#!/usr/bin/env node
/**
 * User: garcia.wul (garcia.wul@alibaba-inc.com)
 * Date: 2014/10/14
 * Time: 17:05
 *
 */

var ArgumentParser = require('argparse').ArgumentParser;
var chalk = require("chalk");
var fs = require("fs");
var path = require("path");
var _ = require("underscore");
var Index = require("../index");

var argumentParser = new ArgumentParser({
    version: require("../package.json").version,
    addHelp: true,
    description: "command line tool for cmd-nice"
});

argumentParser.addArgument(["--configFile"], {
    help: "config file",
    type: "string",
    required: false,
    dest: "configFile"
});

argumentParser.addArgument(["--keywords"], {
    help: "keywords",
    type: "string",
    required: true,
    dest: "keywords",
    nargs: "*"
});

var args = argumentParser.parseArgs();

var alias = {};
var aliasPaths = {};
if (fs.existsSync(args.configFile)) {
    var configContent = fs.readFileSync(args.configFile, "utf-8");
    configContent = eval(configContent);
    alias = configContent.alias;
    aliasPaths = configContent.paths;
}

_.each(args.keywords, function(keywords) {
    var dependencyUtils = new Index.DependencyUtils({
        alias: alias,
        aliasPaths: aliasPaths,
        rootPath: process.cwd()
    });
    var dependencies = dependencyUtils.analyseWhoDepend(keywords);
    console.log(chalk.cyan("\nwho depend " + keywords + ":"));
    _.each(dependencies, function(name) {
        console.log(name);
    });
});