/*! sass.js - v0.0.0 - 2014-06-06 */
(function (root, factory) {
  'use strict';
  if (typeof define === 'function' && define.amd) {
    define([], factory);
  } else if (typeof exports === 'object') {
    module.exports = factory();
  } else {
    root.Sass = factory();
  }
}(this, function () {// Note: Some Emscripten settings will significantly limit the speed of the generated code.
// Note: Some Emscripten settings may limit the speed of the generated code.
// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');
// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}
// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };
  var nodeFS = require('graceful-fs');
  var nodePath = require('path');
  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };
  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };
  Module['load'] = function load(f) {
    globalEval(read(f));
  };
  Module['arguments'] = process['argv'].slice(2);
  
}
else if (ENVIRONMENT_IS_SHELL) {
  Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm
  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }
  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };
  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }
  this['Module'] = Module;
  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };
  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }
  if (typeof console !== 'undefined') {
    Module['print'] = function print(x) {
      console.log(x);
    };
    Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }
  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}
function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***
// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];
// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];
// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}
// === Auto-generated preamble library stuff ===
//========================================
// Runtime code shared with compiler
//========================================
var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?{ ?[^}]* ?}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (vararg) return 8;
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + Pointer_stringify(code) + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;
      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }
      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }
      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}
//========================================
// Runtime essentials
//========================================
var __THREW__ = 0; // Used in checking for thrown exceptions.
var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;
var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;
function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}
var globalScope = this;
// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;
// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}
// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}
// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;
// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;
// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;
var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;
// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }
  var singleType = typeof types === 'string' ? types : null;
  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }
  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }
  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }
  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];
    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }
    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later
    setValue(ret+i, curr, type);
    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }
  return ret;
}
Module['allocate'] = allocate;
function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;
  var ret = '';
  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }
  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;
// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;
  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;
// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;
// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;
  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;
// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;
function demangle(func) {
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    var i = 3;
    // params, etc.
    var basicTypes = {
      'v': 'void',
      'b': 'bool',
      'c': 'char',
      's': 'short',
      'i': 'int',
      'l': 'long',
      'f': 'float',
      'd': 'double',
      'w': 'wchar_t',
      'a': 'signed char',
      'h': 'unsigned char',
      't': 'unsigned short',
      'j': 'unsigned int',
      'm': 'unsigned long',
      'x': 'long long',
      'y': 'unsigned long long',
      'z': '...'
    };
    function dump(x) {
      //return;
      if (x) Module.print(x);
      Module.print(func);
      var pre = '';
      for (var a = 0; a < i; a++) pre += ' ';
      Module.print (pre + '^');
    }
    var subs = [];
    function parseNested() {
      i++;
      if (func[i] === 'K') i++; // ignore const
      var parts = [];
      while (func[i] !== 'E') {
        if (func[i] === 'S') { // substitution
          i++;
          var next = func.indexOf('_', i);
          var num = func.substring(i, next) || 0;
          parts.push(subs[num] || '?');
          i = next+1;
          continue;
        }
        if (func[i] === 'C') { // constructor
          parts.push(parts[parts.length-1]);
          i += 2;
          continue;
        }
        var size = parseInt(func.substr(i));
        var pre = size.toString().length;
        if (!size || !pre) { i--; break; } // counter i++ below us
        var curr = func.substr(i + pre, size);
        parts.push(curr);
        subs.push(curr);
        i += pre + size;
      }
      i++; // skip E
      return parts;
    }
    var first = true;
    function parse(rawList, limit, allowVoid) { // main parser
      limit = limit || Infinity;
      var ret = '', list = [];
      function flushList() {
        return '(' + list.join(', ') + ')';
      }
      var name;
      if (func[i] === 'N') {
        // namespaced N-E
        name = parseNested().join('::');
        limit--;
        if (limit === 0) return rawList ? [name] : name;
      } else {
        // not namespaced
        if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
        var size = parseInt(func.substr(i));
        if (size) {
          var pre = size.toString().length;
          name = func.substr(i + pre, size);
          i += pre + size;
        }
      }
      first = false;
      if (func[i] === 'I') {
        i++;
        var iList = parse(true);
        var iRet = parse(true, 1, true);
        ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
      } else {
        ret = name;
      }
      paramLoop: while (i < func.length && limit-- > 0) {
        //dump('paramLoop');
        var c = func[i++];
        if (c in basicTypes) {
          list.push(basicTypes[c]);
        } else {
          switch (c) {
            case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
            case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
            case 'L': { // literal
              i++; // skip basic type
              var end = func.indexOf('E', i);
              var size = end - i;
              list.push(func.substr(i, size));
              i += size + 2; // size + 'EE'
              break;
            }
            case 'A': { // array
              var size = parseInt(func.substr(i));
              i += size.toString().length;
              if (func[i] !== '_') throw '?';
              i++; // skip _
              list.push(parse(true, 1, true)[0] + ' [' + size + ']');
              break;
            }
            case 'E': break paramLoop;
            default: ret += '?' + c; break paramLoop;
          }
        }
      }
      if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
      return rawList ? list : ret + flushList();
    }
    return parse();
  } catch(e) {
    return func;
  }
}
function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}
function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}
// Memory management
var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}
var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk
function enlargeMemory() {
  abort('Cannot enlarge memory arrays in asm.js. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', or (2) set Module.TOTAL_MEMORY before the program runs.');
}
var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 16777216;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;
var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}
// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'Cannot fallback to non-typed array case: Code is too specialized');
var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);
// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');
Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;
function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}
var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited
var runtimeInitialized = false;
function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}
function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}
function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}
function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}
function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}
function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;
function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;
function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;
function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;
function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;
// Tools
// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;
function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;
// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;
function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;
function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;
function unSign(value, bits, ignore, sig) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore, sig) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}
if (!Math['imul']) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];
var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;
// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled
function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;
Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data
var memoryInitializer = null;
// === Body ===
STATIC_BASE = 8;
STATICTOP = STATIC_BASE + 42440;
var _stdout;
var _stdout=_stdout=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var _stdin;
var _stdin=_stdin=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var _stderr;
var _stderr=_stderr=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
/* global initializers */ __ATINIT__.push({ func: function() { runPostSets() } },{ func: function() { __GLOBAL__I_a() } });
var ___fsmu8;
var ___dso_handle;
var ___dso_handle=___dso_handle=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTVN10__cxxabiv120__si_class_type_infoE;
__ZTVN10__cxxabiv120__si_class_type_infoE=allocate([0,0,0,0,184,126,0,0,40,1,0,0,214,0,0,0,46,0,0,0,126,1,0,0,6,0,0,0,4,0,0,0,22,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTVN10__cxxabiv119__pointer_type_infoE;
__ZTVN10__cxxabiv119__pointer_type_infoE=allocate([0,0,0,0,200,126,0,0,40,1,0,0,178,0,0,0,46,0,0,0,126,1,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTVN10__cxxabiv117__class_type_infoE;
__ZTVN10__cxxabiv117__class_type_infoE=allocate([0,0,0,0,232,126,0,0,40,1,0,0,144,0,0,0,46,0,0,0,126,1,0,0,6,0,0,0,16,0,0,0,6,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTIc;
__ZTIc=allocate([8,90,0,0,96,90,0,0], "i8", ALLOC_STATIC);
var __ZN4Sass7ContextC1ENS0_4DataE;
var __ZN4Sass7ContextD1Ev;
var __ZN4Sass13ContextualizeC1ERNS_7ContextEPNS_4EvalEPNS_11EnvironmentIPNS_8AST_NodeEEEPNS_9BacktraceEPNS_8SelectorESD_;
var __ZN4Sass13ContextualizeD1Ev;
var __ZN4Sass5ErrorC1ENS0_4TypeENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEENS_8PositionES8_;
var __ZN4Sass4EvalC1ERNS_7ContextEPNS_11EnvironmentIPNS_8AST_NodeEEEPNS_9BacktraceE;
var __ZN4Sass4EvalD1Ev;
var __ZN4Sass6ExpandC1ERNS_7ContextEPNS_4EvalEPNS_13ContextualizeEPNS_11EnvironmentIPNS_8AST_NodeEEEPNS_9BacktraceE;
var __ZN4Sass6ExtendC1ERNS_7ContextERNSt3__18multimapINS_17Compound_SelectorEPNS_16Complex_SelectorENS3_4lessIS5_EENS3_9allocatorINS3_4pairIKS5_S7_EEEEEERNS_10Subset_MapINS3_12basic_stringIcNS3_11char_traitsIcEENSA_IcEEEENSB_IS7_PS5_EEEEPNS_9BacktraceE;
var __ZN4Sass7InspectC1EPNS_7ContextE;
var __ZN4Sass7InspectD1Ev;
var __ZN4Sass17Output_CompressedC1EPNS_7ContextE;
var __ZN4Sass17Output_CompressedD1Ev;
var __ZN4Sass13Output_NestedC1EbPNS_7ContextE;
var __ZN4Sass13Output_NestedD1Ev;
var __ZN4Sass9SourceMapC1ERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE;
var __ZN4Sass9To_StringC1EPNS_7ContextE;
var __ZN4Sass9To_StringD1Ev;
var __ZNSt13runtime_errorC1EPKc;
var __ZNSt13runtime_errorD1Ev;
var __ZNSt12length_errorD1Ev;
var __ZNSt12out_of_rangeD1Ev;
var __ZNSt3__16localeC1Ev;
var __ZNSt3__16localeC1ERKS0_;
var __ZNSt3__16localeD1Ev;
var __ZNSt8bad_castC1Ev;
var __ZNSt8bad_castD1Ev;
/* memory initializer */ allocate([0,0,0,0,0,0,36,64,0,0,0,0,0,0,89,64,0,0,0,0,0,136,195,64,0,0,0,0,132,215,151,65,0,128,224,55,121,195,65,67,23,110,5,181,181,184,147,70,245,249,63,233,3,79,56,77,50,29,48,249,72,119,130,90,60,191,115,127,221,79,21,117,61,0,0,0,0,0,0,0,36,108,105,115,116,49,0,0,74,117,108,0,0,0,0,0,109,111,99,99,97,115,105,110,0,0,0,0,0,0,0,0,106,111,105,110,40,36,108,105,115,116,49,44,32,36,108,105,115,116,50,44,32,36,115,101,112,97,114,97,116,111,114,58,32,97,117,116,111,41,0,0,74,117,110,0,0,0,0,0,109,105,115,116,121,114,111,115,101,0,0,0,0,0,0,0,105,110,100,101,120,40,36,108,105,115,116,44,32,36,118,97,108,117,101,41,0,0,0,0,65,112,114,0,0,0,0,0,102,105,108,101,32,116,111,32,105,109,112,111,114,116,32,110,111,116,32,102,111,117,110,100,32,111,114,32,117,110,114,101,97,100,97,98,108,101,58,32,0,0,0,0,0,0,0,0,109,105,110,116,99,114,101,97,109,0,0,0,0,0,0,0,105,110,100,101,120,32,111,117,116,32,111,102,32,98,111,117,110,100,115,32,102,111,114,32,96,0,0,0,0,0,0,0,32,33,100,101,102,97,117,108,116,0,0,0,0,0,0,0,77,97,114,0,0,0,0,0,109,105,100,110,105,103,104,116,98,108,117,101,0,0,0,0,96,32,109,117,115,116,32,110,111,116,32,98,101,32,101,109,112,116,121,0,0,0,0,0,70,101,98,0,0,0,0,0,109,101,100,105,117,109,118,105,111,108,101,116,114,101,100,0,97,114,103,117,109,101,110,116,32,96,36,108,105,115,116,96,32,111,102,32,96,0,0,0,74,97,110,0,0,0,0,0,109,101,100,105,117,109,116,117,114,113,117,111,105,115,101,0,98,108,117,101,0,0,0,0,96,32,109,117,115,116,32,98,101,32,110,111,110,45,122,101,114,111,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,109,101,100,105,117,109,115,112,114,105,110,103,103,114,101,101,110,0,0,0,0,0,0,0,36,98,108,117,101,0,0,0,97,114,103,117,109,101,110,116,32,96,36,110,96,32,111,102,32,96,0,0,0,0,0,0,91,109,93,0,0,0,0,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,98,101,32,117,115,101,100,32,97,115,32,110,97,109,101,100,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,0,0,109,101,100,105,117,109,115,108,97,116,101,98,108,117,101,0,101,114,114,111,114,32,105,110,32,67,32,102,117,110,99,116,105,111,110,32,0,0,0,0,79,99,116,111,98,101,114,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,32,32,34,109,97,112,112,105,110,103,115,34,58,32,34,0,109,101,100,105,117,109,115,101,97,103,114,101,101,110,0,0,110,116,104,40,36,108,105,115,116,44,32,36,110,41,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,109,101,100,105,117,109,112,117,114,112,108,101,0,0,0,0,58,102,105,114,115,116,45,108,101,116,116,101,114,0,0,0,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,32,109,97,121,32,110,111,116,32,104,97,118,101,32,97,32,100,101,102,97,117,108,116,32,118,97,108,117,101,0,0,58,0,0,0,0,0,0,0,36,108,105,115,116,0,0,0,65,117,103,117,115,116,0,0,109,101,100,105,117,109,111,114,99,104,105,100,0,0,0,0,108,101,110,103,116,104,40,36,108,105,115,116,41,0,0,0,74,117,108,121,0,0,0,0,109,101,100,105,117,109,98,108,117,101,0,0,0,0,0,0,109,97,120,40,36,120,49,44,32,36,120,50,46,46,46,41,0,0,0,0,0,0,0,0,74,117,110,101,0,0,0,0,117,114,108,0,0,0,0,0,109,101,100,105,117,109,97,113,117,97,109,97,114,105,110,101,0,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,96,32,111,110,108,121,32,116,97,107,101,115,32,110,117,109,101,114,105,99,32,97,114,103,117,109,101,110,116,115,0,0,32,33,105,109,112,111,114,116,97,110,116,0,0,0,0,0,77,97,121,0,0,0,0,0,109,97,114,111,111,110,0,0,96,0,0,0,0,0,0,0,65,112,114,105,108,0,0,0,109,97,103,101,110,116,97,0,36,120,50,0,0,0,0,0,77,97,114,99,104,0,0,0,108,105,110,101,110,0,0,0,36,120,49,0,0,0,0,0,98,108,97,110,99,104,101,100,97,108,109,111,110,100,0,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,108,105,109,101,103,114,101,101,110,0,0,0,0,0,0,0,36,103,114,101,101,110,0,0,109,105,110,40,36,120,49,44,32,36,120,50,46,46,46,41,0,0,0,0,0,0,0,0,110,101,115,116,101,100,32,115,101,108,101,99,116,111,114,115,32,109,97,121,32,110,111,116,32,98,101,32,101,120,116,101,110,100,101,100,0,0,0,0,74,97,110,117,97,114,121,0,108,105,109,101,0,0,0,0,32,111,102,32,0,0,0,0,111,110,108,121,32,85,84,70,45,56,32,100,111,99,117,109,101,110,116,115,32,97,114,101,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,101,100,59,32,121,111,117,114,32,100,111,99,117,109,101,110,116,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,0,0,0,0,0,0,32,100,105,100,32,110,111,116,32,114,101,116,117,114,110,32,97,32,118,97,108,117,101,0,97,98,115,40,36,118,97,108,117,101,41,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,32,32,34,110,97,109,101,115,34,58,32,91,93,44,10,0,108,105,103,104,116,121,101,108,108,111,119,0,0,0,0,0,71,66,45,49,56,48,51,48,0,0,0,0,0,0,0,0,102,108,111,111,114,40,36,118,97,108,117,101,41,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,108,105,103,104,116,115,116,101,101,108,98,108,117,101,0,0,58,58,102,105,114,115,116,45,108,105,110,101,0,0,0,0,66,79,67,85,45,49,0,0,59,0,0,0,0,0,0,0,99,101,105,108,40,36,118,97,108,117,101,41,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,108,105,103,104,116,115,108,97,116,101,103,114,101,121,0,0,83,67,83,85,0,0,0,0,114,111,117,110,100,40,36,118,97,108,117,101,41,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,108,105,103,104,116,115,108,97,116,101,103,114,97,121,0,0,85,84,70,45,69,66,67,68,73,67,0,0,0,0,0,0,96,32,109,117,115,116,32,98,101,32,117,110,105,116,108,101,115,115,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,108,105,103,104,116,115,107,121,98,108,117,101,0,0,0,0,64,109,101,100,105,97,32,0,85,84,70,45,49,0,0,0,33,105,109,112,111,114,116,97,110,116,0,0,0,0,0,0,97,114,103,117,109,101,110,116,32,36,118,97,108,117,101,32,111,102,32,96,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,108,105,103,104,116,115,101,97,103,114,101,101,110,0,0,0,85,84,70,45,55,0,0,0,36,118,97,108,117,101,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,108,105,103,104,116,115,97,108,109,111,110,0,0,0,0,0,85,84,70,45,51,50,32,40,98,105,103,32,101,110,100,105,97,110,41,0,0,0,0,0,112,101,114,99,101,110,116,97,103,101,40,36,118,97,108,117,101,41,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,108,105,103,104,116,112,105,110,107,0,0,0,0,0,0,0,85,84,70,45,51,50,32,40,108,105,116,116,108,101,32,101,110,100,105,97,110,41,0,0,116,111,45,108,111,119,101,114,45,99,97,115,101,40,36,115,116,114,105,110,103,41,0,0,98,108,97,99,107,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,108,105,103,104,116,103,114,101,101,110,0,0,0,0,0,0,85,84,70,45,49,54,32,40,108,105,116,116,108,101,32,101,110,100,105,97,110,41,0,0,116,111,45,117,112,112,101,114,45,99,97,115,101,40,36,115,116,114,105,110,103,41,0,0,115,101,108,101,99,116,111,114,32,103,114,111,117,112,115,32,109,97,121,32,110,111,116,32,98,101,32,101,120,116,101,110,100,101,100,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,108,105,103,104,116,103,114,101,121,0,0,0,0,0,0,0,97,114,103,117,109,101,110,116,32,0,0,0,0,0,0,0,85,84,70,45,49,54,32,40,98,105,103,32,101,110,100,105,97,110,41,0,0,0,0,0,96,0,0,0,0,0,0,0,36,101,110,100,45,97,116,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,93,44,10,0,0,0,0,0,108,105,103,104,116,103,114,97,121,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,36,115,116,97,114,116,45,97,116,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,121,101,108,108,111,119,0,0,0,0,58,102,105,114,115,116,45,108,105,110,101,0,0,0,0,0,117,110,99,108,111,115,101,100,32,112,97,114,101,110,116,104,101,115,105,115,32,105,110,32,109,101,100,105,97,32,113,117,101,114,121,32,101,120,112,114,101,115,115,105,111,110,0,0,32,42,47,0,0,0,0,0,115,116,114,45,115,108,105,99,101,40,36,115,116,114,105,110,103,44,32,36,115,116,97,114,116,45,97,116,44,32,36,101,110,100,45,97,116,58,45,49,41,0,0,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,64,105,109,112,111,114,116,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,108,105,103,104,116,99,121,97,110,0,0,0,0,0,0,0,109,101,100,105,97,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,100,32,105,110,32,109,101,100,105,97,32,113,117,101,114,121,32,101,120,112,114,101,115,115,105,111,110,0,0,0,0,0,0,0,0,36,115,117,98,115,116,114,105,110,103,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,108,105,103,104,116,99,111,114,97,108,0,0,0,0,0,0,109,101,100,105,97,32,113,117,101,114,121,32,101,120,112,114,101,115,115,105,111,110,32,109,117,115,116,32,98,101,103,105,110,32,119,105,116,104,32,39,40,39,0,0,0,0,0,0,115,116,114,45,105,110,100,101,120,40,36,115,116,114,105,110,103,44,32,36,115,117,98,115,116,114,105,110,103,41,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,108,105,103,104,116,98,108,117,101,0,0,0,0,0,0,0,46,99,115,115,0,0,0,0,32,125,10,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,105,110,32,109,101,100,105,97,32,113,117,101,114,121,0,0,0,0,0,36,105,110,100,101,120,0,0,32,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,108,101,109,111,110,99,104,105,102,102,111,110,0,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,117,112,112,101,114,32,98,111,117,110,100,32,105,110,32,64,101,97,99,104,32,100,105,114,101,99,116,105,118,101,0,0,0,36,105,110,115,101,114,116,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,108,97,119,110,103,114,101,101,110,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,105,110,39,32,107,101,121,119,111,114,100,32,105,110,32,64,101,97,99,104,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,0,0,0,115,116,114,45,105,110,115,101,114,116,40,36,115,116,114,105,110,103,44,32,36,105,110,115,101,114,116,44,32,36,105,110,100,101,120,41,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,108,97,118,101,110,100,101,114,98,108,117,115,104,0,0,0,64,101,97,99,104,32,100,105,114,101,99,116,105,118,101,32,114,101,113,117,105,114,101,115,32,97,110,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,0,0,115,116,114,45,108,101,110,103,116,104,40,36,115,116,114,105,110,103,41,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,98,105,115,113,117,101,0,0,108,97,118,101,110,100,101,114,0,0,0,0,0,0,0,0,114,103,98,40,36,114,101,100,44,32,36,103,114,101,101,110,44,32,36,98,108,117,101,41,0,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,117,112,112,101,114,32,98,111,117,110,100,32,105,110,32,64,102,111,114,32,100,105,114,101,99,116,105,118,101,0,0,0,0,113,117,111,116,101,40,36,115,116,114,105,110,103,41,0,0,64,114,101,116,117,114,110,32,109,97,121,32,111,110,108,121,32,98,101,32,117,115,101,100,32,119,105,116,104,105,110,32,97,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,107,104,97,107,105,0,0,0,101,120,112,101,99,116,101,100,32,39,116,104,114,111,117,103,104,39,32,111,114,32,39,116,111,39,32,107,101,121,119,111,100,32,105,110,32,64,102,111,114,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,44,32,105,110,32,102,117,110,99,116,105,111,110,32,96,0,32,104,97,115,32,110,111,32,112,97,114,97,109,101,116,101,114,32,110,97,109,101,100,32,0,0,0,0,0,0,0,0,36,115,116,114,105,110,103,0,34,44,0,0,0,0,0,0,105,118,111,114,121,0,0,0,101,120,112,101,99,116,101,100,32,39,102,114,111,109,39,32,107,101,121,119,111,114,100,32,105,110,32,64,102,111,114,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,0,0,117,110,113,117,111,116,101,40,36,115,116,114,105,110,103,41,0,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,105,110,100,105,103,111,0,0,58,58,97,102,116,101,114,0,64,102,111,114,32,100,105,114,101,99,116,105,118,101,32,114,101,113,117,105,114,101,115,32,97,110,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,0,0,0,47,47,0,0,0,0,0,0,105,101,45,104,101,120,45,115,116,114,40,36,99,111,108,111,114,41,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,105,110,100,105,97,110,114,101,100,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,64,101,108,115,101,0,0,0,0,0,0,0,0,110,111,116,32,101,110,111,117,103,104,32,97,114,103,117,109,101,110,116,115,32,102,111,114,32,96,99,104,97,110,103,101,45,99,111,108,111,114,96,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,104,111,116,112,105,110,107,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,112,114,101,100,105,99,97,116,101,32,102,111,114,32,64,105,102,0,0,0,0,0,0,0,0,58,110,111,116,40,0,0,0,99,97,110,110,111,116,32,115,112,101,99,105,102,121,32,98,111,116,104,32,82,71,66,32,97,110,100,32,72,83,76,32,118,97,108,117,101,115,32,102,111,114,32,96,99,104,97,110,103,101,45,99,111,108,111,114,96,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,104,111,110,101,121,100,101,119,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,116,111,112,45,108,101,118,101,108,32,101,120,112,114,101,115,115,105,111,110,0,0,0,0,32,123,10,0,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,105,110,116,101,114,112,111,108,97,110,116,32,105,110,115,105,100,101,32,105,110,116,101,114,112,111,108,97,116,101,100,32,105,100,101,110,116,105,102,105,101,114,32,0,0,0,0,0,0,0,0,99,104,97,110,103,101,45,99,111,108,111,114,40,36,99,111,108,111,114,44,32,36,114,101,100,58,32,102,97,108,115,101,44,32,36,103,114,101,101,110,58,32,102,97,108,115,101,44,32,36,98,108,117,101,58,32,102,97,108,115,101,44,32,36,104,117,101,58,32,102,97,108,115,101,44,32,36,115,97,116,117,114,97,116,105,111,110,58,32,102,97,108,115,101,44,32,36,108,105,103,104,116,110,101,115,115,58,32,102,97,108,115,101,44,32,36,97,108,112,104,97,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,64,109,101,100,105,97,32,0,103,114,101,101,110,121,101,108,108,111,119,0,0,0,0,0,110,111,116,32,101,110,111,117,103,104,32,97,114,103,117,109,101,110,116,115,32,102,111,114,32,96,115,99,97,108,101,45,99,111,108,111,114,96,0,0,80,77,0,0,0,0,0,0,103,114,101,101,110,0,0,0,101,114,114,111,114,32,112,97,114,115,105,110,103,32,105,110,116,101,114,112,111,108,97,116,101,100,32,118,97,108,117,101,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,112,101,99,105,102,121,32,98,111,116,104,32,82,71,66,32,97,110,100,32,72,83,76,32,118,97,108,117,101,115,32,102,111,114,32,96,115,99,97,108,101,45,99,111,108,111,114,96,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,103,114,101,121,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,105,110,116,101,114,112,111,108,97,110,116,32,105,110,115,105,100,101,32,73,69,32,102,117,110,99,116,105,111,110,32,0,0,0,0,46,46,46,0,0,0,0,0,115,99,97,108,101,45,99,111,108,111,114,40,36,99,111,108,111,114,44,32,36,114,101,100,58,32,102,97,108,115,101,44,32,36,103,114,101,101,110,58,32,102,97,108,115,101,44,32,36,98,108,117,101,58,32,102,97,108,115,101,44,32,36,104,117,101,58,32,102,97,108,115,101,44,32,36,115,97,116,117,114,97,116,105,111,110,58,32,102,97,108,115,101,44,32,36,108,105,103,104,116,110,101,115,115,58,32,102,97,108,115,101,44,32,36,97,108,112,104,97,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,0,98,101,105,103,101,0,0,0,103,114,97,121,0,0,0,0,32,97,110,100,32,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,105,110,116,101,114,112,111,108,97,110,116,32,105,110,115,105,100,101,32,115,116,114,105,110,103,32,99,111,110,115,116,97,110,116,32,0,0,0,0,0,0,0,0,46,115,97,115,115,0,0,0,110,111,116,32,101,110,111,117,103,104,32,97,114,103,117,109,101,110,116,115,32,102,111,114,32,96,97,100,106,117,115,116,45,99,111,108,111,114,96,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,103,111,108,100,101,110,114,111,100,0,0,0,0,0,0,0,101,114,114,111,114,32,114,101,97,100,105,110,103,32,118,97,108,117,101,115,32,97,102,116,101,114,32,0,0,0,0,0,102,117,110,99,116,105,111,110,32,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,32,112,114,111,118,105,100,101,100,32,109,111,114,101,32,116,104,97,110,32,111,110,99,101,32,105,110,32,99,97,108,108,32,116,111,32,0,0,0,0,99,97,110,110,111,116,32,115,112,101,99,105,102,121,32,98,111,116,104,32,82,71,66,32,97,110,100,32,72,83,76,32,118,97,108,117,101,115,32,102,111,114,32,96,97,100,106,117,115,116,45,99,111,108,111,114,96,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,112,120,0,0,0,0,0,0,34,0,0,0,0,0,0,0,103,111,108,100,0,0,0,0,33,105,109,112,111,114,116,97,110,116,0,0,0,0,0,0,97,100,106,117,115,116,45,99,111,108,111,114,40,36,99,111,108,111,114,44,32,36,114,101,100,58,32,102,97,108,115,101,44,32,36,103,114,101,101,110,58,32,102,97,108,115,101,44,32,36,98,108,117,101,58,32,102,97,108,115,101,44,32,36,104,117,101,58,32,102,97,108,115,101,44,32,36,115,97,116,117,114,97,116,105,111,110,58,32,102,97,108,115,101,44,32,36,108,105,103,104,116,110,101,115,115,58,32,102,97,108,115,101,44,32,36,97,108,112,104,97,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,103,104,111,115,116,119,104,105,116,101,0,0,0,0,0,0,58,97,102,116,101,114,0,0,32,32,34,115,111,117,114,99,101,115,34,58,32,91,0,0,85,82,73,32,105,115,32,109,105,115,115,105,110,103,32,39,41,39,0,0,0,0,0,0,111,110,108,121,32,0,0,0,47,42,0,0,0,0,0,0,102,97,100,101,45,111,117,116,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,103,97,105,110,115,98,111,114,111,0,0,0,0,0,0,0,109,97,108,102,111,114,109,101,100,32,85,82,76,0,0,0,116,114,97,110,115,112,97,114,101,110,116,105,122,101,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,102,117,99,104,115,105,97,0,100,97,110,103,108,105,110,103,32,101,120,112,114,101,115,115,105,111,110,32,105,110,32,85,82,76,0,0,0,0,0,0,102,97,100,101,45,105,110,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,0,102,111,114,101,115,116,103,114,101,101,110,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,32,42,47,0,0,0,0,0,99,111,109,109,101,110,116,32,105,110,32,85,82,76,0,0,32,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,111,112,97,99,105,102,121,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,0,102,108,111,114,97,108,119,104,105,116,101,0,0,0,0,0,117,110,99,108,111,115,101,100,32,112,97,114,101,110,116,104,101,115,105,115,0,0,0,0,116,114,117,101,0,0,0,0,41,0,0,0,0,0,0,0,102,105,114,101,98,114,105,99,107,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,114,103,98,97,40,0,0,0,97,108,112,104,97,40,0,0,100,111,100,103,101,114,98,108,117,101,0,0,0,0,0,0,42,0,0,0,0,0,0,0,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,67,83,83,32,118,97,108,117,101,0,0,0,0,0,0,0,111,112,97,99,105,116,121,40,36,99,111,108,111,114,41,0,97,122,117,114,101,0,0,0,100,105,109,103,114,101,121,0,96,32,109,117,115,116,32,98,101,32,98,101,116,119,101,101,110,32,0,0,0,0,0,0,43,0,0,0,0,0,0,0,46,115,99,115,115,0,0,0,97,108,112,104,97,40,36,99,111,108,111,114,41,0,0,0,117,112,112,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,100,105,109,103,114,97,121,0,115,116,121,108,101,32,100,101,99,108,97,114,97,116,105,111,110,32,109,117,115,116,32,99,111,110,116,97,105,110,32,97,32,118,97,108,117,101,0,0,91,102,93,0,0,0,0,0,32,0,0,0,0,0,0,0,112,97,114,97,109,101,116,101,114,32,0,0,0,0,0,0,105,110,118,101,114,116,40,36,99,111,108,111,114,41,0,0,112,116,0,0,0,0,0,0,100,101,101,112,115,107,121,98,108,117,101,0,0,0,0,0,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,97,32,39,58,39,0,0,0,0,0,32,37,32,0,0,0,0,0,99,111,109,112,108,101,109,101,110,116,40,36,99,111,108,111,114,41,0,0,0,0,0,0,100,101,101,112,112,105,110,107,0,0,0,0,0,0,0,0,58,58,98,101,102,111,114,101,0,0,0,0,0,0,0,0,34,44,10,0,0,0,0,0,58,32,101,114,114,111,114,58,32,0,0,0,0,0,0,0,112,114,111,112,101,114,116,121,32,34,0,0,0,0,0,0,32,9,10,11,12,13,0,0,103,114,97,121,115,99,97,108,101,40,36,99,111,108,111,114,41,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,100,97,114,107,118,105,111,108,101,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,112,114,111,112,101,114,116,121,32,110,97,109,101,0,0,0,32,42,32,0,0,0,0,0,100,101,115,97,116,117,114,97,116,101,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,115,116,114,105,110,103,0,0,100,97,114,107,116,117,114,113,117,111,105,115,101,0,0,0,105,110,118,97,108,105,100,32,115,101,108,101,99,116,111,114,32,102,111,114,32,64,101,120,116,101,110,100,0,0,0,0,32,45,32,0,0,0,0,0,115,97,116,117,114,97,116,101,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,100,97,114,107,115,108,97,116,101,103,114,101,121,0,0,0,116,111,112,45,108,101,118,101,108,32,64,119,97,114,110,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,0,0,44,32,0,0,0,0,0,0,64,99,111,110,116,101,110,116,32,109,97,121,32,111,110,108,121,32,98,101,32,117,115,101,100,32,119,105,116,104,105,110,32,97,32,109,105,120,105,110,0,0,0,0,0,0,0,0,64,109,101,100,105,97,32,0,32,43,32,0,0,0,0,0,100,97,114,107,101,110,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,100,97,114,107,115,108,97,116,101,103,114,97,121,0,0,0,111,110,108,121,32,118,97,114,105,97,98,108,101,32,100,101,99,108,97,114,97,116,105,111,110,115,32,97,110,100,32,99,111,110,116,114,111,108,32,100,105,114,101,99,116,105,118,101,115,32,97,114,101,32,97,108,108,111,119,101,100,32,105,110,115,105,100,101,32,102,117,110,99,116,105,111,110,115,0,0,36,97,109,111,117,110,116,0,111,114,100,105,110,97,108,32,97,114,103,117,109,101,110,116,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,110,97,109,101,100,32,97,114,103,117,109,101,110,116,115,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,100,97,114,107,115,108,97,116,101,98,108,117,101,0,0,0,64,105,109,112,111,114,116,32,100,105,114,101,99,116,105,118,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,115,105,100,101,32,109,105,120,105,110,115,32,97,110,100,32,102,117,110,99,116,105,111,110,115,0,0,32,60,32,0,0,0,0,0,108,105,103,104,116,101,110,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,0,111,114,100,105,110,97,108,32,97,114,103,117,109,101,110,116,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,115,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,100,97,114,107,115,101,97,103,114,101,101,110,0,0,0,0,110,111,110,45,116,101,114,109,105,110,97,108,32,115,116,97,116,101,109,101,110,116,32,111,114,32,100,101,99,108,97,114,97,116,105,111,110,32,109,117,115,116,32,101,110,100,32,119,105,116,104,32,39,59,39,0,102,117,110,99,116,105,111,110,115,32,97,110,100,32,109,105,120,105,110,115,32,109,97,121,32,110,111,116,32,98,101,32,99,97,108,108,101,100,32,119,105,116,104,32,98,111,116,104,32,110,97,109,101,100,32,97,114,103,117,109,101,110,116,115,32,97,110,100,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,115,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,100,97,114,107,115,97,108,109,111,110,0,0,0,0,0,0,97,113,117,97,109,97,114,105,110,101,0,0,0,0,0,0,96,32,111,102,32,96,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,32,102,111,114,32,0,0,0,0,32,62,32,0,0,0,0,0,97,100,106,117,115,116,45,104,117,101,40,36,99,111,108,111,114,44,32,36,100,101,103,114,101,101,115,41,0,0,0,0,108,111,119,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,102,117,110,99,116,105,111,110,115,32,97,110,100,32,109,105,120,105,110,115,32,109,97,121,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,119,105,116,104,32,111,110,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,100,97,114,107,114,101,100,0,101,120,112,101,99,116,101,100,32,97,32,115,116,114,105,110,103,32,99,111,110,115,116,97,110,116,32,111,114,32,105,100,101,110,116,105,102,105,101,114,32,105,110,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,32,102,111,114,32,0,0,0,0,0,87,65,82,78,73,78,71,58,32,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,108,105,103,104,116,110,101,115,115,40,36,99,111,108,111,114,41,0,0,0,0,0,0,0,114,101,113,117,105,114,101,100,32,112,97,114,97,109,101,116,101,114,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,111,112,116,105,111,110,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,110,97,109,101,100,32,97,114,103,117,109,101,110,116,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,109,109,0,0,0,0,0,0,100,97,114,107,111,114,99,104,105,100,0,0,0,0,0,0,105,110,118,97,108,105,100,32,111,112,101,114,97,116,111,114,32,105,110,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,32,102,111,114,32,0,0,0,0,0,114,101,113,117,105,114,101,100,32,112,97,114,97,109,101,116,101,114,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,110,117,109,98,101,114,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,100,97,114,107,111,114,97,110,103,101,0,0,0,0,0,0,58,98,101,102,111,114,101,0,32,32,34,102,105,108,101,34,58,32,34,0,0,0,0,0,58,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,32,105,110,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,0,0,0,0,10,0,0,0,0,0,0,0,115,97,116,117,114,97,116,105,111,110,40,36,99,111,108,111,114,41,0,0,0,0,0,0,102,117,110,99,116,105,111,110,115,32,97,110,100,32,109,105,120,105,110,115,32,99,97,110,110,111,116,32,104,97,118,101,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,0,0,0,0,0,0,0,0,100,97,114,107,111,108,105,118,101,103,114,101,101,110,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,112,115,101,117,100,111,45,99,108,97,115,115,32,111,114,32,112,115,101,117,100,111,45,101,108,101,109,101,110,116,0,0,0,0,0,32,97,110,100,32,0,0,0,100,101,103,0,0,0,0,0,111,112,116,105,111,110,97,108,32,112,97,114,97,109,101,116,101,114,115,32,109,97,121,32,110,111,116,32,98,101,32,99,111,109,98,105,110,101,100,32,119,105,116,104,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,115,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,100,97,114,107,109,97,103,101,110,116,97,0,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,97,114,103,117,109,101,110,116,32,116,111,32,0,0,0,0,0,0,0,44,32,0,0,0,0,0,0,37,112,0,0,0,0,0,0,104,117,101,40,36,99,111,108,111,114,41,0,0,0,0,0,102,97,108,115,101,0,0,0,91,98,117,105,108,116,45,105,110,32,102,117,110,99,116,105,111,110,93,0,0,0,0,0,100,97,114,107,107,104,97,107,105,0,0,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,64,105,110,99,108,117,100,101,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,47,42,32,108,105,110,101,32,0,0,0,0,0,0,0,0,46,46,46,41,0,0,0,0,64,99,111,110,116,101,110,116,59,0,0,0,0,0,0,0,100,97,114,107,103,114,101,101,110,0,0,0,0,0,0,0,104,115,108,97,40,36,104,117,101,44,32,36,115,97,116,117,114,97,116,105,111,110,44,32,36,108,105,103,104,116,110,101,115,115,44,32,36,97,108,112,104,97,41,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,67,32,102,117,110,99,116,105,111,110,58,32,0,0,0,97,108,105,99,101,98,108,117,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,32,116,111,32,0,0,0,0,64,105,110,99,108,117,100,101,32,0,0,0,0,0,0,0,36,108,105,103,104,116,110,101,115,115,0,0,0,0,0,0,116,114,117,101,0,0,0,0,59,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,111,112,101,114,97,110,100,115,32,102,111,114,32,109,111,100,117,108,111,0,0,0,0,0,100,97,114,107,103,114,101,121,0,0,0,0,0,0,0,0,110,101,103,97,116,101,100,32,115,101,108,101,99,116,111,114,32,105,115,32,109,105,115,115,105,110,103,32,39,41,39,0,64,102,117,110,99,116,105,111,110,32,0,0,0,0,0,0,36,115,97,116,117,114,97,116,105,111,110,0,0,0,0,0,105,110,118,97,108,105,100,32,111,112,101,114,97,110,100,115,32,102,111,114,32,109,117,108,116,105,112,108,105,99,97,116,105,111,110,0,0,0,0,0,58,32,0,0,0,0,0,0,100,97,114,107,103,114,97,121,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,115,101,108,101,99,116,111,114,32,97,102,116,101,114,32,0,64,109,105,120,105,110,32,0,97,108,112,104,97,32,99,104,97,110,110,101,108,115,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,119,104,101,110,32,99,111,109,98,105,110,105,110,103,32,99,111,108,111,114,115,0,0,0,0,0,0,100,97,114,107,103,111,108,100,101,110,114,111,100,0,0,0,125,0,0,0,0,0,0,0,97,113,117,97,0,0,0,0,97,114,103,117,109,101,110,116,32,96,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,97,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,115,101,108,101,99,116,111,114,0,0,0,0,0,0,0,46,46,92,0,0,0,0,0,100,97,114,107,99,121,97,110,0,0,0,0,0,0,0,0,104,115,108,40,36,104,117,101,44,32,36,115,97,116,117,114,97,116,105,111,110,44,32,36,108,105,103,104,116,110,101,115,115,41,0,0,0,0,0,0,99,111,110,116,101,110,116,115,32,111,102,32,110,97,109,101,115,112,97,99,101,100,32,112,114,111,112,101,114,116,105,101,115,32,109,117,115,116,32,114,101,115,117,108,116,32,105,110,32,115,116,121,108,101,32,100,101,99,108,97,114,97,116,105,111,110,115,32,111,110,108,121,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,100,105,118,105,100,101,32,97,32,110,117,109,98,101,114,32,98,121,32,97,32,99,111,108,111,114,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,97,32,39,123,39,32,97,102,116,101,114,32,110,97,109,101,115,112,97,99,101,100,32,112,114,111,112,101,114,116,121,0,0,0,0,0,0,0,0,66,97,99,107,116,114,97,99,101,58,0,0,0,0,0,0,103,105,118,101,110,32,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,36,119,101,105,103,104,116,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,115,117,98,115,101,116,32,109,97,112,32,107,101,121,115,32,109,97,121,32,110,111,116,32,98,101,32,101,109,112,116,121,0,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,112,99,0,0,0,0,0,0,100,97,114,107,98,108,117,101,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,32,105,110,32,97,115,115,105,103,110,109,101,110,116,32,115,116,97,116,101,109,101,110,116,0,0,0,0,0,0,0,0,64,119,104,105,108,101,32,0,45,0,0,0,0,0,0,0,99,121,97,110,0,0,0,0,32,32,34,118,101,114,115,105,111,110,34,58,32,51,44,10,0,0,0,0,0,0,0,0,85,110,97,98,108,101,32,116,111,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,58,32,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,58,39,32,97,102,116,101,114,32,0,0,0,0,0,10,13,0,0,0,0,0,0,99,97,110,110,111,116,32,97,100,100,32,111,114,32,115,117,98,116,114,97,99,116,32,110,117,109,98,101,114,115,32,119,105,116,104,32,105,110,99,111,109,112,97,116,105,98,108,101,32,117,110,105,116,115,0,0,99,114,105,109,115,111,110,0,32,123,32,0,0,0,0,0,105,110,118,97,108,105,100,32,110,97,109,101,32,105,110,32,64,105,110,99,108,117,100,101,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,0,64,101,97,99,104,32,0,0,109,105,120,40,36,99,111,108,111,114,45,49,44,32,36,99,111,108,111,114,45,50,44,32,36,119,101,105,103,104,116,58,32,53,48,37,41,0,0,0,96,69,120,112,97,110,100,96,32,100,111,101,115,110,39,116,32,104,97,110,100,108,101,32,0,0,0,0,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,0,0,0,0,0,0,0,0,99,111,114,110,115,105,108,107,0,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,97,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,40,101,46,103,46,32,36,120,41,32,111,114,32,39,41,39,32,102,111,114,32,116,104,101,32,112,97,114,97,109,101,116,101,114,32,108,105,115,116,32,102,111,114,32,0,0,0,32,116,111,32,0,0,0,0,99,111,114,110,102,108,111,119,101,114,98,108,117,101,0,0,98,108,117,101,40,36,99,111,108,111,114,41,0,0,0,0,67,0,0,0,0,0,0,0,117,110,107,110,111,119,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,59,32,112,108,101,97,115,101,32,99,111,110,116,97,99,116,32,116,104,101,32,76,105,98,83,97,115,115,32,109,97,105,110,116,97,105,110,101,114,115,0,0,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,108,105,115,116,0,0,0,0,42,47,0,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,118,97,114,105,97,98,108,101,32,98,105,110,100,105,110,103,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,0,10,0,0,0,0,0,0,0,32,109,117,115,116,32,98,101,103,105,110,32,119,105,116,104,32,97,32,39,123,39,0,0,108,111,119,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105].concat([114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,32,116,104,114,111,117,103,104,32,0,0,0,0,0,0,0,99,111,114,97,108,0,0,0,32,123,10,0,0,0,0,0,103,114,101,101,110,40,36,99,111,108,111,114,41,0,0,0,118,101,99,116,111,114,0,0,109,105,120,105,110,32,0,0,99,97,110,110,111,116,32,99,111,109,112,97,114,101,32,110,117,109,98,101,114,115,32,119,105,116,104,32,105,110,99,111,109,112,97,116,105,98,108,101,32,117,110,105,116,115,0,0,97,114,103,108,105,115,116,0,44,0,0,0,0,0,0,0,99,111,108,111,114,0,0,0,32,0,0,0,0,0,0,0,32,102,114,111,109,32,0,0,99,104,111,99,111,108,97,116,101,0,0,0,0,0,0,0,91,98,117,105,108,116,45,105,110,32,102,117,110,99,116,105,111,110,93,0,0,0,0,0,91,102,93,0,0,0,0,0,114,101,100,40,36,99,111,108,111,114,41,0,0,0,0,0,37,46,48,76,102,0,0,0,64,99,111,110,116,101,110,116,91,109,93,0,0,0,0,0,115,111,117,114,99,101,32,115,116,114,105,110,103,0,0,0,109,97,121,32,111,110,108,121,32,99,111,109,112,97,114,101,32,110,117,109,98,101,114,115,0,0,0,0,0,0,0,0,32,42,47,0,0,0,0,0,47,42,35,32,115,111,117,114,99,101,77,97,112,112,105,110,103,85,82,76,61,0,0,0,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,32,109,97,121,32,110,111,116,32,98,101,32,112,97,115,115,101,100,32,98,121,32,110,97,109,101,0,0,0,0,0,0,34,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,98,111,100,121,32,102,111,114,32,0,0,0,0,0,0,0,91,67,79,76,79,82,32,84,65,66,76,69,93,0,0,0,64,102,111,114,32,0,0,0,121,101,108,108,111,119,103,114,101,101,110,0,0,0,0,0,121,101,108,108,111,119,0,0,99,104,97,114,116,114,101,117,115,101,0,0,0,0,0,0,119,104,105,116,101,115,109,111,107,101,0,0,0,0,0,0,119,104,105,116,101,0,0,0,36,99,111,108,111,114,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,114,98,0,0,0,0,0,0,119,104,101,97,116,0,0,0,44,0,0,0,0,0,0,0,118,105,111,108,101,116,0,0,116,117,114,113,117,111,105,115,101,0,0,0,0,0,0,0,64,105,109,112,111,114,116,0,116,111,109,97,116,111,0,0,116,104,105,115,116,108,101,0,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,116,101,97,108,0,0,0,0,110,117,109,98,101,114,0,0,116,97,110,0,0,0,0,0,115,116,114,105,110,103,0,0,115,116,101,101,108,98,108,117,101,0,0,0,0,0,0,0,83,97,116,0,0,0,0,0,115,112,114,105,110,103,103,114,101,101,110,0,0,0,0,0,99,97,100,101,116,98,108,117,101,0,0,0,0,0,0,0,70,114,105,0,0,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,115,110,111,119,0,0,0,0,114,103,98,97,40,36,99,111,108,111,114,44,32,36,97,108,112,104,97,41,0,0,0,0,37,76,102,0,0,0,0,0,96,32,109,117,115,116,32,98,101,32,97,32,0,0,0,0,96,0,0,0,0,0,0,0,84,104,117,0,0,0,0,0,115,108,97,116,101,103,114,101,121,0,0,0,0,0,0,0,117,110,98,111,117,110,100,32,118,97,114,105,97,98,108,101,32,0,0,0,0,0,0,0,87,101,100,0,0,0,0,0,59,0,0,0,0,0,0,0,115,108,97,116,101,103,114,97,121,0,0,0,0,0,0,0,84,117,101,0,0,0,0,0,115,108,97,116,101,98,108,117,101,0,0,0,0,0,0,0,64,105,110,99,108,117,100,101,32,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,77,111,110,0,0,0,0,0,115,107,121,98,108,117,101,0,36,111,110,108,121,45,112,97,116,104,0,0,0,0,0,0,83,117,110,0,0,0,0,0,115,105,108,118,101,114,0,0,36,112,97,116,104,0,0,0,115,105,101,110,110,97,0,0,91,99,32,102,117,110,99,116,105,111,110,93,0,0,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,110,97,109,101,32,105,110,32,0,0,0,0,0,0,0,0,97,110,116,105,113,117,101,119,104,105,116,101,0,0,0,0,105,109,97,103,101,45,117,114,108,40,36,112,97,116,104,44,32,36,111,110,108,121,45,112,97,116,104,58,32,102,97,108,115,101,44,32,36,99,97,99,104,101,45,98,117,115,116,101,114,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,115,101,97,115,104,101,108,108,0,0,0,0,0,0,0,0,46,46,47,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,115,101,97,103,114,101,101,110,0,0,0,0,0,0,0,0,36,105,102,45,102,97,108,115,101,0,0,0,0,0,0,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,115,97,110,100,121,98,114,111,119,110,0,0,0,0,0,0,98,117,114,108,121,119,111,111,100,0,0,0,0,0,0,0,36,99,111,110,100,105,116,105,111,110,0,0,0,0,0,0,84,117,101,115,100,97,121,0,115,97,108,109,111,110,0,0,36,97,108,112,104,97,0,0,105,102,40,36,99,111,110,100,105,116,105,111,110,44,32,36,105,102,45,116,114,117,101,44,32,36,105,102,45,102,97,108,115,101,41,0,0,0,0,0,32,105,115,32,109,105,115,115,105,110,103,32,105,110,32,99,97,108,108,32,116,111,32,0,44,32,105,110,32,109,105,120,105,110,32,96,0,0,0,0,77,111,110,100,97,121,0,0,115,97,100,100,108,101,98,114,111,119,110,0,0,0,0,0,45,0,0,0,0,0,0,0,96,32,103,105,118,101,110,32,119,114,111,110,103,32,110,117,109,98,101,114,32,111,102,32,97,114,103,117,109,101,110,116,115,0,0,0,0,0,0,0,110,111,116,40,36,118,97,108,117,101,41,0,0,0,0,0,83,117,110,100,97,121,0,0,114,111,121,97,108,98,108,117,101,0,0,0,0,0,0,0,36,110,117,109,98,101,114,45,50,0,0,0,0,0,0,0,114,111,115,121,98,114,111,119,110,0,0,0,0,0,0,0,32,111,110,108,121,32,116,97,107,101,115,32,0,0,0,0,43,0,0,0,0,0,0,0,36,110,117,109,98,101,114,45,49,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,114,101,100,0,0,0,0,0,99,111,109,112,97,114,97,98,108,101,40,36,110,117,109,98,101,114,45,49,44,32,36,110,117,109,98,101,114,45,50,41,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,112,117,114,112,108,101,0,0,117,110,105,116,108,101,115,115,40,36,110,117,109,98,101,114,41,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,101,120,112,101,99,116,105,110,103,32,97,110,111,116,104,101,114,32,117,114,108,32,111,114,32,113,117,111,116,101,100,32,112,97,116,104,32,105,110,32,64,105,109,112,111,114,116,32,108,105,115,116,0,0,0,0,112,111,119,100,101,114,98,108,117,101,0,0,0,0,0,0,117,112,112,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,46,46,46,0,0,0,0,0,36,110,117,109,98,101,114,0,64,119,97,114,110,32,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,112,108,117,109,0,0,0,0,117,110,105,116,40,36,110,117,109,98,101,114,41,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,112,105,110,107,0,0,0,0,99,111,108,111,114,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,112,101,114,117,0,0,0,0,98,114,111,119,110,0,0,0,116,121,112,101,45,111,102,40,36,118,97,108,117,101,41,0,112,101,97,99,104,112,117,102,102,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,32,97,114,103,117,109,101,110,116,115,59,32,0,0,0,0,114,103,98,97,40,36,114,101,100,44,32,36,103,114,101,101,110,44,32,36,98,108,117,101,44,32,36,97,108,112,104,97,41,0,0,0,0,0,0,0,36,118,97,108,117,101,115,0,110,111,32,109,105,120,105,110,32,110,97,109,101,100,32,0,114,101,113,117,105,114,101,100,32,112,97,114,97,109,101,116,101,114,32,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,112,97,112,97,121,97,119,104,105,112,0,0,0,0,0,0,111,118,101,114,108,111,97,100,101,100,32,102,117,110,99,116,105,111,110,32,96,0,0,0,99,111,109,112,97,99,116,40,36,118,97,108,117,101,115,46,46,46,41,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,112,97,108,101,118,105,111,108,101,116,114,101,100,0,0,0,36,108,105,115,116,115,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,99,109,0,0,0,0,0,0,112,97,108,101,116,117,114,113,117,111,105,115,101,0,0,0,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,48,49,50,51,52,53,54,55,56,57,43,47,0,0,0,0,0,0,0,0,64,109,105,120,105,110,32,0,122,105,112,40,36,108,105,115,116,115,46,46,46,41,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,112,97,108,101,103,114,101,101,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,112,97,108,101,103,111,108,100,101,110,114,111,100,0,0,0,97,112,112,101,110,100,40,36,108,105,115,116,44,32,36,118,97,108,44,32,36,115,101,112,97,114,97,116,111,114,58,32,97,117,116,111,41,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,64,105,109,112,111,114,116,32,100,105,114,101,99,116,105,118,101,32,114,101,113,117,105,114,101,115,32,97,32,117,114,108,32,111,114,32,113,117,111,116,101,100,32,112,97,116,104,0,111,114,99,104,105,100,0,0,96,32,109,117,115,116,32,98,101,32,96,115,112,97,99,101,96,44,32,96,99,111,109,109,97,96,44,32,111,114,32,96,97,117,116,111,96,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,111,114,97,110,103,101,114,101,100,0,0,0,0,0,0,0,97,114,103,117,109,101,110,116,32,96,36,115,101,112,97,114,97,116,111,114,96,32,111,102,32,96,0,0,0,0,0,0,111,114,97,110,103,101,0,0,97,117,116,111,0,0,0,0,68,101,99,0,0,0,0,0,111,108,105,118,101,100,114,97,98,0,0,0,0,0,0,0,98,108,117,101,118,105,111,108,101,116,0,0,0,0,0,0,99,111,109,109,97,0,0,0,78,111,118,0,0,0,0,0,111,108,105,118,101,0,0,0,105,110,0,0,0,0,0,0,115,112,97,99,101,0,0,0,91,102,93,0,0,0,0,0,79,99,116,0,0,0,0,0,112,114,111,118,105,100,101,100,32,109,111,114,101,32,116,104,97,110,32,111,110,99,101,32,105,110,32,99,97,108,108,32,116,111,32,0,0,0,0,0,111,108,100,108,97,99,101,0,58,32,0,0,0,0,0,0,36,115,101,112,97,114,97,116,111,114,0,0,0,0,0,0,83,101,112,0,0,0,0,0,34,10,0,0,0,0,0,0,110,97,118,121,0,0,0,0,36,108,105,115,116,50,0,0,65,117,103,0,0,0,0,0,110,97,118,97,106,111,119,104,105,116,101,0,0,0,0,0,58,58,102,105,114,115,116,45,108,101,116,116,101,114,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,72,58,37,77,58,37,83,37,72,58,37,77,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,89,45,37,109,45,37,100,37,109,47,37,100,47,37,121,37,72,58,37,77,58,37,83,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,136,114,0,0,216,1,0,0,104,1,0,0,42,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,114,0,0,158,1,0,0,236,0,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,114,0,0,54,0,0,0,46,1,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,114,0,0,194,0,0,0,156,0,0,0,226,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,114,0,0,194,0,0,0,50,1,0,0,226,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,114,0,0,194,0,0,0,208,1,0,0,226,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,0,0,116,0,0,0,190,0,0,0,32,0,0,0,4,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,115,0,0,42,1,0,0,154,1,0,0,32,0,0,0,2,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,115,0,0,112,0,0,0,252,0,0,0,32,0,0,0,18,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,115,0,0,92,2,0,0,224,0,0,0,32,0,0,0,12,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,192,1,0,0,90,1,0,0,32,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,116,0,0,238,0,0,0,74,0,0,0,32,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,116,0,0,64,1,0,0,206,0,0,0,32,0,0,0,84,0,0,0,62,0,0,0,92,0,0,0,42,0,0,0,6,0,0,0,26,0,0,0,4,0,0,0,248,255,255,255,64,116,0,0,228,0,0,0,6,0,0,0,98,0,0,0,10,0,0,0,2,0,0,0,254,0,0,0,86,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,116,0,0,142,0,0,0,86,2,0,0,32,0,0,0,20,0,0,0,66,0,0,0,96,0,0,0,50,0,0,0,68,0,0,0,2,0,0,0,2,0,0,0,248,255,255,255,104,116,0,0,58,0,0,0,216,0,0,0,48,1,0,0,230,0,0,0,74,0,0,0,0,1,0,0,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,116,0,0,188,0,0,0,54,2,0,0,32,0,0,0,42,0,0,0,32,0,0,0,246,0,0,0,248,1,0,0,204,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,116,0,0,196,0,0,0,48,0,0,0,32,0,0,0,172,0,0,0,4,0,0,0,0,1,0,0,88,1,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,116,0,0,190,1,0,0,2,0,0,0,32,0,0,0,62,0,0,0,64,0,0,0,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,116,0,0,70,1,0,0,172,1,0,0,32,0,0,0,18,0,0,0,62,0,0,0,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,116,0,0,16,1,0,0,18,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,116,0,0,160,0,0,0,222,0,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,117,0,0,34,0,0,0,142,1,0,0,32,0,0,0,54,0,0,0,52,0,0,0,84,0,0,0,42,0,0,0,82,0,0,0,8,0,0,0,6,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,117,0,0,26,0,0,0,66,0,0,0,32,0,0,0,44,0,0,0,48,0,0,0,76,0,0,0,46,0,0,0,74,0,0,0,4,0,0,0,2,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,117,0,0,222,1,0,0,54,1,0,0,32,0,0,0,18,0,0,0,16,0,0,0,10,0,0,0,12,0,0,0,90,0,0,0,14,0,0,0,8,0,0,0,24,0,0,0,22,0,0,0,20,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,117,0,0,56,2,0,0,198,1,0,0,32,0,0,0,94,0,0,0,54,0,0,0,30,0,0,0,32,0,0,0,60,0,0,0,34,0,0,0,28,0,0,0,40,0,0,0,38,0,0,0,36,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,117,0,0,56,0,0,0,8,0,0,0,32,0,0,0,24,0,0,0,12,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,117,0,0,20,0,0,0,244,0,0,0,32,0,0,0,4,0,0,0,18,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,117,0,0,176,1,0,0,52,2,0,0,32,0,0,0,12,0,0,0,16,0,0,0,30,0,0,0,50,1,0,0,132,0,0,0,10,0,0,0,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,117,0,0,148,1,0,0,218,0,0,0,32,0,0,0,8,0,0,0,4,0,0,0,28,0,0,0,180,0,0,0,238,0,0,0,8,0,0,0,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,117,0,0,148,1,0,0,14,0,0,0,32,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,130,0,0,0,110,0,0,0,14,0,0,0,60,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,118,0,0,148,1,0,0,14,2,0,0,32,0,0,0,2,0,0,0,6,0,0,0,22,0,0,0,252,0,0,0,156,0,0,0,12,0,0,0,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,118,0,0,148,1,0,0,220,1,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,118,0,0,240,1,0,0,230,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,118,0,0,148,1,0,0,80,1,0,0,32,0,0,0,8,0,0,0,16,0,0,0,10,0,0,0,14,0,0,0,248,1,0,0,38,0,0,0,22,3,0,0,48,0,0,0,192,2,0,0,38,0,0,0,28,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,118,0,0,148,0,0,0,60,1,0,0,32,0,0,0,166,2,0,0,52,0,0,0,0,3,0,0,68,0,0,0,246,0,0,0,44,0,0,0,10,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,118,0,0,184,0,0,0,86,1,0,0,64,0,0,0,102,1,0,0,84,0,0,0,16,0,0,0,228,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,176,118,0,0,166,1,0,0,88,2,0,0,56,0,0,0,248,255,255,255,176,118,0,0,230,1,0,0,42,0,0,0,192,255,255,255,192,255,255,255,176,118,0,0,68,2,0,0,168,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,118,0,0,148,1,0,0,60,0,0,0,32,0,0,0,2,0,0,0,6,0,0,0,22,0,0,0,252,0,0,0,156,0,0,0,12,0,0,0,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,118,0,0,148,1,0,0,90,2,0,0,32,0,0,0,2,0,0,0,6,0,0,0,22,0,0,0,252,0,0,0,156,0,0,0,12,0,0,0,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,118,0,0,232,1,0,0,82,2,0,0,142,0,0,0,94,0,0,0,28,0,0,0,20,0,0,0,176,0,0,0,200,0,0,0,86,0,0,0,54,1,0,0,154,0,0,0,138,1,0,0,60,0,0,0,32,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,118,0,0,88,0,0,0,184,1,0,0,12,1,0,0,30,0,0,0,12,0,0,0,14,0,0,0,70,0,0,0,80,0,0,0,92,0,0,0,28,0,0,0,244,0,0,0,250,0,0,0,98,0,0,0,68,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,118,0,0,202,1,0,0,210,0,0,0,142,0,0,0,94,0,0,0,22,0,0,0,26,0,0,0,176,0,0,0,200,0,0,0,86,0,0,0,236,0,0,0,154,0,0,0,128,2,0,0,60,0,0,0,40,3,0,0,0,0,0,0,0,0,0,0,108,0,0,0,0,0,0,0,40,119,0,0,136,1,0,0,10,1,0,0,148,255,255,255,148,255,255,255,40,119,0,0,92,1,0,0,114,1,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,88,119,0,0,66,1,0,0,170,1,0,0,252,255,255,255,252,255,255,255,88,119,0,0,104,0,0,0,24,2,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,112,119,0,0,18,1,0,0,186,1,0,0,252,255,255,255,252,255,255,255,112,119,0,0,102,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,136,119,0,0,192,0,0,0,94,2,0,0,248,255,255,255,248,255,255,255,136,119,0,0,48,2,0,0,136,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,160,119,0,0,16,2,0,0,6,1,0,0,248,255,255,255,248,255,255,255,160,119,0,0,30,2,0,0,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,119,0,0,78,2,0,0,246,1,0,0,194,2,0,0,80,0,0,0,34,0,0,0,34,0,0,0,2,1,0,0,200,0,0,0,86,0,0,0,204,0,0,0,154,0,0,0,248,2,0,0,60,0,0,0,42,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,119,0,0,2,1,0,0,84,2,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,120,0,0,36,1,0,0,150,1,0,0,10,0,0,0,30,0,0,0,12,0,0,0,14,0,0,0,8,1,0,0,80,0,0,0,92,0,0,0,28,0,0,0,244,0,0,0,250,0,0,0,14,0,0,0,132,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,120,0,0,134,1,0,0,118,0,0,0,94,0,0,0,94,0,0,0,22,0,0,0,26,0,0,0,12,0,0,0,200,0,0,0,86,0,0,0,236,0,0,0,154,0,0,0,128,2,0,0,96,0,0,0,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,120,0,0,26,1,0,0,118,1,0,0,32,0,0,0,56,0,0,0,146,0,0,0,114,0,0,0,208,0,0,0,164,1,0,0,40,1,0,0,104,0,0,0,146,2,0,0,178,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,120,0,0,204,0,0,0,36,0,0,0,32,0,0,0,220,0,0,0,144,0,0,0,116,1,0,0,80,2,0,0,142,1,0,0,70,0,0,0,46,1,0,0,22,2,0,0,180,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,120,0,0,2,2,0,0,208,0,0,0,32,0,0,0,16,0,0,0,108,0,0,0,14,2,0,0,6,2,0,0,94,2,0,0,126,0,0,0,72,0,0,0,90,1,0,0,138,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,120,0,0,254,1,0,0,140,1,0,0,32,0,0,0,214,0,0,0,218,0,0,0,222,1,0,0,178,0,0,0,24,1,0,0,142,2,0,0,124,0,0,0,226,2,0,0,124,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,120,0,0,88,1,0,0,206,1,0,0,22,0,0,0,30,0,0,0,12,0,0,0,14,0,0,0,70,0,0,0,80,0,0,0,92,0,0,0,188,0,0,0,126,0,0,0,208,2,0,0,98,0,0,0,68,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,120,0,0,12,0,0,0,178,1,0,0,14,1,0,0,94,0,0,0,22,0,0,0,26,0,0,0,176,0,0,0,200,0,0,0,86,0,0,0,210,0,0,0,22,0,0,0,194,1,0,0,60,0,0,0,40,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,121,0,0,140,0,0,0,188,1,0,0,106,0,0,0,130,1,0,0,56,0,0,0,234,0,0,0,28,0,0,0,188,0,0,0,94,0,0,0,82,0,0,0,108,0,0,0,64,0,0,0,18,1,0,0,92,1,0,0,136,1,0,0,146,0,0,0,216,1,0,0,180,0,0,0,176,0,0,0,126,0,0,0,148,0,0,0,82,1,0,0,10,0,0,0,56,1,0,0,212,0,0,0,84,1,0,0,240,0,0,0,202,1,0,0,218,0,0,0,138,0,0,0,48,1,0,0,142,0,0,0,48,0,0,0,160,0,0,0,0,1,0,0,60,1,0,0,254,0,0,0,110,1,0,0,182,1,0,0,138,1,0,0,12,0,0,0,192,1,0,0,186,1,0,0,132,0,0,0,58,1,0,0,206,0,0,0,34,1,0,0,90,1,0,0,190,1,0,0,214,1,0,0,36,0,0,0,134,1,0,0,40,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,121,0,0,8,0,0,0,8,0,0,0,188,1,0,0,22,2,0,0,10,0,0,0,170,0,0,0,186,0,0,0,152,1,0,0,92,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,121,0,0,120,1,0,0,198,0,0,0,148,0,0,0,38,0,0,0,88,2,0,0,66,2,0,0,138,0,0,0,198,1,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,121,0,0,8,0,0,0,8,0,0,0,188,1,0,0,22,2,0,0,10,0,0,0,170,0,0,0,186,0,0,0,152,1,0,0,92,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,121,0,0,32,1,0,0,146,1,0,0,160,1,0,0,30,3,0,0,8,2,0,0,238,0,0,0,212,1,0,0,86,0,0,0,116,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,121,0,0,80,0,0,0,226,0,0,0,134,0,0,0,58,2,0,0,164,1,0,0,46,2,0,0,26,3,0,0,12,1,0,0,208,0,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,172,2,0,0,220,255,255,255,128,121,0,0,114,2,0,0,242,0,0,0,242,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,121,0,0,4,2,0,0,70,0,0,0,148,1,0,0,166,0,0,0,200,2,0,0,4,0,0,0,122,2,0,0,194,0,0,0,20,0,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,121,0,0,8,0,0,0,8,0,0,0,188,1,0,0,22,2,0,0,10,0,0,0,170,0,0,0,186,0,0,0,152,1,0,0,92,0,0,0,96,0,0,0,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,121,0,0,56,1,0,0,202,0,0,0,136,0,0,0,18,3,0,0,32,0,0,0,176,2,0,0,204,2,0,0,218,1,0,0,72,1,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,121,0,0,8,0,0,0,8,0,0,0,188,1,0,0,22,2,0,0,10,0,0,0,170,0,0,0,186,0,0,0,152,1,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,121,0,0,68,0,0,0,252,1,0,0,240,1,0,0,20,1,0,0,172,1,0,0,96,2,0,0,98,0,0,0,176,1,0,0,52,1,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,121,0,0,174,1,0,0,28,2,0,0,158,0,0,0,98,2,0,0,250,1,0,0,198,2,0,0,82,1,0,0,148,1,0,0,26,1,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,121,0,0,124,1,0,0,228,1,0,0,236,0,0,0,62,0,0,0,40,0,0,0,104,2,0,0,70,0,0,0,200,0,0,0,222,1,0,0,206,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,122,0,0,98,1,0,0,22,2,0,0,128,0,0,0,34,1,0,0,86,1,0,0,142,0,0,0,158,0,0,0,46,0,0,0,118,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,122,0,0,42,0,0,0,108,1,0,0,162,1,0,0,50,0,0,0,44,0,0,0,214,0,0,0,144,1,0,0,126,2,0,0,100,0,0,0,78,0,0,0,108,1,0,0,62,2,0,0,88,2,0,0,234,2,0,0,58,1,0,0,176,2,0,0,164,0,0,0,102,2,0,0,130,2,0,0,244,1,0,0,220,2,0,0,190,0,0,0,228,0,0,0,198,2,0,0,28,0,0,0,4,1,0,0,6,1,0,0,182,2,0,0,204,0,0,0,236,2,0,0,66,2,0,0,74,0,0,0,216,1,0,0,20,0,0,0,246,2,0,0,176,1,0,0,208,2,0,0,84,1,0,0,134,2,0,0,46,2,0,0,144,0,0,0,2,3,0,0,158,2,0,0,110,0,0,0,54,1,0,0,44,1,0,0,118,2,0,0,200,2,0,0,166,0,0,0,62,0,0,0,110,1,0,0,10,2,0,0,74,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,122,0,0,24,1,0,0,40,0,0,0,166,2,0,0,100,1,0,0,18,2,0,0,122,1,0,0,194,0,0,0,232,0,0,0,136,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,122,0,0,76,1,0,0,234,0,0,0,182,1,0,0,200,0,0,0,50,3,0,0,218,2,0,0,2,1,0,0,186,0,0,0,182,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,122,0,0,64,2,0,0,236,1,0,0,234,1,0,0,210,1,0,0,220,2,0,0,246,2,0,0,180,2,0,0,202,0,0,0,172,0,0,0,112,0,0,0,144,2,0,0,94,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,122,0,0,200,1,0,0,38,1,0,0,188,2,0,0,188,0,0,0,130,0,0,0,84,2,0,0,52,1,0,0,252,0,0,0,208,1,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,122,0,0,8,0,0,0,8,0,0,0,104,2,0,0,14,3,0,0,218,1,0,0,230,2,0,0,174,1,0,0,4,0,0,0,166,0,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,122,0,0,68,1,0,0,140,0,0,0,216,2,0,0,170,2,0,0,184,0,0,0,12,0,0,0,118,1,0,0,36,1,0,0,220,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,122,0,0,226,1,0,0,74,2,0,0,86,0,0,0,74,0,0,0,146,0,0,0,112,2,0,0,32,3,0,0,230,1,0,0,52,0,0,0,182,0,0,0,128,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,122,0,0,232,0,0,0,134,0,0,0,16,0,0,0,6,2,0,0,98,1,0,0,226,0,0,0,156,1,0,0,50,1,0,0,250,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,122,0,0,96,2,0,0,146,0,0,0,58,0,0,0,230,1,0,0,242,2,0,0,230,2,0,0,192,2,0,0,44,2,0,0,104,1,0,0,198,1,0,0,172,1,0,0,242,1,0,0,68,0,0,0,238,2,0,0,216,0,0,0,40,0,0,0,250,2,0,0,174,0,0,0,32,0,0,0,124,0,0,0,178,1,0,0,50,2,0,0,132,0,0,0,184,0,0,0,100,2,0,0,90,2,0,0,162,2,0,0,154,1,0,0,160,2,0,0,130,1,0,0,98,0,0,0,222,0,0,0,184,2,0,0,200,1,0,0,112,0,0,0,224,0,0,0,244,2,0,0,244,0,0,0,140,0,0,0,60,1,0,0,254,2,0,0,220,0,0,0,162,0,0,0,230,0,0,0,10,3,0,0,4,3,0,0,160,0,0,0,68,2,0,0,136,1,0,0,112,2,0,0,114,1,0,0,206,0,0,0,84,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,122,0,0,216,0,0,0,180,1,0,0,72,1,0,0,174,0,0,0,252,1,0,0,16,0,0,0,94,0,0,0,4,3,0,0,38,3,0,0,136,1,0,0,124,2,0,0,34,3,0,0,192,0,0,0,44,2,0,0,148,2,0,0,14,0,0,0,106,1,0,0,158,1,0,0,124,1,0,0,176,0,0,0,156,0,0,0,34,2,0,0,190,2,0,0,218,0,0,0,234,0,0,0,92,2,0,0,154,0,0,0,90,2,0,0,144,2,0,0,134,0,0,0,240,1,0,0,104,1,0,0,116,0,0,0,12,1,0,0,48,1,0,0,114,2,0,0,40,1,0,0,118,0,0,0,158,2,0,0,88,0,0,0,52,2,0,0,120,0,0,0,14,1,0,0,46,1,0,0,226,1,0,0,178,2,0,0,64,1,0,0,66,0,0,0,184,1,0,0,204,0,0,0,224,0,0,0,132,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,122,0,0,112,1,0,0,34,2,0,0,36,2,0,0,22,0,0,0,150,1,0,0,128,0,0,0,60,2,0,0,80,0,0,0,62,1,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,122,0,0,150,0,0,0,72,0,0,0,48,2,0,0,122,0,0,0,204,1,0,0,112,1,0,0,120,2,0,0,146,1,0,0,150,0,0,0,182,0,0,0,92,1,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,122,0,0,228,0,0,0,74,1,0,0,48,0,0,0,116,2,0,0,68,1,0,0,96,1,0,0,234,2,0,0,242,0,0,0,74,1,0,0,76,0,0,0,26,1,0,0,194,1,0,0,228,255,255,255,240,122,0,0,72,2,0,0,76,0,0,0,212,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,123,0,0,228,0,0,0,174,0,0,0,92,0,0,0,112,1,0,0,122,0,0,0,34,0,0,0,124,1,0,0,188,1,0,0,70,0,0,0,190,0,0,0,172,1,0,0,246,0,0,0,108,1,0,0,206,1,0,0,102,0,0,0,106,1,0,0,94,1,0,0,170,0,0,0,196,1,0,0,164,0,0,0,2,1,0,0,90,0,0,0,216,0,0,0,156,1,0,0,236,0,0,0,76,0,0,0,194,1,0,0,154,0,0,0,200,1,0,0,38,1,0,0,116,1,0,0,238,0,0,0,204,1,0,0,106,0,0,0,134,0,0,0,162,0,0,0,240,1,0,0,178,0,0,0,158,1,0,0,62,0,0,0,168,0,0,0,78,1,0,0,68,0,0,0,104,0,0,0,180,1,0,0,158,0,0,0,28,1,0,0,68,1,0,0,192,0,0,0,230,0,0,0,76,1,0,0,96,1,0,0,164,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,123,0,0,110,1,0,0,32,2,0,0,180,2,0,0,24,3,0,0,42,1,0,0,140,2,0,0,72,2,0,0,4,1,0,0,32,1,0,0,134,0,0,0,108,0,0,0,20,1,0,0,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,123,0,0,116,1,0,0,38,2,0,0,54,0,0,0,50,0,0,0,70,2,0,0,162,1,0,0,136,2,0,0,224,1,0,0,86,1,0,0,182,0,0,0,76,2,0,0,240,0,0,0,114,0,0,0,220,255,255,255,48,123,0,0,2,1,0,0,158,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,123,0,0,62,2,0,0,170,0,0,0,82,1,0,0,126,0,0,0,200,1,0,0,28,3,0,0,228,1,0,0,238,1,0,0,16,2,0,0,196,0,0,0,166,1,0,0,60,0,0,0,86,0,0,0,20,2,0,0,182,1,0,0,120,1,0,0,206,2,0,0,230,1,0,0,102,1,0,0,168,1,0,0,22,1,0,0,232,2,0,0,212,0,0,0,20,0,0,0,142,2,0,0,4,1,0,0,62,1,0,0,190,1,0,0,172,2,0,0,198,1,0,0,196,2,0,0,254,2,0,0,96,0,0,0,84,0,0,0,248,0,0,0,100,0,0,0,48,3,0,0,84,1,0,0,16,3,0,0,70,1,0,0,20,3,0,0,222,1,0,0,210,0,0,0,238,2,0,0,24,0,0,0,126,2,0,0,2,2,0,0,92,0,0,0,240,2,0,0,44,1,0,0,110,1,0,0,50,2,0,0,156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,123,0,0,96,0,0,0,58,1,0,0,196,0,0,0,134,2,0,0,188,2,0,0,0,1,0,0,90,1,0,0,234,1,0,0,232,1,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,123,0,0,166,0,0,0,12,1,0,0,138,0,0,0,208,1,0,0,130,1,0,0,236,0,0,0,168,0,0,0,144,0,0,0,84,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,123,0,0,110,0,0,0,250,0,0,0,162,1,0,0,148,0,0,0,48,0,0,0,44,3,0,0,154,1,0,0,40,0,0,0,114,1,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,123,0,0,94,0,0,0,70,2,0,0,86,2,0,0,174,2,0,0,86,2,0,0,6,0,0,0,252,2,0,0,224,0,0,0,222,0,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,123,0,0,130,1,0,0,66,2,0,0,156,2,0,0,78,2,0,0,94,2,0,0,74,1,0,0,160,1,0,0,112,0,0,0,140,1,0,0,40,1,0,0,118,0,0,0,50,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,123,0,0,200,0,0,0,64,0,0,0,150,2,0,0,230,0,0,0,126,1,0,0,242,2,0,0,102,0,0,0,198,0,0,0,54,1,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,123,0,0,58,2,0,0,106,1,0,0,30,1,0,0,8,3,0,0,6,3,0,0,232,1,0,0,236,2,0,0,110,0,0,0,22,1,0,0,96,0,0,0,140,0,0,0,50,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,123,0,0,128,0,0,0,60,2,0,0,172,0,0,0,58,1,0,0,184,2,0,0,108,2,0,0,42,2,0,0,162,1,0,0,118,1,0,0,96,0,0,0,186,0,0,0,42,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,123,0,0,250,1,0,0,62,0,0,0,80,1,0,0,76,0,0,0,206,1,0,0,26,2,0,0])
.concat([42,0,0,0,10,1,0,0,244,0,0,0,96,0,0,0,118,0,0,0,50,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,123,0,0,12,2,0,0,254,0,0,0,42,2,0,0,250,1,0,0,250,0,0,0,118,0,0,0,128,1,0,0,138,1,0,0,238,0,0,0,168,1,0,0,0,2,0,0,170,0,0,0,88,0,0,0,136,2,0,0,118,1,0,0,66,1,0,0,148,2,0,0,34,0,0,0,164,2,0,0,140,1,0,0,146,0,0,0,202,0,0,0,122,0,0,0,36,1,0,0,156,1,0,0,28,2,0,0,236,1,0,0,202,2,0,0,102,1,0,0,42,1,0,0,176,0,0,0,80,0,0,0,86,1,0,0,218,1,0,0,186,1,0,0,18,1,0,0,92,2,0,0,52,0,0,0,210,2,0,0,212,1,0,0,122,2,0,0,18,2,0,0,252,0,0,0,124,2,0,0,24,2,0,0,120,2,0,0,240,0,0,0,68,1,0,0,240,2,0,0,36,0,0,0,46,0,0,0,78,1,0,0,196,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,124,0,0,248,0,0,0,114,0,0,0,190,1,0,0,44,0,0,0,26,1,0,0,8,0,0,0,244,0,0,0,8,0,0,0,104,1,0,0,162,0,0,0,242,0,0,0,188,0,0,0,224,255,255,255,0,124,0,0,248,2,0,0,128,1,0,0,216,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,124,0,0,18,0,0,0,124,0,0,0,56,1,0,0,50,1,0,0,220,0,0,0,240,0,0,0,140,1,0,0,58,0,0,0,120,1,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,124,0,0,78,0,0,0,48,1,0,0,232,0,0,0,36,2,0,0,214,1,0,0,252,0,0,0,40,2,0,0,204,0,0,0,42,1,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,124,0,0,172,0,0,0,22,1,0,0,204,1,0,0,142,1,0,0,226,2,0,0,164,2,0,0,162,2,0,0,66,1,0,0,120,0,0,0,96,0,0,0,118,0,0,0,50,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,124,0,0,10,2,0,0,152,1,0,0,60,2,0,0,52,3,0,0,196,1,0,0,82,2,0,0,216,2,0,0,122,1,0,0,6,0,0,0,34,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,124,0,0,234,1,0,0,44,0,0,0,228,1,0,0,12,3,0,0,56,0,0,0,118,2,0,0,108,0,0,0,38,0,0,0,30,0,0,0,182,0,0,0,38,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,124,0,0,8,0,0,0,8,0,0,0,188,1,0,0,22,2,0,0,10,0,0,0,170,0,0,0,186,0,0,0,152,1,0,0,92,0,0,0,96,0,0,0,118,0,0,0,50,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,124,0,0,132,0,0,0,72,2,0,0,214,1,0,0,100,2,0,0,94,1,0,0,254,0,0,0,232,0,0,0,242,1,0,0,210,1,0,0,96,0,0,0,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,124,0,0,108,0,0,0,164,0,0,0,58,0,0,0,214,2,0,0,80,2,0,0,170,1,0,0,116,1,0,0,98,1,0,0,150,1,0,0,96,0,0,0,38,1,0,0,70,0,0,0,44,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,125,0,0,96,1,0,0,212,1,0,0,194,0,0,0,14,2,0,0,152,0,0,0,92,1,0,0,18,0,0,0,244,1,0,0,80,1,0,0,96,0,0,0,26,0,0,0,40,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,125,0,0,40,2,0,0,122,0,0,0,218,0,0,0,224,1,0,0,124,0,0,0,36,3,0,0,134,1,0,0,130,0,0,0,20,1,0,0,182,0,0,0,56,2,0,0,94,0,0,0,114,0,0,0,216,255,255,255,64,125,0,0,2,1,0,0,12,2,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,125,0,0,50,2,0,0,78,1,0,0,30,0,0,0,228,0,0,0,194,2,0,0,38,1,0,0,30,1,0,0,174,1,0,0,70,1,0,0,54,0,0,0,158,0,0,0,16,2,0,0,224,255,255,255,96,125,0,0,64,0,0,0,176,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,125,0,0,66,0,0,0,182,1,0,0,164,1,0,0,2,0,0,0,238,1,0,0,24,0,0,0,62,1,0,0,82,1,0,0,158,1,0,0,82,0,0,0,226,0,0,0,152,0,0,0,18,0,0,0,168,2,0,0,116,0,0,0,212,2,0,0,76,1,0,0,200,0,0,0,166,1,0,0,202,1,0,0,46,1,0,0,170,1,0,0,30,2,0,0,4,2,0,0,82,2,0,0,32,1,0,0,140,2,0,0,52,2,0,0,56,0,0,0,206,2,0,0,150,0,0,0,252,2,0,0,60,0,0,0,58,2,0,0,192,1,0,0,224,1,0,0,2,2,0,0,154,2,0,0,26,2,0,0,224,2,0,0,192,0,0,0,150,1,0,0,94,1,0,0,196,2,0,0,120,0,0,0,218,2,0,0,214,2,0,0,98,1,0,0,206,1,0,0,186,0,0,0,90,0,0,0,48,1,0,0,152,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,125,0,0,162,0,0,0,8,1,0,0,98,2,0,0,190,0,0,0,46,0,0,0,12,2,0,0,34,0,0,0,196,0,0,0,66,0,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,125,0,0,160,0,0,0,22,0,0,0,120,0,0,0,36,1,0,0,250,2,0,0,80,1,0,0,54,0,0,0,4,2,0,0,102,2,0,0,192,1,0,0,222,2,0,0,180,0,0,0,150,0,0,0,2,3,0,0,110,2,0,0,64,2,0,0,216,1,0,0,24,2,0,0,24,1,0,0,28,0,0,0,18,1,0,0,152,2,0,0,180,1,0,0,112,0,0,0,110,0,0,0,182,0,0,0,82,0,0,0,220,1,0,0,244,2,0,0,76,1,0,0,242,1,0,0,214,0,0,0,202,1,0,0,54,3,0,0,152,1,0,0,234,1,0,0,72,0,0,0,60,1,0,0,8,1,0,0,224,2,0,0,140,0,0,0,132,1,0,0,202,2,0,0,30,0,0,0,10,3,0,0,28,1,0,0,104,0,0,0,176,1,0,0,78,0,0,0,202,0,0,0,138,2,0,0,108,1,0,0,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,125,0,0,214,1,0,0,30,0,0,0,38,0,0,0,154,2,0,0,160,2,0,0,106,2,0,0,0,2,0,0,8,1,0,0,42,0,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,220,255,255,255,176,125,0,0,174,1,0,0,24,0,0,0,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,125,0,0,126,0,0,0,244,1,0,0,116,2,0,0,78,1,0,0,32,2,0,0,66,1,0,0,208,0,0,0,24,1,0,0,124,0,0,0,62,1,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,125,0,0,122,1,0,0,248,1,0,0,76,0,0,0,182,2,0,0,64,0,0,0,212,2,0,0,246,1,0,0,64,1,0,0,128,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,125,0,0,90,0,0,0,20,2,0,0,210,0,0,0,28,2,0,0,56,2,0,0,188,1,0,0,36,0,0,0,246,1,0,0,16,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,0,0,134,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,126,0,0,232,2,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,126,0,0,92,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,126,0,0,174,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,126,0,0,122,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,126,0,0,168,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,126,0,0,2,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,126,0,0,132,1,0,0,28,0,0,0,190,2,0,0,150,2,0,0,54,2,0,0,10,2,0,0,16,1,0,0,238,1,0,0,54,0,0,0,100,1,0,0,228,255,255,255,56,126,0,0,52,1,0,0,62,2,0,0,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,126,0,0,100,0,0,0,76,2,0,0,184,1,0,0,146,1,0,0,228,2,0,0,186,1,0,0,38,2,0,0,100,1,0,0,16,1,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,126,0,0,8,0,0,0,8,0,0,0,188,1,0,0,22,2,0,0,10,0,0,0,170,0,0,0,186,0,0,0,152,1,0,0,92,0,0,0,182,0,0,0,8,2,0,0,94,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,126,0,0,6,2,0,0,180,0,0,0,8,0,0,0,186,2,0,0,136,0,0,0,58,0,0,0,236,1,0,0,170,1,0,0,18,0,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,126,0,0,28,1,0,0,194,1,0,0,170,2,0,0,162,0,0,0,146,2,0,0,148,1,0,0,2,0,0,0,44,1,0,0,132,1,0,0,76,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,126,0,0,40,1,0,0,84,1,0,0,46,0,0,0,126,1,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,126,0,0,40,1,0,0,160,1,0,0,46,0,0,0,126,1,0,0,6,0,0,0,32,0,0,0,32,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,118,0,0,0,0,0,0,0,99,0,0,0,0,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,83,116,57,101,120,99,101,112,116,105,111,110,0,0,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,80,75,99,0,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,49,95,95,98,97,115,105,99,95,115,116,114,105,110,103,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,78,83,116,51,95,95,49,49,56,98,97,115,105,99,95,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,78,83,116,51,95,95,49,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,52,83,97,115,115,57,84,111,95,83,116,114,105,110,103,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,83,116,97,116,101,109,101,110,116,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,80,97,114,97,109,101,116,101,114,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,118,69,69,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,80,78,83,95,57,83,116,97,116,101,109,101,110,116,69,69,69,0,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,80,78,83,95,56,83,101,108,101,99,116,111,114,69,69,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,80,78,83,95,49,48,69,120,112,114,101,115,115,105,111,110,69,69,69,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,78,83,116,51,95,95,49,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,49,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,49,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,49,48,83,97,115,115,95,86,97,108,117,101,69,69,0,78,52,83,97,115,115,57,72,97,115,95,66,108,111,99,107,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,69,120,116,101,110,115,105,111,110,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,65,114,103,117,109,101,110,116,115,69,0,0,0,0,0,0,0,78,52,83,97,115,115,56,86,97,114,105,97,98,108,101,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,56,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,56,65,114,103,117,109,101,110,116,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,56,65,83,84,95,78,111,100,101,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,55,87,97,114,110,105,110,103,69,0,78,52,83,97,115,115,55,84,101,120,116,117,97,108,69,0,78,52,83,97,115,115,55,82,117,108,101,115,101,116,69,0,78,52,83,97,115,115,55,80,114,111,112,115,101,116,69,0,78,52,83,97,115,115,55,73,110,115,112,101,99,116,69,0,78,52,83,97,115,115,55,67,111,110,116,101,110,116,69,0,78,52,83,97,115,115,55,67,111,109,109,101,110,116,69,0,78,52,83,97,115,115,55,66,111,111,108,101,97,110,69,0,78,52,83,97,115,115,55,65,116,95,82,117,108,101,69,0,78,52,83,97,115,115,54,83,116,114,105,110,103,69,0,0,78,52,83,97,115,115,54,82,101,116,117,114,110,69,0,0,78,52,83,97,115,115,54,78,117,109,98,101,114,69,0,0,78,52,83,97,115,115,54,73,109,112,111,114,116,69,0,0,78,52,83,97,115,115,54,69,120,116,101,110,100,69,0,0,78,52,83,97,115,115,54,69,120,112,97,110,100,69,0,0,78,52,83,97,115,115,53,87,104,105,108,101,69,0,0,0,78,52,83,97,115,115,53,69,114,114,111,114,69,0,0,0,78,52,83,97,115,115,53,67,111,108,111,114,69,0,0,0,78,52,83,97,115,115,53,66,108,111,99,107,69,0,0,0,78,52,83,97,115,115,52,84,111,95,67,69,0,0,0,0,78,52,83,97,115,115,52,78,117,108,108,69,0,0,0,0,78,52,83,97,115,115,52,76,105,115,116,69,0,0,0,0,78,52,83,97,115,115,52,69,118,97,108,69,0,0,0,0,78,52,83,97,115,115,52,69,97,99,104,69,0,0,0,0,78,52,83,97,115,115,51,70,111,114,69,0,0,0,0,0,78,52,83,97,115,115,50,73,102,69,0,0,0,0,0,0,78,52,83,97,115,115,50,50,77,101,100,105,97,95,81,117,101,114,121,95,69,120,112,114,101,115,115,105,111,110,69,0,78,52,83,97,115,115,50,48,83,101,108,101,99,116,111,114,95,80,108,97,99,101,104,111,108,100,101,114,69,0,0,0,78,52,83,97,115,115,50,48,70,117,110,99,116,105,111,110,95,67,97,108,108,95,83,99,104,101,109,97,69,0,0,0,78,52,83,97,115,115,49,56,83,101,108,101,99,116,111,114,95,82,101,102,101,114,101,110,99,101,69,0,0,0,0,0,78,52,83,97,115,115,49,56,83,101,108,101,99,116,111,114,95,81,117,97,108,105,102,105,101,114,69,0,0,0,0,0,78,52,83,97,115,115,49,56,65,116,116,114,105,98,117,116,101,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,78,52,83,97,115,115,49,55,79,117,116,112,117,116,95,67,111,109,112,114,101,115,115,101,100,69,0,0,0,0,0,0,78,52,83,97,115,115,49,55,67,111,109,112,111,117,110,100,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,78,52,83,97,115,115,49,55,66,105,110,97,114,121,95,69,120,112,114,101,115,115,105,111,110,69,0,0,0,0,0,0,78,52,83,97,115,115,49,54,85,110,97,114,121,95,69,120,112,114,101,115,115,105,111,110,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,54,78,101,103,97,116,101,100,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,54,67,111,109,112,108,101,120,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,83,116,114,105,110,103,95,67,111,110,115,116,97,110,116,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,83,105,109,112,108,101,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,83,101,108,101,99,116,111,114,95,83,99,104,101,109,97,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,80,115,101,117,100,111,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,55,73,110,115,112,101,99,116,69,69,69,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,54,69,120,116,101,110,100,69,69,69,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,49,55,79,117,116,112,117,116,95,67,111,109,112,114,101,115,115,101,100,69,69,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,49,51,79,117,116,112,117,116,95,78,101,115,116,101,100,69,69,69,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,80,78,83,95,57,83,116,97,116,101,109,101,110,116,69,78,83,95,54,69,120,112,97,110,100,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,80,78,83,95,56,83,101,108,101,99,116,111,114,69,78,83,95,49,51,67,111,110,116,101,120,116,117,97,108,105,122,101,69,69,69,0,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,80,78,83,95,49,48,69,120,112,114,101,115,115,105,111,110,69,78,83,95,52,69,118,97,108,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,78,83,116,51,95,95,49,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,49,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,49,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,95,57,84,111,95,83,116,114,105,110,103,69,69,69,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,49,48,83,97,115,115,95,86,97,108,117,101,78,83,95,52,84,111,95,67,69,69,69,0,0,78,52,83,97,115,115,49,51,84,121,112,101,95,83,101,108,101,99,116,111,114,69,0,0,78,52,83,97,115,115,49,51,83,116,114,105,110,103,95,83,99,104,101,109,97,69,0,0,78,52,83,97,115,115,49,51,83,101,108,101,99,116,111,114,95,76,105,115,116,69,0,0,78,52,83,97,115,115,49,51,79,117,116,112,117,116,95,78,101,115,116,101,100,69,0,0,78,52,83,97,115,115,49,51,70,117,110,99,116,105,111,110,95,67,97,108,108,69,0,0,78,52,83,97,115,115,49,51,67,111,110,116,101,120,116,117,97,108,105,122,101,69,0,0,78,52,83,97,115,115,49,49,77,101,100,105,97,95,81,117,101,114,121,69,0,0,0,0,78,52,83,97,115,115,49,49,77,101,100,105,97,95,66,108,111,99,107,69,0,0,0,0,78,52,83,97,115,115,49,49,73,109,112,111,114,116,95,83,116,117,98,69,0,0,0,0,78,52,83,97,115,115,49,49,68,101,99,108,97,114,97,116,105,111,110,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,57,83,116,97,116,101,109,101,110,116,69,69,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,57,80,97,114,97,109,101,116,101,114,69,69,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,56,65,114,103,117,109,101,110,116,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,50,50,77,101,100,105,97,95,81,117,101,114,121,95,69,120,112,114,101,115,115,105,111,110,69,69,69,0,0,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,49,54,67,111,109,112,108,101,120,95,83,101,108,101,99,116,111,114,69,69,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,49,53,83,105,109,112,108,101,95,83,101,108,101,99,116,111,114,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,49,48,69,120,112,114,101,115,115,105,111,110,69,69,69,0,0,78,52,83,97,115,115,49,48,80,97,114,97,109,101,116,101,114,115,69,0,0,0,0,0,78,52,83,97,115,115,49,48,77,105,120,105,110,95,67,97,108,108,69,0,0,0,0,0,78,52,83,97,115,115,49,48,69,120,112,114,101,115,115,105,111,110,69,0,0,0,0,0,78,52,83,97,115,115,49,48,68,101,102,105,110,105,116,105,111,110,69,0,0,0,0,0,78,52,83,97,115,115,49,48,65,115,115,105,103,110,109,101,110,116,69,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,51,95,95,102,117,110,100,97,109,101,110,116,97,108,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,57,95,95,112,111,105,110,116,101,114,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,112,98,97,115,101,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,68,110,0,0,0,0,0,0,8,90,0,0,88,90,0,0,0,0,0,0,104,90,0,0,0,0,0,0,120,90,0,0,0,0,0,0,136,90,0,0,128,114,0,0,0,0,0,0,0,0,0,0,152,90,0,0,128,114,0,0,0,0,0,0,0,0,0,0,168,90,0,0,128,114,0,0,0,0,0,0,0,0,0,0,192,90,0,0,216,114,0,0,0,0,0,0,0,0,0,0,216,90,0,0,216,114,0,0,0,0,0,0,0,0,0,0,240,90,0,0,128,114,0,0,0,0,0,0,0,0,0,0,0,91,0,0,1,0,0,0,0,0,0,0,0,0,0,0,8,91,0,0,48,90,0,0,32,91,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,40,120,0,0,0,0,0,0,48,90,0,0,104,91,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,48,120,0,0,0,0,0,0,48,90,0,0,176,91,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,56,120,0,0,0,0,0,0,48,90,0,0,248,91,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,64,120,0,0,0,0,0,0,0,0,0,0,64,92,0,0,240,116,0,0,0,0,0,0,0,0,0,0,112,92,0,0,240,116,0,0,0,0,0,0,48,90,0,0,160,92,0,0,0,0,0,0,1,0,0,0,64,119,0,0,0,0,0,0,48,90,0,0,184,92,0,0,0,0,0,0,1,0,0,0,64,119,0,0,0,0,0,0,48,90,0,0,208,92,0,0,0,0,0,0,1,0,0,0,72,119,0,0,0,0,0,0,48,90,0,0,232,92,0,0,0,0,0,0,1,0,0,0,72,119,0,0,0,0,0,0,48,90,0,0,0,93,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,216,120,0,0,0,8,0,0,48,90,0,0,72,93,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,216,120,0,0,0,8,0,0,48,90,0,0,144,93,0,0,0,0,0,0,3,0,0,0,40,118,0,0,2,0,0,0,248,114,0,0,2,0,0,0,144,118,0,0,0,8,0,0,48,90,0,0,216,93,0,0,0,0,0,0,3,0,0,0,40,118,0,0,2,0,0,0,248,114,0,0,2,0,0,0,152,118,0,0,0,8,0,0,0,0,0,0,32,94,0,0,40,118,0,0,0,0,0,0,0,0,0,0,56,94,0,0,40,118,0,0,0,0,0,0,48,90,0,0,80,94,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,80,119,0,0,2,0,0,0,48,90,0,0,104,94,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,80,119,0,0,2,0,0,0,0,0,0,0,128,94,0,0,0,0,0,0,152,94,0,0,200,119,0,0,0,0,0,0,48,90,0,0,184,94,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,160,115,0,0,0,0,0,0,48,90,0,0,0,95,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,184,115,0,0,0,0,0,0,48,90,0,0,72,95,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,208,115,0,0,0,0,0,0,48,90,0,0,144,95,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,232,115,0,0,0,0,0,0,0,0,0,0,216,95,0,0,40,118,0,0,0,0,0,0,0,0,0,0,240,95,0,0,40,118,0,0,0,0,0,0,48,90,0,0,8,96,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,216,119,0,0,2,0,0,0,48,90,0,0,48,96,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,216,119,0,0,2,0,0,0,48,90,0,0,88,96,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,216,119,0,0,2,0,0,0,48,90,0,0,128,96,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,216,119,0,0,2,0,0,0,0,0,0,0,168,96,0,0,56,119,0,0,0,0,0,0,0,0,0,0,192,96,0,0,40,118,0,0,0,0,0,0,48,90,0,0,216,96,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,208,120,0,0,2,0,0,0,48,90,0,0,240,96,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,208,120,0,0,2,0,0,0,0,0,0,0,8,97,0,0,0,0,0,0,48,97,0,0,0,0,0,0,88,97,0,0,0,0,0,0,128,97,0,0,248,119,0,0,0,0,0,0,0,0,0,0,160,97,0,0,8,119,0,0,0,0,0,0,0,0,0,0,232,97,0,0,8,118,0,0,0,0,0,0,0,0,0,0,16,98,0,0,8,118,0,0,0,0,0,0,0,0,0,0,56,98,0,0,248,118,0,0,0,0,0,0,0,0,0,0,128,98,0,0,0,0,0,0,184,98,0,0,0,0,0,0,240,98,0,0,48,90,0,0,16,99,0,0,3,0,0,0,2,0,0,0,160,119,0,0,2,0,0,0,112,119,0,0,2,8,0,0,0,0,0,0,64,99,0,0,160,119,0,0,0,0,0,0,0,0,0,0,112,99,0,0,0,0,0,0,144,99,0,0,0,0,0,0,176,99,0,0,0,0,0,0,208,99,0,0,48,90,0,0,232,99,0,0,0,0,0,0,1,0,0,0,128,115,0,0,3,244,255,255,48,90,0,0,24,100,0,0,0,0,0,0,1,0,0,0,144,115,0,0,3,244,255,255,48,90,0,0,72,100,0,0,0,0,0,0,1,0,0,0,128,115,0,0,3,244,255,255,48,90,0,0,120,100,0,0,0,0,0,0,1,0,0,0,144,115,0,0,3,244,255,255,0,0,0,0,168,100,0,0,248,118,0,0,0,0,0,0,0,0,0,0,216,100,0,0,168,114,0,0,0,0,0,0,0,0,0,0,240,100,0,0,48,90,0,0,8,101,0,0,0,0,0,0,1,0,0,0,136,118,0,0,0,0,0,0,0,0,0,0,72,101,0,0,0,119,0,0,0,0,0,0])
.concat([0,0,0,0,96,101,0,0,240,118,0,0,0,0,0,0,0,0,0,0,128,101,0,0,248,118,0,0,0,0,0,0,0,0,0,0,160,101,0,0,0,0,0,0,192,101,0,0,0,0,0,0,224,101,0,0,0,0,0,0,0,102,0,0,48,90,0,0,32,102,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,200,120,0,0,2,0,0,0,48,90,0,0,64,102,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,200,120,0,0,2,0,0,0,48,90,0,0,96,102,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,200,120,0,0,2,0,0,0,48,90,0,0,128,102,0,0,0,0,0,0,2,0,0,0,40,118,0,0,2,0,0,0,200,120,0,0,2,0,0,0,0,0,0,0,160,102,0,0,0,0,0,0,184,102,0,0,0,0,0,0,208,102,0,0,0,0,0,0,232,102,0,0,240,118,0,0,0,0,0,0,0,0,0,0,0,103,0,0,248,118,0,0,0,0,0,0,0,0,0,0,24,103,0,0,16,125,0,0,0,0,0,0,0,0,0,0,48,103,0,0,208,121,0,0,0,0,0,0,0,0,0,0,72,103,0,0,208,121,0,0,0,0,0,0,0,0,0,0,96,103,0,0,0,0,0,0,120,103,0,0,0,0,0,0,160,103,0,0,0,0,0,0,200,103,0,0,0,0,0,0,240,103,0,0,0,0,0,0,72,104,0,0,0,0,0,0,104,104,0,0,16,121,0,0,0,0,0,0,0,0,0,0,128,104,0,0,16,121,0,0,0,0,0,0,48,90,0,0,152,104,0,0,0,0,0,0,2,0,0,0,104,126,0,0,2,0,0,0,16,126,0,0,2,36,0,0,0,0,0,0,176,104,0,0,104,126,0,0,0,0,0,0,0,0,0,0,200,104,0,0,208,121,0,0,0,0,0,0,0,0,0,0,224,104,0,0,104,126,0,0,0,0,0,0,0,0,0,0,248,104,0,0,0,0,0,0,16,105,0,0,16,121,0,0,0,0,0,0,0,0,0,0,32,105,0,0,104,126,0,0,0,0,0,0,0,0,0,0,48,105,0,0,96,121,0,0,0,0,0,0,0,0,0,0,64,105,0,0,96,121,0,0,0,0,0,0,0,0,0,0,80,105,0,0,160,124,0,0,0,0,0,0,0,0,0,0,96,105,0,0,16,121,0,0,0,0,0,0,0,0,0,0,112,105,0,0,16,121,0,0,0,0,0,0,0,0,0,0,128,105,0,0,104,126,0,0,0,0,0,0,0,0,0,0,144,105,0,0,96,121,0,0,0,0,0,0,0,0,0,0,160,105,0,0,104,126,0,0,0,0,0,0,0,0,0,0,176,105,0,0,16,121,0,0,0,0,0,0,0,0,0,0,192,105,0,0,104,126,0,0,0,0,0,0,0,0,0,0,208,105,0,0,16,121,0,0,0,0,0,0,0,0,0,0,224,105,0,0,176,124,0,0,0,0,0,0,0,0,0,0,240,105,0,0,224,124,0,0,0,0,0,0,0,0,0,0,0,106,0,0,96,121,0,0,0,0,0,0,0,0,0,0,16,106,0,0,0,0,0,0,32,106,0,0,104,126,0,0,0,0,0,0,48,90,0,0,48,106,0,0,0,0,0,0,2,0,0,0,16,121,0,0,2,0,0,0,0,126,0,0,2,28,0,0,0,0,0,0,64,106,0,0,32,125,0,0,0,0,0,0,0,0,0,0,80,106,0,0,104,126,0,0,0,0,0,0,48,90,0,0,96,106,0,0,0,0,0,0,2,0,0,0,104,126,0,0,2,0,0,0,48,126,0,0,2,36,0,0,0,0,0,0,112,106,0,0,0,125,0,0,0,0,0,0,0,0,0,0,128,106,0,0,96,121,0,0,0,0,0,0,0,0,0,0,144,106,0,0,96,121,0,0,0,0,0,0,0,0,0,0,160,106,0,0,16,121,0,0,0,0,0,0,0,0,0,0,176,106,0,0,104,126,0,0,0,0,0,0,0,0,0,0,208,106,0,0,112,124,0,0,0,0,0,0,0,0,0,0,240,106,0,0,104,126,0,0,0,0,0,0,0,0,0,0,16,107,0,0,112,124,0,0,0,0,0,0,0,0,0,0,48,107,0,0,112,124,0,0,0,0,0,0,0,0,0,0,80,107,0,0,112,124,0,0,0,0,0,0,0,0,0,0,112,107,0,0,192,124,0,0,0,0,0,0,48,90,0,0,144,107,0,0,0,0,0,0,2,0,0,0,176,121,0,0,2,0,0,0,40,126,0,0,2,32,0,0,0,0,0,0,176,107,0,0,104,126,0,0,0,0,0,0,0,0,0,0,208,107,0,0,104,126,0,0,0,0,0,0,0,0,0,0,240,107,0,0,112,124,0,0,0,0,0,0,0,0,0,0,16,108,0,0,176,121,0,0,0,0,0,0,0,0,0,0,48,108,0,0,104,122,0,0,0,0,0,0,0,0,0,0,80,108,0,0,176,121,0,0,0,0,0,0,0,0,0,0,112,108,0,0,176,121,0,0,0,0,0,0,0,0,0,0,144,108,0,0,112,124,0,0,0,0,0,0,0,0,0,0,176,108,0,0,48,121,0,0,0,0,0,0,0,0,0,0,216,108,0,0,48,121,0,0,0,0,0,0,0,0,0,0,0,109,0,0,48,121,0,0,0,0,0,0,0,0,0,0,56,109,0,0,48,121,0,0,0,0,0,0,0,0,0,0,104,109,0,0,56,121,0,0,0,0,0,0,0,0,0,0,160,109,0,0,64,121,0,0,0,0,0,0,0,0,0,0,224,109,0,0,72,121,0,0,0,0,0,0,0,0,0,0,24,110,0,0,80,121,0,0,0,0,0,0,0,0,0,0,128,110,0,0,88,121,0,0,0,0,0,0,0,0,0,0,176,110,0,0,112,124,0,0,0,0,0,0,48,90,0,0,200,110,0,0,0,0,0,0,2,0,0,0,104,122,0,0,2,0,0,0,48,126,0,0,2,40,0,0,48,90,0,0,224,110,0,0,0,0,0,0,2,0,0,0,176,121,0,0,2,0,0,0,32,126,0,0,2,32,0,0,0,0,0,0,248,110,0,0,208,124,0,0,0,0,0,0,0,0,0,0,16,111,0,0,104,126,0,0,0,0,0,0,0,0,0,0,40,111,0,0,240,124,0,0,0,0,0,0,48,90,0,0,64,111,0,0,0,0,0,0,2,0,0,0,104,126,0,0,2,0,0,0,24,126,0,0,2,36,0,0,0,0,0,0,88,111,0,0,96,121,0,0,0,0,0,0,0,0,0,0,112,111,0,0,16,121,0,0,0,0,0,0,0,0,0,0,136,111,0,0,16,121,0,0,0,0,0,0,0,0,0,0,160,111,0,0,0,0,0,0,200,111,0,0,0,0,0,0,240,111,0,0,0,0,0,0,24,112,0,0,0,0,0,0,80,112,0,0,0,0,0,0,128,112,0,0,0,0,0,0,176,112,0,0,48,90,0,0,216,112,0,0,0,0,0,0,2,0,0,0,208,121,0,0,2,0,0,0,8,126,0,0,2,28,0,0,0,0,0,0,240,112,0,0,96,121,0,0,0,0,0,0,0,0,0,0,8,113,0,0,208,121,0,0,0,0,0,0,0,0,0,0,32,113,0,0,96,121,0,0,0,0,0,0,0,0,0,0,56,113,0,0,16,121,0,0,0,0,0,0,0,0,0,0,80,113,0,0,248,126,0,0,0,0,0,0,0,0,0,0,120,113,0,0,232,126,0,0,0,0,0,0,0,0,0,0,160,113,0,0,232,126,0,0,0,0,0,0,0,0,0,0,200,113,0,0,216,126,0,0,0,0,0,0,0,0,0,0,240,113,0,0,248,126,0,0,0,0,0,0,0,0,0,0,24,114,0,0,248,126,0,0,0,0,0,0,0,0,0,0,64,114,0,0,120,114,0,0,0,0,0,0,8,90,0,0,104,114,0,0,64,0,0,0,0,0,0,0,160,119,0,0,16,2,0,0,6,1,0,0,192,255,255,255,192,255,255,255,160,119,0,0,30,2,0,0,168,0,0,0,108,0,0,0,0,0,0,0,160,119,0,0,16,2,0,0,6,1,0,0,148,255,255,255,148,255,255,255,160,119,0,0,30,2,0,0,168,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,64,0,0,0,0,0,0,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,96,109,64,0,0,0,0,0,224,106,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,106,64,0,0,0,0,0,0,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,128,107,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,108,64,0,0,0,0,0,128,104,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,96,109,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,64,97,64,0,0,0,0,0,128,69,64,0,0,0,0,0,64,108,64,0,0,0,0,0,160,100,64,0,0,0,0,0,0,69,64,0,0,0,0,0,0,69,64,0,0,0,0,0,192,107,64,0,0,0,0,0,0,103,64,0,0,0,0,0,224,96,64,0,0,0,0,0,192,87,64,0,0,0,0,0,192,99,64,0,0,0,0,0,0,100,64,0,0,0,0,0,192,95,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,106,64,0,0,0,0,0,64,90,64,0,0,0,0,0,0,62,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,0,0,84,64,0,0,0,0,0,0,89,64,0,0,0,0,0,160,98,64,0,0,0,0,0,160,109,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,111,64,0,0,0,0,0,128,107,64,0,0,0,0,0,128,107,64,0,0,0,0,0,0,52,64,0,0,0,0,0,0,78,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,96,97,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,103,64,0,0,0,0,0,192,96,64,0,0,0,0,0,0,38,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,89,64,0,0,0,0,0,0,0,0,0,0,0,0,0,160,103,64,0,0,0,0,0,224,102,64,0,0,0,0,0,192,90,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,96,97,64,0,0,0,0,0,64,85,64,0,0,0,0,0,192,90,64,0,0,0,0,0,128,71,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,32,99,64,0,0,0,0,0,0,73,64,0,0,0,0,0,128,105,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,109,64,0,0,0,0,0,192,98,64,0,0,0,0,0,128,94,64,0,0,0,0,0,224,97,64,0,0,0,0,0,128,103,64,0,0,0,0,0,224,97,64,0,0,0,0,0,0,82,64,0,0,0,0,0,128,78,64,0,0,0,0,0,96,97,64,0,0,0,0,0,128,71,64,0,0,0,0,0,192,83,64,0,0,0,0,0,192,83,64,0,0,0,0,0,128,71,64,0,0,0,0,0,192,83,64,0,0,0,0,0,192,83,64,0,0,0,0,0,0,0,0,0,0,0,0,0,192,105,64,0,0,0,0,0,32,106,64,0,0,0,0,0,128,98,64,0,0,0,0,0,0,0,0,0,0,0,0,0,96,106,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,52,64,0,0,0,0,0,96,98,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,103,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,0,62,64,0,0,0,0,0,0,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,102,64,0,0,0,0,0,0,65,64,0,0,0,0,0,0,65,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,0,65,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,65,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,128,107,64,0,0,0,0,0,128,107,64,0,0,0,0,0,128,107,64,0,0,0,0,0,0,111,64,0,0,0,0,0,0,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,106,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,107,64,0,0,0,0,0,160,100,64,0,0,0,0,0,0,64,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,160,101,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,71,64,0,0,0,0,0,0,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,90,64,0,0,0,0,0,128,102,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,87,64,0,0,0,0,0,0,87,64,0,0,0,0,0,192,82,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,96,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,0,110,64,0,0,0,0,0,192,108,64,0,0,0,0,0,128,97,64,0,0,0,0,0,192,108,64,0,0,0,0,0,192,108,64,0,0,0,0,0,64,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,0,95,64,0,0,0,0,0,128,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,160,105,64,0,0,0,0,0,160,101,64,0,0,0,0,0,0,107,64,0,0,0,0,0,192,108,64,0,0,0,0,0,0,110,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,108,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,64,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,0,98,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,102,64,0,0,0,0,0,32,104,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,100,64,0,0,0,0,0,128,94,64,0,0,0,0,0,0,64,64,0,0,0,0,0,64,102,64,0,0,0,0,0,64,101,64,0,0,0,0,0,224,96,64,0,0,0,0,0,192,105,64,0,0,0,0,0,64,111,64,0,0,0,0,0,192,93,64,0,0,0,0,0,0,97,64,0,0,0,0,0,32,99,64,0,0,0,0,0,192,93,64,0,0,0,0,0,0,97,64,0,0,0,0,0,32,99,64,0,0,0,0,0,0,102,64,0,0,0,0,0,128,104,64,0,0,0,0,0,192,107,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,108,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,73,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,192,108,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,89,64,0,0,0,0,0,160,105,64,0,0,0,0,0,64,101,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,105,64,0,0,0,0,0,64,103,64,0,0,0,0,0,64,85,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,98,64,0,0,0,0,0,0,92,64,0,0,0,0,0,0,107,64,0,0,0,0,0,0,78,64,0,0,0,0,0,96,102,64,0,0,0,0,0,64,92,64,0,0,0,0,0,192,94,64,0,0,0,0,0,0,90,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,111,64,0,0,0,0,0,64,99,64,0,0,0,0,0,0,82,64,0,0,0,0,0,32,106,64,0,0,0,0,0,128,105,64,0,0,0,0,0,224,104,64,0,0,0,0,0,0,53,64,0,0,0,0,0,160,96,64,0,0,0,0,0,0,57,64,0,0,0,0,0,0,57,64,0,0,0,0,0,0,92,64,0,0,0,0,0,160,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,108,64,0,0,0,0,0,32,108,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,108,64,0,0,0,0,0,160,102,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,107,64,0,0,0,0,0,160,101,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,160,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,192,108,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,192,90,64,0,0,0,0,0,192,97,64,0,0,0,0,0,128,65,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,100,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,64,81,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,107,64,0,0,0,0,0,0,92,64,0,0,0,0,0,192,106,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,109,64,0,0,0,0,0,64,101,64,0,0,0,0,0,0,99,64,0,0,0,0,0,96,111,64,0,0,0,0,0,0,99,64,0,0,0,0,0,224,101,64,0,0,0,0,0,192,109,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,107,64,0,0,0,0,0,0,92,64,0,0,0,0,0,96,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,109,64,0,0,0,0,0,160,106,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,107,64,0,0,0,0,0,32,103,64,0,0,0,0,0,160,105,64,0,0,0,0,0,160,96,64,0,0,0,0,0,128,79,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,104,64,0,0,0,0,0,96,105,64,0,0,0,0,0,160,107,64,0,0,0,0,0,0,100,64,0,0,0,0,0,160,107,64,0,0,0,0,0,0,102,64,0,0,0,0,0,0,108,64,0,0,0,0,0,192,108,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,103,64,0,0,0,0,0,224,97,64,0,0,0,0,0,224,97,64,0,0,0,0,0,64,80,64,0,0,0,0,0,64,90,64,0,0,0,0,0,32,108,64,0,0,0,0,0,96,97,64,0,0,0,0,0,64,81,64,0,0,0,0,0,0,51,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,96,64,0,0,0,0,0,128,92,64,0,0,0,0,0,128,110,64,0,0,0,0,0,128,100,64,0,0,0,0,0,0,88,64,0,0,0,0,0,0,71,64,0,0,0,0,0,96,97,64,0,0,0,0,0,192,85,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,100,64,0,0,0,0,0,128,84,64,0,0,0,0,0,128,70,64,0,0,0,0,0,0,104,64,0,0,0,0,0,0,104,64,0,0,0,0,0,0,104,64,0,0,0,0,0,224,96,64,0,0,0,0,0,192,105,64,0,0,0,0,0,96,109,64,0,0,0,0,0,128,90,64,0,0,0,0,0,128,86,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,92,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,98,64,0,0,0,0,0,0,92,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,0,128,81,64,0,0,0,0,0,64,96,64,0,0,0,0,0,128,102,64,0,0,0,0,0,64,106,64,0,0,0,0,0,128,102,64,0,0,0,0,0,128,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,107,64,0,0,0,0,0,224,103,64,0,0,0,0,0,0,107,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,88,64,0,0,0,0,0,192,81,64,0,0,0,0,0,0,80,64,0,0,0,0,0,0,108,64,0,0,0,0,0,0,106,64,0,0,0,0,0,192,109,64,0,0,0,0,0,64,96,64,0,0,0,0,0,192,109,64,0,0,0,0,0,160,110,64,0,0,0,0,0,192,107,64,0,0,0,0,0,96,102,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,99,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,73,64,0,0,0,0,0,254,175,64,56,6,0,0,0,0,0,0,16,13,0,0,0,0,0,0,184,0,0,0,0,0,0,0,64,40,0,0,0,0,0,0,176,5,0,0,0,0,0,0,208,22,0,0,0,0,0,0,96,47,0,0,0,0,0,0,120,0,0,0,0,0,0,0,176,33,0,0,0,0,0,0,0,6,0,0,0,0,0,0,32,39,0,0,0,0,0,0,168,49,0,0,0,0,0,0,184,12,0,0,0,0,0,0,232,40,0,0,0,0,0,0,224,2,0,0,0,0,0,0,200,45,0,0,0,0,0,0,80,38,0,0,0,0,0,0,160,4,0,0,0,0,0,0,168,3,0,0,0,0,0,0,0,33,0,0,0,0,0,0,224,35,0,0,0,0,0,0,96,5,0,0,0,0,0,0,48,45,0,0,0,0,0,0,0,21,0,0,0,0,0,0,248,7,0,0,0,0,0,0,160,7,0,0,0,0,0,0,96,16,0,0,0,0,0,0,232,19,0,0,0,0,0,0,232,17,0,0,0,0,0,0,112,12,0,0,0,0,0,0,232,11,0,0,0,0,0,0,168,31,0,0,0,0,0,0,80,7,0,0,0,0,0,0,152,14,0,0,0,0,0,0,120,24,0,0,0,0,0,0,176,23,0,0,0,0,0,0,80,46,0,0,0,0,0,0,200,28,0,0,0,0,0,0,64,9,0,0,0,0,0,0,120,10,0,0,0,0,0,0,240,29,0,0,0,0,0,0,72,44,0,0,0,0,0,0,24,24,0,0,0,0,0,0,144,46,0,0,0,0,0,0,216,24,0,0,0,0,0,0,192,20,0,0,0,0,0,0,32,14,0,0,0,0,0,0,176,47,0,0,0,0,0,0,136,22,0,0,0,0,0,0,208,21,0,0,0,0,0,0,40,27,0,0,0,0,0,0,72,21,0,0,0,0,0,0,192,48,0,0,0,0,0,0,24,48,0,0,0,0,0,0,8,43,0,0,0,0,0,0,128,3,0,0,0,0,0,0,96,23,0,0,0,0,0,0,184,25,0,0,0,0,0,0,32,50,0,0,0,0,0,0,64,119,104,105,108,101,0,0,239,187,191,0,0,0,0,0,247,100,76,0,0,0,0,0,64,109,105,120,105,110,0,0,64,109,101,100,105,97,0,0,102,97,108,115,101,0,0,0,64,119,97,114,110,0,0,0,116,114,117,101,0,0,0,0,14,254,255,0,0,0,0,0,111,110,108,121,0,0,0,0,110,117,108,108,0,0,0,0,102,114,111,109,0,0,0,0,101,118,101,110,0,0,0,0,64,101,108,115,101,0,0,0,46,46,46,0,0,0,0,0,64,101,97,99,104,0,0,0,99,97,108,99,40,0,0,0,117,114,108,40,0,0,0,0,111,100,100,0,0,0,0,0,110,111,116,0,0,0,0,0,64,102,111,114,0,0,0,0,97,110,100,0,0,0,0,0,116,111,0,0,0,0,0,0,125,0,0,0,0,0,0,0,111,114,0,0,0,0,0,0,105,110,0,0,0,0,0,0,64,105,102,0,0,0,0,0,33,61,0,0,0,0,0,0,60,61,0,0,0,0,0,0,62,61,0,0,0,0,0,0,60,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,61,61,0,0,0,0,0,0,105,102,0,0,0,0,0,0,232,3,0,0,0,0,0,0,45,119,101,98,107,105,116,45,99,97,108,99,40,0,0,0,32,9,13,10,12,0,0,0,221,115,102,115,0,0,0,0,58,110,111,116,40,0,0,0,101,120,112,114,101,115,115,105,111,110,0,0,0,0,0,0,255,254,0,0,0,0,0,0,0,0,254,255,0,0,0,0,255,254,0,0,0,0,0,0,254,255,0,0,0,0,0,0,105,109,112,111,114,116,97,110,116,0,0,0,0,0,0,0,45,109,111,122,45,99,97,108,99,40,0,0,0,0,0,0,132,49,149,51,0,0,0,0,64,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,32,45,126,0,0,0,0,0,36,61,0,0,0,0,0,0,43,47,118,56,45,0,0,0,43,47,118,47,0,0,0,0,43,47,118,43,0,0,0,0,43,47,118,57,0,0,0,0,43,47,118,56,0,0,0,0,126,61,0,0,0,0,0,0,116,104,114,111,117,103,104,0,47,47,0,0,0,0,0,0,64,105,110,99,108,117,100,101,0,0,0,0,0,0,0,0,35,123,0,0,0,0,0,0,100,101,102,97,117,108,116,0,64,99,111,110,116,101,110,116,0,0,0,0,0,0,0,0,64,99,104,97,114,115,101,116,0,0,0,0,0,0,0,0,94,61,0,0,0,0,0,0,42,47,0,0,0,0,0,0,42,61,0,0,0,0,0,0,47,42,0,0,0,0,0,0,45,43,0,0,0,0,0,0,64,114,101,116,117,114,110,0,112,114,111,103,105,100,0,0,124,61,0,0,0,0,0,0,64,105,109,112,111,114,116,0,64,101,120,116,101,110,100,0,251,238,40,0,0,0,0,0,88,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,6,0,0,0,10,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,82,184,30,133,235,81,4,64,0,0,0,0,0,0,24,64,102,102,102,102,102,102,57,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,88,64,76,38,147,201,100,50,217,63,0,0,0,0,0,0,240,63,185,92,46,151,203,229,2,64,0,0,0,0,0,0,36,64,22,139,197,98,177,88,60,64,185,92,46,151,203,229,66,64,85,85,85,85,85,85,197,63,24,75,126,177,228,23,219,63,0,0,0,0,0,0,240,63,239,238,238,238,238,238,16,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,48,64,10,133,66,161,80,40,164,63,154,153,153,153,153,153,185,63,144,199,227,241,120,60,206,63,0,0,0,0,0,0,240,63,172,213,106,181,90,173,6,64,144,199,227,241,120,60,14,64,28,199,113,28,199,113,140,63,101,135,169,203,237,15,162,63,85,85,85,85,85,85,181,63,62,233,147,62,233,147,214,63,0,0,0,0,0,0,240,63,85,85,85,85,85,85,245,63,85,85,85,85,85,85,133,63,24,75,126,177,228,23,155,63,0,0,0,0,0,0,176,63,239,238,238,238,238,238,208,63,0,0,0,0,0,0,232,63,0,0,0,0,0,0,240,63,16,34,0,0,56,44,0,0,136,35,0,0,128,28,0,0,152,22,0,0,112,18,0,0,160,12,0,0,184,7,0,0,104,4,0,0,192,1,0,0,64,51,0,0,168,47,0,0,248,44,0,0,216,42,0,0,232,41,0,0,184,40,0,0,48,40,0,0,16,39,0,0,176,38,0,0,16,38,0,0,120,37,0,0,48,37,0,0,208,35,0,0,112,35,0,0,8,35,0,0,136,34,0,0,160,33,0,0,48,33,0,0,192,32,0,0,16,32,0,0,64,31,0,0,168,30,0,0,120,29,0,0,112,28,0,0,160,27,0,0,208,26,0,0,224,25,0,0,40,25,0,0,160,24,0,0,72,24,0,0,200,23,0,0,120,23,0,0,16,23,0,0,160,22,0,0,80,22,0,0,40,22,0,0,240,21,0,0,104,21,0,0,32,21,0,0,224,20,0,0,112,20,0,0,208,19,0,0,0,19,0,0,120,18,0,0,168,17,0,0,48,17,0,0,240,16,0,0,232,15,0,0,72,15,0,0,200,14,0,0,80,14,0,0,232,13,0,0,104,13,0,0,168,12,0,0,48,12,0,0,168,11,0,0,48,11,0,0,192,10,0,0,56,10,0,0,184,9,0,0,224,8,0,0,168,8,0,0,72,8,0,0,208,7,0,0,120,7,0,0,40,7,0,0,248,6,0,0,160,6,0,0,88,6,0,0,32,6,0,0,208,5,0,0,144,5,0,0,232,4,0,0,136,4,0,0,88,4,0,0,64,4,0,0,40,4,0,0,208,3,0,0,152,3,0,0,112,3,0,0,0,3,0,0,208,2,0,0,104,2,0,0,240,1,0,0,176,1,0,0,128,1,0,0,80,1,0,0,8,1,0,0,168,0,0,0,104,0,0,0,248,51,0,0,224,51,0,0,176,51,0,0,96,51,0,0,48,51,0,0,24,51,0,0,232,50,0,0,152,50,0,0,16,50,0,0,224,49,0,0,72,49,0,0,0,49,0,0,152,48,0,0,192,47,0,0,160,47,0,0,128,47,0,0,88,47,0,0,240,46,0,0,136,46,0,0,72,46,0,0,0,46,0,0,224,45,0,0,136,45,0,0,32,45,0,0,232,44,0,0,184,44,0,0,144,44,0,0,248,43,0,0,232,43,0,0,200,43,0,0,152,43,0,0,128,43,0,0,72,43,0,0,0,43,0,0,200,42,0,0,176,42,0,0,160,42,0,0,144,42,0,0,120,42,0,0,112,42,0,0,88,42,0,0,80,42,0,0,64,42,0,0,8,42,0,0,248,41,0,0,224,41,0,0,208,41,0,0,0,0,0,0])
, "i8", ALLOC_NONE, Runtime.GLOBAL_BASE)
var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);
assert(tempDoublePtr % 8 == 0);
function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
}
function copyTempDouble(ptr) {
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];
  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];
  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];
  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];
}
  function ___gxx_personality_v0() {
    }
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }function __ZSt9terminatev() {
      _exit(-1234);
    }
  function ___cxa_bad_typeid() {
  Module['printErr']('missing function: __cxa_bad_typeid'); abort(-1);
  }
  function ___cxa_pure_virtual() {
      ABORT = true;
      throw 'Pure virtual function called!';
    }
  function ___cxa_call_unexpected(exception) {
      Module.printErr('Unexpected exception thrown, this is not properly supported - aborting');
      ABORT = true;
      throw exception;
    }
  Module["_memcpy"] = _memcpy;var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;
  function ___cxa_allocate_exception(size) {
      return _malloc(size);
    }
  function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr);
      } catch(e) { // XXX FIXME
      }
    }
  function _llvm_eh_exception() {
      return HEAP32[((_llvm_eh_exception.buf)>>2)];
    }
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  function ___resumeException(ptr) {
      if (HEAP32[((_llvm_eh_exception.buf)>>2)] == 0) HEAP32[((_llvm_eh_exception.buf)>>2)]=ptr;
      throw ptr;;
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = HEAP32[((_llvm_eh_exception.buf)>>2)];
      if (throwntype == -1) throwntype = HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      HEAP32[((_llvm_eh_exception.buf)>>2)]=ptr
      HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)]=type
      HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)]=destructor
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr;;
    }
  Module["_memmove"] = _memmove;var _llvm_memmove_p0i8_p0i8_i32=_memmove;
  Module["_memcmp"] = _memcmp;
  var _llvm_memcpy_p0i8_p0i8_i64=_memcpy;
  function _llvm_lifetime_start() {}
  function _llvm_lifetime_end() {}
  function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      return ptr;
    }
  function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Clear type.
      HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)]=0
      // Call destructor if one is registered then clear it.
      var ptr = HEAP32[((_llvm_eh_exception.buf)>>2)];
      var destructor = HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)];
      if (destructor) {
        Runtime.dynCall('vi', destructor, [ptr]);
        HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)]=0
      }
      // Free ptr if it isn't null.
      if (ptr) {
        ___cxa_free_exception(ptr);
        HEAP32[((_llvm_eh_exception.buf)>>2)]=0
      }
    }
  Module["_memset"] = _memset;var _llvm_memset_p0i8_i32=_memset;
  Module["_strlen"] = _strlen;
  var _llvm_memset_p0i8_i64=_memset;
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value
      return value;
    }
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 0777, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 0777 | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },reconcile:function (src, dst, callback) {
        var total = 0;
        var create = {};
        for (var key in src.files) {
          if (!src.files.hasOwnProperty(key)) continue;
          var e = src.files[key];
          var e2 = dst.files[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create[key] = e;
            total++;
          }
        }
        var remove = {};
        for (var key in dst.files) {
          if (!dst.files.hasOwnProperty(key)) continue;
          var e = dst.files[key];
          var e2 = src.files[key];
          if (!e2) {
            remove[key] = e;
            total++;
          }
        }
        if (!total) {
          // early out
          return callback(null);
        }
        var completed = 0;
        function done(err) {
          if (err) return callback(err);
          if (++completed >= total) {
            return callback(null);
          }
        };
        // create a single transaction to handle and IDB reads / writes we'll need to do
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        transaction.onerror = function transaction_onerror() { callback(this.error); };
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
        for (var path in create) {
          if (!create.hasOwnProperty(path)) continue;
          var entry = create[path];
          if (dst.type === 'local') {
            // save file to local
            try {
              if (FS.isDir(entry.mode)) {
                FS.mkdir(path, entry.mode);
              } else if (FS.isFile(entry.mode)) {
                var stream = FS.open(path, 'w+', 0666);
                FS.write(stream, entry.contents, 0, entry.contents.length, 0, true /* canOwn */);
                FS.close(stream);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // save file to IDB
            var req = store.put(entry, path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
        for (var path in remove) {
          if (!remove.hasOwnProperty(path)) continue;
          var entry = remove[path];
          if (dst.type === 'local') {
            // delete file from local
            try {
              if (FS.isDir(entry.mode)) {
                // TODO recursive delete?
                FS.rmdir(path);
              } else if (FS.isFile(entry.mode)) {
                FS.unlink(path);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // delete file from IDB
            var req = store.delete(path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
      },getLocalSet:function (mount, callback) {
        var files = {};
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
        var check = FS.readdir(mount.mountpoint)
          .filter(isRealDir)
          .map(toAbsolute(mount.mountpoint));
        while (check.length) {
          var path = check.pop();
          var stat, node;
          try {
            var lookup = FS.lookupPath(path);
            node = lookup.node;
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path)
              .filter(isRealDir)
              .map(toAbsolute(path)));
            files[path] = { mode: stat.mode, timestamp: stat.mtime };
          } else if (FS.isFile(stat.mode)) {
            files[path] = { contents: node.contents, mode: stat.mode, timestamp: stat.mtime };
          } else {
            return callback(new Error('node type not supported'));
          }
        }
        return callback(null, { type: 'local', files: files });
      },getDB:function (name, callback) {
        // look it up in the cache
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        req.onupgradeneeded = function req_onupgradeneeded() {
          db = req.result;
          db.createObjectStore(IDBFS.DB_STORE_NAME);
        };
        req.onsuccess = function req_onsuccess() {
          db = req.result;
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function req_onerror() {
          callback(this.error);
        };
      },getRemoteSet:function (mount, callback) {
        var files = {};
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function transaction_onerror() { callback(this.error); };
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          store.openCursor().onsuccess = function store_openCursor_onsuccess(event) {
            var cursor = event.target.result;
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, files: files });
            }
            files[cursor.key] = cursor.value;
            cursor.continue();
          };
        });
      }};
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.position = position;
          return position;
        }}};
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[null],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || { recurse_count: 0 };
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
        // start at the root
        var current = FS.root;
        var current_path = '/';
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            current = current.mount.root;
          }
          // follow symlinks
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
            this.parent = null;
            this.mount = null;
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            FS.hashAddNode(this);
          };
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
          FS.FSNode.prototype = {};
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
        return new FS.FSNode(parent, name, mode, rdev);
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 1;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
        var completed = 0;
        var total = FS.mounts.length;
        function done(err) {
          if (err) {
            return callback(err);
          }
          if (++completed >= total) {
            callback(null);
          }
        };
        // sync all mounts
        for (var i = 0; i < FS.mounts.length; i++) {
          var mount = FS.mounts[i];
          if (!mount.type.syncfs) {
            done(null);
            continue;
          }
          mount.type.syncfs(mount, populate, done);
        }
      },mount:function (type, opts, mountpoint) {
        var lookup;
        if (mountpoint) {
          lookup = FS.lookupPath(mountpoint, { follow: false });
          mountpoint = lookup.path;  // use the absolute path
        }
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          root: null
        };
        // create a root node for the fs
        var root = type.mount(mount);
        root.mount = mount;
        mount.root = root;
        // assign the mount info to the mountpoint's node
        if (lookup) {
          lookup.node.mount = mount;
          lookup.node.mounted = true;
          // compatibility update FS.root if we mount to /
          if (mountpoint === '/') {
            FS.root = mount.root;
          }
        }
        // add to our cached list of mounts
        FS.mounts.push(mount);
        return root;
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 0666;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 0777;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 0666;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path, { follow: false });
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 0666 : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0);
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=stdin.fd;
        assert(stdin.fd === 1, 'invalid handle for stdin (' + stdin.fd + ')');
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=stdout.fd;
        assert(stdout.fd === 2, 'invalid handle for stdout (' + stdout.fd + ')');
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=stderr.fd;
        assert(stderr.fd === 3, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
          this.stack = stackTrace();
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
        FS.nameTable = new Array(4096);
        FS.root = FS.createNode(null, '/', 16384 | 0777, 0);
        FS.mount(MEMFS, {}, '/');
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
        FS.ensureErrnoError();
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
              if (!hasByteServing) chunkSize = datalength;
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};function _getcwd(buf, size) {
      // char *getcwd(char *buf, size_t size);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/getcwd.html
      if (size == 0) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var cwd = FS.cwd();
      if (size < cwd.length + 1) {
        ___setErrNo(ERRNO_CODES.ERANGE);
        return 0;
      } else {
        writeAsciiToMemory(cwd, buf);
        return buf;
      }
    }
  Module["_strcpy"] = _strcpy;
  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }
  function _fmod(x, y) {
      return x % y;
    }
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
      // Apply sign.
      ret *= multiplier;
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str
      }
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }
  var _llvm_memmove_p0i8_p0i8_i64=_memmove;
  Module["_tolower"] = _tolower;
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode
        HEAP32[(((buf)+(16))>>2)]=stat.nlink
        HEAP32[(((buf)+(20))>>2)]=stat.uid
        HEAP32[(((buf)+(24))>>2)]=stat.gid
        HEAP32[(((buf)+(28))>>2)]=stat.rdev
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size
        HEAP32[(((buf)+(40))>>2)]=4096
        HEAP32[(((buf)+(44))>>2)]=stat.blocks
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000)
        HEAP32[(((buf)+(52))>>2)]=0
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000)
        HEAP32[(((buf)+(60))>>2)]=0
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000)
        HEAP32[(((buf)+(68))>>2)]=0
        HEAP32[(((buf)+(72))>>2)]=stat.ino
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      _fsync(stream);
      return _close(stream);
    }
  var _mkport=undefined;var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 0777, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var bytesWritten = _write(stream, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStream(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStream(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop()
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(stream, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var ret = _lseek(stream, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStream(stream);
      stream.eof = false;
      return 0;
    }var _fseeko=_fseek;
  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStream(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }var _ftello=_ftell;
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var ret = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return (ret == -1) ? 0 : ret;
    }
  var _floor=Math_floor;
  function _toupper(chr) {
      if (chr >= 97 && chr <= 122) {
        return chr - 97 + 65;
      } else {
        return chr;
      }
    }
  var _ceil=Math_ceil;
  var _fabs=Math_abs;
  function _llvm_eh_typeid_for(type) {
      return type;
    }
  function _isalpha(chr) {
      return (chr >= 97 && chr <= 122) ||
             (chr >= 65 && chr <= 90);
    }
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }
  function _isalnum(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 122) ||
             (chr >= 65 && chr <= 90);
    }
  function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      throw HEAP32[((_llvm_eh_exception.buf)>>2)];;
    }
  function _memchr(ptr, chr, num) {
      chr = unSign(chr);
      for (var i = 0; i < num; i++) {
        if (HEAP8[(ptr)] == chr) return ptr;
        ptr++;
      }
      return 0;
    }
  function _pthread_mutex_lock() {}
  function _pthread_mutex_unlock() {}
  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }
  function ___cxa_guard_release() {}
  function _pthread_cond_broadcast() {
      return 0;
    }
  function _pthread_cond_wait() {
      return 0;
    }
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStream(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }
  function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStream(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }var _getc=_fgetc;
  function ___errno_location() {
      return ___errno_state;
    }
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  function _abort() {
      Module['abort']();
    }
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = HEAPF64[(((varargs)+(argIndex))>>3)];
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+8))>>2)]];
          argIndex += 8; // each 32-bit chunk is in a 64-bit block
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Math.max(Runtime.getNativeFieldSize(type), Runtime.getAlignSize(type, null, true));
        return ret;
      }
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
          // Handle precision.
          var precisionSet = false;
          if (next == 46) {
            var precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          } else {
            var precision = 6; // Standard default.
          }
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }
  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }
  function ___cxa_guard_abort() {}
  var _isxdigit_l=_isxdigit;
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }var _isdigit_l=_isdigit;
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16)
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text)
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text)
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j]
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }
  function _catopen() { throw 'TODO: ' + aborter }
  function _catgets() { throw 'TODO: ' + aborter }
  function _catclose() { throw 'TODO: ' + aborter }
  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }
  function _freelocale(locale) {
      _free(locale);
    }
  function _isascii(chr) {
      return chr >= 0 && (chr & 0x80) == 0;
    }
  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i]
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i]
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i]
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
      var pattern = Pointer_stringify(format);
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }var _strftime_l=_strftime;
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str
      }
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }var _strtoull_l=_strtoull;
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }var _strtoll_l=_strtoll;
  function _uselocale(locale) {
      return 0;
    }
  var _llvm_va_start=undefined;
  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }
  function _llvm_va_end() {}
  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }
  function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }
  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }
  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret
      }
      return ret;
    }
  var Browser={mainLoop:{scheduler:null,shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
        // Canvas event setup
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
            var errorInfo = '?';
            function onContextCreationError(event) {
              errorInfo = event.statusMessage || errorInfo;
            }
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (window.scrollX + rect.left);
              y = t.pageY - (window.scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (window.scrollX + rect.left);
            y = event.pageY - (window.scrollY + rect.top);
          }
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};
_llvm_eh_exception.buf = allocate(12, "void*", ALLOC_STATIC);
FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require('graceful-fs'); NODEFS.staticInit(); }
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
staticSealed = true; // seal the static portion of memory
STACK_MAX = STACK_BASE + 5242880;
DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);
assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");
 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);
var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iddddiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iddddiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) {
  try {
    return Module["dynCall_iiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vidi(index,a1,a2,a3) {
  try {
    Module["dynCall_vidi"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15) {
  try {
    Module["dynCall_viiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_ddd(index,a1,a2) {
  try {
    return Module["dynCall_ddd"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_fiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_fiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiidi(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiidi"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_diii(index,a1,a2,a3) {
  try {
    return Module["dynCall_diii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.__ZTVN10__cxxabiv117__class_type_infoE|0;var p=env.___fsmu8|0;var q=env.__ZTIc|0;var r=env._stdout|0;var s=env.__ZTVN10__cxxabiv119__pointer_type_infoE|0;var t=env.___dso_handle|0;var u=env._stdin|0;var v=env.__ZTVN10__cxxabiv120__si_class_type_infoE|0;var w=env._stderr|0;var x=+env.NaN;var y=+env.Infinity;var z=0;var A=0;var B=0;var C=0;var D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0.0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=0;var U=0;var V=0;var W=global.Math.floor;var X=global.Math.abs;var Y=global.Math.sqrt;var Z=global.Math.pow;var _=global.Math.cos;var $=global.Math.sin;var aa=global.Math.tan;var ab=global.Math.acos;var ac=global.Math.asin;var ad=global.Math.atan;var ae=global.Math.atan2;var af=global.Math.exp;var ag=global.Math.log;var ah=global.Math.ceil;var ai=global.Math.imul;var aj=env.abort;var ak=env.assert;var al=env.asmPrintInt;var am=env.asmPrintFloat;var an=env.min;var ao=env.invoke_iiiiiiii;var ap=env.invoke_iiiiiiddi;var aq=env.invoke_viiiii;var ar=env.invoke_vi;var as=env.invoke_vii;var at=env.invoke_iiiiiii;var au=env.invoke_ii;var av=env.invoke_viiiddddi;var aw=env.invoke_iddddiii;var ax=env.invoke_iiiiiiiiiiii;var ay=env.invoke_vidi;var az=env.invoke_iiii;var aA=env.invoke_viiiiiiiiiiiiiii;var aB=env.invoke_viiiiid;var aC=env.invoke_viiiiiiii;var aD=env.invoke_viiiiii;var aE=env.invoke_ddd;var aF=env.invoke_fiii;var aG=env.invoke_viiidi;var aH=env.invoke_iid;var aI=env.invoke_viiiiiii;var aJ=env.invoke_viiiiiid;var aK=env.invoke_viiiiiiiii;var aL=env.invoke_viiiiiiiiii;var aM=env.invoke_iii;var aN=env.invoke_diii;var aO=env.invoke_dii;var aP=env.invoke_i;var aQ=env.invoke_iiiiii;var aR=env.invoke_viii;var aS=env.invoke_v;var aT=env.invoke_iiiiiiiii;var aU=env.invoke_iiiii;var aV=env.invoke_viiii;var aW=env._llvm_lifetime_end;var aX=env._lseek;var aY=env.__scanString;var aZ=env._fclose;var a_=env._pthread_mutex_lock;var a$=env.___cxa_end_catch;var a0=env._strtoull;var a1=env._fflush;var a2=env._strtol;var a3=env.__isLeapYear;var a4=env._fwrite;var a5=env._send;var a6=env._isspace;var a7=env._read;var a8=env._ceil;var a9=env._fsync;var ba=env.___cxa_guard_abort;var bb=env._newlocale;var bc=env.___gxx_personality_v0;var bd=env._pthread_cond_wait;var be=env.___cxa_rethrow;var bf=env._fmod;var bg=env.___resumeException;var bh=env._memchr;var bi=env._llvm_va_end;var bj=env._vsscanf;var bk=env._snprintf;var bl=env._fgetc;var bm=env.__getFloat;var bn=env._atexit;var bo=env.___cxa_free_exception;var bp=env._close;var bq=env.___setErrNo;var br=env._isxdigit;var bs=env._ftell;var bt=env._exit;var bu=env._sprintf;var bv=env._asprintf;var bw=env.___ctype_b_loc;var bx=env._freelocale;var by=env._catgets;var bz=env.___cxa_is_number_type;var bA=env._getcwd;var bB=env.___cxa_does_inherit;var bC=env.___cxa_guard_acquire;var bD=env.___cxa_begin_catch;var bE=env._recv;var bF=env.__parseInt64;var bG=env.__ZSt18uncaught_exceptionv;var bH=env.___cxa_call_unexpected;var bI=env.__exit;var bJ=env._strftime;var bK=env.___cxa_throw;var bL=env._llvm_eh_exception;var bM=env._toupper;var bN=env._pread;var bO=env._fopen;var bP=env._open;var bQ=env.__arraySum;var bR=env._isalnum;var bS=env._isalpha;var bT=env.___cxa_find_matching_catch;var bU=env._strdup;var bV=env.__formatString;var bW=env._pthread_cond_broadcast;var bX=env.__ZSt9terminatev;var bY=env._isascii;var bZ=env._pthread_mutex_unlock;var b_=env._sbrk;var b$=env.___errno_location;var b0=env._strerror;var b1=env._catclose;var b2=env._llvm_lifetime_start;var b3=env.__parseInt;var b4=env.___cxa_guard_release;var b5=env._ungetc;var b6=env._uselocale;var b7=env._vsnprintf;var b8=env._sscanf;var b9=env._sysconf;var ca=env._fread;var cb=env._abort;var cc=env._isdigit;var cd=env._strtoll;var ce=env.__addDays;var cf=env._fabs;var cg=env._floor;var ch=env.__reallyNegative;var ci=env._fseek;var cj=env.___cxa_bad_typeid;var ck=env._write;var cl=env.___cxa_allocate_exception;var cm=env._stat;var cn=env.___cxa_pure_virtual;var co=env._vasprintf;var cp=env._catopen;var cq=env.___ctype_toupper_loc;var cr=env.___ctype_tolower_loc;var cs=env._llvm_eh_typeid_for;var ct=env._pwrite;var cu=env._strerror_r;var cv=env._time;var cw=0.0;
// EMSCRIPTEN_START_FUNCS
function Gc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;Gy(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!z){K=J}else{z=0;L=35;break L12}}else{K=c[I>>2]|0}if((K|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){L=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!z){P=O}else{z=0;L=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;L=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((L|0)==22){L=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}z=0;aR(88,o|0,V<<1|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,X|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){Y=x}else{Y=c[y>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){$=_}else{z=0;L=35;break}}else{$=c[J>>2]|0}if((Gu($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;z=0,au(O|0,H|0)|0;if(!z){F=Z;G=H;continue}else{z=0;L=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((L|0)==35){G=bT(-1,-1)|0;aa=M;ab=G;Eb(o);Eb(n);bg(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(42,S|0,c[q>>2]|0,j|0,v|0)|0);if(z){z=0;break}c[k>>2]=F;Io(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{F=c[H+12>>2]|0;if((F|0)==(c[H+16>>2]|0)){G=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){ae=G}else{z=0;break L6}}else{ae=c[F>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){L=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){F=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!z){af=F}else{z=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;L=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);do{if((L|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;aa=M;ab=e;Eb(o);Eb(n);bg(ab|0)}function Gd(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Ge(a,0,j,k,f,g,h);i=b;return}function Ge(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;Gy(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!z){K=J}else{z=0;L=35;break L12}}else{K=c[I>>2]|0}if((K|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){L=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!z){P=O}else{z=0;L=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;L=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((L|0)==22){L=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}z=0;aR(88,o|0,V<<1|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,X|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){Y=x}else{Y=c[y>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){$=_}else{z=0;L=35;break}}else{$=c[J>>2]|0}if((Gu($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;z=0,au(O|0,H|0)|0;if(!z){F=Z;G=H;continue}else{z=0;L=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((L|0)==35){G=bT(-1,-1)|0;aa=M;ab=G;Eb(o);Eb(n);bg(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(6,S|0,c[q>>2]|0,j|0,v|0)|0);G=M;if(z){z=0;break}c[k>>2]=F;c[k+4>>2]=G;Io(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{G=c[H+12>>2]|0;if((G|0)==(c[H+16>>2]|0)){F=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){ae=F}else{z=0;break L6}}else{ae=c[G>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){L=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){G=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!z){af=G}else{z=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;L=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);do{if((L|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;aa=M;ab=e;Eb(o);Eb(n);bg(ab|0)}function Gf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Gg(a,0,j,k,f,g,h);i=b;return}function Gg(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0;f=i;i=i+144|0;m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=f|0;n=f+104|0;o=f+112|0;p=f+128|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=c[j+4>>2]&74;if((v|0)==64){w=8}else if((v|0)==0){w=0}else if((v|0)==8){w=16}else{w=10}v=m|0;Gy(o,j,v,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L6:do{if(!z){if((a[q]&1)==0){m=j+1|0;x=m;y=m;A=p+8|0}else{m=p+8|0;x=c[m>>2]|0;y=j+1|0;A=m}c[r>>2]=x;m=s|0;c[t>>2]=m;c[u>>2]=0;B=g|0;C=h|0;D=p|0;E=p+4|0;F=c[n>>2]|0;G=x;H=c[B>>2]|0;L12:while(1){do{if((H|0)==0){I=0}else{J=c[H+12>>2]|0;if((J|0)==(c[H+16>>2]|0)){K=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){L=K}else{z=0;N=35;break L12}}else{L=c[J>>2]|0}if((L|0)!=-1){I=H;break}c[B>>2]=0;I=0}}while(0);O=(I|0)==0;J=c[C>>2]|0;do{if((J|0)==0){N=22}else{K=c[J+12>>2]|0;if((K|0)==(c[J+16>>2]|0)){P=(z=0,au(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!z){Q=P}else{z=0;N=35;break L12}}else{Q=c[K>>2]|0}if((Q|0)==-1){c[C>>2]=0;N=22;break}else{K=(J|0)==0;if(O^K){R=J;S=K;break}else{T=G;U=J;V=K;break L12}}}}while(0);if((N|0)==22){N=0;if(O){T=G;U=0;V=1;break}else{R=0;S=1}}J=d[q]|0;K=(J&1|0)==0;if(((c[r>>2]|0)-G|0)==((K?J>>>1:c[E>>2]|0)|0)){if(K){W=J>>>1;X=J>>>1}else{J=c[E>>2]|0;W=J;X=J}z=0;aR(88,p|0,W<<1|0,0);if(z){z=0;N=35;break}if((a[q]&1)==0){Y=10}else{Y=(c[D>>2]&-2)-1|0}z=0;aR(88,p|0,Y|0,0);if(z){z=0;N=35;break}if((a[q]&1)==0){Z=y}else{Z=c[A>>2]|0}c[r>>2]=Z+X;_=Z}else{_=G}J=I+12|0;K=c[J>>2]|0;P=I+16|0;if((K|0)==(c[P>>2]|0)){$=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!z){aa=$}else{z=0;N=35;break}}else{aa=c[K>>2]|0}if((Gu(aa,w,_,r,u,F,o,m,t,v)|0)!=0){T=_;U=R;V=S;break}K=c[J>>2]|0;if((K|0)==(c[P>>2]|0)){P=c[(c[I>>2]|0)+40>>2]|0;z=0,au(P|0,I|0)|0;if(!z){G=_;H=I;continue}else{z=0;N=35;break}}else{c[J>>2]=K+4;G=_;H=I;continue}}if((N|0)==35){H=bT(-1,-1)|0;ab=M;ac=H;Eb(p);Eb(o);bg(ac|0)}H=d[o]|0;if((H&1|0)==0){ad=H>>>1}else{ad=c[o+4>>2]|0}do{if((ad|0)!=0){H=c[t>>2]|0;if((H-s|0)>=160){break}G=c[u>>2]|0;c[t>>2]=H+4;c[H>>2]=G}}while(0);G=(z=0,aU(8,T|0,c[r>>2]|0,k|0,w|0)|0);if(z){z=0;break}b[l>>1]=G;Io(o,m,c[t>>2]|0,k);do{if(O){ae=0}else{G=c[I+12>>2]|0;if((G|0)==(c[I+16>>2]|0)){H=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!z){af=H}else{z=0;break L6}}else{af=c[G>>2]|0}if((af|0)!=-1){ae=I;break}c[B>>2]=0;ae=0}}while(0);B=(ae|0)==0;do{if(V){N=64}else{m=c[U+12>>2]|0;if((m|0)==(c[U+16>>2]|0)){G=(z=0,au(c[(c[U>>2]|0)+36>>2]|0,U|0)|0);if(!z){ag=G}else{z=0;break L6}}else{ag=c[m>>2]|0}if((ag|0)==-1){c[C>>2]=0;N=64;break}if(!(B^(U|0)==0)){break}ah=e|0;c[ah>>2]=ae;Eb(p);Eb(o);i=f;return}}while(0);do{if((N|0)==64){if(B){break}ah=e|0;c[ah>>2]=ae;Eb(p);Eb(o);i=f;return}}while(0);c[k>>2]=c[k>>2]|2;ah=e|0;c[ah>>2]=ae;Eb(p);Eb(o);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;ab=M;ac=f;Eb(p);Eb(o);bg(ac|0)}function Gh(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Gi(a,0,j,k,f,g,h);i=b;return}function Gi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;Gy(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!z){K=J}else{z=0;L=35;break L12}}else{K=c[I>>2]|0}if((K|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){L=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!z){P=O}else{z=0;L=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;L=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((L|0)==22){L=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}z=0;aR(88,o|0,V<<1|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,X|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){Y=x}else{Y=c[y>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){$=_}else{z=0;L=35;break}}else{$=c[J>>2]|0}if((Gu($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;z=0,au(O|0,H|0)|0;if(!z){F=Z;G=H;continue}else{z=0;L=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((L|0)==35){G=bT(-1,-1)|0;aa=M;ab=G;Eb(o);Eb(n);bg(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(4,S|0,c[q>>2]|0,j|0,v|0)|0);if(z){z=0;break}c[k>>2]=F;Io(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{F=c[H+12>>2]|0;if((F|0)==(c[H+16>>2]|0)){G=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){ae=G}else{z=0;break L6}}else{ae=c[F>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){L=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){F=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!z){af=F}else{z=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;L=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);do{if((L|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;aa=M;ab=e;Eb(o);Eb(n);bg(ab|0)}function Gj(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Gk(a,0,j,k,f,g,h);i=b;return}function Gk(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;Gy(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!z){K=J}else{z=0;L=35;break L12}}else{K=c[I>>2]|0}if((K|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){L=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!z){P=O}else{z=0;L=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;L=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((L|0)==22){L=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}z=0;aR(88,o|0,V<<1|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,X|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){Y=x}else{Y=c[y>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){$=_}else{z=0;L=35;break}}else{$=c[J>>2]|0}if((Gu($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;z=0,au(O|0,H|0)|0;if(!z){F=Z;G=H;continue}else{z=0;L=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((L|0)==35){G=bT(-1,-1)|0;aa=M;ab=G;Eb(o);Eb(n);bg(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(30,S|0,c[q>>2]|0,j|0,v|0)|0);if(z){z=0;break}c[k>>2]=F;Io(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{F=c[H+12>>2]|0;if((F|0)==(c[H+16>>2]|0)){G=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){ae=G}else{z=0;break L6}}else{ae=c[F>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){L=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){F=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!z){af=F}else{z=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;L=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);do{if((L|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;aa=M;ab=e;Eb(o);Eb(n);bg(ab|0)}function Gl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Gm(a,0,j,k,f,g,h);i=b;return}function Gm(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;Gy(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!z){K=J}else{z=0;L=35;break L12}}else{K=c[I>>2]|0}if((K|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){L=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!z){P=O}else{z=0;L=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;L=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((L|0)==22){L=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}z=0;aR(88,o|0,V<<1|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,X|0,0);if(z){z=0;L=35;break}if((a[p]&1)==0){Y=x}else{Y=c[y>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){$=_}else{z=0;L=35;break}}else{$=c[J>>2]|0}if((Gu($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;z=0,au(O|0,H|0)|0;if(!z){F=Z;G=H;continue}else{z=0;L=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((L|0)==35){G=bT(-1,-1)|0;aa=M;ab=G;Eb(o);Eb(n);bg(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(20,S|0,c[q>>2]|0,j|0,v|0)|0);G=M;if(z){z=0;break}c[k>>2]=F;c[k+4>>2]=G;Io(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{G=c[H+12>>2]|0;if((G|0)==(c[H+16>>2]|0)){F=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!z){ae=F}else{z=0;break L6}}else{ae=c[G>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){L=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){G=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!z){af=G}else{z=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;L=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);do{if((L|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;aa=M;ab=e;Eb(o);Eb(n);bg(ab|0)}function Gn(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Go(a,0,j,k,f,g,h);i=b;return}function Go(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0.0,ai=0,aj=0,ak=0,al=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;Gz(o,j,x,m,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L1:do{if(!z){if((a[q]&1)==0){y=j+1|0;A=y;B=y;C=p+8|0}else{y=p+8|0;A=c[y>>2]|0;B=j+1|0;C=y}c[r>>2]=A;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=h|0;F=p|0;G=p+4|0;H=c[m>>2]|0;I=c[n>>2]|0;J=A;K=c[D>>2]|0;L7:while(1){do{if((K|0)==0){L=0}else{N=c[K+12>>2]|0;if((N|0)==(c[K+16>>2]|0)){O=(z=0,au(c[(c[K>>2]|0)+36>>2]|0,K|0)|0);if(!z){P=O}else{z=0;Q=31;break L7}}else{P=c[N>>2]|0}if((P|0)!=-1){L=K;break}c[D>>2]=0;L=0}}while(0);R=(L|0)==0;N=c[E>>2]|0;do{if((N|0)==0){Q=18}else{O=c[N+12>>2]|0;if((O|0)==(c[N+16>>2]|0)){S=(z=0,au(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(!z){T=S}else{z=0;Q=31;break L7}}else{T=c[O>>2]|0}if((T|0)==-1){c[E>>2]=0;Q=18;break}else{O=(N|0)==0;if(R^O){U=N;V=O;break}else{W=J;X=N;Y=O;break L7}}}}while(0);if((Q|0)==18){Q=0;if(R){W=J;X=0;Y=1;break}else{U=0;V=1}}N=d[q]|0;O=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((O?N>>>1:c[G>>2]|0)|0)){if(O){Z=N>>>1;_=N>>>1}else{N=c[G>>2]|0;Z=N;_=N}z=0;aR(88,p|0,Z<<1|0,0);if(z){z=0;Q=31;break}if((a[q]&1)==0){$=10}else{$=(c[F>>2]&-2)-1|0}z=0;aR(88,p|0,$|0,0);if(z){z=0;Q=31;break}if((a[q]&1)==0){aa=B}else{aa=c[C>>2]|0}c[r>>2]=aa+_;ab=aa}else{ab=J}N=L+12|0;O=c[N>>2]|0;S=L+16|0;if((O|0)==(c[S>>2]|0)){ac=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!z){ad=ac}else{z=0;Q=31;break}}else{ad=c[O>>2]|0}if((GA(ad,v,w,ab,r,H,I,o,y,t,u,x)|0)!=0){W=ab;X=U;Y=V;break}O=c[N>>2]|0;if((O|0)==(c[S>>2]|0)){S=c[(c[L>>2]|0)+40>>2]|0;z=0,au(S|0,L|0)|0;if(!z){J=ab;K=L;continue}else{z=0;Q=31;break}}else{c[N>>2]=O+4;J=ab;K=L;continue}}if((Q|0)==31){K=bT(-1,-1)|0;ae=M;af=K;Eb(p);Eb(o);bg(af|0)}K=d[o]|0;if((K&1|0)==0){ag=K>>>1}else{ag=c[o+4>>2]|0}do{if((ag|0)!=0){if((a[v]&1)==0){break}K=c[t>>2]|0;if((K-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=K+4;c[K>>2]=J}}while(0);ah=(z=0,+(+aF(2,W|0,c[r>>2]|0,k|0)));if(z){z=0;break}g[l>>2]=ah;Io(o,y,c[t>>2]|0,k);do{if(R){ai=0}else{J=c[L+12>>2]|0;if((J|0)==(c[L+16>>2]|0)){K=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!z){aj=K}else{z=0;break L1}}else{aj=c[J>>2]|0}if((aj|0)!=-1){ai=L;break}c[D>>2]=0;ai=0}}while(0);D=(ai|0)==0;do{if(Y){Q=61}else{y=c[X+12>>2]|0;if((y|0)==(c[X+16>>2]|0)){J=(z=0,au(c[(c[X>>2]|0)+36>>2]|0,X|0)|0);if(!z){ak=J}else{z=0;break L1}}else{ak=c[y>>2]|0}if((ak|0)==-1){c[E>>2]=0;Q=61;break}if(!(D^(X|0)==0)){break}al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}}while(0);do{if((Q|0)==61){if(D){break}al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;ae=M;af=e;Eb(p);Eb(o);bg(af|0)}function Gp(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Gq(a,0,j,k,f,g,h);i=b;return}function Gq(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0.0,ai=0,aj=0,ak=0,al=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;Gz(o,j,x,m,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L1:do{if(!z){if((a[q]&1)==0){y=j+1|0;A=y;B=y;C=p+8|0}else{y=p+8|0;A=c[y>>2]|0;B=j+1|0;C=y}c[r>>2]=A;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=c[m>>2]|0;I=c[n>>2]|0;J=A;K=c[D>>2]|0;L7:while(1){do{if((K|0)==0){L=0}else{N=c[K+12>>2]|0;if((N|0)==(c[K+16>>2]|0)){O=(z=0,au(c[(c[K>>2]|0)+36>>2]|0,K|0)|0);if(!z){P=O}else{z=0;Q=31;break L7}}else{P=c[N>>2]|0}if((P|0)!=-1){L=K;break}c[D>>2]=0;L=0}}while(0);R=(L|0)==0;N=c[E>>2]|0;do{if((N|0)==0){Q=18}else{O=c[N+12>>2]|0;if((O|0)==(c[N+16>>2]|0)){S=(z=0,au(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(!z){T=S}else{z=0;Q=31;break L7}}else{T=c[O>>2]|0}if((T|0)==-1){c[E>>2]=0;Q=18;break}else{O=(N|0)==0;if(R^O){U=N;V=O;break}else{W=J;X=N;Y=O;break L7}}}}while(0);if((Q|0)==18){Q=0;if(R){W=J;X=0;Y=1;break}else{U=0;V=1}}N=d[q]|0;O=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((O?N>>>1:c[G>>2]|0)|0)){if(O){Z=N>>>1;_=N>>>1}else{N=c[G>>2]|0;Z=N;_=N}z=0;aR(88,p|0,Z<<1|0,0);if(z){z=0;Q=31;break}if((a[q]&1)==0){$=10}else{$=(c[F>>2]&-2)-1|0}z=0;aR(88,p|0,$|0,0);if(z){z=0;Q=31;break}if((a[q]&1)==0){aa=B}else{aa=c[C>>2]|0}c[r>>2]=aa+_;ab=aa}else{ab=J}N=L+12|0;O=c[N>>2]|0;S=L+16|0;if((O|0)==(c[S>>2]|0)){ac=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!z){ad=ac}else{z=0;Q=31;break}}else{ad=c[O>>2]|0}if((GA(ad,v,w,ab,r,H,I,o,y,t,u,x)|0)!=0){W=ab;X=U;Y=V;break}O=c[N>>2]|0;if((O|0)==(c[S>>2]|0)){S=c[(c[L>>2]|0)+40>>2]|0;z=0,au(S|0,L|0)|0;if(!z){J=ab;K=L;continue}else{z=0;Q=31;break}}else{c[N>>2]=O+4;J=ab;K=L;continue}}if((Q|0)==31){K=bT(-1,-1)|0;ae=M;af=K;Eb(p);Eb(o);bg(af|0)}K=d[o]|0;if((K&1|0)==0){ag=K>>>1}else{ag=c[o+4>>2]|0}do{if((ag|0)!=0){if((a[v]&1)==0){break}K=c[t>>2]|0;if((K-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=K+4;c[K>>2]=J}}while(0);ah=(z=0,+(+aN(4,W|0,c[r>>2]|0,k|0)));if(z){z=0;break}h[l>>3]=ah;Io(o,y,c[t>>2]|0,k);do{if(R){ai=0}else{J=c[L+12>>2]|0;if((J|0)==(c[L+16>>2]|0)){K=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!z){aj=K}else{z=0;break L1}}else{aj=c[J>>2]|0}if((aj|0)!=-1){ai=L;break}c[D>>2]=0;ai=0}}while(0);D=(ai|0)==0;do{if(Y){Q=61}else{y=c[X+12>>2]|0;if((y|0)==(c[X+16>>2]|0)){J=(z=0,au(c[(c[X>>2]|0)+36>>2]|0,X|0)|0);if(!z){ak=J}else{z=0;break L1}}else{ak=c[y>>2]|0}if((ak|0)==-1){c[E>>2]=0;Q=61;break}if(!(D^(X|0)==0)){break}al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}}while(0);do{if((Q|0)==61){if(D){break}al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;ae=M;af=e;Eb(p);Eb(o);bg(af|0)}function Gr(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Gs(a,0,j,k,f,g,h);i=b;return}function Gs(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0.0,ai=0,aj=0,ak=0,al=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;Gz(o,j,x,m,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L1:do{if(!z){if((a[q]&1)==0){y=j+1|0;A=y;B=y;C=p+8|0}else{y=p+8|0;A=c[y>>2]|0;B=j+1|0;C=y}c[r>>2]=A;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=c[m>>2]|0;I=c[n>>2]|0;J=A;K=c[D>>2]|0;L7:while(1){do{if((K|0)==0){L=0}else{N=c[K+12>>2]|0;if((N|0)==(c[K+16>>2]|0)){O=(z=0,au(c[(c[K>>2]|0)+36>>2]|0,K|0)|0);if(!z){P=O}else{z=0;Q=31;break L7}}else{P=c[N>>2]|0}if((P|0)!=-1){L=K;break}c[D>>2]=0;L=0}}while(0);R=(L|0)==0;N=c[E>>2]|0;do{if((N|0)==0){Q=18}else{O=c[N+12>>2]|0;if((O|0)==(c[N+16>>2]|0)){S=(z=0,au(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(!z){T=S}else{z=0;Q=31;break L7}}else{T=c[O>>2]|0}if((T|0)==-1){c[E>>2]=0;Q=18;break}else{O=(N|0)==0;if(R^O){U=N;V=O;break}else{W=J;X=N;Y=O;break L7}}}}while(0);if((Q|0)==18){Q=0;if(R){W=J;X=0;Y=1;break}else{U=0;V=1}}N=d[q]|0;O=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((O?N>>>1:c[G>>2]|0)|0)){if(O){Z=N>>>1;_=N>>>1}else{N=c[G>>2]|0;Z=N;_=N}z=0;aR(88,p|0,Z<<1|0,0);if(z){z=0;Q=31;break}if((a[q]&1)==0){$=10}else{$=(c[F>>2]&-2)-1|0}z=0;aR(88,p|0,$|0,0);if(z){z=0;Q=31;break}if((a[q]&1)==0){aa=B}else{aa=c[C>>2]|0}c[r>>2]=aa+_;ab=aa}else{ab=J}N=L+12|0;O=c[N>>2]|0;S=L+16|0;if((O|0)==(c[S>>2]|0)){ac=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!z){ad=ac}else{z=0;Q=31;break}}else{ad=c[O>>2]|0}if((GA(ad,v,w,ab,r,H,I,o,y,t,u,x)|0)!=0){W=ab;X=U;Y=V;break}O=c[N>>2]|0;if((O|0)==(c[S>>2]|0)){S=c[(c[L>>2]|0)+40>>2]|0;z=0,au(S|0,L|0)|0;if(!z){J=ab;K=L;continue}else{z=0;Q=31;break}}else{c[N>>2]=O+4;J=ab;K=L;continue}}if((Q|0)==31){K=bT(-1,-1)|0;ae=M;af=K;Eb(p);Eb(o);bg(af|0)}K=d[o]|0;if((K&1|0)==0){ag=K>>>1}else{ag=c[o+4>>2]|0}do{if((ag|0)!=0){if((a[v]&1)==0){break}K=c[t>>2]|0;if((K-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=K+4;c[K>>2]=J}}while(0);ah=(z=0,+(+aN(2,W|0,c[r>>2]|0,k|0)));if(z){z=0;break}h[l>>3]=ah;Io(o,y,c[t>>2]|0,k);do{if(R){ai=0}else{J=c[L+12>>2]|0;if((J|0)==(c[L+16>>2]|0)){K=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!z){aj=K}else{z=0;break L1}}else{aj=c[J>>2]|0}if((aj|0)!=-1){ai=L;break}c[D>>2]=0;ai=0}}while(0);D=(ai|0)==0;do{if(Y){Q=61}else{y=c[X+12>>2]|0;if((y|0)==(c[X+16>>2]|0)){J=(z=0,au(c[(c[X>>2]|0)+36>>2]|0,X|0)|0);if(!z){ak=J}else{z=0;break L1}}else{ak=c[y>>2]|0}if((ak|0)==-1){c[E>>2]=0;Q=61;break}if(!(D^(X|0)==0)){break}al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}}while(0);do{if((Q|0)==61){if(D){break}al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;al=b|0;c[al>>2]=ai;Eb(p);Eb(o);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;ae=M;af=e;Eb(p);Eb(o);bg(af|0)}function Gt(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;e=i;i=i+136|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+120|0;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;LI(n|0,0,12)|0;u=p;z=0;as(352,o|0,h|0);if(z){z=0;h=bT(-1,-1)|0;v=M;w=h;Eb(n);x=w;y=0;A=x;B=v;bg(A|0)}h=o|0;o=c[h>>2]|0;if((c[10438]|0)==-1){C=4}else{c[l>>2]=41752;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41752,l|0,520);if(!z){C=4}else{z=0}}L7:do{if((C|0)==4){l=(c[10439]|0)-1|0;D=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-D>>2>>>0>l>>>0){E=c[D+(l<<2)>>2]|0;if((E|0)==0){break}F=E;G=m|0;H=c[(c[E>>2]|0)+48>>2]|0;z=0,aU(H|0,F|0,32608,32634,G|0)|0;if(z){z=0;break L7}DL(c[h>>2]|0)|0;LI(u|0,0,12)|0;F=p;z=0;aR(88,p|0,10,0);L13:do{if(!z){if((a[u]&1)==0){H=F+1|0;I=H;J=H;K=p+8|0}else{H=p+8|0;I=c[H>>2]|0;J=F+1|0;K=H}c[q>>2]=I;H=r|0;c[s>>2]=H;c[t>>2]=0;E=f|0;L=g|0;N=p|0;O=p+4|0;P=I;Q=c[E>>2]|0;L19:while(1){do{if((Q|0)==0){R=0}else{S=c[Q+12>>2]|0;if((S|0)==(c[Q+16>>2]|0)){T=(z=0,au(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(!z){U=T}else{z=0;C=41;break L19}}else{U=c[S>>2]|0}if((U|0)!=-1){R=Q;break}c[E>>2]=0;R=0}}while(0);S=(R|0)==0;T=c[L>>2]|0;do{if((T|0)==0){C=26}else{V=c[T+12>>2]|0;if((V|0)==(c[T+16>>2]|0)){W=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!z){X=W}else{z=0;C=41;break L19}}else{X=c[V>>2]|0}if((X|0)==-1){c[L>>2]=0;C=26;break}else{if(S^(T|0)==0){break}else{Y=P;break L19}}}}while(0);if((C|0)==26){C=0;if(S){Y=P;break}}T=d[u]|0;V=(T&1|0)==0;if(((c[q>>2]|0)-P|0)==((V?T>>>1:c[O>>2]|0)|0)){if(V){Z=T>>>1;_=T>>>1}else{T=c[O>>2]|0;Z=T;_=T}z=0;aR(88,p|0,Z<<1|0,0);if(z){z=0;C=41;break}if((a[u]&1)==0){$=10}else{$=(c[N>>2]&-2)-1|0}z=0;aR(88,p|0,$|0,0);if(z){z=0;C=41;break}if((a[u]&1)==0){aa=J}else{aa=c[K>>2]|0}c[q>>2]=aa+_;ab=aa}else{ab=P}T=R+12|0;V=c[T>>2]|0;W=R+16|0;if((V|0)==(c[W>>2]|0)){ac=(z=0,au(c[(c[R>>2]|0)+36>>2]|0,R|0)|0);if(!z){ad=ac}else{z=0;C=41;break}}else{ad=c[V>>2]|0}if((Gu(ad,16,ab,q,t,0,n,H,s,G)|0)!=0){Y=ab;break}V=c[T>>2]|0;if((V|0)==(c[W>>2]|0)){W=c[(c[R>>2]|0)+40>>2]|0;z=0,au(W|0,R|0)|0;if(!z){P=ab;Q=R;continue}else{z=0;C=41;break}}else{c[T>>2]=V+4;P=ab;Q=R;continue}}if((C|0)==41){Q=bT(-1,-1)|0;ae=M;af=Q;break}a[Y+3|0]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}Q=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=Q;break}else{z=0;Q=bT(-1,-1)|0;ae=M;af=Q;break L13}}}while(0);Q=(z=0,aU(22,Y|0,c[10082]|0,8440,(P=i,i=i+8|0,c[P>>2]=k,P)|0)|0);i=P;if(z){z=0;C=42;break}if((Q|0)!=1){c[j>>2]=4}Q=c[E>>2]|0;do{if((Q|0)==0){ag=0}else{P=c[Q+12>>2]|0;if((P|0)==(c[Q+16>>2]|0)){H=(z=0,au(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(!z){ah=H}else{z=0;C=42;break L13}}else{ah=c[P>>2]|0}if((ah|0)!=-1){ag=Q;break}c[E>>2]=0;ag=0}}while(0);E=(ag|0)==0;Q=c[L>>2]|0;do{if((Q|0)==0){C=71}else{P=c[Q+12>>2]|0;if((P|0)==(c[Q+16>>2]|0)){H=(z=0,au(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(!z){ai=H}else{z=0;C=42;break L13}}else{ai=c[P>>2]|0}if((ai|0)==-1){c[L>>2]=0;C=71;break}if(!(E^(Q|0)==0)){break}aj=b|0;c[aj>>2]=ag;Eb(p);Eb(n);i=e;return}}while(0);do{if((C|0)==71){if(E){break}aj=b|0;c[aj>>2]=ag;Eb(p);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;aj=b|0;c[aj>>2]=ag;Eb(p);Eb(n);i=e;return}else{z=0;C=42}}while(0);if((C|0)==42){G=bT(-1,-1)|0;ae=M;af=G}Eb(p);v=ae;w=af;Eb(n);x=w;y=0;A=x;B=v;bg(A|0)}}while(0);l=cl(4)|0;K$(l);z=0;aR(156,l|0,29336,98);if(z){z=0;break}}}while(0);af=bT(-1,-1)|0;ae=M;DL(c[h>>2]|0)|0;v=ae;w=af;Eb(n);x=w;y=0;A=x;B=v;bg(A|0)}function Gu(b,e,f,g,h,i,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=c[g>>2]|0;o=(n|0)==(f|0);do{if(o){p=(c[m+96>>2]|0)==(b|0);if(!p){if((c[m+100>>2]|0)!=(b|0)){break}}c[g>>2]=f+1;a[f]=p?43:45;c[h>>2]=0;q=0;return q|0}}while(0);p=d[j]|0;if((p&1|0)==0){r=p>>>1}else{r=c[j+4>>2]|0}if((r|0)!=0&(b|0)==(i|0)){i=c[l>>2]|0;if((i-k|0)>=160){q=0;return q|0}k=c[h>>2]|0;c[l>>2]=i+4;c[i>>2]=k;c[h>>2]=0;q=0;return q|0}k=m+104|0;i=m;while(1){if((i|0)==(k|0)){s=k;break}if((c[i>>2]|0)==(b|0)){s=i;break}else{i=i+4|0}}i=s-m|0;m=i>>2;if((i|0)>92){q=-1;return q|0}do{if((e|0)==8|(e|0)==10){if((m|0)<(e|0)){break}else{q=-1}return q|0}else if((e|0)==16){if((i|0)<88){break}if(o){q=-1;return q|0}if((n-f|0)>=3){q=-1;return q|0}if((a[n-1|0]|0)!=48){q=-1;return q|0}c[h>>2]=0;s=a[32608+m|0]|0;b=c[g>>2]|0;c[g>>2]=b+1;a[b]=s;q=0;return q|0}}while(0);f=a[32608+m|0]|0;c[g>>2]=n+1;a[n]=f;c[h>>2]=(c[h>>2]|0)+1;q=0;return q|0}function Gv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+40|0;h=g|0;j=g+16|0;k=g+32|0;Ey(k,d);d=k|0;k=c[d>>2]|0;if((c[10440]|0)==-1){l=3}else{c[j>>2]=41760;c[j+4>>2]=460;c[j+8>>2]=0;z=0;aR(2,41760,j|0,520);if(!z){l=3}else{z=0}}L3:do{if((l|0)==3){j=(c[10441]|0)-1|0;m=c[k+8>>2]|0;do{if((c[k+12>>2]|0)-m>>2>>>0>j>>>0){n=c[m+(j<<2)>>2]|0;if((n|0)==0){break}o=n;p=c[(c[n>>2]|0)+32>>2]|0;z=0,aU(p|0,o|0,32608,32634,e|0)|0;if(z){z=0;break L3}o=c[d>>2]|0;if((c[10344]|0)!=-1){c[h>>2]=41376;c[h+4>>2]=460;c[h+8>>2]=0;z=0;aR(2,41376,h|0,520);if(z){z=0;break L3}}p=(c[10345]|0)-1|0;n=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-n>>2>>>0>p>>>0){q=c[n+(p<<2)>>2]|0;if((q|0)==0){break}r=q;s=(z=0,au(c[(c[q>>2]|0)+16>>2]|0,r|0)|0);if(z){z=0;break L3}a[f]=s;z=0;as(c[(c[q>>2]|0)+20>>2]|0,b|0,r|0);if(z){z=0;break L3}DL(c[d>>2]|0)|0;i=g;return}}while(0);p=cl(4)|0;K$(p);z=0;aR(156,p|0,29336,98);if(z){z=0;break L3}}}while(0);j=cl(4)|0;K$(j);z=0;aR(156,j|0,29336,98);if(z){z=0;break}}}while(0);g=bT(-1,-1)|0;DL(c[d>>2]|0)|0;bg(g|0)}function Gw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h|0;k=h+16|0;l=h+32|0;Ey(l,d);d=l|0;l=c[d>>2]|0;if((c[10440]|0)==-1){m=3}else{c[k>>2]=41760;c[k+4>>2]=460;c[k+8>>2]=0;z=0;aR(2,41760,k|0,520);if(!z){m=3}else{z=0}}L3:do{if((m|0)==3){k=(c[10441]|0)-1|0;n=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-n>>2>>>0>k>>>0){o=c[n+(k<<2)>>2]|0;if((o|0)==0){break}p=o;q=c[(c[o>>2]|0)+32>>2]|0;z=0,aU(q|0,p|0,32608,32640,e|0)|0;if(z){z=0;break L3}p=c[d>>2]|0;if((c[10344]|0)!=-1){c[j>>2]=41376;c[j+4>>2]=460;c[j+8>>2]=0;z=0;aR(2,41376,j|0,520);if(z){z=0;break L3}}q=(c[10345]|0)-1|0;o=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-o>>2>>>0>q>>>0){r=c[o+(q<<2)>>2]|0;if((r|0)==0){break}s=r;t=r;u=(z=0,au(c[(c[t>>2]|0)+12>>2]|0,s|0)|0);if(z){z=0;break L3}a[f]=u;u=(z=0,au(c[(c[t>>2]|0)+16>>2]|0,s|0)|0);if(z){z=0;break L3}a[g]=u;z=0;as(c[(c[r>>2]|0)+20>>2]|0,b|0,s|0);if(z){z=0;break L3}DL(c[d>>2]|0)|0;i=h;return}}while(0);q=cl(4)|0;K$(q);z=0;aR(156,q|0,29336,98);if(z){z=0;break L3}}}while(0);k=cl(4)|0;K$(k);z=0;aR(156,k|0,29336,98);if(z){z=0;break}}}while(0);h=bT(-1,-1)|0;DL(c[d>>2]|0)|0;bg(h|0)}function Gx(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0;if(b<<24>>24==i<<24>>24){if((a[e]&1)==0){p=-1;return p|0}a[e]=0;i=c[h>>2]|0;c[h>>2]=i+1;a[i]=46;i=d[k]|0;if((i&1|0)==0){q=i>>>1}else{q=c[k+4>>2]|0}if((q|0)==0){p=0;return p|0}q=c[m>>2]|0;if((q-l|0)>=160){p=0;return p|0}i=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=i;p=0;return p|0}do{if(b<<24>>24==j<<24>>24){i=d[k]|0;if((i&1|0)==0){r=i>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){break}if((a[e]&1)==0){p=-1;return p|0}i=c[m>>2]|0;if((i-l|0)>=160){p=0;return p|0}q=c[n>>2]|0;c[m>>2]=i+4;c[i>>2]=q;c[n>>2]=0;p=0;return p|0}}while(0);r=o+32|0;j=o;while(1){if((j|0)==(r|0)){s=r;break}if((a[j]|0)==b<<24>>24){s=j;break}else{j=j+1|0}}j=s-o|0;if((j|0)>31){p=-1;return p|0}o=a[32608+j|0]|0;if((j|0)==25|(j|0)==24){s=c[h>>2]|0;do{if((s|0)!=(g|0)){if((a[s-1|0]&95|0)==(a[f]&127|0)){break}else{p=-1}return p|0}}while(0);c[h>>2]=s+1;a[s]=o;p=0;return p|0}else if((j|0)==22|(j|0)==23){a[f]=80;s=c[h>>2]|0;c[h>>2]=s+1;a[s]=o;p=0;return p|0}else{s=a[f]|0;do{if((o&95|0)==(s<<24>>24|0)){a[f]=s|-128;if((a[e]&1)==0){break}a[e]=0;g=d[k]|0;if((g&1|0)==0){t=g>>>1}else{t=c[k+4>>2]|0}if((t|0)==0){break}g=c[m>>2]|0;if((g-l|0)>=160){break}b=c[n>>2]|0;c[m>>2]=g+4;c[g>>2]=b}}while(0);m=c[h>>2]|0;c[h>>2]=m+1;a[m]=o;if((j|0)>21){p=0;return p|0}c[n>>2]=(c[n>>2]|0)+1;p=0;return p|0}return 0}function Gy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+40|0;g=f|0;h=f+16|0;j=f+32|0;Ey(j,b);b=j|0;j=c[b>>2]|0;if((c[10438]|0)==-1){k=3}else{c[h>>2]=41752;c[h+4>>2]=460;c[h+8>>2]=0;z=0;aR(2,41752,h|0,520);if(!z){k=3}else{z=0}}L3:do{if((k|0)==3){h=(c[10439]|0)-1|0;l=c[j+8>>2]|0;do{if((c[j+12>>2]|0)-l>>2>>>0>h>>>0){m=c[l+(h<<2)>>2]|0;if((m|0)==0){break}n=m;o=c[(c[m>>2]|0)+48>>2]|0;z=0,aU(o|0,n|0,32608,32634,d|0)|0;if(z){z=0;break L3}n=c[b>>2]|0;if((c[10342]|0)!=-1){c[g>>2]=41368;c[g+4>>2]=460;c[g+8>>2]=0;z=0;aR(2,41368,g|0,520);if(z){z=0;break L3}}o=(c[10343]|0)-1|0;m=c[n+8>>2]|0;do{if((c[n+12>>2]|0)-m>>2>>>0>o>>>0){p=c[m+(o<<2)>>2]|0;if((p|0)==0){break}q=p;r=(z=0,au(c[(c[p>>2]|0)+16>>2]|0,q|0)|0);if(z){z=0;break L3}c[e>>2]=r;z=0;as(c[(c[p>>2]|0)+20>>2]|0,a|0,q|0);if(z){z=0;break L3}DL(c[b>>2]|0)|0;i=f;return}}while(0);o=cl(4)|0;K$(o);z=0;aR(156,o|0,29336,98);if(z){z=0;break L3}}}while(0);h=cl(4)|0;K$(h);z=0;aR(156,h|0,29336,98);if(z){z=0;break}}}while(0);f=bT(-1,-1)|0;DL(c[b>>2]|0)|0;bg(f|0)}function Gz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g|0;j=g+16|0;k=g+32|0;Ey(k,b);b=k|0;k=c[b>>2]|0;if((c[10438]|0)==-1){l=3}else{c[j>>2]=41752;c[j+4>>2]=460;c[j+8>>2]=0;z=0;aR(2,41752,j|0,520);if(!z){l=3}else{z=0}}L3:do{if((l|0)==3){j=(c[10439]|0)-1|0;m=c[k+8>>2]|0;do{if((c[k+12>>2]|0)-m>>2>>>0>j>>>0){n=c[m+(j<<2)>>2]|0;if((n|0)==0){break}o=n;p=c[(c[n>>2]|0)+48>>2]|0;z=0,aU(p|0,o|0,32608,32640,d|0)|0;if(z){z=0;break L3}o=c[b>>2]|0;if((c[10342]|0)!=-1){c[h>>2]=41368;c[h+4>>2]=460;c[h+8>>2]=0;z=0;aR(2,41368,h|0,520);if(z){z=0;break L3}}p=(c[10343]|0)-1|0;n=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-n>>2>>>0>p>>>0){q=c[n+(p<<2)>>2]|0;if((q|0)==0){break}r=q;s=q;t=(z=0,au(c[(c[s>>2]|0)+12>>2]|0,r|0)|0);if(z){z=0;break L3}c[e>>2]=t;t=(z=0,au(c[(c[s>>2]|0)+16>>2]|0,r|0)|0);if(z){z=0;break L3}c[f>>2]=t;z=0;as(c[(c[q>>2]|0)+20>>2]|0,a|0,r|0);if(z){z=0;break L3}DL(c[b>>2]|0)|0;i=g;return}}while(0);p=cl(4)|0;K$(p);z=0;aR(156,p|0,29336,98);if(z){z=0;break L3}}}while(0);j=cl(4)|0;K$(j);z=0;aR(156,j|0,29336,98);if(z){z=0;break}}}while(0);g=bT(-1,-1)|0;DL(c[b>>2]|0)|0;bg(g|0)}function GA(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0;if((b|0)==(i|0)){if((a[e]&1)==0){p=-1;return p|0}a[e]=0;i=c[h>>2]|0;c[h>>2]=i+1;a[i]=46;i=d[k]|0;if((i&1|0)==0){q=i>>>1}else{q=c[k+4>>2]|0}if((q|0)==0){p=0;return p|0}q=c[m>>2]|0;if((q-l|0)>=160){p=0;return p|0}i=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=i;p=0;return p|0}do{if((b|0)==(j|0)){i=d[k]|0;if((i&1|0)==0){r=i>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){break}if((a[e]&1)==0){p=-1;return p|0}i=c[m>>2]|0;if((i-l|0)>=160){p=0;return p|0}q=c[n>>2]|0;c[m>>2]=i+4;c[i>>2]=q;c[n>>2]=0;p=0;return p|0}}while(0);r=o+128|0;j=o;while(1){if((j|0)==(r|0)){s=r;break}if((c[j>>2]|0)==(b|0)){s=j;break}else{j=j+4|0}}j=s-o|0;o=j>>2;if((j|0)>124){p=-1;return p|0}s=a[32608+o|0]|0;do{if((o|0)==25|(o|0)==24){b=c[h>>2]|0;do{if((b|0)!=(g|0)){if((a[b-1|0]&95|0)==(a[f]&127|0)){break}else{p=-1}return p|0}}while(0);c[h>>2]=b+1;a[b]=s;p=0;return p|0}else if((o|0)==22|(o|0)==23){a[f]=80}else{r=a[f]|0;if((s&95|0)!=(r<<24>>24|0)){break}a[f]=r|-128;if((a[e]&1)==0){break}a[e]=0;r=d[k]|0;if((r&1|0)==0){t=r>>>1}else{t=c[k+4>>2]|0}if((t|0)==0){break}r=c[m>>2]|0;if((r-l|0)>=160){break}q=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=q}}while(0);m=c[h>>2]|0;c[h>>2]=m+1;a[m]=s;if((j|0)>84){p=0;return p|0}c[n>>2]=(c[n>>2]|0)+1;p=0;return p|0}function GB(a){a=a|0;DJ(a|0);Lw(a);return}function GC(a){a=a|0;DJ(a|0);return}function GD(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+48|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;if((c[f+4>>2]&1|0)==0){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];cM[o&127](b,d,l,f,g,h&1);i=j;return}Ey(m,f);f=m|0;m=c[f>>2]|0;if((c[10344]|0)==-1){p=5}else{c[k>>2]=41376;c[k+4>>2]=460;c[k+8>>2]=0;z=0;aR(2,41376,k|0,520);if(!z){p=5}else{z=0}}do{if((p|0)==5){k=(c[10345]|0)-1|0;g=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-g>>2>>>0>k>>>0){l=c[g+(k<<2)>>2]|0;if((l|0)==0){break}d=l;DL(c[f>>2]|0)|0;o=c[l>>2]|0;if(h){cB[c[o+24>>2]&1023](n,d)}else{cB[c[o+28>>2]&1023](n,d)}d=n;o=n;l=a[o]|0;if((l&1)==0){q=d+1|0;r=q;s=q;t=n+8|0}else{q=n+8|0;r=c[q>>2]|0;s=d+1|0;t=q}q=e|0;d=n+4|0;u=r;v=l;L20:while(1){if((v&1)==0){w=s}else{w=c[t>>2]|0}l=v&255;if((u|0)==(w+((l&1|0)==0?l>>>1:c[d>>2]|0)|0)){p=28;break}l=a[u]|0;x=c[q>>2]|0;do{if((x|0)!=0){y=x+24|0;A=c[y>>2]|0;if((A|0)!=(c[x+28>>2]|0)){c[y>>2]=A+1;a[A]=l;break}A=(z=0,aM(c[(c[x>>2]|0)+52>>2]|0,x|0,l&255|0)|0);if(z){z=0;p=27;break L20}if((A|0)!=-1){break}c[q>>2]=0}}while(0);u=u+1|0;v=a[o]|0}if((p|0)==27){o=bT(-1,-1)|0;v=M;Eb(n);B=v;C=o;D=C;E=0;F=D;G=B;bg(F|0)}else if((p|0)==28){c[b>>2]=c[q>>2];Eb(n);i=j;return}}}while(0);k=cl(4)|0;K$(k);z=0;aR(156,k|0,29336,98);if(z){z=0;break}}}while(0);j=bT(-1,-1)|0;n=M;DL(c[f>>2]|0)|0;B=n;C=j;D=C;E=0;F=D;G=B;bg(F|0)}function GE(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+80|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=j|0;a[q]=a[13744]|0;a[q+1|0]=a[13745]|0;a[q+2|0]=a[13746]|0;a[q+3|0]=a[13747]|0;a[q+4|0]=a[13748]|0;a[q+5|0]=a[13749]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=k|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}t=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=t;break}else{z=0;t=bT(-1,-1)|0;bg(t|0)}}}while(0);t=GF(u,12,c[10082]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+t|0;h=c[s>>2]&176;do{if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=k+2|0}else if((h|0)==32){w=q}else{x=22}}while(0);if((x|0)==22){w=u}x=l|0;Ey(o,f);z=0;aI(80,u|0,w|0,q|0,x|0,m|0,n|0,o|0);if(!z){DL(c[o>>2]|0)|0;c[p>>2]=c[e>>2];ft(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[o>>2]|0)|0;bg(d|0)}}function GF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g|0;j=h;c[j>>2]=f;c[j+4>>2]=0;j=b6(d|0)|0;d=b7(a|0,b|0,e|0,h|0)|0;if((j|0)==0){i=g;return d|0}z=0,au(36,j|0)|0;if(!z){i=g;return d|0}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function GG(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10440]|0)!=-1){c[n>>2]=41760;c[n+4>>2]=460;c[n+8>>2]=0;D4(41760,n,520)}n=(c[10441]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}r=k;s=c[p>>2]|0;if((c[10344]|0)!=-1){c[m>>2]=41376;c[m+4>>2]=460;c[m+8>>2]=0;D4(41376,m,520)}m=(c[10345]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}t=s;cB[c[(c[s>>2]|0)+20>>2]&1023](o,t);u=o;m=o;p=d[m]|0;if((p&1|0)==0){v=p>>>1}else{v=c[o+4>>2]|0}L23:do{if((v|0)==0){p=c[(c[k>>2]|0)+32>>2]|0;z=0,aU(p|0,r|0,b|0,f|0,g|0)|0;if(z){z=0;w=18;break}c[j>>2]=g+(f-b)}else{c[j>>2]=g;p=a[b]|0;if((p<<24>>24|0)==45|(p<<24>>24|0)==43){n=(z=0,aM(c[(c[k>>2]|0)+28>>2]|0,r|0,p|0)|0);if(z){z=0;w=18;break}p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n;x=b+1|0}else{x=b}do{if((f-x|0)>1){if((a[x]|0)!=48){y=x;break}n=x+1|0;p=a[n]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){y=x;break}p=k;q=(z=0,aM(c[(c[p>>2]|0)+28>>2]|0,r|0,48)|0);if(z){z=0;w=18;break L23}A=c[j>>2]|0;c[j>>2]=A+1;a[A]=q;q=(z=0,aM(c[(c[p>>2]|0)+28>>2]|0,r|0,a[n]|0)|0);if(z){z=0;w=18;break L23}n=c[j>>2]|0;c[j>>2]=n+1;a[n]=q;y=x+2|0}else{y=x}}while(0);do{if((y|0)!=(f|0)){q=f-1|0;if(y>>>0<q>>>0){B=y;C=q}else{break}do{q=a[B]|0;a[B]=a[C]|0;a[C]=q;B=B+1|0;C=C-1|0;}while(B>>>0<C>>>0)}}while(0);q=(z=0,au(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(z){z=0;w=18;break}L42:do{if(y>>>0<f>>>0){n=u+1|0;p=k;A=o+4|0;D=o+8|0;E=0;F=0;G=y;while(1){H=(a[m]&1)==0;do{if((a[(H?n:c[D>>2]|0)+F|0]|0)==0){I=F;J=E}else{if((E|0)!=(a[(H?n:c[D>>2]|0)+F|0]|0)){I=F;J=E;break}K=c[j>>2]|0;c[j>>2]=K+1;a[K]=q;K=d[m]|0;I=(F>>>0<(((K&1|0)==0?K>>>1:c[A>>2]|0)-1|0)>>>0)+F|0;J=0}}while(0);H=(z=0,aM(c[(c[p>>2]|0)+28>>2]|0,r|0,a[G]|0)|0);if(z){z=0;break}K=c[j>>2]|0;c[j>>2]=K+1;a[K]=H;H=G+1|0;if(H>>>0<f>>>0){E=J+1|0;F=I;G=H}else{break L42}}G=bT(-1,-1)|0;L=M;N=G;Eb(o);bg(N|0)}}while(0);q=g+(y-b)|0;G=c[j>>2]|0;if((q|0)==(G|0)){break}F=G-1|0;if(q>>>0<F>>>0){O=q;P=F}else{break}do{F=a[O]|0;a[O]=a[P]|0;a[P]=F;O=O+1|0;P=P-1|0;}while(O>>>0<P>>>0)}}while(0);if((w|0)==18){w=bT(-1,-1)|0;L=M;N=w;Eb(o);bg(N|0)}if((e|0)==(f|0)){Q=c[j>>2]|0;c[h>>2]=Q;Eb(o);i=l;return}else{Q=g+(e-b)|0;c[h>>2]=Q;Eb(o);i=l;return}}function GH(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+112|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+80|0;o=d+88|0;p=d+96|0;q=d+104|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=l|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}t=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=t;break}else{z=0;t=bT(-1,-1)|0;bg(t|0)}}}while(0);t=GF(u,22,c[10082]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==32){w=r}else if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=l+2|0}else{x=22}}while(0);if((x|0)==22){w=u}x=m|0;Ey(p,f);z=0;aI(80,u|0,w|0,r|0,x|0,n|0,o|0,p|0);if(!z){DL(c[p>>2]|0)|0;c[q>>2]=c[e>>2];ft(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[p>>2]|0)|0;bg(d|0)}}function GI(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+80|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=j|0;a[q]=a[13744]|0;a[q+1|0]=a[13745]|0;a[q+2|0]=a[13746]|0;a[q+3|0]=a[13747]|0;a[q+4|0]=a[13748]|0;a[q+5|0]=a[13749]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=117}}while(0);u=k|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}t=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=t;break}else{z=0;t=bT(-1,-1)|0;bg(t|0)}}}while(0);t=GF(u,12,c[10082]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+t|0;h=c[s>>2]&176;do{if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=k+2|0}else if((h|0)==32){w=q}else{x=22}}while(0);if((x|0)==22){w=u}x=l|0;Ey(o,f);z=0;aI(80,u|0,w|0,q|0,x|0,m|0,n|0,o|0);if(!z){DL(c[o>>2]|0)|0;c[p>>2]=c[e>>2];ft(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[o>>2]|0)|0;bg(d|0)}}function GJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+112|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+80|0;o=d+88|0;p=d+96|0;q=d+104|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=117}}while(0);u=l|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}t=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=t;break}else{z=0;t=bT(-1,-1)|0;bg(t|0)}}}while(0);t=GF(u,23,c[10082]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=l+2|0}else if((j|0)==32){w=r}else{x=22}}while(0);if((x|0)==22){w=u}x=m|0;Ey(p,f);z=0;aI(80,u|0,w|0,r|0,x|0,n|0,o|0,p|0);if(!z){DL(c[p>>2]|0)|0;c[q>>2]=c[e>>2];ft(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[p>>2]|0)|0;bg(d|0)}}function GK(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+152|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+112|0;p=d+120|0;q=d+128|0;r=d+136|0;s=d+144|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){if((k&1|0)==0){a[x]=97;y=0;break}else{a[x]=65;y=0;break}}else{a[x]=46;v=x+2|0;a[x+1|0]=42;if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;bg(l|0)}}}while(0);l=c[10082]|0;if(y){w=GF(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=GF(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[42320]|0)==0;L41:do{if(y){do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L41}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}else{do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L41}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}z=0;aS(4);if(z){z=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bT(-1,-1)|0;C=M;D=w}J=C;K=D;L=K;N=0;O=L;P=J;bg(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=Lo(G<<1)|0;if((D|0)!=0){R=D;S=D;T=I;F=59;break}z=0;aS(4);if(z){z=0;U=0;F=58;break}R=0;S=0;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){z=0;as(352,q|0,f|0);if(z){z=0;U=S;F=58;break}z=0;aI(86,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(z){z=0;m=bT(-1,-1)|0;I=M;DL(c[q>>2]|0)|0;V=m;W=I;X=S;break}DL(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];z=0;aI(56,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(z){z=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){Lp(S)}if((H|0)==0){i=d;return}Lp(H);i=d;return}}while(0);if((F|0)==58){F=bT(-1,-1)|0;V=F;W=M;X=U}if((X|0)!=0){Lp(X)}if((H|0)==0){J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}Lp(H);J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}function GL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f|0;h=g;c[h>>2]=e;c[h+4>>2]=0;h=b6(b|0)|0;b=(z=0,az(32,a|0,d|0,g|0)|0);if(!z){if((h|0)==0){i=f;return b|0}z=0,au(36,h|0)|0;if(!z){i=f;return b|0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{z=0;b=bT(-1,-1)|0;if((h|0)==0){bg(b|0)}z=0,au(36,h|0)|0;if(!z){bg(b|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}return 0}function GM(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10440]|0)!=-1){c[n>>2]=41760;c[n+4>>2]=460;c[n+8>>2]=0;D4(41760,n,520)}n=(c[10441]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}r=k;s=c[p>>2]|0;if((c[10344]|0)!=-1){c[m>>2]=41376;c[m+4>>2]=460;c[m+8>>2]=0;D4(41376,m,520)}m=(c[10345]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}t=s;cB[c[(c[s>>2]|0)+20>>2]&1023](o,t);c[j>>2]=g;u=a[b]|0;do{if((u<<24>>24|0)==45|(u<<24>>24|0)==43){m=(z=0,aM(c[(c[k>>2]|0)+28>>2]|0,r|0,u|0)|0);if(z){z=0;break}p=c[j>>2]|0;c[j>>2]=p+1;a[p]=m;v=b+1|0;w=20}else{v=b;w=20}}while(0);L22:do{if((w|0)==20){u=f;L24:do{if((u-v|0)>1){if((a[v]|0)!=48){x=v;w=34;break}m=v+1|0;p=a[m]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){x=v;w=34;break}p=k;n=(z=0,aM(c[(c[p>>2]|0)+28>>2]|0,r|0,48)|0);if(z){z=0;break L22}q=c[j>>2]|0;c[j>>2]=q+1;a[q]=n;n=v+2|0;q=(z=0,aM(c[(c[p>>2]|0)+28>>2]|0,r|0,a[m]|0)|0);if(z){z=0;break L22}m=c[j>>2]|0;c[j>>2]=m+1;a[m]=q;q=n;L30:while(1){if(q>>>0>=f>>>0){y=q;A=n;break L24}m=a[q]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}p=(z=0,az(72,2147483647,10032,0)|0);if(z){z=0;w=31;break L30}c[10082]=p}}while(0);p=(z=0,aM(164,m<<24>>24|0,c[10082]|0)|0);if(z){z=0;w=17;break}if((p|0)==0){y=q;A=n;break L24}else{q=q+1|0}}if((w|0)==17){q=bT(-1,-1)|0;B=M;C=q;Eb(o);bg(C|0)}else if((w|0)==31){q=bT(-1,-1)|0;B=M;C=q;Eb(o);bg(C|0)}}else{x=v;w=34}}while(0);L44:do{if((w|0)==34){L45:while(1){w=0;if(x>>>0>=f>>>0){y=x;A=v;break L44}q=a[x]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}n=(z=0,az(72,2147483647,10032,0)|0);if(z){z=0;w=39;break L45}c[10082]=n}}while(0);m=(z=0,aM(68,q<<24>>24|0,c[10082]|0)|0);if(z){z=0;w=16;break}if((m|0)==0){y=x;A=v;break L44}else{x=x+1|0;w=34}}if((w|0)==16){m=bT(-1,-1)|0;B=M;C=m;Eb(o);bg(C|0)}else if((w|0)==39){m=bT(-1,-1)|0;B=M;C=m;Eb(o);bg(C|0)}}}while(0);m=o;n=o;p=d[n]|0;if((p&1|0)==0){D=p>>>1}else{D=c[o+4>>2]|0}do{if((D|0)==0){p=c[j>>2]|0;E=c[(c[k>>2]|0)+32>>2]|0;z=0,aU(E|0,r|0,A|0,y|0,p|0)|0;if(z){z=0;break L22}c[j>>2]=(c[j>>2]|0)+(y-A)}else{do{if((A|0)!=(y|0)){p=y-1|0;if(A>>>0<p>>>0){F=A;G=p}else{break}do{p=a[F]|0;a[F]=a[G]|0;a[G]=p;F=F+1|0;G=G-1|0;}while(F>>>0<G>>>0)}}while(0);q=(z=0,au(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(z){z=0;break L22}L74:do{if(A>>>0<y>>>0){p=m+1|0;E=o+4|0;H=o+8|0;I=k;J=0;K=0;L=A;while(1){N=(a[n]&1)==0;do{if((a[(N?p:c[H>>2]|0)+K|0]|0)>0){if((J|0)!=(a[(N?p:c[H>>2]|0)+K|0]|0)){O=K;P=J;break}Q=c[j>>2]|0;c[j>>2]=Q+1;a[Q]=q;Q=d[n]|0;O=(K>>>0<(((Q&1|0)==0?Q>>>1:c[E>>2]|0)-1|0)>>>0)+K|0;P=0}else{O=K;P=J}}while(0);N=(z=0,aM(c[(c[I>>2]|0)+28>>2]|0,r|0,a[L]|0)|0);if(z){z=0;break}Q=c[j>>2]|0;c[j>>2]=Q+1;a[Q]=N;N=L+1|0;if(N>>>0<y>>>0){J=P+1|0;K=O;L=N}else{break L74}}L=bT(-1,-1)|0;B=M;C=L;Eb(o);bg(C|0)}}while(0);q=g+(A-b)|0;L=c[j>>2]|0;if((q|0)==(L|0)){break}K=L-1|0;if(q>>>0<K>>>0){R=q;S=K}else{break}do{K=a[R]|0;a[R]=a[S]|0;a[S]=K;R=R+1|0;S=S-1|0;}while(R>>>0<S>>>0)}}while(0);L90:do{if(y>>>0<f>>>0){n=k;m=y;while(1){K=a[m]|0;if(K<<24>>24==46){w=65;break}q=(z=0,aM(c[(c[n>>2]|0)+28>>2]|0,r|0,K|0)|0);if(z){z=0;w=14;break}K=c[j>>2]|0;c[j>>2]=K+1;a[K]=q;q=m+1|0;if(q>>>0<f>>>0){m=q}else{T=q;break L90}}if((w|0)==14){n=bT(-1,-1)|0;B=M;C=n;Eb(o);bg(C|0)}else if((w|0)==65){n=(z=0,au(c[(c[s>>2]|0)+12>>2]|0,t|0)|0);if(z){z=0;break L22}q=c[j>>2]|0;c[j>>2]=q+1;a[q]=n;T=m+1|0;break}}else{T=y}}while(0);n=c[j>>2]|0;q=c[(c[k>>2]|0)+32>>2]|0;z=0,aU(q|0,r|0,T|0,f|0,n|0)|0;if(z){z=0;break}n=(c[j>>2]|0)+(u-T)|0;c[j>>2]=n;if((e|0)==(f|0)){U=n;c[h>>2]=U;Eb(o);i=l;return}U=g+(e-b)|0;c[h>>2]=U;Eb(o);i=l;return}}while(0);l=bT(-1,-1)|0;B=M;C=l;Eb(o);bg(C|0)}function GN(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+152|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+112|0;p=d+120|0;q=d+128|0;r=d+136|0;s=d+144|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){a[x]=76;v=x+1|0;if((k&1|0)==0){a[v]=97;y=0;break}else{a[v]=65;y=0;break}}else{a[x]=46;a[x+1|0]=42;a[x+2|0]=76;v=x+3|0;if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;bg(l|0)}}}while(0);l=c[10082]|0;if(y){w=GF(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=GF(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[42320]|0)==0;L41:do{if(y){do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L41}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}else{do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L41}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}z=0;aS(4);if(z){z=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bT(-1,-1)|0;C=M;D=w}J=C;K=D;L=K;N=0;O=L;P=J;bg(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=Lo(G<<1)|0;if((D|0)!=0){R=D;S=D;T=I;F=59;break}z=0;aS(4);if(z){z=0;U=0;F=58;break}R=0;S=0;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){z=0;as(352,q|0,f|0);if(z){z=0;U=S;F=58;break}z=0;aI(86,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(z){z=0;m=bT(-1,-1)|0;I=M;DL(c[q>>2]|0)|0;V=m;W=I;X=S;break}DL(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];z=0;aI(56,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(z){z=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){Lp(S)}if((H|0)==0){i=d;return}Lp(H);i=d;return}}while(0);if((F|0)==58){F=bT(-1,-1)|0;V=F;W=M;X=U}if((X|0)!=0){Lp(X)}if((H|0)==0){J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}Lp(H);J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}function GO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+104|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+24|0;l=d+48|0;m=d+88|0;n=d+96|0;o=d+16|0;a[o]=a[13752]|0;a[o+1|0]=a[13753]|0;a[o+2|0]=a[13754]|0;a[o+3|0]=a[13755]|0;a[o+4|0]=a[13756]|0;a[o+5|0]=a[13757]|0;p=k|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}q=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=q;break}else{z=0;q=bT(-1,-1)|0;bg(q|0)}}}while(0);q=GF(p,20,c[10082]|0,o,(o=i,i=i+8|0,c[o>>2]=h,o)|0)|0;i=o;o=k+q|0;h=c[f+4>>2]&176;do{if((h|0)==32){r=o}else if((h|0)==16){s=a[p]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){r=k+1|0;break}if(!((q|0)>1&s<<24>>24==48)){t=12;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){t=12;break}r=k+2|0}else{t=12}}while(0);if((t|0)==12){r=p}Ey(m,f);t=m|0;m=c[t>>2]|0;do{if((c[10440]|0)!=-1){c[j>>2]=41760;c[j+4>>2]=460;c[j+8>>2]=0;z=0;aR(2,41760,j|0,520);if(!z){break}else{z=0}u=bT(-1,-1)|0;v=M;w=c[t>>2]|0;x=w|0;y=DL(x)|0;bg(u|0)}}while(0);j=(c[10441]|0)-1|0;h=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-h>>2>>>0>j>>>0){s=c[h+(j<<2)>>2]|0;if((s|0)==0){break}DL(c[t>>2]|0)|0;A=l|0;c1[c[(c[s>>2]|0)+32>>2]&63](s,p,o,A)|0;s=l+q|0;if((r|0)==(o|0)){B=s;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;ft(b,n,A,B,s,f,g);i=d;return}B=l+(r-k)|0;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;ft(b,n,A,B,s,f,g);i=d;return}}while(0);d=cl(4)|0;K$(d);z=0;aR(156,d|0,29336,98);if(z){z=0;u=bT(-1,-1)|0;v=M;w=c[t>>2]|0;x=w|0;y=DL(x)|0;bg(u|0)}}function GP(a){a=a|0;DJ(a|0);Lw(a);return}function GQ(a){a=a|0;DJ(a|0);return}function GR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=i;i=i+48|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;if((c[f+4>>2]&1|0)==0){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];cM[o&127](b,d,l,f,g,h&1);i=j;return}Ey(m,f);f=m|0;m=c[f>>2]|0;if((c[10342]|0)==-1){p=5}else{c[k>>2]=41368;c[k+4>>2]=460;c[k+8>>2]=0;z=0;aR(2,41368,k|0,520);if(!z){p=5}else{z=0}}do{if((p|0)==5){k=(c[10343]|0)-1|0;g=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-g>>2>>>0>k>>>0){l=c[g+(k<<2)>>2]|0;if((l|0)==0){break}d=l;DL(c[f>>2]|0)|0;o=c[l>>2]|0;if(h){cB[c[o+24>>2]&1023](n,d)}else{cB[c[o+28>>2]&1023](n,d)}d=n;o=a[d]|0;if((o&1)==0){l=n+4|0;q=l;r=l;s=n+8|0}else{l=n+8|0;q=c[l>>2]|0;r=n+4|0;s=l}l=e|0;t=q;u=o;L20:while(1){if((u&1)==0){v=r}else{v=c[s>>2]|0}o=u&255;if((o&1|0)==0){w=o>>>1}else{w=c[r>>2]|0}if((t|0)==(v+(w<<2)|0)){p=31;break}o=c[t>>2]|0;x=c[l>>2]|0;do{if((x|0)!=0){y=x+24|0;A=c[y>>2]|0;if((A|0)==(c[x+28>>2]|0)){B=(z=0,aM(c[(c[x>>2]|0)+52>>2]|0,x|0,o|0)|0);if(!z){C=B}else{z=0;p=30;break L20}}else{c[y>>2]=A+4;c[A>>2]=o;C=o}if((C|0)!=-1){break}c[l>>2]=0}}while(0);t=t+4|0;u=a[d]|0}if((p|0)==30){d=bT(-1,-1)|0;u=M;Eo(n);D=u;E=d;F=E;G=0;H=F;I=D;bg(H|0)}else if((p|0)==31){c[b>>2]=c[l>>2];Eo(n);i=j;return}}}while(0);k=cl(4)|0;K$(k);z=0;aR(156,k|0,29336,98);if(z){z=0;break}}}while(0);j=bT(-1,-1)|0;n=M;DL(c[f>>2]|0)|0;D=n;E=j;F=E;G=0;H=F;I=D;bg(H|0)}function GS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+144|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+112|0;n=d+120|0;o=d+128|0;p=d+136|0;q=j|0;a[q]=a[13744]|0;a[q+1|0]=a[13745]|0;a[q+2|0]=a[13746]|0;a[q+3|0]=a[13747]|0;a[q+4|0]=a[13748]|0;a[q+5|0]=a[13749]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=100}}while(0);u=k|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}v=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=v;break}else{z=0;v=bT(-1,-1)|0;bg(v|0)}}}while(0);v=GF(u,12,c[10082]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+v|0;h=c[s>>2]&176;do{if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((v|0)>1&s<<24>>24==48)){x=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=k+2|0}else if((h|0)==32){w=q}else{x=22}}while(0);if((x|0)==22){w=u}x=l|0;Ey(o,f);z=0;aI(48,u|0,w|0,q|0,x|0,m|0,n|0,o|0);if(!z){DL(c[o>>2]|0)|0;c[p>>2]=c[e>>2];GU(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[o>>2]|0)|0;bg(d|0)}}function GT(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10438]|0)!=-1){c[n>>2]=41752;c[n+4>>2]=460;c[n+8>>2]=0;D4(41752,n,520)}n=(c[10439]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}r=k;s=c[p>>2]|0;if((c[10342]|0)!=-1){c[m>>2]=41368;c[m+4>>2]=460;c[m+8>>2]=0;D4(41368,m,520)}m=(c[10343]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}t=s;cB[c[(c[s>>2]|0)+20>>2]&1023](o,t);u=o;m=o;p=d[m]|0;if((p&1|0)==0){v=p>>>1}else{v=c[o+4>>2]|0}L23:do{if((v|0)==0){p=c[(c[k>>2]|0)+48>>2]|0;z=0,aU(p|0,r|0,b|0,f|0,g|0)|0;if(z){z=0;w=18;break}c[j>>2]=g+(f-b<<2)}else{c[j>>2]=g;p=a[b]|0;if((p<<24>>24|0)==45|(p<<24>>24|0)==43){n=(z=0,aM(c[(c[k>>2]|0)+44>>2]|0,r|0,p|0)|0);if(z){z=0;w=18;break}p=c[j>>2]|0;c[j>>2]=p+4;c[p>>2]=n;x=b+1|0}else{x=b}do{if((f-x|0)>1){if((a[x]|0)!=48){y=x;break}n=x+1|0;p=a[n]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){y=x;break}p=k;q=(z=0,aM(c[(c[p>>2]|0)+44>>2]|0,r|0,48)|0);if(z){z=0;w=18;break L23}A=c[j>>2]|0;c[j>>2]=A+4;c[A>>2]=q;q=(z=0,aM(c[(c[p>>2]|0)+44>>2]|0,r|0,a[n]|0)|0);if(z){z=0;w=18;break L23}n=c[j>>2]|0;c[j>>2]=n+4;c[n>>2]=q;y=x+2|0}else{y=x}}while(0);do{if((y|0)!=(f|0)){q=f-1|0;if(y>>>0<q>>>0){B=y;C=q}else{break}do{q=a[B]|0;a[B]=a[C]|0;a[C]=q;B=B+1|0;C=C-1|0;}while(B>>>0<C>>>0)}}while(0);q=(z=0,au(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(z){z=0;w=18;break}L44:do{if(y>>>0<f>>>0){n=u+1|0;p=k;A=o+4|0;D=o+8|0;E=0;F=0;G=y;while(1){H=(a[m]&1)==0;do{if((a[(H?n:c[D>>2]|0)+F|0]|0)==0){I=F;J=E}else{if((E|0)!=(a[(H?n:c[D>>2]|0)+F|0]|0)){I=F;J=E;break}K=c[j>>2]|0;c[j>>2]=K+4;c[K>>2]=q;K=d[m]|0;I=(F>>>0<(((K&1|0)==0?K>>>1:c[A>>2]|0)-1|0)>>>0)+F|0;J=0}}while(0);H=(z=0,aM(c[(c[p>>2]|0)+44>>2]|0,r|0,a[G]|0)|0);if(z){z=0;break}K=c[j>>2]|0;c[j>>2]=K+4;c[K>>2]=H;H=G+1|0;if(H>>>0<f>>>0){E=J+1|0;F=I;G=H}else{break L44}}G=bT(-1,-1)|0;L=M;N=G;Eb(o);bg(N|0)}}while(0);q=g+(y-b<<2)|0;G=c[j>>2]|0;if((q|0)==(G|0)){break}F=G-4|0;if(q>>>0<F>>>0){O=q;P=F}else{break}do{F=c[O>>2]|0;c[O>>2]=c[P>>2];c[P>>2]=F;O=O+4|0;P=P-4|0;}while(O>>>0<P>>>0)}}while(0);if((w|0)==18){w=bT(-1,-1)|0;L=M;N=w;Eb(o);bg(N|0)}if((e|0)==(f|0)){Q=c[j>>2]|0;c[h>>2]=Q;Eb(o);i=l;return}else{Q=g+(e-b<<2)|0;c[h>>2]=Q;Eb(o);i=l;return}}function GU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[l>>2];l=k|0;m=d|0;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((cI[c[(c[d>>2]|0)+48>>2]&127](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){En(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}g=(z=0,az(c[(c[d>>2]|0)+48>>2]|0,d|0,r|0,q|0)|0);if(z){z=0;e=bT(-1,-1)|0;Eo(l);bg(e|0)}if((g|0)==(q|0)){Eo(l);break}c[m>>2]=0;c[b>>2]=0;Eo(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((cI[c[(c[d>>2]|0)+48>>2]&127](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function GV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+232|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+200|0;o=d+208|0;p=d+216|0;q=d+224|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=l|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}t=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=t;break}else{z=0;t=bT(-1,-1)|0;bg(t|0)}}}while(0);t=GF(u,22,c[10082]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==32){w=r}else if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=l+2|0}else{x=22}}while(0);if((x|0)==22){w=u}x=m|0;Ey(p,f);z=0;aI(48,u|0,w|0,r|0,x|0,n|0,o|0,p|0);if(!z){DL(c[p>>2]|0)|0;c[q>>2]=c[e>>2];GU(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[p>>2]|0)|0;bg(d|0)}}function GW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+144|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+112|0;n=d+120|0;o=d+128|0;p=d+136|0;q=j|0;a[q]=a[13744]|0;a[q+1|0]=a[13745]|0;a[q+2|0]=a[13746]|0;a[q+3|0]=a[13747]|0;a[q+4|0]=a[13748]|0;a[q+5|0]=a[13749]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=117}}while(0);u=k|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}t=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=t;break}else{z=0;t=bT(-1,-1)|0;bg(t|0)}}}while(0);t=GF(u,12,c[10082]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+t|0;h=c[s>>2]&176;do{if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=k+2|0}else if((h|0)==32){w=q}else{x=22}}while(0);if((x|0)==22){w=u}x=l|0;Ey(o,f);z=0;aI(48,u|0,w|0,q|0,x|0,m|0,n|0,o|0);if(!z){DL(c[o>>2]|0)|0;c[p>>2]=c[e>>2];GU(b,p,x,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[o>>2]|0)|0;bg(d|0)}}function GX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+240|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+208|0;o=d+216|0;p=d+224|0;q=d+232|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=117}}while(0);u=l|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}t=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=t;break}else{z=0;t=bT(-1,-1)|0;bg(t|0)}}}while(0);t=GF(u,23,c[10082]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){x=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){x=22;break}w=l+2|0}else if((j|0)==32){w=r}else{x=22}}while(0);if((x|0)==22){w=u}x=m|0;Ey(p,f);z=0;aI(48,u|0,w|0,r|0,x|0,n|0,o|0,p|0);if(!z){DL(c[p>>2]|0)|0;c[q>>2]=c[e>>2];GU(b,q,x,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{z=0;d=bT(-1,-1)|0;DL(c[p>>2]|0)|0;bg(d|0)}}function GY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+320|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+280|0;p=d+288|0;q=d+296|0;r=d+304|0;s=d+312|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){if((k&1|0)==0){a[x]=97;y=0;break}else{a[x]=65;y=0;break}}else{a[x]=46;v=x+2|0;a[x+1|0]=42;if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;bg(l|0)}}}while(0);l=c[10082]|0;if(y){w=GF(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=GF(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[42320]|0)==0;L41:do{if(y){do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L41}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}else{do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L41}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}z=0;aS(4);if(z){z=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bT(-1,-1)|0;C=M;D=w}J=C;K=D;L=K;N=0;O=L;P=J;bg(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=Lo(G<<3)|0;u=D;if((D|0)!=0){R=u;S=u;T=I;F=59;break}z=0;aS(4);if(z){z=0;U=0;F=58;break}R=u;S=u;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){z=0;as(352,q|0,f|0);if(z){z=0;U=S;F=58;break}z=0;aI(70,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(z){z=0;m=bT(-1,-1)|0;I=M;DL(c[q>>2]|0)|0;V=m;W=I;X=S;break}DL(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];z=0;aI(52,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(z){z=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){Lp(S)}if((H|0)==0){i=d;return}Lp(H);i=d;return}}while(0);if((F|0)==58){F=bT(-1,-1)|0;V=F;W=M;X=U}if((X|0)!=0){Lp(X)}if((H|0)==0){J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}Lp(H);J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}function GZ(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10438]|0)!=-1){c[n>>2]=41752;c[n+4>>2]=460;c[n+8>>2]=0;D4(41752,n,520)}n=(c[10439]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=cl(4)|0;s=r;K$(s);bK(r|0,29336,98)}r=k;s=c[p>>2]|0;if((c[10342]|0)!=-1){c[m>>2]=41368;c[m+4>>2]=460;c[m+8>>2]=0;D4(41368,m,520)}m=(c[10343]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=cl(4)|0;u=t;K$(u);bK(t|0,29336,98)}t=s;cB[c[(c[s>>2]|0)+20>>2]&1023](o,t);c[j>>2]=g;u=a[b]|0;do{if((u<<24>>24|0)==45|(u<<24>>24|0)==43){m=(z=0,aM(c[(c[k>>2]|0)+44>>2]|0,r|0,u|0)|0);if(z){z=0;break}p=c[j>>2]|0;c[j>>2]=p+4;c[p>>2]=m;v=b+1|0;w=20}else{v=b;w=20}}while(0);L22:do{if((w|0)==20){u=f;L24:do{if((u-v|0)>1){if((a[v]|0)!=48){x=v;w=34;break}m=v+1|0;p=a[m]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){x=v;w=34;break}p=k;n=(z=0,aM(c[(c[p>>2]|0)+44>>2]|0,r|0,48)|0);if(z){z=0;break L22}q=c[j>>2]|0;c[j>>2]=q+4;c[q>>2]=n;n=v+2|0;q=(z=0,aM(c[(c[p>>2]|0)+44>>2]|0,r|0,a[m]|0)|0);if(z){z=0;break L22}m=c[j>>2]|0;c[j>>2]=m+4;c[m>>2]=q;q=n;L30:while(1){if(q>>>0>=f>>>0){y=q;A=n;break L24}m=a[q]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}p=(z=0,az(72,2147483647,10032,0)|0);if(z){z=0;w=31;break L30}c[10082]=p}}while(0);p=(z=0,aM(164,m<<24>>24|0,c[10082]|0)|0);if(z){z=0;w=17;break}if((p|0)==0){y=q;A=n;break L24}else{q=q+1|0}}if((w|0)==17){q=bT(-1,-1)|0;B=M;C=q;Eb(o);bg(C|0)}else if((w|0)==31){q=bT(-1,-1)|0;B=M;C=q;Eb(o);bg(C|0)}}else{x=v;w=34}}while(0);L44:do{if((w|0)==34){L45:while(1){w=0;if(x>>>0>=f>>>0){y=x;A=v;break L44}q=a[x]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}n=(z=0,az(72,2147483647,10032,0)|0);if(z){z=0;w=39;break L45}c[10082]=n}}while(0);m=(z=0,aM(68,q<<24>>24|0,c[10082]|0)|0);if(z){z=0;w=16;break}if((m|0)==0){y=x;A=v;break L44}else{x=x+1|0;w=34}}if((w|0)==39){m=bT(-1,-1)|0;B=M;C=m;Eb(o);bg(C|0)}else if((w|0)==16){m=bT(-1,-1)|0;B=M;C=m;Eb(o);bg(C|0)}}}while(0);m=o;n=o;p=d[n]|0;if((p&1|0)==0){D=p>>>1}else{D=c[o+4>>2]|0}do{if((D|0)==0){p=c[j>>2]|0;E=c[(c[k>>2]|0)+48>>2]|0;z=0,aU(E|0,r|0,A|0,y|0,p|0)|0;if(z){z=0;break L22}c[j>>2]=(c[j>>2]|0)+(y-A<<2)}else{do{if((A|0)!=(y|0)){p=y-1|0;if(A>>>0<p>>>0){F=A;G=p}else{break}do{p=a[F]|0;a[F]=a[G]|0;a[G]=p;F=F+1|0;G=G-1|0;}while(F>>>0<G>>>0)}}while(0);q=(z=0,au(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(z){z=0;break L22}L72:do{if(A>>>0<y>>>0){p=m+1|0;E=o+4|0;H=o+8|0;I=k;J=0;K=0;L=A;while(1){N=(a[n]&1)==0;do{if((a[(N?p:c[H>>2]|0)+K|0]|0)>0){if((J|0)!=(a[(N?p:c[H>>2]|0)+K|0]|0)){O=K;P=J;break}Q=c[j>>2]|0;c[j>>2]=Q+4;c[Q>>2]=q;Q=d[n]|0;O=(K>>>0<(((Q&1|0)==0?Q>>>1:c[E>>2]|0)-1|0)>>>0)+K|0;P=0}else{O=K;P=J}}while(0);N=(z=0,aM(c[(c[I>>2]|0)+44>>2]|0,r|0,a[L]|0)|0);if(z){z=0;break}Q=c[j>>2]|0;c[j>>2]=Q+4;c[Q>>2]=N;N=L+1|0;if(N>>>0<y>>>0){J=P+1|0;K=O;L=N}else{break L72}}L=bT(-1,-1)|0;B=M;C=L;Eb(o);bg(C|0)}}while(0);q=g+(A-b<<2)|0;L=c[j>>2]|0;if((q|0)==(L|0)){break}K=L-4|0;if(q>>>0<K>>>0){R=q;S=K}else{break}do{K=c[R>>2]|0;c[R>>2]=c[S>>2];c[S>>2]=K;R=R+4|0;S=S-4|0;}while(R>>>0<S>>>0)}}while(0);L90:do{if(y>>>0<f>>>0){n=k;m=y;while(1){K=a[m]|0;if(K<<24>>24==46){w=65;break}q=(z=0,aM(c[(c[n>>2]|0)+44>>2]|0,r|0,K|0)|0);if(z){z=0;w=14;break}K=c[j>>2]|0;c[j>>2]=K+4;c[K>>2]=q;q=m+1|0;if(q>>>0<f>>>0){m=q}else{T=q;break L90}}if((w|0)==14){n=bT(-1,-1)|0;B=M;C=n;Eb(o);bg(C|0)}else if((w|0)==65){n=(z=0,au(c[(c[s>>2]|0)+12>>2]|0,t|0)|0);if(z){z=0;break L22}q=c[j>>2]|0;c[j>>2]=q+4;c[q>>2]=n;T=m+1|0;break}}else{T=y}}while(0);n=c[j>>2]|0;q=c[(c[k>>2]|0)+48>>2]|0;z=0,aU(q|0,r|0,T|0,f|0,n|0)|0;if(z){z=0;break}n=(c[j>>2]|0)+(u-T<<2)|0;c[j>>2]=n;if((e|0)==(f|0)){U=n;c[h>>2]=U;Eb(o);i=l;return}U=g+(e-b<<2)|0;c[h>>2]=U;Eb(o);i=l;return}}while(0);l=bT(-1,-1)|0;B=M;C=l;Eb(o);bg(C|0)}function G_(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+320|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+280|0;p=d+288|0;q=d+296|0;r=d+304|0;s=d+312|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){x=w}else{a[w]=35;x=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){a[x]=76;v=x+1|0;if((k&1|0)==0){a[v]=97;y=0;break}else{a[v]=65;y=0;break}}else{a[x]=46;a[x+1|0]=42;a[x+2|0]=76;v=x+3|0;if((w|0)==4){if((k&1|0)==0){a[v]=102;y=1;break}else{a[v]=70;y=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;y=1;break}else{a[v]=69;y=1;break}}else{if((k&1|0)==0){a[v]=103;y=1;break}else{a[v]=71;y=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;bg(l|0)}}}while(0);l=c[10082]|0;if(y){w=GF(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=GF(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[42320]|0)==0;L40:do{if(y){do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L40}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}else{do{if(w){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;C=M;D=l;break L40}}}while(0);l=(z=0,aU(28,m|0,c[10082]|0,t|0,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0);i=A;if(!z){E=l;F=44}else{z=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}z=0;aS(4);if(z){z=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bT(-1,-1)|0;C=M;D=w}J=C;K=D;L=K;N=0;O=L;P=J;bg(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=Lo(G<<3)|0;u=D;if((D|0)!=0){R=u;S=u;T=I;F=59;break}z=0;aS(4);if(z){z=0;U=0;F=58;break}R=u;S=u;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){z=0;as(352,q|0,f|0);if(z){z=0;U=S;F=58;break}z=0;aI(70,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(z){z=0;m=bT(-1,-1)|0;I=M;DL(c[q>>2]|0)|0;V=m;W=I;X=S;break}DL(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];z=0;aI(52,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(z){z=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){Lp(S)}if((H|0)==0){i=d;return}Lp(H);i=d;return}}while(0);if((F|0)==58){F=bT(-1,-1)|0;V=F;W=M;X=U}if((X|0)!=0){Lp(X)}if((H|0)==0){J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}Lp(H);J=W;K=V;L=K;N=0;O=L;P=J;bg(O|0)}function G$(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+216|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+24|0;l=d+48|0;m=d+200|0;n=d+208|0;o=d+16|0;a[o]=a[13752]|0;a[o+1|0]=a[13753]|0;a[o+2|0]=a[13754]|0;a[o+3|0]=a[13755]|0;a[o+4|0]=a[13756]|0;a[o+5|0]=a[13757]|0;p=k|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}q=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=q;break}else{z=0;q=bT(-1,-1)|0;bg(q|0)}}}while(0);q=GF(p,20,c[10082]|0,o,(o=i,i=i+8|0,c[o>>2]=h,o)|0)|0;i=o;o=k+q|0;h=c[f+4>>2]&176;do{if((h|0)==16){r=a[p]|0;if((r<<24>>24|0)==45|(r<<24>>24|0)==43){s=k+1|0;break}if(!((q|0)>1&r<<24>>24==48)){t=12;break}r=a[k+1|0]|0;if(!((r<<24>>24|0)==120|(r<<24>>24|0)==88)){t=12;break}s=k+2|0}else if((h|0)==32){s=o}else{t=12}}while(0);if((t|0)==12){s=p}Ey(m,f);t=m|0;m=c[t>>2]|0;do{if((c[10438]|0)!=-1){c[j>>2]=41752;c[j+4>>2]=460;c[j+8>>2]=0;z=0;aR(2,41752,j|0,520);if(!z){break}else{z=0}u=bT(-1,-1)|0;v=M;w=c[t>>2]|0;x=w|0;y=DL(x)|0;bg(u|0)}}while(0);j=(c[10439]|0)-1|0;h=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-h>>2>>>0>j>>>0){r=c[h+(j<<2)>>2]|0;if((r|0)==0){break}DL(c[t>>2]|0)|0;A=l|0;c1[c[(c[r>>2]|0)+48>>2]&63](r,p,o,A)|0;r=l+(q<<2)|0;if((s|0)==(o|0)){B=r;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;GU(b,n,A,B,r,f,g);i=d;return}B=l+(s-k<<2)|0;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;GU(b,n,A,B,r,f,g);i=d;return}}while(0);d=cl(4)|0;K$(d);z=0;aR(156,d|0,29336,98);if(z){z=0;u=bT(-1,-1)|0;v=M;w=c[t>>2]|0;x=w|0;y=DL(x)|0;bg(u|0)}}function G0(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0;n=i;i=i+48|0;o=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[o>>2];o=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[o>>2];o=n|0;p=n+16|0;q=n+24|0;r=n+32|0;s=n+40|0;Ey(p,h);t=p|0;p=c[t>>2]|0;do{if((c[10440]|0)!=-1){c[o>>2]=41760;c[o+4>>2]=460;c[o+8>>2]=0;z=0;aR(2,41760,o|0,520);if(!z){break}else{z=0}u=bT(-1,-1)|0;v=M;w=c[t>>2]|0;x=w|0;y=DL(x)|0;bg(u|0)}}while(0);o=(c[10441]|0)-1|0;A=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-A>>2>>>0>o>>>0){B=c[A+(o<<2)>>2]|0;if((B|0)==0){break}C=B;DL(c[t>>2]|0)|0;c[j>>2]=0;D=f|0;L8:do{if((l|0)==(m|0)){E=67}else{F=g|0;G=B;H=B;I=B+8|0;J=e;K=r|0;L=s|0;N=q|0;O=l;P=0;L10:while(1){Q=P;while(1){if((Q|0)!=0){E=67;break L8}R=c[D>>2]|0;do{if((R|0)==0){S=0}else{if((c[R+12>>2]|0)!=(c[R+16>>2]|0)){S=R;break}if((cD[c[(c[R>>2]|0)+36>>2]&511](R)|0)!=-1){S=R;break}c[D>>2]=0;S=0}}while(0);R=(S|0)==0;T=c[F>>2]|0;L20:do{if((T|0)==0){E=20}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){if((cD[c[(c[T>>2]|0)+36>>2]&511](T)|0)!=-1){break}c[F>>2]=0;E=20;break L20}}while(0);if(R){U=T}else{E=21;break L10}}}while(0);if((E|0)==20){E=0;if(R){E=21;break L10}else{U=0}}if((cI[c[(c[G>>2]|0)+36>>2]&127](C,a[O]|0,0)|0)<<24>>24==37){E=24;break}T=a[O]|0;if(T<<24>>24>=0){V=c[I>>2]|0;if((b[V+(T<<24>>24<<1)>>1]&8192)!=0){W=O;E=35;break}}X=S+12|0;T=c[X>>2]|0;Y=S+16|0;if((T|0)==(c[Y>>2]|0)){Z=(cD[c[(c[S>>2]|0)+36>>2]&511](S)|0)&255}else{Z=a[T]|0}T=cV[c[(c[H>>2]|0)+12>>2]&1023](C,Z)|0;if(T<<24>>24==(cV[c[(c[H>>2]|0)+12>>2]&1023](C,a[O]|0)|0)<<24>>24){E=62;break}c[j>>2]=4;Q=4}L38:do{if((E|0)==35){while(1){E=0;Q=W+1|0;if((Q|0)==(m|0)){_=m;break}T=a[Q]|0;if(T<<24>>24<0){_=Q;break}if((b[V+(T<<24>>24<<1)>>1]&8192)==0){_=Q;break}else{W=Q;E=35}}R=S;Q=U;while(1){do{if((R|0)==0){$=0}else{if((c[R+12>>2]|0)!=(c[R+16>>2]|0)){$=R;break}if((cD[c[(c[R>>2]|0)+36>>2]&511](R)|0)!=-1){$=R;break}c[D>>2]=0;$=0}}while(0);T=($|0)==0;do{if((Q|0)==0){E=48}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){if(T){aa=Q;break}else{ab=_;break L38}}if((cD[c[(c[Q>>2]|0)+36>>2]&511](Q)|0)==-1){c[F>>2]=0;E=48;break}else{if(T^(Q|0)==0){aa=Q;break}else{ab=_;break L38}}}}while(0);if((E|0)==48){E=0;if(T){ab=_;break L38}else{aa=0}}ac=$+12|0;ad=c[ac>>2]|0;ae=$+16|0;if((ad|0)==(c[ae>>2]|0)){af=(cD[c[(c[$>>2]|0)+36>>2]&511]($)|0)&255}else{af=a[ad]|0}if(af<<24>>24<0){ab=_;break L38}if((b[(c[I>>2]|0)+(af<<24>>24<<1)>>1]&8192)==0){ab=_;break L38}ad=c[ac>>2]|0;if((ad|0)==(c[ae>>2]|0)){cD[c[(c[$>>2]|0)+40>>2]&511]($)|0;R=$;Q=aa;continue}else{c[ac>>2]=ad+1;R=$;Q=aa;continue}}}else if((E|0)==24){E=0;Q=O+1|0;if((Q|0)==(m|0)){E=25;break L10}R=cI[c[(c[G>>2]|0)+36>>2]&127](C,a[Q]|0,0)|0;if((R<<24>>24|0)==69|(R<<24>>24|0)==48){ad=O+2|0;if((ad|0)==(m|0)){E=28;break L10}ag=R;ah=cI[c[(c[G>>2]|0)+36>>2]&127](C,a[ad]|0,0)|0;ai=ad}else{ag=0;ah=R;ai=Q}Q=c[(c[J>>2]|0)+36>>2]|0;c[K>>2]=S;c[L>>2]=U;cT[Q&7](q,e,r,s,h,j,k,ah,ag);c[D>>2]=c[N>>2];ab=ai+1|0}else if((E|0)==62){E=0;Q=c[X>>2]|0;if((Q|0)==(c[Y>>2]|0)){cD[c[(c[S>>2]|0)+40>>2]&511](S)|0}else{c[X>>2]=Q+1}ab=O+1|0}}while(0);if((ab|0)==(m|0)){E=67;break L8}O=ab;P=c[j>>2]|0}if((E|0)==28){c[j>>2]=4;aj=S;break}else if((E|0)==25){c[j>>2]=4;aj=S;break}else if((E|0)==21){c[j>>2]=4;aj=S;break}}}while(0);if((E|0)==67){aj=c[D>>2]|0}C=f|0;do{if((aj|0)!=0){if((c[aj+12>>2]|0)!=(c[aj+16>>2]|0)){break}if((cD[c[(c[aj>>2]|0)+36>>2]&511](aj)|0)!=-1){break}c[C>>2]=0}}while(0);D=c[C>>2]|0;B=(D|0)==0;P=g|0;O=c[P>>2]|0;L96:do{if((O|0)==0){E=77}else{do{if((c[O+12>>2]|0)==(c[O+16>>2]|0)){if((cD[c[(c[O>>2]|0)+36>>2]&511](O)|0)!=-1){break}c[P>>2]=0;E=77;break L96}}while(0);if(!B){break}ak=d|0;c[ak>>2]=D;i=n;return}}while(0);do{if((E|0)==77){if(B){break}ak=d|0;c[ak>>2]=D;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ak=d|0;c[ak>>2]=D;i=n;return}}while(0);n=cl(4)|0;K$(n);z=0;aR(156,n|0,29336,98);if(z){z=0;u=bT(-1,-1)|0;v=M;w=c[t>>2]|0;x=w|0;y=DL(x)|0;bg(u|0)}}function G1(a){a=a|0;DJ(a|0);Lw(a);return}function G2(a){a=a|0;DJ(a|0);return}function G3(a){a=a|0;return 2}function G4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;c[k>>2]=c[d>>2];c[l>>2]=c[e>>2];G0(a,b,k,l,f,g,h,13736,13744);i=j;return}function G5(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+8|0;n=d+8|0;o=cD[c[(c[n>>2]|0)+20>>2]&511](n)|0;c[l>>2]=c[e>>2];c[m>>2]=c[f>>2];f=o;e=a[o]|0;if((e&1)==0){p=f+1|0;q=f+1|0}else{f=c[o+8>>2]|0;p=f;q=f}f=e&255;if((f&1|0)==0){r=f>>>1}else{r=c[o+4>>2]|0}G0(b,d,l,m,g,h,j,q,p+r|0);i=k;return}function G6(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;Ey(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10440]|0)!=-1){c[l>>2]=41760;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41760,l|0,520);if(!z){break}else{z=0}n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}while(0);l=(c[10441]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}DL(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cD[c[c[v>>2]>>2]&511](v)|0;c[k>>2]=u;u=(FN(d,k,w,w+168|0,t,g,0)|0)-w|0;if((u|0)>=168){x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}c[h+24>>2]=((u|0)/12|0|0)%7|0;x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}}while(0);j=cl(4)|0;K$(j);z=0;aR(156,j|0,29336,98);if(z){z=0;n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}function G7(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;Ey(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10440]|0)!=-1){c[l>>2]=41760;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41760,l|0,520);if(!z){break}else{z=0}n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}while(0);l=(c[10441]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}DL(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cD[c[(c[v>>2]|0)+4>>2]&511](v)|0;c[k>>2]=u;u=(FN(d,k,w,w+288|0,t,g,0)|0)-w|0;if((u|0)>=288){x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}c[h+16>>2]=((u|0)/12|0|0)%12|0;x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}}while(0);j=cl(4)|0;K$(j);z=0;aR(156,j|0,29336,98);if(z){z=0;n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}function G8(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+32|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;l=b+24|0;Ey(l,f);f=l|0;l=c[f>>2]|0;do{if((c[10440]|0)!=-1){c[k>>2]=41760;c[k+4>>2]=460;c[k+8>>2]=0;z=0;aR(2,41760,k|0,520);if(!z){break}else{z=0}m=bT(-1,-1)|0;n=M;o=c[f>>2]|0;p=o|0;q=DL(p)|0;bg(m|0)}}while(0);k=(c[10441]|0)-1|0;r=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-r>>2>>>0>k>>>0){s=c[r+(k<<2)>>2]|0;if((s|0)==0){break}DL(c[f>>2]|0)|0;c[j>>2]=c[e>>2];t=Hd(d,j,g,s,4)|0;if((c[g>>2]&4|0)!=0){u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}if((t|0)<69){x=t+2e3|0}else{x=(t-69|0)>>>0<31>>>0?t+1900|0:t}c[h+20>>2]=x-1900;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}}while(0);b=cl(4)|0;K$(b);z=0;aR(156,b|0,29336,98);if(z){z=0;m=bT(-1,-1)|0;n=M;o=c[f>>2]|0;p=o|0;q=DL(p)|0;bg(m|0)}}function G9(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0;l=i;i=i+328|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=l|0;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;N=l+208|0;O=l+216|0;P=l+224|0;Q=l+232|0;R=l+240|0;S=l+248|0;T=l+256|0;U=l+264|0;V=l+272|0;W=l+280|0;X=l+288|0;Y=l+296|0;Z=l+304|0;_=l+312|0;$=l+320|0;c[h>>2]=0;Ey(A,g);aa=A|0;A=c[aa>>2]|0;do{if((c[10440]|0)!=-1){c[y>>2]=41760;c[y+4>>2]=460;c[y+8>>2]=0;z=0;aR(2,41760,y|0,520);if(!z){break}else{z=0}ab=bT(-1,-1)|0;ac=M;ad=c[aa>>2]|0;ae=ad|0;af=DL(ae)|0;bg(ab|0)}}while(0);y=(c[10441]|0)-1|0;ag=c[A+8>>2]|0;do{if((c[A+12>>2]|0)-ag>>2>>>0>y>>>0){ah=c[ag+(y<<2)>>2]|0;if((ah|0)==0){break}ai=ah;DL(c[aa>>2]|0)|0;L8:do{switch(k<<24>>24|0){case 84:{ah=e|0;c[U>>2]=c[ah>>2];c[V>>2]=c[f>>2];G0(T,d,U,V,g,h,j,13688,13696);c[ah>>2]=c[T>>2];break};case 121:{c[n>>2]=c[f>>2];ah=Hd(e,n,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}if((ah|0)<69){aj=ah+2e3|0}else{aj=(ah-69|0)>>>0<31>>>0?ah+1900|0:ah}c[j+20>>2]=aj-1900;break};case 99:{ah=d+8|0;ak=cD[c[(c[ah>>2]|0)+12>>2]&511](ah)|0;ah=e|0;c[C>>2]=c[ah>>2];c[D>>2]=c[f>>2];al=ak;am=a[ak]|0;if((am&1)==0){an=al+1|0;ao=al+1|0}else{al=c[ak+8>>2]|0;an=al;ao=al}al=am&255;if((al&1|0)==0){ap=al>>>1}else{ap=c[ak+4>>2]|0}G0(B,d,C,D,g,h,j,ao,an+ap|0);c[ah>>2]=c[B>>2];break};case 98:case 66:case 104:{ah=c[f>>2]|0;ak=d+8|0;al=cD[c[(c[ak>>2]|0)+4>>2]&511](ak)|0;c[w>>2]=ah;ah=(FN(e,w,al,al+288|0,ai,h,0)|0)-al|0;if((ah|0)>=288){break L8}c[j+16>>2]=((ah|0)/12|0|0)%12|0;break};case 82:{ah=e|0;c[R>>2]=c[ah>>2];c[S>>2]=c[f>>2];G0(Q,d,R,S,g,h,j,13696,13701);c[ah>>2]=c[Q>>2];break};case 83:{c[p>>2]=c[f>>2];ah=Hd(e,p,h,ai,2)|0;al=c[h>>2]|0;if((al&4|0)==0&(ah|0)<61){c[j>>2]=ah;break L8}else{c[h>>2]=al|4;break L8}break};case 119:{c[o>>2]=c[f>>2];al=Hd(e,o,h,ai,1)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(al|0)<7){c[j+24>>2]=al;break L8}else{c[h>>2]=ah|4;break L8}break};case 120:{ah=c[(c[d>>2]|0)+20>>2]|0;c[W>>2]=c[e>>2];c[X>>2]=c[f>>2];cR[ah&127](b,d,W,X,g,h,j);i=l;return};case 88:{ah=d+8|0;al=cD[c[(c[ah>>2]|0)+24>>2]&511](ah)|0;ah=e|0;c[Z>>2]=c[ah>>2];c[_>>2]=c[f>>2];ak=al;am=a[al]|0;if((am&1)==0){aq=ak+1|0;ar=ak+1|0}else{ak=c[al+8>>2]|0;aq=ak;ar=ak}ak=am&255;if((ak&1|0)==0){as=ak>>>1}else{as=c[al+4>>2]|0}G0(Y,d,Z,_,g,h,j,ar,aq+as|0);c[ah>>2]=c[Y>>2];break};case 72:{c[u>>2]=c[f>>2];ah=Hd(e,u,h,ai,2)|0;al=c[h>>2]|0;if((al&4|0)==0&(ah|0)<24){c[j+8>>2]=ah;break L8}else{c[h>>2]=al|4;break L8}break};case 73:{al=j+8|0;c[t>>2]=c[f>>2];ah=Hd(e,t,h,ai,2)|0;ak=c[h>>2]|0;do{if((ak&4|0)==0){if((ah-1|0)>>>0>=12>>>0){break}c[al>>2]=ah;break L8}}while(0);c[h>>2]=ak|4;break};case 106:{c[s>>2]=c[f>>2];ah=Hd(e,s,h,ai,3)|0;al=c[h>>2]|0;if((al&4|0)==0&(ah|0)<366){c[j+28>>2]=ah;break L8}else{c[h>>2]=al|4;break L8}break};case 109:{c[r>>2]=c[f>>2];al=(Hd(e,r,h,ai,2)|0)-1|0;ah=c[h>>2]|0;if((ah&4|0)==0&(al|0)<12){c[j+16>>2]=al;break L8}else{c[h>>2]=ah|4;break L8}break};case 68:{ah=e|0;c[F>>2]=c[ah>>2];c[G>>2]=c[f>>2];G0(E,d,F,G,g,h,j,13728,13736);c[ah>>2]=c[E>>2];break};case 110:case 116:{c[K>>2]=c[f>>2];Ha(0,e,K,h,ai);break};case 112:{c[L>>2]=c[f>>2];Hb(d,j+8|0,e,L,h,ai);break};case 77:{c[q>>2]=c[f>>2];ah=Hd(e,q,h,ai,2)|0;al=c[h>>2]|0;if((al&4|0)==0&(ah|0)<60){c[j+4>>2]=ah;break L8}else{c[h>>2]=al|4;break L8}break};case 100:case 101:{al=j+12|0;c[v>>2]=c[f>>2];ah=Hd(e,v,h,ai,2)|0;am=c[h>>2]|0;do{if((am&4|0)==0){if((ah-1|0)>>>0>=31>>>0){break}c[al>>2]=ah;break L8}}while(0);c[h>>2]=am|4;break};case 114:{ah=e|0;c[O>>2]=c[ah>>2];c[P>>2]=c[f>>2];G0(N,d,O,P,g,h,j,13704,13715);c[ah>>2]=c[N>>2];break};case 97:case 65:{ah=c[f>>2]|0;al=d+8|0;ak=cD[c[c[al>>2]>>2]&511](al)|0;c[x>>2]=ah;ah=(FN(e,x,ak,ak+168|0,ai,h,0)|0)-ak|0;if((ah|0)>=168){break L8}c[j+24>>2]=((ah|0)/12|0|0)%7|0;break};case 70:{ah=e|0;c[I>>2]=c[ah>>2];c[J>>2]=c[f>>2];G0(H,d,I,J,g,h,j,13720,13728);c[ah>>2]=c[H>>2];break};case 89:{c[m>>2]=c[f>>2];ah=Hd(e,m,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}c[j+20>>2]=ah-1900;break};case 37:{c[$>>2]=c[f>>2];Hc(0,e,$,h,ai);break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}}while(0);l=cl(4)|0;K$(l);z=0;aR(156,l|0,29336,98);if(z){z=0;ab=bT(-1,-1)|0;ac=M;ad=c[aa>>2]|0;ae=ad|0;af=DL(ae)|0;bg(ab|0)}}function Ha(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;j=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[j>>2];j=e|0;e=f|0;f=h+8|0;L1:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((cD[c[(c[h>>2]|0)+36>>2]&511](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;L10:do{if((l|0)==0){m=12}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if((cD[c[(c[l>>2]|0)+36>>2]&511](l)|0)!=-1){break}c[e>>2]=0;m=12;break L10}}while(0);if(h){n=l;o=0}else{p=l;q=0;break L1}}}while(0);if((m|0)==12){m=0;if(h){p=0;q=1;break}else{n=0;o=1}}l=c[j>>2]|0;r=c[l+12>>2]|0;if((r|0)==(c[l+16>>2]|0)){s=(cD[c[(c[l>>2]|0)+36>>2]&511](l)|0)&255}else{s=a[r]|0}if(s<<24>>24<0){p=n;q=o;break}if((b[(c[f>>2]|0)+(s<<24>>24<<1)>>1]&8192)==0){p=n;q=o;break}r=c[j>>2]|0;l=r+12|0;t=c[l>>2]|0;if((t|0)==(c[r+16>>2]|0)){cD[c[(c[r>>2]|0)+40>>2]&511](r)|0;continue}else{c[l>>2]=t+1;continue}}o=c[j>>2]|0;do{if((o|0)==0){u=0}else{if((c[o+12>>2]|0)!=(c[o+16>>2]|0)){u=o;break}if((cD[c[(c[o>>2]|0)+36>>2]&511](o)|0)==-1){c[j>>2]=0;u=0;break}else{u=c[j>>2]|0;break}}}while(0);j=(u|0)==0;do{if(q){m=31}else{if((c[p+12>>2]|0)!=(c[p+16>>2]|0)){if(!(j^(p|0)==0)){break}i=d;return}if((cD[c[(c[p>>2]|0)+36>>2]&511](p)|0)==-1){c[e>>2]=0;m=31;break}if(!j){break}i=d;return}}while(0);do{if((m|0)==31){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function Hb(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+8|0;k=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[k>>2];k=j|0;l=a+8|0;a=cD[c[(c[l>>2]|0)+8>>2]&511](l)|0;l=d[a]|0;if((l&1|0)==0){m=l>>>1}else{m=c[a+4>>2]|0}l=d[a+12|0]|0;if((l&1|0)==0){n=l>>>1}else{n=c[a+16>>2]|0}if((m|0)==(-n|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[k>>2]=c[f>>2];f=FN(e,k,a,a+24|0,h,g,0)|0;g=f-a|0;do{if((f|0)==(a|0)){if((c[b>>2]|0)!=12){break}c[b>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[b>>2]|0;if((g|0)>=12){i=j;return}c[b>>2]=g+12;i=j;return}function Hc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=d|0;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((cD[c[(c[d>>2]|0)+36>>2]&511](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e|0;e=c[j>>2]|0;L8:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if((cD[c[(c[e>>2]|0)+36>>2]&511](e)|0)!=-1){break}c[j>>2]=0;k=11;break L8}}while(0);if(d){l=e;m=0}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0;m=1}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){n=(cD[c[(c[d>>2]|0)+36>>2]&511](d)|0)&255}else{n=a[e]|0}if((cI[c[(c[g>>2]|0)+36>>2]&127](g,n,0)|0)<<24>>24!=37){c[f>>2]=c[f>>2]|4;i=b;return}n=c[h>>2]|0;g=n+12|0;e=c[g>>2]|0;if((e|0)==(c[n+16>>2]|0)){cD[c[(c[n>>2]|0)+40>>2]&511](n)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){o=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){o=e;break}if((cD[c[(c[e>>2]|0)+36>>2]&511](e)|0)==-1){c[h>>2]=0;o=0;break}else{o=c[h>>2]|0;break}}}while(0);h=(o|0)==0;do{if(m){k=31}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(!(h^(l|0)==0)){break}i=b;return}if((cD[c[(c[l>>2]|0)+36>>2]&511](l)|0)==-1){c[j>>2]=0;k=31;break}if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function Hd(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((cD[c[(c[d>>2]|0)+36>>2]&511](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e|0;e=c[l>>2]|0;L8:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if((cD[c[(c[e>>2]|0)+36>>2]&511](e)|0)!=-1){break}c[l>>2]=0;m=11;break L8}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(cD[c[(c[d>>2]|0)+36>>2]&511](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>=0){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=g;q=(cI[c[(c[d>>2]|0)+36>>2]&127](g,p,0)|0)<<24>>24;r=c[k>>2]|0;s=r+12|0;t=c[s>>2]|0;if((t|0)==(c[r+16>>2]|0)){cD[c[(c[r>>2]|0)+40>>2]&511](r)|0;u=q;v=h;w=n}else{c[s>>2]=t+1;u=q;v=h;w=n}while(1){x=u-48|0;q=v-1|0;t=c[k>>2]|0;do{if((t|0)==0){y=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){y=t;break}if((cD[c[(c[t>>2]|0)+36>>2]&511](t)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);t=(y|0)==0;if((w|0)==0){z=y;A=0}else{do{if((c[w+12>>2]|0)==(c[w+16>>2]|0)){if((cD[c[(c[w>>2]|0)+36>>2]&511](w)|0)!=-1){B=w;break}c[l>>2]=0;B=0}else{B=w}}while(0);z=c[k>>2]|0;A=B}C=(A|0)==0;if(!((t^C)&(q|0)>0)){m=41;break}s=c[z+12>>2]|0;if((s|0)==(c[z+16>>2]|0)){D=(cD[c[(c[z>>2]|0)+36>>2]&511](z)|0)&255}else{D=a[s]|0}if(D<<24>>24<0){o=x;m=57;break}if((b[(c[e>>2]|0)+(D<<24>>24<<1)>>1]&2048)==0){o=x;m=58;break}s=((cI[c[(c[d>>2]|0)+36>>2]&127](g,D,0)|0)<<24>>24)+(x*10|0)|0;r=c[k>>2]|0;E=r+12|0;F=c[E>>2]|0;if((F|0)==(c[r+16>>2]|0)){cD[c[(c[r>>2]|0)+40>>2]&511](r)|0;u=s;v=q;w=A;continue}else{c[E>>2]=F+1;u=s;v=q;w=A;continue}}if((m|0)==41){do{if((z|0)==0){G=0}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){G=z;break}if((cD[c[(c[z>>2]|0)+36>>2]&511](z)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);d=(G|0)==0;L65:do{if(C){m=51}else{do{if((c[A+12>>2]|0)==(c[A+16>>2]|0)){if((cD[c[(c[A>>2]|0)+36>>2]&511](A)|0)!=-1){break}c[l>>2]=0;m=51;break L65}}while(0);if(d){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==51){if(d){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==57){i=j;return o|0}else if((m|0)==58){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function He(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;l=i;i=i+48|0;m=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[m>>2];m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=l|0;n=l+16|0;o=l+24|0;p=l+32|0;q=l+40|0;Ey(n,f);r=n|0;n=c[r>>2]|0;do{if((c[10438]|0)!=-1){c[m>>2]=41752;c[m+4>>2]=460;c[m+8>>2]=0;z=0;aR(2,41752,m|0,520);if(!z){break}else{z=0}s=bT(-1,-1)|0;t=M;u=c[r>>2]|0;v=u|0;w=DL(v)|0;bg(s|0)}}while(0);m=(c[10439]|0)-1|0;x=c[n+8>>2]|0;do{if((c[n+12>>2]|0)-x>>2>>>0>m>>>0){y=c[x+(m<<2)>>2]|0;if((y|0)==0){break}A=y;DL(c[r>>2]|0)|0;c[g>>2]=0;B=d|0;L8:do{if((j|0)==(k|0)){C=71}else{D=e|0;E=y;F=y;G=y;H=b;I=p|0;J=q|0;K=o|0;L=j;N=0;L10:while(1){O=N;while(1){if((O|0)!=0){C=71;break L8}P=c[B>>2]|0;do{if((P|0)==0){Q=0}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=cD[c[(c[P>>2]|0)+36>>2]&511](P)|0}else{S=c[R>>2]|0}if((S|0)!=-1){Q=P;break}c[B>>2]=0;Q=0}}while(0);P=(Q|0)==0;R=c[D>>2]|0;do{if((R|0)==0){C=23}else{T=c[R+12>>2]|0;if((T|0)==(c[R+16>>2]|0)){U=cD[c[(c[R>>2]|0)+36>>2]&511](R)|0}else{U=c[T>>2]|0}if((U|0)==-1){c[D>>2]=0;C=23;break}else{if(P^(R|0)==0){V=R;break}else{C=25;break L10}}}}while(0);if((C|0)==23){C=0;if(P){C=25;break L10}else{V=0}}if((cI[c[(c[E>>2]|0)+52>>2]&127](A,c[L>>2]|0,0)|0)<<24>>24==37){C=28;break}if(cI[c[(c[F>>2]|0)+12>>2]&127](A,8192,c[L>>2]|0)|0){W=L;C=38;break}X=Q+12|0;R=c[X>>2]|0;Y=Q+16|0;if((R|0)==(c[Y>>2]|0)){Z=cD[c[(c[Q>>2]|0)+36>>2]&511](Q)|0}else{Z=c[R>>2]|0}R=cV[c[(c[G>>2]|0)+28>>2]&1023](A,Z)|0;if((R|0)==(cV[c[(c[G>>2]|0)+28>>2]&1023](A,c[L>>2]|0)|0)){C=66;break}c[g>>2]=4;O=4}L42:do{if((C|0)==38){while(1){C=0;O=W+4|0;if((O|0)==(k|0)){_=k;break}if(cI[c[(c[F>>2]|0)+12>>2]&127](A,8192,c[O>>2]|0)|0){W=O;C=38}else{_=O;break}}P=Q;O=V;while(1){do{if((P|0)==0){$=0}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){aa=cD[c[(c[P>>2]|0)+36>>2]&511](P)|0}else{aa=c[R>>2]|0}if((aa|0)!=-1){$=P;break}c[B>>2]=0;$=0}}while(0);R=($|0)==0;do{if((O|0)==0){C=53}else{T=c[O+12>>2]|0;if((T|0)==(c[O+16>>2]|0)){ab=cD[c[(c[O>>2]|0)+36>>2]&511](O)|0}else{ab=c[T>>2]|0}if((ab|0)==-1){c[D>>2]=0;C=53;break}else{if(R^(O|0)==0){ac=O;break}else{ad=_;break L42}}}}while(0);if((C|0)==53){C=0;if(R){ad=_;break L42}else{ac=0}}T=$+12|0;ae=c[T>>2]|0;af=$+16|0;if((ae|0)==(c[af>>2]|0)){ag=cD[c[(c[$>>2]|0)+36>>2]&511]($)|0}else{ag=c[ae>>2]|0}if(!(cI[c[(c[F>>2]|0)+12>>2]&127](A,8192,ag)|0)){ad=_;break L42}ae=c[T>>2]|0;if((ae|0)==(c[af>>2]|0)){cD[c[(c[$>>2]|0)+40>>2]&511]($)|0;P=$;O=ac;continue}else{c[T>>2]=ae+4;P=$;O=ac;continue}}}else if((C|0)==28){C=0;O=L+4|0;if((O|0)==(k|0)){C=29;break L10}P=cI[c[(c[E>>2]|0)+52>>2]&127](A,c[O>>2]|0,0)|0;if((P<<24>>24|0)==69|(P<<24>>24|0)==48){ae=L+8|0;if((ae|0)==(k|0)){C=32;break L10}ah=P;ai=cI[c[(c[E>>2]|0)+52>>2]&127](A,c[ae>>2]|0,0)|0;aj=ae}else{ah=0;ai=P;aj=O}O=c[(c[H>>2]|0)+36>>2]|0;c[I>>2]=Q;c[J>>2]=V;cT[O&7](o,b,p,q,f,g,h,ai,ah);c[B>>2]=c[K>>2];ad=aj+4|0}else if((C|0)==66){C=0;O=c[X>>2]|0;if((O|0)==(c[Y>>2]|0)){cD[c[(c[Q>>2]|0)+40>>2]&511](Q)|0}else{c[X>>2]=O+4}ad=L+4|0}}while(0);if((ad|0)==(k|0)){C=71;break L8}L=ad;N=c[g>>2]|0}if((C|0)==25){c[g>>2]=4;ak=Q;break}else if((C|0)==29){c[g>>2]=4;ak=Q;break}else if((C|0)==32){c[g>>2]=4;ak=Q;break}}}while(0);if((C|0)==71){ak=c[B>>2]|0}A=d|0;do{if((ak|0)!=0){y=c[ak+12>>2]|0;if((y|0)==(c[ak+16>>2]|0)){al=cD[c[(c[ak>>2]|0)+36>>2]&511](ak)|0}else{al=c[y>>2]|0}if((al|0)!=-1){break}c[A>>2]=0}}while(0);B=c[A>>2]|0;y=(B|0)==0;N=e|0;L=c[N>>2]|0;do{if((L|0)==0){C=84}else{K=c[L+12>>2]|0;if((K|0)==(c[L+16>>2]|0)){am=cD[c[(c[L>>2]|0)+36>>2]&511](L)|0}else{am=c[K>>2]|0}if((am|0)==-1){c[N>>2]=0;C=84;break}if(!(y^(L|0)==0)){break}an=a|0;c[an>>2]=B;i=l;return}}while(0);do{if((C|0)==84){if(y){break}an=a|0;c[an>>2]=B;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;an=a|0;c[an>>2]=B;i=l;return}}while(0);l=cl(4)|0;K$(l);z=0;aR(156,l|0,29336,98);if(z){z=0;s=bT(-1,-1)|0;t=M;u=c[r>>2]|0;v=u|0;w=DL(v)|0;bg(s|0)}}function Hf(a){a=a|0;DJ(a|0);Lw(a);return}function Hg(a){a=a|0;DJ(a|0);return}function Hh(a){a=a|0;return 2}function Hi(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;c[k>>2]=c[d>>2];c[l>>2]=c[e>>2];He(a,b,k,l,f,g,h,13656,13688);i=j;return}function Hj(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+8|0;n=d+8|0;o=cD[c[(c[n>>2]|0)+20>>2]&511](n)|0;c[l>>2]=c[e>>2];c[m>>2]=c[f>>2];f=a[o]|0;if((f&1)==0){p=o+4|0;q=o+4|0}else{e=c[o+8>>2]|0;p=e;q=e}e=f&255;if((e&1|0)==0){r=e>>>1}else{r=c[o+4>>2]|0}He(b,d,l,m,g,h,j,q,p+(r<<2)|0);i=k;return}function Hk(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;Ey(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10438]|0)!=-1){c[l>>2]=41752;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41752,l|0,520);if(!z){break}else{z=0}n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}while(0);l=(c[10439]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}DL(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cD[c[c[v>>2]>>2]&511](v)|0;c[k>>2]=u;u=(Ga(d,k,w,w+168|0,t,g,0)|0)-w|0;if((u|0)>=168){x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}c[h+24>>2]=((u|0)/12|0|0)%7|0;x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}}while(0);j=cl(4)|0;K$(j);z=0;aR(156,j|0,29336,98);if(z){z=0;n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}function Hl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;Ey(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10438]|0)!=-1){c[l>>2]=41752;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41752,l|0,520);if(!z){break}else{z=0}n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}while(0);l=(c[10439]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}DL(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cD[c[(c[v>>2]|0)+4>>2]&511](v)|0;c[k>>2]=u;u=(Ga(d,k,w,w+288|0,t,g,0)|0)-w|0;if((u|0)>=288){x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}c[h+16>>2]=((u|0)/12|0|0)%12|0;x=d|0;y=c[x>>2]|0;A=a|0;c[A>>2]=y;i=j;return}}while(0);j=cl(4)|0;K$(j);z=0;aR(156,j|0,29336,98);if(z){z=0;n=bT(-1,-1)|0;o=M;p=c[f>>2]|0;q=p|0;r=DL(q)|0;bg(n|0)}}function Hm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+32|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;l=b+24|0;Ey(l,f);f=l|0;l=c[f>>2]|0;do{if((c[10438]|0)!=-1){c[k>>2]=41752;c[k+4>>2]=460;c[k+8>>2]=0;z=0;aR(2,41752,k|0,520);if(!z){break}else{z=0}m=bT(-1,-1)|0;n=M;o=c[f>>2]|0;p=o|0;q=DL(p)|0;bg(m|0)}}while(0);k=(c[10439]|0)-1|0;r=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-r>>2>>>0>k>>>0){s=c[r+(k<<2)>>2]|0;if((s|0)==0){break}DL(c[f>>2]|0)|0;c[j>>2]=c[e>>2];t=Hr(d,j,g,s,4)|0;if((c[g>>2]&4|0)!=0){u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}if((t|0)<69){x=t+2e3|0}else{x=(t-69|0)>>>0<31>>>0?t+1900|0:t}c[h+20>>2]=x-1900;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}}while(0);b=cl(4)|0;K$(b);z=0;aR(156,b|0,29336,98);if(z){z=0;m=bT(-1,-1)|0;n=M;o=c[f>>2]|0;p=o|0;q=DL(p)|0;bg(m|0)}}function Hn(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0;l=i;i=i+328|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=l|0;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;N=l+208|0;O=l+216|0;P=l+224|0;Q=l+232|0;R=l+240|0;S=l+248|0;T=l+256|0;U=l+264|0;V=l+272|0;W=l+280|0;X=l+288|0;Y=l+296|0;Z=l+304|0;_=l+312|0;$=l+320|0;c[h>>2]=0;Ey(A,g);aa=A|0;A=c[aa>>2]|0;do{if((c[10438]|0)!=-1){c[y>>2]=41752;c[y+4>>2]=460;c[y+8>>2]=0;z=0;aR(2,41752,y|0,520);if(!z){break}else{z=0}ab=bT(-1,-1)|0;ac=M;ad=c[aa>>2]|0;ae=ad|0;af=DL(ae)|0;bg(ab|0)}}while(0);y=(c[10439]|0)-1|0;ag=c[A+8>>2]|0;do{if((c[A+12>>2]|0)-ag>>2>>>0>y>>>0){ah=c[ag+(y<<2)>>2]|0;if((ah|0)==0){break}ai=ah;DL(c[aa>>2]|0)|0;L8:do{switch(k<<24>>24|0){case 68:{ah=e|0;c[F>>2]=c[ah>>2];c[G>>2]=c[f>>2];He(E,d,F,G,g,h,j,13624,13656);c[ah>>2]=c[E>>2];break};case 70:{ah=e|0;c[I>>2]=c[ah>>2];c[J>>2]=c[f>>2];He(H,d,I,J,g,h,j,13488,13520);c[ah>>2]=c[H>>2];break};case 89:{c[m>>2]=c[f>>2];ah=Hr(e,m,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}c[j+20>>2]=ah-1900;break};case 37:{c[$>>2]=c[f>>2];Hq(0,e,$,h,ai);break};case 98:case 66:case 104:{ah=c[f>>2]|0;aj=d+8|0;ak=cD[c[(c[aj>>2]|0)+4>>2]&511](aj)|0;c[w>>2]=ah;ah=(Ga(e,w,ak,ak+288|0,ai,h,0)|0)-ak|0;if((ah|0)>=288){break L8}c[j+16>>2]=((ah|0)/12|0|0)%12|0;break};case 110:case 116:{c[K>>2]=c[f>>2];Ho(0,e,K,h,ai);break};case 112:{c[L>>2]=c[f>>2];Hp(d,j+8|0,e,L,h,ai);break};case 114:{ah=e|0;c[O>>2]=c[ah>>2];c[P>>2]=c[f>>2];He(N,d,O,P,g,h,j,13576,13620);c[ah>>2]=c[N>>2];break};case 82:{ah=e|0;c[R>>2]=c[ah>>2];c[S>>2]=c[f>>2];He(Q,d,R,S,g,h,j,13552,13572);c[ah>>2]=c[Q>>2];break};case 121:{c[n>>2]=c[f>>2];ah=Hr(e,n,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}if((ah|0)<69){al=ah+2e3|0}else{al=(ah-69|0)>>>0<31>>>0?ah+1900|0:ah}c[j+20>>2]=al-1900;break};case 77:{c[q>>2]=c[f>>2];ah=Hr(e,q,h,ai,2)|0;ak=c[h>>2]|0;if((ak&4|0)==0&(ah|0)<60){c[j+4>>2]=ah;break L8}else{c[h>>2]=ak|4;break L8}break};case 100:case 101:{ak=j+12|0;c[v>>2]=c[f>>2];ah=Hr(e,v,h,ai,2)|0;aj=c[h>>2]|0;do{if((aj&4|0)==0){if((ah-1|0)>>>0>=31>>>0){break}c[ak>>2]=ah;break L8}}while(0);c[h>>2]=aj|4;break};case 119:{c[o>>2]=c[f>>2];ah=Hr(e,o,h,ai,1)|0;ak=c[h>>2]|0;if((ak&4|0)==0&(ah|0)<7){c[j+24>>2]=ah;break L8}else{c[h>>2]=ak|4;break L8}break};case 106:{c[s>>2]=c[f>>2];ak=Hr(e,s,h,ai,3)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(ak|0)<366){c[j+28>>2]=ak;break L8}else{c[h>>2]=ah|4;break L8}break};case 73:{ah=j+8|0;c[t>>2]=c[f>>2];ak=Hr(e,t,h,ai,2)|0;am=c[h>>2]|0;do{if((am&4|0)==0){if((ak-1|0)>>>0>=12>>>0){break}c[ah>>2]=ak;break L8}}while(0);c[h>>2]=am|4;break};case 109:{c[r>>2]=c[f>>2];ak=(Hr(e,r,h,ai,2)|0)-1|0;ah=c[h>>2]|0;if((ah&4|0)==0&(ak|0)<12){c[j+16>>2]=ak;break L8}else{c[h>>2]=ah|4;break L8}break};case 83:{c[p>>2]=c[f>>2];ah=Hr(e,p,h,ai,2)|0;ak=c[h>>2]|0;if((ak&4|0)==0&(ah|0)<61){c[j>>2]=ah;break L8}else{c[h>>2]=ak|4;break L8}break};case 72:{c[u>>2]=c[f>>2];ak=Hr(e,u,h,ai,2)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(ak|0)<24){c[j+8>>2]=ak;break L8}else{c[h>>2]=ah|4;break L8}break};case 99:{ah=d+8|0;ak=cD[c[(c[ah>>2]|0)+12>>2]&511](ah)|0;ah=e|0;c[C>>2]=c[ah>>2];c[D>>2]=c[f>>2];aj=a[ak]|0;if((aj&1)==0){an=ak+4|0;ao=ak+4|0}else{ap=c[ak+8>>2]|0;an=ap;ao=ap}ap=aj&255;if((ap&1|0)==0){aq=ap>>>1}else{aq=c[ak+4>>2]|0}He(B,d,C,D,g,h,j,ao,an+(aq<<2)|0);c[ah>>2]=c[B>>2];break};case 97:case 65:{ah=c[f>>2]|0;ak=d+8|0;ap=cD[c[c[ak>>2]>>2]&511](ak)|0;c[x>>2]=ah;ah=(Ga(e,x,ap,ap+168|0,ai,h,0)|0)-ap|0;if((ah|0)>=168){break L8}c[j+24>>2]=((ah|0)/12|0|0)%7|0;break};case 84:{ah=e|0;c[U>>2]=c[ah>>2];c[V>>2]=c[f>>2];He(T,d,U,V,g,h,j,13520,13552);c[ah>>2]=c[T>>2];break};case 120:{ah=c[(c[d>>2]|0)+20>>2]|0;c[W>>2]=c[e>>2];c[X>>2]=c[f>>2];cR[ah&127](b,d,W,X,g,h,j);i=l;return};case 88:{ah=d+8|0;ap=cD[c[(c[ah>>2]|0)+24>>2]&511](ah)|0;ah=e|0;c[Z>>2]=c[ah>>2];c[_>>2]=c[f>>2];ak=a[ap]|0;if((ak&1)==0){ar=ap+4|0;as=ap+4|0}else{aj=c[ap+8>>2]|0;ar=aj;as=aj}aj=ak&255;if((aj&1|0)==0){at=aj>>>1}else{at=c[ap+4>>2]|0}He(Y,d,Z,_,g,h,j,as,ar+(at<<2)|0);c[ah>>2]=c[Y>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}}while(0);l=cl(4)|0;K$(l);z=0;aR(156,l|0,29336,98);if(z){z=0;ab=bT(-1,-1)|0;ac=M;ad=c[aa>>2]|0;ae=ad|0;af=DL(ae)|0;bg(ab|0)}}function Ho(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;a=i;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=b|0;b=d|0;d=f;L1:while(1){h=c[g>>2]|0;do{if((h|0)==0){j=1}else{k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){l=cD[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[g>>2]=0;j=1;break}else{j=(c[g>>2]|0)==0;break}}}while(0);h=c[b>>2]|0;do{if((h|0)==0){m=15}else{k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){n=cD[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{n=c[k>>2]|0}if((n|0)==-1){c[b>>2]=0;m=15;break}else{k=(h|0)==0;if(j^k){o=h;p=k;break}else{q=h;r=k;break L1}}}}while(0);if((m|0)==15){m=0;if(j){q=0;r=1;break}else{o=0;p=1}}h=c[g>>2]|0;k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){s=cD[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{s=c[k>>2]|0}if(!(cI[c[(c[d>>2]|0)+12>>2]&127](f,8192,s)|0)){q=o;r=p;break}k=c[g>>2]|0;h=k+12|0;t=c[h>>2]|0;if((t|0)==(c[k+16>>2]|0)){cD[c[(c[k>>2]|0)+40>>2]&511](k)|0;continue}else{c[h>>2]=t+4;continue}}p=c[g>>2]|0;do{if((p|0)==0){u=1}else{o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0)){v=cD[c[(c[p>>2]|0)+36>>2]&511](p)|0}else{v=c[o>>2]|0}if((v|0)==-1){c[g>>2]=0;u=1;break}else{u=(c[g>>2]|0)==0;break}}}while(0);do{if(r){m=37}else{g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){w=cD[c[(c[q>>2]|0)+36>>2]&511](q)|0}else{w=c[g>>2]|0}if((w|0)==-1){c[b>>2]=0;m=37;break}if(!(u^(q|0)==0)){break}i=a;return}}while(0);do{if((m|0)==37){if(u){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Hp(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+8|0;k=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[k>>2];k=j|0;l=a+8|0;a=cD[c[(c[l>>2]|0)+8>>2]&511](l)|0;l=d[a]|0;if((l&1|0)==0){m=l>>>1}else{m=c[a+4>>2]|0}l=d[a+12|0]|0;if((l&1|0)==0){n=l>>>1}else{n=c[a+16>>2]|0}if((m|0)==(-n|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[k>>2]=c[f>>2];f=Ga(e,k,a,a+24|0,h,g,0)|0;g=f-a|0;do{if((f|0)==(a|0)){if((c[b>>2]|0)!=12){break}c[b>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[b>>2]|0;if((g|0)>=12){i=j;return}c[b>>2]=g+12;i=j;return}function Hq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=b|0;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=cD[c[(c[b>>2]|0)+36>>2]&511](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d|0;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=cD[c[(c[d>>2]|0)+36>>2]&511](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{b=(d|0)==0;if(h^b){n=d;o=b;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0;o=1}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){p=cD[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{p=c[d>>2]|0}if((cI[c[(c[f>>2]|0)+52>>2]&127](f,p,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;i=a;return}p=c[g>>2]|0;f=p+12|0;d=c[f>>2]|0;if((d|0)==(c[p+16>>2]|0)){cD[c[(c[p>>2]|0)+40>>2]&511](p)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){q=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){r=cD[c[(c[d>>2]|0)+36>>2]&511](d)|0}else{r=c[f>>2]|0}if((r|0)==-1){c[g>>2]=0;q=1;break}else{q=(c[g>>2]|0)==0;break}}}while(0);do{if(o){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){s=cD[c[(c[n>>2]|0)+36>>2]&511](n)|0}else{s=c[g>>2]|0}if((s|0)==-1){c[k>>2]=0;l=38;break}if(!(q^(n|0)==0)){break}i=a;return}}while(0);do{if((l|0)==38){if(q){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Hr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;h=b;b=i;i=i+4|0;i=i+7&-8;c[b>>2]=c[h>>2];h=a|0;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=cD[c[(c[a>>2]|0)+36>>2]&511](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b|0;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=cD[c[(c[b>>2]|0)+36>>2]&511](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j^(b|0)==0){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=cD[c[(c[j>>2]|0)+36>>2]&511](j)|0}else{q=c[b>>2]|0}b=e;if(!(cI[c[(c[b>>2]|0)+12>>2]&127](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}j=e;n=(cI[c[(c[j>>2]|0)+52>>2]&127](e,q,0)|0)<<24>>24;q=c[h>>2]|0;a=q+12|0;k=c[a>>2]|0;if((k|0)==(c[q+16>>2]|0)){cD[c[(c[q>>2]|0)+40>>2]&511](q)|0;r=n;s=f;t=o}else{c[a>>2]=k+4;r=n;s=f;t=o}while(1){u=r-48|0;o=s-1|0;f=c[h>>2]|0;do{if((f|0)==0){v=0}else{n=c[f+12>>2]|0;if((n|0)==(c[f+16>>2]|0)){w=cD[c[(c[f>>2]|0)+36>>2]&511](f)|0}else{w=c[n>>2]|0}if((w|0)==-1){c[h>>2]=0;v=0;break}else{v=c[h>>2]|0;break}}}while(0);f=(v|0)==0;if((t|0)==0){x=v;y=0}else{n=c[t+12>>2]|0;if((n|0)==(c[t+16>>2]|0)){z=cD[c[(c[t>>2]|0)+36>>2]&511](t)|0}else{z=c[n>>2]|0}if((z|0)==-1){c[l>>2]=0;A=0}else{A=t}x=c[h>>2]|0;y=A}B=(y|0)==0;if(!((f^B)&(o|0)>0)){break}f=c[x+12>>2]|0;if((f|0)==(c[x+16>>2]|0)){C=cD[c[(c[x>>2]|0)+36>>2]&511](x)|0}else{C=c[f>>2]|0}if(!(cI[c[(c[b>>2]|0)+12>>2]&127](e,2048,C)|0)){p=u;m=66;break}f=((cI[c[(c[j>>2]|0)+52>>2]&127](e,C,0)|0)<<24>>24)+(u*10|0)|0;n=c[h>>2]|0;k=n+12|0;a=c[k>>2]|0;if((a|0)==(c[n+16>>2]|0)){cD[c[(c[n>>2]|0)+40>>2]&511](n)|0;r=f;s=o;t=y;continue}else{c[k>>2]=a+4;r=f;s=o;t=y;continue}}if((m|0)==66){i=g;return p|0}do{if((x|0)==0){D=1}else{t=c[x+12>>2]|0;if((t|0)==(c[x+16>>2]|0)){E=cD[c[(c[x>>2]|0)+36>>2]&511](x)|0}else{E=c[t>>2]|0}if((E|0)==-1){c[h>>2]=0;D=1;break}else{D=(c[h>>2]|0)==0;break}}}while(0);do{if(B){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){F=cD[c[(c[y>>2]|0)+36>>2]&511](y)|0}else{F=c[h>>2]|0}if((F|0)==-1){c[l>>2]=0;m=60;break}if(D^(y|0)==0){p=u}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(D){break}else{p=u}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=u;i=g;return p|0}function Hs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b;e=b+8|0;f=c[e>>2]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}g=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=g;break}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);if((f|0)==(c[10082]|0)){h=b|0;DJ(h);Lw(d);return}z=0;ar(592,c[e>>2]|0);if(!z){h=b|0;DJ(h);Lw(d);return}else{z=0}bT(-1,-1,0)|0;bX()}function Ht(b){b=b|0;var d=0,e=0,f=0,g=0;d=b+8|0;e=c[d>>2]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}f=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=f;break}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);if((e|0)==(c[10082]|0)){g=b|0;DJ(g);return}z=0;ar(592,c[d>>2]|0);if(!z){g=b|0;DJ(g);return}else{z=0}bT(-1,-1,0)|0;bX()}function Hu(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;f=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[f>>2];f=g|0;l=g+8|0;m=l|0;n=f|0;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(k<<24>>24!=0){a[o]=k;a[p]=j}j=bJ(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b|0;c[r>>2]=q;i=g;return}else{s=l;t=m}while(1){m=a[t]|0;if((s|0)==0){u=0}else{l=s+24|0;j=c[l>>2]|0;if((j|0)==(c[s+28>>2]|0)){v=cV[c[(c[s>>2]|0)+52>>2]&1023](s,m&255)|0}else{c[l>>2]=j+1;a[j]=m;v=m&255}u=(v|0)==-1?0:s}m=t+1|0;if((m|0)==(d|0)){q=u;break}else{s=u;t=m}}r=b|0;c[r>>2]=q;i=g;return}function Hv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b;e=b+8|0;f=c[e>>2]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}g=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=g;break}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);if((f|0)==(c[10082]|0)){h=b|0;DJ(h);Lw(d);return}z=0;ar(592,c[e>>2]|0);if(!z){h=b|0;DJ(h);Lw(d);return}else{z=0}bT(-1,-1,0)|0;bX()}function Hw(b){b=b|0;var d=0,e=0,f=0,g=0;d=b+8|0;e=c[d>>2]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}f=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=f;break}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);if((e|0)==(c[10082]|0)){g=b|0;DJ(g);return}z=0;ar(592,c[d>>2]|0);if(!z){g=b|0;DJ(g);return}else{z=0}bT(-1,-1,0)|0;bX()}function Hx(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+408|0;e=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[e>>2];e=f|0;k=f+400|0;l=e|0;c[k>>2]=e+400;Hy(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a|0;c[n>>2]=m;i=f;return}else{o=k;p=l}while(1){l=c[p>>2]|0;if((o|0)==0){q=0}else{k=o+24|0;d=c[k>>2]|0;if((d|0)==(c[o+28>>2]|0)){r=cV[c[(c[o>>2]|0)+52>>2]&1023](o,l)|0}else{c[k>>2]=d+4;c[d>>2]=l;r=l}q=(r|0)==-1?0:o}l=p+4|0;if((l|0)==(j|0)){m=q;break}else{o=q;p=l}}n=a|0;c[n>>2]=m;i=f;return}function Hy(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j|0;l=j+112|0;m=i;i=i+4|0;i=i+7&-8;n=j+8|0;o=k|0;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(h<<24>>24!=0){a[p]=h;a[q]=g}g=b|0;bJ(n|0,100,o|0,f|0,c[g>>2]|0)|0;c[l>>2]=0;c[l+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=b6(c[g>>2]|0)|0;g=(z=0,aU(18,d|0,m|0,n|0,l|0)|0);if(z){z=0;l=bT(-1,-1)|0;if((f|0)==0){bg(l|0)}z=0,au(36,f|0)|0;if(!z){bg(l|0)}else{z=0;bT(-1,-1,0)|0;bX()}}do{if((f|0)!=0){z=0,au(36,f|0)|0;if(!z){break}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);if((g|0)==-1){Ik(6192)}else{c[e>>2]=d+(g<<2);i=j;return}}function Hz(a){a=a|0;DJ(a|0);Lw(a);return}function HA(a){a=a|0;DJ(a|0);return}function HB(a){a=a|0;return 127}function HC(a){a=a|0;return 127}function HD(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function HE(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function HF(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function HG(a,b){a=a|0;b=b|0;D9(a,1,45);return}function HH(a){a=a|0;return 0}function HI(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function HJ(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function HK(a){a=a|0;DJ(a|0);Lw(a);return}function HL(a){a=a|0;DJ(a|0);return}function HM(a){a=a|0;return 127}function HN(a){a=a|0;return 127}function HO(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function HP(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function HQ(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function HR(a,b){a=a|0;b=b|0;D9(a,1,45);return}function HS(a){a=a|0;return 0}function HT(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function HU(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function HV(a){a=a|0;DJ(a|0);Lw(a);return}function HW(a){a=a|0;DJ(a|0);return}function HX(a){a=a|0;return 2147483647}function HY(a){a=a|0;return 2147483647}function HZ(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function H_(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function H$(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function H0(a,b){a=a|0;b=b|0;En(a,1,45);return}function H1(a){a=a|0;return 0}function H2(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function H3(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function H4(a){a=a|0;DJ(a|0);Lw(a);return}function H5(a){a=a|0;DJ(a|0);return}function H6(a){a=a|0;return 2147483647}function H7(a){a=a|0;return 2147483647}function H8(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function H9(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function Ia(a,b){a=a|0;b=b|0;LI(a|0,0,12)|0;return}function Ib(a,b){a=a|0;b=b|0;En(a,1,45);return}function Ic(a){a=a|0;return 0}function Id(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function Ie(b,c){b=b|0;c=c|0;c=b;E=67109634;a[c]=E;E=E>>8;a[c+1|0]=E;E=E>>8;a[c+2|0]=E;E=E>>8;a[c+3|0]=E;return}function If(a){a=a|0;DJ(a|0);Lw(a);return}function Ig(a){a=a|0;DJ(a|0);return}function Ih(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0;d=i;i=i+280|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+120|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=d+176|0;u=m|0;v=n|0;c[v>>2]=u;w=n+4|0;c[w>>2]=556;x=m+100|0;z=0;as(352,p|0,h|0);do{if(!z){m=p|0;y=c[m>>2]|0;if((c[10440]|0)==-1){A=4}else{c[l>>2]=41760;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41760,l|0,520);if(!z){A=4}else{z=0;A=15}}L5:do{if((A|0)==4){B=(c[10441]|0)-1|0;C=c[y+8>>2]|0;do{if((c[y+12>>2]|0)-C>>2>>>0>B>>>0){D=c[C+(B<<2)>>2]|0;if((D|0)==0){break}E=D;a[q]=0;F=f|0;c[r>>2]=c[F>>2];G=(z=0,ax(4,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,E|0,n|0,o|0,x|0)|0);if(z){z=0;A=15;break L5}L11:do{if(G){H=s|0;I=c[(c[D>>2]|0)+32>>2]|0;z=0,aU(I|0,E|0,13472,13482,H|0)|0;if(z){z=0;A=15;break L5}I=t|0;J=c[o>>2]|0;K=c[v>>2]|0;L=J-K|0;do{if((L|0)>98){N=Lo(L+2|0)|0;if((N|0)!=0){O=N;P=N;A=19;break}z=0;aS(4);if(!z){O=0;P=0;A=19}else{z=0;Q=0;A=16}}else{O=I;P=0;A=19}}while(0);do{if((A|0)==19){if((a[q]&1)==0){R=O}else{a[O]=45;R=O+1|0}if(K>>>0<J>>>0){L=s+10|0;N=s;S=R;T=K;while(1){U=H;while(1){if((U|0)==(L|0)){V=L;break}if((a[U]|0)==(a[T]|0)){V=U;break}else{U=U+1|0}}a[S]=a[13472+(V-N)|0]|0;U=T+1|0;W=S+1|0;if(U>>>0<(c[o>>2]|0)>>>0){S=W;T=U}else{X=W;break}}}else{X=R}a[X]=0;T=b8(I|0,11040,(S=i,i=i+8|0,c[S>>2]=k,S)|0)|0;i=S;if((T|0)==1){if((P|0)==0){break L11}Lp(P);break L11}T=cl(8)|0;z=0;as(466,T|0,10776);if(z){z=0;S=bT(-1,-1)|0;N=M;bo(T|0);Y=N;Z=S;_=P;break}z=0;aR(156,T|0,29352,466);if(z){z=0;Q=P;A=16;break}}}while(0);if((A|0)==16){I=bT(-1,-1)|0;Y=M;Z=I;_=Q}I=Z;H=Y;if((_|0)==0){$=H;aa=I;break L5}Lp(_);$=H;aa=I;break L5}}while(0);E=e|0;D=c[E>>2]|0;do{if((D|0)==0){ab=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){ab=D;break}G=(z=0,au(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(z){z=0;A=15;break L5}if((G|0)!=-1){ab=D;break}c[E>>2]=0;ab=0}}while(0);E=(ab|0)==0;D=c[F>>2]|0;do{if((D|0)==0){A=45}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(E){break}else{A=47;break}}G=(z=0,au(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(z){z=0;A=15;break L5}if((G|0)==-1){c[F>>2]=0;A=45;break}else{if(E^(D|0)==0){break}else{A=47;break}}}}while(0);if((A|0)==45){if(E){A=47}}if((A|0)==47){c[j>>2]=c[j>>2]|2}c[b>>2]=ab;DL(c[m>>2]|0)|0;D=c[v>>2]|0;c[v>>2]=0;if((D|0)==0){i=d;return}z=0;ar(c[w>>2]|0,D|0);if(!z){i=d;return}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);B=cl(4)|0;K$(B);z=0;aR(156,B|0,29336,98);if(z){z=0;A=15;break}}}while(0);if((A|0)==15){y=bT(-1,-1)|0;$=M;aa=y}DL(c[m>>2]|0)|0;y=c[v>>2]|0;c[v>>2]=0;if((y|0)==0){ac=aa;ad=$}else{ae=y;af=aa;ag=$;break}ah=ac;ai=0;aj=ah;ak=ad;bg(aj|0)}else{z=0;y=bT(-1,-1)|0;c[v>>2]=0;ae=u;af=y;ag=M}}while(0);z=0;ar(c[w>>2]|0,ae|0);if(!z){ac=af;ad=ag;ah=ac;ai=0;aj=ah;ak=ad;bg(aj|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Ii(a){a=a|0;return}function Ij(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0;q=i;i=i+440|0;r=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[r>>2];r=q|0;s=q+400|0;t=q+408|0;u=q+416|0;v=q+424|0;w=v;x=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=r|0;LI(w|0,0,12)|0;F=x;G=y;H=A;I=B;LI(F|0,0,12)|0;LI(G|0,0,12)|0;LI(H|0,0,12)|0;LI(I|0,0,12)|0;z=0;aL(4,g|0,h|0,s|0,t|0,u|0,v|0,x|0,y|0,A|0,C|0);L1:do{if(!z){h=n|0;c[o>>2]=c[h>>2];g=e|0;J=f|0;K=m+8|0;L=A+1|0;N=A+4|0;O=A+8|0;P=y+1|0;Q=y+4|0;R=y+8|0;S=(j&512|0)!=0;T=x+1|0;U=x+4|0;V=x+8|0;W=B+1|0;X=B+4|0;Y=B+8|0;Z=s+3|0;_=v+4|0;$=n+4|0;aa=p;ab=556;ac=E;ad=E;ae=r+400|0;af=0;ag=0;L3:while(1){ah=c[g>>2]|0;do{if((ah|0)==0){ai=0}else{if((c[ah+12>>2]|0)!=(c[ah+16>>2]|0)){ai=ah;break}aj=(z=0,au(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}if((aj|0)==-1){c[g>>2]=0;ai=0;break}else{ai=c[g>>2]|0;break}}}while(0);ah=(ai|0)==0;aj=c[J>>2]|0;do{if((aj|0)==0){am=15}else{if((c[aj+12>>2]|0)!=(c[aj+16>>2]|0)){if(ah){an=aj;break}else{ao=ab;ap=ac;aq=ad;at=af;am=274;break L3}}av=(z=0,au(c[(c[aj>>2]|0)+36>>2]|0,aj|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}if((av|0)==-1){c[J>>2]=0;am=15;break}else{if(ah){an=aj;break}else{ao=ab;ap=ac;aq=ad;at=af;am=274;break L3}}}}while(0);if((am|0)==15){am=0;if(ah){ao=ab;ap=ac;aq=ad;at=af;am=274;break}else{an=0}}L25:do{switch(a[s+ag|0]|0){case 3:{aj=a[G]|0;av=aj&255;aw=(av&1|0)==0?av>>>1:c[Q>>2]|0;av=a[H]|0;ax=av&255;ay=(ax&1|0)==0?ax>>>1:c[N>>2]|0;if((aw|0)==(-ay|0)){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}ax=(aw|0)==0;aw=c[g>>2]|0;aF=c[aw+12>>2]|0;aG=c[aw+16>>2]|0;aH=(aF|0)==(aG|0);if(!(ax|(ay|0)==0)){if(aH){ay=(z=0,au(c[(c[aw>>2]|0)+36>>2]|0,aw|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}aI=c[g>>2]|0;aJ=ay&255;aK=a[G]|0;aM=aI;aN=c[aI+12>>2]|0;aO=c[aI+16>>2]|0}else{aJ=a[aF]|0;aK=aj;aM=aw;aN=aF;aO=aG}aG=aM+12|0;aI=(aN|0)==(aO|0);if(aJ<<24>>24==(a[(aK&1)==0?P:c[R>>2]|0]|0)){if(aI){ay=c[(c[aM>>2]|0)+40>>2]|0;z=0,au(ay|0,aM|0)|0;if(z){z=0;ak=ac;al=ab;am=24;break L3}}else{c[aG>>2]=aN+1}aG=d[G]|0;az=((aG&1|0)==0?aG>>>1:c[Q>>2]|0)>>>0>1>>>0?y:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}if(aI){aI=(z=0,au(c[(c[aM>>2]|0)+36>>2]|0,aM|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}aP=aI&255}else{aP=a[aN]|0}if(aP<<24>>24!=(a[(a[H]&1)==0?L:c[O>>2]|0]|0)){am=110;break L3}aI=c[g>>2]|0;aG=aI+12|0;ay=c[aG>>2]|0;if((ay|0)==(c[aI+16>>2]|0)){aQ=c[(c[aI>>2]|0)+40>>2]|0;z=0,au(aQ|0,aI|0)|0;if(z){z=0;ak=ac;al=ab;am=24;break L3}}else{c[aG>>2]=ay+1}a[l]=1;ay=d[H]|0;az=((ay&1|0)==0?ay>>>1:c[N>>2]|0)>>>0>1>>>0?A:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}if(ax){if(aH){ax=(z=0,au(c[(c[aw>>2]|0)+36>>2]|0,aw|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}aR=ax&255;aT=a[H]|0}else{aR=a[aF]|0;aT=av}if(aR<<24>>24!=(a[(aT&1)==0?L:c[O>>2]|0]|0)){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}av=c[g>>2]|0;ax=av+12|0;ay=c[ax>>2]|0;if((ay|0)==(c[av+16>>2]|0)){aG=c[(c[av>>2]|0)+40>>2]|0;z=0,au(aG|0,av|0)|0;if(z){z=0;ak=ac;al=ab;am=24;break L3}}else{c[ax>>2]=ay+1}a[l]=1;ay=d[H]|0;az=((ay&1|0)==0?ay>>>1:c[N>>2]|0)>>>0>1>>>0?A:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}if(aH){aH=(z=0,au(c[(c[aw>>2]|0)+36>>2]|0,aw|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}aU=aH&255;aV=a[G]|0}else{aU=a[aF]|0;aV=aj}if(aU<<24>>24!=(a[(aV&1)==0?P:c[R>>2]|0]|0)){a[l]=1;az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}aj=c[g>>2]|0;aF=aj+12|0;aH=c[aF>>2]|0;if((aH|0)==(c[aj+16>>2]|0)){aw=c[(c[aj>>2]|0)+40>>2]|0;z=0,au(aw|0,aj|0)|0;if(z){z=0;ak=ac;al=ab;am=24;break L3}}else{c[aF>>2]=aH+1}aH=d[G]|0;az=((aH&1|0)==0?aH>>>1:c[Q>>2]|0)>>>0>1>>>0?y:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break};case 0:{am=43;break};case 1:{if((ag|0)==3){ao=ab;ap=ac;aq=ad;at=af;am=274;break L3}aH=c[g>>2]|0;aF=c[aH+12>>2]|0;if((aF|0)==(c[aH+16>>2]|0)){aj=(z=0,au(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}aW=aj&255}else{aW=a[aF]|0}aF=aW<<24>>24;aj=(z=0,au(274,aF|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}if((aj|0)==0){am=42;break L3}if((b[(c[K>>2]|0)+(aF<<1)>>1]&8192)==0){am=42;break L3}aF=c[g>>2]|0;aj=aF+12|0;aH=c[aj>>2]|0;if((aH|0)==(c[aF+16>>2]|0)){aw=(z=0,au(c[(c[aF>>2]|0)+40>>2]|0,aF|0)|0);if(z){z=0;ak=ac;al=ab;am=24;break L3}aX=aw&255}else{c[aj>>2]=aH+1;aX=a[aH]|0}z=0;as(590,B|0,aX|0);if(!z){am=43}else{z=0;ak=ac;al=ab;am=24;break L3}break};case 2:{if(!((af|0)!=0|ag>>>0<2>>>0)){if((ag|0)==2){aY=(a[Z]|0)!=0}else{aY=0}if(!(S|aY)){az=0;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}}aH=a[F]|0;aj=c[V>>2]|0;aw=(aH&1)==0?T:aj;L100:do{if((ag|0)==0){aZ=aw;a_=aH;a$=aj}else{if((d[s+(ag-1)|0]|0)>>>0>=2>>>0){aZ=aw;a_=aH;a$=aj;break}aF=aH&255;L103:do{if((((aF&1|0)==0?aF>>>1:c[U>>2]|0)|0)==0){a0=aw;a1=aH;a2=aj}else{ay=aw;while(1){ax=a[ay]|0;av=(z=0,au(274,ax|0)|0);if(z){z=0;am=21;break L3}if((av|0)==0){break}if((b[(c[K>>2]|0)+(ax<<1)>>1]&8192)==0){break}ax=ay+1|0;av=a[F]|0;aG=c[V>>2]|0;aI=av&255;if((ax|0)==(((av&1)==0?T:aG)+((aI&1|0)==0?aI>>>1:c[U>>2]|0)|0)){a0=ax;a1=av;a2=aG;break L103}else{ay=ax}}a0=ay;a1=a[F]|0;a2=c[V>>2]|0}}while(0);aF=(a1&1)==0?T:a2;ax=a0-aF|0;aG=a[I]|0;av=aG&255;aI=(av&1|0)==0?av>>>1:c[X>>2]|0;if(ax>>>0>aI>>>0){aZ=aF;a_=a1;a$=a2;break}av=(aG&1)==0?W:c[Y>>2]|0;aG=av+aI|0;if((a0|0)==(aF|0)){aZ=a0;a_=a1;a$=a2;break}aQ=av+(aI-ax)|0;ax=aF;while(1){if((a[aQ]|0)!=(a[ax]|0)){aZ=aF;a_=a1;a$=a2;break L100}aI=aQ+1|0;if((aI|0)==(aG|0)){aZ=a0;a_=a1;a$=a2;break}else{aQ=aI;ax=ax+1|0}}}}while(0);aw=a_&255;L117:do{if((aZ|0)==(((a_&1)==0?T:a$)+((aw&1|0)==0?aw>>>1:c[U>>2]|0)|0)){a3=aZ}else{aj=an;aH=aZ;while(1){ax=c[g>>2]|0;do{if((ax|0)==0){a4=0}else{if((c[ax+12>>2]|0)!=(c[ax+16>>2]|0)){a4=ax;break}aQ=(z=0,au(c[(c[ax>>2]|0)+36>>2]|0,ax|0)|0);if(z){z=0;am=22;break L3}if((aQ|0)==-1){c[g>>2]=0;a4=0;break}else{a4=c[g>>2]|0;break}}}while(0);ax=(a4|0)==0;do{if((aj|0)==0){am=141}else{if((c[aj+12>>2]|0)!=(c[aj+16>>2]|0)){if(ax){a5=aj;break}else{a3=aH;break L117}}ay=(z=0,au(c[(c[aj>>2]|0)+36>>2]|0,aj|0)|0);if(z){z=0;am=22;break L3}if((ay|0)==-1){c[J>>2]=0;am=141;break}else{if(ax){a5=aj;break}else{a3=aH;break L117}}}}while(0);if((am|0)==141){am=0;if(ax){a3=aH;break L117}else{a5=0}}ay=c[g>>2]|0;aQ=c[ay+12>>2]|0;if((aQ|0)==(c[ay+16>>2]|0)){aG=(z=0,au(c[(c[ay>>2]|0)+36>>2]|0,ay|0)|0);if(z){z=0;am=22;break L3}a6=aG&255}else{a6=a[aQ]|0}if(a6<<24>>24!=(a[aH]|0)){a3=aH;break L117}aQ=c[g>>2]|0;aG=aQ+12|0;ay=c[aG>>2]|0;if((ay|0)==(c[aQ+16>>2]|0)){aF=c[(c[aQ>>2]|0)+40>>2]|0;z=0,au(aF|0,aQ|0)|0;if(z){z=0;am=22;break L3}}else{c[aG>>2]=ay+1}ay=aH+1|0;aG=a[F]|0;aQ=aG&255;if((ay|0)==(((aG&1)==0?T:c[V>>2]|0)+((aQ&1|0)==0?aQ>>>1:c[U>>2]|0)|0)){a3=ay;break}else{aj=a5;aH=ay}}}}while(0);if(!S){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L25}aw=a[F]|0;aH=aw&255;if((a3|0)==(((aw&1)==0?T:c[V>>2]|0)+((aH&1|0)==0?aH>>>1:c[U>>2]|0)|0)){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa}else{am=154;break L3}break};case 4:{aH=0;aw=ae;aj=ad;ay=ac;aQ=ab;aG=aa;L152:while(1){aF=c[g>>2]|0;do{if((aF|0)==0){a7=0}else{if((c[aF+12>>2]|0)!=(c[aF+16>>2]|0)){a7=aF;break}aI=(z=0,au(c[(c[aF>>2]|0)+36>>2]|0,aF|0)|0);if(z){z=0;a8=ay;a9=aQ;am=19;break L3}if((aI|0)==-1){c[g>>2]=0;a7=0;break}else{a7=c[g>>2]|0;break}}}while(0);aF=(a7|0)==0;aI=c[J>>2]|0;do{if((aI|0)==0){am=167}else{if((c[aI+12>>2]|0)!=(c[aI+16>>2]|0)){if(aF){break}else{break L152}}av=(z=0,au(c[(c[aI>>2]|0)+36>>2]|0,aI|0)|0);if(z){z=0;a8=ay;a9=aQ;am=19;break L3}if((av|0)==-1){c[J>>2]=0;am=167;break}else{if(aF){break}else{break L152}}}}while(0);if((am|0)==167){am=0;if(aF){break}}aI=c[g>>2]|0;av=c[aI+12>>2]|0;if((av|0)==(c[aI+16>>2]|0)){ba=(z=0,au(c[(c[aI>>2]|0)+36>>2]|0,aI|0)|0);if(z){z=0;a8=ay;a9=aQ;am=19;break L3}bb=ba&255}else{bb=a[av]|0}av=bb<<24>>24;ba=(z=0,au(274,av|0)|0);if(z){z=0;a8=ay;a9=aQ;am=19;break L3}do{if((ba|0)==0){am=187}else{if((b[(c[K>>2]|0)+(av<<1)>>1]&2048)==0){am=187;break}aI=c[o>>2]|0;if((aI|0)==(aG|0)){bc=(c[$>>2]|0)!=556;bd=c[h>>2]|0;be=aG-bd|0;bf=be>>>0<2147483647>>>0?be<<1:-1;bh=Lr(bc?bd:0,bf)|0;if((bh|0)==0){z=0;aS(4);if(z){z=0;a8=ay;a9=aQ;am=19;break L3}}do{if(bc){c[h>>2]=bh;bi=bh}else{bd=c[h>>2]|0;c[h>>2]=bh;if((bd|0)==0){bi=bh;break}z=0;ar(c[$>>2]|0,bd|0);if(z){z=0;am=184;break L3}bi=c[h>>2]|0}}while(0);c[$>>2]=512;bh=bi+be|0;c[o>>2]=bh;bj=(c[h>>2]|0)+bf|0;bk=bh}else{bj=aG;bk=aI}c[o>>2]=bk+1;a[bk]=bb;bl=aH+1|0;bm=aw;bn=aj;bo=ay;bp=aQ;bq=bj}}while(0);if((am|0)==187){am=0;av=d[w]|0;if((((av&1|0)==0?av>>>1:c[_>>2]|0)|0)==0|(aH|0)==0){break}if(bb<<24>>24!=(a[u]|0)){break}if((aj|0)==(aw|0)){av=aj-ay|0;ba=av>>>0<2147483647>>>0?av<<1:-1;aF=av>>2;if((aQ|0)==556){br=0}else{br=ay}av=Lr(br,ba)|0;bh=av;if((av|0)==0){z=0;aS(4);if(z){z=0;a8=ay;a9=aQ;am=19;break L3}}bs=bh+(ba>>>2<<2)|0;bt=bh+(aF<<2)|0;bu=bh;bv=512}else{bs=aw;bt=aj;bu=ay;bv=aQ}c[bt>>2]=aH;bl=0;bm=bs;bn=bt+4|0;bo=bu;bp=bv;bq=aG}bh=c[g>>2]|0;aF=bh+12|0;ba=c[aF>>2]|0;if((ba|0)==(c[bh+16>>2]|0)){av=c[(c[bh>>2]|0)+40>>2]|0;z=0,au(av|0,bh|0)|0;if(!z){aH=bl;aw=bm;aj=bn;ay=bo;aQ=bp;aG=bq;continue}else{z=0;a8=bo;a9=bp;am=19;break L3}}else{c[aF>>2]=ba+1;aH=bl;aw=bm;aj=bn;ay=bo;aQ=bp;aG=bq;continue}}if((ay|0)==(aj|0)|(aH|0)==0){bw=aw;bx=aj;by=ay;bz=aQ}else{if((aj|0)==(aw|0)){ba=aj-ay|0;aF=ba>>>0<2147483647>>>0?ba<<1:-1;bh=ba>>2;if((aQ|0)==556){bA=0}else{bA=ay}ba=Lr(bA,aF)|0;av=ba;if((ba|0)==0){z=0;aS(4);if(z){z=0;ak=ay;al=aQ;am=24;break L3}}bB=av+(aF>>>2<<2)|0;bC=av+(bh<<2)|0;bD=av;bE=512}else{bB=aw;bC=aj;bD=ay;bE=aQ}c[bC>>2]=aH;bw=bB;bx=bC+4|0;by=bD;bz=bE}if((c[C>>2]|0)>0){av=c[g>>2]|0;do{if((av|0)==0){bF=0}else{if((c[av+12>>2]|0)!=(c[av+16>>2]|0)){bF=av;break}bh=(z=0,au(c[(c[av>>2]|0)+36>>2]|0,av|0)|0);if(z){z=0;ak=by;al=bz;am=24;break L3}if((bh|0)==-1){c[g>>2]=0;bF=0;break}else{bF=c[g>>2]|0;break}}}while(0);av=(bF|0)==0;aH=c[J>>2]|0;do{if((aH|0)==0){am=220}else{if((c[aH+12>>2]|0)!=(c[aH+16>>2]|0)){if(av){bG=aH;break}else{am=227;break L3}}aQ=(z=0,au(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(z){z=0;ak=by;al=bz;am=24;break L3}if((aQ|0)==-1){c[J>>2]=0;am=220;break}else{if(av){bG=aH;break}else{am=227;break L3}}}}while(0);if((am|0)==220){am=0;if(av){am=227;break L3}else{bG=0}}aH=c[g>>2]|0;aQ=c[aH+12>>2]|0;if((aQ|0)==(c[aH+16>>2]|0)){ay=(z=0,au(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(z){z=0;ak=by;al=bz;am=24;break L3}bH=ay&255}else{bH=a[aQ]|0}if(bH<<24>>24!=(a[t]|0)){am=227;break L3}aQ=c[g>>2]|0;ay=aQ+12|0;aH=c[ay>>2]|0;if((aH|0)==(c[aQ+16>>2]|0)){aj=c[(c[aQ>>2]|0)+40>>2]|0;z=0,au(aj|0,aQ|0)|0;if(!z){bI=aG;bJ=bG}else{z=0;ak=by;al=bz;am=24;break L3}}else{c[ay>>2]=aH+1;bI=aG;bJ=bG}while(1){aH=c[g>>2]|0;do{if((aH|0)==0){bK=0}else{if((c[aH+12>>2]|0)!=(c[aH+16>>2]|0)){bK=aH;break}ay=(z=0,au(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(z){z=0;am=20;break L3}if((ay|0)==-1){c[g>>2]=0;bK=0;break}else{bK=c[g>>2]|0;break}}}while(0);aH=(bK|0)==0;do{if((bJ|0)==0){am=243}else{if((c[bJ+12>>2]|0)!=(c[bJ+16>>2]|0)){if(aH){bL=bJ;break}else{am=252;break L3}}ay=(z=0,au(c[(c[bJ>>2]|0)+36>>2]|0,bJ|0)|0);if(z){z=0;am=20;break L3}if((ay|0)==-1){c[J>>2]=0;am=243;break}else{if(aH){bL=bJ;break}else{am=252;break L3}}}}while(0);if((am|0)==243){am=0;if(aH){am=252;break L3}else{bL=0}}ay=c[g>>2]|0;aQ=c[ay+12>>2]|0;if((aQ|0)==(c[ay+16>>2]|0)){aj=(z=0,au(c[(c[ay>>2]|0)+36>>2]|0,ay|0)|0);if(z){z=0;am=20;break L3}bM=aj&255}else{bM=a[aQ]|0}aQ=bM<<24>>24;aj=(z=0,au(274,aQ|0)|0);if(z){z=0;am=20;break L3}if((aj|0)==0){am=252;break L3}if((b[(c[K>>2]|0)+(aQ<<1)>>1]&2048)==0){am=252;break L3}aQ=c[o>>2]|0;if((aQ|0)==(bI|0)){aj=(c[$>>2]|0)!=556;ay=c[h>>2]|0;aw=bI-ay|0;bh=aw>>>0<2147483647>>>0?aw<<1:-1;aF=Lr(aj?ay:0,bh)|0;if((aF|0)==0){z=0;aS(4);if(z){z=0;am=20;break L3}}do{if(aj){c[h>>2]=aF;bN=aF}else{ay=c[h>>2]|0;c[h>>2]=aF;if((ay|0)==0){bN=aF;break}z=0;ar(c[$>>2]|0,ay|0);if(z){z=0;am=261;break L3}bN=c[h>>2]|0}}while(0);c[$>>2]=512;aF=bN+aw|0;c[o>>2]=aF;bO=(c[h>>2]|0)+bh|0;bP=aF}else{bO=bI;bP=aQ}aF=c[g>>2]|0;aj=c[aF+12>>2]|0;if((aj|0)==(c[aF+16>>2]|0)){aH=(z=0,au(c[(c[aF>>2]|0)+36>>2]|0,aF|0)|0);if(z){z=0;am=20;break L3}bQ=aH&255;bR=c[o>>2]|0}else{bQ=a[aj]|0;bR=bP}c[o>>2]=bR+1;a[bR]=bQ;aj=(c[C>>2]|0)-1|0;c[C>>2]=aj;aH=c[g>>2]|0;aF=aH+12|0;ay=c[aF>>2]|0;if((ay|0)==(c[aH+16>>2]|0)){ba=c[(c[aH>>2]|0)+40>>2]|0;z=0,au(ba|0,aH|0)|0;if(z){z=0;am=20;break L3}}else{c[aF>>2]=ay+1}if((aj|0)>0){bI=bO;bJ=bL}else{bS=bO;break}}}else{bS=aG}if((c[o>>2]|0)==(c[h>>2]|0)){am=272;break L3}else{az=af;aA=bw;aB=bx;aC=by;aD=bz;aE=bS}break};default:{az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa}}}while(0);L308:do{if((am|0)==43){am=0;if((ag|0)==3){ao=ab;ap=ac;aq=ad;at=af;am=274;break L3}else{bU=an}while(1){ah=c[g>>2]|0;do{if((ah|0)==0){bV=0}else{if((c[ah+12>>2]|0)!=(c[ah+16>>2]|0)){bV=ah;break}av=(z=0,au(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(z){z=0;am=23;break L3}if((av|0)==-1){c[g>>2]=0;bV=0;break}else{bV=c[g>>2]|0;break}}}while(0);ah=(bV|0)==0;do{if((bU|0)==0){am=56}else{if((c[bU+12>>2]|0)!=(c[bU+16>>2]|0)){if(ah){bW=bU;break}else{az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L308}}aQ=(z=0,au(c[(c[bU>>2]|0)+36>>2]|0,bU|0)|0);if(z){z=0;am=23;break L3}if((aQ|0)==-1){c[J>>2]=0;am=56;break}else{if(ah){bW=bU;break}else{az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L308}}}}while(0);if((am|0)==56){am=0;if(ah){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L308}else{bW=0}}aQ=c[g>>2]|0;bh=c[aQ+12>>2]|0;if((bh|0)==(c[aQ+16>>2]|0)){aw=(z=0,au(c[(c[aQ>>2]|0)+36>>2]|0,aQ|0)|0);if(z){z=0;am=23;break L3}bY=aw&255}else{bY=a[bh]|0}bh=bY<<24>>24;aw=(z=0,au(274,bh|0)|0);if(z){z=0;am=23;break L3}if((aw|0)==0){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L308}if((b[(c[K>>2]|0)+(bh<<1)>>1]&8192)==0){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L308}bh=c[g>>2]|0;aw=bh+12|0;aQ=c[aw>>2]|0;if((aQ|0)==(c[bh+16>>2]|0)){av=(z=0,au(c[(c[bh>>2]|0)+40>>2]|0,bh|0)|0);if(z){z=0;am=23;break L3}bZ=av&255}else{c[aw>>2]=aQ+1;bZ=a[aQ]|0}z=0;as(590,B|0,bZ|0);if(!z){bU=bW}else{z=0;am=23;break L3}}}}while(0);aG=ag+1|0;if(aG>>>0<4>>>0){aa=aE;ab=aD;ac=aC;ad=aB;ae=aA;af=az;ag=aG}else{ao=aD;ap=aC;aq=aB;at=az;am=274;break}}L346:do{if((am|0)==110){c[k>>2]=c[k>>2]|4;b_=0;b$=ac;b0=ab}else if((am|0)==42){c[k>>2]=c[k>>2]|4;b_=0;b$=ac;b0=ab}else if((am|0)==19){ag=bT(-1,-1)|0;b1=M;b2=ag;b3=a8;b4=a9;break L1}else if((am|0)==20){ag=bT(-1,-1)|0;b1=M;b2=ag;b3=by;b4=bz;break L1}else if((am|0)==21){ag=bT(-1,-1)|0;b1=M;b2=ag;b3=ac;b4=ab;break L1}else if((am|0)==22){ag=bT(-1,-1)|0;b1=M;b2=ag;b3=ac;b4=ab;break L1}else if((am|0)==23){ag=bT(-1,-1)|0;b1=M;b2=ag;b3=ac;b4=ab;break L1}else if((am|0)==24){ag=bT(-1,-1)|0;b1=M;b2=ag;b3=ak;b4=al;break L1}else if((am|0)==154){c[k>>2]=c[k>>2]|4;b_=0;b$=ac;b0=ab}else if((am|0)==184){bT(-1,-1,0)|0;bX();return 0}else if((am|0)==227){c[k>>2]=c[k>>2]|4;b_=0;b$=by;b0=bz}else if((am|0)==252){c[k>>2]=c[k>>2]|4;b_=0;b$=by;b0=bz}else if((am|0)==261){bT(-1,-1,0)|0;bX();return 0}else if((am|0)==272){c[k>>2]=c[k>>2]|4;b_=0;b$=by;b0=bz}else if((am|0)==274){L362:do{if((at|0)!=0){ag=at;af=at+1|0;ae=at+8|0;ad=at+4|0;aa=1;L364:while(1){K=d[ag]|0;if((K&1|0)==0){b5=K>>>1}else{b5=c[ad>>2]|0}if(aa>>>0>=b5>>>0){break L362}K=c[g>>2]|0;do{if((K|0)==0){b6=0}else{if((c[K+12>>2]|0)!=(c[K+16>>2]|0)){b6=K;break}h=(z=0,au(c[(c[K>>2]|0)+36>>2]|0,K|0)|0);if(z){z=0;am=18;break L364}if((h|0)==-1){c[g>>2]=0;b6=0;break}else{b6=c[g>>2]|0;break}}}while(0);K=(b6|0)==0;ah=c[J>>2]|0;do{if((ah|0)==0){am=292}else{if((c[ah+12>>2]|0)!=(c[ah+16>>2]|0)){if(K){break}else{am=301;break L364}}h=(z=0,au(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(z){z=0;am=18;break L364}if((h|0)==-1){c[J>>2]=0;am=292;break}else{if(K){break}else{am=301;break L364}}}}while(0);if((am|0)==292){am=0;if(K){am=301;break}}ah=c[g>>2]|0;h=c[ah+12>>2]|0;if((h|0)==(c[ah+16>>2]|0)){$=(z=0,au(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(z){z=0;am=18;break}b7=$&255}else{b7=a[h]|0}if((a[ag]&1)==0){b8=af}else{b8=c[ae>>2]|0}if(b7<<24>>24!=(a[b8+aa|0]|0)){am=301;break}h=aa+1|0;$=c[g>>2]|0;ah=$+12|0;_=c[ah>>2]|0;if((_|0)==(c[$+16>>2]|0)){U=c[(c[$>>2]|0)+40>>2]|0;z=0,au(U|0,$|0)|0;if(!z){aa=h;continue}else{z=0;am=18;break}}else{c[ah>>2]=_+1;aa=h;continue}}if((am|0)==18){aa=bT(-1,-1)|0;b1=M;b2=aa;b3=ap;b4=ao;break L1}else if((am|0)==301){c[k>>2]=c[k>>2]|4;b_=0;b$=ap;b0=ao;break L346}}}while(0);if((ap|0)==(aq|0)){b_=1;b$=aq;b0=ao;break}c[D>>2]=0;Io(v,ap,aq,D);if((c[D>>2]|0)==0){b_=1;b$=ap;b0=ao;break}c[k>>2]=c[k>>2]|4;b_=0;b$=ap;b0=ao}}while(0);Eb(B);Eb(A);Eb(y);Eb(x);Eb(v);if((b$|0)==0){i=q;return b_|0}z=0;ar(b0|0,b$|0);if(!z){i=q;return b_|0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{z=0;g=bT(-1,-1)|0;b1=M;b2=g;b3=E;b4=556}}while(0);Eb(B);Eb(A);Eb(y);Eb(x);Eb(v);if((b3|0)==0){bg(b2|0)}z=0;ar(b4|0,b3|0);if(!z){bg(b2|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function Ik(a){a=a|0;var b=0;b=cl(8)|0;z=0;as(466,b|0,a|0);if(!z){bK(b|0,29352,466)}else{z=0;a=bT(-1,-1)|0;bo(b|0);bg(a|0)}}function Il(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+160|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+120|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=m|0;t=n|0;c[t>>2]=s;u=n+4|0;c[u>>2]=556;v=m+100|0;z=0;as(352,p|0,h|0);do{if(!z){m=p|0;w=c[m>>2]|0;if((c[10440]|0)==-1){x=4}else{c[l>>2]=41760;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41760,l|0,520);if(!z){x=4}else{z=0}}L5:do{if((x|0)==4){y=(c[10441]|0)-1|0;A=c[w+8>>2]|0;do{if((c[w+12>>2]|0)-A>>2>>>0>y>>>0){B=c[A+(y<<2)>>2]|0;if((B|0)==0){break}C=B;a[q]=0;D=f|0;E=c[D>>2]|0;c[r>>2]=E;F=(z=0,ax(4,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,C|0,n|0,o|0,v|0)|0);if(z){z=0;break L5}if(F){F=k;if((a[F]&1)==0){a[k+1|0]=0;a[F]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}F=B;if((a[q]&1)!=0){B=(z=0,aM(c[(c[F>>2]|0)+28>>2]|0,C|0,45)|0);if(z){z=0;break L5}z=0;as(590,k|0,B|0);if(z){z=0;break L5}}B=(z=0,aM(c[(c[F>>2]|0)+28>>2]|0,C|0,48)|0);if(z){z=0;break L5}C=c[o>>2]|0;F=C-1|0;G=c[t>>2]|0;while(1){if(G>>>0>=F>>>0){break}if((a[G]|0)==B<<24>>24){G=G+1|0}else{break}}z=0,az(64,k|0,G|0,C|0)|0;if(z){z=0;break L5}}B=e|0;F=c[B>>2]|0;do{if((F|0)==0){H=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){H=F;break}I=(z=0,au(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(z){z=0;break L5}if((I|0)!=-1){H=F;break}c[B>>2]=0;H=0}}while(0);B=(H|0)==0;do{if((E|0)==0){x=33}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(B){break}else{x=35;break}}F=(z=0,au(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(z){z=0;break L5}if((F|0)==-1){c[D>>2]=0;x=33;break}else{if(B^(E|0)==0){break}else{x=35;break}}}}while(0);if((x|0)==33){if(B){x=35}}if((x|0)==35){c[j>>2]=c[j>>2]|2}c[b>>2]=H;DL(c[m>>2]|0)|0;E=c[t>>2]|0;c[t>>2]=0;if((E|0)==0){i=d;return}z=0;ar(c[u>>2]|0,E|0);if(!z){i=d;return}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);y=cl(4)|0;K$(y);z=0;aR(156,y|0,29336,98);if(z){z=0;break}}}while(0);w=bT(-1,-1)|0;y=w;w=M;DL(c[m>>2]|0)|0;A=c[t>>2]|0;c[t>>2]=0;if((A|0)==0){J=w;K=y}else{L=A;N=w;O=y;break}P=K;Q=0;R=P;S=J;bg(R|0)}else{z=0;y=bT(-1,-1)|0;c[t>>2]=0;L=s;N=M;O=y}}while(0);z=0;ar(c[u>>2]|0,L|0);if(!z){J=N;K=O;P=K;Q=0;R=P;S=J;bg(R|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Im(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=b;g=d;h=a[f]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if((h&1)==0){k=10;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}h=e-g|0;if((e|0)==(d|0)){return b|0}if((k-j|0)>>>0<h>>>0){Ek(b,k,j+h-k|0,j,j,0,0);m=a[f]|0}else{m=l}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;l=g+1|0;if((l|0)==(e|0)){break}else{g=l;d=d+1|0}}a[n+m|0]=0;m=j+h|0;if((a[f]&1)==0){a[f]=m<<1;return b|0}else{c[b+4>>2]=m;return b|0}return 0}function In(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+56|0;o=n|0;p=n+16|0;q=n+32|0;r=n+40|0;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+12|0;i=i+7&-8;y=x;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=B;D=i;i=i+12|0;i=i+7&-8;F=D;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+12|0;i=i+7&-8;J=I;if(b){b=c[d>>2]|0;if((c[10558]|0)!=-1){c[p>>2]=42232;c[p+4>>2]=460;c[p+8>>2]=0;D4(42232,p,520)}p=(c[10559]|0)-1|0;K=c[b+8>>2]|0;if((c[b+12>>2]|0)-K>>2>>>0<=p>>>0){L=cl(4)|0;M=L;K$(M);bK(L|0,29336,98)}b=c[K+(p<<2)>>2]|0;if((b|0)==0){L=cl(4)|0;M=L;K$(M);bK(L|0,29336,98)}L=b;cB[c[(c[b>>2]|0)+44>>2]&1023](q,L);M=e;E=c[q>>2]|0;a[M]=E;E=E>>8;a[M+1|0]=E;E=E>>8;a[M+2|0]=E;E=E>>8;a[M+3|0]=E;M=b;cB[c[(c[M>>2]|0)+32>>2]&1023](r,L);q=l;if((a[q]&1)==0){a[l+1|0]=0;a[q]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}z=0;as(620,l|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];LI(s|0,0,12)|0;Eb(r);cB[c[(c[M>>2]|0)+28>>2]&1023](t,L);r=k;if((a[r]&1)==0){a[k+1|0]=0;a[r]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}z=0;as(620,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];LI(u|0,0,12)|0;Eb(t);t=b;a[f]=cD[c[(c[t>>2]|0)+12>>2]&511](L)|0;a[g]=cD[c[(c[t>>2]|0)+16>>2]&511](L)|0;cB[c[(c[M>>2]|0)+20>>2]&1023](v,L);t=h;if((a[t]&1)==0){a[h+1|0]=0;a[t]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}z=0;as(620,h|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[t>>2]=c[w>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];LI(w|0,0,12)|0;Eb(v);cB[c[(c[M>>2]|0)+24>>2]&1023](x,L);M=j;if((a[M]&1)==0){a[j+1|0]=0;a[M]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}z=0;as(620,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[M>>2]=c[y>>2];c[M+4>>2]=c[y+4>>2];c[M+8>>2]=c[y+8>>2];LI(y|0,0,12)|0;Eb(x);N=cD[c[(c[b>>2]|0)+36>>2]&511](L)|0;c[m>>2]=N;i=n;return}else{L=c[d>>2]|0;if((c[10560]|0)!=-1){c[o>>2]=42240;c[o+4>>2]=460;c[o+8>>2]=0;D4(42240,o,520)}o=(c[10561]|0)-1|0;d=c[L+8>>2]|0;if((c[L+12>>2]|0)-d>>2>>>0<=o>>>0){O=cl(4)|0;P=O;K$(P);bK(O|0,29336,98)}L=c[d+(o<<2)>>2]|0;if((L|0)==0){O=cl(4)|0;P=O;K$(P);bK(O|0,29336,98)}O=L;cB[c[(c[L>>2]|0)+44>>2]&1023](A,O);P=e;E=c[A>>2]|0;a[P]=E;E=E>>8;a[P+1|0]=E;E=E>>8;a[P+2|0]=E;E=E>>8;a[P+3|0]=E;P=L;cB[c[(c[P>>2]|0)+32>>2]&1023](B,O);A=l;if((a[A]&1)==0){a[l+1|0]=0;a[A]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}z=0;as(620,l|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[A>>2]=c[C>>2];c[A+4>>2]=c[C+4>>2];c[A+8>>2]=c[C+8>>2];LI(C|0,0,12)|0;Eb(B);cB[c[(c[P>>2]|0)+28>>2]&1023](D,O);B=k;if((a[B]&1)==0){a[k+1|0]=0;a[B]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}z=0;as(620,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[B>>2]=c[F>>2];c[B+4>>2]=c[F+4>>2];c[B+8>>2]=c[F+8>>2];LI(F|0,0,12)|0;Eb(D);D=L;a[f]=cD[c[(c[D>>2]|0)+12>>2]&511](O)|0;a[g]=cD[c[(c[D>>2]|0)+16>>2]&511](O)|0;cB[c[(c[P>>2]|0)+20>>2]&1023](G,O);D=h;if((a[D]&1)==0){a[h+1|0]=0;a[D]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}z=0;as(620,h|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[D>>2]=c[H>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];LI(H|0,0,12)|0;Eb(G);cB[c[(c[P>>2]|0)+24>>2]&1023](I,O);P=j;if((a[P]&1)==0){a[j+1|0]=0;a[P]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}z=0;as(620,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[P>>2]=c[J>>2];c[P+4>>2]=c[J+4>>2];c[P+8>>2]=c[J+8>>2];LI(J|0,0,12)|0;Eb(I);N=cD[c[(c[L>>2]|0)+36>>2]&511](O)|0;c[m>>2]=N;i=n;return}}function Io(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=b;h=b;i=a[h]|0;j=i&255;if((j&1|0)==0){k=j>>>1}else{k=c[b+4>>2]|0}if((k|0)==0){return}do{if((d|0)==(e|0)){l=i}else{k=e-4|0;if(k>>>0>d>>>0){m=d;n=k}else{l=i;break}do{k=c[m>>2]|0;c[m>>2]=c[n>>2];c[n>>2]=k;m=m+4|0;n=n-4|0;}while(m>>>0<n>>>0);l=a[h]|0}}while(0);if((l&1)==0){o=g+1|0}else{o=c[b+8>>2]|0}g=l&255;if((g&1|0)==0){p=g>>>1}else{p=c[b+4>>2]|0}b=e-4|0;e=a[o]|0;g=e<<24>>24;l=e<<24>>24<1|e<<24>>24==127;L22:do{if(b>>>0>d>>>0){e=o+p|0;h=o;n=d;m=g;i=l;while(1){if(!i){if((m|0)!=(c[n>>2]|0)){break}}k=(e-h|0)>1?h+1|0:h;j=n+4|0;q=a[k]|0;r=q<<24>>24;s=q<<24>>24<1|q<<24>>24==127;if(j>>>0<b>>>0){h=k;n=j;m=r;i=s}else{t=r;u=s;break L22}}c[f>>2]=4;return}else{t=g;u=l}}while(0);if(u){return}u=c[b>>2]|0;if(!(t>>>0<u>>>0|(u|0)==0)){return}c[f>>2]=4;return}function Ip(a){a=a|0;DJ(a|0);Lw(a);return}function Iq(a){a=a|0;DJ(a|0);return}function Ir(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;d=i;i=i+600|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+416|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=d+496|0;u=m|0;v=n|0;c[v>>2]=u;w=n+4|0;c[w>>2]=556;x=m+400|0;z=0;as(352,p|0,h|0);do{if(!z){m=p|0;y=c[m>>2]|0;if((c[10438]|0)==-1){A=4}else{c[l>>2]=41752;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41752,l|0,520);if(!z){A=4}else{z=0;A=15}}L5:do{if((A|0)==4){B=(c[10439]|0)-1|0;C=c[y+8>>2]|0;do{if((c[y+12>>2]|0)-C>>2>>>0>B>>>0){D=c[C+(B<<2)>>2]|0;if((D|0)==0){break}E=D;a[q]=0;F=f|0;c[r>>2]=c[F>>2];G=(z=0,ax(2,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,E|0,n|0,o|0,x|0)|0);if(z){z=0;A=15;break L5}L11:do{if(G){H=s|0;I=c[(c[D>>2]|0)+48>>2]|0;z=0,aU(I|0,E|0,13456,13466,H|0)|0;if(z){z=0;A=15;break L5}I=t|0;J=c[o>>2]|0;K=c[v>>2]|0;L=J-K|0;do{if((L|0)>392){N=Lo((L>>2)+2|0)|0;if((N|0)!=0){O=N;P=N;A=19;break}z=0;aS(4);if(!z){O=0;P=0;A=19}else{z=0;Q=0;A=16}}else{O=I;P=0;A=19}}while(0);do{if((A|0)==19){if((a[q]&1)==0){R=O}else{a[O]=45;R=O+1|0}if(K>>>0<J>>>0){L=s+40|0;N=s;S=R;T=K;while(1){U=H;while(1){if((U|0)==(L|0)){V=L;break}if((c[U>>2]|0)==(c[T>>2]|0)){V=U;break}else{U=U+4|0}}a[S]=a[13456+(V-N>>2)|0]|0;U=T+4|0;W=S+1|0;if(U>>>0<(c[o>>2]|0)>>>0){S=W;T=U}else{X=W;break}}}else{X=R}a[X]=0;T=b8(I|0,11040,(S=i,i=i+8|0,c[S>>2]=k,S)|0)|0;i=S;if((T|0)==1){if((P|0)==0){break L11}Lp(P);break L11}T=cl(8)|0;z=0;as(466,T|0,10776);if(z){z=0;S=bT(-1,-1)|0;N=M;bo(T|0);Y=N;Z=S;_=P;break}z=0;aR(156,T|0,29352,466);if(z){z=0;Q=P;A=16;break}}}while(0);if((A|0)==16){I=bT(-1,-1)|0;Y=M;Z=I;_=Q}I=Z;H=Y;if((_|0)==0){$=H;aa=I;break L5}Lp(_);$=H;aa=I;break L5}}while(0);E=e|0;D=c[E>>2]|0;do{if((D|0)==0){ab=0}else{G=c[D+12>>2]|0;if((G|0)==(c[D+16>>2]|0)){I=(z=0,au(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(!z){ac=I}else{z=0;A=15;break L5}}else{ac=c[G>>2]|0}if((ac|0)!=-1){ab=D;break}c[E>>2]=0;ab=0}}while(0);E=(ab|0)==0;D=c[F>>2]|0;do{if((D|0)==0){A=46}else{G=c[D+12>>2]|0;if((G|0)==(c[D+16>>2]|0)){I=(z=0,au(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(!z){ad=I}else{z=0;A=15;break L5}}else{ad=c[G>>2]|0}if((ad|0)==-1){c[F>>2]=0;A=46;break}else{if(E^(D|0)==0){break}else{A=48;break}}}}while(0);if((A|0)==46){if(E){A=48}}if((A|0)==48){c[j>>2]=c[j>>2]|2}c[b>>2]=ab;DL(c[m>>2]|0)|0;D=c[v>>2]|0;c[v>>2]=0;if((D|0)==0){i=d;return}z=0;ar(c[w>>2]|0,D|0);if(!z){i=d;return}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);B=cl(4)|0;K$(B);z=0;aR(156,B|0,29336,98);if(z){z=0;A=15;break}}}while(0);if((A|0)==15){y=bT(-1,-1)|0;$=M;aa=y}DL(c[m>>2]|0)|0;y=c[v>>2]|0;c[v>>2]=0;if((y|0)==0){ae=aa;af=$}else{ag=y;ah=aa;ai=$;break}aj=ae;ak=0;al=aj;am=af;bg(al|0)}else{z=0;y=bT(-1,-1)|0;c[v>>2]=0;ag=u;ah=y;ai=M}}while(0);z=0;ar(c[w>>2]|0,ag|0);if(!z){ae=ah;af=ai;aj=ae;ak=0;al=aj;am=af;bg(al|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Is(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0;p=i;i=i+448|0;q=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[q>>2];q=p|0;r=p+8|0;s=p+408|0;t=p+416|0;u=p+424|0;v=p+432|0;w=v;x=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;c[q>>2]=o;o=r|0;LI(w|0,0,12)|0;E=x;F=y;G=A;H=B;LI(E|0,0,12)|0;LI(F|0,0,12)|0;LI(G|0,0,12)|0;LI(H|0,0,12)|0;z=0;aL(8,f|0,g|0,s|0,t|0,u|0,v|0,x|0,y|0,A|0,C|0);L1:do{if(!z){g=m|0;c[n>>2]=c[g>>2];f=b|0;I=e|0;J=l;K=A+4|0;L=A+8|0;N=y+4|0;O=y+8|0;P=(h&512|0)!=0;Q=x+4|0;R=x+8|0;S=B+4|0;T=B+8|0;U=s+3|0;V=v+4|0;W=556;X=o;Y=o;Z=r+400|0;_=0;$=0;L3:while(1){aa=c[f>>2]|0;do{if((aa|0)==0){ab=1}else{ac=c[aa+12>>2]|0;if((ac|0)==(c[aa+16>>2]|0)){ad=(z=0,au(c[(c[aa>>2]|0)+36>>2]|0,aa|0)|0);if(!z){ae=ad}else{z=0;af=X;ag=W;ah=25;break L3}}else{ae=c[ac>>2]|0}if((ae|0)==-1){c[f>>2]=0;ab=1;break}else{ab=(c[f>>2]|0)==0;break}}}while(0);aa=c[I>>2]|0;do{if((aa|0)==0){ah=16}else{ac=c[aa+12>>2]|0;if((ac|0)==(c[aa+16>>2]|0)){ad=(z=0,au(c[(c[aa>>2]|0)+36>>2]|0,aa|0)|0);if(!z){ai=ad}else{z=0;af=X;ag=W;ah=25;break L3}}else{ai=c[ac>>2]|0}if((ai|0)==-1){c[I>>2]=0;ah=16;break}else{if(ab^(aa|0)==0){aj=aa;break}else{ak=W;al=X;am=Y;an=_;ah=256;break L3}}}}while(0);if((ah|0)==16){ah=0;if(ab){ak=W;al=X;am=Y;an=_;ah=256;break}else{aj=0}}L27:do{switch(a[s+$|0]|0){case 1:{if(($|0)==3){ak=W;al=X;am=Y;an=_;ah=256;break L3}aa=c[f>>2]|0;ac=c[aa+12>>2]|0;if((ac|0)==(c[aa+16>>2]|0)){ad=(z=0,au(c[(c[aa>>2]|0)+36>>2]|0,aa|0)|0);if(!z){ao=ad}else{z=0;af=X;ag=W;ah=25;break L3}}else{ao=c[ac>>2]|0}ac=(z=0,az(c[(c[J>>2]|0)+12>>2]|0,l|0,8192,ao|0)|0);if(z){z=0;af=X;ag=W;ah=25;break L3}if(!ac){ah=40;break L3}ac=c[f>>2]|0;ad=ac+12|0;aa=c[ad>>2]|0;if((aa|0)==(c[ac+16>>2]|0)){ap=(z=0,au(c[(c[ac>>2]|0)+40>>2]|0,ac|0)|0);if(!z){aq=ap}else{z=0;af=X;ag=W;ah=25;break L3}}else{c[ad>>2]=aa+4;aq=c[aa>>2]|0}z=0;as(254,B|0,aq|0);if(!z){ah=41}else{z=0;af=X;ag=W;ah=25;break L3}break};case 0:{ah=41;break};case 3:{aa=a[F]|0;ad=aa&255;ap=(ad&1|0)==0;ac=a[G]|0;at=ac&255;av=(at&1|0)==0;if(((ap?ad>>>1:c[N>>2]|0)|0)==(-(av?at>>>1:c[K>>2]|0)|0)){aw=_;ax=Z;ay=Y;aA=X;aB=W;break L27}do{if(((ap?ad>>>1:c[N>>2]|0)|0)!=0){if(((av?at>>>1:c[K>>2]|0)|0)==0){break}aC=c[f>>2]|0;aD=c[aC+12>>2]|0;if((aD|0)==(c[aC+16>>2]|0)){aE=(z=0,au(c[(c[aC>>2]|0)+36>>2]|0,aC|0)|0);if(z){z=0;af=X;ag=W;ah=25;break L3}aF=aE;aG=a[F]|0}else{aF=c[aD>>2]|0;aG=aa}aD=c[f>>2]|0;aE=aD+12|0;aC=c[aE>>2]|0;aH=(aC|0)==(c[aD+16>>2]|0);if((aF|0)==(c[((aG&1)==0?N:c[O>>2]|0)>>2]|0)){if(aH){aI=c[(c[aD>>2]|0)+40>>2]|0;z=0,au(aI|0,aD|0)|0;if(z){z=0;af=X;ag=W;ah=25;break L3}}else{c[aE>>2]=aC+4}aE=d[F]|0;aw=((aE&1|0)==0?aE>>>1:c[N>>2]|0)>>>0>1>>>0?y:_;ax=Z;ay=Y;aA=X;aB=W;break L27}if(aH){aH=(z=0,au(c[(c[aD>>2]|0)+36>>2]|0,aD|0)|0);if(!z){aJ=aH}else{z=0;af=X;ag=W;ah=25;break L3}}else{aJ=c[aC>>2]|0}if((aJ|0)!=(c[((a[G]&1)==0?K:c[L>>2]|0)>>2]|0)){ah=106;break L3}aC=c[f>>2]|0;aH=aC+12|0;aD=c[aH>>2]|0;if((aD|0)==(c[aC+16>>2]|0)){aE=c[(c[aC>>2]|0)+40>>2]|0;z=0,au(aE|0,aC|0)|0;if(z){z=0;af=X;ag=W;ah=25;break L3}}else{c[aH>>2]=aD+4}a[k]=1;aD=d[G]|0;aw=((aD&1|0)==0?aD>>>1:c[K>>2]|0)>>>0>1>>>0?A:_;ax=Z;ay=Y;aA=X;aB=W;break L27}}while(0);at=c[f>>2]|0;av=c[at+12>>2]|0;aD=(av|0)==(c[at+16>>2]|0);if(((ap?ad>>>1:c[N>>2]|0)|0)==0){if(aD){aH=(z=0,au(c[(c[at>>2]|0)+36>>2]|0,at|0)|0);if(z){z=0;af=X;ag=W;ah=25;break L3}aK=aH;aM=a[G]|0}else{aK=c[av>>2]|0;aM=ac}if((aK|0)!=(c[((aM&1)==0?K:c[L>>2]|0)>>2]|0)){aw=_;ax=Z;ay=Y;aA=X;aB=W;break L27}aH=c[f>>2]|0;aC=aH+12|0;aE=c[aC>>2]|0;if((aE|0)==(c[aH+16>>2]|0)){aI=c[(c[aH>>2]|0)+40>>2]|0;z=0,au(aI|0,aH|0)|0;if(z){z=0;af=X;ag=W;ah=25;break L3}}else{c[aC>>2]=aE+4}a[k]=1;aE=d[G]|0;aw=((aE&1|0)==0?aE>>>1:c[K>>2]|0)>>>0>1>>>0?A:_;ax=Z;ay=Y;aA=X;aB=W;break L27}if(aD){aD=(z=0,au(c[(c[at>>2]|0)+36>>2]|0,at|0)|0);if(z){z=0;af=X;ag=W;ah=25;break L3}aN=aD;aO=a[F]|0}else{aN=c[av>>2]|0;aO=aa}if((aN|0)!=(c[((aO&1)==0?N:c[O>>2]|0)>>2]|0)){a[k]=1;aw=_;ax=Z;ay=Y;aA=X;aB=W;break L27}av=c[f>>2]|0;aD=av+12|0;at=c[aD>>2]|0;if((at|0)==(c[av+16>>2]|0)){aE=c[(c[av>>2]|0)+40>>2]|0;z=0,au(aE|0,av|0)|0;if(z){z=0;af=X;ag=W;ah=25;break L3}}else{c[aD>>2]=at+4}at=d[F]|0;aw=((at&1|0)==0?at>>>1:c[N>>2]|0)>>>0>1>>>0?y:_;ax=Z;ay=Y;aA=X;aB=W;break};case 2:{if(!((_|0)!=0|$>>>0<2>>>0)){if(($|0)==2){aP=(a[U]|0)!=0}else{aP=0}if(!(P|aP)){aw=0;ax=Z;ay=Y;aA=X;aB=W;break L27}}at=a[E]|0;aD=(at&1)==0?Q:c[R>>2]|0;L99:do{if(($|0)==0){aQ=aD;aT=at;aU=aj}else{if((d[s+($-1)|0]|0)>>>0<2>>>0){aV=aD;aW=at}else{aQ=aD;aT=at;aU=aj;break}while(1){av=aW&255;if((aV|0)==(((aW&1)==0?Q:c[R>>2]|0)+(((av&1|0)==0?av>>>1:c[Q>>2]|0)<<2)|0)){aX=aW;break}av=(z=0,az(c[(c[J>>2]|0)+12>>2]|0,l|0,8192,c[aV>>2]|0)|0);if(z){z=0;ah=22;break L3}if(!av){ah=117;break}aV=aV+4|0;aW=a[E]|0}if((ah|0)==117){ah=0;aX=a[E]|0}av=(aX&1)==0;aE=aV-(av?Q:c[R>>2]|0)>>2;aC=a[H]|0;aH=aC&255;aI=(aH&1|0)==0;L109:do{if(aE>>>0<=(aI?aH>>>1:c[S>>2]|0)>>>0){aY=(aC&1)==0;aZ=(aY?S:c[T>>2]|0)+((aI?aH>>>1:c[S>>2]|0)-aE<<2)|0;a_=(aY?S:c[T>>2]|0)+((aI?aH>>>1:c[S>>2]|0)<<2)|0;if((aZ|0)==(a_|0)){aQ=aV;aT=aX;aU=aj;break L99}else{a$=aZ;a0=av?Q:c[R>>2]|0}while(1){if((c[a$>>2]|0)!=(c[a0>>2]|0)){break L109}aZ=a$+4|0;if((aZ|0)==(a_|0)){aQ=aV;aT=aX;aU=aj;break L99}a$=aZ;a0=a0+4|0}}}while(0);aQ=av?Q:c[R>>2]|0;aT=aX;aU=aj}}while(0);L116:while(1){at=aT&255;if((aQ|0)==(((aT&1)==0?Q:c[R>>2]|0)+(((at&1|0)==0?at>>>1:c[Q>>2]|0)<<2)|0)){break}at=c[f>>2]|0;do{if((at|0)==0){a1=1}else{aD=c[at+12>>2]|0;if((aD|0)==(c[at+16>>2]|0)){aa=(z=0,au(c[(c[at>>2]|0)+36>>2]|0,at|0)|0);if(!z){a2=aa}else{z=0;ah=23;break L3}}else{a2=c[aD>>2]|0}if((a2|0)==-1){c[f>>2]=0;a1=1;break}else{a1=(c[f>>2]|0)==0;break}}}while(0);do{if((aU|0)==0){ah=138}else{at=c[aU+12>>2]|0;if((at|0)==(c[aU+16>>2]|0)){av=(z=0,au(c[(c[aU>>2]|0)+36>>2]|0,aU|0)|0);if(!z){a3=av}else{z=0;ah=23;break L3}}else{a3=c[at>>2]|0}if((a3|0)==-1){c[I>>2]=0;ah=138;break}else{if(a1^(aU|0)==0){a4=aU;break}else{break L116}}}}while(0);if((ah|0)==138){ah=0;if(a1){break}else{a4=0}}at=c[f>>2]|0;av=c[at+12>>2]|0;if((av|0)==(c[at+16>>2]|0)){aD=(z=0,au(c[(c[at>>2]|0)+36>>2]|0,at|0)|0);if(!z){a5=aD}else{z=0;ah=23;break L3}}else{a5=c[av>>2]|0}if((a5|0)!=(c[aQ>>2]|0)){break}av=c[f>>2]|0;aD=av+12|0;at=c[aD>>2]|0;if((at|0)==(c[av+16>>2]|0)){aa=c[(c[av>>2]|0)+40>>2]|0;z=0,au(aa|0,av|0)|0;if(z){z=0;ah=23;break L3}}else{c[aD>>2]=at+4}aQ=aQ+4|0;aT=a[E]|0;aU=a4}if(!P){aw=_;ax=Z;ay=Y;aA=X;aB=W;break L27}at=a[E]|0;aD=at&255;if((aQ|0)==(((at&1)==0?Q:c[R>>2]|0)+(((aD&1|0)==0?aD>>>1:c[Q>>2]|0)<<2)|0)){aw=_;ax=Z;ay=Y;aA=X;aB=W}else{ah=150;break L3}break};case 4:{aD=0;at=Z;av=Y;aa=X;ac=W;L152:while(1){ad=c[f>>2]|0;do{if((ad|0)==0){a6=1}else{ap=c[ad+12>>2]|0;if((ap|0)==(c[ad+16>>2]|0)){aH=(z=0,au(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!z){a7=aH}else{z=0;a8=aa;a9=ac;ah=20;break L3}}else{a7=c[ap>>2]|0}if((a7|0)==-1){c[f>>2]=0;a6=1;break}else{a6=(c[f>>2]|0)==0;break}}}while(0);ad=c[I>>2]|0;do{if((ad|0)==0){ah=164}else{ap=c[ad+12>>2]|0;if((ap|0)==(c[ad+16>>2]|0)){aH=(z=0,au(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!z){ba=aH}else{z=0;a8=aa;a9=ac;ah=20;break L3}}else{ba=c[ap>>2]|0}if((ba|0)==-1){c[I>>2]=0;ah=164;break}else{if(a6^(ad|0)==0){break}else{break L152}}}}while(0);if((ah|0)==164){ah=0;if(a6){break}}ad=c[f>>2]|0;ap=c[ad+12>>2]|0;if((ap|0)==(c[ad+16>>2]|0)){aH=(z=0,au(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!z){bb=aH}else{z=0;a8=aa;a9=ac;ah=20;break L3}}else{bb=c[ap>>2]|0}ap=(z=0,az(c[(c[J>>2]|0)+12>>2]|0,l|0,2048,bb|0)|0);if(z){z=0;a8=aa;a9=ac;ah=20;break L3}if(ap){ap=c[n>>2]|0;if((ap|0)==(c[q>>2]|0)){z=0;aR(98,m|0,n|0,q|0);if(z){z=0;a8=aa;a9=ac;ah=20;break L3}bc=c[n>>2]|0}else{bc=ap}c[n>>2]=bc+4;c[bc>>2]=bb;bd=aD+1|0;be=at;bf=av;bh=aa;bi=ac}else{ap=d[w]|0;if((((ap&1|0)==0?ap>>>1:c[V>>2]|0)|0)==0|(aD|0)==0){break}if((bb|0)!=(c[u>>2]|0)){break}if((av|0)==(at|0)){ap=(ac|0)!=556;aH=av-aa|0;ad=aH>>>0<2147483647>>>0?aH<<1:-1;aI=aH>>2;if(ap){bj=aa}else{bj=0}ap=Lr(bj,ad)|0;aH=ap;if((ap|0)==0){z=0;aS(4);if(z){z=0;a8=aa;a9=ac;ah=20;break L3}}bk=aH+(ad>>>2<<2)|0;bl=aH+(aI<<2)|0;bm=aH;bn=512}else{bk=at;bl=av;bm=aa;bn=ac}c[bl>>2]=aD;bd=0;be=bk;bf=bl+4|0;bh=bm;bi=bn}aH=c[f>>2]|0;aI=aH+12|0;ad=c[aI>>2]|0;if((ad|0)==(c[aH+16>>2]|0)){ap=c[(c[aH>>2]|0)+40>>2]|0;z=0,au(ap|0,aH|0)|0;if(!z){aD=bd;at=be;av=bf;aa=bh;ac=bi;continue}else{z=0;a8=bh;a9=bi;ah=20;break L3}}else{c[aI>>2]=ad+4;aD=bd;at=be;av=bf;aa=bh;ac=bi;continue}}if((aa|0)==(av|0)|(aD|0)==0){bo=at;bp=av;bq=aa;br=ac}else{if((av|0)==(at|0)){ad=(ac|0)!=556;aI=av-aa|0;aH=aI>>>0<2147483647>>>0?aI<<1:-1;ap=aI>>2;if(ad){bs=aa}else{bs=0}ad=Lr(bs,aH)|0;aI=ad;if((ad|0)==0){z=0;aS(4);if(z){z=0;af=aa;ag=ac;ah=25;break L3}}bt=aI+(aH>>>2<<2)|0;bu=aI+(ap<<2)|0;bv=aI;bw=512}else{bt=at;bu=av;bv=aa;bw=ac}c[bu>>2]=aD;bo=bt;bp=bu+4|0;bq=bv;br=bw}aI=c[C>>2]|0;if((aI|0)>0){ap=c[f>>2]|0;do{if((ap|0)==0){bx=1}else{aH=c[ap+12>>2]|0;if((aH|0)==(c[ap+16>>2]|0)){ad=(z=0,au(c[(c[ap>>2]|0)+36>>2]|0,ap|0)|0);if(!z){by=ad}else{z=0;af=bq;ag=br;ah=25;break L3}}else{by=c[aH>>2]|0}if((by|0)==-1){c[f>>2]=0;bx=1;break}else{bx=(c[f>>2]|0)==0;break}}}while(0);ap=c[I>>2]|0;do{if((ap|0)==0){ah=213}else{aD=c[ap+12>>2]|0;if((aD|0)==(c[ap+16>>2]|0)){ac=(z=0,au(c[(c[ap>>2]|0)+36>>2]|0,ap|0)|0);if(!z){bz=ac}else{z=0;af=bq;ag=br;ah=25;break L3}}else{bz=c[aD>>2]|0}if((bz|0)==-1){c[I>>2]=0;ah=213;break}else{if(bx^(ap|0)==0){bA=ap;break}else{ah=219;break L3}}}}while(0);if((ah|0)==213){ah=0;if(bx){ah=219;break L3}else{bA=0}}ap=c[f>>2]|0;aD=c[ap+12>>2]|0;if((aD|0)==(c[ap+16>>2]|0)){ac=(z=0,au(c[(c[ap>>2]|0)+36>>2]|0,ap|0)|0);if(!z){bB=ac}else{z=0;af=bq;ag=br;ah=25;break L3}}else{bB=c[aD>>2]|0}if((bB|0)!=(c[t>>2]|0)){ah=219;break L3}aD=c[f>>2]|0;ac=aD+12|0;ap=c[ac>>2]|0;if((ap|0)==(c[aD+16>>2]|0)){aa=c[(c[aD>>2]|0)+40>>2]|0;z=0,au(aa|0,aD|0)|0;if(!z){bC=bA;bD=aI}else{z=0;af=bq;ag=br;ah=25;break L3}}else{c[ac>>2]=ap+4;bC=bA;bD=aI}while(1){ap=c[f>>2]|0;do{if((ap|0)==0){bE=1}else{ac=c[ap+12>>2]|0;if((ac|0)==(c[ap+16>>2]|0)){aD=(z=0,au(c[(c[ap>>2]|0)+36>>2]|0,ap|0)|0);if(!z){bF=aD}else{z=0;ah=21;break L3}}else{bF=c[ac>>2]|0}if((bF|0)==-1){c[f>>2]=0;bE=1;break}else{bE=(c[f>>2]|0)==0;break}}}while(0);do{if((bC|0)==0){ah=236}else{ap=c[bC+12>>2]|0;if((ap|0)==(c[bC+16>>2]|0)){ac=(z=0,au(c[(c[bC>>2]|0)+36>>2]|0,bC|0)|0);if(!z){bG=ac}else{z=0;ah=21;break L3}}else{bG=c[ap>>2]|0}if((bG|0)==-1){c[I>>2]=0;ah=236;break}else{if(bE^(bC|0)==0){bH=bC;break}else{ah=243;break L3}}}}while(0);if((ah|0)==236){ah=0;if(bE){ah=243;break L3}else{bH=0}}ap=c[f>>2]|0;ac=c[ap+12>>2]|0;if((ac|0)==(c[ap+16>>2]|0)){aD=(z=0,au(c[(c[ap>>2]|0)+36>>2]|0,ap|0)|0);if(!z){bI=aD}else{z=0;ah=21;break L3}}else{bI=c[ac>>2]|0}ac=(z=0,az(c[(c[J>>2]|0)+12>>2]|0,l|0,2048,bI|0)|0);if(z){z=0;ah=21;break L3}if(!ac){ah=243;break L3}if((c[n>>2]|0)==(c[q>>2]|0)){z=0;aR(98,m|0,n|0,q|0);if(z){z=0;ah=21;break L3}}ac=c[f>>2]|0;aD=c[ac+12>>2]|0;if((aD|0)==(c[ac+16>>2]|0)){ap=(z=0,au(c[(c[ac>>2]|0)+36>>2]|0,ac|0)|0);if(!z){bJ=ap}else{z=0;ah=21;break L3}}else{bJ=c[aD>>2]|0}aD=c[n>>2]|0;c[n>>2]=aD+4;c[aD>>2]=bJ;aD=bD-1|0;c[C>>2]=aD;ap=c[f>>2]|0;ac=ap+12|0;aa=c[ac>>2]|0;if((aa|0)==(c[ap+16>>2]|0)){av=c[(c[ap>>2]|0)+40>>2]|0;z=0,au(av|0,ap|0)|0;if(z){z=0;ah=21;break L3}}else{c[ac>>2]=aa+4}if((aD|0)>0){bC=bH;bD=aD}else{break}}}if((c[n>>2]|0)==(c[g>>2]|0)){ah=254;break L3}else{aw=_;ax=bo;ay=bp;aA=bq;aB=br}break};default:{aw=_;ax=Z;ay=Y;aA=X;aB=W}}}while(0);L296:do{if((ah|0)==41){ah=0;if(($|0)==3){ak=W;al=X;am=Y;an=_;ah=256;break L3}else{bK=aj}while(1){aI=c[f>>2]|0;do{if((aI|0)==0){bL=1}else{aD=c[aI+12>>2]|0;if((aD|0)==(c[aI+16>>2]|0)){aa=(z=0,au(c[(c[aI>>2]|0)+36>>2]|0,aI|0)|0);if(!z){bM=aa}else{z=0;ah=24;break L3}}else{bM=c[aD>>2]|0}if((bM|0)==-1){c[f>>2]=0;bL=1;break}else{bL=(c[f>>2]|0)==0;break}}}while(0);do{if((bK|0)==0){ah=55}else{aI=c[bK+12>>2]|0;if((aI|0)==(c[bK+16>>2]|0)){aD=(z=0,au(c[(c[bK>>2]|0)+36>>2]|0,bK|0)|0);if(!z){bN=aD}else{z=0;ah=24;break L3}}else{bN=c[aI>>2]|0}if((bN|0)==-1){c[I>>2]=0;ah=55;break}else{if(bL^(bK|0)==0){bO=bK;break}else{aw=_;ax=Z;ay=Y;aA=X;aB=W;break L296}}}}while(0);if((ah|0)==55){ah=0;if(bL){aw=_;ax=Z;ay=Y;aA=X;aB=W;break L296}else{bO=0}}aI=c[f>>2]|0;aD=c[aI+12>>2]|0;if((aD|0)==(c[aI+16>>2]|0)){aa=(z=0,au(c[(c[aI>>2]|0)+36>>2]|0,aI|0)|0);if(!z){bP=aa}else{z=0;ah=24;break L3}}else{bP=c[aD>>2]|0}aD=(z=0,az(c[(c[J>>2]|0)+12>>2]|0,l|0,8192,bP|0)|0);if(z){z=0;ah=24;break L3}if(!aD){aw=_;ax=Z;ay=Y;aA=X;aB=W;break L296}aD=c[f>>2]|0;aa=aD+12|0;aI=c[aa>>2]|0;if((aI|0)==(c[aD+16>>2]|0)){ac=(z=0,au(c[(c[aD>>2]|0)+40>>2]|0,aD|0)|0);if(!z){bQ=ac}else{z=0;ah=24;break L3}}else{c[aa>>2]=aI+4;bQ=c[aI>>2]|0}z=0;as(254,B|0,bQ|0);if(!z){bK=bO}else{z=0;ah=24;break L3}}}}while(0);aI=$+1|0;if(aI>>>0<4>>>0){W=aB;X=aA;Y=ay;Z=ax;_=aw;$=aI}else{ak=aB;al=aA;am=ay;an=aw;ah=256;break}}L333:do{if((ah|0)==219){c[j>>2]=c[j>>2]|4;bR=0;bS=bq;bU=br}else if((ah|0)==254){c[j>>2]=c[j>>2]|4;bR=0;bS=bq;bU=br}else if((ah|0)==243){c[j>>2]=c[j>>2]|4;bR=0;bS=bq;bU=br}else if((ah|0)==256){L338:do{if((an|0)!=0){$=an;_=an+4|0;Z=an+8|0;Y=1;L340:while(1){J=d[$]|0;if((J&1|0)==0){bV=J>>>1}else{bV=c[_>>2]|0}if(Y>>>0>=bV>>>0){break L338}J=c[f>>2]|0;do{if((J|0)==0){bW=1}else{g=c[J+12>>2]|0;if((g|0)==(c[J+16>>2]|0)){V=(z=0,au(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!z){bY=V}else{z=0;ah=19;break L340}}else{bY=c[g>>2]|0}if((bY|0)==-1){c[f>>2]=0;bW=1;break}else{bW=(c[f>>2]|0)==0;break}}}while(0);J=c[I>>2]|0;do{if((J|0)==0){ah=275}else{g=c[J+12>>2]|0;if((g|0)==(c[J+16>>2]|0)){V=(z=0,au(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!z){bZ=V}else{z=0;ah=19;break L340}}else{bZ=c[g>>2]|0}if((bZ|0)==-1){c[I>>2]=0;ah=275;break}else{if(bW^(J|0)==0){break}else{ah=283;break L340}}}}while(0);if((ah|0)==275){ah=0;if(bW){ah=283;break}}J=c[f>>2]|0;g=c[J+12>>2]|0;if((g|0)==(c[J+16>>2]|0)){V=(z=0,au(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!z){b_=V}else{z=0;ah=19;break}}else{b_=c[g>>2]|0}if((a[$]&1)==0){b$=_}else{b$=c[Z>>2]|0}if((b_|0)!=(c[b$+(Y<<2)>>2]|0)){ah=283;break}g=Y+1|0;V=c[f>>2]|0;J=V+12|0;Q=c[J>>2]|0;if((Q|0)==(c[V+16>>2]|0)){R=c[(c[V>>2]|0)+40>>2]|0;z=0,au(R|0,V|0)|0;if(!z){Y=g;continue}else{z=0;ah=19;break}}else{c[J>>2]=Q+4;Y=g;continue}}if((ah|0)==283){c[j>>2]=c[j>>2]|4;bR=0;bS=al;bU=ak;break L333}else if((ah|0)==19){Y=bT(-1,-1)|0;b0=M;b1=Y;b2=al;b3=ak;break L1}}}while(0);if((al|0)==(am|0)){bR=1;bS=am;bU=ak;break}c[D>>2]=0;Io(v,al,am,D);if((c[D>>2]|0)==0){bR=1;bS=al;bU=ak;break}c[j>>2]=c[j>>2]|4;bR=0;bS=al;bU=ak}else if((ah|0)==20){Y=bT(-1,-1)|0;b0=M;b1=Y;b2=a8;b3=a9;break L1}else if((ah|0)==21){Y=bT(-1,-1)|0;b0=M;b1=Y;b2=bq;b3=br;break L1}else if((ah|0)==22){Y=bT(-1,-1)|0;b0=M;b1=Y;b2=X;b3=W;break L1}else if((ah|0)==23){Y=bT(-1,-1)|0;b0=M;b1=Y;b2=X;b3=W;break L1}else if((ah|0)==24){Y=bT(-1,-1)|0;b0=M;b1=Y;b2=X;b3=W;break L1}else if((ah|0)==25){Y=bT(-1,-1)|0;b0=M;b1=Y;b2=af;b3=ag;break L1}else if((ah|0)==40){c[j>>2]=c[j>>2]|4;bR=0;bS=X;bU=W}else if((ah|0)==106){c[j>>2]=c[j>>2]|4;bR=0;bS=X;bU=W}else if((ah|0)==150){c[j>>2]=c[j>>2]|4;bR=0;bS=X;bU=W}}while(0);Eo(B);Eo(A);Eo(y);Eo(x);Eb(v);if((bS|0)==0){i=p;return bR|0}z=0;ar(bU|0,bS|0);if(!z){i=p;return bR|0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{z=0;W=bT(-1,-1)|0;b0=M;b1=W;b2=o;b3=556}}while(0);Eo(B);Eo(A);Eo(y);Eo(x);Eb(v);if((b2|0)==0){bg(b1|0)}z=0;ar(b3|0,b2|0);if(!z){bg(b1|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function It(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+456|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+416|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=m|0;t=n|0;c[t>>2]=s;u=n+4|0;c[u>>2]=556;v=m+400|0;z=0;as(352,p|0,h|0);do{if(!z){m=p|0;w=c[m>>2]|0;if((c[10438]|0)==-1){x=4}else{c[l>>2]=41752;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41752,l|0,520);if(!z){x=4}else{z=0}}L5:do{if((x|0)==4){y=(c[10439]|0)-1|0;A=c[w+8>>2]|0;do{if((c[w+12>>2]|0)-A>>2>>>0>y>>>0){B=c[A+(y<<2)>>2]|0;if((B|0)==0){break}C=B;a[q]=0;D=f|0;E=c[D>>2]|0;c[r>>2]=E;F=(z=0,ax(2,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,C|0,n|0,o|0,v|0)|0);if(z){z=0;break L5}if(F){F=k;if((a[F]&1)==0){c[k+4>>2]=0;a[F]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}F=B;if((a[q]&1)!=0){B=(z=0,aM(c[(c[F>>2]|0)+44>>2]|0,C|0,45)|0);if(z){z=0;break L5}z=0;as(254,k|0,B|0);if(z){z=0;break L5}}B=(z=0,aM(c[(c[F>>2]|0)+44>>2]|0,C|0,48)|0);if(z){z=0;break L5}C=c[o>>2]|0;F=C-4|0;G=c[t>>2]|0;while(1){if(G>>>0>=F>>>0){break}if((c[G>>2]|0)==(B|0)){G=G+4|0}else{break}}z=0,az(74,k|0,G|0,C|0)|0;if(z){z=0;break L5}}B=e|0;F=c[B>>2]|0;do{if((F|0)==0){H=0}else{I=c[F+12>>2]|0;if((I|0)==(c[F+16>>2]|0)){J=(z=0,au(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(!z){K=J}else{z=0;break L5}}else{K=c[I>>2]|0}if((K|0)!=-1){H=F;break}c[B>>2]=0;H=0}}while(0);B=(H|0)==0;do{if((E|0)==0){x=34}else{F=c[E+12>>2]|0;if((F|0)==(c[E+16>>2]|0)){C=(z=0,au(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(!z){L=C}else{z=0;break L5}}else{L=c[F>>2]|0}if((L|0)==-1){c[D>>2]=0;x=34;break}else{if(B^(E|0)==0){break}else{x=36;break}}}}while(0);if((x|0)==34){if(B){x=36}}if((x|0)==36){c[j>>2]=c[j>>2]|2}c[b>>2]=H;DL(c[m>>2]|0)|0;E=c[t>>2]|0;c[t>>2]=0;if((E|0)==0){i=d;return}z=0;ar(c[u>>2]|0,E|0);if(!z){i=d;return}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);y=cl(4)|0;K$(y);z=0;aR(156,y|0,29336,98);if(z){z=0;break}}}while(0);w=bT(-1,-1)|0;y=w;w=M;DL(c[m>>2]|0)|0;A=c[t>>2]|0;c[t>>2]=0;if((A|0)==0){N=w;O=y}else{P=A;Q=w;R=y;break}S=O;T=0;U=S;V=N;bg(U|0)}else{z=0;y=bT(-1,-1)|0;c[t>>2]=0;P=s;Q=M;R=y}}while(0);z=0;ar(c[u>>2]|0,P|0);if(!z){N=Q;O=R;S=O;T=0;U=S;V=N;bg(U|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Iu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=b;g=d;h=a[f]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if((h&1)==0){k=1;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}h=e-g>>2;if((h|0)==0){return b|0}if((k-j|0)>>>0<h>>>0){Eu(b,k,j+h-k|0,j,j,0,0);m=a[f]|0}else{m=l}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{l=j+((e-4+(-g|0)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{g=m;d=d+4|0}}o=n+(l<<2)|0}c[o>>2]=0;o=j+h|0;if((a[f]&1)==0){a[f]=o<<1;return b|0}else{c[b+4>>2]=o;return b|0}return 0}function Iv(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+56|0;o=n|0;p=n+16|0;q=n+32|0;r=n+40|0;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;x=i;i=i+12|0;i=i+7&-8;y=x;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=B;D=i;i=i+12|0;i=i+7&-8;F=D;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+12|0;i=i+7&-8;J=I;if(b){b=c[d>>2]|0;if((c[10554]|0)!=-1){c[p>>2]=42216;c[p+4>>2]=460;c[p+8>>2]=0;D4(42216,p,520)}p=(c[10555]|0)-1|0;K=c[b+8>>2]|0;if((c[b+12>>2]|0)-K>>2>>>0<=p>>>0){L=cl(4)|0;M=L;K$(M);bK(L|0,29336,98)}b=c[K+(p<<2)>>2]|0;if((b|0)==0){L=cl(4)|0;M=L;K$(M);bK(L|0,29336,98)}L=b;cB[c[(c[b>>2]|0)+44>>2]&1023](q,L);M=e;E=c[q>>2]|0;a[M]=E;E=E>>8;a[M+1|0]=E;E=E>>8;a[M+2|0]=E;E=E>>8;a[M+3|0]=E;M=b;cB[c[(c[M>>2]|0)+32>>2]&1023](r,L);q=l;if((a[q]&1)==0){c[l+4>>2]=0;a[q]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}z=0;as(510,l|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];LI(s|0,0,12)|0;Eo(r);cB[c[(c[M>>2]|0)+28>>2]&1023](t,L);r=k;if((a[r]&1)==0){c[k+4>>2]=0;a[r]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}z=0;as(510,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];LI(u|0,0,12)|0;Eo(t);t=b;c[f>>2]=cD[c[(c[t>>2]|0)+12>>2]&511](L)|0;c[g>>2]=cD[c[(c[t>>2]|0)+16>>2]&511](L)|0;cB[c[(c[b>>2]|0)+20>>2]&1023](v,L);b=h;if((a[b]&1)==0){a[h+1|0]=0;a[b]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}z=0;as(620,h|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[b>>2]=c[w>>2];c[b+4>>2]=c[w+4>>2];c[b+8>>2]=c[w+8>>2];LI(w|0,0,12)|0;Eb(v);cB[c[(c[M>>2]|0)+24>>2]&1023](x,L);M=j;if((a[M]&1)==0){c[j+4>>2]=0;a[M]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}z=0;as(510,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[M>>2]=c[y>>2];c[M+4>>2]=c[y+4>>2];c[M+8>>2]=c[y+8>>2];LI(y|0,0,12)|0;Eo(x);N=cD[c[(c[t>>2]|0)+36>>2]&511](L)|0;c[m>>2]=N;i=n;return}else{L=c[d>>2]|0;if((c[10556]|0)!=-1){c[o>>2]=42224;c[o+4>>2]=460;c[o+8>>2]=0;D4(42224,o,520)}o=(c[10557]|0)-1|0;d=c[L+8>>2]|0;if((c[L+12>>2]|0)-d>>2>>>0<=o>>>0){O=cl(4)|0;P=O;K$(P);bK(O|0,29336,98)}L=c[d+(o<<2)>>2]|0;if((L|0)==0){O=cl(4)|0;P=O;K$(P);bK(O|0,29336,98)}O=L;cB[c[(c[L>>2]|0)+44>>2]&1023](A,O);P=e;E=c[A>>2]|0;a[P]=E;E=E>>8;a[P+1|0]=E;E=E>>8;a[P+2|0]=E;E=E>>8;a[P+3|0]=E;P=L;cB[c[(c[P>>2]|0)+32>>2]&1023](B,O);A=l;if((a[A]&1)==0){c[l+4>>2]=0;a[A]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}z=0;as(510,l|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[A>>2]=c[C>>2];c[A+4>>2]=c[C+4>>2];c[A+8>>2]=c[C+8>>2];LI(C|0,0,12)|0;Eo(B);cB[c[(c[P>>2]|0)+28>>2]&1023](D,O);B=k;if((a[B]&1)==0){c[k+4>>2]=0;a[B]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}z=0;as(510,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[B>>2]=c[F>>2];c[B+4>>2]=c[F+4>>2];c[B+8>>2]=c[F+8>>2];LI(F|0,0,12)|0;Eo(D);D=L;c[f>>2]=cD[c[(c[D>>2]|0)+12>>2]&511](O)|0;c[g>>2]=cD[c[(c[D>>2]|0)+16>>2]&511](O)|0;cB[c[(c[L>>2]|0)+20>>2]&1023](G,O);L=h;if((a[L]&1)==0){a[h+1|0]=0;a[L]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}z=0;as(620,h|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[L>>2]=c[H>>2];c[L+4>>2]=c[H+4>>2];c[L+8>>2]=c[H+8>>2];LI(H|0,0,12)|0;Eb(G);cB[c[(c[P>>2]|0)+24>>2]&1023](I,O);P=j;if((a[P]&1)==0){c[j+4>>2]=0;a[P]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}z=0;as(510,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[P>>2]=c[J>>2];c[P+4>>2]=c[J+4>>2];c[P+8>>2]=c[J+8>>2];LI(J|0,0,12)|0;Eo(I);N=cD[c[(c[D>>2]|0)+36>>2]&511](O)|0;c[m>>2]=N;i=n;return}}function Iw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;f=(c[e>>2]|0)!=556;g=a|0;a=c[g>>2]|0;h=a;i=(c[d>>2]|0)-h|0;j=i>>>0<2147483647>>>0?i<<1:-1;i=(c[b>>2]|0)-h>>2;if(f){k=a}else{k=0}a=Lr(k,j)|0;k=a;if((a|0)==0){LB()}do{if(f){c[g>>2]=k;l=k}else{a=c[g>>2]|0;c[g>>2]=k;if((a|0)==0){l=k;break}z=0;ar(c[e>>2]|0,a|0);if(!z){l=c[g>>2]|0;break}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);c[e>>2]=512;c[b>>2]=l+(i<<2);c[d>>2]=(c[g>>2]|0)+(j>>>2<<2);return}function Ix(a){a=a|0;DJ(a|0);Lw(a);return}function Iy(a){a=a|0;DJ(a|0);return}function Iz(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0;e=i;i=i+280|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=e|0;n=e+120|0;o=e+232|0;p=e+240|0;q=e+248|0;r=e+256|0;s=e+264|0;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;x=w;y=i;i=i+4|0;i=i+7&-8;A=i;i=i+100|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=e+16|0;c[n>>2]=E;F=e+128|0;G=bk(E|0,100,10488,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;L1:do{if(G>>>0>99>>>0){do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}H=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=H;break}else{z=0;H=bT(-1,-1)|0;I=M;J=H;K=0;L=0;N=12;break L1}}}while(0);H=(z=0,aU(28,n|0,c[10082]|0,10488,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0);i=E;if(z){z=0;O=0;P=0;N=11;break}Q=c[n>>2]|0;if((Q|0)==0){z=0;aS(4);if(z){z=0;O=0;P=0;N=11;break}R=c[n>>2]|0}else{R=Q}Q=Lo(H)|0;if((Q|0)!=0){S=Q;T=H;U=R;V=Q;N=15;break}z=0;aS(4);if(!z){S=0;T=H;U=R;V=0;N=15}else{z=0;O=R;P=0;N=11}}else{S=F;T=G;U=0;V=0;N=15}}while(0);do{if((N|0)==15){z=0;as(352,o|0,j|0);if(z){z=0;O=U;P=V;N=11;break}G=o|0;F=c[G>>2]|0;if((c[10440]|0)==-1){N=18}else{c[m>>2]=41760;c[m+4>>2]=460;c[m+8>>2]=0;z=0;aR(2,41760,m|0,520);if(!z){N=18}else{z=0;N=45}}L21:do{if((N|0)==18){R=(c[10441]|0)-1|0;E=c[F+8>>2]|0;do{if((c[F+12>>2]|0)-E>>2>>>0>R>>>0){H=c[E+(R<<2)>>2]|0;if((H|0)==0){break}Q=H;W=c[n>>2]|0;X=W+T|0;Y=c[(c[H>>2]|0)+32>>2]|0;z=0,aU(Y|0,Q|0,W|0,X|0,S|0)|0;if(z){z=0;N=45;break L21}if((T|0)==0){Z=0}else{Z=(a[c[n>>2]|0]|0)==45}LI(t|0,0,12)|0;LI(v|0,0,12)|0;LI(x|0,0,12)|0;z=0;aL(10,g|0,Z|0,o|0,p|0,q|0,r|0,s|0,u|0,w|0,y|0);L30:do{if(!z){X=A|0;W=c[y>>2]|0;if((T|0)>(W|0)){Y=d[x]|0;if((Y&1|0)==0){_=Y>>>1}else{_=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){$=Y>>>1}else{$=c[u+4>>2]|0}aa=(T-W<<1|1)+_+$|0}else{Y=d[x]|0;if((Y&1|0)==0){ab=Y>>>1}else{ab=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){ac=Y>>>1}else{ac=c[u+4>>2]|0}aa=ab+2+ac|0}Y=aa+W|0;do{if(Y>>>0>100>>>0){H=Lo(Y)|0;if((H|0)!=0){ad=H;ae=H;break}z=0;aS(4);if(!z){ad=0;ae=0;break}else{z=0}H=bT(-1,-1)|0;af=M;ag=H;break L30}else{ad=X;ae=0}}while(0);z=0;aA(2,ad|0,B|0,C|0,c[j+4>>2]|0,S|0,S+T|0,Q|0,Z|0,p|0,a[q]|0,a[r]|0,s|0,u|0,w|0,W|0);do{if(!z){c[D>>2]=c[f>>2];z=0;aI(56,b|0,D|0,ad|0,c[B>>2]|0,c[C>>2]|0,j|0,k|0);if(z){z=0;break}if((ae|0)!=0){Lp(ae)}Eb(w);Eb(u);Eb(s);DL(c[G>>2]|0)|0;if((V|0)!=0){Lp(V)}if((U|0)==0){i=e;return}Lp(U);i=e;return}else{z=0}}while(0);W=bT(-1,-1)|0;X=W;W=M;if((ae|0)==0){af=W;ag=X;break}Lp(ae);af=W;ag=X}else{z=0;X=bT(-1,-1)|0;af=M;ag=X}}while(0);Eb(w);Eb(u);Eb(s);ah=af;ai=ag;break L21}}while(0);R=cl(4)|0;K$(R);z=0;aR(156,R|0,29336,98);if(z){z=0;N=45;break}}}while(0);if((N|0)==45){F=bT(-1,-1)|0;ah=M;ai=F}DL(c[G>>2]|0)|0;aj=ah;ak=ai;al=U;am=V}}while(0);if((N|0)==11){V=bT(-1,-1)|0;I=M;J=V;K=O;L=P;N=12}if((N|0)==12){aj=I;ak=J;al=K;am=L}if((am|0)!=0){Lp(am)}if((al|0)==0){an=ak;ao=0;ap=an;aq=aj;bg(ap|0)}Lp(al);an=ak;ao=0;ap=an;aq=aj;bg(ap|0)}function IA(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;n=i;i=i+40|0;o=n|0;p=n+16|0;q=n+32|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+4|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;x=w;y=i;i=i+12|0;i=i+7&-8;A=y;B=i;i=i+12|0;i=i+7&-8;C=B;D=i;i=i+4|0;i=i+7&-8;F=D;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+4|0;i=i+7&-8;J=I;K=i;i=i+12|0;i=i+7&-8;L=K;M=i;i=i+12|0;i=i+7&-8;N=M;O=i;i=i+12|0;i=i+7&-8;P=O;Q=c[e>>2]|0;if(b){if((c[10558]|0)!=-1){c[p>>2]=42232;c[p+4>>2]=460;c[p+8>>2]=0;D4(42232,p,520)}p=(c[10559]|0)-1|0;b=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-b>>2>>>0<=p>>>0){R=cl(4)|0;S=R;K$(S);bK(R|0,29336,98)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){R=cl(4)|0;S=R;K$(S);bK(R|0,29336,98)}R=e;S=c[e>>2]|0;do{if(d){cB[c[S+44>>2]&1023](r,R);p=f;E=c[q>>2]|0;a[p]=E;E=E>>8;a[p+1|0]=E;E=E>>8;a[p+2|0]=E;E=E>>8;a[p+3|0]=E;cB[c[(c[e>>2]|0)+32>>2]&1023](s,R);p=l;if((a[p]&1)==0){a[l+1|0]=0;a[p]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}z=0;as(620,l|0,0);if(!z){c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];LI(t|0,0,12)|0;Eb(s);break}else{z=0;bT(-1,-1,0)|0;bX()}}else{cB[c[S+40>>2]&1023](v,R);p=f;E=c[u>>2]|0;a[p]=E;E=E>>8;a[p+1|0]=E;E=E>>8;a[p+2|0]=E;E=E>>8;a[p+3|0]=E;cB[c[(c[e>>2]|0)+28>>2]&1023](w,R);p=l;if((a[p]&1)==0){a[l+1|0]=0;a[p]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}z=0;as(620,l|0,0);if(!z){c[p>>2]=c[x>>2];c[p+4>>2]=c[x+4>>2];c[p+8>>2]=c[x+8>>2];LI(x|0,0,12)|0;Eb(w);break}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);w=e;a[g]=cD[c[(c[w>>2]|0)+12>>2]&511](R)|0;a[h]=cD[c[(c[w>>2]|0)+16>>2]&511](R)|0;w=e;cB[c[(c[w>>2]|0)+20>>2]&1023](y,R);x=j;if((a[x]&1)==0){a[j+1|0]=0;a[x]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}z=0;as(620,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[x>>2]=c[A>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];LI(A|0,0,12)|0;Eb(y);cB[c[(c[w>>2]|0)+24>>2]&1023](B,R);w=k;if((a[w]&1)==0){a[k+1|0]=0;a[w]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}z=0;as(620,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[w>>2]=c[C>>2];c[w+4>>2]=c[C+4>>2];c[w+8>>2]=c[C+8>>2];LI(C|0,0,12)|0;Eb(B);T=cD[c[(c[e>>2]|0)+36>>2]&511](R)|0;c[m>>2]=T;i=n;return}else{if((c[10560]|0)!=-1){c[o>>2]=42240;c[o+4>>2]=460;c[o+8>>2]=0;D4(42240,o,520)}o=(c[10561]|0)-1|0;R=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-R>>2>>>0<=o>>>0){U=cl(4)|0;V=U;K$(V);bK(U|0,29336,98)}Q=c[R+(o<<2)>>2]|0;if((Q|0)==0){U=cl(4)|0;V=U;K$(V);bK(U|0,29336,98)}U=Q;V=c[Q>>2]|0;do{if(d){cB[c[V+44>>2]&1023](F,U);o=f;E=c[D>>2]|0;a[o]=E;E=E>>8;a[o+1|0]=E;E=E>>8;a[o+2|0]=E;E=E>>8;a[o+3|0]=E;cB[c[(c[Q>>2]|0)+32>>2]&1023](G,U);o=l;if((a[o]&1)==0){a[l+1|0]=0;a[o]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}z=0;as(620,l|0,0);if(!z){c[o>>2]=c[H>>2];c[o+4>>2]=c[H+4>>2];c[o+8>>2]=c[H+8>>2];LI(H|0,0,12)|0;Eb(G);break}else{z=0;bT(-1,-1,0)|0;bX()}}else{cB[c[V+40>>2]&1023](J,U);o=f;E=c[I>>2]|0;a[o]=E;E=E>>8;a[o+1|0]=E;E=E>>8;a[o+2|0]=E;E=E>>8;a[o+3|0]=E;cB[c[(c[Q>>2]|0)+28>>2]&1023](K,U);o=l;if((a[o]&1)==0){a[l+1|0]=0;a[o]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}z=0;as(620,l|0,0);if(!z){c[o>>2]=c[L>>2];c[o+4>>2]=c[L+4>>2];c[o+8>>2]=c[L+8>>2];LI(L|0,0,12)|0;Eb(K);break}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);K=Q;a[g]=cD[c[(c[K>>2]|0)+12>>2]&511](U)|0;a[h]=cD[c[(c[K>>2]|0)+16>>2]&511](U)|0;K=Q;cB[c[(c[K>>2]|0)+20>>2]&1023](M,U);h=j;if((a[h]&1)==0){a[j+1|0]=0;a[h]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}z=0;as(620,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[h>>2]=c[N>>2];c[h+4>>2]=c[N+4>>2];c[h+8>>2]=c[N+8>>2];LI(N|0,0,12)|0;Eb(M);cB[c[(c[K>>2]|0)+24>>2]&1023](O,U);K=k;if((a[K]&1)==0){a[k+1|0]=0;a[K]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}z=0;as(620,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[K>>2]=c[P>>2];c[K+4>>2]=c[P+4>>2];c[K+8>>2]=c[P+8>>2];LI(P|0,0,12)|0;Eb(O);T=cD[c[(c[Q>>2]|0)+36>>2]&511](U)|0;c[m>>2]=T;i=n;return}}function IB(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0;c[f>>2]=d;s=j;t=q;u=q+1|0;v=q+8|0;w=q+4|0;q=p;x=(g&512|0)==0;y=p+1|0;z=p+4|0;A=p+8|0;p=j+8|0;B=(r|0)>0;C=o;D=o+1|0;E=o+8|0;F=o+4|0;o=-r|0;G=h;h=0;while(1){L3:do{switch(a[l+h|0]|0){case 2:{H=a[q]|0;I=H&255;J=(I&1|0)==0;if(J){K=I>>>1}else{K=c[z>>2]|0}if((K|0)==0|x){L=G;break L3}if((H&1)==0){M=y;N=y}else{H=c[A>>2]|0;M=H;N=H}if(J){O=I>>>1}else{O=c[z>>2]|0}I=M+O|0;J=c[f>>2]|0;if((N|0)==(I|0)){P=J}else{H=N;Q=J;while(1){a[Q]=a[H]|0;J=H+1|0;R=Q+1|0;if((J|0)==(I|0)){P=R;break}else{H=J;Q=R}}}c[f>>2]=P;L=G;break};case 0:{c[e>>2]=c[f>>2];L=G;break};case 1:{c[e>>2]=c[f>>2];Q=cV[c[(c[s>>2]|0)+28>>2]&1023](j,32)|0;H=c[f>>2]|0;c[f>>2]=H+1;a[H]=Q;L=G;break};case 3:{Q=a[t]|0;H=Q&255;if((H&1|0)==0){S=H>>>1}else{S=c[w>>2]|0}if((S|0)==0){L=G;break L3}if((Q&1)==0){T=u}else{T=c[v>>2]|0}Q=a[T]|0;H=c[f>>2]|0;c[f>>2]=H+1;a[H]=Q;L=G;break};case 4:{Q=c[f>>2]|0;H=k?G+1|0:G;I=H;while(1){if(I>>>0>=i>>>0){break}R=a[I]|0;if(R<<24>>24<0){break}if((b[(c[p>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){break}else{I=I+1|0}}R=I;if(B){if(I>>>0>H>>>0){J=H+(-R|0)|0;R=J>>>0<o>>>0?o:J;J=R+r|0;U=I;V=r;W=Q;while(1){X=U-1|0;Y=a[X]|0;c[f>>2]=W+1;a[W]=Y;Y=V-1|0;Z=(Y|0)>0;if(!(X>>>0>H>>>0&Z)){break}U=X;V=Y;W=c[f>>2]|0}W=I+R|0;if(Z){_=J;$=W;aa=34}else{ab=0;ac=J;ad=W}}else{_=r;$=I;aa=34}if((aa|0)==34){aa=0;ab=cV[c[(c[s>>2]|0)+28>>2]&1023](j,48)|0;ac=_;ad=$}W=c[f>>2]|0;c[f>>2]=W+1;if((ac|0)>0){V=ac;U=W;while(1){a[U]=ab;Y=V-1|0;X=c[f>>2]|0;c[f>>2]=X+1;if((Y|0)>0){V=Y;U=X}else{ae=X;break}}}else{ae=W}a[ae]=m;af=ad}else{af=I}if((af|0)==(H|0)){U=cV[c[(c[s>>2]|0)+28>>2]&1023](j,48)|0;V=c[f>>2]|0;c[f>>2]=V+1;a[V]=U}else{U=a[C]|0;V=U&255;if((V&1|0)==0){ag=V>>>1}else{ag=c[F>>2]|0}if((ag|0)==0){ah=af;ai=0;aj=0;ak=-1}else{if((U&1)==0){al=D}else{al=c[E>>2]|0}ah=af;ai=0;aj=0;ak=a[al]|0}while(1){do{if((ai|0)==(ak|0)){U=c[f>>2]|0;c[f>>2]=U+1;a[U]=n;U=aj+1|0;V=a[C]|0;J=V&255;if((J&1|0)==0){am=J>>>1}else{am=c[F>>2]|0}if(U>>>0>=am>>>0){an=ak;ao=U;ap=0;break}J=(V&1)==0;if(J){aq=D}else{aq=c[E>>2]|0}if((a[aq+U|0]|0)==127){an=-1;ao=U;ap=0;break}if(J){ar=D}else{ar=c[E>>2]|0}an=a[ar+U|0]|0;ao=U;ap=0}else{an=ak;ao=aj;ap=ai}}while(0);U=ah-1|0;J=a[U]|0;V=c[f>>2]|0;c[f>>2]=V+1;a[V]=J;if((U|0)==(H|0)){break}else{ah=U;ai=ap+1|0;aj=ao;ak=an}}}I=c[f>>2]|0;if((Q|0)==(I|0)){L=H;break L3}W=I-1|0;if(Q>>>0<W>>>0){as=Q;at=W}else{L=H;break L3}while(1){W=a[as]|0;a[as]=a[at]|0;a[at]=W;W=as+1|0;I=at-1|0;if(W>>>0<I>>>0){as=W;at=I}else{L=H;break}}break};default:{L=G}}}while(0);H=h+1|0;if(H>>>0<4>>>0){G=L;h=H}else{break}}h=a[t]|0;t=h&255;L=(t&1|0)==0;if(L){au=t>>>1}else{au=c[w>>2]|0}if(au>>>0>1>>>0){if((h&1)==0){av=u;aw=u}else{u=c[v>>2]|0;av=u;aw=u}if(L){ax=t>>>1}else{ax=c[w>>2]|0}w=av+ax|0;ax=c[f>>2]|0;av=aw+1|0;if((av|0)==(w|0)){ay=ax}else{aw=ax;ax=av;while(1){a[aw]=a[ax]|0;av=aw+1|0;t=ax+1|0;if((t|0)==(w|0)){ay=av;break}else{aw=av;ax=t}}}c[f>>2]=ay}ay=g&176;if((ay|0)==16){return}else if((ay|0)==32){c[e>>2]=c[f>>2];return}else{c[e>>2]=d;return}}function IC(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0;e=i;i=i+64|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+24|0;o=e+32|0;p=e+40|0;q=e+48|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+4|0;i=i+7&-8;x=i;i=i+100|0;i=i+7&-8;y=i;i=i+4|0;i=i+7&-8;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;Ey(m,h);C=m|0;D=c[C>>2]|0;if((c[10440]|0)==-1){E=3}else{c[l>>2]=41760;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41760,l|0,520);if(!z){E=3}else{z=0}}L3:do{if((E|0)==3){l=(c[10441]|0)-1|0;F=c[D+8>>2]|0;do{if((c[D+12>>2]|0)-F>>2>>>0>l>>>0){G=c[F+(l<<2)>>2]|0;if((G|0)==0){break}H=G;I=k;J=k;K=a[J]|0;L=K&255;if((L&1|0)==0){N=L>>>1}else{N=c[k+4>>2]|0}if((N|0)==0){O=0}else{if((K&1)==0){P=I+1|0}else{P=c[k+8>>2]|0}K=a[P]|0;L=(z=0,aM(c[(c[G>>2]|0)+28>>2]|0,H|0,45)|0);if(z){z=0;break L3}O=K<<24>>24==L<<24>>24}LI(r|0,0,12)|0;LI(t|0,0,12)|0;LI(v|0,0,12)|0;z=0;aL(10,g|0,O|0,m|0,n|0,o|0,p|0,q|0,s|0,u|0,w|0);L20:do{if(!z){L=x|0;K=a[J]|0;G=K&255;Q=(G&1|0)==0;if(Q){R=G>>>1}else{R=c[k+4>>2]|0}S=c[w>>2]|0;if((R|0)>(S|0)){if(Q){T=G>>>1}else{T=c[k+4>>2]|0}G=d[v]|0;if((G&1|0)==0){U=G>>>1}else{U=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){V=G>>>1}else{V=c[s+4>>2]|0}W=(T-S<<1|1)+U+V|0}else{G=d[v]|0;if((G&1|0)==0){X=G>>>1}else{X=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){Y=G>>>1}else{Y=c[s+4>>2]|0}W=X+2+Y|0}G=W+S|0;do{if(G>>>0>100>>>0){Q=Lo(G)|0;if((Q|0)!=0){Z=Q;_=Q;$=K;break}z=0;aS(4);if(!z){Z=0;_=0;$=a[J]|0;break}else{z=0;Q=bT(-1,-1)|0;aa=M;ab=Q;break L20}}else{Z=L;_=0;$=K}}while(0);if(($&1)==0){ac=I+1|0;ad=I+1|0}else{K=c[k+8>>2]|0;ac=K;ad=K}K=$&255;if((K&1|0)==0){ae=K>>>1}else{ae=c[k+4>>2]|0}z=0;aA(2,Z|0,y|0,A|0,c[h+4>>2]|0,ad|0,ac+ae|0,H|0,O|0,n|0,a[o]|0,a[p]|0,q|0,s|0,u|0,S|0);do{if(!z){c[B>>2]=c[f>>2];z=0;aI(56,b|0,B|0,Z|0,c[y>>2]|0,c[A>>2]|0,h|0,j|0);if(z){z=0;break}if((_|0)==0){Eb(u);Eb(s);Eb(q);af=c[C>>2]|0;ag=af|0;ah=DL(ag)|0;i=e;return}Lp(_);Eb(u);Eb(s);Eb(q);af=c[C>>2]|0;ag=af|0;ah=DL(ag)|0;i=e;return}else{z=0}}while(0);S=bT(-1,-1)|0;K=S;S=M;if((_|0)==0){aa=S;ab=K;break}Lp(_);aa=S;ab=K}else{z=0;K=bT(-1,-1)|0;aa=M;ab=K}}while(0);Eb(u);Eb(s);Eb(q);ai=aa;aj=ab;ak=c[C>>2]|0;al=ak|0;am=DL(al)|0;an=aj;ao=0;ap=an;aq=ai;bg(ap|0)}}while(0);l=cl(4)|0;K$(l);z=0;aR(156,l|0,29336,98);if(z){z=0;break}}}while(0);ab=bT(-1,-1)|0;ai=M;aj=ab;ak=c[C>>2]|0;al=ak|0;am=DL(al)|0;an=aj;ao=0;ap=an;aq=ai;bg(ap|0)}function ID(a){a=a|0;DJ(a|0);Lw(a);return}function IE(a){a=a|0;DJ(a|0);return}function IF(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,at=0;e=i;i=i+576|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=e|0;n=e+120|0;o=e+528|0;p=e+536|0;q=e+544|0;r=e+552|0;s=e+560|0;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;x=w;y=i;i=i+4|0;i=i+7&-8;A=i;i=i+400|0;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=e+16|0;c[n>>2]=E;F=e+128|0;G=bk(E|0,100,10488,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;L1:do{if(G>>>0>99>>>0){do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}H=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=H;break}else{z=0;H=bT(-1,-1)|0;I=M;J=H;K=0;L=0;N=12;break L1}}}while(0);H=(z=0,aU(28,n|0,c[10082]|0,10488,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0);i=E;if(z){z=0;O=0;P=0;N=11;break}Q=c[n>>2]|0;if((Q|0)==0){z=0;aS(4);if(z){z=0;O=0;P=0;N=11;break}R=c[n>>2]|0}else{R=Q}Q=Lo(H<<2)|0;S=Q;if((Q|0)!=0){T=S;U=H;V=R;W=S;N=15;break}z=0;aS(4);if(!z){T=S;U=H;V=R;W=S;N=15}else{z=0;O=R;P=S;N=11}}else{T=F;U=G;V=0;W=0;N=15}}while(0);do{if((N|0)==15){z=0;as(352,o|0,j|0);if(z){z=0;O=V;P=W;N=11;break}G=o|0;F=c[G>>2]|0;if((c[10438]|0)==-1){N=18}else{c[m>>2]=41752;c[m+4>>2]=460;c[m+8>>2]=0;z=0;aR(2,41752,m|0,520);if(!z){N=18}else{z=0;N=44}}L21:do{if((N|0)==18){R=(c[10439]|0)-1|0;E=c[F+8>>2]|0;do{if((c[F+12>>2]|0)-E>>2>>>0>R>>>0){S=c[E+(R<<2)>>2]|0;if((S|0)==0){break}H=S;Q=c[n>>2]|0;X=Q+U|0;Y=c[(c[S>>2]|0)+48>>2]|0;z=0,aU(Y|0,H|0,Q|0,X|0,T|0)|0;if(z){z=0;N=44;break L21}if((U|0)==0){Z=0}else{Z=(a[c[n>>2]|0]|0)==45}LI(t|0,0,12)|0;LI(v|0,0,12)|0;LI(x|0,0,12)|0;z=0;aL(2,g|0,Z|0,o|0,p|0,q|0,r|0,s|0,u|0,w|0,y|0);do{if(!z){X=A|0;Q=c[y>>2]|0;if((U|0)>(Q|0)){Y=d[x]|0;if((Y&1|0)==0){_=Y>>>1}else{_=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){$=Y>>>1}else{$=c[u+4>>2]|0}aa=(U-Q<<1|1)+_+$|0}else{Y=d[x]|0;if((Y&1|0)==0){ab=Y>>>1}else{ab=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){ac=Y>>>1}else{ac=c[u+4>>2]|0}aa=ab+2+ac|0}Y=aa+Q|0;do{if(Y>>>0>100>>>0){S=Lo(Y<<2)|0;ad=S;if((S|0)!=0){ae=ad;af=ad;N=48;break}z=0;aS(4);if(!z){ae=ad;af=ad;N=48}else{z=0;ag=ad}}else{ae=X;af=0;N=48}}while(0);do{if((N|0)==48){z=0;aA(4,ae|0,B|0,C|0,c[j+4>>2]|0,T|0,T+(U<<2)|0,H|0,Z|0,p|0,c[q>>2]|0,c[r>>2]|0,s|0,u|0,w|0,Q|0);if(z){z=0;ag=af;break}c[D>>2]=c[f>>2];z=0;aI(52,b|0,D|0,ae|0,c[B>>2]|0,c[C>>2]|0,j|0,k|0);if(z){z=0;ag=af;break}if((af|0)!=0){Lp(af)}Eo(w);Eo(u);Eb(s);DL(c[G>>2]|0)|0;if((W|0)!=0){Lp(W)}if((V|0)==0){i=e;return}Lp(V);i=e;return}}while(0);Q=bT(-1,-1)|0;X=Q;Q=M;if((ag|0)==0){ah=Q;ai=X;break}Lp(ag);ah=Q;ai=X}else{z=0;X=bT(-1,-1)|0;ah=M;ai=X}}while(0);Eo(w);Eo(u);Eb(s);aj=ah;ak=ai;break L21}}while(0);R=cl(4)|0;K$(R);z=0;aR(156,R|0,29336,98);if(z){z=0;N=44;break}}}while(0);if((N|0)==44){F=bT(-1,-1)|0;aj=M;ak=F}DL(c[G>>2]|0)|0;al=aj;am=ak;an=V;ao=W}}while(0);if((N|0)==11){W=bT(-1,-1)|0;I=M;J=W;K=O;L=P;N=12}if((N|0)==12){al=I;am=J;an=K;ao=L}if((ao|0)!=0){Lp(ao)}if((an|0)==0){ap=am;aq=0;ar=ap;at=al;bg(ar|0)}Lp(an);ap=am;aq=0;ar=ap;at=al;bg(ar|0)}function IG(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;n=i;i=i+40|0;o=n|0;p=n+16|0;q=n+32|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+4|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;x=w;y=i;i=i+12|0;i=i+7&-8;A=y;B=i;i=i+12|0;i=i+7&-8;C=B;D=i;i=i+4|0;i=i+7&-8;F=D;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+4|0;i=i+7&-8;J=I;K=i;i=i+12|0;i=i+7&-8;L=K;M=i;i=i+12|0;i=i+7&-8;N=M;O=i;i=i+12|0;i=i+7&-8;P=O;Q=c[e>>2]|0;if(b){if((c[10554]|0)!=-1){c[p>>2]=42216;c[p+4>>2]=460;c[p+8>>2]=0;D4(42216,p,520)}p=(c[10555]|0)-1|0;b=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-b>>2>>>0<=p>>>0){R=cl(4)|0;S=R;K$(S);bK(R|0,29336,98)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){R=cl(4)|0;S=R;K$(S);bK(R|0,29336,98)}R=e;S=c[e>>2]|0;do{if(d){cB[c[S+44>>2]&1023](r,R);p=f;E=c[q>>2]|0;a[p]=E;E=E>>8;a[p+1|0]=E;E=E>>8;a[p+2|0]=E;E=E>>8;a[p+3|0]=E;cB[c[(c[e>>2]|0)+32>>2]&1023](s,R);p=l;if((a[p]&1)==0){c[l+4>>2]=0;a[p]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}z=0;as(510,l|0,0);if(!z){c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];LI(t|0,0,12)|0;Eo(s);break}else{z=0;bT(-1,-1,0)|0;bX()}}else{cB[c[S+40>>2]&1023](v,R);p=f;E=c[u>>2]|0;a[p]=E;E=E>>8;a[p+1|0]=E;E=E>>8;a[p+2|0]=E;E=E>>8;a[p+3|0]=E;cB[c[(c[e>>2]|0)+28>>2]&1023](w,R);p=l;if((a[p]&1)==0){c[l+4>>2]=0;a[p]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}z=0;as(510,l|0,0);if(!z){c[p>>2]=c[x>>2];c[p+4>>2]=c[x+4>>2];c[p+8>>2]=c[x+8>>2];LI(x|0,0,12)|0;Eo(w);break}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);w=e;c[g>>2]=cD[c[(c[w>>2]|0)+12>>2]&511](R)|0;c[h>>2]=cD[c[(c[w>>2]|0)+16>>2]&511](R)|0;cB[c[(c[e>>2]|0)+20>>2]&1023](y,R);x=j;if((a[x]&1)==0){a[j+1|0]=0;a[x]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}z=0;as(620,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[x>>2]=c[A>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];LI(A|0,0,12)|0;Eb(y);cB[c[(c[e>>2]|0)+24>>2]&1023](B,R);e=k;if((a[e]&1)==0){c[k+4>>2]=0;a[e]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}z=0;as(510,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[e>>2]=c[C>>2];c[e+4>>2]=c[C+4>>2];c[e+8>>2]=c[C+8>>2];LI(C|0,0,12)|0;Eo(B);T=cD[c[(c[w>>2]|0)+36>>2]&511](R)|0;c[m>>2]=T;i=n;return}else{if((c[10556]|0)!=-1){c[o>>2]=42224;c[o+4>>2]=460;c[o+8>>2]=0;D4(42224,o,520)}o=(c[10557]|0)-1|0;R=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-R>>2>>>0<=o>>>0){U=cl(4)|0;V=U;K$(V);bK(U|0,29336,98)}Q=c[R+(o<<2)>>2]|0;if((Q|0)==0){U=cl(4)|0;V=U;K$(V);bK(U|0,29336,98)}U=Q;V=c[Q>>2]|0;do{if(d){cB[c[V+44>>2]&1023](F,U);o=f;E=c[D>>2]|0;a[o]=E;E=E>>8;a[o+1|0]=E;E=E>>8;a[o+2|0]=E;E=E>>8;a[o+3|0]=E;cB[c[(c[Q>>2]|0)+32>>2]&1023](G,U);o=l;if((a[o]&1)==0){c[l+4>>2]=0;a[o]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}z=0;as(510,l|0,0);if(!z){c[o>>2]=c[H>>2];c[o+4>>2]=c[H+4>>2];c[o+8>>2]=c[H+8>>2];LI(H|0,0,12)|0;Eo(G);break}else{z=0;bT(-1,-1,0)|0;bX()}}else{cB[c[V+40>>2]&1023](J,U);o=f;E=c[I>>2]|0;a[o]=E;E=E>>8;a[o+1|0]=E;E=E>>8;a[o+2|0]=E;E=E>>8;a[o+3|0]=E;cB[c[(c[Q>>2]|0)+28>>2]&1023](K,U);o=l;if((a[o]&1)==0){c[l+4>>2]=0;a[o]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}z=0;as(510,l|0,0);if(!z){c[o>>2]=c[L>>2];c[o+4>>2]=c[L+4>>2];c[o+8>>2]=c[L+8>>2];LI(L|0,0,12)|0;Eo(K);break}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);K=Q;c[g>>2]=cD[c[(c[K>>2]|0)+12>>2]&511](U)|0;c[h>>2]=cD[c[(c[K>>2]|0)+16>>2]&511](U)|0;cB[c[(c[Q>>2]|0)+20>>2]&1023](M,U);h=j;if((a[h]&1)==0){a[j+1|0]=0;a[h]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}z=0;as(620,j|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[h>>2]=c[N>>2];c[h+4>>2]=c[N+4>>2];c[h+8>>2]=c[N+8>>2];LI(N|0,0,12)|0;Eb(M);cB[c[(c[Q>>2]|0)+24>>2]&1023](O,U);Q=k;if((a[Q]&1)==0){c[k+4>>2]=0;a[Q]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}z=0;as(510,k|0,0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[Q>>2]=c[P>>2];c[Q+4>>2]=c[P+4>>2];c[Q+8>>2]=c[P+8>>2];LI(P|0,0,12)|0;Eo(O);T=cD[c[(c[K>>2]|0)+36>>2]&511](U)|0;c[m>>2]=T;i=n;return}}function IH(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0;c[e>>2]=b;r=i;s=p;t=p+4|0;u=p+8|0;p=o;v=(f&512|0)==0;w=o+4|0;x=o+8|0;o=i;y=(q|0)>0;z=n;A=n+1|0;B=n+8|0;C=n+4|0;n=g;g=0;while(1){L3:do{switch(a[k+g|0]|0){case 2:{D=a[p]|0;E=D&255;F=(E&1|0)==0;if(F){G=E>>>1}else{G=c[w>>2]|0}if((G|0)==0|v){H=n;break L3}if((D&1)==0){I=w;J=w;K=w}else{D=c[x>>2]|0;I=D;J=D;K=D}if(F){L=E>>>1}else{L=c[w>>2]|0}E=I+(L<<2)|0;F=c[e>>2]|0;if((J|0)==(E|0)){M=F}else{D=(I+(L-1<<2)+(-K|0)|0)>>>2;N=J;O=F;while(1){c[O>>2]=c[N>>2];P=N+4|0;if((P|0)==(E|0)){break}N=P;O=O+4|0}M=F+(D+1<<2)|0}c[e>>2]=M;H=n;break};case 1:{c[d>>2]=c[e>>2];O=cV[c[(c[r>>2]|0)+44>>2]&1023](i,32)|0;N=c[e>>2]|0;c[e>>2]=N+4;c[N>>2]=O;H=n;break};case 0:{c[d>>2]=c[e>>2];H=n;break};case 3:{O=a[s]|0;N=O&255;if((N&1|0)==0){Q=N>>>1}else{Q=c[t>>2]|0}if((Q|0)==0){H=n;break L3}if((O&1)==0){R=t}else{R=c[u>>2]|0}O=c[R>>2]|0;N=c[e>>2]|0;c[e>>2]=N+4;c[N>>2]=O;H=n;break};case 4:{O=c[e>>2]|0;N=j?n+4|0:n;E=N;while(1){if(E>>>0>=h>>>0){break}if(cI[c[(c[o>>2]|0)+12>>2]&127](i,2048,c[E>>2]|0)|0){E=E+4|0}else{break}}if(y){if(E>>>0>N>>>0){D=E;F=q;do{D=D-4|0;P=c[D>>2]|0;S=c[e>>2]|0;c[e>>2]=S+4;c[S>>2]=P;F=F-1|0;T=(F|0)>0;}while(D>>>0>N>>>0&T);if(T){U=F;V=D;W=35}else{X=0;Y=F;Z=D}}else{U=q;V=E;W=35}if((W|0)==35){W=0;X=cV[c[(c[r>>2]|0)+44>>2]&1023](i,48)|0;Y=U;Z=V}P=c[e>>2]|0;c[e>>2]=P+4;if((Y|0)>0){S=Y;_=P;while(1){c[_>>2]=X;$=S-1|0;aa=c[e>>2]|0;c[e>>2]=aa+4;if(($|0)>0){S=$;_=aa}else{ab=aa;break}}}else{ab=P}c[ab>>2]=l;ac=Z}else{ac=E}if((ac|0)==(N|0)){_=cV[c[(c[r>>2]|0)+44>>2]&1023](i,48)|0;S=c[e>>2]|0;c[e>>2]=S+4;c[S>>2]=_}else{_=a[z]|0;S=_&255;if((S&1|0)==0){ad=S>>>1}else{ad=c[C>>2]|0}if((ad|0)==0){ae=ac;af=0;ag=0;ah=-1}else{if((_&1)==0){ai=A}else{ai=c[B>>2]|0}ae=ac;af=0;ag=0;ah=a[ai]|0}while(1){do{if((af|0)==(ah|0)){_=c[e>>2]|0;c[e>>2]=_+4;c[_>>2]=m;_=ag+1|0;S=a[z]|0;D=S&255;if((D&1|0)==0){aj=D>>>1}else{aj=c[C>>2]|0}if(_>>>0>=aj>>>0){ak=ah;al=_;am=0;break}D=(S&1)==0;if(D){an=A}else{an=c[B>>2]|0}if((a[an+_|0]|0)==127){ak=-1;al=_;am=0;break}if(D){ao=A}else{ao=c[B>>2]|0}ak=a[ao+_|0]|0;al=_;am=0}else{ak=ah;al=ag;am=af}}while(0);_=ae-4|0;D=c[_>>2]|0;S=c[e>>2]|0;c[e>>2]=S+4;c[S>>2]=D;if((_|0)==(N|0)){break}else{ae=_;af=am+1|0;ag=al;ah=ak}}}E=c[e>>2]|0;if((O|0)==(E|0)){H=N;break L3}P=E-4|0;if(O>>>0<P>>>0){ap=O;aq=P}else{H=N;break L3}while(1){P=c[ap>>2]|0;c[ap>>2]=c[aq>>2];c[aq>>2]=P;P=ap+4|0;E=aq-4|0;if(P>>>0<E>>>0){ap=P;aq=E}else{H=N;break}}break};default:{H=n}}}while(0);N=g+1|0;if(N>>>0<4>>>0){n=H;g=N}else{break}}g=a[s]|0;s=g&255;H=(s&1|0)==0;if(H){ar=s>>>1}else{ar=c[t>>2]|0}if(ar>>>0>1>>>0){if((g&1)==0){as=t;at=t;au=t}else{g=c[u>>2]|0;as=g;at=g;au=g}if(H){av=s>>>1}else{av=c[t>>2]|0}t=as+(av<<2)|0;s=c[e>>2]|0;H=at+4|0;if((H|0)==(t|0)){aw=s}else{at=((as+(av-2<<2)+(-au|0)|0)>>>2)+1|0;au=s;av=H;while(1){c[au>>2]=c[av>>2];H=av+4|0;if((H|0)==(t|0)){break}else{au=au+4|0;av=H}}aw=s+(at<<2)|0}c[e>>2]=aw}aw=f&176;if((aw|0)==16){return}else if((aw|0)==32){c[d>>2]=c[e>>2];return}else{c[d>>2]=b;return}}function II(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0;e=i;i=i+64|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+24|0;o=e+32|0;p=e+40|0;q=e+48|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+4|0;i=i+7&-8;x=i;i=i+400|0;y=i;i=i+4|0;i=i+7&-8;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;Ey(m,h);C=m|0;D=c[C>>2]|0;if((c[10438]|0)==-1){E=3}else{c[l>>2]=41752;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41752,l|0,520);if(!z){E=3}else{z=0}}L3:do{if((E|0)==3){l=(c[10439]|0)-1|0;F=c[D+8>>2]|0;do{if((c[D+12>>2]|0)-F>>2>>>0>l>>>0){G=c[F+(l<<2)>>2]|0;if((G|0)==0){break}H=G;I=k;J=a[I]|0;K=J&255;if((K&1|0)==0){L=K>>>1}else{L=c[k+4>>2]|0}if((L|0)==0){N=0}else{if((J&1)==0){O=k+4|0}else{O=c[k+8>>2]|0}J=c[O>>2]|0;K=(z=0,aM(c[(c[G>>2]|0)+44>>2]|0,H|0,45)|0);if(z){z=0;break L3}N=(J|0)==(K|0)}LI(r|0,0,12)|0;LI(t|0,0,12)|0;LI(v|0,0,12)|0;z=0;aL(2,g|0,N|0,m|0,n|0,o|0,p|0,q|0,s|0,u|0,w|0);do{if(!z){K=x|0;J=a[I]|0;G=J&255;P=(G&1|0)==0;if(P){Q=G>>>1}else{Q=c[k+4>>2]|0}R=c[w>>2]|0;if((Q|0)>(R|0)){if(P){S=G>>>1}else{S=c[k+4>>2]|0}G=d[v]|0;if((G&1|0)==0){T=G>>>1}else{T=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){U=G>>>1}else{U=c[s+4>>2]|0}V=(S-R<<1|1)+T+U|0}else{G=d[v]|0;if((G&1|0)==0){W=G>>>1}else{W=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){X=G>>>1}else{X=c[s+4>>2]|0}V=W+2+X|0}G=V+R|0;do{if(G>>>0>100>>>0){P=Lo(G<<2)|0;Y=P;if((P|0)!=0){Z=Y;_=Y;$=J;E=46;break}z=0;aS(4);if(z){z=0;aa=Y;break}Z=Y;_=Y;$=a[I]|0;E=46}else{Z=K;_=0;$=J;E=46}}while(0);do{if((E|0)==46){if(($&1)==0){ab=k+4|0;ac=k+4|0}else{J=c[k+8>>2]|0;ab=J;ac=J}J=$&255;if((J&1|0)==0){ad=J>>>1}else{ad=c[k+4>>2]|0}z=0;aA(4,Z|0,y|0,A|0,c[h+4>>2]|0,ac|0,ab+(ad<<2)|0,H|0,N|0,n|0,c[o>>2]|0,c[p>>2]|0,q|0,s|0,u|0,R|0);if(z){z=0;aa=_;break}c[B>>2]=c[f>>2];z=0;aI(52,b|0,B|0,Z|0,c[y>>2]|0,c[A>>2]|0,h|0,j|0);if(z){z=0;aa=_;break}if((_|0)==0){Eo(u);Eo(s);Eb(q);ae=c[C>>2]|0;af=ae|0;ag=DL(af)|0;i=e;return}Lp(_);Eo(u);Eo(s);Eb(q);ae=c[C>>2]|0;af=ae|0;ag=DL(af)|0;i=e;return}}while(0);R=bT(-1,-1)|0;J=R;R=M;if((aa|0)==0){ah=R;ai=J;break}Lp(aa);ah=R;ai=J}else{z=0;J=bT(-1,-1)|0;ah=M;ai=J}}while(0);Eo(u);Eo(s);Eb(q);aj=ah;ak=ai;al=c[C>>2]|0;am=al|0;an=DL(am)|0;ao=ak;ap=0;aq=ao;ar=aj;bg(aq|0)}}while(0);l=cl(4)|0;K$(l);z=0;aR(156,l|0,29336,98);if(z){z=0;break}}}while(0);ai=bT(-1,-1)|0;aj=M;ak=ai;al=c[C>>2]|0;am=al|0;an=DL(am)|0;ao=ak;ap=0;aq=ao;ar=aj;bg(aq|0)}function IJ(a){a=a|0;DJ(a|0);Lw(a);return}function IK(a){a=a|0;DJ(a|0);return}function IL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=cp(f|0,1)|0;return d>>>(((d|0)!=-1|0)>>>0)|0}function IM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+16|0;j=d|0;k=j;LI(k|0,0,12)|0;l=b;m=h;n=a[h]|0;if((n&1)==0){o=m+1|0;p=m+1|0}else{m=c[h+8>>2]|0;o=m;p=m}m=n&255;if((m&1|0)==0){q=m>>>1}else{q=c[h+4>>2]|0}h=o+q|0;do{if(p>>>0<h>>>0){q=p;do{z=0;as(590,j|0,a[q]|0);if(z){z=0;r=12;break}q=q+1|0;}while(q>>>0<h>>>0);if((r|0)==12){q=bT(-1,-1)|0;s=M;t=q;break}q=(e|0)==-1?-1:e<<1;if((a[k]&1)==0){u=q;r=16;break}v=c[j+8>>2]|0;w=q;r=17}else{u=(e|0)==-1?-1:e<<1;r=16}}while(0);if((r|0)==16){v=j+1|0;w=u;r=17}do{if((r|0)==17){u=(z=0,aU(34,w|0,f|0,g|0,v|0)|0);if(z){z=0;e=bT(-1,-1)|0;s=M;t=e;break}LI(l|0,0,12)|0;e=LJ(u|0)|0;k=u+e|0;if((e|0)>0){x=u}else{Eb(j);i=d;return}while(1){z=0;as(590,b|0,a[x]|0);if(z){z=0;break}u=x+1|0;if(u>>>0<k>>>0){x=u}else{r=25;break}}if((r|0)==25){Eb(j);i=d;return}k=bT(-1,-1)|0;u=M;Eb(b);y=u;A=k;Eb(j);B=A;C=0;D=B;E=y;bg(D|0)}}while(0);y=s;A=t;Eb(j);B=A;C=0;D=B;E=y;bg(D|0)}function IN(a,b){a=a|0;b=b|0;b1(((b|0)==-1?-1:b<<1)|0)|0;return}function IO(a){a=a|0;DJ(a|0);Lw(a);return}function IP(a){a=a|0;DJ(a|0);return}function IQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=cp(f|0,1)|0;return d>>>(((d|0)!=-1|0)>>>0)|0}function IR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+224|0;j=d|0;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=r;t=i;i=i+8|0;u=i;i=i+8|0;LI(s|0,0,12)|0;v=b;w=t|0;c[t+4>>2]=0;c[t>>2]=15568;x=a[h]|0;if((x&1)==0){y=h+4|0;A=h+4|0}else{B=c[h+8>>2]|0;y=B;A=B}B=x&255;if((B&1|0)==0){C=B>>>1}else{C=c[h+4>>2]|0}h=y+(C<<2)|0;L9:do{if(A>>>0<h>>>0){C=t;y=k|0;B=k+32|0;x=A;D=15568;L11:while(1){c[m>>2]=x;E=(z=0,aT(c[D+12>>2]|0,w|0,j|0,x|0,h|0,m|0,y|0,B|0,l|0)|0);if(z){z=0;F=24;break}G=c[m>>2]|0;if((E|0)==2|(G|0)==(x|0)){F=12;break}if(y>>>0<(c[l>>2]|0)>>>0){E=y;do{z=0;as(590,r|0,a[E]|0);if(z){z=0;F=23;break L11}E=E+1|0;}while(E>>>0<(c[l>>2]|0)>>>0);H=c[m>>2]|0}else{H=G}if(H>>>0>=h>>>0){break L9}x=H;D=c[C>>2]|0}do{if((F|0)==23){C=bT(-1,-1)|0;I=M;J=C}else if((F|0)==12){C=cl(8)|0;z=0;as(466,C|0,6192);if(z){z=0;D=bT(-1,-1)|0;x=M;bo(C|0);I=x;J=D;break}z=0;aR(156,C|0,29352,466);if(z){z=0;C=bT(-1,-1)|0;I=M;J=C;break}}else if((F|0)==24){C=bT(-1,-1)|0;I=M;J=C}}while(0);DJ(t|0);K=I;L=J;Eb(r);N=L;O=0;P=N;Q=K;bg(P|0)}}while(0);DJ(t|0);if((a[s]&1)==0){R=r+1|0}else{R=c[r+8>>2]|0}s=(z=0,aU(34,((e|0)==-1?-1:e<<1)|0,f|0,g|0,R|0)|0);if(z){z=0;R=bT(-1,-1)|0;K=M;L=R;Eb(r);N=L;O=0;P=N;Q=K;bg(P|0)}LI(v|0,0,12)|0;v=u|0;c[u+4>>2]=0;c[u>>2]=15512;R=LJ(s|0)|0;g=s+R|0;if((R|0)<1){S=u|0;DJ(S);Eb(r);i=d;return}R=u;f=g;e=o|0;t=o+128|0;o=s;s=15512;L46:while(1){c[q>>2]=o;J=(z=0,aT(c[s+16>>2]|0,v|0,n|0,o|0,((f-o|0)>32?o+32|0:g)|0,q|0,e|0,t|0,p|0)|0);if(z){z=0;F=46;break}I=c[q>>2]|0;if((J|0)==2|(I|0)==(o|0)){F=35;break}if(e>>>0<(c[p>>2]|0)>>>0){J=e;do{z=0;as(254,b|0,c[J>>2]|0);if(z){z=0;F=45;break L46}J=J+4|0;}while(J>>>0<(c[p>>2]|0)>>>0);T=c[q>>2]|0}else{T=I}if(T>>>0>=g>>>0){F=50;break}o=T;s=c[R>>2]|0}do{if((F|0)==35){R=cl(8)|0;z=0;as(466,R|0,6192);if(z){z=0;s=bT(-1,-1)|0;T=M;bo(R|0);U=T;V=s;break}z=0;aR(156,R|0,29352,466);if(z){z=0;R=bT(-1,-1)|0;U=M;V=R;break}}else if((F|0)==46){R=bT(-1,-1)|0;U=M;V=R}else if((F|0)==50){S=u|0;DJ(S);Eb(r);i=d;return}else if((F|0)==45){R=bT(-1,-1)|0;U=M;V=R}}while(0);DJ(u|0);Eo(b);K=U;L=V;Eb(r);N=L;O=0;P=N;Q=K;bg(P|0)}function IS(a,b){a=a|0;b=b|0;b1(((b|0)==-1?-1:b<<1)|0)|0;return}function IT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b>>2]=14960;d=b+8|0;e=c[d>>2]|0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}f=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=f;break}else{z=0}bT(-1,-1,0)|0;g=b|0;DJ(g);bX()}}while(0);if((e|0)==(c[10082]|0)){h=b|0;DJ(h);return}z=0;ar(592,c[d>>2]|0);if(!z){h=b|0;DJ(h);return}else{z=0}bT(-1,-1,0)|0;g=b|0;DJ(g);bX()}function IU(a){a=a|0;var b=0;a=cl(8)|0;z=0;as(622,a|0,10320);if(!z){c[a>>2]=13896;bK(a|0,29384,474)}else{z=0;b=bT(-1,-1)|0;bo(a|0);bg(b|0)}}function IV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+448|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;A=e+304|0;B=e+320|0;C=e+336|0;D=e+352|0;E=e+368|0;F=e+384|0;G=e+400|0;H=e+416|0;I=e+432|0;c[b+4>>2]=d-1;c[b>>2]=15216;d=b+8|0;J=b+12|0;K=b+136|0;a[K]=1;L=b+24|0;N=L;c[J>>2]=N;c[d>>2]=N;c[b+16>>2]=L+112;L=28;O=N;do{if((O|0)==0){P=0}else{c[O>>2]=0;P=c[J>>2]|0}O=P+4|0;c[J>>2]=O;L=L-1|0;}while((L|0)!=0);L=b+144|0;z=0;aR(96,L|0,10032,1);if(!z){O=c[d>>2]|0;P=c[J>>2]|0;if((O|0)!=(P|0)){c[J>>2]=P+(~((P-4+(-O|0)|0)>>>2)<<2)}c[10115]=0;c[10114]=14920;if((c[10360]|0)==-1){Q=10}else{c[I>>2]=41440;c[I+4>>2]=460;c[I+8>>2]=0;z=0;aR(2,41440,I|0,520);if(!z){Q=10}else{z=0;Q=111}}L14:do{if((Q|0)==10){z=0;aR(270,b|0,40456,(c[10361]|0)-1|0);if(z){z=0;Q=111;break}c[10113]=0;c[10112]=14880;if((c[10358]|0)!=-1){c[H>>2]=41432;c[H+4>>2]=460;c[H+8>>2]=0;z=0;aR(2,41432,H|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40448,(c[10359]|0)-1|0);if(z){z=0;Q=111;break}c[10165]=0;c[10164]=15328;c[10166]=0;a[40668]=0;I=(z=0,aP(8)|0);if(z){z=0;bT(-1,-1,0)|0;bX()}c[10166]=c[I>>2];if((c[10440]|0)!=-1){c[G>>2]=41760;c[G+4>>2]=460;c[G+8>>2]=0;z=0;aR(2,41760,G|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40656,(c[10441]|0)-1|0);if(z){z=0;Q=111;break}c[10163]=0;c[10162]=15248;if((c[10438]|0)!=-1){c[F>>2]=41752;c[F+4>>2]=460;c[F+8>>2]=0;z=0;aR(2,41752,F|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40648,(c[10439]|0)-1|0);if(z){z=0;Q=111;break}c[10117]=0;c[10116]=15016;if((c[10364]|0)!=-1){c[E>>2]=41456;c[E+4>>2]=460;c[E+8>>2]=0;z=0;aR(2,41456,E|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40464,(c[10365]|0)-1|0);if(z){z=0;Q=111;break}c[3361]=0;c[3360]=14960;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}I=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=I;break}else{z=0;I=bT(-1,-1)|0;O=M;DJ(13440);R=O;S=I;break L14}}}while(0);c[3362]=c[10082];if((c[10362]|0)!=-1){c[D>>2]=41448;c[D+4>>2]=460;c[D+8>>2]=0;z=0;aR(2,41448,D|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,13440,(c[10363]|0)-1|0);if(z){z=0;Q=111;break}c[10119]=0;c[10118]=15072;if((c[10366]|0)!=-1){c[C>>2]=41464;c[C+4>>2]=460;c[C+8>>2]=0;z=0;aR(2,41464,C|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40472,(c[10367]|0)-1|0);if(z){z=0;Q=111;break}c[10121]=0;c[10120]=15128;if((c[10368]|0)!=-1){c[B>>2]=41472;c[B+4>>2]=460;c[B+8>>2]=0;z=0;aR(2,41472,B|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40480,(c[10369]|0)-1|0);if(z){z=0;Q=111;break}c[10095]=0;c[10094]=14424;a[40384]=46;a[40385]=44;LI(40388,0,12)|0;if((c[10344]|0)!=-1){c[A>>2]=41376;c[A+4>>2]=460;c[A+8>>2]=0;z=0;aR(2,41376,A|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40376,(c[10345]|0)-1|0);if(z){z=0;Q=111;break}c[3353]=0;c[3352]=14376;c[3354]=46;c[3355]=44;LI(13424,0,12)|0;if((c[10342]|0)!=-1){c[y>>2]=41368;c[y+4>>2]=460;c[y+8>>2]=0;z=0;aR(2,41368,y|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,13408,(c[10343]|0)-1|0);if(z){z=0;Q=111;break}c[10111]=0;c[10110]=14808;if((c[10356]|0)!=-1){c[x>>2]=41424;c[x+4>>2]=460;c[x+8>>2]=0;z=0;aR(2,41424,x|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40440,(c[10357]|0)-1|0);if(z){z=0;Q=111;break}c[10109]=0;c[10108]=14736;if((c[10354]|0)!=-1){c[w>>2]=41416;c[w+4>>2]=460;c[w+8>>2]=0;z=0;aR(2,41416,w|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40432,(c[10355]|0)-1|0);if(z){z=0;Q=111;break}c[10107]=0;c[10106]=14672;if((c[10352]|0)!=-1){c[v>>2]=41408;c[v+4>>2]=460;c[v+8>>2]=0;z=0;aR(2,41408,v|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40424,(c[10353]|0)-1|0);if(z){z=0;Q=111;break}c[10105]=0;c[10104]=14608;if((c[10350]|0)!=-1){c[u>>2]=41400;c[u+4>>2]=460;c[u+8>>2]=0;z=0;aR(2,41400,u|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40416,(c[10351]|0)-1|0);if(z){z=0;Q=111;break}c[10175]=0;c[10174]=16520;if((c[10560]|0)!=-1){c[t>>2]=42240;c[t+4>>2]=460;c[t+8>>2]=0;z=0;aR(2,42240,t|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40696,(c[10561]|0)-1|0);if(z){z=0;Q=111;break}c[10173]=0;c[10172]=16456;if((c[10558]|0)!=-1){c[s>>2]=42232;c[s+4>>2]=460;c[s+8>>2]=0;z=0;aR(2,42232,s|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40688,(c[10559]|0)-1|0);if(z){z=0;Q=111;break}c[10171]=0;c[10170]=16392;if((c[10556]|0)!=-1){c[r>>2]=42224;c[r+4>>2]=460;c[r+8>>2]=0;z=0;aR(2,42224,r|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40680,(c[10557]|0)-1|0);if(z){z=0;Q=111;break}c[10169]=0;c[10168]=16328;if((c[10554]|0)!=-1){c[q>>2]=42216;c[q+4>>2]=460;c[q+8>>2]=0;z=0;aR(2,42216,q|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40672,(c[10555]|0)-1|0);if(z){z=0;Q=111;break}c[10093]=0;c[10092]=14080;if((c[10332]|0)!=-1){c[p>>2]=41328;c[p+4>>2]=460;c[p+8>>2]=0;z=0;aR(2,41328,p|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40368,(c[10333]|0)-1|0);if(z){z=0;Q=111;break}c[10091]=0;c[10090]=14040;if((c[10330]|0)!=-1){c[o>>2]=41320;c[o+4>>2]=460;c[o+8>>2]=0;z=0;aR(2,41320,o|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40360,(c[10331]|0)-1|0);if(z){z=0;Q=111;break}c[10089]=0;c[10088]=14e3;if((c[10328]|0)!=-1){c[n>>2]=41312;c[n+4>>2]=460;c[n+8>>2]=0;z=0;aR(2,41312,n|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40352,(c[10329]|0)-1|0);if(z){z=0;Q=111;break}c[10087]=0;c[10086]=13960;if((c[10326]|0)!=-1){c[m>>2]=41304;c[m+4>>2]=460;c[m+8>>2]=0;z=0;aR(2,41304,m|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40344,(c[10327]|0)-1|0);if(z){z=0;Q=111;break}c[3349]=0;c[3348]=14280;c[3350]=14328;if((c[10340]|0)!=-1){c[l>>2]=41360;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41360,l|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,13392,(c[10341]|0)-1|0);if(z){z=0;Q=111;break}c[3345]=0;c[3344]=14184;c[3346]=14232;if((c[10338]|0)!=-1){c[k>>2]=41352;c[k+4>>2]=460;c[k+8>>2]=0;z=0;aR(2,41352,k|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,13376,(c[10339]|0)-1|0);if(z){z=0;Q=111;break}c[3341]=0;c[3340]=15184;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}I=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=I;break}else{z=0;I=bT(-1,-1)|0;O=M;DJ(13360);R=O;S=I;break L14}}}while(0);c[3342]=c[10082];c[3340]=14152;if((c[10336]|0)!=-1){c[j>>2]=41344;c[j+4>>2]=460;c[j+8>>2]=0;z=0;aR(2,41344,j|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,13360,(c[10337]|0)-1|0);if(z){z=0;Q=111;break}c[3337]=0;c[3336]=15184;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}I=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=I;break}else{z=0;I=bT(-1,-1)|0;O=M;DJ(13344);R=O;S=I;break L14}}}while(0);c[3338]=c[10082];c[3336]=14120;if((c[10334]|0)!=-1){c[h>>2]=41336;c[h+4>>2]=460;c[h+8>>2]=0;z=0;aR(2,41336,h|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,13344,(c[10335]|0)-1|0);if(z){z=0;Q=111;break}c[10103]=0;c[10102]=14512;if((c[10348]|0)!=-1){c[g>>2]=41392;c[g+4>>2]=460;c[g+8>>2]=0;z=0;aR(2,41392,g|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40408,(c[10349]|0)-1|0);if(z){z=0;Q=111;break}c[10101]=0;c[10100]=14472;if((c[10346]|0)!=-1){c[f>>2]=41384;c[f+4>>2]=460;c[f+8>>2]=0;z=0;aR(2,41384,f|0,520);if(z){z=0;Q=111;break}}z=0;aR(270,b|0,40400,(c[10347]|0)-1|0);if(z){z=0;Q=111;break}i=e;return}}while(0);if((Q|0)==111){Q=bT(-1,-1)|0;R=M;S=Q}Eb(L);T=R;U=S}else{z=0;S=bT(-1,-1)|0;T=M;U=S}S=c[d>>2]|0;if((S|0)==0){V=b|0;DJ(V);W=U;X=0;Y=W;Z=T;bg(Y|0)}d=c[J>>2]|0;if((S|0)!=(d|0)){c[J>>2]=d+(~((d-4+(-S|0)|0)>>>2)<<2)}if((S|0)==(b+24|0)){a[K]=0;V=b|0;DJ(V);W=U;X=0;Y=W;Z=T;bg(Y|0)}else{Lw(S);V=b|0;DJ(V);W=U;X=0;Y=W;Z=T;bg(Y|0)}}function IW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=b|0;DK(e);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f|0;i=c[h>>2]|0;j=a-i>>2;do{if(j>>>0>d>>>0){k=i}else{l=d+1|0;if(j>>>0>=l>>>0){if(j>>>0<=l>>>0){k=i;break}m=i+(l<<2)|0;if((m|0)==(a|0)){k=i;break}c[g>>2]=a+(~((a-4+(-m|0)|0)>>>2)<<2);k=i;break}z=0;as(182,f|0,l-j|0);if(!z){k=c[h>>2]|0;break}else{z=0}l=bT(-1,-1)|0;if((b|0)==0){bg(l|0)}DL(e)|0;bg(l|0)}}while(0);e=c[k+(d<<2)>>2]|0;if((e|0)==0){n=k;o=n+(d<<2)|0;c[o>>2]=b;return}DL(e|0)|0;n=c[h>>2]|0;o=n+(d<<2)|0;c[o>>2]=b;return}function IX(a){a=a|0;IY(a);Lw(a);return}function IY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c[b>>2]=15216;d=b+12|0;e=c[d>>2]|0;f=b+8|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=0;i=g;g=e;while(1){e=c[i+(h<<2)>>2]|0;if((e|0)==0){j=g;k=i}else{DL(e|0)|0;j=c[d>>2]|0;k=c[f>>2]|0}e=h+1|0;if(e>>>0<j-k>>2>>>0){h=e;i=k;g=j}else{break}}}Eb(b+144|0);j=c[f>>2]|0;if((j|0)==0){l=b|0;DJ(l);return}f=c[d>>2]|0;if((j|0)!=(f|0)){c[d>>2]=f+(~((f-4+(-j|0)|0)>>>2)<<2)}if((j|0)==(b+24|0)){a[b+136|0]=0;l=b|0;DJ(l);return}else{Lw(j);l=b|0;DJ(l);return}}function IZ(){var b=0,d=0;if((a[42304]|0)!=0){b=c[10074]|0;return b|0}if((bC(42304)|0)==0){b=c[10074]|0;return b|0}do{if((a[42312]|0)==0){if((bC(42312)|0)==0){break}z=0;as(242,40488,1);if(!z){c[10078]=40488;c[10076]=40312;break}else{z=0;d=bT(-1,-1)|0;bg(d|0)}}}while(0);d=c[c[10076]>>2]|0;c[10080]=d;DK(d|0);c[10074]=40320;b=c[10074]|0;return b|0}function I_(a){a=a|0;var b=0,d=0;b=(z=0,aP(4)|0);if(!z){d=c[b>>2]|0;c[a>>2]=d;DK(d|0);return}else{z=0;bT(-1,-1,0)|0;bX()}}function I$(a,b){a=a|0;b=b|0;var d=0;d=c[b>>2]|0;c[a>>2]=d;DK(d|0);return}function I0(a){a=a|0;DL(c[a>>2]|0)|0;return}function I1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d|0;f=c[a>>2]|0;a=b|0;if((c[a>>2]|0)!=-1){c[e>>2]=b;c[e+4>>2]=460;c[e+8>>2]=0;D4(a,e,520)}e=(c[b+4>>2]|0)-1|0;b=c[f+8>>2]|0;if((c[f+12>>2]|0)-b>>2>>>0<=e>>>0){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function I2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d|0;f=c[a>>2]|0;a=b|0;if((c[a>>2]|0)!=-1){c[e>>2]=b;c[e+4>>2]=460;c[e+8>>2]=0;D4(a,e,520)}e=(c[b+4>>2]|0)-1|0;b=c[f+8>>2]|0;if((c[f+12>>2]|0)-b>>2>>>0<=e>>>0){g=cl(4)|0;h=g;K$(h);bK(g|0,29336,98);return 0}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=cl(4)|0;h=g;K$(h);bK(g|0,29336,98);return 0}else{i=d;return f|0}return 0}function I3(a){a=a|0;DJ(a|0);Lw(a);return}function I4(a){a=a|0;if((a|0)==0){return}cA[c[(c[a>>2]|0)+4>>2]&1023](a);return}function I5(a){a=a|0;c[a+4>>2]=(K=c[10370]|0,c[10370]=K+1,K)+1;return}function I6(a){a=a|0;DJ(a|0);Lw(a);return}function I7(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;if(e>>>0>=128>>>0){f=0;return f|0}a=(z=0,aP(8)|0);if(z){z=0;bT(-1,-1,0)|0;bX();return 0}f=(b[(c[a>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;return f|0}function I8(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;if((d|0)==(e|0)){g=d;return g|0}else{h=d;i=f}while(1){f=c[h>>2]|0;if(f>>>0<128>>>0){d=(z=0,aP(8)|0);if(z){z=0;j=4;break}k=b[(c[d>>2]|0)+(f<<1)>>1]|0}else{k=0}b[i>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;j=8;break}else{h=f;i=i+2|0}}if((j|0)==4){bT(-1,-1,0)|0;bX();return 0}else if((j|0)==8){return g|0}return 0}function I9(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((e|0)==(f|0)){g=e;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128>>>0){a=(z=0,aP(8)|0);if(z){z=0;i=4;break}if((b[(c[a>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0){g=h;i=10;break}}e=h+4|0;if((e|0)==(f|0)){g=f;i=9;break}else{h=e}}if((i|0)==4){bT(-1,-1,0)|0;bX();return 0}else if((i|0)==10){return g|0}else if((i|0)==9){return g|0}return 0}function Ja(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=e;while(1){if((a|0)==(f|0)){g=f;h=10;break}e=c[a>>2]|0;if(e>>>0>=128>>>0){g=a;h=8;break}i=(z=0,aP(8)|0);if(z){z=0;h=5;break}if((b[(c[i>>2]|0)+(e<<1)>>1]&d)<<16>>16==0){g=a;h=9;break}else{a=a+4|0}}if((h|0)==5){bT(-1,-1,0)|0;bX();return 0}else if((h|0)==8){return g|0}else if((h|0)==10){return g|0}else if((h|0)==9){return g|0}return 0}function Jb(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>=128>>>0){d=b;return d|0}a=(z=0,aP(6)|0);if(z){z=0;bT(-1,-1,0)|0;bX();return 0}d=c[(c[a>>2]|0)+(b<<2)>>2]|0;return d|0}function Jc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)==(d|0)){e=b;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128>>>0){a=(z=0,aP(6)|0);if(z){z=0;g=4;break}h=c[(c[a>>2]|0)+(b<<2)>>2]|0}else{h=b}c[f>>2]=h;b=f+4|0;if((b|0)==(d|0)){e=d;g=8;break}else{f=b}}if((g|0)==4){bT(-1,-1,0)|0;bX();return 0}else if((g|0)==8){return e|0}return 0}function Jd(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>=128>>>0){d=b;return d|0}a=(z=0,aP(2)|0);if(z){z=0;bT(-1,-1,0)|0;bX();return 0}d=c[(c[a>>2]|0)+(b<<2)>>2]|0;return d|0}function Je(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)==(d|0)){e=b;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128>>>0){a=(z=0,aP(2)|0);if(z){z=0;g=4;break}h=c[(c[a>>2]|0)+(b<<2)>>2]|0}else{h=b}c[f>>2]=h;b=f+4|0;if((b|0)==(d|0)){e=d;g=8;break}else{f=b}}if((g|0)==4){bT(-1,-1,0)|0;bX();return 0}else if((g|0)==8){return e|0}return 0}function Jf(a,b){a=a|0;b=b|0;return b<<24>>24|0}function Jg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((d|0)==(e|0)){g=d;return g|0}else{h=d;i=f}while(1){c[i>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{h=f;i=i+4|0}}return g|0}function Jh(a,b,c){a=a|0;b=b|0;c=c|0;return(b>>>0<128>>>0?b&255:c)|0}function Ji(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;if((d|0)==(e|0)){h=d;return h|0}b=((e-4+(-d|0)|0)>>>2)+1|0;i=d;j=g;while(1){g=c[i>>2]|0;a[j]=g>>>0<128>>>0?g&255:f;g=i+4|0;if((g|0)==(e|0)){break}else{i=g;j=j+1|0}}h=d+(b<<2)|0;return h|0}function Jj(b){b=b|0;var d=0;c[b>>2]=15328;d=c[b+8>>2]|0;do{if((d|0)!=0){if((a[b+12|0]&1)==0){break}Lx(d)}}while(0);DJ(b|0);Lw(b);return}function Jk(b){b=b|0;var d=0;c[b>>2]=15328;d=c[b+8>>2]|0;do{if((d|0)!=0){if((a[b+12|0]&1)==0){break}Lx(d)}}while(0);DJ(b|0);return}function Jl(a,b){a=a|0;b=b|0;var d=0;if(b<<24>>24<0){d=b;return d|0}a=(z=0,aP(6)|0);if(z){z=0;bT(-1,-1,0)|0;bX();return 0}d=c[(c[a>>2]|0)+((b&255)<<2)>>2]&255;return d|0}function Jm(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if((d|0)==(e|0)){f=d;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24<0){h=d}else{b=(z=0,aP(6)|0);if(z){z=0;i=4;break}h=c[(c[b>>2]|0)+(d<<24>>24<<2)>>2]&255}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;i=8;break}else{g=d}}if((i|0)==4){bT(-1,-1,0)|0;bX();return 0}else if((i|0)==8){return f|0}return 0}function Jn(a,b){a=a|0;b=b|0;var d=0;if(b<<24>>24<0){d=b;return d|0}a=(z=0,aP(2)|0);if(z){z=0;bT(-1,-1,0)|0;bX();return 0}d=c[(c[a>>2]|0)+(b<<24>>24<<2)>>2]&255;return d|0}function Jo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if((d|0)==(e|0)){f=d;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24<0){h=d}else{b=(z=0,aP(2)|0);if(z){z=0;i=4;break}h=c[(c[b>>2]|0)+(d<<24>>24<<2)>>2]&255}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;i=9;break}else{g=d}}if((i|0)==4){bT(-1,-1,0)|0;bX();return 0}else if((i|0)==9){return f|0}return 0}function Jp(a,b){a=a|0;b=b|0;return b|0}function Jq(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((c|0)==(d|0)){f=c;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{g=e;h=h+1|0}}return f|0}function Jr(a,b,c){a=a|0;b=b|0;c=c|0;return(b<<24>>24<0?c:b)|0}function Js(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((c|0)==(d|0)){g=c;return g|0}else{h=c;i=f}while(1){f=a[h]|0;a[i]=f<<24>>24<0?e:f;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{h=f;i=i+1|0}}return g|0}function Jt(a){a=a|0;DJ(a|0);Lw(a);return}function Ju(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function Jv(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function Jw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Jx(a){a=a|0;return 1}function Jy(a){a=a|0;return 1}function Jz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return(b>>>0<e>>>0?b:e)|0}function JA(a){a=a|0;return 1}function JB(a){a=a|0;IT(a);Lw(a);return}function JC(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;l=i;i=i+8|0;m=l|0;n=m;o=i;i=i+4|0;i=i+7&-8;p=e;while(1){if((p|0)==(f|0)){q=f;break}if((c[p>>2]|0)==0){q=p;break}else{p=p+4|0}}c[k>>2]=h;c[g>>2]=e;L5:do{if((e|0)==(f|0)|(h|0)==(j|0)){r=e}else{p=d;s=j;t=b+8|0;u=o|0;v=h;w=e;x=q;while(1){y=c[p+4>>2]|0;c[m>>2]=c[p>>2];c[m+4>>2]=y;A=b6(c[t>>2]|0)|0;y=(z=0,aQ(16,v|0,g|0,x-w>>2|0,s-v|0,d|0)|0);if(z){z=0;B=10;break}if((A|0)!=0){z=0,au(36,A|0)|0;if(z){z=0;B=9;break}}if((y|0)==(-1|0)){B=15;break}else if((y|0)==0){C=1;B=57;break}D=(c[k>>2]|0)+y|0;c[k>>2]=D;if((D|0)==(j|0)){B=48;break}if((x|0)==(f|0)){E=f;F=D;G=c[g>>2]|0}else{H=b6(c[t>>2]|0)|0;D=(z=0,az(78,u|0,0,d|0)|0);if(z){z=0;B=34;break}if((H|0)!=0){z=0,au(36,H|0)|0;if(z){z=0;B=33;break}}if((D|0)==-1){C=2;B=59;break}y=c[k>>2]|0;if(D>>>0>(s-y|0)>>>0){C=1;B=60;break}L24:do{if((D|0)!=0){I=D;J=u;K=y;while(1){L=a[J]|0;c[k>>2]=K+1;a[K]=L;L=I-1|0;if((L|0)==0){break L24}I=L;J=J+1|0;K=c[k>>2]|0}}}while(0);y=(c[g>>2]|0)+4|0;c[g>>2]=y;D=y;while(1){if((D|0)==(f|0)){M=f;break}if((c[D>>2]|0)==0){M=D;break}else{D=D+4|0}}E=M;F=c[k>>2]|0;G=y}if((G|0)==(f|0)|(F|0)==(j|0)){r=G;break L5}else{v=F;w=G;x=E}}if((B|0)==9){bT(-1,-1,0)|0;bX();return 0}else if((B|0)==10){x=bT(-1,-1)|0;if((A|0)==0){bg(x|0)}z=0,au(36,A|0)|0;if(!z){bg(x|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else if((B|0)==15){c[k>>2]=v;L44:do{if((w|0)==(c[g>>2]|0)){N=w}else{x=w;u=v;while(1){s=c[x>>2]|0;O=b6(c[t>>2]|0)|0;p=(z=0,az(78,u|0,s|0,n|0)|0);if(z){z=0;break}if((O|0)!=0){z=0,au(36,O|0)|0;if(z){z=0;B=19;break}}if((p|0)==-1){N=x;break L44}s=(c[k>>2]|0)+p|0;c[k>>2]=s;p=x+4|0;if((p|0)==(c[g>>2]|0)){N=p;break L44}else{x=p;u=s}}if((B|0)==19){bT(-1,-1,0)|0;bX();return 0}u=bT(-1,-1)|0;if((O|0)==0){bg(u|0)}z=0,au(36,O|0)|0;if(!z){bg(u|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);c[g>>2]=N;C=2;i=l;return C|0}else if((B|0)==33){bT(-1,-1,0)|0;bX();return 0}else if((B|0)==34){t=bT(-1,-1)|0;if((H|0)==0){bg(t|0)}z=0,au(36,H|0)|0;if(!z){bg(t|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else if((B|0)==48){r=c[g>>2]|0;break}else if((B|0)==57){i=l;return C|0}else if((B|0)==59){i=l;return C|0}else if((B|0)==60){i=l;return C|0}}}while(0);C=(r|0)!=(f|0)|0;i=l;return C|0}function JD(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;l=i;i=i+8|0;m=l|0;n=m;o=e;while(1){if((o|0)==(f|0)){p=f;break}if((a[o]|0)==0){p=o;break}else{o=o+1|0}}c[k>>2]=h;c[g>>2]=e;L5:do{if((e|0)==(f|0)|(h|0)==(j|0)){q=e}else{o=d;r=j;s=b+8|0;t=h;u=e;v=p;while(1){w=c[o+4>>2]|0;c[m>>2]=c[o>>2];c[m+4>>2]=w;x=v;y=b6(c[s>>2]|0)|0;w=(z=0,aQ(6,t|0,g|0,x-u|0,r-t>>2|0,d|0)|0);if(z){z=0;A=10;break}if((y|0)!=0){z=0,au(36,y|0)|0;if(z){z=0;A=9;break}}if((w|0)==(-1|0)){A=15;break}else if((w|0)==0){B=2;A=56;break}C=(c[k>>2]|0)+(w<<2)|0;c[k>>2]=C;if((C|0)==(j|0)){A=47;break}w=c[g>>2]|0;if((v|0)==(f|0)){D=f;E=C;F=w}else{G=b6(c[s>>2]|0)|0;H=(z=0,aU(40,C|0,w|0,1,d|0)|0);if(z){z=0;A=37;break}if((G|0)!=0){z=0,au(36,G|0)|0;if(z){z=0;A=36;break}}if((H|0)!=0){B=2;A=60;break}c[k>>2]=(c[k>>2]|0)+4;H=(c[g>>2]|0)+1|0;c[g>>2]=H;w=H;while(1){if((w|0)==(f|0)){I=f;break}if((a[w]|0)==0){I=w;break}else{w=w+1|0}}D=I;E=c[k>>2]|0;F=H}if((F|0)==(f|0)|(E|0)==(j|0)){q=F;break L5}else{t=E;u=F;v=D}}if((A|0)==10){v=bT(-1,-1)|0;if((y|0)==0){bg(v|0)}z=0,au(36,y|0)|0;if(!z){bg(v|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else if((A|0)==15){c[k>>2]=t;L36:do{if((u|0)==(c[g>>2]|0)){J=u}else{v=t;r=u;while(1){K=b6(c[s>>2]|0)|0;o=(z=0,aU(40,v|0,r|0,x-r|0,n|0)|0);if(z){z=0;A=20;break}if((K|0)!=0){z=0,au(36,K|0)|0;if(z){z=0;A=19;break}}if((o|0)==0){L=r+1|0}else if((o|0)==(-1|0)){A=26;break}else if((o|0)==(-2|0)){A=27;break}else{L=r+o|0}o=(c[k>>2]|0)+4|0;c[k>>2]=o;if((L|0)==(c[g>>2]|0)){J=L;break L36}else{v=o;r=L}}if((A|0)==19){bT(-1,-1,0)|0;bX();return 0}else if((A|0)==20){v=bT(-1,-1)|0;if((K|0)==0){bg(v|0)}z=0,au(36,K|0)|0;if(!z){bg(v|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else if((A|0)==26){c[g>>2]=r;B=2;i=l;return B|0}else if((A|0)==27){c[g>>2]=r;B=1;i=l;return B|0}}}while(0);c[g>>2]=J;B=(J|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==9){bT(-1,-1,0)|0;bX();return 0}else if((A|0)==36){bT(-1,-1,0)|0;bX();return 0}else if((A|0)==37){s=bT(-1,-1)|0;if((G|0)==0){bg(s|0)}z=0,au(36,G|0)|0;if(!z){bg(s|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else if((A|0)==47){q=c[g>>2]|0;break}else if((A|0)==56){i=l;return B|0}else if((A|0)==60){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function JE(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h|0;j=b6(c[b+8>>2]|0)|0;b=(z=0,az(78,e|0,0,d|0)|0);if(z){z=0;d=bT(-1,-1)|0;if((j|0)==0){bg(d|0)}z=0,au(36,j|0)|0;if(!z){bg(d|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}do{if((j|0)!=0){z=0,au(36,j|0)|0;if(!z){break}else{z=0}bT(-1,-1,0)|0;bX();return 0}}while(0);if((b|0)==(-1|0)|(b|0)==0){k=2;i=h;return k|0}j=b-1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=j;m=e;n=b}while(1){b=a[m]|0;c[g>>2]=n+1;a[n]=b;b=l-1|0;if((b|0)==0){k=0;break}l=b;m=m+1|0;n=c[g>>2]|0}i=h;return k|0}function JF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+8|0;a=(z=0,au(36,c[b>>2]|0)|0);do{if(!z){d=(z=0,az(56,0,0,4)|0);if(z){z=0;bT(-1,-1,0)|0;if((a|0)==0){bX();return 0}z=0,au(36,a|0)|0;if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}do{if((a|0)!=0){z=0,au(36,a|0)|0;if(!z){break}else{z=0}bT(-1,-1,0)|0;bX();return 0}}while(0);if((d|0)!=0){e=-1;return e|0}f=c[b>>2]|0;if((f|0)==0){e=1;return e|0}g=(z=0,au(36,f|0)|0);if(z){z=0;break}if((g|0)==0){e=0;return e|0}z=0,au(36,g|0)|0;if(!z){e=0;return e|0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{z=0}}while(0);bT(-1,-1,0)|0;bX();return 0}function JG(a){a=a|0;return 0}function JH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if((f|0)==0|(d|0)==(e|0)){g=0;return g|0}h=e;i=a+8|0;a=d;d=0;j=0;while(1){k=b6(c[i>>2]|0)|0;l=(z=0,az(4,a|0,h-a|0,b|0)|0);if(z){z=0;m=7;break}if((k|0)!=0){z=0,au(36,k|0)|0;if(z){z=0;m=6;break}}if((l|0)==0){n=1;o=a+1|0}else if((l|0)==(-1|0)|(l|0)==(-2|0)){g=d;m=19;break}else{n=l;o=a+l|0}l=n+d|0;p=j+1|0;if(p>>>0>=f>>>0|(o|0)==(e|0)){g=l;m=18;break}else{a=o;d=l;j=p}}if((m|0)==6){bT(-1,-1,0)|0;bX();return 0}else if((m|0)==7){j=bT(-1,-1)|0;if((k|0)==0){bg(j|0)}z=0,au(36,k|0)|0;if(!z){bg(j|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else if((m|0)==18){return g|0}else if((m|0)==19){return g|0}return 0}function JI(a){a=a|0;var b=0,d=0;b=c[a+8>>2]|0;if((b|0)==0){d=1;return d|0}a=(z=0,au(36,b|0)|0);if(z){z=0;bT(-1,-1,0)|0;bX();return 0}if((a|0)==0){d=4;return d|0}z=0,au(36,a|0)|0;if(!z){d=4;return d|0}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function JJ(a){a=a|0;DJ(a|0);Lw(a);return}function JK(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=JL(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function JL(d,f,g,h,i,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;c[g>>2]=d;c[j>>2]=h;do{if((l&2|0)!=0){if((i-h|0)<3){m=1;return m|0}else{c[j>>2]=h+1;a[h]=-17;d=c[j>>2]|0;c[j>>2]=d+1;a[d]=-69;d=c[j>>2]|0;c[j>>2]=d+1;a[d]=-65;break}}}while(0);h=f;l=c[g>>2]|0;if(l>>>0>=f>>>0){m=0;return m|0}d=i;i=l;L10:while(1){l=b[i>>1]|0;n=l&65535;if(n>>>0>k>>>0){m=2;o=30;break}do{if((l&65535)>>>0<128>>>0){p=c[j>>2]|0;if((d-p|0)<1){m=1;o=33;break L10}c[j>>2]=p+1;a[p]=l}else{if((l&65535)>>>0<2048>>>0){p=c[j>>2]|0;if((d-p|0)<2){m=1;o=29;break L10}c[j>>2]=p+1;a[p]=n>>>6|192;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n&63|128;break}if((l&65535)>>>0<55296>>>0){p=c[j>>2]|0;if((d-p|0)<3){m=1;o=31;break L10}c[j>>2]=p+1;a[p]=n>>>12|224;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n>>>6&63|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n&63|128;break}if((l&65535)>>>0>=56320>>>0){if((l&65535)>>>0<57344>>>0){m=2;o=37;break L10}p=c[j>>2]|0;if((d-p|0)<3){m=1;o=38;break L10}c[j>>2]=p+1;a[p]=n>>>12|224;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n>>>6&63|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n&63|128;break}if((h-i|0)<4){m=1;o=28;break L10}p=i+2|0;q=e[p>>1]|0;if((q&64512|0)!=56320){m=2;o=35;break L10}if((d-(c[j>>2]|0)|0)<4){m=1;o=32;break L10}r=n&960;if(((r<<10)+65536|n<<10&64512|q&1023)>>>0>k>>>0){m=2;o=36;break L10}c[g>>2]=p;p=(r>>>6)+1|0;r=c[j>>2]|0;c[j>>2]=r+1;a[r]=p>>>2|240;r=c[j>>2]|0;c[j>>2]=r+1;a[r]=n>>>2&15|p<<4&48|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n<<4&48|q>>>6&15|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=q&63|128}}while(0);n=(c[g>>2]|0)+2|0;c[g>>2]=n;if(n>>>0<f>>>0){i=n}else{m=0;o=39;break}}if((o|0)==28){return m|0}else if((o|0)==29){return m|0}else if((o|0)==30){return m|0}else if((o|0)==31){return m|0}else if((o|0)==32){return m|0}else if((o|0)==33){return m|0}else if((o|0)==35){return m|0}else if((o|0)==36){return m|0}else if((o|0)==37){return m|0}else if((o|0)==38){return m|0}else if((o|0)==39){return m|0}return 0}function JM(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=JN(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function JN(e,f,g,h,i,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c[g>>2]=e;c[j>>2]=h;h=c[g>>2]|0;do{if((l&4|0)==0){m=h}else{if((f-h|0)<=2){m=h;break}if((a[h]|0)!=-17){m=h;break}if((a[h+1|0]|0)!=-69){m=h;break}if((a[h+2|0]|0)!=-65){m=h;break}e=h+3|0;c[g>>2]=e;m=e}}while(0);L8:do{if(m>>>0<f>>>0){h=f;l=i;e=c[j>>2]|0;n=m;L10:while(1){if(e>>>0>=i>>>0){o=n;break L8}p=a[n]|0;q=p&255;if(q>>>0>k>>>0){r=2;s=49;break}do{if(p<<24>>24>-1){b[e>>1]=p&255;c[g>>2]=(c[g>>2]|0)+1}else{if((p&255)>>>0<194>>>0){r=2;s=43;break L10}if((p&255)>>>0<224>>>0){if((h-n|0)<2){r=1;s=44;break L10}t=d[n+1|0]|0;if((t&192|0)!=128){r=2;s=45;break L10}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=42;break L10}b[e>>1]=u;c[g>>2]=(c[g>>2]|0)+2;break}if((p&255)>>>0<240>>>0){if((h-n|0)<3){r=1;s=51;break L10}u=a[n+1|0]|0;t=a[n+2|0]|0;if((q|0)==237){if((u&-32)<<24>>24!=-128){r=2;s=50;break L10}}else if((q|0)==224){if((u&-32)<<24>>24!=-96){r=2;s=56;break L10}}else{if((u&-64)<<24>>24!=-128){r=2;s=52;break L10}}v=t&255;if((v&192|0)!=128){r=2;s=57;break L10}t=(u&255)<<6&4032|q<<12|v&63;if((t&65535)>>>0>k>>>0){r=2;s=53;break L10}b[e>>1]=t;c[g>>2]=(c[g>>2]|0)+3;break}if((p&255)>>>0>=245>>>0){r=2;s=62;break L10}if((h-n|0)<4){r=1;s=55;break L10}t=a[n+1|0]|0;v=a[n+2|0]|0;u=a[n+3|0]|0;if((q|0)==244){if((t&-16)<<24>>24!=-128){r=2;s=46;break L10}}else if((q|0)==240){if((t+112&255)>>>0>=48>>>0){r=2;s=54;break L10}}else{if((t&-64)<<24>>24!=-128){r=2;s=61;break L10}}w=v&255;if((w&192|0)!=128){r=2;s=58;break L10}v=u&255;if((v&192|0)!=128){r=2;s=59;break L10}if((l-e|0)<4){r=1;s=60;break L10}u=q&7;x=t&255;t=w<<6;y=v&63;if((x<<12&258048|u<<18|t&4032|y)>>>0>k>>>0){r=2;s=47;break L10}b[e>>1]=x<<2&60|w>>>4&3|((x>>>4&3|u<<2)<<6)+16320|55296;u=(c[j>>2]|0)+2|0;c[j>>2]=u;b[u>>1]=y|t&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);q=(c[j>>2]|0)+2|0;c[j>>2]=q;p=c[g>>2]|0;if(p>>>0<f>>>0){e=q;n=p}else{o=p;break L8}}if((s|0)==57){return r|0}else if((s|0)==60){return r|0}else if((s|0)==54){return r|0}else if((s|0)==55){return r|0}else if((s|0)==56){return r|0}else if((s|0)==49){return r|0}else if((s|0)==45){return r|0}else if((s|0)==46){return r|0}else if((s|0)==43){return r|0}else if((s|0)==61){return r|0}else if((s|0)==62){return r|0}else if((s|0)==44){return r|0}else if((s|0)==58){return r|0}else if((s|0)==59){return r|0}else if((s|0)==47){return r|0}else if((s|0)==42){return r|0}else if((s|0)==50){return r|0}else if((s|0)==52){return r|0}else if((s|0)==53){return r|0}else if((s|0)==51){return r|0}}else{o=m}}while(0);r=o>>>0<f>>>0|0;return r|0}function JO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function JP(a){a=a|0;return 0}function JQ(a){a=a|0;return 0}function JR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return JS(c,d,e,1114111,0)|0}function JS(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;do{if((g&4|0)==0){h=b}else{if((c-b|0)<=2){h=b;break}if((a[b]|0)!=-17){h=b;break}if((a[b+1|0]|0)!=-69){h=b;break}h=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);L7:do{if(h>>>0<c>>>0&(e|0)!=0){g=c;i=0;j=h;L9:while(1){k=a[j]|0;l=k&255;if(l>>>0>f>>>0){m=j;break L7}do{if(k<<24>>24>-1){n=j+1|0;o=i}else{if((k&255)>>>0<194>>>0){m=j;break L7}if((k&255)>>>0<224>>>0){if((g-j|0)<2){m=j;break L7}p=d[j+1|0]|0;if((p&192|0)!=128){m=j;break L7}if((p&63|l<<6&1984)>>>0>f>>>0){m=j;break L7}n=j+2|0;o=i;break}if((k&255)>>>0<240>>>0){q=j;if((g-q|0)<3){m=j;break L7}p=a[j+1|0]|0;r=a[j+2|0]|0;if((l|0)==237){if((p&-32)<<24>>24!=-128){s=23;break L9}}else if((l|0)==224){if((p&-32)<<24>>24!=-96){s=21;break L9}}else{if((p&-64)<<24>>24!=-128){s=25;break L9}}t=r&255;if((t&192|0)!=128){m=j;break L7}if(((p&255)<<6&4032|l<<12&61440|t&63)>>>0>f>>>0){m=j;break L7}n=j+3|0;o=i;break}if((k&255)>>>0>=245>>>0){m=j;break L7}u=j;if((g-u|0)<4){m=j;break L7}if((e-i|0)>>>0<2>>>0){m=j;break L7}t=a[j+1|0]|0;p=a[j+2|0]|0;r=a[j+3|0]|0;if((l|0)==240){if((t+112&255)>>>0>=48>>>0){s=34;break L9}}else if((l|0)==244){if((t&-16)<<24>>24!=-128){s=36;break L9}}else{if((t&-64)<<24>>24!=-128){s=38;break L9}}v=p&255;if((v&192|0)!=128){m=j;break L7}p=r&255;if((p&192|0)!=128){m=j;break L7}if(((t&255)<<12&258048|l<<18&1835008|v<<6&4032|p&63)>>>0>f>>>0){m=j;break L7}n=j+4|0;o=i+1|0}}while(0);l=o+1|0;if(n>>>0<c>>>0&l>>>0<e>>>0){i=l;j=n}else{m=n;break L7}}if((s|0)==25){w=q-b|0;return w|0}else if((s|0)==23){w=q-b|0;return w|0}else if((s|0)==21){w=q-b|0;return w|0}else if((s|0)==38){w=u-b|0;return w|0}else if((s|0)==34){w=u-b|0;return w|0}else if((s|0)==36){w=u-b|0;return w|0}}else{m=h}}while(0);w=m-b|0;return w|0}function JT(a){a=a|0;return 4}function JU(a){a=a|0;DJ(a|0);Lw(a);return}function JV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=JW(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function JW(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;c[e>>2]=b;c[h>>2]=f;do{if((j&2|0)!=0){if((g-f|0)<3){k=1;return k|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(f>>>0>=d>>>0){k=0;return k|0}j=g;g=f;L10:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>i>>>0){k=2;l=23;break}do{if(f>>>0<128>>>0){b=c[h>>2]|0;if((j-b|0)<1){k=1;l=22;break L10}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048>>>0){b=c[h>>2]|0;if((j-b|0)<2){k=1;l=20;break L10}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;m=j-b|0;if(f>>>0<65536>>>0){if((m|0)<3){k=1;l=24;break L10}c[h>>2]=b+1;a[b]=f>>>12|224;n=c[h>>2]|0;c[h>>2]=n+1;a[n]=f>>>6&63|128;n=c[h>>2]|0;c[h>>2]=n+1;a[n]=f&63|128;break}else{if((m|0)<4){k=1;l=26;break L10}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{k=0;l=25;break}}if((l|0)==24){return k|0}else if((l|0)==22){return k|0}else if((l|0)==25){return k|0}else if((l|0)==20){return k|0}else if((l|0)==26){return k|0}else if((l|0)==23){return k|0}return 0}function JX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=JY(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function JY(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c[f>>2]=b;c[i>>2]=g;g=c[f>>2]|0;do{if((k&4|0)==0){l=g}else{if((e-g|0)<=2){l=g;break}if((a[g]|0)!=-17){l=g;break}if((a[g+1|0]|0)!=-69){l=g;break}if((a[g+2|0]|0)!=-65){l=g;break}b=g+3|0;c[f>>2]=b;l=b}}while(0);L8:do{if(l>>>0<e>>>0){g=e;k=c[i>>2]|0;b=l;L10:while(1){if(k>>>0>=h>>>0){m=b;break L8}n=a[b]|0;o=n&255;do{if(n<<24>>24>-1){if(o>>>0>j>>>0){p=2;q=42;break L10}c[k>>2]=o;c[f>>2]=(c[f>>2]|0)+1}else{if((n&255)>>>0<194>>>0){p=2;q=47;break L10}if((n&255)>>>0<224>>>0){if((g-b|0)<2){p=1;q=49;break L10}r=d[b+1|0]|0;if((r&192|0)!=128){p=2;q=48;break L10}s=r&63|o<<6&1984;if(s>>>0>j>>>0){p=2;q=45;break L10}c[k>>2]=s;c[f>>2]=(c[f>>2]|0)+2;break}if((n&255)>>>0<240>>>0){if((g-b|0)<3){p=1;q=60;break L10}s=a[b+1|0]|0;r=a[b+2|0]|0;if((o|0)==237){if((s&-32)<<24>>24!=-128){p=2;q=41;break L10}}else if((o|0)==224){if((s&-32)<<24>>24!=-96){p=2;q=51;break L10}}else{if((s&-64)<<24>>24!=-128){p=2;q=44;break L10}}t=r&255;if((t&192|0)!=128){p=2;q=43;break L10}r=(s&255)<<6&4032|o<<12&61440|t&63;if(r>>>0>j>>>0){p=2;q=50;break L10}c[k>>2]=r;c[f>>2]=(c[f>>2]|0)+3;break}if((n&255)>>>0>=245>>>0){p=2;q=46;break L10}if((g-b|0)<4){p=1;q=59;break L10}r=a[b+1|0]|0;t=a[b+2|0]|0;s=a[b+3|0]|0;if((o|0)==244){if((r&-16)<<24>>24!=-128){p=2;q=55;break L10}}else if((o|0)==240){if((r+112&255)>>>0>=48>>>0){p=2;q=58;break L10}}else{if((r&-64)<<24>>24!=-128){p=2;q=52;break L10}}u=t&255;if((u&192|0)!=128){p=2;q=57;break L10}t=s&255;if((t&192|0)!=128){p=2;q=56;break L10}s=(r&255)<<12&258048|o<<18&1835008|u<<6&4032|t&63;if(s>>>0>j>>>0){p=2;q=54;break L10}c[k>>2]=s;c[f>>2]=(c[f>>2]|0)+4}}while(0);o=(c[i>>2]|0)+4|0;c[i>>2]=o;n=c[f>>2]|0;if(n>>>0<e>>>0){k=o;b=n}else{m=n;break L8}}if((q|0)==48){return p|0}else if((q|0)==49){return p|0}else if((q|0)==56){return p|0}else if((q|0)==45){return p|0}else if((q|0)==46){return p|0}else if((q|0)==60){return p|0}else if((q|0)==47){return p|0}else if((q|0)==51){return p|0}else if((q|0)==52){return p|0}else if((q|0)==57){return p|0}else if((q|0)==58){return p|0}else if((q|0)==41){return p|0}else if((q|0)==59){return p|0}else if((q|0)==50){return p|0}else if((q|0)==42){return p|0}else if((q|0)==43){return p|0}else if((q|0)==54){return p|0}else if((q|0)==55){return p|0}else if((q|0)==44){return p|0}}else{m=l}}while(0);p=m>>>0<e>>>0|0;return p|0}function JZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function J_(a){a=a|0;return 0}function J$(a){a=a|0;return 0}function J0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return J1(c,d,e,1114111,0)|0}function J1(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;do{if((g&4|0)==0){h=b}else{if((c-b|0)<=2){h=b;break}if((a[b]|0)!=-17){h=b;break}if((a[b+1|0]|0)!=-69){h=b;break}h=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);L7:do{if(h>>>0<c>>>0&(e|0)!=0){g=c;i=1;j=h;L9:while(1){k=a[j]|0;l=k&255;do{if(k<<24>>24>-1){if(l>>>0>f>>>0){m=j;break L7}n=j+1|0}else{if((k&255)>>>0<194>>>0){m=j;break L7}if((k&255)>>>0<224>>>0){if((g-j|0)<2){m=j;break L7}o=d[j+1|0]|0;if((o&192|0)!=128){m=j;break L7}if((o&63|l<<6&1984)>>>0>f>>>0){m=j;break L7}n=j+2|0;break}if((k&255)>>>0<240>>>0){p=j;if((g-p|0)<3){m=j;break L7}o=a[j+1|0]|0;q=a[j+2|0]|0;if((l|0)==224){if((o&-32)<<24>>24!=-96){r=21;break L9}}else if((l|0)==237){if((o&-32)<<24>>24!=-128){r=23;break L9}}else{if((o&-64)<<24>>24!=-128){r=25;break L9}}s=q&255;if((s&192|0)!=128){m=j;break L7}if(((o&255)<<6&4032|l<<12&61440|s&63)>>>0>f>>>0){m=j;break L7}n=j+3|0;break}if((k&255)>>>0>=245>>>0){m=j;break L7}t=j;if((g-t|0)<4){m=j;break L7}s=a[j+1|0]|0;o=a[j+2|0]|0;q=a[j+3|0]|0;if((l|0)==240){if((s+112&255)>>>0>=48>>>0){r=33;break L9}}else if((l|0)==244){if((s&-16)<<24>>24!=-128){r=35;break L9}}else{if((s&-64)<<24>>24!=-128){r=37;break L9}}u=o&255;if((u&192|0)!=128){m=j;break L7}o=q&255;if((o&192|0)!=128){m=j;break L7}if(((s&255)<<12&258048|l<<18&1835008|u<<6&4032|o&63)>>>0>f>>>0){m=j;break L7}n=j+4|0}}while(0);if(!(n>>>0<c>>>0&i>>>0<e>>>0)){m=n;break L7}i=i+1|0;j=n}if((r|0)==21){v=p-b|0;return v|0}else if((r|0)==25){v=p-b|0;return v|0}else if((r|0)==33){v=t-b|0;return v|0}else if((r|0)==35){v=t-b|0;return v|0}else if((r|0)==37){v=t-b|0;return v|0}else if((r|0)==23){v=p-b|0;return v|0}}else{m=h}}while(0);v=m-b|0;return v|0}function J2(a){a=a|0;return 4}function J3(a){a=a|0;DJ(a|0);Lw(a);return}function J4(a){a=a|0;DJ(a|0);Lw(a);return}function J5(a){a=a|0;c[a>>2]=14424;Eb(a+12|0);DJ(a|0);Lw(a);return}function J6(a){a=a|0;c[a>>2]=14424;Eb(a+12|0);DJ(a|0);return}function J7(a){a=a|0;c[a>>2]=14376;Eb(a+16|0);DJ(a|0);Lw(a);return}function J8(a){a=a|0;c[a>>2]=14376;Eb(a+16|0);DJ(a|0);return}function J9(b){b=b|0;return a[b+8|0]|0}function Ka(a){a=a|0;return c[a+8>>2]|0}function Kb(b){b=b|0;return a[b+9|0]|0}function Kc(a){a=a|0;return c[a+12>>2]|0}function Kd(a,b){a=a|0;b=b|0;D7(a,b+12|0);return}function Ke(a,b){a=a|0;b=b|0;D7(a,b+16|0);return}function Kf(a,b){a=a|0;b=b|0;D8(a,8792,4);return}function Kg(a,b){a=a|0;b=b|0;Em(a,8672,KW(8672)|0);return}function Kh(a,b){a=a|0;b=b|0;D8(a,8464,5);return}function Ki(a,b){a=a|0;b=b|0;Em(a,8360,KW(8360)|0);return}function Kj(b){b=b|0;var d=0;if((a[42400]|0)!=0){d=c[10200]|0;return d|0}if((bC(42400)|0)==0){d=c[10200]|0;return d|0}do{if((a[42288]|0)==0){if((bC(42288)|0)==0){break}LI(39840,0,168)|0;bn(452,0,t|0)|0}}while(0);z=0,aM(542,39840,11736)|0;do{if(!z){z=0,aM(542,39852,11648)|0;if(z){z=0;break}z=0,aM(542,39864,11544)|0;if(z){z=0;break}z=0,aM(542,39876,11480)|0;if(z){z=0;break}z=0,aM(542,39888,11432)|0;if(z){z=0;break}z=0,aM(542,39900,11400)|0;if(z){z=0;break}z=0,aM(542,39912,11280)|0;if(z){z=0;break}z=0,aM(542,39924,11232)|0;if(z){z=0;break}z=0,aM(542,39936,11200)|0;if(z){z=0;break}z=0,aM(542,39948,11152)|0;if(z){z=0;break}z=0,aM(542,39960,11120)|0;if(z){z=0;break}z=0,aM(542,39972,11072)|0;if(z){z=0;break}z=0,aM(542,39984,10984)|0;if(z){z=0;break}z=0,aM(542,39996,10944)|0;if(z){z=0;break}c[10200]=39840;d=c[10200]|0;return d|0}else{z=0}}while(0);d=bT(-1,-1)|0;bg(d|0);return 0}function Kk(b){b=b|0;var d=0;if((a[42344]|0)!=0){d=c[10178]|0;return d|0}if((bC(42344)|0)==0){d=c[10178]|0;return d|0}do{if((a[42264]|0)==0){if((bC(42264)|0)==0){break}LI(39096,0,168)|0;bn(548,0,t|0)|0}}while(0);z=0,aM(222,39096,13e3)|0;do{if(!z){z=0,aM(222,39108,12872)|0;if(z){z=0;break}z=0,aM(222,39120,12784)|0;if(z){z=0;break}z=0,aM(222,39132,12728)|0;if(z){z=0;break}z=0,aM(222,39144,12568)|0;if(z){z=0;break}z=0,aM(222,39156,12504)|0;if(z){z=0;break}z=0,aM(222,39168,12400)|0;if(z){z=0;break}z=0,aM(222,39180,12280)|0;if(z){z=0;break}z=0,aM(222,39192,12176)|0;if(z){z=0;break}z=0,aM(222,39204,12144)|0;if(z){z=0;break}z=0,aM(222,39216,12104)|0;if(z){z=0;break}z=0,aM(222,39228,11944)|0;if(z){z=0;break}z=0,aM(222,39240,11896)|0;if(z){z=0;break}z=0,aM(222,39252,11832)|0;if(z){z=0;break}c[10178]=39096;d=c[10178]|0;return d|0}else{z=0}}while(0);d=bT(-1,-1)|0;bg(d|0);return 0}function Kl(b){b=b|0;var d=0;if((a[42392]|0)!=0){d=c[10198]|0;return d|0}if((bC(42392)|0)==0){d=c[10198]|0;return d|0}do{if((a[42280]|0)==0){if((bC(42280)|0)==0){break}LI(39552,0,288)|0;bn(558,0,t|0)|0}}while(0);z=0,aM(542,39552,1248)|0;do{if(!z){z=0,aM(542,39564,1144)|0;if(z){z=0;break}z=0,aM(542,39576,1104)|0;if(z){z=0;break}z=0,aM(542,39588,1080)|0;if(z){z=0;break}z=0,aM(542,39600,1056)|0;if(z){z=0;break}z=0,aM(542,39612,960)|0;if(z){z=0;break}z=0,aM(542,39624,912)|0;if(z){z=0;break}z=0,aM(542,39636,872)|0;if(z){z=0;break}z=0,aM(542,39648,752)|0;if(z){z=0;break}z=0,aM(542,39660,656)|0;if(z){z=0;break}z=0,aM(542,39672,560)|0;if(z){z=0;break}z=0,aM(542,39684,480)|0;if(z){z=0;break}z=0,aM(542,39696,424)|0;if(z){z=0;break}z=0,aM(542,39708,376)|0;if(z){z=0;break}z=0,aM(542,39720,328)|0;if(z){z=0;break}z=0,aM(542,39732,208)|0;if(z){z=0;break}z=0,aM(542,39744,1056)|0;if(z){z=0;break}z=0,aM(542,39756,160)|0;if(z){z=0;break}z=0,aM(542,39768,96)|0;if(z){z=0;break}z=0,aM(542,39780,13296)|0;if(z){z=0;break}z=0,aM(542,39792,13264)|0;if(z){z=0;break}z=0,aM(542,39804,13184)|0;if(z){z=0;break}z=0,aM(542,39816,13144)|0;if(z){z=0;break}z=0,aM(542,39828,13096)|0;if(z){z=0;break}c[10198]=39552;d=c[10198]|0;return d|0}else{z=0}}while(0);d=bT(-1,-1)|0;bg(d|0);return 0}function Km(b){b=b|0;var d=0;if((a[42336]|0)!=0){d=c[10176]|0;return d|0}if((bC(42336)|0)==0){d=c[10176]|0;return d|0}do{if((a[42256]|0)==0){if((bC(42256)|0)==0){break}LI(38808,0,288)|0;bn(84,0,t|0)|0}}while(0);z=0,aM(222,38808,4040)|0;do{if(!z){z=0,aM(222,38820,3872)|0;if(z){z=0;break}z=0,aM(222,38832,3760)|0;if(z){z=0;break}z=0,aM(222,38844,3640)|0;if(z){z=0;break}z=0,aM(222,38856,1984)|0;if(z){z=0;break}z=0,aM(222,38868,3408)|0;if(z){z=0;break}z=0,aM(222,38880,3208)|0;if(z){z=0;break}z=0,aM(222,38892,3088)|0;if(z){z=0;break}z=0,aM(222,38904,2944)|0;if(z){z=0;break}z=0,aM(222,38916,2832)|0;if(z){z=0;break}z=0,aM(222,38928,2712)|0;if(z){z=0;break}z=0,aM(222,38940,2576)|0;if(z){z=0;break}z=0,aM(222,38952,2472)|0;if(z){z=0;break}z=0,aM(222,38964,2256)|0;if(z){z=0;break}z=0,aM(222,38976,2192)|0;if(z){z=0;break}z=0,aM(222,38988,2104)|0;if(z){z=0;break}z=0,aM(222,39e3,1984)|0;if(z){z=0;break}z=0,aM(222,39012,1896)|0;if(z){z=0;break}z=0,aM(222,39024,1816)|0;if(z){z=0;break}z=0,aM(222,39036,1768)|0;if(z){z=0;break}z=0,aM(222,39048,1680)|0;if(z){z=0;break}z=0,aM(222,39060,1608)|0;if(z){z=0;break}z=0,aM(222,39072,1552)|0;if(z){z=0;break}z=0,aM(222,39084,1472)|0;if(z){z=0;break}c[10176]=38808;d=c[10176]|0;return d|0}else{z=0}}while(0);d=bT(-1,-1)|0;bg(d|0);return 0}function Kn(b){b=b|0;var d=0,e=0,f=0;if((a[42408]|0)!=0){d=c[10202]|0;return d|0}if((bC(42408)|0)==0){d=c[10202]|0;return d|0}do{if((a[42296]|0)==0){if((bC(42296)|0)==0){break}LI(40008,0,288)|0;bn(82,0,t|0)|0}}while(0);z=0,aM(542,40008,4512)|0;if(z){z=0;e=bT(-1,-1)|0;f=M;bg(e|0)}z=0,aM(542,40020,4392)|0;if(z){z=0;e=bT(-1,-1)|0;f=M;bg(e|0)}c[10202]=40008;d=c[10202]|0;return d|0}
function yQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;g=i;i=i+8|0;h=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[h>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];h=g|0;c[b>>2]=d;d=b+4|0;j=d|0;k=b+8|0;l=b+12|0;m=b+28|0;n=e;LI(d|0,0,24)|0;L1:do{if((a[n]&1)==0){o=m;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];p=0;q=0;r=11}else{o=c[e+8>>2]|0;s=c[e+4>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(s>>>0<11>>>0){a[m]=s<<1;t=m+1|0}else{u=s+16&-16;v=(z=0,au(248,u|0)|0);if(z){z=0;break}c[b+36>>2]=v;c[m>>2]=u|1;c[b+32>>2]=s;t=v}LF(t|0,o|0,s)|0;a[t+s|0]=0;p=c[k>>2]|0;q=c[l>>2]|0;r=11;break L1}}while(0);s=bT(-1,-1)|0;w=M;x=s}}while(0);do{if((r|0)==11){c[b+40>>2]=1;l=b+44|0;t=f;c[l>>2]=c[t>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[b+56>>2]=0;c[b+60>>2]=0;c[h>>2]=0;if((p|0)==(q|0)){z=0;as(72,d|0,h|0);if(!z){i=g;return}else{z=0}t=bT(-1,-1)|0;l=t;t=M;if((a[m]&1)==0){w=t;x=l;break}Lw(c[b+36>>2]|0);w=t;x=l;break}else{if((p|0)==0){y=0}else{c[p>>2]=0;y=c[k>>2]|0}c[k>>2]=y+4;i=g;return}}}while(0);g=c[j>>2]|0;if((g|0)==0){A=x;B=0;C=A;D=w;bg(C|0)}j=c[k>>2]|0;if((g|0)!=(j|0)){c[k>>2]=j+(~((j-4+(-g|0)|0)>>>2)<<2)}Lw(g);A=x;B=0;C=A;D=w;bg(C|0)}function yR(b){b=b|0;var c=0,d=0,e=0,f=0;c=(a6(a[b]|0)|0)==0;d=c?0:b+1|0;if((d|0)==0){e=0;return e|0}else{f=d}while(1){d=(a6(a[f]|0)|0)==0;b=d?0:f+1|0;if((b|0)==0){e=f;break}else{f=b}}return e|0}function yS(b){b=b|0;var c=0,d=0,e=0;c=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((c|0)==0){d=0;return d|0}else{e=c}while(1){c=((a[e]|0)-48|0)>>>0<10>>>0?e+1|0:0;if((c|0)==0){d=e;break}else{e=c}}return d|0}function yT(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a[37152]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37152;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);c=e<<24>>24!=0?0:d;if((c|0)==0){l=0;return l|0}else{m=c}while(1){c=a[m]|0;if((c<<24>>24|0)==10|(c<<24>>24|0)==0){l=m;break}m=m+1|0}return l|0}function yU(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37152]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37152;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yV(a){a=a|0;return yW(a)|0}function yW(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=(a6(a[b]|0)|0)==0;d=c?0:b+1|0;if((d|0)==0){e=0}else{c=d;while(1){d=(a6(a[c]|0)|0)==0;f=d?0:c+1|0;if((f|0)==0){e=c;break}else{c=f}}}c=(e|0)!=0?e:b;if((c|0)==0){g=0;return g|0}b=a[37248]|0;L8:do{if(b<<24>>24==0){h=c;i=0}else{e=c;f=37248;d=b;while(1){if((a[e]|0)!=d<<24>>24){h=e;i=d;break L8}j=e+1|0;k=f+1|0;l=a[k]|0;if(l<<24>>24==0){h=j;i=0;break}else{e=j;f=k;d=l}}}}while(0);b=i<<24>>24!=0?0:h;if((b|0)==0){g=0;return g|0}h=a[37232]|0;if(h<<24>>24==0){i=b;while(1){if((a[i]|0)==0){g=0;m=17;break}if((i|0)==0){i=i+1|0}else{g=i;m=18;break}}if((m|0)==17){return g|0}else if((m|0)==18){return g|0}}else{n=b}while(1){b=a[n]|0;if(b<<24>>24==0){g=0;m=19;break}L26:do{if(b<<24>>24==h<<24>>24){i=37232;c=n;while(1){d=c+1|0;f=i+1|0;e=a[f]|0;if(e<<24>>24==0){o=d;p=0;break L26}if((a[d]|0)==e<<24>>24){i=f;c=d}else{o=d;p=e;break}}}else{o=n;p=h}}while(0);b=p<<24>>24!=0?0:o;if((b|0)==0){n=n+1|0}else{g=b;m=20;break}}if((m|0)==19){return g|0}else if((m|0)==20){return g|0}return 0}function yX(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37248]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37248;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yY(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a[b]|0;d=b+1|0;b=c<<24>>24==34?d:0;L1:do{if((b|0)!=0){e=a[b]|0;if(e<<24>>24==0){break}else{f=b;g=e}while(1){e=f+1|0;h=g<<24>>24==34?e:0;if((h|0)==0){i=e}else{if((a[f-1|0]|0)==92){i=h}else{j=h;break}}h=a[i]|0;if(h<<24>>24==0){break L1}else{f=i;g=h}}return j|0}}while(0);g=c<<24>>24==39?d:0;if((g|0)==0){j=0;return j|0}d=a[g]|0;if(d<<24>>24==0){j=0;return j|0}else{k=g;l=d}while(1){d=k+1|0;g=l<<24>>24==39?d:0;if((g|0)==0){m=d}else{if((a[k-1|0]|0)==92){m=g}else{j=g;n=12;break}}g=a[m]|0;if(g<<24>>24==0){j=0;n=15;break}else{k=m;l=g}}if((n|0)==12){return j|0}else if((n|0)==15){return j|0}return 0}function yZ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a[37176]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37176;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);c=e<<24>>24!=0?0:d;if((c|0)==0){l=0;return l|0}d=a[36840]|0;if(d<<24>>24==0){e=c;while(1){if((a[e]|0)==0){l=0;m=15;break}if((e|0)==0){e=e+1|0}else{l=e;m=16;break}}if((m|0)==15){return l|0}else if((m|0)==16){return l|0}}else{n=c}while(1){c=a[n]|0;if(c<<24>>24==0){l=0;m=17;break}L19:do{if(c<<24>>24==d<<24>>24){e=36840;b=n;while(1){h=b+1|0;g=e+1|0;f=a[g]|0;if(f<<24>>24==0){o=h;p=0;break L19}if((a[h]|0)==f<<24>>24){e=g;b=h}else{o=h;p=f;break}}}else{o=n;p=d}}while(0);c=p<<24>>24!=0?0:o;if((c|0)==0){n=n+1|0}else{l=c;m=18;break}}if((m|0)==17){return l|0}else if((m|0)==18){return l|0}return 0}function y_(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a6(a[b]|0)|0)==0;d=c?0:b+1|0;if((d|0)==0){e=0;f=(e|0)!=0;g=f?e:b;return g|0}else{h=d}while(1){d=(a6(a[h]|0)|0)==0;c=d?0:h+1|0;if((c|0)==0){e=h;break}else{h=c}}f=(e|0)!=0;g=f?e:b;return g|0}function y$(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=(a6(a[b]|0)|0)==0;d=c?0:b+1|0;do{if((d|0)==0){c=yW(b)|0;if((c|0)!=0){e=c;break}c=a[37152]|0;L6:do{if(c<<24>>24==0){f=b;g=0}else{h=b;i=37152;j=c;while(1){if((a[h]|0)!=j<<24>>24){f=h;g=j;break L6}k=h+1|0;l=i+1|0;m=a[l]|0;if(m<<24>>24==0){f=k;g=0;break}else{h=k;i=l;j=m}}}}while(0);c=g<<24>>24!=0?0:f;if((c|0)==0){n=b;return n|0}else{o=c}while(1){c=a[o]|0;if((c<<24>>24|0)==10|(c<<24>>24|0)==0){break}o=o+1|0}if((o|0)==0){n=b}else{e=o;break}return n|0}else{c=d;while(1){j=(a6(a[c]|0)|0)==0;i=j?0:c+1|0;if((i|0)==0){e=c;break}else{c=i}}}}while(0);d=a[37152]|0;if(d<<24>>24==0){o=e;L20:while(1){b=(a6(a[o]|0)|0)==0;f=b?0:o+1|0;if((f|0)!=0){b=f;while(1){f=(a6(a[b]|0)|0)==0;g=f?0:b+1|0;if((g|0)==0){o=b;continue L20}else{b=g}}}b=yW(o)|0;if((b|0)!=0){o=b;continue}if((o|0)==0){n=0;p=31;break}else{q=o}while(1){b=a[q]|0;if((b<<24>>24|0)==10|(b<<24>>24|0)==0){break}q=q+1|0}if((q|0)==0){n=o;p=32;break}else{o=q}}if((p|0)==31){return n|0}else if((p|0)==32){return n|0}}else{r=e}L34:while(1){e=(a6(a[r]|0)|0)==0;q=e?0:r+1|0;if((q|0)!=0){e=q;while(1){q=(a6(a[e]|0)|0)==0;o=q?0:e+1|0;if((o|0)==0){r=e;continue L34}else{e=o}}}e=yW(r)|0;if((e|0)==0){s=r;t=37152;u=d}else{r=e;continue}while(1){if((a[s]|0)!=u<<24>>24){v=s;w=u;break}e=s+1|0;o=t+1|0;q=a[o]|0;if(q<<24>>24==0){v=e;w=0;break}else{s=e;t=o;u=q}}q=w<<24>>24!=0?0:v;if((q|0)==0){n=r;p=33;break}else{x=q}while(1){q=a[x]|0;if((q<<24>>24|0)==10|(q<<24>>24|0)==0){break}x=x+1|0}if((x|0)==0){n=r;p=34;break}else{r=x}}if((p|0)==33){return n|0}else if((p|0)==34){return n|0}return 0}function y0(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=(a[b]|0)==45?b+1|0:0;d=(c|0)!=0?c:b;if((d|0)==0){e=0;return e|0}do{if((bS(a[d]|0)|0)==0){b=a[d]|0;if(b<<24>>24<0){f=5;break}g=b;h=d+1|0;f=7}else{f=5}}while(0);do{if((f|0)==5){b=d+1|0;if((b|0)!=0){i=b;break}g=a[d]|0;h=0;f=7}}while(0);do{if((f|0)==7){d=g<<24>>24==95?h:0;if((d|0)!=0){i=d;break}d=g<<24>>24==92?h:0;if((d|0)==0){e=0;return e|0}b=(a[d]|0)!=0?d+1|0:d;if((b|0)==0){e=0}else{i=b;break}return e|0}}while(0);e=Ab(i)|0;return e|0}function y1(a){a=a|0;var b=0,c=0,d=0;b=z9(a)|0;if((b|0)==0){c=0;return c|0}else{d=b}while(1){b=z9(d)|0;if((b|0)==0){c=d;break}else{d=b}}return c|0}function y2(a){a=a|0;var b=0,c=0,d=0;b=z7(a)|0;if((b|0)==0){c=0;return c|0}else{d=b}while(1){b=z7(d)|0;if((b|0)==0){c=d;break}else{d=b}}return c|0}function y3(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=(a[b]|0)==64?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==45?c+1|0:0;e=(b|0)!=0?b:c;if((e|0)==0){d=0;return d|0}do{if((bS(a[e]|0)|0)==0){c=a[e]|0;if(c<<24>>24<0){f=6;break}g=c;h=e+1|0;f=8}else{f=6}}while(0);do{if((f|0)==6){c=e+1|0;if((c|0)!=0){i=c;break}g=a[e]|0;h=0;f=8}}while(0);do{if((f|0)==8){e=g<<24>>24==95?h:0;if((e|0)!=0){i=e;break}e=g<<24>>24==92?h:0;if((e|0)==0){d=0;return d|0}c=(a[e]|0)!=0?e+1|0:e;if((c|0)==0){d=0}else{i=c;break}return d|0}}while(0);d=Ab(i)|0;return d|0}function y4(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37288]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37288;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function y5(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36688]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36688;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function y6(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36680]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36680;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function y7(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37064]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37064;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function y8(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37264]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37264;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function y9(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37160]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37160;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function za(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37192]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37192;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zb(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37296]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37296;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zc(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36864]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36864;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zd(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36760]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36760;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function ze(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36816]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36816;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zf(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36744]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36744;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zg(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36832]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36832;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zh(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37144]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37144;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zi(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36776]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36776;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zj(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36856]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36856;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zk(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36656]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36656;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zl(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36704]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36704;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zm(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36736]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36736;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zn(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=11}else{do{if((bS(a[e]|0)|0)==0){d=a[e]|0;if(d<<24>>24<0){f=5;break}g=d;h=e+1|0;f=7}else{f=5}}while(0);do{if((f|0)==5){d=e+1|0;if((d|0)!=0){i=d;break}g=a[e]|0;h=0;f=7}}while(0);do{if((f|0)==7){d=g<<24>>24==95?h:0;if((d|0)!=0){i=d;break}d=g<<24>>24==92?h:0;if((d|0)==0){f=11;break L1}j=(a[d]|0)!=0?d+1|0:d;if((j|0)==0){f=11;break L1}else{i=j}}}while(0);j=Ab(i)|0;if((j|0)==0){f=11}else{k=j}}}while(0);if((f|0)==11){k=(a[b]|0)==42?c:0}c=(k|0)!=0?k:b;if((c|0)==0){l=0;return l|0}l=(a[c]|0)==124?c+1|0:0;return l|0}function zo(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=zn(b)|0;d=(c|0)!=0?c:b;if((d|0)==0){e=0;return e|0}b=(a[d]|0)==45?d+1|0:0;c=(b|0)!=0?b:d;if((c|0)==0){e=0;return e|0}do{if((bS(a[c]|0)|0)==0){d=a[c]|0;if(d<<24>>24<0){f=6;break}g=d;h=c+1|0;f=8}else{f=6}}while(0);do{if((f|0)==6){d=c+1|0;if((d|0)!=0){i=d;break}g=a[c]|0;h=0;f=8}}while(0);do{if((f|0)==8){c=g<<24>>24==95?h:0;if((c|0)!=0){i=c;break}c=g<<24>>24==92?h:0;if((c|0)==0){e=0;return e|0}d=(a[c]|0)!=0?c+1|0:c;if((d|0)==0){e=0}else{i=d;break}return e|0}}while(0);e=Ab(i)|0;return e|0}function zp(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[b]|0;d=c<<24>>24==45?b+1|0:0;if((d|0)==0){e=b;f=c}else{c=d;while(1){d=a[c]|0;b=d<<24>>24==45?c+1|0:0;if((b|0)==0){e=c;f=d;break}else{c=b}}}c=f<<24>>24==45?e+1|0:0;f=(c|0)!=0?c:e;if((f|0)==0){g=0;return g|0}do{if((bS(a[f]|0)|0)==0){e=a[f]|0;if(e<<24>>24<0){h=7;break}i=e;j=f+1|0;h=9}else{h=7}}while(0);do{if((h|0)==7){e=f+1|0;if((e|0)!=0){k=e;break}i=a[f]|0;j=0;h=9}}while(0);do{if((h|0)==9){f=i<<24>>24==95?j:0;if((f|0)!=0){k=f;break}f=i<<24>>24==92?j:0;if((f|0)==0){g=0;return g|0}e=(a[f]|0)!=0?f+1|0:f;if((e|0)==0){g=0}else{k=e;break}return g|0}}while(0);g=Ab(k)|0;return g|0}function zq(b){b=b|0;var c=0,d=0,e=0;c=zn(b)|0;d=(c|0)!=0?c:b;if((d|0)==0){e=0;return e|0}e=(a[d]|0)==42?d+1|0:0;return e|0}function zr(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=(a[b]|0)==35?b+1|0:0;if((c|0)==0){d=0;return d|0}do{if((bR(a[c]|0)|0)==0){b=a[c]|0;if(b<<24>>24<0){e=5;break}f=b;g=c+1|0;e=7}else{e=5}}while(0);do{if((e|0)==5){b=c+1|0;if((b|0)!=0){h=b;break}f=a[c]|0;g=0;e=7}}while(0);do{if((e|0)==7){c=f<<24>>24==45?g:0;if((c|0)!=0){h=c;break}c=f<<24>>24==95?g:0;if((c|0)==0){d=0}else{h=c;break}return d|0}}while(0);while(1){do{if((bR(a[h]|0)|0)==0){g=a[h]|0;if(g<<24>>24<0){e=12;break}i=g;j=h+1|0}else{e=12}}while(0);if((e|0)==12){e=0;g=h+1|0;if((g|0)!=0){h=g;continue}i=a[h]|0;j=0}g=i<<24>>24==45?j:0;if((g|0)!=0){h=g;continue}g=i<<24>>24==95?j:0;if((g|0)==0){d=h;break}else{h=g}}return d|0}function zs(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=(a[b]|0)==46?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==45?c+1|0:0;e=(b|0)!=0?b:c;if((e|0)==0){d=0;return d|0}do{if((bS(a[e]|0)|0)==0){c=a[e]|0;if(c<<24>>24<0){f=6;break}g=c;h=e+1|0;f=8}else{f=6}}while(0);do{if((f|0)==6){c=e+1|0;if((c|0)!=0){i=c;break}g=a[e]|0;h=0;f=8}}while(0);do{if((f|0)==8){e=g<<24>>24==95?h:0;if((e|0)!=0){i=e;break}e=g<<24>>24==92?h:0;if((e|0)==0){d=0;return d|0}c=(a[e]|0)!=0?e+1|0:e;if((c|0)==0){d=0}else{i=c;break}return d|0}}while(0);d=Ab(i)|0;return d|0}function zt(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=zn(b)|0;d=(c|0)!=0?c:b;L1:do{if((d|0)!=0){c=(a[d]|0)==45?d+1|0:0;e=(c|0)!=0?c:d;if((e|0)==0){break}do{if((bS(a[e]|0)|0)==0){c=a[e]|0;if(c<<24>>24<0){f=6;break}g=c;h=e+1|0;f=8}else{f=6}}while(0);do{if((f|0)==6){c=e+1|0;if((c|0)!=0){i=c;break}g=a[e]|0;h=0;f=8}}while(0);do{if((f|0)==8){e=g<<24>>24==95?h:0;if((e|0)!=0){i=e;break}e=g<<24>>24==92?h:0;if((e|0)==0){break L1}c=(a[e]|0)!=0?e+1|0:e;if((c|0)==0){break L1}else{i=c}}}while(0);c=Ab(i)|0;if((c|0)==0){break}else{j=c}return j|0}}while(0);i=(a[b]|0)==45?b+1|0:0;h=(i|0)!=0?i:b;if((h|0)==0){j=0;return j|0}do{if((bS(a[h]|0)|0)==0){b=a[h]|0;if(b<<24>>24<0){f=16;break}k=b;l=h+1|0;f=18}else{f=16}}while(0);do{if((f|0)==16){b=h+1|0;if((b|0)!=0){m=b;break}k=a[h]|0;l=0;f=18}}while(0);do{if((f|0)==18){h=k<<24>>24==95?l:0;if((h|0)!=0){m=h;break}h=k<<24>>24==92?l:0;if((h|0)==0){j=0;return j|0}b=(a[h]|0)!=0?h+1|0:h;if((b|0)==0){j=0}else{m=b;break}return j|0}}while(0);j=Ab(m)|0;return j|0}function zu(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=(a[b]|0)==37?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==45?c+1|0:0;e=(b|0)!=0?b:c;if((e|0)==0){d=0;return d|0}do{if((bS(a[e]|0)|0)==0){c=a[e]|0;if(c<<24>>24<0){f=6;break}g=c;h=e+1|0;f=8}else{f=6}}while(0);do{if((f|0)==6){c=e+1|0;if((c|0)!=0){i=c;break}g=a[e]|0;h=0;f=8}}while(0);do{if((f|0)==8){e=g<<24>>24==95?h:0;if((e|0)!=0){i=e;break}e=g<<24>>24==92?h:0;if((e|0)==0){d=0;return d|0}c=(a[e]|0)!=0?e+1|0:e;if((c|0)==0){d=0}else{i=c;break}return d|0}}while(0);d=Ab(i)|0;return d|0}function zv(b){b=b|0;var c=0,d=0,e=0;c=37256;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}return(e?0:b+1|0)|0}function zw(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=37256;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=a[e]|0;c=((b<<24>>24)-48|0)>>>0<10>>>0?e+1|0:0;d=(c|0)==0;if(d){g=e;h=b}else{b=c;while(1){e=a[b]|0;i=((e<<24>>24)-48|0)>>>0<10>>>0?b+1|0:0;if((i|0)==0){g=b;h=e;break}else{b=i}}}b=h<<24>>24==46?g+1|0:0;do{if((b|0)!=0){g=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((g|0)==0){break}else{j=g}while(1){g=((a[j]|0)-48|0)>>>0<10>>>0?j+1|0:0;if((g|0)==0){f=j;break}else{j=g}}return f|0}}while(0);if(d){f=0;return f|0}else{k=c}while(1){c=((a[k]|0)-48|0)>>>0<10>>>0?k+1|0:0;if((c|0)==0){f=k;break}else{k=c}}return f|0}function zx(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=37256;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=b+1|0;d=e?0:c;e=(d|0)!=0?d:b;do{if((e|0)==0){f=37256}else{d=((a[e]|0)-48|0)>>>0<10>>>0?e+1|0:0;if((d|0)==0){f=37256;break}else{g=d}while(1){d=((a[g]|0)-48|0)>>>0<10>>>0?g+1|0:0;if((d|0)==0){h=g;break}else{g=d}}return h|0}}while(0);while(1){g=a[f]|0;if(g<<24>>24==0){h=0;i=11;break}if((a[b]|0)==g<<24>>24){h=c;i=12;break}else{f=f+1|0}}if((i|0)==11){return h|0}else if((i|0)==12){return h|0}return 0}function zy(a){a=a|0;return zz(a)|0}function zz(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=37256;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=((a[e]|0)-48|0)>>>0<10>>>0?e+1|0:0;if((b|0)==0){g=0}else{c=b;while(1){b=((a[c]|0)-48|0)>>>0<10>>>0?c+1|0:0;if((b|0)==0){g=c;break}else{c=b}}}c=(g|0)!=0?g:e;if((c|0)==0){f=0;return f|0}e=(a[c]|0)==110?c+1|0:0;if((e|0)==0){f=0;return f|0}c=(a6(a[e]|0)|0)==0;g=c?0:e+1|0;if((g|0)==0){h=0}else{c=g;while(1){g=(a6(a[c]|0)|0)==0;b=g?0:c+1|0;if((b|0)==0){h=c;break}else{c=b}}}c=(h|0)!=0?h:e;if((c|0)==0){f=0;return f|0}else{i=37256}while(1){e=a[i]|0;if(e<<24>>24==0){j=1;break}if((a[c]|0)==e<<24>>24){j=0;break}else{i=i+1|0}}i=j?0:c+1|0;if((i|0)==0){f=0;return f|0}c=(a6(a[i]|0)|0)==0;j=c?0:i+1|0;if((j|0)==0){k=0}else{c=j;while(1){j=(a6(a[c]|0)|0)==0;e=j?0:c+1|0;if((e|0)==0){k=c;break}else{c=e}}}c=(k|0)!=0?k:i;if((c|0)==0){f=0;return f|0}i=((a[c]|0)-48|0)>>>0<10>>>0?c+1|0:0;if((i|0)==0){f=0;return f|0}else{l=i}while(1){i=((a[l]|0)-48|0)>>>0<10>>>0?l+1|0:0;if((i|0)==0){f=l;break}else{l=i}}return f|0}function zA(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=37256;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=a[e]|0;c=((b<<24>>24)-48|0)>>>0<10>>>0?e+1|0:0;d=(c|0)==0;if(d){g=e;h=b}else{b=c;while(1){e=a[b]|0;i=((e<<24>>24)-48|0)>>>0<10>>>0?b+1|0:0;if((i|0)==0){g=b;h=e;break}else{b=i}}}b=h<<24>>24==46?g+1|0:0;do{if((b|0)==0){j=10}else{g=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((g|0)==0){j=10;break}else{k=g}while(1){g=a[k]|0;h=((g<<24>>24)-48|0)>>>0<10>>>0?k+1|0:0;if((h|0)==0){l=k;m=g;break}else{k=h}}}}while(0);if((j|0)==10){if(d){f=0;return f|0}else{d=c;while(1){c=a[d]|0;j=((c<<24>>24)-48|0)>>>0<10>>>0?d+1|0:0;if((j|0)==0){l=d;m=c;break}else{d=j}}}}f=m<<24>>24==37?l+1|0:0;return f|0}function zB(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=37256;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=a[e]|0;c=((b<<24>>24)-48|0)>>>0<10>>>0?e+1|0:0;d=(c|0)==0;if(d){g=e;h=b}else{b=c;while(1){e=a[b]|0;i=((e<<24>>24)-48|0)>>>0<10>>>0?b+1|0:0;if((i|0)==0){g=b;h=e;break}else{b=i}}}b=h<<24>>24==46?g+1|0:0;do{if((b|0)==0){j=10}else{g=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((g|0)==0){j=10;break}else{k=g}while(1){g=a[k]|0;h=((g<<24>>24)-48|0)>>>0<10>>>0?k+1|0:0;if((h|0)==0){l=k;m=g;break}else{k=h}}}}while(0);if((j|0)==10){if(d){f=0;return f|0}else{d=c;while(1){c=a[d]|0;k=((c<<24>>24)-48|0)>>>0<10>>>0?d+1|0:0;if((k|0)==0){l=d;m=c;break}else{d=k}}}}d=m<<24>>24==45?l+1|0:0;m=(d|0)!=0?d:l;if((m|0)==0){f=0;return f|0}do{if((bS(a[m]|0)|0)==0){l=a[m]|0;if(l<<24>>24<0){j=16;break}n=l;o=m+1|0;j=18}else{j=16}}while(0);do{if((j|0)==16){l=m+1|0;if((l|0)!=0){p=l;break}n=a[m]|0;o=0;j=18}}while(0);do{if((j|0)==18){m=n<<24>>24==95?o:0;if((m|0)!=0){p=m;break}m=n<<24>>24==92?o:0;if((m|0)==0){f=0;return f|0}l=(a[m]|0)!=0?m+1|0:m;if((l|0)==0){f=0}else{p=l;break}return f|0}}while(0);f=Ab(p)|0;return f|0}function zC(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=(a[b]|0)==35?b+1|0:0;do{if((c|0)==0){d=0}else{e=(br(a[c]|0)|0)==0;f=e?0:c+1|0;if((f|0)==0){d=0;break}else{g=f}while(1){f=(br(a[g]|0)|0)==0;e=f?0:g+1|0;if((e|0)==0){d=g;break}else{g=e}}}}while(0);g=d-b|0;return((g|0)!=4&(g|0)!=7?0:d)|0}function zD(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36792]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36792;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zE(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(a[b]|0)==33?b+1|0:0;if((c|0)==0){d=0;return d|0}b=y$(c)|0;if((b|0)==0){d=0;return d|0}c=a[37024]|0;L7:do{if(c<<24>>24==0){e=b;f=0}else{g=b;h=37024;i=c;while(1){if((a[g]|0)!=i<<24>>24){e=g;f=i;break L7}j=g+1|0;k=h+1|0;l=a[k]|0;if(l<<24>>24==0){e=j;f=0;break}else{g=j;h=k;i=l}}}}while(0);d=f<<24>>24!=0?0:e;return d|0}function zF(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(a[b]|0)==33?b+1|0:0;if((c|0)==0){d=0;return d|0}b=y$(c)|0;if((b|0)==0){d=0;return d|0}c=a[37184]|0;L7:do{if(c<<24>>24==0){e=b;f=0}else{g=b;h=37184;i=c;while(1){if((a[g]|0)!=i<<24>>24){e=g;f=i;break L7}j=g+1|0;k=h+1|0;l=a[k]|0;if(l<<24>>24==0){e=j;f=0;break}else{g=j;h=k;i=l}}}}while(0);d=f<<24>>24!=0?0:e;return d|0}function zG(b){b=b|0;var c=0,d=0;c=(a[b]|0)==58?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==58?c+1|0:0;d=(b|0)!=0?b:c;return d|0}function zH(b){b=b|0;var c=0,d=0,e=0;c=z9(b)|0;if((c|0)==0){d=0;return d|0}else{e=c}while(1){c=z9(e)|0;if((c|0)==0){break}else{e=c}}d=(a[e]|0)==40?e+1|0:0;return d|0}function zI(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=(a[b]|0)==45?b+1|0:0;d=(c|0)!=0?c:b;if((d|0)==0){e=0;return e|0}do{if((bS(a[d]|0)|0)==0){b=a[d]|0;if(b<<24>>24<0){f=5;break}g=b;h=d+1|0;f=7}else{f=5}}while(0);do{if((f|0)==5){b=d+1|0;if((b|0)!=0){i=b;break}g=a[d]|0;h=0;f=7}}while(0);do{if((f|0)==7){d=g<<24>>24==95?h:0;if((d|0)!=0){i=d;break}d=g<<24>>24==92?h:0;if((d|0)==0){e=0;return e|0}b=(a[d]|0)!=0?d+1|0:d;if((b|0)==0){e=0}else{i=b;break}return e|0}}while(0);h=Ab(i)|0;if((h|0)==0){e=0;return e|0}e=(a[h]|0)==40?h+1|0:0;return e|0}function zJ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36968]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36968;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zK(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36752]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36752;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zL(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36800]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36800;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zM(b){b=b|0;return((a[b]|0)==61?b+1|0:0)|0}function zN(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37136]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37136;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zO(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37280]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37280;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zP(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37224]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37224;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zQ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37088]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37088;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zR(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[37240]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=37240;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zS(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=(a[b]|0)==36?b+1|0:0;if((c|0)==0){d=0;return d|0}do{if((bR(a[c]|0)|0)==0){b=a[c]|0;if(b<<24>>24<0){e=5;break}f=b;g=c+1|0;e=7}else{e=5}}while(0);do{if((e|0)==5){b=c+1|0;if((b|0)!=0){h=b;break}f=a[c]|0;g=0;e=7}}while(0);do{if((e|0)==7){c=f<<24>>24==45?g:0;if((c|0)!=0){h=c;break}c=f<<24>>24==95?g:0;if((c|0)==0){d=0}else{h=c;break}return d|0}}while(0);while(1){do{if((bR(a[h]|0)|0)==0){g=a[h]|0;if(g<<24>>24<0){e=12;break}i=g;j=h+1|0}else{e=12}}while(0);if((e|0)==12){e=0;g=h+1|0;if((g|0)!=0){h=g;continue}i=a[h]|0;j=0}g=i<<24>>24==45?j:0;if((g|0)!=0){h=g;continue}g=i<<24>>24==95?j:0;if((g|0)==0){d=h;break}else{h=g}}return d|0}function zT(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36712]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36712;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zU(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36696]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36696;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zV(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36824]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36824;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zW(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36848]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36848;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zX(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36912]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36912;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zY(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36872]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36872;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function zZ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36904]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36904;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function z_(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36888]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36888;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function z$(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36896]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36896;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function z0(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[36880]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36880;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function z1(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a[36976]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=36976;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);c=e<<24>>24!=0?0:d;L6:do{if((c|0)==0){d=a[37272]|0;L8:do{if(d<<24>>24==0){l=b;m=0}else{e=b;h=37272;g=d;while(1){if((a[e]|0)!=g<<24>>24){l=e;m=g;break L8}f=e+1|0;k=h+1|0;j=a[k]|0;if(j<<24>>24==0){l=f;m=0;break}else{e=f;h=k;g=j}}}}while(0);d=m<<24>>24!=0?0:l;if((d|0)==0){n=0;return n|0}g=(a[d]|0)==58?d+1|0:0;if((g|0)==0){n=0;return n|0}d=z6(g)|0;if((d|0)==0){n=0;return n|0}g=(a[d]|0)==46?d+1|0:0;if((g|0)==0){n=0;return n|0}d=z6(g)|0;if((d|0)==0){n=0;return n|0}else{o=d}while(1){d=(a[o]|0)==46?o+1|0:0;if((d|0)==0){p=o;break L6}g=z6(d)|0;if((g|0)==0){break}else{o=g}}if((o|0)==0){n=0}else{p=o;break}return n|0}else{p=c}}while(0);c=(a[p]|0)==40?p+1|0:0;if((c|0)==0){n=0;return n|0}p=a[c]|0;if(p<<24>>24==0){n=0;return n|0}else{q=c;r=p}while(1){p=q+1|0;c=r<<24>>24==59?p:0;if((c|0)==0){s=p}else{if((a[q-1|0]|0)==92){s=c}else{n=c;t=23;break}}c=a[s]|0;if(c<<24>>24==0){n=0;t=30;break}else{q=s;r=c}}if((t|0)==23){return n|0}else if((t|0)==30){return n|0}return 0}function z2(a){a=a|0;return z3(a)|0}function z3(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=zS(b)|0;L1:do{if((c|0)==0){d=z9(b)|0;if((d|0)!=0){e=d;while(1){d=z9(e)|0;if((d|0)==0){f=e;break L1}else{e=d}}}e=(a[b]|0)==45?b+1|0:0;d=(e|0)!=0?e:b;if((d|0)==0){g=0;return g|0}do{if((bS(a[d]|0)|0)==0){e=a[d]|0;if(e<<24>>24<0){h=8;break}i=e;j=d+1|0;h=10}else{h=8}}while(0);do{if((h|0)==8){e=d+1|0;if((e|0)!=0){k=e;break}i=a[d]|0;j=0;h=10}}while(0);do{if((h|0)==10){d=i<<24>>24==95?j:0;if((d|0)!=0){k=d;break}d=i<<24>>24==92?j:0;if((d|0)==0){g=0;return g|0}e=(a[d]|0)!=0?d+1|0:d;if((e|0)==0){g=0}else{k=e;break}return g|0}}while(0);e=Ab(k)|0;if((e|0)==0){g=0}else{f=e;break}return g|0}else{f=c}}while(0);c=y$(f)|0;if((c|0)==0){g=0;return g|0}f=(a[c]|0)==61?c+1|0:0;if((f|0)==0){g=0;return g|0}c=y$(f)|0;if((c|0)==0){g=0;return g|0}g=z5(c)|0;return g|0}function z4(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=(a6(a[b]|0)|0)==0;d=c?0:b+1|0;do{if((d|0)==0){e=b}else{c=d;while(1){f=(a6(a[c]|0)|0)==0;g=c+1|0;h=f?0:g;if((h|0)==0){break}else{c=h}}h=(a6(a[c]|0)|0)==0;f=h?0:g;if((f|0)==0){e=c;break}else{i=f}while(1){f=(a6(a[i]|0)|0)==0;h=i+1|0;j=f?0:h;if((j|0)!=0){i=j;continue}j=(a6(a[i]|0)|0)==0;f=j?0:h;if((f|0)==0){e=i;break}else{i=f}}}}while(0);i=a[e]|0;if((i<<24>>24|0)==34|(i<<24>>24|0)==39){g=e+1|0;d=i<<24>>24==34?g:0;L11:do{if((d|0)!=0){b=a[d]|0;if(b<<24>>24==0){break}else{k=d;l=b}while(1){b=k+1|0;c=l<<24>>24==34?b:0;if((c|0)==0){m=b}else{if((a[k-1|0]|0)==92){m=c}else{n=c;break}}c=a[m]|0;if(c<<24>>24==0){break L11}else{k=m;l=c}}return n|0}}while(0);l=i<<24>>24==39?g:0;if((l|0)==0){n=0;return n|0}g=a[l]|0;if(g<<24>>24==0){n=0;return n|0}else{o=l;p=g}while(1){g=o+1|0;l=p<<24>>24==39?g:0;if((l|0)==0){q=g}else{if((a[o-1|0]|0)==92){q=l}else{n=l;r=33;break}}l=a[q]|0;if(l<<24>>24==0){n=0;r=38;break}else{o=q;p=l}}if((r|0)==33){return n|0}else if((r|0)==38){return n|0}}else if((i<<24>>24|0)==41){n=e;return n|0}else{p=e;e=i;L33:while(1){i=p+1|0;q=(i|0)==0;L35:do{if((a6(e<<24>>24|0)|0)==0|q){o=a[p]|0;if((o<<24>>24|0)==34|(o<<24>>24|0)==39|(o<<24>>24|0)==40){n=0;r=35;break L33}else if((o<<24>>24|0)!=92){s=i;break}L38:do{if(q){t=37080}else{o=1;l=i;while(1){if(!o){u=1;v=l;break}g=(br(a[l]|0)|0)==0;m=g?0:l+1|0;if((m|0)==0){t=37080;break L38}else{o=0;l=m}}while(1){if(u>>>0>=7>>>0){r=24;break}l=(br(a[v]|0)|0)==0;o=l?0:v+1|0;if((o|0)==0){w=36952;break}else{u=u+1|0;v=o}}if((r|0)==24){r=0;if((v|0)==0){t=37080;break}else{w=36952}}while(1){o=a[w]|0;if(o<<24>>24==0){x=1;break}if((a[v]|0)==o<<24>>24){x=0;break}else{w=w+1|0}}o=x?0:v+1|0;l=(o|0)!=0?o:v;if((l|0)==0){t=37080}else{s=l;break L35}}}while(0);while(1){l=a[t]|0;if(l<<24>>24==0){n=0;r=40;break L33}if((a[p]|0)==l<<24>>24){break}else{t=t+1|0}}if(q){n=0;r=42;break L33}else{s=i}}else{s=i}}while(0);i=a[s]|0;if(i<<24>>24==41){n=s;r=39;break}else{p=s;e=i}}if((r|0)==35){return n|0}else if((r|0)==39){return n|0}else if((r|0)==40){return n|0}else if((r|0)==42){return n|0}}return 0}function z5(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=zS(b)|0;if((c|0)!=0){d=c;return d|0}c=z9(b)|0;if((c|0)!=0){e=c;while(1){c=z9(e)|0;if((c|0)==0){d=e;break}else{e=c}}return d|0}e=b+1|0;c=(a[b]|0)==45?e:0;f=(c|0)!=0?c:b;L9:do{if((f|0)==0){g=37256}else{do{if((bS(a[f]|0)|0)==0){c=a[f]|0;if(c<<24>>24<0){h=8;break}i=c;j=f+1|0;h=10}else{h=8}}while(0);do{if((h|0)==8){c=f+1|0;if((c|0)!=0){k=c;break}i=a[f]|0;j=0;h=10}}while(0);do{if((h|0)==10){c=i<<24>>24==95?j:0;if((c|0)!=0){k=c;break}c=i<<24>>24==92?j:0;if((c|0)==0){g=37256;break L9}l=(a[c]|0)!=0?c+1|0:c;if((l|0)==0){g=37256;break L9}else{k=l}}}while(0);l=Ab(k)|0;if((l|0)==0){g=37256;break}else{d=l}return d|0}}while(0);while(1){k=a[g]|0;if(k<<24>>24==0){m=0;break}if((a[b]|0)==k<<24>>24){m=e;break}else{g=g+1|0}}g=(m|0)!=0?m:b;do{if((g|0)!=0){m=a[g]|0;k=((m<<24>>24)-48|0)>>>0<10>>>0?g+1|0:0;j=(k|0)==0;if(j){n=g;o=m}else{m=k;while(1){i=a[m]|0;h=((i<<24>>24)-48|0)>>>0<10>>>0?m+1|0:0;if((h|0)==0){n=m;o=i;break}else{m=h}}}m=o<<24>>24==46?n+1|0:0;do{if((m|0)!=0){h=((a[m]|0)-48|0)>>>0<10>>>0?m+1|0:0;if((h|0)==0){break}else{p=h}while(1){h=((a[p]|0)-48|0)>>>0<10>>>0?p+1|0:0;if((h|0)==0){d=p;break}else{p=h}}return d|0}}while(0);if(j){break}else{q=k}while(1){m=((a[q]|0)-48|0)>>>0<10>>>0?q+1|0:0;if((m|0)==0){d=q;break}else{q=m}}return d|0}}while(0);q=(a[b]|0)==35?e:0;do{if((q|0)==0){r=0}else{e=(br(a[q]|0)|0)==0;p=e?0:q+1|0;if((p|0)==0){r=0;break}else{s=p}while(1){p=(br(a[s]|0)|0)==0;e=p?0:s+1|0;if((e|0)==0){r=s;break}else{s=e}}}}while(0);s=r-b|0;d=(s|0)!=4&(s|0)!=7?0:r;return d|0}function z6(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=z9(b)|0;if((c|0)!=0){d=c;while(1){c=z9(d)|0;if((c|0)==0){e=d;break}else{d=c}}return e|0}d=(a[b]|0)==45?b+1|0:0;c=(d|0)!=0?d:b;if((c|0)==0){e=0;return e|0}do{if((bS(a[c]|0)|0)==0){b=a[c]|0;if(b<<24>>24<0){f=7;break}g=b;h=c+1|0;f=9}else{f=7}}while(0);do{if((f|0)==7){b=c+1|0;if((b|0)!=0){i=b;break}g=a[c]|0;h=0;f=9}}while(0);do{if((f|0)==9){c=g<<24>>24==95?h:0;if((c|0)!=0){i=c;break}c=g<<24>>24==92?h:0;if((c|0)==0){e=0;return e|0}b=(a[c]|0)!=0?c+1|0:c;if((b|0)==0){e=0}else{i=b;break}return e|0}}while(0);e=Ab(i)|0;return e|0}function z7(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=z8(b)|0;do{if((c|0)==0){if((b|0)==0){d=0}else{e=b;break}return d|0}else{f=c;while(1){g=z8(f)|0;if((g|0)==0){e=f;break}else{f=g}}}}while(0);c=a[37176]|0;L7:do{if(c<<24>>24==0){h=e;i=0}else{b=e;f=37176;g=c;while(1){if((a[b]|0)!=g<<24>>24){h=b;i=g;break L7}j=b+1|0;k=f+1|0;l=a[k]|0;if(l<<24>>24==0){h=j;i=0;break}else{b=j;f=k;g=l}}}}while(0);c=i<<24>>24!=0?0:h;if((c|0)==0){d=0;return d|0}h=a[36840]|0;L15:do{if(h<<24>>24==0){i=c;while(1){if((a[i]|0)==0){d=0;break}if((i|0)==0){i=i+1|0}else{m=i;break L15}}return d|0}else{i=c;while(1){e=a[i]|0;if(e<<24>>24==0){d=0;break}L19:do{if(e<<24>>24==h<<24>>24){g=36840;f=i;while(1){b=f+1|0;l=g+1|0;k=a[l]|0;if(k<<24>>24==0){n=b;o=0;break L19}if((a[b]|0)==k<<24>>24){g=l;f=b}else{n=b;o=k;break}}}else{n=i;o=h}}while(0);e=o<<24>>24!=0?0:n;if((e|0)==0){i=i+1|0}else{m=e;break L15}}return d|0}}while(0);n=z8(m)|0;if((n|0)==0){d=m;return d|0}else{p=n}while(1){n=z8(p)|0;if((n|0)==0){d=p;break}else{p=n}}return d|0}function z8(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=37256}else{do{if((bS(a[e]|0)|0)==0){d=a[e]|0;if(d<<24>>24<0){g=5;break}h=d;i=e+1|0;g=7}else{g=5}}while(0);do{if((g|0)==5){d=e+1|0;if((d|0)!=0){j=d;break}h=a[e]|0;i=0;g=7}}while(0);do{if((g|0)==7){d=h<<24>>24==95?i:0;if((d|0)!=0){j=d;break}d=h<<24>>24==92?i:0;if((d|0)==0){f=37256;break L1}k=(a[d]|0)!=0?d+1|0:d;if((k|0)==0){f=37256;break L1}else{j=k}}}while(0);k=Ab(j)|0;if((k|0)==0){f=37256;break}else{l=k}return l|0}}while(0);while(1){j=a[f]|0;if(j<<24>>24==0){m=0;break}if((a[b]|0)==j<<24>>24){m=c;break}else{f=f+1|0}}f=(m|0)!=0?m:b;do{if((f|0)!=0){m=a[f]|0;j=((m<<24>>24)-48|0)>>>0<10>>>0?f+1|0:0;i=(j|0)==0;if(i){n=f;o=m}else{m=j;while(1){h=a[m]|0;e=((h<<24>>24)-48|0)>>>0<10>>>0?m+1|0:0;if((e|0)==0){n=m;o=h;break}else{m=e}}}m=o<<24>>24==46?n+1|0:0;do{if((m|0)==0){g=19}else{e=((a[m]|0)-48|0)>>>0<10>>>0?m+1|0:0;if((e|0)==0){g=19;break}else{p=e}while(1){e=a[p]|0;h=((e<<24>>24)-48|0)>>>0<10>>>0?p+1|0:0;if((h|0)==0){q=p;r=e;break}else{p=h}}}}while(0);if((g|0)==19){if(i){break}else{s=j}while(1){m=a[s]|0;h=((m<<24>>24)-48|0)>>>0<10>>>0?s+1|0:0;if((h|0)==0){q=s;r=m;break}else{s=h}}}j=r<<24>>24==37?q+1|0:0;if((j|0)==0){break}else{l=j}return l|0}}while(0);q=zB(b)|0;if((q|0)!=0){l=q;return l|0}q=(a[b]|0)==35?c:0;do{if((q|0)==0){t=0}else{r=(br(a[q]|0)|0)==0;s=r?0:q+1|0;if((s|0)==0){t=0;break}else{u=s}while(1){s=(br(a[u]|0)|0)==0;r=s?0:u+1|0;if((r|0)==0){t=u;break}else{u=r}}}}while(0);u=t-b|0;q=(u|0)!=4&(u|0)!=7?0:t;if((q|0)==0){v=37256}else{l=q;return l|0}while(1){q=a[v]|0;if(q<<24>>24==0){w=0;break}if((a[b]|0)==q<<24>>24){w=c;break}else{v=v+1|0}}v=(w|0)!=0?w:b;do{if((v|0)!=0){w=a[v]|0;q=((w<<24>>24)-48|0)>>>0<10>>>0?v+1|0:0;t=(q|0)==0;if(t){x=v;y=w}else{w=q;while(1){u=a[w]|0;r=((u<<24>>24)-48|0)>>>0<10>>>0?w+1|0:0;if((r|0)==0){x=w;y=u;break}else{w=r}}}w=y<<24>>24==46?x+1|0:0;do{if((w|0)!=0){r=((a[w]|0)-48|0)>>>0<10>>>0?w+1|0:0;if((r|0)==0){break}else{z=r}while(1){r=((a[z]|0)-48|0)>>>0<10>>>0?z+1|0:0;if((r|0)==0){l=z;break}else{z=r}}return l|0}}while(0);if(t){break}else{A=q}while(1){w=((a[A]|0)-48|0)>>>0<10>>>0?A+1|0:0;if((w|0)==0){l=A;break}else{A=w}}return l|0}}while(0);A=a[b]|0;b=A<<24>>24==34?c:0;L66:do{if((b|0)!=0){z=a[b]|0;if(z<<24>>24==0){break}else{B=b;C=z}while(1){z=B+1|0;x=C<<24>>24==34?z:0;if((x|0)==0){D=z}else{if((a[B-1|0]|0)==92){D=x}else{l=x;break}}x=a[D]|0;if(x<<24>>24==0){break L66}else{B=D;C=x}}return l|0}}while(0);C=A<<24>>24==39?c:0;if((C|0)==0){l=0;return l|0}c=a[C]|0;if(c<<24>>24==0){l=0;return l|0}else{E=C;F=c}while(1){c=E+1|0;C=F<<24>>24==39?c:0;if((C|0)==0){G=c}else{if((a[E-1|0]|0)==92){G=C}else{l=C;g=57;break}}C=a[G]|0;if(C<<24>>24==0){l=0;g=58;break}else{E=G;F=C}}if((g|0)==57){return l|0}else if((g|0)==58){return l|0}return 0}function z9(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=11}else{do{if((bS(a[e]|0)|0)==0){d=a[e]|0;if(d<<24>>24<0){f=5;break}g=d;h=e+1|0;f=7}else{f=5}}while(0);do{if((f|0)==5){d=e+1|0;if((d|0)!=0){i=d;break}g=a[e]|0;h=0;f=7}}while(0);do{if((f|0)==7){d=g<<24>>24==95?h:0;if((d|0)!=0){i=d;break}d=g<<24>>24==92?h:0;if((d|0)==0){f=11;break L1}j=(a[d]|0)!=0?d+1|0:d;if((j|0)==0){f=11;break L1}else{i=j}}}while(0);j=Ab(i)|0;if((j|0)==0){f=11}else{k=j;f=12}}}while(0);if((f|0)==11){i=a[b]|0;h=i<<24>>24==45?c:0;if((h|0)==0){l=b;m=i}else{k=h;f=12}}if((f|0)==12){L17:while(1){f=0;h=k+1|0;i=(a[k]|0)==45?h:0;b=(i|0)!=0?i:k;L19:do{if((b|0)!=0){do{if((bS(a[b]|0)|0)==0){i=a[b]|0;if(i<<24>>24<0){f=16;break}n=i;o=b+1|0;f=18}else{f=16}}while(0);do{if((f|0)==16){f=0;i=b+1|0;if((i|0)!=0){p=i;break}n=a[b]|0;o=0;f=18}}while(0);do{if((f|0)==18){f=0;i=n<<24>>24==95?o:0;if((i|0)!=0){p=i;break}i=n<<24>>24==92?o:0;if((i|0)==0){break L19}c=(a[i]|0)!=0?i+1|0:i;if((c|0)==0){break L19}else{p=c}}}while(0);c=Ab(p)|0;if((c|0)!=0){k=c;f=12;continue L17}}}while(0);b=a[k]|0;c=b<<24>>24==45?h:0;if((c|0)==0){l=k;m=b;break}else{k=c;f=12}}}if((l|0)==0){q=0;return q|0}f=a[37176]|0;L37:do{if(f<<24>>24==0){r=l;s=0}else{k=l;p=37176;o=f;n=m;while(1){if(n<<24>>24!=o<<24>>24){r=k;s=o;break L37}c=k+1|0;b=p+1|0;i=a[b]|0;if(i<<24>>24==0){r=c;s=0;break L37}k=c;p=b;o=i;n=a[c]|0}}}while(0);m=s<<24>>24!=0?0:r;if((m|0)==0){q=0;return q|0}r=a[36840]|0;L46:do{if(r<<24>>24==0){s=m;while(1){if((a[s]|0)==0){q=0;break}if((s|0)==0){s=s+1|0}else{t=s;break L46}}return q|0}else{s=m;while(1){f=a[s]|0;if(f<<24>>24==0){q=0;break}L54:do{if(f<<24>>24==r<<24>>24){l=36840;n=s;while(1){o=n+1|0;p=l+1|0;k=a[p]|0;if(k<<24>>24==0){u=o;v=0;break L54}if((a[o]|0)==k<<24>>24){l=p;n=o}else{u=o;v=k;break}}}else{u=s;v=r}}while(0);f=v<<24>>24!=0?0:u;if((f|0)==0){s=s+1|0}else{t=f;break L46}}return q|0}}while(0);u=Aa(t)|0;if((u|0)==0){q=t;return q|0}else{w=u}while(1){u=Aa(w)|0;if((u|0)==0){q=w;break}else{w=u}}return q|0}function Aa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=37256}else{do{if((bS(a[e]|0)|0)==0){d=a[e]|0;if(d<<24>>24<0){g=5;break}h=d;i=e+1|0;g=7}else{g=5}}while(0);do{if((g|0)==5){d=e+1|0;if((d|0)!=0){j=d;break}h=a[e]|0;i=0;g=7}}while(0);do{if((g|0)==7){d=h<<24>>24==95?i:0;if((d|0)!=0){j=d;break}d=h<<24>>24==92?i:0;if((d|0)==0){f=37256;break L1}k=(a[d]|0)!=0?d+1|0:d;if((k|0)==0){f=37256;break L1}else{j=k}}}while(0);k=Ab(j)|0;if((k|0)==0){f=37256;break}else{l=k}return l|0}}while(0);while(1){j=a[f]|0;if(j<<24>>24==0){m=0;break}if((a[b]|0)==j<<24>>24){m=c;break}else{f=f+1|0}}f=(m|0)!=0?m:b;do{if((f|0)!=0){m=a[f]|0;j=((m<<24>>24)-48|0)>>>0<10>>>0?f+1|0:0;i=(j|0)==0;if(i){n=f;o=m}else{m=j;while(1){h=a[m]|0;g=((h<<24>>24)-48|0)>>>0<10>>>0?m+1|0:0;if((g|0)==0){n=m;o=h;break}else{m=g}}}m=o<<24>>24==46?n+1|0:0;do{if((m|0)!=0){g=((a[m]|0)-48|0)>>>0<10>>>0?m+1|0:0;if((g|0)==0){break}else{p=g}while(1){g=((a[p]|0)-48|0)>>>0<10>>>0?p+1|0:0;if((g|0)==0){l=p;break}else{p=g}}return l|0}}while(0);if(i){break}else{q=j}while(1){m=((a[q]|0)-48|0)>>>0<10>>>0?q+1|0:0;if((m|0)==0){l=q;break}else{q=m}}return l|0}}while(0);l=(a[b]|0)==45?c:0;return l|0}function Ab(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;do{if((bR(a[b]|0)|0)==0){c=a[b]|0;if(c<<24>>24<0){d=4;break}e=c;f=b+1|0;d=6}else{d=4}}while(0);do{if((d|0)==4){c=b+1|0;if((c|0)!=0){g=c;break}e=a[b]|0;f=0;d=6}}while(0);do{if((d|0)==6){c=e<<24>>24==45?f:0;if((c|0)!=0){g=c;break}c=e<<24>>24==95?f:0;if((c|0)!=0){g=c;break}c=e<<24>>24==92?f:0;if((c|0)==0){h=b;return h|0}i=(a[c]|0)!=0?c+1|0:c;if((i|0)==0){h=b}else{g=i;break}return h|0}}while(0);while(1){do{if((bR(a[g]|0)|0)==0){b=a[g]|0;if(b<<24>>24<0){d=13;break}j=b;k=g+1|0}else{d=13}}while(0);if((d|0)==13){d=0;b=g+1|0;if((b|0)!=0){g=b;continue}j=a[g]|0;k=0}b=j<<24>>24==45?k:0;if((b|0)!=0){g=b;continue}b=j<<24>>24==95?k:0;if((b|0)!=0){g=b;continue}b=j<<24>>24==92?k:0;if((b|0)==0){h=g;d=23;break}f=(a[b]|0)!=0?b+1|0:b;if((f|0)==0){h=g;d=20;break}else{g=f}}if((d|0)==20){return h|0}else if((d|0)==23){return h|0}return 0}function Ac(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=b;return}function Ad(a,b,d){a=a|0;b=+b;d=d|0;c[a>>2]=1;h[a+8>>3]=b;c[a+16>>2]=bU(d|0)|0;return}function Ae(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;c[a>>2]=2;h[a+8>>3]=b;h[a+16>>3]=d;h[a+24>>3]=e;h[a+32>>3]=f;return}function Af(a,b){a=a|0;b=b|0;c[a>>2]=3;c[a+4>>2]=bU(b|0)|0;return}function Ag(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[a>>2]=4;c[a+8>>2]=b;c[e+4>>2]=d;c[e+12>>2]=Lo(b*40|0)|0;return}function Ah(a){a=a|0;c[a>>2]=5;return}function Ai(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;if((a[b+68|0]&1)!=0){Lw(c[b+76>>2]|0)}d=b+48|0;e=c[d>>2]|0;if((e|0)!=0){f=b+52|0;g=c[f>>2]|0;if((e|0)==(g|0)){h=e}else{i=g;while(1){g=i-12|0;c[f>>2]=g;if((a[g]&1)==0){j=g}else{Lw(c[i-12+8>>2]|0);j=c[f>>2]|0}if((e|0)==(j|0)){break}else{i=j}}h=c[d>>2]|0}Lw(h)}if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}if((a[b+16|0]&1)!=0){Lw(c[b+24>>2]|0)}if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function Aj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;c[b>>2]=c[d>>2];e=b+4|0;f=d+4|0;if((a[f]&1)==0){g=e;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2]}else{f=c[d+12>>2]|0;g=c[d+8>>2]|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){a[e]=g<<1;h=e+1|0}else{i=g+16&-16;j=Lu(i)|0;c[b+12>>2]=j;c[e>>2]=i|1;c[b+8>>2]=g;h=j}LF(h|0,f|0,g)|0;a[h+g|0]=0}g=b+16|0;h=d+16|0;L12:do{if((a[h]&1)==0){f=g;c[f>>2]=c[h>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];k=19}else{f=c[d+24>>2]|0;j=c[d+20>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(j>>>0<11>>>0){a[g]=j<<1;l=g+1|0}else{i=j+16&-16;m=(z=0,au(248,i|0)|0);if(z){z=0;break}c[b+24>>2]=m;c[g>>2]=i|1;c[b+20>>2]=j;l=m}LF(l|0,f|0,j)|0;a[l+j|0]=0;k=19;break L12}}while(0);j=bT(-1,-1)|0;n=M;o=j}}while(0);do{if((k|0)==19){l=b+28|0;h=d+28|0;L27:do{if((a[h]&1)==0){j=l;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];k=29}else{j=c[d+36>>2]|0;f=c[d+32>>2]|0;do{if(f>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(f>>>0<11>>>0){a[l]=f<<1;p=l+1|0}else{m=f+16&-16;i=(z=0,au(248,m|0)|0);if(z){z=0;break}c[b+36>>2]=i;c[l>>2]=m|1;c[b+32>>2]=f;p=i}LF(p|0,j|0,f)|0;a[p+f|0]=0;k=29;break L27}}while(0);f=bT(-1,-1)|0;q=M;r=f}}while(0);do{if((k|0)==29){c[b+40>>2]=c[d+40>>2];c[b+44>>2]=c[d+44>>2];h=b+48|0;z=0;as(294,h|0,d+48|0);do{if(!z){a[b+60|0]=a[d+60|0]&1;a[b+61|0]=a[d+61|0]&1;c[b+64>>2]=c[d+64>>2];f=b+68|0;j=d+68|0;if((a[j]&1)==0){i=f;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];s=b+80|0;t=d+80|0;u=c[t>>2]|0;c[s>>2]=u;return}j=c[d+76>>2]|0;i=c[d+72>>2]|0;do{if(i>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(i>>>0<11>>>0){a[f]=i<<1;v=f+1|0}else{m=i+16&-16;w=(z=0,au(248,m|0)|0);if(z){z=0;break}c[b+76>>2]=w;c[f>>2]=m|1;c[b+72>>2]=i;v=w}LF(v|0,j|0,i)|0;a[v+i|0]=0;s=b+80|0;t=d+80|0;u=c[t>>2]|0;c[s>>2]=u;return}}while(0);i=bT(-1,-1)|0;j=i;i=M;f=h|0;w=c[f>>2]|0;if((w|0)==0){x=i;y=j;break}m=b+52|0;A=c[m>>2]|0;if((w|0)==(A|0)){B=w}else{C=A;while(1){A=C-12|0;c[m>>2]=A;if((a[A]&1)==0){D=A}else{Lw(c[C-12+8>>2]|0);D=c[m>>2]|0}if((w|0)==(D|0)){break}else{C=D}}B=c[f>>2]|0}Lw(B);x=i;y=j}else{z=0;C=bT(-1,-1)|0;x=M;y=C}}while(0);if((a[l]&1)==0){q=x;r=y;break}Lw(c[b+36>>2]|0);q=x;r=y}}while(0);if((a[g]&1)==0){n=q;o=r;break}Lw(c[b+24>>2]|0);n=q;o=r}}while(0);if((a[e]&1)==0){E=o;F=0;G=E;H=n;bg(G|0)}Lw(c[b+12>>2]|0);E=o;F=0;G=E;H=n;bg(G|0)}function Ak(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0;g=i;i=i+80|0;h=g|0;j=g+16|0;k=g+32|0;l=g+48|0;m=g+64|0;n=b;a[n]=0;a[b+1|0]=0;o=f|0;do{if((c[o>>2]&-249|0)>0){p=f+24|0;if((a[p]&1)==0){q=h;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];r=a[q]|0;s=q}else{q=c[f+32>>2]|0;p=c[f+28>>2]|0;if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=37;break}}if(p>>>0<11>>>0){u=p<<1&255;v=h;a[v]=u;w=h+1|0;x=u;y=v}else{v=p+16&-16;u=(z=0,au(248,v|0)|0);if(z){z=0;t=37;break}c[h+8>>2]=u;A=v|1;c[h>>2]=A;c[h+4>>2]=p;w=u;x=A&255;y=h}LF(w|0,q|0,p)|0;a[w+p|0]=0;r=x;s=y}if((r&1)==0){B=s;C=r;D=1;E=0;t=15;break}F=c[h+8>>2]|0;G=s;H=r;I=1;J=0;t=16}else{p=h;a[p]=0;a[h+1|0]=0;B=p;C=0;D=0;E=1;t=15}}while(0);if((t|0)==15){F=h+1|0;G=B;H=C;I=D;J=E;t=16}L20:do{if((t|0)==16){E=H&255;if((E&1|0)==0){K=E>>>1}else{K=c[h+4>>2]|0}z=0,az(88,b|0,F|0,K|0)|0;if(z){z=0;E=bT(-1,-1)|0;D=E;E=M;do{if(J){C=a[G]|0;if((C&1)==0){t=41;break}Lw(c[h+8>>2]|0);if(I){L=C}else{N=D;O=E;break L20}}else{t=41}}while(0);if((t|0)==41){if(!I){N=D;O=E;break}L=a[G]|0}if((L&1)==0){N=D;O=E;break}Lw(c[h+8>>2]|0);N=D;O=E;break}do{if(J){if((a[G]&1)==0){break}Lw(c[h+8>>2]|0)}}while(0);do{if(I){if((a[G]&1)==0){break}Lw(c[h+8>>2]|0)}}while(0);E=f+24|0;z=0,aM(542,E|0,38304)|0;if(z){z=0;t=37;break}D=e;C=e;B=a[C]|0;r=B&255;if((r&1|0)==0){P=r>>>1}else{P=c[e+4>>2]|0}if((B&1)==0){Q=D+1|0}else{Q=c[e+8>>2]|0}B=Q+P|0;do{if((B|0)==(Q|0)){t=115;break}B=B-1|0;}while((bh(9680,d[B]|0|0,2)|0)!=0);if((t|0)==115){i=g;return}r=B-Q|0;if((r|0)==-1){i=g;return}s=r+1|0;z=0;aq(30,j|0,e|0,s|0,-1|0,0);if(z){z=0;t=37;break}z=0;aq(30,k|0,e|0,0,s|0,0);L64:do{if(!z){z=0,aM(344,e|0,k|0)|0;if(z){z=0;s=bT(-1,-1)|0;r=s;s=M;if((a[k]&1)==0){R=r;S=s;break}Lw(c[k+8>>2]|0);R=r;S=s;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}s=l;LI(s|0,0,12)|0;r=a[j]|0;y=r&255;if((y&1|0)==0){T=y>>>1}else{T=c[j+4>>2]|0}y=(r&1)==0;if(y){U=j+1|0}else{U=c[j+8>>2]|0}r=T+1|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(r>>>0<11>>>0){a[s]=T<<1;V=l+1|0}else{x=T+17&-16;w=(z=0,au(248,x|0)|0);if(z){z=0;break}c[l+8>>2]=w;c[l>>2]=x|1;c[l+4>>2]=T;V=w}LF(V|0,U|0,T)|0;a[V+T|0]=0;z=0,az(88,l|0,8096,1)|0;if(z){z=0;break}w=a[s]|0;if((w&1)==0){W=l+1|0}else{W=c[l+8>>2]|0}x=w&255;if((x&1|0)==0){X=x>>>1}else{X=c[l+4>>2]|0}z=0,az(88,E|0,W|0,X|0)|0;if(z){z=0;x=bT(-1,-1)|0;w=x;x=M;if((a[s]&1)==0){R=w;S=x;break L64}Lw(c[l+8>>2]|0);R=w;S=x;break L64}if((a[s]&1)!=0){Lw(c[l+8>>2]|0)}L106:do{if((c[o>>2]&-249|0)==0){x=a[C]|0;w=x&255;if((w&1|0)==0){Y=w>>>1}else{Y=c[e+4>>2]|0}if((Y|0)==0){break}if((x&1)==0){Z=D+1|0}else{Z=c[e+8>>2]|0}x=Z+Y|0;w=Z;while(1){if((w|0)==(x|0)){break L106}if((bh(6160,d[w]|0|0,6)|0)==0){break}else{w=w+1|0}}x=w-Z|0;if((x|0)==-1){break}z=0;aq(30,m|0,e|0,x|0,-1|0,0);if(z){z=0;t=91;break L64}z=0,aM(344,e|0,m|0)|0;if(!z){if((a[m]&1)==0){break}Lw(c[m+8>>2]|0);break}else{z=0;x=bT(-1,-1)|0;p=x;x=M;if((a[m]&1)==0){R=p;S=x;break L64}Lw(c[m+8>>2]|0);R=p;S=x;break L64}}}while(0);x=a[C]|0;if((x&1)==0){_=D+1|0}else{_=c[e+8>>2]|0}p=x&255;if((p&1|0)==0){$=p>>>1}else{$=c[e+4>>2]|0}z=0,az(88,b|0,_|0,$|0)|0;if(z){z=0;t=91;break L64}if(y){i=g;return}Lw(c[j+8>>2]|0);i=g;return}}while(0);y=bT(-1,-1)|0;r=M;if((a[s]&1)==0){aa=r;ab=y;t=92;break}Lw(c[l+8>>2]|0);aa=r;ab=y;t=92}else{z=0;t=91}}while(0);if((t|0)==91){D=bT(-1,-1)|0;aa=M;ab=D;t=92}if((t|0)==92){R=ab;S=aa}if((a[j]&1)==0){N=R;O=S;break}Lw(c[j+8>>2]|0);N=R;O=S}}while(0);if((t|0)==37){t=bT(-1,-1)|0;N=t;O=M}if((a[n]&1)==0){ac=N;ad=0;ae=ac;af=O;bg(ae|0)}Lw(c[b+8>>2]|0);ac=N;ad=0;ae=ac;af=O;bg(ae|0)}function Al(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0;g=i;i=i+512|0;h=g|0;j=g+16|0;k=g+32|0;l=g+48|0;m=g+64|0;n=g+80|0;o=g+96|0;p=g+112|0;q=g+128|0;r=g+144|0;s=g+160|0;t=g+176|0;u=g+192|0;v=g+208|0;w=g+224|0;x=g+240|0;y=g+256|0;A=g+272|0;B=g+288|0;C=g+304|0;D=g+320|0;F=g+336|0;G=g+352|0;H=g+368|0;I=g+384|0;J=g+400|0;K=g+416|0;L=g+432|0;N=g+448|0;O=g+464|0;P=g+480|0;Q=g+496|0;R=b;a[R]=0;a[b+1|0]=0;S=e;T=e;U=a[T]|0;V=U&255;if((V&1|0)==0){W=V>>>1}else{W=c[e+4>>2]|0}L5:do{if((W|0)==0){X=-1}else{if((U&1)==0){Y=S+1|0}else{Y=c[e+8>>2]|0}V=Y+W|0;Z=Y;while(1){if((Z|0)==(V|0)){X=-1;break L5}if((bh(6160,d[Z]|0,6)|0)==0){break}else{Z=Z+1|0}}X=Z-Y|0}}while(0);Y=(a[f+20|0]&1)==0?X:0;do{if((Y|0)==-1){X=f+24|0;z=0;aR(410,k|0,e|0,8096);if(z){z=0;_=23;break}W=k;U=a[W]|0;if((U&1)==0){$=k+1|0}else{$=c[k+8>>2]|0}V=U&255;if((V&1|0)==0){aa=V>>>1}else{aa=c[k+4>>2]|0}z=0,az(88,X|0,$|0,aa|0)|0;if(z){z=0;X=bT(-1,-1)|0;V=X;X=M;if((a[W]&1)==0){ab=V;ac=X;break}Lw(c[k+8>>2]|0);ab=V;ac=X;break}if((a[W]&1)==0){i=g;return}Lw(c[k+8>>2]|0);i=g;return}else{z=0;aq(30,l|0,e|0,0,Y|0,0);if(z){z=0;_=23;break}W=l;X=d[W]|0;if((X&1|0)==0){ad=X>>>1}else{ad=c[l+4>>2]|0}X=f+36|0;V=f+56|0;U=f+52|0;ae=(c[V>>2]|0)-1+(c[U>>2]|0)|0;af=f+40|0;ag=c[(c[af>>2]|0)+(((ae>>>0)/341|0)<<2)>>2]|0;ah=(ae>>>0)%341|0;ae=d[ag+(ah*12|0)|0]|0;if((ae&1|0)==0){ai=ae>>>1}else{ai=c[ag+(ah*12|0)+4>>2]|0}ah=f+8|0;L45:do{if(ad>>>0>ai>>>0){aj=ah;_=73}else{ag=ah;ae=ah;ak=a[ae]|0;al=ak&255;am=(al&1|0)==0;if(am){an=al>>>1}else{an=c[f+12>>2]|0}ao=(ak&1)==0;if(ao){ap=ag+1|0}else{ap=c[f+16>>2]|0}ak=an>>>0>2>>>0;do{if((LH(ap|0,5304,(ak?2:an)|0)|0)==0){if(!(an>>>0>1>>>0&(ak^1))){_=44;break}at=c[f>>2]|0;_=53}else{_=44}}while(0);L59:do{if((_|0)==44){if(am){av=al>>>1}else{av=c[f+12>>2]|0}if(ao){aw=ag+1|0}else{aw=c[f+16>>2]|0}ak=av>>>0>2>>>0;do{if((LH(aw|0,3728,(ak?2:av)|0)|0)==0){if(!(av>>>0>1>>>0&(ak^1))){break}ax=c[f>>2]|0;if((ax&128|0)!=0){at=ax;_=53;break L59}}}while(0);if(am){ay=al>>>1}else{ay=c[f+12>>2]|0}if(ao){aA=ag+1|0}else{aA=c[f+16>>2]|0}ak=ay>>>0>2>>>0;do{if((LH(aA|0,3728,(ak?2:ay)|0)|0)==0){if(!(ay>>>0>1>>>0&(ak^1))){break}ax=c[f>>2]|0;if((ax&128|0)!=0){break}if((ax&32|0)==0){break L59}z=0,az(88,b|0,8096,1)|0;if(!z){break L59}else{z=0;_=56;break L45}}}while(0);if((a[f+5|0]&1)==0){break}if((a[f+4|0]&1)!=0){break}z=0,az(88,b|0,1528,1)|0;if(z){z=0;_=56;break L45}}}while(0);do{if((_|0)==53){if((at&64|0)!=0){break}z=0,az(88,b|0,2360,3)|0;if(z){z=0;_=56;break L45}}}while(0);z=0,aM(542,ah|0,38304)|0;if(!z){aj=ae;_=73}else{z=0;_=56}}}while(0);L93:do{if((_|0)==73){Z=f+44|0;ag=j;ao=f|0;al=m;am=m;ak=al+1|0;ax=ak;aB=al+3|0;al=m+8|0;aC=m+4|0;aD=j+1|0;aE=j+8|0;aF=m|0;aG=j+4|0;aH=f+12|0;aI=l+4|0;L95:while(1){aJ=d[W]|0;aK=c[V>>2]|0;aL=aK-1+(c[U>>2]|0)|0;aN=c[af>>2]|0;aO=c[aN+(((aL>>>0)/341|0)<<2)>>2]|0;aP=(aL>>>0)%341|0;aL=a[aO+(aP*12|0)|0]|0;aQ=aL&255;if((aQ&1|0)==0){aS=aQ>>>1}else{aS=c[aO+(aP*12|0)+4>>2]|0}if(((aJ&1|0)==0?aJ>>>1:c[aI>>2]|0)>>>0>=aS>>>0){_=116;break}if((aL&1)==0){aT=aK;aU=aN}else{Lw(c[aO+(aP*12|0)+8>>2]|0);aT=c[V>>2]|0;aU=c[af>>2]|0}c[V>>2]=aT-1;aP=c[Z>>2]|0;aO=aP-aU>>2;if((aO|0)==0){aV=0}else{aV=(aO*341|0)-1|0}if((aV+(1-aT)-(c[U>>2]|0)|0)>>>0>681>>>0){Lw(c[aP-4>>2]|0);c[Z>>2]=(c[Z>>2]|0)-4}aP=d[aj]|0;if((aP&1|0)==0){aW=aP>>>1}else{aW=c[aH>>2]|0}do{if((aW|0)==0){aP=c[ao>>2]&-249;do{if((aP|0)==0){a[am]=4;E=32032;a[ax]=E;E=E>>8;a[ax+1|0]=E;a[aB]=0}else{if((aP|0)<2){a[am]=4;E=32032;a[ax]=E;E=E>>8;a[ax+1|0]=E;a[aB]=0;break}aO=(c[V>>2]|0)-1+(c[U>>2]|0)|0;z=0;aR(26,j|0,8096,(c[(c[af>>2]|0)+(((aO>>>0)/341|0)<<2)>>2]|0)+(((aO>>>0)%341|0)*12|0)|0);if(z){z=0;_=55;break L95}LI(am|0,0,12)|0;aO=a[ag]|0;aN=aO&255;aK=(aN&1|0)==0?aN>>>1:c[aG>>2]|0;aN=(aO&1)==0?aD:c[aE>>2]|0;aO=aK+1|0;if(aO>>>0>4294967279>>>0){_=94;break L95}if(aO>>>0<11>>>0){a[am]=aK<<1;aX=ak}else{aO=aK+17&-16;aL=(z=0,au(248,aO|0)|0);if(z){z=0;_=101;break L95}c[al>>2]=aL;c[aF>>2]=aO|1;c[aC>>2]=aK;aX=aL}LF(aX|0,aN|0,aK)|0;a[aX+aK|0]=0;z=0,az(88,m|0,9088,1)|0;if(z){z=0;_=101;break L95}if((a[ag]&1)==0){break}Lw(c[aE>>2]|0)}}while(0);aP=a[am]|0;aK=(aP&1)==0?ak:c[al>>2]|0;aN=aP&255;aP=(aN&1|0)==0?aN>>>1:c[aC>>2]|0;z=0,az(88,b|0,aK|0,aP|0)|0;if(z){z=0;_=112;break L95}if((a[am]&1)==0){break}Lw(c[al>>2]|0)}else{z=0,az(88,b|0,2360,3)|0;if(z){z=0;_=55;break L95}}}while(0);z=0,aM(542,ah|0,38304)|0;if(z){z=0;_=55;break}}do{if((_|0)==55){aC=bT(-1,-1)|0;aY=M;aZ=aC;_=57;break L93}else if((_|0)==94){z=0;ar(86,0);if(z){z=0;aC=bT(-1,-1)|0;a_=M;a$=aC;break}}else if((_|0)==101){aC=bT(-1,-1)|0;a_=M;a$=aC}else if((_|0)==112){aC=bT(-1,-1)|0;ak=aC;aC=M;if((a[am]&1)==0){a0=ak;a1=aC;break L93}Lw(c[al>>2]|0);a0=ak;a1=aC;break L93}else if((_|0)==116){z=0;aq(30,n|0,e|0,Y|0,1,0);if(z){z=0;_=56;break L93}aC=a[n]|0;ak=aC&255;if((ak&1|0)==0){a2=ak>>>1}else{a2=c[n+4>>2]|0}ak=(aC&1)==0;if(ak){a3=n+1|0}else{a3=c[n+8>>2]|0}aC=a2>>>0>1>>>0;aF=LH(a3|0,856,(aC?1:a2)|0)|0;if((aF|0)==0){a4=(a2|0)==0?-1:aC&1}else{a4=aF}if(!ak){Lw(c[n+8>>2]|0)}L162:do{if((a4|0)==0){ak=a[T]|0;aF=ak&255;if((aF&1|0)==0){a5=aF>>>1}else{a5=c[e+4>>2]|0}L168:do{if(a5>>>0>Y>>>0){if((ak&1)==0){a6=S+1|0}else{a6=c[e+8>>2]|0}aF=a6+a5|0;if((a5|0)==(Y|0)){a7=-1;break}aC=a6+Y|0;L175:while(1){aD=6160;while(1){if((aD|0)==6166){break}if((a[aC]|0)==(a[aD]|0)){break L175}else{aD=aD+1|0}}aD=aC+1|0;if((aD|0)==(aF|0)){a7=-1;break L168}else{aC=aD}}if((aC|0)==(aF|0)){a7=-1;break}a7=aC-a6|0}else{a7=-1}}while(0);z=0;aq(30,r|0,e|0,Y+1|0,a7+~Y|0,0);if(z){z=0;_=56;break L93}z=0;aR(210,q|0,l|0,r|0);do{if(!z){ak=p;LI(ak|0,0,12)|0;aD=q;aG=a[aD]|0;aB=aG&255;if((aB&1|0)==0){a8=aB>>>1}else{a8=c[q+4>>2]|0}if((aG&1)==0){a9=q+1|0}else{a9=c[q+8>>2]|0}aG=a8+1|0;do{if(aG>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;_=159;break}}else{if(aG>>>0<11>>>0){a[ak]=a8<<1;ba=p+1|0}else{aB=a8+17&-16;ax=(z=0,au(248,aB|0)|0);if(z){z=0;_=159;break}c[p+8>>2]=ax;c[p>>2]=aB|1;c[p+4>>2]=a8;ba=ax}LF(ba|0,a9|0,a8)|0;a[ba+a8|0]=0;z=0,az(88,p|0,856,1)|0;if(z){z=0;_=159;break}z=0;aq(30,s|0,e|0,a7|0,-1|0,0);do{if(!z){z=0;aR(210,o|0,p|0,s|0);do{if(!z){z=0,aM(344,e|0,o|0)|0;if(z){z=0;ax=bT(-1,-1)|0;aB=ax;ax=M;if((a[o]&1)==0){bb=aB;bc=ax;break}Lw(c[o+8>>2]|0);bb=aB;bc=ax;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}if((a[ak]&1)!=0){Lw(c[p+8>>2]|0)}if((a[aD]&1)!=0){Lw(c[q+8>>2]|0)}if((a[r]&1)==0){break L162}Lw(c[r+8>>2]|0);break L162}else{z=0;ax=bT(-1,-1)|0;bb=ax;bc=M}}while(0);if((a[s]&1)==0){bd=bb;be=bc;break}Lw(c[s+8>>2]|0);bd=bb;be=bc}else{z=0;ax=bT(-1,-1)|0;bd=ax;be=M}}while(0);if((a[ak]&1)==0){bf=bd;bi=be;break}Lw(c[p+8>>2]|0);bf=bd;bi=be}}while(0);if((_|0)==159){aG=bT(-1,-1)|0;aC=M;if((a[ak]&1)!=0){Lw(c[p+8>>2]|0)}bf=aG;bi=aC}if((a[aD]&1)==0){bj=bf;bk=bi;break}Lw(c[q+8>>2]|0);bj=bf;bk=bi}else{z=0;aC=bT(-1,-1)|0;bj=aC;bk=M}}while(0);if((a[r]&1)==0){a0=bj;a1=bk;break L93}Lw(c[r+8>>2]|0);a0=bj;a1=bk;break L93}else{z=0;aq(30,t|0,e|0,Y|0,1,0);if(z){z=0;_=56;break L93}aC=a[t]|0;aG=aC&255;if((aG&1|0)==0){bl=aG>>>1}else{bl=c[t+4>>2]|0}aG=(aC&1)==0;if(aG){bm=t+1|0}else{bm=c[t+8>>2]|0}aC=bl>>>0>1>>>0;aF=LH(bm|0,80,(aC?1:bl)|0)|0;if((aF|0)==0){bn=(bl|0)==0?-1:aC&1}else{bn=aF}if(!aG){Lw(c[t+8>>2]|0)}if((bn|0)==0){aG=v;LI(aG|0,0,12)|0;aF=a[W]|0;aC=aF&255;ax=(aC&1|0)==0?aC>>>1:c[aI>>2]|0;if((aF&1)==0){bo=l+1|0}else{bo=c[l+8>>2]|0}aF=ax+7|0;do{if(aF>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(aF>>>0<11>>>0){a[aG]=ax<<1;bp=v+1|0}else{aC=ax+23&-16;aB=(z=0,au(248,aC|0)|0);if(z){z=0;break}c[v+8>>2]=aB;c[v>>2]=aC|1;c[v+4>>2]=ax;bp=aB}LF(bp|0,bo|0,ax)|0;a[bp+ax|0]=0;z=0,az(88,v|0,12704,7)|0;if(z){z=0;break}z=0;aq(30,w|0,e|0,Y+1|0,-1|0,0);do{if(!z){z=0;aR(210,u|0,v|0,w|0);do{if(!z){z=0,aM(344,e|0,u|0)|0;if(z){z=0;aB=bT(-1,-1)|0;aC=aB;aB=M;if((a[u]&1)==0){bq=aC;br=aB;break}Lw(c[u+8>>2]|0);bq=aC;br=aB;break}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}if((a[aG]&1)==0){break L162}Lw(c[v+8>>2]|0);break L162}else{z=0;aB=bT(-1,-1)|0;bq=aB;br=M}}while(0);if((a[w]&1)==0){bs=bq;bt=br;break}Lw(c[w+8>>2]|0);bs=bq;bt=br}else{z=0;aB=bT(-1,-1)|0;bs=aB;bt=M}}while(0);if((a[aG]&1)==0){a0=bs;a1=bt;break L93}Lw(c[v+8>>2]|0);a0=bs;a1=bt;break L93}}while(0);ax=bT(-1,-1)|0;aF=M;if((a[aG]&1)==0){aY=aF;aZ=ax;_=57;break L93}Lw(c[v+8>>2]|0);aY=aF;aZ=ax;_=57;break L93}z=0;aq(30,x|0,e|0,Y|0,1,0);if(z){z=0;_=56;break L93}ax=a[x]|0;aF=ax&255;if((aF&1|0)==0){bu=aF>>>1}else{bu=c[x+4>>2]|0}aF=(ax&1)==0;if(aF){bv=x+1|0}else{bv=c[x+8>>2]|0}ax=bu>>>0>1>>>0;aD=LH(bv|0,11808,(ax?1:bu)|0)|0;if((aD|0)==0){bw=(bu|0)==0?-1:ax&1}else{bw=aD}if(!aF){Lw(c[x+8>>2]|0)}if((bw|0)==0){aF=A;LI(aF|0,0,12)|0;aD=a[W]|0;ax=aD&255;ak=(ax&1|0)==0?ax>>>1:c[aI>>2]|0;if((aD&1)==0){bx=l+1|0}else{bx=c[l+8>>2]|0}aD=ak+9|0;do{if(aD>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(aD>>>0<11>>>0){a[aF]=ak<<1;by=A+1|0}else{ax=ak+25&-16;aB=(z=0,au(248,ax|0)|0);if(z){z=0;break}c[A+8>>2]=aB;c[A>>2]=ax|1;c[A+4>>2]=ak;by=aB}LF(by|0,bx|0,ak)|0;a[by+ak|0]=0;z=0,az(88,A|0,11176,9)|0;if(z){z=0;break}z=0;aq(30,B|0,e|0,Y+1|0,-1|0,0);do{if(!z){z=0;aR(210,y|0,A|0,B|0);do{if(!z){z=0,aM(344,e|0,y|0)|0;if(z){z=0;aB=bT(-1,-1)|0;ax=aB;aB=M;if((a[y]&1)==0){bz=ax;bA=aB;break}Lw(c[y+8>>2]|0);bz=ax;bA=aB;break}if((a[y]&1)!=0){Lw(c[y+8>>2]|0)}if((a[B]&1)!=0){Lw(c[B+8>>2]|0)}if((a[aF]&1)==0){break L162}Lw(c[A+8>>2]|0);break L162}else{z=0;aB=bT(-1,-1)|0;bz=aB;bA=M}}while(0);if((a[B]&1)==0){bB=bz;bC=bA;break}Lw(c[B+8>>2]|0);bB=bz;bC=bA}else{z=0;aB=bT(-1,-1)|0;bB=aB;bC=M}}while(0);if((a[aF]&1)==0){a0=bB;a1=bC;break L93}Lw(c[A+8>>2]|0);a0=bB;a1=bC;break L93}}while(0);ak=bT(-1,-1)|0;aD=M;if((a[aF]&1)==0){aY=aD;aZ=ak;_=57;break L93}Lw(c[A+8>>2]|0);aY=aD;aZ=ak;_=57;break L93}z=0;aq(30,C|0,e|0,Y|0,7,0);if(z){z=0;_=56;break L93}ak=a[C]|0;aD=ak&255;if((aD&1|0)==0){bD=aD>>>1}else{bD=c[C+4>>2]|0}aD=(ak&1)==0;if(aD){bE=C+1|0}else{bE=c[C+8>>2]|0}ak=bD>>>0>7>>>0;aG=LH(bE|0,10856,(ak?7:bD)|0)|0;if((aG|0)==0){bF=bD>>>0<7>>>0?-1:ak&1}else{bF=aG}if(!aD){Lw(c[C+8>>2]|0)}if((bF|0)!=0){break}aD=Y+7|0;aG=a[T]|0;ak=aG&255;aB=(ak&1|0)==0;if(aB){bG=ak>>>1}else{bG=c[e+4>>2]|0}L373:do{if(bG>>>0>aD>>>0){if((aG&1)==0){bH=S+1|0}else{bH=c[e+8>>2]|0}ax=bH+bG|0;if((bG|0)==(aD|0)){bI=-1;break}aC=bH+aD|0;L380:while(1){Z=6160;while(1){if((Z|0)==6166){break}if((a[aC]|0)==(a[Z]|0)){break L380}else{Z=Z+1|0}}Z=aC+1|0;if((Z|0)==(ax|0)){bI=-1;break L373}else{aC=Z}}if((aC|0)==(ax|0)){bI=-1;break}bI=aC-bH|0}else{bI=-1}}while(0);if(aB){bJ=ak>>>1}else{bJ=c[e+4>>2]|0}L393:do{if(bJ>>>0>bI>>>0){if((aG&1)==0){bK=S+1|0}else{bK=c[e+8>>2]|0}aD=bK+bJ|0;aF=bK+bI|0;while(1){if((aF|0)==(aD|0)){bL=-1;break L393}if((bh(6160,d[aF]|0,6)|0)==0){break}else{aF=aF+1|0}}bL=aF-bK|0}else{bL=-1}}while(0);z=0;aq(30,D|0,e|0,bL|0,1,0);if(z){z=0;_=56;break L93}aG=a[D]|0;ak=aG&255;if((ak&1|0)==0){bM=ak>>>1}else{bM=c[D+4>>2]|0}ak=(aG&1)==0;if(ak){bN=D+1|0}else{bN=c[D+8>>2]|0}aG=bM>>>0>1>>>0;aB=LH(bN|0,10648,(aG?1:bM)|0)|0;if((aB|0)==0){bO=(bM|0)==0?-1:aG&1}else{bO=aB}if(!ak){Lw(c[D+8>>2]|0)}if((bO|0)==0){break}ak=a[T]|0;aB=ak&255;if((aB&1|0)==0){bP=aB>>>1}else{bP=c[e+4>>2]|0}if((ak&1)==0){bQ=S+1|0}else{bQ=c[e+8>>2]|0}ak=bQ+bP|0;while(1){if((ak|0)==(bQ|0)){bR=-1;break}bS=ak-1|0;if((bh(6160,d[bS]|0,6)|0)==0){_=331;break}else{ak=bS}}if((_|0)==331){bR=bS-bQ|0}z=0;aq(30,I|0,e|0,0,bL|0,0);if(z){z=0;_=56;break L93}ak=H;LI(ak|0,0,12)|0;aB=a[I]|0;aG=aB&255;if((aG&1|0)==0){bU=aG>>>1}else{bU=c[I+4>>2]|0}aG=(aB&1)==0;if(aG){bV=I+1|0}else{bV=c[I+8>>2]|0}aB=bU+1|0;do{if(aB>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;_=347;break}}else{if(aB>>>0<11>>>0){a[ak]=bU<<1;bW=H+1|0}else{aD=bU+17&-16;aC=(z=0,au(248,aD|0)|0);if(z){z=0;_=347;break}c[H+8>>2]=aC;c[H>>2]=aD|1;c[H+4>>2]=bU;bW=aC}LF(bW|0,bV|0,bU)|0;a[bW+bU|0]=0;z=0,az(88,H|0,10648,1)|0;if(z){z=0;_=347;break}z=0;aq(30,J|0,e|0,bL|0,1-bL+bR|0,0);do{if(!z){z=0;aR(210,G|0,H|0,J|0);do{if(!z){aC=F;LI(aC|0,0,12)|0;aD=G;ax=a[aD]|0;Z=ax&255;if((Z&1|0)==0){bX=Z>>>1}else{bX=c[G+4>>2]|0}if((ax&1)==0){bY=G+1|0}else{bY=c[G+8>>2]|0}ax=bX+1|0;do{if(ax>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;_=365;break}}else{if(ax>>>0<11>>>0){a[aC]=bX<<1;bZ=F+1|0}else{Z=bX+17&-16;ae=(z=0,au(248,Z|0)|0);if(z){z=0;_=365;break}c[F+8>>2]=ae;c[F>>2]=Z|1;c[F+4>>2]=bX;bZ=ae}LF(bZ|0,bY|0,bX)|0;a[bZ+bX|0]=0;z=0,az(88,F|0,10648,1)|0;if(z){z=0;_=365;break}z=0,aM(344,e|0,F|0)|0;if(z){z=0;ae=bT(-1,-1)|0;Z=ae;ae=M;if((a[aC]&1)==0){b_=Z;b$=ae;break}Lw(c[F+8>>2]|0);b_=Z;b$=ae;break}if((a[aC]&1)!=0){Lw(c[F+8>>2]|0)}if((a[aD]&1)!=0){Lw(c[G+8>>2]|0)}if((a[J]&1)!=0){Lw(c[J+8>>2]|0)}if((a[ak]&1)!=0){Lw(c[H+8>>2]|0)}if(aG){break L162}Lw(c[I+8>>2]|0);break L162}}while(0);if((_|0)==365){ax=bT(-1,-1)|0;ae=M;if((a[aC]&1)!=0){Lw(c[F+8>>2]|0)}b_=ax;b$=ae}if((a[aD]&1)==0){b0=b_;b1=b$;break}Lw(c[G+8>>2]|0);b0=b_;b1=b$}else{z=0;ae=bT(-1,-1)|0;b0=ae;b1=M}}while(0);if((a[J]&1)==0){b2=b0;b3=b1;break}Lw(c[J+8>>2]|0);b2=b0;b3=b1}else{z=0;ae=bT(-1,-1)|0;b2=ae;b3=M}}while(0);if((a[ak]&1)==0){b4=b2;b5=b3;break}Lw(c[H+8>>2]|0);b4=b2;b5=b3}}while(0);if((_|0)==347){aB=bT(-1,-1)|0;aF=M;if((a[ak]&1)!=0){Lw(c[H+8>>2]|0)}b4=aB;b5=aF}if(aG){a0=b4;a1=b5;break L93}Lw(c[I+8>>2]|0);a0=b4;a1=b5;break L93}}while(0);z=0;aq(30,K|0,e|0,Y|0,2,0);if(z){z=0;_=56;break L93}aF=d[W]|0;aB=(aF&1|0)==0;ae=(c[V>>2]|0)-1+(c[U>>2]|0)|0;ax=(c[af>>2]|0)+(((ae>>>0)/341|0)<<2)|0;Z=c[ax>>2]|0;aP=(ae>>>0)%341|0;ae=d[Z+(aP*12|0)|0]|0;if((ae&1|0)==0){b6=ae>>>1}else{b6=c[Z+(aP*12|0)+4>>2]|0}do{if((aB?aF>>>1:c[aI>>2]|0)>>>0>=b6>>>0){Z=d[aj]|0;if((Z&1|0)==0){b7=Z>>>1}else{b7=c[aH>>2]|0}if((b7|0)!=0){break}a[f+5|0]=1}}while(0);Z=c[ax>>2]|0;ae=d[Z+(aP*12|0)|0]|0;aK=(ae&1|0)==0;if(aK){b8=ae>>>1}else{b8=c[Z+(aP*12|0)+4>>2]|0}L530:do{if((aB?aF>>>1:c[aI>>2]|0)>>>0>b8>>>0){aN=ah;aL=a[aj]|0;aO=aL&255;aJ=(aO&1|0)==0;if(aJ){b9=aO>>>1}else{b9=c[aH>>2]|0}if((b9|0)!=0){if(aJ){ca=aO>>>1}else{ca=c[aH>>2]|0}aQ=(aL&1)==0;if(aQ){cb=aN+1|0}else{cb=c[f+16>>2]|0}aL=ca>>>0>2>>>0;if((LH(cb|0,5304,(aL?2:ca)|0)|0)==0){if(ca>>>0>1>>>0&(aL^1)){_=484;break}}if(aJ){cc=aO>>>1}else{cc=c[aH>>2]|0}if(aQ){cd=aN+1|0}else{cd=c[f+16>>2]|0}aN=cc>>>0>2>>>0;do{if((LH(cd|0,3728,(aN?2:cc)|0)|0)==0){if(!(cc>>>0>1>>>0&(aN^1))){break}if((c[ao>>2]&128|0)!=0){_=484;break L530}}}while(0);if(aK){ce=ae>>>1}else{ce=c[Z+(aP*12|0)+4>>2]|0}if((a[T]&1)==0){cf=S+1|0}else{cf=c[e+8>>2]|0}a[cf+ce|0]=47;aN=(c[V>>2]|0)-1+(c[U>>2]|0)|0;aG=c[(c[af>>2]|0)+(((aN>>>0)/341|0)<<2)>>2]|0;ak=(aN>>>0)%341|0;aN=d[aG+(ak*12|0)|0]|0;if((aN&1|0)==0){cg=aN>>>1}else{cg=c[aG+(ak*12|0)+4>>2]|0}if((a[T]&1)==0){ch=S+1|0}else{ch=c[e+8>>2]|0}a[ch+(cg+1)|0]=47;_=484;break}ak=h;aG=c[ao>>2]&-249;L578:do{if((aG|0)==0){a[L]=6;aN=L+1|0;a[aN]=a[9752]|0;a[aN+1|0]=a[9753]|0;a[aN+2|0]=a[9754]|0;a[L+4|0]=0}else{if((aG|0)<3){aN=L;a[L]=4;aQ=aN+1|0;E=31520;a[aQ]=E;E=E>>8;a[aQ+1|0]=E;a[aN+3|0]=0;break}z=0;aR(26,h|0,8096,Z+(aP*12|0)|0);if(z){z=0;_=402;break L530}aN=L;LI(aN|0,0,12)|0;aQ=a[ak]|0;aO=aQ&255;if((aO&1|0)==0){ci=aO>>>1}else{ci=c[h+4>>2]|0}if((aQ&1)==0){cj=h+1|0}else{cj=c[h+8>>2]|0}aQ=ci+1|0;do{if(aQ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(aQ>>>0<11>>>0){a[aN]=ci<<1;ck=L+1|0}else{aO=ci+17&-16;aJ=(z=0,au(248,aO|0)|0);if(z){z=0;break}c[L+8>>2]=aJ;c[L>>2]=aO|1;c[L+4>>2]=ci;ck=aJ}LF(ck|0,cj|0,ci)|0;a[ck+ci|0]=0;z=0,az(88,L|0,9536,1)|0;if(z){z=0;break}if((a[ak]&1)==0){break L578}Lw(c[h+8>>2]|0);break L578}}while(0);aQ=bT(-1,-1)|0;aJ=M;if((a[aN]&1)!=0){Lw(c[L+8>>2]|0)}if((a[ak]&1)==0){cl=aJ;cm=aQ;_=403;break L530}Lw(c[h+8>>2]|0);cl=aJ;cm=aQ;_=403;break L530}}while(0);ak=L;aG=a[ak]|0;if((aG&1)==0){cn=L+1|0}else{cn=c[L+8>>2]|0}aQ=aG&255;if((aQ&1|0)==0){co=aQ>>>1}else{co=c[L+4>>2]|0}z=0,az(88,b|0,cn|0,co|0)|0;if(z){z=0;aQ=bT(-1,-1)|0;aG=aQ;aQ=M;if((a[ak]&1)==0){cp=aG;cq=aQ;break}Lw(c[L+8>>2]|0);cp=aG;cq=aQ;break}if((a[ak]&1)!=0){Lw(c[L+8>>2]|0)}ak=N;a[ak]=0;a[N+1|0]=0;z=0;as(330,X|0,N|0);if(z){z=0;aQ=bT(-1,-1)|0;aG=aQ;aQ=M;if((a[ak]&1)==0){cp=aG;cq=aQ;break}Lw(c[N+8>>2]|0);cp=aG;cq=aQ;break}if((a[ak]&1)!=0){Lw(c[N+8>>2]|0)}ak=(c[V>>2]|0)-1+(c[U>>2]|0)|0;aQ=(c[(c[af>>2]|0)+(((ak>>>0)/341|0)<<2)>>2]|0)+(((ak>>>0)%341|0)*12|0)|0;z=0,aM(344,aQ|0,l|0)|0;if(!z){_=484}else{z=0;_=402}}else{_=484}}while(0);L632:do{if((_|0)==484){aP=K;Z=K;ae=a[Z]|0;aK=ae&255;aF=(aK&1|0)==0;if(aF){cr=aK>>>1}else{cr=c[K+4>>2]|0}aB=(ae&1)==0;if(aB){cs=aP+1|0}else{cs=c[K+8>>2]|0}ae=cr>>>0>2>>>0;if((LH(cs|0,5304,(ae?2:cr)|0)|0)==0){if(cr>>>0>1>>>0&(ae^1)){_=500}else{_=492}}else{_=492}do{if((_|0)==492){if(aF){ct=aK>>>1}else{ct=c[K+4>>2]|0}if(aB){cu=aP+1|0}else{cu=c[K+8>>2]|0}ae=ct>>>0>2>>>0;if((LH(cu|0,3728,(ae?2:ct)|0)|0)!=0){break}if(ct>>>0>1>>>0&(ae^1)){_=500}}}while(0);if((_|0)==500){a[f+5|0]=0;aP=ah;aB=a[aj]|0;ae=aB&255;ax=(ae&1|0)==0;if(ax){cv=ae>>>1}else{cv=c[aH>>2]|0}aQ=(aB&1)==0;if(aQ){cw=aP+1|0}else{cw=c[f+16>>2]|0}aB=cv>>>0>2>>>0;if((LH(cw|0,5304,(aB?2:cv)|0)|0)==0){if(cv>>>0>1>>>0&(aB^1)){_=517}else{_=508}}else{_=508}do{if((_|0)==508){if(ax){cx=ae>>>1}else{cx=c[aH>>2]|0}if(aQ){cy=aP+1|0}else{cy=c[f+16>>2]|0}aB=cx>>>0>2>>>0;if((LH(cy|0,3728,(aB?2:cx)|0)|0)!=0){break}if(!(cx>>>0>1>>>0&(aB^1))){break}if((c[ao>>2]&128|0)!=0){_=517}}}while(0);do{if((_|0)==517){if(aF){cz=aK>>>1}else{cz=c[K+4>>2]|0}if((cz|0)==0){break}if((c[ao>>2]&192|0)!=0){break}z=0,az(88,b|0,2360,3)|0;if(z){z=0;_=402;break L632}}}while(0);do{if((c[ao>>2]&128|0)!=0){aK=d[aj]|0;if((aK&1|0)==0){cA=aK>>>1}else{cA=c[aH>>2]|0}if((cA|0)!=0){break}if((a[T]&1)==0){cB=S+1|0}else{cB=c[e+8>>2]|0}a[cB+(Y+1)|0]=42}}while(0);z=0,aM(344,ah|0,K|0)|0;if(z){z=0;_=402;break}}aK=ah;aF=a[aj]|0;aP=aF&255;aQ=(aP&1|0)==0;if(aQ){cC=aP>>>1}else{cC=c[aH>>2]|0}if((cC|0)==0){_=538}else{if((c[ao>>2]&64|0)==0){_=538}}L707:do{if((_|0)==538){if(aQ){cD=aP>>>1}else{cD=c[aH>>2]|0}if((aF&1)==0){cE=aK+1|0}else{cE=c[f+16>>2]|0}ae=cD>>>0>2>>>0;do{if((LH(cE|0,3728,(ae?2:cD)|0)|0)==0){if(!(cD>>>0>1>>>0&(ae^1))){break}if((c[ao>>2]&160|0)==0){break L707}}}while(0);z=0;aR(100,O|0,e|0,f|0);if(z){z=0;_=402;break L632}ae=O;aN=a[ae]|0;if((aN&1)==0){cF=O+1|0}else{cF=c[O+8>>2]|0}ax=aN&255;if((ax&1|0)==0){cG=ax>>>1}else{cG=c[O+4>>2]|0}z=0,az(88,b|0,cF|0,cG|0)|0;if(!z){if((a[ae]&1)==0){break}Lw(c[O+8>>2]|0);break}else{z=0;ax=bT(-1,-1)|0;aN=ax;ax=M;if((a[ae]&1)==0){cp=aN;cq=ax;break L632}Lw(c[O+8>>2]|0);cp=aN;cq=ax;break L632}}}while(0);aK=a[T]|0;aF=aK&255;if((aF&1|0)==0){cH=aF>>>1}else{cH=c[e+4>>2]|0}if((aK&1)==0){cI=S+1|0}else{cI=c[e+8>>2]|0}aK=cI+cH|0;while(1){if((aK|0)==(cI|0)){break}cJ=aK-1|0;if((bh(6160,d[cJ]|0,6)|0)==0){_=568;break}else{aK=cJ}}do{if((_|0)==568){aK=cJ-cI|0;if((aK|0)==-1){break}z=0;aq(30,P|0,e|0,aK|0,1,0);if(z){z=0;_=402;break L632}aF=d[aj]|0;if((aF&1|0)==0){cK=aF>>>1}else{cK=c[aH>>2]|0}if((cK|0)==0){aF=a[P]|0;aP=aF&255;if((aP&1|0)==0){cL=aP>>>1}else{cL=c[P+4>>2]|0}if((aF&1)==0){cM=P+1|0}else{cM=c[P+8>>2]|0}aF=cL>>>0>1>>>0;aP=LH(cM|0,10392,(aF?1:cL)|0)|0;if((aP|0)==0){cN=(cL|0)==0?-1:aF&1}else{cN=aP}cO=(cN|0)==0|0}else{cO=0}a[f+4|0]=cO;L769:do{if((aK|0)>0){z=0;aq(30,Q|0,e|0,aK-1|0,2,0);L771:do{if(!z){aP=a[Q]|0;aF=aP&255;if((aF&1|0)==0){cP=aF>>>1}else{cP=c[Q+4>>2]|0}aF=(aP&1)==0;if(aF){cQ=Q+1|0}else{cQ=c[Q+8>>2]|0}aP=cP>>>0>2>>>0;do{if((LH(cQ|0,10128,(aP?2:cP)|0)|0)==0){if(!(cP>>>0>1>>>0&(aP^1))){break}z=0,aM(542,ah|0,38304)|0;if(!z){break}else{z=0}aQ=bT(-1,-1)|0;ax=aQ;aQ=M;if(aF){cR=ax;cS=aQ;break L771}Lw(c[Q+8>>2]|0);cR=ax;cS=aQ;break L771}}while(0);if(aF){break L769}Lw(c[Q+8>>2]|0);break L769}else{z=0;aP=bT(-1,-1)|0;cR=aP;cS=M}}while(0);if((a[P]&1)==0){cp=cR;cq=cS;break L632}Lw(c[P+8>>2]|0);cp=cR;cq=cS;break L632}}while(0);if((a[P]&1)==0){break}Lw(c[P+8>>2]|0)}}while(0);if((a[Z]&1)!=0){Lw(c[K+8>>2]|0)}if((a[W]&1)==0){i=g;return}Lw(c[l+8>>2]|0);i=g;return}}while(0);if((_|0)==402){aK=bT(-1,-1)|0;cl=M;cm=aK;_=403}if((_|0)==403){cp=cm;cq=cl}if((a[K]&1)==0){a0=cp;a1=cq;break L93}Lw(c[K+8>>2]|0);a0=cp;a1=cq;break L93}}while(0);if((a[am]&1)!=0){Lw(c[al>>2]|0)}if((a[ag]&1)==0){aY=a_;aZ=a$;_=57;break}Lw(c[aE>>2]|0);aY=a_;aZ=a$;_=57}}while(0);if((_|0)==56){ah=bT(-1,-1)|0;aY=M;aZ=ah;_=57}if((_|0)==57){a0=aZ;a1=aY}if((a[W]&1)==0){ab=a0;ac=a1;break}Lw(c[l+8>>2]|0);ab=a0;ac=a1}}while(0);if((_|0)==23){_=bT(-1,-1)|0;ab=_;ac=M}if((a[R]&1)==0){cT=ab;cU=0;cV=cT;cW=ac;bg(cV|0)}Lw(c[b+8>>2]|0);cT=ab;cU=0;cV=cT;cW=ac;bg(cV|0)}function Am(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;e=i;i=i+16|0;f=e|0;g=f;h=i;i=i+12|0;i=i+7&-8;j=i;i=i+144|0;k=i;i=i+60|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+12|0;i=i+7&-8;LI(g|0,0,12)|0;p=h;a[p]=0;q=h+1|0;a[q]=0;r=j+64|0;s=j|0;t=j+8|0;c[t>>2]=15464;u=j+12|0;c[s>>2]=32540;v=j+64|0;c[v>>2]=32560;c[j+4>>2]=0;z=0;as(198,j+64|0,u|0);L1:do{if(!z){c[j+136>>2]=0;c[j+140>>2]=-1;w=j+8|0;c[s>>2]=15444;c[r>>2]=15484;c[t>>2]=15464;x=u|0;c[x>>2]=15768;y=j+16|0;I_(y);LI(j+20|0,0,24)|0;c[x>>2]=15624;A=j+44|0;LI(j+44|0,0,16)|0;c[j+60>>2]=24;z=0;as(212,u|0,b|0);if(z){z=0;B=bT(-1,-1)|0;C=M;if((a[A]&1)!=0){Lw(c[j+52>>2]|0)}c[x>>2]=15768;z=0;ar(394,y|0);if(!z){D=B;E=C;F=8;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}LI(k+24|0,0,36)|0;a[k+4|0]=0;a[k+5|0]=0;C=k+20|0;B=k+8|0;LI(k+8|0,0,13)|0;z=0,aM(542,B|0,38304)|0;L11:do{if(!z){B=k+24|0;z=0,aM(542,B|0,38304)|0;if(z){z=0;F=27;break}B=l;a[B]=0;a[l+1|0]=0;z=0;as(330,k+36|0,l|0);if(z){z=0;x=bT(-1,-1)|0;G=x;x=M;if((a[B]&1)==0){H=x;I=G;F=63;break}Lw(c[l+8>>2]|0);H=x;I=G;F=63;break}if((a[B]&1)!=0){Lw(c[l+8>>2]|0)}c[k>>2]=d;B=j;G=m;x=m+1|0;J=m+8|0;K=m+4|0;while(1){L=(z=0,az(44,B|0,f|0,10)|0);if(z){z=0;F=26;break}if((c[L+((c[(c[L>>2]|0)-12>>2]|0)+16)>>2]&5|0)!=0){F=33;break}z=0;aR(78,m|0,f|0,k|0);if(z){z=0;F=26;break}L=a[G]|0;N=L&255;z=0,az(88,h|0,((L&1)==0?x:c[J>>2]|0)|0,((N&1|0)==0?N>>>1:c[K>>2]|0)|0)|0;if(z){z=0;F=31;break}if((a[G]&1)==0){continue}Lw(c[J>>2]|0)}if((F|0)==31){K=bT(-1,-1)|0;x=K;K=M;if((a[G]&1)==0){H=K;I=x;F=63;break}Lw(c[J>>2]|0);H=K;I=x;F=63;break}else if((F|0)==26){x=bT(-1,-1)|0;O=M;P=x;F=28;break}else if((F|0)==33){x=n;a[x]=0;a[n+1|0]=0;a[C]=1;z=0;aR(78,o|0,n|0,k|0);do{if(!z){K=o;B=a[K]|0;if((B&1)==0){Q=o+1|0}else{Q=c[o+8>>2]|0}N=B&255;if((N&1|0)==0){R=N>>>1}else{R=c[o+4>>2]|0}z=0,az(88,h|0,Q|0,R|0)|0;if(z){z=0;N=bT(-1,-1)|0;B=N;N=M;if((a[K]&1)==0){S=N;T=B;break}Lw(c[o+8>>2]|0);S=N;T=B;break}if((a[K]&1)!=0){Lw(c[o+8>>2]|0)}K=a[p]|0;B=K&255;if((B&1|0)==0){U=B>>>1}else{U=c[h+4>>2]|0}B=(z=0,au(88,U+1|0)|0);if(z){z=0;F=51;break}if((K&1)==0){V=q}else{V=c[h+8>>2]|0}LK(B|0,V|0)|0;if((a[x]&1)!=0){Lw(c[n+8>>2]|0)}z=0;ar(246,k|0);if(z){z=0;K=bT(-1,-1)|0;W=M;X=K;F=66;break L11}c[s>>2]=15444;c[v>>2]=15484;c[w>>2]=15464;K=j+12|0;c[K>>2]=15624;if((a[A]&1)!=0){Lw(c[j+52>>2]|0)}c[K>>2]=15768;z=0;ar(394,y|0);if(z){z=0;K=bT(-1,-1)|0;N=M;z=0;ar(272,j+64|0);if(!z){Y=N;Z=K;F=24;break L1}else{z=0}bT(-1,-1,0)|0;bX();return 0}z=0;ar(272,j+64|0);if(z){z=0;K=bT(-1,-1)|0;Y=M;Z=K;F=24;break L1}if((a[p]&1)!=0){Lw(c[h+8>>2]|0)}if((a[g]&1)==0){i=e;return B|0}Lw(c[f+8>>2]|0);i=e;return B|0}else{z=0;F=51}}while(0);if((F|0)==51){J=bT(-1,-1)|0;S=M;T=J}if((a[x]&1)==0){H=S;I=T;F=63;break}Lw(c[n+8>>2]|0);H=S;I=T;F=63;break}}else{z=0;F=27}}while(0);if((F|0)==27){C=bT(-1,-1)|0;O=M;P=C;F=28}if((F|0)==28){H=O;I=P;F=63}if((F|0)==63){z=0;ar(246,k|0);if(!z){W=H;X=I;F=66}else{z=0}}do{if((F|0)==66){c[s>>2]=15444;c[v>>2]=15484;c[w>>2]=15464;C=j+12|0;c[C>>2]=15624;if((a[A]&1)!=0){Lw(c[j+52>>2]|0)}c[C>>2]=15768;z=0;ar(394,y|0);if(!z){z=0;ar(272,j+64|0);if(!z){_=W;$=X;break L1}else{z=0;break}}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,j+64|0);if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);bT(-1,-1,0)|0;bX();return 0}else{z=0;y=bT(-1,-1)|0;D=y;E=M;F=8}}while(0);do{if((F|0)==8){z=0;ar(272,r|0);if(!z){Y=E;Z=D;F=24;break}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);if((F|0)==24){_=Y;$=Z}if((a[p]&1)!=0){Lw(c[h+8>>2]|0)}if((a[g]&1)==0){aa=$;ab=0;ac=aa;ad=_;bg(ac|0)}Lw(c[f+8>>2]|0);aa=$;ab=0;ac=aa;ad=_;bg(ac|0);return 0}function An(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;i=c[h+(g+16)>>2]|0;do{if((i|0)==0){j=c[h+(g+72)>>2]|0;if((j|0)==0){k=g}else{z=0,au(62,j|0)|0;if(z){z=0;l=16;break}k=c[(c[f>>2]|0)-12>>2]|0}if((c[h+(k+16)>>2]|0)!=0){return b|0}j=d;if((a[j]&1)==0){m=d+1|0;a[m]=0;a[j]=0;n=m;o=d+4|0;p=d+8|0}else{m=d+8|0;a[c[m>>2]|0]=0;q=d+4|0;c[q>>2]=0;n=d+1|0;o=q;p=m}m=d|0;q=0;while(1){r=c[h+((c[(c[f>>2]|0)-12>>2]|0)+24)>>2]|0;s=r+12|0;t=c[s>>2]|0;if((t|0)==(c[r+16>>2]|0)){u=(z=0,au(c[(c[r>>2]|0)+40>>2]|0,r|0)|0);if(z){z=0;l=15;break}if((u|0)==-1){v=q;w=2;break}else{x=u&255}}else{c[s>>2]=t+1;x=a[t]|0}t=q+1|0;if(x<<24>>24==e<<24>>24){v=t;w=0;break}s=a[j]|0;if((s&1)==0){y=(s&255)>>>1;A=10}else{y=c[o>>2]|0;A=(c[m>>2]&-2)-1|0}if((y|0)==(A|0)){z=0;aI(46,d|0,A|0,1,A|0,A|0,0,0);if(z){z=0;l=15;break}B=a[j]|0}else{B=s}if((B&1)==0){a[j]=(y<<1)+2;C=n;D=y+1|0}else{s=c[p>>2]|0;u=y+1|0;c[o>>2]=u;C=s;D=u}a[C+y|0]=x;a[C+D|0]=0;if((a[j]&1)==0){q=t;continue}if((c[o>>2]|0)==-17){v=t;w=4;break}else{q=t}}if((l|0)==15){q=bT(-1,-1,0)|0;E=M;F=q;break}q=c[(c[f>>2]|0)-12>>2]|0;z=0;as(368,h+q|0,c[h+(q+16)>>2]|((v|0)==0?w|4:w)|0);if(z){z=0;l=16;break}return b|0}else{z=0;as(368,h+g|0,i|4|0);if(z){z=0;l=16;break}return b|0}}while(0);if((l|0)==16){l=bT(-1,-1,0)|0;E=M;F=l}bD(F|0)|0;z=0;ar(182,h+(c[(c[f>>2]|0)-12>>2]|0)|0);if(!z){a$();return b|0}else{z=0}b=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(b|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function Ao(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=b+8|0;f=c[e>>2]|0;g=b+4|0;h=c[g>>2]|0;i=f-h>>2;if((i|0)==0){j=0}else{j=(i*341|0)-1|0}i=b+16|0;k=c[i>>2]|0;l=b+20|0;m=c[l>>2]|0;if((j|0)==(m+k|0)){Ap(b);n=c[l>>2]|0;o=c[i>>2]|0;p=c[g>>2]|0;q=c[e>>2]|0}else{n=m;o=k;p=h;q=f}f=o+n|0;if((q|0)==(p|0)){r=c[l>>2]|0;s=r+1|0;c[l>>2]=s;return}q=c[p+(((f>>>0)/341|0)<<2)>>2]|0;p=(f>>>0)%341|0;f=q+(p*12|0)|0;if((f|0)==0){r=c[l>>2]|0;s=r+1|0;c[l>>2]=s;return}n=d;if((a[n]&1)==0){o=f;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];r=c[l>>2]|0;s=r+1|0;c[l>>2]=s;return}n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[f]=o<<1;t=f+1|0}else{d=o+16&-16;h=Lu(d)|0;c[q+(p*12|0)+8>>2]=h;c[f>>2]=d|1;c[q+(p*12|0)+4>>2]=o;t=h}LF(t|0,n|0,o)|0;a[t+o|0]=0;r=c[l>>2]|0;s=r+1|0;c[l>>2]=s;return}function Ap(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;b=i;i=i+32|0;d=b|0;e=b+8|0;f=a+16|0;g=c[f>>2]|0;if(g>>>0>340>>>0){c[f>>2]=g-341;g=a+4|0;f=c[g>>2]|0;h=c[f>>2]|0;j=f+4|0;c[g>>2]=j;k=a+8|0;l=c[k>>2]|0;m=a+12|0;do{if((l|0)==(c[m>>2]|0)){n=a|0;o=c[n>>2]|0;if(j>>>0>o>>>0){p=j;q=((p-o>>2)+1|0)/-2|0;r=q+1|0;s=l-p|0;LG(f+(r<<2)|0,j|0,s|0)|0;p=f+(r+(s>>2)<<2)|0;c[k>>2]=p;c[g>>2]=(c[g>>2]|0)+(q<<2);t=p;break}p=l-o>>1;q=(p|0)==0?1:p;p=Lu(q<<2)|0;s=p+(q>>>2<<2)|0;r=p+(q<<2)|0;if((j|0)==(l|0)){u=s;v=o}else{o=j;q=s;do{if((q|0)==0){w=0}else{c[q>>2]=c[o>>2];w=q}q=w+4|0;o=o+4|0;}while((o|0)!=(l|0));u=q;v=c[n>>2]|0}c[n>>2]=p;c[g>>2]=s;c[k>>2]=u;c[m>>2]=r;if((v|0)==0){t=u;break}Lw(v);t=c[k>>2]|0}else{t=l}}while(0);if((t|0)==0){x=0}else{c[t>>2]=h;x=c[k>>2]|0}c[k>>2]=x+4;i=b;return}x=a|0;k=a+8|0;h=c[k>>2]|0;t=a+4|0;l=h-(c[t>>2]|0)>>2;v=a+12|0;u=v|0;m=c[u>>2]|0;g=a|0;a=m-(c[g>>2]|0)|0;if(l>>>0<a>>2>>>0){w=Lu(4092)|0;if((m|0)!=(h|0)){if((h|0)==0){y=0}else{c[h>>2]=w;y=c[k>>2]|0}c[k>>2]=y+4;i=b;return}c[d>>2]=w;Aq(x,d);d=c[t>>2]|0;x=c[d>>2]|0;w=d+4|0;c[t>>2]=w;y=c[k>>2]|0;do{if((y|0)==(c[u>>2]|0)){h=c[g>>2]|0;if(w>>>0>h>>>0){m=w;j=((m-h>>2)+1|0)/-2|0;f=j+1|0;o=y-m|0;LG(d+(f<<2)|0,w|0,o|0)|0;m=d+(f+(o>>2)<<2)|0;c[k>>2]=m;c[t>>2]=(c[t>>2]|0)+(j<<2);A=m;break}m=y-h>>1;j=(m|0)==0?1:m;m=Lu(j<<2)|0;o=m+(j>>>2<<2)|0;f=m+(j<<2)|0;if((w|0)==(y|0)){B=o;C=h}else{h=w;j=o;do{if((j|0)==0){D=0}else{c[j>>2]=c[h>>2];D=j}j=D+4|0;h=h+4|0;}while((h|0)!=(y|0));B=j;C=c[g>>2]|0}c[g>>2]=m;c[t>>2]=o;c[k>>2]=B;c[u>>2]=f;if((C|0)==0){A=B;break}Lw(C);A=c[k>>2]|0}else{A=y}}while(0);if((A|0)==0){E=0}else{c[A>>2]=x;E=c[k>>2]|0}c[k>>2]=E+4;i=b;return}E=a>>1;a=(E|0)==0?1:E;E=e+12|0;c[e+16>>2]=v;v=Lu(a<<2)|0;x=v;A=e|0;c[A>>2]=x;y=x+(l<<2)|0;C=e+8|0;c[C>>2]=y;B=e+4|0;c[B>>2]=y;c[E>>2]=x+(a<<2);D=(z=0,au(248,4092)|0);L52:do{if(!z){w=D;do{if((l|0)==(a|0)){d=y-v|0;if(y>>>0>x>>>0){h=x+(l+(((d>>2)+1|0)/-2|0)<<2)|0;c[C>>2]=h;c[B>>2]=h;F=h;break}h=d>>1;d=(h|0)==0?1:h;h=(z=0,au(248,d<<2|0)|0);if(z){z=0;G=43;break L52}r=h;h=r+(d>>>2<<2)|0;c[A>>2]=r;c[B>>2]=h;c[C>>2]=h;c[E>>2]=r+(d<<2);if((v|0)==0){F=h;break}Lw(v);F=h}else{F=y}}while(0);if((F|0)==0){H=0}else{c[F>>2]=w;H=c[C>>2]|0}c[C>>2]=H+4;f=c[k>>2]|0;while(1){if((f|0)==(c[t>>2]|0)){break}o=f-4|0;z=0;as(306,e|0,o|0);if(!z){f=o}else{z=0;G=51;break}}if((G|0)==51){w=bT(-1,-1)|0;o=w;w=M;m=c[B>>2]|0;j=c[C>>2]|0;if((m|0)==(j|0)){I=o;J=w;break}c[C>>2]=j+(~((j-4+(-m|0)|0)>>>2)<<2);I=o;J=w;break}w=c[g>>2]|0;c[g>>2]=c[A>>2];c[A>>2]=w;c[t>>2]=c[B>>2];c[B>>2]=f;o=c[k>>2]|0;c[k>>2]=c[C>>2];c[C>>2]=o;m=c[u>>2]|0;c[u>>2]=c[E>>2];c[E>>2]=m;if((f|0)!=(o|0)){c[C>>2]=o+(~((o-4+(-f|0)|0)>>>2)<<2)}if((w|0)==0){i=b;return}Lw(w);i=b;return}else{z=0;G=43}}while(0);do{if((G|0)==43){b=bT(-1,-1,0)|0;bD(b|0)|0;Lw(c[x+(l-1<<2)>>2]|0);z=0;aS(6);if(z){z=0}b=bT(-1,-1)|0;C=M;z=0;aS(2);if(!z){I=b;J=C;break}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);l=c[A>>2]|0;if((l|0)==0){K=I;L=0;N=K;O=J;bg(N|0)}Lw(l);K=I;L=0;N=K;O=J;bg(N|0)}function Aq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=a+4|0;e=c[d>>2]|0;f=a|0;do{if((e|0)==(c[f>>2]|0)){g=a+8|0;h=c[g>>2]|0;i=a+12|0;j=c[i>>2]|0;k=j;if(h>>>0<j>>>0){j=h;l=((k-j>>2)+1|0)/2|0;m=j-e|0;j=h+(l-(m>>2)<<2)|0;LG(j|0,e|0,m|0)|0;c[d>>2]=j;c[g>>2]=(c[g>>2]|0)+(l<<2);n=j;break}j=k-e>>1;k=(j|0)==0?1:j;j=Lu(k<<2)|0;l=j+((k+3|0)>>>2<<2)|0;m=j+(k<<2)|0;if((e|0)==(h|0)){o=l;p=e}else{k=e;q=l;do{if((q|0)==0){r=0}else{c[q>>2]=c[k>>2];r=q}q=r+4|0;k=k+4|0;}while((k|0)!=(h|0));o=q;p=c[f>>2]|0}c[f>>2]=j;c[d>>2]=l;c[g>>2]=o;c[i>>2]=m;if((p|0)==0){n=l;break}Lw(p);n=c[d>>2]|0}else{n=e}}while(0);e=n-4|0;if((e|0)==0){s=n;t=s-4|0;c[d>>2]=t;return}c[e>>2]=c[b>>2];s=c[d>>2]|0;t=s-4|0;c[d>>2]=t;return}function Ar(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=a+4|0;e=c[d>>2]|0;f=a|0;do{if((e|0)==(c[f>>2]|0)){g=a+8|0;h=c[g>>2]|0;i=a+12|0;j=c[i>>2]|0;k=j;if(h>>>0<j>>>0){j=h;l=((k-j>>2)+1|0)/2|0;m=j-e|0;j=h+(l-(m>>2)<<2)|0;LG(j|0,e|0,m|0)|0;c[d>>2]=j;c[g>>2]=(c[g>>2]|0)+(l<<2);n=j;break}j=k-e>>1;k=(j|0)==0?1:j;j=Lu(k<<2)|0;l=j+((k+3|0)>>>2<<2)|0;m=j+(k<<2)|0;if((e|0)==(h|0)){o=l;p=e}else{k=e;q=l;do{if((q|0)==0){r=0}else{c[q>>2]=c[k>>2];r=q}q=r+4|0;k=k+4|0;}while((k|0)!=(h|0));o=q;p=c[f>>2]|0}c[f>>2]=j;c[d>>2]=l;c[g>>2]=o;c[i>>2]=m;if((p|0)==0){n=l;break}Lw(p);n=c[d>>2]|0}else{n=e}}while(0);e=n-4|0;if((e|0)==0){s=n;t=s-4|0;c[d>>2]=t;return}c[e>>2]=c[b>>2];s=c[d>>2]|0;t=s-4|0;c[d>>2]=t;return}function As(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=b+36|0;At(d|0);e=b+40|0;f=c[e>>2]|0;g=b+44|0;h=c[g>>2]|0;do{if((f|0)!=(h|0)){i=f;do{Lw(c[i>>2]|0);i=i+4|0;}while((i|0)!=(h|0));i=c[e>>2]|0;j=c[g>>2]|0;if((i|0)==(j|0)){break}c[g>>2]=j+(~((j-4+(-i|0)|0)>>>2)<<2)}}while(0);g=c[d>>2]|0;if((g|0)!=0){Lw(g)}if((a[b+24|0]&1)!=0){Lw(c[b+32>>2]|0)}if((a[b+8|0]&1)==0){return}Lw(c[b+16>>2]|0);return}function At(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=b+4|0;e=c[d>>2]|0;f=b+16|0;g=c[f>>2]|0;h=e+(((g>>>0)/341|0)<<2)|0;i=b+8|0;if((c[i>>2]|0)==(e|0)){j=0;k=0;l=b+20|0}else{m=b+20|0;b=g+(c[m>>2]|0)|0;j=(c[e+(((b>>>0)/341|0)<<2)>>2]|0)+(((b>>>0)%341|0)*12|0)|0;k=(c[h>>2]|0)+(((g>>>0)%341|0)*12|0)|0;l=m}m=h;h=k;L5:while(1){k=h;do{if((k|0)==(j|0)){break L5}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=k+12|0;}while((k-(c[m>>2]|0)|0)!=4092);k=m+4|0;m=k;h=c[k>>2]|0}c[l>>2]=0;l=c[d>>2]|0;h=(c[i>>2]|0)-l>>2;if(h>>>0>2>>>0){m=l;while(1){Lw(c[m>>2]|0);l=(c[d>>2]|0)+4|0;c[d>>2]=l;j=(c[i>>2]|0)-l>>2;if(j>>>0>2>>>0){m=l}else{n=j;break}}}else{n=h}if((n|0)==1){c[f>>2]=170;return}else if((n|0)==2){c[f>>2]=341;return}else{return}}function Au(){return Lq(1,64)|0}function Av(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+12>>2]|0;if((b|0)!=0){Lp(b)}b=c[a+16>>2]|0;if((b|0)!=0){Lp(b)}b=c[a+48>>2]|0;if((b|0)!=0){Lp(b)}b=c[a+56>>2]|0;d=c[a+60>>2]|0;if((b|0)==0){e=a;Lp(e);return}if((d|0)>0){f=0;do{Lp(c[b+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(d|0))}Lp(b);e=a;Lp(e);return}function Aw(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=b|0;h=c[g>>2]|0;i=(c[b+4>>2]|0)-h|0;b=(i|0)/12|0;j=Lo(b<<2)|0;if((i|0)>0){k=0;l=h}else{c[e>>2]=j;c[f>>2]=b;return}while(1){h=l+(k*12|0)|0;i=h;m=d[i]|0;if((m&1|0)==0){n=m>>>1}else{n=c[l+(k*12|0)+4>>2]|0}m=Lo(n+1|0)|0;o=j+(k<<2)|0;c[o>>2]=m;p=a[i]|0;if((p&1)==0){q=h+1|0;r=h+1|0}else{h=c[l+(k*12|0)+8>>2]|0;q=h;r=h}h=p&255;if((h&1|0)==0){s=h>>>1}else{s=c[l+(k*12|0)+4>>2]|0}h=q+s|0;if((r|0)==(h|0)){t=l;u=p}else{p=r;i=m;while(1){a[i]=a[p]|0;m=p+1|0;if((m|0)==(h|0)){break}else{p=m;i=i+1|0}}i=c[g>>2]|0;t=i;u=a[i+(k*12|0)|0]|0}i=u&255;if((i&1|0)==0){v=i>>>1}else{v=c[t+(k*12|0)+4>>2]|0}a[(c[o>>2]|0)+v|0]=0;i=k+1|0;if((i|0)>=(b|0)){break}k=i;l=c[g>>2]|0}c[e>>2]=j;c[f>>2]=b;return}function Ax(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0;d=i;i=i+32|0;e=d|0;f=d+8|0;g=d+16|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=j;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+248|0;o=i;i=i+84|0;i=i+7&-8;p=i;i=i+84|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+144|0;w=i;i=i+12|0;i=i+7&-8;x=i;i=i+144|0;y=i;i=i+12|0;i=i+7&-8;A=l;a[A]=0;a[l+1|0]=0;B=c[b+20>>2]|0;do{if((B|0)==0){C=0;D=5}else{if((c[b+28>>2]|0)!=2){C=0;D=5;break}z=0,aM(542,l|0,B|0)|0;if(!z){C=1;D=5}else{z=0;D=4}}}while(0);L4:do{if((D|0)==5){B=c[b+4>>2]|0;E=(B|0)==0?38296:B;B=LJ(E|0)|0;if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;D=4;break}return 0}if(B>>>0<11>>>0){F=B<<1&255;a[m]=F;G=m+1|0;H=F}else{F=B+16&-16;I=(z=0,au(248,F|0)|0);if(z){z=0;D=4;break}c[m+8>>2]=I;J=F|1;c[m>>2]=J;c[m+4>>2]=B;G=I;H=J&255}LF(G|0,E|0,B)|0;a[G+B|0]=0;LI(p|0,0,84)|0;c[p>>2]=c[b+8>>2];B=c[b>>2]|0;E=(B|0)==0?38296:B;B=LJ(E|0)|0;L15:do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;D=74;break}return 0}else{if(B>>>0<11>>>0){a[q]=B<<1;K=q+1|0}else{J=B+16&-16;I=(z=0,au(248,J|0)|0);if(z){z=0;D=74;break}c[q+8>>2]=I;c[q>>2]=J|1;c[q+4>>2]=B;K=I}LF(K|0,E|0,B)|0;a[K+B|0]=0;I=p+4|0;z=0,aM(344,I|0,q|0)|0;do{if(!z){I=m;if((H&1)==0){J=r;c[J>>2]=c[I>>2];c[J+4>>2]=c[I+4>>2];c[J+8>>2]=c[I+8>>2]}else{J=c[m+8>>2]|0;F=c[m+4>>2]|0;if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;D=75;break}return 0}if(F>>>0<11>>>0){a[r]=F<<1;L=r+1|0}else{N=F+16&-16;O=(z=0,au(248,N|0)|0);if(z){z=0;D=75;break}c[r+8>>2]=O;c[r>>2]=N|1;c[r+4>>2]=F;L=O}LF(L|0,J|0,F)|0;a[L+F|0]=0}F=p+16|0;z=0,aM(344,F|0,r|0)|0;do{if(!z){c[p+64>>2]=c[b+24>>2];a[p+60|0]=(c[b+28>>2]|0)==1|0;a[p+61|0]=C;if((a[A]&1)==0){F=s;c[F>>2]=c[A>>2];c[F+4>>2]=c[A+4>>2];c[F+8>>2]=c[A+8>>2]}else{F=c[l+8>>2]|0;J=c[l+4>>2]|0;if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;D=76;break}return 0}if(J>>>0<11>>>0){a[s]=J<<1;P=s+1|0}else{O=J+16&-16;N=(z=0,au(248,O|0)|0);if(z){z=0;D=76;break}c[s+8>>2]=N;c[s>>2]=O|1;c[s+4>>2]=J;P=N}LF(P|0,F|0,J)|0;a[P+J|0]=0}J=p+68|0;z=0,aM(344,J|0,s|0)|0;do{if(!z){J=c[b+36>>2]|0;F=(J|0)==0?38296:J;J=LJ(F|0)|0;if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;D=77;break}return 0}if(J>>>0<11>>>0){a[t]=J<<1;Q=t+1|0}else{N=J+16&-16;O=(z=0,au(248,N|0)|0);if(z){z=0;D=77;break}c[t+8>>2]=O;c[t>>2]=N|1;c[t+4>>2]=J;Q=O}LF(Q|0,F|0,J)|0;a[Q+J|0]=0;J=p+28|0;z=0,aM(344,J|0,t|0)|0;L63:do{if(!z){c[p+40>>2]=c[b+32>>2];c[p+44>>2]=0;z=0;aR(152,p+48|0,0,0);do{if(!z){J=c[b+40>>2]|0;c[p+80>>2]=(J|0)==0?5:J;z=0;as(362,o|0,p|0);if(z){z=0;break}z=0;as(546,n|0,o|0);if(z){z=0;J=bT(-1,-1,31448,29320)|0;F=M;z=0;ar(400,o|0);if(!z){R=F;S=J;break L63}else{z=0;break L4}}z=0;ar(400,o|0);if(z){z=0;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}z=0;ar(400,p|0);L84:do{if(!z){J=c[b+52>>2]|0;L86:do{if((J|0)==0){D=91}else{if((c[J>>2]|0)==0){D=91;break}F=n+120|0;O=n+124|0;N=n+116|0;T=J;while(1){if((c[T+4>>2]|0)==0){D=91;break L86}U=c[F>>2]|0;if((U|0)==(c[O>>2]|0)){z=0;as(686,N|0,T|0);if(z){z=0;break}}else{if((U|0)==0){V=0}else{W=U;U=T;c[W>>2]=c[U>>2];c[W+4>>2]=c[U+4>>2];c[W+8>>2]=c[U+8>>2];V=c[F>>2]|0}c[F>>2]=V+12}U=T+12|0;if((c[U>>2]|0)==0){D=91;break L86}else{T=U}}T=bT(-1,-1,31448,29320)|0;X=M;Y=T}}while(0);if((D|0)==91){J=(z=0,au(142,n|0)|0);do{if(!z){c[b+12>>2]=J;T=(z=0,au(192,n|0)|0);if(z){z=0;break}c[b+16>>2]=T;c[b+48>>2]=0;c[b+44>>2]=0;z=0;as(14,u|0,n|0);if(z){z=0;break}Aw(u,b+56|0,b+60|0);T=u|0;F=c[T>>2]|0;if((F|0)!=0){N=u+4|0;O=c[N>>2]|0;if((F|0)==(O|0)){Z=F}else{U=O;while(1){O=U-12|0;c[N>>2]=O;if((a[O]&1)==0){_=O}else{Lw(c[U-12+8>>2]|0);_=c[N>>2]|0}if((F|0)==(_|0)){break}else{U=_}}Z=c[T>>2]|0}Lw(Z)}z=0;ar(318,n|0);if(z){z=0;break L84}if((a[I]&1)!=0){Lw(c[m+8>>2]|0)}if((a[A]&1)==0){i=d;return 0}Lw(c[l+8>>2]|0);i=d;return 0}else{z=0}}while(0);J=bT(-1,-1,31448,29320)|0;X=M;Y=J}z=0;ar(318,n|0);if(z){z=0;break L4}$=X;aa=Y;ab=I;break L15}else{z=0}}while(0);J=bT(-1,-1,31448,29320)|0;$=M;aa=J;ab=I;break L15}else{z=0}}while(0);J=bT(-1,-1,31448,29320)|0;R=M;S=J}else{z=0;J=bT(-1,-1,31448,29320)|0;R=M;S=J}}while(0);if((a[t]&1)==0){ac=R;ad=S;break}Lw(c[t+8>>2]|0);ac=R;ad=S}else{z=0;D=77}}while(0);if((D|0)==77){J=bT(-1,-1,31448,29320)|0;ac=M;ad=J}if((a[s]&1)==0){ae=ac;af=ad;break}Lw(c[s+8>>2]|0);ae=ac;af=ad}else{z=0;D=76}}while(0);if((D|0)==76){I=bT(-1,-1,31448,29320)|0;ae=M;af=I}if((a[r]&1)==0){ag=ae;ah=af;break}Lw(c[r+8>>2]|0);ag=ae;ah=af}else{z=0;D=75}}while(0);if((D|0)==75){I=bT(-1,-1,31448,29320)|0;ag=M;ah=I}if((a[q]&1)==0){ai=ag;aj=ah;D=89;break}Lw(c[q+8>>2]|0);ai=ag;aj=ah;D=89}}while(0);if((D|0)==74){B=bT(-1,-1,31448,29320)|0;ai=M;aj=B;D=89}if((D|0)==89){z=0;ar(400,p|0);if(z){z=0;break}$=ai;aa=aj;ab=m}if((a[ab]&1)==0){ak=$;al=aa;D=112;break}Lw(c[m+8>>2]|0);ak=$;al=aa;D=112}}while(0);if((D|0)==4){aa=bT(-1,-1,31448,29320)|0;ak=M;al=aa;D=112}L156:do{if((D|0)==112){if((a[A]&1)!=0){Lw(c[l+8>>2]|0)}if((ak|0)!=(cs(31448)|0)){if((ak|0)!=(cs(29320)|0)){am=ak;an=al;ao=an;ap=0;aq=ao;at=am;bg(aq|0)}aa=bD(al|0)|0;$=aa;m=v+64|0;ab=v|0;aj=v+8|0;ai=aj|0;c[ai>>2]=15464;p=v+12|0;c[ab>>2]=32540;ah=v+64|0;c[ah>>2]=32560;c[v+4>>2]=0;z=0;as(198,v+64|0,p|0);L166:do{if(!z){c[v+136>>2]=0;c[v+140>>2]=-1;ag=v+8|0;c[ab>>2]=15444;c[m>>2]=15484;c[ai>>2]=15464;q=p|0;c[q>>2]=15768;af=v+16|0;I_(af);LI(v+20|0,0,24)|0;c[q>>2]=15624;ae=v+44|0;LI(v+44|0,0,16)|0;c[v+60>>2]=24;LI(h|0,0,12)|0;z=0;as(212,p|0,g|0);if(z){z=0;r=bT(-1,-1)|0;ad=M;if((a[h]&1)!=0){Lw(c[g+8>>2]|0)}if((a[ae]&1)!=0){Lw(c[v+52>>2]|0)}c[q>>2]=15768;z=0;ar(394,af|0);if(!z){av=r;aw=ad;D=168;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}if((a[h]&1)!=0){Lw(c[g+8>>2]|0)}ad=(z=0,aM(114,aj|0,9624)|0);L181:do{if(!z){r=cD[c[(c[aa>>2]|0)+8>>2]&511]($)|0;q=(z=0,aM(114,ad|0,r|0)|0);if(z){z=0;D=196;break}z=0;as(352,e|0,q+(c[(c[q>>2]|0)-12>>2]|0)|0);if(z){z=0;D=196;break}r=(z=0,aM(198,e|0,41760)|0);do{if(!z){ac=(z=0,aM(c[(c[r>>2]|0)+28>>2]|0,r|0,10)|0);if(z){z=0;break}z=0;ar(394,e|0);if(z){z=0;D=196;break L181}z=0,aM(242,q|0,ac|0)|0;if(z){z=0;D=196;break L181}z=0,au(62,q|0)|0;if(z){z=0;D=196;break L181}z=0;as(576,w|0,p|0);if(z){z=0;D=196;break L181}ac=w;if((a[ac]&1)==0){ax=w+1|0}else{ax=c[w+8>>2]|0}c[b+48>>2]=bU(ax|0)|0;if((a[ac]&1)!=0){Lw(c[w+8>>2]|0)}c[b+44>>2]=1;c[b+12>>2]=0;c[b+16>>2]=0;c[ab>>2]=15444;c[ah>>2]=15484;c[ag>>2]=15464;ac=v+12|0;c[ac>>2]=15624;if((a[ae]&1)!=0){Lw(c[v+52>>2]|0)}c[ac>>2]=15768;z=0;ar(394,af|0);if(z){z=0;ac=bT(-1,-1)|0;s=M;z=0;ar(272,v+64|0);if(!z){ay=s;az=ac;D=195;break L166}else{z=0}bT(-1,-1,0)|0;bX();return 0}z=0;ar(272,v+64|0);if(z){z=0;ac=bT(-1,-1)|0;ay=M;az=ac;D=195;break L166}a$();i=d;return 0}else{z=0}}while(0);q=bT(-1,-1)|0;r=M;z=0;ar(394,e|0);if(!z){aA=r;aB=q;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;D=196}}while(0);if((D|0)==196){ad=bT(-1,-1)|0;aA=M;aB=ad}ad=aB;q=aA;c[ab>>2]=15444;c[ah>>2]=15484;c[ag>>2]=15464;r=v+12|0;c[r>>2]=15624;if((a[ae]&1)!=0){Lw(c[v+52>>2]|0)}c[r>>2]=15768;z=0;ar(394,af|0);if(!z){z=0;ar(272,v+64|0);if(!z){aC=q;aD=ad;break}else{z=0;break L156}}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,v+64|0);if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{z=0;ad=bT(-1,-1)|0;av=ad;aw=M;D=168}}while(0);do{if((D|0)==168){z=0;ar(272,m|0);if(!z){ay=aw;az=av;D=195;break}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);if((D|0)==195){aC=ay;aD=az}z=0;aS(2);if(!z){am=aC;an=aD}else{z=0;break}ao=an;ap=0;aq=ao;at=am;bg(aq|0)}m=bD(al|0)|0;ah=x+64|0;ab=x|0;p=x+8|0;$=p|0;c[$>>2]=15464;aa=x+12|0;c[ab>>2]=32540;aj=x+64|0;c[aj>>2]=32560;c[x+4>>2]=0;z=0;as(198,x+64|0,aa|0);L235:do{if(!z){c[x+136>>2]=0;c[x+140>>2]=-1;ai=x+8|0;c[ab>>2]=15444;c[ah>>2]=15484;c[$>>2]=15464;ad=aa|0;c[ad>>2]=15768;q=x+16|0;I_(q);LI(x+20|0,0,24)|0;c[ad>>2]=15624;r=x+44|0;LI(x+44|0,0,16)|0;c[x+60>>2]=24;LI(k|0,0,12)|0;z=0;as(212,aa|0,j|0);if(z){z=0;ac=bT(-1,-1)|0;s=M;if((a[k]&1)!=0){Lw(c[j+8>>2]|0)}if((a[r]&1)!=0){Lw(c[x+52>>2]|0)}c[ad>>2]=15768;z=0;ar(394,q|0);if(!z){aE=ac;aF=s;D=126;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}if((a[k]&1)!=0){Lw(c[j+8>>2]|0)}s=(z=0,aM(814,p|0,m+4|0)|0);L250:do{if(!z){ac=(z=0,aM(114,s|0,8040)|0);if(z){z=0;D=206;break}ad=(z=0,aM(312,ac|0,c[m+20>>2]|0)|0);if(z){z=0;D=206;break}ac=(z=0,aM(114,ad|0,6128)|0);if(z){z=0;D=206;break}ad=(z=0,aM(814,ac|0,m+28|0)|0);if(z){z=0;D=206;break}z=0;as(352,f|0,ad+(c[(c[ad>>2]|0)-12>>2]|0)|0);if(z){z=0;D=206;break}ac=(z=0,aM(198,f|0,41760)|0);do{if(!z){S=(z=0,aM(c[(c[ac>>2]|0)+28>>2]|0,ac|0,10)|0);if(z){z=0;break}z=0;ar(394,f|0);if(z){z=0;D=206;break L250}z=0,aM(242,ad|0,S|0)|0;if(z){z=0;D=206;break L250}z=0,au(62,ad|0)|0;if(z){z=0;D=206;break L250}z=0;as(576,y|0,aa|0);if(z){z=0;D=206;break L250}S=y;if((a[S]&1)==0){aG=y+1|0}else{aG=c[y+8>>2]|0}c[b+48>>2]=bU(aG|0)|0;if((a[S]&1)!=0){Lw(c[y+8>>2]|0)}c[b+44>>2]=1;c[b+12>>2]=0;c[b+16>>2]=0;c[ab>>2]=15444;c[aj>>2]=15484;c[ai>>2]=15464;S=x+12|0;c[S>>2]=15624;if((a[r]&1)!=0){Lw(c[x+52>>2]|0)}c[S>>2]=15768;z=0;ar(394,q|0);if(z){z=0;S=bT(-1,-1)|0;R=M;z=0;ar(272,x+64|0);if(!z){aH=R;aI=S;D=205;break L235}else{z=0}bT(-1,-1,0)|0;bX();return 0}z=0;ar(272,x+64|0);if(z){z=0;S=bT(-1,-1)|0;aH=M;aI=S;D=205;break L235}a$();i=d;return 0}else{z=0}}while(0);ad=bT(-1,-1)|0;ac=M;z=0;ar(394,f|0);if(!z){aJ=ac;aK=ad;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;D=206}}while(0);if((D|0)==206){s=bT(-1,-1)|0;aJ=M;aK=s}s=aK;af=aJ;c[ab>>2]=15444;c[aj>>2]=15484;c[ai>>2]=15464;ae=x+12|0;c[ae>>2]=15624;if((a[r]&1)!=0){Lw(c[x+52>>2]|0)}c[ae>>2]=15768;z=0;ar(394,q|0);if(!z){z=0;ar(272,x+64|0);if(!z){aL=af;aN=s;break}else{z=0;break L156}}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,x+64|0);if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{z=0;s=bT(-1,-1)|0;aE=s;aF=M;D=126}}while(0);do{if((D|0)==126){z=0;ar(272,ah|0);if(!z){aH=aF;aI=aE;D=205;break}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);if((D|0)==205){aL=aH;aN=aI}z=0;aS(2);if(!z){am=aL;an=aN}else{z=0;break}ao=an;ap=0;aq=ao;at=am;bg(aq|0)}}while(0);bT(-1,-1,0)|0;bX();return 0}function Ay(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=(h|0)/12|0;j=i+1|0;if(j>>>0>357913941>>>0){IU(0)}k=a+8|0;a=((c[k>>2]|0)-g|0)/12|0;if(a>>>0>178956969>>>0){l=357913941;m=5}else{g=a<<1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l*12|0)|0;o=l}l=n+(i*12|0)|0;if((l|0)!=0){m=l;l=b;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}l=n+((((h|0)/-12|0)+i|0)*12|0)|0;i=f;LF(l|0,i|0,h)|0;c[e>>2]=l;c[d>>2]=n+(j*12|0);c[k>>2]=n+(o*12|0);if((f|0)==0){return}Lw(i);return}function Az(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=b|0;f=b+4|0;g=b+12|0;h=b+16|0;LI(b|0,0,28)|0;c[b+28>>2]=1;c[b+32>>2]=1;i=b+36|0;j=d;if((a[j]&1)==0){k=i;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];return}j=c[d+8>>2]|0;k=c[d+4>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[i]=k<<1;l=i+1|0}else{d=k+16&-16;m=(z=0,au(248,d|0)|0);if(z){z=0;break}c[b+44>>2]=m;c[i>>2]=d|1;c[b+40>>2]=k;l=m}LF(l|0,j|0,k)|0;a[l+k|0]=0;return}}while(0);k=bT(-1,-1)|0;l=c[g>>2]|0;g=l;if((l|0)!=0){j=c[h>>2]|0;if((l|0)!=(j|0)){c[h>>2]=j+(~(((j-24+(-g|0)|0)>>>0)/24|0)*24|0)}Lw(l)}l=c[e>>2]|0;if((l|0)==0){bg(k|0)}g=c[f>>2]|0;if((l|0)==(g|0)){n=l}else{j=g;while(1){g=j-12|0;c[f>>2]=g;if((a[g]&1)==0){o=g}else{Lw(c[j-12+8>>2]|0);o=c[f>>2]|0}if((l|0)==(o|0)){break}else{j=o}}n=c[e>>2]|0}Lw(n);bg(k|0)}function AA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0;e=i;i=i+112|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=b;o=b;a[o]=4;p=n+1|0;q=p;E=2683;a[q]=E;E=E>>8;a[q+1|0]=E;a[n+3|0]=0;z=0,az(88,b|0,9600,16)|0;L1:do{if(!z){z=0;aR(26,g|0,8024,d+36|0);if(z){z=0;r=53;break}n=f;LI(n|0,0,12)|0;q=g;s=a[q]|0;t=s&255;if((t&1|0)==0){u=t>>>1}else{u=c[g+4>>2]|0}if((s&1)==0){v=g+1|0}else{v=c[g+8>>2]|0}s=u+3|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;r=17;break}}else{if(s>>>0<11>>>0){a[n]=u<<1;w=f+1|0}else{t=u+19&-16;x=(z=0,au(248,t|0)|0);if(z){z=0;r=17;break}c[f+8>>2]=x;c[f>>2]=t|1;c[f+4>>2]=u;w=x}LF(w|0,v|0,u)|0;a[w+u|0]=0;z=0,az(88,f|0,6120,3)|0;if(z){z=0;r=17;break}x=a[n]|0;if((x&1)==0){y=f+1|0}else{y=c[f+8>>2]|0}t=x&255;if((t&1|0)==0){A=t>>>1}else{A=c[f+4>>2]|0}z=0,az(88,b|0,y|0,A|0)|0;if(z){z=0;t=bT(-1,-1)|0;x=t;t=M;if((a[n]&1)==0){B=t;C=x;break}Lw(c[f+8>>2]|0);B=t;C=x;break}if((a[n]&1)!=0){Lw(c[f+8>>2]|0)}if((a[q]&1)!=0){Lw(c[g+8>>2]|0)}z=0,az(88,b|0,5256,14)|0;if(z){z=0;r=53;break L1}x=d+4|0;t=d|0;D=c[t>>2]|0;L41:do{if((c[x>>2]|0)!=(D|0)){F=h;G=j;H=j+1|0;I=h+1|0;J=j+8|0;K=h+8|0;L=h+4|0;N=h|0;O=j+4|0;P=0;Q=D;while(1){z=0;aR(26,j|0,5064,Q+(P*12|0)|0);if(z){z=0;r=52;break}LI(F|0,0,12)|0;R=a[G]|0;S=R&255;T=(S&1|0)==0?S>>>1:c[O>>2]|0;S=(R&1)==0?H:c[J>>2]|0;R=T+2|0;if(R>>>0>4294967279>>>0){r=35;break}if(R>>>0<11>>>0){a[F]=T<<1;U=I}else{R=T+18&-16;V=(z=0,au(248,R|0)|0);if(z){z=0;r=42;break}c[K>>2]=V;c[N>>2]=R|1;c[L>>2]=T;U=V}LF(U|0,S|0,T)|0;a[U+T|0]=0;z=0,az(88,h|0,3552,2)|0;if(z){z=0;r=42;break}T=a[F]|0;S=T&255;z=0,az(88,b|0,((T&1)==0?I:c[K>>2]|0)|0,((S&1|0)==0?S>>>1:c[L>>2]|0)|0)|0;if(z){z=0;r=61;break}if((a[F]&1)!=0){Lw(c[K>>2]|0)}if((a[G]&1)!=0){Lw(c[J>>2]|0)}S=P+1|0;W=c[x>>2]|0;X=c[t>>2]|0;if(S>>>0<((W-X|0)/12|0)>>>0){P=S;Q=X}else{r=65;break}}do{if((r|0)==35){z=0;ar(86,0);if(z){z=0;Q=bT(-1,-1)|0;Y=M;Z=Q;r=44;break}}else if((r|0)==42){Q=bT(-1,-1)|0;Y=M;Z=Q;r=44}else if((r|0)==52){Q=bT(-1,-1)|0;_=M;$=Q;r=54;break L1}else if((r|0)==61){Q=bT(-1,-1)|0;P=Q;Q=M;if((a[F]&1)==0){aa=Q;ab=P;break}Lw(c[K>>2]|0);aa=Q;ab=P}else if((r|0)==65){if((X|0)==(W|0)){break L41}P=a[o]|0;Q=P&255;if((Q&1|0)==0){ac=Q>>>1;ad=Q>>>1}else{Q=c[b+4>>2]|0;ac=Q;ad=Q}Q=ad-1|0;if(ac>>>0<Q>>>0){z=0;ar(240,0);if(z){z=0;r=53;break L1}}if((P&1)==0){a[o]=Q<<1;ae=p}else{P=c[b+8>>2]|0;c[b+4>>2]=Q;ae=P}a[ae+Q|0]=0;break L41}}while(0);if((r|0)==44){if((a[F]&1)!=0){Lw(c[K>>2]|0)}aa=Y;ab=Z}if((a[G]&1)==0){af=aa;ag=ab;break L1}Lw(c[J>>2]|0);af=aa;ag=ab;break L1}}while(0);z=0,az(88,b|0,2208,3)|0;if(z){z=0;r=53;break L1}z=0,az(88,b|0,1408,15)|0;if(z){z=0;r=53;break L1}z=0;as(106,m|0,d|0);if(z){z=0;r=53;break L1}t=l;LI(t|0,0,12)|0;x=m;D=m;Q=a[D]|0;P=Q&255;if((P&1|0)==0){ah=P>>>1}else{ah=c[m+4>>2]|0}P=ah+15|0;do{if(P>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;r=93;break}}else{if(P>>>0<11>>>0){a[t]=30;ai=l+1|0}else{L=ah+31&-16;I=(z=0,au(248,L|0)|0);if(z){z=0;r=93;break}c[l+8>>2]=I;c[l>>2]=L|1;c[l+4>>2]=15;ai=I}LF(ai|0,704,15)|0;a[ai+15|0]=0;if((Q&1)==0){aj=x+1|0}else{aj=c[m+8>>2]|0}z=0,az(88,l|0,aj|0,ah|0)|0;if(z){z=0;r=93;break}I=k;LI(I|0,0,12)|0;L=a[t]|0;N=L&255;if((N&1|0)==0){ak=N>>>1}else{ak=c[l+4>>2]|0}if((L&1)==0){al=l+1|0}else{al=c[l+8>>2]|0}L=ak+2|0;do{if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;r=109;break}}else{if(L>>>0<11>>>0){a[I]=ak<<1;am=k+1|0}else{N=ak+18&-16;H=(z=0,au(248,N|0)|0);if(z){z=0;r=109;break}c[k+8>>2]=H;c[k>>2]=N|1;c[k+4>>2]=ak;am=H}LF(am|0,al|0,ak)|0;a[am+ak|0]=0;z=0,az(88,k|0,13272,2)|0;if(z){z=0;r=109;break}H=a[I]|0;if((H&1)==0){an=k+1|0}else{an=c[k+8>>2]|0}N=H&255;if((N&1|0)==0){ao=N>>>1}else{ao=c[k+4>>2]|0}z=0,az(88,b|0,an|0,ao|0)|0;if(z){z=0;N=bT(-1,-1)|0;H=N;N=M;if((a[I]&1)==0){ap=N;aq=H;break}Lw(c[k+8>>2]|0);ap=N;aq=H;break}if((a[I]&1)!=0){Lw(c[k+8>>2]|0)}if((a[t]&1)!=0){Lw(c[l+8>>2]|0)}if((a[D]&1)!=0){Lw(c[m+8>>2]|0)}z=0,az(88,b|0,12536,1)|0;if(z){z=0;r=53;break L1}i=e;return}}while(0);if((r|0)==109){L=bT(-1,-1)|0;J=M;if((a[I]&1)!=0){Lw(c[k+8>>2]|0)}ap=J;aq=L}if((a[t]&1)==0){at=ap;av=aq;break}Lw(c[l+8>>2]|0);at=ap;av=aq}}while(0);if((r|0)==93){x=bT(-1,-1)|0;Q=M;if((a[t]&1)!=0){Lw(c[l+8>>2]|0)}at=Q;av=x}if((a[D]&1)==0){af=at;ag=av;break L1}Lw(c[m+8>>2]|0);af=at;ag=av;break L1}}while(0);if((r|0)==17){s=bT(-1,-1)|0;x=M;if((a[n]&1)!=0){Lw(c[f+8>>2]|0)}B=x;C=s}if((a[q]&1)==0){af=B;ag=C;break}Lw(c[g+8>>2]|0);af=B;ag=C}else{z=0;r=53}}while(0);if((r|0)==53){C=bT(-1,-1)|0;_=M;$=C;r=54}if((r|0)==54){af=_;ag=$}if((a[o]&1)==0){aw=ag;ax=0;ay=aw;aA=af;bg(ay|0)}Lw(c[b+8>>2]|0);aw=ag;ax=0;ay=aw;aA=af;bg(ay|0)}function AB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=b;a[k]=0;a[b+1|0]=0;l=d+16|0;m=d+12|0;n=c[m>>2]|0;if((c[l>>2]|0)==(n|0)){i=e;return}o=d+48|0;d=f;p=f+1|0;q=g;r=g+1|0;s=h;t=h+1|0;u=j;v=j+1|0;w=j+8|0;x=j+4|0;y=h+8|0;A=h+4|0;B=g+8|0;C=g+4|0;D=f+8|0;E=f+4|0;F=0;G=0;H=0;I=0;J=0;K=0;L=n;L4:while(1){n=(c[L+(F*24|0)+16>>2]|0)-1|0;N=(c[L+(F*24|0)+20>>2]|0)-1|0;O=(c[L+(F*24|0)+4>>2]|0)-1|0;P=(c[L+(F*24|0)+8>>2]|0)-1|0;Q=(c[L+(F*24|0)>>2]|0)-1|0;do{if((n|0)==(K|0)){if((F|0)==0){R=K;S=J;break}z=0,az(88,b|0,10824,1)|0;if(!z){R=K;S=J}else{z=0;T=7;break L4}}else{U=K;while(1){z=0,az(88,b|0,11128,1)|0;if(z){z=0;T=6;break L4}V=U+1|0;if((n|0)==(V|0)){R=n;S=0;break}else{U=V}}}}while(0);z=0;aR(44,f|0,o|0,N-S|0);if(z){z=0;T=7;break}n=a[d]|0;U=n&255;z=0,az(88,b|0,((n&1)==0?p:c[D>>2]|0)|0,((U&1|0)==0?U>>>1:c[E>>2]|0)|0)|0;if(z){z=0;T=28;break}if((a[d]&1)!=0){Lw(c[D>>2]|0)}z=0;aR(44,g|0,o|0,Q-G|0);if(z){z=0;T=7;break}U=a[q]|0;n=U&255;z=0,az(88,b|0,((U&1)==0?r:c[B>>2]|0)|0,((n&1|0)==0?n>>>1:c[C>>2]|0)|0)|0;if(z){z=0;T=30;break}if((a[q]&1)!=0){Lw(c[B>>2]|0)}z=0;aR(44,h|0,o|0,O-I|0);if(z){z=0;T=7;break}n=a[s]|0;U=n&255;z=0,az(88,b|0,((n&1)==0?t:c[y>>2]|0)|0,((U&1|0)==0?U>>>1:c[A>>2]|0)|0)|0;if(z){z=0;T=32;break}if((a[s]&1)!=0){Lw(c[y>>2]|0)}z=0;aR(44,j|0,o|0,P-H|0);if(z){z=0;T=7;break}U=a[u]|0;n=U&255;z=0,az(88,b|0,((U&1)==0?v:c[w>>2]|0)|0,((n&1|0)==0?n>>>1:c[x>>2]|0)|0)|0;if(z){z=0;T=34;break}if((a[u]&1)!=0){Lw(c[w>>2]|0)}n=F+1|0;U=c[m>>2]|0;if(n>>>0<(((c[l>>2]|0)-U|0)/24|0)>>>0){F=n;G=Q;H=P;I=O;J=N;K=R;L=U}else{T=41;break}}do{if((T|0)==7){L=bT(-1,-1)|0;W=M;X=L;T=8}else if((T|0)==6){L=bT(-1,-1)|0;W=M;X=L;T=8}else if((T|0)==28){L=bT(-1,-1)|0;R=L;L=M;if((a[d]&1)==0){Y=L;Z=R;break}Lw(c[D>>2]|0);Y=L;Z=R}else if((T|0)==30){R=bT(-1,-1)|0;L=R;R=M;if((a[q]&1)==0){Y=R;Z=L;break}Lw(c[B>>2]|0);Y=R;Z=L}else if((T|0)==32){L=bT(-1,-1)|0;R=L;L=M;if((a[s]&1)==0){Y=L;Z=R;break}Lw(c[y>>2]|0);Y=L;Z=R}else if((T|0)==34){R=bT(-1,-1)|0;L=R;R=M;if((a[u]&1)==0){Y=R;Z=L;break}Lw(c[w>>2]|0);Y=R;Z=L}else if((T|0)==41){i=e;return}}while(0);if((T|0)==8){Y=W;Z=X}if((a[k]&1)==0){_=Z;$=0;aa=_;ab=Y;bg(aa|0)}Lw(c[b+8>>2]|0);_=Z;$=0;aa=_;ab=Y;bg(aa|0)}function AC(a){a=a|0;var b=0;b=a+28|0;c[b>>2]=(c[b>>2]|0)-1;c[a+32>>2]=1;return}function AD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=d;f=d;g=a[f]|0;if((g&1)==0){h=e+1|0;i=e+1|0}else{j=c[d+8>>2]|0;h=j;i=j}j=g&255;if((j&1|0)==0){k=j>>>1}else{k=c[d+4>>2]|0}j=h+k|0;if((i|0)==(j|0)){l=0}else{k=i;i=0;while(1){h=((a[k]|0)==10)+i|0;g=k+1|0;if((g|0)==(j|0)){l=h;break}else{k=g;i=h}}}i=b+28|0;c[i>>2]=(c[i>>2]|0)+l;i=a[f]|0;f=i&255;k=(f&1|0)==0;if((l|0)<=0){if(k){m=f>>>1}else{m=c[d+4>>2]|0}l=b+32|0;c[l>>2]=(c[l>>2]|0)+m;return}if(k){n=f>>>1;o=f>>>1}else{f=c[d+4>>2]|0;n=f;o=f}L25:do{if((n|0)==0){p=-1}else{if((i&1)==0){q=e+1|0}else{q=c[d+8>>2]|0}f=q+n|0;do{if((f|0)==(q|0)){p=-1;break L25}f=f-1|0;}while((a[f]|0)!=10);p=f-q|0}}while(0);c[b+32>>2]=o-p;return}function AE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=d|0;f=b+16|0;b=e;c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];f=e;b=e+12|0;g=a+24|0;c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];g=a+16|0;b=c[g>>2]|0;if((b|0)==(c[a+20>>2]|0)){AF(a+12|0,e);i=d;return}if((b|0)==0){h=0}else{e=b;c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];h=c[g>>2]|0}c[g>>2]=h+24;i=d;return}function AF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=(h|0)/24|0;j=i+1|0;if(j>>>0>178956970>>>0){IU(0)}k=a+8|0;a=((c[k>>2]|0)-g|0)/24|0;if(a>>>0>89478484>>>0){l=178956970;m=5}else{g=a<<1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l*24|0)|0;o=l}l=n+(i*24|0)|0;if((l|0)!=0){m=l;l=b;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[m+16>>2]=c[l+16>>2];c[m+20>>2]=c[l+20>>2]}l=n+((((h|0)/-24|0)+i|0)*24|0)|0;i=f;LF(l|0,i|0,h)|0;c[e>>2]=l;c[d>>2]=n+(j*24|0);c[k>>2]=n+(o*24|0);if((f|0)==0){return}Lw(i);return}function AG(b,c,d){b=b|0;c=c|0;d=d|0;Ac(b,a[d+36|0]&1);return}function AH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;d=i;i=i+16|0;f=d|0;g=+h[e+40>>3];jw(f,e);e=f;if((a[e]&1)==0){j=f+1|0}else{j=c[f+8>>2]|0}z=0;ay(2,b|0,+g,j|0);if(!z){if((a[e]&1)==0){i=d;return}Lw(c[f+8>>2]|0);i=d;return}else{z=0;d=bT(-1,-1)|0;if((a[e]&1)==0){bg(d|0)}Lw(c[f+8>>2]|0);bg(d|0)}}function AI(a,b,c){a=a|0;b=b|0;c=c|0;Ae(a,+h[c+40>>3],+h[c+48>>3],+h[c+56>>3],+h[c+64>>3]);return}function AJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;f=d|0;g=e+40|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[e+48>>2]|0;g=c[e+44>>2]|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){e=g<<1&255;l=f;a[l]=e;m=f+1|0;n=e;o=l}else{l=g+16&-16;e=Lu(l)|0;c[f+8>>2]=e;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=e;n=p&255;o=f}LF(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}z=0;as(552,b|0,q|0);if(!z){if((a[k]&1)==0){i=d;return}Lw(c[f+8>>2]|0);i=d;return}else{z=0;d=bT(-1,-1)|0;if((a[k]&1)==0){bg(d|0)}Lw(c[f+8>>2]|0);bg(d|0)}}function AK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+40|0;f=e|0;g=d+44|0;h=d+40|0;Ag(a,(c[g>>2]|0)-(c[h>>2]|0)>>2,(c[d+52>>2]|0)!=1|0);d=c[h>>2]|0;j=(c[g>>2]|0)-d>>2;if((j|0)==0){i=e;return}g=a+12|0;a=b|0;b=f;k=0;l=d;while(1){d=(c[g>>2]|0)+(k*40|0)|0;m=c[l+(k<<2)>>2]|0;c_[c[(c[m>>2]|0)+32>>2]&511](f,m|0,a);m=d;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[m+16>>2]=c[b+16>>2];c[m+20>>2]=c[b+20>>2];c[m+24>>2]=c[b+24>>2];c[m+28>>2]=c[b+28>>2];c[m+32>>2]=c[b+32>>2];c[m+36>>2]=c[b+36>>2];m=k+1|0;if(m>>>0>=j>>>0){break}k=m;l=c[h>>2]|0}i=e;return}function AL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+40|0;f=e|0;g=d+44|0;h=d+40|0;Ag(a,(c[g>>2]|0)-(c[h>>2]|0)>>2,0);d=c[h>>2]|0;j=(c[g>>2]|0)-d>>2;if((j|0)==0){i=e;return}g=a+12|0;a=b|0;b=f;k=0;l=d;while(1){d=(c[g>>2]|0)+(k*40|0)|0;m=c[l+(k<<2)>>2]|0;c_[c[(c[m>>2]|0)+32>>2]&511](f,m,a);m=d;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[m+16>>2]=c[b+16>>2];c[m+20>>2]=c[b+20>>2];c[m+24>>2]=c[b+24>>2];c[m+28>>2]=c[b+28>>2];c[m+32>>2]=c[b+32>>2];c[m+36>>2]=c[b+36>>2];m=k+1|0;if(m>>>0>=j>>>0){break}k=m;l=c[h>>2]|0}i=e;return}function AM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d+36>>2]|0;c_[c[(c[e>>2]|0)+32>>2]&511](a,e|0,b|0);return}function AN(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AO(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AP(a){a=a|0;return}function AQ(a){a=a|0;Lw(a);return}function AR(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AS(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AT(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AU(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AV(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AW(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AX(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AY(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function AZ(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A_(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A$(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A0(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A1(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A2(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A3(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A4(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A5(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A6(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A7(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A8(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function A9(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Ba(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bb(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bc(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bd(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Be(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bf(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bg(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bh(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bi(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bj(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bk(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bl(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bm(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bn(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bo(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bp(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bq(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Br(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bs(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bt(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bu(a,b,c){a=a|0;b=b|0;c=c|0;Ah(a);return}function Bv(a,b){a=a|0;b=b|0;c[a>>2]=16728;c[a+4>>2]=b;return}function Bw(a){a=a|0;Lw(a);return}function Bx(a){a=a|0;return}function By(a,b,c){a=a|0;b=b|0;c=c|0;C6(a,b,c);return}function Bz(a,b,c){a=a|0;b=b|0;c=c|0;C5(a,b,c);return}function BA(a,b,c){a=a|0;b=b|0;c=c|0;C4(a,b,c);return}function BB(a,b,c){a=a|0;b=b|0;c=c|0;C3(a,b,c);return}function BC(a,b,c){a=a|0;b=b|0;c=c|0;C2(a,b,c);return}function BD(a,b,c){a=a|0;b=b|0;c=c|0;C1(a,b,c);return}function BE(a,b,c){a=a|0;b=b|0;c=c|0;C0(a,b,c);return}function BF(a,b,c){a=a|0;b=b|0;c=c|0;C$(a,b,c);return}function BG(a,b,c){a=a|0;b=b|0;c=c|0;C_(a,b,c);return}function BH(a,b,c){a=a|0;b=b|0;c=c|0;CZ(a,b,c);return}function BI(a,b,c){a=a|0;b=b|0;c=c|0;CY(a,b,c);return}function BJ(a,b,c){a=a|0;b=b|0;c=c|0;CX(a,b,c);return}function BK(a,b,c){a=a|0;b=b|0;c=c|0;CW(a,b,c);return}function BL(a,b,c){a=a|0;b=b|0;c=c|0;CV(a,b,c);return}function BM(a,b,c){a=a|0;b=b|0;c=c|0;CU(a,b,c);return}function BN(a,b,c){a=a|0;b=b|0;c=c|0;CT(a,b,c);return}function BO(a,b,c){a=a|0;b=b|0;c=c|0;CS(a,b,c);return}function BP(a,b,c){a=a|0;b=b|0;c=c|0;CR(a,b,c);return}function BQ(a,b,c){a=a|0;b=b|0;c=c|0;CQ(a,b,c);return}function BR(a,b,c){a=a|0;b=b|0;c=c|0;CP(a,b,c);return}function BS(a,b,c){a=a|0;b=b|0;c=c|0;CO(a,b,c);return}function BT(a,b,c){a=a|0;b=b|0;c=c|0;CN(a,b,c);return}function BU(a,b,c){a=a|0;b=b|0;c=c|0;CM(a,b,c);return}function BV(a,b,c){a=a|0;b=b|0;c=c|0;CL(a,b,c);return}function BW(a,b,c){a=a|0;b=b|0;c=c|0;CK(a,b,c);return}function BX(a,b,c){a=a|0;b=b|0;c=c|0;CJ(a,b,c);return}function BY(a,b,c){a=a|0;b=b|0;c=c|0;CI(a,b,c);return}function BZ(a,b,c){a=a|0;b=b|0;c=c|0;CH(a,b,c);return}function B_(a,b,c){a=a|0;b=b|0;c=c|0;CG(a,b,c);return}function B$(a,b,c){a=a|0;b=b|0;c=c|0;CF(a,b,c);return}function B0(a,b,c){a=a|0;b=b|0;c=c|0;CE(a,b,c);return}function B1(a,b,c){a=a|0;b=b|0;c=c|0;CD(a,b,c);return}function B2(a,b,c){a=a|0;b=b|0;c=c|0;CC(a,b,c);return}function B3(a,b,c){a=a|0;b=b|0;c=c|0;CB(a,b,c);return}function B4(a,b,c){a=a|0;b=b|0;c=c|0;CA(a,b,c);return}function B5(b,c,d){b=b|0;c=c|0;d=d|0;a[b]=0;a[b+1|0]=0;return}function B6(a,b,c){a=a|0;b=b|0;c=c|0;Cz(a,b,c);return}function B7(a,b,c){a=a|0;b=b|0;c=c|0;Cy(a,b,c);return}function B8(a,b,c){a=a|0;b=b|0;c=c|0;Cx(a,b,c);return}function B9(a,b,c){a=a|0;b=b|0;c=c|0;Cw(a,b,c);return}function Ca(a,b,c){a=a|0;b=b|0;c=c|0;Cv(a,b,c);return}function Cb(a,b,c){a=a|0;b=b|0;c=c|0;Cu(a,b,c);return}function Cc(a,b,c){a=a|0;b=b|0;c=c|0;Ct(a,b,c);return}function Cd(a,b,c){a=a|0;b=b|0;c=c|0;Cs(a,b,c);return}function Ce(a,b,c){a=a|0;b=b|0;c=c|0;Cr(a,b,c);return}function Cf(a,b,c){a=a|0;b=b|0;c=c|0;Cq(a,b,c);return}function Cg(a,b,c){a=a|0;b=b|0;c=c|0;Cp(a,b,c);return}function Ch(a,b,c){a=a|0;b=b|0;c=c|0;Co(a,b,c);return}function Ci(a,b,c){a=a|0;b=b|0;c=c|0;Cn(a,b,c);return}function Cj(a,b,c){a=a|0;b=b|0;c=c|0;Cm(a,b,c);return}function Ck(a,b,c){a=a|0;b=b|0;c=c|0;Cl(a,b,c);return}function Cl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cm(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Co(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cs(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Ct(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function Cz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function CZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;ro(g,c[d+4>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];rq(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}LF(h|0,e|0,d)|0;a[h+d|0]=0;rq(g);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;z=0;ar(364,g|0);if(!z){bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function C7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b;e=a[b]|0;f=e&255;g=(f&1|0)==0;if(g){h=f>>>1}else{h=c[b+4>>2]|0}i=(e&1)==0;if(i){j=d+1|0}else{j=c[b+8>>2]|0}e=h>>>0>2>>>0;do{if((LH(j|0,13160,(e?2:h)|0)|0)==0){if(h>>>0>1>>>0&(e^1)){k=0}else{break}return k|0}}while(0);if(g){l=f>>>1}else{l=c[b+4>>2]|0}if(i){m=d+1|0}else{m=c[b+8>>2]|0}e=l>>>0>2>>>0;do{if((LH(m|0,12608,(e?2:l)|0)|0)==0){if(l>>>0>1>>>0&(e^1)){k=1}else{break}return k|0}}while(0);if(g){n=f>>>1}else{n=c[b+4>>2]|0}if(i){o=d+1|0}else{o=c[b+8>>2]|0}e=n>>>0>2>>>0;do{if((LH(o|0,9512,(e?2:n)|0)|0)==0){if(n>>>0>1>>>0&(e^1)){k=2}else{break}return k|0}}while(0);if(g){p=f>>>1}else{p=c[b+4>>2]|0}if(i){q=d+1|0}else{q=c[b+8>>2]|0}e=p>>>0>2>>>0;do{if((LH(q|0,7840,(e?2:p)|0)|0)==0){if(p>>>0>1>>>0&(e^1)){k=3}else{break}return k|0}}while(0);if(g){r=f>>>1}else{r=c[b+4>>2]|0}if(i){s=d+1|0}else{s=c[b+8>>2]|0}e=r>>>0>2>>>0;do{if((LH(s|0,6e3,(e?2:r)|0)|0)==0){if(r>>>0>1>>>0&(e^1)){k=4}else{break}return k|0}}while(0);if(g){t=f>>>1}else{t=c[b+4>>2]|0}if(i){u=d+1|0}else{u=c[b+8>>2]|0}b=t>>>0>2>>>0;d=LH(u|0,5056,(b?2:t)|0)|0;if((d|0)==0){v=t>>>0<2>>>0?-1:b&1}else{v=d}k=(v|0)==0?5:6;return k|0}function C8(a,b){a=a|0;b=b|0;var c=0,d=0.0;c=C7(a)|0;a=C7(b)|0;if((c|0)==6|(a|0)==6){d=0.0;return+d}d=+h[37376+(c*48|0)+(a<<3)>>3];return+d}function C9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(d>>>0>=e>>>0){f=0;return f|0}g=b;h=b+8|0;if((a[b]&1)==0){b=d;i=0;while(1){L7:do{if((a[g+1+b|0]|0)>-1){j=b+1|0}else{k=b;while(1){l=k+1|0;if(l>>>0>=e>>>0){j=l;break L7}if((a[g+1+l|0]&-64)<<24>>24==-128){k=l}else{j=l;break}}}}while(0);k=i+1|0;if(j>>>0<e>>>0){b=j;i=k}else{f=k;break}}return f|0}else{i=d;d=0;while(1){L16:do{if((a[(c[h>>2]|0)+i|0]|0)>-1){m=i+1|0}else{j=i;while(1){b=j+1|0;if(b>>>0>=e>>>0){m=b;break L16}if((a[(c[h>>2]|0)+b|0]&-64)<<24>>24==-128){j=b}else{m=b;break}}}}while(0);j=d+1|0;if(m>>>0<e>>>0){i=m;d=j}else{f=j;break}}return f|0}return 0}function Da(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a[b]|0;e=d&255;if((e&1|0)==0){f=e>>>1}else{f=c[b+4>>2]|0}if((f|0)==0){g=0;return g|0}e=b;if((d&1)==0){d=0;h=0;while(1){L11:do{if((a[e+1+d|0]|0)>-1){i=d+1|0}else{j=d;while(1){k=j+1|0;if(k>>>0>=f>>>0){i=k;break L11}if((a[e+1+k|0]&-64)<<24>>24==-128){j=k}else{i=k;break}}}}while(0);j=h+1|0;if(i>>>0<f>>>0){d=i;h=j}else{g=j;break}}return g|0}h=c[b+8>>2]|0;b=0;i=0;while(1){L21:do{if((a[h+b|0]|0)>-1){l=b+1|0}else{d=b;while(1){e=d+1|0;if(e>>>0>=f>>>0){l=e;break L21}if((a[h+e|0]&-64)<<24>>24==-128){d=e}else{l=e;break}}}}while(0);d=i+1|0;if(l>>>0<f>>>0){b=l;i=d}else{g=d;break}}return g|0}function Db(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((d|0)==0){e=0;return e|0}f=a[b]|0;g=(f&1)==0;h=b+1|0;i=b+8|0;j=b+4|0;b=0;k=0;while(1){if(g){l=h}else{l=c[i>>2]|0}L9:do{if((a[l+k|0]|0)>-1){m=k+1|0}else{n=f&255;o=n>>>1;if((n&1|0)==0){n=k;while(1){p=n+1|0;if(p>>>0>=o>>>0){m=p;break L9}if((f&1)==0){q=h}else{q=c[i>>2]|0}if((a[q+p|0]&-64)<<24>>24==-128){n=p}else{m=p;break}}}else{n=k;while(1){o=n+1|0;if(o>>>0>=(c[j>>2]|0)>>>0){m=o;break L9}if(g){r=h}else{r=c[i>>2]|0}if((a[r+o|0]&-64)<<24>>24==-128){n=o}else{m=o;break}}}}}while(0);n=b+1|0;if(n>>>0<d>>>0){b=n;k=m}else{e=m;break}}return e|0}function Dc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=b;f=a[b]|0;g=(f&1)==0;if(g){h=e+1|0}else{h=c[b+8>>2]|0}if((a[h+d|0]|0)>-1){i=1;return i|0}h=f&255;f=h>>>1;j=e+1|0;e=b+8|0;k=b+4|0;if((h&1|0)==0){h=1;b=d;while(1){l=b+1|0;if(h>>>0>=f>>>0){i=h;m=18;break}if(g){n=j}else{n=c[e>>2]|0}if((a[n+l|0]&-64)<<24>>24==-128){h=h+1|0;b=l}else{i=h;m=17;break}}if((m|0)==18){return i|0}else if((m|0)==17){return i|0}}else{h=1;b=d;while(1){d=b+1|0;if(h>>>0>=(c[k>>2]|0)>>>0){i=h;m=16;break}if(g){o=j}else{o=c[e>>2]|0}if((a[o+d|0]&-64)<<24>>24==-128){h=h+1|0;b=d}else{i=h;m=19;break}}if((m|0)==19){return i|0}else if((m|0)==16){return i|0}}return 0}function Dd(a,b){a=a|0;b=b|0;var c=0,d=0;c=(a|0)>(b|0);if(!((a|0)<1|c)){d=a-1|0;return d|0}if(c){d=b;return d|0}if((a|0)==0){d=0;return d|0}else{return((((a|0)>-1?a:-a|0)|0)>(b|0)?0:b+a|0)|0}return 0}function De(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b|0;e=b+8|0;f=b+16|0;g=b+24|0;h=c[u>>2]|0;DA(41128,h,41256);c[10530]=16036;c[10532]=16056;c[10531]=0;z=0;as(198,42128,41128);if(z){z=0;j=bT(-1,-1)|0;Ex(42128);bg(j|0)}c[10550]=0;c[10551]=-1;j=c[r>>2]|0;c[10258]=15768;I_(41036);LI(41040,0,24)|0;c[10258]=16256;c[10266]=j;I$(g,41036);k=(z=0,aM(198,g|0,41456)|0);if(z){z=0;l=bT(-1,-1)|0;I0(g);c[10258]=15768;I0(41036);bg(l|0)}l=k;I0(g);c[10267]=l;c[10268]=41264;a[41076]=(cD[c[(c[k>>2]|0)+28>>2]&511](l)|0)&1;c[10464]=15940;c[10465]=15960;z=0;as(198,41860,41032);if(z){z=0;l=bT(-1,-1)|0;Ex(41860);bg(l|0)}c[10483]=0;c[10484]=-1;l=c[w>>2]|0;c[10270]=15768;I_(41084);LI(41088,0,24)|0;c[10270]=16256;c[10278]=l;I$(f,41084);k=(z=0,aM(198,f|0,41456)|0);if(z){z=0;g=bT(-1,-1)|0;I0(f);c[10270]=15768;I0(41084);bg(g|0)}g=k;I0(f);c[10279]=g;c[10280]=41272;a[41124]=(cD[c[(c[k>>2]|0)+28>>2]&511](g)|0)&1;c[10508]=15940;c[10509]=15960;z=0;as(198,42036,41080);if(z){z=0;g=bT(-1,-1)|0;Ex(42036);bg(g|0)}c[10527]=0;c[10528]=-1;g=c[(c[(c[10508]|0)-12>>2]|0)+42056>>2]|0;c[10486]=15940;c[10487]=15960;z=0;as(198,41948,g|0);if(z){z=0;g=bT(-1,-1)|0;Ex(41948);bg(g|0)}c[10505]=0;c[10506]=-1;c[(c[(c[10530]|0)-12>>2]|0)+42192>>2]=41856;g=(c[(c[10508]|0)-12>>2]|0)+42036|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[10508]|0)-12>>2]|0)+42104>>2]=41856;Dm(40976,h,41280);c[10442]=15988;c[10444]=16008;c[10443]=0;z=0;as(198,41776,40976);if(z){z=0;h=bT(-1,-1)|0;Ex(41776);bg(h|0)}c[10462]=0;c[10463]=-1;c[10220]=15696;I_(40884);LI(40888,0,24)|0;c[10220]=16184;c[10228]=j;I$(e,40884);j=(z=0,aM(198,e|0,41448)|0);if(z){z=0;h=bT(-1,-1)|0;I0(e);c[10220]=15696;I0(40884);bg(h|0)}h=j;I0(e);c[10229]=h;c[10230]=41288;a[40924]=(cD[c[(c[j>>2]|0)+28>>2]&511](h)|0)&1;c[10372]=15892;c[10373]=15912;z=0;as(198,41492,40880);if(z){z=0;h=bT(-1,-1)|0;Ex(41492);bg(h|0)}c[10391]=0;c[10392]=-1;c[10232]=15696;I_(40932);LI(40936,0,24)|0;c[10232]=16184;c[10240]=l;I$(d,40932);l=(z=0,aM(198,d|0,41448)|0);if(z){z=0;h=bT(-1,-1)|0;I0(d);c[10232]=15696;I0(40932);bg(h|0)}h=l;I0(d);c[10241]=h;c[10242]=41296;a[40972]=(cD[c[(c[l>>2]|0)+28>>2]&511](h)|0)&1;c[10416]=15892;c[10417]=15912;z=0;as(198,41668,40928);if(z){z=0;h=bT(-1,-1)|0;Ex(41668);bg(h|0)}c[10435]=0;c[10436]=-1;h=c[(c[(c[10416]|0)-12>>2]|0)+41688>>2]|0;c[10394]=15892;c[10395]=15912;z=0;as(198,41580,h|0);if(!z){c[10413]=0;c[10414]=-1;c[(c[(c[10442]|0)-12>>2]|0)+41840>>2]=41488;h=(c[(c[10416]|0)-12>>2]|0)+41668|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[10416]|0)-12>>2]|0)+41736>>2]=41488;i=b;return}else{z=0;b=bT(-1,-1)|0;Ex(41580);bg(b|0)}}function Df(a){a=a|0;z=0,au(62,41856)|0;do{if(!z){z=0,au(62,41944)|0;if(z){z=0;break}z=0,au(166,41488)|0;if(z){z=0;break}z=0,au(166,41576)|0;if(z){z=0;break}return}else{z=0}}while(0);bT(-1,-1,0)|0;bX()}function Dg(a){a=a|0;c[a>>2]=15696;I0(a+4|0);return}function Dh(a){a=a|0;c[a>>2]=15696;I0(a+4|0);Lw(a);return}function Di(b,d){b=b|0;d=d|0;var e=0;cD[c[(c[b>>2]|0)+24>>2]&511](b)|0;e=I2(d,41448)|0;d=e;c[b+36>>2]=d;a[b+44|0]=(cD[c[(c[e>>2]|0)+28>>2]&511](d)|0)&1;return}function Dj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b|0;e=b+8|0;f=a+36|0;g=a+40|0;h=d|0;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=cZ[c[(c[a>>2]|0)+20>>2]&31](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((a4(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=6;break}if((l|0)==2){m=-1;n=8;break}else if((l|0)!=1){n=4;break}}if((n|0)==6){i=b;return m|0}else if((n|0)==8){i=b;return m|0}else if((n|0)==4){m=((a1(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}return 0}function Dk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if((a[b+44|0]&1)!=0){f=a4(d|0,4,e|0,c[b+32>>2]|0)|0;return f|0}g=b;if((e|0)>0){h=d;i=0}else{f=0;return f|0}while(1){if((cV[c[(c[g>>2]|0)+52>>2]&1023](b,c[h>>2]|0)|0)==-1){f=i;j=10;break}d=i+1|0;if((d|0)<(e|0)){h=h+4|0;i=d}else{f=d;j=9;break}}if((j|0)==9){return f|0}else if((j|0)==10){return f|0}return 0}function Dl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;L1:do{if(!k){c[g>>2]=d;if((a[b+44|0]&1)!=0){if((a4(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f|0;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=c0[c[(c[u>>2]|0)+12>>2]&31](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=17;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(v>>>0>=2>>>0){l=-1;w=18;break}v=(c[h>>2]|0)-r|0;if((a4(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=14;break}if(u){t=u?c[j>>2]|0:t}else{break L1}}if((w|0)==17){i=e;return l|0}else if((w|0)==7){if((a4(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==18){i=e;return l|0}else if((w|0)==14){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Dm(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;g=f|0;h=b|0;c[h>>2]=15696;j=b+4|0;I_(j);LI(b+8|0,0,24)|0;c[h>>2]=16584;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;I$(g,j);e=(z=0,aM(198,g|0,41448)|0);if(z){z=0;k=bT(-1,-1)|0;l=M;I0(g);c[h>>2]=15696;I0(j);bg(k|0)}d=e;m=b+36|0;c[m>>2]=d;n=b+44|0;c[n>>2]=cD[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[m>>2]|0;a[b+53|0]=(cD[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[n>>2]|0)<=8){I0(g);i=f;return}z=0;ar(50,664);if(!z){I0(g);i=f;return}else{z=0;k=bT(-1,-1)|0;l=M;I0(g);c[h>>2]=15696;I0(j);bg(k|0)}}function Dn(a){a=a|0;c[a>>2]=15696;I0(a+4|0);return}function Do(a){a=a|0;c[a>>2]=15696;I0(a+4|0);Lw(a);return}function Dp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=I2(d,41448)|0;d=e;f=b+36|0;c[f>>2]=d;g=b+44|0;c[g>>2]=cD[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[f>>2]|0;a[b+53|0]=(cD[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[g>>2]|0)<=8){return}Ik(664);return}function Dq(a){a=a|0;return Dt(a,0)|0}function Dr(a){a=a|0;return Dt(a,1)|0}function Ds(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]&1)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;L8:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f|0;q=c0[c[(c[o>>2]|0)+12>>2]&31](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==2|(q|0)==1){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=p>>>0){break L8}r=o-1|0;c[g>>2]=r;if((b5(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Dt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]&1)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;L8:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=bl(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break L8}}i=e;return n|0}}while(0);L15:do{if((a[b+53|0]&1)==0){l=b+40|0;m=b+36|0;o=f|0;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=c0[c[(c[t>>2]|0)+16>>2]&31](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=26;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break L15}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=29;break}v=bl(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=30;break}a[w]=v;r=r+1|0}if((y|0)==29){i=e;return n|0}else if((y|0)==26){i=e;return n|0}else if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==30){i=e;return n|0}}else{c[g>>2]=a[f|0]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b-1|0;if((b5(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=27;break}else{b=z}}if((y|0)==27){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Du(a){a=a|0;c[a>>2]=15768;I0(a+4|0);return}function Dv(a){a=a|0;c[a>>2]=15768;I0(a+4|0);Lw(a);return}function Dw(b,d){b=b|0;d=d|0;var e=0;cD[c[(c[b>>2]|0)+24>>2]&511](b)|0;e=I2(d,41456)|0;d=e;c[b+36>>2]=d;a[b+44|0]=(cD[c[(c[e>>2]|0)+28>>2]&511](d)|0)&1;return}function Dx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b|0;e=b+8|0;f=a+36|0;g=a+40|0;h=d|0;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=cZ[c[(c[a>>2]|0)+20>>2]&31](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((a4(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=8;break}if((l|0)==2){m=-1;n=7;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((a1(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==8){i=b;return m|0}else if((n|0)==7){i=b;return m|0}return 0}function Dy(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;if((a[b+44|0]&1)!=0){g=a4(e|0,1,f|0,c[b+32>>2]|0)|0;return g|0}h=b;if((f|0)>0){i=e;j=0}else{g=0;return g|0}while(1){if((cV[c[(c[h>>2]|0)+52>>2]&1023](b,d[i]|0)|0)==-1){g=j;k=10;break}e=j+1|0;if((e|0)<(f|0)){i=i+1|0;j=e}else{g=e;k=7;break}}if((k|0)==7){return g|0}else if((k|0)==10){return g|0}return 0}function Dz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;L1:do{if(!k){a[g]=d;if((a[b+44|0]&1)!=0){if((a4(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f|0;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=c0[c[(c[u>>2]|0)+12>>2]&31](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=17;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(v>>>0>=2>>>0){l=-1;w=18;break}v=(c[h>>2]|0)-r|0;if((a4(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=16;break}if(u){t=u?c[j>>2]|0:t}else{break L1}}if((w|0)==7){if((a4(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==17){i=e;return l|0}else if((w|0)==16){i=e;return l|0}else if((w|0)==18){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function DA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;g=f|0;h=b|0;c[h>>2]=15768;j=b+4|0;I_(j);LI(b+8|0,0,24)|0;c[h>>2]=16656;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;I$(g,j);e=(z=0,aM(198,g|0,41456)|0);if(z){z=0;k=bT(-1,-1)|0;l=M;I0(g);c[h>>2]=15768;I0(j);bg(k|0)}d=e;m=b+36|0;c[m>>2]=d;n=b+44|0;c[n>>2]=cD[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[m>>2]|0;a[b+53|0]=(cD[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[n>>2]|0)<=8){I0(g);i=f;return}z=0;ar(50,664);if(!z){I0(g);i=f;return}else{z=0;k=bT(-1,-1)|0;l=M;I0(g);c[h>>2]=15768;I0(j);bg(k|0)}}function DB(a){a=a|0;c[a>>2]=15768;I0(a+4|0);return}function DC(a){a=a|0;c[a>>2]=15768;I0(a+4|0);Lw(a);return}function DD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=I2(d,41456)|0;d=e;f=b+36|0;c[f>>2]=d;g=b+44|0;c[g>>2]=cD[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[f>>2]|0;a[b+53|0]=(cD[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[g>>2]|0)<=8){return}Ik(664);return}function DE(a){a=a|0;return DH(a,0)|0}function DF(a){a=a|0;return DH(a,1)|0}function DG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]&1)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;L8:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f|0;q=c0[c[(c[o>>2]|0)+12>>2]&31](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==2|(q|0)==1){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=p>>>0){break L8}r=o-1|0;c[g>>2]=r;if((b5(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function DH(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f|0;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]&1)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;L8:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=bl(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break L8}}i=f;return o|0}}while(0);L15:do{if((a[b+53|0]&1)==0){m=b+40|0;n=b+36|0;p=g|0;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=c0[c[(c[u>>2]|0)+16>>2]&31](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=29;break}else if((y|0)!=1){A=s;break L15}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=26;break}w=bl(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=30;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==30){i=f;return o|0}else if((z|0)==29){i=f;return o|0}else if((z|0)==26){i=f;return o|0}}else{a[h]=a[g|0]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k-1|0;if((b5(d[g+j|0]|0|0,c[l>>2]|0)|0)==-1){o=-1;z=31;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==31){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function DI(){De(0);bn(102,42208,t|0)|0;return}function DJ(a){a=a|0;return}function DK(a){a=a|0;var b=0;b=a+4|0;K=c[b>>2]|0,c[b>>2]=K+1,K;return}function DL(a){a=a|0;var b=0,d=0;b=a+4|0;if(((K=c[b>>2]|0,c[b>>2]=K+ -1,K)|0)!=0){d=0;return d|0}cA[c[(c[a>>2]|0)+8>>2]&1023](a);d=1;return d|0}function DM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a>>2]=13928;d=a+4|0;if((d|0)==0){return}a=LJ(b|0)|0;e=Lv(a+13|0)|0;c[e+4>>2]=a;c[e>>2]=a;f=e+12|0;c[d>>2]=f;c[e+8>>2]=0;LF(f|0,b|0,a+1|0)|0;return}function DN(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=13928;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((K=c[d>>2]|0,c[d>>2]=K+ -1,K)-1|0)>=0){e=a;Lw(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;Lw(e);return}Lx(d);e=a;Lw(e);return}function DO(a){a=a|0;var b=0;c[a>>2]=13928;b=a+4|0;a=(c[b>>2]|0)-4|0;if(((K=c[a>>2]|0,c[a>>2]=K+ -1,K)-1|0)>=0){return}a=(c[b>>2]|0)-12|0;if((a|0)==0){return}Lx(a);return}function DP(a){a=a|0;return c[a+4>>2]|0}function DQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;c[b>>2]=13832;e=b+4|0;if((e|0)==0){return}if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=LJ(f|0)|0;b=Lv(d+13|0)|0;c[b+4>>2]=d;c[b>>2]=d;g=b+12|0;c[e>>2]=g;c[b+8>>2]=0;LF(g|0,f|0,d+1|0)|0;return}function DR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a>>2]=13832;d=a+4|0;if((d|0)==0){return}a=LJ(b|0)|0;e=Lv(a+13|0)|0;c[e+4>>2]=a;c[e>>2]=a;f=e+12|0;c[d>>2]=f;c[e+8>>2]=0;LF(f|0,b|0,a+1|0)|0;return}function DS(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=13832;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((K=c[d>>2]|0,c[d>>2]=K+ -1,K)-1|0)>=0){e=a;Lw(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;Lw(e);return}Lx(d);e=a;Lw(e);return}function DT(a){a=a|0;var b=0;c[a>>2]=13832;b=a+4|0;a=(c[b>>2]|0)-4|0;if(((K=c[a>>2]|0,c[a>>2]=K+ -1,K)-1|0)>=0){return}a=(c[b>>2]|0)-12|0;if((a|0)==0){return}Lx(a);return}function DU(a){a=a|0;return c[a+4>>2]|0}function DV(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=13928;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((K=c[d>>2]|0,c[d>>2]=K+ -1,K)-1|0)>=0){e=a;Lw(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;Lw(e);return}Lx(d);e=a;Lw(e);return}function DW(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=13928;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((K=c[d>>2]|0,c[d>>2]=K+ -1,K)-1|0)>=0){e=a;Lw(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;Lw(e);return}Lx(d);e=a;Lw(e);return}function DX(a){a=a|0;return}function DY(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;return}function DZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e|0;c_[c[(c[a>>2]|0)+12>>2]&511](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function D_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if((c[b+4>>2]|0)!=(a|0)){e=0;return e|0}e=(c[b>>2]|0)==(d|0);return e|0}function D$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;d=b0(e|0)|0;e=LJ(d|0)|0;if(e>>>0>4294967279>>>0){D5(0)}if(e>>>0<11>>>0){a[b]=e<<1;f=b+1|0;LF(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}else{h=e+16&-16;i=Lu(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=e;f=i;LF(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}}function D0(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=f;j=i;i=i+12|0;i=i+7&-8;k=e|0;l=c[k>>2]|0;do{if((l|0)!=0){m=d[h]|0;if((m&1|0)==0){n=m>>>1}else{n=c[f+4>>2]|0}if((n|0)==0){o=l}else{Ei(f,8960,2)|0;o=c[k>>2]|0}m=c[e+4>>2]|0;c_[c[(c[m>>2]|0)+24>>2]&511](j,m,o);m=j;p=a[m]|0;if((p&1)==0){q=j+1|0}else{q=c[j+8>>2]|0}r=p&255;if((r&1|0)==0){s=r>>>1}else{s=c[j+4>>2]|0}z=0,az(88,f|0,q|0,s|0)|0;if(!z){if((a[m]&1)==0){break}Lw(c[j+8>>2]|0);break}else{z=0}r=bT(-1,-1)|0;if((a[m]&1)==0){bg(r|0)}Lw(c[j+8>>2]|0);bg(r|0)}}while(0);j=b;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];LI(h|0,0,12)|0;i=g;return}function D1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;f=i;i=i+32|0;g=d;d=i;i=i+8|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];g=f|0;h=f+16|0;j=LJ(e|0)|0;if(j>>>0>4294967279>>>0){D5(0)}if(j>>>0<11>>>0){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=Lu(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}LF(k|0,e|0,j)|0;a[k+j|0]=0;z=0;aR(262,g|0,d|0,h|0);do{if(!z){z=0;as(96,b|0,g|0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[g]&1)==0){n=j;o=k;break}Lw(c[g+8>>2]|0);n=j;o=k;break}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}if((a[h]&1)==0){p=b|0;c[p>>2]=16152;q=b+8|0;r=d;s=q;t=r|0;u=c[t>>2]|0;v=r+4|0;w=c[v>>2]|0;x=s|0;c[x>>2]=u;y=s+4|0;c[y>>2]=w;i=f;return}Lw(c[h+8>>2]|0);p=b|0;c[p>>2]=16152;q=b+8|0;r=d;s=q;t=r|0;u=c[t>>2]|0;v=r+4|0;w=c[v>>2]|0;x=s|0;c[x>>2]=u;y=s+4|0;c[y>>2]=w;i=f;return}else{z=0;k=bT(-1,-1)|0;n=M;o=k}}while(0);if((a[h]&1)==0){A=o;B=0;C=A;D=n;bg(C|0)}Lw(c[h+8>>2]|0);A=o;B=0;C=A;D=n;bg(C|0)}function D2(a){a=a|0;DT(a|0);Lw(a);return}function D3(a){a=a|0;DT(a|0);return}function D4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e;if((c[a>>2]|0)==1){do{bd(41208,41184)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)!=0){f;return}c[a>>2]=1;z=0,au(272,41184)|0;do{if(!z){z=0;ar(d|0,b|0);if(z){z=0;break}z=0,au(14,41184)|0;if(z){z=0;break}c[a>>2]=-1;z=0,au(272,41184)|0;if(z){z=0;break}z=0,au(116,41208)|0;if(z){z=0;break}return}else{z=0}}while(0);b=bT(-1,-1,0)|0;bD(b|0)|0;z=0,au(14,41184)|0;do{if(!z){c[a>>2]=0;z=0,au(272,41184)|0;if(z){z=0;break}z=0,au(116,41208)|0;if(z){z=0;break}z=0;aS(6);if(z){z=0;break}}else{z=0}}while(0);a=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(a|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function D5(a){a=a|0;var b=0;a=cl(8)|0;z=0;as(622,a|0,1392);if(!z){c[a>>2]=13896;bK(a|0,29384,474)}else{z=0;b=bT(-1,-1)|0;bo(a|0);bg(b|0)}}function D6(a){a=a|0;var b=0;a=cl(8)|0;z=0;as(622,a|0,1392);if(!z){c[a>>2]=13864;bK(a|0,29368,10)}else{z=0;b=bT(-1,-1)|0;bo(a|0);bg(b|0)}}function D7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=d;if((a[e]&1)==0){f=b;c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];return}e=c[d+8>>2]|0;f=c[d+4>>2]|0;if(f>>>0>4294967279>>>0){D5(0)}if(f>>>0<11>>>0){a[b]=f<<1;g=b+1|0}else{d=f+16&-16;h=Lu(d)|0;c[b+8>>2]=h;c[b>>2]=d|1;c[b+4>>2]=f;g=h}LF(g|0,e|0,f)|0;a[g+f|0]=0;return}function D8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(e>>>0>4294967279>>>0){D5(0)}if(e>>>0<11>>>0){a[b]=e<<1;f=b+1|0;LF(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}else{h=e+16&-16;i=Lu(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=e;f=i;LF(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}}function D9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if(d>>>0>4294967279>>>0){D5(0)}if(d>>>0<11>>>0){a[b]=d<<1;f=b+1|0}else{g=d+16&-16;h=Lu(g)|0;c[b+8>>2]=h;c[b>>2]=g|1;c[b+4>>2]=d;f=h}LI(f|0,e|0,d|0)|0;a[f+d|0]=0;return}function Ea(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=a[d]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}if(i>>>0<e>>>0){D6(0)}if((g&1)==0){j=d+1|0}else{j=c[d+8>>2]|0}d=j+e|0;j=i-e|0;e=j>>>0<f>>>0?j:f;if(e>>>0>4294967279>>>0){D5(0)}if(e>>>0<11>>>0){a[b]=e<<1;k=b+1|0;LF(k|0,d|0,e)|0;l=k+e|0;a[l]=0;return}else{f=e+16&-16;j=Lu(f)|0;c[b+8>>2]=j;c[b>>2]=f|1;c[b+4>>2]=e;k=j;LF(k|0,d|0,e)|0;l=k+e|0;a[l]=0;return}}function Eb(b){b=b|0;if((a[b]&1)==0){return}Lw(c[b+8>>2]|0);return}function Ec(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((b|0)==(d|0)){return b|0}e=a[d]|0;if((e&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}g=e&255;if((g&1|0)==0){h=g>>>1}else{h=c[d+4>>2]|0}d=b;g=b;e=a[g]|0;if((e&1)==0){i=10;j=e}else{e=c[b>>2]|0;i=(e&-2)-1|0;j=e&255}if(i>>>0<h>>>0){e=j&255;if((e&1|0)==0){k=e>>>1}else{k=c[b+4>>2]|0}Ej(b,i,h-i|0,k,0,k,h,f);return b|0}if((j&1)==0){l=d+1|0}else{l=c[b+8>>2]|0}LG(l|0,f|0,h|0)|0;a[l+h|0]=0;if((a[g]&1)==0){a[g]=h<<1;return b|0}else{c[b+4>>2]=h;return b|0}return 0}function Ed(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=LJ(d|0)|0;f=b;g=b;h=a[g]|0;if((h&1)==0){i=10;j=h}else{h=c[b>>2]|0;i=(h&-2)-1|0;j=h&255}if(i>>>0<e>>>0){h=j&255;if((h&1|0)==0){k=h>>>1}else{k=c[b+4>>2]|0}Ej(b,i,e-i|0,k,0,k,e,d);return b|0}if((j&1)==0){l=f+1|0}else{l=c[b+8>>2]|0}LG(l|0,d|0,e|0)|0;a[l+e|0]=0;if((a[g]&1)==0){a[g]=e<<1;return b|0}else{c[b+4>>2]=e;return b|0}return 0}function Ee(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b;g=a[f]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[b+4>>2]|0}if(i>>>0<d>>>0){Ef(b,d-i|0,e)|0;return}if((g&1)==0){a[b+1+d|0]=0;a[f]=d<<1;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;return}}function Ef(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((d|0)==0){return b|0}f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}if((h-j|0)>>>0<d>>>0){Ek(b,h,d-h+j|0,j,j,0,0);k=a[f]|0}else{k=i}if((k&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}LI(l+j|0,e|0,d|0)|0;e=j+d|0;if((a[f]&1)==0){a[f]=e<<1}else{c[b+4>>2]=e}a[l+e|0]=0;return b|0}function Eg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(d>>>0>4294967279>>>0){D5(0)}e=b;f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}g=j>>>0>d>>>0?j:d;if(g>>>0<11>>>0){k=11}else{k=g+16&-16}g=k-1|0;if((g|0)==(h|0)){return}if((g|0)==10){l=e+1|0;m=c[b+8>>2]|0;n=1;o=0}else{do{if(g>>>0>h>>>0){p=Lu(k)|0}else{d=(z=0,au(248,k|0)|0);if(!z){p=d;break}else{z=0}d=bT(-1,-1,0)|0;bD(d|0)|0;a$();return}}while(0);h=i&1;if(h<<24>>24==0){q=e+1|0}else{q=c[b+8>>2]|0}l=p;m=q;n=h<<24>>24!=0;o=1}h=i&255;if((h&1|0)==0){r=h>>>1}else{r=c[b+4>>2]|0}LF(l|0,m|0,r+1|0)|0;if(n){Lw(m)}if(o){c[b>>2]=k|1;c[b+4>>2]=j;c[b+8>>2]=l;return}else{a[f]=j<<1;return}}function Eh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b;f=a[e]|0;if((f&1)==0){g=(f&255)>>>1;h=10}else{g=c[b+4>>2]|0;h=(c[b>>2]&-2)-1|0}if((g|0)==(h|0)){Ek(b,h,1,h,h,0,0);i=a[e]|0}else{i=f}if((i&1)==0){a[e]=(g<<1)+2;j=b+1|0;k=g+1|0;l=j+g|0;a[l]=d;m=j+k|0;a[m]=0;return}else{e=c[b+8>>2]|0;i=g+1|0;c[b+4>>2]=i;j=e;k=i;l=j+g|0;a[l]=d;m=j+k|0;a[m]=0;return}}function Ei(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}if((h-j|0)>>>0<e>>>0){Ej(b,h,e-h+j|0,j,j,0,e,d);return b|0}if((e|0)==0){return b|0}if((i&1)==0){k=b+1|0}else{k=c[b+8>>2]|0}LF(k+j|0,d|0,e)|0;d=j+e|0;if((a[f]&1)==0){a[f]=d<<1}else{c[b+4>>2]=d}a[k+d|0]=0;return b|0}function Ej(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((-18-d|0)>>>0<e>>>0){D5(0)}if((a[b]&1)==0){k=b+1|0}else{k=c[b+8>>2]|0}do{if(d>>>0<2147483623>>>0){l=e+d|0;m=d<<1;n=l>>>0<m>>>0?m:l;if(n>>>0<11>>>0){o=11;break}o=n+16&-16}else{o=-17}}while(0);e=Lu(o)|0;if((g|0)!=0){LF(e|0,k|0,g)|0}if((i|0)!=0){LF(e+g|0,j|0,i)|0}j=f-h|0;if((j|0)!=(g|0)){LF(e+(i+g)|0,k+(h+g)|0,j-g|0)|0}if((d|0)==10){p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+s|0;a[u]=0;return}Lw(k);p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+s|0;a[u]=0;return}function Ek(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((-17-d|0)>>>0<e>>>0){D5(0)}if((a[b]&1)==0){j=b+1|0}else{j=c[b+8>>2]|0}do{if(d>>>0<2147483623>>>0){k=e+d|0;l=d<<1;m=k>>>0<l>>>0?l:k;if(m>>>0<11>>>0){n=11;break}n=m+16&-16}else{n=-17}}while(0);e=Lu(n)|0;if((g|0)!=0){LF(e|0,j|0,g)|0}m=f-h|0;if((m|0)!=(g|0)){LF(e+(i+g)|0,j+(h+g)|0,m-g|0)|0}if((d|0)==10){o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}Lw(j);o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}function El(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=b;h=a[g]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){D6(0);return 0}if((h&1)==0){k=10;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}if((k-j|0)>>>0<f>>>0){Ej(b,k,j+f-k|0,j,d,0,f,e);return b|0}if((f|0)==0){return b|0}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}l=j-d|0;k=m+d|0;if((j|0)==(d|0)){n=e}else{do{if(k>>>0>e>>>0){o=e}else{if((m+j|0)>>>0<=e>>>0){o=e;break}o=e+f|0}}while(0);LG(m+(f+d)|0,k|0,l|0)|0;n=o}LG(k|0,n|0,f|0)|0;n=j+f|0;if((a[g]&1)==0){a[g]=n<<1}else{c[b+4>>2]=n}a[m+n|0]=0;return b|0}function Em(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(e>>>0>1073741807>>>0){D5(0)}if(e>>>0<2>>>0){a[b]=e<<1;f=b+4|0;g=KX(f,d,e)|0;h=f+(e<<2)|0;c[h>>2]=0;return}else{i=e+4&-4;j=Lu(i<<2)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=e;f=j;g=KX(f,d,e)|0;h=f+(e<<2)|0;c[h>>2]=0;return}}function En(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(d>>>0>1073741807>>>0){D5(0)}if(d>>>0<2>>>0){a[b]=d<<1;f=b+4|0;g=KZ(f,e,d)|0;h=f+(d<<2)|0;c[h>>2]=0;return}else{i=d+4&-4;j=Lu(i<<2)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=d;f=j;g=KZ(f,e,d)|0;h=f+(d<<2)|0;c[h>>2]=0;return}}function Eo(b){b=b|0;if((a[b]&1)==0){return}Lw(c[b+8>>2]|0);return}function Ep(a,b){a=a|0;b=b|0;return Eq(a,b,KW(b)|0)|0}function Eq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b;g=a[f]|0;if((g&1)==0){h=1;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}if(h>>>0<e>>>0){g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}Et(b,h,e-h|0,j,0,j,e,d);return b|0}if((i&1)==0){k=b+4|0}else{k=c[b+8>>2]|0}KY(k,d,e)|0;c[k+(e<<2)>>2]=0;if((a[f]&1)==0){a[f]=e<<1;return b|0}else{c[b+4>>2]=e;return b|0}return 0}function Er(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(d>>>0>1073741807>>>0){D5(0)}e=b;f=a[e]|0;if((f&1)==0){g=1;h=f}else{f=c[b>>2]|0;g=(f&-2)-1|0;h=f&255}f=h&255;if((f&1|0)==0){i=f>>>1}else{i=c[b+4>>2]|0}f=i>>>0>d>>>0?i:d;if(f>>>0<2>>>0){j=2}else{j=f+4&-4}f=j-1|0;if((f|0)==(g|0)){return}if((f|0)==1){k=b+4|0;l=c[b+8>>2]|0;m=1;n=0}else{d=j<<2;do{if(f>>>0>g>>>0){o=Lu(d)|0}else{p=(z=0,au(248,d|0)|0);if(!z){o=p;break}else{z=0}p=bT(-1,-1,0)|0;bD(p|0)|0;a$();return}}while(0);d=h&1;if(d<<24>>24==0){q=b+4|0}else{q=c[b+8>>2]|0}k=o;l=q;m=d<<24>>24!=0;n=1}d=k;k=h&255;if((k&1|0)==0){r=k>>>1}else{r=c[b+4>>2]|0}KX(d,l,r+1|0)|0;if(m){Lw(l)}if(n){c[b>>2]=j|1;c[b+4>>2]=i;c[b+8>>2]=d;return}else{a[e]=i<<1;return}}function Es(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b;f=a[e]|0;if((f&1)==0){g=(f&255)>>>1;h=1}else{g=c[b+4>>2]|0;h=(c[b>>2]&-2)-1|0}if((g|0)==(h|0)){Eu(b,h,1,h,h,0,0);i=a[e]|0}else{i=f}if((i&1)==0){a[e]=(g<<1)+2;j=b+4|0;k=g+1|0;l=j+(g<<2)|0;c[l>>2]=d;m=j+(k<<2)|0;c[m>>2]=0;return}else{e=c[b+8>>2]|0;i=g+1|0;c[b+4>>2]=i;j=e;k=i;l=j+(g<<2)|0;c[l>>2]=d;m=j+(k<<2)|0;c[m>>2]=0;return}}function Et(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((1073741806-d|0)>>>0<e>>>0){D5(0)}if((a[b]&1)==0){k=b+4|0}else{k=c[b+8>>2]|0}do{if(d>>>0<536870887>>>0){l=e+d|0;m=d<<1;n=l>>>0<m>>>0?m:l;if(n>>>0<2>>>0){o=2;break}o=n+4&-4}else{o=1073741807}}while(0);e=Lu(o<<2)|0;if((g|0)!=0){KX(e,k,g)|0}if((i|0)!=0){KX(e+(g<<2)|0,j,i)|0}j=f-h|0;if((j|0)!=(g|0)){KX(e+(i+g<<2)|0,k+(h+g<<2)|0,j-g|0)|0}if((d|0)==1){p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+(s<<2)|0;c[u>>2]=0;return}Lw(k);p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+(s<<2)|0;c[u>>2]=0;return}function Eu(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((1073741807-d|0)>>>0<e>>>0){D5(0)}if((a[b]&1)==0){j=b+4|0}else{j=c[b+8>>2]|0}do{if(d>>>0<536870887>>>0){k=e+d|0;l=d<<1;m=k>>>0<l>>>0?l:k;if(m>>>0<2>>>0){n=2;break}n=m+4&-4}else{n=1073741807}}while(0);e=Lu(n<<2)|0;if((g|0)!=0){KX(e,j,g)|0}m=f-h|0;if((m|0)!=(g|0)){KX(e+(i+g<<2)|0,j+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}Lw(j);o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}function Ev(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=b;LI(g|0,0,12)|0;h=LJ(e|0)|0;i=f;j=f;k=d[j]|0;if((k&1|0)==0){l=k>>>1}else{l=c[f+4>>2]|0}k=l+h|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[g]=h<<1;m=b+1|0}else{n=k+16&-16;o=(z=0,au(248,n|0)|0);if(z){z=0;break}c[b+8>>2]=o;c[b>>2]=n|1;c[b+4>>2]=h;m=o}LF(m|0,e|0,h)|0;a[m+h|0]=0;if((a[j]&1)==0){p=i+1|0}else{p=c[f+8>>2]|0}z=0,az(88,b|0,p|0,l|0)|0;if(z){z=0;break}return}}while(0);l=bT(-1,-1)|0;if((a[g]&1)==0){bg(l|0)}Lw(c[b+8>>2]|0);bg(l|0)}function Ew(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e|0;g=(c[b+24>>2]|0)==0;if(g){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((g&1|d)&c[b+20>>2]|0)==0){i=e;return}e=cl(16)|0;do{if((a[42328]|0)==0){if((bC(42328)|0)==0){break}c[10084]=15392;bn(184,40336,t|0)|0}}while(0);b=LO(40336,0,32)|0;c[f>>2]=b&0|1;c[f+4>>2]=M|0;z=0;aR(440,e|0,f|0,9424);if(!z){c[e>>2]=14576;bK(e|0,29944,160)}else{z=0;f=bT(-1,-1)|0;bo(e|0);bg(f|0)}}function Ex(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=14552;b=c[a+40>>2]|0;d=a+32|0;e=a+36|0;L1:do{if((b|0)!=0){f=b;while(1){f=f-1|0;z=0;aR(c[(c[d>>2]|0)+(f<<2)>>2]|0,0,a|0,c[(c[e>>2]|0)+(f<<2)>>2]|0);if(z){z=0;break}if((f|0)==0){break L1}}bT(-1,-1,0)|0;bX()}}while(0);I0(a+28|0);Lp(c[d>>2]|0);Lp(c[e>>2]|0);Lp(c[a+48>>2]|0);Lp(c[a+60>>2]|0);return}function Ey(a,b){a=a|0;b=b|0;I$(a,b+28|0);return}function Ez(a,b){a=a|0;b=b|0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;LI(a+32|0,0,40)|0;if((b|0)==0){return}I_(b);return}function EA(a){a=a|0;c[a>>2]=15768;I0(a+4|0);Lw(a);return}function EB(a){a=a|0;c[a>>2]=15768;I0(a+4|0);return}function EC(a,b){a=a|0;b=b|0;return}function ED(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function EE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function EF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;b=d;d=i;i=i+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;i=e;return}function EG(a){a=a|0;return 0}function EH(a){a=a|0;return 0}function EI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=b;if((e|0)<=0){g=0;return g|0}h=b+12|0;i=b+16|0;j=d;d=0;while(1){k=c[h>>2]|0;if(k>>>0<(c[i>>2]|0)>>>0){c[h>>2]=k+1;l=a[k]|0}else{k=cD[c[(c[f>>2]|0)+40>>2]&511](b)|0;if((k|0)==-1){g=d;m=9;break}l=k&255}a[j]=l;k=d+1|0;if((k|0)<(e|0)){j=j+1|0;d=k}else{g=k;m=11;break}}if((m|0)==9){return g|0}else if((m|0)==11){return g|0}return 0}function EJ(a){a=a|0;return-1|0}function EK(a){a=a|0;var b=0,e=0;if((cD[c[(c[a>>2]|0)+36>>2]&511](a)|0)==-1){b=-1;return b|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+1;b=d[a]|0;return b|0}function EL(a,b){a=a|0;b=b|0;return-1|0}function EM(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=b;if((f|0)<=0){h=0;return h|0}i=b+24|0;j=b+28|0;k=0;l=e;while(1){e=c[i>>2]|0;if(e>>>0<(c[j>>2]|0)>>>0){m=a[l]|0;c[i>>2]=e+1;a[e]=m}else{if((cV[c[(c[g>>2]|0)+52>>2]&1023](b,d[l]|0)|0)==-1){h=k;n=10;break}}m=k+1|0;if((m|0)<(f|0)){k=m;l=l+1|0}else{h=m;n=9;break}}if((n|0)==9){return h|0}else if((n|0)==10){return h|0}return 0}function EN(a,b){a=a|0;b=b|0;return-1|0}function EO(a){a=a|0;c[a>>2]=15696;I0(a+4|0);Lw(a);return}function EP(a){a=a|0;c[a>>2]=15696;I0(a+4|0);return}function EQ(a,b){a=a|0;b=b|0;return}function ER(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function ES(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function ET(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;b=d;d=i;i=i+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;i=e;return}function EU(a){a=a|0;return 0}function EV(a){a=a|0;return 0}function EW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a;if((d|0)<=0){f=0;return f|0}g=a+12|0;h=a+16|0;i=b;b=0;while(1){j=c[g>>2]|0;if(j>>>0<(c[h>>2]|0)>>>0){c[g>>2]=j+4;k=c[j>>2]|0}else{j=cD[c[(c[e>>2]|0)+40>>2]&511](a)|0;if((j|0)==-1){f=b;l=9;break}else{k=j}}c[i>>2]=k;j=b+1|0;if((j|0)<(d|0)){i=i+4|0;b=j}else{f=j;l=10;break}}if((l|0)==9){return f|0}else if((l|0)==10){return f|0}return 0}function EX(a){a=a|0;return-1|0}function EY(a){a=a|0;var b=0,d=0;if((cD[c[(c[a>>2]|0)+36>>2]&511](a)|0)==-1){b=-1;return b|0}d=a+12|0;a=c[d>>2]|0;c[d>>2]=a+4;b=c[a>>2]|0;return b|0}function EZ(a,b){a=a|0;b=b|0;return-1|0}function E_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a;if((d|0)<=0){f=0;return f|0}g=a+24|0;h=a+28|0;i=0;j=b;while(1){b=c[g>>2]|0;if(b>>>0<(c[h>>2]|0)>>>0){k=c[j>>2]|0;c[g>>2]=b+4;c[b>>2]=k}else{if((cV[c[(c[e>>2]|0)+52>>2]&1023](a,c[j>>2]|0)|0)==-1){f=i;l=10;break}}k=i+1|0;if((k|0)<(d|0)){i=k;j=j+4|0}else{f=k;l=8;break}}if((l|0)==8){return f|0}else if((l|0)==10){return f|0}return 0}function E$(a,b){a=a|0;b=b|0;return-1|0}function E0(a){a=a|0;Ex(a+8|0);Lw(a);return}function E1(a){a=a|0;Ex(a+8|0);return}function E2(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;Ex(b+(d+8)|0);Lw(b+d|0);return}function E3(a){a=a|0;Ex(a+((c[(c[a>>2]|0)-12>>2]|0)+8)|0);return}function E4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+8|0;e=d|0;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;if((c[h+(g+24)>>2]|0)==0){i=d;return b|0}j=e|0;a[j]=0;c[e+4>>2]=b;do{if((c[h+(g+16)>>2]|0)==0){k=c[h+(g+72)>>2]|0;do{if((k|0)==0){l=5}else{z=0,au(62,k|0)|0;if(!z){l=5;break}else{z=0}m=bT(-1,-1,0)|0;n=m}}while(0);if((l|0)==5){a[j]=1;k=c[h+((c[(c[f>>2]|0)-12>>2]|0)+24)>>2]|0;m=(z=0,au(c[(c[k>>2]|0)+24>>2]|0,k|0)|0);if(!z){if((m|0)!=-1){break}m=c[(c[f>>2]|0)-12>>2]|0;z=0;as(368,h+m|0,c[h+(m+16)>>2]|1|0);if(!z){break}else{z=0}}else{z=0}m=bT(-1,-1,0)|0;Fi(e);n=m}bD(n|0)|0;m=c[(c[f>>2]|0)-12>>2]|0;k=h+(m+16)|0;c[k>>2]=c[k>>2]|1;if((c[h+(m+20)>>2]&1|0)==0){a$();i=d;return b|0}z=0;aS(6);if(!z){return 0}else{z=0}m=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(m|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);Fi(e);i=d;return b|0}function E5(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){return}else{be()}}function E6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a+4|0;c[e>>2]=0;f=a;g=c[(c[f>>2]|0)-12>>2]|0;h=a;i=c[h+(g+16)>>2]|0;do{if((i|0)==0){j=c[h+(g+72)>>2]|0;if((j|0)==0){k=g}else{z=0,au(62,j|0)|0;if(z){z=0;break}k=c[(c[f>>2]|0)-12>>2]|0}if((c[h+(k+16)>>2]|0)!=0){l=k;m=16;break}j=c[h+(k+24)>>2]|0;n=(z=0,az(c[(c[j>>2]|0)+32>>2]|0,j|0,b|0,d|0)|0);if(z){z=0;break}c[e>>2]=n;if((n|0)==(d|0)){return a|0}n=c[(c[f>>2]|0)-12>>2]|0;z=0;as(368,h+n|0,c[h+(n+16)>>2]|6|0);if(z){z=0;break}return a|0}else{z=0;as(368,h+g|0,i|4|0);if(z){z=0;break}l=c[(c[f>>2]|0)-12>>2]|0;m=16}}while(0);do{if((m|0)==16){z=0;as(368,h+l|0,c[h+(l+16)>>2]|4|0);if(z){z=0;break}return a|0}}while(0);l=bT(-1,-1,0)|0;bD(l|0)|0;l=c[(c[f>>2]|0)-12>>2]|0;f=h+(l+16)|0;c[f>>2]=c[f>>2]|1;if((c[h+(l+20)>>2]&1|0)==0){a$();return a|0}z=0;aS(6);if(!z){return 0}else{z=0}a=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(a|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function E7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d|0;f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;b=c[h+(g+16)>>2]|0;do{if((b|0)==0){j=c[h+(g+72)>>2]|0;if((j|0)==0){k=g}else{z=0,au(62,j|0)|0;if(z){z=0;break}k=c[(c[f>>2]|0)-12>>2]|0}if((c[h+(k+16)>>2]|0)!=0){i=d;return}j=c[h+(k+24)>>2]|0;z=0;aD(c[(c[j>>2]|0)+16>>2]|0,e|0,j|0,0,0,1,8);if(z){z=0;break}j=a;l=e;c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=d;return}else{z=0;as(368,h+g|0,b|4|0);if(z){z=0;break}i=d;return}}while(0);b=bT(-1,-1,0)|0;bD(b|0)|0;b=c[(c[f>>2]|0)-12>>2]|0;f=h+(b+16)|0;c[f>>2]=c[f>>2]|1;if((c[h+(b+20)>>2]&1|0)==0){a$();i=d;return}z=0;aS(6);if(z){z=0}d=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(d|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function E8(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f|0;h=a;j=c[(c[h>>2]|0)-12>>2]|0;k=a;l=c[k+(j+16)>>2]|0;do{if((l|0)==0){m=c[k+(j+72)>>2]|0;if((m|0)==0){n=j}else{z=0,au(62,m|0)|0;if(z){z=0;break}n=c[(c[h>>2]|0)-12>>2]|0}if((c[k+(n+16)>>2]|0)!=0){i=f;return a|0}m=c[k+(n+24)>>2]|0;z=0;aD(c[(c[m>>2]|0)+16>>2]|0,g|0,m|0,b|0,d|0,e|0,8);if(z){z=0;break}m=g+8|0;if(!((c[m>>2]|0)==(-1|0)&(c[m+4>>2]|0)==(-1|0))){i=f;return a|0}m=c[(c[h>>2]|0)-12>>2]|0;z=0;as(368,k+m|0,c[k+(m+16)>>2]|4|0);if(z){z=0;break}i=f;return a|0}else{z=0;as(368,k+j|0,l|4|0);if(z){z=0;break}i=f;return a|0}}while(0);l=bT(-1,-1,0)|0;bD(l|0)|0;l=c[(c[h>>2]|0)-12>>2]|0;h=k+(l+16)|0;c[h>>2]=c[h>>2]|1;if((c[k+(l+20)>>2]&1|0)==0){a$();i=f;return a|0}z=0;aS(6);if(!z){return 0}else{z=0}a=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(a|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function E9(a){a=a|0;Ex(a+8|0);Lw(a);return}function Fa(a){a=a|0;Ex(a+8|0);return}function Fb(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;Ex(b+(d+8)|0);Lw(b+d|0);return}function Fc(a){a=a|0;Ex(a+((c[(c[a>>2]|0)-12>>2]|0)+8)|0);return}function Fd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+8|0;e=d|0;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;if((c[h+(g+24)>>2]|0)==0){i=d;return b|0}j=e|0;a[j]=0;c[e+4>>2]=b;do{if((c[h+(g+16)>>2]|0)==0){k=c[h+(g+72)>>2]|0;do{if((k|0)==0){l=5}else{z=0,au(166,k|0)|0;if(!z){l=5;break}else{z=0}m=bT(-1,-1,0)|0;n=m}}while(0);if((l|0)==5){a[j]=1;k=c[h+((c[(c[f>>2]|0)-12>>2]|0)+24)>>2]|0;m=(z=0,au(c[(c[k>>2]|0)+24>>2]|0,k|0)|0);if(!z){if((m|0)!=-1){break}m=c[(c[f>>2]|0)-12>>2]|0;z=0;as(368,h+m|0,c[h+(m+16)>>2]|1|0);if(!z){break}else{z=0}}else{z=0}m=bT(-1,-1,0)|0;Fr(e);n=m}bD(n|0)|0;m=c[(c[f>>2]|0)-12>>2]|0;k=h+(m+16)|0;c[k>>2]=c[k>>2]|1;if((c[h+(m+20)>>2]&1|0)==0){a$();i=d;return b|0}z=0;aS(6);if(!z){return 0}else{z=0}m=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(m|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);Fr(e);i=d;return b|0}function Fe(a){a=a|0;Ex(a+4|0);Lw(a);return}function Ff(a){a=a|0;Ex(a+4|0);return}function Fg(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;Ex(b+(d+4)|0);Lw(b+d|0);return}function Fh(a){a=a|0;Ex(a+((c[(c[a>>2]|0)-12>>2]|0)+4)|0);return}function Fi(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+4|0;a=c[b>>2]|0;d=c[(c[a>>2]|0)-12>>2]|0;e=a;if((c[e+(d+24)>>2]|0)==0){return}if((c[e+(d+16)>>2]|0)!=0){return}if((c[e+(d+4)>>2]&8192|0)==0){return}if(bG()|0){return}d=c[b>>2]|0;e=c[d+((c[(c[d>>2]|0)-12>>2]|0)+24)>>2]|0;d=(z=0,au(c[(c[e>>2]|0)+24>>2]|0,e|0)|0);do{if(!z){if((d|0)!=-1){return}e=c[b>>2]|0;a=c[(c[e>>2]|0)-12>>2]|0;f=e;z=0;as(368,f+a|0,c[f+(a+16)>>2]|1|0);if(z){z=0;break}return}else{z=0}}while(0);b=bT(-1,-1,0)|0;bD(b|0)|0;z=0;aS(2);if(!z){return}else{z=0;bT(-1,-1,0)|0;bX()}}function Fj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;do{if((p|0)==0){q=4}else{z=0,au(62,p|0)|0;if(!z){q=4;break}else{z=0}r=bT(-1,-1,0)|0;s=r}}while(0);if((q|0)==4){a[l]=1;I$(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=(z=0,aM(198,j|0,41408)|0);if(!z){r=p;I0(j);t=c[(c[m>>2]|0)-12>>2]|0;u=c[o+(t+24)>>2]|0;v=o+t|0;w=o+(t+76)|0;x=c[w>>2]|0;y=x&255;L11:do{if((x|0)==-1){I$(g,o+(t+28)|0);A=(z=0,aM(198,g|0,41760)|0);do{if(!z){B=(z=0,aM(c[(c[A>>2]|0)+28>>2]|0,A|0,32)|0);if(z){z=0;break}I0(g);c[w>>2]=B<<24>>24;C=B;q=10;break L11}else{z=0}}while(0);A=bT(-1,-1,0)|0;B=M;I0(g);D=B;E=A}else{C=y;q=10}}while(0);if((q|0)==10){y=c[(c[p>>2]|0)+24>>2]|0;c[f>>2]=u;z=0;aD(y|0,k|0,r|0,f|0,v|0,C|0,d|0);if(!z){if((c[k>>2]|0)!=0){break}y=c[(c[m>>2]|0)-12>>2]|0;z=0;as(368,o+y|0,c[o+(y+16)>>2]|5|0);if(!z){break}else{z=0}}else{z=0}y=bT(-1,-1,0)|0;D=M;E=y}F=E}else{z=0;y=bT(-1,-1,0)|0;I0(j);F=y}Fi(h);s=F}bD(s|0)|0;y=c[(c[m>>2]|0)-12>>2]|0;w=o+(y+16)|0;c[w>>2]=c[w>>2]|1;if((c[o+(y+20)>>2]&1|0)==0){a$();i=e;return b|0}z=0;aS(6);if(!z){return 0}else{z=0}y=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(y|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);Fi(h);i=e;return b|0}function Fk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;do{if((p|0)==0){q=4}else{z=0,au(62,p|0)|0;if(!z){q=4;break}else{z=0}r=bT(-1,-1,0)|0;s=r}}while(0);if((q|0)==4){a[l]=1;I$(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=(z=0,aM(198,j|0,41408)|0);if(!z){r=p;I0(j);t=c[(c[m>>2]|0)-12>>2]|0;u=c[o+(t+24)>>2]|0;v=o+t|0;w=o+(t+76)|0;x=c[w>>2]|0;y=x&255;L10:do{if((x|0)==-1){I$(g,o+(t+28)|0);A=(z=0,aM(198,g|0,41760)|0);do{if(!z){B=(z=0,aM(c[(c[A>>2]|0)+28>>2]|0,A|0,32)|0);if(z){z=0;break}I0(g);c[w>>2]=B<<24>>24;C=B;q=10;break L10}else{z=0}}while(0);A=bT(-1,-1,0)|0;B=M;I0(g);D=B;E=A}else{C=y;q=10}}while(0);if((q|0)==10){y=c[(c[p>>2]|0)+24>>2]|0;c[f>>2]=u;z=0;aD(y|0,k|0,r|0,f|0,v|0,C|0,d|0);if(!z){if((c[k>>2]|0)!=0){break}y=c[(c[m>>2]|0)-12>>2]|0;z=0;as(368,o+y|0,c[o+(y+16)>>2]|5|0);if(!z){break}else{z=0}}else{z=0}y=bT(-1,-1,0)|0;D=M;E=y}F=E}else{z=0;y=bT(-1,-1,0)|0;I0(j);F=y}Fi(h);s=F}bD(s|0)|0;y=c[(c[m>>2]|0)-12>>2]|0;w=o+(y+16)|0;c[w>>2]=c[w>>2]|1;if((c[o+(y+20)>>2]&1|0)==0){a$();i=e;return b|0}z=0;aS(6);if(!z){return 0}else{z=0}y=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(y|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);Fi(h);i=e;return b|0}function Fl(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;do{if((p|0)==0){q=4}else{z=0,au(62,p|0)|0;if(!z){q=4;break}else{z=0}r=bT(-1,-1,0)|0;s=r}}while(0);if((q|0)==4){a[l]=1;I$(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=(z=0,aM(198,j|0,41408)|0);if(!z){r=p;I0(j);t=c[(c[m>>2]|0)-12>>2]|0;u=c[o+(t+24)>>2]|0;v=o+t|0;w=o+(t+76)|0;x=c[w>>2]|0;y=x&255;L10:do{if((x|0)==-1){I$(g,o+(t+28)|0);A=(z=0,aM(198,g|0,41760)|0);do{if(!z){B=(z=0,aM(c[(c[A>>2]|0)+28>>2]|0,A|0,32)|0);if(z){z=0;break}I0(g);c[w>>2]=B<<24>>24;C=B;q=10;break L10}else{z=0}}while(0);A=bT(-1,-1,0)|0;B=M;I0(g);D=B;E=A}else{C=y;q=10}}while(0);if((q|0)==10){y=c[(c[p>>2]|0)+32>>2]|0;c[f>>2]=u;z=0;aB(y|0,k|0,r|0,f|0,v|0,C|0,+d);if(!z){if((c[k>>2]|0)!=0){break}y=c[(c[m>>2]|0)-12>>2]|0;z=0;as(368,o+y|0,c[o+(y+16)>>2]|5|0);if(!z){break}else{z=0}}else{z=0}y=bT(-1,-1,0)|0;D=M;E=y}F=E}else{z=0;y=bT(-1,-1,0)|0;I0(j);F=y}Fi(h);s=F}bD(s|0)|0;y=c[(c[m>>2]|0)-12>>2]|0;w=o+(y+16)|0;c[w>>2]=c[w>>2]|1;if((c[o+(y+20)>>2]&1|0)==0){a$();i=e;return b|0}z=0;aS(6);if(!z){return 0}else{z=0}y=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(y|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);Fi(h);i=e;return b|0}function Fm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e|0;g=f|0;a[g]=0;c[f+4>>2]=b;h=b;j=c[(c[h>>2]|0)-12>>2]|0;k=b;do{if((c[k+(j+16)>>2]|0)==0){l=c[k+(j+72)>>2]|0;do{if((l|0)==0){m=4}else{z=0,au(62,l|0)|0;if(!z){m=4;break}else{z=0}n=bT(-1,-1,0)|0;o=n}}while(0);if((m|0)==4){a[g]=1;l=c[k+((c[(c[h>>2]|0)-12>>2]|0)+24)>>2]|0;n=l;do{if((l|0)==0){p=n;m=9}else{q=l+24|0;r=c[q>>2]|0;if((r|0)==(c[l+28>>2]|0)){s=(z=0,aM(c[(c[l>>2]|0)+52>>2]|0,n|0,d&255|0)|0);if(!z){t=s}else{z=0;break}}else{c[q>>2]=r+1;a[r]=d;t=d&255}p=(t|0)==-1?0:n;m=9}}while(0);if((m|0)==9){if((p|0)!=0){break}n=c[(c[h>>2]|0)-12>>2]|0;z=0;as(368,k+n|0,c[k+(n+16)>>2]|1|0);if(!z){break}else{z=0}}n=bT(-1,-1,0)|0;Fi(f);o=n}bD(o|0)|0;n=c[(c[h>>2]|0)-12>>2]|0;l=k+(n+16)|0;c[l>>2]=c[l>>2]|1;if((c[k+(n+20)>>2]&1|0)==0){a$();i=e;return b|0}z=0;aS(6);if(!z){return 0}else{z=0}n=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(n|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);Fi(f);i=e;return b|0}function Fn(a){a=a|0;Ex(a+4|0);Lw(a);return}function Fo(a){a=a|0;Ex(a+4|0);return}function Fp(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;Ex(b+(d+4)|0);Lw(b+d|0);return}function Fq(a){a=a|0;Ex(a+((c[(c[a>>2]|0)-12>>2]|0)+4)|0);return}function Fr(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+4|0;a=c[b>>2]|0;d=c[(c[a>>2]|0)-12>>2]|0;e=a;if((c[e+(d+24)>>2]|0)==0){return}if((c[e+(d+16)>>2]|0)!=0){return}if((c[e+(d+4)>>2]&8192|0)==0){return}if(bG()|0){return}d=c[b>>2]|0;e=c[d+((c[(c[d>>2]|0)-12>>2]|0)+24)>>2]|0;d=(z=0,au(c[(c[e>>2]|0)+24>>2]|0,e|0)|0);do{if(!z){if((d|0)!=-1){return}e=c[b>>2]|0;a=c[(c[e>>2]|0)-12>>2]|0;f=e;z=0;as(368,f+a|0,c[f+(a+16)>>2]|1|0);if(z){z=0;break}return}else{z=0}}while(0);b=bT(-1,-1,0)|0;bD(b|0)|0;z=0;aS(2);if(!z){return}else{z=0;bT(-1,-1,0)|0;bX()}}function Fs(a){a=a|0;return 10992}function Ft(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)==1){D8(a,12240,35);return}else{D$(a,b|0,c);return}}function Fu(a){a=a|0;DX(a|0);return}function Fv(a){a=a|0;D3(a|0);Lw(a);return}function Fw(a){a=a|0;D3(a|0);return}function Fx(a){a=a|0;Ex(a);Lw(a);return}function Fy(a){a=a|0;DX(a|0);Lw(a);return}function Fz(a){a=a|0;DJ(a|0);Lw(a);return}function FA(a){a=a|0;DJ(a|0);return}function FB(a){a=a|0;DJ(a|0);return}function FC(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;L1:do{if((e|0)==(f|0)){g=c}else{b=c;h=e;while(1){if((b|0)==(d|0)){i=-1;j=10;break}k=a[b]|0;l=a[h]|0;if(k<<24>>24<l<<24>>24){i=-1;j=9;break}if(l<<24>>24<k<<24>>24){i=1;j=11;break}k=b+1|0;l=h+1|0;if((l|0)==(f|0)){g=k;break L1}else{b=k;h=l}}if((j|0)==10){return i|0}else if((j|0)==11){return i|0}else if((j|0)==9){return i|0}}}while(0);i=(g|0)!=(d|0)|0;return i|0}function FD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=e;g=f-d|0;if(g>>>0>4294967279>>>0){D5(b)}if(g>>>0<11>>>0){a[b]=g<<1;h=b+1|0}else{i=g+16&-16;j=Lu(i)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=g;h=j}if((e|0)==(f|0)){k=h;a[k]=0;return}j=f+(-d|0)|0;d=h;g=e;while(1){a[d]=a[g]|0;e=g+1|0;if((e|0)==(f|0)){break}else{d=d+1|0;g=e}}k=h+j|0;a[k]=0;return}function FE(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;if((c|0)==(d|0)){e=0;return e|0}else{f=c;g=0}while(1){c=(a[f]|0)+(g<<4)|0;b=c&-268435456;h=(b>>>24|b)^c;c=f+1|0;if((c|0)==(d|0)){e=h;break}else{f=c;g=h}}return e|0}function FF(a){a=a|0;DJ(a|0);Lw(a);return}function FG(a){a=a|0;DJ(a|0);return}function FH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;L1:do{if((e|0)==(f|0)){g=b}else{a=b;h=e;while(1){if((a|0)==(d|0)){i=-1;j=9;break}k=c[a>>2]|0;l=c[h>>2]|0;if((k|0)<(l|0)){i=-1;j=11;break}if((l|0)<(k|0)){i=1;j=10;break}k=a+4|0;l=h+4|0;if((l|0)==(f|0)){g=k;break L1}else{a=k;h=l}}if((j|0)==9){return i|0}else if((j|0)==11){return i|0}else if((j|0)==10){return i|0}}}while(0);i=(g|0)!=(d|0)|0;return i|0}function FI(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=e;g=f-d|0;h=g>>2;if(h>>>0>1073741807>>>0){D5(b)}if(h>>>0<2>>>0){a[b]=g>>>1;i=b+4|0}else{g=h+4&-4;j=Lu(g<<2)|0;c[b+8>>2]=j;c[b>>2]=g|1;c[b+4>>2]=h;i=j}if((e|0)==(f|0)){k=i;c[k>>2]=0;return}j=(f-4+(-d|0)|0)>>>2;d=i;h=e;while(1){c[d>>2]=c[h>>2];e=h+4|0;if((e|0)==(f|0)){break}else{d=d+4|0;h=e}}k=i+(j+1<<2)|0;c[k>>2]=0;return}function FJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)==(d|0)){e=0;return e|0}else{f=b;g=0}while(1){b=(c[f>>2]|0)+(g<<4)|0;a=b&-268435456;h=(a>>>24|a)^b;b=f+4|0;if((b|0)==(d|0)){e=h;break}else{f=b;g=h}}return e|0}function FK(a){a=a|0;DJ(a|0);Lw(a);return}function FL(a){a=a|0;DJ(a|0);return}function FM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+112|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+40|0;p=k+48|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+104|0;if((c[g+4>>2]&1|0)==0){c[n>>2]=-1;v=c[(c[d>>2]|0)+16>>2]|0;w=e|0;c[p>>2]=c[w>>2];c[q>>2]=c[f>>2];cR[v&127](o,d,p,q,g,h,n);q=c[o>>2]|0;c[w>>2]=q;w=c[n>>2]|0;if((w|0)==0){a[j]=0}else if((w|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=q;i=k;return}Ey(r,g);q=r|0;r=c[q>>2]|0;if((c[10440]|0)==-1){x=9}else{c[m>>2]=41760;c[m+4>>2]=460;c[m+8>>2]=0;z=0;aR(2,41760,m|0,520);if(!z){x=9}else{z=0}}do{if((x|0)==9){m=(c[10441]|0)-1|0;w=c[r+8>>2]|0;do{if((c[r+12>>2]|0)-w>>2>>>0>m>>>0){n=c[w+(m<<2)>>2]|0;if((n|0)==0){break}o=n;DL(c[q>>2]|0)|0;Ey(s,g);n=s|0;p=c[n>>2]|0;if((c[10344]|0)==-1){x=15}else{c[l>>2]=41376;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41376,l|0,520);if(!z){x=15}else{z=0}}do{if((x|0)==15){d=(c[10345]|0)-1|0;v=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-v>>2>>>0>d>>>0){y=c[v+(d<<2)>>2]|0;if((y|0)==0){break}A=y;DL(c[n>>2]|0)|0;B=t|0;C=y;z=0;as(c[(c[C>>2]|0)+24>>2]|0,B|0,A|0);do{if(!z){y=t+12|0;z=0;as(c[(c[C>>2]|0)+28>>2]|0,y|0,A|0);if(z){z=0;D=y;break}c[u>>2]=c[f>>2];y=(z=0,ao(4,e|0,u|0,B|0,t+24|0,o|0,h|0,1)|0);if(!z){a[j]=(y|0)==(B|0)|0;c[b>>2]=c[e>>2];Eb(t+12|0);Eb(t|0);i=k;return}else{z=0;y=bT(-1,-1)|0;E=M;Eb(t+12|0);Eb(t|0);F=y;G=E;H=F;I=0;J=H;K=G;bg(J|0)}}else{z=0;D=B}}while(0);A=bT(-1,-1)|0;C=A;A=M;if((B|0)==(D|0)){F=C;G=A;H=F;I=0;J=H;K=G;bg(J|0)}else{L=D}while(1){E=L-12|0;Eb(E);if((E|0)==(B|0)){F=C;G=A;break}else{L=E}}H=F;I=0;J=H;K=G;bg(J|0)}}while(0);d=cl(4)|0;K$(d);z=0;aR(156,d|0,29336,98);if(z){z=0;break}}}while(0);o=bT(-1,-1)|0;p=M;DL(c[n>>2]|0)|0;F=o;G=p;H=F;I=0;J=H;K=G;bg(J|0)}}while(0);m=cl(4)|0;K$(m);z=0;aR(156,m|0,29336,98);if(z){z=0;break}}}while(0);L=bT(-1,-1)|0;D=M;DL(c[q>>2]|0)|0;F=L;G=D;H=F;I=0;J=H;K=G;bg(J|0)}function FN(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;l=i;i=i+104|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=(g-f|0)/12|0;n=l|0;do{if(m>>>0>100>>>0){o=Lo(m)|0;if((o|0)!=0){p=o;q=o;break}z=0;aS(4);if(!z){p=0;q=0;break}else{z=0}o=bT(-1,-1)|0;r=M;s=o;bg(s|0)}else{p=n;q=0}}while(0);n=(f|0)==(g|0);if(n){t=m;u=0}else{o=m;m=0;v=p;w=f;while(1){x=d[w]|0;if((x&1|0)==0){y=x>>>1}else{y=c[w+4>>2]|0}if((y|0)==0){a[v]=2;A=m+1|0;B=o-1|0}else{a[v]=1;A=m;B=o}x=w+12|0;if((x|0)==(g|0)){t=B;u=A;break}else{o=B;m=A;v=v+1|0;w=x}}}w=b|0;b=e|0;e=h;v=0;A=u;u=t;L19:while(1){t=c[w>>2]|0;do{if((t|0)==0){C=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){C=t;break}m=(z=0,au(c[(c[t>>2]|0)+36>>2]|0,t|0)|0);if(z){z=0;D=6;break L19}if((m|0)==-1){c[w>>2]=0;C=0;break}else{C=c[w>>2]|0;break}}}while(0);t=(C|0)==0;m=c[b>>2]|0;if((m|0)==0){E=C;F=0}else{do{if((c[m+12>>2]|0)==(c[m+16>>2]|0)){B=(z=0,au(c[(c[m>>2]|0)+36>>2]|0,m|0)|0);if(z){z=0;D=6;break L19}if((B|0)!=-1){G=m;break}c[b>>2]=0;G=0}else{G=m}}while(0);E=c[w>>2]|0;F=G}H=(F|0)==0;if(!((t^H)&(u|0)!=0)){D=81;break}m=c[E+12>>2]|0;if((m|0)==(c[E+16>>2]|0)){B=(z=0,au(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(z){z=0;D=6;break}I=B&255}else{I=a[m]|0}if(k){J=I}else{m=(z=0,aM(c[(c[e>>2]|0)+12>>2]|0,h|0,I|0)|0);if(!z){J=m}else{z=0;D=6;break}}do{if(n){K=A;L=u}else{m=v+1|0;L48:do{if(k){B=u;o=A;y=p;x=0;N=f;while(1){do{if((a[y]|0)==1){O=N;if((a[O]&1)==0){P=N+1|0}else{P=c[N+8>>2]|0}if(J<<24>>24!=(a[P+v|0]|0)){a[y]=0;Q=x;R=o;S=B-1|0;break}T=d[O]|0;if((T&1|0)==0){U=T>>>1}else{U=c[N+4>>2]|0}if((U|0)!=(m|0)){Q=1;R=o;S=B;break}a[y]=2;Q=1;R=o+1|0;S=B-1|0}else{Q=x;R=o;S=B}}while(0);T=N+12|0;if((T|0)==(g|0)){V=S;W=R;X=Q;break L48}B=S;o=R;y=y+1|0;x=Q;N=T}}else{N=u;x=A;y=p;o=0;B=f;while(1){do{if((a[y]|0)==1){T=B;if((a[T]&1)==0){Y=B+1|0}else{Y=c[B+8>>2]|0}O=(z=0,aM(c[(c[e>>2]|0)+12>>2]|0,h|0,a[Y+v|0]|0)|0);if(z){z=0;D=5;break L19}if(J<<24>>24!=O<<24>>24){a[y]=0;Z=o;_=x;$=N-1|0;break}O=d[T]|0;if((O&1|0)==0){aa=O>>>1}else{aa=c[B+4>>2]|0}if((aa|0)!=(m|0)){Z=1;_=x;$=N;break}a[y]=2;Z=1;_=x+1|0;$=N-1|0}else{Z=o;_=x;$=N}}while(0);O=B+12|0;if((O|0)==(g|0)){V=$;W=_;X=Z;break L48}N=$;x=_;y=y+1|0;o=Z;B=O}}}while(0);if(!X){K=W;L=V;break}m=c[w>>2]|0;B=m+12|0;o=c[B>>2]|0;if((o|0)==(c[m+16>>2]|0)){y=c[(c[m>>2]|0)+40>>2]|0;z=0,au(y|0,m|0)|0;if(z){z=0;D=6;break L19}}else{c[B>>2]=o+1}if((W+V|0)>>>0<2>>>0|n){K=W;L=V;break}o=v+1|0;B=W;m=p;y=f;while(1){do{if((a[m]|0)==2){x=d[y]|0;if((x&1|0)==0){ab=x>>>1}else{ab=c[y+4>>2]|0}if((ab|0)==(o|0)){ac=B;break}a[m]=0;ac=B-1|0}else{ac=B}}while(0);x=y+12|0;if((x|0)==(g|0)){K=ac;L=V;break}else{B=ac;m=m+1|0;y=x}}}}while(0);v=v+1|0;A=K;u=L}if((D|0)==6){L=bT(-1,-1)|0;ad=M;ae=L}else if((D|0)==81){do{if((E|0)==0){af=0;D=87}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){af=E;D=87;break}L=(z=0,au(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(z){z=0;break}if((L|0)==-1){c[w>>2]=0;af=0;D=87;break}else{af=c[w>>2]|0;D=87;break}}}while(0);L114:do{if((D|0)==87){w=(af|0)==0;do{if(H){D=93}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(w){break}else{D=95;break}}E=(z=0,au(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(z){z=0;break L114}if((E|0)==-1){c[b>>2]=0;D=93;break}else{if(w^(F|0)==0){break}else{D=95;break}}}}while(0);if((D|0)==93){if(w){D=95}}if((D|0)==95){c[j>>2]=c[j>>2]|2}L130:do{if(n){D=100}else{E=f;L=p;while(1){if((a[L]|0)==2){ag=E;break L130}u=E+12|0;if((u|0)==(g|0)){D=100;break L130}E=u;L=L+1|0}}}while(0);if((D|0)==100){c[j>>2]=c[j>>2]|4;ag=g}if((q|0)==0){i=l;return ag|0}Lp(q);i=l;return ag|0}}while(0);ag=bT(-1,-1)|0;ad=M;ae=ag}else if((D|0)==5){D=bT(-1,-1)|0;ad=M;ae=D}if((q|0)==0){r=ad;s=ae;bg(s|0)}Lp(q);r=ad;s=ae;bg(s|0);return 0}function FO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];FP(a,0,j,k,f,g,h);i=b;return}function FP(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;Gv(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(z){z=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);K=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(K){L=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(z){z=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(K^R){L=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(K){O=F;P=0;Q=1;break}else{L=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}z=0;aR(88,o|0,S<<1|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,U|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){V=x}else{V=c[y>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((F5(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=L;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;z=0,au(X|0,H|0)|0;if(!z){F=W;G=H;continue}else{z=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bT(-1,-1)|0;_=M;$=G;Eb(o);Eb(n);bg($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(42,O|0,c[q>>2]|0,j|0,v|0)|0);if(z){z=0;break}c[k>>2]=F;Io(n,l,c[s>>2]|0,j);do{if(K){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}F=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;break L6}if((F|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(z=0,au(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(z){z=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;_=M;$=e;Eb(o);Eb(n);bg($|0)}function FQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];FR(a,0,j,k,f,g,h);i=b;return}function FR(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==8){v=16}else if((u|0)==0){v=0}else{v=10}u=l|0;Gv(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(z){z=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);K=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(K){L=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(z){z=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(K^R){L=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(K){O=F;P=0;Q=1;break}else{L=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}z=0;aR(88,o|0,S<<1|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,U|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){V=x}else{V=c[y>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((F5(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=L;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;z=0,au(X|0,H|0)|0;if(!z){F=W;G=H;continue}else{z=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bT(-1,-1)|0;_=M;$=G;Eb(o);Eb(n);bg($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(6,O|0,c[q>>2]|0,j|0,v|0)|0);G=M;if(z){z=0;break}c[k>>2]=F;c[k+4>>2]=G;Io(n,l,c[s>>2]|0,j);do{if(K){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}G=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;break L6}if((G|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(z=0,au(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(z){z=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;_=M;$=e;Eb(o);Eb(n);bg($|0)}function FS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];FT(a,0,j,k,f,g,h);i=b;return}function FT(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;f=i;i=i+72|0;m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=f|0;n=f+32|0;o=f+40|0;p=f+56|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=c[j+4>>2]&74;if((v|0)==0){w=0}else if((v|0)==8){w=16}else if((v|0)==64){w=8}else{w=10}v=m|0;Gv(o,j,v,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L6:do{if(!z){if((a[q]&1)==0){m=j+1|0;x=m;y=m;A=p+8|0}else{m=p+8|0;x=c[m>>2]|0;y=j+1|0;A=m}c[r>>2]=x;m=s|0;c[t>>2]=m;c[u>>2]=0;B=g|0;C=h|0;D=p|0;E=p+4|0;F=a[n]|0;G=x;H=c[B>>2]|0;L12:while(1){do{if((H|0)==0){I=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){I=H;break}J=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;K=34;break L12}if((J|0)!=-1){I=H;break}c[B>>2]=0;I=0}}while(0);L=(I|0)==0;J=c[C>>2]|0;do{if((J|0)==0){K=21}else{if((c[J+12>>2]|0)!=(c[J+16>>2]|0)){if(L){N=J;O=0;break}else{P=G;Q=J;R=0;break L12}}S=(z=0,au(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(z){z=0;K=34;break L12}if((S|0)==-1){c[C>>2]=0;K=21;break}else{S=(J|0)==0;if(L^S){N=J;O=S;break}else{P=G;Q=J;R=S;break L12}}}}while(0);if((K|0)==21){K=0;if(L){P=G;Q=0;R=1;break}else{N=0;O=1}}J=d[q]|0;S=(J&1|0)==0;if(((c[r>>2]|0)-G|0)==((S?J>>>1:c[E>>2]|0)|0)){if(S){T=J>>>1;U=J>>>1}else{J=c[E>>2]|0;T=J;U=J}z=0;aR(88,p|0,T<<1|0,0);if(z){z=0;K=34;break}if((a[q]&1)==0){V=10}else{V=(c[D>>2]&-2)-1|0}z=0;aR(88,p|0,V|0,0);if(z){z=0;K=34;break}if((a[q]&1)==0){W=y}else{W=c[A>>2]|0}c[r>>2]=W+U;X=W}else{X=G}J=I+12|0;S=c[J>>2]|0;Y=I+16|0;if((S|0)==(c[Y>>2]|0)){Z=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(z){z=0;K=34;break}_=Z&255}else{_=a[S]|0}if((F5(_,w,X,r,u,F,o,m,t,v)|0)!=0){P=X;Q=N;R=O;break}S=c[J>>2]|0;if((S|0)==(c[Y>>2]|0)){Y=c[(c[I>>2]|0)+40>>2]|0;z=0,au(Y|0,I|0)|0;if(!z){G=X;H=I;continue}else{z=0;K=34;break}}else{c[J>>2]=S+1;G=X;H=I;continue}}if((K|0)==34){H=bT(-1,-1)|0;$=M;aa=H;Eb(p);Eb(o);bg(aa|0)}H=d[o]|0;if((H&1|0)==0){ab=H>>>1}else{ab=c[o+4>>2]|0}do{if((ab|0)!=0){H=c[t>>2]|0;if((H-s|0)>=160){break}G=c[u>>2]|0;c[t>>2]=H+4;c[H>>2]=G}}while(0);G=(z=0,aU(8,P|0,c[r>>2]|0,k|0,w|0)|0);if(z){z=0;break}b[l>>1]=G;Io(o,m,c[t>>2]|0,k);do{if(L){ac=0}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){ac=I;break}G=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(z){z=0;break L6}if((G|0)!=-1){ac=I;break}c[B>>2]=0;ac=0}}while(0);B=(ac|0)==0;L75:do{if(R){K=62}else{do{if((c[Q+12>>2]|0)==(c[Q+16>>2]|0)){m=(z=0,au(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(z){z=0;break L6}if((m|0)!=-1){break}c[C>>2]=0;K=62;break L75}}while(0);if(!(B^(Q|0)==0)){break}ad=e|0;c[ad>>2]=ac;Eb(p);Eb(o);i=f;return}}while(0);do{if((K|0)==62){if(B){break}ad=e|0;c[ad>>2]=ac;Eb(p);Eb(o);i=f;return}}while(0);c[k>>2]=c[k>>2]|2;ad=e|0;c[ad>>2]=ac;Eb(p);Eb(o);i=f;return}else{z=0}}while(0);f=bT(-1,-1)|0;$=M;aa=f;Eb(p);Eb(o);bg(aa|0)}function FU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];FV(a,0,j,k,f,g,h);i=b;return}function FV(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==8){v=16}else if((u|0)==0){v=0}else{v=10}u=l|0;Gv(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(z){z=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);K=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(K){L=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(z){z=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(K^R){L=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(K){O=F;P=0;Q=1;break}else{L=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}z=0;aR(88,o|0,S<<1|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,U|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){V=x}else{V=c[y>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((F5(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=L;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;z=0,au(X|0,H|0)|0;if(!z){F=W;G=H;continue}else{z=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bT(-1,-1)|0;_=M;$=G;Eb(o);Eb(n);bg($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(4,O|0,c[q>>2]|0,j|0,v|0)|0);if(z){z=0;break}c[k>>2]=F;Io(n,l,c[s>>2]|0,j);do{if(K){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}F=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;break L6}if((F|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(z=0,au(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(z){z=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;_=M;$=e;Eb(o);Eb(n);bg($|0)}function FW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];FX(a,0,j,k,f,g,h);i=b;return}function FX(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==8){v=16}else if((u|0)==64){v=8}else{v=10}u=l|0;Gv(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(z){z=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);K=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(K){L=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(z){z=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(K^R){L=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(K){O=F;P=0;Q=1;break}else{L=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}z=0;aR(88,o|0,S<<1|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,U|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){V=x}else{V=c[y>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((F5(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=L;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;z=0,au(X|0,H|0)|0;if(!z){F=W;G=H;continue}else{z=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bT(-1,-1)|0;_=M;$=G;Eb(o);Eb(n);bg($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(30,O|0,c[q>>2]|0,j|0,v|0)|0);if(z){z=0;break}c[k>>2]=F;Io(n,l,c[s>>2]|0,j);do{if(K){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}F=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;break L6}if((F|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(z=0,au(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(z){z=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;_=M;$=e;Eb(o);Eb(n);bg($|0)}function FY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];FZ(a,0,j,k,f,g,h);i=b;return}function FZ(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==8){v=16}else if((u|0)==0){v=0}else{v=10}u=l|0;Gv(n,h,u,m);LI(p|0,0,12)|0;h=o;z=0;aR(88,o|0,10,0);L6:do{if(!z){if((a[p]&1)==0){l=h+1|0;w=l;x=l;y=o+8|0}else{l=o+8|0;w=c[l>>2]|0;x=h+1|0;y=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(z){z=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);K=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(K){L=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(z=0,au(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(z){z=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(K^R){L=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(K){O=F;P=0;Q=1;break}else{L=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}z=0;aR(88,o|0,S<<1|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}z=0;aR(88,o|0,U|0,0);if(z){z=0;J=34;break}if((a[p]&1)==0){V=x}else{V=c[y>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((F5(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=L;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;z=0,au(X|0,H|0)|0;if(!z){F=W;G=H;continue}else{z=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bT(-1,-1)|0;_=M;$=G;Eb(o);Eb(n);bg($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(z=0,aU(20,O|0,c[q>>2]|0,j|0,v|0)|0);G=M;if(z){z=0;break}c[k>>2]=F;c[k+4>>2]=G;Io(n,l,c[s>>2]|0,j);do{if(K){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}G=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;break L6}if((G|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(z=0,au(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(z){z=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;Eb(o);Eb(n);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;_=M;$=e;Eb(o);Eb(n);bg($|0)}function F_(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];F$(a,0,j,k,f,g,h);i=b;return}function F$(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0,ah=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;Gw(o,j,x,m,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L1:do{if(!z){if((a[q]&1)==0){y=j+1|0;A=y;B=y;C=p+8|0}else{y=p+8|0;A=c[y>>2]|0;B=j+1|0;C=y}c[r>>2]=A;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=h|0;F=p|0;G=p+4|0;H=a[m]|0;I=a[n]|0;J=A;K=c[D>>2]|0;L7:while(1){do{if((K|0)==0){L=0}else{if((c[K+12>>2]|0)!=(c[K+16>>2]|0)){L=K;break}N=(z=0,au(c[(c[K>>2]|0)+36>>2]|0,K|0)|0);if(z){z=0;O=30;break L7}if((N|0)!=-1){L=K;break}c[D>>2]=0;L=0}}while(0);P=(L|0)==0;N=c[E>>2]|0;do{if((N|0)==0){O=17}else{if((c[N+12>>2]|0)!=(c[N+16>>2]|0)){if(P){Q=N;R=0;break}else{S=J;T=N;U=0;break L7}}V=(z=0,au(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(z){z=0;O=30;break L7}if((V|0)==-1){c[E>>2]=0;O=17;break}else{V=(N|0)==0;if(P^V){Q=N;R=V;break}else{S=J;T=N;U=V;break L7}}}}while(0);if((O|0)==17){O=0;if(P){S=J;T=0;U=1;break}else{Q=0;R=1}}N=d[q]|0;V=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((V?N>>>1:c[G>>2]|0)|0)){if(V){W=N>>>1;X=N>>>1}else{N=c[G>>2]|0;W=N;X=N}z=0;aR(88,p|0,W<<1|0,0);if(z){z=0;O=30;break}if((a[q]&1)==0){Y=10}else{Y=(c[F>>2]&-2)-1|0}z=0;aR(88,p|0,Y|0,0);if(z){z=0;O=30;break}if((a[q]&1)==0){Z=B}else{Z=c[C>>2]|0}c[r>>2]=Z+X;_=Z}else{_=J}N=L+12|0;V=c[N>>2]|0;$=L+16|0;if((V|0)==(c[$>>2]|0)){aa=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(z){z=0;O=30;break}ab=aa&255}else{ab=a[V]|0}if((Gx(ab,v,w,_,r,H,I,o,y,t,u,x)|0)!=0){S=_;T=Q;U=R;break}V=c[N>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[L>>2]|0)+40>>2]|0;z=0,au($|0,L|0)|0;if(!z){J=_;K=L;continue}else{z=0;O=30;break}}else{c[N>>2]=V+1;J=_;K=L;continue}}if((O|0)==30){K=bT(-1,-1)|0;ac=M;ad=K;Eb(p);Eb(o);bg(ad|0)}K=d[o]|0;if((K&1|0)==0){ae=K>>>1}else{ae=c[o+4>>2]|0}do{if((ae|0)!=0){if((a[v]&1)==0){break}K=c[t>>2]|0;if((K-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=K+4;c[K>>2]=J}}while(0);af=(z=0,+(+aF(2,S|0,c[r>>2]|0,k|0)));if(z){z=0;break}g[l>>2]=af;Io(o,y,c[t>>2]|0,k);do{if(P){ag=0}else{if((c[L+12>>2]|0)!=(c[L+16>>2]|0)){ag=L;break}J=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(z){z=0;break L1}if((J|0)!=-1){ag=L;break}c[D>>2]=0;ag=0}}while(0);D=(ag|0)==0;L71:do{if(U){O=59}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){y=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(z){z=0;break L1}if((y|0)!=-1){break}c[E>>2]=0;O=59;break L71}}while(0);if(!(D^(T|0)==0)){break}ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}}while(0);do{if((O|0)==59){if(D){break}ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;ac=M;ad=e;Eb(p);Eb(o);bg(ad|0)}function F0(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];F1(a,0,j,k,f,g,h);i=b;return}function F1(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0,ah=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;Gw(o,j,x,m,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L1:do{if(!z){if((a[q]&1)==0){y=j+1|0;A=y;B=y;C=p+8|0}else{y=p+8|0;A=c[y>>2]|0;B=j+1|0;C=y}c[r>>2]=A;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=a[m]|0;I=a[n]|0;J=A;K=c[D>>2]|0;L7:while(1){do{if((K|0)==0){L=0}else{if((c[K+12>>2]|0)!=(c[K+16>>2]|0)){L=K;break}N=(z=0,au(c[(c[K>>2]|0)+36>>2]|0,K|0)|0);if(z){z=0;O=30;break L7}if((N|0)!=-1){L=K;break}c[D>>2]=0;L=0}}while(0);P=(L|0)==0;N=c[E>>2]|0;do{if((N|0)==0){O=17}else{if((c[N+12>>2]|0)!=(c[N+16>>2]|0)){if(P){Q=N;R=0;break}else{S=J;T=N;U=0;break L7}}V=(z=0,au(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(z){z=0;O=30;break L7}if((V|0)==-1){c[E>>2]=0;O=17;break}else{V=(N|0)==0;if(P^V){Q=N;R=V;break}else{S=J;T=N;U=V;break L7}}}}while(0);if((O|0)==17){O=0;if(P){S=J;T=0;U=1;break}else{Q=0;R=1}}N=d[q]|0;V=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((V?N>>>1:c[G>>2]|0)|0)){if(V){W=N>>>1;X=N>>>1}else{N=c[G>>2]|0;W=N;X=N}z=0;aR(88,p|0,W<<1|0,0);if(z){z=0;O=30;break}if((a[q]&1)==0){Y=10}else{Y=(c[F>>2]&-2)-1|0}z=0;aR(88,p|0,Y|0,0);if(z){z=0;O=30;break}if((a[q]&1)==0){Z=B}else{Z=c[C>>2]|0}c[r>>2]=Z+X;_=Z}else{_=J}N=L+12|0;V=c[N>>2]|0;$=L+16|0;if((V|0)==(c[$>>2]|0)){aa=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(z){z=0;O=30;break}ab=aa&255}else{ab=a[V]|0}if((Gx(ab,v,w,_,r,H,I,o,y,t,u,x)|0)!=0){S=_;T=Q;U=R;break}V=c[N>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[L>>2]|0)+40>>2]|0;z=0,au($|0,L|0)|0;if(!z){J=_;K=L;continue}else{z=0;O=30;break}}else{c[N>>2]=V+1;J=_;K=L;continue}}if((O|0)==30){K=bT(-1,-1)|0;ac=M;ad=K;Eb(p);Eb(o);bg(ad|0)}K=d[o]|0;if((K&1|0)==0){ae=K>>>1}else{ae=c[o+4>>2]|0}do{if((ae|0)!=0){if((a[v]&1)==0){break}K=c[t>>2]|0;if((K-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=K+4;c[K>>2]=J}}while(0);af=(z=0,+(+aN(4,S|0,c[r>>2]|0,k|0)));if(z){z=0;break}h[l>>3]=af;Io(o,y,c[t>>2]|0,k);do{if(P){ag=0}else{if((c[L+12>>2]|0)!=(c[L+16>>2]|0)){ag=L;break}J=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(z){z=0;break L1}if((J|0)!=-1){ag=L;break}c[D>>2]=0;ag=0}}while(0);D=(ag|0)==0;L71:do{if(U){O=59}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){y=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(z){z=0;break L1}if((y|0)!=-1){break}c[E>>2]=0;O=59;break L71}}while(0);if(!(D^(T|0)==0)){break}ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}}while(0);do{if((O|0)==59){if(D){break}ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;ac=M;ad=e;Eb(p);Eb(o);bg(ad|0)}function F2(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];F3(a,0,j,k,f,g,h);i=b;return}function F3(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0,ah=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;x=e|0;Gw(o,j,x,m,n);LI(q|0,0,12)|0;j=p;z=0;aR(88,p|0,10,0);L1:do{if(!z){if((a[q]&1)==0){y=j+1|0;A=y;B=y;C=p+8|0}else{y=p+8|0;A=c[y>>2]|0;B=j+1|0;C=y}c[r>>2]=A;y=s|0;c[t>>2]=y;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=a[m]|0;I=a[n]|0;J=A;K=c[D>>2]|0;L7:while(1){do{if((K|0)==0){L=0}else{if((c[K+12>>2]|0)!=(c[K+16>>2]|0)){L=K;break}N=(z=0,au(c[(c[K>>2]|0)+36>>2]|0,K|0)|0);if(z){z=0;O=30;break L7}if((N|0)!=-1){L=K;break}c[D>>2]=0;L=0}}while(0);P=(L|0)==0;N=c[E>>2]|0;do{if((N|0)==0){O=17}else{if((c[N+12>>2]|0)!=(c[N+16>>2]|0)){if(P){Q=N;R=0;break}else{S=J;T=N;U=0;break L7}}V=(z=0,au(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(z){z=0;O=30;break L7}if((V|0)==-1){c[E>>2]=0;O=17;break}else{V=(N|0)==0;if(P^V){Q=N;R=V;break}else{S=J;T=N;U=V;break L7}}}}while(0);if((O|0)==17){O=0;if(P){S=J;T=0;U=1;break}else{Q=0;R=1}}N=d[q]|0;V=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((V?N>>>1:c[G>>2]|0)|0)){if(V){W=N>>>1;X=N>>>1}else{N=c[G>>2]|0;W=N;X=N}z=0;aR(88,p|0,W<<1|0,0);if(z){z=0;O=30;break}if((a[q]&1)==0){Y=10}else{Y=(c[F>>2]&-2)-1|0}z=0;aR(88,p|0,Y|0,0);if(z){z=0;O=30;break}if((a[q]&1)==0){Z=B}else{Z=c[C>>2]|0}c[r>>2]=Z+X;_=Z}else{_=J}N=L+12|0;V=c[N>>2]|0;$=L+16|0;if((V|0)==(c[$>>2]|0)){aa=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(z){z=0;O=30;break}ab=aa&255}else{ab=a[V]|0}if((Gx(ab,v,w,_,r,H,I,o,y,t,u,x)|0)!=0){S=_;T=Q;U=R;break}V=c[N>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[L>>2]|0)+40>>2]|0;z=0,au($|0,L|0)|0;if(!z){J=_;K=L;continue}else{z=0;O=30;break}}else{c[N>>2]=V+1;J=_;K=L;continue}}if((O|0)==30){K=bT(-1,-1)|0;ac=M;ad=K;Eb(p);Eb(o);bg(ad|0)}K=d[o]|0;if((K&1|0)==0){ae=K>>>1}else{ae=c[o+4>>2]|0}do{if((ae|0)!=0){if((a[v]&1)==0){break}K=c[t>>2]|0;if((K-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=K+4;c[K>>2]=J}}while(0);af=(z=0,+(+aN(2,S|0,c[r>>2]|0,k|0)));if(z){z=0;break}h[l>>3]=af;Io(o,y,c[t>>2]|0,k);do{if(P){ag=0}else{if((c[L+12>>2]|0)!=(c[L+16>>2]|0)){ag=L;break}J=(z=0,au(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(z){z=0;break L1}if((J|0)!=-1){ag=L;break}c[D>>2]=0;ag=0}}while(0);D=(ag|0)==0;L71:do{if(U){O=59}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){y=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(z){z=0;break L1}if((y|0)!=-1){break}c[E>>2]=0;O=59;break L71}}while(0);if(!(D^(T|0)==0)){break}ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}}while(0);do{if((O|0)==59){if(D){break}ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;ah=b|0;c[ah>>2]=ag;Eb(p);Eb(o);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;ac=M;ad=e;Eb(p);Eb(o);bg(ad|0)}function F4(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0;e=i;i=i+64|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+48|0;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;LI(n|0,0,12)|0;u=p;z=0;as(352,o|0,h|0);if(z){z=0;h=bT(-1,-1)|0;v=M;w=h;Eb(n);x=w;y=0;A=x;B=v;bg(A|0)}h=o|0;o=c[h>>2]|0;if((c[10440]|0)==-1){C=4}else{c[l>>2]=41760;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41760,l|0,520);if(!z){C=4}else{z=0}}L7:do{if((C|0)==4){l=(c[10441]|0)-1|0;D=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-D>>2>>>0>l>>>0){E=c[D+(l<<2)>>2]|0;if((E|0)==0){break}F=E;G=m|0;H=c[(c[E>>2]|0)+32>>2]|0;z=0,aU(H|0,F|0,32608,32634,G|0)|0;if(z){z=0;break L7}DL(c[h>>2]|0)|0;LI(u|0,0,12)|0;F=p;z=0;aR(88,p|0,10,0);L13:do{if(!z){if((a[u]&1)==0){H=F+1|0;I=H;J=H;K=p+8|0}else{H=p+8|0;I=c[H>>2]|0;J=F+1|0;K=H}c[q>>2]=I;H=r|0;c[s>>2]=H;c[t>>2]=0;E=f|0;L=g|0;N=p|0;O=p+4|0;P=I;Q=c[E>>2]|0;L19:while(1){do{if((Q|0)==0){R=0}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){R=Q;break}S=(z=0,au(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(z){z=0;C=40;break L19}if((S|0)!=-1){R=Q;break}c[E>>2]=0;R=0}}while(0);S=(R|0)==0;T=c[L>>2]|0;do{if((T|0)==0){C=25}else{if((c[T+12>>2]|0)!=(c[T+16>>2]|0)){if(S){break}else{U=P;break L19}}V=(z=0,au(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(z){z=0;C=40;break L19}if((V|0)==-1){c[L>>2]=0;C=25;break}else{if(S^(T|0)==0){break}else{U=P;break L19}}}}while(0);if((C|0)==25){C=0;if(S){U=P;break}}T=d[u]|0;V=(T&1|0)==0;if(((c[q>>2]|0)-P|0)==((V?T>>>1:c[O>>2]|0)|0)){if(V){W=T>>>1;X=T>>>1}else{T=c[O>>2]|0;W=T;X=T}z=0;aR(88,p|0,W<<1|0,0);if(z){z=0;C=40;break}if((a[u]&1)==0){Y=10}else{Y=(c[N>>2]&-2)-1|0}z=0;aR(88,p|0,Y|0,0);if(z){z=0;C=40;break}if((a[u]&1)==0){Z=J}else{Z=c[K>>2]|0}c[q>>2]=Z+X;_=Z}else{_=P}T=R+12|0;V=c[T>>2]|0;$=R+16|0;if((V|0)==(c[$>>2]|0)){aa=(z=0,au(c[(c[R>>2]|0)+36>>2]|0,R|0)|0);if(z){z=0;C=40;break}ab=aa&255}else{ab=a[V]|0}if((F5(ab,16,_,q,t,0,n,H,s,G)|0)!=0){U=_;break}V=c[T>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[R>>2]|0)+40>>2]|0;z=0,au($|0,R|0)|0;if(!z){P=_;Q=R;continue}else{z=0;C=40;break}}else{c[T>>2]=V+1;P=_;Q=R;continue}}if((C|0)==40){Q=bT(-1,-1)|0;ac=M;ad=Q;break}a[U+3|0]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}Q=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=Q;break}else{z=0;Q=bT(-1,-1)|0;ac=M;ad=Q;break L13}}}while(0);Q=(z=0,aU(22,U|0,c[10082]|0,8440,(P=i,i=i+8|0,c[P>>2]=k,P)|0)|0);i=P;if(z){z=0;C=41;break}if((Q|0)!=1){c[j>>2]=4}Q=c[E>>2]|0;do{if((Q|0)==0){ae=0}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){ae=Q;break}P=(z=0,au(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(z){z=0;C=41;break L13}if((P|0)!=-1){ae=Q;break}c[E>>2]=0;ae=0}}while(0);E=(ae|0)==0;Q=c[L>>2]|0;do{if((Q|0)==0){C=70}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){if(!E){break}af=b|0;c[af>>2]=ae;Eb(p);Eb(n);i=e;return}P=(z=0,au(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(z){z=0;C=41;break L13}if((P|0)==-1){c[L>>2]=0;C=70;break}if(!(E^(Q|0)==0)){break}af=b|0;c[af>>2]=ae;Eb(p);Eb(n);i=e;return}}while(0);do{if((C|0)==70){if(E){break}af=b|0;c[af>>2]=ae;Eb(p);Eb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;af=b|0;c[af>>2]=ae;Eb(p);Eb(n);i=e;return}else{z=0;C=41}}while(0);if((C|0)==41){G=bT(-1,-1)|0;ac=M;ad=G}Eb(p);v=ac;w=ad;Eb(n);x=w;y=0;A=x;B=v;bg(A|0)}}while(0);l=cl(4)|0;K$(l);z=0;aR(156,l|0,29336,98);if(z){z=0;break}}}while(0);ad=bT(-1,-1)|0;ac=M;DL(c[h>>2]|0)|0;v=ac;w=ad;Eb(n);x=w;y=0;A=x;B=v;bg(A|0)}function F5(b,e,f,g,h,i,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=c[g>>2]|0;o=(n|0)==(f|0);do{if(o){p=(a[m+24|0]|0)==b<<24>>24;if(!p){if((a[m+25|0]|0)!=b<<24>>24){break}}c[g>>2]=f+1;a[f]=p?43:45;c[h>>2]=0;q=0;return q|0}}while(0);p=d[j]|0;if((p&1|0)==0){r=p>>>1}else{r=c[j+4>>2]|0}if((r|0)!=0&b<<24>>24==i<<24>>24){i=c[l>>2]|0;if((i-k|0)>=160){q=0;return q|0}k=c[h>>2]|0;c[l>>2]=i+4;c[i>>2]=k;c[h>>2]=0;q=0;return q|0}k=m+26|0;i=m;while(1){if((i|0)==(k|0)){s=k;break}if((a[i]|0)==b<<24>>24){s=i;break}else{i=i+1|0}}i=s-m|0;if((i|0)>23){q=-1;return q|0}do{if((e|0)==8|(e|0)==10){if((i|0)<(e|0)){break}else{q=-1}return q|0}else if((e|0)==16){if((i|0)<22){break}if(o){q=-1;return q|0}if((n-f|0)>=3){q=-1;return q|0}if((a[n-1|0]|0)!=48){q=-1;return q|0}c[h>>2]=0;m=a[32608+i|0]|0;s=c[g>>2]|0;c[g>>2]=s+1;a[s]=m;q=0;return q|0}}while(0);f=a[32608+i|0]|0;c[g>>2]=n+1;a[n]=f;c[h>>2]=(c[h>>2]|0)+1;q=0;return q|0}function F6(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f|0;h=g;c[h>>2]=e;c[h+4>>2]=0;h=b6(b|0)|0;b=bj(a|0,d|0,g|0)|0;if((h|0)==0){i=f;return b|0}z=0,au(36,h|0)|0;if(!z){i=f;return b|0}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function F7(a){a=a|0;DJ(a|0);Lw(a);return}function F8(a){a=a|0;DJ(a|0);return}function F9(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+112|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+40|0;p=k+48|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+104|0;if((c[g+4>>2]&1|0)==0){c[n>>2]=-1;v=c[(c[d>>2]|0)+16>>2]|0;w=e|0;c[p>>2]=c[w>>2];c[q>>2]=c[f>>2];cR[v&127](o,d,p,q,g,h,n);q=c[o>>2]|0;c[w>>2]=q;w=c[n>>2]|0;if((w|0)==1){a[j]=1}else if((w|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=q;i=k;return}Ey(r,g);q=r|0;r=c[q>>2]|0;if((c[10438]|0)==-1){x=9}else{c[m>>2]=41752;c[m+4>>2]=460;c[m+8>>2]=0;z=0;aR(2,41752,m|0,520);if(!z){x=9}else{z=0}}do{if((x|0)==9){m=(c[10439]|0)-1|0;w=c[r+8>>2]|0;do{if((c[r+12>>2]|0)-w>>2>>>0>m>>>0){n=c[w+(m<<2)>>2]|0;if((n|0)==0){break}o=n;DL(c[q>>2]|0)|0;Ey(s,g);n=s|0;p=c[n>>2]|0;if((c[10342]|0)==-1){x=15}else{c[l>>2]=41368;c[l+4>>2]=460;c[l+8>>2]=0;z=0;aR(2,41368,l|0,520);if(!z){x=15}else{z=0}}do{if((x|0)==15){d=(c[10343]|0)-1|0;v=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-v>>2>>>0>d>>>0){y=c[v+(d<<2)>>2]|0;if((y|0)==0){break}A=y;DL(c[n>>2]|0)|0;B=t|0;C=y;z=0;as(c[(c[C>>2]|0)+24>>2]|0,B|0,A|0);do{if(!z){y=t+12|0;z=0;as(c[(c[C>>2]|0)+28>>2]|0,y|0,A|0);if(z){z=0;D=y;break}c[u>>2]=c[f>>2];y=(z=0,ao(2,e|0,u|0,B|0,t+24|0,o|0,h|0,1)|0);if(!z){a[j]=(y|0)==(B|0)|0;c[b>>2]=c[e>>2];Eo(t+12|0);Eo(t|0);i=k;return}else{z=0;y=bT(-1,-1)|0;E=M;Eo(t+12|0);Eo(t|0);F=y;G=E;H=F;I=0;J=H;K=G;bg(J|0)}}else{z=0;D=B}}while(0);A=bT(-1,-1)|0;C=A;A=M;if((B|0)==(D|0)){F=C;G=A;H=F;I=0;J=H;K=G;bg(J|0)}else{L=D}while(1){E=L-12|0;Eo(E);if((E|0)==(B|0)){F=C;G=A;break}else{L=E}}H=F;I=0;J=H;K=G;bg(J|0)}}while(0);d=cl(4)|0;K$(d);z=0;aR(156,d|0,29336,98);if(z){z=0;break}}}while(0);o=bT(-1,-1)|0;p=M;DL(c[n>>2]|0)|0;F=o;G=p;H=F;I=0;J=H;K=G;bg(J|0)}}while(0);m=cl(4)|0;K$(m);z=0;aR(156,m|0,29336,98);if(z){z=0;break}}}while(0);L=bT(-1,-1)|0;D=M;DL(c[q>>2]|0)|0;F=L;G=D;H=F;I=0;J=H;K=G;bg(J|0)}function Ga(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;l=i;i=i+104|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=(g-f|0)/12|0;n=l|0;do{if(m>>>0>100>>>0){o=Lo(m)|0;if((o|0)!=0){p=o;q=o;break}z=0;aS(4);if(!z){p=0;q=0;break}else{z=0}o=bT(-1,-1)|0;r=M;s=o;bg(s|0)}else{p=n;q=0}}while(0);n=(f|0)==(g|0);if(n){t=m;u=0}else{o=m;m=0;v=p;w=f;while(1){x=d[w]|0;if((x&1|0)==0){y=x>>>1}else{y=c[w+4>>2]|0}if((y|0)==0){a[v]=2;A=m+1|0;B=o-1|0}else{a[v]=1;A=m;B=o}x=w+12|0;if((x|0)==(g|0)){t=B;u=A;break}else{o=B;m=A;v=v+1|0;w=x}}}w=b|0;b=e|0;e=h;v=0;A=u;u=t;L19:while(1){t=c[w>>2]|0;do{if((t|0)==0){C=0}else{m=c[t+12>>2]|0;if((m|0)==(c[t+16>>2]|0)){B=(z=0,au(c[(c[t>>2]|0)+36>>2]|0,t|0)|0);if(!z){D=B}else{z=0;E=6;break L19}}else{D=c[m>>2]|0}if((D|0)==-1){c[w>>2]=0;C=0;break}else{C=c[w>>2]|0;break}}}while(0);t=(C|0)==0;m=c[b>>2]|0;if((m|0)==0){F=C;G=0}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){o=(z=0,au(c[(c[m>>2]|0)+36>>2]|0,m|0)|0);if(!z){H=o}else{z=0;E=6;break}}else{H=c[B>>2]|0}if((H|0)==-1){c[b>>2]=0;I=0}else{I=m}F=c[w>>2]|0;G=I}J=(G|0)==0;if(!((t^J)&(u|0)!=0)){E=82;break}t=c[F+12>>2]|0;if((t|0)==(c[F+16>>2]|0)){m=(z=0,au(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(!z){K=m}else{z=0;E=6;break}}else{K=c[t>>2]|0}if(k){L=K}else{t=(z=0,aM(c[(c[e>>2]|0)+28>>2]|0,h|0,K|0)|0);if(!z){L=t}else{z=0;E=6;break}}do{if(n){N=A;O=u}else{t=v+1|0;L51:do{if(k){m=u;B=A;o=p;y=0;x=f;while(1){do{if((a[o]|0)==1){P=x;if((a[P]&1)==0){Q=x+4|0}else{Q=c[x+8>>2]|0}if((L|0)!=(c[Q+(v<<2)>>2]|0)){a[o]=0;R=y;S=B;T=m-1|0;break}U=d[P]|0;if((U&1|0)==0){V=U>>>1}else{V=c[x+4>>2]|0}if((V|0)!=(t|0)){R=1;S=B;T=m;break}a[o]=2;R=1;S=B+1|0;T=m-1|0}else{R=y;S=B;T=m}}while(0);U=x+12|0;if((U|0)==(g|0)){W=T;X=S;Y=R;break L51}m=T;B=S;o=o+1|0;y=R;x=U}}else{x=u;y=A;o=p;B=0;m=f;while(1){do{if((a[o]|0)==1){U=m;if((a[U]&1)==0){Z=m+4|0}else{Z=c[m+8>>2]|0}P=(z=0,aM(c[(c[e>>2]|0)+28>>2]|0,h|0,c[Z+(v<<2)>>2]|0)|0);if(z){z=0;E=5;break L19}if((L|0)!=(P|0)){a[o]=0;_=B;$=y;aa=x-1|0;break}P=d[U]|0;if((P&1|0)==0){ab=P>>>1}else{ab=c[m+4>>2]|0}if((ab|0)!=(t|0)){_=1;$=y;aa=x;break}a[o]=2;_=1;$=y+1|0;aa=x-1|0}else{_=B;$=y;aa=x}}while(0);P=m+12|0;if((P|0)==(g|0)){W=aa;X=$;Y=_;break L51}x=aa;y=$;o=o+1|0;B=_;m=P}}}while(0);if(!Y){N=X;O=W;break}t=c[w>>2]|0;m=t+12|0;B=c[m>>2]|0;if((B|0)==(c[t+16>>2]|0)){o=c[(c[t>>2]|0)+40>>2]|0;z=0,au(o|0,t|0)|0;if(z){z=0;E=6;break L19}}else{c[m>>2]=B+4}if((X+W|0)>>>0<2>>>0|n){N=X;O=W;break}B=v+1|0;m=X;t=p;o=f;while(1){do{if((a[t]|0)==2){y=d[o]|0;if((y&1|0)==0){ac=y>>>1}else{ac=c[o+4>>2]|0}if((ac|0)==(B|0)){ad=m;break}a[t]=0;ad=m-1|0}else{ad=m}}while(0);y=o+12|0;if((y|0)==(g|0)){N=ad;O=W;break}else{m=ad;t=t+1|0;o=y}}}}while(0);v=v+1|0;A=N;u=O}if((E|0)==6){O=bT(-1,-1)|0;ae=M;af=O}else if((E|0)==82){do{if((F|0)==0){ag=1;E=89}else{O=c[F+12>>2]|0;if((O|0)==(c[F+16>>2]|0)){u=(z=0,au(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(!z){ah=u}else{z=0;break}}else{ah=c[O>>2]|0}if((ah|0)==-1){c[w>>2]=0;ag=1;E=89;break}else{ag=(c[w>>2]|0)==0;E=89;break}}}while(0);L119:do{if((E|0)==89){do{if(J){E=95}else{w=c[G+12>>2]|0;if((w|0)==(c[G+16>>2]|0)){ah=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!z){ai=ah}else{z=0;break L119}}else{ai=c[w>>2]|0}if((ai|0)==-1){c[b>>2]=0;E=95;break}else{if(ag^(G|0)==0){break}else{E=97;break}}}}while(0);if((E|0)==95){if(ag){E=97}}if((E|0)==97){c[j>>2]=c[j>>2]|2}L135:do{if(n){E=102}else{w=f;ah=p;while(1){if((a[ah]|0)==2){aj=w;break L135}F=w+12|0;if((F|0)==(g|0)){E=102;break L135}w=F;ah=ah+1|0}}}while(0);if((E|0)==102){c[j>>2]=c[j>>2]|4;aj=g}if((q|0)==0){i=l;return aj|0}Lp(q);i=l;return aj|0}}while(0);aj=bT(-1,-1)|0;ae=M;af=aj}else if((E|0)==5){E=bT(-1,-1)|0;ae=M;af=E}if((q|0)==0){r=ae;s=af;bg(s|0)}Lp(q);r=ae;s=af;bg(s|0);return 0}function Gb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Gc(a,0,j,k,f,g,h);i=b;return}
function jp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=c[d+52>>2]|0;if((k|0)==0){l=0}else{l=cV[c[(c[k>>2]|0)+20>>2]&1023](k,b|0)|0}k=c[b+4>>2]|0;m=Lu(60)|0;c[h>>2]=m;n=k+4|0;o=c[n>>2]|0;if((o|0)==(c[k+8>>2]|0)){e4(k|0,h);p=c[h>>2]|0}else{if((o|0)==0){q=0}else{c[o>>2]=m;q=c[n>>2]|0}c[n>>2]=q+4;p=m}m=p;q=d+4|0;L11:do{if((a[q]&1)==0){o=j;c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];r=18}else{o=c[d+12>>2]|0;h=c[d+8>>2]|0;do{if(h>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;s=j+1|0}else{t=h+16&-16;u=(z=0,au(248,t|0)|0);if(z){z=0;break}c[j+8>>2]=u;c[j>>2]=t|1;c[j+4>>2]=h;s=u}LF(s|0,o|0,h)|0;a[s+h|0]=0;r=18;break L11}}while(0);h=bT(-1,-1)|0;v=M;w=h}}while(0);do{if((r|0)==18){s=d+16|0;q=f;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];s=d+44|0;q=d+40|0;z=0;aI(88,p|0,j|0,f|0,l|0,(c[s>>2]|0)-(c[q>>2]|0)>>2|0,(a[d+56|0]&1)!=0|0,(a[d+57|0]&1)!=0|0);if(z){z=0;h=bT(-1,-1)|0;o=h;h=M;if((a[j]&1)==0){v=h;w=o;break}Lw(c[j+8>>2]|0);v=h;w=o;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}o=c[q>>2]|0;h=(c[s>>2]|0)-o>>2;if((h|0)==0){x=p;i=e;return x|0}s=p+36|0;u=s;t=b|0;y=s+8|0;A=y;B=s+12|0;C=s+4|0;D=s;s=0;E=o;while(1){o=c[E+(s<<2)>>2]|0;F=cV[c[(c[o>>2]|0)+20>>2]&1023](o,t)|0;c[g>>2]=F;o=c[A>>2]|0;if((o|0)==(c[B>>2]|0)){j_(C,g);G=c[g>>2]|0}else{if((o|0)==0){H=0}else{c[o>>2]=F;H=c[A>>2]|0}c[y>>2]=H+4;G=F}cB[c[c[D>>2]>>2]&1023](u,G);F=s+1|0;if(F>>>0>=h>>>0){break}s=F;E=c[q>>2]|0}x=p;i=e;return x|0}}while(0);x=c[k>>2]|0;k=c[n>>2]|0;e=x;while(1){if((e|0)==(k|0)){I=k;break}if((c[e>>2]|0)==(p|0)){I=e;break}else{e=e+4|0}}e=I-x>>2;I=x+(e+1<<2)|0;p=k-I|0;LG(x+(e<<2)|0,I|0,p|0)|0;I=x+((p>>2)+e<<2)|0;e=c[n>>2]|0;if((I|0)==(e|0)){Lw(m);J=w;K=0;L=J;N=v;bg(L|0)}c[n>>2]=e+(~((e-4+(-I|0)|0)>>>2)<<2);Lw(m);J=w;K=0;L=J;N=v;bg(L|0);return 0}function jq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+72|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=c[d+36>>2]|0;if((l|0)==0){m=0}else{m=cV[c[(c[l>>2]|0)+20>>2]&1023](l|0,b|0)|0}l=c[d+40>>2]|0;if((l|0)==0){n=0}else{n=cV[c[(c[l>>2]|0)+20>>2]&1023](l|0,b|0)|0}l=c[b+4>>2]|0;b=Lu(48)|0;c[j>>2]=b;o=l+4|0;p=c[o>>2]|0;if((p|0)==(c[l+8>>2]|0)){e4(l|0,j);q=c[j>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=b;r=c[o>>2]|0}c[o>>2]=r+4;q=b}b=q;r=d+4|0;L14:do{if((a[r]&1)==0){p=k;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];s=a[p]|0;t=p;u=20}else{p=c[d+12>>2]|0;j=c[d+8>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){v=j<<1&255;w=k;a[w]=v;x=k+1|0;y=v;A=w}else{w=j+16&-16;v=(z=0,au(248,w|0)|0);if(z){z=0;break}c[k+8>>2]=v;B=w|1;c[k>>2]=B;c[k+4>>2]=j;x=v;y=B&255;A=k}LF(x|0,p|0,j)|0;a[x+j|0]=0;s=y;t=A;u=20;break L14}}while(0);j=bT(-1,-1)|0;C=M;D=j}}while(0);do{if((u|0)==20){A=d+16|0;y=h;c[y>>2]=c[A>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];A=a[d+44|0]&1;y=h;x=f;r=g;j=q;L29:do{if((s&1)==0){c[x>>2]=c[t>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];u=30}else{p=c[k+8>>2]|0;B=c[k+4>>2]|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(B>>>0<11>>>0){a[x]=B<<1;E=f+1|0}else{v=B+16&-16;w=(z=0,au(248,v|0)|0);if(z){z=0;break}c[f+8>>2]=w;c[f>>2]=v|1;c[f+4>>2]=B;E=w}LF(E|0,p|0,B)|0;a[E+B|0]=0;u=30;break L29}}while(0);B=bT(-1,-1)|0;F=M;G=B}}while(0);do{if((u|0)==30){c[r>>2]=c[y>>2];c[r+4>>2]=c[y+4>>2];c[r+8>>2]=c[y+8>>2];z=0;aD(6,j|0,f|0,g|0,0,0,0);if(z){z=0;B=bT(-1,-1)|0;p=M;if((a[x]&1)==0){F=p;G=B;break}Lw(c[f+8>>2]|0);F=p;G=B;break}if((a[x]&1)!=0){Lw(c[f+8>>2]|0)}c[q>>2]=20104;c[q+36>>2]=m;c[q+40>>2]=n;a[q+44|0]=A;if((a[t]&1)==0){i=e;return j|0}Lw(c[k+8>>2]|0);i=e;return j|0}}while(0);j=G;A=F;if((a[t]&1)==0){C=A;D=j;break}Lw(c[k+8>>2]|0);C=A;D=j}}while(0);k=c[l>>2]|0;l=c[o>>2]|0;t=k;while(1){if((t|0)==(l|0)){H=l;break}if((c[t>>2]|0)==(q|0)){H=t;break}else{t=t+4|0}}t=H-k>>2;H=k+(t+1<<2)|0;q=l-H|0;LG(k+(t<<2)|0,H|0,q|0)|0;H=k+((q>>2)+t<<2)|0;t=c[o>>2]|0;if((H|0)==(t|0)){Lw(b);I=D;J=0;K=I;L=C;bg(K|0)}c[o>>2]=t+(~((t-4+(-H|0)|0)>>>2)<<2);Lw(b);I=D;J=0;K=I;L=C;bg(K|0);return 0}function jr(a,b){a=a|0;b=b|0;return b|0}function js(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+120|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+104|0;p=c[d+36>>2]|0;a[p+28|0]=0;q=cV[c[(c[p>>2]|0)+20>>2]&1023](p|0,b|0)|0;a[q+28|0]=0;p=d+52|0;L1:do{if((a[p]&1)==0){r=q}else{if((c[q+32>>2]|0)==5){r=q;break}s=c[b+4>>2]|0;t=Lu(60)|0;c[k>>2]=t;u=s+4|0;v=c[u>>2]|0;if((v|0)==(c[s+8>>2]|0)){e4(s|0,k);w=c[k>>2]|0}else{if((v|0)==0){x=0}else{c[v>>2]=t;x=c[u>>2]|0}c[u>>2]=x+4;w=t}t=w;v=q+4|0;L11:do{if((a[v]&1)==0){y=l;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];A=18}else{y=c[q+12>>2]|0;B=c[q+8>>2]|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(B>>>0<11>>>0){a[l]=B<<1;C=l+1|0}else{D=B+16&-16;E=(z=0,au(248,D|0)|0);if(z){z=0;break}c[l+8>>2]=E;c[l>>2]=D|1;c[l+4>>2]=B;C=E}LF(C|0,y|0,B)|0;a[C+B|0]=0;A=18;break L11}}while(0);B=bT(-1,-1)|0;F=M;G=B}}while(0);do{if((A|0)==18){v=q+16|0;B=j;c[B>>2]=c[v>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];z=0;aD(36,w|0,l|0,j|0,0,1,1);if(z){z=0;v=bT(-1,-1)|0;B=v;v=M;if((a[l]&1)==0){F=v;G=B;break}Lw(c[l+8>>2]|0);F=v;G=B;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}B=w+36|0;v=B;c[h>>2]=q;y=B+8|0;E=y;D=c[E>>2]|0;if((D|0)==(c[B+12>>2]|0)){fq(B+4|0,h);H=c[h>>2]|0}else{if((D|0)==0){I=0}else{c[D>>2]=q;I=c[E>>2]|0}c[y>>2]=I+4;H=q}cB[c[c[B>>2]>>2]&1023](v,H);r=w;break L1}}while(0);v=c[s>>2]|0;B=c[u>>2]|0;y=v;while(1){if((y|0)==(B|0)){J=B;break}if((c[y>>2]|0)==(w|0)){J=y;break}else{y=y+4|0}}y=J-v>>2;s=v+(y+1<<2)|0;E=B-s|0;LG(v+(y<<2)|0,s|0,E|0)|0;s=v+((E>>2)+y<<2)|0;y=c[u>>2]|0;if((s|0)!=(y|0)){c[u>>2]=y+(~((y-4+(-s|0)|0)>>>2)<<2)}Lw(t);K=F;L=G;N=L;O=0;P=N;Q=K;bg(P|0)}}while(0);G=c[b+4>>2]|0;b=Lu(56)|0;c[g>>2]=b;F=G+4|0;J=c[F>>2]|0;if((J|0)==(c[G+8>>2]|0)){e4(G|0,g);R=c[g>>2]|0}else{if((J|0)==0){S=0}else{c[J>>2]=b;S=c[F>>2]|0}c[F>>2]=S+4;R=b}b=R;S=R;J=d+4|0;L57:do{if((a[J]&1)==0){g=m;c[g>>2]=c[J>>2];c[g+4>>2]=c[J+4>>2];c[g+8>>2]=c[J+8>>2];A=51}else{g=c[d+12>>2]|0;w=c[d+8>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[m]=w<<1;T=m+1|0}else{H=w+16&-16;q=(z=0,au(248,H|0)|0);if(z){z=0;break}c[m+8>>2]=q;c[m>>2]=H|1;c[m+4>>2]=w;T=q}LF(T|0,g|0,w)|0;a[T+w|0]=0;A=51;break L57}}while(0);w=bT(-1,-1)|0;U=M;V=w}}while(0);do{if((A|0)==51){T=n;J=d+16|0;c[T>>2]=c[J>>2];c[T+4>>2]=c[J+4>>2];c[T+8>>2]=c[J+8>>2];J=d+40|0;L72:do{if((a[J]&1)==0){w=o;c[w>>2]=c[J>>2];c[w+4>>2]=c[J+4>>2];c[w+8>>2]=c[J+8>>2];A=61}else{w=c[d+48>>2]|0;g=c[d+44>>2]|0;do{if(g>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(g>>>0<11>>>0){a[o]=g<<1;W=o+1|0}else{t=g+16&-16;u=(z=0,au(248,t|0)|0);if(z){z=0;break}c[o+8>>2]=u;c[o>>2]=t|1;c[o+4>>2]=g;W=u}LF(W|0,w|0,g)|0;a[W+g|0]=0;A=61;break L72}}while(0);g=bT(-1,-1)|0;X=M;Y=g}}while(0);do{if((A|0)==61){J=(a[p]&1)!=0;g=f;c[g>>2]=c[T>>2];c[g+4>>2]=c[T+4>>2];c[g+8>>2]=c[T+8>>2];z=0;aD(30,S|0,m|0,f|0,r|0,o|0,J|0);if(z){z=0;J=bT(-1,-1)|0;g=J;J=M;if((a[o]&1)==0){X=J;Y=g;break}Lw(c[o+8>>2]|0);X=J;Y=g;break}g=R;if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[m]&1)==0){i=e;return g|0}Lw(c[m+8>>2]|0);i=e;return g|0}}while(0);if((a[m]&1)==0){U=X;V=Y;break}Lw(c[m+8>>2]|0);U=X;V=Y}}while(0);Y=c[G>>2]|0;G=c[F>>2]|0;X=Y;while(1){if((X|0)==(G|0)){Z=G;break}if((c[X>>2]|0)==(R|0)){Z=X;break}else{X=X+4|0}}X=Z-Y>>2;Z=Y+(X+1<<2)|0;R=G-Z|0;LG(Y+(X<<2)|0,Z|0,R|0)|0;Z=Y+((R>>2)+X<<2)|0;X=c[F>>2]|0;if((Z|0)!=(X|0)){c[F>>2]=X+(~((X-4+(-Z|0)|0)>>>2)<<2)}Lw(b);K=U;L=V;N=L;O=0;P=N;Q=K;bg(P|0);return 0}function jt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+48|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=c[b+4>>2]|0;l=Lu(56)|0;c[h>>2]=l;m=k+4|0;n=c[m>>2]|0;if((n|0)==(c[k+8>>2]|0)){e4(k|0,h);o=c[h>>2]|0}else{if((n|0)==0){p=0}else{c[n>>2]=l;p=c[m>>2]|0}c[m>>2]=p+4;o=l}l=o;p=d+4|0;L8:do{if((a[p]&1)==0){n=j;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];q=16}else{n=c[d+12>>2]|0;h=c[d+8>>2]|0;do{if(h>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;r=j+1|0}else{s=h+16&-16;t=(z=0,au(248,s|0)|0);if(z){z=0;break}c[j+8>>2]=t;c[j>>2]=s|1;c[j+4>>2]=h;r=t}LF(r|0,n|0,h)|0;a[r+h|0]=0;q=16;break L8}}while(0);h=bT(-1,-1)|0;u=h;v=M}}while(0);do{if((q|0)==16){r=d+16|0;p=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];z=0;aR(50,o|0,j|0,g|0);if(z){z=0;r=bT(-1,-1)|0;p=r;r=M;if((a[j]&1)==0){u=p;v=r;break}Lw(c[j+8>>2]|0);u=p;v=r;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}r=d+40|0;p=c[r>>2]|0;h=(c[d+44>>2]|0)-p>>2;if((h|0)==0){w=o;i=e;return w|0}n=o+36|0;t=n;s=b|0;x=n+8|0;y=x;A=n+12|0;B=n+4|0;C=n;n=0;D=p;while(1){p=c[D+(n<<2)>>2]|0;E=cV[c[(c[p>>2]|0)+20>>2]&1023](p,s)|0;c[f>>2]=E;p=c[y>>2]|0;if((p|0)==(c[A>>2]|0)){jZ(B,f);F=c[f>>2]|0}else{if((p|0)==0){G=0}else{c[p>>2]=E;G=c[y>>2]|0}c[x>>2]=G+4;F=E}cB[c[c[C>>2]>>2]&1023](t,F);E=n+1|0;if(E>>>0>=h>>>0){break}n=E;D=c[r>>2]|0}w=o;i=e;return w|0}}while(0);w=c[k>>2]|0;k=c[m>>2]|0;e=w;while(1){if((e|0)==(k|0)){H=k;break}if((c[e>>2]|0)==(o|0)){H=e;break}else{e=e+4|0}}e=H-w>>2;H=w+(e+1<<2)|0;o=k-H|0;LG(w+(e<<2)|0,H|0,o|0)|0;H=w+((o>>2)+e<<2)|0;e=c[m>>2]|0;if((H|0)==(e|0)){Lw(l);I=u;J=0;K=I;L=v;bg(K|0)}c[m>>2]=e+(~((e-4+(-H|0)|0)>>>2)<<2);Lw(l);I=u;J=0;K=I;L=v;bg(K|0);return 0}function ju(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;f=i;i=i+96|0;g=f|0;j=f+8|0;k=f+16|0;l=f+32|0;m=f+48|0;n=f+64|0;o=f+80|0;p=e;q=d[p]|0;if((q&1|0)==0){r=q>>>1}else{r=c[e+4>>2]|0}L5:do{if((r|0)==0){q=c[b+52>>2]|0;s=b+48|0;t=c[s>>2]|0;u=(q-t|0)/12|0;if((q|0)==(t|0)){break}q=k;v=k+8|0;w=k+1|0;x=k|0;y=k+4|0;A=0;B=t;while(1){t=B+(A*12|0)|0;if((a[t]&1)==0){c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2]}else{t=c[B+(A*12|0)+8>>2]|0;C=c[B+(A*12|0)+4>>2]|0;if(C>>>0>4294967279>>>0){D=10;break}if(C>>>0<11>>>0){a[q]=C<<1;E=w}else{F=C+16&-16;G=Lu(F)|0;c[v>>2]=G;c[x>>2]=F|1;c[y>>2]=C;E=G}LF(E|0,t|0,C)|0;a[E+C|0]=0}C=(z=0,au(46,k|0)|0);if(z){z=0;D=17;break}if((C|0)!=6){D=21;break}if((a[q]&1)!=0){Lw(c[v>>2]|0)}C=A+1|0;if(C>>>0>=u>>>0){break L5}A=C;B=c[s>>2]|0}do{if((D|0)==10){D5(0)}else if((D|0)==17){s=bT(-1,-1)|0;H=M;I=s}else if((D|0)==21){z=0,aM(344,e|0,k|0)|0;if(z){z=0;s=bT(-1,-1)|0;H=M;I=s;break}if((a[q]&1)==0){break L5}Lw(c[v>>2]|0);break L5}}while(0);s=I;B=H;if((a[q]&1)==0){J=B;K=s;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[v>>2]|0);J=B;K=s;L=K;N=0;O=L;P=J;bg(O|0)}}while(0);H=d[p]|0;if((H&1|0)==0){Q=H>>>1}else{Q=c[e+4>>2]|0}L43:do{if((Q|0)==0){H=c[b+64>>2]|0;p=b+60|0;I=c[p>>2]|0;k=(H-I|0)/12|0;if((H|0)==(I|0)){break}H=l;E=l+8|0;r=l+1|0;s=l|0;B=l+4|0;A=0;u=I;while(1){I=u+(A*12|0)|0;if((a[I]&1)==0){c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2]}else{I=c[u+(A*12|0)+8>>2]|0;y=c[u+(A*12|0)+4>>2]|0;if(y>>>0>4294967279>>>0){D=37;break}if(y>>>0<11>>>0){a[H]=y<<1;R=r}else{x=y+16&-16;w=Lu(x)|0;c[E>>2]=w;c[s>>2]=x|1;c[B>>2]=y;R=w}LF(R|0,I|0,y)|0;a[R+y|0]=0}y=(z=0,au(46,l|0)|0);if(z){z=0;D=44;break}if((y|0)!=6){D=48;break}if((a[H]&1)!=0){Lw(c[E>>2]|0)}y=A+1|0;if(y>>>0>=k>>>0){break L43}A=y;u=c[p>>2]|0}do{if((D|0)==37){D5(0)}else if((D|0)==44){p=bT(-1,-1)|0;S=M;T=p}else if((D|0)==48){z=0,aM(344,e|0,l|0)|0;if(z){z=0;p=bT(-1,-1)|0;S=M;T=p;break}if((a[H]&1)==0){break L43}Lw(c[E>>2]|0);break L43}}while(0);p=T;u=S;if((a[H]&1)==0){J=u;K=p;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[E>>2]|0);J=u;K=p;L=K;N=0;O=L;P=J;bg(O|0)}}while(0);S=b+48|0;T=b+52|0;l=c[T>>2]|0;R=S|0;Q=c[R>>2]|0;p=(l-Q|0)/12|0;L77:do{if((l|0)!=(Q|0)){u=m;A=m+8|0;k=b+40|0;B=m+1|0;s=m|0;r=m+4|0;v=0;q=Q;while(1){y=q+(v*12|0)|0;if((a[y]&1)==0){c[u>>2]=c[y>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2]}else{y=c[q+(v*12|0)+8>>2]|0;I=c[q+(v*12|0)+4>>2]|0;if(I>>>0>4294967279>>>0){D=60;break}if(I>>>0<11>>>0){a[u]=I<<1;U=B}else{w=I+16&-16;x=Lu(w)|0;c[A>>2]=x;c[s>>2]=w|1;c[r>>2]=I;U=x}LF(U|0,y|0,I)|0;a[U+I|0]=0}I=(z=0,au(46,m|0)|0);if(z){z=0;break}if((I|0)!=6){V=(z=0,+(+aO(2,m|0,e|0)));if(z){z=0;break}h[k>>3]=V*+h[k>>3];I=(c[R>>2]|0)+(v*12|0)|0;z=0,aM(344,I|0,e|0)|0;if(z){z=0;break}}if((a[u]&1)!=0){Lw(c[A>>2]|0)}I=v+1|0;if(I>>>0>=p>>>0){break L77}v=I;q=c[R>>2]|0}if((D|0)==60){D5(0)}q=bT(-1,-1)|0;v=q;q=M;if((a[u]&1)==0){J=q;K=v;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[A>>2]|0);J=q;K=v;L=K;N=0;O=L;P=J;bg(O|0)}}while(0);p=b+64|0;m=c[p>>2]|0;U=b+60|0;Q=c[U>>2]|0;l=(m-Q|0)/12|0;L107:do{if((m|0)!=(Q|0)){v=n;q=n+8|0;k=b+40|0;r=n+1|0;s=n|0;B=n+4|0;E=0;H=Q;while(1){I=H+(E*12|0)|0;if((a[I]&1)==0){c[v>>2]=c[I>>2];c[v+4>>2]=c[I+4>>2];c[v+8>>2]=c[I+8>>2]}else{I=c[H+(E*12|0)+8>>2]|0;y=c[H+(E*12|0)+4>>2]|0;if(y>>>0>4294967279>>>0){D=80;break}if(y>>>0<11>>>0){a[v]=y<<1;W=r}else{x=y+16&-16;w=Lu(x)|0;c[q>>2]=w;c[s>>2]=x|1;c[B>>2]=y;W=w}LF(W|0,I|0,y)|0;a[W+y|0]=0}y=(z=0,au(46,n|0)|0);if(z){z=0;break}if((y|0)!=6){V=(z=0,+(+aO(2,n|0,e|0)));if(z){z=0;break}h[k>>3]=+h[k>>3]/V;y=(c[U>>2]|0)+(E*12|0)|0;z=0,aM(344,y|0,e|0)|0;if(z){z=0;break}}if((a[v]&1)!=0){Lw(c[q>>2]|0)}y=E+1|0;if(y>>>0>=l>>>0){break L107}E=y;H=c[U>>2]|0}if((D|0)==80){D5(0)}H=bT(-1,-1)|0;E=H;H=M;if((a[v]&1)==0){J=H;K=E;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[q>>2]|0);J=H;K=E;L=K;N=0;O=L;P=J;bg(O|0)}}while(0);l=o|0;c[l>>2]=0;e=o+4|0;c[e>>2]=0;n=o+8|0;c[n>>2]=0;z=0;as(402,o|0,((c[T>>2]|0)-(c[R>>2]|0)|0)/12|0|0);L137:do{if(!z){W=c[R>>2]|0;L139:do{if((W|0)!=(c[T>>2]|0)){Q=W;L140:while(1){b=c[U>>2]|0;m=c[p>>2]|0;L142:do{if((b|0)==(m|0)){X=b;D=116}else{E=a[Q]|0;H=E&255;k=(H&1|0)==0;B=H>>>1;H=Q+1|0;s=Q+8|0;r=Q+4|0;A=b;while(1){u=A;y=a[A]|0;I=y&255;if((I&1|0)==0){Y=I>>>1}else{Y=c[A+4>>2]|0}if(k){Z=B}else{Z=c[r>>2]|0}L153:do{if((Y|0)==(Z|0)){I=(y&1)==0;if(I){_=u+1|0}else{_=c[A+8>>2]|0}if((E&1)==0){$=H}else{$=c[s>>2]|0}if(!I){if((LH(_|0,$|0,Y|0)|0)==0){X=A;D=116;break L142}else{break}}if((Y|0)==0){X=A;D=116;break L142}else{aa=$;ab=_;ac=Y}while(1){if((a[ab]|0)!=(a[aa]|0)){break L153}I=ac-1|0;if((I|0)==0){X=A;D=116;break L142}else{aa=aa+1|0;ab=ab+1|0;ac=I}}}}while(0);u=A+12|0;if((u|0)==(m|0)){D=135;break}else{A=u}}}}while(0);do{if((D|0)==116){D=0;if((X|0)==(m|0)){D=135;break}A=(X-b|0)/12|0;s=b+(A*12|0)|0;H=b+((A+1|0)*12|0)|0;if((H|0)==(m|0)){ad=s;ae=m}else{A=s;s=H;do{z=0,aM(344,A|0,s|0)|0;if(z){z=0;D=125;break L140}s=s+12|0;A=A+12|0;}while((s|0)!=(m|0));ad=A;ae=c[p>>2]|0}if((ad|0)==(ae|0)){break}else{af=ae}while(1){s=af-12|0;c[p>>2]=s;if((a[s]&1)==0){ag=s}else{Lw(c[af-12+8>>2]|0);ag=c[p>>2]|0}if((ad|0)==(ag|0)){break}else{af=ag}}}}while(0);do{if((D|0)==135){D=0;m=c[e>>2]|0;if((m|0)==(c[n>>2]|0)){z=0;as(284,o|0,Q|0);if(!z){break}else{z=0;D=126;break L140}}do{if((m|0)!=0){b=Q;if((a[b]&1)==0){A=m;c[A>>2]=c[b>>2];c[A+4>>2]=c[b+4>>2];c[A+8>>2]=c[b+8>>2];break}b=c[Q+8>>2]|0;A=c[Q+4>>2]|0;if(A>>>0>4294967279>>>0){D=140;break L140}if(A>>>0<11>>>0){a[m]=A<<1;ah=m+1|0}else{s=A+16&-16;H=(z=0,au(248,s|0)|0);if(z){z=0;D=126;break L140}c[m+8>>2]=H;c[m>>2]=s|1;c[m+4>>2]=A;ah=H}LF(ah|0,b|0,A)|0;a[ah+A|0]=0}}while(0);c[e>>2]=(c[e>>2]|0)+12}}while(0);Q=Q+12|0;if((Q|0)==(c[T>>2]|0)){break L139}}if((D|0)==125){Q=bT(-1,-1)|0;ai=M;aj=Q;break L137}else if((D|0)==126){Q=bT(-1,-1)|0;ai=M;aj=Q;break L137}else if((D|0)==140){z=0;ar(86,0);if(z){z=0;D=127;break L137}}}}while(0);z=0;aR(152,S|0,c[l>>2]|0,c[e>>2]|0);if(z){z=0;D=127;break}z=0;aR(416,c[R>>2]|0,c[T>>2]|0,g|0);if(z){z=0;D=127;break}z=0;aR(416,c[U>>2]|0,c[p>>2]|0,j|0);if(z){z=0;D=127;break}W=c[l>>2]|0;if((W|0)==0){i=f;return}q=c[e>>2]|0;if((W|0)==(q|0)){ak=W}else{v=q;while(1){q=v-12|0;c[e>>2]=q;if((a[q]&1)==0){al=q}else{Lw(c[v-12+8>>2]|0);al=c[e>>2]|0}if((W|0)==(al|0)){break}else{v=al}}ak=c[l>>2]|0}Lw(ak);i=f;return}else{z=0;D=127}}while(0);if((D|0)==127){D=bT(-1,-1)|0;ai=M;aj=D}D=aj;aj=ai;ai=c[l>>2]|0;if((ai|0)==0){J=aj;K=D;L=K;N=0;O=L;P=J;bg(O|0)}f=c[e>>2]|0;if((ai|0)==(f|0)){am=ai}else{ak=f;while(1){f=ak-12|0;c[e>>2]=f;if((a[f]&1)==0){an=f}else{Lw(c[ak-12+8>>2]|0);an=c[e>>2]|0}if((ai|0)==(an|0)){break}else{ak=an}}am=c[l>>2]|0}Lw(am);J=aj;K=D;L=K;N=0;O=L;P=J;bg(O|0)}function jv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;e=i;f=b;g=i;i=i+12|0;i=i+7&-8;h=i;i=i+12|0;i=i+7&-8;j=c[d+52>>2]|0;k=d+48|0;l=c[k>>2]|0;m=(j-l|0)/12|0;L1:do{if((j|0)!=(l|0)){n=g;o=g+8|0;p=g+1|0;q=g|0;r=g+4|0;s=0;t=l;while(1){u=t+(s*12|0)|0;if((a[u]&1)==0){c[n>>2]=c[u>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2]}else{u=c[t+(s*12|0)+8>>2]|0;v=c[t+(s*12|0)+4>>2]|0;if(v>>>0>4294967279>>>0){w=6;break}if(v>>>0<11>>>0){a[n]=v<<1;x=p}else{y=v+16&-16;A=Lu(y)|0;c[o>>2]=A;c[q>>2]=y|1;c[r>>2]=v;x=A}LF(x|0,u|0,v)|0;a[x+v|0]=0}v=(z=0,au(46,g|0)|0);if(z){z=0;w=22;break}B=(a[n]&1)==0;if((v|0)!=6){w=13;break}if(!B){Lw(c[o>>2]|0)}v=s+1|0;if(v>>>0>=m>>>0){break L1}s=v;t=c[k>>2]|0}if((w|0)==22){t=bT(-1,-1)|0;C=M;D=t}else if((w|0)==13){if(B){c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];i=e;return}t=c[o>>2]|0;s=c[r>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(s>>>0<11>>>0){a[f]=s<<1;E=b+1|0}else{q=s+16&-16;p=(z=0,au(248,q|0)|0);if(z){z=0;break}c[b+8>>2]=p;c[b>>2]=q|1;c[b+4>>2]=s;E=p}LF(E|0,t|0,s)|0;a[E+s|0]=0;if(B){i=e;return}Lw(c[o>>2]|0);i=e;return}}while(0);s=bT(-1,-1)|0;C=M;D=s}else if((w|0)==6){D5(0)}s=D;t=C;if((a[n]&1)==0){F=t;G=s;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[o>>2]|0);F=t;G=s;H=G;I=0;J=H;K=F;bg(J|0)}}while(0);C=c[d+64>>2]|0;D=d+60|0;d=c[D>>2]|0;B=(C-d|0)/12|0;L48:do{if((C|0)!=(d|0)){E=h;k=h+8|0;m=h+1|0;g=h|0;x=h+4|0;l=0;j=d;while(1){s=j+(l*12|0)|0;if((a[s]&1)==0){c[E>>2]=c[s>>2];c[E+4>>2]=c[s+4>>2];c[E+8>>2]=c[s+8>>2]}else{s=c[j+(l*12|0)+8>>2]|0;t=c[j+(l*12|0)+4>>2]|0;if(t>>>0>4294967279>>>0){w=35;break}if(t>>>0<11>>>0){a[E]=t<<1;L=m}else{r=t+16&-16;p=Lu(r)|0;c[k>>2]=p;c[g>>2]=r|1;c[x>>2]=t;L=p}LF(L|0,s|0,t)|0;a[L+t|0]=0}t=(z=0,au(46,h|0)|0);if(z){z=0;w=51;break}N=(a[E]&1)==0;if((t|0)!=6){w=42;break}if(!N){Lw(c[k>>2]|0)}t=l+1|0;if(t>>>0>=B>>>0){break L48}l=t;j=c[D>>2]|0}if((w|0)==42){if(N){c[f>>2]=c[E>>2];c[f+4>>2]=c[E+4>>2];c[f+8>>2]=c[E+8>>2];i=e;return}j=c[k>>2]|0;l=c[x>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(l>>>0<11>>>0){a[f]=l<<1;O=b+1|0}else{g=l+16&-16;m=(z=0,au(248,g|0)|0);if(z){z=0;break}c[b+8>>2]=m;c[b>>2]=g|1;c[b+4>>2]=l;O=m}LF(O|0,j|0,l)|0;a[O+l|0]=0;if(N){i=e;return}Lw(c[k>>2]|0);i=e;return}}while(0);l=bT(-1,-1)|0;P=M;Q=l}else if((w|0)==35){D5(0)}else if((w|0)==51){l=bT(-1,-1)|0;P=M;Q=l}l=Q;j=P;if((a[E]&1)==0){F=j;G=l;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[k>>2]|0);F=j;G=l;H=G;I=0;J=H;K=F;bg(J|0)}}while(0);LI(f|0,0,12)|0;i=e;return}function jw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+16|0;f=e|0;g=f;h=i;i=i+144|0;j=h+64|0;k=h|0;l=h+8|0;m=l|0;c[m>>2]=15464;n=h+12|0;c[k>>2]=32540;o=h+64|0;c[o>>2]=32560;c[h+4>>2]=0;z=0;as(198,h+64|0,n|0);do{if(!z){c[h+136>>2]=0;c[h+140>>2]=-1;p=h+8|0;c[k>>2]=15444;c[j>>2]=15484;c[m>>2]=15464;q=n|0;c[q>>2]=15768;r=h+16|0;I_(r);LI(h+20|0,0,24)|0;c[q>>2]=15624;s=h+44|0;LI(h+44|0,0,16)|0;c[h+60>>2]=24;LI(g|0,0,12)|0;z=0;as(212,n|0,f|0);if(z){z=0;t=bT(-1,-1)|0;u=M;if((a[g]&1)!=0){Lw(c[f+8>>2]|0)}if((a[s]&1)!=0){Lw(c[h+52>>2]|0)}c[q>>2]=15768;z=0;ar(394,r|0);if(!z){v=t;w=u;break}else{z=0}bT(-1,-1,0)|0;bX()}if((a[g]&1)!=0){Lw(c[f+8>>2]|0)}u=c[d+52>>2]|0;t=d+48|0;q=c[t>>2]|0;x=(u-q|0)/12|0;L17:do{if((u|0)==(q|0)){y=30}else{A=l;B=0;while(1){if((B|0)!=0){z=0,aM(106,A|0,42)|0;if(z){z=0;break}}z=0,aM(814,A|0,(c[t>>2]|0)+(B*12|0)|0)|0;if(z){z=0;break}C=B+1|0;if(C>>>0<x>>>0){B=C}else{y=30;break L17}}B=bT(-1,-1)|0;D=M;E=B}}while(0);L26:do{if((y|0)==30){x=d+60|0;t=d+64|0;L28:do{if((c[x>>2]|0)==(c[t>>2]|0)){y=38}else{q=l;z=0,aM(106,q|0,47)|0;if(z){z=0;break}q=c[t>>2]|0;u=c[x>>2]|0;B=(q-u|0)/12|0;if((q|0)==(u|0)){y=38;break}u=l;q=0;while(1){if((q|0)!=0){z=0,aM(106,u|0,42)|0;if(z){z=0;break}}z=0,aM(814,u|0,(c[x>>2]|0)+(q*12|0)|0)|0;if(z){z=0;break}A=q+1|0;if(A>>>0<B>>>0){q=A}else{y=38;break L28}}q=bT(-1,-1)|0;D=M;E=q;break L26}}while(0);do{if((y|0)==38){z=0;as(576,b|0,n|0);if(z){z=0;break}c[k>>2]=15444;c[o>>2]=15484;c[p>>2]=15464;x=h+12|0;c[x>>2]=15624;if((a[s]&1)!=0){Lw(c[h+52>>2]|0)}c[x>>2]=15768;z=0;ar(394,r|0);if(!z){Ex(h+64|0);i=e;return}else{z=0}x=bT(-1,-1)|0;z=0;ar(272,h+64|0);if(!z){bg(x|0)}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);x=bT(-1,-1)|0;D=M;E=x}}while(0);c[k>>2]=15444;c[o>>2]=15484;c[p>>2]=15464;x=h+12|0;c[x>>2]=15624;if((a[s]&1)!=0){Lw(c[h+52>>2]|0)}c[x>>2]=15768;z=0;ar(394,r|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,h+64|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,h+64|0);if(!z){bg(E|0)}else{z=0}bT(-1,-1,0)|0;bX()}else{z=0;x=bT(-1,-1)|0;v=x;w=M}}while(0);z=0;ar(272,j|0);if(!z){bg(v|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function jx(a){a=a|0;ke(a);return}function jy(a,b){a=a|0;b=b|0;return b|0}function jz(a,b){a=a|0;b=b|0;return b|0}function jA(a,b){a=a|0;b=b|0;return b|0}function jB(a,b){a=a|0;b=b|0;return b|0}function jC(a,b){a=a|0;b=b|0;return b|0}function jD(a,b){a=a|0;b=b|0;return b|0}function jE(a,b){a=a|0;b=b|0;return b|0}function jF(a,b){a=a|0;b=b|0;return b|0}function jG(a,b){a=a|0;b=b|0;return b|0}function jH(a,b){a=a|0;b=b|0;return b|0}function jI(a,b){a=a|0;b=b|0;return b|0}function jJ(a,b){a=a|0;b=b|0;return b|0}function jK(a,b){a=a|0;b=b|0;return b|0}function jL(a,b){a=a|0;b=b|0;return b|0}function jM(a,b){a=a|0;b=b|0;return b|0}function jN(a,b){a=a|0;b=b|0;return b|0}function jO(a,b){a=a|0;b=b|0;return b|0}function jP(a,b){a=a|0;b=b|0;return b|0}function jQ(a,b){a=a|0;b=b|0;return b|0}function jR(a,b){a=a|0;b=b|0;return b|0}function jS(a,b){a=a|0;b=b|0;return b|0}function jT(a,b){a=a|0;b=b|0;return b|0}function jU(a,b){a=a|0;b=b|0;return b|0}function jV(a,b){a=a|0;b=b|0;return b|0}function jW(a,b){a=a|0;b=b|0;return b|0}function jX(a,b){a=a|0;b=b|0;return b|0}function jY(a,b){a=a|0;b=b|0;return b|0}function jZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function j_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function j$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=LH(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==17){t=0;if(o){u=e>>>1}else{u=c[d+20>>2]|0}if(h){v=i}else{v=c[k>>2]|0}if(r){w=m+1|0}else{w=c[d+24>>2]|0}if(g){x=b}else{x=c[j>>2]|0}m=LH(w|0,x|0,(v>>>0<u>>>0?v:u)|0)|0;if((m|0)==0){if(u>>>0>=v>>>0){f=1;t=35;break}}else{if((m|0)>=0){f=1;t=36;break}}y=d+4|0}else if((t|0)==16){t=0;y=d|0}m=c[y>>2]|0;if((m|0)==0){f=0;t=33;break}else{d=m}}if((t|0)==33){return f|0}else if((t|0)==36){return f|0}else if((t|0)==35){return f|0}return 0}function j0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=d;g=(e-f|0)/12|0;h=b+8|0;i=c[h>>2]|0;j=b|0;k=c[j>>2]|0;l=k;if(g>>>0>((i-l|0)/12|0)>>>0){if((k|0)==0){m=i}else{i=b+4|0;n=c[i>>2]|0;if((k|0)==(n|0)){o=k}else{p=n;while(1){n=p-12|0;c[i>>2]=n;if((a[n]&1)==0){q=n}else{Lw(c[p-12+8>>2]|0);q=c[i>>2]|0}if((k|0)==(q|0)){break}else{p=q}}o=c[j>>2]|0}Lw(o);c[h>>2]=0;c[i>>2]=0;c[j>>2]=0;m=0}if(g>>>0>357913941>>>0){IU(0)}i=(m|0)/12|0;do{if(i>>>0>178956969>>>0){r=357913941}else{m=i<<1;o=m>>>0<g>>>0?g:m;if(o>>>0<=357913941>>>0){r=o;break}IU(0)}}while(0);i=Lu(r*12|0)|0;o=b+4|0;c[o>>2]=i;c[j>>2]=i;c[h>>2]=i+(r*12|0);if((d|0)==(e|0)){return}else{s=d;t=i}L23:while(1){do{if((t|0)!=0){i=s;if((a[i]&1)==0){r=t;c[r>>2]=c[i>>2];c[r+4>>2]=c[i+4>>2];c[r+8>>2]=c[i+8>>2];break}i=c[s+8>>2]|0;r=c[s+4>>2]|0;if(r>>>0>4294967279>>>0){u=42;break L23}if(r>>>0<11>>>0){a[t]=r<<1;v=t+1|0}else{h=r+16&-16;j=Lu(h)|0;c[t+8>>2]=j;c[t>>2]=h|1;c[t+4>>2]=r;v=j}LF(v|0,i|0,r)|0;a[v+r|0]=0}}while(0);r=(c[o>>2]|0)+12|0;c[o>>2]=r;i=s+12|0;if((i|0)==(e|0)){u=54;break}else{s=i;t=r}}if((u|0)==42){D5(0)}else if((u|0)==54){return}}t=b+4|0;b=((c[t>>2]|0)-l|0)/12|0;if(g>>>0>b>>>0){w=1;x=d+(b*12|0)|0}else{w=0;x=e}if((x|0)==(d|0)){y=k}else{b=(((x-12+(-f|0)|0)>>>0)/12|0)+1|0;f=k;g=d;while(1){Ec(f,g)|0;d=g+12|0;if((d|0)==(x|0)){break}else{f=f+12|0;g=d}}y=k+(b*12|0)|0}if(!w){w=c[t>>2]|0;if((y|0)==(w|0)){return}else{z=w}while(1){w=z-12|0;c[t>>2]=w;if((a[w]&1)==0){A=w}else{Lw(c[z-12+8>>2]|0);A=c[t>>2]|0}if((y|0)==(A|0)){break}else{z=A}}return}if((x|0)==(e|0)){return}A=x;x=c[t>>2]|0;L63:while(1){do{if((x|0)!=0){z=A;if((a[z]&1)==0){y=x;c[y>>2]=c[z>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];break}z=c[A+8>>2]|0;y=c[A+4>>2]|0;if(y>>>0>4294967279>>>0){u=16;break L63}if(y>>>0<11>>>0){a[x]=y<<1;B=x+1|0}else{w=y+16&-16;b=Lu(w)|0;c[x+8>>2]=b;c[x>>2]=w|1;c[x+4>>2]=y;B=b}LF(B|0,z|0,y)|0;a[B+y|0]=0}}while(0);y=(c[t>>2]|0)+12|0;c[t>>2]=y;z=A+12|0;if((z|0)==(e|0)){u=52;break}else{A=z;x=y}}if((u|0)==16){D5(0)}else if((u|0)==52){return}}function j1(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function j2(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function j3(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+148>>2]&1023](b,a);return}function j4(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function j5(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function j6(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function j7(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function j8(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+148>>2]&511](a,d,b);return}function j9(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+148>>2]&511](a,d,b);return}function ka(a){a=a|0;return 0}function kb(b,c){b=b|0;c=c|0;c=b;a[b]=8;b=c+1|0;E=1819047278;a[b]=E;E=E>>8;a[b+1|0]=E;E=E>>8;a[b+2|0]=E;E=E>>8;a[b+3|0]=E;a[c+5|0]=0;return}function kc(a){a=a|0;return 1}function kd(a){a=a|0;return 1}function ke(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=b|0;c[d>>2]=18464;e=b+60|0;f=c[e>>2]|0;if((f|0)!=0){g=b+64|0;h=c[g>>2]|0;if((f|0)==(h|0)){i=f}else{j=h;while(1){h=j-12|0;c[g>>2]=h;if((a[h]&1)==0){k=h}else{Lw(c[j-12+8>>2]|0);k=c[g>>2]|0}if((f|0)==(k|0)){break}else{j=k}}i=c[e>>2]|0}Lw(i)}i=b+48|0;e=c[i>>2]|0;if((e|0)!=0){k=b+52|0;j=c[k>>2]|0;if((e|0)==(j|0)){l=e}else{f=j;while(1){j=f-12|0;c[k>>2]=j;if((a[j]&1)==0){m=j}else{Lw(c[f-12+8>>2]|0);m=c[k>>2]|0}if((e|0)==(m|0)){break}else{f=m}}l=c[i>>2]|0}Lw(l)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function kf(a){a=a|0;var b=0;z=0;ar(494,a|0);if(!z){Lw(a);return}else{z=0;b=bT(-1,-1)|0;Lw(a);bg(b|0)}}function kg(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+120>>2]&1023](b,a);return}function kh(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function ki(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function kj(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function kk(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function kl(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+120>>2]&511](a,d,b);return}function km(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+120>>2]&511](a,d,b);return}function kn(b,c){b=b|0;c=c|0;c=b;a[b]=12;b=c+1|0;a[b]=a[7976]|0;a[b+1|0]=a[7977]|0;a[b+2|0]=a[7978]|0;a[b+3|0]=a[7979]|0;a[b+4|0]=a[7980]|0;a[b+5|0]=a[7981]|0;a[c+7|0]=0;return}function ko(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;a[g]=d;d=h|0;a[d]=0;c[h+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;L1:do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){z=0,au(62,o|0)|0;if(z){z=0;p=15;break}}a[d]=1;o=c[(c[l>>2]|0)-12>>2]|0;c[j>>2]=c[n+(o+24)>>2];q=n+o|0;r=g+1|0;s=(c[n+(o+4)>>2]&176|0)==32?r:g;t=n+(o+76)|0;o=c[t>>2]|0;u=o&255;L6:do{if((o|0)==-1){z=0;as(352,f|0,q|0);if(z){z=0;p=16;break}v=(z=0,aM(198,f|0,41760)|0);do{if(!z){w=(z=0,aM(c[(c[v>>2]|0)+28>>2]|0,v|0,32)|0);if(z){z=0;break}z=0;ar(394,f|0);if(z){z=0;p=16;break L6}c[t>>2]=w<<24>>24;x=w;p=12;break L6}else{z=0}}while(0);v=bT(-1,-1,0)|0;w=M;z=0;ar(394,f|0);if(!z){y=w;A=v;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{x=u;p=12}}while(0);do{if((p|0)==12){z=0;aI(56,k|0,j|0,g|0,s|0,r|0,q|0,x|0);if(z){z=0;p=16;break}if((c[k>>2]|0)!=0){p=18;break L1}u=c[(c[l>>2]|0)-12>>2]|0;z=0;as(368,n+u|0,c[n+(u+16)>>2]|5|0);if(!z){p=18;break L1}else{z=0;p=16}}}while(0);if((p|0)==16){q=bT(-1,-1,0)|0;y=M;A=q}z=0;ar(138,h|0);if(!z){B=A;break}else{z=0}C=bT(-1,-1,0)|0;D=M;bX();return 0}else{p=18}}while(0);do{if((p|0)==18){z=0;ar(138,h|0);if(z){z=0;p=15;break}i=e;return b|0}}while(0);if((p|0)==15){p=bT(-1,-1,0)|0;B=p}bD(B|0)|0;z=0;ar(182,n+(c[(c[l>>2]|0)-12>>2]|0)|0);if(!z){a$();i=e;return b|0}else{z=0}b=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(b|0)}else{z=0;C=bT(-1,-1,0)|0;D=M;bX();return 0}return 0}function kp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=b|0;k=d;if((a[k]&1)==0){l=g;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2]}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){D5(0)}if(l>>>0<11>>>0){a[g]=l<<1;m=g+1|0}else{d=l+16&-16;n=Lu(d)|0;c[g+8>>2]=n;c[g>>2]=d|1;c[g+4>>2]=l;m=n}LF(m|0,k|0,l)|0;a[m+l|0]=0}l=h;m=e;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];z=0;aD(6,j|0,g|0,h|0,0,0,0);if(!z){if((a[g]&1)==0){o=b+36|0;p=b+40|0;c[p>>2]=0;q=b+44|0;c[q>>2]=0;r=b+48|0;c[r>>2]=0;s=b|0;c[s>>2]=17208;c[o>>2]=17272;t=b+52|0;a[t]=0;u=b+53|0;a[u]=0;i=f;return}Lw(c[g+8>>2]|0);o=b+36|0;p=b+40|0;c[p>>2]=0;q=b+44|0;c[q>>2]=0;r=b+48|0;c[r>>2]=0;s=b|0;c[s>>2]=17208;c[o>>2]=17272;t=b+52|0;a[t]=0;u=b+53|0;a[u]=0;i=f;return}else{z=0;f=bT(-1,-1)|0;if((a[g]&1)==0){bg(f|0)}Lw(c[g+8>>2]|0);bg(f|0)}}function kq(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+36>>2]=22544;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function kr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+36>>2]=22544;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){h=b;Lw(h);return}Lw(c[b+12>>2]|0);h=b;Lw(h);return}function ks(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+164>>2]&1023](b,a);return}function kt(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function ku(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function kv(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function kw(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function kx(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+164>>2]&511](a,d,b);return}function ky(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+164>>2]&511](a,d,b);return}function kz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+256|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=d+40|0;if((a[w]&1)==0){x=f;c[x>>2]=c[w>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];y=a[x]|0;A=x}else{x=c[d+48>>2]|0;w=c[d+44>>2]|0;if(w>>>0>4294967279>>>0){D5(0)}if(w>>>0<11>>>0){B=w<<1&255;C=f;a[C]=B;D=f+1|0;E=B;F=C}else{C=w+16&-16;B=Lu(C)|0;c[f+8>>2]=B;G=C|1;c[f>>2]=G;c[f+4>>2]=w;D=B;E=G&255;F=f}LF(D|0,x|0,w)|0;a[D+w|0]=0;y=E;A=F}F=y&255;if((F&1|0)==0){H=F>>>1}else{H=c[f+4>>2]|0}if((a[A]&1)!=0){Lw(c[f+8>>2]|0)}if((H|0)!=0){L21:do{if((a[b+53|0]&1)!=0){H=Lu(64)|0;f=g+8|0;c[f>>2]=H;c[g>>2]=65;c[g+4>>2]=53;LF(H|0,7744,53)|0;a[H+53|0]=0;H=d+4|0;L23:do{if((a[H]&1)==0){A=h;c[A>>2]=c[H>>2];c[A+4>>2]=c[H+4>>2];c[A+8>>2]=c[H+8>>2];I=26}else{A=c[d+12>>2]|0;F=c[d+8>>2]|0;do{if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(F>>>0<11>>>0){a[h]=F<<1;J=h+1|0}else{y=F+16&-16;E=(z=0,au(248,y|0)|0);if(z){z=0;break}c[h+8>>2]=E;c[h>>2]=y|1;c[h+4>>2]=F;J=E}LF(J|0,A|0,F)|0;a[J+F|0]=0;I=26;break L23}}while(0);F=bT(-1,-1)|0;K=M;L=F}}while(0);do{if((I|0)==26){H=j;F=d+16|0;c[H>>2]=c[F>>2];c[H+4>>2]=c[F+4>>2];c[H+8>>2]=c[F+8>>2];z=0;aR(382,g|0,h|0,j|0);if(z){z=0;F=bT(-1,-1)|0;H=F;F=M;if((a[h]&1)==0){K=F;L=H;break}Lw(c[h+8>>2]|0);K=F;L=H;break}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}if((a[g]&1)==0){break L21}Lw(c[f>>2]|0);break L21}}while(0);if((a[g]&1)==0){N=K;O=L;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[f>>2]|0);N=K;O=L;P=O;Q=0;R=P;S=N;bg(R|0)}}while(0);a[b+52|0]=1;i=e;return}L=b+53|0;K=(a[L]&1)!=0;if((a[d+52|0]&1)!=0){L56:do{if(K){g=Lu(80)|0;h=k+8|0;c[h>>2]=g;c[k>>2]=81;c[k+4>>2]=73;LF(g|0,7448,73)|0;a[g+73|0]=0;g=d+4|0;L58:do{if((a[g]&1)==0){j=l;c[j>>2]=c[g>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];I=49}else{j=c[d+12>>2]|0;J=c[d+8>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(J>>>0<11>>>0){a[l]=J<<1;T=l+1|0}else{H=J+16&-16;F=(z=0,au(248,H|0)|0);if(z){z=0;break}c[l+8>>2]=F;c[l>>2]=H|1;c[l+4>>2]=J;T=F}LF(T|0,j|0,J)|0;a[T+J|0]=0;I=49;break L58}}while(0);J=bT(-1,-1)|0;U=M;V=J}}while(0);do{if((I|0)==49){g=m;f=d+16|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];z=0;aR(382,k|0,l|0,m|0);if(z){z=0;f=bT(-1,-1)|0;g=f;f=M;if((a[l]&1)==0){U=f;V=g;break}Lw(c[l+8>>2]|0);U=f;V=g;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}if((a[k]&1)==0){break L56}Lw(c[h>>2]|0);break L56}}while(0);if((a[k]&1)==0){N=U;O=V;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[h>>2]|0);N=U;O=V;P=O;Q=0;R=P;S=N;bg(R|0)}}while(0);L87:do{if((a[b+52|0]&1)!=0){V=Lu(96)|0;U=n+8|0;c[U>>2]=V;c[n>>2]=97;c[n+4>>2]=94;LF(V|0,7144,94)|0;a[V+94|0]=0;V=d+4|0;L89:do{if((a[V]&1)==0){k=o;c[k>>2]=c[V>>2];c[k+4>>2]=c[V+4>>2];c[k+8>>2]=c[V+8>>2];I=70}else{k=c[d+12>>2]|0;l=c[d+8>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(l>>>0<11>>>0){a[o]=l<<1;W=o+1|0}else{m=l+16&-16;T=(z=0,au(248,m|0)|0);if(z){z=0;break}c[o+8>>2]=T;c[o>>2]=m|1;c[o+4>>2]=l;W=T}LF(W|0,k|0,l)|0;a[W+l|0]=0;I=70;break L89}}while(0);l=bT(-1,-1)|0;X=M;Y=l}}while(0);do{if((I|0)==70){V=p;h=d+16|0;c[V>>2]=c[h>>2];c[V+4>>2]=c[h+4>>2];c[V+8>>2]=c[h+8>>2];z=0;aR(382,n|0,o|0,p|0);if(z){z=0;h=bT(-1,-1)|0;V=h;h=M;if((a[o]&1)==0){X=h;Y=V;break}Lw(c[o+8>>2]|0);X=h;Y=V;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)==0){break L87}Lw(c[U>>2]|0);break L87}}while(0);if((a[n]&1)==0){N=X;O=Y;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[U>>2]|0);N=X;O=Y;P=O;Q=0;R=P;S=N;bg(R|0)}}while(0);a[L]=1;i=e;return}L120:do{if(K){L=Lu(64)|0;Y=q+8|0;c[Y>>2]=L;c[q>>2]=65;c[q+4>>2]=56;LF(L|0,6984,56)|0;a[L+56|0]=0;L=d+4|0;L122:do{if((a[L]&1)==0){X=r;c[X>>2]=c[L>>2];c[X+4>>2]=c[L+4>>2];c[X+8>>2]=c[L+8>>2];I=92}else{X=c[d+12>>2]|0;n=c[d+8>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(n>>>0<11>>>0){a[r]=n<<1;Z=r+1|0}else{o=n+16&-16;p=(z=0,au(248,o|0)|0);if(z){z=0;break}c[r+8>>2]=p;c[r>>2]=o|1;c[r+4>>2]=n;Z=p}LF(Z|0,X|0,n)|0;a[Z+n|0]=0;I=92;break L122}}while(0);n=bT(-1,-1)|0;_=M;$=n}}while(0);do{if((I|0)==92){L=s;U=d+16|0;c[L>>2]=c[U>>2];c[L+4>>2]=c[U+4>>2];c[L+8>>2]=c[U+8>>2];z=0;aR(382,q|0,r|0,s|0);if(z){z=0;U=bT(-1,-1)|0;L=U;U=M;if((a[r]&1)==0){_=U;$=L;break}Lw(c[r+8>>2]|0);_=U;$=L;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){break L120}Lw(c[Y>>2]|0);break L120}}while(0);if((a[q]&1)==0){N=_;O=$;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[Y>>2]|0);N=_;O=$;P=O;Q=0;R=P;S=N;bg(R|0)}}while(0);if((a[b+52|0]&1)==0){i=e;return}b=Lu(48)|0;$=t+8|0;c[$>>2]=b;c[t>>2]=49;c[t+4>>2]=46;LF(b|0,6728,46)|0;a[b+46|0]=0;b=d+4|0;L154:do{if((a[b]&1)==0){_=u;c[_>>2]=c[b>>2];c[_+4>>2]=c[b+4>>2];c[_+8>>2]=c[b+8>>2];I=113}else{_=c[d+12>>2]|0;q=c[d+8>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(q>>>0<11>>>0){a[u]=q<<1;aa=u+1|0}else{r=q+16&-16;s=(z=0,au(248,r|0)|0);if(z){z=0;break}c[u+8>>2]=s;c[u>>2]=r|1;c[u+4>>2]=q;aa=s}LF(aa|0,_|0,q)|0;a[aa+q|0]=0;I=113;break L154}}while(0);q=bT(-1,-1)|0;ab=M;ac=q}}while(0);do{if((I|0)==113){aa=v;b=d+16|0;c[aa>>2]=c[b>>2];c[aa+4>>2]=c[b+4>>2];c[aa+8>>2]=c[b+8>>2];z=0;aR(382,t|0,u|0,v|0);if(z){z=0;b=bT(-1,-1)|0;aa=b;b=M;if((a[u]&1)==0){ab=b;ac=aa;break}Lw(c[u+8>>2]|0);ab=b;ac=aa;break}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}if((a[t]&1)==0){i=e;return}Lw(c[$>>2]|0);i=e;return}}while(0);if((a[t]&1)==0){N=ab;O=ac;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[$>>2]|0);N=ab;O=ac;P=O;Q=0;R=P;S=N;bg(R|0)}function kA(a,b){a=a|0;b=b|0;kz(a-56+20|0,b);return}function kB(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-56+20|0;c[d+36>>2]=22544;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function kC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-56+20|0;c[d+36>>2]=22544;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){h=d;Lw(h);return}Lw(c[d+12>>2]|0);h=d;Lw(h);return}function kD(a,b){a=a|0;b=b|0;return}function kE(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function kF(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function kG(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+144>>2]&1023](b,a);return}function kH(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function kI(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function kJ(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function kK(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function kL(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+144>>2]&511](a,d,b);return}function kM(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+144>>2]&511](a,d,b);return}function kN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+32|0;l=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=b|0;o=d;if((a[o]&1)==0){p=l;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){D5(0)}if(p>>>0<11>>>0){a[l]=p<<1;q=l+1|0}else{d=p+16&-16;r=Lu(d)|0;c[l+8>>2]=r;c[l>>2]=d|1;c[l+4>>2]=p;q=r}LF(q|0,o|0,p)|0;a[q+p|0]=0}p=m;q=e;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];z=0;aD(6,n|0,l|0,m|0,0,0,0);if(z){z=0;m=bT(-1,-1)|0;n=m;m=M;if((a[l]&1)==0){s=m;t=n;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[l+8>>2]|0);s=m;t=n;u=t;v=0;w=u;x=s;bg(w|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}l=b+36|0;c[l>>2]=22576;n=b+40|0;c[n>>2]=0;m=b+44|0;c[m>>2]=0;q=b+48|0;c[q>>2]=0;if((g|0)==0){y=b|0;c[y>>2]=22200;c[l>>2]=22260;A=b+52|0;c[A>>2]=f;B=b+56|0;C=h&1;a[B]=C;D=b+57|0;E=j&1;a[D]=E;i=k;return}p=(z=0,au(248,g<<2|0)|0);if(!z){e=p;c[n>>2]=e;c[m>>2]=e;c[q>>2]=e+(g<<2);y=b|0;c[y>>2]=22200;c[l>>2]=22260;A=b+52|0;c[A>>2]=f;B=b+56|0;C=h&1;a[B]=C;D=b+57|0;E=j&1;a[D]=E;i=k;return}else{z=0}k=bT(-1,-1)|0;E=k;k=M;c[b>>2]=17512;if((a[b+4|0]&1)==0){s=k;t=E;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[b+12>>2]|0);s=k;t=E;u=t;v=0;w=u;x=s;bg(w|0)}function kO(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+36>>2]=22576;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function kP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+36>>2]=22576;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){h=b;Lw(h);return}Lw(c[b+12>>2]|0);h=b;Lw(h);return}function kQ(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+140>>2]&1023](b,a);return}function kR(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function kS(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function kT(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function kU(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function kV(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+140>>2]&511](a,d,b);return}function kW(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+140>>2]&511](a,d,b);return}function kX(a,b){a=a|0;b=b|0;return}function kY(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-60+24|0;c[d+36>>2]=22576;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function kZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+24|0;c[d+36>>2]=22576;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){h=d;Lw(h);return}Lw(c[d+12>>2]|0);h=d;Lw(h);return}function k_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0;e=b|0;c[e>>2]=17512;f=b+4|0;g=d+4|0;if((a[g]&1)==0){i=f;c[i>>2]=c[g>>2];c[i+4>>2]=c[g+4>>2];c[i+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;i=c[d+8>>2]|0;if(i>>>0>4294967279>>>0){D5(0)}if(i>>>0<11>>>0){a[f]=i<<1;j=f+1|0}else{k=i+16&-16;l=Lu(k)|0;c[b+12>>2]=l;c[f>>2]=k|1;c[b+8>>2]=i;j=l}LF(j|0,g|0,i)|0;a[j+i|0]=0}i=b+16|0;j=d+16|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];c[e>>2]=22848;a[b+28|0]=a[d+28|0]&1;a[b+29|0]=a[d+29|0]&1;c[b+32>>2]=c[d+32>>2];c[e>>2]=19128;h[b+40>>3]=+h[d+40>>3];h[b+48>>3]=+h[d+48>>3];h[b+56>>3]=+h[d+56>>3];h[b+64>>3]=+h[d+64>>3];j=b+72|0;i=d+72|0;if((a[i]&1)==0){g=j;c[g>>2]=c[i>>2];c[g+4>>2]=c[i+4>>2];c[g+8>>2]=c[i+8>>2];return}i=c[d+80>>2]|0;g=c[d+76>>2]|0;do{if(g>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(g>>>0<11>>>0){a[j]=g<<1;m=j+1|0}else{d=g+16&-16;l=(z=0,au(248,d|0)|0);if(z){z=0;break}c[b+80>>2]=l;c[j>>2]=d|1;c[b+76>>2]=g;m=l}LF(m|0,i|0,g)|0;a[m+g|0]=0;return}}while(0);g=bT(-1,-1)|0;c[e>>2]=17512;if((a[f]&1)==0){bg(g|0)}Lw(c[b+12>>2]|0);bg(g|0)}function k$(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aq(8,m|0,k|0,l|0,g|0,0);if(z){z=0;g=bT(-1,-1)|0;l=g;g=M;if((a[k]&1)==0){r=g;s=l;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=g;s=l;t=s;u=0;v=t;w=r;bg(v|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=b+40|0;c[k>>2]=22672;l=b+44|0;c[l>>2]=0;g=b+48|0;c[g>>2]=0;m=b+52|0;c[m>>2]=0;if((f|0)==0){x=b|0;c[x>>2]=21488;c[k>>2]=21548;y=b+56|0;a[y]=h;i=j;return}p=(z=0,au(248,f<<2|0)|0);if(!z){o=p;c[l>>2]=o;c[g>>2]=o;c[m>>2]=o+(f<<2);x=b|0;c[x>>2]=21488;c[k>>2]=21548;y=b+56|0;a[y]=h;i=j;return}else{z=0}j=bT(-1,-1)|0;h=j;j=M;c[b>>2]=17512;if((a[b+4|0]&1)==0){r=j;s=h;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[b+12>>2]|0);r=j;s=h;t=s;u=0;v=t;w=r;bg(v|0)}function k0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aD(6,l|0,j|0,k|0,g|0,0,0);if(!z){if((a[j]&1)==0){q=b|0;c[q>>2]=18328;r=b+36|0;s=f&1;a[r]=s;t=b+32|0;c[t>>2]=4;i=h;return}Lw(c[j+8>>2]|0);q=b|0;c[q>>2]=18328;r=b+36|0;s=f&1;a[r]=s;t=b+32|0;c[t>>2]=4;i=h;return}else{z=0;h=bT(-1,-1)|0;if((a[j]&1)==0){bg(h|0)}Lw(c[j+8>>2]|0);bg(h|0)}}function k1(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+40>>2]=22672;d=c[b+44>>2]|0;e=d;if((d|0)!=0){f=b+48|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function k2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+40>>2]=22672;d=c[b+44>>2]|0;e=d;if((d|0)!=0){f=b+48|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){h=b;Lw(h);return}Lw(c[b+12>>2]|0);h=b;Lw(h);return}function k3(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+132>>2]&1023](b,a);return}function k4(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function k5(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function k6(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function k7(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function k8(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+132>>2]&511](a,d,b);return}function k9(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+132>>2]&511](a,d,b);return}function la(b,c){b=b|0;c=c|0;c=b;a[b]=12;b=c+1|0;a[b]=a[6296]|0;a[b+1|0]=a[6297]|0;a[b+2|0]=a[6298]|0;a[b+3|0]=a[6299]|0;a[b+4|0]=a[6300]|0;a[b+5|0]=a[6301]|0;a[c+7|0]=0;return}function lb(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-60+20|0;c[d+40>>2]=22672;b=c[d+44>>2]|0;e=b;if((b|0)!=0){f=d+48|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function lc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+20|0;c[d+40>>2]=22672;b=c[d+44>>2]|0;e=b;if((b|0)!=0){f=d+48|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){h=d;Lw(h);return}Lw(c[d+12>>2]|0);h=d;Lw(h);return}function ld(a,b){a=a|0;b=b|0;cB[c[c[b>>2]>>2]&1023](b,a|0);return}function le(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a|0)|0}function lf(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a|0)|0}function lg(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a|0)|0}function lh(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a|0)|0}function li(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[c[d>>2]>>2]&511](a,d,b|0);return}function lj(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[c[d>>2]>>2]&511](a,d,b|0);return}function lk(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aD(6,l|0,j|0,k|0,0,0,0);if(z){z=0;k=bT(-1,-1)|0;l=k;k=M;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}j=b|0;c[j>>2]=21896;l=b+36|0;k=f;if((a[k]&1)==0){o=l;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];w=b+48|0;c[w>>2]=g;x=b+52|0;c[x>>2]=0;y=b+32|0;c[y>>2]=4;i=h;return}k=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[l]=o<<1;A=l+1|0}else{f=o+16&-16;n=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+44>>2]=n;c[l>>2]=f|1;c[b+40>>2]=o;A=n}LF(A|0,k|0,o)|0;a[A+o|0]=0;w=b+48|0;c[w>>2]=g;x=b+52|0;c[x>>2]=0;y=b+32|0;c[y>>2]=4;i=h;return}}while(0);h=bT(-1,-1)|0;y=h;h=M;c[j>>2]=17512;if((a[b+4|0]&1)==0){q=h;r=y;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[b+12>>2]|0);q=h;r=y;s=r;t=0;u=s;v=q;bg(u|0)}function ll(b){b=b|0;var d=0;d=b|0;c[d>>2]=21896;if((a[b+36|0]&1)!=0){Lw(c[b+44>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function lm(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21896;if((a[b+36|0]&1)!=0){Lw(c[b+44>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function ln(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+104>>2]&1023](b,a);return}function lo(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function lp(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function lq(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function lr(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function ls(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+104>>2]&511](a,d,b);return}function lt(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+104>>2]&511](a,d,b);return}function lu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aq(8,l|0,j|0,k|0,g|0,1);if(z){z=0;g=bT(-1,-1)|0;k=g;g=M;if((a[j]&1)==0){q=g;r=k;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[j+8>>2]|0);q=g;r=k;s=r;t=0;u=s;v=q;bg(u|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}j=b|0;c[j>>2]=21136;k=b+40|0;g=f;if((a[g]&1)==0){l=k;c[l>>2]=c[g>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];i=h;return}g=c[f+8>>2]|0;l=c[f+4>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(l>>>0<11>>>0){a[k]=l<<1;w=k+1|0}else{f=l+16&-16;o=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+48>>2]=o;c[k>>2]=f|1;c[b+44>>2]=l;w=o}LF(w|0,g|0,l)|0;a[w+l|0]=0;i=h;return}}while(0);h=bT(-1,-1)|0;l=h;h=M;c[j>>2]=17512;if((a[b+4|0]&1)==0){q=h;r=l;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[b+12>>2]|0);q=h;r=l;s=r;t=0;u=s;v=q;bg(u|0)}function lv(b){b=b|0;var d=0;d=b|0;c[d>>2]=21136;if((a[b+40|0]&1)!=0){Lw(c[b+48>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function lw(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21136;if((a[b+40|0]&1)!=0){Lw(c[b+48>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function lx(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+136>>2]&1023](b,a);return}function ly(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function lz(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function lA(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function lB(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function lC(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+136>>2]&511](a,d,b);return}function lD(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+136>>2]&511](a,d,b);return}function lE(b,c){b=b|0;c=c|0;c=b;a[b]=12;b=c+1|0;a[b]=a[6296]|0;a[b+1|0]=a[6297]|0;a[b+2|0]=a[6298]|0;a[b+3|0]=a[6299]|0;a[b+4|0]=a[6300]|0;a[b+5|0]=a[6301]|0;a[c+7|0]=0;return}function lF(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aq(8,l|0,j|0,k|0,g|0,1);if(z){z=0;g=bT(-1,-1)|0;k=g;g=M;if((a[j]&1)==0){q=g;r=k;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[j+8>>2]|0);q=g;r=k;s=r;t=0;u=s;v=q;bg(u|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}j=b|0;c[j>>2]=21136;k=LJ(f|0)|0;g=b+40|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[g]=k<<1;w=g+1|0;LF(w|0,f|0,k)|0;x=w+k|0;a[x]=0;i=h;return}l=k+16&-16;o=(z=0,au(248,l|0)|0);if(z){z=0;break}c[b+48>>2]=o;c[g>>2]=l|1;c[b+44>>2]=k;w=o;LF(w|0,f|0,k)|0;x=w+k|0;a[x]=0;i=h;return}}while(0);h=bT(-1,-1)|0;x=h;h=M;c[j>>2]=17512;if((a[b+4|0]&1)==0){q=h;r=x;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[b+12>>2]|0);q=h;r=x;s=r;t=0;u=s;v=q;bg(u|0)}function lG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=b|0;c[e>>2]=17512;f=b+4|0;g=d+4|0;if((a[g]&1)==0){i=f;c[i>>2]=c[g>>2];c[i+4>>2]=c[g+4>>2];c[i+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;i=c[d+8>>2]|0;if(i>>>0>4294967279>>>0){D5(0)}if(i>>>0<11>>>0){a[f]=i<<1;j=f+1|0}else{k=i+16&-16;l=Lu(k)|0;c[b+12>>2]=l;c[f>>2]=k|1;c[b+8>>2]=i;j=l}LF(j|0,g|0,i)|0;a[j+i|0]=0}i=b+16|0;j=d+16|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];c[e>>2]=22848;a[b+28|0]=a[d+28|0]&1;a[b+29|0]=a[d+29|0]&1;c[b+32>>2]=c[d+32>>2];c[e>>2]=18464;h[b+40>>3]=+h[d+40>>3];j=b+48|0;z=0;as(294,j|0,d+48|0);do{if(!z){z=0;as(294,b+60|0,d+60|0);if(!z){return}else{z=0}i=bT(-1,-1)|0;g=i;i=M;l=j|0;k=c[l>>2]|0;if((k|0)==0){m=i;n=g;break}o=b+52|0;p=c[o>>2]|0;if((k|0)==(p|0)){q=k}else{r=p;while(1){p=r-12|0;c[o>>2]=p;if((a[p]&1)==0){s=p}else{Lw(c[r-12+8>>2]|0);s=c[o>>2]|0}if((k|0)==(s|0)){break}else{r=s}}q=c[l>>2]|0}Lw(q);m=i;n=g}else{z=0;r=bT(-1,-1)|0;m=M;n=r}}while(0);c[e>>2]=17512;if((a[f]&1)==0){t=n;u=0;v=t;w=m;bg(v|0)}Lw(c[b+12>>2]|0);t=n;u=0;v=t;w=m;bg(v|0)}function lH(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function lI(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function lJ(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+128>>2]&1023](b,a);return}function lK(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function lL(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function lM(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function lN(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function lO(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+128>>2]&511](a,d,b);return}function lP(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+128>>2]&511](a,d,b);return}function lQ(b){b=b|0;return(a[b+36|0]&1)!=0|0}function lR(b,c){b=b|0;c=c|0;c=b;a[b]=8;b=c+1|0;E=1819242338;a[b]=E;E=E>>8;a[b+1|0]=E;E=E>>8;a[b+2|0]=E;E=E>>8;a[b+3|0]=E;a[c+5|0]=0;return}function lS(b){b=b|0;return(a[b+36|0]&1)==0|0}function lT(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+32|0;l=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=b|0;o=e;if((a[o]&1)==0){p=l;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[e+8>>2]|0;p=c[e+4>>2]|0;if(p>>>0>4294967279>>>0){D5(0)}if(p>>>0<11>>>0){a[l]=p<<1;q=l+1|0}else{e=p+16&-16;r=Lu(e)|0;c[l+8>>2]=r;c[l>>2]=e|1;c[l+4>>2]=p;q=r}LF(q|0,o|0,p)|0;a[q+p|0]=0}p=m;q=f;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];z=0;aD(6,n|0,l|0,m|0,0,0,0);if(z){z=0;m=bT(-1,-1)|0;n=m;m=M;if((a[l]&1)==0){s=m;t=n;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[l+8>>2]|0);s=m;t=n;u=t;v=0;w=u;x=s;bg(w|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}l=b|0;c[l>>2]=18464;h[b+40>>3]=g;n=b+48|0;m=n|0;q=b+52|0;p=b+60|0;f=b+64|0;LI(n|0,0,24)|0;o=d[j]|0;if((o&1|0)==0){y=o>>>1}else{y=c[j+4>>2]|0}if((y|0)==0){A=b+32|0;c[A>>2]=2;i=k;return}z=0;as(284,n|0,j|0);if(!z){A=b+32|0;c[A>>2]=2;i=k;return}else{z=0}k=bT(-1,-1)|0;A=k;k=M;j=c[p>>2]|0;if((j|0)!=0){n=c[f>>2]|0;if((j|0)==(n|0)){B=j}else{y=n;while(1){n=y-12|0;c[f>>2]=n;if((a[n]&1)==0){C=n}else{Lw(c[y-12+8>>2]|0);C=c[f>>2]|0}if((j|0)==(C|0)){break}else{y=C}}B=c[p>>2]|0}Lw(B)}B=c[m>>2]|0;if((B|0)!=0){p=c[q>>2]|0;if((B|0)==(p|0)){D=B}else{C=p;while(1){p=C-12|0;c[q>>2]=p;if((a[p]&1)==0){E=p}else{Lw(c[C-12+8>>2]|0);E=c[q>>2]|0}if((B|0)==(E|0)){break}else{C=E}}D=c[m>>2]|0}Lw(D)}c[l>>2]=17512;if((a[b+4|0]&1)==0){s=k;t=A;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[b+12>>2]|0);s=k;t=A;u=t;v=0;w=u;x=s;bg(w|0)}function lU(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+8|0;j=h|0;c[a>>2]=18832;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;c[a+16>>2]=f;f=a+20|0;e=a+24|0;d=a+32|0;b=a+36|0;k=a+44|0;l=a+48|0;LI(f|0,0,36)|0;c[a+56>>2]=g;c[j>>2]=0;z=0;as(6,k|0,j|0);if(!z){i=h;return}else{z=0}h=bT(-1,-1)|0;j=c[k>>2]|0;k=j;if((j|0)!=0){g=c[l>>2]|0;if((j|0)!=(g|0)){c[l>>2]=g+(~((g-4+(-k|0)|0)>>>2)<<2)}Lw(j)}j=c[d>>2]|0;d=j;if((j|0)!=0){k=c[b>>2]|0;if((j|0)!=(k|0)){c[b>>2]=k+(~((k-4+(-d|0)|0)>>>2)<<2)}Lw(j)}j=c[f>>2]|0;if((j|0)==0){bg(h|0)}f=c[e>>2]|0;if((j|0)!=(f|0)){c[e>>2]=f+(~((f-4+(-j|0)|0)>>>2)<<2)}Lw(j);bg(h|0)}function lV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;e=i;i=i+72|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=j+4|0;c[m>>2]=0;c[j+8>>2]=0;c[j>>2]=m;m=b+16|0;c[j+12>>2]=c[m>>2];c[m>>2]=j;n=c[b+4>>2]|0;o=(z=0,au(248,48)|0);L1:do{if(!z){p=o;c[h>>2]=p;q=n+4|0;r=c[q>>2]|0;if((r|0)==(c[n+8>>2]|0)){z=0;as(382,n|0,h|0);if(z){z=0;s=43;break}t=c[h>>2]|0}else{if((r|0)==0){u=0}else{c[r>>2]=p;u=c[q>>2]|0}c[q>>2]=u+4;t=p}p=t;r=t;v=d+4|0;L11:do{if((a[v]&1)==0){w=l;c[w>>2]=c[v>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];s=18}else{w=c[d+12>>2]|0;x=c[d+8>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[l]=x<<1;y=l+1|0}else{A=x+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[l+8>>2]=B;c[l>>2]=A|1;c[l+4>>2]=x;y=B}LF(y|0,w|0,x)|0;a[y+x|0]=0;s=18;break L11}}while(0);x=bT(-1,-1)|0;C=x;D=M}}while(0);do{if((s|0)==18){v=d+16|0;x=g;c[x>>2]=c[v>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];v=d+36|0;x=d+32|0;z=0;aq(4,r|0,l|0,g|0,(c[v>>2]|0)-(c[x>>2]|0)>>2|0,(a[d+44|0]&1)!=0|0);if(z){z=0;w=bT(-1,-1)|0;B=w;w=M;if((a[l]&1)==0){C=B;D=w;break}Lw(c[l+8>>2]|0);C=B;D=w;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}c[k>>2]=r;w=b+24|0;B=c[w>>2]|0;if((B|0)==(c[b+28>>2]|0)){z=0;as(408,b+20|0,k|0);if(z){z=0;s=43;break L1}E=c[w>>2]|0}else{if((B|0)==0){F=0}else{c[B>>2]=r;F=c[w>>2]|0}B=F+4|0;c[w>>2]=B;E=B}B=c[E-4>>2]|0;A=c[x>>2]|0;G=(c[v>>2]|0)-A>>2;if((G|0)==0){H=E;I=H-4|0;c[w>>2]=I;J=c[m>>2]|0;K=J+12|0;L=c[K>>2]|0;c[m>>2]=L;N=c[k>>2]|0;O=N|0;P=j|0;Q=j+4|0;R=c[Q>>2]|0;S=R;g_(P,S);i=e;return O|0}v=b|0;T=B+28|0;U=B+36|0;V=B+40|0;W=B+32|0;B=T;X=0;Y=A;while(1){A=c[Y+(X<<2)>>2]|0;Z=(z=0,aM(c[(c[A>>2]|0)+16>>2]|0,A|0,v|0)|0);if(z){z=0;s=42;break}if((Z|0)!=0){c[f>>2]=Z;A=c[U>>2]|0;if((A|0)==(c[V>>2]|0)){z=0;as(488,W|0,f|0);if(z){z=0;s=42;break}_=c[f>>2]|0}else{if((A|0)==0){$=0}else{c[A>>2]=Z;$=c[U>>2]|0}c[U>>2]=$+4;_=Z}z=0;as(c[c[B>>2]>>2]|0,T|0,_|0);if(z){z=0;s=42;break}}Z=X+1|0;if(Z>>>0>=G>>>0){break}X=Z;Y=c[x>>2]|0}if((s|0)==42){x=bT(-1,-1)|0;aa=M;ab=x;break L1}H=c[w>>2]|0;I=H-4|0;c[w>>2]=I;J=c[m>>2]|0;K=J+12|0;L=c[K>>2]|0;c[m>>2]=L;N=c[k>>2]|0;O=N|0;P=j|0;Q=j+4|0;R=c[Q>>2]|0;S=R;g_(P,S);i=e;return O|0}}while(0);r=c[n>>2]|0;x=c[q>>2]|0;Y=r;while(1){if((Y|0)==(x|0)){ac=x;break}if((c[Y>>2]|0)==(t|0)){ac=Y;break}else{Y=Y+4|0}}Y=ac-r>>2;X=r+(Y+1<<2)|0;G=x-X|0;LG(r+(Y<<2)|0,X|0,G|0)|0;X=r+((G>>2)+Y<<2)|0;Y=c[q>>2]|0;if((X|0)!=(Y|0)){c[q>>2]=Y+(~((Y-4+(-X|0)|0)>>>2)<<2)}Lw(p);ad=C;ae=D;af=j|0;ag=j+4|0;ah=c[ag>>2]|0;ai=ah;g_(af,ai);aj=ad;ak=0;al=aj;am=ae;bg(al|0)}else{z=0;s=43}}while(0);if((s|0)==43){s=bT(-1,-1)|0;aa=M;ab=s}ad=ab;ae=aa;af=j|0;ag=j+4|0;ah=c[ag>>2]|0;ai=ah;g_(af,ai);aj=ad;ak=0;al=aj;am=ae;bg(al|0);return 0}function lW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0;e=i;i=i+232|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+64|0;m=e+72|0;n=e+136|0;o=e+152|0;p=e+168|0;q=e+184|0;r=e+200|0;s=e+216|0;Bv(k,0);t=d+32|0;u=c[t>>2]|0;v=c[(c[u>>2]|0)+24>>2]|0;w=b+44|0;x=b+48|0;y=(z=0,at(112,c[b+12>>2]|0,c[(c[x>>2]|0)-4>>2]|0,c[b+16>>2]|0,c[b+56>>2]|0,0,0)|0);L1:do{if(!z){A=(z=0,aM(v|0,u|0,y|0)|0);if(z){z=0;B=89;break}c[l>>2]=A;z=0;aR(c[(c[A>>2]|0)+28>>2]|0,o|0,A|0,k|0);if(z){z=0;B=89;break}A=n;LI(A|0,0,12)|0;C=o;D=a[C]|0;E=D&255;if((E&1|0)==0){F=E>>>1}else{F=c[o+4>>2]|0}if((D&1)==0){G=o+1|0}else{G=c[o+8>>2]|0}D=F+1|0;do{if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;B=18;break}return 0}else{if(D>>>0<11>>>0){a[A]=F<<1;H=n+1|0}else{E=F+17&-16;I=(z=0,au(248,E|0)|0);if(z){z=0;B=18;break}c[n+8>>2]=I;c[n>>2]=E|1;c[n+4>>2]=F;H=I}LF(H|0,G|0,F)|0;a[H+F|0]=0;z=0,az(88,n|0,9344,1)|0;if(z){z=0;B=18;break}if((a[A]&1)==0){J=n+1|0}else{J=c[n+8>>2]|0}I=b+4|0;E=c[I>>2]|0;K=c[t>>2]|0;L=K+4|0;L27:do{if((a[L]&1)==0){N=p;c[N>>2]=c[L>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];B=33}else{N=c[K+12>>2]|0;O=c[K+8>>2]|0;do{if(O>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(O>>>0<11>>>0){a[p]=O<<1;P=p+1|0}else{Q=O+16&-16;R=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[p+8>>2]=R;c[p>>2]=Q|1;c[p+4>>2]=O;P=R}LF(P|0,N|0,O)|0;a[P+O|0]=0;B=33;break L27}}while(0);O=bT(-1,-1)|0;S=O;T=M}}while(0);do{if((B|0)==33){L=q;O=K+16|0;c[L>>2]=c[O>>2];c[L+4>>2]=c[O+4>>2];c[L+8>>2]=c[O+8>>2];z=0;aq(2,m|0,J|0,E|0,p|0,q|0);do{if(!z){O=(z=0,au(50,m|0)|0);if(z){z=0;L=bT(-1,-1)|0;N=L;L=M;if((a[m+28|0]&1)!=0){Lw(c[m+36>>2]|0)}R=c[m+4>>2]|0;if((R|0)==0){U=N;V=L;break}Q=m+8|0;W=c[Q>>2]|0;if((R|0)!=(W|0)){c[Q>>2]=W+(~((W-4+(-R|0)|0)>>>2)<<2)}Lw(R);U=N;V=L;break}L=O|0;c[l>>2]=L;if((a[m+28|0]&1)!=0){Lw(c[m+36>>2]|0)}O=c[m+4>>2]|0;N=O;if((O|0)!=0){R=m+8|0;W=c[R>>2]|0;if((O|0)!=(W|0)){c[R>>2]=W+(~((W-4+(-N|0)|0)>>>2)<<2)}Lw(O)}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if((a[A]&1)!=0){Lw(c[n+8>>2]|0)}if((a[C]&1)!=0){Lw(c[o+8>>2]|0)}O=c[x>>2]|0;if((O|0)==(c[b+52>>2]|0)){z=0;as(6,w|0,l|0);if(z){z=0;B=89;break L1}}else{if((O|0)==0){X=0}else{c[O>>2]=L;X=c[x>>2]|0}c[x>>2]=X+4}L=c[I>>2]|0;O=(z=0,au(248,36)|0);if(z){z=0;B=89;break L1}N=O;c[j>>2]=N;O=L+4|0;W=c[O>>2]|0;if((W|0)==(c[L+8>>2]|0)){z=0;as(382,L|0,j|0);if(z){z=0;B=89;break L1}Y=c[j>>2]|0}else{if((W|0)==0){Z=0}else{c[W>>2]=N;Z=c[O>>2]|0}c[O>>2]=Z+4;Y=N}N=Y;W=d+4|0;L89:do{if((a[W]&1)==0){R=r;c[R>>2]=c[W>>2];c[R+4>>2]=c[W+4>>2];c[R+8>>2]=c[W+8>>2];B=69}else{R=c[d+12>>2]|0;Q=c[d+8>>2]|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Q>>>0<11>>>0){a[r]=Q<<1;_=r+1|0}else{$=Q+16&-16;aa=(z=0,au(248,$|0)|0);if(z){z=0;break}c[r+8>>2]=aa;c[r>>2]=$|1;c[r+4>>2]=Q;_=aa}LF(_|0,R|0,Q)|0;a[_+Q|0]=0;B=69;break L89}}while(0);Q=bT(-1,-1)|0;ab=Q;ac=M}}while(0);do{if((B|0)==69){W=s;Q=d+16|0;c[W>>2]=c[Q>>2];c[W+4>>2]=c[Q+4>>2];c[W+8>>2]=c[Q+8>>2];Q=c[l>>2]|0;R=c[d+28>>2]|0;aa=(z=0,aM(c[(c[R>>2]|0)+16>>2]|0,R|0,b|0)|0);do{if(!z){R=(z=0,au(c[(c[aa>>2]|0)+40>>2]|0,aa|0)|0);if(z){z=0;B=106;break}$=h;c[$>>2]=c[W>>2];c[$+4>>2]=c[W+4>>2];c[$+8>>2]=c[W+8>>2];ad=f;ae=g;af=Y;ag=r;ah=a[ag]|0;ai=(ah&1)==0;if(ai){c[ad>>2]=c[ag>>2];c[ad+4>>2]=c[ag+4>>2];c[ad+8>>2]=c[ag+8>>2]}else{ag=c[r+8>>2]|0;aj=c[r+4>>2]|0;if(aj>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;B=106;break}return 0}if(aj>>>0<11>>>0){a[ad]=aj<<1;ak=f+1|0}else{al=aj+16&-16;am=(z=0,au(248,al|0)|0);if(z){z=0;B=106;break}c[f+8>>2]=am;c[f>>2]=al|1;c[f+4>>2]=aj;ak=am}LF(ak|0,ag|0,aj)|0;a[ak+aj|0]=0}c[ae>>2]=c[$>>2];c[ae+4>>2]=c[$+4>>2];c[ae+8>>2]=c[$+8>>2];z=0;aV(6,af|0,f|0,g|0,R|0);if(z){z=0;R=bT(-1,-1)|0;af=M;if((a[ad]&1)==0){an=af;ao=R;ap=ah;break}Lw(c[f+8>>2]|0);an=af;ao=R;ap=ah;break}if((a[ad]&1)!=0){Lw(c[f+8>>2]|0)}c[Y>>2]=17704;c[Y+32>>2]=Q;if(ai){av=c[x>>2]|0;aw=av-4|0;c[x>>2]=aw;ax=Y;Bx(k);i=e;return ax|0}Lw(c[r+8>>2]|0);av=c[x>>2]|0;aw=av-4|0;c[x>>2]=aw;ax=Y;Bx(k);i=e;return ax|0}else{z=0;B=106}}while(0);if((B|0)==106){Q=bT(-1,-1)|0;an=M;ao=Q;ap=a[r]|0}Q=ao;W=an;if((ap&1)==0){ab=Q;ac=W;break}Lw(c[r+8>>2]|0);ab=Q;ac=W}}while(0);W=c[L>>2]|0;Q=c[O>>2]|0;aa=W;while(1){if((aa|0)==(Q|0)){ay=Q;break}if((c[aa>>2]|0)==(Y|0)){ay=aa;break}else{aa=aa+4|0}}aa=ay-W>>2;L=W+(aa+1<<2)|0;ai=Q-L|0;LG(W+(aa<<2)|0,L|0,ai|0)|0;L=W+((ai>>2)+aa<<2)|0;aa=c[O>>2]|0;if((L|0)!=(aa|0)){c[O>>2]=aa+(~((aa-4+(-L|0)|0)>>>2)<<2)}Lw(N);aA=ab;aB=ac;break L1}else{z=0;L=bT(-1,-1)|0;U=L;V=M}}while(0);if((a[p]&1)==0){S=U;T=V;break}Lw(c[p+8>>2]|0);S=U;T=V}}while(0);if((a[A]&1)==0){aC=S;aD=T;break}Lw(c[n+8>>2]|0);aC=S;aD=T}}while(0);if((B|0)==18){D=bT(-1,-1)|0;I=M;if((a[A]&1)!=0){Lw(c[n+8>>2]|0)}aC=D;aD=I}if((a[C]&1)==0){aA=aC;aB=aD;break}Lw(c[o+8>>2]|0);aA=aC;aB=aD}else{z=0;B=89}}while(0);if((B|0)==89){B=bT(-1,-1)|0;aA=B;aB=M}z=0;ar(444,k|0);if(!z){bg(aA|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function lX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0;e=i;i=i+176|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+48|0;m=e+56|0;n=e+64|0;o=e+80|0;p=e+88|0;q=e+96|0;r=e+112|0;s=e+128|0;t=e+144|0;u=e+160|0;v=b+32|0;w=c[d+32>>2]|0;c[p>>2]=w;x=b+36|0;y=c[x>>2]|0;if((y|0)==(c[b+40>>2]|0)){m4(v,p)}else{if((y|0)==0){A=0}else{c[y>>2]=w;A=c[x>>2]|0}c[x>>2]=A+4}A=c[d+28>>2]|0;w=cV[c[(c[A>>2]|0)+16>>2]&1023](A,b|0)|0;A=cD[c[(c[w>>2]|0)+40>>2]&511](w)|0;w=c[(c[b+24>>2]|0)-4>>2]|0;y=A+32|0;p=c[y>>2]|0;B=(c[A+36>>2]|0)-p>>2;if((B|0)==0){C=c[x>>2]|0;D=C-4|0;c[x>>2]=D;i=e;return 0}A=b+4|0;E=d+4|0;F=q;G=d+16|0;H=v|0;v=w+28|0;I=w+36|0;J=w+40|0;K=w+32|0;w=v;L=r;N=r+8|0;O=d+12|0;P=d+8|0;d=r+1|0;Q=r|0;R=r+4|0;S=q+8|0;T=q+1|0;U=q|0;V=q+4|0;W=s+8|0;X=s|0;Y=s+4|0;Z=t;_=u;$=b+56|0;b=s;aa=t+8|0;ab=t+1|0;ac=t|0;ad=t+4|0;ae=0;af=p;L11:while(1){p=c[af+(ae<<2)>>2]|0;if((p|0)==0){ag=9;break}do{if((c[(c[(c[p>>2]|0)-4>>2]|0)+4>>2]|0)==28552){ah=c[A>>2]|0;ai=Lu(60)|0;c[o>>2]=ai;aj=ah+4|0;ak=c[aj>>2]|0;if((ak|0)==(c[ah+8>>2]|0)){e4(ah|0,o);al=c[o>>2]|0}else{if((ak|0)==0){am=0}else{c[ak>>2]=ai;am=c[aj>>2]|0}c[aj>>2]=am+4;al=ai}an=al;if((a[E]&1)==0){c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2]}else{ai=c[O>>2]|0;ak=c[P>>2]|0;if(ak>>>0>4294967279>>>0){ag=19;break L11}if(ak>>>0<11>>>0){a[F]=ak<<1;ao=T}else{ap=ak+16&-16;at=(z=0,au(248,ap|0)|0);if(z){z=0;ag=67;break L11}c[S>>2]=at;c[U>>2]=ap|1;c[V>>2]=ak;ao=at}LF(ao|0,ai|0,ak)|0;a[ao+ak|0]=0}ak=n;c[ak>>2]=c[G>>2];c[ak+4>>2]=c[G+4>>2];c[ak+8>>2]=c[G+8>>2];z=0;aD(2,al|0,q|0,n|0,0,0,0);if(z){z=0;ag=70;break L11}if((a[F]&1)!=0){Lw(c[S>>2]|0)}ak=c[x>>2]|0;ai=al+40|0;at=ai;do{if((c[H>>2]|0)==(ak|0)){ap=c[p+28>>2]|0;c[g>>2]=ap;av=ai+8|0;aw=c[av>>2]|0;ax=aw;if((aw|0)==(c[ai+12>>2]|0)){fq(ai+4|0,g);ay=c[g>>2]|0}else{if((aw|0)==0){az=0}else{c[ax>>2]=ap;az=c[av>>2]|0}c[av>>2]=az+4;ay=ap}cB[c[c[ai>>2]>>2]&1023](at,ay)}else{ap=c[ak-4>>2]|0;c[m>>2]=ap;av=ai+8|0;ax=c[av>>2]|0;aw=ax;aA=ai+12|0;if((ax|0)==(c[aA>>2]|0)){fq(ai+4|0,m);aB=c[m>>2]|0}else{if((ax|0)==0){aC=0}else{c[aw>>2]=ap;aC=c[av>>2]|0}c[av>>2]=aC+4;aB=ap}cB[c[c[ai>>2]>>2]&1023](at,aB);aE=c[A>>2]|0;ap=Lu(52)|0;c[l>>2]=ap;aF=aE+4|0;aw=c[aF>>2]|0;if((aw|0)==(c[aE+8>>2]|0)){e4(aE|0,l);aG=c[l>>2]|0}else{if((aw|0)==0){aH=0}else{c[aw>>2]=ap;aH=c[aF>>2]|0}c[aF>>2]=aH+4;aG=ap}aI=aG;if((a[E]&1)==0){c[L>>2]=c[E>>2];c[L+4>>2]=c[E+4>>2];c[L+8>>2]=c[E+8>>2]}else{ap=c[O>>2]|0;aw=c[P>>2]|0;if(aw>>>0>4294967279>>>0){ag=43;break L11}if(aw>>>0<11>>>0){a[L]=aw<<1;aJ=d}else{ax=aw+16&-16;aK=(z=0,au(248,ax|0)|0);if(z){z=0;ag=78;break L11}c[N>>2]=aK;c[Q>>2]=ax|1;c[R>>2]=aw;aJ=aK}LF(aJ|0,ap|0,aw)|0;a[aJ+aw|0]=0}aw=k;c[aw>>2]=c[G>>2];c[aw+4>>2]=c[G+4>>2];c[aw+8>>2]=c[G+8>>2];z=0;aq(38,aG|0,r|0,k|0,11672,0);if(z){z=0;aL=1;ag=81;break L11}aw=aG;c[j>>2]=aw;ap=c[av>>2]|0;aK=ap;if((ap|0)==(c[aA>>2]|0)){z=0;as(376,ai+4|0,j|0);if(z){z=0;aL=0;ag=81;break L11}aM=c[j>>2]|0}else{if((ap|0)==0){aN=0}else{c[aK>>2]=aw;aN=c[av>>2]|0}c[av>>2]=aN+4;aM=aw}z=0;as(c[c[ai>>2]>>2]|0,at|0,aM|0);if(z){z=0;aL=0;ag=81;break L11}aw=c[p+28>>2]|0;c[h>>2]=aw;aK=c[av>>2]|0;ap=aK;if((aK|0)==(c[aA>>2]|0)){z=0;as(376,ai+4|0,h|0);if(z){z=0;aL=0;ag=81;break L11}aO=c[h>>2]|0}else{if((aK|0)==0){aP=0}else{c[ap>>2]=aw;aP=c[av>>2]|0}c[av>>2]=aP+4;aO=aw}z=0;as(c[c[ai>>2]>>2]|0,at|0,aO|0);if(z){z=0;aL=0;ag=81;break L11}if((a[L]&1)==0){break}Lw(c[N>>2]|0)}}while(0);c[p+28>>2]=al;c[f>>2]=p;at=c[I>>2]|0;if((at|0)==(c[J>>2]|0)){m3(K,f);aQ=c[f>>2]|0}else{if((at|0)==0){aR=0}else{c[at>>2]=p;aR=c[I>>2]|0}c[I>>2]=aR+4;aQ=p}cB[c[c[w>>2]>>2]&1023](v,aQ)}else{at=Lu(80)|0;c[W>>2]=at;c[X>>2]=81;c[Y>>2]=72;LF(at|0,9224,72)|0;a[at+72|0]=0;at=p+4|0;if((a[at]&1)==0){c[Z>>2]=c[at>>2];c[Z+4>>2]=c[at+4>>2];c[Z+8>>2]=c[at+8>>2]}else{at=c[p+12>>2]|0;ai=c[p+8>>2]|0;if(ai>>>0>4294967279>>>0){ag=105;break L11}if(ai>>>0<11>>>0){a[Z]=ai<<1;aS=ab}else{ak=ai+16&-16;aw=(z=0,au(248,ak|0)|0);if(z){z=0;ag=117;break L11}c[aa>>2]=aw;c[ac>>2]=ak|1;c[ad>>2]=ai;aS=aw}LF(aS|0,at|0,ai)|0;a[aS+ai|0]=0}ai=p+16|0;c[_>>2]=c[ai>>2];c[_+4>>2]=c[ai+4>>2];c[_+8>>2]=c[ai+8>>2];z=0;aV(46,s|0,t|0,u|0,c[$>>2]|0);if(z){z=0;ag=120;break L11}if((a[Z]&1)!=0){Lw(c[aa>>2]|0)}if((a[b]&1)==0){break}Lw(c[W>>2]|0)}}while(0);p=ae+1|0;if(p>>>0>=B>>>0){ag=128;break}ae=p;af=c[y>>2]|0}do{if((ag|0)==117){y=bT(-1,-1)|0;aT=M;aU=y;ag=119}else if((ag|0)==70){y=bT(-1,-1)|0;af=y;y=M;if((a[F]&1)==0){aW=y;aX=af;ag=72;break}Lw(c[S>>2]|0);aW=y;aX=af;ag=72}else if((ag|0)==120){af=bT(-1,-1)|0;y=af;af=M;if((a[Z]&1)==0){aY=af;aZ=y;ag=122;break}Lw(c[aa>>2]|0);aY=af;aZ=y;ag=122}else if((ag|0)==105){z=0;ar(86,0);if(!z){return 0}else{z=0;y=bT(-1,-1)|0;aT=M;aU=y;ag=119;break}}else if((ag|0)==78){y=bT(-1,-1)|0;a_=M;a$=y;ag=80}else if((ag|0)==9){cj();return 0}else if((ag|0)==67){y=bT(-1,-1)|0;a0=M;a1=y;ag=69}else if((ag|0)==81){y=bT(-1,-1)|0;af=y;y=M;if((a[L]&1)==0){if(aL){a2=af;a3=y;ag=84;break}else{a4=y;a5=af}a6=a5;a7=0;a8=a6;a9=a4;bg(a8|0)}else{Lw(c[N>>2]|0);if(aL){a2=af;a3=y;ag=84;break}else{a4=y;a5=af}a6=a5;a7=0;a8=a6;a9=a4;bg(a8|0)}}else if((ag|0)==43){z=0;ar(86,0);if(!z){return 0}else{z=0;af=bT(-1,-1)|0;a_=M;a$=af;ag=80;break}}else if((ag|0)==19){z=0;ar(86,0);if(!z){return 0}else{z=0;af=bT(-1,-1)|0;a0=M;a1=af;ag=69;break}}else if((ag|0)==128){C=c[x>>2]|0;D=C-4|0;c[x>>2]=D;i=e;return 0}}while(0);if((ag|0)==119){aY=aT;aZ=aU;ag=122}else if((ag|0)==80){a2=a$;a3=a_;ag=84}else if((ag|0)==69){aW=a0;aX=a1;ag=72}if((ag|0)==72){a1=c[ah>>2]|0;ah=c[aj>>2]|0;a0=a1;while(1){if((a0|0)==(ah|0)){ba=ah;break}if((c[a0>>2]|0)==(al|0)){ba=a0;break}else{a0=a0+4|0}}a0=ba-a1>>2;ba=a1+(a0+1<<2)|0;al=ah-ba|0;LG(a1+(a0<<2)|0,ba|0,al|0)|0;ba=a1+((al>>2)+a0<<2)|0;a0=c[aj>>2]|0;if((ba|0)!=(a0|0)){c[aj>>2]=a0+(~((a0-4+(-ba|0)|0)>>>2)<<2)}Lw(an);a4=aW;a5=aX;a6=a5;a7=0;a8=a6;a9=a4;bg(a8|0)}else if((ag|0)==84){aX=c[aE>>2]|0;aE=c[aF>>2]|0;aW=aX;while(1){if((aW|0)==(aE|0)){bb=aE;break}if((c[aW>>2]|0)==(aG|0)){bb=aW;break}else{aW=aW+4|0}}aW=bb-aX>>2;bb=aX+(aW+1<<2)|0;aG=aE-bb|0;LG(aX+(aW<<2)|0,bb|0,aG|0)|0;bb=aX+((aG>>2)+aW<<2)|0;aW=c[aF>>2]|0;if((bb|0)!=(aW|0)){c[aF>>2]=aW+(~((aW-4+(-bb|0)|0)>>>2)<<2)}Lw(aI);a4=a3;a5=a2;a6=a5;a7=0;a8=a6;a9=a4;bg(a8|0)}else if((ag|0)==122){if((a[b]&1)==0){a4=aY;a5=aZ;a6=a5;a7=0;a8=a6;a9=a4;bg(a8|0)}Lw(c[W>>2]|0);a4=aY;a5=aZ;a6=a5;a7=0;a8=a6;a9=a4;bg(a8|0)}return 0}function lY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;i=i+88|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+72|0;m=c[d+32>>2]|0;n=c[(c[m>>2]|0)+20>>2]|0;o=iX(c[b+8>>2]|0,c[b+16>>2]|0,c[b+56>>2]|0)|0;p=cV[n&1023](m,o)|0;o=c[b+4>>2]|0;m=Lu(40)|0;c[j>>2]=m;n=o+4|0;q=c[n>>2]|0;if((q|0)==(c[o+8>>2]|0)){e4(o|0,j);r=c[j>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=m;s=c[n>>2]|0}c[n>>2]=s+4;r=m}m=r;s=d+4|0;L8:do{if((a[s]&1)==0){q=k;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];t=16}else{q=c[d+12>>2]|0;j=c[d+8>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[k]=j<<1;u=k+1|0}else{v=j+16&-16;w=(z=0,au(248,v|0)|0);if(z){z=0;break}c[k+8>>2]=w;c[k>>2]=v|1;c[k+4>>2]=j;u=w}LF(u|0,q|0,j)|0;a[u+j|0]=0;t=16;break L8}}while(0);j=bT(-1,-1)|0;x=M;y=j}}while(0);do{if((t|0)==16){u=l;s=d+16|0;c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];s=c[d+28>>2]|0;j=(z=0,aM(c[(c[s>>2]|0)+16>>2]|0,s|0,b|0)|0);do{if(!z){s=(z=0,au(c[(c[j>>2]|0)+40>>2]|0,j|0)|0);if(z){z=0;t=37;break}q=h;c[q>>2]=c[u>>2];c[q+4>>2]=c[u+4>>2];c[q+8>>2]=c[u+8>>2];w=f;v=g;A=r;B=k;C=a[B]|0;D=(C&1)==0;if(D){c[w>>2]=c[B>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]}else{B=c[k+8>>2]|0;E=c[k+4>>2]|0;if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=37;break}return 0}if(E>>>0<11>>>0){a[w]=E<<1;F=f+1|0}else{G=E+16&-16;H=(z=0,au(248,G|0)|0);if(z){z=0;t=37;break}c[f+8>>2]=H;c[f>>2]=G|1;c[f+4>>2]=E;F=H}LF(F|0,B|0,E)|0;a[F+E|0]=0}c[v>>2]=c[q>>2];c[v+4>>2]=c[q+4>>2];c[v+8>>2]=c[q+8>>2];z=0;aV(6,A|0,f|0,g|0,s|0);if(z){z=0;s=bT(-1,-1)|0;A=M;if((a[w]&1)==0){I=A;J=s;K=C;break}Lw(c[f+8>>2]|0);I=A;J=s;K=C;break}if((a[w]&1)!=0){Lw(c[f+8>>2]|0)}c[r>>2]=22288;c[r+32>>2]=p;w=r+36|0;c[w>>2]=0;if(D){L=b+48|0;N=c[L>>2]|0;O=N-4|0;P=c[O>>2]|0;Q=P;c[w>>2]=Q;R=r;i=e;return R|0}Lw(c[k+8>>2]|0);L=b+48|0;N=c[L>>2]|0;O=N-4|0;P=c[O>>2]|0;Q=P;c[w>>2]=Q;R=r;i=e;return R|0}else{z=0;t=37}}while(0);if((t|0)==37){u=bT(-1,-1)|0;I=M;J=u;K=a[k]|0}u=J;j=I;if((K&1)==0){x=j;y=u;break}Lw(c[k+8>>2]|0);x=j;y=u}}while(0);k=c[o>>2]|0;o=c[n>>2]|0;K=k;while(1){if((K|0)==(o|0)){S=o;break}if((c[K>>2]|0)==(r|0)){S=K;break}else{K=K+4|0}}K=S-k>>2;S=k+(K+1<<2)|0;r=o-S|0;LG(k+(K<<2)|0,S|0,r|0)|0;S=k+((r>>2)+K<<2)|0;K=c[n>>2]|0;if((S|0)==(K|0)){Lw(m);T=y;U=0;V=T;W=x;bg(V|0)}c[n>>2]=K+(~((K-4+(-S|0)|0)>>>2)<<2);Lw(m);T=y;U=0;V=T;W=x;bg(V|0);return 0}function lZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+64|0;m=c[d+28>>2]|0;c[h>>2]=0;n=b+48|0;o=c[n>>2]|0;if((o|0)==(c[b+52>>2]|0)){m6(b+44|0,h)}else{if((o|0)==0){p=0}else{c[o>>2]=0;p=c[n>>2]|0}c[n>>2]=p+4}p=c[d+44>>2]|0;o=c[d+48>>2]|0;do{if((p|0)==0){if((o|0)==0){q=0;r=0;break}h=c[(c[o>>2]|0)+20>>2]|0;s=iX(c[b+8>>2]|0,c[b+16>>2]|0,c[b+56>>2]|0)|0;q=0;r=cV[h&1023](o|0,s)|0}else{s=c[(c[p>>2]|0)+24>>2]|0;h=hn(c[b+12>>2]|0,0,c[b+16>>2]|0,c[b+56>>2]|0,0,0)|0;q=cV[s&1023](p|0,h)|0;r=o}}while(0);if((m|0)==0){t=0}else{o=cV[c[(c[m>>2]|0)+16>>2]&1023](m,b|0)|0;t=cD[c[(c[o>>2]|0)+40>>2]&511](o)|0}o=c[b+4>>2]|0;b=Lu(52)|0;c[g>>2]=b;m=o+4|0;p=c[m>>2]|0;if((p|0)==(c[o+8>>2]|0)){e4(o|0,g);u=c[g>>2]|0}else{if((p|0)==0){v=0}else{c[p>>2]=b;v=c[m>>2]|0}c[m>>2]=v+4;u=b}b=u;v=u;p=d+4|0;L23:do{if((a[p]&1)==0){g=j;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];w=27}else{g=c[d+12>>2]|0;h=c[d+8>>2]|0;do{if(h>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;x=j+1|0}else{s=h+16&-16;y=(z=0,au(248,s|0)|0);if(z){z=0;break}c[j+8>>2]=y;c[j>>2]=s|1;c[j+4>>2]=h;x=y}LF(x|0,g|0,h)|0;a[x+h|0]=0;w=27;break L23}}while(0);h=bT(-1,-1)|0;A=M;B=h}}while(0);do{if((w|0)==27){x=k;p=d+16|0;c[x>>2]=c[p>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];p=d+32|0;L38:do{if((a[p]&1)==0){h=l;c[h>>2]=c[p>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];w=37}else{h=c[d+40>>2]|0;g=c[d+36>>2]|0;do{if(g>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(g>>>0<11>>>0){a[l]=g<<1;C=l+1|0}else{y=g+16&-16;s=(z=0,au(248,y|0)|0);if(z){z=0;break}c[l+8>>2]=s;c[l>>2]=y|1;c[l+4>>2]=g;C=s}LF(C|0,h|0,g)|0;a[C+g|0]=0;w=37;break L38}}while(0);g=bT(-1,-1)|0;D=M;E=g}}while(0);do{if((w|0)==37){p=f;c[p>>2]=c[x>>2];c[p+4>>2]=c[x+4>>2];c[p+8>>2]=c[x+8>>2];z=0;aD(10,v|0,j|0,f|0,l|0,q|0,t|0);if(z){z=0;p=bT(-1,-1)|0;g=p;p=M;if((a[l]&1)==0){D=p;E=g;break}Lw(c[l+8>>2]|0);D=p;E=g;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}if((r|0)==0){F=c[n>>2]|0;G=F-4|0;c[n>>2]=G;H=u;i=e;return H|0}c[u+48>>2]=r;F=c[n>>2]|0;G=F-4|0;c[n>>2]=G;H=u;i=e;return H|0}}while(0);if((a[j]&1)==0){A=D;B=E;break}Lw(c[j+8>>2]|0);A=D;B=E}}while(0);E=c[o>>2]|0;o=c[m>>2]|0;D=E;while(1){if((D|0)==(o|0)){I=o;break}if((c[D>>2]|0)==(u|0)){I=D;break}else{D=D+4|0}}D=I-E>>2;I=E+(D+1<<2)|0;u=o-I|0;LG(E+(D<<2)|0,I|0,u|0)|0;I=E+((u>>2)+D<<2)|0;D=c[m>>2]|0;if((I|0)==(D|0)){Lw(b);J=B;K=0;L=J;N=A;bg(L|0)}c[m>>2]=D+(~((D-4+(-I|0)|0)>>>2)<<2);Lw(b);J=B;K=0;L=J;N=A;bg(L|0);return 0}function l_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+88|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+72|0;m=c[d+28>>2]|0;n=c[(c[m>>2]|0)+20>>2]|0;o=b+8|0;p=b+16|0;q=b+56|0;r=iX(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;s=cV[n&1023](m,r)|0;r=c[b+4>>2]|0;b=Lu(40)|0;c[j>>2]=b;m=r+4|0;n=c[m>>2]|0;if((n|0)==(c[r+8>>2]|0)){e4(r|0,j);t=c[j>>2]|0}else{if((n|0)==0){u=0}else{c[n>>2]=b;u=c[m>>2]|0}c[m>>2]=u+4;t=b}b=t;u=d+4|0;L8:do{if((a[u]&1)==0){n=k;c[n>>2]=c[u>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];v=16}else{n=c[d+12>>2]|0;j=c[d+8>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[k]=j<<1;w=k+1|0}else{x=j+16&-16;y=(z=0,au(248,x|0)|0);if(z){z=0;break}c[k+8>>2]=y;c[k>>2]=x|1;c[k+4>>2]=j;w=y}LF(w|0,n|0,j)|0;a[w+j|0]=0;v=16;break L8}}while(0);j=bT(-1,-1)|0;A=M;B=j}}while(0);do{if((v|0)==16){w=l;u=d+16|0;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];u=c[d+32>>2]|0;j=c[(c[u>>2]|0)+20>>2]|0;n=(z=0,az(46,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0);do{if(!z){y=(z=0,aM(j|0,u|0,n|0)|0);if(z){z=0;v=37;break}x=a[d+36|0]&1;C=h;c[C>>2]=c[w>>2];c[C+4>>2]=c[w+4>>2];c[C+8>>2]=c[w+8>>2];D=f;E=g;F=t;G=k;H=a[G]|0;I=(H&1)==0;if(I){c[D>>2]=c[G>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2]}else{G=c[k+8>>2]|0;J=c[k+4>>2]|0;if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;v=37;break}return 0}if(J>>>0<11>>>0){a[D]=J<<1;K=f+1|0}else{L=J+16&-16;N=(z=0,au(248,L|0)|0);if(z){z=0;v=37;break}c[f+8>>2]=N;c[f>>2]=L|1;c[f+4>>2]=J;K=N}LF(K|0,G|0,J)|0;a[K+J|0]=0}c[E>>2]=c[C>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];z=0;aR(424,F|0,f|0,g|0);if(z){z=0;C=bT(-1,-1)|0;E=M;if((a[D]&1)==0){O=E;P=C;Q=H;break}Lw(c[f+8>>2]|0);O=E;P=C;Q=H;break}if((a[D]&1)!=0){Lw(c[f+8>>2]|0)}c[t>>2]=22416;c[t+28>>2]=s;c[t+32>>2]=y;a[t+36|0]=x;if(I){i=e;return F|0}Lw(c[k+8>>2]|0);i=e;return F|0}else{z=0;v=37}}while(0);if((v|0)==37){w=bT(-1,-1)|0;O=M;P=w;Q=a[k]|0}w=P;n=O;if((Q&1)==0){A=n;B=w;break}Lw(c[k+8>>2]|0);A=n;B=w}}while(0);k=c[r>>2]|0;r=c[m>>2]|0;Q=k;while(1){if((Q|0)==(r|0)){R=r;break}if((c[Q>>2]|0)==(t|0)){R=Q;break}else{Q=Q+4|0}}Q=R-k>>2;R=k+(Q+1<<2)|0;t=r-R|0;LG(k+(Q<<2)|0,R|0,t|0)|0;R=k+((t>>2)+Q<<2)|0;Q=c[m>>2]|0;if((R|0)==(Q|0)){Lw(b);S=B;T=0;U=S;V=A;bg(U|0)}c[m>>2]=Q+(~((Q-4+(-R|0)|0)>>>2)<<2);Lw(b);S=B;T=0;U=S;V=A;bg(U|0);return 0}function l$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+28|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+36>>2]|0;j=c[d+32>>2]|0;if(j>>>0>4294967279>>>0){D5(0);return 0}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=Lu(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}LF(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+16|0;q=c[r>>2]|0;do{if((l&1)==0){j=g;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];t=19}else{j=c[f+8>>2]|0;p=c[f+4>>2]|0;if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=39;break}return 0}if(p>>>0<11>>>0){a[g]=p<<1;u=g+1|0}else{k=p+16&-16;s=(z=0,au(248,k|0)|0);if(z){z=0;t=39;break}c[g+8>>2]=s;c[g>>2]=k|1;c[g+4>>2]=p;u=s}LF(u|0,j|0,p)|0;a[u+p|0]=0;t=19}}while(0);L24:do{if((t|0)==19){u=(z=0,aM(560,q|0,g|0)|0);if(z){z=0;l=bT(-1,-1)|0;p=l;l=M;if((a[g]&1)==0){v=p;w=l;break}Lw(c[g+8>>2]|0);v=p;w=l;break}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}do{if(u){if((a[d+44|0]&1)!=0){break}l=c[d+40>>2]|0;p=c[(c[l>>2]|0)+20>>2]|0;j=(z=0,az(46,c[b+8>>2]|0,c[r>>2]|0,c[b+56>>2]|0)|0);if(z){z=0;t=39;break L24}s=(z=0,aM(p|0,l|0,j|0)|0);if(z){z=0;t=39;break L24}j=s|0;s=c[r>>2]|0;if((a[m]&1)==0){l=h;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2]}else{l=c[f+8>>2]|0;p=c[f+4>>2]|0;if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=39;break L24}return 0}if(p>>>0<11>>>0){a[h]=p<<1;x=h+1|0}else{k=p+16&-16;n=(z=0,au(248,k|0)|0);if(z){z=0;t=39;break L24}c[h+8>>2]=n;c[h>>2]=k|1;c[h+4>>2]=p;x=n}LF(x|0,l|0,p)|0;a[x+p|0]=0}p=(z=0,aM(90,s|0,h|0)|0);if(!z){c[p>>2]=j;if((a[h]&1)==0){break}Lw(c[h+8>>2]|0);break}else{z=0;j=bT(-1,-1)|0;p=j;j=M;if((a[h]&1)==0){v=p;w=j;break L24}Lw(c[h+8>>2]|0);v=p;w=j;break L24}}else{j=c[d+40>>2]|0;p=c[(c[j>>2]|0)+20>>2]|0;s=(z=0,az(46,c[b+8>>2]|0,c[r>>2]|0,c[b+56>>2]|0)|0);if(z){z=0;t=39;break L24}l=(z=0,aM(p|0,j|0,s|0)|0);if(z){z=0;t=39;break L24}s=(z=0,aM(178,c[r>>2]|0,f|0)|0);if(z){z=0;t=39;break L24}c[s>>2]=l}}while(0);if((a[m]&1)==0){i=e;return 0}Lw(c[f+8>>2]|0);i=e;return 0}}while(0);if((t|0)==39){t=bT(-1,-1)|0;v=t;w=M}if((a[m]&1)==0){y=v;A=0;B=y;C=w;bg(B|0)}Lw(c[f+8>>2]|0);y=v;A=0;B=y;C=w;bg(B|0);return 0}function l0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+24|0;j=e+40|0;k=c[b+4>>2]|0;l=Lu(52)|0;c[g>>2]=l;m=k+4|0;n=c[m>>2]|0;if((n|0)==(c[k+8>>2]|0)){e4(k|0,g);o=c[g>>2]|0}else{if((n|0)==0){p=0}else{c[n>>2]=l;p=c[m>>2]|0}c[m>>2]=p+4;o=l}l=o;p=o;n=d+4|0;L8:do{if((a[n]&1)==0){g=h;c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];q=16}else{g=c[d+12>>2]|0;r=c[d+8>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(r>>>0<11>>>0){a[h]=r<<1;s=h+1|0}else{t=r+16&-16;u=(z=0,au(248,t|0)|0);if(z){z=0;break}c[h+8>>2]=u;c[h>>2]=t|1;c[h+4>>2]=r;s=u}LF(s|0,g|0,r)|0;a[s+r|0]=0;q=16;break L8}}while(0);r=bT(-1,-1)|0;v=r;w=M}}while(0);do{if((q|0)==16){s=d+16|0;n=f;c[n>>2]=c[s>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];z=0;aR(214,p|0,h|0,f|0);if(z){z=0;s=bT(-1,-1)|0;n=s;s=M;if((a[h]&1)==0){v=n;w=s;break}Lw(c[h+8>>2]|0);v=n;w=s;break}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}s=d+40|0;n=c[s>>2]|0;r=(c[d+44>>2]|0)-n>>2;if((r|0)==0){x=o;i=e;return x|0}g=o+40|0;u=b+8|0;t=b+16|0;y=b+56|0;A=g+4|0;B=g+8|0;C=g;g=0;D=n;while(1){n=c[D+(g<<2)>>2]|0;E=c[(c[n>>2]|0)+20>>2]|0;F=iX(c[u>>2]|0,c[t>>2]|0,c[y>>2]|0)|0;G=cV[E&1023](n|0,F)|0;c[j>>2]=G;F=c[A>>2]|0;n=F;if((F|0)==(c[B>>2]|0)){fq(C,j)}else{if((F|0)==0){H=0}else{c[n>>2]=G;H=c[A>>2]|0}c[A>>2]=H+4}G=g+1|0;if(G>>>0>=r>>>0){break}g=G;D=c[s>>2]|0}x=o;i=e;return x|0}}while(0);x=c[k>>2]|0;k=c[m>>2]|0;e=x;while(1){if((e|0)==(k|0)){I=k;break}if((c[e>>2]|0)==(o|0)){I=e;break}else{e=e+4|0}}e=I-x>>2;I=x+(e+1<<2)|0;o=k-I|0;LG(x+(e<<2)|0,I|0,o|0)|0;I=x+((o>>2)+e<<2)|0;e=c[m>>2]|0;if((I|0)==(e|0)){Lw(l);J=v;K=0;L=J;N=w;bg(L|0)}c[m>>2]=e+(~((e-4+(-I|0)|0)>>>2)<<2);Lw(l);J=v;K=0;L=J;N=w;bg(L|0);return 0}function l1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;e=i;i=i+24|0;f=e|0;g=e+8|0;h=(c[b+4>>2]|0)+52|0;j=d+28|0;if((a[j]&1)==0){k=g;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[d+36>>2]|0;k=c[d+32>>2]|0;if(k>>>0>4294967279>>>0){D5(0);return 0}if(k>>>0<11>>>0){a[g]=k<<1;l=g+1|0}else{d=k+16&-16;m=Lu(d)|0;c[g+8>>2]=m;c[g>>2]=d|1;c[g+4>>2]=k;l=m}LF(l|0,j|0,k)|0;a[l+k|0]=0}k=(z=0,aM(510,h|0,g|0)|0);L12:do{if(!z){h=c[k>>2]|0;l=c[(c[b+24>>2]|0)-4>>2]|0;j=h+32|0;m=c[j>>2]|0;d=(c[h+36>>2]|0)-m>>2;L15:do{if((d|0)!=0){h=b|0;n=l+28|0;o=l+36|0;p=l+40|0;q=l+32|0;r=n;s=0;t=m;while(1){u=c[t+(s<<2)>>2]|0;v=(z=0,aM(c[(c[u>>2]|0)+16>>2]|0,u|0,h|0)|0);if(z){z=0;break}if((v|0)!=0){c[f>>2]=v;u=c[o>>2]|0;if((u|0)==(c[p>>2]|0)){z=0;as(488,q|0,f|0);if(z){z=0;break}w=c[f>>2]|0}else{if((u|0)==0){x=0}else{c[u>>2]=v;x=c[o>>2]|0}c[o>>2]=x+4;w=v}z=0;as(c[c[r>>2]>>2]|0,n|0,w|0);if(z){z=0;break}}v=s+1|0;if(v>>>0>=d>>>0){break L15}s=v;t=c[j>>2]|0}t=bT(-1,-1)|0;y=M;A=t;break L12}}while(0);if((a[g]&1)==0){i=e;return 0}Lw(c[g+8>>2]|0);i=e;return 0}else{z=0;j=bT(-1,-1)|0;y=M;A=j}}while(0);if((a[g]&1)==0){bg(A|0)}Lw(c[g+8>>2]|0);bg(A|0);return 0}function l2(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[(c[b>>2]|0)+20>>2]|0;e=iX(c[a+8>>2]|0,c[a+16>>2]|0,c[a+56>>2]|0)|0;cV[d&1023](b,e)|0;return 0}function l3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+88|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+72|0;m=c[b+4>>2]|0;n=Lu(32)|0;c[j>>2]=n;o=m+4|0;p=c[o>>2]|0;if((p|0)==(c[m+8>>2]|0)){e4(m|0,j);q=c[j>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=n;r=c[o>>2]|0}c[o>>2]=r+4;q=n}n=q;r=d+4|0;L8:do{if((a[r]&1)==0){p=k;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];s=16}else{p=c[d+12>>2]|0;j=c[d+8>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[k]=j<<1;t=k+1|0}else{u=j+16&-16;v=(z=0,au(248,u|0)|0);if(z){z=0;break}c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=j;t=v}LF(t|0,p|0,j)|0;a[t+j|0]=0;s=16;break L8}}while(0);j=bT(-1,-1)|0;w=M;x=j}}while(0);do{if((s|0)==16){t=l;r=d+16|0;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];r=c[d+28>>2]|0;j=c[(c[r>>2]|0)+20>>2]|0;p=(z=0,az(46,c[b+8>>2]|0,c[b+16>>2]|0,c[b+56>>2]|0)|0);do{if(!z){v=(z=0,aM(j|0,r|0,p|0)|0);if(z){z=0;s=37;break}u=h;c[u>>2]=c[t>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];y=f;A=g;B=q;C=k;D=a[C]|0;E=(D&1)==0;if(E){c[y>>2]=c[C>>2];c[y+4>>2]=c[C+4>>2];c[y+8>>2]=c[C+8>>2]}else{C=c[k+8>>2]|0;F=c[k+4>>2]|0;if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;s=37;break}return 0}if(F>>>0<11>>>0){a[y]=F<<1;G=f+1|0}else{H=F+16&-16;I=(z=0,au(248,H|0)|0);if(z){z=0;s=37;break}c[f+8>>2]=I;c[f>>2]=H|1;c[f+4>>2]=F;G=I}LF(G|0,C|0,F)|0;a[G+F|0]=0}c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];z=0;aR(424,B|0,f|0,g|0);if(z){z=0;u=bT(-1,-1)|0;A=M;if((a[y]&1)==0){J=A;K=u;L=D;break}Lw(c[f+8>>2]|0);J=A;K=u;L=D;break}if((a[y]&1)!=0){Lw(c[f+8>>2]|0)}c[q>>2]=18128;c[q+28>>2]=v;if(E){i=e;return B|0}Lw(c[k+8>>2]|0);i=e;return B|0}else{z=0;s=37}}while(0);if((s|0)==37){t=bT(-1,-1)|0;J=M;K=t;L=a[k]|0}t=K;p=J;if((L&1)==0){w=p;x=t;break}Lw(c[k+8>>2]|0);w=p;x=t}}while(0);k=c[m>>2]|0;m=c[o>>2]|0;L=k;while(1){if((L|0)==(m|0)){N=m;break}if((c[L>>2]|0)==(q|0)){N=L;break}else{L=L+4|0}}L=N-k>>2;N=k+(L+1<<2)|0;q=m-N|0;LG(k+(L<<2)|0,N|0,q|0)|0;N=k+((q>>2)+L<<2)|0;L=c[o>>2]|0;if((N|0)==(L|0)){Lw(n);O=x;P=0;Q=O;R=w;bg(Q|0)}c[o>>2]=L+(~((L-4+(-N|0)|0)>>>2)<<2);Lw(n);O=x;P=0;Q=O;R=w;bg(Q|0);return 0}function l4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d|0;f=d+8|0;g=c[b+28>>2]|0;h=c[(c[g>>2]|0)+20>>2]|0;j=iX(c[a+8>>2]|0,c[a+16>>2]|0,c[a+56>>2]|0)|0;k=cV[h&1023](g|0,j)|0;if(cD[c[(c[k>>2]|0)+36>>2]&511](k)|0){k=c[b+32>>2]|0;j=c[(c[a+24>>2]|0)-4>>2]|0;g=k+32|0;h=c[g>>2]|0;l=(c[k+36>>2]|0)-h>>2;if((l|0)==0){i=d;return 0}k=a|0;m=j+28|0;n=j+36|0;o=j+40|0;p=j+32|0;j=m;q=0;r=h;while(1){h=c[r+(q<<2)>>2]|0;s=cV[c[(c[h>>2]|0)+16>>2]&1023](h|0,k)|0;if((s|0)!=0){c[e>>2]=s;h=c[n>>2]|0;if((h|0)==(c[o>>2]|0)){m3(p,e);t=c[e>>2]|0}else{if((h|0)==0){u=0}else{c[h>>2]=s;u=c[n>>2]|0}c[n>>2]=u+4;t=s}cB[c[c[j>>2]>>2]&1023](m,t)}s=q+1|0;if(s>>>0>=l>>>0){break}q=s;r=c[g>>2]|0}i=d;return 0}g=c[b+36>>2]|0;if((g|0)==0){i=d;return 0}b=c[(c[a+24>>2]|0)-4>>2]|0;r=g+32|0;q=c[r>>2]|0;l=(c[g+36>>2]|0)-q>>2;if((l|0)==0){i=d;return 0}g=a|0;a=b+28|0;t=b+36|0;m=b+40|0;j=b+32|0;b=a;u=0;n=q;while(1){q=c[n+(u<<2)>>2]|0;e=cV[c[(c[q>>2]|0)+16>>2]&1023](q|0,g)|0;if((e|0)!=0){c[f>>2]=e;q=c[t>>2]|0;if((q|0)==(c[m>>2]|0)){m3(j,f);v=c[f>>2]|0}else{if((q|0)==0){w=0}else{c[q>>2]=e;w=c[t>>2]|0}c[t>>2]=w+4;v=e}cB[c[c[b>>2]>>2]&1023](a,v)}e=u+1|0;if(e>>>0>=l>>>0){break}u=e;n=c[r>>2]|0}i=d;return 0}function l5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0.0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0;e=i;i=i+280|0;f=e|0;g=e+16|0;j=e+24|0;k=e+32|0;l=e+48|0;m=e+56|0;n=e+72|0;o=e+88|0;p=e+104|0;q=e+120|0;r=e+136|0;s=e+152|0;t=e+168|0;u=e+184|0;v=e+200|0;w=e+216|0;x=e+232|0;y=e+248|0;A=e+264|0;B=d+32|0;if((a[B]&1)==0){C=m;c[C>>2]=c[B>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2]}else{B=c[d+40>>2]|0;C=c[d+36>>2]|0;if(C>>>0>4294967279>>>0){D5(0);return 0}if(C>>>0<11>>>0){a[m]=C<<1;D=m+1|0}else{E=C+16&-16;F=Lu(E)|0;c[m+8>>2]=F;c[m>>2]=E|1;c[m+4>>2]=C;D=F}LF(D|0,B|0,C)|0;a[D+C|0]=0}C=c[d+44>>2]|0;D=c[(c[C>>2]|0)+20>>2]|0;B=b+8|0;F=b+16|0;E=b+56|0;G=(z=0,az(46,c[B>>2]|0,c[F>>2]|0,c[E>>2]|0)|0);L12:do{if(!z){H=(z=0,aM(D|0,C|0,G|0)|0);if(z){z=0;I=28;break}L15:do{if((c[H+32>>2]|0)!=2){J=(z=0,au(248,48)|0);if(z){z=0;I=28;break L12}K=n+8|0;c[K>>2]=J;c[n>>2]=49;c[n+4>>2]=47;LF(J|0,7400,47)|0;a[J+47|0]=0;J=H+4|0;L18:do{if((a[J]&1)==0){L=o;c[L>>2]=c[J>>2];c[L+4>>2]=c[J+4>>2];c[L+8>>2]=c[J+8>>2];I=23}else{L=c[H+12>>2]|0;N=c[H+8>>2]|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[o]=N<<1;O=o+1|0}else{P=N+16&-16;Q=(z=0,au(248,P|0)|0);if(z){z=0;break}c[o+8>>2]=Q;c[o>>2]=P|1;c[o+4>>2]=N;O=Q}LF(O|0,L|0,N)|0;a[O+N|0]=0;I=23;break L18}}while(0);N=bT(-1,-1)|0;R=N;S=M}}while(0);do{if((I|0)==23){J=p;N=H+16|0;c[J>>2]=c[N>>2];c[J+4>>2]=c[N+4>>2];c[J+8>>2]=c[N+8>>2];z=0;aV(46,n|0,o|0,p|0,c[E>>2]|0);if(z){z=0;N=bT(-1,-1)|0;J=N;N=M;if((a[o]&1)==0){R=J;S=N;break}Lw(c[o+8>>2]|0);R=J;S=N;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)==0){break L15}Lw(c[K>>2]|0);break L15}}while(0);if((a[n]&1)==0){T=R;U=S;break L12}Lw(c[K>>2]|0);T=R;U=S;break L12}}while(0);N=c[d+48>>2]|0;J=c[(c[N>>2]|0)+20>>2]|0;L=(z=0,az(46,c[B>>2]|0,c[F>>2]|0,c[E>>2]|0)|0);if(z){z=0;I=28;break}Q=(z=0,aM(J|0,N|0,L|0)|0);if(z){z=0;I=28;break}L46:do{if((c[Q+32>>2]|0)!=2){L=(z=0,au(248,48)|0);if(z){z=0;I=28;break L12}N=q+8|0;c[N>>2]=L;c[q>>2]=49;c[q+4>>2]=47;LF(L|0,5856,47)|0;a[L+47|0]=0;L=Q+4|0;L49:do{if((a[L]&1)==0){J=r;c[J>>2]=c[L>>2];c[J+4>>2]=c[L+4>>2];c[J+8>>2]=c[L+8>>2];I=48}else{J=c[Q+12>>2]|0;P=c[Q+8>>2]|0;do{if(P>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(P>>>0<11>>>0){a[r]=P<<1;V=r+1|0}else{W=P+16&-16;X=(z=0,au(248,W|0)|0);if(z){z=0;break}c[r+8>>2]=X;c[r>>2]=W|1;c[r+4>>2]=P;V=X}LF(V|0,J|0,P)|0;a[V+P|0]=0;I=48;break L49}}while(0);P=bT(-1,-1)|0;Y=P;Z=M}}while(0);do{if((I|0)==48){L=s;K=Q+16|0;c[L>>2]=c[K>>2];c[L+4>>2]=c[K+4>>2];c[L+8>>2]=c[K+8>>2];z=0;aV(46,q|0,r|0,s|0,c[E>>2]|0);if(z){z=0;K=bT(-1,-1)|0;L=K;K=M;if((a[r]&1)==0){Y=L;Z=K;break}Lw(c[r+8>>2]|0);Y=L;Z=K;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){break L46}Lw(c[N>>2]|0);break L46}}while(0);if((a[q]&1)==0){T=Y;U=Z;break L12}Lw(c[N>>2]|0);T=Y;U=Z;break L12}}while(0);_=+h[H+40>>3];$=+h[Q+40>>3];if((a[d+52|0]&1)==0){aa=$}else{aa=$+1.0}K=t+4|0;c[K>>2]=0;c[t+8>>2]=0;c[t>>2]=K;K=t+12|0;c[K>>2]=0;L=b+4|0;P=c[L>>2]|0;J=(z=0,au(248,72)|0);L78:do{if(!z){X=J;c[l>>2]=X;W=P+4|0;ab=c[W>>2]|0;if((ab|0)==(c[P+8>>2]|0)){z=0;as(382,P|0,l|0);if(z){z=0;I=148;break}ac=c[l>>2]|0}else{if((ab|0)==0){ad=0}else{c[ab>>2]=X;ad=c[W>>2]|0}c[W>>2]=ad+4;ac=X}X=ac;ab=ac;ae=H+4|0;L88:do{if((a[ae]&1)==0){af=u;c[af>>2]=c[ae>>2];c[af+4>>2]=c[ae+4>>2];c[af+8>>2]=c[ae+8>>2];I=77}else{af=c[H+12>>2]|0;ag=c[H+8>>2]|0;do{if(ag>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ag>>>0<11>>>0){a[u]=ag<<1;ah=u+1|0}else{ai=ag+16&-16;aj=(z=0,au(248,ai|0)|0);if(z){z=0;break}c[u+8>>2]=aj;c[u>>2]=ai|1;c[u+4>>2]=ag;ah=aj}LF(ah|0,af|0,ag)|0;a[ah+ag|0]=0;I=77;break L88}}while(0);ag=bT(-1,-1)|0;ak=M;al=ag}}while(0);do{if((I|0)==77){N=H+16|0;ag=k;c[ag>>2]=c[N>>2];c[ag+4>>2]=c[N+4>>2];c[ag+8>>2]=c[N+8>>2];ag=v;a[ag]=0;a[v+1|0]=0;z=0;aG(2,ab|0,u|0,k|0,+_,v|0);do{if(!z){af=m;aj=(a[af]&1)==0;if(aj){ai=w;c[ai>>2]=c[af>>2];c[ai+4>>2]=c[af+4>>2];c[ai+8>>2]=c[af+8>>2]}else{ai=c[m+8>>2]|0;am=c[m+4>>2]|0;if(am>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;an=0;I=151;break}return 0}if(am>>>0<11>>>0){a[w]=am<<1;ao=w+1|0}else{ap=am+16&-16;aq=(z=0,au(248,ap|0)|0);if(z){z=0;an=0;I=151;break}c[w+8>>2]=aq;c[w>>2]=ap|1;c[w+4>>2]=am;ao=aq}LF(ao|0,ai|0,am)|0;a[ao+am|0]=0}am=(z=0,aM(90,t|0,w|0)|0);if(z){z=0;ai=bT(-1,-1)|0;aq=ai;ai=M;if((a[w]&1)==0){at=aq;av=ai;aw=0;break}Lw(c[w+8>>2]|0);at=aq;av=ai;aw=0;break}c[am>>2]=ac;if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}if((a[ag]&1)!=0){Lw(c[v+8>>2]|0)}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}am=c[F>>2]|0;c[K>>2]=am;c[F>>2]=t;ai=c[d+28>>2]|0;L131:do{if(_<aa){aq=b+24|0;ap=ai+36|0;ax=ai+32|0;ay=x;aA=y;aB=y+1|0;aC=A;aD=x+8|0;aE=y+8|0;aF=A+8|0;aH=m+8|0;aI=m+4|0;aJ=A+1|0;aK=A|0;aL=A+4|0;aN=H+12|0;aO=H+8|0;aP=x+1|0;aQ=x|0;aR=x+4|0;aS=b|0;$=_;L133:while(1){aT=c[(c[aq>>2]|0)-4>>2]|0;aU=c[ax>>2]|0;aW=(c[ap>>2]|0)-aU>>2;L135:do{if((aW|0)!=0){aX=aT+28|0;aY=aT+36|0;aZ=aT+40|0;a_=aT+32|0;a$=aX;a0=0;a1=aU;while(1){a2=c[a1+(a0<<2)>>2]|0;a3=(z=0,aM(c[(c[a2>>2]|0)+16>>2]|0,a2|0,aS|0)|0);if(z){z=0;I=146;break L133}if((a3|0)!=0){c[j>>2]=a3;a2=c[aY>>2]|0;if((a2|0)==(c[aZ>>2]|0)){z=0;as(488,a_|0,j|0);if(z){z=0;I=146;break L133}a4=c[j>>2]|0}else{if((a2|0)==0){a5=0}else{c[a2>>2]=a3;a5=c[aY>>2]|0}c[aY>>2]=a5+4;a4=a3}z=0;as(c[c[a$>>2]>>2]|0,aX|0,a4|0);if(z){z=0;I=146;break L133}}a3=a0+1|0;if(a3>>>0>=aW>>>0){break L135}a0=a3;a1=c[ax>>2]|0}}}while(0);a6=c[L>>2]|0;aW=(z=0,au(248,72)|0);if(z){z=0;I=147;break}aU=aW;c[g>>2]=aU;a7=a6+4|0;aW=c[a7>>2]|0;if((aW|0)==(c[a6+8>>2]|0)){z=0;as(382,a6|0,g|0);if(z){z=0;I=147;break}a8=c[g>>2]|0}else{if((aW|0)==0){a9=0}else{c[aW>>2]=aU;a9=c[a7>>2]|0}c[a7>>2]=a9+4;a8=aU}ba=a8;aU=a8;if((a[ae]&1)==0){c[ay>>2]=c[ae>>2];c[ay+4>>2]=c[ae+4>>2];c[ay+8>>2]=c[ae+8>>2]}else{aW=c[aN>>2]|0;aT=c[aO>>2]|0;if(aT>>>0>4294967279>>>0){I=120;break}if(aT>>>0<11>>>0){a[ay]=aT<<1;bb=aP}else{a1=aT+16&-16;a0=(z=0,au(248,a1|0)|0);if(z){z=0;I=165;break}c[aD>>2]=a0;c[aQ>>2]=a1|1;c[aR>>2]=aT;bb=a0}LF(bb|0,aW|0,aT)|0;a[bb+aT|0]=0}aT=f;c[aT>>2]=c[N>>2];c[aT+4>>2]=c[N+4>>2];c[aT+8>>2]=c[N+8>>2];bc=$+1.0;a[aA]=0;a[aB]=0;z=0;aG(2,aU|0,x|0,f|0,+bc,y|0);if(z){z=0;bd=1;I=168;break}aU=c[F>>2]|0;if(aj){c[aC>>2]=c[af>>2];c[aC+4>>2]=c[af+4>>2];c[aC+8>>2]=c[af+8>>2]}else{aT=c[aH>>2]|0;aW=c[aI>>2]|0;if(aW>>>0>4294967279>>>0){I=131;break}if(aW>>>0<11>>>0){a[aC]=aW<<1;be=aJ}else{a0=aW+16&-16;a1=(z=0,au(248,a0|0)|0);if(z){z=0;bd=0;I=168;break}c[aF>>2]=a1;c[aK>>2]=a0|1;c[aL>>2]=aW;be=a1}LF(be|0,aT|0,aW)|0;a[be+aW|0]=0}aW=(z=0,aM(90,aU|0,A|0)|0);if(z){z=0;I=171;break}c[aW>>2]=a8;if((a[aC]&1)!=0){Lw(c[aF>>2]|0)}if((a[aA]&1)!=0){Lw(c[aE>>2]|0)}if((a[ay]&1)!=0){Lw(c[aD>>2]|0)}if(bc<aa){$=bc}else{I=184;break}}do{if((I|0)==120){z=0;ar(86,0);if(!z){return 0}else{z=0;aL=bT(-1,-1)|0;bf=M;bh=aL;I=167;break}}else if((I|0)==131){z=0;ar(86,0);if(!z){return 0}else{z=0;aL=bT(-1,-1)|0;bi=M;bj=aL;bk=0;I=170;break}}else if((I|0)==146){aL=bT(-1,-1)|0;bl=M;bm=aL;I=149;break L78}else if((I|0)==147){aL=bT(-1,-1)|0;bl=M;bm=aL;I=149;break L78}else if((I|0)==165){aL=bT(-1,-1)|0;bf=M;bh=aL;I=167}else if((I|0)==168){aL=bT(-1,-1)|0;bi=M;bj=aL;bk=bd;I=170}else if((I|0)==171){aL=bT(-1,-1)|0;aK=aL;aL=M;if((a[aC]&1)==0){bn=aK;bo=0;bp=aL;I=173;break}Lw(c[aF>>2]|0);bn=aK;bo=0;bp=aL;I=173}else if((I|0)==184){bq=c[K>>2]|0;break L131}}while(0);if((I|0)==167){br=bf;bs=bh}else if((I|0)==170){bn=bj;bo=bk;bp=bi;I=173}do{if((I|0)==173){if((a[aA]&1)!=0){Lw(c[aE>>2]|0)}if((a[ay]&1)==0){if(bo){br=bp;bs=bn;break}else{bt=bn;bu=bp;break L78}}else{Lw(c[aD>>2]|0);if(bo){br=bp;bs=bn;break}else{bt=bn;bu=bp;break L78}}}}while(0);aD=c[a6>>2]|0;ay=c[a7>>2]|0;aE=aD;while(1){if((aE|0)==(ay|0)){bv=ay;break}if((c[aE>>2]|0)==(a8|0)){bv=aE;break}else{aE=aE+4|0}}aE=bv-aD>>2;aA=aD+(aE+1<<2)|0;aF=ay-aA|0;LG(aD+(aE<<2)|0,aA|0,aF|0)|0;aA=aD+((aF>>2)+aE<<2)|0;aE=c[a7>>2]|0;if((aA|0)!=(aE|0)){c[a7>>2]=aE+(~((aE-4+(-aA|0)|0)>>>2)<<2)}Lw(ba);bt=bs;bu=br;break L78}else{bq=am}}while(0);c[F>>2]=bq;g_(t|0,c[t+4>>2]|0);if(aj){i=e;return 0}Lw(c[m+8>>2]|0);i=e;return 0}else{z=0;an=1;I=151}}while(0);if((I|0)==151){N=bT(-1,-1)|0;at=N;av=M;aw=an}if((a[ag]&1)!=0){Lw(c[v+8>>2]|0)}if((a[u]&1)==0){if(aw){ak=av;al=at;break}else{bt=at;bu=av;break L78}}else{Lw(c[u+8>>2]|0);if(aw){ak=av;al=at;break}else{bt=at;bu=av;break L78}}}}while(0);ae=c[P>>2]|0;ab=c[W>>2]|0;N=ae;while(1){if((N|0)==(ab|0)){bw=ab;break}if((c[N>>2]|0)==(ac|0)){bw=N;break}else{N=N+4|0}}N=bw-ae>>2;am=ae+(N+1<<2)|0;af=ab-am|0;LG(ae+(N<<2)|0,am|0,af|0)|0;am=ae+((af>>2)+N<<2)|0;N=c[W>>2]|0;if((am|0)!=(N|0)){c[W>>2]=N+(~((N-4+(-am|0)|0)>>>2)<<2)}Lw(X);bt=al;bu=ak}else{z=0;I=148}}while(0);if((I|0)==148){P=bT(-1,-1)|0;bl=M;bm=P;I=149}if((I|0)==149){bt=bm;bu=bl}g_(t|0,c[t+4>>2]|0);T=bt;U=bu}else{z=0;I=28}}while(0);if((I|0)==28){I=bT(-1,-1)|0;T=I;U=M}if((a[m]&1)==0){bx=T;by=0;bz=bx;bA=U;bg(bz|0)}Lw(c[m+8>>2]|0);bx=T;by=0;bz=bx;bA=U;bg(bz|0);return 0}function l6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0;e=i;i=i+120|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+104|0;p=d+32|0;if((a[p]&1)==0){q=k;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2]}else{p=c[d+40>>2]|0;q=c[d+36>>2]|0;if(q>>>0>4294967279>>>0){D5(0);return 0}if(q>>>0<11>>>0){a[k]=q<<1;r=k+1|0}else{s=q+16&-16;t=Lu(s)|0;c[k+8>>2]=t;c[k>>2]=s|1;c[k+4>>2]=q;r=t}LF(r|0,p|0,q)|0;a[r+q|0]=0}q=c[d+44>>2]|0;r=c[(c[q>>2]|0)+20>>2]|0;p=b+8|0;t=b+16|0;s=b+56|0;u=(z=0,az(46,c[p>>2]|0,c[t>>2]|0,c[s>>2]|0)|0);L12:do{if(!z){v=(z=0,aM(r|0,q|0,u|0)|0);if(z){z=0;w=39;break}L15:do{if((c[v+32>>2]|0)==5){x=v}else{y=c[b+4>>2]|0;A=(z=0,au(248,60)|0);if(z){z=0;w=39;break L12}B=A;c[j>>2]=B;A=y+4|0;C=c[A>>2]|0;if((C|0)==(c[y+8>>2]|0)){z=0;as(382,y|0,j|0);if(z){z=0;w=39;break L12}D=c[j>>2]|0}else{if((C|0)==0){E=0}else{c[C>>2]=B;E=c[A>>2]|0}c[A>>2]=E+4;D=B}B=D;C=D;F=v+4|0;L27:do{if((a[F]&1)==0){G=l;c[G>>2]=c[F>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];w=29}else{G=c[v+12>>2]|0;H=c[v+8>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[l]=H<<1;I=l+1|0}else{J=H+16&-16;K=(z=0,au(248,J|0)|0);if(z){z=0;break}c[l+8>>2]=K;c[l>>2]=J|1;c[l+4>>2]=H;I=K}LF(I|0,G|0,H)|0;a[I+H|0]=0;w=29;break L27}}while(0);H=bT(-1,-1)|0;L=H;N=M}}while(0);do{if((w|0)==29){F=v+16|0;H=h;c[H>>2]=c[F>>2];c[H+4>>2]=c[F+4>>2];c[H+8>>2]=c[F+8>>2];z=0;aD(36,C|0,l|0,h|0,1,1,0);if(z){z=0;F=bT(-1,-1)|0;H=F;F=M;if((a[l]&1)==0){L=H;N=F;break}Lw(c[l+8>>2]|0);L=H;N=F;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}F=D+36|0;H=F;c[g>>2]=v;G=F+8|0;K=G;J=c[K>>2]|0;if((J|0)==(c[F+12>>2]|0)){z=0;as(376,F+4|0,g|0);if(z){z=0;w=39;break L12}O=c[g>>2]|0}else{if((J|0)==0){P=0}else{c[J>>2]=v;P=c[K>>2]|0}c[G>>2]=P+4;O=v}z=0;as(c[c[F>>2]>>2]|0,H|0,O|0);if(!z){x=C;break L15}else{z=0;w=39;break L12}}}while(0);C=c[y>>2]|0;H=c[A>>2]|0;F=C;while(1){if((F|0)==(H|0)){Q=H;break}if((c[F>>2]|0)==(D|0)){Q=F;break}else{F=F+4|0}}F=Q-C>>2;y=C+(F+1<<2)|0;G=H-y|0;LG(C+(F<<2)|0,y|0,G|0)|0;y=C+((G>>2)+F<<2)|0;F=c[A>>2]|0;if((y|0)!=(F|0)){c[A>>2]=F+(~((F-4+(-y|0)|0)>>>2)<<2)}Lw(B);R=L;S=N;break L12}}while(0);v=m+4|0;c[v>>2]=0;c[m+8>>2]=0;c[m>>2]=v;v=m+12|0;c[v>>2]=0;y=k;F=(a[y]&1)==0;do{if(F){G=n;c[G>>2]=c[y>>2];c[G+4>>2]=c[y+4>>2];c[G+8>>2]=c[y+8>>2];w=60}else{G=c[k+8>>2]|0;K=c[k+4>>2]|0;if(K>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;w=97;break}return 0}if(K>>>0<11>>>0){a[n]=K<<1;T=n+1|0}else{J=K+16&-16;U=(z=0,au(248,J|0)|0);if(z){z=0;w=97;break}c[n+8>>2]=U;c[n>>2]=J|1;c[n+4>>2]=K;T=U}LF(T|0,G|0,K)|0;a[T+K|0]=0;w=60}}while(0);L78:do{if((w|0)==60){K=(z=0,aM(90,m|0,n|0)|0);if(z){z=0;G=bT(-1,-1)|0;U=G;G=M;if((a[n]&1)==0){V=U;W=G;break}Lw(c[n+8>>2]|0);V=U;W=G;break}c[K>>2]=0;if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}K=c[t>>2]|0;c[v>>2]=K;c[t>>2]=m;G=c[d+28>>2]|0;U=x+40|0;J=c[U>>2]|0;X=(c[x+44>>2]|0)-J>>2;do{if((X|0)==0){Y=K}else{Z=o;_=b+24|0;$=G+36|0;aa=G+32|0;ab=b|0;ac=o+8|0;ad=k+8|0;ae=k+4|0;af=o+1|0;ag=o|0;ah=o+4|0;ai=0;aj=J;ak=m;L89:while(1){al=c[aj+(ai<<2)>>2]|0;am=c[(c[al>>2]|0)+20>>2]|0;an=(z=0,az(46,c[p>>2]|0,ak|0,c[s>>2]|0)|0);if(z){z=0;w=96;break}ao=(z=0,aM(am|0,al|0,an|0)|0);if(z){z=0;w=96;break}an=ao|0;ao=c[t>>2]|0;if(F){c[Z>>2]=c[y>>2];c[Z+4>>2]=c[y+4>>2];c[Z+8>>2]=c[y+8>>2]}else{al=c[ad>>2]|0;am=c[ae>>2]|0;if(am>>>0>4294967279>>>0){w=70;break}if(am>>>0<11>>>0){a[Z]=am<<1;ap=af}else{aq=am+16&-16;at=(z=0,au(248,aq|0)|0);if(z){z=0;w=96;break}c[ac>>2]=at;c[ag>>2]=aq|1;c[ah>>2]=am;ap=at}LF(ap|0,al|0,am)|0;a[ap+am|0]=0}am=(z=0,aM(90,ao|0,o|0)|0);if(z){z=0;w=101;break}c[am>>2]=an;if((a[Z]&1)!=0){Lw(c[ac>>2]|0)}an=c[(c[_>>2]|0)-4>>2]|0;am=c[aa>>2]|0;ao=(c[$>>2]|0)-am>>2;L107:do{if((ao|0)!=0){al=an+28|0;at=an+36|0;aq=an+40|0;av=an+32|0;aw=al;ax=0;ay=am;while(1){aA=c[ay+(ax<<2)>>2]|0;aB=(z=0,aM(c[(c[aA>>2]|0)+16>>2]|0,aA|0,ab|0)|0);if(z){z=0;w=95;break L89}if((aB|0)!=0){c[f>>2]=aB;aA=c[at>>2]|0;if((aA|0)==(c[aq>>2]|0)){z=0;as(488,av|0,f|0);if(z){z=0;w=95;break L89}aC=c[f>>2]|0}else{if((aA|0)==0){aE=0}else{c[aA>>2]=aB;aE=c[at>>2]|0}c[at>>2]=aE+4;aC=aB}z=0;as(c[c[aw>>2]>>2]|0,al|0,aC|0);if(z){z=0;w=95;break L89}}aB=ax+1|0;if(aB>>>0>=ao>>>0){break L107}ax=aB;ay=c[aa>>2]|0}}}while(0);ao=ai+1|0;if(ao>>>0>=X>>>0){w=103;break}ai=ao;aj=c[U>>2]|0;ak=c[t>>2]|0}if((w|0)==70){z=0;ar(86,0);if(z){z=0;w=97;break L78}return 0}else if((w|0)==95){ak=bT(-1,-1)|0;aF=M;aG=ak;w=98;break L78}else if((w|0)==96){ak=bT(-1,-1)|0;aF=M;aG=ak;w=98;break L78}else if((w|0)==101){ak=bT(-1,-1)|0;aj=ak;ak=M;if((a[Z]&1)==0){V=aj;W=ak;break L78}Lw(c[ac>>2]|0);V=aj;W=ak;break L78}else if((w|0)==103){Y=c[v>>2]|0;break}}}while(0);c[t>>2]=Y;g_(m|0,c[m+4>>2]|0);if(F){i=e;return 0}Lw(c[k+8>>2]|0);i=e;return 0}}while(0);if((w|0)==97){F=bT(-1,-1)|0;aF=M;aG=F;w=98}if((w|0)==98){V=aG;W=aF}g_(m|0,c[m+4>>2]|0);R=V;S=W}else{z=0;w=39}}while(0);if((w|0)==39){w=bT(-1,-1)|0;R=w;S=M}if((a[k]&1)==0){aH=R;aI=0;aJ=aH;aK=S;bg(aJ|0)}Lw(c[k+8>>2]|0);aH=R;aI=0;aJ=aH;aK=S;bg(aJ|0);return 0}function l7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d|0;f=c[b+32>>2]|0;g=c[b+28>>2]|0;b=f|0;h=f;f=a+8|0;j=a+16|0;k=a+56|0;l=a+24|0;m=g+36|0;n=g+32|0;g=a|0;L1:while(1){a=c[(c[h>>2]|0)+20>>2]|0;o=iX(c[f>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;p=cV[a&1023](b,o)|0;if(!(cD[c[(c[p>>2]|0)+36>>2]&511](p)|0)){break}p=c[(c[l>>2]|0)-4>>2]|0;o=c[n>>2]|0;a=(c[m>>2]|0)-o>>2;if((a|0)==0){continue}q=p+28|0;r=p+36|0;s=p+40|0;t=p+32|0;p=q;u=0;v=o;while(1){o=c[v+(u<<2)>>2]|0;w=cV[c[(c[o>>2]|0)+16>>2]&1023](o|0,g)|0;if((w|0)!=0){c[e>>2]=w;o=c[r>>2]|0;if((o|0)==(c[s>>2]|0)){m3(t,e);x=c[e>>2]|0}else{if((o|0)==0){y=0}else{c[o>>2]=w;y=c[r>>2]|0}c[r>>2]=y+4;x=w}cB[c[c[p>>2]>>2]&1023](q,x)}w=u+1|0;if(w>>>0>=a>>>0){continue L1}u=w;v=c[n>>2]|0}}i=d;return 0}function l8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=Lu(48)|0;k=f+8|0;c[k>>2]=j;c[f>>2]=49;c[f+4>>2]=42;LF(j|0,3360,42)|0;a[j+42|0]=0;j=d+4|0;L1:do{if((a[j]&1)==0){l=g;c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];m=11}else{l=c[d+12>>2]|0;n=c[d+8>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(n>>>0<11>>>0){a[g]=n<<1;o=g+1|0}else{p=n+16&-16;q=(z=0,au(248,p|0)|0);if(z){z=0;break}c[g+8>>2]=q;c[g>>2]=p|1;c[g+4>>2]=n;o=q}LF(o|0,l|0,n)|0;a[o+n|0]=0;m=11;break L1}}while(0);n=bT(-1,-1)|0;r=M;s=n}}while(0);do{if((m|0)==11){o=h;j=d+16|0;c[o>>2]=c[j>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];z=0;aV(46,f|0,g|0,h|0,c[b+56>>2]|0);if(z){z=0;j=bT(-1,-1)|0;o=j;j=M;if((a[g]&1)==0){r=j;s=o;break}Lw(c[g+8>>2]|0);r=j;s=o;break}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}if((a[f]&1)==0){i=e;return 0}Lw(c[k>>2]|0);i=e;return 0}}while(0);if((a[f]&1)==0){t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k>>2]|0);t=s;u=0;v=t;w=r;bg(v|0);return 0}function l9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0;e=i;i=i+392|0;f=e|0;g=e+8|0;h=e+72|0;j=e+80|0;k=e+96|0;l=e+112|0;m=e+128|0;n=e+144|0;o=e+160|0;p=e+176|0;q=e+240|0;r=e+304|0;s=e+368|0;t=e+384|0;Bv(h,0);u=c[(c[b+48>>2]|0)-4>>2]|0;if((u|0)==0){Bx(h);i=e;return 0}v=c[d+28>>2]|0;d=c[(c[v>>2]|0)+24>>2]|0;w=b+56|0;x=(z=0,at(112,c[b+12>>2]|0,0,c[b+16>>2]|0,c[w>>2]|0,0,0)|0);L4:do{if(!z){y=(z=0,aM(d|0,v|0,x|0)|0);if(z){z=0;A=3;break}B=y+36|0;L7:do{if(((c[y+40>>2]|0)-(c[B>>2]|0)|0)!=4){C=(z=0,au(248,48)|0);if(z){z=0;A=3;break L4}D=j+8|0;c[D>>2]=C;c[j>>2]=49;c[j+4>>2]=35;LF(C|0,2064,35)|0;a[C+35|0]=0;C=y+4|0;L10:do{if((a[C]&1)==0){E=k;c[E>>2]=c[C>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];A=19}else{E=c[y+12>>2]|0;F=c[y+8>>2]|0;do{if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(F>>>0<11>>>0){a[k]=F<<1;G=k+1|0}else{H=F+16&-16;I=(z=0,au(248,H|0)|0);if(z){z=0;break}c[k+8>>2]=I;c[k>>2]=H|1;c[k+4>>2]=F;G=I}LF(G|0,E|0,F)|0;a[G+F|0]=0;A=19;break L10}}while(0);F=bT(-1,-1)|0;J=F;K=M}}while(0);do{if((A|0)==19){C=l;F=y+16|0;c[C>>2]=c[F>>2];c[C+4>>2]=c[F+4>>2];c[C+8>>2]=c[F+8>>2];z=0;aV(46,j|0,k|0,l|0,c[w>>2]|0);if(z){z=0;F=bT(-1,-1)|0;C=F;F=M;if((a[k]&1)==0){J=C;K=F;break}Lw(c[k+8>>2]|0);J=C;K=F;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((a[j]&1)==0){break L7}Lw(c[D>>2]|0);break L7}}while(0);if((a[j]&1)==0){L=J;N=K;break L4}Lw(c[D>>2]|0);L=J;N=K;break L4}}while(0);y=c[c[B>>2]>>2]|0;F=y+36|0;if((c[F>>2]|0)==0){A=31}else{if((c[y+40>>2]|0)!=0){A=31}}L38:do{if((A|0)==31){C=(z=0,au(248,48)|0);if(z){z=0;A=3;break L4}E=m+8|0;c[E>>2]=C;c[m>>2]=49;c[m+4>>2]=36;LF(C|0,1208,36)|0;a[C+36|0]=0;C=y+4|0;L41:do{if((a[C]&1)==0){I=n;c[I>>2]=c[C>>2];c[I+4>>2]=c[C+4>>2];c[I+8>>2]=c[C+8>>2];A=42}else{I=c[y+12>>2]|0;H=c[y+8>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[n]=H<<1;O=n+1|0}else{P=H+16&-16;Q=(z=0,au(248,P|0)|0);if(z){z=0;break}c[n+8>>2]=Q;c[n>>2]=P|1;c[n+4>>2]=H;O=Q}LF(O|0,I|0,H)|0;a[O+H|0]=0;A=42;break L41}}while(0);H=bT(-1,-1)|0;R=H;S=M}}while(0);do{if((A|0)==42){C=o;D=y+16|0;c[C>>2]=c[D>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];z=0;aV(46,m|0,n|0,o|0,c[w>>2]|0);if(z){z=0;D=bT(-1,-1)|0;C=D;D=M;if((a[n]&1)==0){R=C;S=D;break}Lw(c[n+8>>2]|0);R=C;S=D;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[m]&1)==0){break L38}Lw(c[E>>2]|0);break L38}}while(0);if((a[m]&1)==0){L=R;N=S;break L4}Lw(c[E>>2]|0);L=R;N=S;break L4}}while(0);y=c[F>>2]|0;B=u+36|0;D=(c[u+40>>2]|0)-(c[B>>2]|0)>>2;if((D|0)==0){Bx(h);i=e;return 0}C=b+4|0;H=q|0;I=q+60|0;Q=p|0;P=p+60|0;T=g|0;U=g+60|0;V=g|0;W=g+32|0;X=g+48|0;Y=g+52|0;Z=g+36|0;_=g+4|0;$=p|0;aa=p+32|0;ab=p+48|0;ac=p+52|0;ad=p+36|0;ae=p+4|0;af=q|0;ag=q+32|0;ah=q+48|0;ai=q+52|0;aj=q+36|0;ak=q+4|0;al=r|0;am=r+32|0;an=r+48|0;ao=r+52|0;ap=r+36|0;aq=r+4|0;av=t|0;aw=t+4|0;ax=s|0;ay=s+4|0;az=r+12|0;aA=r+40|0;aB=q+12|0;aC=q+40|0;aD=p+12|0;aE=p+40|0;aF=g+12|0;aG=g+40|0;aH=0;while(1){aI=c[C>>2]|0;z=0;as(326,r|0,y|0);if(z){z=0;A=2;break}aJ=c[(c[B>>2]|0)+(aH<<2)>>2]|0;z=0;as(326,H|0,r|0);if(z){z=0;A=99;break}c[I>>2]=aJ;z=0;as(326,Q|0,H|0);if(z){z=0;A=100;break}c[P>>2]=c[I>>2];z=0;as(326,T|0,Q|0);if(z){z=0;A=101;break}c[U>>2]=c[P>>2];z=0;aR(422,f|0,aI+212|0,g|0);if(z){z=0;A=65;break}c[V>>2]=20768;c[W>>2]=20824;e9(X,c[Y>>2]|0);c[W>>2]=22640;aI=c[Z>>2]|0;aJ=aI;if((aI|0)!=0){aK=c[aG>>2]|0;if((aI|0)!=(aK|0)){c[aG>>2]=aK+(~((aK-4+(-aJ|0)|0)>>>2)<<2)}Lw(aI)}c[V>>2]=17512;if((a[_]&1)!=0){Lw(c[aF>>2]|0)}c[$>>2]=20768;c[aa>>2]=20824;e9(ab,c[ac>>2]|0);c[aa>>2]=22640;aI=c[ad>>2]|0;aJ=aI;if((aI|0)!=0){aK=c[aE>>2]|0;if((aI|0)!=(aK|0)){c[aE>>2]=aK+(~((aK-4+(-aJ|0)|0)>>>2)<<2)}Lw(aI)}c[$>>2]=17512;if((a[ae]&1)!=0){Lw(c[aD>>2]|0)}c[af>>2]=20768;c[ag>>2]=20824;e9(ah,c[ai>>2]|0);c[ag>>2]=22640;aI=c[aj>>2]|0;aJ=aI;if((aI|0)!=0){aK=c[aC>>2]|0;if((aI|0)!=(aK|0)){c[aC>>2]=aK+(~((aK-4+(-aJ|0)|0)>>>2)<<2)}Lw(aI)}c[af>>2]=17512;if((a[ak]&1)!=0){Lw(c[aB>>2]|0)}c[al>>2]=20768;c[am>>2]=20824;e9(an,c[ao>>2]|0);c[am>>2]=22640;aI=c[ap>>2]|0;aJ=aI;if((aI|0)!=0){aK=c[aA>>2]|0;if((aI|0)!=(aK|0)){c[aA>>2]=aK+(~((aK-4+(-aJ|0)|0)>>>2)<<2)}Lw(aI)}c[al>>2]=17512;if((a[aq]&1)!=0){Lw(c[az>>2]|0)}aI=c[C>>2]|0;z=0;as(104,s|0,y|0);if(z){z=0;A=2;break}c[av>>2]=c[(c[B>>2]|0)+(aH<<2)>>2];c[aw>>2]=y;z=0;aR(226,aI+224|0,s|0,t|0);if(z){z=0;A=120;break}aI=c[ax>>2]|0;if((aI|0)!=0){aJ=c[ay>>2]|0;if((aI|0)==(aJ|0)){aL=aI}else{aK=aJ;while(1){aJ=aK-12|0;c[ay>>2]=aJ;if((a[aJ]&1)==0){aN=aJ}else{Lw(c[aK-12+8>>2]|0);aN=c[ay>>2]|0}if((aI|0)==(aN|0)){break}else{aK=aN}}aL=c[ax>>2]|0}Lw(aL)}aK=aH+1|0;if(aK>>>0<D>>>0){aH=aK}else{A=133;break}}do{if((A|0)==133){Bx(h);i=e;return 0}else if((A|0)==2){aH=bT(-1,-1)|0;aO=M;aP=aH;A=4;break L4}else if((A|0)==65){aH=bT(-1,-1)|0;D=M;c[V>>2]=20768;c[W>>2]=20824;e9(X,c[Y>>2]|0);c[W>>2]=22640;y=c[Z>>2]|0;aw=y;if((y|0)!=0){B=c[aG>>2]|0;if((y|0)!=(B|0)){c[aG>>2]=B+(~((B-4+(-aw|0)|0)>>>2)<<2)}Lw(y)}c[V>>2]=17512;if((a[_]&1)==0){aQ=D;aS=aH;A=102;break}Lw(c[aF>>2]|0);aQ=D;aS=aH;A=102}else if((A|0)==99){aH=bT(-1,-1)|0;aT=aH;aU=M}else if((A|0)==100){aH=bT(-1,-1)|0;aW=aH;aX=M;A=108}else if((A|0)==101){aH=bT(-1,-1)|0;aQ=M;aS=aH;A=102}else if((A|0)==120){aH=bT(-1,-1)|0;D=aH;aH=M;y=c[ax>>2]|0;if((y|0)==0){L=D;N=aH;break L4}aw=c[ay>>2]|0;if((y|0)==(aw|0)){aY=y}else{B=aw;while(1){aw=B-12|0;c[ay>>2]=aw;if((a[aw]&1)==0){aZ=aw}else{Lw(c[B-12+8>>2]|0);aZ=c[ay>>2]|0}if((y|0)==(aZ|0)){break}else{B=aZ}}aY=c[ax>>2]|0}Lw(aY);L=D;N=aH;break L4}}while(0);do{if((A|0)==102){ax=aS;ay=aQ;c[$>>2]=20768;c[aa>>2]=20824;e9(ab,c[ac>>2]|0);c[aa>>2]=22640;aF=c[ad>>2]|0;_=aF;if((aF|0)!=0){V=c[aE>>2]|0;if((aF|0)!=(V|0)){c[aE>>2]=V+(~((V-4+(-_|0)|0)>>>2)<<2)}Lw(aF)}c[$>>2]=17512;if((a[ae]&1)==0){aW=ax;aX=ay;A=108;break}Lw(c[aD>>2]|0);aW=ax;aX=ay;A=108}}while(0);do{if((A|0)==108){c[af>>2]=20768;c[ag>>2]=20824;e9(ah,c[ai>>2]|0);c[ag>>2]=22640;aD=c[aj>>2]|0;ae=aD;if((aD|0)!=0){$=c[aC>>2]|0;if((aD|0)!=($|0)){c[aC>>2]=$+(~(($-4+(-ae|0)|0)>>>2)<<2)}Lw(aD)}c[af>>2]=17512;if((a[ak]&1)==0){aT=aW;aU=aX;break}Lw(c[aB>>2]|0);aT=aW;aU=aX}}while(0);c[al>>2]=20768;c[am>>2]=20824;e9(an,c[ao>>2]|0);c[am>>2]=22640;aB=c[ap>>2]|0;ak=aB;if((aB|0)!=0){af=c[aA>>2]|0;if((aB|0)!=(af|0)){c[aA>>2]=af+(~((af-4+(-ak|0)|0)>>>2)<<2)}Lw(aB)}c[al>>2]=17512;if((a[aq]&1)==0){L=aT;N=aU;break}Lw(c[az>>2]|0);L=aT;N=aU}else{z=0;A=3}}while(0);if((A|0)==3){aU=bT(-1,-1)|0;aO=M;aP=aU;A=4}if((A|0)==4){L=aP;N=aO}z=0;ar(444,h|0);if(!z){bg(L|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function ma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0;f=i;i=i+112|0;g=f|0;h=f+8|0;j=f+24|0;k=f+32|0;l=f+48|0;m=f+56|0;n=f+64|0;o=f+80|0;p=d|0;q=d+4|0;if((c[p>>2]|0)==(c[q>>2]|0)){r=cl(4)|0;c[r>>2]=9448;bK(r|0,29416,0)}r=b+4|0;s=c[r>>2]|0;c[m>>2]=s-(c[b>>2]|0)>>3;if((s|0)==(c[b+8>>2]|0)){m1(b|0,e)}else{if((s|0)==0){t=0}else{c[s>>2]=c[e>>2];c[s+4>>2]=c[e+4>>2];t=c[r>>2]|0}c[r>>2]=t+8}t=n|0;r=n+4|0;c[r>>2]=0;e=n+8|0;c[e>>2]=0;s=n|0;c[s>>2]=r;r=c[q>>2]|0;u=c[p>>2]|0;v=(r-u|0)/12|0;if((r|0)==(u|0)){w=n+4|0;x=c[w>>2]|0;y=x;fc(t,y);i=f;return}r=n+4|0;A=0;B=u;L14:while(1){u=B+(A*12|0)|0;C=e1(t,l,u)|0;if((c[C>>2]|0)==0){D=(z=0,au(248,28)|0);if(z){z=0;E=33;break}F=D+16|0;do{if((F|0)!=0){G=u;if((a[G]&1)==0){c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];break}G=c[B+(A*12|0)+8>>2]|0;H=c[B+(A*12|0)+4>>2]|0;if(H>>>0>4294967279>>>0){E=16;break L14}if(H>>>0<11>>>0){a[F]=H<<1;I=D+17|0}else{J=H+16&-16;K=(z=0,au(248,J|0)|0);if(z){z=0;E=23;break L14}c[D+24>>2]=K;c[F>>2]=J|1;c[D+20>>2]=H;I=K}LF(I|0,G|0,H)|0;a[I+H|0]=0}}while(0);F=c[l>>2]|0;u=D;c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=F;c[C>>2]=u;F=c[c[s>>2]>>2]|0;if((F|0)==0){L=u}else{c[s>>2]=F;L=c[C>>2]|0}e2(c[r>>2]|0,L);c[e>>2]=(c[e>>2]|0)+1}F=A+1|0;if(F>>>0>=v>>>0){E=35;break}A=F;B=c[p>>2]|0}do{if((E|0)==16){z=0;ar(86,0);if(z){z=0;B=bT(-1,-1)|0;N=M;O=B;E=25;break}}else if((E|0)==23){B=bT(-1,-1)|0;N=M;O=B;E=25}else if((E|0)==33){B=bT(-1,-1)|0;P=M;Q=B}else if((E|0)==35){B=c[q>>2]|0;A=c[p>>2]|0;v=(B-A|0)/12|0;if((B|0)==(A|0)){w=n+4|0;x=c[w>>2]|0;y=x;fc(t,y);i=f;return}B=b+12|0;e=k|0;L=B|0;r=b+16|0;s=b+20|0;l=h|0;I=o+12|0;F=o+16|0;u=o|0;H=o+4|0;G=0;K=A;while(1){A=K+(G*12|0)|0;J=m$(B,j,A)|0;if((c[J>>2]|0)==0){z=0;aR(398,k|0,B|0,A|0);if(z){z=0;E=32;break}A=c[e>>2]|0;c[e>>2]=0;R=c[j>>2]|0;S=A|0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=R;c[J>>2]=S;R=c[c[L>>2]>>2]|0;if((R|0)==0){T=S}else{c[L>>2]=R;T=c[J>>2]|0}e2(c[r>>2]|0,T);c[s>>2]=(c[s>>2]|0)+1}J=(c[p>>2]|0)+(G*12|0)|0;R=m$(B,g,J)|0;S=c[R>>2]|0;A=S;if((S|0)==0){z=0;aR(398,h|0,B|0,J|0);if(z){z=0;E=32;break}J=c[l>>2]|0;c[l>>2]=0;S=c[g>>2]|0;U=J|0;c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=S;c[R>>2]=U;S=c[c[L>>2]>>2]|0;if((S|0)==0){V=U}else{c[L>>2]=S;V=c[R>>2]|0}e2(c[r>>2]|0,V);c[s>>2]=(c[s>>2]|0)+1;W=J}else{W=A}z=0;aV(16,o|0,d|0,n|0,m|0);if(z){z=0;E=32;break}A=W+32|0;J=c[A>>2]|0;if((J|0)==(c[W+36>>2]|0)){z=0;as(582,W+28|0,o|0);if(z){z=0;E=63;break}}else{if((J|0)==0){X=0}else{z=0;as(544,J|0,o|0);if(z){z=0;E=63;break}X=c[A>>2]|0}c[A>>2]=X+28}fc(I,c[F>>2]|0);A=c[u>>2]|0;if((A|0)!=0){J=c[H>>2]|0;if((A|0)==(J|0)){Y=A}else{R=J;while(1){J=R-12|0;c[H>>2]=J;if((a[J]&1)==0){Z=J}else{Lw(c[R-12+8>>2]|0);Z=c[H>>2]|0}if((A|0)==(Z|0)){break}else{R=Z}}Y=c[u>>2]|0}Lw(Y)}R=G+1|0;if(R>>>0>=v>>>0){E=74;break}G=R;K=c[p>>2]|0}if((E|0)==32){K=bT(-1,-1)|0;P=M;Q=K;break}else if((E|0)==63){K=bT(-1,-1)|0;G=K;K=M;fc(I,c[F>>2]|0);v=c[u>>2]|0;if((v|0)==0){_=K;$=G;aa=n+4|0;ab=c[aa>>2]|0;ac=ab;fc(t,ac);ad=$;ae=0;af=ad;ag=_;bg(af|0)}s=c[H>>2]|0;if((v|0)==(s|0)){ah=v}else{r=s;while(1){s=r-12|0;c[H>>2]=s;if((a[s]&1)==0){ai=s}else{Lw(c[r-12+8>>2]|0);ai=c[H>>2]|0}if((v|0)==(ai|0)){break}else{r=ai}}ah=c[u>>2]|0}Lw(ah);_=K;$=G;aa=n+4|0;ab=c[aa>>2]|0;ac=ab;fc(t,ac);ad=$;ae=0;af=ad;ag=_;bg(af|0)}else if((E|0)==74){w=n+4|0;x=c[w>>2]|0;y=x;fc(t,y);i=f;return}}}while(0);do{if((E|0)==25){if((D|0)==0){P=N;Q=O;break}Lw(D);P=N;Q=O}}while(0);_=P;$=Q;aa=n+4|0;ab=c[aa>>2]|0;ac=ab;fc(t,ac);ad=$;ae=0;af=ad;ag=_;bg(af|0)}function mb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;j=c[b+4>>2]|0;k=Lu(76)|0;c[f>>2]=k;l=j+4|0;m=c[l>>2]|0;if((m|0)==(c[j+8>>2]|0)){e4(j|0,f);n=c[f>>2]|0}else{if((m|0)==0){o=0}else{c[m>>2]=k;o=c[l>>2]|0}c[l>>2]=o+4;n=k}k=n;z=0;as(644,n|0,d|0);if(z){z=0;o=bT(-1,-1)|0;m=o;o=M;f=c[j>>2]|0;j=c[l>>2]|0;p=f;while(1){if((p|0)==(j|0)){q=j;break}if((c[p>>2]|0)==(n|0)){q=p;break}else{p=p+4|0}}p=q-f>>2;q=f+(p+1<<2)|0;r=j-q|0;LG(f+(p<<2)|0,q|0,r|0)|0;q=f+((r>>2)+p<<2)|0;p=c[l>>2]|0;if((q|0)!=(p|0)){c[l>>2]=p+(~((p-4+(-q|0)|0)>>>2)<<2)}Lw(k);s=o;t=m;u=t;v=0;w=u;x=s;bg(w|0)}m=b+16|0;b=c[m>>2]|0;o=d+32|0;if((a[o]&1)==0){k=h;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];y=a[k]|0;A=k}else{k=c[d+40>>2]|0;o=c[d+36>>2]|0;if(o>>>0>4294967279>>>0){D5(0);return 0}if(o>>>0<11>>>0){q=o<<1&255;p=h;a[p]=q;B=h+1|0;C=q;D=p}else{p=o+16&-16;q=Lu(p)|0;c[h+8>>2]=q;l=p|1;c[h>>2]=l;c[h+4>>2]=o;B=q;C=l&255;D=h}LF(B|0,k|0,o)|0;a[B+o|0]=0;y=C;A=D}D=((c[d+52>>2]|0)==0?552:13176)|0;d=g;LI(d|0,0,12)|0;C=y&255;if((C&1|0)==0){E=C>>>1}else{E=c[h+4>>2]|0}if((y&1)==0){F=h+1|0}else{F=c[h+8>>2]|0}y=E+3|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=29;break}return 0}else{if(y>>>0<11>>>0){a[d]=E<<1;H=g+1|0}else{C=E+19&-16;o=(z=0,au(248,C|0)|0);if(z){z=0;G=29;break}c[g+8>>2]=o;c[g>>2]=C|1;c[g+4>>2]=E;H=o}LF(H|0,F|0,E)|0;a[H+E|0]=0;z=0,az(88,g|0,D|0,3)|0;if(z){z=0;G=29;break}o=(z=0,aM(178,b|0,g|0)|0);if(z){z=0;C=bT(-1,-1)|0;B=C;C=M;if((a[d]&1)==0){I=C;J=B;break}Lw(c[g+8>>2]|0);I=C;J=B;break}c[o>>2]=n;if((a[d]&1)!=0){Lw(c[g+8>>2]|0)}if((a[A]&1)==0){K=c[m>>2]|0;L=n+48|0;N=K;c[L>>2]=N;i=e;return 0}Lw(c[h+8>>2]|0);K=c[m>>2]|0;L=n+48|0;N=K;c[L>>2]=N;i=e;return 0}}while(0);if((G|0)==29){G=bT(-1,-1)|0;e=M;if((a[d]&1)!=0){Lw(c[g+8>>2]|0)}I=e;J=G}if((a[A]&1)==0){s=I;t=J;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[h+8>>2]|0);s=I;t=J;u=t;v=0;w=u;x=s;bg(w|0);return 0}function mc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0;e=i;i=i+448|0;f=e|0;g=e+8|0;h=e+24|0;j=e+40|0;k=e+48|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+104|0;p=e+120|0;q=e+136|0;r=e+152|0;s=e+168|0;t=e+184|0;u=e+200|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;A=e+304|0;B=e+320|0;C=e+336|0;D=e+352|0;F=e+368|0;G=e+384|0;H=e+400|0;I=e+416|0;J=e+432|0;K=d+32|0;if((a[K]&1)==0){L=n;c[L>>2]=c[K>>2];c[L+4>>2]=c[K+4>>2];c[L+8>>2]=c[K+8>>2];N=a[L]|0;O=L}else{L=c[d+40>>2]|0;P=c[d+36>>2]|0;if(P>>>0>4294967279>>>0){D5(0);return 0}if(P>>>0<11>>>0){Q=P<<1&255;R=n;a[R]=Q;S=n+1|0;T=Q;U=R}else{R=P+16&-16;Q=Lu(R)|0;c[n+8>>2]=Q;V=R|1;c[n>>2]=V;c[n+4>>2]=P;S=Q;T=V&255;U=n}LF(S|0,L|0,P)|0;a[S+P|0]=0;N=T;O=U}U=m;LI(U|0,0,12)|0;T=N&255;if((T&1|0)==0){W=T>>>1}else{W=c[n+4>>2]|0}if((N&1)==0){X=n+1|0}else{X=c[n+8>>2]|0}N=W+3|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[U]=W<<1;Y=m+1|0}else{T=W+19&-16;P=(z=0,au(248,T|0)|0);if(z){z=0;break}c[m+8>>2]=P;c[m>>2]=T|1;c[m+4>>2]=W;Y=P}LF(Y|0,X|0,W)|0;a[Y+W|0]=0;z=0,az(88,m|0,552,3)|0;if(z){z=0;break}if((a[O]&1)!=0){Lw(c[n+8>>2]|0)}P=b+16|0;T=c[P>>2]|0;do{if((a[U]&1)==0){S=o;c[S>>2]=c[U>>2];c[S+4>>2]=c[U+4>>2];c[S+8>>2]=c[U+8>>2];Z=37}else{S=c[m+8>>2]|0;L=c[m+4>>2]|0;if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=86;break}return 0}if(L>>>0<11>>>0){a[o]=L<<1;_=o+1|0}else{V=L+16&-16;Q=(z=0,au(248,V|0)|0);if(z){z=0;Z=86;break}c[o+8>>2]=Q;c[o>>2]=V|1;c[o+4>>2]=L;_=Q}LF(_|0,S|0,L)|0;a[_+L|0]=0;Z=37}}while(0);L45:do{if((Z|0)==37){L=(z=0,aM(560,T|0,o|0)|0);if(z){z=0;S=bT(-1,-1)|0;Q=S;S=M;if((a[o]&1)==0){$=Q;aa=S;break}Lw(c[o+8>>2]|0);$=Q;aa=S;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}L54:do{if(!L){if((a[K]&1)==0){S=q;c[S>>2]=c[K>>2];c[S+4>>2]=c[K+4>>2];c[S+8>>2]=c[K+8>>2];ab=a[S]|0;ac=S}else{S=c[d+40>>2]|0;Q=c[d+36>>2]|0;if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=86;break L45}return 0}if(Q>>>0<11>>>0){V=Q<<1&255;R=q;a[R]=V;ad=q+1|0;ae=V;af=R}else{R=Q+16&-16;V=(z=0,au(248,R|0)|0);if(z){z=0;Z=86;break L45}c[q+8>>2]=V;ag=R|1;c[q>>2]=ag;c[q+4>>2]=Q;ad=V;ae=ag&255;af=q}LF(ad|0,S|0,Q)|0;a[ad+Q|0]=0;ab=ae;ac=af}Q=p;LI(Q|0,0,12)|0;S=q;ag=ab&255;if((ag&1|0)==0){ah=ag>>>1}else{ah=c[q+4>>2]|0}ag=ah+15|0;do{if(ag>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=65;break}return 0}else{if(ag>>>0<11>>>0){a[Q]=30;ai=p+1|0}else{V=ah+31&-16;R=(z=0,au(248,V|0)|0);if(z){z=0;Z=65;break}c[p+8>>2]=R;c[p>>2]=V|1;c[p+4>>2]=15;ai=R}LF(ai|0,12360,15)|0;a[ai+15|0]=0;if((a[ac]&1)==0){aj=S+1|0}else{aj=c[q+8>>2]|0}z=0,az(88,p|0,aj|0,ah|0)|0;if(z){z=0;Z=65;break}R=d+4|0;L87:do{if((a[R]&1)==0){V=r;c[V>>2]=c[R>>2];c[V+4>>2]=c[R+4>>2];c[V+8>>2]=c[R+8>>2];Z=77}else{V=c[d+12>>2]|0;ak=c[d+8>>2]|0;do{if(ak>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ak>>>0<11>>>0){a[r]=ak<<1;al=r+1|0}else{am=ak+16&-16;an=(z=0,au(248,am|0)|0);if(z){z=0;break}c[r+8>>2]=an;c[r>>2]=am|1;c[r+4>>2]=ak;al=an}LF(al|0,V|0,ak)|0;a[al+ak|0]=0;Z=77;break L87}}while(0);ak=bT(-1,-1)|0;ao=ak;ap=M}}while(0);do{if((Z|0)==77){R=s;ak=d+16|0;c[R>>2]=c[ak>>2];c[R+4>>2]=c[ak+4>>2];c[R+8>>2]=c[ak+8>>2];z=0;aV(46,p|0,r|0,s|0,c[b+56>>2]|0);if(z){z=0;ak=bT(-1,-1)|0;R=ak;ak=M;if((a[r]&1)==0){ao=R;ap=ak;break}Lw(c[r+8>>2]|0);ao=R;ap=ak;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[Q]&1)!=0){Lw(c[p+8>>2]|0)}if((a[ac]&1)==0){break L54}Lw(c[q+8>>2]|0);break L54}}while(0);if((a[Q]&1)==0){at=ao;av=ap;break}Lw(c[p+8>>2]|0);at=ao;av=ap}}while(0);if((Z|0)==65){S=bT(-1,-1)|0;ag=M;if((a[Q]&1)!=0){Lw(c[p+8>>2]|0)}at=S;av=ag}if((a[ac]&1)==0){$=at;aa=av;break L45}Lw(c[q+8>>2]|0);$=at;aa=av;break L45}}while(0);L=c[P>>2]|0;if((a[U]&1)==0){ag=t;c[ag>>2]=c[U>>2];c[ag+4>>2]=c[U+4>>2];c[ag+8>>2]=c[U+8>>2]}else{ag=c[m+8>>2]|0;S=c[m+4>>2]|0;if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=86;break}return 0}if(S>>>0<11>>>0){a[t]=S<<1;aw=t+1|0}else{ak=S+16&-16;R=(z=0,au(248,ak|0)|0);if(z){z=0;Z=86;break}c[t+8>>2]=R;c[t>>2]=ak|1;c[t+4>>2]=S;aw=R}LF(aw|0,ag|0,S)|0;a[aw+S|0]=0}S=(z=0,aM(90,L|0,t|0)|0);if(z){z=0;L=bT(-1,-1)|0;ag=L;L=M;if((a[t]&1)==0){$=ag;aa=L;break}Lw(c[t+8>>2]|0);$=ag;aa=L;break}L=c[S>>2]|0;if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}S=c[L+28>>2]|0;ag=c[L+44>>2]|0;R=c[d+44>>2]|0;ak=c[(c[R>>2]|0)+20>>2]|0;V=b+8|0;an=b+56|0;am=(z=0,az(46,c[V>>2]|0,c[P>>2]|0,c[an>>2]|0)|0);if(z){z=0;Z=86;break}ax=(z=0,aM(ak|0,R|0,am|0)|0);if(z){z=0;Z=86;break}am=ax;ax=c[an>>2]|0;R=d+4|0;if((a[R]&1)==0){ak=v;c[ak>>2]=c[R>>2];c[ak+4>>2]=c[R+4>>2];c[ak+8>>2]=c[R+8>>2]}else{ak=c[d+12>>2]|0;ay=c[d+8>>2]|0;if(ay>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=86;break}return 0}if(ay>>>0<11>>>0){a[v]=ay<<1;aA=v+1|0}else{aB=ay+16&-16;aC=(z=0,au(248,aB|0)|0);if(z){z=0;Z=86;break}c[v+8>>2]=aC;c[v>>2]=aB|1;c[v+4>>2]=ay;aA=aC}LF(aA|0,ak|0,ay)|0;a[aA+ay|0]=0}ay=w;ak=d+16|0;c[ay>>2]=c[ak>>2];c[ay+4>>2]=c[ak+4>>2];c[ay+8>>2]=c[ak+8>>2];L158:do{if((a[K]&1)==0){aC=A;c[aC>>2]=c[K>>2];c[aC+4>>2]=c[K+4>>2];c[aC+8>>2]=c[K+8>>2];aE=a[aC]|0;aF=aC;Z=132}else{aC=c[d+40>>2]|0;aB=c[d+36>>2]|0;do{if(aB>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aB>>>0<11>>>0){aG=aB<<1&255;aH=A;a[aH]=aG;aJ=A+1|0;aK=aG;aL=aH}else{aH=aB+16&-16;aG=(z=0,au(248,aH|0)|0);if(z){z=0;break}c[A+8>>2]=aG;aN=aH|1;c[A>>2]=aN;c[A+4>>2]=aB;aJ=aG;aK=aN&255;aL=A}LF(aJ|0,aC|0,aB)|0;a[aJ+aB|0]=0;aE=aK;aF=aL;Z=132;break L158}}while(0);aB=bT(-1,-1)|0;aO=aB;aP=M}}while(0);do{if((Z|0)==132){aB=y;LI(aB|0,0,12)|0;aC=A;Q=aE&255;if((Q&1|0)==0){aQ=Q>>>1}else{aQ=c[A+4>>2]|0}Q=aQ+12|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=146;break}return 0}else{if(Q>>>0<11>>>0){a[aB]=24;aS=y+1|0}else{aN=aQ+28&-16;aG=(z=0,au(248,aN|0)|0);if(z){z=0;Z=146;break}c[y+8>>2]=aG;c[y>>2]=aN|1;c[y+4>>2]=12;aS=aG}LF(aS|0,11632,12)|0;a[aS+12|0]=0;if((a[aF]&1)==0){aT=aC+1|0}else{aT=c[A+8>>2]|0}z=0,az(88,y|0,aT|0,aQ|0)|0;if(z){z=0;Z=146;break}aG=x;LI(aG|0,0,12)|0;aN=a[aB]|0;aH=aN&255;if((aH&1|0)==0){aU=aH>>>1}else{aU=c[y+4>>2]|0}if((aN&1)==0){aW=y+1|0}else{aW=c[y+8>>2]|0}aN=aU+1|0;do{if(aN>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=162;break}return 0}else{if(aN>>>0<11>>>0){a[aG]=aU<<1;aX=x+1|0}else{aH=aU+17&-16;aY=(z=0,au(248,aH|0)|0);if(z){z=0;Z=162;break}c[x+8>>2]=aY;c[x>>2]=aH|1;c[x+4>>2]=aU;aX=aY}LF(aX|0,aW|0,aU)|0;a[aX+aU|0]=0;z=0,az(88,x|0,11064,1)|0;if(z){z=0;Z=162;break}aY=l;c[aY>>2]=c[ay>>2];c[aY+4>>2]=c[ay+4>>2];c[aY+8>>2]=c[ay+8>>2];z=0;aq(26,u|0,ax|0,v|0,l|0,x|0);if(z){z=0;aY=bT(-1,-1)|0;aH=aY;aY=M;if((a[aG]&1)==0){aZ=aH;a_=aY;break}Lw(c[x+8>>2]|0);aZ=aH;a_=aY;break}if((a[aG]&1)!=0){Lw(c[x+8>>2]|0)}if((a[aB]&1)!=0){Lw(c[y+8>>2]|0)}if((a[aF]&1)!=0){Lw(c[A+8>>2]|0)}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}c[an>>2]=u;aY=B+4|0;c[aY>>2]=0;c[B+8>>2]=0;c[B>>2]=aY;aY=B+12|0;c[aY>>2]=0;c[aY>>2]=c[L+48>>2];aY=d+28|0;L225:do{if((c[aY>>2]|0)==0){Z=260}else{aH=b+4|0;a$=c[aH>>2]|0;a0=(z=0,au(248,76)|0);if(z){z=0;Z=234;break}a1=a0;c[k>>2]=a1;a0=a$+4|0;a2=c[a0>>2]|0;if((a2|0)==(c[a$+8>>2]|0)){z=0;as(382,a$|0,k|0);if(z){z=0;Z=234;break}a3=c[k>>2]|0}else{if((a2|0)==0){a4=0}else{c[a2>>2]=a1;a4=c[a0>>2]|0}c[a0>>2]=a4+4;a3=a1}a1=a3;a2=a3;L236:do{if((a[R]&1)==0){a5=C;c[a5>>2]=c[R>>2];c[a5+4>>2]=c[R+4>>2];c[a5+8>>2]=c[R+8>>2];Z=191}else{a5=c[d+12>>2]|0;a6=c[d+8>>2]|0;do{if(a6>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(a6>>>0<11>>>0){a[C]=a6<<1;a7=C+1|0}else{a8=a6+16&-16;a9=(z=0,au(248,a8|0)|0);if(z){z=0;break}c[C+8>>2]=a9;c[C>>2]=a8|1;c[C+4>>2]=a6;a7=a9}LF(a7|0,a5|0,a6)|0;a[a7+a6|0]=0;Z=191;break L236}}while(0);a6=bT(-1,-1)|0;ba=a6;bb=M}}while(0);do{if((Z|0)==191){a6=D;c[a6>>2]=c[ak>>2];c[a6+4>>2]=c[ak+4>>2];c[a6+8>>2]=c[ak+8>>2];a5=F;a9=F;a[a9]=16;a8=a5+1|0;bc=a8|0;E=1852793664;a[bc]=E;E=E>>8;a[bc+1|0]=E;E=E>>8;a[bc+2|0]=E;E=E>>8;a[bc+3|0]=E;bc=a8+4|0;E=1953391988;a[bc]=E;E=E>>8;a[bc+1|0]=E;E=E>>8;a[bc+2|0]=E;E=E>>8;a[bc+3|0]=E;a[a5+9|0]=0;a5=c[aH>>2]|0;bc=(z=0,au(248,48)|0);L251:do{if(!z){a8=bc;c[j>>2]=a8;bd=a5+4|0;be=c[bd>>2]|0;if((be|0)==(c[a5+8>>2]|0)){z=0;as(382,a5|0,j|0);if(z){z=0;Z=237;break}bf=c[j>>2]|0}else{if((be|0)==0){bh=0}else{c[be>>2]=a8;bh=c[bd>>2]|0}c[bd>>2]=bh+4;bf=a8}a8=bf;be=bf;L261:do{if((a[R]&1)==0){bi=G;c[bi>>2]=c[R>>2];c[bi+4>>2]=c[R+4>>2];c[bi+8>>2]=c[R+8>>2];Z=208}else{bi=c[d+12>>2]|0;bj=c[d+8>>2]|0;do{if(bj>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bj>>>0<11>>>0){a[G]=bj<<1;bk=G+1|0}else{bl=bj+16&-16;bm=(z=0,au(248,bl|0)|0);if(z){z=0;break}c[G+8>>2]=bm;c[G>>2]=bl|1;c[G+4>>2]=bj;bk=bm}LF(bk|0,bi|0,bj)|0;a[bk+bj|0]=0;Z=208;break L261}}while(0);bj=bT(-1,-1)|0;bn=M;bo=bj}}while(0);do{if((Z|0)==208){bj=h;c[bj>>2]=c[ak>>2];c[bj+4>>2]=c[ak+4>>2];c[bj+8>>2]=c[ak+8>>2];z=0;aR(476,be|0,G|0,h|0);do{if(!z){bj=c[aY>>2]|0;bi=g;c[bi>>2]=c[a6>>2];c[bi+4>>2]=c[a6+4>>2];c[bi+8>>2]=c[a6+8>>2];z=0;aI(4,a2|0,C|0,g|0,F|0,be|0,bj|0,0);if(z){z=0;bp=0;break}if((a[G]&1)!=0){Lw(c[G+8>>2]|0)}if((a[a9]&1)!=0){Lw(c[F+8>>2]|0)}if((a[C]&1)!=0){Lw(c[C+8>>2]|0)}c[a3+48>>2]=c[P>>2];bj=(z=0,au(248,16)|0);if(z){z=0;Z=234;break L225}bi=H+8|0;c[bi>>2]=bj;c[H>>2]=17;c[H+4>>2]=11;LF(bj|0,10496,11)|0;a[bj+11|0]=0;bj=(z=0,aM(178,B|0,H|0)|0);if(!z){c[bj>>2]=a3;if((a[H]&1)==0){Z=260;break L225}Lw(c[bi>>2]|0);Z=260;break L225}else{z=0;bj=bT(-1,-1)|0;bm=bj;bj=M;if((a[H]&1)==0){bq=bm;br=bj;break L225}Lw(c[bi>>2]|0);bq=bm;br=bj;break L225}}else{z=0;bp=1}}while(0);bj=bT(-1,-1)|0;bm=bj;bj=M;if((a[G]&1)==0){if(bp){bn=bj;bo=bm;break}else{bs=bm;bt=bj;break L251}}else{Lw(c[G+8>>2]|0);if(bp){bn=bj;bo=bm;break}else{bs=bm;bt=bj;break L251}}}}while(0);be=c[a5>>2]|0;bj=c[bd>>2]|0;bm=be;while(1){if((bm|0)==(bj|0)){bu=bj;break}if((c[bm>>2]|0)==(bf|0)){bu=bm;break}else{bm=bm+4|0}}bm=bu-be>>2;bi=be+(bm+1<<2)|0;bl=bj-bi|0;LG(be+(bm<<2)|0,bi|0,bl|0)|0;bi=be+((bl>>2)+bm<<2)|0;bm=c[bd>>2]|0;if((bi|0)!=(bm|0)){c[bd>>2]=bm+(~((bm-4+(-bi|0)|0)>>>2)<<2)}Lw(a8);bs=bo;bt=bn}else{z=0;Z=237}}while(0);if((Z|0)==237){a5=bT(-1,-1)|0;bs=a5;bt=M}if((a[a9]&1)!=0){Lw(c[F+8>>2]|0)}if((a[C]&1)==0){ba=bs;bb=bt;break}Lw(c[C+8>>2]|0);ba=bs;bb=bt}}while(0);a2=c[a$>>2]|0;aH=c[a0>>2]|0;a5=a2;while(1){if((a5|0)==(aH|0)){bv=aH;break}if((c[a5>>2]|0)==(a3|0)){bv=a5;break}else{a5=a5+4|0}}a5=bv-a2>>2;a$=a2+(a5+1<<2)|0;a6=aH-a$|0;LG(a2+(a5<<2)|0,a$|0,a6|0)|0;a$=a2+((a6>>2)+a5<<2)|0;a5=c[a0>>2]|0;if((a$|0)!=(a5|0)){c[a0>>2]=a5+(~((a5-4+(-a$|0)|0)>>>2)<<2)}Lw(a1);bq=ba;br=bb}}while(0);L321:do{if((Z|0)==260){if((a[K]&1)==0){aY=J;c[aY>>2]=c[K>>2];c[aY+4>>2]=c[K+4>>2];c[aY+8>>2]=c[K+8>>2];bw=a[aY]|0;bx=aY}else{aY=c[d+40>>2]|0;a$=c[d+36>>2]|0;if(a$>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=234;break}return 0}if(a$>>>0<11>>>0){a5=a$<<1&255;a6=J;a[a6]=a5;by=J+1|0;bz=a5;bA=a6}else{a6=a$+16&-16;a5=(z=0,au(248,a6|0)|0);if(z){z=0;Z=234;break}c[J+8>>2]=a5;bc=a6|1;c[J>>2]=bc;c[J+4>>2]=a$;by=a5;bz=bc&255;bA=J}LF(by|0,aY|0,a$)|0;a[by+a$|0]=0;bw=bz;bx=bA}a$=I;LI(a$|0,0,12)|0;aY=J;bc=bw&255;if((bc&1|0)==0){bB=bc>>>1}else{bB=c[J+4>>2]|0}bc=bB+6|0;do{if(bc>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=284;break}return 0}else{if(bc>>>0<11>>>0){a[a$]=12;bC=I+1|0}else{a5=bB+22&-16;a6=(z=0,au(248,a5|0)|0);if(z){z=0;Z=284;break}c[I+8>>2]=a6;c[I>>2]=a5|1;c[I+4>>2]=6;bC=a6}a[bC]=a[10328]|0;a[bC+1|0]=a[10329]|0;a[bC+2|0]=a[10330]|0;a[bC+3|0]=a[10331]|0;a[bC+4|0]=a[10332]|0;a[bC+5|0]=a[10333]|0;a[bC+6|0]=0;if((a[bx]&1)==0){bD=aY+1|0}else{bD=c[J+8>>2]|0}z=0,az(88,I|0,bD|0,bB|0)|0;if(z){z=0;Z=284;break}z=0;aD(24,I|0,ag|0,am|0,c[b+4>>2]|0,B|0,c[V>>2]|0);if(z){z=0;a6=bT(-1,-1)|0;a5=a6;a6=M;if((a[a$]&1)==0){bE=a5;bF=a6;break}Lw(c[I+8>>2]|0);bE=a5;bF=a6;break}if((a[a$]&1)!=0){Lw(c[I+8>>2]|0)}if((a[bx]&1)!=0){Lw(c[J+8>>2]|0)}a6=c[P>>2]|0;c[P>>2]=B;a5=c[(c[b+24>>2]|0)-4>>2]|0;bi=S+32|0;bm=c[bi>>2]|0;bl=(c[S+36>>2]|0)-bm>>2;L364:do{if((bl|0)!=0){bG=b|0;bH=a5+28|0;bI=a5+36|0;bJ=a5+40|0;bK=a5+32|0;bL=bH;bM=0;bN=bm;while(1){bO=c[bN+(bM<<2)>>2]|0;bP=(z=0,aM(c[(c[bO>>2]|0)+16>>2]|0,bO|0,bG|0)|0);if(z){z=0;break}if((bP|0)!=0){c[f>>2]=bP;bO=c[bI>>2]|0;if((bO|0)==(c[bJ>>2]|0)){z=0;as(488,bK|0,f|0);if(z){z=0;break}bQ=c[f>>2]|0}else{if((bO|0)==0){bR=0}else{c[bO>>2]=bP;bR=c[bI>>2]|0}c[bI>>2]=bR+4;bQ=bP}z=0;as(c[c[bL>>2]>>2]|0,bH|0,bQ|0);if(z){z=0;break}}bP=bM+1|0;if(bP>>>0>=bl>>>0){break L364}bM=bP;bN=c[bi>>2]|0}bN=bT(-1,-1)|0;bS=M;bU=bN;Z=235;break L321}}while(0);c[P>>2]=a6;c[an>>2]=c[u>>2];g_(B|0,c[B+4>>2]|0);if((a[u+28|0]&1)!=0){Lw(c[u+36>>2]|0)}if((a[u+4|0]&1)!=0){Lw(c[u+12>>2]|0)}if((a[U]&1)==0){i=e;return 0}Lw(c[m+8>>2]|0);i=e;return 0}}while(0);if((Z|0)==284){aY=bT(-1,-1)|0;bc=M;if((a[a$]&1)!=0){Lw(c[I+8>>2]|0)}bE=aY;bF=bc}if((a[bx]&1)==0){bq=bE;br=bF;break}Lw(c[J+8>>2]|0);bq=bE;br=bF}}while(0);if((Z|0)==234){bc=bT(-1,-1)|0;bS=M;bU=bc;Z=235}if((Z|0)==235){bq=bU;br=bS}g_(B|0,c[B+4>>2]|0);if((a[u+28|0]&1)!=0){Lw(c[u+36>>2]|0)}if((a[u+4|0]&1)==0){$=bq;aa=br;break L45}Lw(c[u+12>>2]|0);$=bq;aa=br;break L45}}while(0);if((Z|0)==162){aN=bT(-1,-1)|0;bc=M;if((a[aG]&1)!=0){Lw(c[x+8>>2]|0)}aZ=aN;a_=bc}if((a[aB]&1)==0){bV=aZ;bW=a_;break}Lw(c[y+8>>2]|0);bV=aZ;bW=a_}}while(0);if((Z|0)==146){aC=bT(-1,-1)|0;Q=M;if((a[aB]&1)!=0){Lw(c[y+8>>2]|0)}bV=aC;bW=Q}if((a[aF]&1)==0){aO=bV;aP=bW;break}Lw(c[A+8>>2]|0);aO=bV;aP=bW}}while(0);if((a[v]&1)==0){$=aO;aa=aP;break}Lw(c[v+8>>2]|0);$=aO;aa=aP}}while(0);if((Z|0)==86){P=bT(-1,-1)|0;$=P;aa=M}if((a[U]&1)==0){bX=$;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;bg(b$|0)}Lw(c[m+8>>2]|0);bX=$;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;bg(b$|0)}}while(0);aa=bT(-1,-1)|0;$=M;if((a[U]&1)!=0){Lw(c[m+8>>2]|0)}m=aa;aa=$;if((a[O]&1)==0){bX=m;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;bg(b$|0)}Lw(c[n+8>>2]|0);bX=m;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;bg(b$|0);return 0}function md(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;e=i;i=i+128|0;f=e|0;g=e+16|0;h=e+32|0;j=e+40|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=e+112|0;p=c[b+16>>2]|0;q=Lu(16)|0;r=k+8|0;c[r>>2]=q;c[k>>2]=17;c[k+4>>2]=11;LF(q|0,10496,11)|0;a[q+11|0]=0;q=(z=0,aM(560,p|0,k|0)|0);if(z){z=0;p=bT(-1,-1)|0;s=p;p=M;if((a[k]&1)==0){t=p;u=s;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[r>>2]|0);t=p;u=s;v=u;w=0;x=v;y=t;bg(x|0)}if((a[k]&1)!=0){Lw(c[r>>2]|0)}if(!q){A=0;i=e;return A|0}q=b+4|0;r=c[q>>2]|0;k=Lu(48)|0;c[j>>2]=k;s=r+4|0;p=c[s>>2]|0;if((p|0)==(c[r+8>>2]|0)){e4(r|0,j);B=c[j>>2]|0}else{if((p|0)==0){C=0}else{c[p>>2]=k;C=c[s>>2]|0}c[s>>2]=C+4;B=k}k=B;C=B;p=d+4|0;L21:do{if((a[p]&1)==0){j=l;c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];D=22}else{j=c[d+12>>2]|0;F=c[d+8>>2]|0;do{if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(F>>>0<11>>>0){a[l]=F<<1;G=l+1|0}else{H=F+16&-16;I=(z=0,au(248,H|0)|0);if(z){z=0;break}c[l+8>>2]=I;c[l>>2]=H|1;c[l+4>>2]=F;G=I}LF(G|0,j|0,F)|0;a[G+F|0]=0;D=22;break L21}}while(0);F=bT(-1,-1)|0;J=M;K=F}}while(0);do{if((D|0)==22){G=m;F=d+16|0;c[G>>2]=c[F>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];j=n;I=n;a[I]=16;H=j+1|0;L=H|0;E=1852793664;a[L]=E;E=E>>8;a[L+1|0]=E;E=E>>8;a[L+2|0]=E;E=E>>8;a[L+3|0]=E;L=H+4|0;E=1953391988;a[L]=E;E=E>>8;a[L+1|0]=E;E=E>>8;a[L+2|0]=E;E=E>>8;a[L+3|0]=E;a[j+9|0]=0;j=c[q>>2]|0;L=(z=0,au(248,56)|0);L36:do{if(!z){H=L;c[h>>2]=H;N=j+4|0;O=c[N>>2]|0;if((O|0)==(c[j+8>>2]|0)){z=0;as(382,j|0,h|0);if(z){z=0;D=49;break}P=c[h>>2]|0}else{if((O|0)==0){Q=0}else{c[O>>2]=H;Q=c[N>>2]|0}c[N>>2]=Q+4;P=H}H=P;O=P;L46:do{if((a[p]&1)==0){R=o;c[R>>2]=c[p>>2];c[R+4>>2]=c[p+4>>2];c[R+8>>2]=c[p+8>>2];D=39}else{R=c[d+12>>2]|0;S=c[d+8>>2]|0;do{if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(S>>>0<11>>>0){a[o]=S<<1;T=o+1|0}else{U=S+16&-16;V=(z=0,au(248,U|0)|0);if(z){z=0;break}c[o+8>>2]=V;c[o>>2]=U|1;c[o+4>>2]=S;T=V}LF(T|0,R|0,S)|0;a[T+S|0]=0;D=39;break L46}}while(0);S=bT(-1,-1)|0;W=S;X=M}}while(0);do{if((D|0)==39){S=g;c[S>>2]=c[F>>2];c[S+4>>2]=c[F+4>>2];c[S+8>>2]=c[F+8>>2];z=0;aR(50,O|0,o|0,g|0);do{if(!z){S=f;c[S>>2]=c[G>>2];c[S+4>>2]=c[G+4>>2];c[S+8>>2]=c[G+8>>2];z=0;aD(40,C|0,l|0,f|0,n|0,O|0,0);if(z){z=0;Y=0;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[I]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}A=cV[c[(c[B>>2]|0)+16>>2]&1023](C,b|0)|0;i=e;return A|0}else{z=0;Y=1}}while(0);S=bT(-1,-1)|0;R=S;S=M;if((a[o]&1)==0){if(Y){W=R;X=S;break}else{Z=S;_=R;break L36}}else{Lw(c[o+8>>2]|0);if(Y){W=R;X=S;break}else{Z=S;_=R;break L36}}}}while(0);O=c[j>>2]|0;R=c[N>>2]|0;S=O;while(1){if((S|0)==(R|0)){$=R;break}if((c[S>>2]|0)==(P|0)){$=S;break}else{S=S+4|0}}S=$-O>>2;V=O+(S+1<<2)|0;U=R-V|0;LG(O+(S<<2)|0,V|0,U|0)|0;V=O+((U>>2)+S<<2)|0;S=c[N>>2]|0;if((V|0)!=(S|0)){c[N>>2]=S+(~((S-4+(-V|0)|0)>>>2)<<2)}Lw(H);Z=X;_=W}else{z=0;D=49}}while(0);if((D|0)==49){j=bT(-1,-1)|0;Z=M;_=j}if((a[I]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)==0){J=Z;K=_;break}Lw(c[l+8>>2]|0);J=Z;K=_}}while(0);_=c[r>>2]|0;r=c[s>>2]|0;Z=_;while(1){if((Z|0)==(r|0)){aa=r;break}if((c[Z>>2]|0)==(B|0)){aa=Z;break}else{Z=Z+4|0}}Z=aa-_>>2;aa=_+(Z+1<<2)|0;B=r-aa|0;LG(_+(Z<<2)|0,aa|0,B|0)|0;aa=_+((B>>2)+Z<<2)|0;Z=c[s>>2]|0;if((aa|0)!=(Z|0)){c[s>>2]=Z+(~((Z-4+(-aa|0)|0)>>>2)<<2)}Lw(k);t=J;u=K;v=u;w=0;x=v;y=t;bg(x|0);return 0}function me(a,b){a=a|0;b=b|0;return mL(a,b)|0}function mf(a){a=a|0;g$(a);return}function mg(a){a=a|0;var b=0;z=0;ar(538,a|0);if(!z){Lw(a);return}else{z=0;b=bT(-1,-1)|0;Lw(a);bg(b|0)}}function mh(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mi(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mj(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mk(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function ml(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mm(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mn(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mo(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mp(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mq(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mr(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function ms(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mt(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mu(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mv(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mw(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mx(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function my(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mz(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mA(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mB(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mC(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mD(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mE(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mF(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mG(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mH(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mI(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mJ(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mK(a,b){a=a|0;b=b|0;return mL(a,b|0)|0}function mL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0;e=i;i=i+160|0;f=e|0;g=e+16|0;h=e+32|0;j=e+40|0;k=e+56|0;l=e+64|0;m=e+80|0;n=e+96|0;o=e+112|0;p=e+128|0;q=e+144|0;r=Lu(64)|0;s=l+8|0;c[s>>2]=r;c[l>>2]=65;c[l+4>>2]=62;LF(r|0,10040,62)|0;a[r+62|0]=0;r=d+4|0;L1:do{if((a[r]&1)==0){t=m;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];u=11}else{t=c[d+12>>2]|0;v=c[d+8>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(v>>>0<11>>>0){a[m]=v<<1;w=m+1|0}else{x=v+16&-16;y=(z=0,au(248,x|0)|0);if(z){z=0;break}c[m+8>>2]=y;c[m>>2]=x|1;c[m+4>>2]=v;w=y}LF(w|0,t|0,v)|0;a[w+v|0]=0;u=11;break L1}}while(0);v=bT(-1,-1)|0;A=v;B=M}}while(0);do{if((u|0)==11){w=n;r=d+16|0;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];z=0;aV(46,l|0,m|0,n|0,c[b+56>>2]|0);if(z){z=0;r=bT(-1,-1)|0;w=r;r=M;if((a[m]&1)==0){A=w;B=r;break}Lw(c[m+8>>2]|0);A=w;B=r;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}if((a[l]&1)!=0){Lw(c[s>>2]|0)}r=b+4|0;w=c[r>>2]|0;v=Lu(52)|0;c[k>>2]=v;t=w+4|0;y=c[t>>2]|0;if((y|0)==(c[w+8>>2]|0)){e4(w|0,k);C=c[k>>2]|0}else{if((y|0)==0){D=0}else{c[y>>2]=v;D=c[t>>2]|0}c[t>>2]=D+4;C=v}v=C;y=C;x=o;a[x]=0;a[o+1|0]=0;E=(z=0,au(248,32)|0);if(!z){LF(E|0,9848,24)|0;a[E+24|0]=0;L35:do{if((d|0)==0){z=0;aS(10);if(!z){return 0}else{z=0;F=bT(-1,-1)|0;G=M;H=F;u=58;break}}else{F=c[(c[(c[d>>2]|0)-4>>2]|0)+4>>2]|0;I=p;LI(I|0,0,12)|0;J=LJ(F|0)|0;K=J+24|0;do{if(K>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(K>>>0<11>>>0){a[I]=48;L=p+1|0}else{N=J+40&-16;O=(z=0,au(248,N|0)|0);if(z){z=0;break}c[p+8>>2]=O;c[p>>2]=N|1;c[p+4>>2]=24;L=O}LF(L|0,E|0,24)|0;a[L+24|0]=0;z=0,az(88,p|0,F|0,J|0)|0;if(z){z=0;break}c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;z=0;aq(28,y|0,o|0,j|0,p|0,0);if(z){z=0;O=bT(-1,-1)|0;N=O;O=M;if((a[I]&1)==0){P=N;Q=O;break L35}Lw(c[p+8>>2]|0);P=N;Q=O;break L35}if((a[I]&1)!=0){Lw(c[p+8>>2]|0)}Lw(E);if((a[x]&1)!=0){Lw(c[o+8>>2]|0)}O=c[r>>2]|0;N=Lu(32)|0;c[h>>2]=N;R=O+4|0;S=c[R>>2]|0;if((S|0)==(c[O+8>>2]|0)){e4(O|0,h);T=c[h>>2]|0}else{if((S|0)==0){U=0}else{c[S>>2]=N;U=c[R>>2]|0}c[R>>2]=U+4;T=N}N=T;S=q;a[S]=0;a[q+1|0]=0;V=f;W=T;c[V>>2]=c[S>>2];c[V+4>>2]=c[S+4>>2];c[V+8>>2]=c[S+8>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;z=0;aR(424,W|0,f|0,g|0);if(!z){if((a[V]&1)==0){X=T|0;c[X>>2]=17568;Y=T+28|0;Z=C;c[Y>>2]=Z;i=e;return W|0}Lw(c[f+8>>2]|0);X=T|0;c[X>>2]=17568;Y=T+28|0;Z=C;c[Y>>2]=Z;i=e;return W|0}else{z=0}W=bT(-1,-1)|0;S=M;if((a[V]&1)!=0){Lw(c[f+8>>2]|0)}V=W;W=S;S=c[O>>2]|0;O=c[R>>2]|0;_=S;while(1){if((_|0)==(O|0)){$=O;break}if((c[_>>2]|0)==(T|0)){$=_;break}else{_=_+4|0}}_=$-S>>2;aa=S+(_+1<<2)|0;ab=O-aa|0;LG(S+(_<<2)|0,aa|0,ab|0)|0;aa=S+((ab>>2)+_<<2)|0;_=c[R>>2]|0;if((aa|0)!=(_|0)){c[R>>2]=_+(~((_-4+(-aa|0)|0)>>>2)<<2)}Lw(N);ac=V;ad=W;ae=ac;af=0;ag=ae;ah=ad;bg(ag|0)}}while(0);J=bT(-1,-1)|0;F=M;if((a[I]&1)==0){G=F;H=J;u=58;break}Lw(c[p+8>>2]|0);G=F;H=J;u=58}}while(0);if((u|0)==58){P=H;Q=G}Lw(E);ai=P;aj=Q}else{z=0;r=bT(-1,-1)|0;ai=r;aj=M}if((a[x]&1)!=0){Lw(c[o+8>>2]|0)}r=c[w>>2]|0;y=c[t>>2]|0;J=r;while(1){if((J|0)==(y|0)){ak=y;break}if((c[J>>2]|0)==(C|0)){ak=J;break}else{J=J+4|0}}J=ak-r>>2;w=r+(J+1<<2)|0;x=y-w|0;LG(r+(J<<2)|0,w|0,x|0)|0;w=r+((x>>2)+J<<2)|0;J=c[t>>2]|0;if((w|0)!=(J|0)){c[t>>2]=J+(~((J-4+(-w|0)|0)>>>2)<<2)}Lw(v);ac=ai;ad=aj;ae=ac;af=0;ag=ae;ah=ad;bg(ag|0)}}while(0);if((a[l]&1)==0){ac=A;ad=B;ae=ac;af=0;ag=ae;ah=ad;bg(ag|0)}Lw(c[s>>2]|0);ac=A;ad=B;ae=ac;af=0;ag=ae;ah=ad;bg(ag|0);return 0}function mM(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function mN(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function mO(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+48>>2]&1023](b,a);return}function mP(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function mQ(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function mR(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function mS(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function mT(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+48>>2]&511](a,d,b);return}function mU(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+48>>2]&511](a,d,b);return}function mV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;g=i;i=i+32|0;h=g|0;j=g+8|0;k=g+16|0;gM(b|0,d);d=b+12|0;l=d|0;m=b+16|0;c[m>>2]=0;n=b+20|0;c[n>>2]=0;o=m;c[l>>2]=o;m=c[e>>2]|0;p=e+4|0;if((m|0)==(p|0)){q=b+24|0;r=c[f>>2]|0;c[q>>2]=r;i=g;return}e=j|0;s=k|0;t=b+16|0;u=m;while(1){m=u+16|0;c[e>>2]=o;v=mW(d,j,h,m)|0;if((c[v>>2]|0)==0){z=0;aR(248,k|0,d|0,m|0);if(z){z=0;break}m=c[s>>2]|0;c[s>>2]=0;w=c[h>>2]|0;x=m|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=w;c[v>>2]=x;w=c[c[l>>2]>>2]|0;if((w|0)==0){y=x}else{c[l>>2]=w;y=c[v>>2]|0}e2(c[t>>2]|0,y);c[n>>2]=(c[n>>2]|0)+1}v=c[u+4>>2]|0;if((v|0)==0){w=u|0;while(1){x=c[w+8>>2]|0;if((w|0)==(c[x>>2]|0)){A=x;break}else{w=x}}}else{w=v;while(1){x=c[w>>2]|0;if((x|0)==0){A=w;break}else{w=x}}}if((A|0)==(p|0)){B=22;break}else{u=A}}if((B|0)==22){q=b+24|0;r=c[f>>2]|0;c[q>>2]=r;i=g;return}g=bT(-1,-1)|0;fc(d,c[t>>2]|0);t=b|0;d=c[t>>2]|0;if((d|0)==0){bg(g|0)}r=b+4|0;b=c[r>>2]|0;if((d|0)==(b|0)){C=d}else{q=b;while(1){b=q-12|0;c[r>>2]=b;if((a[b]&1)==0){D=b}else{Lw(c[q-12+8>>2]|0);D=c[r>>2]|0}if((d|0)==(D|0)){break}else{q=D}}C=c[t>>2]|0}Lw(C);bg(g|0)}function mW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=i;h=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[h>>2];h=b+4|0;j=c[d>>2]|0;do{if((j|0)!=(h|0)){d=f;k=a[f]|0;l=k&255;m=(l&1|0)==0;if(m){n=l>>>1}else{n=c[f+4>>2]|0}o=j+16|0;p=o;q=a[o]|0;o=q&255;r=(o&1|0)==0;if(r){s=o>>>1}else{s=c[j+20>>2]|0}t=(k&1)==0;if(t){u=d+1|0}else{u=c[f+8>>2]|0}k=(q&1)==0;if(k){v=p+1|0}else{v=c[j+24>>2]|0}q=LH(u|0,v|0,(s>>>0<n>>>0?s:n)|0)|0;if((q|0)==0){if(n>>>0<s>>>0){break}}else{if((q|0)<0){break}}if(r){w=o>>>1}else{w=c[j+20>>2]|0}if(m){x=l>>>1}else{x=c[f+4>>2]|0}if(k){y=p+1|0}else{y=c[j+24>>2]|0}if(t){z=d+1|0}else{z=c[f+8>>2]|0}p=LH(y|0,z|0,(x>>>0<w>>>0?x:w)|0)|0;if((p|0)==0){if(w>>>0>=x>>>0){A=80}}else{if((p|0)>=0){A=80}}if((A|0)==80){c[e>>2]=j;B=e;i=g;return B|0}p=j+4|0;k=c[p>>2]|0;o=(k|0)==0;if(o){r=j|0;while(1){q=c[r+8>>2]|0;if((r|0)==(c[q>>2]|0)){C=q;break}else{r=q}}}else{r=k;while(1){q=c[r>>2]|0;if((q|0)==0){C=r;break}else{r=q}}}do{if((C|0)!=(h|0)){if(m){D=l>>>1}else{D=c[f+4>>2]|0}r=C+16|0;k=a[r]|0;q=k&255;if((q&1|0)==0){E=q>>>1}else{E=c[C+20>>2]|0}if(t){F=d+1|0}else{F=c[f+8>>2]|0}if((k&1)==0){G=r+1|0}else{G=c[C+24>>2]|0}r=LH(F|0,G|0,(E>>>0<D>>>0?E:D)|0)|0;if((r|0)==0){if(D>>>0<E>>>0){break}}else{if((r|0)<0){break}}B=e1(b,e,f)|0;i=g;return B|0}}while(0);if(o){c[e>>2]=j;B=p;i=g;return B|0}else{c[e>>2]=C;B=C|0;i=g;return B|0}}}while(0);C=c[j>>2]|0;do{if((j|0)==(c[b>>2]|0)){H=j}else{if((C|0)==0){E=j|0;while(1){D=c[E+8>>2]|0;if((E|0)==(c[D>>2]|0)){E=D}else{I=D;break}}}else{E=C;while(1){p=c[E+4>>2]|0;if((p|0)==0){I=E;break}else{E=p}}}E=I;p=I+16|0;o=a[p]|0;D=o&255;if((D&1|0)==0){J=D>>>1}else{J=c[I+20>>2]|0}D=a[f]|0;G=D&255;if((G&1|0)==0){K=G>>>1}else{K=c[f+4>>2]|0}if((o&1)==0){L=p+1|0}else{L=c[I+24>>2]|0}if((D&1)==0){M=f+1|0}else{M=c[f+8>>2]|0}D=LH(L|0,M|0,(K>>>0<J>>>0?K:J)|0)|0;if((D|0)==0){if(J>>>0<K>>>0){H=E;break}}else{if((D|0)<0){H=E;break}}B=e1(b,e,f)|0;i=g;return B|0}}while(0);if((C|0)==0){c[e>>2]=j;B=j|0;i=g;return B|0}else{c[e>>2]=H;B=H+4|0;i=g;return B|0}return 0}function mX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f|0;h=d+4|0;d=Lu(28)|0;j=d;k=f+8|0;l=g|0;a[l]=a[k]|0;a[l+1|0]=a[k+1|0]|0;a[l+2|0]=a[k+2|0]|0;k=g|0;g=d+16|0;L1:do{if((g|0)!=0){l=e;if((a[l]&1)==0){c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];break}l=c[e+8>>2]|0;m=c[e+4>>2]|0;do{if(m>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(m>>>0<11>>>0){a[g]=m<<1;n=d+17|0}else{o=m+16&-16;p=(z=0,au(248,o|0)|0);if(z){z=0;break}c[d+24>>2]=p;c[g>>2]=o|1;c[d+20>>2]=m;n=p}LF(n|0,l|0,m)|0;a[n+m|0]=0;break L1}}while(0);m=bT(-1,-1)|0;if((d|0)==0){bg(m|0)}Lw(d);bg(m|0)}}while(0);c[b>>2]=j;c[b+4>>2]=h;a[b+8|0]=1;h=b+9|0;a[h]=a[k]|0;a[h+1|0]=a[k+1|0]|0;a[h+2|0]=a[k+2|0]|0;i=f;return}function mY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+24|0;e=d|0;f=a+8|0;g=f;h=a+4|0;j=c[h>>2]|0;k=a|0;l=c[k>>2]|0;m=l;n=(j-m|0)/28|0;o=n+1|0;if(o>>>0>153391689>>>0){IU(0)}p=((c[f>>2]|0)-m|0)/28|0;if(p>>>0>76695843>>>0){m=e+12|0;c[m>>2]=0;c[e+16>>2]=g;q=153391689;r=m;s=6}else{m=p<<1;p=m>>>0<o>>>0?o:m;m=e+12|0;c[m>>2]=0;c[e+16>>2]=g;if((p|0)==0){t=0;u=0;v=m}else{q=p;r=m;s=6}}if((s|0)==6){t=Lu(q*28|0)|0;u=q;v=r}r=e|0;c[r>>2]=t;q=t+(n*28|0)|0;m=e+8|0;c[m>>2]=q;p=e+4|0;c[p>>2]=q;g=t+(u*28|0)|0;c[v>>2]=g;do{if((q|0)==0){w=l;x=j}else{z=0;as(544,q|0,b|0);if(!z){w=c[k>>2]|0;x=c[h>>2]|0;break}else{z=0}u=bT(-1,-1)|0;y=M;A=u;mZ(e);bg(A|0)}}while(0);b=t+((n+1|0)*28|0)|0;c[m>>2]=b;if((x|0)==(w|0)){B=x;C=q;D=x;c[k>>2]=C;c[p>>2]=B;c[h>>2]=b;c[m>>2]=D;E=a+8|0;F=c[E>>2]|0;c[E>>2]=g;c[v>>2]=F;c[r>>2]=B;mZ(e);i=d;return}else{G=x;H=q}while(1){I=H-28|0;q=G-28|0;if((I|0)!=0){z=0;as(544,I|0,q|0);if(z){z=0;s=16;break}}c[p>>2]=I;if((q|0)==(w|0)){s=14;break}else{G=q;H=I}}if((s|0)==16){H=bT(-1,-1)|0;y=M;A=H;mZ(e);bg(A|0)}else if((s|0)==14){B=c[k>>2]|0;C=I;D=c[h>>2]|0;c[k>>2]=C;c[p>>2]=B;c[h>>2]=b;c[m>>2]=D;E=a+8|0;F=c[E>>2]|0;c[E>>2]=g;c[v>>2]=F;c[r>>2]=B;mZ(e);i=d;return}}function mZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=c[b+4>>2]|0;e=b+8|0;f=c[e>>2]|0;if((d|0)!=(f|0)){g=f;do{f=g-28|0;c[e>>2]=f;fc(g-28+12|0,c[g-28+16>>2]|0);h=f|0;f=c[h>>2]|0;if((f|0)!=0){i=g-28+4|0;j=c[i>>2]|0;if((f|0)==(j|0)){k=f}else{l=j;while(1){j=l-12|0;c[i>>2]=j;if((a[j]&1)==0){m=j}else{Lw(c[l-12+8>>2]|0);m=c[i>>2]|0}if((f|0)==(m|0)){break}else{l=m}}k=c[h>>2]|0}Lw(k)}g=c[e>>2]|0;}while((d|0)!=(g|0))}g=c[b>>2]|0;if((g|0)==0){return}Lw(g);return}function m_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;gM(b|0,d|0);j=b+12|0;k=j|0;l=b+16|0;c[l>>2]=0;m=b+20|0;c[m>>2]=0;n=l;c[k>>2]=n;l=c[d+12>>2]|0;o=d+16|0;if((l|0)==(o|0)){p=b+24|0;q=d+24|0;r=c[q>>2]|0;c[p>>2]=r;i=e;return}s=g|0;t=h|0;u=b+16|0;v=l;while(1){l=v+16|0;c[s>>2]=n;w=mW(j,g,f,l)|0;if((c[w>>2]|0)==0){z=0;aR(248,h|0,j|0,l|0);if(z){z=0;break}l=c[t>>2]|0;c[t>>2]=0;x=c[f>>2]|0;y=l|0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=x;c[w>>2]=y;x=c[c[k>>2]>>2]|0;if((x|0)==0){A=y}else{c[k>>2]=x;A=c[w>>2]|0}e2(c[u>>2]|0,A);c[m>>2]=(c[m>>2]|0)+1}w=c[v+4>>2]|0;if((w|0)==0){x=v|0;while(1){y=c[x+8>>2]|0;if((x|0)==(c[y>>2]|0)){B=y;break}else{x=y}}}else{x=w;while(1){y=c[x>>2]|0;if((y|0)==0){B=x;break}else{x=y}}}if((B|0)==(o|0)){C=24;break}else{v=B}}if((C|0)==24){p=b+24|0;q=d+24|0;r=c[q>>2]|0;c[p>>2]=r;i=e;return}e=bT(-1,-1)|0;fc(j,c[u>>2]|0);u=b|0;j=c[u>>2]|0;if((j|0)==0){bg(e|0)}r=b+4|0;b=c[r>>2]|0;if((j|0)==(b|0)){D=j}else{p=b;while(1){b=p-12|0;c[r>>2]=b;if((a[b]&1)==0){E=b}else{Lw(c[p-12+8>>2]|0);E=c[r>>2]|0}if((j|0)==(E|0)){break}else{p=E}}D=c[u>>2]|0}Lw(D);bg(e|0)}function m$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=(f&1|0)==0;j=f>>>1;f=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;e=g;while(1){g=e+16|0;if(i){m=j}else{m=c[l>>2]|0}n=g;o=a[g]|0;g=o&255;p=(g&1|0)==0;if(p){q=g>>>1}else{q=c[e+20>>2]|0}if(f){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=LH(r|0,t|0,(q>>>0<m>>>0?q:m)|0)|0;if((o|0)==0){if(m>>>0<q>>>0){u=16}}else{if((o|0)<0){u=16}}if((u|0)==16){u=0;v=e|0;o=c[v>>2]|0;if((o|0)==0){u=17;break}else{e=o;continue}}if(p){w=g>>>1}else{w=c[e+20>>2]|0}if(i){x=j}else{x=c[l>>2]|0}if(s){y=n+1|0}else{y=c[e+24>>2]|0}if(f){z=b}else{z=c[k>>2]|0}n=LH(y|0,z|0,(x>>>0<w>>>0?x:w)|0)|0;if((n|0)==0){if(w>>>0>=x>>>0){u=33;break}}else{if((n|0)>=0){u=33;break}}A=e+4|0;n=c[A>>2]|0;if((n|0)==0){u=32;break}else{e=n}}if((u|0)==17){c[d>>2]=e;h=v;return h|0}else if((u|0)==32){c[d>>2]=e;h=A;return h|0}else if((u|0)==33){c[d>>2]=e;h=d;return h|0}return 0}function m0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=d+4|0;d=Lu(40)|0;g=d;h=d+16|0;L1:do{if((h|0)!=0){i=e;if((a[i]&1)==0){c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];break}i=c[e+8>>2]|0;j=c[e+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(j>>>0<11>>>0){a[h]=j<<1;k=d+17|0}else{l=j+16&-16;m=(z=0,au(248,l|0)|0);if(z){z=0;break}c[d+24>>2]=m;c[h>>2]=l|1;c[d+20>>2]=j;k=m}LF(k|0,i|0,j)|0;a[k+j|0]=0;break L1}}while(0);j=bT(-1,-1)|0;if((d|0)==0){bg(j|0)}Lw(d);bg(j|0)}}while(0);k=d+28|0;if((k|0)==0){n=b|0;c[n>>2]=g;o=b+4|0;c[o>>2]=f;p=b+8|0;a[p]=1;q=b+9|0;a[q]=1;return}c[k>>2]=0;c[d+32>>2]=0;c[d+36>>2]=0;n=b|0;c[n>>2]=g;o=b+4|0;c[o>>2]=f;p=b+8|0;a[p]=1;q=b+9|0;a[q]=1;return}function m1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;e=c[d>>2]|0;f=a|0;g=c[f>>2]|0;h=g;i=e-h>>3;j=i+1|0;if(j>>>0>536870911>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-h|0;if(a>>3>>>0>268435454>>>0){l=536870911;m=5}else{n=a>>2;a=n>>>0<j>>>0?j:n;if((a|0)==0){o=0;p=0}else{l=a;m=5}}if((m|0)==5){o=Lu(l<<3)|0;p=l}l=o+(i<<3)|0;m=o+(p<<3)|0;if((l|0)!=0){c[l>>2]=c[b>>2];c[o+(i<<3)+4>>2]=c[b+4>>2]}b=o+(j<<3)|0;if((e|0)==(g|0)){q=e;r=l}else{j=i-1-((e-8+(-h|0)|0)>>>3)|0;h=e;e=l;while(1){l=e-8|0;i=h-8|0;if((l|0)!=0){c[l>>2]=c[i>>2];c[e-8+4>>2]=c[h-8+4>>2]}if((i|0)==(g|0)){break}else{h=i;e=l}}q=c[f>>2]|0;r=o+(j<<3)|0}c[f>>2]=r;c[d>>2]=b;c[k>>2]=m;if((q|0)==0){return}Lw(q);return}function m2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b+4|0;f=e|0;g=c[f>>2]|0;if((g|0)==0){h=f;i=e}else{e=d|0;f=g;while(1){if(dk(e,f+16|0)|0){g=f|0;j=c[g>>2]|0;if((j|0)==0){h=g;i=f;break}else{f=j;continue}}else{j=f+4|0;g=c[j>>2]|0;if((g|0)==0){h=j;i=f;break}else{f=g;continue}}}}f=Lu(80)|0;e=f;g=f+16|0;do{if((g|0)!=0){z=0;as(326,g|0,d|0);if(!z){c[f+76>>2]=c[d+60>>2];break}else{z=0}j=bT(-1,-1)|0;if((f|0)==0){bg(j|0)}Lw(f);bg(j|0)}}while(0);d=f;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=i;c[h>>2]=d;i=b|0;f=c[c[i>>2]>>2]|0;if((f|0)==0){k=d}else{c[i>>2]=f;k=c[h>>2]|0}e2(c[b+4>>2]|0,k);k=b+8|0;c[k>>2]=(c[k>>2]|0)+1;c[a>>2]=e;return}function m3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function m4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function m5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function m6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function m7(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aV(6,m|0,k|0,l|0,h|0);if(z){z=0;h=bT(-1,-1)|0;l=h;h=M;if((a[k]&1)==0){r=h;s=l;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=h;s=l;t=s;u=0;v=t;w=r;bg(v|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=b|0;c[k>>2]=22784;l=b+32|0;h=f;if((a[h]&1)==0){m=l;c[m>>2]=c[h>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];x=b+44|0;c[x>>2]=g;i=j;return}h=c[f+8>>2]|0;m=c[f+4>>2]|0;do{if(m>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(m>>>0<11>>>0){a[l]=m<<1;y=l+1|0}else{f=m+16&-16;p=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=p;c[l>>2]=f|1;c[b+36>>2]=m;y=p}LF(y|0,h|0,m)|0;a[y+m|0]=0;x=b+44|0;c[x>>2]=g;i=j;return}}while(0);j=bT(-1,-1)|0;g=j;j=M;c[k>>2]=17512;if((a[b+4|0]&1)==0){r=j;s=g;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[b+12>>2]|0);r=j;s=g;t=s;u=0;v=t;w=r;bg(v|0)}function m8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aR(424,k|0,h|0,j|0);if(!z){if((a[h]&1)==0){p=b|0;c[p>>2]=17080;q=b+28|0;c[q>>2]=f;i=g;return}Lw(c[h+8>>2]|0);p=b|0;c[p>>2]=17080;q=b+28|0;c[q>>2]=f;i=g;return}else{z=0;g=bT(-1,-1)|0;if((a[h]&1)==0){bg(g|0)}Lw(c[h+8>>2]|0);bg(g|0)}}function m9(b){b=b|0;var d=0;d=b|0;c[d>>2]=22784;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function na(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=22784;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function nb(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+88>>2]&1023](b,a);return}function nc(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function nd(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function ne(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function nf(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function ng(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+88>>2]&511](a,d,b);return}function nh(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+88>>2]&511](a,d,b);return}function ni(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=d;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+8>>2]|0;j=c[d+4>>2]|0;if(j>>>0>4294967279>>>0){D5(0)}if(j>>>0<11>>>0){d=j<<1&255;n=h;a[n]=d;o=h+1|0;p=d;q=n}else{n=j+16&-16;d=Lu(n)|0;c[h+8>>2]=d;r=n|1;c[h>>2]=r;c[h+4>>2]=j;o=d;p=r&255;q=h}LF(o|0,k|0,j)|0;a[o+j|0]=0;l=p;m=q}q=e;e=g;c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];q=g;g=b|0;c[g>>2]=17512;e=b+4|0;L12:do{if((l&1)==0){p=e;c[p>>2]=c[m>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2]}else{p=c[h+8>>2]|0;j=c[h+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(j>>>0<11>>>0){a[e]=j<<1;s=e+1|0}else{o=j+16&-16;k=(z=0,au(248,o|0)|0);if(z){z=0;break}c[b+12>>2]=k;c[e>>2]=o|1;c[b+8>>2]=j;s=k}LF(s|0,p|0,j)|0;a[s+j|0]=0;break L12}}while(0);j=bT(-1,-1)|0;if((a[m]&1)==0){bg(j|0)}Lw(p);bg(j|0)}}while(0);s=b+16|0;c[s>>2]=c[q>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];if((a[m]&1)==0){t=b+28|0;u=b+32|0;c[u>>2]=0;v=b+36|0;c[v>>2]=0;w=b+40|0;c[w>>2]=0;c[g>>2]=22704;c[t>>2]=22752;x=b+44|0;a[x]=0;y=b+45|0;a[y]=0;i=f;return}Lw(c[h+8>>2]|0);t=b+28|0;u=b+32|0;c[u>>2]=0;v=b+36|0;c[v>>2]=0;w=b+40|0;c[w>>2]=0;c[g>>2]=22704;c[t>>2]=22752;x=b+44|0;a[x]=0;y=b+45|0;a[y]=0;i=f;return}function nj(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+28>>2]=22512;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function nk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+28>>2]=22512;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){h=b;Lw(h);return}Lw(c[b+12>>2]|0);h=b;Lw(h);return}function nl(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+156>>2]&1023](b,a);return}function nm(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function nn(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function no(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function np(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function nq(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+156>>2]&511](a,d,b);return}function nr(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+156>>2]&511](a,d,b);return}function ns(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+240|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;if((c[d+40>>2]|0)!=0){L3:do{if((a[b+45|0]&1)!=0){v=Lu(80)|0;w=f+8|0;c[w>>2]=v;c[f>>2]=81;c[f+4>>2]=71;LF(v|0,8288,71)|0;a[v+71|0]=0;v=d+4|0;L5:do{if((a[v]&1)==0){x=g;c[x>>2]=c[v>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];y=13}else{x=c[d+12>>2]|0;A=c[d+8>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(A>>>0<11>>>0){a[g]=A<<1;B=g+1|0}else{C=A+16&-16;D=(z=0,au(248,C|0)|0);if(z){z=0;break}c[g+8>>2]=D;c[g>>2]=C|1;c[g+4>>2]=A;B=D}LF(B|0,x|0,A)|0;a[B+A|0]=0;y=13;break L5}}while(0);A=bT(-1,-1)|0;E=M;F=A}}while(0);do{if((y|0)==13){v=h;A=d+16|0;c[v>>2]=c[A>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];z=0;aR(382,f|0,g|0,h|0);if(z){z=0;A=bT(-1,-1)|0;v=A;A=M;if((a[g]&1)==0){E=A;F=v;break}Lw(c[g+8>>2]|0);E=A;F=v;break}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}if((a[f]&1)==0){break L3}Lw(c[w>>2]|0);break L3}}while(0);if((a[f]&1)==0){G=E;H=F;I=H;J=0;K=I;L=G;bg(K|0)}Lw(c[w>>2]|0);G=E;H=F;I=H;J=0;K=I;L=G;bg(K|0)}}while(0);a[b+44|0]=1;i=e;return}F=b+45|0;E=(a[F]&1)!=0;if((a[d+44|0]&1)!=0){L38:do{if(E){f=Lu(80)|0;g=j+8|0;c[g>>2]=f;c[j>>2]=81;c[j+4>>2]=72;LF(f|0,8128,72)|0;a[f+72|0]=0;f=d+4|0;L40:do{if((a[f]&1)==0){h=k;c[h>>2]=c[f>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];y=36}else{h=c[d+12>>2]|0;B=c[d+8>>2]|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(B>>>0<11>>>0){a[k]=B<<1;N=k+1|0}else{v=B+16&-16;A=(z=0,au(248,v|0)|0);if(z){z=0;break}c[k+8>>2]=A;c[k>>2]=v|1;c[k+4>>2]=B;N=A}LF(N|0,h|0,B)|0;a[N+B|0]=0;y=36;break L40}}while(0);B=bT(-1,-1)|0;O=M;P=B}}while(0);do{if((y|0)==36){f=l;w=d+16|0;c[f>>2]=c[w>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];z=0;aR(382,j|0,k|0,l|0);if(z){z=0;w=bT(-1,-1)|0;f=w;w=M;if((a[k]&1)==0){O=w;P=f;break}Lw(c[k+8>>2]|0);O=w;P=f;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((a[j]&1)==0){break L38}Lw(c[g>>2]|0);break L38}}while(0);if((a[j]&1)==0){G=O;H=P;I=H;J=0;K=I;L=G;bg(K|0)}Lw(c[g>>2]|0);G=O;H=P;I=H;J=0;K=I;L=G;bg(K|0)}}while(0);L69:do{if((a[b+44|0]&1)!=0){P=Lu(80)|0;O=m+8|0;c[O>>2]=P;c[m>>2]=81;c[m+4>>2]=71;LF(P|0,8288,71)|0;a[P+71|0]=0;P=d+4|0;L71:do{if((a[P]&1)==0){j=n;c[j>>2]=c[P>>2];c[j+4>>2]=c[P+4>>2];c[j+8>>2]=c[P+8>>2];y=57}else{j=c[d+12>>2]|0;k=c[d+8>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[n]=k<<1;Q=n+1|0}else{l=k+16&-16;N=(z=0,au(248,l|0)|0);if(z){z=0;break}c[n+8>>2]=N;c[n>>2]=l|1;c[n+4>>2]=k;Q=N}LF(Q|0,j|0,k)|0;a[Q+k|0]=0;y=57;break L71}}while(0);k=bT(-1,-1)|0;R=M;S=k}}while(0);do{if((y|0)==57){P=o;g=d+16|0;c[P>>2]=c[g>>2];c[P+4>>2]=c[g+4>>2];c[P+8>>2]=c[g+8>>2];z=0;aR(382,m|0,n|0,o|0);if(z){z=0;g=bT(-1,-1)|0;P=g;g=M;if((a[n]&1)==0){R=g;S=P;break}Lw(c[n+8>>2]|0);R=g;S=P;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[m]&1)==0){break L69}Lw(c[O>>2]|0);break L69}}while(0);if((a[m]&1)==0){G=R;H=S;I=H;J=0;K=I;L=G;bg(K|0)}Lw(c[O>>2]|0);G=R;H=S;I=H;J=0;K=I;L=G;bg(K|0)}}while(0);a[F]=1;i=e;return}L102:do{if(E){F=Lu(64)|0;S=p+8|0;c[S>>2]=F;c[p>>2]=65;c[p+4>>2]=59;LF(F|0,7912,59)|0;a[F+59|0]=0;F=d+4|0;L104:do{if((a[F]&1)==0){R=q;c[R>>2]=c[F>>2];c[R+4>>2]=c[F+4>>2];c[R+8>>2]=c[F+8>>2];y=79}else{R=c[d+12>>2]|0;m=c[d+8>>2]|0;do{if(m>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(m>>>0<11>>>0){a[q]=m<<1;T=q+1|0}else{n=m+16&-16;o=(z=0,au(248,n|0)|0);if(z){z=0;break}c[q+8>>2]=o;c[q>>2]=n|1;c[q+4>>2]=m;T=o}LF(T|0,R|0,m)|0;a[T+m|0]=0;y=79;break L104}}while(0);m=bT(-1,-1)|0;U=M;V=m}}while(0);do{if((y|0)==79){F=r;O=d+16|0;c[F>>2]=c[O>>2];c[F+4>>2]=c[O+4>>2];c[F+8>>2]=c[O+8>>2];z=0;aR(382,p|0,q|0,r|0);if(z){z=0;O=bT(-1,-1)|0;F=O;O=M;if((a[q]&1)==0){U=O;V=F;break}Lw(c[q+8>>2]|0);U=O;V=F;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[p]&1)==0){break L102}Lw(c[S>>2]|0);break L102}}while(0);if((a[p]&1)==0){G=U;H=V;I=H;J=0;K=I;L=G;bg(K|0)}Lw(c[S>>2]|0);G=U;H=V;I=H;J=0;K=I;L=G;bg(K|0)}}while(0);if((a[b+44|0]&1)==0){i=e;return}b=Lu(64)|0;V=s+8|0;c[V>>2]=b;c[s>>2]=65;c[s+4>>2]=52;LF(b|0,7688,52)|0;a[b+52|0]=0;b=d+4|0;L136:do{if((a[b]&1)==0){U=t;c[U>>2]=c[b>>2];c[U+4>>2]=c[b+4>>2];c[U+8>>2]=c[b+8>>2];y=100}else{U=c[d+12>>2]|0;p=c[d+8>>2]|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(p>>>0<11>>>0){a[t]=p<<1;W=t+1|0}else{q=p+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[t+8>>2]=r;c[t>>2]=q|1;c[t+4>>2]=p;W=r}LF(W|0,U|0,p)|0;a[W+p|0]=0;y=100;break L136}}while(0);p=bT(-1,-1)|0;X=M;Y=p}}while(0);do{if((y|0)==100){W=u;b=d+16|0;c[W>>2]=c[b>>2];c[W+4>>2]=c[b+4>>2];c[W+8>>2]=c[b+8>>2];z=0;aR(382,s|0,t|0,u|0);if(z){z=0;b=bT(-1,-1)|0;W=b;b=M;if((a[t]&1)==0){X=b;Y=W;break}Lw(c[t+8>>2]|0);X=b;Y=W;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}if((a[s]&1)==0){i=e;return}Lw(c[V>>2]|0);i=e;return}}while(0);if((a[s]&1)==0){G=X;H=Y;I=H;J=0;K=I;L=G;bg(K|0)}Lw(c[V>>2]|0);G=X;H=Y;I=H;J=0;K=I;L=G;bg(K|0)}function nt(a,b){a=a|0;b=b|0;ns(a-48+20|0,b);return}function nu(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-48+20|0;c[d+28>>2]=22512;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function nv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-48+20|0;c[d+28>>2]=22512;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){h=d;Lw(h);return}Lw(c[d+12>>2]|0);h=d;Lw(h);return}function nw(a,b){a=a|0;b=b|0;return}function nx(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+32|0;l=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=b|0;o=d;if((a[o]&1)==0){p=l;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){D5(0)}if(p>>>0<11>>>0){a[l]=p<<1;q=l+1|0}else{d=p+16&-16;r=Lu(d)|0;c[l+8>>2]=r;c[l>>2]=d|1;c[l+4>>2]=p;q=r}LF(q|0,o|0,p)|0;a[q+p|0]=0}p=m;q=e;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];z=0;aV(6,n|0,l|0,m|0,h|0);if(z){z=0;h=bT(-1,-1)|0;m=h;h=M;if((a[l]&1)==0){s=h;t=m;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[l+8>>2]|0);s=h;t=m;u=t;v=0;w=u;x=s;bg(w|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}l=b|0;c[l>>2]=22920;m=b+32|0;h=f;if((a[h]&1)==0){n=m;c[n>>2]=c[h>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];y=b+44|0;c[y>>2]=g;A=b+48|0;c[A>>2]=0;B=b+52|0;c[B>>2]=j;C=b+56|0;D=b+72|0;c[D>>2]=0;E=C;LI(E|0,0,13)|0;i=k;return}h=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(n>>>0<11>>>0){a[m]=n<<1;F=m+1|0}else{f=n+16&-16;q=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=q;c[m>>2]=f|1;c[b+36>>2]=n;F=q}LF(F|0,h|0,n)|0;a[F+n|0]=0;y=b+44|0;c[y>>2]=g;A=b+48|0;c[A>>2]=0;B=b+52|0;c[B>>2]=j;C=b+56|0;D=b+72|0;c[D>>2]=0;E=C;LI(E|0,0,13)|0;i=k;return}}while(0);k=bT(-1,-1)|0;E=k;k=M;c[l>>2]=17512;if((a[b+4|0]&1)==0){s=k;t=E;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[b+12>>2]|0);s=k;t=E;u=t;v=0;w=u;x=s;bg(w|0)}function ny(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b|0;c[e>>2]=17512;f=b+4|0;g=d+4|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;h=c[d+8>>2]|0;if(h>>>0>4294967279>>>0){D5(0)}if(h>>>0<11>>>0){a[f]=h<<1;i=f+1|0}else{j=h+16&-16;k=Lu(j)|0;c[b+12>>2]=k;c[f>>2]=j|1;c[b+8>>2]=h;i=k}LF(i|0,g|0,h)|0;a[i+h|0]=0}h=b+16|0;i=d+16|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];c[e>>2]=17080;c[b+28>>2]=c[d+28>>2];c[e>>2]=22920;i=b+32|0;h=d+32|0;L12:do{if((a[h]&1)==0){g=i;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2]}else{g=c[d+40>>2]|0;k=c[d+36>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[i]=k<<1;l=i+1|0}else{j=k+16&-16;m=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+40>>2]=m;c[i>>2]=j|1;c[b+36>>2]=k;l=m}LF(l|0,g|0,k)|0;a[l+k|0]=0;break L12}}while(0);k=bT(-1,-1)|0;c[e>>2]=17512;if((a[f]&1)==0){bg(k|0)}Lw(c[b+12>>2]|0);bg(k|0)}}while(0);c[b+44>>2]=c[d+44>>2];c[b+48>>2]=c[d+48>>2];c[b+52>>2]=c[d+52>>2];c[b+56>>2]=c[d+56>>2];c[b+60>>2]=c[d+60>>2];c[b+64>>2]=c[d+64>>2];a[b+68|0]=a[d+68|0]&1;c[b+72>>2]=c[d+72>>2];return}function nz(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function nA(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function nB(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+52>>2]&1023](b,a);return}function nC(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function nD(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function nE(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function nF(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function nG(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+52>>2]&511](a,d,b);return}function nH(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+52>>2]&511](a,d,b);return}function nI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=b|0;k=d;if((a[k]&1)==0){l=g;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2]}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){D5(0)}if(l>>>0<11>>>0){a[g]=l<<1;m=g+1|0}else{d=l+16&-16;n=Lu(d)|0;c[g+8>>2]=n;c[g>>2]=d|1;c[g+4>>2]=l;m=n}LF(m|0,k|0,l)|0;a[m+l|0]=0}l=h;m=e;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];z=0;aR(424,j|0,g|0,h|0);if(!z){if((a[g]&1)==0){o=b|0;c[o>>2]=18536;p=b+28|0;q=p;LI(q|0,0,24)|0;i=f;return}Lw(c[g+8>>2]|0);o=b|0;c[o>>2]=18536;p=b+28|0;q=p;LI(q|0,0,24)|0;i=f;return}else{z=0;f=bT(-1,-1)|0;if((a[g]&1)==0){bg(f|0)}Lw(c[g+8>>2]|0);bg(f|0)}}function nJ(a){a=a|0;nS(a);return}function nK(a){a=a|0;var b=0;z=0;ar(52,a|0);if(!z){Lw(a);return}else{z=0;b=bT(-1,-1)|0;Lw(a);bg(b|0)}}function nL(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+40>>2]&1023](b,a);return}function nM(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function nN(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function nO(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function nP(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function nQ(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+40>>2]&511](a,d,b);return}function nR(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+40>>2]&511](a,d,b);return}function nS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=b|0;c[d>>2]=18536;e=c[b+40>>2]|0;f=e;if((e|0)!=0){g=b+44|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}e=b+28|0;f=c[e>>2]|0;if((f|0)!=0){h=b+32|0;g=c[h>>2]|0;if((f|0)==(g|0)){i=f}else{j=g;while(1){g=j-12|0;c[h>>2]=g;if((a[g]&1)==0){k=g}else{Lw(c[j-12+8>>2]|0);k=c[h>>2]|0}if((f|0)==(k|0)){break}else{j=k}}i=c[e>>2]|0}Lw(i)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function nT(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function nU(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function nV(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+32>>2]&1023](b,a);return}function nW(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function nX(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function nY(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function nZ(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function n_(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+32>>2]&511](a,d,b);return}function n$(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+32>>2]&511](a,d,b);return}function n0(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aV(6,m|0,k|0,l|0,h|0);if(z){z=0;h=bT(-1,-1)|0;l=h;h=M;if((a[k]&1)==0){r=h;s=l;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=h;s=l;t=s;u=0;v=t;w=r;bg(v|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=b|0;c[k>>2]=18264;l=b+32|0;h=f;if((a[h]&1)==0){m=l;c[m>>2]=c[h>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];x=b+44|0;c[x>>2]=g;y=b+48|0;c[y>>2]=0;i=j;return}h=c[f+8>>2]|0;m=c[f+4>>2]|0;do{if(m>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(m>>>0<11>>>0){a[l]=m<<1;A=l+1|0}else{f=m+16&-16;p=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=p;c[l>>2]=f|1;c[b+36>>2]=m;A=p}LF(A|0,h|0,m)|0;a[A+m|0]=0;x=b+44|0;c[x>>2]=g;y=b+48|0;c[y>>2]=0;i=j;return}}while(0);j=bT(-1,-1)|0;y=j;j=M;c[k>>2]=17512;if((a[b+4|0]&1)==0){r=j;s=y;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[b+12>>2]|0);r=j;s=y;t=s;u=0;v=t;w=r;bg(v|0)}function n1(b){b=b|0;var d=0;d=b|0;c[d>>2]=18264;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function n2(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=18264;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function n3(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+28>>2]&1023](b,a);return}function n4(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function n5(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function n6(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function n7(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function n8(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+28>>2]&511](a,d,b);return}function n9(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+28>>2]&511](a,d,b);return}function oa(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function ob(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function oc(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+24>>2]&1023](b,a);return}function od(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function oe(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function of(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function og(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function oh(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+24>>2]&511](a,d,b);return}function oi(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+24>>2]&511](a,d,b);return}function oj(a){a=a|0;return 1}function ok(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function ol(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function om(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+16>>2]&1023](b,a);return}function on(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function oo(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function op(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function oq(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function or(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+16>>2]&511](a,d,b);return}function os(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+16>>2]&511](a,d,b);return}function ot(a){a=a|0;return 1}function ou(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aR(424,l|0,j|0,k|0);if(z){z=0;k=bT(-1,-1)|0;l=k;k=M;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}j=b+28|0;c[j>>2]=22480;l=b+32|0;c[l>>2]=0;k=b+36|0;c[k>>2]=0;o=b+40|0;c[o>>2]=0;if((f|0)==0){w=b|0;c[w>>2]=19200;c[j>>2]=19256;x=b+44|0;y=g&1;a[x]=y;A=b+45|0;a[A]=0;B=b+46|0;a[B]=0;i=h;return}n=(z=0,au(248,f<<2|0)|0);if(!z){e=n;c[l>>2]=e;c[k>>2]=e;c[o>>2]=e+(f<<2);w=b|0;c[w>>2]=19200;c[j>>2]=19256;x=b+44|0;y=g&1;a[x]=y;A=b+45|0;a[A]=0;B=b+46|0;a[B]=0;i=h;return}else{z=0}h=bT(-1,-1)|0;B=h;h=M;c[b>>2]=17512;if((a[b+4|0]&1)==0){q=h;r=B;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[b+12>>2]|0);q=h;r=B;s=r;t=0;u=s;v=q;bg(u|0)}function ov(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+28>>2]=22480;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function ow(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+28>>2]=22480;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){h=b;Lw(h);return}Lw(c[b+12>>2]|0);h=b;Lw(h);return}function ox(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+12>>2]&1023](b,a);return}function oy(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function oz(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function oA(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function oB(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function oC(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+12>>2]&511](a,d,b);return}function oD(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+12>>2]&511](a,d,b);return}function oE(a){a=a|0;return a|0}function oF(b,d){b=b|0;d=d|0;if(cD[c[(c[d>>2]|0)+36>>2]&511](d)|0){a[b+45|0]=1;return}else{a[b+46|0]=1;return}}function oG(b,d){b=b|0;d=d|0;var e=0;e=b-48+20|0;if(cD[c[(c[d>>2]|0)+36>>2]&511](d)|0){a[e+45|0]=1;return}else{a[e+46|0]=1;return}}function oH(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-48+20|0;c[d+28>>2]=22480;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function oI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-48+20|0;c[d+28>>2]=22480;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){h=d;Lw(h);return}Lw(c[d+12>>2]|0);h=d;Lw(h);return}function oJ(a,b){a=a|0;b=b|0;return}function oK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[a>>2]=18600;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;c[a+16>>2]=f;return}function oL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=b+32|0;e=c[d>>2]|0;f=(c[b+36>>2]|0)-e>>2;if((f|0)==0){return}b=a|0;a=0;g=e;while(1){e=c[g+(a<<2)>>2]|0;cB[c[(c[e>>2]|0)+8>>2]&1023](e|0,b);e=a+1|0;if(e>>>0>=f>>>0){break}a=e;g=c[d>>2]|0}return}function oM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0;e=i;i=i+432|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=e+48|0;m=e+64|0;n=e+72|0;o=e+80|0;p=e+88|0;q=e+104|0;r=e+112|0;s=e+120|0;t=e+136|0;u=e+144|0;v=e+160|0;w=e+168|0;x=e+176|0;y=e+192|0;A=e+208|0;B=e+224|0;C=e+256|0;D=e+320|0;E=e+336|0;F=e+352|0;G=e+368|0;H=e+384|0;I=e+400|0;J=e+416|0;Bv(w,0);K=d+32|0;L=c[K>>2]|0;N=b+4|0;O=c[N>>2]|0;P=(z=0,au(248,48)|0);L1:do{if(!z){Q=P;c[v>>2]=Q;R=O+4|0;S=c[R>>2]|0;if((S|0)==(c[O+8>>2]|0)){z=0;as(382,O|0,v|0);if(z){z=0;T=35;break}U=c[v>>2]|0}else{if((S|0)==0){V=0}else{c[S>>2]=Q;V=c[R>>2]|0}c[R>>2]=V+4;U=Q}Q=U;S=U;W=c[K>>2]|0;X=W+4|0;L11:do{if((a[X]&1)==0){Y=x;c[Y>>2]=c[X>>2];c[Y+4>>2]=c[X+4>>2];c[Y+8>>2]=c[X+8>>2];T=18}else{Y=c[W+12>>2]|0;Z=c[W+8>>2]|0;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(Z>>>0<11>>>0){a[x]=Z<<1;_=x+1|0}else{$=Z+16&-16;aa=(z=0,au(248,$|0)|0);if(z){z=0;break}c[x+8>>2]=aa;c[x>>2]=$|1;c[x+4>>2]=Z;_=aa}LF(_|0,Y|0,Z)|0;a[_+Z|0]=0;T=18;break L11}}while(0);Z=bT(-1,-1)|0;ab=Z;ac=M}}while(0);do{if((T|0)==18){X=W+16|0;Z=u;c[Z>>2]=c[X>>2];c[Z+4>>2]=c[X+4>>2];c[Z+8>>2]=c[X+8>>2];z=0;aV(58,S|0,x|0,u|0,0);if(z){z=0;X=bT(-1,-1)|0;Z=X;X=M;if((a[x]&1)==0){ab=Z;ac=X;break}Lw(c[x+8>>2]|0);ab=Z;ac=X;break}if((a[x]&1)!=0){Lw(c[x+8>>2]|0)}X=L+36|0;Z=c[X>>2]|0;Y=(c[L+40>>2]|0)-Z>>2;L33:do{if((Y|0)==0){ad=U+40|0;ae=U+36|0}else{aa=y;$=s;af=b+8|0;ag=y+8|0;ah=y+1|0;ai=y|0;aj=y+4|0;ak=L+4|0;al=A;am=L+16|0;an=b+16|0;ao=B|0;ap=A+8|0;at=L+12|0;av=L+8|0;aw=A+1|0;ax=A|0;ay=A+4|0;aA=U+32|0;aB=aA;aC=U+40|0;aD=aA+12|0;aE=U+36|0;aF=aE;aG=aA;aA=0;aH=Z;L35:while(1){aJ=c[aH+(aA<<2)>>2]|0;aK=1;aL=0;L37:while(1){aN=aJ;aO=aK;while(1){if((aN|0)==0){break L37}aP=(z=0,au(c[(c[aN>>2]|0)+36>>2]|0,aN|0)|0);if(z){z=0;T=32;break L35}if((aP|0)==0){break L37}aQ=c[N>>2]|0;aS=(z=0,au(248,60)|0);if(z){z=0;T=32;break L35}aT=aS;c[t>>2]=aT;aU=aQ+4|0;aS=c[aU>>2]|0;if((aS|0)==(c[aQ+8>>2]|0)){z=0;as(382,aQ|0,t|0);if(z){z=0;T=32;break L35}aW=c[t>>2]|0}else{if((aS|0)==0){aX=0}else{c[aS>>2]=aT;aX=c[aU>>2]|0}c[aU>>2]=aX+4;aW=aT}aY=aW;aZ=aW;aT=aN+4|0;if((a[aT]&1)==0){c[aa>>2]=c[aT>>2];c[aa+4>>2]=c[aT+4>>2];c[aa+8>>2]=c[aT+8>>2]}else{aT=c[aN+12>>2]|0;aS=c[aN+8>>2]|0;if(aS>>>0>4294967279>>>0){T=56;break L35}if(aS>>>0<11>>>0){a[aa]=aS<<1;a_=ah}else{a$=aS+16&-16;a0=(z=0,au(248,a$|0)|0);if(z){z=0;T=124;break L35}c[ag>>2]=a0;c[ai>>2]=a$|1;c[aj>>2]=aS;a_=a0}LF(a_|0,aT|0,aS)|0;a[a_+aS|0]=0}LG($|0,aN+16|0,12)|0;z=0;aV(42,aZ|0,y|0,s|0,1);if(z){z=0;T=127;break L35}if((a[aa]&1)!=0){Lw(c[ag>>2]|0)}aS=aW+32|0;aT=aS;a0=aP|0;c[r>>2]=a0;aP=aW+40|0;a$=c[aP>>2]|0;a1=a$;if((a1|0)==(c[aS+12>>2]|0)){z=0;as(740,aW+36|0,r|0);if(z){z=0;T=32;break L35}a2=c[r>>2]|0}else{if((a$|0)==0){a3=0}else{c[a1>>2]=a0;a3=c[aP>>2]|0}c[aP>>2]=a3+4;a2=a0}z=0;as(c[c[aS>>2]>>2]|0,aT|0,a2|0);if(z){z=0;T=32;break L35}aT=(z=0,aM(434,c[af>>2]|0,aZ|0)|0);if(z){z=0;T=32;break L35}if((aT|0)==0){aN=0;aO=0}else{break}}a4=c[N>>2]|0;aT=(z=0,au(248,48)|0);if(z){z=0;T=33;break L35}aS=aT;c[q>>2]=aS;a5=a4+4|0;aT=c[a5>>2]|0;if((aT|0)==(c[a4+8>>2]|0)){z=0;as(382,a4|0,q|0);if(z){z=0;T=33;break L35}a6=c[q>>2]|0}else{if((aT|0)==0){a7=0}else{c[aT>>2]=aS;a7=c[a5>>2]|0}c[a5>>2]=a7+4;a6=aS}a8=a6;aS=a6;if((a[ak]&1)==0){c[al>>2]=c[ak>>2];c[al+4>>2]=c[ak+4>>2];c[al+8>>2]=c[ak+8>>2]}else{aT=c[at>>2]|0;a0=c[av>>2]|0;if(a0>>>0>4294967279>>>0){T=85;break L35}if(a0>>>0<11>>>0){a[al]=a0<<1;a9=aw}else{aP=a0+16&-16;a1=(z=0,au(248,aP|0)|0);if(z){z=0;T=135;break L35}c[ap>>2]=a1;c[ax>>2]=aP|1;c[ay>>2]=a0;a9=a1}LF(a9|0,aT|0,a0)|0;a[a9+a0|0]=0}a0=p;c[a0>>2]=c[am>>2];c[a0+4>>2]=c[am+4>>2];c[a0+8>>2]=c[am+8>>2];z=0;aV(58,aS|0,A|0,p|0,0);if(z){z=0;T=138;break L35}if((a[al]&1)!=0){Lw(c[ap>>2]|0)}a0=(c[af>>2]|0)+4|0;aT=a0;a1=c[a0>>2]|0;L101:do{if((a1|0)==0){ba=aT}else{a0=a1;aP=aT;while(1){a$=a0;while(1){bb=(z=0,aM(80,a$+16|0,aZ|0)|0);if(z){z=0;T=29;break L35}bc=a$;if(!bb){break}bb=c[a$+4>>2]|0;if((bb|0)==0){ba=aP;break L101}else{a$=bb}}bb=c[a$>>2]|0;if((bb|0)==0){ba=bc;break}else{a0=bb;aP=bc}}}}while(0);aT=(c[af>>2]|0)+4|0;a1=aT;aP=c[aT>>2]|0;L110:do{if((aP|0)==0){bd=a1}else{aT=aP;a0=a1;while(1){bb=aT;while(1){be=(z=0,aM(80,aZ|0,bb+16|0)|0);if(z){z=0;T=30;break L35}bf=bb;if(be){break}be=c[bb+4>>2]|0;if((be|0)==0){bd=a0;break L110}else{bb=be}}a$=c[bb>>2]|0;if((a$|0)==0){bd=bf;break}else{aT=a$;a0=bf}}}}while(0);if((ba|0)==(bd|0)){aJ=0;aK=aO;aL=aS;continue}a1=aW;aP=aN;a0=a6+32|0;aT=a0;a$=a6+40|0;be=a0+12|0;bh=a6+36|0;bi=a0;a0=ba;while(1){z=0;aI(58,B|0,c[N>>2]|0,0,0,c[an>>2]|0,a1|0,c[a0+76>>2]|0);if(z){z=0;T=31;break L35}bj=(z=0,aM(c[(c[aP>>2]|0)+24>>2]|0,aN|0,ao|0)|0);if(z){z=0;T=146;break L35}bk=bj;c[o>>2]=bk;bj=c[a$>>2]|0;bl=bj;if((bl|0)==(c[be>>2]|0)){z=0;as(272,bh|0,o|0);if(z){z=0;T=146;break L35}bm=c[o>>2]|0}else{if((bj|0)==0){bn=0}else{c[bl>>2]=bk;bn=c[a$>>2]|0}c[a$>>2]=bn+4;bm=bk}z=0;as(c[c[bi>>2]>>2]|0,aT|0,bm|0);if(z){z=0;T=146;break L35}z=0;ar(22,B|0);if(z){z=0;T=31;break L35}bk=c[a0+4>>2]|0;if((bk|0)==0){bl=a0|0;while(1){bj=c[bl+8>>2]|0;if((bl|0)==(c[bj>>2]|0)){bo=bj;break}else{bl=bj}}}else{bl=bk;while(1){bj=c[bl>>2]|0;if((bj|0)==0){bo=bl;break}else{bl=bj}}}bl=bo;if((bl|0)==(bd|0)){aJ=0;aK=aO;aL=aS;continue L37}else{a0=bl}}}L142:do{if(!((aL|0)==0|aO^1)){aK=aL+36|0;aJ=c[aK>>2]|0;a0=(c[aL+40>>2]|0)-aJ>>2;if((a0|0)==0){break}else{bp=0;bq=aJ}while(1){aJ=c[bq+(bp<<2)>>2]|0;c[n>>2]=aJ;aS=c[aC>>2]|0;aT=aS;if((aT|0)==(c[aD>>2]|0)){z=0;as(272,aF|0,n|0);if(z){z=0;T=34;break L35}br=c[n>>2]|0}else{if((aS|0)==0){bs=0}else{c[aT>>2]=aJ;bs=c[aC>>2]|0}c[aC>>2]=bs+4;br=aJ}z=0;as(c[c[aG>>2]>>2]|0,aB|0,br|0);if(z){z=0;T=34;break L35}aJ=bp+1|0;if(aJ>>>0>=a0>>>0){break L142}bp=aJ;bq=c[aK>>2]|0}}}while(0);aL=aA+1|0;if(aL>>>0>=Y>>>0){ad=aC;ae=aE;break L33}aA=aL;aH=c[X>>2]|0}do{if((T|0)==33){aH=bT(-1,-1)|0;bt=M;bu=aH;T=36;break L1}else if((T|0)==85){z=0;ar(86,0);if(z){z=0;aH=bT(-1,-1)|0;bv=M;bw=aH;T=137;break}}else if((T|0)==127){aH=bT(-1,-1)|0;aA=aH;aH=M;if((a[aa]&1)==0){bx=aA;by=aH;T=129;break}Lw(c[ag>>2]|0);bx=aA;by=aH;T=129}else if((T|0)==135){aH=bT(-1,-1)|0;bv=M;bw=aH;T=137}else if((T|0)==56){z=0;ar(86,0);if(z){z=0;aH=bT(-1,-1)|0;bz=M;bA=aH;T=126;break}}else if((T|0)==146){aH=bT(-1,-1)|0;aA=M;z=0;ar(22,B|0);if(!z){bB=aH;bC=aA;break L1}else{z=0}bD=bT(-1,-1,0)|0;bE=M;bX()}else if((T|0)==124){aA=bT(-1,-1)|0;bz=M;bA=aA;T=126}else if((T|0)==30){aA=bT(-1,-1)|0;bt=M;bu=aA;T=36;break L1}else if((T|0)==138){aA=bT(-1,-1)|0;aH=aA;aA=M;if((a[al]&1)==0){bF=aH;bG=aA;T=140;break}Lw(c[ap>>2]|0);bF=aH;bG=aA;T=140}else if((T|0)==34){aA=bT(-1,-1)|0;bt=M;bu=aA;T=36;break L1}else if((T|0)==29){aA=bT(-1,-1)|0;bt=M;bu=aA;T=36;break L1}else if((T|0)==32){aA=bT(-1,-1)|0;bt=M;bu=aA;T=36;break L1}else if((T|0)==31){aA=bT(-1,-1)|0;bt=M;bu=aA;T=36;break L1}}while(0);if((T|0)==126){bx=bA;by=bz;T=129}else if((T|0)==137){bF=bw;bG=bv;T=140}if((T|0)==129){ap=c[aQ>>2]|0;al=c[aU>>2]|0;ag=ap;while(1){if((ag|0)==(al|0)){bH=al;break}if((c[ag>>2]|0)==(aW|0)){bH=ag;break}else{ag=ag+4|0}}ag=bH-ap>>2;aa=ap+(ag+1<<2)|0;aA=al-aa|0;LG(ap+(ag<<2)|0,aa|0,aA|0)|0;aa=ap+((aA>>2)+ag<<2)|0;ag=c[aU>>2]|0;if((aa|0)!=(ag|0)){c[aU>>2]=ag+(~((ag-4+(-aa|0)|0)>>>2)<<2)}Lw(aY);bB=bx;bC=by;break L1}else if((T|0)==140){aa=c[a4>>2]|0;ag=c[a5>>2]|0;aA=aa;while(1){if((aA|0)==(ag|0)){bI=ag;break}if((c[aA>>2]|0)==(a6|0)){bI=aA;break}else{aA=aA+4|0}}aA=bI-aa>>2;ap=aa+(aA+1<<2)|0;al=ag-ap|0;LG(aa+(aA<<2)|0,ap|0,al|0)|0;ap=aa+((al>>2)+aA<<2)|0;aA=c[a5>>2]|0;if((ap|0)!=(aA|0)){c[a5>>2]=aA+(~((aA-4+(-ap|0)|0)>>>2)<<2)}Lw(a8);bB=bF;bC=bG;break L1}}}while(0);L203:do{if((c[ad>>2]|0)!=(c[ae>>2]|0)){z=0;aR(c[(c[U>>2]|0)+28>>2]|0,E|0,S|0,w|0);if(z){z=0;T=35;break L1}X=D;LI(X|0,0,12)|0;Y=E;Z=a[Y]|0;ap=Z&255;if((ap&1|0)==0){bJ=ap>>>1}else{bJ=c[E+4>>2]|0}if((Z&1)==0){bK=E+1|0}else{bK=c[E+8>>2]|0}Z=bJ+1|0;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;T=176;break}}else{if(Z>>>0<11>>>0){a[X]=bJ<<1;bL=D+1|0}else{ap=bJ+17&-16;aA=(z=0,au(248,ap|0)|0);if(z){z=0;T=176;break}c[D+8>>2]=aA;c[D>>2]=ap|1;c[D+4>>2]=bJ;bL=aA}LF(bL|0,bK|0,bJ)|0;a[bL+bJ|0]=0;z=0,az(88,D|0,8800,1)|0;if(z){z=0;T=176;break}if((a[X]&1)==0){bM=D+1|0}else{bM=c[D+8>>2]|0}aA=c[N>>2]|0;ap=U+4|0;L228:do{if((a[ap]&1)==0){al=F;c[al>>2]=c[ap>>2];c[al+4>>2]=c[ap+4>>2];c[al+8>>2]=c[ap+8>>2];T=191}else{al=c[U+12>>2]|0;aH=c[U+8>>2]|0;do{if(aH>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(aH>>>0<11>>>0){a[F]=aH<<1;bN=F+1|0}else{aE=aH+16&-16;aC=(z=0,au(248,aE|0)|0);if(z){z=0;break}c[F+8>>2]=aC;c[F>>2]=aE|1;c[F+4>>2]=aH;bN=aC}LF(bN|0,al|0,aH)|0;a[bN+aH|0]=0;T=191;break L228}}while(0);aH=bT(-1,-1)|0;bO=aH;bP=M}}while(0);do{if((T|0)==191){ap=G;aH=U+16|0;c[ap>>2]=c[aH>>2];c[ap+4>>2]=c[aH+4>>2];c[ap+8>>2]=c[aH+8>>2];z=0;aq(2,C|0,bM|0,aA|0,F|0,G|0);do{if(!z){aH=(z=0,au(50,C|0)|0);if(z){z=0;ap=bT(-1,-1)|0;al=ap;ap=M;if((a[C+28|0]&1)!=0){Lw(c[C+36>>2]|0)}aC=c[C+4>>2]|0;if((aC|0)==0){bQ=al;bR=ap;break}aE=C+8|0;aB=c[aE>>2]|0;if((aC|0)!=(aB|0)){c[aE>>2]=aB+(~((aB-4+(-aC|0)|0)>>>2)<<2)}Lw(aC);bQ=al;bR=ap;break}c[K>>2]=aH;if((a[C+28|0]&1)!=0){Lw(c[C+36>>2]|0)}aH=c[C+4>>2]|0;ap=aH;if((aH|0)!=0){al=C+8|0;aC=c[al>>2]|0;if((aH|0)!=(aC|0)){c[al>>2]=aC+(~((aC-4+(-ap|0)|0)>>>2)<<2)}Lw(aH)}if((a[F]&1)!=0){Lw(c[F+8>>2]|0)}if((a[X]&1)!=0){Lw(c[D+8>>2]|0)}if((a[Y]&1)==0){break L203}Lw(c[E+8>>2]|0);break L203}else{z=0;aH=bT(-1,-1)|0;bQ=aH;bR=M}}while(0);if((a[F]&1)==0){bO=bQ;bP=bR;break}Lw(c[F+8>>2]|0);bO=bQ;bP=bR}}while(0);if((a[X]&1)==0){bS=bO;bU=bP;break}Lw(c[D+8>>2]|0);bS=bO;bU=bP}}while(0);if((T|0)==176){Z=bT(-1,-1)|0;aa=M;if((a[X]&1)!=0){Lw(c[D+8>>2]|0)}bS=Z;bU=aa}if((a[Y]&1)==0){bB=bS;bC=bU;break L1}Lw(c[E+8>>2]|0);bB=bS;bC=bU;break L1}}while(0);aa=H|0;Z=H+4|0;c[Z>>2]=0;c[H+8>>2]=0;c[H>>2]=Z;Z=c[K>>2]|0;ag=c[N>>2]|0;aA=(z=0,au(248,48)|0);L284:do{if(!z){aH=aA;c[m>>2]=aH;ap=ag+4|0;aC=c[ap>>2]|0;if((aC|0)==(c[ag+8>>2]|0)){z=0;as(382,ag|0,m|0);if(z){z=0;T=255;break}bV=c[m>>2]|0}else{if((aC|0)==0){bW=0}else{c[aC>>2]=aH;bW=c[ap>>2]|0}c[ap>>2]=bW+4;bV=aH}aH=bV;aC=Z+4|0;L294:do{if((a[aC]&1)==0){al=I;c[al>>2]=c[aC>>2];c[al+4>>2]=c[aC+4>>2];c[al+8>>2]=c[aC+8>>2];T=237}else{al=c[Z+12>>2]|0;aB=c[Z+8>>2]|0;do{if(aB>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(aB>>>0<11>>>0){a[I]=aB<<1;bY=I+1|0}else{aE=aB+16&-16;aG=(z=0,au(248,aE|0)|0);if(z){z=0;break}c[I+8>>2]=aG;c[I>>2]=aE|1;c[I+4>>2]=aB;bY=aG}LF(bY|0,al|0,aB)|0;a[bY+aB|0]=0;T=237;break L294}}while(0);aB=bT(-1,-1)|0;bZ=aB;b_=M}}while(0);do{if((T|0)==237){Y=Z+16|0;X=l;c[X>>2]=c[Y>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];X=Z+40|0;aB=Z+36|0;z=0;aV(58,bV|0,I|0,l|0,(c[X>>2]|0)-(c[aB>>2]|0)>>2|0);if(z){z=0;al=bT(-1,-1)|0;aG=al;al=M;if((a[I]&1)==0){bZ=aG;b_=al;break}Lw(c[I+8>>2]|0);bZ=aG;b_=al;break}if((a[I]&1)!=0){Lw(c[I+8>>2]|0)}al=c[aB>>2]|0;aG=(c[X>>2]|0)-al>>2;do{if((aG|0)==0){T=284}else{X=bV+32|0;aE=X;aF=bV+40|0;aD=X+12|0;ao=bV+36|0;an=X;X=0;af=0;am=al;L318:while(1){ay=am+(af<<2)|0;c[ay>>2]=c[(c[ay>>2]|0)+40>>2];ay=c[(c[aB>>2]|0)+(af<<2)>>2]|0;if((a[ay+29|0]&1)==0){c[k>>2]=ay;ax=c[aF>>2]|0;aw=ax;if((aw|0)==(c[aD>>2]|0)){z=0;as(272,ao|0,k|0);if(z){z=0;T=254;break}b$=c[k>>2]|0}else{if((ax|0)==0){b0=0}else{c[aw>>2]=ay;b0=c[aF>>2]|0}c[aF>>2]=b0+4;b$=ay}z=0;as(c[c[an>>2]>>2]|0,aE|0,b$|0);if(z){z=0;T=254;break}b1=c[(c[aB>>2]|0)+(af<<2)>>2]|0}else{b1=ay}ay=(z=0,az(2,b|0,b1|0,H|0)|0);if(z){z=0;T=254;break}aw=ay+36|0;ax=c[aw>>2]|0;av=(c[ay+40>>2]|0)-ax>>2;L333:do{if((av|0)==0){b2=X}else{ay=0;at=ax;while(1){ak=(z=0,az(20,b|0,c[(c[aB>>2]|0)+(af<<2)>>2]|0,c[(c[at+(ay<<2)>>2]|0)+40>>2]|0)|0);if(z){z=0;T=253;break L318}$=(ak|0)==0?0:ak+32|0;ak=$+4|0;aj=c[ak>>2]|0;ai=(c[$+8>>2]|0)-aj>>2;L337:do{if((ai|0)!=0){$=0;ah=aj;while(1){aL=c[ah+($<<2)>>2]|0;c[g>>2]=aL;aK=c[aF>>2]|0;a0=aK;if((a0|0)==(c[aD>>2]|0)){z=0;as(272,ao|0,g|0);if(z){z=0;T=252;break L318}b3=c[g>>2]|0}else{if((aK|0)==0){b4=0}else{c[a0>>2]=aL;b4=c[aF>>2]|0}c[aF>>2]=b4+4;b3=aL}z=0;as(c[c[an>>2]>>2]|0,aE|0,b3|0);if(z){z=0;T=252;break L318}aL=$+1|0;if(aL>>>0>=ai>>>0){break L337}$=aL;ah=c[ak>>2]|0}}}while(0);ak=ay+1|0;if(ak>>>0>=av>>>0){b2=1;break L333}ay=ak;at=c[aw>>2]|0}}}while(0);aw=af+1|0;if(aw>>>0>=aG>>>0){T=283;break}X=b2;af=aw;am=c[aB>>2]|0}if((T|0)==252){am=bT(-1,-1)|0;b5=M;b6=am;T=256;break L284}else if((T|0)==253){am=bT(-1,-1)|0;b5=M;b6=am;T=256;break L284}else if((T|0)==254){am=bT(-1,-1)|0;b5=M;b6=am;T=256;break L284}else if((T|0)==283){if(!b2){T=284;break}am=bV;c[K>>2]=am;b7=am;break}}}while(0);if((T|0)==284){b7=c[K>>2]|0}L363:do{if((a[b7+29|0]&1)!=0){aB=c[N>>2]|0;aG=(z=0,au(248,48)|0);if(z){z=0;T=255;break L284}al=aG;c[f>>2]=al;aG=aB+4|0;am=c[aG>>2]|0;if((am|0)==(c[aB+8>>2]|0)){z=0;as(382,aB|0,f|0);if(z){z=0;T=255;break L284}b8=c[f>>2]|0}else{if((am|0)==0){b9=0}else{c[am>>2]=al;b9=c[aG>>2]|0}c[aG>>2]=b9+4;b8=al}al=b8;L374:do{if((a[aC]&1)==0){am=J;c[am>>2]=c[aC>>2];c[am+4>>2]=c[aC+4>>2];c[am+8>>2]=c[aC+8>>2];T=304}else{am=c[Z+12>>2]|0;af=c[Z+8>>2]|0;do{if(af>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(af>>>0<11>>>0){a[J]=af<<1;ca=J+1|0}else{X=af+16&-16;aE=(z=0,au(248,X|0)|0);if(z){z=0;break}c[J+8>>2]=aE;c[J>>2]=X|1;c[J+4>>2]=af;ca=aE}LF(ca|0,am|0,af)|0;a[ca+af|0]=0;T=304;break L374}}while(0);af=bT(-1,-1)|0;cb=af;cc=M}}while(0);do{if((T|0)==304){af=h;c[af>>2]=c[Y>>2];c[af+4>>2]=c[Y+4>>2];c[af+8>>2]=c[Y+8>>2];z=0;aV(58,b8|0,J|0,h|0,0);if(z){z=0;af=bT(-1,-1)|0;am=af;af=M;if((a[J]&1)==0){cb=am;cc=af;break}Lw(c[J+8>>2]|0);cb=am;cc=af;break}if((a[J]&1)!=0){Lw(c[J+8>>2]|0)}af=b7+36|0;am=c[af>>2]|0;aE=(c[b7+40>>2]|0)-am>>2;L396:do{if((aE|0)!=0){X=b8+32|0;an=X;aF=b8+40|0;ao=X+12|0;aD=b8+36|0;aw=X;X=0;av=am;while(1){ax=c[av+(X<<2)>>2]|0;if((a[ax+29|0]&1)==0){c[j>>2]=ax;at=c[aF>>2]|0;ay=at;if((ay|0)==(c[ao>>2]|0)){z=0;as(272,aD|0,j|0);if(z){z=0;break}cd=c[j>>2]|0}else{if((at|0)==0){ce=0}else{c[ay>>2]=ax;ce=c[aF>>2]|0}c[aF>>2]=ce+4;cd=ax}z=0;as(c[c[aw>>2]>>2]|0,an|0,cd|0);if(z){z=0;break}}ax=X+1|0;if(ax>>>0>=aE>>>0){break L396}X=ax;av=c[af>>2]|0}av=bT(-1,-1)|0;b5=M;b6=av;T=256;break L284}}while(0);c[K>>2]=b8;break L363}}while(0);af=c[aB>>2]|0;aE=c[aG>>2]|0;am=af;while(1){if((am|0)==(aE|0)){cf=aE;break}if((c[am>>2]|0)==(b8|0)){cf=am;break}else{am=am+4|0}}am=cf-af>>2;aB=af+(am+1<<2)|0;av=aE-aB|0;LG(af+(am<<2)|0,aB|0,av|0)|0;aB=af+((av>>2)+am<<2)|0;am=c[aG>>2]|0;if((aB|0)!=(am|0)){c[aG>>2]=am+(~((am-4+(-aB|0)|0)>>>2)<<2)}Lw(al);cg=cb;ch=cc;break L284}}while(0);Y=c[d+28>>2]|0;z=0;as(c[(c[Y>>2]|0)+8>>2]|0,Y|0,b|0);if(z){z=0;T=255;break L284}pF(aa,c[H+4>>2]|0);Bx(w);i=e;return}}while(0);aC=c[ag>>2]|0;Y=c[ap>>2]|0;aB=aC;while(1){if((aB|0)==(Y|0)){ci=Y;break}if((c[aB>>2]|0)==(bV|0)){ci=aB;break}else{aB=aB+4|0}}aB=ci-aC>>2;am=aC+(aB+1<<2)|0;av=Y-am|0;LG(aC+(aB<<2)|0,am|0,av|0)|0;am=aC+((av>>2)+aB<<2)|0;aB=c[ap>>2]|0;if((am|0)!=(aB|0)){c[ap>>2]=aB+(~((aB-4+(-am|0)|0)>>>2)<<2)}Lw(aH);cg=bZ;ch=b_}else{z=0;T=255}}while(0);if((T|0)==255){ag=bT(-1,-1)|0;b5=M;b6=ag;T=256}if((T|0)==256){cg=b6;ch=b5}pF(aa,c[H+4>>2]|0);bB=cg;bC=ch;break L1}}while(0);S=c[O>>2]|0;W=c[R>>2]|0;ag=S;while(1){if((ag|0)==(W|0)){cj=W;break}if((c[ag>>2]|0)==(U|0)){cj=ag;break}else{ag=ag+4|0}}ag=cj-S>>2;Z=S+(ag+1<<2)|0;aA=W-Z|0;LG(S+(ag<<2)|0,Z|0,aA|0)|0;Z=S+((aA>>2)+ag<<2)|0;ag=c[R>>2]|0;if((Z|0)!=(ag|0)){c[R>>2]=ag+(~((ag-4+(-Z|0)|0)>>>2)<<2)}Lw(Q);bB=ab;bC=ac}else{z=0;T=35}}while(0);if((T|0)==35){ac=bT(-1,-1)|0;bt=M;bu=ac;T=36}if((T|0)==36){bB=bu;bC=bt}z=0;ar(444,w|0);if(!z){bg(bB|0)}else{z=0;bD=bT(-1,-1,0)|0;bE=M;bX()}}function oN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f=i;i=i+64|0;g=f|0;h=f+8|0;j=f+24|0;k=f+32|0;l=f+40|0;m=f+48|0;Bv(l,0);n=c[b+4>>2]|0;o=(z=0,au(248,48)|0);L1:do{if(!z){p=o;c[j>>2]=p;q=n+4|0;r=c[q>>2]|0;if((r|0)==(c[n+8>>2]|0)){z=0;as(382,n|0,j|0);if(z){z=0;s=45;break}t=c[j>>2]|0}else{if((r|0)==0){u=0}else{c[r>>2]=p;u=c[q>>2]|0}c[q>>2]=u+4;t=p}p=t;r=t;v=d+4|0;L11:do{if((a[v]&1)==0){w=m;c[w>>2]=c[v>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];s=18}else{w=c[d+12>>2]|0;x=c[d+8>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[m]=x<<1;y=m+1|0}else{A=x+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[m+8>>2]=B;c[m>>2]=A|1;c[m+4>>2]=x;y=B}LF(y|0,w|0,x)|0;a[y+x|0]=0;s=18;break L11}}while(0);x=bT(-1,-1)|0;C=x;D=M}}while(0);do{if((s|0)==18){v=d+16|0;x=h;c[x>>2]=c[v>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];z=0;aV(58,r|0,m|0,h|0,0);if(z){z=0;v=bT(-1,-1)|0;x=v;v=M;if((a[m]&1)==0){C=x;D=v;break}Lw(c[m+8>>2]|0);C=x;D=v;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}v=c[d+36>>2]|0;x=c[d+40>>2]|0;L33:do{if((v|0)!=0){w=c[v+36>>2]|0;do{if(((c[v+40>>2]|0)-w|0)==4){B=c[w>>2]|0;if((B|0)==0){z=0;aS(10);if(z){z=0;s=45;break L1}return 0}else{if((c[(c[(c[B>>2]|0)-4>>2]|0)+4>>2]|0)!=27408){break}if((c[B+32>>2]|0)==0){break L33}else{break}}}}while(0);w=t+32|0;B=w;A=(z=0,az(34,b|0,v|0,e|0)|0);if(z){z=0;s=45;break L1}E=(A|0)==0?0:A+32|0;A=E+4|0;F=c[A>>2]|0;G=(c[E+8>>2]|0)-F>>2;if((G|0)==0){break}E=t+40|0;H=w+12|0;I=t+36|0;J=w;w=0;K=F;while(1){F=c[K+(w<<2)>>2]|0;c[g>>2]=F;L=c[E>>2]|0;N=L;if((N|0)==(c[H>>2]|0)){z=0;as(272,I|0,g|0);if(z){z=0;break}O=c[g>>2]|0}else{if((L|0)==0){P=0}else{c[N>>2]=F;P=c[E>>2]|0}c[E>>2]=P+4;O=F}z=0;as(c[c[J>>2]>>2]|0,B|0,O|0);if(z){z=0;break}F=w+1|0;if(F>>>0>=G>>>0){break L33}w=F;K=c[A>>2]|0}A=bT(-1,-1)|0;Q=M;R=A;s=46;break L1}}while(0);if((x|0)==0){Bx(l);i=f;return r|0}v=t+32|0;A=v;K=t+40|0;w=v+12|0;G=t+36|0;B=v;v=x;L62:while(1){J=c[v+36>>2]|0;E=c[v+40>>2]|0;L64:do{if((J|0)!=0){I=c[J+36>>2]|0;do{if(((c[J+40>>2]|0)-I|0)==4){H=c[I>>2]|0;if((H|0)==0){s=59;break L62}if((c[(c[(c[H>>2]|0)-4>>2]|0)+4>>2]|0)!=27408){break}if((c[H+32>>2]|0)==0){break L64}}}while(0);I=(z=0,az(34,b|0,J|0,e|0)|0);if(z){z=0;s=43;break L62}H=(I|0)==0?0:I+32|0;I=H+4|0;F=c[I>>2]|0;N=(c[H+8>>2]|0)-F>>2;if((N|0)==0){break}else{S=0;T=F}while(1){F=c[T+(S<<2)>>2]|0;c[k>>2]=F;H=c[K>>2]|0;L=H;if((L|0)==(c[w>>2]|0)){z=0;as(272,G|0,k|0);if(z){z=0;s=42;break L62}U=c[k>>2]|0}else{if((H|0)==0){V=0}else{c[L>>2]=F;V=c[K>>2]|0}c[K>>2]=V+4;U=F}z=0;as(c[c[B>>2]>>2]|0,A|0,U|0);if(z){z=0;s=42;break L62}F=S+1|0;if(F>>>0>=N>>>0){break L64}S=F;T=c[I>>2]|0}}}while(0);if((E|0)==0){s=79;break}else{v=E}}if((s|0)==59){z=0;aS(10);if(z){z=0;s=45;break L1}return 0}else if((s|0)==79){Bx(l);i=f;return r|0}else if((s|0)==42){v=bT(-1,-1)|0;Q=M;R=v;s=46;break L1}else if((s|0)==43){v=bT(-1,-1)|0;Q=M;R=v;s=46;break L1}}}while(0);r=c[n>>2]|0;v=c[q>>2]|0;A=r;while(1){if((A|0)==(v|0)){W=v;break}if((c[A>>2]|0)==(t|0)){W=A;break}else{A=A+4|0}}A=W-r>>2;B=r+(A+1<<2)|0;K=v-B|0;LG(r+(A<<2)|0,B|0,K|0)|0;B=r+((K>>2)+A<<2)|0;A=c[q>>2]|0;if((B|0)!=(A|0)){c[q>>2]=A+(~((A-4+(-B|0)|0)>>>2)<<2)}Lw(p);X=C;Y=D}else{z=0;s=45}}while(0);if((s|0)==45){D=bT(-1,-1)|0;Q=M;R=D;s=46}if((s|0)==46){X=R;Y=Q}z=0;ar(444,l|0);if(!z){bg(X|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function oO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0;f=i;i=i+168|0;g=f|0;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+48|0;n=f+56|0;o=f+72|0;p=f+80|0;q=f+88|0;r=f+104|0;s=f+120|0;t=f+136|0;u=f+152|0;Bv(p,0);v=b+4|0;b=c[v>>2]|0;w=(z=0,au(248,48)|0);L1:do{if(!z){x=w;c[o>>2]=x;y=b+4|0;A=c[y>>2]|0;if((A|0)==(c[b+8>>2]|0)){z=0;as(382,b|0,o|0);if(z){z=0;B=47;break}C=c[o>>2]|0}else{if((A|0)==0){D=0}else{c[A>>2]=x;D=c[y>>2]|0}c[y>>2]=D+4;C=x}x=C;A=C;E=d+4|0;L11:do{if((a[E]&1)==0){F=q;c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];B=18}else{F=c[d+12>>2]|0;G=c[d+8>>2]|0;do{if(G>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(G>>>0<11>>>0){a[q]=G<<1;H=q+1|0}else{I=G+16&-16;J=(z=0,au(248,I|0)|0);if(z){z=0;break}c[q+8>>2]=J;c[q>>2]=I|1;c[q+4>>2]=G;H=J}LF(H|0,F|0,G)|0;a[H+G|0]=0;B=18;break L11}}while(0);G=bT(-1,-1)|0;K=M;L=G}}while(0);do{if((B|0)==18){E=d+16|0;G=n;c[G>>2]=c[E>>2];c[G+4>>2]=c[E+4>>2];c[G+8>>2]=c[E+8>>2];z=0;aV(58,A|0,q|0,n|0,0);if(z){z=0;E=bT(-1,-1)|0;G=E;E=M;if((a[q]&1)==0){K=E;L=G;break}Lw(c[q+8>>2]|0);K=E;L=G;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}G=p|0;z=0;aR(c[(c[d>>2]|0)+28>>2]|0,r|0,d|0,G|0);if(z){z=0;B=47;break L1}z=0;aR(c[(c[e>>2]|0)+28>>2]|0,s|0,e|0,G|0);if(z){z=0;G=bT(-1,-1)|0;E=G;G=M;if((a[r]&1)==0){N=G;O=E;break L1}Lw(c[r+8>>2]|0);N=G;O=E;break L1}E=r;G=r;F=a[G]|0;J=F&255;if((J&1|0)==0){P=J>>>1}else{P=c[r+4>>2]|0}J=s;I=a[s]|0;Q=I&255;if((Q&1|0)==0){R=Q>>>1}else{R=c[s+4>>2]|0}L46:do{if((P|0)==(R|0)){Q=(F&1)==0;if(Q){S=E+1|0}else{S=c[r+8>>2]|0}T=I&1;if(T<<24>>24==0){U=J+1|0}else{U=c[s+8>>2]|0}if(!Q){V=(LH(S|0,U|0,P|0)|0)==0;W=T;break}if((P|0)==0){V=1;W=T;break}else{X=U;Y=S;Z=P}while(1){if((a[Y]|0)!=(a[X]|0)){V=0;W=T;break L46}Q=Z-1|0;if((Q|0)==0){V=1;W=T;break}else{X=X+1|0;Y=Y+1|0;Z=Q}}}else{V=0;W=I&1}}while(0);if(W<<24>>24==0){_=F}else{Lw(c[s+8>>2]|0);_=a[G]|0}if((_&1)!=0){Lw(c[r+8>>2]|0)}if(V){Bx(p);i=f;return A|0}I=(z=0,aM(52,d|0,c[v>>2]|0)|0);if(z){z=0;B=47;break L1}J=(z=0,aM(52,e|0,c[v>>2]|0)|0);if(z){z=0;B=47;break L1}E=(I|0)!=0;if((J|0)==0|E^1){if(!E){E=C+32|0;T=E;c[g>>2]=e;Q=C+40|0;$=c[Q>>2]|0;aa=$;if((aa|0)==(c[E+12>>2]|0)){z=0;as(272,C+36|0,g|0);if(z){z=0;B=47;break L1}ab=c[g>>2]|0}else{if(($|0)==0){ac=0}else{c[aa>>2]=e;ac=c[Q>>2]|0}c[Q>>2]=ac+4;ab=e}z=0;as(c[c[E>>2]>>2]|0,T|0,ab|0);if(z){z=0;B=47;break L1}Bx(p);i=f;return A|0}T=(z=0,au(136,I|0)|0);if(z){z=0;B=47;break L1}c[T+40>>2]=e;T=C+32|0;E=T;c[h>>2]=I;Q=C+40|0;aa=c[Q>>2]|0;$=aa;if(($|0)==(c[T+12>>2]|0)){z=0;as(272,C+36|0,h|0);if(z){z=0;B=47;break L1}ad=c[h>>2]|0}else{if((aa|0)==0){ae=0}else{c[$>>2]=I;ae=c[Q>>2]|0}c[Q>>2]=ae+4;ad=I}z=0;as(c[c[T>>2]>>2]|0,E|0,ad|0);if(z){z=0;B=47;break L1}Bx(p);i=f;return A|0}E=c[v>>2]|0;T=(z=0,au(248,44)|0);if(z){z=0;B=47;break L1}Q=T;c[m>>2]=Q;T=E+4|0;$=c[T>>2]|0;if(($|0)==(c[E+8>>2]|0)){z=0;as(382,E|0,m|0);if(z){z=0;B=47;break L1}af=c[m>>2]|0}else{if(($|0)==0){ag=0}else{c[$>>2]=Q;ag=c[T>>2]|0}c[T>>2]=ag+4;af=Q}Q=af;$=af;aa=C+4|0;L109:do{if((a[aa]&1)==0){ah=t;c[ah>>2]=c[aa>>2];c[ah+4>>2]=c[aa+4>>2];c[ah+8>>2]=c[aa+8>>2];B=79}else{ah=c[C+12>>2]|0;ai=c[C+8>>2]|0;do{if(ai>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ai>>>0<11>>>0){a[t]=ai<<1;aj=t+1|0}else{ak=ai+16&-16;al=(z=0,au(248,ak|0)|0);if(z){z=0;break}c[t+8>>2]=al;c[t>>2]=ak|1;c[t+4>>2]=ai;aj=al}LF(aj|0,ah|0,ai)|0;a[aj+ai|0]=0;B=79;break L109}}while(0);ai=bT(-1,-1)|0;am=M;an=ai}}while(0);do{if((B|0)==79){aa=u;G=C+16|0;c[aa>>2]=c[G>>2];c[aa+4>>2]=c[G+4>>2];c[aa+8>>2]=c[G+8>>2];G=(z=0,au(82,e|0)|0);do{if(!z){F=l;c[F>>2]=c[aa>>2];c[F+4>>2]=c[aa+4>>2];c[F+8>>2]=c[aa+8>>2];z=0;aD(20,$|0,t|0,l|0,0,G|0,0);if(z){z=0;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}F=(z=0,au(136,I|0)|0);if(z){z=0;B=47;break L1}c[F+40>>2]=e;F=C+32|0;ai=F;c[k>>2]=I;ah=C+40|0;al=c[ah>>2]|0;ak=al;ao=F+12|0;if((ak|0)==(c[ao>>2]|0)){z=0;as(272,C+36|0,k|0);if(z){z=0;B=47;break L1}ap=c[k>>2]|0}else{if((al|0)==0){aq=0}else{c[ak>>2]=I;aq=c[ah>>2]|0}c[ah>>2]=aq+4;ap=I}ak=F;z=0;as(c[c[ak>>2]>>2]|0,ai|0,ap|0);if(z){z=0;B=47;break L1}F=(z=0,aM(52,d|0,c[v>>2]|0)|0);if(z){z=0;B=47;break L1}al=(z=0,au(136,F|0)|0);if(z){z=0;B=47;break L1}c[al+40>>2]=$;al=(z=0,au(136,J|0)|0);if(z){z=0;B=47;break L1}c[al+40>>2]=F;c[j>>2]=J;F=c[ah>>2]|0;al=F;if((al|0)==(c[ao>>2]|0)){z=0;as(272,C+36|0,j|0);if(z){z=0;B=47;break L1}at=c[j>>2]|0}else{if((F|0)==0){av=0}else{c[al>>2]=J;av=c[ah>>2]|0}c[ah>>2]=av+4;at=J}z=0;as(c[c[ak>>2]>>2]|0,ai|0,at|0);if(z){z=0;B=47;break L1}Bx(p);i=f;return A|0}else{z=0}}while(0);G=bT(-1,-1)|0;aa=G;G=M;if((a[t]&1)==0){am=G;an=aa;break}Lw(c[t+8>>2]|0);am=G;an=aa}}while(0);J=c[E>>2]|0;$=c[T>>2]|0;I=J;while(1){if((I|0)==($|0)){aw=$;break}if((c[I>>2]|0)==(af|0)){aw=I;break}else{I=I+4|0}}I=aw-J>>2;E=J+(I+1<<2)|0;aa=$-E|0;LG(J+(I<<2)|0,E|0,aa|0)|0;E=J+((aa>>2)+I<<2)|0;I=c[T>>2]|0;if((E|0)!=(I|0)){c[T>>2]=I+(~((I-4+(-E|0)|0)>>>2)<<2)}Lw(Q);N=am;O=an;break L1}}while(0);A=c[b>>2]|0;E=c[y>>2]|0;I=A;while(1){if((I|0)==(E|0)){ax=E;break}if((c[I>>2]|0)==(C|0)){ax=I;break}else{I=I+4|0}}I=ax-A>>2;aa=A+(I+1<<2)|0;G=E-aa|0;LG(A+(I<<2)|0,aa|0,G|0)|0;aa=A+((G>>2)+I<<2)|0;I=c[y>>2]|0;if((aa|0)!=(I|0)){c[y>>2]=I+(~((I-4+(-aa|0)|0)>>>2)<<2)}Lw(x);N=K;O=L}else{z=0;B=47}}while(0);if((B|0)==47){B=bT(-1,-1)|0;N=M;O=B}z=0;ar(444,p|0);if(!z){bg(O|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function oP(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function oQ(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;if((d|0)==0){return}cB[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function oR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0;f=i;i=i+216|0;g=f|0;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+56|0;n=f+64|0;o=f+80|0;p=f+88|0;q=f+96|0;r=f+104|0;s=f+112|0;t=f+120|0;u=f+136|0;v=f+152|0;w=f+168|0;x=f+184|0;y=f+200|0;Bv(s,0);A=b+4|0;B=c[A>>2]|0;C=(z=0,au(248,48)|0);L1:do{if(!z){D=C;c[o>>2]=D;E=B+4|0;F=c[E>>2]|0;if((F|0)==(c[B+8>>2]|0)){z=0;as(382,B|0,o|0);if(z){z=0;G=40;break}H=c[o>>2]|0}else{if((F|0)==0){I=0}else{c[F>>2]=D;I=c[E>>2]|0}c[E>>2]=I+4;H=D}D=H;F=H;J=d+4|0;L11:do{if((a[J]&1)==0){K=t;c[K>>2]=c[J>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];G=18}else{K=c[d+12>>2]|0;L=c[d+8>>2]|0;do{if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(L>>>0<11>>>0){a[t]=L<<1;N=t+1|0}else{O=L+16&-16;P=(z=0,au(248,O|0)|0);if(z){z=0;break}c[t+8>>2]=P;c[t>>2]=O|1;c[t+4>>2]=L;N=P}LF(N|0,K|0,L)|0;a[N+L|0]=0;G=18;break L11}}while(0);L=bT(-1,-1)|0;Q=L;R=M}}while(0);do{if((G|0)==18){L=d+16|0;K=n;c[K>>2]=c[L>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];z=0;aV(58,F|0,t|0,n|0,0);if(z){z=0;K=bT(-1,-1)|0;P=K;K=M;if((a[t]&1)==0){Q=P;R=K;break}Lw(c[t+8>>2]|0);Q=P;R=K;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}K=c[b+12>>2]|0;z=0;as(104,v|0,d|0);if(z){z=0;G=40;break L1}z=0;aR(174,u|0,K|0,v|0);if(z){z=0;K=bT(-1,-1)|0;P=K;K=M;O=v|0;S=c[O>>2]|0;if((S|0)==0){T=P;U=K;break L1}V=v+4|0;W=c[V>>2]|0;if((S|0)==(W|0)){X=S}else{Y=W;while(1){W=Y-12|0;c[V>>2]=W;if((a[W]&1)==0){Z=W}else{Lw(c[Y-12+8>>2]|0);Z=c[V>>2]|0}if((S|0)==(Z|0)){break}else{Y=Z}}X=c[O>>2]|0}Lw(X);T=P;U=K;break L1}Y=v|0;S=c[Y>>2]|0;if((S|0)!=0){V=v+4|0;W=c[V>>2]|0;if((S|0)==(W|0)){_=S}else{$=W;while(1){W=$-12|0;c[V>>2]=W;if((a[W]&1)==0){aa=W}else{Lw(c[$-12+8>>2]|0);aa=c[V>>2]|0}if((S|0)==(aa|0)){break}else{$=aa}}_=c[Y>>2]|0}Lw(_)}$=u+4|0;S=u|0;V=c[S>>2]|0;K=(c[$>>2]|0)-V>>3;L57:do{if((K|0)==0){ab=V}else{P=e+4|0;O=w;W=w+8|0;ac=d+12|0;ad=d+8|0;ae=w+1|0;af=w|0;ag=w+4|0;ah=x;ai=H+32|0;aj=ai;ak=H+40|0;al=ai+12|0;am=H+36|0;an=ai;ai=y|0;ao=y|0;ap=y+4|0;aq=ap|0;at=y+8|0;av=ap;ap=e|0;aw=e+4|0;ax=aw;ay=y+4|0;aA=q|0;aB=x+8|0;aC=x+1|0;aE=x|0;aF=x+4|0;aG=0;aH=V;L59:while(1){aI=c[aH+(aG<<3)+4>>2]|0;aJ=c[P>>2]|0;L61:do{if((aJ|0)==0){aK=aI;G=61}else{aL=aJ;do{aN=aL+16|0;aO=(z=0,aM(80,aI|0,aN|0)|0);if(z){z=0;G=57;break L59}if(aO){aP=aL|0}else{aO=(z=0,aM(80,aN|0,aI|0)|0);if(z){z=0;G=57;break L59}if(!aO){break L61}aP=aL+4|0}aL=c[aP>>2]|0;}while((aL|0)!=0);aK=c[(c[S>>2]|0)+(aG<<3)+4>>2]|0;G=61}}while(0);do{if((G|0)==61){G=0;aI=(z=0,az(12,d|0,aK|0,c[A>>2]|0)|0);if(z){z=0;G=58;break L59}aJ=(z=0,au(82,c[(c[S>>2]|0)+(aG<<3)>>2]|0)|0);if(z){z=0;G=58;break L59}do{if((aJ|0)==0){aQ=c[A>>2]|0;aL=(z=0,au(248,60)|0);if(z){z=0;G=58;break L59}aO=aL;c[m>>2]=aO;aS=aQ+4|0;aL=c[aS>>2]|0;if((aL|0)==(c[aQ+8>>2]|0)){z=0;as(382,aQ|0,m|0);if(z){z=0;G=58;break L59}aT=c[m>>2]|0}else{if((aL|0)==0){aU=0}else{c[aL>>2]=aO;aU=c[aS>>2]|0}c[aS>>2]=aU+4;aT=aO}aW=aT;aO=aT;if((a[J]&1)==0){c[O>>2]=c[J>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2]}else{aL=c[ac>>2]|0;aN=c[ad>>2]|0;if(aN>>>0>4294967279>>>0){G=74;break L59}if(aN>>>0<11>>>0){a[O]=aN<<1;aX=ae}else{aY=aN+16&-16;aZ=(z=0,au(248,aY|0)|0);if(z){z=0;G=84;break L59}c[W>>2]=aZ;c[af>>2]=aY|1;c[ag>>2]=aN;aX=aZ}LF(aX|0,aL|0,aN)|0;a[aX+aN|0]=0}aN=l;c[aN>>2]=c[L>>2];c[aN+4>>2]=c[L+4>>2];c[aN+8>>2]=c[L+8>>2];z=0;aV(42,aO|0,w|0,l|0,0);if(z){z=0;G=87;break L59}if((a[O]&1)==0){a_=aO;break}Lw(c[W>>2]|0);a_=aO}else{a_=aJ}}while(0);do{if((c[a_+40>>2]|0)==(c[a_+36>>2]|0)){a$=aI}else{if((c[aI+40>>2]|0)==(c[aI+36>>2]|0)){a$=a_;break}aJ=(z=0,az(54,a_|0,aI|0,c[A>>2]|0)|0);if(!z){a$=aJ}else{z=0;G=58;break L59}}}while(0);if((a$|0)==0){break}if((c[a$+40>>2]|0)==(c[a$+36>>2]|0)){break}aI=(z=0,aM(642,c[(c[S>>2]|0)+(aG<<3)>>2]|0,c[A>>2]|0)|0);if(z){z=0;G=58;break L59}a0=c[A>>2]|0;aJ=(z=0,au(248,44)|0);if(z){z=0;G=58;break L59}aO=aJ;c[k>>2]=aO;a1=a0+4|0;aJ=c[a1>>2]|0;if((aJ|0)==(c[a0+8>>2]|0)){z=0;as(382,a0|0,k|0);if(z){z=0;G=58;break L59}a2=c[k>>2]|0}else{if((aJ|0)==0){a3=0}else{c[aJ>>2]=aO;a3=c[a1>>2]|0}c[a1>>2]=a3+4;a2=aO}a4=a2;aO=a2;if((a[J]&1)==0){c[ah>>2]=c[J>>2];c[ah+4>>2]=c[J+4>>2];c[ah+8>>2]=c[J+8>>2]}else{aJ=c[ac>>2]|0;aN=c[ad>>2]|0;if(aN>>>0>4294967279>>>0){G=111;break L59}if(aN>>>0<11>>>0){a[ah]=aN<<1;a5=aC}else{aL=aN+16&-16;aZ=(z=0,au(248,aL|0)|0);if(z){z=0;G=152;break L59}c[aB>>2]=aZ;c[aE>>2]=aL|1;c[aF>>2]=aN;a5=aZ}LF(a5|0,aJ|0,aN)|0;a[a5+aN|0]=0}aN=j;c[aN>>2]=c[L>>2];c[aN+4>>2]=c[L+4>>2];c[aN+8>>2]=c[L+8>>2];z=0;aD(20,aO|0,x|0,j|0,0,a$|0,0);if(z){z=0;G=155;break L59}if((a[ah]&1)!=0){Lw(c[aB>>2]|0)}aN=(z=0,au(48,aI|0)|0);if(z){z=0;G=58;break L59}z=0;aR(482,aI|0,aO|0,aN|0);if(z){z=0;G=58;break L59}c[h>>2]=aI;aN=c[ak>>2]|0;aO=aN;if((aO|0)==(c[al>>2]|0)){z=0;as(272,am|0,h|0);if(z){z=0;G=58;break L59}a6=c[h>>2]|0}else{if((aN|0)==0){a7=0}else{c[aO>>2]=aI;a7=c[ak>>2]|0}c[ak>>2]=a7+4;a6=aI}z=0;as(c[c[an>>2]>>2]|0,aj|0,a6|0);if(z){z=0;G=58;break L59}c[aq>>2]=0;c[at>>2]=0;c[ao>>2]=av;aO=c[ap>>2]|0;if((aO|0)!=(ax|0)){aN=aO;while(1){c[aA>>2]=av;z=0;aV(40,r|0,ai|0,q|0,aN+16|0);if(z){z=0;G=137;break L59}aO=c[aN+4>>2]|0;if((aO|0)==0){aJ=aN|0;while(1){aZ=c[aJ+8>>2]|0;if((aJ|0)==(c[aZ>>2]|0)){a8=aZ;break}else{aJ=aZ}}}else{aJ=aO;while(1){aZ=c[aJ>>2]|0;if((aZ|0)==0){a8=aJ;break}else{aJ=aZ}}}if((a8|0)==(aw|0)){break}else{aN=a8}}}z=0;aR(22,p|0,ai|0,c[(c[S>>2]|0)+(aG<<3)+4>>2]|0);if(z){z=0;G=164;break L59}aN=(z=0,az(2,b|0,aI|0,y|0)|0);if(z){z=0;G=164;break L59}aJ=(aN|0)==0?0:aN+32|0;aN=aJ+4|0;aO=c[aN>>2]|0;aZ=(c[aJ+8>>2]|0)-aO>>2;L155:do{if((aZ|0)!=0){aJ=0;aL=aO;while(1){aY=c[aL+(aJ<<2)>>2]|0;c[g>>2]=aY;a9=c[ak>>2]|0;ba=a9;if((ba|0)==(c[al>>2]|0)){z=0;as(272,am|0,g|0);if(z){z=0;G=163;break L59}bb=c[g>>2]|0}else{if((a9|0)==0){bc=0}else{c[ba>>2]=aY;bc=c[ak>>2]|0}c[ak>>2]=bc+4;bb=aY}z=0;as(c[c[an>>2]>>2]|0,aj|0,bb|0);if(z){z=0;G=163;break L59}aY=aJ+1|0;if(aY>>>0>=aZ>>>0){break L155}aJ=aY;aL=c[aN>>2]|0}}}while(0);pF(ai,c[ay>>2]|0)}}while(0);aN=aG+1|0;aZ=c[S>>2]|0;if(aN>>>0<K>>>0){aG=aN;aH=aZ}else{ab=aZ;break L57}}do{if((G|0)==155){aH=bT(-1,-1)|0;aG=aH;aH=M;if((a[ah]&1)==0){bd=aG;be=aH;G=157;break}Lw(c[aB>>2]|0);bd=aG;be=aH;G=157}else if((G|0)==137){aH=bT(-1,-1)|0;aG=M;pF(ai,c[ay>>2]|0);bf=aG;bh=aH;G=59}else if((G|0)==163){aH=bT(-1,-1)|0;bi=M;bj=aH;G=165}else if((G|0)==164){aH=bT(-1,-1)|0;bi=M;bj=aH;G=165}else if((G|0)==152){aH=bT(-1,-1)|0;bk=M;bl=aH;G=154}else if((G|0)==111){z=0;ar(86,0);if(!z){return 0}else{z=0;aH=bT(-1,-1)|0;bk=M;bl=aH;G=154;break}}else if((G|0)==57){aH=bT(-1,-1)|0;bf=M;bh=aH;G=59}else if((G|0)==58){aH=bT(-1,-1)|0;bf=M;bh=aH;G=59}else if((G|0)==74){z=0;ar(86,0);if(!z){return 0}else{z=0;aH=bT(-1,-1)|0;bm=M;bn=aH;G=86;break}}else if((G|0)==84){aH=bT(-1,-1)|0;bm=M;bn=aH;G=86}else if((G|0)==87){aH=bT(-1,-1)|0;aG=aH;aH=M;if((a[O]&1)==0){bo=aG;bp=aH;G=89;break}Lw(c[W>>2]|0);bo=aG;bp=aH;G=89}}while(0);if((G|0)==165){pF(ai,c[ay>>2]|0);bq=bj;br=bi}else if((G|0)==154){bd=bl;be=bk;G=157}else if((G|0)==59){bq=bh;br=bf}else if((G|0)==86){bo=bn;bp=bm;G=89}if((G|0)==157){W=c[a0>>2]|0;O=c[a1>>2]|0;aB=W;while(1){if((aB|0)==(O|0)){bs=O;break}if((c[aB>>2]|0)==(a2|0)){bs=aB;break}else{aB=aB+4|0}}aB=bs-W>>2;ay=W+(aB+1<<2)|0;ai=O-ay|0;LG(W+(aB<<2)|0,ay|0,ai|0)|0;ay=W+((ai>>2)+aB<<2)|0;aB=c[a1>>2]|0;if((ay|0)!=(aB|0)){c[a1>>2]=aB+(~((aB-4+(-ay|0)|0)>>>2)<<2)}Lw(a4);bq=bd;br=be}else if((G|0)==89){ay=c[aQ>>2]|0;aB=c[aS>>2]|0;ai=ay;while(1){if((ai|0)==(aB|0)){bt=aB;break}if((c[ai>>2]|0)==(aT|0)){bt=ai;break}else{ai=ai+4|0}}ai=bt-ay>>2;W=ay+(ai+1<<2)|0;O=aB-W|0;LG(ay+(ai<<2)|0,W|0,O|0)|0;W=ay+((O>>2)+ai<<2)|0;ai=c[aS>>2]|0;if((W|0)!=(ai|0)){c[aS>>2]=ai+(~((ai-4+(-W|0)|0)>>>2)<<2)}Lw(aW);bq=bo;br=bp}W=c[S>>2]|0;if((W|0)==0){T=bq;U=br;break L1}ai=c[$>>2]|0;if((W|0)!=(ai|0)){c[$>>2]=ai+(~((ai-8+(-W|0)|0)>>>3)<<3)}Lw(W);T=bq;U=br;break L1}}while(0);if((ab|0)==0){Bx(s);i=f;return F|0}S=c[$>>2]|0;if((ab|0)!=(S|0)){c[$>>2]=S+(~((S-8+(-ab|0)|0)>>>3)<<3)}Lw(ab);Bx(s);i=f;return F|0}}while(0);F=c[B>>2]|0;J=c[E>>2]|0;S=F;while(1){if((S|0)==(J|0)){bu=J;break}if((c[S>>2]|0)==(H|0)){bu=S;break}else{S=S+4|0}}S=bu-F>>2;K=F+(S+1<<2)|0;L=J-K|0;LG(F+(S<<2)|0,K|0,L|0)|0;K=F+((L>>2)+S<<2)|0;S=c[E>>2]|0;if((K|0)!=(S|0)){c[E>>2]=S+(~((S-4+(-K|0)|0)>>>2)<<2)}Lw(D);T=Q;U=R}else{z=0;G=40}}while(0);if((G|0)==40){G=bT(-1,-1)|0;T=G;U=M}z=0;ar(444,s|0);if(!z){bg(T|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function oS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+16|0;g=f|0;pI(g,d,e);e=b|0;c[e>>2]=0;d=b+4|0;c[d>>2]=0;h=b+8|0;c[h>>2]=0;j=g+4|0;k=c[j>>2]|0;l=g|0;g=c[l>>2]|0;m=(k-g|0)/20|0;L1:do{if((k|0)==(g|0)){n=k}else{o=0;p=g;q=0;r=0;while(1){s=p+(o*20|0)|0;if((q|0)==(r|0)){z=0;as(464,b|0,s|0);if(z){z=0;break}}else{if((q|0)==0){t=0}else{c[q>>2]=c[s>>2];c[q+4>>2]=c[p+(o*20|0)+4>>2];t=c[d>>2]|0}c[d>>2]=t+8}s=o+1|0;u=c[l>>2]|0;if(s>>>0>=m>>>0){n=u;break L1}o=s;p=u;q=c[d>>2]|0;r=c[h>>2]|0}r=bT(-1,-1)|0;q=c[e>>2]|0;p=q;if((q|0)!=0){o=c[d>>2]|0;if((q|0)!=(o|0)){c[d>>2]=o+(~((o-8+(-p|0)|0)>>>3)<<3)}Lw(q)}q=c[l>>2]|0;if((q|0)==0){bg(r|0)}p=c[j>>2]|0;if((q|0)==(p|0)){v=q}else{o=p;while(1){p=o-20|0;c[j>>2]=p;u=o-20+8|0;s=c[u>>2]|0;if((s|0)==0){w=p}else{p=o-20+12|0;x=c[p>>2]|0;if((s|0)==(x|0)){y=s}else{A=x;while(1){x=A-12|0;c[p>>2]=x;if((a[x]&1)==0){B=x}else{Lw(c[A-12+8>>2]|0);B=c[p>>2]|0}if((s|0)==(B|0)){break}else{A=B}}y=c[u>>2]|0}Lw(y);w=c[j>>2]|0}if((q|0)==(w|0)){break}else{o=w}}v=c[l>>2]|0}Lw(v);bg(r|0)}}while(0);if((n|0)==0){i=f;return}v=c[j>>2]|0;if((n|0)==(v|0)){C=n}else{w=v;while(1){v=w-20|0;c[j>>2]=v;y=w-20+8|0;B=c[y>>2]|0;if((B|0)==0){D=v}else{v=w-20+12|0;d=c[v>>2]|0;if((B|0)==(d|0)){E=B}else{e=d;while(1){d=e-12|0;c[v>>2]=d;if((a[d]&1)==0){F=d}else{Lw(c[e-12+8>>2]|0);F=c[v>>2]|0}if((B|0)==(F|0)){break}else{e=F}}E=c[y>>2]|0}Lw(E);D=c[j>>2]|0}if((n|0)==(D|0)){break}else{w=D}}C=c[l>>2]|0}Lw(C);i=f;return}function oT(a,b){a=a|0;b=b|0;return}function oU(a){a=a|0;return}function oV(a){a=a|0;Lw(a);return}function oW(a,b){a=a|0;b=b|0;return}function oX(a,b){a=a|0;b=b|0;return}function oY(a,b){a=a|0;b=b|0;return}function oZ(a,b){a=a|0;b=b|0;return}function o_(a,b){a=a|0;b=b|0;return}function o$(a,b){a=a|0;b=b|0;return}function o0(a,b){a=a|0;b=b|0;return}function o1(a,b){a=a|0;b=b|0;return}function o2(a,b){a=a|0;b=b|0;return}function o3(a,b){a=a|0;b=b|0;return}function o4(a,b){a=a|0;b=b|0;return}function o5(a,b){a=a|0;b=b|0;return}function o6(a,b){a=a|0;b=b|0;return}function o7(a,b){a=a|0;b=b|0;return}function o8(a,b){a=a|0;b=b|0;return}function o9(a,b){a=a|0;b=b|0;return}function pa(a,b){a=a|0;b=b|0;return}function pb(a,b){a=a|0;b=b|0;return}function pc(a,b){a=a|0;b=b|0;return}function pd(a,b){a=a|0;b=b|0;return}function pe(a,b){a=a|0;b=b|0;return}function pf(a,b){a=a|0;b=b|0;return}function pg(a,b){a=a|0;b=b|0;return}function ph(a,b){a=a|0;b=b|0;return}function pi(a,b){a=a|0;b=b|0;return}function pj(a,b){a=a|0;b=b|0;return}function pk(a,b){a=a|0;b=b|0;return}function pl(a,b){a=a|0;b=b|0;return}function pm(a,b){a=a|0;b=b|0;return}function pn(a,b){a=a|0;b=b|0;return}function po(a,b){a=a|0;b=b|0;return}function pp(a,b){a=a|0;b=b|0;return}function pq(a,b){a=a|0;b=b|0;return}function pr(a,b){a=a|0;b=b|0;return}function ps(a,b){a=a|0;b=b|0;return}function pt(a,b){a=a|0;b=b|0;return}function pu(a,b){a=a|0;b=b|0;return}function pv(a,b){a=a|0;b=b|0;return}function pw(a,b){a=a|0;b=b|0;return}function px(a,b){a=a|0;b=b|0;return}function py(a,b){a=a|0;b=b|0;return}function pz(a,b){a=a|0;b=b|0;return}function pA(a,b){a=a|0;b=b|0;return}function pB(a,b){a=a|0;b=b|0;return}function pC(a,b){a=a|0;b=b|0;return}function pD(a,b){a=a|0;b=b|0;return}function pE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+8|0;g=f|0;h=d+4|0;j=h|0;k=c[j>>2]|0;do{if((k|0)==0){l=h;c[g>>2]=l;m=j;n=l}else{l=k;while(1){o=l+16|0;if(dk(e,o)|0){p=l|0;q=c[p>>2]|0;if((q|0)==0){r=4;break}else{l=q;continue}}if(!(dk(o,e)|0)){r=8;break}s=l+4|0;o=c[s>>2]|0;if((o|0)==0){r=7;break}else{l=o}}if((r|0)==7){c[g>>2]=l;m=s;n=l;break}else if((r|0)==4){c[g>>2]=l;m=p;n=l;break}else if((r|0)==8){c[g>>2]=l;m=g;n=l;break}}}while(0);g=c[m>>2]|0;if((g|0)!=0){t=g;u=0;v=b|0;c[v>>2]=t;w=b+4|0;a[w]=u;i=f;return}g=Lu(76)|0;r=g;p=g+16|0;do{if((p|0)!=0){z=0;as(326,p|0,e|0);if(!z){break}else{z=0}s=bT(-1,-1)|0;if((g|0)==0){bg(s|0)}Lw(g);bg(s|0)}}while(0);e=g;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=n;c[m>>2]=e;n=d|0;g=c[c[n>>2]>>2]|0;if((g|0)==0){x=e}else{c[n>>2]=g;x=c[m>>2]|0}e2(c[d+4>>2]|0,x);x=d+8|0;c[x>>2]=(c[x>>2]|0)+1;t=r;u=1;v=b|0;c[v>>2]=t;w=b+4|0;a[w]=u;i=f;return}function pF(a,b){a=a|0;b=b|0;if((b|0)==0){return}pF(a,c[b>>2]|0);pF(a,c[b+4>>2]|0);a=b+16|0;z=0;ar(c[c[a>>2]>>2]|0,a|0);if(z){z=0;a=bT(-1,-1)|0;bH(a|0)}Lw(b);return}function pG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=f|0;h=f+8|0;c[h>>2]=c[d>>2];d=pH(b,h,g,e)|0;h=c[d>>2]|0;if((h|0)!=0){j=h;k=a|0;c[k>>2]=j;i=f;return}h=Lu(76)|0;l=h;m=h+16|0;do{if((m|0)!=0){z=0;as(326,m|0,e|0);if(!z){break}else{z=0}n=bT(-1,-1)|0;if((h|0)==0){bg(n|0)}Lw(h);bg(n|0)}}while(0);e=c[g>>2]|0;g=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=e;c[d>>2]=g;e=b|0;h=c[c[e>>2]>>2]|0;if((h|0)==0){o=g}else{c[e>>2]=h;o=c[d>>2]|0}e2(c[b+4>>2]|0,o);o=b+8|0;c[o>>2]=(c[o>>2]|0)+1;j=l;k=a|0;c[k>>2]=j;i=f;return}function pH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b;b=i;i=i+4|0;i=i+7&-8;c[b>>2]=c[g>>2];g=a+4|0;h=c[b>>2]|0;do{if((h|0)!=(g|0)){b=h+16|0;if(dk(e,b)|0){break}if(!(dk(b,e)|0)){c[d>>2]=h;j=d;i=f;return j|0}b=h+4|0;k=c[b>>2]|0;if((k|0)==0){l=h|0;while(1){m=c[l+8>>2]|0;if((l|0)==(c[m>>2]|0)){n=m;break}else{l=m}}}else{l=k;while(1){m=c[l>>2]|0;if((m|0)==0){n=l;break}else{l=m}}}l=g;do{if((n|0)==(l|0)){o=k}else{if(dk(e,n+16|0)|0){o=c[b>>2]|0;break}m=g|0;p=c[m>>2]|0;if((p|0)==0){c[d>>2]=l;j=m;i=f;return j|0}else{q=p}while(1){p=q+16|0;if(dk(e,p)|0){r=q|0;m=c[r>>2]|0;if((m|0)==0){s=35;break}else{q=m;continue}}if(!(dk(p,e)|0)){s=39;break}t=q+4|0;p=c[t>>2]|0;if((p|0)==0){s=38;break}else{q=p}}if((s|0)==35){c[d>>2]=q;j=r;i=f;return j|0}else if((s|0)==38){c[d>>2]=q;j=t;i=f;return j|0}else if((s|0)==39){c[d>>2]=q;j=d;i=f;return j|0}}}while(0);if((o|0)==0){c[d>>2]=h;j=b;i=f;return j|0}else{c[d>>2]=n;j=n|0;i=f;return j|0}}}while(0);n=h|0;do{if((h|0)==(c[a>>2]|0)){u=h}else{o=c[n>>2]|0;if((o|0)==0){q=h|0;while(1){t=c[q+8>>2]|0;if((q|0)==(c[t>>2]|0)){q=t}else{v=t;break}}}else{q=o;while(1){b=c[q+4>>2]|0;if((b|0)==0){v=q;break}else{q=b}}}if(dk(v+16|0,e)|0){u=v;break}q=g|0;o=c[q>>2]|0;if((o|0)==0){c[d>>2]=g;j=q;i=f;return j|0}else{w=o}while(1){o=w+16|0;if(dk(e,o)|0){x=w|0;q=c[x>>2]|0;if((q|0)==0){s=15;break}else{w=q;continue}}if(!(dk(o,e)|0)){s=19;break}y=w+4|0;o=c[y>>2]|0;if((o|0)==0){s=18;break}else{w=o}}if((s|0)==15){c[d>>2]=w;j=x;i=f;return j|0}else if((s|0)==18){c[d>>2]=w;j=y;i=f;return j|0}else if((s|0)==19){c[d>>2]=w;j=d;i=f;return j|0}}}while(0);if((c[n>>2]|0)==0){c[d>>2]=h;j=n;i=f;return j|0}else{c[d>>2]=u;j=u+4|0;i=f;return j|0}return 0}function pI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0;f=i;i=i+224|0;g=f|0;h=f+8|0;j=f+24|0;k=f+32|0;l=f+40|0;m=f+48|0;n=f+56|0;o=f+64|0;p=f+72|0;q=f+80|0;r=f+96|0;s=f+112|0;t=f+128|0;u=f+144|0;v=f+160|0;w=f+176|0;x=f+184|0;y=f+208|0;gM(r,e);A=r|0;B=c[A>>2]|0;C=r+4|0;r=c[C>>2]|0;z=0;aR(416,B|0,r|0,f+88|0);do{if(!z){D=s|0;c[D>>2]=0;E=s+4|0;c[E>>2]=0;F=s+8|0;c[F>>2]=0;G=c[e+4>>2]|0;H=e|0;I=c[H>>2]|0;J=(G-I|0)/12|0;L4:do{if((G|0)==(I|0)){K=0;L=0;N=69}else{O=d+12|0;P=O|0;Q=h|0;R=O|0;S=d+16|0;T=d+20|0;U=t|0;V=t|0;W=t+4|0;X=t+8|0;Y=n|0;Z=o|0;_=p|0;$=q|0;aa=u|0;ab=u+4|0;ac=u+4|0;ad=v|0;ae=v+4|0;af=u+8|0;ag=0;ah=I;L6:while(1){ai=ah+(ag*12|0)|0;if((pX(P,ai)|0)!=0){aj=m$(O,g,ai)|0;ak=c[aj>>2]|0;al=ak;if((ak|0)==0){z=0;aR(398,h|0,O|0,ai|0);if(z){z=0;N=6;break}ai=c[Q>>2]|0;c[Q>>2]=0;ak=c[g>>2]|0;am=ai|0;c[ai>>2]=0;c[ai+4>>2]=0;c[ai+8>>2]=ak;c[aj>>2]=am;ak=c[c[R>>2]>>2]|0;if((ak|0)==0){an=am}else{c[R>>2]=ak;an=c[aj>>2]|0}e2(c[S>>2]|0,an);c[T>>2]=(c[T>>2]|0)+1;ao=ai}else{ao=al}c[V>>2]=0;c[W>>2]=0;c[X>>2]=0;al=ao+32|0;ai=c[al>>2]|0;aj=ao+28|0;ak=c[aj>>2]|0;do{if((ai|0)!=(ak|0)){am=ai-ak|0;ap=(am|0)/28|0;if(ap>>>0>153391689>>>0){N=16;break L6}aq=(z=0,au(248,am|0)|0);if(z){z=0;N=24;break L6}am=aq;c[W>>2]=am;c[V>>2]=am;c[X>>2]=am+(ap*28|0);ap=c[aj>>2]|0;at=c[al>>2]|0;if((ap|0)==(at|0)){break}else{av=ap;aw=am}do{if((aw|0)==0){ax=0}else{z=0;as(544,aw|0,av|0);if(!z){ax=aw}else{z=0;N=23;break L6}}aw=ax+28|0;c[W>>2]=aw;av=av+28|0;}while((av|0)!=(at|0));at=(aw-aq|0)/28|0;if((aw|0)==(am|0)){break}else{ay=0}do{ap=c[am+(ay*28|0)+12>>2]|0;c[Y>>2]=B;c[Z>>2]=r;c[_>>2]=ap;c[$>>2]=am+(ay*28|0)+16;do{if(pW(n,o,p,q,0)|0){ap=c[am+(ay*28|0)+24>>2]|0;z=0;as(294,v|0,am+(ay*28|0)|0);if(z){z=0;N=29;break L6}c[aa>>2]=ap;z=0;as(294,ab|0,v|0);if(z){z=0;N=51;break L6}ap=c[E>>2]|0;if((ap|0)==(c[F>>2]|0)){z=0;as(776,s|0,u|0);if(z){z=0;N=52;break L6}}else{if((ap|0)==0){az=0}else{c[ap>>2]=c[aa>>2];z=0;as(294,ap+4|0,ab|0);if(z){z=0;N=52;break L6}az=c[E>>2]|0}c[E>>2]=az+16}ap=c[ac>>2]|0;if((ap|0)!=0){aA=c[af>>2]|0;if((ap|0)!=(aA|0)){aB=aA;while(1){aA=aB-12|0;c[af>>2]=aA;if((a[aA]&1)!=0){Lw(c[aB-12+8>>2]|0)}if((ap|0)==(aA|0)){break}else{aB=aA}}}Lw(ap)}aB=c[ad>>2]|0;if((aB|0)==0){break}aA=c[ae>>2]|0;if((aB|0)!=(aA|0)){aC=aA;while(1){aA=aC-12|0;c[ae>>2]=aA;if((a[aA]&1)!=0){Lw(c[aC-12+8>>2]|0)}if((aB|0)==(aA|0)){break}else{aC=aA}}}Lw(aB)}}while(0);ay=ay+1|0;}while(ay>>>0<at>>>0)}}while(0);pU(U)}al=ag+1|0;if(al>>>0>=J>>>0){N=68;break}ag=al;ah=c[H>>2]|0}do{if((N|0)==68){K=c[D>>2]|0;L=c[E>>2]|0;N=69;break L4}else if((N|0)==24){ah=bT(-1,-1)|0;aD=M;aE=ah;N=26}else if((N|0)==29){ah=bT(-1,-1)|0;aF=ah;aG=M}else if((N|0)==23){ah=bT(-1,-1)|0;aD=M;aE=ah;N=26}else if((N|0)==51){ah=bT(-1,-1)|0;aH=ah;aI=M;N=58}else if((N|0)==52){ah=bT(-1,-1)|0;ag=ah;ah=M;ab=c[ac>>2]|0;if((ab|0)==0){aH=ag;aI=ah;N=58;break}aa=c[af>>2]|0;if((ab|0)!=(aa|0)){$=aa;while(1){aa=$-12|0;c[af>>2]=aa;if((a[aa]&1)!=0){Lw(c[$-12+8>>2]|0)}if((ab|0)==(aa|0)){break}else{$=aa}}}Lw(ab);aH=ag;aI=ah;N=58}else if((N|0)==16){z=0;ar(152,0);if(z){z=0;$=bT(-1,-1)|0;aD=M;aE=$;N=26;break}}else if((N|0)==6){$=bT(-1,-1)|0;aJ=M;aK=$;N=8;break L4}}while(0);if((N|0)==26){pU(U);aJ=aD;aK=aE;N=8;break}do{if((N|0)==58){af=c[ad>>2]|0;if((af|0)==0){aF=aH;aG=aI;break}ac=c[ae>>2]|0;if((af|0)!=(ac|0)){$=ac;while(1){ac=$-12|0;c[ae>>2]=ac;if((a[ac]&1)!=0){Lw(c[$-12+8>>2]|0)}if((af|0)==(ac|0)){break}else{$=ac}}}Lw(af);aF=aH;aG=aI}}while(0);pU(U);aL=aF;aM=aG}}while(0);L96:do{if((N|0)==69){z=0;aR(468,K|0,L|0,j|0);do{if(!z){H=c[E>>2]|0;c[k>>2]=c[D>>2];c[l>>2]=H;z=0;aV(36,w|0,k|0,l|0,m|0);if(z){z=0;break}z=0;as(388,s|0,(c[w>>2]|0)-(c[D>>2]|0)>>4|0);if(z){z=0;break}H=b|0;c[H>>2]=0;J=b+4|0;c[J>>2]=0;F=b+8|0;c[F>>2]=0;I=c[D>>2]|0;G=(c[E>>2]|0)-I>>4;L102:do{if((G|0)==0){aN=I}else{ae=d|0;ad=x|0;$=x+4|0;ah=x+8|0;ag=x+8|0;ab=y|0;ac=y+4|0;aa=x+12|0;_=0;Z=I;while(1){Y=c[Z+(_<<4)>>2]|0;W=c[ae>>2]|0;X=c[W+(Y<<3)>>2]|0;V=c[W+(Y<<3)+4>>2]|0;z=0;as(294,y|0,Z+(_<<4)+4|0);if(z){z=0;N=95;break}c[ad>>2]=X;c[$>>2]=V;z=0;as(294,ah|0,y|0);if(z){z=0;N=96;break}V=c[J>>2]|0;if((V|0)==(c[F>>2]|0)){z=0;as(482,b|0,x|0);if(z){z=0;N=97;break}}else{if((V|0)==0){aO=0}else{c[V>>2]=c[ad>>2];c[V+4>>2]=c[$>>2];z=0;as(294,V+8|0,ah|0);if(z){z=0;N=97;break}aO=c[J>>2]|0}c[J>>2]=aO+20}V=c[ag>>2]|0;if((V|0)!=0){X=c[aa>>2]|0;if((V|0)!=(X|0)){Y=X;while(1){X=Y-12|0;c[aa>>2]=X;if((a[X]&1)!=0){Lw(c[Y-12+8>>2]|0)}if((V|0)==(X|0)){break}else{Y=X}}}Lw(V)}Y=c[ab>>2]|0;if((Y|0)!=0){X=c[ac>>2]|0;if((Y|0)!=(X|0)){W=X;while(1){X=W-12|0;c[ac>>2]=X;if((a[X]&1)!=0){Lw(c[W-12+8>>2]|0)}if((Y|0)==(X|0)){break}else{W=X}}}Lw(Y)}W=_+1|0;V=c[D>>2]|0;if(W>>>0<G>>>0){_=W;Z=V}else{aN=V;break L102}}do{if((N|0)==95){Z=bT(-1,-1)|0;aP=Z;aQ=M}else if((N|0)==96){Z=bT(-1,-1)|0;aS=Z;aT=M;N=103}else if((N|0)==97){Z=bT(-1,-1)|0;_=Z;Z=M;ah=c[ag>>2]|0;if((ah|0)==0){aS=_;aT=Z;N=103;break}$=c[aa>>2]|0;if((ah|0)!=($|0)){ad=$;while(1){$=ad-12|0;c[aa>>2]=$;if((a[$]&1)!=0){Lw(c[ad-12+8>>2]|0)}if((ah|0)==($|0)){break}else{ad=$}}}Lw(ah);aS=_;aT=Z;N=103}}while(0);do{if((N|0)==103){aa=c[ab>>2]|0;if((aa|0)==0){aP=aS;aQ=aT;break}ag=c[ac>>2]|0;if((aa|0)!=(ag|0)){ad=ag;while(1){ag=ad-12|0;c[ac>>2]=ag;if((a[ag]&1)!=0){Lw(c[ad-12+8>>2]|0)}if((aa|0)==(ag|0)){break}else{ad=ag}}}Lw(aa);aP=aS;aQ=aT}}while(0);ac=c[H>>2]|0;if((ac|0)==0){aL=aP;aM=aQ;break L96}ab=c[J>>2]|0;if((ac|0)==(ab|0)){aU=ac}else{ad=ab;while(1){ab=ad-20|0;c[J>>2]=ab;Z=ad-20+8|0;_=c[Z>>2]|0;if((_|0)==0){aW=ab}else{ab=ad-20+12|0;ah=c[ab>>2]|0;if((_|0)==(ah|0)){aX=_}else{ag=ah;while(1){ah=ag-12|0;c[ab>>2]=ah;if((a[ah]&1)==0){aY=ah}else{Lw(c[ag-12+8>>2]|0);aY=c[ab>>2]|0}if((_|0)==(aY|0)){break}else{ag=aY}}aX=c[Z>>2]|0}Lw(aX);aW=c[J>>2]|0}if((ac|0)==(aW|0)){break}else{ad=aW}}aU=c[H>>2]|0}Lw(aU);aL=aP;aM=aQ;break L96}}while(0);if((aN|0)!=0){H=c[E>>2]|0;if((aN|0)==(H|0)){aZ=aN}else{J=H;while(1){H=J-16|0;c[E>>2]=H;G=J-16+4|0;F=c[G>>2]|0;if((F|0)==0){a_=H}else{H=J-16+8|0;I=c[H>>2]|0;if((F|0)==(I|0)){a$=F}else{af=I;while(1){I=af-12|0;c[H>>2]=I;if((a[I]&1)==0){a0=I}else{Lw(c[af-12+8>>2]|0);a0=c[H>>2]|0}if((F|0)==(a0|0)){break}else{af=a0}}a$=c[G>>2]|0}Lw(a$);a_=c[E>>2]|0}if((aN|0)==(a_|0)){break}else{J=a_}}aZ=c[D>>2]|0}Lw(aZ)}J=c[A>>2]|0;if((J|0)==0){i=f;return}af=c[C>>2]|0;if((J|0)!=(af|0)){F=af;while(1){af=F-12|0;c[C>>2]=af;if((a[af]&1)!=0){Lw(c[F-12+8>>2]|0)}if((J|0)==(af|0)){break}else{F=af}}}Lw(J);i=f;return}else{z=0}}while(0);U=bT(-1,-1)|0;aJ=M;aK=U;N=8}}while(0);if((N|0)==8){aL=aK;aM=aJ}U=c[D>>2]|0;if((U|0)==0){a1=aL;a2=aM;break}F=c[E>>2]|0;if((U|0)==(F|0)){a3=U}else{af=F;while(1){F=af-16|0;c[E>>2]=F;H=af-16+4|0;I=c[H>>2]|0;if((I|0)==0){a4=F}else{F=af-16+8|0;ad=c[F>>2]|0;if((I|0)==(ad|0)){a5=I}else{ac=ad;while(1){ad=ac-12|0;c[F>>2]=ad;if((a[ad]&1)==0){a6=ad}else{Lw(c[ac-12+8>>2]|0);a6=c[F>>2]|0}if((I|0)==(a6|0)){break}else{ac=a6}}a5=c[H>>2]|0}Lw(a5);a4=c[E>>2]|0}if((U|0)==(a4|0)){break}else{af=a4}}a3=c[D>>2]|0}Lw(a3);a1=aL;a2=aM}else{z=0;af=bT(-1,-1)|0;a1=af;a2=M}}while(0);aM=c[A>>2]|0;if((aM|0)==0){a7=a1;a8=0;a9=a7;ba=a2;bg(a9|0)}A=c[C>>2]|0;if((aM|0)!=(A|0)){aL=A;while(1){A=aL-12|0;c[C>>2]=A;if((a[A]&1)!=0){Lw(c[aL-12+8>>2]|0)}if((aM|0)==(A|0)){break}else{aL=A}}}Lw(aM);a7=a1;a8=0;a9=a7;ba=a2;bg(a9|0)}function pJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b+4|0;f=c[e>>2]|0;g=c[b>>2]|0;h=f-g>>4;if(h>>>0<d>>>0){pL(b,d-h|0);return}if(h>>>0<=d>>>0){return}h=g+(d<<4)|0;if((h|0)==(f|0)){return}else{i=f}while(1){f=i-16|0;c[e>>2]=f;d=i-16+4|0;g=c[d>>2]|0;if((g|0)==0){j=f}else{f=i-16+8|0;b=c[f>>2]|0;if((g|0)==(b|0)){k=g}else{l=b;while(1){b=l-12|0;c[f>>2]=b;if((a[b]&1)==0){m=b}else{Lw(c[l-12+8>>2]|0);m=c[f>>2]|0}if((g|0)==(m|0)){break}else{l=m}}k=c[d>>2]|0}Lw(k);j=c[e>>2]|0}if((h|0)==(j|0)){break}else{i=j}}return}function pK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=b+4|0;f=c[e>>2]|0;g=b|0;h=c[g>>2]|0;i=h;j=(f-i|0)/20|0;k=j+1|0;if(k>>>0>214748364>>>0){IU(0)}l=b+8|0;b=((c[l>>2]|0)-i|0)/20|0;if(b>>>0>107374181>>>0){m=214748364;n=5}else{i=b<<1;b=i>>>0<k>>>0?k:i;if((b|0)==0){o=0;p=0}else{m=b;n=5}}if((n|0)==5){o=Lu(m*20|0)|0;p=m}m=o+(j*20|0)|0;b=o+(p*20|0)|0;do{if((m|0)==0){q=h;r=f;n=10}else{c[m>>2]=c[d>>2];c[o+(j*20|0)+4>>2]=c[d+4>>2];z=0;as(294,o+(j*20|0)+8|0,d+8|0);if(!z){q=c[g>>2]|0;r=c[e>>2]|0;n=10;break}else{z=0;p=bT(-1,-1)|0;s=M;t=p;break}}}while(0);L14:do{if((n|0)==10){d=o+(k*20|0)|0;L16:do{if((r|0)==(q|0)){c[g>>2]=m;c[e>>2]=d;c[l>>2]=b;u=r}else{j=r;f=m;while(1){v=f-20|0;h=j-20|0;if((v|0)!=0){c[v>>2]=c[h>>2];c[f-20+4>>2]=c[j-20+4>>2];z=0;as(294,f-20+8|0,j-20+8|0);if(z){z=0;break}}if((h|0)==(q|0)){n=15;break}else{j=h;f=v}}if((n|0)==15){j=c[g>>2]|0;h=c[e>>2]|0;c[g>>2]=v;c[e>>2]=d;c[l>>2]=b;if((j|0)==(h|0)){u=j;break}else{w=h}while(1){h=w-20|0;p=w-20+8|0;i=c[p>>2]|0;if((i|0)!=0){x=w-20+12|0;y=c[x>>2]|0;if((i|0)==(y|0)){A=i}else{B=y;while(1){y=B-12|0;c[x>>2]=y;if((a[y]&1)==0){C=y}else{Lw(c[B-12+8>>2]|0);C=c[x>>2]|0}if((i|0)==(C|0)){break}else{B=C}}A=c[p>>2]|0}Lw(A)}if((j|0)==(h|0)){u=j;break L16}else{w=h}}}j=bT(-1,-1)|0;B=M;if((f|0)!=(d|0)){i=d;while(1){x=i-20|0;y=i-20+8|0;D=c[y>>2]|0;if((D|0)!=0){E=i-20+12|0;F=c[E>>2]|0;if((D|0)==(F|0)){G=D}else{H=F;while(1){F=H-12|0;c[E>>2]=F;if((a[F]&1)==0){I=F}else{Lw(c[H-12+8>>2]|0);I=c[E>>2]|0}if((D|0)==(I|0)){break}else{H=I}}G=c[y>>2]|0}Lw(G)}if((f|0)==(x|0)){break}else{i=x}}}if((o|0)==0){J=B;K=j}else{s=B;t=j;break L14}bg(K|0)}}while(0);if((u|0)==0){return}Lw(u);return}}while(0);Lw(o);J=s;K=t;bg(K|0)}function pL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;e=b+8|0;f=b+4|0;g=c[f>>2]|0;h=c[e>>2]|0;i=g;if(h-i>>4>>>0>=d>>>0){j=d;k=g;do{if((k|0)==0){l=0}else{LI(k|0,0,16)|0;l=c[f>>2]|0}k=l+16|0;c[f>>2]=k;j=j-1|0;}while((j|0)!=0);return}j=b|0;b=c[j>>2]|0;k=i-b>>4;i=k+d|0;if(i>>>0>268435455>>>0){IU(0)}l=h-b|0;if(l>>4>>>0>134217726>>>0){m=268435455;n=9}else{b=l>>3;l=b>>>0<i>>>0?i:b;if((l|0)==0){o=0;p=0}else{m=l;n=9}}if((n|0)==9){o=Lu(m<<4)|0;p=m}m=o+(k<<4)|0;k=d;d=m;do{if((d|0)==0){q=0}else{LI(d|0,0,16)|0;q=d}d=q+16|0;k=k-1|0;}while((k|0)!=0);k=o+(p<<4)|0;p=c[j>>2]|0;q=c[f>>2]|0;L23:do{if((q|0)==(p|0)){c[j>>2]=m;c[f>>2]=d;c[e>>2]=k;r=p}else{l=q;b=m;while(1){s=b-16|0;i=l-16|0;if((s|0)!=0){c[s>>2]=c[i>>2];z=0;as(294,b-16+4|0,l-16+4|0);if(z){z=0;break}}if((i|0)==(p|0)){n=19;break}else{l=i;b=s}}if((n|0)==19){l=c[j>>2]|0;i=c[f>>2]|0;c[j>>2]=s;c[f>>2]=d;c[e>>2]=k;if((l|0)==(i|0)){r=l;break}else{t=i}while(1){i=t-16|0;h=t-16+4|0;g=c[h>>2]|0;if((g|0)!=0){u=t-16+8|0;v=c[u>>2]|0;if((g|0)==(v|0)){w=g}else{x=v;while(1){v=x-12|0;c[u>>2]=v;if((a[v]&1)==0){y=v}else{Lw(c[x-12+8>>2]|0);y=c[u>>2]|0}if((g|0)==(y|0)){break}else{x=y}}w=c[h>>2]|0}Lw(w)}if((l|0)==(i|0)){r=l;break L23}else{t=i}}}l=bT(-1,-1)|0;if((b|0)!=(d|0)){x=d;while(1){g=x-16|0;u=x-16+4|0;v=c[u>>2]|0;if((v|0)!=0){A=x-16+8|0;B=c[A>>2]|0;if((v|0)==(B|0)){C=v}else{D=B;while(1){B=D-12|0;c[A>>2]=B;if((a[B]&1)==0){E=B}else{Lw(c[D-12+8>>2]|0);E=c[A>>2]|0}if((v|0)==(E|0)){break}else{D=E}}C=c[u>>2]|0}Lw(C)}if((b|0)==(g|0)){break}else{x=g}}}if((o|0)==0){bg(l|0)}Lw(o);bg(l|0)}}while(0);if((r|0)==0){return}Lw(r);return}function pM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=i;h=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[h>>2];h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=f;f=i;i=i+1|0;i=i+7&-8;a[f]=a[h]|0;h=d|0;d=c[h>>2]|0;f=e|0;e=c[f>>2]|0;L1:do{if((d|0)==(e|0)){j=d}else{k=d+16|0;if((k|0)!=(e|0)){l=d;m=k;k=c[d>>2]|0;while(1){n=c[m>>2]|0;L7:do{if((k|0)==(n|0)){o=c[l+8>>2]|0;p=c[l+4>>2]|0;q=c[l+20>>2]|0;if((o-p|0)!=((c[l+24>>2]|0)-q|0)){break}if((p|0)==(o|0)){j=l;break L1}else{r=q;s=p}while(1){p=a[s]|0;q=p&255;if((q&1|0)==0){t=q>>>1}else{t=c[s+4>>2]|0}q=a[r]|0;u=q&255;if((u&1|0)==0){v=u>>>1}else{v=c[r+4>>2]|0}if((t|0)!=(v|0)){break L7}u=(p&1)==0;if(u){w=s+1|0}else{w=c[s+8>>2]|0}if((q&1)==0){x=r+1|0}else{x=c[r+8>>2]|0}do{if(u){if((t|0)==0){break}else{y=x;z=w;A=t}while(1){if((a[z]|0)!=(a[y]|0)){break L7}q=A-1|0;if((q|0)==0){break}else{y=y+1|0;z=z+1|0;A=q}}}else{if((LH(w|0,x|0,t|0)|0)!=0){break L7}}}while(0);u=s+12|0;if((u|0)==(o|0)){j=l;break L1}else{r=r+12|0;s=u}}}}while(0);o=m+16|0;if((o|0)==(e|0)){break}else{l=m;m=o;k=n}}}c[h>>2]=e;B=e;C=b|0;c[C>>2]=B;i=g;return}}while(0);c[h>>2]=j;if((j|0)==(e|0)){B=e;C=b|0;c[C>>2]=B;i=g;return}s=j+32|0;if((s|0)==(e|0)){D=j}else{e=j+16|0;r=s;s=j;while(1){j=r|0;L47:do{if((c[s>>2]|0)==(c[j>>2]|0)){t=c[s+8>>2]|0;x=c[s+4>>2]|0;w=c[e+20>>2]|0;if((t-x|0)!=((c[e+24>>2]|0)-w|0)){E=53;break}if((x|0)==(t|0)){break}else{F=x;G=w}while(1){w=a[F]|0;x=w&255;if((x&1|0)==0){H=x>>>1}else{H=c[F+4>>2]|0}x=a[G]|0;A=x&255;if((A&1|0)==0){I=A>>>1}else{I=c[G+4>>2]|0}if((H|0)!=(I|0)){E=53;break L47}A=(w&1)==0;if(A){J=F+1|0}else{J=c[F+8>>2]|0}if((x&1)==0){K=G+1|0}else{K=c[G+8>>2]|0}do{if(A){if((H|0)==0){break}else{L=K;M=J;N=H}while(1){if((a[M]|0)!=(a[L]|0)){E=53;break L47}x=N-1|0;if((x|0)==0){break}else{L=L+1|0;M=M+1|0;N=x}}}else{if((LH(J|0,K|0,H|0)|0)!=0){E=53;break L47}}}while(0);A=F+12|0;if((A|0)==(t|0)){break}else{F=A;G=G+12|0}}}else{E=53}}while(0);do{if((E|0)==53){E=0;t=s+16|0;c[h>>2]=t;c[t>>2]=c[j>>2];if((s|0)==(e|0)){break}j0(s+20|0,c[e+20>>2]|0,c[e+24>>2]|0)}}while(0);j=r+16|0;t=c[h>>2]|0;if((j|0)==(c[f>>2]|0)){D=t;break}else{e=r;r=j;s=t}}}s=D+16|0;c[h>>2]=s;B=s;C=b|0;c[C>>2]=B;i=g;return}function pN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0;e=i;i=i+320|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=e+48|0;n=e+56|0;o=e+64|0;p=e+72|0;q=e+80|0;r=e+88|0;s=e+96|0;t=e+104|0;u=e+112|0;v=e+120|0;w=e+128|0;x=e+136|0;y=e+144|0;z=e+152|0;A=e+160|0;B=e+168|0;C=e+176|0;D=e+184|0;E=e+192|0;F=e+200|0;G=e+208|0;H=e+216|0;I=e+224|0;J=e+232|0;K=e+240|0;L=e+248|0;M=e+256|0;N=e+264|0;O=e+272|0;P=e+280|0;Q=e+288|0;R=e+296|0;S=e+304|0;T=e+312|0;U=f|0;V=g|0;W=h|0;X=j|0;Y=o|0;Z=p|0;_=q|0;$=r|0;aa=k|0;ab=l|0;ac=m|0;ad=n|0;ae=M|0;af=N|0;ag=O|0;ah=P|0;ai=w|0;aj=x|0;ak=y|0;al=z|0;am=A|0;an=B|0;ao=C|0;ap=D|0;aq=I|0;ar=J|0;as=K|0;at=L|0;au=E|0;av=F|0;aw=G|0;ax=H|0;ay=s|0;az=t|0;aA=u|0;aB=v|0;aC=a;a=b;L1:while(1){b=a;aD=a-16|0;aE=a-32|0;aF=aD|0;aG=a-16+4|0;aH=a-16+8|0;aI=a-16+12|0;aJ=aC;L3:while(1){aK=aJ;aL=b-aK|0;aM=aL>>4;switch(aM|0){case 5:{aN=12;break L1;break};case 4:{aN=11;break L1;break};case 2:{aN=4;break L1;break};case 0:case 1:{aN=86;break L1;break};case 3:{aN=10;break L1;break};default:{}}if((aL|0)<112){aN=14;break L1}aO=(aM|0)/2|0;aP=aJ+(aO<<4)|0;if((aL|0)>15984){aL=(aM|0)/4|0;aQ=pQ(aJ,aJ+(aL<<4)|0,aP,aJ+(aL+aO<<4)|0,aD,0)|0}else{aQ=pO(aJ,aP,aD,0)|0}aL=aJ|0;aM=c[aL>>2]|0;aR=aP|0;aS=c[aR>>2]|0;L11:do{if(aM>>>0<aS>>>0){aT=aD;aU=aQ}else{if(aS>>>0>=aM>>>0){aV=c[aJ+8>>2]|0;aW=c[aJ+(aO<<4)+4>>2]|0;aX=c[aJ+(aO<<4)+8>>2]|0;c[ae>>2]=c[aJ+4>>2];c[af>>2]=aV;c[ag>>2]=aW;c[ah>>2]=aX;if(pT(M,N,O,P,0)|0){aT=aD;aU=aQ;break}}L16:do{if((aJ|0)!=(aE|0)){aX=aJ+(aO<<4)+4|0;aW=aJ+(aO<<4)+8|0;aV=aD;aY=aE;while(1){aZ=aY|0;a_=c[aZ>>2]|0;a$=c[aR>>2]|0;if(a_>>>0<a$>>>0){aN=50;break}if(a$>>>0>=a_>>>0){a0=aV-16+4|0;a1=aV-16+8|0;a$=c[a1>>2]|0;a2=c[aX>>2]|0;a3=c[aW>>2]|0;c[ay>>2]=c[a0>>2];c[az>>2]=a$;c[aA>>2]=a2;c[aB>>2]=a3;if(pT(s,t,u,v,0)|0){aN=54;break}}a3=aY-16|0;if((aJ|0)==(a3|0)){break L16}else{aV=aY;aY=a3}}if((aN|0)==54){aN=0;a4=c[aZ>>2]|0;a5=a0;a6=a1}else if((aN|0)==50){aN=0;a4=a_;a5=aV-16+4|0;a6=aV-16+8|0}aW=c[aL>>2]|0;c[aL>>2]=a4;c[aZ>>2]=aW;aW=aJ+4|0;aX=c[aW>>2]|0;c[aW>>2]=c[a5>>2];c[a5>>2]=aX;aX=aJ+8|0;aW=c[aX>>2]|0;c[aX>>2]=c[a6>>2];c[a6>>2]=aW;aW=aJ+12|0;aX=aV-16+12|0;a3=c[aW>>2]|0;c[aW>>2]=c[aX>>2];c[aX>>2]=a3;aT=aY;aU=aQ+1|0;break L11}}while(0);a3=aJ+16|0;aX=c[aL>>2]|0;aW=c[aF>>2]|0;do{if(aX>>>0<aW>>>0){a7=a3}else{if(aW>>>0>=aX>>>0){a2=c[aJ+8>>2]|0;a$=c[aG>>2]|0;a8=c[aH>>2]|0;c[aq>>2]=c[aJ+4>>2];c[ar>>2]=a2;c[as>>2]=a$;c[at>>2]=a8;if(pT(I,J,K,L,0)|0){a7=a3;break}}if((a3|0)==(aD|0)){aN=87;break L1}a8=aJ+4|0;a$=aJ+8|0;a2=a3;while(1){a9=c[aL>>2]|0;ba=a2|0;bb=c[ba>>2]|0;if(a9>>>0<bb>>>0){aN=29;break}if(bb>>>0>=a9>>>0){a9=c[a$>>2]|0;bc=a2+4|0;bd=c[bc>>2]|0;be=a2+8|0;bf=c[be>>2]|0;c[au>>2]=c[a8>>2];c[av>>2]=a9;c[aw>>2]=bd;c[ax>>2]=bf;if(pT(E,F,G,H,0)|0){aN=32;break}}bf=a2+16|0;if((bf|0)==(aD|0)){aN=93;break L1}else{a2=bf}}if((aN|0)==32){aN=0;bg=c[ba>>2]|0;bh=bc;bi=be}else if((aN|0)==29){aN=0;bg=bb;bh=a2+4|0;bi=a2+8|0}c[ba>>2]=c[aF>>2];c[aF>>2]=bg;a8=c[bh>>2]|0;c[bh>>2]=c[aG>>2];c[aG>>2]=a8;a8=c[bi>>2]|0;c[bi>>2]=c[aH>>2];c[aH>>2]=a8;a8=a2+12|0;a$=c[a8>>2]|0;c[a8>>2]=c[aI>>2];c[aI>>2]=a$;a7=a2+16|0}}while(0);if((a7|0)==(aD|0)){aN=95;break L1}a3=aJ+4|0;aX=aJ+8|0;aW=aD;a$=a7;while(1){a8=c[aL>>2]|0;aY=a$|0;aV=c[aY>>2]|0;L49:do{if(a8>>>0<aV>>>0){bj=a$;bk=aY}else{bf=a8;bd=aY;a9=aV;while(1){if(a9>>>0<bf>>>0){bl=bf}else{bm=c[aX>>2]|0;bn=c[bd+4>>2]|0;bo=c[bd+8>>2]|0;c[am>>2]=c[a3>>2];c[an>>2]=bm;c[ao>>2]=bn;c[ap>>2]=bo;if(pT(A,B,C,D,0)|0){bj=bd;bk=bd;break L49}bl=c[aL>>2]|0}bp=bd+16|0;bo=c[bp>>2]|0;if(bl>>>0<bo>>>0){break}else{bf=bl;bd=bp;a9=bo}}bj=bp;bk=bp}}while(0);aV=aW;while(1){bq=aV-16|0;aY=c[aL>>2]|0;br=bq|0;a8=c[br>>2]|0;if(aY>>>0<a8>>>0){aV=bq;continue}if(a8>>>0<aY>>>0){break}aY=c[aX>>2]|0;a8=c[aV-16+4>>2]|0;a2=c[aV-16+8>>2]|0;c[ai>>2]=c[a3>>2];c[aj>>2]=aY;c[ak>>2]=a8;c[al>>2]=a2;if(pT(w,x,y,z,0)|0){aV=bq}else{break}}if(bj>>>0>=bq>>>0){aJ=bj;continue L3}a2=c[bk>>2]|0;c[bk>>2]=c[br>>2];c[br>>2]=a2;a2=bj+4|0;a8=aV-16+4|0;aY=c[a2>>2]|0;c[a2>>2]=c[a8>>2];c[a8>>2]=aY;aY=bj+8|0;a8=aV-16+8|0;a2=c[aY>>2]|0;c[aY>>2]=c[a8>>2];c[a8>>2]=a2;a2=bj+12|0;a8=aV-16+12|0;aY=c[a2>>2]|0;c[a2>>2]=c[a8>>2];c[a8>>2]=aY;aW=bq;a$=bj+16|0}}}while(0);aL=aJ+16|0;L65:do{if(aL>>>0<aT>>>0){aR=aT;aO=aL;aM=aU;aS=aP;while(1){a$=aS|0;aW=aS+4|0;a3=aS+8|0;aX=aO;while(1){bs=aX|0;aY=c[bs>>2]|0;a8=c[a$>>2]|0;if(aY>>>0>=a8>>>0){if(a8>>>0<aY>>>0){bt=a8;break}a8=c[aX+8>>2]|0;aY=c[aW>>2]|0;a2=c[a3>>2]|0;c[Y>>2]=c[aX+4>>2];c[Z>>2]=a8;c[_>>2]=aY;c[$>>2]=a2;if(!(pT(o,p,q,r,0)|0)){aN=61;break}}aX=aX+16|0}if((aN|0)==61){aN=0;bt=c[a$>>2]|0}aV=aR-16|0;a2=aV|0;aY=c[a2>>2]|0;L77:do{if(aY>>>0<bt>>>0){bu=aR;bv=aV;bw=a2}else{a8=aR;a9=a2;bd=aY;bf=bt;while(1){bx=a9;if(bf>>>0<bd>>>0){by=bf}else{bo=c[a8-16+8>>2]|0;bn=c[aW>>2]|0;bm=c[a3>>2]|0;c[aa>>2]=c[a8-16+4>>2];c[ab>>2]=bo;c[ac>>2]=bn;c[ad>>2]=bm;if(pT(k,l,m,n,0)|0){bu=a8;bv=bx;bw=a9;break L77}by=c[a$>>2]|0}bz=a9-16|0;bm=c[bz>>2]|0;if(bm>>>0<by>>>0){break}else{a8=bx;a9=bz;bd=bm;bf=by}}bu=bx;bv=bz;bw=bz}}while(0);if(aX>>>0>bv>>>0){bA=aX;bB=aM;bC=aS;break L65}a$=c[bs>>2]|0;c[bs>>2]=c[bw>>2];c[bw>>2]=a$;a$=aX+4|0;a3=bu-16+4|0;aW=c[a$>>2]|0;c[a$>>2]=c[a3>>2];c[a3>>2]=aW;aW=aX+8|0;a3=bu-16+8|0;a$=c[aW>>2]|0;c[aW>>2]=c[a3>>2];c[a3>>2]=a$;a$=aX+12|0;a3=bu-16+12|0;aW=c[a$>>2]|0;c[a$>>2]=c[a3>>2];c[a3>>2]=aW;aR=bv;aO=aX+16|0;aM=aM+1|0;aS=(aS|0)==(aX|0)?bv:aS}}else{bA=aL;bB=aU;bC=aP}}while(0);do{if((bA|0)==(bC|0)){bD=bB}else{aP=bC|0;aL=c[aP>>2]|0;aS=bA|0;aM=c[aS>>2]|0;if(aL>>>0<aM>>>0){bE=aM;bF=aL;bG=bA+4|0;bH=bC+4|0;bI=bA+8|0;bJ=bC+8|0}else{if(aM>>>0<aL>>>0){bD=bB;break}aL=bC+4|0;aM=bC+8|0;aO=c[aM>>2]|0;aR=bA+4|0;aW=c[aR>>2]|0;a3=bA+8|0;a$=c[a3>>2]|0;c[U>>2]=c[aL>>2];c[V>>2]=aO;c[W>>2]=aW;c[X>>2]=a$;if(!(pT(f,g,h,j,0)|0)){bD=bB;break}bE=c[aS>>2]|0;bF=c[aP>>2]|0;bG=aR;bH=aL;bI=a3;bJ=aM}c[aS>>2]=bF;c[aP>>2]=bE;aP=c[bG>>2]|0;c[bG>>2]=c[bH>>2];c[bH>>2]=aP;aP=c[bI>>2]|0;c[bI>>2]=c[bJ>>2];c[bJ>>2]=aP;aP=bA+12|0;aS=bC+12|0;aM=c[aP>>2]|0;c[aP>>2]=c[aS>>2];c[aS>>2]=aM;bD=bB+1|0}}while(0);if((bD|0)==0){bK=pS(aJ,bA,0)|0;aM=bA+16|0;if(pS(aM,a,0)|0){aN=80;break}if(bK){aJ=aM;continue}}aM=bA;if((aM-aK|0)>=(b-aM|0)){aN=84;break}pN(aJ,bA,d);aJ=bA+16|0}if((aN|0)==84){aN=0;pN(bA+16|0,a,d);aC=aJ;a=bA;continue}else if((aN|0)==80){aN=0;if(bK){aN=90;break}else{aC=aJ;a=bA;continue}}}if((aN|0)==12){pQ(aJ,aJ+16|0,aJ+32|0,aJ+48|0,aD,0)|0;i=e;return}else if((aN|0)==11){pP(aJ,aJ+16|0,aJ+32|0,aD,0)|0;i=e;return}else if((aN|0)==4){bA=a-16|0;aC=c[bA>>2]|0;bK=aJ|0;d=c[bK>>2]|0;do{if(aC>>>0<d>>>0){bL=d;bM=aC;bN=aJ+4|0;bO=aJ+8|0}else{if(d>>>0<aC>>>0){i=e;return}bD=c[aH>>2]|0;bB=aJ+4|0;bC=c[bB>>2]|0;bJ=aJ+8|0;bI=c[bJ>>2]|0;c[Q>>2]=c[aG>>2];c[R>>2]=bD;c[S>>2]=bC;c[T>>2]=bI;if(pT(Q,R,S,T,0)|0){bL=c[bK>>2]|0;bM=c[bA>>2]|0;bN=bB;bO=bJ;break}else{i=e;return}}}while(0);c[bK>>2]=bM;c[bA>>2]=bL;bL=c[bN>>2]|0;c[bN>>2]=c[aG>>2];c[aG>>2]=bL;bL=c[bO>>2]|0;c[bO>>2]=c[aH>>2];c[aH>>2]=bL;bL=aJ+12|0;aH=c[bL>>2]|0;c[bL>>2]=c[aI>>2];c[aI>>2]=aH;i=e;return}else if((aN|0)==90){i=e;return}else if((aN|0)==93){i=e;return}else if((aN|0)==95){i=e;return}else if((aN|0)==86){i=e;return}else if((aN|0)==87){i=e;return}else if((aN|0)==14){pR(aJ,a,0);i=e;return}else if((aN|0)==10){pO(aJ,aJ+16|0,aD,0)|0;i=e;return}}
function q8(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0.0,a_=0.0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0;k=i;i=i+368|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+32|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;x=k+176|0;y=k+192|0;A=k+208|0;B=k+224|0;C=k+240|0;D=k+256|0;F=k+272|0;G=k+288|0;H=k+304|0;I=k+320|0;J=k+336|0;K=k+352|0;L=o;N=o;a[N]=10;O=L+1|0;a[O]=a[864]|0;a[O+1|0]=a[865]|0;a[O+2|0]=a[866]|0;a[O+3|0]=a[867]|0;a[O+4|0]=a[868]|0;a[L+6|0]=0;L=(z=0,aM(90,b|0,o|0)|0);if(z){z=0;O=bT(-1,-1)|0;P=O;O=M;if((a[N]&1)==0){Q=P;R=O;S=Q;T=0;U=S;V=R;bg(U|0)}Lw(c[o+8>>2]|0);Q=P;R=O;S=Q;T=0;U=S;V=R;bg(U|0)}O=c[L>>2]|0;if((O|0)==0){X=0}else{X=Lh(O,31184,31536,-1)|0}if((a[N]&1)!=0){Lw(c[o+8>>2]|0)}o=p;N=p;a[N]=4;O=o+1|0;E=28196;a[O]=E;E=E>>8;a[O+1|0]=E;a[o+3|0]=0;o=q;O=g;c[o>>2]=c[O>>2];c[o+4>>2]=c[O+4>>2];c[o+8>>2]=c[O+8>>2];o=(z=0,at(44,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(z){z=0;q=bT(-1,-1)|0;g=q;q=M;if((a[N]&1)==0){Q=g;R=q;S=Q;T=0;U=S;V=R;bg(U|0)}Lw(c[p+8>>2]|0);Q=g;R=q;S=Q;T=0;U=S;V=R;bg(U|0)}if((a[N]&1)!=0){Lw(c[p+8>>2]|0)}p=o+40|0;L24:do{if(+h[p>>3]==0.0){o=LJ(e|0)|0;if(o>>>0>4294967279>>>0){D5(0);return 0}if(o>>>0<11>>>0){N=o<<1&255;q=t;g=t;a[g]=N;Y=q+1|0;Z=N;_=q;$=g}else{g=o+16&-16;q=Lu(g)|0;c[t+8>>2]=q;N=g|1;c[t>>2]=N;c[t+4>>2]=o;Y=q;Z=N&255;_=t;$=t}LF(Y|0,e|0,o)|0;a[Y+o|0]=0;o=s;LI(o|0,0,12)|0;N=Z&255;if((N&1|0)==0){aa=N>>>1}else{aa=c[t+4>>2]|0}N=aa+18|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;ab=31;break}return 0}else{if(N>>>0<11>>>0){a[o]=36;ac=s+1|0}else{q=aa+34&-16;g=(z=0,au(248,q|0)|0);if(z){z=0;ab=31;break}c[s+8>>2]=g;c[s>>2]=q|1;c[s+4>>2]=18;ac=g}LF(ac|0,528,18)|0;a[ac+18|0]=0;if((Z&1)==0){ad=_+1|0}else{ad=c[t+8>>2]|0}z=0,az(88,s|0,ad|0,aa|0)|0;if(z){z=0;ab=31;break}g=r;LI(g|0,0,12)|0;q=a[o]|0;L=q&255;if((L&1|0)==0){ae=L>>>1}else{ae=c[s+4>>2]|0}if((q&1)==0){af=s+1|0}else{af=c[s+8>>2]|0}q=ae+18|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;ab=47;break}return 0}else{if(q>>>0<11>>>0){a[g]=ae<<1;ag=r+1|0}else{L=ae+34&-16;P=(z=0,au(248,L|0)|0);if(z){z=0;ab=47;break}c[r+8>>2]=P;c[r>>2]=L|1;c[r+4>>2]=ae;ag=P}LF(ag|0,af|0,ae)|0;a[ag+ae|0]=0;z=0,az(88,r|0,456,18)|0;if(z){z=0;ab=47;break}P=f;L67:do{if((a[P]&1)==0){L=u;c[L>>2]=c[P>>2];c[L+4>>2]=c[P+4>>2];c[L+8>>2]=c[P+8>>2];ab=59}else{L=c[f+8>>2]|0;ah=c[f+4>>2]|0;do{if(ah>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ah>>>0<11>>>0){a[u]=ah<<1;ai=u+1|0}else{aj=ah+16&-16;ak=(z=0,au(248,aj|0)|0);if(z){z=0;break}c[u+8>>2]=ak;c[u>>2]=aj|1;c[u+4>>2]=ah;ai=ak}LF(ai|0,L|0,ah)|0;a[ai+ah|0]=0;ab=59;break L67}}while(0);ah=bT(-1,-1)|0;al=ah;am=M}}while(0);do{if((ab|0)==59){P=v;c[P>>2]=c[O>>2];c[P+4>>2]=c[O+4>>2];c[P+8>>2]=c[O+8>>2];z=0;aR(382,r|0,u|0,v|0);if(z){z=0;P=bT(-1,-1)|0;ah=P;P=M;if((a[u]&1)==0){al=ah;am=P;break}Lw(c[u+8>>2]|0);al=ah;am=P;break}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}if((a[g]&1)!=0){Lw(c[r+8>>2]|0)}if((a[o]&1)!=0){Lw(c[s+8>>2]|0)}if((a[$]&1)==0){break L24}Lw(c[t+8>>2]|0);break L24}}while(0);if((a[g]&1)==0){an=al;ao=am;break}Lw(c[r+8>>2]|0);an=al;ao=am}}while(0);if((ab|0)==47){q=bT(-1,-1)|0;P=M;if((a[g]&1)!=0){Lw(c[r+8>>2]|0)}an=q;ao=P}if((a[o]&1)==0){ap=an;aq=ao;break}Lw(c[s+8>>2]|0);ap=an;aq=ao}}while(0);if((ab|0)==31){N=bT(-1,-1)|0;P=M;if((a[o]&1)!=0){Lw(c[s+8>>2]|0)}ap=N;aq=P}if((a[$]&1)==0){Q=ap;R=aq;S=Q;T=0;U=S;V=R;bg(U|0)}Lw(c[t+8>>2]|0);Q=ap;R=aq;S=Q;T=0;U=S;V=R;bg(U|0)}}while(0);L118:do{if((X|0)==0){aq=Lu(60)|0;c[n>>2]=aq;ap=d+4|0;t=c[ap>>2]|0;if((t|0)==(c[d+8>>2]|0)){e4(d|0,n);av=c[n>>2]|0}else{if((t|0)==0){aw=0}else{c[t>>2]=aq;aw=c[ap>>2]|0}c[ap>>2]=aw+4;av=aq}aq=av;t=av;$=f;L127:do{if((a[$]&1)==0){s=w;c[s>>2]=c[$>>2];c[s+4>>2]=c[$+4>>2];c[s+8>>2]=c[$+8>>2];ab=97}else{s=c[f+8>>2]|0;ao=c[f+4>>2]|0;do{if(ao>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ao>>>0<11>>>0){a[w]=ao<<1;ax=w+1|0}else{an=ao+16&-16;r=(z=0,au(248,an|0)|0);if(z){z=0;break}c[w+8>>2]=r;c[w>>2]=an|1;c[w+4>>2]=ao;ax=r}LF(ax|0,s|0,ao)|0;a[ax+ao|0]=0;ab=97;break L127}}while(0);ao=bT(-1,-1)|0;ay=ao;aA=M}}while(0);do{if((ab|0)==97){$=m;c[$>>2]=c[O>>2];c[$+4>>2]=c[O+4>>2];c[$+8>>2]=c[O+8>>2];z=0;aD(36,t|0,w|0,m|0,1,0,0);if(z){z=0;$=bT(-1,-1)|0;o=$;$=M;if((a[w]&1)==0){ay=o;aA=$;break}Lw(c[w+8>>2]|0);ay=o;aA=$;break}if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}$=x;o=x;a[o]=10;ao=$+1|0;a[ao]=a[864]|0;a[ao+1|0]=a[865]|0;a[ao+2|0]=a[866]|0;a[ao+3|0]=a[867]|0;a[ao+4|0]=a[868]|0;a[$+6|0]=0;$=y;c[$>>2]=c[O>>2];c[$+4>>2]=c[O+4>>2];c[$+8>>2]=c[O+8>>2];$=(z=0,at(118,x|0,b|0,e|0,f|0,y|0,j|0)|0);do{if(!z){ao=av+36|0;s=ao;c[l>>2]=$;g=ao+8|0;r=g;an=c[r>>2]|0;if((an|0)==(c[ao+12>>2]|0)){z=0;as(376,ao+4|0,l|0);if(z){z=0;break}aB=c[l>>2]|0}else{if((an|0)==0){aC=0}else{c[an>>2]=$;aC=c[r>>2]|0}c[g>>2]=aC+4;aB=$}z=0;as(c[c[ao>>2]>>2]|0,s|0,aB|0);if(z){z=0;break}if((a[o]&1)==0){aE=t;break L118}Lw(c[x+8>>2]|0);aE=t;break L118}else{z=0}}while(0);$=bT(-1,-1)|0;s=$;$=M;if((a[o]&1)==0){Q=s;R=$;S=Q;T=0;U=S;V=R;bg(U|0)}Lw(c[x+8>>2]|0);Q=s;R=$;S=Q;T=0;U=S;V=R;bg(U|0)}}while(0);t=c[d>>2]|0;$=c[ap>>2]|0;s=t;while(1){if((s|0)==($|0)){aF=$;break}if((c[s>>2]|0)==(av|0)){aF=s;break}else{s=s+4|0}}s=aF-t>>2;ao=t+(s+1<<2)|0;g=$-ao|0;LG(t+(s<<2)|0,ao|0,g|0)|0;ao=t+((g>>2)+s<<2)|0;s=c[ap>>2]|0;if((ao|0)!=(s|0)){c[ap>>2]=s+(~((s-4+(-ao|0)|0)>>>2)<<2)}Lw(aq);Q=ay;R=aA;S=Q;T=0;U=S;V=R;bg(U|0)}else{aE=X}}while(0);X=aE+40|0;aA=aE+44|0;L176:do{if((c[X>>2]|0)==(c[aA>>2]|0)){ay=LJ(e|0)|0;if(ay>>>0>4294967279>>>0){D5(0);return 0}if(ay>>>0<11>>>0){aF=ay<<1&255;av=C;d=C;a[d]=aF;aG=av+1|0;aH=aF;aI=av;aJ=d}else{d=ay+16&-16;av=Lu(d)|0;c[C+8>>2]=av;aF=d|1;c[C>>2]=aF;c[C+4>>2]=ay;aG=av;aH=aF&255;aI=C;aJ=C}LF(aG|0,e|0,ay)|0;a[aG+ay|0]=0;ay=B;LI(ay|0,0,12)|0;aF=aH&255;if((aF&1|0)==0){aK=aF>>>1}else{aK=c[C+4>>2]|0}aF=aK+21|0;do{if(aF>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;ab=141;break}return 0}else{if(aF>>>0<11>>>0){a[ay]=42;aL=B+1|0}else{av=aK+37&-16;d=(z=0,au(248,av|0)|0);if(z){z=0;ab=141;break}c[B+8>>2]=d;c[B>>2]=av|1;c[B+4>>2]=21;aL=d}LF(aL|0,400,21)|0;a[aL+21|0]=0;if((aH&1)==0){aN=aI+1|0}else{aN=c[C+8>>2]|0}z=0,az(88,B|0,aN|0,aK|0)|0;if(z){z=0;ab=141;break}d=A;LI(d|0,0,12)|0;av=a[ay]|0;x=av&255;if((x&1|0)==0){aO=x>>>1}else{aO=c[B+4>>2]|0}if((av&1)==0){aP=B+1|0}else{aP=c[B+8>>2]|0}av=aO+19|0;do{if(av>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;ab=157;break}return 0}else{if(av>>>0<11>>>0){a[d]=aO<<1;aQ=A+1|0}else{x=aO+35&-16;aB=(z=0,au(248,x|0)|0);if(z){z=0;ab=157;break}c[A+8>>2]=aB;c[A>>2]=x|1;c[A+4>>2]=aO;aQ=aB}LF(aQ|0,aP|0,aO)|0;a[aQ+aO|0]=0;z=0,az(88,A|0,352,19)|0;if(z){z=0;ab=157;break}aB=f;L221:do{if((a[aB]&1)==0){x=D;c[x>>2]=c[aB>>2];c[x+4>>2]=c[aB+4>>2];c[x+8>>2]=c[aB+8>>2];ab=169}else{x=c[f+8>>2]|0;aC=c[f+4>>2]|0;do{if(aC>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aC>>>0<11>>>0){a[D]=aC<<1;aS=D+1|0}else{l=aC+16&-16;j=(z=0,au(248,l|0)|0);if(z){z=0;break}c[D+8>>2]=j;c[D>>2]=l|1;c[D+4>>2]=aC;aS=j}LF(aS|0,x|0,aC)|0;a[aS+aC|0]=0;ab=169;break L221}}while(0);aC=bT(-1,-1)|0;aT=aC;aU=M}}while(0);do{if((ab|0)==169){aB=F;c[aB>>2]=c[O>>2];c[aB+4>>2]=c[O+4>>2];c[aB+8>>2]=c[O+8>>2];z=0;aR(382,A|0,D|0,F|0);if(z){z=0;aB=bT(-1,-1)|0;aC=aB;aB=M;if((a[D]&1)==0){aT=aC;aU=aB;break}Lw(c[D+8>>2]|0);aT=aC;aU=aB;break}if((a[D]&1)!=0){Lw(c[D+8>>2]|0)}if((a[d]&1)!=0){Lw(c[A+8>>2]|0)}if((a[ay]&1)!=0){Lw(c[B+8>>2]|0)}if((a[aJ]&1)==0){break L176}Lw(c[C+8>>2]|0);break L176}}while(0);if((a[d]&1)==0){aV=aT;aW=aU;break}Lw(c[A+8>>2]|0);aV=aT;aW=aU}}while(0);if((ab|0)==157){av=bT(-1,-1)|0;o=M;if((a[d]&1)!=0){Lw(c[A+8>>2]|0)}aV=av;aW=o}if((a[ay]&1)==0){aX=aV;aY=aW;break}Lw(c[B+8>>2]|0);aX=aV;aY=aW}}while(0);if((ab|0)==141){aF=bT(-1,-1)|0;aq=M;if((a[ay]&1)!=0){Lw(c[B+8>>2]|0)}aX=aF;aY=aq}if((a[aJ]&1)==0){Q=aX;R=aY;S=Q;T=0;U=S;V=R;bg(U|0)}Lw(c[C+8>>2]|0);Q=aX;R=aY;S=Q;T=0;U=S;V=R;bg(U|0)}}while(0);aZ=+h[p>>3];p=c[aA>>2]|0;aA=c[X>>2]|0;if(aZ<0.0){a_=+(p-aA>>2>>>0>>>0)}else{a_=-1.0}aY=~~+W(aZ+a_);L273:do{if(aY>>>0>((p-aA>>2)-1|0)>>>0){aX=LJ(e|0)|0;if(aX>>>0>4294967279>>>0){D5(0);return 0}if(aX>>>0<11>>>0){C=aX<<1&255;aJ=I;B=I;a[B]=C;a$=aJ+1|0;a0=C;a1=aJ;a2=B}else{B=aX+16&-16;aJ=Lu(B)|0;c[I+8>>2]=aJ;C=B|1;c[I>>2]=C;c[I+4>>2]=aX;a$=aJ;a0=C&255;a1=I;a2=I}LF(a$|0,e|0,aX)|0;a[a$+aX|0]=0;aX=H;LI(aX|0,0,12)|0;C=a0&255;if((C&1|0)==0){a3=C>>>1}else{a3=c[I+4>>2]|0}C=a3+25|0;do{if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;ab=211;break}return 0}else{if(C>>>0<11>>>0){a[aX]=50;a4=H+1|0}else{aJ=a3+41&-16;B=(z=0,au(248,aJ|0)|0);if(z){z=0;ab=211;break}c[H+8>>2]=B;c[H>>2]=aJ|1;c[H+4>>2]=25;a4=B}LF(a4|0,280,25)|0;a[a4+25|0]=0;if((a0&1)==0){a5=a1+1|0}else{a5=c[I+8>>2]|0}z=0,az(88,H|0,a5|0,a3|0)|0;if(z){z=0;ab=211;break}B=G;LI(B|0,0,12)|0;aJ=a[aX]|0;aW=aJ&255;if((aW&1|0)==0){a6=aW>>>1}else{a6=c[H+4>>2]|0}if((aJ&1)==0){a7=H+1|0}else{a7=c[H+8>>2]|0}aJ=a6+1|0;do{if(aJ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;ab=227;break}return 0}else{if(aJ>>>0<11>>>0){a[B]=a6<<1;a8=G+1|0}else{aW=a6+17&-16;aV=(z=0,au(248,aW|0)|0);if(z){z=0;ab=227;break}c[G+8>>2]=aV;c[G>>2]=aW|1;c[G+4>>2]=a6;a8=aV}LF(a8|0,a7|0,a6)|0;a[a8+a6|0]=0;z=0,az(88,G|0,1072,1)|0;if(z){z=0;ab=227;break}aV=f;L318:do{if((a[aV]&1)==0){aW=J;c[aW>>2]=c[aV>>2];c[aW+4>>2]=c[aV+4>>2];c[aW+8>>2]=c[aV+8>>2];ab=239}else{aW=c[f+8>>2]|0;A=c[f+4>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){a[J]=A<<1;a9=J+1|0}else{aU=A+16&-16;aT=(z=0,au(248,aU|0)|0);if(z){z=0;break}c[J+8>>2]=aT;c[J>>2]=aU|1;c[J+4>>2]=A;a9=aT}LF(a9|0,aW|0,A)|0;a[a9+A|0]=0;ab=239;break L318}}while(0);A=bT(-1,-1)|0;ba=A;bb=M}}while(0);do{if((ab|0)==239){aV=K;c[aV>>2]=c[O>>2];c[aV+4>>2]=c[O+4>>2];c[aV+8>>2]=c[O+8>>2];z=0;aR(382,G|0,J|0,K|0);if(z){z=0;aV=bT(-1,-1)|0;A=aV;aV=M;if((a[J]&1)==0){ba=A;bb=aV;break}Lw(c[J+8>>2]|0);ba=A;bb=aV;break}if((a[J]&1)!=0){Lw(c[J+8>>2]|0)}if((a[B]&1)!=0){Lw(c[G+8>>2]|0)}if((a[aX]&1)!=0){Lw(c[H+8>>2]|0)}if((a[a2]&1)==0){break L273}Lw(c[I+8>>2]|0);break L273}}while(0);if((a[B]&1)==0){bc=ba;bd=bb;break}Lw(c[G+8>>2]|0);bc=ba;bd=bb}}while(0);if((ab|0)==227){aJ=bT(-1,-1)|0;d=M;if((a[B]&1)!=0){Lw(c[G+8>>2]|0)}bc=aJ;bd=d}if((a[aX]&1)==0){be=bc;bf=bd;break}Lw(c[H+8>>2]|0);be=bc;bf=bd}}while(0);if((ab|0)==211){C=bT(-1,-1)|0;ay=M;if((a[aX]&1)!=0){Lw(c[H+8>>2]|0)}be=C;bf=ay}if((a[a2]&1)==0){Q=be;R=bf;S=Q;T=0;U=S;V=R;bg(U|0)}Lw(c[I+8>>2]|0);Q=be;R=bf;S=Q;T=0;U=S;V=R;bg(U|0)}}while(0);U=c[(c[X>>2]|0)+(aY<<2)>>2]|0;if((a[aE+56|0]&1)==0){bh=U;i=k;return bh|0}bh=c[U+36>>2]|0;i=k;return bh|0}function q9(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=Lu(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}LF(t|0,r|0,s)|0;a[t+s|0]=0}s=(z=0,aM(90,d|0,k|0)|0);if(z){z=0;d=bT(-1,-1)|0;t=d;d=M;if((a[k]&1)==0){w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[k+8>>2]|0);w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=Lh(t,31184,32360,-1)|0}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;LF(k+1|0,9104,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}z=0,az(88,l|0,E|0,F|0)|0;do{if(!z){z=0,az(88,l|0,7312,6)|0;if(z){z=0;G=57;break}F=LJ(e|0)|0;z=0,az(88,l|0,e|0,F|0)|0;if(z){z=0;G=57;break}z=0,az(88,l|0,11048,12)|0;if(z){z=0;G=57;break}F=m;a[F]=0;E=m+1|0;a[E]=0;z=0,az(88,l|0,E|0,0)|0;if(z){z=0;E=bT(-1,-1)|0;b=E;E=M;if((a[F]&1)==0){H=E;I=b;break}Lw(c[m+8>>2]|0);H=E;I=b;break}if((a[F]&1)!=0){Lw(c[m+8>>2]|0)}if((a[t]&1)==0){F=n;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2]}else{F=c[l+8>>2]|0;b=c[l+4>>2]|0;if(b>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=57;break}return 0}if(b>>>0<11>>>0){a[n]=b<<1;J=n+1|0}else{E=b+16&-16;q=(z=0,au(248,E|0)|0);if(z){z=0;G=57;break}c[n+8>>2]=q;c[n>>2]=E|1;c[n+4>>2]=b;J=q}LF(J|0,F|0,b)|0;a[J+b|0]=0}b=f;L61:do{if((a[b]&1)==0){F=o;c[F>>2]=c[b>>2];c[F+4>>2]=c[b+4>>2];c[F+8>>2]=c[b+8>>2];G=50}else{F=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;K=o+1|0}else{E=q+16&-16;k=(z=0,au(248,E|0)|0);if(z){z=0;break}c[o+8>>2]=k;c[o>>2]=E|1;c[o+4>>2]=q;K=k}LF(K|0,F|0,q)|0;a[K+q|0]=0;G=50;break L61}}while(0);q=bT(-1,-1)|0;L=M;N=q}}while(0);do{if((G|0)==50){b=p;q=g;c[b>>2]=c[q>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];z=0;aV(46,n|0,o|0,p|0,h|0);if(z){z=0;q=bT(-1,-1)|0;b=q;q=M;if((a[o]&1)==0){L=q;N=b;break}Lw(c[o+8>>2]|0);L=q;N=b;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}Lw(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=L;I=N;break}Lw(c[n+8>>2]|0);H=L;I=N}else{z=0;G=57}}while(0);if((G|0)==57){G=bT(-1,-1)|0;H=M;I=G}if((a[t]&1)==0){w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[l+8>>2]|0);w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0);return 0}function ra(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;j=i;i=i+224|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;p=j+56|0;q=j+64|0;r=j+80|0;s=j+96|0;t=j+112|0;u=j+128|0;v=j+144|0;w=j+160|0;x=j+176|0;y=j+192|0;A=j+208|0;B=q;C=q;a[C]=10;D=B+1|0;a[D]=a[864]|0;a[D+1|0]=a[865]|0;a[D+2|0]=a[866]|0;a[D+3|0]=a[867]|0;a[D+4|0]=a[868]|0;a[B+6|0]=0;B=(z=0,aM(90,b|0,q|0)|0);if(z){z=0;D=bT(-1,-1)|0;E=D;D=M;if((a[C]&1)==0){F=D;G=E;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[q+8>>2]|0);F=D;G=E;H=G;I=0;J=H;K=F;bg(J|0)}E=c[B>>2]|0;if((E|0)==0){L=0}else{L=Lh(E,31184,31536,-1)|0}if((a[C]&1)!=0){Lw(c[q+8>>2]|0)}q=r;C=r;a[C]=12;E=q+1|0;a[E]=a[1808]|0;a[E+1|0]=a[1809]|0;a[E+2|0]=a[1810]|0;a[E+3|0]=a[1811]|0;a[E+4|0]=a[1812]|0;a[E+5|0]=a[1813]|0;a[q+7|0]=0;q=s;E=g;c[q>>2]=c[E>>2];c[q+4>>2]=c[E+4>>2];c[q+8>>2]=c[E+8>>2];q=(z=0,at(118,r|0,b|0,e|0,f|0,s|0,h|0)|0);if(z){z=0;s=bT(-1,-1)|0;g=s;s=M;if((a[C]&1)==0){F=s;G=g;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[r+8>>2]|0);F=s;G=g;H=G;I=0;J=H;K=F;bg(J|0)}if((a[C]&1)!=0){Lw(c[r+8>>2]|0)}L24:do{if((L|0)==0){r=Lu(60)|0;c[p>>2]=r;C=d+4|0;g=c[C>>2]|0;if((g|0)==(c[d+8>>2]|0)){e4(d|0,p);N=c[p>>2]|0}else{if((g|0)==0){O=0}else{c[g>>2]=r;O=c[C>>2]|0}c[C>>2]=O+4;N=r}r=N;g=N;s=f;L33:do{if((a[s]&1)==0){B=t;c[B>>2]=c[s>>2];c[B+4>>2]=c[s+4>>2];c[B+8>>2]=c[s+8>>2];P=27}else{B=c[f+8>>2]|0;D=c[f+4>>2]|0;do{if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(D>>>0<11>>>0){a[t]=D<<1;Q=t+1|0}else{R=D+16&-16;S=(z=0,au(248,R|0)|0);if(z){z=0;break}c[t+8>>2]=S;c[t>>2]=R|1;c[t+4>>2]=D;Q=S}LF(Q|0,B|0,D)|0;a[Q+D|0]=0;P=27;break L33}}while(0);D=bT(-1,-1)|0;T=M;U=D}}while(0);do{if((P|0)==27){s=o;c[s>>2]=c[E>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];z=0;aD(36,g|0,t|0,o|0,1,0,0);if(z){z=0;s=bT(-1,-1)|0;D=s;s=M;if((a[t]&1)==0){T=s;U=D;break}Lw(c[t+8>>2]|0);T=s;U=D;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}D=u;s=u;a[s]=10;B=D+1|0;a[B]=a[864]|0;a[B+1|0]=a[865]|0;a[B+2|0]=a[866]|0;a[B+3|0]=a[867]|0;a[B+4|0]=a[868]|0;a[D+6|0]=0;D=v;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];D=(z=0,at(118,u|0,b|0,e|0,f|0,v|0,h|0)|0);do{if(!z){B=N+36|0;S=B;c[n>>2]=D;R=B+8|0;V=R;W=c[V>>2]|0;if((W|0)==(c[B+12>>2]|0)){z=0;as(376,B+4|0,n|0);if(z){z=0;break}X=c[n>>2]|0}else{if((W|0)==0){Y=0}else{c[W>>2]=D;Y=c[V>>2]|0}c[R>>2]=Y+4;X=D}z=0;as(c[c[B>>2]>>2]|0,S|0,X|0);if(z){z=0;break}if((a[s]&1)==0){Z=g;break L24}Lw(c[u+8>>2]|0);Z=g;break L24}else{z=0}}while(0);D=bT(-1,-1)|0;S=D;D=M;if((a[s]&1)==0){F=D;G=S;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[u+8>>2]|0);F=D;G=S;H=G;I=0;J=H;K=F;bg(J|0)}}while(0);g=c[d>>2]|0;S=c[C>>2]|0;D=g;while(1){if((D|0)==(S|0)){_=S;break}if((c[D>>2]|0)==(N|0)){_=D;break}else{D=D+4|0}}D=_-g>>2;B=g+(D+1<<2)|0;R=S-B|0;LG(g+(D<<2)|0,B|0,R|0)|0;B=g+((R>>2)+D<<2)|0;D=c[C>>2]|0;if((B|0)!=(D|0)){c[C>>2]=D+(~((D-4+(-B|0)|0)>>>2)<<2)}Lw(r);F=T;G=U;H=G;I=0;J=H;K=F;bg(J|0)}else{Z=L}}while(0);L=Z+40|0;U=(c[Z+44>>2]|0)-(c[L>>2]|0)>>2;T=Z+56|0;Z=0;do{if(Z>>>0>=U>>>0){P=89;break}_=c[(c[L>>2]|0)+(Z<<2)>>2]|0;if((a[T]&1)==0){$=_}else{$=c[_+36>>2]|0}Z=Z+1|0}while(!(i8($,q,d)|0));if((P|0)==89){q=Lu(40)|0;c[k>>2]=q;$=d+4|0;T=c[$>>2]|0;if((T|0)==(c[d+8>>2]|0)){e4(d|0,k);aa=c[k>>2]|0}else{if((T|0)==0){ab=0}else{c[T>>2]=q;ab=c[$>>2]|0}c[$>>2]=ab+4;aa=q}q=aa;ab=f;L97:do{if((a[ab]&1)==0){T=y;c[T>>2]=c[ab>>2];c[T+4>>2]=c[ab+4>>2];c[T+8>>2]=c[ab+8>>2];P=104}else{T=c[f+8>>2]|0;k=c[f+4>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(k>>>0<11>>>0){a[y]=k<<1;ac=y+1|0}else{L=k+16&-16;U=(z=0,au(248,L|0)|0);if(z){z=0;break}c[y+8>>2]=U;c[y>>2]=L|1;c[y+4>>2]=k;ac=U}LF(ac|0,T|0,k)|0;a[ac+k|0]=0;P=104;break L97}}while(0);k=bT(-1,-1)|0;ad=M;ae=k}}while(0);do{if((P|0)==104){ac=A;c[ac>>2]=c[E>>2];c[ac+4>>2]=c[E+4>>2];c[ac+8>>2]=c[E+8>>2];z=0;aV(4,aa|0,y|0,A|0,0);if(z){z=0;ac=bT(-1,-1)|0;ab=ac;ac=M;if((a[y]&1)==0){ad=ac;ae=ab;break}Lw(c[y+8>>2]|0);ad=ac;ae=ab;break}if((a[y]&1)==0){af=q;ag=af;i=j;return ag|0}Lw(c[y+8>>2]|0);af=q;ag=af;i=j;return ag|0}}while(0);y=c[d>>2]|0;A=c[$>>2]|0;ab=y;while(1){if((ab|0)==(A|0)){ah=A;break}if((c[ab>>2]|0)==(aa|0)){ah=ab;break}else{ab=ab+4|0}}ab=ah-y>>2;ah=y+(ab+1<<2)|0;aa=A-ah|0;LG(y+(ab<<2)|0,ah|0,aa|0)|0;ah=y+((aa>>2)+ab<<2)|0;ab=c[$>>2]|0;if((ah|0)!=(ab|0)){c[$>>2]=ab+(~((ab-4+(-ah|0)|0)>>>2)<<2)}Lw(q);F=ad;G=ae;H=G;I=0;J=H;K=F;bg(J|0)}ae=Lu(72)|0;c[m>>2]=ae;ad=d+4|0;q=c[ad>>2]|0;if((q|0)==(c[d+8>>2]|0)){e4(d|0,m);ai=c[m>>2]|0}else{if((q|0)==0){aj=0}else{c[q>>2]=ae;aj=c[ad>>2]|0}c[ad>>2]=aj+4;ai=ae}ae=ai;aj=ai;q=f;L137:do{if((a[q]&1)==0){m=w;c[m>>2]=c[q>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];P=73}else{m=c[f+8>>2]|0;ah=c[f+4>>2]|0;do{if(ah>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ah>>>0<11>>>0){a[w]=ah<<1;ak=w+1|0}else{ab=ah+16&-16;$=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[w+8>>2]=$;c[w>>2]=ab|1;c[w+4>>2]=ah;ak=$}LF(ak|0,m|0,ah)|0;a[ak+ah|0]=0;P=73;break L137}}while(0);ah=bT(-1,-1)|0;al=M;am=ah}}while(0);do{if((P|0)==73){ak=l;c[ak>>2]=c[E>>2];c[ak+4>>2]=c[E+4>>2];c[ak+8>>2]=c[E+8>>2];ak=x;a[ak]=0;a[x+1|0]=0;z=0;aG(2,aj|0,w|0,l|0,+(+(Z>>>0>>>0)),x|0);if(z){z=0;f=bT(-1,-1)|0;q=f;f=M;if((a[ak]&1)!=0){Lw(c[x+8>>2]|0)}if((a[w]&1)==0){al=f;am=q;break}Lw(c[w+8>>2]|0);al=f;am=q;break}if((a[ak]&1)!=0){Lw(c[x+8>>2]|0)}if((a[w]&1)==0){af=ae;ag=af;i=j;return ag|0}Lw(c[w+8>>2]|0);af=ae;ag=af;i=j;return ag|0}}while(0);ag=c[d>>2]|0;d=c[ad>>2]|0;j=ag;while(1){if((j|0)==(d|0)){an=d;break}if((c[j>>2]|0)==(ai|0)){an=j;break}else{j=j+4|0}}j=an-ag>>2;an=ag+(j+1<<2)|0;ai=d-an|0;LG(ag+(j<<2)|0,an|0,ai|0)|0;an=ag+((ai>>2)+j<<2)|0;j=c[ad>>2]|0;if((an|0)!=(j|0)){c[ad>>2]=j+(~((j-4+(-an|0)|0)>>>2)<<2)}Lw(ae);F=al;G=am;H=G;I=0;J=H;K=F;bg(J|0);return 0}function rb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0;j=i;i=i+392|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+16|0;n=j+32|0;o=j+40|0;p=j+48|0;q=j+64|0;r=j+72|0;s=j+80|0;t=j+96|0;u=j+104|0;v=j+120|0;w=j+136|0;x=j+152|0;y=j+168|0;A=j+184|0;B=j+200|0;C=j+216|0;D=j+232|0;E=j+248|0;F=j+264|0;G=j+280|0;H=j+296|0;I=j+312|0;J=j+328|0;K=j+344|0;L=j+360|0;N=j+376|0;O=u;P=u;a[P]=12;Q=O+1|0;a[Q]=a[88]|0;a[Q+1|0]=a[89]|0;a[Q+2|0]=a[90]|0;a[Q+3|0]=a[91]|0;a[Q+4|0]=a[92]|0;a[Q+5|0]=a[93]|0;a[O+7|0]=0;O=(z=0,aM(90,b|0,u|0)|0);if(z){z=0;Q=bT(-1,-1)|0;R=Q;Q=M;if((a[P]&1)==0){S=R;T=Q;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[u+8>>2]|0);S=R;T=Q;U=S;V=0;W=U;X=T;bg(W|0)}Q=c[O>>2]|0;if((Q|0)==0){Y=0}else{Y=Lh(Q,31184,31536,-1)|0}if((a[P]&1)!=0){Lw(c[u+8>>2]|0)}u=v;P=v;a[P]=12;Q=u+1|0;a[Q]=a[13288]|0;a[Q+1|0]=a[13289]|0;a[Q+2|0]=a[13290]|0;a[Q+3|0]=a[13291]|0;a[Q+4|0]=a[13292]|0;a[Q+5|0]=a[13293]|0;a[u+7|0]=0;u=(z=0,aM(90,b|0,v|0)|0);if(z){z=0;Q=bT(-1,-1)|0;O=Q;Q=M;if((a[P]&1)==0){S=O;T=Q;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[v+8>>2]|0);S=O;T=Q;U=S;V=0;W=U;X=T;bg(W|0)}Q=c[u>>2]|0;if((Q|0)==0){Z=0}else{Z=Lh(Q,31184,31536,-1)|0}if((a[P]&1)!=0){Lw(c[v+8>>2]|0)}v=w;P=w;a[P]=20;LF(v+1|0,13248,10)|0;a[v+11|0]=0;v=x;Q=g;c[v>>2]=c[Q>>2];c[v+4>>2]=c[Q+4>>2];c[v+8>>2]=c[Q+8>>2];v=(z=0,at(108,w|0,b|0,e|0,f|0,x|0,h|0)|0);if(z){z=0;x=bT(-1,-1)|0;g=x;x=M;if((a[P]&1)==0){S=g;T=x;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[w+8>>2]|0);S=g;T=x;U=S;V=0;W=U;X=T;bg(W|0)}if((a[P]&1)!=0){Lw(c[w+8>>2]|0)}L37:do{if((Y|0)==0){w=Lu(60)|0;c[t>>2]=w;P=d+4|0;x=c[P>>2]|0;g=d+8|0;if((x|0)==(c[g>>2]|0)){e4(d|0,t);_=c[t>>2]|0}else{if((x|0)==0){$=0}else{c[x>>2]=w;$=c[P>>2]|0}c[P>>2]=$+4;_=w}w=_;x=_;u=f;L46:do{if((a[u]&1)==0){O=y;c[O>>2]=c[u>>2];c[O+4>>2]=c[u+4>>2];c[O+8>>2]=c[u+8>>2];aa=34}else{O=c[f+8>>2]|0;R=c[f+4>>2]|0;do{if(R>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(R>>>0<11>>>0){a[y]=R<<1;ab=y+1|0}else{ac=R+16&-16;ad=(z=0,au(248,ac|0)|0);if(z){z=0;break}c[y+8>>2]=ad;c[y>>2]=ac|1;c[y+4>>2]=R;ab=ad}LF(ab|0,O|0,R)|0;a[ab+R|0]=0;aa=34;break L46}}while(0);R=bT(-1,-1)|0;ae=R;af=M}}while(0);do{if((aa|0)==34){u=s;c[u>>2]=c[Q>>2];c[u+4>>2]=c[Q+4>>2];c[u+8>>2]=c[Q+8>>2];z=0;aD(36,x|0,y|0,s|0,1,0,0);if(z){z=0;u=bT(-1,-1)|0;R=u;u=M;if((a[y]&1)==0){ae=R;af=u;break}Lw(c[y+8>>2]|0);ae=R;af=u;break}if((a[y]&1)!=0){Lw(c[y+8>>2]|0)}u=A;R=A;a[R]=12;O=u+1|0;a[O]=a[88]|0;a[O+1|0]=a[89]|0;a[O+2|0]=a[90]|0;a[O+3|0]=a[91]|0;a[O+4|0]=a[92]|0;a[O+5|0]=a[93]|0;a[u+7|0]=0;u=B;c[u>>2]=c[Q>>2];c[u+4>>2]=c[Q+4>>2];c[u+8>>2]=c[Q+8>>2];u=(z=0,at(118,A|0,b|0,e|0,f|0,B|0,h|0)|0);do{if(!z){O=_+36|0;ad=O;c[r>>2]=u;ac=O+8|0;ag=ac;ah=c[ag>>2]|0;if((ah|0)==(c[O+12>>2]|0)){z=0;as(376,O+4|0,r|0);if(z){z=0;break}ai=c[r>>2]|0}else{if((ah|0)==0){aj=0}else{c[ah>>2]=u;aj=c[ag>>2]|0}c[ac>>2]=aj+4;ai=u}z=0;as(c[c[O>>2]>>2]|0,ad|0,ai|0);if(z){z=0;break}if((a[R]&1)!=0){Lw(c[A+8>>2]|0)}if((Z|0)==0){ak=0;al=x;am=P;an=g;aa=64;break L37}ao=Z;ap=c[Z+52>>2]|0;aq=x;break L37}else{z=0}}while(0);u=bT(-1,-1)|0;ad=u;u=M;if((a[R]&1)==0){S=ad;T=u;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[A+8>>2]|0);S=ad;T=u;U=S;V=0;W=U;X=T;bg(W|0)}}while(0);x=c[d>>2]|0;g=c[P>>2]|0;u=x;while(1){if((u|0)==(g|0)){av=g;break}if((c[u>>2]|0)==(_|0)){av=u;break}else{u=u+4|0}}u=av-x>>2;ad=x+(u+1<<2)|0;O=g-ad|0;LG(x+(u<<2)|0,ad|0,O|0)|0;ad=x+((O>>2)+u<<2)|0;u=c[P>>2]|0;if((ad|0)!=(u|0)){c[P>>2]=u+(~((u-4+(-ad|0)|0)>>>2)<<2)}Lw(w);S=ae;T=af;U=S;V=0;W=U;X=T;bg(W|0)}else{ad=c[Y+52>>2]|0;if((Z|0)!=0){ao=Z;ap=ad;aq=Y;break}ak=ad;al=Y;am=d+4|0;an=d+8|0;aa=64}}while(0);L99:do{if((aa|0)==64){Y=Lu(60)|0;c[q>>2]=Y;Z=c[am>>2]|0;if((Z|0)==(c[an>>2]|0)){e4(d|0,q);aw=c[q>>2]|0}else{if((Z|0)==0){ax=0}else{c[Z>>2]=Y;ax=c[am>>2]|0}c[am>>2]=ax+4;aw=Y}Y=aw;Z=aw;af=f;L108:do{if((a[af]&1)==0){ae=C;c[ae>>2]=c[af>>2];c[ae+4>>2]=c[af+4>>2];c[ae+8>>2]=c[af+8>>2];aa=79}else{ae=c[f+8>>2]|0;av=c[f+4>>2]|0;do{if(av>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(av>>>0<11>>>0){a[C]=av<<1;ay=C+1|0}else{_=av+16&-16;A=(z=0,au(248,_|0)|0);if(z){z=0;break}c[C+8>>2]=A;c[C>>2]=_|1;c[C+4>>2]=av;ay=A}LF(ay|0,ae|0,av)|0;a[ay+av|0]=0;aa=79;break L108}}while(0);av=bT(-1,-1)|0;aA=av;aB=M}}while(0);do{if((aa|0)==79){af=p;c[af>>2]=c[Q>>2];c[af+4>>2]=c[Q+4>>2];c[af+8>>2]=c[Q+8>>2];z=0;aD(36,Z|0,C|0,p|0,1,0,0);if(z){z=0;af=bT(-1,-1)|0;w=af;af=M;if((a[C]&1)==0){aA=w;aB=af;break}Lw(c[C+8>>2]|0);aA=w;aB=af;break}if((a[C]&1)!=0){Lw(c[C+8>>2]|0)}af=D;w=D;a[w]=12;P=af+1|0;a[P]=a[13288]|0;a[P+1|0]=a[13289]|0;a[P+2|0]=a[13290]|0;a[P+3|0]=a[13291]|0;a[P+4|0]=a[13292]|0;a[P+5|0]=a[13293]|0;a[af+7|0]=0;af=E;c[af>>2]=c[Q>>2];c[af+4>>2]=c[Q+4>>2];c[af+8>>2]=c[Q+8>>2];af=(z=0,at(118,D|0,b|0,e|0,f|0,E|0,h|0)|0);do{if(!z){P=aw+36|0;x=P;c[o>>2]=af;g=P+8|0;av=g;ae=c[av>>2]|0;if((ae|0)==(c[P+12>>2]|0)){z=0;as(376,P+4|0,o|0);if(z){z=0;break}aC=c[o>>2]|0}else{if((ae|0)==0){aE=0}else{c[ae>>2]=af;aE=c[av>>2]|0}c[g>>2]=aE+4;aC=af}z=0;as(c[c[P>>2]>>2]|0,x|0,aC|0);if(z){z=0;break}if((a[w]&1)==0){ao=Z;ap=ak;aq=al;break L99}Lw(c[D+8>>2]|0);ao=Z;ap=ak;aq=al;break L99}else{z=0}}while(0);af=bT(-1,-1)|0;x=af;af=M;if((a[w]&1)==0){S=x;T=af;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[D+8>>2]|0);S=x;T=af;U=S;V=0;W=U;X=T;bg(W|0)}}while(0);Z=c[d>>2]|0;af=c[am>>2]|0;x=Z;while(1){if((x|0)==(af|0)){aF=af;break}if((c[x>>2]|0)==(aw|0)){aF=x;break}else{x=x+4|0}}x=aF-Z>>2;P=Z+(x+1<<2)|0;g=af-P|0;LG(Z+(x<<2)|0,P|0,g|0)|0;P=Z+((g>>2)+x<<2)|0;x=c[am>>2]|0;if((P|0)!=(x|0)){c[am>>2]=x+(~((x-4+(-P|0)|0)>>>2)<<2)}Lw(Y);S=aA;T=aB;U=S;V=0;W=U;X=T;bg(W|0)}}while(0);aB=aq+36|0;aA=ao+36|0;am=((c[ao+44>>2]|0)-(c[ao+40>>2]|0)>>2)+((c[aq+44>>2]|0)-(c[aq+40>>2]|0)>>2)|0;aF=v+40|0;if((a[aF]&1)==0){aw=G;c[aw>>2]=c[aF>>2];c[aw+4>>2]=c[aF+4>>2];c[aw+8>>2]=c[aF+8>>2]}else{aF=c[v+48>>2]|0;aw=c[v+44>>2]|0;if(aw>>>0>4294967279>>>0){D5(0);return 0}if(aw>>>0<11>>>0){a[G]=aw<<1;aG=G+1|0}else{v=aw+16&-16;D=Lu(v)|0;c[G+8>>2]=D;c[G>>2]=v|1;c[G+4>>2]=aw;aG=D}LF(aG|0,aF|0,aw)|0;a[aG+aw|0]=0}z=0;as(180,F|0,G|0);if(z){z=0;aw=bT(-1,-1)|0;aG=aw;aw=M;if((a[G]&1)==0){S=aG;T=aw;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[G+8>>2]|0);S=aG;T=aw;U=S;V=0;W=U;X=T;bg(W|0)}if((a[G]&1)!=0){Lw(c[G+8>>2]|0)}G=F;aw=F;aG=a[aw]|0;aF=aG&255;D=(aF&1|0)==0;if(D){aH=aF>>>1}else{aH=c[F+4>>2]|0}v=(aG&1)==0;if(v){aI=G+1|0}else{aI=c[F+8>>2]|0}aG=aH>>>0>5>>>0;if((LH(aI|0,13168,(aG?5:aH)|0)|0)==0){if(aH>>>0>4>>>0&(aG^1)){aJ=0;aa=213}else{aa=124}}else{aa=124}L188:do{if((aa|0)==124){if(D){aK=aF>>>1}else{aK=c[F+4>>2]|0}if(v){aL=G+1|0}else{aL=c[F+8>>2]|0}aG=aK>>>0>5>>>0;if((LH(aL|0,13136,(aG?5:aK)|0)|0)==0){if(aK>>>0>4>>>0&(aG^1)){aJ=1;aa=213;break}}if(D){aN=aF>>>1}else{aN=c[F+4>>2]|0}if(v){aO=G+1|0}else{aO=c[F+8>>2]|0}aG=aN>>>0>4>>>0;if((LH(aO|0,13088,(aG?4:aN)|0)|0)==0){if(aN>>>0>3>>>0&(aG^1)){aJ=ap;aa=213;break}}aG=LJ(e|0)|0;if(aG>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aa=200;break}return 0}if(aG>>>0<11>>>0){aH=aG<<1&255;aI=J;al=J;a[al]=aH;aP=aI+1|0;aQ=aH;aS=aI;aT=al}else{al=aG+16&-16;aI=(z=0,au(248,al|0)|0);if(z){z=0;aa=200;break}c[J+8>>2]=aI;aH=al|1;c[J>>2]=aH;c[J+4>>2]=aG;aP=aI;aQ=aH&255;aS=J;aT=J}LF(aP|0,e|0,aG)|0;a[aP+aG|0]=0;aG=I;LI(aG|0,0,12)|0;aH=aQ&255;if((aH&1|0)==0){aU=aH>>>1}else{aU=c[J+4>>2]|0}aH=aU+26|0;do{if(aH>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aa=161;break}return 0}else{if(aH>>>0<11>>>0){a[aG]=52;aV=I+1|0}else{aI=aU+42&-16;al=(z=0,au(248,aI|0)|0);if(z){z=0;aa=161;break}c[I+8>>2]=al;c[I>>2]=aI|1;c[I+4>>2]=26;aV=al}LF(aV|0,13048,26)|0;a[aV+26|0]=0;if((aQ&1)==0){aW=aS+1|0}else{aW=c[J+8>>2]|0}z=0,az(88,I|0,aW|0,aU|0)|0;if(z){z=0;aa=161;break}al=H;LI(al|0,0,12)|0;aI=a[aG]|0;ak=aI&255;if((ak&1|0)==0){aX=ak>>>1}else{aX=c[I+4>>2]|0}if((aI&1)==0){aY=I+1|0}else{aY=c[I+8>>2]|0}aI=aX+37|0;do{if(aI>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aa=177;break}return 0}else{if(aI>>>0<11>>>0){a[al]=aX<<1;aZ=H+1|0}else{ak=aX+53&-16;aC=(z=0,au(248,ak|0)|0);if(z){z=0;aa=177;break}c[H+8>>2]=aC;c[H>>2]=ak|1;c[H+4>>2]=aX;aZ=aC}LF(aZ|0,aY|0,aX)|0;a[aZ+aX|0]=0;z=0,az(88,H|0,12960,37)|0;if(z){z=0;aa=177;break}aC=f;L253:do{if((a[aC]&1)==0){ak=K;c[ak>>2]=c[aC>>2];c[ak+4>>2]=c[aC+4>>2];c[ak+8>>2]=c[aC+8>>2];aa=189}else{ak=c[f+8>>2]|0;aE=c[f+4>>2]|0;do{if(aE>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aE>>>0<11>>>0){a[K]=aE<<1;a_=K+1|0}else{o=aE+16&-16;h=(z=0,au(248,o|0)|0);if(z){z=0;break}c[K+8>>2]=h;c[K>>2]=o|1;c[K+4>>2]=aE;a_=h}LF(a_|0,ak|0,aE)|0;a[a_+aE|0]=0;aa=189;break L253}}while(0);aE=bT(-1,-1)|0;a$=aE;a0=M}}while(0);do{if((aa|0)==189){aC=L;c[aC>>2]=c[Q>>2];c[aC+4>>2]=c[Q+4>>2];c[aC+8>>2]=c[Q+8>>2];z=0;aR(382,H|0,K|0,L|0);if(z){z=0;aC=bT(-1,-1)|0;aE=aC;aC=M;if((a[K]&1)==0){a$=aE;a0=aC;break}Lw(c[K+8>>2]|0);a$=aE;a0=aC;break}if((a[K]&1)!=0){Lw(c[K+8>>2]|0)}if((a[al]&1)!=0){Lw(c[H+8>>2]|0)}if((a[aG]&1)!=0){Lw(c[I+8>>2]|0)}if((a[aT]&1)==0){aJ=ap;aa=213;break L188}Lw(c[J+8>>2]|0);aJ=ap;aa=213;break L188}}while(0);if((a[al]&1)==0){a1=a$;a2=a0;break}Lw(c[H+8>>2]|0);a1=a$;a2=a0}}while(0);if((aa|0)==177){aI=bT(-1,-1)|0;w=M;if((a[al]&1)!=0){Lw(c[H+8>>2]|0)}a1=aI;a2=w}if((a[aG]&1)==0){a3=a1;a4=a2;break}Lw(c[I+8>>2]|0);a3=a1;a4=a2}}while(0);if((aa|0)==161){aH=bT(-1,-1)|0;Y=M;if((a[aG]&1)!=0){Lw(c[I+8>>2]|0)}a3=aH;a4=Y}if((a[aT]&1)==0){a5=a3;a6=a4;break}Lw(c[J+8>>2]|0);a5=a3;a6=a4}}while(0);L302:do{if((aa|0)==213){a4=(z=0,au(248,60)|0);if(z){z=0;aa=200;break}a3=a4;c[n>>2]=a3;a4=d+4|0;J=c[a4>>2]|0;if((J|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,n|0);if(z){z=0;aa=200;break}a7=c[n>>2]|0}else{if((J|0)==0){a8=0}else{c[J>>2]=a3;a8=c[a4>>2]|0}c[a4>>2]=a8+4;a7=a3}a3=a7;J=f;L313:do{if((a[J]&1)==0){aT=N;c[aT>>2]=c[J>>2];c[aT+4>>2]=c[J+4>>2];c[aT+8>>2]=c[J+8>>2];aa=230}else{aT=c[f+8>>2]|0;I=c[f+4>>2]|0;do{if(I>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(I>>>0<11>>>0){a[N]=I<<1;a9=N+1|0}else{a2=I+16&-16;a1=(z=0,au(248,a2|0)|0);if(z){z=0;break}c[N+8>>2]=a1;c[N>>2]=a2|1;c[N+4>>2]=I;a9=a1}LF(a9|0,aT|0,I)|0;a[a9+I|0]=0;aa=230;break L313}}while(0);I=bT(-1,-1)|0;ba=I;bb=M}}while(0);do{if((aa|0)==230){J=m;c[J>>2]=c[Q>>2];c[J+4>>2]=c[Q+4>>2];c[J+8>>2]=c[Q+8>>2];z=0;aD(36,a7|0,N|0,m|0,am|0,aJ|0,0);if(z){z=0;J=bT(-1,-1)|0;aG=J;J=M;if((a[N]&1)==0){ba=aG;bb=J;break}Lw(c[N+8>>2]|0);ba=aG;bb=J;break}if((a[N]&1)!=0){Lw(c[N+8>>2]|0)}J=a7+36|0;aG=J;I=(aq|0)==0?0:aB;aT=I+4|0;al=c[aT>>2]|0;a1=(c[I+8>>2]|0)-al>>2;L335:do{if((a1|0)!=0){I=J+8|0;a2=I;H=J+12|0;a0=J+4|0;a$=J;ap=0;K=al;while(1){L=c[K+(ap<<2)>>2]|0;c[l>>2]=L;a_=c[a2>>2]|0;if((a_|0)==(c[H>>2]|0)){z=0;as(376,a0|0,l|0);if(z){z=0;break}bc=c[l>>2]|0}else{if((a_|0)==0){bd=0}else{c[a_>>2]=L;bd=c[a2>>2]|0}c[I>>2]=bd+4;bc=L}z=0;as(c[c[a$>>2]>>2]|0,aG|0,bc|0);if(z){z=0;break}L=ap+1|0;if(L>>>0>=a1>>>0){break L335}ap=L;K=c[aT>>2]|0}K=bT(-1,-1)|0;be=M;bf=K;aa=201;break L302}}while(0);aT=(ao|0)==0?0:aA;a1=aT+4|0;al=c[a1>>2]|0;K=(c[aT+8>>2]|0)-al>>2;L351:do{if((K|0)!=0){aT=J+8|0;ap=aT;a$=J+12|0;I=J+4|0;a2=J;a0=0;H=al;while(1){L=c[H+(a0<<2)>>2]|0;c[k>>2]=L;a_=c[ap>>2]|0;if((a_|0)==(c[a$>>2]|0)){z=0;as(376,I|0,k|0);if(z){z=0;break}bh=c[k>>2]|0}else{if((a_|0)==0){bi=0}else{c[a_>>2]=L;bi=c[ap>>2]|0}c[aT>>2]=bi+4;bh=L}z=0;as(c[c[a2>>2]>>2]|0,aG|0,bh|0);if(z){z=0;break}L=a0+1|0;if(L>>>0>=K>>>0){break L351}a0=L;H=c[a1>>2]|0}H=bT(-1,-1)|0;be=M;bf=H;aa=201;break L302}}while(0);a1=a7;if((a[aw]&1)==0){i=j;return a1|0}Lw(c[F+8>>2]|0);i=j;return a1|0}}while(0);a1=c[d>>2]|0;K=c[a4>>2]|0;aG=a1;while(1){if((aG|0)==(K|0)){bj=K;break}if((c[aG>>2]|0)==(a7|0)){bj=aG;break}else{aG=aG+4|0}}aG=bj-a1>>2;al=a1+(aG+1<<2)|0;J=K-al|0;LG(a1+(aG<<2)|0,al|0,J|0)|0;al=a1+((J>>2)+aG<<2)|0;aG=c[a4>>2]|0;if((al|0)!=(aG|0)){c[a4>>2]=aG+(~((aG-4+(-al|0)|0)>>>2)<<2)}Lw(a3);a5=ba;a6=bb}}while(0);if((aa|0)==200){bb=bT(-1,-1)|0;be=M;bf=bb;aa=201}if((aa|0)==201){a5=bf;a6=be}if((a[aw]&1)==0){S=a5;T=a6;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[F+8>>2]|0);S=a5;T=a6;U=S;V=0;W=U;X=T;bg(W|0);return 0}function rc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0;j=i;i=i+344|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;p=j+56|0;q=j+64|0;r=j+72|0;s=j+88|0;t=j+104|0;u=j+120|0;v=j+136|0;w=j+152|0;x=j+168|0;y=j+184|0;A=j+200|0;B=j+216|0;C=j+232|0;D=j+248|0;F=j+264|0;G=j+280|0;H=j+296|0;I=j+312|0;J=j+328|0;K=r;L=r;a[L]=10;N=K+1|0;a[N]=a[864]|0;a[N+1|0]=a[865]|0;a[N+2|0]=a[866]|0;a[N+3|0]=a[867]|0;a[N+4|0]=a[868]|0;a[K+6|0]=0;K=(z=0,aM(90,b|0,r|0)|0);if(z){z=0;N=bT(-1,-1)|0;O=N;N=M;if((a[L]&1)==0){P=O;Q=N;R=P;S=0;T=R;U=Q;bg(T|0)}Lw(c[r+8>>2]|0);P=O;Q=N;R=P;S=0;T=R;U=Q;bg(T|0)}N=c[K>>2]|0;if((N|0)==0){V=0}else{V=Lh(N,31184,31536,-1)|0}if((a[L]&1)!=0){Lw(c[r+8>>2]|0)}r=s;L=s;a[L]=8;N=r+1|0;E=1818326564;a[N]=E;E=E>>8;a[N+1|0]=E;E=E>>8;a[N+2|0]=E;E=E>>8;a[N+3|0]=E;a[r+5|0]=0;r=t;N=g;c[r>>2]=c[N>>2];c[r+4>>2]=c[N+4>>2];c[r+8>>2]=c[N+8>>2];r=(z=0,at(118,s|0,b|0,e|0,f|0,t|0,h|0)|0);if(z){z=0;t=bT(-1,-1)|0;g=t;t=M;if((a[L]&1)==0){P=g;Q=t;R=P;S=0;T=R;U=Q;bg(T|0)}Lw(c[s+8>>2]|0);P=g;Q=t;R=P;S=0;T=R;U=Q;bg(T|0)}if((a[L]&1)!=0){Lw(c[s+8>>2]|0)}s=u;L=u;a[L]=20;LF(s+1|0,13248,10)|0;a[s+11|0]=0;s=v;c[s>>2]=c[N>>2];c[s+4>>2]=c[N+4>>2];c[s+8>>2]=c[N+8>>2];s=(z=0,at(108,u|0,b|0,e|0,f|0,v|0,h|0)|0);if(z){z=0;v=bT(-1,-1)|0;t=v;v=M;if((a[L]&1)==0){P=t;Q=v;R=P;S=0;T=R;U=Q;bg(T|0)}Lw(c[u+8>>2]|0);P=t;Q=v;R=P;S=0;T=R;U=Q;bg(T|0)}if((a[L]&1)!=0){Lw(c[u+8>>2]|0)}L34:do{if((V|0)==0){u=Lu(60)|0;c[p>>2]=u;L=d+4|0;v=c[L>>2]|0;t=d+8|0;if((v|0)==(c[t>>2]|0)){e4(d|0,p);W=c[p>>2]|0}else{if((v|0)==0){X=0}else{c[v>>2]=u;X=c[L>>2]|0}c[L>>2]=X+4;W=u}u=W;v=W;g=f;L43:do{if((a[g]&1)==0){K=w;c[K>>2]=c[g>>2];c[K+4>>2]=c[g+4>>2];c[K+8>>2]=c[g+8>>2];Y=31}else{K=c[f+8>>2]|0;O=c[f+4>>2]|0;do{if(O>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(O>>>0<11>>>0){a[w]=O<<1;Z=w+1|0}else{_=O+16&-16;$=(z=0,au(248,_|0)|0);if(z){z=0;break}c[w+8>>2]=$;c[w>>2]=_|1;c[w+4>>2]=O;Z=$}LF(Z|0,K|0,O)|0;a[Z+O|0]=0;Y=31;break L43}}while(0);O=bT(-1,-1)|0;aa=O;ab=M}}while(0);do{if((Y|0)==31){g=o;c[g>>2]=c[N>>2];c[g+4>>2]=c[N+4>>2];c[g+8>>2]=c[N+8>>2];z=0;aD(36,v|0,w|0,o|0,1,0,0);if(z){z=0;g=bT(-1,-1)|0;O=g;g=M;if((a[w]&1)==0){aa=O;ab=g;break}Lw(c[w+8>>2]|0);aa=O;ab=g;break}if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}g=x;O=x;a[O]=10;K=g+1|0;a[K]=a[864]|0;a[K+1|0]=a[865]|0;a[K+2|0]=a[866]|0;a[K+3|0]=a[867]|0;a[K+4|0]=a[868]|0;a[g+6|0]=0;g=y;c[g>>2]=c[N>>2];c[g+4>>2]=c[N+4>>2];c[g+8>>2]=c[N+8>>2];g=(z=0,at(118,x|0,b|0,e|0,f|0,y|0,h|0)|0);do{if(!z){K=W+36|0;$=K;c[n>>2]=g;_=K+8|0;ac=_;ad=c[ac>>2]|0;if((ad|0)==(c[K+12>>2]|0)){z=0;as(376,K+4|0,n|0);if(z){z=0;break}ae=c[n>>2]|0}else{if((ad|0)==0){af=0}else{c[ad>>2]=g;af=c[ac>>2]|0}c[_>>2]=af+4;ae=g}z=0;as(c[c[K>>2]>>2]|0,$|0,ae|0);if(z){z=0;break}if((a[O]&1)==0){ag=v;ah=L;ai=t;break L34}Lw(c[x+8>>2]|0);ag=v;ah=L;ai=t;break L34}else{z=0}}while(0);g=bT(-1,-1)|0;$=g;g=M;if((a[O]&1)==0){P=$;Q=g;R=P;S=0;T=R;U=Q;bg(T|0)}Lw(c[x+8>>2]|0);P=$;Q=g;R=P;S=0;T=R;U=Q;bg(T|0)}}while(0);t=c[d>>2]|0;v=c[L>>2]|0;g=t;while(1){if((g|0)==(v|0)){aj=v;break}if((c[g>>2]|0)==(W|0)){aj=g;break}else{g=g+4|0}}g=aj-t>>2;$=t+(g+1<<2)|0;K=v-$|0;LG(t+(g<<2)|0,$|0,K|0)|0;$=t+((K>>2)+g<<2)|0;g=c[L>>2]|0;if(($|0)!=(g|0)){c[L>>2]=g+(~((g-4+(-$|0)|0)>>>2)<<2)}Lw(u);P=aa;Q=ab;R=P;S=0;T=R;U=Q;bg(T|0)}else{ag=V;ah=d+4|0;ai=d+8|0}}while(0);V=Lu(60)|0;c[m>>2]=V;ab=c[ah>>2]|0;if((ab|0)==(c[ai>>2]|0)){e4(d|0,m);ak=c[m>>2]|0}else{if((ab|0)==0){al=0}else{c[ab>>2]=V;al=c[ah>>2]|0}c[ah>>2]=al+4;ak=V}V=ak;al=ak;ab=f;L100:do{if((a[ab]&1)==0){m=A;c[m>>2]=c[ab>>2];c[m+4>>2]=c[ab+4>>2];c[m+8>>2]=c[ab+8>>2];Y=74}else{m=c[f+8>>2]|0;ai=c[f+4>>2]|0;do{if(ai>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ai>>>0<11>>>0){a[A]=ai<<1;am=A+1|0}else{aa=ai+16&-16;aj=(z=0,au(248,aa|0)|0);if(z){z=0;break}c[A+8>>2]=aj;c[A>>2]=aa|1;c[A+4>>2]=ai;am=aj}LF(am|0,m|0,ai)|0;a[am+ai|0]=0;Y=74;break L100}}while(0);ai=bT(-1,-1)|0;an=ai;ao=M}}while(0);do{if((Y|0)==74){am=B;c[am>>2]=c[N>>2];c[am+4>>2]=c[N+4>>2];c[am+8>>2]=c[N+8>>2];ai=ag+36|0;m=((c[ag+44>>2]|0)-(c[ag+40>>2]|0)>>2)+1|0;u=c[ag+52>>2]|0;L=l;c[L>>2]=c[am>>2];c[L+4>>2]=c[am+4>>2];c[L+8>>2]=c[am+8>>2];z=0;aD(36,al|0,A|0,l|0,m|0,u|0,0);if(z){z=0;u=bT(-1,-1)|0;m=u;u=M;if((a[A]&1)==0){an=m;ao=u;break}Lw(c[A+8>>2]|0);an=m;ao=u;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}u=s+40|0;if((a[u]&1)==0){m=D;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2]}else{u=c[s+48>>2]|0;m=c[s+44>>2]|0;if(m>>>0>4294967279>>>0){D5(0);return 0}if(m>>>0<11>>>0){a[D]=m<<1;ap=D+1|0}else{am=m+16&-16;L=Lu(am)|0;c[D+8>>2]=L;c[D>>2]=am|1;c[D+4>>2]=m;ap=L}LF(ap|0,u|0,m)|0;a[ap+m|0]=0}z=0;as(180,C|0,D|0);if(z){z=0;m=bT(-1,-1)|0;u=m;m=M;if((a[D]&1)==0){P=u;Q=m;R=P;S=0;T=R;U=Q;bg(T|0)}Lw(c[D+8>>2]|0);P=u;Q=m;R=P;S=0;T=R;U=Q;bg(T|0)}if((a[D]&1)!=0){Lw(c[D+8>>2]|0)}m=C;u=C;L=a[u]|0;am=L&255;t=(am&1|0)==0;if(t){aq=am>>>1}else{aq=c[C+4>>2]|0}v=(L&1)==0;if(v){av=m+1|0}else{av=c[C+8>>2]|0}L=aq>>>0>5>>>0;do{if((LH(av|0,13168,(L?5:aq)|0)|0)==0){if(!(aq>>>0>4>>>0&(L^1))){Y=111;break}c[ak+52>>2]=0;Y=197}else{Y=111}}while(0);L154:do{if((Y|0)==111){if(t){aw=am>>>1}else{aw=c[C+4>>2]|0}if(v){ax=m+1|0}else{ax=c[C+8>>2]|0}L=aw>>>0>5>>>0;do{if((LH(ax|0,13136,(L?5:aw)|0)|0)==0){if(!(aw>>>0>4>>>0&(L^1))){break}c[ak+52>>2]=1;Y=197;break L154}}while(0);if(t){ay=am>>>1}else{ay=c[C+4>>2]|0}if(v){aA=m+1|0}else{aA=c[C+8>>2]|0}L=ay>>>0>4>>>0;if((LH(aA|0,13088,(L?4:ay)|0)|0)==0){if(ay>>>0>3>>>0&(L^1)){Y=197;break}}L=LJ(e|0)|0;if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Y=109;break}return 0}if(L>>>0<11>>>0){O=L<<1&255;aj=H;aa=H;a[aa]=O;aB=aj+1|0;aC=O;aE=aj;aF=aa}else{aa=L+16&-16;aj=(z=0,au(248,aa|0)|0);if(z){z=0;Y=109;break}c[H+8>>2]=aj;O=aa|1;c[H>>2]=O;c[H+4>>2]=L;aB=aj;aC=O&255;aE=H;aF=H}LF(aB|0,e|0,L)|0;a[aB+L|0]=0;L=G;LI(L|0,0,12)|0;O=aC&255;if((O&1|0)==0){aG=O>>>1}else{aG=c[H+4>>2]|0}O=aG+26|0;do{if(O>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Y=149;break}return 0}else{if(O>>>0<11>>>0){a[L]=52;aH=G+1|0}else{aj=aG+42&-16;aa=(z=0,au(248,aj|0)|0);if(z){z=0;Y=149;break}c[G+8>>2]=aa;c[G>>2]=aj|1;c[G+4>>2]=26;aH=aa}LF(aH|0,13048,26)|0;a[aH+26|0]=0;if((aC&1)==0){aI=aE+1|0}else{aI=c[H+8>>2]|0}z=0,az(88,G|0,aI|0,aG|0)|0;if(z){z=0;Y=149;break}aa=F;LI(aa|0,0,12)|0;aj=a[L]|0;W=aj&255;if((W&1|0)==0){aJ=W>>>1}else{aJ=c[G+4>>2]|0}if((aj&1)==0){aK=G+1|0}else{aK=c[G+8>>2]|0}aj=aJ+37|0;do{if(aj>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Y=165;break}return 0}else{if(aj>>>0<11>>>0){a[aa]=aJ<<1;aL=F+1|0}else{W=aJ+53&-16;x=(z=0,au(248,W|0)|0);if(z){z=0;Y=165;break}c[F+8>>2]=x;c[F>>2]=W|1;c[F+4>>2]=aJ;aL=x}LF(aL|0,aK|0,aJ)|0;a[aL+aJ|0]=0;z=0,az(88,F|0,12960,37)|0;if(z){z=0;Y=165;break}L222:do{if((a[ab]&1)==0){x=I;c[x>>2]=c[ab>>2];c[x+4>>2]=c[ab+4>>2];c[x+8>>2]=c[ab+8>>2];Y=177}else{x=c[f+8>>2]|0;W=c[f+4>>2]|0;do{if(W>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(W>>>0<11>>>0){a[I]=W<<1;aN=I+1|0}else{ae=W+16&-16;af=(z=0,au(248,ae|0)|0);if(z){z=0;break}c[I+8>>2]=af;c[I>>2]=ae|1;c[I+4>>2]=W;aN=af}LF(aN|0,x|0,W)|0;a[aN+W|0]=0;Y=177;break L222}}while(0);W=bT(-1,-1)|0;aO=W;aP=M}}while(0);do{if((Y|0)==177){W=J;c[W>>2]=c[N>>2];c[W+4>>2]=c[N+4>>2];c[W+8>>2]=c[N+8>>2];z=0;aR(382,F|0,I|0,J|0);if(z){z=0;W=bT(-1,-1)|0;x=W;W=M;if((a[I]&1)==0){aO=x;aP=W;break}Lw(c[I+8>>2]|0);aO=x;aP=W;break}if((a[I]&1)!=0){Lw(c[I+8>>2]|0)}if((a[aa]&1)!=0){Lw(c[F+8>>2]|0)}if((a[L]&1)!=0){Lw(c[G+8>>2]|0)}if((a[aF]&1)==0){Y=197;break L154}Lw(c[H+8>>2]|0);Y=197;break L154}}while(0);if((a[aa]&1)==0){aQ=aO;aS=aP;break}Lw(c[F+8>>2]|0);aQ=aO;aS=aP}}while(0);if((Y|0)==165){aj=bT(-1,-1)|0;W=M;if((a[aa]&1)!=0){Lw(c[F+8>>2]|0)}aQ=aj;aS=W}if((a[L]&1)==0){aT=aQ;aU=aS;break}Lw(c[G+8>>2]|0);aT=aQ;aU=aS}}while(0);if((Y|0)==149){O=bT(-1,-1)|0;W=M;if((a[L]&1)!=0){Lw(c[G+8>>2]|0)}aT=O;aU=W}if((a[aF]&1)==0){aV=aT;aW=aU;break}Lw(c[H+8>>2]|0);aV=aT;aW=aU}}while(0);L269:do{if((Y|0)==197){m=ak+36|0;v=m;am=(ag|0)==0?0:ai;t=am+4|0;W=c[t>>2]|0;O=(c[am+8>>2]|0)-W>>2;L271:do{if((O|0)==0){am=m+8|0;aX=am;aY=am;aZ=m+12|0}else{am=m+8|0;aj=am;x=m+12|0;af=m+4|0;ae=m;n=0;h=W;while(1){y=c[h+(n<<2)>>2]|0;c[k>>2]=y;b=c[aj>>2]|0;if((b|0)==(c[x>>2]|0)){z=0;as(376,af|0,k|0);if(z){z=0;break}a_=c[k>>2]|0}else{if((b|0)==0){a$=0}else{c[b>>2]=y;a$=c[aj>>2]|0}c[am>>2]=a$+4;a_=y}z=0;as(c[c[ae>>2]>>2]|0,v|0,a_|0);if(z){z=0;break}y=n+1|0;if(y>>>0>=O>>>0){aX=am;aY=aj;aZ=x;break L271}n=y;h=c[t>>2]|0}h=bT(-1,-1)|0;a0=M;a1=h;Y=110;break L269}}while(0);c[q>>2]=r;t=c[aY>>2]|0;if((t|0)==(c[aZ>>2]|0)){z=0;as(376,m+4|0,q|0);if(z){z=0;Y=109;break}a2=c[q>>2]|0}else{if((t|0)==0){a3=0}else{c[t>>2]=r;a3=c[aY>>2]|0}c[aX>>2]=a3+4;a2=r}z=0;as(c[c[m>>2]>>2]|0,v|0,a2|0);if(z){z=0;Y=109;break}t=ak;if((a[u]&1)==0){i=j;return t|0}Lw(c[C+8>>2]|0);i=j;return t|0}}while(0);if((Y|0)==109){ai=bT(-1,-1)|0;a0=M;a1=ai;Y=110}if((Y|0)==110){aV=a1;aW=a0}if((a[u]&1)==0){P=aV;Q=aW;R=P;S=0;T=R;U=Q;bg(T|0)}Lw(c[C+8>>2]|0);P=aV;Q=aW;R=P;S=0;T=R;U=Q;bg(T|0)}}while(0);aW=c[d>>2]|0;d=c[ah>>2]|0;aV=aW;while(1){if((aV|0)==(d|0)){a4=d;break}if((c[aV>>2]|0)==(ak|0)){a4=aV;break}else{aV=aV+4|0}}aV=a4-aW>>2;a4=aW+(aV+1<<2)|0;ak=d-a4|0;LG(aW+(aV<<2)|0,a4|0,ak|0)|0;a4=aW+((ak>>2)+aV<<2)|0;aV=c[ah>>2]|0;if((a4|0)!=(aV|0)){c[ah>>2]=aV+(~((aV-4+(-a4|0)|0)>>>2)<<2)}Lw(V);P=an;Q=ao;R=P;S=0;T=R;U=Q;bg(T|0);return 0}function rd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0;j=i;i=i+184|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+16|0;n=j+32|0;o=j+40|0;p=j+56|0;q=j+64|0;r=j+72|0;s=j+88|0;t=j+96|0;u=j+104|0;v=j+120|0;w=j+136|0;x=j+152|0;y=j+168|0;A=Lu(60)|0;c[t>>2]=A;B=d+4|0;C=c[B>>2]|0;D=d+8|0;if((C|0)==(c[D>>2]|0)){e4(d|0,t);E=c[t>>2]|0}else{if((C|0)==0){F=0}else{c[C>>2]=A;F=c[B>>2]|0}c[B>>2]=F+4;E=A}A=E;F=u;C=u;a[C]=12;t=F+1|0;a[t]=a[12560]|0;a[t+1|0]=a[12561]|0;a[t+2|0]=a[12562]|0;a[t+3|0]=a[12563]|0;a[t+4|0]=a[12564]|0;a[t+5|0]=a[12565]|0;a[F+7|0]=0;F=v;t=g;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2];F=(z=0,at(54,u|0,b|0,e|0,f|0,v|0,h|0)|0);do{if(!z){h=E;v=E|0;c[v>>2]=17512;e=E+4|0;b=F+4|0;if((a[b]&1)==0){g=e;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2]}else{b=c[F+12>>2]|0;g=c[F+8>>2]|0;if(g>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=27;break}return 0}if(g>>>0<11>>>0){a[e]=g<<1;H=e+1|0}else{I=g+16&-16;J=(z=0,au(248,I|0)|0);if(z){z=0;G=27;break}c[E+12>>2]=J;c[e>>2]=I|1;c[E+8>>2]=g;H=J}LF(H|0,b|0,g)|0;a[H+g|0]=0}g=E+16|0;b=F+16|0;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[v>>2]=22848;a[E+28|0]=a[F+28|0]&1;a[h+29|0]=a[F+29|0]&1;c[E+32>>2]=c[F+32>>2];h=E+36|0;c[h>>2]=22672;b=E+40|0;z=0;as(698,b|0,F+40|0);if(z){z=0;g=bT(-1,-1)|0;J=M;c[v>>2]=17512;if((a[e]&1)==0){K=J;L=g;break}Lw(c[E+12>>2]|0);K=J;L=g;break}c[v>>2]=19592;c[h>>2]=19652;c[E+52>>2]=c[F+52>>2];v=E+56|0;a[v]=a[F+56|0]&1;if((a[C]&1)!=0){Lw(c[u+8>>2]|0)}g=h+8|0;J=h+4|0;h=c[J>>2]|0;e=(c[g>>2]|0)-h>>2;L30:do{if((e|0)==0){N=0}else{I=d|0;O=f;P=w;Q=w+8|0;R=f+8|0;S=f+4|0;T=w+1|0;U=w|0;V=w+4|0;W=0;X=0;Y=h;L32:while(1){Z=c[Y+(X<<2)>>2]|0;if((a[v]&1)==0){_=Z}else{_=c[Z+36>>2]|0}if((_|0)==0){G=37}else{Z=Lh(_,32360,31536,-1)|0;if((Z|0)==0){G=37}else{$=Z}}do{if((G|0)==37){G=0;Z=Lu(60)|0;c[s>>2]=Z;aa=c[B>>2]|0;if((aa|0)==(c[D>>2]|0)){e4(I,s);ab=c[s>>2]|0}else{if((aa|0)==0){ac=0}else{c[aa>>2]=Z;ac=c[B>>2]|0}c[B>>2]=ac+4;ab=Z}ad=ab;Z=ab;if((a[O]&1)==0){c[P>>2]=c[O>>2];c[P+4>>2]=c[O+4>>2];c[P+8>>2]=c[O+8>>2]}else{aa=c[R>>2]|0;ae=c[S>>2]|0;if(ae>>>0>4294967279>>>0){G=45;break L32}if(ae>>>0<11>>>0){a[P]=ae<<1;af=T}else{ag=ae+16&-16;ah=(z=0,au(248,ag|0)|0);if(z){z=0;G=64;break L32}c[Q>>2]=ah;c[U>>2]=ag|1;c[V>>2]=ae;af=ah}LF(af|0,aa|0,ae)|0;a[af+ae|0]=0}ae=r;c[ae>>2]=c[t>>2];c[ae+4>>2]=c[t+4>>2];c[ae+8>>2]=c[t+8>>2];z=0;aD(36,Z|0,w|0,r|0,1,0,0);if(z){z=0;G=67;break L32}if((a[P]&1)!=0){Lw(c[Q>>2]|0)}ae=ab+36|0;aa=ae;ah=c[(c[b>>2]|0)+(X<<2)>>2]|0;if((a[v]&1)==0){ai=ah}else{ai=c[ah+36>>2]|0}c[q>>2]=ai;ah=ae+8|0;ag=ah;aj=c[ag>>2]|0;if((aj|0)==(c[ae+12>>2]|0)){fq(ae+4|0,q);ak=c[q>>2]|0}else{if((aj|0)==0){al=0}else{c[aj>>2]=ai;al=c[ag>>2]|0}c[ah>>2]=al+4;ak=ai}cB[c[c[ae>>2]>>2]&1023](aa,ak);if((a[v]&1)==0){c[(c[J>>2]|0)+(X<<2)>>2]=ab;$=Z;break}else{c[(c[(c[J>>2]|0)+(X<<2)>>2]|0)+36>>2]=ab;$=Z;break}}}while(0);Z=(c[$+44>>2]|0)-(c[$+40>>2]|0)>>2;if((X|0)==0){am=Z}else{am=Z>>>0<W>>>0?Z:W}Z=X+1|0;if(Z>>>0>=e>>>0){N=am;break L30}W=am;X=Z;Y=c[b>>2]|0}do{if((G|0)==45){z=0;ar(86,0);if(!z){return 0}else{z=0;Y=bT(-1,-1)|0;an=M;ao=Y;G=66;break}}else if((G|0)==64){Y=bT(-1,-1)|0;an=M;ao=Y;G=66}else if((G|0)==67){Y=bT(-1,-1)|0;X=Y;Y=M;if((a[P]&1)==0){ap=X;aq=Y;break}Lw(c[Q>>2]|0);ap=X;aq=Y}}while(0);if((G|0)==66){ap=ao;aq=an}Q=c[d>>2]|0;P=c[B>>2]|0;Y=Q;while(1){if((Y|0)==(P|0)){av=P;break}if((c[Y>>2]|0)==(ab|0)){av=Y;break}else{Y=Y+4|0}}Y=av-Q>>2;X=Q+(Y+1<<2)|0;W=P-X|0;LG(Q+(Y<<2)|0,X|0,W|0)|0;X=Q+((W>>2)+Y<<2)|0;Y=c[B>>2]|0;if((X|0)!=(Y|0)){c[B>>2]=Y+(~((Y-4+(-X|0)|0)>>>2)<<2)}Lw(ad);aw=ap;ax=aq;ay=aw;az=0;aA=ay;aB=ax;bg(aA|0)}}while(0);e=Lu(60)|0;c[p>>2]=e;h=c[B>>2]|0;if((h|0)==(c[D>>2]|0)){e4(d|0,p);aC=c[p>>2]|0}else{if((h|0)==0){aE=0}else{c[h>>2]=e;aE=c[B>>2]|0}c[B>>2]=aE+4;aC=e}e=aC;h=f;L107:do{if((a[h]&1)==0){X=x;c[X>>2]=c[h>>2];c[X+4>>2]=c[h+4>>2];c[X+8>>2]=c[h+8>>2];G=95}else{X=c[f+8>>2]|0;Y=c[f+4>>2]|0;do{if(Y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Y>>>0<11>>>0){a[x]=Y<<1;aF=x+1|0}else{W=Y+16&-16;V=(z=0,au(248,W|0)|0);if(z){z=0;break}c[x+8>>2]=V;c[x>>2]=W|1;c[x+4>>2]=Y;aF=V}LF(aF|0,X|0,Y)|0;a[aF+Y|0]=0;G=95;break L107}}while(0);Y=bT(-1,-1)|0;aG=Y;aH=M}}while(0);do{if((G|0)==95){Y=o;c[Y>>2]=c[t>>2];c[Y+4>>2]=c[t+4>>2];c[Y+8>>2]=c[t+8>>2];z=0;aD(36,aC|0,x|0,o|0,N|0,1,0);if(z){z=0;Y=bT(-1,-1)|0;X=Y;Y=M;if((a[x]&1)==0){aG=X;aH=Y;break}Lw(c[x+8>>2]|0);aG=X;aH=Y;break}if((a[x]&1)!=0){Lw(c[x+8>>2]|0)}Y=(c[g>>2]|0)-(c[J>>2]|0)>>2;if((N|0)==0){aI=aC;i=j;return aI|0}X=d|0;Q=y;P=y+8|0;V=(Y|0)==0;W=aC+36|0;U=W;T=W+8|0;S=T;R=W+12|0;O=W+4|0;I=W;W=f+8|0;Z=f+4|0;aa=y+1|0;ae=y|0;ah=y+4|0;ag=0;while(1){aj=Lu(60)|0;c[n>>2]=aj;aJ=c[B>>2]|0;if((aJ|0)==(c[D>>2]|0)){e4(X,n);aK=c[n>>2]|0}else{if((aJ|0)==0){aL=0}else{c[aJ>>2]=aj;aL=c[B>>2]|0}c[B>>2]=aL+4;aK=aj}aM=aK;if((a[h]&1)==0){c[Q>>2]=c[h>>2];c[Q+4>>2]=c[h+4>>2];c[Q+8>>2]=c[h+8>>2]}else{aj=c[W>>2]|0;aJ=c[Z>>2]|0;if(aJ>>>0>4294967279>>>0){G=108;break}if(aJ>>>0<11>>>0){a[Q]=aJ<<1;aN=aa}else{aO=aJ+16&-16;aP=(z=0,au(248,aO|0)|0);if(z){z=0;G=137;break}c[P>>2]=aP;c[ae>>2]=aO|1;c[ah>>2]=aJ;aN=aP}LF(aN|0,aj|0,aJ)|0;a[aN+aJ|0]=0}aJ=m;c[aJ>>2]=c[t>>2];c[aJ+4>>2]=c[t+4>>2];c[aJ+8>>2]=c[t+8>>2];z=0;aD(36,aK|0,y|0,m|0,Y|0,0,0);if(z){z=0;G=140;break}if((a[Q]&1)!=0){Lw(c[P>>2]|0)}if(!V){aJ=aK+36|0;aj=aJ;aP=aJ+8|0;aO=aP;aQ=aJ+12|0;aR=aJ+4|0;aS=aJ;aJ=0;do{aT=c[(c[b>>2]|0)+(aJ<<2)>>2]|0;if((a[v]&1)==0){aU=aT}else{aU=c[aT+36>>2]|0}aT=c[(c[aU+40>>2]|0)+(ag<<2)>>2]|0;c[l>>2]=aT;aV=c[aO>>2]|0;if((aV|0)==(c[aQ>>2]|0)){fq(aR,l);aW=c[l>>2]|0}else{if((aV|0)==0){aX=0}else{c[aV>>2]=aT;aX=c[aO>>2]|0}c[aP>>2]=aX+4;aW=aT}cB[c[c[aS>>2]>>2]&1023](aj,aW);aJ=aJ+1|0;}while(aJ>>>0<Y>>>0)}aJ=aK;c[k>>2]=aJ;aj=c[S>>2]|0;if((aj|0)==(c[R>>2]|0)){fq(O,k);aY=c[k>>2]|0}else{if((aj|0)==0){aZ=0}else{c[aj>>2]=aJ;aZ=c[S>>2]|0}c[T>>2]=aZ+4;aY=aJ}cB[c[c[I>>2]>>2]&1023](U,aY);aJ=ag+1|0;if(aJ>>>0<N>>>0){ag=aJ}else{G=156;break}}do{if((G|0)==108){z=0;ar(86,0);if(!z){return 0}else{z=0;ag=bT(-1,-1)|0;a_=M;a$=ag;G=139;break}}else if((G|0)==156){aI=aC;i=j;return aI|0}else if((G|0)==140){ag=bT(-1,-1)|0;U=ag;ag=M;if((a[Q]&1)==0){a0=U;a1=ag;break}Lw(c[P>>2]|0);a0=U;a1=ag}else if((G|0)==137){ag=bT(-1,-1)|0;a_=M;a$=ag;G=139}}while(0);if((G|0)==139){a0=a$;a1=a_}P=c[d>>2]|0;Q=c[B>>2]|0;ag=P;while(1){if((ag|0)==(Q|0)){a2=Q;break}if((c[ag>>2]|0)==(aK|0)){a2=ag;break}else{ag=ag+4|0}}ag=a2-P>>2;U=P+(ag+1<<2)|0;I=Q-U|0;LG(P+(ag<<2)|0,U|0,I|0)|0;U=P+((I>>2)+ag<<2)|0;ag=c[B>>2]|0;if((U|0)!=(ag|0)){c[B>>2]=ag+(~((ag-4+(-U|0)|0)>>>2)<<2)}Lw(aM);aw=a0;ax=a1;ay=aw;az=0;aA=ay;aB=ax;bg(aA|0)}}while(0);v=c[d>>2]|0;b=c[B>>2]|0;h=v;while(1){if((h|0)==(b|0)){a3=b;break}if((c[h>>2]|0)==(aC|0)){a3=h;break}else{h=h+4|0}}h=a3-v>>2;J=v+(h+1<<2)|0;g=b-J|0;LG(v+(h<<2)|0,J|0,g|0)|0;J=v+((g>>2)+h<<2)|0;h=c[B>>2]|0;if((J|0)!=(h|0)){c[B>>2]=h+(~((h-4+(-J|0)|0)>>>2)<<2)}Lw(e);aw=aG;ax=aH;ay=aw;az=0;aA=ay;aB=ax;bg(aA|0)}else{z=0;G=27}}while(0);if((G|0)==27){G=bT(-1,-1)|0;K=M;L=G}G=L;L=K;if((a[C]&1)!=0){Lw(c[u+8>>2]|0)}u=c[d>>2]|0;d=c[B>>2]|0;C=u;while(1){if((C|0)==(d|0)){a4=d;break}if((c[C>>2]|0)==(E|0)){a4=C;break}else{C=C+4|0}}C=a4-u>>2;a4=u+(C+1<<2)|0;E=d-a4|0;LG(u+(C<<2)|0,a4|0,E|0)|0;a4=u+((E>>2)+C<<2)|0;C=c[B>>2]|0;if((a4|0)!=(C|0)){c[B>>2]=C+(~((C-4+(-a4|0)|0)>>>2)<<2)}Lw(A);aw=G;ax=L;ay=aw;az=0;aA=ay;aB=ax;bg(aA|0);return 0}function re(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;j=i;i=i+128|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;o=j+48|0;p=j+56|0;q=j+64|0;r=j+80|0;s=j+96|0;t=j+112|0;u=q;a[u]=14;v=q+1|0;a[v]=a[12352]|0;a[v+1|0]=a[12353]|0;a[v+2|0]=a[12354]|0;a[v+3|0]=a[12355]|0;a[v+4|0]=a[12356]|0;a[v+5|0]=a[12357]|0;a[v+6|0]=a[12358]|0;v=q+8|0;a[v]=0;w=r;x=g;c[w>>2]=c[x>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];w=(z=0,at(54,q|0,b|0,e|0,f|0,r|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;r=h;h=M;if((a[u]&1)==0){y=r;A=h;B=y;C=0;D=B;E=A;bg(D|0)}Lw(c[v>>2]|0);y=r;A=h;B=y;C=0;D=B;E=A;bg(D|0)}if((a[u]&1)!=0){Lw(c[v>>2]|0)}v=c[w+40>>2]|0;L11:do{if(((c[w+44>>2]|0)-v|0)==4){u=c[v>>2]|0;if((a[w+56|0]&1)==0){F=u}else{F=c[u+36>>2]|0}do{if((F|0)!=0){u=Lh(F,32360,31536,-1)|0;if((u|0)==0){break}G=u;H=c[u+52>>2]|0;break L11}}while(0);u=Lu(60)|0;c[o>>2]=u;h=d+4|0;r=c[h>>2]|0;if((r|0)==(c[d+8>>2]|0)){e4(d|0,o);I=c[o>>2]|0}else{if((r|0)==0){J=0}else{c[r>>2]=u;J=c[h>>2]|0}c[h>>2]=J+4;I=u}u=I;r=f;L27:do{if((a[r]&1)==0){e=s;c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];K=26}else{e=c[f+8>>2]|0;b=c[f+4>>2]|0;do{if(b>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(b>>>0<11>>>0){a[s]=b<<1;L=s+1|0}else{q=b+16&-16;g=(z=0,au(248,q|0)|0);if(z){z=0;break}c[s+8>>2]=g;c[s>>2]=q|1;c[s+4>>2]=b;L=g}LF(L|0,e|0,b)|0;a[L+b|0]=0;K=26;break L27}}while(0);b=bT(-1,-1)|0;N=b;O=M}}while(0);do{if((K|0)==26){r=n;c[r>>2]=c[x>>2];c[r+4>>2]=c[x+4>>2];c[r+8>>2]=c[x+8>>2];z=0;aD(36,I|0,s|0,n|0,1,1,0);if(z){z=0;r=bT(-1,-1)|0;b=r;r=M;if((a[s]&1)==0){N=b;O=r;break}Lw(c[s+8>>2]|0);N=b;O=r;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}r=I+36|0;b=r;c[m>>2]=F;e=r+8|0;g=e;q=c[g>>2]|0;if((q|0)==(c[r+12>>2]|0)){fq(r+4|0,m);P=c[m>>2]|0}else{if((q|0)==0){Q=0}else{c[q>>2]=F;Q=c[g>>2]|0}c[e>>2]=Q+4;P=F}cB[c[c[r>>2]>>2]&1023](b,P);R=u;S=R;i=j;return S|0}}while(0);b=c[d>>2]|0;r=c[h>>2]|0;e=b;while(1){if((e|0)==(r|0)){T=r;break}if((c[e>>2]|0)==(I|0)){T=e;break}else{e=e+4|0}}e=T-b>>2;g=b+(e+1<<2)|0;q=r-g|0;LG(b+(e<<2)|0,g|0,q|0)|0;g=b+((q>>2)+e<<2)|0;e=c[h>>2]|0;if((g|0)!=(e|0)){c[h>>2]=e+(~((e-4+(-g|0)|0)>>>2)<<2)}Lw(u);y=N;A=O;B=y;C=0;D=B;E=A;bg(D|0)}else{G=w;H=1}}while(0);w=Lu(60)|0;c[l>>2]=w;O=d+4|0;N=c[O>>2]|0;if((N|0)==(c[d+8>>2]|0)){e4(d|0,l);U=c[l>>2]|0}else{if((N|0)==0){V=0}else{c[N>>2]=w;V=c[O>>2]|0}c[O>>2]=V+4;U=w}w=U;V=f;L74:do{if((a[V]&1)==0){N=t;c[N>>2]=c[V>>2];c[N+4>>2]=c[V+4>>2];c[N+8>>2]=c[V+8>>2];K=60}else{N=c[f+8>>2]|0;l=c[f+4>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(l>>>0<11>>>0){a[t]=l<<1;W=t+1|0}else{T=l+16&-16;I=(z=0,au(248,T|0)|0);if(z){z=0;break}c[t+8>>2]=I;c[t>>2]=T|1;c[t+4>>2]=l;W=I}LF(W|0,N|0,l)|0;a[W+l|0]=0;K=60;break L74}}while(0);l=bT(-1,-1)|0;X=l;Y=M}}while(0);do{if((K|0)==60){W=k;c[W>>2]=c[x>>2];c[W+4>>2]=c[x+4>>2];c[W+8>>2]=c[x+8>>2];z=0;aD(36,U|0,t|0,k|0,0,H|0,0);if(z){z=0;W=bT(-1,-1)|0;f=W;W=M;if((a[t]&1)==0){X=f;Y=W;break}Lw(c[t+8>>2]|0);X=f;Y=W;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}W=G+40|0;f=c[W>>2]|0;V=(c[G+44>>2]|0)-f>>2;if((V|0)==0){R=w;S=R;i=j;return S|0}l=G+56|0;N=U+36|0;u=N;h=N+8|0;b=h;r=N+12|0;I=N+4|0;T=N;N=0;P=f;while(1){f=c[P+(N<<2)>>2]|0;if((a[l]&1)==0){Z=f}else{Z=c[f+36>>2]|0}do{if((Z|0)==0){K=79}else{f=Lh(Z,32360,31304,-1)|0;if((f|0)==0){K=79;break}if((a[f+36|0]&1)!=0){K=79}}}while(0);if((K|0)==79){K=0;f=c[(c[W>>2]|0)+(N<<2)>>2]|0;if((a[l]&1)==0){_=f}else{_=c[f+36>>2]|0}c[p>>2]=_;f=c[b>>2]|0;if((f|0)==(c[r>>2]|0)){fq(I,p);$=c[p>>2]|0}else{if((f|0)==0){aa=0}else{c[f>>2]=_;aa=c[b>>2]|0}c[h>>2]=aa+4;$=_}cB[c[c[T>>2]>>2]&1023](u,$)}f=N+1|0;if(f>>>0>=V>>>0){R=w;break}N=f;P=c[W>>2]|0}S=R;i=j;return S|0}}while(0);S=c[d>>2]|0;d=c[O>>2]|0;j=S;while(1){if((j|0)==(d|0)){ab=d;break}if((c[j>>2]|0)==(U|0)){ab=j;break}else{j=j+4|0}}j=ab-S>>2;ab=S+(j+1<<2)|0;U=d-ab|0;LG(S+(j<<2)|0,ab|0,U|0)|0;ab=S+((U>>2)+j<<2)|0;j=c[O>>2]|0;if((ab|0)!=(j|0)){c[O>>2]=j+(~((j-4+(-ab|0)|0)>>>2)<<2)}Lw(w);y=X;A=Y;B=y;C=0;D=B;E=A;bg(D|0);return 0}function rf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;j=i;i=i+200|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+48|0;p=j+64|0;q=j+80|0;r=j+88|0;s=j+104|0;t=j+120|0;u=j+136|0;v=j+152|0;w=j+168|0;x=j+184|0;y=o;A=o;a[A]=12;B=y+1|0;a[B]=a[1808]|0;a[B+1|0]=a[1809]|0;a[B+2|0]=a[1810]|0;a[B+3|0]=a[1811]|0;a[B+4|0]=a[1812]|0;a[B+5|0]=a[1813]|0;a[y+7|0]=0;y=p;B=g;c[y>>2]=c[B>>2];c[y+4>>2]=c[B+4>>2];c[y+8>>2]=c[B+8>>2];y=(z=0,at(118,o|0,b|0,e|0,f|0,p|0,h|0)|0);if(z){z=0;p=bT(-1,-1)|0;g=p;p=M;if((a[A]&1)==0){C=p;D=g;E=D;F=0;G=E;H=C;bg(G|0)}Lw(c[o+8>>2]|0);C=p;D=g;E=D;F=0;G=E;H=C;bg(G|0)}if((a[A]&1)!=0){Lw(c[o+8>>2]|0)}L11:do{if((c[y+32>>2]|0)==4){Bv(q,0);z=0;aR(c[(c[y>>2]|0)+28>>2]|0,r|0,y|0,q|0);L13:do{if(!z){L16:do{if((j$(d+160|0,r)|0)==0){I=0;J=0}else{o=(z=0,au(248,52)|0);do{if(!z){A=o;c[n>>2]=A;g=d+4|0;p=c[g>>2]|0;if((p|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,n|0);if(z){z=0;K=31;break}L=c[n>>2]|0}else{if((p|0)==0){N=0}else{c[p>>2]=A;N=c[g>>2]|0}c[g>>2]=N+4;L=A}A=L;p=f;L28:do{if((a[p]&1)==0){O=s;c[O>>2]=c[p>>2];c[O+4>>2]=c[p+4>>2];c[O+8>>2]=c[p+8>>2];K=24}else{O=c[f+8>>2]|0;P=c[f+4>>2]|0;do{if(P>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(P>>>0<11>>>0){a[s]=P<<1;Q=s+1|0}else{R=P+16&-16;S=(z=0,au(248,R|0)|0);if(z){z=0;break}c[s+8>>2]=S;c[s>>2]=R|1;c[s+4>>2]=P;Q=S}LF(Q|0,O|0,P)|0;a[Q+P|0]=0;K=24;break L28}}while(0);P=bT(-1,-1)|0;T=M;U=P}}while(0);do{if((K|0)==24){p=m;c[p>>2]=c[B>>2];c[p+4>>2]=c[B+4>>2];c[p+8>>2]=c[B+8>>2];z=0;aq(38,L|0,s|0,m|0,12168,0);if(z){z=0;p=bT(-1,-1)|0;P=p;p=M;if((a[s]&1)==0){T=p;U=P;break}Lw(c[s+8>>2]|0);T=p;U=P;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}I=1;J=L;break L16}}while(0);P=c[d>>2]|0;p=c[g>>2]|0;O=P;while(1){if((O|0)==(p|0)){V=p;break}if((c[O>>2]|0)==(L|0)){V=O;break}else{O=O+4|0}}O=V-P>>2;S=P+(O+1<<2)|0;R=p-S|0;LG(P+(O<<2)|0,S|0,R|0)|0;S=P+((R>>2)+O<<2)|0;O=c[g>>2]|0;if((S|0)!=(O|0)){c[g>>2]=O+(~((O-4+(-S|0)|0)>>>2)<<2)}Lw(A);W=T;X=U}else{z=0;K=31}}while(0);if((K|0)==31){o=bT(-1,-1)|0;W=M;X=o}if((a[r]&1)==0){Y=W;Z=X;break L13}Lw(c[r+8>>2]|0);Y=W;Z=X;break L13}}while(0);if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}Bx(q);if((I|0)==1){_=J}else{break L11}i=j;return _|0}else{z=0;o=bT(-1,-1)|0;Y=M;Z=o}}while(0);z=0;ar(444,q|0);if(!z){C=Y;D=Z;E=D;F=0;G=E;H=C;bg(G|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);Z=Lu(52)|0;c[l>>2]=Z;Y=d+4|0;q=c[Y>>2]|0;if((q|0)==(c[d+8>>2]|0)){e4(d|0,l);$=c[l>>2]|0}else{if((q|0)==0){aa=0}else{c[q>>2]=Z;aa=c[Y>>2]|0}c[Y>>2]=aa+4;$=Z}Z=$;aa=$;q=f;L79:do{if((a[q]&1)==0){l=t;c[l>>2]=c[q>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];K=62}else{l=c[f+8>>2]|0;J=c[f+4>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(J>>>0<11>>>0){a[t]=J<<1;ab=t+1|0}else{I=J+16&-16;r=(z=0,au(248,I|0)|0);if(z){z=0;break}c[t+8>>2]=r;c[t>>2]=I|1;c[t+4>>2]=J;ab=r}LF(ab|0,l|0,J)|0;a[ab+J|0]=0;K=62;break L79}}while(0);J=bT(-1,-1)|0;ac=M;ad=J}}while(0);do{if((K|0)==62){ab=u;c[ab>>2]=c[B>>2];c[ab+4>>2]=c[B+4>>2];c[ab+8>>2]=c[B+8>>2];q=w;J=w;a[J]=12;l=q+1|0;a[l]=a[1808]|0;a[l+1|0]=a[1809]|0;a[l+2|0]=a[1810]|0;a[l+3|0]=a[1811]|0;a[l+4|0]=a[1812]|0;a[l+5|0]=a[1813]|0;a[q+7|0]=0;q=x;c[q>>2]=c[B>>2];c[q+4>>2]=c[B+4>>2];c[q+8>>2]=c[B+8>>2];q=(z=0,at(118,w|0,b|0,e|0,f|0,x|0,h|0)|0);do{if(!z){z=0;as(c[(c[q>>2]|0)+40>>2]|0,v|0,q|0);if(z){z=0;K=72;break}l=k;c[l>>2]=c[ab>>2];c[l+4>>2]=c[ab+4>>2];c[l+8>>2]=c[ab+8>>2];z=0;aq(28,aa|0,t|0,k|0,v|0,0);if(z){z=0;l=bT(-1,-1)|0;r=l;l=M;if((a[v]&1)==0){ae=l;af=r;break}Lw(c[v+8>>2]|0);ae=l;af=r;break}r=$;if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}if((a[J]&1)!=0){Lw(c[w+8>>2]|0)}if((a[t]&1)==0){_=r;i=j;return _|0}Lw(c[t+8>>2]|0);_=r;i=j;return _|0}else{z=0;K=72}}while(0);if((K|0)==72){ab=bT(-1,-1)|0;ae=M;af=ab}if((a[J]&1)!=0){Lw(c[w+8>>2]|0)}if((a[t]&1)==0){ac=ae;ad=af;break}Lw(c[t+8>>2]|0);ac=ae;ad=af}}while(0);af=c[d>>2]|0;d=c[Y>>2]|0;ae=af;while(1){if((ae|0)==(d|0)){ag=d;break}if((c[ae>>2]|0)==($|0)){ag=ae;break}else{ae=ae+4|0}}ae=ag-af>>2;ag=af+(ae+1<<2)|0;$=d-ag|0;LG(af+(ae<<2)|0,ag|0,$|0)|0;ag=af+(($>>2)+ae<<2)|0;ae=c[Y>>2]|0;if((ag|0)!=(ae|0)){c[Y>>2]=ae+(~((ae-4+(-ag|0)|0)>>>2)<<2)}Lw(Z);C=ac;D=ad;E=D;F=0;G=E;H=C;bg(G|0);return 0}function rg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;j=i;i=i+120|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+88|0;r=j+104|0;s=Lu(52)|0;c[l>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){e4(d|0,l);v=c[l>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){l=m;c[l>>2]=c[u>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];x=16}else{l=c[f+8>>2]|0;y=c[f+4>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[m]=y<<1;A=m+1|0}else{B=y+16&-16;C=(z=0,au(248,B|0)|0);if(z){z=0;break}c[m+8>>2]=C;c[m>>2]=B|1;c[m+4>>2]=y;A=C}LF(A|0,l|0,y)|0;a[A+y|0]=0;x=16;break L8}}while(0);y=bT(-1,-1)|0;D=M;E=y}}while(0);do{if((x|0)==16){A=n;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];y=q;a[y]=14;l=q+1|0;a[l]=a[12088]|0;a[l+1|0]=a[12089]|0;a[l+2|0]=a[12090]|0;a[l+3|0]=a[12091]|0;a[l+4|0]=a[12092]|0;a[l+5|0]=a[12093]|0;a[l+6|0]=a[12094]|0;l=q+8|0;a[l]=0;C=r;c[C>>2]=c[u>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];u=(z=0,at(44,q|0,b|0,e|0,f|0,r|0,h|0)|0);do{if(!z){z=0;as(248,p|0,u|0);if(z){z=0;x=30;break}z=0;aR(286,o|0,p|0,34);do{if(!z){C=k;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];z=0;aq(28,w|0,m|0,k|0,o|0,0);if(z){z=0;C=bT(-1,-1)|0;B=C;C=M;if((a[o]&1)==0){F=C;G=B;break}Lw(c[o+8>>2]|0);F=C;G=B;break}B=v;if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if((a[y]&1)!=0){Lw(c[l>>2]|0)}if((a[m]&1)==0){i=j;return B|0}Lw(c[m+8>>2]|0);i=j;return B|0}else{z=0;B=bT(-1,-1)|0;F=M;G=B}}while(0);if((a[p]&1)==0){H=F;I=G;break}Lw(c[p+8>>2]|0);H=F;I=G}else{z=0;x=30}}while(0);if((x|0)==30){A=bT(-1,-1)|0;H=M;I=A}if((a[y]&1)!=0){Lw(c[l>>2]|0)}if((a[m]&1)==0){D=H;E=I;break}Lw(c[m+8>>2]|0);D=H;E=I}}while(0);I=c[d>>2]|0;d=c[t>>2]|0;H=I;while(1){if((H|0)==(d|0)){J=d;break}if((c[H>>2]|0)==(v|0)){J=H;break}else{H=H+4|0}}H=J-I>>2;J=I+(H+1<<2)|0;v=d-J|0;LG(I+(H<<2)|0,J|0,v|0)|0;J=I+((v>>2)+H<<2)|0;H=c[t>>2]|0;if((J|0)==(H|0)){Lw(s);K=E;L=0;N=K;O=D;bg(N|0)}c[t>>2]=H+(~((H-4+(-J|0)|0)>>>2)<<2);Lw(s);K=E;L=0;N=K;O=D;bg(N|0);return 0}function rh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=i;i=i+72|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+40|0;o=j+56|0;p=Lu(40)|0;c[k>>2]=p;q=d+4|0;r=c[q>>2]|0;if((r|0)==(c[d+8>>2]|0)){e4(d|0,k);s=c[k>>2]|0}else{if((r|0)==0){t=0}else{c[r>>2]=p;t=c[q>>2]|0}c[q>>2]=t+4;s=p}p=s;t=s;r=f;L8:do{if((a[r]&1)==0){k=l;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];u=16}else{k=c[f+8>>2]|0;v=c[f+4>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(v>>>0<11>>>0){a[l]=v<<1;w=l+1|0}else{x=v+16&-16;y=(z=0,au(248,x|0)|0);if(z){z=0;break}c[l+8>>2]=y;c[l>>2]=x|1;c[l+4>>2]=v;w=y}LF(w|0,k|0,v)|0;a[w+v|0]=0;u=16;break L8}}while(0);v=bT(-1,-1)|0;A=M;B=v}}while(0);do{if((u|0)==16){w=m;r=g;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];w=n;a[w]=14;v=n+1|0;a[v]=a[12088]|0;a[v+1|0]=a[12089]|0;a[v+2|0]=a[12090]|0;a[v+3|0]=a[12091]|0;a[v+4|0]=a[12092]|0;a[v+5|0]=a[12093]|0;a[v+6|0]=a[12094]|0;v=n+8|0;a[v]=0;k=o;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];r=(z=0,at(44,n|0,b|0,e|0,f|0,o|0,h|0)|0);do{if(!z){if((c[r+48>>2]|0)==(c[r+52>>2]|0)){C=(c[r+60>>2]|0)==(c[r+64>>2]|0)}else{C=0}z=0;aV(4,t|0,l|0,m|0,C|0);if(z){z=0;break}k=s;if((a[w]&1)!=0){Lw(c[v>>2]|0)}if((a[l]&1)==0){i=j;return k|0}Lw(c[l+8>>2]|0);i=j;return k|0}else{z=0}}while(0);r=bT(-1,-1)|0;k=r;r=M;if((a[w]&1)!=0){Lw(c[v>>2]|0)}if((a[l]&1)==0){A=r;B=k;break}Lw(c[l+8>>2]|0);A=r;B=k}}while(0);l=c[d>>2]|0;d=c[q>>2]|0;j=l;while(1){if((j|0)==(d|0)){D=d;break}if((c[j>>2]|0)==(s|0)){D=j;break}else{j=j+4|0}}j=D-l>>2;D=l+(j+1<<2)|0;s=d-D|0;LG(l+(j<<2)|0,D|0,s|0)|0;D=l+((s>>2)+j<<2)|0;j=c[q>>2]|0;if((D|0)==(j|0)){Lw(p);E=B;F=0;G=E;H=A;bg(G|0)}c[q>>2]=j+(~((j-4+(-D|0)|0)>>>2)<<2);Lw(p);E=B;F=0;G=E;H=A;bg(G|0);return 0}function ri(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0;j=i;i=i+264|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+16|0;n=j+32|0;o=j+48|0;p=j+64|0;q=j+80|0;r=j+96|0;s=j+112|0;t=j+184|0;u=j+200|0;v=j+216|0;w=j+232|0;x=j+248|0;y=m;A=m;a[A]=18;LF(y+1|0,11816,9)|0;a[y+10|0]=0;y=n;B=g;c[y>>2]=c[B>>2];c[y+4>>2]=c[B+4>>2];c[y+8>>2]=c[B+8>>2];y=(z=0,at(44,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(z){z=0;n=bT(-1,-1)|0;g=n;n=M;if((a[A]&1)==0){C=n;D=g;E=D;F=0;G=E;H=C;bg(G|0)}Lw(c[m+8>>2]|0);C=n;D=g;E=D;F=0;G=E;H=C;bg(G|0)}if((a[A]&1)!=0){Lw(c[m+8>>2]|0)}m=o;A=o;a[A]=18;LF(m+1|0,11760,9)|0;a[m+10|0]=0;m=p;c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];m=(z=0,at(44,o|0,b|0,e|0,f|0,p|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;p=h;h=M;if((a[A]&1)==0){C=h;D=p;E=D;F=0;G=E;H=C;bg(G|0)}Lw(c[o+8>>2]|0);C=h;D=p;E=D;F=0;G=E;H=C;bg(G|0)}if((a[A]&1)!=0){Lw(c[o+8>>2]|0)}if((c[y+48>>2]|0)==(c[y+52>>2]|0)){if((c[y+60>>2]|0)!=(c[y+64>>2]|0)){I=9}}else{I=9}do{if((I|0)==9){if((c[m+48>>2]|0)==(c[m+52>>2]|0)){if((c[m+60>>2]|0)==(c[m+64>>2]|0)){break}}lG(s,m);z=0;as(328,t|0,y|0);do{if(!z){z=0;as(774,s|0,t|0);if(z){z=0;o=bT(-1,-1)|0;A=o;o=M;if((a[t]&1)==0){J=o;K=A;break}Lw(c[t+8>>2]|0);J=o;K=A;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}A=(z=0,au(248,40)|0);if(z){z=0;I=91;break}o=A;c[k>>2]=o;A=d+4|0;p=c[A>>2]|0;if((p|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,k|0);if(z){z=0;I=91;break}L=c[k>>2]|0}else{if((p|0)==0){N=0}else{c[p>>2]=o;N=c[A>>2]|0}c[A>>2]=N+4;L=o}o=L;p=L;h=f;L46:do{if((a[h]&1)==0){e=u;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];I=63}else{e=c[f+8>>2]|0;b=c[f+4>>2]|0;do{if(b>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(b>>>0<11>>>0){a[u]=b<<1;O=u+1|0}else{g=b+16&-16;n=(z=0,au(248,g|0)|0);if(z){z=0;break}c[u+8>>2]=n;c[u>>2]=g|1;c[u+4>>2]=b;O=n}LF(O|0,e|0,b)|0;a[O+b|0]=0;I=63;break L46}}while(0);b=bT(-1,-1)|0;P=M;Q=b}}while(0);do{if((I|0)==63){h=v;c[h>>2]=c[B>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2];z=0;as(248,w|0,y|0);do{if(!z){z=0;as(248,x|0,s|0);do{if(!z){h=w;b=a[w]|0;e=b&255;if((e&1|0)==0){R=e>>>1}else{R=c[w+4>>2]|0}e=x;n=a[x]|0;g=n&255;if((g&1|0)==0){S=g>>>1}else{S=c[x+4>>2]|0}L73:do{if((R|0)==(S|0)){g=(b&1)==0;if(g){T=h+1|0}else{T=c[w+8>>2]|0}if((n&1)==0){U=e+1|0}else{U=c[x+8>>2]|0}if(!g){V=(LH(T|0,U|0,R|0)|0)==0;break}if((R|0)==0){V=1;break}else{W=U;X=T;Y=R}while(1){if((a[X]|0)!=(a[W]|0)){V=0;break L73}g=Y-1|0;if((g|0)==0){V=1;break}else{W=W+1|0;X=X+1|0;Y=g}}}else{V=0}}while(0);z=0;aV(4,p|0,u|0,v|0,V|0);if(z){z=0;e=bT(-1,-1)|0;h=e;e=M;if((n&1)==0){Z=e;_=h;$=b;break}Lw(c[x+8>>2]|0);Z=e;_=h;$=b;break}if((n&1)!=0){Lw(c[x+8>>2]|0)}if((b&1)!=0){Lw(c[w+8>>2]|0)}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}ke(s);aa=o;ab=aa;i=j;return ab|0}else{z=0;h=bT(-1,-1)|0;Z=M;_=h;$=a[w]|0}}while(0);if(($&1)==0){ac=Z;ad=_;break}Lw(c[w+8>>2]|0);ac=Z;ad=_}else{z=0;h=bT(-1,-1)|0;ac=M;ad=h}}while(0);if((a[u]&1)==0){P=ac;Q=ad;break}Lw(c[u+8>>2]|0);P=ac;Q=ad}}while(0);p=c[d>>2]|0;h=c[A>>2]|0;e=p;while(1){if((e|0)==(h|0)){ae=h;break}if((c[e>>2]|0)==(L|0)){ae=e;break}else{e=e+4|0}}e=ae-p>>2;g=p+(e+1<<2)|0;af=h-g|0;LG(p+(e<<2)|0,g|0,af|0)|0;g=p+((af>>2)+e<<2)|0;e=c[A>>2]|0;if((g|0)!=(e|0)){c[A>>2]=e+(~((e-4+(-g|0)|0)>>>2)<<2)}Lw(o);J=P;K=Q}else{z=0;I=91}}while(0);if((I|0)==91){g=bT(-1,-1)|0;J=M;K=g}z=0;ar(494,s|0);if(!z){C=J;D=K;E=D;F=0;G=E;H=C;bg(G|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);K=Lu(40)|0;c[l>>2]=K;J=d+4|0;s=c[J>>2]|0;if((s|0)==(c[d+8>>2]|0)){e4(d|0,l);ag=c[l>>2]|0}else{if((s|0)==0){ah=0}else{c[s>>2]=K;ah=c[J>>2]|0}c[J>>2]=ah+4;ag=K}K=ag;ah=f;L132:do{if((a[ah]&1)==0){s=q;c[s>>2]=c[ah>>2];c[s+4>>2]=c[ah+4>>2];c[s+8>>2]=c[ah+8>>2];I=26}else{s=c[f+8>>2]|0;l=c[f+4>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(l>>>0<11>>>0){a[q]=l<<1;ai=q+1|0}else{Q=l+16&-16;P=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[q+8>>2]=P;c[q>>2]=Q|1;c[q+4>>2]=l;ai=P}LF(ai|0,s|0,l)|0;a[ai+l|0]=0;I=26;break L132}}while(0);l=bT(-1,-1)|0;aj=M;ak=l}}while(0);do{if((I|0)==26){ai=r;c[ai>>2]=c[B>>2];c[ai+4>>2]=c[B+4>>2];c[ai+8>>2]=c[B+8>>2];z=0;aV(4,ag|0,q|0,r|0,1);if(z){z=0;ai=bT(-1,-1)|0;f=ai;ai=M;if((a[q]&1)==0){aj=ai;ak=f;break}Lw(c[q+8>>2]|0);aj=ai;ak=f;break}if((a[q]&1)==0){aa=K;ab=aa;i=j;return ab|0}Lw(c[q+8>>2]|0);aa=K;ab=aa;i=j;return ab|0}}while(0);ab=c[d>>2]|0;d=c[J>>2]|0;j=ab;while(1){if((j|0)==(d|0)){al=d;break}if((c[j>>2]|0)==(ag|0)){al=j;break}else{j=j+4|0}}j=al-ab>>2;al=ab+(j+1<<2)|0;ag=d-al|0;LG(ab+(j<<2)|0,al|0,ag|0)|0;al=ab+((ag>>2)+j<<2)|0;j=c[J>>2]|0;if((al|0)!=(j|0)){c[J>>2]=j+(~((j-4+(-al|0)|0)>>>2)<<2)}Lw(K);C=aj;D=ak;E=D;F=0;G=E;H=C;bg(G|0);return 0}function rj(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+72|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+40|0;o=j+56|0;p=Lu(40)|0;c[k>>2]=p;q=d+4|0;r=c[q>>2]|0;if((r|0)==(c[d+8>>2]|0)){e4(d|0,k);s=c[k>>2]|0}else{if((r|0)==0){t=0}else{c[r>>2]=p;t=c[q>>2]|0}c[q>>2]=t+4;s=p}p=s;t=s;r=f;L8:do{if((a[r]&1)==0){k=l;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];u=16}else{k=c[f+8>>2]|0;v=c[f+4>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(v>>>0<11>>>0){a[l]=v<<1;w=l+1|0}else{x=v+16&-16;y=(z=0,au(248,x|0)|0);if(z){z=0;break}c[l+8>>2]=y;c[l>>2]=x|1;c[l+4>>2]=v;w=y}LF(w|0,k|0,v)|0;a[w+v|0]=0;u=16;break L8}}while(0);v=bT(-1,-1)|0;A=M;B=v}}while(0);do{if((u|0)==16){w=m;r=g;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];w=n;v=n;a[v]=12;k=w+1|0;a[k]=a[1808]|0;a[k+1|0]=a[1809]|0;a[k+2|0]=a[1810]|0;a[k+3|0]=a[1811]|0;a[k+4|0]=a[1812]|0;a[k+5|0]=a[1813]|0;a[w+7|0]=0;w=o;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];r=(z=0,at(118,n|0,b|0,e|0,f|0,o|0,h|0)|0);do{if(!z){w=(z=0,au(c[(c[r>>2]|0)+48>>2]|0,r|0)|0);if(z){z=0;break}z=0;aV(4,t|0,l|0,m|0,w|0);if(z){z=0;break}w=s;if((a[v]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)==0){i=j;return w|0}Lw(c[l+8>>2]|0);i=j;return w|0}else{z=0}}while(0);r=bT(-1,-1)|0;w=r;r=M;if((a[v]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)==0){A=r;B=w;break}Lw(c[l+8>>2]|0);A=r;B=w}}while(0);l=c[d>>2]|0;d=c[q>>2]|0;n=l;while(1){if((n|0)==(d|0)){C=d;break}if((c[n>>2]|0)==(s|0)){C=n;break}else{n=n+4|0}}n=C-l>>2;C=l+(n+1<<2)|0;s=d-C|0;LG(l+(n<<2)|0,C|0,s|0)|0;C=l+((s>>2)+n<<2)|0;n=c[q>>2]|0;if((C|0)==(n|0)){Lw(p);D=B;E=0;F=D;G=A;bg(F|0)}c[q>>2]=n+(~((n-4+(-C|0)|0)>>>2)<<2);Lw(p);D=B;E=0;F=D;G=A;bg(F|0);return 0}function rk(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;d=i;i=i+96|0;j=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=d|0;k=d+16|0;l=d+32|0;m=d+48|0;n=d+64|0;o=d+80|0;p=j;q=j;a[q]=20;LF(p+1|0,11528,10)|0;a[p+11|0]=0;p=k;r=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];p=(z=0,at(118,j|0,b|0,e|0,f|0,k|0,h|0)|0);L1:do{if(!z){k=(z=0,au(c[(c[p>>2]|0)+48>>2]|0,p|0)|0);if(z){z=0;s=13;break}do{if(k){g=l;t=l;a[t]=18;LF(g+1|0,11464,9)|0;a[g+10|0]=0;g=m;c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];g=(z=0,at(118,l|0,b|0,e|0,f|0,m|0,h|0)|0);if(!z){if((a[t]&1)==0){u=g;break}Lw(c[l+8>>2]|0);u=g;break}else{z=0;g=bT(-1,-1)|0;v=g;g=M;if((a[t]&1)==0){w=g;x=v;break L1}Lw(c[l+8>>2]|0);w=g;x=v;break L1}}else{v=n;g=n;a[g]=16;t=v+1|0;y=t|0;E=761686308;a[y]=E;E=E>>8;a[y+1|0]=E;E=E>>8;a[y+2|0]=E;E=E>>8;a[y+3|0]=E;y=t+4|0;E=1702195828;a[y]=E;E=E>>8;a[y+1|0]=E;E=E>>8;a[y+2|0]=E;E=E>>8;a[y+3|0]=E;a[v+9|0]=0;v=o;c[v>>2]=c[r>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2];v=(z=0,at(118,n|0,b|0,e|0,f|0,o|0,h|0)|0);if(!z){if((a[g]&1)==0){u=v;break}Lw(c[n+8>>2]|0);u=v;break}else{z=0;v=bT(-1,-1)|0;y=v;v=M;if((a[g]&1)==0){w=v;x=y;break L1}Lw(c[n+8>>2]|0);w=v;x=y;break L1}}}while(0);if((a[q]&1)==0){i=d;return u|0}Lw(c[j+8>>2]|0);i=d;return u|0}else{z=0;s=13}}while(0);if((s|0)==13){s=bT(-1,-1)|0;w=M;x=s}if((a[q]&1)==0){A=x;B=0;C=A;D=w;bg(C|0)}Lw(c[j+8>>2]|0);A=x;B=0;C=A;D=w;bg(C|0);return 0}function rl(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,av=0,aw=0,ax=0;j=i;i=i+248|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+88|0;r=j+104|0;s=j+120|0;t=j+136|0;u=j+152|0;v=j+168|0;w=j+184|0;x=j+200|0;y=j+216|0;A=j+232|0;B=m;C=m;a[C]=10;D=B+1|0;a[D]=a[11248]|0;a[D+1|0]=a[11249]|0;a[D+2|0]=a[11250]|0;a[D+3|0]=a[11251]|0;a[D+4|0]=a[11252]|0;a[B+6|0]=0;B=n;D=g;c[B>>2]=c[D>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];B=(z=0,at(108,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(z){z=0;n=bT(-1,-1)|0;g=n;n=M;if((a[C]&1)==0){F=g;G=n;H=F;I=0;J=H;K=G;bg(J|0)}Lw(c[m+8>>2]|0);F=g;G=n;H=F;I=0;J=H;K=G;bg(J|0)}if((a[C]&1)!=0){Lw(c[m+8>>2]|0)}m=o;C=o;a[C]=20;LF(m+1|0,11216,10)|0;a[m+11|0]=0;m=p;c[m>>2]=c[D>>2];c[m+4>>2]=c[D+4>>2];c[m+8>>2]=c[D+8>>2];m=(z=0,at(118,o|0,b|0,e|0,f|0,p|0,h|0)|0);do{if(!z){h=(z=0,au(c[(c[m>>2]|0)+48>>2]|0,m|0)|0);if(z){z=0;break}if((a[C]&1)!=0){Lw(c[o+8>>2]|0)}gr(s,d+128|0,11192);p=B+40|0;L17:do{if((a[p]&1)==0){e=u;c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];L=18}else{e=c[B+48>>2]|0;b=c[B+44>>2]|0;do{if(b>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(b>>>0<11>>>0){a[u]=b<<1;N=u+1|0}else{n=b+16&-16;g=(z=0,au(248,n|0)|0);if(z){z=0;break}c[u+8>>2]=g;c[u>>2]=n|1;c[u+4>>2]=b;N=g}LF(N|0,e|0,b)|0;a[N+b|0]=0;L=18;break L17}}while(0);b=bT(-1,-1)|0;O=b;P=M}}while(0);do{if((L|0)==18){z=0;as(180,t|0,u|0);do{if(!z){z=0;aR(210,r|0,s|0,t|0);do{if(!z){z=0;aR(286,q|0,r|0,34);if(z){z=0;p=bT(-1,-1)|0;b=p;p=M;if((a[r]&1)==0){Q=b;R=p;break}Lw(c[r+8>>2]|0);Q=b;R=p;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}L54:do{if(h){p=w;LI(p|0,0,12)|0;b=q;e=a[q]|0;g=e&255;if((g&1|0)==0){S=g>>>1}else{S=c[q+4>>2]|0}g=S+4|0;do{if(g>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(g>>>0<11>>>0){a[p]=8;T=w+1|0}else{n=S+20&-16;U=(z=0,au(248,n|0)|0);if(z){z=0;break}c[w+8>>2]=U;c[w>>2]=n|1;c[w+4>>2]=4;T=U}U=T;E=678195829;a[U]=E;E=E>>8;a[U+1|0]=E;E=E>>8;a[U+2|0]=E;E=E>>8;a[U+3|0]=E;a[T+4|0]=0;if((e&1)==0){V=b+1|0}else{V=c[q+8>>2]|0}z=0,az(88,w|0,V|0,S|0)|0;if(z){z=0;break}U=v;LI(U|0,0,12)|0;n=a[p]|0;W=n&255;if((W&1|0)==0){X=W>>>1}else{X=c[w+4>>2]|0}if((n&1)==0){Y=w+1|0}else{Y=c[w+8>>2]|0}n=X+1|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;L=60;break}return 0}else{if(n>>>0<11>>>0){a[U]=X<<1;Z=v+1|0}else{W=X+17&-16;_=(z=0,au(248,W|0)|0);if(z){z=0;L=60;break}c[v+8>>2]=_;c[v>>2]=W|1;c[v+4>>2]=X;Z=_}LF(Z|0,Y|0,X)|0;a[Z+X|0]=0;z=0,az(88,v|0,5664,1)|0;if(z){z=0;L=60;break}z=0,aM(344,q|0,v|0)|0;if(z){z=0;_=bT(-1,-1)|0;W=_;_=M;if((a[U]&1)==0){$=W;aa=_;break}Lw(c[v+8>>2]|0);$=W;aa=_;break}if((a[U]&1)!=0){Lw(c[v+8>>2]|0)}if((a[p]&1)==0){L=89;break L54}Lw(c[w+8>>2]|0);L=89;break L54}}while(0);if((L|0)==60){n=bT(-1,-1)|0;_=M;if((a[U]&1)!=0){Lw(c[v+8>>2]|0)}$=n;aa=_}if((a[p]&1)==0){ab=$;ac=aa;break L54}Lw(c[w+8>>2]|0);ab=$;ac=aa;break L54}}while(0);b=bT(-1,-1)|0;e=M;if((a[p]&1)==0){ad=e;ae=b;L=83;break}Lw(c[w+8>>2]|0);ad=e;ae=b;L=83}else{L=89}}while(0);L109:do{if((L|0)==89){b=(z=0,au(248,52)|0);do{if(!z){e=b;c[l>>2]=e;g=d+4|0;_=c[g>>2]|0;if((_|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,l|0);if(z){z=0;break}af=c[l>>2]|0}else{if((_|0)==0){ag=0}else{c[_>>2]=e;ag=c[g>>2]|0}c[g>>2]=ag+4;af=e}e=af;_=af;n=f;L121:do{if((a[n]&1)==0){W=x;c[W>>2]=c[n>>2];c[W+4>>2]=c[n+4>>2];c[W+8>>2]=c[n+8>>2];L=106}else{W=c[f+8>>2]|0;ah=c[f+4>>2]|0;do{if(ah>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ah>>>0<11>>>0){a[x]=ah<<1;ai=x+1|0}else{aj=ah+16&-16;ak=(z=0,au(248,aj|0)|0);if(z){z=0;break}c[x+8>>2]=ak;c[x>>2]=aj|1;c[x+4>>2]=ah;ai=ak}LF(ai|0,W|0,ah)|0;a[ai+ah|0]=0;L=106;break L121}}while(0);ah=bT(-1,-1)|0;al=ah;am=M}}while(0);do{if((L|0)==106){n=y;c[n>>2]=c[D>>2];c[n+4>>2]=c[D+4>>2];c[n+8>>2]=c[D+8>>2];U=q;L136:do{if((a[U]&1)==0){ah=A;c[ah>>2]=c[U>>2];c[ah+4>>2]=c[U+4>>2];c[ah+8>>2]=c[U+8>>2];L=116}else{ah=c[q+8>>2]|0;W=c[q+4>>2]|0;do{if(W>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(W>>>0<11>>>0){a[A]=W<<1;an=A+1|0}else{ak=W+16&-16;aj=(z=0,au(248,ak|0)|0);if(z){z=0;break}c[A+8>>2]=aj;c[A>>2]=ak|1;c[A+4>>2]=W;an=aj}LF(an|0,ah|0,W)|0;a[an+W|0]=0;L=116;break L136}}while(0);W=bT(-1,-1)|0;ao=W;ap=M}}while(0);do{if((L|0)==116){W=k;c[W>>2]=c[n>>2];c[W+4>>2]=c[n+4>>2];c[W+8>>2]=c[n+8>>2];z=0;aq(28,_|0,x|0,k|0,A|0,0);if(z){z=0;W=bT(-1,-1)|0;ah=W;W=M;if((a[A]&1)==0){ao=ah;ap=W;break}Lw(c[A+8>>2]|0);ao=ah;ap=W;break}W=af;if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[x]&1)!=0){Lw(c[x+8>>2]|0)}if((a[U]&1)==0){i=j;return W|0}Lw(c[q+8>>2]|0);i=j;return W|0}}while(0);if((a[x]&1)==0){al=ao;am=ap;break}Lw(c[x+8>>2]|0);al=ao;am=ap}}while(0);_=c[d>>2]|0;U=c[g>>2]|0;n=_;while(1){if((n|0)==(U|0)){av=U;break}if((c[n>>2]|0)==(af|0)){av=n;break}else{n=n+4|0}}n=av-_>>2;W=_+(n+1<<2)|0;ah=U-W|0;LG(_+(n<<2)|0,W|0,ah|0)|0;W=_+((ah>>2)+n<<2)|0;n=c[g>>2]|0;if((W|0)!=(n|0)){c[g>>2]=n+(~((n-4+(-W|0)|0)>>>2)<<2)}Lw(e);ab=al;ac=am;break L109}else{z=0}}while(0);b=bT(-1,-1)|0;ad=M;ae=b;L=83}}while(0);if((L|0)==83){ab=ae;ac=ad}if((a[q]&1)==0){F=ab;G=ac;H=F;I=0;J=H;K=G;bg(J|0)}Lw(c[q+8>>2]|0);F=ab;G=ac;H=F;I=0;J=H;K=G;bg(J|0)}else{z=0;b=bT(-1,-1)|0;Q=b;R=M}}while(0);if((a[t]&1)==0){aw=Q;ax=R;break}Lw(c[t+8>>2]|0);aw=Q;ax=R}else{z=0;b=bT(-1,-1)|0;aw=b;ax=M}}while(0);if((a[u]&1)==0){O=aw;P=ax;break}Lw(c[u+8>>2]|0);O=aw;P=ax}}while(0);if((a[s]&1)==0){F=O;G=P;H=F;I=0;J=H;K=G;bg(J|0)}Lw(c[s+8>>2]|0);F=O;G=P;H=F;I=0;J=H;K=G;bg(J|0)}else{z=0}}while(0);P=bT(-1,-1)|0;O=P;P=M;if((a[C]&1)==0){F=O;G=P;H=F;I=0;J=H;K=G;bg(J|0)}Lw(c[o+8>>2]|0);F=O;G=P;H=F;I=0;J=H;K=G;bg(J|0);return 0}function rm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a|0;c[d>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;a=b+4|0;g=b|0;b=(c[a>>2]|0)-(c[g>>2]|0)|0;h=b>>2;if((h|0)==0){return}do{if(h>>>0>1073741823>>>0){z=0;ar(152,0);if(z){z=0;break}}else{i=(z=0,au(248,b|0)|0);if(z){z=0;break}j=i;c[e>>2]=j;c[d>>2]=j;c[f>>2]=j+(h<<2);i=c[g>>2]|0;k=c[a>>2]|0;if((i|0)==(k|0)){return}else{l=i;m=j}do{if((m|0)==0){n=0}else{c[m>>2]=c[l>>2];n=c[e>>2]|0}m=n+4|0;c[e>>2]=m;l=l+4|0;}while((l|0)!=(k|0));return}}while(0);l=bT(-1,-1)|0;m=c[d>>2]|0;if((m|0)==0){bg(l|0)}d=c[e>>2]|0;if((m|0)!=(d|0)){c[e>>2]=d+(~((d-4+(-m|0)|0)>>>2)<<2)}Lw(m);bg(l|0)}function rn(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;m=i;i=i+32|0;l=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];l=m|0;n=m+16|0;o=b|0;p=d;if((a[p]&1)==0){q=l;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2]}else{p=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){D5(0)}if(q>>>0<11>>>0){a[l]=q<<1;r=l+1|0}else{d=q+16&-16;s=Lu(d)|0;c[l+8>>2]=s;c[l>>2]=d|1;c[l+4>>2]=q;r=s}LF(r|0,p|0,q)|0;a[r+q|0]=0}q=n;r=e;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];z=0;aV(6,o|0,l|0,n|0,0);if(z){z=0;n=bT(-1,-1)|0;o=n;n=M;if((a[l]&1)==0){t=n;u=o;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[l+8>>2]|0);t=n;u=o;v=u;w=0;x=v;y=t;bg(x|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}l=b|0;c[l>>2]=22920;o=b+32|0;n=g;if((a[n]&1)==0){r=o;c[r>>2]=c[n>>2];c[r+4>>2]=c[n+4>>2];c[r+8>>2]=c[n+8>>2];A=b+44|0;c[A>>2]=h;B=b+48|0;c[B>>2]=0;C=b+52|0;c[C>>2]=1;D=b+56|0;c[D>>2]=0;E=b+60|0;c[E>>2]=j;F=b+64|0;c[F>>2]=k;G=b+68|0;a[G]=0;H=b+72|0;c[H>>2]=f;i=m;return}n=c[g+8>>2]|0;r=c[g+4>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(r>>>0<11>>>0){a[o]=r<<1;I=o+1|0}else{g=r+16&-16;q=(z=0,au(248,g|0)|0);if(z){z=0;break}c[b+40>>2]=q;c[o>>2]=g|1;c[b+36>>2]=r;I=q}LF(I|0,n|0,r)|0;a[I+r|0]=0;A=b+44|0;c[A>>2]=h;B=b+48|0;c[B>>2]=0;C=b+52|0;c[C>>2]=1;D=b+56|0;c[D>>2]=0;E=b+60|0;c[E>>2]=j;F=b+64|0;c[F>>2]=k;G=b+68|0;a[G]=0;H=b+72|0;c[H>>2]=f;i=m;return}}while(0);m=bT(-1,-1)|0;f=m;m=M;c[l>>2]=17512;if((a[b+4|0]&1)==0){t=m;u=f;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[b+12>>2]|0);t=m;u=f;v=u;w=0;x=v;y=t;bg(x|0)}function ro(b,d){b=b|0;d=d|0;var e=0;c[b>>2]=17832;e=b+4|0;a[e]=0;a[e+1|0]=0;c[b+16>>2]=0;c[b+20>>2]=d;return}function rp(b){b=b|0;var d=0;c[b>>2]=17832;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function rq(b){b=b|0;c[b>>2]=17832;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function rr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+44|0;L1:do{if((a[k]&1)==0){l=f;a[l]=6;m=f+1|0;a[m]=a[10296]|0;a[m+1|0]=a[10297]|0;a[m+2|0]=a[10298]|0;a[f+4|0]=0;n=b+4|0;z=0,az(88,n|0,m|0,3)|0;do{if(!z){m=c[b+20>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[l]&1)!=0){Lw(c[f+8>>2]|0)}m=b+16|0;c[m>>2]=(c[m>>2]|0)+1;break L1}else{z=0}}while(0);m=bT(-1,-1)|0;n=m;m=M;if((a[l]&1)==0){o=n;p=m;q=o;r=0;s=q;t=p;bg(s|0)}Lw(c[f+8>>2]|0);o=n;p=m;q=o;r=0;s=q;t=p;bg(s|0)}}while(0);f=d+32|0;m=(c[d+36>>2]|0)-(c[f>>2]|0)>>2;L17:do{if((m|0)!=0){d=b|0;n=h;u=h;v=n+1|0;w=n+2|0;n=b+4|0;x=b+20|0;y=h+8|0;A=g;B=g;C=A+1|0;D=A+2|0;A=g+8|0;E=0;L19:while(1){rs(b);F=c[(c[f>>2]|0)+(E<<2)>>2]|0;cB[c[(c[F>>2]|0)+8>>2]&1023](F|0,d);do{if((a[k]&1)!=0){a[B]=2;a[C]=10;a[D]=0;z=0,az(88,n|0,C|0,1)|0;if(z){z=0;G=18;break L19}F=c[x>>2]|0;if((F|0)!=0){z=0;as(320,F+64|0,g|0);if(z){z=0;G=18;break L19}}if((a[B]&1)==0){break}Lw(c[A>>2]|0)}}while(0);a[u]=2;a[v]=10;a[w]=0;z=0,az(88,n|0,v|0,1)|0;if(z){z=0;G=26;break}F=c[x>>2]|0;if((F|0)!=0){z=0;as(320,F+64|0,h|0);if(z){z=0;G=26;break}}if((a[u]&1)!=0){Lw(c[y>>2]|0)}E=E+1|0;if(E>>>0>=m>>>0){break L17}}if((G|0)==26){E=bT(-1,-1)|0;x=E;E=M;if((a[u]&1)==0){o=x;p=E;q=o;r=0;s=q;t=p;bg(s|0)}Lw(c[y>>2]|0);o=x;p=E;q=o;r=0;s=q;t=p;bg(s|0)}else if((G|0)==18){E=bT(-1,-1)|0;x=E;E=M;if((a[B]&1)==0){o=x;p=E;q=o;r=0;s=q;t=p;bg(s|0)}Lw(c[A>>2]|0);o=x;p=E;q=o;r=0;s=q;t=p;bg(s|0)}}}while(0);L48:do{if((a[k]&1)==0){G=b+16|0;c[G>>2]=(c[G>>2]|0)-1;rs(b);G=j;m=j;a[m]=2;h=G+1|0;a[h]=125;a[G+2|0]=0;G=b+4|0;z=0,az(88,G|0,h|0,1)|0;do{if(!z){h=c[b+20>>2]|0;if((h|0)!=0){z=0;as(320,h+64|0,j|0);if(z){z=0;break}}if((a[m]&1)==0){break L48}Lw(c[j+8>>2]|0);break L48}else{z=0}}while(0);A=bT(-1,-1)|0;B=A;A=M;if((a[m]&1)==0){o=B;p=A;q=o;r=0;s=q;t=p;bg(s|0)}Lw(c[j+8>>2]|0);o=B;p=A;q=o;r=0;s=q;t=p;bg(s|0)}}while(0);if((a[k]&1)==0){i=e;return}k=b+4|0;s=k;p=k;k=a[p]|0;t=k&255;q=(t&1|0)==0;if(q){H=t>>>1}else{H=c[b+8>>2]|0}if(H>>>0<=2>>>0){i=e;return}r=H-1|0;o=(k&1)==0;if(o){I=s+1|0}else{I=c[b+12>>2]|0}if((a[I+r|0]|0)!=10){i=e;return}if(o){J=s+1|0}else{J=c[b+12>>2]|0}if((a[J+(H-2)|0]|0)!=10){i=e;return}if(q){K=t>>>1}else{K=c[b+8>>2]|0}if(K>>>0<r>>>0){D6(0)}if(o){a[p]=r<<1;L=s+1|0}else{s=c[b+12>>2]|0;c[b+8>>2]=r;L=s}a[L+r|0]=0;r=c[b+20>>2]|0;if((r|0)==0){i=e;return}AC(r+64|0);i=e;return}function rs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d|0;f=c[b+16>>2]|0;g=f<<1;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){h=f<<2&255;f=e;a[f]=h;j=e+1|0;k=h;l=f}else{f=g+16&-16;h=Lu(f)|0;c[e+8>>2]=h;m=f|1;c[e>>2]=m;c[e+4>>2]=g;j=h;k=m&255;l=e}LI(j|0,32,g|0)|0;a[j+g|0]=0;if((k&1)==0){n=e+1|0}else{n=c[e+8>>2]|0}g=k&255;if((g&1|0)==0){o=g>>>1}else{o=c[e+4>>2]|0}z=0,az(88,b+4|0,n|0,o|0)|0;do{if(!z){o=c[b+20>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,e|0);if(z){z=0;break}}if((a[l]&1)==0){i=d;return}Lw(c[e+8>>2]|0);i=d;return}else{z=0}}while(0);d=bT(-1,-1)|0;if((a[l]&1)==0){bg(d|0)}Lw(c[e+8>>2]|0);bg(d|0)}function rt(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+32>>2]|0;e=a|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d|0,e);d=c[b+28>>2]|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,e);return}function ru(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=c[d+32>>2]|0;h=b|0;cB[c[(c[g>>2]|0)+8>>2]&1023](g,h);g=f;j=f;a[j]=4;k=g+1|0;l=k;E=8250;a[l]=E;E=E>>8;a[l+1|0]=E;a[g+3|0]=0;z=0,az(88,b+4|0,k|0,2)|0;do{if(!z){k=c[b+20>>2]|0;if((k|0)!=0){z=0;as(320,k+64|0,f|0);if(z){z=0;break}}if((a[j]&1)==0){m=d+28|0;n=c[m>>2]|0;o=n;p=c[o>>2]|0;q=p+8|0;r=c[q>>2]|0;cB[r&1023](n,h);i=e;return}Lw(c[f+8>>2]|0);m=d+28|0;n=c[m>>2]|0;o=n;p=c[o>>2]|0;q=p+8|0;r=c[q>>2]|0;cB[r&1023](n,h);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[j]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function rv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){AE(h+64|0,d|0)}h=f;a[h]=14;j=f+1|0;a[j]=a[4328]|0;a[j+1|0]=a[4329]|0;a[j+2|0]=a[4330]|0;a[j+3|0]=a[4331]|0;a[j+4|0]=a[4332]|0;a[j+5|0]=a[4333]|0;a[j+6|0]=a[4334]|0;k=f+8|0;a[k]=0;z=0,az(88,b+4|0,j|0,7)|0;do{if(!z){j=c[g>>2]|0;if((j|0)!=0){z=0;as(320,j+64|0,f|0);if(z){z=0;break}}if((a[h]&1)!=0){Lw(c[k>>2]|0)}j=c[d+32>>2]|0;l=b|0;cB[c[(c[j>>2]|0)+8>>2]&1023](j,l);j=c[d+28>>2]|0;cB[c[(c[j>>2]|0)+8>>2]&1023](j,l);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[h]&1)==0){bg(e|0)}Lw(c[k>>2]|0);bg(e|0)}function rw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+32|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+40>>2]|0;j=c[d+36>>2]|0;if(j>>>0>4294967279>>>0){D5(0)}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=Lu(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}LF(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+4|0;if((l&1)==0){t=f+1|0}else{t=c[f+8>>2]|0}q=l&255;if((q&1|0)==0){u=q>>>1}else{u=c[f+4>>2]|0}z=0,az(88,r|0,t|0,u|0)|0;do{if(!z){u=b+20|0;t=c[u>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,f|0);if(z){z=0;break}}if((a[m]&1)!=0){Lw(c[f+8>>2]|0)}t=d+44|0;L28:do{if((c[t>>2]|0)!=0){q=g;l=g;a[l]=2;j=q+1|0;a[j]=32;a[q+2|0]=0;z=0,az(88,r|0,j|0,1)|0;do{if(!z){j=c[u>>2]|0;if((j|0)!=0){z=0;as(320,j+64|0,g|0);if(z){z=0;break}}if((a[l]&1)!=0){Lw(c[g+8>>2]|0)}j=c[t>>2]|0;cB[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);break L28}else{z=0}}while(0);j=bT(-1,-1)|0;q=j;j=M;if((a[l]&1)==0){v=j;w=q;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[g+8>>2]|0);v=j;w=q;x=w;y=0;A=x;B=v;bg(A|0)}}while(0);t=c[d+28>>2]|0;if((t|0)!=0){cB[c[(c[t>>2]|0)+8>>2]&1023](t,b|0);i=e;return}t=h;q=h;a[q]=2;j=t+1|0;a[j]=59;a[t+2|0]=0;z=0,az(88,r|0,j|0,1)|0;do{if(!z){j=c[u>>2]|0;if((j|0)!=0){z=0;as(320,j+64|0,h|0);if(z){z=0;break}}if((a[q]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);u=bT(-1,-1)|0;j=u;u=M;if((a[q]&1)==0){v=u;w=j;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[h+8>>2]|0);v=u;w=j;x=w;y=0;A=x;B=v;bg(A|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[m]&1)==0){v=h;w=e;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[f+8>>2]|0);v=h;w=e;x=w;y=0;A=x;B=v;bg(A|0)}function rx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=b+20|0;k=c[j>>2]|0;if((k|0)==0){l=d+28|0}else{m=d+28|0;AE(k+64|0,c[m>>2]|0);l=m}m=c[l>>2]|0;l=b|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m,l);m=f;k=f;a[k]=4;n=m+1|0;o=n;E=8250;a[o]=E;E=E>>8;a[o+1|0]=E;a[m+3|0]=0;m=b+4|0;z=0,az(88,m|0,n|0,2)|0;do{if(!z){n=c[j>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}n=c[j>>2]|0;if((n|0)==0){p=d+32|0}else{b=d+32|0;AE(n+64|0,c[b>>2]|0);p=b}b=c[p>>2]|0;cB[c[(c[b>>2]|0)+8>>2]&1023](b|0,l);L17:do{if((a[d+36|0]&1)!=0){b=Lu(16)|0;n=g+8|0;c[n>>2]=b;c[g>>2]=17;c[g+4>>2]=11;LF(b|0,1040,11)|0;a[b+11|0]=0;o=g;z=0,az(88,m|0,b|0,11)|0;do{if(!z){b=c[j>>2]|0;if((b|0)!=0){z=0;as(320,b+64|0,g|0);if(z){z=0;break}}if((a[o]&1)==0){break L17}Lw(c[n>>2]|0);break L17}else{z=0}}while(0);b=bT(-1,-1)|0;q=b;b=M;if((a[o]&1)==0){r=b;s=q;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[n>>2]|0);r=b;s=q;t=s;u=0;v=t;w=r;bg(v|0)}}while(0);q=h;b=h;a[b]=2;x=q+1|0;a[x]=59;a[q+2|0]=0;z=0,az(88,m|0,x|0,1)|0;do{if(!z){x=c[j>>2]|0;if((x|0)!=0){z=0;as(320,x+64|0,h|0);if(z){z=0;break}}if((a[b]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);x=bT(-1,-1)|0;q=x;x=M;if((a[b]&1)==0){r=x;s=q;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[h+8>>2]|0);r=x;s=q;t=s;u=0;v=t;w=r;bg(v|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[k]&1)==0){r=h;s=e;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[f+8>>2]|0);r=h;s=e;t=s;u=0;v=t;w=r;bg(v|0)}function ry(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+28|0;if((a[k]&1)==0){l=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];m=a[l]|0;n=l}else{l=c[d+36>>2]|0;k=c[d+32>>2]|0;if(k>>>0>4294967279>>>0){D5(0)}if(k>>>0<11>>>0){o=k<<1&255;p=f;a[p]=o;q=f+1|0;r=o;s=p}else{p=k+16&-16;o=Lu(p)|0;c[f+8>>2]=o;t=p|1;c[f>>2]=t;c[f+4>>2]=k;q=o;r=t&255;s=f}LF(q|0,l|0,k)|0;a[q+k|0]=0;m=r;n=s}s=b+4|0;if((m&1)==0){u=f+1|0}else{u=c[f+8>>2]|0}r=m&255;if((r&1|0)==0){v=r>>>1}else{v=c[f+4>>2]|0}z=0,az(88,s|0,u|0,v|0)|0;do{if(!z){v=b+20|0;u=c[v>>2]|0;if((u|0)!=0){z=0;as(320,u+64|0,f|0);if(z){z=0;break}}if((a[n]&1)!=0){Lw(c[f+8>>2]|0)}u=g;r=g;a[r]=4;m=u+1|0;k=m;E=8250;a[k]=E;E=E>>8;a[k+1|0]=E;a[u+3|0]=0;z=0,az(88,s|0,m|0,2)|0;do{if(!z){m=c[v>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,g|0);if(z){z=0;break}}if((a[r]&1)!=0){Lw(c[g+8>>2]|0)}m=c[d+40>>2]|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m|0,b|0);L36:do{if((a[d+44|0]&1)!=0){m=h;u=h;a[u]=18;k=m+1|0;LF(k|0,312,9)|0;a[m+10|0]=0;z=0,az(88,s|0,k|0,9)|0;do{if(!z){k=c[v>>2]|0;if((k|0)!=0){z=0;as(320,k+64|0,h|0);if(z){z=0;break}}if((a[u]&1)==0){break L36}Lw(c[h+8>>2]|0);break L36}else{z=0}}while(0);k=bT(-1,-1)|0;m=k;k=M;if((a[u]&1)==0){w=k;x=m;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[h+8>>2]|0);w=k;x=m;y=x;A=0;B=y;C=w;bg(B|0)}}while(0);m=j;k=j;a[k]=2;q=m+1|0;a[q]=59;a[m+2|0]=0;z=0,az(88,s|0,q|0,1)|0;do{if(!z){q=c[v>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,j|0);if(z){z=0;break}}if((a[k]&1)==0){i=e;return}Lw(c[j+8>>2]|0);i=e;return}else{z=0}}while(0);q=bT(-1,-1)|0;m=q;q=M;if((a[k]&1)==0){w=q;x=m;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[j+8>>2]|0);w=q;x=m;y=x;A=0;B=y;C=w;bg(B|0)}else{z=0}}while(0);v=bT(-1,-1)|0;m=v;v=M;if((a[r]&1)==0){w=v;x=m;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[g+8>>2]|0);w=v;x=m;y=x;A=0;B=y;C=w;bg(B|0)}else{z=0}}while(0);g=bT(-1,-1)|0;j=g;g=M;if((a[n]&1)==0){w=g;x=j;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[f+8>>2]|0);w=g;x=j;y=x;A=0;B=y;C=w;bg(B|0)}function rz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=d+40|0;m=d+44|0;if((c[l>>2]|0)==(c[m>>2]|0)){i=e;return}n=b+20|0;o=c[n>>2]|0;if((o|0)!=0){AE(o+64|0,d|0)}o=f;p=f;a[p]=16;q=o+1|0;r=q;s=r|0;E=1886218560;a[s]=E;E=E>>8;a[s+1|0]=E;E=E>>8;a[s+2|0]=E;E=E>>8;a[s+3|0]=E;s=r+4|0;E=544502383;a[s]=E;E=E>>8;a[s+1|0]=E;E=E>>8;a[s+2|0]=E;E=E>>8;a[s+3|0]=E;a[o+9|0]=0;o=b+4|0;z=0,az(88,o|0,q|0,8)|0;do{if(!z){q=c[n>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,f|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[f+8>>2]|0)}q=c[c[l>>2]>>2]|0;s=b|0;cB[c[(c[q>>2]|0)+8>>2]&1023](q|0,s);q=g;r=g;a[r]=2;t=q+1|0;a[t]=59;a[q+2|0]=0;z=0,az(88,o|0,t|0,1)|0;do{if(!z){t=c[n>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,g|0);if(z){z=0;break}}if((a[r]&1)!=0){Lw(c[g+8>>2]|0)}t=(c[m>>2]|0)-(c[l>>2]|0)>>2;if(t>>>0<=1>>>0){i=e;return}q=h;u=h;v=q+1|0;w=q+2|0;q=j;x=j;y=q+1|0;A=y;B=q+9|0;q=k;C=k;D=q+1|0;F=q+2|0;q=k+8|0;G=j+8|0;H=d|0;I=h+8|0;J=1;while(1){a[u]=2;a[v]=10;a[w]=0;z=0,az(88,o|0,v|0,1)|0;if(z){z=0;K=27;break}L=c[n>>2]|0;if((L|0)!=0){z=0;as(320,L+64|0,h|0);if(z){z=0;K=27;break}}if((a[u]&1)!=0){Lw(c[I>>2]|0)}L=c[n>>2]|0;if((L|0)!=0){AE(L+64|0,H)}a[x]=16;L=A|0;E=1886218560;a[L]=E;E=E>>8;a[L+1|0]=E;E=E>>8;a[L+2|0]=E;E=E>>8;a[L+3|0]=E;L=A+4|0;E=544502383;a[L]=E;E=E>>8;a[L+1|0]=E;E=E>>8;a[L+2|0]=E;E=E>>8;a[L+3|0]=E;a[B]=0;z=0,az(88,o|0,y|0,8)|0;if(z){z=0;K=40;break}L=c[n>>2]|0;if((L|0)!=0){z=0;as(320,L+64|0,j|0);if(z){z=0;K=40;break}}if((a[x]&1)!=0){Lw(c[G>>2]|0)}L=c[(c[l>>2]|0)+(J<<2)>>2]|0;cB[c[(c[L>>2]|0)+8>>2]&1023](L|0,s);a[C]=2;a[D]=59;a[F]=0;z=0,az(88,o|0,D|0,1)|0;if(z){z=0;K=42;break}L=c[n>>2]|0;if((L|0)!=0){z=0;as(320,L+64|0,k|0);if(z){z=0;K=42;break}}if((a[C]&1)!=0){Lw(c[q>>2]|0)}L=J+1|0;if(L>>>0<t>>>0){J=L}else{K=48;break}}if((K|0)==27){J=bT(-1,-1)|0;t=J;J=M;if((a[u]&1)==0){N=t;O=J;P=N;Q=0;R=P;S=O;bg(R|0)}Lw(c[I>>2]|0);N=t;O=J;P=N;Q=0;R=P;S=O;bg(R|0)}else if((K|0)==42){J=bT(-1,-1)|0;t=J;J=M;if((a[C]&1)==0){N=t;O=J;P=N;Q=0;R=P;S=O;bg(R|0)}Lw(c[q>>2]|0);N=t;O=J;P=N;Q=0;R=P;S=O;bg(R|0)}else if((K|0)==48){i=e;return}else if((K|0)==40){J=bT(-1,-1)|0;t=J;J=M;if((a[x]&1)==0){N=t;O=J;P=N;Q=0;R=P;S=O;bg(R|0)}Lw(c[G>>2]|0);N=t;O=J;P=N;Q=0;R=P;S=O;bg(R|0)}}else{z=0}}while(0);s=bT(-1,-1)|0;J=s;s=M;if((a[r]&1)==0){N=J;O=s;P=N;Q=0;R=P;S=O;bg(R|0)}Lw(c[g+8>>2]|0);N=J;O=s;P=N;Q=0;R=P;S=O;bg(R|0)}else{z=0}}while(0);g=bT(-1,-1)|0;K=g;g=M;if((a[p]&1)==0){N=K;O=g;P=N;Q=0;R=P;S=O;bg(R|0)}Lw(c[f+8>>2]|0);N=K;O=g;P=N;Q=0;R=P;S=O;bg(R|0)}function rA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=b+20|0;k=c[j>>2]|0;if((k|0)!=0){AE(k+64|0,d|0)}k=f;l=f;a[l]=16;m=k+1|0;n=m;o=n|0;E=1886218560;a[o]=E;E=E>>8;a[o+1|0]=E;E=E>>8;a[o+2|0]=E;E=E>>8;a[o+3|0]=E;o=n+4|0;E=544502383;a[o]=E;E=E>>8;a[o+1|0]=E;E=E>>8;a[o+2|0]=E;E=E>>8;a[o+3|0]=E;a[k+9|0]=0;k=b+4|0;z=0,az(88,k|0,m|0,8)|0;do{if(!z){m=c[j>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[l]&1)!=0){Lw(c[f+8>>2]|0)}m=d+28|0;if((a[m]&1)==0){b=g;c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];p=a[b]|0;q=b}else{b=c[d+36>>2]|0;m=c[d+32>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){o=m<<1&255;n=g;a[n]=o;r=g+1|0;s=o;t=n}else{n=m+16&-16;o=Lu(n)|0;c[g+8>>2]=o;u=n|1;c[g>>2]=u;c[g+4>>2]=m;r=o;s=u&255;t=g}LF(r|0,b|0,m)|0;a[r+m|0]=0;p=s;q=t}if((p&1)==0){v=g+1|0}else{v=c[g+8>>2]|0}m=p&255;if((m&1|0)==0){w=m>>>1}else{w=c[g+4>>2]|0}z=0,az(88,k|0,v|0,w|0)|0;do{if(!z){m=c[j>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,g|0);if(z){z=0;break}}if((a[q]&1)!=0){Lw(c[g+8>>2]|0)}m=h;b=h;a[b]=2;u=m+1|0;a[u]=59;a[m+2|0]=0;z=0,az(88,k|0,u|0,1)|0;do{if(!z){u=c[j>>2]|0;if((u|0)!=0){z=0;as(320,u+64|0,h|0);if(z){z=0;break}}if((a[b]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);u=bT(-1,-1)|0;m=u;u=M;if((a[b]&1)==0){x=u;y=m;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[h+8>>2]|0);x=u;y=m;A=y;B=0;C=A;D=x;bg(C|0)}else{z=0}}while(0);m=bT(-1,-1)|0;u=m;m=M;if((a[q]&1)==0){x=m;y=u;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[g+8>>2]|0);x=m;y=u;A=y;B=0;C=A;D=x;bg(C|0)}else{z=0}}while(0);g=bT(-1,-1)|0;q=g;g=M;if((a[l]&1)==0){x=g;y=q;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[f+8>>2]|0);x=g;y=q;A=y;B=0;C=A;D=x;bg(C|0)}function rB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+20|0;j=c[h>>2]|0;if((j|0)!=0){AE(j+64|0,d|0)}j=f;k=f;a[k]=12;l=j+1|0;a[l]=a[12096]|0;a[l+1|0]=a[12097]|0;a[l+2|0]=a[12098]|0;a[l+3|0]=a[12099]|0;a[l+4|0]=a[12100]|0;a[l+5|0]=a[12101]|0;a[j+7|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,6)|0;do{if(!z){l=c[h>>2]|0;if((l|0)!=0){z=0;as(320,l+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}l=c[d+28>>2]|0;cB[c[(c[l>>2]|0)+8>>2]&1023](l|0,b|0);l=g;m=g;a[m]=2;n=l+1|0;a[n]=59;a[l+2|0]=0;z=0,az(88,j|0,n|0,1)|0;do{if(!z){n=c[h>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,g|0);if(z){z=0;break}}if((a[m]&1)==0){i=e;return}Lw(c[g+8>>2]|0);i=e;return}else{z=0}}while(0);n=bT(-1,-1)|0;l=n;n=M;if((a[m]&1)==0){o=n;p=l;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[g+8>>2]|0);o=n;p=l;q=p;r=0;s=q;t=o;bg(s|0)}else{z=0}}while(0);g=bT(-1,-1)|0;e=g;g=M;if((a[k]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}function rC(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function rD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=8;l=j+1|0;m=l;E=543582528;a[m]=E;E=E>>8;a[m+1|0]=E;E=E>>8;a[m+2|0]=E;E=E>>8;a[m+3|0]=E;a[j+5|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,4)|0;do{if(!z){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}m=c[d+28>>2]|0;n=b|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m|0,n);m=c[d+32>>2]|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m,n);m=d+36|0;if((c[m>>2]|0)==0){i=e;return}o=g;p=g;a[p]=2;q=o+1|0;a[q]=10;a[o+2|0]=0;z=0,az(88,j|0,q|0,1)|0;do{if(!z){q=c[l>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,g|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[g+8>>2]|0)}rs(b);q=h;o=h;a[o]=8;r=q+1|0;s=r;E=1702063205;a[s]=E;E=E>>8;a[s+1|0]=E;E=E>>8;a[s+2|0]=E;E=E>>8;a[s+3|0]=E;a[q+5|0]=0;z=0,az(88,j|0,r|0,4)|0;do{if(!z){r=c[l>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,h|0);if(z){z=0;break}}if((a[o]&1)!=0){Lw(c[h+8>>2]|0)}r=c[m>>2]|0;cB[c[(c[r>>2]|0)+8>>2]&1023](r,n);i=e;return}else{z=0}}while(0);r=bT(-1,-1)|0;q=r;r=M;if((a[o]&1)==0){t=r;u=q;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[h+8>>2]|0);t=r;u=q;v=u;w=0;x=v;y=t;bg(x|0)}else{z=0}}while(0);n=bT(-1,-1)|0;m=n;n=M;if((a[p]&1)==0){t=n;u=m;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[g+8>>2]|0);t=n;u=m;v=u;w=0;x=v;y=t;bg(x|0)}else{z=0}}while(0);g=bT(-1,-1)|0;h=g;g=M;if((a[k]&1)==0){t=g;u=h;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[f+8>>2]|0);t=g;u=h;v=u;w=0;x=v;y=t;bg(x|0)}function rE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=f;l=f;a[l]=10;m=k+1|0;a[m]=a[10696]|0;a[m+1|0]=a[10697]|0;a[m+2|0]=a[10698]|0;a[m+3|0]=a[10699]|0;a[m+4|0]=a[10700]|0;a[k+6|0]=0;k=b+4|0;z=0,az(88,k|0,m|0,5)|0;do{if(!z){m=b+20|0;n=c[m>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,f|0);if(z){z=0;break}}if((a[l]&1)!=0){Lw(c[f+8>>2]|0)}n=d+32|0;if((a[n]&1)==0){o=g;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];p=a[o]|0;q=o}else{o=c[d+40>>2]|0;n=c[d+36>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){r=n<<1&255;s=g;a[s]=r;t=g+1|0;u=r;v=s}else{s=n+16&-16;r=Lu(s)|0;c[g+8>>2]=r;w=s|1;c[g>>2]=w;c[g+4>>2]=n;t=r;u=w&255;v=g}LF(t|0,o|0,n)|0;a[t+n|0]=0;p=u;q=v}if((p&1)==0){x=g+1|0}else{x=c[g+8>>2]|0}n=p&255;if((n&1|0)==0){y=n>>>1}else{y=c[g+4>>2]|0}z=0,az(88,k|0,x|0,y|0)|0;do{if(!z){n=c[m>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,g|0);if(z){z=0;break}}if((a[q]&1)!=0){Lw(c[g+8>>2]|0)}n=h;o=h;a[o]=12;w=n+1|0;a[w]=a[10416]|0;a[w+1|0]=a[10417]|0;a[w+2|0]=a[10418]|0;a[w+3|0]=a[10419]|0;a[w+4|0]=a[10420]|0;a[w+5|0]=a[10421]|0;a[n+7|0]=0;z=0,az(88,k|0,w|0,6)|0;do{if(!z){w=c[m>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,h|0);if(z){z=0;break}}if((a[o]&1)!=0){Lw(c[h+8>>2]|0)}w=c[d+44>>2]|0;n=b|0;cB[c[(c[w>>2]|0)+8>>2]&1023](w|0,n);w=(a[d+52|0]&1)!=0?10272:9992;r=LJ(w|0)|0;if(r>>>0>4294967279>>>0){D5(0)}if(r>>>0<11>>>0){s=r<<1&255;A=j;a[A]=s;B=j+1|0;C=s;D=A}else{A=r+16&-16;s=Lu(A)|0;c[j+8>>2]=s;E=A|1;c[j>>2]=E;c[j+4>>2]=r;B=s;C=E&255;D=j}LF(B|0,w|0,r)|0;a[B+r|0]=0;if((C&1)==0){F=j+1|0}else{F=c[j+8>>2]|0}r=C&255;if((r&1|0)==0){G=r>>>1}else{G=c[j+4>>2]|0}z=0,az(88,k|0,F|0,G|0)|0;do{if(!z){r=c[m>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,j|0);if(z){z=0;break}}if((a[D]&1)==0){H=d+48|0;I=c[H>>2]|0;J=I|0;K=I;L=c[K>>2]|0;N=L+8|0;O=c[N>>2]|0;cB[O&1023](J,n);P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;cB[U&1023](Q,n);i=e;return}Lw(c[j+8>>2]|0);H=d+48|0;I=c[H>>2]|0;J=I|0;K=I;L=c[K>>2]|0;N=L+8|0;O=c[N>>2]|0;cB[O&1023](J,n);P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;cB[U&1023](Q,n);i=e;return}else{z=0}}while(0);n=bT(-1,-1)|0;r=n;n=M;if((a[D]&1)==0){V=n;W=r;X=W;Y=0;Z=X;_=V;bg(Z|0)}Lw(c[j+8>>2]|0);V=n;W=r;X=W;Y=0;Z=X;_=V;bg(Z|0)}else{z=0}}while(0);r=bT(-1,-1)|0;n=r;r=M;if((a[o]&1)==0){V=r;W=n;X=W;Y=0;Z=X;_=V;bg(Z|0)}Lw(c[h+8>>2]|0);V=r;W=n;X=W;Y=0;Z=X;_=V;bg(Z|0)}else{z=0}}while(0);m=bT(-1,-1)|0;n=m;m=M;if((a[q]&1)==0){V=m;W=n;X=W;Y=0;Z=X;_=V;bg(Z|0)}Lw(c[g+8>>2]|0);V=m;W=n;X=W;Y=0;Z=X;_=V;bg(Z|0)}else{z=0}}while(0);g=bT(-1,-1)|0;q=g;g=M;if((a[l]&1)==0){V=g;W=q;X=W;Y=0;Z=X;_=V;bg(Z|0)}Lw(c[f+8>>2]|0);V=g;W=q;X=W;Y=0;Z=X;_=V;bg(Z|0)}function rF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=12;l=j+1|0;a[l]=a[9800]|0;a[l+1|0]=a[9801]|0;a[l+2|0]=a[9802]|0;a[l+3|0]=a[9803]|0;a[l+4|0]=a[9804]|0;a[l+5|0]=a[9805]|0;a[j+7|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,6)|0;do{if(!z){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}m=d+32|0;if((a[m]&1)==0){n=g;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];o=a[n]|0;p=n}else{n=c[d+40>>2]|0;m=c[d+36>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){q=m<<1&255;r=g;a[r]=q;s=g+1|0;t=q;u=r}else{r=m+16&-16;q=Lu(r)|0;c[g+8>>2]=q;v=r|1;c[g>>2]=v;c[g+4>>2]=m;s=q;t=v&255;u=g}LF(s|0,n|0,m)|0;a[s+m|0]=0;o=t;p=u}if((o&1)==0){w=g+1|0}else{w=c[g+8>>2]|0}m=o&255;if((m&1|0)==0){x=m>>>1}else{x=c[g+4>>2]|0}z=0,az(88,j|0,w|0,x|0)|0;do{if(!z){m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,g|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[g+8>>2]|0)}m=h;n=h;a[n]=8;v=m+1|0;q=v;E=544106784;a[q]=E;E=E>>8;a[q+1|0]=E;E=E>>8;a[q+2|0]=E;E=E>>8;a[q+3|0]=E;a[m+5|0]=0;z=0,az(88,j|0,v|0,4)|0;do{if(!z){v=c[l>>2]|0;if((v|0)!=0){z=0;as(320,v+64|0,h|0);if(z){z=0;break}}if((a[n]&1)==0){y=d+44|0;A=c[y>>2]|0;B=A|0;C=A;D=c[C>>2]|0;F=D+8|0;G=c[F>>2]|0;H=b|0;cB[G&1023](B,H);I=d+28|0;J=c[I>>2]|0;K=J;L=c[K>>2]|0;N=L+8|0;O=c[N>>2]|0;cB[O&1023](J,H);i=e;return}Lw(c[h+8>>2]|0);y=d+44|0;A=c[y>>2]|0;B=A|0;C=A;D=c[C>>2]|0;F=D+8|0;G=c[F>>2]|0;H=b|0;cB[G&1023](B,H);I=d+28|0;J=c[I>>2]|0;K=J;L=c[K>>2]|0;N=L+8|0;O=c[N>>2]|0;cB[O&1023](J,H);i=e;return}else{z=0}}while(0);v=bT(-1,-1)|0;m=v;v=M;if((a[n]&1)==0){P=v;Q=m;R=Q;S=0;T=R;U=P;bg(T|0)}Lw(c[h+8>>2]|0);P=v;Q=m;R=Q;S=0;T=R;U=P;bg(T|0)}else{z=0}}while(0);l=bT(-1,-1)|0;m=l;l=M;if((a[p]&1)==0){P=l;Q=m;R=Q;S=0;T=R;U=P;bg(T|0)}Lw(c[g+8>>2]|0);P=l;Q=m;R=Q;S=0;T=R;U=P;bg(T|0)}else{z=0}}while(0);g=bT(-1,-1)|0;p=g;g=M;if((a[k]&1)==0){P=g;Q=p;R=Q;S=0;T=R;U=P;bg(T|0)}Lw(c[f+8>>2]|0);P=g;Q=p;R=Q;S=0;T=R;U=P;bg(T|0)}function rG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e|0;g=f;a[g]=14;h=f+1|0;a[h]=a[9576]|0;a[h+1|0]=a[9577]|0;a[h+2|0]=a[9578]|0;a[h+3|0]=a[9579]|0;a[h+4|0]=a[9580]|0;a[h+5|0]=a[9581]|0;a[h+6|0]=a[9582]|0;j=f+8|0;a[j]=0;z=0,az(88,b+4|0,h|0,7)|0;do{if(!z){h=c[b+20>>2]|0;if((h|0)!=0){z=0;as(320,h+64|0,f|0);if(z){z=0;break}}if((a[g]&1)!=0){Lw(c[j>>2]|0)}h=c[d+32>>2]|0;k=b|0;cB[c[(c[h>>2]|0)+8>>2]&1023](h|0,k);h=c[d+28>>2]|0;cB[c[(c[h>>2]|0)+8>>2]&1023](h,k);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[g]&1)==0){bg(e|0)}Lw(c[j>>2]|0);bg(e|0)}function rH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=f;j=f;a[j]=16;k=h+1|0;l=k;m=l|0;E=1952805440;a[m]=E;E=E>>8;a[m+1|0]=E;E=E>>8;a[m+2|0]=E;E=E>>8;a[m+3|0]=E;m=l+4|0;E=544109173;a[m]=E;E=E>>8;a[m+1|0]=E;E=E>>8;a[m+2|0]=E;E=E>>8;a[m+3|0]=E;a[h+9|0]=0;h=b+4|0;z=0,az(88,h|0,k|0,8)|0;do{if(!z){k=b+20|0;m=c[k>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[j]&1)!=0){Lw(c[f+8>>2]|0)}m=c[d+28>>2]|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m|0,b|0);m=g;l=g;a[l]=2;n=m+1|0;a[n]=59;a[m+2|0]=0;z=0,az(88,h|0,n|0,1)|0;do{if(!z){n=c[k>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,g|0);if(z){z=0;break}}if((a[l]&1)==0){i=e;return}Lw(c[g+8>>2]|0);i=e;return}else{z=0}}while(0);k=bT(-1,-1)|0;n=k;k=M;if((a[l]&1)==0){o=k;p=n;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[g+8>>2]|0);o=k;p=n;q=p;r=0;s=q;t=o;bg(s|0)}else{z=0}}while(0);g=bT(-1,-1)|0;e=g;g=M;if((a[j]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}function rI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=f;j=f;a[j]=16;k=h+1|0;l=k;m=l|0;E=1954047296;a[m]=E;E=E>>8;a[m+1|0]=E;E=E>>8;a[m+2|0]=E;E=E>>8;a[m+3|0]=E;m=l+4|0;E=543452773;a[m]=E;E=E>>8;a[m+1|0]=E;E=E>>8;a[m+2|0]=E;E=E>>8;a[m+3|0]=E;a[h+9|0]=0;h=b+4|0;z=0,az(88,h|0,k|0,8)|0;do{if(!z){k=b+20|0;m=c[k>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[j]&1)!=0){Lw(c[f+8>>2]|0)}m=c[d+28>>2]|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m|0,b|0);m=g;l=g;a[l]=2;n=m+1|0;a[n]=59;a[m+2|0]=0;z=0,az(88,h|0,n|0,1)|0;do{if(!z){n=c[k>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,g|0);if(z){z=0;break}}if((a[l]&1)==0){i=e;return}Lw(c[g+8>>2]|0);i=e;return}else{z=0}}while(0);k=bT(-1,-1)|0;n=k;k=M;if((a[l]&1)==0){o=k;p=n;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[g+8>>2]|0);o=k;p=n;q=p;r=0;s=q;t=o;bg(s|0)}else{z=0}}while(0);g=bT(-1,-1)|0;e=g;g=M;if((a[j]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}function rJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;L1:do{if((c[d+52>>2]|0)==0){j=f;a[j]=14;k=f+1|0;a[k]=a[9008]|0;a[k+1|0]=a[9009]|0;a[k+2|0]=a[9010]|0;a[k+3|0]=a[9011]|0;a[k+4|0]=a[9012]|0;a[k+5|0]=a[9013]|0;a[k+6|0]=a[9014]|0;l=f+8|0;a[l]=0;m=b+4|0;z=0,az(88,m|0,k|0,7)|0;do{if(!z){k=c[b+20>>2]|0;if((k|0)!=0){z=0;as(320,k+64|0,f|0);if(z){z=0;break}}if((a[j]&1)==0){break L1}Lw(c[l>>2]|0);break L1}else{z=0}}while(0);k=bT(-1,-1)|0;m=k;k=M;if((a[j]&1)==0){n=k;o=m;p=o;q=0;r=p;s=n;bg(r|0)}Lw(c[l>>2]|0);n=k;o=m;p=o;q=0;r=p;s=n;bg(r|0)}else{m=g;k=g;a[k]=20;t=m+1|0;LF(t|0,8888,10)|0;a[m+11|0]=0;m=b+4|0;z=0,az(88,m|0,t|0,10)|0;do{if(!z){t=c[b+20>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,g|0);if(z){z=0;break}}if((a[k]&1)==0){break L1}Lw(c[g+8>>2]|0);break L1}else{z=0}}while(0);l=bT(-1,-1)|0;j=l;l=M;if((a[k]&1)==0){n=l;o=j;p=o;q=0;r=p;s=n;bg(r|0)}Lw(c[g+8>>2]|0);n=l;o=j;p=o;q=0;r=p;s=n;bg(r|0)}}while(0);g=d+32|0;if((a[g]&1)==0){f=h;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];u=a[f]|0;v=f}else{f=c[d+40>>2]|0;g=c[d+36>>2]|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){j=g<<1&255;l=h;a[l]=j;w=h+1|0;x=j;y=l}else{l=g+16&-16;j=Lu(l)|0;c[h+8>>2]=j;t=l|1;c[h>>2]=t;c[h+4>>2]=g;w=j;x=t&255;y=h}LF(w|0,f|0,g)|0;a[w+g|0]=0;u=x;v=y}if((u&1)==0){A=h+1|0}else{A=c[h+8>>2]|0}y=u&255;if((y&1|0)==0){B=y>>>1}else{B=c[h+4>>2]|0}z=0,az(88,b+4|0,A|0,B|0)|0;do{if(!z){B=c[b+20>>2]|0;if((B|0)!=0){z=0;as(320,B+64|0,h|0);if(z){z=0;break}}if((a[v]&1)==0){C=d+44|0;D=c[C>>2]|0;E=D;F=c[E>>2]|0;G=F+8|0;H=c[G>>2]|0;I=b|0;cB[H&1023](D,I);J=d+28|0;K=c[J>>2]|0;L=K;N=c[L>>2]|0;O=N+8|0;P=c[O>>2]|0;cB[P&1023](K,I);i=e;return}Lw(c[h+8>>2]|0);C=d+44|0;D=c[C>>2]|0;E=D;F=c[E>>2]|0;G=F+8|0;H=c[G>>2]|0;I=b|0;cB[H&1023](D,I);J=d+28|0;K=c[J>>2]|0;L=K;N=c[L>>2]|0;O=N+8|0;P=c[O>>2]|0;cB[P&1023](K,I);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;I=e;e=M;if((a[v]&1)==0){n=e;o=I;p=o;q=0;r=p;s=n;bg(r|0)}Lw(c[h+8>>2]|0);n=e;o=I;p=o;q=0;r=p;s=n;bg(r|0)}function rK(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+64|0;g=f|0;h=f+16|0;j=f+32|0;k=f+48|0;l=g;m=g;a[m]=18;LF(l+1|0,8760,9)|0;a[l+10|0]=0;l=e+32|0;L1:do{if((a[l]&1)==0){n=h;c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];o=a[n]|0;p=n;q=11}else{n=c[e+40>>2]|0;r=c[e+36>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(r>>>0<11>>>0){s=r<<1&255;t=h;a[t]=s;u=h+1|0;v=s;w=t}else{t=r+16&-16;s=(z=0,au(248,t|0)|0);if(z){z=0;break}c[h+8>>2]=s;x=t|1;c[h>>2]=x;c[h+4>>2]=r;u=s;v=x&255;w=h}LF(u|0,n|0,r)|0;a[u+r|0]=0;o=v;p=w;q=11;break L1}}while(0);r=bT(-1,-1)|0;y=M;A=r}}while(0);do{if((q|0)==11){if((o&1)==0){B=h+1|0}else{B=c[h+8>>2]|0}w=d[p]|0;if((w&1|0)==0){C=w>>>1}else{C=c[h+4>>2]|0}w=(z=0,az(88,g|0,B|0,C|0)|0);do{if(!z){v=b+4|0;u=a[w]|0;if((u&1)==0){D=w+1|0}else{D=c[w+8>>2]|0}l=u&255;if((l&1|0)==0){E=l>>>1}else{E=c[w+4>>2]|0}z=0,az(88,v|0,D|0,E|0)|0;if(z){z=0;break}l=b+20|0;u=c[l>>2]|0;if((u|0)!=0){z=0;as(320,u+64|0,w|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[h+8>>2]|0)}if((a[m]&1)!=0){Lw(c[g+8>>2]|0)}u=c[e+44>>2]|0;if((u|0)!=0){cB[c[(c[u>>2]|0)+8>>2]&1023](u,b|0)}u=e+28|0;L47:do{if((c[u>>2]|0)!=0){r=j;n=j;a[n]=2;x=r+1|0;a[x]=32;a[r+2|0]=0;z=0,az(88,v|0,x|0,1)|0;do{if(!z){x=c[l>>2]|0;if((x|0)!=0){z=0;as(320,x+64|0,j|0);if(z){z=0;break}}if((a[n]&1)!=0){Lw(c[j+8>>2]|0)}x=c[u>>2]|0;cB[c[(c[x>>2]|0)+8>>2]&1023](x,b|0);if((c[u>>2]|0)==0){break L47}i=f;return}else{z=0}}while(0);x=bT(-1,-1)|0;r=x;x=M;if((a[n]&1)==0){F=x;G=r;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[j+8>>2]|0);F=x;G=r;H=G;I=0;J=H;K=F;bg(J|0)}}while(0);u=k;r=k;a[r]=2;x=u+1|0;a[x]=59;a[u+2|0]=0;z=0,az(88,v|0,x|0,1)|0;do{if(!z){x=c[l>>2]|0;if((x|0)!=0){z=0;as(320,x+64|0,k|0);if(z){z=0;break}}if((a[r]&1)==0){i=f;return}Lw(c[k+8>>2]|0);i=f;return}else{z=0}}while(0);l=bT(-1,-1)|0;v=l;l=M;if((a[r]&1)==0){F=l;G=v;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[k+8>>2]|0);F=l;G=v;H=G;I=0;J=H;K=F;bg(J|0)}else{z=0}}while(0);w=bT(-1,-1)|0;v=w;w=M;if((a[p]&1)==0){y=w;A=v;break}Lw(c[h+8>>2]|0);y=w;A=v}}while(0);if((a[m]&1)==0){F=y;G=A;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[g+8>>2]|0);F=y;G=A;H=G;I=0;J=H;K=F;bg(J|0)}function rL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){AE(h+64|0,d|0)}d=f;h=f;a[h]=18;j=d+1|0;LF(j|0,8592,9)|0;a[d+10|0]=0;z=0,az(88,b+4|0,j|0,9)|0;do{if(!z){j=c[g>>2]|0;if((j|0)!=0){z=0;as(320,j+64|0,f|0);if(z){z=0;break}}if((a[h]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[h]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function rM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;e=i;i=i+16|0;f=e|0;g=(c[d+52>>2]|0)==0?2824:8432;h=LJ(g|0)|0;if(h>>>0>4294967279>>>0){D5(0)}if(h>>>0<11>>>0){j=h<<1&255;a[f]=j;k=f+1|0;l=j}else{j=h+16&-16;m=Lu(j)|0;c[f+8>>2]=m;n=j|1;c[f>>2]=n;c[f+4>>2]=h;k=m;l=n&255}LF(k|0,g|0,h)|0;a[k+h|0]=0;h=d+40|0;k=c[h>>2]|0;g=c[d+44>>2]|0;do{if((k|0)==(g|0)){o=l}else{d=g-k>>2;if((d|0)==0){o=l;break}n=b+4|0;m=f;j=f+1|0;p=b+20|0;q=f+4|0;r=f+8|0;s=b|0;t=0;u=0;v=k;L11:while(1){w=c[v+(t<<2)>>2]|0;x=(z=0,au(c[(c[w>>2]|0)+44>>2]|0,w|0)|0);if(z){z=0;break}if(x){y=u}else{do{if(u){x=a[m]|0;A=(x&1)==0?j:c[r>>2]|0;B=x&255;x=(B&1|0)==0?B>>>1:c[q>>2]|0;z=0,az(88,n|0,A|0,x|0)|0;if(z){z=0;break L11}x=c[p>>2]|0;if((x|0)==0){break}z=0;as(320,x+64|0,f|0);if(z){z=0;break L11}}}while(0);z=0;as(c[(c[w>>2]|0)+8>>2]|0,w|0,s|0);if(!z){y=1}else{z=0;break}}x=t+1|0;if(x>>>0>=d>>>0){C=20;break}t=x;u=y;v=c[h>>2]|0}if((C|0)==20){o=a[m]|0;break}v=bT(-1,-1)|0;if((a[m]&1)==0){bg(v|0)}Lw(c[r>>2]|0);bg(v|0)}}while(0);if((o&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}function rN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0;e=i;i=i+208|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=c[d+40>>2]|0;u=b|0;cB[c[(c[t>>2]|0)+8>>2]&1023](t|0,u);L1:do{switch(c[d+36>>2]|0){case 11:{t=r;v=r;a[v]=2;w=t+1|0;a[w]=47;a[t+2|0]=0;z=0,az(88,b+4|0,w|0,1)|0;do{if(!z){w=c[b+20>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,r|0);if(z){z=0;break}}if((a[v]&1)==0){break L1}Lw(c[r+8>>2]|0);break L1}else{z=0}}while(0);w=bT(-1,-1)|0;t=M;if((a[v]&1)==0){x=t;y=w;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[r+8>>2]|0);x=t;y=w;A=y;B=0;C=A;D=x;bg(C|0);break};case 6:{w=m;a[w]=6;t=m+1|0;a[t]=a[6944]|0;a[t+1|0]=a[6945]|0;a[t+2|0]=a[6946]|0;a[m+4|0]=0;z=0,az(88,b+4|0,t|0,3)|0;do{if(!z){t=c[b+20>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,m|0);if(z){z=0;break}}if((a[w]&1)==0){break L1}Lw(c[m+8>>2]|0);break L1}else{z=0}}while(0);v=bT(-1,-1)|0;t=M;if((a[w]&1)==0){x=t;y=v;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[m+8>>2]|0);x=t;y=v;A=y;B=0;C=A;D=x;bg(C|0);break};case 0:{v=f;t=f;a[t]=10;F=v+1|0;a[F]=a[8272]|0;a[F+1|0]=a[8273]|0;a[F+2|0]=a[8274]|0;a[F+3|0]=a[8275]|0;a[F+4|0]=a[8276]|0;a[v+6|0]=0;z=0,az(88,b+4|0,F|0,5)|0;do{if(!z){F=c[b+20>>2]|0;if((F|0)!=0){z=0;as(320,F+64|0,f|0);if(z){z=0;break}}if((a[t]&1)==0){break L1}Lw(c[f+8>>2]|0);break L1}else{z=0}}while(0);w=bT(-1,-1)|0;F=M;if((a[t]&1)==0){x=F;y=w;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[f+8>>2]|0);x=F;y=w;A=y;B=0;C=A;D=x;bg(C|0);break};case 7:{w=n;F=n;a[F]=8;v=w+1|0;G=v;E=540884e3;a[G]=E;E=E>>8;a[G+1|0]=E;E=E>>8;a[G+2|0]=E;E=E>>8;a[G+3|0]=E;a[w+5|0]=0;z=0,az(88,b+4|0,v|0,4)|0;do{if(!z){v=c[b+20>>2]|0;if((v|0)!=0){z=0;as(320,v+64|0,n|0);if(z){z=0;break}}if((a[F]&1)==0){break L1}Lw(c[n+8>>2]|0);break L1}else{z=0}}while(0);t=bT(-1,-1)|0;v=M;if((a[F]&1)==0){x=v;y=t;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[n+8>>2]|0);x=v;y=t;A=y;B=0;C=A;D=x;bg(C|0);break};case 12:{t=s;a[t]=6;v=s+1|0;a[v]=a[6056]|0;a[v+1|0]=a[6057]|0;a[v+2|0]=a[6058]|0;a[s+4|0]=0;z=0,az(88,b+4|0,v|0,3)|0;do{if(!z){v=c[b+20>>2]|0;if((v|0)!=0){z=0;as(320,v+64|0,s|0);if(z){z=0;break}}if((a[t]&1)==0){break L1}Lw(c[s+8>>2]|0);break L1}else{z=0}}while(0);F=bT(-1,-1)|0;v=M;if((a[t]&1)==0){x=v;y=F;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[s+8>>2]|0);x=v;y=F;A=y;B=0;C=A;D=x;bg(C|0);break};case 3:{F=j;v=j;a[v]=8;w=F+1|0;G=w;E=540877088;a[G]=E;E=E>>8;a[G+1|0]=E;E=E>>8;a[G+2|0]=E;E=E>>8;a[G+3|0]=E;a[F+5|0]=0;z=0,az(88,b+4|0,w|0,4)|0;do{if(!z){w=c[b+20>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,j|0);if(z){z=0;break}}if((a[v]&1)==0){break L1}Lw(c[j+8>>2]|0);break L1}else{z=0}}while(0);t=bT(-1,-1)|0;w=M;if((a[v]&1)==0){x=w;y=t;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[j+8>>2]|0);x=w;y=t;A=y;B=0;C=A;D=x;bg(C|0);break};case 9:{t=p;a[t]=6;w=p+1|0;a[w]=a[6352]|0;a[w+1|0]=a[6353]|0;a[w+2|0]=a[6354]|0;a[p+4|0]=0;z=0,az(88,b+4|0,w|0,3)|0;do{if(!z){w=c[b+20>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,p|0);if(z){z=0;break}}if((a[t]&1)==0){break L1}Lw(c[p+8>>2]|0);break L1}else{z=0}}while(0);v=bT(-1,-1)|0;w=M;if((a[t]&1)==0){x=w;y=v;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[p+8>>2]|0);x=w;y=v;A=y;B=0;C=A;D=x;bg(C|0);break};case 8:{v=o;a[v]=6;w=o+1|0;a[w]=a[6576]|0;a[w+1|0]=a[6577]|0;a[w+2|0]=a[6578]|0;a[o+4|0]=0;z=0,az(88,b+4|0,w|0,3)|0;do{if(!z){w=c[b+20>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,o|0);if(z){z=0;break}}if((a[v]&1)==0){break L1}Lw(c[o+8>>2]|0);break L1}else{z=0}}while(0);t=bT(-1,-1)|0;w=M;if((a[v]&1)==0){x=w;y=t;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[o+8>>2]|0);x=w;y=t;A=y;B=0;C=A;D=x;bg(C|0);break};case 10:{t=q;a[t]=6;w=q+1|0;a[w]=a[6256]|0;a[w+1|0]=a[6257]|0;a[w+2|0]=a[6258]|0;a[q+4|0]=0;z=0,az(88,b+4|0,w|0,3)|0;do{if(!z){w=c[b+20>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,q|0);if(z){z=0;break}}if((a[t]&1)==0){break L1}Lw(c[q+8>>2]|0);break L1}else{z=0}}while(0);v=bT(-1,-1)|0;w=M;if((a[t]&1)==0){x=w;y=v;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[q+8>>2]|0);x=w;y=v;A=y;B=0;C=A;D=x;bg(C|0);break};case 4:{v=k;a[v]=6;w=k+1|0;a[w]=a[7360]|0;a[w+1|0]=a[7361]|0;a[w+2|0]=a[7362]|0;a[k+4|0]=0;z=0,az(88,b+4|0,w|0,3)|0;do{if(!z){w=c[b+20>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,k|0);if(z){z=0;break}}if((a[v]&1)==0){break L1}Lw(c[k+8>>2]|0);break L1}else{z=0}}while(0);t=bT(-1,-1)|0;w=M;if((a[v]&1)==0){x=w;y=t;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[k+8>>2]|0);x=w;y=t;A=y;B=0;C=A;D=x;bg(C|0);break};case 5:{t=l;w=l;a[w]=8;F=t+1|0;G=F;E=540884512;a[G]=E;E=E>>8;a[G+1|0]=E;E=E>>8;a[G+2|0]=E;E=E>>8;a[G+3|0]=E;a[t+5|0]=0;z=0,az(88,b+4|0,F|0,4)|0;do{if(!z){F=c[b+20>>2]|0;if((F|0)!=0){z=0;as(320,F+64|0,l|0);if(z){z=0;break}}if((a[w]&1)==0){break L1}Lw(c[l+8>>2]|0);break L1}else{z=0}}while(0);v=bT(-1,-1)|0;F=M;if((a[w]&1)==0){x=F;y=v;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[l+8>>2]|0);x=F;y=v;A=y;B=0;C=A;D=x;bg(C|0);break};case 1:{v=g;F=g;a[F]=8;t=v+1|0;G=t;E=544370464;a[G]=E;E=E>>8;a[G+1|0]=E;E=E>>8;a[G+2|0]=E;E=E>>8;a[G+3|0]=E;a[v+5|0]=0;z=0,az(88,b+4|0,t|0,4)|0;do{if(!z){t=c[b+20>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,g|0);if(z){z=0;break}}if((a[F]&1)==0){break L1}Lw(c[g+8>>2]|0);break L1}else{z=0}}while(0);w=bT(-1,-1)|0;t=M;if((a[F]&1)==0){x=t;y=w;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[g+8>>2]|0);x=t;y=w;A=y;B=0;C=A;D=x;bg(C|0);break};case 2:{w=h;t=h;a[t]=8;v=w+1|0;G=v;E=540884256;a[G]=E;E=E>>8;a[G+1|0]=E;E=E>>8;a[G+2|0]=E;E=E>>8;a[G+3|0]=E;a[w+5|0]=0;z=0,az(88,b+4|0,v|0,4)|0;do{if(!z){v=c[b+20>>2]|0;if((v|0)!=0){z=0;as(320,v+64|0,h|0);if(z){z=0;break}}if((a[t]&1)==0){break L1}Lw(c[h+8>>2]|0);break L1}else{z=0}}while(0);F=bT(-1,-1)|0;v=M;if((a[t]&1)==0){x=v;y=F;A=y;B=0;C=A;D=x;bg(C|0)}Lw(c[h+8>>2]|0);x=v;y=F;A=y;B=0;C=A;D=x;bg(C|0);break};default:{}}}while(0);C=c[d+44>>2]|0;cB[c[(c[C>>2]|0)+8>>2]&1023](C|0,u);i=e;return}function rO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+16|0;L1:do{if((c[d+36>>2]|0)==0){h=f;j=f;a[j]=2;k=h+1|0;a[k]=43;a[h+2|0]=0;h=b+4|0;z=0,az(88,h|0,k|0,1)|0;do{if(!z){k=c[b+20>>2]|0;if((k|0)!=0){z=0;as(320,k+64|0,f|0);if(z){z=0;break}}if((a[j]&1)==0){break L1}Lw(c[f+8>>2]|0);break L1}else{z=0}}while(0);k=bT(-1,-1)|0;h=k;k=M;if((a[j]&1)==0){l=k;m=h;n=m;o=0;p=n;q=l;bg(p|0)}Lw(c[f+8>>2]|0);l=k;m=h;n=m;o=0;p=n;q=l;bg(p|0)}else{h=g;k=g;a[k]=2;r=h+1|0;a[r]=45;a[h+2|0]=0;h=b+4|0;z=0,az(88,h|0,r|0,1)|0;do{if(!z){r=c[b+20>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,g|0);if(z){z=0;break}}if((a[k]&1)==0){break L1}Lw(c[g+8>>2]|0);break L1}else{z=0}}while(0);j=bT(-1,-1)|0;r=j;j=M;if((a[k]&1)==0){l=j;m=r;n=m;o=0;p=n;q=l;bg(p|0)}Lw(c[g+8>>2]|0);l=j;m=r;n=m;o=0;p=n;q=l;bg(p|0)}}while(0);p=c[d+40>>2]|0;cB[c[(c[p>>2]|0)+8>>2]&1023](p|0,b|0);i=e;return}function rP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;e=i;i=i+16|0;f=e|0;g=d+36|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+44>>2]|0;g=c[d+40>>2]|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){l=g<<1&255;m=f;a[m]=l;n=f+1|0;o=l;p=m}else{m=g+16&-16;l=Lu(m)|0;c[f+8>>2]=l;q=m|1;c[f>>2]=q;c[f+4>>2]=g;n=l;o=q&255;p=f}LF(n|0,h|0,g)|0;a[n+g|0]=0;j=o;k=p}if((j&1)==0){r=f+1|0}else{r=c[f+8>>2]|0}p=j&255;if((p&1|0)==0){s=p>>>1}else{s=c[f+4>>2]|0}z=0,az(88,b+4|0,r|0,s|0)|0;do{if(!z){s=c[b+20>>2]|0;if((s|0)!=0){z=0;as(320,s+64|0,f|0);if(z){z=0;break}}if((a[k]&1)==0){t=d+48|0;u=c[t>>2]|0;v=u;w=c[v>>2]|0;x=w+8|0;y=c[x>>2]|0;A=b|0;cB[y&1023](u,A);i=e;return}Lw(c[f+8>>2]|0);t=d+48|0;u=c[t>>2]|0;v=u;w=c[v>>2]|0;x=w+8|0;y=c[x>>2]|0;A=b|0;cB[y&1023](u,A);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[k]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function rQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+36>>2]|0;e=a|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,e);d=c[b+40>>2]|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,e);return}function rR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+36|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+44>>2]|0;g=c[d+40>>2]|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){d=g<<1&255;l=f;a[l]=d;m=f+1|0;n=d;o=l}else{l=g+16&-16;d=Lu(l)|0;c[f+8>>2]=d;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=d;n=p&255;o=f}LF(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}o=j&255;if((o&1|0)==0){r=o>>>1}else{r=c[f+4>>2]|0}z=0,az(88,b+4|0,q|0,r|0)|0;do{if(!z){r=c[b+20>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,f|0);if(z){z=0;break}}if((a[k]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[k]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function rS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+40|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+48>>2]|0;g=c[d+44>>2]|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){d=g<<1&255;l=f;a[l]=d;m=f+1|0;n=d;o=l}else{l=g+16&-16;d=Lu(l)|0;c[f+8>>2]=d;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=d;n=p&255;o=f}LF(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}o=j&255;if((o&1|0)==0){r=o>>>1}else{r=c[f+4>>2]|0}z=0,az(88,b+4|0,q|0,r|0)|0;do{if(!z){r=c[b+20>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,f|0);if(z){z=0;break}}if((a[k]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[k]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function rT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0;e=i;i=i+16|0;f=e|0;g=f;j=i;i=i+144|0;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=j;s=j+64|0;t=j|0;u=j+8|0;v=u|0;c[v>>2]=15464;w=j+12|0;x=j;c[t>>2]=32540;y=j+64|0;c[y>>2]=32560;c[j+4>>2]=0;z=0;as(198,j+64|0,w|0);do{if(!z){c[j+136>>2]=0;c[j+140>>2]=-1;A=j+8|0;c[t>>2]=15444;c[s>>2]=15484;c[v>>2]=15464;B=w|0;c[B>>2]=15768;C=j+16|0;I_(C);LI(j+20|0,0,24)|0;c[B>>2]=15624;D=j+44|0;LI(j+44|0,0,16)|0;c[j+60>>2]=24;LI(g|0,0,12)|0;z=0;as(212,w|0,f|0);if(z){z=0;E=bT(-1,-1)|0;F=M;if((a[g]&1)!=0){Lw(c[f+8>>2]|0)}if((a[D]&1)!=0){Lw(c[j+52>>2]|0)}c[B>>2]=15768;z=0;ar(394,C|0);if(!z){G=F;H=E;break}else{z=0}bT(-1,-1,0)|0;bX()}if((a[g]&1)!=0){Lw(c[f+8>>2]|0)}E=b+20|0;F=c[E>>2]|0;if((F|0)==0){I=5}else{I=c[F+184>>2]|0}c[r+((c[(c[x>>2]|0)-12>>2]|0)+8)>>2]=I;F=u+((c[(c[u>>2]|0)-12>>2]|0)+4)|0;c[F>>2]=c[F>>2]&-261|4;F=u;J=+h[d+40>>3];z=0,aH(2,F|0,+J)|0;do{if(!z){z=0;as(576,k|0,w|0);if(z){z=0;K=33;break}F=k;B=k;L=a[B]|0;N=L&255;if((N&1|0)==0){O=N>>>1;P=k+4|0}else{N=k+4|0;O=c[N>>2]|0;P=N}N=F+1|0;Q=k+8|0;R=O;S=L;L26:while(1){L=R-1|0;T=(S&1)==0;U=S&255;V=(U&1|0)==0;if((a[(T?N:c[Q>>2]|0)+L|0]|0)!=48){K=37;break}if(V){W=U>>>1;X=U>>>1}else{Y=c[P>>2]|0;W=Y;X=Y}Y=X-1|0;do{if(W>>>0<Y>>>0){Z=Y-W|0;z=0,az(82,k|0,Z|0,0)|0;if(z){z=0;K=34;break L26}}else{if(T){a[F+1+Y|0]=0;a[B]=Y<<1;break}else{a[(c[Q>>2]|0)+Y|0]=0;c[P>>2]=Y;break}}}while(0);R=L;S=a[B]|0}L40:do{if((K|0)==37){if(V){_=U>>>1}else{_=c[P>>2]|0}do{if((a[(T?N:c[Q>>2]|0)+(_-1)|0]|0)==46){if(V){$=U>>>1;aa=U>>>1}else{S=c[P>>2]|0;$=S;aa=S}S=aa-1|0;if($>>>0<S>>>0){R=S-$|0;z=0,az(82,k|0,R|0,0)|0;if(!z){K=49;break}else{z=0;break}}if(T){a[F+1+S|0]=0;a[B]=S<<1;K=49;break}else{a[(c[Q>>2]|0)+S|0]=0;c[P>>2]=S;K=49;break}}else{K=49}}while(0);L58:do{if((K|0)==49){if((((c[d+52>>2]|0)-(c[d+48>>2]|0)|0)/12|0)>>>0>1>>>0){K=51}else{if((c[d+64>>2]|0)!=(c[d+60>>2]|0)){K=51}}L62:do{if((K|0)==51){z=0;as(248,n|0,d|0);if(z){z=0;break L58}z=0;aR(210,m|0,k|0,n|0);do{if(!z){L=l;LI(L|0,0,12)|0;S=m;R=a[S]|0;Y=R&255;if((Y&1|0)==0){ab=Y>>>1}else{ab=c[m+4>>2]|0}if((R&1)==0){ac=m+1|0}else{ac=c[m+8>>2]|0}R=ab+25|0;do{if(R>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;K=67;break}}else{if(R>>>0<11>>>0){a[L]=ab<<1;ad=l+1|0}else{Y=ab+41&-16;Z=(z=0,au(248,Y|0)|0);if(z){z=0;K=67;break}c[l+8>>2]=Z;c[l>>2]=Y|1;c[l+4>>2]=ab;ad=Z}LF(ad|0,ac|0,ab)|0;a[ad+ab|0]=0;z=0,az(88,l|0,5736,25)|0;if(z){z=0;K=67;break}Z=d+4|0;L85:do{if((a[Z]&1)==0){Y=o;c[Y>>2]=c[Z>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];K=79}else{Y=c[d+12>>2]|0;ae=c[d+8>>2]|0;do{if(ae>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(ae>>>0<11>>>0){a[o]=ae<<1;af=o+1|0}else{ag=ae+16&-16;ah=(z=0,au(248,ag|0)|0);if(z){z=0;break}c[o+8>>2]=ah;c[o>>2]=ag|1;c[o+4>>2]=ae;af=ah}LF(af|0,Y|0,ae)|0;a[af+ae|0]=0;K=79;break L85}}while(0);ae=bT(-1,-1)|0;ai=M;aj=ae}}while(0);do{if((K|0)==79){Z=p;ae=d+16|0;c[Z>>2]=c[ae>>2];c[Z+4>>2]=c[ae+4>>2];c[Z+8>>2]=c[ae+8>>2];z=0;aR(382,l|0,o|0,p|0);if(z){z=0;ae=bT(-1,-1)|0;Z=ae;ae=M;if((a[o]&1)==0){ai=ae;aj=Z;break}Lw(c[o+8>>2]|0);ai=ae;aj=Z;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[L]&1)!=0){Lw(c[l+8>>2]|0)}if((a[S]&1)!=0){Lw(c[m+8>>2]|0)}if((a[n]&1)==0){break L62}Lw(c[n+8>>2]|0);break L62}}while(0);if((a[L]&1)==0){ak=ai;al=aj;break}Lw(c[l+8>>2]|0);ak=ai;al=aj}}while(0);if((K|0)==67){R=bT(-1,-1)|0;Z=M;if((a[L]&1)!=0){Lw(c[l+8>>2]|0)}ak=Z;al=R}if((a[S]&1)==0){am=ak;an=al;break}Lw(c[m+8>>2]|0);am=ak;an=al}else{z=0;R=bT(-1,-1)|0;am=M;an=R}}while(0);if((a[n]&1)==0){ao=am;ap=an;break L40}Lw(c[n+8>>2]|0);ao=am;ap=an;break L40}}while(0);R=b+4|0;Z=a[B]|0;ae=(Z&1)==0?N:c[Q>>2]|0;Y=Z&255;if((Y&1|0)==0){aq=Y>>>1}else{aq=c[P>>2]|0}z=0,az(88,R|0,ae|0,aq|0)|0;if(z){z=0;break}ae=c[E>>2]|0;if((ae|0)!=0){z=0;as(320,ae+64|0,k|0);if(z){z=0;break}}z=0;as(248,q|0,d|0);if(z){z=0;break}ae=q;Y=a[ae]|0;if((Y&1)==0){at=q+1|0}else{at=c[q+8>>2]|0}Z=Y&255;if((Z&1|0)==0){av=Z>>>1}else{av=c[q+4>>2]|0}z=0,az(88,R|0,at|0,av|0)|0;do{if(!z){R=c[E>>2]|0;if((R|0)!=0){z=0;as(320,R+64|0,q|0);if(z){z=0;break}}if((a[ae]&1)!=0){Lw(c[q+8>>2]|0)}if((a[B]&1)!=0){Lw(c[Q>>2]|0)}c[t>>2]=15444;c[y>>2]=15484;c[A>>2]=15464;R=j+12|0;c[R>>2]=15624;if((a[D]&1)!=0){Lw(c[j+52>>2]|0)}c[R>>2]=15768;z=0;ar(394,C|0);if(!z){Ex(j+64|0);i=e;return}else{z=0}R=bT(-1,-1)|0;z=0;ar(272,j+64|0);if(!z){bg(R|0)}else{z=0;bT(-1,-1,0)|0;bX()}}else{z=0}}while(0);R=bT(-1,-1)|0;Z=R;R=M;if((a[ae]&1)==0){ao=R;ap=Z;break L40}Lw(c[q+8>>2]|0);ao=R;ap=Z;break L40}}while(0);Z=bT(-1,-1)|0;aw=M;ax=Z;K=36}else if((K|0)==34){Z=bT(-1,-1)|0;aw=M;ax=Z;K=36}}while(0);if((K|0)==36){ao=aw;ap=ax}if((a[B]&1)==0){ay=ao;aA=ap;break}Lw(c[Q>>2]|0);ay=ao;aA=ap}else{z=0;K=33}}while(0);if((K|0)==33){E=bT(-1,-1)|0;ay=M;aA=E}c[t>>2]=15444;c[y>>2]=15484;c[A>>2]=15464;E=j+12|0;c[E>>2]=15624;if((a[D]&1)!=0){Lw(c[j+52>>2]|0)}c[E>>2]=15768;z=0;ar(394,C|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,j+64|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,j+64|0);if(!z){bg(aA|0)}else{z=0}bT(-1,-1,0)|0;bX()}else{z=0;E=bT(-1,-1)|0;G=M;H=E}}while(0);z=0;ar(272,s|0);if(!z){bg(H|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function rU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0;e=i;i=i+16|0;f=e|0;g=f;j=i;i=i+144|0;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+4|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=j+64|0;p=j|0;q=j+8|0;r=q|0;c[r>>2]=15464;s=j+12|0;c[p>>2]=32540;t=j+64|0;c[t>>2]=32560;c[j+4>>2]=0;z=0;as(198,j+64|0,s|0);do{if(!z){c[j+136>>2]=0;c[j+140>>2]=-1;u=j+8|0;c[p>>2]=15444;c[o>>2]=15484;c[r>>2]=15464;v=s|0;c[v>>2]=15768;w=j+16|0;I_(w);LI(j+20|0,0,24)|0;c[v>>2]=15624;x=j+44|0;LI(j+44|0,0,16)|0;c[j+60>>2]=24;LI(g|0,0,12)|0;z=0;as(212,s|0,f|0);if(z){z=0;y=bT(-1,-1)|0;A=M;if((a[g]&1)!=0){Lw(c[f+8>>2]|0)}if((a[x]&1)!=0){Lw(c[j+52>>2]|0)}c[v>>2]=15768;z=0;ar(394,w|0);if(!z){B=y;C=A;break}else{z=0}bT(-1,-1,0)|0;bX()}if((a[g]&1)!=0){Lw(c[f+8>>2]|0)}D=+h[d+40>>3];if(D>255.0){E=255.0}else{E=D<0.0?0.0:D}D=+h[d+48>>3];if(D>255.0){F=255.0}else{F=D<0.0?0.0:D}D=+h[d+56>>3];if(D>255.0){G=255.0}else{G=D<0.0?0.0:D}D=+h[d+64>>3];if(D>1.0){H=1.0}else{H=D<0.0?0.0:D}A=d+72|0;do{if((a[A]&1)==0){y=k;c[y>>2]=c[A>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];I=a[y]|0;J=y;K=33}else{y=c[d+80>>2]|0;v=c[d+76>>2]|0;if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;K=52;break}}if(v>>>0<11>>>0){L=v<<1&255;N=k;a[N]=L;O=k+1|0;P=L;Q=N}else{N=v+16&-16;L=(z=0,au(248,N|0)|0);if(z){z=0;K=52;break}c[k+8>>2]=L;R=N|1;c[k>>2]=R;c[k+4>>2]=v;O=L;P=R&255;Q=k}LF(O|0,y|0,v)|0;a[O+v|0]=0;I=P;J=Q;K=33}}while(0);L41:do{if((K|0)==33){v=I&255;if((v&1|0)==0){S=v>>>1}else{S=c[k+4>>2]|0}if((a[J]&1)!=0){Lw(c[k+8>>2]|0)}L50:do{if((S|0)==0){if(H<1.0){v=q;z=0,aM(114,v|0,5696)|0;if(z){z=0;K=52;break L41}y=(z=0,aM(310,v|0,~~E|0)|0);if(z){z=0;K=52;break L41}z=0,aM(114,y|0,8432)|0;if(z){z=0;K=52;break L41}y=(z=0,aM(310,v|0,~~F|0)|0);if(z){z=0;K=52;break L41}z=0,aM(114,y|0,8432)|0;if(z){z=0;K=52;break L41}y=(z=0,aM(310,v|0,~~G|0)|0);if(z){z=0;K=52;break L41}z=0,aM(114,y|0,8432)|0;if(z){z=0;K=52;break L41}y=(z=0,aH(2,v|0,+H)|0);if(z){z=0;K=52;break L41}z=0,aM(106,y|0,41)|0;if(!z){break}else{z=0;K=52;break L41}}y=~~(+(~~(+(~~(E*65536.0)|0)+F*256.0)|0)+G);c[m>>2]=y;v=c[b+20>>2]|0;L63:do{if((v|0)!=0){R=c[v+176>>2]|0;if((R|0)==0){break}else{T=R}while(1){R=c[T+16>>2]|0;if((y|0)<(R|0)){U=T|0}else{if((R|0)>=(y|0)){break}U=T+4|0}T=c[U>>2]|0;if((T|0)==0){break L63}}R=(z=0,aM(722,v+172|0,m|0)|0);if(z){z=0;K=52;break L41}z=0,aM(814,q|0,R|0)|0;if(!z){break L50}else{z=0;K=52;break L41}}}while(0);v=q;y=(z=0,aM(106,v|0,35)|0);if(z){z=0;K=52;break L41}R=y;L=y;c[L+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;c[L+((c[(c[R>>2]|0)-12>>2]|0)+76)>>2]=48;R=q;L=q;y=L+((c[(c[R>>2]|0)-12>>2]|0)+4)|0;c[y>>2]=c[y>>2]&-75|8;c[L+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;y=~~+W(E+.5);z=0,aM(310,v|0,y|0)|0;if(z){z=0;K=52;break L41}y=L+((c[(c[R>>2]|0)-12>>2]|0)+4)|0;c[y>>2]=c[y>>2]&-75|8;c[L+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;y=~~+W(F+.5);z=0,aM(310,v|0,y|0)|0;if(z){z=0;K=52;break L41}y=L+((c[(c[R>>2]|0)-12>>2]|0)+4)|0;c[y>>2]=c[y>>2]&-75|8;c[L+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;R=~~+W(G+.5);z=0,aM(310,v|0,R|0)|0;if(z){z=0;K=52;break L41}}else{if((a[A]&1)==0){R=l;c[R>>2]=c[A>>2];c[R+4>>2]=c[A+4>>2];c[R+8>>2]=c[A+8>>2]}else{R=c[d+80>>2]|0;v=c[d+76>>2]|0;if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;K=52;break L41}}if(v>>>0<11>>>0){a[l]=v<<1;V=l+1|0}else{L=v+16&-16;y=(z=0,au(248,L|0)|0);if(z){z=0;K=52;break L41}c[l+8>>2]=y;c[l>>2]=L|1;c[l+4>>2]=v;V=y}LF(V|0,R|0,v)|0;a[V+v|0]=0}v=q;z=0,aM(814,v|0,l|0)|0;if(!z){if((a[l]&1)==0){break}Lw(c[l+8>>2]|0);break}else{z=0;v=bT(-1,-1)|0;R=v;v=M;if((a[l]&1)==0){X=v;Y=R;break L41}Lw(c[l+8>>2]|0);X=v;Y=R;break L41}}}while(0);z=0;as(576,n|0,s|0);if(z){z=0;K=52;break}R=b+4|0;v=n;y=a[v]|0;if((y&1)==0){Z=n+1|0}else{Z=c[n+8>>2]|0}L=y&255;if((L&1|0)==0){_=L>>>1}else{_=c[n+4>>2]|0}z=0,az(88,R|0,Z|0,_|0)|0;do{if(!z){R=c[b+20>>2]|0;if((R|0)!=0){z=0;as(320,R+64|0,n|0);if(z){z=0;break}}if((a[v]&1)!=0){Lw(c[n+8>>2]|0)}c[p>>2]=15444;c[t>>2]=15484;c[u>>2]=15464;R=j+12|0;c[R>>2]=15624;if((a[x]&1)!=0){Lw(c[j+52>>2]|0)}c[R>>2]=15768;z=0;ar(394,w|0);if(!z){Ex(j+64|0);i=e;return}else{z=0}R=bT(-1,-1)|0;z=0;ar(272,j+64|0);if(!z){bg(R|0)}else{z=0;bT(-1,-1,0)|0;bX()}}else{z=0}}while(0);R=bT(-1,-1)|0;L=R;R=M;if((a[v]&1)==0){X=R;Y=L;break}Lw(c[n+8>>2]|0);X=R;Y=L}}while(0);if((K|0)==52){A=bT(-1,-1)|0;X=M;Y=A}c[p>>2]=15444;c[t>>2]=15484;c[u>>2]=15464;A=j+12|0;c[A>>2]=15624;if((a[x]&1)!=0){Lw(c[j+52>>2]|0)}c[A>>2]=15768;z=0;ar(394,w|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,j+64|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,j+64|0);if(!z){bg(Y|0)}else{z=0}bT(-1,-1,0)|0;bX()}else{z=0;A=bT(-1,-1)|0;B=A;C=M}}while(0);z=0;ar(272,o|0);if(!z){bg(B|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function rV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e|0;g=(a[d+36|0]&1)!=0?5656:5576;d=LJ(g|0)|0;if(d>>>0>4294967279>>>0){D5(0)}if(d>>>0<11>>>0){h=d<<1&255;j=f;a[j]=h;k=f+1|0;l=h;m=j}else{j=d+16&-16;h=Lu(j)|0;c[f+8>>2]=h;n=j|1;c[f>>2]=n;c[f+4>>2]=d;k=h;l=n&255;m=f}LF(k|0,g|0,d)|0;a[k+d|0]=0;if((l&1)==0){o=f+1|0}else{o=c[f+8>>2]|0}d=l&255;if((d&1|0)==0){p=d>>>1}else{p=c[f+4>>2]|0}z=0,az(88,b+4|0,o|0,p|0)|0;do{if(!z){p=c[b+20>>2]|0;if((p|0)!=0){z=0;as(320,p+64|0,f|0);if(z){z=0;break}}if((a[m]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[m]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function rW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=d+44|0;j=c[h>>2]|0;k=(c[d+48>>2]|0)-j>>2;if((k|0)==0){i=e;return}d=b|0;l=g;m=g;n=l+1|0;o=l+2|0;l=b+4|0;p=b+20|0;b=g+8|0;q=f;r=f;s=q+1|0;t=s;u=q+3|0;q=f+8|0;v=0;w=j;L4:while(1){do{if((a[(c[w+(v<<2)>>2]|0)+29|0]&1)!=0){a[r]=4;E=31523;a[t]=E;E=E>>8;a[t+1|0]=E;a[u]=0;z=0,az(88,l|0,s|0,2)|0;if(z){z=0;x=9;break L4}j=c[p>>2]|0;if((j|0)!=0){z=0;as(320,j+64|0,f|0);if(z){z=0;x=9;break L4}}if((a[r]&1)==0){break}Lw(c[q>>2]|0)}}while(0);j=c[(c[h>>2]|0)+(v<<2)>>2]|0;cB[c[(c[j>>2]|0)+8>>2]&1023](j|0,d);do{if((a[(c[(c[h>>2]|0)+(v<<2)>>2]|0)+29|0]&1)!=0){a[m]=2;a[n]=125;a[o]=0;z=0,az(88,l|0,n|0,1)|0;if(z){z=0;x=17;break L4}j=c[p>>2]|0;if((j|0)!=0){z=0;as(320,j+64|0,g|0);if(z){z=0;x=17;break L4}}if((a[m]&1)==0){break}Lw(c[b>>2]|0)}}while(0);j=v+1|0;if(j>>>0>=k>>>0){x=28;break}v=j;w=c[h>>2]|0}if((x|0)==9){h=bT(-1,-1)|0;w=h;h=M;if((a[r]&1)==0){y=h;A=w;B=A;C=0;D=B;F=y;bg(D|0)}Lw(c[q>>2]|0);y=h;A=w;B=A;C=0;D=B;F=y;bg(D|0)}else if((x|0)==17){w=bT(-1,-1)|0;h=w;w=M;if((a[m]&1)==0){y=w;A=h;B=A;C=0;D=B;F=y;bg(D|0)}Lw(c[b>>2]|0);y=w;A=h;B=A;C=0;D=B;F=y;bg(D|0)}else if((x|0)==28){i=e;return}}function rX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=d+40|0;j=(a[h]&1)==0;L1:do{if((a[d+36|0]&1)==0){if(j){k=f;c[k>>2]=c[h>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];l=1;m=0;n=21;break}k=c[d+48>>2]|0;o=c[d+44>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[f]=o<<1;p=f+1|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[f+8>>2]=r;c[f>>2]=q|1;c[f+4>>2]=o;p=r}LF(p|0,k|0,o)|0;a[p+o|0]=0;l=1;m=0;n=21;break L1}}while(0);o=bT(-1,-1)|0;s=o;t=M;u=s;v=0;w=u;x=t;bg(w|0)}else{if(j){o=g;c[o>>2]=c[h>>2];c[o+4>>2]=c[h+4>>2];c[o+8>>2]=c[h+8>>2]}else{o=c[d+48>>2]|0;k=c[d+44>>2]|0;if(k>>>0>4294967279>>>0){D5(0)}if(k>>>0<11>>>0){a[g]=k<<1;y=g+1|0}else{r=k+16&-16;q=Lu(r)|0;c[g+8>>2]=q;c[g>>2]=r|1;c[g+4>>2]=k;y=q}LF(y|0,o|0,k)|0;a[y+k|0]=0}z=0;as(180,f|0,g|0);if(!z){l=0;m=1;n=21;break}else{z=0}k=bT(-1,-1)|0;A=M;B=k}}while(0);do{if((n|0)==21){y=b+4|0;d=f;h=a[d]|0;if((h&1)==0){C=f+1|0}else{C=c[f+8>>2]|0}j=h&255;if((j&1|0)==0){D=j>>>1}else{D=c[f+4>>2]|0}z=0,az(88,y|0,C|0,D|0)|0;do{if(!z){y=c[b+20>>2]|0;if((y|0)!=0){z=0;as(320,y+64|0,f|0);if(z){z=0;break}}do{if(l){if((a[d]&1)==0){break}Lw(c[f+8>>2]|0)}}while(0);if(!m){i=e;return}if((a[d]&1)!=0){Lw(c[f+8>>2]|0)}if((a[g]&1)==0){i=e;return}Lw(c[g+8>>2]|0);i=e;return}else{z=0}}while(0);y=bT(-1,-1)|0;j=y;y=M;do{if(l){if((a[d]&1)==0){n=44;break}Lw(c[f+8>>2]|0);if(m){break}else{s=j;t=y}u=s;v=0;w=u;x=t;bg(w|0)}else{n=44}}while(0);do{if((n|0)==44){if(m){break}else{s=j;t=y}u=s;v=0;w=u;x=t;bg(w|0)}}while(0);if((a[d]&1)==0){A=y;B=j;break}Lw(c[f+8>>2]|0);A=y;B=j}}while(0);if((a[g]&1)==0){s=B;t=A;u=s;v=0;w=u;x=t;bg(w|0)}Lw(c[g+8>>2]|0);s=B;t=A;u=s;v=0;w=u;x=t;bg(w|0)}function rY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+16|0;f=e|0;g=f;h=d;j=d;k=a[j]|0;l=k&255;m=(l&1|0)==0;if(m){n=l>>>1}else{n=c[d+4>>2]|0}if((n|0)==0){a[b]=0;a[b+1|0]=0;i=e;return}if(m){o=l>>>1}else{o=c[d+4>>2]|0}n=k&1;do{if((o|0)==1){k=n<<24>>24==0;if(k){p=h+1|0}else{p=c[d+8>>2]|0}if((a[p]|0)!=34){if(k){q=h+1|0}else{q=c[d+8>>2]|0}if((a[q]|0)!=39){break}}a[b]=0;a[b+1|0]=0;i=e;return}}while(0);q=n<<24>>24==0;if(q){r=h+1|0}else{r=c[d+8>>2]|0}if((a[r]|0)==34){if(q){s=h+1|0}else{s=c[d+8>>2]|0}if(m){t=l>>>1}else{t=c[d+4>>2]|0}if((a[s+(t-1)|0]|0)==34){u=34}else{v=30}}else{v=30}do{if((v|0)==30){if(q){w=h+1|0}else{w=c[d+8>>2]|0}if((a[w]|0)==39){if(q){x=h+1|0}else{x=c[d+8>>2]|0}if(m){y=l>>>1}else{y=c[d+4>>2]|0}if((a[x+(y-1)|0]|0)==39){u=39;break}}if(q){t=b;c[t>>2]=c[j>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];i=e;return}t=c[d+8>>2]|0;s=c[d+4>>2]|0;if(s>>>0>4294967279>>>0){D5(0)}if(s>>>0<11>>>0){a[b]=s<<1;A=b+1|0}else{r=s+16&-16;n=Lu(r)|0;c[b+8>>2]=n;c[b>>2]=r|1;c[b+4>>2]=s;A=n}LF(A|0,t|0,s)|0;a[A+s|0]=0;i=e;return}}while(0);LI(g|0,0,12)|0;if(m){B=l>>>1}else{B=c[d+4>>2]|0}z=0;as(620,f|0,B-2|0);L76:do{if(!z){B=a[j]|0;l=B&255;if((l&1|0)==0){C=l>>>1}else{C=c[d+4>>2]|0}l=C-1|0;L82:do{if(l>>>0>1>>>0){m=h+1|0;A=f+1|0;q=f+8|0;y=f+4|0;x=f|0;w=d+8|0;s=1;t=B;while(1){if((t&1)==0){D=m}else{D=c[w>>2]|0}if((a[D+s|0]|0)==(u|0)){n=a[g]|0;r=n&255;if((r&1|0)==0){E=r>>>1;F=r>>>1}else{r=c[y>>2]|0;E=r;F=r}r=F-1|0;if(E>>>0<r>>>0){v=65;break}if((n&1)==0){a[g]=r<<1;G=A}else{n=c[q>>2]|0;c[y>>2]=r;G=n}a[G+r|0]=0;H=a[j]|0}else{H=t}if((H&1)==0){I=m}else{I=c[w>>2]|0}r=a[I+s|0]|0;n=a[g]|0;if((n&1)==0){J=(n&255)>>>1;K=10;L=n}else{p=c[x>>2]|0;J=c[y>>2]|0;K=(p&-2)-1|0;L=p&255}if((J|0)==(K|0)){if((K|0)==-17){v=82;break}p=(L&1)==0?A:c[q>>2]|0;do{if(K>>>0<2147483623>>>0){o=K+1|0;k=K<<1;N=o>>>0<k>>>0?k:o;if(N>>>0<11>>>0){O=11;break}O=N+16&-16}else{O=-17}}while(0);N=(z=0,au(248,O|0)|0);if(z){z=0;v=71;break}LF(N|0,p|0,K)|0;if((K|0)!=10){Lw(p)}c[q>>2]=N;N=O|1;c[x>>2]=N;P=N&255}else{P=n}if((P&1)==0){a[g]=(J<<1)+2;Q=A;R=J+1|0}else{N=c[q>>2]|0;o=J+1|0;c[y>>2]=o;Q=N;R=o}a[Q+J|0]=r;a[Q+R|0]=0;o=s+1|0;if(o>>>0>=l>>>0){break L82}s=o;t=a[j]|0}if((v|0)==65){z=0;ar(240,0);if(z){z=0;v=72;break L76}}else if((v|0)==71){t=bT(-1,-1)|0;S=M;T=t;U=L;break L76}else if((v|0)==82){z=0;ar(86,0);if(z){z=0;v=72;break L76}}}}while(0);l=(a[g]&1)==0;if(l){B=b;c[B>>2]=c[g>>2];c[B+4>>2]=c[g+4>>2];c[B+8>>2]=c[g+8>>2];i=e;return}B=c[f+8>>2]|0;t=c[f+4>>2]|0;if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;v=72;break}}if(t>>>0<11>>>0){a[b]=t<<1;V=b+1|0}else{s=t+16&-16;y=(z=0,au(248,s|0)|0);if(z){z=0;v=72;break}c[b+8>>2]=y;c[b>>2]=s|1;c[b+4>>2]=t;V=y}LF(V|0,B|0,t)|0;a[V+t|0]=0;if(l){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0;v=72}}while(0);if((v|0)==72){v=bT(-1,-1)|0;S=M;T=v;U=a[g]|0}if((U&1)==0){bg(T|0)}Lw(c[f+8>>2]|0);bg(T|0)}function rZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+52|0;if((c[j>>2]|0)==0){k=d+40|0;l=c[c[k>>2]>>2]|0;cB[c[(c[l>>2]|0)+8>>2]&1023](l,b|0);m=1;n=k}else{L4:do{if((a[d+56|0]&1)==0){if((a[d+57|0]&1)==0){break}k=g;l=g;a[l]=10;o=k+1|0;a[o]=a[5296]|0;a[o+1|0]=a[5297]|0;a[o+2|0]=a[5298]|0;a[o+3|0]=a[5299]|0;a[o+4|0]=a[5300]|0;a[k+6|0]=0;k=b+4|0;z=0,az(88,k|0,o|0,5)|0;do{if(!z){o=c[b+20>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,g|0);if(z){z=0;break}}if((a[l]&1)==0){break L4}Lw(c[g+8>>2]|0);break L4}else{z=0}}while(0);o=bT(-1,-1)|0;k=o;o=M;if((a[l]&1)==0){p=o;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[g+8>>2]|0);p=o;q=k;r=q;s=0;t=r;u=p;bg(t|0)}else{k=f;o=f;a[o]=8;v=k+1|0;w=v;E=544501614;a[w]=E;E=E>>8;a[w+1|0]=E;E=E>>8;a[w+2|0]=E;E=E>>8;a[w+3|0]=E;a[k+5|0]=0;k=b+4|0;z=0,az(88,k|0,v|0,4)|0;do{if(!z){v=c[b+20>>2]|0;if((v|0)!=0){z=0;as(320,v+64|0,f|0);if(z){z=0;break}}if((a[o]&1)==0){break L4}Lw(c[f+8>>2]|0);break L4}else{z=0}}while(0);l=bT(-1,-1)|0;v=l;l=M;if((a[o]&1)==0){p=l;q=v;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[f+8>>2]|0);p=l;q=v;r=q;s=0;t=r;u=p;bg(t|0)}}while(0);f=c[j>>2]|0;cB[c[(c[f>>2]|0)+8>>2]&1023](f,b|0);m=0;n=d+40|0}f=(c[d+44>>2]|0)-(c[n>>2]|0)>>2;if(m>>>0>=f>>>0){i=e;return}d=h;j=h;g=d+1|0;v=d+6|0;d=b+4|0;l=b+20|0;k=b|0;b=h+8|0;w=m;while(1){a[j]=10;a[g]=a[8272]|0;a[g+1|0]=a[8273]|0;a[g+2|0]=a[8274]|0;a[g+3|0]=a[8275]|0;a[g+4|0]=a[8276]|0;a[v]=0;z=0,az(88,d|0,g|0,5)|0;if(z){z=0;break}m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,h|0);if(z){z=0;break}}if((a[j]&1)!=0){Lw(c[b>>2]|0)}m=c[(c[n>>2]|0)+(w<<2)>>2]|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m,k);m=w+1|0;if(m>>>0<f>>>0){w=m}else{x=33;break}}if((x|0)==33){i=e;return}e=bT(-1,-1)|0;x=e;e=M;if((a[j]&1)==0){p=e;q=x;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b>>2]|0);p=e;q=x;r=q;s=0;t=r;u=p;bg(t|0)}function r_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;if((a[d+44|0]&1)!=0){j=c[d+36>>2]|0;cB[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);i=e;return}j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,1)|0;do{if(!z){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}m=c[d+36>>2]|0;n=b|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m|0,n);m=d+40|0;L13:do{if((c[m>>2]|0)!=0){o=g;p=g;a[p]=4;q=o+1|0;r=q;E=8250;a[r]=E;E=E>>8;a[r+1|0]=E;a[o+3|0]=0;z=0,az(88,j|0,q|0,2)|0;do{if(!z){q=c[l>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,g|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[g+8>>2]|0)}q=c[m>>2]|0;cB[c[(c[q>>2]|0)+8>>2]&1023](q|0,n);break L13}else{z=0}}while(0);q=bT(-1,-1)|0;o=q;q=M;if((a[p]&1)==0){s=q;t=o;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[g+8>>2]|0);s=q;t=o;u=t;v=0;w=u;x=s;bg(w|0)}}while(0);n=h;m=h;a[m]=2;o=n+1|0;a[o]=41;a[n+2|0]=0;z=0,az(88,j|0,o|0,1)|0;do{if(!z){o=c[l>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,h|0);if(z){z=0;break}}if((a[m]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);l=bT(-1,-1)|0;o=l;l=M;if((a[m]&1)==0){s=l;t=o;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[h+8>>2]|0);s=l;t=o;u=t;v=0;w=u;x=s;bg(w|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[k]&1)==0){s=h;t=e;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[f+8>>2]|0);s=h;t=e;u=t;v=0;w=u;x=s;bg(w|0)}function r$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d|0;f=e;g=e;a[g]=8;h=f+1|0;j=h;E=1819047278;a[j]=E;E=E>>8;a[j+1|0]=E;E=E>>8;a[j+2|0]=E;E=E>>8;a[j+3|0]=E;a[f+5|0]=0;z=0,az(88,b+4|0,h|0,4)|0;do{if(!z){h=c[b+20>>2]|0;if((h|0)!=0){z=0;as(320,h+64|0,e|0);if(z){z=0;break}}if((a[g]&1)==0){i=d;return}Lw(c[e+8>>2]|0);i=d;return}else{z=0}}while(0);d=bT(-1,-1)|0;if((a[g]&1)==0){bg(d|0)}Lw(c[e+8>>2]|0);bg(d|0)}function r0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+28|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+36>>2]|0;j=c[d+32>>2]|0;if(j>>>0>4294967279>>>0){D5(0)}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=Lu(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}LF(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+4|0;if((l&1)==0){t=f+1|0}else{t=c[f+8>>2]|0}q=l&255;if((q&1|0)==0){u=q>>>1}else{u=c[f+4>>2]|0}z=0,az(88,r|0,t|0,u|0)|0;do{if(!z){u=b+20|0;t=c[u>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,f|0);if(z){z=0;break}}if((a[m]&1)!=0){Lw(c[f+8>>2]|0)}t=d+40|0;if((c[t>>2]|0)!=0){q=g;l=g;a[l]=4;j=q+1|0;p=j;E=8250;a[p]=E;E=E>>8;a[p+1|0]=E;a[q+3|0]=0;z=0,az(88,r|0,j|0,2)|0;do{if(!z){j=c[u>>2]|0;if((j|0)!=0){z=0;as(320,j+64|0,g|0);if(z){z=0;break}}if((a[l]&1)!=0){Lw(c[g+8>>2]|0)}j=c[t>>2]|0;cB[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);i=e;return}else{z=0}}while(0);t=bT(-1,-1)|0;j=t;t=M;if((a[l]&1)==0){v=t;w=j;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[g+8>>2]|0);v=t;w=j;x=w;y=0;A=x;B=v;bg(A|0)}if((a[d+44|0]&1)==0){i=e;return}j=h;a[j]=6;t=h+1|0;a[t]=a[4576]|0;a[t+1|0]=a[4577]|0;a[t+2|0]=a[4578]|0;a[h+4|0]=0;z=0,az(88,r|0,t|0,3)|0;do{if(!z){t=c[u>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,h|0);if(z){z=0;break}}if((a[j]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);u=bT(-1,-1)|0;l=u;u=M;if((a[j]&1)==0){v=u;w=l;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[h+8>>2]|0);v=u;w=l;x=w;y=0;A=x;B=v;bg(A|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[m]&1)==0){v=h;w=e;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[f+8>>2]|0);v=h;w=e;x=w;y=0;A=x;B=v;bg(A|0)}function r1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,1)|0;do{if(!z){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}m=d+32|0;n=c[m>>2]|0;o=d+36|0;L9:do{if((n|0)!=(c[o>>2]|0)){p=c[n>>2]|0;q=b|0;cB[c[(c[p>>2]|0)+8>>2]&1023](p,q);p=(c[o>>2]|0)-(c[m>>2]|0)>>2;if(p>>>0<=1>>>0){break}r=g;s=g;t=r+1|0;u=t;v=r+3|0;r=g+8|0;w=1;while(1){a[s]=4;E=8236;a[u]=E;E=E>>8;a[u+1|0]=E;a[v]=0;z=0,az(88,j|0,t|0,2)|0;if(z){z=0;break}x=c[l>>2]|0;if((x|0)!=0){z=0;as(320,x+64|0,g|0);if(z){z=0;break}}if((a[s]&1)!=0){Lw(c[r>>2]|0)}x=c[(c[m>>2]|0)+(w<<2)>>2]|0;cB[c[(c[x>>2]|0)+8>>2]&1023](x,q);w=w+1|0;if(w>>>0>=p>>>0){break L9}}p=bT(-1,-1)|0;w=p;p=M;if((a[s]&1)==0){y=w;A=p;B=y;C=0;D=B;F=A;bg(D|0)}Lw(c[r>>2]|0);y=w;A=p;B=y;C=0;D=B;F=A;bg(D|0)}}while(0);m=h;o=h;a[o]=2;n=m+1|0;a[n]=41;a[m+2|0]=0;z=0,az(88,j|0,n|0,1)|0;do{if(!z){n=c[l>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,h|0);if(z){z=0;break}}if((a[o]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);l=bT(-1,-1)|0;n=l;l=M;if((a[o]&1)==0){y=n;A=l;B=y;C=0;D=B;F=A;bg(D|0)}Lw(c[h+8>>2]|0);y=n;A=l;B=y;C=0;D=B;F=A;bg(D|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[k]&1)==0){y=e;A=h;B=y;C=0;D=B;F=A;bg(D|0)}Lw(c[f+8>>2]|0);y=e;A=h;B=y;C=0;D=B;F=A;bg(D|0)}function r2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+40|0;if((a[k]&1)==0){l=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];m=a[l]|0;n=l}else{l=c[d+48>>2]|0;o=c[d+44>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){p=o<<1&255;q=f;a[q]=p;r=f+1|0;s=p;t=q}else{q=o+16&-16;p=Lu(q)|0;c[f+8>>2]=p;u=q|1;c[f>>2]=u;c[f+4>>2]=o;r=p;s=u&255;t=f}LF(r|0,l|0,o)|0;a[r+o|0]=0;m=s;n=t}t=m&255;if((t&1|0)==0){v=t>>>1}else{v=c[f+4>>2]|0}if((a[n]&1)!=0){Lw(c[f+8>>2]|0)}L19:do{if((v|0)!=0){if((a[k]&1)==0){f=g;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];w=a[f]|0;x=f}else{f=c[d+48>>2]|0;n=c[d+44>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){t=n<<1&255;m=g;a[m]=t;y=g+1|0;A=t;B=m}else{m=n+16&-16;t=Lu(m)|0;c[g+8>>2]=t;s=m|1;c[g>>2]=s;c[g+4>>2]=n;y=t;A=s&255;B=g}LF(y|0,f|0,n)|0;a[y+n|0]=0;w=A;x=B}n=b+4|0;if((w&1)==0){C=g+1|0}else{C=c[g+8>>2]|0}f=w&255;if((f&1|0)==0){D=f>>>1}else{D=c[g+4>>2]|0}z=0,az(88,n|0,C|0,D|0)|0;do{if(!z){f=b+20|0;s=c[f>>2]|0;if((s|0)!=0){z=0;as(320,s+64|0,g|0);if(z){z=0;break}}if((a[x]&1)!=0){Lw(c[g+8>>2]|0)}s=h;t=h;a[t]=4;m=s+1|0;o=m;E=8250;a[o]=E;E=E>>8;a[o+1|0]=E;a[s+3|0]=0;z=0,az(88,n|0,m|0,2)|0;do{if(!z){m=c[f>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,h|0);if(z){z=0;break}}if((a[t]&1)==0){break L19}Lw(c[h+8>>2]|0);break L19}else{z=0}}while(0);f=bT(-1,-1)|0;m=f;f=M;if((a[t]&1)==0){F=f;G=m;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[h+8>>2]|0);F=f;G=m;H=G;I=0;J=H;K=F;bg(J|0)}else{z=0}}while(0);n=bT(-1,-1)|0;m=n;n=M;if((a[x]&1)==0){F=n;G=m;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[g+8>>2]|0);F=n;G=m;H=G;I=0;J=H;K=F;bg(J|0)}}while(0);g=c[d+36>>2]|0;if((c[g+32>>2]|0)==6){i=e;return}cB[c[(c[g>>2]|0)+8>>2]&1023](g|0,b|0);if((a[d+52|0]&1)==0){i=e;return}d=j;a[d]=6;g=j+1|0;a[g]=a[4576]|0;a[g+1|0]=a[4577]|0;a[g+2|0]=a[4578]|0;a[j+4|0]=0;z=0,az(88,b+4|0,g|0,3)|0;do{if(!z){g=c[b+20>>2]|0;if((g|0)!=0){z=0;as(320,g+64|0,j|0);if(z){z=0;break}}if((a[d]&1)==0){i=e;return}Lw(c[j+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;b=e;e=M;if((a[d]&1)==0){F=e;G=b;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[j+8>>2]|0);F=e;G=b;H=G;I=0;J=H;K=F;bg(J|0)}function r3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,1)|0;do{if(!z){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}m=d+40|0;n=c[m>>2]|0;o=d+44|0;L9:do{if((n|0)!=(c[o>>2]|0)){p=c[n>>2]|0;q=b|0;cB[c[(c[p>>2]|0)+8>>2]&1023](p,q);p=(c[o>>2]|0)-(c[m>>2]|0)>>2;if(p>>>0<=1>>>0){break}r=g;s=g;t=r+1|0;u=t;v=r+3|0;r=g+8|0;w=1;while(1){a[s]=4;E=8236;a[u]=E;E=E>>8;a[u+1|0]=E;a[v]=0;z=0,az(88,j|0,t|0,2)|0;if(z){z=0;break}x=c[l>>2]|0;if((x|0)!=0){z=0;as(320,x+64|0,g|0);if(z){z=0;break}}if((a[s]&1)!=0){Lw(c[r>>2]|0)}x=c[(c[m>>2]|0)+(w<<2)>>2]|0;cB[c[(c[x>>2]|0)+8>>2]&1023](x,q);w=w+1|0;if(w>>>0>=p>>>0){break L9}}p=bT(-1,-1)|0;w=p;p=M;if((a[s]&1)==0){y=w;A=p;B=y;C=0;D=B;F=A;bg(D|0)}Lw(c[r>>2]|0);y=w;A=p;B=y;C=0;D=B;F=A;bg(D|0)}}while(0);m=h;o=h;a[o]=2;n=m+1|0;a[n]=41;a[m+2|0]=0;z=0,az(88,j|0,n|0,1)|0;do{if(!z){n=c[l>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,h|0);if(z){z=0;break}}if((a[o]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);l=bT(-1,-1)|0;n=l;l=M;if((a[o]&1)==0){y=n;A=l;B=y;C=0;D=B;F=A;bg(D|0)}Lw(c[h+8>>2]|0);y=n;A=l;B=y;C=0;D=B;F=A;bg(D|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[k]&1)==0){y=e;A=h;B=y;C=0;D=B;F=A;bg(D|0)}Lw(c[f+8>>2]|0);y=e;A=h;B=y;C=0;D=B;F=A;bg(D|0)}function r4(a,b){a=a|0;b=b|0;var d=0;d=c[b+32>>2]|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function r5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e|0;g=c[d+32>>2]|0;if((g|0)!=0){cB[c[(c[g>>2]|0)+8>>2]&1023](g|0,b|0);i=e;return}g=f;d=f;a[d]=2;h=g+1|0;a[h]=38;a[g+2|0]=0;z=0,az(88,b+4|0,h|0,1)|0;do{if(!z){h=c[b+20>>2]|0;if((h|0)!=0){z=0;as(320,h+64|0,f|0);if(z){z=0;break}}if((a[d]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[d]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function r6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+32|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+40>>2]|0;g=c[d+36>>2]|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){d=g<<1&255;l=f;a[l]=d;m=f+1|0;n=d;o=l}else{l=g+16&-16;d=Lu(l)|0;c[f+8>>2]=d;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=d;n=p&255;o=f}LF(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}o=j&255;if((o&1|0)==0){r=o>>>1}else{r=c[f+4>>2]|0}z=0,az(88,b+4|0,q|0,r|0)|0;do{if(!z){r=c[b+20>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,f|0);if(z){z=0;break}}if((a[k]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[k]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function r7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){AE(h+64|0,d|0)}h=d+32|0;if((a[h]&1)==0){j=f;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];k=a[j]|0;l=j}else{j=c[d+40>>2]|0;h=c[d+36>>2]|0;if(h>>>0>4294967279>>>0){D5(0)}if(h>>>0<11>>>0){d=h<<1&255;m=f;a[m]=d;n=f+1|0;o=d;p=m}else{m=h+16&-16;d=Lu(m)|0;c[f+8>>2]=d;q=m|1;c[f>>2]=q;c[f+4>>2]=h;n=d;o=q&255;p=f}LF(n|0,j|0,h)|0;a[n+h|0]=0;k=o;l=p}if((k&1)==0){r=f+1|0}else{r=c[f+8>>2]|0}p=k&255;if((p&1|0)==0){s=p>>>1}else{s=c[f+4>>2]|0}z=0,az(88,b+4|0,r|0,s|0)|0;do{if(!z){s=c[g>>2]|0;if((s|0)!=0){z=0;as(320,s+64|0,f|0);if(z){z=0;break}}if((a[l]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[l]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function r8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){AE(h+64|0,d|0)}h=d+32|0;if((a[h]&1)==0){j=f;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];k=a[j]|0;l=j}else{j=c[d+40>>2]|0;h=c[d+36>>2]|0;if(h>>>0>4294967279>>>0){D5(0)}if(h>>>0<11>>>0){d=h<<1&255;m=f;a[m]=d;n=f+1|0;o=d;p=m}else{m=h+16&-16;d=Lu(m)|0;c[f+8>>2]=d;q=m|1;c[f>>2]=q;c[f+4>>2]=h;n=d;o=q&255;p=f}LF(n|0,j|0,h)|0;a[n+h|0]=0;k=o;l=p}if((k&1)==0){r=f+1|0}else{r=c[f+8>>2]|0}p=k&255;if((p&1|0)==0){s=p>>>1}else{s=c[f+4>>2]|0}z=0,az(88,b+4|0,r|0,s|0)|0;do{if(!z){s=c[g>>2]|0;if((s|0)!=0){z=0;as(320,s+64|0,f|0);if(z){z=0;break}}if((a[l]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;if((a[l]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function r9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){AE(m+64|0,d|0)}m=f;n=f;a[n]=2;o=m+1|0;a[o]=91;a[m+2|0]=0;m=b+4|0;z=0,az(88,m|0,o|0,1)|0;do{if(!z){o=c[l>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,f|0);if(z){z=0;break}}if((a[n]&1)!=0){Lw(c[f+8>>2]|0)}o=d+32|0;if((a[o]&1)==0){p=g;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];q=a[p]|0;r=p}else{p=c[d+40>>2]|0;o=c[d+36>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){s=o<<1&255;t=g;a[t]=s;u=g+1|0;v=s;w=t}else{t=o+16&-16;s=Lu(t)|0;c[g+8>>2]=s;x=t|1;c[g>>2]=x;c[g+4>>2]=o;u=s;v=x&255;w=g}LF(u|0,p|0,o)|0;a[u+o|0]=0;q=v;r=w}if((q&1)==0){y=g+1|0}else{y=c[g+8>>2]|0}o=q&255;if((o&1|0)==0){A=o>>>1}else{A=c[g+4>>2]|0}z=0,az(88,m|0,y|0,A|0)|0;do{if(!z){o=c[l>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,g|0);if(z){z=0;break}}if((a[r]&1)!=0){Lw(c[g+8>>2]|0)}o=d+44|0;if((a[o]&1)==0){p=h;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];B=a[p]|0;C=p}else{p=c[d+52>>2]|0;x=c[d+48>>2]|0;if(x>>>0>4294967279>>>0){D5(0)}if(x>>>0<11>>>0){s=x<<1&255;t=h;a[t]=s;D=h+1|0;E=s;F=t}else{t=x+16&-16;s=Lu(t)|0;c[h+8>>2]=s;G=t|1;c[h>>2]=G;c[h+4>>2]=x;D=s;E=G&255;F=h}LF(D|0,p|0,x)|0;a[D+x|0]=0;B=E;C=F}x=B&255;if((x&1|0)==0){H=x>>>1}else{H=c[h+4>>2]|0}if((a[C]&1)!=0){Lw(c[h+8>>2]|0)}L57:do{if((H|0)!=0){if((a[o]&1)==0){x=j;c[x>>2]=c[o>>2];c[x+4>>2]=c[o+4>>2];c[x+8>>2]=c[o+8>>2];I=a[x]|0;J=x}else{x=c[d+52>>2]|0;p=c[d+48>>2]|0;if(p>>>0>4294967279>>>0){D5(0)}if(p>>>0<11>>>0){G=p<<1&255;s=j;a[s]=G;K=j+1|0;L=G;N=s}else{s=p+16&-16;G=Lu(s)|0;c[j+8>>2]=G;t=s|1;c[j>>2]=t;c[j+4>>2]=p;K=G;L=t&255;N=j}LF(K|0,x|0,p)|0;a[K+p|0]=0;I=L;J=N}if((I&1)==0){O=j+1|0}else{O=c[j+8>>2]|0}p=I&255;if((p&1|0)==0){P=p>>>1}else{P=c[j+4>>2]|0}z=0,az(88,m|0,O|0,P|0)|0;do{if(!z){p=c[l>>2]|0;if((p|0)!=0){z=0;as(320,p+64|0,j|0);if(z){z=0;break}}if((a[J]&1)!=0){Lw(c[j+8>>2]|0)}p=c[d+56>>2]|0;if((p|0)==0){break L57}cB[c[(c[p>>2]|0)+8>>2]&1023](p,b|0);break L57}else{z=0}}while(0);p=bT(-1,-1)|0;x=p;p=M;if((a[J]&1)==0){Q=p;R=x;S=R;T=0;U=S;V=Q;bg(U|0)}Lw(c[j+8>>2]|0);Q=p;R=x;S=R;T=0;U=S;V=Q;bg(U|0)}}while(0);o=k;x=k;a[x]=2;p=o+1|0;a[p]=93;a[o+2|0]=0;z=0,az(88,m|0,p|0,1)|0;do{if(!z){p=c[l>>2]|0;if((p|0)!=0){z=0;as(320,p+64|0,k|0);if(z){z=0;break}}if((a[x]&1)==0){i=e;return}Lw(c[k+8>>2]|0);i=e;return}else{z=0}}while(0);p=bT(-1,-1)|0;o=p;p=M;if((a[x]&1)==0){Q=p;R=o;S=R;T=0;U=S;V=Q;bg(U|0)}Lw(c[k+8>>2]|0);Q=p;R=o;S=R;T=0;U=S;V=Q;bg(U|0)}else{z=0}}while(0);o=bT(-1,-1)|0;p=o;o=M;if((a[r]&1)==0){Q=o;R=p;S=R;T=0;U=S;V=Q;bg(U|0)}Lw(c[g+8>>2]|0);Q=o;R=p;S=R;T=0;U=S;V=Q;bg(U|0)}else{z=0}}while(0);g=bT(-1,-1)|0;r=g;g=M;if((a[n]&1)==0){Q=g;R=r;S=R;T=0;U=S;V=Q;bg(U|0)}Lw(c[f+8>>2]|0);Q=g;R=r;S=R;T=0;U=S;V=Q;bg(U|0)}function sa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+20|0;j=c[h>>2]|0;if((j|0)!=0){AE(j+64|0,d|0)}j=d+32|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+40>>2]|0;j=c[d+36>>2]|0;if(j>>>0>4294967279>>>0){D5(0)}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=Lu(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}LF(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+4|0;if((l&1)==0){t=f+1|0}else{t=c[f+8>>2]|0}q=l&255;if((q&1|0)==0){u=q>>>1}else{u=c[f+4>>2]|0}z=0,az(88,r|0,t|0,u|0)|0;do{if(!z){u=c[h>>2]|0;if((u|0)!=0){z=0;as(320,u+64|0,f|0);if(z){z=0;break}}if((a[m]&1)!=0){Lw(c[f+8>>2]|0)}u=c[d+44>>2]|0;if((u|0)==0){i=e;return}cB[c[(c[u>>2]|0)+8>>2]&1023](u,b|0);u=g;t=g;a[t]=2;q=u+1|0;a[q]=41;a[u+2|0]=0;z=0,az(88,r|0,q|0,1)|0;do{if(!z){q=c[h>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,g|0);if(z){z=0;break}}if((a[t]&1)==0){i=e;return}Lw(c[g+8>>2]|0);i=e;return}else{z=0}}while(0);q=bT(-1,-1)|0;u=q;q=M;if((a[t]&1)==0){v=q;w=u;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[g+8>>2]|0);v=q;w=u;x=w;y=0;A=x;B=v;bg(A|0)}else{z=0}}while(0);g=bT(-1,-1)|0;e=g;g=M;if((a[m]&1)==0){v=g;w=e;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[f+8>>2]|0);v=g;w=e;x=w;y=0;A=x;B=v;bg(A|0)}function sb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+20|0;j=c[h>>2]|0;if((j|0)!=0){AE(j+64|0,d|0)}j=f;k=f;a[k]=10;l=j+1|0;a[l]=a[3968]|0;a[l+1|0]=a[3969]|0;a[l+2|0]=a[3970]|0;a[l+3|0]=a[3971]|0;a[l+4|0]=a[3972]|0;a[j+6|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,5)|0;do{if(!z){l=c[h>>2]|0;if((l|0)!=0){z=0;as(320,l+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}l=c[d+32>>2]|0;cB[c[(c[l>>2]|0)+8>>2]&1023](l|0,b|0);l=g;m=g;a[m]=2;n=l+1|0;a[n]=41;a[l+2|0]=0;z=0,az(88,j|0,n|0,1)|0;do{if(!z){n=c[h>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,g|0);if(z){z=0;break}}if((a[m]&1)==0){i=e;return}Lw(c[g+8>>2]|0);i=e;return}else{z=0}}while(0);n=bT(-1,-1)|0;l=n;n=M;if((a[m]&1)==0){o=n;p=l;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[g+8>>2]|0);o=n;p=l;q=p;r=0;s=q;t=o;bg(s|0)}else{z=0}}while(0);g=bT(-1,-1)|0;e=g;g=M;if((a[k]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}Lw(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;bg(s|0)}function sc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=b+36|0;e=c[d>>2]|0;f=(c[b+40>>2]|0)-e>>2;if((f|0)==0){return}b=a|0;a=0;g=e;while(1){e=c[g+(a<<2)>>2]|0;cB[c[(c[e>>2]|0)+8>>2]&1023](e|0,b);e=a+1|0;if(e>>>0>=f>>>0){break}a=e;g=c[d>>2]|0}return}function sd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=c[d+36>>2]|0;m=c[d+40>>2]|0;n=c[d+32>>2]|0;L1:do{if((l|0)!=0){d=l+40|0;o=l+36|0;p=c[o>>2]|0;do{if(((c[d>>2]|0)-p|0)==4){q=c[p>>2]|0;if((q|0)==0){cj()}if((c[(c[(c[q>>2]|0)-4>>2]|0)+4>>2]|0)!=27408){r=7;break}if((c[q+32>>2]|0)!=0){r=7}}else{r=7}}while(0);if((r|0)==7){cB[c[(c[l>>2]|0)+8>>2]&1023](l,b|0)}p=c[o>>2]|0;do{if(((c[d>>2]|0)-p|0)==4){q=c[p>>2]|0;if((q|0)==0){cj()}if((c[(c[(c[q>>2]|0)-4>>2]|0)+4>>2]|0)!=27408){s=0;break}s=(c[q+32>>2]|0)==0}else{s=0}}while(0);if(s|(m|0)==0){break}p=f;d=f;a[d]=2;o=p+1|0;a[o]=32;a[p+2|0]=0;p=b+4|0;z=0,az(88,p|0,o|0,1)|0;do{if(!z){o=c[b+20>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,f|0);if(z){z=0;break}}if((a[d]&1)==0){break L1}Lw(c[f+8>>2]|0);break L1}else{z=0}}while(0);o=bT(-1,-1)|0;p=o;o=M;if((a[d]&1)==0){t=o;u=p;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[f+8>>2]|0);t=o;u=p;v=u;w=0;x=v;y=t;bg(x|0)}}while(0);L32:do{if((n|0)==3){f=j;s=j;a[s]=2;l=f+1|0;a[l]=43;a[f+2|0]=0;f=b+4|0;z=0,az(88,f|0,l|0,1)|0;do{if(!z){l=c[b+20>>2]|0;if((l|0)!=0){z=0;as(320,l+64|0,j|0);if(z){z=0;break}}if((a[s]&1)==0){break L32}Lw(c[j+8>>2]|0);break L32}else{z=0}}while(0);d=bT(-1,-1)|0;l=d;d=M;if((a[s]&1)==0){t=d;u=l;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[j+8>>2]|0);t=d;u=l;v=u;w=0;x=v;y=t;bg(x|0)}else if((n|0)==2){l=h;d=h;a[d]=2;f=l+1|0;a[f]=126;a[l+2|0]=0;z=0,az(88,b+4|0,f|0,1)|0;do{if(!z){f=c[b+20>>2]|0;if((f|0)!=0){z=0;as(320,f+64|0,h|0);if(z){z=0;break}}if((a[d]&1)==0){break L32}Lw(c[h+8>>2]|0);break L32}else{z=0}}while(0);s=bT(-1,-1)|0;f=s;s=M;if((a[d]&1)==0){t=s;u=f;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[h+8>>2]|0);t=s;u=f;v=u;w=0;x=v;y=t;bg(x|0)}else if((n|0)==1){f=g;s=g;a[s]=2;l=f+1|0;a[l]=62;a[f+2|0]=0;z=0,az(88,b+4|0,l|0,1)|0;do{if(!z){l=c[b+20>>2]|0;if((l|0)!=0){z=0;as(320,l+64|0,g|0);if(z){z=0;break}}if((a[s]&1)==0){break L32}Lw(c[g+8>>2]|0);break L32}else{z=0}}while(0);d=bT(-1,-1)|0;l=d;d=M;if((a[s]&1)==0){t=d;u=l;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[g+8>>2]|0);t=d;u=l;v=u;w=0;x=v;y=t;bg(x|0)}}while(0);g=(m|0)!=0;L70:do{if(!((n|0)==0|g^1)){h=k;j=k;a[j]=2;l=h+1|0;a[l]=32;a[h+2|0]=0;h=b+4|0;z=0,az(88,h|0,l|0,1)|0;do{if(!z){l=c[b+20>>2]|0;if((l|0)!=0){z=0;as(320,l+64|0,k|0);if(z){z=0;break}}if((a[j]&1)==0){break L70}Lw(c[k+8>>2]|0);break L70}else{z=0}}while(0);s=bT(-1,-1)|0;l=s;s=M;if((a[j]&1)==0){t=s;u=l;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[k+8>>2]|0);t=s;u=l;v=u;w=0;x=v;y=t;bg(x|0)}}while(0);if(!g){i=e;return}cB[c[(c[m>>2]|0)+8>>2]&1023](m,b|0);i=e;return}function se(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+36|0;h=c[g>>2]|0;j=d+40|0;if((h|0)==(c[j>>2]|0)){i=e;return}d=c[h>>2]|0;h=b|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,h);d=(c[j>>2]|0)-(c[g>>2]|0)>>2;if(d>>>0<=1>>>0){i=e;return}j=f;k=f;l=j+1|0;m=l;n=j+3|0;j=b+4|0;o=b+20|0;b=f+8|0;p=1;while(1){a[k]=4;E=8236;a[m]=E;E=E>>8;a[m+1|0]=E;a[n]=0;z=0,az(88,j|0,l|0,2)|0;if(z){z=0;break}q=c[o>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[b>>2]|0)}q=c[(c[g>>2]|0)+(p<<2)>>2]|0;cB[c[(c[q>>2]|0)+8>>2]&1023](q,h);q=p+1|0;if(q>>>0<d>>>0){p=q}else{r=17;break}}if((r|0)==17){i=e;return}e=bT(-1,-1)|0;if((a[k]&1)==0){bg(e|0)}Lw(c[b>>2]|0);bg(e|0)}function sf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0;f=i;i=i+16|0;g=f|0;h=g;j=d;k=d;l=a[k]|0;m=l&255;n=(m&1|0)==0;if(n){o=m>>>1}else{o=c[d+4>>2]|0}if((o|0)==0){o=b;a[b]=4;LI(o+1|0,e|0,2)|0;a[o+3|0]=0;i=f;return}o=l&1;do{if(e<<24>>24!=0){l=o<<24>>24==0;if(l){p=j+1|0}else{p=c[d+8>>2]|0}if((a[p]|0)==34){break}if(l){q=j+1|0}else{q=c[d+8>>2]|0}if((a[q]|0)==39){break}LI(h|0,0,12)|0;if(n){r=m>>>1}else{r=c[d+4>>2]|0}z=0;as(620,g|0,r+2|0);L25:do{if(!z){l=g;s=a[h]|0;if((s&1)==0){t=(s&255)>>>1;u=10;v=s}else{w=c[g>>2]|0;t=c[g+4>>2]|0;u=(w&-2)-1|0;v=w&255}if((t|0)==(u|0)){if((u|0)==-17){z=0;ar(86,0);if(z){z=0;x=74;break}}if((v&1)==0){y=l+1|0}else{y=c[g+8>>2]|0}do{if(u>>>0<2147483623>>>0){w=u+1|0;A=u<<1;B=w>>>0<A>>>0?A:w;if(B>>>0<11>>>0){C=11;break}C=B+16&-16}else{C=-17}}while(0);B=(z=0,au(248,C|0)|0);if(z){z=0;x=74;break}LF(B|0,y|0,u)|0;if((u|0)!=10){Lw(y)}c[g+8>>2]=B;B=C|1;c[g>>2]=B;D=B&255}else{D=s}if((D&1)==0){a[h]=(t<<1)+2;E=l+1|0;F=t+1|0}else{B=c[g+8>>2]|0;w=t+1|0;c[g+4>>2]=w;E=B;F=w}a[E+t|0]=e;a[E+F|0]=0;w=a[k]|0;B=w&255;if((B&1|0)==0){G=B>>>1}else{G=c[d+4>>2]|0}L58:do{if((G|0)!=0){B=j+1|0;A=l+1|0;H=g+8|0;I=g|0;J=g+4|0;K=d+8|0;L=0;N=w;while(1){if((N&1)==0){O=B}else{O=c[K>>2]|0}if((a[O+L|0]|0)==e<<24>>24){P=a[h]|0;if((P&1)==0){Q=(P&255)>>>1;R=10;S=P}else{T=c[I>>2]|0;Q=c[J>>2]|0;R=(T&-2)-1|0;S=T&255}if((Q|0)==(R|0)){if((R|0)==-17){x=60;break}T=(S&1)==0?A:c[H>>2]|0;do{if(R>>>0<2147483623>>>0){U=R+1|0;V=R<<1;W=U>>>0<V>>>0?V:U;if(W>>>0<11>>>0){X=11;break}X=W+16&-16}else{X=-17}}while(0);W=(z=0,au(248,X|0)|0);if(z){z=0;Y=S;x=73;break}LF(W|0,T|0,R)|0;if((R|0)!=10){Lw(T)}c[H>>2]=W;W=X|1;c[I>>2]=W;Z=W&255}else{Z=P}if((Z&1)==0){a[h]=(Q<<1)+2;_=A;$=Q+1|0}else{W=c[H>>2]|0;U=Q+1|0;c[J>>2]=U;_=W;$=U}a[_+Q|0]=92;a[_+$|0]=0;aa=a[k]|0}else{aa=N}if((aa&1)==0){ab=B}else{ab=c[K>>2]|0}U=a[ab+L|0]|0;W=a[h]|0;if((W&1)==0){ac=(W&255)>>>1;ad=10;ae=W}else{V=c[I>>2]|0;ac=c[J>>2]|0;ad=(V&-2)-1|0;ae=V&255}if((ac|0)==(ad|0)){if((ad|0)==-17){x=84;break}V=(ae&1)==0?A:c[H>>2]|0;do{if(ad>>>0<2147483623>>>0){af=ad+1|0;ag=ad<<1;ah=af>>>0<ag>>>0?ag:af;if(ah>>>0<11>>>0){ai=11;break}ai=ah+16&-16}else{ai=-17}}while(0);P=(z=0,au(248,ai|0)|0);if(z){z=0;Y=ae;x=73;break}LF(P|0,V|0,ad)|0;if((ad|0)!=10){Lw(V)}c[H>>2]=P;P=ai|1;c[I>>2]=P;aj=P&255}else{aj=W}if((aj&1)==0){a[h]=(ac<<1)+2;ak=A;al=ac+1|0}else{P=c[H>>2]|0;T=ac+1|0;c[J>>2]=T;ak=P;al=T}a[ak+ac|0]=U;a[ak+al|0]=0;T=L+1|0;if(T>>>0>=G>>>0){break L58}L=T;N=a[k]|0}if((x|0)==84){z=0;ar(86,0);if(z){z=0;x=74;break L25}}else if((x|0)==73){N=bT(-1,-1)|0;am=M;an=N;ao=Y;break L25}else if((x|0)==60){z=0;ar(86,0);if(z){z=0;x=74;break L25}}}}while(0);w=a[h]|0;if((w&1)==0){ap=(w&255)>>>1;aq=10;at=w}else{s=c[g>>2]|0;ap=c[g+4>>2]|0;aq=(s&-2)-1|0;at=s&255}if((ap|0)==(aq|0)){if((aq|0)==-17){z=0;ar(86,0);if(z){z=0;x=74;break}}if((at&1)==0){av=l+1|0}else{av=c[g+8>>2]|0}do{if(aq>>>0<2147483623>>>0){s=aq+1|0;N=aq<<1;L=s>>>0<N>>>0?N:s;if(L>>>0<11>>>0){aw=11;break}aw=L+16&-16}else{aw=-17}}while(0);L=(z=0,au(248,aw|0)|0);if(z){z=0;x=74;break}LF(L|0,av|0,aq)|0;if((aq|0)!=10){Lw(av)}c[g+8>>2]=L;L=aw|1;c[g>>2]=L;ax=L&255}else{ax=w}if((ax&1)==0){a[h]=(ap<<1)+2;ay=l+1|0;az=ap+1|0}else{L=c[g+8>>2]|0;s=ap+1|0;c[g+4>>2]=s;ay=L;az=s}a[ay+ap|0]=e;a[ay+az|0]=0;s=(a[h]&1)==0;if(s){L=b;c[L>>2]=c[h>>2];c[L+4>>2]=c[h+4>>2];c[L+8>>2]=c[h+8>>2];i=f;return}L=c[g+8>>2]|0;N=c[g+4>>2]|0;if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;x=74;break}}if(N>>>0<11>>>0){a[b]=N<<1;aA=b+1|0}else{J=N+16&-16;H=(z=0,au(248,J|0)|0);if(z){z=0;x=74;break}c[b+8>>2]=H;c[b>>2]=J|1;c[b+4>>2]=N;aA=H}LF(aA|0,L|0,N)|0;a[aA+N|0]=0;if(s){i=f;return}Lw(c[g+8>>2]|0);i=f;return}else{z=0;x=74}}while(0);if((x|0)==74){s=bT(-1,-1)|0;am=M;an=s;ao=a[h]|0}if((ao&1)==0){bg(an|0)}Lw(c[g+8>>2]|0);bg(an|0)}}while(0);if(o<<24>>24==0){o=b;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];i=f;return}k=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[b]=o<<1;aB=b+1|0}else{d=o+16&-16;an=Lu(d)|0;c[b+8>>2]=an;c[b>>2]=d|1;c[b+4>>2]=o;aB=an}LF(aB|0,k|0,o)|0;a[aB+o|0]=0;i=f;return}function sg(a,b){a=a|0;b=b|0;return}function sh(b,d){b=b|0;d=d|0;var e=0;c[b>>2]=20536;e=b+4|0;a[e]=0;a[e+1|0]=0;e=b+16|0;a[e]=0;a[e+1|0]=0;c[b+28>>2]=d;return}function si(b){b=b|0;var d=0;c[b>>2]=20536;if((a[b+16|0]&1)!=0){Lw(c[b+24>>2]|0)}if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function sj(b){b=b|0;c[b>>2]=20536;if((a[b+16|0]&1)!=0){Lw(c[b+24>>2]|0)}if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function sk(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+40|0;g=f|0;h=f+24|0;ro(g,c[b+28>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=b+16|0;j=g+4|0;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[g+12>>2]|0;j=c[g+8>>2]|0;if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;n=22;break}}if(j>>>0<11>>>0){o=j<<1&255;p=h;a[p]=o;q=h+1|0;r=o;s=p}else{p=j+16&-16;o=(z=0,au(248,p|0)|0);if(z){z=0;n=22;break}c[h+8>>2]=o;t=p|1;c[h>>2]=t;c[h+4>>2]=j;q=o;r=t&255;s=h}LF(q|0,k|0,j)|0;a[q+j|0]=0;l=r;m=s}if((l&1)==0){u=h+1|0}else{u=c[h+8>>2]|0}j=d[m]|0;if((j&1|0)==0){v=j>>>1}else{v=c[h+4>>2]|0}z=0,az(88,e|0,u|0,v|0)|0;if(z){z=0;e=bT(-1,-1)|0;j=e;e=M;if((a[m]&1)==0){w=e;x=j;break}Lw(c[h+8>>2]|0);w=e;x=j;break}if((a[m]&1)==0){rq(g);i=f;return}Lw(c[h+8>>2]|0);rq(g);i=f;return}else{z=0;n=22}}while(0);if((n|0)==22){n=bT(-1,-1)|0;w=M;x=n}z=0;ar(364,g|0);if(!z){bg(x|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function sl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((a[d+44|0]&1)==0){return}e=d+32|0;f=c[e>>2]|0;g=(c[d+36>>2]|0)-f>>2;if((g|0)==0){return}d=b|0;b=0;h=f;while(1){f=c[h+(b<<2)>>2]|0;cB[c[(c[f>>2]|0)+8>>2]&1023](f|0,d);f=b+1|0;if(f>>>0>=g>>>0){break}b=f;h=c[e>>2]|0}return}function sm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+80|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+64|0;m=d+32|0;n=c[m>>2]|0;o=c[d+28>>2]|0;d=n;p=b+28|0;q=c[p>>2]|0;L1:do{if((c[q+220>>2]|0)==0){r=Lu(48)|0;c[h>>2]=r;s=q+4|0;t=c[s>>2]|0;if((t|0)==(c[q+8>>2]|0)){e4(q|0,h);u=c[h>>2]|0}else{if((t|0)==0){v=0}else{c[t>>2]=r;v=c[s>>2]|0}c[s>>2]=v+4;u=r}r=u;t=u;w=n+4|0;L10:do{if((a[w]&1)==0){x=j;c[x>>2]=c[w>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];y=17}else{x=c[n+12>>2]|0;A=c[n+8>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(A>>>0<11>>>0){a[j]=A<<1;B=j+1|0}else{C=A+16&-16;D=(z=0,au(248,C|0)|0);if(z){z=0;break}c[j+8>>2]=D;c[j>>2]=C|1;c[j+4>>2]=A;B=D}LF(B|0,x|0,A)|0;a[B+A|0]=0;y=17;break L10}}while(0);A=bT(-1,-1)|0;E=A;F=M}}while(0);do{if((y|0)==17){w=n+16|0;A=g;c[A>>2]=c[w>>2];c[A+4>>2]=c[w+4>>2];c[A+8>>2]=c[w+8>>2];z=0;aV(58,t|0,j|0,g|0,0);if(z){z=0;w=bT(-1,-1)|0;A=w;w=M;if((a[j]&1)==0){E=A;F=w;break}Lw(c[j+8>>2]|0);E=A;F=w;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}w=n+36|0;A=c[w>>2]|0;x=(c[n+40>>2]|0)-A>>2;L32:do{if((x|0)!=0){D=u+32|0;C=D;G=u+40|0;H=D+12|0;I=u+36|0;J=D;D=0;K=A;while(1){L=c[K+(D<<2)>>2]|0;if((a[L+29|0]&1)==0){c[f>>2]=L;N=c[G>>2]|0;O=N;if((O|0)==(c[H>>2]|0)){ib(I,f);P=c[f>>2]|0}else{if((N|0)==0){Q=0}else{c[O>>2]=L;Q=c[G>>2]|0}c[G>>2]=Q+4;P=L}cB[c[c[J>>2]>>2]&1023](C,P)}L=D+1|0;if(L>>>0>=x>>>0){break L32}D=L;K=c[w>>2]|0}}}while(0);w=u;c[m>>2]=w;R=w;S=t;break L1}}while(0);t=c[q>>2]|0;w=c[s>>2]|0;x=t;while(1){if((x|0)==(w|0)){T=w;break}if((c[x>>2]|0)==(u|0)){T=x;break}else{x=x+4|0}}x=T-t>>2;A=t+(x+1<<2)|0;K=w-A|0;LG(t+(x<<2)|0,A|0,K|0)|0;A=t+((K>>2)+x<<2)|0;x=c[s>>2]|0;if((A|0)!=(x|0)){c[s>>2]=x+(~((x-4+(-A|0)|0)>>>2)<<2)}Lw(r);U=E;V=F;W=U;X=0;Y=W;Z=V;bg(Y|0)}else{R=n;S=d}}while(0);if((c[S+40>>2]|0)==(c[S+36>>2]|0)){i=e;return}L61:do{if((a[o+46|0]&1)!=0){S=b|0;cB[c[(c[R>>2]|0)+8>>2]&1023](R|0,S);d=k;n=k;a[n]=2;F=d+1|0;a[F]=123;a[d+2|0]=0;d=b+4|0;z=0,az(88,d|0,F|0,1)|0;do{if(!z){F=c[p>>2]|0;if((F|0)!=0){z=0;as(320,F+64|0,k|0);if(z){z=0;break}}if((a[n]&1)!=0){Lw(c[k+8>>2]|0)}F=o+32|0;E=c[F>>2]|0;T=(c[o+36>>2]|0)-E>>2;L71:do{if((T|0)!=0){u=0;q=E;while(1){m=c[q+(u<<2)>>2]|0;if(!(cD[c[(c[m>>2]|0)+36>>2]&511](m)|0)){cB[c[(c[m>>2]|0)+8>>2]&1023](m|0,S)}m=u+1|0;if(m>>>0>=T>>>0){break L71}u=m;q=c[F>>2]|0}}}while(0);F=l;T=l;a[T]=2;E=F+1|0;a[E]=125;a[F+2|0]=0;z=0,az(88,d|0,E|0,1)|0;do{if(!z){E=c[p>>2]|0;if((E|0)!=0){z=0;as(320,E+64|0,l|0);if(z){z=0;break}}if((a[T]&1)==0){break L61}Lw(c[l+8>>2]|0);break L61}else{z=0}}while(0);E=bT(-1,-1)|0;F=E;E=M;if((a[T]&1)==0){U=F;V=E;W=U;X=0;Y=W;Z=V;bg(Y|0)}Lw(c[l+8>>2]|0);U=F;V=E;W=U;X=0;Y=W;Z=V;bg(Y|0)}else{z=0}}while(0);d=bT(-1,-1)|0;S=d;d=M;if((a[n]&1)==0){U=S;V=d;W=U;X=0;Y=W;Z=V;bg(Y|0)}Lw(c[k+8>>2]|0);U=S;V=d;W=U;X=0;Y=W;Z=V;bg(Y|0)}}while(0);if((a[o+45|0]&1)==0){i=e;return}Y=o+32|0;V=c[Y>>2]|0;Z=(c[o+36>>2]|0)-V>>2;if((Z|0)==0){i=e;return}o=b|0;b=0;W=V;while(1){V=c[W+(b<<2)>>2]|0;if(cD[c[(c[V>>2]|0)+36>>2]&511](V)|0){cB[c[(c[V>>2]|0)+8>>2]&1023](V|0,o)}V=b+1|0;if(V>>>0>=Z>>>0){break}b=V;W=c[Y>>2]|0}i=e;return}function sn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=c[d+32>>2]|0;m=c[d+28>>2]|0;n=b+28|0;AE((c[n>>2]|0)+64|0,d|0);o=f;a[o]=14;p=f+1|0;a[p]=a[6568]|0;a[p+1|0]=a[6569]|0;a[p+2|0]=a[6570]|0;a[p+3|0]=a[6571]|0;a[p+4|0]=a[6572]|0;a[p+5|0]=a[6573]|0;a[p+6|0]=a[6574]|0;q=f+8|0;a[q]=0;r=b+4|0;z=0,az(88,r|0,p|0,7)|0;do{if(!z){p=c[n>>2]|0;if((p|0)!=0){z=0;as(320,p+64|0,f|0);if(z){z=0;break}}if((a[o]&1)!=0){Lw(c[q>>2]|0)}p=b|0;cB[c[(c[l>>2]|0)+8>>2]&1023](l,p);s=g;t=g;a[t]=2;u=s+1|0;a[u]=123;a[s+2|0]=0;z=0,az(88,r|0,u|0,1)|0;do{if(!z){u=c[n>>2]|0;if((u|0)!=0){z=0;as(320,u+64|0,g|0);if(z){z=0;break}}if((a[t]&1)!=0){Lw(c[g+8>>2]|0)}u=c[d+36>>2]|0;L17:do{if((u|0)==0){v=0}else{if((a[m+46|0]&1)==0){v=0;break}cB[c[(c[u>>2]|0)+8>>2]&1023](u|0,p);s=h;w=h;a[w]=2;x=s+1|0;a[x]=123;a[s+2|0]=0;z=0,az(88,r|0,x|0,1)|0;do{if(!z){x=c[n>>2]|0;if((x|0)!=0){z=0;as(320,x+64|0,h|0);if(z){z=0;break}}if((a[w]&1)==0){v=1;break L17}Lw(c[h+8>>2]|0);v=1;break L17}else{z=0}}while(0);x=bT(-1,-1)|0;s=x;x=M;if((a[w]&1)==0){y=s;A=x;B=y;C=0;D=B;E=A;bg(D|0)}Lw(c[h+8>>2]|0);y=s;A=x;B=y;C=0;D=B;E=A;bg(D|0)}}while(0);u=m+36|0;x=m+32|0;s=c[x>>2]|0;F=(c[u>>2]|0)-s>>2;L32:do{if((F|0)!=0){G=0;H=s;while(1){I=c[H+(G<<2)>>2]|0;if(!(cD[c[(c[I>>2]|0)+36>>2]&511](I)|0)){cB[c[(c[I>>2]|0)+8>>2]&1023](I|0,p)}I=G+1|0;if(I>>>0>=F>>>0){break L32}G=I;H=c[x>>2]|0}}}while(0);L40:do{if(v){F=j;s=j;a[s]=2;H=F+1|0;a[H]=125;a[F+2|0]=0;z=0,az(88,r|0,H|0,1)|0;do{if(!z){H=c[n>>2]|0;if((H|0)!=0){z=0;as(320,H+64|0,j|0);if(z){z=0;break}}if((a[s]&1)==0){break L40}Lw(c[j+8>>2]|0);break L40}else{z=0}}while(0);H=bT(-1,-1)|0;F=H;H=M;if((a[s]&1)==0){y=F;A=H;B=y;C=0;D=B;E=A;bg(D|0)}Lw(c[j+8>>2]|0);y=F;A=H;B=y;C=0;D=B;E=A;bg(D|0)}}while(0);H=c[x>>2]|0;F=(c[u>>2]|0)-H>>2;L54:do{if((F|0)!=0){G=0;w=H;while(1){I=c[w+(G<<2)>>2]|0;if(cD[c[(c[I>>2]|0)+36>>2]&511](I)|0){cB[c[(c[I>>2]|0)+8>>2]&1023](I|0,p)}I=G+1|0;if(I>>>0>=F>>>0){break L54}G=I;w=c[x>>2]|0}}}while(0);x=k;F=k;a[F]=2;H=x+1|0;a[H]=125;a[x+2|0]=0;z=0,az(88,r|0,H|0,1)|0;do{if(!z){H=c[n>>2]|0;if((H|0)!=0){z=0;as(320,H+64|0,k|0);if(z){z=0;break}}if((a[F]&1)==0){i=e;return}Lw(c[k+8>>2]|0);i=e;return}else{z=0}}while(0);H=bT(-1,-1)|0;x=H;H=M;if((a[F]&1)==0){y=x;A=H;B=y;C=0;D=B;E=A;bg(D|0)}Lw(c[k+8>>2]|0);y=x;A=H;B=y;C=0;D=B;E=A;bg(D|0)}else{z=0}}while(0);p=bT(-1,-1)|0;H=p;p=M;if((a[t]&1)==0){y=H;A=p;B=y;C=0;D=B;E=A;bg(D|0)}Lw(c[g+8>>2]|0);y=H;A=p;B=y;C=0;D=B;E=A;bg(D|0)}else{z=0}}while(0);g=bT(-1,-1)|0;k=g;g=M;if((a[o]&1)==0){y=k;A=g;B=y;C=0;D=B;E=A;bg(D|0)}Lw(c[q>>2]|0);y=k;A=g;B=y;C=0;D=B;E=A;bg(D|0)}function so(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0;e=i;i=i+96|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=d+32|0;if((a[m]&1)==0){n=f;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];o=a[n]|0;p=n}else{n=c[d+40>>2]|0;m=c[d+36>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){q=m<<1&255;r=f;a[r]=q;s=f+1|0;t=q;u=r}else{r=m+16&-16;q=Lu(r)|0;c[f+8>>2]=q;v=r|1;c[f>>2]=v;c[f+4>>2]=m;s=q;t=v&255;u=f}LF(s|0,n|0,m)|0;a[s+m|0]=0;o=t;p=u}u=c[d+44>>2]|0;t=c[d+48>>2]|0;m=c[d+28>>2]|0;d=b+4|0;if((o&1)==0){w=f+1|0}else{w=c[f+8>>2]|0}s=o&255;if((s&1|0)==0){x=s>>>1}else{x=c[f+4>>2]|0}z=0,az(88,d|0,w|0,x|0)|0;L20:do{if(!z){x=b+28|0;w=c[x>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,f|0);if(z){z=0;y=27;break}}L25:do{if((u|0)==0){if((t|0)==0){break}w=h;s=h;a[s]=2;o=w+1|0;a[o]=32;a[w+2|0]=0;z=0,az(88,d|0,o|0,1)|0;do{if(!z){o=c[x>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,h|0);if(z){z=0;break}}if((a[s]&1)!=0){Lw(c[h+8>>2]|0)}z=0;as(c[(c[t>>2]|0)+8>>2]|0,t|0,b|0);if(!z){break L25}else{z=0;y=27;break L20}}else{z=0}}while(0);o=bT(-1,-1)|0;w=o;o=M;if((a[s]&1)==0){A=w;B=o;break L20}Lw(c[h+8>>2]|0);A=w;B=o;break L20}else{o=g;w=g;a[w]=2;n=o+1|0;a[n]=32;a[o+2|0]=0;z=0,az(88,d|0,n|0,1)|0;do{if(!z){n=c[x>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,g|0);if(z){z=0;break}}if((a[w]&1)!=0){Lw(c[g+8>>2]|0)}z=0;as(c[(c[u>>2]|0)+8>>2]|0,u|0,b|0);if(!z){break L25}else{z=0;y=27;break L20}}else{z=0}}while(0);s=bT(-1,-1)|0;n=s;s=M;if((a[w]&1)==0){A=n;B=s;break L20}Lw(c[g+8>>2]|0);A=n;B=s;break L20}}while(0);L50:do{if((m|0)==0){s=j;n=j;a[n]=2;o=s+1|0;a[o]=59;a[s+2|0]=0;z=0,az(88,d|0,o|0,1)|0;do{if(!z){o=c[x>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,j|0);if(z){z=0;break}}if((a[n]&1)==0){break L50}Lw(c[j+8>>2]|0);break L50}else{z=0}}while(0);w=bT(-1,-1)|0;o=w;w=M;if((a[n]&1)==0){A=o;B=w;break L20}Lw(c[j+8>>2]|0);A=o;B=w;break L20}else{w=k;o=k;a[o]=2;s=w+1|0;a[s]=123;a[w+2|0]=0;z=0,az(88,d|0,s|0,1)|0;do{if(!z){s=c[x>>2]|0;if((s|0)!=0){z=0;as(320,s+64|0,k|0);if(z){z=0;break}}if((a[o]&1)!=0){Lw(c[k+8>>2]|0)}s=m+36|0;w=c[s>>2]|0;v=m+32|0;q=c[v>>2]|0;r=w-q>>2;do{if((r|0)==0){C=w;D=q}else{E=b|0;F=0;G=q;while(1){H=c[G+(F<<2)>>2]|0;I=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;y=26;break}if(!I){z=0;as(c[(c[H>>2]|0)+8>>2]|0,H|0,E|0);if(z){z=0;y=26;break}}H=F+1|0;if(H>>>0>=r>>>0){y=62;break}F=H;G=c[v>>2]|0}if((y|0)==26){G=bT(-1,-1)|0;J=M;K=G;y=28;break L20}else if((y|0)==62){C=c[s>>2]|0;D=c[v>>2]|0;break}}}while(0);s=C-D>>2;L73:do{if((s|0)!=0){r=b|0;q=0;w=D;while(1){G=c[w+(q<<2)>>2]|0;F=(z=0,au(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(z){z=0;break}if(F){z=0;as(c[(c[G>>2]|0)+8>>2]|0,G|0,r|0);if(z){z=0;break}}G=q+1|0;if(G>>>0>=s>>>0){break L73}q=G;w=c[v>>2]|0}w=bT(-1,-1)|0;J=M;K=w;y=28;break L20}}while(0);v=l;s=l;a[s]=2;w=v+1|0;a[w]=125;a[v+2|0]=0;z=0,az(88,d|0,w|0,1)|0;do{if(!z){w=c[x>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,l|0);if(z){z=0;break}}if((a[s]&1)==0){break L50}Lw(c[l+8>>2]|0);break L50}else{z=0}}while(0);w=bT(-1,-1)|0;v=w;w=M;if((a[s]&1)==0){A=v;B=w;break L20}Lw(c[l+8>>2]|0);A=v;B=w;break L20}else{z=0}}while(0);n=bT(-1,-1)|0;w=n;n=M;if((a[o]&1)==0){A=w;B=n;break L20}Lw(c[k+8>>2]|0);A=w;B=n;break L20}}while(0);if((a[p]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0;y=27}}while(0);if((y|0)==27){e=bT(-1,-1)|0;J=M;K=e;y=28}if((y|0)==28){A=K;B=J}if((a[p]&1)==0){L=A;N=0;O=L;P=B;bg(O|0)}Lw(c[f+8>>2]|0);L=A;N=0;O=L;P=B;bg(O|0)}function sp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+32|0;l=c[k>>2]|0;m=c[l+32>>2]|0;n=(m|0)!=6;do{if((m|0)==4){o=l+40|0;if((a[o]&1)==0){p=f;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];q=a[p]|0;r=p}else{p=c[l+48>>2]|0;o=c[l+44>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){s=o<<1&255;t=f;a[t]=s;u=f+1|0;v=s;w=t}else{t=o+16&-16;s=Lu(t)|0;c[f+8>>2]=s;x=t|1;c[f>>2]=x;c[f+4>>2]=o;u=s;v=x&255;w=f}LF(u|0,p|0,o)|0;a[u+o|0]=0;q=v;r=w}o=q&255;if((o&1|0)==0){y=o>>>1}else{y=c[f+4>>2]|0}o=n&(y|0)!=0;if((a[r]&1)==0){A=o;B=15;break}Lw(c[f+8>>2]|0);if(o){break}i=e;return}else{A=n;B=15}}while(0);do{if((B|0)==15){if(A){break}i=e;return}}while(0);A=b+28|0;B=c[A>>2]|0;if((B|0)==0){C=d+28|0}else{n=d+28|0;AE(B+64|0,c[n>>2]|0);C=n}n=c[C>>2]|0;C=b|0;cB[c[(c[n>>2]|0)+8>>2]&1023](n,C);n=g;B=g;a[B]=2;f=n+1|0;a[f]=58;a[n+2|0]=0;n=b+4|0;z=0,az(88,n|0,f|0,1)|0;do{if(!z){f=c[A>>2]|0;if((f|0)!=0){z=0;as(320,f+64|0,g|0);if(z){z=0;break}}if((a[B]&1)!=0){Lw(c[g+8>>2]|0)}f=c[A>>2]|0;if((f|0)!=0){AE(f+64|0,c[k>>2]|0)}f=c[k>>2]|0;cB[c[(c[f>>2]|0)+8>>2]&1023](f|0,C);L39:do{if((a[d+36|0]&1)!=0){f=h;b=h;a[b]=20;r=f+1|0;LF(r|0,1728,10)|0;a[f+11|0]=0;z=0,az(88,n|0,r|0,10)|0;do{if(!z){r=c[A>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,h|0);if(z){z=0;break}}if((a[b]&1)==0){break L39}Lw(c[h+8>>2]|0);break L39}else{z=0}}while(0);r=bT(-1,-1)|0;f=r;r=M;if((a[b]&1)==0){D=r;E=f;F=E;G=0;H=F;I=D;bg(H|0)}Lw(c[h+8>>2]|0);D=r;E=f;F=E;G=0;H=F;I=D;bg(H|0)}}while(0);f=j;r=j;a[r]=2;y=f+1|0;a[y]=59;a[f+2|0]=0;z=0,az(88,n|0,y|0,1)|0;do{if(!z){y=c[A>>2]|0;if((y|0)!=0){z=0;as(320,y+64|0,j|0);if(z){z=0;break}}if((a[r]&1)==0){i=e;return}Lw(c[j+8>>2]|0);i=e;return}else{z=0}}while(0);y=bT(-1,-1)|0;f=y;y=M;if((a[r]&1)==0){D=y;E=f;F=E;G=0;H=F;I=D;bg(H|0)}Lw(c[j+8>>2]|0);D=y;E=f;F=E;G=0;H=F;I=D;bg(H|0)}else{z=0}}while(0);j=bT(-1,-1)|0;e=j;j=M;if((a[B]&1)==0){D=j;E=e;F=E;G=0;H=F;I=D;bg(H|0)}Lw(c[g+8>>2]|0);D=j;E=e;F=E;G=0;H=F;I=D;bg(H|0)}function sq(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+64|0;g=f|0;h=f+8|0;j=f+24|0;k=f+48|0;Bv(g,0);l=c[e+28>>2]|0;z=0;aR(c[(c[l>>2]|0)+28>>2]|0,h|0,l|0,g|0);L1:do{if(!z){l=h;m=a[l]|0;if((m&1)==0){n=h+1|0}else{n=c[h+8>>2]|0}L8:do{if((a[n+2|0]|0)==33){z=0;as(130,j|0,c[b+28>>2]|0);L10:do{if(!z){z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,j|0);do{if(!z){o=b+4|0;p=j+4|0;if((a[p]&1)==0){q=k;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];r=a[q]|0;s=q}else{q=c[j+12>>2]|0;p=c[j+8>>2]|0;if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=31;break}}if(p>>>0<11>>>0){u=p<<1&255;v=k;a[v]=u;w=k+1|0;x=u;y=v}else{v=p+16&-16;u=(z=0,au(248,v|0)|0);if(z){z=0;t=31;break}c[k+8>>2]=u;A=v|1;c[k>>2]=A;c[k+4>>2]=p;w=u;x=A&255;y=k}LF(w|0,q|0,p)|0;a[w+p|0]=0;r=x;s=y}if((r&1)==0){B=k+1|0}else{B=c[k+8>>2]|0}p=d[s]|0;if((p&1|0)==0){C=p>>>1}else{C=c[k+4>>2]|0}z=0,az(88,o|0,B|0,C|0)|0;if(z){z=0;o=bT(-1,-1)|0;p=o;o=M;if((a[s]&1)==0){D=o;E=p;break}Lw(c[k+8>>2]|0);D=o;E=p;break}if((a[s]&1)!=0){Lw(c[k+8>>2]|0)}z=0;ar(364,j|0);if(z){z=0;t=7;break L10}F=a[l]|0;break L8}else{z=0;t=31}}while(0);if((t|0)==31){p=bT(-1,-1)|0;D=M;E=p}z=0;ar(364,j|0);if(!z){G=D;H=E;break}else{z=0}I=bT(-1,-1,0)|0;J=M;bX()}else{z=0;t=7}}while(0);if((t|0)==7){p=bT(-1,-1)|0;G=M;H=p}if((a[l]&1)==0){K=G;L=H;break L1}Lw(c[h+8>>2]|0);K=G;L=H;break L1}else{F=m}}while(0);if((F&1)==0){Bx(g);i=f;return}Lw(c[h+8>>2]|0);Bx(g);i=f;return}else{z=0;m=bT(-1,-1)|0;K=M;L=m}}while(0);z=0;ar(444,g|0);if(!z){bg(L|0)}else{z=0;I=bT(-1,-1,0)|0;J=M;bX()}}function sr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+16|0;f=e|0;g=((c[d+52>>2]|0)==0?5568:1e3)|0;h=f;j=f;a[j]=2;k=h+1|0;a[k]=a[g]|0;a[h+2|0]=0;h=d+40|0;g=c[h>>2]|0;l=d+44|0;if((g|0)==(c[l>>2]|0)){i=e;return}d=c[g>>2]|0;g=(z=0,au(c[(c[d>>2]|0)+44>>2]|0,d|0)|0);L4:do{if(!z){if(!g){z=0;as(c[(c[d>>2]|0)+8>>2]|0,d|0,b|0);if(z){z=0;m=3;break}}n=c[h>>2]|0;o=(c[l>>2]|0)-n>>2;L9:do{if(o>>>0>1>>>0){p=b+4|0;q=b+28|0;r=f+4|0;s=f+8|0;t=b|0;if(g){u=1;v=n;L12:while(1){w=c[v+(u<<2)>>2]|0;x=(z=0,au(c[(c[w>>2]|0)+44>>2]|0,w|0)|0);if(z){z=0;break}do{if(!x){y=a[j]|0;A=(y&1)==0?k:c[s>>2]|0;B=y&255;y=(B&1|0)==0?B>>>1:c[r>>2]|0;z=0,az(88,p|0,A|0,y|0)|0;if(z){z=0;break L12}y=c[q>>2]|0;if((y|0)==0){break}z=0;as(320,y+64|0,f|0);if(z){z=0;break L12}}}while(0);z=0;as(c[(c[w>>2]|0)+8>>2]|0,w|0,t|0);if(z){z=0;break}x=u+1|0;if(x>>>0>=o>>>0){break L9}u=x;v=c[h>>2]|0}v=bT(-1,-1)|0;C=M;D=v;break L4}else{E=1;F=n}L23:while(1){v=c[F+(E<<2)>>2]|0;u=(z=0,au(c[(c[v>>2]|0)+44>>2]|0,v|0)|0);if(z){z=0;break}do{if((E|0)!=1|u){if(u){break}x=a[j]|0;y=(x&1)==0?k:c[s>>2]|0;A=x&255;x=(A&1|0)==0?A>>>1:c[r>>2]|0;z=0,az(88,p|0,y|0,x|0)|0;if(z){z=0;break L23}x=c[q>>2]|0;if((x|0)==0){break}z=0;as(320,x+64|0,f|0);if(z){z=0;break L23}}else{x=a[j]|0;y=(x&1)==0?k:c[s>>2]|0;A=x&255;x=(A&1|0)==0?A>>>1:c[r>>2]|0;z=0,az(88,p|0,y|0,x|0)|0;if(z){z=0;break L23}x=c[q>>2]|0;if((x|0)==0){break}z=0;as(320,x+64|0,f|0);if(z){z=0;break L23}}}while(0);z=0;as(c[(c[v>>2]|0)+8>>2]|0,v|0,t|0);if(z){z=0;break}u=E+1|0;if(u>>>0>=o>>>0){break L9}E=u;F=c[h>>2]|0}t=bT(-1,-1)|0;C=M;D=t;break L4}}while(0);if((a[j]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0;m=3}}while(0);if((m|0)==3){m=bT(-1,-1)|0;C=M;D=m}if((a[j]&1)==0){bg(D|0)}Lw(c[f+8>>2]|0);bg(D|0)}function ss(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;if((a[d+44|0]&1)!=0){j=c[d+36>>2]|0;cB[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);i=e;return}j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,1)|0;do{if(!z){l=b+28|0;m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}m=c[d+36>>2]|0;n=b|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m|0,n);m=d+40|0;L13:do{if((c[m>>2]|0)!=0){o=g;p=g;a[p]=2;q=o+1|0;a[q]=58;a[o+2|0]=0;z=0,az(88,j|0,q|0,1)|0;do{if(!z){q=c[l>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,g|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[g+8>>2]|0)}q=c[m>>2]|0;cB[c[(c[q>>2]|0)+8>>2]&1023](q|0,n);break L13}else{z=0}}while(0);q=bT(-1,-1)|0;o=q;q=M;if((a[p]&1)==0){r=q;s=o;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[g+8>>2]|0);r=q;s=o;t=s;u=0;v=t;w=r;bg(v|0)}}while(0);n=h;m=h;a[m]=2;o=n+1|0;a[o]=41;a[n+2|0]=0;z=0,az(88,j|0,o|0,1)|0;do{if(!z){o=c[l>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,h|0);if(z){z=0;break}}if((a[m]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);l=bT(-1,-1)|0;o=l;l=M;if((a[m]&1)==0){r=l;s=o;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[h+8>>2]|0);r=l;s=o;t=s;u=0;v=t;w=r;bg(v|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[k]&1)==0){r=h;s=e;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[f+8>>2]|0);r=h;s=e;t=s;u=0;v=t;w=r;bg(v|0)}function st(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+40|0;if((a[k]&1)==0){l=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];m=a[l]|0;n=l}else{l=c[d+48>>2]|0;o=c[d+44>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){p=o<<1&255;q=f;a[q]=p;r=f+1|0;s=p;t=q}else{q=o+16&-16;p=Lu(q)|0;c[f+8>>2]=p;u=q|1;c[f>>2]=u;c[f+4>>2]=o;r=p;s=u&255;t=f}LF(r|0,l|0,o)|0;a[r+o|0]=0;m=s;n=t}t=m&255;if((t&1|0)==0){v=t>>>1}else{v=c[f+4>>2]|0}if((a[n]&1)!=0){Lw(c[f+8>>2]|0)}L19:do{if((v|0)!=0){if((a[k]&1)==0){f=g;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];w=a[f]|0;x=f}else{f=c[d+48>>2]|0;n=c[d+44>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){t=n<<1&255;m=g;a[m]=t;y=g+1|0;A=t;B=m}else{m=n+16&-16;t=Lu(m)|0;c[g+8>>2]=t;s=m|1;c[g>>2]=s;c[g+4>>2]=n;y=t;A=s&255;B=g}LF(y|0,f|0,n)|0;a[y+n|0]=0;w=A;x=B}n=b+4|0;if((w&1)==0){C=g+1|0}else{C=c[g+8>>2]|0}f=w&255;if((f&1|0)==0){D=f>>>1}else{D=c[g+4>>2]|0}z=0,az(88,n|0,C|0,D|0)|0;do{if(!z){f=b+28|0;s=c[f>>2]|0;if((s|0)!=0){z=0;as(320,s+64|0,g|0);if(z){z=0;break}}if((a[x]&1)!=0){Lw(c[g+8>>2]|0)}s=h;t=h;a[t]=2;m=s+1|0;a[m]=58;a[s+2|0]=0;z=0,az(88,n|0,m|0,1)|0;do{if(!z){m=c[f>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,h|0);if(z){z=0;break}}if((a[t]&1)==0){break L19}Lw(c[h+8>>2]|0);break L19}else{z=0}}while(0);f=bT(-1,-1)|0;m=f;f=M;if((a[t]&1)==0){E=f;F=m;G=F;H=0;I=G;J=E;bg(I|0)}Lw(c[h+8>>2]|0);E=f;F=m;G=F;H=0;I=G;J=E;bg(I|0)}else{z=0}}while(0);n=bT(-1,-1)|0;m=n;n=M;if((a[x]&1)==0){E=n;F=m;G=F;H=0;I=G;J=E;bg(I|0)}Lw(c[g+8>>2]|0);E=n;F=m;G=F;H=0;I=G;J=E;bg(I|0)}}while(0);g=c[d+36>>2]|0;cB[c[(c[g>>2]|0)+8>>2]&1023](g|0,b|0);if((a[d+52|0]&1)==0){i=e;return}d=j;a[d]=6;g=j+1|0;a[g]=a[12080]|0;a[g+1|0]=a[12081]|0;a[g+2|0]=a[12082]|0;a[j+4|0]=0;z=0,az(88,b+4|0,g|0,3)|0;do{if(!z){g=c[b+28>>2]|0;if((g|0)!=0){z=0;as(320,g+64|0,j|0);if(z){z=0;break}}if((a[d]&1)==0){i=e;return}Lw(c[j+8>>2]|0);i=e;return}else{z=0}}while(0);e=bT(-1,-1)|0;b=e;e=M;if((a[d]&1)==0){E=e;F=b;G=F;H=0;I=G;J=E;bg(I|0)}Lw(c[j+8>>2]|0);E=e;F=b;G=F;H=0;I=G;J=E;bg(I|0)}function su(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;z=0,az(88,j|0,l|0,1)|0;do{if(!z){l=b+28|0;m=c[l>>2]|0;if((m|0)!=0){z=0;as(320,m+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}m=d+40|0;n=c[m>>2]|0;o=d+44|0;L9:do{if((n|0)!=(c[o>>2]|0)){p=c[n>>2]|0;q=b|0;cB[c[(c[p>>2]|0)+8>>2]&1023](p,q);p=(c[o>>2]|0)-(c[m>>2]|0)>>2;if(p>>>0<=1>>>0){break}r=g;s=g;t=r+1|0;u=r+2|0;r=g+8|0;v=1;while(1){a[s]=2;a[t]=44;a[u]=0;z=0,az(88,j|0,t|0,1)|0;if(z){z=0;break}w=c[l>>2]|0;if((w|0)!=0){z=0;as(320,w+64|0,g|0);if(z){z=0;break}}if((a[s]&1)!=0){Lw(c[r>>2]|0)}w=c[(c[m>>2]|0)+(v<<2)>>2]|0;cB[c[(c[w>>2]|0)+8>>2]&1023](w,q);v=v+1|0;if(v>>>0>=p>>>0){break L9}}p=bT(-1,-1)|0;v=p;p=M;if((a[s]&1)==0){x=v;y=p;A=x;B=0;C=A;D=y;bg(C|0)}Lw(c[r>>2]|0);x=v;y=p;A=x;B=0;C=A;D=y;bg(C|0)}}while(0);m=h;o=h;a[o]=2;n=m+1|0;a[n]=41;a[m+2|0]=0;z=0,az(88,j|0,n|0,1)|0;do{if(!z){n=c[l>>2]|0;if((n|0)!=0){z=0;as(320,n+64|0,h|0);if(z){z=0;break}}if((a[o]&1)==0){i=e;return}Lw(c[h+8>>2]|0);i=e;return}else{z=0}}while(0);l=bT(-1,-1)|0;n=l;l=M;if((a[o]&1)==0){x=n;y=l;A=x;B=0;C=A;D=y;bg(C|0)}Lw(c[h+8>>2]|0);x=n;y=l;A=x;B=0;C=A;D=y;bg(C|0)}else{z=0}}while(0);h=bT(-1,-1)|0;e=h;h=M;if((a[k]&1)==0){x=e;y=h;A=x;B=0;C=A;D=y;bg(C|0)}Lw(c[f+8>>2]|0);x=e;y=h;A=x;B=0;C=A;D=y;bg(C|0)}function sv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;e=i;i=i+96|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=c[d+36>>2]|0;n=c[d+40>>2]|0;o=c[d+32>>2]|0;d=(m|0)!=0;L1:do{if(d){p=c[m+36>>2]|0;q=((c[m+40>>2]|0)-p|0)==4;do{if(q){r=c[p>>2]|0;if((r|0)==0){cj()}do{if((c[(c[(c[r>>2]|0)-4>>2]|0)+4>>2]|0)==27408){if((c[r+32>>2]|0)!=0|(n|0)==0){break}cB[c[(c[n>>2]|0)+8>>2]&1023](n,b|0);i=e;return}}while(0);if(!q){break}r=c[p>>2]|0;if((r|0)==0){cj()}if((c[(c[(c[r>>2]|0)-4>>2]|0)+4>>2]|0)!=27408){break}if((c[r+32>>2]|0)==0){break L1}}}while(0);cB[c[(c[m>>2]|0)+8>>2]&1023](m,b|0)}}while(0);L20:do{if((o|0)==1){p=g;q=g;a[q]=2;r=p+1|0;a[r]=62;a[p+2|0]=0;p=b+4|0;z=0,az(88,p|0,r|0,1)|0;do{if(!z){r=c[b+28>>2]|0;if((r|0)!=0){z=0;as(320,r+64|0,g|0);if(z){z=0;break}}if((a[q]&1)==0){break L20}Lw(c[g+8>>2]|0);break L20}else{z=0}}while(0);r=bT(-1,-1)|0;p=r;r=M;if((a[q]&1)==0){s=r;t=p;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[g+8>>2]|0);s=r;t=p;u=t;v=0;w=u;x=s;bg(w|0)}else if((o|0)==0){if((n|0)==0){i=e;return}p=f;r=f;a[r]=2;y=p+1|0;a[y]=32;a[p+2|0]=0;z=0,az(88,b+4|0,y|0,1)|0;do{if(!z){y=c[b+28>>2]|0;if((y|0)!=0){z=0;as(320,y+64|0,f|0);if(z){z=0;break}}if((a[r]&1)==0){break L20}Lw(c[f+8>>2]|0);break L20}else{z=0}}while(0);q=bT(-1,-1)|0;y=q;q=M;if((a[r]&1)==0){s=q;t=y;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[f+8>>2]|0);s=q;t=y;u=t;v=0;w=u;x=s;bg(w|0)}else if((o|0)==3){y=l;q=l;a[q]=2;p=y+1|0;a[p]=43;a[y+2|0]=0;z=0,az(88,b+4|0,p|0,1)|0;do{if(!z){p=c[b+28>>2]|0;if((p|0)!=0){z=0;as(320,p+64|0,l|0);if(z){z=0;break}}if((a[q]&1)==0){break L20}Lw(c[l+8>>2]|0);break L20}else{z=0}}while(0);r=bT(-1,-1)|0;p=r;r=M;if((a[q]&1)==0){s=r;t=p;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[l+8>>2]|0);s=r;t=p;u=t;v=0;w=u;x=s;bg(w|0)}else if((o|0)==2){L61:do{if(d){p=c[m+36>>2]|0;do{if(((c[m+40>>2]|0)-p|0)==4){r=c[p>>2]|0;if((r|0)==0){cj()}if((c[(c[(c[r>>2]|0)-4>>2]|0)+4>>2]|0)!=27408){break}if((c[r+32>>2]|0)==0){break L61}}}while(0);p=h;r=h;a[r]=2;y=p+1|0;a[y]=32;a[p+2|0]=0;p=b+4|0;z=0,az(88,p|0,y|0,1)|0;do{if(!z){y=c[b+28>>2]|0;if((y|0)!=0){z=0;as(320,y+64|0,h|0);if(z){z=0;break}}if((a[r]&1)==0){break L61}Lw(c[h+8>>2]|0);break L61}else{z=0}}while(0);y=bT(-1,-1)|0;p=y;y=M;if((a[r]&1)==0){s=y;t=p;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[h+8>>2]|0);s=y;t=p;u=t;v=0;w=u;x=s;bg(w|0)}}while(0);q=j;p=j;a[p]=2;y=q+1|0;a[y]=126;a[q+2|0]=0;q=b+4|0;z=0,az(88,q|0,y|0,1)|0;do{if(!z){y=b+28|0;A=c[y>>2]|0;if((A|0)!=0){z=0;as(320,A+64|0,j|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[j+8>>2]|0)}if((n|0)==0){i=e;return}A=k;B=k;a[B]=2;C=A+1|0;a[C]=32;a[A+2|0]=0;z=0,az(88,q|0,C|0,1)|0;do{if(!z){C=c[y>>2]|0;if((C|0)!=0){z=0;as(320,C+64|0,k|0);if(z){z=0;break}}if((a[B]&1)==0){break L20}Lw(c[k+8>>2]|0);break L20}else{z=0}}while(0);y=bT(-1,-1)|0;r=y;y=M;if((a[B]&1)==0){s=y;t=r;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[k+8>>2]|0);s=y;t=r;u=t;v=0;w=u;x=s;bg(w|0)}else{z=0}}while(0);q=bT(-1,-1)|0;r=q;q=M;if((a[p]&1)==0){s=q;t=r;u=t;v=0;w=u;x=s;bg(w|0)}Lw(c[j+8>>2]|0);s=q;t=r;u=t;v=0;w=u;x=s;bg(w|0)}}while(0);if((n|0)==0){i=e;return}cB[c[(c[n>>2]|0)+8>>2]&1023](n,b|0);i=e;return}function sw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e|0;g=d+36|0;h=c[g>>2]|0;j=d+40|0;if((h|0)==(c[j>>2]|0)){i=e;return}d=c[h>>2]|0;h=b|0;cB[c[(c[d>>2]|0)+8>>2]&1023](d,h);d=(c[j>>2]|0)-(c[g>>2]|0)>>2;if(d>>>0<=1>>>0){i=e;return}j=f;k=f;l=j+1|0;m=j+2|0;j=b+4|0;n=b+28|0;b=f+8|0;o=1;while(1){a[k]=2;a[l]=44;a[m]=0;z=0,az(88,j|0,l|0,1)|0;if(z){z=0;break}p=c[n>>2]|0;if((p|0)!=0){z=0;as(320,p+64|0,f|0);if(z){z=0;break}}if((a[k]&1)!=0){Lw(c[b>>2]|0)}p=c[(c[g>>2]|0)+(o<<2)>>2]|0;cB[c[(c[p>>2]|0)+8>>2]&1023](p,h);p=o+1|0;if(p>>>0<d>>>0){o=p}else{q=14;break}}if((q|0)==14){i=e;return}e=bT(-1,-1)|0;if((a[k]&1)==0){bg(e|0)}Lw(c[b>>2]|0);bg(e|0)}function sx(a,b){a=a|0;b=b|0;s7(a,b);return}function sy(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sz(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sA(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sB(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sC(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sD(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sE(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sF(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sG(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sH(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sI(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sJ(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sK(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sL(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sM(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sN(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sO(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sP(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sQ(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sR(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sS(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sT(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sU(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sV(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sW(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sX(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sY(a,b){a=a|0;b=b|0;s7(a,b|0);return}function sZ(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s_(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s$(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s0(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s1(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s2(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s3(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s4(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s5(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s6(a,b){a=a|0;b=b|0;s7(a,b|0);return}function s7(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+40|0;g=f|0;h=f+24|0;ro(g,c[b+28>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=b+4|0;j=g+4|0;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[g+12>>2]|0;j=c[g+8>>2]|0;if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;n=22;break}}if(j>>>0<11>>>0){o=j<<1&255;p=h;a[p]=o;q=h+1|0;r=o;s=p}else{p=j+16&-16;o=(z=0,au(248,p|0)|0);if(z){z=0;n=22;break}c[h+8>>2]=o;t=p|1;c[h>>2]=t;c[h+4>>2]=j;q=o;r=t&255;s=h}LF(q|0,k|0,j)|0;a[q+j|0]=0;l=r;m=s}if((l&1)==0){u=h+1|0}else{u=c[h+8>>2]|0}j=d[m]|0;if((j&1|0)==0){v=j>>>1}else{v=c[h+4>>2]|0}z=0,az(88,e|0,u|0,v|0)|0;if(z){z=0;e=bT(-1,-1)|0;j=e;e=M;if((a[m]&1)==0){w=e;x=j;break}Lw(c[h+8>>2]|0);w=e;x=j;break}if((a[m]&1)==0){rq(g);i=f;return}Lw(c[h+8>>2]|0);rq(g);i=f;return}else{z=0;n=22}}while(0);if((n|0)==22){n=bT(-1,-1)|0;w=M;x=n}z=0;ar(364,g|0);if(!z){bg(x|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function s8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;c[b>>2]=21664;f=b+4|0;a[f]=0;a[f+1|0]=0;f=b+16|0;a[f]=0;a[f+1|0]=0;c[b+28>>2]=0;a[b+32|0]=d&1;c[b+36>>2]=e;return}function s9(b){b=b|0;var d=0;c[b>>2]=21664;if((a[b+16|0]&1)!=0){Lw(c[b+24>>2]|0)}if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function ta(b){b=b|0;c[b>>2]=21664;if((a[b+16|0]&1)!=0){Lw(c[b+24>>2]|0)}if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function tb(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+40|0;g=f|0;h=f+24|0;ro(g,c[b+36>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=b+16|0;j=d[e]|0;if((j&1|0)==0){k=j>>>1}else{k=c[b+20>>2]|0}if((k|0)!=0){z=0,az(88,e|0,10192,1)|0;if(z){z=0;l=7;break}}j=g+4|0;if((a[j]&1)==0){m=h;c[m>>2]=c[j>>2];c[m+4>>2]=c[j+4>>2];c[m+8>>2]=c[j+8>>2];n=a[m]|0;o=m}else{m=c[g+12>>2]|0;j=c[g+8>>2]|0;if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;l=7;break}}if(j>>>0<11>>>0){p=j<<1&255;q=h;a[q]=p;r=h+1|0;s=p;t=q}else{q=j+16&-16;p=(z=0,au(248,q|0)|0);if(z){z=0;l=7;break}c[h+8>>2]=p;u=q|1;c[h>>2]=u;c[h+4>>2]=j;r=p;s=u&255;t=h}LF(r|0,m|0,j)|0;a[r+j|0]=0;n=s;o=t}if((n&1)==0){v=h+1|0}else{v=c[h+8>>2]|0}j=d[o]|0;if((j&1|0)==0){w=j>>>1}else{w=c[h+4>>2]|0}z=0,az(88,e|0,v|0,w|0)|0;if(z){z=0;e=bT(-1,-1)|0;j=e;e=M;if((a[o]&1)==0){x=e;y=j;break}Lw(c[h+8>>2]|0);x=e;y=j;break}if((a[o]&1)==0){rq(g);i=f;return}Lw(c[h+8>>2]|0);rq(g);i=f;return}else{z=0;l=7}}while(0);if((l|0)==7){l=bT(-1,-1)|0;x=M;y=l}z=0;ar(364,g|0);if(!z){bg(y|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function tc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f|0;if((a[e+44|0]&1)==0){i=f;return}h=e+32|0;j=(c[e+36>>2]|0)-(c[h>>2]|0)>>2;if((j|0)==0){i=f;return}e=b+4|0;k=b|0;l=j-1|0;m=g;n=g;o=m+1|0;p=m+2|0;m=b+4|0;q=b+36|0;r=g+8|0;s=b+8|0;b=0;L7:while(1){t=d[e]|0;if((t&1|0)==0){u=t>>>1}else{u=c[s>>2]|0}t=c[(c[h>>2]|0)+(b<<2)>>2]|0;cB[c[(c[t>>2]|0)+8>>2]&1023](t|0,k);do{if(b>>>0<l>>>0){t=d[e]|0;if((t&1|0)==0){v=t>>>1}else{v=c[s>>2]|0}if(u>>>0>=v>>>0){break}a[n]=2;a[o]=10;a[p]=0;z=0,az(88,m|0,o|0,1)|0;if(z){z=0;break L7}t=c[q>>2]|0;if((t|0)!=0){z=0;as(320,t+64|0,g|0);if(z){z=0;break L7}}if((a[n]&1)==0){break}Lw(c[r>>2]|0)}}while(0);t=b+1|0;if(t>>>0<j>>>0){b=t}else{w=23;break}}if((w|0)==23){i=f;return}f=bT(-1,-1)|0;if((a[n]&1)==0){bg(f|0)}Lw(c[r>>2]|0);bg(f|0)}function td(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0;e=i;i=i+56|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=k;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+144|0;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=d+32|0;v=c[u>>2]|0;w=c[d+28>>2]|0;x=v;y=b+36|0;A=c[y>>2]|0;L1:do{if((c[A+220>>2]|0)==0){B=Lu(48)|0;c[j>>2]=B;C=A+4|0;D=c[C>>2]|0;if((D|0)==(c[A+8>>2]|0)){e4(A|0,j);E=c[j>>2]|0}else{if((D|0)==0){F=0}else{c[D>>2]=B;F=c[C>>2]|0}c[C>>2]=F+4;E=B}B=E;D=E;G=v+4|0;L10:do{if((a[G]&1)==0){H=m;c[H>>2]=c[G>>2];c[H+4>>2]=c[G+4>>2];c[H+8>>2]=c[G+8>>2];I=17}else{H=c[v+12>>2]|0;J=c[v+8>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(J>>>0<11>>>0){a[m]=J<<1;K=m+1|0}else{L=J+16&-16;N=(z=0,au(248,L|0)|0);if(z){z=0;break}c[m+8>>2]=N;c[m>>2]=L|1;c[m+4>>2]=J;K=N}LF(K|0,H|0,J)|0;a[K+J|0]=0;I=17;break L10}}while(0);J=bT(-1,-1)|0;O=J;P=M}}while(0);do{if((I|0)==17){G=v+16|0;J=h;c[J>>2]=c[G>>2];c[J+4>>2]=c[G+4>>2];c[J+8>>2]=c[G+8>>2];z=0;aV(58,D|0,m|0,h|0,0);if(z){z=0;G=bT(-1,-1)|0;J=G;G=M;if((a[m]&1)==0){O=J;P=G;break}Lw(c[m+8>>2]|0);O=J;P=G;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}G=v+36|0;J=c[G>>2]|0;H=(c[v+40>>2]|0)-J>>2;L32:do{if((H|0)!=0){N=E+32|0;L=N;Q=E+40|0;R=N+12|0;S=E+36|0;T=N;N=0;U=J;while(1){V=c[U+(N<<2)>>2]|0;if((a[V+29|0]&1)==0){c[g>>2]=V;W=c[Q>>2]|0;X=W;if((X|0)==(c[R>>2]|0)){ib(S,g);Y=c[g>>2]|0}else{if((W|0)==0){Z=0}else{c[X>>2]=V;Z=c[Q>>2]|0}c[Q>>2]=Z+4;Y=V}cB[c[c[T>>2]>>2]&1023](L,Y)}V=N+1|0;if(V>>>0>=H>>>0){break L32}N=V;U=c[G>>2]|0}}}while(0);G=E;c[u>>2]=G;_=G;$=D;break L1}}while(0);D=c[A>>2]|0;G=c[C>>2]|0;H=D;while(1){if((H|0)==(G|0)){aa=G;break}if((c[H>>2]|0)==(E|0)){aa=H;break}else{H=H+4|0}}H=aa-D>>2;J=D+(H+1<<2)|0;U=G-J|0;LG(D+(H<<2)|0,J|0,U|0)|0;J=D+((U>>2)+H<<2)|0;H=c[C>>2]|0;if((J|0)!=(H|0)){c[C>>2]=H+(~((H-4+(-J|0)|0)>>>2)<<2)}Lw(B);ab=O;ac=P;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}else{_=v;$=x}}while(0);if((c[$+40>>2]|0)==(c[$+36>>2]|0)){i=e;return}L61:do{if((a[w+46|0]&1)==0){ah=0}else{te(b);L63:do{if((a[b+32|0]&1)==0){ai=b+4|0}else{$=n+64|0;x=n|0;v=n+8|0;P=v|0;c[P>>2]=15464;O=n+12|0;c[x>>2]=32540;aa=n+64|0;c[aa>>2]=32560;c[n+4>>2]=0;z=0;as(198,n+64|0,O|0);do{if(!z){c[n+136>>2]=0;c[n+140>>2]=-1;E=n+8|0;c[x>>2]=15444;c[$>>2]=15484;c[P>>2]=15464;A=O|0;c[A>>2]=15768;u=n+16|0;I_(u);Y=n+20|0;LI(Y|0,0,24)|0;c[A>>2]=15624;Z=n+44|0;g=n+56|0;m=n+60|0;LI(n+44|0,0,16)|0;c[m>>2]=24;LI(l|0,0,12)|0;z=0;as(212,O|0,k|0);if(z){z=0;h=bT(-1,-1)|0;K=M;if((a[l]&1)!=0){Lw(c[k+8>>2]|0)}if((a[Z]&1)!=0){Lw(c[n+52>>2]|0)}c[A>>2]=15768;z=0;ar(394,u|0);if(!z){aj=h;ak=K;break}else{z=0}bT(-1,-1,0)|0;bX()}if((a[l]&1)!=0){Lw(c[k+8>>2]|0)}K=(z=0,aM(114,v|0,8568)|0);L81:do{if(!z){h=(z=0,aM(312,K|0,c[d+20>>2]|0)|0);if(z){z=0;I=132;break}A=(z=0,aM(114,h|0,6512)|0);if(z){z=0;I=132;break}h=d+4|0;if((a[h]&1)==0){F=o;c[F>>2]=c[h>>2];c[F+4>>2]=c[h+4>>2];c[F+8>>2]=c[h+8>>2]}else{h=c[d+12>>2]|0;F=c[d+8>>2]|0;if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;I=132;break}}if(F>>>0<11>>>0){a[o]=F<<1;al=o+1|0}else{j=F+16&-16;J=(z=0,au(248,j|0)|0);if(z){z=0;I=132;break}c[o+8>>2]=J;c[o>>2]=j|1;c[o+4>>2]=F;al=J}LF(al|0,h|0,F)|0;a[al+F|0]=0}F=(z=0,aM(814,A|0,o|0)|0);L98:do{if(!z){A=(z=0,aM(114,F|0,5544)|0);if(z){z=0;I=133;break}z=0;as(352,f|0,A+(c[(c[A>>2]|0)-12>>2]|0)|0);if(z){z=0;I=133;break}h=(z=0,aM(198,f|0,41760)|0);do{if(!z){J=(z=0,aM(c[(c[h>>2]|0)+28>>2]|0,h|0,10)|0);if(z){z=0;break}z=0;ar(394,f|0);if(z){z=0;I=133;break L98}z=0,aM(242,A|0,J|0)|0;if(z){z=0;I=133;break L98}z=0,au(62,A|0)|0;if(z){z=0;I=133;break L98}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}J=p;j=c[m>>2]|0;do{if((j&16|0)==0){if((j&8|0)==0){LI(J|0,0,12)|0;break}H=c[Y>>2]|0;U=c[n+28>>2]|0;N=H;L=U-N|0;if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;I=132;break L81}}if(L>>>0<11>>>0){a[J]=L<<1;am=p+1|0}else{T=L+16&-16;Q=(z=0,au(248,T|0)|0);if(z){z=0;I=132;break L81}c[p+8>>2]=Q;c[p>>2]=T|1;c[p+4>>2]=L;am=Q}if((H|0)==(U|0)){an=am}else{Q=U+(-N|0)|0;N=am;L=H;while(1){a[N]=a[L]|0;H=L+1|0;if((H|0)==(U|0)){break}else{N=N+1|0;L=H}}an=am+Q|0}a[an]=0}else{L=c[g>>2]|0;N=c[n+36>>2]|0;if(L>>>0<N>>>0){c[g>>2]=N;ao=N}else{ao=L}L=c[n+32>>2]|0;N=L;U=ao-N|0;if(U>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;I=132;break L81}}if(U>>>0<11>>>0){a[J]=U<<1;ap=p+1|0}else{H=U+16&-16;T=(z=0,au(248,H|0)|0);if(z){z=0;I=132;break L81}c[p+8>>2]=T;c[p>>2]=H|1;c[p+4>>2]=U;ap=T}if((L|0)==(ao|0)){aq=ap}else{T=ao+(-N|0)|0;N=ap;U=L;while(1){a[N]=a[U]|0;L=U+1|0;if((L|0)==(ao|0)){break}else{N=N+1|0;U=L}}aq=ap+T|0}a[aq]=0}}while(0);j=b+4|0;U=a[J]|0;if((U&1)==0){at=p+1|0}else{at=c[p+8>>2]|0}N=U&255;if((N&1|0)==0){av=N>>>1}else{av=c[p+4>>2]|0}z=0,az(88,j|0,at|0,av|0)|0;do{if(!z){N=c[y>>2]|0;if((N|0)!=0){z=0;as(320,N+64|0,p|0);if(z){z=0;break}}if((a[J]&1)!=0){Lw(c[p+8>>2]|0)}z=0;ar(38,b|0);if(z){z=0;I=132;break L81}c[x>>2]=15444;c[aa>>2]=15484;c[E>>2]=15464;N=n+12|0;c[N>>2]=15624;if((a[Z]&1)!=0){Lw(c[n+52>>2]|0)}c[N>>2]=15768;z=0;ar(394,u|0);if(!z){Ex(n+64|0);ai=j;break L63}else{z=0}N=bT(-1,-1)|0;z=0;ar(272,n+64|0);if(!z){bg(N|0)}else{z=0;bT(-1,-1,0)|0;bX()}}else{z=0}}while(0);j=bT(-1,-1)|0;N=j;j=M;if((a[J]&1)==0){aw=N;ax=j;break L81}Lw(c[p+8>>2]|0);aw=N;ax=j;break L81}else{z=0}}while(0);A=bT(-1,-1)|0;h=M;z=0;ar(394,f|0);if(!z){ay=h;aA=A;break}else{z=0}bT(-1,-1,0)|0;bX()}else{z=0;I=133}}while(0);if((I|0)==133){F=bT(-1,-1)|0;ay=M;aA=F}F=aA;A=ay;if((a[o]&1)==0){aw=F;ax=A;break}Lw(c[o+8>>2]|0);aw=F;ax=A}else{z=0;I=132}}while(0);if((I|0)==132){g=bT(-1,-1)|0;aw=g;ax=M}c[x>>2]=15444;c[aa>>2]=15484;c[E>>2]=15464;g=n+12|0;c[g>>2]=15624;if((a[Z]&1)!=0){Lw(c[n+52>>2]|0)}c[g>>2]=15768;z=0;ar(394,u|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,n+64|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,n+64|0);if(!z){ab=aw;ac=ax;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}else{z=0}bT(-1,-1,0)|0;bX()}else{z=0;g=bT(-1,-1)|0;aj=g;ak=M}}while(0);z=0;ar(272,$|0);if(!z){bg(aj|0)}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);B=b|0;cB[c[(c[_>>2]|0)+8>>2]&1023](_|0,B);C=q;a[C]=6;D=q+1|0;a[D]=a[4120]|0;a[D+1|0]=a[4121]|0;a[D+2|0]=a[4122]|0;a[q+4|0]=0;z=0,az(88,ai|0,D|0,3)|0;do{if(!z){D=c[y>>2]|0;if((D|0)!=0){z=0;as(320,D+64|0,q|0);if(z){z=0;break}}if((a[C]&1)!=0){Lw(c[q+8>>2]|0)}D=b+28|0;G=(c[D>>2]|0)+1|0;c[D>>2]=G;aa=w+32|0;x=c[aa>>2]|0;v=(c[w+36>>2]|0)-x>>2;do{if((v|0)==0){aB=G}else{O=r;P=r+8|0;g=r+4|0;Y=r+1|0;m=r|0;K=s;A=s;F=K+1|0;h=K+2|0;K=s+8|0;j=0;N=x;L217:while(1){U=c[N+(j<<2)>>2]|0;if((U|0)==0){I=152;break}do{if((c[(c[(c[U>>2]|0)-4>>2]|0)+4>>2]|0)==28552){Q=c[U+32>>2]|0;L=c[Q+32>>2]|0;if((L|0)==5){H=Q+40|0;S=c[H>>2]|0;R=(c[Q+44>>2]|0)-S>>2;if((R|0)==0){aC=0;break}else{aD=1;aE=0;aF=S}while(1){S=c[aF+(aE<<2)>>2]|0;aG=(cD[c[(c[S>>2]|0)+44>>2]&511](S)|0)&aD;S=aE+1|0;if(S>>>0>=R>>>0){break}aD=aG;aE=S;aF=c[H>>2]|0}aC=aG^1;break}else if((L|0)!=4){aC=1;break}H=Q+40|0;if((a[H]&1)==0){c[O>>2]=c[H>>2];c[O+4>>2]=c[H+4>>2];c[O+8>>2]=c[H+8>>2];aH=a[O]|0}else{H=c[Q+48>>2]|0;R=c[Q+44>>2]|0;if(R>>>0>4294967279>>>0){I=158;break L217}if(R>>>0<11>>>0){S=R<<1&255;a[O]=S;aI=Y;aJ=S}else{S=R+16&-16;V=Lu(S)|0;c[P>>2]=V;X=S|1;c[m>>2]=X;c[g>>2]=R;aI=V;aJ=X&255}LF(aI|0,H|0,R)|0;a[aI+R|0]=0;aH=aJ}R=aH&255;H=(((R&1|0)==0?R>>>1:c[g>>2]|0)|0)!=0;if((aH&1)==0){aC=H;break}Lw(c[P>>2]|0);aC=H}else{aC=1}}while(0);do{if(!(cD[c[(c[U>>2]|0)+36>>2]&511](U)|0|aC^1)){if((cD[c[(c[U>>2]|0)+40>>2]&511](U)|0)==0){te(b)}cB[c[(c[U>>2]|0)+8>>2]&1023](U|0,B);a[A]=2;a[F]=10;a[h]=0;z=0,az(88,ai|0,F|0,1)|0;if(z){z=0;I=179;break L217}H=c[y>>2]|0;if((H|0)!=0){z=0;as(320,H+64|0,s|0);if(z){z=0;I=179;break L217}}if((a[A]&1)==0){break}Lw(c[K>>2]|0)}}while(0);U=j+1|0;if(U>>>0>=v>>>0){I=183;break}j=U;N=c[aa>>2]|0}if((I|0)==152){cj()}else if((I|0)==158){D5(0)}else if((I|0)==179){N=bT(-1,-1)|0;j=N;N=M;if((a[A]&1)==0){ab=j;ac=N;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}Lw(c[K>>2]|0);ab=j;ac=N;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}else if((I|0)==183){aB=c[D>>2]|0;break}}}while(0);c[D>>2]=aB-1;aa=ai;v=a[aa]|0;x=v&255;if((x&1|0)==0){aK=x>>>1;aL=x>>>1}else{x=c[b+8>>2]|0;aK=x;aL=x}x=aL-1|0;if(aK>>>0<x>>>0){D6(0)}if((v&1)==0){a[aa]=x<<1;aN=ai+1|0}else{aa=c[b+12>>2]|0;c[b+8>>2]=x;aN=aa}a[aN+x|0]=0;x=c[y>>2]|0;if((x|0)!=0){AC(x+64|0)}x=t;a[x]=6;aa=t+1|0;a[aa]=a[2776]|0;a[aa+1|0]=a[2777]|0;a[aa+2|0]=a[2778]|0;a[t+4|0]=0;z=0,az(88,ai|0,aa|0,3)|0;do{if(!z){aa=c[y>>2]|0;if((aa|0)!=0){z=0;as(320,aa+64|0,t|0);if(z){z=0;break}}if((a[x]&1)==0){ah=1;break L61}Lw(c[t+8>>2]|0);ah=1;break L61}else{z=0}}while(0);D=bT(-1,-1)|0;aa=D;D=M;if((a[x]&1)==0){ab=aa;ac=D;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}Lw(c[t+8>>2]|0);ab=aa;ac=D;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}else{z=0}}while(0);B=bT(-1,-1)|0;D=B;B=M;if((a[C]&1)==0){ab=D;ac=B;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}Lw(c[q+8>>2]|0);ab=D;ac=B;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}}while(0);if((a[w+45|0]&1)==0){i=e;return}if(ah){af=b+28|0;c[af>>2]=(c[af>>2]|0)+1}af=w+32|0;ac=c[af>>2]|0;ag=(c[w+36>>2]|0)-ac>>2;L299:do{if((ag|0)!=0){w=b|0;ad=0;ae=ac;while(1){ab=c[ae+(ad<<2)>>2]|0;if(cD[c[(c[ab>>2]|0)+36>>2]&511](ab)|0){cB[c[(c[ab>>2]|0)+8>>2]&1023](ab|0,w)}ab=ad+1|0;if(ab>>>0>=ag>>>0){break L299}ad=ab;ae=c[af>>2]|0}}}while(0);if(!ah){i=e;return}ah=b+28|0;c[ah>>2]=(c[ah>>2]|0)-1;i=e;return}function te(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d|0;f=c[b+28>>2]|0;g=f<<1;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){h=f<<2&255;f=e;a[f]=h;j=e+1|0;k=h;l=f}else{f=g+16&-16;h=Lu(f)|0;c[e+8>>2]=h;m=f|1;c[e>>2]=m;c[e+4>>2]=g;j=h;k=m&255;l=e}LI(j|0,32,g|0)|0;a[j+g|0]=0;if((k&1)==0){n=e+1|0}else{n=c[e+8>>2]|0}g=k&255;if((g&1|0)==0){o=g>>>1}else{o=c[e+4>>2]|0}z=0,az(88,b+4|0,n|0,o|0)|0;do{if(!z){o=c[b+36>>2]|0;if((o|0)!=0){z=0;as(320,o+64|0,e|0);if(z){z=0;break}}if((a[l]&1)==0){i=d;return}Lw(c[e+8>>2]|0);i=d;return}else{z=0}}while(0);d=bT(-1,-1)|0;if((a[l]&1)==0){bg(d|0)}Lw(c[e+8>>2]|0);bg(d|0)}function tf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;i=i+96|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=c[d+32>>2]|0;n=c[d+28>>2]|0;te(b);o=b+36|0;AE((c[o>>2]|0)+64|0,d|0);p=f;a[p]=14;q=f+1|0;a[q]=a[1712]|0;a[q+1|0]=a[1713]|0;a[q+2|0]=a[1714]|0;a[q+3|0]=a[1715]|0;a[q+4|0]=a[1716]|0;a[q+5|0]=a[1717]|0;a[q+6|0]=a[1718]|0;r=f+8|0;a[r]=0;s=b+4|0;z=0,az(88,s|0,q|0,7)|0;do{if(!z){q=c[o>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,f|0);if(z){z=0;break}}if((a[p]&1)!=0){Lw(c[r>>2]|0)}q=b|0;cB[c[(c[m>>2]|0)+8>>2]&1023](m,q);t=g;a[t]=6;u=g+1|0;a[u]=a[4120]|0;a[u+1|0]=a[4121]|0;a[u+2|0]=a[4122]|0;a[g+4|0]=0;z=0,az(88,s|0,u|0,3)|0;do{if(!z){u=c[o>>2]|0;if((u|0)!=0){z=0;as(320,u+64|0,g|0);if(z){z=0;break}}if((a[t]&1)!=0){Lw(c[g+8>>2]|0)}u=c[d+36>>2]|0;L17:do{if((u|0)==0){v=0}else{if((a[n+46|0]&1)==0){v=0;break}w=b+28|0;c[w>>2]=(c[w>>2]|0)+1;te(b);cB[c[(c[u>>2]|0)+8>>2]&1023](u|0,q);w=h;a[w]=6;x=h+1|0;a[x]=a[4120]|0;a[x+1|0]=a[4121]|0;a[x+2|0]=a[4122]|0;a[h+4|0]=0;z=0,az(88,s|0,x|0,3)|0;do{if(!z){x=c[o>>2]|0;if((x|0)!=0){z=0;as(320,x+64|0,h|0);if(z){z=0;break}}if((a[w]&1)==0){v=1;break L17}Lw(c[h+8>>2]|0);v=1;break L17}else{z=0}}while(0);x=bT(-1,-1)|0;y=x;x=M;if((a[w]&1)==0){A=y;B=x;C=A;D=0;E=C;F=B;bg(E|0)}Lw(c[h+8>>2]|0);A=y;B=x;C=A;D=0;E=C;F=B;bg(E|0)}}while(0);u=b+28|0;x=(c[u>>2]|0)+1|0;c[u>>2]=x;y=n+36|0;G=n+32|0;H=c[G>>2]|0;I=(c[y>>2]|0)-H>>2;do{if((I|0)==0){J=x}else{K=j;L=j;N=K+1|0;O=K+2|0;K=j+8|0;P=0;Q=H;L34:while(1){R=c[Q+(P<<2)>>2]|0;do{if(!(cD[c[(c[R>>2]|0)+36>>2]&511](R)|0)){if((cD[c[(c[R>>2]|0)+40>>2]&511](R)|0)==0){te(b)}cB[c[(c[R>>2]|0)+8>>2]&1023](R|0,q);a[L]=2;a[N]=10;a[O]=0;z=0,az(88,s|0,N|0,1)|0;if(z){z=0;break L34}S=c[o>>2]|0;if((S|0)!=0){z=0;as(320,S+64|0,j|0);if(z){z=0;break L34}}if((a[L]&1)==0){break}Lw(c[K>>2]|0)}}while(0);R=P+1|0;if(R>>>0>=I>>>0){T=38;break}P=R;Q=c[G>>2]|0}if((T|0)==38){J=c[u>>2]|0;break}Q=bT(-1,-1)|0;P=Q;Q=M;if((a[L]&1)==0){A=P;B=Q;C=A;D=0;E=C;F=B;bg(E|0)}Lw(c[K>>2]|0);A=P;B=Q;C=A;D=0;E=C;F=B;bg(E|0)}}while(0);c[u>>2]=J-1;L56:do{if(v){I=s;H=a[I]|0;x=H&255;if((x&1|0)==0){U=x>>>1;V=x>>>1}else{x=c[b+8>>2]|0;U=x;V=x}x=V-1|0;if(U>>>0<x>>>0){D6(0)}if((H&1)==0){a[I]=x<<1;W=s+1|0}else{I=c[b+12>>2]|0;c[b+8>>2]=x;W=I}a[W+x|0]=0;x=c[o>>2]|0;if((x|0)!=0){AC(x+64|0)}x=k;a[x]=6;I=k+1|0;a[I]=a[2776]|0;a[I+1|0]=a[2777]|0;a[I+2|0]=a[2778]|0;a[k+4|0]=0;z=0,az(88,s|0,I|0,3)|0;do{if(!z){I=c[o>>2]|0;if((I|0)!=0){z=0;as(320,I+64|0,k|0);if(z){z=0;break}}if((a[x]&1)!=0){Lw(c[k+8>>2]|0)}X=(c[u>>2]|0)+1|0;break L56}else{z=0}}while(0);K=bT(-1,-1)|0;L=K;K=M;if((a[x]&1)==0){A=L;B=K;C=A;D=0;E=C;F=B;bg(E|0)}Lw(c[k+8>>2]|0);A=L;B=K;C=A;D=0;E=C;F=B;bg(E|0)}else{X=J}}while(0);c[u>>2]=X;K=c[G>>2]|0;L=(c[y>>2]|0)-K>>2;L87:do{if((L|0)!=0){I=0;H=K;while(1){Q=c[H+(I<<2)>>2]|0;if(cD[c[(c[Q>>2]|0)+36>>2]&511](Q)|0){cB[c[(c[Q>>2]|0)+8>>2]&1023](Q|0,q)}Q=I+1|0;if(Q>>>0>=L>>>0){break L87}I=Q;H=c[G>>2]|0}}}while(0);G=c[u>>2]|0;if(v){L=G-1|0;c[u>>2]=L;Y=L}else{Y=G}c[u>>2]=Y-1;G=s;L=a[G]|0;K=L&255;if((K&1|0)==0){Z=K>>>1;_=K>>>1}else{K=c[b+8>>2]|0;Z=K;_=K}K=_-1|0;if(Z>>>0<K>>>0){D6(0)}if((L&1)==0){a[G]=K<<1;$=s+1|0}else{G=c[b+12>>2]|0;c[b+8>>2]=K;$=G}a[$+K|0]=0;K=c[o>>2]|0;if((K|0)!=0){AC(K+64|0)}K=l;a[K]=6;G=l+1|0;a[G]=a[2776]|0;a[G+1|0]=a[2777]|0;a[G+2|0]=a[2778]|0;a[l+4|0]=0;z=0,az(88,s|0,G|0,3)|0;do{if(!z){G=c[o>>2]|0;if((G|0)!=0){z=0;as(320,G+64|0,l|0);if(z){z=0;break}}if((a[K]&1)==0){i=e;return}Lw(c[l+8>>2]|0);i=e;return}else{z=0}}while(0);u=bT(-1,-1)|0;G=u;u=M;if((a[K]&1)==0){A=G;B=u;C=A;D=0;E=C;F=B;bg(E|0)}Lw(c[l+8>>2]|0);A=G;B=u;C=A;D=0;E=C;F=B;bg(E|0)}else{z=0}}while(0);q=bT(-1,-1)|0;u=q;q=M;if((a[t]&1)==0){A=u;B=q;C=A;D=0;E=C;F=B;bg(E|0)}Lw(c[g+8>>2]|0);A=u;B=q;C=A;D=0;E=C;F=B;bg(E|0)}else{z=0}}while(0);g=bT(-1,-1)|0;l=g;g=M;if((a[p]&1)==0){A=l;B=g;C=A;D=0;E=C;F=B;bg(E|0)}Lw(c[r>>2]|0);A=l;B=g;C=A;D=0;E=C;F=B;bg(E|0)}function tg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;e=i;i=i+128|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=d+32|0;if((a[o]&1)==0){p=f;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];q=a[p]|0;r=p}else{p=c[d+40>>2]|0;o=c[d+36>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){s=o<<1&255;t=f;a[t]=s;u=f+1|0;v=s;w=t}else{t=o+16&-16;s=Lu(t)|0;c[f+8>>2]=s;x=t|1;c[f>>2]=x;c[f+4>>2]=o;u=s;v=x&255;w=f}LF(u|0,p|0,o)|0;a[u+o|0]=0;q=v;r=w}w=c[d+44>>2]|0;v=c[d+48>>2]|0;o=c[d+28>>2]|0;d=b+4|0;if((q&1)==0){y=f+1|0}else{y=c[f+8>>2]|0}u=q&255;if((u&1|0)==0){A=u>>>1}else{A=c[f+4>>2]|0}z=0,az(88,d|0,y|0,A|0)|0;L20:do{if(!z){A=b+36|0;y=c[A>>2]|0;if((y|0)!=0){z=0;as(320,y+64|0,f|0);if(z){z=0;B=27;break}}L25:do{if((w|0)==0){if((v|0)==0){break}y=h;u=h;a[u]=2;q=y+1|0;a[q]=32;a[y+2|0]=0;z=0,az(88,d|0,q|0,1)|0;do{if(!z){q=c[A>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,h|0);if(z){z=0;break}}if((a[u]&1)!=0){Lw(c[h+8>>2]|0)}z=0;as(c[(c[v>>2]|0)+8>>2]|0,v|0,b|0);if(!z){break L25}else{z=0;B=27;break L20}}else{z=0}}while(0);q=bT(-1,-1)|0;y=q;q=M;if((a[u]&1)==0){C=y;D=q;break L20}Lw(c[h+8>>2]|0);C=y;D=q;break L20}else{q=g;y=g;a[y]=2;p=q+1|0;a[p]=32;a[q+2|0]=0;z=0,az(88,d|0,p|0,1)|0;do{if(!z){p=c[A>>2]|0;if((p|0)!=0){z=0;as(320,p+64|0,g|0);if(z){z=0;break}}if((a[y]&1)!=0){Lw(c[g+8>>2]|0)}z=0;as(c[(c[w>>2]|0)+8>>2]|0,w|0,b|0);if(!z){break L25}else{z=0;B=27;break L20}}else{z=0}}while(0);u=bT(-1,-1)|0;p=u;u=M;if((a[y]&1)==0){C=p;D=u;break L20}Lw(c[g+8>>2]|0);C=p;D=u;break L20}}while(0);L50:do{if((o|0)==0){u=j;p=j;a[p]=2;q=u+1|0;a[q]=59;a[u+2|0]=0;z=0,az(88,d|0,q|0,1)|0;do{if(!z){q=c[A>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,j|0);if(z){z=0;break}}if((a[p]&1)==0){break L50}Lw(c[j+8>>2]|0);break L50}else{z=0}}while(0);y=bT(-1,-1)|0;q=y;y=M;if((a[p]&1)==0){C=q;D=y;break L20}Lw(c[j+8>>2]|0);C=q;D=y;break L20}else{y=k;a[y]=6;q=k+1|0;a[q]=a[4120]|0;a[q+1|0]=a[4121]|0;a[q+2|0]=a[4122]|0;a[k+4|0]=0;z=0,az(88,d|0,q|0,3)|0;do{if(!z){q=c[A>>2]|0;if((q|0)!=0){z=0;as(320,q+64|0,k|0);if(z){z=0;break}}if((a[y]&1)!=0){Lw(c[k+8>>2]|0)}q=b+28|0;c[q>>2]=(c[q>>2]|0)+1;u=o+36|0;x=c[u>>2]|0;s=o+32|0;t=c[s>>2]|0;E=x-t>>2;do{if((E|0)==0){F=x;G=t}else{H=b|0;I=l;J=l;K=I+1|0;L=I+2|0;I=l+8|0;N=0;O=t;L71:while(1){P=c[O+(N<<2)>>2]|0;Q=(z=0,au(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(z){z=0;B=26;break}do{if(!Q){R=(z=0,au(c[(c[P>>2]|0)+40>>2]|0,P|0)|0);if(z){z=0;B=26;break L71}if((R|0)==0){z=0;ar(38,b|0);if(z){z=0;B=26;break L71}}z=0;as(c[(c[P>>2]|0)+8>>2]|0,P|0,H|0);if(z){z=0;B=26;break L71}a[J]=2;a[K]=10;a[L]=0;z=0,az(88,d|0,K|0,1)|0;if(z){z=0;B=68;break L71}R=c[A>>2]|0;if((R|0)!=0){z=0;as(320,R+64|0,l|0);if(z){z=0;B=68;break L71}}if((a[J]&1)==0){break}Lw(c[I>>2]|0)}}while(0);P=N+1|0;if(P>>>0>=E>>>0){B=72;break}N=P;O=c[s>>2]|0}if((B|0)==26){O=bT(-1,-1)|0;S=M;T=O;B=28;break L20}else if((B|0)==68){O=bT(-1,-1)|0;N=O;O=M;if((a[J]&1)==0){C=N;D=O;break L20}Lw(c[I>>2]|0);C=N;D=O;break L20}else if((B|0)==72){F=c[u>>2]|0;G=c[s>>2]|0;break}}}while(0);u=F-G>>2;L94:do{if((u|0)!=0){E=b|0;t=m;x=m;O=t+1|0;N=t+2|0;t=m+8|0;K=0;L=G;L96:while(1){H=c[L+(K<<2)>>2]|0;P=(z=0,au(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(z){z=0;B=25;break}do{if(P){z=0;as(c[(c[H>>2]|0)+8>>2]|0,H|0,E|0);if(z){z=0;B=25;break L96}a[x]=2;a[O]=10;a[N]=0;z=0,az(88,d|0,O|0,1)|0;if(z){z=0;break L96}Q=c[A>>2]|0;if((Q|0)!=0){z=0;as(320,Q+64|0,m|0);if(z){z=0;break L96}}if((a[x]&1)==0){break}Lw(c[t>>2]|0)}}while(0);H=K+1|0;if(H>>>0>=u>>>0){break L94}K=H;L=c[s>>2]|0}if((B|0)==25){L=bT(-1,-1)|0;S=M;T=L;B=28;break L20}L=bT(-1,-1)|0;K=L;L=M;if((a[x]&1)==0){C=K;D=L;break L20}Lw(c[t>>2]|0);C=K;D=L;break L20}}while(0);c[q>>2]=(c[q>>2]|0)-1;s=d;u=a[s]|0;L=u&255;if((L&1|0)==0){U=L>>>1;V=L>>>1}else{L=c[b+8>>2]|0;U=L;V=L}L=V-1|0;K=d;if(U>>>0<L>>>0){z=0;ar(240,0);if(z){z=0;B=27;break L20}}if((u&1)==0){a[s]=L<<1;W=K+1|0}else{u=c[b+12>>2]|0;c[b+8>>2]=L;W=u}a[W+L|0]=0;L=c[A>>2]|0;if((L|0)!=0){z=0;ar(308,L+64|0);if(z){z=0;B=27;break L20}}do{if((a[o+45|0]&1)!=0){L=a[s]|0;u=L&255;if((u&1|0)==0){X=u>>>1;Y=u>>>1}else{u=c[b+8>>2]|0;X=u;Y=u}u=Y-1|0;if(X>>>0<u>>>0){z=0;ar(240,0);if(z){z=0;B=27;break L20}}if((L&1)==0){a[s]=u<<1;Z=K+1|0}else{L=c[b+12>>2]|0;c[b+8>>2]=u;Z=L}a[Z+u|0]=0;u=c[A>>2]|0;if((u|0)==0){break}z=0;ar(308,u+64|0);if(z){z=0;B=27;break L20}}}while(0);K=n;a[K]=6;s=n+1|0;a[s]=a[2776]|0;a[s+1|0]=a[2777]|0;a[s+2|0]=a[2778]|0;a[n+4|0]=0;z=0,az(88,d|0,s|0,3)|0;do{if(!z){s=c[A>>2]|0;if((s|0)!=0){z=0;as(320,s+64|0,n|0);if(z){z=0;break}}if((a[K]&1)==0){break L50}Lw(c[n+8>>2]|0);break L50}else{z=0}}while(0);s=bT(-1,-1)|0;q=s;s=M;if((a[K]&1)==0){C=q;D=s;break L20}Lw(c[n+8>>2]|0);C=q;D=s;break L20}else{z=0}}while(0);p=bT(-1,-1)|0;s=p;p=M;if((a[y]&1)==0){C=s;D=p;break L20}Lw(c[k+8>>2]|0);C=s;D=p;break L20}}while(0);if((a[r]&1)==0){i=e;return}Lw(c[f+8>>2]|0);i=e;return}else{z=0;B=27}}while(0);if((B|0)==27){e=bT(-1,-1)|0;S=M;T=e;B=28}if((B|0)==28){C=T;D=S}if((a[r]&1)==0){_=C;$=0;aa=_;ab=D;bg(aa|0)}Lw(c[f+8>>2]|0);_=C;$=0;aa=_;ab=D;bg(aa|0)}function th(a,b){a=a|0;b=b|0;t$(a,b);return}function ti(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tj(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tk(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tl(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tm(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tn(a,b){a=a|0;b=b|0;t$(a,b|0);return}function to(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tp(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tq(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tr(a,b){a=a|0;b=b|0;t$(a,b|0);return}function ts(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tt(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tu(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tv(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tw(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tx(a,b){a=a|0;b=b|0;t$(a,b|0);return}function ty(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tz(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tA(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tB(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tC(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tD(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tE(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tF(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tG(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tH(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tI(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tJ(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tK(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tL(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tM(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tN(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tO(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tP(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tQ(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tR(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tS(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tT(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tU(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tV(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tW(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tX(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tY(a,b){a=a|0;b=b|0;t$(a,b|0);return}function tZ(a,b){a=a|0;b=b|0;t$(a,b|0);return}function t_(a,b){a=a|0;b=b|0;t$(a,b|0);return}function t$(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+40|0;g=f|0;h=f+24|0;ro(g,c[b+36>>2]|0);z=0;as(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!z){e=b+4|0;j=g+4|0;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[g+12>>2]|0;j=c[g+8>>2]|0;if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;n=22;break}}if(j>>>0<11>>>0){o=j<<1&255;p=h;a[p]=o;q=h+1|0;r=o;s=p}else{p=j+16&-16;o=(z=0,au(248,p|0)|0);if(z){z=0;n=22;break}c[h+8>>2]=o;t=p|1;c[h>>2]=t;c[h+4>>2]=j;q=o;r=t&255;s=h}LF(q|0,k|0,j)|0;a[q+j|0]=0;l=r;m=s}if((l&1)==0){u=h+1|0}else{u=c[h+8>>2]|0}j=d[m]|0;if((j&1|0)==0){v=j>>>1}else{v=c[h+4>>2]|0}z=0,az(88,e|0,u|0,v|0)|0;if(z){z=0;e=bT(-1,-1)|0;j=e;e=M;if((a[m]&1)==0){w=e;x=j;break}Lw(c[h+8>>2]|0);w=e;x=j;break}if((a[m]&1)==0){rq(g);i=f;return}Lw(c[h+8>>2]|0);rq(g);i=f;return}else{z=0;n=22}}while(0);if((n|0)==22){n=bT(-1,-1)|0;w=M;x=n}z=0;ar(364,g|0);if(!z){bg(x|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function t0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=f;if((a[l]&1)==0){m=k;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[f+8>>2]|0;m=c[f+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[k]=m<<1;n=k+1|0}else{f=m+16&-16;o=Lu(f)|0;c[k+8>>2]=o;c[k>>2]=f|1;c[k+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=g;g=j;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];z=0;aV(38,b|0,e|0,k|0,j|0);if(!z){if((a[k]&1)==0){p=b+16|0;c[p>>2]=d;q=b+20|0;c[q>>2]=d;r=LJ(d|0)|0;s=d+r|0;t=b+24|0;c[t>>2]=s;i=h;return}Lw(c[k+8>>2]|0);p=b+16|0;c[p>>2]=d;q=b+20|0;c[q>>2]=d;r=LJ(d|0)|0;s=d+r|0;t=b+24|0;c[t>>2]=s;i=h;return}else{z=0;h=bT(-1,-1)|0;if((a[k]&1)==0){bg(h|0)}Lw(c[k+8>>2]|0);bg(h|0)}}function t1(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+32|0;j=d;d=i;i=i+8|0;c[d>>2]=c[j>>2];c[d+4>>2]=c[j+4>>2];j=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=f;if((a[l]&1)==0){m=k;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[f+8>>2]|0;m=c[f+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[k]=m<<1;n=k+1|0}else{f=m+16&-16;o=Lu(f)|0;c[k+8>>2]=o;c[k>>2]=f|1;c[k+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=g;g=j;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];z=0;aV(38,b|0,e|0,k|0,j|0);if(!z){if((a[k]&1)==0){p=d|0;q=c[p>>2]|0;r=b+16|0;c[r>>2]=q;s=b+20|0;c[s>>2]=q;t=d+4|0;u=c[t>>2]|0;v=b+24|0;c[v>>2]=u;i=h;return}Lw(c[k+8>>2]|0);p=d|0;q=c[p>>2]|0;r=b+16|0;c[r>>2]=q;s=b+20|0;c[s>>2]=q;t=d+4|0;u=c[t>>2]|0;v=b+24|0;c[v>>2]=u;i=h;return}else{z=0;h=bT(-1,-1)|0;if((a[k]&1)==0){bg(h|0)}Lw(c[k+8>>2]|0);bg(h|0)}}function t2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0;d=i;i=i+200|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=d+48|0;m=d+56|0;n=d+64|0;o=d+72|0;p=d+80|0;q=d+88|0;r=d+96|0;s=d+104|0;t=d+120|0;u=d+128|0;v=d+136|0;w=d+144|0;x=d+152|0;y=d+168|0;A=d+176|0;B=d+192|0;C=B;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+12|0;i=i+7&-8;G=i;i=i+12|0;i=i+7&-8;H=i;i=i+12|0;i=i+7&-8;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+12|0;i=i+7&-8;K=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+12|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+12|0;i=i+7&-8;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+12|0;i=i+7&-8;W=i;i=i+12|0;i=i+7&-8;X=b|0;Y=c[X>>2]|0;Z=Lu(48)|0;c[y>>2]=Z;_=Y+4|0;$=c[_>>2]|0;if(($|0)==(c[Y+8>>2]|0)){e4(Y|0,y);aa=c[y>>2]|0}else{if(($|0)==0){ab=0}else{c[$>>2]=Z;ab=c[_>>2]|0}c[_>>2]=ab+4;aa=Z}Z=aa;ab=aa;$=b+28|0;L8:do{if((a[$]&1)==0){y=A;c[y>>2]=c[$>>2];c[y+4>>2]=c[$+4>>2];c[y+8>>2]=c[$+8>>2];ac=16}else{y=c[b+36>>2]|0;ad=c[b+32>>2]|0;do{if(ad>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ad>>>0<11>>>0){a[A]=ad<<1;ae=A+1|0}else{af=ad+16&-16;ag=(z=0,au(248,af|0)|0);if(z){z=0;break}c[A+8>>2]=ag;c[A>>2]=af|1;c[A+4>>2]=ad;ae=ag}LF(ae|0,y|0,ad)|0;a[ae+ad|0]=0;ac=16;break L8}}while(0);ad=bT(-1,-1)|0;ah=ad;ai=M}}while(0);do{if((ac|0)==16){ae=b+44|0;ad=x;c[ad>>2]=c[ae>>2];c[ad+4>>2]=c[ae+4>>2];c[ad+8>>2]=c[ae+8>>2];z=0;aq(4,ab|0,A|0,x|0,0,0);if(z){z=0;ad=bT(-1,-1)|0;y=ad;ad=M;if((a[A]&1)==0){ah=y;ai=ad;break}Lw(c[A+8>>2]|0);ah=y;ai=ad;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}a[aa+44|0]=1;t3(b);t4(b)|0;ad=b+20|0;y=b+24|0;if((c[ad>>2]|0)>>>0>=(c[y>>2]|0)>>>0){i=d;return ab|0}ag=T|0;af=V+8|0;aj=V|0;ak=V+4|0;al=W|0;am=W+4|0;an=W+8|0;ao=V;ap=T+4|0;at=aa+28|0;av=at;aw=U|0;ax=U+4|0;ay=aa+36|0;az=ay;aA=aa+40|0;aB=aa+32|0;aC=at;at=R+8|0;aD=R|0;aE=R+4|0;aF=S|0;aG=S+4|0;aH=S+8|0;aI=R;aJ=b+48|0;aK=b+40|0;aL=b+52|0;aM=b+56|0;aN=P+8|0;aO=P|0;aP=P+4|0;aQ=Q|0;aS=Q+4|0;aT=Q+8|0;aU=P;aW=N+8|0;aX=N|0;aY=N+4|0;aZ=O|0;a_=O+4|0;a$=O+8|0;a0=N;a1=K+8|0;a2=K|0;a3=K+4|0;a4=L|0;a5=L+4|0;a6=L+8|0;a7=K;a8=I+8|0;a9=I|0;ba=I+4|0;bb=J|0;bc=J+4|0;bd=J+8|0;be=I;bf=F;bh=G;bi=H;bj=s;bk=F+8|0;bl=H+8|0;bm=H+1|0;bn=H|0;bo=H+4|0;bp=b+36|0;bq=b+32|0;br=F+1|0;bs=F|0;bt=F+4|0;bu=D;bv=E;bw=D+8|0;bx=D+1|0;by=D|0;bz=D+4|0;L33:while(1){L35:do{if((t5(b)|0)==0){if((y4(y$(c[ad>>2]|0)|0)|0)!=0){bA=t8(b)|0;if((c[bA+40>>2]|0)!=(c[bA+44>>2]|0)){bB=bA|0;c[u>>2]=bB;bC=c[az>>2]|0;if((bC|0)==(c[aA>>2]|0)){m3(aB,u);bD=c[u>>2]|0}else{if((bC|0)==0){bE=0}else{c[bC>>2]=bB;bE=c[az>>2]|0}c[ay>>2]=bE+4;bD=bB}cB[c[c[aC>>2]>>2]&1023](av,bD)}bB=bA+28|0;bC=c[bB>>2]|0;bF=c[bA+32>>2]|0;if((bC|0)!=(bF|0)){bA=(bF-bC|0)/12|0;bC=0;do{bG=c[X>>2]|0;bF=Lu(40)|0;c[t>>2]=bF;bH=bG+4|0;bI=c[bH>>2]|0;if((bI|0)==(c[bG+8>>2]|0)){e4(bG|0,t);bJ=c[t>>2]|0}else{if((bI|0)==0){bK=0}else{c[bI>>2]=bF;bK=c[bH>>2]|0}c[bH>>2]=bK+4;bJ=bF}bL=bJ;bF=bJ;if((a[$]&1)==0){c[bf>>2]=c[$>>2];c[bf+4>>2]=c[$+4>>2];c[bf+8>>2]=c[$+8>>2]}else{bI=c[bp>>2]|0;bM=c[bq>>2]|0;if(bM>>>0>4294967279>>>0){ac=84;break L33}if(bM>>>0<11>>>0){a[bf]=bM<<1;bN=br}else{bO=bM+16&-16;bP=(z=0,au(248,bO|0)|0);if(z){z=0;ac=114;break L33}c[bk>>2]=bP;c[bs>>2]=bO|1;c[bt>>2]=bM;bN=bP}LF(bN|0,bI|0,bM)|0;a[bN+bM|0]=0}c[bh>>2]=c[ae>>2];c[bh+4>>2]=c[ae+4>>2];c[bh+8>>2]=c[ae+8>>2];bM=c[bB>>2]|0;bI=bM+(bC*12|0)|0;if((a[bI]&1)==0){c[bi>>2]=c[bI>>2];c[bi+4>>2]=c[bI+4>>2];c[bi+8>>2]=c[bI+8>>2]}else{bI=c[bM+(bC*12|0)+8>>2]|0;bP=c[bM+(bC*12|0)+4>>2]|0;if(bP>>>0>4294967279>>>0){ac=94;break L33}if(bP>>>0<11>>>0){a[bi]=bP<<1;bQ=bm}else{bM=bP+16&-16;bO=(z=0,au(248,bM|0)|0);if(z){z=0;ac=117;break L33}c[bl>>2]=bO;c[bn>>2]=bM|1;c[bo>>2]=bP;bQ=bO}LF(bQ|0,bI|0,bP)|0;a[bQ+bP|0]=0}c[bj>>2]=c[bh>>2];c[bj+4>>2]=c[bh+4>>2];c[bj+8>>2]=c[bh+8>>2];z=0;aV(28,bF|0,F|0,s|0,H|0);if(z){z=0;bR=1;ac=120;break L33}bF=bJ;c[r>>2]=bF;bP=c[az>>2]|0;if((bP|0)==(c[aA>>2]|0)){z=0;as(488,aB|0,r|0);if(z){z=0;bR=0;ac=120;break L33}bS=c[r>>2]|0}else{if((bP|0)==0){bU=0}else{c[bP>>2]=bF;bU=c[az>>2]|0}c[ay>>2]=bU+4;bS=bF}z=0;as(c[c[aC>>2]>>2]|0,av|0,bS|0);if(z){z=0;bR=0;ac=120;break L33}if((a[bi]&1)!=0){Lw(c[bl>>2]|0)}if((a[bf]&1)!=0){Lw(c[bk>>2]|0)}bC=bC+1|0;}while(bC>>>0<bA>>>0)}bA=y$(c[ad>>2]|0)|0;bC=(a[bA]|0)==59?bA+1|0:0;if((bC|0)==0){bB=Lu(64)|0;c[a8>>2]=bB;c[a9>>2]=65;c[ba>>2]=53;LF(bB|0,2416,53)|0;a[bB+53|0]=0;c[bb>>2]=0;c[bc>>2]=0;c[bd>>2]=0;z=0;aR(492,b|0,I|0,J|0);if(z){z=0;ac=145;break L33}if((a[be]&1)==0){break}Lw(c[a8>>2]|0);break}bB=c[aJ>>2]|0;bF=c[ad>>2]|0;L131:do{if(bF>>>0<bC>>>0){bP=bF;bI=0;while(1){bO=a[bP]|0;if((bO<<24>>24|0)==10){bV=bI+1|0}else if((bO<<24>>24|0)==0){bW=bI;break L131}else{bV=bI}bO=bP+1|0;if(bO>>>0<bC>>>0){bP=bO;bI=bV}else{bW=bV;break}}}else{bW=0}}while(0);c[aJ>>2]=bW+bB;bI=bA;bP=0;while(1){bO=bI-1|0;if(bO>>>0<bF>>>0){break}if((a[bO]|0)==10){break}else{bI=bO;bP=bP+1|0}}if((bW|0)!=0){c[aK>>2]=1}bI=c[aK>>2]|0;c[aL>>2]=bI+bP;bF=bC;bB=bA;c[aK>>2]=bF-bB+bP+bI;c[aM>>2]=bB;c[aM+4>>2]=bF;c[ad>>2]=bC;break}do{if((y6(y$(c[ad>>2]|0)|0)|0)==0){if((y7(y$(c[ad>>2]|0)|0)|0)!=0){break}if((zS(y$(c[ad>>2]|0)|0)|0)!=0){bF=ub(b)|0;c[p>>2]=bF;bB=c[az>>2]|0;if((bB|0)==(c[aA>>2]|0)){m3(aB,p);bX=c[p>>2]|0}else{if((bB|0)==0){bY=0}else{c[bB>>2]=bF;bY=c[az>>2]|0}c[ay>>2]=bY+4;bX=bF}cB[c[c[aC>>2]>>2]&1023](av,bX);bF=y$(c[ad>>2]|0)|0;bB=(a[bF]|0)==59?bF+1|0:0;if((bB|0)==0){bI=Lu(64)|0;c[a1>>2]=bI;c[a2>>2]=65;c[a3>>2]=52;LF(bI|0,10136,52)|0;a[bI+52|0]=0;c[a4>>2]=0;c[a5>>2]=0;c[a6>>2]=0;z=0;aR(492,b|0,K|0,L|0);if(z){z=0;ac=175;break L33}if((a[a7]&1)==0){break L35}Lw(c[a1>>2]|0);break L35}bI=c[aJ>>2]|0;bO=c[ad>>2]|0;L163:do{if(bO>>>0<bB>>>0){bM=bO;bZ=0;while(1){b_=a[bM]|0;if((b_<<24>>24|0)==10){b$=bZ+1|0}else if((b_<<24>>24|0)==0){b0=bZ;break L163}else{b$=bZ}b_=bM+1|0;if(b_>>>0<bB>>>0){bM=b_;bZ=b$}else{b0=b$;break}}}else{b0=0}}while(0);c[aJ>>2]=b0+bI;bZ=bF;bM=0;while(1){b_=bZ-1|0;if(b_>>>0<bO>>>0){break}if((a[b_]|0)==10){break}else{bZ=b_;bM=bM+1|0}}if((b0|0)!=0){c[aK>>2]=1}bZ=c[aK>>2]|0;c[aL>>2]=bZ+bM;bO=bB;bI=bF;c[aK>>2]=bO-bI+bM+bZ;c[aM>>2]=bI;c[aM+4>>2]=bO;c[ad>>2]=bB;break L35}bO=y$(c[ad>>2]|0)|0;bI=(a[bO]|0)==42?bO+1|0:0;bZ=(bI|0)!=0?bI:bO;do{if((bZ|0)!=0){bO=y1(bZ)|0;if((bO|0)==0){bI=y0(bZ)|0;if((bI|0)==0){break}else{b1=bI}}else{b1=bO}bO=y_(b1)|0;if((bO|0)==0){break}bI=(a[bO]|0)==58?bO+1|0:0;if((bI|0)==0){break}bO=y_(bI)|0;if((bO|0)==0){break}if((bO+1|0)==0|(a[bO]|0)!=123){break}bO=uc(b)|0;c[o>>2]=bO;bI=c[az>>2]|0;if((bI|0)==(c[aA>>2]|0)){m3(aB,o);b2=c[o>>2]|0}else{if((bI|0)==0){b3=0}else{c[bI>>2]=bO;b3=c[az>>2]|0}c[ay>>2]=b3+4;b2=bO}cB[c[c[aC>>2]>>2]&1023](av,b2);break L35}}while(0);if((y9(y$(c[ad>>2]|0)|0)|0)!=0){bZ=ud(b)|0;bB=bZ|0;c[n>>2]=bB;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,n);b4=c[n>>2]|0}else{if((bM|0)==0){b5=0}else{c[bM>>2]=bB;b5=c[az>>2]|0}c[ay>>2]=b5+4;b4=bB}cB[c[c[aC>>2]>>2]&1023](av,b4);if((c[bZ+28>>2]|0)!=0){break L35}bZ=y$(c[ad>>2]|0)|0;bB=(a[bZ]|0)==59?bZ+1|0:0;if((bB|0)==0){bM=Lu(64)|0;c[aW>>2]=bM;c[aX>>2]=65;c[aY>>2]=54;LF(bM|0,8512,54)|0;a[bM+54|0]=0;c[aZ>>2]=0;c[a_>>2]=0;c[a$>>2]=0;z=0;aR(492,b|0,N|0,O|0);if(z){z=0;ac=211;break L33}if((a[a0]&1)==0){break L35}Lw(c[aW>>2]|0);break L35}bM=c[aJ>>2]|0;bF=c[ad>>2]|0;L210:do{if(bF>>>0<bB>>>0){bO=bF;bI=0;while(1){b_=a[bO]|0;if((b_<<24>>24|0)==10){b6=bI+1|0}else if((b_<<24>>24|0)==0){b7=bI;break L210}else{b6=bI}b_=bO+1|0;if(b_>>>0<bB>>>0){bO=b_;bI=b6}else{b7=b6;break}}}else{b7=0}}while(0);c[aJ>>2]=b7+bM;bI=bZ;bO=0;while(1){b_=bI-1|0;if(b_>>>0<bF>>>0){break}if((a[b_]|0)==10){break}else{bI=b_;bO=bO+1|0}}if((b7|0)!=0){c[aK>>2]=1}bI=c[aK>>2]|0;c[aL>>2]=bI+bO;bF=bB;bM=bZ;c[aK>>2]=bF-bM+bO+bI;c[aM>>2]=bM;c[aM+4>>2]=bF;c[ad>>2]=bB;break L35}if((zc(y$(c[ad>>2]|0)|0)|0)!=0){bF=ue(b,0)|0;c[m>>2]=bF;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,m);b8=c[m>>2]|0}else{if((bM|0)==0){b9=0}else{c[bM>>2]=bF;b9=c[az>>2]|0}c[ay>>2]=b9+4;b8=bF}cB[c[c[aC>>2]>>2]&1023](av,b8);break L35}if((ze(y$(c[ad>>2]|0)|0)|0)!=0){bF=uf(b)|0;c[l>>2]=bF;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,l);ca=c[l>>2]|0}else{if((bM|0)==0){cb=0}else{c[bM>>2]=bF;cb=c[az>>2]|0}c[ay>>2]=cb+4;ca=bF}cB[c[c[aC>>2]>>2]&1023](av,ca);break L35}if((zi(y$(c[ad>>2]|0)|0)|0)!=0){bF=ug(b)|0;c[k>>2]=bF;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,k);cc=c[k>>2]|0}else{if((bM|0)==0){cd=0}else{c[bM>>2]=bF;cd=c[az>>2]|0}c[ay>>2]=cd+4;cc=bF}cB[c[c[aC>>2]>>2]&1023](av,cc);break L35}if((zk(y$(c[ad>>2]|0)|0)|0)!=0){bF=uh(b)|0;c[j>>2]=bF;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,j);ce=c[j>>2]|0}else{if((bM|0)==0){cf=0}else{c[bM>>2]=bF;cf=c[az>>2]|0}c[ay>>2]=cf+4;ce=bF}cB[c[c[aC>>2]>>2]&1023](av,ce);break L35}if((y5(y$(c[ad>>2]|0)|0)|0)!=0){bF=ui(b)|0;c[h>>2]=bF;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,h);cg=c[h>>2]|0}else{if((bM|0)==0){ch=0}else{c[bM>>2]=bF;ch=c[az>>2]|0}c[ay>>2]=ch+4;cg=bF}cB[c[c[aC>>2]>>2]&1023](av,cg);break L35}if((zl(y$(c[ad>>2]|0)|0)|0)!=0){bF=uj(b)|0;c[g>>2]=bF;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,g);ci=c[g>>2]|0}else{if((bM|0)==0){cj=0}else{c[bM>>2]=bF;cj=c[az>>2]|0}c[ay>>2]=cj+4;ci=bF}cB[c[c[aC>>2]>>2]&1023](av,ci);bF=y$(c[ad>>2]|0)|0;bM=(a[bF]|0)==59?bF+1|0:0;if((bM|0)==0){bI=Lu(64)|0;c[aN>>2]=bI;c[aO>>2]=65;c[aP>>2]=51;LF(bI|0,6456,51)|0;a[bI+51|0]=0;c[aQ>>2]=0;c[aS>>2]=0;c[aT>>2]=0;z=0;aR(492,b|0,P|0,Q|0);if(z){z=0;ac=268;break L33}if((a[aU]&1)==0){break L35}Lw(c[aN>>2]|0);break L35}bI=c[aJ>>2]|0;b_=c[ad>>2]|0;L289:do{if(b_>>>0<bM>>>0){ck=b_;cl=0;while(1){cm=a[ck]|0;if((cm<<24>>24|0)==10){cn=cl+1|0}else if((cm<<24>>24|0)==0){co=cl;break L289}else{cn=cl}cm=ck+1|0;if(cm>>>0<bM>>>0){ck=cm;cl=cn}else{co=cn;break}}}else{co=0}}while(0);c[aJ>>2]=co+bI;bB=bF;bO=0;while(1){bZ=bB-1|0;if(bZ>>>0<b_>>>0){break}if((a[bZ]|0)==10){break}else{bB=bZ;bO=bO+1|0}}if((co|0)!=0){c[aK>>2]=1}bB=c[aK>>2]|0;c[aL>>2]=bB+bO;b_=bM;bI=bF;c[aK>>2]=b_-bI+bO+bB;c[aM>>2]=bI;c[aM+4>>2]=b_;c[ad>>2]=bM;break L35}if((uk(b)|0)!=0){ul(b)|0;b_=y$(c[ad>>2]|0)|0;bI=(a[b_]|0)==59?b_+1|0:0;if((bI|0)==0){break L35}bB=c[aJ>>2]|0;bZ=c[ad>>2]|0;L307:do{if(bZ>>>0<bI>>>0){cl=bZ;ck=0;while(1){cm=a[cl]|0;if((cm<<24>>24|0)==10){cp=ck+1|0}else if((cm<<24>>24|0)==0){cq=ck;break L307}else{cp=ck}cm=cl+1|0;if(cm>>>0<bI>>>0){cl=cm;ck=cp}else{cq=cp;break}}}else{cq=0}}while(0);c[aJ>>2]=cq+bB;bM=b_;bO=0;while(1){bF=bM-1|0;if(bF>>>0<bZ>>>0){break}if((a[bF]|0)==10){break}else{bM=bF;bO=bO+1|0}}if((cq|0)!=0){c[aK>>2]=1}bM=c[aK>>2]|0;c[aL>>2]=bM+bO;bZ=bI;bB=b_;c[aK>>2]=bZ-bB+bO+bM;c[aM>>2]=bB;c[aM+4>>2]=bZ;c[ad>>2]=bI;break L35}if((y3(y$(c[ad>>2]|0)|0)|0)==0){un(T,b,c[ad>>2]|0);bZ=c[ag>>2]|0;if((bZ|0)==0){up(b)|0;if((c[ad>>2]|0)>>>0>=(c[y>>2]|0)>>>0){ac=322;break L33}bB=Lu(32)|0;c[af>>2]=bB;c[aj>>2]=33;c[ak>>2]=28;LF(bB|0,4088,28)|0;a[bB+28|0]=0;c[al>>2]=0;c[am>>2]=0;c[an>>2]=0;z=0;aR(492,b|0,V|0,W|0);if(z){z=0;ac=316;break L33}if((a[ao]&1)==0){break L35}Lw(c[af>>2]|0);break L35}bB=c[ap>>2]|0;c[aw>>2]=bZ;c[ax>>2]=bB;bB=uo(b,U)|0;c[e>>2]=bB;bZ=c[az>>2]|0;if((bZ|0)==(c[aA>>2]|0)){m3(aB,e);cr=c[e>>2]|0}else{if((bZ|0)==0){cs=0}else{c[bZ>>2]=bB;cs=c[az>>2]|0}c[ay>>2]=cs+4;cr=bB}cB[c[c[aC>>2]>>2]&1023](av,cr);break L35}bB=um(b)|0;bZ=bB|0;c[f>>2]=bZ;bM=c[az>>2]|0;if((bM|0)==(c[aA>>2]|0)){m3(aB,f);ct=c[f>>2]|0}else{if((bM|0)==0){cu=0}else{c[bM>>2]=bZ;cu=c[az>>2]|0}c[ay>>2]=cu+4;ct=bZ}cB[c[c[aC>>2]>>2]&1023](av,ct);if((c[bB+28>>2]|0)!=0){break L35}bB=y$(c[ad>>2]|0)|0;bZ=(a[bB]|0)==59?bB+1|0:0;if((bZ|0)==0){bM=Lu(48)|0;c[at>>2]=bM;c[aD>>2]=49;c[aE>>2]=45;LF(bM|0,5496,45)|0;a[bM+45|0]=0;c[aF>>2]=0;c[aG>>2]=0;c[aH>>2]=0;z=0;aR(492,b|0,R|0,S|0);if(z){z=0;ac=303;break L33}if((a[aI]&1)==0){break L35}Lw(c[at>>2]|0);break L35}bM=c[aJ>>2]|0;bF=c[ad>>2]|0;L351:do{if(bF>>>0<bZ>>>0){ck=bF;cl=0;while(1){cm=a[ck]|0;if((cm<<24>>24|0)==10){cv=cl+1|0}else if((cm<<24>>24|0)==0){cw=cl;break L351}else{cv=cl}cm=ck+1|0;if(cm>>>0<bZ>>>0){ck=cm;cl=cv}else{cw=cv;break}}}else{cw=0}}while(0);c[aJ>>2]=cw+bM;bI=bB;bO=0;while(1){b_=bI-1|0;if(b_>>>0<bF>>>0){break}if((a[b_]|0)==10){break}else{bI=b_;bO=bO+1|0}}if((cw|0)!=0){c[aK>>2]=1}bI=c[aK>>2]|0;c[aL>>2]=bI+bO;bF=bZ;bM=bB;c[aK>>2]=bF-bM+bO+bI;c[aM>>2]=bM;c[aM+4>>2]=bF;c[ad>>2]=bZ;break L35}}while(0);bC=ua(b)|0;c[q>>2]=bC;bP=c[az>>2]|0;if((bP|0)==(c[aA>>2]|0)){m3(aB,q);cx=c[q>>2]|0}else{if((bP|0)==0){cy=0}else{c[bP>>2]=bC;cy=c[az>>2]|0}c[ay>>2]=cy+4;cx=bC}cB[c[c[aC>>2]>>2]&1023](av,cx)}else{bC=c[aM+4>>2]|0;c[B>>2]=c[aM>>2];c[B+4>>2]=bC;bC=t6(b,C)|0;cz=c[X>>2]|0;bP=Lu(32)|0;c[w>>2]=bP;cA=cz+4|0;bA=c[cA>>2]|0;if((bA|0)==(c[cz+8>>2]|0)){e4(cz|0,w);cC=c[w>>2]|0}else{if((bA|0)==0){cD=0}else{c[bA>>2]=bP;cD=c[cA>>2]|0}c[cA>>2]=cD+4;cC=bP}cE=cC;if((a[$]&1)==0){c[bu>>2]=c[$>>2];c[bu+4>>2]=c[$+4>>2];c[bu+8>>2]=c[$+8>>2]}else{bP=c[bp>>2]|0;bA=c[bq>>2]|0;if(bA>>>0>4294967279>>>0){ac=30;break L33}if(bA>>>0<11>>>0){a[bu]=bA<<1;cF=bx}else{bF=bA+16&-16;bM=(z=0,au(248,bF|0)|0);if(z){z=0;ac=55;break L33}c[bw>>2]=bM;c[by>>2]=bF|1;c[bz>>2]=bA;cF=bM}LF(cF|0,bP|0,bA)|0;a[cF+bA|0]=0}c[bv>>2]=c[ae>>2];c[bv+4>>2]=c[ae+4>>2];c[bv+8>>2]=c[ae+8>>2];z=0;aV(32,cC|0,D|0,E|0,bC|0);if(z){z=0;ac=58;break L33}if((a[bu]&1)!=0){Lw(c[bw>>2]|0)}bC=cC;c[v>>2]=bC;bA=c[az>>2]|0;if((bA|0)==(c[aA>>2]|0)){m3(aB,v);cG=c[v>>2]|0}else{if((bA|0)==0){cH=0}else{c[bA>>2]=bC;cH=c[az>>2]|0}c[ay>>2]=cH+4;cG=bC}cB[c[c[aC>>2]>>2]&1023](av,cG)}}while(0);t4(b)|0;if((c[ad>>2]|0)>>>0>=(c[y>>2]|0)>>>0){ac=323;break}}do{if((ac|0)==175){y=bT(-1,-1)|0;ad=y;y=M;if((a[a7]&1)==0){cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}Lw(c[a1>>2]|0);cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else if((ac|0)==145){y=bT(-1,-1)|0;ad=y;y=M;if((a[be]&1)==0){cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}Lw(c[a8>>2]|0);cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else if((ac|0)==211){y=bT(-1,-1)|0;ad=y;y=M;if((a[a0]&1)==0){cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}Lw(c[aW>>2]|0);cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else if((ac|0)==30){z=0;ar(86,0);if(!z){return 0}else{z=0;y=bT(-1,-1)|0;cO=M;cP=y;ac=57;break}}else if((ac|0)==55){y=bT(-1,-1)|0;cO=M;cP=y;ac=57}else if((ac|0)==58){y=bT(-1,-1)|0;ad=y;y=M;if((a[bu]&1)==0){cQ=ad;cR=y;ac=60;break}Lw(c[bw>>2]|0);cQ=ad;cR=y;ac=60}else if((ac|0)==84){z=0;ar(86,0);if(!z){return 0}else{z=0;y=bT(-1,-1)|0;cS=M;cT=y;ac=116;break}}else if((ac|0)==94){z=0;ar(86,0);if(!z){return 0}else{z=0;y=bT(-1,-1)|0;cU=M;cV=y;ac=119;break}}else if((ac|0)==114){y=bT(-1,-1)|0;cS=M;cT=y;ac=116}else if((ac|0)==117){y=bT(-1,-1)|0;cU=M;cV=y;ac=119}else if((ac|0)==120){y=bT(-1,-1)|0;ad=y;y=M;if((a[bi]&1)==0){cW=ad;cX=y;cY=bR;ac=122;break}Lw(c[bl>>2]|0);cW=ad;cX=y;cY=bR;ac=122}else if((ac|0)==268){y=bT(-1,-1)|0;ad=y;y=M;if((a[aU]&1)==0){cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}Lw(c[aN>>2]|0);cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else if((ac|0)==303){y=bT(-1,-1)|0;ad=y;y=M;if((a[aI]&1)==0){cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}Lw(c[at>>2]|0);cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else if((ac|0)==316){y=bT(-1,-1)|0;ad=y;y=M;if((a[ao]&1)==0){cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}Lw(c[af>>2]|0);cI=ad;cJ=y;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else if((ac|0)==322){i=d;return ab|0}else if((ac|0)==323){i=d;return ab|0}}while(0);if((ac|0)==57){cQ=cP;cR=cO;ac=60}else if((ac|0)==116){cZ=cS;c_=cT}else if((ac|0)==119){cW=cV;cX=cU;cY=1;ac=122}do{if((ac|0)==60){af=c[cz>>2]|0;ao=c[cA>>2]|0;at=af;while(1){if((at|0)==(ao|0)){c$=ao;break}if((c[at>>2]|0)==(cC|0)){c$=at;break}else{at=at+4|0}}at=c$-af>>2;aI=af+(at+1<<2)|0;aN=ao-aI|0;LG(af+(at<<2)|0,aI|0,aN|0)|0;aI=af+((aN>>2)+at<<2)|0;at=c[cA>>2]|0;if((aI|0)!=(at|0)){c[cA>>2]=at+(~((at-4+(-aI|0)|0)>>>2)<<2)}Lw(cE);cI=cQ;cJ=cR;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else if((ac|0)==122){if((a[bf]&1)==0){if(cY){cZ=cX;c_=cW;break}else{cI=cW;cJ=cX}cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}else{Lw(c[bk>>2]|0);if(cY){cZ=cX;c_=cW;break}else{cI=cW;cJ=cX}cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}}}while(0);bk=c[bG>>2]|0;bf=c[bH>>2]|0;aI=bk;while(1){if((aI|0)==(bf|0)){c0=bf;break}if((c[aI>>2]|0)==(bJ|0)){c0=aI;break}else{aI=aI+4|0}}aI=c0-bk>>2;at=bk+(aI+1<<2)|0;aN=bf-at|0;LG(bk+(aI<<2)|0,at|0,aN|0)|0;at=bk+((aN>>2)+aI<<2)|0;aI=c[bH>>2]|0;if((at|0)!=(aI|0)){c[bH>>2]=aI+(~((aI-4+(-at|0)|0)>>>2)<<2)}Lw(bL);cI=c_;cJ=cZ;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0)}}while(0);cZ=c[Y>>2]|0;Y=c[_>>2]|0;c_=cZ;while(1){if((c_|0)==(Y|0)){c1=Y;break}if((c[c_>>2]|0)==(aa|0)){c1=c_;break}else{c_=c_+4|0}}c_=c1-cZ>>2;c1=cZ+(c_+1<<2)|0;aa=Y-c1|0;LG(cZ+(c_<<2)|0,c1|0,aa|0)|0;c1=cZ+((aa>>2)+c_<<2)|0;c_=c[_>>2]|0;if((c1|0)!=(c_|0)){c[_>>2]=c_+(~((c_-4+(-c1|0)|0)>>>2)<<2)}Lw(Z);cI=ah;cJ=ai;cK=cI;cL=0;cM=cK;cN=cJ;bg(cM|0);return 0}function t3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0;d=i;i=i+16|0;e=d|0;f=e;g=i;i=i+12|0;i=i+7&-8;h=i;i=i+12|0;i=i+7&-8;LI(f|0,0,12)|0;j=c[b+16>>2]|0;k=a[j]|0;switch(k&255|0){case 221:{do{if((j+4|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[36960]|0)){if((a[j+1|0]|0)!=(a[36961]|0)){l=0;break}if((a[j+2|0]|0)!=(a[36962]|0)){l=0;break}l=(a[j+3|0]|0)==(a[36963]|0)?4:0}else{l=0}}while(0);z=0,aM(542,e|0,1640)|0;if(!z){m=l;n=44}else{z=0;n=5}break};case 239:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[36664]|0)){if((a[j+1|0]|0)!=(a[36665]|0)){o=0;break}o=(a[j+2|0]|0)==(a[36666]|0)?3:0}else{o=0}}while(0);z=0,aM(542,e|0,2232)|0;if(!z){p=o;n=66}else{z=0;n=5}break};case 254:{if((j+2|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[37016]|0)){q=(a[j+1|0]|0)==(a[37017]|0)?2:0}else{q=0}z=0,aM(542,e|0,2152)|0;if(!z){m=q;n=44}else{z=0;n=5}break};case 43:{q=c[b+24>>2]|0;o=j+4|0;do{if(o>>>0>q>>>0){r=0;s=0}else{do{if(k<<24>>24==(a[37128]|0)){if((a[j+1|0]|0)!=(a[37129]|0)){t=0;break}if((a[j+2|0]|0)!=(a[37130]|0)){t=0;break}t=(a[j+3|0]|0)==(a[37131]|0)?4:0}else{t=0}}while(0);do{if(k<<24>>24==(a[37120]|0)){if((a[j+1|0]|0)!=(a[37121]|0)){u=0;break}if((a[j+2|0]|0)!=(a[37122]|0)){u=0;break}u=(a[j+3|0]|0)==(a[37123]|0)?4:0}else{u=0}}while(0);l=u|t;do{if(k<<24>>24==(a[37112]|0)){if((a[j+1|0]|0)!=(a[37113]|0)){v=0;break}if((a[j+2|0]|0)!=(a[37114]|0)){v=0;break}v=(a[j+3|0]|0)==(a[37115]|0)?4:0}else{v=0}}while(0);w=l|v;if(k<<24>>24!=(a[37104]|0)){r=0;s=w;break}if((a[j+1|0]|0)!=(a[37105]|0)){r=0;s=w;break}if((a[j+2|0]|0)!=(a[37106]|0)){r=0;s=w;break}r=(a[j+3|0]|0)==(a[37107]|0)?4:0;s=w}}while(0);v=s|r;do{if((j+5|0)>>>0<=q>>>0&k<<24>>24==(a[37096]|0)){if((a[j+1|0]|0)!=(a[37097]|0)){x=0;break}if((a[j+2|0]|0)!=(a[37098]|0)){x=0;break}if((a[j+3|0]|0)!=(a[37099]|0)){x=0;break}x=(a[o]|0)==(a[37100]|0)?5:0}else{x=0}}while(0);z=0,aM(542,e|0,1800)|0;if(!z){m=v|x;n=44}else{z=0;n=5}break};case 0:{do{if((j+4|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[37e3]|0)){if((a[j+1|0]|0)!=(a[37001]|0)){y=0;break}if((a[j+2|0]|0)!=(a[37002]|0)){y=0;break}y=(a[j+3|0]|0)==(a[37003]|0)?4:0}else{y=0}}while(0);z=0,aM(542,e|0,1848)|0;if(!z){m=y;n=44}else{z=0;n=5}break};case 255:{y=c[b+24>>2]|0;x=j+2|0;do{if(x>>>0<=y>>>0&k<<24>>24==(a[37008]|0)){v=a[j+1|0]|0;if(v<<24>>24!=(a[37009]|0)){A=0;B=0;break}if(!((j+4|0)>>>0<=y>>>0&k<<24>>24==(a[36992]|0))){A=0;B=2;break}if(v<<24>>24!=(a[36993]|0)){A=0;B=2;break}if((a[x]|0)!=(a[36994]|0)){A=0;B=2;break}A=(a[j+3|0]|0)==(a[36995]|0)?4:0;B=2}else{A=0;B=0}}while(0);x=A|B;z=0,aM(542,e|0,((x|0)==2?2016:1928)|0)|0;if(!z){m=x;n=44}else{z=0;n=5}break};case 132:{do{if((j+4|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[37056]|0)){if((a[j+1|0]|0)!=(a[37057]|0)){C=0;break}if((a[j+2|0]|0)!=(a[37058]|0)){C=0;break}C=(a[j+3|0]|0)==(a[37059]|0)?4:0}else{C=0}}while(0);z=0,aM(542,e|0,1440)|0;if(!z){m=C;n=44}else{z=0;n=5}break};case 251:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[37304]|0)){if((a[j+1|0]|0)!=(a[37305]|0)){D=0;break}D=(a[j+2|0]|0)==(a[37306]|0)?3:0}else{D=0}}while(0);z=0,aM(542,e|0,1520)|0;if(!z){m=D;n=44}else{z=0;n=5}break};case 14:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[36720]|0)){if((a[j+1|0]|0)!=(a[36721]|0)){E=0;break}E=(a[j+2|0]|0)==(a[36722]|0)?3:0}else{E=0}}while(0);z=0,aM(542,e|0,1584)|0;if(!z){m=E;n=44}else{z=0;n=5}break};case 247:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[36672]|0)){if((a[j+1|0]|0)!=(a[36673]|0)){F=0;break}F=(a[j+2|0]|0)==(a[36674]|0)?3:0}else{F=0}}while(0);z=0,aM(542,e|0,1720)|0;if(!z){m=F;n=44}else{z=0;n=5}break};default:{p=0;n=66}}L80:do{if((n|0)==5){F=bT(-1,-1)|0;G=M;H=F;n=6}else if((n|0)==44){if((m|0)==0){p=0;n=66;break}F=g;LI(F|0,0,12)|0;j=e;k=a[f]|0;E=k&255;if((E&1|0)==0){I=E>>>1}else{I=c[e+4>>2]|0}E=I+74|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(E>>>0<11>>>0){a[F]=-108;J=g+1|0}else{D=I+90&-16;C=(z=0,au(248,D|0)|0);if(z){z=0;break}c[g+8>>2]=C;c[g>>2]=D|1;c[g+4>>2]=74;J=C}LF(J|0,1272,74)|0;a[J+74|0]=0;if((k&1)==0){K=j+1|0}else{K=c[e+8>>2]|0}z=0,az(88,g|0,K|0,I|0)|0;if(z){z=0;break}c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;z=0;aR(492,b|0,g|0,h|0);if(!z){if((a[F]&1)==0){p=m;n=66;break L80}Lw(c[g+8>>2]|0);p=m;n=66;break L80}else{z=0;C=bT(-1,-1)|0;D=C;C=M;if((a[F]&1)==0){L=C;N=D;break L80}Lw(c[g+8>>2]|0);L=C;N=D;break L80}}}while(0);j=bT(-1,-1)|0;k=M;if((a[F]&1)==0){G=k;H=j;n=6;break}Lw(c[g+8>>2]|0);G=k;H=j;n=6}}while(0);if((n|0)==6){L=G;N=H}else if((n|0)==66){n=b+20|0;c[n>>2]=(c[n>>2]|0)+p;if((a[f]&1)==0){i=d;return}Lw(c[e+8>>2]|0);i=d;return}if((a[f]&1)==0){O=N;P=0;Q=O;R=L;bg(Q|0)}Lw(c[e+8>>2]|0);O=N;P=0;Q=O;R=L;bg(Q|0)}function t4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y_(c[d>>2]|0)|0;f=y_(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}
function c3(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function c4(){return i|0}function c5(a){a=a|0;i=a}function c6(a,b){a=a|0;b=b|0;if((z|0)==0){z=a;A=b}}function c7(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function c8(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function c9(a){a=a|0;M=a}function da(a){a=a|0;N=a}function db(a){a=a|0;O=a}function dc(a){a=a|0;P=a}function dd(a){a=a|0;Q=a}function de(a){a=a|0;R=a}function df(a){a=a|0;S=a}function dg(a){a=a|0;T=a}function dh(a){a=a|0;U=a}function di(a){a=a|0;V=a}function dj(){c[7326]=o+8;c[7328]=o+8;c[7330]=v+8;c[7334]=v+8;c[7338]=v+8;c[7342]=v+8;c[7346]=v+8;c[7350]=v+8;c[7354]=s+8;c[7357]=q;c[7358]=o+8;c[7392]=v+8;c[7396]=v+8;c[7460]=v+8;c[7464]=v+8;c[7484]=o+8;c[7486]=v+8;c[7522]=v+8;c[7526]=v+8;c[7562]=v+8;c[7566]=v+8;c[7586]=o+8;c[7588]=o+8;c[7590]=o+8;c[7592]=v+8;c[7596]=v+8;c[7600]=v+8;c[7604]=v+8;c[7608]=v+8;c[7612]=o+8;c[7614]=o+8;c[7616]=o+8;c[7626]=v+8;c[7630]=o+8;c[7632]=o+8;c[7634]=o+8;c[7636]=o+8;c[7662]=v+8;c[7666]=v+8;c[7670]=o+8;c[7678]=v+8;c[7682]=v+8;c[7686]=v+8;c[7690]=o+8;c[7692]=o+8;c[7694]=o+8;c[7696]=o+8;c[7730]=o+8;c[7732]=o+8;c[7734]=o+8;c[7736]=v+8;c[7740]=v+8;c[7744]=v+8;c[7748]=v+8;c[7752]=v+8;c[7756]=o+8;c[7758]=o+8;c[7760]=o+8;c[7762]=o+8;c[7764]=o+8;c[7766]=o+8;c[7768]=v+8;c[7772]=v+8;c[7784]=v+8;c[7788]=v+8;c[7792]=v+8;c[7796]=o+8;c[7798]=v+8;c[7802]=v+8;c[7806]=v+8;c[7810]=v+8;c[7814]=v+8;c[7818]=v+8;c[7822]=v+8;c[7826]=v+8;c[7830]=v+8;c[7834]=v+8;c[7838]=v+8;c[7842]=v+8;c[7846]=v+8;c[7850]=v+8;c[7854]=v+8;c[7858]=v+8;c[7862]=o+8;c[7864]=v+8;c[7876]=v+8;c[7880]=v+8;c[7892]=v+8;c[7896]=v+8;c[7900]=v+8;c[7904]=v+8;c[7908]=v+8;c[7912]=v+8;c[7916]=v+8;c[7920]=v+8;c[7924]=v+8;c[7928]=v+8;c[7932]=v+8;c[7944]=v+8;c[7948]=v+8;c[7952]=v+8;c[7956]=v+8;c[7960]=v+8;c[7964]=v+8;c[7968]=v+8;c[7972]=v+8;c[7976]=v+8;c[7980]=v+8;c[7984]=v+8;c[7988]=v+8;c[7992]=v+8;c[7996]=v+8;c[8e3]=v+8;c[8004]=v+8;c[8008]=v+8;c[8012]=v+8;c[8032]=v+8;c[8036]=v+8;c[8040]=v+8;c[8052]=v+8;c[8056]=v+8;c[8060]=v+8;c[8064]=o+8;c[8066]=o+8;c[8068]=o+8;c[8070]=o+8;c[8072]=o+8;c[8074]=o+8;c[8076]=o+8;c[8086]=v+8;c[8090]=v+8;c[8094]=v+8;c[8098]=v+8;c[8102]=v+8;c[8106]=v+8;c[8110]=v+8;c[8114]=v+8;c[8118]=v+8;c[8122]=v+8;c[8126]=v+8}function dk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;Bv(f,0);j=f|0;z=0;aR(c[(c[b>>2]|0)+28>>2]|0,g|0,b|0,j|0);do{if(!z){z=0;aR(c[(c[d>>2]|0)+28>>2]|0,h|0,d|0,j|0);if(z){z=0;b=bT(-1,-1)|0;k=b;b=M;if((a[g]&1)==0){l=b;m=k;break}Lw(c[g+8>>2]|0);l=b;m=k;break}k=g;b=a[k]|0;n=b&255;if((n&1|0)==0){o=n>>>1}else{o=c[g+4>>2]|0}n=a[h]|0;p=n&255;if((p&1|0)==0){q=p>>>1}else{q=c[h+4>>2]|0}if((b&1)==0){r=g+1|0}else{r=c[g+8>>2]|0}p=(n&1)==0;if(p){s=h+1|0}else{s=c[h+8>>2]|0}n=LH(r|0,s|0,(q>>>0<o>>>0?q:o)|0)|0;t=(n|0)==0?o>>>0<q>>>0:(n|0)<0;if(p){u=b}else{Lw(c[h+8>>2]|0);u=a[k]|0}if((u&1)==0){Bx(f);i=e;return t|0}Lw(c[g+8>>2]|0);Bx(f);i=e;return t|0}else{z=0;t=bT(-1,-1)|0;l=M;m=t}}while(0);z=0;ar(444,f|0);if(!z){bg(m|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function dl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;Bv(f,0);j=f|0;z=0;aR(c[(c[b>>2]|0)+28>>2]|0,g|0,b|0,j|0);do{if(!z){z=0;aR(c[(c[d>>2]|0)+28>>2]|0,h|0,d|0,j|0);if(z){z=0;b=bT(-1,-1)|0;k=b;b=M;if((a[g]&1)==0){l=b;m=k;break}Lw(c[g+8>>2]|0);l=b;m=k;break}k=g;b=a[k]|0;n=b&255;if((n&1|0)==0){o=n>>>1}else{o=c[g+4>>2]|0}n=a[h]|0;p=n&255;if((p&1|0)==0){q=p>>>1}else{q=c[h+4>>2]|0}if((b&1)==0){r=g+1|0}else{r=c[g+8>>2]|0}p=(n&1)==0;if(p){s=h+1|0}else{s=c[h+8>>2]|0}n=LH(r|0,s|0,(q>>>0<o>>>0?q:o)|0)|0;t=(n|0)==0?o>>>0<q>>>0:(n|0)<0;if(p){u=b}else{Lw(c[h+8>>2]|0);u=a[k]|0}if((u&1)==0){Bx(f);i=e;return t|0}Lw(c[g+8>>2]|0);Bx(f);i=e;return t|0}else{z=0;t=bT(-1,-1)|0;l=M;m=t}}while(0);z=0;ar(444,f|0);if(!z){bg(m|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function dm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=a+36|0;f=c[e>>2]|0;g=(c[a+40>>2]|0)-f>>2;if((g|0)==0|(b|0)==0){h=b;return h|0}else{i=0;j=b;k=f}while(1){f=c[k+(i<<2)>>2]|0;b=cI[c[(c[f>>2]|0)+44>>2]&127](f,j,d)|0;f=i+1|0;if(f>>>0>=g>>>0|(b|0)==0){h=b;break}i=f;j=b;k=c[e>>2]|0}return h|0}function dn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0;f=i;i=i+120|0;g=f|0;h=f+16|0;j=f+24|0;k=f+32|0;l=f+40|0;m=f+48|0;n=f+56|0;o=f+64|0;p=f+72|0;q=f+88|0;r=f+104|0;Bv(o,0);s=d+40|0;t=d+36|0;u=(c[s>>2]|0)-(c[t>>2]|0)>>2;v=b|0;w=b;x=o|0;y=p;A=q;B=p+1|0;C=q+1|0;D=q+8|0;E=p+8|0;F=q+4|0;G=p+4|0;H=0;while(1){if(H>>>0>=u>>>0){I=25;break}z=0;aR(c[(c[w>>2]|0)+28>>2]|0,p|0,v|0,x|0);if(z){z=0;I=20;break}J=c[(c[t>>2]|0)+(H<<2)>>2]|0;z=0;aR(c[(c[J>>2]|0)+28>>2]|0,q|0,J|0,x|0);if(z){z=0;I=23;break}J=a[y]|0;K=J&255;L=(K&1|0)==0?K>>>1:c[G>>2]|0;K=a[A]|0;N=K&255;L6:do{if((L|0)==(((N&1|0)==0?N>>>1:c[F>>2]|0)|0)){O=(J&1)==0;P=O?B:c[E>>2]|0;Q=K&1;R=Q<<24>>24==0?C:c[D>>2]|0;if(!O){S=(LH(P|0,R|0,L|0)|0)==0;T=Q;break}if((L|0)==0){S=1;T=Q;break}else{U=R;V=P;W=L}while(1){if((a[V]|0)!=(a[U]|0)){S=0;T=Q;break L6}P=W-1|0;if((P|0)==0){S=1;T=Q;break}else{U=U+1|0;V=V+1|0;W=P}}}else{S=0;T=K&1}}while(0);if(T<<24>>24==0){X=J}else{Lw(c[D>>2]|0);X=a[y]|0}if((X&1)!=0){Lw(c[E>>2]|0)}if(S){Y=d;I=126;break}else{H=H+1|0}}L22:do{if((I|0)==20){H=bT(-1,-1)|0;Z=M;_=H;I=22}else if((I|0)==23){H=bT(-1,-1)|0;S=H;H=M;if((a[y]&1)==0){$=H;aa=S;break}Lw(c[E>>2]|0);$=H;aa=S}else if((I|0)==25){L27:do{if((b|0)==0){z=0;aS(10);if(z){z=0;break}return 0}else{S=c[(c[(c[b>>2]|0)-4>>2]|0)+4>>2]|0;H=c[t>>2]|0;X=(c[s>>2]|0)-H>>2;L31:do{if((S|0)==27792|(S|0)==27632){if((X|0)==0){I=44;break}D=X-1|0;T=0;W=H;while(1){V=c[W+(T<<2)>>2]|0;if((V|0)==0){break}U=c[(c[(c[V>>2]|0)-4>>2]|0)+4>>2]|0;if((U|0)==27792|(U|0)==27632){U=c[W+(D<<2)>>2]|0;V=(z=0,au(c[(c[U>>2]|0)+48>>2]|0,U|0)|0);if(z){z=0;I=19;break}if(V){ab=T;break L31}}V=T+1|0;if(V>>>0>=X>>>0){I=44;break L31}T=V;W=c[t>>2]|0}if((I|0)==19){W=bT(-1,-1)|0;Z=M;_=W;I=22;break L22}z=0;aS(10);if(z){z=0;break L27}return 0}else{W=0;while(1){if(W>>>0>=X>>>0){I=44;break L31}T=c[H+(W<<2)>>2]|0;if((T|0)==0){break}D=c[(c[(c[T>>2]|0)-4>>2]|0)+4>>2]|0;if((D|0)==27792|(D|0)==27632){ab=W;break L31}else{W=W+1|0}}z=0;aS(10);if(z){z=0;break L27}return 0}}while(0);if((I|0)==44){H=(z=0,au(248,60)|0);if(z){z=0;break}S=H;c[k>>2]=S;H=e+4|0;W=c[H>>2]|0;if((W|0)==(c[e+8>>2]|0)){z=0;as(382,e|0,k|0);if(z){z=0;break}ac=c[k>>2]|0}else{if((W|0)==0){ad=0}else{c[W>>2]=S;ad=c[H>>2]|0}c[H>>2]=ad+4;ac=S}S=ac;W=ac;z=0;as(326,W|0,d|0);if(z){z=0;D=bT(-1,-1)|0;T=D;D=M;V=c[e>>2]|0;U=c[H>>2]|0;C=V;while(1){if((C|0)==(U|0)){ae=U;break}if((c[C>>2]|0)==(ac|0)){ae=C;break}else{C=C+4|0}}C=ae-V>>2;B=V+(C+1<<2)|0;F=U-B|0;LG(V+(C<<2)|0,B|0,F|0)|0;B=V+((F>>2)+C<<2)|0;C=c[H>>2]|0;if((B|0)!=(C|0)){c[H>>2]=C+(~((C-4+(-B|0)|0)>>>2)<<2)}Lw(S);$=D;aa=T;break L22}B=ac+32|0;C=B;c[j>>2]=b;F=ac+40|0;A=c[F>>2]|0;G=A;if((G|0)==(c[B+12>>2]|0)){z=0;as(740,ac+36|0,j|0);if(z){z=0;break}af=c[j>>2]|0}else{if((A|0)==0){ag=0}else{c[G>>2]=b;ag=c[F>>2]|0}c[F>>2]=ag+4;af=b}z=0;as(c[c[B>>2]>>2]|0,C|0,af|0);if(!z){Y=W}else{z=0;break}Bx(o);i=f;return Y|0}C=(z=0,au(248,60)|0);if(z){z=0;break}B=C;c[h>>2]=B;C=e+4|0;F=c[C>>2]|0;if((F|0)==(c[e+8>>2]|0)){z=0;as(382,e|0,h|0);if(z){z=0;break}ah=c[h>>2]|0}else{if((F|0)==0){ai=0}else{c[F>>2]=B;ai=c[C>>2]|0}c[C>>2]=ai+4;ah=B}B=ah;F=ah;G=d+4|0;L92:do{if((a[G]&1)==0){A=r;c[A>>2]=c[G>>2];c[A+4>>2]=c[G+4>>2];c[A+8>>2]=c[G+8>>2];I=82}else{A=c[d+12>>2]|0;x=c[d+8>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[r]=x<<1;aj=r+1|0}else{q=x+16&-16;v=(z=0,au(248,q|0)|0);if(z){z=0;break}c[r+8>>2]=v;c[r>>2]=q|1;c[r+4>>2]=x;aj=v}LF(aj|0,A|0,x)|0;a[aj+x|0]=0;I=82;break L92}}while(0);x=bT(-1,-1)|0;ak=M;al=x}}while(0);do{if((I|0)==82){G=d+16|0;W=g;c[W>>2]=c[G>>2];c[W+4>>2]=c[G+4>>2];c[W+8>>2]=c[G+8>>2];z=0;aV(42,F|0,r|0,g|0,0);if(z){z=0;G=bT(-1,-1)|0;W=G;G=M;if((a[r]&1)==0){ak=G;al=W;break}Lw(c[r+8>>2]|0);ak=G;al=W;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}W=ah+32|0;G=W;L114:do{if((ab|0)==0){am=ah+40|0;an=W+12|0}else{T=ah+40|0;D=W+12|0;S=ah+36|0;H=W;V=0;while(1){U=c[(c[t>>2]|0)+(V<<2)>>2]|0;c[l>>2]=U;x=c[T>>2]|0;A=x;if((A|0)==(c[D>>2]|0)){z=0;as(740,S|0,l|0);if(z){z=0;break}ao=c[l>>2]|0}else{if((x|0)==0){ap=0}else{c[A>>2]=U;ap=c[T>>2]|0}c[T>>2]=ap+4;ao=U}z=0;as(c[c[H>>2]>>2]|0,G|0,ao|0);if(z){z=0;break}U=V+1|0;if(U>>>0<ab>>>0){V=U}else{am=T;an=D;break L114}}D=bT(-1,-1)|0;Z=M;_=D;I=22;break L22}}while(0);c[m>>2]=b;D=c[am>>2]|0;T=D;if((T|0)==(c[an>>2]|0)){z=0;as(740,ah+36|0,m|0);if(z){z=0;break L27}aq=c[m>>2]|0}else{if((D|0)==0){at=0}else{c[T>>2]=b;at=c[am>>2]|0}c[am>>2]=at+4;aq=b}T=W;z=0;as(c[c[T>>2]>>2]|0,G|0,aq|0);if(z){z=0;break L27}if(ab>>>0>=X>>>0){Y=F;Bx(o);i=f;return Y|0}D=ah+36|0;V=ab;while(1){H=c[(c[t>>2]|0)+(V<<2)>>2]|0;c[n>>2]=H;S=c[am>>2]|0;U=S;if((U|0)==(c[an>>2]|0)){z=0;as(740,D|0,n|0);if(z){z=0;I=17;break}av=c[n>>2]|0}else{if((S|0)==0){aw=0}else{c[U>>2]=H;aw=c[am>>2]|0}c[am>>2]=aw+4;av=H}z=0;as(c[c[T>>2]>>2]|0,G|0,av|0);if(z){z=0;I=17;break}H=V+1|0;if(H>>>0<X>>>0){V=H}else{Y=F;I=129;break}}if((I|0)==17){V=bT(-1,-1)|0;Z=M;_=V;I=22;break L22}else if((I|0)==129){Bx(o);i=f;return Y|0}}}while(0);F=c[e>>2]|0;X=c[C>>2]|0;V=F;while(1){if((V|0)==(X|0)){ax=X;break}if((c[V>>2]|0)==(ah|0)){ax=V;break}else{V=V+4|0}}V=ax-F>>2;G=F+(V+1<<2)|0;T=X-G|0;LG(F+(V<<2)|0,G|0,T|0)|0;G=F+((T>>2)+V<<2)|0;V=c[C>>2]|0;if((G|0)!=(V|0)){c[C>>2]=V+(~((V-4+(-G|0)|0)>>>2)<<2)}Lw(B);$=ak;aa=al;break L22}}while(0);J=bT(-1,-1)|0;Z=M;_=J;I=22}else if((I|0)==126){Bx(o);i=f;return Y|0}}while(0);if((I|0)==22){$=Z;aa=_}z=0;ar(444,o|0);if(!z){bg(aa|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function dp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0;f=i;i=i+192|0;g=f|0;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=f+56|0;o=f+64|0;p=f+80|0;q=f+88|0;r=f+96|0;s=f+112|0;t=f+128|0;u=f+144|0;v=f+160|0;w=f+176|0;x=b+32|0;if((a[x]&1)==0){y=r;c[y>>2]=c[x>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];A=a[y]|0;B=y}else{y=c[b+40>>2]|0;C=c[b+36>>2]|0;if(C>>>0>4294967279>>>0){D5(0);return 0}if(C>>>0<11>>>0){D=C<<1&255;E=r;a[E]=D;F=r+1|0;G=D;H=E}else{E=C+16&-16;D=Lu(E)|0;c[r+8>>2]=D;I=E|1;c[r>>2]=I;c[r+4>>2]=C;F=D;G=I&255;H=r}LF(F|0,y|0,C)|0;a[F+C|0]=0;A=G;B=H}H=A&255;if((H&1|0)==0){J=H>>>1}else{J=c[r+4>>2]|0}if((A&1)==0){K=r+1|0}else{K=c[r+8>>2]|0}A=J>>>0>1>>>0;H=LH(K|0,13336,(A?1:J)|0)|0;if((H|0)==0){L=(J|0)==0?-1:A&1}else{L=H}if((a[B]&1)!=0){Lw(c[r+8>>2]|0)}if((L|0)==0){L=Lu(60)|0;c[q>>2]=L;r=e+4|0;B=c[r>>2]|0;if((B|0)==(c[e+8>>2]|0)){e4(e|0,q);N=c[q>>2]|0}else{if((B|0)==0){O=0}else{c[B>>2]=L;O=c[r>>2]|0}c[r>>2]=O+4;N=L}L=N;O=N;z=0;as(326,O|0,d|0);if(!z){P=O;i=f;return P|0}else{z=0}O=bT(-1,-1)|0;B=O;O=M;q=c[e>>2]|0;H=c[r>>2]|0;A=q;while(1){if((A|0)==(H|0)){Q=H;break}if((c[A>>2]|0)==(N|0)){Q=A;break}else{A=A+4|0}}A=Q-q>>2;Q=q+(A+1<<2)|0;N=H-Q|0;LG(q+(A<<2)|0,Q|0,N|0)|0;Q=q+((N>>2)+A<<2)|0;A=c[r>>2]|0;if((Q|0)!=(A|0)){c[r>>2]=A+(~((A-4+(-Q|0)|0)>>>2)<<2)}Lw(L);R=O;S=B;T=S;U=0;V=T;W=R;bg(V|0)}B=d+32|0;O=d+36|0;L=c[c[O>>2]>>2]|0;if((L|0)==0){cj();return 0}if((c[(c[(c[L>>2]|0)-4>>2]|0)+4>>2]|0)!=28336){Q=Lu(60)|0;c[k>>2]=Q;A=e+4|0;r=c[A>>2]|0;if((r|0)==(c[e+8>>2]|0)){e4(e|0,k);X=c[k>>2]|0}else{if((r|0)==0){Y=0}else{c[r>>2]=Q;Y=c[A>>2]|0}c[A>>2]=Y+4;X=Q}Q=X;Y=X;r=d+4|0;L59:do{if((a[r]&1)==0){k=w;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];Z=166}else{k=c[d+12>>2]|0;N=c[d+8>>2]|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[w]=N<<1;_=w+1|0}else{q=N+16&-16;H=(z=0,au(248,q|0)|0);if(z){z=0;break}c[w+8>>2]=H;c[w>>2]=q|1;c[w+4>>2]=N;_=H}LF(_|0,k|0,N)|0;a[_+N|0]=0;Z=166;break L59}}while(0);N=bT(-1,-1)|0;$=M;aa=N}}while(0);do{if((Z|0)==166){_=d+16|0;r=j;c[r>>2]=c[_>>2];c[r+4>>2]=c[_+4>>2];c[r+8>>2]=c[_+8>>2];z=0;aV(42,Y|0,w|0,j|0,0);if(z){z=0;_=bT(-1,-1)|0;r=_;_=M;if((a[w]&1)==0){$=_;aa=r;break}Lw(c[w+8>>2]|0);$=_;aa=r;break}if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}r=X+32|0;_=r;N=b|0;c[h>>2]=N;k=X+40|0;H=c[k>>2]|0;q=H;J=r+12|0;if((q|0)==(c[J>>2]|0)){e3(X+36|0,h);ab=c[h>>2]|0}else{if((H|0)==0){ac=0}else{c[q>>2]=N;ac=c[k>>2]|0}c[k>>2]=ac+4;ab=N}N=r;cB[c[c[N>>2]>>2]&1023](_,ab);r=(d|0)==0?0:B;q=r+4|0;H=c[q>>2]|0;K=(c[r+8>>2]|0)-H>>2;if((K|0)==0){P=Y;i=f;return P|0}r=X+36|0;G=0;C=H;while(1){H=c[C+(G<<2)>>2]|0;c[g>>2]=H;F=c[k>>2]|0;y=F;if((y|0)==(c[J>>2]|0)){e3(r,g);ad=c[g>>2]|0}else{if((F|0)==0){ae=0}else{c[y>>2]=H;ae=c[k>>2]|0}c[k>>2]=ae+4;ad=H}cB[c[c[N>>2]>>2]&1023](_,ad);H=G+1|0;if(H>>>0>=K>>>0){P=Y;break}G=H;C=c[q>>2]|0}i=f;return P|0}}while(0);Y=c[e>>2]|0;ad=c[A>>2]|0;ae=Y;while(1){if((ae|0)==(ad|0)){af=ad;break}if((c[ae>>2]|0)==(X|0)){af=ae;break}else{ae=ae+4|0}}ae=af-Y>>2;af=Y+(ae+1<<2)|0;X=ad-af|0;LG(Y+(ae<<2)|0,af|0,X|0)|0;af=Y+((X>>2)+ae<<2)|0;ae=c[A>>2]|0;if((af|0)!=(ae|0)){c[A>>2]=ae+(~((ae-4+(-af|0)|0)>>>2)<<2)}Lw(Q);R=$;S=aa;T=S;U=0;V=T;W=R;bg(V|0)}aa=L+32|0;if((a[aa]&1)==0){$=s;c[$>>2]=c[aa>>2];c[$+4>>2]=c[aa+4>>2];c[$+8>>2]=c[aa+8>>2];ag=a[$]|0;ah=$}else{$=c[L+40>>2]|0;Q=c[L+36>>2]|0;if(Q>>>0>4294967279>>>0){D5(0);return 0}if(Q>>>0<11>>>0){af=Q<<1&255;ae=s;a[ae]=af;ai=s+1|0;aj=af;ak=ae}else{ae=Q+16&-16;af=Lu(ae)|0;c[s+8>>2]=af;A=ae|1;c[s>>2]=A;c[s+4>>2]=Q;ai=af;aj=A&255;ak=s}LF(ai|0,$|0,Q)|0;a[ai+Q|0]=0;ag=aj;ah=ak}ak=ag&255;if((ak&1|0)==0){al=ak>>>1}else{al=c[s+4>>2]|0}if((ag&1)==0){am=s+1|0}else{am=c[s+8>>2]|0}ag=al>>>0>1>>>0;ak=LH(am|0,13336,(ag?1:al)|0)|0;if((ak|0)==0){an=(al|0)==0?-1:ag&1}else{an=ak}if((a[ah]&1)!=0){Lw(c[s+8>>2]|0)}if((an|0)==0){an=Lu(60)|0;c[p>>2]=an;s=e+4|0;ah=c[s>>2]|0;if((ah|0)==(c[e+8>>2]|0)){e4(e|0,p);ao=c[p>>2]|0}else{if((ah|0)==0){ap=0}else{c[ah>>2]=an;ap=c[s>>2]|0}c[s>>2]=ap+4;ao=an}an=ao;ap=ao;ah=d+4|0;L146:do{if((a[ah]&1)==0){p=t;c[p>>2]=c[ah>>2];c[p+4>>2]=c[ah+4>>2];c[p+8>>2]=c[ah+8>>2];Z=69}else{p=c[d+12>>2]|0;ak=c[d+8>>2]|0;do{if(ak>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ak>>>0<11>>>0){a[t]=ak<<1;aq=t+1|0}else{ag=ak+16&-16;al=(z=0,au(248,ag|0)|0);if(z){z=0;break}c[t+8>>2]=al;c[t>>2]=ag|1;c[t+4>>2]=ak;aq=al}LF(aq|0,p|0,ak)|0;a[aq+ak|0]=0;Z=69;break L146}}while(0);ak=bT(-1,-1)|0;at=M;av=ak}}while(0);do{if((Z|0)==69){aq=d+16|0;ah=o;c[ah>>2]=c[aq>>2];c[ah+4>>2]=c[aq+4>>2];c[ah+8>>2]=c[aq+8>>2];z=0;aV(42,ap|0,t|0,o|0,0);if(z){z=0;aq=bT(-1,-1)|0;ah=aq;aq=M;if((a[t]&1)==0){at=aq;av=ah;break}Lw(c[t+8>>2]|0);at=aq;av=ah;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}ah=ao+32|0;aq=ah;ak=b|0;c[n>>2]=ak;p=ao+40|0;al=c[p>>2]|0;ag=al;am=ah+12|0;if((ag|0)==(c[am>>2]|0)){e3(ao+36|0,n);aw=c[n>>2]|0}else{if((al|0)==0){ax=0}else{c[ag>>2]=ak;ax=c[p>>2]|0}c[p>>2]=ax+4;aw=ak}ak=ah;cB[c[c[ak>>2]>>2]&1023](aq,aw);ah=c[O>>2]|0;ag=(c[d+40>>2]|0)-ah>>2;if(ag>>>0<=1>>>0){P=ap;i=f;return P|0}al=ao+36|0;aj=1;Q=ah;while(1){ah=c[Q+(aj<<2)>>2]|0;c[m>>2]=ah;ai=c[p>>2]|0;$=ai;if(($|0)==(c[am>>2]|0)){e3(al,m);ay=c[m>>2]|0}else{if((ai|0)==0){az=0}else{c[$>>2]=ah;az=c[p>>2]|0}c[p>>2]=az+4;ay=ah}cB[c[c[ak>>2]>>2]&1023](aq,ay);ah=aj+1|0;if(ah>>>0>=ag>>>0){P=ap;break}aj=ah;Q=c[O>>2]|0}i=f;return P|0}}while(0);O=c[e>>2]|0;ap=c[s>>2]|0;ay=O;while(1){if((ay|0)==(ap|0)){aA=ap;break}if((c[ay>>2]|0)==(ao|0)){aA=ay;break}else{ay=ay+4|0}}ay=aA-O>>2;aA=O+(ay+1<<2)|0;ao=ap-aA|0;LG(O+(ay<<2)|0,aA|0,ao|0)|0;aA=O+((ao>>2)+ay<<2)|0;ay=c[s>>2]|0;if((aA|0)!=(ay|0)){c[s>>2]=ay+(~((ay-4+(-aA|0)|0)>>>2)<<2)}Lw(an);R=at;S=av;T=S;U=0;V=T;W=R;bg(V|0)}if((a[aa]&1)==0){av=u;c[av>>2]=c[aa>>2];c[av+4>>2]=c[aa+4>>2];c[av+8>>2]=c[aa+8>>2]}else{aa=c[L+40>>2]|0;av=c[L+36>>2]|0;if(av>>>0>4294967279>>>0){D5(0);return 0}if(av>>>0<11>>>0){a[u]=av<<1;aB=u+1|0}else{L=av+16&-16;at=Lu(L)|0;c[u+8>>2]=at;c[u>>2]=L|1;c[u+4>>2]=av;aB=at}LF(aB|0,aa|0,av)|0;a[aB+av|0]=0}L210:do{if((a[x]&1)==0){av=v;c[av>>2]=c[x>>2];c[av+4>>2]=c[x+4>>2];c[av+8>>2]=c[x+8>>2]}else{av=c[b+40>>2]|0;aB=c[b+36>>2]|0;do{if(aB>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aB>>>0<11>>>0){a[v]=aB<<1;aC=v+1|0}else{aa=aB+16&-16;at=(z=0,au(248,aa|0)|0);if(z){z=0;break}c[v+8>>2]=at;c[v>>2]=aa|1;c[v+4>>2]=aB;aC=at}LF(aC|0,av|0,aB)|0;a[aC+aB|0]=0;break L210}}while(0);aB=bT(-1,-1)|0;av=aB;aB=M;if((a[u]&1)==0){R=aB;S=av;T=S;U=0;V=T;W=R;bg(V|0)}Lw(c[u+8>>2]|0);R=aB;S=av;T=S;U=0;V=T;W=R;bg(V|0)}}while(0);aC=u;b=a[u]|0;x=b&255;if((x&1|0)==0){aD=x>>>1}else{aD=c[u+4>>2]|0}x=v;av=a[v]|0;aB=av&255;if((aB&1|0)==0){aE=aB>>>1}else{aE=c[v+4>>2]|0}L236:do{if((aD|0)==(aE|0)){aB=(b&1)==0;if(aB){aF=aC+1|0}else{aF=c[u+8>>2]|0}at=av&1;if(at<<24>>24==0){aG=x+1|0}else{aG=c[v+8>>2]|0}if(!aB){aH=(LH(aF|0,aG|0,aD|0)|0)==0;aI=at;break}if((aD|0)==0){aH=1;aI=at;break}else{aJ=aG;aK=aF;aL=aD}while(1){if((a[aK]|0)!=(a[aJ]|0)){aH=0;aI=at;break L236}aB=aL-1|0;if((aB|0)==0){aH=1;aI=at;break}else{aJ=aJ+1|0;aK=aK+1|0;aL=aB}}}else{aH=0;aI=av&1}}while(0);if(aI<<24>>24!=0){Lw(c[v+8>>2]|0)}if((b&1)!=0){Lw(c[u+8>>2]|0)}if(!aH){P=0;i=f;return P|0}aH=Lu(60)|0;c[l>>2]=aH;u=e+4|0;b=c[u>>2]|0;if((b|0)==(c[e+8>>2]|0)){e4(e|0,l);aM=c[l>>2]|0}else{if((b|0)==0){aN=0}else{c[b>>2]=aH;aN=c[u>>2]|0}c[u>>2]=aN+4;aM=aH}aH=aM;aN=aM;z=0;as(326,aN|0,d|0);if(!z){P=aN;i=f;return P|0}else{z=0}P=bT(-1,-1)|0;f=P;P=M;aN=c[e>>2]|0;e=c[u>>2]|0;d=aN;while(1){if((d|0)==(e|0)){aO=e;break}if((c[d>>2]|0)==(aM|0)){aO=d;break}else{d=d+4|0}}d=aO-aN>>2;aO=aN+(d+1<<2)|0;aM=e-aO|0;LG(aN+(d<<2)|0,aO|0,aM|0)|0;aO=aN+((aM>>2)+d<<2)|0;d=c[u>>2]|0;if((aO|0)!=(d|0)){c[u>>2]=d+(~((d-4+(-aO|0)|0)>>>2)<<2)}Lw(aH);R=P;S=f;T=S;U=0;V=T;W=R;bg(V|0);return 0}function dq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;f=i;i=i+64|0;g=f|0;h=f+16|0;j=f+32|0;k=f+48|0;l=b+32|0;if((a[l]&1)==0){m=g;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=a[m]|0;o=m}else{m=c[b+40>>2]|0;p=c[b+36>>2]|0;if(p>>>0>4294967279>>>0){D5(0);return 0}if(p>>>0<11>>>0){q=p<<1&255;r=g;a[r]=q;s=g+1|0;t=q;u=r}else{r=p+16&-16;q=Lu(r)|0;c[g+8>>2]=q;v=r|1;c[g>>2]=v;c[g+4>>2]=p;s=q;t=v&255;u=g}LF(s|0,m|0,p)|0;a[s+p|0]=0;n=t;o=u}if((n&1)==0){w=g+1|0}else{w=c[g+8>>2]|0}n=(a[w]|0)==35;if((a[o]&1)!=0){Lw(c[g+8>>2]|0)}L19:do{if(n){g=d+36|0;o=c[g>>2]|0;w=(c[d+40>>2]|0)-o>>2;if((w|0)==0){break}u=h;t=h+1|0;p=j;s=k;m=j+1|0;v=k+1|0;q=k+8|0;r=j+8|0;x=k+4|0;y=j+4|0;A=b+40|0;B=b+36|0;C=k|0;D=j|0;E=h+8|0;F=h|0;G=h+4|0;H=0;I=o;L22:while(1){o=c[I+(H<<2)>>2]|0;if((o|0)==0){J=18;break}do{if((c[(c[(c[o>>2]|0)-4>>2]|0)+4>>2]|0)==27440){K=o+32|0;if((a[K]&1)==0){c[u>>2]=c[K>>2];c[u+4>>2]=c[K+4>>2];c[u+8>>2]=c[K+8>>2];L=a[u]|0}else{N=c[o+40>>2]|0;O=c[o+36>>2]|0;if(O>>>0>4294967279>>>0){J=23;break L22}if(O>>>0<11>>>0){P=O<<1&255;a[u]=P;Q=t;R=P}else{P=O+16&-16;S=Lu(P)|0;c[E>>2]=S;T=P|1;c[F>>2]=T;c[G>>2]=O;Q=S;R=T&255}LF(Q|0,N|0,O)|0;a[Q+O|0]=0;L=R}do{if((a[(L&1)==0?t:c[E>>2]|0]|0)==35){if((a[K]&1)==0){c[p>>2]=c[K>>2];c[p+4>>2]=c[K+4>>2];c[p+8>>2]=c[K+8>>2]}else{O=c[o+40>>2]|0;N=c[o+36>>2]|0;if(N>>>0>4294967279>>>0){J=32;break L22}if(N>>>0<11>>>0){a[p]=N<<1;U=m}else{T=N+16&-16;S=(z=0,au(248,T|0)|0);if(z){z=0;J=63;break L22}c[r>>2]=S;c[D>>2]=T|1;c[y>>2]=N;U=S}LF(U|0,O|0,N)|0;a[U+N|0]=0}if((a[l]&1)==0){c[s>>2]=c[l>>2];c[s+4>>2]=c[l+4>>2];c[s+8>>2]=c[l+8>>2]}else{N=c[A>>2]|0;O=c[B>>2]|0;if(O>>>0>4294967279>>>0){J=42;break L22}if(O>>>0<11>>>0){a[s]=O<<1;V=v}else{S=O+16&-16;T=(z=0,au(248,S|0)|0);if(z){z=0;J=66;break L22}c[q>>2]=T;c[C>>2]=S|1;c[x>>2]=O;V=T}LF(V|0,N|0,O)|0;a[V+O|0]=0}O=a[p]|0;N=O&255;T=(N&1|0)==0?N>>>1:c[y>>2]|0;N=a[s]|0;S=N&255;L58:do{if((T|0)==(((S&1|0)==0?S>>>1:c[x>>2]|0)|0)){P=(O&1)==0;W=P?m:c[r>>2]|0;X=N&1;Y=X<<24>>24==0?v:c[q>>2]|0;if(!P){Z=(LH(W|0,Y|0,T|0)|0)!=0;_=X;break}if((T|0)==0){Z=0;_=X;break}else{$=Y;aa=W;ab=T}while(1){if((a[aa]|0)!=(a[$]|0)){Z=1;_=X;break L58}W=ab-1|0;if((W|0)==0){Z=0;_=X;break}else{$=$+1|0;aa=aa+1|0;ab=W}}}else{Z=1;_=N&1}}while(0);if(_<<24>>24!=0){Lw(c[q>>2]|0)}if((O&1)==0){ac=Z;break}Lw(c[r>>2]|0);ac=Z}else{ac=0}}while(0);if((L&1)==0){if(ac){ad=0;J=77;break L22}else{break}}else{Lw(c[E>>2]|0);if(ac){ad=0;J=79;break L22}else{break}}}}while(0);o=H+1|0;if(o>>>0>=w>>>0){break L19}H=o;I=c[g>>2]|0}do{if((J|0)==77){i=f;return ad|0}else if((J|0)==79){i=f;return ad|0}else if((J|0)==63){g=bT(-1,-1)|0;ae=M;af=g;J=65}else if((J|0)==66){g=bT(-1,-1)|0;ag=M;ah=g;J=68}else if((J|0)==23){D5(0);return 0}else if((J|0)==42){z=0;ar(86,0);if(!z){return 0}else{z=0;g=bT(-1,-1)|0;ag=M;ah=g;J=68;break}}else if((J|0)==18){cj();return 0}else if((J|0)==32){z=0;ar(86,0);if(!z){return 0}else{z=0;g=bT(-1,-1)|0;ae=M;af=g;J=65;break}}}while(0);do{if((J|0)==65){ai=ae;aj=af}else if((J|0)==68){g=ah;I=ag;if((a[p]&1)==0){ai=I;aj=g;break}Lw(c[r>>2]|0);ai=I;aj=g}}while(0);if((L&1)==0){ak=aj;al=0;am=ak;an=ai;bg(am|0)}Lw(c[E>>2]|0);ak=aj;al=0;am=ak;an=ai;bg(am|0)}}while(0);ad=dn(b|0,d,e)|0;i=f;return ad|0}function dr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+32|0;g=f|0;h=f+16|0;L1:do{if(cD[c[(c[b>>2]|0)+48>>2]&511](b)|0){j=d+36|0;k=c[j>>2]|0;l=(c[d+40>>2]|0)-k>>2;if((l|0)==0){break}m=g;n=b+32|0;o=h;p=g+1|0;q=h+1|0;r=h+8|0;s=g+8|0;t=h+4|0;u=g+4|0;v=b+40|0;w=b+36|0;x=h|0;y=g|0;A=0;B=k;L4:while(1){k=c[B+(A<<2)>>2]|0;if((k|0)==0){C=5;break}D=c[k>>2]|0;do{if((c[(c[D-4>>2]|0)+4>>2]|0)==27792){if(!(cD[c[D+48>>2]&511](k)|0)){break}E=k+32|0;if((a[E]&1)==0){c[m>>2]=c[E>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2]}else{E=c[k+40>>2]|0;F=c[k+36>>2]|0;if(F>>>0>4294967279>>>0){C=11;break L4}if(F>>>0<11>>>0){a[m]=F<<1;G=p}else{H=F+16&-16;I=Lu(H)|0;c[s>>2]=I;c[y>>2]=H|1;c[u>>2]=F;G=I}LF(G|0,E|0,F)|0;a[G+F|0]=0}if((a[n]&1)==0){c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{F=c[v>>2]|0;E=c[w>>2]|0;if(E>>>0>4294967279>>>0){C=19;break L4}if(E>>>0<11>>>0){a[o]=E<<1;J=q}else{I=E+16&-16;H=(z=0,au(248,I|0)|0);if(z){z=0;C=38;break L4}c[r>>2]=H;c[x>>2]=I|1;c[t>>2]=E;J=H}LF(J|0,F|0,E)|0;a[J+E|0]=0}E=a[m]|0;F=E&255;H=(F&1|0)==0?F>>>1:c[u>>2]|0;F=a[o]|0;I=F&255;L29:do{if((H|0)==(((I&1|0)==0?I>>>1:c[t>>2]|0)|0)){K=(E&1)==0;L=K?p:c[s>>2]|0;N=F&1;O=N<<24>>24==0?q:c[r>>2]|0;if(!K){P=(LH(L|0,O|0,H|0)|0)!=0;Q=N;break}if((H|0)==0){P=0;Q=N;break}else{R=O;S=L;T=H}while(1){if((a[S]|0)!=(a[R]|0)){P=1;Q=N;break L29}L=T-1|0;if((L|0)==0){P=0;Q=N;break}else{R=R+1|0;S=S+1|0;T=L}}}else{P=1;Q=F&1}}while(0);if(Q<<24>>24!=0){Lw(c[r>>2]|0)}if((E&1)==0){if(P){U=0;C=48;break L4}else{break}}else{Lw(c[s>>2]|0);if(P){U=0;C=47;break L4}else{break}}}}while(0);k=A+1|0;if(k>>>0>=l>>>0){break L1}A=k;B=c[j>>2]|0}do{if((C|0)==5){cj();return 0}else if((C|0)==11){D5(0);return 0}else if((C|0)==19){z=0;ar(86,0);if(!z){return 0}else{z=0;j=bT(-1,-1)|0;V=M;W=j;break}}else if((C|0)==38){j=bT(-1,-1)|0;V=M;W=j}else if((C|0)==47){i=f;return U|0}else if((C|0)==48){i=f;return U|0}}while(0);if((a[m]&1)==0){bg(W|0)}Lw(c[s>>2]|0);bg(W|0)}}while(0);U=dn(b|0,d,e)|0;i=f;return U|0}function ds(a){a=a|0;var b=0;b=a;while(1){a=c[b+40>>2]|0;if((a|0)==0){break}else{b=a}}return c[b+36>>2]|0}function dt(a){a=a|0;var b=0;b=a;while(1){a=c[b+40>>2]|0;if((a|0)==0){break}else{b=a}}return b|0}function du(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+56|0;f=e|0;g=e+16|0;h=e+24|0;j=e+40|0;k=b+40|0;l=c[k>>2]|0;if((l|0)==0){m=0;i=e;return m|0}n=b+36|0;if((c[n>>2]|0)==0){m=du(l,d)|0;i=e;return m|0}l=Lu(44)|0;c[g>>2]=l;o=d+4|0;p=c[o>>2]|0;if((p|0)==(c[d+8>>2]|0)){e4(d|0,g);q=c[g>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=l;r=c[o>>2]|0}c[o>>2]=r+4;q=l}l=q;r=q;p=b+4|0;L15:do{if((a[p]&1)==0){g=h;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];s=19}else{g=c[b+12>>2]|0;t=c[b+8>>2]|0;do{if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(t>>>0<11>>>0){a[h]=t<<1;u=h+1|0}else{v=t+16&-16;w=(z=0,au(248,v|0)|0);if(z){z=0;break}c[h+8>>2]=w;c[h>>2]=v|1;c[h+4>>2]=t;u=w}LF(u|0,g|0,t)|0;a[u+t|0]=0;s=19;break L15}}while(0);t=bT(-1,-1)|0;x=M;y=t}}while(0);do{if((s|0)==19){u=j;p=b+16|0;c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];p=c[b+32>>2]|0;t=c[n>>2]|0;g=(z=0,aM(52,c[k>>2]|0,d|0)|0);do{if(!z){w=f;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];z=0;aD(20,r|0,h|0,f|0,p|0,t|0,g|0);if(z){z=0;break}if((a[h]&1)==0){m=r;i=e;return m|0}Lw(c[h+8>>2]|0);m=r;i=e;return m|0}else{z=0}}while(0);g=bT(-1,-1)|0;t=g;g=M;if((a[h]&1)==0){x=g;y=t;break}Lw(c[h+8>>2]|0);x=g;y=t}}while(0);h=c[d>>2]|0;d=c[o>>2]|0;m=h;while(1){if((m|0)==(d|0)){A=d;break}if((c[m>>2]|0)==(q|0)){A=m;break}else{m=m+4|0}}m=A-h>>2;A=h+(m+1<<2)|0;q=d-A|0;LG(h+(m<<2)|0,A|0,q|0)|0;A=h+((q>>2)+m<<2)|0;m=c[o>>2]|0;if((A|0)==(m|0)){Lw(l);B=y;C=0;D=B;E=x;bg(D|0)}c[o>>2]=m+(~((m-4+(-A|0)|0)>>>2)<<2);Lw(l);B=y;C=0;D=B;E=x;bg(D|0);return 0}function dv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+40|0;d=c[b>>2]|0;L1:do{if((d|0)==0){e=a;f=b}else{g=a;h=b;i=d;while(1){j=i;k=1;while(1){l=c[j+40>>2]|0;if((l|0)==0){break}else{j=l;k=k+1|0}}if((k|0)==1){e=g;f=h;break L1}j=i+40|0;l=c[j>>2]|0;if((l|0)==0){e=i;f=j;break}else{g=i;h=j;i=l}}}}while(0);d=e+32|0;e=c[d>>2]|0;c[d>>2]=0;c[f>>2]=0;return e|0}function dw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=a;while(1){f=e+40|0;a=c[f>>2]|0;if((a|0)==0){break}else{e=a}}c[f>>2]=b;c[e+32>>2]=d;return}function dx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e|0;g=Lu(44)|0;c[f>>2]=g;h=d+4|0;j=c[h>>2]|0;if((j|0)==(c[d+8>>2]|0)){e4(d|0,f);k=c[f>>2]|0}else{if((j|0)==0){l=0}else{c[j>>2]=g;l=c[h>>2]|0}c[h>>2]=l+4;k=g}g=k;l=k;j=k|0;c[j>>2]=17512;f=k+4|0;m=b+4|0;L8:do{if((a[m]&1)==0){n=f;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{n=c[b+12>>2]|0;o=c[b+8>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[f]=o<<1;p=f+1|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[k+12>>2]=r;c[f>>2]=q|1;c[k+8>>2]=o;p=r}LF(p|0,n|0,o)|0;a[p+o|0]=0;break L8}}while(0);o=bT(-1,-1)|0;n=c[d>>2]|0;r=c[h>>2]|0;q=n;while(1){if((q|0)==(r|0)){s=r;break}if((c[q>>2]|0)==(k|0)){s=q;break}else{q=q+4|0}}q=s-n>>2;t=n+(q+1<<2)|0;u=r-t|0;LG(n+(q<<2)|0,t|0,u|0)|0;t=n+((u>>2)+q<<2)|0;q=c[h>>2]|0;if((t|0)==(q|0)){Lw(g);bg(o|0)}c[h>>2]=q+(~((q-4+(-t|0)|0)>>>2)<<2);Lw(g);bg(o|0)}}while(0);g=k+16|0;h=b+16|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[j>>2]=17376;a[k+28|0]=a[b+28|0]&1;a[l+29|0]=a[b+29|0]&1;c[j>>2]=21072;c[k+32>>2]=c[b+32>>2];c[k+36>>2]=c[b+36>>2];j=k+40|0;k=b+40|0;c[j>>2]=c[k>>2];b=c[k>>2]|0;if((b|0)==0){i=e;return l|0}c[j>>2]=dx(b,d)|0;i=e;return l|0}function dy(a){a=a|0;return 0}function dz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;if((a[b+29|0]&1)==0){d=0;return d|0}e=c[b+36>>2]|0;f=(c[b+40>>2]|0)-e>>2;b=0;while(1){if(b>>>0>=f>>>0){d=0;g=8;break}h=c[e+(b<<2)>>2]|0;if((a[h+29|0]&1)==0){b=b+1|0}else{break}}if((g|0)==8){return d|0}d=cD[c[(c[h>>2]|0)+36>>2]&511](h)|0;return d|0}function dA(b){b=b|0;var d=0,e=0;if((a[b+29|0]&1)==0){d=0;return d|0}e=c[b+36>>2]|0;do{if((e|0)!=0){if((a[e+29|0]&1)==0){break}d=cD[c[(c[e>>2]|0)+36>>2]&511](e)|0;return d|0}}while(0);e=c[b+40>>2]|0;if((e|0)==0){d=0;return d|0}if((a[e+29|0]&1)==0){d=0;return d|0}d=cD[c[(c[e>>2]|0)+36>>2]&511](e)|0;return d|0}function dB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;if((a[b+29|0]&1)==0){d=0;return d|0}e=c[b+36>>2]|0;f=(c[b+40>>2]|0)-e>>2;b=0;while(1){if(b>>>0>=f>>>0){d=0;g=7;break}h=c[e+(b<<2)>>2]|0;if((a[h+29|0]&1)==0){b=b+1|0}else{break}}if((g|0)==7){return d|0}d=cD[c[(c[h>>2]|0)+36>>2]&511](h|0)|0;return d|0}function dC(a){a=a|0;return a|0}function dD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+24|0;f=e|0;g=e+8|0;Bv(f,0);h=b|0;c[h>>2]=0;j=b+4|0;c[j>>2]=0;k=b+8|0;c[k>>2]=0;l=d+40|0;m=d+36|0;z=0;as(402,b|0,(c[l>>2]|0)-(c[m>>2]|0)>>2|0);L1:do{if(!z){d=c[m>>2]|0;n=(c[l>>2]|0)-d>>2;if((n|0)==0){Bx(f);i=e;return}o=f|0;p=g;q=g+8|0;r=g+4|0;s=0;t=d;L6:while(1){d=c[t+(s<<2)>>2]|0;z=0;aR(c[(c[d>>2]|0)+28>>2]|0,g|0,d|0,o|0);if(z){z=0;u=23;break}d=c[j>>2]|0;if((d|0)==(c[k>>2]|0)){z=0;as(284,b|0,g|0);if(z){z=0;u=26;break}}else{do{if((d|0)!=0){if((a[p]&1)==0){v=d;c[v>>2]=c[p>>2];c[v+4>>2]=c[p+4>>2];c[v+8>>2]=c[p+8>>2];break}v=c[q>>2]|0;w=c[r>>2]|0;if(w>>>0>4294967279>>>0){u=10;break L6}if(w>>>0<11>>>0){a[d]=w<<1;x=d+1|0}else{y=w+16&-16;A=(z=0,au(248,y|0)|0);if(z){z=0;u=26;break L6}c[d+8>>2]=A;c[d>>2]=y|1;c[d+4>>2]=w;x=A}LF(x|0,v|0,w)|0;a[x+w|0]=0}}while(0);c[j>>2]=(c[j>>2]|0)+12}if((a[p]&1)!=0){Lw(c[q>>2]|0)}d=s+1|0;if(d>>>0>=n>>>0){u=42;break}s=d;t=c[m>>2]|0}do{if((u|0)==10){z=0;ar(86,0);if(z){z=0;t=bT(-1,-1)|0;B=M;C=t;break}}else if((u|0)==26){t=bT(-1,-1)|0;B=M;C=t}else if((u|0)==42){Bx(f);i=e;return}else if((u|0)==23){t=bT(-1,-1)|0;D=M;E=t;u=25;break L1}}while(0);t=C;s=B;if((a[p]&1)==0){F=t;G=s;break}Lw(c[q>>2]|0);F=t;G=s}else{z=0;s=bT(-1,-1)|0;D=M;E=s;u=25}}while(0);if((u|0)==25){F=E;G=D}D=c[h>>2]|0;if((D|0)!=0){G=c[j>>2]|0;if((D|0)==(G|0)){H=D}else{E=G;while(1){G=E-12|0;c[j>>2]=G;if((a[G]&1)==0){I=G}else{Lw(c[E-12+8>>2]|0);I=c[j>>2]|0}if((D|0)==(I|0)){break}else{E=I}}H=c[h>>2]|0}Lw(H)}z=0;ar(444,f|0);if(!z){bg(F|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function dE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=e|0;g=b+8|0;h=c[b>>2]|0;if((((c[g>>2]|0)-h|0)/12|0)>>>0>=d>>>0){i=e;return}j=((c[b+4>>2]|0)-h|0)/12|0;h=f+12|0;c[h>>2]=0;c[f+16>>2]=g;if((d|0)==0){k=0}else{k=Lu(d*12|0)|0}g=f|0;c[g>>2]=k;l=k+(j*12|0)|0;j=f+8|0;c[j>>2]=l;m=f+4|0;c[m>>2]=l;c[h>>2]=k+(d*12|0);z=0;as(476,b|0,f|0);if(!z){f=c[m>>2]|0;b=c[j>>2]|0;if((f|0)!=(b|0)){d=b;while(1){b=d-12|0;c[j>>2]=b;if((a[b]&1)!=0){Lw(c[d-12+8>>2]|0)}if((f|0)==(b|0)){break}else{d=b}}}d=c[g>>2]|0;if((d|0)==0){i=e;return}Lw(d);i=e;return}else{z=0;e=bT(-1,-1)|0;d=c[m>>2]|0;m=c[j>>2]|0;if((d|0)!=(m|0)){f=m;while(1){m=f-12|0;c[j>>2]=m;if((a[m]&1)!=0){Lw(c[f-12+8>>2]|0)}if((d|0)==(m|0)){break}else{f=m}}}f=c[g>>2]|0;if((f|0)==0){bg(e|0)}Lw(f);bg(e|0)}}function dF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0;f=i;i=i+88|0;g=f|0;h=f+8|0;j=f+24|0;k=f+32|0;l=f+40|0;m=f+56|0;n=f+72|0;Bv(k,0);o=(z=0,au(248,60)|0);L1:do{if(!z){p=o;c[j>>2]=p;q=e+4|0;r=c[q>>2]|0;if((r|0)==(c[e+8>>2]|0)){z=0;as(382,e|0,j|0);if(z){z=0;s=42;break}t=c[j>>2]|0}else{if((r|0)==0){u=0}else{c[r>>2]=p;u=c[q>>2]|0}c[q>>2]=u+4;t=p}p=t;r=t;v=b+4|0;L11:do{if((a[v]&1)==0){w=l;c[w>>2]=c[v>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];s=18}else{w=c[b+12>>2]|0;x=c[b+8>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[l]=x<<1;y=l+1|0}else{A=x+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[l+8>>2]=B;c[l>>2]=A|1;c[l+4>>2]=x;y=B}LF(y|0,w|0,x)|0;a[y+x|0]=0;s=18;break L11}}while(0);x=bT(-1,-1)|0;C=M;D=x}}while(0);do{if((s|0)==18){v=b+16|0;x=h;c[x>>2]=c[v>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];z=0;aV(42,r|0,l|0,h|0,0);if(z){z=0;v=bT(-1,-1)|0;x=v;v=M;if((a[l]&1)==0){C=v;D=x;break}Lw(c[l+8>>2]|0);C=v;D=x;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}x=b+36|0;v=(c[b+40>>2]|0)-(c[x>>2]|0)>>2;if((v|0)==0){Bx(k);i=f;return r|0}w=d+40|0;B=d+36|0;A=k|0;E=m;F=n;G=m+1|0;H=n+1|0;I=n+8|0;J=m+8|0;K=n+4|0;L=m+4|0;N=t+32|0;O=N;P=t+40|0;Q=N+12|0;R=t+36|0;S=N;N=0;L36:while(1){T=(c[w>>2]|0)-(c[B>>2]|0)>>2;U=0;while(1){V=c[(c[x>>2]|0)+(N<<2)>>2]|0;if(U>>>0>=T>>>0){s=55;break}z=0;aR(c[(c[V>>2]|0)+28>>2]|0,m|0,V|0,A|0);if(z){z=0;s=40;break L36}W=c[(c[B>>2]|0)+(U<<2)>>2]|0;z=0;aR(c[(c[W>>2]|0)+28>>2]|0,n|0,W|0,A|0);if(z){z=0;s=53;break L36}W=a[E]|0;X=W&255;Y=(X&1|0)==0?X>>>1:c[L>>2]|0;X=a[F]|0;Z=X&255;L43:do{if((Y|0)==(((Z&1|0)==0?Z>>>1:c[K>>2]|0)|0)){_=(W&1)==0;$=_?G:c[J>>2]|0;aa=X&1;ab=aa<<24>>24==0?H:c[I>>2]|0;if(!_){ac=(LH($|0,ab|0,Y|0)|0)==0;ad=aa;break}if((Y|0)==0){ac=1;ad=aa;break}else{ae=ab;af=$;ag=Y}while(1){if((a[af]|0)!=(a[ae]|0)){ac=0;ad=aa;break L43}$=ag-1|0;if(($|0)==0){ac=1;ad=aa;break}else{ae=ae+1|0;af=af+1|0;ag=$}}}else{ac=0;ad=X&1}}while(0);if(ad<<24>>24==0){ah=W}else{Lw(c[I>>2]|0);ah=a[E]|0}if((ah&1)!=0){Lw(c[J>>2]|0)}if(ac){break}U=U+1|0}if((s|0)==55){s=0;c[g>>2]=V;U=c[P>>2]|0;T=U;if((T|0)==(c[Q>>2]|0)){z=0;as(740,R|0,g|0);if(z){z=0;s=41;break}ai=c[g>>2]|0}else{if((U|0)==0){aj=0}else{c[T>>2]=V;aj=c[P>>2]|0}c[P>>2]=aj+4;ai=V}z=0;as(c[c[S>>2]>>2]|0,O|0,ai|0);if(z){z=0;s=41;break}}T=N+1|0;if(T>>>0<v>>>0){N=T}else{s=68;break}}if((s|0)==53){N=bT(-1,-1)|0;v=N;N=M;if((a[E]&1)==0){ak=N;al=v;break L1}Lw(c[J>>2]|0);ak=N;al=v;break L1}else if((s|0)==40){v=bT(-1,-1)|0;am=M;an=v;s=43;break L1}else if((s|0)==41){v=bT(-1,-1)|0;am=M;an=v;s=43;break L1}else if((s|0)==68){Bx(k);i=f;return r|0}}}while(0);r=c[e>>2]|0;v=c[q>>2]|0;N=r;while(1){if((N|0)==(v|0)){ao=v;break}if((c[N>>2]|0)==(t|0)){ao=N;break}else{N=N+4|0}}N=ao-r>>2;O=r+(N+1<<2)|0;S=v-O|0;LG(r+(N<<2)|0,O|0,S|0)|0;O=r+((S>>2)+N<<2)|0;N=c[q>>2]|0;if((O|0)!=(N|0)){c[q>>2]=N+(~((N-4+(-O|0)|0)>>>2)<<2)}Lw(p);ak=C;al=D}else{z=0;s=42}}while(0);if((s|0)==42){D=bT(-1,-1)|0;am=M;an=D;s=43}if((s|0)==43){ak=am;al=an}z=0;ar(444,k|0);if(!z){bg(al|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function dG(a,b){a=a|0;b=b|0;cB[c[c[b>>2]>>2]&1023](b,a);return}function dH(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a)|0}function dI(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a)|0}function dJ(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a)|0}function dK(a,b){a=a|0;b=b|0;return cV[c[c[b>>2]>>2]&1023](b,a)|0}function dL(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[c[d>>2]>>2]&511](a,d,b);return}function dM(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[c[d>>2]>>2]&511](a,d,b);return}function dN(a){a=a|0;return c[9232]|0}function dO(a){a=a|0;return 0}function dP(b){b=b|0;var d=0;d=b|0;c[d>>2]=20176;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function dQ(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=20176;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function dR(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+176>>2]&1023](b,a);return}function dS(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dT(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dU(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dV(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dW(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+176>>2]&511](a,d,b);return}function dX(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+176>>2]&511](a,d,b);return}function dY(b){b=b|0;var d=0;d=b|0;c[d>>2]=21416;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function dZ(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21416;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function d_(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+180>>2]&1023](b,a);return}function d$(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function d0(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function d1(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function d2(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function d3(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+180>>2]&511](a,d,b);return}function d4(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+180>>2]&511](a,d,b);return}function d5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+16|0;e=d|0;f=b+32|0;if((a[f]&1)==0){g=e;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];h=a[g]|0;j=g}else{g=c[b+40>>2]|0;f=c[b+36>>2]|0;if(f>>>0>4294967279>>>0){D5(0);return 0}if(f>>>0<11>>>0){b=f<<1&255;k=e;a[k]=b;l=e+1|0;m=b;n=k}else{k=f+16&-16;b=Lu(k)|0;c[e+8>>2]=b;o=k|1;c[e>>2]=o;c[e+4>>2]=f;l=b;m=o&255;n=e}LF(l|0,g|0,f)|0;a[l+f|0]=0;h=m;j=n}n=h&255;if((n&1|0)==0){p=n>>>1}else{p=c[e+4>>2]|0}if((h&1)==0){q=e+1|0}else{q=c[e+8>>2]|0}h=p>>>0>1>>>0;n=LH(q|0,13336,(h?1:p)|0)|0;if((n|0)==0){r=(p|0)==0?-1:h&1}else{r=n}if((a[j]&1)==0){s=(r|0)!=0;t=s&1;i=d;return t|0}Lw(c[e+8>>2]|0);s=(r|0)!=0;t=s&1;i=d;return t|0}function d6(b){b=b|0;var d=0;d=b|0;c[d>>2]=20392;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function d7(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=20392;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function d8(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+184>>2]&1023](b,a);return}function d9(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function ea(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function eb(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function ec(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function ed(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+184>>2]&511](a,d,b);return}function ee(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+184>>2]&511](a,d,b);return}function ef(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d|0;f=b+32|0;if((a[f]&1)==0){g=e;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];h=a[g]|0;j=g}else{g=c[b+40>>2]|0;f=c[b+36>>2]|0;if(f>>>0>4294967279>>>0){D5(0);return 0}if(f>>>0<11>>>0){b=f<<1&255;k=e;a[k]=b;l=e+1|0;m=b;n=k}else{k=f+16&-16;b=Lu(k)|0;c[e+8>>2]=b;o=k|1;c[e>>2]=o;c[e+4>>2]=f;l=b;m=o&255;n=e}LF(l|0,g|0,f)|0;a[l+f|0]=0;h=m;j=n}if((h&1)==0){p=e+1|0}else{p=c[e+8>>2]|0}h=(a[p]|0)==35;if((a[j]&1)!=0){Lw(c[e+8>>2]|0)}e=c[9232]|0;if(!h){q=e;i=d;return q|0}q=ai(e,e)|0;i=d;return q|0}function eg(b){b=b|0;var d=0;d=b|0;c[d>>2]=21344;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function eh(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21344;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function ei(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+192>>2]&1023](b,a);return}function ej(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function ek(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function el(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function em(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function en(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+192>>2]&511](a,d,b);return}function eo(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+192>>2]&511](a,d,b);return}function ep(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,as=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0;d=i;i=i+128|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+64|0;k=d+80|0;l=d+96|0;m=d+112|0;n=b+32|0;o=(a[n]&1)==0;if(o){p=e;c[p>>2]=c[n>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];q=a[p]|0;r=p}else{p=c[b+40>>2]|0;s=c[b+36>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){t=s<<1&255;u=e;a[u]=t;v=e+1|0;w=t;x=u}else{u=s+16&-16;t=Lu(u)|0;c[e+8>>2]=t;y=u|1;c[e>>2]=y;c[e+4>>2]=s;v=t;w=y&255;x=e}LF(v|0,p|0,s)|0;a[v+s|0]=0;q=w;r=x}x=q&255;if((x&1|0)==0){A=x>>>1}else{A=c[e+4>>2]|0}if((q&1)==0){B=e+1|0}else{B=c[e+8>>2]|0}q=A>>>0>7>>>0;if((LH(B|0,8016,(q?7:A)|0)|0)==0){if(A>>>0>6>>>0&(q^1)){C=1}else{D=17}}else{D=17}L22:do{if((D|0)==17){L24:do{if(o){q=f;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];E=a[q]|0;D=27}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[f]=B;F=f+1|0;G=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[f+8>>2]=x;w=B|1;c[f>>2]=w;c[f+4>>2]=A;F=x;G=w&255}LF(F|0,q|0,A)|0;a[F+A|0]=0;E=G;D=27;break L24}}while(0);A=bT(-1,-1)|0;H=M;I=A}}while(0);L37:do{if((D|0)==27){A=E&255;if((A&1|0)==0){J=A>>>1}else{J=c[f+4>>2]|0}if((E&1)==0){K=f+1|0}else{K=c[f+8>>2]|0}A=J>>>0>8>>>0;if((LH(K|0,6104,(A?8:J)|0)|0)==0){if(J>>>0>7>>>0&(A^1)){L=1}else{D=35}}else{D=35}L49:do{if((D|0)==35){L51:do{if(o){A=g;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];N=a[A]|0;D=45}else{A=c[b+40>>2]|0;q=c[b+36>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){w=q<<1&255;a[g]=w;O=g+1|0;P=w}else{w=q+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[g+8>>2]=x;B=w|1;c[g>>2]=B;c[g+4>>2]=q;O=x;P=B&255}LF(O|0,A|0,q)|0;a[O+q|0]=0;N=P;D=45;break L51}}while(0);q=bT(-1,-1)|0;Q=M;R=q}}while(0);L64:do{if((D|0)==45){q=N&255;if((q&1|0)==0){S=q>>>1}else{S=c[g+4>>2]|0}if((N&1)==0){T=g+1|0}else{T=c[g+8>>2]|0}q=S>>>0>6>>>0;if((LH(T|0,5248,(q?6:S)|0)|0)==0){if(S>>>0>5>>>0&(q^1)){U=1}else{D=53}}else{D=53}L76:do{if((D|0)==53){L78:do{if(o){q=h;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];V=a[q]|0;D=63}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[h]=B;W=h+1|0;X=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[h+8>>2]=x;w=B|1;c[h>>2]=w;c[h+4>>2]=A;W=x;X=w&255}LF(W|0,q|0,A)|0;a[W+A|0]=0;V=X;D=63;break L78}}while(0);A=bT(-1,-1)|0;Y=M;Z=A}}while(0);L91:do{if((D|0)==63){A=V&255;if((A&1|0)==0){_=A>>>1}else{_=c[h+4>>2]|0}if((V&1)==0){$=h+1|0}else{$=c[h+8>>2]|0}A=_>>>0>7>>>0;if((LH($|0,3672,(A?7:_)|0)|0)==0){if(_>>>0>6>>>0&(A^1)){aa=1}else{D=71}}else{D=71}L103:do{if((D|0)==71){L105:do{if(o){A=j;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];ab=a[A]|0;D=81}else{A=c[b+40>>2]|0;q=c[b+36>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){w=q<<1&255;a[j]=w;ac=j+1|0;ad=w}else{w=q+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[j+8>>2]=x;B=w|1;c[j>>2]=B;c[j+4>>2]=q;ac=x;ad=B&255}LF(ac|0,A|0,q)|0;a[ac+q|0]=0;ab=ad;D=81;break L105}}while(0);q=bT(-1,-1)|0;ae=M;af=q}}while(0);L118:do{if((D|0)==81){q=ab&255;if((q&1|0)==0){ag=q>>>1}else{ag=c[j+4>>2]|0}if((ab&1)==0){ah=j+1|0}else{ah=c[j+8>>2]|0}q=ag>>>0>11>>>0;if((LH(ah|0,2296,(q?11:ag)|0)|0)==0){if(ag>>>0>10>>>0&(q^1)){ai=1}else{D=89}}else{D=89}L130:do{if((D|0)==89){L132:do{if(o){q=k;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];aj=a[q]|0;D=99}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[k]=B;ak=k+1|0;al=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[k+8>>2]=x;w=B|1;c[k>>2]=w;c[k+4>>2]=A;ak=x;al=w&255}LF(ak|0,q|0,A)|0;a[ak+A|0]=0;aj=al;D=99;break L132}}while(0);A=bT(-1,-1)|0;am=M;an=A}}while(0);L145:do{if((D|0)==99){A=aj&255;if((A&1|0)==0){ao=A>>>1}else{ao=c[k+4>>2]|0}if((aj&1)==0){ap=k+1|0}else{ap=c[k+8>>2]|0}A=ao>>>0>12>>>0;if((LH(ap|0,1504,(A?12:ao)|0)|0)==0){if(ao>>>0>11>>>0&(A^1)){aq=1}else{D=107}}else{D=107}L157:do{if((D|0)==107){L159:do{if(o){A=l;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];as=a[A]|0;D=117}else{A=c[b+40>>2]|0;q=c[b+36>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){w=q<<1&255;a[l]=w;at=l+1|0;av=w}else{w=q+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[l+8>>2]=x;B=w|1;c[l>>2]=B;c[l+4>>2]=q;at=x;av=B&255}LF(at|0,A|0,q)|0;a[at+q|0]=0;as=av;D=117;break L159}}while(0);q=bT(-1,-1)|0;aw=M;ax=q}}while(0);L172:do{if((D|0)==117){q=as&255;if((q&1|0)==0){ay=q>>>1}else{ay=c[l+4>>2]|0}if((as&1)==0){az=l+1|0}else{az=c[l+8>>2]|0}q=ay>>>0>13>>>0;if((LH(az|0,784,(q?13:ay)|0)|0)==0){if(ay>>>0>12>>>0&(q^1)){aA=1}else{D=125}}else{D=125}do{if((D|0)==125){L186:do{if(o){q=m;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];aB=a[q]|0}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[m]=B;aC=m+1|0;aD=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[m+8>>2]=x;w=B|1;c[m>>2]=w;c[m+4>>2]=A;aC=x;aD=w&255}LF(aC|0,q|0,A)|0;a[aC+A|0]=0;aB=aD;break L186}}while(0);A=bT(-1,-1)|0;q=A;A=M;if((as&1)==0){aw=A;ax=q;break L172}Lw(c[l+8>>2]|0);aw=A;ax=q;break L172}}while(0);q=aB&255;if((q&1|0)==0){aE=q>>>1}else{aE=c[m+4>>2]|0}if((aB&1)==0){aF=m+1|0}else{aF=c[m+8>>2]|0}q=aE>>>0>14>>>0;A=LH(aF|0,13320,(q?14:aE)|0)|0;if((A|0)==0){aG=aE>>>0<14>>>0?-1:q&1}else{aG=A}A=(aG|0)==0;if((aB&1)==0){aA=A;break}Lw(c[m+8>>2]|0);aA=A}}while(0);if((as&1)==0){aq=aA;break L157}Lw(c[l+8>>2]|0);aq=aA;break L157}}while(0);if((aj&1)==0){am=aw;an=ax;break L145}Lw(c[k+8>>2]|0);am=aw;an=ax;break L145}}while(0);if((aj&1)==0){ai=aq;break L130}Lw(c[k+8>>2]|0);ai=aq;break L130}}while(0);if((ab&1)==0){ae=am;af=an;break L118}Lw(c[j+8>>2]|0);ae=am;af=an;break L118}}while(0);if((ab&1)==0){aa=ai;break L103}Lw(c[j+8>>2]|0);aa=ai;break L103}}while(0);if((V&1)==0){Y=ae;Z=af;break L91}Lw(c[h+8>>2]|0);Y=ae;Z=af;break L91}}while(0);if((V&1)==0){U=aa;break L76}Lw(c[h+8>>2]|0);U=aa;break L76}}while(0);if((N&1)==0){Q=Y;R=Z;break L64}Lw(c[g+8>>2]|0);Q=Y;R=Z;break L64}}while(0);if((N&1)==0){L=U;break L49}Lw(c[g+8>>2]|0);L=U;break L49}}while(0);if((E&1)==0){H=Q;I=R;break L37}Lw(c[f+8>>2]|0);H=Q;I=R;break L37}}while(0);if((E&1)==0){C=L;break L22}Lw(c[f+8>>2]|0);C=L;break L22}}while(0);if((a[r]&1)==0){aH=I;aI=0;aJ=aH;aK=H;bg(aJ|0)}Lw(c[e+8>>2]|0);aH=I;aI=0;aJ=aH;aK=H;bg(aJ|0)}}while(0);if((a[r]&1)==0){aL=c[9232]|0;aM=C?1:aL;i=d;return aM|0}Lw(c[e+8>>2]|0);aL=c[9232]|0;aM=C?1:aL;i=d;return aM|0}function eq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,as=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0;d=i;i=i+128|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+64|0;k=d+80|0;l=d+96|0;m=d+112|0;n=b+32|0;o=(a[n]&1)==0;if(o){p=e;c[p>>2]=c[n>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];q=a[p]|0;r=p}else{p=c[b+40>>2]|0;s=c[b+36>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){t=s<<1&255;u=e;a[u]=t;v=e+1|0;w=t;x=u}else{u=s+16&-16;t=Lu(u)|0;c[e+8>>2]=t;y=u|1;c[e>>2]=y;c[e+4>>2]=s;v=t;w=y&255;x=e}LF(v|0,p|0,s)|0;a[v+s|0]=0;q=w;r=x}x=q&255;if((x&1|0)==0){A=x>>>1}else{A=c[e+4>>2]|0}if((q&1)==0){B=e+1|0}else{B=c[e+8>>2]|0}q=A>>>0>7>>>0;if((LH(B|0,8016,(q?7:A)|0)|0)==0){if(A>>>0>6>>>0&(q^1)){C=1}else{D=17}}else{D=17}L22:do{if((D|0)==17){L24:do{if(o){q=f;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];E=a[q]|0;D=27}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[f]=B;F=f+1|0;G=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[f+8>>2]=x;w=B|1;c[f>>2]=w;c[f+4>>2]=A;F=x;G=w&255}LF(F|0,q|0,A)|0;a[F+A|0]=0;E=G;D=27;break L24}}while(0);A=bT(-1,-1)|0;H=M;I=A}}while(0);L37:do{if((D|0)==27){A=E&255;if((A&1|0)==0){J=A>>>1}else{J=c[f+4>>2]|0}if((E&1)==0){K=f+1|0}else{K=c[f+8>>2]|0}A=J>>>0>8>>>0;if((LH(K|0,6104,(A?8:J)|0)|0)==0){if(J>>>0>7>>>0&(A^1)){L=1}else{D=35}}else{D=35}L49:do{if((D|0)==35){L51:do{if(o){A=g;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];N=a[A]|0;D=45}else{A=c[b+40>>2]|0;q=c[b+36>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){w=q<<1&255;a[g]=w;O=g+1|0;P=w}else{w=q+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[g+8>>2]=x;B=w|1;c[g>>2]=B;c[g+4>>2]=q;O=x;P=B&255}LF(O|0,A|0,q)|0;a[O+q|0]=0;N=P;D=45;break L51}}while(0);q=bT(-1,-1)|0;Q=M;R=q}}while(0);L64:do{if((D|0)==45){q=N&255;if((q&1|0)==0){S=q>>>1}else{S=c[g+4>>2]|0}if((N&1)==0){T=g+1|0}else{T=c[g+8>>2]|0}q=S>>>0>6>>>0;if((LH(T|0,5248,(q?6:S)|0)|0)==0){if(S>>>0>5>>>0&(q^1)){U=1}else{D=53}}else{D=53}L76:do{if((D|0)==53){L78:do{if(o){q=h;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];V=a[q]|0;D=63}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[h]=B;W=h+1|0;X=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[h+8>>2]=x;w=B|1;c[h>>2]=w;c[h+4>>2]=A;W=x;X=w&255}LF(W|0,q|0,A)|0;a[W+A|0]=0;V=X;D=63;break L78}}while(0);A=bT(-1,-1)|0;Y=M;Z=A}}while(0);L91:do{if((D|0)==63){A=V&255;if((A&1|0)==0){_=A>>>1}else{_=c[h+4>>2]|0}if((V&1)==0){$=h+1|0}else{$=c[h+8>>2]|0}A=_>>>0>7>>>0;if((LH($|0,3672,(A?7:_)|0)|0)==0){if(_>>>0>6>>>0&(A^1)){aa=1}else{D=71}}else{D=71}L103:do{if((D|0)==71){L105:do{if(o){A=j;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];ab=a[A]|0;D=81}else{A=c[b+40>>2]|0;q=c[b+36>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){w=q<<1&255;a[j]=w;ac=j+1|0;ad=w}else{w=q+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[j+8>>2]=x;B=w|1;c[j>>2]=B;c[j+4>>2]=q;ac=x;ad=B&255}LF(ac|0,A|0,q)|0;a[ac+q|0]=0;ab=ad;D=81;break L105}}while(0);q=bT(-1,-1)|0;ae=M;af=q}}while(0);L118:do{if((D|0)==81){q=ab&255;if((q&1|0)==0){ag=q>>>1}else{ag=c[j+4>>2]|0}if((ab&1)==0){ah=j+1|0}else{ah=c[j+8>>2]|0}q=ag>>>0>11>>>0;if((LH(ah|0,2296,(q?11:ag)|0)|0)==0){if(ag>>>0>10>>>0&(q^1)){ai=1}else{D=89}}else{D=89}L130:do{if((D|0)==89){L132:do{if(o){q=k;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];aj=a[q]|0;D=99}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[k]=B;ak=k+1|0;al=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[k+8>>2]=x;w=B|1;c[k>>2]=w;c[k+4>>2]=A;ak=x;al=w&255}LF(ak|0,q|0,A)|0;a[ak+A|0]=0;aj=al;D=99;break L132}}while(0);A=bT(-1,-1)|0;am=M;an=A}}while(0);L145:do{if((D|0)==99){A=aj&255;if((A&1|0)==0){ao=A>>>1}else{ao=c[k+4>>2]|0}if((aj&1)==0){ap=k+1|0}else{ap=c[k+8>>2]|0}A=ao>>>0>12>>>0;if((LH(ap|0,1504,(A?12:ao)|0)|0)==0){if(ao>>>0>11>>>0&(A^1)){aq=1}else{D=107}}else{D=107}L157:do{if((D|0)==107){L159:do{if(o){A=l;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];as=a[A]|0;D=117}else{A=c[b+40>>2]|0;q=c[b+36>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){w=q<<1&255;a[l]=w;at=l+1|0;av=w}else{w=q+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[l+8>>2]=x;B=w|1;c[l>>2]=B;c[l+4>>2]=q;at=x;av=B&255}LF(at|0,A|0,q)|0;a[at+q|0]=0;as=av;D=117;break L159}}while(0);q=bT(-1,-1)|0;aw=M;ax=q}}while(0);L172:do{if((D|0)==117){q=as&255;if((q&1|0)==0){ay=q>>>1}else{ay=c[l+4>>2]|0}if((as&1)==0){az=l+1|0}else{az=c[l+8>>2]|0}q=ay>>>0>13>>>0;if((LH(az|0,784,(q?13:ay)|0)|0)==0){if(ay>>>0>12>>>0&(q^1)){aA=1}else{D=125}}else{D=125}do{if((D|0)==125){L186:do{if(o){q=m;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];aB=a[q]|0}else{q=c[b+40>>2]|0;A=c[b+36>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){B=A<<1&255;a[m]=B;aC=m+1|0;aD=B}else{B=A+16&-16;x=(z=0,au(248,B|0)|0);if(z){z=0;break}c[m+8>>2]=x;w=B|1;c[m>>2]=w;c[m+4>>2]=A;aC=x;aD=w&255}LF(aC|0,q|0,A)|0;a[aC+A|0]=0;aB=aD;break L186}}while(0);A=bT(-1,-1)|0;q=A;A=M;if((as&1)==0){aw=A;ax=q;break L172}Lw(c[l+8>>2]|0);aw=A;ax=q;break L172}}while(0);q=aB&255;if((q&1|0)==0){aE=q>>>1}else{aE=c[m+4>>2]|0}if((aB&1)==0){aF=m+1|0}else{aF=c[m+8>>2]|0}q=aE>>>0>14>>>0;A=LH(aF|0,13320,(q?14:aE)|0)|0;if((A|0)==0){aG=aE>>>0<14>>>0?-1:q&1}else{aG=A}A=(aG|0)==0;if((aB&1)==0){aA=A;break}Lw(c[m+8>>2]|0);aA=A}}while(0);if((as&1)==0){aq=aA;break L157}Lw(c[l+8>>2]|0);aq=aA;break L157}}while(0);if((aj&1)==0){am=aw;an=ax;break L145}Lw(c[k+8>>2]|0);am=aw;an=ax;break L145}}while(0);if((aj&1)==0){ai=aq;break L130}Lw(c[k+8>>2]|0);ai=aq;break L130}}while(0);if((ab&1)==0){ae=am;af=an;break L118}Lw(c[j+8>>2]|0);ae=am;af=an;break L118}}while(0);if((ab&1)==0){aa=ai;break L103}Lw(c[j+8>>2]|0);aa=ai;break L103}}while(0);if((V&1)==0){Y=ae;Z=af;break L91}Lw(c[h+8>>2]|0);Y=ae;Z=af;break L91}}while(0);if((V&1)==0){U=aa;break L76}Lw(c[h+8>>2]|0);U=aa;break L76}}while(0);if((N&1)==0){Q=Y;R=Z;break L64}Lw(c[g+8>>2]|0);Q=Y;R=Z;break L64}}while(0);if((N&1)==0){L=U;break L49}Lw(c[g+8>>2]|0);L=U;break L49}}while(0);if((E&1)==0){H=Q;I=R;break L37}Lw(c[f+8>>2]|0);H=Q;I=R;break L37}}while(0);if((E&1)==0){C=L;break L22}Lw(c[f+8>>2]|0);C=L;break L22}}while(0);if((a[r]&1)==0){aH=I;aI=0;aJ=aH;aK=H;bg(aJ|0)}Lw(c[e+8>>2]|0);aH=I;aI=0;aJ=aH;aK=H;bg(aJ|0)}}while(0);if((a[r]&1)==0){i=d;return C|0}Lw(c[e+8>>2]|0);i=d;return C|0}function er(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b|0;c[d>>2]=20768;e=b+32|0;c[e>>2]=20824;e9(b+48|0,c[b+52>>2]|0);c[e>>2]=22640;e=c[b+36>>2]|0;f=e;if((e|0)!=0){g=b+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function es(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b|0;c[d>>2]=20768;e=b+32|0;c[e>>2]=20824;e9(b+48|0,c[b+52>>2]|0);c[e>>2]=22640;e=c[b+36>>2]|0;f=e;if((e|0)!=0){g=b+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}c[d>>2]=17512;if((a[b+4|0]&1)==0){i=b;Lw(i);return}Lw(c[b+12>>2]|0);i=b;Lw(i);return}function et(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+200>>2]&1023](b,a);return}function eu(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function ev(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function ew(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function ex(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function ey(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+200>>2]&511](a,d,b);return}function ez(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+200>>2]&511](a,d,b);return}function eA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=a+36|0;d=c[b>>2]|0;e=(c[a+40>>2]|0)-d>>2;if((e|0)==0){f=0;return f|0}else{g=0;h=0;i=d}while(1){d=c[i+(g<<2)>>2]|0;a=(cD[c[(c[d>>2]|0)+40>>2]&511](d|0)|0)+h|0;d=g+1|0;if(d>>>0>=e>>>0){f=a;break}g=d;h=a;i=c[b>>2]|0}return f|0}function eB(b,c){b=b|0;c=c|0;if((a[c+28|0]&1)!=0){a[b+28|0]=1}if((a[c+29|0]&1)==0){return}a[b+29|0]=1;return}function eC(b,c){b=b|0;c=c|0;var d=0;d=b-60+28|0;if((a[c+28|0]&1)!=0){a[d+28|0]=1}if((a[c+29|0]&1)==0){return}a[d+29|0]=1;return}function eD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+28|0;b=d;c[b>>2]=20768;e=d+32|0;c[e>>2]=20824;e9(d+48|0,c[d+52>>2]|0);c[e>>2]=22640;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}c[b>>2]=17512;if((a[d+4|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function eE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+28|0;b=d;c[b>>2]=20768;e=d+32|0;c[e>>2]=20824;e9(d+48|0,c[d+52>>2]|0);c[e>>2]=22640;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}c[b>>2]=17512;if((a[d+4|0]&1)==0){Lw(d);return}Lw(c[d+12>>2]|0);Lw(d);return}function eF(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function eG(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function eH(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+204>>2]&1023](b,a);return}function eI(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function eJ(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function eK(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function eL(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function eM(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+204>>2]&511](a,d,b);return}function eN(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+204>>2]&511](a,d,b);return}function eO(a){a=a|0;var b=0,d=0,e=0;b=c[a+36>>2]|0;if((b|0)==0){d=0}else{d=cD[c[(c[b>>2]|0)+40>>2]&511](b)|0}b=c[a+40>>2]|0;if((b|0)==0){e=d;return e|0}e=(cD[c[(c[b>>2]|0)+40>>2]&511](b)|0)+d|0;return e|0}function eP(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+32>>2]=22608;d=c[b+36>>2]|0;e=d;if((d|0)!=0){f=b+40|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function eQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+32>>2]=22608;d=c[b+36>>2]|0;e=d;if((d|0)!=0){f=b+40|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){h=b;Lw(h);return}Lw(c[b+12>>2]|0);h=b;Lw(h);return}function eR(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+208>>2]&1023](b,a);return}function eS(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function eT(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function eU(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function eV(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function eW(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+208>>2]&511](a,d,b);return}function eX(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+208>>2]&511](a,d,b);return}function eY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=a+36|0;d=c[b>>2]|0;e=(c[a+40>>2]|0)-d>>2;if((e|0)==0){f=0;return f|0}else{g=0;h=0;i=d}while(1){d=c[i+(g<<2)>>2]|0;a=(cD[c[(c[d>>2]|0)+40>>2]&511](d)|0)+h|0;d=g+1|0;if(d>>>0>=e>>>0){f=a;break}g=d;h=a;i=c[b>>2]|0}return f|0}function eZ(b,c){b=b|0;c=c|0;if((a[c+28|0]&1)!=0){a[b+28|0]=1}if((a[c+29|0]&1)==0){return}a[b+29|0]=1;return}function e_(b,c){b=b|0;c=c|0;var d=0;d=b-48+16|0;if((a[c+28|0]&1)!=0){a[d+28|0]=1}if((a[c+29|0]&1)==0){return}a[d+29|0]=1;return}function e$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-48+16|0;c[d+32>>2]=22608;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}c[d>>2]=17512;if((a[b-48+20|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function e0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b-48+16|0;c[d+32>>2]=22608;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}c[d>>2]=17512;if((a[b-48+20|0]&1)==0){i=d;Lw(i);return}Lw(c[d+12>>2]|0);i=d;Lw(i);return}function e1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=f>>>1;j=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;L5:do{if((f&1|0)==0){e=g;while(1){m=e+16|0;n=m;o=a[m]|0;m=o&255;p=(m&1|0)==0;if(p){q=m>>>1}else{q=c[e+20>>2]|0}if(j){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=LH(r|0,t|0,(q>>>0<i>>>0?q:i)|0)|0;if((o|0)==0){if(i>>>0<q>>>0){u=26}}else{if((o|0)<0){u=26}}if((u|0)==26){u=0;o=e|0;v=c[o>>2]|0;if((v|0)==0){w=e;x=o;u=39;break}else{e=v;continue}}if(p){y=m>>>1}else{y=c[e+20>>2]|0}if(s){z=n+1|0}else{z=c[e+24>>2]|0}if(j){A=b}else{A=c[k>>2]|0}n=LH(z|0,A|0,(i>>>0<y>>>0?i:y)|0)|0;if((n|0)==0){if(y>>>0>=i>>>0){B=e;u=53;break L5}}else{if((n|0)>=0){B=e;u=53;break L5}}n=e+4|0;s=c[n>>2]|0;if((s|0)==0){C=e;D=n;u=52;break}else{e=s}}}else{e=g;while(1){s=e+16|0;n=c[l>>2]|0;m=s;p=a[s]|0;s=p&255;v=(s&1|0)==0;if(v){E=s>>>1}else{E=c[e+20>>2]|0}if(j){F=b}else{F=c[k>>2]|0}o=(p&1)==0;if(o){G=m+1|0}else{G=c[e+24>>2]|0}p=LH(F|0,G|0,(E>>>0<n>>>0?E:n)|0)|0;if((p|0)==0){if(n>>>0<E>>>0){u=38}}else{if((p|0)<0){u=38}}if((u|0)==38){u=0;p=e|0;n=c[p>>2]|0;if((n|0)==0){w=e;x=p;u=39;break}else{e=n;continue}}if(v){H=s>>>1}else{H=c[e+20>>2]|0}s=c[l>>2]|0;if(o){I=m+1|0}else{I=c[e+24>>2]|0}if(j){J=b}else{J=c[k>>2]|0}m=LH(I|0,J|0,(s>>>0<H>>>0?s:H)|0)|0;if((m|0)==0){if(H>>>0>=s>>>0){B=e;u=53;break L5}}else{if((m|0)>=0){B=e;u=53;break L5}}m=e+4|0;s=c[m>>2]|0;if((s|0)==0){C=e;D=m;u=52;break}else{e=s}}}}while(0);if((u|0)==52){c[d>>2]=C;h=D;return h|0}else if((u|0)==53){c[d>>2]=B;h=d;return h|0}else if((u|0)==39){c[d>>2]=w;h=x;return h|0}return 0}function e2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=(d|0)==(b|0);a[d+12|0]=e&1;if(e){return}else{f=d}while(1){g=f+8|0;h=c[g>>2]|0;d=h+12|0;if((a[d]&1)!=0){i=39;break}j=h+8|0;k=c[j>>2]|0;e=c[k>>2]|0;if((h|0)==(e|0)){l=c[k+4>>2]|0;if((l|0)==0){i=7;break}m=l+12|0;if((a[m]&1)!=0){i=7;break}a[d]=1;a[k+12|0]=(k|0)==(b|0)|0;a[m]=1}else{if((e|0)==0){i=24;break}m=e+12|0;if((a[m]&1)!=0){i=24;break}a[d]=1;a[k+12|0]=(k|0)==(b|0)|0;a[m]=1}if((k|0)==(b|0)){i=42;break}else{f=k}}if((i|0)==39){return}else if((i|0)==42){return}else if((i|0)==7){if((f|0)==(c[h>>2]|0)){n=h;o=k}else{b=h+4|0;m=c[b>>2]|0;d=m|0;e=c[d>>2]|0;c[b>>2]=e;if((e|0)==0){p=k}else{c[e+8>>2]=h;p=c[j>>2]|0}e=m+8|0;c[e>>2]=p;p=c[j>>2]|0;b=p|0;if((c[b>>2]|0)==(h|0)){c[b>>2]=m}else{c[p+4>>2]=m}c[d>>2]=h;c[j>>2]=m;n=m;o=c[e>>2]|0}a[n+12|0]=1;a[o+12|0]=0;n=o|0;e=c[n>>2]|0;m=e+4|0;d=c[m>>2]|0;c[n>>2]=d;if((d|0)!=0){c[d+8>>2]=o}d=o+8|0;c[e+8>>2]=c[d>>2];n=c[d>>2]|0;p=n|0;if((c[p>>2]|0)==(o|0)){c[p>>2]=e}else{c[n+4>>2]=e}c[m>>2]=o;c[d>>2]=e;return}else if((i|0)==24){i=h|0;if((f|0)==(c[i>>2]|0)){e=f+4|0;d=c[e>>2]|0;c[i>>2]=d;if((d|0)==0){q=k}else{c[d+8>>2]=h;q=c[j>>2]|0}c[g>>2]=q;q=c[j>>2]|0;d=q|0;if((c[d>>2]|0)==(h|0)){c[d>>2]=f}else{c[q+4>>2]=f}c[e>>2]=h;c[j>>2]=f;r=f;s=c[g>>2]|0}else{r=h;s=k}a[r+12|0]=1;a[s+12|0]=0;r=s+4|0;k=c[r>>2]|0;h=k|0;g=c[h>>2]|0;c[r>>2]=g;if((g|0)!=0){c[g+8>>2]=s}g=s+8|0;c[k+8>>2]=c[g>>2];r=c[g>>2]|0;f=r|0;if((c[f>>2]|0)==(s|0)){c[f>>2]=k}else{c[r+4>>2]=k}c[h>>2]=s;c[g>>2]=k;return}}function e3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function e4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function e5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=b|0;f=c[e>>2]|0;g=b+4|0;h=c[g>>2]|0;i=d+4|0;j=c[i>>2]|0;do{if((h|0)==(f|0)){k=f;l=j}else{m=h;n=j;L2:while(1){o=n-12|0;p=m-12|0;do{if((o|0)!=0){q=p;if((a[q]&1)==0){r=o;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];break}q=c[m-12+8>>2]|0;r=c[m-12+4>>2]|0;if(r>>>0>4294967279>>>0){s=6;break L2}if(r>>>0<11>>>0){a[o]=r<<1;t=o+1|0}else{u=r+16&-16;v=Lu(u)|0;c[n-12+8>>2]=v;c[o>>2]=u|1;c[n-12+4>>2]=r;t=v}LF(t|0,q|0,r)|0;a[t+r|0]=0}}while(0);w=(c[i>>2]|0)-12|0;c[i>>2]=w;if((p|0)==(f|0)){s=12;break}else{m=p;n=w}}if((s|0)==6){D5(0)}else if((s|0)==12){k=c[e>>2]|0;l=w;break}}}while(0);c[e>>2]=l;c[i>>2]=k;k=d+8|0;l=c[g>>2]|0;c[g>>2]=c[k>>2];c[k>>2]=l;l=b+8|0;b=d+12|0;k=c[l>>2]|0;c[l>>2]=c[b>>2];c[b>>2]=k;c[d>>2]=c[i>>2];return}function e6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+24|0;f=e|0;g=b+8|0;h=g;j=c[b>>2]|0;k=((c[b+4>>2]|0)-j|0)/12|0;l=k+1|0;if(l>>>0>357913941>>>0){IU(0)}m=((c[g>>2]|0)-j|0)/12|0;if(m>>>0>178956969>>>0){j=f+12|0;c[j>>2]=0;c[f+16>>2]=h;n=357913941;o=j;p=6}else{j=m<<1;m=j>>>0<l>>>0?l:j;j=f+12|0;c[j>>2]=0;c[f+16>>2]=h;if((m|0)==0){q=0;r=0;s=j}else{n=m;o=j;p=6}}if((p|0)==6){q=Lu(n*12|0)|0;r=n;s=o}o=f|0;c[o>>2]=q;n=q+(k*12|0)|0;j=f+8|0;c[j>>2]=n;m=f+4|0;c[m>>2]=n;c[s>>2]=q+(r*12|0);do{if((n|0)==0){t=0;p=18}else{r=d;if((a[r]&1)==0){s=n;c[s>>2]=c[r>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];t=n;p=18;break}r=c[d+8>>2]|0;s=c[d+4>>2]|0;if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}if(s>>>0<11>>>0){a[n]=s<<1;u=n+1|0}else{h=s+16&-16;l=(z=0,au(248,h|0)|0);if(z){z=0;break}c[q+(k*12|0)+8>>2]=l;c[n>>2]=h|1;c[q+(k*12|0)+4>>2]=s;u=l}LF(u|0,r|0,s)|0;a[u+s|0]=0;t=c[j>>2]|0;p=18}}while(0);do{if((p|0)==18){c[j>>2]=t+12;z=0;as(476,b|0,f|0);if(z){z=0;break}u=c[m>>2]|0;k=c[j>>2]|0;if((u|0)!=(k|0)){q=k;while(1){k=q-12|0;c[j>>2]=k;if((a[k]&1)!=0){Lw(c[q-12+8>>2]|0)}if((u|0)==(k|0)){break}else{q=k}}}q=c[o>>2]|0;if((q|0)==0){i=e;return}Lw(q);i=e;return}}while(0);e=bT(-1,-1)|0;f=c[m>>2]|0;m=c[j>>2]|0;if((f|0)!=(m|0)){b=m;while(1){m=b-12|0;c[j>>2]=m;if((a[m]&1)!=0){Lw(c[b-12+8>>2]|0)}if((f|0)==(m|0)){break}else{b=m}}}b=c[o>>2]|0;if((b|0)==0){bg(e|0)}Lw(b);bg(e|0)}function e7(a,b){a=a|0;b=b|0;return}function e8(a,b){a=a|0;b=b|0;return}function e9(a,b){a=a|0;b=b|0;if((b|0)==0){return}e9(a,c[b>>2]|0);e9(a,c[b+4>>2]|0);a=b+16|0;z=0;ar(c[c[a>>2]>>2]|0,a|0);if(z){z=0;a=bT(-1,-1)|0;bH(a|0)}Lw(b);return}function fa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aq(20,m|0,k|0,l|0,0,0);if(z){z=0;l=bT(-1,-1)|0;if((a[k]&1)==0){bg(l|0)}Lw(c[k+8>>2]|0);bg(l|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}c[b>>2]=21072;c[b+32>>2]=f;c[b+36>>2]=g;c[b+40>>2]=h;f=(g|0)!=0;if(f){if((a[g+28|0]&1)==0){r=14}else{r=16}}else{r=14}do{if((r|0)==14){if((h|0)==0){break}if((a[h+28|0]&1)!=0){r=16}}}while(0);if((r|0)==16){a[b+28|0]=1}if(f){if((a[g+29|0]&1)==0){r=21}}else{r=21}do{if((r|0)==21){if((h|0)==0){i=j;return}if((a[h+29|0]&1)!=0){break}i=j;return}}while(0);a[b+29|0]=1;i=j;return}function fb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=d;if((a[l]&1)==0){m=k;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=a[m]|0;o=m}else{m=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){D5(0)}if(l>>>0<11>>>0){d=l<<1&255;p=k;a[p]=d;q=k+1|0;r=d;s=p}else{p=l+16&-16;d=Lu(p)|0;c[k+8>>2]=d;t=p|1;c[k>>2]=t;c[k+4>>2]=l;q=d;r=t&255;s=k}LF(q|0,m|0,l)|0;a[q+l|0]=0;n=r;o=s}s=e;e=j;c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];s=j;j=b|0;c[j>>2]=17512;e=b+4|0;L12:do{if((n&1)==0){r=e;c[r>>2]=c[o>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2]}else{r=c[k+8>>2]|0;l=c[k+4>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(l>>>0<11>>>0){a[e]=l<<1;u=e+1|0}else{q=l+16&-16;m=(z=0,au(248,q|0)|0);if(z){z=0;break}c[b+12>>2]=m;c[e>>2]=q|1;c[b+8>>2]=l;u=m}LF(u|0,r|0,l)|0;a[u+l|0]=0;break L12}}while(0);l=bT(-1,-1)|0;if((a[o]&1)==0){bg(l|0)}Lw(r);bg(l|0)}}while(0);u=b+16|0;c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];if((a[o]&1)==0){c[j>>2]=17376;v=b+28|0;w=f&1;a[v]=w;x=b+29|0;y=g&1;a[x]=y;i=h;return}Lw(c[k+8>>2]|0);c[j>>2]=17376;v=b+28|0;w=f&1;a[v]=w;x=b+29|0;y=g&1;a[x]=y;i=h;return}function fc(b,d){b=b|0;d=d|0;if((d|0)==0){return}fc(b,c[d>>2]|0);fc(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){Lw(c[d+24>>2]|0)}Lw(d);return}function fd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aq(20,k|0,h|0,j|0,0,0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}h=b+32|0;c[h>>2]=22640;k=b+36|0;c[k>>2]=0;j=b+40|0;c[j>>2]=0;n=b+44|0;c[n>>2]=0;if((f|0)==0){v=b|0;c[v>>2]=20768;c[h>>2]=20824;w=b+52|0;x=w|0;c[x>>2]=0;y=b+56|0;c[y>>2]=0;A=w;B=b+48|0;c[B>>2]=A;i=g;return}m=(z=0,au(248,f<<2|0)|0);if(!z){e=m;c[k>>2]=e;c[j>>2]=e;c[n>>2]=e+(f<<2);v=b|0;c[v>>2]=20768;c[h>>2]=20824;w=b+52|0;x=w|0;c[x>>2]=0;y=b+56|0;c[y>>2]=0;A=w;B=b+48|0;c[B>>2]=A;i=g;return}else{z=0}g=bT(-1,-1)|0;A=g;g=M;c[b>>2]=17512;if((a[b+4|0]&1)==0){p=g;q=A;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b+12>>2]|0);p=g;q=A;r=q;s=0;t=r;u=p;bg(t|0)}function fe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=b|0;c[j>>2]=17512;k=b+4|0;l=d+4|0;if((a[l]&1)==0){m=k;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+12>>2]|0;m=c[d+8>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[k]=m<<1;n=k+1|0}else{o=m+16&-16;p=Lu(o)|0;c[b+12>>2]=p;c[k>>2]=o|1;c[b+8>>2]=m;n=p}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=b+16|0;n=d+16|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[j>>2]=17376;a[b+28|0]=a[d+28|0]&1;a[b+29|0]=a[d+29|0]&1;n=b+32|0;c[n>>2]=22640;z=0;as(234,b+36|0,d+36|0);do{if(!z){c[j>>2]=20768;c[n>>2]=20824;m=b+48|0;l=m|0;p=b+52|0;c[p>>2]=0;o=b+56|0;c[o>>2]=0;q=p;c[l>>2]=q;p=c[d+48>>2]|0;r=d+52|0;if((p|0)==(r|0)){i=e;return}s=g|0;t=h|0;u=b+52|0;v=p;while(1){p=v+16|0;c[s>>2]=q;w=(z=0,aU(36,m|0,g|0,f|0,p|0)|0);if(z){z=0;break}if((c[w>>2]|0)==0){z=0;aR(184,h|0,m|0,p|0);if(z){z=0;break}p=c[t>>2]|0;c[t>>2]=0;x=c[f>>2]|0;y=p|0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=x;c[w>>2]=y;x=c[c[l>>2]>>2]|0;if((x|0)==0){A=y}else{c[l>>2]=x;A=c[w>>2]|0}e2(c[u>>2]|0,A);c[o>>2]=(c[o>>2]|0)+1}w=c[v+4>>2]|0;if((w|0)==0){x=v|0;while(1){y=c[x+8>>2]|0;if((x|0)==(c[y>>2]|0)){B=y;break}else{x=y}}}else{x=w;while(1){y=c[x>>2]|0;if((y|0)==0){B=x;break}else{x=y}}}if((B|0)==(r|0)){C=34;break}else{v=B}}if((C|0)==34){i=e;return}v=bT(-1,-1)|0;r=M;e9(m,c[u>>2]|0);o=v;v=r;c[n>>2]=22640;r=c[b+36>>2]|0;if((r|0)==0){D=v;E=o;break}l=b+40|0;t=c[l>>2]|0;if((r|0)!=(t|0)){c[l>>2]=t+(~((t-4+(-r|0)|0)>>>2)<<2)}Lw(r);D=v;E=o}else{z=0;o=bT(-1,-1)|0;D=M;E=o}}while(0);c[j>>2]=17512;if((a[k]&1)==0){F=E;G=0;H=F;I=D;bg(H|0)}Lw(c[b+12>>2]|0);F=E;G=0;H=F;I=D;bg(H|0)}function ff(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b;b=i;i=i+4|0;i=i+7&-8;c[b>>2]=c[g>>2];g=a+4|0;h=c[b>>2]|0;do{if((h|0)!=(g|0)){b=h+16|0;if(dl(e,b)|0){break}if(!(dl(b,e)|0)){c[d>>2]=h;j=d;i=f;return j|0}b=h+4|0;k=c[b>>2]|0;if((k|0)==0){l=h|0;while(1){m=c[l+8>>2]|0;if((l|0)==(c[m>>2]|0)){n=m;break}else{l=m}}}else{l=k;while(1){m=c[l>>2]|0;if((m|0)==0){n=l;break}else{l=m}}}l=g;do{if((n|0)==(l|0)){o=k}else{if(dl(e,n+16|0)|0){o=c[b>>2]|0;break}m=g|0;p=c[m>>2]|0;if((p|0)==0){c[d>>2]=l;j=m;i=f;return j|0}else{q=p}while(1){p=q+16|0;if(dl(e,p)|0){r=q|0;m=c[r>>2]|0;if((m|0)==0){s=35;break}else{q=m;continue}}if(!(dl(p,e)|0)){s=39;break}t=q+4|0;p=c[t>>2]|0;if((p|0)==0){s=38;break}else{q=p}}if((s|0)==39){c[d>>2]=q;j=d;i=f;return j|0}else if((s|0)==38){c[d>>2]=q;j=t;i=f;return j|0}else if((s|0)==35){c[d>>2]=q;j=r;i=f;return j|0}}}while(0);if((o|0)==0){c[d>>2]=h;j=b;i=f;return j|0}else{c[d>>2]=n;j=n|0;i=f;return j|0}}}while(0);n=h|0;do{if((h|0)==(c[a>>2]|0)){u=h}else{o=c[n>>2]|0;if((o|0)==0){r=h|0;while(1){q=c[r+8>>2]|0;if((r|0)==(c[q>>2]|0)){r=q}else{v=q;break}}}else{r=o;while(1){b=c[r+4>>2]|0;if((b|0)==0){v=r;break}else{r=b}}}if(dl(v+16|0,e)|0){u=v;break}r=g|0;o=c[r>>2]|0;if((o|0)==0){c[d>>2]=g;j=r;i=f;return j|0}else{w=o}while(1){o=w+16|0;if(dl(e,o)|0){x=w|0;r=c[x>>2]|0;if((r|0)==0){s=15;break}else{w=r;continue}}if(!(dl(o,e)|0)){s=19;break}y=w+4|0;o=c[y>>2]|0;if((o|0)==0){s=18;break}else{w=o}}if((s|0)==19){c[d>>2]=w;j=d;i=f;return j|0}else if((s|0)==18){c[d>>2]=w;j=y;i=f;return j|0}else if((s|0)==15){c[d>>2]=w;j=x;i=f;return j|0}}}while(0);if((c[n>>2]|0)==0){c[d>>2]=h;j=n;i=f;return j|0}else{c[d>>2]=u;j=u+4|0;i=f;return j|0}return 0}function fg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+16|0;g=f|0;h=d+4|0;d=Lu(60)|0;j=d;k=f+8|0;l=g|0;a[l]=a[k]|0;a[l+1|0]=a[k+1|0]|0;a[l+2|0]=a[k+2|0]|0;k=g|0;g=d+16|0;if((g|0)==0){m=b|0;c[m>>2]=j;n=b+4|0;c[n>>2]=h;o=b+8|0;a[o]=1;p=b;q=p+9|0;a[q]=a[k]|0;a[q+1|0]=a[k+1|0]|0;a[q+2|0]=a[k+2|0]|0;i=f;return}l=g;c[l>>2]=17512;g=d+20|0;r=e+4|0;L4:do{if((a[r]&1)==0){c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2]}else{s=c[e+12>>2]|0;t=c[e+8>>2]|0;do{if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(t>>>0<11>>>0){a[g]=t<<1;u=d+21|0}else{v=t+16&-16;w=(z=0,au(248,v|0)|0);if(z){z=0;break}c[d+28>>2]=w;c[g>>2]=v|1;c[d+24>>2]=t;u=w}LF(u|0,s|0,t)|0;a[u+t|0]=0;break L4}}while(0);t=bT(-1,-1)|0;if((d|0)==0){bg(t|0)}Lw(d);bg(t|0)}}while(0);u=d+32|0;g=e+16|0;c[u>>2]=c[g>>2];c[u+4>>2]=c[g+4>>2];c[u+8>>2]=c[g+8>>2];a[d+44|0]=a[e+28|0]&1;a[d+45|0]=a[e+29|0]&1;c[l>>2]=21072;c[d+48>>2]=c[e+32>>2];c[d+52>>2]=c[e+36>>2];c[d+56>>2]=c[e+40>>2];m=b|0;c[m>>2]=j;n=b+4|0;c[n>>2]=h;o=b+8|0;a[o]=1;p=b;q=p+9|0;a[q]=a[k]|0;a[q+1|0]=a[k+1|0]|0;a[q+2|0]=a[k+2|0]|0;i=f;return}function fh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a|0;c[d>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;a=b+4|0;g=b|0;b=(c[a>>2]|0)-(c[g>>2]|0)|0;h=b>>2;if((h|0)==0){return}do{if(h>>>0>1073741823>>>0){z=0;ar(152,0);if(z){z=0;break}}else{i=(z=0,au(248,b|0)|0);if(z){z=0;break}j=i;c[e>>2]=j;c[d>>2]=j;c[f>>2]=j+(h<<2);i=c[g>>2]|0;k=c[a>>2]|0;if((i|0)==(k|0)){return}else{l=i;m=j}do{if((m|0)==0){n=0}else{c[m>>2]=c[l>>2];n=c[e>>2]|0}m=n+4|0;c[e>>2]=m;l=l+4|0;}while((l|0)!=(k|0));return}}while(0);l=bT(-1,-1)|0;m=c[d>>2]|0;if((m|0)==0){bg(l|0)}d=c[e>>2]|0;if((m|0)!=(d|0)){c[e>>2]=d+(~((d-4+(-m|0)|0)>>>2)<<2)}Lw(m);bg(l|0)}function fi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=b;a[d]=0;f=b+1|0;a[f]=0;if((e|0)<0){g=-e<<1|1}else{g=e<<1}e=b+8|0;h=b+4|0;i=b|0;j=g;g=0;while(1){k=j&31;l=j>>5;m=(l|0)>0;n=a[(c[9328]|0)+(m?k|32:k)|0]|0;if((g&1)==0){o=(g&255)>>>1;p=10}else{o=c[h>>2]|0;p=(c[i>>2]&-2)-1|0}if((o|0)==(p|0)){z=0;aI(46,b|0,p|0,1,p|0,p|0,0,0);if(z){z=0;break}q=a[d]|0}else{q=g}if((q&1)==0){a[d]=(o<<1)+2;r=f;s=o+1|0}else{k=c[e>>2]|0;t=o+1|0;c[h>>2]=t;r=k;s=t}a[r+o|0]=n;a[r+s|0]=0;if(!m){u=18;break}j=l;g=a[d]|0}if((u|0)==18){return}u=bT(-1,-1)|0;if((a[d]&1)==0){bg(u|0)}Lw(c[e>>2]|0);bg(u|0)}function fj(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ee=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0,ep=0,eq=0,er=0,es=0,et=0,eu=0,ev=0,ew=0,ex=0,ey=0,ez=0,eA=0,eB=0,eC=0,eD=0,eE=0,eF=0,eG=0,eH=0,eI=0,eJ=0,eK=0,eL=0,eM=0,eN=0,eO=0,eP=0,eQ=0,eR=0,eS=0,eT=0,eU=0,eV=0,eW=0,eX=0,eY=0,eZ=0,e_=0,e$=0,e0=0,e1=0,e2=0,e3=0,e4=0,e5=0,e6=0,e7=0,e8=0,e9=0,fa=0,fb=0,fc=0,fd=0,fe=0,ff=0,fg=0,fh=0,fi=0,fj=0,fk=0,fl=0,fm=0,fn=0,fo=0,fq=0,fr=0,ft=0,fu=0,fv=0,fw=0,fx=0,fy=0,fz=0,fA=0,fB=0,fC=0,fD=0,fE=0,fF=0,fG=0,fH=0,fI=0,fK=0,fL=0,fM=0,fN=0,fO=0,fP=0,fQ=0,fR=0,fS=0,fT=0,fU=0,fV=0,fW=0,fX=0,fY=0,fZ=0,f_=0,f$=0,f0=0,f1=0,f2=0,f3=0,f4=0,f5=0,f6=0,f7=0,f8=0,f9=0,ga=0,gb=0,gc=0,gd=0,ge=0,gf=0,gg=0,gh=0,gi=0,gj=0,gk=0,gl=0,gm=0,gn=0,go=0,gp=0,gq=0,gr=0,gs=0,gt=0,gu=0,gv=0,gw=0,gx=0,gy=0,gz=0,gA=0,gB=0,gC=0,gD=0,gE=0,gF=0,gG=0,gH=0,gI=0,gJ=0,gK=0,gL=0,gM=0,gN=0,gO=0,gP=0,gQ=0,gR=0,gS=0,gT=0,gU=0,gV=0,gW=0,gX=0,gY=0,gZ=0,g_=0,g$=0,g0=0,g1=0,g2=0,g3=0,g4=0,g5=0,g6=0,g7=0,g8=0,g9=0,ha=0,hb=0,hc=0,hd=0,he=0,hf=0,hg=0,hh=0;j=i;i=i+128|0;k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+48|0;p=j+56|0;q=j+72|0;r=j+80|0;s=j+96|0;t=j+104|0;u=j+112|0;v=u;w=i;i=i+12|0;i=i+7&-8;x=w;y=i;i=i+12|0;i=i+7&-8;A=y;B=i;i=i+12|0;i=i+7&-8;C=B;D=i;i=i+12|0;i=i+7&-8;E=D;F=i;i=i+12|0;i=i+7&-8;G=F;H=i;i=i+12|0;i=i+7&-8;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+144|0;K=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+12|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+12|0;i=i+7&-8;T=i;i=i+12|0;i=i+7&-8;U=i;i=i+12|0;i=i+7&-8;V=i;i=i+12|0;i=i+7&-8;W=i;i=i+12|0;i=i+7&-8;X=i;i=i+12|0;i=i+7&-8;Y=i;i=i+12|0;i=i+7&-8;Z=i;i=i+12|0;i=i+7&-8;_=i;i=i+144|0;$=i;i=i+12|0;i=i+7&-8;aa=i;i=i+12|0;i=i+7&-8;ab=i;i=i+12|0;i=i+7&-8;ac=i;i=i+12|0;i=i+7&-8;ad=i;i=i+12|0;i=i+7&-8;ae=i;i=i+12|0;i=i+7&-8;af=i;i=i+144|0;ag=i;i=i+12|0;i=i+7&-8;ah=i;i=i+12|0;i=i+7&-8;ai=i;i=i+12|0;i=i+7&-8;aj=i;i=i+12|0;i=i+7&-8;ak=i;i=i+12|0;i=i+7&-8;al=i;i=i+144|0;am=i;i=i+12|0;i=i+7&-8;an=i;i=i+12|0;i=i+7&-8;ao=i;i=i+12|0;i=i+7&-8;ap=i;i=i+12|0;i=i+7&-8;aq=i;i=i+12|0;i=i+7&-8;at=i;i=i+144|0;av=i;i=i+12|0;i=i+7&-8;aw=i;i=i+12|0;i=i+7&-8;ax=i;i=i+12|0;i=i+7&-8;ay=i;i=i+12|0;i=i+7&-8;aA=i;i=i+12|0;i=i+7&-8;aB=i;i=i+8|0;aC=i;i=i+12|0;i=i+7&-8;aE=i;i=i+12|0;i=i+7&-8;aF=i;i=i+12|0;i=i+7&-8;aG=i;i=i+12|0;i=i+7&-8;aH=i;i=i+144|0;aI=i;i=i+12|0;i=i+7&-8;aJ=i;i=i+12|0;i=i+7&-8;aK=i;i=i+12|0;i=i+7&-8;aL=i;i=i+12|0;i=i+7&-8;aN=H|0;aO=H+4|0;c[aO>>2]=0;c[H+8>>2]=0;c[H>>2]=aO;aO=d+36|0;aP=c[aO>>2]|0;aQ=d+32|0;d=c[aQ>>2]|0;aS=aP-d>>2;do{if((aS|0)==0){aT=aP;aU=d;aV=28}else{aW=I;aX=I+8|0;aY=I+1|0;aZ=I|0;a_=I+4|0;a$=0;a0=d;while(1){a1=c[a0+(a$<<2)>>2]|0;a2=a1+28|0;if((a[a2]&1)==0){c[aW>>2]=c[a2>>2];c[aW+4>>2]=c[a2+4>>2];c[aW+8>>2]=c[a2+8>>2]}else{a2=c[a1+36>>2]|0;a3=c[a1+32>>2]|0;if(a3>>>0>4294967279>>>0){aV=6;break}if(a3>>>0<11>>>0){a[aW]=a3<<1;a4=aY}else{a5=a3+16&-16;a6=(z=0,au(248,a5|0)|0);if(z){z=0;aV=22;break}c[aX>>2]=a6;c[aZ>>2]=a5|1;c[a_>>2]=a3;a4=a6}LF(a4|0,a2|0,a3)|0;a[a4+a3|0]=0}a3=(z=0,aM(144,H|0,I|0)|0);if(z){z=0;aV=25;break}c[a3>>2]=a1;if((a[aW]&1)!=0){Lw(c[aX>>2]|0)}a1=a$+1|0;if(a1>>>0>=aS>>>0){aV=27;break}a$=a1;a0=c[aQ>>2]|0}if((aV|0)==22){a0=bT(-1,-1)|0;a7=M;a8=a0;break}else if((aV|0)==6){z=0;ar(86,0);if(z){z=0;aV=23;break}}else if((aV|0)==27){aT=c[aO>>2]|0;aU=c[aQ>>2]|0;aV=28;break}else if((aV|0)==25){a0=bT(-1,-1)|0;a$=a0;a0=M;if((a[aW]&1)==0){a9=a0;ba=a$;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}Lw(c[aX>>2]|0);a9=a0;ba=a$;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}}}while(0);L30:do{if((aV|0)==28){aO=aT-aU>>2;aS=e+40|0;I=(c[e+44>>2]|0)-(c[aS>>2]|0)>>2;L32:do{if((I|0)==0){bj=0;aV=31}else{a4=f+4|0;d=f+8|0;aP=f|0;a$=W;a0=X;a_=X+1|0;aZ=W+8|0;aY=X+8|0;a1=W+1|0;a3=W|0;a2=W+4|0;a6=Y;a5=ae;bk=af+64|0;bl=bk|0;bm=af|0;bn=af+8|0;bo=bn|0;bp=af+12|0;bq=af+64|0;br=af+4|0;bs=bp;bt=af+8|0;bu=bp|0;bv=af+16|0;bw=af+20|0;bx=af+60|0;by=bn;bn=ag;bz=ai;bA=aj;bB=ah;bC=af+12|0;bD=af+44|0;bE=af+64|0;bF=af+52|0;bG=ah+8|0;bH=ai+8|0;bI=ai+1|0;bJ=ai|0;bK=ai+4|0;bL=ag+8|0;bM=ag+1|0;bN=ag|0;bO=ag+4|0;bP=B+8|0;bQ=ak;bR=aq;bS=g|0;bU=g|0;bV=aA;bW=aA+8|0;bY=aA+1|0;bZ=aA|0;b_=aA+4|0;b$=at+64|0;b0=b$|0;b1=at|0;b2=at+8|0;b3=b2|0;b4=at+12|0;b5=at+64|0;b6=at+4|0;b7=b4;b8=at+8|0;b9=b4|0;ca=at+16|0;cb=at+20|0;cc=at+60|0;cd=b2;b2=av;ce=ax;cf=ay;cg=aw;ch=at+12|0;ci=at+44|0;cj=at+64|0;ck=at+52|0;cl=aw+8|0;cm=ax+8|0;cn=ax+1|0;co=ax|0;cp=ax+4|0;cq=av+8|0;cr=av+1|0;cs=av|0;ct=av+4|0;cu=w+8|0;cv=aq+8|0;cw=aq+1|0;cx=aq|0;cy=aq+4|0;cz=al+64|0;cA=cz|0;cB=al|0;cC=al+8|0;cD=cC|0;cE=al+12|0;cF=al+64|0;cG=al+4|0;cH=cE;cI=al+8|0;cJ=cE|0;cK=al+16|0;cL=al+20|0;cM=al+60|0;cN=cC;cC=am;cO=ao;cP=ap;cQ=an;cR=al+12|0;cS=al+44|0;cT=al+64|0;cU=al+52|0;cV=an+8|0;cW=ao+8|0;cX=ao+1|0;cY=ao|0;cZ=ao+4|0;c_=am+8|0;c$=am+1|0;c0=am|0;c1=am+4|0;c2=y+8|0;c3=ak+8|0;c4=ak+1|0;c5=ak|0;c6=ak+4|0;c7=ae+8|0;c8=ae+1|0;c9=ae|0;da=ae+4|0;db=Y+8|0;dc=Y+4|0;dd=Y+1|0;de=Y|0;df=J+64|0;dg=df|0;dh=J|0;di=J+8|0;dj=di|0;dk=J+12|0;dl=J+64|0;dm=J+4|0;dn=dk;dp=J+8|0;dq=dk|0;dr=J+16|0;ds=J+20|0;dt=J+60|0;du=di;di=e+4|0;dv=L;dw=N;dx=e+16|0;dy=K;dz=J+12|0;dA=J+44|0;dB=J+64|0;dC=J+52|0;dD=K+8|0;dE=L+8|0;dF=e+12|0;dG=e+8|0;dH=L+1|0;dI=L|0;dJ=L+4|0;dK=F+8|0;dL=Z;dM=ad;dN=ad+8|0;dO=ad+1|0;dP=ad|0;dQ=ad+4|0;dR=_+64|0;dS=dR|0;dT=_|0;dU=_+8|0;dV=dU|0;dW=_+12|0;dX=_+64|0;dY=_+4|0;dZ=dW;d_=_+8|0;d$=dW|0;d0=_+16|0;d1=_+20|0;d2=_+60|0;d3=dU;dU=$;d4=ab;d5=ac;d6=aa;d7=_+12|0;d8=_+44|0;d9=_+64|0;ea=_+52|0;eb=aa+8|0;ec=ab+8|0;ed=ab+1|0;ee=ab|0;ef=ab+4|0;eg=$+8|0;eh=$+1|0;ei=$|0;ej=$+4|0;ek=D+8|0;el=Z+8|0;em=Z+1|0;en=Z|0;eo=Z+4|0;ep=J+44|0;eq=af+44|0;er=al+44|0;es=at+44|0;et=_+44|0;eu=0;ev=0;L34:while(1){ew=eu>>>0<aO>>>0;ex=eu+1|0;ey=ev;while(1){if(!ew){c[dj>>2]=15464;c[dh>>2]=32540;c[dl>>2]=32560;c[dm>>2]=0;z=0;as(198,J+64|0,dn|0);if(z){z=0;aV=44;break L34}c[J+136>>2]=0;c[J+140>>2]=-1;c[dh>>2]=15444;c[dg>>2]=15484;c[dj>>2]=15464;c[dq>>2]=15768;I_(dr);LI(ds|0,0,24)|0;c[dq>>2]=15624;LI(ep|0,0,16)|0;c[dt>>2]=24;LI(G|0,0,12)|0;z=0;as(212,dk|0,F|0);if(z){z=0;aV=38;break L34}if((a[G]&1)!=0){Lw(c[dK>>2]|0)}ez=(z=0,aM(814,du|0,b|0)|0);if(z){z=0;aV=76;break L34}eA=(z=0,aM(114,ez|0,11792)|0);if(z){z=0;aV=76;break L34}ez=(z=0,aM(312,eA|0,aO|0)|0);if(z){z=0;aV=76;break L34}eA=(z=0,aM(114,ez|0,12296)|0);if(z){z=0;aV=76;break L34}ez=(z=0,aM(114,eA|0,9416)|0);if(z){z=0;aV=76;break L34}z=0,aM(312,ez|0,I|0)|0;if(z){z=0;aV=76;break L34}z=0;as(576,K|0,dk|0);if(z){z=0;aV=76;break L34}if((a[di]&1)==0){c[dv>>2]=c[di>>2];c[dv+4>>2]=c[di+4>>2];c[dv+8>>2]=c[di+8>>2]}else{ez=c[dF>>2]|0;eA=c[dG>>2]|0;if(eA>>>0>4294967279>>>0){aV=58;break L34}if(eA>>>0<11>>>0){a[dv]=eA<<1;eB=dH}else{eC=eA+16&-16;eD=(z=0,au(248,eC|0)|0);if(z){z=0;aV=77;break L34}c[dE>>2]=eD;c[dI>>2]=eC|1;c[dJ>>2]=eA;eB=eD}LF(eB|0,ez|0,eA)|0;a[eB+eA|0]=0}c[dw>>2]=c[dx>>2];c[dw+4>>2]=c[dx+4>>2];c[dw+8>>2]=c[dx+8>>2];z=0;aR(382,K|0,L|0,N|0);if(z){z=0;aV=80;break L34}if((a[dv]&1)!=0){Lw(c[dE>>2]|0)}if((a[dy]&1)!=0){Lw(c[dD>>2]|0)}c[dh>>2]=15444;c[dl>>2]=15484;c[dp>>2]=15464;c[dz>>2]=15624;if((a[dA]&1)!=0){Lw(c[dC>>2]|0)}c[dz>>2]=15768;z=0;ar(394,dr|0);if(z){z=0;aV=74;break L34}z=0;ar(272,dB|0);if(z){z=0;aV=20;break L34}}eE=c[(c[aQ>>2]|0)+(eu<<2)>>2]|0;eF=c[(c[aS>>2]|0)+(ey<<2)>>2]|0;eG=(a[eF+52|0]&1)!=0;if((a[eE+44|0]&1)!=0){aV=91;break L34}do{if(eG){eA=c[eF+36>>2]|0;ez=eA+44|0;eD=ez;eC=eA+40|0;eH=c[eC>>2]|0;if((c[eD>>2]|0)==(eH|0)){bj=eu;aV=31;break L32}eI=eA+56|0;eA=c[eH>>2]|0;do{if((a[eI]&1)==0){eH=(z=0,au(248,56)|0);if(z){z=0;aV=20;break L34}eJ=eH;c[n>>2]=eJ;eH=c[a4>>2]|0;if((eH|0)==(c[d>>2]|0)){z=0;as(382,aP|0,n|0);if(z){z=0;aV=20;break L34}eK=c[n>>2]|0}else{if((eH|0)==0){eL=0}else{c[eH>>2]=eJ;eL=c[a4>>2]|0}c[a4>>2]=eL+4;eK=eJ}eM=eK;eJ=eK;eH=eA+4|0;if((a[eH]&1)==0){c[a$>>2]=c[eH>>2];c[a$+4>>2]=c[eH+4>>2];c[a$+8>>2]=c[eH+8>>2]}else{eH=c[eA+12>>2]|0;eN=c[eA+8>>2]|0;if(eN>>>0>4294967279>>>0){aV=267;break L34}if(eN>>>0<11>>>0){a[a$]=eN<<1;eO=a1}else{eP=eN+16&-16;eQ=(z=0,au(248,eP|0)|0);if(z){z=0;aV=279;break L34}c[aZ>>2]=eQ;c[a3>>2]=eP|1;c[a2>>2]=eN;eO=eQ}LF(eO|0,eH|0,eN)|0;a[eO+eN|0]=0}eN=eA+16|0;eH=m;c[eH>>2]=c[eN>>2];c[eH+4>>2]=c[eN+4>>2];c[eH+8>>2]=c[eN+8>>2];a[a0]=0;a[a_]=0;z=0;aD(30,eJ|0,W|0,m|0,eA|0,X|0,0);if(z){z=0;aV=282;break L34}if((a[a0]&1)!=0){Lw(c[aY>>2]|0)}if((a[a$]&1)==0){eR=eJ;break}Lw(c[aZ>>2]|0);eR=eJ}else{eR=eA}}while(0);eA=c[eC>>2]|0;eJ=eA+4|0;eN=(c[eD>>2]|0)-eJ|0;LG(eA|0,eJ|0,eN|0)|0;eJ=eA+(eN>>2<<2)|0;eN=c[eD>>2]|0;if((eJ|0)!=(eN|0)){eA=eN;do{eA=eA-4|0;c[ez>>2]=eA;}while((eJ|0)!=(eA|0))}if((eJ|0)!=(c[eC>>2]|0)){if((a[eI]&1)!=0|(ex|0)!=(aO|0)){eS=eR;eT=ey;break}}eS=eR;eT=ey+1|0}else{eS=eF;eT=ey+1|0}}while(0);eA=eS+40|0;if((a[eA]&1)==0){c[a6>>2]=c[eA>>2];c[a6+4>>2]=c[eA+4>>2];c[a6+8>>2]=c[eA+8>>2];eU=a[a6]|0}else{ez=c[eS+48>>2]|0;eD=c[eS+44>>2]|0;if(eD>>>0>4294967279>>>0){aV=301;break L34}if(eD>>>0<11>>>0){eN=eD<<1&255;a[a6]=eN;eV=dd;eW=eN}else{eN=eD+16&-16;eH=(z=0,au(248,eN|0)|0);if(z){z=0;aV=20;break L34}c[db>>2]=eH;eQ=eN|1;c[de>>2]=eQ;c[dc>>2]=eD;eV=eH;eW=eQ&255}LF(eV|0,ez|0,eD)|0;a[eV+eD|0]=0;eU=eW}eD=eU&255;ez=(eD&1|0)==0?eD>>>1:c[dc>>2]|0;if((eU&1)!=0){Lw(c[db>>2]|0)}if((ez|0)==0){break}if((a[eA]&1)==0){c[a5>>2]=c[eA>>2];c[a5+4>>2]=c[eA+4>>2];c[a5+8>>2]=c[eA+8>>2];eX=a[a5]|0}else{ez=c[eS+48>>2]|0;eD=c[eS+44>>2]|0;if(eD>>>0>4294967279>>>0){aV=413;break L34}if(eD>>>0<11>>>0){eQ=eD<<1&255;a[a5]=eQ;eY=c8;eZ=eQ}else{eQ=eD+16&-16;eH=(z=0,au(248,eQ|0)|0);if(z){z=0;aV=20;break L34}c[c7>>2]=eH;eN=eQ|1;c[c9>>2]=eN;c[da>>2]=eD;eY=eH;eZ=eN&255}LF(eY|0,ez|0,eD)|0;a[eY+eD|0]=0;eX=eZ}eD=fp(aN,ae)|0;if((eX&1)!=0){Lw(c[c7>>2]|0)}if((eD|0)==0){c[bo>>2]=15464;c[bm>>2]=32540;c[bq>>2]=32560;c[br>>2]=0;z=0;as(198,af+64|0,bs|0);if(z){z=0;aV=433;break L34}c[af+136>>2]=0;c[af+140>>2]=-1;c[bm>>2]=15444;c[bl>>2]=15484;c[bo>>2]=15464;c[bu>>2]=15768;I_(bv);LI(bw|0,0,24)|0;c[bu>>2]=15624;LI(eq|0,0,16)|0;c[bx>>2]=24;LI(C|0,0,12)|0;z=0;as(212,bp|0,B|0);if(z){z=0;aV=427;break L34}if((a[C]&1)!=0){Lw(c[bP>>2]|0)}eD=(z=0,aM(814,by|0,b|0)|0);if(z){z=0;aV=474;break L34}ez=(z=0,aM(114,eD|0,3512)|0);if(z){z=0;aV=474;break L34}if((a[eA]&1)==0){c[bn>>2]=c[eA>>2];c[bn+4>>2]=c[eA+4>>2];c[bn+8>>2]=c[eA+8>>2]}else{eD=c[eS+48>>2]|0;eN=c[eS+44>>2]|0;if(eN>>>0>4294967279>>>0){aV=442;break L34}if(eN>>>0<11>>>0){a[bn]=eN<<1;e_=bM}else{eH=eN+16&-16;eQ=(z=0,au(248,eH|0)|0);if(z){z=0;aV=474;break L34}c[bL>>2]=eQ;c[bN>>2]=eH|1;c[bO>>2]=eN;e_=eQ}LF(e_|0,eD|0,eN)|0;a[e_+eN|0]=0}z=0,aM(814,ez|0,ag|0)|0;if(z){z=0;aV=477;break L34}if((a[bn]&1)!=0){Lw(c[bL>>2]|0)}z=0;as(576,ah|0,bp|0);if(z){z=0;aV=474;break L34}ez=eS+4|0;if((a[ez]&1)==0){c[bz>>2]=c[ez>>2];c[bz+4>>2]=c[ez+4>>2];c[bz+8>>2]=c[ez+8>>2]}else{ez=c[eS+12>>2]|0;eN=c[eS+8>>2]|0;if(eN>>>0>4294967279>>>0){aV=456;break L34}if(eN>>>0<11>>>0){a[bz]=eN<<1;e$=bI}else{eD=eN+16&-16;eQ=(z=0,au(248,eD|0)|0);if(z){z=0;aV=479;break L34}c[bH>>2]=eQ;c[bJ>>2]=eD|1;c[bK>>2]=eN;e$=eQ}LF(e$|0,ez|0,eN)|0;a[e$+eN|0]=0}eN=eS+16|0;c[bA>>2]=c[eN>>2];c[bA+4>>2]=c[eN+4>>2];c[bA+8>>2]=c[eN+8>>2];z=0;aR(382,ah|0,ai|0,aj|0);if(z){z=0;aV=482;break L34}if((a[bz]&1)!=0){Lw(c[bH>>2]|0)}if((a[bB]&1)!=0){Lw(c[bG>>2]|0)}c[bm>>2]=15444;c[bq>>2]=15484;c[bt>>2]=15464;c[bC>>2]=15624;if((a[bD]&1)!=0){Lw(c[bF>>2]|0)}c[bC>>2]=15768;z=0;ar(394,bv|0);if(z){z=0;aV=472;break L34}z=0;ar(272,bE|0);if(z){z=0;aV=20;break L34}}if((a[eA]&1)==0){c[bQ>>2]=c[eA>>2];c[bQ+4>>2]=c[eA+4>>2];c[bQ+8>>2]=c[eA+8>>2]}else{eN=c[eS+48>>2]|0;ez=c[eS+44>>2]|0;if(ez>>>0>4294967279>>>0){aV=495;break L34}if(ez>>>0<11>>>0){a[bQ]=ez<<1;e0=c4}else{eQ=ez+16&-16;eD=(z=0,au(248,eQ|0)|0);if(z){z=0;aV=20;break L34}c[c3>>2]=eD;c[c5>>2]=eQ|1;c[c6>>2]=ez;e0=eD}LF(e0|0,eN|0,ez)|0;a[e0+ez|0]=0}ez=(z=0,aM(144,H|0,ak|0)|0);if(z){z=0;aV=559;break L34}eN=(a[(c[ez>>2]|0)+44|0]&1)==0;if((a[bQ]&1)!=0){Lw(c[c3>>2]|0)}if(!eN){c[cD>>2]=15464;c[cB>>2]=32540;c[cF>>2]=32560;c[cG>>2]=0;z=0;as(198,al+64|0,cH|0);if(z){z=0;aV=516;break L34}c[al+136>>2]=0;c[al+140>>2]=-1;c[cB>>2]=15444;c[cA>>2]=15484;c[cD>>2]=15464;c[cJ>>2]=15768;I_(cK);LI(cL|0,0,24)|0;c[cJ>>2]=15624;LI(er|0,0,16)|0;c[cM>>2]=24;LI(A|0,0,12)|0;z=0;as(212,cE|0,y|0);if(z){z=0;aV=510;break L34}if((a[A]&1)!=0){Lw(c[c2>>2]|0)}eN=(z=0,aM(114,cN|0,2136)|0);if(z){z=0;aV=561;break L34}if((a[eA]&1)==0){c[cC>>2]=c[eA>>2];c[cC+4>>2]=c[eA+4>>2];c[cC+8>>2]=c[eA+8>>2]}else{ez=c[eS+48>>2]|0;eD=c[eS+44>>2]|0;if(eD>>>0>4294967279>>>0){aV=524;break L34}if(eD>>>0<11>>>0){a[cC]=eD<<1;e1=c$}else{eQ=eD+16&-16;eH=(z=0,au(248,eQ|0)|0);if(z){z=0;aV=561;break L34}c[c_>>2]=eH;c[c0>>2]=eQ|1;c[c1>>2]=eD;e1=eH}LF(e1|0,ez|0,eD)|0;a[e1+eD|0]=0}eD=(z=0,aM(814,eN|0,am|0)|0);if(z){z=0;aV=564;break L34}eN=(z=0,aM(114,eD|0,1264)|0);if(z){z=0;aV=564;break L34}eD=(z=0,aM(814,eN|0,b|0)|0);if(z){z=0;aV=564;break L34}z=0,aM(114,eD|0,576)|0;if(z){z=0;aV=564;break L34}if((a[cC]&1)!=0){Lw(c[c_>>2]|0)}z=0;as(576,an|0,cE|0);if(z){z=0;aV=561;break L34}eD=eS+4|0;if((a[eD]&1)==0){c[cO>>2]=c[eD>>2];c[cO+4>>2]=c[eD+4>>2];c[cO+8>>2]=c[eD+8>>2]}else{eD=c[eS+12>>2]|0;eN=c[eS+8>>2]|0;if(eN>>>0>4294967279>>>0){aV=541;break L34}if(eN>>>0<11>>>0){a[cO]=eN<<1;e2=cX}else{ez=eN+16&-16;eH=(z=0,au(248,ez|0)|0);if(z){z=0;aV=566;break L34}c[cW>>2]=eH;c[cY>>2]=ez|1;c[cZ>>2]=eN;e2=eH}LF(e2|0,eD|0,eN)|0;a[e2+eN|0]=0}eN=eS+16|0;c[cP>>2]=c[eN>>2];c[cP+4>>2]=c[eN+4>>2];c[cP+8>>2]=c[eN+8>>2];z=0;aR(382,an|0,ao|0,ap|0);if(z){z=0;aV=569;break L34}if((a[cO]&1)!=0){Lw(c[cW>>2]|0)}if((a[cQ]&1)!=0){Lw(c[cV>>2]|0)}c[cB>>2]=15444;c[cF>>2]=15484;c[cI>>2]=15464;c[cR>>2]=15624;if((a[cS]&1)!=0){Lw(c[cU>>2]|0)}c[cR>>2]=15768;z=0;ar(394,cK|0);if(z){z=0;aV=557;break L34}z=0;ar(272,cT|0);if(z){z=0;aV=20;break L34}}if((a[eA]&1)==0){c[bR>>2]=c[eA>>2];c[bR+4>>2]=c[eA+4>>2];c[bR+8>>2]=c[eA+8>>2];e3=a[bR]|0}else{eN=c[eS+48>>2]|0;eD=c[eS+44>>2]|0;if(eD>>>0>4294967279>>>0){aV=582;break L34}if(eD>>>0<11>>>0){eH=eD<<1&255;a[bR]=eH;e4=cw;e5=eH}else{eH=eD+16&-16;ez=(z=0,au(248,eH|0)|0);if(z){z=0;aV=20;break L34}c[cv>>2]=ez;eQ=eH|1;c[cx>>2]=eQ;c[cy>>2]=eD;e4=ez;e5=eQ&255}LF(e4|0,eN|0,eD)|0;a[e4+eD|0]=0;e3=e5}eD=(fs(bS,aq)|0)==0;if((e3&1)!=0){Lw(c[cv>>2]|0)}if(!eD){c[b3>>2]=15464;c[b1>>2]=32540;c[b5>>2]=32560;c[b6>>2]=0;z=0;as(198,at+64|0,b7|0);if(z){z=0;aV=602;break L34}c[at+136>>2]=0;c[at+140>>2]=-1;c[b1>>2]=15444;c[b0>>2]=15484;c[b3>>2]=15464;c[b9>>2]=15768;I_(ca);LI(cb|0,0,24)|0;c[b9>>2]=15624;LI(es|0,0,16)|0;c[cc>>2]=24;LI(x|0,0,12)|0;z=0;as(212,b4|0,w|0);if(z){z=0;aV=596;break L34}if((a[x]&1)!=0){Lw(c[cu>>2]|0)}eD=(z=0,aM(114,cd|0,5968)|0);if(z){z=0;aV=644;break L34}eN=eE+28|0;if((a[eN]&1)==0){c[b2>>2]=c[eN>>2];c[b2+4>>2]=c[eN+4>>2];c[b2+8>>2]=c[eN+8>>2]}else{eN=c[eE+36>>2]|0;eQ=c[eE+32>>2]|0;if(eQ>>>0>4294967279>>>0){aV=610;break L34}if(eQ>>>0<11>>>0){a[b2]=eQ<<1;e6=cr}else{ez=eQ+16&-16;eH=(z=0,au(248,ez|0)|0);if(z){z=0;aV=644;break L34}c[cq>>2]=eH;c[cs>>2]=ez|1;c[ct>>2]=eQ;e6=eH}LF(e6|0,eN|0,eQ)|0;a[e6+eQ|0]=0}eQ=(z=0,aM(814,eD|0,av|0)|0);if(z){z=0;aV=647;break L34}eD=(z=0,aM(114,eQ|0,13192)|0);if(z){z=0;aV=647;break L34}z=0,aM(814,eD|0,b|0)|0;if(z){z=0;aV=647;break L34}if((a[b2]&1)!=0){Lw(c[cq>>2]|0)}z=0;as(576,aw|0,b4|0);if(z){z=0;aV=644;break L34}eD=eS+4|0;if((a[eD]&1)==0){c[ce>>2]=c[eD>>2];c[ce+4>>2]=c[eD+4>>2];c[ce+8>>2]=c[eD+8>>2]}else{eD=c[eS+12>>2]|0;eQ=c[eS+8>>2]|0;if(eQ>>>0>4294967279>>>0){aV=626;break L34}if(eQ>>>0<11>>>0){a[ce]=eQ<<1;e7=cn}else{eN=eQ+16&-16;eH=(z=0,au(248,eN|0)|0);if(z){z=0;aV=649;break L34}c[cm>>2]=eH;c[co>>2]=eN|1;c[cp>>2]=eQ;e7=eH}LF(e7|0,eD|0,eQ)|0;a[e7+eQ|0]=0}eQ=eS+16|0;c[cf>>2]=c[eQ>>2];c[cf+4>>2]=c[eQ+4>>2];c[cf+8>>2]=c[eQ+8>>2];z=0;aR(382,aw|0,ax|0,ay|0);if(z){z=0;aV=652;break L34}if((a[ce]&1)!=0){Lw(c[cm>>2]|0)}if((a[cg]&1)!=0){Lw(c[cl>>2]|0)}c[b1>>2]=15444;c[b5>>2]=15484;c[b8>>2]=15464;c[ch>>2]=15624;if((a[ci]&1)!=0){Lw(c[ck>>2]|0)}c[ch>>2]=15768;z=0;ar(394,ca|0);if(z){z=0;aV=642;break L34}z=0;ar(272,cj|0);if(z){z=0;aV=20;break L34}}eQ=c[eS+36>>2]|0;if((a[eA]&1)==0){c[bV>>2]=c[eA>>2];c[bV+4>>2]=c[eA+4>>2];c[bV+8>>2]=c[eA+8>>2]}else{eA=c[eS+48>>2]|0;eD=c[eS+44>>2]|0;if(eD>>>0>4294967279>>>0){aV=665;break L34}if(eD>>>0<11>>>0){a[bV]=eD<<1;e8=bY}else{eH=eD+16&-16;eN=(z=0,au(248,eH|0)|0);if(z){z=0;aV=20;break L34}c[bW>>2]=eN;c[bZ>>2]=eH|1;c[b_>>2]=eD;e8=eN}LF(e8|0,eA|0,eD)|0;a[e8+eD|0]=0}eD=(z=0,aM(178,bU|0,aA|0)|0);if(z){z=0;aV=676;break L34}c[eD>>2]=eQ;if((a[bV]&1)!=0){Lw(c[bW>>2]|0)}if(eT>>>0<I>>>0){ey=eT}else{bj=eu;aV=31;break L32}}ew=eE+28|0;if((a[ew]&1)==0){c[dL>>2]=c[ew>>2];c[dL+4>>2]=c[ew+4>>2];c[dL+8>>2]=c[ew+8>>2];e9=a[dL]|0}else{eQ=c[eE+36>>2]|0;eD=c[eE+32>>2]|0;if(eD>>>0>4294967279>>>0){aV=314;break}if(eD>>>0<11>>>0){eA=eD<<1&255;a[dL]=eA;fa=em;fb=eA}else{eA=eD+16&-16;eN=(z=0,au(248,eA|0)|0);if(z){z=0;aV=21;break}c[el>>2]=eN;eH=eA|1;c[en>>2]=eH;c[eo>>2]=eD;fa=eN;fb=eH&255}LF(fa|0,eQ|0,eD)|0;a[fa+eD|0]=0;e9=fb}eD=(fs(bS,Z)|0)==0;if((e9&1)!=0){Lw(c[el>>2]|0)}if(!eD){c[dV>>2]=15464;c[dT>>2]=32540;c[dX>>2]=32560;c[dY>>2]=0;z=0;as(198,_+64|0,dZ|0);if(z){z=0;aV=334;break}c[_+136>>2]=0;c[_+140>>2]=-1;c[dT>>2]=15444;c[dS>>2]=15484;c[dV>>2]=15464;c[d$>>2]=15768;I_(d0);LI(d1|0,0,24)|0;c[d$>>2]=15624;LI(et|0,0,16)|0;c[d2>>2]=24;LI(E|0,0,12)|0;z=0;as(212,dW|0,D|0);if(z){z=0;aV=328;break}if((a[E]&1)!=0){Lw(c[ek>>2]|0)}eD=(z=0,aM(114,d3|0,5968)|0);if(z){z=0;aV=376;break}if((a[ew]&1)==0){c[dU>>2]=c[ew>>2];c[dU+4>>2]=c[ew+4>>2];c[dU+8>>2]=c[ew+8>>2]}else{eQ=c[eE+36>>2]|0;eH=c[eE+32>>2]|0;if(eH>>>0>4294967279>>>0){aV=342;break}if(eH>>>0<11>>>0){a[dU]=eH<<1;fc=eh}else{eN=eH+16&-16;eA=(z=0,au(248,eN|0)|0);if(z){z=0;aV=376;break}c[eg>>2]=eA;c[ei>>2]=eN|1;c[ej>>2]=eH;fc=eA}LF(fc|0,eQ|0,eH)|0;a[fc+eH|0]=0}eH=(z=0,aM(814,eD|0,$|0)|0);if(z){z=0;aV=379;break}eD=(z=0,aM(114,eH|0,4936)|0);if(z){z=0;aV=379;break}z=0,aM(814,eD|0,b|0)|0;if(z){z=0;aV=379;break}if((a[dU]&1)!=0){Lw(c[eg>>2]|0)}z=0;as(576,aa|0,dW|0);if(z){z=0;aV=376;break}eD=eS+4|0;if((a[eD]&1)==0){c[d4>>2]=c[eD>>2];c[d4+4>>2]=c[eD+4>>2];c[d4+8>>2]=c[eD+8>>2]}else{eD=c[eS+12>>2]|0;eH=c[eS+8>>2]|0;if(eH>>>0>4294967279>>>0){aV=358;break}if(eH>>>0<11>>>0){a[d4]=eH<<1;fd=ed}else{eQ=eH+16&-16;eA=(z=0,au(248,eQ|0)|0);if(z){z=0;aV=381;break}c[ec>>2]=eA;c[ee>>2]=eQ|1;c[ef>>2]=eH;fd=eA}LF(fd|0,eD|0,eH)|0;a[fd+eH|0]=0}eH=eS+16|0;c[d5>>2]=c[eH>>2];c[d5+4>>2]=c[eH+4>>2];c[d5+8>>2]=c[eH+8>>2];z=0;aR(382,aa|0,ab|0,ac|0);if(z){z=0;aV=384;break}if((a[d4]&1)!=0){Lw(c[ec>>2]|0)}if((a[d6]&1)!=0){Lw(c[eb>>2]|0)}c[dT>>2]=15444;c[dX>>2]=15484;c[d_>>2]=15464;c[d7>>2]=15624;if((a[d8]&1)!=0){Lw(c[ea>>2]|0)}c[d7>>2]=15768;z=0;ar(394,d0|0);if(z){z=0;aV=374;break}z=0;ar(272,d9|0);if(z){z=0;aV=21;break}}eH=c[eS+36>>2]|0;if((a[ew]&1)==0){c[dM>>2]=c[ew>>2];c[dM+4>>2]=c[ew+4>>2];c[dM+8>>2]=c[ew+8>>2]}else{ew=c[eE+36>>2]|0;eD=c[eE+32>>2]|0;if(eD>>>0>4294967279>>>0){aV=397;break}if(eD>>>0<11>>>0){a[dM]=eD<<1;fe=dO}else{eA=eD+16&-16;eQ=(z=0,au(248,eA|0)|0);if(z){z=0;aV=21;break}c[dN>>2]=eQ;c[dP>>2]=eA|1;c[dQ>>2]=eD;fe=eQ}LF(fe|0,ew|0,eD)|0;a[fe+eD|0]=0}eD=(z=0,aM(178,bU|0,ad|0)|0);if(z){z=0;aV=408;break}c[eD>>2]=eH;if((a[dM]&1)!=0){Lw(c[dN>>2]|0)}if(eT>>>0<I>>>0){eu=ex;ev=eT}else{bj=ex;aV=31;break L32}}do{if((aV|0)==74){ev=bT(-1,-1)|0;eu=M;z=0;ar(272,dB|0);if(!z){a7=eu;a8=ev;break L30}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==76){ev=bT(-1,-1)|0;ff=M;fg=ev;aV=84}else if((aV|0)==77){ev=bT(-1,-1)|0;fh=M;fi=ev;aV=79}else if((aV|0)==38){ev=bT(-1,-1)|0;eu=M;if((a[G]&1)!=0){Lw(c[dK>>2]|0)}if((a[dA]&1)!=0){Lw(c[dC>>2]|0)}c[dq>>2]=15768;z=0;ar(394,dr|0);if(!z){fj=eu;fk=ev;aV=45;break}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==44){ev=bT(-1,-1)|0;fj=M;fk=ev;aV=45}else if((aV|0)==21){ev=bT(-1,-1)|0;a7=M;a8=ev;break L30}else if((aV|0)==58){z=0;ar(86,0);if(z){z=0;ev=bT(-1,-1)|0;fh=M;fi=ev;aV=79;break}}else if((aV|0)==80){ev=bT(-1,-1)|0;eu=ev;ev=M;if((a[dv]&1)==0){fl=ev;fm=eu;aV=82;break}Lw(c[dE>>2]|0);fl=ev;fm=eu;aV=82}else if((aV|0)==91){if(eG){eu=eE+28|0;if((a[eu]&1)==0){ev=O;c[ev>>2]=c[eu>>2];c[ev+4>>2]=c[eu+4>>2];c[ev+8>>2]=c[eu+8>>2];fn=a[ev]|0}else{ev=c[eE+36>>2]|0;dQ=c[eE+32>>2]|0;if(dQ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}if(dQ>>>0<11>>>0){dP=dQ<<1&255;a[O]=dP;fo=O+1|0;fq=dP}else{dP=dQ+16&-16;dO=(z=0,au(248,dP|0)|0);if(z){z=0;aV=23;break L30}c[O+8>>2]=dO;d5=dP|1;c[O>>2]=d5;c[O+4>>2]=dQ;fo=dO;fq=d5&255}LF(fo|0,ev|0,dQ)|0;a[fo+dQ|0]=0;fn=fq}dQ=(fs(bS,O)|0)==0;if((fn&1)!=0){Lw(c[O+8>>2]|0)}if(dQ){dQ=c[eF+36>>2]|0;if((a[eu]&1)==0){ev=Q;c[ev>>2]=c[eu>>2];c[ev+4>>2]=c[eu+4>>2];c[ev+8>>2]=c[eu+8>>2]}else{ev=c[eE+36>>2]|0;d5=c[eE+32>>2]|0;if(d5>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}if(d5>>>0<11>>>0){a[Q]=d5<<1;fr=Q+1|0}else{dO=d5+16&-16;dP=(z=0,au(248,dO|0)|0);if(z){z=0;aV=23;break L30}c[Q+8>>2]=dP;c[Q>>2]=dO|1;c[Q+4>>2]=d5;fr=dP}LF(fr|0,ev|0,d5)|0;a[fr+d5|0]=0}d5=(z=0,aM(178,bU|0,Q|0)|0);if(!z){c[d5>>2]=dQ;if((a[Q]&1)==0){bj=ex;aV=31;break L32}Lw(c[Q+8>>2]|0);bj=ex;aV=31;break L32}else{z=0}dQ=bT(-1,-1)|0;d5=dQ;dQ=M;if((a[Q]&1)==0){a9=dQ;ba=d5;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}Lw(c[Q+8>>2]|0);a9=dQ;ba=d5;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}if((a[eu]&1)==0){d5=P;c[d5>>2]=c[eu>>2];c[d5+4>>2]=c[eu+4>>2];c[d5+8>>2]=c[eu+8>>2]}else{eu=c[eE+36>>2]|0;d5=c[eE+32>>2]|0;if(d5>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}if(d5>>>0<11>>>0){a[P]=d5<<1;ft=P+1|0}else{dQ=d5+16&-16;ev=(z=0,au(248,dQ|0)|0);if(z){z=0;aV=23;break L30}c[P+8>>2]=ev;c[P>>2]=dQ|1;c[P+4>>2]=d5;ft=ev}LF(ft|0,eu|0,d5)|0;a[ft+d5|0]=0}d5=(z=0,aM(178,bU|0,P|0)|0);L476:do{if(!z){eu=(c[d5>>2]|0)+36|0;ev=eu;dQ=c[eF+36>>2]|0;if((dQ|0)==0){fu=0}else{fu=dQ+36|0}dQ=fu+4|0;dP=c[dQ>>2]|0;dO=(c[fu+8>>2]|0)-dP>>2;L482:do{if((dO|0)!=0){ef=eu+8|0;ee=ef;ed=eu+12|0;dW=eu+4|0;ej=eu;ei=0;eh=dP;while(1){d3=c[eh+(ei<<2)>>2]|0;c[t>>2]=d3;d2=c[ee>>2]|0;if((d2|0)==(c[ed>>2]|0)){z=0;as(376,dW|0,t|0);if(z){z=0;break}fv=c[t>>2]|0}else{if((d2|0)==0){fw=0}else{c[d2>>2]=d3;fw=c[ee>>2]|0}c[ef>>2]=fw+4;fv=d3}z=0;as(c[c[ej>>2]>>2]|0,ev|0,fv|0);if(z){z=0;break}d3=ei+1|0;if(d3>>>0>=dO>>>0){break L482}ei=d3;eh=c[dQ>>2]|0}eh=bT(-1,-1)|0;fx=M;fy=eh;break L476}}while(0);if((a[P]&1)==0){bj=ex;aV=31;break L32}Lw(c[P+8>>2]|0);bj=ex;aV=31;break L32}else{z=0;dQ=bT(-1,-1)|0;fx=M;fy=dQ}}while(0);d5=fy;dQ=fx;if((a[P]&1)==0){a9=dQ;ba=d5;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}Lw(c[P+8>>2]|0);a9=dQ;ba=d5;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}d5=(z=0,au(248,60)|0);if(z){z=0;aV=23;break L30}dQ=d5;c[s>>2]=dQ;d5=c[a4>>2]|0;if((d5|0)==(c[d>>2]|0)){z=0;as(382,aP|0,s|0);if(z){z=0;aV=23;break L30}fz=c[s>>2]|0}else{if((d5|0)==0){fA=0}else{c[d5>>2]=dQ;fA=c[a4>>2]|0}c[a4>>2]=fA+4;fz=dQ}dQ=fz;d5=eE+4|0;L514:do{if((a[d5]&1)==0){dO=R;c[dO>>2]=c[d5>>2];c[dO+4>>2]=c[d5+4>>2];c[dO+8>>2]=c[d5+8>>2];aV=167}else{dO=c[eE+12>>2]|0;ev=c[eE+8>>2]|0;do{if(ev>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(ev>>>0<11>>>0){a[R]=ev<<1;fB=R+1|0}else{dP=ev+16&-16;eu=(z=0,au(248,dP|0)|0);if(z){z=0;break}c[R+8>>2]=eu;c[R>>2]=dP|1;c[R+4>>2]=ev;fB=eu}LF(fB|0,dO|0,ev)|0;a[fB+ev|0]=0;aV=167;break L514}}while(0);ev=bT(-1,-1)|0;fC=M;fD=ev}}while(0);do{if((aV|0)==167){d5=eE+16|0;ev=r;c[ev>>2]=c[d5>>2];c[ev+4>>2]=c[d5+4>>2];c[ev+8>>2]=c[d5+8>>2];z=0;aD(36,fz|0,R|0,r|0,0,1,1);if(z){z=0;d5=bT(-1,-1)|0;ev=d5;d5=M;if((a[R]&1)==0){fC=d5;fD=ev;break}Lw(c[R+8>>2]|0);fC=d5;fD=ev;break}if((a[R]&1)!=0){Lw(c[R+8>>2]|0)}ev=eE+28|0;if((a[ev]&1)==0){d5=S;c[d5>>2]=c[ev>>2];c[d5+4>>2]=c[ev+4>>2];c[d5+8>>2]=c[ev+8>>2]}else{ev=c[eE+36>>2]|0;d5=c[eE+32>>2]|0;if(d5>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}if(d5>>>0<11>>>0){a[S]=d5<<1;fE=S+1|0}else{dO=d5+16&-16;eu=(z=0,au(248,dO|0)|0);if(z){z=0;aV=23;break L30}c[S+8>>2]=eu;c[S>>2]=dO|1;c[S+4>>2]=d5;fE=eu}LF(fE|0,ev|0,d5)|0;a[fE+d5|0]=0}d5=(z=0,aM(178,bU|0,S|0)|0);if(z){z=0;ev=bT(-1,-1)|0;eu=ev;ev=M;if((a[S]&1)==0){a9=ev;ba=eu;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}Lw(c[S+8>>2]|0);a9=ev;ba=eu;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}c[d5>>2]=fz;if((a[S]&1)!=0){Lw(c[S+8>>2]|0)}if(ey>>>0>=I>>>0){bj=ex;aV=31;break L32}d5=fz+36|0;eu=d5;ev=T;dO=U;dP=V;eh=p;ei=d5+8|0;ej=ei;ef=d5+12|0;ee=d5+4|0;dW=d5;d5=T+8|0;ed=V+8|0;eI=V+1|0;eC=V|0;eJ=V+4|0;d3=T+1|0;d2=T|0;et=T+4|0;d1=ey;while(1){dV=c[(c[aS>>2]|0)+(d1<<2)>>2]|0;dS=(z=0,au(248,56)|0);if(z){z=0;aV=19;break}dZ=dS;c[q>>2]=dZ;dS=c[a4>>2]|0;if((dS|0)==(c[d>>2]|0)){z=0;as(382,aP|0,q|0);if(z){z=0;aV=19;break}fF=c[q>>2]|0}else{if((dS|0)==0){fG=0}else{c[dS>>2]=dZ;fG=c[a4>>2]|0}c[a4>>2]=fG+4;fF=dZ}fH=fF;dZ=fF;dS=dV+4|0;if((a[dS]&1)==0){c[ev>>2]=c[dS>>2];c[ev+4>>2]=c[dS+4>>2];c[ev+8>>2]=c[dS+8>>2]}else{dS=c[dV+12>>2]|0;dY=c[dV+8>>2]|0;if(dY>>>0>4294967279>>>0){aV=195;break}if(dY>>>0<11>>>0){a[ev]=dY<<1;fI=d3}else{el=dY+16&-16;eo=(z=0,au(248,el|0)|0);if(z){z=0;aV=236;break}c[d5>>2]=eo;c[d2>>2]=el|1;c[et>>2]=dY;fI=eo}LF(fI|0,dS|0,dY)|0;a[fI+dY|0]=0}dY=dV+16|0;c[dO>>2]=c[dY>>2];c[dO+4>>2]=c[dY+4>>2];c[dO+8>>2]=c[dY+8>>2];dY=c[dV+36>>2]|0;dS=dV+40|0;if((a[dS]&1)==0){c[dP>>2]=c[dS>>2];c[dP+4>>2]=c[dS+4>>2];c[dP+8>>2]=c[dS+8>>2]}else{dS=c[dV+48>>2]|0;eo=c[dV+44>>2]|0;if(eo>>>0>4294967279>>>0){aV=205;break}if(eo>>>0<11>>>0){a[dP]=eo<<1;fK=eI}else{dV=eo+16&-16;el=(z=0,au(248,dV|0)|0);if(z){z=0;aV=239;break}c[ed>>2]=el;c[eC>>2]=dV|1;c[eJ>>2]=eo;fK=el}LF(fK|0,dS|0,eo)|0;a[fK+eo|0]=0}c[eh>>2]=c[dO>>2];c[eh+4>>2]=c[dO+4>>2];c[eh+8>>2]=c[dO+8>>2];z=0;aD(30,dZ|0,T|0,p|0,dY|0,V|0,0);if(z){z=0;fL=1;aV=242;break}dY=fF;c[o>>2]=dY;dZ=c[ej>>2]|0;if((dZ|0)==(c[ef>>2]|0)){z=0;as(376,ee|0,o|0);if(z){z=0;fL=0;aV=242;break}fM=c[o>>2]|0}else{if((dZ|0)==0){fN=0}else{c[dZ>>2]=dY;fN=c[ej>>2]|0}c[ei>>2]=fN+4;fM=dY}z=0;as(c[c[dW>>2]>>2]|0,eu|0,fM|0);if(z){z=0;fL=0;aV=242;break}if((a[dP]&1)!=0){Lw(c[ed>>2]|0)}if((a[ev]&1)!=0){Lw(c[d5>>2]|0)}dY=d1+1|0;if(dY>>>0<I>>>0){d1=dY}else{bj=ex;aV=31;break L32}}do{if((aV|0)==19){d1=bT(-1,-1)|0;a7=M;a8=d1;break L30}else if((aV|0)==195){z=0;ar(86,0);if(z){z=0;d1=bT(-1,-1)|0;fO=M;fP=d1;aV=238;break}}else if((aV|0)==205){z=0;ar(86,0);if(z){z=0;d1=bT(-1,-1)|0;fQ=M;fR=d1;aV=241;break}}else if((aV|0)==236){d1=bT(-1,-1)|0;fO=M;fP=d1;aV=238}else if((aV|0)==239){d1=bT(-1,-1)|0;fQ=M;fR=d1;aV=241}else if((aV|0)==242){d1=bT(-1,-1)|0;eu=d1;d1=M;if((a[dP]&1)==0){fS=fL;fT=d1;fU=eu;aV=244;break}Lw(c[ed>>2]|0);fS=fL;fT=d1;fU=eu;aV=244}}while(0);if((aV|0)==238){fV=fP;fW=fO}else if((aV|0)==241){fS=1;fT=fQ;fU=fR;aV=244}do{if((aV|0)==244){if((a[ev]&1)==0){if(fS){fV=fU;fW=fT;break}else{a9=fT;ba=fU}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else{Lw(c[d5>>2]|0);if(fS){fV=fU;fW=fT;break}else{a9=fT;ba=fU}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}}}while(0);d5=c[f>>2]|0;ev=c[a4>>2]|0;ed=d5;while(1){if((ed|0)==(ev|0)){fX=ev;break}if((c[ed>>2]|0)==(fF|0)){fX=ed;break}else{ed=ed+4|0}}ed=fX-d5>>2;dP=d5+(ed+1<<2)|0;eu=ev-dP|0;LG(d5+(ed<<2)|0,dP|0,eu|0)|0;dP=d5+((eu>>2)+ed<<2)|0;ed=c[a4>>2]|0;if((dP|0)!=(ed|0)){c[a4>>2]=ed+(~((ed-4+(-dP|0)|0)>>>2)<<2)}Lw(fH);a9=fW;ba=fV;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}}while(0);dP=c[f>>2]|0;ed=c[a4>>2]|0;eu=dP;while(1){if((eu|0)==(ed|0)){fY=ed;break}if((c[eu>>2]|0)==(fz|0)){fY=eu;break}else{eu=eu+4|0}}eu=fY-dP>>2;d1=dP+(eu+1<<2)|0;dW=ed-d1|0;LG(dP+(eu<<2)|0,d1|0,dW|0)|0;d1=dP+((dW>>2)+eu<<2)|0;eu=c[a4>>2]|0;if((d1|0)!=(eu|0)){c[a4>>2]=eu+(~((eu-4+(-d1|0)|0)>>>2)<<2)}Lw(dQ);a9=fC;ba=fD;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else if((aV|0)==20){d1=bT(-1,-1)|0;a7=M;a8=d1;break L30}else if((aV|0)==267){z=0;ar(86,0);if(z){z=0;d1=bT(-1,-1)|0;fZ=M;f_=d1;aV=281;break}}else if((aV|0)==279){d1=bT(-1,-1)|0;fZ=M;f_=d1;aV=281}else if((aV|0)==282){d1=bT(-1,-1)|0;eu=d1;d1=M;if((a[a0]&1)!=0){Lw(c[aY>>2]|0)}if((a[a$]&1)==0){f$=d1;f0=eu;aV=286;break}Lw(c[aZ>>2]|0);f$=d1;f0=eu;aV=286}else if((aV|0)==301){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}else if((aV|0)==314){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}else if((aV|0)==328){eu=bT(-1,-1)|0;d1=M;if((a[E]&1)!=0){Lw(c[ek>>2]|0)}if((a[d8]&1)!=0){Lw(c[ea>>2]|0)}c[d$>>2]=15768;z=0;ar(394,d0|0);if(!z){f1=eu;f2=d1;aV=335;break}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==334){d1=bT(-1,-1)|0;f1=d1;f2=M;aV=335}else if((aV|0)==342){z=0;ar(86,0);if(z){z=0;d1=bT(-1,-1)|0;f3=M;f4=d1;aV=378;break}}else if((aV|0)==358){z=0;ar(86,0);if(z){z=0;d1=bT(-1,-1)|0;f5=M;f6=d1;aV=383;break}}else if((aV|0)==374){d1=bT(-1,-1)|0;eu=M;z=0;ar(272,d9|0);if(!z){a7=eu;a8=d1;break L30}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==376){d1=bT(-1,-1)|0;f3=M;f4=d1;aV=378}else if((aV|0)==379){d1=bT(-1,-1)|0;eu=d1;d1=M;if((a[dU]&1)==0){f7=d1;f8=eu;aV=388;break}Lw(c[eg>>2]|0);f7=d1;f8=eu;aV=388}else if((aV|0)==381){eu=bT(-1,-1)|0;f5=M;f6=eu;aV=383}else if((aV|0)==384){eu=bT(-1,-1)|0;d1=eu;eu=M;if((a[d4]&1)==0){f9=eu;ga=d1;aV=386;break}Lw(c[ec>>2]|0);f9=eu;ga=d1;aV=386}else if((aV|0)==397){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}else if((aV|0)==408){d1=bT(-1,-1)|0;eu=d1;d1=M;if((a[dM]&1)==0){a9=d1;ba=eu;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}Lw(c[dN>>2]|0);a9=d1;ba=eu;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else if((aV|0)==413){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}else if((aV|0)==427){eu=bT(-1,-1)|0;d1=M;if((a[C]&1)!=0){Lw(c[bP>>2]|0)}if((a[bD]&1)!=0){Lw(c[bF>>2]|0)}c[bu>>2]=15768;z=0;ar(394,bv|0);if(!z){gb=eu;gc=d1;aV=434;break}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==433){d1=bT(-1,-1)|0;gb=d1;gc=M;aV=434}else if((aV|0)==442){z=0;ar(86,0);if(z){z=0;d1=bT(-1,-1)|0;gd=M;ge=d1;aV=476;break}}else if((aV|0)==456){z=0;ar(86,0);if(z){z=0;d1=bT(-1,-1)|0;gf=M;gg=d1;aV=481;break}}else if((aV|0)==472){d1=bT(-1,-1)|0;eu=M;z=0;ar(272,bE|0);if(!z){a7=eu;a8=d1;break L30}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==474){d1=bT(-1,-1)|0;gd=M;ge=d1;aV=476}else if((aV|0)==477){d1=bT(-1,-1)|0;eu=d1;d1=M;if((a[bn]&1)==0){gh=d1;gi=eu;aV=486;break}Lw(c[bL>>2]|0);gh=d1;gi=eu;aV=486}else if((aV|0)==479){eu=bT(-1,-1)|0;gf=M;gg=eu;aV=481}else if((aV|0)==482){eu=bT(-1,-1)|0;d1=eu;eu=M;if((a[bz]&1)==0){gj=eu;gk=d1;aV=484;break}Lw(c[bH>>2]|0);gj=eu;gk=d1;aV=484}else if((aV|0)==495){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}else if((aV|0)==510){d1=bT(-1,-1)|0;eu=M;if((a[A]&1)!=0){Lw(c[c2>>2]|0)}if((a[cS]&1)!=0){Lw(c[cU>>2]|0)}c[cJ>>2]=15768;z=0;ar(394,cK|0);if(!z){gl=d1;gm=eu;aV=517;break}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==516){eu=bT(-1,-1)|0;gl=eu;gm=M;aV=517}else if((aV|0)==524){z=0;ar(86,0);if(z){z=0;eu=bT(-1,-1)|0;gn=M;go=eu;aV=563;break}}else if((aV|0)==541){z=0;ar(86,0);if(z){z=0;eu=bT(-1,-1)|0;gp=M;gq=eu;aV=568;break}}else if((aV|0)==557){eu=bT(-1,-1)|0;d1=M;z=0;ar(272,cT|0);if(!z){a7=d1;a8=eu;break L30}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==559){eu=bT(-1,-1)|0;d1=eu;eu=M;if((a[bQ]&1)==0){a9=eu;ba=d1;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}Lw(c[c3>>2]|0);a9=eu;ba=d1;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else if((aV|0)==561){d1=bT(-1,-1)|0;gn=M;go=d1;aV=563}else if((aV|0)==564){d1=bT(-1,-1)|0;eu=d1;d1=M;if((a[cC]&1)==0){gr=d1;gs=eu;aV=573;break}Lw(c[c_>>2]|0);gr=d1;gs=eu;aV=573}else if((aV|0)==566){eu=bT(-1,-1)|0;gp=M;gq=eu;aV=568}else if((aV|0)==569){eu=bT(-1,-1)|0;d1=eu;eu=M;if((a[cO]&1)==0){gt=eu;gu=d1;aV=571;break}Lw(c[cW>>2]|0);gt=eu;gu=d1;aV=571}else if((aV|0)==582){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}else if((aV|0)==596){d1=bT(-1,-1)|0;eu=M;if((a[x]&1)!=0){Lw(c[cu>>2]|0)}if((a[ci]&1)!=0){Lw(c[ck>>2]|0)}c[b9>>2]=15768;z=0;ar(394,ca|0);if(!z){gv=d1;gw=eu;aV=603;break}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==602){eu=bT(-1,-1)|0;gv=eu;gw=M;aV=603}else if((aV|0)==610){z=0;ar(86,0);if(z){z=0;eu=bT(-1,-1)|0;gx=M;gy=eu;aV=646;break}}else if((aV|0)==626){z=0;ar(86,0);if(z){z=0;eu=bT(-1,-1)|0;gz=M;gA=eu;aV=651;break}}else if((aV|0)==642){eu=bT(-1,-1)|0;d1=M;z=0;ar(272,cj|0);if(!z){a7=d1;a8=eu;break L30}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==644){eu=bT(-1,-1)|0;gx=M;gy=eu;aV=646}else if((aV|0)==647){eu=bT(-1,-1)|0;d1=eu;eu=M;if((a[b2]&1)==0){gB=eu;gC=d1;aV=656;break}Lw(c[cq>>2]|0);gB=eu;gC=d1;aV=656}else if((aV|0)==649){d1=bT(-1,-1)|0;gz=M;gA=d1;aV=651}else if((aV|0)==652){d1=bT(-1,-1)|0;eu=d1;d1=M;if((a[ce]&1)==0){gD=d1;gE=eu;aV=654;break}Lw(c[cm>>2]|0);gD=d1;gE=eu;aV=654}else if((aV|0)==665){z=0;ar(86,0);if(z){z=0;aV=23;break L30}}else if((aV|0)==676){eu=bT(-1,-1)|0;d1=eu;eu=M;if((a[bV]&1)==0){a9=eu;ba=d1;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}Lw(c[bW>>2]|0);a9=eu;ba=d1;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}}while(0);if((aV|0)==79){fl=fh;fm=fi;aV=82}else if((aV|0)==45){z=0;ar(272,df|0);if(!z){a7=fj;a8=fk;break L30}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==281){f$=fZ;f0=f_;aV=286}else if((aV|0)==335){z=0;ar(272,dR|0);if(!z){a7=f2;a8=f1;break L30}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==378){f7=f3;f8=f4;aV=388}else if((aV|0)==383){f9=f5;ga=f6;aV=386}else if((aV|0)==434){z=0;ar(272,bk|0);if(!z){a7=gc;a8=gb;break L30}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==476){gh=gd;gi=ge;aV=486}else if((aV|0)==481){gj=gf;gk=gg;aV=484}else if((aV|0)==517){z=0;ar(272,cz|0);if(!z){a7=gm;a8=gl;break L30}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==563){gr=gn;gs=go;aV=573}else if((aV|0)==568){gt=gp;gu=gq;aV=571}else if((aV|0)==603){z=0;ar(272,b$|0);if(!z){a7=gw;a8=gv;break L30}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==646){gB=gx;gC=gy;aV=656}else if((aV|0)==651){gD=gz;gE=gA;aV=654}do{if((aV|0)==82){if((a[dy]&1)==0){ff=fl;fg=fm;aV=84;break}Lw(c[dD>>2]|0);ff=fl;fg=fm;aV=84}else if((aV|0)==286){bW=c[f>>2]|0;bV=c[a4>>2]|0;cm=bW;while(1){if((cm|0)==(bV|0)){gF=bV;break}if((c[cm>>2]|0)==(eK|0)){gF=cm;break}else{cm=cm+4|0}}cm=gF-bW>>2;dQ=bW+(cm+1<<2)|0;dP=bV-dQ|0;LG(bW+(cm<<2)|0,dQ|0,dP|0)|0;dQ=bW+((dP>>2)+cm<<2)|0;cm=c[a4>>2]|0;if((dQ|0)!=(cm|0)){c[a4>>2]=cm+(~((cm-4+(-dQ|0)|0)>>>2)<<2)}Lw(eM);a9=f$;ba=f0;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else if((aV|0)==386){if((a[d6]&1)==0){f7=f9;f8=ga;aV=388;break}Lw(c[eb>>2]|0);f7=f9;f8=ga;aV=388}else if((aV|0)==484){if((a[bB]&1)==0){gh=gj;gi=gk;aV=486;break}Lw(c[bG>>2]|0);gh=gj;gi=gk;aV=486}else if((aV|0)==571){if((a[cQ]&1)==0){gr=gt;gs=gu;aV=573;break}Lw(c[cV>>2]|0);gr=gt;gs=gu;aV=573}else if((aV|0)==654){if((a[cg]&1)==0){gB=gD;gC=gE;aV=656;break}Lw(c[cl>>2]|0);gB=gD;gC=gE;aV=656}}while(0);if((aV|0)==84){c[dh>>2]=15444;c[dl>>2]=15484;c[dp>>2]=15464;c[dz>>2]=15624;if((a[dA]&1)!=0){Lw(c[dC>>2]|0)}c[dz>>2]=15768;z=0;ar(394,dr|0);if(!z){z=0;ar(272,dB|0);if(!z){a9=ff;ba=fg}else{z=0;break}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,dB|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==388){c[dT>>2]=15444;c[dX>>2]=15484;c[d_>>2]=15464;c[d7>>2]=15624;if((a[d8]&1)!=0){Lw(c[ea>>2]|0)}c[d7>>2]=15768;z=0;ar(394,d0|0);if(!z){z=0;ar(272,d9|0);if(!z){a9=f7;ba=f8}else{z=0;break}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,d9|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==486){c[bm>>2]=15444;c[bq>>2]=15484;c[bt>>2]=15464;c[bC>>2]=15624;if((a[bD]&1)!=0){Lw(c[bF>>2]|0)}c[bC>>2]=15768;z=0;ar(394,bv|0);if(!z){z=0;ar(272,bE|0);if(!z){a9=gh;ba=gi}else{z=0;break}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,bE|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==573){c[cB>>2]=15444;c[cF>>2]=15484;c[cI>>2]=15464;c[cR>>2]=15624;if((a[cS]&1)!=0){Lw(c[cU>>2]|0)}c[cR>>2]=15768;z=0;ar(394,cK|0);if(!z){z=0;ar(272,cT|0);if(!z){a9=gr;ba=gs}else{z=0;break}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,cT|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==656){c[b1>>2]=15444;c[b5>>2]=15484;c[b8>>2]=15464;c[ch>>2]=15624;if((a[ci]&1)!=0){Lw(c[ck>>2]|0)}c[ch>>2]=15768;z=0;ar(394,ca|0);if(!z){z=0;ar(272,cj|0);if(!z){a9=gB;ba=gC}else{z=0;break}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,cj|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}}}while(0);L896:do{if((aV|0)==31){if(bj>>>0>=aO>>>0){gG=H+4|0;gH=c[gG>>2]|0;gI=gH;fJ(aN,gI);i=j;return}I=aC;aS=g|0;aX=aH+64|0;aW=aX|0;cl=aH|0;cg=aH+8|0;cV=cg|0;cQ=aH+12|0;bG=aH+64|0;bB=aH+4|0;eb=cQ;d6=aH+8|0;a4=cQ|0;dD=aH+16|0;dy=aH+20|0;b$=aH+60|0;cz=cg;cg=aI;bk=e+4|0;dR=aK;df=aL;dQ=e+16|0;cm=aJ;dP=aH+12|0;ed=aH+44|0;ce=aH+64|0;cq=aH+52|0;b2=aJ+8|0;b9=aK+8|0;cu=e+12|0;cW=e+8|0;cO=aK+1|0;c_=aK|0;cC=aK+4|0;c3=aI+8|0;bQ=aI+1|0;cJ=aI|0;c2=aI+4|0;bH=u+8|0;bz=h+8|0;bL=h+12|0;bn=g|0;bu=aG;bP=aG+8|0;dN=aG+1|0;dM=aG|0;ec=aG+4|0;d4=f+4|0;eg=f+8|0;dU=f|0;d$=aE;ek=aF;aZ=aE+8|0;a$=aF+8|0;aY=aF+1|0;a0=aF|0;aP=aF+4|0;d=aE+1|0;bU=aE|0;bS=aE+4|0;dE=aC+8|0;dv=aC+1|0;dq=aC|0;dK=aC+4|0;d1=aH+44|0;eu=bj;L901:while(1){z=0;as(278,aB|0,0);if(z){z=0;aV=18;break}dW=c[(c[aQ>>2]|0)+(eu<<2)>>2]|0;ei=dW+28|0;if((a[ei]&1)==0){c[I>>2]=c[ei>>2];c[I+4>>2]=c[ei+4>>2];c[I+8>>2]=c[ei+8>>2];gJ=a[I]|0}else{ej=c[dW+36>>2]|0;ee=c[dW+32>>2]|0;if(ee>>>0>4294967279>>>0){aV=682;break}if(ee>>>0<11>>>0){ef=ee<<1&255;a[I]=ef;gK=dv;gL=ef}else{ef=ee+16&-16;dO=(z=0,au(248,ef|0)|0);if(z){z=0;aV=726;break}c[dE>>2]=dO;eh=ef|1;c[dq>>2]=eh;c[dK>>2]=ee;gK=dO;gL=eh&255}LF(gK|0,ej|0,ee)|0;a[gK+ee|0]=0;gJ=gL}ee=(fs(aS,aC)|0)==0;if((gJ&1)!=0){Lw(c[dE>>2]|0)}do{if(ee){if((a[dW+44|0]&1)!=0){ej=(z=0,au(248,60)|0);if(z){z=0;aV=726;break L901}eh=ej;c[l>>2]=eh;ej=c[d4>>2]|0;if((ej|0)==(c[eg>>2]|0)){z=0;as(382,dU|0,l|0);if(z){z=0;aV=726;break L901}gM=c[l>>2]|0}else{if((ej|0)==0){gN=0}else{c[ej>>2]=eh;gN=c[d4>>2]|0}c[d4>>2]=gN+4;gM=eh}gO=gM;eh=dW+4|0;if((a[eh]&1)==0){c[d$>>2]=c[eh>>2];c[d$+4>>2]=c[eh+4>>2];c[d$+8>>2]=c[eh+8>>2]}else{eh=c[dW+12>>2]|0;ej=c[dW+8>>2]|0;if(ej>>>0>4294967279>>>0){aV=703;break L901}if(ej>>>0<11>>>0){a[d$]=ej<<1;gP=d}else{dO=ej+16&-16;ef=(z=0,au(248,dO|0)|0);if(z){z=0;aV=729;break L901}c[aZ>>2]=ef;c[bU>>2]=dO|1;c[bS>>2]=ej;gP=ef}LF(gP|0,eh|0,ej)|0;a[gP+ej|0]=0}ej=dW+16|0;eh=k;c[eh>>2]=c[ej>>2];c[eh+4>>2]=c[ej+4>>2];c[eh+8>>2]=c[ej+8>>2];z=0;aD(36,gM|0,aE|0,k|0,0,1,1);if(z){z=0;gQ=1;aV=732;break L901}if((a[ei]&1)==0){c[ek>>2]=c[ei>>2];c[ek+4>>2]=c[ei+4>>2];c[ek+8>>2]=c[ei+8>>2]}else{ej=c[dW+36>>2]|0;eh=c[dW+32>>2]|0;if(eh>>>0>4294967279>>>0){aV=714;break L901}if(eh>>>0<11>>>0){a[ek]=eh<<1;gR=aY}else{ef=eh+16&-16;dO=(z=0,au(248,ef|0)|0);if(z){z=0;gQ=0;aV=732;break L901}c[a$>>2]=dO;c[a0>>2]=ef|1;c[aP>>2]=eh;gR=dO}LF(gR|0,ej|0,eh)|0;a[gR+eh|0]=0}eh=(z=0,aM(178,bn|0,aF|0)|0);if(z){z=0;aV=735;break L901}c[eh>>2]=gM;if((a[ek]&1)!=0){Lw(c[a$>>2]|0)}if((a[d$]&1)==0){break}Lw(c[aZ>>2]|0);break}eh=c[dW+40>>2]|0;if((eh|0)!=0){ej=c[bz>>2]|0;dO=c[bL>>2]|0;ef=c[(c[eh>>2]|0)+20>>2]|0;eJ=(z=0,az(46,h|0,g|0,dO|0)|0);if(z){z=0;aV=726;break L901}eC=(z=0,aM(ef|0,eh|0,eJ|0)|0);if(z){z=0;aV=726;break L901}c[bz>>2]=ej;c[bL>>2]=dO;dO=eC|0;if((a[ei]&1)==0){c[bu>>2]=c[ei>>2];c[bu+4>>2]=c[ei+4>>2];c[bu+8>>2]=c[ei+8>>2]}else{eC=c[dW+36>>2]|0;ej=c[dW+32>>2]|0;if(ej>>>0>4294967279>>>0){aV=752;break L901}if(ej>>>0<11>>>0){a[bu]=ej<<1;gS=dN}else{eJ=ej+16&-16;eh=(z=0,au(248,eJ|0)|0);if(z){z=0;aV=726;break L901}c[bP>>2]=eh;c[dM>>2]=eJ|1;c[ec>>2]=ej;gS=eh}LF(gS|0,eC|0,ej)|0;a[gS+ej|0]=0}ej=(z=0,aM(178,bn|0,aG|0)|0);if(z){z=0;aV=762;break L901}c[ej>>2]=dO;if((a[bu]&1)==0){break}Lw(c[bP>>2]|0);break}c[cV>>2]=15464;c[cl>>2]=32540;c[bG>>2]=32560;c[bB>>2]=0;z=0;as(198,aH+64|0,eb|0);if(z){z=0;aV=774;break L901}c[aH+136>>2]=0;c[aH+140>>2]=-1;c[cl>>2]=15444;c[aW>>2]=15484;c[cV>>2]=15464;c[a4>>2]=15768;I_(dD);LI(dy|0,0,24)|0;c[a4>>2]=15624;LI(d1|0,0,16)|0;c[b$>>2]=24;LI(v|0,0,12)|0;z=0;as(212,cQ|0,u|0);if(z){z=0;aV=768;break L901}if((a[v]&1)!=0){Lw(c[bH>>2]|0)}dO=(z=0,aM(114,cz|0,12376)|0);if(z){z=0;aV=816;break L901}if((a[ei]&1)==0){c[cg>>2]=c[ei>>2];c[cg+4>>2]=c[ei+4>>2];c[cg+8>>2]=c[ei+8>>2]}else{ej=c[dW+36>>2]|0;eC=c[dW+32>>2]|0;if(eC>>>0>4294967279>>>0){aV=782;break L901}if(eC>>>0<11>>>0){a[cg]=eC<<1;gT=bQ}else{eh=eC+16&-16;eJ=(z=0,au(248,eh|0)|0);if(z){z=0;aV=816;break L901}c[c3>>2]=eJ;c[cJ>>2]=eh|1;c[c2>>2]=eC;gT=eJ}LF(gT|0,ej|0,eC)|0;a[gT+eC|0]=0}eC=(z=0,aM(814,dO|0,aI|0)|0);if(z){z=0;aV=819;break L901}dO=(z=0,aM(114,eC|0,11608)|0);if(z){z=0;aV=819;break L901}z=0,aM(814,dO|0,b|0)|0;if(z){z=0;aV=819;break L901}if((a[cg]&1)!=0){Lw(c[c3>>2]|0)}z=0;as(576,aJ|0,cQ|0);if(z){z=0;aV=816;break L901}if((a[bk]&1)==0){c[dR>>2]=c[bk>>2];c[dR+4>>2]=c[bk+4>>2];c[dR+8>>2]=c[bk+8>>2]}else{dO=c[cu>>2]|0;eC=c[cW>>2]|0;if(eC>>>0>4294967279>>>0){aV=798;break L901}if(eC>>>0<11>>>0){a[dR]=eC<<1;gU=cO}else{ej=eC+16&-16;eJ=(z=0,au(248,ej|0)|0);if(z){z=0;aV=821;break L901}c[b9>>2]=eJ;c[c_>>2]=ej|1;c[cC>>2]=eC;gU=eJ}LF(gU|0,dO|0,eC)|0;a[gU+eC|0]=0}c[df>>2]=c[dQ>>2];c[df+4>>2]=c[dQ+4>>2];c[df+8>>2]=c[dQ+8>>2];z=0;aR(382,aJ|0,aK|0,aL|0);if(z){z=0;aV=824;break L901}if((a[dR]&1)!=0){Lw(c[b9>>2]|0)}if((a[cm]&1)!=0){Lw(c[b2>>2]|0)}c[cl>>2]=15444;c[bG>>2]=15484;c[d6>>2]=15464;c[dP>>2]=15624;if((a[ed]&1)!=0){Lw(c[cq>>2]|0)}c[dP>>2]=15768;z=0;ar(394,dD|0);if(z){z=0;aV=814;break L901}z=0;ar(272,ce|0);if(z){z=0;aV=726;break L901}}}while(0);z=0;ar(444,aB|0);if(z){z=0;aV=18;break}dW=eu+1|0;if(dW>>>0<aO>>>0){eu=dW}else{aV=842;break}}do{if((aV|0)==18){eu=bT(-1,-1)|0;a7=M;a8=eu;break L30}else if((aV|0)==682){z=0;ar(86,0);if(z){z=0;aV=727;break}}else if((aV|0)==703){z=0;ar(86,0);if(z){z=0;eu=bT(-1,-1)|0;gV=M;gW=eu;aV=731;break}}else if((aV|0)==714){z=0;ar(86,0);if(z){z=0;eu=bT(-1,-1)|0;gX=M;gY=eu;gZ=0;aV=734;break}}else if((aV|0)==726){eu=bT(-1,-1)|0;g_=M;g$=eu;aV=728}else if((aV|0)==729){eu=bT(-1,-1)|0;gV=M;gW=eu;aV=731}else if((aV|0)==732){eu=bT(-1,-1)|0;gX=M;gY=eu;gZ=gQ;aV=734}else if((aV|0)==735){eu=bT(-1,-1)|0;dQ=eu;eu=M;if((a[ek]&1)==0){g0=0;g1=eu;g2=dQ;aV=737;break}Lw(c[a$>>2]|0);g0=0;g1=eu;g2=dQ;aV=737}else if((aV|0)==752){z=0;ar(86,0);if(z){z=0;aV=727;break}}else if((aV|0)==762){dQ=bT(-1,-1)|0;eu=dQ;dQ=M;if((a[bu]&1)==0){g3=dQ;g4=eu;break}Lw(c[bP>>2]|0);g3=dQ;g4=eu}else if((aV|0)==768){eu=bT(-1,-1)|0;dQ=M;if((a[v]&1)!=0){Lw(c[bH>>2]|0)}if((a[ed]&1)!=0){Lw(c[cq>>2]|0)}c[a4>>2]=15768;z=0;ar(394,dD|0);if(!z){g5=eu;g6=dQ;aV=775;break}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==774){dQ=bT(-1,-1)|0;g5=dQ;g6=M;aV=775}else if((aV|0)==782){z=0;ar(86,0);if(z){z=0;dQ=bT(-1,-1)|0;g7=M;g8=dQ;aV=818;break}}else if((aV|0)==798){z=0;ar(86,0);if(z){z=0;dQ=bT(-1,-1)|0;g9=M;ha=dQ;aV=823;break}}else if((aV|0)==814){dQ=bT(-1,-1)|0;eu=M;z=0;ar(272,ce|0);if(!z){g_=eu;g$=dQ;aV=728;break}else{z=0}bT(-1,-1,0)|0;bX()}else if((aV|0)==816){dQ=bT(-1,-1)|0;g7=M;g8=dQ;aV=818}else if((aV|0)==819){dQ=bT(-1,-1)|0;eu=dQ;dQ=M;if((a[cg]&1)==0){hb=dQ;hc=eu;aV=828;break}Lw(c[c3>>2]|0);hb=dQ;hc=eu;aV=828}else if((aV|0)==821){eu=bT(-1,-1)|0;g9=M;ha=eu;aV=823}else if((aV|0)==824){eu=bT(-1,-1)|0;dQ=eu;eu=M;if((a[dR]&1)==0){hd=eu;he=dQ;aV=826;break}Lw(c[b9>>2]|0);hd=eu;he=dQ;aV=826}else if((aV|0)==842){gG=H+4|0;gH=c[gG>>2]|0;gI=gH;fJ(aN,gI);i=j;return}}while(0);do{if((aV|0)==727){b9=bT(-1,-1)|0;g_=M;g$=b9;aV=728}else if((aV|0)==731){hf=gW;hg=gV;aV=740}else if((aV|0)==734){g0=gZ;g1=gX;g2=gY;aV=737}else if((aV|0)==775){z=0;ar(272,aX|0);if(!z){g_=g6;g$=g5;aV=728;break}else{z=0;bT(-1,-1,0)|0;bX()}}else if((aV|0)==818){hb=g7;hc=g8;aV=828}else if((aV|0)==823){hd=g9;he=ha;aV=826}}while(0);do{if((aV|0)==728){g3=g_;g4=g$}else if((aV|0)==737){if((a[d$]&1)==0){if(g0){hf=g2;hg=g1;aV=740;break}else{g3=g1;g4=g2;break}}else{Lw(c[aZ>>2]|0);if(g0){hf=g2;hg=g1;aV=740;break}else{g3=g1;g4=g2;break}}}else if((aV|0)==826){if((a[cm]&1)==0){hb=hd;hc=he;aV=828;break}Lw(c[b2>>2]|0);hb=hd;hc=he;aV=828}}while(0);do{if((aV|0)==740){b2=c[f>>2]|0;cm=c[d4>>2]|0;aZ=b2;while(1){if((aZ|0)==(cm|0)){hh=cm;break}if((c[aZ>>2]|0)==(gM|0)){hh=aZ;break}else{aZ=aZ+4|0}}aZ=hh-b2>>2;d$=b2+(aZ+1<<2)|0;aX=cm-d$|0;LG(b2+(aZ<<2)|0,d$|0,aX|0)|0;d$=b2+((aX>>2)+aZ<<2)|0;aZ=c[d4>>2]|0;if((d$|0)!=(aZ|0)){c[d4>>2]=aZ+(~((aZ-4+(-d$|0)|0)>>>2)<<2)}Lw(gO);g3=hg;g4=hf}else if((aV|0)==828){c[cl>>2]=15444;c[bG>>2]=15484;c[d6>>2]=15464;c[dP>>2]=15624;if((a[ed]&1)!=0){Lw(c[cq>>2]|0)}c[dP>>2]=15768;z=0;ar(394,dD|0);if(!z){z=0;ar(272,ce|0);if(!z){g3=hb;g4=hc;break}else{z=0;break L896}}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,ce|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);z=0;ar(444,aB|0);if(!z){a9=g3;ba=g4}else{z=0;break}bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}}while(0);bT(-1,-1,0)|0;bX()}}while(0);if((aV|0)==23){aV=bT(-1,-1)|0;a7=M;a8=aV}a9=a7;ba=a8;bb=H+4|0;bc=c[bb>>2]|0;bd=bc;fJ(aN,bd);be=ba;bf=0;bh=be;bi=a9;bg(bh|0)}function fk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=fu(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=Lu(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}LF(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bT(-1,-1)|0;if((h|0)==0){bg(o|0)}Lw(h);bg(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}e2(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function fl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=g|0;a[k]=0;c[g+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;L1:do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){z=0,au(62,o|0)|0;if(z){z=0;p=15;break}}a[k]=1;o=LJ(d|0)|0;q=c[(c[l>>2]|0)-12>>2]|0;c[h>>2]=c[n+(q+24)>>2];r=d+o|0;o=(c[n+(q+4)>>2]&176|0)==32?r:d;s=n+q|0;t=n+(q+76)|0;q=c[t>>2]|0;u=q&255;L6:do{if((q|0)==-1){z=0;as(352,f|0,s|0);if(z){z=0;p=16;break}v=(z=0,aM(198,f|0,41760)|0);do{if(!z){w=(z=0,aM(c[(c[v>>2]|0)+28>>2]|0,v|0,32)|0);if(z){z=0;break}z=0;ar(394,f|0);if(z){z=0;p=16;break L6}c[t>>2]=w<<24>>24;x=w;p=12;break L6}else{z=0}}while(0);v=bT(-1,-1,0)|0;w=M;z=0;ar(394,f|0);if(!z){y=w;A=v;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{x=u;p=12}}while(0);do{if((p|0)==12){z=0;aI(56,j|0,h|0,d|0,o|0,r|0,s|0,x|0);if(z){z=0;p=16;break}if((c[j>>2]|0)!=0){p=18;break L1}u=c[(c[l>>2]|0)-12>>2]|0;z=0;as(368,n+u|0,c[n+(u+16)>>2]|5|0);if(!z){p=18;break L1}else{z=0;p=16}}}while(0);if((p|0)==16){s=bT(-1,-1,0)|0;y=M;A=s}z=0;ar(138,g|0);if(!z){B=A;break}else{z=0}C=bT(-1,-1,0)|0;D=M;bX();return 0}else{p=18}}while(0);do{if((p|0)==18){z=0;ar(138,g|0);if(z){z=0;p=15;break}i=e;return b|0}}while(0);if((p|0)==15){p=bT(-1,-1,0)|0;B=p}bD(B|0)|0;z=0;ar(182,n+(c[(c[l>>2]|0)-12>>2]|0)|0);if(!z){a$();i=e;return b|0}else{z=0}b=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(b|0)}else{z=0;C=bT(-1,-1,0)|0;D=M;bX();return 0}return 0}function fm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=g|0;a[k]=0;c[g+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;L1:do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){z=0,au(62,o|0)|0;if(z){z=0;p=30;break}}a[k]=1;o=d;q=a[d]|0;r=q&255;if((r&1|0)==0){s=r>>>1}else{s=c[d+4>>2]|0}r=c[(c[l>>2]|0)-12>>2]|0;c[h>>2]=c[n+(r+24)>>2];t=(q&1)==0;if(t){u=o+1|0}else{u=c[d+8>>2]|0}do{if((c[n+(r+4)>>2]&176|0)==32){if(t){v=o+1+s|0;p=18;break}else{w=(c[d+8>>2]|0)+s|0;p=17;break}}else{if(t){v=o+1|0;p=18;break}else{w=c[d+8>>2]|0;p=17;break}}}while(0);if((p|0)==17){x=c[d+8>>2]|0;y=w}else if((p|0)==18){x=o+1|0;y=v}t=x+s|0;q=n+r|0;A=n+(r+76)|0;B=c[A>>2]|0;C=B&255;L27:do{if((B|0)==-1){z=0;as(352,f|0,q|0);if(z){z=0;p=31;break}D=(z=0,aM(198,f|0,41760)|0);do{if(!z){E=(z=0,aM(c[(c[D>>2]|0)+28>>2]|0,D|0,32)|0);if(z){z=0;break}z=0;ar(394,f|0);if(z){z=0;p=31;break L27}c[A>>2]=E<<24>>24;F=E;p=27;break L27}else{z=0}}while(0);D=bT(-1,-1,0)|0;E=M;z=0;ar(394,f|0);if(!z){G=E;H=D;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{F=C;p=27}}while(0);do{if((p|0)==27){z=0;aI(56,j|0,h|0,u|0,y|0,t|0,q|0,F|0);if(z){z=0;p=31;break}if((c[j>>2]|0)!=0){p=33;break L1}C=c[(c[l>>2]|0)-12>>2]|0;z=0;as(368,n+C|0,c[n+(C+16)>>2]|5|0);if(!z){p=33;break L1}else{z=0;p=31}}}while(0);if((p|0)==31){q=bT(-1,-1,0)|0;G=M;H=q}z=0;ar(138,g|0);if(!z){I=H;break}else{z=0}J=bT(-1,-1,0)|0;K=M;bX();return 0}else{p=33}}while(0);do{if((p|0)==33){z=0;ar(138,g|0);if(z){z=0;p=30;break}i=e;return b|0}}while(0);if((p|0)==30){p=bT(-1,-1,0)|0;I=p}bD(I|0)|0;z=0;ar(182,n+(c[(c[l>>2]|0)-12>>2]|0)|0);if(!z){a$();i=e;return b|0}else{z=0}b=bT(-1,-1)|0;z=0;aS(2);if(!z){bg(b|0)}else{z=0;J=bT(-1,-1,0)|0;K=M;bX();return 0}return 0}function fn(b){b=b|0;var d=0;c[b>>2]=15444;c[b+64>>2]=15484;c[b+8>>2]=15464;d=b+12|0;c[d>>2]=15624;if((a[b+44|0]&1)!=0){Lw(c[b+52>>2]|0)}c[d>>2]=15768;z=0;ar(394,b+16|0);if(!z){Ex(b+64|0);return}else{z=0}d=bT(-1,-1)|0;z=0;ar(272,b+64|0);if(!z){bg(d|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function fo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=fr(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=Lu(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}LF(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bT(-1,-1)|0;if((h|0)==0){bg(o|0)}Lw(h);bg(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}e2(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function fp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=LH(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==17){t=0;if(o){u=e>>>1}else{u=c[d+20>>2]|0}if(h){v=i}else{v=c[k>>2]|0}if(r){w=m+1|0}else{w=c[d+24>>2]|0}if(g){x=b}else{x=c[j>>2]|0}m=LH(w|0,x|0,(v>>>0<u>>>0?v:u)|0)|0;if((m|0)==0){if(u>>>0>=v>>>0){f=1;t=35;break}}else{if((m|0)>=0){f=1;t=33;break}}y=d+4|0}else if((t|0)==16){t=0;y=d|0}m=c[y>>2]|0;if((m|0)==0){f=0;t=36;break}else{d=m}}if((t|0)==35){return f|0}else if((t|0)==33){return f|0}else if((t|0)==36){return f|0}return 0}function fq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function fr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=(f&1|0)==0;j=f>>>1;f=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;e=g;while(1){g=e+16|0;if(i){m=j}else{m=c[l>>2]|0}n=g;o=a[g]|0;g=o&255;p=(g&1|0)==0;if(p){q=g>>>1}else{q=c[e+20>>2]|0}if(f){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=LH(r|0,t|0,(q>>>0<m>>>0?q:m)|0)|0;if((o|0)==0){if(m>>>0<q>>>0){u=16}}else{if((o|0)<0){u=16}}if((u|0)==16){u=0;v=e|0;o=c[v>>2]|0;if((o|0)==0){u=17;break}else{e=o;continue}}if(p){w=g>>>1}else{w=c[e+20>>2]|0}if(i){x=j}else{x=c[l>>2]|0}if(s){y=n+1|0}else{y=c[e+24>>2]|0}if(f){z=b}else{z=c[k>>2]|0}n=LH(y|0,z|0,(x>>>0<w>>>0?x:w)|0)|0;if((n|0)==0){if(w>>>0>=x>>>0){u=33;break}}else{if((n|0)>=0){u=33;break}}A=e+4|0;n=c[A>>2]|0;if((n|0)==0){u=32;break}else{e=n}}if((u|0)==33){c[d>>2]=e;h=d;return h|0}else if((u|0)==32){c[d>>2]=e;h=A;return h|0}else if((u|0)==17){c[d>>2]=e;h=v;return h|0}return 0}function fs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=LH(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==16){t=0;u=d|0}else if((t|0)==17){t=0;if(o){v=e>>>1}else{v=c[d+20>>2]|0}if(h){w=i}else{w=c[k>>2]|0}if(r){x=m+1|0}else{x=c[d+24>>2]|0}if(g){y=b}else{y=c[j>>2]|0}m=LH(x|0,y|0,(w>>>0<v>>>0?w:v)|0)|0;if((m|0)==0){if(v>>>0>=w>>>0){f=1;t=35;break}}else{if((m|0)>=0){f=1;t=36;break}}u=d+4|0}m=c[u>>2]|0;if((m|0)==0){f=0;t=33;break}else{d=m}}if((t|0)==33){return f|0}else if((t|0)==36){return f|0}else if((t|0)==35){return f|0}return 0}function ft(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+16|0;l=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[l>>2];l=k|0;m=d|0;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g|0;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;do{if((h|0)>0){if((cI[c[(c[d>>2]|0)+48>>2]&127](d,e,h)|0)==(h|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){if(q>>>0<11>>>0){h=q<<1&255;e=l;a[e]=h;r=l+1|0;s=h;t=e}else{e=q+16&-16;h=Lu(e)|0;c[l+8>>2]=h;g=e|1;c[l>>2]=g;c[l+4>>2]=q;r=h;s=g&255;t=l}LI(r|0,j|0,q|0)|0;a[r+q|0]=0;if((s&1)==0){u=l+1|0}else{u=c[l+8>>2]|0}g=(z=0,az(c[(c[d>>2]|0)+48>>2]|0,d|0,u|0,q|0)|0);if(z){z=0;h=bT(-1,-1)|0;if((a[t]&1)==0){bg(h|0)}Lw(c[l+8>>2]|0);bg(h|0)}if((g|0)==(q|0)){if((a[t]&1)==0){break}Lw(c[l+8>>2]|0);break}c[m>>2]=0;c[b>>2]=0;if((a[t]&1)==0){i=k;return}Lw(c[l+8>>2]|0);i=k;return}}while(0);l=n-o|0;do{if((l|0)>0){if((cI[c[(c[d>>2]|0)+48>>2]&127](d,f,l)|0)==(l|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function fu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=f>>>1;j=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;L5:do{if((f&1|0)==0){e=g;while(1){m=e+16|0;n=m;o=a[m]|0;m=o&255;p=(m&1|0)==0;if(p){q=m>>>1}else{q=c[e+20>>2]|0}if(j){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=LH(r|0,t|0,(q>>>0<i>>>0?q:i)|0)|0;if((o|0)==0){if(i>>>0<q>>>0){u=26}}else{if((o|0)<0){u=26}}if((u|0)==26){u=0;o=e|0;v=c[o>>2]|0;if((v|0)==0){w=e;x=o;u=39;break}else{e=v;continue}}if(p){y=m>>>1}else{y=c[e+20>>2]|0}if(s){z=n+1|0}else{z=c[e+24>>2]|0}if(j){A=b}else{A=c[k>>2]|0}n=LH(z|0,A|0,(i>>>0<y>>>0?i:y)|0)|0;if((n|0)==0){if(y>>>0>=i>>>0){B=e;u=53;break L5}}else{if((n|0)>=0){B=e;u=53;break L5}}n=e+4|0;s=c[n>>2]|0;if((s|0)==0){C=e;D=n;u=52;break}else{e=s}}}else{e=g;while(1){s=e+16|0;n=c[l>>2]|0;m=s;p=a[s]|0;s=p&255;v=(s&1|0)==0;if(v){E=s>>>1}else{E=c[e+20>>2]|0}if(j){F=b}else{F=c[k>>2]|0}o=(p&1)==0;if(o){G=m+1|0}else{G=c[e+24>>2]|0}p=LH(F|0,G|0,(E>>>0<n>>>0?E:n)|0)|0;if((p|0)==0){if(n>>>0<E>>>0){u=38}}else{if((p|0)<0){u=38}}if((u|0)==38){u=0;p=e|0;n=c[p>>2]|0;if((n|0)==0){w=e;x=p;u=39;break}else{e=n;continue}}if(v){H=s>>>1}else{H=c[e+20>>2]|0}s=c[l>>2]|0;if(o){I=m+1|0}else{I=c[e+24>>2]|0}if(j){J=b}else{J=c[k>>2]|0}m=LH(I|0,J|0,(s>>>0<H>>>0?s:H)|0)|0;if((m|0)==0){if(H>>>0>=s>>>0){B=e;u=53;break L5}}else{if((m|0)>=0){B=e;u=53;break L5}}m=e+4|0;s=c[m>>2]|0;if((s|0)==0){C=e;D=m;u=52;break}else{e=s}}}}while(0);if((u|0)==53){c[d>>2]=B;h=d;return h|0}else if((u|0)==52){c[d>>2]=C;h=D;return h|0}else if((u|0)==39){c[d>>2]=w;h=x;return h|0}return 0}function fv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=b;f=c[d+48>>2]|0;if((f&16|0)!=0){g=d+44|0;h=c[g>>2]|0;i=c[d+24>>2]|0;if(h>>>0<i>>>0){c[g>>2]=i;j=i}else{j=h}h=c[d+20>>2]|0;i=h;g=j-i|0;if(g>>>0>4294967279>>>0){D5(0)}if(g>>>0<11>>>0){a[e]=g<<1;k=b+1|0}else{l=g+16&-16;m=Lu(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=g;k=m}if((h|0)==(j|0)){n=k}else{m=j+(-i|0)|0;i=k;g=h;while(1){a[i]=a[g]|0;h=g+1|0;if((h|0)==(j|0)){break}else{i=i+1|0;g=h}}n=k+m|0}a[n]=0;return}if((f&8|0)==0){LI(e|0,0,12)|0;return}f=c[d+8>>2]|0;n=c[d+16>>2]|0;d=f;m=n-d|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[e]=m<<1;o=b+1|0}else{e=m+16&-16;k=Lu(e)|0;c[b+8>>2]=k;c[b>>2]=e|1;c[b+4>>2]=m;o=k}if((f|0)==(n|0)){p=o}else{k=n+(-d|0)|0;d=o;m=f;while(1){a[d]=a[m]|0;f=m+1|0;if((f|0)==(n|0)){break}else{d=d+1|0;m=f}}p=o+k|0}a[p]=0;return}function fw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b>>2]=15444;c[b+64>>2]=15484;c[b+8>>2]=15464;d=b+12|0;c[d>>2]=15624;if((a[b+44|0]&1)!=0){Lw(c[b+52>>2]|0)}c[d>>2]=15768;z=0;ar(394,b+16|0);if(z){z=0;d=bT(-1,-1)|0;e=M;z=0;ar(272,b+64|0);if(!z){f=e;g=d;h=b;Lw(h);bg(g|0)}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,b+64|0);if(!z){Lw(b);return}else{z=0}d=bT(-1,-1)|0;f=M;g=d;h=b;Lw(h);bg(g|0)}function fx(b){b=b|0;var d=0,e=0;d=b-144+136|0;c[d>>2]=15444;b=d+64|0;c[b>>2]=15484;c[d+8>>2]=15464;e=d+12|0;c[e>>2]=15624;if((a[d+44|0]&1)!=0){Lw(c[d+52>>2]|0)}c[e>>2]=15768;z=0;ar(394,d+16|0);if(!z){Ex(b);return}else{z=0}d=bT(-1,-1)|0;z=0;ar(272,b|0);if(!z){bg(d|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function fy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b-144+136|0;c[d>>2]=15444;b=d+64|0;c[b>>2]=15484;c[d+8>>2]=15464;e=d+12|0;c[e>>2]=15624;if((a[d+44|0]&1)!=0){Lw(c[d+52>>2]|0)}c[e>>2]=15768;z=0;ar(394,d+16|0);if(z){z=0;e=bT(-1,-1)|0;f=M;z=0;ar(272,b|0);if(!z){g=f;h=e;i=d;Lw(i);bg(h|0)}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,b|0);if(!z){Lw(d);return}else{z=0}b=bT(-1,-1)|0;g=M;h=b;i=d;Lw(i);bg(h|0)}function fz(b){b=b|0;var d=0,e=0,f=0;d=b;e=c[(c[b>>2]|0)-12>>2]|0;c[d+e>>2]=15444;b=d+(e+64)|0;c[b>>2]=15484;c[d+(e+8)>>2]=15464;f=d+(e+12)|0;c[f>>2]=15624;if((a[d+(e+44)|0]&1)!=0){Lw(c[d+(e+52)>>2]|0)}c[f>>2]=15768;z=0;ar(394,d+(e+16)|0);if(!z){Ex(b);return}else{z=0}e=bT(-1,-1)|0;z=0;ar(272,b|0);if(!z){bg(e|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function fA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b;e=c[(c[b>>2]|0)-12>>2]|0;b=d+e|0;c[b>>2]=15444;f=d+(e+64)|0;c[f>>2]=15484;c[d+(e+8)>>2]=15464;g=d+(e+12)|0;c[g>>2]=15624;if((a[d+(e+44)|0]&1)!=0){Lw(c[d+(e+52)>>2]|0)}c[g>>2]=15768;z=0;ar(394,d+(e+16)|0);if(z){z=0;e=bT(-1,-1)|0;d=M;z=0;ar(272,f|0);if(!z){h=d;i=e;Lw(b);bg(i|0)}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,f|0);if(!z){Lw(b);return}else{z=0}f=bT(-1,-1)|0;h=M;i=f;Lw(b);bg(i|0)}function fB(b){b=b|0;var d=0;d=b|0;c[d>>2]=15624;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=15768;I0(b+4|0);return}function fC(b){b=b|0;var d=0;d=b|0;c[d>>2]=15624;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=15768;z=0;ar(394,b+4|0);if(!z){Lw(b);return}else{z=0;d=bT(-1,-1)|0;Lw(b);bg(d|0)}}function fD(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=d+44|0;j=c[i>>2]|0;k=d+24|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[i>>2]=l;m=l}else{m=j}j=h&24;do{if((j|0)==0){i=b;c[i>>2]=0;c[i+4>>2]=0;i=b+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}else if((j|0)==24){if((g|0)==0){n=0;o=0;break}else if((g|0)==2){p=11;break}else if((g|0)!=1){p=15;break}i=b;c[i>>2]=0;c[i+4>>2]=0;i=b+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}else{if((g|0)==0){n=0;o=0;break}else if((g|0)==2){p=11;break}else if((g|0)!=1){p=15;break}if((h&8|0)==0){i=l-(c[d+20>>2]|0)|0;n=(i|0)<0|0?-1:0;o=i;break}else{i=(c[d+12>>2]|0)-(c[d+8>>2]|0)|0;n=(i|0)<0|0?-1:0;o=i;break}}}while(0);if((p|0)==15){g=b;c[g>>2]=0;c[g+4>>2]=0;g=b+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}if((p|0)==11){p=d+32|0;if((a[p]&1)==0){q=p+1|0}else{q=c[d+40>>2]|0}p=m-q|0;n=(p|0)<0|0?-1:0;o=p}p=LM(o,n,e,f)|0;f=M;e=0;do{if(!((f|0)<(e|0)|(f|0)==(e|0)&p>>>0<0>>>0)){n=d+32|0;if((a[n]&1)==0){r=n+1|0}else{r=c[d+40>>2]|0}n=m-r|0;o=(n|0)<0|0?-1:0;if((o|0)<(f|0)|(o|0)==(f|0)&n>>>0<p>>>0){break}n=h&8;do{if(!((p|0)==0&(f|0)==0)){do{if((n|0)!=0){if((c[d+12>>2]|0)!=0){break}o=b;c[o>>2]=0;c[o+4>>2]=0;o=b+8|0;c[o>>2]=-1;c[o+4>>2]=-1;return}}while(0);if(!((h&16|0)!=0&(l|0)==0)){break}o=b;c[o>>2]=0;c[o+4>>2]=0;o=b+8|0;c[o>>2]=-1;c[o+4>>2]=-1;return}}while(0);if((n|0)!=0){c[d+12>>2]=(c[d+8>>2]|0)+p;c[d+16>>2]=m}if((h&16|0)!=0){c[k>>2]=(c[d+20>>2]|0)+p}o=b;c[o>>2]=0;c[o+4>>2]=0;o=b+8|0;c[o>>2]=p;c[o+4>>2]=f;return}}while(0);f=b;c[f>>2]=0;c[f+4>>2]=0;f=b+8|0;c[f>>2]=-1;c[f+4>>2]=-1;return}function fE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=d;d=i;i=i+16|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];g=d+8|0;cM[c[(c[b>>2]|0)+16>>2]&127](a,b,c[g>>2]|0,c[g+4>>2]|0,0,e);i=f;return}function fF(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,i=0;b=a+44|0;e=c[b>>2]|0;f=c[a+24>>2]|0;if(e>>>0<f>>>0){c[b>>2]=f;g=f}else{g=e}if((c[a+48>>2]&8|0)==0){h=-1;return h|0}e=a+16|0;f=c[e>>2]|0;b=c[a+12>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;i=g}else{i=f}if(b>>>0>=i>>>0){h=-1;return h|0}h=d[b]|0;return h|0}function fG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b+44|0;f=c[e>>2]|0;g=c[b+24>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;h=g}else{h=f}f=b+8|0;g=c[f>>2]|0;e=b+12|0;i=c[e>>2]|0;if(g>>>0>=i>>>0){j=-1;return j|0}if((d|0)==-1){c[f>>2]=g;c[e>>2]=i-1;c[b+16>>2]=h;j=0;return j|0}k=i-1|0;do{if((c[b+48>>2]&16|0)==0){if((d<<24>>24|0)==(a[k]|0)){break}else{j=-1}return j|0}}while(0);c[f>>2]=g;c[e>>2]=k;c[b+16>>2]=h;a[k]=d;j=d;return j|0}function fH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;if((d|0)==-1){e=0;return e|0}f=b|0;g=b+12|0;h=b+8|0;i=(c[g>>2]|0)-(c[h>>2]|0)|0;j=b+24|0;k=c[j>>2]|0;l=b+28|0;m=c[l>>2]|0;L4:do{if((k|0)==(m|0)){n=b+48|0;if((c[n>>2]&16|0)==0){e=-1;return e|0}o=b+20|0;p=c[o>>2]|0;q=k-p|0;r=b+44|0;s=(c[r>>2]|0)-p|0;p=b+32|0;t=p;u=p;v=a[u]|0;if((v&1)==0){w=(v&255)>>>1;x=10}else{w=c[b+36>>2]|0;x=(c[p>>2]&-2)-1|0}do{if((w|0)==(x|0)){z=0;aI(46,p|0,x|0,1,x|0,x|0,0,0);if(z){z=0;break}y=a[u]|0;A=11}else{y=v;A=11}}while(0);L16:do{if((A|0)==11){if((y&1)==0){a[u]=(w<<1)+2;B=t+1|0;C=w+1|0}else{v=c[b+40>>2]|0;D=w+1|0;c[b+36>>2]=D;B=v;C=D}a[B+w|0]=0;a[B+C|0]=0;D=a[u]|0;if((D&1)==0){E=10;F=D}else{D=c[p>>2]|0;E=(D&-2)-1|0;F=D&255}D=F&255;if((D&1|0)==0){G=D>>>1}else{G=c[b+36>>2]|0}do{if(G>>>0<E>>>0){D=E-G|0;z=0,az(82,p|0,D|0,0)|0;if(z){z=0;break L16}}else{if((F&1)==0){a[t+1+E|0]=0;a[u]=E<<1;break}else{a[(c[b+40>>2]|0)+E|0]=0;c[b+36>>2]=E;break}}}while(0);D=a[u]|0;if((D&1)==0){H=t+1|0}else{H=c[b+40>>2]|0}v=D&255;if((v&1|0)==0){I=v>>>1}else{I=c[b+36>>2]|0}v=H+I|0;c[o>>2]=H;c[l>>2]=v;D=H+q|0;c[j>>2]=D;J=H+s|0;c[r>>2]=J;K=D;L=v;M=J;N=n;break L4}}while(0);n=bT(-1,-1,0)|0;bD(n|0)|0;a$();e=-1;return e|0}else{K=k;L=m;M=c[b+44>>2]|0;N=b+48|0}}while(0);m=K+1|0;k=m>>>0<M>>>0?M:m;c[b+44>>2]=k;if((c[N>>2]&8|0)!=0){N=b+32|0;if((a[N]&1)==0){O=N+1|0}else{O=c[b+40>>2]|0}c[h>>2]=O;c[g>>2]=O+i;c[b+16>>2]=k}if((K|0)==(L|0)){e=cV[c[(c[b>>2]|0)+52>>2]&1023](f,d&255)|0;return e|0}else{c[j>>2]=m;a[K]=d;e=d&255;return e|0}return 0}function fI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=b+32|0;do{if((e|0)!=(d|0)){f=a[d]|0;if((f&1)==0){g=d+1|0}else{g=c[d+8>>2]|0}h=f&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}h=e;f=e;j=a[f]|0;if((j&1)==0){k=10;l=j}else{j=c[e>>2]|0;k=(j&-2)-1|0;l=j&255}if(k>>>0<i>>>0){j=l&255;if((j&1|0)==0){m=j>>>1}else{m=c[b+36>>2]|0}Ej(e,k,i-k|0,m,0,m,i,g);break}if((l&1)==0){n=h+1|0}else{n=c[b+40>>2]|0}LG(n|0,g|0,i|0)|0;a[n+i|0]=0;if((a[f]&1)==0){a[f]=i<<1;break}else{c[b+36>>2]=i;break}}}while(0);i=b+44|0;c[i>>2]=0;n=b+48|0;g=c[n>>2]|0;if((g&8|0)!=0){l=e;m=a[e]|0;k=(m&1)==0;if(k){o=l+1|0}else{o=c[b+40>>2]|0}d=m&255;if((d&1|0)==0){p=d>>>1}else{p=c[b+36>>2]|0}d=o+p|0;c[i>>2]=d;if(k){q=l+1|0;r=l+1|0}else{l=c[b+40>>2]|0;q=l;r=l}c[b+8>>2]=r;c[b+12>>2]=q;c[b+16>>2]=d}if((g&16|0)==0){return}g=e;d=e;q=a[d]|0;r=q&255;if((r&1|0)==0){s=r>>>1}else{s=c[b+36>>2]|0}if((q&1)==0){c[i>>2]=g+1+s;t=10;u=q}else{c[i>>2]=(c[b+40>>2]|0)+s;i=c[e>>2]|0;t=(i&-2)-1|0;u=i&255}i=u&255;if((i&1|0)==0){v=i>>>1}else{v=c[b+36>>2]|0}do{if(v>>>0<t>>>0){Ef(e,t-v|0,0)|0}else{if((u&1)==0){a[g+1+t|0]=0;a[d]=t<<1;break}else{a[(c[b+40>>2]|0)+t|0]=0;c[b+36>>2]=t;break}}}while(0);t=a[d]|0;if((t&1)==0){w=g+1|0;x=g+1|0}else{g=c[b+40>>2]|0;w=g;x=g}g=t&255;if((g&1|0)==0){y=g>>>1}else{y=c[b+36>>2]|0}g=b+24|0;c[g>>2]=x;c[b+20>>2]=x;c[b+28>>2]=w+y;if((c[n>>2]&3|0)==0){return}c[g>>2]=x+s;return}function fJ(b,d){b=b|0;d=d|0;if((d|0)==0){return}fJ(b,c[d>>2]|0);fJ(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){Lw(c[d+24>>2]|0)}Lw(d);return}function fK(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;k=i;i=i+80|0;l=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=b|0;r=e;if((a[r]&1)==0){s=l;c[s>>2]=c[r>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2]}else{r=c[e+8>>2]|0;s=c[e+4>>2]|0;if(s>>>0>4294967279>>>0){D5(0)}if(s>>>0<11>>>0){a[l]=s<<1;t=l+1|0}else{e=s+16&-16;u=Lu(e)|0;c[l+8>>2]=u;c[l>>2]=e|1;c[l+4>>2]=s;t=u}LF(t|0,r|0,s)|0;a[t+s|0]=0}s=m;t=f;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];z=0;aD(6,q|0,l|0,m|0,0,0,0);if(z){z=0;m=bT(-1,-1)|0;q=m;m=M;if((a[l]&1)==0){v=m;w=q;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[l+8>>2]|0);v=m;w=q;x=w;y=0;A=x;B=v;bg(A|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}l=b|0;c[l>>2]=17440;c[b+36>>2]=g;g=b+40|0;q=h;L22:do{if((a[q]&1)==0){m=g;c[m>>2]=c[q>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];C=m;D=22}else{m=c[h+8>>2]|0;t=c[h+4>>2]|0;do{if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(t>>>0<11>>>0){s=g;a[s]=t<<1;E=g+1|0;F=s}else{s=t+16&-16;f=(z=0,au(248,s|0)|0);if(z){z=0;break}c[b+48>>2]=f;c[g>>2]=s|1;c[b+44>>2]=t;E=f;F=g}LF(E|0,m|0,t)|0;a[E+t|0]=0;C=F;D=22;break L22}}while(0);t=bT(-1,-1)|0;G=M;H=t}}while(0);do{if((D|0)==22){a[b+52|0]=j&1;F=d[C]|0;if((F&1|0)==0){I=F>>>1}else{I=c[b+44>>2]|0}if((I|0)==0|j^1){i=k;return}F=(z=0,au(248,64)|0);do{if(!z){E=n+8|0;c[E>>2]=F;c[n>>2]=65;c[n+4>>2]=50;LF(F|0,10592,50)|0;a[F+50|0]=0;g=b+4|0;L47:do{if((a[g]&1)==0){h=o;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];D=37}else{h=c[b+12>>2]|0;q=c[b+8>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(q>>>0<11>>>0){a[o]=q<<1;J=o+1|0}else{t=q+16&-16;m=(z=0,au(248,t|0)|0);if(z){z=0;break}c[o+8>>2]=m;c[o>>2]=t|1;c[o+4>>2]=q;J=m}LF(J|0,h|0,q)|0;a[J+q|0]=0;D=37;break L47}}while(0);q=bT(-1,-1)|0;K=M;L=q}}while(0);do{if((D|0)==37){g=p;q=b+16|0;c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];z=0;aR(382,n|0,o|0,p|0);if(z){z=0;q=bT(-1,-1)|0;g=q;q=M;if((a[o]&1)==0){K=q;L=g;break}Lw(c[o+8>>2]|0);K=q;L=g;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)==0){i=k;return}Lw(c[E>>2]|0);i=k;return}}while(0);if((a[n]&1)==0){N=K;O=L;break}Lw(c[E>>2]|0);N=K;O=L}else{z=0;g=bT(-1,-1)|0;N=M;O=g}}while(0);if((a[C]&1)==0){G=N;H=O;break}Lw(c[b+48>>2]|0);G=N;H=O}}while(0);c[l>>2]=17512;if((a[b+4|0]&1)==0){v=G;w=H;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[b+12>>2]|0);v=G;w=H;x=w;y=0;A=x;B=v;bg(A|0)}function fL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=d;if((a[m]&1)==0){n=l;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];o=a[n]|0;p=n}else{n=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){d=m<<1&255;q=l;a[q]=d;r=l+1|0;s=d;t=q}else{q=m+16&-16;d=Lu(q)|0;c[l+8>>2]=d;u=q|1;c[l>>2]=u;c[l+4>>2]=m;r=d;s=u&255;t=l}LF(r|0,n|0,m)|0;a[r+m|0]=0;o=s;p=t}t=e;e=k;c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];t=k;k=b|0;c[k>>2]=17512;e=b+4|0;L12:do{if((o&1)==0){s=e;c[s>>2]=c[p>>2];c[s+4>>2]=c[p+4>>2];c[s+8>>2]=c[p+8>>2]}else{s=c[l+8>>2]|0;m=c[l+4>>2]|0;do{if(m>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(m>>>0<11>>>0){a[e]=m<<1;v=e+1|0}else{r=m+16&-16;n=(z=0,au(248,r|0)|0);if(z){z=0;break}c[b+12>>2]=n;c[e>>2]=r|1;c[b+8>>2]=m;v=n}LF(v|0,s|0,m)|0;a[v+m|0]=0;break L12}}while(0);m=bT(-1,-1)|0;if((a[p]&1)==0){bg(m|0)}Lw(s);bg(m|0)}}while(0);v=b+16|0;c[v>>2]=c[t>>2];c[v+4>>2]=c[t+4>>2];c[v+8>>2]=c[t+8>>2];if((a[p]&1)==0){c[k>>2]=22848;w=b+28|0;x=f&1;a[w]=x;y=b+29|0;A=g&1;a[y]=A;B=b+32|0;c[B>>2]=h;i=j;return}Lw(c[l+8>>2]|0);c[k>>2]=22848;w=b+28|0;x=f&1;a[w]=x;y=b+29|0;A=g&1;a[y]=A;B=b+32|0;c[B>>2]=h;i=j;return}function fM(b){b=b|0;var d=0;d=b|0;c[d>>2]=17440;if((a[b+40|0]&1)!=0){Lw(c[b+48>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function fN(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=17440;if((a[b+40|0]&1)!=0){Lw(c[b+48>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function fO(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+160>>2]&1023](b,a);return}function fP(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function fQ(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function fR(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function fS(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function fT(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+160>>2]&511](a,d,b);return}function fU(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+160>>2]&511](a,d,b);return}function fV(a){a=a|0;return 1}function fW(b,c){b=b|0;c=c|0;a[b]=0;a[b+1|0]=0;return}function fX(a){a=a|0;return 0}function fY(a){a=a|0;return 0}function fZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aD(6,m|0,k|0,l|0,0,0,0);if(z){z=0;l=bT(-1,-1)|0;m=l;l=M;if((a[k]&1)==0){r=l;s=m;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=l;s=m;t=s;u=0;v=t;w=r;bg(v|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=b+36|0;c[k>>2]=22672;m=b+40|0;c[m>>2]=0;l=b+44|0;c[l>>2]=0;p=b+48|0;c[p>>2]=0;if((f|0)==0){x=b|0;c[x>>2]=19592;c[k>>2]=19652;y=b+52|0;c[y>>2]=g;A=b+56|0;B=h&1;a[A]=B;C=b+32|0;c[C>>2]=5;i=j;return}o=(z=0,au(248,f<<2|0)|0);if(!z){e=o;c[m>>2]=e;c[l>>2]=e;c[p>>2]=e+(f<<2);x=b|0;c[x>>2]=19592;c[k>>2]=19652;y=b+52|0;c[y>>2]=g;A=b+56|0;B=h&1;a[A]=B;C=b+32|0;c[C>>2]=5;i=j;return}else{z=0}j=bT(-1,-1)|0;C=j;j=M;c[b>>2]=17512;if((a[b+4|0]&1)==0){r=j;s=C;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[b+12>>2]|0);r=j;s=C;t=s;u=0;v=t;w=r;bg(v|0)}function f_(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+36>>2]=22672;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function f$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+36>>2]=22672;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(d)}c[b>>2]=17512;if((a[b+4|0]&1)==0){h=b;Lw(h);return}Lw(c[b+12>>2]|0);h=b;Lw(h);return}function f0(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+92>>2]&1023](b,a);return}function f1(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function f2(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function f3(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function f4(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function f5(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+92>>2]&511](a,d,b);return}function f6(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+92>>2]&511](a,d,b);return}function f7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(a[d+56|0]&1)!=0?10384:10120;d=LJ(e|0)|0;if(d>>>0>4294967279>>>0){D5(0)}if(d>>>0<11>>>0){a[b]=d<<1;f=b+1|0;LF(f|0,e|0,d)|0;g=f+d|0;a[g]=0;return}else{h=d+16&-16;i=Lu(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=d;f=i;LF(f|0,e|0,d)|0;g=f+d|0;a[g]=0;return}}function f8(a){a=a|0;return(c[a+44>>2]|0)==(c[a+40>>2]|0)|0}function f9(a,b){a=a|0;b=b|0;return}function ga(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-60+24|0;c[d+36>>2]=22672;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){return}Lw(c[d+12>>2]|0);return}function gb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+24|0;c[d+36>>2]=22672;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}Lw(b)}c[d>>2]=17512;if((a[d+4|0]&1)==0){h=d;Lw(h);return}Lw(c[d+12>>2]|0);h=d;Lw(h);return}function gc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0;e=i;i=i+96|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=b|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=c[d>>2];n=b+16|0;c[n>>2]=0;o=b+20|0;c[o>>2]=0;c[b+24>>2]=0;p=b+28|0;z=0;as(294,p|0,d+48|0);do{if(!z){q=b+40|0;c[q>>2]=0;r=b+44|0;c[r>>2]=0;c[b+48>>2]=0;s=b+52|0;t=s|0;u=b+56|0;c[u>>2]=0;c[b+60>>2]=0;c[s>>2]=u;u=b+64|0;s=d+16|0;L3:do{if((a[s]&1)==0){v=g;c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];w=12}else{v=c[d+24>>2]|0;x=c[d+20>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(x>>>0<11>>>0){a[g]=x<<1;y=g+1|0}else{A=x+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[g+8>>2]=B;c[g>>2]=A|1;c[g+4>>2]=x;y=B}LF(y|0,v|0,x)|0;a[y+x|0]=0;w=12;break L3}}while(0);x=bT(-1,-1)|0;C=M;D=x}}while(0);L16:do{if((w|0)==12){z=0;as(102,f|0,g|0);do{if(!z){z=0;as(12,u|0,f|0);if(z){z=0;s=bT(-1,-1)|0;x=s;s=M;if((a[f]&1)==0){E=s;F=x;break}Lw(c[f+8>>2]|0);E=s;F=x;break}if((a[f]&1)!=0){Lw(c[f+8>>2]|0)}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}x=b+116|0;c[x>>2]=0;s=b+120|0;c[s>>2]=0;c[b+124>>2]=0;v=b+128|0;B=d+28|0;L30:do{if((a[B]&1)==0){A=v;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];w=28}else{A=c[d+36>>2]|0;G=c[d+32>>2]|0;do{if(G>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(G>>>0<11>>>0){a[v]=G<<1;H=v+1|0}else{I=G+16&-16;J=(z=0,au(248,I|0)|0);if(z){z=0;break}c[b+136>>2]=J;c[v>>2]=I|1;c[b+132>>2]=G;H=J}LF(H|0,A|0,G)|0;a[H+G|0]=0;w=28;break L30}}while(0);G=bT(-1,-1)|0;K=M;L=G}}while(0);do{if((w|0)==28){a[b+140|0]=a[d+60|0]&1;a[b+141|0]=a[d+61|0]&1;c[b+144>>2]=c[d+64>>2];B=b+148|0;G=d+68|0;L45:do{if((a[G]&1)==0){A=B;c[A>>2]=c[G>>2];c[A+4>>2]=c[G+4>>2];c[A+8>>2]=c[G+8>>2];w=38}else{A=c[d+76>>2]|0;J=c[d+72>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(J>>>0<11>>>0){a[B]=J<<1;N=B+1|0}else{I=J+16&-16;O=(z=0,au(248,I|0)|0);if(z){z=0;break}c[b+156>>2]=O;c[B>>2]=I|1;c[b+152>>2]=J;N=O}LF(N|0,A|0,J)|0;a[N+J|0]=0;w=38;break L45}}while(0);J=bT(-1,-1)|0;P=M;Q=J}}while(0);do{if((w|0)==38){G=b+160|0;J=b+164|0;c[J>>2]=0;c[b+168>>2]=0;c[G>>2]=J;J=b+172|0;A=b+176|0;c[A>>2]=0;c[b+180>>2]=0;c[J>>2]=A;c[b+184>>2]=c[d+80>>2];A=b+188|0;O=b+192|0;I=b+200|0;R=G|0;G=J|0;J=b+212|0;S=J|0;T=b+216|0;c[T>>2]=0;c[b+220>>2]=0;LI(A|0,0,24)|0;c[J>>2]=T;T=b+224|0;J=b+228|0;LI(T|0,0,24)|0;c[b+236>>2]=b+240;z=0;as(276,h|0,0);L60:do{if(!z){z=0,aM(344,I|0,h|0)|0;if(z){z=0;U=bT(-1,-1)|0;V=U;U=M;if((a[h]&1)==0){W=U;X=V;break}Lw(c[h+8>>2]|0);W=U;X=V;break}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}z=0;as(508,b|0,c[d+40>>2]|0);if(z){z=0;w=96;break}z=0;as(266,b|0,0);if(z){z=0;w=96;break}z=0;ar(270,b|0);if(z){z=0;w=96;break}V=d+4|0;if((a[V]&1)==0){U=j;c[U>>2]=c[V>>2];c[U+4>>2]=c[V+4>>2];c[U+8>>2]=c[V+8>>2];Y=a[U]|0;Z=U}else{U=c[d+12>>2]|0;V=c[d+8>>2]|0;if(V>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;w=96;break}}if(V>>>0<11>>>0){_=V<<1&255;$=j;a[$]=_;aa=j+1|0;ab=_;ac=$}else{$=V+16&-16;_=(z=0,au(248,$|0)|0);if(z){z=0;w=96;break}c[j+8>>2]=_;ad=$|1;c[j>>2]=ad;c[j+4>>2]=V;aa=_;ab=ad&255;ac=j}LF(aa|0,U|0,V)|0;a[aa+V|0]=0;Y=ab;Z=ac}V=Y&255;if((V&1|0)==0){ae=V>>>1}else{ae=c[j+4>>2]|0}L89:do{if((ae|0)!=0){V=(Y&1)==0;L91:do{if(V){U=l;c[U>>2]=c[Z>>2];c[U+4>>2]=c[Z+4>>2];c[U+8>>2]=c[Z+8>>2];w=69}else{U=c[j+8>>2]|0;ad=c[j+4>>2]|0;do{if(ad>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(ad>>>0<11>>>0){a[l]=ad<<1;af=l+1|0}else{_=ad+16&-16;$=(z=0,au(248,_|0)|0);if(z){z=0;break}c[l+8>>2]=$;c[l>>2]=_|1;c[l+4>>2]=ad;af=$}LF(af|0,U|0,ad)|0;a[af+ad|0]=0;w=69;break L91}}while(0);ad=bT(-1,-1)|0;ag=M;ah=ad}}while(0);do{if((w|0)==69){z=0;aR(384,k|0,b|0,l|0);if(z){z=0;ad=bT(-1,-1)|0;U=ad;ad=M;if((a[l]&1)==0){ag=ad;ah=U;break}Lw(c[l+8>>2]|0);ag=ad;ah=U;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}U=a[k]|0;ad=U&255;if((ad&1|0)==0){ai=ad>>>1}else{ai=c[k+4>>2]|0}if((ai|0)!=0){if((U&1)==0){break L89}Lw(c[k+8>>2]|0);break L89}ad=cl(12)|0;L121:do{if(V){c[ad>>2]=c[Z>>2];c[ad+4>>2]=c[Z+4>>2];c[ad+8>>2]=c[Z+8>>2];w=86}else{$=c[j+8>>2]|0;_=c[j+4>>2]|0;do{if(_>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(_>>>0<11>>>0){a[ad]=_<<1;aj=ad+1|0}else{ak=_+16&-16;al=(z=0,au(248,ak|0)|0);if(z){z=0;break}c[ad+8>>2]=al;c[ad>>2]=ak|1;c[ad+4>>2]=_;aj=al}LF(aj|0,$|0,_)|0;a[aj+_|0]=0;w=86;break L121}}while(0);_=bT(-1,-1)|0;$=M;bo(ad|0);am=$;an=_}}while(0);do{if((w|0)==86){z=0;aR(156,ad|0,30688,300);if(z){z=0;_=bT(-1,-1)|0;am=M;an=_;break}}}while(0);if((U&1)==0){ag=am;ah=an;break}Lw(c[k+8>>2]|0);ag=am;ah=an}}while(0);if(V){W=ag;X=ah;break L60}Lw(c[j+8>>2]|0);W=ag;X=ah;break L60}}while(0);if((Y&1)==0){i=e;return}Lw(c[j+8>>2]|0);i=e;return}else{z=0;w=96}}while(0);if((w|0)==96){ad=bT(-1,-1)|0;W=M;X=ad}hi(b+236|0,c[b+240>>2]|0);ad=c[T>>2]|0;_=ad;if((ad|0)!=0){$=c[J>>2]|0;if((ad|0)!=($|0)){c[J>>2]=$+(~(($-8+(-_|0)|0)>>>3)<<3)}Lw(ad)}hh(S,c[b+216>>2]|0);if((a[I]&1)!=0){Lw(c[b+208>>2]|0)}ad=c[A>>2]|0;if((ad|0)!=0){_=c[O>>2]|0;if((ad|0)==(_|0)){ao=ad}else{$=_;while(1){_=$-12|0;c[O>>2]=_;if((a[_]&1)==0){ap=_}else{Lw(c[$-12+8>>2]|0);ap=c[O>>2]|0}if((ad|0)==(ap|0)){break}else{$=ap}}ao=c[A>>2]|0}Lw(ao)}hg(G,c[b+176>>2]|0);hf(R,c[b+164>>2]|0);if((a[B]&1)==0){P=W;Q=X;break}Lw(c[b+156>>2]|0);P=W;Q=X}}while(0);if((a[v]&1)==0){K=P;L=Q;break}Lw(c[b+136>>2]|0);K=P;L=Q}}while(0);v=c[x>>2]|0;B=v;if((v|0)!=0){$=c[s>>2]|0;if((v|0)!=($|0)){c[s>>2]=$+(~((($-12+(-B|0)|0)>>>0)/12|0)*12|0)}Lw(v)}z=0;ar(154,u|0);if(!z){C=K;D=L;break L16}else{z=0}aq=bT(-1,-1,0)|0;at=M;bX()}else{z=0;v=bT(-1,-1)|0;E=M;F=v}}while(0);if((a[g]&1)==0){C=E;D=F;break}Lw(c[g+8>>2]|0);C=E;D=F}}while(0);hd(t,c[b+56>>2]|0);u=c[q>>2]|0;if((u|0)!=0){v=c[r>>2]|0;if((u|0)==(v|0)){av=u}else{B=v;while(1){v=B-16|0;c[r>>2]=v;if((a[v]&1)==0){aw=v}else{Lw(c[B-16+8>>2]|0);aw=c[r>>2]|0}if((u|0)==(aw|0)){break}else{B=aw}}av=c[q>>2]|0}Lw(av)}B=p|0;u=c[B>>2]|0;if((u|0)==0){ax=C;ay=D;break}r=b+32|0;t=c[r>>2]|0;if((u|0)==(t|0)){az=u}else{v=t;while(1){t=v-12|0;c[r>>2]=t;if((a[t]&1)==0){aA=t}else{Lw(c[v-12+8>>2]|0);aA=c[r>>2]|0}if((u|0)==(aA|0)){break}else{v=aA}}az=c[B>>2]|0}Lw(az);ax=C;ay=D}else{z=0;v=bT(-1,-1)|0;ax=M;ay=v}}while(0);ax=c[n>>2]|0;n=ax;if((ax|0)!=0){D=c[o>>2]|0;if((ax|0)!=(D|0)){c[o>>2]=D+(~((D-4+(-n|0)|0)>>>2)<<2)}Lw(ax)}z=0;ar(290,m|0);if(!z){bg(ay|0)}else{z=0;aq=bT(-1,-1,0)|0;at=M;bX()}}function gd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+1024|0;e=bA(d|0,1024)|0;f=LJ(e|0)|0;if(f>>>0>4294967279>>>0){D5(0)}if(f>>>0<11>>>0){g=f<<1&255;h=b;j=b;a[j]=g;k=h+1|0;l=g;m=h;n=j}else{j=f+16&-16;h=Lu(j)|0;c[b+8>>2]=h;g=j|1;c[b>>2]=g;c[b+4>>2]=f;k=h;l=g&255;m=b;n=b}LF(k|0,e|0,f)|0;a[k+f|0]=0;f=l&255;if((f&1|0)==0){o=f>>>1}else{o=c[b+4>>2]|0}if((l&1)==0){p=m+1|0}else{p=c[b+8>>2]|0}if((a[p+(o-1)|0]|0)==47){i=d;return}if((l&1)==0){q=(l&255)>>>1;r=10}else{q=c[b+4>>2]|0;r=(c[b>>2]&-2)-1|0}do{if((q|0)==(r|0)){z=0;aI(46,b|0,r|0,1,r|0,r|0,0,0);if(!z){s=a[n]|0;break}else{z=0}o=bT(-1,-1)|0;if((a[n]&1)==0){bg(o|0)}Lw(c[b+8>>2]|0);bg(o|0)}else{s=l}}while(0);if((s&1)==0){a[n]=(q<<1)+2;t=m+1|0;u=q+1|0}else{m=c[b+8>>2]|0;n=q+1|0;c[b+4>>2]=n;t=m;u=n}a[t+q|0]=47;a[t+u|0]=0;i=d;return}function ge(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+28|0;j=b+200|0;k=b+32|0;l=c[k>>2]|0;m=b+36|0;if((l|0)==(c[m>>2]|0)){e6(h,j)}else{do{if((l|0)!=0){n=j;if((a[n]&1)==0){o=l;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];break}n=c[b+208>>2]|0;o=c[b+204>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[l]=o<<1;p=l+1|0}else{q=o+16&-16;r=Lu(q)|0;c[l+8>>2]=r;c[l>>2]=q|1;c[l+4>>2]=o;p=r}LF(p|0,n|0,o)|0;a[p+o|0]=0}}while(0);c[k>>2]=(c[k>>2]|0)+12}if((d|0)==0){i=e;return}else{s=d}while(1){t=a[s]|0;if((t<<24>>24|0)==58|(t<<24>>24|0)==0){break}s=s+1|0}p=t<<24>>24!=0?s:0;L24:do{if((p|0)==0){u=d}else{s=f;t=f+1|0;l=f+8|0;b=f+4|0;j=f|0;o=d;n=p;L26:while(1){r=n-o|0;if(r>>>0>4294967279>>>0){v=19;break}if(r>>>0<11>>>0){q=r<<1&255;a[s]=q;w=t;x=q}else{q=r+16&-16;y=Lu(q)|0;c[l>>2]=y;A=q|1;c[j>>2]=A;c[b>>2]=r;w=y;x=A&255}LF(w|0,o|0,r)|0;a[w+r|0]=0;r=x&255;do{if((((r&1|0)==0?r>>>1:c[b>>2]|0)|0)!=0){A=x&255;if((a[((x&1)==0?t:c[l>>2]|0)+(((A&1|0)==0?A>>>1:c[b>>2]|0)-1)|0]|0)!=47){if((x&1)==0){B=(x&255)>>>1;C=10;D=x}else{A=c[j>>2]|0;B=c[b>>2]|0;C=(A&-2)-1|0;D=A&255}if((B|0)==(C|0)){if((C|0)==-17){v=30;break L26}A=(D&1)==0?t:c[l>>2]|0;do{if(C>>>0<2147483623>>>0){y=C+1|0;q=C<<1;E=y>>>0<q>>>0?q:y;if(E>>>0<11>>>0){F=11;break}F=E+16&-16}else{F=-17}}while(0);E=(z=0,au(248,F|0)|0);if(z){z=0;v=43;break L26}LF(E|0,A|0,C)|0;if((C|0)!=10){Lw(A)}c[l>>2]=E;E=F|1;c[j>>2]=E;G=E&255}else{G=x}if((G&1)==0){a[s]=(B<<1)+2;H=t;I=B+1|0}else{E=c[l>>2]|0;y=B+1|0;c[b>>2]=y;H=E;I=y}a[H+B|0]=47;a[H+I|0]=0}y=c[k>>2]|0;if((y|0)==(c[m>>2]|0)){z=0;as(284,h|0,f|0);if(!z){break}else{z=0;v=43;break L26}}do{if((y|0)!=0){if((a[s]&1)==0){E=y;c[E>>2]=c[s>>2];c[E+4>>2]=c[s+4>>2];c[E+8>>2]=c[s+8>>2];break}E=c[l>>2]|0;q=c[b>>2]|0;if(q>>>0>4294967279>>>0){v=52;break L26}if(q>>>0<11>>>0){a[y]=q<<1;J=y+1|0}else{K=q+16&-16;L=(z=0,au(248,K|0)|0);if(z){z=0;v=43;break L26}c[y+8>>2]=L;c[y>>2]=K|1;c[y+4>>2]=q;J=L}LF(J|0,E|0,q)|0;a[J+q|0]=0}}while(0);c[k>>2]=(c[k>>2]|0)+12}}while(0);r=n+1|0;y=r;while(1){N=a[y]|0;if((N<<24>>24|0)==58|(N<<24>>24|0)==0){break}y=y+1|0}A=N<<24>>24!=0?y:0;if((a[s]&1)!=0){Lw(c[l>>2]|0)}if((A|0)==0){u=r;break L24}else{o=r;n=A}}do{if((v|0)==30){z=0;ar(86,0);if(z){z=0;v=44;break}}else if((v|0)==43){n=bT(-1,-1)|0;O=M;P=n}else if((v|0)==19){D5(0)}else if((v|0)==52){z=0;ar(86,0);if(z){z=0;v=44;break}}}while(0);if((v|0)==44){n=bT(-1,-1)|0;O=M;P=n}n=P;o=O;if((a[s]&1)==0){Q=o;R=n;S=R;T=0;U=S;V=Q;bg(U|0)}Lw(c[l>>2]|0);Q=o;R=n;S=R;T=0;U=S;V=Q;bg(U|0)}}while(0);O=LJ(u|0)|0;if(O>>>0>4294967279>>>0){D5(0)}if(O>>>0<11>>>0){P=O<<1&255;N=g;J=g;a[J]=P;W=N+1|0;X=P;Y=N;Z=J}else{J=O+16&-16;N=Lu(J)|0;c[g+8>>2]=N;P=J|1;c[g>>2]=P;c[g+4>>2]=O;W=N;X=P&255;Y=g;Z=g}LF(W|0,u|0,O)|0;a[W+O|0]=0;O=X&255;if((O&1|0)==0){_=O>>>1}else{_=c[g+4>>2]|0}L107:do{if((_|0)!=0){if((X&1)==0){$=Y+1|0}else{$=c[g+8>>2]|0}O=X&255;if((O&1|0)==0){aa=O>>>1}else{aa=c[g+4>>2]|0}do{if((a[$+(aa-1)|0]|0)==47){v=106}else{if((X&1)==0){ab=(X&255)>>>1;ac=10;ad=X}else{O=c[g>>2]|0;ab=c[g+4>>2]|0;ac=(O&-2)-1|0;ad=O&255}if((ab|0)==(ac|0)){if((ac|0)==-17){z=0;ar(86,0);if(z){z=0;break}}if((ad&1)==0){ae=Y+1|0}else{ae=c[g+8>>2]|0}do{if(ac>>>0<2147483623>>>0){O=ac+1|0;W=ac<<1;u=O>>>0<W>>>0?W:O;if(u>>>0<11>>>0){af=11;break}af=u+16&-16}else{af=-17}}while(0);r=(z=0,au(248,af|0)|0);if(z){z=0;break}LF(r|0,ae|0,ac)|0;if((ac|0)!=10){Lw(ae)}c[g+8>>2]=r;r=af|1;c[g>>2]=r;ag=r&255}else{ag=X}if((ag&1)==0){a[Z]=(ab<<1)+2;ah=Y+1|0;ai=ab+1|0}else{r=c[g+8>>2]|0;y=ab+1|0;c[g+4>>2]=y;ah=r;ai=y}a[ah+ab|0]=47;a[ah+ai|0]=0;v=106}}while(0);L146:do{if((v|0)==106){l=c[k>>2]|0;if((l|0)==(c[m>>2]|0)){z=0;as(284,h|0,g|0);if(!z){break L107}else{z=0;break}}do{if((l|0)!=0){if((a[Z]&1)==0){s=l;c[s>>2]=c[Z>>2];c[s+4>>2]=c[Z+4>>2];c[s+8>>2]=c[Z+8>>2];break}s=c[g+8>>2]|0;y=c[g+4>>2]|0;if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break L146}}if(y>>>0<11>>>0){a[l]=y<<1;aj=l+1|0}else{r=y+16&-16;u=(z=0,au(248,r|0)|0);if(z){z=0;break L146}c[l+8>>2]=u;c[l>>2]=r|1;c[l+4>>2]=y;aj=u}LF(aj|0,s|0,y)|0;a[aj+y|0]=0}}while(0);c[k>>2]=(c[k>>2]|0)+12;break L107}}while(0);l=bT(-1,-1)|0;y=l;l=M;if((a[Z]&1)==0){Q=l;R=y;S=R;T=0;U=S;V=Q;bg(U|0)}Lw(c[g+8>>2]|0);Q=l;R=y;S=R;T=0;U=S;V=Q;bg(U|0)}}while(0);if((a[Z]&1)==0){i=e;return}Lw(c[g+8>>2]|0);i=e;return}function gf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d|0;gd(e,0);f=b+32|0;g=c[f>>2]|0;L1:do{if((g|0)==(c[b+36>>2]|0)){z=0;as(284,b+28|0,e|0);if(z){z=0;h=33}}else{do{if((g|0)!=0){j=e;if((a[j]&1)==0){k=g;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];break}j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;h=33;break L1}}if(k>>>0<11>>>0){a[g]=k<<1;l=g+1|0}else{m=k+16&-16;n=(z=0,au(248,m|0)|0);if(z){z=0;h=33;break L1}c[g+8>>2]=n;c[g>>2]=m|1;c[g+4>>2]=k;l=n}LF(l|0,j|0,k)|0;a[l+k|0]=0}}while(0);c[f>>2]=(c[f>>2]|0)+12}}while(0);if((h|0)==33){h=bT(-1,-1)|0;if((a[e]&1)==0){bg(h|0)}Lw(c[e+8>>2]|0);bg(h|0)}if((a[e]&1)!=0){Lw(c[e+8>>2]|0)}e=c[f>>2]|0;f=e-12|0;h=a[f]|0;l=(h&1)==0;if(l){o=f+1|0}else{o=c[e-12+8>>2]|0}f=h&255;if((f&1|0)==0){p=f>>>1}else{p=c[e-12+4>>2]|0}if((a[o+(p-1)|0]|0)==47){i=d;return}p=e-12|0;o=p;if(l){q=f>>>1;r=10}else{q=c[e-12+4>>2]|0;r=(c[p>>2]&-2)-1|0}if((q|0)==(r|0)){Ek(p,r,1,r,r,0,0);s=a[o]|0}else{s=h}if((s&1)==0){a[o]=(q<<1)+2;t=p+1|0;u=q+1|0}else{p=c[e-12+8>>2]|0;o=q+1|0;c[e-12+4>>2]=o;t=p;u=o}a[t+q|0]=47;a[t+u|0]=0;i=d;return}function gg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;d=i;i=i+80|0;e=d|0;f=d+16|0;g=d+24|0;j=d+40|0;k=d+56|0;l=d+72|0;m=c[9416]|0;if((m|0)==0){i=d;return}n=g;o=g+1|0;p=b+4|0;q=b+8|0;r=b|0;s=j+8|0;t=j|0;u=j+4|0;v=k;w=k+1|0;x=e|0;y=e+4|0;A=e+8|0;B=j;C=b+160|0;D=b+172|0;E=g+8|0;F=k+8|0;G=g|0;H=g+4|0;I=0;J=m;while(1){m=LJ(J|0)|0;if(m>>>0>4294967279>>>0){K=4;break}if(m>>>0<11>>>0){a[n]=m<<1;L=o}else{N=m+16&-16;O=Lu(N)|0;c[E>>2]=O;c[G>>2]=N|1;c[H>>2]=m;L=O}LF(L|0,J|0,m)|0;a[L+m|0]=0;m=(z=0,au(248,88)|0);if(z){z=0;K=27;break}O=m;c[f>>2]=O;m=c[p>>2]|0;if((m|0)==(c[q>>2]|0)){z=0;as(382,r|0,f|0);if(z){z=0;K=27;break}P=c[f>>2]|0}else{if((m|0)==0){Q=0}else{c[m>>2]=O;Q=c[p>>2]|0}c[p>>2]=Q+4;P=O}R=P;O=P;m=(z=0,au(248,16)|0);if(z){z=0;K=28;break}c[s>>2]=m;c[t>>2]=17;c[u>>2]=13;LF(m|0,10680,13)|0;a[m+13|0]=0;m=I*3|0;S=+h[32648+(m<<3)>>3];T=+h[32648+(m+1<<3)>>3];U=+h[32648+(m+2<<3)>>3];a[v]=0;a[w]=0;c[x>>2]=0;c[y>>2]=0;c[A>>2]=0;z=0;av(2,O|0,j|0,e|0,+S,+T,+U,+1.0,k|0);if(z){z=0;K=29;break}if((a[v]&1)!=0){Lw(c[F>>2]|0)}if((a[B]&1)!=0){Lw(c[s>>2]|0)}m=(z=0,aM(262,C|0,g|0)|0);if(z){z=0;K=27;break}c[m>>2]=O;c[l>>2]=~~(U+ +(~~(T*256.0+ +(~~(S*65536.0)|0))|0));O=(z=0,aM(722,D|0,l|0)|0);if(z){z=0;K=27;break}z=0,aM(344,O|0,g|0)|0;if(z){z=0;K=27;break}O=I+1|0;if((a[n]&1)!=0){Lw(c[E>>2]|0)}m=c[37664+(O<<2)>>2]|0;if((m|0)==0){K=44;break}else{I=O;J=m}}do{if((K|0)==29){J=bT(-1,-1)|0;I=J;J=M;if((a[v]&1)!=0){Lw(c[F>>2]|0)}if((a[B]&1)==0){V=J;W=I;K=33;break}Lw(c[s>>2]|0);V=J;W=I;K=33}else if((K|0)==4){D5(0)}else if((K|0)==44){i=d;return}else if((K|0)==27){I=bT(-1,-1)|0;X=M;Y=I}else if((K|0)==28){I=bT(-1,-1)|0;V=M;W=I;K=33}}while(0);if((K|0)==33){K=c[b>>2]|0;b=c[p>>2]|0;d=K;while(1){if((d|0)==(b|0)){Z=b;break}if((c[d>>2]|0)==(P|0)){Z=d;break}else{d=d+4|0}}d=Z-K>>2;Z=K+(d+1<<2)|0;P=b-Z|0;LG(K+(d<<2)|0,Z|0,P|0)|0;Z=K+((P>>2)+d<<2)|0;d=c[p>>2]|0;if((Z|0)!=(d|0)){c[p>>2]=d+(~((d-4+(-Z|0)|0)>>>2)<<2)}Lw(R);X=V;Y=W}if((a[n]&1)==0){_=Y;$=0;aa=_;ab=X;bg(aa|0)}Lw(c[E>>2]|0);_=Y;$=0;aa=_;ab=X;bg(aa|0)}function gh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0;f=i;i=i+16|0;g=f|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+4|0;i=i+7&-8;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;LI(h|0,0,12)|0;s=b;t=d+28|0;u=((c[d+32>>2]|0)-(c[t>>2]|0)|0)/12|0;v=k;w=e;x=l;y=d+188|0;A=d+192|0;B=d+196|0;C=d+52|0;D=C|0;E=j;F=m;G=d+20|0;H=d+24|0;I=d+16|0;J=d+40|0;K=q;L=p;N=p+12|0;O=o;P=o+12|0;Q=d+44|0;R=d+48|0;S=d+64|0;T=d+148|0;U=d+200|0;V=d+68|0;W=d+72|0;d=r;X=j+8|0;Y=j+4|0;Z=b+1|0;_=b+8|0;$=b|0;aa=b+4|0;b=r+8|0;ab=r+4|0;ac=q+8|0;ad=p+8|0;ae=o+8|0;af=o+4|0;ag=p+4|0;ah=o+1|0;ai=o|0;aj=q+4|0;ak=p+1|0;al=p|0;p=q+1|0;am=q|0;q=g+8|0;an=g+4|0;ao=m+8|0;ap=m+1|0;aq=m|0;at=m+4|0;av=k+8|0;aw=l+8|0;ax=e+8|0;ay=e+4|0;e=l+1|0;az=l|0;aA=l+4|0;aB=k+1|0;aC=k|0;aD=k+4|0;aE=0;L1:while(1){if(aE>>>0>=u>>>0){aF=204;break}aG=c[t>>2]|0;aH=aG+(aE*12|0)|0;if((a[aH]&1)==0){c[v>>2]=c[aH>>2];c[v+4>>2]=c[aH+4>>2];c[v+8>>2]=c[aH+8>>2]}else{aH=c[aG+(aE*12|0)+8>>2]|0;aI=c[aG+(aE*12|0)+4>>2]|0;if(aI>>>0>4294967279>>>0){aF=6;break}if(aI>>>0<11>>>0){a[v]=aI<<1;aJ=aB}else{aG=aI+16&-16;aK=(z=0,au(248,aG|0)|0);if(z){z=0;aF=53;break}c[av>>2]=aK;c[aC>>2]=aG|1;c[aD>>2]=aI;aJ=aK}LF(aJ|0,aH|0,aI)|0;a[aJ+aI|0]=0}if((a[w]&1)==0){c[x>>2]=c[w>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2]}else{aI=c[ax>>2]|0;aH=c[ay>>2]|0;if(aH>>>0>4294967279>>>0){aF=16;break}if(aH>>>0<11>>>0){a[x]=aH<<1;aL=e}else{aK=aH+16&-16;aG=(z=0,au(248,aK|0)|0);if(z){z=0;aF=56;break}c[aw>>2]=aG;c[az>>2]=aK|1;c[aA>>2]=aH;aL=aG}LF(aL|0,aI|0,aH)|0;a[aL+aH|0]=0}z=0;aR(24,j|0,k|0,l|0);if(z){z=0;aF=59;break}if((a[x]&1)!=0){Lw(c[aw>>2]|0)}if((a[v]&1)!=0){Lw(c[av>>2]|0)}aH=c[A>>2]|0;if((aH|0)==(c[B>>2]|0)){z=0;as(284,y|0,j|0);if(z){z=0;aF=63;break}}else{do{if((aH|0)!=0){if((a[E]&1)==0){aI=aH;c[aI>>2]=c[E>>2];c[aI+4>>2]=c[E+4>>2];c[aI+8>>2]=c[E+8>>2];break}aI=c[X>>2]|0;aG=c[Y>>2]|0;if(aG>>>0>4294967279>>>0){aF=33;break L1}if(aG>>>0<11>>>0){a[aH]=aG<<1;aN=aH+1|0}else{aK=aG+16&-16;aO=(z=0,au(248,aK|0)|0);if(z){z=0;aF=63;break L1}c[aH+8>>2]=aO;c[aH>>2]=aK|1;c[aH+4>>2]=aG;aN=aO}LF(aN|0,aI|0,aG)|0;a[aN+aG|0]=0}}while(0);c[A>>2]=(c[A>>2]|0)+12}aH=(gD(D,j)|0)==0;aG=a[E]|0;aI=(aG&1)==0;do{if(aH){if(aI){c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2]}else{aO=c[X>>2]|0;aK=c[Y>>2]|0;if(aK>>>0>4294967279>>>0){aF=69;break L1}if(aK>>>0<11>>>0){a[F]=aK<<1;aP=ap}else{aQ=aK+16&-16;aS=(z=0,au(248,aQ|0)|0);if(z){z=0;aF=63;break L1}c[ao>>2]=aS;c[aq>>2]=aQ|1;c[at>>2]=aK;aP=aS}LF(aP|0,aO|0,aK)|0;a[aP+aK|0]=0}aK=(z=0,aM(328,m|0,g|0)|0);if(z){z=0;aF=179;break L1}if((a[F]&1)!=0){Lw(c[ao>>2]|0)}if((aK|0)==0){aT=0;aU=a[E]|0;break}c[n>>2]=aK;aO=c[G>>2]|0;if((aO|0)==(c[H>>2]|0)){z=0;as(26,I|0,n|0);if(z){z=0;aF=63;break L1}}else{if((aO|0)==0){aW=0}else{c[aO>>2]=aK;aW=c[G>>2]|0}c[G>>2]=aW+4}aO=c[A>>2]|0;if((aO|0)==(c[B>>2]|0)){z=0;as(284,y|0,g|0);if(z){z=0;aF=63;break L1}}else{do{if((aO|0)!=0){if((a[h]&1)==0){aS=aO;c[aS>>2]=c[h>>2];c[aS+4>>2]=c[h+4>>2];c[aS+8>>2]=c[h+8>>2];break}aS=c[q>>2]|0;aQ=c[an>>2]|0;if(aQ>>>0>4294967279>>>0){aF=91;break L1}if(aQ>>>0<11>>>0){a[aO]=aQ<<1;aX=aO+1|0}else{aY=aQ+16&-16;aZ=(z=0,au(248,aY|0)|0);if(z){z=0;aF=63;break L1}c[aO+8>>2]=aZ;c[aO>>2]=aY|1;c[aO+4>>2]=aQ;aX=aZ}LF(aX|0,aS|0,aQ)|0;a[aX+aQ|0]=0}}while(0);c[A>>2]=(c[A>>2]|0)+12}if((a[E]&1)==0){c[K>>2]=c[E>>2];c[K+4>>2]=c[E+4>>2];c[K+8>>2]=c[E+8>>2];a_=a[K]|0}else{aO=c[X>>2]|0;aQ=c[Y>>2]|0;if(aQ>>>0>4294967279>>>0){aF=103;break L1}if(aQ>>>0<11>>>0){aS=aQ<<1&255;a[K]=aS;a$=p;a0=aS}else{aS=aQ+16&-16;aZ=(z=0,au(248,aS|0)|0);if(z){z=0;aF=63;break L1}c[ac>>2]=aZ;aY=aS|1;c[am>>2]=aY;c[aj>>2]=aQ;a$=aZ;a0=aY&255}LF(a$|0,aO|0,aQ)|0;a[a$+aQ|0]=0;a_=a0}if((a_&1)==0){c[L>>2]=c[K>>2];c[L+4>>2]=c[K+4>>2];c[L+8>>2]=c[K+8>>2];a1=a[L]|0}else{aQ=c[ac>>2]|0;aO=c[aj>>2]|0;if(aO>>>0>4294967279>>>0){aF=113;break L1}if(aO>>>0<11>>>0){aY=aO<<1&255;a[L]=aY;a2=ak;a3=aY}else{aY=aO+16&-16;aZ=(z=0,au(248,aY|0)|0);if(z){z=0;aF=181;break L1}c[ad>>2]=aZ;aS=aY|1;c[al>>2]=aS;c[ag>>2]=aO;a2=aZ;a3=aS&255}LF(a2|0,aQ|0,aO)|0;a[a2+aO|0]=0;a1=a3}c[N>>2]=aK;if((a1&1)==0){c[O>>2]=c[L>>2];c[O+4>>2]=c[L+4>>2];c[O+8>>2]=c[L+8>>2]}else{aO=c[ad>>2]|0;aQ=c[ag>>2]|0;if(aQ>>>0>4294967279>>>0){aF=123;break L1}if(aQ>>>0<11>>>0){a[O]=aQ<<1;a4=ah}else{aS=aQ+16&-16;aZ=(z=0,au(248,aS|0)|0);if(z){z=0;aF=184;break L1}c[ae>>2]=aZ;c[ai>>2]=aS|1;c[af>>2]=aQ;a4=aZ}LF(a4|0,aO|0,aQ)|0;a[a4+aQ|0]=0}c[P>>2]=aK;aQ=c[Q>>2]|0;if((aQ|0)==(c[R>>2]|0)){z=0;as(532,J|0,o|0);if(z){z=0;aF=187;break L1}}else{if((aQ|0)==0){a5=0}else{a6=a[O]|0;if((a6&1)==0){aO=aQ;c[aO>>2]=c[O>>2];c[aO+4>>2]=c[O+4>>2];c[aO+8>>2]=c[O+8>>2]}else{aO=c[ae>>2]|0;aZ=c[af>>2]|0;if(aZ>>>0>4294967279>>>0){aF=135;break L1}if(aZ>>>0<11>>>0){a[aQ]=aZ<<1;a7=aQ+1|0}else{aS=aZ+16&-16;aY=(z=0,au(248,aS|0)|0);if(z){z=0;aF=187;break L1}c[aQ+8>>2]=aY;c[aQ>>2]=aS|1;c[aQ+4>>2]=aZ;a7=aY}LF(a7|0,aO|0,aZ)|0;a[a7+aZ|0]=0}c[aQ+12>>2]=aK;a5=c[Q>>2]|0}c[Q>>2]=a5+16}if((a[O]&1)!=0){Lw(c[ae>>2]|0)}if((a1&1)!=0){Lw(c[ad>>2]|0)}if((a_&1)!=0){Lw(c[ac>>2]|0)}z=0;aV(44,r|0,g|0,T|0,U|0);if(z){z=0;aF=63;break L1}aQ=c[V>>2]|0;if((aQ|0)==(c[W>>2]|0)){z=0;as(284,S|0,r|0);if(z){z=0;aF=195;break L1}}else{do{if((aQ|0)!=0){if((a[d]&1)==0){aZ=aQ;c[aZ>>2]=c[d>>2];c[aZ+4>>2]=c[d+4>>2];c[aZ+8>>2]=c[d+8>>2];break}aZ=c[b>>2]|0;aO=c[ab>>2]|0;if(aO>>>0>4294967279>>>0){aF=157;break L1}if(aO>>>0<11>>>0){a[aQ]=aO<<1;a8=aQ+1|0}else{aY=aO+16&-16;aS=(z=0,au(248,aY|0)|0);if(z){z=0;aF=195;break L1}c[aQ+8>>2]=aS;c[aQ>>2]=aY|1;c[aQ+4>>2]=aO;a8=aS}LF(a8|0,aZ|0,aO)|0;a[a8+aO|0]=0}}while(0);c[V>>2]=(c[V>>2]|0)+12}if((a[d]&1)!=0){Lw(c[b>>2]|0)}aQ=(z=0,aM(510,C|0,j|0)|0);if(z){z=0;aF=63;break L1}c[aQ>>2]=0;aQ=a[E]|0;if((aQ&1)==0){c[s>>2]=c[E>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];aT=1;aU=aQ;break}aK=c[X>>2]|0;aO=c[Y>>2]|0;if(aO>>>0>4294967279>>>0){aF=172;break L1}if(aO>>>0<11>>>0){a[s]=aO<<1;a9=Z}else{aZ=aO+16&-16;aS=(z=0,au(248,aZ|0)|0);if(z){z=0;aF=63;break L1}c[_>>2]=aS;c[$>>2]=aZ|1;c[aa>>2]=aO;a9=aS}LF(a9|0,aK|0,aO)|0;a[a9+aO|0]=0;aT=1;aU=aQ}else{if(aI){c[s>>2]=c[E>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];aT=1;aU=aG;break}aQ=c[X>>2]|0;aO=c[Y>>2]|0;if(aO>>>0>4294967279>>>0){aF=46;break L1}if(aO>>>0<11>>>0){a[s]=aO<<1;ba=Z}else{aK=aO+16&-16;aS=(z=0,au(248,aK|0)|0);if(z){z=0;aF=63;break L1}c[_>>2]=aS;c[$>>2]=aK|1;c[aa>>2]=aO;ba=aS}LF(ba|0,aQ|0,aO)|0;a[ba+aO|0]=0;aT=1;aU=aG}}while(0);if((aU&1)!=0){Lw(c[X>>2]|0)}if((aT|0)==0){aE=aE+1|0}else{aF=205;break}}do{if((aF|0)==16){z=0;ar(86,0);if(z){z=0;aE=bT(-1,-1)|0;bb=M;bc=aE;aF=58;break}}else if((aF|0)==46){z=0;ar(86,0);if(z){z=0;aF=64;break}}else if((aF|0)==59){aE=bT(-1,-1)|0;aT=aE;aE=M;if((a[x]&1)==0){bd=aE;be=aT;aF=61;break}Lw(c[aw>>2]|0);bd=aE;be=aT;aF=61}else if((aF|0)==91){z=0;ar(86,0);if(z){z=0;aF=64;break}}else if((aF|0)==56){aT=bT(-1,-1)|0;bb=M;bc=aT;aF=58}else if((aF|0)==195){aT=bT(-1,-1)|0;bf=M;bh=aT;aF=197}else if((aF|0)==204){LI(s|0,0,12)|0;aF=205}else if((aF|0)==6){z=0;ar(86,0);if(z){z=0;aT=bT(-1,-1)|0;bi=M;bj=aT;aF=55;break}}else if((aF|0)==63){aT=bT(-1,-1)|0;bk=M;bl=aT;aF=65}else if((aF|0)==53){aT=bT(-1,-1)|0;bi=M;bj=aT;aF=55}else if((aF|0)==33){z=0;ar(86,0);if(z){z=0;aF=64;break}}else if((aF|0)==103){z=0;ar(86,0);if(z){z=0;aF=64;break}}else if((aF|0)==135){z=0;ar(86,0);if(z){z=0;aT=bT(-1,-1)|0;bm=M;bn=aT;bo=a6;aF=189;break}}else if((aF|0)==123){z=0;ar(86,0);if(z){z=0;aT=bT(-1,-1)|0;bp=M;bq=aT;aF=186;break}}else if((aF|0)==181){aT=bT(-1,-1)|0;br=M;bs=aT;aF=183}else if((aF|0)==184){aT=bT(-1,-1)|0;bp=M;bq=aT;aF=186}else if((aF|0)==187){aT=bT(-1,-1)|0;bm=M;bn=aT;bo=a[O]|0;aF=189}else if((aF|0)==157){z=0;ar(86,0);if(z){z=0;aT=bT(-1,-1)|0;bf=M;bh=aT;aF=197;break}}else if((aF|0)==172){z=0;ar(86,0);if(z){z=0;aF=64;break}}else if((aF|0)==179){aT=bT(-1,-1)|0;aE=aT;aT=M;if((a[F]&1)==0){bt=aT;bu=aE;aF=202;break}Lw(c[ao>>2]|0);bt=aT;bu=aE;aF=202}else if((aF|0)==113){z=0;ar(86,0);if(z){z=0;aE=bT(-1,-1)|0;br=M;bs=aE;aF=183;break}}else if((aF|0)==69){z=0;ar(86,0);if(z){z=0;aF=64;break}}}while(0);do{if((aF|0)==58){bd=bb;be=bc;aF=61}else if((aF|0)==64){ao=bT(-1,-1)|0;bk=M;bl=ao;aF=65}else if((aF|0)==55){bv=bi;bw=bj}else if((aF|0)==197){ao=bh;F=bf;if((a[d]&1)==0){bt=F;bu=ao;aF=202;break}Lw(c[b>>2]|0);bt=F;bu=ao;aF=202}else if((aF|0)==205){if((a[h]&1)==0){i=f;return}Lw(c[q>>2]|0);i=f;return}else if((aF|0)==183){bx=br;by=bs;aF=193}else if((aF|0)==186){bz=bp;bA=bq;aF=191}else if((aF|0)==189){ao=bn;F=bm;if((bo&1)==0){bz=F;bA=ao;aF=191;break}Lw(c[ae>>2]|0);bz=F;bA=ao;aF=191}}while(0);do{if((aF|0)==65){bt=bk;bu=bl;aF=202}else if((aF|0)==191){if((a1&1)==0){bx=bz;by=bA;aF=193;break}Lw(c[ad>>2]|0);bx=bz;by=bA;aF=193}else if((aF|0)==61){if((a[v]&1)==0){bv=bd;bw=be;break}Lw(c[av>>2]|0);bv=bd;bw=be}}while(0);do{if((aF|0)==193){if((a_&1)==0){bt=bx;bu=by;aF=202;break}Lw(c[ac>>2]|0);bt=bx;bu=by;aF=202}}while(0);do{if((aF|0)==202){if((a[E]&1)==0){bv=bt;bw=bu;break}Lw(c[X>>2]|0);bv=bt;bw=bu}}while(0);if((a[h]&1)==0){bB=bw;bC=0;bD=bB;bE=bv;bg(bD|0)}Lw(c[q>>2]|0);bB=bw;bC=0;bD=bB;bE=bv;bg(bD|0)}function gi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b+20|0;e=c[d>>2]|0;f=b+16|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=0;i=g;g=e;while(1){e=c[i+(h<<2)>>2]|0;if((e|0)==0){j=g;k=i}else{Lx(e);j=c[d>>2]|0;k=c[f>>2]|0}e=h+1|0;if(e>>>0<j-k>>2>>>0){h=e;i=k;g=j}else{break}}}hi(b+236|0,c[b+240>>2]|0);j=c[b+224>>2]|0;g=j;if((j|0)!=0){k=b+228|0;i=c[k>>2]|0;if((j|0)!=(i|0)){c[k>>2]=i+(~((i-8+(-g|0)|0)>>>3)<<3)}Lw(j)}hh(b+212|0,c[b+216>>2]|0);if((a[b+200|0]&1)!=0){Lw(c[b+208>>2]|0)}j=b+188|0;g=c[j>>2]|0;if((g|0)!=0){i=b+192|0;k=c[i>>2]|0;if((g|0)==(k|0)){l=g}else{h=k;while(1){k=h-12|0;c[i>>2]=k;if((a[k]&1)==0){m=k}else{Lw(c[h-12+8>>2]|0);m=c[i>>2]|0}if((g|0)==(m|0)){break}else{h=m}}l=c[j>>2]|0}Lw(l)}hg(b+172|0,c[b+176>>2]|0);hf(b+160|0,c[b+164>>2]|0);if((a[b+148|0]&1)!=0){Lw(c[b+156>>2]|0)}if((a[b+128|0]&1)!=0){Lw(c[b+136>>2]|0)}l=c[b+116>>2]|0;j=l;if((l|0)!=0){m=b+120|0;h=c[m>>2]|0;if((l|0)!=(h|0)){c[m>>2]=h+(~(((h-12+(-j|0)|0)>>>0)/12|0)*12|0)}Lw(l)}z=0;ar(154,b+64|0);if(!z){hd(b+52|0,c[b+56>>2]|0);l=b+40|0;j=c[l>>2]|0;if((j|0)!=0){h=b+44|0;m=c[h>>2]|0;if((j|0)==(m|0)){n=j}else{g=m;while(1){m=g-16|0;c[h>>2]=m;if((a[m]&1)==0){o=m}else{Lw(c[g-16+8>>2]|0);o=c[h>>2]|0}if((j|0)==(o|0)){break}else{g=o}}n=c[l>>2]|0}Lw(n)}n=b+28|0;l=c[n>>2]|0;if((l|0)!=0){o=b+32|0;g=c[o>>2]|0;if((l|0)==(g|0)){p=l}else{j=g;while(1){g=j-12|0;c[o>>2]=g;if((a[g]&1)==0){q=g}else{Lw(c[j-12+8>>2]|0);q=c[o>>2]|0}if((l|0)==(q|0)){break}else{j=q}}p=c[n>>2]|0}Lw(p)}p=c[f>>2]|0;if((p|0)==0){r=b|0;gF(r);return}n=c[d>>2]|0;if((p|0)!=(n|0)){c[d>>2]=n+(~((n-4+(-p|0)|0)>>>2)<<2)}Lw(p);r=b|0;gF(r);return}else{z=0}r=bT(-1,-1)|0;hd(b+52|0,c[b+56>>2]|0);p=b+40|0;n=c[p>>2]|0;if((n|0)!=0){q=b+44|0;j=c[q>>2]|0;if((n|0)==(j|0)){s=n}else{l=j;while(1){j=l-16|0;c[q>>2]=j;if((a[j]&1)==0){t=j}else{Lw(c[l-16+8>>2]|0);t=c[q>>2]|0}if((n|0)==(t|0)){break}else{l=t}}s=c[p>>2]|0}Lw(s)}s=b+28|0;p=c[s>>2]|0;if((p|0)!=0){t=b+32|0;l=c[t>>2]|0;if((p|0)==(l|0)){u=p}else{n=l;while(1){l=n-12|0;c[t>>2]=l;if((a[l]&1)==0){v=l}else{Lw(c[n-12+8>>2]|0);v=c[t>>2]|0}if((p|0)==(v|0)){break}else{n=v}}u=c[s>>2]|0}Lw(u)}u=c[f>>2]|0;f=u;if((u|0)!=0){s=c[d>>2]|0;if((u|0)!=(s|0)){c[d>>2]=s+(~((s-4+(-f|0)|0)>>>2)<<2)}Lw(u)}z=0;ar(290,b|0);if(!z){bg(r|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function gj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=gE(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=Lu(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}LF(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bT(-1,-1)|0;if((h|0)==0){bg(o|0)}Lw(h);bg(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}e2(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function gk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d|0;f=a+4|0;g=f|0;h=c[g>>2]|0;do{if((h|0)==0){j=f;c[e>>2]=j;k=g;l=j}else{j=c[b>>2]|0;m=h;while(1){n=c[m+16>>2]|0;if((j|0)<(n|0)){o=m|0;p=c[o>>2]|0;if((p|0)==0){q=5;break}else{m=p;continue}}if((n|0)>=(j|0)){q=9;break}r=m+4|0;n=c[r>>2]|0;if((n|0)==0){q=8;break}else{m=n}}if((q|0)==8){c[e>>2]=m;k=r;l=m;break}else if((q|0)==9){c[e>>2]=m;k=e;l=m;break}else if((q|0)==5){c[e>>2]=m;k=o;l=m;break}}}while(0);o=c[k>>2]|0;if((o|0)!=0){s=o;t=s+20|0;i=d;return t|0}o=Lu(32)|0;e=o+16|0;if((e|0)!=0){c[e>>2]=c[b>>2]}b=o+20|0;if((b|0)!=0){LI(b|0,0,12)|0}b=o;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=l;c[k>>2]=b;l=a|0;e=c[c[l>>2]>>2]|0;if((e|0)==0){u=b}else{c[l>>2]=e;u=c[k>>2]|0}e2(c[a+4>>2]|0,u);u=a+8|0;c[u>>2]=(c[u>>2]|0)+1;s=o;t=s+20|0;i=d;return t|0}function gl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=gA(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=Lu(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}LF(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bT(-1,-1)|0;if((h|0)==0){bg(o|0)}Lw(h);bg(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}e2(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function gm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0;g=i;i=i+16|0;h=g|0;j=h;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+12|0;i=i+7&-8;w=i;i=i+12|0;i=i+7&-8;x=i;i=i+4|0;i=i+7&-8;y=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;LI(j|0,0,12)|0;D=b;E=e;L1:do{if((a[E]&1)==0){F=l;c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];G=11}else{F=c[e+8>>2]|0;H=c[e+4>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(H>>>0<11>>>0){a[l]=H<<1;I=l+1|0}else{J=H+16&-16;K=(z=0,au(248,J|0)|0);if(z){z=0;break}c[l+8>>2]=K;c[l>>2]=J|1;c[l+4>>2]=H;I=K}LF(I|0,F|0,H)|0;a[I+H|0]=0;G=11;break L1}}while(0);H=bT(-1,-1)|0;L=M;N=H}}while(0);L14:do{if((G|0)==11){I=f;L16:do{if((a[I]&1)==0){e=m;c[e>>2]=c[I>>2];c[e+4>>2]=c[I+4>>2];c[e+8>>2]=c[I+8>>2];G=21}else{e=c[f+8>>2]|0;E=c[f+4>>2]|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(E>>>0<11>>>0){a[m]=E<<1;O=m+1|0}else{H=E+16&-16;F=(z=0,au(248,H|0)|0);if(z){z=0;break}c[m+8>>2]=F;c[m>>2]=H|1;c[m+4>>2]=E;O=F}LF(O|0,e|0,E)|0;a[O+E|0]=0;G=21;break L16}}while(0);E=bT(-1,-1)|0;P=M;Q=E}}while(0);do{if((G|0)==21){z=0;aR(24,k|0,l|0,m|0);if(z){z=0;E=bT(-1,-1)|0;e=E;E=M;if((a[m]&1)==0){P=E;Q=e;break}Lw(c[m+8>>2]|0);P=E;Q=e;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}e=d+52|0;E=e|0;F=(gD(E,k)|0)==0;H=k;K=(a[H]&1)==0;L41:do{if(F){if(K){J=n;c[J>>2]=c[H>>2];c[J+4>>2]=c[H+4>>2];c[J+8>>2]=c[H+8>>2]}else{J=c[k+8>>2]|0;R=c[k+4>>2]|0;if(R>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=44;break}}if(R>>>0<11>>>0){a[n]=R<<1;S=n+1|0}else{T=R+16&-16;U=(z=0,au(248,T|0)|0);if(z){z=0;G=44;break}c[n+8>>2]=U;c[n>>2]=T|1;c[n+4>>2]=R;S=U}LF(S|0,J|0,R)|0;a[S+R|0]=0}R=(z=0,aM(328,n|0,h|0)|0);if(z){z=0;J=bT(-1,-1)|0;U=J;J=M;if((a[n]&1)==0){V=J;W=U;break}Lw(c[n+8>>2]|0);V=J;W=U;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((R|0)!=0){c[o>>2]=R;U=d+20|0;J=c[U>>2]|0;if((J|0)==(c[d+24>>2]|0)){z=0;as(26,d+16|0,o|0);if(z){z=0;G=44;break}}else{if((J|0)==0){X=0}else{c[J>>2]=R;X=c[U>>2]|0}c[U>>2]=X+4}U=d+192|0;J=c[U>>2]|0;if((J|0)==(c[d+196>>2]|0)){z=0;as(284,d+188|0,h|0);if(z){z=0;G=44;break}}else{do{if((J|0)!=0){if((a[j]&1)==0){T=J;c[T>>2]=c[j>>2];c[T+4>>2]=c[j+4>>2];c[T+8>>2]=c[j+8>>2];break}T=c[h+8>>2]|0;Y=c[h+4>>2]|0;if(Y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=44;break L41}}if(Y>>>0<11>>>0){a[J]=Y<<1;Z=J+1|0}else{_=Y+16&-16;$=(z=0,au(248,_|0)|0);if(z){z=0;G=44;break L41}c[J+8>>2]=$;c[J>>2]=_|1;c[J+4>>2]=Y;Z=$}LF(Z|0,T|0,Y)|0;a[Z+Y|0]=0}}while(0);c[U>>2]=(c[U>>2]|0)+12}J=d+40|0;if((a[H]&1)==0){Y=r;c[Y>>2]=c[H>>2];c[Y+4>>2]=c[H+4>>2];c[Y+8>>2]=c[H+8>>2];aa=a[Y]|0;ab=Y}else{Y=c[k+8>>2]|0;T=c[k+4>>2]|0;if(T>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=44;break}}if(T>>>0<11>>>0){$=T<<1&255;_=r;a[_]=$;ac=r+1|0;ad=$;ae=_}else{_=T+16&-16;$=(z=0,au(248,_|0)|0);if(z){z=0;G=44;break}c[r+8>>2]=$;af=_|1;c[r>>2]=af;c[r+4>>2]=T;ac=$;ad=af&255;ae=r}LF(ac|0,Y|0,T)|0;a[ac+T|0]=0;aa=ad;ab=ae}L117:do{if((aa&1)==0){T=q;c[T>>2]=c[ab>>2];c[T+4>>2]=c[ab+4>>2];c[T+8>>2]=c[ab+8>>2];ag=a[T]|0;ah=T;G=99}else{T=c[r+8>>2]|0;Y=c[r+4>>2]|0;do{if(Y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(Y>>>0<11>>>0){af=Y<<1&255;$=q;a[$]=af;ai=q+1|0;aj=af;ak=$}else{$=Y+16&-16;af=(z=0,au(248,$|0)|0);if(z){z=0;break}c[q+8>>2]=af;_=$|1;c[q>>2]=_;c[q+4>>2]=Y;ai=af;aj=_&255;ak=q}LF(ai|0,T|0,Y)|0;a[ai+Y|0]=0;ag=aj;ah=ak;G=99;break L117}}while(0);Y=bT(-1,-1)|0;al=M;am=Y}}while(0);do{if((G|0)==99){c[q+12>>2]=R;L132:do{if((ag&1)==0){U=p;c[U>>2]=c[ah>>2];c[U+4>>2]=c[ah+4>>2];c[U+8>>2]=c[ah+8>>2];G=109}else{U=c[q+8>>2]|0;Y=c[q+4>>2]|0;do{if(Y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(Y>>>0<11>>>0){a[p]=Y<<1;an=p+1|0}else{T=Y+16&-16;_=(z=0,au(248,T|0)|0);if(z){z=0;break}c[p+8>>2]=_;c[p>>2]=T|1;c[p+4>>2]=Y;an=_}LF(an|0,U|0,Y)|0;a[an+Y|0]=0;G=109;break L132}}while(0);Y=bT(-1,-1)|0;ao=M;ap=Y}}while(0);do{if((G|0)==109){c[p+12>>2]=R;Y=d+44|0;U=c[Y>>2]|0;do{if((U|0)==(c[d+48>>2]|0)){z=0;as(532,J|0,p|0);if(z){z=0;G=162}}else{if((U|0)==0){aq=0}else{_=p;if((a[_]&1)==0){T=U;c[T>>2]=c[_>>2];c[T+4>>2]=c[_+4>>2];c[T+8>>2]=c[_+8>>2]}else{_=c[p+8>>2]|0;T=c[p+4>>2]|0;if(T>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=162;break}}if(T>>>0<11>>>0){a[U]=T<<1;at=U+1|0}else{af=T+16&-16;$=(z=0,au(248,af|0)|0);if(z){z=0;G=162;break}c[U+8>>2]=$;c[U>>2]=af|1;c[U+4>>2]=T;at=$}LF(at|0,_|0,T)|0;a[at+T|0]=0}c[U+12>>2]=R;aq=c[Y>>2]|0}c[Y>>2]=aq+16}}while(0);if((G|0)==162){Y=bT(-1,-1)|0;U=Y;Y=M;if((a[p]&1)==0){ao=Y;ap=U;break}Lw(c[p+8>>2]|0);ao=Y;ap=U;break}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if((ag&1)!=0){Lw(c[q+8>>2]|0)}if((a[ab]&1)!=0){Lw(c[r+8>>2]|0)}z=0;aV(44,s|0,h|0,d+148|0,d+200|0);if(z){z=0;G=44;break L41}U=d+68|0;Y=c[U>>2]|0;L180:do{if((Y|0)==(c[d+72>>2]|0)){z=0;as(284,d+64|0,s|0);if(z){z=0;G=168}}else{do{if((Y|0)!=0){T=s;if((a[T]&1)==0){_=Y;c[_>>2]=c[T>>2];c[_+4>>2]=c[T+4>>2];c[_+8>>2]=c[T+8>>2];break}T=c[s+8>>2]|0;_=c[s+4>>2]|0;if(_>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=168;break L180}}if(_>>>0<11>>>0){a[Y]=_<<1;av=Y+1|0}else{$=_+16&-16;af=(z=0,au(248,$|0)|0);if(z){z=0;G=168;break L180}c[Y+8>>2]=af;c[Y>>2]=$|1;c[Y+4>>2]=_;av=af}LF(av|0,T|0,_)|0;a[av+_|0]=0}}while(0);c[U>>2]=(c[U>>2]|0)+12}}while(0);if((G|0)==168){U=bT(-1,-1)|0;Y=U;U=M;if((a[s]&1)==0){V=U;W=Y;break L41}Lw(c[s+8>>2]|0);V=U;W=Y;break L41}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}Y=(z=0,aM(510,e|0,k|0)|0);if(z){z=0;G=44;break L41}c[Y>>2]=0;if((a[H]&1)==0){c[D>>2]=c[H>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];G=357;break L41}Y=c[k+8>>2]|0;U=c[k+4>>2]|0;if(U>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=44;break L41}}if(U>>>0<11>>>0){a[D]=U<<1;aw=b+1|0}else{_=U+16&-16;T=(z=0,au(248,_|0)|0);if(z){z=0;G=44;break L41}c[b+8>>2]=T;c[b>>2]=_|1;c[b+4>>2]=U;aw=T}LF(aw|0,Y|0,U)|0;a[aw+U|0]=0;G=357;break L41}}while(0);if((ag&1)==0){al=ao;am=ap;break}Lw(c[q+8>>2]|0);al=ao;am=ap}}while(0);if((a[ab]&1)==0){V=al;W=am;break}Lw(c[r+8>>2]|0);V=al;W=am;break}R=d+28|0;J=((c[d+32>>2]|0)-(c[R>>2]|0)|0)/12|0;U=u;Y=v;T=t;_=w;af=d+20|0;$=d+24|0;ax=d+16|0;ay=d+192|0;az=d+196|0;aA=d+188|0;aB=d+40|0;aC=B;aD=A;aE=A+12|0;aF=y;aG=y+12|0;aH=d+44|0;aI=d+48|0;aJ=d+64|0;aK=d+148|0;aL=d+200|0;aN=d+68|0;aO=d+72|0;aP=C;aQ=t+8|0;aS=t+4|0;aT=b+1|0;aU=b+8|0;aW=b|0;aX=b+4|0;aY=C+8|0;aZ=C+4|0;a_=B+8|0;a$=A+8|0;a0=y+8|0;a1=y+4|0;a2=A+4|0;a3=y+1|0;a4=y|0;a5=B+4|0;a6=A+1|0;a7=A|0;a8=B+1|0;a9=B|0;ba=h+8|0;bb=h+4|0;bc=w+8|0;bd=w+1|0;be=w|0;bf=w+4|0;bh=u+8|0;bi=v+8|0;bj=f+8|0;bk=f+4|0;bl=v+1|0;bm=v|0;bn=v+4|0;bo=u+1|0;bp=u|0;bq=u+4|0;br=0;L223:while(1){if(br>>>0>=J>>>0){G=356;break}bs=c[R>>2]|0;bt=bs+(br*12|0)|0;if((a[bt]&1)==0){c[U>>2]=c[bt>>2];c[U+4>>2]=c[bt+4>>2];c[U+8>>2]=c[bt+8>>2]}else{bt=c[bs+(br*12|0)+8>>2]|0;bu=c[bs+(br*12|0)+4>>2]|0;if(bu>>>0>4294967279>>>0){G=175;break}if(bu>>>0<11>>>0){a[U]=bu<<1;bv=bo}else{bs=bu+16&-16;bw=(z=0,au(248,bs|0)|0);if(z){z=0;G=43;break}c[bh>>2]=bw;c[bp>>2]=bs|1;c[bq>>2]=bu;bv=bw}LF(bv|0,bt|0,bu)|0;a[bv+bu|0]=0}if((a[I]&1)==0){c[Y>>2]=c[I>>2];c[Y+4>>2]=c[I+4>>2];c[Y+8>>2]=c[I+8>>2]}else{bu=c[bj>>2]|0;bt=c[bk>>2]|0;if(bt>>>0>4294967279>>>0){G=185;break}if(bt>>>0<11>>>0){a[Y]=bt<<1;bx=bl}else{bw=bt+16&-16;bs=(z=0,au(248,bw|0)|0);if(z){z=0;G=208;break}c[bi>>2]=bs;c[bm>>2]=bw|1;c[bn>>2]=bt;bx=bs}LF(bx|0,bu|0,bt)|0;a[bx+bt|0]=0}z=0;aR(24,t|0,u|0,v|0);if(z){z=0;G=211;break}if((a[Y]&1)!=0){Lw(c[bi>>2]|0)}if((a[U]&1)!=0){Lw(c[bh>>2]|0)}bt=(gD(E,t)|0)==0;bu=a[T]|0;bs=(bu&1)==0;do{if(bt){if(bs){c[_>>2]=c[T>>2];c[_+4>>2]=c[T+4>>2];c[_+8>>2]=c[T+8>>2]}else{bw=c[aQ>>2]|0;by=c[aS>>2]|0;if(by>>>0>4294967279>>>0){G=221;break L223}if(by>>>0<11>>>0){a[_]=by<<1;bz=bd}else{bA=by+16&-16;bB=(z=0,au(248,bA|0)|0);if(z){z=0;G=215;break L223}c[bc>>2]=bB;c[be>>2]=bA|1;c[bf>>2]=by;bz=bB}LF(bz|0,bw|0,by)|0;a[bz+by|0]=0}by=(z=0,aM(328,w|0,h|0)|0);if(z){z=0;G=331;break L223}if((a[_]&1)!=0){Lw(c[bc>>2]|0)}if((by|0)==0){bC=0;bD=a[T]|0;break}c[x>>2]=by;bw=c[af>>2]|0;if((bw|0)==(c[$>>2]|0)){z=0;as(26,ax|0,x|0);if(z){z=0;G=215;break L223}}else{if((bw|0)==0){bE=0}else{c[bw>>2]=by;bE=c[af>>2]|0}c[af>>2]=bE+4}bw=c[ay>>2]|0;if((bw|0)==(c[az>>2]|0)){z=0;as(284,aA|0,h|0);if(z){z=0;G=215;break L223}}else{do{if((bw|0)!=0){if((a[j]&1)==0){bB=bw;c[bB>>2]=c[j>>2];c[bB+4>>2]=c[j+4>>2];c[bB+8>>2]=c[j+8>>2];break}bB=c[ba>>2]|0;bA=c[bb>>2]|0;if(bA>>>0>4294967279>>>0){G=243;break L223}if(bA>>>0<11>>>0){a[bw]=bA<<1;bF=bw+1|0}else{bG=bA+16&-16;bH=(z=0,au(248,bG|0)|0);if(z){z=0;G=215;break L223}c[bw+8>>2]=bH;c[bw>>2]=bG|1;c[bw+4>>2]=bA;bF=bH}LF(bF|0,bB|0,bA)|0;a[bF+bA|0]=0}}while(0);c[ay>>2]=(c[ay>>2]|0)+12}if((a[T]&1)==0){c[aC>>2]=c[T>>2];c[aC+4>>2]=c[T+4>>2];c[aC+8>>2]=c[T+8>>2];bI=a[aC]|0}else{bw=c[aQ>>2]|0;bA=c[aS>>2]|0;if(bA>>>0>4294967279>>>0){G=255;break L223}if(bA>>>0<11>>>0){bB=bA<<1&255;a[aC]=bB;bJ=a8;bK=bB}else{bB=bA+16&-16;bH=(z=0,au(248,bB|0)|0);if(z){z=0;G=215;break L223}c[a_>>2]=bH;bG=bB|1;c[a9>>2]=bG;c[a5>>2]=bA;bJ=bH;bK=bG&255}LF(bJ|0,bw|0,bA)|0;a[bJ+bA|0]=0;bI=bK}if((bI&1)==0){c[aD>>2]=c[aC>>2];c[aD+4>>2]=c[aC+4>>2];c[aD+8>>2]=c[aC+8>>2];bL=a[aD]|0}else{bA=c[a_>>2]|0;bw=c[a5>>2]|0;if(bw>>>0>4294967279>>>0){G=265;break L223}if(bw>>>0<11>>>0){bG=bw<<1&255;a[aD]=bG;bM=a6;bN=bG}else{bG=bw+16&-16;bH=(z=0,au(248,bG|0)|0);if(z){z=0;G=333;break L223}c[a$>>2]=bH;bB=bG|1;c[a7>>2]=bB;c[a2>>2]=bw;bM=bH;bN=bB&255}LF(bM|0,bA|0,bw)|0;a[bM+bw|0]=0;bL=bN}c[aE>>2]=by;if((bL&1)==0){c[aF>>2]=c[aD>>2];c[aF+4>>2]=c[aD+4>>2];c[aF+8>>2]=c[aD+8>>2]}else{bw=c[a$>>2]|0;bA=c[a2>>2]|0;if(bA>>>0>4294967279>>>0){G=275;break L223}if(bA>>>0<11>>>0){a[aF]=bA<<1;bO=a3}else{bB=bA+16&-16;bH=(z=0,au(248,bB|0)|0);if(z){z=0;G=336;break L223}c[a0>>2]=bH;c[a4>>2]=bB|1;c[a1>>2]=bA;bO=bH}LF(bO|0,bw|0,bA)|0;a[bO+bA|0]=0}c[aG>>2]=by;bA=c[aH>>2]|0;if((bA|0)==(c[aI>>2]|0)){z=0;as(532,aB|0,y|0);if(z){z=0;G=339;break L223}}else{if((bA|0)==0){bP=0}else{bQ=a[aF]|0;if((bQ&1)==0){bw=bA;c[bw>>2]=c[aF>>2];c[bw+4>>2]=c[aF+4>>2];c[bw+8>>2]=c[aF+8>>2]}else{bw=c[a0>>2]|0;bH=c[a1>>2]|0;if(bH>>>0>4294967279>>>0){G=287;break L223}if(bH>>>0<11>>>0){a[bA]=bH<<1;bR=bA+1|0}else{bB=bH+16&-16;bG=(z=0,au(248,bB|0)|0);if(z){z=0;G=339;break L223}c[bA+8>>2]=bG;c[bA>>2]=bB|1;c[bA+4>>2]=bH;bR=bG}LF(bR|0,bw|0,bH)|0;a[bR+bH|0]=0}c[bA+12>>2]=by;bP=c[aH>>2]|0}c[aH>>2]=bP+16}if((a[aF]&1)!=0){Lw(c[a0>>2]|0)}if((bL&1)!=0){Lw(c[a$>>2]|0)}if((bI&1)!=0){Lw(c[a_>>2]|0)}z=0;aV(44,C|0,h|0,aK|0,aL|0);if(z){z=0;G=215;break L223}bA=c[aN>>2]|0;if((bA|0)==(c[aO>>2]|0)){z=0;as(284,aJ|0,C|0);if(z){z=0;G=347;break L223}}else{do{if((bA|0)!=0){if((a[aP]&1)==0){bH=bA;c[bH>>2]=c[aP>>2];c[bH+4>>2]=c[aP+4>>2];c[bH+8>>2]=c[aP+8>>2];break}bH=c[aY>>2]|0;bw=c[aZ>>2]|0;if(bw>>>0>4294967279>>>0){G=309;break L223}if(bw>>>0<11>>>0){a[bA]=bw<<1;bS=bA+1|0}else{bG=bw+16&-16;bB=(z=0,au(248,bG|0)|0);if(z){z=0;G=347;break L223}c[bA+8>>2]=bB;c[bA>>2]=bG|1;c[bA+4>>2]=bw;bS=bB}LF(bS|0,bH|0,bw)|0;a[bS+bw|0]=0}}while(0);c[aN>>2]=(c[aN>>2]|0)+12}if((a[aP]&1)!=0){Lw(c[aY>>2]|0)}bA=(z=0,aM(510,e|0,t|0)|0);if(z){z=0;G=215;break L223}c[bA>>2]=0;bA=a[T]|0;if((bA&1)==0){c[D>>2]=c[T>>2];c[D+4>>2]=c[T+4>>2];c[D+8>>2]=c[T+8>>2];bC=1;bD=bA;break}by=c[aQ>>2]|0;bw=c[aS>>2]|0;if(bw>>>0>4294967279>>>0){G=324;break L223}if(bw>>>0<11>>>0){a[D]=bw<<1;bU=aT}else{bH=bw+16&-16;bB=(z=0,au(248,bH|0)|0);if(z){z=0;G=215;break L223}c[aU>>2]=bB;c[aW>>2]=bH|1;c[aX>>2]=bw;bU=bB}LF(bU|0,by|0,bw)|0;a[bU+bw|0]=0;bC=1;bD=bA}else{if(bs){c[D>>2]=c[T>>2];c[D+4>>2]=c[T+4>>2];c[D+8>>2]=c[T+8>>2];bC=1;bD=bu;break}bA=c[aQ>>2]|0;bw=c[aS>>2]|0;if(bw>>>0>4294967279>>>0){G=201;break L223}if(bw>>>0<11>>>0){a[D]=bw<<1;bV=aT}else{by=bw+16&-16;bB=(z=0,au(248,by|0)|0);if(z){z=0;G=215;break L223}c[aU>>2]=bB;c[aW>>2]=by|1;c[aX>>2]=bw;bV=bB}LF(bV|0,bA|0,bw)|0;a[bV+bw|0]=0;bC=1;bD=bu}}while(0);if((bD&1)!=0){Lw(c[aQ>>2]|0)}if((bC|0)==0){br=br+1|0}else{G=357;break L41}}do{if((G|0)==324){z=0;ar(86,0);if(z){z=0;G=216;break}}else if((G|0)==331){br=bT(-1,-1)|0;aX=br;br=M;if((a[_]&1)==0){bW=br;bX=aX;break}Lw(c[bc>>2]|0);bW=br;bX=aX}else if((G|0)==333){aX=bT(-1,-1)|0;bY=M;bZ=aX;G=335}else if((G|0)==336){aX=bT(-1,-1)|0;b_=M;b$=aX;G=338}else if((G|0)==339){aX=bT(-1,-1)|0;b0=M;b1=aX;b2=a[aF]|0;G=341}else if((G|0)==221){z=0;ar(86,0);if(z){z=0;G=216;break}}else if((G|0)==243){z=0;ar(86,0);if(z){z=0;G=216;break}}else if((G|0)==255){z=0;ar(86,0);if(z){z=0;G=216;break}}else if((G|0)==201){z=0;ar(86,0);if(z){z=0;G=216;break}}else if((G|0)==208){aX=bT(-1,-1)|0;b3=M;b4=aX;G=210}else if((G|0)==211){aX=bT(-1,-1)|0;br=aX;aX=M;if((a[Y]&1)==0){b5=aX;b6=br;G=213;break}Lw(c[bi>>2]|0);b5=aX;b6=br;G=213}else if((G|0)==215){br=bT(-1,-1)|0;b7=M;b8=br;G=217}else if((G|0)==175){z=0;ar(86,0);if(z){z=0;G=44;break L41}}else if((G|0)==265){z=0;ar(86,0);if(z){z=0;br=bT(-1,-1)|0;bY=M;bZ=br;G=335;break}}else if((G|0)==275){z=0;ar(86,0);if(z){z=0;br=bT(-1,-1)|0;b_=M;b$=br;G=338;break}}else if((G|0)==43){br=bT(-1,-1)|0;b9=M;ca=br;G=45;break L41}else if((G|0)==185){z=0;ar(86,0);if(z){z=0;br=bT(-1,-1)|0;b3=M;b4=br;G=210;break}}else if((G|0)==347){br=bT(-1,-1)|0;cb=M;cc=br;G=349}else if((G|0)==356){LI(D|0,0,12)|0;G=357;break L41}else if((G|0)==287){z=0;ar(86,0);if(z){z=0;br=bT(-1,-1)|0;b0=M;b1=br;b2=bQ;G=341;break}}else if((G|0)==309){z=0;ar(86,0);if(z){z=0;br=bT(-1,-1)|0;cb=M;cc=br;G=349;break}}}while(0);do{if((G|0)==335){cd=bY;ce=bZ;G=345}else if((G|0)==338){cf=b_;cg=b$;G=343}else if((G|0)==341){bi=b1;Y=b0;if((b2&1)==0){cf=Y;cg=bi;G=343;break}Lw(c[a0>>2]|0);cf=Y;cg=bi;G=343}else if((G|0)==216){bi=bT(-1,-1)|0;b7=M;b8=bi;G=217}else if((G|0)==210){b5=b3;b6=b4;G=213}else if((G|0)==349){bi=cc;Y=cb;if((a[aP]&1)==0){bW=Y;bX=bi;break}Lw(c[aY>>2]|0);bW=Y;bX=bi}}while(0);do{if((G|0)==343){if((bL&1)==0){cd=cf;ce=cg;G=345;break}Lw(c[a$>>2]|0);cd=cf;ce=cg;G=345}else if((G|0)==217){bW=b7;bX=b8}else if((G|0)==213){if((a[U]&1)==0){V=b5;W=b6;break L41}Lw(c[bh>>2]|0);V=b5;W=b6;break L41}}while(0);do{if((G|0)==345){if((bI&1)==0){bW=cd;bX=ce;break}Lw(c[a_>>2]|0);bW=cd;bX=ce}}while(0);if((a[T]&1)==0){V=bW;W=bX;break}Lw(c[aQ>>2]|0);V=bW;W=bX}else{if(K){c[D>>2]=c[H>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];G=357;break}a_=c[k+8>>2]|0;bh=c[k+4>>2]|0;if(bh>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=44;break}}if(bh>>>0<11>>>0){a[D]=bh<<1;ch=b+1|0}else{U=bh+16&-16;a$=(z=0,au(248,U|0)|0);if(z){z=0;G=44;break}c[b+8>>2]=a$;c[b>>2]=U|1;c[b+4>>2]=bh;ch=a$}LF(ch|0,a_|0,bh)|0;a[ch+bh|0]=0;G=357}}while(0);if((G|0)==44){K=bT(-1,-1)|0;b9=M;ca=K;G=45}else if((G|0)==357){if((a[H]&1)!=0){Lw(c[k+8>>2]|0)}if((a[j]&1)==0){i=g;return}Lw(c[h+8>>2]|0);i=g;return}if((G|0)==45){V=b9;W=ca}if((a[H]&1)==0){L=V;N=W;break L14}Lw(c[k+8>>2]|0);L=V;N=W;break L14}}while(0);if((a[l]&1)==0){L=P;N=Q;break}Lw(c[l+8>>2]|0);L=P;N=Q}}while(0);if((a[j]&1)==0){ci=N;cj=0;ck=ci;cl=L;bg(ck|0)}Lw(c[h+8>>2]|0);ci=N;cj=0;ck=ci;cl=L;bg(ck|0)}function gn(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0;e=i;i=i+504|0;f=e|0;g=e+16|0;h=e+80|0;j=e+96|0;k=e+112|0;l=e+128|0;m=e+168|0;n=e+184|0;o=e+200|0;p=e+216|0;q=e+232|0;r=e+264|0;s=e+328|0;t=e+352|0;u=e+384|0;v=e+400|0;w=e+416|0;x=e+456|0;y=e+472|0;A=e+488|0;B=b+44|0;C=b+40|0;D=c[C>>2]|0;L1:do{if((c[B>>2]|0)==(D|0)){E=0}else{F=h;G=j|0;H=j+4|0;I=j+8|0;J=b+52|0;K=g+28|0;L=g+4|0;N=g+8|0;O=g+36|0;P=h+8|0;Q=h+1|0;R=h|0;S=h+4|0;T=0;U=0;V=D;while(1){W=c[V+(T<<4)+12>>2]|0;X=V+(T<<4)|0;if((a[X]&1)==0){c[F>>2]=c[X>>2];c[F+4>>2]=c[X+4>>2];c[F+8>>2]=c[X+8>>2]}else{X=c[V+(T<<4)+8>>2]|0;Y=c[V+(T<<4)+4>>2]|0;if(Y>>>0>4294967279>>>0){Z=6;break}if(Y>>>0<11>>>0){a[F]=Y<<1;_=Q}else{$=Y+16&-16;aa=Lu($)|0;c[P>>2]=aa;c[R>>2]=$|1;c[S>>2]=Y;_=aa}LF(_|0,X|0,Y)|0;a[_+Y|0]=0}Y=T+1|0;c[G>>2]=Y;c[H>>2]=1;c[I>>2]=1;z=0;aq(2,g|0,W|0,b|0,h|0,j|0);if(z){z=0;Z=16;break}if((a[F]&1)!=0){Lw(c[P>>2]|0)}W=(z=0,au(284,g|0)|0);if(z){z=0;Z=18;break}X=(T|0)==0?W:U;aa=(z=0,aM(510,J|0,(c[C>>2]|0)+(T<<4)|0)|0);if(z){z=0;Z=18;break}c[aa>>2]=W;if((a[K]&1)!=0){Lw(c[O>>2]|0)}W=c[L>>2]|0;aa=W;if((W|0)!=0){$=c[N>>2]|0;if((W|0)!=($|0)){c[N>>2]=$+(~(($-4+(-aa|0)|0)>>>2)<<2)}Lw(W)}W=c[C>>2]|0;if(Y>>>0<(c[B>>2]|0)-W>>4>>>0){T=Y;U=X;V=W}else{E=X;break L1}}if((Z|0)==16){V=bT(-1,-1)|0;U=V;V=M;if((a[F]&1)==0){ab=U;ac=V;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}Lw(c[P>>2]|0);ab=U;ac=V;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}else if((Z|0)==18){V=bT(-1,-1)|0;U=V;V=M;if((a[K]&1)!=0){Lw(c[O>>2]|0)}T=c[L>>2]|0;if((T|0)==0){ab=U;ac=V;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}J=c[N>>2]|0;if((T|0)!=(J|0)){c[N>>2]=J+(~((J-4+(-T|0)|0)>>>2)<<2)}Lw(T);ab=U;ac=V;ad=ab;ae=0;af=ad;ag=ac;bg(af|0)}else if((Z|0)==6){D5(0);return 0}}}while(0);B=k+4|0;c[B>>2]=0;c[k+8>>2]=0;c[k>>2]=B;c[k+12>>2]=0;B=m;a[B]=0;a[m+1|0]=0;C=n;a[C]=0;a[n+1|0]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;z=0;aq(26,l|0,0,m|0,f|0,n|0);do{if(!z){if((a[C]&1)!=0){Lw(c[n+8>>2]|0)}if((a[B]&1)!=0){Lw(c[m+8>>2]|0)}z=0;as(554,b|0,k|0);L56:do{if(!z){f=c[b+120>>2]|0;g=b+116|0;j=c[g>>2]|0;h=(f-j|0)/12|0;L58:do{if((f|0)!=(j|0)){_=o;D=0;V=j;while(1){U=V+(D*12|0)|0;c[_>>2]=c[U>>2];c[_+4>>2]=c[U+4>>2];c[_+8>>2]=c[U+8>>2];z=0;aR(114,b|0,k|0,o|0);if(z){z=0;break}U=D+1|0;if(U>>>0>=h>>>0){break L58}D=U;V=c[g>>2]|0}V=bT(-1,-1)|0;ah=M;ai=V;Z=48;break L56}}while(0);z=0;aV(52,p|0,b|0,k|0,l|0);if(z){z=0;Z=47;break}z=0;aI(58,q|0,b|0,p|0,k|0,l|0,0,0);L67:do{if(!z){z=0;aD(50,r|0,b|0,p|0,q|0,k|0,l|0);L69:do{if(!z){g=(z=0,aM(c[(c[E>>2]|0)+16>>2]|0,E|0,r|0)|0);L71:do{if(!z){h=(z=0,au(c[(c[g>>2]|0)+40>>2]|0,g|0)|0);if(z){z=0;Z=59;break}do{if((c[b+220>>2]|0)!=0){z=0;aq(24,s|0,b|0,b+212|0,b+224|0,l|0);if(z){z=0;Z=59;break L71}z=0;as(c[(c[h>>2]|0)+8>>2]|0,h|0,s|0);if(!z){break}else{z=0}j=bT(-1,-1)|0;aj=j;ak=M;break L71}}while(0);L79:do{if((c[b+144>>2]|0)==3){z=0;as(290,t|0,b|0);if(z){z=0;Z=59;break L71}z=0;as(c[(c[h>>2]|0)+8>>2]|0,h|0,t|0);do{if(!z){z=0;aR(210,u|0,t+16|0,t+4|0);if(z){z=0;Z=76;break}do{if((a[b+141|0]&1)==0){Z=80}else{z=0;aR(32,v|0,0,b+148|0);if(z){z=0;Z=77;break}j=v;f=a[j]|0;if((f&1)==0){al=v+1|0}else{al=c[v+8>>2]|0}V=f&255;if((V&1|0)==0){am=V>>>1}else{am=c[v+4>>2]|0}z=0,az(88,u|0,al|0,am|0)|0;if(!z){if((a[j]&1)==0){Z=80;break}Lw(c[v+8>>2]|0);Z=80;break}else{z=0;V=bT(-1,-1)|0;f=V;V=M;if((a[j]&1)==0){an=f;ao=V;break}Lw(c[v+8>>2]|0);an=f;ao=V;break}}}while(0);do{if((Z|0)==80){V=u;if((a[V]&1)==0){ap=u+1|0}else{ap=c[u+8>>2]|0}f=(z=0,au(250,ap|0)|0);if(z){z=0;Z=77;break}if((a[V]&1)!=0){Lw(c[u+8>>2]|0)}z=0;ar(254,t|0);if(!z){at=f;break L79}else{z=0;Z=59;break L71}}}while(0);if((Z|0)==77){f=bT(-1,-1)|0;an=f;ao=M}if((a[u]&1)==0){av=an;aw=ao;break}Lw(c[u+8>>2]|0);av=an;aw=ao}else{z=0;Z=76}}while(0);if((Z|0)==76){f=bT(-1,-1)|0;av=f;aw=M}z=0;ar(254,t|0);if(!z){aj=av;ak=aw;break L71}else{z=0}ax=bT(-1,-1,0)|0;ay=M;bX();return 0}else{z=0;aR(14,w|0,(a[b+140|0]&1)!=0|0,b|0);if(z){z=0;Z=59;break L71}z=0;as(c[(c[h>>2]|0)+8>>2]|0,h|0,w|0);L121:do{if(!z){f=w+16|0;V=d[f]|0;if((V&1|0)==0){aA=V>>>1}else{aA=c[w+20>>2]|0}do{if((aA|0)!=0){V=d[w+4|0]|0;if((V&1|0)==0){aB=V>>>1}else{aB=c[w+8>>2]|0}if((aB|0)==0){break}z=0,az(88,f|0,10656,1)|0;if(z){z=0;Z=131;break L121}}}while(0);z=0;aR(210,x|0,f|0,w+4|0);if(z){z=0;Z=131;break}L136:do{if((a[b+141|0]&1)==0){Z=138}else{z=0;aR(32,A|0,0,b+148|0);if(z){z=0;Z=132;break}V=y;LI(V|0,0,12)|0;j=A;D=A;_=a[D]|0;U=_&255;if((U&1|0)==0){aC=U>>>1}else{aC=c[A+4>>2]|0}U=aC+1|0;do{if(U>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=118;break}return 0}else{if(U>>>0<11>>>0){a[V]=2;aE=y+1|0}else{T=aC+17&-16;J=(z=0,au(248,T|0)|0);if(z){z=0;Z=118;break}c[y+8>>2]=J;c[y>>2]=T|1;c[y+4>>2]=1;aE=J}a[aE]=10;a[aE+1|0]=0;if((_&1)==0){aF=j+1|0}else{aF=c[A+8>>2]|0}z=0,az(88,y|0,aF|0,aC|0)|0;if(z){z=0;Z=118;break}J=a[V]|0;if((J&1)==0){aG=y+1|0}else{aG=c[y+8>>2]|0}T=J&255;if((T&1|0)==0){aH=T>>>1}else{aH=c[y+4>>2]|0}z=0,az(88,x|0,aG|0,aH|0)|0;if(z){z=0;T=bT(-1,-1)|0;J=T;T=M;if((a[V]&1)==0){aJ=J;aK=T;break}Lw(c[y+8>>2]|0);aJ=J;aK=T;break}if((a[V]&1)!=0){Lw(c[y+8>>2]|0)}if((a[D]&1)==0){Z=138;break L136}Lw(c[A+8>>2]|0);Z=138;break L136}}while(0);if((Z|0)==118){j=bT(-1,-1)|0;_=M;if((a[V]&1)!=0){Lw(c[y+8>>2]|0)}aJ=j;aK=_}if((a[D]&1)==0){aL=aJ;aN=aK;break}Lw(c[A+8>>2]|0);aL=aJ;aN=aK}}while(0);do{if((Z|0)==138){f=x;if((a[f]&1)==0){aO=x+1|0}else{aO=c[x+8>>2]|0}_=(z=0,au(250,aO|0)|0);if(z){z=0;Z=132;break}if((a[f]&1)!=0){Lw(c[x+8>>2]|0)}z=0;ar(438,w|0);if(!z){at=_;break L79}else{z=0;Z=59;break L71}}}while(0);if((Z|0)==132){_=bT(-1,-1)|0;aL=_;aN=M}if((a[x]&1)==0){aP=aL;aQ=aN;break}Lw(c[x+8>>2]|0);aP=aL;aQ=aN}else{z=0;Z=131}}while(0);if((Z|0)==131){_=bT(-1,-1)|0;aP=_;aQ=M}z=0;ar(438,w|0);if(!z){aj=aP;ak=aQ;break L71}else{z=0}ax=bT(-1,-1,0)|0;ay=M;bX();return 0}}while(0);z=0;ar(538,r|0);if(z){z=0;Z=58;break L69}z=0;ar(22,q|0);if(z){z=0;Z=57;break L67}z=0;ar(170,p|0);if(z){z=0;Z=47;break L56}if((a[l+28|0]&1)!=0){Lw(c[l+36>>2]|0)}if((a[l+4|0]&1)==0){aS=k|0;aT=k+4|0;aU=c[aT>>2]|0;aW=aU;g_(aS,aW);i=e;return at|0}Lw(c[l+12>>2]|0);aS=k|0;aT=k+4|0;aU=c[aT>>2]|0;aW=aU;g_(aS,aW);i=e;return at|0}else{z=0;Z=59}}while(0);if((Z|0)==59){g=bT(-1,-1)|0;aj=g;ak=M}z=0;ar(538,r|0);if(!z){aX=aj;aY=ak;break}else{z=0}ax=bT(-1,-1,0)|0;ay=M;bX();return 0}else{z=0;Z=58}}while(0);if((Z|0)==58){g=bT(-1,-1)|0;aX=g;aY=M}z=0;ar(22,q|0);if(!z){aZ=aX;a_=aY;break}else{z=0}ax=bT(-1,-1,0)|0;ay=M;bX();return 0}else{z=0;Z=57}}while(0);if((Z|0)==57){g=bT(-1,-1)|0;aZ=g;a_=M}z=0;ar(170,p|0);if(!z){a$=aZ;a0=a_;break}else{z=0}ax=bT(-1,-1,0)|0;ay=M;bX();return 0}else{z=0;Z=47}}while(0);if((Z|0)==47){N=bT(-1,-1)|0;ah=M;ai=N;Z=48}if((Z|0)==48){a$=ai;a0=ah}if((a[l+28|0]&1)!=0){Lw(c[l+36>>2]|0)}if((a[l+4|0]&1)==0){a1=a$;a2=a0;break}Lw(c[l+12>>2]|0);a1=a$;a2=a0}else{z=0;N=bT(-1,-1)|0;L=N;N=M;if((a[C]&1)!=0){Lw(c[n+8>>2]|0)}if((a[B]&1)==0){a1=L;a2=N;break}Lw(c[m+8>>2]|0);a1=L;a2=N}}while(0);g_(k|0,c[k+4>>2]|0);ab=a1;ac=a2;ad=ab;ae=0;af=ad;ag=ac;bg(af|0);return 0}function go(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e|0;gv(b,c[9070]|0,114,d);g=f;h=f;a[h]=8;j=g+1|0;E=1633838962;a[j]=E;E=E>>8;a[j+1|0]=E;E=E>>8;a[j+2|0]=E;E=E>>8;a[j+3|0]=E;a[g+5|0]=0;z=0;aR(400,b|0,f|0,d|0);if(!z){if((a[h]&1)!=0){Lw(c[f+8>>2]|0)}gx(b,c[9152]|0,22,4,d);gx(b,c[9154]|0,98,2,d);gv(b,c[9072]|0,122,d);gv(b,c[9052]|0,38,d);gv(b,c[9066]|0,8,d);gv(b,c[9078]|0,52,d);gv(b,c[9086]|0,2,d);gv(b,c[9062]|0,6,d);gv(b,c[9084]|0,72,d);gv(b,c[9108]|0,60,d);gv(b,c[9126]|0,74,d);gv(b,c[9120]|0,28,d);gv(b,c[9146]|0,42,d);gv(b,c[9160]|0,70,d);gv(b,c[9134]|0,46,d);gv(b,c[9114]|0,82,d);gv(b,c[9130]|0,18,d);gv(b,c[9116]|0,10,d);gv(b,c[9158]|0,34,d);gv(b,c[9056]|0,84,d);gv(b,c[9142]|0,84,d);gv(b,c[9144]|0,120,d);gv(b,c[9148]|0,120,d);gv(b,c[9092]|0,24,d);gv(b,c[9136]|0,24,d);gv(b,c[9100]|0,56,d);gv(b,c[9102]|0,68,d);gv(b,c[9098]|0,106,d);gv(b,c[9112]|0,16,d);gv(b,c[9138]|0,78,d);gv(b,c[9048]|0,26,d);gv(b,c[9104]|0,40,d);gv(b,c[9106]|0,30,d);gv(b,c[9124]|0,86,d);gv(b,c[9122]|0,66,d);gv(b,c[9094]|0,94,d);gv(b,c[9096]|0,104,d);gv(b,c[9110]|0,20,d);gv(b,c[9046]|0,96,d);gv(b,c[9064]|0,102,d);gv(b,c[9054]|0,58,d);gv(b,c[9088]|0,48,d);gv(b,c[9080]|0,92,d);gv(b,c[9082]|0,4,d);gv(b,c[9156]|0,116,d);gv(b,c[9074]|0,76,d);gv(b,c[9050]|0,32,d);gv(b,c[9060]|0,62,d);gv(b,c[9162]|0,124,d);gv(b,c[9150]|0,14,d);gv(b,c[9068]|0,90,d);gv(b,c[9140]|0,50,d);gv(b,c[9058]|0,100,d);gv(b,c[9132]|0,36,d);gv(b,c[9118]|0,64,d);gv(b,c[9076]|0,88,d);gv(b,c[9090]|0,80,d);gv(b,c[9128]|0,12,d);i=e;return}else{z=0}e=bT(-1,-1)|0;if((a[h]&1)==0){bg(e|0)}Lw(c[f+8>>2]|0);bg(e|0)}function gp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=ql(c[e>>2]|0,c[e+4>>2]|0,c[e+8>>2]|0,b)|0;c[j+48>>2]=d;b=j|0;e=j+32|0;if((a[e]&1)==0){k=h;c[k>>2]=c[e>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];l=a[k]|0;m=k}else{k=c[j+40>>2]|0;e=c[j+36>>2]|0;if(e>>>0>4294967279>>>0){D5(0)}if(e>>>0<11>>>0){j=e<<1&255;n=h;a[n]=j;o=h+1|0;p=j;q=n}else{n=e+16&-16;j=Lu(n)|0;c[h+8>>2]=j;r=n|1;c[h>>2]=r;c[h+4>>2]=e;o=j;p=r&255;q=h}LF(o|0,k|0,e)|0;a[o+e|0]=0;l=p;m=q}q=g;LI(q|0,0,12)|0;p=l&255;if((p&1|0)==0){s=p>>>1}else{s=c[h+4>>2]|0}if((l&1)==0){t=h+1|0}else{t=c[h+8>>2]|0}l=s+3|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;u=23;break}}else{if(l>>>0<11>>>0){a[q]=s<<1;v=g+1|0}else{p=s+19&-16;e=(z=0,au(248,p|0)|0);if(z){z=0;u=23;break}c[g+8>>2]=e;c[g>>2]=p|1;c[g+4>>2]=s;v=e}LF(v|0,t|0,s)|0;a[v+s|0]=0;z=0,az(88,g|0,10464,3)|0;if(z){z=0;u=23;break}e=(z=0,aM(90,d|0,g|0)|0);if(z){z=0;p=bT(-1,-1)|0;o=p;p=M;if((a[q]&1)==0){w=p;x=o;break}Lw(c[g+8>>2]|0);w=p;x=o;break}c[e>>2]=b;if((a[q]&1)!=0){Lw(c[g+8>>2]|0)}if((a[m]&1)==0){i=f;return}Lw(c[h+8>>2]|0);i=f;return}}while(0);if((u|0)==23){u=bT(-1,-1)|0;f=M;if((a[q]&1)!=0){Lw(c[g+8>>2]|0)}w=f;x=u}if((a[m]&1)==0){y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[h+8>>2]|0);y=x;A=0;B=y;C=w;bg(B|0)}function gq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;d=i;i=i+48|0;f=d|0;g=d+16|0;h=d+32|0;j=e;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){D5(0)}if(k>>>0<11>>>0){a[h]=k<<1;l=h+1|0}else{e=k+16&-16;m=Lu(e)|0;c[h+8>>2]=m;c[h>>2]=e|1;c[h+4>>2]=k;l=m}LF(l|0,j|0,k)|0;a[l+k|0]=0}z=0;as(102,g|0,h|0);do{if(!z){k=f;LI(k|0,0,12)|0;l=g;j=g;m=a[j]|0;e=m&255;if((e&1|0)==0){n=e>>>1}else{n=c[g+4>>2]|0}e=n+21|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;o=24;break}}else{if(e>>>0<11>>>0){a[k]=42;p=f+1|0}else{q=n+37&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;o=24;break}c[f+8>>2]=r;c[f>>2]=q|1;c[f+4>>2]=21;p=r}LF(p|0,10568,21)|0;a[p+21|0]=0;if((m&1)==0){s=l+1|0}else{s=c[g+8>>2]|0}z=0,az(88,f|0,s|0,n|0)|0;if(z){z=0;o=24;break}z=0;aR(410,b|0,f|0,10560);if(z){z=0;r=bT(-1,-1)|0;q=r;r=M;if((a[k]&1)==0){t=r;u=q;break}Lw(c[f+8>>2]|0);t=r;u=q;break}if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}if((a[j]&1)!=0){Lw(c[g+8>>2]|0)}if((a[h]&1)==0){i=d;return}Lw(c[h+8>>2]|0);i=d;return}}while(0);if((o|0)==24){l=bT(-1,-1)|0;m=M;if((a[k]&1)!=0){Lw(c[f+8>>2]|0)}t=m;u=l}if((a[j]&1)==0){v=t;w=u;break}Lw(c[g+8>>2]|0);v=t;w=u}else{z=0;l=bT(-1,-1)|0;v=M;w=l}}while(0);if((a[h]&1)==0){x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[h+8>>2]|0);x=w;y=0;A=x;B=v;bg(A|0)}function gr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=b;LI(f|0,0,12)|0;g=a[d]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}h=LJ(e|0)|0;if((g&1)==0){j=d+1|0}else{j=c[d+8>>2]|0}d=h+i|0;do{if(d>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(d>>>0<11>>>0){a[f]=i<<1;k=b+1|0}else{g=d+16&-16;l=(z=0,au(248,g|0)|0);if(z){z=0;break}c[b+8>>2]=l;c[b>>2]=g|1;c[b+4>>2]=i;k=l}LF(k|0,j|0,i)|0;a[k+i|0]=0;z=0,az(88,b|0,e|0,h|0)|0;if(z){z=0;break}return}}while(0);h=bT(-1,-1)|0;if((a[f]&1)==0){bg(h|0)}Lw(c[b+8>>2]|0);bg(h|0)}function gs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d|0;if((a[b+141|0]&1)==0){f=0;i=d;return f|0}AA(e,b+64|0);b=e;if((a[b]&1)==0){g=e+1|0}else{g=c[e+8>>2]|0}h=(z=0,au(250,g|0)|0);if(!z){if((a[b]&1)==0){f=h;i=d;return f|0}Lw(c[e+8>>2]|0);f=h;i=d;return f|0}else{z=0;f=bT(-1,-1)|0;if((a[b]&1)==0){bg(f|0)}Lw(c[e+8>>2]|0);bg(f|0)}return 0}function gt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d|0;f=b+12|0;g=c[f>>2]|0;if((g|0)==0){h=0;i=d;return h|0}j=b+40|0;k=c[j>>2]|0;l=b+44|0;m=c[l>>2]|0;if((k|0)==(m|0)){n=g}else{g=m;while(1){m=g-16|0;c[l>>2]=m;if((a[m]&1)==0){o=m}else{Lw(c[g-16+8>>2]|0);o=c[l>>2]|0}if((k|0)==(o|0)){break}else{g=o}}n=c[f>>2]|0}f=Lu(16)|0;o=e+8|0;c[o>>2]=f;c[e>>2]=17;c[e+4>>2]=13;LF(f|0,10512,13)|0;a[f+13|0]=0;g=e+12|0;c[g>>2]=n;do{if((k|0)==(c[b+48>>2]|0)){z=0;as(532,j|0,e|0);if(z){z=0;p=16;break}if((a[e]&1)!=0){p=14}}else{if((k|0)==0){q=0}else{n=(z=0,au(248,16)|0);if(z){z=0;p=16;break}c[k+8>>2]=n;c[k>>2]=17;c[k+4>>2]=13;LF(n|0,f|0,13)|0;a[n+13|0]=0;c[k+12>>2]=c[g>>2];q=c[l>>2]|0}c[l>>2]=q+16;p=14}}while(0);if((p|0)==14){Lw(c[o>>2]|0)}else if((p|0)==16){p=bT(-1,-1)|0;if((a[e]&1)==0){bg(p|0)}Lw(c[o>>2]|0);bg(p|0)}h=gn(b)|0;i=d;return h|0}function gu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+32|0;j=d+188|0;k=j|0;l=d+192|0;gG(c[k>>2]|0,c[l>>2]|0,e+24|0);d=c[l>>2]|0;c[f>>2]=c[k>>2];c[g>>2]=d;gz(h,f,g,e+16|0);g=c[h>>2]|0;h=c[l>>2]|0;f=c[k>>2]|0;k=f;d=g;m=(d-k|0)/12|0;n=f+(m*12|0)|0;if((g|0)==(h|0)){gM(b,j);i=e;return}g=((h-d|0)/12|0)+m|0;d=f+(g*12|0)|0;if((d|0)==(h|0)){o=n;p=h}else{q=h+(~g*12|0)+(-k|0)|0;k=m+1|0;m=n;n=d;while(1){Ec(m,n)|0;d=n+12|0;if((d|0)==(h|0)){break}else{m=m+12|0;n=d}}o=f+((k+((q>>>0)/12|0)|0)*12|0)|0;p=c[l>>2]|0}if((o|0)==(p|0)){gM(b,j);i=e;return}else{r=p}while(1){p=r-12|0;c[l>>2]=p;if((a[p]&1)==0){s=p}else{Lw(c[r-12+8>>2]|0);s=c[l>>2]|0}if((o|0)==(s|0)){break}else{r=s}}gM(b,j);i=e;return}function gv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;g=i;i=i+32|0;h=g|0;j=g+16|0;k=qk(d,e,b)|0;c[k+48>>2]=f;b=k|0;e=k+32|0;if((a[e]&1)==0){d=j;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];l=a[d]|0;m=d}else{d=c[k+40>>2]|0;e=c[k+36>>2]|0;if(e>>>0>4294967279>>>0){D5(0)}if(e>>>0<11>>>0){k=e<<1&255;n=j;a[n]=k;o=j+1|0;p=k;q=n}else{n=e+16&-16;k=Lu(n)|0;c[j+8>>2]=k;r=n|1;c[j>>2]=r;c[j+4>>2]=e;o=k;p=r&255;q=j}LF(o|0,d|0,e)|0;a[o+e|0]=0;l=p;m=q}q=h;LI(q|0,0,12)|0;p=l&255;if((p&1|0)==0){s=p>>>1}else{s=c[j+4>>2]|0}if((l&1)==0){t=j+1|0}else{t=c[j+8>>2]|0}l=s+3|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;u=23;break}}else{if(l>>>0<11>>>0){a[q]=s<<1;v=h+1|0}else{p=s+19&-16;e=(z=0,au(248,p|0)|0);if(z){z=0;u=23;break}c[h+8>>2]=e;c[h>>2]=p|1;c[h+4>>2]=s;v=e}LF(v|0,t|0,s)|0;a[v+s|0]=0;z=0,az(88,h|0,10464,3)|0;if(z){z=0;u=23;break}e=(z=0,aM(90,f|0,h|0)|0);if(z){z=0;p=bT(-1,-1)|0;o=p;p=M;if((a[q]&1)==0){w=p;x=o;break}Lw(c[h+8>>2]|0);w=p;x=o;break}c[e>>2]=b;if((a[q]&1)!=0){Lw(c[h+8>>2]|0)}if((a[m]&1)==0){i=g;return}Lw(c[j+8>>2]|0);i=g;return}}while(0);if((u|0)==23){u=bT(-1,-1)|0;g=M;if((a[q]&1)!=0){Lw(c[h+8>>2]|0)}w=g;x=u}if((a[m]&1)==0){y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[j+8>>2]|0);y=x;A=0;B=y;C=w;bg(B|0)}function gw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e|0;g=b|0;if((fs(b|0,d)|0)!=0){h=fo(g,d)|0;i=e;return h|0}j=c[b+12>>2]|0;if((j|0)==0){h=fo(g,d)|0;i=e;return h|0}g=d;if((a[g]&1)==0){b=f;c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2]}else{g=c[d+8>>2]|0;b=c[d+4>>2]|0;if(b>>>0>4294967279>>>0){D5(0);return 0}if(b>>>0<11>>>0){a[f]=b<<1;k=f+1|0}else{d=b+16&-16;l=Lu(d)|0;c[f+8>>2]=l;c[f>>2]=d|1;c[f+4>>2]=b;k=l}LF(k|0,g|0,b)|0;a[k+b|0]=0}b=(z=0,aM(90,j|0,f|0)|0);if(!z){if((a[f]&1)==0){h=b;i=e;return h|0}Lw(c[f+8>>2]|0);h=b;i=e;return h|0}else{z=0;h=bT(-1,-1)|0;if((a[f]&1)==0){bg(h|0)}Lw(c[f+8>>2]|0);bg(h|0)}return 0}function gx(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;h=i;i=i+16|0;j=h|0;k=j;l=i;i=i+144|0;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=qk(d,e,b)|0;b=l+64|0;e=l|0;d=l+8|0;p=d|0;c[p>>2]=15464;q=l+12|0;c[e>>2]=32540;r=l+64|0;c[r>>2]=32560;c[l+4>>2]=0;z=0;as(198,l+64|0,q|0);do{if(!z){c[l+136>>2]=0;c[l+140>>2]=-1;s=l+8|0;c[e>>2]=15444;c[b>>2]=15484;c[p>>2]=15464;t=q|0;c[t>>2]=15768;u=l+16|0;I_(u);v=l+20|0;LI(v|0,0,24)|0;c[t>>2]=15624;w=l+44|0;x=l+56|0;y=l+60|0;LI(l+44|0,0,16)|0;c[y>>2]=24;LI(k|0,0,12)|0;z=0;as(212,q|0,j|0);if(z){z=0;A=bT(-1,-1)|0;B=M;if((a[k]&1)!=0){Lw(c[j+8>>2]|0)}if((a[w]&1)!=0){Lw(c[l+52>>2]|0)}c[t>>2]=15768;z=0;ar(394,u|0);if(!z){C=A;D=B;break}else{z=0}bT(-1,-1,0)|0;bX()}if((a[k]&1)!=0){Lw(c[j+8>>2]|0)}B=o+32|0;do{if((a[B]&1)==0){A=m;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];E=25}else{A=c[o+40>>2]|0;t=c[o+36>>2]|0;if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;E=69;break}}if(t>>>0<11>>>0){a[m]=t<<1;F=m+1|0}else{G=t+16&-16;H=(z=0,au(248,G|0)|0);if(z){z=0;E=69;break}c[m+8>>2]=H;c[m>>2]=G|1;c[m+4>>2]=t;F=H}LF(F|0,A|0,t)|0;a[F+t|0]=0;E=25}}while(0);L28:do{if((E|0)==25){B=(z=0,aM(814,d|0,m|0)|0);do{if(!z){t=(z=0,aM(114,B|0,10464)|0);if(z){z=0;break}z=0,aM(312,t|0,f|0)|0;if(z){z=0;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}c[o+48>>2]=g;t=o|0;A=n;H=c[y>>2]|0;do{if((H&16|0)==0){if((H&8|0)==0){LI(A|0,0,12)|0;break}G=c[v>>2]|0;I=c[l+28>>2]|0;J=G;K=I-J|0;if(K>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;E=69;break L28}}if(K>>>0<11>>>0){a[A]=K<<1;L=n+1|0}else{N=K+16&-16;O=(z=0,au(248,N|0)|0);if(z){z=0;E=69;break L28}c[n+8>>2]=O;c[n>>2]=N|1;c[n+4>>2]=K;L=O}if((G|0)==(I|0)){P=L}else{O=I+(-J|0)|0;J=L;K=G;while(1){a[J]=a[K]|0;G=K+1|0;if((G|0)==(I|0)){break}else{J=J+1|0;K=G}}P=L+O|0}a[P]=0}else{K=c[x>>2]|0;J=c[l+36>>2]|0;if(K>>>0<J>>>0){c[x>>2]=J;Q=J}else{Q=K}K=c[l+32>>2]|0;J=K;I=Q-J|0;if(I>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;E=69;break L28}}if(I>>>0<11>>>0){a[A]=I<<1;R=n+1|0}else{G=I+16&-16;N=(z=0,au(248,G|0)|0);if(z){z=0;E=69;break L28}c[n+8>>2]=N;c[n>>2]=G|1;c[n+4>>2]=I;R=N}if((K|0)==(Q|0)){S=R}else{N=Q+(-J|0)|0;J=R;I=K;while(1){a[J]=a[I]|0;K=I+1|0;if((K|0)==(Q|0)){break}else{J=J+1|0;I=K}}S=R+N|0}a[S]=0}}while(0);H=(z=0,aM(90,g|0,n|0)|0);if(z){z=0;I=bT(-1,-1)|0;J=I;I=M;if((a[A]&1)==0){T=I;U=J;break L28}Lw(c[n+8>>2]|0);T=I;U=J;break L28}c[H>>2]=t;if((a[A]&1)!=0){Lw(c[n+8>>2]|0)}c[e>>2]=15444;c[r>>2]=15484;c[s>>2]=15464;H=l+12|0;c[H>>2]=15624;if((a[w]&1)!=0){Lw(c[l+52>>2]|0)}c[H>>2]=15768;z=0;ar(394,u|0);if(!z){Ex(l+64|0);i=h;return}else{z=0}H=bT(-1,-1)|0;z=0;ar(272,l+64|0);if(!z){bg(H|0)}else{z=0;bT(-1,-1,0)|0;bX()}}else{z=0}}while(0);B=bT(-1,-1)|0;H=B;B=M;if((a[m]&1)==0){T=B;U=H;break}Lw(c[m+8>>2]|0);T=B;U=H}}while(0);if((E|0)==69){x=bT(-1,-1)|0;T=M;U=x}c[e>>2]=15444;c[r>>2]=15484;c[s>>2]=15464;x=l+12|0;c[x>>2]=15624;if((a[w]&1)!=0){Lw(c[l+52>>2]|0)}c[x>>2]=15768;z=0;ar(394,u|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,l+64|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,l+64|0);if(!z){bg(U|0)}else{z=0}bT(-1,-1,0)|0;bX()}else{z=0;x=bT(-1,-1)|0;C=x;D=M}}while(0);z=0;ar(272,b|0);if(!z){bg(C|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function gy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+72|0;g=f|0;h=f+16|0;j=f+24|0;k=f+40|0;l=f+56|0;m=Lu(76)|0;c[h>>2]=m;n=b+4|0;o=c[n>>2]|0;if((o|0)==(c[b+8>>2]|0)){e4(b|0,h);p=c[h>>2]|0}else{if((o|0)==0){q=0}else{c[o>>2]=m;q=c[n>>2]|0}c[n>>2]=q+4;p=m}m=p;q=p;o=(z=0,au(248,32)|0);do{if(!z){h=j+8|0;c[h>>2]=o;c[j>>2]=33;c[j+4>>2]=19;LF(o|0,10440,19)|0;a[o+19|0]=0;r=d;L10:do{if((a[r]&1)==0){s=k;c[s>>2]=c[r>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];t=17}else{s=c[d+8>>2]|0;u=c[d+4>>2]|0;do{if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(u>>>0<11>>>0){a[k]=u<<1;v=k+1|0}else{w=u+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[k+8>>2]=x;c[k>>2]=w|1;c[k+4>>2]=u;v=x}LF(v|0,s|0,u)|0;a[v+u|0]=0;t=17;break L10}}while(0);u=bT(-1,-1)|0;y=M;A=u}}while(0);do{if((t|0)==17){c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;z=0;aC(16,q|0,j|0,g|0,0,k|0,0,0,1);if(z){z=0;r=bT(-1,-1)|0;u=r;r=M;if((a[k]&1)==0){y=r;A=u;break}Lw(c[k+8>>2]|0);y=r;A=u;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((a[j]&1)!=0){Lw(c[h>>2]|0)}gr(l,d,10464);u=(z=0,aM(90,e|0,l|0)|0);if(!z){c[u>>2]=p;if((a[l]&1)==0){i=f;return}Lw(c[l+8>>2]|0);i=f;return}else{z=0;u=bT(-1,-1)|0;r=u;u=M;if((a[l]&1)==0){B=u;C=r;D=C;E=0;F=D;G=B;bg(F|0)}Lw(c[l+8>>2]|0);B=u;C=r;D=C;E=0;F=D;G=B;bg(F|0)}}}while(0);if((a[j]&1)==0){H=y;I=A;break}Lw(c[h>>2]|0);H=y;I=A}else{z=0;r=bT(-1,-1)|0;H=M;I=r}}while(0);A=c[b>>2]|0;b=c[n>>2]|0;y=A;while(1){if((y|0)==(b|0)){J=b;break}if((c[y>>2]|0)==(p|0)){J=y;break}else{y=y+4|0}}y=J-A>>2;J=A+(y+1<<2)|0;p=b-J|0;LG(A+(y<<2)|0,J|0,p|0)|0;J=A+((p>>2)+y<<2)|0;y=c[n>>2]|0;if((J|0)!=(y|0)){c[n>>2]=y+(~((y-4+(-J|0)|0)>>>2)<<2)}Lw(m);B=H;C=I;D=C;E=0;F=D;G=B;bg(F|0)}function gz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;h=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[h>>2];h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=f;f=i;i=i+1|0;i=i+7&-8;a[f]=a[h]|0;h=d|0;d=c[h>>2]|0;f=c[e>>2]|0;L1:do{if((d|0)==(f|0)){j=d}else{e=d+12|0;if((e|0)!=(f|0)){k=d;l=e;e=a[d]|0;while(1){m=k;n=e&255;if((n&1|0)==0){o=n>>>1}else{o=c[k+4>>2]|0}n=l;p=a[l]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[k+16>>2]|0}L15:do{if((o|0)==(r|0)){q=(a[k]&1)==0;if(q){s=m+1|0}else{s=c[k+8>>2]|0}if((p&1)==0){t=n+1|0}else{t=c[k+20>>2]|0}if(!q){if((LH(s|0,t|0,o|0)|0)==0){j=k;break L1}else{break}}if((o|0)==0){j=k;break L1}else{u=t;v=s;w=o}while(1){if((a[v]|0)!=(a[u]|0)){break L15}q=w-1|0;if((q|0)==0){j=k;break L1}else{u=u+1|0;v=v+1|0;w=q}}}}while(0);n=l+12|0;if((n|0)==(f|0)){break}else{k=l;l=n;e=p}}}c[h>>2]=f;x=f;y=b|0;c[y>>2]=x;i=g;return}}while(0);c[h>>2]=j;if((j|0)==(f|0)){x=f;y=b|0;c[y>>2]=x;i=g;return}w=j+24|0;if((w|0)==(f|0)){z=j}else{v=j+12|0;u=w;w=j;while(1){j=w;o=a[w]|0;s=o&255;if((s&1|0)==0){A=s>>>1}else{A=c[w+4>>2]|0}s=u;t=a[u]|0;r=t&255;if((r&1|0)==0){B=r>>>1}else{B=c[v+16>>2]|0}L50:do{if((A|0)==(B|0)){r=(o&1)==0;if(r){C=j+1|0}else{C=c[w+8>>2]|0}if((t&1)==0){D=s+1|0}else{D=c[v+20>>2]|0}if(!r){if((LH(C|0,D|0,A|0)|0)==0){E=w;break}else{F=45;break}}if((A|0)==0){E=w;break}else{G=D;H=C;I=A}while(1){if((a[H]|0)!=(a[G]|0)){F=45;break L50}r=I-1|0;if((r|0)==0){E=w;break}else{G=G+1|0;H=H+1|0;I=r}}}else{F=45}}while(0);if((F|0)==45){F=0;s=w+12|0;c[h>>2]=s;Ec(s,u)|0;E=s}s=u+12|0;if((s|0)==(f|0)){z=E;break}else{v=u;u=s;w=E}}}E=z+12|0;c[h>>2]=E;x=E;y=b|0;c[y>>2]=x;i=g;return}function gA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=(f&1|0)==0;j=f>>>1;f=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;e=g;while(1){g=e+16|0;if(i){m=j}else{m=c[l>>2]|0}n=g;o=a[g]|0;g=o&255;p=(g&1|0)==0;if(p){q=g>>>1}else{q=c[e+20>>2]|0}if(f){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=LH(r|0,t|0,(q>>>0<m>>>0?q:m)|0)|0;if((o|0)==0){if(m>>>0<q>>>0){u=16}}else{if((o|0)<0){u=16}}if((u|0)==16){u=0;v=e|0;o=c[v>>2]|0;if((o|0)==0){u=17;break}else{e=o;continue}}if(p){w=g>>>1}else{w=c[e+20>>2]|0}if(i){x=j}else{x=c[l>>2]|0}if(s){y=n+1|0}else{y=c[e+24>>2]|0}if(f){z=b}else{z=c[k>>2]|0}n=LH(y|0,z|0,(x>>>0<w>>>0?x:w)|0)|0;if((n|0)==0){if(w>>>0>=x>>>0){u=33;break}}else{if((n|0)>=0){u=33;break}}A=e+4|0;n=c[A>>2]|0;if((n|0)==0){u=32;break}else{e=n}}if((u|0)==33){c[d>>2]=e;h=d;return h|0}else if((u|0)==17){c[d>>2]=e;h=v;return h|0}else if((u|0)==32){c[d>>2]=e;h=A;return h|0}return 0}function gB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;e=b+4|0;f=c[e>>2]|0;g=b|0;h=c[g>>2]|0;i=h;j=f-i>>4;k=j+1|0;if(k>>>0>268435455>>>0){IU(0)}l=b+8|0;b=(c[l>>2]|0)-i|0;if(b>>4>>>0>134217726>>>0){m=268435455;n=5}else{i=b>>3;b=i>>>0<k>>>0?k:i;if((b|0)==0){o=0;p=0}else{m=b;n=5}}if((n|0)==5){o=Lu(m<<4)|0;p=m}m=o+(j<<4)|0;b=o+(p<<4)|0;L9:do{if((m|0)==0){q=f;n=18}else{p=d;L11:do{if((a[p]&1)==0){i=m;c[i>>2]=c[p>>2];c[i+4>>2]=c[p+4>>2];c[i+8>>2]=c[p+8>>2];r=f}else{i=c[d+8>>2]|0;s=c[d+4>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(s>>>0<11>>>0){a[m]=s<<1;t=m+1|0}else{u=s+16&-16;v=(z=0,au(248,u|0)|0);if(z){z=0;break}c[o+(j<<4)+8>>2]=v;c[m>>2]=u|1;c[o+(j<<4)+4>>2]=s;t=v}LF(t|0,i|0,s)|0;a[t+s|0]=0;r=c[e>>2]|0;break L11}}while(0);s=bT(-1,-1)|0;w=M;x=s;break L9}}while(0);c[o+(j<<4)+12>>2]=c[d+12>>2];q=r;n=18}}while(0);L25:do{if((n|0)==18){r=o+(k<<4)|0;L27:do{if((q|0)==(h|0)){c[g>>2]=m;c[e>>2]=r;c[l>>2]=b;y=h}else{d=q;j=m;while(1){A=j-16|0;t=d-16|0;if((A|0)!=0){f=t;if((a[f]&1)==0){p=A;c[p>>2]=c[f>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2]}else{f=c[d-16+8>>2]|0;p=c[d-16+4>>2]|0;if(p>>>0>4294967279>>>0){n=24;break}if(p>>>0<11>>>0){a[A]=p<<1;B=A+1|0}else{s=p+16&-16;i=(z=0,au(248,s|0)|0);if(z){z=0;n=41;break}c[j-16+8>>2]=i;c[A>>2]=s|1;c[j-16+4>>2]=p;B=i}LF(B|0,f|0,p)|0;a[B+p|0]=0}c[j-16+12>>2]=c[d-16+12>>2]}if((t|0)==(h|0)){n=33;break}else{d=t;j=A}}do{if((n|0)==41){d=bT(-1,-1)|0;C=M;D=d}else if((n|0)==33){d=c[g>>2]|0;t=c[e>>2]|0;c[g>>2]=A;c[e>>2]=r;c[l>>2]=b;if((d|0)==(t|0)){y=d;break L27}else{E=t}while(1){t=E-16|0;if((a[t]&1)!=0){Lw(c[E-16+8>>2]|0)}if((d|0)==(t|0)){y=d;break L27}else{E=t}}}else if((n|0)==24){z=0;ar(86,0);if(z){z=0;d=bT(-1,-1)|0;C=M;D=d;break}}}while(0);if((j|0)==(r|0)){w=C;x=D;break L25}else{F=r}while(1){d=F-16|0;if((a[d]&1)!=0){Lw(c[F-16+8>>2]|0)}if((j|0)==(d|0)){w=C;x=D;break L25}else{F=d}}}}while(0);if((y|0)==0){return}Lw(y);return}}while(0);if((o|0)==0){bg(x|0)}Lw(o);bg(x|0)}function gC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function gD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=LH(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==17){t=0;if(o){u=e>>>1}else{u=c[d+20>>2]|0}if(h){v=i}else{v=c[k>>2]|0}if(r){w=m+1|0}else{w=c[d+24>>2]|0}if(g){x=b}else{x=c[j>>2]|0}m=LH(w|0,x|0,(v>>>0<u>>>0?v:u)|0)|0;if((m|0)==0){if(u>>>0>=v>>>0){f=1;t=34;break}}else{if((m|0)>=0){f=1;t=36;break}}y=d+4|0}else if((t|0)==16){t=0;y=d|0}m=c[y>>2]|0;if((m|0)==0){f=0;t=35;break}else{d=m}}if((t|0)==36){return f|0}else if((t|0)==35){return f|0}else if((t|0)==34){return f|0}return 0}function gE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=f>>>1;j=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;L5:do{if((f&1|0)==0){e=g;while(1){m=e+16|0;n=m;o=a[m]|0;m=o&255;p=(m&1|0)==0;if(p){q=m>>>1}else{q=c[e+20>>2]|0}if(j){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=LH(r|0,t|0,(q>>>0<i>>>0?q:i)|0)|0;if((o|0)==0){if(i>>>0<q>>>0){u=26}}else{if((o|0)<0){u=26}}if((u|0)==26){u=0;o=e|0;v=c[o>>2]|0;if((v|0)==0){w=e;x=o;u=39;break}else{e=v;continue}}if(p){y=m>>>1}else{y=c[e+20>>2]|0}if(s){z=n+1|0}else{z=c[e+24>>2]|0}if(j){A=b}else{A=c[k>>2]|0}n=LH(z|0,A|0,(i>>>0<y>>>0?i:y)|0)|0;if((n|0)==0){if(y>>>0>=i>>>0){B=e;u=53;break L5}}else{if((n|0)>=0){B=e;u=53;break L5}}n=e+4|0;s=c[n>>2]|0;if((s|0)==0){C=e;D=n;u=52;break}else{e=s}}}else{e=g;while(1){s=e+16|0;n=c[l>>2]|0;m=s;p=a[s]|0;s=p&255;v=(s&1|0)==0;if(v){E=s>>>1}else{E=c[e+20>>2]|0}if(j){F=b}else{F=c[k>>2]|0}o=(p&1)==0;if(o){G=m+1|0}else{G=c[e+24>>2]|0}p=LH(F|0,G|0,(E>>>0<n>>>0?E:n)|0)|0;if((p|0)==0){if(n>>>0<E>>>0){u=38}}else{if((p|0)<0){u=38}}if((u|0)==38){u=0;p=e|0;n=c[p>>2]|0;if((n|0)==0){w=e;x=p;u=39;break}else{e=n;continue}}if(v){H=s>>>1}else{H=c[e+20>>2]|0}s=c[l>>2]|0;if(o){I=m+1|0}else{I=c[e+24>>2]|0}if(j){J=b}else{J=c[k>>2]|0}m=LH(I|0,J|0,(s>>>0<H>>>0?s:H)|0)|0;if((m|0)==0){if(H>>>0>=s>>>0){B=e;u=53;break L5}}else{if((m|0)>=0){B=e;u=53;break L5}}m=e+4|0;s=c[m>>2]|0;if((s|0)==0){C=e;D=m;u=52;break}else{e=s}}}}while(0);if((u|0)==52){c[d>>2]=C;h=D;return h|0}else if((u|0)==53){c[d>>2]=B;h=d;return h|0}else if((u|0)==39){c[d>>2]=w;h=x;return h|0}return 0}function gF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;b=a+4|0;d=a|0;a=c[d>>2]|0;e=(c[b>>2]|0)-a>>2;L1:do{if((e|0)==0){f=a}else{g=0;h=a;while(1){i=c[h+(g<<2)>>2]|0;if((i|0)!=0){z=0;ar(c[(c[i>>2]|0)+4>>2]|0,i|0);if(z){z=0;break}}i=g+1|0;j=c[d>>2]|0;if(i>>>0<e>>>0){g=i;h=j}else{f=j;break L1}}h=bT(-1,-1)|0;g=c[d>>2]|0;if((g|0)==0){bg(h|0)}j=c[b>>2]|0;if((g|0)!=(j|0)){c[b>>2]=j+(~((j-4+(-g|0)|0)>>>2)<<2)}Lw(g);bg(h|0)}}while(0);if((f|0)==0){return}d=c[b>>2]|0;if((f|0)!=(d|0)){c[b>>2]=d+(~((d-4+(-f|0)|0)>>>2)<<2)}Lw(f);return}function gG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0;f=i;i=i+96|0;g=f+80|0;h=f|0;j=f+16|0;k=f+32|0;l=f+48|0;m=f+64|0;n=d;d=b;L1:while(1){b=d;o=d;p=d+1|0;q=d+12|0;r=d+8|0;s=d+4|0;t=n;L3:while(1){u=t;v=u-b|0;switch((v|0)/12|0|0){case 5:{w=21;break L1;break};case 4:{w=20;break L1;break};case 2:{w=4;break L1;break};case 3:{w=19;break L1;break};case 0:case 1:{w=186;break L1;break};default:{}}if((v|0)<84){w=23;break L1}x=t-12|0;y=(v|0)/24|0;z=d+(y*12|0)|0;if((v|0)>11988){A=(v|0)/48|0;B=gJ(d,d+(A*12|0)|0,z,d+((A+y|0)*12|0)|0,x,0)|0}else{B=gH(d,z,x,0)|0}A=a[o]|0;C=A&255;D=(C&1|0)==0;if(D){E=C>>>1}else{E=c[s>>2]|0}v=z;F=a[z]|0;G=F&255;H=(G&1|0)==0;if(H){I=G>>>1}else{I=c[d+(y*12|0)+4>>2]|0}J=(A&1)==0;if(J){K=p}else{K=c[r>>2]|0}A=(F&1)==0;if(A){L=v+1|0}else{L=c[d+(y*12|0)+8>>2]|0}F=LH(K|0,L|0,(I>>>0<E>>>0?I:E)|0)|0;if((F|0)==0){if(E>>>0<I>>>0){M=x;N=B}else{w=41}}else{if((F|0)<0){M=x;N=B}else{w=41}}if((w|0)==41){w=0;F=t-24|0;if((d|0)==(F|0)){break}O=G>>>1;G=v+1|0;v=d+(y*12|0)+8|0;P=d+(y*12|0)+4|0;y=x;Q=F;while(1){R=Q;F=a[R]|0;S=F&255;if((S&1|0)==0){T=S>>>1}else{T=c[y-12+4>>2]|0}if(H){U=O}else{U=c[P>>2]|0}if((F&1)==0){V=Q+1|0}else{V=c[y-12+8>>2]|0}if(A){W=G}else{W=c[v>>2]|0}F=LH(V|0,W|0,(U>>>0<T>>>0?U:T)|0)|0;if((F|0)==0){if(T>>>0<U>>>0){break}}else{if((F|0)<0){break}}F=Q-12|0;if((d|0)==(F|0)){break L3}else{y=Q;Q=F}}c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[o>>2]=c[R>>2];c[o+4>>2]=c[R+4>>2];c[o+8>>2]=c[R+8>>2];c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];c[R+8>>2]=c[k+8>>2];M=Q;N=B+1|0}L54:do{if(q>>>0<M>>>0){y=M;v=q;G=N;A=z;while(1){P=a[A]|0;O=P&255;H=(O&1|0)==0;F=O>>>1;O=(P&1)==0;P=A+1|0;S=A+8|0;X=A+4|0;Y=v;while(1){Z=Y;_=a[Z]|0;$=_&255;if(($&1|0)==0){aa=$>>>1}else{aa=c[Y+4>>2]|0}if(H){ab=F}else{ab=c[X>>2]|0}if((_&1)==0){ac=Y+1|0}else{ac=c[Y+8>>2]|0}if(O){ad=P}else{ad=c[S>>2]|0}_=LH(ac|0,ad|0,(ab>>>0<aa>>>0?ab:aa)|0)|0;if((_|0)==0){if(aa>>>0>=ab>>>0){ae=y;break}}else{if((_|0)>=0){ae=y;break}}Y=Y+12|0}while(1){af=ae-12|0;ag=af;_=a[ag]|0;$=_&255;if(($&1|0)==0){ah=$>>>1}else{ah=c[ae-12+4>>2]|0}if(H){ai=F}else{ai=c[X>>2]|0}if((_&1)==0){aj=af+1|0}else{aj=c[ae-12+8>>2]|0}if(O){ak=P}else{ak=c[S>>2]|0}_=LH(aj|0,ak|0,(ai>>>0<ah>>>0?ai:ah)|0)|0;if((_|0)==0){if(ah>>>0<ai>>>0){break}else{ae=af;continue}}else{if((_|0)>-1){ae=af;continue}else{break}}}if(Y>>>0>af>>>0){al=Y;am=G;an=A;break L54}c[j>>2]=c[Z>>2];c[j+4>>2]=c[Z+4>>2];c[j+8>>2]=c[Z+8>>2];c[Z>>2]=c[ag>>2];c[Z+4>>2]=c[ag+4>>2];c[Z+8>>2]=c[ag+8>>2];c[ag>>2]=c[j>>2];c[ag+4>>2]=c[j+4>>2];c[ag+8>>2]=c[j+8>>2];y=af;v=Y+12|0;G=G+1|0;A=(A|0)==(Y|0)?af:A}}else{al=q;am=N;an=z}}while(0);do{if((al|0)==(an|0)){ao=am}else{z=an;Q=a[z]|0;A=Q&255;if((A&1|0)==0){ap=A>>>1}else{ap=c[an+4>>2]|0}A=al;G=a[A]|0;v=G&255;if((v&1|0)==0){aq=v>>>1}else{aq=c[al+4>>2]|0}if((Q&1)==0){ar=an+1|0}else{ar=c[an+8>>2]|0}if((G&1)==0){as=al+1|0}else{as=c[al+8>>2]|0}G=LH(ar|0,as|0,(aq>>>0<ap>>>0?aq:ap)|0)|0;if((G|0)==0){if(ap>>>0>=aq>>>0){ao=am;break}}else{if((G|0)>=0){ao=am;break}}c[h>>2]=c[A>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];c[A>>2]=c[z>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];c[z>>2]=c[h>>2];c[z+4>>2]=c[h+4>>2];c[z+8>>2]=c[h+8>>2];ao=am+1|0}}while(0);do{if((ao|0)==0){z=gL(d,al,0)|0;A=al+12|0;if(gL(A,t,0)|0){if(z){w=176;break L1}else{t=al;continue L3}}else{if(z){n=t;d=A;continue L1}else{break}}}}while(0);A=al;if((A-b|0)<(u-A|0)){w=173;break}gG(al+12|0,t,e);t=al}if((w|0)==173){w=0;gG(d,al,e);n=t;d=al+12|0;continue}if(D){at=C>>>1}else{at=c[s>>2]|0}b=x;A=a[b]|0;z=A&255;if((z&1|0)==0){au=z>>>1}else{au=c[t-12+4>>2]|0}if(J){av=p}else{av=c[r>>2]|0}if((A&1)==0){aw=x+1|0}else{aw=c[t-12+8>>2]|0}A=LH(av|0,aw|0,(au>>>0<at>>>0?au:at)|0)|0;if((A|0)==0){if(at>>>0<au>>>0){ax=q}else{w=57}}else{if((A|0)<0){ax=q}else{w=57}}if((w|0)==57){w=0;if((q|0)==(x|0)){w=181;break}A=C>>>1;z=q;while(1){if(D){ay=A}else{ay=c[s>>2]|0}az=z;G=a[az]|0;Q=G&255;if((Q&1|0)==0){aA=Q>>>1}else{aA=c[z+4>>2]|0}if(J){aB=p}else{aB=c[r>>2]|0}if((G&1)==0){aC=z+1|0}else{aC=c[z+8>>2]|0}G=LH(aB|0,aC|0,(aA>>>0<ay>>>0?aA:ay)|0)|0;if((G|0)==0){if(ay>>>0<aA>>>0){break}}else{if((G|0)<0){break}}G=z+12|0;if((G|0)==(x|0)){w=184;break L1}else{z=G}}c[m>>2]=c[az>>2];c[m+4>>2]=c[az+4>>2];c[m+8>>2]=c[az+8>>2];c[az>>2]=c[b>>2];c[az+4>>2]=c[b+4>>2];c[az+8>>2]=c[b+8>>2];c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];ax=z+12|0}if((ax|0)==(x|0)){w=185;break}else{aD=x;aE=ax}while(1){A=a[o]|0;G=A&255;Q=(G&1|0)==0;v=G>>>1;G=(A&1)==0;A=aE;while(1){if(Q){aF=v}else{aF=c[s>>2]|0}aG=A;y=a[aG]|0;S=y&255;if((S&1|0)==0){aH=S>>>1}else{aH=c[A+4>>2]|0}if(G){aI=p}else{aI=c[r>>2]|0}if((y&1)==0){aJ=A+1|0}else{aJ=c[A+8>>2]|0}y=LH(aI|0,aJ|0,(aH>>>0<aF>>>0?aH:aF)|0)|0;if((y|0)==0){if(aF>>>0<aH>>>0){aK=aD;break}}else{if((y|0)<=-1){aK=aD;break}}A=A+12|0}while(1){aL=aK-12|0;if(Q){aM=v}else{aM=c[s>>2]|0}aN=aL;u=a[aN]|0;y=u&255;if((y&1|0)==0){aO=y>>>1}else{aO=c[aK-12+4>>2]|0}if(G){aP=p}else{aP=c[r>>2]|0}if((u&1)==0){aQ=aL+1|0}else{aQ=c[aK-12+8>>2]|0}u=LH(aP|0,aQ|0,(aO>>>0<aM>>>0?aO:aM)|0)|0;if((u|0)==0){if(aM>>>0<aO>>>0){aK=aL;continue}else{break}}else{if((u|0)<0){aK=aL;continue}else{break}}}if(A>>>0>=aL>>>0){n=t;d=A;continue L1}c[l>>2]=c[aG>>2];c[l+4>>2]=c[aG+4>>2];c[l+8>>2]=c[aG+8>>2];c[aG>>2]=c[aN>>2];c[aG+4>>2]=c[aN+4>>2];c[aG+8>>2]=c[aN+8>>2];c[aN>>2]=c[l>>2];c[aN+4>>2]=c[l+4>>2];c[aN+8>>2]=c[l+8>>2];aD=aL;aE=A+12|0}}if((w|0)==21){gJ(d,q,d+24|0,d+36|0,t-12|0,0)|0;i=f;return}else if((w|0)==20){gI(d,q,d+24|0,t-12|0,0)|0;i=f;return}else if((w|0)==4){aE=t-12|0;aL=aE;aD=a[aL]|0;l=aD&255;if((l&1|0)==0){aR=l>>>1}else{aR=c[t-12+4>>2]|0}l=a[o]|0;aN=l&255;if((aN&1|0)==0){aS=aN>>>1}else{aS=c[s>>2]|0}if((aD&1)==0){aT=aE+1|0}else{aT=c[t-12+8>>2]|0}if((l&1)==0){aU=p}else{aU=c[r>>2]|0}r=LH(aT|0,aU|0,(aS>>>0<aR>>>0?aS:aR)|0)|0;do{if((r|0)==0){if(aR>>>0<aS>>>0){break}i=f;return}else{if((r|0)<0){break}i=f;return}}while(0);r=g;c[r>>2]=c[o>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[o>>2]=c[aL>>2];c[o+4>>2]=c[aL+4>>2];c[o+8>>2]=c[aL+8>>2];c[aL>>2]=c[r>>2];c[aL+4>>2]=c[r+4>>2];c[aL+8>>2]=c[r+8>>2];i=f;return}else if((w|0)==19){gH(d,q,t-12|0,0)|0;i=f;return}else if((w|0)==176){i=f;return}else if((w|0)==181){i=f;return}else if((w|0)==184){i=f;return}else if((w|0)==185){i=f;return}else if((w|0)==186){i=f;return}else if((w|0)==23){gK(d,t,0);i=f;return}}function gH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+80|0;g=f|0;h=f+16|0;j=f+32|0;k=f+48|0;l=f+64|0;m=d;n=d;o=a[n]|0;p=o&255;q=(p&1|0)==0;if(q){r=p>>>1}else{r=c[d+4>>2]|0}s=b;t=b;u=a[t]|0;v=u&255;if((v&1|0)==0){w=v>>>1}else{w=c[b+4>>2]|0}v=(o&1)==0;if(v){x=m+1|0}else{x=c[d+8>>2]|0}if((u&1)==0){y=s+1|0}else{y=c[b+8>>2]|0}u=LH(x|0,y|0,(w>>>0<r>>>0?w:r)|0)|0;if((u|0)==0){y=e;x=e;o=a[x]|0;z=o&255;A=(z&1|0)==0;if(r>>>0<w>>>0){B=y;C=x;D=z;E=A;F=o;G=47}else{H=y;I=x;J=z;K=A;L=o;G=16}}else{o=e;A=e;z=a[A]|0;x=z&255;y=(x&1|0)==0;if((u|0)<0){B=o;C=A;D=x;E=y;F=z;G=47}else{H=o;I=A;J=x;K=y;L=z;G=16}}if((G|0)==16){if(K){M=J>>>1}else{M=c[e+4>>2]|0}if(q){N=p>>>1}else{N=c[d+4>>2]|0}if((L&1)==0){O=H+1|0}else{O=c[e+8>>2]|0}if(v){P=m+1|0}else{P=c[d+8>>2]|0}H=LH(O|0,P|0,(N>>>0<M>>>0?N:M)|0)|0;do{if((H|0)==0){if(M>>>0<N>>>0){break}else{Q=0}i=f;return Q|0}else{if((H|0)<0){break}else{Q=0}i=f;return Q|0}}while(0);H=l;c[H>>2]=c[n>>2];c[H+4>>2]=c[n+4>>2];c[H+8>>2]=c[n+8>>2];c[n>>2]=c[I>>2];c[n+4>>2]=c[I+4>>2];c[n+8>>2]=c[I+8>>2];c[I>>2]=c[H>>2];c[I+4>>2]=c[H+4>>2];c[I+8>>2]=c[H+8>>2];H=a[n]|0;I=H&255;if((I&1|0)==0){R=I>>>1}else{R=c[d+4>>2]|0}I=a[t]|0;l=I&255;if((l&1|0)==0){S=l>>>1}else{S=c[b+4>>2]|0}if((H&1)==0){T=m+1|0}else{T=c[d+8>>2]|0}if((I&1)==0){U=s+1|0}else{U=c[b+8>>2]|0}b=LH(T|0,U|0,(S>>>0<R>>>0?S:R)|0)|0;do{if((b|0)==0){if(R>>>0<S>>>0){break}else{Q=1}i=f;return Q|0}else{if((b|0)<0){break}else{Q=1}i=f;return Q|0}}while(0);b=k;c[b>>2]=c[t>>2];c[b+4>>2]=c[t+4>>2];c[b+8>>2]=c[t+8>>2];c[t>>2]=c[n>>2];c[t+4>>2]=c[n+4>>2];c[t+8>>2]=c[n+8>>2];c[n>>2]=c[b>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];Q=2;i=f;return Q|0}else if((G|0)==47){if(E){V=D>>>1}else{V=c[e+4>>2]|0}if(q){W=p>>>1}else{W=c[d+4>>2]|0}if((F&1)==0){X=B+1|0}else{X=c[e+8>>2]|0}if(v){Y=m+1|0}else{Y=c[d+8>>2]|0}v=LH(X|0,Y|0,(W>>>0<V>>>0?W:V)|0)|0;if((v|0)==0){if(V>>>0<W>>>0){G=62}}else{if((v|0)<0){G=62}}if((G|0)==62){G=j;c[G>>2]=c[t>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];c[t>>2]=c[C>>2];c[t+4>>2]=c[C+4>>2];c[t+8>>2]=c[C+8>>2];c[C>>2]=c[G>>2];c[C+4>>2]=c[G+4>>2];c[C+8>>2]=c[G+8>>2];Q=1;i=f;return Q|0}G=h;c[G>>2]=c[t>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];c[t>>2]=c[n>>2];c[t+4>>2]=c[n+4>>2];c[t+8>>2]=c[n+8>>2];c[n>>2]=c[G>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];G=a[C]|0;t=G&255;if((t&1|0)==0){Z=t>>>1}else{Z=c[e+4>>2]|0}t=a[n]|0;h=t&255;if((h&1|0)==0){_=h>>>1}else{_=c[d+4>>2]|0}if((G&1)==0){$=B+1|0}else{$=c[e+8>>2]|0}if((t&1)==0){aa=m+1|0}else{aa=c[d+8>>2]|0}d=LH($|0,aa|0,(_>>>0<Z>>>0?_:Z)|0)|0;do{if((d|0)==0){if(Z>>>0<_>>>0){break}else{Q=1}i=f;return Q|0}else{if((d|0)<0){break}else{Q=1}i=f;return Q|0}}while(0);d=g;c[d>>2]=c[n>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];c[n>>2]=c[C>>2];c[n+4>>2]=c[C+4>>2];c[n+8>>2]=c[C+8>>2];c[C>>2]=c[d>>2];c[C+4>>2]=c[d+4>>2];c[C+8>>2]=c[d+8>>2];Q=2;i=f;return Q|0}return 0}function gI(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+48|0;h=g|0;j=g+16|0;k=g+32|0;l=gH(b,d,e,0)|0;m=f;n=a[m]|0;o=n&255;if((o&1|0)==0){p=o>>>1}else{p=c[f+4>>2]|0}o=e;q=e;r=a[q]|0;s=r&255;if((s&1|0)==0){t=s>>>1}else{t=c[e+4>>2]|0}if((n&1)==0){u=f+1|0}else{u=c[f+8>>2]|0}if((r&1)==0){v=o+1|0}else{v=c[e+8>>2]|0}r=LH(u|0,v|0,(t>>>0<p>>>0?t:p)|0)|0;do{if((r|0)==0){if(p>>>0<t>>>0){break}else{w=l}i=g;return w|0}else{if((r|0)<0){break}else{w=l}i=g;return w|0}}while(0);r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[q>>2]=c[m>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];r=l+1|0;m=a[q]|0;k=m&255;if((k&1|0)==0){x=k>>>1}else{x=c[e+4>>2]|0}k=d;t=d;p=a[t]|0;v=p&255;if((v&1|0)==0){y=v>>>1}else{y=c[d+4>>2]|0}if((m&1)==0){z=o+1|0}else{z=c[e+8>>2]|0}if((p&1)==0){A=k+1|0}else{A=c[d+8>>2]|0}p=LH(z|0,A|0,(y>>>0<x>>>0?y:x)|0)|0;do{if((p|0)==0){if(x>>>0<y>>>0){break}else{w=r}i=g;return w|0}else{if((p|0)<0){break}else{w=r}i=g;return w|0}}while(0);r=j;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[t>>2]=c[q>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];r=l+2|0;q=a[t]|0;j=q&255;if((j&1|0)==0){B=j>>>1}else{B=c[d+4>>2]|0}j=b;p=a[j]|0;y=p&255;if((y&1|0)==0){C=y>>>1}else{C=c[b+4>>2]|0}if((q&1)==0){D=k+1|0}else{D=c[d+8>>2]|0}if((p&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}b=LH(D|0,E|0,(C>>>0<B>>>0?C:B)|0)|0;do{if((b|0)==0){if(B>>>0<C>>>0){break}else{w=r}i=g;return w|0}else{if((b|0)<0){break}else{w=r}i=g;return w|0}}while(0);r=h;c[r>>2]=c[j>>2];c[r+4>>2]=c[j+4>>2];c[r+8>>2]=c[j+8>>2];c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];w=l+3|0;i=g;return w|0}function gJ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=i;i=i+64|0;j=h|0;k=h+16|0;l=h+32|0;m=h+48|0;n=gI(b,d,e,f,0)|0;o=g;p=a[o]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[g+4>>2]|0}q=f;s=f;t=a[s]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[f+4>>2]|0}if((p&1)==0){w=g+1|0}else{w=c[g+8>>2]|0}if((t&1)==0){x=q+1|0}else{x=c[f+8>>2]|0}t=LH(w|0,x|0,(v>>>0<r>>>0?v:r)|0)|0;do{if((t|0)==0){if(r>>>0<v>>>0){break}else{y=n}i=h;return y|0}else{if((t|0)<0){break}else{y=n}i=h;return y|0}}while(0);t=m;c[t>>2]=c[s>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];c[s>>2]=c[o>>2];c[s+4>>2]=c[o+4>>2];c[s+8>>2]=c[o+8>>2];c[o>>2]=c[t>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];t=n+1|0;o=a[s]|0;m=o&255;if((m&1|0)==0){z=m>>>1}else{z=c[f+4>>2]|0}m=e;v=e;r=a[v]|0;x=r&255;if((x&1|0)==0){A=x>>>1}else{A=c[e+4>>2]|0}if((o&1)==0){B=q+1|0}else{B=c[f+8>>2]|0}if((r&1)==0){C=m+1|0}else{C=c[e+8>>2]|0}r=LH(B|0,C|0,(A>>>0<z>>>0?A:z)|0)|0;do{if((r|0)==0){if(z>>>0<A>>>0){break}else{y=t}i=h;return y|0}else{if((r|0)<0){break}else{y=t}i=h;return y|0}}while(0);t=l;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];t=n+2|0;s=a[v]|0;l=s&255;if((l&1|0)==0){D=l>>>1}else{D=c[e+4>>2]|0}l=d;r=d;A=a[r]|0;z=A&255;if((z&1|0)==0){E=z>>>1}else{E=c[d+4>>2]|0}if((s&1)==0){F=m+1|0}else{F=c[e+8>>2]|0}if((A&1)==0){G=l+1|0}else{G=c[d+8>>2]|0}A=LH(F|0,G|0,(E>>>0<D>>>0?E:D)|0)|0;do{if((A|0)==0){if(D>>>0<E>>>0){break}else{y=t}i=h;return y|0}else{if((A|0)<0){break}else{y=t}i=h;return y|0}}while(0);t=k;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];c[r>>2]=c[v>>2];c[r+4>>2]=c[v+4>>2];c[r+8>>2]=c[v+8>>2];c[v>>2]=c[t>>2];c[v+4>>2]=c[t+4>>2];c[v+8>>2]=c[t+8>>2];t=n+3|0;v=a[r]|0;k=v&255;if((k&1|0)==0){H=k>>>1}else{H=c[d+4>>2]|0}k=b;A=a[k]|0;E=A&255;if((E&1|0)==0){I=E>>>1}else{I=c[b+4>>2]|0}if((v&1)==0){J=l+1|0}else{J=c[d+8>>2]|0}if((A&1)==0){K=b+1|0}else{K=c[b+8>>2]|0}b=LH(J|0,K|0,(I>>>0<H>>>0?I:H)|0)|0;do{if((b|0)==0){if(H>>>0<I>>>0){break}else{y=t}i=h;return y|0}else{if((b|0)<0){break}else{y=t}i=h;return y|0}}while(0);t=j;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];c[t+8>>2]=c[k+8>>2];c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];y=n+4|0;i=h;return y|0}
function pO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0;e=i;i=i+160|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=e+48|0;n=e+56|0;o=e+64|0;p=e+72|0;q=e+80|0;r=e+88|0;s=e+96|0;t=e+104|0;u=e+112|0;v=e+120|0;w=e+128|0;x=e+136|0;y=e+144|0;z=e+152|0;A=b|0;B=c[A>>2]|0;C=a|0;D=c[C>>2]|0;L1:do{if(B>>>0<D>>>0){E=d|0;F=c[E>>2]|0;if(F>>>0<B>>>0){G=E;H=D;I=F;J=21}else{K=B;L=F;M=E;J=19}}else{do{if(D>>>0<B>>>0){E=d|0;F=c[E>>2]|0;if(F>>>0>=B>>>0){N=B;O=F;P=E;J=8;break}Q=E;R=B;S=F;T=b+4|0;U=b+8|0}else{F=b+4|0;E=b+8|0;V=c[E>>2]|0;W=c[a+4>>2]|0;X=c[a+8>>2]|0;c[w>>2]=c[F>>2];c[x>>2]=V;c[y>>2]=W;c[z>>2]=X;X=pT(w,x,y,z,0)|0;W=d|0;V=c[W>>2]|0;Y=c[A>>2]|0;Z=V>>>0<Y>>>0;if(!X){if(Z){Q=W;R=Y;S=V;T=F;U=E;break}else{N=Y;O=V;P=W;J=8;break}}if(!Z){K=Y;L=V;M=W;J=19;break L1}G=W;H=c[C>>2]|0;I=V;J=21;break L1}}while(0);do{if((J|0)==8){if(N>>>0<O>>>0){_=0;i=e;return _|0}V=c[d+8>>2]|0;W=b+4|0;Y=c[W>>2]|0;Z=b+8|0;E=c[Z>>2]|0;c[s>>2]=c[d+4>>2];c[t>>2]=V;c[u>>2]=Y;c[v>>2]=E;if(pT(s,t,u,v,0)|0){Q=P;R=c[A>>2]|0;S=c[P>>2]|0;T=W;U=Z;break}else{_=0;i=e;return _|0}}}while(0);c[A>>2]=S;c[Q>>2]=R;Z=d+4|0;W=c[T>>2]|0;c[T>>2]=c[Z>>2];c[Z>>2]=W;W=d+8|0;Z=c[U>>2]|0;c[U>>2]=c[W>>2];c[W>>2]=Z;Z=b+12|0;W=d+12|0;E=c[Z>>2]|0;c[Z>>2]=c[W>>2];c[W>>2]=E;E=c[A>>2]|0;W=c[C>>2]|0;do{if(E>>>0<W>>>0){$=W;aa=E;ab=a+4|0;ac=a+8|0}else{if(W>>>0<E>>>0){_=1;i=e;return _|0}Y=c[U>>2]|0;V=a+4|0;F=c[V>>2]|0;X=a+8|0;ad=c[X>>2]|0;c[o>>2]=c[T>>2];c[p>>2]=Y;c[q>>2]=F;c[r>>2]=ad;if(pT(o,p,q,r,0)|0){$=c[C>>2]|0;aa=c[A>>2]|0;ab=V;ac=X;break}else{_=1;i=e;return _|0}}}while(0);c[C>>2]=aa;c[A>>2]=$;E=c[ab>>2]|0;c[ab>>2]=c[T>>2];c[T>>2]=E;E=c[ac>>2]|0;c[ac>>2]=c[U>>2];c[U>>2]=E;E=a+12|0;W=c[E>>2]|0;c[E>>2]=c[Z>>2];c[Z>>2]=W;_=2;i=e;return _|0}}while(0);L32:do{if((J|0)==19){do{if(K>>>0<L>>>0){ae=c[C>>2]|0;af=K;ag=b+4|0;ah=b+8|0}else{U=d+4|0;ac=d+8|0;T=c[ac>>2]|0;ab=b+4|0;$=c[ab>>2]|0;aa=b+8|0;r=c[aa>>2]|0;c[k>>2]=c[U>>2];c[l>>2]=T;c[m>>2]=$;c[n>>2]=r;r=pT(k,l,m,n,0)|0;$=c[C>>2]|0;if(r){ai=M;aj=$;ak=c[M>>2]|0;al=U;am=ac;break L32}else{ae=$;af=c[A>>2]|0;ag=ab;ah=aa;break}}}while(0);c[C>>2]=af;c[A>>2]=ae;Z=a+4|0;aa=c[Z>>2]|0;c[Z>>2]=c[ag>>2];c[ag>>2]=aa;aa=a+8|0;Z=c[aa>>2]|0;c[aa>>2]=c[ah>>2];c[ah>>2]=Z;Z=a+12|0;aa=b+12|0;ab=c[Z>>2]|0;c[Z>>2]=c[aa>>2];c[aa>>2]=ab;ab=c[M>>2]|0;Z=c[A>>2]|0;do{if(ab>>>0<Z>>>0){an=Z;ao=ab;ap=d+4|0;aq=d+8|0}else{if(Z>>>0<ab>>>0){_=1;i=e;return _|0}$=d+4|0;ac=d+8|0;U=c[ac>>2]|0;r=c[ag>>2]|0;T=c[ah>>2]|0;c[f>>2]=c[$>>2];c[g>>2]=U;c[h>>2]=r;c[j>>2]=T;if(pT(f,g,h,j,0)|0){an=c[A>>2]|0;ao=c[M>>2]|0;ap=$;aq=ac;break}else{_=1;i=e;return _|0}}}while(0);c[A>>2]=ao;c[M>>2]=an;ab=c[ag>>2]|0;c[ag>>2]=c[ap>>2];c[ap>>2]=ab;ab=c[ah>>2]|0;c[ah>>2]=c[aq>>2];c[aq>>2]=ab;ab=d+12|0;Z=c[aa>>2]|0;c[aa>>2]=c[ab>>2];c[ab>>2]=Z;_=2;i=e;return _|0}else if((J|0)==21){ai=G;aj=H;ak=I;al=d+4|0;am=d+8|0}}while(0);c[C>>2]=ak;c[ai>>2]=aj;aj=a+4|0;ai=c[aj>>2]|0;c[aj>>2]=c[al>>2];c[al>>2]=ai;ai=a+8|0;al=c[ai>>2]|0;c[ai>>2]=c[am>>2];c[am>>2]=al;al=a+12|0;a=d+12|0;d=c[al>>2]|0;c[al>>2]=c[a>>2];c[a>>2]=d;_=1;i=e;return _|0}function pP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;f=i;i=i+96|0;g=f|0;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=pO(a,b,d,0)|0;u=e|0;v=c[u>>2]|0;w=d|0;x=c[w>>2]|0;do{if(v>>>0<x>>>0){y=x;z=v;A=d+4|0;B=e+4|0;C=d+8|0;D=e+8|0}else{if(x>>>0<v>>>0){E=t;i=f;return E|0}F=e+4|0;G=e+8|0;H=c[G>>2]|0;I=d+4|0;J=c[I>>2]|0;K=d+8|0;L=c[K>>2]|0;c[p>>2]=c[F>>2];c[q>>2]=H;c[r>>2]=J;c[s>>2]=L;if(pT(p,q,r,s,0)|0){y=c[w>>2]|0;z=c[u>>2]|0;A=I;B=F;C=K;D=G;break}else{E=t;i=f;return E|0}}}while(0);c[w>>2]=z;c[u>>2]=y;y=c[A>>2]|0;c[A>>2]=c[B>>2];c[B>>2]=y;y=c[C>>2]|0;c[C>>2]=c[D>>2];c[D>>2]=y;y=d+12|0;d=e+12|0;e=c[y>>2]|0;c[y>>2]=c[d>>2];c[d>>2]=e;e=t+1|0;d=c[w>>2]|0;D=b|0;B=c[D>>2]|0;do{if(d>>>0<B>>>0){M=B;N=d;O=b+4|0;P=b+8|0}else{if(B>>>0<d>>>0){E=e;i=f;return E|0}u=c[C>>2]|0;z=b+4|0;s=c[z>>2]|0;r=b+8|0;q=c[r>>2]|0;c[l>>2]=c[A>>2];c[m>>2]=u;c[n>>2]=s;c[o>>2]=q;if(pT(l,m,n,o,0)|0){M=c[D>>2]|0;N=c[w>>2]|0;O=z;P=r;break}else{E=e;i=f;return E|0}}}while(0);c[D>>2]=N;c[w>>2]=M;M=c[O>>2]|0;c[O>>2]=c[A>>2];c[A>>2]=M;M=c[P>>2]|0;c[P>>2]=c[C>>2];c[C>>2]=M;M=b+12|0;b=c[M>>2]|0;c[M>>2]=c[y>>2];c[y>>2]=b;b=t+2|0;y=c[D>>2]|0;C=a|0;A=c[C>>2]|0;do{if(y>>>0<A>>>0){Q=A;R=y;S=a+4|0;T=a+8|0}else{if(A>>>0<y>>>0){E=b;i=f;return E|0}w=c[P>>2]|0;N=a+4|0;e=c[N>>2]|0;o=a+8|0;n=c[o>>2]|0;c[g>>2]=c[O>>2];c[h>>2]=w;c[j>>2]=e;c[k>>2]=n;if(pT(g,h,j,k,0)|0){Q=c[C>>2]|0;R=c[D>>2]|0;S=N;T=o;break}else{E=b;i=f;return E|0}}}while(0);c[C>>2]=R;c[D>>2]=Q;Q=c[S>>2]|0;c[S>>2]=c[O>>2];c[O>>2]=Q;Q=c[T>>2]|0;c[T>>2]=c[P>>2];c[P>>2]=Q;Q=a+12|0;a=c[Q>>2]|0;c[Q>>2]=c[M>>2];c[M>>2]=a;E=t+3|0;i=f;return E|0}function pQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;g=i;i=i+128|0;h=g|0;j=g+8|0;k=g+16|0;l=g+24|0;m=g+32|0;n=g+40|0;o=g+48|0;p=g+56|0;q=g+64|0;r=g+72|0;s=g+80|0;t=g+88|0;u=g+96|0;v=g+104|0;w=g+112|0;x=g+120|0;y=pP(a,b,d,e,0)|0;z=f|0;A=c[z>>2]|0;B=e|0;C=c[B>>2]|0;do{if(A>>>0<C>>>0){D=C;E=A;F=e+4|0;G=f+4|0;H=e+8|0;I=f+8|0}else{if(C>>>0<A>>>0){J=y;i=g;return J|0}K=f+4|0;L=f+8|0;M=c[L>>2]|0;N=e+4|0;O=c[N>>2]|0;P=e+8|0;Q=c[P>>2]|0;c[u>>2]=c[K>>2];c[v>>2]=M;c[w>>2]=O;c[x>>2]=Q;if(pT(u,v,w,x,0)|0){D=c[B>>2]|0;E=c[z>>2]|0;F=N;G=K;H=P;I=L;break}else{J=y;i=g;return J|0}}}while(0);c[B>>2]=E;c[z>>2]=D;D=c[F>>2]|0;c[F>>2]=c[G>>2];c[G>>2]=D;D=c[H>>2]|0;c[H>>2]=c[I>>2];c[I>>2]=D;D=e+12|0;e=f+12|0;f=c[D>>2]|0;c[D>>2]=c[e>>2];c[e>>2]=f;f=y+1|0;e=c[B>>2]|0;I=d|0;G=c[I>>2]|0;do{if(e>>>0<G>>>0){R=G;S=e;T=d+4|0;U=d+8|0}else{if(G>>>0<e>>>0){J=f;i=g;return J|0}z=c[H>>2]|0;E=d+4|0;x=c[E>>2]|0;w=d+8|0;v=c[w>>2]|0;c[q>>2]=c[F>>2];c[r>>2]=z;c[s>>2]=x;c[t>>2]=v;if(pT(q,r,s,t,0)|0){R=c[I>>2]|0;S=c[B>>2]|0;T=E;U=w;break}else{J=f;i=g;return J|0}}}while(0);c[I>>2]=S;c[B>>2]=R;R=c[T>>2]|0;c[T>>2]=c[F>>2];c[F>>2]=R;R=c[U>>2]|0;c[U>>2]=c[H>>2];c[H>>2]=R;R=d+12|0;d=c[R>>2]|0;c[R>>2]=c[D>>2];c[D>>2]=d;d=y+2|0;D=c[I>>2]|0;H=b|0;F=c[H>>2]|0;do{if(D>>>0<F>>>0){V=F;W=D;X=b+4|0;Y=b+8|0}else{if(F>>>0<D>>>0){J=d;i=g;return J|0}B=c[U>>2]|0;S=b+4|0;f=c[S>>2]|0;t=b+8|0;s=c[t>>2]|0;c[m>>2]=c[T>>2];c[n>>2]=B;c[o>>2]=f;c[p>>2]=s;if(pT(m,n,o,p,0)|0){V=c[H>>2]|0;W=c[I>>2]|0;X=S;Y=t;break}else{J=d;i=g;return J|0}}}while(0);c[H>>2]=W;c[I>>2]=V;V=c[X>>2]|0;c[X>>2]=c[T>>2];c[T>>2]=V;V=c[Y>>2]|0;c[Y>>2]=c[U>>2];c[U>>2]=V;V=b+12|0;b=c[V>>2]|0;c[V>>2]=c[R>>2];c[R>>2]=b;b=y+3|0;R=c[H>>2]|0;U=a|0;T=c[U>>2]|0;do{if(R>>>0<T>>>0){Z=T;_=R;$=a+4|0;aa=a+8|0}else{if(T>>>0<R>>>0){J=b;i=g;return J|0}I=c[Y>>2]|0;W=a+4|0;d=c[W>>2]|0;p=a+8|0;o=c[p>>2]|0;c[h>>2]=c[X>>2];c[j>>2]=I;c[k>>2]=d;c[l>>2]=o;if(pT(h,j,k,l,0)|0){Z=c[U>>2]|0;_=c[H>>2]|0;$=W;aa=p;break}else{J=b;i=g;return J|0}}}while(0);c[U>>2]=_;c[H>>2]=Z;Z=c[$>>2]|0;c[$>>2]=c[X>>2];c[X>>2]=Z;Z=c[aa>>2]|0;c[aa>>2]=c[Y>>2];c[Y>>2]=Z;Z=a+12|0;a=c[Z>>2]|0;c[Z>>2]=c[V>>2];c[V>>2]=a;J=y+4|0;i=g;return J|0}function pR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+80|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=e+48|0;n=e+56|0;o=e+64|0;p=b+32|0;pO(b,b+16|0,p,0)|0;q=b+48|0;if((q|0)==(d|0)){i=e;return}r=o|0;s=o+4|0;t=s|0;u=o+8|0;v=f|0;w=g|0;x=h|0;y=j|0;A=o+4|0;B=k|0;C=l|0;D=m|0;E=n|0;F=q;q=p;L4:while(1){p=F|0;G=c[p>>2]|0;H=c[q>>2]|0;do{if(G>>>0<H>>>0){I=G;J=7}else{if(H>>>0<G>>>0){break}K=c[F+8>>2]|0;L=c[q+4>>2]|0;N=c[q+8>>2]|0;c[B>>2]=c[F+4>>2];c[C>>2]=K;c[D>>2]=L;c[E>>2]=N;if(!(pT(k,l,m,n,0)|0)){break}I=c[p>>2]|0;J=7}}while(0);do{if((J|0)==7){J=0;c[r>>2]=I;gM(s,F+4|0);p=F;G=q;while(1){O=G|0;c[p>>2]=c[O>>2];P=G+4|0;z=0;aR(152,p+4|0,c[P>>2]|0,c[G+8>>2]|0);if(z){z=0;J=23;break L4}if((G|0)==(b|0)){J=10;break}H=G-16|0;N=c[r>>2]|0;L=c[H>>2]|0;if(N>>>0<L>>>0){p=G;G=H;continue}if(L>>>0<N>>>0){J=14;break}N=c[u>>2]|0;L=c[G-16+4>>2]|0;K=c[G-16+8>>2]|0;c[v>>2]=c[t>>2];c[w>>2]=N;c[x>>2]=L;c[y>>2]=K;if(pT(f,g,h,j,0)|0){p=G;G=H}else{J=14;break}}if((J|0)==10){J=0;c[O>>2]=c[r>>2];J=15}else if((J|0)==14){J=0;c[O>>2]=c[r>>2];if((G|0)!=(o|0)){J=15}}if((J|0)==15){J=0;z=0;aR(152,P|0,c[t>>2]|0,c[u>>2]|0);if(z){z=0;J=24;break L4}}p=c[A>>2]|0;if((p|0)==0){break}H=c[u>>2]|0;if((p|0)==(H|0)){Q=p}else{K=H;while(1){H=K-12|0;c[u>>2]=H;if((a[H]&1)==0){R=H}else{Lw(c[K-12+8>>2]|0);R=c[u>>2]|0}if((p|0)==(R|0)){break}else{K=R}}Q=c[A>>2]|0}Lw(Q)}}while(0);K=F+16|0;if((K|0)==(d|0)){J=36;break}else{q=F;F=K}}if((J|0)==36){i=e;return}else if((J|0)==24){e=bT(-1,-1)|0;S=M;T=e}else if((J|0)==23){J=bT(-1,-1)|0;S=M;T=J}J=c[A>>2]|0;if((J|0)==0){bg(T|0)}S=c[u>>2]|0;if((J|0)==(S|0)){U=J}else{e=S;while(1){S=e-12|0;c[u>>2]=S;if((a[S]&1)==0){V=S}else{Lw(c[e-12+8>>2]|0);V=c[u>>2]|0}if((J|0)==(V|0)){break}else{e=V}}U=c[A>>2]|0}Lw(U);bg(T|0)}function pS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+112|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=e+48|0;n=e+56|0;o=e+64|0;p=e+72|0;q=e+80|0;r=e+88|0;s=e+96|0;switch(d-b>>4|0){case 4:{pP(b,b+16|0,b+32|0,d-16|0,0)|0;t=1;i=e;return t|0};case 0:case 1:{t=1;i=e;return t|0};case 2:{u=d-16|0;v=c[u>>2]|0;w=b|0;x=c[w>>2]|0;do{if(v>>>0<x>>>0){y=x;A=v;B=b+4|0;C=d-16+4|0;D=b+8|0;E=d-16+8|0}else{if(x>>>0<v>>>0){t=1;i=e;return t|0}F=d-16+4|0;G=d-16+8|0;H=c[G>>2]|0;I=b+4|0;J=c[I>>2]|0;K=b+8|0;L=c[K>>2]|0;c[o>>2]=c[F>>2];c[p>>2]=H;c[q>>2]=J;c[r>>2]=L;if(pT(o,p,q,r,0)|0){y=c[w>>2]|0;A=c[u>>2]|0;B=I;C=F;D=K;E=G;break}else{t=1;i=e;return t|0}}}while(0);c[w>>2]=A;c[u>>2]=y;y=c[B>>2]|0;c[B>>2]=c[C>>2];c[C>>2]=y;y=c[D>>2]|0;c[D>>2]=c[E>>2];c[E>>2]=y;y=b+12|0;E=d-16+12|0;D=c[y>>2]|0;c[y>>2]=c[E>>2];c[E>>2]=D;t=1;i=e;return t|0};case 5:{pQ(b,b+16|0,b+32|0,b+48|0,d-16|0,0)|0;t=1;i=e;return t|0};case 3:{pO(b,b+16|0,d-16|0,0)|0;t=1;i=e;return t|0};default:{D=b+32|0;pO(b,b+16|0,D,0)|0;E=b+48|0;if((E|0)==(d|0)){t=1;i=e;return t|0}y=s|0;C=s+4|0;B=C|0;u=s+8|0;A=f|0;w=g|0;r=h|0;q=j|0;p=s+4|0;o=k|0;v=l|0;x=m|0;G=n|0;K=D;D=0;F=E;E=0;L8:while(1){I=F|0;L=c[I>>2]|0;J=c[K>>2]|0;do{if(L>>>0<J>>>0){N=L;O=17}else{if(J>>>0<L>>>0){P=E;Q=F;R=D;break}H=c[F+8>>2]|0;S=c[K+4>>2]|0;T=c[K+8>>2]|0;c[o>>2]=c[F+4>>2];c[v>>2]=H;c[x>>2]=S;c[G>>2]=T;if(!(pT(k,l,m,n,0)|0)){P=E;Q=F;R=D;break}N=c[I>>2]|0;O=17}}while(0);if((O|0)==17){O=0;c[y>>2]=N;gM(C,F+4|0);I=K;L=F;while(1){U=I|0;c[L>>2]=c[U>>2];V=I+4|0;if((L|0)!=(I|0)){z=0;aR(152,L+4|0,c[V>>2]|0,c[I+8>>2]|0);if(z){z=0;O=29;break L8}}if((I|0)==(b|0)){O=21;break}J=I-16|0;T=c[y>>2]|0;S=c[J>>2]|0;if(T>>>0<S>>>0){L=I;I=J;continue}if(S>>>0<T>>>0){O=25;break}T=c[u>>2]|0;S=c[I-16+4>>2]|0;H=c[I-16+8>>2]|0;c[A>>2]=c[B>>2];c[w>>2]=T;c[r>>2]=S;c[q>>2]=H;if(pT(f,g,h,j,0)|0){L=I;I=J}else{O=25;break}}if((O|0)==25){O=0;c[U>>2]=c[y>>2];if((I|0)!=(s|0)){O=26}}else if((O|0)==21){O=0;c[U>>2]=c[y>>2];O=26}if((O|0)==26){O=0;z=0;aR(152,V|0,c[B>>2]|0,c[u>>2]|0);if(z){z=0;O=30;break}}L=D+1|0;if((L|0)==8){J=F+16|0;W=1;X=(J|0)==(d|0);Y=J}else{W=0;X=E;Y=F}J=c[p>>2]|0;if((J|0)!=0){H=c[u>>2]|0;if((J|0)==(H|0)){Z=J}else{S=H;while(1){H=S-12|0;c[u>>2]=H;if((a[H]&1)==0){_=H}else{Lw(c[S-12+8>>2]|0);_=c[u>>2]|0}if((J|0)==(_|0)){break}else{S=_}}Z=c[p>>2]|0}Lw(Z)}if(W){t=X;O=58;break}else{P=X;Q=Y;R=L}}S=Q+16|0;if((S|0)==(d|0)){t=1;O=59;break}else{K=Q;D=R;F=S;E=P}}if((O|0)==58){i=e;return t|0}else if((O|0)==59){i=e;return t|0}else if((O|0)==29){t=bT(-1,-1)|0;$=M;aa=t}else if((O|0)==30){O=bT(-1,-1)|0;$=M;aa=O}O=c[p>>2]|0;if((O|0)==0){bg(aa|0)}$=c[u>>2]|0;if((O|0)==($|0)){ab=O}else{t=$;while(1){$=t-12|0;c[u>>2]=$;if((a[$]&1)==0){ac=$}else{Lw(c[t-12+8>>2]|0);ac=c[u>>2]|0}if((O|0)==(ac|0)){break}else{t=ac}}ab=c[p>>2]|0}Lw(ab);bg(aa|0)}}return 0}function pT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=b;b=i;i=i+4|0;i=i+7&-8;c[b>>2]=c[h>>2];h=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[h>>2];h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[h>>2];h=b|0;b=e|0;e=c[b>>2]|0;j=c[f>>2]|0;if((e|0)==(j|0)){k=0;i=g;return k|0}f=c[d>>2]|0;d=e;e=c[h>>2]|0;while(1){if((e|0)==(f|0)){k=1;l=39;break}m=e;n=a[e]|0;o=n&255;p=(o&1|0)==0;if(p){q=o>>>1}else{q=c[e+4>>2]|0}r=d;s=a[d]|0;t=s&255;u=(t&1|0)==0;if(u){v=t>>>1}else{v=c[d+4>>2]|0}w=(n&1)==0;if(w){x=m+1|0}else{x=c[e+8>>2]|0}n=(s&1)==0;if(n){y=r+1|0}else{y=c[d+8>>2]|0}s=LH(x|0,y|0,(v>>>0<q>>>0?v:q)|0)|0;if((s|0)==0){if(q>>>0<v>>>0){k=1;l=42;break}}else{if((s|0)<0){k=1;l=40;break}}if(u){z=t>>>1}else{z=c[d+4>>2]|0}if(p){A=o>>>1}else{A=c[e+4>>2]|0}if(n){B=r+1|0}else{B=c[d+8>>2]|0}if(w){C=m+1|0}else{C=c[e+8>>2]|0}m=LH(B|0,C|0,(A>>>0<z>>>0?A:z)|0)|0;if((m|0)==0){if(z>>>0<A>>>0){k=0;l=37;break}}else{if((m|0)<0){k=0;l=36;break}}m=e+12|0;c[h>>2]=m;w=d+12|0;c[b>>2]=w;if((w|0)==(j|0)){k=0;l=38;break}else{d=w;e=m}}if((l|0)==42){i=g;return k|0}else if((l|0)==39){i=g;return k|0}else if((l|0)==40){i=g;return k|0}else if((l|0)==37){i=g;return k|0}else if((l|0)==38){i=g;return k|0}else if((l|0)==36){i=g;return k|0}return 0}function pU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=b|0;e=c[d>>2]|0;if((e|0)==0){return}f=b+4|0;b=c[f>>2]|0;if((e|0)==(b|0)){g=e}else{h=b;do{b=h-28|0;c[f>>2]=b;fc(h-28+12|0,c[h-28+16>>2]|0);i=b|0;b=c[i>>2]|0;if((b|0)!=0){j=h-28+4|0;k=c[j>>2]|0;if((b|0)==(k|0)){l=b}else{m=k;while(1){k=m-12|0;c[j>>2]=k;if((a[k]&1)==0){n=k}else{Lw(c[m-12+8>>2]|0);n=c[j>>2]|0}if((b|0)==(n|0)){break}else{m=n}}l=c[i>>2]|0}Lw(l)}h=c[f>>2]|0;}while((e|0)!=(h|0));g=c[d>>2]|0}Lw(g);return}function pV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=b+4|0;f=c[e>>2]|0;g=b|0;h=c[g>>2]|0;i=h;j=f-i>>4;k=j+1|0;if(k>>>0>268435455>>>0){IU(0)}l=b+8|0;b=(c[l>>2]|0)-i|0;if(b>>4>>>0>134217726>>>0){m=268435455;n=5}else{i=b>>3;b=i>>>0<k>>>0?k:i;if((b|0)==0){o=0;p=0}else{m=b;n=5}}if((n|0)==5){o=Lu(m<<4)|0;p=m}m=o+(j<<4)|0;b=o+(p<<4)|0;do{if((m|0)==0){q=h;r=f;n=10}else{c[m>>2]=c[d>>2];z=0;as(294,o+(j<<4)+4|0,d+4|0);if(!z){q=c[g>>2]|0;r=c[e>>2]|0;n=10;break}else{z=0;p=bT(-1,-1)|0;s=M;t=p;break}}}while(0);L14:do{if((n|0)==10){d=o+(k<<4)|0;L16:do{if((r|0)==(q|0)){c[g>>2]=m;c[e>>2]=d;c[l>>2]=b;u=r}else{j=r;f=m;while(1){v=f-16|0;h=j-16|0;if((v|0)!=0){c[v>>2]=c[h>>2];z=0;as(294,f-16+4|0,j-16+4|0);if(z){z=0;break}}if((h|0)==(q|0)){n=15;break}else{j=h;f=v}}if((n|0)==15){j=c[g>>2]|0;h=c[e>>2]|0;c[g>>2]=v;c[e>>2]=d;c[l>>2]=b;if((j|0)==(h|0)){u=j;break}else{w=h}while(1){h=w-16|0;p=w-16+4|0;i=c[p>>2]|0;if((i|0)!=0){x=w-16+8|0;y=c[x>>2]|0;if((i|0)==(y|0)){A=i}else{B=y;while(1){y=B-12|0;c[x>>2]=y;if((a[y]&1)==0){C=y}else{Lw(c[B-12+8>>2]|0);C=c[x>>2]|0}if((i|0)==(C|0)){break}else{B=C}}A=c[p>>2]|0}Lw(A)}if((j|0)==(h|0)){u=j;break L16}else{w=h}}}j=bT(-1,-1)|0;B=M;if((f|0)!=(d|0)){i=d;while(1){x=i-16|0;y=i-16+4|0;D=c[y>>2]|0;if((D|0)!=0){E=i-16+8|0;F=c[E>>2]|0;if((D|0)==(F|0)){G=D}else{H=F;while(1){F=H-12|0;c[E>>2]=F;if((a[F]&1)==0){I=F}else{Lw(c[H-12+8>>2]|0);I=c[E>>2]|0}if((D|0)==(I|0)){break}else{H=I}}G=c[y>>2]|0}Lw(G)}if((f|0)==(x|0)){break}else{i=x}}}if((o|0)==0){J=B;K=j}else{s=B;t=j;break L14}bg(K|0)}}while(0);if((u|0)==0){return}Lw(u);return}}while(0);Lw(o);J=s;K=t;bg(K|0)}function pW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;h=b;b=i;i=i+4|0;i=i+7&-8;c[b>>2]=c[h>>2];h=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[h>>2];h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[h>>2];h=b|0;b=e|0;e=c[b>>2]|0;j=c[f>>2]|0;if((e|0)==(j|0)){k=1;i=g;return k|0}f=c[d>>2]|0;d=e;e=c[h>>2]|0;while(1){if((e|0)==(f|0)){k=0;l=44;break}m=d+16|0;n=m;o=a[m]|0;m=o&255;p=(m&1|0)==0;if(p){q=m>>>1}else{q=c[d+20>>2]|0}r=e;s=a[e]|0;t=s&255;u=(t&1|0)==0;if(u){v=t>>>1}else{v=c[e+4>>2]|0}w=(o&1)==0;if(w){x=n+1|0}else{x=c[d+24>>2]|0}o=(s&1)==0;if(o){y=r+1|0}else{y=c[e+8>>2]|0}s=LH(x|0,y|0,(v>>>0<q>>>0?v:q)|0)|0;if((s|0)==0){if(q>>>0<v>>>0){k=0;l=43;break}}else{if((s|0)<0){k=0;l=45;break}}if(u){z=t>>>1}else{z=c[e+4>>2]|0}if(p){A=m>>>1}else{A=c[d+20>>2]|0}if(o){B=r+1|0}else{B=c[e+8>>2]|0}if(w){C=n+1|0}else{C=c[d+24>>2]|0}n=LH(B|0,C|0,(A>>>0<z>>>0?A:z)|0)|0;if((n|0)==0){if(z>>>0<A>>>0){D=d}else{l=34}}else{if((n|0)<0){D=d}else{l=34}}if((l|0)==34){l=0;n=c[d+4>>2]|0;if((n|0)==0){w=d|0;while(1){r=c[w+8>>2]|0;if((w|0)==(c[r>>2]|0)){E=r;break}else{w=r}}}else{w=n;while(1){r=c[w>>2]|0;if((r|0)==0){E=w;break}else{w=r}}}w=E;c[b>>2]=w;D=w}w=e+12|0;c[h>>2]=w;if((D|0)==(j|0)){k=1;l=41;break}else{d=D;e=w}}if((l|0)==41){i=g;return k|0}else if((l|0)==45){i=g;return k|0}else if((l|0)==43){i=g;return k|0}else if((l|0)==44){i=g;return k|0}return 0}function pX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=LH(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==16){t=0;u=d|0}else if((t|0)==17){t=0;if(o){v=e>>>1}else{v=c[d+20>>2]|0}if(h){w=i}else{w=c[k>>2]|0}if(r){x=m+1|0}else{x=c[d+24>>2]|0}if(g){y=b}else{y=c[j>>2]|0}m=LH(x|0,y|0,(w>>>0<v>>>0?w:v)|0)|0;if((m|0)==0){if(v>>>0>=w>>>0){f=1;t=34;break}}else{if((m|0)>=0){f=1;t=36;break}}u=d+4|0}m=c[u>>2]|0;if((m|0)==0){f=0;t=35;break}else{d=m}}if((t|0)==36){return f|0}else if((t|0)==35){return f|0}else if((t|0)==34){return f|0}return 0}function pY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=d|0;e=d;L1:while(1){f=a;while(1){g=c[f>>2]|0;h=g;if((g|0)==0){i=0;j=25;break L1}d=g+16|0;if(dk(b,d)|0){break}f=g+4|0;if(!(dk(d,b)|0)){break L1}}a=g|0;e=h}if((j|0)==25){return i|0}j=c[g>>2]|0;L11:do{if((j|0)==0){k=h}else{g=j;a=h;while(1){d=g;while(1){l=d;if(!(dk(d+16|0,b)|0)){break}m=c[d+4>>2]|0;if((m|0)==0){k=a;break L11}else{d=m}}m=c[d>>2]|0;if((m|0)==0){k=l;break}else{g=m;a=l}}}}while(0);l=c[f>>2]|0;L19:do{if((l|0)==0){n=e}else{f=l;h=e;while(1){j=f;while(1){o=j;if(dk(b,j+16|0)|0){break}a=c[j+4>>2]|0;if((a|0)==0){n=h;break L19}else{j=a}}d=c[j>>2]|0;if((d|0)==0){n=o;break}else{f=d;h=o}}}}while(0);if((k|0)==(n|0)){i=0;return i|0}else{p=k;q=0}while(1){k=q+1|0;o=c[p+4>>2]|0;if((o|0)==0){b=p|0;while(1){e=c[b+8>>2]|0;if((b|0)==(c[e>>2]|0)){r=e;break}else{b=e}}}else{b=o;while(1){e=c[b>>2]|0;if((e|0)==0){r=b;break}else{b=e}}}b=r;if((b|0)==(n|0)){i=k;break}else{p=b;q=k}}return i|0}function pZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=d;f=d;g=a[f]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}h=g&1;L5:do{if((i|0)!=0){if(h<<24>>24==0){j=e+1|0}else{j=c[d+8>>2]|0}g=j+i|0;do{if((g|0)==(j|0)){break L5}g=g-1|0;}while((a[g]|0)!=47);k=g-j|0;if((k|0)==-1){break}Ea(b,d,k+1|0,-1,0);return}}while(0);if(h<<24>>24==0){h=b;c[h>>2]=c[f>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];return}f=c[d+8>>2]|0;h=c[d+4>>2]|0;if(h>>>0>4294967279>>>0){D5(0)}if(h>>>0<11>>>0){a[b]=h<<1;l=b+1|0}else{d=h+16&-16;j=Lu(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=h;l=j}LF(l|0,f|0,h)|0;a[l+h|0]=0;return}function p_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=d;f=a[d]|0;g=f&255;if((g&1|0)==0){h=g>>>1}else{h=c[d+4>>2]|0}L5:do{if((h|0)!=0){if((f&1)==0){i=e+1|0}else{i=c[d+8>>2]|0}g=i+h|0;do{if((g|0)==(i|0)){break L5}g=g-1|0;}while((a[g]|0)!=47);j=g-i|0;if((j|0)==-1){break}Ea(b,d,0,j+1|0,0);return}}while(0);a[b]=0;a[b+1|0]=0;return}function p$(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;g=i;i=i+64|0;h=g|0;j=g+16|0;k=g+32|0;l=g+48|0;m=e;n=e;o=a[n]|0;p=o&255;q=(p&1|0)==0;if(q){r=p>>>1}else{r=c[e+4>>2]|0}s=f;t=a[s]|0;if((r|0)==0){if((t&1)==0){r=b;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];i=g;return}r=c[f+8>>2]|0;u=c[f+4>>2]|0;if(u>>>0>4294967279>>>0){D5(0)}if(u>>>0<11>>>0){a[b]=u<<1;v=b+1|0}else{w=u+16&-16;x=Lu(w)|0;c[b+8>>2]=x;c[b>>2]=w|1;c[b+4>>2]=u;v=x}LF(v|0,r|0,u)|0;a[v+u|0]=0;i=g;return}u=t&255;if((u&1|0)==0){y=u>>>1}else{y=c[f+4>>2]|0}if((y|0)==0){if((o&1)==0){y=b;c[y>>2]=c[n>>2];c[y+4>>2]=c[n+4>>2];c[y+8>>2]=c[n+8>>2];i=g;return}y=c[e+8>>2]|0;u=c[e+4>>2]|0;if(u>>>0>4294967279>>>0){D5(0)}if(u>>>0<11>>>0){a[b]=u<<1;A=b+1|0}else{v=u+16&-16;r=Lu(v)|0;c[b+8>>2]=r;c[b>>2]=v|1;c[b+4>>2]=u;A=r}LF(A|0,y|0,u)|0;a[A+u|0]=0;i=g;return}u=(t&1)==0;if(u){B=f+1|0}else{B=c[f+8>>2]|0}if((a[B]|0)==47){if(u){u=b;c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];i=g;return}u=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){D5(0)}if(B>>>0<11>>>0){a[b]=B<<1;C=b+1|0}else{t=B+16&-16;A=Lu(t)|0;c[b+8>>2]=A;c[b>>2]=t|1;c[b+4>>2]=B;C=A}LF(C|0,u|0,B)|0;a[C+B|0]=0;i=g;return}if(q){D=p>>>1}else{D=c[e+4>>2]|0}q=(o&1)==0;if(q){E=m+1|0}else{E=c[e+8>>2]|0}if((a[E+(D-1)|0]|0)!=47){if(q){F=p>>>1;G=10}else{F=c[e+4>>2]|0;G=(c[e>>2]&-2)-1|0}if((F|0)==(G|0)){Ek(e,G,1,G,G,0,0);H=a[n]|0}else{H=o}if((H&1)==0){a[n]=(F<<1)+2;I=m+1|0;J=F+1|0}else{H=c[e+8>>2]|0;o=F+1|0;c[e+4>>2]=o;I=H;J=o}a[I+F|0]=47;a[I+J|0]=0}J=h;I=h+1|0;F=k;o=l;H=l+8|0;G=m+1|0;m=e+8|0;p=e+4|0;q=k+8|0;D=h+8|0;E=j;B=j+1|0;C=j+8|0;u=j+4|0;A=h+4|0;t=f+4|0;L80:while(1){y=d[s]|0;if((y&1|0)==0){K=y>>>1}else{K=c[t>>2]|0}if(K>>>0<=3>>>0){L=90;break}Ea(h,f,0,3,0);y=a[J]|0;r=y&255;v=(r&1|0)==0?r>>>1:c[A>>2]|0;N=(y&1)==0;y=v>>>0>3>>>0;if((LH((N?I:c[D>>2]|0)|0,11424,(y?3:v)|0)|0)==0){if(v>>>0>2>>>0&(y^1)){O=1}else{L=60}}else{L=60}do{if((L|0)==60){L=0;z=0;aq(30,j|0,f|0,0,3,0);if(z){z=0;L=84;break L80}y=a[E]|0;v=y&255;r=(v&1|0)==0?v>>>1:c[u>>2]|0;v=(y&1)==0;y=r>>>0>3>>>0;x=LH((v?B:c[C>>2]|0)|0,9160,(y?3:r)|0)|0;if((x|0)==0){P=r>>>0<3>>>0?-1:y&1}else{P=x}x=(P|0)==0;if(v){O=x;break}Lw(c[C>>2]|0);O=x}}while(0);if(N){if(!O){L=90;break}}else{Lw(c[D>>2]|0);if(!O){L=90;break}}Ea(k,f,3,-1,0);z=0,aM(344,f|0,k|0)|0;if(z){z=0;L=86;break}if((a[F]&1)!=0){Lw(c[q>>2]|0)}x=a[n]|0;v=x&255;if((v&1|0)==0){y=v>>>1;Q=v>>>1;R=y;S=y}else{y=c[p>>2]|0;Q=y;R=y;S=y}L109:do{if((Q|0)==0){T=-1}else{if((x&1)==0){U=G}else{U=c[m>>2]|0}y=U+(Q>>>0>(S-2|0)>>>0?R-1|0:Q)|0;do{if((y|0)==(U|0)){T=-1;break L109}y=y-1|0;}while((a[y]|0)!=47);T=y-U|0}}while(0);Ea(l,e,0,(T|0)==-1?-1:T+1|0,0);z=0,aM(344,e|0,l|0)|0;if(z){z=0;L=88;break}if((a[o]&1)==0){continue}Lw(c[H>>2]|0)}if((L|0)==88){l=bT(-1,-1)|0;T=l;l=M;if((a[o]&1)==0){V=l;W=T;X=W;Y=0;Z=X;_=V;bg(Z|0)}Lw(c[H>>2]|0);V=l;W=T;X=W;Y=0;Z=X;_=V;bg(Z|0)}else if((L|0)==90){g0(b,e,f);i=g;return}else if((L|0)==84){g=bT(-1,-1)|0;f=g;g=M;if(N){V=g;W=f;X=W;Y=0;Z=X;_=V;bg(Z|0)}Lw(c[D>>2]|0);V=g;W=f;X=W;Y=0;Z=X;_=V;bg(Z|0)}else if((L|0)==86){L=bT(-1,-1)|0;f=L;L=M;if((a[F]&1)==0){V=L;W=f;X=W;Y=0;Z=X;_=V;bg(Z|0)}Lw(c[q>>2]|0);V=L;W=f;X=W;Y=0;Z=X;_=V;bg(Z|0)}}function p0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+32|0;g=f|0;h=f+16|0;j=d;k=(a[j]&1)==0;if(k){l=d+1|0}else{l=c[d+8>>2]|0}if((a[l]|0)==47){if(k){l=b;c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];i=f;return}l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[b]=m<<1;n=b+1|0}else{o=m+16&-16;p=Lu(o)|0;c[b+8>>2]=p;c[b>>2]=o|1;c[b+4>>2]=m;n=p}LF(n|0,l|0,m)|0;a[n+m|0]=0;i=f;return}m=e;if((a[m]&1)==0){n=g;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[e+8>>2]|0;n=c[e+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[g]=n<<1;q=g+1|0}else{e=n+16&-16;l=Lu(e)|0;c[g+8>>2]=l;c[g>>2]=e|1;c[g+4>>2]=n;q=l}LF(q|0,m|0,n)|0;a[q+n|0]=0}L31:do{if(k){n=h;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];r=31}else{n=c[d+8>>2]|0;q=c[d+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(q>>>0<11>>>0){a[h]=q<<1;s=h+1|0}else{m=q+16&-16;l=(z=0,au(248,m|0)|0);if(z){z=0;break}c[h+8>>2]=l;c[h>>2]=m|1;c[h+4>>2]=q;s=l}LF(s|0,n|0,q)|0;a[s+q|0]=0;r=31;break L31}}while(0);q=bT(-1,-1)|0;t=M;u=q}}while(0);do{if((r|0)==31){z=0;aR(24,b|0,g|0,h|0);if(z){z=0;s=bT(-1,-1)|0;d=s;s=M;if((a[h]&1)==0){t=s;u=d;break}Lw(c[h+8>>2]|0);t=s;u=d;break}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}if((a[g]&1)==0){i=f;return}Lw(c[g+8>>2]|0);i=f;return}}while(0);if((a[g]&1)==0){v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[g+8>>2]|0);v=u;w=0;x=v;y=t;bg(x|0)}function p1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0;g=i;i=i+64|0;h=g|0;j=g+16|0;k=g+32|0;l=g+48|0;p0(h,d,f);z=0;aR(344,j|0,e|0,f|0);do{if(!z){f=k;a[f]=0;e=k+1|0;a[e]=0;d=l;a[d]=0;m=l+1|0;a[m]=0;n=h;o=h;p=a[o]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[h+4>>2]|0}q=j;s=j;t=a[s]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[j+4>>2]|0}u=v>>>0<r>>>0?v:r;L11:do{if((u|0)==0){w=0;x=n+1|0;y=h+8|0}else{A=n+1|0;B=(t&1)==0;C=q+1|0;D=h+8|0;E=c[D>>2]|0;F=c[j+8>>2]|0;if((p&1)==0){G=0;H=0;while(1){if((a[n+1+H|0]|0)!=(a[(B?C:F)+H|0]|0)){w=G;x=A;y=D;break L11}I=H+1|0;J=(a[n+1+H|0]|0)==47?I:G;if(I>>>0<u>>>0){G=J;H=I}else{w=J;x=A;y=D;break}}}else{H=0;G=0;while(1){if((a[E+G|0]|0)!=(a[(B?C:F)+G|0]|0)){w=H;x=A;y=D;break L11}J=G+1|0;I=(a[E+G|0]|0)==47?J:H;if(J>>>0<u>>>0){H=I;G=J}else{w=I;x=A;y=D;break}}}}}while(0);u=k+8|0;n=k|0;t=k+4|0;D=h+4|0;A=w;G=p;while(1){H=G&255;if(A>>>0>=((H&1|0)==0?H>>>1:c[D>>2]|0)>>>0){K=22;break}if((G&1)==0){L=x}else{L=c[y>>2]|0}H=a[L+A|0]|0;E=a[f]|0;if((E&1)==0){N=(E&255)>>>1;O=10;P=E}else{F=c[n>>2]|0;N=c[t>>2]|0;O=(F&-2)-1|0;P=F&255}if((N|0)==(O|0)){if((O|0)==-17){K=30;break}F=(P&1)==0?e:c[u>>2]|0;do{if(O>>>0<2147483623>>>0){C=O+1|0;B=O<<1;I=C>>>0<B>>>0?B:C;if(I>>>0<11>>>0){Q=11;break}Q=I+16&-16}else{Q=-17}}while(0);I=(z=0,au(248,Q|0)|0);if(z){z=0;K=17;break}LF(I|0,F|0,O)|0;if((O|0)!=10){Lw(F)}c[u>>2]=I;I=Q|1;c[n>>2]=I;R=I&255}else{R=E}if((R&1)==0){a[f]=(N<<1)+2;S=e;T=N+1|0}else{I=c[u>>2]|0;C=N+1|0;c[t>>2]=C;S=I;T=C}a[S+N|0]=H;a[S+T|0]=0;A=A+1|0;G=a[o]|0}do{if((K|0)==17){G=bT(-1,-1)|0;U=M;V=G;K=19}else if((K|0)==30){z=0;ar(86,0);if(z){z=0;K=18;break}}else if((K|0)==22){G=q+1|0;A=l+8|0;n=l|0;D=l+4|0;p=j+8|0;C=j+4|0;I=w;while(1){B=a[s]|0;J=B&255;if(I>>>0>=((J&1|0)==0?J>>>1:c[C>>2]|0)>>>0){K=44;break}J=a[((B&1)==0?G:c[p>>2]|0)+I|0]|0;B=a[d]|0;if((B&1)==0){W=(B&255)>>>1;X=10;Y=B}else{Z=c[n>>2]|0;W=c[D>>2]|0;X=(Z&-2)-1|0;Y=Z&255}if((W|0)==(X|0)){if((X|0)==-17){K=52;break}Z=(Y&1)==0?m:c[A>>2]|0;do{if(X>>>0<2147483623>>>0){_=X+1|0;$=X<<1;aa=_>>>0<$>>>0?$:_;if(aa>>>0<11>>>0){ab=11;break}ab=aa+16&-16}else{ab=-17}}while(0);aa=(z=0,au(248,ab|0)|0);if(z){z=0;K=16;break}LF(aa|0,Z|0,X)|0;if((X|0)!=10){Lw(Z)}c[A>>2]=aa;aa=ab|1;c[n>>2]=aa;ac=aa&255}else{ac=B}if((ac&1)==0){a[d]=(W<<1)+2;ad=m;ae=W+1|0}else{aa=c[A>>2]|0;_=W+1|0;c[D>>2]=_;ad=aa;ae=_}a[ad+W|0]=J;a[ad+ae|0]=0;I=I+1|0}if((K|0)==16){I=bT(-1,-1)|0;U=M;V=I;K=19;break}else if((K|0)==44){I=a[d]|0;n=I&255;G=n>>>1;C=c[A>>2]|0;H=c[D>>2]|0;L79:do{if((n&1|0)==0){E=0;F=0;while(1){if(E>>>0>=G>>>0){af=F;break L79}_=((a[((I&1)==0?m:C)+E|0]|0)==47)+F|0;E=E+1|0;F=_}}else{F=0;E=0;while(1){if(F>>>0>=H>>>0){af=E;break L79}J=((a[((I&1)==0?m:C)+F|0]|0)==47)+E|0;F=F+1|0;E=J}}}while(0);C=b;a[C]=0;a[b+1|0]=0;L87:do{if((af|0)==0){K=74}else{I=0;while(1){z=0,az(88,b|0,11424,3)|0;if(z){z=0;break}H=I+1|0;if(H>>>0<af>>>0){I=H}else{K=74;break L87}}I=bT(-1,-1)|0;ag=M;ah=I}}while(0);do{if((K|0)==74){I=a[f]|0;H=(I&1)==0?e:c[u>>2]|0;G=I&255;I=(G&1|0)==0?G>>>1:c[t>>2]|0;z=0,az(88,b|0,H|0,I|0)|0;if(z){z=0;I=bT(-1,-1)|0;ag=M;ah=I;break}if((a[d]&1)!=0){Lw(c[A>>2]|0)}if((a[f]&1)!=0){Lw(c[u>>2]|0)}if((a[s]&1)!=0){Lw(c[p>>2]|0)}if((a[o]&1)==0){i=g;return}Lw(c[y>>2]|0);i=g;return}}while(0);p=ah;A=ag;if((a[C]&1)==0){ai=p;aj=A;break}Lw(c[b+8>>2]|0);ai=p;aj=A;break}else if((K|0)==52){z=0;ar(86,0);if(z){z=0;K=18;break}}}}while(0);if((K|0)==18){t=bT(-1,-1)|0;U=M;V=t;K=19}if((K|0)==19){ai=V;aj=U}if((a[d]&1)!=0){Lw(c[l+8>>2]|0)}if((a[f]&1)!=0){Lw(c[u>>2]|0)}if((a[s]&1)==0){ak=ai;al=aj;am=o;break}Lw(c[j+8>>2]|0);ak=ai;al=aj;am=o}else{z=0;t=bT(-1,-1)|0;ak=t;al=M;am=h}}while(0);if((a[am]&1)==0){an=ak;ao=0;ap=an;aq=al;bg(ap|0)}Lw(c[h+8>>2]|0);an=ak;ao=0;ap=an;aq=al;bg(ap|0)}function p2(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0;f=i;i=i+352|0;g=f|0;h=f+16|0;j=f+32|0;k=f+48|0;l=f+64|0;m=f+80|0;n=f+96|0;o=f+112|0;p=f+128|0;q=f+144|0;r=f+160|0;s=f+176|0;t=f+192|0;u=f+208|0;v=f+224|0;w=f+240|0;x=f+256|0;y=f+272|0;A=f+288|0;B=f+304|0;C=f+320|0;D=f+336|0;E=D;F=i;i=i+12|0;i=i+7&-8;Ec(e,b)|0;G=e;if((a[G]&1)==0){H=g;c[H>>2]=c[G>>2];c[H+4>>2]=c[G+4>>2];c[H+8>>2]=c[G+8>>2]}else{H=c[e+8>>2]|0;I=c[e+4>>2]|0;if(I>>>0>4294967279>>>0){D5(0);return 0}if(I>>>0<11>>>0){a[g]=I<<1;J=g+1|0}else{K=I+16&-16;L=Lu(K)|0;c[g+8>>2]=L;c[g>>2]=K|1;c[g+4>>2]=I;J=L}LF(J|0,H|0,I)|0;a[J+I|0]=0}I=(z=0,au(292,g|0)|0);if(z){z=0;J=bT(-1,-1)|0;H=J;J=M;if((a[g]&1)==0){N=J;O=H;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[g+8>>2]|0);N=J;O=H;P=O;Q=0;R=P;S=N;bg(R|0)}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}L22:do{if((I|0)==0){g=b;H=a[g]|0;if((H&1)==0){J=j;c[J>>2]=c[g>>2];c[J+4>>2]=c[g+4>>2];c[J+8>>2]=c[g+8>>2];T=a[J]|0;U=J}else{J=c[b+8>>2]|0;L=c[b+4>>2]|0;if(L>>>0>4294967279>>>0){D5(0);return 0}if(L>>>0<11>>>0){K=L<<1&255;V=j;a[V]=K;W=j+1|0;X=K;Y=V}else{V=L+16&-16;K=Lu(V)|0;c[j+8>>2]=K;Z=V|1;c[j>>2]=Z;c[j+4>>2]=L;W=K;X=Z&255;Y=j}LF(W|0,J|0,L)|0;a[W+L|0]=0;T=X;U=Y}L=j;J=T&255;if((J&1|0)==0){_=J>>>1}else{_=c[j+4>>2]|0}L39:do{if((_|0)==0){$=32}else{if((T&1)==0){aa=L+1|0}else{aa=c[j+8>>2]|0}J=aa+_|0;do{if((J|0)==(aa|0)){$=32;break L39}J=J-1|0;}while((a[J]|0)!=47);Z=J-aa|0;if((Z|0)==-1){$=32;break}K=Z+1|0;Z=T&255;if((Z&1|0)==0){ab=Z>>>1}else{ab=c[j+4>>2]|0}if((T&1)==0){ac=L+1|0}else{ac=c[j+8>>2]|0}Z=ab>>>0<K>>>0?ab:K;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Z>>>0<11>>>0){a[h]=Z<<1;ad=h+1|0}else{K=Z+16&-16;V=(z=0,au(248,K|0)|0);if(z){z=0;break}c[h+8>>2]=V;c[h>>2]=K|1;c[h+4>>2]=Z;ad=V}LF(ad|0,ac|0,Z)|0;a[ad+Z|0]=0;break L39}}while(0);Z=bT(-1,-1)|0;J=Z;Z=M;if((a[U]&1)==0){N=Z;O=J;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[j+8>>2]|0);N=Z;O=J;P=O;Q=0;R=P;S=N;bg(R|0)}}while(0);if(($|0)==32){a[h]=0;a[h+1|0]=0}if((T&1)==0){ae=H}else{Lw(c[j+8>>2]|0);ae=a[g]|0}L78:do{if((ae&1)==0){L=l;c[L>>2]=c[g>>2];c[L+4>>2]=c[g+4>>2];c[L+8>>2]=c[g+8>>2];$=59}else{L=c[b+8>>2]|0;J=c[b+4>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(J>>>0<11>>>0){a[l]=J<<1;af=l+1|0}else{Z=J+16&-16;V=(z=0,au(248,Z|0)|0);if(z){z=0;break}c[l+8>>2]=V;c[l>>2]=Z|1;c[l+4>>2]=J;af=V}LF(af|0,L|0,J)|0;a[af+J|0]=0;$=59;break L78}}while(0);J=bT(-1,-1)|0;ag=M;ah=J}}while(0);do{if(($|0)==59){z=0;as(102,k|0,l|0);if(z){z=0;g=bT(-1,-1)|0;H=g;g=M;if((a[l]&1)==0){ag=g;ah=H;break}Lw(c[l+8>>2]|0);ag=g;ah=H;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}H=m;LI(H|0,0,12)|0;g=k;J=k;L=a[J]|0;V=L&255;if((V&1|0)==0){ai=V>>>1}else{ai=c[k+4>>2]|0}V=ai+1|0;do{if(V>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=76;break}return 0}else{if(V>>>0<11>>>0){a[H]=2;aj=m+1|0}else{Z=ai+17&-16;K=(z=0,au(248,Z|0)|0);if(z){z=0;$=76;break}c[m+8>>2]=K;c[m>>2]=Z|1;c[m+4>>2]=1;aj=K}a[aj]=95;a[aj+1|0]=0;if((L&1)==0){ak=g+1|0}else{ak=c[k+8>>2]|0}z=0,az(88,m|0,ak|0,ai|0)|0;if(z){z=0;$=76;break}z=0;aR(210,n|0,h|0,m|0);L116:do{if(!z){z=0,aM(344,e|0,n|0)|0;if(z){z=0;K=bT(-1,-1)|0;Z=K;K=M;if((a[n]&1)==0){al=K;am=Z;break}Lw(c[n+8>>2]|0);al=K;am=Z;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[G]&1)==0){Z=o;c[Z>>2]=c[G>>2];c[Z+4>>2]=c[G+4>>2];c[Z+8>>2]=c[G+8>>2]}else{Z=c[e+8>>2]|0;K=c[e+4>>2]|0;if(K>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=244;break}return 0}if(K>>>0<11>>>0){a[o]=K<<1;an=o+1|0}else{ao=K+16&-16;ap=(z=0,au(248,ao|0)|0);if(z){z=0;$=244;break}c[o+8>>2]=ap;c[o>>2]=ao|1;c[o+4>>2]=K;an=ap}LF(an|0,Z|0,K)|0;a[an+K|0]=0}K=(z=0,au(292,o|0)|0);if(z){z=0;Z=bT(-1,-1)|0;ap=Z;Z=M;if((a[o]&1)==0){al=Z;am=ap;break}Lw(c[o+8>>2]|0);al=Z;am=ap;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}L145:do{if((K|0)==0){ap=p;LI(ap|0,0,12)|0;Z=m;ao=a[H]|0;at=ao&255;if((at&1|0)==0){av=at>>>1}else{av=c[m+4>>2]|0}if((ao&1)==0){aw=Z+1|0}else{aw=c[m+8>>2]|0}ao=av+5|0;do{if(ao>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ao>>>0<11>>>0){a[ap]=av<<1;ax=p+1|0}else{at=av+21&-16;ay=(z=0,au(248,at|0)|0);if(z){z=0;break}c[p+8>>2]=ay;c[p>>2]=at|1;c[p+4>>2]=av;ax=ay}LF(ax|0,aw|0,av)|0;a[ax+av|0]=0;z=0,az(88,p|0,5832,5)|0;if(z){z=0;break}z=0;aR(210,q|0,h|0,p|0);L163:do{if(!z){z=0,aM(344,e|0,q|0)|0;if(z){z=0;ay=bT(-1,-1)|0;at=ay;ay=M;if((a[q]&1)==0){aA=ay;aB=at;break}Lw(c[q+8>>2]|0);aA=ay;aB=at;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[G]&1)==0){at=r;c[at>>2]=c[G>>2];c[at+4>>2]=c[G+4>>2];c[at+8>>2]=c[G+8>>2]}else{at=c[e+8>>2]|0;ay=c[e+4>>2]|0;if(ay>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=250;break}return 0}if(ay>>>0<11>>>0){a[r]=ay<<1;aC=r+1|0}else{aD=ay+16&-16;aE=(z=0,au(248,aD|0)|0);if(z){z=0;$=250;break}c[r+8>>2]=aE;c[r>>2]=aD|1;c[r+4>>2]=ay;aC=aE}LF(aC|0,at|0,ay)|0;a[aC+ay|0]=0}ay=(z=0,au(292,r|0)|0);if(z){z=0;at=bT(-1,-1)|0;aE=at;at=M;if((a[r]&1)==0){aA=at;aB=aE;break}Lw(c[r+8>>2]|0);aA=at;aB=aE;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}L192:do{if((ay|0)==0){aE=s;LI(aE|0,0,12)|0;at=a[H]|0;aD=at&255;if((aD&1|0)==0){aF=aD>>>1}else{aF=c[m+4>>2]|0}if((at&1)==0){aG=Z+1|0}else{aG=c[m+8>>2]|0}at=aF+5|0;do{if(at>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(at>>>0<11>>>0){a[aE]=aF<<1;aH=s+1|0}else{aD=aF+21&-16;aI=(z=0,au(248,aD|0)|0);if(z){z=0;break}c[s+8>>2]=aI;c[s>>2]=aD|1;c[s+4>>2]=aF;aH=aI}LF(aH|0,aG|0,aF)|0;a[aH+aF|0]=0;z=0,az(88,s|0,4800,5)|0;if(z){z=0;break}z=0;aR(210,t|0,h|0,s|0);L212:do{if(!z){z=0,aM(344,e|0,t|0)|0;if(z){z=0;aI=bT(-1,-1)|0;aD=aI;aI=M;if((a[t]&1)==0){aJ=aI;aK=aD;break}Lw(c[t+8>>2]|0);aJ=aI;aK=aD;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}if((a[G]&1)==0){aD=u;c[aD>>2]=c[G>>2];c[aD+4>>2]=c[G+4>>2];c[aD+8>>2]=c[G+8>>2]}else{aD=c[e+8>>2]|0;aI=c[e+4>>2]|0;if(aI>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=256;break}return 0}if(aI>>>0<11>>>0){a[u]=aI<<1;aL=u+1|0}else{aN=aI+16&-16;aO=(z=0,au(248,aN|0)|0);if(z){z=0;$=256;break}c[u+8>>2]=aO;c[u>>2]=aN|1;c[u+4>>2]=aI;aL=aO}LF(aL|0,aD|0,aI)|0;a[aL+aI|0]=0}aI=(z=0,au(292,u|0)|0);if(z){z=0;aD=bT(-1,-1)|0;aO=aD;aD=M;if((a[u]&1)==0){aJ=aD;aK=aO;break}Lw(c[u+8>>2]|0);aJ=aD;aK=aO;break}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}L241:do{if((aI|0)==0){aO=v;LI(aO|0,0,12)|0;aD=a[J]|0;aN=aD&255;aP=(aN&1|0)==0;if(aP){aQ=aN>>>1}else{aQ=c[k+4>>2]|0}aS=(aD&1)==0;if(aS){aT=g+1|0}else{aT=c[k+8>>2]|0}aD=aQ+5|0;do{if(aD>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aD>>>0<11>>>0){a[aO]=aQ<<1;aU=v+1|0}else{aV=aQ+21&-16;aW=(z=0,au(248,aV|0)|0);if(z){z=0;break}c[v+8>>2]=aW;c[v>>2]=aV|1;c[v+4>>2]=aQ;aU=aW}LF(aU|0,aT|0,aQ)|0;a[aU+aQ|0]=0;z=0,az(88,v|0,5832,5)|0;if(z){z=0;break}z=0;aR(210,w|0,h|0,v|0);L261:do{if(!z){z=0,aM(344,e|0,w|0)|0;if(z){z=0;aW=bT(-1,-1)|0;aV=aW;aW=M;if((a[w]&1)==0){aX=aW;aY=aV;break}Lw(c[w+8>>2]|0);aX=aW;aY=aV;break}if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}if((a[G]&1)==0){aV=x;c[aV>>2]=c[G>>2];c[aV+4>>2]=c[G+4>>2];c[aV+8>>2]=c[G+8>>2]}else{aV=c[e+8>>2]|0;aW=c[e+4>>2]|0;if(aW>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=262;break}return 0}if(aW>>>0<11>>>0){a[x]=aW<<1;aZ=x+1|0}else{a_=aW+16&-16;a$=(z=0,au(248,a_|0)|0);if(z){z=0;$=262;break}c[x+8>>2]=a$;c[x>>2]=a_|1;c[x+4>>2]=aW;aZ=a$}LF(aZ|0,aV|0,aW)|0;a[aZ+aW|0]=0}aW=(z=0,au(292,x|0)|0);if(z){z=0;aV=bT(-1,-1)|0;a$=aV;aV=M;if((a[x]&1)==0){aX=aV;aY=a$;break}Lw(c[x+8>>2]|0);aX=aV;aY=a$;break}if((a[x]&1)!=0){Lw(c[x+8>>2]|0)}L290:do{if((aW|0)==0){a$=y;LI(a$|0,0,12)|0;if(aP){a0=aN>>>1}else{a0=c[k+4>>2]|0}if(aS){a1=g+1|0}else{a1=c[k+8>>2]|0}aV=a0+5|0;do{if(aV>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aV>>>0<11>>>0){a[a$]=a0<<1;a2=y+1|0}else{a_=a0+21&-16;a3=(z=0,au(248,a_|0)|0);if(z){z=0;break}c[y+8>>2]=a3;c[y>>2]=a_|1;c[y+4>>2]=a0;a2=a3}LF(a2|0,a1|0,a0)|0;a[a2+a0|0]=0;z=0,az(88,y|0,4800,5)|0;if(z){z=0;break}z=0;aR(210,A|0,h|0,y|0);L310:do{if(!z){z=0,aM(344,e|0,A|0)|0;if(z){z=0;a3=bT(-1,-1)|0;a_=a3;a3=M;if((a[A]&1)==0){a4=a3;a5=a_;break}Lw(c[A+8>>2]|0);a4=a3;a5=a_;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[G]&1)==0){a_=B;c[a_>>2]=c[G>>2];c[a_+4>>2]=c[G+4>>2];c[a_+8>>2]=c[G+8>>2]}else{a_=c[e+8>>2]|0;a3=c[e+4>>2]|0;if(a3>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=268;break}return 0}if(a3>>>0<11>>>0){a[B]=a3<<1;a6=B+1|0}else{a7=a3+16&-16;a8=(z=0,au(248,a7|0)|0);if(z){z=0;$=268;break}c[B+8>>2]=a8;c[B>>2]=a7|1;c[B+4>>2]=a3;a6=a8}LF(a6|0,a_|0,a3)|0;a[a6+a3|0]=0}a3=(z=0,au(292,B|0)|0);if(z){z=0;a_=bT(-1,-1)|0;a8=a_;a_=M;if((a[B]&1)==0){a4=a_;a5=a8;break}Lw(c[B+8>>2]|0);a4=a_;a5=a8;break}if((a[B]&1)!=0){Lw(c[B+8>>2]|0)}do{if((a3|0)==0){z=0;aR(210,C|0,h|0,v|0);if(z){z=0;$=268;break L310}z=0,aM(344,e|0,C|0)|0;if(!z){if((a[C]&1)==0){break}Lw(c[C+8>>2]|0);break}else{z=0;a8=bT(-1,-1)|0;a_=a8;a8=M;if((a[C]&1)==0){a4=a8;a5=a_;break L310}Lw(c[C+8>>2]|0);a4=a8;a5=a_;break L310}}}while(0);if((a[a$]&1)==0){a9=a3;break L290}Lw(c[y+8>>2]|0);a9=a3;break L290}else{z=0;$=268}}while(0);if(($|0)==268){a_=bT(-1,-1)|0;a4=M;a5=a_}if((a[a$]&1)==0){aX=a4;aY=a5;break L261}Lw(c[y+8>>2]|0);aX=a4;aY=a5;break L261}}while(0);aV=bT(-1,-1)|0;a_=M;if((a[a$]&1)==0){ba=a_;bb=aV;$=263;break L261}Lw(c[y+8>>2]|0);ba=a_;bb=aV;$=263;break L261}else{a9=aW}}while(0);if((a[aO]&1)==0){bc=a9;break L241}Lw(c[v+8>>2]|0);bc=a9;break L241}else{z=0;$=262}}while(0);if(($|0)==262){aW=bT(-1,-1)|0;ba=M;bb=aW;$=263}if(($|0)==263){aX=ba;aY=bb}if((a[aO]&1)==0){aJ=aX;aK=aY;break L212}Lw(c[v+8>>2]|0);aJ=aX;aK=aY;break L212}}while(0);aS=bT(-1,-1)|0;aN=M;if((a[aO]&1)==0){bd=aN;be=aS;$=257;break L212}Lw(c[v+8>>2]|0);bd=aN;be=aS;$=257;break L212}else{bc=aI}}while(0);if((a[aE]&1)==0){bf=bc;break L192}Lw(c[s+8>>2]|0);bf=bc;break L192}else{z=0;$=256}}while(0);if(($|0)==256){aI=bT(-1,-1)|0;bd=M;be=aI;$=257}if(($|0)==257){aJ=bd;aK=be}if((a[aE]&1)==0){aA=aJ;aB=aK;break L163}Lw(c[s+8>>2]|0);aA=aJ;aB=aK;break L163}}while(0);at=bT(-1,-1)|0;aI=M;if((a[aE]&1)==0){bh=aI;bi=at;$=251;break L163}Lw(c[s+8>>2]|0);bh=aI;bi=at;$=251;break L163}else{bf=ay}}while(0);if((a[ap]&1)==0){bj=bf;break L145}Lw(c[p+8>>2]|0);bj=bf;break L145}else{z=0;$=250}}while(0);if(($|0)==250){ay=bT(-1,-1)|0;bh=M;bi=ay;$=251}if(($|0)==251){aA=bh;aB=bi}if((a[ap]&1)==0){al=aA;am=aB;break L116}Lw(c[p+8>>2]|0);al=aA;am=aB;break L116}}while(0);Z=bT(-1,-1)|0;ao=M;if((a[ap]&1)==0){bk=ao;bl=Z;$=245;break L116}Lw(c[p+8>>2]|0);bk=ao;bl=Z;$=245;break L116}else{bj=K}}while(0);if((a[H]&1)!=0){Lw(c[m+8>>2]|0)}if((a[J]&1)!=0){Lw(c[k+8>>2]|0)}if((a[h]&1)==0){bm=bj;break L22}Lw(c[h+8>>2]|0);bm=bj;break L22}else{z=0;$=244}}while(0);if(($|0)==244){K=bT(-1,-1)|0;bk=M;bl=K;$=245}if(($|0)==245){al=bk;am=bl}if((a[H]&1)==0){bn=al;bo=am;break}Lw(c[m+8>>2]|0);bn=al;bo=am}}while(0);if(($|0)==76){g=bT(-1,-1)|0;L=M;if((a[H]&1)!=0){Lw(c[m+8>>2]|0)}bn=L;bo=g}if((a[J]&1)==0){ag=bn;ah=bo;break}Lw(c[k+8>>2]|0);ag=bn;ah=bo}}while(0);if((a[h]&1)==0){N=ag;O=ah;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[h+8>>2]|0);N=ag;O=ah;P=O;Q=0;R=P;S=N;bg(R|0)}else{bm=I}}while(0);LI(E|0,0,12)|0;I=d[G]|0;G=(I&1|0)==0;if(G){bp=I>>>1}else{bp=c[e+4>>2]|0}do{if(bp>>>0>5>>>0){if(G){bq=I>>>1}else{bq=c[e+4>>2]|0}z=0;aq(30,F|0,e|0,bq-5|0,5,0);if(z){z=0;ah=bT(-1,-1)|0;br=M;bs=ah;$=317;break}z=0,aM(344,D|0,F|0)|0;if(!z){if((a[F]&1)==0){$=314;break}Lw(c[F+8>>2]|0);$=314;break}else{z=0;ah=bT(-1,-1)|0;ag=ah;ah=M;if((a[F]&1)==0){bt=ah;bu=ag;break}Lw(c[F+8>>2]|0);bt=ah;bu=ag;break}}else{$=314}}while(0);do{if(($|0)==314){F=D+1|0;bq=D+8|0;e=D+4|0;I=0;while(1){G=a[E]|0;bp=G&255;bv=(G&1)==0;if(I>>>0>=((bp&1|0)==0?bp>>>1:c[e>>2]|0)>>>0){break}bp=(z=0,au(60,a[(bv?F:c[bq>>2]|0)+I|0]|0)|0);if(z){z=0;$=315;break}a[((a[E]&1)==0?F:c[bq>>2]|0)+I|0]=bp;I=I+1|0}if(($|0)==315){I=bT(-1,-1)|0;br=M;bs=I;$=317;break}if(bv){i=f;return bm|0}Lw(c[bq>>2]|0);i=f;return bm|0}}while(0);if(($|0)==317){bt=br;bu=bs}if((a[E]&1)==0){N=bt;O=bu;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[D+8>>2]|0);N=bt;O=bu;P=O;Q=0;R=P;S=N;bg(R|0);return 0}function p3(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=i;i=i+288|0;f=e|0;g=e+80|0;h=e+272|0;j=h;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+16|0;m=i;i=i+12|0;i=i+7&-8;n=b;o=b;if((a[o]&1)==0){p=n+1|0}else{p=c[b+8>>2]|0}if((cm(p|0,f|0)|0)==-1){q=0;i=e;return q|0}if((c[f+12>>2]&61440|0)==16384){q=0;i=e;return q|0}if((a[o]&1)==0){r=n+1|0}else{r=c[b+8>>2]|0}n=g;f=g+108|0;p=g|0;s=g;t=g+8|0;u=g;c[p>>2]=32580;v=g+108|0;c[v>>2]=32600;c[g+4>>2]=0;z=0;as(198,g+108|0,t|0);L15:do{if(!z){c[g+180>>2]=0;c[g+184>>2]=-1;c[p>>2]=15844;c[f>>2]=15864;z=0;ar(6,t|0);if(z){z=0;w=bT(-1,-1)|0;x=w;y=M;break}w=g+72|0;do{if((c[w>>2]|0)==0){A=bO(r|0,10808)|0;c[w>>2]=A;if((A|0)==0){B=15;break}c[g+96>>2]=14;if((ci(A|0,0,2)|0)==0){break}aZ(c[w>>2]|0)|0;c[w>>2]=0;B=15}else{B=15}}while(0);do{if((B|0)==15){A=c[(c[u>>2]|0)-12>>2]|0;z=0;as(368,n+A|0,c[n+(A+16)>>2]|4|0);if(!z){break}else{z=0}A=bT(-1,-1)|0;C=M;z=0;ar(220,t|0);if(!z){x=A;y=C;break L15}else{z=0}D=bT(-1,-1,0)|0;E=M;bX();return 0}}while(0);LI(j|0,0,12)|0;C=d[o]|0;A=(C&1|0)==0;if(A){F=C>>>1}else{F=c[b+4>>2]|0}do{if(F>>>0>5>>>0){if(A){G=C>>>1}else{G=c[b+4>>2]|0}z=0;aq(30,k|0,b|0,G-5|0,5,0);if(z){z=0;B=34;break}z=0,aM(344,h|0,k|0)|0;if(!z){if((a[k]&1)==0){B=38;break}Lw(c[k+8>>2]|0);B=38;break}else{z=0;H=bT(-1,-1)|0;I=H;H=M;if((a[k]&1)==0){J=H;K=I;break}Lw(c[k+8>>2]|0);J=H;K=I;break}}else{B=38}}while(0);L46:do{if((B|0)==38){L48:do{if((c[w>>2]|0)==0){L=0}else{z=0;as(734,l|0,s|0);if(z){z=0;B=34;break L46}C=c[l+8>>2]|0;A=(z=0,au(88,C+1|0)|0);if(z){z=0;B=34;break L46}I=0;H=0;z=0,aU(26,s|0,I|0,H|0,0)|0;if(z){z=0;B=34;break L46}z=0,az(76,s|0,A|0,C|0)|0;if(z){z=0;B=34;break L46}a[A+C|0]=0;C=c[w>>2]|0;do{if((C|0)!=0){H=(z=0,au(c[(c[t>>2]|0)+24>>2]|0,t|0)|0);if(z){z=0;I=bT(-1,-1)|0;N=M;aZ(C|0)|0;O=N;P=I;B=35;break L46}if((aZ(C|0)|0)!=0){break}c[w>>2]=0;if((H|0)==0){L=A;break L48}}}while(0);C=c[(c[u>>2]|0)-12>>2]|0;z=0;as(368,n+C|0,c[n+(C+16)>>2]|4|0);if(!z){L=A}else{z=0;B=34;break L46}}}while(0);C=h+1|0;H=h+8|0;I=h+4|0;N=0;while(1){Q=a[j]|0;R=Q&255;S=(R&1|0)==0;if(N>>>0>=(S?R>>>1:c[I>>2]|0)>>>0){break}T=(z=0,au(60,a[((Q&1)==0?C:c[H>>2]|0)+N|0]|0)|0);if(z){z=0;B=33;break}a[((a[j]&1)==0?C:c[H>>2]|0)+N|0]=T;N=N+1|0}if((B|0)==33){N=bT(-1,-1)|0;O=M;P=N;B=35;break}N=S?R>>>1:c[I>>2]|0;do{if((LH(((Q&1)==0?C:c[H>>2]|0)|0,4800,(N>>>0>5>>>0?5:N)|0)|0)==0){if((N|0)!=5|(L|0)==0){U=L;break}T=LJ(L|0)|0;if(T>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;B=34;break L46}return 0}if(T>>>0<11>>>0){a[m]=T<<1;V=m+1|0}else{W=T+16&-16;X=(z=0,au(248,W|0)|0);if(z){z=0;B=34;break L46}c[m+8>>2]=X;c[m>>2]=W|1;c[m+4>>2]=T;V=X}LF(V|0,L|0,T)|0;a[V+T|0]=0;T=(z=0,aM(680,m|0,1)|0);if(z){z=0;X=bT(-1,-1)|0;W=X;X=M;if((a[m]&1)==0){J=X;K=W;break L46}Lw(c[m+8>>2]|0);J=X;K=W;break L46}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}Lx(L);U=T}else{U=L}}while(0);if((a[j]&1)!=0){Lw(c[H>>2]|0)}c[p>>2]=15844;c[v>>2]=15864;z=0;ar(220,t|0);if(!z){Ex(g+108|0);q=U;i=e;return q|0}else{z=0}N=bT(-1,-1)|0;z=0;ar(272,g+108|0);if(!z){bg(N|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);if((B|0)==34){w=bT(-1,-1)|0;O=M;P=w;B=35}if((B|0)==35){J=O;K=P}if((a[j]&1)!=0){Lw(c[h+8>>2]|0)}c[p>>2]=15844;c[v>>2]=15864;z=0;ar(220,t|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,g+108|0);if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}z=0;ar(272,g+108|0);if(!z){bg(K|0)}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;w=bT(-1,-1)|0;x=w;y=M}}while(0);z=0;ar(272,f|0);if(!z){bg(x|0)}else{z=0;D=bT(-1,-1,0)|0;E=M;bX();return 0}return 0}function p4(a){a=a|0;var b=0;c[a>>2]=15844;c[a+108>>2]=15864;z=0;ar(220,a+8|0);if(!z){Ex(a+108|0);return}else{z=0}b=bT(-1,-1)|0;z=0;ar(272,a+108|0);if(!z){bg(b|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function p5(a){a=a|0;p9(a);return}function p6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;c[a>>2]=15844;c[a+108>>2]=15864;z=0;ar(220,a+8|0);if(z){z=0;b=bT(-1,-1)|0;d=M;z=0;ar(272,a+108|0);if(!z){e=d;f=b;g=a;Lw(g);bg(f|0)}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,a+108|0);if(!z){Lw(a);return}else{z=0}b=bT(-1,-1)|0;e=M;f=b;g=a;Lw(g);bg(f|0)}function p7(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;c[b+d>>2]=15844;a=b+(d+108)|0;c[a>>2]=15864;z=0;ar(220,b+(d+8)|0);if(!z){Ex(a);return}else{z=0}d=bT(-1,-1)|0;z=0;ar(272,a|0);if(!z){bg(d|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function p8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;a=b+d|0;c[a>>2]=15844;e=b+(d+108)|0;c[e>>2]=15864;z=0;ar(220,b+(d+8)|0);if(z){z=0;d=bT(-1,-1)|0;b=M;z=0;ar(272,e|0);if(!z){f=b;g=d;Lw(a);bg(g|0)}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,e|0);if(!z){Lw(a);return}else{z=0}e=bT(-1,-1)|0;f=M;g=e;Lw(a);bg(g|0)}function p9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b|0;c[d>>2]=16080;e=b+64|0;f=c[e>>2]|0;do{if((f|0)!=0){z=0,au(258,b|0)|0;if(!z){if((aZ(f|0)|0)!=0){break}c[e>>2]=0;break}else{z=0}g=bT(-1,-1,0)|0;aZ(f|0)|0;bD(g|0)|0;z=0;aS(2);if(!z){break}else{z=0}g=bT(-1,-1)|0;c[d>>2]=15768;z=0;ar(394,b+4|0);if(!z){bg(g|0)}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);do{if((a[b+96|0]&1)!=0){f=c[b+32>>2]|0;if((f|0)==0){break}Lx(f)}}while(0);if((a[b+97|0]&1)==0){c[d>>2]=15768;h=b+4|0;I0(h);return}f=c[b+56>>2]|0;if((f|0)==0){c[d>>2]=15768;h=b+4|0;I0(h);return}Lx(f);c[d>>2]=15768;h=b+4|0;I0(h);return}function qa(a){a=a|0;var b=0;z=0;ar(220,a|0);if(!z){Lw(a);return}else{z=0;b=bT(-1,-1)|0;Lw(a);bg(b|0)}}function qb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;cD[c[(c[b>>2]|0)+24>>2]&511](b)|0;e=I2(d,41456)|0;d=e;c[b+68>>2]=d;f=b+98|0;g=a[f]&1;h=cD[c[(c[e>>2]|0)+28>>2]&511](d)|0;a[f]=h&1;if((g&255|0)==(h&1|0)){return}g=b+96|0;LI(b+8|0,0,24)|0;f=(a[g]&1)!=0;if(h){h=b+32|0;do{if(f){d=c[h>>2]|0;if((d|0)==0){break}Lx(d)}}while(0);d=b+97|0;a[g]=a[d]&1;e=b+60|0;c[b+52>>2]=c[e>>2];i=b+56|0;c[h>>2]=c[i>>2];c[e>>2]=0;c[i>>2]=0;a[d]=0;return}do{if(!f){d=b+32|0;i=c[d>>2]|0;if((i|0)==(b+44|0)){break}e=c[b+52>>2]|0;c[b+60>>2]=e;c[b+56>>2]=i;a[b+97|0]=0;c[d>>2]=Lv(e)|0;a[g]=1;return}}while(0);g=c[b+52>>2]|0;c[b+60>>2]=g;c[b+56>>2]=Lv(g)|0;a[b+97|0]=1;return}function qc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b|0;g=b+96|0;LI(b+8|0,0,24)|0;do{if((a[g]&1)!=0){h=c[b+32>>2]|0;if((h|0)==0){break}Lx(h)}}while(0);h=b+97|0;do{if((a[h]&1)!=0){i=c[b+56>>2]|0;if((i|0)==0){break}Lx(i)}}while(0);i=b+52|0;c[i>>2]=e;do{if(e>>>0>8>>>0){j=a[b+98|0]|0;if((j&1)==0|(d|0)==0){c[b+32>>2]=Lv(e)|0;a[g]=1;k=j;break}else{c[b+32>>2]=d;a[g]=0;k=j;break}}else{c[b+32>>2]=b+44;c[i>>2]=8;a[g]=0;k=a[b+98|0]|0}}while(0);if((k&1)!=0){c[b+60>>2]=0;c[b+56>>2]=0;a[h]=0;return f|0}k=(e|0)<8?8:e;c[b+60>>2]=k;if((d|0)!=0&k>>>0>7>>>0){c[b+56>>2]=d;a[h]=0;return f|0}else{c[b+56>>2]=Lv(k)|0;a[h]=1;return f|0}return 0}function qd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;g=c[b+68>>2]|0;if((g|0)==0){h=cl(4)|0;K$(h);bK(h|0,29336,98)}h=cD[c[(c[g>>2]|0)+24>>2]&511](g)|0;g=b+64|0;do{if((c[g>>2]|0)!=0){i=(h|0)>0;if(!(i|(d|0)==0&(e|0)==0)){break}if((cD[c[(c[b>>2]|0)+24>>2]&511](b)|0)!=0){break}if(f>>>0>=3>>>0){j=a;c[j>>2]=0;c[j+4>>2]=0;j=a+8|0;c[j>>2]=-1;c[j+4>>2]=-1;return}j=c[g>>2]|0;if(i){i=LW(h,(h|0)<0|0?-1:0,d,e)|0;k=i}else{k=0}if((ci(j|0,k|0,f|0)|0)==0){j=bs(c[g>>2]|0)|0;i=b+72|0;l=c[i+4>>2]|0;m=a;c[m>>2]=c[i>>2];c[m+4>>2]=l;l=a+8|0;c[l>>2]=j;c[l+4>>2]=(j|0)<0|0?-1:0;return}else{j=a;c[j>>2]=0;c[j+4>>2]=0;j=a+8|0;c[j>>2]=-1;c[j+4>>2]=-1;return}}}while(0);b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}function qe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;f=d;d=i;i=i+16|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];f=b+64|0;do{if((c[f>>2]|0)!=0){if((cD[c[(c[b>>2]|0)+24>>2]&511](b)|0)!=0){break}if((ci(c[f>>2]|0,c[d+8>>2]|0,0)|0)==0){g=d;h=c[g+4>>2]|0;j=b+72|0;c[j>>2]=c[g>>2];c[j+4>>2]=h;h=a;j=d;c[h>>2]=c[j>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];i=e;return}else{j=a;c[j>>2]=0;c[j+4>>2]=0;j=a+8|0;c[j>>2]=-1;c[j+4>>2]=-1;i=e;return}}}while(0);d=a;c[d>>2]=0;c[d+4>>2]=0;d=a+8|0;c[d>>2]=-1;c[d+4>>2]=-1;i=e;return}function qf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d|0;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=cl(4)|0;K$(m);bK(m|0,29336,98);return 0}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;c[f>>2]=c[o>>2];c[f+4>>2]=p;do{if((a[b+98|0]&1)==0){p=cD[c[(c[l>>2]|0)+24>>2]&511](l)|0;o=b+36|0;q=c[o>>2]|0;r=(c[b+40>>2]|0)-q|0;if((p|0)>0){s=(ai((c[b+16>>2]|0)-(c[b+12>>2]|0)|0,p)|0)+r|0;t=0;break}p=c[b+12>>2]|0;if((p|0)==(c[b+16>>2]|0)){s=r;t=0;break}u=c[k>>2]|0;v=b+32|0;w=cZ[c[(c[u>>2]|0)+32>>2]&31](u,g,c[v>>2]|0,q,p-(c[b+8>>2]|0)|0)|0;s=r-w+(c[o>>2]|0)-(c[v>>2]|0)|0;t=1}else{s=(c[b+16>>2]|0)-(c[b+12>>2]|0)|0;t=0}}while(0);if((ci(c[h>>2]|0,-s|0,1)|0)!=0){j=-1;i=d;return j|0}if(t){v=b+72|0;o=c[f+4>>2]|0;c[v>>2]=c[f>>2];c[v+4>>2]=o}o=c[b+32>>2]|0;c[b+40>>2]=o;c[b+36>>2]=o;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[m>>2]=0}else{do{if((c[b+24>>2]|0)!=(c[b+20>>2]|0)){if((cV[c[(c[b>>2]|0)+52>>2]&1023](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);o=b+72|0;v=b+32|0;w=b+52|0;while(1){r=c[k>>2]|0;p=c[v>>2]|0;q=cZ[c[(c[r>>2]|0)+20>>2]&31](r,o,p,p+(c[w>>2]|0)|0,e)|0;p=c[v>>2]|0;r=(c[e>>2]|0)-p|0;if((a4(p|0,1,r|0,c[h>>2]|0)|0)!=(r|0)){j=-1;x=29;break}if((q|0)==2){j=-1;x=28;break}else if((q|0)!=1){x=10;break}}if((x|0)==28){i=d;return j|0}else if((x|0)==10){if((a1(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((x|0)==29){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function qg(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e|0;g=e+8|0;h=b+64|0;if((c[h>>2]|0)==0){j=-1;i=e;return j|0}k=b+92|0;if((c[k>>2]&8|0)==0){c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;if((a[b+98|0]&1)==0){l=c[b+56>>2]|0;m=l+(c[b+60>>2]|0)|0;c[b+8>>2]=l;c[b+12>>2]=m;c[b+16>>2]=m;n=m}else{m=c[b+32>>2]|0;l=m+(c[b+52>>2]|0)|0;c[b+8>>2]=m;c[b+12>>2]=l;c[b+16>>2]=l;n=l}c[k>>2]=8;o=1;p=n;q=b+12|0}else{n=b+12|0;o=0;p=c[n>>2]|0;q=n}if((p|0)==0){n=f+1|0;c[b+8>>2]=f;c[q>>2]=n;c[b+16>>2]=n;r=n}else{r=p}p=c[b+16>>2]|0;if(o){s=0}else{o=(p-(c[b+8>>2]|0)|0)/2|0;s=o>>>0>4>>>0?4:o}o=b+16|0;do{if((r|0)==(p|0)){n=b+8|0;LG(c[n>>2]|0,r+(-s|0)|0,s|0)|0;if((a[b+98|0]&1)!=0){k=c[n>>2]|0;l=ca(k+s|0,1,(c[o>>2]|0)-s-k|0,c[h>>2]|0)|0;if((l|0)==0){t=-1;u=n;break}k=c[n>>2]|0;m=k+s|0;c[q>>2]=m;c[o>>2]=k+(l+s);t=d[m]|0;u=n;break}m=b+32|0;l=b+36|0;k=c[l>>2]|0;v=b+40|0;LG(c[m>>2]|0,k|0,(c[v>>2]|0)-k|0)|0;k=c[m>>2]|0;w=k+((c[v>>2]|0)-(c[l>>2]|0))|0;c[l>>2]=w;if((k|0)==(b+44|0)){x=8}else{x=c[b+52>>2]|0}y=k+x|0;c[v>>2]=y;k=b+60|0;z=(c[k>>2]|0)-s|0;A=y-w|0;y=b+72|0;B=y;C=b+80|0;D=c[B+4>>2]|0;c[C>>2]=c[B>>2];c[C+4>>2]=D;D=ca(w|0,1,(A>>>0<z>>>0?A:z)|0,c[h>>2]|0)|0;if((D|0)==0){t=-1;u=n;break}z=c[b+68>>2]|0;if((z|0)==0){A=cl(4)|0;K$(A);bK(A|0,29336,98);return 0}A=(c[l>>2]|0)+D|0;c[v>>2]=A;D=c[n>>2]|0;if((c0[c[(c[z>>2]|0)+16>>2]&31](z,y,c[m>>2]|0,A,l,D+s|0,D+(c[k>>2]|0)|0,g)|0)==3){k=c[m>>2]|0;m=c[v>>2]|0;c[n>>2]=k;c[q>>2]=k;c[o>>2]=m;t=d[k]|0;u=n;break}k=c[g>>2]|0;m=c[n>>2]|0;v=m+s|0;if((k|0)==(v|0)){t=-1;u=n;break}c[n>>2]=m;c[q>>2]=v;c[o>>2]=k;t=d[v]|0;u=n}else{t=d[r]|0;u=b+8|0}}while(0);if((c[u>>2]|0)!=(f|0)){j=t;i=e;return j|0}c[u>>2]=0;c[q>>2]=0;c[o>>2]=0;j=t;i=e;return j|0}function qh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((c[b+64>>2]|0)==0){e=-1;return e|0}f=b+12|0;g=c[f>>2]|0;if((c[b+8>>2]|0)>>>0>=g>>>0){e=-1;return e|0}if((d|0)==-1){c[f>>2]=g-1;e=0;return e|0}h=g-1|0;do{if((c[b+88>>2]&16|0)==0){if((d<<24>>24|0)==(a[h]|0)){break}else{e=-1}return e|0}}while(0);c[f>>2]=h;a[h]=d;e=d;return e|0}function qi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+24|0;f=e|0;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}l=b+92|0;if((c[l>>2]&16|0)==0){c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;m=c[b+52>>2]|0;do{if(m>>>0>8>>>0){if((a[b+98|0]&1)==0){n=c[b+56>>2]|0;o=n+((c[b+60>>2]|0)-1)|0;c[b+24>>2]=n;c[b+20>>2]=n;c[b+28>>2]=o;p=n;q=o;break}else{o=c[b+32>>2]|0;n=o+(m-1)|0;c[b+24>>2]=o;c[b+20>>2]=o;c[b+28>>2]=n;p=o;q=n;break}}else{c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;p=0;q=0}}while(0);c[l>>2]=16;r=p;s=q;t=b+20|0;u=b+28|0}else{q=b+20|0;p=b+28|0;r=c[q>>2]|0;s=c[p>>2]|0;t=q;u=p}p=(d|0)==-1;q=b+24|0;l=c[q>>2]|0;if(p){v=r;w=l}else{if((l|0)==0){c[q>>2]=f;c[t>>2]=f;c[u>>2]=f+1;x=f}else{x=l}a[x]=d;x=(c[q>>2]|0)+1|0;c[q>>2]=x;v=c[t>>2]|0;w=x}x=b+24|0;if((w|0)!=(v|0)){L23:do{if((a[b+98|0]&1)==0){q=b+32|0;l=c[q>>2]|0;c[g>>2]=l;f=b+68|0;m=c[f>>2]|0;if((m|0)==0){y=cl(4)|0;z=y;K$(z);bK(y|0,29336,98);return 0}n=b+72|0;o=b+52|0;A=m;m=v;B=w;C=l;while(1){l=c0[c[(c[A>>2]|0)+12>>2]&31](A,n,m,B,h,C,C+(c[o>>2]|0)|0,g)|0;D=c[t>>2]|0;if((c[h>>2]|0)==(D|0)){k=-1;E=31;break}if((l|0)==3){E=22;break}if(l>>>0>=2>>>0){k=-1;E=34;break}F=c[q>>2]|0;G=(c[g>>2]|0)-F|0;if((a4(F|0,1,G|0,c[j>>2]|0)|0)!=(G|0)){k=-1;E=37;break}if((l|0)!=1){break L23}l=c[h>>2]|0;G=c[x>>2]|0;c[t>>2]=l;c[u>>2]=G;F=l+(G-l)|0;c[x>>2]=F;G=c[f>>2]|0;if((G|0)==0){E=39;break}A=G;m=l;B=F;C=c[q>>2]|0}if((E|0)==34){i=e;return k|0}else if((E|0)==31){i=e;return k|0}else if((E|0)==39){y=cl(4)|0;z=y;K$(z);bK(y|0,29336,98);return 0}else if((E|0)==22){q=(c[x>>2]|0)-D|0;if((a4(D|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((E|0)==37){i=e;return k|0}}else{q=w-v|0;if((a4(v|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);c[x>>2]=r;c[t>>2]=r;c[u>>2]=s}k=p?0:d;i=e;return k|0}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d|0;f=d+8|0;g=b|0;c[g>>2]=15768;h=b+4|0;I_(h);LI(b+8|0,0,24)|0;c[g>>2]=16080;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;j=b+68|0;k=b+98|0;LI(b+52|0,0,47)|0;I$(e,h);l=(z=0,aM(172,e|0,41456)|0);if(z){z=0;m=bT(-1,-1)|0;bH(m|0)}z=0;ar(394,e|0);L4:do{if(!z){do{if(l){I$(f,h);e=(z=0,aM(198,f|0,41456)|0);if(!z){c[j>>2]=e;z=0;ar(394,f|0);if(z){z=0;n=8;break L4}e=c[j>>2]|0;a[k]=(cD[c[(c[e>>2]|0)+28>>2]&511](e)|0)&1;break}else{z=0;e=bT(-1,-1)|0;m=M;z=0;ar(394,f|0);if(!z){o=m;p=e;break L4}else{z=0}q=bT(-1,-1,0)|0;r=M;bX()}}}while(0);e=c[(c[b>>2]|0)+12>>2]|0;z=0,az(e|0,b|0,0,4096)|0;if(z){z=0;n=8;break}i=d;return}else{z=0;n=8}}while(0);if((n|0)==8){n=bT(-1,-1)|0;o=M;p=n}c[g>>2]=15768;z=0;ar(394,h|0);if(!z){bg(p|0)}else{z=0;q=bT(-1,-1,0)|0;r=M;bX()}}function qk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+168|0;g=f|0;h=f+16|0;j=f+24|0;k=f+88|0;l=f+104|0;m=f+120|0;n=f+136|0;o=f+152|0;p=Lu(32)|0;q=k+8|0;c[q>>2]=p;c[k>>2]=33;c[k+4>>2]=19;LF(p|0,8472,19)|0;a[p+19|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z=0;aq(2,j|0,b|0,e|0,k|0,l|0);if(z){z=0;l=bT(-1,-1)|0;p=l;l=M;if((a[k]&1)==0){r=p;s=l;t=r;u=0;v=t;w=s;bg(v|0)}Lw(c[q>>2]|0);r=p;s=l;t=r;u=0;v=t;w=s;bg(v|0)}if((a[k]&1)!=0){Lw(c[q>>2]|0)}q=j+20|0;k=(z=0,au(66,c[q>>2]|0)|0);do{if(!z){l=(z=0,au(212,k|0)|0);if(z){z=0;x=53;break}if((l|0)==0){y=c[j+56>>2]|0;A=c[j+60>>2]|0}else{p=j+48|0;B=c[p>>2]|0;C=c[q>>2]|0;L17:do{if(C>>>0<l>>>0){D=C;E=0;while(1){F=a[D]|0;if((F<<24>>24|0)==10){G=E+1|0}else if((F<<24>>24|0)==0){H=E;break L17}else{G=E}F=D+1|0;if(F>>>0<l>>>0){D=F;E=G}else{H=G;break}}}else{H=0}}while(0);c[p>>2]=H+B;E=k;D=0;while(1){F=E-1|0;if(F>>>0<C>>>0){break}if((a[F]|0)==10){break}else{E=F;D=D+1|0}}E=j+40|0;if((H|0)!=0){c[E>>2]=1}C=c[E>>2]|0;c[j+52>>2]=C+D;B=l;p=k;c[E>>2]=B-p+D+C;C=j+56|0;c[C>>2]=p;c[C+4>>2]=B;c[q>>2]=l;y=k;A=l}B=A-y|0;if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;x=53;break}return 0}if(B>>>0<11>>>0){C=B<<1&255;a[m]=C;I=m+1|0;J=C}else{C=B+16&-16;p=(z=0,au(248,C|0)|0);if(z){z=0;x=53;break}c[m+8>>2]=p;E=C|1;c[m>>2]=E;c[m+4>>2]=B;I=p;J=E&255}LF(I|0,y|0,B)|0;a[I+B|0]=0;B=(z=0,au(122,j|0)|0);do{if(!z){E=(z=0,au(248,76)|0);if(z){z=0;x=54;break}p=E;c[h>>2]=p;E=e+4|0;C=c[E>>2]|0;if((C|0)==(c[e+8>>2]|0)){z=0;as(382,e|0,h|0);if(z){z=0;x=54;break}K=c[h>>2]|0}else{if((C|0)==0){L=0}else{c[C>>2]=p;L=c[E>>2]|0}c[E>>2]=L+4;K=p}p=K;C=K;F=(z=0,au(248,32)|0);do{if(!z){N=n+8|0;c[N>>2]=F;c[n>>2]=33;c[n+4>>2]=19;LF(F|0,8472,19)|0;a[F+19|0]=0;L55:do{if((J&1)==0){O=m;P=o;c[P>>2]=c[O>>2];c[P+4>>2]=c[O+4>>2];c[P+8>>2]=c[O+8>>2];x=44}else{O=c[m+8>>2]|0;P=c[m+4>>2]|0;do{if(P>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(P>>>0<11>>>0){a[o]=P<<1;Q=o+1|0}else{R=P+16&-16;S=(z=0,au(248,R|0)|0);if(z){z=0;break}c[o+8>>2]=S;c[o>>2]=R|1;c[o+4>>2]=P;Q=S}LF(Q|0,O|0,P)|0;a[Q+P|0]=0;x=44;break L55}}while(0);P=bT(-1,-1)|0;T=P;U=M}}while(0);do{if((x|0)==44){c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;z=0;aC(16,C|0,n|0,g|0,b|0,o|0,B|0,d|0,0);if(z){z=0;P=bT(-1,-1)|0;O=P;P=M;if((a[o]&1)==0){T=O;U=P;break}Lw(c[o+8>>2]|0);T=O;U=P;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)!=0){Lw(c[N>>2]|0)}if((J&1)!=0){Lw(c[m+8>>2]|0)}if((a[j+28|0]&1)!=0){Lw(c[j+36>>2]|0)}P=c[j+4>>2]|0;if((P|0)==0){i=f;return C|0}O=j+8|0;S=c[O>>2]|0;if((P|0)!=(S|0)){c[O>>2]=S+(~((S-4+(-P|0)|0)>>>2)<<2)}Lw(P);i=f;return C|0}}while(0);if((a[n]&1)==0){V=T;W=U;break}Lw(c[N>>2]|0);V=T;W=U}else{z=0;P=bT(-1,-1)|0;V=P;W=M}}while(0);C=c[e>>2]|0;F=c[E>>2]|0;P=C;while(1){if((P|0)==(F|0)){X=F;break}if((c[P>>2]|0)==(K|0)){X=P;break}else{P=P+4|0}}P=X-C>>2;S=C+(P+1<<2)|0;O=F-S|0;LG(C+(P<<2)|0,S|0,O|0)|0;S=C+((O>>2)+P<<2)|0;P=c[E>>2]|0;if((S|0)!=(P|0)){c[E>>2]=P+(~((P-4+(-S|0)|0)>>>2)<<2)}Lw(p);Y=V;Z=W}else{z=0;x=54}}while(0);if((x|0)==54){B=bT(-1,-1)|0;Y=B;Z=M}if((J&1)==0){_=Y;$=Z;break}Lw(c[m+8>>2]|0);_=Y;$=Z}else{z=0;x=53}}while(0);if((x|0)==53){x=bT(-1,-1)|0;_=x;$=M}if((a[j+28|0]&1)!=0){Lw(c[j+36>>2]|0)}x=c[j+4>>2]|0;if((x|0)==0){r=_;s=$;t=r;u=0;v=t;w=s;bg(v|0)}Z=j+8|0;j=c[Z>>2]|0;if((x|0)!=(j|0)){c[Z>>2]=j+(~((j-4+(-x|0)|0)>>>2)<<2)}Lw(x);r=_;s=$;t=r;u=0;v=t;w=s;bg(v|0);return 0}function ql(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;g=i;i=i+168|0;h=g|0;j=g+16|0;k=g+24|0;l=g+88|0;m=g+104|0;n=g+120|0;o=g+136|0;p=g+152|0;q=Lu(16)|0;r=l+8|0;c[r>>2]=q;c[l>>2]=17;c[l+4>>2]=12;LF(q|0,11264,12)|0;a[q+12|0]=0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;z=0;aq(2,k|0,b|0,f|0,l|0,m|0);if(z){z=0;m=bT(-1,-1)|0;q=m;m=M;if((a[l]&1)==0){s=q;t=m;u=s;v=0;w=u;x=t;bg(w|0)}Lw(c[r>>2]|0);s=q;t=m;u=s;v=0;w=u;x=t;bg(w|0)}if((a[l]&1)!=0){Lw(c[r>>2]|0)}r=k+20|0;l=(z=0,au(66,c[r>>2]|0)|0);do{if(!z){m=(z=0,au(212,l|0)|0);if(z){z=0;y=53;break}if((m|0)==0){A=c[k+56>>2]|0;B=c[k+60>>2]|0}else{q=k+48|0;C=c[q>>2]|0;D=c[r>>2]|0;L16:do{if(D>>>0<m>>>0){E=D;F=0;while(1){G=a[E]|0;if((G<<24>>24|0)==10){H=F+1|0}else if((G<<24>>24|0)==0){I=F;break L16}else{H=F}G=E+1|0;if(G>>>0<m>>>0){E=G;F=H}else{I=H;break}}}else{I=0}}while(0);c[q>>2]=I+C;F=l;E=0;while(1){G=F-1|0;if(G>>>0<D>>>0){break}if((a[G]|0)==10){break}else{F=G;E=E+1|0}}F=k+40|0;if((I|0)!=0){c[F>>2]=1}D=c[F>>2]|0;c[k+52>>2]=D+E;C=m;q=l;c[F>>2]=C-q+E+D;D=k+56|0;c[D>>2]=q;c[D+4>>2]=C;c[r>>2]=m;A=l;B=m}C=B-A|0;if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;y=53;break}return 0}if(C>>>0<11>>>0){D=C<<1&255;a[n]=D;J=n+1|0;K=D}else{D=C+16&-16;q=(z=0,au(248,D|0)|0);if(z){z=0;y=53;break}c[n+8>>2]=q;F=D|1;c[n>>2]=F;c[n+4>>2]=C;J=q;K=F&255}LF(J|0,A|0,C)|0;a[J+C|0]=0;C=(z=0,au(122,k|0)|0);do{if(!z){F=(z=0,au(248,76)|0);if(z){z=0;y=54;break}q=F;c[j>>2]=q;F=f+4|0;D=c[F>>2]|0;if((D|0)==(c[f+8>>2]|0)){z=0;as(382,f|0,j|0);if(z){z=0;y=54;break}L=c[j>>2]|0}else{if((D|0)==0){N=0}else{c[D>>2]=q;N=c[F>>2]|0}c[F>>2]=N+4;L=q}q=L;D=L;G=(z=0,au(248,16)|0);do{if(!z){O=o+8|0;c[O>>2]=G;c[o>>2]=17;c[o+4>>2]=12;LF(G|0,11264,12)|0;a[G+12|0]=0;L54:do{if((K&1)==0){P=n;Q=p;c[Q>>2]=c[P>>2];c[Q+4>>2]=c[P+4>>2];c[Q+8>>2]=c[P+8>>2];y=44}else{P=c[n+8>>2]|0;Q=c[n+4>>2]|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Q>>>0<11>>>0){a[p]=Q<<1;R=p+1|0}else{S=Q+16&-16;T=(z=0,au(248,S|0)|0);if(z){z=0;break}c[p+8>>2]=T;c[p>>2]=S|1;c[p+4>>2]=Q;R=T}LF(R|0,P|0,Q)|0;a[R+Q|0]=0;y=44;break L54}}while(0);Q=bT(-1,-1)|0;U=Q;V=M}}while(0);do{if((y|0)==44){c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;z=0;aL(6,D|0,o|0,h|0,b|0,p|0,C|0,d|0,e|0,0,0);if(z){z=0;Q=bT(-1,-1)|0;P=Q;Q=M;if((a[p]&1)==0){U=P;V=Q;break}Lw(c[p+8>>2]|0);U=P;V=Q;break}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if((a[o]&1)!=0){Lw(c[O>>2]|0)}if((K&1)!=0){Lw(c[n+8>>2]|0)}if((a[k+28|0]&1)!=0){Lw(c[k+36>>2]|0)}Q=c[k+4>>2]|0;if((Q|0)==0){i=g;return D|0}P=k+8|0;T=c[P>>2]|0;if((Q|0)!=(T|0)){c[P>>2]=T+(~((T-4+(-Q|0)|0)>>>2)<<2)}Lw(Q);i=g;return D|0}}while(0);if((a[o]&1)==0){W=U;X=V;break}Lw(c[O>>2]|0);W=U;X=V}else{z=0;Q=bT(-1,-1)|0;W=Q;X=M}}while(0);D=c[f>>2]|0;G=c[F>>2]|0;Q=D;while(1){if((Q|0)==(G|0)){Y=G;break}if((c[Q>>2]|0)==(L|0)){Y=Q;break}else{Q=Q+4|0}}Q=Y-D>>2;T=D+(Q+1<<2)|0;P=G-T|0;LG(D+(Q<<2)|0,T|0,P|0)|0;T=D+((P>>2)+Q<<2)|0;Q=c[F>>2]|0;if((T|0)!=(Q|0)){c[F>>2]=Q+(~((Q-4+(-T|0)|0)>>>2)<<2)}Lw(q);Z=W;_=X}else{z=0;y=54}}while(0);if((y|0)==54){C=bT(-1,-1)|0;Z=C;_=M}if((K&1)==0){$=Z;aa=_;break}Lw(c[n+8>>2]|0);$=Z;aa=_}else{z=0;y=53}}while(0);if((y|0)==53){y=bT(-1,-1)|0;$=y;aa=M}if((a[k+28|0]&1)!=0){Lw(c[k+36>>2]|0)}y=c[k+4>>2]|0;if((y|0)==0){s=$;t=aa;u=s;v=0;w=u;x=t;bg(w|0)}_=k+8|0;k=c[_>>2]|0;if((y|0)!=(k|0)){c[_>>2]=k+(~((k-4+(-y|0)|0)>>>2)<<2)}Lw(y);s=$;t=aa;u=s;v=0;w=u;x=t;bg(w|0);return 0}function qm(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;m=i;i=i+16|0;n=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=m|0;o=n;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+144|0;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=p;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=qn(b,d,e,f,p,l)|0;w=+h[u+40>>3];if(!(w<j|w>k)){i=m;return u|0}p=q+64|0;d=q|0;g=q+8|0;x=g|0;c[x>>2]=15464;y=q+12|0;c[d>>2]=32540;A=q+64|0;c[A>>2]=32560;c[q+4>>2]=0;z=0;as(198,q+64|0,y|0);do{if(!z){c[q+136>>2]=0;c[q+140>>2]=-1;B=q+8|0;c[d>>2]=15444;c[p>>2]=15484;c[x>>2]=15464;C=y|0;c[C>>2]=15768;D=q+16|0;I_(D);LI(q+20|0,0,24)|0;c[C>>2]=15624;E=q+44|0;LI(q+44|0,0,16)|0;c[q+60>>2]=24;LI(o|0,0,12)|0;z=0;as(212,y|0,n|0);if(z){z=0;F=bT(-1,-1)|0;G=M;if((a[o]&1)!=0){Lw(c[n+8>>2]|0)}if((a[E]&1)!=0){Lw(c[q+52>>2]|0)}c[C>>2]=15768;z=0;ar(394,D|0);if(!z){H=F;I=G;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}if((a[o]&1)!=0){Lw(c[n+8>>2]|0)}G=g;F=(z=0,aM(114,G|0,9104)|0);do{if(!z){C=(z=0,aM(814,F|0,b|0)|0);if(z){z=0;J=47;break}K=(z=0,aM(114,C|0,7312)|0);if(z){z=0;J=47;break}C=(z=0,aM(114,K|0,e|0)|0);if(z){z=0;J=47;break}z=0,aM(114,C|0,5800)|0;if(z){z=0;J=47;break}C=(z=0,aH(2,G|0,+j)|0);if(z){z=0;J=47;break}K=(z=0,aM(114,C|0,4736)|0);if(z){z=0;J=47;break}z=0,aH(2,K|0,+k)|0;if(z){z=0;J=47;break}z=0;as(576,r|0,y|0);if(z){z=0;J=47;break}K=f;L29:do{if((a[K]&1)==0){C=s;c[C>>2]=c[K>>2];c[C+4>>2]=c[K+4>>2];c[C+8>>2]=c[K+8>>2];J=35}else{C=c[f+8>>2]|0;L=c[f+4>>2]|0;do{if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(L>>>0<11>>>0){a[s]=L<<1;N=s+1|0}else{O=L+16&-16;P=(z=0,au(248,O|0)|0);if(z){z=0;break}c[s+8>>2]=P;c[s>>2]=O|1;c[s+4>>2]=L;N=P}LF(N|0,C|0,L)|0;a[N+L|0]=0;J=35;break L29}}while(0);L=bT(-1,-1)|0;Q=M;R=L}}while(0);do{if((J|0)==35){K=t;c[K>>2]=c[v>>2];c[K+4>>2]=c[v+4>>2];c[K+8>>2]=c[v+8>>2];z=0;aV(46,r|0,s|0,t|0,l|0);if(z){z=0;K=bT(-1,-1)|0;L=K;K=M;if((a[s]&1)==0){Q=K;R=L;break}Lw(c[s+8>>2]|0);Q=K;R=L;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}c[d>>2]=15444;c[A>>2]=15484;c[B>>2]=15464;L=q+12|0;c[L>>2]=15624;if((a[E]&1)!=0){Lw(c[q+52>>2]|0)}c[L>>2]=15768;z=0;ar(394,D|0);if(!z){Ex(q+64|0);i=m;return u|0}else{z=0}L=bT(-1,-1)|0;z=0;ar(272,q+64|0);if(!z){bg(L|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);if((a[r]&1)==0){S=Q;T=R;break}Lw(c[r+8>>2]|0);S=Q;T=R}else{z=0;J=47}}while(0);if((J|0)==47){G=bT(-1,-1)|0;S=M;T=G}c[d>>2]=15444;c[A>>2]=15484;c[B>>2]=15464;G=q+12|0;c[G>>2]=15624;if((a[E]&1)!=0){Lw(c[q+52>>2]|0)}c[G>>2]=15768;z=0;ar(394,D|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,q+64|0);if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}z=0;ar(272,q+64|0);if(!z){bg(T|0)}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;G=bT(-1,-1)|0;H=G;I=M}}while(0);z=0;ar(272,p|0);if(!z){bg(H|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function qn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=Lu(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}LF(t|0,r|0,s)|0;a[t+s|0]=0}s=(z=0,aM(90,d|0,k|0)|0);if(z){z=0;d=bT(-1,-1)|0;t=d;d=M;if((a[k]&1)==0){w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[k+8>>2]|0);w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=Lh(t,31184,31368,-1)|0}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;LF(k+1|0,9104,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}z=0,az(88,l|0,E|0,F|0)|0;do{if(!z){z=0,az(88,l|0,7312,6)|0;if(z){z=0;G=57;break}F=LJ(e|0)|0;z=0,az(88,l|0,e|0,F|0)|0;if(z){z=0;G=57;break}z=0,az(88,l|0,11048,12)|0;if(z){z=0;G=57;break}F=m;E=m;a[E]=12;b=F+1|0;a[b]=a[10904]|0;a[b+1|0]=a[10905]|0;a[b+2|0]=a[10906]|0;a[b+3|0]=a[10907]|0;a[b+4|0]=a[10908]|0;a[b+5|0]=a[10909]|0;a[F+7|0]=0;z=0,az(88,l|0,b|0,6)|0;if(z){z=0;b=bT(-1,-1)|0;F=b;b=M;if((a[E]&1)==0){H=b;I=F;break}Lw(c[m+8>>2]|0);H=b;I=F;break}if((a[E]&1)!=0){Lw(c[m+8>>2]|0)}if((a[t]&1)==0){E=n;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2]}else{E=c[l+8>>2]|0;F=c[l+4>>2]|0;if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=57;break}return 0}if(F>>>0<11>>>0){a[n]=F<<1;J=n+1|0}else{b=F+16&-16;q=(z=0,au(248,b|0)|0);if(z){z=0;G=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=F;J=q}LF(J|0,E|0,F)|0;a[J+F|0]=0}F=f;L61:do{if((a[F]&1)==0){E=o;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];G=50}else{E=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;K=o+1|0}else{b=q+16&-16;k=(z=0,au(248,b|0)|0);if(z){z=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;K=k}LF(K|0,E|0,q)|0;a[K+q|0]=0;G=50;break L61}}while(0);q=bT(-1,-1)|0;L=M;N=q}}while(0);do{if((G|0)==50){F=p;q=g;c[F>>2]=c[q>>2];c[F+4>>2]=c[q+4>>2];c[F+8>>2]=c[q+8>>2];z=0;aV(46,n|0,o|0,p|0,h|0);if(z){z=0;q=bT(-1,-1)|0;F=q;q=M;if((a[o]&1)==0){L=q;N=F;break}Lw(c[o+8>>2]|0);L=q;N=F;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}Lw(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=L;I=N;break}Lw(c[n+8>>2]|0);H=L;I=N}else{z=0;G=57}}while(0);if((G|0)==57){G=bT(-1,-1)|0;H=M;I=G}if((a[t]&1)==0){w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[l+8>>2]|0);w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0);return 0}function qo(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;k=i;i=i+168|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=k+152|0;w=Lu(88)|0;c[m>>2]=w;x=d+4|0;y=c[x>>2]|0;if((y|0)==(c[d+8>>2]|0)){e4(d|0,m);A=c[m>>2]|0}else{if((y|0)==0){B=0}else{c[y>>2]=w;B=c[x>>2]|0}c[x>>2]=B+4;A=w}w=A;B=A;y=f;L8:do{if((a[y]&1)==0){m=n;c[m>>2]=c[y>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];C=16}else{m=c[f+8>>2]|0;D=c[f+4>>2]|0;do{if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(D>>>0<11>>>0){a[n]=D<<1;F=n+1|0}else{G=D+16&-16;H=(z=0,au(248,G|0)|0);if(z){z=0;break}c[n+8>>2]=H;c[n>>2]=G|1;c[n+4>>2]=D;F=H}LF(F|0,m|0,D)|0;a[F+D|0]=0;C=16;break L8}}while(0);D=bT(-1,-1)|0;I=M;J=D}}while(0);do{if((C|0)==16){F=o;y=g;c[F>>2]=c[y>>2];c[F+4>>2]=c[y+4>>2];c[F+8>>2]=c[y+8>>2];D=p;m=p;a[m]=8;H=D+1|0;E=1684369956;a[H]=E;E=E>>8;a[H+1|0]=E;E=E>>8;a[H+2|0]=E;E=E>>8;a[H+3|0]=E;a[D+5|0]=0;D=q;c[D>>2]=c[y>>2];c[D+4>>2]=c[y+4>>2];c[D+8>>2]=c[y+8>>2];D=(z=0,ap(2,p|0,b|0,e|0,f|0,q|0,+0.0,+255.0,j|0)|0);do{if(!z){K=+h[D+40>>3];H=r;G=r;a[G]=12;L=H+1|0;a[L]=a[1176]|0;a[L+1|0]=a[1177]|0;a[L+2|0]=a[1178]|0;a[L+3|0]=a[1179]|0;a[L+4|0]=a[1180]|0;a[L+5|0]=a[1181]|0;a[H+7|0]=0;H=s;c[H>>2]=c[y>>2];c[H+4>>2]=c[y+4>>2];c[H+8>>2]=c[y+8>>2];H=(z=0,ap(2,r|0,b|0,e|0,f|0,s|0,+0.0,+255.0,j|0)|0);do{if(!z){N=+h[H+40>>3];L=t;O=t;a[O]=10;P=L+1|0;a[P]=a[520]|0;a[P+1|0]=a[521]|0;a[P+2|0]=a[522]|0;a[P+3|0]=a[523]|0;a[P+4|0]=a[524]|0;a[L+6|0]=0;L=u;c[L>>2]=c[y>>2];c[L+4>>2]=c[y+4>>2];c[L+8>>2]=c[y+8>>2];L=(z=0,ap(2,t|0,b|0,e|0,f|0,u|0,+0.0,+255.0,j|0)|0);do{if(!z){Q=+h[L+40>>3];P=v;a[P]=0;a[v+1|0]=0;R=l;c[R>>2]=c[F>>2];c[R+4>>2]=c[F+4>>2];c[R+8>>2]=c[F+8>>2];z=0;av(2,B|0,n|0,l|0,+K,+N,+Q,+1.0,v|0);if(z){z=0;R=bT(-1,-1)|0;S=R;R=M;if((a[P]&1)==0){T=R;U=S;break}Lw(c[v+8>>2]|0);T=R;U=S;break}S=A;if((a[P]&1)!=0){Lw(c[v+8>>2]|0)}if((a[O]&1)!=0){Lw(c[t+8>>2]|0)}if((a[G]&1)!=0){Lw(c[r+8>>2]|0)}if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return S|0}Lw(c[n+8>>2]|0);i=k;return S|0}else{z=0;S=bT(-1,-1)|0;T=M;U=S}}while(0);if((a[O]&1)==0){V=T;W=U;break}Lw(c[t+8>>2]|0);V=T;W=U}else{z=0;L=bT(-1,-1)|0;V=M;W=L}}while(0);if((a[G]&1)==0){X=V;Y=W;break}Lw(c[r+8>>2]|0);X=V;Y=W}else{z=0;H=bT(-1,-1)|0;X=M;Y=H}}while(0);if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){I=X;J=Y;break}Lw(c[n+8>>2]|0);I=X;J=Y}}while(0);Y=c[d>>2]|0;d=c[x>>2]|0;X=Y;while(1){if((X|0)==(d|0)){Z=d;break}if((c[X>>2]|0)==(A|0)){Z=X;break}else{X=X+4|0}}X=Z-Y>>2;Z=Y+(X+1<<2)|0;A=d-Z|0;LG(Y+(X<<2)|0,Z|0,A|0)|0;Z=Y+((A>>2)+X<<2)|0;X=c[x>>2]|0;if((Z|0)==(X|0)){Lw(w);_=J;$=0;aa=_;ab=I;bg(aa|0)}c[x>>2]=X+(~((X-4+(-Z|0)|0)>>>2)<<2);Lw(w);_=J;$=0;aa=_;ab=I;bg(aa|0);return 0}function qp(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0.0,O=0,P=0.0,Q=0,R=0,S=0.0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0;k=i;i=i+200|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=k+152|0;w=k+168|0;x=k+184|0;y=Lu(88)|0;c[m>>2]=y;A=d+4|0;B=c[A>>2]|0;if((B|0)==(c[d+8>>2]|0)){e4(d|0,m);C=c[m>>2]|0}else{if((B|0)==0){D=0}else{c[B>>2]=y;D=c[A>>2]|0}c[A>>2]=D+4;C=y}y=C;D=C;B=f;L8:do{if((a[B]&1)==0){m=n;c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];F=16}else{m=c[f+8>>2]|0;G=c[f+4>>2]|0;do{if(G>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(G>>>0<11>>>0){a[n]=G<<1;H=n+1|0}else{I=G+16&-16;J=(z=0,au(248,I|0)|0);if(z){z=0;break}c[n+8>>2]=J;c[n>>2]=I|1;c[n+4>>2]=G;H=J}LF(H|0,m|0,G)|0;a[H+G|0]=0;F=16;break L8}}while(0);G=bT(-1,-1)|0;K=M;L=G}}while(0);do{if((F|0)==16){H=o;B=g;c[H>>2]=c[B>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];G=p;m=p;a[m]=8;J=G+1|0;E=1684369956;a[J]=E;E=E>>8;a[J+1|0]=E;E=E>>8;a[J+2|0]=E;E=E>>8;a[J+3|0]=E;a[G+5|0]=0;G=q;c[G>>2]=c[B>>2];c[G+4>>2]=c[B+4>>2];c[G+8>>2]=c[B+8>>2];G=(z=0,ap(2,p|0,b|0,e|0,f|0,q|0,+0.0,+255.0,j|0)|0);do{if(!z){N=+h[G+40>>3];J=r;I=r;a[I]=12;O=J+1|0;a[O]=a[1176]|0;a[O+1|0]=a[1177]|0;a[O+2|0]=a[1178]|0;a[O+3|0]=a[1179]|0;a[O+4|0]=a[1180]|0;a[O+5|0]=a[1181]|0;a[J+7|0]=0;J=s;c[J>>2]=c[B>>2];c[J+4>>2]=c[B+4>>2];c[J+8>>2]=c[B+8>>2];J=(z=0,ap(2,r|0,b|0,e|0,f|0,s|0,+0.0,+255.0,j|0)|0);do{if(!z){P=+h[J+40>>3];O=t;Q=t;a[Q]=10;R=O+1|0;a[R]=a[520]|0;a[R+1|0]=a[521]|0;a[R+2|0]=a[522]|0;a[R+3|0]=a[523]|0;a[R+4|0]=a[524]|0;a[O+6|0]=0;O=u;c[O>>2]=c[B>>2];c[O+4>>2]=c[B+4>>2];c[O+8>>2]=c[B+8>>2];O=(z=0,ap(2,t|0,b|0,e|0,f|0,u|0,+0.0,+255.0,j|0)|0);do{if(!z){S=+h[O+40>>3];R=v;T=v;a[T]=12;U=R+1|0;a[U]=a[11560]|0;a[U+1|0]=a[11561]|0;a[U+2|0]=a[11562]|0;a[U+3|0]=a[11563]|0;a[U+4|0]=a[11564]|0;a[U+5|0]=a[11565]|0;a[R+7|0]=0;R=w;c[R>>2]=c[B>>2];c[R+4>>2]=c[B+4>>2];c[R+8>>2]=c[B+8>>2];R=(z=0,ap(2,v|0,b|0,e|0,f|0,w|0,+0.0,+1.0,j|0)|0);do{if(!z){V=+h[R+40>>3];U=x;a[U]=0;a[x+1|0]=0;W=l;c[W>>2]=c[H>>2];c[W+4>>2]=c[H+4>>2];c[W+8>>2]=c[H+8>>2];z=0;av(2,D|0,n|0,l|0,+N,+P,+S,+V,x|0);if(z){z=0;W=bT(-1,-1)|0;X=W;W=M;if((a[U]&1)==0){Y=W;Z=X;break}Lw(c[x+8>>2]|0);Y=W;Z=X;break}X=C;if((a[U]&1)!=0){Lw(c[x+8>>2]|0)}if((a[T]&1)!=0){Lw(c[v+8>>2]|0)}if((a[Q]&1)!=0){Lw(c[t+8>>2]|0)}if((a[I]&1)!=0){Lw(c[r+8>>2]|0)}if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return X|0}Lw(c[n+8>>2]|0);i=k;return X|0}else{z=0;X=bT(-1,-1)|0;Y=M;Z=X}}while(0);if((a[T]&1)==0){_=Y;$=Z;break}Lw(c[v+8>>2]|0);_=Y;$=Z}else{z=0;R=bT(-1,-1)|0;_=M;$=R}}while(0);if((a[Q]&1)==0){aa=_;ab=$;break}Lw(c[t+8>>2]|0);aa=_;ab=$}else{z=0;O=bT(-1,-1)|0;aa=M;ab=O}}while(0);if((a[I]&1)==0){ac=aa;ad=ab;break}Lw(c[r+8>>2]|0);ac=aa;ad=ab}else{z=0;J=bT(-1,-1)|0;ac=M;ad=J}}while(0);if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){K=ac;L=ad;break}Lw(c[n+8>>2]|0);K=ac;L=ad}}while(0);ad=c[d>>2]|0;d=c[A>>2]|0;ac=ad;while(1){if((ac|0)==(d|0)){ae=d;break}if((c[ac>>2]|0)==(C|0)){ae=ac;break}else{ac=ac+4|0}}ac=ae-ad>>2;ae=ad+(ac+1<<2)|0;C=d-ae|0;LG(ad+(ac<<2)|0,ae|0,C|0)|0;ae=ad+((C>>2)+ac<<2)|0;ac=c[A>>2]|0;if((ae|0)==(ac|0)){Lw(y);af=L;ag=0;ah=af;ai=K;bg(ah|0)}c[A>>2]=ac+(~((ac-4+(-ae|0)|0)>>>2)<<2);Lw(y);af=L;ag=0;ah=af;ai=K;bg(ah|0);return 0}function qq(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=m;t=m;a[t]=12;u=s+1|0;a[u]=a[10768]|0;a[u+1|0]=a[10769]|0;a[u+2|0]=a[10770]|0;a[u+3|0]=a[10771]|0;a[u+4|0]=a[10772]|0;a[u+5|0]=a[10773]|0;a[s+7|0]=0;s=n;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(z=0,at(110,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(z){z=0;n=bT(-1,-1)|0;g=n;n=M;if((a[t]&1)==0){v=g;w=n;x=v;y=0;A=x;B=w;bg(A|0)}Lw(c[m+8>>2]|0);v=g;w=n;x=v;y=0;A=x;B=w;bg(A|0)}if((a[t]&1)!=0){Lw(c[m+8>>2]|0)}m=Lu(88)|0;c[l>>2]=m;t=d+4|0;n=c[t>>2]|0;if((n|0)==(c[d+8>>2]|0)){e4(d|0,l);C=c[l>>2]|0}else{if((n|0)==0){D=0}else{c[n>>2]=m;D=c[t>>2]|0}c[t>>2]=D+4;C=m}m=C;z=0;as(618,C|0,s|0);if(z){z=0;s=bT(-1,-1)|0;D=s;s=M;n=c[d>>2]|0;d=c[t>>2]|0;l=n;while(1){if((l|0)==(d|0)){E=d;break}if((c[l>>2]|0)==(C|0)){E=l;break}else{l=l+4|0}}l=E-n>>2;E=n+(l+1<<2)|0;g=d-E|0;LG(n+(l<<2)|0,E|0,g|0)|0;E=n+((g>>2)+l<<2)|0;l=c[t>>2]|0;if((E|0)!=(l|0)){c[t>>2]=l+(~((l-4+(-E|0)|0)>>>2)<<2)}Lw(m);v=D;w=s;x=v;y=0;A=x;B=w;bg(A|0)}s=o;D=o;a[D]=12;m=s+1|0;a[m]=a[11560]|0;a[m+1|0]=a[11561]|0;a[m+2|0]=a[11562]|0;a[m+3|0]=a[11563]|0;a[m+4|0]=a[11564]|0;a[m+5|0]=a[11565]|0;a[s+7|0]=0;s=p;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];u=(z=0,ap(2,o|0,b|0,e|0,f|0,p|0,+0.0,+1.0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;p=j;j=M;if((a[D]&1)==0){v=p;w=j;x=v;y=0;A=x;B=w;bg(A|0)}Lw(c[o+8>>2]|0);v=p;w=j;x=v;y=0;A=x;B=w;bg(A|0)}h[C+64>>3]=+h[u+40>>3];if((a[D]&1)!=0){Lw(c[o+8>>2]|0)}o=r;a[o]=0;a[r+1|0]=0;D=(z=0,aM(344,C+72|0,r|0)|0);do{if(!z){u=D;if((a[u]&1)==0){j=q;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];F=a[j]|0}else{j=c[D+8>>2]|0;u=c[D+4>>2]|0;if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(u>>>0<11>>>0){p=u<<1&255;a[q]=p;G=q+1|0;H=p}else{p=u+16&-16;f=(z=0,au(248,p|0)|0);if(z){z=0;break}c[q+8>>2]=f;e=p|1;c[q>>2]=e;c[q+4>>2]=u;G=f;H=e&255}LF(G|0,j|0,u)|0;a[G+u|0]=0;F=H}if((F&1)!=0){Lw(c[q+8>>2]|0)}if((a[o]&1)==0){I=C;i=k;return I|0}Lw(c[r+8>>2]|0);I=C;i=k;return I|0}else{z=0}}while(0);I=bT(-1,-1)|0;k=I;I=M;if((a[o]&1)==0){v=k;w=I;x=v;y=0;A=x;B=w;bg(A|0)}Lw(c[r+8>>2]|0);v=k;w=I;x=v;y=0;A=x;B=w;bg(A|0);return 0}function qr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=Lu(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}LF(t|0,r|0,s)|0;a[t+s|0]=0}s=(z=0,aM(90,d|0,k|0)|0);if(z){z=0;d=bT(-1,-1)|0;t=d;d=M;if((a[k]&1)==0){w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[k+8>>2]|0);w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=Lh(t,31184,31456,-1)|0}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;LF(k+1|0,9104,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}z=0,az(88,l|0,E|0,F|0)|0;do{if(!z){z=0,az(88,l|0,7312,6)|0;if(z){z=0;G=57;break}F=LJ(e|0)|0;z=0,az(88,l|0,e|0,F|0)|0;if(z){z=0;G=57;break}z=0,az(88,l|0,11048,12)|0;if(z){z=0;G=57;break}F=m;E=m;a[E]=10;b=F+1|0;a[b]=a[12168]|0;a[b+1|0]=a[12169]|0;a[b+2|0]=a[12170]|0;a[b+3|0]=a[12171]|0;a[b+4|0]=a[12172]|0;a[F+6|0]=0;z=0,az(88,l|0,b|0,5)|0;if(z){z=0;b=bT(-1,-1)|0;F=b;b=M;if((a[E]&1)==0){H=b;I=F;break}Lw(c[m+8>>2]|0);H=b;I=F;break}if((a[E]&1)!=0){Lw(c[m+8>>2]|0)}if((a[t]&1)==0){E=n;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2]}else{E=c[l+8>>2]|0;F=c[l+4>>2]|0;if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=57;break}return 0}if(F>>>0<11>>>0){a[n]=F<<1;J=n+1|0}else{b=F+16&-16;q=(z=0,au(248,b|0)|0);if(z){z=0;G=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=F;J=q}LF(J|0,E|0,F)|0;a[J+F|0]=0}F=f;L61:do{if((a[F]&1)==0){E=o;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];G=50}else{E=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;K=o+1|0}else{b=q+16&-16;k=(z=0,au(248,b|0)|0);if(z){z=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;K=k}LF(K|0,E|0,q)|0;a[K+q|0]=0;G=50;break L61}}while(0);q=bT(-1,-1)|0;L=M;N=q}}while(0);do{if((G|0)==50){F=p;q=g;c[F>>2]=c[q>>2];c[F+4>>2]=c[q+4>>2];c[F+8>>2]=c[q+8>>2];z=0;aV(46,n|0,o|0,p|0,h|0);if(z){z=0;q=bT(-1,-1)|0;F=q;q=M;if((a[o]&1)==0){L=q;N=F;break}Lw(c[o+8>>2]|0);L=q;N=F;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}Lw(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=L;I=N;break}Lw(c[n+8>>2]|0);H=L;I=N}else{z=0;G=57}}while(0);if((G|0)==57){G=bT(-1,-1)|0;H=M;I=G}if((a[t]&1)==0){w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[l+8>>2]|0);w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0);return 0}function qs(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=Lu(72)|0;c[m>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){e4(d|0,m);v=c[m>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){m=n;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];x=16}else{m=c[f+8>>2]|0;y=c[f+4>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[n]=y<<1;A=n+1|0}else{B=y+16&-16;C=(z=0,au(248,B|0)|0);if(z){z=0;break}c[n+8>>2]=C;c[n>>2]=B|1;c[n+4>>2]=y;A=C}LF(A|0,m|0,y)|0;a[A+y|0]=0;x=16;break L8}}while(0);y=bT(-1,-1)|0;D=M;E=y}}while(0);do{if((x|0)==16){A=o;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];y=p;m=p;a[m]=12;C=y+1|0;a[C]=a[10768]|0;a[C+1|0]=a[10769]|0;a[C+2|0]=a[10770]|0;a[C+3|0]=a[10771]|0;a[C+4|0]=a[10772]|0;a[C+5|0]=a[10773]|0;a[y+7|0]=0;y=q;c[y>>2]=c[u>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];u=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);do{if(!z){F=+h[u+40>>3];y=r;a[y]=0;a[r+1|0]=0;C=l;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];z=0;aG(2,w|0,n|0,l|0,+F,r|0);if(z){z=0;C=bT(-1,-1)|0;B=C;C=M;if((a[y]&1)==0){G=C;H=B;break}Lw(c[r+8>>2]|0);G=C;H=B;break}B=v;if((a[y]&1)!=0){Lw(c[r+8>>2]|0)}if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return B|0}Lw(c[n+8>>2]|0);i=k;return B|0}else{z=0;B=bT(-1,-1)|0;G=M;H=B}}while(0);if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){D=G;E=H;break}Lw(c[n+8>>2]|0);D=G;E=H}}while(0);H=c[d>>2]|0;d=c[t>>2]|0;G=H;while(1){if((G|0)==(d|0)){I=d;break}if((c[G>>2]|0)==(v|0)){I=G;break}else{G=G+4|0}}G=I-H>>2;I=H+(G+1<<2)|0;v=d-I|0;LG(H+(G<<2)|0,I|0,v|0)|0;I=H+((v>>2)+G<<2)|0;G=c[t>>2]|0;if((I|0)==(G|0)){Lw(s);J=E;K=0;L=J;N=D;bg(L|0)}c[t>>2]=G+(~((G-4+(-I|0)|0)>>>2)<<2);Lw(s);J=E;K=0;L=J;N=D;bg(L|0);return 0}function qt(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=Lu(72)|0;c[m>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){e4(d|0,m);v=c[m>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){m=n;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];x=16}else{m=c[f+8>>2]|0;y=c[f+4>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[n]=y<<1;A=n+1|0}else{B=y+16&-16;C=(z=0,au(248,B|0)|0);if(z){z=0;break}c[n+8>>2]=C;c[n>>2]=B|1;c[n+4>>2]=y;A=C}LF(A|0,m|0,y)|0;a[A+y|0]=0;x=16;break L8}}while(0);y=bT(-1,-1)|0;D=M;E=y}}while(0);do{if((x|0)==16){A=o;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];y=p;m=p;a[m]=12;C=y+1|0;a[C]=a[10768]|0;a[C+1|0]=a[10769]|0;a[C+2|0]=a[10770]|0;a[C+3|0]=a[10771]|0;a[C+4|0]=a[10772]|0;a[C+5|0]=a[10773]|0;a[y+7|0]=0;y=q;c[y>>2]=c[u>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];u=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);do{if(!z){F=+h[u+48>>3];y=r;a[y]=0;a[r+1|0]=0;C=l;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];z=0;aG(2,w|0,n|0,l|0,+F,r|0);if(z){z=0;C=bT(-1,-1)|0;B=C;C=M;if((a[y]&1)==0){G=C;H=B;break}Lw(c[r+8>>2]|0);G=C;H=B;break}B=v;if((a[y]&1)!=0){Lw(c[r+8>>2]|0)}if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return B|0}Lw(c[n+8>>2]|0);i=k;return B|0}else{z=0;B=bT(-1,-1)|0;G=M;H=B}}while(0);if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){D=G;E=H;break}Lw(c[n+8>>2]|0);D=G;E=H}}while(0);H=c[d>>2]|0;d=c[t>>2]|0;G=H;while(1){if((G|0)==(d|0)){I=d;break}if((c[G>>2]|0)==(v|0)){I=G;break}else{G=G+4|0}}G=I-H>>2;I=H+(G+1<<2)|0;v=d-I|0;LG(H+(G<<2)|0,I|0,v|0)|0;I=H+((v>>2)+G<<2)|0;G=c[t>>2]|0;if((I|0)==(G|0)){Lw(s);J=E;K=0;L=J;N=D;bg(L|0)}c[t>>2]=G+(~((G-4+(-I|0)|0)>>>2)<<2);Lw(s);J=E;K=0;L=J;N=D;bg(L|0);return 0}function qu(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=Lu(72)|0;c[m>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){e4(d|0,m);v=c[m>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){m=n;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];x=16}else{m=c[f+8>>2]|0;y=c[f+4>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[n]=y<<1;A=n+1|0}else{B=y+16&-16;C=(z=0,au(248,B|0)|0);if(z){z=0;break}c[n+8>>2]=C;c[n>>2]=B|1;c[n+4>>2]=y;A=C}LF(A|0,m|0,y)|0;a[A+y|0]=0;x=16;break L8}}while(0);y=bT(-1,-1)|0;D=M;E=y}}while(0);do{if((x|0)==16){A=o;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];y=p;m=p;a[m]=12;C=y+1|0;a[C]=a[10768]|0;a[C+1|0]=a[10769]|0;a[C+2|0]=a[10770]|0;a[C+3|0]=a[10771]|0;a[C+4|0]=a[10772]|0;a[C+5|0]=a[10773]|0;a[y+7|0]=0;y=q;c[y>>2]=c[u>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];u=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);do{if(!z){F=+h[u+56>>3];y=r;a[y]=0;a[r+1|0]=0;C=l;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];z=0;aG(2,w|0,n|0,l|0,+F,r|0);if(z){z=0;C=bT(-1,-1)|0;B=C;C=M;if((a[y]&1)==0){G=C;H=B;break}Lw(c[r+8>>2]|0);G=C;H=B;break}B=v;if((a[y]&1)!=0){Lw(c[r+8>>2]|0)}if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return B|0}Lw(c[n+8>>2]|0);i=k;return B|0}else{z=0;B=bT(-1,-1)|0;G=M;H=B}}while(0);if((a[m]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)==0){D=G;E=H;break}Lw(c[n+8>>2]|0);D=G;E=H}}while(0);H=c[d>>2]|0;d=c[t>>2]|0;G=H;while(1){if((G|0)==(d|0)){I=d;break}if((c[G>>2]|0)==(v|0)){I=G;break}else{G=G+4|0}}G=I-H>>2;I=H+(G+1<<2)|0;v=d-I|0;LG(H+(G<<2)|0,I|0,v|0)|0;I=H+((v>>2)+G<<2)|0;G=c[t>>2]|0;if((I|0)==(G|0)){Lw(s);J=E;K=0;L=J;N=D;bg(L|0)}c[t>>2]=G+(~((G-4+(-I|0)|0)>>>2)<<2);Lw(s);J=E;K=0;L=J;N=D;bg(L|0);return 0}function qv(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0;k=i;i=i+152|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=n;w=n;a[w]=16;x=v+1|0;y=x|0;E=1819239204;a[y]=E;E=E>>8;a[y+1|0]=E;E=E>>8;a[y+2|0]=E;E=E>>8;a[y+3|0]=E;y=x+4|0;E=825061999;a[y]=E;E=E>>8;a[y+1|0]=E;E=E>>8;a[y+2|0]=E;E=E>>8;a[y+3|0]=E;a[v+9|0]=0;v=o;y=g;c[v>>2]=c[y>>2];c[v+4>>2]=c[y+4>>2];c[v+8>>2]=c[y+8>>2];v=(z=0,at(110,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;o=bT(-1,-1)|0;g=o;o=M;if((a[w]&1)==0){A=g;B=o;C=A;D=0;F=C;G=B;bg(F|0)}Lw(c[n+8>>2]|0);A=g;B=o;C=A;D=0;F=C;G=B;bg(F|0)}if((a[w]&1)!=0){Lw(c[n+8>>2]|0)}n=p;w=p;a[w]=16;o=n+1|0;g=o|0;E=1819239204;a[g]=E;E=E>>8;a[g+1|0]=E;E=E>>8;a[g+2|0]=E;E=E>>8;a[g+3|0]=E;g=o+4|0;E=841839215;a[g]=E;E=E>>8;a[g+1|0]=E;E=E>>8;a[g+2|0]=E;E=E>>8;a[g+3|0]=E;a[n+9|0]=0;n=q;c[n>>2]=c[y>>2];c[n+4>>2]=c[y+4>>2];c[n+8>>2]=c[y+8>>2];n=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(z){z=0;q=bT(-1,-1)|0;g=q;q=M;if((a[w]&1)==0){A=g;B=q;C=A;D=0;F=C;G=B;bg(F|0)}Lw(c[p+8>>2]|0);A=g;B=q;C=A;D=0;F=C;G=B;bg(F|0)}if((a[w]&1)!=0){Lw(c[p+8>>2]|0)}p=r;a[p]=14;w=r+1|0;a[w]=a[9440]|0;a[w+1|0]=a[9441]|0;a[w+2|0]=a[9442]|0;a[w+3|0]=a[9443]|0;a[w+4|0]=a[9444]|0;a[w+5|0]=a[9445]|0;a[w+6|0]=a[9446]|0;w=r+8|0;a[w]=0;q=s;c[q>>2]=c[y>>2];c[q+4>>2]=c[y+4>>2];c[q+8>>2]=c[y+8>>2];q=(z=0,ap(2,r|0,b|0,e|0,f|0,s|0,+0.0,+100.0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;s=j;j=M;if((a[p]&1)==0){A=s;B=j;C=A;D=0;F=C;G=B;bg(F|0)}Lw(c[w>>2]|0);A=s;B=j;C=A;D=0;F=C;G=B;bg(F|0)}if((a[p]&1)!=0){Lw(c[w>>2]|0)}H=+h[q+40>>3]/100.0;I=H*2.0+-1.0;q=v+64|0;w=n+64|0;J=+h[q>>3]- +h[w>>3];K=I*J;if(K==-1.0){L=I}else{L=(I+J)/(K+1.0)}K=(L+1.0)*.5;L=1.0-K;p=Lu(88)|0;c[m>>2]=p;j=d+4|0;s=c[j>>2]|0;if((s|0)==(c[d+8>>2]|0)){e4(d|0,m);N=c[m>>2]|0}else{if((s|0)==0){O=0}else{c[s>>2]=p;O=c[j>>2]|0}c[j>>2]=O+4;N=p}p=N;O=N;s=f;L41:do{if((a[s]&1)==0){m=t;c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];P=27}else{m=c[f+8>>2]|0;e=c[f+4>>2]|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(e>>>0<11>>>0){a[t]=e<<1;Q=t+1|0}else{b=e+16&-16;r=(z=0,au(248,b|0)|0);if(z){z=0;break}c[t+8>>2]=r;c[t>>2]=b|1;c[t+4>>2]=e;Q=r}LF(Q|0,m|0,e)|0;a[Q+e|0]=0;P=27;break L41}}while(0);e=bT(-1,-1)|0;R=e;S=M}}while(0);do{if((P|0)==27){Q=l;c[Q>>2]=c[y>>2];c[Q+4>>2]=c[y+4>>2];c[Q+8>>2]=c[y+8>>2];J=+W(K*+h[v+40>>3]+L*+h[n+40>>3]);I=+W(K*+h[v+48>>3]+L*+h[n+48>>3]);T=+W(K*+h[v+56>>3]+L*+h[n+56>>3]);U=H*+h[q>>3]+(1.0-H)*+h[w>>3];Q=u;a[Q]=0;a[u+1|0]=0;z=0;av(2,O|0,t|0,l|0,+J,+I,+T,+U,u|0);if(z){z=0;f=bT(-1,-1)|0;s=f;f=M;if((a[Q]&1)!=0){Lw(c[u+8>>2]|0)}if((a[t]&1)==0){R=s;S=f;break}Lw(c[t+8>>2]|0);R=s;S=f;break}f=N;if((a[Q]&1)!=0){Lw(c[u+8>>2]|0)}if((a[t]&1)==0){i=k;return f|0}Lw(c[t+8>>2]|0);i=k;return f|0}}while(0);k=c[d>>2]|0;d=c[j>>2]|0;t=k;while(1){if((t|0)==(d|0)){V=d;break}if((c[t>>2]|0)==(N|0)){V=t;break}else{t=t+4|0}}t=V-k>>2;V=k+(t+1<<2)|0;N=d-V|0;LG(k+(t<<2)|0,V|0,N|0)|0;V=k+((N>>2)+t<<2)|0;t=c[j>>2]|0;if((V|0)!=(t|0)){c[j>>2]=t+(~((t-4+(-V|0)|0)>>>2)<<2)}Lw(p);A=R;B=S;C=A;D=0;F=C;G=B;bg(F|0);return 0}function qw(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0.0,f=0.0,g=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;e=b/255.0;b=c/255.0;c=d/255.0;d=b<c?c:b;f=e<d?d:e;d=c<b?c:b;g=d<e?d:e;d=f-g;i=f+g;j=i*.5;L1:do{if(f==g){k=0.0;l=0.0}else{if(j<.5){m=i}else{m=2.0-f-g}n=d/m;o=d*.5;p=(o+(f-e)/6.0)/d;q=(o+(f-b)/6.0)/d;r=(o+(f-c)/6.0)/d;do{if(e==f){s=r-q}else{if(b==f){s=p+.3333333333333333-r;break}if(c!=f){k=0.0;l=n;break L1}s=q+.6666666666666666-p}}while(0);if(s<0.0){k=s+1.0;l=n;break}if(s<=1.0){k=s;l=n;break}k=s+-1.0;l=n}}while(0);h[a>>3]=+((~~(k*360.0)|0)%360|0|0);h[a+8>>3]=l*100.0;h[a+16>>3]=j*100.0;return}function qx(b,d,e,f,g,h,j){b=+b;d=+d;e=+e;f=+f;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+56|0;l=j;j=i;i=i+12|0;i=i+7&-8;c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=+((((~~b|0)%360|0)+360|0)%360|0|0)/360.0;b=d/100.0;d=e/100.0;if(d>.5){q=b+d-b*d}else{q=d*(b+1.0)}b=d*2.0-q;d=p+.3333333333333333;if(d<0.0){r=d+1.0}else{r=d}if(r>1.0){s=r+-1.0}else{s=r}do{if(s*6.0<1.0){t=b+(q-b)*s*6.0}else{if(s*2.0<1.0){t=q;break}if(s*3.0>=2.0){t=b;break}t=b+(q-b)*(.6666666666666666-s)*6.0}}while(0);s=t*255.0;if(p<0.0){u=p+1.0}else{u=p}if(u>1.0){v=u+-1.0}else{v=u}do{if(v*6.0<1.0){w=b+(q-b)*v*6.0}else{if(v*2.0<1.0){w=q;break}if(v*3.0>=2.0){w=b;break}w=b+(q-b)*(.6666666666666666-v)*6.0}}while(0);v=w*255.0;w=p+-.3333333333333333;if(w<0.0){x=w+1.0}else{x=w}if(x>1.0){y=x+-1.0}else{y=x}do{if(y*6.0<1.0){A=b+(q-b)*y*6.0}else{if(y*2.0<1.0){A=q;break}if(y*3.0>=2.0){A=b;break}A=b+(q-b)*(.6666666666666666-y)*6.0}}while(0);y=A*255.0;B=Lu(88)|0;c[m>>2]=B;C=g+4|0;D=c[C>>2]|0;if((D|0)==(c[g+8>>2]|0)){e4(g|0,m);E=c[m>>2]|0}else{if((D|0)==0){F=0}else{c[D>>2]=B;F=c[C>>2]|0}c[C>>2]=F+4;E=B}B=E;F=E;D=h;L48:do{if((a[D]&1)==0){m=n;c[m>>2]=c[D>>2];c[m+4>>2]=c[D+4>>2];c[m+8>>2]=c[D+8>>2];G=46}else{m=c[h+8>>2]|0;H=c[h+4>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[n]=H<<1;I=n+1|0}else{J=H+16&-16;K=(z=0,au(248,J|0)|0);if(z){z=0;break}c[n+8>>2]=K;c[n>>2]=J|1;c[n+4>>2]=H;I=K}LF(I|0,m|0,H)|0;a[I+H|0]=0;G=46;break L48}}while(0);H=bT(-1,-1)|0;L=M;N=H}}while(0);do{if((G|0)==46){I=j;h=l;c[h>>2]=c[I>>2];c[h+4>>2]=c[I+4>>2];c[h+8>>2]=c[I+8>>2];I=o;a[I]=0;a[o+1|0]=0;z=0;av(2,F|0,n|0,l|0,+s,+v,+y,+f,o|0);if(z){z=0;h=bT(-1,-1)|0;D=h;h=M;if((a[I]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)==0){L=h;N=D;break}Lw(c[n+8>>2]|0);L=h;N=D;break}if((a[I]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)==0){i=k;return F|0}Lw(c[n+8>>2]|0);i=k;return F|0}}while(0);F=c[g>>2]|0;g=c[C>>2]|0;k=F;while(1){if((k|0)==(g|0)){O=g;break}if((c[k>>2]|0)==(E|0)){O=k;break}else{k=k+4|0}}k=O-F>>2;O=F+(k+1<<2)|0;E=g-O|0;LG(F+(k<<2)|0,O|0,E|0)|0;O=F+((E>>2)+k<<2)|0;k=c[C>>2]|0;if((O|0)==(k|0)){Lw(B);P=N;Q=0;R=P;S=L;bg(R|0)}c[C>>2]=k+(~((k-4+(-O|0)|0)>>>2)<<2);Lw(B);P=N;Q=0;R=P;S=L;bg(R|0);return 0}function qy(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0,A=0,B=0.0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+80|0;r=k+96|0;s=l;t=l;a[t]=8;u=s+1|0;E=1702193188;a[u]=E;E=E>>8;a[u+1|0]=E;E=E>>8;a[u+2|0]=E;E=E>>8;a[u+3|0]=E;a[s+5|0]=0;s=m;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(z=0,at(44,l|0,b|0,e|0,f|0,m|0,j|0)|0);do{if(!z){v=+h[s+40>>3];m=(z=0,au(248,16)|0);if(z){z=0;w=13;break}g=n+8|0;c[g>>2]=m;c[n>>2]=17;c[n+4>>2]=11;LF(m|0,8904,11)|0;a[m+11|0]=0;m=o;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];m=(z=0,ap(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);do{if(!z){x=+h[m+40>>3];y=p;A=p;a[A]=20;LF(y+1|0,8776,10)|0;a[y+11|0]=0;y=q;c[y>>2]=c[u>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];y=(z=0,ap(2,p|0,b|0,e|0,f|0,q|0,+0.0,+100.0,j|0)|0);do{if(!z){B=+h[y+40>>3];C=r;c[C>>2]=c[u>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];C=(z=0,aw(2,+v,+x,+B,+1.0,d|0,f|0,r|0)|0);if(z){z=0;break}D=C|0;if((a[A]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)!=0){Lw(c[g>>2]|0)}if((a[t]&1)==0){i=k;return D|0}Lw(c[l+8>>2]|0);i=k;return D|0}else{z=0}}while(0);y=bT(-1,-1)|0;D=y;y=M;if((a[A]&1)==0){F=y;G=D;break}Lw(c[p+8>>2]|0);F=y;G=D}else{z=0;D=bT(-1,-1)|0;F=M;G=D}}while(0);if((a[n]&1)==0){H=F;I=G;break}Lw(c[g>>2]|0);H=F;I=G}else{z=0;w=13}}while(0);if((w|0)==13){w=bT(-1,-1)|0;H=M;I=w}if((a[t]&1)==0){J=I;K=0;L=J;N=H;bg(L|0)}Lw(c[l+8>>2]|0);J=I;K=0;L=J;N=H;bg(L|0);return 0}function qz(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,A=0.0,B=0,C=0,D=0.0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;k=i;i=i+144|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+80|0;r=k+96|0;s=k+112|0;t=k+128|0;u=l;v=l;a[v]=8;w=u+1|0;E=1702193188;a[w]=E;E=E>>8;a[w+1|0]=E;E=E>>8;a[w+2|0]=E;E=E>>8;a[w+3|0]=E;a[u+5|0]=0;u=m;w=g;c[u>>2]=c[w>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];u=(z=0,at(44,l|0,b|0,e|0,f|0,m|0,j|0)|0);do{if(!z){x=+h[u+40>>3];m=(z=0,au(248,16)|0);if(z){z=0;y=16;break}g=n+8|0;c[g>>2]=m;c[n>>2]=17;c[n+4>>2]=11;LF(m|0,8904,11)|0;a[m+11|0]=0;m=o;c[m>>2]=c[w>>2];c[m+4>>2]=c[w+4>>2];c[m+8>>2]=c[w+8>>2];m=(z=0,ap(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);do{if(!z){A=+h[m+40>>3];B=p;C=p;a[C]=20;LF(B+1|0,8776,10)|0;a[B+11|0]=0;B=q;c[B>>2]=c[w>>2];c[B+4>>2]=c[w+4>>2];c[B+8>>2]=c[w+8>>2];B=(z=0,ap(2,p|0,b|0,e|0,f|0,q|0,+0.0,+100.0,j|0)|0);do{if(!z){D=+h[B+40>>3];F=r;G=r;a[G]=12;H=F+1|0;a[H]=a[11560]|0;a[H+1|0]=a[11561]|0;a[H+2|0]=a[11562]|0;a[H+3|0]=a[11563]|0;a[H+4|0]=a[11564]|0;a[H+5|0]=a[11565]|0;a[F+7|0]=0;F=s;c[F>>2]=c[w>>2];c[F+4>>2]=c[w+4>>2];c[F+8>>2]=c[w+8>>2];F=(z=0,ap(2,r|0,b|0,e|0,f|0,s|0,+0.0,+1.0,j|0)|0);do{if(!z){I=+h[F+40>>3];H=t;c[H>>2]=c[w>>2];c[H+4>>2]=c[w+4>>2];c[H+8>>2]=c[w+8>>2];H=(z=0,aw(2,+x,+A,+D,+I,d|0,f|0,t|0)|0);if(z){z=0;break}J=H|0;if((a[G]&1)!=0){Lw(c[r+8>>2]|0)}if((a[C]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)!=0){Lw(c[g>>2]|0)}if((a[v]&1)==0){i=k;return J|0}Lw(c[l+8>>2]|0);i=k;return J|0}else{z=0}}while(0);F=bT(-1,-1)|0;J=F;F=M;if((a[G]&1)==0){K=F;L=J;break}Lw(c[r+8>>2]|0);K=F;L=J}else{z=0;J=bT(-1,-1)|0;K=M;L=J}}while(0);if((a[C]&1)==0){N=K;O=L;break}Lw(c[p+8>>2]|0);N=K;O=L}else{z=0;B=bT(-1,-1)|0;N=M;O=B}}while(0);if((a[n]&1)==0){P=N;Q=O;break}Lw(c[g>>2]|0);P=N;Q=O}else{z=0;y=16}}while(0);if((y|0)==16){y=bT(-1,-1)|0;P=M;Q=y}if((a[v]&1)==0){R=Q;S=0;T=R;U=P;bg(T|0)}Lw(c[l+8>>2]|0);R=Q;S=0;T=R;U=P;bg(T|0);return 0}function qA(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+80|0;r=k+96|0;s=n;t=n;a[t]=12;u=s+1|0;a[u]=a[10768]|0;a[u+1|0]=a[10769]|0;a[u+2|0]=a[10770]|0;a[u+3|0]=a[10771]|0;a[u+4|0]=a[10772]|0;a[u+5|0]=a[10773]|0;a[s+7|0]=0;s=o;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(z=0,at(110,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;o=j;j=M;if((a[t]&1)==0){v=j;w=o;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[n+8>>2]|0);v=j;w=o;x=w;y=0;A=x;B=v;bg(A|0)}if((a[t]&1)!=0){Lw(c[n+8>>2]|0)}qw(p,+h[s+40>>3],+h[s+48>>3],+h[s+56>>3]);s=Lu(72)|0;c[m>>2]=s;n=d+4|0;t=c[n>>2]|0;if((t|0)==(c[d+8>>2]|0)){e4(d|0,m);C=c[m>>2]|0}else{if((t|0)==0){D=0}else{c[t>>2]=s;D=c[n>>2]|0}c[n>>2]=D+4;C=s}s=C;D=C;t=f;L18:do{if((a[t]&1)==0){m=q;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];E=19}else{m=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[q]=o<<1;F=q+1|0}else{j=o+16&-16;e=(z=0,au(248,j|0)|0);if(z){z=0;break}c[q+8>>2]=e;c[q>>2]=j|1;c[q+4>>2]=o;F=e}LF(F|0,m|0,o)|0;a[F+o|0]=0;E=19;break L18}}while(0);o=bT(-1,-1)|0;G=M;H=o}}while(0);do{if((E|0)==19){F=l;c[F>>2]=c[u>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];I=+h[p>>3];F=r;a[F]=6;f=r+1|0;a[f]=a[8280]|0;a[f+1|0]=a[8281]|0;a[f+2|0]=a[8282]|0;a[r+4|0]=0;z=0;aG(2,D|0,q|0,l|0,+I,r|0);if(z){z=0;f=bT(-1,-1)|0;t=f;f=M;if((a[F]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){G=f;H=t;break}Lw(c[q+8>>2]|0);G=f;H=t;break}t=C;if((a[F]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){i=k;return t|0}Lw(c[q+8>>2]|0);i=k;return t|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;q=k;while(1){if((q|0)==(d|0)){J=d;break}if((c[q>>2]|0)==(C|0)){J=q;break}else{q=q+4|0}}q=J-k>>2;J=k+(q+1<<2)|0;C=d-J|0;LG(k+(q<<2)|0,J|0,C|0)|0;J=k+((C>>2)+q<<2)|0;q=c[n>>2]|0;if((J|0)!=(q|0)){c[n>>2]=q+(~((q-4+(-J|0)|0)>>>2)<<2)}Lw(s);v=G;w=H;x=w;y=0;A=x;B=v;bg(A|0);return 0}function qB(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+80|0;r=k+96|0;s=n;t=n;a[t]=12;u=s+1|0;a[u]=a[10768]|0;a[u+1|0]=a[10769]|0;a[u+2|0]=a[10770]|0;a[u+3|0]=a[10771]|0;a[u+4|0]=a[10772]|0;a[u+5|0]=a[10773]|0;a[s+7|0]=0;s=o;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(z=0,at(110,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;o=j;j=M;if((a[t]&1)==0){v=j;w=o;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[n+8>>2]|0);v=j;w=o;x=w;y=0;A=x;B=v;bg(A|0)}if((a[t]&1)!=0){Lw(c[n+8>>2]|0)}qw(p,+h[s+40>>3],+h[s+48>>3],+h[s+56>>3]);s=Lu(72)|0;c[m>>2]=s;n=d+4|0;t=c[n>>2]|0;if((t|0)==(c[d+8>>2]|0)){e4(d|0,m);C=c[m>>2]|0}else{if((t|0)==0){D=0}else{c[t>>2]=s;D=c[n>>2]|0}c[n>>2]=D+4;C=s}s=C;D=C;t=f;L18:do{if((a[t]&1)==0){m=q;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];E=19}else{m=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[q]=o<<1;F=q+1|0}else{j=o+16&-16;e=(z=0,au(248,j|0)|0);if(z){z=0;break}c[q+8>>2]=e;c[q>>2]=j|1;c[q+4>>2]=o;F=e}LF(F|0,m|0,o)|0;a[F+o|0]=0;E=19;break L18}}while(0);o=bT(-1,-1)|0;G=M;H=o}}while(0);do{if((E|0)==19){F=l;c[F>>2]=c[u>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];I=+h[p+8>>3];F=r;f=r;a[f]=2;a[F+1|0]=37;a[F+2|0]=0;z=0;aG(2,D|0,q|0,l|0,+I,r|0);if(z){z=0;F=bT(-1,-1)|0;t=F;F=M;if((a[f]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){G=F;H=t;break}Lw(c[q+8>>2]|0);G=F;H=t;break}t=C;if((a[f]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){i=k;return t|0}Lw(c[q+8>>2]|0);i=k;return t|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;q=k;while(1){if((q|0)==(d|0)){J=d;break}if((c[q>>2]|0)==(C|0)){J=q;break}else{q=q+4|0}}q=J-k>>2;J=k+(q+1<<2)|0;C=d-J|0;LG(k+(q<<2)|0,J|0,C|0)|0;J=k+((C>>2)+q<<2)|0;q=c[n>>2]|0;if((J|0)!=(q|0)){c[n>>2]=q+(~((q-4+(-J|0)|0)>>>2)<<2)}Lw(s);v=G;w=H;x=w;y=0;A=x;B=v;bg(A|0);return 0}function qC(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+80|0;r=k+96|0;s=n;t=n;a[t]=12;u=s+1|0;a[u]=a[10768]|0;a[u+1|0]=a[10769]|0;a[u+2|0]=a[10770]|0;a[u+3|0]=a[10771]|0;a[u+4|0]=a[10772]|0;a[u+5|0]=a[10773]|0;a[s+7|0]=0;s=o;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(z=0,at(110,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;o=j;j=M;if((a[t]&1)==0){v=j;w=o;x=w;y=0;A=x;B=v;bg(A|0)}Lw(c[n+8>>2]|0);v=j;w=o;x=w;y=0;A=x;B=v;bg(A|0)}if((a[t]&1)!=0){Lw(c[n+8>>2]|0)}qw(p,+h[s+40>>3],+h[s+48>>3],+h[s+56>>3]);s=Lu(72)|0;c[m>>2]=s;n=d+4|0;t=c[n>>2]|0;if((t|0)==(c[d+8>>2]|0)){e4(d|0,m);C=c[m>>2]|0}else{if((t|0)==0){D=0}else{c[t>>2]=s;D=c[n>>2]|0}c[n>>2]=D+4;C=s}s=C;D=C;t=f;L18:do{if((a[t]&1)==0){m=q;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];E=19}else{m=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[q]=o<<1;F=q+1|0}else{j=o+16&-16;e=(z=0,au(248,j|0)|0);if(z){z=0;break}c[q+8>>2]=e;c[q>>2]=j|1;c[q+4>>2]=o;F=e}LF(F|0,m|0,o)|0;a[F+o|0]=0;E=19;break L18}}while(0);o=bT(-1,-1)|0;G=M;H=o}}while(0);do{if((E|0)==19){F=l;c[F>>2]=c[u>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];I=+h[p+16>>3];F=r;f=r;a[f]=2;a[F+1|0]=37;a[F+2|0]=0;z=0;aG(2,D|0,q|0,l|0,+I,r|0);if(z){z=0;F=bT(-1,-1)|0;t=F;F=M;if((a[f]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){G=F;H=t;break}Lw(c[q+8>>2]|0);G=F;H=t;break}t=C;if((a[f]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){i=k;return t|0}Lw(c[q+8>>2]|0);i=k;return t|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;q=k;while(1){if((q|0)==(d|0)){J=d;break}if((c[q>>2]|0)==(C|0)){J=q;break}else{q=q+4|0}}q=J-k>>2;J=k+(q+1<<2)|0;C=d-J|0;LG(k+(q<<2)|0,J|0,C|0)|0;J=k+((C>>2)+q<<2)|0;q=c[n>>2]|0;if((J|0)!=(q|0)){c[n>>2]=q+(~((q-4+(-J|0)|0)>>>2)<<2)}Lw(s);v=G;w=H;x=w;y=0;A=x;B=v;bg(A|0);return 0}function qD(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0.0,C=0.0,D=0.0,F=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10768]|0;a[t+1|0]=a[10769]|0;a[t+2|0]=a[10770]|0;a[t+3|0]=a[10771]|0;a[t+4|0]=a[10772]|0;a[t+5|0]=a[10773]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(z=0,at(110,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(z){z=0;m=bT(-1,-1)|0;g=m;m=M;if((a[s]&1)==0){u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[l+8>>2]|0);u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}if((a[s]&1)!=0){Lw(c[l+8>>2]|0)}l=n;s=n;a[s]=16;m=l+1|0;g=m|0;E=1734698020;a[g]=E;E=E>>8;a[g+1|0]=E;E=E>>8;a[g+2|0]=E;E=E>>8;a[g+3|0]=E;g=m+4|0;E=1936024946;a[g]=E;E=E>>8;a[g+1|0]=E;E=E>>8;a[g+2|0]=E;E=E>>8;a[g+3|0]=E;a[l+9|0]=0;l=o;c[l>>2]=c[t>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];l=(z=0,at(44,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(!z){if((a[s]&1)!=0){Lw(c[n+8>>2]|0)}qw(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p>>3]+ +h[l+40>>3];C=+h[p+8>>3];D=+h[p+16>>3];F=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=qx(B,C,D,F,d,f,q)|0;i=k;return t|0}else{z=0}t=bT(-1,-1)|0;k=t;t=M;if((a[s]&1)==0){u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[n+8>>2]|0);u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0);return 0}function qE(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10768]|0;a[t+1|0]=a[10769]|0;a[t+2|0]=a[10770]|0;a[t+3|0]=a[10771]|0;a[t+4|0]=a[10772]|0;a[t+5|0]=a[10773]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(z=0,at(110,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(z){z=0;m=bT(-1,-1)|0;g=m;m=M;if((a[s]&1)==0){u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[l+8>>2]|0);u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}if((a[s]&1)!=0){Lw(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6720]|0;a[s+1|0]=a[6721]|0;a[s+2|0]=a[6722]|0;a[s+3|0]=a[6723]|0;a[s+4|0]=a[6724]|0;a[s+5|0]=a[6725]|0;a[s+6|0]=a[6726]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(z=0,ap(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!z){if((a[l]&1)!=0){Lw(c[s>>2]|0)}qw(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+16>>3];C=+h[p>>3];D=+h[p+8>>3];E=(B<0.0?0.0:B)+ +h[m+40>>3];B=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=qx(C,D,E,B,d,f,q)|0;i=k;return t|0}else{z=0}t=bT(-1,-1)|0;k=t;t=M;if((a[l]&1)==0){u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[s>>2]|0);u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0);return 0}function qF(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10768]|0;a[t+1|0]=a[10769]|0;a[t+2|0]=a[10770]|0;a[t+3|0]=a[10771]|0;a[t+4|0]=a[10772]|0;a[t+5|0]=a[10773]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(z=0,at(110,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(z){z=0;m=bT(-1,-1)|0;g=m;m=M;if((a[s]&1)==0){u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[l+8>>2]|0);u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}if((a[s]&1)!=0){Lw(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6720]|0;a[s+1|0]=a[6721]|0;a[s+2|0]=a[6722]|0;a[s+3|0]=a[6723]|0;a[s+4|0]=a[6724]|0;a[s+5|0]=a[6725]|0;a[s+6|0]=a[6726]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(z=0,ap(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!z){if((a[l]&1)!=0){Lw(c[s>>2]|0)}qw(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+16>>3];C=+h[p>>3];D=+h[p+8>>3];E=(B>100.0?100.0:B)- +h[m+40>>3];B=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=qx(C,D,E,B,d,f,q)|0;i=k;return t|0}else{z=0}t=bT(-1,-1)|0;k=t;t=M;if((a[l]&1)==0){u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[s>>2]|0);u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0);return 0}function qG(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10768]|0;a[t+1|0]=a[10769]|0;a[t+2|0]=a[10770]|0;a[t+3|0]=a[10771]|0;a[t+4|0]=a[10772]|0;a[t+5|0]=a[10773]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(z=0,at(110,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(z){z=0;m=bT(-1,-1)|0;g=m;m=M;if((a[s]&1)==0){u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[l+8>>2]|0);u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}if((a[s]&1)!=0){Lw(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6720]|0;a[s+1|0]=a[6721]|0;a[s+2|0]=a[6722]|0;a[s+3|0]=a[6723]|0;a[s+4|0]=a[6724]|0;a[s+5|0]=a[6725]|0;a[s+6|0]=a[6726]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(z=0,ap(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!z){if((a[l]&1)!=0){Lw(c[s>>2]|0)}qw(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+8>>3];C=+h[p>>3];D=(B<0.0?0.0:B)+ +h[m+40>>3];B=+h[p+16>>3];E=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=qx(C,D,B,E,d,f,q)|0;i=k;return t|0}else{z=0}t=bT(-1,-1)|0;k=t;t=M;if((a[l]&1)==0){u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[s>>2]|0);u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0);return 0}function qH(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10768]|0;a[t+1|0]=a[10769]|0;a[t+2|0]=a[10770]|0;a[t+3|0]=a[10771]|0;a[t+4|0]=a[10772]|0;a[t+5|0]=a[10773]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(z=0,at(110,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(z){z=0;m=bT(-1,-1)|0;g=m;m=M;if((a[s]&1)==0){u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[l+8>>2]|0);u=g;v=m;w=u;x=0;y=w;A=v;bg(y|0)}if((a[s]&1)!=0){Lw(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6720]|0;a[s+1|0]=a[6721]|0;a[s+2|0]=a[6722]|0;a[s+3|0]=a[6723]|0;a[s+4|0]=a[6724]|0;a[s+5|0]=a[6725]|0;a[s+6|0]=a[6726]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(z=0,ap(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!z){if((a[l]&1)!=0){Lw(c[s>>2]|0)}qw(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+8>>3];C=+h[p>>3];D=(B>100.0?100.0:B)- +h[m+40>>3];B=+h[p+16>>3];E=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=qx(C,D,B,E,d,f,q)|0;i=k;return t|0}else{z=0}t=bT(-1,-1)|0;k=t;t=M;if((a[l]&1)==0){u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0)}Lw(c[s>>2]|0);u=k;v=t;w=u;x=0;y=w;A=v;bg(y|0);return 0}function qI(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+56|0;p=l;q=l;a[q]=12;r=p+1|0;a[r]=a[10768]|0;a[r+1|0]=a[10769]|0;a[r+2|0]=a[10770]|0;a[r+3|0]=a[10771]|0;a[r+4|0]=a[10772]|0;a[r+5|0]=a[10773]|0;a[p+7|0]=0;p=m;r=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];p=(z=0,at(110,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(!z){if((a[q]&1)!=0){Lw(c[l+8>>2]|0)}qw(n,+h[p+40>>3],+h[p+48>>3],+h[p+56>>3]);s=+h[n>>3];t=+h[n+16>>3];u=+h[p+64>>3];p=o;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];r=qx(s,0.0,t,u,d,f,o)|0;i=k;return r|0}else{z=0}r=bT(-1,-1)|0;if((a[q]&1)==0){bg(r|0)}Lw(c[l+8>>2]|0);bg(r|0);return 0}function qJ(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+56|0;p=l;q=l;a[q]=12;r=p+1|0;a[r]=a[10768]|0;a[r+1|0]=a[10769]|0;a[r+2|0]=a[10770]|0;a[r+3|0]=a[10771]|0;a[r+4|0]=a[10772]|0;a[r+5|0]=a[10773]|0;a[p+7|0]=0;p=m;r=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];p=(z=0,at(110,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(!z){if((a[q]&1)!=0){Lw(c[l+8>>2]|0)}qw(n,+h[p+40>>3],+h[p+48>>3],+h[p+56>>3]);s=+h[n>>3]+-180.0;t=+h[n+8>>3];u=+h[n+16>>3];v=+h[p+64>>3];p=o;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];r=qx(s,t,u,v,d,f,o)|0;i=k;return r|0}else{z=0}r=bT(-1,-1)|0;if((a[q]&1)==0){bg(r|0)}Lw(c[l+8>>2]|0);bg(r|0);return 0}function qK(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0;k=i;i=i+88|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=n;s=n;a[s]=12;t=r+1|0;a[t]=a[10768]|0;a[t+1|0]=a[10769]|0;a[t+2|0]=a[10770]|0;a[t+3|0]=a[10771]|0;a[t+4|0]=a[10772]|0;a[t+5|0]=a[10773]|0;a[r+7|0]=0;r=o;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(z=0,at(110,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;o=j;j=M;if((a[s]&1)==0){u=j;v=o;w=v;x=0;y=w;A=u;bg(y|0)}Lw(c[n+8>>2]|0);u=j;v=o;w=v;x=0;y=w;A=u;bg(y|0)}if((a[s]&1)!=0){Lw(c[n+8>>2]|0)}n=Lu(88)|0;c[m>>2]=n;s=d+4|0;o=c[s>>2]|0;if((o|0)==(c[d+8>>2]|0)){e4(d|0,m);B=c[m>>2]|0}else{if((o|0)==0){C=0}else{c[o>>2]=n;C=c[s>>2]|0}c[s>>2]=C+4;B=n}n=B;C=B;o=f;L18:do{if((a[o]&1)==0){m=p;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];D=19}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[p]=j<<1;E=p+1|0}else{e=j+16&-16;b=(z=0,au(248,e|0)|0);if(z){z=0;break}c[p+8>>2]=b;c[p>>2]=e|1;c[p+4>>2]=j;E=b}LF(E|0,m|0,j)|0;a[E+j|0]=0;D=19;break L18}}while(0);j=bT(-1,-1)|0;F=M;G=j}}while(0);do{if((D|0)==19){E=l;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2];H=255.0- +h[r+40>>3];I=255.0- +h[r+48>>3];J=255.0- +h[r+56>>3];K=+h[r+64>>3];E=q;a[E]=0;a[q+1|0]=0;z=0;av(2,C|0,p|0,l|0,+H,+I,+J,+K,q|0);if(z){z=0;f=bT(-1,-1)|0;o=f;f=M;if((a[E]&1)!=0){Lw(c[q+8>>2]|0)}if((a[p]&1)==0){F=f;G=o;break}Lw(c[p+8>>2]|0);F=f;G=o;break}o=B;if((a[E]&1)!=0){Lw(c[q+8>>2]|0)}if((a[p]&1)==0){i=k;return o|0}Lw(c[p+8>>2]|0);i=k;return o|0}}while(0);k=c[d>>2]|0;d=c[s>>2]|0;p=k;while(1){if((p|0)==(d|0)){L=d;break}if((c[p>>2]|0)==(B|0)){L=p;break}else{p=p+4|0}}p=L-k>>2;L=k+(p+1<<2)|0;B=d-L|0;LG(k+(p<<2)|0,L|0,B|0)|0;L=k+((B>>2)+p<<2)|0;p=c[s>>2]|0;if((L|0)!=(p|0)){c[s>>2]=p+(~((p-4+(-L|0)|0)>>>2)<<2)}Lw(n);u=F;v=G;w=v;x=0;y=w;A=u;bg(y|0);return 0}function qL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,as=0,av=0,aw=0,ax=0,ay=0;k=i;i=i+224|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;x=k+176|0;y=k+192|0;A=k+208|0;B=p;C=p;a[C]=12;D=B+1|0;a[D]=a[10768]|0;a[D+1|0]=a[10769]|0;a[D+2|0]=a[10770]|0;a[D+3|0]=a[10771]|0;a[D+4|0]=a[10772]|0;a[D+5|0]=a[10773]|0;a[B+7|0]=0;B=(z=0,aM(90,b|0,p|0)|0);if(z){z=0;D=bT(-1,-1)|0;E=D;D=M;if((a[C]&1)==0){F=D;G=E;H=G;I=0;J=H;K=F;bg(J|0)}Lw(c[p+8>>2]|0);F=D;G=E;H=G;I=0;J=H;K=F;bg(J|0)}E=c[B>>2]|0;if((E|0)==0){L=0}else{L=Lh(E,31184,31840,-1)|0}if((a[C]&1)!=0){Lw(c[p+8>>2]|0)}if((L|0)==0){p=Lu(72)|0;c[m>>2]=p;C=d+4|0;E=c[C>>2]|0;if((E|0)==(c[d+8>>2]|0)){e4(d|0,m);N=c[m>>2]|0}else{if((E|0)==0){O=0}else{c[E>>2]=p;O=c[C>>2]|0}c[C>>2]=O+4;N=p}p=N;O=N;E=f;L23:do{if((a[E]&1)==0){m=v;c[m>>2]=c[E>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2];P=108}else{m=c[f+8>>2]|0;B=c[f+4>>2]|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(B>>>0<11>>>0){a[v]=B<<1;Q=v+1|0}else{D=B+16&-16;R=(z=0,au(248,D|0)|0);if(z){z=0;break}c[v+8>>2]=R;c[v>>2]=D|1;c[v+4>>2]=B;Q=R}LF(Q|0,m|0,B)|0;a[Q+B|0]=0;P=108;break L23}}while(0);B=bT(-1,-1)|0;S=M;T=B}}while(0);do{if((P|0)==108){Q=w;E=g;c[Q>>2]=c[E>>2];c[Q+4>>2]=c[E+4>>2];c[Q+8>>2]=c[E+8>>2];B=x;m=x;a[m]=12;R=B+1|0;a[R]=a[10768]|0;a[R+1|0]=a[10769]|0;a[R+2|0]=a[10770]|0;a[R+3|0]=a[10771]|0;a[R+4|0]=a[10772]|0;a[R+5|0]=a[10773]|0;a[B+7|0]=0;B=y;c[B>>2]=c[E>>2];c[B+4>>2]=c[E+4>>2];c[B+8>>2]=c[E+8>>2];E=(z=0,at(110,x|0,b|0,e|0,f|0,y|0,j|0)|0);do{if(!z){U=+h[E+64>>3];B=A;a[B]=0;a[A+1|0]=0;R=l;c[R>>2]=c[Q>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];z=0;aG(2,O|0,v|0,l|0,+U,A|0);if(z){z=0;R=bT(-1,-1)|0;D=R;R=M;if((a[B]&1)==0){V=R;W=D;break}Lw(c[A+8>>2]|0);V=R;W=D;break}if((a[B]&1)!=0){Lw(c[A+8>>2]|0)}if((a[m]&1)!=0){Lw(c[x+8>>2]|0)}if((a[v]&1)==0){X=p;Y=X;i=k;return Y|0}Lw(c[v+8>>2]|0);X=p;Y=X;i=k;return Y|0}else{z=0;B=bT(-1,-1)|0;V=M;W=B}}while(0);if((a[m]&1)!=0){Lw(c[x+8>>2]|0)}if((a[v]&1)==0){S=V;T=W;break}Lw(c[v+8>>2]|0);S=V;T=W}}while(0);W=c[d>>2]|0;V=c[C>>2]|0;v=W;while(1){if((v|0)==(V|0)){Z=V;break}if((c[v>>2]|0)==(N|0)){Z=v;break}else{v=v+4|0}}v=Z-W>>2;Z=W+(v+1<<2)|0;N=V-Z|0;LG(W+(v<<2)|0,Z|0,N|0)|0;Z=W+((N>>2)+v<<2)|0;v=c[C>>2]|0;if((Z|0)!=(v|0)){c[C>>2]=v+(~((v-4+(-Z|0)|0)>>>2)<<2)}Lw(p);F=S;G=T;H=G;I=0;J=H;K=F;bg(J|0)}T=Lu(52)|0;c[o>>2]=T;S=d+4|0;p=c[S>>2]|0;if((p|0)==(c[d+8>>2]|0)){e4(d|0,o);_=c[o>>2]|0}else{if((p|0)==0){$=0}else{c[p>>2]=T;$=c[S>>2]|0}c[S>>2]=$+4;_=T}T=_;$=_;p=f;L77:do{if((a[p]&1)==0){o=q;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];P=24}else{o=c[f+8>>2]|0;Z=c[f+4>>2]|0;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Z>>>0<11>>>0){a[q]=Z<<1;aa=q+1|0}else{v=Z+16&-16;C=(z=0,au(248,v|0)|0);if(z){z=0;break}c[q+8>>2]=C;c[q>>2]=v|1;c[q+4>>2]=Z;aa=C}LF(aa|0,o|0,Z)|0;a[aa+Z|0]=0;P=24;break L77}}while(0);Z=bT(-1,-1)|0;ab=Z;ac=M}}while(0);do{if((P|0)==24){aa=r;f=g;c[aa>>2]=c[f>>2];c[aa+4>>2]=c[f+4>>2];c[aa+8>>2]=c[f+8>>2];f=L+40|0;L92:do{if((a[f]&1)==0){p=u;c[p>>2]=c[f>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2];ad=a[p]|0;ae=p;P=34}else{p=c[L+48>>2]|0;Z=c[L+44>>2]|0;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Z>>>0<11>>>0){o=Z<<1&255;m=u;a[m]=o;af=u+1|0;ag=o;ah=m}else{m=Z+16&-16;o=(z=0,au(248,m|0)|0);if(z){z=0;break}c[u+8>>2]=o;C=m|1;c[u>>2]=C;c[u+4>>2]=Z;af=o;ag=C&255;ah=u}LF(af|0,p|0,Z)|0;a[af+Z|0]=0;ad=ag;ae=ah;P=34;break L92}}while(0);Z=bT(-1,-1)|0;ai=M;aj=Z}}while(0);do{if((P|0)==34){f=t;LI(f|0,0,12)|0;Z=u;p=ad&255;if((p&1|0)==0){ak=p>>>1}else{ak=c[u+4>>2]|0}p=ak+6|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;P=48;break}return 0}else{if(p>>>0<11>>>0){a[f]=12;al=t+1|0}else{C=ak+22&-16;o=(z=0,au(248,C|0)|0);if(z){z=0;P=48;break}c[t+8>>2]=o;c[t>>2]=C|1;c[t+4>>2]=6;al=o}a[al]=a[5704]|0;a[al+1|0]=a[5705]|0;a[al+2|0]=a[5706]|0;a[al+3|0]=a[5707]|0;a[al+4|0]=a[5708]|0;a[al+5|0]=a[5709]|0;a[al+6|0]=0;if((a[ae]&1)==0){am=Z+1|0}else{am=c[u+8>>2]|0}z=0,az(88,t|0,am|0,ak|0)|0;if(z){z=0;P=48;break}o=s;LI(o|0,0,12)|0;C=a[f]|0;m=C&255;if((m&1|0)==0){an=m>>>1}else{an=c[t+4>>2]|0}if((C&1)==0){ao=t+1|0}else{ao=c[t+8>>2]|0}C=an+1|0;do{if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;P=64;break}return 0}else{if(C>>>0<11>>>0){a[o]=an<<1;ap=s+1|0}else{m=an+17&-16;v=(z=0,au(248,m|0)|0);if(z){z=0;P=64;break}c[s+8>>2]=v;c[s>>2]=m|1;c[s+4>>2]=an;ap=v}LF(ap|0,ao|0,an)|0;a[ap+an|0]=0;z=0,az(88,s|0,5664,1)|0;if(z){z=0;P=64;break}v=n;c[v>>2]=c[aa>>2];c[v+4>>2]=c[aa+4>>2];c[v+8>>2]=c[aa+8>>2];z=0;aq(28,$|0,q|0,n|0,s|0,0);if(z){z=0;v=bT(-1,-1)|0;m=v;v=M;if((a[o]&1)==0){as=v;av=m;break}Lw(c[s+8>>2]|0);as=v;av=m;break}if((a[o]&1)!=0){Lw(c[s+8>>2]|0)}if((a[f]&1)!=0){Lw(c[t+8>>2]|0)}if((a[ae]&1)!=0){Lw(c[u+8>>2]|0)}if((a[q]&1)==0){X=T;Y=X;i=k;return Y|0}Lw(c[q+8>>2]|0);X=T;Y=X;i=k;return Y|0}}while(0);if((P|0)==64){C=bT(-1,-1)|0;m=M;if((a[o]&1)!=0){Lw(c[s+8>>2]|0)}as=m;av=C}if((a[f]&1)==0){aw=as;ax=av;break}Lw(c[t+8>>2]|0);aw=as;ax=av}}while(0);if((P|0)==48){Z=bT(-1,-1)|0;p=M;if((a[f]&1)!=0){Lw(c[t+8>>2]|0)}aw=p;ax=Z}if((a[ae]&1)==0){ai=aw;aj=ax;break}Lw(c[u+8>>2]|0);ai=aw;aj=ax}}while(0);if((a[q]&1)==0){ab=aj;ac=ai;break}Lw(c[q+8>>2]|0);ab=aj;ac=ai}}while(0);ai=c[d>>2]|0;d=c[S>>2]|0;aj=ai;while(1){if((aj|0)==(d|0)){ay=d;break}if((c[aj>>2]|0)==(_|0)){ay=aj;break}else{aj=aj+4|0}}aj=ay-ai>>2;ay=ai+(aj+1<<2)|0;_=d-ay|0;LG(ai+(aj<<2)|0,ay|0,_|0)|0;ay=ai+((_>>2)+aj<<2)|0;aj=c[S>>2]|0;if((ay|0)!=(aj|0)){c[S>>2]=aj+(~((aj-4+(-ay|0)|0)>>>2)<<2)}Lw(T);F=ac;G=ab;H=G;I=0;J=H;K=F;bg(J|0);return 0}function qM(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,N=0.0,O=0;k=i;i=i+120|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=n;u=n;a[u]=12;v=t+1|0;a[v]=a[10768]|0;a[v+1|0]=a[10769]|0;a[v+2|0]=a[10770]|0;a[v+3|0]=a[10771]|0;a[v+4|0]=a[10772]|0;a[v+5|0]=a[10773]|0;a[t+7|0]=0;t=o;v=g;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(z=0,at(110,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;o=bT(-1,-1)|0;g=o;o=M;if((a[u]&1)==0){w=g;x=o;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[n+8>>2]|0);w=g;x=o;y=w;A=0;B=y;C=x;bg(B|0)}if((a[u]&1)!=0){Lw(c[n+8>>2]|0)}D=+h[t+64>>3];n=p;a[n]=14;u=p+1|0;a[u]=a[6720]|0;a[u+1|0]=a[6721]|0;a[u+2|0]=a[6722]|0;a[u+3|0]=a[6723]|0;a[u+4|0]=a[6724]|0;a[u+5|0]=a[6725]|0;a[u+6|0]=a[6726]|0;u=p+8|0;a[u]=0;o=q;c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];o=(z=0,ap(2,p|0,b|0,e|0,f|0,q|0,+0.0,+1.0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;q=j;j=M;if((a[n]&1)==0){w=q;x=j;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[u>>2]|0);w=q;x=j;y=w;A=0;B=y;C=x;bg(B|0)}E=D+ +h[o+40>>3];if((a[n]&1)!=0){Lw(c[u>>2]|0)}u=Lu(88)|0;c[m>>2]=u;n=d+4|0;o=c[n>>2]|0;if((o|0)==(c[d+8>>2]|0)){e4(d|0,m);F=c[m>>2]|0}else{if((o|0)==0){G=0}else{c[o>>2]=u;G=c[n>>2]|0}c[n>>2]=G+4;F=u}u=F;G=F;o=f;L28:do{if((a[o]&1)==0){m=r;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];H=22}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[r]=j<<1;I=r+1|0}else{q=j+16&-16;e=(z=0,au(248,q|0)|0);if(z){z=0;break}c[r+8>>2]=e;c[r>>2]=q|1;c[r+4>>2]=j;I=e}LF(I|0,m|0,j)|0;a[I+j|0]=0;H=22;break L28}}while(0);j=bT(-1,-1)|0;J=j;K=M}}while(0);do{if((H|0)==22){I=l;c[I>>2]=c[v>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];D=+h[t+40>>3];L=+h[t+48>>3];N=+h[t+56>>3];I=s;a[I]=0;a[s+1|0]=0;z=0;av(2,G|0,r|0,l|0,+D,+L,+N,+(E>1.0?1.0:E),s|0);if(z){z=0;f=bT(-1,-1)|0;o=f;f=M;if((a[I]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)==0){J=o;K=f;break}Lw(c[r+8>>2]|0);J=o;K=f;break}f=F;if((a[I]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)==0){i=k;return f|0}Lw(c[r+8>>2]|0);i=k;return f|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;r=k;while(1){if((r|0)==(d|0)){O=d;break}if((c[r>>2]|0)==(F|0)){O=r;break}else{r=r+4|0}}r=O-k>>2;O=k+(r+1<<2)|0;F=d-O|0;LG(k+(r<<2)|0,O|0,F|0)|0;O=k+((F>>2)+r<<2)|0;r=c[n>>2]|0;if((O|0)!=(r|0)){c[n>>2]=r+(~((r-4+(-O|0)|0)>>>2)<<2)}Lw(u);w=J;x=K;y=w;A=0;B=y;C=x;bg(B|0);return 0}function qN(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,N=0.0,O=0;k=i;i=i+120|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=n;u=n;a[u]=12;v=t+1|0;a[v]=a[10768]|0;a[v+1|0]=a[10769]|0;a[v+2|0]=a[10770]|0;a[v+3|0]=a[10771]|0;a[v+4|0]=a[10772]|0;a[v+5|0]=a[10773]|0;a[t+7|0]=0;t=o;v=g;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(z=0,at(110,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;o=bT(-1,-1)|0;g=o;o=M;if((a[u]&1)==0){w=g;x=o;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[n+8>>2]|0);w=g;x=o;y=w;A=0;B=y;C=x;bg(B|0)}if((a[u]&1)!=0){Lw(c[n+8>>2]|0)}D=+h[t+64>>3];n=p;a[n]=14;u=p+1|0;a[u]=a[6720]|0;a[u+1|0]=a[6721]|0;a[u+2|0]=a[6722]|0;a[u+3|0]=a[6723]|0;a[u+4|0]=a[6724]|0;a[u+5|0]=a[6725]|0;a[u+6|0]=a[6726]|0;u=p+8|0;a[u]=0;o=q;c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];o=(z=0,ap(2,p|0,b|0,e|0,f|0,q|0,+0.0,+1.0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;q=j;j=M;if((a[n]&1)==0){w=q;x=j;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[u>>2]|0);w=q;x=j;y=w;A=0;B=y;C=x;bg(B|0)}E=D- +h[o+40>>3];if((a[n]&1)!=0){Lw(c[u>>2]|0)}u=Lu(88)|0;c[m>>2]=u;n=d+4|0;o=c[n>>2]|0;if((o|0)==(c[d+8>>2]|0)){e4(d|0,m);F=c[m>>2]|0}else{if((o|0)==0){G=0}else{c[o>>2]=u;G=c[n>>2]|0}c[n>>2]=G+4;F=u}u=F;G=F;o=f;L28:do{if((a[o]&1)==0){m=r;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];H=22}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[r]=j<<1;I=r+1|0}else{q=j+16&-16;e=(z=0,au(248,q|0)|0);if(z){z=0;break}c[r+8>>2]=e;c[r>>2]=q|1;c[r+4>>2]=j;I=e}LF(I|0,m|0,j)|0;a[I+j|0]=0;H=22;break L28}}while(0);j=bT(-1,-1)|0;J=j;K=M}}while(0);do{if((H|0)==22){I=l;c[I>>2]=c[v>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];D=+h[t+40>>3];L=+h[t+48>>3];N=+h[t+56>>3];I=s;a[I]=0;a[s+1|0]=0;z=0;av(2,G|0,r|0,l|0,+D,+L,+N,+(E<0.0?0.0:E),s|0);if(z){z=0;f=bT(-1,-1)|0;o=f;f=M;if((a[I]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)==0){J=o;K=f;break}Lw(c[r+8>>2]|0);J=o;K=f;break}f=F;if((a[I]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)==0){i=k;return f|0}Lw(c[r+8>>2]|0);i=k;return f|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;r=k;while(1){if((r|0)==(d|0)){O=d;break}if((c[r>>2]|0)==(F|0)){O=r;break}else{r=r+4|0}}r=O-k>>2;O=k+(r+1<<2)|0;F=d-O|0;LG(k+(r<<2)|0,O|0,F|0)|0;O=k+((F>>2)+r<<2)|0;r=c[n>>2]|0;if((O|0)!=(r|0)){c[n>>2]=r+(~((r-4+(-O|0)|0)>>>2)<<2)}Lw(u);w=J;x=K;y=w;A=0;B=y;C=x;bg(B|0);return 0}function qO(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0.0,an=0.0,ao=0.0,ap=0.0,aq=0.0,as=0.0,aw=0.0,ax=0.0,ay=0,az=0,aA=0.0,aB=0.0,aC=0.0,aD=0.0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0;k=i;i=i+424|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;x=k+176|0;y=k+192|0;A=k+208|0;B=k+224|0;C=k+240|0;D=k+256|0;F=k+272|0;G=k+288|0;H=k+312|0;I=k+328|0;J=k+344|0;K=k+360|0;L=k+376|0;N=k+392|0;O=k+408|0;P=p;Q=p;a[Q]=12;R=P+1|0;a[R]=a[10768]|0;a[R+1|0]=a[10769]|0;a[R+2|0]=a[10770]|0;a[R+3|0]=a[10771]|0;a[R+4|0]=a[10772]|0;a[R+5|0]=a[10773]|0;a[P+7|0]=0;P=q;R=g;c[P>>2]=c[R>>2];c[P+4>>2]=c[R+4>>2];c[P+8>>2]=c[R+8>>2];P=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;q=j;j=M;if((a[Q]&1)==0){S=q;T=j;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[p+8>>2]|0);S=q;T=j;U=S;V=0;W=U;X=T;bg(W|0)}if((a[Q]&1)!=0){Lw(c[p+8>>2]|0)}p=r;Q=r;a[Q]=8;j=p+1|0;E=1684369956;a[j]=E;E=E>>8;a[j+1|0]=E;E=E>>8;a[j+2|0]=E;E=E>>8;a[j+3|0]=E;a[p+5|0]=0;p=(z=0,aM(90,b|0,r|0)|0);if(z){z=0;j=bT(-1,-1)|0;q=j;j=M;if((a[Q]&1)==0){S=q;T=j;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[r+8>>2]|0);S=q;T=j;U=S;V=0;W=U;X=T;bg(W|0)}j=c[p>>2]|0;if((j|0)==0){Y=0}else{Y=Lh(j,31184,31368,-1)|0}if((a[Q]&1)!=0){Lw(c[r+8>>2]|0)}r=s;Q=s;a[Q]=12;j=r+1|0;a[j]=a[1176]|0;a[j+1|0]=a[1177]|0;a[j+2|0]=a[1178]|0;a[j+3|0]=a[1179]|0;a[j+4|0]=a[1180]|0;a[j+5|0]=a[1181]|0;a[r+7|0]=0;r=(z=0,aM(90,b|0,s|0)|0);if(z){z=0;j=bT(-1,-1)|0;p=j;j=M;if((a[Q]&1)==0){S=p;T=j;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[s+8>>2]|0);S=p;T=j;U=S;V=0;W=U;X=T;bg(W|0)}j=c[r>>2]|0;if((j|0)==0){Z=0}else{Z=Lh(j,31184,31368,-1)|0}if((a[Q]&1)!=0){Lw(c[s+8>>2]|0)}s=t;Q=t;a[Q]=10;j=s+1|0;a[j]=a[520]|0;a[j+1|0]=a[521]|0;a[j+2|0]=a[522]|0;a[j+3|0]=a[523]|0;a[j+4|0]=a[524]|0;a[s+6|0]=0;s=(z=0,aM(90,b|0,t|0)|0);if(z){z=0;j=bT(-1,-1)|0;r=j;j=M;if((a[Q]&1)==0){S=r;T=j;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[t+8>>2]|0);S=r;T=j;U=S;V=0;W=U;X=T;bg(W|0)}j=c[s>>2]|0;if((j|0)==0){_=0}else{_=Lh(j,31184,31368,-1)|0}if((a[Q]&1)!=0){Lw(c[t+8>>2]|0)}t=u;Q=u;a[Q]=8;j=t+1|0;E=1702193188;a[j]=E;E=E>>8;a[j+1|0]=E;E=E>>8;a[j+2|0]=E;E=E>>8;a[j+3|0]=E;a[t+5|0]=0;t=(z=0,aM(90,b|0,u|0)|0);if(z){z=0;j=bT(-1,-1)|0;s=j;j=M;if((a[Q]&1)==0){S=s;T=j;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[u+8>>2]|0);S=s;T=j;U=S;V=0;W=U;X=T;bg(W|0)}j=c[t>>2]|0;if((j|0)==0){$=0}else{$=Lh(j,31184,31368,-1)|0}if((a[Q]&1)!=0){Lw(c[u+8>>2]|0)}u=Lu(16)|0;Q=v+8|0;c[Q>>2]=u;c[v>>2]=17;c[v+4>>2]=11;LF(u|0,8904,11)|0;a[u+11|0]=0;u=(z=0,aM(90,b|0,v|0)|0);if(z){z=0;j=bT(-1,-1)|0;t=j;j=M;if((a[v]&1)==0){S=t;T=j;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[Q>>2]|0);S=t;T=j;U=S;V=0;W=U;X=T;bg(W|0)}j=c[u>>2]|0;if((j|0)==0){aa=0}else{aa=Lh(j,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[Q>>2]|0)}Q=w;v=w;a[v]=20;LF(Q+1|0,8776,10)|0;a[Q+11|0]=0;Q=(z=0,aM(90,b|0,w|0)|0);if(z){z=0;j=bT(-1,-1)|0;u=j;j=M;if((a[v]&1)==0){S=u;T=j;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[w+8>>2]|0);S=u;T=j;U=S;V=0;W=U;X=T;bg(W|0)}j=c[Q>>2]|0;if((j|0)==0){ab=0}else{ab=Lh(j,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[w+8>>2]|0)}w=x;v=x;a[v]=12;j=w+1|0;a[j]=a[11560]|0;a[j+1|0]=a[11561]|0;a[j+2|0]=a[11562]|0;a[j+3|0]=a[11563]|0;a[j+4|0]=a[11564]|0;a[j+5|0]=a[11565]|0;a[w+7|0]=0;w=(z=0,aM(90,b|0,x|0)|0);if(z){z=0;b=bT(-1,-1)|0;j=b;b=M;if((a[v]&1)==0){S=j;T=b;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[x+8>>2]|0);S=j;T=b;U=S;V=0;W=U;X=T;bg(W|0)}b=c[w>>2]|0;if((b|0)==0){ac=0}else{ac=Lh(b,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[x+8>>2]|0)}x=(Y|0)!=0;v=(Z|0)==0;b=(_|0)!=0|(x|v^1);w=($|0)!=0;j=(aa|0)==0;Q=(ab|0)!=0|(w|j^1);L102:do{if(b&Q){u=Lu(64)|0;t=y+8|0;c[t>>2]=u;c[y>>2]=65;c[y+4>>2]=57;LF(u|0,4976,57)|0;a[u+57|0]=0;u=f;L104:do{if((a[u]&1)==0){s=A;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];ad=66}else{s=c[f+8>>2]|0;r=c[f+4>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(r>>>0<11>>>0){a[A]=r<<1;ae=A+1|0}else{p=r+16&-16;q=(z=0,au(248,p|0)|0);if(z){z=0;break}c[A+8>>2]=q;c[A>>2]=p|1;c[A+4>>2]=r;ae=q}LF(ae|0,s|0,r)|0;a[ae+r|0]=0;ad=66;break L104}}while(0);r=bT(-1,-1)|0;af=r;ag=M}}while(0);do{if((ad|0)==66){u=B;c[u>>2]=c[R>>2];c[u+4>>2]=c[R+4>>2];c[u+8>>2]=c[R+8>>2];z=0;aR(382,y|0,A|0,B|0);if(z){z=0;u=bT(-1,-1)|0;r=u;u=M;if((a[A]&1)==0){af=r;ag=u;break}Lw(c[A+8>>2]|0);af=r;ag=u;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[y]&1)==0){break L102}Lw(c[t>>2]|0);break L102}}while(0);if((a[y]&1)==0){S=af;T=ag;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[t>>2]|0);S=af;T=ag;U=S;V=0;W=U;X=T;bg(W|0)}}while(0);if(b){b=Lu(88)|0;c[o>>2]=b;ag=d+4|0;af=c[ag>>2]|0;if((af|0)==(c[d+8>>2]|0)){e4(d|0,o);ah=c[o>>2]|0}else{if((af|0)==0){ai=0}else{c[af>>2]=b;ai=c[ag>>2]|0}c[ag>>2]=ai+4;ah=b}b=ah;ai=ah;af=f;L142:do{if((a[af]&1)==0){o=C;c[o>>2]=c[af>>2];c[o+4>>2]=c[af+4>>2];c[o+8>>2]=c[af+8>>2];ad=92}else{o=c[f+8>>2]|0;y=c[f+4>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[C]=y<<1;aj=C+1|0}else{A=y+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[C+8>>2]=B;c[C>>2]=A|1;c[C+4>>2]=y;aj=B}LF(aj|0,o|0,y)|0;a[aj+y|0]=0;ad=92;break L142}}while(0);y=bT(-1,-1)|0;ak=y;al=M}}while(0);do{if((ad|0)==92){aj=D;c[aj>>2]=c[R>>2];c[aj+4>>2]=c[R+4>>2];c[aj+8>>2]=c[R+8>>2];if(x){am=+h[Y+40>>3]}else{am=0.0}an=+h[P+40>>3]+am;if(v){ao=0.0}else{ao=+h[Z+40>>3]}ap=+h[P+48>>3]+ao;if((_|0)==0){aq=0.0}else{aq=+h[_+40>>3]}as=+h[P+56>>3]+aq;if((ac|0)==0){aw=0.0}else{aw=+h[ac+40>>3]}ax=+h[P+64>>3]+aw;af=F;a[af]=0;a[F+1|0]=0;y=n;c[y>>2]=c[aj>>2];c[y+4>>2]=c[aj+4>>2];c[y+8>>2]=c[aj+8>>2];z=0;av(2,ai|0,C|0,n|0,+an,+ap,+as,+ax,F|0);if(z){z=0;aj=bT(-1,-1)|0;y=aj;aj=M;if((a[af]&1)!=0){Lw(c[F+8>>2]|0)}if((a[C]&1)==0){ak=y;al=aj;break}Lw(c[C+8>>2]|0);ak=y;al=aj;break}if((a[af]&1)!=0){Lw(c[F+8>>2]|0)}af=ah;if((a[C]&1)==0){ay=af;i=k;return ay|0}Lw(c[C+8>>2]|0);ay=af;i=k;return ay|0}}while(0);C=c[d>>2]|0;F=c[ag>>2]|0;n=C;while(1){if((n|0)==(F|0)){az=F;break}if((c[n>>2]|0)==(ah|0)){az=n;break}else{n=n+4|0}}n=az-C>>2;az=C+(n+1<<2)|0;ah=F-az|0;LG(C+(n<<2)|0,az|0,ah|0)|0;az=C+((ah>>2)+n<<2)|0;n=c[ag>>2]|0;if((az|0)!=(n|0)){c[ag>>2]=n+(~((n-4+(-az|0)|0)>>>2)<<2)}Lw(b);S=ak;T=al;U=S;V=0;W=U;X=T;bg(W|0)}if(Q){qw(G,+h[P+40>>3],+h[P+48>>3],+h[P+56>>3]);if(w){aA=+h[$+40>>3]}else{aA=0.0}aw=+h[G>>3]+aA;if(j){aB=0.0}else{aB=+h[aa+40>>3]}aA=+h[G+8>>3]+aB;if((ab|0)==0){aC=0.0}else{aC=+h[ab+40>>3]}aB=+h[G+16>>3]+aC;if((ac|0)==0){aD=0.0}else{aD=+h[ac+40>>3]}aC=+h[P+64>>3]+aD;G=H;c[G>>2]=c[R>>2];c[G+4>>2]=c[R+4>>2];c[G+8>>2]=c[R+8>>2];ay=qx(aw,aA,aB,aC,d,f,H)|0;i=k;return ay|0}if((ac|0)==0){H=Lu(48)|0;G=L+8|0;c[G>>2]=H;c[L>>2]=49;c[L+4>>2]=39;LF(H|0,4808,39)|0;a[H+39|0]=0;H=f;L211:do{if((a[H]&1)==0){ab=N;c[ab>>2]=c[H>>2];c[ab+4>>2]=c[H+4>>2];c[ab+8>>2]=c[H+8>>2];ad=168}else{ab=c[f+8>>2]|0;aa=c[f+4>>2]|0;do{if(aa>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aa>>>0<11>>>0){a[N]=aa<<1;aE=N+1|0}else{j=aa+16&-16;$=(z=0,au(248,j|0)|0);if(z){z=0;break}c[N+8>>2]=$;c[N>>2]=j|1;c[N+4>>2]=aa;aE=$}LF(aE|0,ab|0,aa)|0;a[aE+aa|0]=0;ad=168;break L211}}while(0);aa=bT(-1,-1)|0;aF=aa;aG=M}}while(0);do{if((ad|0)==168){aE=O;c[aE>>2]=c[R>>2];c[aE+4>>2]=c[R+4>>2];c[aE+8>>2]=c[R+8>>2];z=0;aR(382,L|0,N|0,O|0);if(z){z=0;aE=bT(-1,-1)|0;H=aE;aE=M;if((a[N]&1)==0){aF=H;aG=aE;break}Lw(c[N+8>>2]|0);aF=H;aG=aE;break}if((a[N]&1)!=0){Lw(c[N+8>>2]|0)}if((a[L]&1)!=0){Lw(c[G>>2]|0)}ay=P|0;i=k;return ay|0}}while(0);if((a[L]&1)==0){S=aF;T=aG;U=S;V=0;W=U;X=T;bg(W|0)}Lw(c[G>>2]|0);S=aF;T=aG;U=S;V=0;W=U;X=T;bg(W|0)}aG=Lu(88)|0;c[l>>2]=aG;aF=d+4|0;G=c[aF>>2]|0;if((G|0)==(c[d+8>>2]|0)){e4(d|0,l);aH=c[l>>2]|0}else{if((G|0)==0){aI=0}else{c[G>>2]=aG;aI=c[aF>>2]|0}c[aF>>2]=aI+4;aH=aG}aG=aH;aI=aH;G=f;L250:do{if((a[G]&1)==0){l=I;c[l>>2]=c[G>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];ad=142}else{l=c[f+8>>2]|0;L=c[f+4>>2]|0;do{if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(L>>>0<11>>>0){a[I]=L<<1;aJ=I+1|0}else{N=L+16&-16;O=(z=0,au(248,N|0)|0);if(z){z=0;break}c[I+8>>2]=O;c[I>>2]=N|1;c[I+4>>2]=L;aJ=O}LF(aJ|0,l|0,L)|0;a[aJ+L|0]=0;ad=142;break L250}}while(0);L=bT(-1,-1)|0;aK=L;aL=M}}while(0);do{if((ad|0)==142){aJ=J;c[aJ>>2]=c[R>>2];c[aJ+4>>2]=c[R+4>>2];c[aJ+8>>2]=c[R+8>>2];aC=+h[P+40>>3];aB=+h[P+48>>3];aA=+h[P+56>>3];aw=+h[P+64>>3]+ +h[ac+40>>3];f=K;a[f]=0;a[K+1|0]=0;G=m;c[G>>2]=c[aJ>>2];c[G+4>>2]=c[aJ+4>>2];c[G+8>>2]=c[aJ+8>>2];z=0;av(2,aI|0,I|0,m|0,+aC,+aB,+aA,+aw,K|0);if(z){z=0;aJ=bT(-1,-1)|0;G=aJ;aJ=M;if((a[f]&1)!=0){Lw(c[K+8>>2]|0)}if((a[I]&1)==0){aK=G;aL=aJ;break}Lw(c[I+8>>2]|0);aK=G;aL=aJ;break}if((a[f]&1)!=0){Lw(c[K+8>>2]|0)}f=aH;if((a[I]&1)==0){ay=f;i=k;return ay|0}Lw(c[I+8>>2]|0);ay=f;i=k;return ay|0}}while(0);ay=c[d>>2]|0;d=c[aF>>2]|0;k=ay;while(1){if((k|0)==(d|0)){aN=d;break}if((c[k>>2]|0)==(aH|0)){aN=k;break}else{k=k+4|0}}k=aN-ay>>2;aN=ay+(k+1<<2)|0;aH=d-aN|0;LG(ay+(k<<2)|0,aN|0,aH|0)|0;aN=ay+((aH>>2)+k<<2)|0;k=c[aF>>2]|0;if((aN|0)!=(k|0)){c[aF>>2]=k+(~((k-4+(-aN|0)|0)>>>2)<<2)}Lw(aG);S=aK;T=aL;U=S;V=0;W=U;X=T;bg(W|0);return 0}function qP(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,as=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0.0,aF=0.0,aG=0.0,aH=0.0,aI=0.0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0.0,aQ=0.0,aS=0.0,aT=0.0,aU=0.0,aV=0.0,aW=0.0,aX=0,aY=0,aZ=0.0,a_=0.0,a$=0.0,a0=0.0,a1=0.0,a2=0.0,a3=0.0,a4=0.0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0.0,be=0;k=i;i=i+712|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+32|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;x=k+176|0;y=k+192|0;A=k+208|0;B=k+224|0;C=k+240|0;D=k+256|0;F=k+272|0;G=k+288|0;H=k+304|0;I=k+320|0;J=k+336|0;K=k+352|0;L=k+368|0;N=k+384|0;O=k+400|0;P=k+416|0;Q=k+432|0;R=k+448|0;S=k+464|0;T=k+480|0;U=k+496|0;V=k+512|0;W=k+528|0;X=k+544|0;Y=k+568|0;Z=k+584|0;_=k+600|0;$=k+616|0;aa=k+632|0;ab=k+648|0;ac=k+664|0;ad=k+680|0;ae=k+696|0;af=p;ag=p;a[ag]=12;ah=af+1|0;a[ah]=a[10768]|0;a[ah+1|0]=a[10769]|0;a[ah+2|0]=a[10770]|0;a[ah+3|0]=a[10771]|0;a[ah+4|0]=a[10772]|0;a[ah+5|0]=a[10773]|0;a[af+7|0]=0;af=q;ah=g;c[af>>2]=c[ah>>2];c[af+4>>2]=c[ah+4>>2];c[af+8>>2]=c[ah+8>>2];af=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(z){z=0;q=bT(-1,-1)|0;g=q;q=M;if((a[ag]&1)==0){ai=g;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[p+8>>2]|0);ai=g;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}if((a[ag]&1)!=0){Lw(c[p+8>>2]|0)}p=r;ag=r;a[ag]=8;q=p+1|0;E=1684369956;a[q]=E;E=E>>8;a[q+1|0]=E;E=E>>8;a[q+2|0]=E;E=E>>8;a[q+3|0]=E;a[p+5|0]=0;p=(z=0,aM(90,b|0,r|0)|0);if(z){z=0;q=bT(-1,-1)|0;g=q;q=M;if((a[ag]&1)==0){ai=g;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[r+8>>2]|0);ai=g;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}q=c[p>>2]|0;if((q|0)==0){ao=0}else{ao=Lh(q,31184,31368,-1)|0}if((a[ag]&1)!=0){Lw(c[r+8>>2]|0)}r=s;ag=s;a[ag]=12;q=r+1|0;a[q]=a[1176]|0;a[q+1|0]=a[1177]|0;a[q+2|0]=a[1178]|0;a[q+3|0]=a[1179]|0;a[q+4|0]=a[1180]|0;a[q+5|0]=a[1181]|0;a[r+7|0]=0;r=(z=0,aM(90,b|0,s|0)|0);if(z){z=0;q=bT(-1,-1)|0;p=q;q=M;if((a[ag]&1)==0){ai=p;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[s+8>>2]|0);ai=p;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}q=c[r>>2]|0;if((q|0)==0){aq=0}else{aq=Lh(q,31184,31368,-1)|0}if((a[ag]&1)!=0){Lw(c[s+8>>2]|0)}s=t;ag=t;a[ag]=10;q=s+1|0;a[q]=a[520]|0;a[q+1|0]=a[521]|0;a[q+2|0]=a[522]|0;a[q+3|0]=a[523]|0;a[q+4|0]=a[524]|0;a[s+6|0]=0;s=(z=0,aM(90,b|0,t|0)|0);if(z){z=0;q=bT(-1,-1)|0;r=q;q=M;if((a[ag]&1)==0){ai=r;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[t+8>>2]|0);ai=r;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}q=c[s>>2]|0;if((q|0)==0){as=0}else{as=Lh(q,31184,31368,-1)|0}if((a[ag]&1)!=0){Lw(c[t+8>>2]|0)}t=u;ag=u;a[ag]=8;q=t+1|0;E=1702193188;a[q]=E;E=E>>8;a[q+1|0]=E;E=E>>8;a[q+2|0]=E;E=E>>8;a[q+3|0]=E;a[t+5|0]=0;t=(z=0,aM(90,b|0,u|0)|0);if(z){z=0;q=bT(-1,-1)|0;s=q;q=M;if((a[ag]&1)==0){ai=s;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[u+8>>2]|0);ai=s;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}q=c[t>>2]|0;if((q|0)==0){aw=0}else{aw=Lh(q,31184,31368,-1)|0}if((a[ag]&1)!=0){Lw(c[u+8>>2]|0)}u=Lu(16)|0;ag=v+8|0;c[ag>>2]=u;c[v>>2]=17;c[v+4>>2]=11;LF(u|0,8904,11)|0;a[u+11|0]=0;u=(z=0,aM(90,b|0,v|0)|0);if(z){z=0;q=bT(-1,-1)|0;t=q;q=M;if((a[v]&1)==0){ai=t;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[ag>>2]|0);ai=t;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}q=c[u>>2]|0;if((q|0)==0){ax=0}else{ax=Lh(q,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[ag>>2]|0)}ag=w;v=w;a[v]=20;LF(ag+1|0,8776,10)|0;a[ag+11|0]=0;ag=(z=0,aM(90,b|0,w|0)|0);if(z){z=0;q=bT(-1,-1)|0;u=q;q=M;if((a[v]&1)==0){ai=u;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[w+8>>2]|0);ai=u;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}q=c[ag>>2]|0;if((q|0)==0){ay=0}else{ay=Lh(q,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[w+8>>2]|0)}w=x;v=x;a[v]=12;q=w+1|0;a[q]=a[11560]|0;a[q+1|0]=a[11561]|0;a[q+2|0]=a[11562]|0;a[q+3|0]=a[11563]|0;a[q+4|0]=a[11564]|0;a[q+5|0]=a[11565]|0;a[w+7|0]=0;w=(z=0,aM(90,b|0,x|0)|0);if(z){z=0;q=bT(-1,-1)|0;ag=q;q=M;if((a[v]&1)==0){ai=ag;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[x+8>>2]|0);ai=ag;aj=q;ak=ai;al=0;am=ak;an=aj;bg(am|0)}q=c[w>>2]|0;if((q|0)==0){az=0}else{az=Lh(q,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[x+8>>2]|0)}x=(ao|0)!=0;ao=(aq|0)==0;aq=(as|0)!=0|(x|ao^1);v=(aw|0)!=0;aw=(ax|0)==0;ax=(ay|0)!=0|(v|aw^1);L102:do{if(aq&ax){q=Lu(64)|0;w=y+8|0;c[w>>2]=q;c[y>>2]=65;c[y+4>>2]=56;LF(q|0,4448,56)|0;a[q+56|0]=0;q=f;L104:do{if((a[q]&1)==0){ag=A;c[ag>>2]=c[q>>2];c[ag+4>>2]=c[q+4>>2];c[ag+8>>2]=c[q+8>>2];aA=66}else{ag=c[f+8>>2]|0;u=c[f+4>>2]|0;do{if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(u>>>0<11>>>0){a[A]=u<<1;aB=A+1|0}else{t=u+16&-16;s=(z=0,au(248,t|0)|0);if(z){z=0;break}c[A+8>>2]=s;c[A>>2]=t|1;c[A+4>>2]=u;aB=s}LF(aB|0,ag|0,u)|0;a[aB+u|0]=0;aA=66;break L104}}while(0);u=bT(-1,-1)|0;aC=u;aD=M}}while(0);do{if((aA|0)==66){q=B;c[q>>2]=c[ah>>2];c[q+4>>2]=c[ah+4>>2];c[q+8>>2]=c[ah+8>>2];z=0;aR(382,y|0,A|0,B|0);if(z){z=0;q=bT(-1,-1)|0;u=q;q=M;if((a[A]&1)==0){aC=u;aD=q;break}Lw(c[A+8>>2]|0);aC=u;aD=q;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[y]&1)==0){break L102}Lw(c[w>>2]|0);break L102}}while(0);if((a[y]&1)==0){ai=aC;aj=aD;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[w>>2]|0);ai=aC;aj=aD;ak=ai;al=0;am=ak;an=aj;bg(am|0)}}while(0);if(aq){do{if(x){aq=C;aD=C;a[aD]=8;aC=aq+1|0;E=1684369956;a[aC]=E;E=E>>8;a[aC+1|0]=E;E=E>>8;a[aC+2|0]=E;E=E>>8;a[aC+3|0]=E;a[aq+5|0]=0;aq=D;c[aq>>2]=c[ah>>2];c[aq+4>>2]=c[ah+4>>2];c[aq+8>>2]=c[ah+8>>2];aq=(z=0,ap(2,C|0,b|0,e|0,f|0,D|0,+-100.0,+100.0,j|0)|0);if(!z){aE=+h[aq+40>>3]/100.0;if((a[aD]&1)==0){aF=aE;break}Lw(c[C+8>>2]|0);aF=aE;break}else{z=0}aq=bT(-1,-1)|0;aC=aq;aq=M;if((a[aD]&1)==0){ai=aC;aj=aq;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[C+8>>2]|0);ai=aC;aj=aq;ak=ai;al=0;am=ak;an=aj;bg(am|0)}else{aF=0.0}}while(0);do{if(ao){aG=0.0}else{C=F;D=F;a[D]=12;x=C+1|0;a[x]=a[1176]|0;a[x+1|0]=a[1177]|0;a[x+2|0]=a[1178]|0;a[x+3|0]=a[1179]|0;a[x+4|0]=a[1180]|0;a[x+5|0]=a[1181]|0;a[C+7|0]=0;C=G;c[C>>2]=c[ah>>2];c[C+4>>2]=c[ah+4>>2];c[C+8>>2]=c[ah+8>>2];C=(z=0,ap(2,F|0,b|0,e|0,f|0,G|0,+-100.0,+100.0,j|0)|0);if(!z){aE=+h[C+40>>3]/100.0;if((a[D]&1)==0){aG=aE;break}Lw(c[F+8>>2]|0);aG=aE;break}else{z=0}C=bT(-1,-1)|0;x=C;C=M;if((a[D]&1)==0){ai=x;aj=C;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[F+8>>2]|0);ai=x;aj=C;ak=ai;al=0;am=ak;an=aj;bg(am|0)}}while(0);do{if((as|0)==0){aH=0.0}else{F=H;G=H;a[G]=10;ao=F+1|0;a[ao]=a[520]|0;a[ao+1|0]=a[521]|0;a[ao+2|0]=a[522]|0;a[ao+3|0]=a[523]|0;a[ao+4|0]=a[524]|0;a[F+6|0]=0;F=I;c[F>>2]=c[ah>>2];c[F+4>>2]=c[ah+4>>2];c[F+8>>2]=c[ah+8>>2];F=(z=0,ap(2,H|0,b|0,e|0,f|0,I|0,+-100.0,+100.0,j|0)|0);if(!z){aE=+h[F+40>>3]/100.0;if((a[G]&1)==0){aH=aE;break}Lw(c[H+8>>2]|0);aH=aE;break}else{z=0}F=bT(-1,-1)|0;ao=F;F=M;if((a[G]&1)==0){ai=ao;aj=F;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[H+8>>2]|0);ai=ao;aj=F;ak=ai;al=0;am=ak;an=aj;bg(am|0)}}while(0);do{if((az|0)==0){aI=0.0}else{H=J;I=J;a[I]=12;as=H+1|0;a[as]=a[11560]|0;a[as+1|0]=a[11561]|0;a[as+2|0]=a[11562]|0;a[as+3|0]=a[11563]|0;a[as+4|0]=a[11564]|0;a[as+5|0]=a[11565]|0;a[H+7|0]=0;H=K;c[H>>2]=c[ah>>2];c[H+4>>2]=c[ah+4>>2];c[H+8>>2]=c[ah+8>>2];H=(z=0,ap(2,J|0,b|0,e|0,f|0,K|0,+-100.0,+100.0,j|0)|0);if(!z){aE=+h[H+40>>3]/100.0;if((a[I]&1)==0){aI=aE;break}Lw(c[J+8>>2]|0);aI=aE;break}else{z=0}H=bT(-1,-1)|0;as=H;H=M;if((a[I]&1)==0){ai=as;aj=H;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[J+8>>2]|0);ai=as;aj=H;ak=ai;al=0;am=ak;an=aj;bg(am|0)}}while(0);J=Lu(88)|0;c[n>>2]=J;K=d+4|0;H=c[K>>2]|0;if((H|0)==(c[d+8>>2]|0)){e4(d|0,n);aJ=c[n>>2]|0}else{if((H|0)==0){aK=0}else{c[H>>2]=J;aK=c[K>>2]|0}c[K>>2]=aK+4;aJ=J}J=aJ;aK=aJ;H=f;L186:do{if((a[H]&1)==0){n=L;c[n>>2]=c[H>>2];c[n+4>>2]=c[H+4>>2];c[n+8>>2]=c[H+8>>2];aA=108}else{n=c[f+8>>2]|0;as=c[f+4>>2]|0;do{if(as>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(as>>>0<11>>>0){a[L]=as<<1;aL=L+1|0}else{I=as+16&-16;F=(z=0,au(248,I|0)|0);if(z){z=0;break}c[L+8>>2]=F;c[L>>2]=I|1;c[L+4>>2]=as;aL=F}LF(aL|0,n|0,as)|0;a[aL+as|0]=0;aA=108;break L186}}while(0);as=bT(-1,-1)|0;aN=as;aO=M}}while(0);do{if((aA|0)==108){aL=N;c[aL>>2]=c[ah>>2];c[aL+4>>2]=c[ah+4>>2];c[aL+8>>2]=c[ah+8>>2];aE=+h[af+40>>3];if(aF>0.0){aP=255.0-aE}else{aP=aE}aQ=+h[af+48>>3];if(aG>0.0){aS=255.0-aQ}else{aS=aQ}aT=+h[af+56>>3];if(aH>0.0){aU=255.0-aT}else{aU=aT}aV=+h[af+64>>3];if(aI>0.0){aW=1.0-aV}else{aW=aV}H=O;a[H]=0;a[O+1|0]=0;as=l;c[as>>2]=c[aL>>2];c[as+4>>2]=c[aL+4>>2];c[as+8>>2]=c[aL+8>>2];z=0;av(2,aK|0,L|0,l|0,+(aE+aF*aP),+(aQ+aG*aS),+(aT+aH*aU),+(aV+aI*aW),O|0);if(z){z=0;aL=bT(-1,-1)|0;as=aL;aL=M;if((a[H]&1)!=0){Lw(c[O+8>>2]|0)}if((a[L]&1)==0){aN=as;aO=aL;break}Lw(c[L+8>>2]|0);aN=as;aO=aL;break}if((a[H]&1)!=0){Lw(c[O+8>>2]|0)}H=aJ;if((a[L]&1)==0){aX=H;i=k;return aX|0}Lw(c[L+8>>2]|0);aX=H;i=k;return aX|0}}while(0);L=c[d>>2]|0;O=c[K>>2]|0;l=L;while(1){if((l|0)==(O|0)){aY=O;break}if((c[l>>2]|0)==(aJ|0)){aY=l;break}else{l=l+4|0}}l=aY-L>>2;aY=L+(l+1<<2)|0;aJ=O-aY|0;LG(L+(l<<2)|0,aY|0,aJ|0)|0;aY=L+((aJ>>2)+l<<2)|0;l=c[K>>2]|0;if((aY|0)!=(l|0)){c[K>>2]=l+(~((l-4+(-aY|0)|0)>>>2)<<2)}Lw(J);ai=aN;aj=aO;ak=ai;al=0;am=ak;an=aj;bg(am|0)}if(ax){do{if(v){ax=P;aO=P;a[aO]=8;aN=ax+1|0;E=1702193188;a[aN]=E;E=E>>8;a[aN+1|0]=E;E=E>>8;a[aN+2|0]=E;E=E>>8;a[aN+3|0]=E;a[ax+5|0]=0;ax=Q;c[ax>>2]=c[ah>>2];c[ax+4>>2]=c[ah+4>>2];c[ax+8>>2]=c[ah+8>>2];ax=(z=0,ap(2,P|0,b|0,e|0,f|0,Q|0,+-100.0,+100.0,j|0)|0);if(!z){aW=+h[ax+40>>3]/100.0;if((a[aO]&1)==0){aZ=aW;break}Lw(c[P+8>>2]|0);aZ=aW;break}else{z=0}ax=bT(-1,-1)|0;aN=ax;ax=M;if((a[aO]&1)==0){ai=aN;aj=ax;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[P+8>>2]|0);ai=aN;aj=ax;ak=ai;al=0;am=ak;an=aj;bg(am|0)}else{aZ=0.0}}while(0);do{if(aw){a_=0.0}else{P=Lu(16)|0;Q=R+8|0;c[Q>>2]=P;c[R>>2]=17;c[R+4>>2]=11;LF(P|0,8904,11)|0;a[P+11|0]=0;P=S;c[P>>2]=c[ah>>2];c[P+4>>2]=c[ah+4>>2];c[P+8>>2]=c[ah+8>>2];P=(z=0,ap(2,R|0,b|0,e|0,f|0,S|0,+-100.0,+100.0,j|0)|0);if(!z){aW=+h[P+40>>3]/100.0;if((a[R]&1)==0){a_=aW;break}Lw(c[Q>>2]|0);a_=aW;break}else{z=0}P=bT(-1,-1)|0;v=P;P=M;if((a[R]&1)==0){ai=v;aj=P;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[Q>>2]|0);ai=v;aj=P;ak=ai;al=0;am=ak;an=aj;bg(am|0)}}while(0);do{if((ay|0)==0){a$=0.0}else{R=T;S=T;a[S]=20;LF(R+1|0,8776,10)|0;a[R+11|0]=0;R=U;c[R>>2]=c[ah>>2];c[R+4>>2]=c[ah+4>>2];c[R+8>>2]=c[ah+8>>2];R=(z=0,ap(2,T|0,b|0,e|0,f|0,U|0,+-100.0,+100.0,j|0)|0);if(!z){aW=+h[R+40>>3]/100.0;if((a[S]&1)==0){a$=aW;break}Lw(c[T+8>>2]|0);a$=aW;break}else{z=0}R=bT(-1,-1)|0;aw=R;R=M;if((a[S]&1)==0){ai=aw;aj=R;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[T+8>>2]|0);ai=aw;aj=R;ak=ai;al=0;am=ak;an=aj;bg(am|0)}}while(0);do{if((az|0)==0){a0=0.0}else{T=V;U=V;a[U]=12;ay=T+1|0;a[ay]=a[11560]|0;a[ay+1|0]=a[11561]|0;a[ay+2|0]=a[11562]|0;a[ay+3|0]=a[11563]|0;a[ay+4|0]=a[11564]|0;a[ay+5|0]=a[11565]|0;a[T+7|0]=0;T=W;c[T>>2]=c[ah>>2];c[T+4>>2]=c[ah+4>>2];c[T+8>>2]=c[ah+8>>2];T=(z=0,ap(2,V|0,b|0,e|0,f|0,W|0,+-100.0,+100.0,j|0)|0);if(!z){aW=+h[T+40>>3]/100.0;if((a[U]&1)==0){a0=aW;break}Lw(c[V+8>>2]|0);a0=aW;break}else{z=0}T=bT(-1,-1)|0;ay=T;T=M;if((a[U]&1)==0){ai=ay;aj=T;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[V+8>>2]|0);ai=ay;aj=T;ak=ai;al=0;am=ak;an=aj;bg(am|0)}}while(0);V=af+40|0;qw(X,+h[V>>3],+h[af+48>>3],+h[af+56>>3]);W=X|0;aW=+h[W>>3];if(aZ>0.0){a1=360.0-aW}else{a1=aW}aI=aW+aZ*a1;h[W>>3]=aI;W=X+8|0;a1=+h[W>>3];if(a_>0.0){a2=100.0-a1}else{a2=a1}aZ=a1+a_*a2;h[W>>3]=aZ;W=X+16|0;a2=+h[W>>3];if(a$>0.0){a3=100.0-a2}else{a3=a2}a_=a2+a$*a3;h[W>>3]=a_;a3=+h[af+64>>3];if(a0>0.0){a4=1.0-a3}else{a4=+h[V>>3]}V=Y;c[V>>2]=c[ah>>2];c[V+4>>2]=c[ah+4>>2];c[V+8>>2]=c[ah+8>>2];aX=qx(aI,aZ,a_,a3+a0*a4,d,f,Y)|0;i=k;return aX|0}if((az|0)==0){az=Lu(48)|0;Y=ac+8|0;c[Y>>2]=az;c[ac>>2]=49;c[ac+4>>2]=38;LF(az|0,4352,38)|0;a[az+38|0]=0;az=f;L300:do{if((a[az]&1)==0){V=ad;c[V>>2]=c[az>>2];c[V+4>>2]=c[az+4>>2];c[V+8>>2]=c[az+8>>2];aA=224}else{V=c[f+8>>2]|0;W=c[f+4>>2]|0;do{if(W>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(W>>>0<11>>>0){a[ad]=W<<1;a5=ad+1|0}else{X=W+16&-16;T=(z=0,au(248,X|0)|0);if(z){z=0;break}c[ad+8>>2]=T;c[ad>>2]=X|1;c[ad+4>>2]=W;a5=T}LF(a5|0,V|0,W)|0;a[a5+W|0]=0;aA=224;break L300}}while(0);W=bT(-1,-1)|0;a6=W;a7=M}}while(0);do{if((aA|0)==224){a5=ae;c[a5>>2]=c[ah>>2];c[a5+4>>2]=c[ah+4>>2];c[a5+8>>2]=c[ah+8>>2];z=0;aR(382,ac|0,ad|0,ae|0);if(z){z=0;a5=bT(-1,-1)|0;az=a5;a5=M;if((a[ad]&1)==0){a6=az;a7=a5;break}Lw(c[ad+8>>2]|0);a6=az;a7=a5;break}if((a[ad]&1)!=0){Lw(c[ad+8>>2]|0)}if((a[ac]&1)!=0){Lw(c[Y>>2]|0)}aX=af|0;i=k;return aX|0}}while(0);if((a[ac]&1)==0){ai=a6;aj=a7;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[Y>>2]|0);ai=a6;aj=a7;ak=ai;al=0;am=ak;an=aj;bg(am|0)}a7=Z;a6=Z;a[a6]=12;Y=a7+1|0;a[Y]=a[11560]|0;a[Y+1|0]=a[11561]|0;a[Y+2|0]=a[11562]|0;a[Y+3|0]=a[11563]|0;a[Y+4|0]=a[11564]|0;a[Y+5|0]=a[11565]|0;a[a7+7|0]=0;a7=_;c[a7>>2]=c[ah>>2];c[a7+4>>2]=c[ah+4>>2];c[a7+8>>2]=c[ah+8>>2];a7=(z=0,ap(2,Z|0,b|0,e|0,f|0,_|0,+-100.0,+100.0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;_=j;j=M;if((a[a6]&1)==0){ai=_;aj=j;ak=ai;al=0;am=ak;an=aj;bg(am|0)}Lw(c[Z+8>>2]|0);ai=_;aj=j;ak=ai;al=0;am=ak;an=aj;bg(am|0)}a4=+h[a7+40>>3]/100.0;if((a[a6]&1)!=0){Lw(c[Z+8>>2]|0)}Z=Lu(88)|0;c[m>>2]=Z;a6=d+4|0;a7=c[a6>>2]|0;if((a7|0)==(c[d+8>>2]|0)){e4(d|0,m);a8=c[m>>2]|0}else{if((a7|0)==0){a9=0}else{c[a7>>2]=Z;a9=c[a6>>2]|0}c[a6>>2]=a9+4;a8=Z}Z=a8;a9=a8;a7=f;L349:do{if((a[a7]&1)==0){m=$;c[m>>2]=c[a7>>2];c[m+4>>2]=c[a7+4>>2];c[m+8>>2]=c[a7+8>>2];aA=194}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[$]=j<<1;ba=$+1|0}else{_=j+16&-16;e=(z=0,au(248,_|0)|0);if(z){z=0;break}c[$+8>>2]=e;c[$>>2]=_|1;c[$+4>>2]=j;ba=e}LF(ba|0,m|0,j)|0;a[ba+j|0]=0;aA=194;break L349}}while(0);j=bT(-1,-1)|0;bb=j;bc=M}}while(0);do{if((aA|0)==194){ba=aa;c[ba>>2]=c[ah>>2];c[ba+4>>2]=c[ah+4>>2];c[ba+8>>2]=c[ah+8>>2];a0=+h[af+40>>3];a3=+h[af+48>>3];a_=+h[af+56>>3];aZ=+h[af+64>>3];if(a4>0.0){bd=1.0-aZ}else{bd=aZ}f=ab;a[f]=0;a[ab+1|0]=0;a7=o;c[a7>>2]=c[ba>>2];c[a7+4>>2]=c[ba+4>>2];c[a7+8>>2]=c[ba+8>>2];z=0;av(2,a9|0,$|0,o|0,+a0,+a3,+a_,+(aZ+a4*bd),ab|0);if(z){z=0;ba=bT(-1,-1)|0;a7=ba;ba=M;if((a[f]&1)!=0){Lw(c[ab+8>>2]|0)}if((a[$]&1)==0){bb=a7;bc=ba;break}Lw(c[$+8>>2]|0);bb=a7;bc=ba;break}if((a[f]&1)!=0){Lw(c[ab+8>>2]|0)}f=a8;if((a[$]&1)==0){aX=f;i=k;return aX|0}Lw(c[$+8>>2]|0);aX=f;i=k;return aX|0}}while(0);aX=c[d>>2]|0;d=c[a6>>2]|0;k=aX;while(1){if((k|0)==(d|0)){be=d;break}if((c[k>>2]|0)==(a8|0)){be=k;break}else{k=k+4|0}}k=be-aX>>2;be=aX+(k+1<<2)|0;a8=d-be|0;LG(aX+(k<<2)|0,be|0,a8|0)|0;be=aX+((a8>>2)+k<<2)|0;k=c[a6>>2]|0;if((be|0)!=(k|0)){c[a6>>2]=k+(~((k-4+(-be|0)|0)>>>2)<<2)}Lw(Z);ai=bb;aj=bc;ak=ai;al=0;am=ak;an=aj;bg(am|0);return 0}function qQ(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,as=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0.0,aL=0,aN=0,aO=0,aP=0,aQ=0.0,aS=0,aT=0,aU=0,aV=0,aW=0.0,aX=0,aY=0,aZ=0,a_=0,a$=0.0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0.0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0;k=i;i=i+664|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;x=k+176|0;y=k+192|0;A=k+208|0;B=k+224|0;C=k+240|0;D=k+256|0;F=k+272|0;G=k+288|0;H=k+304|0;I=k+320|0;J=k+336|0;K=k+352|0;L=k+368|0;N=k+384|0;O=k+400|0;P=k+416|0;Q=k+440|0;R=k+456|0;S=k+472|0;T=k+488|0;U=k+504|0;V=k+520|0;W=k+536|0;X=k+552|0;Y=k+568|0;Z=k+584|0;_=k+600|0;$=k+616|0;aa=k+632|0;ab=k+648|0;ac=p;ad=p;a[ad]=12;ae=ac+1|0;a[ae]=a[10768]|0;a[ae+1|0]=a[10769]|0;a[ae+2|0]=a[10770]|0;a[ae+3|0]=a[10771]|0;a[ae+4|0]=a[10772]|0;a[ae+5|0]=a[10773]|0;a[ac+7|0]=0;ac=q;ae=g;c[ac>>2]=c[ae>>2];c[ac+4>>2]=c[ae+4>>2];c[ac+8>>2]=c[ae+8>>2];ac=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(z){z=0;q=bT(-1,-1)|0;g=q;q=M;if((a[ad]&1)==0){af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[p+8>>2]|0);af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}if((a[ad]&1)!=0){Lw(c[p+8>>2]|0)}p=r;ad=r;a[ad]=8;q=p+1|0;E=1684369956;a[q]=E;E=E>>8;a[q+1|0]=E;E=E>>8;a[q+2|0]=E;E=E>>8;a[q+3|0]=E;a[p+5|0]=0;p=(z=0,aM(90,b|0,r|0)|0);if(z){z=0;q=bT(-1,-1)|0;g=q;q=M;if((a[ad]&1)==0){af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[r+8>>2]|0);af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}q=c[p>>2]|0;if((q|0)==0){al=0}else{al=Lh(q,31184,31368,-1)|0}if((a[ad]&1)!=0){Lw(c[r+8>>2]|0)}r=s;ad=s;a[ad]=12;q=r+1|0;a[q]=a[1176]|0;a[q+1|0]=a[1177]|0;a[q+2|0]=a[1178]|0;a[q+3|0]=a[1179]|0;a[q+4|0]=a[1180]|0;a[q+5|0]=a[1181]|0;a[r+7|0]=0;r=(z=0,aM(90,b|0,s|0)|0);if(z){z=0;q=bT(-1,-1)|0;p=q;q=M;if((a[ad]&1)==0){af=p;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[s+8>>2]|0);af=p;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}q=c[r>>2]|0;if((q|0)==0){am=0}else{am=Lh(q,31184,31368,-1)|0}if((a[ad]&1)!=0){Lw(c[s+8>>2]|0)}s=t;ad=t;a[ad]=10;q=s+1|0;a[q]=a[520]|0;a[q+1|0]=a[521]|0;a[q+2|0]=a[522]|0;a[q+3|0]=a[523]|0;a[q+4|0]=a[524]|0;a[s+6|0]=0;s=(z=0,aM(90,b|0,t|0)|0);if(z){z=0;q=bT(-1,-1)|0;r=q;q=M;if((a[ad]&1)==0){af=r;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[t+8>>2]|0);af=r;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}q=c[s>>2]|0;if((q|0)==0){an=0}else{an=Lh(q,31184,31368,-1)|0}if((a[ad]&1)!=0){Lw(c[t+8>>2]|0)}t=u;ad=u;a[ad]=8;q=t+1|0;E=1702193188;a[q]=E;E=E>>8;a[q+1|0]=E;E=E>>8;a[q+2|0]=E;E=E>>8;a[q+3|0]=E;a[t+5|0]=0;t=(z=0,aM(90,b|0,u|0)|0);if(z){z=0;q=bT(-1,-1)|0;s=q;q=M;if((a[ad]&1)==0){af=s;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[u+8>>2]|0);af=s;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}q=c[t>>2]|0;if((q|0)==0){ao=0}else{ao=Lh(q,31184,31368,-1)|0}if((a[ad]&1)!=0){Lw(c[u+8>>2]|0)}u=Lu(16)|0;ad=v+8|0;c[ad>>2]=u;c[v>>2]=17;c[v+4>>2]=11;LF(u|0,8904,11)|0;a[u+11|0]=0;u=(z=0,aM(90,b|0,v|0)|0);if(z){z=0;q=bT(-1,-1)|0;t=q;q=M;if((a[v]&1)==0){af=t;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[ad>>2]|0);af=t;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}q=c[u>>2]|0;if((q|0)==0){aq=0}else{aq=Lh(q,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[ad>>2]|0)}ad=w;v=w;a[v]=20;LF(ad+1|0,8776,10)|0;a[ad+11|0]=0;ad=(z=0,aM(90,b|0,w|0)|0);if(z){z=0;q=bT(-1,-1)|0;u=q;q=M;if((a[v]&1)==0){af=u;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[w+8>>2]|0);af=u;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}q=c[ad>>2]|0;if((q|0)==0){as=0}else{as=Lh(q,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[w+8>>2]|0)}w=x;v=x;a[v]=12;q=w+1|0;a[q]=a[11560]|0;a[q+1|0]=a[11561]|0;a[q+2|0]=a[11562]|0;a[q+3|0]=a[11563]|0;a[q+4|0]=a[11564]|0;a[q+5|0]=a[11565]|0;a[w+7|0]=0;w=(z=0,aM(90,b|0,x|0)|0);if(z){z=0;q=bT(-1,-1)|0;ad=q;q=M;if((a[v]&1)==0){af=ad;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[x+8>>2]|0);af=ad;ag=q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}q=c[w>>2]|0;if((q|0)==0){aw=0}else{aw=Lh(q,31184,31368,-1)|0}if((a[v]&1)!=0){Lw(c[x+8>>2]|0)}x=(al|0)!=0;al=(am|0)==0;am=(an|0)!=0|(x|al^1);v=(ao|0)!=0;q=(aq|0)==0;aq=(as|0)!=0|(v|q^1);L102:do{if(am&aq){w=Lu(64)|0;ad=y+8|0;c[ad>>2]=w;c[y>>2]=65;c[y+4>>2]=57;LF(w|0,3976,57)|0;a[w+57|0]=0;w=f;L104:do{if((a[w]&1)==0){u=A;c[u>>2]=c[w>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];ax=66}else{u=c[f+8>>2]|0;t=c[f+4>>2]|0;do{if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(t>>>0<11>>>0){a[A]=t<<1;ay=A+1|0}else{s=t+16&-16;r=(z=0,au(248,s|0)|0);if(z){z=0;break}c[A+8>>2]=r;c[A>>2]=s|1;c[A+4>>2]=t;ay=r}LF(ay|0,u|0,t)|0;a[ay+t|0]=0;ax=66;break L104}}while(0);t=bT(-1,-1)|0;az=t;aA=M}}while(0);do{if((ax|0)==66){w=B;c[w>>2]=c[ae>>2];c[w+4>>2]=c[ae+4>>2];c[w+8>>2]=c[ae+8>>2];z=0;aR(382,y|0,A|0,B|0);if(z){z=0;w=bT(-1,-1)|0;t=w;w=M;if((a[A]&1)==0){az=t;aA=w;break}Lw(c[A+8>>2]|0);az=t;aA=w;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[y]&1)==0){break L102}Lw(c[ad>>2]|0);break L102}}while(0);if((a[y]&1)==0){af=az;ag=aA;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[ad>>2]|0);af=az;ag=aA;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}}while(0);if(am){am=Lu(88)|0;c[o>>2]=am;aA=d+4|0;az=c[aA>>2]|0;if((az|0)==(c[d+8>>2]|0)){e4(d|0,o);aB=c[o>>2]|0}else{if((az|0)==0){aC=0}else{c[az>>2]=am;aC=c[aA>>2]|0}c[aA>>2]=aC+4;aB=am}am=aB;aC=aB;az=f;L142:do{if((a[az]&1)==0){o=C;c[o>>2]=c[az>>2];c[o+4>>2]=c[az+4>>2];c[o+8>>2]=c[az+8>>2];ax=92}else{o=c[f+8>>2]|0;y=c[f+4>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[C]=y<<1;aD=C+1|0}else{A=y+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[C+8>>2]=B;c[C>>2]=A|1;c[C+4>>2]=y;aD=B}LF(aD|0,o|0,y)|0;a[aD+y|0]=0;ax=92;break L142}}while(0);y=bT(-1,-1)|0;aE=y;aF=M}}while(0);do{if((ax|0)==92){aD=D;c[aD>>2]=c[ae>>2];c[aD+4>>2]=c[ae+4>>2];c[aD+8>>2]=c[ae+8>>2];do{if(x){az=F;a[F]=8;y=az+1|0;E=1684369956;a[y]=E;E=E>>8;a[y+1|0]=E;E=E>>8;a[y+2|0]=E;E=E>>8;a[y+3|0]=E;a[az+5|0]=0;az=G;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(z=0,ap(2,F|0,b|0,e|0,f|0,G|0,+0.0,+255.0,j|0)|0);if(!z){aG=az+40|0;aH=1;ax=97;break}else{z=0;az=bT(-1,-1)|0;aI=M;aJ=az;ax=142;break}}else{aG=ac+40|0;aH=0;ax=97}}while(0);L163:do{if((ax|0)==97){aK=+h[aG>>3];do{if(al){aL=ac+48|0;aN=0;ax=102}else{az=H;a[H]=12;y=az+1|0;a[y]=a[1176]|0;a[y+1|0]=a[1177]|0;a[y+2|0]=a[1178]|0;a[y+3|0]=a[1179]|0;a[y+4|0]=a[1180]|0;a[y+5|0]=a[1181]|0;a[az+7|0]=0;az=I;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(z=0,ap(2,H|0,b|0,e|0,f|0,I|0,+0.0,+255.0,j|0)|0);if(!z){aL=az+40|0;aN=1;ax=102;break}else{z=0;az=bT(-1,-1)|0;aO=M;aP=az;ax=139;break}}}while(0);L171:do{if((ax|0)==102){aQ=+h[aL>>3];do{if((an|0)==0){aS=ac+56|0;aT=0;ax=107}else{az=J;a[J]=10;y=az+1|0;a[y]=a[520]|0;a[y+1|0]=a[521]|0;a[y+2|0]=a[522]|0;a[y+3|0]=a[523]|0;a[y+4|0]=a[524]|0;a[az+6|0]=0;az=K;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(z=0,ap(2,J|0,b|0,e|0,f|0,K|0,+0.0,+255.0,j|0)|0);if(!z){aS=az+40|0;aT=1;ax=107;break}else{z=0;az=bT(-1,-1)|0;aU=M;aV=az;ax=136;break}}}while(0);L179:do{if((ax|0)==107){aW=+h[aS>>3];do{if((aw|0)==0){aX=ac+64|0;aY=0;ax=112}else{az=L;a[L]=12;y=az+1|0;a[y]=a[11560]|0;a[y+1|0]=a[11561]|0;a[y+2|0]=a[11562]|0;a[y+3|0]=a[11563]|0;a[y+4|0]=a[11564]|0;a[y+5|0]=a[11565]|0;a[az+7|0]=0;az=N;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(z=0,ap(2,L|0,b|0,e|0,f|0,N|0,+0.0,+255.0,j|0)|0);if(!z){aX=az+40|0;aY=1;ax=112;break}else{z=0;az=bT(-1,-1)|0;aZ=M;a_=az;ax=133;break}}}while(0);do{if((ax|0)==112){a$=+h[aX>>3];az=O;a[az]=0;a[O+1|0]=0;y=n;c[y>>2]=c[aD>>2];c[y+4>>2]=c[aD+4>>2];c[y+8>>2]=c[aD+8>>2];z=0;av(2,aC|0,C|0,n|0,+aK,+aQ,+aW,+a$,O|0);if(z){z=0;y=bT(-1,-1)|0;o=y;y=M;if((a[az]&1)==0){if(aY){aZ=y;a_=o;ax=133;break}else{a0=o;a1=y;break}}else{Lw(c[O+8>>2]|0);if(aY){aZ=y;a_=o;ax=133;break}else{a0=o;a1=y;break}}}y=aB;if((a[az]&1)!=0){Lw(c[O+8>>2]|0)}do{if(aY){if((a[L]&1)==0){break}Lw(c[L+8>>2]|0)}}while(0);do{if(aT){if((a[J]&1)==0){break}Lw(c[J+8>>2]|0)}}while(0);do{if(aN){if((a[H]&1)==0){break}Lw(c[H+8>>2]|0)}}while(0);do{if(aH){if((a[F]&1)==0){break}Lw(c[F+8>>2]|0)}}while(0);if((a[C]&1)==0){a2=y;i=k;return a2|0}Lw(c[C+8>>2]|0);a2=y;i=k;return a2|0}}while(0);do{if((ax|0)==133){if((a[L]&1)==0){a0=a_;a1=aZ;break}Lw(c[L+8>>2]|0);if(aT){aU=aZ;aV=a_;ax=136;break L179}else{a3=a_;a4=aZ;break L179}}}while(0);if(aT){aU=a1;aV=a0;ax=136}else{a3=a0;a4=a1}}}while(0);do{if((ax|0)==136){if((a[J]&1)==0){a3=aV;a4=aU;break}Lw(c[J+8>>2]|0);if(aN){aO=aU;aP=aV;ax=139;break L171}else{a5=aV;a6=aU;break L171}}}while(0);if(aN){aO=a4;aP=a3;ax=139}else{a5=a3;a6=a4}}}while(0);do{if((ax|0)==139){if((a[H]&1)==0){a5=aP;a6=aO;break}Lw(c[H+8>>2]|0);if(aH){aI=aO;aJ=aP;ax=142;break L163}else{a7=aP;a8=aO;break L163}}}while(0);if(aH){aI=a6;aJ=a5;ax=142}else{a7=a5;a8=a6}}}while(0);do{if((ax|0)==142){if((a[F]&1)==0){a7=aJ;a8=aI;break}Lw(c[F+8>>2]|0);a7=aJ;a8=aI}}while(0);if((a[C]&1)==0){aE=a7;aF=a8;break}Lw(c[C+8>>2]|0);aE=a7;aF=a8}}while(0);a8=c[d>>2]|0;a7=c[aA>>2]|0;C=a8;while(1){if((C|0)==(a7|0)){a9=a7;break}if((c[C>>2]|0)==(aB|0)){a9=C;break}else{C=C+4|0}}C=a9-a8>>2;a9=a8+(C+1<<2)|0;aB=a7-a9|0;LG(a8+(C<<2)|0,a9|0,aB|0)|0;a9=a8+((aB>>2)+C<<2)|0;C=c[aA>>2]|0;if((a9|0)!=(C|0)){c[aA>>2]=C+(~((C-4+(-a9|0)|0)>>>2)<<2)}Lw(am);af=aE;ag=aF;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}if(aq){qw(P,+h[ac+40>>3],+h[ac+48>>3],+h[ac+56>>3]);if(v){h[P>>3]=+((((~~+h[ao+40>>3]|0)%360|0)+360|0)%360|0|0)/360.0}do{if(!q){ao=Lu(16)|0;v=Q+8|0;c[v>>2]=ao;c[Q>>2]=17;c[Q+4>>2]=11;LF(ao|0,8904,11)|0;a[ao+11|0]=0;ao=R;c[ao>>2]=c[ae>>2];c[ao+4>>2]=c[ae+4>>2];c[ao+8>>2]=c[ae+8>>2];ao=(z=0,ap(2,Q|0,b|0,e|0,f|0,R|0,+0.0,+100.0,j|0)|0);if(!z){h[P+8>>3]=+h[ao+40>>3];if((a[Q]&1)==0){break}Lw(c[v>>2]|0);break}else{z=0}ao=bT(-1,-1)|0;aq=ao;ao=M;if((a[Q]&1)==0){af=aq;ag=ao;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[v>>2]|0);af=aq;ag=ao;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}}while(0);do{if((as|0)!=0){Q=S;R=S;a[R]=20;LF(Q+1|0,8776,10)|0;a[Q+11|0]=0;Q=T;c[Q>>2]=c[ae>>2];c[Q+4>>2]=c[ae+4>>2];c[Q+8>>2]=c[ae+8>>2];Q=(z=0,ap(2,S|0,b|0,e|0,f|0,T|0,+0.0,+100.0,j|0)|0);if(!z){h[P+16>>3]=+h[Q+40>>3];if((a[R]&1)==0){break}Lw(c[S+8>>2]|0);break}else{z=0}Q=bT(-1,-1)|0;q=Q;Q=M;if((a[R]&1)==0){af=q;ag=Q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[S+8>>2]|0);af=q;ag=Q;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}}while(0);do{if((aw|0)==0){ba=+h[ac+64>>3]}else{S=U;T=U;a[T]=12;as=S+1|0;a[as]=a[11560]|0;a[as+1|0]=a[11561]|0;a[as+2|0]=a[11562]|0;a[as+3|0]=a[11563]|0;a[as+4|0]=a[11564]|0;a[as+5|0]=a[11565]|0;a[S+7|0]=0;S=V;c[S>>2]=c[ae>>2];c[S+4>>2]=c[ae+4>>2];c[S+8>>2]=c[ae+8>>2];S=(z=0,ap(2,U|0,b|0,e|0,f|0,V|0,+0.0,+1.0,j|0)|0);if(!z){aK=+h[S+40>>3];if((a[T]&1)==0){ba=aK;break}Lw(c[U+8>>2]|0);ba=aK;break}else{z=0}S=bT(-1,-1)|0;as=S;S=M;if((a[T]&1)==0){af=as;ag=S;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[U+8>>2]|0);af=as;ag=S;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}}while(0);aK=+h[P>>3];aQ=+h[P+8>>3];aW=+h[P+16>>3];P=W;c[P>>2]=c[ae>>2];c[P+4>>2]=c[ae+4>>2];c[P+8>>2]=c[ae+8>>2];a2=qx(aK,aQ,aW,ba,d,f,W)|0;i=k;return a2|0}if((aw|0)==0){aw=Lu(48)|0;W=$+8|0;c[W>>2]=aw;c[$>>2]=49;c[$+4>>2]=39;LF(aw|0,3832,39)|0;a[aw+39|0]=0;aw=f;L288:do{if((a[aw]&1)==0){P=aa;c[P>>2]=c[aw>>2];c[P+4>>2]=c[aw+4>>2];c[P+8>>2]=c[aw+8>>2];ax=222}else{P=c[f+8>>2]|0;U=c[f+4>>2]|0;do{if(U>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(U>>>0<11>>>0){a[aa]=U<<1;bb=aa+1|0}else{V=U+16&-16;S=(z=0,au(248,V|0)|0);if(z){z=0;break}c[aa+8>>2]=S;c[aa>>2]=V|1;c[aa+4>>2]=U;bb=S}LF(bb|0,P|0,U)|0;a[bb+U|0]=0;ax=222;break L288}}while(0);U=bT(-1,-1)|0;bc=U;bd=M}}while(0);do{if((ax|0)==222){bb=ab;c[bb>>2]=c[ae>>2];c[bb+4>>2]=c[ae+4>>2];c[bb+8>>2]=c[ae+8>>2];z=0;aR(382,$|0,aa|0,ab|0);if(z){z=0;bb=bT(-1,-1)|0;aw=bb;bb=M;if((a[aa]&1)==0){bc=aw;bd=bb;break}Lw(c[aa+8>>2]|0);bc=aw;bd=bb;break}if((a[aa]&1)!=0){Lw(c[aa+8>>2]|0)}if((a[$]&1)!=0){Lw(c[W>>2]|0)}a2=ac|0;i=k;return a2|0}}while(0);if((a[$]&1)==0){af=bc;ag=bd;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[W>>2]|0);af=bc;ag=bd;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}bd=X;bc=X;a[bc]=12;W=bd+1|0;a[W]=a[11560]|0;a[W+1|0]=a[11561]|0;a[W+2|0]=a[11562]|0;a[W+3|0]=a[11563]|0;a[W+4|0]=a[11564]|0;a[W+5|0]=a[11565]|0;a[bd+7|0]=0;bd=Y;c[bd>>2]=c[ae>>2];c[bd+4>>2]=c[ae+4>>2];c[bd+8>>2]=c[ae+8>>2];bd=(z=0,ap(2,X|0,b|0,e|0,f|0,Y|0,+0.0,+1.0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;Y=j;j=M;if((a[bc]&1)==0){af=Y;ag=j;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}Lw(c[X+8>>2]|0);af=Y;ag=j;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0)}ba=+h[bd+40>>3];if((a[bc]&1)!=0){Lw(c[X+8>>2]|0)}X=Lu(88)|0;c[l>>2]=X;bc=d+4|0;bd=c[bc>>2]|0;if((bd|0)==(c[d+8>>2]|0)){e4(d|0,l);be=c[l>>2]|0}else{if((bd|0)==0){bf=0}else{c[bd>>2]=X;bf=c[bc>>2]|0}c[bc>>2]=bf+4;be=X}X=be;bf=be;bd=f;L337:do{if((a[bd]&1)==0){l=Z;c[l>>2]=c[bd>>2];c[l+4>>2]=c[bd+4>>2];c[l+8>>2]=c[bd+8>>2];ax=194}else{l=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(j>>>0<11>>>0){a[Z]=j<<1;bh=Z+1|0}else{Y=j+16&-16;e=(z=0,au(248,Y|0)|0);if(z){z=0;break}c[Z+8>>2]=e;c[Z>>2]=Y|1;c[Z+4>>2]=j;bh=e}LF(bh|0,l|0,j)|0;a[bh+j|0]=0;ax=194;break L337}}while(0);j=bT(-1,-1)|0;bi=j;bj=M}}while(0);do{if((ax|0)==194){bh=m;c[bh>>2]=c[ae>>2];c[bh+4>>2]=c[ae+4>>2];c[bh+8>>2]=c[ae+8>>2];aW=+h[ac+40>>3];aQ=+h[ac+48>>3];aK=+h[ac+56>>3];bh=_;a[bh]=0;a[_+1|0]=0;z=0;av(2,bf|0,Z|0,m|0,+aW,+aQ,+aK,+ba,_|0);if(z){z=0;f=bT(-1,-1)|0;bd=f;f=M;if((a[bh]&1)!=0){Lw(c[_+8>>2]|0)}if((a[Z]&1)==0){bi=bd;bj=f;break}Lw(c[Z+8>>2]|0);bi=bd;bj=f;break}if((a[bh]&1)!=0){Lw(c[_+8>>2]|0)}bh=be;if((a[Z]&1)==0){a2=bh;i=k;return a2|0}Lw(c[Z+8>>2]|0);a2=bh;i=k;return a2|0}}while(0);a2=c[d>>2]|0;d=c[bc>>2]|0;k=a2;while(1){if((k|0)==(d|0)){bk=d;break}if((c[k>>2]|0)==(be|0)){bk=k;break}else{k=k+4|0}}k=bk-a2>>2;bk=a2+(k+1<<2)|0;be=d-bk|0;LG(a2+(k<<2)|0,bk|0,be|0)|0;bk=a2+((be>>2)+k<<2)|0;k=c[bc>>2]|0;if((bk|0)!=(k|0)){c[bc>>2]=k+(~((k-4+(-bk|0)|0)>>>2)<<2)}Lw(X);af=bi;ag=bj;ah=af;ai=0;aj=ah;ak=ag;bg(aj|0);return 0}function qR(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,av=0,aw=0,ax=0;k=i;i=i+40|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=n;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+144|0;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+12|0;i=i+7&-8;w=p;x=p;a[x]=12;y=w+1|0;a[y]=a[10768]|0;a[y+1|0]=a[10769]|0;a[y+2|0]=a[10770]|0;a[y+3|0]=a[10771]|0;a[y+4|0]=a[10772]|0;a[y+5|0]=a[10773]|0;a[w+7|0]=0;w=q;y=g;c[w>>2]=c[y>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];w=(z=0,at(110,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;q=j;j=M;if((a[x]&1)==0){A=j;B=q;C=B;D=0;E=C;F=A;bg(E|0)}Lw(c[p+8>>2]|0);A=j;B=q;C=B;D=0;E=C;F=A;bg(E|0)}if((a[x]&1)!=0){Lw(c[p+8>>2]|0)}G=+h[w+40>>3];if(G>255.0){H=255.5}else{H=(G<0.0?0.0:G)+.5}G=+h[w+48>>3];if(G>255.0){I=255.5}else{I=(G<0.0?0.0:G)+.5}G=+h[w+56>>3];if(G>255.0){J=255.5}else{J=(G<0.0?0.0:G)+.5}G=+h[w+64>>3];if(G>1.0){K=255.5}else{K=(G<0.0?0.0:G*255.0)+.5}w=r+64|0;p=r|0;x=r+8|0;q=x|0;c[q>>2]=15464;j=r+12|0;c[p>>2]=32540;e=r+64|0;c[e>>2]=32560;c[r+4>>2]=0;z=0;as(198,r+64|0,j|0);do{if(!z){c[r+136>>2]=0;c[r+140>>2]=-1;b=r+8|0;c[p>>2]=15444;c[w>>2]=15484;c[q>>2]=15464;g=j|0;c[g>>2]=15768;L=r+16|0;I_(L);LI(r+20|0,0,24)|0;c[g>>2]=15624;N=r+44|0;LI(r+44|0,0,16)|0;c[r+60>>2]=24;LI(o|0,0,12)|0;z=0;as(212,j|0,n|0);if(z){z=0;O=bT(-1,-1)|0;P=M;if((a[o]&1)!=0){Lw(c[n+8>>2]|0)}if((a[N]&1)!=0){Lw(c[r+52>>2]|0)}c[g>>2]=15768;z=0;ar(394,L|0);if(!z){Q=O;R=P;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}if((a[o]&1)!=0){Lw(c[n+8>>2]|0)}P=x;O=(z=0,aM(106,P|0,35)|0);do{if(!z){g=O;S=O;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;c[S+((c[(c[g>>2]|0)-12>>2]|0)+76)>>2]=48;g=x;S=x;T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;T=~~+W(K);z=0,aM(310,P|0,T|0)|0;if(z){z=0;U=41;break}T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;T=~~+W(H);z=0,aM(310,P|0,T|0)|0;if(z){z=0;U=41;break}T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;T=~~+W(I);z=0,aM(310,P|0,T|0)|0;if(z){z=0;U=41;break}T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;g=~~+W(J);z=0,aM(310,P|0,g|0)|0;if(z){z=0;U=41;break}z=0;as(576,s|0,j|0);if(z){z=0;U=41;break}g=s;S=a[g]|0;T=S&255;if((T&1|0)==0){V=T>>>1}else{V=c[s+4>>2]|0}L49:do{if((V|0)==0){U=45}else{T=(S&1)==0;X=s+1|0;Y=s+8|0;Z=0;while(1){_=(z=0,au(312,a[(T?X:c[Y>>2]|0)+Z|0]|0)|0);if(z){z=0;break}a[(T?X:c[Y>>2]|0)+Z|0]=_;_=Z+1|0;if(_>>>0<V>>>0){Z=_}else{U=45;break L49}}Z=bT(-1,-1)|0;$=M;aa=Z;U=44}}while(0);L55:do{if((U|0)==45){Z=(z=0,au(248,52)|0);do{if(!z){Y=Z;c[m>>2]=Y;X=d+4|0;T=c[X>>2]|0;if((T|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,m|0);if(z){z=0;break}ab=c[m>>2]|0}else{if((T|0)==0){ac=0}else{c[T>>2]=Y;ac=c[X>>2]|0}c[X>>2]=ac+4;ab=Y}Y=ab;T=ab;_=f;L67:do{if((a[_]&1)==0){ad=t;c[ad>>2]=c[_>>2];c[ad+4>>2]=c[_+4>>2];c[ad+8>>2]=c[_+8>>2];U=62}else{ad=c[f+8>>2]|0;ae=c[f+4>>2]|0;do{if(ae>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ae>>>0<11>>>0){a[t]=ae<<1;af=t+1|0}else{ag=ae+16&-16;ah=(z=0,au(248,ag|0)|0);if(z){z=0;break}c[t+8>>2]=ah;c[t>>2]=ag|1;c[t+4>>2]=ae;af=ah}LF(af|0,ad|0,ae)|0;a[af+ae|0]=0;U=62;break L67}}while(0);ae=bT(-1,-1)|0;ai=M;aj=ae}}while(0);do{if((U|0)==62){_=u;c[_>>2]=c[y>>2];c[_+4>>2]=c[y+4>>2];c[_+8>>2]=c[y+8>>2];ae=(S&1)==0;L82:do{if(ae){ad=v;c[ad>>2]=c[g>>2];c[ad+4>>2]=c[g+4>>2];c[ad+8>>2]=c[g+8>>2];U=72}else{ad=c[s+8>>2]|0;ah=c[s+4>>2]|0;do{if(ah>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ah>>>0<11>>>0){a[v]=ah<<1;ak=v+1|0}else{ag=ah+16&-16;al=(z=0,au(248,ag|0)|0);if(z){z=0;break}c[v+8>>2]=al;c[v>>2]=ag|1;c[v+4>>2]=ah;ak=al}LF(ak|0,ad|0,ah)|0;a[ak+ah|0]=0;U=72;break L82}}while(0);ah=bT(-1,-1)|0;am=M;an=ah}}while(0);do{if((U|0)==72){ah=l;c[ah>>2]=c[_>>2];c[ah+4>>2]=c[_+4>>2];c[ah+8>>2]=c[_+8>>2];z=0;aq(28,T|0,t|0,l|0,v|0,0);if(z){z=0;ah=bT(-1,-1)|0;ad=ah;ah=M;if((a[v]&1)==0){am=ah;an=ad;break}Lw(c[v+8>>2]|0);am=ah;an=ad;break}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}if(!ae){Lw(c[s+8>>2]|0)}c[p>>2]=15444;c[e>>2]=15484;c[b>>2]=15464;ad=r+12|0;c[ad>>2]=15624;if((a[N]&1)!=0){Lw(c[r+52>>2]|0)}c[ad>>2]=15768;z=0;ar(394,L|0);if(!z){Ex(r+64|0);i=k;return ab|0}else{z=0}ad=bT(-1,-1)|0;z=0;ar(272,r+64|0);if(!z){bg(ad|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);if((a[t]&1)==0){ai=am;aj=an;break}Lw(c[t+8>>2]|0);ai=am;aj=an}}while(0);T=c[d>>2]|0;ae=c[X>>2]|0;_=T;while(1){if((_|0)==(ae|0)){ao=ae;break}if((c[_>>2]|0)==(ab|0)){ao=_;break}else{_=_+4|0}}_=ao-T>>2;ad=T+(_+1<<2)|0;ah=ae-ad|0;LG(T+(_<<2)|0,ad|0,ah|0)|0;ad=T+((ah>>2)+_<<2)|0;_=c[X>>2]|0;if((ad|0)!=(_|0)){c[X>>2]=_+(~((_-4+(-ad|0)|0)>>>2)<<2)}Lw(Y);ap=ai;av=aj;break L55}else{z=0}}while(0);Z=bT(-1,-1)|0;$=M;aa=Z;U=44}}while(0);if((U|0)==44){ap=$;av=aa}if((S&1)==0){aw=ap;ax=av;break}Lw(c[s+8>>2]|0);aw=ap;ax=av}else{z=0;U=41}}while(0);if((U|0)==41){P=bT(-1,-1)|0;aw=M;ax=P}c[p>>2]=15444;c[e>>2]=15484;c[b>>2]=15464;P=r+12|0;c[P>>2]=15624;if((a[N]&1)!=0){Lw(c[r+52>>2]|0)}c[P>>2]=15768;z=0;ar(394,L|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,r+64|0);if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}z=0;ar(272,r+64|0);if(!z){A=aw;B=ax;C=B;D=0;E=C;F=A;bg(E|0)}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;P=bT(-1,-1)|0;Q=P;R=M}}while(0);z=0;ar(272,w|0);if(!z){bg(Q|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function qS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0;h=i;i=i+128|0;e=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];e=h|0;j=h+16|0;k=h+24|0;l=h+32|0;m=h+48|0;n=h+64|0;o=h+80|0;p=h+96|0;q=h+112|0;Bv(k,0);r=l;a[r]=14;s=l+1|0;a[s]=a[3544]|0;a[s+1|0]=a[3545]|0;a[s+2|0]=a[3546]|0;a[s+3|0]=a[3547]|0;a[s+4|0]=a[3548]|0;a[s+5|0]=a[3549]|0;a[s+6|0]=a[3550]|0;s=l+8|0;a[s]=0;t=(z=0,aM(90,b|0,l|0)|0);do{if(!z){l=c[t>>2]|0;if((a[r]&1)!=0){Lw(c[s>>2]|0)}z=0;aR(c[(c[l>>2]|0)+28>>2]|0,n|0,l|0,k|0);if(z){z=0;l=bT(-1,-1)|0;u=l;v=M;break}z=0;as(180,m|0,n|0);if(z){z=0;l=bT(-1,-1)|0;b=l;l=M;if((a[n]&1)==0){u=b;v=l;break}Lw(c[n+8>>2]|0);u=b;v=l;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}l=(z=0,au(248,52)|0);do{if(!z){b=l;c[j>>2]=b;w=d+4|0;x=c[w>>2]|0;if((x|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,j|0);if(z){z=0;y=47;break}A=c[j>>2]|0}else{if((x|0)==0){B=0}else{c[x>>2]=b;B=c[w>>2]|0}c[w>>2]=B+4;A=b}b=A;x=A;C=f;L26:do{if((a[C]&1)==0){D=o;c[D>>2]=c[C>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];y=25}else{D=c[f+8>>2]|0;E=c[f+4>>2]|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(E>>>0<11>>>0){a[o]=E<<1;F=o+1|0}else{G=E+16&-16;H=(z=0,au(248,G|0)|0);if(z){z=0;break}c[o+8>>2]=H;c[o>>2]=G|1;c[o+4>>2]=E;F=H}LF(F|0,D|0,E)|0;a[F+E|0]=0;y=25;break L26}}while(0);E=bT(-1,-1)|0;I=E;J=M}}while(0);do{if((y|0)==25){C=p;E=g;c[C>>2]=c[E>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];E=m;L41:do{if((a[E]&1)==0){D=q;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];y=35}else{D=c[m+8>>2]|0;H=c[m+4>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[q]=H<<1;K=q+1|0}else{G=H+16&-16;L=(z=0,au(248,G|0)|0);if(z){z=0;break}c[q+8>>2]=L;c[q>>2]=G|1;c[q+4>>2]=H;K=L}LF(K|0,D|0,H)|0;a[K+H|0]=0;y=35;break L41}}while(0);H=bT(-1,-1)|0;N=H;O=M}}while(0);do{if((y|0)==35){H=e;c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];z=0;aq(28,x|0,o|0,e|0,q|0,0);if(z){z=0;H=bT(-1,-1)|0;D=H;H=M;if((a[q]&1)==0){N=D;O=H;break}Lw(c[q+8>>2]|0);N=D;O=H;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}H=A;a[A+28|0]=1;if((a[E]&1)==0){Bx(k);i=h;return H|0}Lw(c[m+8>>2]|0);Bx(k);i=h;return H|0}}while(0);if((a[o]&1)==0){I=N;J=O;break}Lw(c[o+8>>2]|0);I=N;J=O}}while(0);x=c[d>>2]|0;E=c[w>>2]|0;C=x;while(1){if((C|0)==(E|0)){P=E;break}if((c[C>>2]|0)==(A|0)){P=C;break}else{C=C+4|0}}C=P-x>>2;H=x+(C+1<<2)|0;D=E-H|0;LG(x+(C<<2)|0,H|0,D|0)|0;H=x+((D>>2)+C<<2)|0;C=c[w>>2]|0;if((H|0)!=(C|0)){c[w>>2]=C+(~((C-4+(-H|0)|0)>>>2)<<2)}Lw(b);Q=I;R=J}else{z=0;y=47}}while(0);if((y|0)==47){l=bT(-1,-1)|0;Q=l;R=M}if((a[m]&1)==0){u=Q;v=R;break}Lw(c[m+8>>2]|0);u=Q;v=R}else{z=0;l=bT(-1,-1)|0;H=l;l=M;if((a[r]&1)==0){u=H;v=l;break}Lw(c[s>>2]|0);u=H;v=l}}while(0);z=0;ar(444,k|0);if(!z){bg(u|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function qT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0;h=i;i=i+128|0;e=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];e=h|0;j=h+16|0;k=h+24|0;l=h+32|0;m=h+48|0;n=h+64|0;o=h+80|0;p=h+96|0;q=h+112|0;Bv(k,0);r=l;a[r]=14;s=l+1|0;a[s]=a[3544]|0;a[s+1|0]=a[3545]|0;a[s+2|0]=a[3546]|0;a[s+3|0]=a[3547]|0;a[s+4|0]=a[3548]|0;a[s+5|0]=a[3549]|0;a[s+6|0]=a[3550]|0;s=l+8|0;a[s]=0;t=(z=0,aM(90,b|0,l|0)|0);do{if(!z){l=c[t>>2]|0;if((a[r]&1)!=0){Lw(c[s>>2]|0)}z=0;aR(c[(c[l>>2]|0)+28>>2]|0,n|0,l|0,k|0);if(z){z=0;l=bT(-1,-1)|0;u=l;v=M;break}z=0;aR(286,m|0,n|0,34);if(z){z=0;l=bT(-1,-1)|0;b=l;l=M;if((a[n]&1)==0){u=b;v=l;break}Lw(c[n+8>>2]|0);u=b;v=l;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}l=(z=0,au(248,52)|0);do{if(!z){b=l;c[j>>2]=b;w=d+4|0;x=c[w>>2]|0;if((x|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,j|0);if(z){z=0;y=47;break}A=c[j>>2]|0}else{if((x|0)==0){B=0}else{c[x>>2]=b;B=c[w>>2]|0}c[w>>2]=B+4;A=b}b=A;x=A;C=f;L26:do{if((a[C]&1)==0){D=o;c[D>>2]=c[C>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];y=25}else{D=c[f+8>>2]|0;E=c[f+4>>2]|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(E>>>0<11>>>0){a[o]=E<<1;F=o+1|0}else{G=E+16&-16;H=(z=0,au(248,G|0)|0);if(z){z=0;break}c[o+8>>2]=H;c[o>>2]=G|1;c[o+4>>2]=E;F=H}LF(F|0,D|0,E)|0;a[F+E|0]=0;y=25;break L26}}while(0);E=bT(-1,-1)|0;I=E;J=M}}while(0);do{if((y|0)==25){C=p;E=g;c[C>>2]=c[E>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];E=m;L41:do{if((a[E]&1)==0){D=q;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];y=35}else{D=c[m+8>>2]|0;H=c[m+4>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[q]=H<<1;K=q+1|0}else{G=H+16&-16;L=(z=0,au(248,G|0)|0);if(z){z=0;break}c[q+8>>2]=L;c[q>>2]=G|1;c[q+4>>2]=H;K=L}LF(K|0,D|0,H)|0;a[K+H|0]=0;y=35;break L41}}while(0);H=bT(-1,-1)|0;N=H;O=M}}while(0);do{if((y|0)==35){H=e;c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];z=0;aq(28,x|0,o|0,e|0,q|0,0);if(z){z=0;H=bT(-1,-1)|0;D=H;H=M;if((a[q]&1)==0){N=D;O=H;break}Lw(c[q+8>>2]|0);N=D;O=H;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}H=A;a[A+28|0]=1;if((a[E]&1)==0){Bx(k);i=h;return H|0}Lw(c[m+8>>2]|0);Bx(k);i=h;return H|0}}while(0);if((a[o]&1)==0){I=N;J=O;break}Lw(c[o+8>>2]|0);I=N;J=O}}while(0);x=c[d>>2]|0;E=c[w>>2]|0;C=x;while(1){if((C|0)==(E|0)){P=E;break}if((c[C>>2]|0)==(A|0)){P=C;break}else{C=C+4|0}}C=P-x>>2;H=x+(C+1<<2)|0;D=E-H|0;LG(x+(C<<2)|0,H|0,D|0)|0;H=x+((D>>2)+C<<2)|0;C=c[w>>2]|0;if((H|0)!=(C|0)){c[w>>2]=C+(~((C-4+(-H|0)|0)>>>2)<<2)}Lw(b);Q=I;R=J}else{z=0;y=47}}while(0);if((y|0)==47){l=bT(-1,-1)|0;Q=l;R=M}if((a[m]&1)==0){u=Q;v=R;break}Lw(c[m+8>>2]|0);u=Q;v=R}else{z=0;l=bT(-1,-1)|0;H=l;l=M;if((a[r]&1)==0){u=H;v=l;break}Lw(c[s>>2]|0);u=H;v=l}}while(0);z=0;ar(444,k|0);if(!z){bg(u|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function qU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;j=i;i=i+104|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+88|0;r=m;a[r]=14;s=m+1|0;a[s]=a[3544]|0;a[s+1|0]=a[3545]|0;a[s+2|0]=a[3546]|0;a[s+3|0]=a[3547]|0;a[s+4|0]=a[3548]|0;a[s+5|0]=a[3549]|0;a[s+6|0]=a[3550]|0;s=m+8|0;a[s]=0;t=n;u=g;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];t=(z=0,at(108,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;n=h;h=M;if((a[r]&1)==0){v=n;w=h;x=v;y=0;A=x;B=w;bg(A|0)}Lw(c[s>>2]|0);v=n;w=h;x=v;y=0;A=x;B=w;bg(A|0)}if((a[r]&1)!=0){Lw(c[s>>2]|0)}s=t+40|0;if((a[s]&1)==0){r=o;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];C=a[r]|0;D=r}else{r=c[t+48>>2]|0;s=c[t+44>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){h=s<<1&255;n=o;a[n]=h;E=o+1|0;F=h;G=n}else{n=s+16&-16;h=Lu(n)|0;c[o+8>>2]=h;e=n|1;c[o>>2]=e;c[o+4>>2]=s;E=h;F=e&255;G=o}LF(E|0,r|0,s)|0;a[E+s|0]=0;C=F;D=G}G=C&255;if((G&1|0)==0){H=G>>>1}else{H=c[o+4>>2]|0}G=t+40|0;C=G;F=a[G]|0;G=F&255;if((G&1|0)==0){I=G>>>1}else{I=c[t+44>>2]|0}do{if((I|0)==0){J=0}else{G=(F&1)==0;if(G){K=C+1|0}else{K=c[t+48>>2]|0}if((a[K]|0)==34){J=1;break}if(G){L=C+1|0}else{L=c[t+48>>2]|0}J=(a[L]|0)==39}}while(0);L=(z=0,az(24,o|0,J&1|0,(J<<31>>31)+H|0)|0);do{if(!z){H=(z=0,au(248,72)|0);if(z){z=0;N=30;break}J=H;c[l>>2]=J;H=d+4|0;t=c[H>>2]|0;if((t|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,l|0);if(z){z=0;N=30;break}O=c[l>>2]|0}else{if((t|0)==0){P=0}else{c[t>>2]=J;P=c[H>>2]|0}c[H>>2]=P+4;O=J}J=O;t=O;C=f;L53:do{if((a[C]&1)==0){K=p;c[K>>2]=c[C>>2];c[K+4>>2]=c[C+4>>2];c[K+8>>2]=c[C+8>>2];N=48}else{K=c[f+8>>2]|0;F=c[f+4>>2]|0;do{if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(F>>>0<11>>>0){a[p]=F<<1;Q=p+1|0}else{I=F+16&-16;G=(z=0,au(248,I|0)|0);if(z){z=0;break}c[p+8>>2]=G;c[p>>2]=I|1;c[p+4>>2]=F;Q=G}LF(Q|0,K|0,F)|0;a[Q+F|0]=0;N=48;break L53}}while(0);F=bT(-1,-1)|0;R=F;S=M}}while(0);do{if((N|0)==48){C=k;c[C>>2]=c[u>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];C=q;a[C]=0;a[q+1|0]=0;z=0;aG(2,t|0,p|0,k|0,+(+(L>>>0>>>0)),q|0);if(z){z=0;F=bT(-1,-1)|0;K=F;F=M;if((a[C]&1)!=0){Lw(c[q+8>>2]|0)}if((a[p]&1)==0){R=K;S=F;break}Lw(c[p+8>>2]|0);R=K;S=F;break}F=O;if((a[C]&1)!=0){Lw(c[q+8>>2]|0)}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if((a[D]&1)==0){i=j;return F|0}Lw(c[o+8>>2]|0);i=j;return F|0}}while(0);t=c[d>>2]|0;F=c[H>>2]|0;C=t;while(1){if((C|0)==(F|0)){T=F;break}if((c[C>>2]|0)==(O|0)){T=C;break}else{C=C+4|0}}C=T-t>>2;K=t+(C+1<<2)|0;G=F-K|0;LG(t+(C<<2)|0,K|0,G|0)|0;K=t+((G>>2)+C<<2)|0;C=c[H>>2]|0;if((K|0)!=(C|0)){c[H>>2]=C+(~((C-4+(-K|0)|0)>>>2)<<2)}Lw(J);U=R;V=S}else{z=0;N=30}}while(0);if((N|0)==30){N=bT(-1,-1)|0;U=N;V=M}if((a[D]&1)==0){v=U;w=V;x=v;y=0;A=x;B=w;bg(A|0)}Lw(c[o+8>>2]|0);v=U;w=V;x=v;y=0;A=x;B=w;bg(A|0);return 0}function qV(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=Lu(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}LF(t|0,r|0,s)|0;a[t+s|0]=0}s=(z=0,aM(90,d|0,k|0)|0);if(z){z=0;d=bT(-1,-1)|0;t=d;d=M;if((a[k]&1)==0){w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[k+8>>2]|0);w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=Lh(t,31184,31840,-1)|0}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;LF(k+1|0,9104,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}z=0,az(88,l|0,E|0,F|0)|0;do{if(!z){z=0,az(88,l|0,7312,6)|0;if(z){z=0;G=57;break}F=LJ(e|0)|0;z=0,az(88,l|0,e|0,F|0)|0;if(z){z=0;G=57;break}z=0,az(88,l|0,11048,12)|0;if(z){z=0;G=57;break}F=m;E=m;a[E]=12;b=F+1|0;a[b]=a[10920]|0;a[b+1|0]=a[10921]|0;a[b+2|0]=a[10922]|0;a[b+3|0]=a[10923]|0;a[b+4|0]=a[10924]|0;a[b+5|0]=a[10925]|0;a[F+7|0]=0;z=0,az(88,l|0,b|0,6)|0;if(z){z=0;b=bT(-1,-1)|0;F=b;b=M;if((a[E]&1)==0){H=b;I=F;break}Lw(c[m+8>>2]|0);H=b;I=F;break}if((a[E]&1)!=0){Lw(c[m+8>>2]|0)}if((a[t]&1)==0){E=n;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2]}else{E=c[l+8>>2]|0;F=c[l+4>>2]|0;if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=57;break}return 0}if(F>>>0<11>>>0){a[n]=F<<1;J=n+1|0}else{b=F+16&-16;q=(z=0,au(248,b|0)|0);if(z){z=0;G=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=F;J=q}LF(J|0,E|0,F)|0;a[J+F|0]=0}F=f;L61:do{if((a[F]&1)==0){E=o;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];G=50}else{E=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;K=o+1|0}else{b=q+16&-16;k=(z=0,au(248,b|0)|0);if(z){z=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;K=k}LF(K|0,E|0,q)|0;a[K+q|0]=0;G=50;break L61}}while(0);q=bT(-1,-1)|0;L=M;N=q}}while(0);do{if((G|0)==50){F=p;q=g;c[F>>2]=c[q>>2];c[F+4>>2]=c[q+4>>2];c[F+8>>2]=c[q+8>>2];z=0;aV(46,n|0,o|0,p|0,h|0);if(z){z=0;q=bT(-1,-1)|0;F=q;q=M;if((a[o]&1)==0){L=q;N=F;break}Lw(c[o+8>>2]|0);L=q;N=F;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}Lw(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=L;I=N;break}Lw(c[n+8>>2]|0);H=L;I=N}else{z=0;G=57}}while(0);if((G|0)==57){G=bT(-1,-1)|0;H=M;I=G}if((a[t]&1)==0){w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[l+8>>2]|0);w=H;x=I;y=x;A=0;B=y;C=w;bg(B|0);return 0}function qW(b,e,f,g,j,k){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0.0,ac=0,ad=0.0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,av=0,aw=0,ax=0;l=i;i=i+280|0;m=j;j=i;i=i+12|0;i=i+7&-8;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];m=l|0;n=l+16|0;o=l+24|0;p=l+40|0;q=l+56|0;r=l+72|0;s=l+88|0;t=l+104|0;u=l+120|0;v=l+136|0;w=l+152|0;x=l+168|0;y=l+184|0;A=l+200|0;B=l+216|0;C=l+232|0;D=l+248|0;E=l+264|0;F=o;a[F]=14;G=o+1|0;a[G]=a[3544]|0;a[G+1|0]=a[3545]|0;a[G+2|0]=a[3546]|0;a[G+3|0]=a[3547]|0;a[G+4|0]=a[3548]|0;a[G+5|0]=a[3549]|0;a[G+6|0]=a[3550]|0;G=o+8|0;a[G]=0;H=p;I=j;c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];H=(z=0,at(108,o|0,b|0,f|0,g|0,p|0,k|0)|0);if(z){z=0;p=bT(-1,-1)|0;o=p;p=M;if((a[F]&1)==0){J=o;K=p;L=J;N=0;O=L;P=K;bg(O|0)}Lw(c[G>>2]|0);J=o;K=p;L=J;N=0;O=L;P=K;bg(O|0)}if((a[F]&1)!=0){Lw(c[G>>2]|0)}G=H+40|0;if((a[G]&1)==0){F=q;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2]}else{G=c[H+48>>2]|0;F=c[H+44>>2]|0;if(F>>>0>4294967279>>>0){D5(0);return 0}if(F>>>0<11>>>0){a[q]=F<<1;Q=q+1|0}else{p=F+16&-16;o=Lu(p)|0;c[q+8>>2]=o;c[q>>2]=p|1;c[q+4>>2]=F;Q=o}LF(Q|0,G|0,F)|0;a[Q+F|0]=0}F=H+40|0;Q=F;G=a[F]|0;F=G&255;if((F&1|0)==0){R=F>>>1}else{R=c[H+44>>2]|0}do{if((R|0)==0){S=0}else{F=(G&1)==0;if(F){T=Q+1|0}else{T=c[H+48>>2]|0}if((a[T]|0)!=34){if(F){U=Q+1|0}else{U=c[H+48>>2]|0}if((a[U]|0)!=39){S=0;break}}if(F){V=Q+1|0}else{V=c[H+48>>2]|0}S=a[V]|0}}while(0);z=0;as(180,r|0,q|0);do{if(!z){z=0,aM(344,q|0,r|0)|0;if(z){z=0;V=bT(-1,-1)|0;H=V;V=M;if((a[r]&1)==0){W=H;Y=V;break}Lw(c[r+8>>2]|0);W=H;Y=V;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}V=s;a[V]=14;H=s+1|0;a[H]=a[2936]|0;a[H+1|0]=a[2937]|0;a[H+2|0]=a[2938]|0;a[H+3|0]=a[2939]|0;a[H+4|0]=a[2940]|0;a[H+5|0]=a[2941]|0;a[H+6|0]=a[2942]|0;H=s+8|0;a[H]=0;Q=t;c[Q>>2]=c[I>>2];c[Q+4>>2]=c[I+4>>2];c[Q+8>>2]=c[I+8>>2];Q=(z=0,at(108,s|0,b|0,f|0,g|0,t|0,k|0)|0);if(z){z=0;U=bT(-1,-1)|0;T=U;U=M;if((a[V]&1)==0){W=T;Y=U;break}Lw(c[H>>2]|0);W=T;Y=U;break}if((a[V]&1)!=0){Lw(c[H>>2]|0)}H=Q+40|0;if((a[H]&1)==0){V=u;c[V>>2]=c[H>>2];c[V+4>>2]=c[H+4>>2];c[V+8>>2]=c[H+8>>2]}else{H=c[Q+48>>2]|0;V=c[Q+44>>2]|0;if(V>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Z=67;break}return 0}if(V>>>0<11>>>0){a[u]=V<<1;_=u+1|0}else{Q=V+16&-16;U=(z=0,au(248,Q|0)|0);if(z){z=0;Z=67;break}c[u+8>>2]=U;c[u>>2]=Q|1;c[u+4>>2]=V;_=U}LF(_|0,H|0,V)|0;a[_+V|0]=0}z=0;as(180,v|0,u|0);L73:do{if(!z){z=0,aM(344,u|0,v|0)|0;if(z){z=0;V=bT(-1,-1)|0;H=V;V=M;if((a[v]&1)==0){$=H;aa=V;break}Lw(c[v+8>>2]|0);$=H;aa=V;break}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}V=w;H=w;a[H]=12;U=V+1|0;a[U]=a[2816]|0;a[U+1|0]=a[2817]|0;a[U+2|0]=a[2818]|0;a[U+3|0]=a[2819]|0;a[U+4|0]=a[2820]|0;a[U+5|0]=a[2821]|0;a[V+7|0]=0;V=x;c[V>>2]=c[I>>2];c[V+4>>2]=c[I+4>>2];c[V+8>>2]=c[I+8>>2];V=(z=0,at(44,w|0,b|0,f|0,g|0,x|0,k|0)|0);if(z){z=0;U=bT(-1,-1)|0;Q=U;U=M;if((a[H]&1)==0){$=Q;aa=U;break}Lw(c[w+8>>2]|0);$=Q;aa=U;break}if((a[H]&1)!=0){Lw(c[w+8>>2]|0)}ab=+h[V+40>>3];V=q;H=d[V]|0;if((H&1|0)==0){ac=H>>>1}else{ac=c[q+4>>2]|0}H=(z=0,az(24,q|0,0,ac|0)|0);if(z){z=0;Z=72;break}ad=+(H>>>0>>>0);do{if(ab<=0.0|ab>ad){if(ab>ad){U=a[u]|0;if((U&1)==0){ae=u+1|0}else{ae=c[u+8>>2]|0}Q=U&255;if((Q&1|0)==0){af=Q>>>1}else{af=c[u+4>>2]|0}z=0,az(88,q|0,ae|0,af|0)|0;if(!z){break}else{z=0;Z=72;break L73}}if(ab==0.0){z=0;aR(210,y|0,u|0,q|0);if(z){z=0;Z=72;break L73}z=0,aM(344,q|0,y|0)|0;if(!z){if((a[y]&1)==0){break}Lw(c[y+8>>2]|0);break}else{z=0;Q=bT(-1,-1)|0;U=Q;Q=M;if((a[y]&1)==0){$=U;aa=Q;break L73}Lw(c[y+8>>2]|0);$=U;aa=Q;break L73}}if(+X(+ab)>ad){z=0;aR(210,A|0,u|0,q|0);if(z){z=0;Z=72;break L73}z=0,aM(344,q|0,A|0)|0;if(!z){if((a[A]&1)==0){break}Lw(c[A+8>>2]|0);break}else{z=0;Q=bT(-1,-1)|0;U=Q;Q=M;if((a[A]&1)==0){$=U;aa=Q;break L73}Lw(c[A+8>>2]|0);$=U;aa=Q;break L73}}Q=(z=0,aM(588,q|0,~~(ab+ +((H+1|0)>>>0>>>0))|0)|0);if(z){z=0;Z=72;break L73}U=a[u]|0;if((U&1)==0){ag=u+1|0}else{ag=c[u+8>>2]|0}T=U&255;if((T&1|0)==0){ah=T>>>1}else{ah=c[u+4>>2]|0}z=0,aU(2,q|0,Q|0,ag|0,ah|0)|0;if(z){z=0;Z=72;break L73}}else{Q=(z=0,aM(588,q|0,~~(ab+-1.0)|0)|0);if(z){z=0;Z=72;break L73}T=a[u]|0;if((T&1)==0){ai=u+1|0}else{ai=c[u+8>>2]|0}U=T&255;if((U&1|0)==0){aj=U>>>1}else{aj=c[u+4>>2]|0}z=0,aU(2,q|0,Q|0,ai|0,aj|0)|0;if(z){z=0;Z=72;break L73}}}while(0);do{if(S<<24>>24!=0){z=0;aR(286,B|0,q|0,S|0);if(z){z=0;Z=72;break L73}z=0,aM(344,q|0,B|0)|0;if(!z){if((a[B]&1)==0){break}Lw(c[B+8>>2]|0);break}else{z=0;H=bT(-1,-1)|0;Q=H;H=M;if((a[B]&1)==0){$=Q;aa=H;break L73}Lw(c[B+8>>2]|0);$=Q;aa=H;break L73}}}while(0);H=(z=0,au(248,52)|0);if(z){z=0;Z=72;break}Q=H;c[n>>2]=Q;H=e+4|0;U=c[H>>2]|0;if((U|0)==(c[e+8>>2]|0)){z=0;as(382,e|0,n|0);if(z){z=0;Z=72;break}ak=c[n>>2]|0}else{if((U|0)==0){al=0}else{c[U>>2]=Q;al=c[H>>2]|0}c[H>>2]=al+4;ak=Q}Q=ak;U=ak;T=g;L163:do{if((a[T]&1)==0){G=C;c[G>>2]=c[T>>2];c[G+4>>2]=c[T+4>>2];c[G+8>>2]=c[T+8>>2];Z=131}else{G=c[g+8>>2]|0;R=c[g+4>>2]|0;do{if(R>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(R>>>0<11>>>0){a[C]=R<<1;am=C+1|0}else{F=R+16&-16;o=(z=0,au(248,F|0)|0);if(z){z=0;break}c[C+8>>2]=o;c[C>>2]=F|1;c[C+4>>2]=R;am=o}LF(am|0,G|0,R)|0;a[am+R|0]=0;Z=131;break L163}}while(0);R=bT(-1,-1)|0;an=R;ao=M}}while(0);do{if((Z|0)==131){T=D;c[T>>2]=c[I>>2];c[T+4>>2]=c[I+4>>2];c[T+8>>2]=c[I+8>>2];L178:do{if((a[V]&1)==0){R=E;c[R>>2]=c[V>>2];c[R+4>>2]=c[V+4>>2];c[R+8>>2]=c[V+8>>2];Z=141}else{R=c[q+8>>2]|0;G=c[q+4>>2]|0;do{if(G>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(G>>>0<11>>>0){a[E]=G<<1;ap=E+1|0}else{o=G+16&-16;F=(z=0,au(248,o|0)|0);if(z){z=0;break}c[E+8>>2]=F;c[E>>2]=o|1;c[E+4>>2]=G;ap=F}LF(ap|0,R|0,G)|0;a[ap+G|0]=0;Z=141;break L178}}while(0);G=bT(-1,-1)|0;av=G;aw=M}}while(0);do{if((Z|0)==141){G=m;c[G>>2]=c[T>>2];c[G+4>>2]=c[T+4>>2];c[G+8>>2]=c[T+8>>2];z=0;aq(28,U|0,C|0,m|0,E|0,0);if(z){z=0;G=bT(-1,-1)|0;R=G;G=M;if((a[E]&1)==0){av=R;aw=G;break}Lw(c[E+8>>2]|0);av=R;aw=G;break}G=ak;if((a[E]&1)!=0){Lw(c[E+8>>2]|0)}if((a[C]&1)!=0){Lw(c[C+8>>2]|0)}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}if((a[V]&1)==0){i=l;return G|0}Lw(c[q+8>>2]|0);i=l;return G|0}}while(0);if((a[C]&1)==0){an=av;ao=aw;break}Lw(c[C+8>>2]|0);an=av;ao=aw}}while(0);V=c[e>>2]|0;U=c[H>>2]|0;T=V;while(1){if((T|0)==(U|0)){ax=U;break}if((c[T>>2]|0)==(ak|0)){ax=T;break}else{T=T+4|0}}T=ax-V>>2;G=V+(T+1<<2)|0;R=U-G|0;LG(V+(T<<2)|0,G|0,R|0)|0;G=V+((R>>2)+T<<2)|0;T=c[H>>2]|0;if((G|0)!=(T|0)){c[H>>2]=T+(~((T-4+(-G|0)|0)>>>2)<<2)}Lw(Q);$=an;aa=ao}else{z=0;Z=72}}while(0);if((Z|0)==72){G=bT(-1,-1)|0;$=G;aa=M}if((a[u]&1)==0){W=$;Y=aa;break}Lw(c[u+8>>2]|0);W=$;Y=aa}else{z=0;Z=67}}while(0);if((Z|0)==67){Z=bT(-1,-1)|0;W=Z;Y=M}if((a[q]&1)==0){J=W;K=Y;L=J;N=0;O=L;P=K;bg(O|0)}Lw(c[q+8>>2]|0);J=W;K=Y;L=J;N=0;O=L;P=K;bg(O|0);return 0}function qX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,av=0,aw=0,ax=0,ay=0,aA=0;j=i;i=i+256|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+80|0;r=j+96|0;s=j+112|0;t=j+128|0;u=j+144|0;v=j+160|0;w=j+176|0;x=j+192|0;y=j+208|0;A=j+224|0;B=j+240|0;C=q;a[C]=14;D=q+1|0;a[D]=a[3544]|0;a[D+1|0]=a[3545]|0;a[D+2|0]=a[3546]|0;a[D+3|0]=a[3547]|0;a[D+4|0]=a[3548]|0;a[D+5|0]=a[3549]|0;a[D+6|0]=a[3550]|0;D=q+8|0;a[D]=0;E=r;F=g;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];E=(z=0,at(108,q|0,b|0,e|0,f|0,r|0,h|0)|0);if(z){z=0;r=bT(-1,-1)|0;q=r;r=M;if((a[C]&1)==0){G=q;H=r;I=G;J=0;K=I;L=H;bg(K|0)}Lw(c[D>>2]|0);G=q;H=r;I=G;J=0;K=I;L=H;bg(K|0)}if((a[C]&1)!=0){Lw(c[D>>2]|0)}D=s;C=s;a[C]=20;LF(D+1|0,2560,10)|0;a[D+11|0]=0;D=t;c[D>>2]=c[F>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];D=(z=0,at(108,s|0,b|0,e|0,f|0,t|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;t=h;h=M;if((a[C]&1)==0){G=t;H=h;I=G;J=0;K=I;L=H;bg(K|0)}Lw(c[s+8>>2]|0);G=t;H=h;I=G;J=0;K=I;L=H;bg(K|0)}if((a[C]&1)!=0){Lw(c[s+8>>2]|0)}s=E+40|0;if((a[s]&1)==0){C=u;c[C>>2]=c[s>>2];c[C+4>>2]=c[s+4>>2];c[C+8>>2]=c[s+8>>2]}else{s=c[E+48>>2]|0;C=c[E+44>>2]|0;if(C>>>0>4294967279>>>0){D5(0);return 0}if(C>>>0<11>>>0){a[u]=C<<1;N=u+1|0}else{E=C+16&-16;h=Lu(E)|0;c[u+8>>2]=h;c[u>>2]=E|1;c[u+4>>2]=C;N=h}LF(N|0,s|0,C)|0;a[N+C|0]=0}z=0;as(180,v|0,u|0);do{if(!z){z=0,aM(344,u|0,v|0)|0;if(z){z=0;C=bT(-1,-1)|0;N=C;C=M;if((a[v]&1)==0){O=N;P=C;break}Lw(c[v+8>>2]|0);O=N;P=C;break}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}C=D+40|0;if((a[C]&1)==0){N=w;c[N>>2]=c[C>>2];c[N+4>>2]=c[C+4>>2];c[N+8>>2]=c[C+8>>2]}else{C=c[D+48>>2]|0;N=c[D+44>>2]|0;if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Q=94;break}return 0}if(N>>>0<11>>>0){a[w]=N<<1;R=w+1|0}else{s=N+16&-16;h=(z=0,au(248,s|0)|0);if(z){z=0;Q=94;break}c[w+8>>2]=h;c[w>>2]=s|1;c[w+4>>2]=N;R=h}LF(R|0,C|0,N)|0;a[R+N|0]=0}z=0;as(180,x|0,w|0);L54:do{if(!z){z=0,aM(344,w|0,x|0)|0;if(z){z=0;N=bT(-1,-1)|0;C=N;N=M;if((a[x]&1)==0){S=C;T=N;break}Lw(c[x+8>>2]|0);S=C;T=N;break}if((a[x]&1)!=0){Lw(c[x+8>>2]|0)}N=w;C=a[N]|0;if((C&1)==0){U=w+1|0}else{U=c[w+8>>2]|0}h=C&255;if((h&1|0)==0){V=h>>>1}else{V=c[w+4>>2]|0}h=u;C=u;s=a[C]|0;E=s&255;if((E&1|0)==0){W=E>>>1}else{W=c[u+4>>2]|0}L75:do{if(W>>>0<V>>>0){Q=56}else{if((V|0)==0){X=0}else{if((s&1)==0){Y=h+1|0}else{Y=c[u+8>>2]|0}E=Y+W|0;t=U+V|0;e=Y;if((W|0)<(V|0)){Q=56;break}b=W+(1-V)|0;r=Y+b|0;if((b|0)==0){Q=56;break}b=a[U]|0;q=Y;L85:while(1){if((a[q]|0)==b<<24>>24){g=U;Z=q;do{g=g+1|0;if((g|0)==(t|0)){break L85}Z=Z+1|0;}while((a[Z]|0)==(a[g]|0))}g=q+1|0;if((g|0)==(r|0)){Q=56;break L75}else{q=g}}if((q|0)==(E|0)){Q=56;break}r=q-e|0;if((r|0)==-1){Q=56;break}else{X=r}}r=(z=0,az(24,u|0,0,X+1|0)|0);if(z){z=0;Q=97;break L54}t=(z=0,au(248,72)|0);if(z){z=0;Q=97;break L54}b=t;c[l>>2]=b;t=d+4|0;g=c[t>>2]|0;if((g|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,l|0);if(z){z=0;Q=97;break L54}_=c[l>>2]|0}else{if((g|0)==0){$=0}else{c[g>>2]=b;$=c[t>>2]|0}c[t>>2]=$+4;_=b}b=_;g=_;Z=f;L105:do{if((a[Z]&1)==0){aa=A;c[aa>>2]=c[Z>>2];c[aa+4>>2]=c[Z+4>>2];c[aa+8>>2]=c[Z+8>>2];Q=128}else{aa=c[f+8>>2]|0;ab=c[f+4>>2]|0;do{if(ab>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ab>>>0<11>>>0){a[A]=ab<<1;ac=A+1|0}else{ad=ab+16&-16;ae=(z=0,au(248,ad|0)|0);if(z){z=0;break}c[A+8>>2]=ae;c[A>>2]=ad|1;c[A+4>>2]=ab;ac=ae}LF(ac|0,aa|0,ab)|0;a[ac+ab|0]=0;Q=128;break L105}}while(0);ab=bT(-1,-1)|0;af=ab;ag=M}}while(0);do{if((Q|0)==128){Z=k;c[Z>>2]=c[F>>2];c[Z+4>>2]=c[F+4>>2];c[Z+8>>2]=c[F+8>>2];Z=B;a[Z]=0;a[B+1|0]=0;z=0;aG(2,g|0,A|0,k|0,+(+(r>>>0>>>0)),B|0);if(!z){if((a[Z]&1)!=0){Lw(c[B+8>>2]|0)}if((a[A]&1)==0){ah=b;break L75}Lw(c[A+8>>2]|0);ah=b;break L75}else{z=0;e=bT(-1,-1)|0;q=e;e=M;if((a[Z]&1)!=0){Lw(c[B+8>>2]|0)}if((a[A]&1)==0){af=q;ag=e;break}Lw(c[A+8>>2]|0);af=q;ag=e;break}}}while(0);r=c[d>>2]|0;g=c[t>>2]|0;e=r;while(1){if((e|0)==(g|0)){ai=g;break}if((c[e>>2]|0)==(_|0)){ai=e;break}else{e=e+4|0}}e=ai-r>>2;q=r+(e+1<<2)|0;Z=g-q|0;LG(r+(e<<2)|0,q|0,Z|0)|0;q=r+((Z>>2)+e<<2)|0;e=c[t>>2]|0;if((q|0)!=(e|0)){c[t>>2]=e+(~((e-4+(-q|0)|0)>>>2)<<2)}Lw(b);S=af;T=ag;break L54}}while(0);L139:do{if((Q|0)==56){h=(z=0,au(248,36)|0);if(z){z=0;Q=97;break L54}s=h;c[p>>2]=s;h=d+4|0;q=c[h>>2]|0;if((q|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,p|0);if(z){z=0;Q=97;break L54}aj=c[p>>2]|0}else{if((q|0)==0){ak=0}else{c[q>>2]=s;ak=c[h>>2]|0}c[h>>2]=ak+4;aj=s}s=aj;q=f;L150:do{if((a[q]&1)==0){e=y;c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];al=a[e]|0;am=e;Q=73}else{e=c[f+8>>2]|0;Z=c[f+4>>2]|0;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Z>>>0<11>>>0){E=Z<<1&255;ab=y;a[ab]=E;an=y+1|0;ao=E;ap=ab}else{ab=Z+16&-16;E=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[y+8>>2]=E;aa=ab|1;c[y>>2]=aa;c[y+4>>2]=Z;an=E;ao=aa&255;ap=y}LF(an|0,e|0,Z)|0;a[an+Z|0]=0;al=ao;am=ap;Q=73;break L150}}while(0);Z=bT(-1,-1)|0;aq=Z;av=M}}while(0);do{if((Q|0)==73){q=o;c[q>>2]=c[F>>2];c[q+4>>2]=c[F+4>>2];c[q+8>>2]=c[F+8>>2];q=o;b=m;t=n;r=aj;L165:do{if((al&1)==0){c[b>>2]=c[am>>2];c[b+4>>2]=c[am+4>>2];c[b+8>>2]=c[am+8>>2];Q=83}else{g=c[y+8>>2]|0;Z=c[y+4>>2]|0;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Z>>>0<11>>>0){a[b]=Z<<1;aw=m+1|0}else{e=Z+16&-16;aa=(z=0,au(248,e|0)|0);if(z){z=0;break}c[m+8>>2]=aa;c[m>>2]=e|1;c[m+4>>2]=Z;aw=aa}LF(aw|0,g|0,Z)|0;a[aw+Z|0]=0;Q=83;break L165}}while(0);Z=bT(-1,-1)|0;ax=M;ay=Z}}while(0);do{if((Q|0)==83){c[t>>2]=c[q>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];z=0;aD(6,r|0,m|0,n|0,0,0,0);if(z){z=0;Z=bT(-1,-1)|0;g=M;if((a[b]&1)==0){ax=g;ay=Z;break}Lw(c[m+8>>2]|0);ax=g;ay=Z;break}if((a[b]&1)!=0){Lw(c[m+8>>2]|0)}c[aj>>2]=19520;c[aj+32>>2]=6;if((a[am]&1)==0){ah=s;break L139}Lw(c[y+8>>2]|0);ah=s;break L139}}while(0);b=ay;r=ax;if((a[am]&1)==0){aq=b;av=r;break}Lw(c[y+8>>2]|0);aq=b;av=r}}while(0);r=c[d>>2]|0;b=c[h>>2]|0;q=r;while(1){if((q|0)==(b|0)){aA=b;break}if((c[q>>2]|0)==(aj|0)){aA=q;break}else{q=q+4|0}}q=aA-r>>2;t=r+(q+1<<2)|0;Z=b-t|0;LG(r+(q<<2)|0,t|0,Z|0)|0;t=r+((Z>>2)+q<<2)|0;q=c[h>>2]|0;if((t|0)!=(q|0)){c[h>>2]=q+(~((q-4+(-t|0)|0)>>>2)<<2)}Lw(s);S=aq;T=av;break L54}}while(0);if((a[N]&1)!=0){Lw(c[w+8>>2]|0)}t=ah;if((a[C]&1)==0){i=j;return t|0}Lw(c[u+8>>2]|0);i=j;return t|0}else{z=0;Q=97}}while(0);if((Q|0)==97){t=bT(-1,-1)|0;S=t;T=M}if((a[w]&1)==0){O=S;P=T;break}Lw(c[w+8>>2]|0);O=S;P=T}else{z=0;Q=94}}while(0);if((Q|0)==94){Q=bT(-1,-1)|0;O=Q;P=M}if((a[u]&1)==0){G=O;H=P;I=G;J=0;K=I;L=H;bg(K|0)}Lw(c[u+8>>2]|0);G=O;H=P;I=G;J=0;K=I;L=H;bg(K|0);return 0}function qY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;k=i;i=i+168|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=k+152|0;w=v;x=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=n;a[E]=14;F=n+1|0;a[F]=a[3544]|0;a[F+1|0]=a[3545]|0;a[F+2|0]=a[3546]|0;a[F+3|0]=a[3547]|0;a[F+4|0]=a[3548]|0;a[F+5|0]=a[3549]|0;a[F+6|0]=a[3550]|0;F=n+8|0;a[F]=0;G=o;H=g;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];G=(z=0,at(108,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;o=bT(-1,-1)|0;n=o;o=M;if((a[E]&1)==0){I=n;J=o;K=I;L=0;N=K;O=J;bg(N|0)}Lw(c[F>>2]|0);I=n;J=o;K=I;L=0;N=K;O=J;bg(N|0)}if((a[E]&1)!=0){Lw(c[F>>2]|0)}F=p;E=p;a[E]=18;LF(F+1|0,2240,9)|0;a[F+10|0]=0;F=q;c[F>>2]=c[H>>2];c[F+4>>2]=c[H+4>>2];c[F+8>>2]=c[H+8>>2];F=(z=0,at(44,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(z){z=0;q=bT(-1,-1)|0;o=q;q=M;if((a[E]&1)==0){I=o;J=q;K=I;L=0;N=K;O=J;bg(N|0)}Lw(c[p+8>>2]|0);I=o;J=q;K=I;L=0;N=K;O=J;bg(N|0)}if((a[E]&1)!=0){Lw(c[p+8>>2]|0)}p=r;a[p]=14;E=r+1|0;a[E]=a[2184]|0;a[E+1|0]=a[2185]|0;a[E+2|0]=a[2186]|0;a[E+3|0]=a[2187]|0;a[E+4|0]=a[2188]|0;a[E+5|0]=a[2189]|0;a[E+6|0]=a[2190]|0;E=r+8|0;a[E]=0;q=s;c[q>>2]=c[H>>2];c[q+4>>2]=c[H+4>>2];c[q+8>>2]=c[H+8>>2];q=(z=0,at(44,r|0,b|0,e|0,f|0,s|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;s=j;j=M;if((a[p]&1)==0){I=s;J=j;K=I;L=0;N=K;O=J;bg(N|0)}Lw(c[E>>2]|0);I=s;J=j;K=I;L=0;N=K;O=J;bg(N|0)}if((a[p]&1)!=0){Lw(c[E>>2]|0)}E=G+40|0;if((a[E]&1)==0){p=t;c[p>>2]=c[E>>2];c[p+4>>2]=c[E+4>>2];c[p+8>>2]=c[E+8>>2]}else{E=c[G+48>>2]|0;p=c[G+44>>2]|0;if(p>>>0>4294967279>>>0){D5(0);return 0}if(p>>>0<11>>>0){a[t]=p<<1;P=t+1|0}else{j=p+16&-16;s=Lu(j)|0;c[t+8>>2]=s;c[t>>2]=j|1;c[t+4>>2]=p;P=s}LF(P|0,E|0,p)|0;a[P+p|0]=0}p=G+40|0;P=p;E=a[p]|0;p=E&255;if((p&1|0)==0){Q=p>>>1}else{Q=c[G+44>>2]|0}do{if((Q|0)==0){R=0}else{p=(E&1)==0;if(p){S=P+1|0}else{S=c[G+48>>2]|0}if((a[S]|0)!=34){if(p){T=P+1|0}else{T=c[G+48>>2]|0}if((a[T]|0)!=39){R=0;break}}if(p){U=P+1|0}else{U=c[G+48>>2]|0}R=a[U]|0}}while(0);z=0;as(180,u|0,t|0);do{if(!z){z=0,aM(344,t|0,u|0)|0;if(z){z=0;U=bT(-1,-1)|0;G=U;U=M;if((a[u]&1)==0){V=G;W=U;break}Lw(c[u+8>>2]|0);V=G;W=U;break}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}X=+h[F+40>>3];U=(z=0,au(234,t|0)|0);if(z){z=0;Y=70;break}G=(z=0,aM(370,~~X|0,U|0)|0);if(z){z=0;Y=70;break}U=(z=0,aM(588,t|0,G|0)|0);if(z){z=0;Y=70;break}X=+h[q+40>>3];G=(z=0,au(234,t|0)|0);if(z){z=0;Y=70;break}P=(z=0,aM(370,~~X|0,G|0)|0);if(z){z=0;Y=70;break}G=(z=0,aM(588,t|0,P|0)|0);if(z){z=0;Y=70;break}LI(w|0,0,12)|0;P=G-U|0;do{if((U|0)==(G|0)){T=t;S=a[t]|0;E=S&255;if((E&1|0)==0){Z=E>>>1}else{Z=c[t+4>>2]|0}if(Z>>>0<U>>>0){z=0;ar(240,0);if(z){z=0;Y=73;break}return 0}if((S&1)==0){_=T+1|0}else{_=c[t+8>>2]|0}T=_+U|0;S=Z-U|0;E=S>>>0<P>>>0?S:P;if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Y=73;break}return 0}if(E>>>0<11>>>0){a[x]=E<<1;$=x+1|0}else{S=E+16&-16;Q=(z=0,au(248,S|0)|0);if(z){z=0;Y=73;break}c[x+8>>2]=Q;c[x>>2]=S|1;c[x+4>>2]=E;$=Q}LF($|0,T|0,E)|0;a[$+E|0]=0;z=0,aM(344,v|0,x|0)|0;if(!z){if((a[x]&1)==0){Y=98;break}Lw(c[x+8>>2]|0);Y=98;break}else{z=0;E=bT(-1,-1)|0;T=E;E=M;if((a[x]&1)==0){aa=T;ab=E;break}Lw(c[x+8>>2]|0);aa=T;ab=E;break}}else{E=(z=0,aM(384,t|0,G|0)|0);if(z){z=0;Y=73;break}T=E+P|0;E=t;Q=a[t]|0;S=Q&255;if((S&1|0)==0){ac=S>>>1}else{ac=c[t+4>>2]|0}if(ac>>>0<U>>>0){z=0;ar(240,0);if(z){z=0;Y=73;break}return 0}if((Q&1)==0){ad=E+1|0}else{ad=c[t+8>>2]|0}E=ad+U|0;Q=ac-U|0;S=Q>>>0<T>>>0?Q:T;if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;Y=73;break}return 0}if(S>>>0<11>>>0){a[y]=S<<1;ae=y+1|0}else{T=S+16&-16;Q=(z=0,au(248,T|0)|0);if(z){z=0;Y=73;break}c[y+8>>2]=Q;c[y>>2]=T|1;c[y+4>>2]=S;ae=Q}LF(ae|0,E|0,S)|0;a[ae+S|0]=0;z=0,aM(344,v|0,y|0)|0;if(!z){if((a[y]&1)==0){Y=98;break}Lw(c[y+8>>2]|0);Y=98;break}else{z=0;S=bT(-1,-1)|0;E=S;S=M;if((a[y]&1)==0){aa=E;ab=S;break}Lw(c[y+8>>2]|0);aa=E;ab=S;break}}}while(0);L135:do{if((Y|0)==98){do{if(R<<24>>24!=0){z=0;aR(286,A|0,v|0,R|0);if(z){z=0;Y=73;break L135}z=0,aM(344,v|0,A|0)|0;if(!z){if((a[A]&1)==0){break}Lw(c[A+8>>2]|0);break}else{z=0;U=bT(-1,-1)|0;P=U;U=M;if((a[A]&1)==0){aa=P;ab=U;break L135}Lw(c[A+8>>2]|0);aa=P;ab=U;break L135}}}while(0);U=(z=0,au(248,52)|0);if(z){z=0;Y=73;break}P=U;c[m>>2]=P;U=d+4|0;G=c[U>>2]|0;if((G|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,m|0);if(z){z=0;Y=73;break}af=c[m>>2]|0}else{if((G|0)==0){ag=0}else{c[G>>2]=P;ag=c[U>>2]|0}c[U>>2]=ag+4;af=P}P=af;G=af;S=f;L155:do{if((a[S]&1)==0){E=B;c[E>>2]=c[S>>2];c[E+4>>2]=c[S+4>>2];c[E+8>>2]=c[S+8>>2];Y=122}else{E=c[f+8>>2]|0;Q=c[f+4>>2]|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Q>>>0<11>>>0){a[B]=Q<<1;ah=B+1|0}else{T=Q+16&-16;p=(z=0,au(248,T|0)|0);if(z){z=0;break}c[B+8>>2]=p;c[B>>2]=T|1;c[B+4>>2]=Q;ah=p}LF(ah|0,E|0,Q)|0;a[ah+Q|0]=0;Y=122;break L155}}while(0);Q=bT(-1,-1)|0;ai=Q;aj=M}}while(0);do{if((Y|0)==122){S=C;c[S>>2]=c[H>>2];c[S+4>>2]=c[H+4>>2];c[S+8>>2]=c[H+8>>2];L170:do{if((a[w]&1)==0){Q=D;c[Q>>2]=c[w>>2];c[Q+4>>2]=c[w+4>>2];c[Q+8>>2]=c[w+8>>2];Y=132}else{Q=c[v+8>>2]|0;E=c[v+4>>2]|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(E>>>0<11>>>0){a[D]=E<<1;ak=D+1|0}else{p=E+16&-16;T=(z=0,au(248,p|0)|0);if(z){z=0;break}c[D+8>>2]=T;c[D>>2]=p|1;c[D+4>>2]=E;ak=T}LF(ak|0,Q|0,E)|0;a[ak+E|0]=0;Y=132;break L170}}while(0);E=bT(-1,-1)|0;al=E;am=M}}while(0);do{if((Y|0)==132){E=l;c[E>>2]=c[S>>2];c[E+4>>2]=c[S+4>>2];c[E+8>>2]=c[S+8>>2];z=0;aq(28,G|0,B|0,l|0,D|0,0);if(z){z=0;E=bT(-1,-1)|0;Q=E;E=M;if((a[D]&1)==0){al=Q;am=E;break}Lw(c[D+8>>2]|0);al=Q;am=E;break}E=af;if((a[D]&1)!=0){Lw(c[D+8>>2]|0)}if((a[B]&1)!=0){Lw(c[B+8>>2]|0)}if((a[w]&1)!=0){Lw(c[v+8>>2]|0)}if((a[t]&1)==0){i=k;return E|0}Lw(c[t+8>>2]|0);i=k;return E|0}}while(0);if((a[B]&1)==0){ai=al;aj=am;break}Lw(c[B+8>>2]|0);ai=al;aj=am}}while(0);G=c[d>>2]|0;S=c[U>>2]|0;E=G;while(1){if((E|0)==(S|0)){an=S;break}if((c[E>>2]|0)==(af|0)){an=E;break}else{E=E+4|0}}E=an-G>>2;Q=G+(E+1<<2)|0;T=S-Q|0;LG(G+(E<<2)|0,Q|0,T|0)|0;Q=G+((T>>2)+E<<2)|0;E=c[U>>2]|0;if((Q|0)!=(E|0)){c[U>>2]=E+(~((E-4+(-Q|0)|0)>>>2)<<2)}Lw(P);aa=ai;ab=aj}}while(0);if((Y|0)==73){Q=bT(-1,-1)|0;aa=Q;ab=M}if((a[w]&1)==0){V=aa;W=ab;break}Lw(c[v+8>>2]|0);V=aa;W=ab}else{z=0;Y=70}}while(0);if((Y|0)==70){Y=bT(-1,-1)|0;V=Y;W=M}if((a[t]&1)==0){I=V;J=W;K=I;L=0;N=K;O=J;bg(N|0)}Lw(c[t+8>>2]|0);I=V;J=W;K=I;L=0;N=K;O=J;bg(N|0);return 0}function qZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;j=i;i=i+120|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+88|0;r=j+104|0;s=m;a[s]=14;t=m+1|0;a[t]=a[3544]|0;a[t+1|0]=a[3545]|0;a[t+2|0]=a[3546]|0;a[t+3|0]=a[3547]|0;a[t+4|0]=a[3548]|0;a[t+5|0]=a[3549]|0;a[t+6|0]=a[3550]|0;t=m+8|0;a[t]=0;u=n;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=(z=0,at(108,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;n=h;h=M;if((a[s]&1)==0){w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[t>>2]|0);w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}if((a[s]&1)!=0){Lw(c[t>>2]|0)}t=u+40|0;if((a[t]&1)==0){s=o;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];D=a[s]|0;E=s}else{s=c[u+48>>2]|0;t=c[u+44>>2]|0;if(t>>>0>4294967279>>>0){D5(0);return 0}if(t>>>0<11>>>0){u=t<<1&255;h=o;a[h]=u;F=o+1|0;G=u;H=h}else{h=t+16&-16;u=Lu(h)|0;c[o+8>>2]=u;n=h|1;c[o>>2]=n;c[o+4>>2]=t;F=u;G=n&255;H=o}LF(F|0,s|0,t)|0;a[F+t|0]=0;D=G;E=H}H=D&255;if((H&1|0)==0){I=H>>>1}else{I=c[o+4>>2]|0}L26:do{if((I|0)==0){J=24}else{H=(a[E]&1)==0;D=o+1|0;G=o+8|0;t=0;while(1){F=(z=0,au(312,a[(H?D:c[G>>2]|0)+t|0]|0)|0);if(z){z=0;break}a[(H?D:c[G>>2]|0)+t|0]=F;F=t+1|0;if(F>>>0<I>>>0){t=F}else{J=24;break L26}}t=bT(-1,-1)|0;K=M;L=t;J=23}}while(0);L32:do{if((J|0)==24){I=(z=0,au(248,52)|0);do{if(!z){t=I;c[l>>2]=t;G=d+4|0;D=c[G>>2]|0;if((D|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,l|0);if(z){z=0;break}N=c[l>>2]|0}else{if((D|0)==0){O=0}else{c[D>>2]=t;O=c[G>>2]|0}c[G>>2]=O+4;N=t}t=N;D=N;H=f;L44:do{if((a[H]&1)==0){F=p;c[F>>2]=c[H>>2];c[F+4>>2]=c[H+4>>2];c[F+8>>2]=c[H+8>>2];J=41}else{F=c[f+8>>2]|0;s=c[f+4>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(s>>>0<11>>>0){a[p]=s<<1;P=p+1|0}else{n=s+16&-16;u=(z=0,au(248,n|0)|0);if(z){z=0;break}c[p+8>>2]=u;c[p>>2]=n|1;c[p+4>>2]=s;P=u}LF(P|0,F|0,s)|0;a[P+s|0]=0;J=41;break L44}}while(0);s=bT(-1,-1)|0;Q=s;R=M}}while(0);do{if((J|0)==41){H=q;c[H>>2]=c[v>>2];c[H+4>>2]=c[v+4>>2];c[H+8>>2]=c[v+8>>2];s=(a[E]&1)==0;L59:do{if(s){F=r;c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];J=51}else{F=c[o+8>>2]|0;u=c[o+4>>2]|0;do{if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(u>>>0<11>>>0){a[r]=u<<1;S=r+1|0}else{n=u+16&-16;h=(z=0,au(248,n|0)|0);if(z){z=0;break}c[r+8>>2]=h;c[r>>2]=n|1;c[r+4>>2]=u;S=h}LF(S|0,F|0,u)|0;a[S+u|0]=0;J=51;break L59}}while(0);u=bT(-1,-1)|0;T=u;U=M}}while(0);do{if((J|0)==51){u=k;c[u>>2]=c[H>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];z=0;aq(28,D|0,p|0,k|0,r|0,0);if(z){z=0;u=bT(-1,-1)|0;F=u;u=M;if((a[r]&1)==0){T=F;U=u;break}Lw(c[r+8>>2]|0);T=F;U=u;break}u=N;if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if(s){i=j;return u|0}Lw(c[o+8>>2]|0);i=j;return u|0}}while(0);if((a[p]&1)==0){Q=T;R=U;break}Lw(c[p+8>>2]|0);Q=T;R=U}}while(0);D=c[d>>2]|0;s=c[G>>2]|0;H=D;while(1){if((H|0)==(s|0)){V=s;break}if((c[H>>2]|0)==(N|0)){V=H;break}else{H=H+4|0}}H=V-D>>2;u=D+(H+1<<2)|0;F=s-u|0;LG(D+(H<<2)|0,u|0,F|0)|0;u=D+((F>>2)+H<<2)|0;H=c[G>>2]|0;if((u|0)!=(H|0)){c[G>>2]=H+(~((H-4+(-u|0)|0)>>>2)<<2)}Lw(t);W=Q;X=R;break L32}else{z=0}}while(0);I=bT(-1,-1)|0;K=M;L=I;J=23}}while(0);if((J|0)==23){W=L;X=K}if((a[E]&1)==0){w=W;x=X;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[o+8>>2]|0);w=W;x=X;y=w;A=0;B=y;C=x;bg(B|0);return 0}function q_(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;j=i;i=i+120|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+88|0;r=j+104|0;s=m;a[s]=14;t=m+1|0;a[t]=a[3544]|0;a[t+1|0]=a[3545]|0;a[t+2|0]=a[3546]|0;a[t+3|0]=a[3547]|0;a[t+4|0]=a[3548]|0;a[t+5|0]=a[3549]|0;a[t+6|0]=a[3550]|0;t=m+8|0;a[t]=0;u=n;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=(z=0,at(108,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;n=h;h=M;if((a[s]&1)==0){w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[t>>2]|0);w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}if((a[s]&1)!=0){Lw(c[t>>2]|0)}t=u+40|0;if((a[t]&1)==0){s=o;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];D=a[s]|0;E=s}else{s=c[u+48>>2]|0;t=c[u+44>>2]|0;if(t>>>0>4294967279>>>0){D5(0);return 0}if(t>>>0<11>>>0){u=t<<1&255;h=o;a[h]=u;F=o+1|0;G=u;H=h}else{h=t+16&-16;u=Lu(h)|0;c[o+8>>2]=u;n=h|1;c[o>>2]=n;c[o+4>>2]=t;F=u;G=n&255;H=o}LF(F|0,s|0,t)|0;a[F+t|0]=0;D=G;E=H}H=D&255;if((H&1|0)==0){I=H>>>1}else{I=c[o+4>>2]|0}L26:do{if((I|0)==0){J=24}else{H=(a[E]&1)==0;D=o+1|0;G=o+8|0;t=0;while(1){F=(z=0,au(60,a[(H?D:c[G>>2]|0)+t|0]|0)|0);if(z){z=0;break}a[(H?D:c[G>>2]|0)+t|0]=F;F=t+1|0;if(F>>>0<I>>>0){t=F}else{J=24;break L26}}t=bT(-1,-1)|0;K=M;L=t;J=23}}while(0);L32:do{if((J|0)==24){I=(z=0,au(248,52)|0);do{if(!z){t=I;c[l>>2]=t;G=d+4|0;D=c[G>>2]|0;if((D|0)==(c[d+8>>2]|0)){z=0;as(382,d|0,l|0);if(z){z=0;break}N=c[l>>2]|0}else{if((D|0)==0){O=0}else{c[D>>2]=t;O=c[G>>2]|0}c[G>>2]=O+4;N=t}t=N;D=N;H=f;L44:do{if((a[H]&1)==0){F=p;c[F>>2]=c[H>>2];c[F+4>>2]=c[H+4>>2];c[F+8>>2]=c[H+8>>2];J=41}else{F=c[f+8>>2]|0;s=c[f+4>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(s>>>0<11>>>0){a[p]=s<<1;P=p+1|0}else{n=s+16&-16;u=(z=0,au(248,n|0)|0);if(z){z=0;break}c[p+8>>2]=u;c[p>>2]=n|1;c[p+4>>2]=s;P=u}LF(P|0,F|0,s)|0;a[P+s|0]=0;J=41;break L44}}while(0);s=bT(-1,-1)|0;Q=s;R=M}}while(0);do{if((J|0)==41){H=q;c[H>>2]=c[v>>2];c[H+4>>2]=c[v+4>>2];c[H+8>>2]=c[v+8>>2];s=(a[E]&1)==0;L59:do{if(s){F=r;c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];J=51}else{F=c[o+8>>2]|0;u=c[o+4>>2]|0;do{if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(u>>>0<11>>>0){a[r]=u<<1;S=r+1|0}else{n=u+16&-16;h=(z=0,au(248,n|0)|0);if(z){z=0;break}c[r+8>>2]=h;c[r>>2]=n|1;c[r+4>>2]=u;S=h}LF(S|0,F|0,u)|0;a[S+u|0]=0;J=51;break L59}}while(0);u=bT(-1,-1)|0;T=u;U=M}}while(0);do{if((J|0)==51){u=k;c[u>>2]=c[H>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];z=0;aq(28,D|0,p|0,k|0,r|0,0);if(z){z=0;u=bT(-1,-1)|0;F=u;u=M;if((a[r]&1)==0){T=F;U=u;break}Lw(c[r+8>>2]|0);T=F;U=u;break}u=N;if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if(s){i=j;return u|0}Lw(c[o+8>>2]|0);i=j;return u|0}}while(0);if((a[p]&1)==0){Q=T;R=U;break}Lw(c[p+8>>2]|0);Q=T;R=U}}while(0);D=c[d>>2]|0;s=c[G>>2]|0;H=D;while(1){if((H|0)==(s|0)){V=s;break}if((c[H>>2]|0)==(N|0)){V=H;break}else{H=H+4|0}}H=V-D>>2;u=D+(H+1<<2)|0;F=s-u|0;LG(D+(H<<2)|0,u|0,F|0)|0;u=D+((F>>2)+H<<2)|0;H=c[G>>2]|0;if((u|0)!=(H|0)){c[G>>2]=H+(~((H-4+(-u|0)|0)>>>2)<<2)}Lw(t);W=Q;X=R;break L32}else{z=0}}while(0);I=bT(-1,-1)|0;K=M;L=I;J=23}}while(0);if((J|0)==23){W=L;X=K}if((a[E]&1)==0){w=W;x=X;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[o+8>>2]|0);w=W;x=X;y=w;A=0;B=y;C=x;bg(B|0);return 0}function q$(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0;k=i;i=i+168|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=k+152|0;w=n;x=n;a[x]=12;y=w+1|0;a[y]=a[1808]|0;a[y+1|0]=a[1809]|0;a[y+2|0]=a[1810]|0;a[y+3|0]=a[1811]|0;a[y+4|0]=a[1812]|0;a[y+5|0]=a[1813]|0;a[w+7|0]=0;w=o;y=g;c[w>>2]=c[y>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];w=(z=0,at(44,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;o=j;j=M;if((a[x]&1)==0){A=j;B=o;C=B;D=0;E=C;F=A;bg(E|0)}Lw(c[n+8>>2]|0);A=j;B=o;C=B;D=0;E=C;F=A;bg(E|0)}if((a[x]&1)!=0){Lw(c[n+8>>2]|0)}if((c[w+48>>2]|0)==(c[w+52>>2]|0)){if((c[w+60>>2]|0)!=(c[w+64>>2]|0)){G=6}}else{G=6}L13:do{if((G|0)==6){n=LJ(e|0)|0;if(n>>>0>4294967279>>>0){D5(0);return 0}if(n>>>0<11>>>0){x=n<<1&255;o=r;j=r;a[j]=x;H=o+1|0;I=x;J=o;K=j}else{j=n+16&-16;o=Lu(j)|0;c[r+8>>2]=o;x=j|1;c[r>>2]=x;c[r+4>>2]=n;H=o;I=x&255;J=r;K=r}LF(H|0,e|0,n)|0;a[H+n|0]=0;n=q;LI(n|0,0,12)|0;x=I&255;if((x&1|0)==0){L=x>>>1}else{L=c[r+4>>2]|0}x=L+20|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=25;break}return 0}else{if(x>>>0<11>>>0){a[n]=40;N=q+1|0}else{o=L+36&-16;j=(z=0,au(248,o|0)|0);if(z){z=0;G=25;break}c[q+8>>2]=j;c[q>>2]=o|1;c[q+4>>2]=20;N=j}LF(N|0,1744,20)|0;a[N+20|0]=0;if((I&1)==0){O=J+1|0}else{O=c[r+8>>2]|0}z=0,az(88,q|0,O|0,L|0)|0;if(z){z=0;G=25;break}j=p;LI(j|0,0,12)|0;o=a[n]|0;b=o&255;if((b&1|0)==0){P=b>>>1}else{P=c[q+4>>2]|0}if((o&1)==0){Q=q+1|0}else{Q=c[q+8>>2]|0}o=P+18|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=41;break}return 0}else{if(o>>>0<11>>>0){a[j]=P<<1;R=p+1|0}else{b=P+34&-16;g=(z=0,au(248,b|0)|0);if(z){z=0;G=41;break}c[p+8>>2]=g;c[p>>2]=b|1;c[p+4>>2]=P;R=g}LF(R|0,Q|0,P)|0;a[R+P|0]=0;z=0,az(88,p|0,1656,18)|0;if(z){z=0;G=41;break}g=f;L56:do{if((a[g]&1)==0){b=s;c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];G=53}else{b=c[f+8>>2]|0;S=c[f+4>>2]|0;do{if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(S>>>0<11>>>0){a[s]=S<<1;T=s+1|0}else{U=S+16&-16;V=(z=0,au(248,U|0)|0);if(z){z=0;break}c[s+8>>2]=V;c[s>>2]=U|1;c[s+4>>2]=S;T=V}LF(T|0,b|0,S)|0;a[T+S|0]=0;G=53;break L56}}while(0);S=bT(-1,-1)|0;W=M;X=S}}while(0);do{if((G|0)==53){g=t;c[g>>2]=c[y>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];z=0;aR(382,p|0,s|0,t|0);if(z){z=0;g=bT(-1,-1)|0;S=g;g=M;if((a[s]&1)==0){W=g;X=S;break}Lw(c[s+8>>2]|0);W=g;X=S;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}if((a[j]&1)!=0){Lw(c[p+8>>2]|0)}if((a[n]&1)!=0){Lw(c[q+8>>2]|0)}if((a[K]&1)==0){break L13}Lw(c[r+8>>2]|0);break L13}}while(0);if((a[j]&1)==0){Y=W;Z=X;break}Lw(c[p+8>>2]|0);Y=W;Z=X}}while(0);if((G|0)==41){o=bT(-1,-1)|0;S=M;if((a[j]&1)!=0){Lw(c[p+8>>2]|0)}Y=S;Z=o}if((a[n]&1)==0){_=Y;$=Z;break}Lw(c[q+8>>2]|0);_=Y;$=Z}}while(0);if((G|0)==25){x=bT(-1,-1)|0;o=M;if((a[n]&1)!=0){Lw(c[q+8>>2]|0)}_=o;$=x}if((a[K]&1)==0){A=_;B=$;C=B;D=0;E=C;F=A;bg(E|0)}Lw(c[r+8>>2]|0);A=_;B=$;C=B;D=0;E=C;F=A;bg(E|0)}}while(0);$=Lu(72)|0;c[m>>2]=$;_=d+4|0;r=c[_>>2]|0;if((r|0)==(c[d+8>>2]|0)){e4(d|0,m);aa=c[m>>2]|0}else{if((r|0)==0){ab=0}else{c[r>>2]=$;ab=c[_>>2]|0}c[_>>2]=ab+4;aa=$}$=aa;ab=aa;r=f;L114:do{if((a[r]&1)==0){m=u;c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];G=90}else{m=c[f+8>>2]|0;K=c[f+4>>2]|0;do{if(K>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(K>>>0<11>>>0){a[u]=K<<1;ac=u+1|0}else{q=K+16&-16;Z=(z=0,au(248,q|0)|0);if(z){z=0;break}c[u+8>>2]=Z;c[u>>2]=q|1;c[u+4>>2]=K;ac=Z}LF(ac|0,m|0,K)|0;a[ac+K|0]=0;G=90;break L114}}while(0);K=bT(-1,-1)|0;ad=M;ae=K}}while(0);do{if((G|0)==90){ac=l;c[ac>>2]=c[y>>2];c[ac+4>>2]=c[y+4>>2];c[ac+8>>2]=c[y+8>>2];af=+h[w+40>>3]*100.0;ac=v;f=v;a[f]=2;a[ac+1|0]=37;a[ac+2|0]=0;z=0;aG(2,ab|0,u|0,l|0,+af,v|0);if(z){z=0;ac=bT(-1,-1)|0;r=ac;ac=M;if((a[f]&1)!=0){Lw(c[v+8>>2]|0)}if((a[u]&1)==0){ad=ac;ae=r;break}Lw(c[u+8>>2]|0);ad=ac;ae=r;break}r=aa;if((a[f]&1)!=0){Lw(c[v+8>>2]|0)}if((a[u]&1)==0){i=k;return r|0}Lw(c[u+8>>2]|0);i=k;return r|0}}while(0);k=c[d>>2]|0;d=c[_>>2]|0;u=k;while(1){if((u|0)==(d|0)){ag=d;break}if((c[u>>2]|0)==(aa|0)){ag=u;break}else{u=u+4|0}}u=ag-k>>2;ag=k+(u+1<<2)|0;aa=d-ag|0;LG(k+(u<<2)|0,ag|0,aa|0)|0;ag=k+((aa>>2)+u<<2)|0;u=c[_>>2]|0;if((ag|0)!=(u|0)){c[_>>2]=u+(~((u-4+(-ag|0)|0)>>>2)<<2)}Lw($);A=ad;B=ae;C=B;D=0;E=C;F=A;bg(E|0);return 0}function q0(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,N=0.0,O=0.0,P=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[1808]|0;a[s+1|0]=a[1809]|0;a[s+2|0]=a[1810]|0;a[s+3|0]=a[1811]|0;a[s+4|0]=a[1812]|0;a[s+5|0]=a[1813]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(z=0,at(44,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;n=j;j=M;if((a[r]&1)==0){t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[m+8>>2]|0);t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}if((a[r]&1)!=0){Lw(c[m+8>>2]|0)}m=Lu(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){e4(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;z=0;as(566,A|0,q|0);if(z){z=0;q=bT(-1,-1)|0;B=q;q=M;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;LG(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}Lw(m);t=B;u=q;v=t;w=0;x=v;y=u;bg(x|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){D5(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=Lu(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}LF(D|0,q|0,B)|0;a[D+B|0]=0}B=(z=0,aM(344,A+4|0,p|0)|0);do{if(!z){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(z=0,au(248,m|0)|0);if(z){z=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}LF(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){Lw(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=L+.5;O=+W(N);h[K>>3]=O;P=A;i=k;return P|0}Lw(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=L+.5;O=+W(N);h[K>>3]=O;P=A;i=k;return P|0}else{z=0}}while(0);P=bT(-1,-1)|0;k=P;P=M;if((a[p]&1)==0){t=k;u=P;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[p+8>>2]|0);t=k;u=P;v=t;w=0;x=v;y=u;bg(x|0);return 0}function q1(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,N=0.0,O=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[1808]|0;a[s+1|0]=a[1809]|0;a[s+2|0]=a[1810]|0;a[s+3|0]=a[1811]|0;a[s+4|0]=a[1812]|0;a[s+5|0]=a[1813]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(z=0,at(44,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;n=j;j=M;if((a[r]&1)==0){t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[m+8>>2]|0);t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}if((a[r]&1)!=0){Lw(c[m+8>>2]|0)}m=Lu(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){e4(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;z=0;as(566,A|0,q|0);if(z){z=0;q=bT(-1,-1)|0;B=q;q=M;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;LG(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}Lw(m);t=B;u=q;v=t;w=0;x=v;y=u;bg(x|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){D5(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=Lu(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}LF(D|0,q|0,B)|0;a[D+B|0]=0}B=(z=0,aM(344,A+4|0,p|0)|0);do{if(!z){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(z=0,au(248,m|0)|0);if(z){z=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}LF(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){Lw(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=+ah(L);h[K>>3]=N;O=A;i=k;return O|0}Lw(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=+ah(L);h[K>>3]=N;O=A;i=k;return O|0}else{z=0}}while(0);O=bT(-1,-1)|0;k=O;O=M;if((a[p]&1)==0){t=k;u=O;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[p+8>>2]|0);t=k;u=O;v=t;w=0;x=v;y=u;bg(x|0);return 0}function q2(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,N=0.0,O=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[1808]|0;a[s+1|0]=a[1809]|0;a[s+2|0]=a[1810]|0;a[s+3|0]=a[1811]|0;a[s+4|0]=a[1812]|0;a[s+5|0]=a[1813]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(z=0,at(44,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;n=j;j=M;if((a[r]&1)==0){t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[m+8>>2]|0);t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}if((a[r]&1)!=0){Lw(c[m+8>>2]|0)}m=Lu(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){e4(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;z=0;as(566,A|0,q|0);if(z){z=0;q=bT(-1,-1)|0;B=q;q=M;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;LG(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}Lw(m);t=B;u=q;v=t;w=0;x=v;y=u;bg(x|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){D5(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=Lu(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}LF(D|0,q|0,B)|0;a[D+B|0]=0}B=(z=0,aM(344,A+4|0,p|0)|0);do{if(!z){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(z=0,au(248,m|0)|0);if(z){z=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}LF(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){Lw(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=+W(L);h[K>>3]=N;O=A;i=k;return O|0}Lw(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=+W(L);h[K>>3]=N;O=A;i=k;return O|0}else{z=0}}while(0);O=bT(-1,-1)|0;k=O;O=M;if((a[p]&1)==0){t=k;u=O;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[p+8>>2]|0);t=k;u=O;v=t;w=0;x=v;y=u;bg(x|0);return 0}function q3(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,N=0.0,O=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[1808]|0;a[s+1|0]=a[1809]|0;a[s+2|0]=a[1810]|0;a[s+3|0]=a[1811]|0;a[s+4|0]=a[1812]|0;a[s+5|0]=a[1813]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(z=0,at(44,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(z){z=0;j=bT(-1,-1)|0;n=j;j=M;if((a[r]&1)==0){t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[m+8>>2]|0);t=n;u=j;v=t;w=0;x=v;y=u;bg(x|0)}if((a[r]&1)!=0){Lw(c[m+8>>2]|0)}m=Lu(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){e4(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;z=0;as(566,A|0,q|0);if(z){z=0;q=bT(-1,-1)|0;B=q;q=M;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;LG(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}Lw(m);t=B;u=q;v=t;w=0;x=v;y=u;bg(x|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){D5(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=Lu(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}LF(D|0,q|0,B)|0;a[D+B|0]=0}B=(z=0,aM(344,A+4|0,p|0)|0);do{if(!z){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(z=0,au(248,m|0)|0);if(z){z=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}LF(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){Lw(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=+X(+L);h[K>>3]=N;O=A;i=k;return O|0}Lw(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;K=J;L=+h[K>>3];N=+X(+L);h[K>>3]=N;O=A;i=k;return O|0}else{z=0}}while(0);O=bT(-1,-1)|0;k=O;O=M;if((a[p]&1)==0){t=k;u=O;v=t;w=0;x=v;y=u;bg(x|0)}Lw(c[p+8>>2]|0);t=k;u=O;v=t;w=0;x=v;y=u;bg(x|0);return 0}function q4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,as=0,av=0,aw=0,ax=0;j=i;i=i+144|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=j+96|0;r=j+112|0;s=j+128|0;t=k;a[t]=6;u=k+1|0;a[u]=a[1120]|0;a[u+1|0]=a[1121]|0;a[u+2|0]=a[1122]|0;a[k+4|0]=0;u=l;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=(z=0,at(44,k|0,b|0,e|0,f|0,l|0,h|0)|0);if(z){z=0;l=bT(-1,-1)|0;g=l;l=M;if((a[t]&1)==0){w=g;x=l;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[k+8>>2]|0);w=g;x=l;y=w;A=0;B=y;C=x;bg(B|0)}if((a[t]&1)!=0){Lw(c[k+8>>2]|0)}k=m;a[k]=6;t=m+1|0;a[t]=a[1096]|0;a[t+1|0]=a[1097]|0;a[t+2|0]=a[1098]|0;a[m+4|0]=0;t=n;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(z=0,at(54,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;n=h;h=M;if((a[k]&1)==0){w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[m+8>>2]|0);w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}if((a[k]&1)!=0){Lw(c[m+8>>2]|0)}m=t+40|0;k=c[m>>2]|0;h=(c[t+44>>2]|0)-k>>2;if((h|0)==0){D=u;E=D|0;i=j;return E|0}n=t+56|0;t=q;b=q+1|0;l=p;g=p+1|0;F=o;G=o+1|0;H=f;I=r;J=s;K=q+8|0;L=p+8|0;N=o+8|0;O=r+8|0;P=f+8|0;Q=f+4|0;f=r+1|0;R=r|0;S=r+4|0;T=o|0;U=o+4|0;V=p+4|0;W=p|0;X=q+4|0;Y=q|0;q=u;u=0;Z=k;L24:while(1){k=c[Z+(u<<2)>>2]|0;if((a[n]&1)==0){_=k}else{_=c[k+36>>2]|0}if((_|0)==0){$=17}else{k=Lh(_,32360,31368,-1)|0;if((k|0)==0){$=17}else{aa=k}}do{if(($|0)==17){$=0;k=LJ(e|0)|0;if(k>>>0>4294967279>>>0){$=18;break L24}if(k>>>0<11>>>0){ab=k<<1&255;a[t]=ab;ac=b;ad=ab}else{ab=k+16&-16;ae=Lu(ab)|0;c[K>>2]=ae;af=ab|1;c[Y>>2]=af;c[X>>2]=k;ac=ae;ad=af&255}LF(ac|0,e|0,k)|0;a[ac+k|0]=0;LI(l|0,0,12)|0;k=ad&255;af=(k&1|0)==0?k>>>1:c[X>>2]|0;k=af+1|0;if(k>>>0>4294967279>>>0){$=23;break L24}if(k>>>0<11>>>0){a[l]=2;ag=g}else{k=af+17&-16;ae=(z=0,au(248,k|0)|0);if(z){z=0;$=30;break L24}c[L>>2]=ae;c[W>>2]=k|1;c[V>>2]=1;ag=ae}a[ag]=96;a[ag+1|0]=0;ae=(ad&1)==0?b:c[K>>2]|0;z=0,az(88,p|0,ae|0,af|0)|0;if(z){z=0;$=30;break L24}LI(F|0,0,12)|0;af=a[l]|0;ae=af&255;k=(ae&1|0)==0?ae>>>1:c[V>>2]|0;ae=(af&1)==0?g:c[L>>2]|0;af=k+30|0;if(af>>>0>4294967279>>>0){$=35;break L24}if(af>>>0<11>>>0){a[F]=k<<1;ah=G}else{af=k+46&-16;ab=(z=0,au(248,af|0)|0);if(z){z=0;$=42;break L24}c[N>>2]=ab;c[T>>2]=af|1;c[U>>2]=k;ah=ab}LF(ah|0,ae|0,k)|0;a[ah+k|0]=0;z=0,az(88,o|0,1008,30)|0;if(z){z=0;$=42;break L24}if((a[H]&1)==0){c[I>>2]=c[H>>2];c[I+4>>2]=c[H+4>>2];c[I+8>>2]=c[H+8>>2]}else{k=c[P>>2]|0;ae=c[Q>>2]|0;if(ae>>>0>4294967279>>>0){$=49;break L24}if(ae>>>0<11>>>0){a[I]=ae<<1;ai=f}else{ab=ae+16&-16;af=(z=0,au(248,ab|0)|0);if(z){z=0;$=67;break L24}c[O>>2]=af;c[R>>2]=ab|1;c[S>>2]=ae;ai=af}LF(ai|0,k|0,ae)|0;a[ai+ae|0]=0}c[J>>2]=c[v>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];z=0;aR(382,o|0,r|0,s|0);if(z){z=0;$=70;break L24}if((a[I]&1)!=0){Lw(c[O>>2]|0)}if((a[F]&1)!=0){Lw(c[N>>2]|0)}if((a[l]&1)!=0){Lw(c[L>>2]|0)}if((a[t]&1)==0){aa=0;break}Lw(c[K>>2]|0);aa=0}}while(0);ae=i9(aa|0,q|0,d)|0;k=ae?aa:q;ae=u+1|0;if(ae>>>0>=h>>>0){D=k;$=83;break}q=k;u=ae;Z=c[m>>2]|0}do{if(($|0)==35){z=0;ar(86,0);if(!z){return 0}else{z=0;m=bT(-1,-1)|0;aj=M;ak=m;$=44;break}}else if(($|0)==49){z=0;ar(86,0);if(!z){return 0}else{z=0;m=bT(-1,-1)|0;al=M;am=m;$=69;break}}else if(($|0)==67){m=bT(-1,-1)|0;al=M;am=m;$=69}else if(($|0)==83){E=D|0;i=j;return E|0}else if(($|0)==23){z=0;ar(86,0);if(!z){return 0}else{z=0;m=bT(-1,-1)|0;an=M;ao=m;$=32;break}}else if(($|0)==30){m=bT(-1,-1)|0;an=M;ao=m;$=32}else if(($|0)==70){m=bT(-1,-1)|0;Z=m;m=M;if((a[I]&1)==0){ap=Z;aq=m;$=72;break}Lw(c[O>>2]|0);ap=Z;aq=m;$=72}else if(($|0)==42){m=bT(-1,-1)|0;aj=M;ak=m;$=44}else if(($|0)==18){D5(0);return 0}}while(0);if(($|0)==44){if((a[F]&1)!=0){Lw(c[N>>2]|0)}as=ak;av=aj;$=74}else if(($|0)==32){if((a[l]&1)!=0){Lw(c[L>>2]|0)}aw=ao;ax=an}else if(($|0)==69){ap=am;aq=al;$=72}do{if(($|0)==72){if((a[F]&1)==0){as=ap;av=aq;$=74;break}Lw(c[N>>2]|0);as=ap;av=aq;$=74}}while(0);do{if(($|0)==74){if((a[l]&1)==0){aw=as;ax=av;break}Lw(c[L>>2]|0);aw=as;ax=av}}while(0);if((a[t]&1)==0){w=aw;x=ax;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[K>>2]|0);w=aw;x=ax;y=w;A=0;B=y;C=x;bg(B|0);return 0}function q5(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){D5(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=Lu(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}LF(t|0,r|0,s)|0;a[t+s|0]=0}s=(z=0,aM(90,d|0,k|0)|0);if(z){z=0;d=bT(-1,-1)|0;t=d;d=M;if((a[k]&1)==0){w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[k+8>>2]|0);w=d;x=t;y=x;A=0;B=y;C=w;bg(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=Lh(t,31184,31536,-1)|0}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;LF(k+1|0,9104,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){F=b+1|0}else{F=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){G=q>>>1}else{G=c[b+4>>2]|0}z=0,az(88,l|0,F|0,G|0)|0;do{if(!z){z=0,az(88,l|0,7312,6)|0;if(z){z=0;H=57;break}G=LJ(e|0)|0;z=0,az(88,l|0,e|0,G|0)|0;if(z){z=0;H=57;break}z=0,az(88,l|0,11048,12)|0;if(z){z=0;H=57;break}G=m;F=m;a[F]=8;b=G+1|0;q=b;E=1953720684;a[q]=E;E=E>>8;a[q+1|0]=E;E=E>>8;a[q+2|0]=E;E=E>>8;a[q+3|0]=E;a[G+5|0]=0;z=0,az(88,l|0,b|0,4)|0;if(z){z=0;b=bT(-1,-1)|0;G=b;b=M;if((a[F]&1)==0){I=b;J=G;break}Lw(c[m+8>>2]|0);I=b;J=G;break}if((a[F]&1)!=0){Lw(c[m+8>>2]|0)}if((a[t]&1)==0){F=n;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2]}else{F=c[l+8>>2]|0;G=c[l+4>>2]|0;if(G>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;H=57;break}return 0}if(G>>>0<11>>>0){a[n]=G<<1;K=n+1|0}else{b=G+16&-16;q=(z=0,au(248,b|0)|0);if(z){z=0;H=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=G;K=q}LF(K|0,F|0,G)|0;a[K+G|0]=0}G=f;L61:do{if((a[G]&1)==0){F=o;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];H=50}else{F=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;L=o+1|0}else{b=q+16&-16;k=(z=0,au(248,b|0)|0);if(z){z=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;L=k}LF(L|0,F|0,q)|0;a[L+q|0]=0;H=50;break L61}}while(0);q=bT(-1,-1)|0;N=M;O=q}}while(0);do{if((H|0)==50){G=p;q=g;c[G>>2]=c[q>>2];c[G+4>>2]=c[q+4>>2];c[G+8>>2]=c[q+8>>2];z=0;aV(46,n|0,o|0,p|0,h|0);if(z){z=0;q=bT(-1,-1)|0;G=q;q=M;if((a[o]&1)==0){N=q;O=G;break}Lw(c[o+8>>2]|0);N=q;O=G;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}Lw(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){I=N;J=O;break}Lw(c[n+8>>2]|0);I=N;J=O}else{z=0;H=57}}while(0);if((H|0)==57){H=bT(-1,-1)|0;I=M;J=H}if((a[t]&1)==0){w=I;x=J;y=x;A=0;B=y;C=w;bg(B|0)}Lw(c[l+8>>2]|0);w=I;x=J;y=x;A=0;B=y;C=w;bg(B|0);return 0}function q6(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,as=0,av=0,aw=0,ax=0;j=i;i=i+144|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=j+96|0;r=j+112|0;s=j+128|0;t=k;a[t]=6;u=k+1|0;a[u]=a[1120]|0;a[u+1|0]=a[1121]|0;a[u+2|0]=a[1122]|0;a[k+4|0]=0;u=l;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=(z=0,at(44,k|0,b|0,e|0,f|0,l|0,h|0)|0);if(z){z=0;l=bT(-1,-1)|0;g=l;l=M;if((a[t]&1)==0){w=g;x=l;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[k+8>>2]|0);w=g;x=l;y=w;A=0;B=y;C=x;bg(B|0)}if((a[t]&1)!=0){Lw(c[k+8>>2]|0)}k=m;a[k]=6;t=m+1|0;a[t]=a[1096]|0;a[t+1|0]=a[1097]|0;a[t+2|0]=a[1098]|0;a[m+4|0]=0;t=n;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(z=0,at(54,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(z){z=0;h=bT(-1,-1)|0;n=h;h=M;if((a[k]&1)==0){w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[m+8>>2]|0);w=n;x=h;y=w;A=0;B=y;C=x;bg(B|0)}if((a[k]&1)!=0){Lw(c[m+8>>2]|0)}m=t+40|0;k=c[m>>2]|0;h=(c[t+44>>2]|0)-k>>2;if((h|0)==0){D=u;E=D|0;i=j;return E|0}n=t+56|0;t=q;b=q+1|0;l=p;g=p+1|0;F=o;G=o+1|0;H=f;I=r;J=s;K=q+8|0;L=p+8|0;N=o+8|0;O=r+8|0;P=f+8|0;Q=f+4|0;f=r+1|0;R=r|0;S=r+4|0;T=o|0;U=o+4|0;V=p+4|0;W=p|0;X=q+4|0;Y=q|0;q=u;u=0;Z=k;L24:while(1){k=c[Z+(u<<2)>>2]|0;if((a[n]&1)==0){_=k}else{_=c[k+36>>2]|0}if((_|0)==0){$=17}else{k=Lh(_,32360,31368,-1)|0;if((k|0)==0){$=17}else{aa=k}}do{if(($|0)==17){$=0;k=LJ(e|0)|0;if(k>>>0>4294967279>>>0){$=18;break L24}if(k>>>0<11>>>0){ab=k<<1&255;a[t]=ab;ac=b;ad=ab}else{ab=k+16&-16;ae=Lu(ab)|0;c[K>>2]=ae;af=ab|1;c[Y>>2]=af;c[X>>2]=k;ac=ae;ad=af&255}LF(ac|0,e|0,k)|0;a[ac+k|0]=0;LI(l|0,0,12)|0;k=ad&255;af=(k&1|0)==0?k>>>1:c[X>>2]|0;k=af+1|0;if(k>>>0>4294967279>>>0){$=23;break L24}if(k>>>0<11>>>0){a[l]=2;ag=g}else{k=af+17&-16;ae=(z=0,au(248,k|0)|0);if(z){z=0;$=30;break L24}c[L>>2]=ae;c[W>>2]=k|1;c[V>>2]=1;ag=ae}a[ag]=96;a[ag+1|0]=0;ae=(ad&1)==0?b:c[K>>2]|0;z=0,az(88,p|0,ae|0,af|0)|0;if(z){z=0;$=30;break L24}LI(F|0,0,12)|0;af=a[l]|0;ae=af&255;k=(ae&1|0)==0?ae>>>1:c[V>>2]|0;ae=(af&1)==0?g:c[L>>2]|0;af=k+30|0;if(af>>>0>4294967279>>>0){$=35;break L24}if(af>>>0<11>>>0){a[F]=k<<1;ah=G}else{af=k+46&-16;ab=(z=0,au(248,af|0)|0);if(z){z=0;$=42;break L24}c[N>>2]=ab;c[T>>2]=af|1;c[U>>2]=k;ah=ab}LF(ah|0,ae|0,k)|0;a[ah+k|0]=0;z=0,az(88,o|0,1008,30)|0;if(z){z=0;$=42;break L24}if((a[H]&1)==0){c[I>>2]=c[H>>2];c[I+4>>2]=c[H+4>>2];c[I+8>>2]=c[H+8>>2]}else{k=c[P>>2]|0;ae=c[Q>>2]|0;if(ae>>>0>4294967279>>>0){$=49;break L24}if(ae>>>0<11>>>0){a[I]=ae<<1;ai=f}else{ab=ae+16&-16;af=(z=0,au(248,ab|0)|0);if(z){z=0;$=67;break L24}c[O>>2]=af;c[R>>2]=ab|1;c[S>>2]=ae;ai=af}LF(ai|0,k|0,ae)|0;a[ai+ae|0]=0}c[J>>2]=c[v>>2];c[J+4>>2]=c[v+4>>2];c[J+8>>2]=c[v+8>>2];z=0;aR(382,o|0,r|0,s|0);if(z){z=0;$=70;break L24}if((a[I]&1)!=0){Lw(c[O>>2]|0)}if((a[F]&1)!=0){Lw(c[N>>2]|0)}if((a[l]&1)!=0){Lw(c[L>>2]|0)}if((a[t]&1)==0){aa=0;break}Lw(c[K>>2]|0);aa=0}}while(0);ae=i9(q|0,aa|0,d)|0;k=ae?aa:q;ae=u+1|0;if(ae>>>0>=h>>>0){D=k;$=83;break}q=k;u=ae;Z=c[m>>2]|0}do{if(($|0)==35){z=0;ar(86,0);if(!z){return 0}else{z=0;m=bT(-1,-1)|0;aj=M;ak=m;$=44;break}}else if(($|0)==83){E=D|0;i=j;return E|0}else if(($|0)==42){m=bT(-1,-1)|0;aj=M;ak=m;$=44}else if(($|0)==67){m=bT(-1,-1)|0;al=M;am=m;$=69}else if(($|0)==30){m=bT(-1,-1)|0;an=M;ao=m;$=32}else if(($|0)==23){z=0;ar(86,0);if(!z){return 0}else{z=0;m=bT(-1,-1)|0;an=M;ao=m;$=32;break}}else if(($|0)==70){m=bT(-1,-1)|0;Z=m;m=M;if((a[I]&1)==0){ap=Z;aq=m;$=72;break}Lw(c[O>>2]|0);ap=Z;aq=m;$=72}else if(($|0)==49){z=0;ar(86,0);if(!z){return 0}else{z=0;m=bT(-1,-1)|0;al=M;am=m;$=69;break}}else if(($|0)==18){D5(0);return 0}}while(0);if(($|0)==32){if((a[l]&1)!=0){Lw(c[L>>2]|0)}as=ao;av=an}else if(($|0)==44){if((a[F]&1)!=0){Lw(c[N>>2]|0)}aw=ak;ax=aj;$=74}else if(($|0)==69){ap=am;aq=al;$=72}do{if(($|0)==72){if((a[F]&1)==0){aw=ap;ax=aq;$=74;break}Lw(c[N>>2]|0);aw=ap;ax=aq;$=74}}while(0);do{if(($|0)==74){if((a[l]&1)==0){as=aw;av=ax;break}Lw(c[L>>2]|0);as=aw;av=ax}}while(0);if((a[t]&1)==0){w=as;x=av;y=w;A=0;B=y;C=x;bg(B|0)}Lw(c[K>>2]|0);w=as;x=av;y=w;A=0;B=y;C=x;bg(B|0);return 0}function q7(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;h=i;i=i+88|0;e=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];e=h|0;j=h+16|0;k=h+24|0;l=h+40|0;m=h+56|0;n=h+72|0;o=k;p=k;a[p]=10;q=o+1|0;a[q]=a[864]|0;a[q+1|0]=a[865]|0;a[q+2|0]=a[866]|0;a[q+3|0]=a[867]|0;a[q+4|0]=a[868]|0;a[o+6|0]=0;o=(z=0,aM(90,b|0,k|0)|0);if(z){z=0;b=bT(-1,-1)|0;q=b;b=M;if((a[p]&1)==0){r=b;s=q;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=b;s=q;t=s;u=0;v=t;w=r;bg(v|0)}q=c[o>>2]|0;if((q|0)==0){x=0}else{x=Lh(q,31184,31536,-1)|0}if((a[p]&1)!=0){Lw(c[k+8>>2]|0)}k=Lu(72)|0;c[j>>2]=k;p=d+4|0;q=c[p>>2]|0;if((q|0)==(c[d+8>>2]|0)){e4(d|0,j);y=c[j>>2]|0}else{if((q|0)==0){A=0}else{c[q>>2]=k;A=c[p>>2]|0}c[p>>2]=A+4;y=k}k=y;A=y;q=f;L21:do{if((a[q]&1)==0){j=l;c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];B=23}else{j=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(o>>>0<11>>>0){a[l]=o<<1;C=l+1|0}else{b=o+16&-16;D=(z=0,au(248,b|0)|0);if(z){z=0;break}c[l+8>>2]=D;c[l>>2]=b|1;c[l+4>>2]=o;C=D}LF(C|0,j|0,o)|0;a[C+o|0]=0;B=23;break L21}}while(0);o=bT(-1,-1)|0;E=M;F=o}}while(0);do{if((B|0)==23){C=m;f=g;c[C>>2]=c[f>>2];c[C+4>>2]=c[f+4>>2];c[C+8>>2]=c[f+8>>2];if((x|0)==0){G=1.0}else{G=+((c[x+44>>2]|0)-(c[x+40>>2]|0)>>2>>>0>>>0)}f=n;a[f]=0;a[n+1|0]=0;q=e;c[q>>2]=c[C>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];z=0;aG(2,A|0,l|0,e|0,+G,n|0);if(z){z=0;C=bT(-1,-1)|0;q=C;C=M;if((a[f]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)==0){E=C;F=q;break}Lw(c[l+8>>2]|0);E=C;F=q;break}q=y;if((a[f]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)==0){i=h;return q|0}Lw(c[l+8>>2]|0);i=h;return q|0}}while(0);h=c[d>>2]|0;d=c[p>>2]|0;l=h;while(1){if((l|0)==(d|0)){H=d;break}if((c[l>>2]|0)==(y|0)){H=l;break}else{l=l+4|0}}l=H-h>>2;H=h+(l+1<<2)|0;y=d-H|0;LG(h+(l<<2)|0,H|0,y|0)|0;H=h+((y>>2)+l<<2)|0;l=c[p>>2]|0;if((H|0)!=(l|0)){c[p>>2]=l+(~((l-4+(-H|0)|0)>>>2)<<2)}Lw(k);r=E;s=F;t=s;u=0;v=t;w=r;bg(v|0);return 0}
function uQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,as=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0;d=i;i=i+264|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+72|0;m=d+88|0;n=d+104|0;o=d+120|0;p=d+136|0;q=d+152|0;r=d+168|0;s=d+184|0;t=d+200|0;u=d+216|0;v=d+232|0;w=d+248|0;do{if((uR(b)|0)==0){if((uS(b)|0)!=0){break}do{if((ul(b)|0)==0){if((uT(b)|0)!=0){break}x=b+20|0;if((zJ(y$(c[x>>2]|0)|0)|0)!=0){y=uU(b)|0;i=d;return y|0}A=y$(c[x>>2]|0)|0;do{if((A+1|0)==0|(a[A]|0)!=58){if((zI(y$(c[x>>2]|0)|0)|0)!=0){break}B=y$(c[x>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=91)){y=uW(b)|0;i=d;return y|0}if((uX(b)|0)==0){B=c[b+56>>2]|0;C=(c[b+60>>2]|0)-B|0;if(C>>>0>4294967279>>>0){D5(0);return 0}if(C>>>0<11>>>0){D=C<<1&255;E=v;F=v;a[F]=D;G=E+1|0;H=D;I=E;J=F}else{F=C+16&-16;E=Lu(F)|0;c[v+8>>2]=E;D=F|1;c[v>>2]=D;c[v+4>>2]=C;G=E;H=D&255;I=v;J=v}LF(G|0,B|0,C)|0;a[G+C|0]=0;C=u;LI(C|0,0,12)|0;B=H&255;if((B&1|0)==0){K=B>>>1}else{K=c[v+4>>2]|0}B=K+23|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;L=149;break}return 0}else{if(B>>>0<11>>>0){a[C]=46;N=u+1|0}else{D=K+39&-16;E=(z=0,au(248,D|0)|0);if(z){z=0;L=149;break}c[u+8>>2]=E;c[u>>2]=D|1;c[u+4>>2]=23;N=E}LF(N|0,8984,23)|0;a[N+23|0]=0;if((H&1)==0){O=I+1|0}else{O=c[v+8>>2]|0}z=0,az(88,u|0,O|0,K|0)|0;if(z){z=0;L=149;break}c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;z=0;aR(492,b|0,u|0,w|0);if(z){z=0;E=bT(-1,-1)|0;D=E;E=M;if((a[C]&1)==0){P=E;Q=D;break}Lw(c[u+8>>2]|0);P=E;Q=D;break}if((a[C]&1)!=0){Lw(c[u+8>>2]|0)}if((a[J]&1)==0){y=0;i=d;return y|0}Lw(c[v+8>>2]|0);y=0;i=d;return y|0}}while(0);if((L|0)==149){B=bT(-1,-1)|0;D=M;if((a[C]&1)!=0){Lw(c[u+8>>2]|0)}P=D;Q=B}if((a[J]&1)==0){R=P;S=Q;T=S;U=0;V=T;W=R;bg(V|0)}Lw(c[v+8>>2]|0);R=P;S=Q;T=S;U=0;V=T;W=R;bg(V|0)}B=c[b>>2]|0;D=Lu(44)|0;c[f>>2]=D;E=B+4|0;F=c[E>>2]|0;if((F|0)==(c[B+8>>2]|0)){e4(B|0,f);X=c[f>>2]|0}else{if((F|0)==0){Y=0}else{c[F>>2]=D;Y=c[E>>2]|0}c[E>>2]=Y+4;X=D}D=X;F=X;Z=b+28|0;L74:do{if((a[Z]&1)==0){_=r;c[_>>2]=c[Z>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];L=106}else{_=c[b+36>>2]|0;$=c[b+32>>2]|0;do{if($>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if($>>>0<11>>>0){a[r]=$<<1;aa=r+1|0}else{ab=$+16&-16;ac=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[r+8>>2]=ac;c[r>>2]=ab|1;c[r+4>>2]=$;aa=ac}LF(aa|0,_|0,$)|0;a[aa+$|0]=0;L=106;break L74}}while(0);$=bT(-1,-1)|0;ad=M;ae=$}}while(0);do{if((L|0)==106){Z=s;C=b+44|0;c[Z>>2]=c[C>>2];c[Z+4>>2]=c[C+4>>2];c[Z+8>>2]=c[C+8>>2];C=c[b+56>>2]|0;$=(c[b+60>>2]|0)-C|0;do{if($>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;L=119;break}return 0}else{if($>>>0<11>>>0){a[t]=$<<1;af=t+1|0}else{_=$+16&-16;ac=(z=0,au(248,_|0)|0);if(z){z=0;L=119;break}c[t+8>>2]=ac;c[t>>2]=_|1;c[t+4>>2]=$;af=ac}LF(af|0,C|0,$)|0;a[af+$|0]=0;ac=e;c[ac>>2]=c[Z>>2];c[ac+4>>2]=c[Z+4>>2];c[ac+8>>2]=c[Z+8>>2];z=0;aV(50,F|0,r|0,e|0,t|0);if(z){z=0;ac=bT(-1,-1)|0;_=ac;ac=M;if((a[t]&1)==0){ag=ac;ah=_;break}Lw(c[t+8>>2]|0);ag=ac;ah=_;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}_=X;if((a[r]&1)==0){y=_;i=d;return y|0}Lw(c[r+8>>2]|0);y=_;i=d;return y|0}}while(0);if((L|0)==119){Z=bT(-1,-1)|0;ag=M;ah=Z}if((a[r]&1)==0){ad=ag;ae=ah;break}Lw(c[r+8>>2]|0);ad=ag;ae=ah}}while(0);F=c[B>>2]|0;Z=c[E>>2]|0;$=F;while(1){if(($|0)==(Z|0)){ai=Z;break}if((c[$>>2]|0)==(X|0)){ai=$;break}else{$=$+4|0}}$=ai-F>>2;B=F+($+1<<2)|0;C=Z-B|0;LG(F+($<<2)|0,B|0,C|0)|0;B=F+((C>>2)+$<<2)|0;$=c[E>>2]|0;if((B|0)!=($|0)){c[E>>2]=$+(~(($-4+(-B|0)|0)>>>2)<<2)}Lw(D);R=ad;S=ae;T=S;U=0;V=T;W=R;bg(V|0)}}while(0);y=uV(b)|0;i=d;return y|0}}while(0);x=c[b>>2]|0;A=Lu(44)|0;c[h>>2]=A;B=x+4|0;$=c[B>>2]|0;if(($|0)==(c[x+8>>2]|0)){e4(x|0,h);aj=c[h>>2]|0}else{if(($|0)==0){ak=0}else{c[$>>2]=A;ak=c[B>>2]|0}c[B>>2]=ak+4;aj=A}A=aj;$=aj;C=b+28|0;L132:do{if((a[C]&1)==0){_=o;c[_>>2]=c[C>>2];c[_+4>>2]=c[C+4>>2];c[_+8>>2]=c[C+8>>2];L=59}else{_=c[b+36>>2]|0;ac=c[b+32>>2]|0;do{if(ac>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ac>>>0<11>>>0){a[o]=ac<<1;al=o+1|0}else{ab=ac+16&-16;am=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[o+8>>2]=am;c[o>>2]=ab|1;c[o+4>>2]=ac;al=am}LF(al|0,_|0,ac)|0;a[al+ac|0]=0;L=59;break L132}}while(0);ac=bT(-1,-1)|0;an=M;ao=ac}}while(0);do{if((L|0)==59){C=p;ac=b+44|0;c[C>>2]=c[ac>>2];c[C+4>>2]=c[ac+4>>2];c[C+8>>2]=c[ac+8>>2];ac=c[b+56>>2]|0;_=(c[b+60>>2]|0)-ac|0;do{if(_>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;L=72;break}return 0}else{if(_>>>0<11>>>0){a[q]=_<<1;ap=q+1|0}else{am=_+16&-16;ab=(z=0,au(248,am|0)|0);if(z){z=0;L=72;break}c[q+8>>2]=ab;c[q>>2]=am|1;c[q+4>>2]=_;ap=ab}LF(ap|0,ac|0,_)|0;a[ap+_|0]=0;ab=g;c[ab>>2]=c[C>>2];c[ab+4>>2]=c[C+4>>2];c[ab+8>>2]=c[C+8>>2];z=0;aV(10,$|0,o|0,g|0,q|0);if(z){z=0;ab=bT(-1,-1)|0;am=ab;ab=M;if((a[q]&1)==0){aq=ab;as=am;break}Lw(c[q+8>>2]|0);aq=ab;as=am;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}am=aj;if((a[o]&1)==0){y=am;i=d;return y|0}Lw(c[o+8>>2]|0);y=am;i=d;return y|0}}while(0);if((L|0)==72){C=bT(-1,-1)|0;aq=M;as=C}if((a[o]&1)==0){an=aq;ao=as;break}Lw(c[o+8>>2]|0);an=aq;ao=as}}while(0);$=c[x>>2]|0;C=c[B>>2]|0;_=$;while(1){if((_|0)==(C|0)){at=C;break}if((c[_>>2]|0)==(aj|0)){at=_;break}else{_=_+4|0}}_=at-$>>2;x=$+(_+1<<2)|0;ac=C-x|0;LG($+(_<<2)|0,x|0,ac|0)|0;x=$+((ac>>2)+_<<2)|0;_=c[B>>2]|0;if((x|0)!=(_|0)){c[B>>2]=_+(~((_-4+(-x|0)|0)>>>2)<<2)}Lw(A);R=an;S=ao;T=S;U=0;V=T;W=R;bg(V|0)}}while(0);ao=c[b>>2]|0;an=Lu(44)|0;c[k>>2]=an;at=ao+4|0;aj=c[at>>2]|0;if((aj|0)==(c[ao+8>>2]|0)){e4(ao|0,k);av=c[k>>2]|0}else{if((aj|0)==0){aw=0}else{c[aj>>2]=an;aw=c[at>>2]|0}c[at>>2]=aw+4;av=an}an=av;aw=av;aj=b+28|0;L188:do{if((a[aj]&1)==0){k=l;c[k>>2]=c[aj>>2];c[k+4>>2]=c[aj+4>>2];c[k+8>>2]=c[aj+8>>2];L=18}else{k=c[b+36>>2]|0;as=c[b+32>>2]|0;do{if(as>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(as>>>0<11>>>0){a[l]=as<<1;ax=l+1|0}else{aq=as+16&-16;o=(z=0,au(248,aq|0)|0);if(z){z=0;break}c[l+8>>2]=o;c[l>>2]=aq|1;c[l+4>>2]=as;ax=o}LF(ax|0,k|0,as)|0;a[ax+as|0]=0;L=18;break L188}}while(0);as=bT(-1,-1)|0;ay=M;aA=as}}while(0);do{if((L|0)==18){ax=m;aj=b+44|0;c[ax>>2]=c[aj>>2];c[ax+4>>2]=c[aj+4>>2];c[ax+8>>2]=c[aj+8>>2];aj=c[b+56>>2]|0;as=(c[b+60>>2]|0)-aj|0;do{if(as>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;L=31;break}return 0}else{if(as>>>0<11>>>0){a[n]=as<<1;aB=n+1|0}else{k=as+16&-16;A=(z=0,au(248,k|0)|0);if(z){z=0;L=31;break}c[n+8>>2]=A;c[n>>2]=k|1;c[n+4>>2]=as;aB=A}LF(aB|0,aj|0,as)|0;a[aB+as|0]=0;A=j;c[A>>2]=c[ax>>2];c[A+4>>2]=c[ax+4>>2];c[A+8>>2]=c[ax+8>>2];z=0;aV(30,aw|0,l|0,j|0,n|0);if(z){z=0;A=bT(-1,-1)|0;k=A;A=M;if((a[n]&1)==0){aC=A;aD=k;break}Lw(c[n+8>>2]|0);aC=A;aD=k;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}k=av;if((a[l]&1)==0){y=k;i=d;return y|0}Lw(c[l+8>>2]|0);y=k;i=d;return y|0}}while(0);if((L|0)==31){ax=bT(-1,-1)|0;aC=M;aD=ax}if((a[l]&1)==0){ay=aC;aA=aD;break}Lw(c[l+8>>2]|0);ay=aC;aA=aD}}while(0);aD=c[ao>>2]|0;ao=c[at>>2]|0;aC=aD;while(1){if((aC|0)==(ao|0)){aE=ao;break}if((c[aC>>2]|0)==(av|0)){aE=aC;break}else{aC=aC+4|0}}aC=aE-aD>>2;aE=aD+(aC+1<<2)|0;av=ao-aE|0;LG(aD+(aC<<2)|0,aE|0,av|0)|0;aE=aD+((av>>2)+aC<<2)|0;aC=c[at>>2]|0;if((aE|0)!=(aC|0)){c[at>>2]=aC+(~((aC-4+(-aE|0)|0)>>>2)<<2)}Lw(an);R=ay;S=aA;T=S;U=0;V=T;W=R;bg(V|0);return 0}function uR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zr(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zs(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zw(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+120|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;k=d+88|0;l=d+104|0;uY(b)|0;m=d+56|0;n=b+44|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];n=uJ(b)|0;o=b+20|0;p=y$(c[o>>2]|0)|0;q=(a[p]|0)==41?p+1|0:0;do{if((q|0)==0){r=Lu(32)|0;s=j+8|0;c[s>>2]=r;c[j>>2]=33;c[j+4>>2]=31;LF(r|0,8856,31)|0;a[r+31|0]=0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;z=0;aR(492,b|0,j|0,k|0);if(!z){if((a[j]&1)==0){break}Lw(c[s>>2]|0);break}else{z=0}r=bT(-1,-1)|0;t=r;r=M;if((a[j]&1)==0){u=r;v=t;w=v;x=0;y=w;A=u;bg(y|0)}Lw(c[s>>2]|0);u=r;v=t;w=v;x=0;y=w;A=u;bg(y|0)}else{t=b+48|0;r=c[t>>2]|0;s=c[o>>2]|0;L12:do{if(s>>>0<q>>>0){B=s;C=0;while(1){D=a[B]|0;if((D<<24>>24|0)==10){E=C+1|0}else if((D<<24>>24|0)==0){F=C;break L12}else{E=C}D=B+1|0;if(D>>>0<q>>>0){B=D;C=E}else{F=E;break}}}else{F=0}}while(0);c[t>>2]=F+r;C=p;B=0;while(1){D=C-1|0;if(D>>>0<s>>>0){break}if((a[D]|0)==10){break}else{C=D;B=B+1|0}}C=b+40|0;if((F|0)!=0){c[C>>2]=1}s=c[C>>2]|0;c[b+52>>2]=s+B;r=q;t=p;c[C>>2]=r-t+B+s;s=b+56|0;c[s>>2]=t;c[s+4>>2]=r;c[o>>2]=q}}while(0);q=c[b>>2]|0;o=Lu(36)|0;c[h>>2]=o;p=q+4|0;F=c[p>>2]|0;if((F|0)==(c[q+8>>2]|0)){e4(q|0,h);G=c[h>>2]|0}else{if((F|0)==0){H=0}else{c[F>>2]=o;H=c[p>>2]|0}c[p>>2]=H+4;G=o}o=G;H=G;F=b+28|0;L34:do{if((a[F]&1)==0){h=l;c[h>>2]=c[F>>2];c[h+4>>2]=c[F+4>>2];c[h+8>>2]=c[F+8>>2];I=a[h]|0;J=h;K=32}else{h=c[b+36>>2]|0;E=c[b+32>>2]|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(E>>>0<11>>>0){j=E<<1&255;k=l;a[k]=j;L=l+1|0;N=j;O=k}else{k=E+16&-16;j=(z=0,au(248,k|0)|0);if(z){z=0;break}c[l+8>>2]=j;r=k|1;c[l>>2]=r;c[l+4>>2]=E;L=j;N=r&255;O=l}LF(L|0,h|0,E)|0;a[L+E|0]=0;I=N;J=O;K=32;break L34}}while(0);E=bT(-1,-1)|0;P=M;Q=E}}while(0);do{if((K|0)==32){O=g;c[O>>2]=c[m>>2];c[O+4>>2]=c[m+4>>2];c[O+8>>2]=c[m+8>>2];O=g;N=e;L=f;b=G;L49:do{if((I&1)==0){c[N>>2]=c[J>>2];c[N+4>>2]=c[J+4>>2];c[N+8>>2]=c[J+8>>2];K=42}else{F=c[l+8>>2]|0;E=c[l+4>>2]|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(E>>>0<11>>>0){a[N]=E<<1;R=e+1|0}else{h=E+16&-16;B=(z=0,au(248,h|0)|0);if(z){z=0;break}c[e+8>>2]=B;c[e>>2]=h|1;c[e+4>>2]=E;R=B}LF(R|0,F|0,E)|0;a[R+E|0]=0;K=42;break L49}}while(0);E=bT(-1,-1)|0;S=M;T=E}}while(0);do{if((K|0)==42){c[L>>2]=c[O>>2];c[L+4>>2]=c[O+4>>2];c[L+8>>2]=c[O+8>>2];z=0;aR(302,b|0,e|0,f|0);if(z){z=0;E=bT(-1,-1)|0;F=M;if((a[N]&1)==0){S=F;T=E;break}Lw(c[e+8>>2]|0);S=F;T=E;break}if((a[N]&1)!=0){Lw(c[e+8>>2]|0)}c[G>>2]=21e3;c[G+32>>2]=n;if((a[J]&1)==0){i=d;return H|0}Lw(c[l+8>>2]|0);i=d;return H|0}}while(0);N=T;b=S;if((a[J]&1)==0){P=b;Q=N;break}Lw(c[l+8>>2]|0);P=b;Q=N}}while(0);l=c[q>>2]|0;q=c[p>>2]|0;J=l;while(1){if((J|0)==(q|0)){U=q;break}if((c[J>>2]|0)==(G|0)){U=J;break}else{J=J+4|0}}J=U-l>>2;U=l+(J+1<<2)|0;G=q-U|0;LG(l+(J<<2)|0,U|0,G|0)|0;U=l+((G>>2)+J<<2)|0;J=c[p>>2]|0;if((U|0)!=(J|0)){c[p>>2]=J+(~((J-4+(-U|0)|0)>>>2)<<2)}Lw(o);u=P;v=Q;w=v;x=0;y=w;A=u;bg(y|0);return 0}function uV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0;d=i;i=i+728|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+72|0;m=d+88|0;n=d+96|0;o=d+112|0;p=d+120|0;q=d+136|0;r=d+144|0;s=d+160|0;t=d+168|0;u=d+176|0;v=d+184|0;w=d+192|0;x=d+208|0;y=d+216|0;A=d+232|0;B=d+240|0;C=d+256|0;D=d+264|0;E=d+280|0;F=d+288|0;G=d+304|0;H=d+312|0;I=d+328|0;J=d+344|0;K=d+360|0;L=d+376|0;N=d+392|0;O=d+408|0;P=d+424|0;Q=d+440|0;R=d+456|0;S=d+472|0;T=d+488|0;U=d+504|0;V=d+520|0;W=d+536|0;X=d+552|0;Y=d+568|0;Z=d+584|0;_=d+600|0;$=d+616|0;aa=d+632|0;ab=d+648|0;ac=d+664|0;ad=d+680|0;ae=d+696|0;af=d+712|0;do{if((uZ(b)|0)==0){if((u_(b)|0)!=0){break}if((u5(b)|0)==0){ag=Lu(48)|0;ah=ae+8|0;c[ah>>2]=ag;c[ae>>2]=49;c[ae+4>>2]=43;LF(ag|0,8224,43)|0;a[ag+43|0]=0;c[af>>2]=0;c[af+4>>2]=0;c[af+8>>2]=0;z=0;aR(492,b|0,ae|0,af|0);if(!z){if((a[ae]&1)==0){ai=0;i=d;return ai|0}Lw(c[ah>>2]|0);ai=0;i=d;return ai|0}else{z=0;ag=bT(-1,-1)|0;aj=ag;ag=M;if((a[ae]&1)==0){ak=aj;al=ag;am=ak;an=0;ao=am;ap=al;bg(ao|0)}Lw(c[ah>>2]|0);ak=aj;al=ag;am=ak;an=0;ao=am;ap=al;bg(ao|0)}}ag=c[b>>2]|0;aj=Lu(48)|0;c[f>>2]=aj;ah=ag+4|0;at=c[ah>>2]|0;if((at|0)==(c[ag+8>>2]|0)){e4(ag|0,f);av=c[f>>2]|0}else{if((at|0)==0){aw=0}else{c[at>>2]=aj;aw=c[ah>>2]|0}c[ah>>2]=aw+4;av=aj}aj=av;at=av;ax=b+28|0;L25:do{if((a[ax]&1)==0){ay=ab;c[ay>>2]=c[ax>>2];c[ay+4>>2]=c[ax+4>>2];c[ay+8>>2]=c[ax+8>>2];aA=508}else{ay=c[b+36>>2]|0;aB=c[b+32>>2]|0;do{if(aB>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aB>>>0<11>>>0){a[ab]=aB<<1;aC=ab+1|0}else{aE=aB+16&-16;aF=(z=0,au(248,aE|0)|0);if(z){z=0;break}c[ab+8>>2]=aF;c[ab>>2]=aE|1;c[ab+4>>2]=aB;aC=aF}LF(aC|0,ay|0,aB)|0;a[aC+aB|0]=0;aA=508;break L25}}while(0);aB=bT(-1,-1)|0;aG=aB;aH=M}}while(0);do{if((aA|0)==508){ax=ac;aB=b+44|0;c[ax>>2]=c[aB>>2];c[ax+4>>2]=c[aB+4>>2];c[ax+8>>2]=c[aB+8>>2];aB=c[b+56>>2]|0;ay=(c[b+60>>2]|0)-aB|0;do{if(ay>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aA=521;break}return 0}else{if(ay>>>0<11>>>0){a[ad]=ay<<1;aI=ad+1|0}else{aF=ay+16&-16;aE=(z=0,au(248,aF|0)|0);if(z){z=0;aA=521;break}c[ad+8>>2]=aE;c[ad>>2]=aF|1;c[ad+4>>2]=ay;aI=aE}LF(aI|0,aB|0,ay)|0;a[aI+ay|0]=0;aE=e;c[aE>>2]=c[ax>>2];c[aE+4>>2]=c[ax+4>>2];c[aE+8>>2]=c[ax+8>>2];z=0;aq(18,at|0,ab|0,e|0,ad|0,0);if(z){z=0;aE=bT(-1,-1)|0;aF=aE;aE=M;if((a[ad]&1)==0){aJ=aF;aK=aE;break}Lw(c[ad+8>>2]|0);aJ=aF;aK=aE;break}if((a[ad]&1)!=0){Lw(c[ad+8>>2]|0)}if((a[ab]&1)==0){ai=at;i=d;return ai|0}Lw(c[ab+8>>2]|0);ai=at;i=d;return ai|0}}while(0);if((aA|0)==521){ax=bT(-1,-1)|0;aJ=ax;aK=M}if((a[ab]&1)==0){aG=aJ;aH=aK;break}Lw(c[ab+8>>2]|0);aG=aJ;aH=aK}}while(0);at=c[ag>>2]|0;ax=c[ah>>2]|0;ay=at;while(1){if((ay|0)==(ax|0)){aL=ax;break}if((c[ay>>2]|0)==(av|0)){aL=ay;break}else{ay=ay+4|0}}ay=aL-at>>2;ag=at+(ay+1<<2)|0;aB=ax-ag|0;LG(at+(ay<<2)|0,ag|0,aB|0)|0;ag=at+((aB>>2)+ay<<2)|0;ay=c[ah>>2]|0;if((ag|0)!=(ay|0)){c[ah>>2]=ay+(~((ay-4+(-ag|0)|0)>>>2)<<2)}Lw(aj);ak=aG;al=aH;am=ak;an=0;ao=am;ap=al;bg(ao|0)}}while(0);aH=b+56|0;aG=c[aH>>2]|0;aL=(c[b+60>>2]|0)-aG|0;if(aL>>>0>4294967279>>>0){D5(0);return 0}if(aL>>>0<11>>>0){av=aL<<1&255;a[H]=av;aM=H+1|0;aN=av}else{av=aL+16&-16;aK=Lu(av)|0;c[H+8>>2]=aK;aJ=av|1;c[H>>2]=aJ;c[H+4>>2]=aL;aM=aK;aN=aJ&255}LF(aM|0,aG|0,aL)|0;a[aM+aL|0]=0;aL=I;I=b+44|0;c[aL>>2]=c[I>>2];c[aL+4>>2]=c[I+4>>2];c[aL+8>>2]=c[I+8>>2];I=(z=0,au(8,b|0)|0);L81:do{if(!z){L83:do{if((I|0)==0){aM=b+20|0;aG=(z=0,au(66,c[aM>>2]|0)|0);if(z){z=0;aA=30;break L81}aJ=(z=0,au(184,aG|0)|0);if(z){z=0;aA=30;break L81}if((aJ|0)!=0){z=0,au(52,b|0)|0;if(z){z=0;aA=30;break L81}aJ=b|0;aG=c[aJ>>2]|0;aK=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}av=aK;c[E>>2]=av;aK=aG+4|0;ab=c[aK>>2]|0;if((ab|0)==(c[aG+8>>2]|0)){z=0;as(382,aG|0,E|0);if(z){z=0;aA=30;break L81}aO=c[E>>2]|0}else{if((ab|0)==0){aP=0}else{c[ab>>2]=av;aP=c[aK>>2]|0}c[aK>>2]=aP+4;aO=av}av=aO;ab=b+28|0;L99:do{if((a[ab]&1)==0){ad=K;c[ad>>2]=c[ab>>2];c[ad+4>>2]=c[ab+4>>2];c[ad+8>>2]=c[ab+8>>2];aA=62}else{ad=c[b+36>>2]|0;e=c[b+32>>2]|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(e>>>0<11>>>0){a[K]=e<<1;aQ=K+1|0}else{aI=e+16&-16;ac=(z=0,au(248,aI|0)|0);if(z){z=0;break}c[K+8>>2]=ac;c[K>>2]=aI|1;c[K+4>>2]=e;aQ=ac}LF(aQ|0,ad|0,e)|0;a[aQ+e|0]=0;aA=62;break L99}}while(0);e=bT(-1,-1)|0;aS=e;aT=M}}while(0);do{if((aA|0)==62){e=D;c[e>>2]=c[aL>>2];c[e+4>>2]=c[aL+4>>2];c[e+8>>2]=c[aL+8>>2];z=0;aq(14,aO|0,K|0,D|0,aH|0,0);if(z){z=0;e=bT(-1,-1)|0;ad=e;e=M;if((a[K]&1)==0){aS=ad;aT=e;break}Lw(c[K+8>>2]|0);aS=ad;aT=e;break}if((a[K]&1)!=0){Lw(c[K+8>>2]|0)}z=0,au(44,b|0)|0;if(z){z=0;aA=30;break L81}e=c[aJ>>2]|0;ad=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}ac=ad;c[C>>2]=ac;ad=e+4|0;aI=c[ad>>2]|0;if((aI|0)==(c[e+8>>2]|0)){z=0;as(382,e|0,C|0);if(z){z=0;aA=30;break L81}aU=c[C>>2]|0}else{if((aI|0)==0){aV=0}else{c[aI>>2]=ac;aV=c[ad>>2]|0}c[ad>>2]=aV+4;aU=ac}ac=aU;L131:do{if((a[ab]&1)==0){aI=L;c[aI>>2]=c[ab>>2];c[aI+4>>2]=c[ab+4>>2];c[aI+8>>2]=c[ab+8>>2];aA=83}else{aI=c[b+36>>2]|0;aC=c[b+32>>2]|0;do{if(aC>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aC>>>0<11>>>0){a[L]=aC<<1;aW=L+1|0}else{aw=aC+16&-16;f=(z=0,au(248,aw|0)|0);if(z){z=0;break}c[L+8>>2]=f;c[L>>2]=aw|1;c[L+4>>2]=aC;aW=f}LF(aW|0,aI|0,aC)|0;a[aW+aC|0]=0;aA=83;break L131}}while(0);aC=bT(-1,-1)|0;aX=aC;aY=M}}while(0);do{if((aA|0)==83){aC=B;c[aC>>2]=c[aL>>2];c[aC+4>>2]=c[aL+4>>2];c[aC+8>>2]=c[aL+8>>2];z=0;aq(14,aU|0,L|0,B|0,aH|0,0);if(z){z=0;aC=bT(-1,-1)|0;aI=aC;aC=M;if((a[L]&1)==0){aX=aI;aY=aC;break}Lw(c[L+8>>2]|0);aX=aI;aY=aC;break}if((a[L]&1)!=0){Lw(c[L+8>>2]|0)}z=0,au(18,b|0)|0;if(z){z=0;aA=30;break L81}aC=c[aJ>>2]|0;aI=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}f=aI;c[A>>2]=f;aI=aC+4|0;aw=c[aI>>2]|0;if((aw|0)==(c[aC+8>>2]|0)){z=0;as(382,aC|0,A|0);if(z){z=0;aA=30;break L81}aZ=c[A>>2]|0}else{if((aw|0)==0){a_=0}else{c[aw>>2]=f;a_=c[aI>>2]|0}c[aI>>2]=a_+4;aZ=f}f=aZ;L163:do{if((a[ab]&1)==0){aw=N;c[aw>>2]=c[ab>>2];c[aw+4>>2]=c[ab+4>>2];c[aw+8>>2]=c[ab+8>>2];aA=104}else{aw=c[b+36>>2]|0;ae=c[b+32>>2]|0;do{if(ae>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ae>>>0<11>>>0){a[N]=ae<<1;a$=N+1|0}else{af=ae+16&-16;ag=(z=0,au(248,af|0)|0);if(z){z=0;break}c[N+8>>2]=ag;c[N>>2]=af|1;c[N+4>>2]=ae;a$=ag}LF(a$|0,aw|0,ae)|0;a[a$+ae|0]=0;aA=104;break L163}}while(0);ae=bT(-1,-1)|0;a0=ae;a1=M}}while(0);do{if((aA|0)==104){ae=y;c[ae>>2]=c[aL>>2];c[ae+4>>2]=c[aL+4>>2];c[ae+8>>2]=c[aL+8>>2];z=0;aq(14,aZ|0,N|0,y|0,aH|0,0);if(z){z=0;ae=bT(-1,-1)|0;aw=ae;ae=M;if((a[N]&1)==0){a0=aw;a1=ae;break}Lw(c[N+8>>2]|0);a0=aw;a1=ae;break}if((a[N]&1)!=0){Lw(c[N+8>>2]|0)}ae=c[aJ>>2]|0;aw=(z=0,au(248,60)|0);if(z){z=0;aA=30;break L81}ag=aw;c[x>>2]=ag;aw=ae+4|0;af=c[aw>>2]|0;if((af|0)==(c[ae+8>>2]|0)){z=0;as(382,ae|0,x|0);if(z){z=0;aA=30;break L81}a2=c[x>>2]|0}else{if((af|0)==0){a3=0}else{c[af>>2]=ag;a3=c[aw>>2]|0}c[aw>>2]=a3+4;a2=ag}ag=a2;L194:do{if((a[ab]&1)==0){af=O;c[af>>2]=c[ab>>2];c[af+4>>2]=c[ab+4>>2];c[af+8>>2]=c[ab+8>>2];aA=124}else{af=c[b+36>>2]|0;ay=c[b+32>>2]|0;do{if(ay>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ay>>>0<11>>>0){a[O]=ay<<1;a4=O+1|0}else{aB=ay+16&-16;aE=(z=0,au(248,aB|0)|0);if(z){z=0;break}c[O+8>>2]=aE;c[O>>2]=aB|1;c[O+4>>2]=ay;a4=aE}LF(a4|0,af|0,ay)|0;a[a4+ay|0]=0;aA=124;break L194}}while(0);ay=bT(-1,-1)|0;a5=ay;a6=M}}while(0);do{if((aA|0)==124){ay=w;c[ay>>2]=c[aL>>2];c[ay+4>>2]=c[aL+4>>2];c[ay+8>>2]=c[aL+8>>2];z=0;aD(2,a2|0,O|0,w|0,3,0,0);if(z){z=0;ay=bT(-1,-1)|0;af=ay;ay=M;if((a[O]&1)==0){a5=af;a6=ay;break}Lw(c[O+8>>2]|0);a5=af;a6=ay;break}if((a[O]&1)!=0){Lw(c[O+8>>2]|0)}ay=a2+40|0;af=ay;aE=aO;c[v>>2]=aE;aB=ay+8|0;aF=c[aB>>2]|0;a7=aF;a8=ay+12|0;if((aF|0)==(c[a8>>2]|0)){z=0;as(376,ay+4|0,v|0);if(z){z=0;aA=30;break L81}a9=c[v>>2]|0}else{if((aF|0)==0){ba=0}else{c[a7>>2]=aE;ba=c[aB>>2]|0}c[aB>>2]=ba+4;a9=aE}z=0;as(c[c[ay>>2]>>2]|0,af|0,a9|0);if(z){z=0;aA=30;break L81}aE=aU;c[u>>2]=aE;a7=c[aB>>2]|0;aF=a7;if((a7|0)==(c[a8>>2]|0)){z=0;as(376,ay+4|0,u|0);if(z){z=0;aA=30;break L81}bb=c[u>>2]|0}else{if((a7|0)==0){bc=0}else{c[aF>>2]=aE;bc=c[aB>>2]|0}c[aB>>2]=bc+4;bb=aE}z=0;as(c[c[ay>>2]>>2]|0,af|0,bb|0);if(z){z=0;aA=30;break L81}aE=aZ;c[t>>2]=aE;aF=c[aB>>2]|0;a7=aF;if((aF|0)==(c[a8>>2]|0)){z=0;as(376,ay+4|0,t|0);if(z){z=0;aA=30;break L81}bd=c[t>>2]|0}else{if((aF|0)==0){be=0}else{c[a7>>2]=aE;be=c[aB>>2]|0}c[aB>>2]=be+4;bd=aE}z=0;as(c[c[ay>>2]>>2]|0,af|0,bd|0);if(z){z=0;aA=30;break L81}bf=a2;break L83}}while(0);af=c[ae>>2]|0;ay=c[aw>>2]|0;aE=af;while(1){if((aE|0)==(ay|0)){bh=ay;break}if((c[aE>>2]|0)==(a2|0)){bh=aE;break}else{aE=aE+4|0}}aE=bh-af>>2;ae=af+(aE+1<<2)|0;aB=ay-ae|0;LG(af+(aE<<2)|0,ae|0,aB|0)|0;ae=af+((aB>>2)+aE<<2)|0;aE=c[aw>>2]|0;if((ae|0)!=(aE|0)){c[aw>>2]=aE+(~((aE-4+(-ae|0)|0)>>>2)<<2)}Lw(ag);bi=a5;bj=a6;break L81}}while(0);ae=c[aC>>2]|0;aE=c[aI>>2]|0;aB=ae;while(1){if((aB|0)==(aE|0)){bk=aE;break}if((c[aB>>2]|0)==(aZ|0)){bk=aB;break}else{aB=aB+4|0}}aB=bk-ae>>2;aC=ae+(aB+1<<2)|0;a7=aE-aC|0;LG(ae+(aB<<2)|0,aC|0,a7|0)|0;aC=ae+((a7>>2)+aB<<2)|0;aB=c[aI>>2]|0;if((aC|0)!=(aB|0)){c[aI>>2]=aB+(~((aB-4+(-aC|0)|0)>>>2)<<2)}Lw(f);bi=a0;bj=a1;break L81}}while(0);aC=c[e>>2]|0;aB=c[ad>>2]|0;a7=aC;while(1){if((a7|0)==(aB|0)){bl=aB;break}if((c[a7>>2]|0)==(aU|0)){bl=a7;break}else{a7=a7+4|0}}a7=bl-aC>>2;e=aC+(a7+1<<2)|0;aF=aB-e|0;LG(aC+(a7<<2)|0,e|0,aF|0)|0;e=aC+((aF>>2)+a7<<2)|0;a7=c[ad>>2]|0;if((e|0)!=(a7|0)){c[ad>>2]=a7+(~((a7-4+(-e|0)|0)>>>2)<<2)}Lw(ac);bi=aX;bj=aY;break L81}}while(0);ab=c[aG>>2]|0;aJ=c[aK>>2]|0;e=ab;while(1){if((e|0)==(aJ|0)){bm=aJ;break}if((c[e>>2]|0)==(aO|0)){bm=e;break}else{e=e+4|0}}e=bm-ab>>2;aG=ab+(e+1<<2)|0;a7=aJ-aG|0;LG(ab+(e<<2)|0,aG|0,a7|0)|0;aG=ab+((a7>>2)+e<<2)|0;e=c[aK>>2]|0;if((aG|0)!=(e|0)){c[aK>>2]=e+(~((e-4+(-aG|0)|0)>>>2)<<2)}Lw(av);bi=aS;bj=aT;break L81}aG=(z=0,au(66,c[aM>>2]|0)|0);if(z){z=0;aA=30;break L81}e=(z=0,au(152,aG|0)|0);if(z){z=0;aA=30;break L81}a7=(e|0)!=0?e:aG;do{if((a7|0)!=0){aG=(z=0,au(280,a7|0)|0);if(z){z=0;aA=30;break L81}e=(aG|0)!=0?aG:a7;if((e|0)==0){break}aG=(a[e]|0)==110?e+1|0:0;if((aG|0)==0){break}e=(z=0,au(66,aG|0)|0);if(z){z=0;aA=30;break L81}if((e|0)==0){break}if((e+1|0)==0|(a[e]|0)!=41){break}z=0,au(128,b|0)|0;if(z){z=0;aA=30;break L81}e=c[b>>2]|0;aG=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}aF=aG;c[s>>2]=aF;aG=e+4|0;a8=c[aG>>2]|0;if((a8|0)==(c[e+8>>2]|0)){z=0;as(382,e|0,s|0);if(z){z=0;aA=30;break L81}bn=c[s>>2]|0}else{if((a8|0)==0){bo=0}else{c[a8>>2]=aF;bo=c[aG>>2]|0}c[aG>>2]=bo+4;bn=aF}aF=bn;a8=b+28|0;L296:do{if((a[a8]&1)==0){bp=P;c[bp>>2]=c[a8>>2];c[bp+4>>2]=c[a8+4>>2];c[bp+8>>2]=c[a8+8>>2];aA=212}else{bp=c[b+36>>2]|0;bq=c[b+32>>2]|0;do{if(bq>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bq>>>0<11>>>0){a[P]=bq<<1;br=P+1|0}else{bs=bq+16&-16;bt=(z=0,au(248,bs|0)|0);if(z){z=0;break}c[P+8>>2]=bt;c[P>>2]=bs|1;c[P+4>>2]=bq;br=bt}LF(br|0,bp|0,bq)|0;a[br+bq|0]=0;aA=212;break L296}}while(0);bq=bT(-1,-1)|0;bu=bq;bv=M}}while(0);do{if((aA|0)==212){a8=r;c[a8>>2]=c[aL>>2];c[a8+4>>2]=c[aL+4>>2];c[a8+8>>2]=c[aL+8>>2];z=0;aq(14,bn|0,P|0,r|0,aH|0,0);if(!z){a8=bn;if((a[P]&1)==0){bf=a8;break L83}Lw(c[P+8>>2]|0);bf=a8;break L83}else{z=0;a8=bT(-1,-1)|0;ac=a8;a8=M;if((a[P]&1)==0){bu=ac;bv=a8;break}Lw(c[P+8>>2]|0);bu=ac;bv=a8;break}}}while(0);a8=c[e>>2]|0;ac=c[aG>>2]|0;ad=a8;while(1){if((ad|0)==(ac|0)){bw=ac;break}if((c[ad>>2]|0)==(bn|0)){bw=ad;break}else{ad=ad+4|0}}ad=bw-a8>>2;e=a8+(ad+1<<2)|0;aC=ac-e|0;LG(a8+(ad<<2)|0,e|0,aC|0)|0;e=a8+((aC>>2)+ad<<2)|0;ad=c[aG>>2]|0;if((e|0)!=(ad|0)){c[aG>>2]=ad+(~((ad-4+(-e|0)|0)>>>2)<<2)}Lw(aF);bi=bu;bj=bv;break L81}}while(0);a7=(z=0,au(40,b|0)|0);if(z){z=0;aA=30;break L81}if((a7|0)!=0){a7=c[b>>2]|0;av=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}aK=av;c[q>>2]=aK;av=a7+4|0;ab=c[av>>2]|0;if((ab|0)==(c[a7+8>>2]|0)){z=0;as(382,a7|0,q|0);if(z){z=0;aA=30;break L81}bx=c[q>>2]|0}else{if((ab|0)==0){by=0}else{c[ab>>2]=aK;by=c[av>>2]|0}c[av>>2]=by+4;bx=aK}aK=bx;ab=b+28|0;L337:do{if((a[ab]&1)==0){aJ=Q;c[aJ>>2]=c[ab>>2];c[aJ+4>>2]=c[ab+4>>2];c[aJ+8>>2]=c[ab+8>>2];aA=243}else{aJ=c[b+36>>2]|0;e=c[b+32>>2]|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(e>>>0<11>>>0){a[Q]=e<<1;bz=Q+1|0}else{ad=e+16&-16;aC=(z=0,au(248,ad|0)|0);if(z){z=0;break}c[Q+8>>2]=aC;c[Q>>2]=ad|1;c[Q+4>>2]=e;bz=aC}LF(bz|0,aJ|0,e)|0;a[bz+e|0]=0;aA=243;break L337}}while(0);e=bT(-1,-1)|0;bA=e;bB=M}}while(0);do{if((aA|0)==243){ab=p;c[ab>>2]=c[aL>>2];c[ab+4>>2]=c[aL+4>>2];c[ab+8>>2]=c[aL+8>>2];z=0;aq(14,bx|0,Q|0,p|0,aH|0,0);if(!z){ab=bx;if((a[Q]&1)==0){bf=ab;break L83}Lw(c[Q+8>>2]|0);bf=ab;break L83}else{z=0;ab=bT(-1,-1)|0;e=ab;ab=M;if((a[Q]&1)==0){bA=e;bB=ab;break}Lw(c[Q+8>>2]|0);bA=e;bB=ab;break}}}while(0);ab=c[a7>>2]|0;e=c[av>>2]|0;aJ=ab;while(1){if((aJ|0)==(e|0)){bC=e;break}if((c[aJ>>2]|0)==(bx|0)){bC=aJ;break}else{aJ=aJ+4|0}}aJ=bC-ab>>2;a7=ab+(aJ+1<<2)|0;aF=e-a7|0;LG(ab+(aJ<<2)|0,a7|0,aF|0)|0;a7=ab+((aF>>2)+aJ<<2)|0;aJ=c[av>>2]|0;if((a7|0)!=(aJ|0)){c[av>>2]=aJ+(~((aJ-4+(-a7|0)|0)>>>2)<<2)}Lw(aK);bi=bA;bj=bB;break L81}a7=(z=0,au(138,b|0)|0);if(z){z=0;aA=30;break L81}if((a7|0)!=0){a7=c[b>>2]|0;aJ=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}aF=aJ;c[o>>2]=aF;aJ=a7+4|0;aG=c[aJ>>2]|0;if((aG|0)==(c[a7+8>>2]|0)){z=0;as(382,a7|0,o|0);if(z){z=0;aA=30;break L81}bD=c[o>>2]|0}else{if((aG|0)==0){bE=0}else{c[aG>>2]=aF;bE=c[aJ>>2]|0}c[aJ>>2]=bE+4;bD=aF}aF=bD;aG=b+28|0;L378:do{if((a[aG]&1)==0){a8=R;c[a8>>2]=c[aG>>2];c[a8+4>>2]=c[aG+4>>2];c[a8+8>>2]=c[aG+8>>2];aA=274}else{a8=c[b+36>>2]|0;ac=c[b+32>>2]|0;do{if(ac>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ac>>>0<11>>>0){a[R]=ac<<1;bF=R+1|0}else{aC=ac+16&-16;ad=(z=0,au(248,aC|0)|0);if(z){z=0;break}c[R+8>>2]=ad;c[R>>2]=aC|1;c[R+4>>2]=ac;bF=ad}LF(bF|0,a8|0,ac)|0;a[bF+ac|0]=0;aA=274;break L378}}while(0);ac=bT(-1,-1)|0;bG=ac;bH=M}}while(0);do{if((aA|0)==274){aG=n;c[aG>>2]=c[aL>>2];c[aG+4>>2]=c[aL+4>>2];c[aG+8>>2]=c[aL+8>>2];z=0;aq(14,bD|0,R|0,n|0,aH|0,0);if(!z){aG=bD;if((a[R]&1)==0){bf=aG;break L83}Lw(c[R+8>>2]|0);bf=aG;break L83}else{z=0;aG=bT(-1,-1)|0;aK=aG;aG=M;if((a[R]&1)==0){bG=aK;bH=aG;break}Lw(c[R+8>>2]|0);bG=aK;bH=aG;break}}}while(0);aG=c[a7>>2]|0;aK=c[aJ>>2]|0;av=aG;while(1){if((av|0)==(aK|0)){bI=aK;break}if((c[av>>2]|0)==(bD|0)){bI=av;break}else{av=av+4|0}}av=bI-aG>>2;a7=aG+(av+1<<2)|0;ab=aK-a7|0;LG(aG+(av<<2)|0,a7|0,ab|0)|0;a7=aG+((ab>>2)+av<<2)|0;av=c[aJ>>2]|0;if((a7|0)!=(av|0)){c[aJ>>2]=av+(~((av-4+(-a7|0)|0)>>>2)<<2)}Lw(aF);bi=bG;bj=bH;break L81}a7=(z=0,au(208,b|0)|0);if(z){z=0;aA=30;break L81}if((a7|0)!=0){a7=c[b>>2]|0;av=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}ab=av;c[m>>2]=ab;av=a7+4|0;e=c[av>>2]|0;if((e|0)==(c[a7+8>>2]|0)){z=0;as(382,a7|0,m|0);if(z){z=0;aA=30;break L81}bJ=c[m>>2]|0}else{if((e|0)==0){bK=0}else{c[e>>2]=ab;bK=c[av>>2]|0}c[av>>2]=bK+4;bJ=ab}ab=bJ;e=b+28|0;L419:do{if((a[e]&1)==0){ac=S;c[ac>>2]=c[e>>2];c[ac+4>>2]=c[e+4>>2];c[ac+8>>2]=c[e+8>>2];aA=305}else{ac=c[b+36>>2]|0;a8=c[b+32>>2]|0;do{if(a8>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(a8>>>0<11>>>0){a[S]=a8<<1;bL=S+1|0}else{ad=a8+16&-16;aC=(z=0,au(248,ad|0)|0);if(z){z=0;break}c[S+8>>2]=aC;c[S>>2]=ad|1;c[S+4>>2]=a8;bL=aC}LF(bL|0,ac|0,a8)|0;a[bL+a8|0]=0;aA=305;break L419}}while(0);a8=bT(-1,-1)|0;bM=a8;bN=M}}while(0);do{if((aA|0)==305){e=l;c[e>>2]=c[aL>>2];c[e+4>>2]=c[aL+4>>2];c[e+8>>2]=c[aL+8>>2];z=0;aq(14,bJ|0,S|0,l|0,aH|0,0);if(!z){e=bJ;if((a[S]&1)==0){bf=e;break L83}Lw(c[S+8>>2]|0);bf=e;break L83}else{z=0;e=bT(-1,-1)|0;aF=e;e=M;if((a[S]&1)==0){bM=aF;bN=e;break}Lw(c[S+8>>2]|0);bM=aF;bN=e;break}}}while(0);e=c[a7>>2]|0;aF=c[av>>2]|0;aJ=e;while(1){if((aJ|0)==(aF|0)){bO=aF;break}if((c[aJ>>2]|0)==(bJ|0)){bO=aJ;break}else{aJ=aJ+4|0}}aJ=bO-e>>2;a7=e+(aJ+1<<2)|0;aG=aF-a7|0;LG(e+(aJ<<2)|0,a7|0,aG|0)|0;a7=e+((aG>>2)+aJ<<2)|0;aJ=c[av>>2]|0;if((a7|0)!=(aJ|0)){c[av>>2]=aJ+(~((aJ-4+(-a7|0)|0)>>>2)<<2)}Lw(ab);bi=bM;bj=bN;break L81}a7=(z=0,au(66,c[aM>>2]|0)|0);if(z){z=0;aA=30;break L81}if(!((a7+1|0)==0|(a[a7]|0)!=41)){a7=c[b>>2]|0;aJ=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}aG=aJ;c[k>>2]=aG;aJ=a7+4|0;aK=c[aJ>>2]|0;if((aK|0)==(c[a7+8>>2]|0)){z=0;as(382,a7|0,k|0);if(z){z=0;aA=30;break L81}bP=c[k>>2]|0}else{if((aK|0)==0){bQ=0}else{c[aK>>2]=aG;bQ=c[aJ>>2]|0}c[aJ>>2]=bQ+4;bP=aG}aG=bP;aK=b+28|0;L460:do{if((a[aK]&1)==0){a8=T;c[a8>>2]=c[aK>>2];c[a8+4>>2]=c[aK+4>>2];c[a8+8>>2]=c[aK+8>>2];aA=336}else{a8=c[b+36>>2]|0;ac=c[b+32>>2]|0;do{if(ac>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ac>>>0<11>>>0){a[T]=ac<<1;bR=T+1|0}else{aC=ac+16&-16;ad=(z=0,au(248,aC|0)|0);if(z){z=0;break}c[T+8>>2]=ad;c[T>>2]=aC|1;c[T+4>>2]=ac;bR=ad}LF(bR|0,a8|0,ac)|0;a[bR+ac|0]=0;aA=336;break L460}}while(0);ac=bT(-1,-1)|0;bS=ac;bU=M}}while(0);do{if((aA|0)==336){aK=j;c[aK>>2]=c[aL>>2];c[aK+4>>2]=c[aL+4>>2];c[aK+8>>2]=c[aL+8>>2];z=0;aq(38,bP|0,T|0,j|0,38312,0);if(!z){aK=bP;if((a[T]&1)==0){bf=aK;break L83}Lw(c[T+8>>2]|0);bf=aK;break L83}else{z=0;aK=bT(-1,-1)|0;aM=aK;aK=M;if((a[T]&1)==0){bS=aM;bU=aK;break}Lw(c[T+8>>2]|0);bS=aM;bU=aK;break}}}while(0);aK=c[a7>>2]|0;aM=c[aJ>>2]|0;ab=aK;while(1){if((ab|0)==(aM|0)){bV=aM;break}if((c[ab>>2]|0)==(bP|0)){bV=ab;break}else{ab=ab+4|0}}ab=bV-aK>>2;a7=aK+(ab+1<<2)|0;av=aM-a7|0;LG(aK+(ab<<2)|0,a7|0,av|0)|0;a7=aK+((av>>2)+ab<<2)|0;ab=c[aJ>>2]|0;if((a7|0)!=(ab|0)){c[aJ>>2]=ab+(~((ab-4+(-a7|0)|0)>>>2)<<2)}Lw(aG);bi=bS;bj=bU;break L81}a7=V;LI(a7|0,0,12)|0;ab=H;av=aN&255;if((av&1|0)==0){bW=av>>>1}else{bW=c[H+4>>2]|0}av=bW+20|0;do{if(av>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(av>>>0<11>>>0){a[a7]=40;bX=V+1|0}else{e=bW+36&-16;aF=(z=0,au(248,e|0)|0);if(z){z=0;break}c[V+8>>2]=aF;c[V>>2]=e|1;c[V+4>>2]=20;bX=aF}LF(bX|0,8736,20)|0;a[bX+20|0]=0;if((aN&1)==0){bY=ab+1|0}else{bY=c[H+8>>2]|0}z=0,az(88,V|0,bY|0,bW|0)|0;if(z){z=0;break}aF=U;LI(aF|0,0,12)|0;e=a[a7]|0;ac=e&255;if((ac&1|0)==0){bZ=ac>>>1}else{bZ=c[V+4>>2]|0}if((e&1)==0){b_=V+1|0}else{b_=c[V+8>>2]|0}e=bZ+4|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aA=378;break}return 0}else{if(e>>>0<11>>>0){a[aF]=bZ<<1;b$=U+1|0}else{ac=bZ+20&-16;a8=(z=0,au(248,ac|0)|0);if(z){z=0;aA=378;break}c[U+8>>2]=a8;c[U>>2]=ac|1;c[U+4>>2]=bZ;b$=a8}LF(b$|0,b_|0,bZ)|0;a[b$+bZ|0]=0;z=0,az(88,U|0,8584,4)|0;if(z){z=0;aA=378;break}c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;z=0;aR(492,b|0,U|0,W|0);if(z){z=0;a8=bT(-1,-1)|0;ac=a8;a8=M;if((a[aF]&1)==0){b0=ac;b1=a8;break}Lw(c[U+8>>2]|0);b0=ac;b1=a8;break}if((a[aF]&1)!=0){Lw(c[U+8>>2]|0)}if((a[a7]&1)==0){bf=0;break L83}Lw(c[V+8>>2]|0);bf=0;break L83}}while(0);if((aA|0)==378){e=bT(-1,-1)|0;a8=M;if((a[aF]&1)!=0){Lw(c[U+8>>2]|0)}b0=e;b1=a8}if((a[a7]&1)==0){bi=b0;bj=b1;break L81}Lw(c[V+8>>2]|0);bi=b0;bj=b1;break L81}}while(0);ab=bT(-1,-1)|0;av=M;if((a[a7]&1)==0){b2=av;b3=ab;aA=31;break L81}Lw(c[V+8>>2]|0);b2=av;b3=ab;aA=31;break L81}else{ab=c[b>>2]|0;av=(z=0,au(248,52)|0);if(z){z=0;aA=30;break L81}aG=av;c[G>>2]=aG;av=ab+4|0;aJ=c[av>>2]|0;if((aJ|0)==(c[ab+8>>2]|0)){z=0;as(382,ab|0,G|0);if(z){z=0;aA=30;break L81}b4=c[G>>2]|0}else{if((aJ|0)==0){b5=0}else{c[aJ>>2]=aG;b5=c[av>>2]|0}c[av>>2]=b5+4;b4=aG}aG=b4;aJ=b+28|0;L552:do{if((a[aJ]&1)==0){aK=J;c[aK>>2]=c[aJ>>2];c[aK+4>>2]=c[aJ+4>>2];c[aK+8>>2]=c[aJ+8>>2];aA=27}else{aK=c[b+36>>2]|0;aM=c[b+32>>2]|0;do{if(aM>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aM>>>0<11>>>0){a[J]=aM<<1;b6=J+1|0}else{a8=aM+16&-16;e=(z=0,au(248,a8|0)|0);if(z){z=0;break}c[J+8>>2]=e;c[J>>2]=a8|1;c[J+4>>2]=aM;b6=e}LF(b6|0,aK|0,aM)|0;a[b6+aM|0]=0;aA=27;break L552}}while(0);aM=bT(-1,-1)|0;b7=aM;b8=M}}while(0);do{if((aA|0)==27){aJ=F;c[aJ>>2]=c[aL>>2];c[aJ+4>>2]=c[aL+4>>2];c[aJ+8>>2]=c[aL+8>>2];z=0;aq(14,b4|0,J|0,F|0,aH|0,0);if(!z){aJ=b4;if((a[J]&1)==0){bf=aJ;break L83}Lw(c[J+8>>2]|0);bf=aJ;break L83}else{z=0;aJ=bT(-1,-1)|0;a7=aJ;aJ=M;if((a[J]&1)==0){b7=a7;b8=aJ;break}Lw(c[J+8>>2]|0);b7=a7;b8=aJ;break}}}while(0);aJ=c[ab>>2]|0;a7=c[av>>2]|0;aM=aJ;while(1){if((aM|0)==(a7|0)){b9=a7;break}if((c[aM>>2]|0)==(b4|0)){b9=aM;break}else{aM=aM+4|0}}aM=b9-aJ>>2;ab=aJ+(aM+1<<2)|0;aK=a7-ab|0;LG(aJ+(aM<<2)|0,ab|0,aK|0)|0;ab=aJ+((aK>>2)+aM<<2)|0;aM=c[av>>2]|0;if((ab|0)!=(aM|0)){c[av>>2]=aM+(~((aM-4+(-ab|0)|0)>>>2)<<2)}Lw(aG);bi=b7;bj=b8;break L81}}while(0);aj=b+20|0;ah=(z=0,au(66,c[aj>>2]|0)|0);if(z){z=0;aA=30;break}at=(a[ah]|0)==41?ah+1|0:0;L582:do{if((at|0)==0){ax=Y;LI(ax|0,0,12)|0;ab=H;aM=a[H]|0;aK=aM&255;if((aK&1|0)==0){ca=aK>>>1}else{ca=c[H+4>>2]|0}aK=ca+25|0;do{if(aK>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aK>>>0<11>>>0){a[ax]=50;cb=Y+1|0}else{aF=ca+41&-16;e=(z=0,au(248,aF|0)|0);if(z){z=0;break}c[Y+8>>2]=e;c[Y>>2]=aF|1;c[Y+4>>2]=25;cb=e}LF(cb|0,8400,25)|0;a[cb+25|0]=0;if((aM&1)==0){cc=ab+1|0}else{cc=c[H+8>>2]|0}z=0,az(88,Y|0,cc|0,ca|0)|0;if(z){z=0;break}e=X;LI(e|0,0,12)|0;aF=a[ax]|0;a8=aF&255;if((a8&1|0)==0){cd=a8>>>1}else{cd=c[Y+4>>2]|0}if((aF&1)==0){ce=Y+1|0}else{ce=c[Y+8>>2]|0}aF=cd+4|0;do{if(aF>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aA=432;break}return 0}else{if(aF>>>0<11>>>0){a[e]=cd<<1;cf=X+1|0}else{a8=cd+20&-16;ac=(z=0,au(248,a8|0)|0);if(z){z=0;aA=432;break}c[X+8>>2]=ac;c[X>>2]=a8|1;c[X+4>>2]=cd;cf=ac}LF(cf|0,ce|0,cd)|0;a[cf+cd|0]=0;z=0,az(88,X|0,8584,4)|0;if(z){z=0;aA=432;break}c[Z>>2]=0;c[Z+4>>2]=0;c[Z+8>>2]=0;z=0;aR(492,b|0,X|0,Z|0);if(z){z=0;ac=bT(-1,-1)|0;a8=ac;ac=M;if((a[e]&1)==0){cg=a8;ch=ac;break}Lw(c[X+8>>2]|0);cg=a8;ch=ac;break}if((a[e]&1)!=0){Lw(c[X+8>>2]|0)}if((a[ax]&1)==0){break L582}Lw(c[Y+8>>2]|0);break L582}}while(0);if((aA|0)==432){aF=bT(-1,-1)|0;ac=M;if((a[e]&1)!=0){Lw(c[X+8>>2]|0)}cg=aF;ch=ac}if((a[ax]&1)==0){bi=cg;bj=ch;break L81}Lw(c[Y+8>>2]|0);bi=cg;bj=ch;break L81}}while(0);ab=bT(-1,-1)|0;aM=M;if((a[ax]&1)==0){b2=aM;b3=ab;aA=31;break L81}Lw(c[Y+8>>2]|0);b2=aM;b3=ab;aA=31;break L81}else{ab=b+48|0;aM=c[ab>>2]|0;aK=c[aj>>2]|0;L584:do{if(aK>>>0<at>>>0){aG=aK;av=0;while(1){aJ=a[aG]|0;if((aJ<<24>>24|0)==10){ci=av+1|0}else if((aJ<<24>>24|0)==0){cj=av;break L584}else{ci=av}aJ=aG+1|0;if(aJ>>>0<at>>>0){aG=aJ;av=ci}else{cj=ci;break}}}else{cj=0}}while(0);c[ab>>2]=cj+aM;ax=ah;av=0;while(1){aG=ax-1|0;if(aG>>>0<aK>>>0){break}if((a[aG]|0)==10){break}else{ax=aG;av=av+1|0}}ax=b+40|0;if((cj|0)!=0){c[ax>>2]=1}aK=c[ax>>2]|0;c[b+52>>2]=aK+av;aM=at;ab=ah;c[ax>>2]=aM-ab+av+aK;aK=aH;c[aK>>2]=ab;c[aK+4>>2]=aM;c[aj>>2]=at}}while(0);at=c[b>>2]|0;aj=(z=0,au(248,48)|0);if(z){z=0;aA=30;break}ah=aj;c[h>>2]=ah;aj=at+4|0;aM=c[aj>>2]|0;if((aM|0)==(c[at+8>>2]|0)){z=0;as(382,at|0,h|0);if(z){z=0;aA=30;break}ck=c[h>>2]|0}else{if((aM|0)==0){cl=0}else{c[aM>>2]=ah;cl=c[aj>>2]|0}c[aj>>2]=cl+4;ck=ah}ah=ck;aM=ck;aK=b+28|0;L662:do{if((a[aK]&1)==0){ab=_;c[ab>>2]=c[aK>>2];c[ab+4>>2]=c[aK+4>>2];c[ab+8>>2]=c[aK+8>>2];aA=461}else{ab=c[b+36>>2]|0;ax=c[b+32>>2]|0;do{if(ax>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ax>>>0<11>>>0){a[_]=ax<<1;cm=_+1|0}else{aG=ax+16&-16;e=(z=0,au(248,aG|0)|0);if(z){z=0;break}c[_+8>>2]=e;c[_>>2]=aG|1;c[_+4>>2]=ax;cm=e}LF(cm|0,ab|0,ax)|0;a[cm+ax|0]=0;aA=461;break L662}}while(0);ax=bT(-1,-1)|0;cn=ax;co=M}}while(0);do{if((aA|0)==461){aK=$;c[aK>>2]=c[aL>>2];c[aK+4>>2]=c[aL+4>>2];c[aK+8>>2]=c[aL+8>>2];ax=H;ab=(a[ax]&1)==0;L677:do{if(ab){av=aa;c[av>>2]=c[ax>>2];c[av+4>>2]=c[ax+4>>2];c[av+8>>2]=c[ax+8>>2];aA=471}else{av=c[H+8>>2]|0;e=c[H+4>>2]|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(e>>>0<11>>>0){a[aa]=e<<1;cp=aa+1|0}else{aG=e+16&-16;aJ=(z=0,au(248,aG|0)|0);if(z){z=0;break}c[aa+8>>2]=aJ;c[aa>>2]=aG|1;c[aa+4>>2]=e;cp=aJ}LF(cp|0,av|0,e)|0;a[cp+e|0]=0;aA=471;break L677}}while(0);e=bT(-1,-1)|0;cq=e;cr=M}}while(0);do{if((aA|0)==471){ax=g;c[ax>>2]=c[aK>>2];c[ax+4>>2]=c[aK+4>>2];c[ax+8>>2]=c[aK+8>>2];z=0;aq(18,aM|0,_|0,g|0,aa|0,bf|0);if(z){z=0;ax=bT(-1,-1)|0;e=ax;ax=M;if((a[aa]&1)==0){cq=e;cr=ax;break}Lw(c[aa+8>>2]|0);cq=e;cr=ax;break}if((a[aa]&1)!=0){Lw(c[aa+8>>2]|0)}if((a[_]&1)!=0){Lw(c[_+8>>2]|0)}if(ab){ai=aM;i=d;return ai|0}Lw(c[H+8>>2]|0);ai=aM;i=d;return ai|0}}while(0);if((a[_]&1)==0){cn=cq;co=cr;break}Lw(c[_+8>>2]|0);cn=cq;co=cr}}while(0);aM=c[at>>2]|0;ab=c[aj>>2]|0;aK=aM;while(1){if((aK|0)==(ab|0)){cs=ab;break}if((c[aK>>2]|0)==(ck|0)){cs=aK;break}else{aK=aK+4|0}}aK=cs-aM>>2;at=aM+(aK+1<<2)|0;ax=ab-at|0;LG(aM+(aK<<2)|0,at|0,ax|0)|0;at=aM+((ax>>2)+aK<<2)|0;aK=c[aj>>2]|0;if((at|0)!=(aK|0)){c[aj>>2]=aK+(~((aK-4+(-at|0)|0)>>>2)<<2)}Lw(ah);bi=cn;bj=co}else{z=0;aA=30}}while(0);if((aA|0)==30){co=bT(-1,-1)|0;b2=M;b3=co;aA=31}if((aA|0)==31){bi=b3;bj=b2}if((a[H]&1)==0){ak=bi;al=bj;am=ak;an=0;ao=am;ap=al;bg(ao|0)}Lw(c[H+8>>2]|0);ak=bi;al=bj;am=ak;an=0;ao=am;ap=al;bg(ao|0);return 0}function uW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0;d=i;i=i+272|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+72|0;m=d+88|0;n=d+104|0;o=d+120|0;p=d+136|0;q=d+152|0;r=d+168|0;s=d+184|0;t=d+200|0;u=d+216|0;v=d+232|0;w=d+248|0;x=d+264|0;y=x;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+12|0;i=i+7&-8;G=i;i=i+12|0;i=i+7&-8;H=i;i=i+12|0;i=i+7&-8;I=b+20|0;J=y$(c[I>>2]|0)|0;K=(a[J]|0)==91?J+1|0:0;if((K|0)!=0){L=b+48|0;N=c[L>>2]|0;O=c[I>>2]|0;L3:do{if(O>>>0<K>>>0){P=O;Q=0;while(1){R=a[P]|0;if((R<<24>>24|0)==0){S=Q;break L3}else if((R<<24>>24|0)==10){T=Q+1|0}else{T=Q}R=P+1|0;if(R>>>0<K>>>0){P=R;Q=T}else{S=T;break}}}else{S=0}}while(0);c[L>>2]=S+N;N=J;L=0;while(1){T=N-1|0;if(T>>>0<O>>>0){break}if((a[T]|0)==10){break}else{N=T;L=L+1|0}}N=b+40|0;if((S|0)!=0){c[N>>2]=1}S=c[N>>2]|0;c[b+52>>2]=S+L;O=K;T=J;c[N>>2]=O-T+L+S;S=b+56|0;c[S>>2]=T;c[S+4>>2]=O;c[I>>2]=K}K=l;l=b+44|0;c[K>>2]=c[l>>2];c[K+4>>2]=c[l+4>>2];c[K+8>>2]=c[l+8>>2];do{if((u6(b)|0)==0){l=Lu(48)|0;O=m+8|0;c[O>>2]=l;c[m>>2]=49;c[m+4>>2]=44;LF(l|0,8048,44)|0;a[l+44|0]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;z=0;aR(492,b|0,m|0,n|0);if(!z){if((a[m]&1)==0){break}Lw(c[O>>2]|0);break}else{z=0}l=bT(-1,-1)|0;S=l;l=M;if((a[m]&1)==0){U=l;V=S;W=V;X=0;Y=W;Z=U;bg(Y|0)}Lw(c[O>>2]|0);U=l;V=S;W=V;X=0;Y=W;Z=U;bg(Y|0)}}while(0);m=b+56|0;n=m|0;S=c[n>>2]|0;l=b+60|0;O=(c[l>>2]|0)-S|0;if(O>>>0>4294967279>>>0){D5(0);return 0}if(O>>>0<11>>>0){a[o]=O<<1;_=o+1|0}else{T=O+16&-16;L=Lu(T)|0;c[o+8>>2]=L;c[o>>2]=T|1;c[o+4>>2]=O;_=L}LF(_|0,S|0,O)|0;a[_+O|0]=0;O=(z=0,au(66,c[I>>2]|0)|0);L36:do{if(!z){_=(a[O]|0)==93?O+1|0:0;L38:do{if((_|0)==0){S=(z=0,au(78,b|0)|0);if(z){z=0;$=68;break L36}L119:do{if((S|0)==0){L=t;LI(L|0,0,12)|0;T=o;N=a[o]|0;J=N&255;if((J&1|0)==0){aa=J>>>1}else{aa=c[o+4>>2]|0}J=aa+43|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(J>>>0<11>>>0){a[L]=86;ab=t+1|0}else{Q=aa+59&-16;P=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[t+8>>2]=P;c[t>>2]=Q|1;c[t+4>>2]=43;ab=P}LF(ab|0,7864,43)|0;a[ab+43|0]=0;if((N&1)==0){ac=T+1|0}else{ac=c[o+8>>2]|0}z=0,az(88,t|0,ac|0,aa|0)|0;if(z){z=0;break}c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;z=0;aR(492,b|0,t|0,u|0);if(!z){if((a[L]&1)==0){break L119}Lw(c[t+8>>2]|0);break L119}else{z=0;P=bT(-1,-1)|0;Q=P;P=M;if((a[L]&1)==0){ad=P;ae=Q;break L36}Lw(c[t+8>>2]|0);ad=P;ae=Q;break L36}}}while(0);T=bT(-1,-1)|0;N=M;if((a[L]&1)==0){af=N;ag=T;$=69;break L36}Lw(c[t+8>>2]|0);af=N;ag=T;$=69;break L36}}while(0);S=c[n>>2]|0;T=(c[l>>2]|0)-S|0;if(T>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=68;break L36}return 0}if(T>>>0<11>>>0){N=T<<1&255;a[v]=N;ah=v+1|0;ai=N}else{N=T+16&-16;J=(z=0,au(248,N|0)|0);if(z){z=0;$=68;break L36}c[v+8>>2]=J;Q=N|1;c[v>>2]=Q;c[v+4>>2]=T;ah=J;ai=Q&255}LF(ah|0,S|0,T)|0;a[ah+T|0]=0;T=(z=0,au(138,b|0)|0);L156:do{if(!z){L158:do{if((T|0)==0){S=(z=0,au(208,b|0)|0);if(z){z=0;$=136;break L156}if((S|0)!=0){S=m;Q=c[S+4>>2]|0;c[x>>2]=c[S>>2];c[x+4>>2]=Q;Q=(z=0,aM(400,b|0,y|0)|0);if(!z){aj=Q;break}else{z=0;$=136;break L156}}Q=A;LI(Q|0,0,12)|0;S=o;J=a[o]|0;N=J&255;if((N&1|0)==0){ak=N>>>1}else{ak=c[o+4>>2]|0}N=ak+67|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[Q]=-122;al=A+1|0}else{P=ak+83&-16;R=(z=0,au(248,P|0)|0);if(z){z=0;break}c[A+8>>2]=R;c[A>>2]=P|1;c[A+4>>2]=67;al=R}LF(al|0,7552,67)|0;a[al+67|0]=0;if((J&1)==0){am=S+1|0}else{am=c[o+8>>2]|0}z=0,az(88,A|0,am|0,ak|0)|0;if(z){z=0;break}c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;z=0;aR(492,b|0,A|0,B|0);if(!z){if((a[Q]&1)==0){aj=0;break L158}Lw(c[A+8>>2]|0);aj=0;break L158}else{z=0;R=bT(-1,-1)|0;P=R;R=M;if((a[Q]&1)==0){an=R;ao=P;break L156}Lw(c[A+8>>2]|0);an=R;ao=P;break L156}}}while(0);S=bT(-1,-1)|0;J=M;if((a[Q]&1)==0){ap=J;at=S;$=137;break L156}Lw(c[A+8>>2]|0);ap=J;at=S;$=137;break L156}else{S=c[b>>2]|0;J=(z=0,au(248,52)|0);if(z){z=0;$=136;break L156}N=J;c[h>>2]=N;J=S+4|0;P=c[J>>2]|0;if((P|0)==(c[S+8>>2]|0)){z=0;as(382,S|0,h|0);if(z){z=0;$=136;break L156}av=c[h>>2]|0}else{if((P|0)==0){aw=0}else{c[P>>2]=N;aw=c[J>>2]|0}c[J>>2]=aw+4;av=N}N=av;P=b+28|0;L169:do{if((a[P]&1)==0){R=w;c[R>>2]=c[P>>2];c[R+4>>2]=c[P+4>>2];c[R+8>>2]=c[P+8>>2];$=133}else{R=c[b+36>>2]|0;ax=c[b+32>>2]|0;do{if(ax>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ax>>>0<11>>>0){a[w]=ax<<1;ay=w+1|0}else{aA=ax+16&-16;aB=(z=0,au(248,aA|0)|0);if(z){z=0;break}c[w+8>>2]=aB;c[w>>2]=aA|1;c[w+4>>2]=ax;ay=aB}LF(ay|0,R|0,ax)|0;a[ay+ax|0]=0;$=133;break L169}}while(0);ax=bT(-1,-1)|0;aC=M;aE=ax}}while(0);do{if(($|0)==133){P=g;c[P>>2]=c[K>>2];c[P+4>>2]=c[K+4>>2];c[P+8>>2]=c[K+8>>2];z=0;aq(14,av|0,w|0,g|0,m|0,1);if(!z){P=av;if((a[w]&1)==0){aj=P;break L158}Lw(c[w+8>>2]|0);aj=P;break L158}else{z=0;P=bT(-1,-1)|0;Q=P;P=M;if((a[w]&1)==0){aC=P;aE=Q;break}Lw(c[w+8>>2]|0);aC=P;aE=Q;break}}}while(0);Q=c[S>>2]|0;P=c[J>>2]|0;ax=Q;while(1){if((ax|0)==(P|0)){aF=P;break}if((c[ax>>2]|0)==(av|0)){aF=ax;break}else{ax=ax+4|0}}ax=aF-Q>>2;S=Q+(ax+1<<2)|0;R=P-S|0;LG(Q+(ax<<2)|0,S|0,R|0)|0;S=Q+((R>>2)+ax<<2)|0;ax=c[J>>2]|0;if((S|0)!=(ax|0)){c[J>>2]=ax+(~((ax-4+(-S|0)|0)>>>2)<<2)}Lw(N);an=aC;ao=aE;break L156}}while(0);L=(z=0,au(66,c[I>>2]|0)|0);if(z){z=0;$=136;break}S=(a[L]|0)==93?L+1|0:0;L229:do{if((S|0)==0){ax=C;LI(ax|0,0,12)|0;R=o;aB=a[o]|0;aA=aB&255;if((aA&1|0)==0){aG=aA>>>1}else{aG=c[o+4>>2]|0}aA=aG+36|0;do{if(aA>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aA>>>0<11>>>0){a[ax]=72;aH=C+1|0}else{aI=aG+52&-16;aJ=(z=0,au(248,aI|0)|0);if(z){z=0;break}c[C+8>>2]=aJ;c[C>>2]=aI|1;c[C+4>>2]=36;aH=aJ}LF(aH|0,7320,36)|0;a[aH+36|0]=0;if((aB&1)==0){aK=R+1|0}else{aK=c[o+8>>2]|0}z=0,az(88,C|0,aK|0,aG|0)|0;if(z){z=0;break}c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;z=0;aR(492,b|0,C|0,D|0);if(!z){if((a[ax]&1)==0){break L229}Lw(c[C+8>>2]|0);break L229}else{z=0;aJ=bT(-1,-1)|0;aI=aJ;aJ=M;if((a[ax]&1)==0){an=aJ;ao=aI;break L156}Lw(c[C+8>>2]|0);an=aJ;ao=aI;break L156}}}while(0);R=bT(-1,-1)|0;aB=M;if((a[ax]&1)==0){ap=aB;at=R;$=137;break L156}Lw(c[C+8>>2]|0);ap=aB;at=R;$=137;break L156}else{R=b+48|0;aB=c[R>>2]|0;aA=c[I>>2]|0;L231:do{if(aA>>>0<S>>>0){N=aA;J=0;while(1){Q=a[N]|0;if((Q<<24>>24|0)==10){aL=J+1|0}else if((Q<<24>>24|0)==0){aN=J;break L231}else{aL=J}Q=N+1|0;if(Q>>>0<S>>>0){N=Q;J=aL}else{aN=aL;break}}}else{aN=0}}while(0);c[R>>2]=aN+aB;ax=L;J=0;while(1){N=ax-1|0;if(N>>>0<aA>>>0){break}if((a[N]|0)==10){break}else{ax=N;J=J+1|0}}ax=b+40|0;if((aN|0)!=0){c[ax>>2]=1}aA=c[ax>>2]|0;c[b+52>>2]=aA+J;aB=S;R=L;c[ax>>2]=aB-R+J+aA;aA=m;c[aA>>2]=R;c[aA+4>>2]=aB;c[I>>2]=S}}while(0);S=c[b>>2]|0;L=(z=0,au(248,60)|0);if(z){z=0;$=136;break}aB=L;c[f>>2]=aB;L=S+4|0;aA=c[L>>2]|0;if((aA|0)==(c[S+8>>2]|0)){z=0;as(382,S|0,f|0);if(z){z=0;$=136;break}aO=c[f>>2]|0}else{if((aA|0)==0){aP=0}else{c[aA>>2]=aB;aP=c[L>>2]|0}c[L>>2]=aP+4;aO=aB}aB=aO;aA=aO;R=b+28|0;L281:do{if((a[R]&1)==0){ax=E;c[ax>>2]=c[R>>2];c[ax+4>>2]=c[R+4>>2];c[ax+8>>2]=c[R+8>>2];$=221}else{ax=c[b+36>>2]|0;N=c[b+32>>2]|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[E]=N<<1;aQ=E+1|0}else{Q=N+16&-16;P=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[E+8>>2]=P;c[E>>2]=Q|1;c[E+4>>2]=N;aQ=P}LF(aQ|0,ax|0,N)|0;a[aQ+N|0]=0;$=221;break L281}}while(0);N=bT(-1,-1)|0;aS=M;aT=N}}while(0);do{if(($|0)==221){R=F;c[R>>2]=c[K>>2];c[R+4>>2]=c[K+4>>2];c[R+8>>2]=c[K+8>>2];N=o;L296:do{if((a[N]&1)==0){ax=G;c[ax>>2]=c[N>>2];c[ax+4>>2]=c[N+4>>2];c[ax+8>>2]=c[N+8>>2];$=231}else{ax=c[o+8>>2]|0;J=c[o+4>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(J>>>0<11>>>0){a[G]=J<<1;aU=G+1|0}else{P=J+16&-16;Q=(z=0,au(248,P|0)|0);if(z){z=0;break}c[G+8>>2]=Q;c[G>>2]=P|1;c[G+4>>2]=J;aU=Q}LF(aU|0,ax|0,J)|0;a[aU+J|0]=0;$=231;break L296}}while(0);J=bT(-1,-1)|0;aV=M;aW=J}}while(0);do{if(($|0)==231){L311:do{if((ai&1)==0){N=v;J=H;c[J>>2]=c[N>>2];c[J+4>>2]=c[N+4>>2];c[J+8>>2]=c[N+8>>2];$=241}else{N=c[v+8>>2]|0;J=c[v+4>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(J>>>0<11>>>0){a[H]=J<<1;aX=H+1|0}else{ax=J+16&-16;Q=(z=0,au(248,ax|0)|0);if(z){z=0;break}c[H+8>>2]=Q;c[H>>2]=ax|1;c[H+4>>2]=J;aX=Q}LF(aX|0,N|0,J)|0;a[aX+J|0]=0;$=241;break L311}}while(0);J=bT(-1,-1)|0;aY=M;aZ=J}}while(0);do{if(($|0)==241){J=e;c[J>>2]=c[R>>2];c[J+4>>2]=c[R+4>>2];c[J+8>>2]=c[R+8>>2];z=0;aD(8,aA|0,E|0,e|0,G|0,H|0,aj|0);if(z){z=0;J=bT(-1,-1)|0;N=J;J=M;if((a[H]&1)==0){aY=J;aZ=N;break}Lw(c[H+8>>2]|0);aY=J;aZ=N;break}if((a[H]&1)!=0){Lw(c[H+8>>2]|0)}if((a[G]&1)!=0){Lw(c[G+8>>2]|0)}if((a[E]&1)!=0){Lw(c[E+8>>2]|0)}if((ai&1)==0){a_=aA;break L38}Lw(c[v+8>>2]|0);a_=aA;break L38}}while(0);if((a[G]&1)==0){aV=aY;aW=aZ;break}Lw(c[G+8>>2]|0);aV=aY;aW=aZ}}while(0);if((a[E]&1)==0){aS=aV;aT=aW;break}Lw(c[E+8>>2]|0);aS=aV;aT=aW}}while(0);aA=c[S>>2]|0;R=c[L>>2]|0;N=aA;while(1){if((N|0)==(R|0)){a$=R;break}if((c[N>>2]|0)==(aO|0)){a$=N;break}else{N=N+4|0}}N=a$-aA>>2;S=aA+(N+1<<2)|0;J=R-S|0;LG(aA+(N<<2)|0,S|0,J|0)|0;S=aA+((J>>2)+N<<2)|0;N=c[L>>2]|0;if((S|0)!=(N|0)){c[L>>2]=N+(~((N-4+(-S|0)|0)>>>2)<<2)}Lw(aB);an=aS;ao=aT}else{z=0;$=136}}while(0);if(($|0)==136){T=bT(-1,-1)|0;ap=M;at=T;$=137}if(($|0)==137){an=ap;ao=at}if((ai&1)==0){ad=an;ae=ao;break L36}Lw(c[v+8>>2]|0);ad=an;ae=ao;break L36}else{T=b+48|0;S=c[T>>2]|0;N=c[I>>2]|0;L40:do{if(N>>>0<_>>>0){J=N;Q=0;while(1){ax=a[J]|0;if((ax<<24>>24|0)==10){a0=Q+1|0}else if((ax<<24>>24|0)==0){a1=Q;break L40}else{a0=Q}ax=J+1|0;if(ax>>>0<_>>>0){J=ax;Q=a0}else{a1=a0;break}}}else{a1=0}}while(0);c[T>>2]=a1+S;Q=O;J=0;while(1){aB=Q-1|0;if(aB>>>0<N>>>0){break}if((a[aB]|0)==10){break}else{Q=aB;J=J+1|0}}Q=b+40|0;if((a1|0)!=0){c[Q>>2]=1}N=c[Q>>2]|0;c[b+52>>2]=N+J;S=_;T=O;c[Q>>2]=S-T+J+N;N=m;c[N>>2]=T;c[N+4>>2]=S;c[I>>2]=_;S=c[b>>2]|0;N=(z=0,au(248,60)|0);if(z){z=0;$=68;break L36}T=N;c[k>>2]=T;N=S+4|0;Q=c[N>>2]|0;if((Q|0)==(c[S+8>>2]|0)){z=0;as(382,S|0,k|0);if(z){z=0;$=68;break L36}a2=c[k>>2]|0}else{if((Q|0)==0){a3=0}else{c[Q>>2]=T;a3=c[N>>2]|0}c[N>>2]=a3+4;a2=T}T=a2;Q=a2;aB=b+28|0;L63:do{if((a[aB]&1)==0){L=p;c[L>>2]=c[aB>>2];c[L+4>>2]=c[aB+4>>2];c[L+8>>2]=c[aB+8>>2];$=51}else{L=c[b+36>>2]|0;aA=c[b+32>>2]|0;do{if(aA>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aA>>>0<11>>>0){a[p]=aA<<1;a4=p+1|0}else{R=aA+16&-16;ax=(z=0,au(248,R|0)|0);if(z){z=0;break}c[p+8>>2]=ax;c[p>>2]=R|1;c[p+4>>2]=aA;a4=ax}LF(a4|0,L|0,aA)|0;a[a4+aA|0]=0;$=51;break L63}}while(0);aA=bT(-1,-1)|0;a5=M;a6=aA}}while(0);do{if(($|0)==51){aB=q;c[aB>>2]=c[K>>2];c[aB+4>>2]=c[K+4>>2];c[aB+8>>2]=c[K+8>>2];J=o;L78:do{if((a[J]&1)==0){aA=r;c[aA>>2]=c[J>>2];c[aA+4>>2]=c[J+4>>2];c[aA+8>>2]=c[J+8>>2];$=61}else{aA=c[o+8>>2]|0;L=c[o+4>>2]|0;do{if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(L>>>0<11>>>0){a[r]=L<<1;a7=r+1|0}else{ax=L+16&-16;R=(z=0,au(248,ax|0)|0);if(z){z=0;break}c[r+8>>2]=R;c[r>>2]=ax|1;c[r+4>>2]=L;a7=R}LF(a7|0,aA|0,L)|0;a[a7+L|0]=0;$=61;break L78}}while(0);L=bT(-1,-1)|0;a8=M;a9=L}}while(0);do{if(($|0)==61){J=s;a[J]=0;a[s+1|0]=0;L=j;c[L>>2]=c[aB>>2];c[L+4>>2]=c[aB+4>>2];c[L+8>>2]=c[aB+8>>2];z=0;aD(8,Q|0,p|0,j|0,r|0,s|0,0);if(z){z=0;L=bT(-1,-1)|0;aA=L;L=M;if((a[J]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)==0){a8=L;a9=aA;break}Lw(c[r+8>>2]|0);a8=L;a9=aA;break}if((a[J]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[p]&1)==0){a_=Q;break L38}Lw(c[p+8>>2]|0);a_=Q;break L38}}while(0);if((a[p]&1)==0){a5=a8;a6=a9;break}Lw(c[p+8>>2]|0);a5=a8;a6=a9}}while(0);Q=c[S>>2]|0;aB=c[N>>2]|0;J=Q;while(1){if((J|0)==(aB|0)){ba=aB;break}if((c[J>>2]|0)==(a2|0)){ba=J;break}else{J=J+4|0}}J=ba-Q>>2;S=Q+(J+1<<2)|0;aA=aB-S|0;LG(Q+(J<<2)|0,S|0,aA|0)|0;S=Q+((aA>>2)+J<<2)|0;J=c[N>>2]|0;if((S|0)!=(J|0)){c[N>>2]=J+(~((J-4+(-S|0)|0)>>>2)<<2)}Lw(T);ad=a5;ae=a6;break L36}}while(0);if((a[o]&1)==0){i=d;return a_|0}Lw(c[o+8>>2]|0);i=d;return a_|0}else{z=0;$=68}}while(0);if(($|0)==68){a_=bT(-1,-1)|0;af=M;ag=a_;$=69}if(($|0)==69){ad=af;ae=ag}if((a[o]&1)==0){U=ad;V=ae;W=V;X=0;Y=W;Z=U;bg(Y|0)}Lw(c[o+8>>2]|0);U=ad;V=ae;W=V;X=0;Y=W;Z=U;bg(Y|0);return 0}function uX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zu(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zJ(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zG(e)|0;if((f|0)==0){g=0;return g|0}h=zI(f)|0;if((h|0)==0){g=0;return g|0}f=b+48|0;i=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=i+o;i=e;f=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;f=f+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[i>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;g=h;return g|0}function u_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zI(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function u$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zK(e)|0;do{if((f|0)==0){g=zL(e)|0;if((g|0)==0){h=0}else{i=g;break}return h|0}else{i=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L5:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L5}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[f>>2]=g+n;g=e;f=0;while(1){o=g-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{g=o;f=f+1|0}}g=b+40|0;if((n|0)!=0){c[g>>2]=1}n=c[g>>2]|0;c[b+52>>2]=n+f;j=i;o=e;c[g>>2]=j-o+f+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=i;h=i;return h|0}function u0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zx(e)|0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=(a[g]|0)==110?g+1|0:0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function u1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zv(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function u2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=yS(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function u3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zv(e)|0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=yS(g)|0;i=(f|0)!=0?f:g;if((i|0)==0){h=0;return h|0}g=(a[i]|0)==110?i+1|0:0;if((g|0)==0){h=0;return h|0}i=b+48|0;f=c[i>>2]|0;j=c[d>>2]|0;L10:do{if(j>>>0<g>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L10}else{n=l}m=k+1|0;if(m>>>0<g>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[i>>2]=f+o;f=e;i=0;while(1){n=f-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{f=n;i=i+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+i;j=g;n=e;c[f>>2]=j-n+i+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=g;h=g;return h|0}function u4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zv(e)|0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=yS(g)|0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function u5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zG(e)|0;if((f|0)==0){g=0;return g|0}h=y0(f)|0;if((h|0)==0){g=0;return g|0}f=b+48|0;i=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=i+o;i=e;f=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;f=f+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[i>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;g=h;return g|0}function u6(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zt(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function u7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zM(e)|0;do{if((f|0)==0){g=zN(e)|0;if((g|0)!=0){h=g;break}g=zO(e)|0;if((g|0)!=0){h=g;break}g=zP(e)|0;if((g|0)!=0){h=g;break}g=zQ(e)|0;if((g|0)!=0){h=g;break}g=zR(e)|0;if((g|0)==0){i=0}else{h=g;break}return i|0}else{h=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L9:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L9}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[g>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;i=h;return i|0}function u8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y8(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function u9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=za(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function va(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zb(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=d+20|0;if((e|0)==0){g=0;h=0;i=c[f>>2]|0}else{g=0;h=0;i=e}L3:while(1){j=(i|0)==0;if(j){k=c[f>>2]|0}else{k=i}e=y0(y$(k)|0)|0;L8:do{if((e|0)==0){if(j){l=c[f>>2]|0}else{l=i}d=zo(y$(l)|0)|0;if((d|0)!=0){m=d;break}if(j){n=c[f>>2]|0}else{n=i}d=zr(y$(n)|0)|0;if((d|0)!=0){m=d;break}if(j){o=c[f>>2]|0}else{o=i}d=zs(y$(o)|0)|0;if((d|0)!=0){m=d;break}if(j){p=c[f>>2]|0}else{p=i}d=zG(y$(p)|0)|0;if((d|0)!=0){q=y0(d)|0;if((q|0)!=0){m=q;break}}if(j){r=c[f>>2]|0}else{r=i}q=zA(y$(r)|0)|0;if((q|0)!=0){m=q;break}if(j){s=c[f>>2]|0}else{s=i}q=zB(y$(s)|0)|0;if((q|0)!=0){m=q;break}if(j){t=c[f>>2]|0}else{t=i}q=yY(y$(t)|0)|0;if((q|0)!=0){m=q;break}if(j){u=c[f>>2]|0}else{u=i}q=y$(u)|0;d=(a[q]|0)==42?q+1|0:0;if((d|0)!=0){m=d;break}if(j){v=c[f>>2]|0}else{v=i}d=y$(v)|0;q=(a[d]|0)==40?d+1|0:0;if((q|0)!=0){m=q;break}if(j){w=c[f>>2]|0}else{w=i}q=y$(w)|0;d=(a[q]|0)==41?q+1|0:0;if((d|0)!=0){m=d;break}if(j){x=c[f>>2]|0}else{x=i}d=y$(x)|0;q=(a[d]|0)==91?d+1|0:0;if((q|0)!=0){m=q;break}if(j){y=c[f>>2]|0}else{y=i}q=y$(y)|0;d=(a[q]|0)==93?q+1|0:0;if((d|0)!=0){m=d;break}if(j){z=c[f>>2]|0}else{z=i}d=y$(z)|0;q=(a[d]|0)==43?d+1|0:0;if((q|0)!=0){m=q;break}if(j){A=c[f>>2]|0}else{A=i}q=y$(A)|0;d=(a[q]|0)==126?q+1|0:0;if((d|0)!=0){m=d;break}if(j){B=c[f>>2]|0}else{B=i}d=y$(B)|0;q=(a[d]|0)==62?d+1|0:0;if((q|0)!=0){m=q;break}if(j){C=c[f>>2]|0}else{C=i}q=y$(C)|0;d=(a[q]|0)==44?q+1|0:0;if((d|0)!=0){m=d;break}if(j){D=c[f>>2]|0}else{D=i}d=zy(y$(D)|0)|0;if((d|0)!=0){m=d;break}if(j){E=c[f>>2]|0}else{E=i}d=y$(E)|0;q=zv(d)|0;F=(q|0)!=0?q:d;do{if((F|0)!=0){d=yS(F)|0;q=(d|0)!=0?d:F;if((q|0)==0){break}d=(a[q]|0)==110?q+1|0:0;if((d|0)!=0){m=d;break L8}}}while(0);if(j){G=c[f>>2]|0}else{G=i}F=y$(G)|0;d=zv(F)|0;q=(d|0)!=0?d:F;if((q|0)!=0){F=yS(q)|0;if((F|0)!=0){m=F;break}}if(j){H=c[f>>2]|0}else{H=i}F=zw(y$(H)|0)|0;if((F|0)!=0){m=F;break}if(j){I=c[f>>2]|0}else{I=i}F=y$(I)|0;q=(a[F]|0)==38?F+1|0:0;if((q|0)!=0){m=q;break}if(j){J=c[f>>2]|0}else{J=i}q=y$(J)|0;F=(a[q]|0)==37?q+1|0:0;if((F|0)!=0){m=F;break}if(j){K=c[f>>2]|0}else{K=i}F=y$(K)|0;q=zM(F)|0;if((q|0)!=0){m=q;break}q=zN(F)|0;if((q|0)!=0){m=q;break}q=zO(F)|0;if((q|0)!=0){m=q;break}q=zP(F)|0;if((q|0)!=0){m=q;break}q=zQ(F)|0;if((q|0)!=0){m=q;break}q=zR(F)|0;if((q|0)!=0){m=q;break}if(j){L=c[f>>2]|0}else{L=i}q=y$(L)|0;F=(a[q]|0)==46?q+1|0:0;if((F|0)!=0){q=yZ(F)|0;if((q|0)!=0){m=q;break}}if(j){M=c[f>>2]|0}else{M=i}q=y$(M)|0;F=(a[q]|0)==35?q+1|0:0;if((F|0)!=0){q=yZ(F)|0;if((q|0)!=0){m=q;break}}if(j){N=c[f>>2]|0}else{N=i}q=y$(N)|0;F=(a[q]|0)==45?q+1|0:0;if((F|0)!=0){q=yZ(F)|0;if((q|0)!=0){m=q;break}}if(j){O=c[f>>2]|0}else{O=i}q=zG(y$(O)|0)|0;if((q|0)!=0){F=yZ(q)|0;if((F|0)!=0){m=F;break}}if(j){P=c[f>>2]|0}else{P=i}F=yZ(y$(P)|0)|0;if((F|0)==0){break L3}else{m=F}}else{m=e}}while(0);g=m;h=(a[m-1|0]|0)==125|h;i=m}if(j){Q=c[f>>2]|0}else{Q=i}i=y$(Q)|0;Q=a[i]|0;f=i+1|0;i=Q<<24>>24==59?f:0;if((i|0)!=0){R=i;S=(R|0)==0;T=S?0:g;U=b|0;c[U>>2]=T;V=b+4|0;W=h&1;a[V]=W;return}i=Q<<24>>24==125?f:0;if((i|0)!=0){R=i;S=(R|0)==0;T=S?0:g;U=b|0;c[U>>2]=T;V=b+4|0;W=h&1;a[V]=W;return}R=Q<<24>>24==123?f:0;S=(R|0)==0;T=S?0:g;U=b|0;c[U>>2]=T;V=b+4|0;W=h&1;a[V]=W;return}function vc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,as=0,at=0,av=0,aw=0,ax=0;d=i;i=i+240|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+56|0;k=d+72|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+128|0;p=d+144|0;q=d+160|0;r=d+176|0;s=d+192|0;t=d+208|0;u=d+224|0;v=b+20|0;w=y$(c[v>>2]|0)|0;x=(a[w]|0)==42?w+1|0:0;y=(x|0)!=0?x:w;do{if((y|0)==0){A=4}else{if((y1(y)|0)==0){A=4;break}B=uF(b)|0}}while(0);L4:do{if((A|0)==4){if((uG(b)|0)==0){y=Lu(32)|0;w=m+8|0;c[w>>2]=y;c[m>>2]=33;c[m+4>>2]=21;LF(y|0,6232,21)|0;a[y+21|0]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;z=0;aR(492,b|0,m|0,n|0);if(!z){if((a[m]&1)==0){B=0;break}Lw(c[w>>2]|0);B=0;break}else{z=0}y=bT(-1,-1)|0;x=y;y=M;if((a[m]&1)==0){C=y;D=x;E=D;F=0;G=E;H=C;bg(G|0)}Lw(c[w>>2]|0);C=y;D=x;E=D;F=0;G=E;H=C;bg(G|0)}x=c[b>>2]|0;y=Lu(52)|0;c[k>>2]=y;w=x+4|0;I=c[w>>2]|0;if((I|0)==(c[x+8>>2]|0)){e4(x|0,k);J=c[k>>2]|0}else{if((I|0)==0){K=0}else{c[I>>2]=y;K=c[w>>2]|0}c[w>>2]=K+4;J=y}y=J;I=b+28|0;L24:do{if((a[I]&1)==0){L=l;c[L>>2]=c[I>>2];c[L+4>>2]=c[I+4>>2];c[L+8>>2]=c[I+8>>2];A=20}else{L=c[b+36>>2]|0;N=c[b+32>>2]|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[l]=N<<1;O=l+1|0}else{P=N+16&-16;Q=(z=0,au(248,P|0)|0);if(z){z=0;break}c[l+8>>2]=Q;c[l>>2]=P|1;c[l+4>>2]=N;O=Q}LF(O|0,L|0,N)|0;a[O+N|0]=0;A=20;break L24}}while(0);N=bT(-1,-1)|0;R=M;S=N}}while(0);do{if((A|0)==20){I=b+44|0;N=j;c[N>>2]=c[I>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];z=0;aq(14,J|0,l|0,j|0,b+56|0,0);if(!z){I=J;if((a[l]&1)==0){B=I;break L4}Lw(c[l+8>>2]|0);B=I;break L4}else{z=0;I=bT(-1,-1)|0;N=I;I=M;if((a[l]&1)==0){R=I;S=N;break}Lw(c[l+8>>2]|0);R=I;S=N;break}}}while(0);N=c[x>>2]|0;I=c[w>>2]|0;L=N;while(1){if((L|0)==(I|0)){T=I;break}if((c[L>>2]|0)==(J|0)){T=L;break}else{L=L+4|0}}L=T-N>>2;x=N+(L+1<<2)|0;Q=I-x|0;LG(N+(L<<2)|0,x|0,Q|0)|0;x=N+((Q>>2)+L<<2)|0;L=c[w>>2]|0;if((x|0)!=(L|0)){c[w>>2]=L+(~((L-4+(-x|0)|0)>>>2)<<2)}Lw(y);C=R;D=S;E=D;F=0;G=E;H=C;bg(G|0)}}while(0);S=y$(c[v>>2]|0)|0;R=(a[S]|0)==58?S+1|0:0;L54:do{if((R|0)==0){T=c[b+56>>2]|0;J=(c[b+60>>2]|0)-T|0;if(J>>>0>4294967279>>>0){D5(0);return 0}if(J>>>0<11>>>0){l=J<<1&255;j=q;O=q;a[O]=l;U=j+1|0;V=l;W=j;X=O}else{O=J+16&-16;j=Lu(O)|0;c[q+8>>2]=j;l=O|1;c[q>>2]=l;c[q+4>>2]=J;U=j;V=l&255;W=q;X=q}LF(U|0,T|0,J)|0;a[U+J|0]=0;J=p;LI(J|0,0,12)|0;T=V&255;if((T&1|0)==0){Y=T>>>1}else{Y=c[q+4>>2]|0}T=Y+10|0;do{if(T>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;A=67;break}return 0}else{if(T>>>0<11>>>0){a[J]=20;Z=p+1|0}else{l=Y+26&-16;j=(z=0,au(248,l|0)|0);if(z){z=0;A=67;break}c[p+8>>2]=j;c[p>>2]=l|1;c[p+4>>2]=10;Z=j}LF(Z|0,6144,10)|0;a[Z+10|0]=0;if((V&1)==0){_=W+1|0}else{_=c[q+8>>2]|0}z=0,az(88,p|0,_|0,Y|0)|0;if(z){z=0;A=67;break}j=o;LI(j|0,0,12)|0;l=a[J]|0;O=l&255;if((O&1|0)==0){$=O>>>1}else{$=c[p+4>>2]|0}if((l&1)==0){aa=p+1|0}else{aa=c[p+8>>2]|0}l=$+27|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;A=83;break}return 0}else{if(l>>>0<11>>>0){a[j]=$<<1;ab=o+1|0}else{O=$+43&-16;K=(z=0,au(248,O|0)|0);if(z){z=0;A=83;break}c[o+8>>2]=K;c[o>>2]=O|1;c[o+4>>2]=$;ab=K}LF(ab|0,aa|0,$)|0;a[ab+$|0]=0;z=0,az(88,o|0,6024,27)|0;if(z){z=0;A=83;break}c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;z=0;aR(492,b|0,o|0,r|0);if(z){z=0;K=bT(-1,-1)|0;O=K;K=M;if((a[j]&1)==0){ac=K;ad=O;break}Lw(c[o+8>>2]|0);ac=K;ad=O;break}if((a[j]&1)!=0){Lw(c[o+8>>2]|0)}if((a[J]&1)!=0){Lw(c[p+8>>2]|0)}if((a[X]&1)==0){break L54}Lw(c[q+8>>2]|0);break L54}}while(0);if((A|0)==83){l=bT(-1,-1)|0;O=M;if((a[j]&1)!=0){Lw(c[o+8>>2]|0)}ac=O;ad=l}if((a[J]&1)==0){ae=ac;af=ad;break}Lw(c[p+8>>2]|0);ae=ac;af=ad}}while(0);if((A|0)==67){T=bT(-1,-1)|0;y=M;if((a[J]&1)!=0){Lw(c[p+8>>2]|0)}ae=y;af=T}if((a[X]&1)==0){C=ae;D=af;E=D;F=0;G=E;H=C;bg(G|0)}Lw(c[q+8>>2]|0);C=ae;D=af;E=D;F=0;G=E;H=C;bg(G|0)}else{T=b+48|0;y=c[T>>2]|0;w=c[v>>2]|0;L56:do{if(w>>>0<R>>>0){N=w;I=0;while(1){l=a[N]|0;if((l<<24>>24|0)==10){ag=I+1|0}else if((l<<24>>24|0)==0){ah=I;break L56}else{ag=I}l=N+1|0;if(l>>>0<R>>>0){N=l;I=ag}else{ah=ag;break}}}else{ah=0}}while(0);c[T>>2]=ah+y;J=S;I=0;while(1){N=J-1|0;if(N>>>0<w>>>0){break}if((a[N]|0)==10){break}else{J=N;I=I+1|0}}J=b+40|0;if((ah|0)!=0){c[J>>2]=1}w=c[J>>2]|0;c[b+52>>2]=w+I;y=R;T=S;c[J>>2]=y-T+I+w;w=b+56|0;c[w>>2]=T;c[w+4>>2]=y;c[v>>2]=R}}while(0);R=y$(c[v>>2]|0)|0;do{if(!((R+1|0)==0|(a[R]|0)!=59)){v=Lu(48)|0;S=s+8|0;c[S>>2]=v;c[s>>2]=49;c[s+4>>2]=38;LF(v|0,5912,38)|0;a[v+38|0]=0;c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;z=0;aR(492,b|0,s|0,t|0);if(!z){if((a[s]&1)==0){break}Lw(c[S>>2]|0);break}else{z=0}v=bT(-1,-1)|0;ah=v;v=M;if((a[s]&1)==0){C=v;D=ah;E=D;F=0;G=E;H=C;bg(G|0)}Lw(c[S>>2]|0);C=v;D=ah;E=D;F=0;G=E;H=C;bg(G|0)}}while(0);s=vd(b)|0;t=c[b>>2]|0;R=Lu(40)|0;c[h>>2]=R;ah=t+4|0;v=c[ah>>2]|0;if((v|0)==(c[t+8>>2]|0)){e4(t|0,h);ai=c[h>>2]|0}else{if((v|0)==0){aj=0}else{c[v>>2]=R;aj=c[ah>>2]|0}c[ah>>2]=aj+4;ai=R}R=ai;aj=ai;v=b+28|0;L161:do{if((a[v]&1)==0){h=u;c[h>>2]=c[v>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];ak=a[h]|0;al=h;A=121}else{h=c[b+36>>2]|0;S=c[b+32>>2]|0;do{if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(S>>>0<11>>>0){ag=S<<1&255;af=u;a[af]=ag;am=u+1|0;an=ag;ao=af}else{af=S+16&-16;ag=(z=0,au(248,af|0)|0);if(z){z=0;break}c[u+8>>2]=ag;ae=af|1;c[u>>2]=ae;c[u+4>>2]=S;am=ag;an=ae&255;ao=u}LF(am|0,h|0,S)|0;a[am+S|0]=0;ak=an;al=ao;A=121;break L161}}while(0);S=bT(-1,-1)|0;ap=M;as=S}}while(0);do{if((A|0)==121){ao=B+16|0;an=g;c[an>>2]=c[ao>>2];c[an+4>>2]=c[ao+4>>2];c[an+8>>2]=c[ao+8>>2];ao=g;an=e;am=f;b=ai;L176:do{if((ak&1)==0){c[an>>2]=c[al>>2];c[an+4>>2]=c[al+4>>2];c[an+8>>2]=c[al+8>>2];A=131}else{v=c[u+8>>2]|0;S=c[u+4>>2]|0;do{if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(S>>>0<11>>>0){a[an]=S<<1;at=e+1|0}else{h=S+16&-16;I=(z=0,au(248,h|0)|0);if(z){z=0;break}c[e+8>>2]=I;c[e>>2]=h|1;c[e+4>>2]=S;at=I}LF(at|0,v|0,S)|0;a[at+S|0]=0;A=131;break L176}}while(0);S=bT(-1,-1)|0;av=M;aw=S}}while(0);do{if((A|0)==131){c[am>>2]=c[ao>>2];c[am+4>>2]=c[ao+4>>2];c[am+8>>2]=c[ao+8>>2];z=0;aR(424,b|0,e|0,f|0);if(z){z=0;S=bT(-1,-1)|0;v=M;if((a[an]&1)==0){av=v;aw=S;break}Lw(c[e+8>>2]|0);av=v;aw=S;break}if((a[an]&1)!=0){Lw(c[e+8>>2]|0)}c[ai>>2]=22416;c[ai+28>>2]=B;c[ai+32>>2]=s;a[ai+36|0]=0;if((a[al]&1)==0){i=d;return aj|0}Lw(c[u+8>>2]|0);i=d;return aj|0}}while(0);an=aw;b=av;if((a[al]&1)==0){ap=b;as=an;break}Lw(c[u+8>>2]|0);ap=b;as=an}}while(0);u=c[t>>2]|0;t=c[ah>>2]|0;al=u;while(1){if((al|0)==(t|0)){ax=t;break}if((c[al>>2]|0)==(ai|0)){ax=al;break}else{al=al+4|0}}al=ax-u>>2;ax=u+(al+1<<2)|0;ai=t-ax|0;LG(u+(al<<2)|0,ax|0,ai|0)|0;ax=u+((ai>>2)+al<<2)|0;al=c[ah>>2]|0;if((ax|0)!=(al|0)){c[ah>>2]=al+(~((al-4+(-ax|0)|0)>>>2)<<2)}Lw(R);C=ap;D=as;E=D;F=0;G=E;H=C;bg(G|0);return 0}function vd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=d+56|0;l=d+64|0;m=d+80|0;n=b+20|0;o=y$(c[n>>2]|0)|0;do{if((o+1|0)==0|(a[o]|0)!=59){p=y$(c[n>>2]|0)|0;if(!((p+1|0)==0|(a[p]|0)!=125)){break}p=y$(c[n>>2]|0)|0;if(!((p+1|0)==0|(a[p]|0)!=123)){break}p=y$(c[n>>2]|0)|0;if(!((p+1|0)==0|(a[p]|0)!=41)){break}p=y$(c[n>>2]|0)|0;q=a[36768]|0;L6:do{if(q<<24>>24==0){r=p;s=8}else{t=p;u=36768;v=q;while(1){if((a[t]|0)!=v<<24>>24){break L6}w=t+1|0;x=u+1|0;y=a[x]|0;if(y<<24>>24==0){r=w;s=8;break}else{t=w;u=x;v=y}}}}while(0);if((s|0)==8){if((r|0)!=0){break}}q=uz(b)|0;p=y$(c[n>>2]|0)|0;if((p+1|0)==0|(a[p]|0)!=44){A=q;i=d;return A|0}p=c[b>>2]|0;v=Lu(60)|0;c[h>>2]=v;u=p+4|0;t=c[u>>2]|0;if((t|0)==(c[p+8>>2]|0)){e4(p|0,h);B=c[h>>2]|0}else{if((t|0)==0){C=0}else{c[t>>2]=v;C=c[u>>2]|0}c[u>>2]=C+4;B=v}v=B;t=b+28|0;L23:do{if((a[t]&1)==0){y=m;c[y>>2]=c[t>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];s=52}else{y=c[b+36>>2]|0;x=c[b+32>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[m]=x<<1;D=m+1|0}else{w=x+16&-16;E=(z=0,au(248,w|0)|0);if(z){z=0;break}c[m+8>>2]=E;c[m>>2]=w|1;c[m+4>>2]=x;D=E}LF(D|0,y|0,x)|0;a[D+x|0]=0;s=52;break L23}}while(0);x=bT(-1,-1)|0;F=x;G=M}}while(0);do{if((s|0)==52){t=b+44|0;x=g;c[x>>2]=c[t>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];z=0;aD(36,B|0,m|0,g|0,2,1,0);if(z){z=0;t=bT(-1,-1)|0;x=t;t=M;if((a[m]&1)==0){F=x;G=t;break}Lw(c[m+8>>2]|0);F=x;G=t;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}t=B+36|0;x=t;c[f>>2]=q;y=t+8|0;E=y;w=c[E>>2]|0;H=t+12|0;if((w|0)==(c[H>>2]|0)){fq(t+4|0,f);I=c[f>>2]|0}else{if((w|0)==0){J=0}else{c[w>>2]=q;J=c[E>>2]|0}c[y>>2]=J+4;I=q}w=t;cB[c[c[w>>2]>>2]&1023](x,I);K=y$(c[n>>2]|0)|0;L=(a[K]|0)==44?K+1|0:0;L52:do{if((L|0)!=0){N=b+48|0;O=b+40|0;P=b+52|0;Q=b+56|0;R=t+4|0;S=K;T=L;do{U=c[N>>2]|0;V=c[n>>2]|0;L56:do{if(V>>>0<T>>>0){W=V;X=0;while(1){Y=a[W]|0;if((Y<<24>>24|0)==0){Z=X;break L56}else if((Y<<24>>24|0)==10){_=X+1|0}else{_=X}Y=W+1|0;if(Y>>>0<T>>>0){W=Y;X=_}else{Z=_;break}}}else{Z=0}}while(0);c[N>>2]=Z+U;X=S;W=0;while(1){Y=X-1|0;if(Y>>>0<V>>>0){break}if((a[Y]|0)==10){break}else{X=Y;W=W+1|0}}if((Z|0)!=0){c[O>>2]=1}X=c[O>>2]|0;c[P>>2]=X+W;V=T;U=S;c[O>>2]=V-U+W+X;c[Q>>2]=U;c[Q+4>>2]=V;c[n>>2]=T;if((T|0)==0){break L52}V=uz(b)|0;c[e>>2]=V;U=c[E>>2]|0;if((U|0)==(c[H>>2]|0)){fq(R,e);$=c[e>>2]|0}else{if((U|0)==0){aa=0}else{c[U>>2]=V;aa=c[E>>2]|0}c[y>>2]=aa+4;$=V}cB[c[c[w>>2]>>2]&1023](x,$);S=y$(c[n>>2]|0)|0;T=(a[S]|0)==44?S+1|0:0;}while((T|0)!=0)}}while(0);A=B;i=d;return A|0}}while(0);q=c[p>>2]|0;x=c[u>>2]|0;w=q;while(1){if((w|0)==(x|0)){ab=x;break}if((c[w>>2]|0)==(B|0)){ab=w;break}else{w=w+4|0}}w=ab-q>>2;p=q+(w+1<<2)|0;y=x-p|0;LG(q+(w<<2)|0,p|0,y|0)|0;p=q+((y>>2)+w<<2)|0;w=c[u>>2]|0;if((p|0)!=(w|0)){c[u>>2]=w+(~((w-4+(-p|0)|0)>>>2)<<2)}Lw(v);ac=F;ad=G;ae=ac;af=0;ag=ae;ah=ad;bg(ag|0)}}while(0);G=c[b>>2]|0;F=Lu(60)|0;c[k>>2]=F;ab=G+4|0;B=c[ab>>2]|0;if((B|0)==(c[G+8>>2]|0)){e4(G|0,k);ai=c[k>>2]|0}else{if((B|0)==0){aj=0}else{c[B>>2]=F;aj=c[ab>>2]|0}c[ab>>2]=aj+4;ai=F}F=ai;aj=b+28|0;L97:do{if((a[aj]&1)==0){B=l;c[B>>2]=c[aj>>2];c[B+4>>2]=c[aj+4>>2];c[B+8>>2]=c[aj+8>>2];s=24}else{B=c[b+36>>2]|0;k=c[b+32>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(k>>>0<11>>>0){a[l]=k<<1;ak=l+1|0}else{n=k+16&-16;$=(z=0,au(248,n|0)|0);if(z){z=0;break}c[l+8>>2]=$;c[l>>2]=n|1;c[l+4>>2]=k;ak=$}LF(ak|0,B|0,k)|0;a[ak+k|0]=0;s=24;break L97}}while(0);k=bT(-1,-1)|0;al=k;am=M}}while(0);do{if((s|0)==24){ak=b+44|0;aj=j;c[aj>>2]=c[ak>>2];c[aj+4>>2]=c[ak+4>>2];c[aj+8>>2]=c[ak+8>>2];z=0;aD(36,ai|0,l|0,j|0,0,0,0);if(z){z=0;ak=bT(-1,-1)|0;aj=ak;ak=M;if((a[l]&1)==0){al=aj;am=ak;break}Lw(c[l+8>>2]|0);al=aj;am=ak;break}ak=ai;if((a[l]&1)==0){A=ak;i=d;return A|0}Lw(c[l+8>>2]|0);A=ak;i=d;return A|0}}while(0);A=c[G>>2]|0;G=c[ab>>2]|0;d=A;while(1){if((d|0)==(G|0)){an=G;break}if((c[d>>2]|0)==(ai|0)){an=d;break}else{d=d+4|0}}d=an-A>>2;an=A+(d+1<<2)|0;ai=G-an|0;LG(A+(d<<2)|0,an|0,ai|0)|0;an=A+((ai>>2)+d<<2)|0;d=c[ab>>2]|0;if((an|0)!=(d|0)){c[ab>>2]=d+(~((d-4+(-an|0)|0)>>>2)<<2)}Lw(F);ac=al;ad=am;ae=ac;af=0;ag=ae;ah=ad;bg(ag|0);return 0}function ve(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+16|0;d=b|0;e=vf(a)|0;f=zW(y$(c[a+20>>2]|0)|0)|0;if((f|0)==0){g=e;i=b;return g|0}if((y0(f)|0)!=0){g=e;i=b;return g|0}f=d|0;c[f>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=0;while(1){l=(z=0,au(160,a|0)|0);if(z){z=0;m=22;break}if((l|0)==0){m=28;break}l=(z=0,au(90,a|0)|0);if(z){z=0;m=22;break}if((k|0)!=(c[j>>2]|0)){if((k|0)==0){n=0}else{c[k>>2]=l;n=c[h>>2]|0}o=n+4|0;c[h>>2]=o;k=o;continue}o=c[f>>2]|0;p=k-o|0;q=p>>2;r=q+1|0;if(r>>>0>1073741823>>>0){m=12;break}if(q>>>0>536870910>>>0){s=1073741823;m=16}else{t=p>>1;u=t>>>0<r>>>0?r:t;if((u|0)==0){v=0;w=0}else{s=u;m=16}}if((m|0)==16){m=0;u=(z=0,au(248,s<<2|0)|0);if(z){z=0;m=22;break}v=u;w=s}u=v+(q<<2)|0;if((u|0)!=0){c[u>>2]=l}l=v+(r<<2)|0;r=o;LF(v|0,r|0,p)|0;c[f>>2]=v;c[h>>2]=l;c[j>>2]=v+(w<<2);if((o|0)==0){k=l;continue}Lw(r);k=l}do{if((m|0)==22){k=bT(-1,-1)|0;x=M;y=k}else if((m|0)==12){z=0;ar(152,0);if(z){z=0;m=23;break}return 0}else if((m|0)==28){k=(z=0,aU(32,a|0,e|0,d|0,1)|0);if(z){z=0;m=23;break}w=c[f>>2]|0;if((w|0)==0){g=k;i=b;return g|0}v=c[h>>2]|0;if((w|0)!=(v|0)){c[h>>2]=v+(~((v-4+(-w|0)|0)>>>2)<<2)}Lw(w);g=k;i=b;return g|0}}while(0);if((m|0)==23){m=bT(-1,-1)|0;x=M;y=m}m=c[f>>2]|0;if((m|0)==0){bg(y|0)}f=c[h>>2]|0;if((m|0)!=(f|0)){c[h>>2]=f+(~((f-4+(-m|0)|0)>>>2)<<2)}Lw(m);bg(y|0);return 0}function vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=i;i=i+16|0;d=b|0;e=vi(a)|0;f=zV(y$(c[a+20>>2]|0)|0)|0;if((f|0)==0){g=e;i=b;return g|0}if((y0(f)|0)!=0){g=e;i=b;return g|0}f=d|0;c[f>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=0;while(1){l=(z=0,au(174,a|0)|0);if(z){z=0;m=22;break}if((l|0)==0){m=28;break}l=(z=0,au(68,a|0)|0);if(z){z=0;m=22;break}if((k|0)!=(c[j>>2]|0)){if((k|0)==0){n=0}else{c[k>>2]=l;n=c[h>>2]|0}o=n+4|0;c[h>>2]=o;k=o;continue}o=c[f>>2]|0;p=k-o|0;q=p>>2;r=q+1|0;if(r>>>0>1073741823>>>0){m=12;break}if(q>>>0>536870910>>>0){s=1073741823;m=16}else{t=p>>1;u=t>>>0<r>>>0?r:t;if((u|0)==0){v=0;w=0}else{s=u;m=16}}if((m|0)==16){m=0;u=(z=0,au(248,s<<2|0)|0);if(z){z=0;m=22;break}v=u;w=s}u=v+(q<<2)|0;if((u|0)!=0){c[u>>2]=l}l=v+(r<<2)|0;r=o;LF(v|0,r|0,p)|0;c[f>>2]=v;c[h>>2]=l;c[j>>2]=v+(w<<2);if((o|0)==0){k=l;continue}Lw(r);k=l}do{if((m|0)==22){k=bT(-1,-1)|0;x=M;y=k}else if((m|0)==12){z=0;ar(152,0);if(z){z=0;m=23;break}return 0}else if((m|0)==28){k=(z=0,aU(32,a|0,e|0,d|0,0)|0);if(z){z=0;m=23;break}w=c[f>>2]|0;if((w|0)==0){g=k;i=b;return g|0}v=c[h>>2]|0;if((w|0)!=(v|0)){c[h>>2]=v+(~((v-4+(-w|0)|0)>>>2)<<2)}Lw(w);g=k;i=b;return g|0}}while(0);if((m|0)==23){m=bT(-1,-1)|0;x=M;y=m}m=c[f>>2]|0;if((m|0)==0){bg(y|0)}f=c[h>>2]|0;if((m|0)!=(f|0)){c[h>>2]=f+(~((f-4+(-m|0)|0)>>>2)<<2)}Lw(m);bg(y|0);return 0}function vg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zW(e)|0;if((f|0)==0){g=0;return g|0}h=(y0(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L7}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[f>>2]=h+n;h=e;f=0;while(1){o=h-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{h=o;f=f+1|0}}h=b+40|0;if((n|0)!=0){c[h>>2]=1}n=c[h>>2]|0;c[b+52>>2]=n+f;j=i;o=e;c[h>>2]=j-o+f+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=i;g=i;return g|0}function vh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;g=i;i=i+40|0;h=g|0;j=g+8|0;k=g+24|0;l=e|0;m=(c[e+4>>2]|0)-(c[l>>2]|0)>>2;if((m|0)==0){n=d;i=g;return n|0}e=b|0;o=b+28|0;p=j;q=k;r=b+44|0;s=(f|0)==11;t=j+8|0;u=b+36|0;v=b+32|0;b=j+1|0;w=j|0;x=j+4|0;y=0;A=d;while(1){B=c[e>>2]|0;d=Lu(48)|0;c[h>>2]=d;C=B+4|0;D=c[C>>2]|0;if((D|0)==(c[B+8>>2]|0)){e4(B|0,h);E=c[h>>2]|0}else{if((D|0)==0){F=0}else{c[D>>2]=d;F=c[C>>2]|0}c[C>>2]=F+4;E=d}G=E;if((a[o]&1)==0){c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{d=c[u>>2]|0;D=c[v>>2]|0;if(D>>>0>4294967279>>>0){H=11;break}if(D>>>0<11>>>0){a[p]=D<<1;I=b}else{J=D+16&-16;K=(z=0,au(248,J|0)|0);if(z){z=0;H=25;break}c[t>>2]=K;c[w>>2]=J|1;c[x>>2]=D;I=K}LF(I|0,d|0,D)|0;a[I+D|0]=0}c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];z=0;aD(14,E|0,j|0,k|0,f|0,A|0,c[(c[l>>2]|0)+(y<<2)>>2]|0);if(z){z=0;H=28;break}D=E;if((a[p]&1)!=0){Lw(c[t>>2]|0)}d=c[E+40>>2]|0;do{if(s){if((a[d+28|0]&1)==0){H=35;break}if((a[(c[E+44>>2]|0)+28|0]&1)==0){H=35;break}a[E+28|0]=1}else{H=35}}while(0);if((H|0)==35){H=0;a[d+28|0]=0;a[(c[E+44>>2]|0)+28|0]=0}K=y+1|0;if(K>>>0<m>>>0){y=K;A=D}else{n=D;H=40;break}}do{if((H|0)==25){A=bT(-1,-1)|0;L=M;N=A;H=27}else if((H|0)==11){z=0;ar(86,0);if(!z){return 0}else{z=0;A=bT(-1,-1)|0;L=M;N=A;H=27;break}}else if((H|0)==40){i=g;return n|0}else if((H|0)==28){A=bT(-1,-1)|0;y=A;A=M;if((a[p]&1)==0){O=A;P=y;break}Lw(c[t>>2]|0);O=A;P=y}}while(0);if((H|0)==27){O=L;P=N}N=c[B>>2]|0;B=c[C>>2]|0;L=N;while(1){if((L|0)==(B|0)){Q=B;break}if((c[L>>2]|0)==(E|0)){Q=L;break}else{L=L+4|0}}L=Q-N>>2;Q=N+(L+1<<2)|0;E=B-Q|0;LG(N+(L<<2)|0,Q|0,E|0)|0;Q=N+((E>>2)+L<<2)|0;L=c[C>>2]|0;if((Q|0)==(L|0)){Lw(G);R=P;S=0;T=R;U=O;bg(T|0)}c[C>>2]=L+(~((L-4+(-Q|0)|0)>>>2)<<2);Lw(G);R=P;S=0;T=R;U=O;bg(T|0);return 0}function vi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;d=i;i=i+40|0;e=d|0;f=d+8|0;g=d+24|0;h=vk(b)|0;j=b+20|0;do{if((zX(y$(c[j>>2]|0)|0)|0)==0){if((zY(y$(c[j>>2]|0)|0)|0)!=0){break}if((z_(y$(c[j>>2]|0)|0)|0)!=0){break}if((zZ(y$(c[j>>2]|0)|0)|0)!=0){break}if((z0(y$(c[j>>2]|0)|0)|0)!=0){break}if((z$(y$(c[j>>2]|0)|0)|0)==0){k=h}else{break}i=d;return k|0}}while(0);do{if((vl(b)|0)==0){if((vm(b)|0)!=0){l=3;break}if((vn(b)|0)!=0){l=5;break}if((vo(b)|0)!=0){l=7;break}if((vp(b)|0)!=0){l=4;break}vq(b)|0;l=6}else{l=2}}while(0);j=vk(b)|0;m=c[b>>2]|0;n=Lu(48)|0;c[e>>2]=n;o=m+4|0;p=c[o>>2]|0;if((p|0)==(c[m+8>>2]|0)){e4(m|0,e);q=c[e>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=n;r=c[o>>2]|0}c[o>>2]=r+4;q=n}n=q;r=b+28|0;L23:do{if((a[r]&1)==0){p=f;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];s=28}else{p=c[b+36>>2]|0;e=c[b+32>>2]|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(e>>>0<11>>>0){a[f]=e<<1;t=f+1|0}else{u=e+16&-16;v=(z=0,au(248,u|0)|0);if(z){z=0;break}c[f+8>>2]=v;c[f>>2]=u|1;c[f+4>>2]=e;t=v}LF(t|0,p|0,e)|0;a[t+e|0]=0;s=28;break L23}}while(0);e=bT(-1,-1)|0;w=M;x=e}}while(0);do{if((s|0)==28){t=g;b=h+16|0;c[t>>2]=c[b>>2];c[t+4>>2]=c[b+4>>2];c[t+8>>2]=c[b+8>>2];z=0;aD(14,q|0,f|0,g|0,l|0,h|0,j|0);if(z){z=0;b=bT(-1,-1)|0;t=b;b=M;if((a[f]&1)==0){w=b;x=t;break}Lw(c[f+8>>2]|0);w=b;x=t;break}t=q;if((a[f]&1)==0){k=t;i=d;return k|0}Lw(c[f+8>>2]|0);k=t;i=d;return k|0}}while(0);k=c[m>>2]|0;m=c[o>>2]|0;d=k;while(1){if((d|0)==(m|0)){y=m;break}if((c[d>>2]|0)==(q|0)){y=d;break}else{d=d+4|0}}d=y-k>>2;y=k+(d+1<<2)|0;q=m-y|0;LG(k+(d<<2)|0,y|0,q|0)|0;y=k+((q>>2)+d<<2)|0;d=c[o>>2]|0;if((y|0)==(d|0)){Lw(n);A=x;B=0;C=A;D=w;bg(C|0)}c[o>>2]=d+(~((d-4+(-y|0)|0)>>>2)<<2);Lw(n);A=x;B=0;C=A;D=w;bg(C|0);return 0}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zV(e)|0;if((f|0)==0){g=0;return g|0}h=(y0(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=h+o;h=e;f=0;while(1){n=h-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{h=n;f=f+1|0}}h=b+40|0;if((o|0)!=0){c[h>>2]=1}o=c[h>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[h>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function vk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;e=d|0;f=d+16|0;g=d+32|0;h=vs(b)|0;j=b+20|0;k=y$(c[j>>2]|0)|0;do{if((k+1|0)==0|(a[k]|0)!=43){l=y$(c[j>>2]|0)|0;m=(zw(l)|0)!=0;n=m?0:l;if((n|0)==0){o=h;i=d;return o|0}if((n+1|0)==0|(a[n]|0)!=45){o=h}else{break}i=d;return o|0}}while(0);k=e|0;c[k>>2]=0;n=e+4|0;c[n>>2]=0;l=e+8|0;c[l>>2]=0;m=f|0;c[m>>2]=0;p=f+4|0;c[p>>2]=0;q=f+8|0;c[q>>2]=0;r=g|0;s=g+4|0;t=b+56|0;u=b+48|0;v=b+40|0;w=b+52|0;x=t;y=0;L8:while(1){A=(z=0,au(66,c[j>>2]|0)|0);if(z){z=0;B=51;break}C=(a[A]|0)==43?A+1|0:0;if((C|0)==0){D=(z=0,au(150,b|0)|0);if(z){z=0;B=51;break}if((D|0)==0){B=57;break}}else{D=c[u>>2]|0;E=c[j>>2]|0;L15:do{if(E>>>0<C>>>0){F=E;G=0;while(1){H=a[F]|0;if((H<<24>>24|0)==10){I=G+1|0}else if((H<<24>>24|0)==0){J=G;break L15}else{I=G}H=F+1|0;if(H>>>0<C>>>0){F=H;G=I}else{J=I;break}}}else{J=0}}while(0);c[u>>2]=J+D;G=A;F=0;while(1){H=G-1|0;if(H>>>0<E>>>0){break}if((a[H]|0)==10){break}else{G=H;F=F+1|0}}if((J|0)!=0){c[v>>2]=1}G=c[v>>2]|0;c[w>>2]=G+F;E=C;D=A;c[v>>2]=E-D+F+G;c[x>>2]=D;c[x+4>>2]=E;c[j>>2]=C}c[r>>2]=5824;c[s>>2]=5825;E=(z=0,aM(500,t|0,g|0)|0);if(z){z=0;B=51;break}D=E?8:9;do{if((y|0)==(c[q>>2]|0)){E=c[m>>2]|0;G=y-E|0;H=G>>2;K=H+1|0;if(K>>>0>1073741823>>>0){B=25;break L8}if(H>>>0>536870910>>>0){L=1073741823;B=29}else{N=G>>1;O=N>>>0<K>>>0?K:N;if((O|0)==0){P=0;Q=0}else{L=O;B=29}}if((B|0)==29){B=0;O=(z=0,au(248,L<<2|0)|0);if(z){z=0;B=51;break L8}P=O;Q=L}O=P+(H<<2)|0;if((O|0)!=0){c[O>>2]=D}O=P+(K<<2)|0;K=E;LF(P|0,K|0,G)|0;c[m>>2]=P;c[p>>2]=O;c[q>>2]=P+(Q<<2);if((E|0)==0){R=O;break}Lw(K);R=O}else{if((y|0)==0){S=0}else{c[y>>2]=D;S=c[p>>2]|0}O=S+4|0;c[p>>2]=O;R=O}}while(0);D=(z=0,au(308,b|0)|0);if(z){z=0;B=51;break}C=c[n>>2]|0;if((C|0)!=(c[l>>2]|0)){if((C|0)!=0){c[C>>2]=D}c[n>>2]=C+4;y=R;continue}F=c[k>>2]|0;A=C-F|0;C=A>>2;O=C+1|0;if(O>>>0>1073741823>>>0){B=41;break}if(C>>>0>536870910>>>0){T=1073741823;B=45}else{K=A>>1;E=K>>>0<O>>>0?O:K;if((E|0)==0){U=0;V=0}else{T=E;B=45}}if((B|0)==45){B=0;E=(z=0,au(248,T<<2|0)|0);if(z){z=0;B=51;break}U=E;V=T}E=U+(C<<2)|0;if((E|0)!=0){c[E>>2]=D}D=F;LF(U|0,D|0,A)|0;c[k>>2]=U;c[n>>2]=U+(O<<2);c[l>>2]=U+(V<<2);if((F|0)==0){y=R;continue}Lw(D);y=R}do{if((B|0)==25){z=0;ar(152,0);if(z){z=0;B=52;break}return 0}else if((B|0)==51){R=bT(-1,-1)|0;W=M;X=R}else if((B|0)==41){z=0;ar(152,0);if(z){z=0;B=52;break}return 0}else if((B|0)==57){R=(z=0,aU(48,b|0,h|0,e|0,f|0)|0);if(z){z=0;B=52;break}y=c[m>>2]|0;V=y;if((y|0)!=0){U=c[p>>2]|0;if((y|0)!=(U|0)){c[p>>2]=U+(~((U-4+(-V|0)|0)>>>2)<<2)}Lw(y)}y=c[k>>2]|0;if((y|0)==0){o=R;i=d;return o|0}V=c[n>>2]|0;if((y|0)!=(V|0)){c[n>>2]=V+(~((V-4+(-y|0)|0)>>>2)<<2)}Lw(y);o=R;i=d;return o|0}}while(0);if((B|0)==52){B=bT(-1,-1)|0;W=M;X=B}B=c[m>>2]|0;m=B;if((B|0)!=0){W=c[p>>2]|0;if((B|0)!=(W|0)){c[p>>2]=W+(~((W-4+(-m|0)|0)>>>2)<<2)}Lw(B)}B=c[k>>2]|0;if((B|0)==0){bg(X|0)}k=c[n>>2]|0;if((B|0)!=(k|0)){c[n>>2]=k+(~((k-4+(-B|0)|0)>>>2)<<2)}Lw(B);bg(X|0);return 0}function vl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zX(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zY(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=z_(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=z0(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zZ(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=z$(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+48|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;LF(m|0,e|0,12)|0;e=k;n=l;o=b|0;p=d;if((a[p]&1)==0){c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2]}else{p=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){D5(0)}if(q>>>0<11>>>0){a[e]=q<<1;r=k+1|0}else{d=q+16&-16;s=Lu(d)|0;c[k+8>>2]=s;c[k>>2]=d|1;c[k+4>>2]=q;r=s}LF(r|0,p|0,q)|0;a[r+q|0]=0}c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];z=0;aD(6,o|0,k|0,l|0,0,0,0);if(!z){if((a[e]&1)==0){t=b|0;c[t>>2]=20856;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;c[w>>2]=h;i=j;return}Lw(c[k+8>>2]|0);t=b|0;c[t>>2]=20856;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;c[w>>2]=h;i=j;return}else{z=0;j=bT(-1,-1)|0;if((a[e]&1)==0){bg(j|0)}Lw(c[k+8>>2]|0);bg(j|0)}}function vs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;d=i;i=i+48|0;e=d|0;f=d+16|0;g=d+32|0;h=d+40|0;j=vw(b)|0;k=b+20|0;l=y$(c[k>>2]|0)|0;do{if((l+1|0)==0|(a[l]|0)!=42){m=y$(c[k>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=47)){break}m=y$(c[k>>2]|0)|0;if((m+1|0)==0|(a[m]|0)!=37){n=j}else{break}i=d;return n|0}}while(0);l=e|0;c[l>>2]=0;m=e+4|0;c[m>>2]=0;o=e+8|0;c[o>>2]=0;p=f|0;c[p>>2]=0;q=f+4|0;c[q>>2]=0;r=f+8|0;c[r>>2]=0;s=b+48|0;t=b+40|0;u=b+52|0;v=b+56|0;w=v;x=g|0;y=g+4|0;A=h|0;B=h+4|0;C=0;L6:while(1){D=(z=0,au(66,c[k>>2]|0)|0);if(z){z=0;E=58;break}F=(a[D]|0)==42?D+1|0:0;do{if((F|0)==0){G=(z=0,au(66,c[k>>2]|0)|0);if(z){z=0;E=58;break L6}H=(a[G]|0)==47?G+1|0:0;if((H|0)!=0){I=c[s>>2]|0;J=c[k>>2]|0;L14:do{if(J>>>0<H>>>0){K=J;L=0;while(1){N=a[K]|0;if((N<<24>>24|0)==10){O=L+1|0}else if((N<<24>>24|0)==0){P=L;break L14}else{O=L}N=K+1|0;if(N>>>0<H>>>0){K=N;L=O}else{P=O;break}}}else{P=0}}while(0);c[s>>2]=P+I;L=G;K=0;while(1){N=L-1|0;if(N>>>0<J>>>0){break}if((a[N]|0)==10){break}else{L=N;K=K+1|0}}if((P|0)!=0){c[t>>2]=1}L=c[t>>2]|0;c[u>>2]=L+K;J=H;I=G;c[t>>2]=J-I+K+L;c[w>>2]=I;c[w+4>>2]=J;c[k>>2]=H;break}J=(z=0,au(66,c[k>>2]|0)|0);if(z){z=0;E=58;break L6}I=(a[J]|0)==37?J+1|0:0;if((I|0)==0){E=112;break L6}L=c[s>>2]|0;N=c[k>>2]|0;L31:do{if(N>>>0<I>>>0){Q=N;R=0;while(1){S=a[Q]|0;if((S<<24>>24|0)==0){T=R;break L31}else if((S<<24>>24|0)==10){U=R+1|0}else{U=R}S=Q+1|0;if(S>>>0<I>>>0){Q=S;R=U}else{T=U;break}}}else{T=0}}while(0);c[s>>2]=T+L;H=J;K=0;while(1){G=H-1|0;if(G>>>0<N>>>0){break}if((a[G]|0)==10){break}else{H=G;K=K+1|0}}if((T|0)!=0){c[t>>2]=1}H=c[t>>2]|0;c[u>>2]=H+K;N=I;L=J;c[t>>2]=N-L+K+H;c[w>>2]=L;c[w+4>>2]=N;c[k>>2]=I}else{N=c[s>>2]|0;L=c[k>>2]|0;L46:do{if(L>>>0<F>>>0){H=L;G=0;while(1){R=a[H]|0;if((R<<24>>24|0)==10){V=G+1|0}else if((R<<24>>24|0)==0){W=G;break L46}else{V=G}R=H+1|0;if(R>>>0<F>>>0){H=R;G=V}else{W=V;break}}}else{W=0}}while(0);c[s>>2]=W+N;I=D;K=0;while(1){J=I-1|0;if(J>>>0<L>>>0){break}if((a[J]|0)==10){break}else{I=J;K=K+1|0}}if((W|0)!=0){c[t>>2]=1}I=c[t>>2]|0;c[u>>2]=I+K;L=F;N=D;c[t>>2]=L-N+K+I;c[w>>2]=N;c[w+4>>2]=L;c[k>>2]=F}}while(0);c[x>>2]=5728;c[y>>2]=5729;F=(z=0,aM(500,v|0,g|0)|0);if(z){z=0;E=58;break}do{if(F){if((C|0)!=(c[r>>2]|0)){if((C|0)==0){X=0}else{c[C>>2]=10;X=c[q>>2]|0}D=X+4|0;c[q>>2]=D;Y=D;break}D=c[p>>2]|0;L=C-D|0;N=L>>2;I=N+1|0;if(I>>>0>1073741823>>>0){E=48;break L6}if(N>>>0>536870910>>>0){Z=1073741823;E=52}else{J=L>>1;G=J>>>0<I>>>0?I:J;if((G|0)==0){_=0;$=0}else{Z=G;E=52}}if((E|0)==52){E=0;G=(z=0,au(248,Z<<2|0)|0);if(z){z=0;E=58;break L6}_=G;$=Z}G=_+(N<<2)|0;if((G|0)!=0){c[G>>2]=10}G=_+(I<<2)|0;I=D;LF(_|0,I|0,L)|0;c[p>>2]=_;c[q>>2]=G;c[r>>2]=_+($<<2);if((D|0)==0){Y=G;break}Lw(I);Y=G}else{c[A>>2]=5688;c[B>>2]=5689;G=(z=0,aM(500,v|0,h|0)|0);if(z){z=0;E=58;break L6}I=(C|0)==(c[r>>2]|0);if(G){if(!I){if((C|0)==0){aa=0}else{c[C>>2]=11;aa=c[q>>2]|0}G=aa+4|0;c[q>>2]=G;Y=G;break}G=c[p>>2]|0;D=C-G|0;L=D>>2;N=L+1|0;if(N>>>0>1073741823>>>0){E=71;break L6}if(L>>>0>536870910>>>0){ab=1073741823;E=75}else{J=D>>1;H=J>>>0<N>>>0?N:J;if((H|0)==0){ac=0;ad=0}else{ab=H;E=75}}if((E|0)==75){E=0;H=(z=0,au(248,ab<<2|0)|0);if(z){z=0;E=58;break L6}ac=H;ad=ab}H=ac+(L<<2)|0;if((H|0)!=0){c[H>>2]=11}H=ac+(N<<2)|0;N=G;LF(ac|0,N|0,D)|0;c[p>>2]=ac;c[q>>2]=H;c[r>>2]=ac+(ad<<2);if((G|0)==0){Y=H;break}Lw(N);Y=H;break}else{if(!I){if((C|0)==0){ae=0}else{c[C>>2]=12;ae=c[q>>2]|0}I=ae+4|0;c[q>>2]=I;Y=I;break}I=c[p>>2]|0;H=C-I|0;N=H>>2;G=N+1|0;if(G>>>0>1073741823>>>0){E=86;break L6}if(N>>>0>536870910>>>0){af=1073741823;E=90}else{D=H>>1;L=D>>>0<G>>>0?G:D;if((L|0)==0){ag=0;ah=0}else{af=L;E=90}}if((E|0)==90){E=0;L=(z=0,au(248,af<<2|0)|0);if(z){z=0;E=58;break L6}ag=L;ah=af}L=ag+(N<<2)|0;if((L|0)!=0){c[L>>2]=12}L=ag+(G<<2)|0;G=I;LF(ag|0,G|0,H)|0;c[p>>2]=ag;c[q>>2]=L;c[r>>2]=ag+(ah<<2);if((I|0)==0){Y=L;break}Lw(G);Y=L;break}}}while(0);F=(z=0,au(268,b|0)|0);if(z){z=0;E=58;break}L=c[m>>2]|0;if((L|0)!=(c[o>>2]|0)){if((L|0)!=0){c[L>>2]=F}c[m>>2]=L+4;C=Y;continue}G=c[l>>2]|0;I=L-G|0;L=I>>2;H=L+1|0;if(H>>>0>1073741823>>>0){E=102;break}if(L>>>0>536870910>>>0){ai=1073741823;E=106}else{N=I>>1;D=N>>>0<H>>>0?H:N;if((D|0)==0){aj=0;ak=0}else{ai=D;E=106}}if((E|0)==106){E=0;D=(z=0,au(248,ai<<2|0)|0);if(z){z=0;E=58;break}aj=D;ak=ai}D=aj+(L<<2)|0;if((D|0)!=0){c[D>>2]=F}F=G;LF(aj|0,F|0,I)|0;c[l>>2]=aj;c[m>>2]=aj+(H<<2);c[o>>2]=aj+(ak<<2);if((G|0)==0){C=Y;continue}Lw(F);C=Y}do{if((E|0)==48){z=0;ar(152,0);if(z){z=0;E=59;break}return 0}else if((E|0)==86){z=0;ar(152,0);if(z){z=0;E=59;break}return 0}else if((E|0)==112){Y=(z=0,aU(48,b|0,j|0,e|0,f|0)|0);if(z){z=0;E=59;break}C=c[p>>2]|0;ak=C;if((C|0)!=0){aj=c[q>>2]|0;if((C|0)!=(aj|0)){c[q>>2]=aj+(~((aj-4+(-ak|0)|0)>>>2)<<2)}Lw(C)}C=c[l>>2]|0;if((C|0)==0){n=Y;i=d;return n|0}ak=c[m>>2]|0;if((C|0)!=(ak|0)){c[m>>2]=ak+(~((ak-4+(-C|0)|0)>>>2)<<2)}Lw(C);n=Y;i=d;return n|0}else if((E|0)==102){z=0;ar(152,0);if(z){z=0;E=59;break}return 0}else if((E|0)==58){Y=bT(-1,-1)|0;al=M;am=Y}else if((E|0)==71){z=0;ar(152,0);if(z){z=0;E=59;break}return 0}}while(0);if((E|0)==59){E=bT(-1,-1)|0;al=M;am=E}E=c[p>>2]|0;p=E;if((E|0)!=0){al=c[q>>2]|0;if((E|0)!=(al|0)){c[q>>2]=al+(~((al-4+(-p|0)|0)>>>2)<<2)}Lw(E)}E=c[l>>2]|0;if((E|0)==0){bg(am|0)}l=c[m>>2]|0;if((E|0)!=(l|0)){c[m>>2]=l+(~((l-4+(-E|0)|0)>>>2)<<2)}Lw(E);bg(am|0);return 0}function vt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=(zw(e)|0)!=0;g=f?0:e;if((g|0)==0){h=0;return h|0}f=(a[g]|0)==45?g+1|0:0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function vu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+32|0;f=d;d=i;i=i+8|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];f=e|0;g=e+16|0;h=c[b>>2]|0;j=(c[b+4>>2]|0)-h|0;if(j>>>0>4294967279>>>0){D5(0);return 0}if(j>>>0<11>>>0){b=j<<1&255;a[f]=b;k=f+1|0;l=b}else{b=j+16&-16;m=Lu(b)|0;c[f+8>>2]=m;n=b|1;c[f>>2]=n;c[f+4>>2]=j;k=m;l=n&255}LF(k|0,h|0,j)|0;a[k+j|0]=0;j=c[d>>2]|0;k=(c[d+4>>2]|0)-j|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(k>>>0<11>>>0){d=k<<1&255;a[g]=d;o=g+1|0;p=d}else{d=k+16&-16;h=(z=0,au(248,d|0)|0);if(z){z=0;break}c[g+8>>2]=h;n=d|1;c[g>>2]=n;c[g+4>>2]=k;o=h;p=n&255}LF(o|0,j|0,k)|0;a[o+k|0]=0;n=f;h=l&255;if((h&1|0)==0){q=h>>>1}else{q=c[f+4>>2]|0}h=g;d=p&255;if((d&1|0)==0){r=d>>>1}else{r=c[g+4>>2]|0}L25:do{if((q|0)==(r|0)){if((l&1)==0){s=n+1|0}else{s=c[f+8>>2]|0}if((p&1)==0){t=h+1|0}else{t=c[g+8>>2]|0}if((l&1)!=0){u=(LH(s|0,t|0,q|0)|0)==0;break}if((q|0)==0){u=1;break}else{v=t;w=s;x=q}while(1){if((a[w]|0)!=(a[v]|0)){u=0;break L25}d=x-1|0;if((d|0)==0){u=1;break}else{v=v+1|0;w=w+1|0;x=d}}}else{u=0}}while(0);if((p&1)!=0){Lw(c[g+8>>2]|0)}if((l&1)==0){i=e;return u|0}Lw(c[f+8>>2]|0);i=e;return u|0}}while(0);u=bT(-1,-1)|0;if((l&1)==0){bg(u|0)}Lw(c[f+8>>2]|0);bg(u|0);return 0}function vv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=i;i=i+40|0;h=g|0;j=g+8|0;k=g+24|0;l=e|0;m=(c[e+4>>2]|0)-(c[l>>2]|0)>>2;if((m|0)==0){n=d;i=g;return n|0}e=b|0;o=b+28|0;p=j;q=k;r=f|0;f=j+8|0;s=b+36|0;t=b+32|0;b=j+1|0;u=j|0;v=j+4|0;w=0;x=d;while(1){y=c[e>>2]|0;d=Lu(48)|0;c[h>>2]=d;A=y+4|0;B=c[A>>2]|0;if((B|0)==(c[y+8>>2]|0)){e4(y|0,h);C=c[h>>2]|0}else{if((B|0)==0){D=0}else{c[B>>2]=d;D=c[A>>2]|0}c[A>>2]=D+4;C=d}E=C;if((a[o]&1)==0){c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{d=c[s>>2]|0;B=c[t>>2]|0;if(B>>>0>4294967279>>>0){F=11;break}if(B>>>0<11>>>0){a[p]=B<<1;G=b}else{H=B+16&-16;I=(z=0,au(248,H|0)|0);if(z){z=0;F=25;break}c[f>>2]=I;c[u>>2]=H|1;c[v>>2]=B;G=I}LF(G|0,d|0,B)|0;a[G+B|0]=0}B=x+16|0;c[q>>2]=c[B>>2];c[q+4>>2]=c[B+4>>2];c[q+8>>2]=c[B+8>>2];z=0;aD(14,C|0,j|0,k|0,c[(c[r>>2]|0)+(w<<2)>>2]|0,x|0,c[(c[l>>2]|0)+(w<<2)>>2]|0);if(z){z=0;F=28;break}B=C;if((a[p]&1)!=0){Lw(c[f>>2]|0)}d=c[C+40>>2]|0;do{if((c[(c[r>>2]|0)+(w<<2)>>2]|0)==11){if((a[d+28|0]&1)==0){F=35;break}if((a[(c[C+44>>2]|0)+28|0]&1)==0){F=35;break}a[C+28|0]=1}else{F=35}}while(0);if((F|0)==35){F=0;a[d+28|0]=0;a[(c[C+44>>2]|0)+28|0]=0}I=w+1|0;if(I>>>0<m>>>0){w=I;x=B}else{n=B;F=39;break}}do{if((F|0)==25){x=bT(-1,-1)|0;J=M;K=x;F=27}else if((F|0)==28){x=bT(-1,-1)|0;w=x;x=M;if((a[p]&1)==0){L=x;N=w;break}Lw(c[f>>2]|0);L=x;N=w}else if((F|0)==39){i=g;return n|0}else if((F|0)==11){z=0;ar(86,0);if(!z){return 0}else{z=0;w=bT(-1,-1)|0;J=M;K=w;F=27;break}}}while(0);if((F|0)==27){L=J;N=K}K=c[y>>2]|0;y=c[A>>2]|0;J=K;while(1){if((J|0)==(y|0)){O=y;break}if((c[J>>2]|0)==(C|0)){O=J;break}else{J=J+4|0}}J=O-K>>2;O=K+(J+1<<2)|0;C=y-O|0;LG(K+(J<<2)|0,O|0,C|0)|0;O=K+((C>>2)+J<<2)|0;J=c[A>>2]|0;if((O|0)==(J|0)){Lw(E);P=N;Q=0;R=P;S=L;bg(R|0)}c[A>>2]=J+(~((J-4+(-O|0)|0)>>>2)<<2);Lw(E);P=N;Q=0;R=P;S=L;bg(R|0);return 0}function vw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0;d=i;i=i+456|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+80|0;o=d+88|0;p=d+104|0;q=d+112|0;r=d+120|0;s=d+136|0;t=d+144|0;u=d+152|0;v=d+168|0;w=d+176|0;x=d+192|0;y=d+200|0;A=d+216|0;B=d+232|0;C=d+248|0;D=d+264|0;E=d+280|0;F=d+296|0;G=d+312|0;H=d+328|0;I=d+344|0;J=d+360|0;K=d+376|0;L=d+392|0;N=d+408|0;O=d+424|0;P=d+440|0;Q=b+20|0;R=y$(c[Q>>2]|0)|0;S=(a[R]|0)==40?R+1|0:0;if((S|0)!=0){T=b+48|0;U=c[T>>2]|0;V=c[Q>>2]|0;L3:do{if(V>>>0<S>>>0){W=V;X=0;while(1){Y=a[W]|0;if((Y<<24>>24|0)==0){Z=X;break L3}else if((Y<<24>>24|0)==10){_=X+1|0}else{_=X}Y=W+1|0;if(Y>>>0<S>>>0){W=Y;X=_}else{Z=_;break}}}else{Z=0}}while(0);c[T>>2]=Z+U;U=R;_=0;while(1){X=U-1|0;if(X>>>0<V>>>0){break}if((a[X]|0)==10){break}else{U=X;_=_+1|0}}U=b+40|0;if((Z|0)!=0){c[U>>2]=1}Z=c[U>>2]|0;V=b+52|0;c[V>>2]=Z+_;X=S;W=R;c[U>>2]=X-W+_+Z;Z=b+56|0;c[Z>>2]=W;c[Z+4>>2]=X;c[Q>>2]=S;S=vd(b)|0;X=y$(c[Q>>2]|0)|0;W=(a[X]|0)==41?X+1|0:0;do{if((W|0)==0){_=Lu(32)|0;R=y+8|0;c[R>>2]=_;c[y>>2]=33;c[y+4>>2]=20;LF(_|0,5632,20)|0;a[_+20|0]=0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;z=0;aR(492,b|0,y|0,A|0);if(!z){if((a[y]&1)==0){break}Lw(c[R>>2]|0);break}else{z=0}_=bT(-1,-1)|0;Y=_;_=M;if((a[y]&1)==0){$=Y;aa=_;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}Lw(c[R>>2]|0);$=Y;aa=_;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{_=c[T>>2]|0;Y=c[Q>>2]|0;L28:do{if(Y>>>0<W>>>0){R=Y;af=0;while(1){ag=a[R]|0;if((ag<<24>>24|0)==0){ah=af;break L28}else if((ag<<24>>24|0)==10){ai=af+1|0}else{ai=af}ag=R+1|0;if(ag>>>0<W>>>0){R=ag;af=ai}else{ah=ai;break}}}else{ah=0}}while(0);c[T>>2]=ah+_;af=X;R=0;while(1){ag=af-1|0;if(ag>>>0<Y>>>0){break}if((a[ag]|0)==10){break}else{af=ag;R=R+1|0}}if((ah|0)!=0){c[U>>2]=1}af=c[U>>2]|0;c[V>>2]=af+R;Y=W;_=X;c[U>>2]=Y-_+R+af;c[Z>>2]=_;c[Z+4>>2]=Y;c[Q>>2]=W}}while(0);a[S+28|0]=0;if((c[S+32>>2]|0)==5){W=c[S+40>>2]|0;if((W|0)==(c[S+44>>2]|0)){aj=S;i=d;return aj|0}a[(c[W>>2]|0)+28|0]=0;aj=S;i=d;return aj|0}if((S|0)==0){cj();return 0}if((c[(c[(c[S>>2]|0)-4>>2]|0)+4>>2]|0)!=27568){aj=S;i=d;return aj|0}W=c[S+40>>2]|0;if((W|0)==0){aj=S;i=d;return aj|0}if((c[W+36>>2]|0)!=11){aj=S;i=d;return aj|0}a[W+28|0]=0;aj=S;i=d;return aj|0}if((z1(y$(c[Q>>2]|0)|0)|0)!=0){aj=vx(b)|0;i=d;return aj|0}if((z2(y$(c[Q>>2]|0)|0)|0)==0){S=y$(c[Q>>2]|0)|0;W=a[36784]|0;L70:do{if(W<<24>>24==0){ak=S;al=282}else{Z=S;U=36784;X=W;while(1){if((a[Z]|0)!=X<<24>>24){al=283;break L70}V=Z+1|0;ah=U+1|0;T=a[ah]|0;if(T<<24>>24==0){ak=V;al=282;break}else{Z=V;U=ah;X=T}}}}while(0);if((al|0)==282){if((ak|0)==0){al=283}}do{if((al|0)==283){ak=y$(c[Q>>2]|0)|0;W=a[37040]|0;L78:do{if(W<<24>>24==0){am=ak;al=286}else{S=ak;X=37040;U=W;while(1){if((a[S]|0)!=U<<24>>24){break L78}Z=S+1|0;R=X+1|0;T=a[R]|0;if(T<<24>>24==0){am=Z;al=286;break}else{S=Z;X=R;U=T}}}}while(0);if((al|0)==286){if((am|0)!=0){break}}W=y$(c[Q>>2]|0)|0;ak=a[36936]|0;L85:do{if(ak<<24>>24==0){an=W;al=290}else{U=W;X=36936;S=ak;while(1){if((a[U]|0)!=S<<24>>24){break L85}T=U+1|0;R=X+1|0;Z=a[R]|0;if(Z<<24>>24==0){an=T;al=290;break}else{U=T;X=R;S=Z}}}}while(0);if((al|0)==290){if((an|0)!=0){break}}if((zH(y$(c[Q>>2]|0)|0)|0)!=0){aj=vB(b)|0;i=d;return aj|0}if((y1(y$(c[Q>>2]|0)|0)|0)!=0){aj=uF(b)|0;i=d;return aj|0}do{if((zI(y$(c[Q>>2]|0)|0)|0)!=0){if((zD(y$(c[Q>>2]|0)|0)|0)!=0){break}aj=vC(b)|0;i=d;return aj|0}}while(0);if((vD(b)|0)!=0){ak=c[b>>2]|0;W=Lu(44)|0;c[f>>2]=W;S=ak+4|0;X=c[S>>2]|0;if((X|0)==(c[ak+8>>2]|0)){e4(ak|0,f);ao=c[f>>2]|0}else{if((X|0)==0){ap=0}else{c[X>>2]=W;ap=c[S>>2]|0}c[S>>2]=ap+4;ao=W}W=ao;X=ao;U=b+28|0;L114:do{if((a[U]&1)==0){Z=L;c[Z>>2]=c[U>>2];c[Z+4>>2]=c[U+4>>2];c[Z+8>>2]=c[U+8>>2];al=315}else{Z=c[b+36>>2]|0;R=c[b+32>>2]|0;do{if(R>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(R>>>0<11>>>0){a[L]=R<<1;at=L+1|0}else{T=R+16&-16;ah=(z=0,au(248,T|0)|0);if(z){z=0;break}c[L+8>>2]=ah;c[L>>2]=T|1;c[L+4>>2]=R;at=ah}LF(at|0,Z|0,R)|0;a[at+R|0]=0;al=315;break L114}}while(0);R=bT(-1,-1)|0;av=R;aw=M}}while(0);do{if((al|0)==315){U=N;R=b+44|0;c[U>>2]=c[R>>2];c[U+4>>2]=c[R+4>>2];c[U+8>>2]=c[R+8>>2];R=(z=0,au(268,b|0)|0);do{if(!z){z=0;aq(40,X|0,L|0,N|0,0,R|0);if(z){z=0;break}U=ao;if((a[L]&1)==0){aj=U;i=d;return aj|0}Lw(c[L+8>>2]|0);aj=U;i=d;return aj|0}else{z=0}}while(0);R=bT(-1,-1)|0;U=R;R=M;if((a[L]&1)==0){av=U;aw=R;break}Lw(c[L+8>>2]|0);av=U;aw=R}}while(0);X=c[ak>>2]|0;R=c[S>>2]|0;U=X;while(1){if((U|0)==(R|0)){ax=R;break}if((c[U>>2]|0)==(ao|0)){ax=U;break}else{U=U+4|0}}U=ax-X>>2;ak=X+(U+1<<2)|0;Z=R-ak|0;LG(X+(U<<2)|0,ak|0,Z|0)|0;ak=X+((Z>>2)+U<<2)|0;U=c[S>>2]|0;if((ak|0)!=(U|0)){c[S>>2]=U+(~((U-4+(-ak|0)|0)>>>2)<<2)}Lw(W);$=av;aa=aw;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}if((vF(b)|0)==0){aj=ur(b)|0;i=d;return aj|0}ak=c[b>>2]|0;U=Lu(44)|0;c[e>>2]=U;Z=ak+4|0;ah=c[Z>>2]|0;if((ah|0)==(c[ak+8>>2]|0)){e4(ak|0,e);ay=c[e>>2]|0}else{if((ah|0)==0){az=0}else{c[ah>>2]=U;az=c[Z>>2]|0}c[Z>>2]=az+4;ay=U}U=ay;ah=ay;T=b+28|0;L159:do{if((a[T]&1)==0){V=O;c[V>>2]=c[T>>2];c[V+4>>2]=c[T+4>>2];c[V+8>>2]=c[T+8>>2];al=344}else{V=c[b+36>>2]|0;ai=c[b+32>>2]|0;do{if(ai>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ai>>>0<11>>>0){a[O]=ai<<1;aA=O+1|0}else{y=ai+16&-16;A=(z=0,au(248,y|0)|0);if(z){z=0;break}c[O+8>>2]=A;c[O>>2]=y|1;c[O+4>>2]=ai;aA=A}LF(aA|0,V|0,ai)|0;a[aA+ai|0]=0;al=344;break L159}}while(0);ai=bT(-1,-1)|0;aB=ai;aC=M}}while(0);do{if((al|0)==344){T=P;W=b+44|0;c[T>>2]=c[W>>2];c[T+4>>2]=c[W+4>>2];c[T+8>>2]=c[W+8>>2];W=(z=0,au(268,b|0)|0);do{if(!z){z=0;aq(40,ah|0,O|0,P|0,1,W|0);if(z){z=0;break}T=ay;if((a[O]&1)==0){aj=T;i=d;return aj|0}Lw(c[O+8>>2]|0);aj=T;i=d;return aj|0}else{z=0}}while(0);W=bT(-1,-1)|0;T=W;W=M;if((a[O]&1)==0){aB=T;aC=W;break}Lw(c[O+8>>2]|0);aB=T;aC=W}}while(0);ah=c[ak>>2]|0;W=c[Z>>2]|0;T=ah;while(1){if((T|0)==(W|0)){aE=W;break}if((c[T>>2]|0)==(ay|0)){aE=T;break}else{T=T+4|0}}T=aE-ah>>2;ak=ah+(T+1<<2)|0;S=W-ak|0;LG(ah+(T<<2)|0,ak|0,S|0)|0;ak=ah+((S>>2)+T<<2)|0;T=c[Z>>2]|0;if((ak|0)!=(T|0)){c[Z>>2]=T+(~((T-4+(-ak|0)|0)>>>2)<<2)}Lw(U);$=aB;aa=aC;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}while(0);aj=vA(b)|0;i=d;return aj|0}aC=b|0;aB=c[aC>>2]|0;aE=Lu(60)|0;c[x>>2]=aE;ay=aB+4|0;O=c[ay>>2]|0;if((O|0)==(c[aB+8>>2]|0)){e4(aB|0,x);aF=c[x>>2]|0}else{if((O|0)==0){aG=0}else{c[O>>2]=aE;aG=c[ay>>2]|0}c[ay>>2]=aG+4;aF=aE}aE=aF;aG=b+28|0;L202:do{if((a[aG]&1)==0){O=B;c[O>>2]=c[aG>>2];c[O+4>>2]=c[aG+4>>2];c[O+8>>2]=c[aG+8>>2];al=54}else{O=c[b+36>>2]|0;x=c[b+32>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[B]=x<<1;aH=B+1|0}else{P=x+16&-16;aA=(z=0,au(248,P|0)|0);if(z){z=0;break}c[B+8>>2]=aA;c[B>>2]=P|1;c[B+4>>2]=x;aH=aA}LF(aH|0,O|0,x)|0;a[aH+x|0]=0;al=54;break L202}}while(0);x=bT(-1,-1)|0;aI=x;aJ=M}}while(0);do{if((al|0)==54){aH=b+44|0;x=w;c[x>>2]=c[aH>>2];c[x+4>>2]=c[aH+4>>2];c[x+8>>2]=c[aH+8>>2];z=0;aD(2,aF|0,B|0,w|0,3,0,0);if(z){z=0;x=bT(-1,-1)|0;O=x;x=M;if((a[B]&1)==0){aI=O;aJ=x;break}Lw(c[B+8>>2]|0);aI=O;aJ=x;break}if((a[B]&1)!=0){Lw(c[B+8>>2]|0)}L224:do{if((uy(b)|0)==0){vy(b)|0;x=aF+40|0;O=x;U=c[aC>>2]|0;Z=Lu(52)|0;c[s>>2]=Z;ah=U+4|0;W=c[ah>>2]|0;if((W|0)==(c[U+8>>2]|0)){e4(U|0,s);aK=c[s>>2]|0}else{if((W|0)==0){aL=0}else{c[W>>2]=Z;aL=c[ah>>2]|0}c[ah>>2]=aL+4;aK=Z}Z=aK;L233:do{if((a[aG]&1)==0){W=F;c[W>>2]=c[aG>>2];c[W+4>>2]=c[aG+4>>2];c[W+8>>2]=c[aG+8>>2];al=129}else{W=c[b+36>>2]|0;aA=c[b+32>>2]|0;do{if(aA>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aA>>>0<11>>>0){a[F]=aA<<1;aM=F+1|0}else{P=aA+16&-16;az=(z=0,au(248,P|0)|0);if(z){z=0;break}c[F+8>>2]=az;c[F>>2]=P|1;c[F+4>>2]=aA;aM=az}LF(aM|0,W|0,aA)|0;a[aM+aA|0]=0;al=129;break L233}}while(0);aA=bT(-1,-1)|0;aN=M;aO=aA}}while(0);do{if((al|0)==129){aA=r;c[aA>>2]=c[aH>>2];c[aA+4>>2]=c[aH+4>>2];c[aA+8>>2]=c[aH+8>>2];z=0;aq(14,aK|0,F|0,r|0,b+56|0,0);do{if(!z){aA=aK;c[q>>2]=aA;W=x+8|0;az=c[W>>2]|0;P=az;if((az|0)==(c[x+12>>2]|0)){z=0;as(376,x+4|0,q|0);if(z){z=0;aP=0;break}aQ=c[q>>2]|0}else{if((az|0)==0){aS=0}else{c[P>>2]=aA;aS=c[W>>2]|0}c[W>>2]=aS+4;aQ=aA}z=0;as(c[c[x>>2]>>2]|0,O|0,aQ|0);if(z){z=0;aP=0;break}if((a[F]&1)==0){break L224}Lw(c[F+8>>2]|0);break L224}else{z=0;aP=1}}while(0);aA=bT(-1,-1)|0;W=aA;aA=M;if((a[F]&1)==0){if(aP){aN=aA;aO=W;break}else{$=W;aa=aA}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{Lw(c[F+8>>2]|0);if(aP){aN=aA;aO=W;break}else{$=W;aa=aA}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}}while(0);O=c[U>>2]|0;x=c[ah>>2]|0;aA=O;while(1){if((aA|0)==(x|0)){aT=x;break}if((c[aA>>2]|0)==(aK|0)){aT=aA;break}else{aA=aA+4|0}}aA=aT-O>>2;U=O+(aA+1<<2)|0;W=x-U|0;LG(O+(aA<<2)|0,U|0,W|0)|0;U=O+((W>>2)+aA<<2)|0;aA=c[ah>>2]|0;if((U|0)!=(aA|0)){c[ah>>2]=aA+(~((aA-4+(-U|0)|0)>>>2)<<2)}Lw(Z);$=aO;aa=aN;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{U=aF+40|0;aA=U;W=c[aC>>2]|0;P=Lu(48)|0;c[v>>2]=P;az=W+4|0;e=c[az>>2]|0;if((e|0)==(c[W+8>>2]|0)){e4(W|0,v);aU=c[v>>2]|0}else{if((e|0)==0){aW=0}else{c[e>>2]=P;aW=c[az>>2]|0}c[az>>2]=aW+4;aU=P}P=aU;e=aU;L283:do{if((a[aG]&1)==0){aw=C;c[aw>>2]=c[aG>>2];c[aw+4>>2]=c[aG+4>>2];c[aw+8>>2]=c[aG+8>>2];al=73}else{aw=c[b+36>>2]|0;av=c[b+32>>2]|0;do{if(av>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(av>>>0<11>>>0){a[C]=av<<1;aX=C+1|0}else{ax=av+16&-16;ao=(z=0,au(248,ax|0)|0);if(z){z=0;break}c[C+8>>2]=ao;c[C>>2]=ax|1;c[C+4>>2]=av;aX=ao}LF(aX|0,aw|0,av)|0;a[aX+av|0]=0;al=73;break L283}}while(0);av=bT(-1,-1)|0;aY=M;aZ=av}}while(0);do{if((al|0)==73){Z=D;c[Z>>2]=c[aH>>2];c[Z+4>>2]=c[aH+4>>2];c[Z+8>>2]=c[aH+8>>2];ah=c[b+56>>2]|0;O=(c[b+60>>2]|0)-ah|0;do{if(O>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;al=102;break}return 0}else{if(O>>>0<11>>>0){a[E]=O<<1;a_=E+1|0}else{x=O+16&-16;av=(z=0,au(248,x|0)|0);if(z){z=0;al=102;break}c[E+8>>2]=av;c[E>>2]=x|1;c[E+4>>2]=O;a_=av}LF(a_|0,ah|0,O)|0;a[a_+O|0]=0;av=u;c[av>>2]=c[Z>>2];c[av+4>>2]=c[Z+4>>2];c[av+8>>2]=c[Z+8>>2];z=0;aV(2,e|0,C|0,u|0,E|0);do{if(!z){av=aU;c[t>>2]=av;x=U+8|0;aw=c[x>>2]|0;ao=aw;if((aw|0)==(c[U+12>>2]|0)){z=0;as(376,U+4|0,t|0);if(z){z=0;a$=0;break}a0=c[t>>2]|0}else{if((aw|0)==0){a1=0}else{c[ao>>2]=av;a1=c[x>>2]|0}c[x>>2]=a1+4;a0=av}z=0;as(c[c[U>>2]>>2]|0,aA|0,a0|0);if(z){z=0;a$=0;break}if((a[E]&1)!=0){Lw(c[E+8>>2]|0)}if((a[C]&1)==0){break L224}Lw(c[C+8>>2]|0);break L224}else{z=0;a$=1}}while(0);av=bT(-1,-1)|0;x=av;av=M;if((a[E]&1)==0){a2=a$;a3=x;a4=av;break}Lw(c[E+8>>2]|0);a2=a$;a3=x;a4=av}}while(0);if((al|0)==102){Z=bT(-1,-1)|0;a2=1;a3=Z;a4=M}if((a[C]&1)==0){if(a2){aY=a4;aZ=a3;break}else{$=a3;aa=a4}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{Lw(c[C+8>>2]|0);if(a2){aY=a4;aZ=a3;break}else{$=a3;aa=a4}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}}while(0);aA=c[W>>2]|0;U=c[az>>2]|0;e=aA;while(1){if((e|0)==(U|0)){a5=U;break}if((c[e>>2]|0)==(aU|0)){a5=e;break}else{e=e+4|0}}e=a5-aA>>2;W=aA+(e+1<<2)|0;Z=U-W|0;LG(aA+(e<<2)|0,W|0,Z|0)|0;W=aA+((Z>>2)+e<<2)|0;e=c[az>>2]|0;if((W|0)!=(e|0)){c[az>>2]=e+(~((e-4+(-W|0)|0)>>>2)<<2)}Lw(P);$=aZ;aa=aY;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}while(0);W=y$(c[Q>>2]|0)|0;e=(a[W]|0)==61?W+1|0:0;if((e|0)!=0){Z=b+48|0;O=c[Z>>2]|0;ah=c[Q>>2]|0;L344:do{if(ah>>>0<e>>>0){av=ah;x=0;while(1){ao=a[av]|0;if((ao<<24>>24|0)==10){a6=x+1|0}else if((ao<<24>>24|0)==0){a7=x;break L344}else{a6=x}ao=av+1|0;if(ao>>>0<e>>>0){av=ao;x=a6}else{a7=a6;break}}}else{a7=0}}while(0);c[Z>>2]=a7+O;x=W;av=0;while(1){P=x-1|0;if(P>>>0<ah>>>0){break}if((a[P]|0)==10){break}else{x=P;av=av+1|0}}x=b+40|0;if((a7|0)!=0){c[x>>2]=1}ah=c[x>>2]|0;c[b+52>>2]=ah+av;O=e;Z=W;c[x>>2]=O-Z+av+ah;ah=b+56|0;c[ah>>2]=Z;c[ah+4>>2]=O;c[Q>>2]=e}O=aF+40|0;ah=O;Z=c[aC>>2]|0;x=Lu(52)|0;c[p>>2]=x;P=Z+4|0;az=c[P>>2]|0;if((az|0)==(c[Z+8>>2]|0)){e4(Z|0,p);a8=c[p>>2]|0}else{if((az|0)==0){a9=0}else{c[az>>2]=x;a9=c[P>>2]|0}c[P>>2]=a9+4;a8=x}x=a8;L366:do{if((a[aG]&1)==0){az=G;c[az>>2]=c[aG>>2];c[az+4>>2]=c[aG+4>>2];c[az+8>>2]=c[aG+8>>2];al=175}else{az=c[b+36>>2]|0;aA=c[b+32>>2]|0;do{if(aA>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aA>>>0<11>>>0){a[G]=aA<<1;ba=G+1|0}else{U=aA+16&-16;ao=(z=0,au(248,U|0)|0);if(z){z=0;break}c[G+8>>2]=ao;c[G>>2]=U|1;c[G+4>>2]=aA;ba=ao}LF(ba|0,az|0,aA)|0;a[ba+aA|0]=0;al=175;break L366}}while(0);aA=bT(-1,-1)|0;bb=M;bc=aA}}while(0);do{if((al|0)==175){e=o;c[e>>2]=c[aH>>2];c[e+4>>2]=c[aH+4>>2];c[e+8>>2]=c[aH+8>>2];e=b+56|0;z=0;aq(14,a8|0,G|0,o|0,e|0,0);do{if(!z){av=a8;c[n>>2]=av;W=O+8|0;aA=c[W>>2]|0;az=aA;ao=O+12|0;if((aA|0)==(c[ao>>2]|0)){z=0;as(376,O+4|0,n|0);if(z){z=0;bd=0;break}be=c[n>>2]|0}else{if((aA|0)==0){bf=0}else{c[az>>2]=av;bf=c[W>>2]|0}c[W>>2]=bf+4;be=av}z=0;as(c[c[O>>2]>>2]|0,ah|0,be|0);if(z){z=0;bd=0;break}if((a[G]&1)!=0){Lw(c[G+8>>2]|0)}L395:do{if((uy(b)|0)==0){vz(b)|0;av=c[aC>>2]|0;az=Lu(52)|0;c[j>>2]=az;aA=av+4|0;U=c[aA>>2]|0;if((U|0)==(c[av+8>>2]|0)){e4(av|0,j);bh=c[j>>2]|0}else{if((U|0)==0){bi=0}else{c[U>>2]=az;bi=c[aA>>2]|0}c[aA>>2]=bi+4;bh=az}az=bh;L470:do{if((a[aG]&1)==0){U=K;c[U>>2]=c[aG>>2];c[U+4>>2]=c[aG+4>>2];c[U+8>>2]=c[aG+8>>2];al=258}else{U=c[b+36>>2]|0;aw=c[b+32>>2]|0;do{if(aw>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aw>>>0<11>>>0){a[K]=aw<<1;bj=K+1|0}else{ax=aw+16&-16;L=(z=0,au(248,ax|0)|0);if(z){z=0;break}c[K+8>>2]=L;c[K>>2]=ax|1;c[K+4>>2]=aw;bj=L}LF(bj|0,U|0,aw)|0;a[bj+aw|0]=0;al=258;break L470}}while(0);aw=bT(-1,-1)|0;bk=M;bl=aw}}while(0);do{if((al|0)==258){aw=h;c[aw>>2]=c[aH>>2];c[aw+4>>2]=c[aH+4>>2];c[aw+8>>2]=c[aH+8>>2];z=0;aq(14,bh|0,K|0,h|0,e|0,0);do{if(!z){aw=bh;c[g>>2]=aw;U=c[W>>2]|0;L=U;if((U|0)==(c[ao>>2]|0)){z=0;as(376,O+4|0,g|0);if(z){z=0;bm=0;break}bn=c[g>>2]|0}else{if((U|0)==0){bo=0}else{c[L>>2]=aw;bo=c[W>>2]|0}c[W>>2]=bo+4;bn=aw}z=0;as(c[c[O>>2]>>2]|0,ah|0,bn|0);if(z){z=0;bm=0;break}if((a[K]&1)==0){break L395}Lw(c[K+8>>2]|0);break L395}else{z=0;bm=1}}while(0);aw=bT(-1,-1)|0;L=aw;aw=M;if((a[K]&1)==0){if(bm){bk=aw;bl=L;break}else{$=L;aa=aw}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{Lw(c[K+8>>2]|0);if(bm){bk=aw;bl=L;break}else{$=L;aa=aw}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}}while(0);aw=c[av>>2]|0;L=c[aA>>2]|0;U=aw;while(1){if((U|0)==(L|0)){bp=L;break}if((c[U>>2]|0)==(bh|0)){bp=U;break}else{U=U+4|0}}U=bp-aw>>2;av=aw+(U+1<<2)|0;ax=L-av|0;LG(aw+(U<<2)|0,av|0,ax|0)|0;av=aw+((ax>>2)+U<<2)|0;U=c[aA>>2]|0;if((av|0)!=(U|0)){c[aA>>2]=U+(~((U-4+(-av|0)|0)>>>2)<<2)}Lw(az);$=bl;aa=bk;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{av=c[aC>>2]|0;U=Lu(48)|0;c[m>>2]=U;ax=av+4|0;N=c[ax>>2]|0;if((N|0)==(c[av+8>>2]|0)){e4(av|0,m);bq=c[m>>2]|0}else{if((N|0)==0){br=0}else{c[N>>2]=U;br=c[ax>>2]|0}c[ax>>2]=br+4;bq=U}U=bq;N=bq;L404:do{if((a[aG]&1)==0){at=H;c[at>>2]=c[aG>>2];c[at+4>>2]=c[aG+4>>2];c[at+8>>2]=c[aG+8>>2];al=201}else{at=c[b+36>>2]|0;ap=c[b+32>>2]|0;do{if(ap>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ap>>>0<11>>>0){a[H]=ap<<1;bs=H+1|0}else{f=ap+16&-16;an=(z=0,au(248,f|0)|0);if(z){z=0;break}c[H+8>>2]=an;c[H>>2]=f|1;c[H+4>>2]=ap;bs=an}LF(bs|0,at|0,ap)|0;a[bs+ap|0]=0;al=201;break L404}}while(0);ap=bT(-1,-1)|0;bt=M;bu=ap}}while(0);do{if((al|0)==201){az=I;c[az>>2]=c[aH>>2];c[az+4>>2]=c[aH+4>>2];c[az+8>>2]=c[aH+8>>2];aA=c[e>>2]|0;aw=(c[b+60>>2]|0)-aA|0;do{if(aw>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;al=231;break}return 0}else{if(aw>>>0<11>>>0){a[J]=aw<<1;bv=J+1|0}else{L=aw+16&-16;ap=(z=0,au(248,L|0)|0);if(z){z=0;al=231;break}c[J+8>>2]=ap;c[J>>2]=L|1;c[J+4>>2]=aw;bv=ap}LF(bv|0,aA|0,aw)|0;a[bv+aw|0]=0;ap=l;c[ap>>2]=c[az>>2];c[ap+4>>2]=c[az+4>>2];c[ap+8>>2]=c[az+8>>2];z=0;aV(2,N|0,H|0,l|0,J|0);do{if(!z){ap=bq;c[k>>2]=ap;L=c[W>>2]|0;at=L;if((L|0)==(c[ao>>2]|0)){z=0;as(376,O+4|0,k|0);if(z){z=0;bw=0;break}bx=c[k>>2]|0}else{if((L|0)==0){by=0}else{c[at>>2]=ap;by=c[W>>2]|0}c[W>>2]=by+4;bx=ap}z=0;as(c[c[O>>2]>>2]|0,ah|0,bx|0);if(z){z=0;bw=0;break}if((a[J]&1)!=0){Lw(c[J+8>>2]|0)}if((a[H]&1)==0){break L395}Lw(c[H+8>>2]|0);break L395}else{z=0;bw=1}}while(0);ap=bT(-1,-1)|0;at=ap;ap=M;if((a[J]&1)==0){bz=bw;bA=at;bB=ap;break}Lw(c[J+8>>2]|0);bz=bw;bA=at;bB=ap}}while(0);if((al|0)==231){az=bT(-1,-1)|0;bz=1;bA=az;bB=M}if((a[H]&1)==0){if(bz){bt=bB;bu=bA;break}else{$=bA;aa=bB}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{Lw(c[H+8>>2]|0);if(bz){bt=bB;bu=bA;break}else{$=bA;aa=bB}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}}while(0);N=c[av>>2]|0;az=c[ax>>2]|0;aw=N;while(1){if((aw|0)==(az|0)){bC=az;break}if((c[aw>>2]|0)==(bq|0)){bC=aw;break}else{aw=aw+4|0}}aw=bC-N>>2;av=N+(aw+1<<2)|0;aA=az-av|0;LG(N+(aw<<2)|0,av|0,aA|0)|0;av=N+((aA>>2)+aw<<2)|0;aw=c[ax>>2]|0;if((av|0)!=(aw|0)){c[ax>>2]=aw+(~((aw-4+(-av|0)|0)>>>2)<<2)}Lw(U);$=bu;aa=bt;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}while(0);aj=aF;i=d;return aj|0}else{z=0;bd=1}}while(0);e=bT(-1,-1)|0;W=e;e=M;if((a[G]&1)==0){if(bd){bb=e;bc=W;break}else{$=W;aa=e}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}else{Lw(c[G+8>>2]|0);if(bd){bb=e;bc=W;break}else{$=W;aa=e}ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}}while(0);ah=c[Z>>2]|0;O=c[P>>2]|0;aH=ah;while(1){if((aH|0)==(O|0)){bD=O;break}if((c[aH>>2]|0)==(a8|0)){bD=aH;break}else{aH=aH+4|0}}aH=bD-ah>>2;Z=ah+(aH+1<<2)|0;e=O-Z|0;LG(ah+(aH<<2)|0,Z|0,e|0)|0;Z=ah+((e>>2)+aH<<2)|0;aH=c[P>>2]|0;if((Z|0)!=(aH|0)){c[P>>2]=aH+(~((aH-4+(-Z|0)|0)>>>2)<<2)}Lw(x);$=bc;aa=bb;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0)}}while(0);bb=c[aB>>2]|0;aB=c[ay>>2]|0;bc=bb;while(1){if((bc|0)==(aB|0)){bE=aB;break}if((c[bc>>2]|0)==(aF|0)){bE=bc;break}else{bc=bc+4|0}}bc=bE-bb>>2;bE=bb+(bc+1<<2)|0;aF=aB-bE|0;LG(bb+(bc<<2)|0,bE|0,aF|0)|0;bE=bb+((aF>>2)+bc<<2)|0;bc=c[ay>>2]|0;if((bE|0)!=(bc|0)){c[ay>>2]=bc+(~((bc-4+(-bE|0)|0)>>>2)<<2)}Lw(aE);$=aI;aa=aJ;ab=$;ac=0;ad=ab;ae=aa;bg(ad|0);return 0}function vx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0;d=i;i=i+128|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+64|0;m=d+72|0;n=d+88|0;o=d+96|0;p=d+112|0;q=d+120|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+8|0;w=i;i=i+64|0;x=i;i=i+8|0;y=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+8|0;vQ(b)|0;G=b+56|0;H=c[G>>2]|0;I=c[G+4>>2]|0;c[q>>2]=H;c[q+4>>2]=I;q=I-1|0;c[r+4>>2]=q;I=b+20|0;c[I>>2]=(c[I>>2]|0)-1;I=H;H=I;L1:do{if(H>>>0<q>>>0){G=a[37176]|0;J=G<<24>>24==0;L3:do{if(J){K=H;while(1){L=a[K]|0;if(L<<24>>24==0){N=12;break L1}O=K+1|0;if(!(L<<24>>24==92&(O|0)!=0|(K|0)==0)){P=K;break L3}if(O>>>0<q>>>0){K=O}else{N=12;break L1}}}else{K=H;while(1){O=a[K]|0;if(O<<24>>24==0){N=12;break L1}L=K+1|0;Q=O<<24>>24==92&(L|0)!=0?0:K;if((Q|0)!=0){O=Q;Q=37176;R=G;while(1){if((a[O]|0)!=R<<24>>24){S=O;T=R;break}U=O+1|0;V=Q+1|0;W=a[V]|0;if(W<<24>>24==0){S=U;T=0;break}else{O=U;Q=V;R=W}}if(!(T<<24>>24!=0|(S|0)==0)){P=K;break L3}}if(L>>>0<q>>>0){K=L}else{N=12;break L1}}}}while(0);K=b|0;R=c[K>>2]|0;if((P|0)==0){X=R;break}Q=Lu(60)|0;c[n>>2]=Q;O=R+4|0;W=c[O>>2]|0;if((W|0)==(c[R+8>>2]|0)){e4(R|0,n);Y=c[n>>2]|0}else{if((W|0)==0){Z=0}else{c[W>>2]=Q;Z=c[O>>2]|0}c[O>>2]=Z+4;Y=Q}Q=Y;W=b+28|0;L26:do{if((a[W]&1)==0){V=t;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];N=57}else{V=c[b+36>>2]|0;U=c[b+32>>2]|0;do{if(U>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(U>>>0<11>>>0){a[t]=U<<1;_=t+1|0}else{$=U+16&-16;aa=(z=0,au(248,$|0)|0);if(z){z=0;break}c[t+8>>2]=aa;c[t>>2]=$|1;c[t+4>>2]=U;_=aa}LF(_|0,V|0,U)|0;a[_+U|0]=0;N=57;break L26}}while(0);U=bT(-1,-1)|0;ab=M;ac=U}}while(0);do{if((N|0)==57){U=b+44|0;V=m;c[V>>2]=c[U>>2];c[V+4>>2]=c[U+4>>2];c[V+8>>2]=c[U+8>>2];z=0;aD(2,Y|0,t|0,m|0,0,0,0);if(z){z=0;V=bT(-1,-1)|0;aa=V;V=M;if((a[t]&1)==0){ab=V;ac=aa;break}Lw(c[t+8>>2]|0);ab=V;ac=aa;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}aa=Y+40|0;V=aa;$=u;ad=v|0;ae=v+4|0;af=aa+8|0;ag=aa+12|0;ah=aa+4|0;ai=u+8|0;aj=b+36|0;ak=b+32|0;al=u+1|0;am=u|0;an=u+4|0;ao=a[36840]|0;ap=ao<<24>>24==0;at=C;av=C+1|0;aw=B;ax=B+1|0;ay=D|0;aA=D+4|0;aB=D+8|0;aC=C+8|0;aE=B+8|0;aF=B|0;aG=B+4|0;aH=C+4|0;aI=C|0;aJ=x|0;aK=x+4|0;aL=y;aM=A;aN=w+28|0;aO=w+4|0;aP=y+8|0;aQ=w+8|0;aS=w+36|0;aT=y+1|0;aU=y|0;aV=y+4|0;aW=H;L48:while(1){L50:while(1){L52:do{if(J){aX=aW;while(1){aY=a[aX]|0;if(aY<<24>>24==0){N=192;break L48}aZ=aX+1|0;if(!(aY<<24>>24==92&(aZ|0)!=0|(aX|0)==0)){a_=aX;break L52}if(aZ>>>0<q>>>0){aX=aZ}else{N=192;break L48}}}else{aX=aW;while(1){aZ=a[aX]|0;if(aZ<<24>>24==0){N=192;break L48}aY=aX+1|0;a$=aZ<<24>>24==92&(aY|0)!=0?0:aX;if((a$|0)!=0){aZ=a$;a$=37176;a0=G;while(1){if((a[aZ]|0)!=a0<<24>>24){a1=aZ;a2=a0;break}a3=aZ+1|0;a4=a$+1|0;a5=a[a4]|0;if(a5<<24>>24==0){a1=a3;a2=0;break}else{aZ=a3;a$=a4;a0=a5}}if(!(a2<<24>>24!=0|(a1|0)==0)){a_=aX;break L52}}if(aY>>>0<q>>>0){aX=aY}else{N=192;break L48}}}}while(0);if((a_|0)==0){N=192;break L48}do{if(aW>>>0<a_>>>0){a6=c[K>>2]|0;aX=Lu(52)|0;c[l>>2]=aX;a7=a6+4|0;a0=c[a7>>2]|0;if((a0|0)==(c[a6+8>>2]|0)){e4(a6|0,l);a8=c[l>>2]|0}else{if((a0|0)==0){a9=0}else{c[a0>>2]=aX;a9=c[a7>>2]|0}c[a7>>2]=a9+4;a8=aX}ba=a8;aX=a8;if((a[W]&1)==0){c[$>>2]=c[W>>2];c[$+4>>2]=c[W+4>>2];c[$+8>>2]=c[W+8>>2]}else{a0=c[aj>>2]|0;a$=c[ak>>2]|0;if(a$>>>0>4294967279>>>0){N=82;break L48}if(a$>>>0<11>>>0){a[$]=a$<<1;bb=al}else{aZ=a$+16&-16;a5=(z=0,au(248,aZ|0)|0);if(z){z=0;N=108;break L48}c[ai>>2]=a5;c[am>>2]=aZ|1;c[an>>2]=a$;bb=a5}LF(bb|0,a0|0,a$)|0;a[bb+a$|0]=0}a$=k;c[a$>>2]=c[U>>2];c[a$+4>>2]=c[U+4>>2];c[a$+8>>2]=c[U+8>>2];c[ad>>2]=aW;c[ae>>2]=a_;z=0;aq(14,aX|0,u|0,k|0,v|0,0);if(z){z=0;bc=1;N=111;break L48}aX=a8;c[j>>2]=aX;a$=c[af>>2]|0;a0=a$;if((a$|0)==(c[ag>>2]|0)){z=0;as(376,ah|0,j|0);if(z){z=0;bc=0;N=111;break L48}bd=c[j>>2]|0}else{if((a$|0)==0){be=0}else{c[a0>>2]=aX;be=c[af>>2]|0}c[af>>2]=be+4;bd=aX}z=0;as(c[c[aa>>2]>>2]|0,V|0,bd|0);if(z){z=0;bc=0;N=111;break L48}if((a[$]&1)==0){break}Lw(c[ai>>2]|0)}}while(0);L99:do{if(ap){aX=a_;while(1){if(aX>>>0>=q>>>0){break L99}if((a[aX]|0)==0){break L99}if((aX|0)==0){aX=aX+1|0}else{bf=aX;break L50}}}else{aX=a_;while(1){if(aX>>>0>=q>>>0){break L99}a0=a[aX]|0;if(a0<<24>>24==0){break L99}L108:do{if(a0<<24>>24==ao<<24>>24){a$=36840;a5=aX;while(1){aZ=a5+1|0;a4=a$+1|0;a3=a[a4]|0;if(a3<<24>>24==0){bh=aZ;bi=0;break L108}if((a[aZ]|0)==a3<<24>>24){a$=a4;a5=aZ}else{bh=aZ;bi=a3;break}}}else{bh=aX;bi=ao}}while(0);if(bi<<24>>24!=0|(bh|0)==0){aX=aX+1|0}else{break}}if((aX|0)!=0){bf=aX;break L50}}}while(0);a0=q-I|0;if(a0>>>0>4294967279>>>0){N=165;break L48}if(a0>>>0<11>>>0){aY=a0<<1&255;a[at]=aY;bj=av;bk=aY}else{aY=a0+16&-16;a5=Lu(aY)|0;c[aC>>2]=a5;a$=aY|1;c[aI>>2]=a$;c[aH>>2]=a0;bj=a5;bk=a$&255}LF(bj|0,H|0,a0)|0;a[bj+a0|0]=0;LI(aw|0,0,12)|0;a0=bk&255;a$=(a0&1|0)==0?a0>>>1:c[aH>>2]|0;a0=a$+44|0;if(a0>>>0>4294967279>>>0){N=170;break L48}if(a0>>>0<11>>>0){a[aw]=88;bl=ax}else{a0=a$+60&-16;a5=(z=0,au(248,a0|0)|0);if(z){z=0;N=177;break L48}c[aE>>2]=a5;c[aF>>2]=a0|1;c[aG>>2]=44;bl=a5}LF(bl|0,4528,44)|0;a[bl+44|0]=0;z=0,az(88,B|0,((bk&1)==0?av:c[aC>>2]|0)|0,a$|0)|0;if(z){z=0;N=177;break L48}c[ay>>2]=0;c[aA>>2]=0;c[aB>>2]=0;z=0;aR(492,b|0,B|0,D|0);if(z){z=0;N=188;break L48}if((a[aw]&1)!=0){Lw(c[aE>>2]|0)}if((a[at]&1)!=0){Lw(c[aC>>2]|0)}if(aW>>>0>=q>>>0){bm=Q;N=231;break L48}}c[aJ>>2]=a_+2;c[aK>>2]=bf;L=c[K>>2]|0;if((a[W]&1)==0){c[aL>>2]=c[W>>2];c[aL+4>>2]=c[W+4>>2];c[aL+8>>2]=c[W+8>>2]}else{a$=c[aj>>2]|0;a5=c[ak>>2]|0;if(a5>>>0>4294967279>>>0){N=134;break}if(a5>>>0<11>>>0){a[aL]=a5<<1;bn=aT}else{a0=a5+16&-16;aY=Lu(a0)|0;c[aP>>2]=aY;c[aU>>2]=a0|1;c[aV>>2]=a5;bn=aY}LF(bn|0,a$|0,a5)|0;a[bn+a5|0]=0}c[aM>>2]=c[U>>2];c[aM+4>>2]=c[U+4>>2];c[aM+8>>2]=c[U+8>>2];z=0;aq(16,w|0,x|0,L|0,y|0,A|0);if(z){z=0;N=155;break}L=(z=0,au(168,w|0)|0);if(z){z=0;N=156;break}if((a[aN]&1)!=0){Lw(c[aS>>2]|0)}a5=c[aO>>2]|0;a$=a5;if((a5|0)!=0){aY=c[aQ>>2]|0;if((a5|0)!=(aY|0)){c[aQ>>2]=aY+(~((aY-4+(-a$|0)|0)>>>2)<<2)}Lw(a5)}if((a[aL]&1)!=0){Lw(c[aP>>2]|0)}a[L+29|0]=1;c[h>>2]=L;a5=c[af>>2]|0;a$=a5;if((a5|0)==(c[ag>>2]|0)){fq(ah,h);bo=c[h>>2]|0}else{if((a5|0)==0){bp=0}else{c[a$>>2]=L;bp=c[af>>2]|0}c[af>>2]=bp+4;bo=L}cB[c[c[aa>>2]>>2]&1023](V,bo);L=bf+1|0;if(L>>>0<q>>>0){aW=L}else{bm=Q;N=234;break}}do{if((N|0)==192){if(aW>>>0>=q>>>0){bm=Q;bq=bm;i=d;return bq|0}aM=c[K>>2]|0;aV=Lu(52)|0;c[g>>2]=aV;aU=aM+4|0;aT=c[aU>>2]|0;if((aT|0)==(c[aM+8>>2]|0)){e4(aM|0,g);br=c[g>>2]|0}else{if((aT|0)==0){bs=0}else{c[aT>>2]=aV;bs=c[aU>>2]|0}c[aU>>2]=bs+4;br=aV}aV=br;aT=br;L177:do{if((a[W]&1)==0){aK=E;c[aK>>2]=c[W>>2];c[aK+4>>2]=c[W+4>>2];c[aK+8>>2]=c[W+8>>2];N=208}else{aK=c[aj>>2]|0;aJ=c[ak>>2]|0;do{if(aJ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aJ>>>0<11>>>0){a[E]=aJ<<1;bt=E+1|0}else{aB=aJ+16&-16;aA=(z=0,au(248,aB|0)|0);if(z){z=0;break}c[E+8>>2]=aA;c[E>>2]=aB|1;c[E+4>>2]=aJ;bt=aA}LF(bt|0,aK|0,aJ)|0;a[bt+aJ|0]=0;N=208;break L177}}while(0);aJ=bT(-1,-1)|0;bu=aJ;bv=M}}while(0);do{if((N|0)==208){aJ=f;c[aJ>>2]=c[U>>2];c[aJ+4>>2]=c[U+4>>2];c[aJ+8>>2]=c[U+8>>2];c[F>>2]=aW;c[F+4>>2]=q;z=0;aq(14,aT|0,E|0,f|0,F|0,0);do{if(!z){aJ=br;c[e>>2]=aJ;aK=c[af>>2]|0;aA=aK;if((aK|0)==(c[ag>>2]|0)){z=0;as(376,ah|0,e|0);if(z){z=0;bw=0;break}bx=c[e>>2]|0}else{if((aK|0)==0){by=0}else{c[aA>>2]=aJ;by=c[af>>2]|0}c[af>>2]=by+4;bx=aJ}z=0;as(c[c[aa>>2]>>2]|0,V|0,bx|0);if(z){z=0;bw=0;break}if((a[E]&1)==0){bm=Q;bq=bm;i=d;return bq|0}Lw(c[E+8>>2]|0);bm=Q;bq=bm;i=d;return bq|0}else{z=0;bw=1}}while(0);aJ=bT(-1,-1)|0;aA=aJ;aJ=M;if((a[E]&1)==0){if(bw){bu=aA;bv=aJ;break}else{bz=aJ;bA=aA}bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}else{Lw(c[E+8>>2]|0);if(bw){bu=aA;bv=aJ;break}else{bz=aJ;bA=aA}bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}}}while(0);aT=c[aM>>2]|0;aA=c[aU>>2]|0;aJ=aT;while(1){if((aJ|0)==(aA|0)){bF=aA;break}if((c[aJ>>2]|0)==(br|0)){bF=aJ;break}else{aJ=aJ+4|0}}aJ=bF-aT>>2;aM=aT+(aJ+1<<2)|0;aK=aA-aM|0;LG(aT+(aJ<<2)|0,aM|0,aK|0)|0;aM=aT+((aK>>2)+aJ<<2)|0;aJ=c[aU>>2]|0;if((aM|0)!=(aJ|0)){c[aU>>2]=aJ+(~((aJ-4+(-aM|0)|0)>>>2)<<2)}Lw(aV);bz=bv;bA=bu;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}else if((N|0)==82){z=0;ar(86,0);if(!z){return 0}else{z=0;aM=bT(-1,-1)|0;bG=M;bH=aM;N=110;break}}else if((N|0)==170){z=0;ar(86,0);if(!z){return 0}else{z=0;aM=bT(-1,-1)|0;bI=M;bJ=aM;N=179;break}}else if((N|0)==188){aM=bT(-1,-1)|0;aJ=aM;aM=M;if((a[aw]&1)==0){bK=aM;bL=aJ;N=190;break}Lw(c[aE>>2]|0);bK=aM;bL=aJ;N=190}else if((N|0)==134){D5(0);return 0}else if((N|0)==177){aJ=bT(-1,-1)|0;bI=M;bJ=aJ;N=179}else if((N|0)==165){D5(0);return 0}else if((N|0)==108){aJ=bT(-1,-1)|0;bG=M;bH=aJ;N=110}else if((N|0)==111){aJ=bT(-1,-1)|0;aM=aJ;aJ=M;if((a[$]&1)==0){if(bc){bM=aM;bN=aJ;break}else{bz=aJ;bA=aM}bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}else{Lw(c[ai>>2]|0);if(bc){bM=aM;bN=aJ;break}else{bz=aJ;bA=aM}bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}}else if((N|0)==231){bq=bm;i=d;return bq|0}else if((N|0)==234){bq=bm;i=d;return bq|0}else if((N|0)==155){aM=bT(-1,-1)|0;bO=M;bP=aM;N=162}else if((N|0)==156){aM=bT(-1,-1)|0;aJ=aM;aM=M;if((a[aN]&1)!=0){Lw(c[aS>>2]|0)}aK=c[aO>>2]|0;if((aK|0)==0){bO=aM;bP=aJ;N=162;break}aB=c[aQ>>2]|0;if((aK|0)!=(aB|0)){c[aQ>>2]=aB+(~((aB-4+(-aK|0)|0)>>>2)<<2)}Lw(aK);bO=aM;bP=aJ;N=162}}while(0);if((N|0)==162){if((a[aL]&1)==0){bz=bO;bA=bP;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}Lw(c[aP>>2]|0);bz=bO;bA=bP;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}else if((N|0)==179){if((a[aw]&1)!=0){Lw(c[aE>>2]|0)}bK=bI;bL=bJ;N=190}else if((N|0)==110){bM=bH;bN=bG}if((N|0)==190){if((a[at]&1)==0){bz=bK;bA=bL;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}Lw(c[aC>>2]|0);bz=bK;bA=bL;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}aQ=c[a6>>2]|0;aO=c[a7>>2]|0;aS=aQ;while(1){if((aS|0)==(aO|0)){bQ=aO;break}if((c[aS>>2]|0)==(a8|0)){bQ=aS;break}else{aS=aS+4|0}}aS=bQ-aQ>>2;aC=aQ+(aS+1<<2)|0;at=aO-aC|0;LG(aQ+(aS<<2)|0,aC|0,at|0)|0;aC=aQ+((at>>2)+aS<<2)|0;aS=c[a7>>2]|0;if((aC|0)!=(aS|0)){c[a7>>2]=aS+(~((aS-4+(-aC|0)|0)>>>2)<<2)}Lw(ba);bz=bN;bA=bM;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}}while(0);W=c[R>>2]|0;K=c[O>>2]|0;G=W;while(1){if((G|0)==(K|0)){bR=K;break}if((c[G>>2]|0)==(Y|0)){bR=G;break}else{G=G+4|0}}G=bR-W>>2;R=W+(G+1<<2)|0;J=K-R|0;LG(W+(G<<2)|0,R|0,J|0)|0;R=W+((J>>2)+G<<2)|0;G=c[O>>2]|0;if((R|0)!=(G|0)){c[O>>2]=G+(~((G-4+(-R|0)|0)>>>2)<<2)}Lw(Q);bz=ab;bA=ac;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0)}else{N=12}}while(0);if((N|0)==12){X=c[b>>2]|0}ac=Lu(52)|0;c[p>>2]=ac;ab=X+4|0;bR=c[ab>>2]|0;if((bR|0)==(c[X+8>>2]|0)){e4(X|0,p);bS=c[p>>2]|0}else{if((bR|0)==0){bU=0}else{c[bR>>2]=ac;bU=c[ab>>2]|0}c[ab>>2]=bU+4;bS=ac}ac=bS;bU=b+28|0;L298:do{if((a[bU]&1)==0){bR=s;c[bR>>2]=c[bU>>2];c[bR+4>>2]=c[bU+4>>2];c[bR+8>>2]=c[bU+8>>2];N=29}else{bR=c[b+36>>2]|0;p=c[b+32>>2]|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(p>>>0<11>>>0){a[s]=p<<1;bV=s+1|0}else{Y=p+16&-16;bM=(z=0,au(248,Y|0)|0);if(z){z=0;break}c[s+8>>2]=bM;c[s>>2]=Y|1;c[s+4>>2]=p;bV=bM}LF(bV|0,bR|0,p)|0;a[bV+p|0]=0;N=29;break L298}}while(0);p=bT(-1,-1)|0;bW=M;bX=p}}while(0);do{if((N|0)==29){bV=b+44|0;bU=o;c[bU>>2]=c[bV>>2];c[bU+4>>2]=c[bV+4>>2];c[bU+8>>2]=c[bV+8>>2];z=0;aq(14,bS|0,s|0,o|0,r|0,0);if(z){z=0;bV=bT(-1,-1)|0;bU=bV;bV=M;if((a[s]&1)==0){bW=bV;bX=bU;break}Lw(c[s+8>>2]|0);bW=bV;bX=bU;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}a[bS+28|0]=1;bm=ac;bq=bm;i=d;return bq|0}}while(0);bq=c[X>>2]|0;X=c[ab>>2]|0;d=bq;while(1){if((d|0)==(X|0)){bY=X;break}if((c[d>>2]|0)==(bS|0)){bY=d;break}else{d=d+4|0}}d=bY-bq>>2;bY=bq+(d+1<<2)|0;bS=X-bY|0;LG(bq+(d<<2)|0,bY|0,bS|0)|0;bY=bq+((bS>>2)+d<<2)|0;d=c[ab>>2]|0;if((bY|0)!=(d|0)){c[ab>>2]=d+(~((d-4+(-bY|0)|0)>>>2)<<2)}Lw(ac);bz=bW;bA=bX;bB=bA;bC=0;bD=bB;bE=bz;bg(bD|0);return 0}function vy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y1(e)|0;do{if((f|0)==0){g=y0(e)|0;if((g|0)==0){h=0}else{i=g;break}return h|0}else{i=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L5:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L5}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[f>>2]=g+n;g=e;f=0;while(1){o=g-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{g=o;f=f+1|0}}g=b+40|0;if((n|0)!=0){c[g>>2]=1}n=c[g>>2]|0;c[b+52>>2]=n+f;j=i;o=e;c[g>>2]=j-o+f+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=i;h=i;return h|0}function vz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y1(e)|0;do{if((f|0)==0){g=y0(e)|0;if((g|0)!=0){h=g;break}g=zw(e)|0;if((g|0)!=0){h=g;break}g=zC(e)|0;if((g|0)==0){i=0}else{h=g;break}return i|0}else{h=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[g>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;i=h;return i|0}function vA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0;d=i;i=i+248|0;e=d|0;f=d+16|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+56|0;l=d+72|0;m=d+80|0;n=d+112|0;o=d+128|0;p=d+144|0;q=d+160|0;r=d+168|0;s=d+184|0;t=d+200|0;u=d+216|0;v=d+232|0;uu(b)|0;w=b+56|0;x=c[w>>2]|0;y=(c[b+60>>2]|0)-x|0;if(y>>>0>4294967279>>>0){D5(0);return 0}if(y>>>0<11>>>0){A=y<<1&255;a[m]=A;B=m+1|0;C=A}else{A=y+16&-16;D=Lu(A)|0;c[m+8>>2]=D;E=A|1;c[m>>2]=E;c[m+4>>2]=y;B=D;C=E&255}LF(B|0,x|0,y)|0;a[B+y|0]=0;y=d+96|0;B=b+44|0;c[y>>2]=c[B>>2];c[y+4>>2]=c[B+4>>2];c[y+8>>2]=c[B+8>>2];x=b+20|0;E=(z=0,au(66,c[x>>2]|0)|0);L8:do{if(!z){D=(a[E]|0)==40?E+1|0:0;if((D|0)==0){F=c[x>>2]|0}else{A=b+48|0;G=c[A>>2]|0;H=c[x>>2]|0;L12:do{if(H>>>0<D>>>0){I=H;J=0;while(1){K=a[I]|0;if((K<<24>>24|0)==10){L=J+1|0}else if((K<<24>>24|0)==0){N=J;break L12}else{L=J}K=I+1|0;if(K>>>0<D>>>0){I=K;J=L}else{N=L;break}}}else{N=0}}while(0);c[A>>2]=N+G;J=E;I=0;while(1){K=J-1|0;if(K>>>0<H>>>0){break}if((a[K]|0)==10){break}else{J=K;I=I+1|0}}J=b+40|0;if((N|0)!=0){c[J>>2]=1}H=c[J>>2]|0;c[b+52>>2]=H+I;G=D;A=E;c[J>>2]=G-A+I+H;H=w;c[H>>2]=A;c[H+4>>2]=G;c[x>>2]=D;F=D}G=n;c[G>>2]=c[B>>2];c[G+4>>2]=c[B+4>>2];c[G+8>>2]=c[B+8>>2];z=0,au(168,b|0)|0;if(z){z=0;O=117;break}H=c[x>>2]|0;A=(z=0,au(66,H|0)|0);if(z){z=0;O=117;break}J=(a[A]|0)==41?A+1|0:0;if((J|0)!=0){K=b+48|0;P=c[K>>2]|0;Q=c[x>>2]|0;L32:do{if(Q>>>0<J>>>0){R=Q;S=0;while(1){T=a[R]|0;if((T<<24>>24|0)==10){U=S+1|0}else if((T<<24>>24|0)==0){V=S;break L32}else{U=S}T=R+1|0;if(T>>>0<J>>>0){R=T;S=U}else{V=U;break}}}else{V=0}}while(0);c[K>>2]=V+P;D=A;I=0;while(1){S=D-1|0;if(S>>>0<Q>>>0){break}if((a[S]|0)==10){break}else{D=S;I=I+1|0}}D=b+40|0;if((V|0)!=0){c[D>>2]=1}Q=c[D>>2]|0;c[b+52>>2]=Q+I;P=J;K=A;c[D>>2]=P-K+I+Q;Q=w;c[Q>>2]=K;c[Q+4>>2]=P;c[x>>2]=J}P=b|0;Q=c[P>>2]|0;K=(z=0,au(248,56)|0);if(z){z=0;O=117;break}D=K;c[l>>2]=D;K=Q+4|0;S=c[K>>2]|0;if((S|0)==(c[Q+8>>2]|0)){z=0;as(382,Q|0,l|0);if(z){z=0;O=117;break}W=c[l>>2]|0}else{if((S|0)==0){X=0}else{c[S>>2]=D;X=c[K>>2]|0}c[K>>2]=X+4;W=D}D=W;S=W;R=b+28|0;L56:do{if((a[R]&1)==0){T=o;c[T>>2]=c[R>>2];c[T+4>>2]=c[R+4>>2];c[T+8>>2]=c[R+8>>2];O=49}else{T=c[b+36>>2]|0;Y=c[b+32>>2]|0;do{if(Y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Y>>>0<11>>>0){a[o]=Y<<1;Z=o+1|0}else{_=Y+16&-16;$=(z=0,au(248,_|0)|0);if(z){z=0;break}c[o+8>>2]=$;c[o>>2]=_|1;c[o+4>>2]=Y;Z=$}LF(Z|0,T|0,Y)|0;a[Z+Y|0]=0;O=49;break L56}}while(0);Y=bT(-1,-1)|0;aa=Y;ab=M}}while(0);do{if((O|0)==49){J=p;c[J>>2]=c[G>>2];c[J+4>>2]=c[G+4>>2];c[J+8>>2]=c[G+8>>2];c[q>>2]=F;c[q+4>>2]=H;I=(z=0,aM(400,b|0,q|0)|0);do{if(!z){A=r;a[A]=0;a[r+1|0]=0;Y=k;c[Y>>2]=c[J>>2];c[Y+4>>2]=c[J+4>>2];c[Y+8>>2]=c[J+8>>2];z=0;aD(30,S|0,o|0,k|0,I|0,r|0,0);if(z){z=0;Y=bT(-1,-1)|0;T=Y;Y=M;if((a[A]&1)==0){ac=T;ad=Y;break}Lw(c[r+8>>2]|0);ac=T;ad=Y;break}if((a[A]&1)!=0){Lw(c[r+8>>2]|0)}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}A=c[P>>2]|0;Y=(z=0,au(248,56)|0);if(z){z=0;O=117;break L8}T=Y;c[j>>2]=T;Y=A+4|0;$=c[Y>>2]|0;if(($|0)==(c[A+8>>2]|0)){z=0;as(382,A|0,j|0);if(z){z=0;O=117;break L8}ae=c[j>>2]|0}else{if(($|0)==0){af=0}else{c[$>>2]=T;af=c[Y>>2]|0}c[Y>>2]=af+4;ae=T}T=ae;$=ae;L92:do{if((a[R]&1)==0){_=s;c[_>>2]=c[R>>2];c[_+4>>2]=c[R+4>>2];c[_+8>>2]=c[R+8>>2];O=72}else{_=c[b+36>>2]|0;ag=c[b+32>>2]|0;do{if(ag>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ag>>>0<11>>>0){a[s]=ag<<1;ah=s+1|0}else{ai=ag+16&-16;aj=(z=0,au(248,ai|0)|0);if(z){z=0;break}c[s+8>>2]=aj;c[s>>2]=ai|1;c[s+4>>2]=ag;ah=aj}LF(ah|0,_|0,ag)|0;a[ah+ag|0]=0;O=72;break L92}}while(0);ag=bT(-1,-1)|0;ak=ag;al=M}}while(0);do{if((O|0)==72){ag=h;c[ag>>2]=c[G>>2];c[ag+4>>2]=c[G+4>>2];c[ag+8>>2]=c[G+8>>2];z=0;aR(50,$|0,s|0,h|0);if(z){z=0;ag=bT(-1,-1)|0;_=ag;ag=M;if((a[s]&1)==0){ak=_;al=ag;break}Lw(c[s+8>>2]|0);ak=_;al=ag;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}ag=ae+36|0;_=ag;c[g>>2]=S;aj=ag+8|0;ai=aj;am=c[ai>>2]|0;if((am|0)==(c[ag+12>>2]|0)){z=0;as(156,ag+4|0,g|0);if(z){z=0;O=117;break L8}an=c[g>>2]|0}else{if((am|0)==0){ao=0}else{c[am>>2]=S;ao=c[ai>>2]|0}c[aj>>2]=ao+4;an=S}z=0;as(c[c[ag>>2]>>2]|0,_|0,an|0);if(z){z=0;O=117;break L8}_=c[P>>2]|0;ag=(z=0,au(248,56)|0);if(z){z=0;O=117;break L8}aj=ag;c[f>>2]=aj;ag=_+4|0;ai=c[ag>>2]|0;if((ai|0)==(c[_+8>>2]|0)){z=0;as(382,_|0,f|0);if(z){z=0;O=117;break L8}ap=c[f>>2]|0}else{if((ai|0)==0){at=0}else{c[ai>>2]=aj;at=c[ag>>2]|0}c[ag>>2]=at+4;ap=aj}aj=ap;ai=ap;L132:do{if((a[R]&1)==0){am=t;c[am>>2]=c[R>>2];c[am+4>>2]=c[R+4>>2];c[am+8>>2]=c[R+8>>2];O=99}else{am=c[b+36>>2]|0;av=c[b+32>>2]|0;do{if(av>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(av>>>0<11>>>0){a[t]=av<<1;aw=t+1|0}else{ax=av+16&-16;ay=(z=0,au(248,ax|0)|0);if(z){z=0;break}c[t+8>>2]=ay;c[t>>2]=ax|1;c[t+4>>2]=av;aw=ay}LF(aw|0,am|0,av)|0;a[aw+av|0]=0;O=99;break L132}}while(0);av=bT(-1,-1)|0;az=av;aA=M}}while(0);do{if((O|0)==99){av=u;c[av>>2]=c[y>>2];c[av+4>>2]=c[y+4>>2];c[av+8>>2]=c[y+8>>2];L147:do{if((C&1)==0){am=m;ay=v;c[ay>>2]=c[am>>2];c[ay+4>>2]=c[am+4>>2];c[ay+8>>2]=c[am+8>>2];O=109}else{am=c[m+8>>2]|0;ay=c[m+4>>2]|0;do{if(ay>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ay>>>0<11>>>0){a[v]=ay<<1;aB=v+1|0}else{ax=ay+16&-16;aC=(z=0,au(248,ax|0)|0);if(z){z=0;break}c[v+8>>2]=aC;c[v>>2]=ax|1;c[v+4>>2]=ay;aB=aC}LF(aB|0,am|0,ay)|0;a[aB+ay|0]=0;O=109;break L147}}while(0);ay=bT(-1,-1)|0;aE=ay;aF=M}}while(0);do{if((O|0)==109){ay=e;c[ay>>2]=c[av>>2];c[ay+4>>2]=c[av+4>>2];c[ay+8>>2]=c[av+8>>2];z=0;aq(10,ai|0,t|0,e|0,v|0,$|0);if(z){z=0;ay=bT(-1,-1)|0;am=ay;ay=M;if((a[v]&1)==0){aE=am;aF=ay;break}Lw(c[v+8>>2]|0);aE=am;aF=ay;break}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}if((C&1)==0){i=d;return ai|0}Lw(c[m+8>>2]|0);i=d;return ai|0}}while(0);if((a[t]&1)==0){az=aE;aA=aF;break}Lw(c[t+8>>2]|0);az=aE;aA=aF}}while(0);ai=c[_>>2]|0;av=c[ag>>2]|0;ay=ai;while(1){if((ay|0)==(av|0)){aG=av;break}if((c[ay>>2]|0)==(ap|0)){aG=ay;break}else{ay=ay+4|0}}ay=aG-ai>>2;_=ai+(ay+1<<2)|0;am=av-_|0;LG(ai+(ay<<2)|0,_|0,am|0)|0;_=ai+((am>>2)+ay<<2)|0;ay=c[ag>>2]|0;if((_|0)!=(ay|0)){c[ag>>2]=ay+(~((ay-4+(-_|0)|0)>>>2)<<2)}Lw(aj);aH=az;aI=aA;break L8}}while(0);$=c[A>>2]|0;_=c[Y>>2]|0;ay=$;while(1){if((ay|0)==(_|0)){aJ=_;break}if((c[ay>>2]|0)==(ae|0)){aJ=ay;break}else{ay=ay+4|0}}ay=aJ-$>>2;A=$+(ay+1<<2)|0;am=_-A|0;LG($+(ay<<2)|0,A|0,am|0)|0;A=$+((am>>2)+ay<<2)|0;ay=c[Y>>2]|0;if((A|0)!=(ay|0)){c[Y>>2]=ay+(~((ay-4+(-A|0)|0)>>>2)<<2)}Lw(T);aH=ak;aI=al;break L8}else{z=0;A=bT(-1,-1)|0;ac=A;ad=M}}while(0);if((a[o]&1)==0){aa=ac;ab=ad;break}Lw(c[o+8>>2]|0);aa=ac;ab=ad}}while(0);R=c[Q>>2]|0;P=c[K>>2]|0;S=R;while(1){if((S|0)==(P|0)){aK=P;break}if((c[S>>2]|0)==(W|0)){aK=S;break}else{S=S+4|0}}S=aK-R>>2;Q=R+(S+1<<2)|0;G=P-Q|0;LG(R+(S<<2)|0,Q|0,G|0)|0;Q=R+((G>>2)+S<<2)|0;S=c[K>>2]|0;if((Q|0)!=(S|0)){c[K>>2]=S+(~((S-4+(-Q|0)|0)>>>2)<<2)}Lw(D);aH=aa;aI=ab}else{z=0;O=117}}while(0);if((O|0)==117){O=bT(-1,-1)|0;aH=O;aI=M}if((C&1)==0){aL=aH;aN=0;aO=aL;aP=aI;bg(aO|0)}Lw(c[m+8>>2]|0);aL=aH;aN=0;aO=aL;aP=aI;bg(aO|0);return 0}function vB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;d=i;i=i+104|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;k=d+88|0;l=uF(b)|0;m=d+56|0;n=b+44|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];n=c[b>>2]|0;o=Lu(44)|0;c[h>>2]=o;p=n+4|0;q=c[p>>2]|0;if((q|0)==(c[n+8>>2]|0)){e4(n|0,h);r=c[h>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=o;s=c[p>>2]|0}c[p>>2]=s+4;r=o}o=r;s=r;q=b+28|0;L8:do{if((a[q]&1)==0){h=j;c[h>>2]=c[q>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];t=16}else{h=c[b+36>>2]|0;u=c[b+32>>2]|0;do{if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(u>>>0<11>>>0){a[j]=u<<1;v=j+1|0}else{w=u+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[j+8>>2]=x;c[j>>2]=w|1;c[j+4>>2]=u;v=x}LF(v|0,h|0,u)|0;a[v+u|0]=0;t=16;break L8}}while(0);u=bT(-1,-1)|0;y=M;A=u}}while(0);do{if((t|0)==16){v=k;c[v>>2]=c[m>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];q=(z=0,au(92,b|0)|0);do{if(!z){u=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];h=e;x=f;w=r;B=j;C=a[B]|0;D=(C&1)==0;if(D){c[h>>2]=c[B>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2]}else{B=c[j+8>>2]|0;E=c[j+4>>2]|0;if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=36;break}return 0}if(E>>>0<11>>>0){a[h]=E<<1;F=e+1|0}else{G=E+16&-16;H=(z=0,au(248,G|0)|0);if(z){z=0;t=36;break}c[e+8>>2]=H;c[e>>2]=G|1;c[e+4>>2]=E;F=H}LF(F|0,B|0,E)|0;a[F+E|0]=0}c[x>>2]=c[u>>2];c[x+4>>2]=c[u+4>>2];c[x+8>>2]=c[u+8>>2];z=0;aD(6,w|0,e|0,f|0,0,0,0);if(z){z=0;w=bT(-1,-1)|0;u=M;if((a[h]&1)==0){I=u;J=w;K=C;break}Lw(c[e+8>>2]|0);I=u;J=w;K=C;break}if((a[h]&1)!=0){Lw(c[e+8>>2]|0)}c[r>>2]=20248;c[r+36>>2]=l;c[r+40>>2]=q;c[r+32>>2]=4;if(D){i=d;return s|0}Lw(c[j+8>>2]|0);i=d;return s|0}else{z=0;t=36}}while(0);if((t|0)==36){q=bT(-1,-1)|0;I=M;J=q;K=a[j]|0}q=J;v=I;if((K&1)==0){y=v;A=q;break}Lw(c[j+8>>2]|0);y=v;A=q}}while(0);j=c[n>>2]|0;n=c[p>>2]|0;K=j;while(1){if((K|0)==(n|0)){L=n;break}if((c[K>>2]|0)==(r|0)){L=K;break}else{K=K+4|0}}K=L-j>>2;L=j+(K+1<<2)|0;r=n-L|0;LG(j+(K<<2)|0,L|0,r|0)|0;L=j+((r>>2)+K<<2)|0;K=c[p>>2]|0;if((L|0)==(K|0)){Lw(o);N=A;O=0;P=N;Q=y;bg(P|0)}c[p>>2]=K+(~((K-4+(-L|0)|0)>>>2)<<2);Lw(o);N=A;O=0;P=N;Q=y;bg(P|0);return 0}function vC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;d=i;i=i+104|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+72|0;k=d+88|0;uu(b)|0;l=c[b+56>>2]|0;m=(c[b+60>>2]|0)-l|0;if(m>>>0>4294967279>>>0){D5(0);return 0}if(m>>>0<11>>>0){n=m<<1&255;a[g]=n;o=g+1|0;p=n}else{n=m+16&-16;q=Lu(n)|0;c[g+8>>2]=q;r=n|1;c[g>>2]=r;c[g+4>>2]=m;o=q;p=r&255}LF(o|0,l|0,m)|0;a[o+m|0]=0;m=d+40|0;o=b+44|0;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];o=c[b>>2]|0;l=(z=0,au(248,56)|0);do{if(!z){r=l;c[f>>2]=r;q=o+4|0;n=c[q>>2]|0;if((n|0)==(c[o+8>>2]|0)){z=0;as(382,o|0,f|0);if(z){z=0;s=42;break}t=c[f>>2]|0}else{if((n|0)==0){u=0}else{c[n>>2]=r;u=c[q>>2]|0}c[q>>2]=u+4;t=r}r=t;n=t;v=b+28|0;L18:do{if((a[v]&1)==0){w=h;c[w>>2]=c[v>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];s=23}else{w=c[b+36>>2]|0;x=c[b+32>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[h]=x<<1;y=h+1|0}else{A=x+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[h+8>>2]=B;c[h>>2]=A|1;c[h+4>>2]=x;y=B}LF(y|0,w|0,x)|0;a[y+x|0]=0;s=23;break L18}}while(0);x=bT(-1,-1)|0;C=x;D=M}}while(0);do{if((s|0)==23){v=j;c[v>>2]=c[m>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];L33:do{if((p&1)==0){x=g;w=k;c[w>>2]=c[x>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];s=33}else{x=c[g+8>>2]|0;w=c[g+4>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[k]=w<<1;E=k+1|0}else{B=w+16&-16;A=(z=0,au(248,B|0)|0);if(z){z=0;break}c[k+8>>2]=A;c[k>>2]=B|1;c[k+4>>2]=w;E=A}LF(E|0,x|0,w)|0;a[E+w|0]=0;s=33;break L33}}while(0);w=bT(-1,-1)|0;F=w;G=M}}while(0);do{if((s|0)==33){w=(z=0,au(92,b|0)|0);do{if(!z){x=e;c[x>>2]=c[v>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];z=0;aq(10,n|0,h|0,e|0,k|0,w|0);if(z){z=0;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}if((p&1)==0){i=d;return n|0}Lw(c[g+8>>2]|0);i=d;return n|0}else{z=0}}while(0);w=bT(-1,-1)|0;x=w;w=M;if((a[k]&1)==0){F=x;G=w;break}Lw(c[k+8>>2]|0);F=x;G=w}}while(0);if((a[h]&1)==0){C=F;D=G;break}Lw(c[h+8>>2]|0);C=F;D=G}}while(0);n=c[o>>2]|0;v=c[q>>2]|0;w=n;while(1){if((w|0)==(v|0)){H=v;break}if((c[w>>2]|0)==(t|0)){H=w;break}else{w=w+4|0}}w=H-n>>2;x=n+(w+1<<2)|0;A=v-x|0;LG(n+(w<<2)|0,x|0,A|0)|0;x=n+((A>>2)+w<<2)|0;w=c[q>>2]|0;if((x|0)!=(w|0)){c[q>>2]=w+(~((w-4+(-x|0)|0)>>>2)<<2)}Lw(r);I=C;J=D}else{z=0;s=42}}while(0);if((s|0)==42){s=bT(-1,-1)|0;I=s;J=M}if((p&1)==0){K=I;L=0;N=K;O=J;bg(N|0)}Lw(c[g+8>>2]|0);K=I;L=0;N=K;O=J;bg(N|0);return 0}function vD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=(a[e]|0)==43?e+1|0:0;if((f|0)==0){g=0;return g|0}h=y$(f)|0;if((h|0)==0){g=0;return g|0}f=(zw(h)|0)!=0;i=f?0:h;if((i|0)==0){g=0;return g|0}h=b+48|0;f=c[h>>2]|0;j=c[d>>2]|0;L10:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L10}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=f+o;f=e;h=0;while(1){n=f-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{f=n;h=h+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+h;j=i;n=e;c[f>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function vE(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=h+32|0;LF(l|0,e|0,12)|0;e=j;m=k;n=b|0;o=d;if((a[o]&1)==0){c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){D5(0)}if(p>>>0<11>>>0){a[e]=p<<1;q=j+1|0}else{d=p+16&-16;r=Lu(d)|0;c[j+8>>2]=r;c[j>>2]=d|1;c[j+4>>2]=p;q=r}LF(q|0,o|0,p)|0;a[q+p|0]=0}c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];z=0;aD(6,n|0,j|0,k|0,0,0,0);if(!z){if((a[e]&1)==0){s=b|0;c[s>>2]=20928;t=b+36|0;c[t>>2]=f;u=b+40|0;c[u>>2]=g;i=h;return}Lw(c[j+8>>2]|0);s=b|0;c[s>>2]=20928;t=b+36|0;c[t>>2]=f;u=b+40|0;c[u>>2]=g;i=h;return}else{z=0;h=bT(-1,-1)|0;if((a[e]&1)==0){bg(h|0)}Lw(c[j+8>>2]|0);bg(h|0)}}function vF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=(a[e]|0)==45?e+1|0:0;if((f|0)==0){g=0;return g|0}h=y$(f)|0;if((h|0)==0){g=0;return g|0}f=(zw(h)|0)!=0;i=f?0:h;if((i|0)==0){g=0;return g|0}h=b+48|0;f=c[h>>2]|0;j=c[d>>2]|0;L10:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L10}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=f+n;f=e;h=0;while(1){o=f-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{f=o;h=h+1|0}}f=b+40|0;if((n|0)!=0){c[f>>2]=1}n=c[f>>2]|0;c[b+52>>2]=n+h;j=i;o=e;c[f>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=i;g=i;return g|0}function vG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zD(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zE(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y2(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ee=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0;d=i;i=i+344|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+56|0;l=d+64|0;m=d+72|0;n=d+88|0;o=d+96|0;p=d+104|0;q=d+120|0;r=d+128|0;s=d+136|0;t=d+152|0;u=d+160|0;v=d+168|0;w=d+184|0;x=d+192|0;y=d+200|0;A=d+216|0;B=d+224|0;C=d+232|0;D=d+248|0;E=d+256|0;F=d+272|0;G=d+336|0;H=G;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+12|0;i=i+7&-8;K=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+12|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+12|0;i=i+7&-8;T=i;i=i+12|0;i=i+7&-8;U=i;i=i+12|0;i=i+7&-8;V=i;i=i+12|0;i=i+7&-8;W=i;i=i+12|0;i=i+7&-8;X=i;i=i+12|0;i=i+7&-8;Y=i;i=i+12|0;i=i+7&-8;Z=i;i=i+12|0;i=i+7&-8;_=i;i=i+12|0;i=i+7&-8;$=i;i=i+12|0;i=i+7&-8;aa=i;i=i+12|0;i=i+7&-8;ab=i;i=i+12|0;i=i+7&-8;ac=b|0;ad=c[ac>>2]|0;ae=Lu(60)|0;c[D>>2]=ae;af=ad+4|0;ag=c[af>>2]|0;if((ag|0)==(c[ad+8>>2]|0)){e4(ad|0,D);ah=c[D>>2]|0}else{if((ag|0)==0){ai=0}else{c[ag>>2]=ae;ai=c[af>>2]|0}c[af>>2]=ai+4;ah=ae}ae=ah;ai=ah;ag=b+28|0;L8:do{if((a[ag]&1)==0){D=E;c[D>>2]=c[ag>>2];c[D+4>>2]=c[ag+4>>2];c[D+8>>2]=c[ag+8>>2];aj=16}else{D=c[b+36>>2]|0;ak=c[b+32>>2]|0;do{if(ak>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ak>>>0<11>>>0){a[E]=ak<<1;al=E+1|0}else{am=ak+16&-16;an=(z=0,au(248,am|0)|0);if(z){z=0;break}c[E+8>>2]=an;c[E>>2]=am|1;c[E+4>>2]=ak;al=an}LF(al|0,D|0,ak)|0;a[al+ak|0]=0;aj=16;break L8}}while(0);ak=bT(-1,-1)|0;ao=ak;ap=M}}while(0);do{if((aj|0)==16){al=b+44|0;ak=C;c[ak>>2]=c[al>>2];c[ak+4>>2]=c[al+4>>2];c[ak+8>>2]=c[al+8>>2];z=0;aD(2,ai|0,E|0,C|0,0,0,0);if(z){z=0;ak=bT(-1,-1)|0;D=ak;ak=M;if((a[E]&1)==0){ao=D;ap=ak;break}Lw(c[E+8>>2]|0);ao=D;ap=ak;break}if((a[E]&1)!=0){Lw(c[E+8>>2]|0)}ak=b+20|0;D=b+24|0;if((c[ak>>2]|0)>>>0>=(c[D>>2]|0)>>>0){i=d;return ai|0}an=aa+8|0;am=aa|0;at=aa+4|0;av=ab|0;aw=ab+4|0;ax=ab+8|0;ay=aa;az=ah+40|0;aA=az;aB=Z;aC=_;aE=b+56|0;aF=b+60|0;aG=$;aH=$+1|0;aI=f;aJ=az+8|0;aK=az+12|0;aL=az+4|0;aM=Z+8|0;aN=$+8|0;aO=$|0;aP=$+4|0;aQ=b+36|0;aS=b+32|0;aT=Z+1|0;aU=Z|0;aW=Z+4|0;aX=Y;aY=b+56|0;aZ=aY|0;a_=ah+56|0;a$=Y+8|0;a0=Y+1|0;a1=Y|0;a2=Y+4|0;a3=V;a4=W;a5=X;a6=X+1|0;a7=m;a8=V+8|0;a9=X+8|0;ba=X|0;bb=X+4|0;bc=V+1|0;bd=V|0;be=V+4|0;bf=S;bh=T;bi=U;bj=U+1|0;bk=p;bl=S+8|0;bm=U+8|0;bn=U|0;bo=U+4|0;bp=S+1|0;bq=S|0;br=S+4|0;bs=P;bt=Q;bu=R;bv=R+1|0;bw=s;bx=P+8|0;by=R+8|0;bz=R|0;bA=R+4|0;bB=P+1|0;bC=P|0;bD=P+4|0;bE=L;bF=N;bG=O;bH=O+1|0;bI=v;bJ=L+8|0;bK=O+8|0;bL=O|0;bM=O+4|0;bN=L+1|0;bO=L|0;bP=L+4|0;bQ=K;bR=K+8|0;bS=K+1|0;bU=K|0;bV=K+4|0;bW=I;bX=J;bY=F+28|0;bZ=F+4|0;b_=I+8|0;b$=F+8|0;b0=F+36|0;b1=I+1|0;b2=I|0;b3=I+4|0;b4=0;L33:while(1){do{if((vR(b)|0)==0){if((uu(b)|0)!=0){b5=c[ac>>2]|0;b6=Lu(52)|0;c[A>>2]=b6;b7=b5+4|0;b8=c[b7>>2]|0;if((b8|0)==(c[b5+8>>2]|0)){e4(b5|0,A);b9=c[A>>2]|0}else{if((b8|0)==0){ca=0}else{c[b8>>2]=b6;ca=c[b7>>2]|0}c[b7>>2]=ca+4;b9=b6}cb=b9;if((a[ag]&1)==0){c[bQ>>2]=c[ag>>2];c[bQ+4>>2]=c[ag+4>>2];c[bQ+8>>2]=c[ag+8>>2]}else{b6=c[aQ>>2]|0;b8=c[aS>>2]|0;if(b8>>>0>4294967279>>>0){aj=73;break L33}if(b8>>>0<11>>>0){a[bQ]=b8<<1;cc=bS}else{cd=b8+16&-16;ce=(z=0,au(248,cd|0)|0);if(z){z=0;aj=90;break L33}c[bR>>2]=ce;c[bU>>2]=cd|1;c[bV>>2]=b8;cc=ce}LF(cc|0,b6|0,b8)|0;a[cc+b8|0]=0}b8=y;c[b8>>2]=c[al>>2];c[b8+4>>2]=c[al+4>>2];c[b8+8>>2]=c[al+8>>2];z=0;aq(14,b9|0,K|0,y|0,aY|0,0);if(z){z=0;cf=1;aj=93;break L33}b8=b9;c[x>>2]=b8;b6=c[aJ>>2]|0;ce=b6;if((b6|0)==(c[aK>>2]|0)){z=0;as(376,aL|0,x|0);if(z){z=0;cf=0;aj=93;break L33}cg=c[x>>2]|0}else{if((b6|0)==0){ch=0}else{c[ce>>2]=b8;ch=c[aJ>>2]|0}c[aJ>>2]=ch+4;cg=b8}z=0;as(c[c[az>>2]>>2]|0,aA|0,cg|0);if(z){z=0;cf=0;aj=93;break L33}if((a[bQ]&1)==0){break}Lw(c[bR>>2]|0);break}if((vN(b)|0)!=0){ci=c[ac>>2]|0;b8=Lu(52)|0;c[w>>2]=b8;cj=ci+4|0;ce=c[cj>>2]|0;if((ce|0)==(c[ci+8>>2]|0)){e4(ci|0,w);ck=c[w>>2]|0}else{if((ce|0)==0){cl=0}else{c[ce>>2]=b8;cl=c[cj>>2]|0}c[cj>>2]=cl+4;ck=b8}cm=ck;b8=ck;if((a[ag]&1)==0){c[bE>>2]=c[ag>>2];c[bE+4>>2]=c[ag+4>>2];c[bE+8>>2]=c[ag+8>>2]}else{ce=c[aQ>>2]|0;b6=c[aS>>2]|0;if(b6>>>0>4294967279>>>0){aj=111;break L33}if(b6>>>0<11>>>0){a[bE]=b6<<1;cn=bN}else{cd=b6+16&-16;co=(z=0,au(248,cd|0)|0);if(z){z=0;aj=137;break L33}c[bJ>>2]=co;c[bO>>2]=cd|1;c[bP>>2]=b6;cn=co}LF(cn|0,ce|0,b6)|0;a[cn+b6|0]=0}c[bF>>2]=c[al>>2];c[bF+4>>2]=c[al+4>>2];c[bF+8>>2]=c[al+8>>2];b6=c[aE>>2]|0;ce=(c[aF>>2]|0)-b6|0;if(ce>>>0>4294967279>>>0){aj=119;break L33}if(ce>>>0<11>>>0){a[bG]=ce<<1;cp=bH}else{co=ce+16&-16;cd=(z=0,au(248,co|0)|0);if(z){z=0;aj=140;break L33}c[bK>>2]=cd;c[bL>>2]=co|1;c[bM>>2]=ce;cp=cd}LF(cp|0,b6|0,ce)|0;a[cp+ce|0]=0;c[bI>>2]=c[bF>>2];c[bI+4>>2]=c[bF+4>>2];c[bI+8>>2]=c[bF+8>>2];z=0;aq(34,b8|0,L|0,v|0,1,O|0);if(z){z=0;cq=1;aj=143;break L33}b8=ck;c[u>>2]=b8;ce=c[aJ>>2]|0;b6=ce;if((ce|0)==(c[aK>>2]|0)){z=0;as(376,aL|0,u|0);if(z){z=0;cq=0;aj=143;break L33}cr=c[u>>2]|0}else{if((ce|0)==0){cs=0}else{c[b6>>2]=b8;cs=c[aJ>>2]|0}c[aJ>>2]=cs+4;cr=b8}z=0;as(c[c[az>>2]>>2]|0,aA|0,cr|0);if(z){z=0;cq=0;aj=143;break L33}if((a[bG]&1)!=0){Lw(c[bK>>2]|0)}if((a[bE]&1)==0){break}Lw(c[bJ>>2]|0);break}if((vO(b)|0)!=0){ct=c[ac>>2]|0;b8=Lu(52)|0;c[t>>2]=b8;cu=ct+4|0;b6=c[cu>>2]|0;if((b6|0)==(c[ct+8>>2]|0)){e4(ct|0,t);cv=c[t>>2]|0}else{if((b6|0)==0){cw=0}else{c[b6>>2]=b8;cw=c[cu>>2]|0}c[cu>>2]=cw+4;cv=b8}cx=cv;b8=cv;if((a[ag]&1)==0){c[bs>>2]=c[ag>>2];c[bs+4>>2]=c[ag+4>>2];c[bs+8>>2]=c[ag+8>>2]}else{b6=c[aQ>>2]|0;ce=c[aS>>2]|0;if(ce>>>0>4294967279>>>0){aj=163;break L33}if(ce>>>0<11>>>0){a[bs]=ce<<1;cy=bB}else{cd=ce+16&-16;co=(z=0,au(248,cd|0)|0);if(z){z=0;aj=189;break L33}c[bx>>2]=co;c[bC>>2]=cd|1;c[bD>>2]=ce;cy=co}LF(cy|0,b6|0,ce)|0;a[cy+ce|0]=0}c[bt>>2]=c[al>>2];c[bt+4>>2]=c[al+4>>2];c[bt+8>>2]=c[al+8>>2];ce=c[aE>>2]|0;b6=(c[aF>>2]|0)-ce|0;if(b6>>>0>4294967279>>>0){aj=171;break L33}if(b6>>>0<11>>>0){a[bu]=b6<<1;cz=bv}else{co=b6+16&-16;cd=(z=0,au(248,co|0)|0);if(z){z=0;aj=192;break L33}c[by>>2]=cd;c[bz>>2]=co|1;c[bA>>2]=b6;cz=cd}LF(cz|0,ce|0,b6)|0;a[cz+b6|0]=0;c[bw>>2]=c[bt>>2];c[bw+4>>2]=c[bt+4>>2];c[bw+8>>2]=c[bt+8>>2];z=0;aq(34,b8|0,P|0,s|0,2,R|0);if(z){z=0;cA=1;aj=195;break L33}b8=cv;c[r>>2]=b8;b6=c[aJ>>2]|0;ce=b6;if((b6|0)==(c[aK>>2]|0)){z=0;as(376,aL|0,r|0);if(z){z=0;cA=0;aj=195;break L33}cC=c[r>>2]|0}else{if((b6|0)==0){cD=0}else{c[ce>>2]=b8;cD=c[aJ>>2]|0}c[aJ>>2]=cD+4;cC=b8}z=0;as(c[c[az>>2]>>2]|0,aA|0,cC|0);if(z){z=0;cA=0;aj=195;break L33}if((a[bu]&1)!=0){Lw(c[by>>2]|0)}if((a[bs]&1)==0){break}Lw(c[bx>>2]|0);break}if((uT(b)|0)!=0){cE=c[ac>>2]|0;b8=Lu(52)|0;c[q>>2]=b8;cF=cE+4|0;ce=c[cF>>2]|0;if((ce|0)==(c[cE+8>>2]|0)){e4(cE|0,q);cG=c[q>>2]|0}else{if((ce|0)==0){cH=0}else{c[ce>>2]=b8;cH=c[cF>>2]|0}c[cF>>2]=cH+4;cG=b8}cI=cG;b8=cG;if((a[ag]&1)==0){c[bf>>2]=c[ag>>2];c[bf+4>>2]=c[ag+4>>2];c[bf+8>>2]=c[ag+8>>2]}else{ce=c[aQ>>2]|0;b6=c[aS>>2]|0;if(b6>>>0>4294967279>>>0){aj=215;break L33}if(b6>>>0<11>>>0){a[bf]=b6<<1;cJ=bp}else{cd=b6+16&-16;co=(z=0,au(248,cd|0)|0);if(z){z=0;aj=241;break L33}c[bl>>2]=co;c[bq>>2]=cd|1;c[br>>2]=b6;cJ=co}LF(cJ|0,ce|0,b6)|0;a[cJ+b6|0]=0}c[bh>>2]=c[al>>2];c[bh+4>>2]=c[al+4>>2];c[bh+8>>2]=c[al+8>>2];b6=c[aE>>2]|0;ce=(c[aF>>2]|0)-b6|0;if(ce>>>0>4294967279>>>0){aj=223;break L33}if(ce>>>0<11>>>0){a[bi]=ce<<1;cK=bj}else{co=ce+16&-16;cd=(z=0,au(248,co|0)|0);if(z){z=0;aj=244;break L33}c[bm>>2]=cd;c[bn>>2]=co|1;c[bo>>2]=ce;cK=cd}LF(cK|0,b6|0,ce)|0;a[cK+ce|0]=0;c[bk>>2]=c[bh>>2];c[bk+4>>2]=c[bh+4>>2];c[bk+8>>2]=c[bh+8>>2];z=0;aq(34,b8|0,S|0,p|0,0,U|0);if(z){z=0;cL=1;aj=247;break L33}b8=cG;c[o>>2]=b8;ce=c[aJ>>2]|0;b6=ce;if((ce|0)==(c[aK>>2]|0)){z=0;as(376,aL|0,o|0);if(z){z=0;cL=0;aj=247;break L33}cM=c[o>>2]|0}else{if((ce|0)==0){cN=0}else{c[b6>>2]=b8;cN=c[aJ>>2]|0}c[aJ>>2]=cN+4;cM=b8}z=0;as(c[c[az>>2]>>2]|0,aA|0,cM|0);if(z){z=0;cL=0;aj=247;break L33}if((a[bi]&1)!=0){Lw(c[bm>>2]|0)}if((a[bf]&1)==0){break}Lw(c[bl>>2]|0);break}if((vP(b)|0)!=0){cO=c[ac>>2]|0;b8=Lu(52)|0;c[n>>2]=b8;cP=cO+4|0;b6=c[cP>>2]|0;if((b6|0)==(c[cO+8>>2]|0)){e4(cO|0,n);cQ=c[n>>2]|0}else{if((b6|0)==0){cR=0}else{c[b6>>2]=b8;cR=c[cP>>2]|0}c[cP>>2]=cR+4;cQ=b8}cS=cQ;b8=cQ;if((a[ag]&1)==0){c[a3>>2]=c[ag>>2];c[a3+4>>2]=c[ag+4>>2];c[a3+8>>2]=c[ag+8>>2]}else{b6=c[aQ>>2]|0;ce=c[aS>>2]|0;if(ce>>>0>4294967279>>>0){aj=267;break L33}if(ce>>>0<11>>>0){a[a3]=ce<<1;cT=bc}else{cd=ce+16&-16;co=(z=0,au(248,cd|0)|0);if(z){z=0;aj=293;break L33}c[a8>>2]=co;c[bd>>2]=cd|1;c[be>>2]=ce;cT=co}LF(cT|0,b6|0,ce)|0;a[cT+ce|0]=0}c[a4>>2]=c[al>>2];c[a4+4>>2]=c[al+4>>2];c[a4+8>>2]=c[al+8>>2];ce=c[aE>>2]|0;b6=(c[aF>>2]|0)-ce|0;if(b6>>>0>4294967279>>>0){aj=275;break L33}if(b6>>>0<11>>>0){a[a5]=b6<<1;cU=a6}else{co=b6+16&-16;cd=(z=0,au(248,co|0)|0);if(z){z=0;aj=296;break L33}c[a9>>2]=cd;c[ba>>2]=co|1;c[bb>>2]=b6;cU=cd}LF(cU|0,ce|0,b6)|0;a[cU+b6|0]=0;c[a7>>2]=c[a4>>2];c[a7+4>>2]=c[a4+4>>2];c[a7+8>>2]=c[a4+8>>2];z=0;aq(34,b8|0,V|0,m|0,3,X|0);if(z){z=0;cV=1;aj=299;break L33}b8=cQ;c[l>>2]=b8;b6=c[aJ>>2]|0;ce=b6;if((b6|0)==(c[aK>>2]|0)){z=0;as(376,aL|0,l|0);if(z){z=0;cV=0;aj=299;break L33}cW=c[l>>2]|0}else{if((b6|0)==0){cX=0}else{c[ce>>2]=b8;cX=c[aJ>>2]|0}c[aJ>>2]=cX+4;cW=b8}z=0;as(c[c[az>>2]>>2]|0,aA|0,cW|0);if(z){z=0;cV=0;aj=299;break L33}if((a[a5]&1)!=0){Lw(c[a9>>2]|0)}if((a[a3]&1)==0){break}Lw(c[a8>>2]|0);break}if((ul(b)|0)!=0){cY=c[ac>>2]|0;b8=Lu(52)|0;c[k>>2]=b8;cZ=cY+4|0;ce=c[cZ>>2]|0;if((ce|0)==(c[cY+8>>2]|0)){e4(cY|0,k);c_=c[k>>2]|0}else{if((ce|0)==0){c$=0}else{c[ce>>2]=b8;c$=c[cZ>>2]|0}c[cZ>>2]=c$+4;c_=b8}c0=c_;if((a[ag]&1)==0){c[aX>>2]=c[ag>>2];c[aX+4>>2]=c[ag+4>>2];c[aX+8>>2]=c[ag+8>>2]}else{b8=c[aQ>>2]|0;ce=c[aS>>2]|0;if(ce>>>0>4294967279>>>0){aj=319;break L33}if(ce>>>0<11>>>0){a[aX]=ce<<1;c1=a0}else{b6=ce+16&-16;cd=(z=0,au(248,b6|0)|0);if(z){z=0;aj=338;break L33}c[a$>>2]=cd;c[a1>>2]=b6|1;c[a2>>2]=ce;c1=cd}LF(c1|0,b8|0,ce)|0;a[c1+ce|0]=0}ce=j;c[ce>>2]=c[al>>2];c[ce+4>>2]=c[al+4>>2];c[ce+8>>2]=c[al+8>>2];z=0;aq(14,c_|0,Y|0,j|0,aY|0,0);if(z){z=0;c2=1;aj=341;break L33}ce=c_;c[h>>2]=ce;b8=c[aJ>>2]|0;cd=b8;if((b8|0)==(c[aK>>2]|0)){z=0;as(376,aL|0,h|0);if(z){z=0;c2=0;aj=341;break L33}c3=c[h>>2]|0}else{if((b8|0)==0){c4=0}else{c[cd>>2]=ce;c4=c[aJ>>2]|0}c[aJ>>2]=c4+4;c3=ce}z=0;as(c[c[az>>2]>>2]|0,aA|0,c3|0);if(z){z=0;c2=0;aj=341;break L33}if((a[aX]&1)!=0){Lw(c[a$>>2]|0)}if((b4|0)!=0){break}a[a_]=a[c[aZ>>2]|0]|0;break}if((uy(b)|0)==0){ce=Lu(48)|0;c[an>>2]=ce;c[am>>2]=49;c[at>>2]=32;LF(ce|0,4408,32)|0;a[ce+32|0]=0;c[av>>2]=0;c[aw>>2]=0;c[ax>>2]=0;z=0;aR(492,b|0,aa|0,ab|0);if(z){z=0;aj=405;break L33}if((a[ay]&1)==0){break}Lw(c[an>>2]|0);break}c5=c[ac>>2]|0;ce=Lu(48)|0;c[g>>2]=ce;c6=c5+4|0;cd=c[c6>>2]|0;if((cd|0)==(c[c5+8>>2]|0)){e4(c5|0,g);c7=c[g>>2]|0}else{if((cd|0)==0){c8=0}else{c[cd>>2]=ce;c8=c[c6>>2]|0}c[c6>>2]=c8+4;c7=ce}c9=c7;ce=c7;if((a[ag]&1)==0){c[aB>>2]=c[ag>>2];c[aB+4>>2]=c[ag+4>>2];c[aB+8>>2]=c[ag+8>>2]}else{cd=c[aQ>>2]|0;b8=c[aS>>2]|0;if(b8>>>0>4294967279>>>0){aj=359;break L33}if(b8>>>0<11>>>0){a[aB]=b8<<1;da=aT}else{b6=b8+16&-16;co=(z=0,au(248,b6|0)|0);if(z){z=0;aj=385;break L33}c[aM>>2]=co;c[aU>>2]=b6|1;c[aW>>2]=b8;da=co}LF(da|0,cd|0,b8)|0;a[da+b8|0]=0}c[aC>>2]=c[al>>2];c[aC+4>>2]=c[al+4>>2];c[aC+8>>2]=c[al+8>>2];b8=c[aE>>2]|0;cd=(c[aF>>2]|0)-b8|0;if(cd>>>0>4294967279>>>0){aj=367;break L33}if(cd>>>0<11>>>0){a[aG]=cd<<1;db=aH}else{co=cd+16&-16;b6=(z=0,au(248,co|0)|0);if(z){z=0;aj=388;break L33}c[aN>>2]=b6;c[aO>>2]=co|1;c[aP>>2]=cd;db=b6}LF(db|0,b8|0,cd)|0;a[db+cd|0]=0;c[aI>>2]=c[aC>>2];c[aI+4>>2]=c[aC+4>>2];c[aI+8>>2]=c[aC+8>>2];z=0;aV(2,ce|0,Z|0,f|0,$|0);if(z){z=0;dc=1;aj=391;break L33}ce=c7;c[e>>2]=ce;cd=c[aJ>>2]|0;b8=cd;if((cd|0)==(c[aK>>2]|0)){z=0;as(376,aL|0,e|0);if(z){z=0;dc=0;aj=391;break L33}dd=c[e>>2]|0}else{if((cd|0)==0){de=0}else{c[b8>>2]=ce;de=c[aJ>>2]|0}c[aJ>>2]=de+4;dd=ce}z=0;as(c[c[az>>2]>>2]|0,aA|0,dd|0);if(z){z=0;dc=0;aj=391;break L33}if((a[aG]&1)!=0){Lw(c[aN>>2]|0)}if((a[aB]&1)==0){break}Lw(c[aM>>2]|0)}else{ce=(c[aF>>2]|0)-1|0;c[G>>2]=(c[aE>>2]|0)+2;c[G+4>>2]=ce;ce=c[ac>>2]|0;if((a[ag]&1)==0){c[bW>>2]=c[ag>>2];c[bW+4>>2]=c[ag+4>>2];c[bW+8>>2]=c[ag+8>>2]}else{b8=c[aQ>>2]|0;cd=c[aS>>2]|0;if(cd>>>0>4294967279>>>0){aj=25;break L33}if(cd>>>0<11>>>0){a[bW]=cd<<1;df=b1}else{b6=cd+16&-16;co=Lu(b6)|0;c[b_>>2]=co;c[b2>>2]=b6|1;c[b3>>2]=cd;df=co}LF(df|0,b8|0,cd)|0;a[df+cd|0]=0}c[bX>>2]=c[al>>2];c[bX+4>>2]=c[al+4>>2];c[bX+8>>2]=c[al+8>>2];z=0;aq(16,F|0,H|0,ce|0,I|0,J|0);if(z){z=0;aj=55;break L33}ce=(z=0,au(168,F|0)|0);if(z){z=0;aj=56;break L33}if((a[bY]&1)!=0){Lw(c[b0>>2]|0)}cd=c[bZ>>2]|0;b8=cd;if((cd|0)!=0){co=c[b$>>2]|0;if((cd|0)!=(co|0)){c[b$>>2]=co+(~((co-4+(-b8|0)|0)>>>2)<<2)}Lw(cd)}if((a[bW]&1)!=0){Lw(c[b_>>2]|0)}a[ce+29|0]=1;c[B>>2]=ce;cd=c[aJ>>2]|0;b8=cd;if((cd|0)==(c[aK>>2]|0)){fq(aL,B);dg=c[B>>2]|0}else{if((cd|0)==0){dh=0}else{c[b8>>2]=ce;dh=c[aJ>>2]|0}c[aJ>>2]=dh+4;dg=ce}cB[c[c[az>>2]>>2]&1023](aA,dg)}}while(0);if((c[ak>>2]|0)>>>0<(c[D>>2]|0)>>>0){b4=b4+1|0}else{aj=410;break}}do{if((aj|0)==405){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[ay]&1)==0){di=D;dj=b4;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}Lw(c[an>>2]|0);di=D;dj=b4;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==73){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dp=M;dq=b4;aj=92;break}}else if((aj|0)==319){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dr=M;ds=b4;aj=340;break}}else if((aj|0)==275){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dt=M;du=b4;aj=298;break}}else if((aj|0)==296){b4=bT(-1,-1)|0;dt=M;du=b4;aj=298}else if((aj|0)==299){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[a5]&1)==0){dv=cV;dw=D;dx=b4;aj=301;break}Lw(c[a9>>2]|0);dv=cV;dw=D;dx=b4;aj=301}else if((aj|0)==189){b4=bT(-1,-1)|0;dy=M;dz=b4;aj=191}else if((aj|0)==163){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dy=M;dz=b4;aj=191;break}}else if((aj|0)==119){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dA=M;dB=b4;aj=142;break}}else if((aj|0)==215){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dC=M;dD=b4;aj=243;break}}else if((aj|0)==143){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[bG]&1)==0){dE=cq;dF=D;dG=b4;aj=145;break}Lw(c[bK>>2]|0);dE=cq;dF=D;dG=b4;aj=145}else if((aj|0)==137){b4=bT(-1,-1)|0;dH=M;dI=b4;aj=139}else if((aj|0)==93){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[bQ]&1)==0){if(cf){dJ=b4;dK=D;aj=96;break}else{di=D;dj=b4}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else{Lw(c[bR>>2]|0);if(cf){dJ=b4;dK=D;aj=96;break}else{di=D;dj=b4}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}else if((aj|0)==267){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dL=M;dM=b4;aj=295;break}}else if((aj|0)==55){b4=bT(-1,-1)|0;dN=b4;dO=M;aj=62}else if((aj|0)==90){b4=bT(-1,-1)|0;dp=M;dq=b4;aj=92}else if((aj|0)==171){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dP=M;dQ=b4;aj=194;break}}else if((aj|0)==140){b4=bT(-1,-1)|0;dA=M;dB=b4;aj=142}else if((aj|0)==247){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[bi]&1)==0){dR=cL;dS=D;dT=b4;aj=249;break}Lw(c[bm>>2]|0);dR=cL;dS=D;dT=b4;aj=249}else if((aj|0)==338){b4=bT(-1,-1)|0;dr=M;ds=b4;aj=340}else if((aj|0)==341){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[aX]&1)==0){if(c2){dU=b4;dV=D;aj=344;break}else{di=D;dj=b4}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else{Lw(c[a$>>2]|0);if(c2){dU=b4;dV=D;aj=344;break}else{di=D;dj=b4}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}else if((aj|0)==192){b4=bT(-1,-1)|0;dP=M;dQ=b4;aj=194}else if((aj|0)==293){b4=bT(-1,-1)|0;dL=M;dM=b4;aj=295}else if((aj|0)==385){b4=bT(-1,-1)|0;dW=M;dX=b4;aj=387}else if((aj|0)==388){b4=bT(-1,-1)|0;dY=M;dZ=b4;aj=390}else if((aj|0)==391){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[aG]&1)==0){d_=dc;d$=D;d0=b4;aj=393;break}Lw(c[aN>>2]|0);d_=dc;d$=D;d0=b4;aj=393}else if((aj|0)==111){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dH=M;dI=b4;aj=139;break}}else if((aj|0)==25){D5(0);return 0}else if((aj|0)==56){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[bY]&1)!=0){Lw(c[b0>>2]|0)}ak=c[bZ>>2]|0;if((ak|0)==0){dN=D;dO=b4;aj=62;break}aA=c[b$>>2]|0;if((ak|0)!=(aA|0)){c[b$>>2]=aA+(~((aA-4+(-ak|0)|0)>>>2)<<2)}Lw(ak);dN=D;dO=b4;aj=62}else if((aj|0)==359){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dW=M;dX=b4;aj=387;break}}else if((aj|0)==367){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;dY=M;dZ=b4;aj=390;break}}else if((aj|0)==410){i=d;return ai|0}else if((aj|0)==195){b4=bT(-1,-1)|0;D=b4;b4=M;if((a[bu]&1)==0){d1=cA;d2=D;d3=b4;aj=197;break}Lw(c[by>>2]|0);d1=cA;d2=D;d3=b4;aj=197}else if((aj|0)==241){b4=bT(-1,-1)|0;dC=M;dD=b4;aj=243}else if((aj|0)==244){b4=bT(-1,-1)|0;d4=M;d5=b4;aj=246}else if((aj|0)==223){z=0;ar(86,0);if(!z){return 0}else{z=0;b4=bT(-1,-1)|0;d4=M;d5=b4;aj=246;break}}}while(0);if((aj|0)==295){d6=dL;d7=dM;aj=304}else if((aj|0)==298){dv=1;dw=du;dx=dt;aj=301}else if((aj|0)==142){dE=1;dF=dB;dG=dA;aj=145}else if((aj|0)==92){dJ=dp;dK=dq;aj=96}else if((aj|0)==139){d8=dH;d9=dI;aj=148}else if((aj|0)==246){dR=1;dS=d5;dT=d4;aj=249}else if((aj|0)==340){dU=dr;dV=ds;aj=344}else if((aj|0)==191){ea=dy;eb=dz;aj=200}else if((aj|0)==194){d1=1;d2=dQ;d3=dP;aj=197}else if((aj|0)==62){if((a[bW]&1)==0){di=dN;dj=dO;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}Lw(c[b_>>2]|0);di=dN;dj=dO;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==387){ec=dW;ed=dX;aj=396}else if((aj|0)==390){d_=1;d$=dZ;d0=dY;aj=393}else if((aj|0)==243){ee=dC;ef=dD;aj=252}do{if((aj|0)==197){if((a[bs]&1)==0){if(d1){ea=d3;eb=d2;aj=200;break}else{di=d2;dj=d3}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else{Lw(c[bx>>2]|0);if(d1){ea=d3;eb=d2;aj=200;break}else{di=d2;dj=d3}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}else if((aj|0)==145){if((a[bE]&1)==0){if(dE){d8=dG;d9=dF;aj=148;break}else{di=dF;dj=dG}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else{Lw(c[bJ>>2]|0);if(dE){d8=dG;d9=dF;aj=148;break}else{di=dF;dj=dG}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}else if((aj|0)==249){if((a[bf]&1)==0){if(dR){ee=dT;ef=dS;aj=252;break}else{di=dS;dj=dT}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else{Lw(c[bl>>2]|0);if(dR){ee=dT;ef=dS;aj=252;break}else{di=dS;dj=dT}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}else if((aj|0)==344){by=c[cY>>2]|0;bu=c[cZ>>2]|0;b$=by;while(1){if((b$|0)==(bu|0)){eg=bu;break}if((c[b$>>2]|0)==(c_|0)){eg=b$;break}else{b$=b$+4|0}}b$=eg-by>>2;bZ=by+(b$+1<<2)|0;b0=bu-bZ|0;LG(by+(b$<<2)|0,bZ|0,b0|0)|0;bZ=by+((b0>>2)+b$<<2)|0;b$=c[cZ>>2]|0;if((bZ|0)!=(b$|0)){c[cZ>>2]=b$+(~((b$-4+(-bZ|0)|0)>>>2)<<2)}Lw(c0);di=dV;dj=dU;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==96){bZ=c[b5>>2]|0;b$=c[b7>>2]|0;b0=bZ;while(1){if((b0|0)==(b$|0)){eh=b$;break}if((c[b0>>2]|0)==(b9|0)){eh=b0;break}else{b0=b0+4|0}}b0=eh-bZ>>2;by=bZ+(b0+1<<2)|0;bu=b$-by|0;LG(bZ+(b0<<2)|0,by|0,bu|0)|0;by=bZ+((bu>>2)+b0<<2)|0;b0=c[b7>>2]|0;if((by|0)!=(b0|0)){c[b7>>2]=b0+(~((b0-4+(-by|0)|0)>>>2)<<2)}Lw(cb);di=dK;dj=dJ;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==301){if((a[a3]&1)==0){if(dv){d6=dx;d7=dw;aj=304;break}else{di=dw;dj=dx}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else{Lw(c[a8>>2]|0);if(dv){d6=dx;d7=dw;aj=304;break}else{di=dw;dj=dx}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}else if((aj|0)==393){if((a[aB]&1)==0){if(d_){ec=d0;ed=d$;aj=396;break}else{di=d$;dj=d0}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else{Lw(c[aM>>2]|0);if(d_){ec=d0;ed=d$;aj=396;break}else{di=d$;dj=d0}dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}}while(0);if((aj|0)==200){aM=c[ct>>2]|0;aB=c[cu>>2]|0;a8=aM;while(1){if((a8|0)==(aB|0)){ei=aB;break}if((c[a8>>2]|0)==(cv|0)){ei=a8;break}else{a8=a8+4|0}}a8=ei-aM>>2;a3=aM+(a8+1<<2)|0;bl=aB-a3|0;LG(aM+(a8<<2)|0,a3|0,bl|0)|0;a3=aM+((bl>>2)+a8<<2)|0;a8=c[cu>>2]|0;if((a3|0)!=(a8|0)){c[cu>>2]=a8+(~((a8-4+(-a3|0)|0)>>>2)<<2)}Lw(cx);di=eb;dj=ea;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==148){a3=c[ci>>2]|0;a8=c[cj>>2]|0;bl=a3;while(1){if((bl|0)==(a8|0)){ej=a8;break}if((c[bl>>2]|0)==(ck|0)){ej=bl;break}else{bl=bl+4|0}}bl=ej-a3>>2;aM=a3+(bl+1<<2)|0;aB=a8-aM|0;LG(a3+(bl<<2)|0,aM|0,aB|0)|0;aM=a3+((aB>>2)+bl<<2)|0;bl=c[cj>>2]|0;if((aM|0)!=(bl|0)){c[cj>>2]=bl+(~((bl-4+(-aM|0)|0)>>>2)<<2)}Lw(cm);di=d9;dj=d8;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==252){aM=c[cE>>2]|0;bl=c[cF>>2]|0;aB=aM;while(1){if((aB|0)==(bl|0)){ek=bl;break}if((c[aB>>2]|0)==(cG|0)){ek=aB;break}else{aB=aB+4|0}}aB=ek-aM>>2;a3=aM+(aB+1<<2)|0;a8=bl-a3|0;LG(aM+(aB<<2)|0,a3|0,a8|0)|0;a3=aM+((a8>>2)+aB<<2)|0;aB=c[cF>>2]|0;if((a3|0)!=(aB|0)){c[cF>>2]=aB+(~((aB-4+(-a3|0)|0)>>>2)<<2)}Lw(cI);di=ef;dj=ee;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==304){a3=c[cO>>2]|0;aB=c[cP>>2]|0;a8=a3;while(1){if((a8|0)==(aB|0)){el=aB;break}if((c[a8>>2]|0)==(cQ|0)){el=a8;break}else{a8=a8+4|0}}a8=el-a3>>2;aM=a3+(a8+1<<2)|0;bl=aB-aM|0;LG(a3+(a8<<2)|0,aM|0,bl|0)|0;aM=a3+((bl>>2)+a8<<2)|0;a8=c[cP>>2]|0;if((aM|0)!=(a8|0)){c[cP>>2]=a8+(~((a8-4+(-aM|0)|0)>>>2)<<2)}Lw(cS);di=d7;dj=d6;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}else if((aj|0)==396){aM=c[c5>>2]|0;a8=c[c6>>2]|0;bl=aM;while(1){if((bl|0)==(a8|0)){em=a8;break}if((c[bl>>2]|0)==(c7|0)){em=bl;break}else{bl=bl+4|0}}bl=em-aM>>2;a3=aM+(bl+1<<2)|0;aB=a8-a3|0;LG(aM+(bl<<2)|0,a3|0,aB|0)|0;a3=aM+((aB>>2)+bl<<2)|0;bl=c[c6>>2]|0;if((a3|0)!=(bl|0)){c[c6>>2]=bl+(~((bl-4+(-a3|0)|0)>>>2)<<2)}Lw(c9);di=ed;dj=ec;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0)}}}while(0);ec=c[ad>>2]|0;ad=c[af>>2]|0;ed=ec;while(1){if((ed|0)==(ad|0)){en=ad;break}if((c[ed>>2]|0)==(ah|0)){en=ed;break}else{ed=ed+4|0}}ed=en-ec>>2;en=ec+(ed+1<<2)|0;ah=ad-en|0;LG(ec+(ed<<2)|0,en|0,ah|0)|0;en=ec+((ah>>2)+ed<<2)|0;ed=c[af>>2]|0;if((en|0)!=(ed|0)){c[af>>2]=ed+(~((ed-4+(-en|0)|0)>>>2)<<2)}Lw(ae);di=ao;dj=ap;dk=di;dl=0;dm=dk;dn=dj;bg(dm|0);return 0}function vK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zT(e)|0;if((f|0)==0){g=0;return g|0}h=(y0(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=h+o;h=e;f=0;while(1){n=h-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{h=n;f=f+1|0}}h=b+40|0;if((o|0)!=0){c[h>>2]=1}o=c[h>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[h>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function vL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zU(e)|0;if((f|0)==0){g=0;return g|0}h=(y0(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L7}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[f>>2]=h+n;h=e;f=0;while(1){o=h-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{h=o;f=f+1|0}}h=b+40|0;if((n|0)!=0){c[h>>2]=1}n=c[h>>2]|0;c[b+52>>2]=n+f;j=i;o=e;c[h>>2]=j-o+f+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=i;g=i;return g|0}function vM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zm(e)|0;if((f|0)==0){g=0;return g|0}h=(y0(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=h+o;h=e;f=0;while(1){n=h-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{h=n;f=f+1|0}}h=b+40|0;if((o|0)!=0){c[h>>2]=1}o=c[h>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[h>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function vN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zA(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zB(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zC(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=z1(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=yZ(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=(a[e]|0)==42?e+1|0:0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=y1(g)|0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function vT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zc(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=a[36920]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=36920;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==0){p=i;break L9}else if((n<<24>>24|0)==10){q=i+1|0}else{q=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=q}else{p=q;break}}}else{p=0}}while(0);c[g>>2]=h+p;h=e;g=0;while(1){q=h-1|0;if(q>>>0<k>>>0){break}if((a[q]|0)==10){break}else{h=q;g=g+1|0}}h=b+40|0;if((p|0)!=0){c[h>>2]=1}p=c[h>>2]|0;c[b+52>>2]=p+g;k=f;q=e;c[h>>2]=k-q+g+p;p=b+56|0;c[p>>2]=q;c[p+4>>2]=k;c[d>>2]=f;o=f;return o|0}function vV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zd(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=ze(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zf(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zh(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function vZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zg(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function v_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zi(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function v$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zj(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function v0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zk(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function v1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y5(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function v2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+56|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=c[b>>2]|0;l=Lu(60)|0;c[h>>2]=l;m=k+4|0;n=c[m>>2]|0;if((n|0)==(c[k+8>>2]|0)){e4(k|0,h);o=c[h>>2]|0}else{if((n|0)==0){p=0}else{c[n>>2]=l;p=c[m>>2]|0}c[m>>2]=p+4;o=l}l=o;p=o;n=b+28|0;L8:do{if((a[n]&1)==0){h=j;c[h>>2]=c[n>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];q=16}else{h=c[b+36>>2]|0;r=c[b+32>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(r>>>0<11>>>0){a[j]=r<<1;s=j+1|0}else{t=r+16&-16;u=(z=0,au(248,t|0)|0);if(z){z=0;break}c[j+8>>2]=u;c[j>>2]=t|1;c[j+4>>2]=r;s=u}LF(s|0,h|0,r)|0;a[s+r|0]=0;q=16;break L8}}while(0);r=bT(-1,-1)|0;v=M;w=r}}while(0);do{if((q|0)==16){s=b+44|0;n=g;c[n>>2]=c[s>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];z=0;aD(36,p|0,j|0,g|0,0,1,0);if(z){z=0;s=bT(-1,-1)|0;n=s;s=M;if((a[j]&1)==0){v=s;w=n;break}Lw(c[j+8>>2]|0);v=s;w=n;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}n=b+20|0;s=y$(c[n>>2]|0)|0;if((s+1|0)==0|(a[s]|0)!=123){s=o+36|0;r=s;h=v3(b)|0;c[f>>2]=h;u=s+8|0;t=u;x=c[t>>2]|0;if((x|0)==(c[s+12>>2]|0)){fq(s+4|0,f);y=c[f>>2]|0}else{if((x|0)==0){A=0}else{c[x>>2]=h;A=c[t>>2]|0}c[u>>2]=A+4;y=h}cB[c[c[s>>2]>>2]&1023](r,y)}r=y$(c[n>>2]|0)|0;s=(a[r]|0)==44?r+1|0:0;if((s|0)==0){i=d;return p|0}h=b+48|0;u=b+40|0;t=b+52|0;x=b+56|0;B=o+36|0;C=B;D=B+8|0;E=D;F=B+12|0;G=B+4|0;H=B;B=r;r=s;while(1){s=c[h>>2]|0;I=c[n>>2]|0;L45:do{if(I>>>0<r>>>0){J=I;K=0;while(1){L=a[J]|0;if((L<<24>>24|0)==0){N=K;break L45}else if((L<<24>>24|0)==10){O=K+1|0}else{O=K}L=J+1|0;if(L>>>0<r>>>0){J=L;K=O}else{N=O;break}}}else{N=0}}while(0);c[h>>2]=N+s;K=B;J=0;while(1){L=K-1|0;if(L>>>0<I>>>0){break}if((a[L]|0)==10){break}else{K=L;J=J+1|0}}if((N|0)!=0){c[u>>2]=1}K=c[u>>2]|0;c[t>>2]=K+J;I=r;s=B;c[u>>2]=I-s+J+K;c[x>>2]=s;c[x+4>>2]=I;c[n>>2]=r;if((r|0)==0){q=56;break}I=v3(b)|0;c[e>>2]=I;s=c[E>>2]|0;if((s|0)==(c[F>>2]|0)){fq(G,e);P=c[e>>2]|0}else{if((s|0)==0){Q=0}else{c[s>>2]=I;Q=c[E>>2]|0}c[D>>2]=Q+4;P=I}cB[c[c[H>>2]>>2]&1023](C,P);I=y$(c[n>>2]|0)|0;s=(a[I]|0)==44?I+1|0:0;if((s|0)==0){q=54;break}else{B=I;r=s}}if((q|0)==54){i=d;return p|0}else if((q|0)==56){i=d;return p|0}}}while(0);p=c[k>>2]|0;k=c[m>>2]|0;d=p;while(1){if((d|0)==(k|0)){R=k;break}if((c[d>>2]|0)==(o|0)){R=d;break}else{d=d+4|0}}d=R-p>>2;R=p+(d+1<<2)|0;o=k-R|0;LG(p+(d<<2)|0,R|0,o|0)|0;R=p+((o>>2)+d<<2)|0;d=c[m>>2]|0;if((R|0)==(d|0)){Lw(l);S=w;T=0;U=S;V=v;bg(U|0)}c[m>>2]=d+(~((d-4+(-R|0)|0)>>>2)<<2);Lw(l);S=w;T=0;U=S;V=v;bg(U|0);return 0}function v3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=d+56|0;l=d+64|0;m=d+80|0;n=b|0;o=c[n>>2]|0;p=Lu(60)|0;c[k>>2]=p;q=o+4|0;r=c[q>>2]|0;if((r|0)==(c[o+8>>2]|0)){e4(o|0,k);s=c[k>>2]|0}else{if((r|0)==0){t=0}else{c[r>>2]=p;t=c[q>>2]|0}c[q>>2]=t+4;s=p}p=s;t=s;r=b+28|0;L8:do{if((a[r]&1)==0){k=l;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];u=16}else{k=c[b+36>>2]|0;v=c[b+32>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(v>>>0<11>>>0){a[l]=v<<1;w=l+1|0}else{x=v+16&-16;y=(z=0,au(248,x|0)|0);if(z){z=0;break}c[l+8>>2]=y;c[l>>2]=x|1;c[l+4>>2]=v;w=y}LF(w|0,k|0,v)|0;a[w+v|0]=0;u=16;break L8}}while(0);v=bT(-1,-1)|0;A=M;B=v}}while(0);do{if((u|0)==16){w=b+44|0;v=j;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];z=0;aI(88,t|0,l|0,j|0,0,0,0,0);if(z){z=0;v=bT(-1,-1)|0;k=v;v=M;if((a[l]&1)==0){A=v;B=k;break}Lw(c[l+8>>2]|0);A=v;B=k;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}do{if((v4(b)|0)==0){if((v5(b)|0)==0){break}a[t+57|0]=1}else{a[s+56|0]=1}}while(0);L35:do{if((y1(y$(c[b+20>>2]|0)|0)|0)==0){if((uu(b)|0)==0){k=s+36|0;v=k;y=v6(b)|0;c[f>>2]=y;x=k+8|0;C=x;D=c[C>>2]|0;if((D|0)==(c[k+12>>2]|0)){j_(k+4|0,f);E=c[f>>2]|0}else{if((D|0)==0){F=0}else{c[D>>2]=y;F=c[C>>2]|0}c[x>>2]=F+4;E=y}cB[c[c[k>>2]>>2]&1023](v,E);break}v=c[n>>2]|0;k=Lu(52)|0;c[h>>2]=k;y=v+4|0;x=c[y>>2]|0;if((x|0)==(c[v+8>>2]|0)){e4(v|0,h);G=c[h>>2]|0}else{if((x|0)==0){H=0}else{c[x>>2]=k;H=c[y>>2]|0}c[y>>2]=H+4;G=k}k=G;L55:do{if((a[r]&1)==0){x=m;c[x>>2]=c[r>>2];c[x+4>>2]=c[r+4>>2];c[x+8>>2]=c[r+8>>2];u=50}else{x=c[b+36>>2]|0;C=c[b+32>>2]|0;do{if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(C>>>0<11>>>0){a[m]=C<<1;I=m+1|0}else{D=C+16&-16;J=(z=0,au(248,D|0)|0);if(z){z=0;break}c[m+8>>2]=J;c[m>>2]=D|1;c[m+4>>2]=C;I=J}LF(I|0,x|0,C)|0;a[I+C|0]=0;u=50;break L55}}while(0);C=bT(-1,-1)|0;K=M;L=C}}while(0);do{if((u|0)==50){C=g;c[C>>2]=c[w>>2];c[C+4>>2]=c[w+4>>2];c[C+8>>2]=c[w+8>>2];z=0;aq(14,G|0,m|0,g|0,b+56|0,0);if(!z){c[s+52>>2]=G;if((a[m]&1)==0){break L35}Lw(c[m+8>>2]|0);break L35}else{z=0;C=bT(-1,-1)|0;x=C;C=M;if((a[m]&1)==0){K=C;L=x;break}Lw(c[m+8>>2]|0);K=C;L=x;break}}}while(0);x=c[v>>2]|0;C=c[y>>2]|0;J=x;while(1){if((J|0)==(C|0)){N=C;break}if((c[J>>2]|0)==(G|0)){N=J;break}else{J=J+4|0}}J=N-x>>2;v=x+(J+1<<2)|0;D=C-v|0;LG(x+(J<<2)|0,v|0,D|0)|0;v=x+((D>>2)+J<<2)|0;J=c[y>>2]|0;if((v|0)!=(J|0)){c[y>>2]=J+(~((J-4+(-v|0)|0)>>>2)<<2)}Lw(k);O=K;P=L;Q=P;R=0;S=Q;T=O;bg(S|0)}else{c[s+52>>2]=uF(b)|0}}while(0);if((v7(b)|0)==0){i=d;return t|0}w=s+36|0;v=w;J=w+8|0;D=J;U=w+12|0;V=w+4|0;W=w;do{w=v6(b)|0;c[e>>2]=w;X=c[D>>2]|0;if((X|0)==(c[U>>2]|0)){j_(V,e);Y=c[e>>2]|0}else{if((X|0)==0){Z=0}else{c[X>>2]=w;Z=c[D>>2]|0}c[J>>2]=Z+4;Y=w}cB[c[c[W>>2]>>2]&1023](v,Y);}while((v7(b)|0)!=0);i=d;return t|0}}while(0);t=c[o>>2]|0;o=c[q>>2]|0;d=t;while(1){if((d|0)==(o|0)){_=o;break}if((c[d>>2]|0)==(s|0)){_=d;break}else{d=d+4|0}}d=_-t>>2;_=t+(d+1<<2)|0;s=o-_|0;LG(t+(d<<2)|0,_|0,s|0)|0;_=t+((s>>2)+d<<2)|0;d=c[q>>2]|0;if((_|0)!=(d|0)){c[q>>2]=d+(~((d-4+(-_|0)|0)>>>2)<<2)}Lw(p);O=A;P=B;Q=P;R=0;S=Q;T=O;bg(S|0);return 0}function v4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=a[36808]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=36808;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==0){p=i;break L9}else if((n<<24>>24|0)==10){q=i+1|0}else{q=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=q}else{p=q;break}}}else{p=0}}while(0);c[g>>2]=h+p;h=e;g=0;while(1){q=h-1|0;if(q>>>0<k>>>0){break}if((a[q]|0)==10){break}else{h=q;g=g+1|0}}h=b+40|0;if((p|0)!=0){c[h>>2]=1}p=c[h>>2]|0;c[b+52>>2]=p+g;k=f;q=e;c[h>>2]=k-q+g+p;p=b+56|0;c[p>>2]=q;c[p+4>>2]=k;c[d>>2]=f;o=f;return o|0}function v5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=a[36728]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=36728;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}function v6(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;d=i;i=i+176|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+128|0;p=d+144|0;q=d+160|0;r=b+20|0;if((y1(y$(c[r>>2]|0)|0)|0)!=0){s=uF(b)|0;t=c[b>>2]|0;u=Lu(48)|0;c[f>>2]=u;v=t+4|0;w=c[v>>2]|0;if((w|0)==(c[t+8>>2]|0)){e4(t|0,f);x=c[f>>2]|0}else{if((w|0)==0){y=0}else{c[w>>2]=u;y=c[v>>2]|0}c[v>>2]=y+4;x=u}u=x;y=x;w=b+28|0;L10:do{if((a[w]&1)==0){f=g;c[f>>2]=c[w>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];A=17}else{f=c[b+36>>2]|0;B=c[b+32>>2]|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(B>>>0<11>>>0){a[g]=B<<1;C=g+1|0}else{D=B+16&-16;E=(z=0,au(248,D|0)|0);if(z){z=0;break}c[g+8>>2]=E;c[g>>2]=D|1;c[g+4>>2]=B;C=E}LF(C|0,f|0,B)|0;a[C+B|0]=0;A=17;break L10}}while(0);B=bT(-1,-1)|0;F=M;G=B}}while(0);do{if((A|0)==17){C=h;w=b+44|0;c[C>>2]=c[w>>2];c[C+4>>2]=c[w+4>>2];c[C+8>>2]=c[w+8>>2];z=0;aD(38,y|0,g|0,h|0,s|0,0,1);if(z){z=0;w=bT(-1,-1)|0;C=w;w=M;if((a[g]&1)==0){F=w;G=C;break}Lw(c[g+8>>2]|0);F=w;G=C;break}if((a[g]&1)==0){H=y;i=d;return H|0}Lw(c[g+8>>2]|0);H=y;i=d;return H|0}}while(0);y=c[t>>2]|0;t=c[v>>2]|0;g=y;while(1){if((g|0)==(t|0)){I=t;break}if((c[g>>2]|0)==(x|0)){I=g;break}else{g=g+4|0}}g=I-y>>2;I=y+(g+1<<2)|0;x=t-I|0;LG(y+(g<<2)|0,I|0,x|0)|0;I=y+((x>>2)+g<<2)|0;g=c[v>>2]|0;if((I|0)!=(g|0)){c[v>>2]=g+(~((g-4+(-I|0)|0)>>>2)<<2)}Lw(u);J=F;K=G;L=K;N=0;O=L;P=J;bg(O|0)}G=y$(c[r>>2]|0)|0;F=(a[G]|0)==40?G+1|0:0;do{if((F|0)==0){u=Lu(48)|0;I=j+8|0;c[I>>2]=u;c[j>>2]=49;c[j+4>>2]=42;LF(u|0,2632,42)|0;a[u+42|0]=0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;z=0;aR(492,b|0,j|0,k|0);if(!z){if((a[j]&1)==0){break}Lw(c[I>>2]|0);break}else{z=0}u=bT(-1,-1)|0;g=u;u=M;if((a[j]&1)==0){J=u;K=g;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[I>>2]|0);J=u;K=g;L=K;N=0;O=L;P=J;bg(O|0)}else{g=b+48|0;u=c[g>>2]|0;I=c[r>>2]|0;L45:do{if(I>>>0<F>>>0){v=I;x=0;while(1){y=a[v]|0;if((y<<24>>24|0)==10){Q=x+1|0}else if((y<<24>>24|0)==0){R=x;break L45}else{Q=x}y=v+1|0;if(y>>>0<F>>>0){v=y;x=Q}else{R=Q;break}}}else{R=0}}while(0);c[g>>2]=R+u;x=G;v=0;while(1){y=x-1|0;if(y>>>0<I>>>0){break}if((a[y]|0)==10){break}else{x=y;v=v+1|0}}x=b+40|0;if((R|0)!=0){c[x>>2]=1}I=c[x>>2]|0;c[b+52>>2]=I+v;u=F;g=G;c[x>>2]=u-g+v+I;I=b+56|0;c[I>>2]=g;c[I+4>>2]=u;c[r>>2]=F}}while(0);F=y$(c[r>>2]|0)|0;do{if(!((F+1|0)==0|(a[F]|0)!=41)){G=Lu(64)|0;R=l+8|0;c[R>>2]=G;c[l>>2]=65;c[l+4>>2]=48;LF(G|0,2504,48)|0;a[G+48|0]=0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;z=0;aR(492,b|0,l|0,m|0);if(!z){if((a[l]&1)==0){break}Lw(c[R>>2]|0);break}else{z=0}G=bT(-1,-1)|0;Q=G;G=M;if((a[l]&1)==0){J=G;K=Q;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[R>>2]|0);J=G;K=Q;L=K;N=0;O=L;P=J;bg(O|0)}}while(0);l=vk(b)|0;m=y$(c[r>>2]|0)|0;F=(a[m]|0)==58?m+1|0:0;if((F|0)==0){S=0}else{Q=b+48|0;G=c[Q>>2]|0;R=c[r>>2]|0;L82:do{if(R>>>0<F>>>0){j=R;k=0;while(1){u=a[j]|0;if((u<<24>>24|0)==10){T=k+1|0}else if((u<<24>>24|0)==0){U=k;break L82}else{T=k}u=j+1|0;if(u>>>0<F>>>0){j=u;k=T}else{U=T;break}}}else{U=0}}while(0);c[Q>>2]=U+G;G=m;Q=0;while(1){T=G-1|0;if(T>>>0<R>>>0){break}if((a[T]|0)==10){break}else{G=T;Q=Q+1|0}}G=b+40|0;if((U|0)!=0){c[G>>2]=1}U=c[G>>2]|0;c[b+52>>2]=U+Q;R=F;T=m;c[G>>2]=R-T+Q+U;U=b+56|0;c[U>>2]=T;c[U+4>>2]=R;c[r>>2]=F;S=vd(b)|0}F=y$(c[r>>2]|0)|0;R=(a[F]|0)==41?F+1|0:0;do{if((R|0)==0){U=Lu(48)|0;T=n+8|0;c[T>>2]=U;c[n>>2]=49;c[n+4>>2]=46;LF(U|0,2312,46)|0;a[U+46|0]=0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;z=0;aR(492,b|0,n|0,o|0);if(!z){if((a[n]&1)==0){break}Lw(c[T>>2]|0);break}else{z=0}U=bT(-1,-1)|0;Q=U;U=M;if((a[n]&1)==0){J=U;K=Q;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[T>>2]|0);J=U;K=Q;L=K;N=0;O=L;P=J;bg(O|0)}else{Q=b+48|0;U=c[Q>>2]|0;T=c[r>>2]|0;L108:do{if(T>>>0<R>>>0){G=T;m=0;while(1){k=a[G]|0;if((k<<24>>24|0)==10){V=m+1|0}else if((k<<24>>24|0)==0){W=m;break L108}else{V=m}k=G+1|0;if(k>>>0<R>>>0){G=k;m=V}else{W=V;break}}}else{W=0}}while(0);c[Q>>2]=W+U;m=F;G=0;while(1){k=m-1|0;if(k>>>0<T>>>0){break}if((a[k]|0)==10){break}else{m=k;G=G+1|0}}m=b+40|0;if((W|0)!=0){c[m>>2]=1}T=c[m>>2]|0;c[b+52>>2]=T+G;U=R;Q=F;c[m>>2]=U-Q+G+T;T=b+56|0;c[T>>2]=Q;c[T+4>>2]=U;c[r>>2]=R}}while(0);R=c[b>>2]|0;r=Lu(48)|0;c[e>>2]=r;F=R+4|0;W=c[F>>2]|0;if((W|0)==(c[R+8>>2]|0)){e4(R|0,e);X=c[e>>2]|0}else{if((W|0)==0){Y=0}else{c[W>>2]=r;Y=c[F>>2]|0}c[F>>2]=Y+4;X=r}r=X;Y=X;W=b+28|0;L130:do{if((a[W]&1)==0){e=p;c[e>>2]=c[W>>2];c[e+4>>2]=c[W+4>>2];c[e+8>>2]=c[W+8>>2];A=93}else{e=c[b+36>>2]|0;V=c[b+32>>2]|0;do{if(V>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(V>>>0<11>>>0){a[p]=V<<1;Z=p+1|0}else{n=V+16&-16;o=(z=0,au(248,n|0)|0);if(z){z=0;break}c[p+8>>2]=o;c[p>>2]=n|1;c[p+4>>2]=V;Z=o}LF(Z|0,e|0,V)|0;a[Z+V|0]=0;A=93;break L130}}while(0);V=bT(-1,-1)|0;_=M;$=V}}while(0);do{if((A|0)==93){Z=q;b=l+16|0;c[Z>>2]=c[b>>2];c[Z+4>>2]=c[b+4>>2];c[Z+8>>2]=c[b+8>>2];z=0;aD(38,Y|0,p|0,q|0,l|0,S|0,0);if(z){z=0;b=bT(-1,-1)|0;Z=b;b=M;if((a[p]&1)==0){_=b;$=Z;break}Lw(c[p+8>>2]|0);_=b;$=Z;break}if((a[p]&1)==0){H=Y;i=d;return H|0}Lw(c[p+8>>2]|0);H=Y;i=d;return H|0}}while(0);H=c[R>>2]|0;R=c[F>>2]|0;d=H;while(1){if((d|0)==(R|0)){aa=R;break}if((c[d>>2]|0)==(X|0)){aa=d;break}else{d=d+4|0}}d=aa-H>>2;aa=H+(d+1<<2)|0;X=R-aa|0;LG(H+(d<<2)|0,aa|0,X|0)|0;aa=H+((X>>2)+d<<2)|0;d=c[F>>2]|0;if((aa|0)!=(d|0)){c[F>>2]=d+(~((d-4+(-aa|0)|0)>>>2)<<2)}Lw(r);J=_;K=$;L=K;N=0;O=L;P=J;bg(O|0);return 0}function v7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=a[36824]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=36824;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}function v8(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+48|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;LF(m|0,e|0,12)|0;e=k;n=l;o=b|0;p=d;if((a[p]&1)==0){c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2]}else{p=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){D5(0)}if(q>>>0<11>>>0){a[e]=q<<1;r=k+1|0}else{d=q+16&-16;s=Lu(d)|0;c[k+8>>2]=s;c[k>>2]=d|1;c[k+4>>2]=q;r=s}LF(r|0,p|0,q)|0;a[r+q|0]=0}c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];z=0;aD(6,o|0,k|0,l|0,0,0,0);if(!z){if((a[e]&1)==0){t=b|0;c[t>>2]=20104;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;x=h&1;a[w]=x;i=j;return}Lw(c[k+8>>2]|0);t=b|0;c[t>>2]=20104;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;x=h&1;a[w]=x;i=j;return}else{z=0;j=bT(-1,-1)|0;if((a[e]&1)==0){bg(j|0)}Lw(c[k+8>>2]|0);bg(j|0)}}function v9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y3(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function wa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zl(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function wb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function wc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function wd(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function we(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function wf(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+68>>2]&1023](b,a);return}function wg(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function wh(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function wi(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function wj(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function wk(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+68>>2]&511](a,d,b);return}function wl(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+68>>2]&511](a,d,b);return}function wm(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aV(6,m|0,k|0,l|0,h|0);if(z){z=0;h=bT(-1,-1)|0;l=h;h=M;if((a[k]&1)==0){r=h;s=l;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=h;s=l;t=s;u=0;v=t;w=r;bg(v|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=b|0;c[k>>2]=19912;l=b+32|0;h=f;if((a[h]&1)==0){m=l;c[m>>2]=c[h>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];x=b+44|0;c[x>>2]=g;i=j;return}h=c[f+8>>2]|0;m=c[f+4>>2]|0;do{if(m>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(m>>>0<11>>>0){a[l]=m<<1;y=l+1|0}else{f=m+16&-16;p=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=p;c[l>>2]=f|1;c[b+36>>2]=m;y=p}LF(y|0,h|0,m)|0;a[y+m|0]=0;x=b+44|0;c[x>>2]=g;i=j;return}}while(0);j=bT(-1,-1)|0;g=j;j=M;c[k>>2]=17512;if((a[b+4|0]&1)==0){r=j;s=g;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[b+12>>2]|0);r=j;s=g;t=s;u=0;v=t;w=r;bg(v|0)}function wn(b){b=b|0;var d=0;d=b|0;c[d>>2]=19912;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function wo(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19912;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function wp(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+64>>2]&1023](b,a);return}function wq(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function wr(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function ws(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function wt(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function wu(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+64>>2]&511](a,d,b);return}function wv(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+64>>2]&511](a,d,b);return}function ww(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;l=i;i=i+32|0;m=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];m=l|0;n=l+16|0;o=b|0;p=d;if((a[p]&1)==0){q=m;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2]}else{p=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){D5(0)}if(q>>>0<11>>>0){a[m]=q<<1;r=m+1|0}else{d=q+16&-16;s=Lu(d)|0;c[m+8>>2]=s;c[m>>2]=d|1;c[m+4>>2]=q;r=s}LF(r|0,p|0,q)|0;a[r+q|0]=0}q=n;r=e;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];z=0;aV(6,o|0,m|0,n|0,j|0);if(z){z=0;j=bT(-1,-1)|0;n=j;j=M;if((a[m]&1)==0){t=j;u=n;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[m+8>>2]|0);t=j;u=n;v=u;w=0;x=v;y=t;bg(x|0)}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}m=b|0;c[m>>2]=19976;n=b+32|0;j=f;if((a[j]&1)==0){o=n;c[o>>2]=c[j>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];A=b+44|0;c[A>>2]=g;B=b+48|0;c[B>>2]=h;C=b+52|0;D=k&1;a[C]=D;i=l;return}j=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[n]=o<<1;E=n+1|0}else{f=o+16&-16;r=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=r;c[n>>2]=f|1;c[b+36>>2]=o;E=r}LF(E|0,j|0,o)|0;a[E+o|0]=0;A=b+44|0;c[A>>2]=g;B=b+48|0;c[B>>2]=h;C=b+52|0;D=k&1;a[C]=D;i=l;return}}while(0);l=bT(-1,-1)|0;D=l;l=M;c[m>>2]=17512;if((a[b+4|0]&1)==0){t=l;u=D;v=u;w=0;x=v;y=t;bg(x|0)}Lw(c[b+12>>2]|0);t=l;u=D;v=u;w=0;x=v;y=t;bg(x|0)}function wx(b){b=b|0;var d=0;d=b|0;c[d>>2]=19976;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function wy(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19976;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function wz(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+60>>2]&1023](b,a);return}function wA(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function wB(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function wC(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function wD(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function wE(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+60>>2]&511](a,d,b);return}function wF(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+60>>2]&511](a,d,b);return}function wG(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function wH(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function wI(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+56>>2]&1023](b,a);return}function wJ(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function wK(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function wL(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function wM(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function wN(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+56>>2]&511](a,d,b);return}function wO(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+56>>2]&511](a,d,b);return}function wP(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function wQ(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function wR(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+108>>2]&1023](b,a);return}function wS(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function wT(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function wU(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function wV(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function wW(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+108>>2]&511](a,d,b);return}function wX(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+108>>2]&511](a,d,b);return}function wY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aD(6,l|0,j|0,k|0,1,0,0);if(z){z=0;k=bT(-1,-1)|0;l=k;k=M;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}j=b|0;c[j>>2]=17632;c[b+36>>2]=f;f=b+40|0;l=g;if((a[l]&1)==0){k=f;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];i=h;return}l=c[g+8>>2]|0;k=c[g+4>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[f]=k<<1;w=f+1|0}else{g=k+16&-16;o=(z=0,au(248,g|0)|0);if(z){z=0;break}c[b+48>>2]=o;c[f>>2]=g|1;c[b+44>>2]=k;w=o}LF(w|0,l|0,k)|0;a[w+k|0]=0;i=h;return}}while(0);h=bT(-1,-1)|0;k=h;h=M;c[j>>2]=17512;if((a[b+4|0]&1)==0){q=h;r=k;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[b+12>>2]|0);q=h;r=k;s=r;t=0;u=s;v=q;bg(u|0)}function wZ(b){b=b|0;var d=0;d=b|0;c[d>>2]=17632;if((a[b+40|0]&1)!=0){Lw(c[b+48>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function w_(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=17632;if((a[b+40|0]&1)!=0){Lw(c[b+48>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function w$(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+116>>2]&1023](b,a);return}function w0(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function w1(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function w2(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function w3(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function w4(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+116>>2]&511](a,d,b);return}function w5(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+116>>2]&511](a,d,b);return}function w6(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function w7(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function w8(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+100>>2]&1023](b,a);return}function w9(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function xa(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function xb(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function xc(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function xd(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+100>>2]&511](a,d,b);return}function xe(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+100>>2]&511](a,d,b);return}function xf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aD(6,k|0,h|0,j|0,0,0,0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}h=b|0;c[h>>2]=17304;k=b+36|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+44>>2]=m;c[k>>2]=f|1;c[b+40>>2]=n;v=m}LF(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bT(-1,-1)|0;n=g;g=M;c[h>>2]=17512;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}function xg(b){b=b|0;var d=0;d=b|0;c[d>>2]=17304;if((a[b+36|0]&1)!=0){Lw(c[b+44>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function xh(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=17304;if((a[b+36|0]&1)!=0){Lw(c[b+44>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function xi(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+112>>2]&1023](b,a);return}function xj(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function xk(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function xl(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function xm(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function xn(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+112>>2]&511](a,d,b);return}function xo(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+112>>2]&511](a,d,b);return}function xp(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function xq(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function xr(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+96>>2]&1023](b,a);return}function xs(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function xt(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function xu(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function xv(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function xw(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+96>>2]&511](a,d,b);return}function xx(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+96>>2]&511](a,d,b);return}function xy(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function xz(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function xA(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+80>>2]&1023](b,a);return}function xB(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function xC(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function xD(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function xE(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function xF(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+80>>2]&511](a,d,b);return}function xG(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+80>>2]&511](a,d,b);return}function xH(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function xI(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function xJ(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+76>>2]&1023](b,a);return}function xK(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function xL(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function xM(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function xN(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function xO(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+76>>2]&511](a,d,b);return}function xP(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+76>>2]&511](a,d,b);return}function xQ(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function xR(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function xS(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+72>>2]&1023](b,a);return}function xT(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function xU(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function xV(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function xW(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function xX(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+72>>2]&511](a,d,b);return}function xY(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+72>>2]&511](a,d,b);return}function xZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aR(302,m|0,k|0,l|0);if(z){z=0;l=bT(-1,-1)|0;m=l;l=M;if((a[k]&1)==0){r=l;s=m;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=l;s=m;t=s;u=0;v=t;w=r;bg(v|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=b|0;c[k>>2]=20464;m=b+32|0;l=f;L22:do{if((a[l]&1)==0){p=m;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];x=22}else{p=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[m]=o<<1;y=m+1|0}else{e=o+16&-16;n=(z=0,au(248,e|0)|0);if(z){z=0;break}c[b+40>>2]=n;c[m>>2]=e|1;c[b+36>>2]=o;y=n}LF(y|0,p|0,o)|0;a[y+o|0]=0;x=22;break L22}}while(0);o=bT(-1,-1)|0;A=M;B=o}}while(0);do{if((x|0)==22){y=b+44|0;f=g;if((a[f]&1)==0){l=y;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];C=b+56|0;c[C>>2]=h;i=j;return}f=c[g+8>>2]|0;l=c[g+4>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(l>>>0<11>>>0){a[y]=l<<1;D=y+1|0}else{o=l+16&-16;p=(z=0,au(248,o|0)|0);if(z){z=0;break}c[b+52>>2]=p;c[y>>2]=o|1;c[b+48>>2]=l;D=p}LF(D|0,f|0,l)|0;a[D+l|0]=0;C=b+56|0;c[C>>2]=h;i=j;return}}while(0);l=bT(-1,-1)|0;f=l;l=M;if((a[m]&1)==0){A=l;B=f;break}Lw(c[b+40>>2]|0);A=l;B=f}}while(0);c[k>>2]=17512;if((a[b+4|0]&1)==0){r=A;s=B;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[b+12>>2]|0);r=A;s=B;t=s;u=0;v=t;w=r;bg(v|0)}function x_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=b|0;k=d;if((a[k]&1)==0){l=g;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2]}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){D5(0)}if(l>>>0<11>>>0){a[g]=l<<1;m=g+1|0}else{d=l+16&-16;n=Lu(d)|0;c[g+8>>2]=n;c[g>>2]=d|1;c[g+4>>2]=l;m=n}LF(m|0,k|0,l)|0;a[m+l|0]=0}l=h;m=e;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];z=0;aq(20,j|0,g|0,h|0,0,0);if(!z){if((a[g]&1)==0){o=b|0;c[o>>2]=21208;i=f;return}Lw(c[g+8>>2]|0);o=b|0;c[o>>2]=21208;i=f;return}else{z=0;f=bT(-1,-1)|0;if((a[g]&1)==0){bg(f|0)}Lw(c[g+8>>2]|0);bg(f|0)}}function x$(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aR(302,l|0,j|0,k|0);if(z){z=0;k=bT(-1,-1)|0;l=k;k=M;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;bg(u|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}j=b|0;c[j>>2]=21344;l=b+32|0;k=f;if((a[k]&1)==0){o=l;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];w=b+44|0;c[w>>2]=g;i=h;return}k=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[l]=o<<1;x=l+1|0}else{f=o+16&-16;n=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=n;c[l>>2]=f|1;c[b+36>>2]=o;x=n}LF(x|0,k|0,o)|0;a[x+o|0]=0;w=b+44|0;c[w>>2]=g;i=h;return}}while(0);h=bT(-1,-1)|0;g=h;h=M;c[j>>2]=17512;if((a[b+4|0]&1)==0){q=h;r=g;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[b+12>>2]|0);q=h;r=g;s=r;t=0;u=s;v=q;bg(u|0)}function x0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aR(302,k|0,h|0,j|0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}h=b|0;c[h>>2]=20176;k=b+32|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];v=b+29|0;a[v]=1;i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;w=k+1|0}else{f=n+16&-16;m=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=m;c[k>>2]=f|1;c[b+36>>2]=n;w=m}LF(w|0,j|0,n)|0;a[w+n|0]=0;v=b+29|0;a[v]=1;i=g;return}}while(0);g=bT(-1,-1)|0;v=g;g=M;c[h>>2]=17512;if((a[b+4|0]&1)==0){p=g;q=v;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b+12>>2]|0);p=g;q=v;r=q;s=0;t=r;u=p;bg(t|0)}function x1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aR(302,k|0,h|0,j|0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}h=b|0;c[h>>2]=20392;k=b+32|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=m;c[k>>2]=f|1;c[b+36>>2]=n;v=m}LF(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bT(-1,-1)|0;n=g;g=M;c[h>>2]=17512;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}function x2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aR(302,k|0,h|0,j|0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}h=b|0;c[h>>2]=21416;k=b+32|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+40>>2]=m;c[k>>2]=f|1;c[b+36>>2]=n;v=m}LF(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bT(-1,-1)|0;n=g;g=M;c[h>>2]=17512;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}function x3(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function x4(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function x5(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+168>>2]&1023](b,a);return}function x6(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function x7(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function x8(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function x9(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function ya(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+168>>2]&511](a,d,b);return}function yb(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+168>>2]&511](a,d,b);return}function yc(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function yd(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function ye(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+20>>2]&1023](b,a);return}function yf(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function yg(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function yh(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function yi(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function yj(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+20>>2]&511](a,d,b);return}function yk(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+20>>2]&511](a,d,b);return}function yl(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){D5(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=Lu(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}LF(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];z=0;aq(8,l|0,j|0,k|0,g|0,1);if(z){z=0;g=bT(-1,-1)|0;k=g;g=M;if((a[j]&1)==0){q=g;r=k;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[j+8>>2]|0);q=g;r=k;s=r;t=0;u=s;v=q;bg(u|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}j=b|0;c[j>>2]=21136;k=b+40|0;g=c[f>>2]|0;l=c[f+4>>2]|0;f=g;o=l-f|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[k]=o<<1;w=k+1|0}else{n=o+16&-16;e=(z=0,au(248,n|0)|0);if(z){z=0;break}c[b+48>>2]=e;c[k>>2]=n|1;c[b+44>>2]=o;w=e}if((g|0)==(l|0)){x=w;a[x]=0;i=h;return}e=l+(-f|0)|0;n=w;m=g;while(1){a[n]=a[m]|0;p=m+1|0;if((p|0)==(l|0)){break}else{n=n+1|0;m=p}}x=w+e|0;a[x]=0;i=h;return}}while(0);h=bT(-1,-1)|0;x=h;h=M;c[j>>2]=17512;if((a[b+4|0]&1)==0){q=h;r=x;s=r;t=0;u=s;v=q;bg(u|0)}Lw(c[b+12>>2]|0);q=h;r=x;s=r;t=0;u=s;v=q;bg(u|0)}function ym(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=Lu(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];z=0;aR(424,m|0,k|0,l|0);if(z){z=0;l=bT(-1,-1)|0;m=l;l=M;if((a[k]&1)==0){r=l;s=m;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[k+8>>2]|0);r=l;s=m;t=s;u=0;v=t;w=r;bg(v|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}k=b|0;c[k>>2]=22984;m=b+28|0;l=f;if((a[l]&1)==0){p=m;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];x=b+40|0;c[x>>2]=g;y=b+44|0;A=h&1;a[y]=A;i=j;return}l=c[f+8>>2]|0;p=c[f+4>>2]|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(p>>>0<11>>>0){a[m]=p<<1;B=m+1|0}else{f=p+16&-16;o=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+36>>2]=o;c[m>>2]=f|1;c[b+32>>2]=p;B=o}LF(B|0,l|0,p)|0;a[B+p|0]=0;x=b+40|0;c[x>>2]=g;y=b+44|0;A=h&1;a[y]=A;i=j;return}}while(0);j=bT(-1,-1)|0;A=j;j=M;c[k>>2]=17512;if((a[b+4|0]&1)==0){r=j;s=A;t=s;u=0;v=t;w=r;bg(v|0)}Lw(c[b+12>>2]|0);r=j;s=A;t=s;u=0;v=t;w=r;bg(v|0)}function yn(b){b=b|0;var d=0;d=b|0;c[d>>2]=22984;if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function yo(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=22984;if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function yp(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+36>>2]&1023](b,a);return}function yq(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function yr(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function ys(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function yt(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function yu(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+36>>2]&511](a,d,b);return}function yv(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+36>>2]&511](a,d,b);return}function yw(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0;j=i;i=i+80|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=d;if((a[p]&1)==0){q=l;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];r=a[q]|0;s=q}else{q=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){D5(0)}if(p>>>0<11>>>0){d=p<<1&255;t=l;a[t]=d;u=l+1|0;v=d;w=t}else{t=p+16&-16;d=Lu(t)|0;c[l+8>>2]=d;x=t|1;c[l>>2]=x;c[l+4>>2]=p;u=d;v=x&255;w=l}LF(u|0,q|0,p)|0;a[u+p|0]=0;r=v;s=w}w=e;e=k;c[e>>2]=c[w>>2];c[e+4>>2]=c[w+4>>2];c[e+8>>2]=c[w+8>>2];w=k;k=b|0;c[k>>2]=17512;e=b+4|0;L12:do{if((r&1)==0){v=e;c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2]}else{v=c[l+8>>2]|0;p=c[l+4>>2]|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(p>>>0<11>>>0){a[e]=p<<1;y=e+1|0}else{u=p+16&-16;q=(z=0,au(248,u|0)|0);if(z){z=0;break}c[b+12>>2]=q;c[e>>2]=u|1;c[b+8>>2]=p;y=q}LF(y|0,v|0,p)|0;a[y+p|0]=0;break L12}}while(0);p=bT(-1,-1)|0;q=p;p=M;if((a[s]&1)==0){A=p;B=q;C=B;D=0;E=C;F=A;bg(E|0)}Lw(v);A=p;B=q;C=B;D=0;E=C;F=A;bg(E|0)}}while(0);y=b+16|0;c[y>>2]=c[w>>2];c[y+4>>2]=c[w+4>>2];c[y+8>>2]=c[w+8>>2];if((a[s]&1)!=0){Lw(c[l+8>>2]|0)}c[k>>2]=17024;l=b+28|0;s=f;L33:do{if((a[s]&1)==0){w=l;c[w>>2]=c[s>>2];c[w+4>>2]=c[s+4>>2];c[w+8>>2]=c[s+8>>2];G=31}else{w=c[f+8>>2]|0;r=c[f+4>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(r>>>0<11>>>0){a[l]=r<<1;H=l+1|0}else{q=r+16&-16;p=(z=0,au(248,q|0)|0);if(z){z=0;break}c[b+36>>2]=p;c[l>>2]=q|1;c[b+32>>2]=r;H=p}LF(H|0,w|0,r)|0;a[H+r|0]=0;G=31;break L33}}while(0);r=bT(-1,-1)|0;I=M;J=r}}while(0);do{if((G|0)==31){c[b+40>>2]=g;a[b+44|0]=h&1;if((g|0)==0|h^1){i=j;return}H=(z=0,au(248,64)|0);do{if(!z){f=m+8|0;c[f>>2]=H;c[m>>2]=65;c[m+4>>2]=54;LF(H|0,800,54)|0;a[H+54|0]=0;s=e;L53:do{if((a[s]&1)==0){r=n;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];G=43}else{r=c[b+12>>2]|0;w=c[b+8>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(w>>>0<11>>>0){a[n]=w<<1;K=n+1|0}else{v=w+16&-16;p=(z=0,au(248,v|0)|0);if(z){z=0;break}c[n+8>>2]=p;c[n>>2]=v|1;c[n+4>>2]=w;K=p}LF(K|0,r|0,w)|0;a[K+w|0]=0;G=43;break L53}}while(0);w=bT(-1,-1)|0;L=M;N=w}}while(0);do{if((G|0)==43){s=o;c[s>>2]=c[y>>2];c[s+4>>2]=c[y+4>>2];c[s+8>>2]=c[y+8>>2];z=0;aR(382,m|0,n|0,o|0);if(z){z=0;s=bT(-1,-1)|0;w=s;s=M;if((a[n]&1)==0){L=s;N=w;break}Lw(c[n+8>>2]|0);L=s;N=w;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[m]&1)==0){i=j;return}Lw(c[f>>2]|0);i=j;return}}while(0);if((a[m]&1)==0){O=L;P=N;break}Lw(c[f>>2]|0);O=L;P=N}else{z=0;w=bT(-1,-1)|0;O=M;P=w}}while(0);if((a[l]&1)==0){I=O;J=P;break}Lw(c[b+36>>2]|0);I=O;J=P}}while(0);c[k>>2]=17512;if((a[e]&1)==0){A=I;B=J;C=B;D=0;E=C;F=A;bg(E|0)}Lw(c[b+12>>2]|0);A=I;B=J;C=B;D=0;E=C;F=A;bg(E|0)}function yx(b){b=b|0;var d=0;d=b|0;c[d>>2]=17024;if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function yy(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=17024;if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function yz(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+152>>2]&1023](b,a);return}function yA(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function yB(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function yC(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function yD(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function yE(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+152>>2]&511](a,d,b);return}function yF(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+152>>2]&511](a,d,b);return}function yG(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aR(424,k|0,h|0,j|0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}h=b|0;c[h>>2]=22352;k=b+28|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(z=0,au(248,f|0)|0);if(z){z=0;break}c[b+36>>2]=m;c[k>>2]=f|1;c[b+32>>2]=n;v=m}LF(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bT(-1,-1)|0;n=g;g=M;c[h>>2]=17512;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;bg(t|0)}function yH(b){b=b|0;var d=0;d=b|0;c[d>>2]=22352;if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function yI(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=22352;if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function yJ(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+44>>2]&1023](b,a);return}function yK(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function yL(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function yM(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function yN(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function yO(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+44>>2]&511](a,d,b);return}function yP(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+44>>2]&511](a,d,b);return}
function t5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=c[d>>2]|0;f=yR(e)|0;if((f|0)==0){g=yT(e)|0;if((g|0)==0){h=e}else{i=g;j=3}}else{i=f;j=3}if((j|0)==3){while(1){j=0;f=yR(i)|0;if((f|0)!=0){i=f;j=3;continue}f=yT(i)|0;if((f|0)==0){h=i;break}else{i=f;j=3}}}j=yV(h)|0;if((j|0)==0){k=0;return k|0}i=b+48|0;f=c[i>>2]|0;g=c[d>>2]|0;L11:do{if(g>>>0<j>>>0){e=g;l=0;while(1){m=a[e]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L11}else{n=l}m=e+1|0;if(m>>>0<j>>>0){e=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[i>>2]=f+o;f=h;i=0;while(1){n=f-1|0;if(n>>>0<g>>>0){break}if((a[n]|0)==10){break}else{f=n;i=i+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+i;g=j;n=h;c[f>>2]=g-n+i+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=g;c[d>>2]=j;k=j;return k|0}function t6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0;e=i;i=i+352|0;f=d;d=i;i=i+8|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=e+72|0;n=e+80|0;o=e+88|0;p=e+96|0;q=e+112|0;r=e+120|0;s=e+136|0;t=e+152|0;u=e+168|0;v=e+176|0;w=e+240|0;x=e+248|0;y=e+264|0;A=e+280|0;B=e+296|0;C=e+312|0;D=e+328|0;E=e+344|0;F=c[d>>2]|0;G=c[d+4>>2]|0;L1:do{if(F>>>0<G>>>0){H=a[37176]|0;I=H<<24>>24==0;L3:do{if(I){J=F;while(1){K=a[J]|0;if(K<<24>>24==0){L=12;break L1}N=J+1|0;if(!(K<<24>>24==92&(N|0)!=0|(J|0)==0)){O=J;break L3}if(N>>>0<G>>>0){J=N}else{L=12;break L1}}}else{J=F;while(1){N=a[J]|0;if(N<<24>>24==0){L=12;break L1}K=J+1|0;P=N<<24>>24==92&(K|0)!=0?0:J;if((P|0)!=0){N=P;P=37176;Q=H;while(1){if((a[N]|0)!=Q<<24>>24){R=N;S=Q;break}T=N+1|0;U=P+1|0;V=a[U]|0;if(V<<24>>24==0){R=T;S=0;break}else{N=T;P=U;Q=V}}if(!(S<<24>>24!=0|(R|0)==0)){O=J;break L3}}if(K>>>0<G>>>0){J=K}else{L=12;break L1}}}}while(0);J=b|0;Q=c[J>>2]|0;if((O|0)==0){W=Q;break}P=Lu(60)|0;c[f>>2]=P;N=Q+4|0;V=c[N>>2]|0;if((V|0)==(c[Q+8>>2]|0)){e4(Q|0,f);X=c[f>>2]|0}else{if((V|0)==0){Y=0}else{c[V>>2]=P;Y=c[N>>2]|0}c[N>>2]=Y+4;X=P}P=X;V=X;U=b+28|0;L26:do{if((a[U]&1)==0){T=s;c[T>>2]=c[U>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];L=57}else{T=c[b+36>>2]|0;Z=c[b+32>>2]|0;do{if(Z>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Z>>>0<11>>>0){a[s]=Z<<1;_=s+1|0}else{$=Z+16&-16;aa=(z=0,au(248,$|0)|0);if(z){z=0;break}c[s+8>>2]=aa;c[s>>2]=$|1;c[s+4>>2]=Z;_=aa}LF(_|0,T|0,Z)|0;a[_+Z|0]=0;L=57;break L26}}while(0);Z=bT(-1,-1)|0;ab=M;ac=Z}}while(0);do{if((L|0)==57){Z=b+44|0;T=j;c[T>>2]=c[Z>>2];c[T+4>>2]=c[Z+4>>2];c[T+8>>2]=c[Z+8>>2];z=0;aD(2,V|0,s|0,j|0,0,0,0);if(z){z=0;T=bT(-1,-1)|0;aa=T;T=M;if((a[s]&1)==0){ab=T;ac=aa;break}Lw(c[s+8>>2]|0);ab=T;ac=aa;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}a[X+56|0]=a[F]|0;aa=X+40|0;T=aa;$=t;ad=u|0;ae=u+4|0;af=aa+8|0;ag=aa+12|0;ah=aa+4|0;ai=t+8|0;aj=b+36|0;ak=b+32|0;al=t+1|0;am=t|0;an=t+4|0;ao=a[36840]|0;ap=ao<<24>>24==0;at=B;av=B+1|0;aw=A;ax=A+1|0;ay=C|0;aA=C+4|0;aB=C+8|0;aC=B+8|0;aE=A+8|0;aF=A|0;aG=A+4|0;aH=B+4|0;aI=B|0;aJ=w|0;aK=w+4|0;aL=x;aM=y;aN=v+28|0;aO=v+4|0;aP=x+8|0;aQ=v+8|0;aS=v+36|0;aT=x+1|0;aU=x|0;aV=x+4|0;aW=F;L48:while(1){L50:while(1){L52:do{if(I){aX=aW;while(1){aY=a[aX]|0;if(aY<<24>>24==0){L=192;break L48}aZ=aX+1|0;if(!(aY<<24>>24==92&(aZ|0)!=0|(aX|0)==0)){a_=aX;break L52}if(aZ>>>0<G>>>0){aX=aZ}else{L=192;break L48}}}else{aX=aW;while(1){aZ=a[aX]|0;if(aZ<<24>>24==0){L=192;break L48}aY=aX+1|0;a$=aZ<<24>>24==92&(aY|0)!=0?0:aX;if((a$|0)!=0){aZ=a$;a$=37176;a0=H;while(1){if((a[aZ]|0)!=a0<<24>>24){a1=aZ;a2=a0;break}a3=aZ+1|0;a4=a$+1|0;a5=a[a4]|0;if(a5<<24>>24==0){a1=a3;a2=0;break}else{aZ=a3;a$=a4;a0=a5}}if(!(a2<<24>>24!=0|(a1|0)==0)){a_=aX;break L52}}if(aY>>>0<G>>>0){aX=aY}else{L=192;break L48}}}}while(0);if((a_|0)==0){L=192;break L48}do{if(aW>>>0<a_>>>0){a6=c[J>>2]|0;aX=Lu(52)|0;c[k>>2]=aX;a7=a6+4|0;a0=c[a7>>2]|0;if((a0|0)==(c[a6+8>>2]|0)){e4(a6|0,k);a8=c[k>>2]|0}else{if((a0|0)==0){a9=0}else{c[a0>>2]=aX;a9=c[a7>>2]|0}c[a7>>2]=a9+4;a8=aX}ba=a8;aX=a8;if((a[U]&1)==0){c[$>>2]=c[U>>2];c[$+4>>2]=c[U+4>>2];c[$+8>>2]=c[U+8>>2]}else{a0=c[aj>>2]|0;a$=c[ak>>2]|0;if(a$>>>0>4294967279>>>0){L=82;break L48}if(a$>>>0<11>>>0){a[$]=a$<<1;bb=al}else{aZ=a$+16&-16;a5=(z=0,au(248,aZ|0)|0);if(z){z=0;L=108;break L48}c[ai>>2]=a5;c[am>>2]=aZ|1;c[an>>2]=a$;bb=a5}LF(bb|0,a0|0,a$)|0;a[bb+a$|0]=0}a$=l;c[a$>>2]=c[Z>>2];c[a$+4>>2]=c[Z+4>>2];c[a$+8>>2]=c[Z+8>>2];c[ad>>2]=aW;c[ae>>2]=a_;z=0;aq(14,aX|0,t|0,l|0,u|0,0);if(z){z=0;bc=1;L=111;break L48}aX=a8;c[m>>2]=aX;a$=c[af>>2]|0;a0=a$;if((a$|0)==(c[ag>>2]|0)){z=0;as(376,ah|0,m|0);if(z){z=0;bc=0;L=111;break L48}bd=c[m>>2]|0}else{if((a$|0)==0){be=0}else{c[a0>>2]=aX;be=c[af>>2]|0}c[af>>2]=be+4;bd=aX}z=0;as(c[c[aa>>2]>>2]|0,T|0,bd|0);if(z){z=0;bc=0;L=111;break L48}if((a[$]&1)==0){break}Lw(c[ai>>2]|0)}}while(0);L99:do{if(ap){aX=a_;while(1){if(aX>>>0>=G>>>0){break L99}if((a[aX]|0)==0){break L99}if((aX|0)==0){aX=aX+1|0}else{bf=aX;break L50}}}else{aX=a_;while(1){if(aX>>>0>=G>>>0){break L99}a0=a[aX]|0;if(a0<<24>>24==0){break L99}L108:do{if(a0<<24>>24==ao<<24>>24){a$=36840;a5=aX;while(1){aZ=a5+1|0;a4=a$+1|0;a3=a[a4]|0;if(a3<<24>>24==0){bh=aZ;bi=0;break L108}if((a[aZ]|0)==a3<<24>>24){a$=a4;a5=aZ}else{bh=aZ;bi=a3;break}}}else{bh=aX;bi=ao}}while(0);if(bi<<24>>24!=0|(bh|0)==0){aX=aX+1|0}else{break}}if((aX|0)!=0){bf=aX;break L50}}}while(0);a0=G-F|0;if(a0>>>0>4294967279>>>0){L=165;break L48}if(a0>>>0<11>>>0){aY=a0<<1&255;a[at]=aY;bj=av;bk=aY}else{aY=a0+16&-16;a5=Lu(aY)|0;c[aC>>2]=a5;a$=aY|1;c[aI>>2]=a$;c[aH>>2]=a0;bj=a5;bk=a$&255}LF(bj|0,F|0,a0)|0;a[bj+a0|0]=0;LI(aw|0,0,12)|0;a0=bk&255;a$=(a0&1|0)==0?a0>>>1:c[aH>>2]|0;a0=a$+48|0;if(a0>>>0>4294967279>>>0){L=170;break L48}if(a0>>>0<11>>>0){a[aw]=96;bl=ax}else{a0=a$+64&-16;a5=(z=0,au(248,a0|0)|0);if(z){z=0;L=177;break L48}c[aE>>2]=a5;c[aF>>2]=a0|1;c[aG>>2]=48;bl=a5}LF(bl|0,4744,48)|0;a[bl+48|0]=0;z=0,az(88,A|0,((bk&1)==0?av:c[aC>>2]|0)|0,a$|0)|0;if(z){z=0;L=177;break L48}c[ay>>2]=0;c[aA>>2]=0;c[aB>>2]=0;z=0;aR(492,b|0,A|0,C|0);if(z){z=0;L=188;break L48}if((a[aw]&1)!=0){Lw(c[aE>>2]|0)}if((a[at]&1)!=0){Lw(c[aC>>2]|0)}if(aW>>>0>=G>>>0){bm=P;L=234;break L48}}c[aJ>>2]=a_+2;c[aK>>2]=bf;K=c[J>>2]|0;if((a[U]&1)==0){c[aL>>2]=c[U>>2];c[aL+4>>2]=c[U+4>>2];c[aL+8>>2]=c[U+8>>2]}else{a$=c[aj>>2]|0;a5=c[ak>>2]|0;if(a5>>>0>4294967279>>>0){L=134;break}if(a5>>>0<11>>>0){a[aL]=a5<<1;bn=aT}else{a0=a5+16&-16;aY=Lu(a0)|0;c[aP>>2]=aY;c[aU>>2]=a0|1;c[aV>>2]=a5;bn=aY}LF(bn|0,a$|0,a5)|0;a[bn+a5|0]=0}c[aM>>2]=c[Z>>2];c[aM+4>>2]=c[Z+4>>2];c[aM+8>>2]=c[Z+8>>2];z=0;aq(16,v|0,w|0,K|0,x|0,y|0);if(z){z=0;L=155;break}K=(z=0,au(168,v|0)|0);if(z){z=0;L=156;break}if((a[aN]&1)!=0){Lw(c[aS>>2]|0)}a5=c[aO>>2]|0;a$=a5;if((a5|0)!=0){aY=c[aQ>>2]|0;if((a5|0)!=(aY|0)){c[aQ>>2]=aY+(~((aY-4+(-a$|0)|0)>>>2)<<2)}Lw(a5)}if((a[aL]&1)!=0){Lw(c[aP>>2]|0)}a[K+29|0]=1;c[n>>2]=K;a5=c[af>>2]|0;a$=a5;if((a5|0)==(c[ag>>2]|0)){fq(ah,n);bo=c[n>>2]|0}else{if((a5|0)==0){bp=0}else{c[a$>>2]=K;bp=c[af>>2]|0}c[af>>2]=bp+4;bo=K}cB[c[c[aa>>2]>>2]&1023](T,bo);K=bf+1|0;if(K>>>0<G>>>0){aW=K}else{bm=P;L=231;break}}do{if((L|0)==165){D5(0);return 0}else if((L|0)==108){aM=bT(-1,-1)|0;bq=M;br=aM;L=110}else if((L|0)==82){z=0;ar(86,0);if(!z){return 0}else{z=0;aM=bT(-1,-1)|0;bq=M;br=aM;L=110;break}}else if((L|0)==231){bs=bm;i=e;return bs|0}else if((L|0)==234){bs=bm;i=e;return bs|0}else if((L|0)==155){aM=bT(-1,-1)|0;bt=M;bu=aM;L=162}else if((L|0)==156){aM=bT(-1,-1)|0;aV=aM;aM=M;if((a[aN]&1)!=0){Lw(c[aS>>2]|0)}aU=c[aO>>2]|0;if((aU|0)==0){bt=aM;bu=aV;L=162;break}aT=c[aQ>>2]|0;if((aU|0)!=(aT|0)){c[aQ>>2]=aT+(~((aT-4+(-aU|0)|0)>>>2)<<2)}Lw(aU);bt=aM;bu=aV;L=162}else if((L|0)==134){D5(0);return 0}else if((L|0)==111){aV=bT(-1,-1)|0;aM=aV;aV=M;if((a[$]&1)==0){if(bc){bv=aM;bw=aV;break}else{bx=aV;by=aM}bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}else{Lw(c[ai>>2]|0);if(bc){bv=aM;bw=aV;break}else{bx=aV;by=aM}bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}}else if((L|0)==170){z=0;ar(86,0);if(!z){return 0}else{z=0;aM=bT(-1,-1)|0;bD=M;bE=aM;L=179;break}}else if((L|0)==177){aM=bT(-1,-1)|0;bD=M;bE=aM;L=179}else if((L|0)==188){aM=bT(-1,-1)|0;aV=aM;aM=M;if((a[aw]&1)==0){bF=aM;bG=aV;L=190;break}Lw(c[aE>>2]|0);bF=aM;bG=aV;L=190}else if((L|0)==192){if(aW>>>0>=G>>>0){bm=P;bs=bm;i=e;return bs|0}aV=c[J>>2]|0;aM=Lu(52)|0;c[o>>2]=aM;aU=aV+4|0;aT=c[aU>>2]|0;if((aT|0)==(c[aV+8>>2]|0)){e4(aV|0,o);bH=c[o>>2]|0}else{if((aT|0)==0){bI=0}else{c[aT>>2]=aM;bI=c[aU>>2]|0}c[aU>>2]=bI+4;bH=aM}aM=bH;aT=bH;L208:do{if((a[U]&1)==0){aK=D;c[aK>>2]=c[U>>2];c[aK+4>>2]=c[U+4>>2];c[aK+8>>2]=c[U+8>>2];L=208}else{aK=c[aj>>2]|0;aJ=c[ak>>2]|0;do{if(aJ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aJ>>>0<11>>>0){a[D]=aJ<<1;bJ=D+1|0}else{aB=aJ+16&-16;aA=(z=0,au(248,aB|0)|0);if(z){z=0;break}c[D+8>>2]=aA;c[D>>2]=aB|1;c[D+4>>2]=aJ;bJ=aA}LF(bJ|0,aK|0,aJ)|0;a[bJ+aJ|0]=0;L=208;break L208}}while(0);aJ=bT(-1,-1)|0;bK=aJ;bL=M}}while(0);do{if((L|0)==208){aJ=p;c[aJ>>2]=c[Z>>2];c[aJ+4>>2]=c[Z+4>>2];c[aJ+8>>2]=c[Z+8>>2];c[E>>2]=aW;c[E+4>>2]=G;z=0;aq(14,aT|0,D|0,p|0,E|0,0);do{if(!z){aJ=bH;c[q>>2]=aJ;aK=c[af>>2]|0;aA=aK;if((aK|0)==(c[ag>>2]|0)){z=0;as(376,ah|0,q|0);if(z){z=0;bM=0;break}bN=c[q>>2]|0}else{if((aK|0)==0){bO=0}else{c[aA>>2]=aJ;bO=c[af>>2]|0}c[af>>2]=bO+4;bN=aJ}z=0;as(c[c[aa>>2]>>2]|0,T|0,bN|0);if(z){z=0;bM=0;break}if((a[D]&1)==0){bm=P;bs=bm;i=e;return bs|0}Lw(c[D+8>>2]|0);bm=P;bs=bm;i=e;return bs|0}else{z=0;bM=1}}while(0);aJ=bT(-1,-1)|0;aA=aJ;aJ=M;if((a[D]&1)==0){if(bM){bK=aA;bL=aJ;break}else{bx=aJ;by=aA}bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}else{Lw(c[D+8>>2]|0);if(bM){bK=aA;bL=aJ;break}else{bx=aJ;by=aA}bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}}}while(0);aT=c[aV>>2]|0;aA=c[aU>>2]|0;aJ=aT;while(1){if((aJ|0)==(aA|0)){bP=aA;break}if((c[aJ>>2]|0)==(bH|0)){bP=aJ;break}else{aJ=aJ+4|0}}aJ=bP-aT>>2;aV=aT+(aJ+1<<2)|0;aK=aA-aV|0;LG(aT+(aJ<<2)|0,aV|0,aK|0)|0;aV=aT+((aK>>2)+aJ<<2)|0;aJ=c[aU>>2]|0;if((aV|0)!=(aJ|0)){c[aU>>2]=aJ+(~((aJ-4+(-aV|0)|0)>>>2)<<2)}Lw(aM);bx=bL;by=bK;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}}while(0);if((L|0)==162){if((a[aL]&1)==0){bx=bt;by=bu;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}Lw(c[aP>>2]|0);bx=bt;by=bu;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}else if((L|0)==110){bv=br;bw=bq}else if((L|0)==179){if((a[aw]&1)!=0){Lw(c[aE>>2]|0)}bF=bD;bG=bE;L=190}if((L|0)==190){if((a[at]&1)==0){bx=bF;by=bG;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}Lw(c[aC>>2]|0);bx=bF;by=bG;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}T=c[a6>>2]|0;aa=c[a7>>2]|0;af=T;while(1){if((af|0)==(aa|0)){bQ=aa;break}if((c[af>>2]|0)==(a8|0)){bQ=af;break}else{af=af+4|0}}af=bQ-T>>2;aC=T+(af+1<<2)|0;at=aa-aC|0;LG(T+(af<<2)|0,aC|0,at|0)|0;aC=T+((at>>2)+af<<2)|0;af=c[a7>>2]|0;if((aC|0)!=(af|0)){c[a7>>2]=af+(~((af-4+(-aC|0)|0)>>>2)<<2)}Lw(ba);bx=bw;by=bv;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}}while(0);U=c[Q>>2]|0;J=c[N>>2]|0;H=U;while(1){if((H|0)==(J|0)){bR=J;break}if((c[H>>2]|0)==(X|0)){bR=H;break}else{H=H+4|0}}H=bR-U>>2;Q=U+(H+1<<2)|0;I=J-Q|0;LG(U+(H<<2)|0,Q|0,I|0)|0;Q=U+((I>>2)+H<<2)|0;H=c[N>>2]|0;if((Q|0)!=(H|0)){c[N>>2]=H+(~((H-4+(-Q|0)|0)>>>2)<<2)}Lw(P);bx=ab;by=ac;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0)}else{L=12}}while(0);if((L|0)==12){W=c[b>>2]|0}ac=Lu(52)|0;c[h>>2]=ac;ab=W+4|0;bR=c[ab>>2]|0;if((bR|0)==(c[W+8>>2]|0)){e4(W|0,h);bS=c[h>>2]|0}else{if((bR|0)==0){bU=0}else{c[bR>>2]=ac;bU=c[ab>>2]|0}c[ab>>2]=bU+4;bS=ac}ac=bS;bU=b+28|0;L298:do{if((a[bU]&1)==0){bR=r;c[bR>>2]=c[bU>>2];c[bR+4>>2]=c[bU+4>>2];c[bR+8>>2]=c[bU+8>>2];L=29}else{bR=c[b+36>>2]|0;h=c[b+32>>2]|0;do{if(h>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(h>>>0<11>>>0){a[r]=h<<1;bV=r+1|0}else{X=h+16&-16;bv=(z=0,au(248,X|0)|0);if(z){z=0;break}c[r+8>>2]=bv;c[r>>2]=X|1;c[r+4>>2]=h;bV=bv}LF(bV|0,bR|0,h)|0;a[bV+h|0]=0;L=29;break L298}}while(0);h=bT(-1,-1)|0;bW=M;bX=h}}while(0);do{if((L|0)==29){bV=b+44|0;bU=g;c[bU>>2]=c[bV>>2];c[bU+4>>2]=c[bV+4>>2];c[bU+8>>2]=c[bV+8>>2];z=0;aq(14,bS|0,r|0,g|0,d|0,0);if(z){z=0;bV=bT(-1,-1)|0;bU=bV;bV=M;if((a[r]&1)==0){bW=bV;bX=bU;break}Lw(c[r+8>>2]|0);bW=bV;bX=bU;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}a[bS+28|0]=1;bm=ac;bs=bm;i=e;return bs|0}}while(0);bs=c[W>>2]|0;W=c[ab>>2]|0;e=bs;while(1){if((e|0)==(W|0)){bY=W;break}if((c[e>>2]|0)==(bS|0)){bY=e;break}else{e=e+4|0}}e=bY-bs>>2;bY=bs+(e+1<<2)|0;bS=W-bY|0;LG(bs+(e<<2)|0,bY|0,bS|0)|0;bY=bs+((bS>>2)+e<<2)|0;e=c[ab>>2]|0;if((bY|0)!=(e|0)){c[ab>>2]=e+(~((e-4+(-bY|0)|0)>>>2)<<2)}Lw(ac);bx=bW;by=bX;bz=by;bA=0;bB=bz;bC=bx;bg(bB|0);return 0}function t7(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;LF(k|0,e|0,12)|0;e=h;l=j;m=b|0;n=d;if((a[n]&1)==0){c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[e]=o<<1;p=h+1|0}else{d=o+16&-16;q=Lu(d)|0;c[h+8>>2]=q;c[h>>2]=d|1;c[h+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];z=0;aR(424,m|0,h|0,j|0);if(!z){if((a[e]&1)==0){r=b|0;c[r>>2]=18128;s=b+28|0;c[s>>2]=f;i=g;return}Lw(c[h+8>>2]|0);r=b|0;c[r>>2]=18128;s=b+28|0;c[s>>2]=f;i=g;return}else{z=0;g=bT(-1,-1)|0;if((a[e]&1)==0){bg(g|0)}Lw(c[h+8>>2]|0);bg(g|0)}}function t8(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0;e=i;i=i+176|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=e+72|0;n=e+80|0;o=e+96|0;p=e+104|0;q=e+120|0;r=e+128|0;s=e+144|0;t=e+160|0;u=t;v=i;i=i+12|0;i=i+7&-8;w=i;i=i+12|0;i=i+7&-8;x=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+4|0;i=i+7&-8;G=i;i=i+12|0;i=i+7&-8;H=i;i=i+12|0;i=i+7&-8;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+12|0;i=i+7&-8;K=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+4|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+12|0;i=i+7&-8;uq(b)|0;T=b|0;U=c[T>>2]|0;V=Lu(52)|0;c[q>>2]=V;W=U+4|0;X=c[W>>2]|0;if((X|0)==(c[U+8>>2]|0)){e4(U|0,q);Y=c[q>>2]|0}else{if((X|0)==0){Z=0}else{c[X>>2]=V;Z=c[W>>2]|0}c[W>>2]=Z+4;Y=V}V=Y;Z=Y;X=b+28|0;L8:do{if((a[X]&1)==0){q=r;c[q>>2]=c[X>>2];c[q+4>>2]=c[X+4>>2];c[q+8>>2]=c[X+8>>2];_=16}else{q=c[b+36>>2]|0;$=c[b+32>>2]|0;do{if($>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if($>>>0<11>>>0){a[r]=$<<1;aa=r+1|0}else{ab=$+16&-16;ac=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[r+8>>2]=ac;c[r>>2]=ab|1;c[r+4>>2]=$;aa=ac}LF(aa|0,q|0,$)|0;a[aa+$|0]=0;_=16;break L8}}while(0);$=bT(-1,-1)|0;ad=$;ae=M}}while(0);do{if((_|0)==16){aa=b+44|0;$=p;c[$>>2]=c[aa>>2];c[$+4>>2]=c[aa+4>>2];c[$+8>>2]=c[aa+8>>2];z=0;aR(214,Z|0,r|0,p|0);if(z){z=0;$=bT(-1,-1)|0;q=$;$=M;if((a[r]&1)==0){ad=q;ae=$;break}Lw(c[r+8>>2]|0);ad=q;ae=$;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}$=b+20|0;q=P+8|0;ac=P|0;ab=P+4|0;af=Q|0;ag=Q+4|0;ah=Q+8|0;ai=P;aj=R+8|0;ak=R|0;al=R+4|0;am=S|0;an=S+4|0;ao=S+8|0;ap=R;at=Y+40|0;av=at+4|0;aw=at+8|0;ax=at;at=b+48|0;ay=b+40|0;aA=b+52|0;aB=b+56|0;aE=b+56|0;aF=b+60|0;aG=s;aH=s+1|0;aI=v;aJ=v+1|0;aK=t;aL=t+4|0;aM=v+8|0;aN=aK+1|0;aO=t+8|0;aP=v+4|0;aQ=v|0;aS=s+8|0;aT=s+4|0;aU=w;aW=x;aX=y;aY=n;aZ=A;a_=B;a$=B+1|0;a0=C;a1=D;a2=E;a3=E+1|0;a4=E+4|0;a5=D+8|0;a6=E+8|0;a7=b+36|0;a8=b+32|0;a9=D+1|0;ba=D|0;bb=D+4|0;bc=C+8|0;bd=C+1|0;be=C|0;bf=C+4|0;bh=A+8|0;bi=B+8|0;bj=A+1|0;bk=A|0;bl=A+4|0;bm=w+8|0;bn=y+8|0;bo=y+1|0;bp=y|0;bq=y+4|0;br=w+1|0;bs=w|0;bt=w+4|0;bu=H;bv=G;bw=J;bx=K;by=I;bz=L;bA=L+1|0;bB=N|0;bC=N+4|0;bD=N+8|0;bE=L+8|0;bF=L|0;bG=L+4|0;bH=Y+32|0;bI=bH;bJ=Y+36|0;bK=Y+28|0;bL=G+8|0;bM=I+8|0;bN=bH|0;bH=I+4|0;bO=J+8|0;bP=K+8|0;bQ=G+4|0;bR=J+1|0;bS=J|0;bU=J+4|0;bV=H+8|0;bW=H+1|0;bX=H|0;bY=H+4|0;bZ=s|0;b_=1;L30:while(1){do{if((ul(b)|0)==0){if((zD(y$(c[$>>2]|0)|0)|0)!=0){b$=ur(b)|0;c[O>>2]=b$;b0=c[av>>2]|0;if((b0|0)==(c[aw>>2]|0)){fq(ax,O);break}if((b0|0)==0){b1=0}else{c[b0>>2]=b$;b1=c[av>>2]|0}c[av>>2]=b1+4;break}if(b_){b$=Lu(48)|0;c[q>>2]=b$;c[ac>>2]=49;c[ab>>2]=47;LF(b$|0,12904,47)|0;a[b$+47|0]=0;c[af>>2]=0;c[ag>>2]=0;c[ah>>2]=0;z=0;aR(492,b|0,P|0,Q|0);if(z){z=0;_=322;break L30}if((a[ai]&1)==0){break}Lw(c[q>>2]|0);break}else{b$=Lu(64)|0;c[aj>>2]=b$;c[ak>>2]=65;c[al>>2]=52;LF(b$|0,11960,52)|0;a[b$+52|0]=0;c[am>>2]=0;c[an>>2]=0;c[ao>>2]=0;z=0;aR(492,b|0,R|0,S|0);if(z){z=0;_=327;break L30}if((a[ap]&1)==0){break}Lw(c[aj>>2]|0);break}}else{b$=c[aE>>2]|0;b0=(c[aF>>2]|0)-b$|0;if(b0>>>0>4294967279>>>0){_=22;break L30}if(b0>>>0<11>>>0){b2=b0<<1&255;a[aG]=b2;b3=aH;b4=b2}else{b2=b0+16&-16;b5=Lu(b2)|0;c[aS>>2]=b5;b6=b2|1;c[bZ>>2]=b6;c[aT>>2]=b0;b3=b5;b4=b6&255}LF(b3|0,b$|0,b0)|0;a[b3+b0|0]=0;LI(u|0,0,12)|0;b0=b4&255;do{if(((b0&1|0)==0?b0>>>1:c[aT>>2]|0)>>>0>6>>>0){b$=b4&255;b6=((b$&1|0)==0?b$>>>1:c[aT>>2]|0)-5|0;b$=b4&255;b5=(b$&1|0)==0?b$>>>1:c[aT>>2]|0;if(b5>>>0<b6>>>0){_=28;break L30}b$=((b4&1)==0?aH:c[aS>>2]|0)+b6|0;b2=b5-b6|0;b6=b2>>>0<4>>>0?b2:4;if(b6>>>0>4294967279>>>0){_=31;break L30}if(b6>>>0<11>>>0){b2=b6<<1&255;a[aI]=b2;b7=aJ;b8=b2}else{b2=b6+16&-16;b5=(z=0,au(248,b2|0)|0);if(z){z=0;_=54;break L30}c[aM>>2]=b5;b9=b2|1;c[aQ>>2]=b9;c[aP>>2]=b6;b7=b5;b8=b9&255}LF(b7|0,b$|0,b6)|0;a[b7+b6|0]=0;b6=(b8&1)==0?aJ:c[aM>>2]|0;b$=b8&255;b9=(b$&1|0)==0?b$>>>1:c[aP>>2]|0;do{if(b9>>>0>10>>>0){z=0;aC(8,t|0,10,b9-10|0,0,0,0,b9|0,b6|0);if(z){z=0;_=57;break L30}ca=a[aI]|0}else{LG(aN|0,b6|0,b9|0)|0;a[aK+1+b9|0]=0;if((a[u]&1)==0){a[u]=b9<<1;ca=b8;break}else{c[aL>>2]=b9;ca=b8;break}}}while(0);if((ca&1)==0){break}Lw(c[aM>>2]|0)}}while(0);b0=a[u]|0;b9=b0&255;b6=(b9&1|0)==0?b9>>>1:c[aL>>2]|0;b9=b6>>>0>4>>>0;do{if((LH(((b0&1)==0?aN:c[aO>>2]|0)|0,2768,(b9?4:b6)|0)|0)==0){if(!(b6>>>0>3>>>0&(b9^1))){_=222;break}cb=c[T>>2]|0;b$=(z=0,au(248,52)|0);if(z){z=0;_=54;break L30}b5=b$;c[o>>2]=b5;cc=cb+4|0;b$=c[cc>>2]|0;if((b$|0)==(c[cb+8>>2]|0)){z=0;as(382,cb|0,o|0);if(z){z=0;_=54;break L30}cd=c[o>>2]|0}else{if((b$|0)==0){ce=0}else{c[b$>>2]=b5;ce=c[cc>>2]|0}c[cc>>2]=ce+4;cd=b5}cf=cd;b5=cd;if((a[X]&1)==0){c[aU>>2]=c[X>>2];c[aU+4>>2]=c[X+4>>2];c[aU+8>>2]=c[X+8>>2]}else{b$=c[a7>>2]|0;b2=c[a8>>2]|0;if(b2>>>0>4294967279>>>0){_=71;break L30}if(b2>>>0<11>>>0){a[aU]=b2<<1;cg=br}else{ch=b2+16&-16;ci=(z=0,au(248,ch|0)|0);if(z){z=0;_=169;break L30}c[bm>>2]=ci;c[bs>>2]=ch|1;c[bt>>2]=b2;cg=ci}LF(cg|0,b$|0,b2)|0;a[cg+b2|0]=0}c[aW>>2]=c[aa>>2];c[aW+4>>2]=c[aa+4>>2];c[aW+8>>2]=c[aa+8>>2];if((a[aG]&1)==0){c[aX>>2]=c[aG>>2];c[aX+4>>2]=c[aG+4>>2];c[aX+8>>2]=c[aG+8>>2]}else{b2=c[aS>>2]|0;b$=c[aT>>2]|0;if(b$>>>0>4294967279>>>0){_=81;break L30}if(b$>>>0<11>>>0){a[aX]=b$<<1;cj=bo}else{ci=b$+16&-16;ch=(z=0,au(248,ci|0)|0);if(z){z=0;_=172;break L30}c[bn>>2]=ch;c[bp>>2]=ci|1;c[bq>>2]=b$;cj=ch}LF(cj|0,b2|0,b$)|0;a[cj+b$|0]=0}c[aY>>2]=c[aW>>2];c[aY+4>>2]=c[aW+4>>2];c[aY+8>>2]=c[aW+8>>2];z=0;aq(28,b5|0,w|0,n|0,y|0,1);if(z){z=0;_=175;break L30}if((a[aX]&1)!=0){Lw(c[bn>>2]|0)}if((a[aU]&1)!=0){Lw(c[bm>>2]|0)}ck=c[T>>2]|0;b5=(z=0,au(248,56)|0);if(z){z=0;_=54;break L30}b$=b5;c[m>>2]=b$;cl=ck+4|0;b5=c[cl>>2]|0;if((b5|0)==(c[ck+8>>2]|0)){z=0;as(382,ck|0,m|0);if(z){z=0;_=54;break L30}cm=c[m>>2]|0}else{if((b5|0)==0){cn=0}else{c[b5>>2]=b$;cn=c[cl>>2]|0}c[cl>>2]=cn+4;cm=b$}co=cm;b$=cm;if((a[X]&1)==0){c[aZ>>2]=c[X>>2];c[aZ+4>>2]=c[X+4>>2];c[aZ+8>>2]=c[X+8>>2]}else{b5=c[a7>>2]|0;b2=c[a8>>2]|0;if(b2>>>0>4294967279>>>0){_=103;break L30}if(b2>>>0<11>>>0){a[aZ]=b2<<1;cp=bj}else{ch=b2+16&-16;ci=(z=0,au(248,ch|0)|0);if(z){z=0;_=185;break L30}c[bh>>2]=ci;c[bk>>2]=ch|1;c[bl>>2]=b2;cp=ci}LF(cp|0,b5|0,b2)|0;a[cp+b2|0]=0}b2=l;c[b2>>2]=c[aa>>2];c[b2+4>>2]=c[aa+4>>2];c[b2+8>>2]=c[aa+8>>2];a[a_]=0;a[a$]=0;z=0;aD(30,b$|0,A|0,l|0,cd|0,B|0,0);if(z){z=0;_=188;break L30}if((a[a_]&1)!=0){Lw(c[bi>>2]|0)}if((a[aZ]&1)!=0){Lw(c[bh>>2]|0)}cq=c[T>>2]|0;b2=(z=0,au(248,56)|0);if(z){z=0;_=54;break L30}b5=b2;c[k>>2]=b5;cr=cq+4|0;b2=c[cr>>2]|0;if((b2|0)==(c[cq+8>>2]|0)){z=0;as(382,cq|0,k|0);if(z){z=0;_=54;break L30}cs=c[k>>2]|0}else{if((b2|0)==0){ct=0}else{c[b2>>2]=b5;ct=c[cr>>2]|0}c[cr>>2]=ct+4;cs=b5}cu=cs;b5=cs;if((a[X]&1)==0){c[a0>>2]=c[X>>2];c[a0+4>>2]=c[X+4>>2];c[a0+8>>2]=c[X+8>>2]}else{b2=c[a7>>2]|0;ci=c[a8>>2]|0;if(ci>>>0>4294967279>>>0){_=125;break L30}if(ci>>>0<11>>>0){a[a0]=ci<<1;cv=bd}else{ch=ci+16&-16;cw=(z=0,au(248,ch|0)|0);if(z){z=0;_=198;break L30}c[bc>>2]=cw;c[be>>2]=ch|1;c[bf>>2]=ci;cv=cw}LF(cv|0,b2|0,ci)|0;a[cv+ci|0]=0}ci=j;c[ci>>2]=c[aa>>2];c[ci+4>>2]=c[aa+4>>2];c[ci+8>>2]=c[aa+8>>2];z=0;aR(50,b5|0,C|0,j|0);if(z){z=0;_=201;break L30}if((a[a0]&1)!=0){Lw(c[bc>>2]|0)}ci=cs+36|0;b2=ci;c[h>>2]=b$;cw=ci+8|0;ch=cw;cx=c[ch>>2]|0;if((cx|0)==(c[ci+12>>2]|0)){z=0;as(156,ci+4|0,h|0);if(z){z=0;_=54;break L30}cy=c[h>>2]|0}else{if((cx|0)==0){cz=0}else{c[cx>>2]=b$;cz=c[ch>>2]|0}c[cw>>2]=cz+4;cy=b$}z=0;as(c[c[ci>>2]>>2]|0,b2|0,cy|0);if(z){z=0;_=54;break L30}cA=c[T>>2]|0;b2=(z=0,au(248,56)|0);if(z){z=0;_=54;break L30}ci=b2;c[g>>2]=ci;cB=cA+4|0;b2=c[cB>>2]|0;if((b2|0)==(c[cA+8>>2]|0)){z=0;as(382,cA|0,g|0);if(z){z=0;_=54;break L30}cC=c[g>>2]|0}else{if((b2|0)==0){cD=0}else{c[b2>>2]=ci;cD=c[cB>>2]|0}c[cB>>2]=cD+4;cC=ci}cE=cC;ci=cC;if((a[X]&1)==0){c[a1>>2]=c[X>>2];c[a1+4>>2]=c[X+4>>2];c[a1+8>>2]=c[X+8>>2]}else{b2=c[a7>>2]|0;b$=c[a8>>2]|0;if(b$>>>0>4294967279>>>0){_=152;break L30}if(b$>>>0<11>>>0){a[a1]=b$<<1;cF=a9}else{cw=b$+16&-16;ch=(z=0,au(248,cw|0)|0);if(z){z=0;_=209;break L30}c[a5>>2]=ch;c[ba>>2]=cw|1;c[bb>>2]=b$;cF=ch}LF(cF|0,b2|0,b$)|0;a[cF+b$|0]=0}b$=f;c[b$>>2]=c[aa>>2];c[b$+4>>2]=c[aa+4>>2];c[b$+8>>2]=c[aa+8>>2];a[a2]=6;a[a3]=a[968]|0;a[a3+1|0]=a[969]|0;a[a3+2|0]=a[970]|0;a[a4]=0;z=0;aq(10,ci|0,D|0,f|0,E|0,b5|0);if(z){z=0;_=212;break L30}if((a[a2]&1)!=0){Lw(c[a6>>2]|0)}if((a[a1]&1)!=0){Lw(c[a5>>2]|0)}b5=cC;c[F>>2]=b5;ci=c[av>>2]|0;b$=ci;if((ci|0)==(c[aw>>2]|0)){z=0;as(376,ax|0,F|0);if(!z){break}else{z=0;_=54;break L30}}if((ci|0)==0){cG=0}else{c[b$>>2]=b5;cG=c[av>>2]|0}c[av>>2]=cG+4}else{_=222}}while(0);do{if((_|0)==222){_=0;if((a[X]&1)==0){c[bu>>2]=c[X>>2];c[bu+4>>2]=c[X+4>>2];c[bu+8>>2]=c[X+8>>2]}else{b9=c[a7>>2]|0;b6=c[a8>>2]|0;if(b6>>>0>4294967279>>>0){_=225;break L30}if(b6>>>0<11>>>0){a[bu]=b6<<1;cH=bW}else{b0=b6+16&-16;b5=(z=0,au(248,b0|0)|0);if(z){z=0;_=54;break L30}c[bV>>2]=b5;c[bX>>2]=b0|1;c[bY>>2]=b6;cH=b5}LF(cH|0,b9|0,b6)|0;a[cH+b6|0]=0}z=0;as(282,G|0,H|0);if(z){z=0;_=267;break L30}if((a[bu]&1)!=0){Lw(c[bV>>2]|0)}b6=c[T>>2]|0;if((a[bv]&1)==0){c[bw>>2]=c[bv>>2];c[bw+4>>2]=c[bv+4>>2];c[bw+8>>2]=c[bv+8>>2]}else{b9=c[bL>>2]|0;b5=c[bQ>>2]|0;if(b5>>>0>4294967279>>>0){_=238;break L30}if(b5>>>0<11>>>0){a[bw]=b5<<1;cI=bR}else{b0=b5+16&-16;b$=(z=0,au(248,b0|0)|0);if(z){z=0;_=269;break L30}c[bO>>2]=b$;c[bS>>2]=b0|1;c[bU>>2]=b5;cI=b$}LF(cI|0,b9|0,b5)|0;a[cI+b5|0]=0}z=0;as(180,K|0,s|0);if(z){z=0;_=272;break L30}z=0;aV(8,I|0,b6|0,J|0,K|0);if(z){z=0;_=273;break L30}if((a[bx]&1)!=0){Lw(c[bP>>2]|0)}if((a[bw]&1)!=0){Lw(c[bO>>2]|0)}b6=d[by]|0;do{if((((b6&1|0)==0?b6>>>1:c[bH>>2]|0)|0)==0){LI(bz|0,0,12)|0;b5=a[aG]|0;b9=b5&255;b$=(b9&1|0)==0?b9>>>1:c[aT>>2]|0;b9=b$+40|0;if(b9>>>0>4294967279>>>0){_=253;break L30}if(b9>>>0<11>>>0){a[bz]=80;cJ=bA}else{b9=b$+56&-16;b0=(z=0,au(248,b9|0)|0);if(z){z=0;_=260;break L30}c[bE>>2]=b0;c[bF>>2]=b9|1;c[bG>>2]=40;cJ=b0}LF(cJ|0,216,40)|0;a[cJ+40|0]=0;b0=(b5&1)==0?aH:c[aS>>2]|0;z=0,az(88,L|0,b0|0,b$|0)|0;if(z){z=0;_=260;break L30}c[bB>>2]=0;c[bC>>2]=0;c[bD>>2]=0;z=0;aR(492,b|0,L|0,N|0);if(z){z=0;_=280;break L30}if((a[bz]&1)==0){break}Lw(c[bE>>2]|0)}}while(0);b6=c[bI>>2]|0;if((b6|0)==(c[bJ>>2]|0)){z=0;as(284,bK|0,I|0);if(z){z=0;_=277;break L30}}else{do{if((b6|0)!=0){if((a[by]&1)==0){b$=b6;c[b$>>2]=c[by>>2];c[b$+4>>2]=c[by+4>>2];c[b$+8>>2]=c[by+8>>2];break}b$=c[bM>>2]|0;b0=c[bH>>2]|0;if(b0>>>0>4294967279>>>0){_=287;break L30}if(b0>>>0<11>>>0){a[b6]=b0<<1;cK=b6+1|0}else{b5=b0+16&-16;b9=(z=0,au(248,b5|0)|0);if(z){z=0;_=277;break L30}c[b6+8>>2]=b9;c[b6>>2]=b5|1;c[b6+4>>2]=b0;cK=b9}LF(cK|0,b$|0,b0)|0;a[cK+b0|0]=0}}while(0);c[bN>>2]=(c[bI>>2]|0)+12}if((a[by]&1)!=0){Lw(c[bM>>2]|0)}if((a[bv]&1)==0){break}Lw(c[bL>>2]|0)}}while(0);if((a[u]&1)!=0){Lw(c[aO>>2]|0)}if((a[aG]&1)==0){break}Lw(c[aS>>2]|0)}}while(0);b6=y$(c[$>>2]|0)|0;b0=(a[b6]|0)==44?b6+1|0:0;if((b0|0)==0){_=340;break}b$=c[at>>2]|0;b9=c[$>>2]|0;L277:do{if(b9>>>0<b0>>>0){b5=b9;ci=0;while(1){b2=a[b5]|0;if((b2<<24>>24|0)==10){cL=ci+1|0}else if((b2<<24>>24|0)==0){cM=ci;break L277}else{cL=ci}b2=b5+1|0;if(b2>>>0<b0>>>0){b5=b2;ci=cL}else{cM=cL;break}}}else{cM=0}}while(0);c[at>>2]=cM+b$;ci=b6;b5=0;while(1){b2=ci-1|0;if(b2>>>0<b9>>>0){break}if((a[b2]|0)==10){break}else{ci=b2;b5=b5+1|0}}if((cM|0)!=0){c[ay>>2]=1}ci=c[ay>>2]|0;c[aA>>2]=ci+b5;b9=b0;b$=b6;c[ay>>2]=b9-b$+b5+ci;c[aB>>2]=b$;c[aB+4>>2]=b9;c[$>>2]=b0;b_=0}do{if((_|0)==28){z=0;ar(240,0);if(z){z=0;_=55;break}return 0}else if((_|0)==209){b_=bT(-1,-1)|0;cN=M;cO=b_;_=211}else if((_|0)==57){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[aI]&1)==0){cP=$;cQ=b_;break}Lw(c[aM>>2]|0);cP=$;cQ=b_}else if((_|0)==103){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;cR=M;cS=b_;_=187;break}}else if((_|0)==71){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;cT=M;cU=b_;_=171;break}}else if((_|0)==22){D5(0);return 0}else if((_|0)==267){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[bu]&1)==0){cP=$;cQ=b_;break}Lw(c[bV>>2]|0);cP=$;cQ=b_}else if((_|0)==269){b_=bT(-1,-1)|0;cV=M;cW=b_;_=271}else if((_|0)==272){b_=bT(-1,-1)|0;cX=b_;cY=M;_=275}else if((_|0)==273){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[bx]&1)==0){cX=$;cY=b_;_=275;break}Lw(c[bP>>2]|0);cX=$;cY=b_;_=275}else if((_|0)==277){b_=bT(-1,-1)|0;cZ=M;c_=b_;_=279}else if((_|0)==280){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[bz]&1)==0){c$=$;c0=b_;_=300;break}Lw(c[bE>>2]|0);c$=$;c0=b_;_=300}else if((_|0)==172){b_=bT(-1,-1)|0;c1=M;c2=b_;_=174}else if((_|0)==175){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[aX]&1)==0){c3=$;c4=b_;_=177;break}Lw(c[bn>>2]|0);c3=$;c4=b_;_=177}else if((_|0)==125){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;c5=M;c6=b_;_=200;break}}else if((_|0)==185){b_=bT(-1,-1)|0;cR=M;cS=b_;_=187}else if((_|0)==188){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[a_]&1)!=0){Lw(c[bi>>2]|0)}if((a[aZ]&1)==0){c7=$;c8=b_;_=192;break}Lw(c[bh>>2]|0);c7=$;c8=b_;_=192}else if((_|0)==81){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;c1=M;c2=b_;_=174;break}}else if((_|0)==238){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;cV=M;cW=b_;_=271;break}}else if((_|0)==54){b_=bT(-1,-1)|0;c9=M;da=b_;_=56}else if((_|0)==198){b_=bT(-1,-1)|0;c5=M;c6=b_;_=200}else if((_|0)==201){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[a0]&1)==0){db=$;dc=b_;_=203;break}Lw(c[bc>>2]|0);db=$;dc=b_;_=203}else if((_|0)==287){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;cZ=M;c_=b_;_=279;break}}else if((_|0)==225){z=0;ar(86,0);if(z){z=0;_=55;break}return 0}else if((_|0)==322){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[ai]&1)==0){dd=$;de=b_;df=dd;dg=0;dh=df;di=de;bg(dh|0)}Lw(c[q>>2]|0);dd=$;de=b_;df=dd;dg=0;dh=df;di=de;bg(dh|0)}else if((_|0)==327){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[ap]&1)==0){dd=$;de=b_;df=dd;dg=0;dh=df;di=de;bg(dh|0)}Lw(c[aj>>2]|0);dd=$;de=b_;df=dd;dg=0;dh=df;di=de;bg(dh|0)}else if((_|0)==253){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;dj=M;dk=b_;_=262;break}}else if((_|0)==260){b_=bT(-1,-1)|0;dj=M;dk=b_;_=262}else if((_|0)==152){z=0;ar(86,0);if(!z){return 0}else{z=0;b_=bT(-1,-1)|0;cN=M;cO=b_;_=211;break}}else if((_|0)==212){b_=bT(-1,-1)|0;$=b_;b_=M;if((a[a2]&1)!=0){Lw(c[a6>>2]|0)}if((a[a1]&1)==0){dl=$;dm=b_;_=216;break}Lw(c[a5>>2]|0);dl=$;dm=b_;_=216}else if((_|0)==340){i=e;return Z|0}else if((_|0)==31){z=0;ar(86,0);if(z){z=0;_=55;break}return 0}else if((_|0)==169){b_=bT(-1,-1)|0;cT=M;cU=b_;_=171}}while(0);do{if((_|0)==271){dn=cW;dp=cV;_=302}else if((_|0)==275){if((a[bw]&1)==0){dn=cX;dp=cY;_=302;break}Lw(c[bO>>2]|0);dn=cX;dp=cY;_=302}else if((_|0)==55){a5=bT(-1,-1)|0;c9=M;da=a5;_=56}else if((_|0)==171){dq=cU;dr=cT;_=179}else if((_|0)==174){c3=c2;c4=c1;_=177}else if((_|0)==187){c7=cS;c8=cR;_=192}else if((_|0)==200){db=c6;dc=c5;_=203}else if((_|0)==262){if((a[bz]&1)==0){cZ=dj;c_=dk;_=279;break}Lw(c[bE>>2]|0);cZ=dj;c_=dk;_=279}else if((_|0)==211){dl=cO;dm=cN;_=216}}while(0);do{if((_|0)==203){bE=c[cq>>2]|0;bz=c[cr>>2]|0;bO=bE;while(1){if((bO|0)==(bz|0)){ds=bz;break}if((c[bO>>2]|0)==(cs|0)){ds=bO;break}else{bO=bO+4|0}}bO=ds-bE>>2;b0=bE+(bO+1<<2)|0;b5=bz-b0|0;LG(bE+(bO<<2)|0,b0|0,b5|0)|0;b0=bE+((b5>>2)+bO<<2)|0;bO=c[cr>>2]|0;if((b0|0)!=(bO|0)){c[cr>>2]=bO+(~((bO-4+(-b0|0)|0)>>>2)<<2)}Lw(cu);cP=db;cQ=dc}else if((_|0)==56){cP=da;cQ=c9}else if((_|0)==192){b0=c[ck>>2]|0;bO=c[cl>>2]|0;b5=b0;while(1){if((b5|0)==(bO|0)){dt=bO;break}if((c[b5>>2]|0)==(cm|0)){dt=b5;break}else{b5=b5+4|0}}b5=dt-b0>>2;bE=b0+(b5+1<<2)|0;bz=bO-bE|0;LG(b0+(b5<<2)|0,bE|0,bz|0)|0;bE=b0+((bz>>2)+b5<<2)|0;b5=c[cl>>2]|0;if((bE|0)!=(b5|0)){c[cl>>2]=b5+(~((b5-4+(-bE|0)|0)>>>2)<<2)}Lw(co);cP=c7;cQ=c8}else if((_|0)==279){c$=c_;c0=cZ;_=300}else if((_|0)==177){if((a[aU]&1)==0){dq=c3;dr=c4;_=179;break}Lw(c[bm>>2]|0);dq=c3;dr=c4;_=179}else if((_|0)==216){bE=c[cA>>2]|0;b5=c[cB>>2]|0;bz=bE;while(1){if((bz|0)==(b5|0)){du=b5;break}if((c[bz>>2]|0)==(cC|0)){du=bz;break}else{bz=bz+4|0}}bz=du-bE>>2;b0=bE+(bz+1<<2)|0;bO=b5-b0|0;LG(bE+(bz<<2)|0,b0|0,bO|0)|0;b0=bE+((bO>>2)+bz<<2)|0;bz=c[cB>>2]|0;if((b0|0)!=(bz|0)){c[cB>>2]=bz+(~((bz-4+(-b0|0)|0)>>>2)<<2)}Lw(cE);cP=dl;cQ=dm}}while(0);do{if((_|0)==179){bm=c[cb>>2]|0;aU=c[cc>>2]|0;b0=bm;while(1){if((b0|0)==(aU|0)){dv=aU;break}if((c[b0>>2]|0)==(cd|0)){dv=b0;break}else{b0=b0+4|0}}b0=dv-bm>>2;bE=bm+(b0+1<<2)|0;b5=aU-bE|0;LG(bm+(b0<<2)|0,bE|0,b5|0)|0;bE=bm+((b5>>2)+b0<<2)|0;b0=c[cc>>2]|0;if((bE|0)!=(b0|0)){c[cc>>2]=b0+(~((b0-4+(-bE|0)|0)>>>2)<<2)}Lw(cf);cP=dq;cQ=dr}else if((_|0)==300){if((a[by]&1)==0){dn=c$;dp=c0;_=302;break}Lw(c[bM>>2]|0);dn=c$;dp=c0;_=302}}while(0);do{if((_|0)==302){if((a[bv]&1)==0){cP=dn;cQ=dp;break}Lw(c[bL>>2]|0);cP=dn;cQ=dp}}while(0);if((a[u]&1)!=0){Lw(c[aO>>2]|0)}if((a[aG]&1)==0){dd=cP;de=cQ;df=dd;dg=0;dh=df;di=de;bg(dh|0)}Lw(c[aS>>2]|0);dd=cP;de=cQ;df=dd;dg=0;dh=df;di=de;bg(dh|0)}}while(0);cQ=c[U>>2]|0;U=c[W>>2]|0;cP=cQ;while(1){if((cP|0)==(U|0)){dw=U;break}if((c[cP>>2]|0)==(Y|0)){dw=cP;break}else{cP=cP+4|0}}cP=dw-cQ>>2;dw=cQ+(cP+1<<2)|0;Y=U-dw|0;LG(cQ+(cP<<2)|0,dw|0,Y|0)|0;dw=cQ+((Y>>2)+cP<<2)|0;cP=c[W>>2]|0;if((dw|0)!=(cP|0)){c[W>>2]=cP+(~((cP-4+(-dw|0)|0)>>>2)<<2)}Lw(V);dd=ad;de=ae;df=dd;dg=0;dh=df;di=de;bg(dh|0);return 0}function t9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+48|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=f+32|0;f=cl(40)|0;k=f;l=b+28|0;L1:do{if((a[l]&1)==0){m=g;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=11}else{m=c[b+36>>2]|0;o=c[b+32>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[g]=o<<1;p=g+1|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[g+8>>2]=r;c[g>>2]=q|1;c[g+4>>2]=o;p=r}LF(p|0,m|0,o)|0;a[p+o|0]=0;n=11;break L1}}while(0);o=bT(-1,-1)|0;s=o;t=M}}while(0);do{if((n|0)==11){p=h;l=(c[e+4>>2]|0)!=0?e:b+44|0;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=d;L16:do{if((a[l]&1)==0){p=j;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];n=21}else{p=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[j]=o<<1;u=j+1|0}else{m=o+16&-16;r=(z=0,au(248,m|0)|0);if(z){z=0;break}c[j+8>>2]=r;c[j>>2]=m|1;c[j+4>>2]=o;u=r}LF(u|0,p|0,o)|0;a[u+o|0]=0;n=21;break L16}}while(0);o=bT(-1,-1)|0;v=1;w=M;x=o}}while(0);do{if((n|0)==21){z=0;aq(36,k|0,2,g|0,h|0,j|0);do{if(!z){z=0;aR(156,f|0,31448,356);if(z){z=0;y=0;break}}else{z=0;y=1}}while(0);l=bT(-1,-1)|0;o=l;l=M;if((a[j]&1)==0){v=y;w=l;x=o;break}Lw(c[j+8>>2]|0);v=y;w=l;x=o}}while(0);if((a[g]&1)==0){if(v){s=x;t=w;break}else{A=x;B=w}C=A;D=0;E=C;F=B;bg(E|0)}else{Lw(c[g+8>>2]|0);if(v){s=x;t=w;break}else{A=x;B=w}C=A;D=0;E=C;F=B;bg(E|0)}}}while(0);bo(f|0);A=s;B=t;C=A;D=0;E=C;F=B;bg(E|0)}function ua(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0;d=i;i=i+264|0;e=d|0;f=d+8|0;g=d+24|0;h=d+40|0;j=d+56|0;k=d+72|0;l=d+88|0;m=d+104|0;n=d+120|0;o=d+136|0;p=d+152|0;q=d+168|0;r=d+184|0;s=d+200|0;t=d+208|0;u=d+216|0;v=d+232|0;w=d+248|0;if((us(b)|0)==0){x=(ut(b)|0)!=0|0}else{x=0}y=b+56|0;A=c[y>>2]|0;B=b+60|0;C=(c[B>>2]|0)-A|0;if(C>>>0>4294967279>>>0){D5(0);return 0}if(C>>>0<11>>>0){D=C<<1&255;a[g]=D;E=g+1|0;F=D}else{D=C+16&-16;G=Lu(D)|0;c[g+8>>2]=G;H=D|1;c[g>>2]=H;c[g+4>>2]=C;E=G;F=H&255}LF(E|0,A|0,C)|0;a[E+C|0]=0;C=(z=0,au(138,b|0)|0);L11:do{if(!z){L13:do{if((C|0)==0){E=j;LI(E|0,0,12)|0;A=g;H=F&255;if((H&1|0)==0){I=H>>>1}else{I=c[g+4>>2]|0}H=I+16|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[E]=32;J=j+1|0}else{G=I+32&-16;D=(z=0,au(248,G|0)|0);if(z){z=0;break}c[j+8>>2]=D;c[j>>2]=G|1;c[j+4>>2]=16;J=D}LF(J|0,11296,16)|0;a[J+16|0]=0;if((F&1)==0){K=A+1|0}else{K=c[g+8>>2]|0}z=0,az(88,j|0,K|0,I|0)|0;if(z){z=0;break}D=h;LI(D|0,0,12)|0;G=a[E]|0;L=G&255;if((L&1|0)==0){N=L>>>1}else{N=c[j+4>>2]|0}if((G&1)==0){O=j+1|0}else{O=c[j+8>>2]|0}do{if((N+11|0)>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;P=40;break}return 0}else{if(N>>>0>4294967284>>>0){a[D]=N<<1;Q=h+1|0}else{G=N+27&-16;L=(z=0,au(248,G|0)|0);if(z){z=0;P=40;break}c[h+8>>2]=L;c[h>>2]=G|1;c[h+4>>2]=N;Q=L}LF(Q|0,O|0,N)|0;a[Q+N|0]=0;z=0,az(88,h|0,10880,11)|0;if(z){z=0;P=40;break}c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;z=0;aR(492,b|0,h|0,k|0);if(z){z=0;L=bT(-1,-1)|0;G=L;L=M;if((a[D]&1)==0){R=G;S=L;break}Lw(c[h+8>>2]|0);R=G;S=L;break}if((a[D]&1)!=0){Lw(c[h+8>>2]|0)}if((a[E]&1)==0){break L13}Lw(c[j+8>>2]|0);break L13}}while(0);if((P|0)==40){L=bT(-1,-1)|0;G=M;if((a[D]&1)!=0){Lw(c[h+8>>2]|0)}R=L;S=G}if((a[E]&1)==0){T=R;U=S;break L11}Lw(c[j+8>>2]|0);T=R;U=S;break L11}}while(0);A=bT(-1,-1)|0;H=M;if((a[E]&1)==0){V=H;W=A;P=48;break L11}Lw(c[j+8>>2]|0);V=H;W=A;P=48;break L11}}while(0);A=c[y>>2]|0;H=(c[B>>2]|0)-A|0;if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;P=47;break}return 0}if(H>>>0<11>>>0){a[l]=H<<1;X=l+1|0}else{G=H+16&-16;L=(z=0,au(248,G|0)|0);if(z){z=0;P=47;break}c[l+8>>2]=L;c[l>>2]=G|1;c[l+4>>2]=H;X=L}LF(X|0,A|0,H)|0;a[X+H|0]=0;H=m;A=b+44|0;c[H>>2]=c[A>>2];c[H+4>>2]=c[A+4>>2];c[H+8>>2]=c[A+8>>2];A=(z=0,au(122,b|0)|0);L78:do{if(!z){L=(z=0,au(66,c[b+20>>2]|0)|0);if(z){z=0;P=122;break}L81:do{if((L+1|0)==0|(a[L]|0)!=123){G=q;LI(G|0,0,12)|0;Y=g;Z=a[g]|0;_=Z&255;if((_&1|0)==0){$=_>>>1}else{$=c[g+4>>2]|0}_=$+9|0;do{if(_>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(_>>>0<11>>>0){a[G]=18;aa=q+1|0}else{ab=$+25&-16;ac=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[q+8>>2]=ac;c[q>>2]=ab|1;c[q+4>>2]=9;aa=ac}LF(aa|0,10664,9)|0;a[aa+9|0]=0;if((Z&1)==0){ad=Y+1|0}else{ad=c[g+8>>2]|0}z=0,az(88,q|0,ad|0,$|0)|0;if(z){z=0;break}ac=p;LI(ac|0,0,12)|0;ab=a[G]|0;ae=ab&255;if((ae&1|0)==0){af=ae>>>1}else{af=c[q+4>>2]|0}if((ab&1)==0){ag=q+1|0}else{ag=c[q+8>>2]|0}ab=af+1|0;do{if(ab>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;P=94;break}return 0}else{if(ab>>>0<11>>>0){a[ac]=af<<1;ah=p+1|0}else{ae=af+17&-16;ai=(z=0,au(248,ae|0)|0);if(z){z=0;P=94;break}c[p+8>>2]=ai;c[p>>2]=ae|1;c[p+4>>2]=af;ah=ai}LF(ah|0,ag|0,af)|0;a[ah+af|0]=0;z=0,az(88,p|0,10408,1)|0;if(z){z=0;P=94;break}z=0;aR(210,o|0,p|0,l|0);do{if(!z){ai=n;LI(ai|0,0,12)|0;ae=o;aj=a[ae]|0;ak=aj&255;if((ak&1|0)==0){al=ak>>>1}else{al=c[o+4>>2]|0}if((aj&1)==0){am=o+1|0}else{am=c[o+8>>2]|0}aj=al+22|0;do{if(aj>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;P=111;break}return 0}else{if(aj>>>0<11>>>0){a[ai]=al<<1;an=n+1|0}else{ak=al+38&-16;ao=(z=0,au(248,ak|0)|0);if(z){z=0;P=111;break}c[n+8>>2]=ao;c[n>>2]=ak|1;c[n+4>>2]=al;an=ao}LF(an|0,am|0,al)|0;a[an+al|0]=0;z=0,az(88,n|0,10200,22)|0;if(z){z=0;P=111;break}c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;z=0;aR(492,b|0,n|0,r|0);if(z){z=0;ao=bT(-1,-1)|0;ak=ao;ao=M;if((a[ai]&1)==0){ap=ak;aq=ao;break}Lw(c[n+8>>2]|0);ap=ak;aq=ao;break}if((a[ai]&1)!=0){Lw(c[n+8>>2]|0)}if((a[ae]&1)!=0){Lw(c[o+8>>2]|0)}if((a[ac]&1)!=0){Lw(c[p+8>>2]|0)}if((a[G]&1)==0){break L81}Lw(c[q+8>>2]|0);break L81}}while(0);if((P|0)==111){aj=bT(-1,-1)|0;ao=M;if((a[ai]&1)!=0){Lw(c[n+8>>2]|0)}ap=aj;aq=ao}if((a[ae]&1)==0){at=ap;av=aq;break}Lw(c[o+8>>2]|0);at=ap;av=aq}else{z=0;ao=bT(-1,-1)|0;at=ao;av=M}}while(0);if((a[ac]&1)==0){aw=at;ax=av;break}Lw(c[p+8>>2]|0);aw=at;ax=av}}while(0);if((P|0)==94){ab=bT(-1,-1)|0;ao=M;if((a[ac]&1)!=0){Lw(c[p+8>>2]|0)}aw=ab;ax=ao}if((a[G]&1)==0){ay=aw;aA=ax;break L78}Lw(c[q+8>>2]|0);ay=aw;aA=ax;break L78}}while(0);Y=bT(-1,-1)|0;Z=M;if((a[G]&1)==0){aB=Z;aC=Y;P=123;break L78}Lw(c[q+8>>2]|0);aB=Z;aC=Y;P=123;break L78}}while(0);L=b+4|0;do{if((x|0)==0){c[s>>2]=1;E=b+8|0;Y=c[E>>2]|0;if((Y|0)==(c[b+12>>2]|0)){z=0;as(72,L|0,s|0);if(!z){break}else{z=0;P=122;break L78}}if((Y|0)==0){aD=0}else{c[Y>>2]=1;aD=c[E>>2]|0}c[E>>2]=aD+4}else{c[t>>2]=2;E=b+8|0;Y=c[E>>2]|0;if((Y|0)==(c[b+12>>2]|0)){z=0;as(72,L|0,t|0);if(!z){break}else{z=0;P=122;break L78}}if((Y|0)==0){aE=0}else{c[Y>>2]=2;aE=c[E>>2]|0}c[E>>2]=aE+4}}while(0);L=(z=0,au(246,b|0)|0);if(z){z=0;P=122;break}E=b+8|0;c[E>>2]=(c[E>>2]|0)-4;E=c[b>>2]|0;Y=(z=0,au(248,76)|0);if(z){z=0;P=122;break}Z=Y;c[e>>2]=Z;Y=E+4|0;_=c[Y>>2]|0;if((_|0)==(c[E+8>>2]|0)){z=0;as(382,E|0,e|0);if(z){z=0;P=122;break}aF=c[e>>2]|0}else{if((_|0)==0){aG=0}else{c[_>>2]=Z;aG=c[Y>>2]|0}c[Y>>2]=aG+4;aF=Z}Z=aF;_=aF;D=b+28|0;L199:do{if((a[D]&1)==0){ao=u;c[ao>>2]=c[D>>2];c[ao+4>>2]=c[D+4>>2];c[ao+8>>2]=c[D+8>>2];P=164}else{ao=c[b+36>>2]|0;ab=c[b+32>>2]|0;do{if(ab>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ab>>>0<11>>>0){a[u]=ab<<1;aH=u+1|0}else{aj=ab+16&-16;ak=(z=0,au(248,aj|0)|0);if(z){z=0;break}c[u+8>>2]=ak;c[u>>2]=aj|1;c[u+4>>2]=ab;aH=ak}LF(aH|0,ao|0,ab)|0;a[aH+ab|0]=0;P=164;break L199}}while(0);ab=bT(-1,-1)|0;aJ=ab;aK=M}}while(0);do{if((P|0)==164){D=v;c[D>>2]=c[H>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];ab=l;ao=(a[ab]&1)==0;L214:do{if(ao){G=w;c[G>>2]=c[ab>>2];c[G+4>>2]=c[ab+4>>2];c[G+8>>2]=c[ab+8>>2];P=174}else{G=c[l+8>>2]|0;ak=c[l+4>>2]|0;do{if(ak>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ak>>>0<11>>>0){a[w]=ak<<1;aL=w+1|0}else{aj=ak+16&-16;aM=(z=0,au(248,aj|0)|0);if(z){z=0;break}c[w+8>>2]=aM;c[w>>2]=aj|1;c[w+4>>2]=ak;aL=aM}LF(aL|0,G|0,ak)|0;a[aL+ak|0]=0;P=174;break L214}}while(0);ak=bT(-1,-1)|0;aN=ak;aO=M}}while(0);do{if((P|0)==174){ab=f;c[ab>>2]=c[D>>2];c[ab+4>>2]=c[D+4>>2];c[ab+8>>2]=c[D+8>>2];z=0;aI(4,_|0,u|0,f|0,w|0,A|0,L|0,x|0);if(z){z=0;ab=bT(-1,-1)|0;ak=ab;ab=M;if((a[w]&1)==0){aN=ak;aO=ab;break}Lw(c[w+8>>2]|0);aN=ak;aO=ab;break}if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}if(!ao){Lw(c[l+8>>2]|0)}if((a[g]&1)==0){i=d;return _|0}Lw(c[g+8>>2]|0);i=d;return _|0}}while(0);if((a[u]&1)==0){aJ=aN;aK=aO;break}Lw(c[u+8>>2]|0);aJ=aN;aK=aO}}while(0);_=c[E>>2]|0;L=c[Y>>2]|0;ao=_;while(1){if((ao|0)==(L|0)){aP=L;break}if((c[ao>>2]|0)==(aF|0)){aP=ao;break}else{ao=ao+4|0}}ao=aP-_>>2;E=_+(ao+1<<2)|0;D=L-E|0;LG(_+(ao<<2)|0,E|0,D|0)|0;E=_+((D>>2)+ao<<2)|0;ao=c[Y>>2]|0;if((E|0)!=(ao|0)){c[Y>>2]=ao+(~((ao-4+(-E|0)|0)>>>2)<<2)}Lw(Z);ay=aJ;aA=aK}else{z=0;P=122}}while(0);if((P|0)==122){A=bT(-1,-1)|0;aB=M;aC=A;P=123}if((P|0)==123){ay=aC;aA=aB}if((a[l]&1)==0){T=ay;U=aA;break}Lw(c[l+8>>2]|0);T=ay;U=aA}else{z=0;P=47}}while(0);if((P|0)==47){aA=bT(-1,-1)|0;V=M;W=aA;P=48}if((P|0)==48){T=W;U=V}if((a[g]&1)==0){aQ=T;aS=0;aT=aQ;aU=U;bg(aT|0)}Lw(c[g+8>>2]|0);aQ=T;aS=0;aT=aQ;aU=U;bg(aT|0);return 0}function ub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0;d=i;i=i+152|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+72|0;k=d+88|0;l=d+104|0;m=d+120|0;n=d+136|0;uy(b)|0;o=b+56|0;p=c[o>>2]|0;q=(c[b+60>>2]|0)-p|0;if(q>>>0>4294967279>>>0){D5(0);return 0}if(q>>>0<11>>>0){r=q<<1&255;a[g]=r;s=g+1|0;t=r}else{r=q+16&-16;u=Lu(r)|0;c[g+8>>2]=u;v=r|1;c[g>>2]=v;c[g+4>>2]=q;s=u;t=v&255}LF(s|0,p|0,q)|0;a[s+q|0]=0;q=d+40|0;s=b+44|0;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];s=b+20|0;p=(z=0,au(66,c[s>>2]|0)|0);L8:do{if(!z){v=(a[p]|0)==58?p+1|0:0;L10:do{if((v|0)==0){u=j;LI(u|0,0,12)|0;r=g;w=t&255;if((w&1|0)==0){x=w>>>1}else{x=c[g+4>>2]|0}w=x+19|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[u]=38;y=j+1|0}else{A=x+35&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[j+8>>2]=B;c[j>>2]=A|1;c[j+4>>2]=19;y=B}LF(y|0,9656,19)|0;a[y+19|0]=0;if((t&1)==0){C=r+1|0}else{C=c[g+8>>2]|0}z=0,az(88,j|0,C|0,x|0)|0;if(z){z=0;break}B=h;LI(B|0,0,12)|0;A=a[u]|0;D=A&255;if((D&1|0)==0){E=D>>>1}else{E=c[j+4>>2]|0}if((A&1)==0){F=j+1|0}else{F=c[j+8>>2]|0}A=E+24|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;G=48;break}return 0}else{if(A>>>0<11>>>0){a[B]=E<<1;H=h+1|0}else{D=E+40&-16;I=(z=0,au(248,D|0)|0);if(z){z=0;G=48;break}c[h+8>>2]=I;c[h>>2]=D|1;c[h+4>>2]=E;H=I}LF(H|0,F|0,E)|0;a[H+E|0]=0;z=0,az(88,h|0,9544,24)|0;if(z){z=0;G=48;break}c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;z=0;aR(492,b|0,h|0,k|0);if(z){z=0;I=bT(-1,-1)|0;D=I;I=M;if((a[B]&1)==0){J=D;K=I;break}Lw(c[h+8>>2]|0);J=D;K=I;break}if((a[B]&1)!=0){Lw(c[h+8>>2]|0)}if((a[u]&1)==0){break L10}Lw(c[j+8>>2]|0);break L10}}while(0);if((G|0)==48){A=bT(-1,-1)|0;I=M;if((a[B]&1)!=0){Lw(c[h+8>>2]|0)}J=A;K=I}if((a[u]&1)==0){L=J;N=K;break L8}Lw(c[j+8>>2]|0);L=J;N=K;break L8}}while(0);r=bT(-1,-1)|0;w=M;if((a[u]&1)==0){O=w;P=r;G=56;break L8}Lw(c[j+8>>2]|0);O=w;P=r;G=56;break L8}else{r=b+48|0;w=c[r>>2]|0;I=c[s>>2]|0;L12:do{if(I>>>0<v>>>0){A=I;D=0;while(1){Q=a[A]|0;if((Q<<24>>24|0)==0){R=D;break L12}else if((Q<<24>>24|0)==10){S=D+1|0}else{S=D}Q=A+1|0;if(Q>>>0<v>>>0){A=Q;D=S}else{R=S;break}}}else{R=0}}while(0);c[r>>2]=R+w;u=p;D=0;while(1){A=u-1|0;if(A>>>0<I>>>0){break}if((a[A]|0)==10){break}else{u=A;D=D+1|0}}u=b+40|0;if((R|0)!=0){c[u>>2]=1}I=c[u>>2]|0;c[b+52>>2]=I+D;w=v;r=p;c[u>>2]=w-r+D+I;I=o;c[I>>2]=r;c[I+4>>2]=w;c[s>>2]=v}}while(0);v=(z=0,au(168,b|0)|0);if(z){z=0;G=55;break}a[v+28|0]=0;w=(z=0,au(232,b|0)|0);if(z){z=0;G=55;break}I=(w|0)!=0;w=c[b>>2]|0;r=(z=0,au(248,48)|0);if(z){z=0;G=55;break}u=r;c[f>>2]=u;r=w+4|0;A=c[r>>2]|0;if((A|0)==(c[w+8>>2]|0)){z=0;as(382,w|0,f|0);if(z){z=0;G=55;break}T=c[f>>2]|0}else{if((A|0)==0){U=0}else{c[A>>2]=u;U=c[r>>2]|0}c[r>>2]=U+4;T=u}u=T;A=T;B=b+28|0;L92:do{if((a[B]&1)==0){Q=l;c[Q>>2]=c[B>>2];c[Q+4>>2]=c[B+4>>2];c[Q+8>>2]=c[B+8>>2];G=81}else{Q=c[b+36>>2]|0;V=c[b+32>>2]|0;do{if(V>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(V>>>0<11>>>0){a[l]=V<<1;W=l+1|0}else{X=V+16&-16;Y=(z=0,au(248,X|0)|0);if(z){z=0;break}c[l+8>>2]=Y;c[l>>2]=X|1;c[l+4>>2]=V;W=Y}LF(W|0,Q|0,V)|0;a[W+V|0]=0;G=81;break L92}}while(0);V=bT(-1,-1)|0;Z=V;_=M}}while(0);do{if((G|0)==81){B=m;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2];V=g;Q=(a[V]&1)==0;L107:do{if(Q){D=n;c[D>>2]=c[V>>2];c[D+4>>2]=c[V+4>>2];c[D+8>>2]=c[V+8>>2];G=91}else{D=c[g+8>>2]|0;Y=c[g+4>>2]|0;do{if(Y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Y>>>0<11>>>0){a[n]=Y<<1;$=n+1|0}else{X=Y+16&-16;aa=(z=0,au(248,X|0)|0);if(z){z=0;break}c[n+8>>2]=aa;c[n>>2]=X|1;c[n+4>>2]=Y;$=aa}LF($|0,D|0,Y)|0;a[$+Y|0]=0;G=91;break L107}}while(0);Y=bT(-1,-1)|0;ab=Y;ac=M}}while(0);do{if((G|0)==91){V=e;c[V>>2]=c[B>>2];c[V+4>>2]=c[B+4>>2];c[V+8>>2]=c[B+8>>2];z=0;aD(18,A|0,l|0,e|0,n|0,v|0,I|0);if(z){z=0;V=bT(-1,-1)|0;Y=V;V=M;if((a[n]&1)==0){ab=Y;ac=V;break}Lw(c[n+8>>2]|0);ab=Y;ac=V;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}if(Q){i=d;return A|0}Lw(c[g+8>>2]|0);i=d;return A|0}}while(0);if((a[l]&1)==0){Z=ab;_=ac;break}Lw(c[l+8>>2]|0);Z=ab;_=ac}}while(0);A=c[w>>2]|0;I=c[r>>2]|0;v=A;while(1){if((v|0)==(I|0)){ad=I;break}if((c[v>>2]|0)==(T|0)){ad=v;break}else{v=v+4|0}}v=ad-A>>2;w=A+(v+1<<2)|0;Q=I-w|0;LG(A+(v<<2)|0,w|0,Q|0)|0;w=A+((Q>>2)+v<<2)|0;v=c[r>>2]|0;if((w|0)!=(v|0)){c[r>>2]=v+(~((v-4+(-w|0)|0)>>>2)<<2)}Lw(u);L=Z;N=_}else{z=0;G=55}}while(0);if((G|0)==55){_=bT(-1,-1)|0;O=M;P=_;G=56}if((G|0)==56){L=P;N=O}if((a[g]&1)==0){ae=L;af=0;ag=ae;ah=N;bg(ag|0)}Lw(c[g+8>>2]|0);ae=L;af=0;ag=ae;ah=N;bg(ag|0);return 0}function uc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=i;i=i+112|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=d+96|0;n=b+20|0;o=y$(c[n>>2]|0)|0;p=(a[o]|0)==42?o+1|0:0;q=(p|0)!=0?p:o;do{if((q|0)==0){r=4}else{if((y1(q)|0)==0){r=4;break}s=uF(b)|0;t=b|0}}while(0);L4:do{if((r|0)==4){uG(b)|0;q=b|0;o=c[q>>2]|0;p=Lu(52)|0;c[g>>2]=p;u=o+4|0;v=c[u>>2]|0;if((v|0)==(c[o+8>>2]|0)){e4(o|0,g);w=c[g>>2]|0}else{if((v|0)==0){x=0}else{c[v>>2]=p;x=c[u>>2]|0}c[u>>2]=x+4;w=p}p=w;v=b+28|0;L13:do{if((a[v]&1)==0){y=h;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];r=19}else{y=c[b+36>>2]|0;A=c[b+32>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){a[h]=A<<1;B=h+1|0}else{C=A+16&-16;D=(z=0,au(248,C|0)|0);if(z){z=0;break}c[h+8>>2]=D;c[h>>2]=C|1;c[h+4>>2]=A;B=D}LF(B|0,y|0,A)|0;a[B+A|0]=0;r=19;break L13}}while(0);A=bT(-1,-1)|0;E=M;F=A}}while(0);do{if((r|0)==19){v=b+44|0;A=f;c[A>>2]=c[v>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];z=0;aq(14,w|0,h|0,f|0,b+56|0,0);if(!z){v=w;if((a[h]&1)==0){s=v;t=q;break L4}Lw(c[h+8>>2]|0);s=v;t=q;break L4}else{z=0;v=bT(-1,-1)|0;A=v;v=M;if((a[h]&1)==0){E=v;F=A;break}Lw(c[h+8>>2]|0);E=v;F=A;break}}}while(0);q=c[o>>2]|0;A=c[u>>2]|0;v=q;while(1){if((v|0)==(A|0)){G=A;break}if((c[v>>2]|0)==(w|0)){G=v;break}else{v=v+4|0}}v=G-q>>2;o=q+(v+1<<2)|0;y=A-o|0;LG(q+(v<<2)|0,o|0,y|0)|0;o=q+((y>>2)+v<<2)|0;v=c[u>>2]|0;if((o|0)!=(v|0)){c[u>>2]=v+(~((v-4+(-o|0)|0)>>>2)<<2)}Lw(p);H=E;I=F;J=I;K=0;L=J;N=H;bg(L|0)}}while(0);F=c[t>>2]|0;t=Lu(36)|0;c[e>>2]=t;E=F+4|0;G=c[E>>2]|0;if((G|0)==(c[F+8>>2]|0)){e4(F|0,e);O=c[e>>2]|0}else{if((G|0)==0){P=0}else{c[G>>2]=t;P=c[E>>2]|0}c[E>>2]=P+4;O=t}t=O;P=O;G=b+28|0;L50:do{if((a[G]&1)==0){e=j;c[e>>2]=c[G>>2];c[e+4>>2]=c[G+4>>2];c[e+8>>2]=c[G+8>>2];r=46}else{e=c[b+36>>2]|0;w=c[b+32>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[j]=w<<1;Q=j+1|0}else{h=w+16&-16;f=(z=0,au(248,h|0)|0);if(z){z=0;break}c[j+8>>2]=f;c[j>>2]=h|1;c[j+4>>2]=w;Q=f}LF(Q|0,e|0,w)|0;a[Q+w|0]=0;r=46;break L50}}while(0);w=bT(-1,-1)|0;R=M;S=w}}while(0);do{if((r|0)==46){Q=k;G=b+44|0;c[Q>>2]=c[G>>2];c[Q+4>>2]=c[G+4>>2];c[Q+8>>2]=c[G+8>>2];z=0;aq(12,P|0,j|0,k|0,s|0,0);if(z){z=0;G=bT(-1,-1)|0;Q=G;G=M;if((a[j]&1)==0){R=G;S=Q;break}Lw(c[j+8>>2]|0);R=G;S=Q;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}Q=y$(c[n>>2]|0)|0;G=(a[Q]|0)==58?Q+1|0:0;if((G|0)==0){T=c[n>>2]|0}else{w=b+48|0;e=c[w>>2]|0;p=c[n>>2]|0;L74:do{if(p>>>0<G>>>0){u=p;q=0;while(1){A=a[u]|0;if((A<<24>>24|0)==0){U=q;break L74}else if((A<<24>>24|0)==10){V=q+1|0}else{V=q}A=u+1|0;if(A>>>0<G>>>0){u=A;q=V}else{U=V;break}}}else{U=0}}while(0);c[w>>2]=U+e;q=Q;u=0;while(1){A=q-1|0;if(A>>>0<p>>>0){break}if((a[A]|0)==10){break}else{q=A;u=u+1|0}}q=b+40|0;if((U|0)!=0){c[q>>2]=1}p=c[q>>2]|0;c[b+52>>2]=p+u;e=G;w=Q;c[q>>2]=e-w+u+p;p=b+56|0;c[p>>2]=w;c[p+4>>2]=e;c[n>>2]=G;T=G}e=y$(T)|0;if(!((e+1|0)==0|(a[e]|0)!=123)){W=uw(b)|0;X=O+28|0;Y=W;c[X>>2]=Y;i=d;return P|0}e=Lu(48)|0;p=l+8|0;c[p>>2]=e;c[l>>2]=49;c[l+4>>2]=40;LF(e|0,9352,40)|0;a[e+40|0]=0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;z=0;aR(492,b|0,l|0,m|0);if(!z){if((a[l]&1)==0){W=uw(b)|0;X=O+28|0;Y=W;c[X>>2]=Y;i=d;return P|0}Lw(c[p>>2]|0);W=uw(b)|0;X=O+28|0;Y=W;c[X>>2]=Y;i=d;return P|0}else{z=0;e=bT(-1,-1)|0;w=e;e=M;if((a[l]&1)==0){H=e;I=w;J=I;K=0;L=J;N=H;bg(L|0)}Lw(c[p>>2]|0);H=e;I=w;J=I;K=0;L=J;N=H;bg(L|0)}}}while(0);l=c[F>>2]|0;F=c[E>>2]|0;P=l;while(1){if((P|0)==(F|0)){Z=F;break}if((c[P>>2]|0)==(O|0)){Z=P;break}else{P=P+4|0}}P=Z-l>>2;Z=l+(P+1<<2)|0;O=F-Z|0;LG(l+(P<<2)|0,Z|0,O|0)|0;Z=l+((O>>2)+P<<2)|0;P=c[E>>2]|0;if((Z|0)!=(P|0)){c[E>>2]=P+(~((P-4+(-Z|0)|0)>>>2)<<2)}Lw(t);H=R;I=S;J=I;K=0;L=J;N=H;bg(L|0);return 0}function ud(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0;d=i;i=i+136|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+56|0;k=d+72|0;l=d+88|0;m=d+104|0;n=d+120|0;uB(b)|0;do{if((uu(b)|0)==0){o=Lu(48)|0;p=g+8|0;c[p>>2]=o;c[g>>2]=49;c[g+4>>2]=34;LF(o|0,9760,34)|0;a[o+34|0]=0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;z=0;aR(492,b|0,g|0,h|0);if(!z){if((a[g]&1)==0){break}Lw(c[p>>2]|0);break}else{z=0}o=bT(-1,-1)|0;q=o;o=M;if((a[g]&1)==0){r=q;s=o;t=r;u=0;v=t;w=s;bg(v|0)}Lw(c[p>>2]|0);r=q;s=o;t=r;u=0;v=t;w=s;bg(v|0)}}while(0);g=j;j=b+44|0;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=c[b+56>>2]|0;h=(c[b+60>>2]|0)-j|0;if(h>>>0>4294967279>>>0){D5(0);return 0}if(h>>>0<11>>>0){o=h<<1&255;a[k]=o;x=k+1|0;y=o}else{o=h+16&-16;q=Lu(o)|0;c[k+8>>2]=q;p=o|1;c[k>>2]=p;c[k+4>>2]=h;x=q;y=p&255}LF(x|0,j|0,h)|0;a[x+h|0]=0;h=(z=0,au(92,b|0)|0);do{if(!z){x=(z=0,au(66,c[b+20>>2]|0)|0);if(z){z=0;A=16;break}if((x+1|0)==0|(a[x]|0)!=123){B=0}else{x=(z=0,au(246,b|0)|0);if(!z){B=x}else{z=0;A=16;break}}x=c[b>>2]|0;j=(z=0,au(248,48)|0);if(z){z=0;A=16;break}p=j;c[f>>2]=p;j=x+4|0;q=c[j>>2]|0;if((q|0)==(c[x+8>>2]|0)){z=0;as(382,x|0,f|0);if(z){z=0;A=16;break}C=c[f>>2]|0}else{if((q|0)==0){D=0}else{c[q>>2]=p;D=c[j>>2]|0}c[j>>2]=D+4;C=p}p=C;q=C;o=b+28|0;L34:do{if((a[o]&1)==0){E=l;c[E>>2]=c[o>>2];c[E+4>>2]=c[o+4>>2];c[E+8>>2]=c[o+8>>2];A=34}else{E=c[b+36>>2]|0;F=c[b+32>>2]|0;do{if(F>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(F>>>0<11>>>0){a[l]=F<<1;G=l+1|0}else{H=F+16&-16;I=(z=0,au(248,H|0)|0);if(z){z=0;break}c[l+8>>2]=I;c[l>>2]=H|1;c[l+4>>2]=F;G=I}LF(G|0,E|0,F)|0;a[G+F|0]=0;A=34;break L34}}while(0);F=bT(-1,-1)|0;J=F;K=M}}while(0);do{if((A|0)==34){o=m;c[o>>2]=c[g>>2];c[o+4>>2]=c[g+4>>2];c[o+8>>2]=c[g+8>>2];L49:do{if((y&1)==0){F=k;E=n;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];A=44}else{F=c[k+8>>2]|0;E=c[k+4>>2]|0;do{if(E>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(E>>>0<11>>>0){a[n]=E<<1;L=n+1|0}else{I=E+16&-16;H=(z=0,au(248,I|0)|0);if(z){z=0;break}c[n+8>>2]=H;c[n>>2]=I|1;c[n+4>>2]=E;L=H}LF(L|0,F|0,E)|0;a[L+E|0]=0;A=44;break L49}}while(0);E=bT(-1,-1)|0;N=E;O=M}}while(0);do{if((A|0)==44){E=e;c[E>>2]=c[o>>2];c[E+4>>2]=c[o+4>>2];c[E+8>>2]=c[o+8>>2];z=0;aD(40,q|0,l|0,e|0,n|0,h|0,B|0);if(z){z=0;E=bT(-1,-1)|0;F=E;E=M;if((a[n]&1)==0){N=F;O=E;break}Lw(c[n+8>>2]|0);N=F;O=E;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}if((y&1)==0){i=d;return q|0}Lw(c[k+8>>2]|0);i=d;return q|0}}while(0);if((a[l]&1)==0){J=N;K=O;break}Lw(c[l+8>>2]|0);J=N;K=O}}while(0);q=c[x>>2]|0;o=c[j>>2]|0;E=q;while(1){if((E|0)==(o|0)){P=o;break}if((c[E>>2]|0)==(C|0)){P=E;break}else{E=E+4|0}}E=P-q>>2;x=q+(E+1<<2)|0;F=o-x|0;LG(q+(E<<2)|0,x|0,F|0)|0;x=q+((F>>2)+E<<2)|0;E=c[j>>2]|0;if((x|0)!=(E|0)){c[j>>2]=E+(~((E-4+(-x|0)|0)>>>2)<<2)}Lw(p);Q=J;R=K}else{z=0;A=16}}while(0);if((A|0)==16){A=bT(-1,-1)|0;Q=A;R=M}if((y&1)==0){r=Q;s=R;t=r;u=0;v=t;w=s;bg(v|0)}Lw(c[k+8>>2]|0);r=Q;s=R;t=r;u=0;v=t;w=s;bg(v|0);return 0}function ue(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0;e=i;i=i+200|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+64|0;m=e+80|0;n=e+104|0;o=e+120|0;p=e+136|0;q=e+152|0;r=e+168|0;s=e+184|0;if(!((vT(b)|0)!=0|d^1)){vU(b)|0}d=e+88|0;t=b+44|0;c[d>>2]=c[t>>2];c[d+4>>2]=c[t+4>>2];c[d+8>>2]=c[t+8>>2];u=vd(b)|0;a[u+28|0]=0;v=b+20|0;w=y$(c[v>>2]|0)|0;do{if((w+1|0)==0|(a[w]|0)!=123){x=Lu(48)|0;y=n+8|0;c[y>>2]=x;c[n>>2]=49;c[n+4>>2]=40;LF(x|0,3920,40)|0;a[x+40|0]=0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;z=0;aR(492,b|0,n|0,o|0);if(!z){if((a[n]&1)==0){break}Lw(c[y>>2]|0);break}else{z=0}x=bT(-1,-1)|0;A=x;x=M;if((a[n]&1)==0){B=A;C=x;D=B;E=0;F=D;G=C;bg(F|0)}Lw(c[y>>2]|0);B=A;C=x;D=B;E=0;F=D;G=C;bg(F|0)}}while(0);n=uw(b)|0;L15:do{if((vV(b)|0)==0){H=0}else{o=y$(c[v>>2]|0)|0;w=a[36920]|0;L17:do{if(w<<24>>24==0){I=o;J=13}else{x=o;A=36920;y=w;while(1){if((a[x]|0)!=y<<24>>24){break L17}K=x+1|0;L=A+1|0;N=a[L]|0;if(N<<24>>24==0){I=K;J=13;break}else{x=K;A=L;y=N}}}}while(0);do{if((J|0)==13){if((I|0)==0){break}w=c[b>>2]|0;o=Lu(48)|0;c[m>>2]=o;y=w+4|0;A=c[y>>2]|0;if((A|0)==(c[w+8>>2]|0)){e4(w|0,m);O=c[m>>2]|0}else{if((A|0)==0){P=0}else{c[A>>2]=o;P=c[y>>2]|0}c[y>>2]=P+4;O=o}o=O;A=O;x=b+28|0;L31:do{if((a[x]&1)==0){N=p;c[N>>2]=c[x>>2];c[N+4>>2]=c[x+4>>2];c[N+8>>2]=c[x+8>>2];J=29}else{N=c[b+36>>2]|0;L=c[b+32>>2]|0;do{if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(L>>>0<11>>>0){a[p]=L<<1;Q=p+1|0}else{K=L+16&-16;R=(z=0,au(248,K|0)|0);if(z){z=0;break}c[p+8>>2]=R;c[p>>2]=K|1;c[p+4>>2]=L;Q=R}LF(Q|0,N|0,L)|0;a[Q+L|0]=0;J=29;break L31}}while(0);L=bT(-1,-1)|0;S=L;T=M}}while(0);do{if((J|0)==29){x=l;c[x>>2]=c[t>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];z=0;aq(4,A|0,p|0,l|0,0,0);if(z){z=0;x=bT(-1,-1)|0;L=x;x=M;if((a[p]&1)==0){S=L;T=x;break}Lw(c[p+8>>2]|0);S=L;T=x;break}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}x=O+28|0;L=x;N=ue(b,1)|0;c[k>>2]=N;R=O+36|0;K=R;U=c[K>>2]|0;if((U|0)==(c[O+40>>2]|0)){m3(O+32|0,k);V=c[k>>2]|0}else{if((U|0)==0){W=0}else{c[U>>2]=N;W=c[K>>2]|0}c[R>>2]=W+4;V=N}cB[c[c[x>>2]>>2]&1023](L,V);H=A;break L15}}while(0);A=c[w>>2]|0;L=c[y>>2]|0;x=A;while(1){if((x|0)==(L|0)){X=L;break}if((c[x>>2]|0)==(O|0)){X=x;break}else{x=x+4|0}}x=X-A>>2;w=A+(x+1<<2)|0;N=L-w|0;LG(A+(x<<2)|0,w|0,N|0)|0;w=A+((N>>2)+x<<2)|0;x=c[y>>2]|0;if((w|0)!=(x|0)){c[y>>2]=x+(~((x-4+(-w|0)|0)>>>2)<<2)}Lw(o);B=S;C=T;D=B;E=0;F=D;G=C;bg(F|0)}}while(0);w=y$(c[v>>2]|0)|0;if(!((w+1|0)==0|(a[w]|0)!=123)){H=uw(b)|0;break}w=Lu(32)|0;x=q+8|0;c[x>>2]=w;c[q>>2]=33;c[q+4>>2]=24;LF(w|0,3800,24)|0;a[w+24|0]=0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;z=0;aR(492,b|0,q|0,r|0);if(!z){if((a[q]&1)==0){H=0;break}Lw(c[x>>2]|0);H=0;break}else{z=0}w=bT(-1,-1)|0;N=w;w=M;if((a[q]&1)==0){B=N;C=w;D=B;E=0;F=D;G=C;bg(F|0)}Lw(c[x>>2]|0);B=N;C=w;D=B;E=0;F=D;G=C;bg(F|0)}}while(0);q=c[b>>2]|0;r=Lu(40)|0;c[j>>2]=r;v=q+4|0;T=c[v>>2]|0;if((T|0)==(c[q+8>>2]|0)){e4(q|0,j);Y=c[j>>2]|0}else{if((T|0)==0){Z=0}else{c[T>>2]=r;Z=c[v>>2]|0}c[v>>2]=Z+4;Y=r}r=Y;Z=Y;T=b+28|0;L89:do{if((a[T]&1)==0){j=s;c[j>>2]=c[T>>2];c[j+4>>2]=c[T+4>>2];c[j+8>>2]=c[T+8>>2];_=a[j]|0;$=j;J=69}else{j=c[b+36>>2]|0;S=c[b+32>>2]|0;do{if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(S>>>0<11>>>0){X=S<<1&255;O=s;a[O]=X;aa=s+1|0;ab=X;ac=O}else{O=S+16&-16;X=(z=0,au(248,O|0)|0);if(z){z=0;break}c[s+8>>2]=X;V=O|1;c[s>>2]=V;c[s+4>>2]=S;aa=X;ab=V&255;ac=s}LF(aa|0,j|0,S)|0;a[aa+S|0]=0;_=ab;$=ac;J=69;break L89}}while(0);S=bT(-1,-1)|0;ad=S;ae=M}}while(0);do{if((J|0)==69){ac=h;c[ac>>2]=c[d>>2];c[ac+4>>2]=c[d+4>>2];c[ac+8>>2]=c[d+8>>2];ac=h;ab=f;aa=g;b=Y;L104:do{if((_&1)==0){c[ab>>2]=c[$>>2];c[ab+4>>2]=c[$+4>>2];c[ab+8>>2]=c[$+8>>2];J=79}else{T=c[s+8>>2]|0;S=c[s+4>>2]|0;do{if(S>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(S>>>0<11>>>0){a[ab]=S<<1;af=f+1|0}else{j=S+16&-16;V=(z=0,au(248,j|0)|0);if(z){z=0;break}c[f+8>>2]=V;c[f>>2]=j|1;c[f+4>>2]=S;af=V}LF(af|0,T|0,S)|0;a[af+S|0]=0;J=79;break L104}}while(0);S=bT(-1,-1)|0;ag=M;ah=S}}while(0);do{if((J|0)==79){c[aa>>2]=c[ac>>2];c[aa+4>>2]=c[ac+4>>2];c[aa+8>>2]=c[ac+8>>2];z=0;aR(424,b|0,f|0,g|0);if(z){z=0;S=bT(-1,-1)|0;T=M;if((a[ab]&1)==0){ag=T;ah=S;break}Lw(c[f+8>>2]|0);ag=T;ah=S;break}if((a[ab]&1)!=0){Lw(c[f+8>>2]|0)}c[Y>>2]=20040;c[Y+28>>2]=u;c[Y+32>>2]=n;c[Y+36>>2]=H;if((a[$]&1)==0){i=e;return Z|0}Lw(c[s+8>>2]|0);i=e;return Z|0}}while(0);ab=ah;b=ag;if((a[$]&1)==0){ad=ab;ae=b;break}Lw(c[s+8>>2]|0);ad=ab;ae=b}}while(0);s=c[q>>2]|0;q=c[v>>2]|0;$=s;while(1){if(($|0)==(q|0)){ai=q;break}if((c[$>>2]|0)==(Y|0)){ai=$;break}else{$=$+4|0}}$=ai-s>>2;ai=s+($+1<<2)|0;Y=q-ai|0;LG(s+($<<2)|0,ai|0,Y|0)|0;ai=s+((Y>>2)+$<<2)|0;$=c[v>>2]|0;if((ai|0)!=($|0)){c[v>>2]=$+(~(($-4+(-ai|0)|0)>>>2)<<2)}Lw(r);B=ad;C=ae;D=B;E=0;F=D;G=C;bg(F|0);return 0}function uf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+232|0;e=d|0;f=d+16|0;g=d+40|0;h=d+56|0;j=d+72|0;k=d+88|0;l=d+104|0;m=d+120|0;n=d+136|0;o=d+152|0;p=d+168|0;q=d+184|0;r=d+200|0;s=d+216|0;vW(b)|0;t=d+24|0;u=b+44|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];do{if((uy(b)|0)==0){u=Lu(48)|0;v=g+8|0;c[v>>2]=u;c[g>>2]=49;c[g+4>>2]=45;LF(u|0,3680,45)|0;a[u+45|0]=0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;z=0;aR(492,b|0,g|0,h|0);if(!z){if((a[g]&1)==0){break}Lw(c[v>>2]|0);break}else{z=0}u=bT(-1,-1)|0;w=u;u=M;if((a[g]&1)==0){x=w;y=u;A=x;B=0;C=A;D=y;bg(C|0)}Lw(c[v>>2]|0);x=w;y=u;A=x;B=0;C=A;D=y;bg(C|0)}}while(0);g=c[b+56>>2]|0;h=(c[b+60>>2]|0)-g|0;if(h>>>0>4294967279>>>0){D5(0);return 0}if(h>>>0<11>>>0){u=h<<1&255;a[j]=u;E=j+1|0;F=u}else{u=h+16&-16;w=Lu(u)|0;c[j+8>>2]=w;v=u|1;c[j>>2]=v;c[j+4>>2]=h;E=w;F=v&255}LF(E|0,g|0,h)|0;a[E+h|0]=0;h=(z=0,au(198,b|0)|0);L19:do{if(!z){do{if((h|0)==0){E=(z=0,au(248,48)|0);if(z){z=0;G=18;break L19}g=k+8|0;c[g>>2]=E;c[k>>2]=49;c[k+4>>2]=41;LF(E|0,3568,41)|0;a[E+41|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z=0;aR(492,b|0,k|0,l|0);if(!z){if((a[k]&1)==0){break}Lw(c[g>>2]|0);break}else{z=0;E=bT(-1,-1)|0;v=E;E=M;if((a[k]&1)==0){H=v;I=E;break L19}Lw(c[g>>2]|0);H=v;I=E;break L19}}}while(0);E=(z=0,au(202,b|0)|0);if(z){z=0;G=18;break}a[E+28|0]=0;v=(z=0,au(288,b|0)|0);if(z){z=0;G=18;break}do{if((v|0)==0){g=(z=0,au(194,b|0)|0);if(z){z=0;G=18;break L19}if((g|0)!=0){J=0;break}g=(z=0,au(248,64)|0);if(z){z=0;G=18;break L19}w=m+8|0;c[w>>2]=g;c[m>>2]=65;c[m+4>>2]=51;LF(g|0,3440,51)|0;a[g+51|0]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;z=0;aR(492,b|0,m|0,n|0);if(!z){if((a[m]&1)==0){J=0;break}Lw(c[w>>2]|0);J=0;break}else{z=0;g=bT(-1,-1)|0;u=g;g=M;if((a[m]&1)==0){H=u;I=g;break L19}Lw(c[w>>2]|0);H=u;I=g;break L19}}else{J=1}}while(0);v=(z=0,au(202,b|0)|0);if(z){z=0;G=18;break}a[v+28|0]=0;g=(z=0,au(66,c[b+20>>2]|0)|0);if(z){z=0;G=18;break}do{if((g+1|0)==0|(a[g]|0)!=123){u=(z=0,au(248,64)|0);if(z){z=0;G=18;break L19}w=o+8|0;c[w>>2]=u;c[o>>2]=65;c[o+4>>2]=52;LF(u|0,3288,52)|0;a[u+52|0]=0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;z=0;aR(492,b|0,o|0,p|0);if(!z){if((a[o]&1)==0){break}Lw(c[w>>2]|0);break}else{z=0;u=bT(-1,-1)|0;K=u;u=M;if((a[o]&1)==0){H=K;I=u;break L19}Lw(c[w>>2]|0);H=K;I=u;break L19}}}while(0);g=(z=0,au(246,b|0)|0);if(z){z=0;G=18;break}u=c[b>>2]|0;K=(z=0,au(248,56)|0);if(z){z=0;G=18;break}w=K;c[f>>2]=w;K=u+4|0;L=c[K>>2]|0;if((L|0)==(c[u+8>>2]|0)){z=0;as(382,u|0,f|0);if(z){z=0;G=18;break}N=c[f>>2]|0}else{if((L|0)==0){O=0}else{c[L>>2]=w;O=c[K>>2]|0}c[K>>2]=O+4;N=w}w=N;L=N;P=b+28|0;L64:do{if((a[P]&1)==0){Q=q;c[Q>>2]=c[P>>2];c[Q+4>>2]=c[P+4>>2];c[Q+8>>2]=c[P+8>>2];G=59}else{Q=c[b+36>>2]|0;R=c[b+32>>2]|0;do{if(R>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(R>>>0<11>>>0){a[q]=R<<1;S=q+1|0}else{T=R+16&-16;U=(z=0,au(248,T|0)|0);if(z){z=0;break}c[q+8>>2]=U;c[q>>2]=T|1;c[q+4>>2]=R;S=U}LF(S|0,Q|0,R)|0;a[S+R|0]=0;G=59;break L64}}while(0);R=bT(-1,-1)|0;V=R;W=M}}while(0);do{if((G|0)==59){P=r;c[P>>2]=c[t>>2];c[P+4>>2]=c[t+4>>2];c[P+8>>2]=c[t+8>>2];L79:do{if((F&1)==0){R=j;Q=s;c[Q>>2]=c[R>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];G=69}else{R=c[j+8>>2]|0;Q=c[j+4>>2]|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Q>>>0<11>>>0){a[s]=Q<<1;X=s+1|0}else{U=Q+16&-16;T=(z=0,au(248,U|0)|0);if(z){z=0;break}c[s+8>>2]=T;c[s>>2]=U|1;c[s+4>>2]=Q;X=T}LF(X|0,R|0,Q)|0;a[X+Q|0]=0;G=69;break L79}}while(0);Q=bT(-1,-1)|0;Y=Q;Z=M}}while(0);do{if((G|0)==69){Q=e;c[Q>>2]=c[P>>2];c[Q+4>>2]=c[P+4>>2];c[Q+8>>2]=c[P+8>>2];z=0;aC(4,L|0,q|0,e|0,s|0,E|0,v|0,g|0,J|0);if(z){z=0;Q=bT(-1,-1)|0;R=Q;Q=M;if((a[s]&1)==0){Y=R;Z=Q;break}Lw(c[s+8>>2]|0);Y=R;Z=Q;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((F&1)==0){i=d;return L|0}Lw(c[j+8>>2]|0);i=d;return L|0}}while(0);if((a[q]&1)==0){V=Y;W=Z;break}Lw(c[q+8>>2]|0);V=Y;W=Z}}while(0);L=c[u>>2]|0;g=c[K>>2]|0;v=L;while(1){if((v|0)==(g|0)){_=g;break}if((c[v>>2]|0)==(N|0)){_=v;break}else{v=v+4|0}}v=_-L>>2;u=L+(v+1<<2)|0;E=g-u|0;LG(L+(v<<2)|0,u|0,E|0)|0;u=L+((E>>2)+v<<2)|0;v=c[K>>2]|0;if((u|0)!=(v|0)){c[K>>2]=v+(~((v-4+(-u|0)|0)>>>2)<<2)}Lw(w);H=V;I=W}else{z=0;G=18}}while(0);if((G|0)==18){G=bT(-1,-1)|0;H=G;I=M}if((F&1)==0){x=H;y=I;A=x;B=0;C=A;D=y;bg(C|0)}Lw(c[j+8>>2]|0);x=H;y=I;A=x;B=0;C=A;D=y;bg(C|0);return 0}function ug(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+200|0;e=d|0;f=d+16|0;g=d+40|0;h=d+56|0;j=d+72|0;k=d+88|0;l=d+104|0;m=d+120|0;n=d+136|0;o=d+152|0;p=d+168|0;q=d+184|0;v_(b)|0;r=d+24|0;s=b+44|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];do{if((uy(b)|0)==0){s=Lu(48)|0;t=g+8|0;c[t>>2]=s;c[g>>2]=49;c[g+4>>2]=46;LF(s|0,3136,46)|0;a[s+46|0]=0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;z=0;aR(492,b|0,g|0,h|0);if(!z){if((a[g]&1)==0){break}Lw(c[t>>2]|0);break}else{z=0}s=bT(-1,-1)|0;u=s;s=M;if((a[g]&1)==0){v=u;w=s;x=v;y=0;A=x;B=w;bg(A|0)}Lw(c[t>>2]|0);v=u;w=s;x=v;y=0;A=x;B=w;bg(A|0)}}while(0);g=c[b+56>>2]|0;h=(c[b+60>>2]|0)-g|0;if(h>>>0>4294967279>>>0){D5(0);return 0}if(h>>>0<11>>>0){s=h<<1&255;a[j]=s;C=j+1|0;D=s}else{s=h+16&-16;u=Lu(s)|0;c[j+8>>2]=u;t=s|1;c[j>>2]=t;c[j+4>>2]=h;C=u;D=t&255}LF(C|0,g|0,h)|0;a[C+h|0]=0;h=(z=0,au(270,b|0)|0);L19:do{if(!z){do{if((h|0)==0){C=(z=0,au(248,48)|0);if(z){z=0;E=18;break L19}g=k+8|0;c[g>>2]=C;c[k>>2]=49;c[k+4>>2]=40;LF(C|0,3e3,40)|0;a[C+40|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z=0;aR(492,b|0,k|0,l|0);if(!z){if((a[k]&1)==0){break}Lw(c[g>>2]|0);break}else{z=0;C=bT(-1,-1)|0;t=C;C=M;if((a[k]&1)==0){F=t;G=C;break L19}Lw(c[g>>2]|0);F=t;G=C;break L19}}}while(0);C=(z=0,au(168,b|0)|0);if(z){z=0;E=18;break}a[C+28|0]=0;L31:do{if((c[C+32>>2]|0)==5){t=C+40|0;g=c[t>>2]|0;u=(c[C+44>>2]|0)-g>>2;if((u|0)==0){break}else{H=0;I=g}while(1){a[(c[I+(H<<2)>>2]|0)+28|0]=0;g=H+1|0;if(g>>>0>=u>>>0){break L31}H=g;I=c[t>>2]|0}}}while(0);t=(z=0,au(66,c[b+20>>2]|0)|0);if(z){z=0;E=18;break}do{if((t+1|0)==0|(a[t]|0)!=123){u=(z=0,au(248,64)|0);if(z){z=0;E=18;break L19}g=m+8|0;c[g>>2]=u;c[m>>2]=65;c[m+4>>2]=53;LF(u|0,2880,53)|0;a[u+53|0]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;z=0;aR(492,b|0,m|0,n|0);if(!z){if((a[m]&1)==0){break}Lw(c[g>>2]|0);break}else{z=0;u=bT(-1,-1)|0;s=u;u=M;if((a[m]&1)==0){F=s;G=u;break L19}Lw(c[g>>2]|0);F=s;G=u;break L19}}}while(0);t=(z=0,au(246,b|0)|0);if(z){z=0;E=18;break}u=c[b>>2]|0;s=(z=0,au(248,48)|0);if(z){z=0;E=18;break}g=s;c[f>>2]=g;s=u+4|0;J=c[s>>2]|0;if((J|0)==(c[u+8>>2]|0)){z=0;as(382,u|0,f|0);if(z){z=0;E=18;break}K=c[f>>2]|0}else{if((J|0)==0){L=0}else{c[J>>2]=g;L=c[s>>2]|0}c[s>>2]=L+4;K=g}g=K;J=K;N=b+28|0;L57:do{if((a[N]&1)==0){O=o;c[O>>2]=c[N>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];E=52}else{O=c[b+36>>2]|0;P=c[b+32>>2]|0;do{if(P>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(P>>>0<11>>>0){a[o]=P<<1;Q=o+1|0}else{R=P+16&-16;S=(z=0,au(248,R|0)|0);if(z){z=0;break}c[o+8>>2]=S;c[o>>2]=R|1;c[o+4>>2]=P;Q=S}LF(Q|0,O|0,P)|0;a[Q+P|0]=0;E=52;break L57}}while(0);P=bT(-1,-1)|0;T=P;U=M}}while(0);do{if((E|0)==52){N=p;c[N>>2]=c[r>>2];c[N+4>>2]=c[r+4>>2];c[N+8>>2]=c[r+8>>2];L72:do{if((D&1)==0){P=j;O=q;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];E=62}else{P=c[j+8>>2]|0;O=c[j+4>>2]|0;do{if(O>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(O>>>0<11>>>0){a[q]=O<<1;V=q+1|0}else{S=O+16&-16;R=(z=0,au(248,S|0)|0);if(z){z=0;break}c[q+8>>2]=R;c[q>>2]=S|1;c[q+4>>2]=O;V=R}LF(V|0,P|0,O)|0;a[V+O|0]=0;E=62;break L72}}while(0);O=bT(-1,-1)|0;W=O;X=M}}while(0);do{if((E|0)==62){O=e;c[O>>2]=c[N>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];z=0;aD(58,J|0,o|0,e|0,q|0,C|0,t|0);if(z){z=0;O=bT(-1,-1)|0;P=O;O=M;if((a[q]&1)==0){W=P;X=O;break}Lw(c[q+8>>2]|0);W=P;X=O;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((D&1)==0){i=d;return J|0}Lw(c[j+8>>2]|0);i=d;return J|0}}while(0);if((a[o]&1)==0){T=W;U=X;break}Lw(c[o+8>>2]|0);T=W;U=X}}while(0);J=c[u>>2]|0;t=c[s>>2]|0;C=J;while(1){if((C|0)==(t|0)){Y=t;break}if((c[C>>2]|0)==(K|0)){Y=C;break}else{C=C+4|0}}C=Y-J>>2;u=J+(C+1<<2)|0;N=t-u|0;LG(J+(C<<2)|0,u|0,N|0)|0;u=J+((N>>2)+C<<2)|0;C=c[s>>2]|0;if((u|0)!=(C|0)){c[s>>2]=C+(~((C-4+(-u|0)|0)>>>2)<<2)}Lw(g);F=T;G=U}else{z=0;E=18}}while(0);if((E|0)==18){E=bT(-1,-1)|0;F=E;G=M}if((D&1)==0){v=F;w=G;x=v;y=0;A=x;B=w;bg(A|0)}Lw(c[j+8>>2]|0);v=F;w=G;x=v;y=0;A=x;B=w;bg(A|0);return 0}function uh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;d=i;i=i+88|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;v0(b)|0;k=d+56|0;l=b+44|0;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=vd(b)|0;a[l+28|0]=0;m=uw(b)|0;n=c[b>>2]|0;o=Lu(36)|0;c[h>>2]=o;p=n+4|0;q=c[p>>2]|0;if((q|0)==(c[n+8>>2]|0)){e4(n|0,h);r=c[h>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=o;s=c[p>>2]|0}c[p>>2]=s+4;r=o}o=r;s=r;q=b+28|0;L8:do{if((a[q]&1)==0){h=j;c[h>>2]=c[q>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];t=a[h]|0;u=h;v=16}else{h=c[b+36>>2]|0;w=c[b+32>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){x=w<<1&255;y=j;a[y]=x;A=j+1|0;B=x;C=y}else{y=w+16&-16;x=(z=0,au(248,y|0)|0);if(z){z=0;break}c[j+8>>2]=x;D=y|1;c[j>>2]=D;c[j+4>>2]=w;A=x;B=D&255;C=j}LF(A|0,h|0,w)|0;a[A+w|0]=0;t=B;u=C;v=16;break L8}}while(0);w=bT(-1,-1)|0;E=M;F=w}}while(0);do{if((v|0)==16){C=g;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[C+8>>2]=c[k+8>>2];C=g;B=e;A=f;b=r;L23:do{if((t&1)==0){c[B>>2]=c[u>>2];c[B+4>>2]=c[u+4>>2];c[B+8>>2]=c[u+8>>2];v=26}else{q=c[j+8>>2]|0;w=c[j+4>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[B]=w<<1;G=e+1|0}else{h=w+16&-16;D=(z=0,au(248,h|0)|0);if(z){z=0;break}c[e+8>>2]=D;c[e>>2]=h|1;c[e+4>>2]=w;G=D}LF(G|0,q|0,w)|0;a[G+w|0]=0;v=26;break L23}}while(0);w=bT(-1,-1)|0;H=M;I=w}}while(0);do{if((v|0)==26){c[A>>2]=c[C>>2];c[A+4>>2]=c[C+4>>2];c[A+8>>2]=c[C+8>>2];z=0;aV(6,b|0,e|0,f|0,m|0);if(z){z=0;w=bT(-1,-1)|0;q=M;if((a[B]&1)==0){H=q;I=w;break}Lw(c[e+8>>2]|0);H=q;I=w;break}if((a[B]&1)!=0){Lw(c[e+8>>2]|0)}c[r>>2]=19064;c[r+32>>2]=l;if((a[u]&1)==0){i=d;return s|0}Lw(c[j+8>>2]|0);i=d;return s|0}}while(0);B=I;b=H;if((a[u]&1)==0){E=b;F=B;break}Lw(c[j+8>>2]|0);E=b;F=B}}while(0);j=c[n>>2]|0;n=c[p>>2]|0;u=j;while(1){if((u|0)==(n|0)){J=n;break}if((c[u>>2]|0)==(r|0)){J=u;break}else{u=u+4|0}}u=J-j>>2;J=j+(u+1<<2)|0;r=n-J|0;LG(j+(u<<2)|0,J|0,r|0)|0;J=j+((r>>2)+u<<2)|0;u=c[p>>2]|0;if((J|0)==(u|0)){Lw(o);K=F;L=0;N=K;O=E;bg(N|0)}c[p>>2]=u+(~((u-4+(-J|0)|0)>>>2)<<2);Lw(o);K=F;L=0;N=K;O=E;bg(N|0);return 0}function ui(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;d=i;i=i+120|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;k=d+88|0;l=d+104|0;v1(b)|0;m=d+56|0;n=b+44|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];n=v2(b)|0;o=y$(c[b+20>>2]|0)|0;do{if((o+1|0)==0|(a[o]|0)!=123){p=Lu(32)|0;q=j+8|0;c[q>>2]=p;c[j>>2]=33;c[j+4>>2]=27;LF(p|0,2784,27)|0;a[p+27|0]=0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;z=0;aR(492,b|0,j|0,k|0);if(!z){if((a[j]&1)==0){break}Lw(c[q>>2]|0);break}else{z=0}p=bT(-1,-1)|0;r=p;p=M;if((a[j]&1)==0){s=r;t=p;u=s;v=0;w=u;x=t;bg(w|0)}Lw(c[q>>2]|0);s=r;t=p;u=s;v=0;w=u;x=t;bg(w|0)}}while(0);j=uw(b)|0;k=c[b>>2]|0;o=Lu(40)|0;c[h>>2]=o;p=k+4|0;r=c[p>>2]|0;if((r|0)==(c[k+8>>2]|0)){e4(k|0,h);y=c[h>>2]|0}else{if((r|0)==0){A=0}else{c[r>>2]=o;A=c[p>>2]|0}c[p>>2]=A+4;y=o}o=y;A=y;r=b+28|0;L19:do{if((a[r]&1)==0){h=l;c[h>>2]=c[r>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];B=a[h]|0;C=h;D=22}else{h=c[b+36>>2]|0;q=c[b+32>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){E=q<<1&255;F=l;a[F]=E;G=l+1|0;H=E;I=F}else{F=q+16&-16;E=(z=0,au(248,F|0)|0);if(z){z=0;break}c[l+8>>2]=E;J=F|1;c[l>>2]=J;c[l+4>>2]=q;G=E;H=J&255;I=l}LF(G|0,h|0,q)|0;a[G+q|0]=0;B=H;C=I;D=22;break L19}}while(0);q=bT(-1,-1)|0;K=q;L=M}}while(0);do{if((D|0)==22){I=g;c[I>>2]=c[m>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];I=g;H=e;G=f;b=y;L34:do{if((B&1)==0){c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];D=32}else{r=c[l+8>>2]|0;q=c[l+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[H]=q<<1;N=e+1|0}else{h=q+16&-16;J=(z=0,au(248,h|0)|0);if(z){z=0;break}c[e+8>>2]=J;c[e>>2]=h|1;c[e+4>>2]=q;N=J}LF(N|0,r|0,q)|0;a[N+q|0]=0;D=32;break L34}}while(0);q=bT(-1,-1)|0;O=M;P=q}}while(0);do{if((D|0)==32){c[G>>2]=c[I>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];z=0;aV(6,b|0,e|0,f|0,j|0);if(z){z=0;q=bT(-1,-1)|0;r=M;if((a[H]&1)==0){O=r;P=q;break}Lw(c[e+8>>2]|0);O=r;P=q;break}if((a[H]&1)!=0){Lw(c[e+8>>2]|0)}c[y>>2]=22288;c[y+32>>2]=n;c[y+36>>2]=0;if((a[C]&1)==0){i=d;return A|0}Lw(c[l+8>>2]|0);i=d;return A|0}}while(0);H=P;b=O;if((a[C]&1)==0){K=H;L=b;break}Lw(c[l+8>>2]|0);K=H;L=b}}while(0);l=c[k>>2]|0;k=c[p>>2]|0;C=l;while(1){if((C|0)==(k|0)){Q=k;break}if((c[C>>2]|0)==(y|0)){Q=C;break}else{C=C+4|0}}C=Q-l>>2;Q=l+(C+1<<2)|0;y=k-Q|0;LG(l+(C<<2)|0,Q|0,y|0)|0;Q=l+((y>>2)+C<<2)|0;C=c[p>>2]|0;if((Q|0)!=(C|0)){c[p>>2]=C+(~((C-4+(-Q|0)|0)>>>2)<<2)}Lw(o);s=K;t=L;u=s;v=0;w=u;x=t;bg(w|0);return 0}function uj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;d=i;i=i+88|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+56|0;k=d+72|0;wa(b)|0;l=c[b>>2]|0;m=Lu(32)|0;c[h>>2]=m;n=l+4|0;o=c[n>>2]|0;if((o|0)==(c[l+8>>2]|0)){e4(l|0,h);p=c[h>>2]|0}else{if((o|0)==0){q=0}else{c[o>>2]=m;q=c[n>>2]|0}c[n>>2]=q+4;p=m}m=p;q=p;o=b+28|0;L8:do{if((a[o]&1)==0){h=j;c[h>>2]=c[o>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];r=16}else{h=c[b+36>>2]|0;s=c[b+32>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(s>>>0<11>>>0){a[j]=s<<1;t=j+1|0}else{u=s+16&-16;v=(z=0,au(248,u|0)|0);if(z){z=0;break}c[j+8>>2]=v;c[j>>2]=u|1;c[j+4>>2]=s;t=v}LF(t|0,h|0,s)|0;a[t+s|0]=0;r=16;break L8}}while(0);s=bT(-1,-1)|0;w=M;x=s}}while(0);do{if((r|0)==16){t=k;o=b+44|0;c[t>>2]=c[o>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];o=(z=0,au(168,b|0)|0);do{if(!z){s=g;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];h=e;v=f;u=p;y=j;A=a[y]|0;B=(A&1)==0;if(B){c[h>>2]=c[y>>2];c[h+4>>2]=c[y+4>>2];c[h+8>>2]=c[y+8>>2]}else{y=c[j+8>>2]|0;C=c[j+4>>2]|0;if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;r=36;break}return 0}if(C>>>0<11>>>0){a[h]=C<<1;D=e+1|0}else{E=C+16&-16;F=(z=0,au(248,E|0)|0);if(z){z=0;r=36;break}c[e+8>>2]=F;c[e>>2]=E|1;c[e+4>>2]=C;D=F}LF(D|0,y|0,C)|0;a[D+C|0]=0}c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];z=0;aR(424,u|0,e|0,f|0);if(z){z=0;u=bT(-1,-1)|0;s=M;if((a[h]&1)==0){G=s;H=u;I=A;break}Lw(c[e+8>>2]|0);G=s;H=u;I=A;break}if((a[h]&1)!=0){Lw(c[e+8>>2]|0)}c[p>>2]=17568;c[p+28>>2]=o;if(B){i=d;return q|0}Lw(c[j+8>>2]|0);i=d;return q|0}else{z=0;r=36}}while(0);if((r|0)==36){o=bT(-1,-1)|0;G=M;H=o;I=a[j]|0}o=H;t=G;if((I&1)==0){w=t;x=o;break}Lw(c[j+8>>2]|0);w=t;x=o}}while(0);j=c[l>>2]|0;l=c[n>>2]|0;I=j;while(1){if((I|0)==(l|0)){J=l;break}if((c[I>>2]|0)==(p|0)){J=I;break}else{I=I+4|0}}I=J-j>>2;J=j+(I+1<<2)|0;p=l-J|0;LG(j+(I<<2)|0,J|0,p|0)|0;J=j+((p>>2)+I<<2)|0;I=c[n>>2]|0;if((J|0)==(I|0)){Lw(m);K=x;L=0;N=K;O=w;bg(N|0)}c[n>>2]=I+(~((I-4+(-J|0)|0)>>>2)<<2);Lw(m);K=x;L=0;N=K;O=w;bg(N|0);return 0}function uk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=a[37208]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=37208;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==0){p=i;break L9}else if((n<<24>>24|0)==10){q=i+1|0}else{q=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=q}else{p=q;break}}}else{p=0}}while(0);c[g>>2]=h+p;h=e;g=0;while(1){q=h-1|0;if(q>>>0<k>>>0){break}if((a[q]|0)==10){break}else{h=q;g=g+1|0}}h=b+40|0;if((p|0)!=0){c[h>>2]=1}p=c[h>>2]|0;c[b+52>>2]=p+g;k=f;q=e;c[h>>2]=k-q+g+p;p=b+56|0;c[p>>2]=q;c[p+4>>2]=k;c[d>>2]=f;o=f;return o|0}function ul(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=yY(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function um(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+112|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+64|0;k=d+80|0;l=d+96|0;v9(b)|0;m=c[b+56>>2]|0;n=(c[b+60>>2]|0)-m|0;if(n>>>0>4294967279>>>0){D5(0);return 0}if(n>>>0<11>>>0){o=n<<1&255;a[g]=o;p=g+1|0;q=o}else{o=n+16&-16;r=Lu(o)|0;c[g+8>>2]=r;s=o|1;c[g>>2]=s;c[g+4>>2]=n;p=r;q=s&255}LF(p|0,m|0,n)|0;a[p+n|0]=0;n=d+40|0;p=b+44|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];p=b+20|0;z=0;aR(434,h|0,b|0,c[p>>2]|0);L8:do{if(!z){m=c[h>>2]|0;do{if((m|0)==0){s=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;t=11;break L8}if(!((s+1|0)==0|(a[s]|0)!=123)){u=0;v=0;break}s=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;t=11;break L8}if(!((s+1|0)==0|(a[s]|0)!=125)){u=0;v=0;break}s=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;t=11;break L8}if(!((s+1|0)==0|(a[s]|0)!=59)){u=0;v=0;break}s=(z=0,au(168,b|0)|0);if(!z){u=0;v=s}else{z=0;t=11;break L8}}else{if((a[h+4|0]&1)==0){s=(z=0,au(50,b|0)|0);if(z){z=0;t=11;break L8}u=s|0;v=0;break}else{s=(z=0,aM(586,b|0,m|0)|0);if(z){z=0;t=11;break L8}u=s|0;v=0;break}}}while(0);m=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;t=11;break}if((m+1|0)==0|(a[m]|0)!=123){w=0}else{m=(z=0,au(246,b|0)|0);if(!z){w=m}else{z=0;t=11;break}}m=c[b>>2]|0;s=(z=0,au(248,52)|0);if(z){z=0;t=11;break}r=s;c[f>>2]=r;s=m+4|0;o=c[s>>2]|0;if((o|0)==(c[m+8>>2]|0)){z=0;as(382,m|0,f|0);if(z){z=0;t=11;break}x=c[f>>2]|0}else{if((o|0)==0){y=0}else{c[o>>2]=r;y=c[s>>2]|0}c[s>>2]=y+4;x=r}r=x;o=x;A=b+28|0;L38:do{if((a[A]&1)==0){B=j;c[B>>2]=c[A>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2];t=41}else{B=c[b+36>>2]|0;C=c[b+32>>2]|0;do{if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(C>>>0<11>>>0){a[j]=C<<1;D=j+1|0}else{E=C+16&-16;F=(z=0,au(248,E|0)|0);if(z){z=0;break}c[j+8>>2]=F;c[j>>2]=E|1;c[j+4>>2]=C;D=F}LF(D|0,B|0,C)|0;a[D+C|0]=0;t=41;break L38}}while(0);C=bT(-1,-1)|0;G=M;H=C}}while(0);do{if((t|0)==41){A=k;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];L53:do{if((q&1)==0){C=g;B=l;c[B>>2]=c[C>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];t=51}else{C=c[g+8>>2]|0;B=c[g+4>>2]|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(B>>>0<11>>>0){a[l]=B<<1;I=l+1|0}else{F=B+16&-16;E=(z=0,au(248,F|0)|0);if(z){z=0;break}c[l+8>>2]=E;c[l>>2]=F|1;c[l+4>>2]=B;I=E}LF(I|0,C|0,B)|0;a[I+B|0]=0;t=51;break L53}}while(0);B=bT(-1,-1)|0;J=M;K=B}}while(0);do{if((t|0)==51){B=e;c[B>>2]=c[A>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2];z=0;aD(10,o|0,j|0,e|0,l|0,u|0,w|0);if(z){z=0;B=bT(-1,-1)|0;C=B;B=M;if((a[l]&1)==0){J=B;K=C;break}Lw(c[l+8>>2]|0);J=B;K=C;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}if((u|0)==0){c[x+48>>2]=v}if((q&1)==0){i=d;return o|0}Lw(c[g+8>>2]|0);i=d;return o|0}}while(0);if((a[j]&1)==0){G=J;H=K;break}Lw(c[j+8>>2]|0);G=J;H=K}}while(0);o=c[m>>2]|0;A=c[s>>2]|0;C=o;while(1){if((C|0)==(A|0)){L=A;break}if((c[C>>2]|0)==(x|0)){L=C;break}else{C=C+4|0}}C=L-o>>2;m=o+(C+1<<2)|0;B=A-m|0;LG(o+(C<<2)|0,m|0,B|0)|0;m=o+((B>>2)+C<<2)|0;C=c[s>>2]|0;if((m|0)!=(C|0)){c[s>>2]=C+(~((C-4+(-m|0)|0)>>>2)<<2)}Lw(r);N=G;O=H}else{z=0;t=11}}while(0);if((t|0)==11){t=bT(-1,-1)|0;N=M;O=t}if((q&1)==0){P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[g+8>>2]|0);P=O;Q=0;R=P;S=N;bg(R|0);return 0}function un(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;f=d+20|0;if((e|0)==0){g=0;h=0;i=c[f>>2]|0}else{g=0;h=0;i=e}L3:while(1){j=(i|0)==0;if(j){k=c[f>>2]|0}else{k=i}e=y0(y$(k)|0)|0;L8:do{if((e|0)==0){if(j){l=c[f>>2]|0}else{l=i}d=zp(y$(l)|0)|0;if((d|0)!=0){m=d;break}if(j){n=c[f>>2]|0}else{n=i}d=zo(y$(n)|0)|0;if((d|0)!=0){m=d;break}if(j){o=c[f>>2]|0}else{o=i}d=zr(y$(o)|0)|0;if((d|0)!=0){m=d;break}if(j){p=c[f>>2]|0}else{p=i}d=zs(y$(p)|0)|0;if((d|0)!=0){m=d;break}if(j){q=c[f>>2]|0}else{q=i}d=zG(y$(q)|0)|0;if((d|0)!=0){r=y0(d)|0;if((r|0)!=0){m=r;break}}if(j){s=c[f>>2]|0}else{s=i}r=zA(y$(s)|0)|0;if((r|0)!=0){m=r;break}if(j){t=c[f>>2]|0}else{t=i}r=zB(y$(t)|0)|0;if((r|0)!=0){m=r;break}if(j){u=c[f>>2]|0}else{u=i}r=yY(y$(u)|0)|0;if((r|0)!=0){m=r;break}if(j){v=c[f>>2]|0}else{v=i}r=y$(v)|0;d=(a[r]|0)==42?r+1|0:0;if((d|0)!=0){m=d;break}if(j){w=c[f>>2]|0}else{w=i}d=y$(w)|0;r=(a[d]|0)==40?d+1|0:0;if((r|0)!=0){m=r;break}if(j){x=c[f>>2]|0}else{x=i}r=y$(x)|0;d=(a[r]|0)==41?r+1|0:0;if((d|0)!=0){m=d;break}if(j){y=c[f>>2]|0}else{y=i}d=y$(y)|0;r=(a[d]|0)==91?d+1|0:0;if((r|0)!=0){m=r;break}if(j){z=c[f>>2]|0}else{z=i}r=y$(z)|0;d=(a[r]|0)==93?r+1|0:0;if((d|0)!=0){m=d;break}if(j){A=c[f>>2]|0}else{A=i}d=y$(A)|0;r=(a[d]|0)==43?d+1|0:0;if((r|0)!=0){m=r;break}if(j){B=c[f>>2]|0}else{B=i}r=y$(B)|0;d=(a[r]|0)==126?r+1|0:0;if((d|0)!=0){m=d;break}if(j){C=c[f>>2]|0}else{C=i}d=y$(C)|0;r=(a[d]|0)==62?d+1|0:0;if((r|0)!=0){m=r;break}if(j){D=c[f>>2]|0}else{D=i}r=y$(D)|0;d=(a[r]|0)==44?r+1|0:0;if((d|0)!=0){m=d;break}if(j){E=c[f>>2]|0}else{E=i}d=zy(y$(E)|0)|0;if((d|0)!=0){m=d;break}if(j){F=c[f>>2]|0}else{F=i}d=y$(F)|0;r=zv(d)|0;G=(r|0)!=0?r:d;do{if((G|0)!=0){d=yS(G)|0;r=(d|0)!=0?d:G;if((r|0)==0){break}d=(a[r]|0)==110?r+1|0:0;if((d|0)!=0){m=d;break L8}}}while(0);if(j){H=c[f>>2]|0}else{H=i}G=y$(H)|0;d=zv(G)|0;r=(d|0)!=0?d:G;if((r|0)!=0){G=yS(r)|0;if((G|0)!=0){m=G;break}}if(j){I=c[f>>2]|0}else{I=i}G=zw(y$(I)|0)|0;if((G|0)!=0){m=G;break}if(j){J=c[f>>2]|0}else{J=i}G=y$(J)|0;r=(a[G]|0)==38?G+1|0:0;if((r|0)!=0){m=r;break}if(j){K=c[f>>2]|0}else{K=i}r=y$(K)|0;G=(a[r]|0)==37?r+1|0:0;if((G|0)!=0){m=G;break}if(j){L=c[f>>2]|0}else{L=i}G=y$(L)|0;r=zM(G)|0;if((r|0)!=0){m=r;break}r=zN(G)|0;if((r|0)!=0){m=r;break}r=zO(G)|0;if((r|0)!=0){m=r;break}r=zP(G)|0;if((r|0)!=0){m=r;break}r=zQ(G)|0;if((r|0)!=0){m=r;break}r=zR(G)|0;if((r|0)!=0){m=r;break}if(j){M=c[f>>2]|0}else{M=i}r=y$(M)|0;G=(a[r]|0)==46?r+1|0:0;if((G|0)!=0){r=yZ(G)|0;if((r|0)!=0){m=r;break}}if(j){N=c[f>>2]|0}else{N=i}r=y$(N)|0;G=(a[r]|0)==35?r+1|0:0;if((G|0)!=0){r=yZ(G)|0;if((r|0)!=0){m=r;break}}if(j){O=c[f>>2]|0}else{O=i}r=y$(O)|0;G=(a[r]|0)==45?r+1|0:0;if((G|0)!=0){r=yZ(G)|0;if((r|0)!=0){m=r;break}}if(j){P=c[f>>2]|0}else{P=i}r=zG(y$(P)|0)|0;if((r|0)!=0){G=yZ(r)|0;if((G|0)!=0){m=G;break}}if(j){Q=c[f>>2]|0}else{Q=i}G=yZ(y$(Q)|0)|0;if((G|0)==0){break L3}else{m=G}}else{m=e}}while(0);g=(a[m-1|0]|0)==125|g;h=1;i=m}if(!h){R=0;S=b|0;c[S>>2]=R;T=b+4|0;U=g&1;a[T]=U;return}if(j){V=c[f>>2]|0}else{V=i}f=y$(V)|0;R=(a[f]|0)==123&(f+1|0)!=0?i:0;S=b|0;c[S>>2]=R;T=b+4|0;U=g&1;a[T]=U;return}function uo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;e=i;i=i+120|0;f=d;d=i;i=i+8|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+72|0;l=e+88|0;m=e+104|0;if((a[d+4|0]&1)==0){n=uJ(b)|0}else{n=uI(b,c[d>>2]|0)|0}d=e+56|0;o=b+44|0;c[d>>2]=c[o>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];o=y$(c[b+20>>2]|0)|0;do{if((o+1|0)==0|(a[o]|0)!=123){p=Lu(48)|0;q=k+8|0;c[q>>2]=p;c[k>>2]=49;c[k+4>>2]=33;LF(p|0,9120,33)|0;a[p+33|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z=0;aR(492,b|0,k|0,l|0);if(!z){if((a[k]&1)==0){break}Lw(c[q>>2]|0);break}else{z=0}p=bT(-1,-1)|0;r=p;p=M;if((a[k]&1)==0){s=r;t=p;u=s;v=0;w=u;x=t;bg(w|0)}Lw(c[q>>2]|0);s=r;t=p;u=s;v=0;w=u;x=t;bg(w|0)}}while(0);k=uw(b)|0;l=c[b>>2]|0;o=Lu(36)|0;c[j>>2]=o;p=l+4|0;r=c[p>>2]|0;if((r|0)==(c[l+8>>2]|0)){e4(l|0,j);y=c[j>>2]|0}else{if((r|0)==0){A=0}else{c[r>>2]=o;A=c[p>>2]|0}c[p>>2]=A+4;y=o}o=y;A=y;r=b+28|0;L23:do{if((a[r]&1)==0){j=m;c[j>>2]=c[r>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];B=a[j]|0;C=j;D=25}else{j=c[b+36>>2]|0;q=c[b+32>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){E=q<<1&255;F=m;a[F]=E;G=m+1|0;H=E;I=F}else{F=q+16&-16;E=(z=0,au(248,F|0)|0);if(z){z=0;break}c[m+8>>2]=E;J=F|1;c[m>>2]=J;c[m+4>>2]=q;G=E;H=J&255;I=m}LF(G|0,j|0,q)|0;a[G+q|0]=0;B=H;C=I;D=25;break L23}}while(0);q=bT(-1,-1)|0;K=q;L=M}}while(0);do{if((D|0)==25){I=h;c[I>>2]=c[d>>2];c[I+4>>2]=c[d+4>>2];c[I+8>>2]=c[d+8>>2];I=h;H=f;G=g;b=y;L38:do{if((B&1)==0){c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];D=35}else{r=c[m+8>>2]|0;q=c[m+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[H]=q<<1;N=f+1|0}else{j=q+16&-16;J=(z=0,au(248,j|0)|0);if(z){z=0;break}c[f+8>>2]=J;c[f>>2]=j|1;c[f+4>>2]=q;N=J}LF(N|0,r|0,q)|0;a[N+q|0]=0;D=35;break L38}}while(0);q=bT(-1,-1)|0;O=M;P=q}}while(0);do{if((D|0)==35){c[G>>2]=c[I>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];z=0;aV(6,b|0,f|0,g|0,k|0);if(z){z=0;q=bT(-1,-1)|0;r=M;if((a[H]&1)==0){O=r;P=q;break}Lw(c[f+8>>2]|0);O=r;P=q;break}if((a[H]&1)!=0){Lw(c[f+8>>2]|0)}c[y>>2]=17704;c[y+32>>2]=n;if((a[C]&1)==0){i=e;return A|0}Lw(c[m+8>>2]|0);i=e;return A|0}}while(0);H=P;b=O;if((a[C]&1)==0){K=H;L=b;break}Lw(c[m+8>>2]|0);K=H;L=b}}while(0);m=c[l>>2]|0;l=c[p>>2]|0;C=m;while(1){if((C|0)==(l|0)){Q=l;break}if((c[C>>2]|0)==(y|0)){Q=C;break}else{C=C+4|0}}C=Q-m>>2;Q=m+(C+1<<2)|0;y=l-Q|0;LG(m+(C<<2)|0,Q|0,y|0)|0;Q=m+((y>>2)+C<<2)|0;C=c[p>>2]|0;if((Q|0)!=(C|0)){c[p>>2]=C+(~((C-4+(-Q|0)|0)>>>2)<<2)}Lw(o);s=K;t=L;u=s;v=0;w=u;x=t;bg(w|0);return 0}function up(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y$(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y4(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function ur(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0;d=i;i=i+528|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+56|0;l=d+72|0;m=d+80|0;n=d+96|0;o=d+104|0;p=d+120|0;q=d+128|0;r=d+144|0;s=d+152|0;t=d+168|0;u=d+184|0;v=d+200|0;w=d+208|0;x=d+216|0;y=d+224|0;A=d+240|0;B=d+248|0;C=d+256|0;D=d+272|0;E=d+280|0;F=d+288|0;G=d+304|0;H=d+312|0;I=d+328|0;J=d+336|0;K=d+352|0;L=d+360|0;N=d+376|0;O=d+392|0;P=d+408|0;Q=d+424|0;R=d+440|0;S=d+456|0;T=d+472|0;U=d+488|0;V=d+504|0;W=d+520|0;X=W;Y=i;i=i+12|0;i=i+7&-8;Z=i;i=i+12|0;i=i+7&-8;_=i;i=i+12|0;i=i+7&-8;$=i;i=i+12|0;i=i+7&-8;aa=i;i=i+12|0;i=i+7&-8;ab=i;i=i+12|0;i=i+7&-8;ac=i;i=i+12|0;i=i+7&-8;ad=i;i=i+64|0;ae=i;i=i+8|0;af=ae;ag=i;i=i+12|0;i=i+7&-8;ah=i;i=i+12|0;i=i+7&-8;ai=i;i=i+12|0;i=i+7&-8;aj=i;i=i+12|0;i=i+7&-8;ak=i;i=i+12|0;i=i+7&-8;al=i;i=i+12|0;i=i+7&-8;am=i;i=i+12|0;i=i+7&-8;an=i;i=i+12|0;i=i+7&-8;ao=i;i=i+12|0;i=i+7&-8;ap=i;i=i+12|0;i=i+7&-8;at=i;i=i+12|0;i=i+7&-8;av=i;i=i+12|0;i=i+7&-8;aw=i;i=i+12|0;i=i+7&-8;ax=i;i=i+12|0;i=i+7&-8;ay=i;i=i+12|0;i=i+7&-8;aA=i;i=i+12|0;i=i+7&-8;aB=i;i=i+12|0;i=i+7&-8;aC=i;i=i+12|0;i=i+7&-8;aE=i;i=i+12|0;i=i+7&-8;aF=i;i=i+12|0;i=i+7&-8;aG=i;i=i+12|0;i=i+7&-8;aH=i;i=i+12|0;i=i+7&-8;aI=i;i=i+12|0;i=i+7&-8;aJ=i;i=i+12|0;i=i+7&-8;aK=i;i=i+12|0;i=i+7&-8;aL=i;i=i+12|0;i=i+7&-8;if((vG(b)|0)!=0){aM=b|0;aN=c[aM>>2]|0;aO=Lu(56)|0;c[K>>2]=aO;aP=aN+4|0;aQ=c[aP>>2]|0;if((aQ|0)==(c[aN+8>>2]|0)){e4(aN|0,K);aS=c[K>>2]|0}else{if((aQ|0)==0){aT=0}else{c[aQ>>2]=aO;aT=c[aP>>2]|0}c[aP>>2]=aT+4;aS=aO}aO=aS;aT=aS;aQ=b+28|0;L10:do{if((a[aQ]&1)==0){K=L;c[K>>2]=c[aQ>>2];c[K+4>>2]=c[aQ+4>>2];c[K+8>>2]=c[aQ+8>>2];aU=17}else{K=c[b+36>>2]|0;aW=c[b+32>>2]|0;do{if(aW>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aW>>>0<11>>>0){a[L]=aW<<1;aX=L+1|0}else{aY=aW+16&-16;aZ=(z=0,au(248,aY|0)|0);if(z){z=0;break}c[L+8>>2]=aZ;c[L>>2]=aY|1;c[L+4>>2]=aW;aX=aZ}LF(aX|0,K|0,aW)|0;a[aX+aW|0]=0;aU=17;break L10}}while(0);aW=bT(-1,-1)|0;a_=aW;a0=M}}while(0);do{if((aU|0)==17){aX=b+44|0;aW=J;c[aW>>2]=c[aX>>2];c[aW+4>>2]=c[aX+4>>2];c[aW+8>>2]=c[aX+8>>2];z=0;aR(50,aT|0,L|0,J|0);if(z){z=0;aW=bT(-1,-1)|0;K=aW;aW=M;if((a[L]&1)==0){a_=K;a0=aW;break}Lw(c[L+8>>2]|0);a_=K;a0=aW;break}if((a[L]&1)!=0){Lw(c[L+8>>2]|0)}aW=c[aM>>2]|0;K=Lu(56)|0;c[I>>2]=K;aZ=aW+4|0;aY=c[aZ>>2]|0;if((aY|0)==(c[aW+8>>2]|0)){e4(aW|0,I);a1=c[I>>2]|0}else{if((aY|0)==0){a2=0}else{c[aY>>2]=K;a2=c[aZ>>2]|0}c[aZ>>2]=a2+4;a1=K}K=a1;aY=a1;L39:do{if((a[aQ]&1)==0){a3=N;c[a3>>2]=c[aQ>>2];c[a3+4>>2]=c[aQ+4>>2];c[a3+8>>2]=c[aQ+8>>2];aU=35}else{a3=c[b+36>>2]|0;a4=c[b+32>>2]|0;do{if(a4>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(a4>>>0<11>>>0){a[N]=a4<<1;a5=N+1|0}else{a6=a4+16&-16;a7=(z=0,au(248,a6|0)|0);if(z){z=0;break}c[N+8>>2]=a7;c[N>>2]=a6|1;c[N+4>>2]=a4;a5=a7}LF(a5|0,a3|0,a4)|0;a[a5+a4|0]=0;aU=35;break L39}}while(0);a4=bT(-1,-1)|0;a8=a4;a9=M}}while(0);do{if((aU|0)==35){a4=H;c[a4>>2]=c[aX>>2];c[a4+4>>2]=c[aX+4>>2];c[a4+8>>2]=c[aX+8>>2];a4=O;a[a4]=6;a3=O+1|0;a[a3]=a[968]|0;a[a3+1|0]=a[969]|0;a[a3+2|0]=a[970]|0;a[O+4|0]=0;z=0;aq(10,aY|0,N|0,H|0,O|0,aT|0);if(z){z=0;a3=bT(-1,-1)|0;a7=a3;a3=M;if((a[a4]&1)!=0){Lw(c[O+8>>2]|0)}if((a[N]&1)==0){a8=a7;a9=a3;break}Lw(c[N+8>>2]|0);a8=a7;a9=a3;break}if((a[a4]&1)!=0){Lw(c[O+8>>2]|0)}if((a[N]&1)!=0){Lw(c[N+8>>2]|0)}a4=b+20|0;a3=c[a4>>2]|0;a7=P;c[a7>>2]=c[aX>>2];c[a7+4>>2]=c[aX+4>>2];c[a7+8>>2]=c[aX+8>>2];a6=(z=0,au(190,a3|0)|0);L67:do{if(!z){ba=c[a4>>2]|0;if((a6|0)==0){bb=ba}else{L71:do{if(ba>>>0<a6>>>0){bc=ba;bd=0;while(1){be=a[bc]|0;if((be<<24>>24|0)==0){bf=bd;break L71}else if((be<<24>>24|0)==10){bh=bd+1|0}else{bh=bd}be=bc+1|0;if(be>>>0<a6>>>0){bc=be;bd=bh}else{bf=bh;break}}}else{bf=0}}while(0);bd=b+48|0;c[bd>>2]=(c[bd>>2]|0)+bf;bd=b+56|0;c[bd>>2]=ba;c[bd+4>>2]=a6;c[a4>>2]=a6;bb=a6}bd=(z=0,au(320,bb|0)|0);if(z){z=0;aU=75;break}if((bd|0)==0){bd=(z=0,au(314,c[a4>>2]|0)|0);if(z){z=0;aU=75;break}if((bd|0)!=0){aU=51}}else{aU=51}do{if((aU|0)==51){bd=(z=0,au(248,16)|0);if(z){z=0;aU=75;break L67}bc=Q+8|0;c[bc>>2]=bd;c[Q>>2]=17;c[Q+4>>2]=14;LF(bd|0,5552,14)|0;a[bd+14|0]=0;c[R>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;z=0;aR(492,b|0,Q|0,R|0);if(!z){if((a[Q]&1)==0){break}Lw(c[bc>>2]|0);break}else{z=0;bd=bT(-1,-1,31448)|0;be=bd;bd=M;if((a[Q]&1)==0){bi=be;bj=bd;break L67}Lw(c[bc>>2]|0);bi=be;bj=bd;break L67}}}while(0);ba=(z=0,au(168,b|0)|0);if(z){z=0;aU=75;break}bd=(z=0,au(66,c[a4>>2]|0)|0);if(z){z=0;aU=75;break}be=(a[bd]|0)==41?bd+1|0:0;do{if((be|0)==0){bc=(z=0,au(248,32)|0);if(z){z=0;aU=75;break L67}bk=S+8|0;c[bk>>2]=bc;c[S>>2]=33;c[S+4>>2]=26;LF(bc|0,5416,26)|0;a[bc+26|0]=0;c[T>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;z=0;aR(492,b|0,S|0,T|0);if(!z){if((a[S]&1)==0){break}Lw(c[bk>>2]|0);break}else{z=0;bc=bT(-1,-1,31448)|0;bl=bc;bc=M;if((a[S]&1)==0){bi=bl;bj=bc;break L67}Lw(c[bk>>2]|0);bi=bl;bj=bc;break L67}}else{bc=b+48|0;bl=c[bc>>2]|0;bk=c[a4>>2]|0;L103:do{if(bk>>>0<be>>>0){bm=bk;bn=0;while(1){bo=a[bm]|0;if((bo<<24>>24|0)==10){bp=bn+1|0}else if((bo<<24>>24|0)==0){bq=bn;break L103}else{bp=bn}bo=bm+1|0;if(bo>>>0<be>>>0){bm=bo;bn=bp}else{bq=bp;break}}}else{bq=0}}while(0);c[bc>>2]=bq+bl;bn=bd;bm=0;while(1){bo=bn-1|0;if(bo>>>0<bk>>>0){break}if((a[bo]|0)==10){break}else{bn=bo;bm=bm+1|0}}bn=b+40|0;if((bq|0)!=0){c[bn>>2]=1}bk=c[bn>>2]|0;c[b+52>>2]=bk+bm;bl=be;bc=bd;c[bn>>2]=bl-bc+bm+bk;bk=b+56|0;c[bk>>2]=bc;c[bk+4>>2]=bl;c[a4>>2]=be}}while(0);be=c[aM>>2]|0;bd=(z=0,au(248,56)|0);if(z){z=0;aU=75;break}bl=bd;c[G>>2]=bl;bd=be+4|0;bk=c[bd>>2]|0;if((bk|0)==(c[be+8>>2]|0)){z=0;as(382,be|0,G|0);if(z){z=0;aU=75;break}br=c[G>>2]|0}else{if((bk|0)==0){bs=0}else{c[bk>>2]=bl;bs=c[bd>>2]|0}c[bd>>2]=bs+4;br=bl}bl=br;bk=br;L127:do{if((a[aQ]&1)==0){bc=U;c[bc>>2]=c[aQ>>2];c[bc+4>>2]=c[aQ+4>>2];c[bc+8>>2]=c[aQ+8>>2];aU=114}else{bc=c[b+36>>2]|0;bn=c[b+32>>2]|0;do{if(bn>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bn>>>0<11>>>0){a[U]=bn<<1;bt=U+1|0}else{bo=bn+16&-16;bu=(z=0,au(248,bo|0)|0);if(z){z=0;break}c[U+8>>2]=bu;c[U>>2]=bo|1;c[U+4>>2]=bn;bt=bu}LF(bt|0,bc|0,bn)|0;a[bt+bn|0]=0;aU=114;break L127}}while(0);bn=bT(-1,-1,31448)|0;bv=bn;bw=M}}while(0);do{if((aU|0)==114){bn=ba+16|0;bc=F;c[bc>>2]=c[bn>>2];c[bc+4>>2]=c[bn+4>>2];c[bc+8>>2]=c[bn+8>>2];bn=V;a[bn]=0;a[V+1|0]=0;z=0;aD(30,bk|0,U|0,F|0,ba|0,V|0,0);if(z){z=0;bc=bT(-1,-1,31448)|0;bm=bc;bc=M;if((a[bn]&1)!=0){Lw(c[V+8>>2]|0)}if((a[U]&1)==0){bv=bm;bw=bc;break}Lw(c[U+8>>2]|0);bv=bm;bw=bc;break}if((a[bn]&1)!=0){Lw(c[V+8>>2]|0)}if((a[U]&1)!=0){Lw(c[U+8>>2]|0)}bn=aS+36|0;bc=bn;c[E>>2]=bk;bm=bn+8|0;bu=bm;bo=c[bu>>2]|0;if((bo|0)==(c[bn+12>>2]|0)){z=0;as(156,bn+4|0,E|0);if(z){z=0;aU=75;break L67}bx=c[E>>2]|0}else{if((bo|0)==0){by=0}else{c[bo>>2]=bk;by=c[bu>>2]|0}c[bm>>2]=by+4;bx=bk}z=0;as(c[c[bn>>2]>>2]|0,bc|0,bx|0);if(z){z=0;aU=75;break L67}bz=a1;i=d;return bz|0}}while(0);bk=c[be>>2]|0;ba=c[bd>>2]|0;bc=bk;while(1){if((bc|0)==(ba|0)){bA=ba;break}if((c[bc>>2]|0)==(br|0)){bA=bc;break}else{bc=bc+4|0}}bc=bA-bk>>2;be=bk+(bc+1<<2)|0;bn=ba-be|0;LG(bk+(bc<<2)|0,be|0,bn|0)|0;be=bk+((bn>>2)+bc<<2)|0;bc=c[bd>>2]|0;if((be|0)!=(bc|0)){c[bd>>2]=bc+(~((bc-4+(-be|0)|0)>>>2)<<2)}Lw(bl);bi=bv;bj=bw}else{z=0;aU=75}}while(0);if((aU|0)==75){a6=bT(-1,-1,31448)|0;bi=a6;bj=M}if((bj|0)!=(cs(31448)|0)){bB=bi;bC=bj;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}bD(bi|0)|0;c[a4>>2]=a3;c[aX>>2]=c[a7>>2];c[aX+4>>2]=c[a7+4>>2];c[aX+8>>2]=c[a7+8>>2];a$();a6=yR(c[a4>>2]|0)|0;be=c[a4>>2]|0;if((a6|0)==0){bI=be}else{L181:do{if(be>>>0<a6>>>0){bc=be;bn=0;while(1){bm=a[bc]|0;if((bm<<24>>24|0)==10){bJ=bn+1|0}else if((bm<<24>>24|0)==0){bK=bn;break L181}else{bJ=bn}bm=bc+1|0;if(bm>>>0<a6>>>0){bc=bm;bn=bJ}else{bK=bJ;break}}}else{bK=0}}while(0);a7=b+48|0;c[a7>>2]=(c[a7>>2]|0)+bK;a7=b+56|0;c[a7>>2]=be;c[a7+4>>2]=a6;c[a4>>2]=a6;bI=a6}a7=z4(bI)|0;L189:do{if((a7|0)==0){a3=Lu(16)|0;bn=_+8|0;c[bn>>2]=a3;c[_>>2]=17;c[_+4>>2]=13;LF(a3|0,5360,13)|0;a[a3+13|0]=0;c[$>>2]=0;c[$+4>>2]=0;c[$+8>>2]=0;z=0;aR(492,b|0,_|0,$|0);if(!z){if((a[_]&1)==0){break}Lw(c[bn>>2]|0);break}else{z=0}a3=bT(-1,-1)|0;bc=a3;a3=M;if((a[_]&1)==0){bB=bc;bC=a3;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}Lw(c[bn>>2]|0);bB=bc;bC=a3;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}else{a3=b+48|0;bc=c[a3>>2]|0;bn=c[a4>>2]|0;L191:do{if(bn>>>0<a7>>>0){bl=bn;bd=0;while(1){bk=a[bl]|0;if((bk<<24>>24|0)==10){bL=bd+1|0}else if((bk<<24>>24|0)==0){bM=bd;break L191}else{bL=bd}bk=bl+1|0;if(bk>>>0<a7>>>0){bl=bk;bd=bL}else{bM=bL;break}}}else{bM=0}}while(0);c[a3>>2]=bM+bc;bd=bI;bl=0;while(1){bk=bd-1|0;if(bk>>>0<bn>>>0){break}if((a[bk]|0)==10){break}else{bd=bk;bl=bl+1|0}}bd=b+40|0;if((bM|0)!=0){c[bd>>2]=1}bn=c[bd>>2]|0;c[b+52>>2]=bn+bl;bc=a7;a3=bI;c[bd>>2]=bc-a3+bl+bn;bn=b+56|0;bd=a3|0;a3=bc|0;c[bn>>2]=bd;c[bn+4>>2]=a3;c[a4>>2]=a7;c[W>>2]=bd;c[W+4>>2]=a3;a3=t6(b,X)|0;bd=c[aM>>2]|0;bn=Lu(56)|0;c[D>>2]=bn;bc=bd+4|0;bk=c[bc>>2]|0;if((bk|0)==(c[bd+8>>2]|0)){e4(bd|0,D);bN=c[D>>2]|0}else{if((bk|0)==0){bO=0}else{c[bk>>2]=bn;bO=c[bc>>2]|0}c[bc>>2]=bO+4;bN=bn}bn=bN;bk=bN;L212:do{if((a[aQ]&1)==0){ba=Y;c[ba>>2]=c[aQ>>2];c[ba+4>>2]=c[aQ+4>>2];c[ba+8>>2]=c[aQ+8>>2];aU=170}else{ba=c[b+36>>2]|0;bm=c[b+32>>2]|0;do{if(bm>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bm>>>0<11>>>0){a[Y]=bm<<1;bP=Y+1|0}else{bu=bm+16&-16;bo=(z=0,au(248,bu|0)|0);if(z){z=0;break}c[Y+8>>2]=bo;c[Y>>2]=bu|1;c[Y+4>>2]=bm;bP=bo}LF(bP|0,ba|0,bm)|0;a[bP+bm|0]=0;aU=170;break L212}}while(0);bm=bT(-1,-1)|0;bQ=bm;bR=M}}while(0);do{if((aU|0)==170){bl=a3+16|0;bm=C;c[bm>>2]=c[bl>>2];c[bm+4>>2]=c[bl+4>>2];c[bm+8>>2]=c[bl+8>>2];bl=Z;a[bl]=0;a[Z+1|0]=0;z=0;aD(30,bk|0,Y|0,C|0,a3|0,Z|0,0);if(z){z=0;bm=bT(-1,-1)|0;ba=bm;bm=M;if((a[bl]&1)!=0){Lw(c[Z+8>>2]|0)}if((a[Y]&1)==0){bQ=ba;bR=bm;break}Lw(c[Y+8>>2]|0);bQ=ba;bR=bm;break}if((a[bl]&1)!=0){Lw(c[Z+8>>2]|0)}if((a[Y]&1)!=0){Lw(c[Y+8>>2]|0)}bl=aS+36|0;bm=bl;c[B>>2]=bk;ba=bl+8|0;bo=ba;bu=c[bo>>2]|0;if((bu|0)==(c[bl+12>>2]|0)){jZ(bl+4|0,B);bS=c[B>>2]|0}else{if((bu|0)==0){bU=0}else{c[bu>>2]=bk;bU=c[bo>>2]|0}c[ba>>2]=bU+4;bS=bk}cB[c[c[bl>>2]>>2]&1023](bm,bS);break L189}}while(0);bk=c[bd>>2]|0;a3=c[bc>>2]|0;bm=bk;while(1){if((bm|0)==(a3|0)){bV=a3;break}if((c[bm>>2]|0)==(bN|0)){bV=bm;break}else{bm=bm+4|0}}bm=bV-bk>>2;bd=bk+(bm+1<<2)|0;bl=a3-bd|0;LG(bk+(bm<<2)|0,bd|0,bl|0)|0;bd=bk+((bl>>2)+bm<<2)|0;bm=c[bc>>2]|0;if((bd|0)!=(bm|0)){c[bc>>2]=bm+(~((bm-4+(-bd|0)|0)>>>2)<<2)}Lw(bn);bB=bQ;bC=bR;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}}while(0);a7=y$(c[a4>>2]|0)|0;a6=(a[a7]|0)==41?a7+1|0:0;do{if((a6|0)==0){be=Lu(32)|0;bd=aa+8|0;c[bd>>2]=be;c[aa>>2]=33;c[aa+4>>2]=18;LF(be|0,5272,18)|0;a[be+18|0]=0;c[ab>>2]=0;c[ab+4>>2]=0;c[ab+8>>2]=0;z=0;aR(492,b|0,aa|0,ab|0);if(!z){if((a[aa]&1)==0){break}Lw(c[bd>>2]|0);break}else{z=0}be=bT(-1,-1)|0;bm=be;be=M;if((a[aa]&1)==0){bB=bm;bC=be;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}Lw(c[bd>>2]|0);bB=bm;bC=be;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}else{be=b+48|0;bm=c[be>>2]|0;bd=c[a4>>2]|0;L268:do{if(bd>>>0<a6>>>0){bl=bd;ba=0;while(1){bo=a[bl]|0;if((bo<<24>>24|0)==10){bW=ba+1|0}else if((bo<<24>>24|0)==0){bX=ba;break L268}else{bW=ba}bo=bl+1|0;if(bo>>>0<a6>>>0){bl=bo;ba=bW}else{bX=bW;break}}}else{bX=0}}while(0);c[be>>2]=bX+bm;bn=a7;bc=0;while(1){bk=bn-1|0;if(bk>>>0<bd>>>0){break}if((a[bk]|0)==10){break}else{bn=bk;bc=bc+1|0}}bn=b+40|0;if((bX|0)!=0){c[bn>>2]=1}bd=c[bn>>2]|0;c[b+52>>2]=bd+bc;bm=a6;be=a7;c[bn>>2]=bm-be+bc+bd;bd=b+56|0;c[bd>>2]=be;c[bd+4>>2]=bm;c[a4>>2]=a6}}while(0);bz=a1;i=d;return bz|0}}while(0);aX=c[aW>>2]|0;aY=c[aZ>>2]|0;a6=aX;while(1){if((a6|0)==(aY|0)){bY=aY;break}if((c[a6>>2]|0)==(a1|0)){bY=a6;break}else{a6=a6+4|0}}a6=bY-aX>>2;aW=aX+(a6+1<<2)|0;a4=aY-aW|0;LG(aX+(a6<<2)|0,aW|0,a4|0)|0;aW=aX+((a4>>2)+a6<<2)|0;a6=c[aZ>>2]|0;if((aW|0)!=(a6|0)){c[aZ>>2]=a6+(~((a6-4+(-aW|0)|0)>>>2)<<2)}Lw(K);bB=a8;bC=a9;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}}while(0);a9=c[aN>>2]|0;aN=c[aP>>2]|0;a8=a9;while(1){if((a8|0)==(aN|0)){bZ=aN;break}if((c[a8>>2]|0)==(aS|0)){bZ=a8;break}else{a8=a8+4|0}}a8=bZ-a9>>2;bZ=a9+(a8+1<<2)|0;aS=aN-bZ|0;LG(a9+(a8<<2)|0,bZ|0,aS|0)|0;bZ=a9+((aS>>2)+a8<<2)|0;a8=c[aP>>2]|0;if((bZ|0)!=(a8|0)){c[aP>>2]=a8+(~((a8-4+(-bZ|0)|0)>>>2)<<2)}Lw(aO);bB=a_;bC=a0;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vH(b)|0)!=0){a0=c[b>>2]|0;a_=Lu(52)|0;c[A>>2]=a_;aO=a0+4|0;bZ=c[aO>>2]|0;if((bZ|0)==(c[a0+8>>2]|0)){e4(a0|0,A);b_=c[A>>2]|0}else{if((bZ|0)==0){b$=0}else{c[bZ>>2]=a_;b$=c[aO>>2]|0}c[aO>>2]=b$+4;b_=a_}a_=b_;b$=b+28|0;L321:do{if((a[b$]&1)==0){bZ=ac;c[bZ>>2]=c[b$>>2];c[bZ+4>>2]=c[b$+4>>2];c[bZ+8>>2]=c[b$+8>>2];aU=230}else{bZ=c[b+36>>2]|0;A=c[b+32>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){a[ac]=A<<1;b0=ac+1|0}else{a8=A+16&-16;aP=(z=0,au(248,a8|0)|0);if(z){z=0;break}c[ac+8>>2]=aP;c[ac>>2]=a8|1;c[ac+4>>2]=A;b0=aP}LF(b0|0,bZ|0,A)|0;a[b0+A|0]=0;aU=230;break L321}}while(0);A=bT(-1,-1)|0;b1=A;b2=M}}while(0);do{if((aU|0)==230){b0=b+44|0;b$=y;c[b$>>2]=c[b0>>2];c[b$+4>>2]=c[b0+4>>2];c[b$+8>>2]=c[b0+8>>2];z=0;aq(38,b_|0,ac|0,y|0,5080,0);if(z){z=0;b0=bT(-1,-1)|0;b$=b0;b0=M;if((a[ac]&1)==0){b1=b$;b2=b0;break}Lw(c[ac+8>>2]|0);b1=b$;b2=b0;break}b0=b_;if((a[ac]&1)==0){bz=b0;i=d;return bz|0}Lw(c[ac+8>>2]|0);bz=b0;i=d;return bz|0}}while(0);ac=c[a0>>2]|0;a0=c[aO>>2]|0;y=ac;while(1){if((y|0)==(a0|0)){b3=a0;break}if((c[y>>2]|0)==(b_|0)){b3=y;break}else{y=y+4|0}}y=b3-ac>>2;b3=ac+(y+1<<2)|0;b_=a0-b3|0;LG(ac+(y<<2)|0,b3|0,b_|0)|0;b3=ac+((b_>>2)+y<<2)|0;y=c[aO>>2]|0;if((b3|0)!=(y|0)){c[aO>>2]=y+(~((y-4+(-b3|0)|0)>>>2)<<2)}Lw(a_);bB=b1;bC=b2;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vI(b)|0)!=0){b2=b+56|0;b1=c[b2+4>>2]|0;c[ae>>2]=c[b2>>2];c[ae+4>>2]=b1;b1=c[b>>2]|0;ae=b+28|0;if((a[ae]&1)==0){b2=ag;c[b2>>2]=c[ae>>2];c[b2+4>>2]=c[ae+4>>2];c[b2+8>>2]=c[ae+8>>2]}else{ae=c[b+36>>2]|0;b2=c[b+32>>2]|0;if(b2>>>0>4294967279>>>0){D5(0);return 0}if(b2>>>0<11>>>0){a[ag]=b2<<1;b4=ag+1|0}else{a_=b2+16&-16;b3=Lu(a_)|0;c[ag+8>>2]=b3;c[ag>>2]=a_|1;c[ag+4>>2]=b2;b4=b3}LF(b4|0,ae|0,b2)|0;a[b4+b2|0]=0}b2=ah;b4=b+44|0;c[b2>>2]=c[b4>>2];c[b2+4>>2]=c[b4+4>>2];c[b2+8>>2]=c[b4+8>>2];z=0;aq(16,ad|0,af|0,b1|0,ag|0,ah|0);do{if(!z){ah=(z=0,au(262,ad|0)|0);if(z){z=0;b1=bT(-1,-1)|0;af=b1;b1=M;if((a[ad+28|0]&1)!=0){Lw(c[ad+36>>2]|0)}b4=c[ad+4>>2]|0;if((b4|0)==0){b5=af;b6=b1;break}b2=ad+8|0;ae=c[b2>>2]|0;if((b4|0)!=(ae|0)){c[b2>>2]=ae+(~((ae-4+(-b4|0)|0)>>>2)<<2)}Lw(b4);b5=af;b6=b1;break}if((a[ad+28|0]&1)!=0){Lw(c[ad+36>>2]|0)}b1=c[ad+4>>2]|0;af=b1;if((b1|0)!=0){b4=ad+8|0;ae=c[b4>>2]|0;if((b1|0)!=(ae|0)){c[b4>>2]=ae+(~((ae-4+(-af|0)|0)>>>2)<<2)}Lw(b1)}b1=ah|0;if((a[ag]&1)==0){bz=b1;i=d;return bz|0}Lw(c[ag+8>>2]|0);bz=b1;i=d;return bz|0}else{z=0;b1=bT(-1,-1)|0;b5=b1;b6=M}}while(0);if((a[ag]&1)==0){bB=b5;bC=b6;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}Lw(c[ag+8>>2]|0);bB=b5;bC=b6;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vK(b)|0)!=0){b6=c[b>>2]|0;b5=Lu(40)|0;c[x>>2]=b5;ag=b6+4|0;ad=c[ag>>2]|0;if((ad|0)==(c[b6+8>>2]|0)){e4(b6|0,x);b7=c[x>>2]|0}else{if((ad|0)==0){b8=0}else{c[ad>>2]=b5;b8=c[ag>>2]|0}c[ag>>2]=b8+4;b7=b5}b5=b7;b8=b+28|0;L408:do{if((a[b8]&1)==0){ad=ai;c[ad>>2]=c[b8>>2];c[ad+4>>2]=c[b8+4>>2];c[ad+8>>2]=c[b8+8>>2];aU=286}else{ad=c[b+36>>2]|0;x=c[b+32>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[ai]=x<<1;b9=ai+1|0}else{b1=x+16&-16;ah=(z=0,au(248,b1|0)|0);if(z){z=0;break}c[ai+8>>2]=ah;c[ai>>2]=b1|1;c[ai+4>>2]=x;b9=ah}LF(b9|0,ad|0,x)|0;a[b9+x|0]=0;aU=286;break L408}}while(0);x=bT(-1,-1)|0;ca=x;cb=M}}while(0);do{if((aU|0)==286){b9=aj;b8=b+44|0;c[b9>>2]=c[b8>>2];c[b9+4>>2]=c[b8+4>>2];c[b9+8>>2]=c[b8+8>>2];z=0;aV(4,b7|0,ai|0,aj|0,1);if(z){z=0;b8=bT(-1,-1)|0;b9=b8;b8=M;if((a[ai]&1)==0){ca=b9;cb=b8;break}Lw(c[ai+8>>2]|0);ca=b9;cb=b8;break}b8=b7;if((a[ai]&1)==0){bz=b8;i=d;return bz|0}Lw(c[ai+8>>2]|0);bz=b8;i=d;return bz|0}}while(0);ai=c[b6>>2]|0;b6=c[ag>>2]|0;aj=ai;while(1){if((aj|0)==(b6|0)){cc=b6;break}if((c[aj>>2]|0)==(b7|0)){cc=aj;break}else{aj=aj+4|0}}aj=cc-ai>>2;cc=ai+(aj+1<<2)|0;b7=b6-cc|0;LG(ai+(aj<<2)|0,cc|0,b7|0)|0;cc=ai+((b7>>2)+aj<<2)|0;aj=c[ag>>2]|0;if((cc|0)!=(aj|0)){c[ag>>2]=aj+(~((aj-4+(-cc|0)|0)>>>2)<<2)}Lw(b5);bB=ca;bC=cb;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vL(b)|0)!=0){cb=c[b>>2]|0;ca=Lu(40)|0;c[w>>2]=ca;b5=cb+4|0;cc=c[b5>>2]|0;if((cc|0)==(c[cb+8>>2]|0)){e4(cb|0,w);cd=c[w>>2]|0}else{if((cc|0)==0){ce=0}else{c[cc>>2]=ca;ce=c[b5>>2]|0}c[b5>>2]=ce+4;cd=ca}ca=cd;ce=b+28|0;L450:do{if((a[ce]&1)==0){cc=ak;c[cc>>2]=c[ce>>2];c[cc+4>>2]=c[ce+4>>2];c[cc+8>>2]=c[ce+8>>2];aU=314}else{cc=c[b+36>>2]|0;w=c[b+32>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[ak]=w<<1;cf=ak+1|0}else{aj=w+16&-16;ag=(z=0,au(248,aj|0)|0);if(z){z=0;break}c[ak+8>>2]=ag;c[ak>>2]=aj|1;c[ak+4>>2]=w;cf=ag}LF(cf|0,cc|0,w)|0;a[cf+w|0]=0;aU=314;break L450}}while(0);w=bT(-1,-1)|0;cg=w;ch=M}}while(0);do{if((aU|0)==314){cf=al;ce=b+44|0;c[cf>>2]=c[ce>>2];c[cf+4>>2]=c[ce+4>>2];c[cf+8>>2]=c[ce+8>>2];z=0;aV(4,cd|0,ak|0,al|0,0);if(z){z=0;ce=bT(-1,-1)|0;cf=ce;ce=M;if((a[ak]&1)==0){cg=cf;ch=ce;break}Lw(c[ak+8>>2]|0);cg=cf;ch=ce;break}ce=cd;if((a[ak]&1)==0){bz=ce;i=d;return bz|0}Lw(c[ak+8>>2]|0);bz=ce;i=d;return bz|0}}while(0);ak=c[cb>>2]|0;cb=c[b5>>2]|0;al=ak;while(1){if((al|0)==(cb|0)){ci=cb;break}if((c[al>>2]|0)==(cd|0)){ci=al;break}else{al=al+4|0}}al=ci-ak>>2;ci=ak+(al+1<<2)|0;cd=cb-ci|0;LG(ak+(al<<2)|0,ci|0,cd|0)|0;ci=ak+((cd>>2)+al<<2)|0;al=c[b5>>2]|0;if((ci|0)!=(al|0)){c[b5>>2]=al+(~((al-4+(-ci|0)|0)>>>2)<<2)}Lw(ca);bB=cg;bC=ch;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vM(b)|0)!=0){ch=c[b>>2]|0;cg=Lu(36)|0;c[v>>2]=cg;ca=ch+4|0;ci=c[ca>>2]|0;if((ci|0)==(c[ch+8>>2]|0)){e4(ch|0,v);cj=c[v>>2]|0}else{if((ci|0)==0){ck=0}else{c[ci>>2]=cg;ck=c[ca>>2]|0}c[ca>>2]=ck+4;cj=cg}cg=cj;ck=b+28|0;L492:do{if((a[ck]&1)==0){ci=am;c[ci>>2]=c[ck>>2];c[ci+4>>2]=c[ck+4>>2];c[ci+8>>2]=c[ck+8>>2];cl=a[ci]|0;cm=ci;aU=342}else{ci=c[b+36>>2]|0;v=c[b+32>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(v>>>0<11>>>0){al=v<<1&255;b5=am;a[b5]=al;cn=am+1|0;co=al;cp=b5}else{b5=v+16&-16;al=(z=0,au(248,b5|0)|0);if(z){z=0;break}c[am+8>>2]=al;cd=b5|1;c[am>>2]=cd;c[am+4>>2]=v;cn=al;co=cd&255;cp=am}LF(cn|0,ci|0,v)|0;a[cn+v|0]=0;cl=co;cm=cp;aU=342;break L492}}while(0);v=bT(-1,-1)|0;cq=v;cr=M}}while(0);do{if((aU|0)==342){cp=b+44|0;co=u;c[co>>2]=c[cp>>2];c[co+4>>2]=c[cp+4>>2];c[co+8>>2]=c[cp+8>>2];cp=u;co=s;cn=t;ck=cj;L507:do{if((cl&1)==0){c[co>>2]=c[cm>>2];c[co+4>>2]=c[cm+4>>2];c[co+8>>2]=c[cm+8>>2];aU=352}else{v=c[am+8>>2]|0;ci=c[am+4>>2]|0;do{if(ci>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ci>>>0<11>>>0){a[co]=ci<<1;ct=s+1|0}else{cd=ci+16&-16;al=(z=0,au(248,cd|0)|0);if(z){z=0;break}c[s+8>>2]=al;c[s>>2]=cd|1;c[s+4>>2]=ci;ct=al}LF(ct|0,v|0,ci)|0;a[ct+ci|0]=0;aU=352;break L507}}while(0);ci=bT(-1,-1)|0;cu=M;cv=ci}}while(0);do{if((aU|0)==352){c[cn>>2]=c[cp>>2];c[cn+4>>2]=c[cp+4>>2];c[cn+8>>2]=c[cp+8>>2];z=0;aD(6,ck|0,s|0,t|0,0,0,0);if(z){z=0;ci=bT(-1,-1)|0;v=M;if((a[co]&1)==0){cu=v;cv=ci;break}Lw(c[s+8>>2]|0);cu=v;cv=ci;break}if((a[co]&1)!=0){Lw(c[s+8>>2]|0)}c[cj>>2]=19520;c[cj+32>>2]=6;if((a[cm]&1)==0){bz=ck;i=d;return bz|0}Lw(c[am+8>>2]|0);bz=ck;i=d;return bz|0}}while(0);ck=cv;co=cu;if((a[cm]&1)==0){cq=ck;cr=co;break}Lw(c[am+8>>2]|0);cq=ck;cr=co}}while(0);am=c[ch>>2]|0;ch=c[ca>>2]|0;cm=am;while(1){if((cm|0)==(ch|0)){cw=ch;break}if((c[cm>>2]|0)==(cj|0)){cw=cm;break}else{cm=cm+4|0}}cm=cw-am>>2;cw=am+(cm+1<<2)|0;cj=ch-cw|0;LG(am+(cm<<2)|0,cw|0,cj|0)|0;cw=am+((cj>>2)+cm<<2)|0;cm=c[ca>>2]|0;if((cw|0)!=(cm|0)){c[ca>>2]=cm+(~((cm-4+(-cw|0)|0)>>>2)<<2)}Lw(cg);bB=cq;bC=cr;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((uu(b)|0)!=0){cr=c[b>>2]|0;cq=Lu(52)|0;c[r>>2]=cq;cg=cr+4|0;cw=c[cg>>2]|0;if((cw|0)==(c[cr+8>>2]|0)){e4(cr|0,r);cx=c[r>>2]|0}else{if((cw|0)==0){cy=0}else{c[cw>>2]=cq;cy=c[cg>>2]|0}c[cg>>2]=cy+4;cx=cq}cq=cx;cy=b+28|0;L554:do{if((a[cy]&1)==0){cw=an;c[cw>>2]=c[cy>>2];c[cw+4>>2]=c[cy+4>>2];c[cw+8>>2]=c[cy+8>>2];aU=385}else{cw=c[b+36>>2]|0;r=c[b+32>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(r>>>0<11>>>0){a[an]=r<<1;cz=an+1|0}else{cm=r+16&-16;ca=(z=0,au(248,cm|0)|0);if(z){z=0;break}c[an+8>>2]=ca;c[an>>2]=cm|1;c[an+4>>2]=r;cz=ca}LF(cz|0,cw|0,r)|0;a[cz+r|0]=0;aU=385;break L554}}while(0);r=bT(-1,-1)|0;cA=r;cC=M}}while(0);do{if((aU|0)==385){cz=b+44|0;cy=q;c[cy>>2]=c[cz>>2];c[cy+4>>2]=c[cz+4>>2];c[cy+8>>2]=c[cz+8>>2];z=0;aq(14,cx|0,an|0,q|0,b+56|0,0);if(z){z=0;cz=bT(-1,-1)|0;cy=cz;cz=M;if((a[an]&1)==0){cA=cy;cC=cz;break}Lw(c[an+8>>2]|0);cA=cy;cC=cz;break}if((a[an]&1)!=0){Lw(c[an+8>>2]|0)}a[cx+28|0]=1;bz=cx;i=d;return bz|0}}while(0);an=c[cr>>2]|0;cr=c[cg>>2]|0;q=an;while(1){if((q|0)==(cr|0)){cD=cr;break}if((c[q>>2]|0)==(cx|0)){cD=q;break}else{q=q+4|0}}q=cD-an>>2;cD=an+(q+1<<2)|0;cx=cr-cD|0;LG(an+(q<<2)|0,cD|0,cx|0)|0;cD=an+((cx>>2)+q<<2)|0;q=c[cg>>2]|0;if((cD|0)!=(q|0)){c[cg>>2]=q+(~((q-4+(-cD|0)|0)>>>2)<<2)}Lw(cq);bB=cA;bC=cC;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vN(b)|0)!=0){cC=c[b>>2]|0;cA=Lu(52)|0;c[p>>2]=cA;cq=cC+4|0;cD=c[cq>>2]|0;if((cD|0)==(c[cC+8>>2]|0)){e4(cC|0,p);cE=c[p>>2]|0}else{if((cD|0)==0){cF=0}else{c[cD>>2]=cA;cF=c[cq>>2]|0}c[cq>>2]=cF+4;cE=cA}cA=cE;cF=cE;cD=b+28|0;L596:do{if((a[cD]&1)==0){p=ao;c[p>>2]=c[cD>>2];c[p+4>>2]=c[cD+4>>2];c[p+8>>2]=c[cD+8>>2];aU=414}else{p=c[b+36>>2]|0;q=c[b+32>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[ao]=q<<1;cG=ao+1|0}else{cg=q+16&-16;cx=(z=0,au(248,cg|0)|0);if(z){z=0;break}c[ao+8>>2]=cx;c[ao>>2]=cg|1;c[ao+4>>2]=q;cG=cx}LF(cG|0,p|0,q)|0;a[cG+q|0]=0;aU=414;break L596}}while(0);q=bT(-1,-1)|0;cH=q;cI=M}}while(0);do{if((aU|0)==414){cG=ap;cD=b+44|0;c[cG>>2]=c[cD>>2];c[cG+4>>2]=c[cD+4>>2];c[cG+8>>2]=c[cD+8>>2];cD=c[b+56>>2]|0;q=(c[b+60>>2]|0)-cD|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aU=427;break}return 0}else{if(q>>>0<11>>>0){a[at]=q<<1;cJ=at+1|0}else{p=q+16&-16;cx=(z=0,au(248,p|0)|0);if(z){z=0;aU=427;break}c[at+8>>2]=cx;c[at>>2]=p|1;c[at+4>>2]=q;cJ=cx}LF(cJ|0,cD|0,q)|0;a[cJ+q|0]=0;cx=o;c[cx>>2]=c[cG>>2];c[cx+4>>2]=c[cG+4>>2];c[cx+8>>2]=c[cG+8>>2];z=0;aq(34,cF|0,ao|0,o|0,1,at|0);if(z){z=0;cx=bT(-1,-1)|0;p=cx;cx=M;if((a[at]&1)==0){cK=p;cL=cx;break}Lw(c[at+8>>2]|0);cK=p;cL=cx;break}if((a[at]&1)!=0){Lw(c[at+8>>2]|0)}cx=cE;if((a[ao]&1)==0){bz=cx;i=d;return bz|0}Lw(c[ao+8>>2]|0);bz=cx;i=d;return bz|0}}while(0);if((aU|0)==427){cG=bT(-1,-1)|0;cK=cG;cL=M}if((a[ao]&1)==0){cH=cK;cI=cL;break}Lw(c[ao+8>>2]|0);cH=cK;cI=cL}}while(0);cL=c[cC>>2]|0;cC=c[cq>>2]|0;cK=cL;while(1){if((cK|0)==(cC|0)){cM=cC;break}if((c[cK>>2]|0)==(cE|0)){cM=cK;break}else{cK=cK+4|0}}cK=cM-cL>>2;cM=cL+(cK+1<<2)|0;cE=cC-cM|0;LG(cL+(cK<<2)|0,cM|0,cE|0)|0;cM=cL+((cE>>2)+cK<<2)|0;cK=c[cq>>2]|0;if((cM|0)!=(cK|0)){c[cq>>2]=cK+(~((cK-4+(-cM|0)|0)>>>2)<<2)}Lw(cA);bB=cH;bC=cI;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vO(b)|0)!=0){cI=c[b>>2]|0;cH=Lu(52)|0;c[n>>2]=cH;cA=cI+4|0;cM=c[cA>>2]|0;if((cM|0)==(c[cI+8>>2]|0)){e4(cI|0,n);cN=c[n>>2]|0}else{if((cM|0)==0){cO=0}else{c[cM>>2]=cH;cO=c[cA>>2]|0}c[cA>>2]=cO+4;cN=cH}cH=cN;cO=cN;cM=b+28|0;L654:do{if((a[cM]&1)==0){n=av;c[n>>2]=c[cM>>2];c[n+4>>2]=c[cM+4>>2];c[n+8>>2]=c[cM+8>>2];aU=454}else{n=c[b+36>>2]|0;cK=c[b+32>>2]|0;do{if(cK>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(cK>>>0<11>>>0){a[av]=cK<<1;cP=av+1|0}else{cq=cK+16&-16;cE=(z=0,au(248,cq|0)|0);if(z){z=0;break}c[av+8>>2]=cE;c[av>>2]=cq|1;c[av+4>>2]=cK;cP=cE}LF(cP|0,n|0,cK)|0;a[cP+cK|0]=0;aU=454;break L654}}while(0);cK=bT(-1,-1)|0;cQ=cK;cR=M}}while(0);do{if((aU|0)==454){cP=aw;cM=b+44|0;c[cP>>2]=c[cM>>2];c[cP+4>>2]=c[cM+4>>2];c[cP+8>>2]=c[cM+8>>2];cM=c[b+56>>2]|0;cK=(c[b+60>>2]|0)-cM|0;do{if(cK>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aU=467;break}return 0}else{if(cK>>>0<11>>>0){a[ax]=cK<<1;cS=ax+1|0}else{n=cK+16&-16;cE=(z=0,au(248,n|0)|0);if(z){z=0;aU=467;break}c[ax+8>>2]=cE;c[ax>>2]=n|1;c[ax+4>>2]=cK;cS=cE}LF(cS|0,cM|0,cK)|0;a[cS+cK|0]=0;cE=m;c[cE>>2]=c[cP>>2];c[cE+4>>2]=c[cP+4>>2];c[cE+8>>2]=c[cP+8>>2];z=0;aq(34,cO|0,av|0,m|0,2,ax|0);if(z){z=0;cE=bT(-1,-1)|0;n=cE;cE=M;if((a[ax]&1)==0){cT=n;cU=cE;break}Lw(c[ax+8>>2]|0);cT=n;cU=cE;break}if((a[ax]&1)!=0){Lw(c[ax+8>>2]|0)}cE=cN;if((a[av]&1)==0){bz=cE;i=d;return bz|0}Lw(c[av+8>>2]|0);bz=cE;i=d;return bz|0}}while(0);if((aU|0)==467){cP=bT(-1,-1)|0;cT=cP;cU=M}if((a[av]&1)==0){cQ=cT;cR=cU;break}Lw(c[av+8>>2]|0);cQ=cT;cR=cU}}while(0);cU=c[cI>>2]|0;cI=c[cA>>2]|0;cT=cU;while(1){if((cT|0)==(cI|0)){cV=cI;break}if((c[cT>>2]|0)==(cN|0)){cV=cT;break}else{cT=cT+4|0}}cT=cV-cU>>2;cV=cU+(cT+1<<2)|0;cN=cI-cV|0;LG(cU+(cT<<2)|0,cV|0,cN|0)|0;cV=cU+((cN>>2)+cT<<2)|0;cT=c[cA>>2]|0;if((cV|0)!=(cT|0)){c[cA>>2]=cT+(~((cT-4+(-cV|0)|0)>>>2)<<2)}Lw(cH);bB=cQ;bC=cR;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((uT(b)|0)!=0){cR=c[b>>2]|0;cQ=Lu(52)|0;c[l>>2]=cQ;cH=cR+4|0;cV=c[cH>>2]|0;if((cV|0)==(c[cR+8>>2]|0)){e4(cR|0,l);cW=c[l>>2]|0}else{if((cV|0)==0){cX=0}else{c[cV>>2]=cQ;cX=c[cH>>2]|0}c[cH>>2]=cX+4;cW=cQ}cQ=cW;cX=cW;cV=b+28|0;L712:do{if((a[cV]&1)==0){l=ay;c[l>>2]=c[cV>>2];c[l+4>>2]=c[cV+4>>2];c[l+8>>2]=c[cV+8>>2];aU=494}else{l=c[b+36>>2]|0;cT=c[b+32>>2]|0;do{if(cT>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(cT>>>0<11>>>0){a[ay]=cT<<1;cY=ay+1|0}else{cA=cT+16&-16;cN=(z=0,au(248,cA|0)|0);if(z){z=0;break}c[ay+8>>2]=cN;c[ay>>2]=cA|1;c[ay+4>>2]=cT;cY=cN}LF(cY|0,l|0,cT)|0;a[cY+cT|0]=0;aU=494;break L712}}while(0);cT=bT(-1,-1)|0;cZ=cT;c_=M}}while(0);do{if((aU|0)==494){cY=aA;cV=b+44|0;c[cY>>2]=c[cV>>2];c[cY+4>>2]=c[cV+4>>2];c[cY+8>>2]=c[cV+8>>2];cV=c[b+56>>2]|0;cT=(c[b+60>>2]|0)-cV|0;do{if(cT>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aU=507;break}return 0}else{if(cT>>>0<11>>>0){a[aB]=cT<<1;c$=aB+1|0}else{l=cT+16&-16;cN=(z=0,au(248,l|0)|0);if(z){z=0;aU=507;break}c[aB+8>>2]=cN;c[aB>>2]=l|1;c[aB+4>>2]=cT;c$=cN}LF(c$|0,cV|0,cT)|0;a[c$+cT|0]=0;cN=k;c[cN>>2]=c[cY>>2];c[cN+4>>2]=c[cY+4>>2];c[cN+8>>2]=c[cY+8>>2];z=0;aq(34,cX|0,ay|0,k|0,0,aB|0);if(z){z=0;cN=bT(-1,-1)|0;l=cN;cN=M;if((a[aB]&1)==0){c0=l;c1=cN;break}Lw(c[aB+8>>2]|0);c0=l;c1=cN;break}if((a[aB]&1)!=0){Lw(c[aB+8>>2]|0)}cN=cW;if((a[ay]&1)==0){bz=cN;i=d;return bz|0}Lw(c[ay+8>>2]|0);bz=cN;i=d;return bz|0}}while(0);if((aU|0)==507){cY=bT(-1,-1)|0;c0=cY;c1=M}if((a[ay]&1)==0){cZ=c0;c_=c1;break}Lw(c[ay+8>>2]|0);cZ=c0;c_=c1}}while(0);c1=c[cR>>2]|0;cR=c[cH>>2]|0;c0=c1;while(1){if((c0|0)==(cR|0)){c2=cR;break}if((c[c0>>2]|0)==(cW|0)){c2=c0;break}else{c0=c0+4|0}}c0=c2-c1>>2;c2=c1+(c0+1<<2)|0;cW=cR-c2|0;LG(c1+(c0<<2)|0,c2|0,cW|0)|0;c2=c1+((cW>>2)+c0<<2)|0;c0=c[cH>>2]|0;if((c2|0)!=(c0|0)){c[cH>>2]=c0+(~((c0-4+(-c2|0)|0)>>>2)<<2)}Lw(cQ);bB=cZ;bC=c_;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((vP(b)|0)!=0){c_=c[b>>2]|0;cZ=Lu(52)|0;c[j>>2]=cZ;cQ=c_+4|0;c2=c[cQ>>2]|0;if((c2|0)==(c[c_+8>>2]|0)){e4(c_|0,j);c3=c[j>>2]|0}else{if((c2|0)==0){c4=0}else{c[c2>>2]=cZ;c4=c[cQ>>2]|0}c[cQ>>2]=c4+4;c3=cZ}cZ=c3;c4=c3;c2=b+28|0;L770:do{if((a[c2]&1)==0){j=aC;c[j>>2]=c[c2>>2];c[j+4>>2]=c[c2+4>>2];c[j+8>>2]=c[c2+8>>2];aU=534}else{j=c[b+36>>2]|0;c0=c[b+32>>2]|0;do{if(c0>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(c0>>>0<11>>>0){a[aC]=c0<<1;c5=aC+1|0}else{cH=c0+16&-16;cW=(z=0,au(248,cH|0)|0);if(z){z=0;break}c[aC+8>>2]=cW;c[aC>>2]=cH|1;c[aC+4>>2]=c0;c5=cW}LF(c5|0,j|0,c0)|0;a[c5+c0|0]=0;aU=534;break L770}}while(0);c0=bT(-1,-1)|0;c6=c0;c7=M}}while(0);do{if((aU|0)==534){c5=aE;c2=b+44|0;c[c5>>2]=c[c2>>2];c[c5+4>>2]=c[c2+4>>2];c[c5+8>>2]=c[c2+8>>2];c2=c[b+56>>2]|0;c0=(c[b+60>>2]|0)-c2|0;do{if(c0>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aU=547;break}return 0}else{if(c0>>>0<11>>>0){a[aF]=c0<<1;c8=aF+1|0}else{j=c0+16&-16;cW=(z=0,au(248,j|0)|0);if(z){z=0;aU=547;break}c[aF+8>>2]=cW;c[aF>>2]=j|1;c[aF+4>>2]=c0;c8=cW}LF(c8|0,c2|0,c0)|0;a[c8+c0|0]=0;cW=h;c[cW>>2]=c[c5>>2];c[cW+4>>2]=c[c5+4>>2];c[cW+8>>2]=c[c5+8>>2];z=0;aq(34,c4|0,aC|0,h|0,3,aF|0);if(z){z=0;cW=bT(-1,-1)|0;j=cW;cW=M;if((a[aF]&1)==0){c9=j;da=cW;break}Lw(c[aF+8>>2]|0);c9=j;da=cW;break}if((a[aF]&1)!=0){Lw(c[aF+8>>2]|0)}cW=c3;if((a[aC]&1)==0){bz=cW;i=d;return bz|0}Lw(c[aC+8>>2]|0);bz=cW;i=d;return bz|0}}while(0);if((aU|0)==547){c5=bT(-1,-1)|0;c9=c5;da=M}if((a[aC]&1)==0){c6=c9;c7=da;break}Lw(c[aC+8>>2]|0);c6=c9;c7=da}}while(0);da=c[c_>>2]|0;c_=c[cQ>>2]|0;c9=da;while(1){if((c9|0)==(c_|0)){db=c_;break}if((c[c9>>2]|0)==(c3|0)){db=c9;break}else{c9=c9+4|0}}c9=db-da>>2;db=da+(c9+1<<2)|0;c3=c_-db|0;LG(da+(c9<<2)|0,db|0,c3|0)|0;db=da+((c3>>2)+c9<<2)|0;c9=c[cQ>>2]|0;if((db|0)!=(c9|0)){c[cQ>>2]=c9+(~((c9-4+(-db|0)|0)>>>2)<<2)}Lw(cZ);bB=c6;bC=c7;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}if((yY(y$(c[b+20>>2]|0)|0)|0)!=0){ul(b)|0;c7=b+56|0;c6=c[c7+4>>2]|0;c[e>>2]=c[c7>>2];c[e+4>>2]=c6;bz=t6(b,e)|0;i=d;return bz|0}if((uy(b)|0)==0){e=c[b+56>>2]|0;c6=(c[b+60>>2]|0)-e|0;if(c6>>>0>4294967279>>>0){D5(0);return 0}if(c6>>>0<11>>>0){c7=c6<<1&255;cZ=aK;db=aK;a[db]=c7;dc=cZ+1|0;dd=c7;de=cZ;df=db}else{db=c6+16&-16;cZ=Lu(db)|0;c[aK+8>>2]=cZ;c7=db|1;c[aK>>2]=c7;c[aK+4>>2]=c6;dc=cZ;dd=c7&255;de=aK;df=aK}LF(dc|0,e|0,c6)|0;a[dc+c6|0]=0;c6=aJ;LI(c6|0,0,12)|0;dc=dd&255;if((dc&1|0)==0){dg=dc>>>1}else{dg=c[aK+4>>2]|0}dc=dg+27|0;do{if(dc>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aU=619;break}return 0}else{if(dc>>>0<11>>>0){a[c6]=54;dh=aJ+1|0}else{e=dg+43&-16;c7=(z=0,au(248,e|0)|0);if(z){z=0;aU=619;break}c[aJ+8>>2]=c7;c[aJ>>2]=e|1;c[aJ+4>>2]=27;dh=c7}LF(dh|0,4880,27)|0;a[dh+27|0]=0;if((dd&1)==0){di=de+1|0}else{di=c[aK+8>>2]|0}z=0,az(88,aJ|0,di|0,dg|0)|0;if(z){z=0;aU=619;break}c[aL>>2]=0;c[aL+4>>2]=0;c[aL+8>>2]=0;z=0;aR(492,b|0,aJ|0,aL|0);if(z){z=0;c7=bT(-1,-1)|0;e=c7;c7=M;if((a[c6]&1)==0){dj=e;dk=c7;break}Lw(c[aJ+8>>2]|0);dj=e;dk=c7;break}if((a[c6]&1)!=0){Lw(c[aJ+8>>2]|0)}if((a[df]&1)==0){bz=0;i=d;return bz|0}Lw(c[aK+8>>2]|0);bz=0;i=d;return bz|0}}while(0);if((aU|0)==619){aL=bT(-1,-1)|0;dg=M;if((a[c6]&1)!=0){Lw(c[aJ+8>>2]|0)}dj=aL;dk=dg}if((a[df]&1)==0){bB=dj;bC=dk;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}Lw(c[aK+8>>2]|0);bB=dj;bC=dk;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0)}dk=c[b>>2]|0;dj=Lu(48)|0;c[g>>2]=dj;aK=dk+4|0;df=c[aK>>2]|0;if((df|0)==(c[dk+8>>2]|0)){e4(dk|0,g);dl=c[g>>2]|0}else{if((df|0)==0){dm=0}else{c[df>>2]=dj;dm=c[aK>>2]|0}c[aK>>2]=dm+4;dl=dj}dj=dl;dm=dl;df=b+28|0;L879:do{if((a[df]&1)==0){g=aG;c[g>>2]=c[df>>2];c[g+4>>2]=c[df+4>>2];c[g+8>>2]=c[df+8>>2];aU=576}else{g=c[b+36>>2]|0;dg=c[b+32>>2]|0;do{if(dg>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(dg>>>0<11>>>0){a[aG]=dg<<1;dn=aG+1|0}else{aL=dg+16&-16;aJ=(z=0,au(248,aL|0)|0);if(z){z=0;break}c[aG+8>>2]=aJ;c[aG>>2]=aL|1;c[aG+4>>2]=dg;dn=aJ}LF(dn|0,g|0,dg)|0;a[dn+dg|0]=0;aU=576;break L879}}while(0);dg=bT(-1,-1)|0;dp=dg;dq=M}}while(0);do{if((aU|0)==576){dn=aH;df=b+44|0;c[dn>>2]=c[df>>2];c[dn+4>>2]=c[df+4>>2];c[dn+8>>2]=c[df+8>>2];df=c[b+56>>2]|0;dg=(c[b+60>>2]|0)-df|0;do{if(dg>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;aU=589;break}return 0}else{if(dg>>>0<11>>>0){a[aI]=dg<<1;dr=aI+1|0}else{g=dg+16&-16;aJ=(z=0,au(248,g|0)|0);if(z){z=0;aU=589;break}c[aI+8>>2]=aJ;c[aI>>2]=g|1;c[aI+4>>2]=dg;dr=aJ}LF(dr|0,df|0,dg)|0;a[dr+dg|0]=0;aJ=f;c[aJ>>2]=c[dn>>2];c[aJ+4>>2]=c[dn+4>>2];c[aJ+8>>2]=c[dn+8>>2];z=0;aV(2,dm|0,aG|0,f|0,aI|0);if(z){z=0;aJ=bT(-1,-1)|0;g=aJ;aJ=M;if((a[aI]&1)==0){ds=g;dt=aJ;break}Lw(c[aI+8>>2]|0);ds=g;dt=aJ;break}if((a[aI]&1)!=0){Lw(c[aI+8>>2]|0)}aJ=dl;if((a[aG]&1)==0){bz=aJ;i=d;return bz|0}Lw(c[aG+8>>2]|0);bz=aJ;i=d;return bz|0}}while(0);if((aU|0)==589){dn=bT(-1,-1)|0;ds=dn;dt=M}if((a[aG]&1)==0){dp=ds;dq=dt;break}Lw(c[aG+8>>2]|0);dp=ds;dq=dt}}while(0);dt=c[dk>>2]|0;dk=c[aK>>2]|0;ds=dt;while(1){if((ds|0)==(dk|0)){du=dk;break}if((c[ds>>2]|0)==(dl|0)){du=ds;break}else{ds=ds+4|0}}ds=du-dt>>2;du=dt+(ds+1<<2)|0;dl=dk-du|0;LG(dt+(ds<<2)|0,du|0,dl|0)|0;du=dt+((dl>>2)+ds<<2)|0;ds=c[aK>>2]|0;if((du|0)!=(ds|0)){c[aK>>2]=ds+(~((ds-4+(-du|0)|0)>>>2)<<2)}Lw(dj);bB=dp;bC=dq;bE=bB;bF=0;bG=bE;bH=bC;bg(bG|0);return 0}function us(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y6(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function ut(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y7(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y0(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=b+56|0;n=c[m>>2]|0;o=(c[b+60>>2]|0)-n|0;if(o>>>0>4294967279>>>0){D5(0);return 0}if(o>>>0<11>>>0){p=o<<1&255;a[h]=p;q=h+1|0;r=p}else{p=o+16&-16;s=Lu(p)|0;c[h+8>>2]=s;t=p|1;c[h>>2]=t;c[h+4>>2]=o;q=s;r=t&255}LF(q|0,n|0,o)|0;a[q+o|0]=0;o=c[b>>2]|0;q=(z=0,au(248,48)|0);L8:do{if(!z){n=q;c[g>>2]=n;t=o+4|0;s=c[t>>2]|0;if((s|0)==(c[o+8>>2]|0)){z=0;as(382,o|0,g|0);if(z){z=0;u=61;break}v=c[g>>2]|0}else{if((s|0)==0){w=0}else{c[s>>2]=n;w=c[t>>2]|0}c[t>>2]=w+4;v=n}n=v;s=v;p=b+28|0;L18:do{if((a[p]&1)==0){x=j;c[x>>2]=c[p>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];u=23}else{x=c[b+36>>2]|0;y=c[b+32>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[j]=y<<1;A=j+1|0}else{B=y+16&-16;C=(z=0,au(248,B|0)|0);if(z){z=0;break}c[j+8>>2]=C;c[j>>2]=B|1;c[j+4>>2]=y;A=C}LF(A|0,x|0,y)|0;a[A+y|0]=0;u=23;break L18}}while(0);y=bT(-1,-1)|0;D=y;E=M}}while(0);do{if((u|0)==23){p=b+44|0;y=f;c[y>>2]=c[p>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];z=0;aR(476,s|0,j|0,f|0);if(z){z=0;p=bT(-1,-1)|0;y=p;p=M;if((a[j]&1)==0){D=y;E=p;break}Lw(c[j+8>>2]|0);D=y;E=p;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}p=b+20|0;y=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;u=61;break L8}x=(a[y]|0)==40?y+1|0:0;L41:do{if((x|0)!=0){C=b+48|0;B=c[C>>2]|0;F=c[p>>2]|0;L43:do{if(F>>>0<x>>>0){G=F;H=0;while(1){I=a[G]|0;if((I<<24>>24|0)==10){J=H+1|0}else if((I<<24>>24|0)==0){K=H;break L43}else{J=H}I=G+1|0;if(I>>>0<x>>>0){G=I;H=J}else{K=J;break}}}else{K=0}}while(0);c[C>>2]=K+B;H=y;G=0;while(1){I=H-1|0;if(I>>>0<F>>>0){break}if((a[I]|0)==10){break}else{H=I;G=G+1|0}}H=b+40|0;if((K|0)!=0){c[H>>2]=1}F=c[H>>2]|0;B=b+52|0;c[B>>2]=F+G;I=x;L=y;c[H>>2]=I-L+G+F;F=m;c[F>>2]=L;c[F+4>>2]=I;c[p>>2]=x;I=(z=0,au(66,x|0)|0);if(z){z=0;u=61;break L8}L58:do{if((I+1|0)==0|(a[I]|0)!=41){L=v+28|0;N=L;O=v+36|0;P=O;Q=v+40|0;R=v+32|0;S=L;while(1){L=(z=0,au(170,b|0)|0);if(z){z=0;break}c[e>>2]=L;T=c[P>>2]|0;if((T|0)==(c[Q>>2]|0)){z=0;as(502,R|0,e|0);if(z){z=0;break}U=c[e>>2]|0}else{if((T|0)==0){V=0}else{c[T>>2]=L;V=c[P>>2]|0}c[O>>2]=V+4;U=L}z=0;as(c[c[S>>2]>>2]|0,N|0,U|0);if(z){z=0;break}L=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;break}T=(a[L]|0)==44?L+1|0:0;if((T|0)==0){break L58}W=c[C>>2]|0;X=c[p>>2]|0;L74:do{if(X>>>0<T>>>0){Y=X;Z=0;while(1){_=a[Y]|0;if((_<<24>>24|0)==10){$=Z+1|0}else if((_<<24>>24|0)==0){aa=Z;break L74}else{$=Z}_=Y+1|0;if(_>>>0<T>>>0){Y=_;Z=$}else{aa=$;break}}}else{aa=0}}while(0);c[C>>2]=aa+W;Z=L;Y=0;while(1){_=Z-1|0;if(_>>>0<X>>>0){break}if((a[_]|0)==10){break}else{Z=_;Y=Y+1|0}}if((aa|0)!=0){c[H>>2]=1}Z=c[H>>2]|0;c[B>>2]=Z+Y;X=T;W=L;c[H>>2]=X-W+Y+Z;c[F>>2]=W;c[F+4>>2]=X;c[p>>2]=T}N=bT(-1,-1)|0;ab=M;ac=N;u=62;break L8}}while(0);I=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;u=61;break L8}G=(a[I]|0)==41?I+1|0:0;if((G|0)!=0){N=c[C>>2]|0;S=c[p>>2]|0;L93:do{if(S>>>0<G>>>0){O=S;P=0;while(1){R=a[O]|0;if((R<<24>>24|0)==10){ad=P+1|0}else if((R<<24>>24|0)==0){ae=P;break L93}else{ad=P}R=O+1|0;if(R>>>0<G>>>0){O=R;P=ad}else{ae=ad;break}}}else{ae=0}}while(0);c[C>>2]=ae+N;P=I;O=0;while(1){R=P-1|0;if(R>>>0<S>>>0){break}if((a[R]|0)==10){break}else{P=R;O=O+1|0}}if((ae|0)!=0){c[H>>2]=1}P=c[H>>2]|0;c[B>>2]=P+O;S=G;N=I;c[H>>2]=S-N+O+P;c[F>>2]=N;c[F+4>>2]=S;c[p>>2]=G;break}S=k;LI(S|0,0,12)|0;N=h;P=r&255;if((P&1|0)==0){af=P>>>1}else{af=c[h+4>>2]|0}P=af+69|0;do{if(P>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(P>>>0<11>>>0){a[S]=-118;ag=k+1|0}else{C=af+85&-16;R=(z=0,au(248,C|0)|0);if(z){z=0;break}c[k+8>>2]=R;c[k>>2]=C|1;c[k+4>>2]=69;ag=R}LF(ag|0,9920,69)|0;a[ag+69|0]=0;if((r&1)==0){ah=N+1|0}else{ah=c[h+8>>2]|0}z=0,az(88,k|0,ah|0,af|0)|0;if(z){z=0;break}c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z=0;aR(492,b|0,k|0,l|0);if(!z){if((a[S]&1)==0){break L41}Lw(c[k+8>>2]|0);break L41}else{z=0;R=bT(-1,-1)|0;C=R;R=M;if((a[S]&1)==0){ai=C;aj=R;break L8}Lw(c[k+8>>2]|0);ai=C;aj=R;break L8}}}while(0);N=bT(-1,-1)|0;P=M;if((a[S]&1)==0){ab=P;ac=N;u=62;break L8}Lw(c[k+8>>2]|0);ab=P;ac=N;u=62;break L8}}while(0);if((a[h]&1)==0){i=d;return s|0}Lw(c[h+8>>2]|0);i=d;return s|0}}while(0);s=c[o>>2]|0;p=c[t>>2]|0;x=s;while(1){if((x|0)==(p|0)){ak=p;break}if((c[x>>2]|0)==(v|0)){ak=x;break}else{x=x+4|0}}x=ak-s>>2;y=s+(x+1<<2)|0;N=p-y|0;LG(s+(x<<2)|0,y|0,N|0)|0;y=s+((N>>2)+x<<2)|0;x=c[t>>2]|0;if((y|0)!=(x|0)){c[t>>2]=x+(~((x-4+(-y|0)|0)>>>2)<<2)}Lw(n);ai=D;aj=E}else{z=0;u=61}}while(0);if((u|0)==61){E=bT(-1,-1)|0;ab=M;ac=E;u=62}if((u|0)==62){ai=ac;aj=ab}if((a[h]&1)==0){al=ai;am=0;an=al;ao=aj;bg(an|0)}Lw(c[h+8>>2]|0);al=ai;am=0;an=al;ao=aj;bg(an|0);return 0}function uw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ee=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0,ep=0,eq=0,er=0,es=0,et=0,eu=0,ev=0,ew=0,ex=0,ey=0,ez=0,eA=0,eB=0,eC=0,eD=0,eE=0,eF=0,eG=0,eH=0,eI=0,eJ=0,eK=0,eL=0,eM=0,eN=0,eO=0,eP=0,eQ=0,eR=0,eS=0,eT=0,eU=0,eV=0,eW=0,eX=0,eY=0,eZ=0,e_=0,e$=0,e0=0,e1=0,e2=0,e3=0,e5=0,e6=0,e7=0,e8=0,e9=0,fa=0,fb=0,fc=0,fd=0,fe=0,ff=0,fg=0,fh=0,fi=0,fj=0,fk=0,fl=0,fm=0,fn=0,fo=0,fp=0,fq=0,fr=0,fs=0,ft=0,fu=0,fv=0,fw=0,fx=0,fy=0,fz=0,fA=0,fB=0,fC=0,fD=0,fE=0,fF=0,fG=0,fH=0,fI=0,fJ=0,fK=0,fL=0,fM=0,fN=0,fO=0,fP=0,fQ=0,fR=0,fS=0,fT=0,fU=0,fV=0,fW=0,fX=0,fY=0,fZ=0,f_=0,f$=0,f0=0,f1=0,f2=0,f3=0,f4=0,f5=0,f6=0,f7=0,f8=0,f9=0;d=i;i=i+496|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=d+48|0;m=d+56|0;n=d+64|0;o=d+72|0;p=d+80|0;q=d+88|0;r=d+96|0;s=d+112|0;t=d+128|0;u=d+144|0;v=d+152|0;w=d+160|0;x=d+176|0;y=d+192|0;A=d+208|0;B=d+216|0;C=d+224|0;D=d+232|0;E=d+240|0;F=d+248|0;G=d+264|0;H=d+280|0;I=d+296|0;J=d+304|0;K=d+312|0;L=d+320|0;N=d+328|0;O=d+336|0;P=d+344|0;Q=d+352|0;R=d+368|0;S=d+376|0;T=d+384|0;U=d+392|0;V=d+400|0;W=d+408|0;X=d+416|0;Y=d+432|0;Z=d+440|0;_=d+456|0;$=d+472|0;aa=d+488|0;ab=aa;ac=i;i=i+12|0;i=i+7&-8;ad=i;i=i+12|0;i=i+7&-8;ae=i;i=i+8|0;af=ae;ag=i;i=i+12|0;i=i+7&-8;ah=i;i=i+12|0;i=i+7&-8;ai=i;i=i+12|0;i=i+7&-8;aj=i;i=i+12|0;i=i+7&-8;ak=i;i=i+12|0;i=i+7&-8;al=i;i=i+12|0;i=i+7&-8;am=i;i=i+12|0;i=i+7&-8;an=i;i=i+12|0;i=i+7&-8;ao=i;i=i+12|0;i=i+7&-8;ap=i;i=i+12|0;i=i+7&-8;at=i;i=i+12|0;i=i+7&-8;av=i;i=i+12|0;i=i+7&-8;aw=i;i=i+12|0;i=i+7&-8;ax=i;i=i+12|0;i=i+7&-8;ay=i;i=i+8|0;az=i;i=i+12|0;i=i+7&-8;aA=i;i=i+12|0;i=i+7&-8;aB=i;i=i+12|0;i=i+7&-8;aC=i;i=i+8|0;aD=i;i=i+8|0;aE=i;i=i+12|0;i=i+7&-8;aF=i;i=i+12|0;i=i+7&-8;aG=i;i=i+8|0;aH=aG;aI=i;i=i+12|0;i=i+7&-8;aJ=i;i=i+12|0;i=i+7&-8;aK=b+20|0;aL=y$(c[aK>>2]|0)|0;aM=(a[aL]|0)==123?aL+1|0:0;if((aM|0)!=0){aN=b+48|0;aO=c[aN>>2]|0;aP=c[aK>>2]|0;L3:do{if(aP>>>0<aM>>>0){aQ=aP;aS=0;while(1){aT=a[aQ]|0;if((aT<<24>>24|0)==10){aU=aS+1|0}else if((aT<<24>>24|0)==0){aW=aS;break L3}else{aU=aS}aT=aQ+1|0;if(aT>>>0<aM>>>0){aQ=aT;aS=aU}else{aW=aU;break}}}else{aW=0}}while(0);c[aN>>2]=aW+aO;aO=aL;aN=0;while(1){aU=aO-1|0;if(aU>>>0<aP>>>0){break}if((a[aU]|0)==10){break}else{aO=aU;aN=aN+1|0}}aO=b+40|0;if((aW|0)!=0){c[aO>>2]=1}aW=c[aO>>2]|0;c[b+52>>2]=aW+aN;aP=aM;aU=aL;c[aO>>2]=aP-aU+aN+aW;aW=b+56|0;c[aW>>2]=aU;c[aW+4>>2]=aP;c[aK>>2]=aM}aM=b|0;aP=c[aM>>2]|0;aW=Lu(48)|0;c[Y>>2]=aW;aU=aP+4|0;aN=c[aU>>2]|0;if((aN|0)==(c[aP+8>>2]|0)){e4(aP|0,Y);aX=c[Y>>2]|0}else{if((aN|0)==0){aY=0}else{c[aN>>2]=aW;aY=c[aU>>2]|0}c[aU>>2]=aY+4;aX=aW}aW=aX;aY=aX;aN=b+28|0;L25:do{if((a[aN]&1)==0){Y=Z;c[Y>>2]=c[aN>>2];c[Y+4>>2]=c[aN+4>>2];c[Y+8>>2]=c[aN+8>>2];aZ=27}else{Y=c[b+36>>2]|0;aO=c[b+32>>2]|0;do{if(aO>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aO>>>0<11>>>0){a[Z]=aO<<1;a_=Z+1|0}else{aL=aO+16&-16;aS=(z=0,au(248,aL|0)|0);if(z){z=0;break}c[Z+8>>2]=aS;c[Z>>2]=aL|1;c[Z+4>>2]=aO;a_=aS}LF(a_|0,Y|0,aO)|0;a[a_+aO|0]=0;aZ=27;break L25}}while(0);aO=bT(-1,-1)|0;a$=aO;a0=M}}while(0);do{if((aZ|0)==27){a_=b+44|0;aO=X;c[aO>>2]=c[a_>>2];c[aO+4>>2]=c[a_+4>>2];c[aO+8>>2]=c[a_+8>>2];z=0;aq(4,aY|0,Z|0,X|0,0,0);if(z){z=0;aO=bT(-1,-1)|0;Y=aO;aO=M;if((a[Z]&1)==0){a$=Y;a0=aO;break}Lw(c[Z+8>>2]|0);a$=Y;a0=aO;break}if((a[Z]&1)!=0){Lw(c[Z+8>>2]|0)}aO=_+8|0;Y=_|0;aS=_+4|0;aL=$|0;aQ=$+4|0;aT=$+8|0;a1=_;a2=b+48|0;a3=b+40|0;a4=b+52|0;a5=b+56|0;a6=ac;a7=ad;a8=aX+28|0;a9=a8;ba=aX+36|0;bb=ba;bc=aX+40|0;bd=aX+32|0;be=a8;a8=ac+8|0;bf=b+36|0;bh=b+32|0;bi=ac+1|0;bj=ac|0;bk=ac+4|0;bl=b+8|0;bm=ap+8|0;bn=ap|0;bo=ap+4|0;bp=at|0;bq=at+4|0;br=at+8|0;bs=ap;bt=aC|0;bu=aE;bv=aF;bw=aE+8|0;bx=aE+1|0;by=aE|0;bz=aE+4|0;bA=aC+4|0;bB=aD|0;bC=aD+4|0;bD=ay|0;bE=az+8|0;bF=az|0;bG=az+4|0;bH=aA|0;bI=aA+4|0;bJ=aA+8|0;bK=az;bL=ay+4|0;bM=aB;bN=t;bO=r;bP=s;bQ=aB+8|0;bR=r+8|0;bS=aB+4|0;bU=r+1|0;bV=r|0;bW=r+4|0;bX=aB+1|0;bY=aB|0;bZ=ax;b_=y;b$=w;b0=x;b1=ax+8|0;b2=w+8|0;b3=ax+4|0;b4=w+1|0;b5=w|0;b6=w+4|0;b7=ax+1|0;b8=ax|0;b9=av+8|0;ca=av|0;cb=av+4|0;cc=aw|0;cd=aw+4|0;ce=aw+8|0;cf=av;cg=an;ch=ao;ci=H;cj=F;ck=G;cl=an+8|0;cm=F+8|0;cn=an+4|0;co=F+1|0;cp=F|0;cq=F+4|0;cr=an+1|0;cs=an|0;ct=ai+8|0;cu=ai|0;cv=ai+4|0;cw=aj|0;cx=aj+4|0;cy=aj+8|0;cz=ai;cA=ak;cC=al;cD=am;cE=Q;cF=ak+8|0;cG=am+8|0;cH=am+1|0;cI=am|0;cJ=am+4|0;cK=ak+1|0;cL=ak|0;cM=ak+4|0;cN=ag;cO=ah;cP=ag+8|0;cQ=ag+1|0;cR=ag|0;cS=ag+4|0;cT=aI;cU=aJ;cV=aI+8|0;cW=aI+1|0;cX=aI|0;cY=aI+4|0;cZ=0;L47:while(1){c_=y$(c[aK>>2]|0)|0;c$=(a[c_]|0)==125?c_+1|0:0;if((c$|0)!=0){aZ=32;break}if(cZ){c0=y$(c[aK>>2]|0)|0;c1=(a[c0]|0)==59?c0+1|0:0;do{if((c1|0)==0){c2=Lu(64)|0;c[aO>>2]=c2;c[Y>>2]=65;c[aS>>2]=55;LF(c2|0,7088,55)|0;a[c2+55|0]=0;c[aL>>2]=0;c[aQ>>2]=0;c[aT>>2]=0;z=0;aR(492,b|0,_|0,$|0);if(z){z=0;aZ=67;break L47}if((a[a1]&1)==0){break}Lw(c[aO>>2]|0)}else{c2=c[a2>>2]|0;c3=c[aK>>2]|0;L57:do{if(c3>>>0<c1>>>0){c4=c3;c5=0;while(1){c6=a[c4]|0;if((c6<<24>>24|0)==10){c7=c5+1|0}else if((c6<<24>>24|0)==0){c8=c5;break L57}else{c7=c5}c6=c4+1|0;if(c6>>>0<c1>>>0){c4=c6;c5=c7}else{c8=c7;break}}}else{c8=0}}while(0);c[a2>>2]=c8+c2;c5=c0;c4=0;while(1){c6=c5-1|0;if(c6>>>0<c3>>>0){break}if((a[c6]|0)==10){break}else{c5=c6;c4=c4+1|0}}if((c8|0)!=0){c[a3>>2]=1}c5=c[a3>>2]|0;c[a4>>2]=c5+c4;c3=c1;c2=c0;c[a3>>2]=c3-c2+c4+c5;c[a5>>2]=c2;c[a5+4>>2]=c3;c[aK>>2]=c1}}while(0);if((t5(b)|0)!=0){do{c1=c[a5+4>>2]|0;c[aa>>2]=c[a5>>2];c[aa+4>>2]=c1;c1=t6(b,ab)|0;c9=c[aM>>2]|0;c0=Lu(32)|0;c[W>>2]=c0;da=c9+4|0;c3=c[da>>2]|0;if((c3|0)==(c[c9+8>>2]|0)){e4(c9|0,W);db=c[W>>2]|0}else{if((c3|0)==0){dc=0}else{c[c3>>2]=c0;dc=c[da>>2]|0}c[da>>2]=dc+4;db=c0}dd=db;if((a[aN]&1)==0){c[a6>>2]=c[aN>>2];c[a6+4>>2]=c[aN+4>>2];c[a6+8>>2]=c[aN+8>>2]}else{c0=c[bf>>2]|0;c3=c[bh>>2]|0;if(c3>>>0>4294967279>>>0){aZ=77;break L47}if(c3>>>0<11>>>0){a[a6]=c3<<1;de=bi}else{c2=c3+16&-16;c5=(z=0,au(248,c2|0)|0);if(z){z=0;aZ=93;break L47}c[a8>>2]=c5;c[bj>>2]=c2|1;c[bk>>2]=c3;de=c5}LF(de|0,c0|0,c3)|0;a[de+c3|0]=0}c[a7>>2]=c[a_>>2];c[a7+4>>2]=c[a_+4>>2];c[a7+8>>2]=c[a_+8>>2];z=0;aV(32,db|0,ac|0,ad|0,c1|0);if(z){z=0;aZ=96;break L47}if((a[a6]&1)!=0){Lw(c[a8>>2]|0)}c1=db;c[V>>2]=c1;c3=c[bb>>2]|0;if((c3|0)==(c[bc>>2]|0)){m3(bd,V);df=c[V>>2]|0}else{if((c3|0)==0){dg=0}else{c[c3>>2]=c1;dg=c[bb>>2]|0}c[ba>>2]=dg+4;df=c1}cB[c[c[be>>2]>>2]&1023](a9,df);}while((t5(b)|0)!=0)}dh=y$(c[aK>>2]|0)|0;di=(a[dh]|0)==125?dh+1|0:0;if((di|0)!=0){aZ=105;break}}L105:do{if((t5(b)|0)==0){if((y4(y$(c[aK>>2]|0)|0)|0)!=0){do{if(((c[(c[bl>>2]|0)-4>>2]|0)-1|0)>>>0<2>>>0){uq(b)|0;c1=Lu(64)|0;c[ct>>2]=c1;c[cu>>2]=65;c[cv>>2]=62;LF(c1|0,6880,62)|0;a[c1+62|0]=0;c[cw>>2]=0;c[cx>>2]=0;c[cy>>2]=0;z=0;aR(492,b|0,ai|0,aj|0);if(z){z=0;aZ=156;break L47}if((a[cz]&1)==0){break}Lw(c[ct>>2]|0)}}while(0);c4=t8(b)|0;if((c[c4+40>>2]|0)!=(c[c4+44>>2]|0)){c1=c4|0;c[S>>2]=c1;c3=c[bb>>2]|0;if((c3|0)==(c[bc>>2]|0)){m3(bd,S);dj=c[S>>2]|0}else{if((c3|0)==0){dk=0}else{c[c3>>2]=c1;dk=c[bb>>2]|0}c[ba>>2]=dk+4;dj=c1}cB[c[c[be>>2]>>2]&1023](a9,dj)}c1=c4+28|0;c3=c[c1>>2]|0;c0=c[c4+32>>2]|0;if((c3|0)==(c0|0)){dl=1;break}c4=(c0-c3|0)/12|0;c3=0;while(1){dm=c[aM>>2]|0;c0=Lu(40)|0;c[R>>2]=c0;dn=dm+4|0;c5=c[dn>>2]|0;if((c5|0)==(c[dm+8>>2]|0)){e4(dm|0,R);dp=c[R>>2]|0}else{if((c5|0)==0){dq=0}else{c[c5>>2]=c0;dq=c[dn>>2]|0}c[dn>>2]=dq+4;dp=c0}dr=dp;c0=dp;if((a[aN]&1)==0){c[cA>>2]=c[aN>>2];c[cA+4>>2]=c[aN+4>>2];c[cA+8>>2]=c[aN+8>>2]}else{c5=c[bf>>2]|0;c2=c[bh>>2]|0;if(c2>>>0>4294967279>>>0){aZ=175;break L47}if(c2>>>0<11>>>0){a[cA]=c2<<1;ds=cK}else{c6=c2+16&-16;dt=(z=0,au(248,c6|0)|0);if(z){z=0;aZ=205;break L47}c[cF>>2]=dt;c[cL>>2]=c6|1;c[cM>>2]=c2;ds=dt}LF(ds|0,c5|0,c2)|0;a[ds+c2|0]=0}c[cC>>2]=c[a_>>2];c[cC+4>>2]=c[a_+4>>2];c[cC+8>>2]=c[a_+8>>2];c2=c[c1>>2]|0;c5=c2+(c3*12|0)|0;if((a[c5]&1)==0){c[cD>>2]=c[c5>>2];c[cD+4>>2]=c[c5+4>>2];c[cD+8>>2]=c[c5+8>>2]}else{c5=c[c2+(c3*12|0)+8>>2]|0;dt=c[c2+(c3*12|0)+4>>2]|0;if(dt>>>0>4294967279>>>0){aZ=185;break L47}if(dt>>>0<11>>>0){a[cD]=dt<<1;du=cH}else{c2=dt+16&-16;c6=(z=0,au(248,c2|0)|0);if(z){z=0;aZ=208;break L47}c[cG>>2]=c6;c[cI>>2]=c2|1;c[cJ>>2]=dt;du=c6}LF(du|0,c5|0,dt)|0;a[du+dt|0]=0}c[cE>>2]=c[cC>>2];c[cE+4>>2]=c[cC+4>>2];c[cE+8>>2]=c[cC+8>>2];z=0;aV(28,c0|0,ak|0,Q|0,am|0);if(z){z=0;dv=1;aZ=211;break L47}c0=dp;c[P>>2]=c0;dt=c[bb>>2]|0;if((dt|0)==(c[bc>>2]|0)){z=0;as(488,bd|0,P|0);if(z){z=0;dv=0;aZ=211;break L47}dw=c[P>>2]|0}else{if((dt|0)==0){dx=0}else{c[dt>>2]=c0;dx=c[bb>>2]|0}c[ba>>2]=dx+4;dw=c0}z=0;as(c[c[be>>2]>>2]|0,a9|0,dw|0);if(z){z=0;dv=0;aZ=211;break L47}if((a[cD]&1)!=0){Lw(c[cG>>2]|0)}if((a[cA]&1)!=0){Lw(c[cF>>2]|0)}c0=c3+1|0;if(c0>>>0<c4>>>0){c3=c0}else{dl=1;break L105}}}if((uy(b)|0)!=0){c3=ub(b)|0;c[O>>2]=c3;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,O);dy=c[O>>2]|0}else{if((c4|0)==0){dz=0}else{c[c4>>2]=c3;dz=c[bb>>2]|0}c[ba>>2]=dz+4;dy=c3}cB[c[c[be>>2]>>2]&1023](a9,dy);dl=1;break}if((zc(y$(c[aK>>2]|0)|0)|0)!=0){c3=ue(b,0)|0;c[N>>2]=c3;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,N);dA=c[N>>2]|0}else{if((c4|0)==0){dB=0}else{c[c4>>2]=c3;dB=c[bb>>2]|0}c[ba>>2]=dB+4;dA=c3}cB[c[c[be>>2]>>2]&1023](a9,dA);dl=0;break}if((ze(y$(c[aK>>2]|0)|0)|0)!=0){c3=uf(b)|0;c[L>>2]=c3;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,L);dC=c[L>>2]|0}else{if((c4|0)==0){dD=0}else{c[c4>>2]=c3;dD=c[bb>>2]|0}c[ba>>2]=dD+4;dC=c3}cB[c[c[be>>2]>>2]&1023](a9,dC);dl=0;break}if((zi(y$(c[aK>>2]|0)|0)|0)!=0){c3=ug(b)|0;c[K>>2]=c3;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,K);dE=c[K>>2]|0}else{if((c4|0)==0){dF=0}else{c[c4>>2]=c3;dF=c[bb>>2]|0}c[ba>>2]=dF+4;dE=c3}cB[c[c[be>>2]>>2]&1023](a9,dE);dl=0;break}if((zk(y$(c[aK>>2]|0)|0)|0)!=0){c3=uh(b)|0;c[J>>2]=c3;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,J);dG=c[J>>2]|0}else{if((c4|0)==0){dH=0}else{c[c4>>2]=c3;dH=c[bb>>2]|0}c[ba>>2]=dH+4;dG=c3}cB[c[c[be>>2]>>2]&1023](a9,dG);dl=0;break}if((u8(b)|0)!=0){dI=c[aM>>2]|0;c3=Lu(32)|0;c[I>>2]=c3;dJ=dI+4|0;c4=c[dJ>>2]|0;if((c4|0)==(c[dI+8>>2]|0)){e4(dI|0,I);dK=c[I>>2]|0}else{if((c4|0)==0){dL=0}else{c[c4>>2]=c3;dL=c[dJ>>2]|0}c[dJ>>2]=dL+4;dK=c3}dM=dK;if((a[aN]&1)==0){c[cg>>2]=c[aN>>2];c[cg+4>>2]=c[aN+4>>2];c[cg+8>>2]=c[aN+8>>2]}else{c3=c[bf>>2]|0;c4=c[bh>>2]|0;if(c4>>>0>4294967279>>>0){aZ=266;break L47}if(c4>>>0<11>>>0){a[cg]=c4<<1;dN=cr}else{c1=c4+16&-16;c0=(z=0,au(248,c1|0)|0);if(z){z=0;aZ=298;break L47}c[cl>>2]=c0;c[cs>>2]=c1|1;c[cn>>2]=c4;dN=c0}LF(dN|0,c3|0,c4)|0;a[dN+c4|0]=0}c[ch>>2]=c[a_>>2];c[ch+4>>2]=c[a_+4>>2];c[ch+8>>2]=c[a_+8>>2];c4=(z=0,au(168,b|0)|0);if(z){z=0;dO=1;aZ=301;break L47}c[ci>>2]=c[ch>>2];c[ci+4>>2]=c[ch+4>>2];c[ci+8>>2]=c[ch+8>>2];c3=dK;dP=a[cg]|0;c0=(dP&1)==0;if(c0){c[cj>>2]=c[cg>>2];c[cj+4>>2]=c[cg+4>>2];c[cj+8>>2]=c[cg+8>>2]}else{c1=c[cl>>2]|0;dt=c[cn>>2]|0;if(dt>>>0>4294967279>>>0){aZ=277;break L47}if(dt>>>0<11>>>0){a[cj]=dt<<1;dQ=co}else{c5=dt+16&-16;c6=(z=0,au(248,c5|0)|0);if(z){z=0;dO=1;aZ=301;break L47}c[cm>>2]=c6;c[cp>>2]=c5|1;c[cq>>2]=dt;dQ=c6}LF(dQ|0,c1|0,dt)|0;a[dQ+dt|0]=0}c[ck>>2]=c[ci>>2];c[ck+4>>2]=c[ci+4>>2];c[ck+8>>2]=c[ci+8>>2];z=0;aR(424,c3|0,F|0,G|0);if(z){z=0;aZ=287;break L47}if((a[cj]&1)!=0){Lw(c[cm>>2]|0)}c[dK>>2]=18400;c[dK+28>>2]=c4;c[E>>2]=c3;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){z=0;as(488,bd|0,E|0);if(z){z=0;dO=0;aZ=301;break L47}dR=c[E>>2]|0}else{if((c4|0)==0){dS=0}else{c[c4>>2]=c3;dS=c[bb>>2]|0}c[ba>>2]=dS+4;dR=c3}z=0;as(c[c[be>>2]>>2]|0,a9|0,dR|0);if(z){z=0;dO=0;aZ=301;break L47}if(c0){dl=1;break}Lw(c[cl>>2]|0);dl=1;break}if((zl(y$(c[aK>>2]|0)|0)|0)!=0){c0=uj(b)|0;c[D>>2]=c0;c3=c[bb>>2]|0;if((c3|0)==(c[bc>>2]|0)){m3(bd,D);dT=c[D>>2]|0}else{if((c3|0)==0){dU=0}else{c[c3>>2]=c0;dU=c[bb>>2]|0}c[ba>>2]=dU+4;dT=c0}cB[c[c[be>>2]>>2]&1023](a9,dT);dl=1;break}if((c[(c[bl>>2]|0)-4>>2]|0)==2){c0=Lu(80)|0;c[bm>>2]=c0;c[bn>>2]=81;c[bo>>2]=78;LF(c0|0,6640,78)|0;a[c0+78|0]=0;c[bp>>2]=0;c[bq>>2]=0;c[br>>2]=0;z=0;aR(492,b|0,ap|0,at|0);if(z){z=0;aZ=323;break L47}if((a[bs]&1)==0){dl=0;break}Lw(c[bm>>2]|0);dl=0;break}do{if((y6(y$(c[aK>>2]|0)|0)|0)==0){if((y7(y$(c[aK>>2]|0)|0)|0)!=0){break}if((y9(y$(c[aK>>2]|0)|0)|0)!=0){c0=ud(b)|0;c3=c0|0;c[B>>2]=c3;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,B);dV=c[B>>2]|0}else{if((c4|0)==0){dW=0}else{c[c4>>2]=c3;dW=c[bb>>2]|0}c[ba>>2]=dW+4;dV=c3}cB[c[c[be>>2]>>2]&1023](a9,dV);dl=(c[c0+28>>2]|0)==0;break L105}if((u9(b)|0)!=0){do{if((c[(c[bl>>2]|0)-4>>2]|0)!=1){c0=Lu(48)|0;c[b9>>2]=c0;c[ca>>2]=49;c[cb>>2]=40;LF(c0|0,6520,40)|0;a[c0+40|0]=0;c[cc>>2]=0;c[cd>>2]=0;c[ce>>2]=0;z=0;aR(492,b|0,av|0,aw|0);if(z){z=0;aZ=345;break L47}if((a[cf]&1)==0){break}Lw(c[b9>>2]|0)}}while(0);dX=c[aM>>2]|0;c0=Lu(28)|0;c[A>>2]=c0;dY=dX+4|0;c3=c[dY>>2]|0;if((c3|0)==(c[dX+8>>2]|0)){e4(dX|0,A);dZ=c[A>>2]|0}else{if((c3|0)==0){d_=0}else{c[c3>>2]=c0;d_=c[dY>>2]|0}c[dY>>2]=d_+4;dZ=c0}d$=dZ;if((a[aN]&1)==0){c[bZ>>2]=c[aN>>2];c[bZ+4>>2]=c[aN+4>>2];c[bZ+8>>2]=c[aN+8>>2];d0=a[bZ]|0}else{c0=c[bf>>2]|0;c3=c[bh>>2]|0;if(c3>>>0>4294967279>>>0){aZ=355;break L47}if(c3>>>0<11>>>0){c4=c3<<1&255;a[bZ]=c4;d1=b7;d2=c4}else{c4=c3+16&-16;dt=(z=0,au(248,c4|0)|0);if(z){z=0;aZ=386;break L47}c[b1>>2]=dt;c1=c4|1;c[b8>>2]=c1;c[b3>>2]=c3;d1=dt;d2=c1&255}LF(d1|0,c0|0,c3)|0;a[d1+c3|0]=0;d0=d2}c3=y;c[c3>>2]=c[a_>>2];c[c3+4>>2]=c[a_+4>>2];c[c3+8>>2]=c[a_+8>>2];c3=dZ;if((d0&1)==0){c[b$>>2]=c[bZ>>2];c[b$+4>>2]=c[bZ+4>>2];c[b$+8>>2]=c[bZ+8>>2]}else{c0=c[b1>>2]|0;c1=c[b3>>2]|0;if(c1>>>0>4294967279>>>0){aZ=365;break L47}if(c1>>>0<11>>>0){a[b$]=c1<<1;d3=b4}else{dt=c1+16&-16;c4=(z=0,au(248,dt|0)|0);if(z){z=0;d4=1;aZ=389;break L47}c[b2>>2]=c4;c[b5>>2]=dt|1;c[b6>>2]=c1;d3=c4}LF(d3|0,c0|0,c1)|0;a[d3+c1|0]=0}c[b0>>2]=c[b_>>2];c[b0+4>>2]=c[b_+4>>2];c[b0+8>>2]=c[b_+8>>2];z=0;aR(424,c3|0,w|0,x|0);if(z){z=0;aZ=375;break L47}if((a[b$]&1)!=0){Lw(c[b2>>2]|0)}c[dZ>>2]=18064;c[v>>2]=c3;c1=c[bb>>2]|0;if((c1|0)==(c[bc>>2]|0)){z=0;as(488,bd|0,v|0);if(z){z=0;d4=0;aZ=389;break L47}d5=c[v>>2]|0}else{if((c1|0)==0){d6=0}else{c[c1>>2]=c3;d6=c[bb>>2]|0}c[ba>>2]=d6+4;d5=c3}z=0;as(c[c[be>>2]>>2]|0,a9|0,d5|0);if(z){z=0;d4=0;aZ=389;break L47}if((d0&1)==0){dl=1;break L105}Lw(c[b1>>2]|0);dl=1;break L105}c3=(va(b)|0)==0;c1=c[aK>>2]|0;if(!c3){vb(ay,b,c1);c3=c[bD>>2]|0;do{if((c3|0)==0){c0=Lu(32)|0;c[bE>>2]=c0;c[bF>>2]=33;c[bG>>2]=28;LF(c0|0,6320,28)|0;a[c0+28|0]=0;c[bH>>2]=0;c[bI>>2]=0;c[bJ>>2]=0;z=0;aR(492,b|0,az|0,aA|0);if(z){z=0;aZ=405;break L47}if((a[bK]&1)==0){break}Lw(c[bE>>2]|0)}}while(0);if((a[bL]&1)==0){d7=uJ(b)|0}else{d7=uI(b,c3)|0}d8=c[aM>>2]|0;c0=Lu(32)|0;c[u>>2]=c0;d9=d8+4|0;c4=c[d9>>2]|0;if((c4|0)==(c[d8+8>>2]|0)){e4(d8|0,u);ea=c[u>>2]|0}else{if((c4|0)==0){eb=0}else{c[c4>>2]=c0;eb=c[d9>>2]|0}c[d9>>2]=eb+4;ea=c0}ec=ea;if((a[aN]&1)==0){c[bM>>2]=c[aN>>2];c[bM+4>>2]=c[aN+4>>2];c[bM+8>>2]=c[aN+8>>2];ed=a[bM]|0}else{c0=c[bf>>2]|0;c4=c[bh>>2]|0;if(c4>>>0>4294967279>>>0){aZ=418;break L47}if(c4>>>0<11>>>0){dt=c4<<1&255;a[bM]=dt;ee=bX;ef=dt}else{dt=c4+16&-16;c6=(z=0,au(248,dt|0)|0);if(z){z=0;aZ=449;break L47}c[bQ>>2]=c6;c5=dt|1;c[bY>>2]=c5;c[bS>>2]=c4;ee=c6;ef=c5&255}LF(ee|0,c0|0,c4)|0;a[ee+c4|0]=0;ed=ef}c4=t;c[c4>>2]=c[a_>>2];c[c4+4>>2]=c[a_+4>>2];c[c4+8>>2]=c[a_+8>>2];c4=ea;if((ed&1)==0){c[bO>>2]=c[bM>>2];c[bO+4>>2]=c[bM+4>>2];c[bO+8>>2]=c[bM+8>>2]}else{c0=c[bQ>>2]|0;c5=c[bS>>2]|0;if(c5>>>0>4294967279>>>0){aZ=428;break L47}if(c5>>>0<11>>>0){a[bO]=c5<<1;eg=bU}else{c6=c5+16&-16;dt=(z=0,au(248,c6|0)|0);if(z){z=0;eh=1;aZ=452;break L47}c[bR>>2]=dt;c[bV>>2]=c6|1;c[bW>>2]=c5;eg=dt}LF(eg|0,c0|0,c5)|0;a[eg+c5|0]=0}c[bP>>2]=c[bN>>2];c[bP+4>>2]=c[bN+4>>2];c[bP+8>>2]=c[bN+8>>2];z=0;aR(424,c4|0,r|0,s|0);if(z){z=0;aZ=438;break L47}if((a[bO]&1)!=0){Lw(c[bR>>2]|0)}c[ea>>2]=17144;c[ea+28>>2]=d7;c[q>>2]=c4;c5=c[bb>>2]|0;if((c5|0)==(c[bc>>2]|0)){z=0;as(488,bd|0,q|0);if(z){z=0;eh=0;aZ=452;break L47}ei=c[q>>2]|0}else{if((c5|0)==0){ej=0}else{c[c5>>2]=c4;ej=c[bb>>2]|0}c[ba>>2]=ej+4;ei=c4}z=0;as(c[c[be>>2]>>2]|0,a9|0,ei|0);if(z){z=0;eh=0;aZ=452;break L47}if((ed&1)==0){dl=1;break L105}Lw(c[bQ>>2]|0);dl=1;break L105}if((y5(y$(c1)|0)|0)!=0){c4=ui(b)|0;c[p>>2]=c4;c5=c[bb>>2]|0;if((c5|0)==(c[bc>>2]|0)){m3(bd,p);ek=c[p>>2]|0}else{if((c5|0)==0){el=0}else{c[c5>>2]=c4;el=c[bb>>2]|0}c[ba>>2]=el+4;ek=c4}cB[c[c[be>>2]>>2]&1023](a9,ek);dl=0;break L105}if((uk(b)|0)!=0){ul(b)|0;c4=y$(c[aK>>2]|0)|0;c5=(a[c4]|0)==59?c4+1|0:0;if((c5|0)==0){dl=0;break L105}c0=c[a2>>2]|0;dt=c[aK>>2]|0;L409:do{if(dt>>>0<c5>>>0){c6=dt;c2=0;while(1){em=a[c6]|0;if((em<<24>>24|0)==10){en=c2+1|0}else if((em<<24>>24|0)==0){eo=c2;break L409}else{en=c2}em=c6+1|0;if(em>>>0<c5>>>0){c6=em;c2=en}else{eo=en;break}}}else{eo=0}}while(0);c[a2>>2]=eo+c0;c1=c4;c3=0;while(1){c2=c1-1|0;if(c2>>>0<dt>>>0){break}if((a[c2]|0)==10){break}else{c1=c2;c3=c3+1|0}}if((eo|0)!=0){c[a3>>2]=1}c1=c[a3>>2]|0;c[a4>>2]=c1+c3;dt=c5;c0=c4;c[a3>>2]=dt-c0+c3+c1;c[a5>>2]=c0;c[a5+4>>2]=dt;c[aK>>2]=c5;dl=0;break L105}if((y3(y$(c[aK>>2]|0)|0)|0)!=0){dt=um(b)|0;c0=dt|0;c[o>>2]=c0;c1=c[bb>>2]|0;if((c1|0)==(c[bc>>2]|0)){m3(bd,o);ep=c[o>>2]|0}else{if((c1|0)==0){eq=0}else{c[c1>>2]=c0;eq=c[bb>>2]|0}c[ba>>2]=eq+4;ep=c0}cB[c[c[be>>2]>>2]&1023](a9,ep);dl=(c[dt+28>>2]|0)==0;break L105}un(aC,b,c[aK>>2]|0);dt=c[bt>>2]|0;if((dt|0)!=0){c0=c[bA>>2]|0;c[bB>>2]=dt;c[bC>>2]=c0;c0=uo(b,aD)|0;c[n>>2]=c0;dt=c[bb>>2]|0;if((dt|0)==(c[bc>>2]|0)){m3(bd,n);er=c[n>>2]|0}else{if((dt|0)==0){es=0}else{c[dt>>2]=c0;es=c[bb>>2]|0}c[ba>>2]=es+4;er=c0}cB[c[c[be>>2]>>2]&1023](a9,er);dl=0;break L105}c0=y$(c[aK>>2]|0)|0;dt=(a[c0]|0)==42?c0+1|0:0;c1=(dt|0)!=0?dt:c0;do{if((c1|0)!=0){c0=y1(c1)|0;if((c0|0)==0){dt=y0(c1)|0;if((dt|0)==0){break}else{et=dt}}else{et=c0}c0=y_(et)|0;if((c0|0)==0){break}dt=(a[c0]|0)==58?c0+1|0:0;if((dt|0)==0){break}c0=y_(dt)|0;if((c0|0)==0){break}if((c0+1|0)==0|(a[c0]|0)!=123){break}c0=uc(b)|0;c[m>>2]=c0;dt=c[bb>>2]|0;if((dt|0)==(c[bc>>2]|0)){m3(bd,m);eu=c[m>>2]|0}else{if((dt|0)==0){ev=0}else{c[dt>>2]=c0;ev=c[bb>>2]|0}c[ba>>2]=ev+4;eu=c0}cB[c[c[be>>2]>>2]&1023](a9,eu);dl=0;break L105}}while(0);c1=y$(c[aK>>2]|0)|0;c5=(c1+1|0)==0|(a[c1]|0)!=59;c1=y$(c[aK>>2]|0)|0;c3=a[c1]|0;if(!c5){c5=c3<<24>>24==59?c1+1|0:0;if((c5|0)==0){dl=0;break L105}c4=c[a2>>2]|0;c0=c[aK>>2]|0;L464:do{if(c0>>>0<c5>>>0){dt=c0;c2=0;while(1){c6=a[dt]|0;if((c6<<24>>24|0)==10){ew=c2+1|0}else if((c6<<24>>24|0)==0){ex=c2;break L464}else{ew=c2}c6=dt+1|0;if(c6>>>0<c5>>>0){dt=c6;c2=ew}else{ex=ew;break}}}else{ex=0}}while(0);c[a2>>2]=ex+c4;c2=c1;dt=0;while(1){c6=c2-1|0;if(c6>>>0<c0>>>0){break}if((a[c6]|0)==10){break}else{c2=c6;dt=dt+1|0}}if((ex|0)!=0){c[a3>>2]=1}c2=c[a3>>2]|0;c[a4>>2]=c2+dt;c0=c5;c4=c1;c[a3>>2]=c0-c4+dt+c2;c[a5>>2]=c4;c[a5+4>>2]=c0;c[aK>>2]=c5;dl=0;break L105}c0=c3<<24>>24==42?c1+1|0:0;c4=(c0|0)!=0?c0:c1;do{if((c4|0)!=0){c0=y1(c4)|0;if((c0|0)==0){break}c2=(a[c0]|0)==58?c0+1|0:0;if((c2|0)==0){break}if((c2+1|0)==0|(a[c2]|0)!=123){break}c2=uc(b)|0;c[l>>2]=c2;c0=c[bb>>2]|0;if((c0|0)==(c[bc>>2]|0)){m3(bd,l);ey=c[l>>2]|0}else{if((c0|0)==0){ez=0}else{c[c0>>2]=c2;ez=c[bb>>2]|0}c[ba>>2]=ez+4;ey=c2}cB[c[c[be>>2]>>2]&1023](a9,ey);dl=0;break L105}}while(0);c4=y$(c[aK>>2]|0)|0;c1=(a[c4]|0)==42?c4+1|0:0;c3=(c1|0)!=0?c1:c4;do{if((c3|0)!=0){c4=y0(c3)|0;if((c4|0)==0){break}c1=(a[c4]|0)==58?c4+1|0:0;if((c1|0)==0){break}if((c1+1|0)==0|(a[c1]|0)!=123){break}c1=uc(b)|0;c[k>>2]=c1;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,k);eA=c[k>>2]|0}else{if((c4|0)==0){eB=0}else{c[c4>>2]=c1;eB=c[bb>>2]|0}c[ba>>2]=eB+4;eA=c1}cB[c[c[be>>2]>>2]&1023](a9,eA);dl=0;break L105}}while(0);c3=vc(b)|0;c1=c3|0;c[j>>2]=c1;c4=c[bb>>2]|0;if((c4|0)==(c[bc>>2]|0)){m3(bd,j);eC=c[j>>2]|0}else{if((c4|0)==0){eD=0}else{c[c4>>2]=c1;eD=c[bb>>2]|0}c[ba>>2]=eD+4;eC=c1}cB[c[c[be>>2]>>2]&1023](a9,eC);c1=y$(c[aK>>2]|0)|0;if((c1+1|0)==0|(a[c1]|0)!=123){dl=1;break L105}eE=c[aM>>2]|0;c1=Lu(36)|0;c[h>>2]=c1;eF=eE+4|0;c4=c[eF>>2]|0;if((c4|0)==(c[eE+8>>2]|0)){e4(eE|0,h);eG=c[h>>2]|0}else{if((c4|0)==0){eH=0}else{c[c4>>2]=c1;eH=c[eF>>2]|0}c[eF>>2]=eH+4;eG=c1}eI=eG;c1=eG;if((a[aN]&1)==0){c[bu>>2]=c[aN>>2];c[bu+4>>2]=c[aN+4>>2];c[bu+8>>2]=c[aN+8>>2]}else{c4=c[bf>>2]|0;c5=c[bh>>2]|0;if(c5>>>0>4294967279>>>0){aZ=544;break L47}if(c5>>>0<11>>>0){a[bu]=c5<<1;eJ=bx}else{dt=c5+16&-16;c2=(z=0,au(248,dt|0)|0);if(z){z=0;aZ=561;break L47}c[bw>>2]=c2;c[by>>2]=dt|1;c[bz>>2]=c5;eJ=c2}LF(eJ|0,c4|0,c5)|0;a[eJ+c5|0]=0}c[bv>>2]=c[a_>>2];c[bv+4>>2]=c[a_+4>>2];c[bv+8>>2]=c[a_+8>>2];c5=c[c3+28>>2]|0;c3=(z=0,au(246,b|0)|0);if(z){z=0;aZ=564;break L47}z=0;aq(12,c1|0,aE|0,aF|0,c5|0,c3|0);if(z){z=0;aZ=564;break L47}if((a[bu]&1)!=0){Lw(c[bw>>2]|0)}c3=eG;c[g>>2]=c3;c5=c[bb>>2]|0;if((c5|0)==(c[bc>>2]|0)){m3(bd,g);eK=c[g>>2]|0}else{if((c5|0)==0){eL=0}else{c[c5>>2]=c3;eL=c[bb>>2]|0}c[ba>>2]=eL+4;eK=c3}cB[c[c[be>>2]>>2]&1023](a9,eK);dl=0;break L105}}while(0);c3=ua(b)|0;c[C>>2]=c3;c5=c[bb>>2]|0;if((c5|0)==(c[bc>>2]|0)){m3(bd,C);eM=c[C>>2]|0}else{if((c5|0)==0){eN=0}else{c[c5>>2]=c3;eN=c[bb>>2]|0}c[ba>>2]=eN+4;eM=c3}cB[c[c[be>>2]>>2]&1023](a9,eM);dl=0}else{c3=c[a5+4>>2]|0;c[ae>>2]=c[a5>>2];c[ae+4>>2]=c3;c3=t6(b,af)|0;eO=c[aM>>2]|0;c5=Lu(32)|0;c[U>>2]=c5;eP=eO+4|0;c1=c[eP>>2]|0;if((c1|0)==(c[eO+8>>2]|0)){e4(eO|0,U);eQ=c[U>>2]|0}else{if((c1|0)==0){eR=0}else{c[c1>>2]=c5;eR=c[eP>>2]|0}c[eP>>2]=eR+4;eQ=c5}eS=eQ;if((a[aN]&1)==0){c[cN>>2]=c[aN>>2];c[cN+4>>2]=c[aN+4>>2];c[cN+8>>2]=c[aN+8>>2]}else{c5=c[bf>>2]|0;c1=c[bh>>2]|0;if(c1>>>0>4294967279>>>0){aZ=124;break L47}if(c1>>>0<11>>>0){a[cN]=c1<<1;eT=cQ}else{c4=c1+16&-16;c2=(z=0,au(248,c4|0)|0);if(z){z=0;aZ=140;break L47}c[cP>>2]=c2;c[cR>>2]=c4|1;c[cS>>2]=c1;eT=c2}LF(eT|0,c5|0,c1)|0;a[eT+c1|0]=0}c[cO>>2]=c[a_>>2];c[cO+4>>2]=c[a_+4>>2];c[cO+8>>2]=c[a_+8>>2];z=0;aV(32,eQ|0,ag|0,ah|0,c3|0);if(z){z=0;aZ=143;break L47}if((a[cN]&1)!=0){Lw(c[cP>>2]|0)}c3=eQ;c[T>>2]=c3;c1=c[bb>>2]|0;if((c1|0)==(c[bc>>2]|0)){m3(bd,T);eU=c[T>>2]|0}else{if((c1|0)==0){eV=0}else{c[c1>>2]=c3;eV=c[bb>>2]|0}c[ba>>2]=eV+4;eU=c3}cB[c[c[be>>2]>>2]&1023](a9,eU);dl=0}}while(0);if((t5(b)|0)==0){cZ=dl;continue}while(1){c3=c[a5+4>>2]|0;c[aG>>2]=c[a5>>2];c[aG+4>>2]=c3;c3=t6(b,aH)|0;eW=c[aM>>2]|0;c1=Lu(32)|0;c[f>>2]=c1;eX=eW+4|0;c5=c[eX>>2]|0;if((c5|0)==(c[eW+8>>2]|0)){e4(eW|0,f);eY=c[f>>2]|0}else{if((c5|0)==0){eZ=0}else{c[c5>>2]=c1;eZ=c[eX>>2]|0}c[eX>>2]=eZ+4;eY=c1}e_=eY;if((a[aN]&1)==0){c[cT>>2]=c[aN>>2];c[cT+4>>2]=c[aN+4>>2];c[cT+8>>2]=c[aN+8>>2]}else{c1=c[bf>>2]|0;c5=c[bh>>2]|0;if(c5>>>0>4294967279>>>0){aZ=592;break L47}if(c5>>>0<11>>>0){a[cT]=c5<<1;e$=cW}else{c2=c5+16&-16;c4=(z=0,au(248,c2|0)|0);if(z){z=0;aZ=608;break L47}c[cV>>2]=c4;c[cX>>2]=c2|1;c[cY>>2]=c5;e$=c4}LF(e$|0,c1|0,c5)|0;a[e$+c5|0]=0}c[cU>>2]=c[a_>>2];c[cU+4>>2]=c[a_+4>>2];c[cU+8>>2]=c[a_+8>>2];z=0;aV(32,eY|0,aI|0,aJ|0,c3|0);if(z){z=0;aZ=611;break L47}if((a[cT]&1)!=0){Lw(c[cV>>2]|0)}c3=eY;c[e>>2]=c3;c5=c[bb>>2]|0;if((c5|0)==(c[bc>>2]|0)){m3(bd,e);e0=c[e>>2]|0}else{if((c5|0)==0){e1=0}else{c[c5>>2]=c3;e1=c[bb>>2]|0}c[ba>>2]=e1+4;e0=c3}cB[c[c[be>>2]>>2]&1023](a9,e0);if((t5(b)|0)==0){cZ=dl;continue L47}}}do{if((aZ|0)==143){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[cN]&1)==0){e2=a9;e3=cZ;aZ=145;break}Lw(c[cP>>2]|0);e2=a9;e3=cZ;aZ=145}else if((aZ|0)==287){cZ=bT(-1,-1)|0;a9=M;if((a[cj]&1)==0){e5=a9;e6=cZ;e7=1;e8=dP;aZ=303;break}Lw(c[cm>>2]|0);e5=a9;e6=cZ;e7=1;e8=dP;aZ=303}else if((aZ|0)==77){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;e9=M;fa=cZ;aZ=95;break}}else if((aZ|0)==32){cZ=c[a2>>2]|0;a9=c[aK>>2]|0;L620:do{if(a9>>>0<c$>>>0){be=a9;ba=0;while(1){bb=a[be]|0;if((bb<<24>>24|0)==10){fb=ba+1|0}else if((bb<<24>>24|0)==0){fc=ba;break L620}else{fb=ba}bb=be+1|0;if(bb>>>0<c$>>>0){be=bb;ba=fb}else{fc=fb;break}}}else{fc=0}}while(0);c[a2>>2]=fc+cZ;ba=c_;be=0;while(1){bb=ba-1|0;if(bb>>>0<a9>>>0){break}if((a[bb]|0)==10){break}else{ba=bb;be=be+1|0}}if((fc|0)!=0){c[a3>>2]=1}ba=c[a3>>2]|0;c[a4>>2]=ba+be;a9=c$;cZ=c_;c[a3>>2]=a9-cZ+be+ba;fd=c$;fe=a9|0;ff=cZ|0;fg=a5|0;c[fg>>2]=ff;fh=a5+4|0;c[fh>>2]=fe;c[aK>>2]=fd;i=d;return aY|0}else if((aZ|0)==93){cZ=bT(-1,-1)|0;e9=M;fa=cZ;aZ=95}else if((aZ|0)==205){cZ=bT(-1,-1)|0;fi=M;fj=cZ;aZ=207}else if((aZ|0)==208){cZ=bT(-1,-1)|0;fk=M;fl=cZ;aZ=210}else if((aZ|0)==96){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[a6]&1)==0){fm=a9;fn=cZ;aZ=98;break}Lw(c[a8>>2]|0);fm=a9;fn=cZ;aZ=98}else if((aZ|0)==175){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fi=M;fj=cZ;aZ=207;break}}else if((aZ|0)==67){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[a1]&1)==0){fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}Lw(c[aO>>2]|0);fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==405){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[bK]&1)==0){fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}Lw(c[bE>>2]|0);fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==386){cZ=bT(-1,-1)|0;fu=M;fv=cZ;aZ=388}else if((aZ|0)==389){cZ=bT(-1,-1)|0;fw=M;fx=cZ;fy=d4;aZ=391}else if((aZ|0)==156){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[cz]&1)==0){fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}Lw(c[ct>>2]|0);fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==365){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fw=M;fx=cZ;fy=1;aZ=391;break}}else if((aZ|0)==544){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fz=M;fA=cZ;aZ=563;break}}else if((aZ|0)==375){cZ=bT(-1,-1)|0;a9=M;if((a[b$]&1)==0){fw=a9;fx=cZ;fy=1;aZ=391;break}Lw(c[b2>>2]|0);fw=a9;fx=cZ;fy=1;aZ=391}else if((aZ|0)==105){cZ=c[a2>>2]|0;a9=c[aK>>2]|0;L672:do{if(a9>>>0<di>>>0){ba=a9;bb=0;while(1){bd=a[ba]|0;if((bd<<24>>24|0)==10){fB=bb+1|0}else if((bd<<24>>24|0)==0){fC=bb;break L672}else{fB=bb}bd=ba+1|0;if(bd>>>0<di>>>0){ba=bd;bb=fB}else{fC=fB;break}}}else{fC=0}}while(0);c[a2>>2]=fC+cZ;be=dh;bb=0;while(1){ba=be-1|0;if(ba>>>0<a9>>>0){break}if((a[ba]|0)==10){break}else{be=ba;bb=bb+1|0}}if((fC|0)!=0){c[a3>>2]=1}be=c[a3>>2]|0;c[a4>>2]=be+bb;a9=di;cZ=dh;c[a3>>2]=a9-cZ+bb+be;fd=di;fe=a9|0;ff=cZ|0;fg=a5|0;c[fg>>2]=ff;fh=a5+4|0;c[fh>>2]=fe;c[aK>>2]=fd;i=d;return aY|0}else if((aZ|0)==298){cZ=bT(-1,-1)|0;fD=M;fE=cZ;aZ=300}else if((aZ|0)==301){cZ=bT(-1,-1)|0;e5=M;e6=cZ;e7=dO;e8=a[cg]|0;aZ=303}else if((aZ|0)==561){cZ=bT(-1,-1)|0;fz=M;fA=cZ;aZ=563}else if((aZ|0)==564){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[bu]&1)==0){fF=a9;fG=cZ;aZ=566;break}Lw(c[bw>>2]|0);fF=a9;fG=cZ;aZ=566}else if((aZ|0)==592){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fH=M;fI=cZ;aZ=610;break}}else if((aZ|0)==608){cZ=bT(-1,-1)|0;fH=M;fI=cZ;aZ=610}else if((aZ|0)==611){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[cT]&1)==0){fJ=a9;fK=cZ;aZ=613;break}Lw(c[cV>>2]|0);fJ=a9;fK=cZ;aZ=613}else if((aZ|0)==266){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fD=M;fE=cZ;aZ=300;break}}else if((aZ|0)==140){cZ=bT(-1,-1)|0;fL=M;fM=cZ;aZ=142}else if((aZ|0)==355){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fu=M;fv=cZ;aZ=388;break}}else if((aZ|0)==277){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;e5=M;e6=cZ;e7=1;e8=dP;aZ=303;break}}else if((aZ|0)==124){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fL=M;fM=cZ;aZ=142;break}}else if((aZ|0)==185){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fk=M;fl=cZ;aZ=210;break}}else if((aZ|0)==323){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[bs]&1)==0){fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}Lw(c[bm>>2]|0);fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==211){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[cD]&1)==0){fN=a9;fO=cZ;fP=dv;aZ=213;break}Lw(c[cG>>2]|0);fN=a9;fO=cZ;fP=dv;aZ=213}else if((aZ|0)==345){cZ=bT(-1,-1)|0;a9=cZ;cZ=M;if((a[cf]&1)==0){fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}Lw(c[b9>>2]|0);fo=a9;fp=cZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==449){cZ=bT(-1,-1)|0;fQ=M;fR=cZ;aZ=451}else if((aZ|0)==452){cZ=bT(-1,-1)|0;fS=M;fT=cZ;fU=eh;aZ=454}else if((aZ|0)==428){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fS=M;fT=cZ;fU=1;aZ=454;break}}else if((aZ|0)==438){cZ=bT(-1,-1)|0;a9=M;if((a[bO]&1)==0){fS=a9;fT=cZ;fU=1;aZ=454;break}Lw(c[bR>>2]|0);fS=a9;fT=cZ;fU=1;aZ=454}else if((aZ|0)==418){z=0;ar(86,0);if(!z){return 0}else{z=0;cZ=bT(-1,-1)|0;fQ=M;fR=cZ;aZ=451;break}}}while(0);do{if((aZ|0)==142){e2=fM;e3=fL;aZ=145}else if((aZ|0)==207){fV=fi;fW=fj}else if((aZ|0)==210){fN=fl;fO=fk;fP=1;aZ=213}else if((aZ|0)==95){fm=fa;fn=e9;aZ=98}else if((aZ|0)==388){fX=fu;fY=fv;aZ=394}else if((aZ|0)==391){bR=fx;bO=fw;if((d0&1)==0){if(fy){fX=bO;fY=bR;aZ=394;break}else{fo=bR;fp=bO}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else{Lw(c[b1>>2]|0);if(fy){fX=bO;fY=bR;aZ=394;break}else{fo=bR;fp=bO}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}}else if((aZ|0)==300){fZ=fD;f_=fE;aZ=306}else if((aZ|0)==563){fF=fA;fG=fz;aZ=566}else if((aZ|0)==610){fJ=fI;fK=fH;aZ=613}else if((aZ|0)==303){bO=e6;bR=e5;if((e8&1)==0){if(e7){fZ=bR;f_=bO;aZ=306;break}else{fo=bO;fp=bR}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else{Lw(c[cl>>2]|0);if(e7){fZ=bR;f_=bO;aZ=306;break}else{fo=bO;fp=bR}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}}else if((aZ|0)==451){f$=fQ;f0=fR;aZ=457}else if((aZ|0)==454){bR=fT;bO=fS;if((ed&1)==0){if(fU){f$=bO;f0=bR;aZ=457;break}else{fo=bR;fp=bO}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else{Lw(c[bQ>>2]|0);if(fU){f$=bO;f0=bR;aZ=457;break}else{fo=bR;fp=bO}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}}}while(0);do{if((aZ|0)==145){bQ=c[eO>>2]|0;cl=c[eP>>2]|0;b1=bQ;while(1){if((b1|0)==(cl|0)){f1=cl;break}if((c[b1>>2]|0)==(eQ|0)){f1=b1;break}else{b1=b1+4|0}}b1=f1-bQ>>2;bb=bQ+(b1+1<<2)|0;bO=cl-bb|0;LG(bQ+(b1<<2)|0,bb|0,bO|0)|0;bb=bQ+((bO>>2)+b1<<2)|0;b1=c[eP>>2]|0;if((bb|0)!=(b1|0)){c[eP>>2]=b1+(~((b1-4+(-bb|0)|0)>>>2)<<2)}Lw(eS);fo=e2;fp=e3;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==98){bb=c[c9>>2]|0;b1=c[da>>2]|0;bO=bb;while(1){if((bO|0)==(b1|0)){f2=b1;break}if((c[bO>>2]|0)==(db|0)){f2=bO;break}else{bO=bO+4|0}}bO=f2-bb>>2;bQ=bb+(bO+1<<2)|0;cl=b1-bQ|0;LG(bb+(bO<<2)|0,bQ|0,cl|0)|0;bQ=bb+((cl>>2)+bO<<2)|0;bO=c[da>>2]|0;if((bQ|0)!=(bO|0)){c[da>>2]=bO+(~((bO-4+(-bQ|0)|0)>>>2)<<2)}Lw(dd);fo=fm;fp=fn;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==394){bQ=c[dX>>2]|0;bO=c[dY>>2]|0;cl=bQ;while(1){if((cl|0)==(bO|0)){f3=bO;break}if((c[cl>>2]|0)==(dZ|0)){f3=cl;break}else{cl=cl+4|0}}cl=f3-bQ>>2;bb=bQ+(cl+1<<2)|0;b1=bO-bb|0;LG(bQ+(cl<<2)|0,bb|0,b1|0)|0;bb=bQ+((b1>>2)+cl<<2)|0;cl=c[dY>>2]|0;if((bb|0)!=(cl|0)){c[dY>>2]=cl+(~((cl-4+(-bb|0)|0)>>>2)<<2)}Lw(d$);fo=fY;fp=fX;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==566){bb=c[eE>>2]|0;cl=c[eF>>2]|0;b1=bb;while(1){if((b1|0)==(cl|0)){f4=cl;break}if((c[b1>>2]|0)==(eG|0)){f4=b1;break}else{b1=b1+4|0}}b1=f4-bb>>2;bQ=bb+(b1+1<<2)|0;bO=cl-bQ|0;LG(bb+(b1<<2)|0,bQ|0,bO|0)|0;bQ=bb+((bO>>2)+b1<<2)|0;b1=c[eF>>2]|0;if((bQ|0)!=(b1|0)){c[eF>>2]=b1+(~((b1-4+(-bQ|0)|0)>>>2)<<2)}Lw(eI);fo=fF;fp=fG;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==613){bQ=c[eW>>2]|0;b1=c[eX>>2]|0;bO=bQ;while(1){if((bO|0)==(b1|0)){f5=b1;break}if((c[bO>>2]|0)==(eY|0)){f5=bO;break}else{bO=bO+4|0}}bO=f5-bQ>>2;bb=bQ+(bO+1<<2)|0;cl=b1-bb|0;LG(bQ+(bO<<2)|0,bb|0,cl|0)|0;bb=bQ+((cl>>2)+bO<<2)|0;bO=c[eX>>2]|0;if((bb|0)!=(bO|0)){c[eX>>2]=bO+(~((bO-4+(-bb|0)|0)>>>2)<<2)}Lw(e_);fo=fJ;fp=fK;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==306){bb=c[dI>>2]|0;bO=c[dJ>>2]|0;cl=bb;while(1){if((cl|0)==(bO|0)){f6=bO;break}if((c[cl>>2]|0)==(dK|0)){f6=cl;break}else{cl=cl+4|0}}cl=f6-bb>>2;bQ=bb+(cl+1<<2)|0;b1=bO-bQ|0;LG(bb+(cl<<2)|0,bQ|0,b1|0)|0;bQ=bb+((b1>>2)+cl<<2)|0;cl=c[dJ>>2]|0;if((bQ|0)!=(cl|0)){c[dJ>>2]=cl+(~((cl-4+(-bQ|0)|0)>>>2)<<2)}Lw(dM);fo=f_;fp=fZ;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else if((aZ|0)==213){if((a[cA]&1)==0){if(fP){fV=fO;fW=fN;break}else{fo=fN;fp=fO}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}else{Lw(c[cF>>2]|0);if(fP){fV=fO;fW=fN;break}else{fo=fN;fp=fO}fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}}else if((aZ|0)==457){bQ=c[d8>>2]|0;cl=c[d9>>2]|0;b1=bQ;while(1){if((b1|0)==(cl|0)){f7=cl;break}if((c[b1>>2]|0)==(ea|0)){f7=b1;break}else{b1=b1+4|0}}b1=f7-bQ>>2;bb=bQ+(b1+1<<2)|0;bO=cl-bb|0;LG(bQ+(b1<<2)|0,bb|0,bO|0)|0;bb=bQ+((bO>>2)+b1<<2)|0;b1=c[d9>>2]|0;if((bb|0)!=(b1|0)){c[d9>>2]=b1+(~((b1-4+(-bb|0)|0)>>>2)<<2)}Lw(ec);fo=f0;fp=f$;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}}while(0);cF=c[dm>>2]|0;cA=c[dn>>2]|0;bb=cF;while(1){if((bb|0)==(cA|0)){f8=cA;break}if((c[bb>>2]|0)==(dp|0)){f8=bb;break}else{bb=bb+4|0}}bb=f8-cF>>2;b1=cF+(bb+1<<2)|0;bO=cA-b1|0;LG(cF+(bb<<2)|0,b1|0,bO|0)|0;b1=cF+((bO>>2)+bb<<2)|0;bb=c[dn>>2]|0;if((b1|0)!=(bb|0)){c[dn>>2]=bb+(~((bb-4+(-b1|0)|0)>>>2)<<2)}Lw(dr);fo=fW;fp=fV;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0)}}while(0);fV=c[aP>>2]|0;aP=c[aU>>2]|0;fW=fV;while(1){if((fW|0)==(aP|0)){f9=aP;break}if((c[fW>>2]|0)==(aX|0)){f9=fW;break}else{fW=fW+4|0}}fW=f9-fV>>2;f9=fV+(fW+1<<2)|0;aX=aP-f9|0;LG(fV+(fW<<2)|0,f9|0,aX|0)|0;f9=fV+((aX>>2)+fW<<2)|0;fW=c[aU>>2]|0;if((f9|0)!=(fW|0)){c[aU>>2]=fW+(~((fW-4+(-f9|0)|0)>>>2)<<2)}Lw(aW);fo=a$;fp=a0;fq=fo;fr=0;fs=fq;ft=fp;bg(fs|0);return 0}function ux(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=i;i=i+104|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+72|0;k=d+88|0;uy(b)|0;l=b+56|0;m=c[l>>2]|0;n=(c[b+60>>2]|0)-m|0;if(n>>>0>4294967279>>>0){D5(0);return 0}if(n>>>0<11>>>0){o=n<<1&255;a[g]=o;p=g+1|0;q=o}else{o=n+16&-16;r=Lu(o)|0;c[g+8>>2]=r;s=o|1;c[g>>2]=s;c[g+4>>2]=n;p=r;q=s&255}LF(p|0,m|0,n)|0;a[p+n|0]=0;n=d+40|0;p=b+44|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];p=b+20|0;m=(z=0,au(66,c[p>>2]|0)|0);do{if(!z){s=(a[m]|0)==58?m+1|0:0;if((s|0)==0){r=(z=0,au(286,b|0)|0);if(z){z=0;t=19;break}u=0;v=(r|0)!=0}else{r=b+48|0;o=c[r>>2]|0;w=c[p>>2]|0;L12:do{if(w>>>0<s>>>0){x=w;y=0;while(1){A=a[x]|0;if((A<<24>>24|0)==10){B=y+1|0}else if((A<<24>>24|0)==0){C=y;break L12}else{B=y}A=x+1|0;if(A>>>0<s>>>0){x=A;y=B}else{C=B;break}}}else{C=0}}while(0);c[r>>2]=C+o;y=m;x=0;while(1){A=y-1|0;if(A>>>0<w>>>0){break}if((a[A]|0)==10){break}else{y=A;x=x+1|0}}y=b+40|0;if((C|0)!=0){c[y>>2]=1}w=c[y>>2]|0;c[b+52>>2]=w+x;o=s;r=m;c[y>>2]=o-r+x+w;w=l;c[w>>2]=r;c[w+4>>2]=o;c[p>>2]=s;o=(z=0,au(278,b|0)|0);if(z){z=0;t=19;break}a[o+28|0]=0;u=o;v=0}o=c[b>>2]|0;w=(z=0,au(248,48)|0);if(z){z=0;t=19;break}r=w;c[f>>2]=r;w=o+4|0;y=c[w>>2]|0;if((y|0)==(c[o+8>>2]|0)){z=0;as(382,o|0,f|0);if(z){z=0;t=19;break}D=c[f>>2]|0}else{if((y|0)==0){E=0}else{c[y>>2]=r;E=c[w>>2]|0}c[w>>2]=E+4;D=r}r=D;y=D;A=b+28|0;L39:do{if((a[A]&1)==0){F=h;c[F>>2]=c[A>>2];c[F+4>>2]=c[A+4>>2];c[F+8>>2]=c[A+8>>2];t=39}else{F=c[b+36>>2]|0;G=c[b+32>>2]|0;do{if(G>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(G>>>0<11>>>0){a[h]=G<<1;H=h+1|0}else{I=G+16&-16;J=(z=0,au(248,I|0)|0);if(z){z=0;break}c[h+8>>2]=J;c[h>>2]=I|1;c[h+4>>2]=G;H=J}LF(H|0,F|0,G)|0;a[H+G|0]=0;t=39;break L39}}while(0);G=bT(-1,-1)|0;K=M;L=G}}while(0);do{if((t|0)==39){A=j;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];L54:do{if((q&1)==0){s=g;x=k;c[x>>2]=c[s>>2];c[x+4>>2]=c[s+4>>2];c[x+8>>2]=c[s+8>>2];t=49}else{s=c[g+8>>2]|0;x=c[g+4>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[k]=x<<1;N=k+1|0}else{G=x+16&-16;F=(z=0,au(248,G|0)|0);if(z){z=0;break}c[k+8>>2]=F;c[k>>2]=G|1;c[k+4>>2]=x;N=F}LF(N|0,s|0,x)|0;a[N+x|0]=0;t=49;break L54}}while(0);x=bT(-1,-1)|0;O=M;P=x}}while(0);do{if((t|0)==49){x=e;c[x>>2]=c[A>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];z=0;aD(26,y|0,h|0,e|0,k|0,u|0,v|0);if(z){z=0;x=bT(-1,-1)|0;s=x;x=M;if((a[k]&1)==0){O=x;P=s;break}Lw(c[k+8>>2]|0);O=x;P=s;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}if((q&1)==0){i=d;return y|0}Lw(c[g+8>>2]|0);i=d;return y|0}}while(0);if((a[h]&1)==0){K=O;L=P;break}Lw(c[h+8>>2]|0);K=O;L=P}}while(0);y=c[o>>2]|0;A=c[w>>2]|0;s=y;while(1){if((s|0)==(A|0)){Q=A;break}if((c[s>>2]|0)==(D|0)){Q=s;break}else{s=s+4|0}}s=Q-y>>2;o=y+(s+1<<2)|0;x=A-o|0;LG(y+(s<<2)|0,o|0,x|0)|0;o=y+((x>>2)+s<<2)|0;s=c[w>>2]|0;if((o|0)!=(s|0)){c[w>>2]=s+(~((s-4+(-o|0)|0)>>>2)<<2)}Lw(r);R=K;S=L}else{z=0;t=19}}while(0);if((t|0)==19){t=bT(-1,-1)|0;R=M;S=t}if((q&1)==0){T=S;U=0;V=T;W=R;bg(V|0)}Lw(c[g+8>>2]|0);T=S;U=0;V=T;W=R;bg(V|0);return 0}function uy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zS(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+56|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=ve(b)|0;l=b+20|0;m=y$(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=59)){n=k;i=d;return n|0}m=y$(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=125)){n=k;i=d;return n|0}m=y$(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=123)){n=k;i=d;return n|0}m=y$(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=41)){n=k;i=d;return n|0}m=y$(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=44)){n=k;i=d;return n|0}m=y$(c[l>>2]|0)|0;o=a[36768]|0;p=o<<24>>24==0;L16:do{if(p){q=m;r=9}else{s=m;t=36768;u=o;while(1){if((a[s]|0)!=u<<24>>24){break L16}v=s+1|0;w=t+1|0;x=a[w]|0;if(x<<24>>24==0){q=v;r=9;break}else{s=v;t=w;u=x}}}}while(0);do{if((r|0)==9){if((q|0)==0){break}else{n=k}i=d;return n|0}}while(0);if((zF(y$(c[l>>2]|0)|0)|0)!=0){n=k;i=d;return n|0}q=c[b>>2]|0;m=Lu(60)|0;c[h>>2]=m;u=q+4|0;t=c[u>>2]|0;if((t|0)==(c[q+8>>2]|0)){e4(q|0,h);y=c[h>>2]|0}else{if((t|0)==0){A=0}else{c[t>>2]=m;A=c[u>>2]|0}c[u>>2]=A+4;y=m}m=y;A=b+28|0;L34:do{if((a[A]&1)==0){t=j;c[t>>2]=c[A>>2];c[t+4>>2]=c[A+4>>2];c[t+8>>2]=c[A+8>>2];r=26}else{t=c[b+36>>2]|0;h=c[b+32>>2]|0;do{if(h>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;B=j+1|0}else{s=h+16&-16;x=(z=0,au(248,s|0)|0);if(z){z=0;break}c[j+8>>2]=x;c[j>>2]=s|1;c[j+4>>2]=h;B=x}LF(B|0,t|0,h)|0;a[B+h|0]=0;r=26;break L34}}while(0);h=bT(-1,-1)|0;C=M;D=h}}while(0);do{if((r|0)==26){B=b+44|0;A=g;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];z=0;aD(36,y|0,j|0,g|0,2,0,0);if(z){z=0;B=bT(-1,-1)|0;A=B;B=M;if((a[j]&1)==0){C=B;D=A;break}Lw(c[j+8>>2]|0);C=B;D=A;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}A=y+36|0;B=A;c[f>>2]=k;h=A+8|0;t=h;x=c[t>>2]|0;s=A+12|0;if((x|0)==(c[s>>2]|0)){fq(A+4|0,f);E=c[f>>2]|0}else{if((x|0)==0){F=0}else{c[x>>2]=k;F=c[t>>2]|0}c[h>>2]=F+4;E=k}x=A;cB[c[c[x>>2]>>2]&1023](B,E);w=y$(c[l>>2]|0)|0;L63:do{if((w+1|0)==0|(a[w]|0)!=59){v=A+4|0;do{G=y$(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=125)){break L63}G=y$(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=123)){break L63}G=y$(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=41)){break L63}G=y$(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=44)){break L63}G=y$(c[l>>2]|0)|0;L71:do{if(p){H=G;r=43}else{I=G;J=36768;K=o;while(1){if((a[I]|0)!=K<<24>>24){break L71}L=I+1|0;N=J+1|0;O=a[N]|0;if(O<<24>>24==0){H=L;r=43;break}else{I=L;J=N;K=O}}}}while(0);if((r|0)==43){r=0;if((H|0)!=0){break L63}}if((zF(y$(c[l>>2]|0)|0)|0)!=0){break L63}G=ve(b)|0;c[e>>2]=G;K=c[t>>2]|0;if((K|0)==(c[s>>2]|0)){fq(v,e);P=c[e>>2]|0}else{if((K|0)==0){Q=0}else{c[K>>2]=G;Q=c[t>>2]|0}c[h>>2]=Q+4;P=G}cB[c[c[x>>2]>>2]&1023](B,P);G=y$(c[l>>2]|0)|0;}while((G+1|0)==0|(a[G]|0)!=59)}}while(0);n=y;i=d;return n|0}}while(0);n=c[q>>2]|0;q=c[u>>2]|0;d=n;while(1){if((d|0)==(q|0)){R=q;break}if((c[d>>2]|0)==(y|0)){R=d;break}else{d=d+4|0}}d=R-n>>2;R=n+(d+1<<2)|0;y=q-R|0;LG(n+(d<<2)|0,R|0,y|0)|0;R=n+((y>>2)+d<<2)|0;d=c[u>>2]|0;if((R|0)==(d|0)){Lw(m);S=D;T=0;U=S;V=C;bg(U|0)}c[u>>2]=d+(~((d-4+(-R|0)|0)>>>2)<<2);Lw(m);S=D;T=0;U=S;V=C;bg(U|0);return 0}function uA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=a[36768]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=36768;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}function uB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y9(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=b+56|0;n=c[m>>2]|0;o=(c[b+60>>2]|0)-n|0;if(o>>>0>4294967279>>>0){D5(0);return 0}if(o>>>0<11>>>0){p=o<<1&255;a[h]=p;q=h+1|0;r=p}else{p=o+16&-16;s=Lu(p)|0;c[h+8>>2]=s;t=p|1;c[h>>2]=t;c[h+4>>2]=o;q=s;r=t&255}LF(q|0,n|0,o)|0;a[q+o|0]=0;o=c[b>>2]|0;q=(z=0,au(248,56)|0);L8:do{if(!z){n=q;c[g>>2]=n;t=o+4|0;s=c[t>>2]|0;if((s|0)==(c[o+8>>2]|0)){z=0;as(382,o|0,g|0);if(z){z=0;u=61;break}v=c[g>>2]|0}else{if((s|0)==0){w=0}else{c[s>>2]=n;w=c[t>>2]|0}c[t>>2]=w+4;v=n}n=v;s=v;p=b+28|0;L18:do{if((a[p]&1)==0){x=j;c[x>>2]=c[p>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];u=23}else{x=c[b+36>>2]|0;y=c[b+32>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[j]=y<<1;A=j+1|0}else{B=y+16&-16;C=(z=0,au(248,B|0)|0);if(z){z=0;break}c[j+8>>2]=C;c[j>>2]=B|1;c[j+4>>2]=y;A=C}LF(A|0,x|0,y)|0;a[A+y|0]=0;u=23;break L18}}while(0);y=bT(-1,-1)|0;D=y;E=M}}while(0);do{if((u|0)==23){p=b+44|0;y=f;c[y>>2]=c[p>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];z=0;aR(50,s|0,j|0,f|0);if(z){z=0;p=bT(-1,-1)|0;y=p;p=M;if((a[j]&1)==0){D=y;E=p;break}Lw(c[j+8>>2]|0);D=y;E=p;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}p=b+20|0;y=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;u=61;break L8}x=(a[y]|0)==40?y+1|0:0;L41:do{if((x|0)!=0){C=b+48|0;B=c[C>>2]|0;F=c[p>>2]|0;L43:do{if(F>>>0<x>>>0){G=F;H=0;while(1){I=a[G]|0;if((I<<24>>24|0)==10){J=H+1|0}else if((I<<24>>24|0)==0){K=H;break L43}else{J=H}I=G+1|0;if(I>>>0<x>>>0){G=I;H=J}else{K=J;break}}}else{K=0}}while(0);c[C>>2]=K+B;H=y;G=0;while(1){I=H-1|0;if(I>>>0<F>>>0){break}if((a[I]|0)==10){break}else{H=I;G=G+1|0}}H=b+40|0;if((K|0)!=0){c[H>>2]=1}F=c[H>>2]|0;B=b+52|0;c[B>>2]=F+G;I=x;L=y;c[H>>2]=I-L+G+F;F=m;c[F>>2]=L;c[F+4>>2]=I;c[p>>2]=x;I=(z=0,au(66,x|0)|0);if(z){z=0;u=61;break L8}L58:do{if((I+1|0)==0|(a[I]|0)!=41){L=v+36|0;N=L;O=L+8|0;P=O;Q=L+12|0;R=L+4|0;S=L;while(1){L=(z=0,au(164,b|0)|0);if(z){z=0;break}c[e>>2]=L;T=c[P>>2]|0;if((T|0)==(c[Q>>2]|0)){z=0;as(156,R|0,e|0);if(z){z=0;break}U=c[e>>2]|0}else{if((T|0)==0){V=0}else{c[T>>2]=L;V=c[P>>2]|0}c[O>>2]=V+4;U=L}z=0;as(c[c[S>>2]>>2]|0,N|0,U|0);if(z){z=0;break}L=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;break}T=(a[L]|0)==44?L+1|0:0;if((T|0)==0){break L58}W=c[C>>2]|0;X=c[p>>2]|0;L74:do{if(X>>>0<T>>>0){Y=X;Z=0;while(1){_=a[Y]|0;if((_<<24>>24|0)==0){$=Z;break L74}else if((_<<24>>24|0)==10){aa=Z+1|0}else{aa=Z}_=Y+1|0;if(_>>>0<T>>>0){Y=_;Z=aa}else{$=aa;break}}}else{$=0}}while(0);c[C>>2]=$+W;Z=L;Y=0;while(1){_=Z-1|0;if(_>>>0<X>>>0){break}if((a[_]|0)==10){break}else{Z=_;Y=Y+1|0}}if(($|0)!=0){c[H>>2]=1}Z=c[H>>2]|0;c[B>>2]=Z+Y;X=T;W=L;c[H>>2]=X-W+Y+Z;c[F>>2]=W;c[F+4>>2]=X;c[p>>2]=T}N=bT(-1,-1)|0;ab=M;ac=N;u=62;break L8}}while(0);I=(z=0,au(66,c[p>>2]|0)|0);if(z){z=0;u=61;break L8}G=(a[I]|0)==41?I+1|0:0;if((G|0)!=0){N=c[C>>2]|0;S=c[p>>2]|0;L93:do{if(S>>>0<G>>>0){O=S;P=0;while(1){R=a[O]|0;if((R<<24>>24|0)==0){ad=P;break L93}else if((R<<24>>24|0)==10){ae=P+1|0}else{ae=P}R=O+1|0;if(R>>>0<G>>>0){O=R;P=ae}else{ad=ae;break}}}else{ad=0}}while(0);c[C>>2]=ad+N;P=I;O=0;while(1){R=P-1|0;if(R>>>0<S>>>0){break}if((a[R]|0)==10){break}else{P=R;O=O+1|0}}if((ad|0)!=0){c[H>>2]=1}P=c[H>>2]|0;c[B>>2]=P+O;S=G;N=I;c[H>>2]=S-N+O+P;c[F>>2]=N;c[F+4>>2]=S;c[p>>2]=G;break}S=k;LI(S|0,0,12)|0;N=h;P=r&255;if((P&1|0)==0){af=P>>>1}else{af=c[h+4>>2]|0}P=af+69|0;do{if(P>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(P>>>0<11>>>0){a[S]=-118;ag=k+1|0}else{C=af+85&-16;R=(z=0,au(248,C|0)|0);if(z){z=0;break}c[k+8>>2]=R;c[k>>2]=C|1;c[k+4>>2]=69;ag=R}LF(ag|0,9920,69)|0;a[ag+69|0]=0;if((r&1)==0){ah=N+1|0}else{ah=c[h+8>>2]|0}z=0,az(88,k|0,ah|0,af|0)|0;if(z){z=0;break}c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z=0;aR(492,b|0,k|0,l|0);if(!z){if((a[S]&1)==0){break L41}Lw(c[k+8>>2]|0);break L41}else{z=0;R=bT(-1,-1)|0;C=R;R=M;if((a[S]&1)==0){ai=C;aj=R;break L8}Lw(c[k+8>>2]|0);ai=C;aj=R;break L8}}}while(0);N=bT(-1,-1)|0;P=M;if((a[S]&1)==0){ab=P;ac=N;u=62;break L8}Lw(c[k+8>>2]|0);ab=P;ac=N;u=62;break L8}}while(0);if((a[h]&1)==0){i=d;return s|0}Lw(c[h+8>>2]|0);i=d;return s|0}}while(0);s=c[o>>2]|0;p=c[t>>2]|0;x=s;while(1){if((x|0)==(p|0)){ak=p;break}if((c[x>>2]|0)==(v|0)){ak=x;break}else{x=x+4|0}}x=ak-s>>2;y=s+(x+1<<2)|0;N=p-y|0;LG(s+(x<<2)|0,y|0,N|0)|0;y=s+((N>>2)+x<<2)|0;x=c[t>>2]|0;if((y|0)!=(x|0)){c[t>>2]=x+(~((x-4+(-y|0)|0)>>>2)<<2)}Lw(n);ai=D;aj=E}else{z=0;u=61}}while(0);if((u|0)==61){E=bT(-1,-1)|0;ab=M;ac=E;u=62}if((u|0)==62){ai=ac;aj=ab}if((a[h]&1)==0){al=ai;am=0;an=al;ao=aj;bg(an|0)}Lw(c[h+8>>2]|0);al=ai;am=0;an=al;ao=aj;bg(an|0);return 0}function uD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;d=i;i=i+160|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+128|0;p=d+144|0;q=b+20|0;r=zS(y$(c[q>>2]|0)|0)|0;do{if((r|0)!=0){s=y$(r)|0;if((s|0)==0){break}if((s+1|0)==0|(a[s]|0)!=58){break}uy(b)|0;s=b+56|0;t=c[s>>2]|0;u=(c[b+60>>2]|0)-t|0;if(u>>>0>4294967279>>>0){D5(0);return 0}if(u>>>0<11>>>0){v=u<<1&255;a[j]=v;w=j+1|0;x=v}else{v=u+16&-16;y=Lu(v)|0;c[j+8>>2]=y;A=v|1;c[j>>2]=A;c[j+4>>2]=u;w=y;x=A&255}LF(w|0,t|0,u)|0;a[w+u|0]=0;u=k;t=b+44|0;c[u>>2]=c[t>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];t=(z=0,au(66,c[q>>2]|0)|0);do{if(!z){A=(a[t]|0)==58?t+1|0:0;if((A|0)!=0){y=b+48|0;v=c[y>>2]|0;B=c[q>>2]|0;L16:do{if(B>>>0<A>>>0){C=B;D=0;while(1){E=a[C]|0;if((E<<24>>24|0)==10){F=D+1|0}else if((E<<24>>24|0)==0){G=D;break L16}else{F=D}E=C+1|0;if(E>>>0<A>>>0){C=E;D=F}else{G=F;break}}}else{G=0}}while(0);c[y>>2]=G+v;D=t;C=0;while(1){E=D-1|0;if(E>>>0<B>>>0){break}if((a[E]|0)==10){break}else{D=E;C=C+1|0}}D=b+40|0;if((G|0)!=0){c[D>>2]=1}B=c[D>>2]|0;c[b+52>>2]=B+C;v=A;y=t;c[D>>2]=v-y+C+B;B=s;c[B>>2]=y;c[B+4>>2]=v;c[q>>2]=A}v=(z=0,au(278,b|0)|0);if(z){z=0;H=56;break}a[v+28|0]=0;B=c[b>>2]|0;y=(z=0,au(248,56)|0);if(z){z=0;H=56;break}D=y;c[h>>2]=D;y=B+4|0;E=c[y>>2]|0;if((E|0)==(c[B+8>>2]|0)){z=0;as(382,B|0,h|0);if(z){z=0;H=56;break}I=c[h>>2]|0}else{if((E|0)==0){J=0}else{c[E>>2]=D;J=c[y>>2]|0}c[y>>2]=J+4;I=D}D=I;E=I;K=b+28|0;L41:do{if((a[K]&1)==0){L=l;c[L>>2]=c[K>>2];c[L+4>>2]=c[K+4>>2];c[L+8>>2]=c[K+8>>2];H=39}else{L=c[b+36>>2]|0;N=c[b+32>>2]|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[l]=N<<1;O=l+1|0}else{P=N+16&-16;Q=(z=0,au(248,P|0)|0);if(z){z=0;break}c[l+8>>2]=Q;c[l>>2]=P|1;c[l+4>>2]=N;O=Q}LF(O|0,L|0,N)|0;a[O+N|0]=0;H=39;break L41}}while(0);N=bT(-1,-1)|0;R=N;S=M}}while(0);do{if((H|0)==39){K=m;c[K>>2]=c[u>>2];c[K+4>>2]=c[u+4>>2];c[K+8>>2]=c[u+8>>2];L56:do{if((x&1)==0){A=j;C=n;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];H=49}else{A=c[j+8>>2]|0;C=c[j+4>>2]|0;do{if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(C>>>0<11>>>0){a[n]=C<<1;T=n+1|0}else{N=C+16&-16;L=(z=0,au(248,N|0)|0);if(z){z=0;break}c[n+8>>2]=L;c[n>>2]=N|1;c[n+4>>2]=C;T=L}LF(T|0,A|0,C)|0;a[T+C|0]=0;H=49;break L56}}while(0);C=bT(-1,-1)|0;U=C;V=M}}while(0);do{if((H|0)==49){C=g;c[C>>2]=c[K>>2];c[C+4>>2]=c[K+4>>2];c[C+8>>2]=c[K+8>>2];z=0;aD(30,E|0,l|0,g|0,v|0,n|0,0);if(z){z=0;C=bT(-1,-1)|0;A=C;C=M;if((a[n]&1)==0){U=A;V=C;break}Lw(c[n+8>>2]|0);U=A;V=C;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}if((x&1)==0){W=E;i=d;return W|0}Lw(c[j+8>>2]|0);W=E;i=d;return W|0}}while(0);if((a[l]&1)==0){R=U;S=V;break}Lw(c[l+8>>2]|0);R=U;S=V}}while(0);E=c[B>>2]|0;v=c[y>>2]|0;K=E;while(1){if((K|0)==(v|0)){X=v;break}if((c[K>>2]|0)==(I|0)){X=K;break}else{K=K+4|0}}K=X-E>>2;B=E+(K+1<<2)|0;C=v-B|0;LG(E+(K<<2)|0,B|0,C|0)|0;B=E+((C>>2)+K<<2)|0;K=c[y>>2]|0;if((B|0)!=(K|0)){c[y>>2]=K+(~((K-4+(-B|0)|0)>>>2)<<2)}Lw(D);Y=R;Z=S}else{z=0;H=56}}while(0);if((H|0)==56){u=bT(-1,-1)|0;Y=u;Z=M}if((x&1)==0){_=Y;$=Z;aa=_;ab=0;ac=aa;ad=$;bg(ac|0)}Lw(c[j+8>>2]|0);_=Y;$=Z;aa=_;ab=0;ac=aa;ad=$;bg(ac|0)}}while(0);Z=uz(b)|0;a[Z+28|0]=0;Y=(uA(b)|0)!=0;j=c[b>>2]|0;x=Lu(56)|0;c[f>>2]=x;S=j+4|0;R=c[S>>2]|0;if((R|0)==(c[j+8>>2]|0)){e4(j|0,f);ae=c[f>>2]|0}else{if((R|0)==0){af=0}else{c[R>>2]=x;af=c[S>>2]|0}c[S>>2]=af+4;ae=x}x=ae;af=ae;R=b+28|0;L110:do{if((a[R]&1)==0){f=o;c[f>>2]=c[R>>2];c[f+4>>2]=c[R+4>>2];c[f+8>>2]=c[R+8>>2];H=86}else{f=c[b+36>>2]|0;X=c[b+32>>2]|0;do{if(X>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(X>>>0<11>>>0){a[o]=X<<1;ag=o+1|0}else{I=X+16&-16;V=(z=0,au(248,I|0)|0);if(z){z=0;break}c[o+8>>2]=V;c[o>>2]=I|1;c[o+4>>2]=X;ag=V}LF(ag|0,f|0,X)|0;a[ag+X|0]=0;H=86;break L110}}while(0);X=bT(-1,-1)|0;ah=X;ai=M}}while(0);do{if((H|0)==86){ag=b+44|0;R=e;c[R>>2]=c[ag>>2];c[R+4>>2]=c[ag+4>>2];c[R+8>>2]=c[ag+8>>2];ag=p;a[ag]=0;a[p+1|0]=0;z=0;aD(30,af|0,o|0,e|0,Z|0,p|0,Y|0);if(z){z=0;R=bT(-1,-1)|0;X=R;R=M;if((a[ag]&1)!=0){Lw(c[p+8>>2]|0)}if((a[o]&1)==0){ah=X;ai=R;break}Lw(c[o+8>>2]|0);ah=X;ai=R;break}if((a[ag]&1)!=0){Lw(c[p+8>>2]|0)}if((a[o]&1)==0){W=af;i=d;return W|0}Lw(c[o+8>>2]|0);W=af;i=d;return W|0}}while(0);W=c[j>>2]|0;j=c[S>>2]|0;d=W;while(1){if((d|0)==(j|0)){aj=j;break}if((c[d>>2]|0)==(ae|0)){aj=d;break}else{d=d+4|0}}d=aj-W>>2;aj=W+(d+1<<2)|0;ae=j-aj|0;LG(W+(d<<2)|0,aj|0,ae|0)|0;aj=W+((ae>>2)+d<<2)|0;d=c[S>>2]|0;if((aj|0)!=(d|0)){c[S>>2]=d+(~((d-4+(-aj|0)|0)>>>2)<<2)}Lw(x);_=ah;$=ai;aa=_;ab=0;ac=aa;ad=$;bg(ac|0);return 0}function uE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=zF(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function uF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0;d=i;i=i+128|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+64|0;m=d+72|0;n=d+88|0;o=d+96|0;p=d+112|0;q=d+120|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+8|0;w=i;i=i+64|0;x=i;i=i+8|0;y=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+8|0;vS(b)|0;G=b+56|0;H=c[G>>2]|0;I=c[G+4>>2]|0;c[q>>2]=H;c[q+4>>2]=I;q=H;H=q;G=I;I=G;L1:do{if(H>>>0<I>>>0){J=a[37176]|0;K=J<<24>>24==0;L3:do{if(K){L=H;while(1){N=a[L]|0;if(N<<24>>24==0){O=12;break L1}P=L+1|0;if(!(N<<24>>24==92&(P|0)!=0|(L|0)==0)){Q=L;break L3}if(P>>>0<I>>>0){L=P}else{O=12;break L1}}}else{L=H;while(1){P=a[L]|0;if(P<<24>>24==0){O=12;break L1}N=L+1|0;R=P<<24>>24==92&(N|0)!=0?0:L;if((R|0)!=0){P=R;R=37176;S=J;while(1){if((a[P]|0)!=S<<24>>24){T=P;U=S;break}V=P+1|0;W=R+1|0;X=a[W]|0;if(X<<24>>24==0){T=V;U=0;break}else{P=V;R=W;S=X}}if(!(U<<24>>24!=0|(T|0)==0)){Q=L;break L3}}if(N>>>0<I>>>0){L=N}else{O=12;break L1}}}}while(0);L=b|0;S=c[L>>2]|0;if((Q|0)==0){Y=S;break}R=Lu(60)|0;c[n>>2]=R;P=S+4|0;X=c[P>>2]|0;if((X|0)==(c[S+8>>2]|0)){e4(S|0,n);Z=c[n>>2]|0}else{if((X|0)==0){_=0}else{c[X>>2]=R;_=c[P>>2]|0}c[P>>2]=_+4;Z=R}R=Z;X=b+28|0;L26:do{if((a[X]&1)==0){W=t;c[W>>2]=c[X>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];O=56}else{W=c[b+36>>2]|0;V=c[b+32>>2]|0;do{if(V>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(V>>>0<11>>>0){a[t]=V<<1;$=t+1|0}else{aa=V+16&-16;ab=(z=0,au(248,aa|0)|0);if(z){z=0;break}c[t+8>>2]=ab;c[t>>2]=aa|1;c[t+4>>2]=V;$=ab}LF($|0,W|0,V)|0;a[$+V|0]=0;O=56;break L26}}while(0);V=bT(-1,-1)|0;ac=M;ad=V}}while(0);do{if((O|0)==56){V=b+44|0;W=m;c[W>>2]=c[V>>2];c[W+4>>2]=c[V+4>>2];c[W+8>>2]=c[V+8>>2];z=0;aD(2,Z|0,t|0,m|0,0,0,0);if(z){z=0;W=bT(-1,-1)|0;ab=W;W=M;if((a[t]&1)==0){ac=W;ad=ab;break}Lw(c[t+8>>2]|0);ac=W;ad=ab;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}ab=Z+40|0;W=ab;aa=u;ae=v|0;af=v+4|0;ag=ab+8|0;ah=ab+12|0;ai=ab+4|0;aj=u+8|0;ak=b+36|0;al=b+32|0;am=u+1|0;an=u|0;ao=u+4|0;ap=a[36840]|0;at=ap<<24>>24==0;av=C;aw=C+1|0;ax=B;ay=B+1|0;aA=D|0;aB=D+4|0;aC=D+8|0;aE=C+8|0;aF=B+8|0;aG=B|0;aH=B+4|0;aI=C+4|0;aJ=C|0;aK=x|0;aL=x+4|0;aM=y;aN=A;aO=w+28|0;aP=w+4|0;aQ=y+8|0;aS=w+8|0;aT=w+36|0;aU=y+1|0;aV=y|0;aW=y+4|0;aX=H;L48:while(1){L50:while(1){L52:do{if(K){aY=aX;while(1){aZ=a[aY]|0;if(aZ<<24>>24==0){O=191;break L48}a_=aY+1|0;if(!(aZ<<24>>24==92&(a_|0)!=0|(aY|0)==0)){a$=aY;break L52}if(a_>>>0<I>>>0){aY=a_}else{O=191;break L48}}}else{aY=aX;while(1){a_=a[aY]|0;if(a_<<24>>24==0){O=191;break L48}aZ=aY+1|0;a0=a_<<24>>24==92&(aZ|0)!=0?0:aY;if((a0|0)!=0){a_=a0;a0=37176;a1=J;while(1){if((a[a_]|0)!=a1<<24>>24){a2=a_;a3=a1;break}a4=a_+1|0;a5=a0+1|0;a6=a[a5]|0;if(a6<<24>>24==0){a2=a4;a3=0;break}else{a_=a4;a0=a5;a1=a6}}if(!(a3<<24>>24!=0|(a2|0)==0)){a$=aY;break L52}}if(aZ>>>0<I>>>0){aY=aZ}else{O=191;break L48}}}}while(0);if((a$|0)==0){O=191;break L48}do{if(aX>>>0<a$>>>0){a7=c[L>>2]|0;aY=Lu(52)|0;c[l>>2]=aY;a8=a7+4|0;a1=c[a8>>2]|0;if((a1|0)==(c[a7+8>>2]|0)){e4(a7|0,l);a9=c[l>>2]|0}else{if((a1|0)==0){ba=0}else{c[a1>>2]=aY;ba=c[a8>>2]|0}c[a8>>2]=ba+4;a9=aY}bb=a9;aY=a9;if((a[X]&1)==0){c[aa>>2]=c[X>>2];c[aa+4>>2]=c[X+4>>2];c[aa+8>>2]=c[X+8>>2]}else{a1=c[ak>>2]|0;a0=c[al>>2]|0;if(a0>>>0>4294967279>>>0){O=81;break L48}if(a0>>>0<11>>>0){a[aa]=a0<<1;bc=am}else{a_=a0+16&-16;a6=(z=0,au(248,a_|0)|0);if(z){z=0;O=107;break L48}c[aj>>2]=a6;c[an>>2]=a_|1;c[ao>>2]=a0;bc=a6}LF(bc|0,a1|0,a0)|0;a[bc+a0|0]=0}a0=k;c[a0>>2]=c[V>>2];c[a0+4>>2]=c[V+4>>2];c[a0+8>>2]=c[V+8>>2];c[ae>>2]=aX;c[af>>2]=a$;z=0;aq(14,aY|0,u|0,k|0,v|0,0);if(z){z=0;bd=1;O=110;break L48}aY=a9;c[j>>2]=aY;a0=c[ag>>2]|0;a1=a0;if((a0|0)==(c[ah>>2]|0)){z=0;as(376,ai|0,j|0);if(z){z=0;bd=0;O=110;break L48}be=c[j>>2]|0}else{if((a0|0)==0){bf=0}else{c[a1>>2]=aY;bf=c[ag>>2]|0}c[ag>>2]=bf+4;be=aY}z=0;as(c[c[ab>>2]>>2]|0,W|0,be|0);if(z){z=0;bd=0;O=110;break L48}if((a[aa]&1)==0){break}Lw(c[aj>>2]|0)}}while(0);L99:do{if(at){aY=a$;while(1){if(aY>>>0>=I>>>0){break L99}if((a[aY]|0)==0){break L99}if((aY|0)==0){aY=aY+1|0}else{bh=aY;break L50}}}else{aY=a$;while(1){if(aY>>>0>=I>>>0){break L99}a1=a[aY]|0;if(a1<<24>>24==0){break L99}L108:do{if(a1<<24>>24==ap<<24>>24){a0=36840;a6=aY;while(1){a_=a6+1|0;a5=a0+1|0;a4=a[a5]|0;if(a4<<24>>24==0){bi=a_;bj=0;break L108}if((a[a_]|0)==a4<<24>>24){a0=a5;a6=a_}else{bi=a_;bj=a4;break}}}else{bi=aY;bj=ap}}while(0);if(bj<<24>>24!=0|(bi|0)==0){aY=aY+1|0}else{break}}if((aY|0)!=0){bh=aY;break L50}}}while(0);a1=G-q|0;if(a1>>>0>4294967279>>>0){O=164;break L48}if(a1>>>0<11>>>0){aZ=a1<<1&255;a[av]=aZ;bk=aw;bl=aZ}else{aZ=a1+16&-16;a6=Lu(aZ)|0;c[aE>>2]=a6;a0=aZ|1;c[aJ>>2]=a0;c[aI>>2]=a1;bk=a6;bl=a0&255}LF(bk|0,H|0,a1)|0;a[bk+a1|0]=0;LI(ax|0,0,12)|0;a1=bl&255;a0=(a1&1|0)==0?a1>>>1:c[aI>>2]|0;a1=a0+56|0;if(a1>>>0>4294967279>>>0){O=169;break L48}if(a1>>>0<11>>>0){a[ax]=112;bm=ay}else{a1=a0+72&-16;a6=(z=0,au(248,a1|0)|0);if(z){z=0;O=176;break L48}c[aF>>2]=a6;c[aG>>2]=a1|1;c[aH>>2]=56;bm=a6}LF(bm|0,4128,56)|0;a[bm+56|0]=0;z=0,az(88,B|0,((bl&1)==0?aw:c[aE>>2]|0)|0,a0|0)|0;if(z){z=0;O=176;break L48}c[aA>>2]=0;c[aB>>2]=0;c[aC>>2]=0;z=0;aR(492,b|0,B|0,D|0);if(z){z=0;O=187;break L48}if((a[ax]&1)!=0){Lw(c[aF>>2]|0)}if((a[av]&1)!=0){Lw(c[aE>>2]|0)}if(aX>>>0>=I>>>0){bn=R;O=232;break L48}}c[aK>>2]=a$+2;c[aL>>2]=bh;N=c[L>>2]|0;if((a[X]&1)==0){c[aM>>2]=c[X>>2];c[aM+4>>2]=c[X+4>>2];c[aM+8>>2]=c[X+8>>2]}else{a0=c[ak>>2]|0;a6=c[al>>2]|0;if(a6>>>0>4294967279>>>0){O=133;break}if(a6>>>0<11>>>0){a[aM]=a6<<1;bo=aU}else{a1=a6+16&-16;aZ=Lu(a1)|0;c[aQ>>2]=aZ;c[aV>>2]=a1|1;c[aW>>2]=a6;bo=aZ}LF(bo|0,a0|0,a6)|0;a[bo+a6|0]=0}c[aN>>2]=c[V>>2];c[aN+4>>2]=c[V+4>>2];c[aN+8>>2]=c[V+8>>2];z=0;aq(16,w|0,x|0,N|0,y|0,A|0);if(z){z=0;O=154;break}N=(z=0,au(168,w|0)|0);if(z){z=0;O=155;break}if((a[aO]&1)!=0){Lw(c[aT>>2]|0)}a6=c[aP>>2]|0;a0=a6;if((a6|0)!=0){aZ=c[aS>>2]|0;if((a6|0)!=(aZ|0)){c[aS>>2]=aZ+(~((aZ-4+(-a0|0)|0)>>>2)<<2)}Lw(a6)}if((a[aM]&1)!=0){Lw(c[aQ>>2]|0)}a[N+29|0]=1;c[h>>2]=N;a6=c[ag>>2]|0;a0=a6;if((a6|0)==(c[ah>>2]|0)){fq(ai,h);bp=c[h>>2]|0}else{if((a6|0)==0){bq=0}else{c[a0>>2]=N;bq=c[ag>>2]|0}c[ag>>2]=bq+4;bp=N}cB[c[c[ab>>2]>>2]&1023](W,bp);N=bh+1|0;if(N>>>0<I>>>0){aX=N}else{bn=R;O=231;break}}do{if((O|0)==81){z=0;ar(86,0);if(!z){return 0}else{z=0;aN=bT(-1,-1)|0;br=M;bs=aN;O=109;break}}else if((O|0)==107){aN=bT(-1,-1)|0;br=M;bs=aN;O=109}else if((O|0)==110){aN=bT(-1,-1)|0;aW=aN;aN=M;if((a[aa]&1)==0){if(bd){bt=aW;bu=aN;break}else{bv=aN;bw=aW}bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}else{Lw(c[aj>>2]|0);if(bd){bt=aW;bu=aN;break}else{bv=aN;bw=aW}bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}}else if((O|0)==133){D5(0);return 0}else if((O|0)==154){aW=bT(-1,-1)|0;bB=M;bC=aW;O=161}else if((O|0)==155){aW=bT(-1,-1)|0;aN=aW;aW=M;if((a[aO]&1)!=0){Lw(c[aT>>2]|0)}aV=c[aP>>2]|0;if((aV|0)==0){bB=aW;bC=aN;O=161;break}aU=c[aS>>2]|0;if((aV|0)!=(aU|0)){c[aS>>2]=aU+(~((aU-4+(-aV|0)|0)>>>2)<<2)}Lw(aV);bB=aW;bC=aN;O=161}else if((O|0)==164){D5(0);return 0}else if((O|0)==169){z=0;ar(86,0);if(!z){return 0}else{z=0;aN=bT(-1,-1)|0;bD=M;bE=aN;O=178;break}}else if((O|0)==176){aN=bT(-1,-1)|0;bD=M;bE=aN;O=178}else if((O|0)==187){aN=bT(-1,-1)|0;aW=aN;aN=M;if((a[ax]&1)==0){bF=aN;bG=aW;O=189;break}Lw(c[aF>>2]|0);bF=aN;bG=aW;O=189}else if((O|0)==191){if(aX>>>0>=I>>>0){bn=R;bH=bn;i=d;return bH|0}aW=c[L>>2]|0;aN=Lu(52)|0;c[g>>2]=aN;aV=aW+4|0;aU=c[aV>>2]|0;if((aU|0)==(c[aW+8>>2]|0)){e4(aW|0,g);bI=c[g>>2]|0}else{if((aU|0)==0){bJ=0}else{c[aU>>2]=aN;bJ=c[aV>>2]|0}c[aV>>2]=bJ+4;bI=aN}aN=bI;aU=bI;L206:do{if((a[X]&1)==0){aL=E;c[aL>>2]=c[X>>2];c[aL+4>>2]=c[X+4>>2];c[aL+8>>2]=c[X+8>>2];O=207}else{aL=c[ak>>2]|0;aK=c[al>>2]|0;do{if(aK>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aK>>>0<11>>>0){a[E]=aK<<1;bK=E+1|0}else{aC=aK+16&-16;aB=(z=0,au(248,aC|0)|0);if(z){z=0;break}c[E+8>>2]=aB;c[E>>2]=aC|1;c[E+4>>2]=aK;bK=aB}LF(bK|0,aL|0,aK)|0;a[bK+aK|0]=0;O=207;break L206}}while(0);aK=bT(-1,-1)|0;bL=aK;bM=M}}while(0);do{if((O|0)==207){aK=f;c[aK>>2]=c[V>>2];c[aK+4>>2]=c[V+4>>2];c[aK+8>>2]=c[V+8>>2];c[F>>2]=aX;c[F+4>>2]=I;z=0;aq(14,aU|0,E|0,f|0,F|0,0);do{if(!z){aK=bI;c[e>>2]=aK;aL=c[ag>>2]|0;aB=aL;if((aL|0)==(c[ah>>2]|0)){z=0;as(376,ai|0,e|0);if(z){z=0;bN=0;break}bO=c[e>>2]|0}else{if((aL|0)==0){bP=0}else{c[aB>>2]=aK;bP=c[ag>>2]|0}c[ag>>2]=bP+4;bO=aK}z=0;as(c[c[ab>>2]>>2]|0,W|0,bO|0);if(z){z=0;bN=0;break}if((a[E]&1)==0){bn=R;bH=bn;i=d;return bH|0}Lw(c[E+8>>2]|0);bn=R;bH=bn;i=d;return bH|0}else{z=0;bN=1}}while(0);aK=bT(-1,-1)|0;aB=aK;aK=M;if((a[E]&1)==0){if(bN){bL=aB;bM=aK;break}else{bv=aK;bw=aB}bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}else{Lw(c[E+8>>2]|0);if(bN){bL=aB;bM=aK;break}else{bv=aK;bw=aB}bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}}}while(0);aU=c[aW>>2]|0;aB=c[aV>>2]|0;aK=aU;while(1){if((aK|0)==(aB|0)){bQ=aB;break}if((c[aK>>2]|0)==(bI|0)){bQ=aK;break}else{aK=aK+4|0}}aK=bQ-aU>>2;aW=aU+(aK+1<<2)|0;aL=aB-aW|0;LG(aU+(aK<<2)|0,aW|0,aL|0)|0;aW=aU+((aL>>2)+aK<<2)|0;aK=c[aV>>2]|0;if((aW|0)!=(aK|0)){c[aV>>2]=aK+(~((aK-4+(-aW|0)|0)>>>2)<<2)}Lw(aN);bv=bM;bw=bL;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}else if((O|0)==231){bH=bn;i=d;return bH|0}else if((O|0)==232){bH=bn;i=d;return bH|0}}while(0);if((O|0)==109){bt=bs;bu=br}else if((O|0)==161){if((a[aM]&1)==0){bv=bB;bw=bC;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}Lw(c[aQ>>2]|0);bv=bB;bw=bC;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}else if((O|0)==178){if((a[ax]&1)!=0){Lw(c[aF>>2]|0)}bF=bD;bG=bE;O=189}if((O|0)==189){if((a[av]&1)==0){bv=bF;bw=bG;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}Lw(c[aE>>2]|0);bv=bF;bw=bG;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}W=c[a7>>2]|0;ab=c[a8>>2]|0;ag=W;while(1){if((ag|0)==(ab|0)){bR=ab;break}if((c[ag>>2]|0)==(a9|0)){bR=ag;break}else{ag=ag+4|0}}ag=bR-W>>2;aE=W+(ag+1<<2)|0;av=ab-aE|0;LG(W+(ag<<2)|0,aE|0,av|0)|0;aE=W+((av>>2)+ag<<2)|0;ag=c[a8>>2]|0;if((aE|0)!=(ag|0)){c[a8>>2]=ag+(~((ag-4+(-aE|0)|0)>>>2)<<2)}Lw(bb);bv=bu;bw=bt;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}}while(0);X=c[S>>2]|0;L=c[P>>2]|0;J=X;while(1){if((J|0)==(L|0)){bS=L;break}if((c[J>>2]|0)==(Z|0)){bS=J;break}else{J=J+4|0}}J=bS-X>>2;S=X+(J+1<<2)|0;K=L-S|0;LG(X+(J<<2)|0,S|0,K|0)|0;S=X+((K>>2)+J<<2)|0;J=c[P>>2]|0;if((S|0)!=(J|0)){c[P>>2]=J+(~((J-4+(-S|0)|0)>>>2)<<2)}Lw(R);bv=ac;bw=ad;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0)}else{O=12}}while(0);if((O|0)==12){Y=c[b>>2]|0}ad=Lu(52)|0;c[p>>2]=ad;ac=Y+4|0;bS=c[ac>>2]|0;if((bS|0)==(c[Y+8>>2]|0)){e4(Y|0,p);bU=c[p>>2]|0}else{if((bS|0)==0){bV=0}else{c[bS>>2]=ad;bV=c[ac>>2]|0}c[ac>>2]=bV+4;bU=ad}ad=bU;bV=b+28|0;L298:do{if((a[bV]&1)==0){bS=s;c[bS>>2]=c[bV>>2];c[bS+4>>2]=c[bV+4>>2];c[bS+8>>2]=c[bV+8>>2];O=29}else{bS=c[b+36>>2]|0;p=c[b+32>>2]|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(p>>>0<11>>>0){a[s]=p<<1;bW=s+1|0}else{Z=p+16&-16;bt=(z=0,au(248,Z|0)|0);if(z){z=0;break}c[s+8>>2]=bt;c[s>>2]=Z|1;c[s+4>>2]=p;bW=bt}LF(bW|0,bS|0,p)|0;a[bW+p|0]=0;O=29;break L298}}while(0);p=bT(-1,-1)|0;bX=M;bY=p}}while(0);do{if((O|0)==29){bW=b+44|0;bV=o;c[bV>>2]=c[bW>>2];c[bV+4>>2]=c[bW+4>>2];c[bV+8>>2]=c[bW+8>>2];z=0;aq(14,bU|0,s|0,o|0,r|0,0);if(z){z=0;bW=bT(-1,-1)|0;bV=bW;bW=M;if((a[s]&1)==0){bX=bW;bY=bV;break}Lw(c[s+8>>2]|0);bX=bW;bY=bV;break}if((a[s]&1)==0){bn=ad;bH=bn;i=d;return bH|0}Lw(c[s+8>>2]|0);bn=ad;bH=bn;i=d;return bH|0}}while(0);bH=c[Y>>2]|0;Y=c[ac>>2]|0;d=bH;while(1){if((d|0)==(Y|0)){bZ=Y;break}if((c[d>>2]|0)==(bU|0)){bZ=d;break}else{d=d+4|0}}d=bZ-bH>>2;bZ=bH+(d+1<<2)|0;bU=Y-bZ|0;LG(bH+(d<<2)|0,bZ|0,bU|0)|0;bZ=bH+((bU>>2)+d<<2)|0;d=c[ac>>2]|0;if((bZ|0)!=(d|0)){c[ac>>2]=d+(~((d-4+(-bZ|0)|0)>>>2)<<2)}Lw(ad);bv=bX;bw=bY;bx=bw;by=0;bz=bx;bA=bv;bg(bz|0);return 0}function uG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=(a[e]|0)==42?e+1|0:0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=y0(g)|0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function uH(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=h+32|0;LF(l|0,e|0,12)|0;e=j;m=k;n=b|0;o=d;if((a[o]&1)==0){c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){D5(0)}if(p>>>0<11>>>0){a[e]=p<<1;q=j+1|0}else{d=p+16&-16;r=Lu(d)|0;c[j+8>>2]=r;c[j>>2]=d|1;c[j+4>>2]=p;q=r}LF(q|0,o|0,p)|0;a[q+p|0]=0}c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];z=0;aV(6,n|0,j|0,k|0,g|0);if(!z){if((a[e]&1)==0){s=b|0;c[s>>2]=17768;t=b+32|0;c[t>>2]=f;i=h;return}Lw(c[j+8>>2]|0);s=b|0;c[s>>2]=17768;t=b+32|0;c[t>>2]=f;i=h;return}else{z=0;h=bT(-1,-1)|0;if((a[e]&1)==0){bg(h|0)}Lw(c[j+8>>2]|0);bg(h|0)}}function uI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0;e=i;i=i+336|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+64|0;m=e+80|0;n=e+88|0;o=e+96|0;p=e+104|0;q=e+120|0;r=e+128|0;s=e+144|0;t=e+152|0;u=e+168|0;v=e+184|0;w=e+192|0;x=e+256|0;y=e+264|0;A=e+280|0;B=e+296|0;C=e+312|0;D=e+320|0;t4(b)|0;E=b+20|0;F=c[E>>2]|0;G=b|0;H=c[G>>2]|0;I=Lu(60)|0;c[s>>2]=I;J=H+4|0;K=c[J>>2]|0;if((K|0)==(c[H+8>>2]|0)){e4(H|0,s);L=c[s>>2]|0}else{if((K|0)==0){N=0}else{c[K>>2]=I;N=c[J>>2]|0}c[J>>2]=N+4;L=I}I=L;N=b+28|0;L8:do{if((a[N]&1)==0){K=t;c[K>>2]=c[N>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];O=16}else{K=c[b+36>>2]|0;s=c[b+32>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(s>>>0<11>>>0){a[t]=s<<1;P=t+1|0}else{Q=s+16&-16;R=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[t+8>>2]=R;c[t>>2]=Q|1;c[t+4>>2]=s;P=R}LF(P|0,K|0,s)|0;a[P+s|0]=0;O=16;break L8}}while(0);s=bT(-1,-1)|0;S=s;T=M}}while(0);do{if((O|0)==16){P=b+44|0;s=r;c[s>>2]=c[P>>2];c[s+4>>2]=c[P+4>>2];c[s+8>>2]=c[P+8>>2];z=0;aD(2,L|0,t|0,r|0,0,0,0);if(z){z=0;s=bT(-1,-1)|0;K=s;s=M;if((a[t]&1)==0){S=K;T=s;break}Lw(c[t+8>>2]|0);S=K;T=s;break}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}L30:do{if(F>>>0<d>>>0){s=a[37176]|0;K=s<<24>>24==0;R=L+40|0;Q=R;U=u;V=v|0;W=v+4|0;X=R+8|0;Y=R+12|0;Z=R+4|0;_=u+8|0;$=b+36|0;aa=b+32|0;ab=u+1|0;ac=u|0;ad=u+4|0;ae=a[36840]|0;af=ae<<24>>24==0;ag=x|0;ah=x+4|0;ai=y;aj=A;ak=w+28|0;al=w+4|0;am=y+8|0;an=w+8|0;ao=w+36|0;ap=y+1|0;at=y|0;av=y+4|0;aw=F;L32:while(1){if(K){ax=aw;while(1){if(ax>>>0>=d>>>0){O=122;break L32}if((a[ax]|0)==0){O=122;break L32}if((ax|0)==0){ax=ax+1|0}else{ay=ax;break}}}else{ax=aw;while(1){if(ax>>>0>=d>>>0){O=122;break L32}az=a[ax]|0;if(az<<24>>24==0){O=122;break L32}L43:do{if(az<<24>>24==s<<24>>24){aA=37176;aB=ax;while(1){aC=aB+1|0;aE=aA+1|0;aF=a[aE]|0;if(aF<<24>>24==0){aG=aC;aH=0;break L43}if((a[aC]|0)==aF<<24>>24){aA=aE;aB=aC}else{aG=aC;aH=aF;break}}}else{aG=ax;aH=s}}while(0);if(aH<<24>>24!=0|(aG|0)==0){ax=ax+1|0}else{break}}if((ax|0)==0){O=122;break}else{ay=ax}}do{if(aw>>>0<ay>>>0){aI=c[G>>2]|0;az=Lu(52)|0;c[q>>2]=az;aJ=aI+4|0;aB=c[aJ>>2]|0;if((aB|0)==(c[aI+8>>2]|0)){e4(aI|0,q);aK=c[q>>2]|0}else{if((aB|0)==0){aL=0}else{c[aB>>2]=az;aL=c[aJ>>2]|0}c[aJ>>2]=aL+4;aK=az}aM=aK;az=aK;if((a[N]&1)==0){c[U>>2]=c[N>>2];c[U+4>>2]=c[N+4>>2];c[U+8>>2]=c[N+8>>2]}else{aB=c[$>>2]|0;aA=c[aa>>2]|0;if(aA>>>0>4294967279>>>0){O=41;break L32}if(aA>>>0<11>>>0){a[U]=aA<<1;aN=ab}else{aF=aA+16&-16;aC=(z=0,au(248,aF|0)|0);if(z){z=0;O=67;break L32}c[_>>2]=aC;c[ac>>2]=aF|1;c[ad>>2]=aA;aN=aC}LF(aN|0,aB|0,aA)|0;a[aN+aA|0]=0}aA=p;c[aA>>2]=c[P>>2];c[aA+4>>2]=c[P+4>>2];c[aA+8>>2]=c[P+8>>2];c[V>>2]=aw;c[W>>2]=ay;z=0;aq(14,az|0,u|0,p|0,v|0,0);if(z){z=0;aO=1;O=70;break L32}az=aK;c[o>>2]=az;aA=c[X>>2]|0;aB=aA;if((aA|0)==(c[Y>>2]|0)){z=0;as(376,Z|0,o|0);if(z){z=0;aO=0;O=70;break L32}aP=c[o>>2]|0}else{if((aA|0)==0){aQ=0}else{c[aB>>2]=az;aQ=c[X>>2]|0}c[X>>2]=aQ+4;aP=az}z=0;as(c[c[R>>2]>>2]|0,Q|0,aP|0);if(z){z=0;aO=0;O=70;break L32}if((a[U]&1)==0){break}Lw(c[_>>2]|0)}}while(0);L81:do{if(af){ax=ay;while(1){if(ax>>>0>=d>>>0){aR=0;break L81}if((a[ax]|0)==0){aR=0;break L81}if((ax|0)==0){ax=ax+1|0}else{aR=ax;break}}}else{ax=ay;while(1){if(ax>>>0>=d>>>0){aR=0;break L81}az=a[ax]|0;if(az<<24>>24==0){aR=0;break L81}L90:do{if(az<<24>>24==ae<<24>>24){aB=36840;aA=ax;while(1){aC=aA+1|0;aF=aB+1|0;aE=a[aF]|0;if(aE<<24>>24==0){aS=aC;aT=0;break L90}if((a[aC]|0)==aE<<24>>24){aB=aF;aA=aC}else{aS=aC;aT=aE;break}}}else{aS=ax;aT=ae}}while(0);if(aT<<24>>24!=0|(aS|0)==0){ax=ax+1|0}else{aR=ax;break}}}}while(0);c[ag>>2]=ay+2;c[ah>>2]=aR;ax=c[G>>2]|0;if((a[N]&1)==0){c[ai>>2]=c[N>>2];c[ai+4>>2]=c[N+4>>2];c[ai+8>>2]=c[N+8>>2]}else{az=c[$>>2]|0;aA=c[aa>>2]|0;if(aA>>>0>4294967279>>>0){O=92;break}if(aA>>>0<11>>>0){a[ai]=aA<<1;aU=ap}else{aB=aA+16&-16;aE=Lu(aB)|0;c[am>>2]=aE;c[at>>2]=aB|1;c[av>>2]=aA;aU=aE}LF(aU|0,az|0,aA)|0;a[aU+aA|0]=0}c[aj>>2]=c[P>>2];c[aj+4>>2]=c[P+4>>2];c[aj+8>>2]=c[P+8>>2];z=0;aq(16,w|0,x|0,ax|0,y|0,A|0);if(z){z=0;O=113;break}ax=(z=0,au(168,w|0)|0);if(z){z=0;O=114;break}if((a[ak]&1)!=0){Lw(c[ao>>2]|0)}aA=c[al>>2]|0;az=aA;if((aA|0)!=0){aE=c[an>>2]|0;if((aA|0)!=(aE|0)){c[an>>2]=aE+(~((aE-4+(-az|0)|0)>>>2)<<2)}Lw(aA)}if((a[ai]&1)!=0){Lw(c[am>>2]|0)}a[ax+29|0]=1;c[n>>2]=ax;aA=c[X>>2]|0;az=aA;if((aA|0)==(c[Y>>2]|0)){fq(Z,n);aV=c[n>>2]|0}else{if((aA|0)==0){aW=0}else{c[az>>2]=ax;aW=c[X>>2]|0}c[X>>2]=aW+4;aV=ax}cB[c[c[R>>2]>>2]&1023](Q,aV);ax=aR+1|0;if(ax>>>0<d>>>0){aw=ax}else{break L30}}do{if((O|0)==41){z=0;ar(86,0);if(!z){return 0}else{z=0;aj=bT(-1,-1)|0;aX=M;aY=aj;O=69;break}}else if((O|0)==122){aj=c[G>>2]|0;av=Lu(52)|0;c[m>>2]=av;at=aj+4|0;ap=c[at>>2]|0;if((ap|0)==(c[aj+8>>2]|0)){e4(aj|0,m);aZ=c[m>>2]|0}else{if((ap|0)==0){a_=0}else{c[ap>>2]=av;a_=c[at>>2]|0}c[at>>2]=a_+4;aZ=av}av=aZ;ap=aZ;L139:do{if((a[N]&1)==0){ah=B;c[ah>>2]=c[N>>2];c[ah+4>>2]=c[N+4>>2];c[ah+8>>2]=c[N+8>>2];O=137}else{ah=c[$>>2]|0;ag=c[aa>>2]|0;do{if(ag>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ag>>>0<11>>>0){a[B]=ag<<1;a$=B+1|0}else{ae=ag+16&-16;af=(z=0,au(248,ae|0)|0);if(z){z=0;break}c[B+8>>2]=af;c[B>>2]=ae|1;c[B+4>>2]=ag;a$=af}LF(a$|0,ah|0,ag)|0;a[a$+ag|0]=0;O=137;break L139}}while(0);ag=bT(-1,-1)|0;a0=M;a1=ag}}while(0);do{if((O|0)==137){ag=l;c[ag>>2]=c[P>>2];c[ag+4>>2]=c[P+4>>2];c[ag+8>>2]=c[P+8>>2];c[C>>2]=aw;c[C+4>>2]=d;z=0;aq(14,ap|0,B|0,l|0,C|0,0);do{if(!z){ag=aZ;c[k>>2]=ag;ah=c[X>>2]|0;af=ah;if((ah|0)==(c[Y>>2]|0)){z=0;as(376,Z|0,k|0);if(z){z=0;a2=0;break}a3=c[k>>2]|0}else{if((ah|0)==0){a4=0}else{c[af>>2]=ag;a4=c[X>>2]|0}c[X>>2]=a4+4;a3=ag}z=0;as(c[c[R>>2]>>2]|0,Q|0,a3|0);if(z){z=0;a2=0;break}if((a[B]&1)==0){break L30}Lw(c[B+8>>2]|0);break L30}else{z=0;a2=1}}while(0);ag=bT(-1,-1)|0;af=ag;ag=M;if((a[B]&1)==0){if(a2){a0=ag;a1=af;break}else{a5=af;a6=ag}a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}else{Lw(c[B+8>>2]|0);if(a2){a0=ag;a1=af;break}else{a5=af;a6=ag}a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}}}while(0);ap=c[aj>>2]|0;ag=c[at>>2]|0;af=ap;while(1){if((af|0)==(ag|0)){bb=ag;break}if((c[af>>2]|0)==(aZ|0)){bb=af;break}else{af=af+4|0}}af=bb-ap>>2;aj=ap+(af+1<<2)|0;ah=ag-aj|0;LG(ap+(af<<2)|0,aj|0,ah|0)|0;aj=ap+((ah>>2)+af<<2)|0;af=c[at>>2]|0;if((aj|0)!=(af|0)){c[at>>2]=af+(~((af-4+(-aj|0)|0)>>>2)<<2)}Lw(av);a5=a1;a6=a0;a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}else if((O|0)==92){D5(0);return 0}else if((O|0)==113){aj=bT(-1,-1)|0;bc=aj;bd=M;O=120}else if((O|0)==114){aj=bT(-1,-1)|0;af=aj;aj=M;if((a[ak]&1)!=0){Lw(c[ao>>2]|0)}ah=c[al>>2]|0;if((ah|0)==0){bc=af;bd=aj;O=120;break}ae=c[an>>2]|0;if((ah|0)!=(ae|0)){c[an>>2]=ae+(~((ae-4+(-ah|0)|0)>>>2)<<2)}Lw(ah);bc=af;bd=aj;O=120}else if((O|0)==67){aj=bT(-1,-1)|0;aX=M;aY=aj;O=69}else if((O|0)==70){aj=bT(-1,-1)|0;af=aj;aj=M;if((a[U]&1)==0){if(aO){be=aj;bf=af;break}else{a5=af;a6=aj}a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}else{Lw(c[_>>2]|0);if(aO){be=aj;bf=af;break}else{a5=af;a6=aj}a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}}}while(0);if((O|0)==120){if((a[ai]&1)==0){a5=bc;a6=bd;a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}Lw(c[am>>2]|0);a5=bc;a6=bd;a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}else if((O|0)==69){be=aX;bf=aY}_=c[aI>>2]|0;U=c[aJ>>2]|0;an=_;while(1){if((an|0)==(U|0)){bh=U;break}if((c[an>>2]|0)==(aK|0)){bh=an;break}else{an=an+4|0}}an=bh-_>>2;am=_+(an+1<<2)|0;ai=U-am|0;LG(_+(an<<2)|0,am|0,ai|0)|0;am=_+((ai>>2)+an<<2)|0;an=c[aJ>>2]|0;if((am|0)!=(an|0)){c[aJ>>2]=an+(~((an-4+(-am|0)|0)>>>2)<<2)}Lw(aM);a5=bf;a6=be;a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}}while(0);c[E>>2]=d;am=c[G>>2]|0;an=Lu(36)|0;c[j>>2]=an;ai=am+4|0;al=c[ai>>2]|0;if((al|0)==(c[am+8>>2]|0)){e4(am|0,j);bi=c[j>>2]|0}else{if((al|0)==0){bj=0}else{c[al>>2]=an;bj=c[ai>>2]|0}c[ai>>2]=bj+4;bi=an}an=bi;al=bi;L222:do{if((a[N]&1)==0){ao=D;c[ao>>2]=c[N>>2];c[ao+4>>2]=c[N+4>>2];c[ao+8>>2]=c[N+8>>2];bk=a[ao]|0;bl=ao;O=172}else{ao=c[b+36>>2]|0;ak=c[b+32>>2]|0;do{if(ak>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ak>>>0<11>>>0){Q=ak<<1&255;R=D;a[R]=Q;bm=D+1|0;bn=Q;bo=R}else{R=ak+16&-16;Q=(z=0,au(248,R|0)|0);if(z){z=0;break}c[D+8>>2]=Q;X=R|1;c[D>>2]=X;c[D+4>>2]=ak;bm=Q;bn=X&255;bo=D}LF(bm|0,ao|0,ak)|0;a[bm+ak|0]=0;bk=bn;bl=bo;O=172;break L222}}while(0);ak=bT(-1,-1)|0;bp=ak;bq=M}}while(0);do{if((O|0)==172){ak=h;c[ak>>2]=c[P>>2];c[ak+4>>2]=c[P+4>>2];c[ak+8>>2]=c[P+8>>2];ak=h;ao=f;_=g;U=bi;L237:do{if((bk&1)==0){c[ao>>2]=c[bl>>2];c[ao+4>>2]=c[bl+4>>2];c[ao+8>>2]=c[bl+8>>2];O=182}else{X=c[D+8>>2]|0;Q=c[D+4>>2]|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Q>>>0<11>>>0){a[ao]=Q<<1;br=f+1|0}else{R=Q+16&-16;Z=(z=0,au(248,R|0)|0);if(z){z=0;break}c[f+8>>2]=Z;c[f>>2]=R|1;c[f+4>>2]=Q;br=Z}LF(br|0,X|0,Q)|0;a[br+Q|0]=0;O=182;break L237}}while(0);Q=bT(-1,-1)|0;bs=M;bt=Q}}while(0);do{if((O|0)==182){c[_>>2]=c[ak>>2];c[_+4>>2]=c[ak+4>>2];c[_+8>>2]=c[ak+8>>2];z=0;aq(20,U|0,f|0,g|0,0,0);if(z){z=0;Q=bT(-1,-1)|0;X=M;if((a[ao]&1)==0){bs=X;bt=Q;break}Lw(c[f+8>>2]|0);bs=X;bt=Q;break}if((a[ao]&1)!=0){Lw(c[f+8>>2]|0)}c[bi>>2]=21280;c[bi+32>>2]=L;if((a[bl]&1)==0){i=e;return al|0}Lw(c[D+8>>2]|0);i=e;return al|0}}while(0);ao=bt;U=bs;if((a[bl]&1)==0){bp=ao;bq=U;break}Lw(c[D+8>>2]|0);bp=ao;bq=U}}while(0);al=c[am>>2]|0;P=c[ai>>2]|0;U=al;while(1){if((U|0)==(P|0)){bu=P;break}if((c[U>>2]|0)==(bi|0)){bu=U;break}else{U=U+4|0}}U=bu-al>>2;am=al+(U+1<<2)|0;ao=P-am|0;LG(al+(U<<2)|0,am|0,ao|0)|0;am=al+((ao>>2)+U<<2)|0;U=c[ai>>2]|0;if((am|0)!=(U|0)){c[ai>>2]=U+(~((U-4+(-am|0)|0)>>>2)<<2)}Lw(an);a5=bp;a6=bq;a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0)}}while(0);bq=c[H>>2]|0;H=c[J>>2]|0;bp=bq;while(1){if((bp|0)==(H|0)){bv=H;break}if((c[bp>>2]|0)==(L|0)){bv=bp;break}else{bp=bp+4|0}}bp=bv-bq>>2;bv=bq+(bp+1<<2)|0;L=H-bv|0;LG(bq+(bp<<2)|0,bv|0,L|0)|0;bv=bq+((L>>2)+bp<<2)|0;bp=c[J>>2]|0;if((bv|0)!=(bp|0)){c[J>>2]=bp+(~((bp-4+(-bv|0)|0)>>>2)<<2)}Lw(I);a5=S;a6=T;a7=a5;a8=0;a9=a7;ba=a6;bg(a9|0);return 0}function uJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0;d=i;i=i+200|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+64|0;m=d+80|0;n=d+88|0;o=d+96|0;p=d+104|0;q=d+120|0;r=d+136|0;s=d+152|0;t=d+168|0;u=d+184|0;Bv(o,0);v=b|0;w=c[v>>2]|0;x=(z=0,au(248,48)|0);L1:do{if(!z){y=x;c[m>>2]=y;A=w+4|0;B=c[A>>2]|0;if((B|0)==(c[w+8>>2]|0)){z=0;as(382,w|0,m|0);if(z){z=0;C=31;break}D=c[m>>2]|0}else{if((B|0)==0){E=0}else{c[B>>2]=y;E=c[A>>2]|0}c[A>>2]=E+4;D=y}y=D;B=D;F=b+28|0;L11:do{if((a[F]&1)==0){G=p;c[G>>2]=c[F>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];C=18}else{G=c[b+36>>2]|0;H=c[b+32>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[p]=H<<1;I=p+1|0}else{J=H+16&-16;K=(z=0,au(248,J|0)|0);if(z){z=0;break}c[p+8>>2]=K;c[p>>2]=J|1;c[p+4>>2]=H;I=K}LF(I|0,G|0,H)|0;a[I+H|0]=0;C=18;break L11}}while(0);H=bT(-1,-1)|0;L=H;N=M}}while(0);do{if((C|0)==18){H=b+44|0;G=l;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];z=0;aV(58,B|0,p|0,l|0,0);if(z){z=0;G=bT(-1,-1)|0;K=G;G=M;if((a[p]&1)==0){L=K;N=G;break}Lw(c[p+8>>2]|0);L=K;N=G;break}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}G=b+20|0;K=q;J=r;O=s;P=t;Q=u;R=u+8|0;S=b+36|0;T=b+32|0;U=u+1|0;V=u|0;W=u+4|0;X=t+8|0;Y=t+1|0;Z=t|0;_=t+4|0;$=r+8|0;aa=r+1|0;ab=r|0;ac=r+4|0;ad=D+32|0;ae=ad;af=D+40|0;ag=ad+12|0;ah=D+36|0;ai=ad;L33:while(1){ad=(z=0,au(66,c[G>>2]|0)|0);if(z){z=0;C=30;break}if(!((ad+1|0)==0|(a[ad]|0)!=123)){C=164;break}ad=(z=0,au(66,c[G>>2]|0)|0);if(z){z=0;C=30;break}if(!((ad+1|0)==0|(a[ad]|0)!=125)){C=160;break}ad=(z=0,au(66,c[G>>2]|0)|0);if(z){z=0;C=30;break}if(!((ad+1|0)==0|(a[ad]|0)!=41)){C=162;break}ad=(z=0,au(66,c[G>>2]|0)|0);if(z){z=0;C=30;break}if(!((ad+1|0)==0|(a[ad]|0)!=59)){C=163;break}ad=(z=0,au(38,b|0)|0);if(z){z=0;C=30;break}aj=ad+28|0;do{if((a[aj]&1)==0){c[K>>2]=c[H>>2];c[K+4>>2]=c[H+4>>2];c[K+8>>2]=c[H+8>>2];ak=c[v>>2]|0;al=(z=0,au(248,36)|0);if(z){z=0;C=30;break L33}am=al;c[j>>2]=am;an=ak+4|0;al=c[an>>2]|0;if((al|0)==(c[ak+8>>2]|0)){z=0;as(382,ak|0,j|0);if(z){z=0;C=30;break L33}ao=c[j>>2]|0}else{if((al|0)==0){ap=0}else{c[al>>2]=am;ap=c[an>>2]|0}c[an>>2]=ap+4;ao=am}aq=ao;if((a[F]&1)==0){c[J>>2]=c[F>>2];c[J+4>>2]=c[F+4>>2];c[J+8>>2]=c[F+8>>2]}else{am=c[S>>2]|0;al=c[T>>2]|0;if(al>>>0>4294967279>>>0){C=54;break L33}if(al>>>0<11>>>0){a[J]=al<<1;at=aa}else{av=al+16&-16;aw=(z=0,au(248,av|0)|0);if(z){z=0;C=93;break L33}c[$>>2]=aw;c[ab>>2]=av|1;c[ac>>2]=al;at=aw}LF(at|0,am|0,al)|0;a[at+al|0]=0}c[O>>2]=c[K>>2];c[O+4>>2]=c[K+4>>2];c[O+8>>2]=c[K+8>>2];z=0;aV(54,ao|0,r|0,s|0,0);if(z){z=0;C=96;break L33}if((a[J]&1)!=0){Lw(c[$>>2]|0)}ax=c[v>>2]|0;al=(z=0,au(248,60)|0);if(z){z=0;C=30;break L33}am=al;c[h>>2]=am;ay=ax+4|0;al=c[ay>>2]|0;if((al|0)==(c[ax+8>>2]|0)){z=0;as(382,ax|0,h|0);if(z){z=0;C=30;break L33}az=c[h>>2]|0}else{if((al|0)==0){aA=0}else{c[al>>2]=am;aA=c[ay>>2]|0}c[ay>>2]=aA+4;az=am}aB=az;am=az;if((a[F]&1)==0){c[P>>2]=c[F>>2];c[P+4>>2]=c[F+4>>2];c[P+8>>2]=c[F+8>>2]}else{al=c[S>>2]|0;aw=c[T>>2]|0;if(aw>>>0>4294967279>>>0){C=74;break L33}if(aw>>>0<11>>>0){a[P]=aw<<1;aC=Y}else{av=aw+16&-16;aE=(z=0,au(248,av|0)|0);if(z){z=0;C=104;break L33}c[X>>2]=aE;c[Z>>2]=av|1;c[_>>2]=aw;aC=aE}LF(aC|0,al|0,aw)|0;a[aC+aw|0]=0}aw=g;c[aw>>2]=c[K>>2];c[aw+4>>2]=c[K+4>>2];c[aw+8>>2]=c[K+8>>2];z=0;aV(42,am|0,t|0,g|0,0);if(z){z=0;C=107;break L33}if((a[P]&1)!=0){Lw(c[X>>2]|0)}aw=az+32|0;al=aw;aE=ao;c[f>>2]=aE;av=az+40|0;aF=c[av>>2]|0;aG=aF;if((aG|0)==(c[aw+12>>2]|0)){z=0;as(740,az+36|0,f|0);if(z){z=0;C=30;break L33}aH=c[f>>2]|0}else{if((aF|0)==0){aI=0}else{c[aG>>2]=aE;aI=c[av>>2]|0}c[av>>2]=aI+4;aH=aE}z=0;as(c[c[aw>>2]>>2]|0,al|0,aH|0);if(z){z=0;C=30;break L33}al=ad+36|0;if((c[al>>2]|0)==0){c[al>>2]=am;a[aj]=1;aJ=ad;break}aK=c[v>>2]|0;al=(z=0,au(248,44)|0);if(z){z=0;C=30;break L33}aw=al;c[e>>2]=aw;aL=aK+4|0;al=c[aL>>2]|0;if((al|0)==(c[aK+8>>2]|0)){z=0;as(382,aK|0,e|0);if(z){z=0;C=30;break L33}aM=c[e>>2]|0}else{if((al|0)==0){aN=0}else{c[al>>2]=aw;aN=c[aL>>2]|0}c[aL>>2]=aN+4;aM=aw}aO=aM;aw=aM;if((a[F]&1)==0){c[Q>>2]=c[F>>2];c[Q+4>>2]=c[F+4>>2];c[Q+8>>2]=c[F+8>>2]}else{al=c[S>>2]|0;aE=c[T>>2]|0;if(aE>>>0>4294967279>>>0){C=125;break L33}if(aE>>>0<11>>>0){a[Q]=aE<<1;aP=U}else{av=aE+16&-16;aG=(z=0,au(248,av|0)|0);if(z){z=0;C=136;break L33}c[R>>2]=aG;c[V>>2]=av|1;c[W>>2]=aE;aP=aG}LF(aP|0,al|0,aE)|0;a[aP+aE|0]=0}aE=k;c[aE>>2]=c[K>>2];c[aE+4>>2]=c[K+4>>2];c[aE+8>>2]=c[K+8>>2];z=0;aD(20,aw|0,u|0,k|0,0,am|0,ad|0);if(z){z=0;C=139;break L33}if((a[Q]&1)!=0){Lw(c[R>>2]|0)}a[aM+28|0]=1;aJ=aw}else{aJ=ad}}while(0);c[n>>2]=aJ;ad=c[af>>2]|0;aj=ad;if((aj|0)==(c[ag>>2]|0)){z=0;as(272,ah|0,n|0);if(z){z=0;C=30;break}aQ=c[n>>2]|0}else{if((ad|0)==0){aR=0}else{c[aj>>2]=aJ;aR=c[af>>2]|0}c[af>>2]=aR+4;aQ=aJ}z=0;as(c[c[ai>>2]>>2]|0,ae|0,aQ|0);if(z){z=0;C=30;break}aj=(z=0,au(266,b|0)|0);if(z){z=0;C=30;break}if((aj|0)==0){C=161;break}}do{if((C|0)==125){z=0;ar(86,0);if(!z){return 0}else{z=0;ae=bT(-1,-1)|0;aS=M;aT=ae;C=138;break}}else if((C|0)==136){ae=bT(-1,-1)|0;aS=M;aT=ae;C=138}else if((C|0)==139){ae=bT(-1,-1)|0;ai=ae;ae=M;if((a[Q]&1)==0){aU=ai;aW=ae;C=141;break}Lw(c[R>>2]|0);aU=ai;aW=ae;C=141}else if((C|0)==93){ae=bT(-1,-1)|0;aX=M;aY=ae;C=95}else if((C|0)==96){ae=bT(-1,-1)|0;ai=ae;ae=M;if((a[J]&1)==0){aZ=ai;a_=ae;C=98;break}Lw(c[$>>2]|0);aZ=ai;a_=ae;C=98}else if((C|0)==104){ae=bT(-1,-1)|0;a$=M;a0=ae;C=106}else if((C|0)==107){ae=bT(-1,-1)|0;ai=ae;ae=M;if((a[P]&1)==0){a1=ai;a2=ae;C=109;break}Lw(c[X>>2]|0);a1=ai;a2=ae;C=109}else if((C|0)==54){z=0;ar(86,0);if(!z){return 0}else{z=0;ae=bT(-1,-1)|0;aX=M;aY=ae;C=95;break}}else if((C|0)==160){Bx(o);i=d;return B|0}else if((C|0)==161){Bx(o);i=d;return B|0}else if((C|0)==162){Bx(o);i=d;return B|0}else if((C|0)==163){Bx(o);i=d;return B|0}else if((C|0)==164){Bx(o);i=d;return B|0}else if((C|0)==30){ae=bT(-1,-1)|0;a3=M;a4=ae;C=32;break L1}else if((C|0)==74){z=0;ar(86,0);if(!z){return 0}else{z=0;ae=bT(-1,-1)|0;a$=M;a0=ae;C=106;break}}}while(0);if((C|0)==138){aU=aT;aW=aS;C=141}else if((C|0)==95){aZ=aY;a_=aX;C=98}else if((C|0)==106){a1=a0;a2=a$;C=109}if((C|0)==141){X=c[aK>>2]|0;P=c[aL>>2]|0;$=X;while(1){if(($|0)==(P|0)){a5=P;break}if((c[$>>2]|0)==(aM|0)){a5=$;break}else{$=$+4|0}}$=a5-X>>2;J=X+($+1<<2)|0;R=P-J|0;LG(X+($<<2)|0,J|0,R|0)|0;J=X+((R>>2)+$<<2)|0;$=c[aL>>2]|0;if((J|0)!=($|0)){c[aL>>2]=$+(~(($-4+(-J|0)|0)>>>2)<<2)}Lw(aO);a6=aU;a7=aW;break L1}else if((C|0)==98){J=c[ak>>2]|0;$=c[an>>2]|0;R=J;while(1){if((R|0)==($|0)){a8=$;break}if((c[R>>2]|0)==(ao|0)){a8=R;break}else{R=R+4|0}}R=a8-J>>2;X=J+(R+1<<2)|0;P=$-X|0;LG(J+(R<<2)|0,X|0,P|0)|0;X=J+((P>>2)+R<<2)|0;R=c[an>>2]|0;if((X|0)!=(R|0)){c[an>>2]=R+(~((R-4+(-X|0)|0)>>>2)<<2)}Lw(aq);a6=aZ;a7=a_;break L1}else if((C|0)==109){X=c[ax>>2]|0;R=c[ay>>2]|0;P=X;while(1){if((P|0)==(R|0)){a9=R;break}if((c[P>>2]|0)==(az|0)){a9=P;break}else{P=P+4|0}}P=a9-X>>2;J=X+(P+1<<2)|0;$=R-J|0;LG(X+(P<<2)|0,J|0,$|0)|0;J=X+(($>>2)+P<<2)|0;P=c[ay>>2]|0;if((J|0)!=(P|0)){c[ay>>2]=P+(~((P-4+(-J|0)|0)>>>2)<<2)}Lw(aB);a6=a1;a7=a2;break L1}}}while(0);B=c[w>>2]|0;F=c[A>>2]|0;J=B;while(1){if((J|0)==(F|0)){ba=F;break}if((c[J>>2]|0)==(D|0)){ba=J;break}else{J=J+4|0}}J=ba-B>>2;P=B+(J+1<<2)|0;$=F-P|0;LG(B+(J<<2)|0,P|0,$|0)|0;P=B+(($>>2)+J<<2)|0;J=c[A>>2]|0;if((P|0)!=(J|0)){c[A>>2]=J+(~((J-4+(-P|0)|0)>>>2)<<2)}Lw(y);a6=L;a7=N}else{z=0;C=31}}while(0);if((C|0)==31){N=bT(-1,-1)|0;a3=M;a4=N;C=32}if((C|0)==32){a6=a4;a7=a3}z=0;ar(444,o|0);if(!z){bg(a6|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function uK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+40|0;e=d|0;f=d+16|0;g=d+24|0;h=b+20|0;j=y$(c[h>>2]|0)|0;do{if((j+1|0)==0|(a[j]|0)!=43){k=y$(c[h>>2]|0)|0;if(!((k+1|0)==0|(a[k]|0)!=126)){l=0;m=0;n=0;o=0;break}k=y$(c[h>>2]|0)|0;if(!((k+1|0)==0|(a[k]|0)!=62)){l=0;m=0;n=0;o=0;break}k=uN(b)|0;l=k;m=c[b+44>>2]|0;n=c[b+48>>2]|0;o=c[b+52>>2]|0}else{l=0;m=0;n=0;o=0}}while(0);j=y$(c[h>>2]|0)|0;k=(a[j]|0)==43?j+1|0:0;do{if((k|0)==0){p=y$(c[h>>2]|0)|0;q=(a[p]|0)==126?p+1|0:0;if((q|0)!=0){r=b+48|0;s=c[r>>2]|0;t=c[h>>2]|0;L10:do{if(t>>>0<q>>>0){u=t;v=0;while(1){w=a[u]|0;if((w<<24>>24|0)==10){x=v+1|0}else if((w<<24>>24|0)==0){y=v;break L10}else{x=v}w=u+1|0;if(w>>>0<q>>>0){u=w;v=x}else{y=x;break}}}else{y=0}}while(0);c[r>>2]=y+s;v=p;u=0;while(1){w=v-1|0;if(w>>>0<t>>>0){break}if((a[w]|0)==10){break}else{v=w;u=u+1|0}}v=b+40|0;if((y|0)!=0){c[v>>2]=1}t=c[v>>2]|0;c[b+52>>2]=t+u;s=q;r=p;c[v>>2]=s-r+u+t;t=b+56|0;c[t>>2]=r;c[t+4>>2]=s;c[h>>2]=q;A=2;B=q;break}s=y$(c[h>>2]|0)|0;t=(a[s]|0)==62?s+1|0:0;if((t|0)==0){A=0;B=c[h>>2]|0;break}r=b+48|0;v=c[r>>2]|0;w=c[h>>2]|0;L28:do{if(w>>>0<t>>>0){C=w;D=0;while(1){E=a[C]|0;if((E<<24>>24|0)==0){F=D;break L28}else if((E<<24>>24|0)==10){G=D+1|0}else{G=D}E=C+1|0;if(E>>>0<t>>>0){C=E;D=G}else{F=G;break}}}else{F=0}}while(0);c[r>>2]=F+v;q=s;u=0;while(1){p=q-1|0;if(p>>>0<w>>>0){break}if((a[p]|0)==10){break}else{q=p;u=u+1|0}}q=b+40|0;if((F|0)!=0){c[q>>2]=1}w=c[q>>2]|0;c[b+52>>2]=w+u;v=t;r=s;c[q>>2]=v-r+u+w;w=b+56|0;c[w>>2]=r;c[w+4>>2]=v;c[h>>2]=t;A=1;B=t}else{v=b+48|0;w=c[v>>2]|0;r=c[h>>2]|0;L43:do{if(r>>>0<k>>>0){q=r;p=0;while(1){D=a[q]|0;if((D<<24>>24|0)==10){H=p+1|0}else if((D<<24>>24|0)==0){I=p;break L43}else{H=p}D=q+1|0;if(D>>>0<k>>>0){q=D;p=H}else{I=H;break}}}else{I=0}}while(0);c[v>>2]=I+w;t=j;u=0;while(1){s=t-1|0;if(s>>>0<r>>>0){break}if((a[s]|0)==10){break}else{t=s;u=u+1|0}}t=b+40|0;if((I|0)!=0){c[t>>2]=1}r=c[t>>2]|0;c[b+52>>2]=r+u;w=k;v=j;c[t>>2]=w-v+u+r;r=b+56|0;c[r>>2]=v;c[r+4>>2]=w;c[h>>2]=k;A=3;B=k}}while(0);k=y$(B)|0;do{if((k+1|0)==0|(a[k]|0)!=44){B=y$(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=41)){J=0;K=m;L=n;N=o;break}B=y$(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=123)){J=0;K=m;L=n;N=o;break}B=y$(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=125)){J=0;K=m;L=n;N=o;break}B=y$(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=59)){J=0;K=m;L=n;N=o;break}B=uK(b)|0;J=B;K=c[b+44>>2]|0;L=c[b+48>>2]|0;N=c[b+52>>2]|0}else{J=0;K=m;L=n;N=o}}while(0);if((L|0)==0){O=c[b+44>>2]|0;P=c[b+48>>2]|0;Q=c[b+52>>2]|0}else{O=K;P=L;Q=N}N=c[b>>2]|0;L=Lu(44)|0;c[f>>2]=L;K=N+4|0;o=c[K>>2]|0;if((o|0)==(c[N+8>>2]|0)){e4(N|0,f);R=c[f>>2]|0}else{if((o|0)==0){S=0}else{c[o>>2]=L;S=c[K>>2]|0}c[K>>2]=S+4;R=L}L=R;S=R;o=b+28|0;L75:do{if((a[o]&1)==0){f=g;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];T=62}else{f=c[b+36>>2]|0;n=c[b+32>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(n>>>0<11>>>0){a[g]=n<<1;U=g+1|0}else{m=n+16&-16;h=(z=0,au(248,m|0)|0);if(z){z=0;break}c[g+8>>2]=h;c[g>>2]=m|1;c[g+4>>2]=n;U=h}LF(U|0,f|0,n)|0;a[U+n|0]=0;T=62;break L75}}while(0);n=bT(-1,-1)|0;V=M;W=n}}while(0);do{if((T|0)==62){c[e>>2]=O;c[e+4>>2]=P;c[e+8>>2]=Q;z=0;aD(20,S|0,g|0,e|0,A|0,l|0,J|0);if(z){z=0;U=bT(-1,-1)|0;b=U;U=M;if((a[g]&1)==0){V=U;W=b;break}Lw(c[g+8>>2]|0);V=U;W=b;break}if((a[g]&1)==0){i=d;return S|0}Lw(c[g+8>>2]|0);i=d;return S|0}}while(0);S=c[N>>2]|0;N=c[K>>2]|0;d=S;while(1){if((d|0)==(N|0)){X=N;break}if((c[d>>2]|0)==(R|0)){X=d;break}else{d=d+4|0}}d=X-S>>2;X=S+(d+1<<2)|0;R=N-X|0;LG(S+(d<<2)|0,X|0,R|0)|0;X=S+((R>>2)+d<<2)|0;d=c[K>>2]|0;if((X|0)==(d|0)){Lw(L);Y=W;Z=0;_=Y;$=V;bg(_|0)}c[K>>2]=d+(~((d-4+(-X|0)|0)>>>2)<<2);Lw(L);Y=W;Z=0;_=Y;$=V;bg(_|0);return 0}function uL(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;LF(k|0,e|0,12)|0;e=h;l=j;m=b|0;n=d;if((a[n]&1)==0){c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[e]=o<<1;p=h+1|0}else{d=o+16&-16;q=Lu(d)|0;c[h+8>>2]=q;c[h>>2]=d|1;c[h+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];z=0;aR(302,m|0,h|0,j|0);if(!z){if((a[e]&1)==0){r=b|0;c[r>>2]=20320;s=b+32|0;c[s>>2]=f;t=b+28|0;a[t]=1;i=g;return}Lw(c[h+8>>2]|0);r=b|0;c[r>>2]=20320;s=b+32|0;c[s>>2]=f;t=b+28|0;a[t]=1;i=g;return}else{z=0;g=bT(-1,-1)|0;if((a[e]&1)==0){bg(g|0)}Lw(c[h+8>>2]|0);bg(g|0)}}function uM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=y$(e)|0;if((f|0)==0){g=0;return g|0}h=(a[f]|0)==44?f+1|0:0;if((h|0)==0){g=0;return g|0}else{i=h}while(1){h=y$(i)|0;if((h|0)==0){break}f=(a[h]|0)==44?h+1|0:0;if((f|0)==0){j=5;break}else{i=f}}do{if((j|0)==5){if((i|0)==0){g=0}else{break}return g|0}}while(0);j=b+48|0;f=c[j>>2]|0;h=c[d>>2]|0;L13:do{if(h>>>0<i>>>0){k=h;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L13}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[j>>2]=f+o;f=e;j=0;while(1){n=f-1|0;if(n>>>0<h>>>0){break}if((a[n]|0)==10){break}else{f=n;j=j+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+j;h=i;n=e;c[f>>2]=h-n+j+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=h;c[d>>2]=i;g=i;return g|0}function uN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0;d=i;i=i+264|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+80|0;o=d+88|0;p=d+96|0;q=d+112|0;r=d+120|0;s=d+136|0;t=d+152|0;u=d+168|0;v=d+184|0;w=d+200|0;x=d+216|0;y=d+232|0;A=d+248|0;B=b|0;C=c[B>>2]|0;D=Lu(60)|0;c[q>>2]=D;E=C+4|0;F=c[E>>2]|0;if((F|0)==(c[C+8>>2]|0)){e4(C|0,q);G=c[q>>2]|0}else{if((F|0)==0){H=0}else{c[F>>2]=D;H=c[E>>2]|0}c[E>>2]=H+4;G=D}D=G;H=G;F=b+28|0;L8:do{if((a[F]&1)==0){q=r;c[q>>2]=c[F>>2];c[q+4>>2]=c[F+4>>2];c[q+8>>2]=c[F+8>>2];I=16}else{q=c[b+36>>2]|0;J=c[b+32>>2]|0;do{if(J>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(J>>>0<11>>>0){a[r]=J<<1;K=r+1|0}else{L=J+16&-16;N=(z=0,au(248,L|0)|0);if(z){z=0;break}c[r+8>>2]=N;c[r>>2]=L|1;c[r+4>>2]=J;K=N}LF(K|0,q|0,J)|0;a[K+J|0]=0;I=16;break L8}}while(0);J=bT(-1,-1)|0;O=M;P=J}}while(0);do{if((I|0)==16){K=b+44|0;J=p;c[J>>2]=c[K>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];z=0;aV(42,H|0,r|0,p|0,0);if(z){z=0;J=bT(-1,-1)|0;q=J;J=M;if((a[r]&1)==0){O=J;P=q;break}Lw(c[r+8>>2]|0);O=J;P=q;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}q=b+20|0;J=y$(c[q>>2]|0)|0;N=(a[J]|0)==38?J+1|0:0;L30:do{if((N|0)==0){Q=0;I=127}else{L=b+48|0;R=c[L>>2]|0;S=c[q>>2]|0;L32:do{if(S>>>0<N>>>0){T=S;U=0;while(1){V=a[T]|0;if((V<<24>>24|0)==0){W=U;break L32}else if((V<<24>>24|0)==10){X=U+1|0}else{X=U}V=T+1|0;if(V>>>0<N>>>0){T=V;U=X}else{W=X;break}}}else{W=0}}while(0);c[L>>2]=W+R;U=J;T=0;while(1){V=U-1|0;if(V>>>0<S>>>0){break}if((a[V]|0)==10){break}else{U=V;T=T+1|0}}U=b+40|0;if((W|0)!=0){c[U>>2]=1}S=c[U>>2]|0;c[b+52>>2]=S+T;R=N;V=J;c[U>>2]=R-V+T+S;S=b+56|0;c[S>>2]=V;c[S+4>>2]=R;c[q>>2]=N;R=G+32|0;V=R;U=c[B>>2]|0;Y=Lu(36)|0;c[o>>2]=Y;Z=U+4|0;_=c[Z>>2]|0;if((_|0)==(c[U+8>>2]|0)){e4(U|0,o);$=c[o>>2]|0}else{if((_|0)==0){aa=0}else{c[_>>2]=Y;aa=c[Z>>2]|0}c[Z>>2]=aa+4;$=Y}Y=$;L53:do{if((a[F]&1)==0){_=s;c[_>>2]=c[F>>2];c[_+4>>2]=c[F+4>>2];c[_+8>>2]=c[F+8>>2];I=44}else{_=c[b+36>>2]|0;ab=c[b+32>>2]|0;do{if(ab>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ab>>>0<11>>>0){a[s]=ab<<1;ac=s+1|0}else{ad=ab+16&-16;ae=(z=0,au(248,ad|0)|0);if(z){z=0;break}c[s+8>>2]=ae;c[s>>2]=ad|1;c[s+4>>2]=ab;ac=ae}LF(ac|0,_|0,ab)|0;a[ac+ab|0]=0;I=44;break L53}}while(0);ab=bT(-1,-1)|0;af=ab;ag=M}}while(0);do{if((I|0)==44){T=t;c[T>>2]=c[K>>2];c[T+4>>2]=c[K+4>>2];c[T+8>>2]=c[K+8>>2];z=0;aV(54,$|0,s|0,t|0,0);do{if(!z){T=$;c[n>>2]=T;ab=G+40|0;_=c[ab>>2]|0;ae=_;ad=R+12|0;if((ae|0)==(c[ad>>2]|0)){z=0;as(740,G+36|0,n|0);if(z){z=0;ah=0;break}ai=c[n>>2]|0}else{if((_|0)==0){aj=0}else{c[ae>>2]=T;aj=c[ab>>2]|0}c[ab>>2]=aj+4;ai=T}T=R;z=0;as(c[c[T>>2]>>2]|0,V|0,ai|0);if(z){z=0;ah=0;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}ae=yR(c[q>>2]|0)|0;if((ae|0)!=0){_=c[q>>2]|0;L84:do{if(_>>>0<ae>>>0){ak=_;al=0;while(1){am=a[ak]|0;if((am<<24>>24|0)==10){an=al+1|0}else if((am<<24>>24|0)==0){ao=al;break L84}else{an=al}am=ak+1|0;if(am>>>0<ae>>>0){ak=am;al=an}else{ao=an;break}}}else{ao=0}}while(0);c[L>>2]=(c[L>>2]|0)+ao;c[S>>2]=_;c[S+4>>2]=ae;c[q>>2]=ae;i=d;return H|0}if((uO(b)|0)==0){Q=1;I=127;break L30}al=c[B>>2]|0;ak=Lu(44)|0;c[m>>2]=ak;am=al+4|0;ap=c[am>>2]|0;if((ap|0)==(c[al+8>>2]|0)){e4(al|0,m);aq=c[m>>2]|0}else{if((ap|0)==0){at=0}else{c[ap>>2]=ak;at=c[am>>2]|0}c[am>>2]=at+4;aq=ak}ak=aq;ap=aq;L101:do{if((a[F]&1)==0){av=u;c[av>>2]=c[F>>2];c[av+4>>2]=c[F+4>>2];c[av+8>>2]=c[F+8>>2];I=95}else{av=c[b+36>>2]|0;aw=c[b+32>>2]|0;do{if(aw>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aw>>>0<11>>>0){a[u]=aw<<1;ax=u+1|0}else{ay=aw+16&-16;az=(z=0,au(248,ay|0)|0);if(z){z=0;break}c[u+8>>2]=az;c[u>>2]=ay|1;c[u+4>>2]=aw;ax=az}LF(ax|0,av|0,aw)|0;a[ax+aw|0]=0;I=95;break L101}}while(0);aw=bT(-1,-1)|0;aA=aw;aB=M}}while(0);do{if((I|0)==95){ae=v;c[ae>>2]=c[K>>2];c[ae+4>>2]=c[K+4>>2];c[ae+8>>2]=c[K+8>>2];_=c[b+56>>2]|0;aw=(c[b+60>>2]|0)-_|0;do{if(aw>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;I=115;break}return 0}else{if(aw>>>0<11>>>0){a[w]=aw<<1;aC=w+1|0}else{av=aw+16&-16;az=(z=0,au(248,av|0)|0);if(z){z=0;I=115;break}c[w+8>>2]=az;c[w>>2]=av|1;c[w+4>>2]=aw;aC=az}LF(aC|0,_|0,aw)|0;a[aC+aw|0]=0;az=l;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];z=0;aV(10,ap|0,u|0,l|0,w|0);do{if(!z){az=aq;c[k>>2]=az;av=c[ab>>2]|0;ay=av;if((ay|0)==(c[ad>>2]|0)){z=0;as(740,G+36|0,k|0);if(z){z=0;aD=0;break}aE=c[k>>2]|0}else{if((av|0)==0){aF=0}else{c[ay>>2]=az;aF=c[ab>>2]|0}c[ab>>2]=aF+4;aE=az}z=0;as(c[c[T>>2]>>2]|0,V|0,aE|0);if(z){z=0;aD=0;break}if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}if((a[u]&1)==0){break L30}Lw(c[u+8>>2]|0);break L30}else{z=0;aD=1}}while(0);az=bT(-1,-1)|0;ay=az;az=M;if((a[w]&1)==0){aG=aD;aH=az;aI=ay;break}Lw(c[w+8>>2]|0);aG=aD;aH=az;aI=ay}}while(0);if((I|0)==115){ae=bT(-1,-1)|0;aG=1;aH=M;aI=ae}if((a[u]&1)==0){if(aG){aA=aI;aB=aH;break}else{aJ=aH;aK=aI}aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}else{Lw(c[u+8>>2]|0);if(aG){aA=aI;aB=aH;break}else{aJ=aH;aK=aI}aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}}}while(0);T=c[al>>2]|0;ab=c[am>>2]|0;ad=T;while(1){if((ad|0)==(ab|0)){aP=ab;break}if((c[ad>>2]|0)==(aq|0)){aP=ad;break}else{ad=ad+4|0}}ad=aP-T>>2;al=T+(ad+1<<2)|0;ap=ab-al|0;LG(T+(ad<<2)|0,al|0,ap|0)|0;al=T+((ap>>2)+ad<<2)|0;ad=c[am>>2]|0;if((al|0)!=(ad|0)){c[am>>2]=ad+(~((ad-4+(-al|0)|0)>>>2)<<2)}Lw(ak);aJ=aB;aK=aA;aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}else{z=0;ah=1}}while(0);al=bT(-1,-1)|0;ad=al;al=M;if((a[s]&1)==0){if(ah){af=ad;ag=al;break}else{aJ=al;aK=ad}aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}else{Lw(c[s+8>>2]|0);if(ah){af=ad;ag=al;break}else{aJ=al;aK=ad}aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}}}while(0);V=c[U>>2]|0;S=c[Z>>2]|0;L=V;while(1){if((L|0)==(S|0)){aQ=S;break}if((c[L>>2]|0)==($|0)){aQ=L;break}else{L=L+4|0}}L=aQ-V>>2;U=V+(L+1<<2)|0;R=S-U|0;LG(V+(L<<2)|0,U|0,R|0)|0;U=V+((R>>2)+L<<2)|0;L=c[Z>>2]|0;if((U|0)!=(L|0)){c[Z>>2]=L+(~((L-4+(-U|0)|0)>>>2)<<2)}Lw(Y);aJ=ag;aK=af;aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}}while(0);L174:do{if((I|0)==127){if((uP(b)|0)==0){if(Q){break}N=G+32|0;J=N;U=uQ(b)|0;c[f>>2]=U;L=G+40|0;R=c[L>>2]|0;ad=R;if((ad|0)==(c[N+12>>2]|0)){e3(G+36|0,f);aR=c[f>>2]|0}else{if((R|0)==0){aS=0}else{c[ad>>2]=U;aS=c[L>>2]|0}c[L>>2]=aS+4;aR=U}cB[c[c[N>>2]>>2]&1023](J,aR);break}J=G+32|0;N=J;U=c[B>>2]|0;L=Lu(44)|0;c[j>>2]=L;ad=U+4|0;R=c[ad>>2]|0;if((R|0)==(c[U+8>>2]|0)){e4(U|0,j);aT=c[j>>2]|0}else{if((R|0)==0){aU=0}else{c[R>>2]=L;aU=c[ad>>2]|0}c[ad>>2]=aU+4;aT=L}L=aT;R=aT;L194:do{if((a[F]&1)==0){al=x;c[al>>2]=c[F>>2];c[al+4>>2]=c[F+4>>2];c[al+8>>2]=c[F+8>>2];I=143}else{al=c[b+36>>2]|0;ap=c[b+32>>2]|0;do{if(ap>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ap>>>0<11>>>0){a[x]=ap<<1;aW=x+1|0}else{ae=ap+16&-16;aw=(z=0,au(248,ae|0)|0);if(z){z=0;break}c[x+8>>2]=aw;c[x>>2]=ae|1;c[x+4>>2]=ap;aW=aw}LF(aW|0,al|0,ap)|0;a[aW+ap|0]=0;I=143;break L194}}while(0);ap=bT(-1,-1)|0;aX=ap;aY=M}}while(0);do{if((I|0)==143){Y=y;c[Y>>2]=c[K>>2];c[Y+4>>2]=c[K+4>>2];c[Y+8>>2]=c[K+8>>2];Z=c[b+56>>2]|0;V=(c[b+60>>2]|0)-Z|0;do{if(V>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;I=163;break}return 0}else{if(V>>>0<11>>>0){a[A]=V<<1;aZ=A+1|0}else{S=V+16&-16;ap=(z=0,au(248,S|0)|0);if(z){z=0;I=163;break}c[A+8>>2]=ap;c[A>>2]=S|1;c[A+4>>2]=V;aZ=ap}LF(aZ|0,Z|0,V)|0;a[aZ+V|0]=0;ap=h;c[ap>>2]=c[Y>>2];c[ap+4>>2]=c[Y+4>>2];c[ap+8>>2]=c[Y+8>>2];z=0;aV(10,R|0,x|0,h|0,A|0);do{if(!z){ap=aT;c[g>>2]=ap;S=G+40|0;al=c[S>>2]|0;aw=al;if((aw|0)==(c[J+12>>2]|0)){z=0;as(740,G+36|0,g|0);if(z){z=0;a_=0;break}a$=c[g>>2]|0}else{if((al|0)==0){a0=0}else{c[aw>>2]=ap;a0=c[S>>2]|0}c[S>>2]=a0+4;a$=ap}z=0;as(c[c[J>>2]>>2]|0,N|0,a$|0);if(z){z=0;a_=0;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[x]&1)==0){break L174}Lw(c[x+8>>2]|0);break L174}else{z=0;a_=1}}while(0);ak=bT(-1,-1)|0;am=ak;ak=M;if((a[A]&1)==0){a1=a_;a2=ak;a3=am;break}Lw(c[A+8>>2]|0);a1=a_;a2=ak;a3=am}}while(0);if((I|0)==163){Y=bT(-1,-1)|0;a1=1;a2=M;a3=Y}if((a[x]&1)==0){if(a1){aX=a3;aY=a2;break}else{aJ=a2;aK=a3}aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}else{Lw(c[x+8>>2]|0);if(a1){aX=a3;aY=a2;break}else{aJ=a2;aK=a3}aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}}}while(0);N=c[U>>2]|0;J=c[ad>>2]|0;R=N;while(1){if((R|0)==(J|0)){a4=J;break}if((c[R>>2]|0)==(aT|0)){a4=R;break}else{R=R+4|0}}R=a4-N>>2;U=N+(R+1<<2)|0;Y=J-U|0;LG(N+(R<<2)|0,U|0,Y|0)|0;U=N+((Y>>2)+R<<2)|0;R=c[ad>>2]|0;if((U|0)!=(R|0)){c[ad>>2]=R+(~((R-4+(-U|0)|0)>>>2)<<2)}Lw(L);aJ=aY;aK=aX;aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0)}}while(0);if((yR(c[q>>2]|0)|0)!=0){i=d;return H|0}K=G+32|0;U=K;R=G+40|0;Y=K+12|0;V=G+36|0;Z=K;while(1){K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=43)){I=201;break}K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=126)){I=202;break}K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=62)){I=203;break}K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=44)){I=204;break}K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=41)){I=205;break}K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=123)){I=206;break}K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=125)){I=207;break}K=y$(c[q>>2]|0)|0;if(!((K+1|0)==0|(a[K]|0)!=59)){I=208;break}K=uQ(b)|0;c[e>>2]=K;am=c[R>>2]|0;ak=am;if((ak|0)==(c[Y>>2]|0)){e3(V,e);a5=c[e>>2]|0}else{if((am|0)==0){a6=0}else{c[ak>>2]=K;a6=c[R>>2]|0}c[R>>2]=a6+4;a5=K}cB[c[c[Z>>2]>>2]&1023](U,a5);if((yR(c[q>>2]|0)|0)!=0){I=209;break}}if((I|0)==201){i=d;return H|0}else if((I|0)==202){i=d;return H|0}else if((I|0)==203){i=d;return H|0}else if((I|0)==204){i=d;return H|0}else if((I|0)==205){i=d;return H|0}else if((I|0)==206){i=d;return H|0}else if((I|0)==207){i=d;return H|0}else if((I|0)==208){i=d;return H|0}else if((I|0)==209){i=d;return H|0}}}while(0);H=c[C>>2]|0;C=c[E>>2]|0;d=H;while(1){if((d|0)==(C|0)){a7=C;break}if((c[d>>2]|0)==(G|0)){a7=d;break}else{d=d+4|0}}d=a7-H>>2;a7=H+(d+1<<2)|0;G=C-a7|0;LG(H+(d<<2)|0,a7|0,G|0)|0;a7=H+((G>>2)+d<<2)|0;d=c[E>>2]|0;if((a7|0)!=(d|0)){c[E>>2]=d+(~((d-4+(-a7|0)|0)>>>2)<<2)}Lw(D);aJ=O;aK=P;aL=aK;aM=0;aN=aL;aO=aJ;bg(aN|0);return 0}function uO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=(zI(e)|0)!=0;g=f?0:e;if((g|0)==0){h=0;return h|0}f=zp(g)|0;do{if((f|0)==0){i=zq(g)|0;if((i|0)!=0){j=i;break}i=yY(g)|0;if((i|0)!=0){j=i;break}i=zB(g)|0;if((i|0)!=0){j=i;break}i=zA(g)|0;if((i|0)!=0){j=i;break}i=zw(g)|0;if((i|0)==0){h=0}else{j=i;break}return h|0}else{j=f}}while(0);f=b+48|0;g=c[f>>2]|0;i=c[d>>2]|0;L12:do{if(i>>>0<j>>>0){k=i;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L12}else{n=l}m=k+1|0;if(m>>>0<j>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<i>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;i=j;n=e;c[g>>2]=i-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=i;c[d>>2]=j;h=j;return h|0}function uP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=y$(c[d>>2]|0)|0;f=(zI(e)|0)!=0;g=f?0:e;if((g|0)==0){h=0;return h|0}f=zo(g)|0;do{if((f|0)==0){i=zq(g)|0;if((i|0)!=0){j=i;break}i=yY(g)|0;if((i|0)!=0){j=i;break}i=zB(g)|0;if((i|0)!=0){j=i;break}i=zA(g)|0;if((i|0)!=0){j=i;break}i=zw(g)|0;if((i|0)==0){h=0}else{j=i;break}return h|0}else{j=f}}while(0);f=b+48|0;g=c[f>>2]|0;i=c[d>>2]|0;L12:do{if(i>>>0<j>>>0){k=i;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L12}else{n=l}m=k+1|0;if(m>>>0<j>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<i>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;i=j;n=e;c[g>>2]=i-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=i;c[d>>2]=j;h=j;return h|0}
function gK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+16|0;f=e|0;g=b+24|0;gH(b,b+12|0,g,0)|0;h=b+36|0;if((h|0)==(d|0)){i=e;return}j=f;k=f+1|0;l=f+8|0;m=f|0;n=f+4|0;o=g;g=h;L4:while(1){h=g;p=a[h]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[g+4>>2]|0}q=a[o]|0;s=q&255;if((s&1|0)==0){t=s>>>1}else{t=c[o+4>>2]|0}s=(p&1)==0;if(s){u=g+1|0}else{u=c[g+8>>2]|0}if((q&1)==0){v=o+1|0}else{v=c[o+8>>2]|0}q=LH(u|0,v|0,(t>>>0<r>>>0?t:r)|0)|0;if((q|0)==0){if(r>>>0<t>>>0){w=18}}else{if((q|0)<0){w=18}}do{if((w|0)==18){w=0;if(s){c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];x=o;y=g}else{q=c[g+8>>2]|0;p=c[g+4>>2]|0;if(p>>>0>4294967279>>>0){w=21;break L4}if(p>>>0<11>>>0){a[j]=p<<1;A=k}else{B=p+16&-16;C=Lu(B)|0;c[l>>2]=C;c[m>>2]=B|1;c[n>>2]=p;A=C}LF(A|0,q|0,p)|0;a[A+p|0]=0;x=o;y=g}while(1){z=0,aM(344,y|0,x|0)|0;if(z){z=0;w=40;break L4}if((x|0)==(b|0)){D=b;break}p=x-12|0;q=a[j]|0;C=q&255;B=(C&1|0)==0?C>>>1:c[n>>2]|0;C=a[p]|0;E=C&255;if((E&1|0)==0){F=E>>>1}else{F=c[x-12+4>>2]|0}if((C&1)==0){G=p+1|0}else{G=c[x-12+8>>2]|0}C=LH(((q&1)==0?k:c[l>>2]|0)|0,G|0,(F>>>0<B>>>0?F:B)|0)|0;if((C|0)==0){if(B>>>0<F>>>0){y=x;x=p;continue}else{D=x;break}}else{if((C|0)<0){y=x;x=p;continue}else{D=x;break}}}z=0,aM(344,D|0,f|0)|0;if(z){z=0;w=41;break L4}if((a[j]&1)==0){break}Lw(c[l>>2]|0)}}while(0);h=g+12|0;if((h|0)==(d|0)){w=47;break}else{o=g;g=h}}if((w|0)==47){i=e;return}else if((w|0)==21){D5(0)}else if((w|0)==41){e=bT(-1,-1)|0;H=M;I=e}else if((w|0)==40){w=bT(-1,-1)|0;H=M;I=w}if((a[j]&1)==0){bg(I|0)}Lw(c[l>>2]|0);bg(I|0)}function gL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;e=i;i=i+32|0;f=e|0;g=e+16|0;switch((d-b|0)/12|0|0){case 4:{gI(b,b+12|0,b+24|0,d-12|0,0)|0;h=1;i=e;return h|0};case 3:{gH(b,b+12|0,d-12|0,0)|0;h=1;i=e;return h|0};case 2:{j=d-12|0;k=j;l=a[k]|0;m=l&255;if((m&1|0)==0){n=m>>>1}else{n=c[d-12+4>>2]|0}m=b;o=a[m]|0;p=o&255;if((p&1|0)==0){q=p>>>1}else{q=c[b+4>>2]|0}if((l&1)==0){r=j+1|0}else{r=c[d-12+8>>2]|0}if((o&1)==0){s=b+1|0}else{s=c[b+8>>2]|0}o=LH(r|0,s|0,(q>>>0<n>>>0?q:n)|0)|0;do{if((o|0)==0){if(n>>>0<q>>>0){break}else{h=1}i=e;return h|0}else{if((o|0)<0){break}else{h=1}i=e;return h|0}}while(0);o=f;c[o>>2]=c[m>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];h=1;i=e;return h|0};case 5:{gJ(b,b+12|0,b+24|0,b+36|0,d-12|0,0)|0;h=1;i=e;return h|0};case 0:case 1:{h=1;i=e;return h|0};default:{o=b+24|0;gH(b,b+12|0,o,0)|0;k=b+36|0;if((k|0)==(d|0)){h=1;i=e;return h|0}m=g;f=g+1|0;q=g+8|0;n=g|0;s=g+4|0;r=0;j=o;o=0;l=k;L10:while(1){k=l;p=a[k]|0;t=p&255;if((t&1|0)==0){u=t>>>1}else{u=c[l+4>>2]|0}t=a[j]|0;v=t&255;if((v&1|0)==0){w=v>>>1}else{w=c[j+4>>2]|0}v=(p&1)==0;if(v){x=l+1|0}else{x=c[l+8>>2]|0}if((t&1)==0){y=j+1|0}else{y=c[j+8>>2]|0}t=LH(x|0,y|0,(w>>>0<u>>>0?w:u)|0)|0;if((t|0)==0){if(u>>>0<w>>>0){A=38}else{B=l;C=o;D=r}}else{if((t|0)<0){A=38}else{B=l;C=o;D=r}}if((A|0)==38){A=0;if(v){c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];E=j;F=l}else{k=c[l+8>>2]|0;v=c[l+4>>2]|0;if(v>>>0>4294967279>>>0){A=41;break}if(v>>>0<11>>>0){a[m]=v<<1;G=f}else{t=v+16&-16;p=Lu(t)|0;c[q>>2]=p;c[n>>2]=t|1;c[s>>2]=v;G=p}LF(G|0,k|0,v)|0;a[G+v|0]=0;E=j;F=l}while(1){z=0,aM(344,F|0,E|0)|0;if(z){z=0;A=60;break L10}if((E|0)==(b|0)){H=b;break}v=E-12|0;k=a[m]|0;p=k&255;t=(p&1|0)==0?p>>>1:c[s>>2]|0;p=a[v]|0;I=p&255;if((I&1|0)==0){J=I>>>1}else{J=c[E-12+4>>2]|0}if((p&1)==0){K=v+1|0}else{K=c[E-12+8>>2]|0}p=LH(((k&1)==0?f:c[q>>2]|0)|0,K|0,(J>>>0<t>>>0?J:t)|0)|0;if((p|0)==0){if(t>>>0<J>>>0){F=E;E=v;continue}else{H=E;break}}else{if((p|0)<0){F=E;E=v;continue}else{H=E;break}}}z=0,aM(344,H|0,g|0)|0;if(z){z=0;A=61;break}v=o+1|0;if((v|0)==8){p=l+12|0;L=1;N=p;O=(p|0)==(d|0)}else{L=0;N=l;O=r}if((a[m]&1)!=0){Lw(c[q>>2]|0)}if(L){h=O;A=76;break}else{B=N;C=v;D=O}}v=B+12|0;if((v|0)==(d|0)){h=1;A=72;break}else{r=D;j=B;o=C;l=v}}if((A|0)==61){l=bT(-1,-1)|0;P=M;Q=l}else if((A|0)==60){l=bT(-1,-1)|0;P=M;Q=l}else if((A|0)==41){D5(0);return 0}else if((A|0)==72){i=e;return h|0}else if((A|0)==76){i=e;return h|0}if((a[m]&1)==0){bg(Q|0)}Lw(c[q>>2]|0);bg(Q|0)}}return 0}function gM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=b|0;c[e>>2]=0;f=b+4|0;c[f>>2]=0;g=b+8|0;c[g>>2]=0;b=d+4|0;h=c[b>>2]|0;i=d|0;d=c[i>>2]|0;if((h|0)==(d|0)){return}j=h-d|0;d=(j|0)/12|0;do{if(d>>>0>357913941>>>0){z=0;ar(152,0);if(z){z=0;k=20;break}}else{h=(z=0,au(248,j|0)|0);if(z){z=0;k=20;break}l=h;c[f>>2]=l;c[e>>2]=l;c[g>>2]=l+(d*12|0);h=c[i>>2]|0;m=c[b>>2]|0;if((h|0)==(m|0)){return}else{n=h;o=l}L9:while(1){do{if((o|0)!=0){l=n;if((a[l]&1)==0){h=o;c[h>>2]=c[l>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];break}l=c[n+8>>2]|0;h=c[n+4>>2]|0;if(h>>>0>4294967279>>>0){k=11;break L9}if(h>>>0<11>>>0){a[o]=h<<1;p=o+1|0}else{q=h+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;k=19;break L9}c[o+8>>2]=r;c[o>>2]=q|1;c[o+4>>2]=h;p=r}LF(p|0,l|0,h)|0;a[p+h|0]=0}}while(0);h=(c[f>>2]|0)+12|0;c[f>>2]=h;l=n+12|0;if((l|0)==(m|0)){k=31;break}else{n=l;o=h}}if((k|0)==11){z=0;ar(86,0);if(z){z=0;k=20;break}}else if((k|0)==31){return}else if((k|0)==19){m=bT(-1,-1)|0;s=M;t=m;break}}}while(0);if((k|0)==20){k=bT(-1,-1)|0;s=M;t=k}k=c[e>>2]|0;if((k|0)==0){bg(t|0)}s=c[f>>2]|0;if((k|0)==(s|0)){u=k}else{o=s;while(1){s=o-12|0;c[f>>2]=s;if((a[s]&1)==0){v=s}else{Lw(c[o-12+8>>2]|0);v=c[f>>2]|0}if((k|0)==(v|0)){break}else{o=v}}u=c[e>>2]|0}Lw(u);bg(t|0)}function gN(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;l=i;i=i+64|0;m=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];m=l|0;n=l+16|0;o=l+32|0;p=l+48|0;q=d;if((a[q]&1)==0){r=p;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];s=a[r]|0;t=r}else{r=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){D5(0)}if(q>>>0<11>>>0){d=q<<1&255;u=p;a[u]=d;v=p+1|0;w=d;x=u}else{u=q+16&-16;d=Lu(u)|0;c[p+8>>2]=d;y=u|1;c[p>>2]=y;c[p+4>>2]=q;v=d;w=y&255;x=p}LF(v|0,r|0,q)|0;a[v+q|0]=0;s=w;t=x}x=e;e=o;c[e>>2]=c[x>>2];c[e+4>>2]=c[x+4>>2];c[e+8>>2]=c[x+8>>2];x=o;o=m;e=n;w=b|0;L12:do{if((s&1)==0){c[o>>2]=c[t>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];A=19}else{q=c[p+8>>2]|0;v=c[p+4>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(v>>>0<11>>>0){a[o]=v<<1;B=m+1|0}else{r=v+16&-16;y=(z=0,au(248,r|0)|0);if(z){z=0;break}c[m+8>>2]=y;c[m>>2]=r|1;c[m+4>>2]=v;B=y}LF(B|0,q|0,v)|0;a[B+v|0]=0;A=19;break L12}}while(0);v=bT(-1,-1)|0;C=M;D=v}}while(0);do{if((A|0)==19){c[e>>2]=c[x>>2];c[e+4>>2]=c[x+4>>2];c[e+8>>2]=c[x+8>>2];z=0;aR(424,w|0,m|0,n|0);if(z){z=0;B=bT(-1,-1)|0;s=M;if((a[o]&1)==0){C=s;D=B;break}Lw(c[m+8>>2]|0);C=s;D=B;break}if((a[o]&1)!=0){Lw(c[m+8>>2]|0)}B=b|0;c[B>>2]=17080;c[b+28>>2]=0;if((a[t]&1)!=0){Lw(c[p+8>>2]|0)}c[B>>2]=22920;s=b+32|0;v=g;if((a[v]&1)==0){q=s;c[q>>2]=c[v>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];E=b+44|0;c[E>>2]=h;F=b+48|0;c[F>>2]=0;G=b+52|0;c[G>>2]=1;H=b+56|0;c[H>>2]=j;I=b+60|0;c[I>>2]=0;J=b+64|0;c[J>>2]=0;K=b+68|0;L=k&1;a[K]=L;N=b+72|0;c[N>>2]=f;i=l;return}v=c[g+8>>2]|0;q=c[g+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(q>>>0<11>>>0){a[s]=q<<1;O=s+1|0}else{y=q+16&-16;r=(z=0,au(248,y|0)|0);if(z){z=0;break}c[b+40>>2]=r;c[s>>2]=y|1;c[b+36>>2]=q;O=r}LF(O|0,v|0,q)|0;a[O+q|0]=0;E=b+44|0;c[E>>2]=h;F=b+48|0;c[F>>2]=0;G=b+52|0;c[G>>2]=1;H=b+56|0;c[H>>2]=j;I=b+60|0;c[I>>2]=0;J=b+64|0;c[J>>2]=0;K=b+68|0;L=k&1;a[K]=L;N=b+72|0;c[N>>2]=f;i=l;return}}while(0);q=bT(-1,-1)|0;v=q;q=M;c[B>>2]=17512;if((a[b+4|0]&1)==0){P=q;Q=v;R=Q;S=0;T=R;U=P;bg(T|0)}Lw(c[b+12>>2]|0);P=q;Q=v;R=Q;S=0;T=R;U=P;bg(T|0)}}while(0);b=D;D=C;if((a[t]&1)==0){P=D;Q=b;R=Q;S=0;T=R;U=P;bg(T|0)}Lw(c[p+8>>2]|0);P=D;Q=b;R=Q;S=0;T=R;U=P;bg(T|0)}function gO(b){b=b|0;var d=0;d=b|0;c[d>>2]=22920;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function gP(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=22920;if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function gQ(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+84>>2]&1023](b,a);return}function gR(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function gS(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function gT(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function gU(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function gV(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+84>>2]&511](a,d,b);return}function gW(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+84>>2]&511](a,d,b);return}function gX(a){a=a|0;return 0}function gY(a){a=a|0;return 0}function gZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=d;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+8>>2]|0;j=c[d+4>>2]|0;if(j>>>0>4294967279>>>0){D5(0)}if(j>>>0<11>>>0){d=j<<1&255;n=h;a[n]=d;o=h+1|0;p=d;q=n}else{n=j+16&-16;d=Lu(n)|0;c[h+8>>2]=d;r=n|1;c[h>>2]=r;c[h+4>>2]=j;o=d;p=r&255;q=h}LF(o|0,k|0,j)|0;a[o+j|0]=0;l=p;m=q}q=e;e=g;c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];q=g;g=b|0;c[g>>2]=17512;e=b+4|0;L12:do{if((l&1)==0){p=e;c[p>>2]=c[m>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2]}else{p=c[h+8>>2]|0;j=c[h+4>>2]|0;do{if(j>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(j>>>0<11>>>0){a[e]=j<<1;s=e+1|0}else{o=j+16&-16;k=(z=0,au(248,o|0)|0);if(z){z=0;break}c[b+12>>2]=k;c[e>>2]=o|1;c[b+8>>2]=j;s=k}LF(s|0,p|0,j)|0;a[s+j|0]=0;break L12}}while(0);j=bT(-1,-1)|0;if((a[m]&1)==0){bg(j|0)}Lw(p);bg(j|0)}}while(0);s=b+16|0;c[s>>2]=c[q>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];if((a[m]&1)==0){c[g>>2]=16960;i=f;return}Lw(c[h+8>>2]|0);c[g>>2]=16960;i=f;return}function g_(b,d){b=b|0;d=d|0;if((d|0)==0){return}g_(b,c[d>>2]|0);g_(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){Lw(c[d+24>>2]|0)}Lw(d);return}function g$(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=18832;b=c[a+44>>2]|0;d=b;if((b|0)!=0){e=a+48|0;f=c[e>>2]|0;if((b|0)!=(f|0)){c[e>>2]=f+(~((f-4+(-d|0)|0)>>>2)<<2)}Lw(b)}b=c[a+32>>2]|0;d=b;if((b|0)!=0){f=a+36|0;e=c[f>>2]|0;if((b|0)!=(e|0)){c[f>>2]=e+(~((e-4+(-d|0)|0)>>>2)<<2)}Lw(b)}b=c[a+20>>2]|0;if((b|0)==0){return}d=a+24|0;a=c[d>>2]|0;if((b|0)!=(a|0)){c[d>>2]=a+(~((a-4+(-b|0)|0)>>>2)<<2)}Lw(b);return}function g0(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=b;LI(g|0,0,12)|0;h=a[e]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[e+4>>2]|0}i=f;k=f;l=d[k]|0;if((l&1|0)==0){m=l>>>1}else{m=c[f+4>>2]|0}if((h&1)==0){n=e+1|0}else{n=c[e+8>>2]|0}e=m+j|0;do{if(e>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(e>>>0<11>>>0){a[g]=j<<1;o=b+1|0}else{h=e+16&-16;l=(z=0,au(248,h|0)|0);if(z){z=0;break}c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;o=l}LF(o|0,n|0,j)|0;a[o+j|0]=0;if((a[k]&1)==0){p=i+1|0}else{p=c[f+8>>2]|0}z=0,az(88,b|0,p|0,m|0)|0;if(z){z=0;break}return}}while(0);m=bT(-1,-1)|0;if((a[g]&1)==0){bg(m|0)}Lw(c[b+8>>2]|0);bg(m|0)}function g1(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[b>>2]=d;d=b+4|0;j=e;if((a[j]&1)==0){k=d;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){D5(0)}if(k>>>0<11>>>0){a[d]=k<<1;l=d+1|0}else{e=k+16&-16;m=Lu(e)|0;c[b+12>>2]=m;c[d>>2]=e|1;c[b+8>>2]=k;l=m}LF(l|0,j|0,k)|0;a[l+k|0]=0}k=b+16|0;l=f;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=b+28|0;k=g;if((a[k]&1)==0){f=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];i=h;return}k=c[g+8>>2]|0;f=c[g+4>>2]|0;do{if(f>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(f>>>0<11>>>0){a[l]=f<<1;n=l+1|0}else{g=f+16&-16;j=(z=0,au(248,g|0)|0);if(z){z=0;break}c[b+36>>2]=j;c[l>>2]=g|1;c[b+32>>2]=f;n=j}LF(n|0,k|0,f)|0;a[n+f|0]=0;i=h;return}}while(0);h=bT(-1,-1)|0;if((a[d]&1)==0){bg(h|0)}Lw(c[b+12>>2]|0);bg(h|0)}function g2(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=+f;g=+g;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;m=i;i=i+32|0;n=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];n=m|0;o=m+16|0;p=b|0;q=d;if((a[q]&1)==0){r=n;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{q=c[d+8>>2]|0;r=c[d+4>>2]|0;if(r>>>0>4294967279>>>0){D5(0)}if(r>>>0<11>>>0){a[n]=r<<1;s=n+1|0}else{d=r+16&-16;t=Lu(d)|0;c[n+8>>2]=t;c[n>>2]=d|1;c[n+4>>2]=r;s=t}LF(s|0,q|0,r)|0;a[s+r|0]=0}r=o;s=e;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];z=0;aD(6,p|0,n|0,o|0,0,0,0);if(z){z=0;o=bT(-1,-1)|0;p=o;o=M;if((a[n]&1)==0){u=o;v=p;w=v;x=0;y=w;A=u;bg(y|0)}Lw(c[n+8>>2]|0);u=o;v=p;w=v;x=0;y=w;A=u;bg(y|0)}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}n=b|0;c[n>>2]=19128;h[b+40>>3]=f;h[b+48>>3]=g;h[b+56>>3]=j;h[b+64>>3]=k;p=b+72|0;o=l;if((a[o]&1)==0){s=p;c[s>>2]=c[o>>2];c[s+4>>2]=c[o+4>>2];c[s+8>>2]=c[o+8>>2];B=b+32|0;c[B>>2]=3;i=m;return}o=c[l+8>>2]|0;s=c[l+4>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(s>>>0<11>>>0){a[p]=s<<1;C=p+1|0}else{l=s+16&-16;r=(z=0,au(248,l|0)|0);if(z){z=0;break}c[b+80>>2]=r;c[p>>2]=l|1;c[b+76>>2]=s;C=r}LF(C|0,o|0,s)|0;a[C+s|0]=0;B=b+32|0;c[B>>2]=3;i=m;return}}while(0);m=bT(-1,-1)|0;B=m;m=M;c[n>>2]=17512;if((a[b+4|0]&1)==0){u=m;v=B;w=v;x=0;y=w;A=u;bg(y|0)}Lw(c[b+12>>2]|0);u=m;v=B;w=v;x=0;y=w;A=u;bg(y|0)}function g3(b){b=b|0;var d=0;d=b|0;c[d>>2]=19128;if((a[b+72|0]&1)!=0){Lw(c[b+80>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function g4(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19128;if((a[b+72|0]&1)!=0){Lw(c[b+80>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function g5(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+124>>2]&1023](b,a);return}function g6(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function g7(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function g8(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function g9(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function ha(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+124>>2]&511](a,d,b);return}function hb(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+124>>2]&511](a,d,b);return}function hc(b,c){b=b|0;c=c|0;c=b;a[b]=10;b=c+1|0;a[b]=a[10400]|0;a[b+1|0]=a[10401]|0;a[b+2|0]=a[10402]|0;a[b+3|0]=a[10403]|0;a[b+4|0]=a[10404]|0;a[c+6|0]=0;return}function hd(b,d){b=b|0;d=d|0;if((d|0)==0){return}hd(b,c[d>>2]|0);hd(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){Lw(c[d+24>>2]|0)}Lw(d);return}function he(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;if((a[b+36|0]&1)!=0){Lw(c[b+44>>2]|0)}d=c[b+12>>2]|0;e=d;if((d|0)!=0){f=b+16|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~(((g-24+(-e|0)|0)>>>0)/24|0)*24|0)}Lw(d)}d=b|0;e=c[d>>2]|0;if((e|0)==0){return}g=b+4|0;b=c[g>>2]|0;if((e|0)==(b|0)){h=e}else{f=b;while(1){b=f-12|0;c[g>>2]=b;if((a[b]&1)==0){i=b}else{Lw(c[f-12+8>>2]|0);i=c[g>>2]|0}if((e|0)==(i|0)){break}else{f=i}}h=c[d>>2]|0}Lw(h);return}function hf(b,d){b=b|0;d=d|0;if((d|0)==0){return}hf(b,c[d>>2]|0);hf(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){Lw(c[d+24>>2]|0)}Lw(d);return}function hg(b,d){b=b|0;d=d|0;if((d|0)==0){return}hg(b,c[d>>2]|0);hg(b,c[d+4>>2]|0);if((a[d+20|0]&1)!=0){Lw(c[d+28>>2]|0)}Lw(d);return}function hh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((d|0)==0){return}hh(b,c[d>>2]|0);hh(b,c[d+4>>2]|0);b=d+16|0;c[b>>2]=20768;e=d+48|0;c[e>>2]=20824;e9(d+64|0,c[d+68>>2]|0);c[e>>2]=22640;e=c[d+52>>2]|0;f=e;if((e|0)!=0){g=d+56|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}Lw(e)}c[b>>2]=17512;if((a[d+20|0]&1)!=0){Lw(c[d+28>>2]|0)}Lw(d);return}function hi(a,b){a=a|0;b=b|0;if((b|0)==0){return}hi(a,c[b>>2]|0);hi(a,c[b+4>>2]|0);z=0;ar(350,b+16|0);if(z){z=0;a=bT(-1,-1)|0;bH(a|0)}Lw(b);return}function hj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+12|0;e=c[d>>2]|0;if((e|0)!=0){f=b+16|0;g=c[f>>2]|0;if((e|0)==(g|0)){h=e}else{i=g;do{g=i-28|0;c[f>>2]=g;fc(i-28+12|0,c[i-28+16>>2]|0);j=g|0;g=c[j>>2]|0;if((g|0)!=0){k=i-28+4|0;l=c[k>>2]|0;if((g|0)==(l|0)){m=g}else{n=l;while(1){l=n-12|0;c[k>>2]=l;if((a[l]&1)==0){o=l}else{Lw(c[n-12+8>>2]|0);o=c[k>>2]|0}if((g|0)==(o|0)){break}else{n=o}}m=c[j>>2]|0}Lw(m)}i=c[f>>2]|0;}while((e|0)!=(i|0));h=c[d>>2]|0}Lw(h)}if((a[b]&1)==0){return}Lw(c[b+8>>2]|0);return}function hk(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;c[a>>2]=21968;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;c[a+16>>2]=0;c[a+20>>2]=f;c[a+24>>2]=g;c[a+28>>2]=h;return}function hl(a){a=a|0;Lw(a);return}function hm(a){a=a|0;return}function hn(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[a+16>>2]=b;c[a+12>>2]=d;c[a+20>>2]=e;c[a+24>>2]=f;c[a+28>>2]=g;return a|0}function ho(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0;e=i;i=i+120|0;f=e|0;g=e+8|0;h=e+24|0;j=e+88|0;k=e+104|0;Bv(f,0);l=c[d+32>>2]|0;m=c[(c[l>>2]|0)+20>>2]|0;n=(z=0,az(46,c[b+8>>2]|0,c[b+12>>2]|0,c[b+20>>2]|0)|0);do{if(!z){o=(z=0,aM(m|0,l|0,n|0)|0);if(z){z=0;p=50;break}z=0;aR(c[(c[o>>2]|0)+28>>2]|0,g|0,o|0,f|0);if(z){z=0;p=50;break}o=g;q=g;r=a[q]|0;if((r&1)==0){s=(r&255)>>>1;t=10;u=r}else{v=c[g>>2]|0;s=c[g+4>>2]|0;t=(v&-2)-1|0;u=v&255}do{if((s|0)==(t|0)){if((t|0)==-17){z=0;ar(86,0);if(z){z=0;p=51;break}return 0}if((u&1)==0){w=o+1|0}else{w=c[g+8>>2]|0}do{if(t>>>0<2147483623>>>0){v=t+1|0;x=t<<1;y=v>>>0<x>>>0?x:v;if(y>>>0<11>>>0){A=11;break}A=y+16&-16}else{A=-17}}while(0);y=(z=0,au(248,A|0)|0);if(z){z=0;p=51;break}LF(y|0,w|0,t)|0;if((t|0)!=10){Lw(w)}c[g+8>>2]=y;y=A|1;c[g>>2]=y;B=y&255;p=21}else{B=r;p=21}}while(0);L27:do{if((p|0)==21){if((B&1)==0){a[q]=(s<<1)+2;C=o+1|0;D=s+1|0}else{r=c[g+8>>2]|0;y=s+1|0;c[g+4>>2]=y;C=r;D=y}a[C+s|0]=123;a[C+D|0]=0;if((a[q]&1)==0){E=o+1|0}else{E=c[g+8>>2]|0}y=c[b+4>>2]|0;r=d+4|0;if((a[r]&1)==0){v=j;c[v>>2]=c[r>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2]}else{r=c[d+12>>2]|0;v=c[d+8>>2]|0;if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;p=51;break}return 0}if(v>>>0<11>>>0){a[j]=v<<1;F=j+1|0}else{x=v+16&-16;G=(z=0,au(248,x|0)|0);if(z){z=0;p=51;break}c[j+8>>2]=G;c[j>>2]=x|1;c[j+4>>2]=v;F=G}LF(F|0,r|0,v)|0;a[F+v|0]=0}v=k;r=d+16|0;c[v>>2]=c[r>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2];z=0;aq(2,h|0,E|0,y|0,j|0,k|0);do{if(!z){y=(z=0,au(50,h|0)|0);if(z){z=0;r=bT(-1,-1)|0;v=r;r=M;if((a[h+28|0]&1)!=0){Lw(c[h+36>>2]|0)}G=c[h+4>>2]|0;if((G|0)==0){H=v;I=r;break}x=h+8|0;J=c[x>>2]|0;if((G|0)!=(J|0)){c[x>>2]=J+(~((J-4+(-G|0)|0)>>>2)<<2)}Lw(G);H=v;I=r;break}if((a[h+28|0]&1)!=0){Lw(c[h+36>>2]|0)}r=c[h+4>>2]|0;v=r;if((r|0)!=0){G=h+8|0;J=c[G>>2]|0;if((r|0)!=(J|0)){c[G>>2]=J+(~((J-4+(-v|0)|0)>>>2)<<2)}Lw(r)}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}r=(z=0,aM(c[(c[y>>2]|0)+24>>2]|0,y|0,b|0)|0);if(z){z=0;p=51;break L27}if((a[q]&1)==0){Bx(f);i=e;return r|0}Lw(c[g+8>>2]|0);Bx(f);i=e;return r|0}else{z=0;r=bT(-1,-1)|0;H=r;I=M}}while(0);if((a[j]&1)==0){K=H;L=I;break}Lw(c[j+8>>2]|0);K=H;L=I}}while(0);if((p|0)==51){o=bT(-1,-1)|0;K=o;L=M}if((a[q]&1)==0){N=K;O=L;break}Lw(c[g+8>>2]|0);N=K;O=L}else{z=0;p=50}}while(0);if((p|0)==50){p=bT(-1,-1)|0;N=p;O=M}z=0;ar(444,f|0);if(!z){bg(N|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function hp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,aj=0;e=i;i=i+88|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=e+72|0;n=b+16|0;o=c[n>>2]|0;p=(o|0)==0;q=c[b+4>>2]|0;r=Lu(48)|0;c[k>>2]=r;s=q+4|0;t=c[s>>2]|0;if((t|0)==(c[q+8>>2]|0)){e4(q|0,k);u=c[k>>2]|0}else{if((t|0)==0){v=0}else{c[t>>2]=r;v=c[s>>2]|0}c[s>>2]=v+4;u=r}r=u;v=u;t=d+4|0;k=(a[t]&1)==0;if(p){L10:do{if(k){p=m;c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];w=51}else{p=c[d+12>>2]|0;x=c[d+8>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[m]=x<<1;y=m+1|0}else{A=x+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[m+8>>2]=B;c[m>>2]=A|1;c[m+4>>2]=x;y=B}LF(y|0,p|0,x)|0;a[y+x|0]=0;w=51;break L10}}while(0);x=bT(-1,-1)|0;C=x;D=M}}while(0);do{if((w|0)==51){y=d+16|0;x=f;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=d+40|0;x=d+36|0;z=0;aV(58,v|0,m|0,f|0,(c[y>>2]|0)-(c[x>>2]|0)>>2|0);if(z){z=0;p=bT(-1,-1)|0;B=p;p=M;if((a[m]&1)==0){C=B;D=p;break}Lw(c[m+8>>2]|0);C=B;D=p;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}p=c[x>>2]|0;B=(c[y>>2]|0)-p>>2;if((B|0)==0){E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;K=(F|0)!=(J|0);L=K?v:0;N=L|0;i=e;return N|0}y=b|0;A=u+32|0;O=A;P=u+40|0;Q=A+12|0;R=u+36|0;S=A;A=0;T=p;while(1){p=c[T+(A<<2)>>2]|0;U=cV[c[(c[p>>2]|0)+24>>2]&1023](p,y)|0;if((U|0)!=0){p=U;c[h>>2]=p;U=c[P>>2]|0;V=U;if((V|0)==(c[Q>>2]|0)){ib(R,h);W=c[h>>2]|0}else{if((U|0)==0){X=0}else{c[V>>2]=p;X=c[P>>2]|0}c[P>>2]=X+4;W=p}cB[c[c[S>>2]>>2]&1023](O,W)}p=A+1|0;if(p>>>0>=B>>>0){break}A=p;T=c[x>>2]|0}E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;K=(F|0)!=(J|0);L=K?v:0;N=L|0;i=e;return N|0}}while(0);W=c[q>>2]|0;X=c[s>>2]|0;h=W;while(1){if((h|0)==(X|0)){Y=X;break}if((c[h>>2]|0)==(u|0)){Y=h;break}else{h=h+4|0}}h=Y-W>>2;Y=W+(h+1<<2)|0;m=X-Y|0;LG(W+(h<<2)|0,Y|0,m|0)|0;Y=W+((m>>2)+h<<2)|0;h=c[s>>2]|0;if((Y|0)!=(h|0)){c[s>>2]=h+(~((h-4+(-Y|0)|0)>>>2)<<2)}Lw(r);Z=C;_=D;$=Z;aa=0;ab=$;ac=_;bg(ab|0)}L59:do{if(k){D=l;c[D>>2]=c[t>>2];c[D+4>>2]=c[t+4>>2];c[D+8>>2]=c[t+8>>2];w=17}else{D=c[d+12>>2]|0;C=c[d+8>>2]|0;do{if(C>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(C>>>0<11>>>0){a[l]=C<<1;ad=l+1|0}else{Y=C+16&-16;h=(z=0,au(248,Y|0)|0);if(z){z=0;break}c[l+8>>2]=h;c[l>>2]=Y|1;c[l+4>>2]=C;ad=h}LF(ad|0,D|0,C)|0;a[ad+C|0]=0;w=17;break L59}}while(0);C=bT(-1,-1)|0;ae=C;af=M}}while(0);do{if((w|0)==17){ad=d+16|0;t=j;c[t>>2]=c[ad>>2];c[t+4>>2]=c[ad+4>>2];c[t+8>>2]=c[ad+8>>2];ad=o+40|0;t=o+36|0;k=d+40|0;C=d+36|0;D=ai((c[k>>2]|0)-(c[C>>2]|0)>>2,(c[ad>>2]|0)-(c[t>>2]|0)>>2)|0;z=0;aV(58,v|0,l|0,j|0,D|0);if(z){z=0;D=bT(-1,-1)|0;h=D;D=M;if((a[l]&1)==0){ae=h;af=D;break}Lw(c[l+8>>2]|0);ae=h;af=D;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}D=(c[ad>>2]|0)-(c[t>>2]|0)>>2;if((D|0)==0){E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;K=(F|0)!=(J|0);L=K?v:0;N=L|0;i=e;return N|0}ad=b|0;h=u+32|0;Y=h;m=u+40|0;W=h+12|0;X=u+36|0;f=h;h=0;do{x=(c[k>>2]|0)-(c[C>>2]|0)>>2;if((x|0)!=0){T=0;do{c[n>>2]=c[(c[t>>2]|0)+(h<<2)>>2];A=c[(c[C>>2]|0)+(T<<2)>>2]|0;B=cV[c[(c[A>>2]|0)+24>>2]&1023](A,ad)|0;if((B|0)!=0){A=B;c[g>>2]=A;B=c[m>>2]|0;O=B;if((O|0)==(c[W>>2]|0)){ib(X,g);ag=c[g>>2]|0}else{if((B|0)==0){ah=0}else{c[O>>2]=A;ah=c[m>>2]|0}c[m>>2]=ah+4;ag=A}cB[c[c[f>>2]>>2]&1023](Y,ag)}T=T+1|0;}while(T>>>0<x>>>0)}h=h+1|0;}while(h>>>0<D>>>0);E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;K=(F|0)!=(J|0);L=K?v:0;N=L|0;i=e;return N|0}}while(0);N=c[q>>2]|0;q=c[s>>2]|0;e=N;while(1){if((e|0)==(q|0)){aj=q;break}if((c[e>>2]|0)==(u|0)){aj=e;break}else{e=e+4|0}}e=aj-N>>2;aj=N+(e+1<<2)|0;u=q-aj|0;LG(N+(e<<2)|0,aj|0,u|0)|0;aj=N+((u>>2)+e<<2)|0;e=c[s>>2]|0;if((aj|0)!=(e|0)){c[s>>2]=e+(~((e-4+(-aj|0)|0)>>>2)<<2)}Lw(r);Z=ae;_=af;$=Z;aa=0;ab=$;ac=_;bg(ab|0);return 0}function hq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0;e=i;i=i+16|0;f=e|0;g=e+8|0;Bv(g,0);h=c[b+4>>2]|0;j=(z=0,au(248,44)|0);L1:do{if(!z){k=j;c[f>>2]=k;l=h+4|0;m=c[l>>2]|0;if((m|0)==(c[h+8>>2]|0)){z=0;as(382,h|0,f|0);if(z){z=0;n=21;break}o=c[f>>2]|0}else{if((m|0)==0){p=0}else{c[m>>2]=k;p=c[l>>2]|0}c[l>>2]=p+4;o=k}k=o;m=o;q=o|0;c[q>>2]=17512;r=o+4|0;s=d+4|0;L11:do{if((a[s]&1)==0){t=r;c[t>>2]=c[s>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2]}else{t=c[d+12>>2]|0;u=c[d+8>>2]|0;do{if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(u>>>0<11>>>0){a[r]=u<<1;v=r+1|0}else{w=u+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[o+12>>2]=x;c[r>>2]=w|1;c[o+8>>2]=u;v=x}LF(v|0,t|0,u)|0;a[v+u|0]=0;break L11}}while(0);u=bT(-1,-1)|0;t=u;u=M;x=c[h>>2]|0;w=c[l>>2]|0;y=x;while(1){if((y|0)==(w|0)){A=w;break}if((c[y>>2]|0)==(o|0)){A=y;break}else{y=y+4|0}}y=A-x>>2;B=x+(y+1<<2)|0;C=w-B|0;LG(x+(y<<2)|0,B|0,C|0)|0;B=x+((C>>2)+y<<2)|0;y=c[l>>2]|0;if((B|0)!=(y|0)){c[l>>2]=y+(~((y-4+(-B|0)|0)>>>2)<<2)}Lw(k);D=u;E=t;break L1}}while(0);k=o+16|0;l=d+16|0;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[q>>2]=17376;a[o+28|0]=a[d+28|0]&1;a[m+29|0]=a[d+29|0]&1;c[q>>2]=21072;l=o+32|0;c[l>>2]=c[d+32>>2];k=o+36|0;r=k;s=d+36|0;B=c[s>>2]|0;c[k>>2]=B;y=o+40|0;C=d+40|0;F=c[C>>2]|0;G=F;c[y>>2]=G;if((B|0)==0){H=0;I=F;J=G}else{G=c[s>>2]|0;s=(z=0,aM(c[(c[G>>2]|0)+24>>2]|0,G|0,b|0)|0);if(z){z=0;n=21;break}c[k>>2]=s;k=c[y>>2]|0;H=s;I=k;J=k}if((I|0)==0){K=0;L=J}else{k=c[C>>2]|0;C=(z=0,aM(c[(c[k>>2]|0)+24>>2]|0,k|0,b|0)|0);if(z){z=0;n=21;break}k=C;c[y>>2]=k;K=C;L=k}if((H|0)==0){n=33}else{if((a[H+29|0]&1)==0){n=33}else{n=35}}do{if((n|0)==33){if((K|0)!=0){if((a[K+29|0]&1)!=0){n=35;break}}a[o+29|0]=0}}while(0);if((n|0)==35){a[o+29|0]=1}do{if((c[r>>2]|0)==0){if((c[l>>2]|0)!=0){break}N=L;Bx(g);i=e;return N|0}}while(0);N=o;Bx(g);i=e;return N|0}else{z=0;n=21}}while(0);if((n|0)==21){n=bT(-1,-1)|0;D=M;E=n}z=0;ar(444,g|0);if(!z){bg(E|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function hr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=i;i=i+88|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+40|0;l=e+56|0;m=e+72|0;Bv(j,0);n=b+24|0;do{if((c[n>>2]|0)==0){o=35}else{p=b+28|0;if((c[p>>2]|0)==0){o=35;break}q=j|0;z=0;aR(c[(c[d>>2]|0)+28>>2]|0,k|0,d|0,q|0);if(z){z=0;o=31;break}r=c[n>>2]|0;z=0;aR(c[(c[r>>2]|0)+28>>2]|0,l|0,r|0,q|0);if(z){z=0;q=bT(-1,-1)|0;r=q;q=M;if((a[k]&1)==0){s=q;t=r;break}Lw(c[k+8>>2]|0);s=q;t=r;break}r=k;q=k;u=a[q]|0;v=u&255;if((v&1|0)==0){w=v>>>1}else{w=c[k+4>>2]|0}v=l;x=a[l]|0;y=x&255;if((y&1|0)==0){A=y>>>1}else{A=c[l+4>>2]|0}L17:do{if((w|0)==(A|0)){y=(u&1)==0;if(y){B=r+1|0}else{B=c[k+8>>2]|0}C=x&1;if(C<<24>>24==0){D=v+1|0}else{D=c[l+8>>2]|0}if(!y){E=(LH(B|0,D|0,w|0)|0)==0;F=C;break}if((w|0)==0){E=1;F=C;break}else{G=D;H=B;I=w}while(1){if((a[H]|0)!=(a[G]|0)){E=0;F=C;break L17}y=I-1|0;if((y|0)==0){E=1;F=C;break}else{G=G+1|0;H=H+1|0;I=y}}}else{E=0;F=x&1}}while(0);if(F<<24>>24==0){J=u}else{Lw(c[l+8>>2]|0);J=a[q]|0}if((J&1)==0){if(!E){o=35;break}}else{Lw(c[k+8>>2]|0);if(!E){o=35;break}}K=c[p>>2]|0;Bx(j);i=e;return K|0}}while(0);L43:do{if((o|0)==35){E=c[b+4>>2]|0;k=(z=0,au(248,60)|0);if(z){z=0;o=31;break}J=k;c[h>>2]=J;k=E+4|0;l=c[k>>2]|0;if((l|0)==(c[E+8>>2]|0)){z=0;as(382,E|0,h|0);if(z){z=0;o=31;break}L=c[h>>2]|0}else{if((l|0)==0){N=0}else{c[l>>2]=J;N=c[k>>2]|0}c[k>>2]=N+4;L=J}J=L;l=L;F=d+4|0;L54:do{if((a[F]&1)==0){I=m;c[I>>2]=c[F>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];o=52}else{I=c[d+12>>2]|0;H=c[d+8>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[m]=H<<1;O=m+1|0}else{G=H+16&-16;w=(z=0,au(248,G|0)|0);if(z){z=0;break}c[m+8>>2]=w;c[m>>2]=G|1;c[m+4>>2]=H;O=w}LF(O|0,I|0,H)|0;a[O+H|0]=0;o=52;break L54}}while(0);H=bT(-1,-1)|0;P=M;Q=H}}while(0);do{if((o|0)==52){F=d+16|0;p=g;c[p>>2]=c[F>>2];c[p+4>>2]=c[F+4>>2];c[p+8>>2]=c[F+8>>2];F=d+40|0;p=d+36|0;z=0;aV(42,l|0,m|0,g|0,(c[F>>2]|0)-(c[p>>2]|0)>>2|0);if(z){z=0;q=bT(-1,-1)|0;u=q;q=M;if((a[m]&1)==0){P=q;Q=u;break}Lw(c[m+8>>2]|0);P=q;Q=u;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}u=c[p>>2]|0;q=(c[F>>2]|0)-u>>2;L76:do{if((q|0)==0){R=L+40|0;S=L+36|0}else{F=b|0;H=L+32|0;I=H;w=L+40|0;G=H+12|0;B=L+36|0;D=B;A=H;H=0;n=u;while(1){x=c[n+(H<<2)>>2]|0;v=(z=0,aM(c[(c[x>>2]|0)+24>>2]|0,x|0,F|0)|0);if(z){z=0;break}if((v|0)!=0){x=v;c[f>>2]=x;v=c[w>>2]|0;r=v;if((r|0)==(c[G>>2]|0)){z=0;as(740,D|0,f|0);if(z){z=0;break}T=c[f>>2]|0}else{if((v|0)==0){U=0}else{c[r>>2]=x;U=c[w>>2]|0}c[w>>2]=U+4;T=x}z=0;as(c[c[A>>2]>>2]|0,I|0,T|0);if(z){z=0;break}}x=H+1|0;if(x>>>0>=q>>>0){R=w;S=B;break L76}H=x;n=c[p>>2]|0}n=bT(-1,-1)|0;V=M;W=n;o=32;break L43}}while(0);K=((c[R>>2]|0)!=(c[S>>2]|0)?l:0)|0;Bx(j);i=e;return K|0}}while(0);l=c[E>>2]|0;p=c[k>>2]|0;q=l;while(1){if((q|0)==(p|0)){X=p;break}if((c[q>>2]|0)==(L|0)){X=q;break}else{q=q+4|0}}q=X-l>>2;E=l+(q+1<<2)|0;u=p-E|0;LG(l+(q<<2)|0,E|0,u|0)|0;E=l+((u>>2)+q<<2)|0;q=c[k>>2]|0;if((E|0)!=(q|0)){c[k>>2]=q+(~((q-4+(-E|0)|0)>>>2)<<2)}Lw(J);s=P;t=Q}}while(0);if((o|0)==31){Q=bT(-1,-1)|0;V=M;W=Q;o=32}if((o|0)==32){s=V;t=W}z=0;ar(444,j|0);if(!z){bg(t|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function hs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+56|0;f=e|0;g=e+16|0;h=e+24|0;j=e+40|0;k=b+16|0;l=c[k>>2]|0;c[k>>2]=0;m=c[b+4>>2]|0;n=Lu(36)|0;c[g>>2]=n;o=m+4|0;p=c[o>>2]|0;if((p|0)==(c[m+8>>2]|0)){e4(m|0,g);q=c[g>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=n;r=c[o>>2]|0}c[o>>2]=r+4;q=n}n=q;r=q;p=d+4|0;L8:do{if((a[p]&1)==0){g=h;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];s=16}else{g=c[d+12>>2]|0;t=c[d+8>>2]|0;do{if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(t>>>0<11>>>0){a[h]=t<<1;u=h+1|0}else{v=t+16&-16;w=(z=0,au(248,v|0)|0);if(z){z=0;break}c[h+8>>2]=w;c[h>>2]=v|1;c[h+4>>2]=t;u=w}LF(u|0,g|0,t)|0;a[u+t|0]=0;s=16;break L8}}while(0);t=bT(-1,-1)|0;x=M;y=t}}while(0);do{if((s|0)==16){u=j;p=d+16|0;c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];p=c[d+32>>2]|0;t=(z=0,aM(c[(c[p>>2]|0)+24>>2]|0,p|0,b|0)|0);do{if(!z){p=f;c[p>>2]=c[u>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];z=0;aV(56,r|0,h|0,f|0,t|0);if(z){z=0;break}if((a[h]&1)==0){c[k>>2]=l;A=q;i=e;return A|0}Lw(c[h+8>>2]|0);c[k>>2]=l;A=q;i=e;return A|0}else{z=0}}while(0);t=bT(-1,-1)|0;u=t;t=M;if((a[h]&1)==0){x=t;y=u;break}Lw(c[h+8>>2]|0);x=t;y=u}}while(0);h=c[m>>2]|0;m=c[o>>2]|0;A=h;while(1){if((A|0)==(m|0)){B=m;break}if((c[A>>2]|0)==(q|0)){B=A;break}else{A=A+4|0}}A=B-h>>2;B=h+(A+1<<2)|0;q=m-B|0;LG(h+(A<<2)|0,B|0,q|0)|0;B=h+((q>>2)+A<<2)|0;A=c[o>>2]|0;if((B|0)==(A|0)){Lw(n);C=y;D=0;E=C;F=x;bg(E|0)}c[o>>2]=A+(~((A-4+(-B|0)|0)>>>2)<<2);Lw(n);C=y;D=0;E=C;F=x;bg(E|0);return 0}function ht(a,b){a=a|0;b=b|0;return b|0}function hu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d|0;f=c[b+56>>2]|0;if((f|0)==0){g=0}else{h=c[(c[f>>2]|0)+20>>2]|0;j=iX(c[a+8>>2]|0,c[a+12>>2]|0,c[a+20>>2]|0)|0;g=cV[h&1023](f,j)|0}j=c[a+4>>2]|0;a=Lu(60)|0;c[e>>2]=a;f=j+4|0;h=c[f>>2]|0;if((h|0)==(c[j+8>>2]|0)){e4(j|0,e);k=c[e>>2]|0}else{if((h|0)==0){l=0}else{c[h>>2]=a;l=c[f>>2]|0}c[f>>2]=l+4;k=a}a=k;z=0;as(768,k|0,b|0);if(!z){c[k+56>>2]=g;i=d;return k|0}else{z=0}d=bT(-1,-1)|0;g=c[j>>2]|0;j=c[f>>2]|0;b=g;while(1){if((b|0)==(j|0)){m=j;break}if((c[b>>2]|0)==(k|0)){m=b;break}else{b=b+4|0}}b=m-g>>2;m=g+(b+1<<2)|0;k=j-m|0;LG(g+(b<<2)|0,m|0,k|0)|0;m=g+((k>>2)+b<<2)|0;b=c[f>>2]|0;if((m|0)==(b|0)){Lw(a);bg(d|0)}c[f>>2]=b+(~((b-4+(-m|0)|0)>>>2)<<2);Lw(a);bg(d|0);return 0}function hv(a,b){a=a|0;b=b|0;return b|0}function hw(a,b){a=a|0;b=b|0;return b|0}function hx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;Bv(f,0);j=b+24|0;L1:do{if((c[j>>2]|0)!=0){k=b+28|0;if((c[k>>2]|0)==0){break}l=f|0;z=0;aR(c[(c[d>>2]|0)+28>>2]|0,g|0,d|0,l|0);do{if(!z){m=c[j>>2]|0;z=0;aR(c[(c[m>>2]|0)+28>>2]|0,h|0,m|0,l|0);if(z){z=0;m=bT(-1,-1)|0;n=m;m=M;if((a[g]&1)==0){o=m;p=n;break}Lw(c[g+8>>2]|0);o=m;p=n;break}n=g;m=g;q=a[m]|0;r=q&255;if((r&1|0)==0){s=r>>>1}else{s=c[g+4>>2]|0}r=h;t=a[h]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[h+4>>2]|0}L18:do{if((s|0)==(v|0)){u=(q&1)==0;if(u){w=n+1|0}else{w=c[g+8>>2]|0}x=t&1;if(x<<24>>24==0){y=r+1|0}else{y=c[h+8>>2]|0}if(!u){A=(LH(w|0,y|0,s|0)|0)==0;B=x;break}if((s|0)==0){A=1;B=x;break}else{C=y;D=w;E=s}while(1){if((a[D]|0)!=(a[C]|0)){A=0;B=x;break L18}u=E-1|0;if((u|0)==0){A=1;B=x;break}else{C=C+1|0;D=D+1|0;E=u}}}else{A=0;B=t&1}}while(0);if(B<<24>>24==0){F=q}else{Lw(c[h+8>>2]|0);F=a[m]|0}if((F&1)==0){if(!A){break L1}}else{Lw(c[g+8>>2]|0);if(!A){break L1}}G=c[k>>2]|0;Bx(f);i=e;return G|0}else{z=0;t=bT(-1,-1)|0;o=M;p=t}}while(0);z=0;ar(444,f|0);if(!z){bg(p|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}}}while(0);G=d|0;Bx(f);i=e;return G|0}function hy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e|0;g=b+16|0;if((c[g>>2]|0)==0){h=0;i=e;return h|0}j=c[b+4>>2]|0;b=Lu(36)|0;c[f>>2]=b;k=j+4|0;l=c[k>>2]|0;if((l|0)==(c[j+8>>2]|0)){e4(j|0,f);m=c[f>>2]|0}else{if((l|0)==0){n=0}else{c[l>>2]=b;n=c[k>>2]|0}c[k>>2]=n+4;m=b}b=m;n=m;l=m|0;c[l>>2]=17512;f=m+4|0;o=d+4|0;L11:do{if((a[o]&1)==0){p=f;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{p=c[d+12>>2]|0;q=c[d+8>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[f]=q<<1;r=f+1|0}else{s=q+16&-16;t=(z=0,au(248,s|0)|0);if(z){z=0;break}c[m+12>>2]=t;c[f>>2]=s|1;c[m+8>>2]=q;r=t}LF(r|0,p|0,q)|0;a[r+q|0]=0;break L11}}while(0);q=bT(-1,-1)|0;p=c[j>>2]|0;t=c[k>>2]|0;s=p;while(1){if((s|0)==(t|0)){u=t;break}if((c[s>>2]|0)==(m|0)){u=s;break}else{s=s+4|0}}s=u-p>>2;v=p+(s+1<<2)|0;w=t-v|0;LG(p+(s<<2)|0,v|0,w|0)|0;v=p+((w>>2)+s<<2)|0;s=c[k>>2]|0;if((v|0)==(s|0)){Lw(b);bg(q|0)}c[k>>2]=s+(~((s-4+(-v|0)|0)>>>2)<<2);Lw(b);bg(q|0)}}while(0);b=m+16|0;k=d+16|0;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[l>>2]=17376;a[m+28|0]=a[d+28|0]&1;a[n+29|0]=a[d+29|0]&1;c[l>>2]=20320;l=m+32|0;c[l>>2]=c[d+32>>2];c[l>>2]=c[g>>2];h=m;i=e;return h|0}function hz(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hA(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hB(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hC(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hD(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hE(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hF(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hG(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hH(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hI(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hJ(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hK(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hL(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hM(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hN(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hO(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hP(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hQ(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hR(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hS(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hT(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hU(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hV(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hW(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hX(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hY(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function hZ(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h_(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h$(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h0(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h1(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h2(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h3(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h4(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h5(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h6(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h7(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h8(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function h9(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function ia(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function ib(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){IU(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=Lu(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;LF(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}Lw(b);return}function ic(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function id(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function ie(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+172>>2]&1023](b,a);return}function ig(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function ih(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function ii(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function ij(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function ik(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+172>>2]&511](a,d,b);return}function il(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+172>>2]&511](a,d,b);return}function im(a){a=a|0;var b=0,d=0;b=c[a+32>>2]|0;if((b|0)==0){d=0;return d|0}d=cD[c[(c[b>>2]|0)+40>>2]&511](b)|0;return d|0}function io(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=b|0;c[e>>2]=17512;f=b+4|0;g=d+4|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;h=c[d+8>>2]|0;if(h>>>0>4294967279>>>0){D5(0)}if(h>>>0<11>>>0){a[f]=h<<1;i=f+1|0}else{j=h+16&-16;k=Lu(j)|0;c[b+12>>2]=k;c[f>>2]=j|1;c[b+8>>2]=h;i=k}LF(i|0,g|0,h)|0;a[i+h|0]=0}h=b+16|0;i=d+16|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];c[e>>2]=17376;a[b+28|0]=a[d+28|0]&1;a[b+29|0]=a[d+29|0]&1;c[e>>2]=20464;i=b+32|0;h=d+32|0;L12:do{if((a[h]&1)==0){g=i;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];l=19}else{g=c[d+40>>2]|0;k=c[d+36>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[i]=k<<1;m=i+1|0}else{j=k+16&-16;n=(z=0,au(248,j|0)|0);if(z){z=0;break}c[b+40>>2]=n;c[i>>2]=j|1;c[b+36>>2]=k;m=n}LF(m|0,g|0,k)|0;a[m+k|0]=0;l=19;break L12}}while(0);k=bT(-1,-1)|0;o=M;p=k}}while(0);do{if((l|0)==19){m=b+44|0;h=d+44|0;if((a[h]&1)==0){k=m;c[k>>2]=c[h>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];q=b+56|0;r=d+56|0;s=c[r>>2]|0;c[q>>2]=s;return}h=c[d+52>>2]|0;k=c[d+48>>2]|0;do{if(k>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(k>>>0<11>>>0){a[m]=k<<1;t=m+1|0}else{g=k+16&-16;n=(z=0,au(248,g|0)|0);if(z){z=0;break}c[b+52>>2]=n;c[m>>2]=g|1;c[b+48>>2]=k;t=n}LF(t|0,h|0,k)|0;a[t+k|0]=0;q=b+56|0;r=d+56|0;s=c[r>>2]|0;c[q>>2]=s;return}}while(0);k=bT(-1,-1)|0;h=k;k=M;if((a[i]&1)==0){o=k;p=h;break}Lw(c[b+40>>2]|0);o=k;p=h}}while(0);c[e>>2]=17512;if((a[f]&1)==0){u=p;v=0;w=u;x=o;bg(w|0)}Lw(c[b+12>>2]|0);u=p;v=0;w=u;x=o;bg(w|0)}function ip(b){b=b|0;var d=0;d=b|0;c[d>>2]=20464;if((a[b+44|0]&1)!=0){Lw(c[b+52>>2]|0)}if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function iq(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=20464;if((a[b+44|0]&1)!=0){Lw(c[b+52>>2]|0)}if((a[b+32|0]&1)!=0){Lw(c[b+40>>2]|0)}c[d>>2]=17512;if((a[b+4|0]&1)==0){e=b;Lw(e);return}Lw(c[b+12>>2]|0);e=b;Lw(e);return}function ir(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+188>>2]&1023](b,a);return}function is(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function it(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function iu(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function iv(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function iw(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+188>>2]&511](a,d,b);return}function ix(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+188>>2]&511](a,d,b);return}function iy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;g=i;i=i+64|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;l=g+48|0;m=d;if((a[m]&1)==0){n=l;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];o=a[n]|0;p=n}else{n=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){d=m<<1&255;q=l;a[q]=d;r=l+1|0;s=d;t=q}else{q=m+16&-16;d=Lu(q)|0;c[l+8>>2]=d;u=q|1;c[l>>2]=u;c[l+4>>2]=m;r=d;s=u&255;t=l}LF(r|0,n|0,m)|0;a[r+m|0]=0;o=s;p=t}t=e;e=k;c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];t=k;k=h;e=j;s=b|0;L12:do{if((o&1)==0){c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];v=19}else{m=c[l+8>>2]|0;r=c[l+4>>2]|0;do{if(r>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(r>>>0<11>>>0){a[k]=r<<1;w=h+1|0}else{n=r+16&-16;u=(z=0,au(248,n|0)|0);if(z){z=0;break}c[h+8>>2]=u;c[h>>2]=n|1;c[h+4>>2]=r;w=u}LF(w|0,m|0,r)|0;a[w+r|0]=0;v=19;break L12}}while(0);r=bT(-1,-1)|0;x=M;y=r}}while(0);do{if((v|0)==19){c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];z=0;aq(20,s|0,h|0,j|0,0,0);if(z){z=0;w=bT(-1,-1)|0;o=M;if((a[k]&1)==0){x=o;y=w;break}Lw(c[h+8>>2]|0);x=o;y=w;break}if((a[k]&1)!=0){Lw(c[h+8>>2]|0)}w=b|0;c[w>>2]=21208;if((a[p]&1)==0){c[w>>2]=21e3;A=b+32|0;c[A>>2]=f;i=g;return}Lw(c[l+8>>2]|0);c[w>>2]=21e3;A=b+32|0;c[A>>2]=f;i=g;return}}while(0);if((a[p]&1)==0){bg(y|0)}Lw(c[l+8>>2]|0);bg(y|0)}function iz(b){b=b|0;c[b>>2]=17512;if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function iA(b){b=b|0;var d=0;c[b>>2]=17512;if((a[b+4|0]&1)==0){d=b;Lw(d);return}Lw(c[b+12>>2]|0);d=b;Lw(d);return}function iB(a,b){a=a|0;b=b|0;cB[c[(c[b>>2]|0)+196>>2]&1023](b,a);return}function iC(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function iD(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function iE(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function iF(a,b){a=a|0;b=b|0;return cV[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function iG(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+196>>2]&511](a,d,b);return}function iH(a,b,d){a=a|0;b=b|0;d=d|0;c_[c[(c[d>>2]|0)+196>>2]&511](a,d,b);return}function iI(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){D5(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=Lu(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}LF(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];z=0;aq(20,k|0,h|0,j|0,0,0);if(z){z=0;j=bT(-1,-1)|0;k=j;j=M;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;bg(t|0)}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}h=b+32|0;c[h>>2]=22608;k=b+36|0;c[k>>2]=0;j=b+40|0;c[j>>2]=0;n=b+44|0;c[n>>2]=0;if((f|0)==0){v=b|0;c[v>>2]=21576;c[h>>2]=21632;i=g;return}m=(z=0,au(248,f<<2|0)|0);if(!z){e=m;c[k>>2]=e;c[j>>2]=e;c[n>>2]=e+(f<<2);v=b|0;c[v>>2]=21576;c[h>>2]=21632;i=g;return}else{z=0}g=bT(-1,-1)|0;h=g;g=M;c[b>>2]=17512;if((a[b+4|0]&1)==0){p=g;q=h;r=q;s=0;t=r;u=p;bg(t|0)}Lw(c[b+12>>2]|0);p=g;q=h;r=q;s=0;t=r;u=p;bg(t|0)}function iJ(a){a=a|0;var b=0;b=Lo((LJ(a|0)|0)+1|0)|0;LK(b|0,a|0)|0;return b|0}function iK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=Au()|0;c[g+24>>2]=b;c[g+28>>2]=d;c[g+32>>2]=e;c[g+36>>2]=0;c[g+8>>2]=a;Ax(g)|0;a=c[g+12>>2]|0;if((a|0)==0){h=0}else{h=bU(a|0)|0}if((c[g+44>>2]|0)==0){i=0;c[f>>2]=i;Av(g);return h|0}i=bU(c[g+48>>2]|0)|0;c[f>>2]=i;Av(g);return h|0}function iL(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[b>>2]=d;d=b+4|0;j=e;if((a[j]&1)==0){k=d;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){D5(0)}if(k>>>0<11>>>0){a[d]=k<<1;l=d+1|0}else{e=k+16&-16;m=Lu(e)|0;c[b+12>>2]=m;c[d>>2]=e|1;c[b+8>>2]=k;l=m}LF(l|0,j|0,k)|0;a[l+k|0]=0}k=b+16|0;l=f;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=b+28|0;k=g;if((a[k]&1)==0){f=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];i=h;return}k=c[g+8>>2]|0;f=c[g+4>>2]|0;do{if(f>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(f>>>0<11>>>0){a[l]=f<<1;n=l+1|0}else{g=f+16&-16;j=(z=0,au(248,g|0)|0);if(z){z=0;break}c[b+36>>2]=j;c[l>>2]=g|1;c[b+32>>2]=f;n=j}LF(n|0,k|0,f)|0;a[n+f|0]=0;i=h;return}}while(0);h=bT(-1,-1)|0;if((a[d]&1)==0){bg(h|0)}Lw(c[b+12>>2]|0);bg(h|0)}function iM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+48|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=f+32|0;f=cl(40)|0;k=f;l=d;L1:do{if((a[l]&1)==0){m=g;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=11}else{m=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(o>>>0<11>>>0){a[g]=o<<1;p=g+1|0}else{q=o+16&-16;r=(z=0,au(248,q|0)|0);if(z){z=0;break}c[g+8>>2]=r;c[g>>2]=q|1;c[g+4>>2]=o;p=r}LF(p|0,m|0,o)|0;a[p+o|0]=0;n=11;break L1}}while(0);o=bT(-1,-1)|0;s=o;t=M}}while(0);do{if((n|0)==11){p=h;d=e;c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];d=b;L16:do{if((a[d]&1)==0){p=j;c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];n=21}else{p=c[b+8>>2]|0;l=c[b+4>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(l>>>0<11>>>0){a[j]=l<<1;u=j+1|0}else{o=l+16&-16;m=(z=0,au(248,o|0)|0);if(z){z=0;break}c[j+8>>2]=m;c[j>>2]=o|1;c[j+4>>2]=l;u=m}LF(u|0,p|0,l)|0;a[u+l|0]=0;n=21;break L16}}while(0);l=bT(-1,-1)|0;v=1;w=M;x=l}}while(0);do{if((n|0)==21){z=0;aq(36,k|0,2,g|0,h|0,j|0);do{if(!z){z=0;aR(156,f|0,31448,356);if(z){z=0;y=0;break}}else{z=0;y=1}}while(0);d=bT(-1,-1)|0;l=d;d=M;if((a[j]&1)==0){v=y;w=d;x=l;break}Lw(c[j+8>>2]|0);v=y;w=d;x=l}}while(0);if((a[g]&1)==0){if(v){s=x;t=w;break}else{A=x;B=w}C=A;D=0;E=C;F=B;bg(E|0)}else{Lw(c[g+8>>2]|0);if(v){s=x;t=w;break}else{A=x;B=w}C=A;D=0;E=C;F=B;bg(E|0)}}}while(0);bo(f|0);A=s;B=t;C=A;D=0;E=C;F=B;bg(E|0)}function iN(b){b=b|0;if((a[b+28|0]&1)!=0){Lw(c[b+36>>2]|0)}if((a[b+4|0]&1)==0){return}Lw(c[b+12>>2]|0);return}function iO(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;h=i;i=i+168|0;j=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=h+32|0;m=h+72|0;n=h+88|0;o=h+104|0;p=h+120|0;q=h+136|0;r=h+152|0;h=e;s=e;t=a[s]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[e+4>>2]|0}do{if((v|0)!=0){if((t&1)==0){w=h+1|0}else{w=c[e+8>>2]|0}if((yY(w)|0)==0){break}u=d[s]|0;if((u&1|0)==0){x=u>>>1}else{x=c[e+4>>2]|0}Ea(k,e,1,x-1|0,0);u=k;y=a[u]|0;if((y&1)==0){A=k+1|0}else{A=c[k+8>>2]|0}B=y&255;if((B&1|0)==0){C=B>>>1}else{C=c[k+4>>2]|0}B=a[s]|0;if((B&1)==0){D=10;E=B}else{B=c[e>>2]|0;D=(B&-2)-1|0;E=B&255}do{if(D>>>0<C>>>0){B=E&255;if((B&1|0)==0){F=B>>>1}else{F=c[e+4>>2]|0}z=0;aC(8,e|0,D|0,C-D|0,F|0,0,F|0,C|0,A|0);if(!z){G=a[u]|0;break}else{z=0}B=bT(-1,-1)|0;H=B;B=M;if((a[u]&1)==0){I=B;J=H;K=J;L=0;N=K;O=I;bg(N|0)}Lw(c[k+8>>2]|0);I=B;J=H;K=J;L=0;N=K;O=I;bg(N|0)}else{if((E&1)==0){P=h+1|0}else{P=c[e+8>>2]|0}LG(P|0,A|0,C|0)|0;a[P+C|0]=0;if((a[s]&1)==0){a[s]=C<<1;G=y;break}else{c[e+4>>2]=C;G=y;break}}}while(0);if((G&1)==0){break}Lw(c[k+8>>2]|0)}}while(0);if((a[s]&1)==0){k=m;c[k>>2]=c[s>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2]}else{k=c[e+8>>2]|0;G=c[e+4>>2]|0;if(G>>>0>4294967279>>>0){D5(0)}if(G>>>0<11>>>0){a[m]=G<<1;Q=m+1|0}else{C=G+16&-16;P=Lu(C)|0;c[m+8>>2]=P;c[m>>2]=C|1;c[m+4>>2]=G;Q=P}LF(Q|0,k|0,G)|0;a[Q+G|0]=0}G=f;f=j;c[f>>2]=c[G>>2];c[f+4>>2]=c[G+4>>2];c[f+8>>2]=c[G+8>>2];f=n;a[f]=0;a[n+1|0]=0;z=0;aq(26,l|0,g|0,m|0,j|0,n|0);if(z){z=0;j=bT(-1,-1)|0;g=j;j=M;if((a[f]&1)!=0){Lw(c[n+8>>2]|0)}if((a[m]&1)==0){I=j;J=g;K=J;L=0;N=K;O=I;bg(N|0)}Lw(c[m+8>>2]|0);I=j;J=g;K=J;L=0;N=K;O=I;bg(N|0)}if((a[f]&1)!=0){Lw(c[n+8>>2]|0)}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}z=0;aR(60,o|0,l|0,0);L78:do{if(!z){m=o;n=a[m]|0;if((n&1)==0){R=o+1|0}else{R=c[o+8>>2]|0}f=n&255;if((f&1|0)==0){S=f>>>1}else{S=c[o+4>>2]|0}z=0,az(88,b|0,R|0,S|0)|0;if(z){z=0;f=bT(-1,-1)|0;n=f;f=M;if((a[m]&1)==0){T=f;U=n;break}Lw(c[o+8>>2]|0);T=f;U=n;break}if((a[m]&1)!=0){Lw(c[o+8>>2]|0)}m=cl(40)|0;n=m;L95:do{if((a[s]&1)==0){f=p;c[f>>2]=c[s>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];V=69}else{f=c[e+8>>2]|0;g=c[e+4>>2]|0;do{if(g>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(g>>>0<11>>>0){a[p]=g<<1;W=p+1|0}else{j=g+16&-16;Q=(z=0,au(248,j|0)|0);if(z){z=0;break}c[p+8>>2]=Q;c[p>>2]=j|1;c[p+4>>2]=g;W=Q}LF(W|0,f|0,g)|0;a[W+g|0]=0;V=69;break L95}}while(0);g=bT(-1,-1)|0;X=g;Y=M}}while(0);do{if((V|0)==69){g=q;c[g>>2]=c[G>>2];c[g+4>>2]=c[G+4>>2];c[g+8>>2]=c[G+8>>2];g=b;L110:do{if((a[g]&1)==0){f=r;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];V=79}else{f=c[b+8>>2]|0;Q=c[b+4>>2]|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}}else{if(Q>>>0<11>>>0){a[r]=Q<<1;Z=r+1|0}else{j=Q+16&-16;k=(z=0,au(248,j|0)|0);if(z){z=0;break}c[r+8>>2]=k;c[r>>2]=j|1;c[r+4>>2]=Q;Z=k}LF(Z|0,f|0,Q)|0;a[Z+Q|0]=0;V=79;break L110}}while(0);Q=bT(-1,-1)|0;_=1;$=M;aa=Q}}while(0);do{if((V|0)==79){z=0;aq(36,n|0,2,p|0,q|0,r|0);do{if(!z){z=0;aR(156,m|0,31448,356);if(z){z=0;ab=0;break}}else{z=0;ab=1}}while(0);g=bT(-1,-1)|0;Q=g;g=M;if((a[r]&1)==0){_=ab;$=g;aa=Q;break}Lw(c[r+8>>2]|0);_=ab;$=g;aa=Q}}while(0);if((a[p]&1)==0){if(_){X=aa;Y=$;break}else{T=$;U=aa;break L78}}else{Lw(c[p+8>>2]|0);if(_){X=aa;Y=$;break}else{T=$;U=aa;break L78}}}}while(0);bo(m|0);T=Y;U=X}else{z=0;n=bT(-1,-1)|0;T=M;U=n}}while(0);if((a[l+28|0]&1)!=0){Lw(c[l+36>>2]|0)}if((a[l+4|0]&1)==0){I=T;J=U;K=J;L=0;N=K;O=I;bg(N|0)}Lw(c[l+12>>2]|0);I=T;J=U;K=J;L=0;N=K;O=I;bg(N|0)}function iP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=i;i=i+32|0;g=f|0;h=f+8|0;j=f+16|0;k=j;l=i;i=i+144|0;m=l+64|0;n=l|0;o=l+8|0;p=o|0;c[p>>2]=15464;q=l+12|0;c[n>>2]=32540;r=l+64|0;c[r>>2]=32560;c[l+4>>2]=0;z=0;as(198,l+64|0,q|0);do{if(!z){c[l+136>>2]=0;c[l+140>>2]=-1;s=l+8|0;c[n>>2]=15444;c[m>>2]=15484;c[p>>2]=15464;t=q|0;c[t>>2]=15768;u=l+16|0;I_(u);v=l+20|0;LI(v|0,0,24)|0;c[t>>2]=15624;w=l+44|0;x=l+56|0;y=l+60|0;LI(l+44|0,0,16)|0;c[y>>2]=24;LI(k|0,0,12)|0;z=0;as(212,q|0,j|0);if(z){z=0;A=bT(-1,-1)|0;B=M;if((a[k]&1)!=0){Lw(c[j+8>>2]|0)}if((a[w]&1)!=0){Lw(c[l+52>>2]|0)}c[t>>2]=15768;z=0;ar(394,u|0);if(!z){C=A;D=B;break}else{z=0}bT(-1,-1,0)|0;bX()}if((a[k]&1)!=0){Lw(c[j+8>>2]|0)}L16:do{if(e){E=16}else{B=o;z=0;as(352,h|0,o+(c[(c[o>>2]|0)-12>>2]|0)|0);if(z){z=0;E=28;break}A=(z=0,aM(198,h|0,41760)|0);do{if(!z){t=(z=0,aM(c[(c[A>>2]|0)+28>>2]|0,A|0,10)|0);if(z){z=0;break}z=0;ar(394,h|0);if(z){z=0;E=28;break L16}z=0,aM(242,B|0,t|0)|0;if(z){z=0;E=28;break L16}z=0,au(62,B|0)|0;if(z){z=0;E=28;break L16}z=0,aM(114,B|0,9400)|0;if(!z){E=16;break L16}else{z=0;E=28;break L16}}else{z=0}}while(0);B=bT(-1,-1)|0;A=M;z=0;ar(394,h|0);if(!z){F=A;G=B;break}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);L27:do{if((E|0)==16){B=d|0;L29:do{if((c[B>>2]|0)!=0){A=o;t=o;H=o;I=e?5960:38328;J=d;K=B;while(1){z=0;as(352,g|0,H+(c[(c[t>>2]|0)-12>>2]|0)|0);if(z){z=0;E=27;break}L=(z=0,aM(198,g|0,41760)|0);if(z){z=0;break}N=(z=0,aM(c[(c[L>>2]|0)+28>>2]|0,L|0,10)|0);if(z){z=0;break}z=0;ar(394,g|0);if(z){z=0;E=27;break}z=0,aM(242,A|0,N|0)|0;if(z){z=0;E=27;break}z=0,au(62,A|0)|0;if(z){z=0;E=27;break}N=(z=0,aM(114,A|0,7640)|0);if(z){z=0;E=27;break}L=(z=0,aM(114,N|0,I|0)|0);if(z){z=0;E=27;break}N=(z=0,aM(814,L|0,J+4|0)|0);if(z){z=0;E=27;break}L=(z=0,aM(114,N|0,4928)|0);if(z){z=0;E=27;break}N=(z=0,aM(312,L|0,c[J+20>>2]|0)|0);if(z){z=0;E=27;break}z=0,aM(814,N|0,(c[K>>2]|0)+28|0)|0;if(z){z=0;E=27;break}J=c[K>>2]|0;K=J|0;if((c[K>>2]|0)==0){break L29}}if((E|0)==27){K=bT(-1,-1)|0;F=M;G=K;break L27}K=bT(-1,-1)|0;J=M;z=0;ar(394,g|0);if(!z){F=J;G=K;break L27}else{z=0}bT(-1,-1,0)|0;bX()}}while(0);B=b;K=c[y>>2]|0;do{if((K&16|0)==0){if((K&8|0)==0){LI(B|0,0,12)|0;break}J=c[v>>2]|0;I=c[l+28>>2]|0;A=J;t=I-A|0;if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;E=28;break L27}}if(t>>>0<11>>>0){a[B]=t<<1;O=b+1|0}else{H=t+16&-16;N=(z=0,au(248,H|0)|0);if(z){z=0;E=28;break L27}c[b+8>>2]=N;c[b>>2]=H|1;c[b+4>>2]=t;O=N}if((J|0)==(I|0)){P=O}else{N=I+(-A|0)|0;A=O;t=J;while(1){a[A]=a[t]|0;J=t+1|0;if((J|0)==(I|0)){break}else{A=A+1|0;t=J}}P=O+N|0}a[P]=0}else{t=c[x>>2]|0;A=c[l+36>>2]|0;if(t>>>0<A>>>0){c[x>>2]=A;Q=A}else{Q=t}t=c[l+32>>2]|0;A=t;I=Q-A|0;if(I>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;E=28;break L27}}if(I>>>0<11>>>0){a[B]=I<<1;R=b+1|0}else{J=I+16&-16;H=(z=0,au(248,J|0)|0);if(z){z=0;E=28;break L27}c[b+8>>2]=H;c[b>>2]=J|1;c[b+4>>2]=I;R=H}if((t|0)==(Q|0)){S=R}else{H=Q+(-A|0)|0;A=R;I=t;while(1){a[A]=a[I]|0;t=I+1|0;if((t|0)==(Q|0)){break}else{A=A+1|0;I=t}}S=R+H|0}a[S]=0}}while(0);c[n>>2]=15444;c[r>>2]=15484;c[s>>2]=15464;B=l+12|0;c[B>>2]=15624;if((a[w]&1)!=0){Lw(c[l+52>>2]|0)}c[B>>2]=15768;z=0;ar(394,u|0);if(!z){Ex(l+64|0);i=f;return}else{z=0}B=bT(-1,-1)|0;z=0;ar(272,l+64|0);if(!z){bg(B|0)}else{z=0;bT(-1,-1,0)|0;bX()}}}while(0);if((E|0)==28){x=bT(-1,-1)|0;F=M;G=x}c[n>>2]=15444;c[r>>2]=15484;c[s>>2]=15464;x=l+12|0;c[x>>2]=15624;if((a[w]&1)!=0){Lw(c[l+52>>2]|0)}c[x>>2]=15768;z=0;ar(394,u|0);if(z){z=0;bT(-1,-1,0)|0;z=0;ar(272,l+64|0);if(!z){bX()}else{z=0;bT(-1,-1,0)|0;bX()}}z=0;ar(272,l+64|0);if(!z){bg(G|0)}else{z=0}bT(-1,-1,0)|0;bX()}else{z=0;x=bT(-1,-1)|0;C=x;D=M}}while(0);z=0;ar(272,m|0);if(!z){bg(C|0)}else{z=0;bT(-1,-1,0)|0;bX()}}function iQ(a,b){a=+a;b=+b;return+(a+b)}function iR(a,b){a=+a;b=+b;return+(a-b)}function iS(a,b){a=+a;b=+b;return+(a*b)}function iT(a,b){a=+a;b=+b;return+(a/b)}function iU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=19680;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;return}function iV(a){a=a|0;Lw(a);return}function iW(a){a=a|0;return}function iX(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return a|0}function iY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b+32|0;e=(c[b+36>>2]|0)-(c[d>>2]|0)>>2;b=a|0;a=0;while(1){if(a>>>0>=e>>>0){f=0;g=5;break}h=c[(c[d>>2]|0)+(a<<2)>>2]|0;i=cV[c[(c[h>>2]|0)+20>>2]&1023](h|0,b)|0;if((i|0)==0){a=a+1|0}else{f=i;g=6;break}}if((g|0)==6){return f|0}else if((g|0)==5){return f|0}return 0}function iZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+28|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+36>>2]|0;j=c[d+32>>2]|0;if(j>>>0>4294967279>>>0){D5(0);return 0}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=Lu(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}LF(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+8|0;q=c[r>>2]|0;do{if((l&1)==0){j=g;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];t=19}else{j=c[f+8>>2]|0;p=c[f+4>>2]|0;if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=38;break}return 0}if(p>>>0<11>>>0){a[g]=p<<1;u=g+1|0}else{k=p+16&-16;s=(z=0,au(248,k|0)|0);if(z){z=0;t=38;break}c[g+8>>2]=s;c[g>>2]=k|1;c[g+4>>2]=p;u=s}LF(u|0,j|0,p)|0;a[u+p|0]=0;t=19}}while(0);L24:do{if((t|0)==19){u=(z=0,aM(560,q|0,g|0)|0);if(z){z=0;l=bT(-1,-1)|0;p=l;l=M;if((a[g]&1)==0){v=p;w=l;break}Lw(c[g+8>>2]|0);v=p;w=l;break}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}do{if(u){if((a[d+44|0]&1)!=0){break}l=c[d+40>>2]|0;p=(z=0,aM(c[(c[l>>2]|0)+20>>2]|0,l|0,b|0)|0);if(z){z=0;t=38;break L24}l=p|0;p=c[r>>2]|0;if((a[m]&1)==0){j=h;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2]}else{j=c[f+8>>2]|0;s=c[f+4>>2]|0;if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;t=38;break L24}return 0}if(s>>>0<11>>>0){a[h]=s<<1;x=h+1|0}else{k=s+16&-16;n=(z=0,au(248,k|0)|0);if(z){z=0;t=38;break L24}c[h+8>>2]=n;c[h>>2]=k|1;c[h+4>>2]=s;x=n}LF(x|0,j|0,s)|0;a[x+s|0]=0}s=(z=0,aM(90,p|0,h|0)|0);if(!z){c[s>>2]=l;if((a[h]&1)==0){break}Lw(c[h+8>>2]|0);break}else{z=0;l=bT(-1,-1)|0;s=l;l=M;if((a[h]&1)==0){v=s;w=l;break L24}Lw(c[h+8>>2]|0);v=s;w=l;break L24}}else{l=c[d+40>>2]|0;s=(z=0,aM(c[(c[l>>2]|0)+20>>2]|0,l|0,b|0)|0);if(z){z=0;t=38;break L24}l=(z=0,aM(178,c[r>>2]|0,f|0)|0);if(z){z=0;t=38;break L24}c[l>>2]=s}}while(0);if((a[m]&1)==0){i=e;return 0}Lw(c[f+8>>2]|0);i=e;return 0}}while(0);if((t|0)==38){t=bT(-1,-1)|0;v=t;w=M}if((a[m]&1)==0){y=v;A=0;B=y;C=w;bg(B|0)}Lw(c[f+8>>2]|0);y=v;A=0;B=y;C=w;bg(B|0);return 0}function i_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e|0;if((fs(b|0,d)|0)!=0){g=1;i=e;return g|0}h=c[b+12>>2]|0;if((h|0)==0){g=0;i=e;return g|0}b=d;if((a[b]&1)==0){j=f;c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2]}else{b=c[d+8>>2]|0;j=c[d+4>>2]|0;if(j>>>0>4294967279>>>0){D5(0);return 0}if(j>>>0<11>>>0){a[f]=j<<1;k=f+1|0}else{d=j+16&-16;l=Lu(d)|0;c[f+8>>2]=l;c[f>>2]=d|1;c[f+4>>2]=j;k=l}LF(k|0,b|0,j)|0;a[k+j|0]=0}j=(z=0,aM(560,h|0,f|0)|0);if(!z){if((a[f]&1)==0){g=j;i=e;return g|0}Lw(c[f+8>>2]|0);g=j;i=e;return g|0}else{z=0;g=bT(-1,-1)|0;if((a[f]&1)==0){bg(g|0)}Lw(c[f+8>>2]|0);bg(g|0)}return 0}function i$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[b+28>>2]|0;e=a|0;a=cV[c[(c[d>>2]|0)+20>>2]&1023](d|0,e)|0;if(cD[c[(c[a>>2]|0)+36>>2]&511](a)|0){a=c[b+32>>2]|0;f=cV[c[(c[a>>2]|0)+20>>2]&1023](a,e)|0;return f|0}a=c[b+36>>2]|0;if((a|0)==0){f=0;return f|0}f=cV[c[(c[a>>2]|0)+20>>2]&1023](a,e)|0;return f|0}function i0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0,aW=0.0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0;e=i;i=i+272|0;f=e|0;g=e+16|0;j=e+24|0;k=e+40|0;l=e+48|0;m=e+64|0;n=e+80|0;o=e+96|0;p=e+112|0;q=e+128|0;r=e+144|0;s=e+160|0;t=e+176|0;u=e+192|0;v=e+208|0;w=e+224|0;x=e+240|0;y=e+256|0;A=d+32|0;if((a[A]&1)==0){B=l;c[B>>2]=c[A>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2]}else{A=c[d+40>>2]|0;B=c[d+36>>2]|0;if(B>>>0>4294967279>>>0){D5(0);return 0}if(B>>>0<11>>>0){a[l]=B<<1;C=l+1|0}else{D=B+16&-16;E=Lu(D)|0;c[l+8>>2]=E;c[l>>2]=D|1;c[l+4>>2]=B;C=E}LF(C|0,A|0,B)|0;a[C+B|0]=0}B=c[d+44>>2]|0;C=b|0;A=(z=0,aM(c[(c[B>>2]|0)+20>>2]|0,B|0,C|0)|0);L12:do{if(!z){L14:do{if((c[A+32>>2]|0)!=2){B=(z=0,au(248,48)|0);if(z){z=0;F=27;break L12}E=m+8|0;c[E>>2]=B;c[m>>2]=49;c[m+4>>2]=47;LF(B|0,10224,47)|0;a[B+47|0]=0;B=A+4|0;L17:do{if((a[B]&1)==0){D=n;c[D>>2]=c[B>>2];c[D+4>>2]=c[B+4>>2];c[D+8>>2]=c[B+8>>2];F=22}else{D=c[A+12>>2]|0;G=c[A+8>>2]|0;do{if(G>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(G>>>0<11>>>0){a[n]=G<<1;H=n+1|0}else{I=G+16&-16;J=(z=0,au(248,I|0)|0);if(z){z=0;break}c[n+8>>2]=J;c[n>>2]=I|1;c[n+4>>2]=G;H=J}LF(H|0,D|0,G)|0;a[H+G|0]=0;F=22;break L17}}while(0);G=bT(-1,-1)|0;K=G;L=M}}while(0);do{if((F|0)==22){B=o;G=A+16|0;c[B>>2]=c[G>>2];c[B+4>>2]=c[G+4>>2];c[B+8>>2]=c[G+8>>2];z=0;aR(382,m|0,n|0,o|0);if(z){z=0;G=bT(-1,-1)|0;B=G;G=M;if((a[n]&1)==0){K=B;L=G;break}Lw(c[n+8>>2]|0);K=B;L=G;break}if((a[n]&1)!=0){Lw(c[n+8>>2]|0)}if((a[m]&1)==0){break L14}Lw(c[E>>2]|0);break L14}}while(0);if((a[m]&1)==0){N=K;O=L;break L12}Lw(c[E>>2]|0);N=K;O=L;break L12}}while(0);G=c[d+48>>2]|0;B=(z=0,aM(c[(c[G>>2]|0)+20>>2]|0,G|0,C|0)|0);if(z){z=0;F=27;break}L44:do{if((c[B+32>>2]|0)!=2){G=(z=0,au(248,48)|0);if(z){z=0;F=27;break L12}D=p+8|0;c[D>>2]=G;c[p>>2]=49;c[p+4>>2]=47;LF(G|0,12032,47)|0;a[G+47|0]=0;G=B+4|0;L47:do{if((a[G]&1)==0){J=q;c[J>>2]=c[G>>2];c[J+4>>2]=c[G+4>>2];c[J+8>>2]=c[G+8>>2];F=46}else{J=c[B+12>>2]|0;I=c[B+8>>2]|0;do{if(I>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(I>>>0<11>>>0){a[q]=I<<1;P=q+1|0}else{Q=I+16&-16;R=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[q+8>>2]=R;c[q>>2]=Q|1;c[q+4>>2]=I;P=R}LF(P|0,J|0,I)|0;a[P+I|0]=0;F=46;break L47}}while(0);I=bT(-1,-1)|0;S=I;T=M}}while(0);do{if((F|0)==46){G=r;E=B+16|0;c[G>>2]=c[E>>2];c[G+4>>2]=c[E+4>>2];c[G+8>>2]=c[E+8>>2];z=0;aR(382,p|0,q|0,r|0);if(z){z=0;E=bT(-1,-1)|0;G=E;E=M;if((a[q]&1)==0){S=G;T=E;break}Lw(c[q+8>>2]|0);S=G;T=E;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[p]&1)==0){break L44}Lw(c[D>>2]|0);break L44}}while(0);if((a[p]&1)==0){N=S;O=T;break L12}Lw(c[D>>2]|0);N=S;O=T;break L12}}while(0);U=+h[A+40>>3];V=+h[B+40>>3];if((a[d+52|0]&1)==0){W=V}else{W=V+1.0}E=s+4|0;c[E>>2]=0;c[s+8>>2]=0;c[s>>2]=E;E=s+12|0;c[E>>2]=0;G=b+4|0;I=c[G>>2]|0;J=(z=0,au(248,72)|0);L76:do{if(!z){R=J;c[k>>2]=R;Q=I+4|0;X=c[Q>>2]|0;if((X|0)==(c[I+8>>2]|0)){z=0;as(382,I|0,k|0);if(z){z=0;F=98;break}Y=c[k>>2]|0}else{if((X|0)==0){Z=0}else{c[X>>2]=R;Z=c[Q>>2]|0}c[Q>>2]=Z+4;Y=R}R=Y;X=Y;_=A+4|0;L86:do{if((a[_]&1)==0){$=t;c[$>>2]=c[_>>2];c[$+4>>2]=c[_+4>>2];c[$+8>>2]=c[_+8>>2];F=75}else{$=c[A+12>>2]|0;aa=c[A+8>>2]|0;do{if(aa>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aa>>>0<11>>>0){a[t]=aa<<1;ab=t+1|0}else{ac=aa+16&-16;ad=(z=0,au(248,ac|0)|0);if(z){z=0;break}c[t+8>>2]=ad;c[t>>2]=ac|1;c[t+4>>2]=aa;ab=ad}LF(ab|0,$|0,aa)|0;a[ab+aa|0]=0;F=75;break L86}}while(0);aa=bT(-1,-1)|0;ae=M;af=aa}}while(0);do{if((F|0)==75){D=A+16|0;aa=j;c[aa>>2]=c[D>>2];c[aa+4>>2]=c[D+4>>2];c[aa+8>>2]=c[D+8>>2];aa=u;a[aa]=0;a[u+1|0]=0;z=0;aG(2,X|0,t|0,j|0,+U,u|0);do{if(!z){$=l;ad=(a[$]&1)==0;if(ad){ac=v;c[ac>>2]=c[$>>2];c[ac+4>>2]=c[$+4>>2];c[ac+8>>2]=c[$+8>>2]}else{ac=c[l+8>>2]|0;ag=c[l+4>>2]|0;if(ag>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;ah=0;F=101;break}return 0}if(ag>>>0<11>>>0){a[v]=ag<<1;ai=v+1|0}else{aj=ag+16&-16;ak=(z=0,au(248,aj|0)|0);if(z){z=0;ah=0;F=101;break}c[v+8>>2]=ak;c[v>>2]=aj|1;c[v+4>>2]=ag;ai=ak}LF(ai|0,ac|0,ag)|0;a[ai+ag|0]=0}ag=(z=0,aM(90,s|0,v|0)|0);if(z){z=0;ac=bT(-1,-1)|0;ak=ac;ac=M;if((a[v]&1)==0){al=ak;am=ac;an=0;break}Lw(c[v+8>>2]|0);al=ak;am=ac;an=0;break}c[ag>>2]=Y;if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}if((a[aa]&1)!=0){Lw(c[u+8>>2]|0)}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}ag=b+8|0;c[E>>2]=c[ag>>2];c[ag>>2]=s;ac=c[d+28>>2]|0;L129:do{if(U<W){ak=ac;aj=w;ao=x;ap=x+1|0;aq=y;at=w+8|0;av=x+8|0;aw=y+8|0;ax=l+8|0;ay=l+4|0;az=y+1|0;aA=y|0;aB=y+4|0;aC=A+12|0;aD=A+8|0;aE=w+1|0;aF=w|0;aH=w+4|0;V=U;while(1){aI=(z=0,aM(c[(c[ak>>2]|0)+20>>2]|0,ac|0,C|0)|0);if(z){z=0;F=97;break}if((aI|0)!=0){aJ=aI;break L129}aK=c[G>>2]|0;aI=(z=0,au(248,72)|0);if(z){z=0;F=97;break}aL=aI;c[g>>2]=aL;aN=aK+4|0;aI=c[aN>>2]|0;if((aI|0)==(c[aK+8>>2]|0)){z=0;as(382,aK|0,g|0);if(z){z=0;F=97;break}aO=c[g>>2]|0}else{if((aI|0)==0){aP=0}else{c[aI>>2]=aL;aP=c[aN>>2]|0}c[aN>>2]=aP+4;aO=aL}aQ=aO;aL=aO;if((a[_]&1)==0){c[aj>>2]=c[_>>2];c[aj+4>>2]=c[_+4>>2];c[aj+8>>2]=c[_+8>>2]}else{aI=c[aC>>2]|0;aS=c[aD>>2]|0;if(aS>>>0>4294967279>>>0){F=125;break}if(aS>>>0<11>>>0){a[aj]=aS<<1;aT=aE}else{aU=aS+16&-16;aV=(z=0,au(248,aU|0)|0);if(z){z=0;F=151;break}c[at>>2]=aV;c[aF>>2]=aU|1;c[aH>>2]=aS;aT=aV}LF(aT|0,aI|0,aS)|0;a[aT+aS|0]=0}aS=f;c[aS>>2]=c[D>>2];c[aS+4>>2]=c[D+4>>2];c[aS+8>>2]=c[D+8>>2];aW=V+1.0;a[ao]=0;a[ap]=0;z=0;aG(2,aL|0,w|0,f|0,+aW,x|0);if(z){z=0;aX=1;F=154;break}aL=c[ag>>2]|0;if(ad){c[aq>>2]=c[$>>2];c[aq+4>>2]=c[$+4>>2];c[aq+8>>2]=c[$+8>>2]}else{aS=c[ax>>2]|0;aI=c[ay>>2]|0;if(aI>>>0>4294967279>>>0){F=136;break}if(aI>>>0<11>>>0){a[aq]=aI<<1;aY=az}else{aV=aI+16&-16;aU=(z=0,au(248,aV|0)|0);if(z){z=0;aX=0;F=154;break}c[aw>>2]=aU;c[aA>>2]=aV|1;c[aB>>2]=aI;aY=aU}LF(aY|0,aS|0,aI)|0;a[aY+aI|0]=0}aI=(z=0,aM(90,aL|0,y|0)|0);if(z){z=0;F=157;break}c[aI>>2]=aO;if((a[aq]&1)!=0){Lw(c[aw>>2]|0)}if((a[ao]&1)!=0){Lw(c[av>>2]|0)}if((a[aj]&1)!=0){Lw(c[at>>2]|0)}if(aW<W){V=aW}else{aJ=0;break L129}}do{if((F|0)==125){z=0;ar(86,0);if(!z){return 0}else{z=0;aB=bT(-1,-1)|0;aZ=M;a_=aB;F=153;break}}else if((F|0)==97){aB=bT(-1,-1)|0;a$=M;a0=aB;F=99;break L76}else if((F|0)==136){z=0;ar(86,0);if(!z){return 0}else{z=0;aB=bT(-1,-1)|0;a1=M;a2=aB;a3=0;F=156;break}}else if((F|0)==151){aB=bT(-1,-1)|0;aZ=M;a_=aB;F=153}else if((F|0)==154){aB=bT(-1,-1)|0;a1=M;a2=aB;a3=aX;F=156}else if((F|0)==157){aB=bT(-1,-1)|0;aA=aB;aB=M;if((a[aq]&1)==0){a4=aA;a5=0;a6=aB;F=159;break}Lw(c[aw>>2]|0);a4=aA;a5=0;a6=aB;F=159}}while(0);if((F|0)==153){a7=aZ;a8=a_}else if((F|0)==156){a4=a2;a5=a3;a6=a1;F=159}do{if((F|0)==159){if((a[ao]&1)!=0){Lw(c[av>>2]|0)}if((a[aj]&1)==0){if(a5){a7=a6;a8=a4;break}else{a9=a4;ba=a6;break L76}}else{Lw(c[at>>2]|0);if(a5){a7=a6;a8=a4;break}else{a9=a4;ba=a6;break L76}}}}while(0);at=c[aK>>2]|0;aj=c[aN>>2]|0;av=at;while(1){if((av|0)==(aj|0)){bb=aj;break}if((c[av>>2]|0)==(aO|0)){bb=av;break}else{av=av+4|0}}av=bb-at>>2;ao=at+(av+1<<2)|0;aw=aj-ao|0;LG(at+(av<<2)|0,ao|0,aw|0)|0;ao=at+((aw>>2)+av<<2)|0;av=c[aN>>2]|0;if((ao|0)!=(av|0)){c[aN>>2]=av+(~((av-4+(-ao|0)|0)>>>2)<<2)}Lw(aQ);a9=a8;ba=a7;break L76}else{aJ=0}}while(0);c[ag>>2]=c[E>>2];g_(s|0,c[s+4>>2]|0);if(ad){i=e;return aJ|0}Lw(c[l+8>>2]|0);i=e;return aJ|0}else{z=0;ah=1;F=101}}while(0);if((F|0)==101){D=bT(-1,-1)|0;al=D;am=M;an=ah}if((a[aa]&1)!=0){Lw(c[u+8>>2]|0)}if((a[t]&1)==0){if(an){ae=am;af=al;break}else{a9=al;ba=am;break L76}}else{Lw(c[t+8>>2]|0);if(an){ae=am;af=al;break}else{a9=al;ba=am;break L76}}}}while(0);_=c[I>>2]|0;X=c[Q>>2]|0;D=_;while(1){if((D|0)==(X|0)){bc=X;break}if((c[D>>2]|0)==(Y|0)){bc=D;break}else{D=D+4|0}}D=bc-_>>2;$=_+(D+1<<2)|0;ac=X-$|0;LG(_+(D<<2)|0,$|0,ac|0)|0;$=_+((ac>>2)+D<<2)|0;D=c[Q>>2]|0;if(($|0)!=(D|0)){c[Q>>2]=D+(~((D-4+(-$|0)|0)>>>2)<<2)}Lw(R);a9=af;ba=ae}else{z=0;F=98}}while(0);if((F|0)==98){I=bT(-1,-1)|0;a$=M;a0=I;F=99}if((F|0)==99){a9=a0;ba=a$}g_(s|0,c[s+4>>2]|0);N=a9;O=ba}else{z=0;F=27}}while(0);if((F|0)==27){F=bT(-1,-1)|0;N=F;O=M}if((a[l]&1)==0){bd=N;be=0;bf=bd;bh=O;bg(bf|0)}Lw(c[l+8>>2]|0);bd=N;be=0;bf=bd;bh=O;bg(bf|0);return 0}function i1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;e=i;i=i+112|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=d+32|0;if((a[o]&1)==0){p=j;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[d+40>>2]|0;p=c[d+36>>2]|0;if(p>>>0>4294967279>>>0){D5(0);return 0}if(p>>>0<11>>>0){a[j]=p<<1;q=j+1|0}else{r=p+16&-16;s=Lu(r)|0;c[j+8>>2]=s;c[j>>2]=r|1;c[j+4>>2]=p;q=s}LF(q|0,o|0,p)|0;a[q+p|0]=0}p=c[d+44>>2]|0;q=b|0;o=(z=0,aM(c[(c[p>>2]|0)+20>>2]|0,p|0,q|0)|0);L12:do{if(!z){L14:do{if((c[o+32>>2]|0)==5){t=o}else{p=c[b+4>>2]|0;s=(z=0,au(248,60)|0);if(z){z=0;u=38;break L12}r=s;c[h>>2]=r;s=p+4|0;v=c[s>>2]|0;if((v|0)==(c[p+8>>2]|0)){z=0;as(382,p|0,h|0);if(z){z=0;u=38;break L12}w=c[h>>2]|0}else{if((v|0)==0){x=0}else{c[v>>2]=r;x=c[s>>2]|0}c[s>>2]=x+4;w=r}r=w;v=w;y=o+4|0;L25:do{if((a[y]&1)==0){A=k;c[A>>2]=c[y>>2];c[A+4>>2]=c[y+4>>2];c[A+8>>2]=c[y+8>>2];u=28}else{A=c[o+12>>2]|0;B=c[o+8>>2]|0;do{if(B>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(B>>>0<11>>>0){a[k]=B<<1;C=k+1|0}else{D=B+16&-16;E=(z=0,au(248,D|0)|0);if(z){z=0;break}c[k+8>>2]=E;c[k>>2]=D|1;c[k+4>>2]=B;C=E}LF(C|0,A|0,B)|0;a[C+B|0]=0;u=28;break L25}}while(0);B=bT(-1,-1)|0;F=B;G=M}}while(0);do{if((u|0)==28){y=o+16|0;B=g;c[B>>2]=c[y>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];z=0;aD(36,v|0,k|0,g|0,1,1,0);if(z){z=0;y=bT(-1,-1)|0;B=y;y=M;if((a[k]&1)==0){F=B;G=y;break}Lw(c[k+8>>2]|0);F=B;G=y;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}y=w+36|0;B=y;c[f>>2]=o;A=y+8|0;E=A;D=c[E>>2]|0;if((D|0)==(c[y+12>>2]|0)){z=0;as(376,y+4|0,f|0);if(z){z=0;u=38;break L12}H=c[f>>2]|0}else{if((D|0)==0){I=0}else{c[D>>2]=o;I=c[E>>2]|0}c[A>>2]=I+4;H=o}z=0;as(c[c[y>>2]>>2]|0,B|0,H|0);if(!z){t=v;break L14}else{z=0;u=38;break L12}}}while(0);v=c[p>>2]|0;B=c[s>>2]|0;y=v;while(1){if((y|0)==(B|0)){J=B;break}if((c[y>>2]|0)==(w|0)){J=y;break}else{y=y+4|0}}y=J-v>>2;p=v+(y+1<<2)|0;A=B-p|0;LG(v+(y<<2)|0,p|0,A|0)|0;p=v+((A>>2)+y<<2)|0;y=c[s>>2]|0;if((p|0)!=(y|0)){c[s>>2]=y+(~((y-4+(-p|0)|0)>>>2)<<2)}Lw(r);K=F;L=G;break L12}}while(0);p=l+4|0;c[p>>2]=0;c[l+8>>2]=0;c[l>>2]=p;p=l+12|0;c[p>>2]=0;y=j;A=(a[y]&1)==0;do{if(A){E=m;c[E>>2]=c[y>>2];c[E+4>>2]=c[y+4>>2];c[E+8>>2]=c[y+8>>2];u=59}else{E=c[j+8>>2]|0;D=c[j+4>>2]|0;if(D>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;u=80;break}return 0}if(D>>>0<11>>>0){a[m]=D<<1;N=m+1|0}else{O=D+16&-16;P=(z=0,au(248,O|0)|0);if(z){z=0;u=80;break}c[m+8>>2]=P;c[m>>2]=O|1;c[m+4>>2]=D;N=P}LF(N|0,E|0,D)|0;a[N+D|0]=0;u=59}}while(0);do{if((u|0)==59){D=(z=0,aM(90,l|0,m|0)|0);if(z){z=0;E=bT(-1,-1)|0;P=E;E=M;if((a[m]&1)==0){Q=P;R=E;break}Lw(c[m+8>>2]|0);Q=P;R=E;break}c[D>>2]=0;if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}D=b+8|0;c[p>>2]=c[D>>2];c[D>>2]=l;E=c[d+28>>2]|0;P=t+40|0;O=(c[t+44>>2]|0)-(c[P>>2]|0)>>2;S=n;T=E;U=n+8|0;V=j+8|0;W=j+4|0;X=n+1|0;Y=n|0;Z=n+4|0;_=0;while(1){if(_>>>0>=O>>>0){$=0;u=86;break}aa=c[(c[P>>2]|0)+(_<<2)>>2]|0;ab=c[D>>2]|0;if(A){c[S>>2]=c[y>>2];c[S+4>>2]=c[y+4>>2];c[S+8>>2]=c[y+8>>2]}else{ac=c[V>>2]|0;ad=c[W>>2]|0;if(ad>>>0>4294967279>>>0){u=67;break}if(ad>>>0<11>>>0){a[S]=ad<<1;ae=X}else{af=ad+16&-16;ag=(z=0,au(248,af|0)|0);if(z){z=0;u=79;break}c[U>>2]=ag;c[Y>>2]=af|1;c[Z>>2]=ad;ae=ag}LF(ae|0,ac|0,ad)|0;a[ae+ad|0]=0}ad=(z=0,aM(90,ab|0,n|0)|0);if(z){z=0;u=84;break}c[ad>>2]=aa;if((a[S]&1)!=0){Lw(c[U>>2]|0)}aa=(z=0,aM(c[(c[T>>2]|0)+20>>2]|0,E|0,q|0)|0);if(z){z=0;u=79;break}if((aa|0)==0){_=_+1|0}else{$=aa;u=86;break}}if((u|0)==67){z=0;ar(86,0);if(z){z=0;u=80;break}return 0}else if((u|0)==79){_=bT(-1,-1)|0;ah=M;ai=_;u=81;break}else if((u|0)==84){_=bT(-1,-1)|0;E=_;_=M;if((a[S]&1)==0){Q=E;R=_;break}Lw(c[U>>2]|0);Q=E;R=_;break}else if((u|0)==86){c[D>>2]=c[p>>2];g_(l|0,c[l+4>>2]|0);if(A){i=e;return $|0}Lw(c[V>>2]|0);i=e;return $|0}}}while(0);if((u|0)==80){A=bT(-1,-1)|0;ah=M;ai=A;u=81}if((u|0)==81){Q=ai;R=ah}g_(l|0,c[l+4>>2]|0);K=Q;L=R}else{z=0;u=38}}while(0);if((u|0)==38){u=bT(-1,-1)|0;K=u;L=M}if((a[j]&1)==0){aj=K;ak=0;al=aj;am=L;bg(al|0)}Lw(c[j+8>>2]|0);aj=K;ak=0;al=aj;am=L;bg(al|0);return 0}function i2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=c[b+32>>2]|0;e=c[b+28>>2]|0;b=e;f=d|0;g=d;d=a|0;while(1){a=cV[c[(c[g>>2]|0)+20>>2]&1023](f,d)|0;if(!(cD[c[(c[a>>2]|0)+36>>2]&511](a)|0)){h=0;i=5;break}a=cV[c[(c[b>>2]|0)+20>>2]&1023](e,d)|0;if((a|0)!=0){h=a;i=6;break}}if((i|0)==5){return h|0}else if((i|0)==6){return h|0}return 0}function i3(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;return cV[c[(c[d>>2]|0)+20>>2]&1023](d|0,a|0)|0}function i4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+176|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+128|0;p=e+144|0;q=e+160|0;r=c[d+28>>2]|0;s=cV[c[(c[r>>2]|0)+20>>2]&1023](r|0,b|0)|0;Bv(j,0);r=k;t=k;a[t]=18;LF(r+1|0,7624,9)|0;a[r+10|0]=0;z=0;aR(c[(c[s>>2]|0)+28>>2]|0,m|0,s|0,j|0);do{if(!z){z=0;as(180,l|0,m|0);if(z){z=0;s=bT(-1,-1)|0;r=s;s=M;if((a[m]&1)==0){u=r;v=s;break}Lw(c[m+8>>2]|0);u=r;v=s;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}s=(z=0,aM(814,42032,k|0)|0);do{if(!z){z=0,aM(814,s|0,l|0)|0;if(z){z=0;w=49;break}r=c[b+12>>2]|0;x=d+4|0;if((a[x]&1)==0){y=o;c[y>>2]=c[x>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2]}else{x=c[d+12>>2]|0;y=c[d+8>>2]|0;if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;w=49;break}return 0}if(y>>>0<11>>>0){a[o]=y<<1;A=o+1|0}else{B=y+16&-16;C=(z=0,au(248,B|0)|0);if(z){z=0;w=49;break}c[o+8>>2]=C;c[o>>2]=B|1;c[o+4>>2]=y;A=C}LF(A|0,x|0,y)|0;a[A+y|0]=0}y=d+16|0;x=h;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=p;a[y]=0;a[p+1|0]=0;z=0;aq(26,n|0,r|0,o|0,h|0,p|0);if(z){z=0;r=bT(-1,-1)|0;x=r;r=M;if((a[y]&1)!=0){Lw(c[p+8>>2]|0)}if((a[o]&1)==0){D=x;E=r;break}Lw(c[o+8>>2]|0);D=x;E=r;break}if((a[y]&1)!=0){Lw(c[p+8>>2]|0)}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}z=0;aR(60,q|0,n|0,1);L39:do{if(!z){z=0,aM(814,42032,q|0)|0;if(z){z=0;y=bT(-1,-1)|0;r=y;y=M;if((a[q]&1)==0){F=r;G=y;break}Lw(c[q+8>>2]|0);F=r;G=y;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}z=0;as(352,g|0,42032+(c[(c[10508]|0)-12>>2]|0)|0);if(z){z=0;w=54;break}y=(z=0,aM(198,g|0,41760)|0);do{if(!z){r=(z=0,aM(c[(c[y>>2]|0)+28>>2]|0,y|0,10)|0);if(z){z=0;break}z=0;ar(394,g|0);if(z){z=0;w=54;break L39}z=0,aM(242,42032,r|0)|0;if(z){z=0;w=54;break L39}z=0,au(62,42032)|0;if(z){z=0;w=54;break L39}z=0;as(352,f|0,42032+(c[(c[10508]|0)-12>>2]|0)|0);if(z){z=0;w=54;break L39}r=(z=0,aM(198,f|0,41760)|0);do{if(!z){x=(z=0,aM(c[(c[r>>2]|0)+28>>2]|0,r|0,10)|0);if(z){z=0;break}z=0;ar(394,f|0);if(z){z=0;w=54;break L39}z=0,aM(242,42032,x|0)|0;if(z){z=0;w=54;break L39}z=0,au(62,42032)|0;if(z){z=0;w=54;break L39}if((a[n+28|0]&1)!=0){Lw(c[n+36>>2]|0)}if((a[n+4|0]&1)!=0){Lw(c[n+12>>2]|0)}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}if((a[t]&1)==0){Bx(j);i=e;return 0}Lw(c[k+8>>2]|0);Bx(j);i=e;return 0}else{z=0}}while(0);r=bT(-1,-1)|0;x=M;z=0;ar(394,f|0);if(!z){H=x;I=r;w=55;break L39}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0}}while(0);y=bT(-1,-1)|0;r=M;z=0;ar(394,g|0);if(!z){H=r;I=y;w=55;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;w=54}}while(0);if((w|0)==54){y=bT(-1,-1)|0;H=M;I=y;w=55}if((w|0)==55){F=I;G=H}if((a[n+28|0]&1)!=0){Lw(c[n+36>>2]|0)}if((a[n+4|0]&1)==0){D=F;E=G;break}Lw(c[n+12>>2]|0);D=F;E=G}else{z=0;w=49}}while(0);if((w|0)==49){s=bT(-1,-1)|0;D=s;E=M}if((a[l]&1)==0){u=D;v=E;break}Lw(c[l+8>>2]|0);u=D;v=E}else{z=0;s=bT(-1,-1)|0;u=s;v=M}}while(0);if((a[t]&1)!=0){Lw(c[k+8>>2]|0)}z=0;ar(444,j|0);if(!z){bg(u|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function i5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+48|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=c[b+4>>2]|0;l=Lu(60)|0;c[h>>2]=l;m=k+4|0;n=c[m>>2]|0;if((n|0)==(c[k+8>>2]|0)){e4(k|0,h);o=c[h>>2]|0}else{if((n|0)==0){p=0}else{c[n>>2]=l;p=c[m>>2]|0}c[m>>2]=p+4;o=l}l=o;p=d+4|0;L8:do{if((a[p]&1)==0){n=j;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];q=16}else{n=c[d+12>>2]|0;h=c[d+8>>2]|0;do{if(h>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;r=j+1|0}else{s=h+16&-16;t=(z=0,au(248,s|0)|0);if(z){z=0;break}c[j+8>>2]=t;c[j>>2]=s|1;c[j+4>>2]=h;r=t}LF(r|0,n|0,h)|0;a[r+h|0]=0;q=16;break L8}}while(0);h=bT(-1,-1)|0;u=h;v=M}}while(0);do{if((q|0)==16){r=d+16|0;p=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];r=d+44|0;p=d+40|0;z=0;aD(36,o|0,j|0,g|0,(c[r>>2]|0)-(c[p>>2]|0)>>2|0,c[d+52>>2]|0,(a[d+56|0]&1)!=0|0);if(z){z=0;h=bT(-1,-1)|0;n=h;h=M;if((a[j]&1)==0){u=n;v=h;break}Lw(c[j+8>>2]|0);u=n;v=h;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}h=c[p>>2]|0;n=(c[r>>2]|0)-h>>2;if((n|0)==0){w=o;i=e;return w|0}r=o+36|0;t=r;s=b|0;x=r+8|0;y=x;A=r+12|0;B=r+4|0;C=r;r=0;D=h;while(1){h=c[D+(r<<2)>>2]|0;E=cV[c[(c[h>>2]|0)+20>>2]&1023](h|0,s)|0;c[f>>2]=E;h=c[y>>2]|0;if((h|0)==(c[A>>2]|0)){fq(B,f);F=c[f>>2]|0}else{if((h|0)==0){G=0}else{c[h>>2]=E;G=c[y>>2]|0}c[x>>2]=G+4;F=E}cB[c[c[C>>2]>>2]&1023](t,F);E=r+1|0;if(E>>>0>=n>>>0){break}r=E;D=c[p>>2]|0}w=o;i=e;return w|0}}while(0);w=c[k>>2]|0;k=c[m>>2]|0;e=w;while(1){if((e|0)==(k|0)){H=k;break}if((c[e>>2]|0)==(o|0)){H=e;break}else{e=e+4|0}}e=H-w>>2;H=w+(e+1<<2)|0;o=k-H|0;LG(w+(e<<2)|0,H|0,o|0)|0;H=w+((o>>2)+e<<2)|0;e=c[m>>2]|0;if((H|0)==(e|0)){Lw(l);I=u;J=0;K=I;L=v;bg(K|0)}c[m>>2]=e+(~((e-4+(-H|0)|0)>>>2)<<2);Lw(l);I=u;J=0;K=I;L=v;bg(K|0);return 0}function i6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,as=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0;e=i;i=i+240|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=e+48|0;n=e+64|0;o=e+80|0;p=e+96|0;q=e+112|0;r=e+128|0;s=e+144|0;t=e+160|0;u=e+176|0;v=e+192|0;w=e+208|0;x=e+224|0;y=c[d+36>>2]|0;L1:do{if((y|0)==11){if((a[d+28|0]&1)==0){A=c[d+40>>2]|0;B=b|0;C=cV[c[(c[A>>2]|0)+20>>2]&1023](A|0,B)|0;A=c[d+44>>2]|0;D=C;E=cV[c[(c[A>>2]|0)+20>>2]&1023](A|0,B)|0;break}else{F=d|0;i=e;return F|0}}else{B=c[d+40>>2]|0;A=b|0;C=cV[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;if((y|0)==0){if(!(cD[c[(c[C>>2]|0)+36>>2]&511](C)|0)){F=C;i=e;return F|0}B=c[d+44>>2]|0;F=cV[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;i=e;return F|0}else if((y|0)==1){if(cD[c[(c[C>>2]|0)+36>>2]&511](C)|0){F=C;i=e;return F|0}B=c[d+44>>2]|0;F=cV[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;i=e;return F|0}else{B=c[d+44>>2]|0;G=cV[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;switch(y|0){case 4:{A=b+4|0;B=c[A>>2]|0;H=Lu(40)|0;c[j>>2]=H;I=B+4|0;J=c[I>>2]|0;if((J|0)==(c[B+8>>2]|0)){e4(B|0,j);K=c[j>>2]|0}else{if((J|0)==0){L=0}else{c[J>>2]=H;L=c[I>>2]|0}c[I>>2]=L+4;K=H}H=K;J=K;N=d+4|0;L23:do{if((a[N]&1)==0){O=q;c[O>>2]=c[N>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];P=81}else{O=c[d+12>>2]|0;Q=c[d+8>>2]|0;do{if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(Q>>>0<11>>>0){a[q]=Q<<1;R=q+1|0}else{S=Q+16&-16;T=(z=0,au(248,S|0)|0);if(z){z=0;break}c[q+8>>2]=T;c[q>>2]=S|1;c[q+4>>2]=Q;R=T}LF(R|0,O|0,Q)|0;a[R+Q|0]=0;P=81;break L23}}while(0);Q=bT(-1,-1)|0;U=Q;V=M}}while(0);do{if((P|0)==81){N=r;Q=d+16|0;c[N>>2]=c[Q>>2];c[N+4>>2]=c[Q+4>>2];c[N+8>>2]=c[Q+8>>2];Q=(z=0,az(36,C|0,G|0,0)|0);do{if(!z){if(Q){W=0}else{N=(z=0,az(26,C|0,G|0,c[A>>2]|0)|0);if(z){z=0;break}W=N^1}z=0;aV(4,J|0,q|0,r|0,W|0);if(z){z=0;break}N=K;if((a[q]&1)==0){F=N;i=e;return F|0}Lw(c[q+8>>2]|0);F=N;i=e;return F|0}else{z=0}}while(0);Q=bT(-1,-1)|0;N=Q;Q=M;if((a[q]&1)==0){U=N;V=Q;break}Lw(c[q+8>>2]|0);U=N;V=Q}}while(0);J=c[B>>2]|0;A=c[I>>2]|0;Q=J;while(1){if((Q|0)==(A|0)){X=A;break}if((c[Q>>2]|0)==(K|0)){X=Q;break}else{Q=Q+4|0}}Q=X-J>>2;B=J+(Q+1<<2)|0;N=A-B|0;LG(J+(Q<<2)|0,B|0,N|0)|0;B=J+((N>>2)+Q<<2)|0;Q=c[I>>2]|0;if((B|0)!=(Q|0)){c[I>>2]=Q+(~((Q-4+(-B|0)|0)>>>2)<<2)}Lw(H);Y=U;Z=V;_=Y;$=0;aa=_;ab=Z;bg(aa|0);break};case 6:{B=c[b+4>>2]|0;Q=Lu(40)|0;c[g>>2]=Q;N=B+4|0;O=c[N>>2]|0;if((O|0)==(c[B+8>>2]|0)){e4(B|0,g);ac=c[g>>2]|0}else{if((O|0)==0){ad=0}else{c[O>>2]=Q;ad=c[N>>2]|0}c[N>>2]=ad+4;ac=Q}Q=ac;O=ac;T=d+4|0;L68:do{if((a[T]&1)==0){S=u;c[S>>2]=c[T>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];P=140}else{S=c[d+12>>2]|0;ae=c[d+8>>2]|0;do{if(ae>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ae>>>0<11>>>0){a[u]=ae<<1;af=u+1|0}else{ag=ae+16&-16;ah=(z=0,au(248,ag|0)|0);if(z){z=0;break}c[u+8>>2]=ah;c[u>>2]=ag|1;c[u+4>>2]=ae;af=ah}LF(af|0,S|0,ae)|0;a[af+ae|0]=0;P=140;break L68}}while(0);ae=bT(-1,-1)|0;ai=ae;aj=M}}while(0);do{if((P|0)==140){T=v;H=d+16|0;c[T>>2]=c[H>>2];c[T+4>>2]=c[H+4>>2];c[T+8>>2]=c[H+8>>2];H=(z=0,az(36,C|0,G|0,0)|0);do{if(!z){z=0;aV(4,O|0,u|0,v|0,H|0);if(z){z=0;break}T=ac;if((a[u]&1)==0){F=T;i=e;return F|0}Lw(c[u+8>>2]|0);F=T;i=e;return F|0}else{z=0}}while(0);H=bT(-1,-1)|0;T=H;H=M;if((a[u]&1)==0){ai=T;aj=H;break}Lw(c[u+8>>2]|0);ai=T;aj=H}}while(0);O=c[B>>2]|0;H=c[N>>2]|0;T=O;while(1){if((T|0)==(H|0)){ak=H;break}if((c[T>>2]|0)==(ac|0)){ak=T;break}else{T=T+4|0}}T=ak-O>>2;B=O+(T+1<<2)|0;I=H-B|0;LG(O+(T<<2)|0,B|0,I|0)|0;B=O+((I>>2)+T<<2)|0;T=c[N>>2]|0;if((B|0)!=(T|0)){c[N>>2]=T+(~((T-4+(-B|0)|0)>>>2)<<2)}Lw(Q);Y=ai;Z=aj;_=Y;$=0;aa=_;ab=Z;bg(aa|0);break};case 3:{B=b+4|0;T=c[B>>2]|0;I=Lu(40)|0;c[k>>2]=I;J=T+4|0;A=c[J>>2]|0;if((A|0)==(c[T+8>>2]|0)){e4(T|0,k);al=c[k>>2]|0}else{if((A|0)==0){am=0}else{c[A>>2]=I;am=c[J>>2]|0}c[J>>2]=am+4;al=I}I=al;A=al;ae=d+4|0;L109:do{if((a[ae]&1)==0){S=o;c[S>>2]=c[ae>>2];c[S+4>>2]=c[ae+4>>2];c[S+8>>2]=c[ae+8>>2];P=53}else{S=c[d+12>>2]|0;ah=c[d+8>>2]|0;do{if(ah>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ah>>>0<11>>>0){a[o]=ah<<1;an=o+1|0}else{ag=ah+16&-16;ao=(z=0,au(248,ag|0)|0);if(z){z=0;break}c[o+8>>2]=ao;c[o>>2]=ag|1;c[o+4>>2]=ah;an=ao}LF(an|0,S|0,ah)|0;a[an+ah|0]=0;P=53;break L109}}while(0);ah=bT(-1,-1)|0;ap=ah;aq=M}}while(0);do{if((P|0)==53){ae=p;Q=d+16|0;c[ae>>2]=c[Q>>2];c[ae+4>>2]=c[Q+4>>2];c[ae+8>>2]=c[Q+8>>2];Q=(z=0,az(26,C|0,G|0,c[B>>2]|0)|0);do{if(!z){z=0;aV(4,A|0,o|0,p|0,Q^1|0);if(z){z=0;break}ae=al;if((a[o]&1)==0){F=ae;i=e;return F|0}Lw(c[o+8>>2]|0);F=ae;i=e;return F|0}else{z=0}}while(0);Q=bT(-1,-1)|0;ae=Q;Q=M;if((a[o]&1)==0){ap=ae;aq=Q;break}Lw(c[o+8>>2]|0);ap=ae;aq=Q}}while(0);A=c[T>>2]|0;B=c[J>>2]|0;Q=A;while(1){if((Q|0)==(B|0)){as=B;break}if((c[Q>>2]|0)==(al|0)){as=Q;break}else{Q=Q+4|0}}Q=as-A>>2;T=A+(Q+1<<2)|0;ae=B-T|0;LG(A+(Q<<2)|0,T|0,ae|0)|0;T=A+((ae>>2)+Q<<2)|0;Q=c[J>>2]|0;if((T|0)!=(Q|0)){c[J>>2]=Q+(~((Q-4+(-T|0)|0)>>>2)<<2)}Lw(I);Y=ap;Z=aq;_=Y;$=0;aa=_;ab=Z;bg(aa|0);break};case 5:{T=c[b+4>>2]|0;Q=Lu(40)|0;c[h>>2]=Q;ae=T+4|0;N=c[ae>>2]|0;if((N|0)==(c[T+8>>2]|0)){e4(T|0,h);at=c[h>>2]|0}else{if((N|0)==0){av=0}else{c[N>>2]=Q;av=c[ae>>2]|0}c[ae>>2]=av+4;at=Q}Q=at;N=at;O=d+4|0;L150:do{if((a[O]&1)==0){H=s;c[H>>2]=c[O>>2];c[H+4>>2]=c[O+4>>2];c[H+8>>2]=c[O+8>>2];P=112}else{H=c[d+12>>2]|0;ah=c[d+8>>2]|0;do{if(ah>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ah>>>0<11>>>0){a[s]=ah<<1;aw=s+1|0}else{S=ah+16&-16;ao=(z=0,au(248,S|0)|0);if(z){z=0;break}c[s+8>>2]=ao;c[s>>2]=S|1;c[s+4>>2]=ah;aw=ao}LF(aw|0,H|0,ah)|0;a[aw+ah|0]=0;P=112;break L150}}while(0);ah=bT(-1,-1)|0;ax=ah;ay=M}}while(0);do{if((P|0)==112){O=t;I=d+16|0;c[O>>2]=c[I>>2];c[O+4>>2]=c[I+4>>2];c[O+8>>2]=c[I+8>>2];I=(z=0,az(36,C|0,G|0,0)|0);do{if(!z){z=0;aV(4,N|0,s|0,t|0,I^1|0);if(z){z=0;break}O=at;if((a[s]&1)==0){F=O;i=e;return F|0}Lw(c[s+8>>2]|0);F=O;i=e;return F|0}else{z=0}}while(0);I=bT(-1,-1)|0;O=I;I=M;if((a[s]&1)==0){ax=O;ay=I;break}Lw(c[s+8>>2]|0);ax=O;ay=I}}while(0);N=c[T>>2]|0;I=c[ae>>2]|0;O=N;while(1){if((O|0)==(I|0)){aA=I;break}if((c[O>>2]|0)==(at|0)){aA=O;break}else{O=O+4|0}}O=aA-N>>2;T=N+(O+1<<2)|0;J=I-T|0;LG(N+(O<<2)|0,T|0,J|0)|0;T=N+((J>>2)+O<<2)|0;O=c[ae>>2]|0;if((T|0)!=(O|0)){c[ae>>2]=O+(~((O-4+(-T|0)|0)>>>2)<<2)}Lw(Q);Y=ax;Z=ay;_=Y;$=0;aa=_;ab=Z;bg(aa|0);break};case 2:{T=b+4|0;O=c[T>>2]|0;J=Lu(40)|0;c[l>>2]=J;A=O+4|0;B=c[A>>2]|0;if((B|0)==(c[O+8>>2]|0)){e4(O|0,l);aB=c[l>>2]|0}else{if((B|0)==0){aC=0}else{c[B>>2]=J;aC=c[A>>2]|0}c[A>>2]=aC+4;aB=J}J=aB;B=aB;ah=d+4|0;L191:do{if((a[ah]&1)==0){H=m;c[H>>2]=c[ah>>2];c[H+4>>2]=c[ah+4>>2];c[H+8>>2]=c[ah+8>>2];P=25}else{H=c[d+12>>2]|0;ao=c[d+8>>2]|0;do{if(ao>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ao>>>0<11>>>0){a[m]=ao<<1;aD=m+1|0}else{S=ao+16&-16;ag=(z=0,au(248,S|0)|0);if(z){z=0;break}c[m+8>>2]=ag;c[m>>2]=S|1;c[m+4>>2]=ao;aD=ag}LF(aD|0,H|0,ao)|0;a[aD+ao|0]=0;P=25;break L191}}while(0);ao=bT(-1,-1)|0;aE=ao;aF=M}}while(0);do{if((P|0)==25){ah=n;Q=d+16|0;c[ah>>2]=c[Q>>2];c[ah+4>>2]=c[Q+4>>2];c[ah+8>>2]=c[Q+8>>2];Q=(z=0,az(26,C|0,G|0,c[T>>2]|0)|0);do{if(!z){z=0;aV(4,B|0,m|0,n|0,Q|0);if(z){z=0;break}ah=aB;if((a[m]&1)==0){F=ah;i=e;return F|0}Lw(c[m+8>>2]|0);F=ah;i=e;return F|0}else{z=0}}while(0);Q=bT(-1,-1)|0;ah=Q;Q=M;if((a[m]&1)==0){aE=ah;aF=Q;break}Lw(c[m+8>>2]|0);aE=ah;aF=Q}}while(0);B=c[O>>2]|0;T=c[A>>2]|0;Q=B;while(1){if((Q|0)==(T|0)){aG=T;break}if((c[Q>>2]|0)==(aB|0)){aG=Q;break}else{Q=Q+4|0}}Q=aG-B>>2;O=B+(Q+1<<2)|0;ah=T-O|0;LG(B+(Q<<2)|0,O|0,ah|0)|0;O=B+((ah>>2)+Q<<2)|0;Q=c[A>>2]|0;if((O|0)!=(Q|0)){c[A>>2]=Q+(~((Q-4+(-O|0)|0)>>>2)<<2)}Lw(J);Y=aE;Z=aF;_=Y;$=0;aa=_;ab=Z;bg(aa|0);break};case 7:{O=b+4|0;Q=c[O>>2]|0;ah=Lu(40)|0;c[f>>2]=ah;ae=Q+4|0;N=c[ae>>2]|0;if((N|0)==(c[Q+8>>2]|0)){e4(Q|0,f);aH=c[f>>2]|0}else{if((N|0)==0){aI=0}else{c[N>>2]=ah;aI=c[ae>>2]|0}c[ae>>2]=aI+4;aH=ah}ah=aH;N=aH;I=d+4|0;L232:do{if((a[I]&1)==0){ao=w;c[ao>>2]=c[I>>2];c[ao+4>>2]=c[I+4>>2];c[ao+8>>2]=c[I+8>>2];P=168}else{ao=c[d+12>>2]|0;H=c[d+8>>2]|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(H>>>0<11>>>0){a[w]=H<<1;aJ=w+1|0}else{ag=H+16&-16;S=(z=0,au(248,ag|0)|0);if(z){z=0;break}c[w+8>>2]=S;c[w>>2]=ag|1;c[w+4>>2]=H;aJ=S}LF(aJ|0,ao|0,H)|0;a[aJ+H|0]=0;P=168;break L232}}while(0);H=bT(-1,-1)|0;aK=H;aL=M}}while(0);do{if((P|0)==168){I=x;J=d+16|0;c[I>>2]=c[J>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];J=(z=0,az(36,C|0,G|0,0)|0);do{if(!z){if(J){aM=1}else{I=(z=0,az(26,C|0,G|0,c[O>>2]|0)|0);if(!z){aM=I}else{z=0;break}}z=0;aV(4,N|0,w|0,x|0,aM|0);if(z){z=0;break}I=aH;if((a[w]&1)==0){F=I;i=e;return F|0}Lw(c[w+8>>2]|0);F=I;i=e;return F|0}else{z=0}}while(0);J=bT(-1,-1)|0;I=J;J=M;if((a[w]&1)==0){aK=I;aL=J;break}Lw(c[w+8>>2]|0);aK=I;aL=J}}while(0);N=c[Q>>2]|0;O=c[ae>>2]|0;J=N;while(1){if((J|0)==(O|0)){aN=O;break}if((c[J>>2]|0)==(aH|0)){aN=J;break}else{J=J+4|0}}J=aN-N>>2;Q=N+(J+1<<2)|0;I=O-Q|0;LG(N+(J<<2)|0,Q|0,I|0)|0;Q=N+((I>>2)+J<<2)|0;J=c[ae>>2]|0;if((Q|0)!=(J|0)){c[ae>>2]=J+(~((J-4+(-Q|0)|0)>>>2)<<2)}Lw(ah);Y=aK;Z=aL;_=Y;$=0;aa=_;ab=Z;bg(aa|0);break};default:{D=C;E=G;break L1}}}}}while(0);aa=c[D+32>>2]|0;Z=c[E+32>>2]|0;ab=(aa|0)==2;_=(Z|0)==2;if(ab&_){F=ja(c[b+4>>2]|0,d,D,E)|0;i=e;return F|0}d=(Z|0)==3;if(ab&d){F=jb(c[b+4>>2]|0,y,D,E)|0;i=e;return F|0}ab=(aa|0)==3;if(ab&_){F=jc(c[b+4>>2]|0,y,D,E)|0;i=e;return F|0}_=c[b+4>>2]|0;if(ab&d){F=jd(_,y,D,E)|0;i=e;return F|0}else{F=je(_,y,D,E)|0;i=e;return F|0}return 0}function i7(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;LF(k|0,e|0,12)|0;e=h;l=j;m=b|0;n=d;if((a[n]&1)==0){c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){D5(0)}if(o>>>0<11>>>0){a[e]=o<<1;p=h+1|0}else{d=o+16&-16;q=Lu(d)|0;c[h+8>>2]=q;c[h>>2]=d|1;c[h+4>>2]=o;p=q}LF(p|0,n|0,o)|0;a[p+o|0]=0}c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];z=0;aD(6,m|0,h|0,j|0,0,0,0);if(!z){if((a[e]&1)==0){r=b|0;c[r>>2]=18192;s=b+36|0;t=f&1;a[s]=t;u=b+32|0;c[u>>2]=1;i=g;return}Lw(c[h+8>>2]|0);r=b|0;c[r>>2]=18192;s=b+36|0;t=f&1;a[s]=t;u=b+32|0;c[u>>2]=1;i=g;return}else{z=0;g=bT(-1,-1)|0;if((a[e]&1)==0){bg(g|0)}Lw(c[h+8>>2]|0);bg(g|0)}}function i8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;f=i;i=i+184|0;g=f|0;j=f+72|0;k=f+88|0;l=f+104|0;m=f+120|0;n=f+136|0;o=f+152|0;p=f+168|0;q=c[b+32>>2]|0;if((q|0)!=(c[d+32>>2]|0)){r=0;i=f;return r|0}switch(q|0){case 2:{q=b;lG(g,d);z=0;as(328,j|0,q|0);do{if(!z){z=0;as(774,g|0,j|0);if(z){z=0;s=bT(-1,-1)|0;t=s;s=M;if((a[j]&1)==0){u=s;v=t;break}Lw(c[j+8>>2]|0);u=s;v=t;break}if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}z=0;as(248,k|0,q|0);if(z){z=0;w=35;break}z=0;as(248,l|0,g|0);if(z){z=0;t=bT(-1,-1)|0;s=t;t=M;if((a[k]&1)==0){u=t;v=s;break}Lw(c[k+8>>2]|0);u=t;v=s;break}s=k;t=a[k]|0;x=t&255;if((x&1|0)==0){y=x>>>1}else{y=c[k+4>>2]|0}x=l;A=a[l]|0;B=A&255;if((B&1|0)==0){C=B>>>1}else{C=c[l+4>>2]|0}L28:do{if((y|0)==(C|0)){B=(t&1)==0;if(B){D=s+1|0}else{D=c[k+8>>2]|0}E=A&1;if(E<<24>>24==0){F=x+1|0}else{F=c[l+8>>2]|0}do{if(B){if((y|0)==0){break}else{G=F;H=D;I=y}while(1){if((a[H]|0)!=(a[G]|0)){J=0;K=E;break L28}L=I-1|0;if((L|0)==0){break}else{G=G+1|0;H=H+1|0;I=L}}}else{if((LH(D|0,F|0,y|0)|0)!=0){J=0;K=E;break L28}}}while(0);J=+h[b+40>>3]==+h[g+40>>3];K=E}else{J=0;K=A&1}}while(0);if(K<<24>>24!=0){Lw(c[l+8>>2]|0)}if((t&1)!=0){Lw(c[k+8>>2]|0)}ke(g);r=J;i=f;return r|0}else{z=0;w=35}}while(0);if((w|0)==35){J=bT(-1,-1)|0;u=M;v=J}z=0;ar(494,g|0);if(!z){N=u;O=v;P=O;Q=0;R=P;S=N;bg(R|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}break};case 1:{r=(a[b+36|0]&1)!=0^(a[d+36|0]&1)!=0^1;i=f;return r|0};case 3:{if(+h[b+40>>3]!=+h[d+40>>3]){r=0;i=f;return r|0}if(+h[b+48>>3]!=+h[d+48>>3]){r=0;i=f;return r|0}if(+h[b+56>>3]!=+h[d+56>>3]){r=0;i=f;return r|0}r=+h[b+64>>3]==+h[d+64>>3];i=f;return r|0};case 4:{v=b+40|0;if((a[v]&1)==0){u=n;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2]}else{v=c[b+48>>2]|0;u=c[b+44>>2]|0;if(u>>>0>4294967279>>>0){D5(0);return 0}if(u>>>0<11>>>0){a[n]=u<<1;T=n+1|0}else{g=u+16&-16;J=Lu(g)|0;c[n+8>>2]=J;c[n>>2]=g|1;c[n+4>>2]=u;T=J}LF(T|0,v|0,u)|0;a[T+u|0]=0}z=0;as(180,m|0,n|0);do{if(!z){u=d+40|0;L87:do{if((a[u]&1)==0){T=p;c[T>>2]=c[u>>2];c[T+4>>2]=c[u+4>>2];c[T+8>>2]=c[u+8>>2];w=64}else{T=c[d+48>>2]|0;v=c[d+44>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(v>>>0<11>>>0){a[p]=v<<1;U=p+1|0}else{J=v+16&-16;g=(z=0,au(248,J|0)|0);if(z){z=0;break}c[p+8>>2]=g;c[p>>2]=J|1;c[p+4>>2]=v;U=g}LF(U|0,T|0,v)|0;a[U+v|0]=0;w=64;break L87}}while(0);v=bT(-1,-1)|0;V=M;W=v}}while(0);do{if((w|0)==64){z=0;as(180,o|0,p|0);if(z){z=0;u=bT(-1,-1)|0;t=u;u=M;if((a[p]&1)==0){V=u;W=t;break}Lw(c[p+8>>2]|0);V=u;W=t;break}t=m;u=m;v=a[u]|0;T=v&255;if((T&1|0)==0){X=T>>>1}else{X=c[m+4>>2]|0}T=o;E=a[o]|0;g=E&255;if((g&1|0)==0){Y=g>>>1}else{Y=c[o+4>>2]|0}L114:do{if((X|0)==(Y|0)){g=(v&1)==0;if(g){Z=t+1|0}else{Z=c[m+8>>2]|0}J=E&1;if(J<<24>>24==0){_=T+1|0}else{_=c[o+8>>2]|0}if(!g){$=(LH(Z|0,_|0,X|0)|0)==0;aa=J;break}if((X|0)==0){$=1;aa=J;break}else{ab=_;ac=Z;ad=X}while(1){if((a[ac]|0)!=(a[ab]|0)){$=0;aa=J;break L114}g=ad-1|0;if((g|0)==0){$=1;aa=J;break}else{ab=ab+1|0;ac=ac+1|0;ad=g}}}else{$=0;aa=E&1}}while(0);if(aa<<24>>24!=0){Lw(c[o+8>>2]|0)}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if((a[u]&1)!=0){Lw(c[m+8>>2]|0)}if((a[n]&1)==0){r=$;i=f;return r|0}Lw(c[n+8>>2]|0);r=$;i=f;return r|0}}while(0);if((a[m]&1)==0){ae=V;af=W;break}Lw(c[m+8>>2]|0);ae=V;af=W}else{z=0;E=bT(-1,-1)|0;ae=M;af=E}}while(0);if((a[n]&1)==0){N=ae;O=af;P=O;Q=0;R=P;S=N;bg(R|0)}Lw(c[n+8>>2]|0);N=ae;O=af;P=O;Q=0;R=P;S=N;bg(R|0);break};case 6:{r=1;i=f;return r|0};case 5:{R=b+40|0;N=(c[b+44>>2]|0)-(c[R>>2]|0)>>2;S=d+40|0;if((N|0)!=((c[d+44>>2]|0)-(c[S>>2]|0)>>2|0)){r=0;i=f;return r|0}if((c[b+52>>2]|0)==(c[d+52>>2]|0)){ag=0}else{r=0;i=f;return r|0}while(1){if(ag>>>0>=N>>>0){r=1;w=115;break}if(i8(c[(c[R>>2]|0)+(ag<<2)>>2]|0,c[(c[S>>2]|0)+(ag<<2)>>2]|0,e)|0){ag=ag+1|0}else{r=0;w=116;break}}if((w|0)==115){i=f;return r|0}else if((w|0)==116){i=f;return r|0}break};default:{r=0;i=f;return r|0}}return 0}function i9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;e=i;i=i+248|0;f=e|0;g=e+16|0;j=e+32|0;k=e+48|0;l=e+120|0;m=e+136|0;n=e+152|0;o=e+168|0;p=e+184|0;q=e+200|0;r=e+216|0;s=e+232|0;if((c[b+32>>2]|0)==2){if((c[d+32>>2]|0)!=2){t=3}}else{t=3}L3:do{if((t|0)==3){u=Lu(32)|0;v=f+8|0;c[v>>2]=u;c[f>>2]=33;c[f+4>>2]=24;LF(u|0,10528,24)|0;a[u+24|0]=0;u=b+4|0;L5:do{if((a[u]&1)==0){w=g;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];t=13}else{w=c[b+12>>2]|0;x=c[b+8>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[g]=x<<1;y=g+1|0}else{A=x+16&-16;B=(z=0,au(248,A|0)|0);if(z){z=0;break}c[g+8>>2]=B;c[g>>2]=A|1;c[g+4>>2]=x;y=B}LF(y|0,w|0,x)|0;a[y+x|0]=0;t=13;break L5}}while(0);x=bT(-1,-1)|0;C=M;D=x}}while(0);do{if((t|0)==13){u=j;x=b+16|0;c[u>>2]=c[x>>2];c[u+4>>2]=c[x+4>>2];c[u+8>>2]=c[x+8>>2];z=0;aR(382,f|0,g|0,j|0);if(z){z=0;x=bT(-1,-1)|0;u=x;x=M;if((a[g]&1)==0){C=x;D=u;break}Lw(c[g+8>>2]|0);C=x;D=u;break}if((a[g]&1)!=0){Lw(c[g+8>>2]|0)}if((a[f]&1)==0){break L3}Lw(c[v>>2]|0);break L3}}while(0);if((a[f]&1)==0){E=C;F=D;G=F;H=0;I=G;J=E;bg(I|0)}Lw(c[v>>2]|0);E=C;F=D;G=F;H=0;I=G;J=E;bg(I|0)}}while(0);D=b;lG(k,d);z=0;as(328,l|0,D|0);do{if(!z){z=0;as(774,k|0,l|0);if(z){z=0;d=bT(-1,-1)|0;C=d;d=M;if((a[l]&1)==0){K=d;L=C;break}Lw(c[l+8>>2]|0);K=d;L=C;break}if((a[l]&1)!=0){Lw(c[l+8>>2]|0)}z=0;as(248,m|0,D|0);if(z){z=0;t=79;break}z=0;as(248,n|0,k|0);L44:do{if(!z){C=a[m]|0;d=C&255;if((d&1|0)==0){N=d>>>1}else{N=c[m+4>>2]|0}d=a[n]|0;L50:do{if((N|0)!=0){f=d&255;if((f&1|0)==0){O=f>>>1}else{O=c[n+4>>2]|0}if((O|0)==0){break}z=0;as(248,o|0,D|0);do{if(!z){z=0;as(248,p|0,k|0);if(z){z=0;f=bT(-1,-1)|0;g=f;f=M;if((a[o]&1)==0){P=f;Q=g;break}Lw(c[o+8>>2]|0);P=f;Q=g;break}g=o;f=a[o]|0;j=f&255;if((j&1|0)==0){R=j>>>1}else{R=c[o+4>>2]|0}j=p;y=a[p]|0;u=y&255;if((u&1|0)==0){S=u>>>1}else{S=c[p+4>>2]|0}L71:do{if((R|0)==(S|0)){u=(f&1)==0;if(u){T=g+1|0}else{T=c[o+8>>2]|0}x=y&1;if(x<<24>>24==0){U=j+1|0}else{U=c[p+8>>2]|0}if(!u){V=(LH(T|0,U|0,R|0)|0)!=0;W=x;break}if((R|0)==0){V=0;W=x;break}else{X=U;Y=T;Z=R}while(1){if((a[Y]|0)!=(a[X]|0)){V=1;W=x;break L71}u=Z-1|0;if((u|0)==0){V=0;W=x;break}else{X=X+1|0;Y=Y+1|0;Z=u}}}else{V=1;W=y&1}}while(0);if(W<<24>>24!=0){Lw(c[p+8>>2]|0)}if((f&1)==0){if(!V){break L50}}else{Lw(c[o+8>>2]|0);if(!V){break L50}}y=(z=0,au(248,48)|0);if(z){z=0;t=83;break}j=q+8|0;c[j>>2]=y;c[q>>2]=49;c[q+4>>2]=46;LF(y|0,10336,46)|0;a[y+46|0]=0;y=b+4|0;L97:do{if((a[y]&1)==0){g=r;c[g>>2]=c[y>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];t=74}else{g=c[b+12>>2]|0;x=c[b+8>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[r]=x<<1;_=r+1|0}else{u=x+16&-16;w=(z=0,au(248,u|0)|0);if(z){z=0;break}c[r+8>>2]=w;c[r>>2]=u|1;c[r+4>>2]=x;_=w}LF(_|0,g|0,x)|0;a[_+x|0]=0;t=74;break L97}}while(0);x=bT(-1,-1)|0;$=M;aa=x}}while(0);do{if((t|0)==74){y=s;f=b+16|0;c[y>>2]=c[f>>2];c[y+4>>2]=c[f+4>>2];c[y+8>>2]=c[f+8>>2];z=0;aR(382,q|0,r|0,s|0);if(z){z=0;f=bT(-1,-1)|0;y=f;f=M;if((a[r]&1)==0){$=f;aa=y;break}Lw(c[r+8>>2]|0);$=f;aa=y;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}if((a[q]&1)==0){break L50}Lw(c[j>>2]|0);break L50}}while(0);if((a[q]&1)==0){P=$;Q=aa;break}Lw(c[j>>2]|0);P=$;Q=aa}else{z=0;t=83}}while(0);if((t|0)==83){y=bT(-1,-1)|0;P=M;Q=y}if((d&1)==0){ab=P;ac=Q;ad=C;break L44}Lw(c[n+8>>2]|0);ab=P;ac=Q;ad=C;break L44}}while(0);y=+h[b+40>>3]<+h[k+40>>3];if((d&1)!=0){Lw(c[n+8>>2]|0)}if((C&1)==0){ke(k);i=e;return y|0}Lw(c[m+8>>2]|0);ke(k);i=e;return y|0}else{z=0;y=bT(-1,-1)|0;ab=M;ac=y;ad=a[m]|0}}while(0);if((ad&1)==0){K=ab;L=ac;break}Lw(c[m+8>>2]|0);K=ab;L=ac}else{z=0;t=79}}while(0);if((t|0)==79){t=bT(-1,-1)|0;K=M;L=t}z=0;ar(494,k|0);if(!z){E=K;F=L;G=F;H=0;I=G;J=E;bg(I|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function ja(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0.0,aB=0,aC=0,aD=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0;g=i;i=i+280|0;j=g|0;k=g+8|0;l=g+24|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+168|0;s=g+184|0;t=g+200|0;u=g+216|0;v=g+232|0;w=g+248|0;x=g+264|0;y=e;A=f;B=+h[e+40>>3];C=+h[f+40>>3];D=c[d+36>>2]|0;E=(D|0)==11;F=C!=0.0;if(!(F|E^1)){G=Lu(52)|0;c[l>>2]=G;H=b+4|0;I=c[H>>2]|0;if((I|0)==(c[b+8>>2]|0)){e4(b|0,l);J=c[l>>2]|0}else{if((I|0)==0){K=0}else{c[I>>2]=G;K=c[H>>2]|0}c[H>>2]=K+4;J=G}G=J;K=e+4|0;L10:do{if((a[K]&1)==0){I=m;c[I>>2]=c[K>>2];c[I+4>>2]=c[K+4>>2];c[I+8>>2]=c[K+8>>2];L=17}else{I=c[e+12>>2]|0;l=c[e+8>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(l>>>0<11>>>0){a[m]=l<<1;N=m+1|0}else{O=l+16&-16;P=(z=0,au(248,O|0)|0);if(z){z=0;break}c[m+8>>2]=P;c[m>>2]=O|1;c[m+4>>2]=l;N=P}LF(N|0,I|0,l)|0;a[N+l|0]=0;L=17;break L10}}while(0);l=bT(-1,-1)|0;Q=l;R=M}}while(0);do{if((L|0)==17){N=d+16|0;K=k;c[K>>2]=c[N>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];z=0;aq(38,J|0,m|0,k|0,10104,0);if(z){z=0;N=bT(-1,-1)|0;K=N;N=M;if((a[m]&1)==0){Q=K;R=N;break}Lw(c[m+8>>2]|0);Q=K;R=N;break}if((a[m]&1)==0){S=G;T=S;i=g;return T|0}Lw(c[m+8>>2]|0);S=G;T=S;i=g;return T|0}}while(0);m=c[b>>2]|0;k=c[H>>2]|0;N=m;while(1){if((N|0)==(k|0)){U=k;break}if((c[N>>2]|0)==(J|0)){U=N;break}else{N=N+4|0}}N=U-m>>2;U=m+(N+1<<2)|0;J=k-U|0;LG(m+(N<<2)|0,U|0,J|0)|0;U=m+((J>>2)+N<<2)|0;N=c[H>>2]|0;if((U|0)!=(N|0)){c[H>>2]=N+(~((N-4+(-U|0)|0)>>>2)<<2)}Lw(G);V=Q;W=R;X=V;Y=0;Z=X;_=W;bg(Z|0)}L43:do{if(!((D|0)!=12|F)){R=Lu(32)|0;Q=n+8|0;c[Q>>2]=R;c[n>>2]=33;c[n+4>>2]=16;LF(R|0,9880,16)|0;a[R+16|0]=0;R=f+4|0;L45:do{if((a[R]&1)==0){G=o;c[G>>2]=c[R>>2];c[G+4>>2]=c[R+4>>2];c[G+8>>2]=c[R+8>>2];L=40}else{G=c[f+12>>2]|0;U=c[f+8>>2]|0;do{if(U>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(U>>>0<11>>>0){a[o]=U<<1;$=o+1|0}else{N=U+16&-16;H=(z=0,au(248,N|0)|0);if(z){z=0;break}c[o+8>>2]=H;c[o>>2]=N|1;c[o+4>>2]=U;$=H}LF($|0,G|0,U)|0;a[$+U|0]=0;L=40;break L45}}while(0);U=bT(-1,-1)|0;aa=U;ab=M}}while(0);do{if((L|0)==40){R=p;U=f+16|0;c[R>>2]=c[U>>2];c[R+4>>2]=c[U+4>>2];c[R+8>>2]=c[U+8>>2];z=0;aR(382,n|0,o|0,p|0);if(z){z=0;U=bT(-1,-1)|0;R=U;U=M;if((a[o]&1)==0){aa=R;ab=U;break}Lw(c[o+8>>2]|0);aa=R;ab=U;break}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}if((a[n]&1)==0){break L43}Lw(c[Q>>2]|0);break L43}}while(0);if((a[n]&1)==0){V=aa;W=ab;X=V;Y=0;Z=X;_=W;bg(Z|0)}Lw(c[Q>>2]|0);V=aa;W=ab;X=V;Y=0;Z=X;_=W;bg(Z|0)}}while(0);lG(q,A);z=0;as(328,r|0,y|0);do{if(!z){z=0;as(774,q|0,r|0);if(z){z=0;A=bT(-1,-1)|0;ab=A;A=M;if((a[r]&1)==0){ac=ab;ad=A;break}Lw(c[r+8>>2]|0);ac=ab;ad=A;break}if((a[r]&1)!=0){Lw(c[r+8>>2]|0)}z=0;as(248,s|0,y|0);if(z){z=0;L=99;break}z=0;as(248,t|0,q|0);do{if(!z){A=s;ab=s;aa=a[ab]|0;n=aa&255;o=(n&1|0)==0;if(o){ae=n>>>1}else{ae=c[s+4>>2]|0}p=t;$=t;F=a[$]|0;U=F&255;R=(U&1|0)==0;if(R){af=U>>>1}else{af=c[t+4>>2]|0}L94:do{if((ae|0)==(af|0)){G=(aa&1)==0;if(G){ag=A+1|0}else{ag=c[s+8>>2]|0}if((F&1)==0){ah=p+1|0}else{ah=c[t+8>>2]|0}if(!G){if((LH(ag|0,ah|0,ae|0)|0)==0){L=114;break}else{L=74;break}}if((ae|0)==0){L=114;break}else{ai=ah;aj=ag;ak=ae}while(1){if((a[aj]|0)!=(a[ai]|0)){L=74;break L94}G=ak-1|0;if((G|0)==0){L=114;break}else{ai=ai+1|0;aj=aj+1|0;ak=G}}}else{L=74}}while(0);L110:do{if((L|0)==74){if(o){al=n>>>1}else{al=c[s+4>>2]|0}if((al|0)==0){L=114;break}if(R){am=U>>>1}else{am=c[t+4>>2]|0}if((am|0)==0){L=114;break}if((D-8|0)>>>0>=2>>>0){L=114;break}p=(z=0,au(248,64)|0);if(z){z=0;L=107;break}F=u+8|0;c[F>>2]=p;c[u>>2]=65;c[u+4>>2]=54;LF(p|0,9688,54)|0;a[p+54|0]=0;p=e+4|0;L124:do{if((a[p]&1)==0){A=v;c[A>>2]=c[p>>2];c[A+4>>2]=c[p+4>>2];c[A+8>>2]=c[p+8>>2];L=94}else{A=c[e+12>>2]|0;aa=c[e+8>>2]|0;do{if(aa>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aa>>>0<11>>>0){a[v]=aa<<1;an=v+1|0}else{G=aa+16&-16;H=(z=0,au(248,G|0)|0);if(z){z=0;break}c[v+8>>2]=H;c[v>>2]=G|1;c[v+4>>2]=aa;an=H}LF(an|0,A|0,aa)|0;a[an+aa|0]=0;L=94;break L124}}while(0);aa=bT(-1,-1)|0;ao=aa;ap=M}}while(0);do{if((L|0)==94){p=w;aa=e+16|0;c[p>>2]=c[aa>>2];c[p+4>>2]=c[aa+4>>2];c[p+8>>2]=c[aa+8>>2];z=0;aR(382,u|0,v|0,w|0);if(z){z=0;aa=bT(-1,-1)|0;p=aa;aa=M;if((a[v]&1)==0){ao=p;ap=aa;break}Lw(c[v+8>>2]|0);ao=p;ap=aa;break}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}if((a[u]&1)==0){L=114;break L110}Lw(c[F>>2]|0);L=114;break L110}}while(0);if((a[u]&1)==0){at=ao;av=ap;break}Lw(c[F>>2]|0);at=ao;av=ap}}while(0);L149:do{if((L|0)==114){U=(z=0,au(248,72)|0);if(z){z=0;L=107;break}R=U;c[j>>2]=R;U=b+4|0;aa=c[U>>2]|0;if((aa|0)==(c[b+8>>2]|0)){z=0;as(382,b|0,j|0);if(z){z=0;L=107;break}aw=c[j>>2]|0}else{if((aa|0)==0){ax=0}else{c[aa>>2]=R;ax=c[U>>2]|0}c[U>>2]=ax+4;aw=R}R=aw;aa=aw;z=0;as(566,aa|0,y|0);if(z){z=0;p=bT(-1,-1)|0;A=p;p=M;H=c[b>>2]|0;G=c[U>>2]|0;N=H;while(1){if((N|0)==(G|0)){ay=G;break}if((c[N>>2]|0)==(aw|0)){ay=N;break}else{N=N+4|0}}N=ay-H>>2;F=H+(N+1<<2)|0;J=G-F|0;LG(H+(N<<2)|0,F|0,J|0)|0;F=H+((J>>2)+N<<2)|0;N=c[U>>2]|0;if((F|0)!=(N|0)){c[U>>2]=N+(~((N-4+(-F|0)|0)>>>2)<<2)}Lw(R);at=A;av=p;break}LG(aw+16|0,d+16|0,12)|0;if(o){az=n>>>1}else{az=c[s+4>>2]|0}do{if((az|0)==0){if((D-8|0)>>>0>=2>>>0){break}F=aw+48|0;N=f+48|0;if((F|0)!=(N|0)){z=0;aR(152,F|0,c[N>>2]|0,c[N+4>>2]|0);if(z){z=0;L=107;break L149}}N=aw+60|0;F=f+60|0;if((N|0)==(F|0)){break}z=0;aR(152,N|0,c[F>>2]|0,c[F+4>>2]|0);if(z){z=0;L=107;break L149}}}while(0);aA=(z=0,+(+aE(c[37320+(D<<2)>>2]|0,+B,+C)));if(z){z=0;L=107;break}h[aw+40>>3]=aA;L183:do{if((D|0)==10){p=f+48|0;A=c[p+4>>2]|0;U=c[p>>2]|0;H=(A-U|0)/12|0;L237:do{if((A|0)!=(U|0)){G=aw+48|0;F=G+4|0;N=F;J=G+8|0;m=G;G=0;k=U;L239:while(1){K=k;l=K+(G*12|0)|0;I=c[N>>2]|0;if((I|0)==(c[J>>2]|0)){z=0;as(284,m|0,l|0);if(z){z=0;L=104;break}}else{do{if((I|0)!=0){P=l;if((a[P]&1)==0){O=I;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];break}P=c[K+(G*12|0)+8>>2]|0;O=c[K+(G*12|0)+4>>2]|0;if(O>>>0>4294967279>>>0){break L239}if(O>>>0<11>>>0){a[I]=O<<1;aB=I+1|0}else{aC=O+16&-16;aD=(z=0,au(248,aC|0)|0);if(z){z=0;L=104;break L239}c[I+8>>2]=aD;c[I>>2]=aC|1;c[I+4>>2]=O;aB=aD}LF(aB|0,P|0,O)|0;a[aB+O|0]=0}}while(0);c[F>>2]=(c[N>>2]|0)+12}I=G+1|0;if(I>>>0>=H>>>0){break L237}G=I;k=c[p>>2]|0}if((L|0)==104){k=bT(-1,-1)|0;aF=M;aG=k;L=108;break L149}z=0;ar(86,0);if(z){z=0;L=107;break L149}return 0}}while(0);p=f+60|0;H=c[p+4>>2]|0;U=p;p=c[U>>2]|0;A=(H-p|0)/12|0;if((H|0)==(p|0)){break}H=aw+64|0;k=H;G=aw+68|0;N=aw+60|0;F=0;m=p;L264:while(1){p=m+(F*12|0)|0;J=c[k>>2]|0;if((J|0)==(c[G>>2]|0)){z=0;as(284,N|0,p|0);if(z){z=0;L=103;break}}else{do{if((J|0)!=0){I=p;if((a[I]&1)==0){K=J;c[K>>2]=c[I>>2];c[K+4>>2]=c[I+4>>2];c[K+8>>2]=c[I+8>>2];break}I=c[m+(F*12|0)+8>>2]|0;K=c[m+(F*12|0)+4>>2]|0;if(K>>>0>4294967279>>>0){break L264}if(K>>>0<11>>>0){a[J]=K<<1;aH=J+1|0}else{l=K+16&-16;O=(z=0,au(248,l|0)|0);if(z){z=0;L=103;break L264}c[J+8>>2]=O;c[J>>2]=l|1;c[J+4>>2]=K;aH=O}LF(aH|0,I|0,K)|0;a[aH+K|0]=0}}while(0);c[H>>2]=(c[k>>2]|0)+12}J=F+1|0;if(J>>>0>=A>>>0){break L183}F=J;m=c[U>>2]|0}if((L|0)==103){U=bT(-1,-1)|0;aF=M;aG=U;L=108;break L149}z=0;ar(86,0);if(z){z=0;L=107;break L149}return 0}else{if(!E){break}U=f+48|0;m=c[U+4>>2]|0;F=c[U>>2]|0;A=(m-F|0)/12|0;L186:do{if((m|0)!=(F|0)){k=aw+64|0;H=k;N=aw+68|0;G=aw+60|0;J=0;p=F;L188:while(1){K=p;I=K+(J*12|0)|0;O=c[H>>2]|0;if((O|0)==(c[N>>2]|0)){z=0;as(284,G|0,I|0);if(z){z=0;L=106;break}}else{do{if((O|0)!=0){l=I;if((a[l]&1)==0){P=O;c[P>>2]=c[l>>2];c[P+4>>2]=c[l+4>>2];c[P+8>>2]=c[l+8>>2];break}l=c[K+(J*12|0)+8>>2]|0;P=c[K+(J*12|0)+4>>2]|0;if(P>>>0>4294967279>>>0){break L188}if(P>>>0<11>>>0){a[O]=P<<1;aI=O+1|0}else{aD=P+16&-16;aC=(z=0,au(248,aD|0)|0);if(z){z=0;L=106;break L188}c[O+8>>2]=aC;c[O>>2]=aD|1;c[O+4>>2]=P;aI=aC}LF(aI|0,l|0,P)|0;a[aI+P|0]=0}}while(0);c[k>>2]=(c[H>>2]|0)+12}O=J+1|0;if(O>>>0>=A>>>0){break L186}J=O;p=c[U>>2]|0}if((L|0)==106){p=bT(-1,-1)|0;aF=M;aG=p;L=108;break L149}z=0;ar(86,0);if(z){z=0;L=107;break L149}return 0}}while(0);U=f+60|0;A=c[U+4>>2]|0;F=U;U=c[F>>2]|0;m=(A-U|0)/12|0;if((A|0)==(U|0)){break}A=aw+48|0;p=A+4|0;J=p;H=A+8|0;k=A;A=0;G=U;L213:while(1){U=G+(A*12|0)|0;N=c[J>>2]|0;if((N|0)==(c[H>>2]|0)){z=0;as(284,k|0,U|0);if(z){z=0;L=105;break}}else{do{if((N|0)!=0){O=U;if((a[O]&1)==0){K=N;c[K>>2]=c[O>>2];c[K+4>>2]=c[O+4>>2];c[K+8>>2]=c[O+8>>2];break}O=c[G+(A*12|0)+8>>2]|0;K=c[G+(A*12|0)+4>>2]|0;if(K>>>0>4294967279>>>0){break L213}if(K>>>0<11>>>0){a[N]=K<<1;aJ=N+1|0}else{I=K+16&-16;P=(z=0,au(248,I|0)|0);if(z){z=0;L=105;break L213}c[N+8>>2]=P;c[N>>2]=I|1;c[N+4>>2]=K;aJ=P}LF(aJ|0,O|0,K)|0;a[aJ+K|0]=0}}while(0);c[p>>2]=(c[J>>2]|0)+12}N=A+1|0;if(N>>>0>=m>>>0){break L183}A=N;G=c[F>>2]|0}if((L|0)==105){F=bT(-1,-1)|0;aF=M;aG=F;L=108;break L149}z=0;ar(86,0);if(z){z=0;L=107;break L149}return 0}}while(0);F=x;a[F]=0;a[x+1|0]=0;z=0;as(774,aa|0,x|0);if(z){z=0;G=bT(-1,-1)|0;A=G;G=M;if((a[F]&1)==0){at=A;av=G;break}Lw(c[x+8>>2]|0);at=A;av=G;break}if((a[F]&1)!=0){Lw(c[x+8>>2]|0)}if((a[$]&1)!=0){Lw(c[t+8>>2]|0)}if((a[ab]&1)!=0){Lw(c[s+8>>2]|0)}ke(q);S=R;T=S;i=g;return T|0}}while(0);if((L|0)==107){n=bT(-1,-1)|0;aF=M;aG=n;L=108}if((L|0)==108){at=aG;av=aF}if((a[$]&1)==0){aK=at;aL=av;aM=ab;break}Lw(c[t+8>>2]|0);aK=at;aL=av;aM=ab}else{z=0;n=bT(-1,-1)|0;aK=n;aL=M;aM=s}}while(0);if((a[aM]&1)==0){ac=aK;ad=aL;break}Lw(c[s+8>>2]|0);ac=aK;ad=aL}else{z=0;L=99}}while(0);if((L|0)==99){L=bT(-1,-1)|0;ac=L;ad=M}z=0;ar(494,q|0);if(!z){V=ac;W=ad;X=V;Y=0;Z=X;_=W;bg(Z|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function jb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aF=0,aG=0,aH=0,aI=0,aJ=0.0,aK=0.0,aL=0.0,aN=0.0,aO=0,aP=0,aQ=0,aS=0,aT=0,aU=0,aV=0;g=i;i=i+296|0;j=g|0;k=g+16|0;l=g+24|0;m=g+40|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+152|0;v=g+168|0;w=g+184|0;x=g+200|0;y=g+216|0;A=g+232|0;B=g+248|0;C=g+264|0;D=g+280|0;E=e;F=f;G=o;a[G]=0;a[o+1|0]=0;H=(z=0,aM(344,f+72|0,o|0)|0);do{if(!z){I=H;if((a[I]&1)==0){J=n;c[J>>2]=c[I>>2];c[J+4>>2]=c[I+4>>2];c[J+8>>2]=c[I+8>>2];K=a[J]|0}else{J=c[H+8>>2]|0;I=c[H+4>>2]|0;if(I>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(I>>>0<11>>>0){L=I<<1&255;a[n]=L;N=n+1|0;O=L}else{L=I+16&-16;P=(z=0,au(248,L|0)|0);if(z){z=0;break}c[n+8>>2]=P;Q=L|1;c[n>>2]=Q;c[n+4>>2]=I;N=P;O=Q&255}LF(N|0,J|0,I)|0;a[N+I|0]=0;K=O}if((K&1)!=0){Lw(c[n+8>>2]|0)}if((a[G]&1)!=0){Lw(c[o+8>>2]|0)}R=+h[e+40>>3];switch(d|0){case 9:case 11:{I=s;J=s;a[J]=2;a[I+1|0]=a[((d|0)==9?9584:9504)|0]|0;a[I+2|0]=0;z=0;as(278,t|0,0);L24:do{if(!z){I=(z=0,au(248,52)|0);do{if(!z){Q=I;c[k>>2]=Q;P=b+4|0;L=c[P>>2]|0;if((L|0)==(c[b+8>>2]|0)){z=0;as(382,b|0,k|0);if(z){z=0;S=89;break}T=c[k>>2]|0}else{if((L|0)==0){U=0}else{c[L>>2]=Q;U=c[P>>2]|0}c[P>>2]=U+4;T=Q}Q=T;L=T;V=e+4|0;L36:do{if((a[V]&1)==0){W=u;c[W>>2]=c[V>>2];c[W+4>>2]=c[V+4>>2];c[W+8>>2]=c[V+8>>2];S=72}else{W=c[e+12>>2]|0;X=c[e+8>>2]|0;do{if(X>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(X>>>0<11>>>0){a[u]=X<<1;Y=u+1|0}else{Z=X+16&-16;_=(z=0,au(248,Z|0)|0);if(z){z=0;break}c[u+8>>2]=_;c[u>>2]=Z|1;c[u+4>>2]=X;Y=_}LF(Y|0,W|0,X)|0;a[Y+X|0]=0;S=72;break L36}}while(0);X=bT(-1,-1)|0;$=X;aa=M}}while(0);do{if((S|0)==72){V=v;X=e+16|0;c[V>>2]=c[X>>2];c[V+4>>2]=c[X+4>>2];c[V+8>>2]=c[X+8>>2];X=t|0;z=0;aR(c[(c[e>>2]|0)+28>>2]|0,y|0,E|0,X|0);do{if(!z){z=0;aR(210,x|0,y|0,s|0);do{if(!z){z=0;aR(c[(c[f>>2]|0)+28>>2]|0,A|0,F|0,X|0);do{if(!z){z=0;aR(210,w|0,x|0,A|0);do{if(!z){W=j;c[W>>2]=c[V>>2];c[W+4>>2]=c[V+4>>2];c[W+8>>2]=c[V+8>>2];z=0;aq(28,L|0,u|0,j|0,w|0,0);if(z){z=0;W=bT(-1,-1)|0;_=W;W=M;if((a[w]&1)==0){ab=_;ac=W;break}Lw(c[w+8>>2]|0);ab=_;ac=W;break}W=T;if((a[w]&1)!=0){Lw(c[w+8>>2]|0)}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[x]&1)!=0){Lw(c[x+8>>2]|0)}if((a[y]&1)!=0){Lw(c[y+8>>2]|0)}if((a[u]&1)!=0){Lw(c[u+8>>2]|0)}z=0;ar(444,t|0);if(z){z=0;S=88;break L24}if((a[J]&1)==0){ad=W;i=g;return ad|0}Lw(c[s+8>>2]|0);ad=W;i=g;return ad|0}else{z=0;W=bT(-1,-1)|0;ab=W;ac=M}}while(0);if((a[A]&1)==0){ae=ab;af=ac;break}Lw(c[A+8>>2]|0);ae=ab;af=ac}else{z=0;W=bT(-1,-1)|0;ae=W;af=M}}while(0);if((a[x]&1)==0){ag=ae;ah=af;break}Lw(c[x+8>>2]|0);ag=ae;ah=af}else{z=0;W=bT(-1,-1)|0;ag=W;ah=M}}while(0);if((a[y]&1)==0){ai=ag;aj=ah;break}Lw(c[y+8>>2]|0);ai=ag;aj=ah}else{z=0;W=bT(-1,-1)|0;ai=W;aj=M}}while(0);if((a[u]&1)==0){$=ai;aa=aj;break}Lw(c[u+8>>2]|0);$=ai;aa=aj}}while(0);L=c[b>>2]|0;V=c[P>>2]|0;X=L;while(1){if((X|0)==(V|0)){ak=V;break}if((c[X>>2]|0)==(T|0)){ak=X;break}else{X=X+4|0}}X=ak-L>>2;W=L+(X+1<<2)|0;_=V-W|0;LG(L+(X<<2)|0,W|0,_|0)|0;W=L+((_>>2)+X<<2)|0;X=c[P>>2]|0;if((W|0)!=(X|0)){c[P>>2]=X+(~((X-4+(-W|0)|0)>>>2)<<2)}Lw(Q);al=$;am=aa}else{z=0;S=89}}while(0);if((S|0)==89){I=bT(-1,-1)|0;al=I;am=M}z=0;ar(444,t|0);if(!z){an=al;ao=am;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;S=88}}while(0);if((S|0)==88){I=bT(-1,-1)|0;an=I;ao=M}if((a[J]&1)==0){ap=an;at=ao;aw=ap;ax=0;ay=aw;az=at;bg(ay|0)}Lw(c[s+8>>2]|0);ap=an;at=ao;aw=ap;ax=0;ay=aw;az=at;bg(ay|0);break};case 8:case 10:{I=Lu(88)|0;c[m>>2]=I;W=b+4|0;X=c[W>>2]|0;if((X|0)==(c[b+8>>2]|0)){e4(b|0,m);aA=c[m>>2]|0}else{if((X|0)==0){aB=0}else{c[X>>2]=I;aB=c[W>>2]|0}c[W>>2]=aB+4;aA=I}I=aA;X=aA;_=e+4|0;L122:do{if((a[_]&1)==0){Z=p;c[Z>>2]=c[_>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];S=34}else{Z=c[e+12>>2]|0;aC=c[e+8>>2]|0;do{if(aC>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aC>>>0<11>>>0){a[p]=aC<<1;aD=p+1|0}else{aF=aC+16&-16;aG=(z=0,au(248,aF|0)|0);if(z){z=0;break}c[p+8>>2]=aG;c[p>>2]=aF|1;c[p+4>>2]=aC;aD=aG}LF(aD|0,Z|0,aC)|0;a[aD+aC|0]=0;S=34;break L122}}while(0);aC=bT(-1,-1)|0;aH=aC;aI=M}}while(0);do{if((S|0)==34){_=q;J=e+16|0;c[_>>2]=c[J>>2];c[_+4>>2]=c[J+4>>2];c[_+8>>2]=c[J+8>>2];J=37320+(d<<2)|0;aJ=(z=0,+(+aE(c[J>>2]|0,+R,+(+h[f+40>>3]))));do{if(!z){aK=(z=0,+(+aE(c[J>>2]|0,+R,+(+h[f+48>>3]))));if(z){z=0;S=43;break}aL=(z=0,+(+aE(c[J>>2]|0,+R,+(+h[f+56>>3]))));if(z){z=0;S=43;break}aN=+h[f+64>>3];aC=r;a[aC]=0;a[r+1|0]=0;Z=l;c[Z>>2]=c[_>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];z=0;av(2,X|0,p|0,l|0,+aJ,+aK,+aL,+aN,r|0);if(z){z=0;Z=bT(-1,-1)|0;aG=Z;Z=M;if((a[aC]&1)==0){aO=aG;aP=Z;break}Lw(c[r+8>>2]|0);aO=aG;aP=Z;break}if((a[aC]&1)!=0){Lw(c[r+8>>2]|0)}aC=aA;if((a[p]&1)==0){ad=aC;i=g;return ad|0}Lw(c[p+8>>2]|0);ad=aC;i=g;return ad|0}else{z=0;S=43}}while(0);if((S|0)==43){_=bT(-1,-1)|0;aO=_;aP=M}if((a[p]&1)==0){aH=aO;aI=aP;break}Lw(c[p+8>>2]|0);aH=aO;aI=aP}}while(0);X=c[b>>2]|0;_=c[W>>2]|0;J=X;while(1){if((J|0)==(_|0)){aQ=_;break}if((c[J>>2]|0)==(aA|0)){aQ=J;break}else{J=J+4|0}}J=aQ-X>>2;aC=X+(J+1<<2)|0;Z=_-aC|0;LG(X+(J<<2)|0,aC|0,Z|0)|0;aC=X+((Z>>2)+J<<2)|0;J=c[W>>2]|0;if((aC|0)!=(J|0)){c[W>>2]=J+(~((J-4+(-aC|0)|0)>>>2)<<2)}Lw(I);ap=aH;at=aI;aw=ap;ax=0;ay=aw;az=at;bg(ay|0);break};case 12:{aC=Lu(48)|0;J=B+8|0;c[J>>2]=aC;c[B>>2]=49;c[B+4>>2]=33;LF(aC|0,9304,33)|0;a[aC+33|0]=0;aC=f+4|0;L167:do{if((a[aC]&1)==0){Z=C;c[Z>>2]=c[aC>>2];c[Z+4>>2]=c[aC+4>>2];c[Z+8>>2]=c[aC+8>>2];S=126}else{Z=c[f+12>>2]|0;aG=c[f+8>>2]|0;do{if(aG>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aG>>>0<11>>>0){a[C]=aG<<1;aS=C+1|0}else{aF=aG+16&-16;aT=(z=0,au(248,aF|0)|0);if(z){z=0;break}c[C+8>>2]=aT;c[C>>2]=aF|1;c[C+4>>2]=aG;aS=aT}LF(aS|0,Z|0,aG)|0;a[aS+aG|0]=0;S=126;break L167}}while(0);aG=bT(-1,-1)|0;aU=aG;aV=M}}while(0);do{if((S|0)==126){aC=D;I=f+16|0;c[aC>>2]=c[I>>2];c[aC+4>>2]=c[I+4>>2];c[aC+8>>2]=c[I+8>>2];z=0;aR(382,B|0,C|0,D|0);if(z){z=0;I=bT(-1,-1)|0;aC=I;I=M;if((a[C]&1)==0){aU=aC;aV=I;break}Lw(c[C+8>>2]|0);aU=aC;aV=I;break}if((a[C]&1)!=0){Lw(c[C+8>>2]|0)}if((a[B]&1)==0){ad=e;i=g;return ad|0}Lw(c[J>>2]|0);ad=e;i=g;return ad|0}}while(0);if((a[B]&1)==0){ap=aU;at=aV;aw=ap;ax=0;ay=aw;az=at;bg(ay|0)}Lw(c[J>>2]|0);ap=aU;at=aV;aw=ap;ax=0;ay=aw;az=at;bg(ay|0);break};default:{ad=e;i=g;return ad|0}}}else{z=0}}while(0);ad=bT(-1,-1)|0;g=ad;ad=M;if((a[G]&1)==0){ap=g;at=ad;aw=ap;ax=0;ay=aw;az=at;bg(ay|0)}Lw(c[o+8>>2]|0);ap=g;at=ad;aw=ap;ax=0;ay=aw;az=at;bg(ay|0);return 0}function jc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0;g=i;i=i+120|0;j=g|0;k=g+16|0;l=g+24|0;m=g+40|0;n=g+56|0;o=g+72|0;p=g+88|0;q=g+104|0;r=+h[f+40>>3];L1:do{if(!((d|0)!=11|r!=0.0)){s=Lu(32)|0;t=l+8|0;c[t>>2]=s;c[l>>2]=33;c[l+4>>2]=16;LF(s|0,9880,16)|0;a[s+16|0]=0;s=f+4|0;L3:do{if((a[s]&1)==0){u=m;c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];v=12}else{u=c[f+12>>2]|0;w=c[f+8>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[m]=w<<1;x=m+1|0}else{y=w+16&-16;A=(z=0,au(248,y|0)|0);if(z){z=0;break}c[m+8>>2]=A;c[m>>2]=y|1;c[m+4>>2]=w;x=A}LF(x|0,u|0,w)|0;a[x+w|0]=0;v=12;break L3}}while(0);w=bT(-1,-1)|0;B=M;C=w}}while(0);do{if((v|0)==12){s=n;w=f+16|0;c[s>>2]=c[w>>2];c[s+4>>2]=c[w+4>>2];c[s+8>>2]=c[w+8>>2];z=0;aR(382,l|0,m|0,n|0);if(z){z=0;w=bT(-1,-1)|0;s=w;w=M;if((a[m]&1)==0){B=w;C=s;break}Lw(c[m+8>>2]|0);B=w;C=s;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}if((a[l]&1)==0){break L1}Lw(c[t>>2]|0);break L1}}while(0);if((a[l]&1)==0){D=B;E=C;F=E;G=0;H=F;I=D;bg(H|0)}Lw(c[t>>2]|0);D=B;E=C;F=E;G=0;H=F;I=D;bg(H|0)}}while(0);C=Lu(88)|0;c[k>>2]=C;B=b+4|0;l=c[B>>2]|0;if((l|0)==(c[b+8>>2]|0)){e4(b|0,k);J=c[k>>2]|0}else{if((l|0)==0){K=0}else{c[l>>2]=C;K=c[B>>2]|0}c[B>>2]=K+4;J=C}C=J;K=J;l=e+4|0;L39:do{if((a[l]&1)==0){k=o;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];v=37}else{k=c[e+12>>2]|0;m=c[e+8>>2]|0;do{if(m>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(m>>>0<11>>>0){a[o]=m<<1;L=o+1|0}else{n=m+16&-16;f=(z=0,au(248,n|0)|0);if(z){z=0;break}c[o+8>>2]=f;c[o>>2]=n|1;c[o+4>>2]=m;L=f}LF(L|0,k|0,m)|0;a[L+m|0]=0;v=37;break L39}}while(0);m=bT(-1,-1)|0;N=M;O=m}}while(0);do{if((v|0)==37){L=p;l=e+16|0;c[L>>2]=c[l>>2];c[L+4>>2]=c[l+4>>2];c[L+8>>2]=c[l+8>>2];l=37320+(d<<2)|0;P=(z=0,+(+aE(c[l>>2]|0,+(+h[e+40>>3]),+r)));do{if(!z){Q=(z=0,+(+aE(c[l>>2]|0,+(+h[e+48>>3]),+r)));if(z){z=0;v=47;break}R=(z=0,+(+aE(c[l>>2]|0,+(+h[e+56>>3]),+r)));if(z){z=0;v=47;break}S=+h[e+64>>3];m=q;a[m]=0;a[q+1|0]=0;k=j;c[k>>2]=c[L>>2];c[k+4>>2]=c[L+4>>2];c[k+8>>2]=c[L+8>>2];z=0;av(2,K|0,o|0,j|0,+P,+Q,+R,+S,q|0);if(z){z=0;k=bT(-1,-1)|0;t=k;k=M;if((a[m]&1)==0){T=k;U=t;break}Lw(c[q+8>>2]|0);T=k;U=t;break}t=J;if((a[m]&1)!=0){Lw(c[q+8>>2]|0)}if((a[o]&1)==0){i=g;return t|0}Lw(c[o+8>>2]|0);i=g;return t|0}else{z=0;v=47}}while(0);if((v|0)==47){L=bT(-1,-1)|0;T=M;U=L}if((a[o]&1)==0){N=T;O=U;break}Lw(c[o+8>>2]|0);N=T;O=U}}while(0);U=c[b>>2]|0;b=c[B>>2]|0;T=U;while(1){if((T|0)==(b|0)){V=b;break}if((c[T>>2]|0)==(J|0)){V=T;break}else{T=T+4|0}}T=V-U>>2;V=U+(T+1<<2)|0;J=b-V|0;LG(U+(T<<2)|0,V|0,J|0)|0;V=U+((J>>2)+T<<2)|0;T=c[B>>2]|0;if((V|0)!=(T|0)){c[B>>2]=T+(~((T-4+(-V|0)|0)>>>2)<<2)}Lw(C);D=N;E=O;F=E;G=0;H=F;I=D;bg(H|0);return 0}function jd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0;g=i;i=i+168|0;j=g|0;k=g+16|0;l=g+24|0;m=g+40|0;n=g+56|0;o=g+72|0;p=g+88|0;q=g+104|0;r=g+120|0;s=g+136|0;t=g+152|0;u=e+64|0;L1:do{if(+h[u>>3]!=+h[f+64>>3]){v=Lu(64)|0;w=l+8|0;c[w>>2]=v;c[l>>2]=65;c[l+4>>2]=50;LF(v|0,9016,50)|0;a[v+50|0]=0;v=f+4|0;L3:do{if((a[v]&1)==0){x=m;c[x>>2]=c[v>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];y=12}else{x=c[f+12>>2]|0;A=c[f+8>>2]|0;do{if(A>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(A>>>0<11>>>0){a[m]=A<<1;B=m+1|0}else{C=A+16&-16;D=(z=0,au(248,C|0)|0);if(z){z=0;break}c[m+8>>2]=D;c[m>>2]=C|1;c[m+4>>2]=A;B=D}LF(B|0,x|0,A)|0;a[B+A|0]=0;y=12;break L3}}while(0);A=bT(-1,-1)|0;E=M;F=A}}while(0);do{if((y|0)==12){v=n;A=f+16|0;c[v>>2]=c[A>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];z=0;aR(382,l|0,m|0,n|0);if(z){z=0;A=bT(-1,-1)|0;v=A;A=M;if((a[m]&1)==0){E=A;F=v;break}Lw(c[m+8>>2]|0);E=A;F=v;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}if((a[l]&1)==0){break L1}Lw(c[w>>2]|0);break L1}}while(0);if((a[l]&1)==0){G=E;H=F;I=H;J=0;K=I;L=G;bg(K|0)}Lw(c[w>>2]|0);G=E;H=F;I=H;J=0;K=I;L=G;bg(K|0)}}while(0);L32:do{if((d-11|0)>>>0<2>>>0){do{if(+h[f+40>>3]!=0.0){if(+h[f+48>>3]==0.0){break}if(+h[f+56>>3]!=0.0){break L32}}}while(0);w=Lu(32)|0;F=o+8|0;c[F>>2]=w;c[o>>2]=33;c[o+4>>2]=16;LF(w|0,9880,16)|0;a[w+16|0]=0;w=f+4|0;L38:do{if((a[w]&1)==0){E=p;c[E>>2]=c[w>>2];c[E+4>>2]=c[w+4>>2];c[E+8>>2]=c[w+8>>2];y=36}else{E=c[f+12>>2]|0;l=c[f+8>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(l>>>0<11>>>0){a[p]=l<<1;N=p+1|0}else{m=l+16&-16;n=(z=0,au(248,m|0)|0);if(z){z=0;break}c[p+8>>2]=n;c[p>>2]=m|1;c[p+4>>2]=l;N=n}LF(N|0,E|0,l)|0;a[N+l|0]=0;y=36;break L38}}while(0);l=bT(-1,-1)|0;O=M;P=l}}while(0);do{if((y|0)==36){w=q;l=f+16|0;c[w>>2]=c[l>>2];c[w+4>>2]=c[l+4>>2];c[w+8>>2]=c[l+8>>2];z=0;aR(382,o|0,p|0,q|0);if(z){z=0;l=bT(-1,-1)|0;w=l;l=M;if((a[p]&1)==0){O=l;P=w;break}Lw(c[p+8>>2]|0);O=l;P=w;break}if((a[p]&1)!=0){Lw(c[p+8>>2]|0)}if((a[o]&1)==0){break L32}Lw(c[F>>2]|0);break L32}}while(0);if((a[o]&1)==0){G=O;H=P;I=H;J=0;K=I;L=G;bg(K|0)}Lw(c[F>>2]|0);G=O;H=P;I=H;J=0;K=I;L=G;bg(K|0)}}while(0);P=Lu(88)|0;c[k>>2]=P;O=b+4|0;o=c[O>>2]|0;if((o|0)==(c[b+8>>2]|0)){e4(b|0,k);Q=c[k>>2]|0}else{if((o|0)==0){R=0}else{c[o>>2]=P;R=c[O>>2]|0}c[O>>2]=R+4;Q=P}P=Q;R=Q;o=e+4|0;L74:do{if((a[o]&1)==0){k=r;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];y=61}else{k=c[e+12>>2]|0;p=c[e+8>>2]|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(p>>>0<11>>>0){a[r]=p<<1;S=r+1|0}else{q=p+16&-16;N=(z=0,au(248,q|0)|0);if(z){z=0;break}c[r+8>>2]=N;c[r>>2]=q|1;c[r+4>>2]=p;S=N}LF(S|0,k|0,p)|0;a[S+p|0]=0;y=61;break L74}}while(0);p=bT(-1,-1)|0;T=M;U=p}}while(0);do{if((y|0)==61){S=s;o=e+16|0;c[S>>2]=c[o>>2];c[S+4>>2]=c[o+4>>2];c[S+8>>2]=c[o+8>>2];o=37320+(d<<2)|0;V=(z=0,+(+aE(c[o>>2]|0,+(+h[e+40>>3]),+(+h[f+40>>3]))));do{if(!z){W=(z=0,+(+aE(c[o>>2]|0,+(+h[e+48>>3]),+(+h[f+48>>3]))));if(z){z=0;y=71;break}X=(z=0,+(+aE(c[o>>2]|0,+(+h[e+56>>3]),+(+h[f+56>>3]))));if(z){z=0;y=71;break}Y=+h[u>>3];p=t;a[p]=0;a[t+1|0]=0;k=j;c[k>>2]=c[S>>2];c[k+4>>2]=c[S+4>>2];c[k+8>>2]=c[S+8>>2];z=0;av(2,R|0,r|0,j|0,+V,+W,+X,+Y,t|0);if(z){z=0;k=bT(-1,-1)|0;F=k;k=M;if((a[p]&1)==0){Z=k;_=F;break}Lw(c[t+8>>2]|0);Z=k;_=F;break}F=Q;if((a[p]&1)!=0){Lw(c[t+8>>2]|0)}if((a[r]&1)==0){i=g;return F|0}Lw(c[r+8>>2]|0);i=g;return F|0}else{z=0;y=71}}while(0);if((y|0)==71){S=bT(-1,-1)|0;Z=M;_=S}if((a[r]&1)==0){T=Z;U=_;break}Lw(c[r+8>>2]|0);T=Z;U=_}}while(0);_=c[b>>2]|0;b=c[O>>2]|0;Z=_;while(1){if((Z|0)==(b|0)){$=b;break}if((c[Z>>2]|0)==(Q|0)){$=Z;break}else{Z=Z+4|0}}Z=$-_>>2;$=_+(Z+1<<2)|0;Q=b-$|0;LG(_+(Z<<2)|0,$|0,Q|0)|0;$=_+((Q>>2)+Z<<2)|0;Z=c[O>>2]|0;if(($|0)!=(Z|0)){c[O>>2]=Z+(~((Z-4+(-$|0)|0)>>>2)<<2)}Lw(P);G=T;H=U;I=H;J=0;K=I;L=G;bg(K|0);return 0}function je(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0;g=i;i=i+240|0;h=g|0;j=g+16|0;k=g+24|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=g+112|0;r=g+128|0;s=g+144|0;t=g+160|0;u=g+176|0;v=g+192|0;w=g+208|0;x=g+224|0;y=x;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+12|0;i=i+7&-8;G=i;i=i+12|0;i=i+7&-8;Bv(k,0);H=c[e+32>>2]|0;I=c[f+32>>2]|0;L1:do{if((H|0)==3){J=m;a[J]=0;a[m+1|0]=0;K=(z=0,aM(344,e+72|0,m|0)|0);do{if(!z){L=K;if((a[L]&1)==0){N=l;c[N>>2]=c[L>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];O=a[N]|0}else{N=c[K+8>>2]|0;L=c[K+4>>2]|0;if(L>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(L>>>0<11>>>0){P=L<<1&255;a[l]=P;Q=l+1|0;R=P}else{P=L+16&-16;S=(z=0,au(248,P|0)|0);if(z){z=0;break}c[l+8>>2]=S;T=P|1;c[l>>2]=T;c[l+4>>2]=L;Q=S;R=T&255}LF(Q|0,N|0,L)|0;a[Q+L|0]=0;O=R}if((O&1)!=0){Lw(c[l+8>>2]|0)}if((a[J]&1)==0){U=20;break L1}Lw(c[m+8>>2]|0);U=20;break L1}else{z=0}}while(0);K=bT(-1,-1)|0;L=K;K=M;if((a[J]&1)==0){V=K;W=L;break}Lw(c[m+8>>2]|0);V=K;W=L}else{U=20}}while(0);L24:do{if((U|0)==20){L26:do{if((I|0)==3){m=o;a[m]=0;a[o+1|0]=0;l=(z=0,aM(344,f+72|0,o|0)|0);do{if(!z){O=l;if((a[O]&1)==0){R=n;c[R>>2]=c[O>>2];c[R+4>>2]=c[O+4>>2];c[R+8>>2]=c[O+8>>2];X=a[R]|0}else{R=c[l+8>>2]|0;O=c[l+4>>2]|0;if(O>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(O>>>0<11>>>0){Q=O<<1&255;a[n]=Q;Y=n+1|0;Z=Q}else{Q=O+16&-16;L=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[n+8>>2]=L;K=Q|1;c[n>>2]=K;c[n+4>>2]=O;Y=L;Z=K&255}LF(Y|0,R|0,O)|0;a[Y+O|0]=0;X=Z}if((X&1)!=0){Lw(c[n+8>>2]|0)}if((a[m]&1)==0){break L26}Lw(c[o+8>>2]|0);break L26}else{z=0}}while(0);l=bT(-1,-1)|0;O=l;l=M;if((a[m]&1)==0){V=l;W=O;break L24}Lw(c[o+8>>2]|0);V=l;W=O;break L24}}while(0);J=k|0;z=0;aR(c[(c[e>>2]|0)+28>>2]|0,p|0,e|0,J|0);if(z){z=0;O=bT(-1,-1)|0;V=M;W=O;break}z=0;aR(c[(c[f>>2]|0)+28>>2]|0,q|0,f|0,J|0);do{if(!z){L56:do{if((H|0)==4){J=p;O=(a[p]&1)==0;if(O){_=J+1|0}else{_=c[p+8>>2]|0}if((a[_]|0)==34){$=0}else{if(O){aa=J+1|0}else{aa=c[p+8>>2]|0}$=(a[aa]|0)!=39}J=(a[e+28|0]&1)==0;if(!J){ab=$;U=62;break}O=b+160|0;l=O|0;if((j$(l,p)|0)!=0&(I|0)==4){do{if((a[f+28|0]&1)==0){if((j$(l,q)|0)==0){break}R=(z=0,aM(262,O|0,p|0)|0);if(z){z=0;U=50;break L56}K=c[R>>2]|0;R=(z=0,aM(262,O|0,q|0)|0);if(z){z=0;U=50;break L56}L=(z=0,aU(46,b|0,d|0,K|0,c[R>>2]|0)|0);if(!z){ac=L;U=211;break L56}else{z=0;U=50;break L56}}}while(0);if(!J){ab=$;U=62;break}}O=b+160|0;if(!((j$(O|0,p)|0)!=0&(I|0)==2)){ab=$;U=62;break}l=(z=0,aM(262,O|0,p|0)|0);if(z){z=0;U=50;break}O=(z=0,aU(24,b|0,d|0,c[l>>2]|0,f|0)|0);if(!z){ac=O;U=211}else{z=0;U=50}}else{ab=0;U=62}}while(0);L81:do{if((U|0)==62){do{if((H|0)==2&(I|0)==4){if((a[f+28|0]&1)!=0){break}m=b+160|0;if((j$(m|0,q)|0)==0){break}O=(z=0,aM(262,m|0,q|0)|0);if(z){z=0;U=50;break L81}m=(z=0,aU(12,b|0,d|0,f|0,c[O>>2]|0)|0);if(!z){ac=m;U=211;break L81}else{z=0;U=50;break L81}}}while(0);L89:do{if((d|0)==12){J=(z=0,au(248,32)|0);if(z){z=0;U=50;break L81}m=u+8|0;c[m>>2]=J;c[u>>2]=33;c[u+4>>2]=27;LF(J|0,8808,27)|0;a[J+27|0]=0;J=e+4|0;L92:do{if((a[J]&1)==0){O=v;c[O>>2]=c[J>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2];U=100}else{O=c[e+12>>2]|0;l=c[e+8>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(l>>>0<11>>>0){a[v]=l<<1;ad=v+1|0}else{L=l+16&-16;R=(z=0,au(248,L|0)|0);if(z){z=0;break}c[v+8>>2]=R;c[v>>2]=L|1;c[v+4>>2]=l;ad=R}LF(ad|0,O|0,l)|0;a[ad+l|0]=0;U=100;break L92}}while(0);l=bT(-1,-1)|0;ae=M;af=l}}while(0);do{if((U|0)==100){J=w;l=e+16|0;c[J>>2]=c[l>>2];c[J+4>>2]=c[l+4>>2];c[J+8>>2]=c[l+8>>2];z=0;aR(382,u|0,v|0,w|0);if(z){z=0;l=bT(-1,-1)|0;J=l;l=M;if((a[v]&1)==0){ae=l;af=J;break}Lw(c[v+8>>2]|0);ae=l;af=J;break}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}if((a[u]&1)==0){break L89}Lw(c[m>>2]|0);break L89}}while(0);if((a[u]&1)==0){ag=ae;ah=af;break L81}Lw(c[m>>2]|0);ag=ae;ah=af;break L81}else if((d|0)==10){J=(z=0,au(248,48)|0);if(z){z=0;U=50;break L81}l=r+8|0;c[l>>2]=J;c[r>>2]=49;c[r+4>>2]=35;LF(J|0,8920,35)|0;a[J+35|0]=0;J=e+4|0;L119:do{if((a[J]&1)==0){O=s;c[O>>2]=c[J>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2];U=79}else{O=c[e+12>>2]|0;R=c[e+8>>2]|0;do{if(R>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(R>>>0<11>>>0){a[s]=R<<1;ai=s+1|0}else{L=R+16&-16;K=(z=0,au(248,L|0)|0);if(z){z=0;break}c[s+8>>2]=K;c[s>>2]=L|1;c[s+4>>2]=R;ai=K}LF(ai|0,O|0,R)|0;a[ai+R|0]=0;U=79;break L119}}while(0);R=bT(-1,-1)|0;aj=M;ak=R}}while(0);do{if((U|0)==79){J=t;m=e+16|0;c[J>>2]=c[m>>2];c[J+4>>2]=c[m+4>>2];c[J+8>>2]=c[m+8>>2];z=0;aR(382,r|0,s|0,t|0);if(z){z=0;m=bT(-1,-1)|0;J=m;m=M;if((a[s]&1)==0){aj=m;ak=J;break}Lw(c[s+8>>2]|0);aj=m;ak=J;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}if((a[r]&1)==0){break L89}Lw(c[l>>2]|0);break L89}}while(0);if((a[r]&1)==0){ag=aj;ah=ak;break L81}Lw(c[l>>2]|0);ag=aj;ah=ak;break L81}}while(0);LI(y|0,0,12)|0;if((d|0)==9){z=0,aM(542,x|0,9584)|0;if(!z){U=114}else{z=0;U=112}}else if((d|0)==11){z=0,aM(542,x|0,9504)|0;if(!z){U=114}else{z=0;U=112}}else{U=114}L148:do{if((U|0)==114){J=p;m=(a[p]&1)==0;if(m){al=J+1|0}else{al=c[p+8>>2]|0}do{if((a[al]|0)==34){U=122}else{if(m){am=J+1|0}else{am=c[p+8>>2]|0}if((a[am]|0)==39){U=122;break}R=q;O=(a[q]&1)==0;if(O){an=R+1|0}else{an=c[q+8>>2]|0}if((a[an]|0)!=34){if(O){ao=R+1|0}else{ao=c[q+8>>2]|0}if((a[ao]|0)!=39){ap=0;break}}if(O){at=R+1|0}else{at=c[q+8>>2]|0}ap=a[at]|0}}while(0);if((U|0)==122){if(m){av=J+1|0}else{av=c[p+8>>2]|0}ap=a[av]|0}z=0;as(180,C|0,p|0);if(z){z=0;U=112;break}z=0;aR(210,B|0,C|0,x|0);do{if(!z){z=0;as(180,D|0,q|0);do{if(!z){z=0;aR(210,A|0,B|0,D|0);if(z){z=0;l=bT(-1,-1)|0;R=l;l=M;if((a[D]&1)==0){aw=l;ax=R;break}Lw(c[D+8>>2]|0);aw=l;ax=R;break}if((a[D]&1)!=0){Lw(c[D+8>>2]|0)}if((a[B]&1)!=0){Lw(c[B+8>>2]|0)}if((a[C]&1)!=0){Lw(c[C+8>>2]|0)}R=(z=0,au(248,52)|0);do{if(!z){l=R;c[j>>2]=l;O=b+4|0;K=c[O>>2]|0;if((K|0)==(c[b+8>>2]|0)){z=0;as(382,b|0,j|0);if(z){z=0;U=192;break}ay=c[j>>2]|0}else{if((K|0)==0){az=0}else{c[K>>2]=l;az=c[O>>2]|0}c[O>>2]=az+4;ay=l}l=ay;K=ay;L=e+4|0;L212:do{if((a[L]&1)==0){Q=E;c[Q>>2]=c[L>>2];c[Q+4>>2]=c[L+4>>2];c[Q+8>>2]=c[L+8>>2];U=165}else{Q=c[e+12>>2]|0;N=c[e+8>>2]|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[E]=N<<1;aA=E+1|0}else{T=N+16&-16;S=(z=0,au(248,T|0)|0);if(z){z=0;break}c[E+8>>2]=S;c[E>>2]=T|1;c[E+4>>2]=N;aA=S}LF(aA|0,Q|0,N)|0;a[aA+N|0]=0;U=165;break L212}}while(0);N=bT(-1,-1)|0;aB=M;aC=N}}while(0);do{if((U|0)==165){L=F;N=e+16|0;c[L>>2]=c[N>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];do{if(ab){N=A;if((a[N]&1)==0){Q=G;c[Q>>2]=c[N>>2];c[Q+4>>2]=c[N+4>>2];c[Q+8>>2]=c[N+8>>2];U=177;break}N=c[A+8>>2]|0;Q=c[A+4>>2]|0;if(Q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;U=194;break}return 0}if(Q>>>0<11>>>0){a[G]=Q<<1;aD=G+1|0}else{S=Q+16&-16;T=(z=0,au(248,S|0)|0);if(z){z=0;U=194;break}c[G+8>>2]=T;c[G>>2]=S|1;c[G+4>>2]=Q;aD=T}LF(aD|0,N|0,Q)|0;a[aD+Q|0]=0;U=177}else{z=0;aR(286,G|0,A|0,ap|0);if(!z){U=177}else{z=0;U=194}}}while(0);do{if((U|0)==194){Q=bT(-1,-1)|0;aE=M;aF=Q}else if((U|0)==177){Q=h;c[Q>>2]=c[L>>2];c[Q+4>>2]=c[L+4>>2];c[Q+8>>2]=c[L+8>>2];z=0;aq(28,K|0,E|0,h|0,G|0,0);if(z){z=0;Q=bT(-1,-1)|0;N=Q;Q=M;if((a[G]&1)==0){aE=Q;aF=N;break}Lw(c[G+8>>2]|0);aE=Q;aF=N;break}N=ay;if((a[G]&1)!=0){Lw(c[G+8>>2]|0)}if((a[E]&1)!=0){Lw(c[E+8>>2]|0)}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[y]&1)==0){ac=N;U=211;break L81}Lw(c[x+8>>2]|0);ac=N;U=211;break L81}}while(0);if((a[E]&1)==0){aB=aE;aC=aF;break}Lw(c[E+8>>2]|0);aB=aE;aC=aF}}while(0);K=c[b>>2]|0;L=c[O>>2]|0;N=K;while(1){if((N|0)==(L|0)){aG=L;break}if((c[N>>2]|0)==(ay|0)){aG=N;break}else{N=N+4|0}}N=aG-K>>2;Q=K+(N+1<<2)|0;T=L-Q|0;LG(K+(N<<2)|0,Q|0,T|0)|0;Q=K+((T>>2)+N<<2)|0;N=c[O>>2]|0;if((Q|0)!=(N|0)){c[O>>2]=N+(~((N-4+(-Q|0)|0)>>>2)<<2)}Lw(l);aH=aB;aI=aC}else{z=0;U=192}}while(0);if((U|0)==192){R=bT(-1,-1)|0;aH=M;aI=R}if((a[A]&1)==0){aJ=aH;aK=aI;break L148}Lw(c[A+8>>2]|0);aJ=aH;aK=aI;break L148}else{z=0;R=bT(-1,-1)|0;aw=M;ax=R}}while(0);if((a[B]&1)==0){aL=aw;aN=ax;break}Lw(c[B+8>>2]|0);aL=aw;aN=ax}else{z=0;R=bT(-1,-1)|0;aL=M;aN=R}}while(0);if((a[C]&1)==0){aJ=aL;aK=aN;break}Lw(c[C+8>>2]|0);aJ=aL;aK=aN}}while(0);if((U|0)==112){J=bT(-1,-1)|0;aJ=M;aK=J}if((a[y]&1)==0){ag=aJ;ah=aK;break}Lw(c[x+8>>2]|0);ag=aJ;ah=aK}}while(0);if((U|0)==50){J=bT(-1,-1)|0;ag=M;ah=J}else if((U|0)==211){if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[p]&1)==0){Bx(k);i=g;return ac|0}Lw(c[p+8>>2]|0);Bx(k);i=g;return ac|0}if((a[q]&1)==0){aO=ag;aP=ah;break}Lw(c[q+8>>2]|0);aO=ag;aP=ah}else{z=0;J=bT(-1,-1)|0;aO=M;aP=J}}while(0);if((a[p]&1)==0){V=aO;W=aP;break}Lw(c[p+8>>2]|0);V=aO;W=aP}}while(0);z=0;ar(444,k|0);if(!z){bg(W|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function jf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;e=i;i=i+128|0;f=e|0;g=e+8|0;j=e+24|0;k=e+32|0;l=e+48|0;m=e+56|0;n=e+64|0;o=e+80|0;p=e+96|0;q=e+112|0;r=d+40|0;s=c[r>>2]|0;t=cV[c[(c[s>>2]|0)+20>>2]&1023](s|0,b|0)|0;s=t+32|0;if((c[s>>2]|0)==2){u=c[b+4>>2]|0;v=Lu(72)|0;c[l>>2]=v;w=u+4|0;x=c[w>>2]|0;if((x|0)==(c[u+8>>2]|0)){e4(u|0,l);y=c[l>>2]|0}else{if((x|0)==0){A=0}else{c[x>>2]=v;A=c[w>>2]|0}c[w>>2]=A+4;y=v}v=y;z=0;as(566,y|0,t|0);if(!z){t=y+40|0;B=+h[t>>3];if((c[d+36>>2]|0)==1){C=-0.0-B}else{C=B}h[t>>3]=C;D=v;E=D;i=e;return E|0}else{z=0}t=bT(-1,-1)|0;A=t;t=M;x=c[u>>2]|0;u=c[w>>2]|0;l=x;while(1){if((l|0)==(u|0)){F=u;break}if((c[l>>2]|0)==(y|0)){F=l;break}else{l=l+4|0}}l=F-x>>2;F=x+(l+1<<2)|0;y=u-F|0;LG(x+(l<<2)|0,F|0,y|0)|0;F=x+((y>>2)+l<<2)|0;l=c[w>>2]|0;if((F|0)!=(l|0)){c[w>>2]=l+(~((l-4+(-F|0)|0)>>>2)<<2)}Lw(v);G=A;H=t;I=G;J=0;K=I;L=H;bg(K|0)}Bv(m,0);L26:do{if((c[s>>2]|0)==6){t=c[r>>2]|0;if((t|0)==0){z=0;aS(10);if(z){z=0;N=42;break}return 0}if((c[(c[(c[t>>2]|0)-4>>2]|0)+4>>2]|0)!=26800){N=52;break}t=c[b+4>>2]|0;A=(z=0,au(248,52)|0);if(z){z=0;N=42;break}v=A;c[j>>2]=v;A=t+4|0;F=c[A>>2]|0;if((F|0)==(c[t+8>>2]|0)){z=0;as(382,t|0,j|0);if(z){z=0;N=42;break}O=c[j>>2]|0}else{if((F|0)==0){P=0}else{c[F>>2]=v;P=c[A>>2]|0}c[A>>2]=P+4;O=v}v=O;F=d+4|0;L42:do{if((a[F]&1)==0){l=n;c[l>>2]=c[F>>2];c[l+4>>2]=c[F+4>>2];c[l+8>>2]=c[F+8>>2];N=39}else{l=c[d+12>>2]|0;w=c[d+8>>2]|0;do{if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(w>>>0<11>>>0){a[n]=w<<1;Q=n+1|0}else{y=w+16&-16;x=(z=0,au(248,y|0)|0);if(z){z=0;break}c[n+8>>2]=x;c[n>>2]=y|1;c[n+4>>2]=w;Q=x}LF(Q|0,l|0,w)|0;a[Q+w|0]=0;N=39;break L42}}while(0);w=bT(-1,-1)|0;R=w;S=M}}while(0);do{if((N|0)==39){F=d+16|0;w=g;c[w>>2]=c[F>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];z=0;aq(38,O|0,n|0,g|0,38320,0);if(!z){c[r>>2]=O;if((a[n]&1)==0){N=52;break L26}Lw(c[n+8>>2]|0);N=52;break L26}else{z=0;F=bT(-1,-1)|0;w=F;F=M;if((a[n]&1)==0){R=w;S=F;break}Lw(c[n+8>>2]|0);R=w;S=F;break}}}while(0);F=c[t>>2]|0;w=c[A>>2]|0;l=F;while(1){if((l|0)==(w|0)){T=w;break}if((c[l>>2]|0)==(O|0)){T=l;break}else{l=l+4|0}}l=T-F>>2;t=F+(l+1<<2)|0;x=w-t|0;LG(F+(l<<2)|0,t|0,x|0)|0;t=F+((x>>2)+l<<2)|0;l=c[A>>2]|0;if((t|0)!=(l|0)){c[A>>2]=l+(~((l-4+(-t|0)|0)>>>2)<<2)}Lw(v);U=R;V=S}else{N=52}}while(0);do{if((N|0)==52){S=c[b+4>>2]|0;R=(z=0,au(248,52)|0);if(z){z=0;N=42;break}T=R;c[f>>2]=T;R=S+4|0;O=c[R>>2]|0;if((O|0)==(c[S+8>>2]|0)){z=0;as(382,S|0,f|0);if(z){z=0;N=42;break}W=c[f>>2]|0}else{if((O|0)==0){X=0}else{c[O>>2]=T;X=c[R>>2]|0}c[R>>2]=X+4;W=T}T=W;O=W;n=d+4|0;L81:do{if((a[n]&1)==0){r=o;c[r>>2]=c[n>>2];c[r+4>>2]=c[n+4>>2];c[r+8>>2]=c[n+8>>2];N=69}else{r=c[d+12>>2]|0;g=c[d+8>>2]|0;do{if(g>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(g>>>0<11>>>0){a[o]=g<<1;Y=o+1|0}else{Q=g+16&-16;P=(z=0,au(248,Q|0)|0);if(z){z=0;break}c[o+8>>2]=P;c[o>>2]=Q|1;c[o+4>>2]=g;Y=P}LF(Y|0,r|0,g)|0;a[Y+g|0]=0;N=69;break L81}}while(0);g=bT(-1,-1)|0;Z=g;_=M}}while(0);do{if((N|0)==69){n=p;v=d+16|0;c[n>>2]=c[v>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];z=0;aR(c[(c[d>>2]|0)+28>>2]|0,q|0,d|0,m|0);do{if(!z){v=k;c[v>>2]=c[n>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];z=0;aq(28,O|0,o|0,k|0,q|0,0);if(z){z=0;v=bT(-1,-1)|0;A=v;v=M;if((a[q]&1)==0){$=A;aa=v;break}Lw(c[q+8>>2]|0);$=A;aa=v;break}if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}Bx(m);D=T;E=D;i=e;return E|0}else{z=0;v=bT(-1,-1)|0;$=v;aa=M}}while(0);if((a[o]&1)==0){Z=$;_=aa;break}Lw(c[o+8>>2]|0);Z=$;_=aa}}while(0);O=c[S>>2]|0;n=c[R>>2]|0;v=O;while(1){if((v|0)==(n|0)){ab=n;break}if((c[v>>2]|0)==(W|0)){ab=v;break}else{v=v+4|0}}v=ab-O>>2;S=O+(v+1<<2)|0;A=n-S|0;LG(O+(v<<2)|0,S|0,A|0)|0;S=O+((A>>2)+v<<2)|0;v=c[R>>2]|0;if((S|0)!=(v|0)){c[R>>2]=v+(~((v-4+(-S|0)|0)>>>2)<<2)}Lw(T);U=Z;V=_}}while(0);if((N|0)==42){N=bT(-1,-1)|0;U=N;V=M}z=0;ar(444,m|0);if(!z){G=U;H=V;I=G;J=0;K=I;L=H;bg(K|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function jg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aN=0,aO=0,aP=0,aS=0,aT=0,aU=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ee=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0,ep=0,eq=0,er=0,es=0,et=0,eu=0,ev=0,ew=0,ex=0,ey=0,ez=0,eA=0,eB=0,eC=0,eD=0,eE=0,eF=0,eG=0,eH=0,eI=0,eJ=0,eK=0,eL=0,eM=0,eN=0,eO=0,eP=0,eQ=0,eR=0,eS=0,eT=0,eU=0,eV=0,eW=0,eX=0,eY=0,eZ=0,e_=0,e$=0,e0=0,e1=0,e2=0,e3=0,e4=0,e5=0,e6=0,e7=0,e8=0,e9=0,fa=0,fb=0,fc=0,fd=0,fe=0,ff=0,fg=0,fh=0,fi=0,fj=0,fk=0,fl=0,fm=0,fn=0,fo=0,fp=0,fq=0,fr=0,fs=0,ft=0,fu=0,fv=0,fw=0,fx=0,fy=0;e=i;i=i+128|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+88|0;n=e+104|0;o=e+112|0;p=o;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+12|0;i=i+7&-8;w=i;i=i+8|0;x=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+16|0;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+40|0;G=i;i=i+12|0;i=i+7&-8;H=i;i=i+12|0;i=i+7&-8;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+12|0;i=i+7&-8;K=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+12|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+12|0;i=i+7&-8;T=i;i=i+12|0;i=i+7&-8;U=i;i=i+40|0;V=i;i=i+12|0;i=i+7&-8;W=i;i=i+12|0;i=i+7&-8;X=i;i=i+12|0;i=i+7&-8;Y=i;i=i+12|0;i=i+7&-8;Z=i;i=i+12|0;i=i+7&-8;_=i;i=i+12|0;i=i+7&-8;$=i;i=i+12|0;i=i+7&-8;aa=i;i=i+12|0;i=i+7&-8;ab=i;i=i+12|0;i=i+7&-8;ac=i;i=i+40|0;ad=i;i=i+12|0;i=i+7&-8;ae=i;i=i+12|0;i=i+7&-8;af=i;i=i+12|0;i=i+7&-8;ag=i;i=i+12|0;i=i+7&-8;ah=i;i=i+12|0;i=i+7&-8;ai=i;i=i+4|0;i=i+7&-8;aj=i;i=i+40|0;ak=i;i=i+40|0;al=i;i=i+12|0;i=i+7&-8;am=i;i=i+12|0;i=i+7&-8;an=i;i=i+12|0;i=i+7&-8;ao=i;i=i+12|0;i=i+7&-8;ap=i;i=i+12|0;i=i+7&-8;av=i;i=i+12|0;i=i+7&-8;aw=i;i=i+40|0;ax=i;i=i+12|0;i=i+7&-8;ay=i;i=i+12|0;i=i+7&-8;aA=i;i=i+144|0;aB=i;i=i+12|0;i=i+7&-8;aC=i;i=i+12|0;i=i+7&-8;aE=i;i=i+12|0;i=i+7&-8;aF=i;i=i+12|0;i=i+7&-8;aG=i;i=i+12|0;i=i+7&-8;aH=i;i=i+12|0;i=i+7&-8;aI=i;i=i+12|0;i=i+7&-8;aJ=i;i=i+12|0;i=i+7&-8;aK=i;i=i+16|0;aL=i;i=i+12|0;i=i+7&-8;aN=i;i=i+12|0;i=i+7&-8;aO=i;i=i+40|0;aP=i;i=i+12|0;i=i+7&-8;aS=i;i=i+12|0;i=i+7&-8;aT=i;i=i+12|0;i=i+7&-8;aU=i;i=i+12|0;i=i+7&-8;aW=i;i=i+12|0;i=i+7&-8;aX=i;i=i+12|0;i=i+7&-8;aY=i;i=i+12|0;i=i+7&-8;aZ=c[d+48>>2]|0;a_=b|0;a$=cV[c[(c[aZ>>2]|0)+20>>2]&1023](aZ,a_)|0;aZ=a$;a0=d+36|0;if((a[a0]&1)==0){a1=r;c[a1>>2]=c[a0>>2];c[a1+4>>2]=c[a0+4>>2];c[a1+8>>2]=c[a0+8>>2];a2=a[a1]|0;a3=a1}else{a1=c[d+44>>2]|0;a4=c[d+40>>2]|0;if(a4>>>0>4294967279>>>0){D5(0);return 0}if(a4>>>0<11>>>0){a5=a4<<1&255;a6=r;a[a6]=a5;a7=r+1|0;a8=a5;a9=a6}else{a6=a4+16&-16;a5=Lu(a6)|0;c[r+8>>2]=a5;ba=a6|1;c[r>>2]=ba;c[r+4>>2]=a4;a7=a5;a8=ba&255;a9=r}LF(a7|0,a1|0,a4)|0;a[a7+a4|0]=0;a2=a8;a3=a9}a9=q;LI(a9|0,0,12)|0;a8=a2&255;if((a8&1|0)==0){bb=a8>>>1}else{bb=c[r+4>>2]|0}if((a2&1)==0){bc=r+1|0}else{bc=c[r+8>>2]|0}a2=bb+3|0;do{if(a2>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(a2>>>0<11>>>0){a[a9]=bb<<1;bd=q+1|0}else{a8=bb+19&-16;a4=(z=0,au(248,a8|0)|0);if(z){z=0;break}c[q+8>>2]=a4;c[q>>2]=a8|1;c[q+4>>2]=bb;bd=a4}LF(bd|0,bc|0,bb)|0;a[bd+bb|0]=0;z=0,az(88,q|0,5952,3)|0;if(z){z=0;break}if((a[a3]&1)!=0){Lw(c[r+8>>2]|0)}a4=b+8|0;a8=c[a4>>2]|0;do{if((a[a9]&1)==0){a7=s;c[a7>>2]=c[a9>>2];c[a7+4>>2]=c[a9+4>>2];c[a7+8>>2]=c[a9+8>>2];be=37}else{a7=c[q+8>>2]|0;a1=c[q+4>>2]|0;if(a1>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=101;break}return 0}if(a1>>>0<11>>>0){a[s]=a1<<1;bf=s+1|0}else{ba=a1+16&-16;a5=(z=0,au(248,ba|0)|0);if(z){z=0;be=101;break}c[s+8>>2]=a5;c[s>>2]=ba|1;c[s+4>>2]=a1;bf=a5}LF(bf|0,a7|0,a1)|0;a[bf+a1|0]=0;be=37}}while(0);L43:do{if((be|0)==37){a1=(z=0,aM(560,a8|0,s|0)|0);if(z){z=0;a7=bT(-1,-1)|0;a5=a7;a7=M;if((a[s]&1)==0){bh=a5;bi=a7;break}Lw(c[s+8>>2]|0);bh=a5;bi=a7;break}if((a[s]&1)!=0){Lw(c[s+8>>2]|0)}L52:do{if(a1){a7=d|0;a5=c[a4>>2]|0;if((a[a9]&1)==0){ba=B;c[ba>>2]=c[a9>>2];c[ba+4>>2]=c[a9+4>>2];c[ba+8>>2]=c[a9+8>>2]}else{ba=c[q+8>>2]|0;a6=c[q+4>>2]|0;if(a6>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=101;break L43}return 0}if(a6>>>0<11>>>0){a[B]=a6<<1;bj=B+1|0}else{bk=a6+16&-16;bl=(z=0,au(248,bk|0)|0);if(z){z=0;be=101;break L43}c[B+8>>2]=bl;c[B>>2]=bk|1;c[B+4>>2]=a6;bj=bl}LF(bj|0,ba|0,a6)|0;a[bj+a6|0]=0}a6=(z=0,aM(90,a5|0,B|0)|0);if(z){z=0;a5=bT(-1,-1)|0;ba=a5;a5=M;if((a[B]&1)==0){bh=ba;bi=a5;break L43}Lw(c[B+8>>2]|0);bh=ba;bi=a5;break L43}a5=c[a6>>2]|0;if((a[B]&1)!=0){Lw(c[B+8>>2]|0)}a6=c[a5+28>>2]|0;ba=c[a5+56>>2]|0;bl=c[a5+60>>2]|0;bk=a$+44|0;bm=a$+40|0;bn=c[bm>>2]|0;bo=(c[bk>>2]|0)-bn>>2;L186:do{if((bo|0)!=0){bp=0;bq=bn;while(1){br=(c[bq+(bp<<2)>>2]|0)+36|0;bs=c[br>>2]|0;bt=(z=0,aM(c[(c[bs>>2]|0)+20>>2]|0,bs|0,a_|0)|0);if(z){z=0;break}c[br>>2]=bt;bt=bp+1|0;if(bt>>>0>=bo>>>0){break L186}bp=bt;bq=c[bm>>2]|0}bq=bT(-1,-1)|0;bu=M;bv=bq;be=102;break L43}}while(0);bo=c[a5+44>>2]|0;bn=C+4|0;c[bn>>2]=0;c[C+8>>2]=0;c[C>>2]=bn;bn=C+12|0;c[bn>>2]=0;c[bn>>2]=c[a5+48>>2];L193:do{if((a6|0)==0){if((ba|0)!=0){if((a[a0]&1)==0){bn=T;c[bn>>2]=c[a0>>2];c[bn+4>>2]=c[a0+4>>2];c[bn+8>>2]=c[a0+8>>2];bw=a[bn]|0;bx=bn}else{bn=c[d+44>>2]|0;bq=c[d+40>>2]|0;if(bq>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=293;break}return 0}if(bq>>>0<11>>>0){bp=bq<<1&255;bt=T;a[bt]=bp;by=T+1|0;bz=bp;bA=bt}else{bt=bq+16&-16;bp=(z=0,au(248,bt|0)|0);if(z){z=0;be=293;break}c[T+8>>2]=bp;br=bt|1;c[T>>2]=br;c[T+4>>2]=bq;by=bp;bz=br&255;bA=T}LF(by|0,bn|0,bq)|0;a[by+bq|0]=0;bw=bz;bx=bA}bq=S;LI(bq|0,0,12)|0;bn=T;br=bw&255;if((br&1|0)==0){bB=br>>>1}else{bB=c[T+4>>2]|0}br=bB+9|0;do{if(br>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=359;break}return 0}else{if(br>>>0<11>>>0){a[bq]=18;bC=S+1|0}else{bp=bB+25&-16;bt=(z=0,au(248,bp|0)|0);if(z){z=0;be=359;break}c[S+8>>2]=bt;c[S>>2]=bp|1;c[S+4>>2]=9;bC=bt}LF(bC|0,4912,9)|0;a[bC+9|0]=0;if((a[bx]&1)==0){bD=bn+1|0}else{bD=c[T+8>>2]|0}z=0,az(88,S|0,bD|0,bB|0)|0;if(z){z=0;be=359;break}bt=b+4|0;z=0;aD(24,S|0,bo|0,aZ|0,c[bt>>2]|0,C|0,b|0);if(z){z=0;bp=bT(-1,-1)|0;bs=bp;bp=M;if((a[bq]&1)==0){bE=bs;bF=bp;break}Lw(c[S+8>>2]|0);bE=bs;bF=bp;break}if((a[bq]&1)!=0){Lw(c[S+8>>2]|0)}if((a[bx]&1)!=0){Lw(c[T+8>>2]|0)}bp=c[a4>>2]|0;c[a4>>2]=C;bs=b+12|0;bG=c[bs>>2]|0;bH=d+4|0;if((a[bH]&1)==0){bI=V;c[bI>>2]=c[bH>>2];c[bI+4>>2]=c[bH+4>>2];c[bI+8>>2]=c[bH+8>>2]}else{bI=c[d+12>>2]|0;bJ=c[d+8>>2]|0;if(bJ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=293;break L193}return 0}if(bJ>>>0<11>>>0){a[V]=bJ<<1;bK=V+1|0}else{bL=bJ+16&-16;bM=(z=0,au(248,bL|0)|0);if(z){z=0;be=293;break L193}c[V+8>>2]=bM;c[V>>2]=bL|1;c[V+4>>2]=bJ;bK=bM}LF(bK|0,bI|0,bJ)|0;a[bK+bJ|0]=0}bJ=W;bI=d+16|0;c[bJ>>2]=c[bI>>2];c[bJ+4>>2]=c[bI+4>>2];c[bJ+8>>2]=c[bI+8>>2];L492:do{if((a[a0]&1)==0){bM=Z;c[bM>>2]=c[a0>>2];c[bM+4>>2]=c[a0+4>>2];c[bM+8>>2]=c[a0+8>>2];bN=a[bM]|0;bO=bM;be=386}else{bM=c[d+44>>2]|0;bL=c[d+40>>2]|0;do{if(bL>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bL>>>0<11>>>0){bP=bL<<1&255;bQ=Z;a[bQ]=bP;bR=Z+1|0;bS=bP;bU=bQ}else{bQ=bL+16&-16;bP=(z=0,au(248,bQ|0)|0);if(z){z=0;break}c[Z+8>>2]=bP;bV=bQ|1;c[Z>>2]=bV;c[Z+4>>2]=bL;bR=bP;bS=bV&255;bU=Z}LF(bR|0,bM|0,bL)|0;a[bR+bL|0]=0;bN=bS;bO=bU;be=386;break L492}}while(0);bL=bT(-1,-1)|0;bW=bL;bY=M}}while(0);do{if((be|0)==386){bL=Y;LI(bL|0,0,12)|0;bM=Z;bV=bN&255;if((bV&1|0)==0){bZ=bV>>>1}else{bZ=c[Z+4>>2]|0}bV=bZ+15|0;do{if(bV>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=400;break}return 0}else{if(bV>>>0<11>>>0){a[bL]=30;b_=Y+1|0}else{bP=bZ+31&-16;bQ=(z=0,au(248,bP|0)|0);if(z){z=0;be=400;break}c[Y+8>>2]=bQ;c[Y>>2]=bP|1;c[Y+4>>2]=15;b_=bQ}LF(b_|0,3496,15)|0;a[b_+15|0]=0;if((a[bO]&1)==0){b$=bM+1|0}else{b$=c[Z+8>>2]|0}z=0,az(88,Y|0,b$|0,bZ|0)|0;if(z){z=0;be=400;break}bQ=X;LI(bQ|0,0,12)|0;bP=a[bL]|0;b0=bP&255;if((b0&1|0)==0){b1=b0>>>1}else{b1=c[Y+4>>2]|0}if((bP&1)==0){b2=Y+1|0}else{b2=c[Y+8>>2]|0}bP=b1+1|0;do{if(bP>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=416;break}return 0}else{if(bP>>>0<11>>>0){a[bQ]=b1<<1;b3=X+1|0}else{b0=b1+17&-16;b4=(z=0,au(248,b0|0)|0);if(z){z=0;be=416;break}c[X+8>>2]=b4;c[X>>2]=b0|1;c[X+4>>2]=b1;b3=b4}LF(b3|0,b2|0,b1)|0;a[b3+b1|0]=0;z=0,az(88,X|0,2176,1)|0;if(z){z=0;be=416;break}b4=h;c[b4>>2]=c[bJ>>2];c[b4+4>>2]=c[bJ+4>>2];c[b4+8>>2]=c[bJ+8>>2];z=0;aq(26,U|0,bG|0,V|0,h|0,X|0);if(z){z=0;b4=bT(-1,-1)|0;b0=b4;b4=M;if((a[bQ]&1)==0){b5=b0;b6=b4;break}Lw(c[X+8>>2]|0);b5=b0;b6=b4;break}if((a[bQ]&1)!=0){Lw(c[X+8>>2]|0)}if((a[bL]&1)!=0){Lw(c[Y+8>>2]|0)}if((a[bO]&1)!=0){Lw(c[Z+8>>2]|0)}if((a[V]&1)!=0){Lw(c[V+8>>2]|0)}c[bs>>2]=U;b4=c[a4>>2]|0;b0=c[bt>>2]|0;b7=c[a5+72>>2]|0;L559:do{if((a[bH]&1)==0){b8=_;c[b8>>2]=c[bH>>2];c[b8+4>>2]=c[bH+4>>2];c[b8+8>>2]=c[bH+8>>2];be=437}else{b8=c[d+12>>2]|0;b9=c[d+8>>2]|0;do{if(b9>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(b9>>>0<11>>>0){a[_]=b9<<1;ca=_+1|0}else{cb=b9+16&-16;cc=(z=0,au(248,cb|0)|0);if(z){z=0;break}c[_+8>>2]=cc;c[_>>2]=cb|1;c[_+4>>2]=b9;ca=cc}LF(ca|0,b8|0,b9)|0;a[ca+b9|0]=0;be=437;break L559}}while(0);b9=bT(-1,-1)|0;cd=b9;ce=M}}while(0);do{if((be|0)==437){b9=$;c[b9>>2]=c[bI>>2];c[b9+4>>2]=c[bI+4>>2];c[b9+8>>2]=c[bI+8>>2];b9=(z=0,at(ba|0,b4|0,b0|0,b7|0,_|0,$|0,U|0)|0);if(z){z=0;b8=bT(-1,-1)|0;cc=b8;b8=M;if((a[_]&1)==0){cd=cc;ce=b8;break}Lw(c[_+8>>2]|0);cd=cc;ce=b8;break}if((a[_]&1)!=0){Lw(c[_+8>>2]|0)}c[bs>>2]=c[U>>2];c[a4>>2]=bp;if((a[U+28|0]&1)!=0){Lw(c[U+36>>2]|0)}if((a[U+4|0]&1)==0){cf=b9;cg=bI;be=970;break L193}Lw(c[U+12>>2]|0);cf=b9;cg=bI;be=970;break L193}}while(0);if((a[U+28|0]&1)!=0){Lw(c[U+36>>2]|0)}if((a[U+4|0]&1)==0){ch=cd;ci=ce;break L193}Lw(c[U+12>>2]|0);ch=cd;ci=ce;break L193}}while(0);if((be|0)==416){bP=bT(-1,-1)|0;b7=M;if((a[bQ]&1)!=0){Lw(c[X+8>>2]|0)}b5=bP;b6=b7}if((a[bL]&1)==0){cj=b5;ck=b6;break}Lw(c[Y+8>>2]|0);cj=b5;ck=b6}}while(0);if((be|0)==400){bM=bT(-1,-1)|0;bV=M;if((a[bL]&1)!=0){Lw(c[Y+8>>2]|0)}cj=bM;ck=bV}if((a[bO]&1)==0){bW=cj;bY=ck;break}Lw(c[Z+8>>2]|0);bW=cj;bY=ck}}while(0);if((a[V]&1)==0){ch=bW;ci=bY;break L193}Lw(c[V+8>>2]|0);ch=bW;ci=bY;break L193}}while(0);if((be|0)==359){bn=bT(-1,-1)|0;br=M;if((a[bq]&1)!=0){Lw(c[S+8>>2]|0)}bE=bn;bF=br}if((a[bx]&1)==0){ch=bE;ci=bF;break}Lw(c[T+8>>2]|0);ch=bE;ci=bF;break}if((bl|0)!=0){if((a[a0]&1)==0){br=ab;c[br>>2]=c[a0>>2];c[br+4>>2]=c[a0+4>>2];c[br+8>>2]=c[a0+8>>2];cl=a[br]|0;cm=br}else{br=c[d+44>>2]|0;bn=c[d+40>>2]|0;if(bn>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=293;break}return 0}if(bn>>>0<11>>>0){bI=bn<<1&255;bp=ab;a[bp]=bI;cn=ab+1|0;co=bI;cp=bp}else{bp=bn+16&-16;bI=(z=0,au(248,bp|0)|0);if(z){z=0;be=293;break}c[ab+8>>2]=bI;bs=bp|1;c[ab>>2]=bs;c[ab+4>>2]=bn;cn=bI;co=bs&255;cp=ab}LF(cn|0,br|0,bn)|0;a[cn+bn|0]=0;cl=co;cm=cp}bn=aa;LI(bn|0,0,12)|0;br=ab;bs=cl&255;if((bs&1|0)==0){cq=bs>>>1}else{cq=c[ab+4>>2]|0}bs=cq+9|0;do{if(bs>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=492;break}return 0}else{if(bs>>>0<11>>>0){a[bn]=18;cr=aa+1|0}else{bI=cq+25&-16;bp=(z=0,au(248,bI|0)|0);if(z){z=0;be=492;break}c[aa+8>>2]=bp;c[aa>>2]=bI|1;c[aa+4>>2]=9;cr=bp}LF(cr|0,4912,9)|0;a[cr+9|0]=0;if((a[cm]&1)==0){cs=br+1|0}else{cs=c[ab+8>>2]|0}z=0,az(88,aa|0,cs|0,cq|0)|0;if(z){z=0;be=492;break}bp=b+4|0;z=0;aD(24,aa|0,bo|0,aZ|0,c[bp>>2]|0,C|0,b|0);if(z){z=0;bI=bT(-1,-1)|0;bH=bI;bI=M;if((a[bn]&1)==0){ct=bH;cu=bI;break}Lw(c[aa+8>>2]|0);ct=bH;cu=bI;break}if((a[bn]&1)!=0){Lw(c[aa+8>>2]|0)}if((a[cm]&1)!=0){Lw(c[ab+8>>2]|0)}bI=c[a4>>2]|0;c[a4>>2]=C;bH=b+12|0;bt=c[bH>>2]|0;bG=d+4|0;if((a[bG]&1)==0){bJ=ad;c[bJ>>2]=c[bG>>2];c[bJ+4>>2]=c[bG+4>>2];c[bJ+8>>2]=c[bG+8>>2]}else{bJ=c[d+12>>2]|0;bV=c[d+8>>2]|0;if(bV>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=293;break L193}return 0}if(bV>>>0<11>>>0){a[ad]=bV<<1;cv=ad+1|0}else{bM=bV+16&-16;b7=(z=0,au(248,bM|0)|0);if(z){z=0;be=293;break L193}c[ad+8>>2]=b7;c[ad>>2]=bM|1;c[ad+4>>2]=bV;cv=b7}LF(cv|0,bJ|0,bV)|0;a[cv+bV|0]=0}bV=ae;bJ=d+16|0;c[bV>>2]=c[bJ>>2];c[bV+4>>2]=c[bJ+4>>2];c[bV+8>>2]=c[bJ+8>>2];L670:do{if((a[a0]&1)==0){b7=ah;c[b7>>2]=c[a0>>2];c[b7+4>>2]=c[a0+4>>2];c[b7+8>>2]=c[a0+8>>2];cw=a[b7]|0;cx=b7;be=519}else{b7=c[d+44>>2]|0;bM=c[d+40>>2]|0;do{if(bM>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bM>>>0<11>>>0){bP=bM<<1&255;b0=ah;a[b0]=bP;cy=ah+1|0;cz=bP;cA=b0}else{b0=bM+16&-16;bP=(z=0,au(248,b0|0)|0);if(z){z=0;break}c[ah+8>>2]=bP;b4=b0|1;c[ah>>2]=b4;c[ah+4>>2]=bM;cy=bP;cz=b4&255;cA=ah}LF(cy|0,b7|0,bM)|0;a[cy+bM|0]=0;cw=cz;cx=cA;be=519;break L670}}while(0);bM=bT(-1,-1)|0;cB=bM;cC=M}}while(0);do{if((be|0)==519){bM=ag;LI(bM|0,0,12)|0;b7=ah;bL=cw&255;if((bL&1|0)==0){cD=bL>>>1}else{cD=c[ah+4>>2]|0}bL=cD+15|0;do{if(bL>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=533;break}return 0}else{if(bL>>>0<11>>>0){a[bM]=30;cE=ag+1|0}else{b4=cD+31&-16;bP=(z=0,au(248,b4|0)|0);if(z){z=0;be=533;break}c[ag+8>>2]=bP;c[ag>>2]=b4|1;c[ag+4>>2]=15;cE=bP}LF(cE|0,3496,15)|0;a[cE+15|0]=0;if((a[cx]&1)==0){cF=b7+1|0}else{cF=c[ah+8>>2]|0}z=0,az(88,ag|0,cF|0,cD|0)|0;if(z){z=0;be=533;break}bP=af;LI(bP|0,0,12)|0;b4=a[bM]|0;b0=b4&255;if((b0&1|0)==0){cG=b0>>>1}else{cG=c[ag+4>>2]|0}if((b4&1)==0){cH=ag+1|0}else{cH=c[ag+8>>2]|0}b4=cG+1|0;do{if(b4>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=549;break}return 0}else{if(b4>>>0<11>>>0){a[bP]=cG<<1;cI=af+1|0}else{b0=cG+17&-16;b9=(z=0,au(248,b0|0)|0);if(z){z=0;be=549;break}c[af+8>>2]=b9;c[af>>2]=b0|1;c[af+4>>2]=cG;cI=b9}LF(cI|0,cH|0,cG)|0;a[cI+cG|0]=0;z=0,az(88,af|0,2176,1)|0;if(z){z=0;be=549;break}b9=g;c[b9>>2]=c[bV>>2];c[b9+4>>2]=c[bV+4>>2];c[b9+8>>2]=c[bV+8>>2];z=0;aq(26,ac|0,bt|0,ad|0,g|0,af|0);if(z){z=0;b9=bT(-1,-1)|0;b0=b9;b9=M;if((a[bP]&1)==0){cJ=b0;cK=b9;break}Lw(c[af+8>>2]|0);cJ=b0;cK=b9;break}if((a[bP]&1)!=0){Lw(c[af+8>>2]|0)}if((a[bM]&1)!=0){Lw(c[ag+8>>2]|0)}if((a[cx]&1)!=0){Lw(c[ah+8>>2]|0)}if((a[ad]&1)!=0){Lw(c[ad+8>>2]|0)}c[bH>>2]=ac;c[ai>>2]=19288;z=0;aR(c[(c[a$>>2]|0)+32>>2]|0,ak|0,aZ|0,ai|0);L737:do{if(!z){z=0;aR(bl|0,aj|0,ak|0,c[a5+64>>2]|0);if(z){z=0;be=658;break}L740:do{if((c[aj>>2]|0)==6){if((a[a0]&1)==0){b9=ao;c[b9>>2]=c[a0>>2];c[b9+4>>2]=c[a0+4>>2];c[b9+8>>2]=c[a0+8>>2];cL=a[b9]|0;cM=b9}else{b9=c[d+44>>2]|0;b0=c[d+40>>2]|0;if(b0>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=658;break L737}return 0}if(b0>>>0<11>>>0){b8=b0<<1&255;cc=ao;a[cc]=b8;cN=ao+1|0;cO=b8;cP=cc}else{cc=b0+16&-16;b8=(z=0,au(248,cc|0)|0);if(z){z=0;be=658;break L737}c[ao+8>>2]=b8;cb=cc|1;c[ao>>2]=cb;c[ao+4>>2]=b0;cN=b8;cO=cb&255;cP=ao}LF(cN|0,b9|0,b0)|0;a[cN+b0|0]=0;cL=cO;cM=cP}b0=an;LI(b0|0,0,12)|0;b9=ao;cb=cL&255;if((cb&1|0)==0){cQ=cb>>>1}else{cQ=c[ao+4>>2]|0}cb=cQ+20|0;do{if(cb>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=587;break}return 0}else{if(cb>>>0<11>>>0){a[b0]=40;cR=an+1|0}else{b8=cQ+36&-16;cc=(z=0,au(248,b8|0)|0);if(z){z=0;be=587;break}c[an+8>>2]=cc;c[an>>2]=b8|1;c[an+4>>2]=20;cR=cc}LF(cR|0,632,20)|0;a[cR+20|0]=0;if((a[cM]&1)==0){cS=b9+1|0}else{cS=c[ao+8>>2]|0}z=0,az(88,an|0,cS|0,cQ|0)|0;if(z){z=0;be=587;break}cc=am;LI(cc|0,0,12)|0;b8=a[b0]|0;cT=b8&255;if((cT&1|0)==0){cU=cT>>>1}else{cU=c[an+4>>2]|0}if((b8&1)==0){cW=an+1|0}else{cW=c[an+8>>2]|0}b8=cU+2|0;do{if(b8>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=603;break}return 0}else{if(b8>>>0<11>>>0){a[cc]=cU<<1;cX=am+1|0}else{cT=cU+18&-16;cY=(z=0,au(248,cT|0)|0);if(z){z=0;be=603;break}c[am+8>>2]=cY;c[am>>2]=cT|1;c[am+4>>2]=cU;cX=cY}LF(cX|0,cW|0,cU)|0;a[cX+cU|0]=0;z=0,az(88,am|0,13240,2)|0;if(z){z=0;be=603;break}cY=c[aj+4>>2]|0;cT=al;LI(cT|0,0,12)|0;cZ=a[cc]|0;c_=cZ&255;if((c_&1|0)==0){c$=c_>>>1}else{c$=c[am+4>>2]|0}c_=LJ(cY|0)|0;if((cZ&1)==0){c0=am+1|0}else{c0=c[am+8>>2]|0}cZ=c_+c$|0;do{if(cZ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=619;break}return 0}else{if(cZ>>>0<11>>>0){a[cT]=c$<<1;c1=al+1|0}else{c2=cZ+16&-16;c3=(z=0,au(248,c2|0)|0);if(z){z=0;be=619;break}c[al+8>>2]=c3;c[al>>2]=c2|1;c[al+4>>2]=c$;c1=c3}LF(c1|0,c0|0,c$)|0;a[c1+c$|0]=0;z=0,az(88,al|0,cY|0,c_|0)|0;if(z){z=0;be=619;break}L809:do{if((a[bG]&1)==0){c3=ap;c[c3>>2]=c[bG>>2];c[c3+4>>2]=c[bG+4>>2];c[c3+8>>2]=c[bG+8>>2];be=631}else{c3=c[d+12>>2]|0;c2=c[d+8>>2]|0;do{if(c2>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(c2>>>0<11>>>0){a[ap]=c2<<1;c4=ap+1|0}else{c5=c2+16&-16;c6=(z=0,au(248,c5|0)|0);if(z){z=0;break}c[ap+8>>2]=c6;c[ap>>2]=c5|1;c[ap+4>>2]=c2;c4=c6}LF(c4|0,c3|0,c2)|0;a[c4+c2|0]=0;be=631;break L809}}while(0);c2=bT(-1,-1)|0;c7=c2;c8=M}}while(0);do{if((be|0)==631){c2=av;c[c2>>2]=c[bJ>>2];c[c2+4>>2]=c[bJ+4>>2];c[c2+8>>2]=c[bJ+8>>2];z=0;aV(46,al|0,ap|0,av|0,c[bH>>2]|0);if(z){z=0;c2=bT(-1,-1)|0;c3=c2;c2=M;if((a[ap]&1)==0){c7=c3;c8=c2;break}Lw(c[ap+8>>2]|0);c7=c3;c8=c2;break}if((a[ap]&1)!=0){Lw(c[ap+8>>2]|0)}if((a[cT]&1)!=0){Lw(c[al+8>>2]|0)}if((a[cc]&1)!=0){Lw(c[am+8>>2]|0)}if((a[b0]&1)!=0){Lw(c[an+8>>2]|0)}if((a[cM]&1)==0){break L740}Lw(c[ao+8>>2]|0);break L740}}while(0);if((a[cT]&1)==0){c9=c7;da=c8;break}Lw(c[al+8>>2]|0);c9=c7;da=c8}}while(0);if((be|0)==619){c_=bT(-1,-1)|0;cY=M;if((a[cT]&1)!=0){Lw(c[al+8>>2]|0)}c9=c_;da=cY}if((a[cc]&1)==0){db=c9;dc=da;break}Lw(c[am+8>>2]|0);db=c9;dc=da}}while(0);if((be|0)==603){b8=bT(-1,-1)|0;cY=M;if((a[cc]&1)!=0){Lw(c[am+8>>2]|0)}db=b8;dc=cY}if((a[b0]&1)==0){dd=db;de=dc;break}Lw(c[an+8>>2]|0);dd=db;de=dc}}while(0);if((be|0)==587){b9=bT(-1,-1)|0;cb=M;if((a[b0]&1)!=0){Lw(c[an+8>>2]|0)}dd=b9;de=cb}if((a[cM]&1)==0){df=dd;dg=de;break L737}Lw(c[ao+8>>2]|0);df=dd;dg=de;break L737}}while(0);cb=aw;b9=aj;c[cb>>2]=c[b9>>2];c[cb+4>>2]=c[b9+4>>2];c[cb+8>>2]=c[b9+8>>2];c[cb+12>>2]=c[b9+12>>2];c[cb+16>>2]=c[b9+16>>2];c[cb+20>>2]=c[b9+20>>2];c[cb+24>>2]=c[b9+24>>2];c[cb+28>>2]=c[b9+28>>2];c[cb+32>>2]=c[b9+32>>2];c[cb+36>>2]=c[b9+36>>2];b9=c[bp>>2]|0;cb=c[bH>>2]|0;if((a[bG]&1)==0){cY=ax;c[cY>>2]=c[bG>>2];c[cY+4>>2]=c[bG+4>>2];c[cY+8>>2]=c[bG+8>>2]}else{cY=c[d+12>>2]|0;b8=c[d+8>>2]|0;if(b8>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=658;break}return 0}if(b8>>>0<11>>>0){a[ax]=b8<<1;dh=ax+1|0}else{c_=b8+16&-16;cZ=(z=0,au(248,c_|0)|0);if(z){z=0;be=658;break}c[ax+8>>2]=cZ;c[ax>>2]=c_|1;c[ax+4>>2]=b8;dh=cZ}LF(dh|0,cY|0,b8)|0;a[dh+b8|0]=0}b8=ay;c[b8>>2]=c[bJ>>2];c[b8+4>>2]=c[bJ+4>>2];c[b8+8>>2]=c[bJ+8>>2];b8=(z=0,aQ(20,aw|0,b9|0,cb|0,ax|0,ay|0)|0);if(z){z=0;cb=bT(-1,-1)|0;b9=cb;cb=M;if((a[ax]&1)==0){df=b9;dg=cb;break}Lw(c[ax+8>>2]|0);df=b9;dg=cb;break}if((a[ax]&1)!=0){Lw(c[ax+8>>2]|0)}c[bH>>2]=c[ac>>2];c[a4>>2]=bI;if((a[ac+28|0]&1)!=0){Lw(c[ac+36>>2]|0)}if((a[ac+4|0]&1)==0){cf=b8;cg=bJ;be=970;break L193}Lw(c[ac+12>>2]|0);cf=b8;cg=bJ;be=970;break L193}else{z=0;be=658}}while(0);if((be|0)==658){b8=bT(-1,-1)|0;df=b8;dg=M}if((a[ac+28|0]&1)!=0){Lw(c[ac+36>>2]|0)}if((a[ac+4|0]&1)==0){ch=df;ci=dg;break L193}Lw(c[ac+12>>2]|0);ch=df;ci=dg;break L193}}while(0);if((be|0)==549){b4=bT(-1,-1)|0;bQ=M;if((a[bP]&1)!=0){Lw(c[af+8>>2]|0)}cJ=b4;cK=bQ}if((a[bM]&1)==0){di=cJ;dj=cK;break}Lw(c[ag+8>>2]|0);di=cJ;dj=cK}}while(0);if((be|0)==533){b7=bT(-1,-1)|0;bL=M;if((a[bM]&1)!=0){Lw(c[ag+8>>2]|0)}di=b7;dj=bL}if((a[cx]&1)==0){cB=di;cC=dj;break}Lw(c[ah+8>>2]|0);cB=di;cC=dj}}while(0);if((a[ad]&1)==0){ch=cB;ci=cC;break L193}Lw(c[ad+8>>2]|0);ch=cB;ci=cC;break L193}}while(0);if((be|0)==492){br=bT(-1,-1)|0;bs=M;if((a[bn]&1)!=0){Lw(c[aa+8>>2]|0)}ct=br;cu=bs}if((a[cm]&1)==0){ch=ct;ci=cu;break}Lw(c[ab+8>>2]|0);ch=ct;ci=cu;break}if((a[a5+68|0]&1)==0){cf=a7;cg=d+16|0;be=970;break}bs=(c[bk>>2]|0)-(c[bm>>2]|0)>>2;br=aA+64|0;bq=aA|0;bJ=aA+8|0;bI=bJ|0;c[bI>>2]=15464;bH=aA+12|0;c[bq>>2]=32540;bG=aA+64|0;c[bG>>2]=32560;c[aA+4>>2]=0;z=0;as(198,aA+64|0,bH|0);do{if(!z){c[aA+136>>2]=0;c[aA+140>>2]=-1;bp=aA+8|0;c[bq>>2]=15444;c[br>>2]=15484;c[bI>>2]=15464;bt=bH|0;c[bt>>2]=15768;bV=aA+16|0;I_(bV);LI(aA+20|0,0,24)|0;c[bt>>2]=15624;bL=aA+44|0;LI(aA+44|0,0,16)|0;c[aA+60>>2]=24;LI(p|0,0,12)|0;z=0;as(212,bH|0,o|0);if(z){z=0;b7=bT(-1,-1)|0;bQ=M;if((a[p]&1)!=0){Lw(c[o+8>>2]|0)}if((a[bL]&1)!=0){Lw(c[aA+52>>2]|0)}c[bt>>2]=15768;z=0;ar(394,bV|0);if(!z){dk=b7;dl=bQ;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}if((a[p]&1)!=0){Lw(c[o+8>>2]|0)}bQ=(z=0,aM(814,bJ|0,q|0)|0);do{if(!z){z=0,aM(312,bQ|0,bs|0)|0;if(z){z=0;be=790;break}z=0;as(576,aB|0,bH|0);if(z){z=0;be=790;break}b7=c[a4>>2]|0;bt=aB;b4=(a[bt]&1)==0;do{if(b4){b8=aC;c[b8>>2]=c[bt>>2];c[b8+4>>2]=c[bt+4>>2];c[b8+8>>2]=c[bt+8>>2];be=725}else{b8=c[aB+8>>2]|0;cb=c[aB+4>>2]|0;if(cb>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=791;break}return 0}if(cb>>>0<11>>>0){a[aC]=cb<<1;dm=aC+1|0}else{b9=cb+16&-16;cY=(z=0,au(248,b9|0)|0);if(z){z=0;be=791;break}c[aC+8>>2]=cY;c[aC>>2]=b9|1;c[aC+4>>2]=cb;dm=cY}LF(dm|0,b8|0,cb)|0;a[dm+cb|0]=0;be=725}}while(0);L954:do{if((be|0)==725){bM=(z=0,aM(560,b7|0,aC|0)|0);if(z){z=0;cb=bT(-1,-1)|0;b8=cb;cb=M;if((a[aC]&1)==0){dn=b8;dp=cb;break}Lw(c[aC+8>>2]|0);dn=b8;dp=cb;break}if((a[aC]&1)!=0){Lw(c[aC+8>>2]|0)}L963:do{if(!bM){if((a[a0]&1)==0){cb=aG;c[cb>>2]=c[a0>>2];c[cb+4>>2]=c[a0+4>>2];c[cb+8>>2]=c[a0+8>>2];dq=a[cb]|0;dr=cb}else{cb=c[d+44>>2]|0;b8=c[d+40>>2]|0;if(b8>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=791;break L954}return 0}if(b8>>>0<11>>>0){cY=b8<<1&255;b9=aG;a[b9]=cY;ds=aG+1|0;dt=cY;du=b9}else{b9=b8+16&-16;cY=(z=0,au(248,b9|0)|0);if(z){z=0;be=791;break L954}c[aG+8>>2]=cY;cZ=b9|1;c[aG>>2]=cZ;c[aG+4>>2]=b8;ds=cY;dt=cZ&255;du=aG}LF(ds|0,cb|0,b8)|0;a[ds+b8|0]=0;dq=dt;dr=du}b8=aF;LI(b8|0,0,12)|0;cb=aG;cZ=dq&255;if((cZ&1|0)==0){dv=cZ>>>1}else{dv=c[aG+4>>2]|0}cZ=dv+21|0;do{if(cZ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=753;break}return 0}else{if(cZ>>>0<11>>>0){a[b8]=42;dw=aF+1|0}else{cY=dv+37&-16;b9=(z=0,au(248,cY|0)|0);if(z){z=0;be=753;break}c[aF+8>>2]=b9;c[aF>>2]=cY|1;c[aF+4>>2]=21;dw=b9}LF(dw|0,12456,21)|0;a[dw+21|0]=0;if((a[dr]&1)==0){dx=cb+1|0}else{dx=c[aG+8>>2]|0}z=0,az(88,aF|0,dx|0,dv|0)|0;if(z){z=0;be=753;break}b9=aE;LI(b9|0,0,12)|0;cY=a[b8]|0;c_=cY&255;if((c_&1|0)==0){dy=c_>>>1}else{dy=c[aF+4>>2]|0}if((cY&1)==0){dz=aF+1|0}else{dz=c[aF+8>>2]|0}cY=dy+33|0;do{if(cY>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=769;break}return 0}else{if(cY>>>0<11>>>0){a[b9]=dy<<1;dA=aE+1|0}else{c_=dy+49&-16;c2=(z=0,au(248,c_|0)|0);if(z){z=0;be=769;break}c[aE+8>>2]=c2;c[aE>>2]=c_|1;c[aE+4>>2]=dy;dA=c2}LF(dA|0,dz|0,dy)|0;a[dA+dy|0]=0;z=0,az(88,aE|0,11680,33)|0;if(z){z=0;be=769;break}c2=d+4|0;L1014:do{if((a[c2]&1)==0){c_=aH;c[c_>>2]=c[c2>>2];c[c_+4>>2]=c[c2+4>>2];c[c_+8>>2]=c[c2+8>>2];be=781}else{c_=c[d+12>>2]|0;c3=c[d+8>>2]|0;do{if(c3>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(c3>>>0<11>>>0){a[aH]=c3<<1;dB=aH+1|0}else{c6=c3+16&-16;c5=(z=0,au(248,c6|0)|0);if(z){z=0;break}c[aH+8>>2]=c5;c[aH>>2]=c6|1;c[aH+4>>2]=c3;dB=c5}LF(dB|0,c_|0,c3)|0;a[dB+c3|0]=0;be=781;break L1014}}while(0);c3=bT(-1,-1)|0;dC=c3;dD=M}}while(0);do{if((be|0)==781){c2=aI;b0=d+16|0;c[c2>>2]=c[b0>>2];c[c2+4>>2]=c[b0+4>>2];c[c2+8>>2]=c[b0+8>>2];z=0;aR(382,aE|0,aH|0,aI|0);if(z){z=0;b0=bT(-1,-1)|0;c2=b0;b0=M;if((a[aH]&1)==0){dC=c2;dD=b0;break}Lw(c[aH+8>>2]|0);dC=c2;dD=b0;break}if((a[aH]&1)!=0){Lw(c[aH+8>>2]|0)}if((a[b9]&1)!=0){Lw(c[aE+8>>2]|0)}if((a[b8]&1)!=0){Lw(c[aF+8>>2]|0)}if((a[dr]&1)==0){break L963}Lw(c[aG+8>>2]|0);break L963}}while(0);if((a[b9]&1)==0){dE=dC;dF=dD;break}Lw(c[aE+8>>2]|0);dE=dC;dF=dD}}while(0);if((be|0)==769){cY=bT(-1,-1)|0;b0=M;if((a[b9]&1)!=0){Lw(c[aE+8>>2]|0)}dE=cY;dF=b0}if((a[b8]&1)==0){dG=dE;dH=dF;break}Lw(c[aF+8>>2]|0);dG=dE;dH=dF}}while(0);if((be|0)==753){cb=bT(-1,-1)|0;cZ=M;if((a[b8]&1)!=0){Lw(c[aF+8>>2]|0)}dG=cb;dH=cZ}if((a[dr]&1)==0){dn=dG;dp=dH;break L954}Lw(c[aG+8>>2]|0);dn=dG;dp=dH;break L954}}while(0);bM=c[a4>>2]|0;if(b4){bP=aJ;c[bP>>2]=c[bt>>2];c[bP+4>>2]=c[bt+4>>2];c[bP+8>>2]=c[bt+8>>2]}else{bP=c[aB+8>>2]|0;cZ=c[aB+4>>2]|0;if(cZ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=791;break}return 0}if(cZ>>>0<11>>>0){a[aJ]=cZ<<1;dI=aJ+1|0}else{cb=cZ+16&-16;b0=(z=0,au(248,cb|0)|0);if(z){z=0;be=791;break}c[aJ+8>>2]=b0;c[aJ>>2]=cb|1;c[aJ+4>>2]=cZ;dI=b0}LF(dI|0,bP|0,cZ)|0;a[dI+cZ|0]=0}cZ=(z=0,aM(90,bM|0,aJ|0)|0);if(z){z=0;bM=bT(-1,-1)|0;bP=bM;bM=M;if((a[aJ]&1)==0){dn=bP;dp=bM;break}Lw(c[aJ+8>>2]|0);dn=bP;dp=bM;break}bM=c[cZ>>2]|0;if((a[aJ]&1)!=0){Lw(c[aJ+8>>2]|0)}cZ=c[bM+44>>2]|0;bP=aK+4|0;c[bP>>2]=0;c[aK+8>>2]=0;c[aK>>2]=bP;bP=aK+12|0;c[bP>>2]=0;c[bP>>2]=c[bM+48>>2];do{if((a[a0]&1)==0){bP=aN;c[bP>>2]=c[a0>>2];c[bP+4>>2]=c[a0+4>>2];c[bP+8>>2]=c[a0+8>>2];dJ=a[bP]|0;dK=bP;be=828}else{bP=c[d+44>>2]|0;b0=c[d+40>>2]|0;if(b0>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=937;break}return 0}if(b0>>>0<11>>>0){cb=b0<<1&255;cY=aN;a[cY]=cb;dL=aN+1|0;dM=cb;dN=cY}else{cY=b0+16&-16;cb=(z=0,au(248,cY|0)|0);if(z){z=0;be=937;break}c[aN+8>>2]=cb;c2=cY|1;c[aN>>2]=c2;c[aN+4>>2]=b0;dL=cb;dM=c2&255;dN=aN}LF(dL|0,bP|0,b0)|0;a[dL+b0|0]=0;dJ=dM;dK=dN;be=828}}while(0);L1092:do{if((be|0)==828){b0=aL;LI(b0|0,0,12)|0;bP=aN;c2=dJ&255;if((c2&1|0)==0){dO=c2>>>1}else{dO=c[aN+4>>2]|0}c2=dO+9|0;do{if(c2>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=842;break}return 0}else{if(c2>>>0<11>>>0){a[b0]=18;dP=aL+1|0}else{cb=dO+25&-16;cY=(z=0,au(248,cb|0)|0);if(z){z=0;be=842;break}c[aL+8>>2]=cY;c[aL>>2]=cb|1;c[aL+4>>2]=9;dP=cY}LF(dP|0,4912,9)|0;a[dP+9|0]=0;if((a[dK]&1)==0){dQ=bP+1|0}else{dQ=c[aN+8>>2]|0}z=0,az(88,aL|0,dQ|0,dO|0)|0;if(z){z=0;be=842;break}cY=b+4|0;z=0;aD(24,aL|0,cZ|0,aZ|0,c[cY>>2]|0,aK|0,b|0);if(z){z=0;cb=bT(-1,-1)|0;c3=cb;cb=M;if((a[b0]&1)==0){dR=c3;dS=cb;break}Lw(c[aL+8>>2]|0);dR=c3;dS=cb;break}if((a[b0]&1)!=0){Lw(c[aL+8>>2]|0)}if((a[dK]&1)!=0){Lw(c[aN+8>>2]|0)}cb=c[a4>>2]|0;c[a4>>2]=aK;c3=b+12|0;c_=c[c3>>2]|0;cc=d+4|0;if((a[cc]&1)==0){c5=aP;c[c5>>2]=c[cc>>2];c[c5+4>>2]=c[cc+4>>2];c[c5+8>>2]=c[cc+8>>2]}else{c5=c[d+12>>2]|0;c6=c[d+8>>2]|0;if(c6>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=937;break L1092}return 0}if(c6>>>0<11>>>0){a[aP]=c6<<1;dT=aP+1|0}else{dU=c6+16&-16;dV=(z=0,au(248,dU|0)|0);if(z){z=0;be=937;break L1092}c[aP+8>>2]=dV;c[aP>>2]=dU|1;c[aP+4>>2]=c6;dT=dV}LF(dT|0,c5|0,c6)|0;a[dT+c6|0]=0}c6=aS;c5=d+16|0;c[c6>>2]=c[c5>>2];c[c6+4>>2]=c[c5+4>>2];c[c6+8>>2]=c[c5+8>>2];L1135:do{if((a[a0]&1)==0){dV=aW;c[dV>>2]=c[a0>>2];c[dV+4>>2]=c[a0+4>>2];c[dV+8>>2]=c[a0+8>>2];dW=a[dV]|0;dX=dV;be=869}else{dV=c[d+44>>2]|0;dU=c[d+40>>2]|0;do{if(dU>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(dU>>>0<11>>>0){dY=dU<<1&255;dZ=aW;a[dZ]=dY;d_=aW+1|0;d$=dY;d0=dZ}else{dZ=dU+16&-16;dY=(z=0,au(248,dZ|0)|0);if(z){z=0;break}c[aW+8>>2]=dY;d1=dZ|1;c[aW>>2]=d1;c[aW+4>>2]=dU;d_=dY;d$=d1&255;d0=aW}LF(d_|0,dV|0,dU)|0;a[d_+dU|0]=0;dW=d$;dX=d0;be=869;break L1135}}while(0);dU=bT(-1,-1)|0;d2=dU;d3=M}}while(0);do{if((be|0)==869){b9=aU;LI(b9|0,0,12)|0;dU=aW;dV=dW&255;if((dV&1|0)==0){d4=dV>>>1}else{d4=c[aW+4>>2]|0}dV=d4+15|0;do{if(dV>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=883;break}return 0}else{if(dV>>>0<11>>>0){a[b9]=30;d5=aU+1|0}else{d1=d4+31&-16;dY=(z=0,au(248,d1|0)|0);if(z){z=0;be=883;break}c[aU+8>>2]=dY;c[aU>>2]=d1|1;c[aU+4>>2]=15;d5=dY}LF(d5|0,3496,15)|0;a[d5+15|0]=0;if((a[dX]&1)==0){d6=dU+1|0}else{d6=c[aW+8>>2]|0}z=0,az(88,aU|0,d6|0,d4|0)|0;if(z){z=0;be=883;break}dY=aT;LI(dY|0,0,12)|0;d1=a[b9]|0;dZ=d1&255;if((dZ&1|0)==0){d7=dZ>>>1}else{d7=c[aU+4>>2]|0}if((d1&1)==0){d8=aU+1|0}else{d8=c[aU+8>>2]|0}d1=d7+1|0;do{if(d1>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=899;break}return 0}else{if(d1>>>0<11>>>0){a[dY]=d7<<1;d9=aT+1|0}else{dZ=d7+17&-16;ea=(z=0,au(248,dZ|0)|0);if(z){z=0;be=899;break}c[aT+8>>2]=ea;c[aT>>2]=dZ|1;c[aT+4>>2]=d7;d9=ea}LF(d9|0,d8|0,d7)|0;a[d9+d7|0]=0;z=0,az(88,aT|0,2176,1)|0;if(z){z=0;be=899;break}ea=f;c[ea>>2]=c[c6>>2];c[ea+4>>2]=c[c6+4>>2];c[ea+8>>2]=c[c6+8>>2];z=0;aq(26,aO|0,c_|0,aP|0,f|0,aT|0);if(z){z=0;ea=bT(-1,-1)|0;dZ=ea;ea=M;if((a[dY]&1)==0){eb=dZ;ec=ea;break}Lw(c[aT+8>>2]|0);eb=dZ;ec=ea;break}if((a[dY]&1)!=0){Lw(c[aT+8>>2]|0)}if((a[b9]&1)!=0){Lw(c[aU+8>>2]|0)}if((a[dX]&1)!=0){Lw(c[aW+8>>2]|0)}if((a[aP]&1)!=0){Lw(c[aP+8>>2]|0)}c[c3>>2]=aO;ea=c[bM+56>>2]|0;dZ=c[a4>>2]|0;ed=c[cY>>2]|0;ee=c[bM+72>>2]|0;L1202:do{if((a[cc]&1)==0){ef=aX;c[ef>>2]=c[cc>>2];c[ef+4>>2]=c[cc+4>>2];c[ef+8>>2]=c[cc+8>>2];be=920}else{ef=c[d+12>>2]|0;eg=c[d+8>>2]|0;do{if(eg>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(eg>>>0<11>>>0){a[aX]=eg<<1;eh=aX+1|0}else{ei=eg+16&-16;ej=(z=0,au(248,ei|0)|0);if(z){z=0;break}c[aX+8>>2]=ej;c[aX>>2]=ei|1;c[aX+4>>2]=eg;eh=ej}LF(eh|0,ef|0,eg)|0;a[eh+eg|0]=0;be=920;break L1202}}while(0);eg=bT(-1,-1)|0;ek=eg;el=M}}while(0);do{if((be|0)==920){cT=aY;c[cT>>2]=c[c5>>2];c[cT+4>>2]=c[c5+4>>2];c[cT+8>>2]=c[c5+8>>2];cT=(z=0,at(ea|0,dZ|0,ed|0,ee|0,aX|0,aY|0,aO|0)|0);if(z){z=0;eg=bT(-1,-1)|0;ef=eg;eg=M;if((a[aX]&1)==0){ek=ef;el=eg;break}Lw(c[aX+8>>2]|0);ek=ef;el=eg;break}if((a[aX]&1)!=0){Lw(c[aX+8>>2]|0)}c[c3>>2]=c[aO>>2];c[a4>>2]=cb;if((a[aO+28|0]&1)!=0){Lw(c[aO+36>>2]|0)}if((a[aO+4|0]&1)!=0){Lw(c[aO+12>>2]|0)}g_(aK|0,c[aK+4>>2]|0);if(!b4){Lw(c[aB+8>>2]|0)}c[bq>>2]=15444;c[bG>>2]=15484;c[bp>>2]=15464;eg=aA+12|0;c[eg>>2]=15624;if((a[bL]&1)!=0){Lw(c[aA+52>>2]|0)}c[eg>>2]=15768;z=0;ar(394,bV|0);if(!z){z=0;ar(272,aA+64|0);if(!z){cf=cT;cg=c5;be=970;break L193}else{z=0;be=293;break L193}}else{z=0}cT=bT(-1,-1)|0;eg=M;z=0;ar(272,aA+64|0);if(!z){em=eg;en=cT;be=294;break L193}else{z=0}bT(-1,-1,0)|0;bX();return 0}}while(0);if((a[aO+28|0]&1)!=0){Lw(c[aO+36>>2]|0)}if((a[aO+4|0]&1)==0){eo=ek;ep=el;break L1092}Lw(c[aO+12>>2]|0);eo=ek;ep=el;break L1092}}while(0);if((be|0)==899){d1=bT(-1,-1)|0;ee=M;if((a[dY]&1)!=0){Lw(c[aT+8>>2]|0)}eb=d1;ec=ee}if((a[b9]&1)==0){eq=eb;er=ec;break}Lw(c[aU+8>>2]|0);eq=eb;er=ec}}while(0);if((be|0)==883){dU=bT(-1,-1)|0;dV=M;if((a[b9]&1)!=0){Lw(c[aU+8>>2]|0)}eq=dU;er=dV}if((a[dX]&1)==0){d2=eq;d3=er;break}Lw(c[aW+8>>2]|0);d2=eq;d3=er}}while(0);if((a[aP]&1)==0){eo=d2;ep=d3;break L1092}Lw(c[aP+8>>2]|0);eo=d2;ep=d3;break L1092}}while(0);if((be|0)==842){bP=bT(-1,-1)|0;c2=M;if((a[b0]&1)!=0){Lw(c[aL+8>>2]|0)}dR=bP;dS=c2}if((a[dK]&1)==0){eo=dR;ep=dS;break}Lw(c[aN+8>>2]|0);eo=dR;ep=dS}}while(0);if((be|0)==937){bM=bT(-1,-1)|0;eo=bM;ep=M}g_(aK|0,c[aK+4>>2]|0);dn=eo;dp=ep}}while(0);if((be|0)==791){bt=bT(-1,-1)|0;dn=bt;dp=M}if(b4){es=dn;et=dp;break}Lw(c[aB+8>>2]|0);es=dn;et=dp}else{z=0;be=790}}while(0);if((be|0)==790){bQ=bT(-1,-1)|0;es=bQ;et=M}c[bq>>2]=15444;c[bG>>2]=15484;c[bp>>2]=15464;bQ=aA+12|0;c[bQ>>2]=15624;if((a[bL]&1)!=0){Lw(c[aA+52>>2]|0)}c[bQ>>2]=15768;z=0;ar(394,bV|0);if(!z){z=0;ar(272,aA+64|0);if(!z){ch=es;ci=et;break L193}else{z=0;be=978;break L52}}else{z=0}bT(-1,-1,0)|0;z=0;ar(272,aA+64|0);if(!z){bX();return 0}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{z=0;bQ=bT(-1,-1)|0;dk=bQ;dl=M}}while(0);z=0;ar(272,br|0);if(!z){em=dl;en=dk;be=294;break}else{z=0;bT(-1,-1,0)|0;bX();return 0}}else{if((a[a0]&1)==0){bG=E;c[bG>>2]=c[a0>>2];c[bG+4>>2]=c[a0+4>>2];c[bG+8>>2]=c[a0+8>>2];eu=a[bG]|0;ev=bG}else{bG=c[d+44>>2]|0;bq=c[d+40>>2]|0;if(bq>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=293;break}return 0}if(bq>>>0<11>>>0){bH=bq<<1&255;bs=E;a[bs]=bH;ew=E+1|0;ex=bH;ey=bs}else{bs=bq+16&-16;bH=(z=0,au(248,bs|0)|0);if(z){z=0;be=293;break}c[E+8>>2]=bH;bJ=bs|1;c[E>>2]=bJ;c[E+4>>2]=bq;ew=bH;ex=bJ&255;ey=E}LF(ew|0,bG|0,bq)|0;a[ew+bq|0]=0;eu=ex;ev=ey}bq=D;LI(bq|0,0,12)|0;bG=E;bJ=eu&255;if((bJ&1|0)==0){ez=bJ>>>1}else{ez=c[E+4>>2]|0}bJ=ez+9|0;do{if(bJ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=175;break}return 0}else{if(bJ>>>0<11>>>0){a[bq]=18;eA=D+1|0}else{bH=ez+25&-16;bs=(z=0,au(248,bH|0)|0);if(z){z=0;be=175;break}c[D+8>>2]=bs;c[D>>2]=bH|1;c[D+4>>2]=9;eA=bs}LF(eA|0,4912,9)|0;a[eA+9|0]=0;if((a[ev]&1)==0){eB=bG+1|0}else{eB=c[E+8>>2]|0}z=0,az(88,D|0,eB|0,ez|0)|0;if(z){z=0;be=175;break}z=0;aD(24,D|0,bo|0,aZ|0,c[b+4>>2]|0,C|0,b|0);if(z){z=0;bs=bT(-1,-1)|0;bH=bs;bs=M;if((a[bq]&1)==0){eC=bH;eD=bs;break}Lw(c[D+8>>2]|0);eC=bH;eD=bs;break}if((a[bq]&1)!=0){Lw(c[D+8>>2]|0)}if((a[ev]&1)!=0){Lw(c[E+8>>2]|0)}bs=c[a4>>2]|0;c[a4>>2]=C;bH=b+12|0;bI=c[bH>>2]|0;bn=d+4|0;if((a[bn]&1)==0){bQ=G;c[bQ>>2]=c[bn>>2];c[bQ+4>>2]=c[bn+4>>2];c[bQ+8>>2]=c[bn+8>>2]}else{bQ=c[d+12>>2]|0;bt=c[d+8>>2]|0;if(bt>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=293;break L193}return 0}if(bt>>>0<11>>>0){a[G]=bt<<1;eE=G+1|0}else{b7=bt+16&-16;bM=(z=0,au(248,b7|0)|0);if(z){z=0;be=293;break L193}c[G+8>>2]=bM;c[G>>2]=b7|1;c[G+4>>2]=bt;eE=bM}LF(eE|0,bQ|0,bt)|0;a[eE+bt|0]=0}bt=H;bQ=d+16|0;c[bt>>2]=c[bQ>>2];c[bt+4>>2]=c[bQ+4>>2];c[bt+8>>2]=c[bQ+8>>2];L249:do{if((a[a0]&1)==0){bM=K;c[bM>>2]=c[a0>>2];c[bM+4>>2]=c[a0+4>>2];c[bM+8>>2]=c[a0+8>>2];eF=a[bM]|0;eG=bM;be=202}else{bM=c[d+44>>2]|0;b7=c[d+40>>2]|0;do{if(b7>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(b7>>>0<11>>>0){cZ=b7<<1&255;c2=K;a[c2]=cZ;eH=K+1|0;eI=cZ;eJ=c2}else{c2=b7+16&-16;cZ=(z=0,au(248,c2|0)|0);if(z){z=0;break}c[K+8>>2]=cZ;bP=c2|1;c[K>>2]=bP;c[K+4>>2]=b7;eH=cZ;eI=bP&255;eJ=K}LF(eH|0,bM|0,b7)|0;a[eH+b7|0]=0;eF=eI;eG=eJ;be=202;break L249}}while(0);b7=bT(-1,-1)|0;eK=b7;eL=M}}while(0);do{if((be|0)==202){bV=J;LI(bV|0,0,12)|0;bL=K;bp=eF&255;if((bp&1|0)==0){eM=bp>>>1}else{eM=c[K+4>>2]|0}bp=eM+15|0;do{if(bp>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=216;break}return 0}else{if(bp>>>0<11>>>0){a[bV]=30;eN=J+1|0}else{b7=eM+31&-16;bM=(z=0,au(248,b7|0)|0);if(z){z=0;be=216;break}c[J+8>>2]=bM;c[J>>2]=b7|1;c[J+4>>2]=15;eN=bM}LF(eN|0,3496,15)|0;a[eN+15|0]=0;if((a[eG]&1)==0){eO=bL+1|0}else{eO=c[K+8>>2]|0}z=0,az(88,J|0,eO|0,eM|0)|0;if(z){z=0;be=216;break}bM=I;LI(bM|0,0,12)|0;b7=a[bV]|0;b4=b7&255;if((b4&1|0)==0){eP=b4>>>1}else{eP=c[J+4>>2]|0}if((b7&1)==0){eQ=J+1|0}else{eQ=c[J+8>>2]|0}b7=eP+1|0;do{if(b7>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=232;break}return 0}else{if(b7>>>0<11>>>0){a[bM]=eP<<1;eR=I+1|0}else{b4=eP+17&-16;bP=(z=0,au(248,b4|0)|0);if(z){z=0;be=232;break}c[I+8>>2]=bP;c[I>>2]=b4|1;c[I+4>>2]=eP;eR=bP}LF(eR|0,eQ|0,eP)|0;a[eR+eP|0]=0;z=0,az(88,I|0,2176,1)|0;if(z){z=0;be=232;break}bP=j;c[bP>>2]=c[bt>>2];c[bP+4>>2]=c[bt+4>>2];c[bP+8>>2]=c[bt+8>>2];z=0;aq(26,F|0,bI|0,G|0,j|0,I|0);if(z){z=0;bP=bT(-1,-1)|0;b4=bP;bP=M;if((a[bM]&1)==0){eS=b4;eT=bP;break}Lw(c[I+8>>2]|0);eS=b4;eT=bP;break}if((a[bM]&1)!=0){Lw(c[I+8>>2]|0)}if((a[bV]&1)!=0){Lw(c[J+8>>2]|0)}if((a[eG]&1)!=0){Lw(c[K+8>>2]|0)}if((a[G]&1)!=0){Lw(c[G+8>>2]|0)}c[bH>>2]=F;bP=(z=0,aM(c[(c[a6>>2]|0)+20>>2]|0,a6|0,a_|0)|0);L316:do{if(!z){L319:do{if((bP|0)==0){b4=O;cZ=O;a[cZ]=18;LF(b4+1|0,4912,9)|0;a[b4+10|0]=0;L321:do{if((a[a0]&1)==0){b4=P;c[b4>>2]=c[a0>>2];c[b4+4>>2]=c[a0+4>>2];c[b4+8>>2]=c[a0+8>>2];be=255}else{b4=c[d+44>>2]|0;c2=c[d+40>>2]|0;do{if(c2>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(c2>>>0<11>>>0){a[P]=c2<<1;eU=P+1|0}else{b8=c2+16&-16;c5=(z=0,au(248,b8|0)|0);if(z){z=0;break}c[P+8>>2]=c5;c[P>>2]=b8|1;c[P+4>>2]=c2;eU=c5}LF(eU|0,b4|0,c2)|0;a[eU+c2|0]=0;be=255;break L321}}while(0);c2=bT(-1,-1)|0;eV=c2;eW=M}}while(0);do{if((be|0)==255){z=0;aR(210,N|0,O|0,P|0);do{if(!z){b9=L;LI(b9|0,0,12)|0;c2=N;b4=a[c2]|0;dY=b4&255;if((dY&1|0)==0){eX=dY>>>1}else{eX=c[N+4>>2]|0}if((b4&1)==0){eY=N+1|0}else{eY=c[N+8>>2]|0}b4=eX+23|0;do{if(b4>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;be=270;break}return 0}else{if(b4>>>0<11>>>0){a[b9]=eX<<1;eZ=L+1|0}else{dY=eX+39&-16;c5=(z=0,au(248,dY|0)|0);if(z){z=0;be=270;break}c[L+8>>2]=c5;c[L>>2]=dY|1;c[L+4>>2]=eX;eZ=c5}LF(eZ|0,eY|0,eX)|0;a[eZ+eX|0]=0;z=0,az(88,L|0,1352,23)|0;if(z){z=0;be=270;break}L356:do{if((a[bn]&1)==0){c5=Q;c[c5>>2]=c[bn>>2];c[c5+4>>2]=c[bn+4>>2];c[c5+8>>2]=c[bn+8>>2];be=282}else{c5=c[d+12>>2]|0;dY=c[d+8>>2]|0;do{if(dY>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(dY>>>0<11>>>0){a[Q]=dY<<1;e_=Q+1|0}else{b8=dY+16&-16;cb=(z=0,au(248,b8|0)|0);if(z){z=0;break}c[Q+8>>2]=cb;c[Q>>2]=b8|1;c[Q+4>>2]=dY;e_=cb}LF(e_|0,c5|0,dY)|0;a[e_+dY|0]=0;be=282;break L356}}while(0);dY=bT(-1,-1)|0;e$=dY;e0=M}}while(0);do{if((be|0)==282){dY=R;c[dY>>2]=c[bQ>>2];c[dY+4>>2]=c[bQ+4>>2];c[dY+8>>2]=c[bQ+8>>2];z=0;aR(382,L|0,Q|0,R|0);if(z){z=0;dY=bT(-1,-1)|0;c5=dY;dY=M;if((a[Q]&1)==0){e$=c5;e0=dY;break}Lw(c[Q+8>>2]|0);e$=c5;e0=dY;break}if((a[Q]&1)!=0){Lw(c[Q+8>>2]|0)}if((a[b9]&1)!=0){Lw(c[L+8>>2]|0)}if((a[c2]&1)!=0){Lw(c[N+8>>2]|0)}if((a[P]&1)!=0){Lw(c[P+8>>2]|0)}if((a[cZ]&1)==0){break L319}Lw(c[O+8>>2]|0);break L319}}while(0);if((a[b9]&1)==0){e1=e$;e2=e0;break}Lw(c[L+8>>2]|0);e1=e$;e2=e0}}while(0);if((be|0)==270){b4=bT(-1,-1)|0;dY=M;if((a[b9]&1)!=0){Lw(c[L+8>>2]|0)}e1=b4;e2=dY}if((a[c2]&1)==0){e3=e1;e4=e2;break}Lw(c[N+8>>2]|0);e3=e1;e4=e2}else{z=0;dY=bT(-1,-1)|0;e3=dY;e4=M}}while(0);if((a[P]&1)==0){eV=e3;eW=e4;break}Lw(c[P+8>>2]|0);eV=e3;eW=e4}}while(0);if((a[cZ]&1)==0){e5=eV;e6=eW;break L316}Lw(c[O+8>>2]|0);e5=eV;e6=eW;break L316}}while(0);c[bH>>2]=c[F>>2];c[a4>>2]=bs;if((a[F+28|0]&1)!=0){Lw(c[F+36>>2]|0)}if((a[F+4|0]&1)==0){cf=bP;cg=bQ;be=970;break L193}Lw(c[F+12>>2]|0);cf=bP;cg=bQ;be=970;break L193}else{z=0;dY=bT(-1,-1)|0;e5=dY;e6=M}}while(0);if((a[F+28|0]&1)!=0){Lw(c[F+36>>2]|0)}if((a[F+4|0]&1)==0){ch=e5;ci=e6;break L193}Lw(c[F+12>>2]|0);ch=e5;ci=e6;break L193}}while(0);if((be|0)==232){b7=bT(-1,-1)|0;bP=M;if((a[bM]&1)!=0){Lw(c[I+8>>2]|0)}eS=b7;eT=bP}if((a[bV]&1)==0){e7=eS;e8=eT;break}Lw(c[J+8>>2]|0);e7=eS;e8=eT}}while(0);if((be|0)==216){bL=bT(-1,-1)|0;bp=M;if((a[bV]&1)!=0){Lw(c[J+8>>2]|0)}e7=bL;e8=bp}if((a[eG]&1)==0){eK=e7;eL=e8;break}Lw(c[K+8>>2]|0);eK=e7;eL=e8}}while(0);if((a[G]&1)==0){ch=eK;ci=eL;break L193}Lw(c[G+8>>2]|0);ch=eK;ci=eL;break L193}}while(0);if((be|0)==175){bG=bT(-1,-1)|0;bJ=M;if((a[bq]&1)!=0){Lw(c[D+8>>2]|0)}eC=bG;eD=bJ}if((a[ev]&1)==0){ch=eC;ci=eD;break}Lw(c[E+8>>2]|0);ch=eC;ci=eD}}while(0);if((be|0)==293){a6=bT(-1,-1)|0;em=M;en=a6;be=294}else if((be|0)==970){LG(cf+16|0,cg|0,12)|0;g_(C|0,c[C+4>>2]|0);e9=cf;break}if((be|0)==294){ch=en;ci=em}g_(C|0,c[C+4>>2]|0);bh=ch;bi=ci;break L43}else{a6=b+4|0;bo=c[a6>>2]|0;bm=(z=0,au(248,56)|0);if(z){z=0;be=101;break L43}bk=bm;c[n>>2]=bk;bm=bo+4|0;a7=c[bm>>2]|0;if((a7|0)==(c[bo+8>>2]|0)){z=0;as(382,bo|0,n|0);if(z){z=0;be=101;break L43}fa=c[n>>2]|0}else{if((a7|0)==0){fb=0}else{c[a7>>2]=bk;fb=c[bm>>2]|0}c[bm>>2]=fb+4;fa=bk}bk=fa;a7=fa;a5=d+4|0;L63:do{if((a[a5]&1)==0){bl=t;c[bl>>2]=c[a5>>2];c[bl+4>>2]=c[a5+4>>2];c[bl+8>>2]=c[a5+8>>2];be=58}else{bl=c[d+12>>2]|0;ba=c[d+8>>2]|0;do{if(ba>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ba>>>0<11>>>0){a[t]=ba<<1;fc=t+1|0}else{bJ=ba+16&-16;bG=(z=0,au(248,bJ|0)|0);if(z){z=0;break}c[t+8>>2]=bG;c[t>>2]=bJ|1;c[t+4>>2]=ba;fc=bG}LF(fc|0,bl|0,ba)|0;a[fc+ba|0]=0;be=58;break L63}}while(0);ba=bT(-1,-1)|0;fd=ba;fe=M}}while(0);do{if((be|0)==58){ba=u;bl=d+16|0;c[ba>>2]=c[bl>>2];c[ba+4>>2]=c[bl+4>>2];c[ba+8>>2]=c[bl+8>>2];L78:do{if((a[a0]&1)==0){bq=v;c[bq>>2]=c[a0>>2];c[bq+4>>2]=c[a0+4>>2];c[bq+8>>2]=c[a0+8>>2];be=68}else{bq=c[d+44>>2]|0;bG=c[d+40>>2]|0;do{if(bG>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bG>>>0<11>>>0){a[v]=bG<<1;ff=v+1|0}else{bJ=bG+16&-16;br=(z=0,au(248,bJ|0)|0);if(z){z=0;break}c[v+8>>2]=br;c[v>>2]=bJ|1;c[v+4>>2]=bG;ff=br}LF(ff|0,bq|0,bG)|0;a[ff+bG|0]=0;be=68;break L78}}while(0);bG=bT(-1,-1)|0;fg=bG;fh=M}}while(0);do{if((be|0)==68){bG=m;c[bG>>2]=c[ba>>2];c[bG+4>>2]=c[ba+4>>2];c[bG+8>>2]=c[ba+8>>2];z=0;aq(10,a7|0,t|0,m|0,v|0,aZ|0);if(z){z=0;bG=bT(-1,-1)|0;bq=bG;bG=M;if((a[v]&1)==0){fg=bq;fh=bG;break}Lw(c[v+8>>2]|0);fg=bq;fh=bG;break}if((a[v]&1)!=0){Lw(c[v+8>>2]|0)}if((a[t]&1)!=0){Lw(c[t+8>>2]|0)}z=0;as(278,w|0,0);if(z){z=0;be=101;break L43}bG=c[a6>>2]|0;bq=(z=0,au(248,52)|0);do{if(!z){br=bq;c[l>>2]=br;bJ=bG+4|0;bQ=c[bJ>>2]|0;if((bQ|0)==(c[bG+8>>2]|0)){z=0;as(382,bG|0,l|0);if(z){z=0;be=117;break}fi=c[l>>2]|0}else{if((bQ|0)==0){fj=0}else{c[bQ>>2]=br;fj=c[bJ>>2]|0}c[bJ>>2]=fj+4;fi=br}br=fi;bQ=fi;L114:do{if((a[a5]&1)==0){bs=x;c[bs>>2]=c[a5>>2];c[bs+4>>2]=c[a5+4>>2];c[bs+8>>2]=c[a5+8>>2];be=91}else{bs=c[d+12>>2]|0;bH=c[d+8>>2]|0;do{if(bH>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(bH>>>0<11>>>0){a[x]=bH<<1;fk=x+1|0}else{bn=bH+16&-16;bI=(z=0,au(248,bn|0)|0);if(z){z=0;break}c[x+8>>2]=bI;c[x>>2]=bn|1;c[x+4>>2]=bH;fk=bI}LF(fk|0,bs|0,bH)|0;a[fk+bH|0]=0;be=91;break L114}}while(0);bH=bT(-1,-1)|0;fl=bH;fm=M}}while(0);do{if((be|0)==91){bV=y;c[bV>>2]=c[bl>>2];c[bV+4>>2]=c[bl+4>>2];c[bV+8>>2]=c[bl+8>>2];z=0;aR(c[(c[fa>>2]|0)+28>>2]|0,A|0,a7|0,w|0);do{if(!z){bH=k;c[bH>>2]=c[bV>>2];c[bH+4>>2]=c[bV+4>>2];c[bH+8>>2]=c[bV+8>>2];z=0;aq(28,bQ|0,x|0,k|0,A|0,0);if(z){z=0;bH=bT(-1,-1)|0;bs=bH;bH=M;if((a[A]&1)==0){fn=bs;fo=bH;break}Lw(c[A+8>>2]|0);fn=bs;fo=bH;break}if((a[A]&1)!=0){Lw(c[A+8>>2]|0)}if((a[x]&1)!=0){Lw(c[x+8>>2]|0)}z=0;ar(444,w|0);if(!z){e9=fi;break L52}else{z=0;be=101;break L43}}else{z=0;bH=bT(-1,-1)|0;fn=bH;fo=M}}while(0);if((a[x]&1)==0){fl=fn;fm=fo;break}Lw(c[x+8>>2]|0);fl=fn;fm=fo}}while(0);bQ=c[bG>>2]|0;bV=c[bJ>>2]|0;bH=bQ;while(1){if((bH|0)==(bV|0)){fp=bV;break}if((c[bH>>2]|0)==(fi|0)){fp=bH;break}else{bH=bH+4|0}}bH=fp-bQ>>2;bs=bQ+(bH+1<<2)|0;bM=bV-bs|0;LG(bQ+(bH<<2)|0,bs|0,bM|0)|0;bs=bQ+((bM>>2)+bH<<2)|0;bH=c[bJ>>2]|0;if((bs|0)!=(bH|0)){c[bJ>>2]=bH+(~((bH-4+(-bs|0)|0)>>>2)<<2)}Lw(br);fq=fl;fr=fm}else{z=0;be=117}}while(0);if((be|0)==117){bG=bT(-1,-1)|0;fq=bG;fr=M}z=0;ar(444,w|0);if(!z){bh=fq;bi=fr;break L43}else{z=0;be=978;break L52}}}while(0);if((a[t]&1)==0){fd=fg;fe=fh;break}Lw(c[t+8>>2]|0);fd=fg;fe=fh}}while(0);a7=c[bo>>2]|0;a5=c[bm>>2]|0;a6=a7;while(1){if((a6|0)==(a5|0)){fs=a5;break}if((c[a6>>2]|0)==(fa|0)){fs=a6;break}else{a6=a6+4|0}}a6=fs-a7>>2;bo=a7+(a6+1<<2)|0;bl=a5-bo|0;LG(a7+(a6<<2)|0,bo|0,bl|0)|0;bo=a7+((bl>>2)+a6<<2)|0;a6=c[bm>>2]|0;if((bo|0)!=(a6|0)){c[bm>>2]=a6+(~((a6-4+(-bo|0)|0)>>>2)<<2)}Lw(bk);bh=fd;bi=fe;break L43}}while(0);if((be|0)==978){bT(-1,-1,0)|0;bX();return 0}if((a[a9]&1)==0){i=e;return e9|0}Lw(c[q+8>>2]|0);i=e;return e9|0}}while(0);if((be|0)==101){a4=bT(-1,-1)|0;bu=M;bv=a4;be=102}if((be|0)==102){bh=bv;bi=bu}if((a[a9]&1)==0){ft=bh;fu=bi;fv=ft;fw=0;fx=fv;fy=fu;bg(fx|0)}Lw(c[q+8>>2]|0);ft=bh;fu=bi;fv=ft;fw=0;fx=fv;fy=fu;bg(fx|0)}}while(0);bi=bT(-1,-1)|0;bh=M;if((a[a9]&1)!=0){Lw(c[q+8>>2]|0)}q=bi;bi=bh;if((a[a3]&1)==0){ft=q;fu=bi;fv=ft;fw=0;fx=fv;fy=fu;bg(fx|0)}Lw(c[r+8>>2]|0);ft=q;fu=bi;fv=ft;fw=0;fx=fv;fy=fu;bg(fx|0);return 0}function jh(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aE=0,aF=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aR=0,aS=0,aT=0,aU=0,aW=0,aX=0.0,aY=0.0,aZ=0.0,a_=0.0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0;j=i;i=i+464|0;k=b;b=i;i=i+40|0;LF(b,k,40)|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+56|0;p=j+64|0;q=j+80|0;r=j+88|0;s=j+104|0;t=j+112|0;u=j+128|0;v=j+136|0;w=j+152|0;x=j+160|0;y=j+168|0;A=j+184|0;B=j+200|0;C=j+216|0;D=j+232|0;E=j+248|0;F=j+264|0;G=j+280|0;H=j+296|0;I=j+312|0;J=j+352|0;K=j+368|0;L=j+384|0;N=j+400|0;O=j+416|0;P=j+432|0;Q=j+448|0;switch(c[b>>2]|0){case 6:{R=c[b+4>>2]|0;S=LJ(R|0)|0;if(S>>>0>4294967279>>>0){D5(0);return 0}if(S>>>0<11>>>0){T=S<<1&255;U=O;V=O;a[V]=T;W=U+1|0;X=T;Y=U;Z=V}else{V=S+16&-16;U=Lu(V)|0;c[O+8>>2]=U;T=V|1;c[O>>2]=T;c[O+4>>2]=S;W=U;X=T&255;Y=O;Z=O}LF(W|0,R|0,S)|0;a[W+S|0]=0;S=N;LI(S|0,0,12)|0;W=X&255;if((W&1|0)==0){_=W>>>1}else{_=c[O+4>>2]|0}W=_+21|0;do{if(W>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=238;break}return 0}else{if(W>>>0<11>>>0){a[S]=42;aa=N+1|0}else{R=_+37&-16;T=(z=0,au(248,R|0)|0);if(z){z=0;$=238;break}c[N+8>>2]=T;c[N>>2]=R|1;c[N+4>>2]=21;aa=T}LF(aa|0,8696,21)|0;a[aa+21|0]=0;if((X&1)==0){ab=Y+1|0}else{ab=c[O+8>>2]|0}z=0,az(88,N|0,ab|0,_|0)|0;if(z){z=0;$=238;break}T=f;L28:do{if((a[T]&1)==0){R=P;c[R>>2]=c[T>>2];c[R+4>>2]=c[T+4>>2];c[R+8>>2]=c[T+8>>2];$=250}else{R=c[f+8>>2]|0;U=c[f+4>>2]|0;do{if(U>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(U>>>0<11>>>0){a[P]=U<<1;ac=P+1|0}else{V=U+16&-16;ad=(z=0,au(248,V|0)|0);if(z){z=0;break}c[P+8>>2]=ad;c[P>>2]=V|1;c[P+4>>2]=U;ac=ad}LF(ac|0,R|0,U)|0;a[ac+U|0]=0;$=250;break L28}}while(0);U=bT(-1,-1)|0;ae=U;af=M}}while(0);do{if(($|0)==250){T=Q;U=g;c[T>>2]=c[U>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];z=0;aV(46,N|0,P|0,Q|0,e|0);if(z){z=0;U=bT(-1,-1)|0;T=U;U=M;if((a[P]&1)==0){ae=T;af=U;break}Lw(c[P+8>>2]|0);ae=T;af=U;break}if((a[P]&1)!=0){Lw(c[P+8>>2]|0)}if((a[S]&1)!=0){Lw(c[N+8>>2]|0)}if((a[Z]&1)==0){ag=0;i=j;return ag|0}Lw(c[O+8>>2]|0);ag=0;i=j;return ag|0}}while(0);if((a[S]&1)==0){ah=ae;ai=af;break}Lw(c[N+8>>2]|0);ah=ae;ai=af}}while(0);if(($|0)==238){af=bT(-1,-1)|0;ae=M;if((a[S]&1)!=0){Lw(c[N+8>>2]|0)}ah=af;ai=ae}if((a[Z]&1)==0){aj=ah;ak=ai;al=aj;am=0;an=al;ao=ak;bg(an|0)}Lw(c[O+8>>2]|0);aj=ah;ak=ai;al=aj;am=0;an=al;ao=ak;bg(an|0);break};case 3:{ai=Lu(52)|0;c[s>>2]=ai;ah=d+4|0;O=c[ah>>2]|0;if((O|0)==(c[d+8>>2]|0)){e4(d|0,s);ap=c[s>>2]|0}else{if((O|0)==0){at=0}else{c[O>>2]=ai;at=c[ah>>2]|0}c[ah>>2]=at+4;ap=ai}ai=ap;at=f;L77:do{if((a[at]&1)==0){O=G;c[O>>2]=c[at>>2];c[O+4>>2]=c[at+4>>2];c[O+8>>2]=c[at+8>>2];$=114}else{O=c[f+8>>2]|0;s=c[f+4>>2]|0;do{if(s>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(s>>>0<11>>>0){a[G]=s<<1;aw=G+1|0}else{Z=s+16&-16;ae=(z=0,au(248,Z|0)|0);if(z){z=0;break}c[G+8>>2]=ae;c[G>>2]=Z|1;c[G+4>>2]=s;aw=ae}LF(aw|0,O|0,s)|0;a[aw+s|0]=0;$=114;break L77}}while(0);s=bT(-1,-1)|0;ax=s;ay=M}}while(0);do{if(($|0)==114){aw=g;at=r;c[at>>2]=c[aw>>2];c[at+4>>2]=c[aw+4>>2];c[at+8>>2]=c[aw+8>>2];z=0;aq(38,ap|0,G|0,r|0,c[b+4>>2]|0,0);if(z){z=0;aw=bT(-1,-1)|0;at=aw;aw=M;if((a[G]&1)==0){ax=at;ay=aw;break}Lw(c[G+8>>2]|0);ax=at;ay=aw;break}aw=ap;if((a[G]&1)==0){ag=aw;i=j;return ag|0}Lw(c[G+8>>2]|0);ag=aw;i=j;return ag|0}}while(0);G=c[d>>2]|0;r=c[ah>>2]|0;aw=G;while(1){if((aw|0)==(r|0)){aA=r;break}if((c[aw>>2]|0)==(ap|0)){aA=aw;break}else{aw=aw+4|0}}aw=aA-G>>2;aA=G+(aw+1<<2)|0;ap=r-aA|0;LG(G+(aw<<2)|0,aA|0,ap|0)|0;aA=G+((ap>>2)+aw<<2)|0;aw=c[ah>>2]|0;if((aA|0)!=(aw|0)){c[ah>>2]=aw+(~((aw-4+(-aA|0)|0)>>>2)<<2)}Lw(ai);aj=ax;ak=ay;al=aj;am=0;an=al;ao=ak;bg(an|0);break};case 5:{ay=Lu(36)|0;c[n>>2]=ay;ax=d+4|0;ai=c[ax>>2]|0;if((ai|0)==(c[d+8>>2]|0)){e4(d|0,n);aB=c[n>>2]|0}else{if((ai|0)==0){aC=0}else{c[ai>>2]=ay;aC=c[ax>>2]|0}c[ax>>2]=aC+4;aB=ay}ay=aB;aC=f;L117:do{if((a[aC]&1)==0){ai=L;c[ai>>2]=c[aC>>2];c[ai+4>>2]=c[aC+4>>2];c[ai+8>>2]=c[aC+8>>2];aE=a[ai]|0;aF=ai;$=192}else{ai=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(n>>>0<11>>>0){aA=n<<1&255;aw=L;a[aw]=aA;aH=L+1|0;aI=aA;aJ=aw}else{aw=n+16&-16;aA=(z=0,au(248,aw|0)|0);if(z){z=0;break}c[L+8>>2]=aA;ah=aw|1;c[L>>2]=ah;c[L+4>>2]=n;aH=aA;aI=ah&255;aJ=L}LF(aH|0,ai|0,n)|0;a[aH+n|0]=0;aE=aI;aF=aJ;$=192;break L117}}while(0);n=bT(-1,-1)|0;aK=n;aL=M}}while(0);do{if(($|0)==192){aJ=g;aI=m;c[aI>>2]=c[aJ>>2];c[aI+4>>2]=c[aJ+4>>2];c[aI+8>>2]=c[aJ+8>>2];aJ=m;aI=k;aH=l;aC=aB;L132:do{if((aE&1)==0){c[aI>>2]=c[aF>>2];c[aI+4>>2]=c[aF+4>>2];c[aI+8>>2]=c[aF+8>>2];$=202}else{n=c[L+8>>2]|0;ai=c[L+4>>2]|0;do{if(ai>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(ai>>>0<11>>>0){a[aI]=ai<<1;aM=k+1|0}else{ah=ai+16&-16;aA=(z=0,au(248,ah|0)|0);if(z){z=0;break}c[k+8>>2]=aA;c[k>>2]=ah|1;c[k+4>>2]=ai;aM=aA}LF(aM|0,n|0,ai)|0;a[aM+ai|0]=0;$=202;break L132}}while(0);ai=bT(-1,-1)|0;aN=M;aO=ai}}while(0);do{if(($|0)==202){c[aH>>2]=c[aJ>>2];c[aH+4>>2]=c[aJ+4>>2];c[aH+8>>2]=c[aJ+8>>2];z=0;aD(6,aC|0,k|0,l|0,0,0,0);if(z){z=0;ai=bT(-1,-1)|0;n=M;if((a[aI]&1)==0){aN=n;aO=ai;break}Lw(c[k+8>>2]|0);aN=n;aO=ai;break}if((a[aI]&1)!=0){Lw(c[k+8>>2]|0)}c[aB>>2]=19520;c[aB+32>>2]=6;if((a[aF]&1)==0){ag=aC;i=j;return ag|0}Lw(c[L+8>>2]|0);ag=aC;i=j;return ag|0}}while(0);aC=aO;aI=aN;if((a[aF]&1)==0){aK=aC;aL=aI;break}Lw(c[L+8>>2]|0);aK=aC;aL=aI}}while(0);L=c[d>>2]|0;aF=c[ax>>2]|0;aN=L;while(1){if((aN|0)==(aF|0)){aP=aF;break}if((c[aN>>2]|0)==(aB|0)){aP=aN;break}else{aN=aN+4|0}}aN=aP-L>>2;aP=L+(aN+1<<2)|0;aB=aF-aP|0;LG(L+(aN<<2)|0,aP|0,aB|0)|0;aP=L+((aB>>2)+aN<<2)|0;aN=c[ax>>2]|0;if((aP|0)!=(aN|0)){c[ax>>2]=aN+(~((aN-4+(-aP|0)|0)>>>2)<<2)}Lw(ay);aj=aK;ak=aL;al=aj;am=0;an=al;ao=ak;bg(an|0);break};case 2:{aL=Lu(88)|0;c[u>>2]=aL;aK=d+4|0;ay=c[aK>>2]|0;if((ay|0)==(c[d+8>>2]|0)){e4(d|0,u);aR=c[u>>2]|0}else{if((ay|0)==0){aS=0}else{c[ay>>2]=aL;aS=c[aK>>2]|0}c[aK>>2]=aS+4;aR=aL}aL=aR;aS=aR;ay=f;L177:do{if((a[ay]&1)==0){u=E;c[u>>2]=c[ay>>2];c[u+4>>2]=c[ay+4>>2];c[u+8>>2]=c[ay+8>>2];$=83}else{u=c[f+8>>2]|0;aP=c[f+4>>2]|0;do{if(aP>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aP>>>0<11>>>0){a[E]=aP<<1;aT=E+1|0}else{aN=aP+16&-16;ax=(z=0,au(248,aN|0)|0);if(z){z=0;break}c[E+8>>2]=ax;c[E>>2]=aN|1;c[E+4>>2]=aP;aT=ax}LF(aT|0,u|0,aP)|0;a[aT+aP|0]=0;$=83;break L177}}while(0);aP=bT(-1,-1)|0;aU=aP;aW=M}}while(0);do{if(($|0)==83){aT=g;ay=t;c[ay>>2]=c[aT>>2];c[ay+4>>2]=c[aT+4>>2];c[ay+8>>2]=c[aT+8>>2];aX=+h[b+8>>3];aY=+h[b+16>>3];aZ=+h[b+24>>3];a_=+h[b+32>>3];aT=F;a[aT]=0;a[F+1|0]=0;z=0;av(2,aS|0,E|0,t|0,+aX,+aY,+aZ,+a_,F|0);if(z){z=0;ay=bT(-1,-1)|0;aP=ay;ay=M;if((a[aT]&1)!=0){Lw(c[F+8>>2]|0)}if((a[E]&1)==0){aU=aP;aW=ay;break}Lw(c[E+8>>2]|0);aU=aP;aW=ay;break}if((a[aT]&1)!=0){Lw(c[F+8>>2]|0)}aT=aR;if((a[E]&1)==0){ag=aT;i=j;return ag|0}Lw(c[E+8>>2]|0);ag=aT;i=j;return ag|0}}while(0);E=c[d>>2]|0;F=c[aK>>2]|0;t=E;while(1){if((t|0)==(F|0)){a$=F;break}if((c[t>>2]|0)==(aR|0)){a$=t;break}else{t=t+4|0}}t=a$-E>>2;a$=E+(t+1<<2)|0;aR=F-a$|0;LG(E+(t<<2)|0,a$|0,aR|0)|0;a$=E+((aR>>2)+t<<2)|0;t=c[aK>>2]|0;if((a$|0)!=(t|0)){c[aK>>2]=t+(~((t-4+(-a$|0)|0)>>>2)<<2)}Lw(aL);aj=aU;ak=aW;al=aj;am=0;an=al;ao=ak;bg(an|0);break};case 0:{aW=Lu(40)|0;c[x>>2]=aW;aU=d+4|0;aL=c[aU>>2]|0;if((aL|0)==(c[d+8>>2]|0)){e4(d|0,x);a0=c[x>>2]|0}else{if((aL|0)==0){a1=0}else{c[aL>>2]=aW;a1=c[aU>>2]|0}c[aU>>2]=a1+4;a0=aW}aW=a0;a1=f;L223:do{if((a[a1]&1)==0){aL=y;c[aL>>2]=c[a1>>2];c[aL+4>>2]=c[a1+4>>2];c[aL+8>>2]=c[a1+8>>2];$=17}else{aL=c[f+8>>2]|0;x=c[f+4>>2]|0;do{if(x>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(x>>>0<11>>>0){a[y]=x<<1;a2=y+1|0}else{a$=x+16&-16;t=(z=0,au(248,a$|0)|0);if(z){z=0;break}c[y+8>>2]=t;c[y>>2]=a$|1;c[y+4>>2]=x;a2=t}LF(a2|0,aL|0,x)|0;a[a2+x|0]=0;$=17;break L223}}while(0);x=bT(-1,-1)|0;a3=x;a4=M}}while(0);do{if(($|0)==17){a2=A;a1=g;c[a2>>2]=c[a1>>2];c[a2+4>>2]=c[a1+4>>2];c[a2+8>>2]=c[a1+8>>2];z=0;aV(4,a0|0,y|0,A|0,(c[b+4>>2]|0)!=0|0);if(z){z=0;a1=bT(-1,-1)|0;a2=a1;a1=M;if((a[y]&1)==0){a3=a2;a4=a1;break}Lw(c[y+8>>2]|0);a3=a2;a4=a1;break}a1=a0;if((a[y]&1)==0){ag=a1;i=j;return ag|0}Lw(c[y+8>>2]|0);ag=a1;i=j;return ag|0}}while(0);y=c[d>>2]|0;A=c[aU>>2]|0;a1=y;while(1){if((a1|0)==(A|0)){a5=A;break}if((c[a1>>2]|0)==(a0|0)){a5=a1;break}else{a1=a1+4|0}}a1=a5-y>>2;a5=y+(a1+1<<2)|0;a0=A-a5|0;LG(y+(a1<<2)|0,a5|0,a0|0)|0;a5=y+((a0>>2)+a1<<2)|0;a1=c[aU>>2]|0;if((a5|0)!=(a1|0)){c[aU>>2]=a1+(~((a1-4+(-a5|0)|0)>>>2)<<2)}Lw(aW);aj=a3;ak=a4;al=aj;am=0;an=al;ao=ak;bg(an|0);break};case 1:{a4=Lu(72)|0;c[w>>2]=a4;a3=d+4|0;aW=c[a3>>2]|0;if((aW|0)==(c[d+8>>2]|0)){e4(d|0,w);a6=c[w>>2]|0}else{if((aW|0)==0){a7=0}else{c[aW>>2]=a4;a7=c[a3>>2]|0}c[a3>>2]=a7+4;a6=a4}a4=a6;a7=a6;aW=f;L263:do{if((a[aW]&1)==0){w=B;c[w>>2]=c[aW>>2];c[w+4>>2]=c[aW+4>>2];c[w+8>>2]=c[aW+8>>2];$=44}else{w=c[f+8>>2]|0;a5=c[f+4>>2]|0;do{if(a5>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(a5>>>0<11>>>0){a[B]=a5<<1;a8=B+1|0}else{a1=a5+16&-16;aU=(z=0,au(248,a1|0)|0);if(z){z=0;break}c[B+8>>2]=aU;c[B>>2]=a1|1;c[B+4>>2]=a5;a8=aU}LF(a8|0,w|0,a5)|0;a[a8+a5|0]=0;$=44;break L263}}while(0);a5=bT(-1,-1)|0;a9=a5;ba=M}}while(0);do{if(($|0)==44){a8=C;aW=g;c[a8>>2]=c[aW>>2];c[a8+4>>2]=c[aW+4>>2];c[a8+8>>2]=c[aW+8>>2];a_=+h[b+8>>3];aW=c[b+16>>2]|0;a5=LJ(aW|0)|0;do{if(a5>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;$=57;break}return 0}else{if(a5>>>0<11>>>0){a[D]=a5<<1;bb=D+1|0}else{w=a5+16&-16;aU=(z=0,au(248,w|0)|0);if(z){z=0;$=57;break}c[D+8>>2]=aU;c[D>>2]=w|1;c[D+4>>2]=a5;bb=aU}LF(bb|0,aW|0,a5)|0;a[bb+a5|0]=0;aU=v;c[aU>>2]=c[a8>>2];c[aU+4>>2]=c[a8+4>>2];c[aU+8>>2]=c[a8+8>>2];z=0;aG(2,a7|0,B|0,v|0,+a_,D|0);if(z){z=0;aU=bT(-1,-1)|0;w=aU;aU=M;if((a[D]&1)==0){bc=w;bd=aU;break}Lw(c[D+8>>2]|0);bc=w;bd=aU;break}if((a[D]&1)!=0){Lw(c[D+8>>2]|0)}aU=a6;if((a[B]&1)==0){ag=aU;i=j;return ag|0}Lw(c[B+8>>2]|0);ag=aU;i=j;return ag|0}}while(0);if(($|0)==57){a8=bT(-1,-1)|0;bc=a8;bd=M}if((a[B]&1)==0){a9=bc;ba=bd;break}Lw(c[B+8>>2]|0);a9=bc;ba=bd}}while(0);bd=c[d>>2]|0;bc=c[a3>>2]|0;B=bd;while(1){if((B|0)==(bc|0)){be=bc;break}if((c[B>>2]|0)==(a6|0)){be=B;break}else{B=B+4|0}}B=be-bd>>2;be=bd+(B+1<<2)|0;a6=bc-be|0;LG(bd+(B<<2)|0,be|0,a6|0)|0;be=bd+((a6>>2)+B<<2)|0;B=c[a3>>2]|0;if((be|0)!=(B|0)){c[a3>>2]=B+(~((B-4+(-be|0)|0)>>>2)<<2)}Lw(a4);aj=a9;ak=ba;al=aj;am=0;an=al;ao=ak;bg(an|0);break};case 4:{ba=Lu(60)|0;c[q>>2]=ba;a9=d+4|0;a4=c[a9>>2]|0;if((a4|0)==(c[d+8>>2]|0)){e4(d|0,q);bf=c[q>>2]|0}else{if((a4|0)==0){bh=0}else{c[a4>>2]=ba;bh=c[a9>>2]|0}c[a9>>2]=bh+4;bf=ba}ba=bf;bh=f;L319:do{if((a[bh]&1)==0){a4=H;c[a4>>2]=c[bh>>2];c[a4+4>>2]=c[bh+4>>2];c[a4+8>>2]=c[bh+8>>2];$=141}else{a4=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(q>>>0<11>>>0){a[H]=q<<1;bi=H+1|0}else{be=q+16&-16;B=(z=0,au(248,be|0)|0);if(z){z=0;break}c[H+8>>2]=B;c[H>>2]=be|1;c[H+4>>2]=q;bi=B}LF(bi|0,a4|0,q)|0;a[bi+q|0]=0;$=141;break L319}}while(0);q=bT(-1,-1)|0;bj=q;bk=M}}while(0);do{if(($|0)==141){bi=g;q=p;c[q>>2]=c[bi>>2];c[q+4>>2]=c[bi+4>>2];c[q+8>>2]=c[bi+8>>2];q=b;a4=c[b+8>>2]|0;z=0;aD(36,bf|0,H|0,p|0,a4|0,(c[q+4>>2]|0)==0|0,0);if(z){z=0;B=bT(-1,-1)|0;be=B;B=M;if((a[H]&1)==0){bj=be;bk=B;break}Lw(c[H+8>>2]|0);bj=be;bk=B;break}if((a[H]&1)!=0){Lw(c[H+8>>2]|0)}L341:do{if((a4|0)!=0){B=I;be=J;a3=K;a6=bf+36|0;bd=a6;bc=a6+8|0;D=bc;v=a6+12|0;a7=a6+4|0;bb=a6;a6=J+8|0;C=f+8|0;a8=f+4|0;a5=J+1|0;aW=J|0;aU=J+4|0;w=c[q+12>>2]|0;a1=0;while(1){a0=w+(a1*40|0)|0;c[B>>2]=c[a0>>2];c[B+4>>2]=c[a0+4>>2];c[B+8>>2]=c[a0+8>>2];c[B+12>>2]=c[a0+12>>2];c[B+16>>2]=c[a0+16>>2];c[B+20>>2]=c[a0+20>>2];c[B+24>>2]=c[a0+24>>2];c[B+28>>2]=c[a0+28>>2];c[B+32>>2]=c[a0+32>>2];c[B+36>>2]=c[a0+36>>2];if((a[bh]&1)==0){c[be>>2]=c[bh>>2];c[be+4>>2]=c[bh+4>>2];c[be+8>>2]=c[bh+8>>2]}else{a0=c[C>>2]|0;y=c[a8>>2]|0;if(y>>>0>4294967279>>>0){$=149;break}if(y>>>0<11>>>0){a[be]=y<<1;bl=a5}else{A=y+16&-16;a2=Lu(A)|0;c[a6>>2]=a2;c[aW>>2]=A|1;c[aU>>2]=y;bl=a2}LF(bl|0,a0|0,y)|0;a[bl+y|0]=0}c[a3>>2]=c[bi>>2];c[a3+4>>2]=c[bi+4>>2];c[a3+8>>2]=c[bi+8>>2];y=(z=0,aQ(20,I|0,d|0,e|0,J|0,K|0)|0);if(z){z=0;break}c[o>>2]=y;a0=c[D>>2]|0;if((a0|0)==(c[v>>2]|0)){z=0;as(376,a7|0,o|0);if(z){z=0;break}bm=c[o>>2]|0}else{if((a0|0)==0){bn=0}else{c[a0>>2]=y;bn=c[D>>2]|0}c[bc>>2]=bn+4;bm=y}z=0;as(c[c[bb>>2]>>2]|0,bd|0,bm|0);if(z){z=0;break}if((a[be]&1)!=0){Lw(c[a6>>2]|0)}a1=a1+1|0;if(a1>>>0>=a4>>>0){break L341}}if(($|0)==149){D5(0);return 0}a1=bT(-1,-1)|0;bd=a1;a1=M;if((a[be]&1)==0){aj=bd;ak=a1;al=aj;am=0;an=al;ao=ak;bg(an|0)}Lw(c[a6>>2]|0);aj=bd;ak=a1;al=aj;am=0;an=al;ao=ak;bg(an|0)}}while(0);ag=bf;i=j;return ag|0}}while(0);$=c[d>>2]|0;d=c[a9>>2]|0;bm=$;while(1){if((bm|0)==(d|0)){bo=d;break}if((c[bm>>2]|0)==(bf|0)){bo=bm;break}else{bm=bm+4|0}}bm=bo-$>>2;bo=$+(bm+1<<2)|0;bf=d-bo|0;LG($+(bm<<2)|0,bo|0,bf|0)|0;bo=$+((bf>>2)+bm<<2)|0;bm=c[a9>>2]|0;if((bo|0)!=(bm|0)){c[a9>>2]=bm+(~((bm-4+(-bo|0)|0)>>>2)<<2)}Lw(ba);aj=bj;ak=bk;al=aj;am=0;an=al;ao=ak;bg(an|0);break};default:{ag=0;i=j;return ag|0}}return 0}function ji(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+56|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=c[d+36>>2]|0;m=b|0;n=cV[c[(c[l>>2]|0)+20>>2]&1023](l,m)|0;l=c[d+40>>2]|0;o=cV[c[(c[l>>2]|0)+20>>2]&1023](l,m)|0;l=c[b+4>>2]|0;b=Lu(60)|0;c[j>>2]=b;p=l+4|0;q=c[p>>2]|0;if((q|0)==(c[l+8>>2]|0)){e4(l|0,j);r=c[j>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=b;s=c[p>>2]|0}c[p>>2]=s+4;r=b}b=r;s=r;q=d+4|0;L8:do{if((a[q]&1)==0){j=k;c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];t=16}else{j=c[d+12>>2]|0;u=c[d+8>>2]|0;do{if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(u>>>0<11>>>0){a[k]=u<<1;v=k+1|0}else{w=u+16&-16;x=(z=0,au(248,w|0)|0);if(z){z=0;break}c[k+8>>2]=x;c[k>>2]=w|1;c[k+4>>2]=u;v=x}LF(v|0,j|0,u)|0;a[v+u|0]=0;t=16;break L8}}while(0);u=bT(-1,-1)|0;y=M;A=u}}while(0);do{if((t|0)==16){v=d+16|0;q=h;c[q>>2]=c[v>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];z=0;aD(2,s|0,k|0,h|0,2,0,0);if(z){z=0;v=bT(-1,-1)|0;q=v;v=M;if((a[k]&1)==0){y=v;A=q;break}Lw(c[k+8>>2]|0);y=v;A=q;break}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}q=r+40|0;v=q;c[g>>2]=n;u=q+8|0;j=c[u>>2]|0;x=j;w=q+12|0;if((j|0)==(c[w>>2]|0)){fq(q+4|0,g);B=c[g>>2]|0}else{if((j|0)==0){C=0}else{c[x>>2]=n;C=c[u>>2]|0}c[u>>2]=C+4;B=n}cB[c[c[q>>2]>>2]&1023](v,B);c[f>>2]=o;x=c[u>>2]|0;if((x|0)==(c[w>>2]|0)){fq(q+4|0,f);D=c[f>>2]|0;E=c[q>>2]|0;F=E;G=c[F>>2]|0;cB[G&1023](v,D);H=r;I=c[H>>2]|0;J=I+20|0;K=c[J>>2]|0;L=cV[K&1023](s,m)|0;i=e;return L|0}if((x|0)==0){N=0}else{c[x>>2]=o;N=c[u>>2]|0}c[u>>2]=N+4;D=o;E=c[q>>2]|0;F=E;G=c[F>>2]|0;cB[G&1023](v,D);H=r;I=c[H>>2]|0;J=I+20|0;K=c[J>>2]|0;L=cV[K&1023](s,m)|0;i=e;return L|0}}while(0);L=c[l>>2]|0;l=c[p>>2]|0;e=L;while(1){if((e|0)==(l|0)){O=l;break}if((c[e>>2]|0)==(r|0)){O=e;break}else{e=e+4|0}}e=O-L>>2;O=L+(e+1<<2)|0;r=l-O|0;LG(L+(e<<2)|0,O|0,r|0)|0;O=L+((r>>2)+e<<2)|0;e=c[p>>2]|0;if((O|0)==(e|0)){Lw(b);P=A;Q=0;R=P;S=y;bg(R|0)}c[p>>2]=e+(~((e-4+(-O|0)|0)>>>2)<<2);Lw(b);P=A;Q=0;R=P;S=y;bg(R|0);return 0}function jj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+120|0;f=e|0;g=e+8|0;h=e+24|0;j=e+40|0;k=e+56|0;l=e+72|0;m=e+88|0;n=e+104|0;Bv(f,0);o=d+36|0;L1:do{if((a[o]&1)==0){p=g;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];q=a[p]|0;r=p;s=11}else{p=c[d+44>>2]|0;t=c[d+40>>2]|0;do{if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(t>>>0<11>>>0){u=t<<1&255;v=g;a[v]=u;w=g+1|0;x=u;y=v}else{v=t+16&-16;u=(z=0,au(248,v|0)|0);if(z){z=0;break}c[g+8>>2]=u;A=v|1;c[g>>2]=A;c[g+4>>2]=t;w=u;x=A&255;y=g}LF(w|0,p|0,t)|0;a[w+t|0]=0;q=x;r=y;s=11;break L1}}while(0);t=bT(-1,-1)|0;B=t;C=M}}while(0);do{if((s|0)==11){y=b+8|0;x=c[y>>2]|0;do{if((q&1)==0){w=h;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];s=21}else{w=c[g+8>>2]|0;t=c[g+4>>2]|0;if(t>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;s=39;break}return 0}if(t>>>0<11>>>0){a[h]=t<<1;D=h+1|0}else{p=t+16&-16;A=(z=0,au(248,p|0)|0);if(z){z=0;s=39;break}c[h+8>>2]=A;c[h>>2]=p|1;c[h+4>>2]=t;D=A}LF(D|0,w|0,t)|0;a[D+t|0]=0;s=21}}while(0);L28:do{if((s|0)==21){t=(z=0,aM(560,x|0,h|0)|0);if(z){z=0;w=bT(-1,-1)|0;A=w;w=M;if((a[h]&1)==0){E=A;F=w;break}Lw(c[h+8>>2]|0);E=A;F=w;break}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}L37:do{if(t){w=c[y>>2]|0;A=(a[r]&1)==0;if(A){p=j;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2]}else{p=c[g+8>>2]|0;u=c[g+4>>2]|0;if(u>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;s=39;break L28}return 0}if(u>>>0<11>>>0){a[j]=u<<1;G=j+1|0}else{v=u+16&-16;H=(z=0,au(248,v|0)|0);if(z){z=0;s=39;break L28}c[j+8>>2]=H;c[j>>2]=v|1;c[j+4>>2]=u;G=H}LF(G|0,p|0,u)|0;a[G+u|0]=0}u=(z=0,aM(90,w|0,j|0)|0);if(z){z=0;w=bT(-1,-1)|0;p=w;w=M;if((a[j]&1)==0){E=p;F=w;break L28}Lw(c[j+8>>2]|0);E=p;F=w;break L28}w=c[u>>2]|0;if((a[j]&1)!=0){Lw(c[j+8>>2]|0)}if((w|0)==0){break}if((c[(c[(c[w>>2]|0)-4>>2]|0)+4>>2]|0)==26848){I=c[w+36>>2]|0}else{I=w}if(A){Bx(f);i=e;return I|0}Lw(c[g+8>>2]|0);Bx(f);i=e;return I|0}else{if((a[o]&1)==0){A=l;c[A>>2]=c[o>>2];c[A+4>>2]=c[o+4>>2];c[A+8>>2]=c[o+8>>2];J=a[A]|0;K=A}else{A=c[d+44>>2]|0;w=c[d+40>>2]|0;if(w>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;s=39;break L28}return 0}if(w>>>0<11>>>0){u=w<<1&255;p=l;a[p]=u;L=l+1|0;N=u;O=p}else{p=w+16&-16;u=(z=0,au(248,p|0)|0);if(z){z=0;s=39;break L28}c[l+8>>2]=u;H=p|1;c[l>>2]=H;c[l+4>>2]=w;L=u;N=H&255;O=l}LF(L|0,A|0,w)|0;a[L+w|0]=0;J=N;K=O}w=k;LI(w|0,0,12)|0;A=l;H=J&255;if((H&1|0)==0){P=H>>>1}else{P=c[l+4>>2]|0}H=P+17|0;do{if(H>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;s=68;break}return 0}else{if(H>>>0<11>>>0){a[w]=34;Q=k+1|0}else{u=P+33&-16;p=(z=0,au(248,u|0)|0);if(z){z=0;s=68;break}c[k+8>>2]=p;c[k>>2]=u|1;c[k+4>>2]=17;Q=p}LF(Q|0,11096,17)|0;a[Q+17|0]=0;if((a[K]&1)==0){R=A+1|0}else{R=c[l+8>>2]|0}z=0,az(88,k|0,R|0,P|0)|0;if(z){z=0;s=68;break}p=d+4|0;L99:do{if((a[p]&1)==0){u=m;c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];s=80}else{u=c[d+12>>2]|0;v=c[d+8>>2]|0;do{if(v>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(v>>>0<11>>>0){a[m]=v<<1;S=m+1|0}else{T=v+16&-16;U=(z=0,au(248,T|0)|0);if(z){z=0;break}c[m+8>>2]=U;c[m>>2]=T|1;c[m+4>>2]=v;S=U}LF(S|0,u|0,v)|0;a[S+v|0]=0;s=80;break L99}}while(0);v=bT(-1,-1)|0;V=v;W=M}}while(0);do{if((s|0)==80){p=n;v=d+16|0;c[p>>2]=c[v>>2];c[p+4>>2]=c[v+4>>2];c[p+8>>2]=c[v+8>>2];z=0;aR(382,k|0,m|0,n|0);if(z){z=0;v=bT(-1,-1)|0;p=v;v=M;if((a[m]&1)==0){V=p;W=v;break}Lw(c[m+8>>2]|0);V=p;W=v;break}if((a[m]&1)!=0){Lw(c[m+8>>2]|0)}if((a[w]&1)!=0){Lw(c[k+8>>2]|0)}if((a[K]&1)==0){break L37}Lw(c[l+8>>2]|0);break L37}}while(0);if((a[w]&1)==0){X=V;Y=W;break}Lw(c[k+8>>2]|0);X=V;Y=W}}while(0);if((s|0)==68){A=bT(-1,-1)|0;H=M;if((a[w]&1)!=0){Lw(c[k+8>>2]|0)}X=A;Y=H}if((a[K]&1)==0){E=X;F=Y;break L28}Lw(c[l+8>>2]|0);E=X;F=Y;break L28}}while(0);z=0;aS(10);if(z){z=0;s=39;break}return 0}}while(0);if((s|0)==39){y=bT(-1,-1)|0;E=y;F=M}if((a[r]&1)==0){B=E;C=F;break}Lw(c[g+8>>2]|0);B=E;C=F}}while(0);z=0;ar(444,f|0);if(!z){bg(B|0)}else{z=0;bT(-1,-1,0)|0;bX();return 0}return 0}function jk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0.0,ap=0,aq=0,at=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,be=0,bf=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0.0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bQ=0,bR=0,bS=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0;e=i;i=i+552|0;f=e|0;g=e+16|0;h=e+24|0;j=e+40|0;k=e+48|0;l=e+64|0;m=e+72|0;n=e+88|0;o=e+96|0;p=e+112|0;q=e+120|0;r=e+136|0;s=e+152|0;t=e+168|0;u=e+184|0;v=e+200|0;w=e+216|0;x=e+232|0;y=e+248|0;A=e+264|0;B=e+280|0;C=e+296|0;D=e+312|0;E=e+328|0;F=e+344|0;G=e+360|0;H=e+376|0;I=e+392|0;J=e+408|0;K=e+424|0;L=e+440|0;N=e+456|0;O=e+472|0;P=e+488|0;Q=e+504|0;R=e+520|0;S=e+536|0;T=c[d+36>>2]|0;if((T|0)==0){U=c[b+4>>2]|0;V=Lu(72)|0;c[p>>2]=V;W=U+4|0;X=c[W>>2]|0;if((X|0)==(c[U+8>>2]|0)){e4(U|0,p);Y=c[p>>2]|0}else{if((X|0)==0){Z=0}else{c[X>>2]=V;Z=c[W>>2]|0}c[W>>2]=Z+4;Y=V}V=Y;Z=Y;X=d+4|0;L10:do{if((a[X]&1)==0){p=q;c[p>>2]=c[X>>2];c[p+4>>2]=c[X+4>>2];c[p+8>>2]=c[X+8>>2];_=17}else{p=c[d+12>>2]|0;$=c[d+8>>2]|0;do{if($>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if($>>>0<11>>>0){a[q]=$<<1;aa=q+1|0}else{ab=$+16&-16;ac=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[q+8>>2]=ac;c[q>>2]=ab|1;c[q+4>>2]=$;aa=ac}LF(aa|0,p|0,$)|0;a[aa+$|0]=0;_=17;break L10}}while(0);$=bT(-1,-1)|0;ad=M;ae=$}}while(0);do{if((_|0)==17){aa=r;X=d+16|0;c[aa>>2]=c[X>>2];c[aa+4>>2]=c[X+4>>2];c[aa+8>>2]=c[X+8>>2];X=d+40|0;L25:do{if((a[X]&1)==0){$=s;c[$>>2]=c[X>>2];c[$+4>>2]=c[X+4>>2];c[$+8>>2]=c[X+8>>2];af=a[$]|0;ag=$;_=27}else{$=c[d+48>>2]|0;p=c[d+44>>2]|0;do{if(p>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(p>>>0<11>>>0){ac=p<<1&255;ab=s;a[ab]=ac;ah=s+1|0;ai=ac;aj=ab}else{ab=p+16&-16;ac=(z=0,au(248,ab|0)|0);if(z){z=0;break}c[s+8>>2]=ac;ak=ab|1;c[s>>2]=ak;c[s+4>>2]=p;ah=ac;ai=ak&255;aj=s}LF(ah|0,$|0,p)|0;a[ah+p|0]=0;af=ai;ag=aj;_=27;break L25}}while(0);p=bT(-1,-1)|0;al=M;am=p}}while(0);do{if((_|0)==27){if((af&1)==0){an=s+1|0}else{an=c[s+8>>2]|0}ao=+LE(an);X=t;a[X]=0;a[t+1|0]=0;p=o;c[p>>2]=c[aa>>2];c[p+4>>2]=c[aa+4>>2];c[p+8>>2]=c[aa+8>>2];z=0;aG(2,Z|0,q|0,o|0,+ao,t|0);if(z){z=0;p=bT(-1,-1)|0;$=p;p=M;if((a[X]&1)!=0){Lw(c[t+8>>2]|0)}if((a[ag]&1)==0){al=p;am=$;break}Lw(c[s+8>>2]|0);al=p;am=$;break}$=Y;if((a[X]&1)!=0){Lw(c[t+8>>2]|0)}if((a[ag]&1)!=0){Lw(c[s+8>>2]|0)}if((a[q]&1)==0){ap=$;i=e;return ap|0}Lw(c[q+8>>2]|0);ap=$;i=e;return ap|0}}while(0);if((a[q]&1)==0){ad=al;ae=am;break}Lw(c[q+8>>2]|0);ad=al;ae=am}}while(0);am=c[U>>2]|0;U=c[W>>2]|0;al=am;while(1){if((al|0)==(U|0)){aq=U;break}if((c[al>>2]|0)==(Y|0)){aq=al;break}else{al=al+4|0}}al=aq-am>>2;aq=am+(al+1<<2)|0;Y=U-aq|0;LG(am+(al<<2)|0,aq|0,Y|0)|0;aq=am+((Y>>2)+al<<2)|0;al=c[W>>2]|0;if((aq|0)!=(al|0)){c[W>>2]=al+(~((al-4+(-aq|0)|0)>>>2)<<2)}Lw(V);at=ad;aw=ae;ax=aw;ay=0;az=ax;aA=at;bg(az|0)}else if((T|0)==1){ae=c[b+4>>2]|0;ad=Lu(72)|0;c[n>>2]=ad;V=ae+4|0;aq=c[V>>2]|0;if((aq|0)==(c[ae+8>>2]|0)){e4(ae|0,n);aB=c[n>>2]|0}else{if((aq|0)==0){aC=0}else{c[aq>>2]=ad;aC=c[V>>2]|0}c[V>>2]=aC+4;aB=ad}ad=aB;aC=aB;aq=d+4|0;L81:do{if((a[aq]&1)==0){n=u;c[n>>2]=c[aq>>2];c[n+4>>2]=c[aq+4>>2];c[n+8>>2]=c[aq+8>>2];_=66}else{n=c[d+12>>2]|0;al=c[d+8>>2]|0;do{if(al>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(al>>>0<11>>>0){a[u]=al<<1;aD=u+1|0}else{W=al+16&-16;Y=(z=0,au(248,W|0)|0);if(z){z=0;break}c[u+8>>2]=Y;c[u>>2]=W|1;c[u+4>>2]=al;aD=Y}LF(aD|0,n|0,al)|0;a[aD+al|0]=0;_=66;break L81}}while(0);al=bT(-1,-1)|0;aE=M;aF=al}}while(0);do{if((_|0)==66){aD=v;aq=d+16|0;c[aD>>2]=c[aq>>2];c[aD+4>>2]=c[aq+4>>2];c[aD+8>>2]=c[aq+8>>2];aq=d+40|0;L96:do{if((a[aq]&1)==0){al=w;c[al>>2]=c[aq>>2];c[al+4>>2]=c[aq+4>>2];c[al+8>>2]=c[aq+8>>2];aH=a[al]|0;aI=al;_=76}else{al=c[d+48>>2]|0;n=c[d+44>>2]|0;do{if(n>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(n>>>0<11>>>0){Y=n<<1&255;W=w;a[W]=Y;aJ=w+1|0;aK=Y;aL=W}else{W=n+16&-16;Y=(z=0,au(248,W|0)|0);if(z){z=0;break}c[w+8>>2]=Y;am=W|1;c[w>>2]=am;c[w+4>>2]=n;aJ=Y;aK=am&255;aL=w}LF(aJ|0,al|0,n)|0;a[aJ+n|0]=0;aH=aK;aI=aL;_=76;break L96}}while(0);n=bT(-1,-1)|0;aM=M;aN=n}}while(0);do{if((_|0)==76){if((aH&1)==0){aO=w+1|0}else{aO=c[w+8>>2]|0}ao=+LE(aO);aq=x;n=x;a[n]=2;a[aq+1|0]=37;a[aq+2|0]=0;aq=m;c[aq>>2]=c[aD>>2];c[aq+4>>2]=c[aD+4>>2];c[aq+8>>2]=c[aD+8>>2];z=0;aG(2,aC|0,u|0,m|0,+ao,x|0);if(z){z=0;aq=bT(-1,-1)|0;al=aq;aq=M;if((a[n]&1)!=0){Lw(c[x+8>>2]|0)}if((a[aI]&1)==0){aM=aq;aN=al;break}Lw(c[w+8>>2]|0);aM=aq;aN=al;break}al=aB;if((a[n]&1)!=0){Lw(c[x+8>>2]|0)}if((a[aI]&1)!=0){Lw(c[w+8>>2]|0)}if((a[u]&1)==0){ap=al;i=e;return ap|0}Lw(c[u+8>>2]|0);ap=al;i=e;return ap|0}}while(0);if((a[u]&1)==0){aE=aM;aF=aN;break}Lw(c[u+8>>2]|0);aE=aM;aF=aN}}while(0);aN=c[ae>>2]|0;ae=c[V>>2]|0;aM=aN;while(1){if((aM|0)==(ae|0)){aP=ae;break}if((c[aM>>2]|0)==(aB|0)){aP=aM;break}else{aM=aM+4|0}}aM=aP-aN>>2;aP=aN+(aM+1<<2)|0;aB=ae-aP|0;LG(aN+(aM<<2)|0,aP|0,aB|0)|0;aP=aN+((aB>>2)+aM<<2)|0;aM=c[V>>2]|0;if((aP|0)!=(aM|0)){c[V>>2]=aM+(~((aM-4+(-aP|0)|0)>>>2)<<2)}Lw(ad);at=aE;aw=aF;ax=aw;ay=0;az=ax;aA=at;bg(az|0)}else if((T|0)==2){aF=c[b+4>>2]|0;aE=Lu(72)|0;c[l>>2]=aE;ad=aF+4|0;aP=c[ad>>2]|0;if((aP|0)==(c[aF+8>>2]|0)){e4(aF|0,l);aQ=c[l>>2]|0}else{if((aP|0)==0){aR=0}else{c[aP>>2]=aE;aR=c[ad>>2]|0}c[ad>>2]=aR+4;aQ=aE}aE=aQ;aR=aQ;aP=d+4|0;L151:do{if((a[aP]&1)==0){l=y;c[l>>2]=c[aP>>2];c[l+4>>2]=c[aP+4>>2];c[l+8>>2]=c[aP+8>>2];_=115}else{l=c[d+12>>2]|0;aM=c[d+8>>2]|0;do{if(aM>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aM>>>0<11>>>0){a[y]=aM<<1;aS=y+1|0}else{V=aM+16&-16;aB=(z=0,au(248,V|0)|0);if(z){z=0;break}c[y+8>>2]=aB;c[y>>2]=V|1;c[y+4>>2]=aM;aS=aB}LF(aS|0,l|0,aM)|0;a[aS+aM|0]=0;_=115;break L151}}while(0);aM=bT(-1,-1)|0;aT=M;aU=aM}}while(0);do{if((_|0)==115){aS=A;aP=d+16|0;c[aS>>2]=c[aP>>2];c[aS+4>>2]=c[aP+4>>2];c[aS+8>>2]=c[aP+8>>2];aP=d+40|0;aM=(a[aP]&1)==0;L166:do{if(aM){l=B;c[l>>2]=c[aP>>2];c[l+4>>2]=c[aP+4>>2];c[l+8>>2]=c[aP+8>>2];aV=a[l]|0;aW=l;_=125}else{l=c[d+48>>2]|0;aB=c[d+44>>2]|0;do{if(aB>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aB>>>0<11>>>0){V=aB<<1&255;aN=B;a[aN]=V;aX=B+1|0;aY=V;aZ=aN}else{aN=aB+16&-16;V=(z=0,au(248,aN|0)|0);if(z){z=0;break}c[B+8>>2]=V;ae=aN|1;c[B>>2]=ae;c[B+4>>2]=aB;aX=V;aY=ae&255;aZ=B}LF(aX|0,l|0,aB)|0;a[aX+aB|0]=0;aV=aY;aW=aZ;_=125;break L166}}while(0);aB=bT(-1,-1)|0;a_=M;a$=aB}}while(0);do{if((_|0)==125){if((aV&1)==0){a0=B+1|0}else{a0=c[B+8>>2]|0}ao=+LE(a0);L185:do{if(aM){aB=D;c[aB>>2]=c[aP>>2];c[aB+4>>2]=c[aP+4>>2];c[aB+8>>2]=c[aP+8>>2];a1=a[aB]|0;a3=aB;_=138}else{aB=c[d+48>>2]|0;l=c[d+44>>2]|0;do{if(l>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(l>>>0<11>>>0){ae=l<<1&255;V=D;a[V]=ae;a4=D+1|0;a5=ae;a6=V}else{V=l+16&-16;ae=(z=0,au(248,V|0)|0);if(z){z=0;break}c[D+8>>2]=ae;aN=V|1;c[D>>2]=aN;c[D+4>>2]=l;a4=ae;a5=aN&255;a6=D}LF(a4|0,aB|0,l)|0;a[a4+l|0]=0;a1=a5;a3=a6;_=138;break L185}}while(0);l=bT(-1,-1)|0;a7=M;a8=l}}while(0);do{if((_|0)==138){if((a1&1)==0){a9=D+1|0}else{a9=c[D+8>>2]|0}l=(z=0,au(290,a9|0)|0);do{if(!z){aB=LJ(l|0)|0;if(aB>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;_=161;break}return 0}if(aB>>>0<11>>>0){a[C]=aB<<1;ba=C+1|0}else{aN=aB+16&-16;ae=(z=0,au(248,aN|0)|0);if(z){z=0;_=161;break}c[C+8>>2]=ae;c[C>>2]=aN|1;c[C+4>>2]=aB;ba=ae}LF(ba|0,l|0,aB)|0;a[ba+aB|0]=0;aB=k;c[aB>>2]=c[aS>>2];c[aB+4>>2]=c[aS+4>>2];c[aB+8>>2]=c[aS+8>>2];z=0;aG(2,aR|0,y|0,k|0,+ao,C|0);if(z){z=0;aB=bT(-1,-1)|0;ae=aB;aB=M;if((a[C]&1)==0){bb=aB;bc=ae;break}Lw(c[C+8>>2]|0);bb=aB;bc=ae;break}ae=aQ;if((a[C]&1)!=0){Lw(c[C+8>>2]|0)}if((a[a3]&1)!=0){Lw(c[D+8>>2]|0)}if((a[aW]&1)!=0){Lw(c[B+8>>2]|0)}if((a[y]&1)==0){ap=ae;i=e;return ap|0}Lw(c[y+8>>2]|0);ap=ae;i=e;return ap|0}else{z=0;_=161}}while(0);if((_|0)==161){l=bT(-1,-1)|0;bb=M;bc=l}if((a[a3]&1)==0){a7=bb;a8=bc;break}Lw(c[D+8>>2]|0);a7=bb;a8=bc}}while(0);if((a[aW]&1)==0){a_=a7;a$=a8;break}Lw(c[B+8>>2]|0);a_=a7;a$=a8}}while(0);if((a[y]&1)==0){aT=a_;aU=a$;break}Lw(c[y+8>>2]|0);aT=a_;aU=a$}}while(0);a$=c[aF>>2]|0;aF=c[ad>>2]|0;a_=a$;while(1){if((a_|0)==(aF|0)){bd=aF;break}if((c[a_>>2]|0)==(aQ|0)){bd=a_;break}else{a_=a_+4|0}}a_=bd-a$>>2;bd=a$+(a_+1<<2)|0;aQ=aF-bd|0;LG(a$+(a_<<2)|0,bd|0,aQ|0)|0;bd=a$+((aQ>>2)+a_<<2)|0;a_=c[ad>>2]|0;if((bd|0)!=(a_|0)){c[ad>>2]=a_+(~((a_-4+(-bd|0)|0)>>>2)<<2)}Lw(aE);at=aT;aw=aU;ax=aw;ay=0;az=ax;aA=at;bg(az|0)}else if((T|0)==3){T=d+40|0;if((a[T]&1)==0){aU=F;c[aU>>2]=c[T>>2];c[aU+4>>2]=c[T+4>>2];c[aU+8>>2]=c[T+8>>2];be=a[aU]|0;bf=aU}else{aU=c[d+48>>2]|0;aT=c[d+44>>2]|0;if(aT>>>0>4294967279>>>0){D5(0);return 0}if(aT>>>0<11>>>0){aE=aT<<1&255;bd=F;a[bd]=aE;bh=F+1|0;bi=aE;bj=bd}else{bd=aT+16&-16;aE=Lu(bd)|0;c[F+8>>2]=aE;a_=bd|1;c[F>>2]=a_;c[F+4>>2]=aT;bh=aE;bi=a_&255;bj=F}LF(bh|0,aU|0,aT)|0;a[bh+aT|0]=0;be=bi;bf=bj}bj=F;bi=be&255;if((bi&1|0)==0){bk=bi>>>1}else{bk=c[F+4>>2]|0}do{if((bk|0)==0){z=0;ar(240,0);if(z){z=0;break}return 0}else{if((be&1)==0){bl=bj+1|0}else{bl=c[F+8>>2]|0}bi=bl+1|0;aT=bk-1|0;if(aT>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(aT>>>0<11>>>0){bh=aT<<1&255;a[E]=bh;bm=E+1|0;bn=bh}else{bh=bk+15&-16;aU=(z=0,au(248,bh|0)|0);if(z){z=0;break}c[E+8>>2]=aU;a_=bh|1;c[E>>2]=a_;c[E+4>>2]=aT;bm=aU;bn=a_&255}LF(bm|0,bi|0,aT)|0;a[bm+aT|0]=0;if((a[bf]&1)!=0){Lw(c[F+8>>2]|0)}aT=E;bi=bn&255;if((bi&1|0)==0){bo=bi>>>1}else{bo=c[E+4>>2]|0}L289:do{if((bo|0)==6){bi=bn&255;if((bi&1|0)==0){bp=bi>>>1}else{bp=c[E+4>>2]|0}if((bn&1)==0){bq=aT+1|0}else{bq=c[E+8>>2]|0}bi=bp>>>0<2>>>0?bp:2;if(bi>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;_=300;break}return 0}if(bi>>>0<11>>>0){a_=bi<<1&255;a[G]=a_;br=G+1|0;bs=a_}else{a_=bi+16&-16;aU=(z=0,au(248,a_|0)|0);if(z){z=0;_=300;break}c[G+8>>2]=aU;bh=a_|1;c[G>>2]=bh;c[G+4>>2]=bi;br=aU;bs=bh&255}LF(br|0,bq|0,bi)|0;a[br+bi|0]=0;bi=bn&255;if((bi&1|0)==0){bt=bi>>>1}else{bt=c[E+4>>2]|0}do{if(bt>>>0<2>>>0){z=0;ar(240,0);if(z){z=0;_=301;break}return 0}else{if((bn&1)==0){bu=aT+1|0}else{bu=c[E+8>>2]|0}bi=bu+2|0;bh=bt-2|0;aU=bh>>>0<2>>>0?bh:2;if(aU>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;_=301;break}return 0}if(aU>>>0<11>>>0){bh=aU<<1&255;a[H]=bh;bv=H+1|0;bw=bh}else{bh=aU+16&-16;a_=(z=0,au(248,bh|0)|0);if(z){z=0;_=301;break}c[H+8>>2]=a_;aE=bh|1;c[H>>2]=aE;c[H+4>>2]=aU;bv=a_;bw=aE&255}LF(bv|0,bi|0,aU)|0;a[bv+aU|0]=0;aU=bn&255;if((aU&1|0)==0){bx=aU>>>1}else{bx=c[E+4>>2]|0}do{if(bx>>>0<4>>>0){z=0;ar(240,0);if(z){z=0;_=302;break}return 0}else{if((bn&1)==0){by=aT+1|0}else{by=c[E+8>>2]|0}aU=by+4|0;bi=bx-4|0;aE=bi>>>0<2>>>0?bi:2;if(aE>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;_=302;break}return 0}if(aE>>>0<11>>>0){bi=aE<<1&255;a[I]=bi;bz=I+1|0;bA=bi}else{bi=aE+16&-16;a_=(z=0,au(248,bi|0)|0);if(z){z=0;_=302;break}c[I+8>>2]=a_;bh=bi|1;c[I>>2]=bh;c[I+4>>2]=aE;bz=a_;bA=bh&255}LF(bz|0,aU|0,aE)|0;a[bz+aE|0]=0;aE=c[b+4>>2]|0;aU=(z=0,au(248,88)|0);do{if(!z){bh=aU;c[j>>2]=bh;a_=aE+4|0;bi=c[a_>>2]|0;if((bi|0)==(c[aE+8>>2]|0)){z=0;as(382,aE|0,j|0);if(z){z=0;_=303;break}bB=c[j>>2]|0}else{if((bi|0)==0){bC=0}else{c[bi>>2]=bh;bC=c[a_>>2]|0}c[a_>>2]=bC+4;bB=bh}bh=bB;bi=bB;bd=d+4|0;L360:do{if((a[bd]&1)==0){ad=J;c[ad>>2]=c[bd>>2];c[ad+4>>2]=c[bd+4>>2];c[ad+8>>2]=c[bd+8>>2];_=268}else{ad=c[d+12>>2]|0;aQ=c[d+8>>2]|0;do{if(aQ>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(aQ>>>0<11>>>0){a[J]=aQ<<1;bD=J+1|0}else{a$=aQ+16&-16;aF=(z=0,au(248,a$|0)|0);if(z){z=0;break}c[J+8>>2]=aF;c[J>>2]=a$|1;c[J+4>>2]=aQ;bD=aF}LF(bD|0,ad|0,aQ)|0;a[bD+aQ|0]=0;_=268;break L360}}while(0);aQ=bT(-1,-1)|0;bE=M;bF=aQ}}while(0);do{if((_|0)==268){bd=K;aQ=d+16|0;c[bd>>2]=c[aQ>>2];c[bd+4>>2]=c[aQ+4>>2];c[bd+8>>2]=c[aQ+8>>2];aQ=G;if((bs&1)==0){bG=G+1|0}else{bG=c[G+8>>2]|0}ao=+(a2(bG|0,0,16)|0);ad=H;if((bw&1)==0){bH=H+1|0}else{bH=c[H+8>>2]|0}bI=+(a2(bH|0,0,16)|0);aF=I;if((bA&1)==0){bJ=I+1|0}else{bJ=c[I+8>>2]|0}a$=a2(bJ|0,0,16)|0;L387:do{if((a[T]&1)==0){y=L;c[y>>2]=c[T>>2];c[y+4>>2]=c[T+4>>2];c[y+8>>2]=c[T+8>>2];_=287}else{y=c[d+48>>2]|0;a8=c[d+44>>2]|0;do{if(a8>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(a8>>>0<11>>>0){a[L]=a8<<1;bK=L+1|0}else{a7=a8+16&-16;B=(z=0,au(248,a7|0)|0);if(z){z=0;break}c[L+8>>2]=B;c[L>>2]=a7|1;c[L+4>>2]=a8;bK=B}LF(bK|0,y|0,a8)|0;a[bK+a8|0]=0;_=287;break L387}}while(0);a8=bT(-1,-1)|0;bL=M;bM=a8}}while(0);do{if((_|0)==287){a8=h;c[a8>>2]=c[bd>>2];c[a8+4>>2]=c[bd+4>>2];c[a8+8>>2]=c[bd+8>>2];z=0;av(2,bi|0,J|0,h|0,+ao,+bI,+(+(a$|0)),+1.0,L|0);if(z){z=0;a8=bT(-1,-1)|0;y=a8;a8=M;if((a[L]&1)==0){bL=a8;bM=y;break}Lw(c[L+8>>2]|0);bL=a8;bM=y;break}if((a[L]&1)!=0){Lw(c[L+8>>2]|0)}if((a[J]&1)!=0){Lw(c[J+8>>2]|0)}if((a[aF]&1)!=0){Lw(c[I+8>>2]|0)}if((a[ad]&1)!=0){Lw(c[H+8>>2]|0)}if((a[aQ]&1)==0){bN=bh;_=387;break L289}Lw(c[G+8>>2]|0);bN=bh;_=387;break L289}}while(0);if((a[J]&1)==0){bE=bL;bF=bM;break}Lw(c[J+8>>2]|0);bE=bL;bF=bM}}while(0);bi=c[aE>>2]|0;aQ=c[a_>>2]|0;ad=bi;while(1){if((ad|0)==(aQ|0)){bO=aQ;break}if((c[ad>>2]|0)==(bB|0)){bO=ad;break}else{ad=ad+4|0}}ad=bO-bi>>2;aF=bi+(ad+1<<2)|0;a$=aQ-aF|0;LG(bi+(ad<<2)|0,aF|0,a$|0)|0;aF=bi+((a$>>2)+ad<<2)|0;ad=c[a_>>2]|0;if((aF|0)!=(ad|0)){c[a_>>2]=ad+(~((ad-4+(-aF|0)|0)>>>2)<<2)}Lw(bh);bP=bE;bQ=bF;bR=a[I]|0}else{z=0;_=303}}while(0);if((_|0)==303){aE=bT(-1,-1)|0;bP=M;bQ=aE;bR=bA}if((bR&1)==0){bS=bP;bU=bQ;break}Lw(c[I+8>>2]|0);bS=bP;bU=bQ}}while(0);if((_|0)==302){aE=bT(-1,-1)|0;bS=M;bU=aE}if((a[H]&1)==0){bV=bS;bW=bU;break}Lw(c[H+8>>2]|0);bV=bS;bW=bU}}while(0);if((_|0)==301){aE=bT(-1,-1)|0;bV=M;bW=aE}if((a[G]&1)==0){bX=bV;bY=bW;break}Lw(c[G+8>>2]|0);bX=bV;bY=bW}else{aE=c[b+4>>2]|0;aU=(z=0,au(248,88)|0);if(z){z=0;_=300;break}aF=aU;c[g>>2]=aF;aU=aE+4|0;ad=c[aU>>2]|0;if((ad|0)==(c[aE+8>>2]|0)){z=0;as(382,aE|0,g|0);if(z){z=0;_=300;break}bZ=c[g>>2]|0}else{if((ad|0)==0){b_=0}else{c[ad>>2]=aF;b_=c[aU>>2]|0}c[aU>>2]=b_+4;bZ=aF}aF=bZ;ad=bZ;a$=d+4|0;L451:do{if((a[a$]&1)==0){bd=N;c[bd>>2]=c[a$>>2];c[bd+4>>2]=c[a$+4>>2];c[bd+8>>2]=c[a$+8>>2];_=339}else{bd=c[d+12>>2]|0;y=c[d+8>>2]|0;do{if(y>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(y>>>0<11>>>0){a[N]=y<<1;b$=N+1|0}else{a8=y+16&-16;B=(z=0,au(248,a8|0)|0);if(z){z=0;break}c[N+8>>2]=B;c[N>>2]=a8|1;c[N+4>>2]=y;b$=B}LF(b$|0,bd|0,y)|0;a[b$+y|0]=0;_=339;break L451}}while(0);y=bT(-1,-1)|0;b0=M;b1=y}}while(0);do{if((_|0)==339){a$=O;y=d+16|0;c[a$>>2]=c[y>>2];c[a$+4>>2]=c[y+4>>2];c[a$+8>>2]=c[y+8>>2];if((bn&1)==0){b2=aT+1|0}else{b2=c[E+8>>2]|0}y=a[b2]|0;bd=P;B=P;a[B]=4;a8=bd+1|0;LI(a8|0,y|0,2)|0;a[bd+3|0]=0;bI=+(a2(a8|0,0,16)|0);if((bn&1)==0){b3=aT+1|0}else{b3=c[E+8>>2]|0}a8=a[b3+1|0]|0;bd=Q;y=Q;a[y]=4;a7=bd+1|0;LI(a7|0,a8|0,2)|0;a[bd+3|0]=0;ao=+(a2(a7|0,0,16)|0);if((bn&1)==0){b4=aT+1|0}else{b4=c[E+8>>2]|0}a7=a[b4+2|0]|0;bd=R;a8=R;a[a8]=4;aW=bd+1|0;LI(aW|0,a7|0,2)|0;a[bd+3|0]=0;bd=a2(aW|0,0,16)|0;L478:do{if((a[T]&1)==0){aW=S;c[aW>>2]=c[T>>2];c[aW+4>>2]=c[T+4>>2];c[aW+8>>2]=c[T+8>>2];_=358}else{aW=c[d+48>>2]|0;a7=c[d+44>>2]|0;do{if(a7>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(a7>>>0<11>>>0){a[S]=a7<<1;b5=S+1|0}else{bc=a7+16&-16;bb=(z=0,au(248,bc|0)|0);if(z){z=0;break}c[S+8>>2]=bb;c[S>>2]=bc|1;c[S+4>>2]=a7;b5=bb}LF(b5|0,aW|0,a7)|0;a[b5+a7|0]=0;_=358;break L478}}while(0);a7=bT(-1,-1)|0;b6=M;b7=a7}}while(0);do{if((_|0)==358){a7=f;c[a7>>2]=c[a$>>2];c[a7+4>>2]=c[a$+4>>2];c[a7+8>>2]=c[a$+8>>2];z=0;av(2,ad|0,N|0,f|0,+bI,+ao,+(+(bd|0)),+1.0,S|0);if(z){z=0;a7=bT(-1,-1)|0;aW=a7;a7=M;if((a[S]&1)==0){b6=a7;b7=aW;break}Lw(c[S+8>>2]|0);b6=a7;b7=aW;break}if((a[S]&1)!=0){Lw(c[S+8>>2]|0)}if((a[a8]&1)!=0){Lw(c[R+8>>2]|0)}if((a[y]&1)!=0){Lw(c[Q+8>>2]|0)}if((a[B]&1)!=0){Lw(c[P+8>>2]|0)}if((a[N]&1)==0){bN=aF;_=387;break L289}Lw(c[N+8>>2]|0);bN=aF;_=387;break L289}}while(0);if((a[a8]&1)!=0){Lw(c[R+8>>2]|0)}if((a[y]&1)!=0){Lw(c[Q+8>>2]|0)}if((a[B]&1)!=0){Lw(c[P+8>>2]|0)}if((a[N]&1)==0){b0=b6;b1=b7;break}Lw(c[N+8>>2]|0);b0=b6;b1=b7}}while(0);ad=c[aE>>2]|0;bd=c[aU>>2]|0;a$=ad;while(1){if((a$|0)==(bd|0)){b8=bd;break}if((c[a$>>2]|0)==(bZ|0)){b8=a$;break}else{a$=a$+4|0}}a$=b8-ad>>2;aE=ad+(a$+1<<2)|0;aW=bd-aE|0;LG(ad+(a$<<2)|0,aE|0,aW|0)|0;aE=ad+((aW>>2)+a$<<2)|0;a$=c[aU>>2]|0;if((aE|0)!=(a$|0)){c[aU>>2]=a$+(~((a$-4+(-aE|0)|0)>>>2)<<2)}Lw(aF);bX=b0;bY=b1}}while(0);if((_|0)==387){aT=bN;if((bn&1)==0){ap=aT;i=e;return ap|0}Lw(c[E+8>>2]|0);ap=aT;i=e;return ap|0}else if((_|0)==300){aT=bT(-1,-1)|0;bX=M;bY=aT}if((bn&1)==0){at=bX;aw=bY;ax=aw;ay=0;az=ax;aA=at;bg(az|0)}Lw(c[E+8>>2]|0);at=bX;aw=bY;ax=aw;ay=0;az=ax;aA=at;bg(az|0)}}while(0);bY=bT(-1,-1)|0;bX=bY;bY=M;if((a[bf]&1)==0){at=bY;aw=bX;ax=aw;ay=0;az=ax;aA=at;bg(az|0)}Lw(c[F+8>>2]|0);at=bY;aw=bX;ax=aw;ay=0;az=ax;aA=at;bg(az|0)}else{ap=0;i=e;return ap|0}return 0}function jl(a,b){a=a|0;b=b|0;return b|0}function jm(a,b){a=a|0;b=b|0;return b|0}function jn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,at=0,av=0,aw=0,ax=0,ay=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0;e=i;i=i+40|0;f=e|0;g=e+16|0;h=e+24|0;j=h;k=i;i=i+8|0;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;LI(j|0,0,12)|0;z=0;as(278,k|0,0);L1:do{if(!z){r=d+44|0;s=c[r>>2]|0;t=(c[d+48>>2]|0)-s>>2;L3:do{if((t|0)==0){u=47}else{v=b|0;w=k|0;x=d+56|0;y=m;A=m+8|0;B=n;C=n+1|0;D=n+8|0;E=n+4|0;F=l;G=l+8|0;H=l+1|0;I=l+4|0;J=m+1|0;K=m+4|0;L=m|0;N=0;O=0;P=s;L5:while(1){Q=c[P+(N<<2)>>2]|0;R=(z=0,aM(c[(c[Q>>2]|0)+20>>2]|0,Q|0,v|0)|0);if(z){z=0;u=32;break}z=0;aR(c[(c[R>>2]|0)+28>>2]|0,l|0,R|0,w|0);if(z){z=0;u=32;break}do{if((a[x]|0)==0){S=0;T=O;u=23}else{if((a[F]&1)==0){c[y>>2]=c[F>>2];c[y+4>>2]=c[F+4>>2];c[y+8>>2]=c[F+8>>2];U=a[y]|0}else{R=c[G>>2]|0;Q=c[I>>2]|0;if(Q>>>0>4294967279>>>0){u=10;break L5}if(Q>>>0<11>>>0){V=Q<<1&255;a[y]=V;W=J;X=V}else{V=Q+16&-16;Y=(z=0,au(248,V|0)|0);if(z){z=0;u=35;break L5}c[A>>2]=Y;Z=V|1;c[L>>2]=Z;c[K>>2]=Q;W=Y;X=Z&255}LF(W|0,R|0,Q)|0;a[W+Q|0]=0;U=X}Q=U&255;R=(Q&1|0)==0?Q>>>1:c[K>>2]|0;if(R>>>0<2>>>0){_=0;$=U;u=24;break}Q=(U&1)==0;if((a[Q?J:c[A>>2]|0]|0)==34){if((a[(Q?J:c[A>>2]|0)+(R-1)|0]|0)!=34){u=20}}else{u=20}if((u|0)==20){u=0;if((a[Q?J:c[A>>2]|0]|0)!=39){_=0;$=U;u=24;break}if((a[(Q?J:c[A>>2]|0)+(R-1)|0]|0)!=39){_=0;$=U;u=24;break}}if((a[Q?J:c[A>>2]|0]|0)==0){_=0;$=U;u=24}else{S=1;T=U;u=23}}}while(0);if((u|0)==23){u=0;Q=(a[(c[(c[r>>2]|0)+(N<<2)>>2]|0)+29|0]&1)!=0;if(S){_=Q;$=T;u=24}else{aa=Q;ab=T;u=26}}do{if((u|0)==24){u=0;if(($&1)==0){aa=_;ab=$;u=26;break}Lw(c[A>>2]|0);if(_){ac=$;u=27}else{ad=$;u=40}}}while(0);if((u|0)==26){u=0;if(aa){ac=ab;u=27}else{ad=ab;u=40}}do{if((u|0)==27){u=0;z=0;as(180,n|0,l|0);if(z){z=0;u=35;break L5}Q=a[B]|0;R=(Q&1)==0?C:c[D>>2]|0;Z=Q&255;Q=(Z&1|0)==0?Z>>>1:c[E>>2]|0;z=0,az(88,h|0,R|0,Q|0)|0;if(z){z=0;u=38;break L5}if((a[B]&1)==0){ae=ac;break}Lw(c[D>>2]|0);ae=ac}else if((u|0)==40){u=0;Q=a[F]|0;R=Q&255;z=0,az(88,h|0,((Q&1)==0?H:c[G>>2]|0)|0,((R&1|0)==0?R>>>1:c[I>>2]|0)|0)|0;if(!z){ae=ad}else{z=0;u=35;break L5}}}while(0);if((a[F]&1)!=0){Lw(c[G>>2]|0)}R=N+1|0;if(R>>>0>=t>>>0){u=47;break L3}N=R;O=ae;P=c[r>>2]|0}do{if((u|0)==10){z=0;ar(86,0);if(!z){return 0}else{z=0;P=bT(-1,-1)|0;af=M;ag=P;u=37;break}}else if((u|0)==32){P=bT(-1,-1)|0;ah=M;ai=P;u=34;break L3}else if((u|0)==35){P=bT(-1,-1)|0;af=M;ag=P;u=37}else if((u|0)==38){P=bT(-1,-1)|0;O=P;P=M;if((a[B]&1)==0){aj=O;ak=P;break}Lw(c[D>>2]|0);aj=O;ak=P}}while(0);if((u|0)==37){aj=ag;ak=af}if((a[F]&1)==0){al=aj;am=ak;break}Lw(c[G>>2]|0);al=aj;am=ak}}while(0);L59:do{if((u|0)==47){r=c[b+4>>2]|0;t=(z=0,au(248,52)|0);do{if(!z){s=t;c[g>>2]=s;D=r+4|0;B=c[D>>2]|0;if((B|0)==(c[r+8>>2]|0)){z=0;as(382,r|0,g|0);if(z){z=0;break}an=c[g>>2]|0}else{if((B|0)==0){ao=0}else{c[B>>2]=s;ao=c[D>>2]|0}c[D>>2]=ao+4;an=s}s=an;B=an;P=d+4|0;L71:do{if((a[P]&1)==0){O=o;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];u=64}else{O=c[d+12>>2]|0;N=c[d+8>>2]|0;do{if(N>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(N>>>0<11>>>0){a[o]=N<<1;ap=o+1|0}else{I=N+16&-16;H=(z=0,au(248,I|0)|0);if(z){z=0;break}c[o+8>>2]=H;c[o>>2]=I|1;c[o+4>>2]=N;ap=H}LF(ap|0,O|0,N)|0;a[ap+N|0]=0;u=64;break L71}}while(0);N=bT(-1,-1)|0;at=N;av=M}}while(0);do{if((u|0)==64){P=p;N=d+16|0;c[P>>2]=c[N>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];L86:do{if((a[j]&1)==0){N=q;c[N>>2]=c[j>>2];c[N+4>>2]=c[j+4>>2];c[N+8>>2]=c[j+8>>2];u=74}else{N=c[h+8>>2]|0;O=c[h+4>>2]|0;do{if(O>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(O>>>0<11>>>0){a[q]=O<<1;aw=q+1|0}else{H=O+16&-16;I=(z=0,au(248,H|0)|0);if(z){z=0;break}c[q+8>>2]=I;c[q>>2]=H|1;c[q+4>>2]=O;aw=I}LF(aw|0,N|0,O)|0;a[aw+O|0]=0;u=74;break L86}}while(0);O=bT(-1,-1)|0;ax=O;ay=M}}while(0);do{if((u|0)==74){O=f;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];z=0;aq(28,B|0,o|0,f|0,q|0,0);if(z){z=0;O=bT(-1,-1)|0;N=O;O=M;if((a[q]&1)==0){ax=N;ay=O;break}Lw(c[q+8>>2]|0);ax=N;ay=O;break}O=an;if((a[q]&1)!=0){Lw(c[q+8>>2]|0)}if((a[o]&1)!=0){Lw(c[o+8>>2]|0)}z=0;ar(444,k|0);if(z){z=0;u=31;break L1}if((a[j]&1)==0){i=e;return O|0}Lw(c[h+8>>2]|0);i=e;return O|0}}while(0);if((a[o]&1)==0){at=ax;av=ay;break}Lw(c[o+8>>2]|0);at=ax;av=ay}}while(0);B=c[r>>2]|0;P=c[D>>2]|0;O=B;while(1){if((O|0)==(P|0)){aA=P;break}if((c[O>>2]|0)==(an|0)){aA=O;break}else{O=O+4|0}}O=aA-B>>2;N=B+(O+1<<2)|0;I=P-N|0;LG(B+(O<<2)|0,N|0,I|0)|0;N=B+((I>>2)+O<<2)|0;O=c[D>>2]|0;if((N|0)!=(O|0)){c[D>>2]=O+(~((O-4+(-N|0)|0)>>>2)<<2)}Lw(s);al=at;am=av;break L59}else{z=0}}while(0);r=bT(-1,-1)|0;ah=M;ai=r;u=34}}while(0);if((u|0)==34){al=ai;am=ah}z=0;ar(444,k|0);if(!z){aB=al;aC=am;break}else{z=0}bT(-1,-1,0)|0;bX();return 0}else{z=0;u=31}}while(0);if((u|0)==31){u=bT(-1,-1)|0;aB=u;aC=M}if((a[j]&1)==0){aD=aB;aE=0;aF=aD;aG=aC;bg(aF|0)}Lw(c[h+8>>2]|0);aD=aB;aE=0;aF=aD;aG=aC;bg(aF|0);return 0}function jo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0;e=i;i=i+72|0;f=e|0;g=e+8|0;h=e+24|0;j=e+40|0;k=e+56|0;l=d|0;if((a[d+28|0]&1)!=0){m=l;i=e;return m|0}n=b+4|0;b=c[n>>2]|0;o=d+40|0;if((a[o]&1)==0){p=g;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];q=a[p]|0}else{p=c[d+48>>2]|0;r=c[d+44>>2]|0;if(r>>>0>4294967279>>>0){D5(0);return 0}if(r>>>0<11>>>0){s=r<<1&255;a[g]=s;t=g+1|0;u=s}else{s=r+16&-16;v=Lu(s)|0;c[g+8>>2]=v;w=s|1;c[g>>2]=w;c[g+4>>2]=r;t=v;u=w&255}LF(t|0,p|0,r)|0;a[t+r|0]=0;q=u}u=(j$(b+160|0,g)|0)!=0;do{if((q&1)==0){if(u){x=b;break}else{m=l}i=e;return m|0}else{Lw(c[g+8>>2]|0);if(u){x=c[n>>2]|0;break}else{m=l;i=e;return m|0}}}while(0);l=Lu(88)|0;c[f>>2]=l;u=x+4|0;g=c[u>>2]|0;if((g|0)==(c[x+8>>2]|0)){e4(x|0,f);y=c[f>>2]|0}else{if((g|0)==0){A=0}else{c[g>>2]=l;A=c[u>>2]|0}c[u>>2]=A+4;y=l}l=y;A=y;g=c[n>>2]|0;L30:do{if((a[o]&1)==0){n=h;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];B=29}else{n=c[d+48>>2]|0;f=c[d+44>>2]|0;do{if(f>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}else{if(f>>>0<11>>>0){a[h]=f<<1;C=h+1|0}else{b=f+16&-16;q=(z=0,au(248,b|0)|0);if(z){z=0;break}c[h+8>>2]=q;c[h>>2]=b|1;c[h+4>>2]=f;C=q}LF(C|0,n|0,f)|0;a[C+f|0]=0;B=29;break L30}}while(0);f=bT(-1,-1)|0;D=M;E=f}}while(0);do{if((B|0)==29){C=(z=0,aM(262,g+160|0,h|0)|0);do{if(!z){z=0;as(618,A|0,c[C>>2]|0);if(z){z=0;break}if((a[h]&1)!=0){Lw(c[h+8>>2]|0)}o=d+4|0;if((a[o]&1)==0){f=k;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2]}else{o=c[d+12>>2]|0;f=c[d+8>>2]|0;if(f>>>0>4294967279>>>0){D5(0);return 0}if(f>>>0<11>>>0){a[k]=f<<1;F=k+1|0}else{n=f+16&-16;q=Lu(n)|0;c[k+8>>2]=q;c[k>>2]=n|1;c[k+4>>2]=f;F=q}LF(F|0,o|0,f)|0;a[F+f|0]=0}f=(z=0,aM(344,y+4|0,k|0)|0);do{if(!z){o=f;if((a[o]&1)==0){q=j;c[q>>2]=c[o>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];G=a[q]|0}else{q=c[f+8>>2]|0;o=c[f+4>>2]|0;if(o>>>0>4294967279>>>0){z=0;ar(86,0);if(z){z=0;break}return 0}if(o>>>0<11>>>0){n=o<<1&255;a[j]=n;H=j+1|0;I=n}else{n=o+16&-16;b=(z=0,au(248,n|0)|0);if(z){z=0;break}c[j+8>>2]=b;r=n|1;c[j>>2]=r;c[j+4>>2]=o;H=b;I=r&255}LF(H|0,q|0,o)|0;a[H+o|0]=0;G=I}if((G&1)!=0){Lw(c[j+8>>2]|0)}if((a[k]&1)!=0){Lw(c[k+8>>2]|0)}LG(y+16|0,d+16|0,12)|0;m=y;i=e;return m|0}else{z=0}}while(0);f=bT(-1,-1)|0;o=f;f=M;if((a[k]&1)==0){J=f;K=o;L=K;N=0;O=L;P=J;bg(O|0)}Lw(c[k+8>>2]|0);J=f;K=o;L=K;N=0;O=L;P=J;bg(O|0)}else{z=0}}while(0);C=bT(-1,-1)|0;o=C;C=M;if((a[h]&1)==0){D=C;E=o;break}Lw(c[h+8>>2]|0);D=C;E=o}}while(0);h=c[x>>2]|0;x=c[u>>2]|0;k=h;while(1){if((k|0)==(x|0)){Q=x;break}if((c[k>>2]|0)==(y|0)){Q=k;break}else{k=k+4|0}}k=Q-h>>2;Q=h+(k+1<<2)|0;y=x-Q|0;LG(h+(k<<2)|0,Q|0,y|0)|0;Q=h+((y>>2)+k<<2)|0;k=c[u>>2]|0;if((Q|0)!=(k|0)){c[u>>2]=k+(~((k-4+(-Q|0)|0)>>>2)<<2)}Lw(l);J=D;K=E;L=K;N=0;O=L;P=J;bg(O|0);return 0}
function Ko(b){b=b|0;var d=0,e=0,f=0;if((a[42352]|0)!=0){d=c[10180]|0;return d|0}if((bC(42352)|0)==0){d=c[10180]|0;return d|0}do{if((a[42272]|0)==0){if((bC(42272)|0)==0){break}LI(39264,0,288)|0;bn(286,0,t|0)|0}}while(0);z=0,aM(222,39264,5040)|0;if(z){z=0;e=bT(-1,-1)|0;f=M;bg(e|0)}z=0,aM(222,39276,4848)|0;if(z){z=0;e=bT(-1,-1)|0;f=M;bg(e|0)}c[10180]=39264;d=c[10180]|0;return d|0}function Kp(b){b=b|0;if((a[42416]|0)!=0){return 40816}if((bC(42416)|0)==0){return 40816}z=0;aR(96,40816,7984,8);if(z){z=0;b=bT(-1,-1)|0;bg(b|0)}bn(300,40816,t|0)|0;return 40816}function Kq(b){b=b|0;var c=0,d=0;if((a[42360]|0)!=0){return 40728}if((bC(42360)|0)==0){return 40728}b=(z=0,au(120,7800)|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}z=0;aR(72,40728,7800,b|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}bn(412,40728,t|0)|0;return 40728}function Kr(b){b=b|0;if((a[42440]|0)!=0){return 40864}if((bC(42440)|0)==0){return 40864}z=0;aR(96,40864,7528,8);if(z){z=0;b=bT(-1,-1)|0;bg(b|0)}bn(300,40864,t|0)|0;return 40864}function Ks(b){b=b|0;var c=0,d=0;if((a[42384]|0)!=0){return 40776}if((bC(42384)|0)==0){return 40776}b=(z=0,au(120,7240)|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}z=0;aR(72,40776,7240,b|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}bn(412,40776,t|0)|0;return 40776}function Kt(b){b=b|0;if((a[42432]|0)!=0){return 40848}if((bC(42432)|0)==0){return 40848}z=0;aR(96,40848,7048,20);if(z){z=0;b=bT(-1,-1)|0;bg(b|0)}bn(300,40848,t|0)|0;return 40848}function Ku(b){b=b|0;var c=0,d=0;if((a[42376]|0)!=0){return 40760}if((bC(42376)|0)==0){return 40760}b=(z=0,au(120,6776)|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}z=0;aR(72,40760,6776,b|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}bn(412,40760,t|0)|0;return 40760}function Kv(b){b=b|0;if((a[42424]|0)!=0){return 40832}if((bC(42424)|0)==0){return 40832}z=0;aR(96,40832,6608,11);if(z){z=0;b=bT(-1,-1)|0;bg(b|0)}bn(300,40832,t|0)|0;return 40832}function Kw(b){b=b|0;var c=0,d=0;if((a[42368]|0)!=0){return 40744}if((bC(42368)|0)==0){return 40744}b=(z=0,au(120,6392)|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}z=0;aR(72,40744,6392,b|0);if(z){z=0;c=bT(-1,-1)|0;d=M;bg(c|0)}bn(412,40744,t|0)|0;return 40744}function Kx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0,m=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=b$()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;bg(l|0)}}}while(0);m=+LD(b,g,c[10082]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=m;i=f;return+h}c[e>>2]=4;h=m;i=f;return+h}function Ky(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0,m=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=b$()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;bg(l|0)}}}while(0);m=+LD(b,g,c[10082]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=m;i=f;return+h}c[e>>2]=4;h=m;i=f;return+h}function Kz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0,m=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=b$()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}l=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=l;break}else{z=0;l=bT(-1,-1)|0;bg(l|0)}}}while(0);m=+LD(b,g,c[10082]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=m;i=f;return+h}function KA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g|0;do{if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0}else{if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;break}l=b$()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}n=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=n;break}else{z=0;n=bT(-1,-1)|0;bg(n|0)}}}while(0);n=a0(b|0,h|0,f|0,c[10082]|0)|0;o=c[l>>2]|0;if((o|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;break}if((o|0)!=34){j=M;k=n;break}c[e>>2]=4;j=-1;k=-1}}while(0);i=g;return(M=j,k)|0}function KB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=b$()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}m=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=m;break}else{z=0;m=bT(-1,-1)|0;bg(m|0)}}}while(0);m=a0(b|0,h|0,f|0,c[10082]|0)|0;f=M;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>-1>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function KC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=b$()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}m=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=m;break}else{z=0;m=bT(-1,-1)|0;bg(m|0)}}}while(0);m=a0(b|0,h|0,f|0,c[10082]|0)|0;f=M;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>-1>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function KD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=b$()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}m=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=m;break}else{z=0;m=bT(-1,-1)|0;bg(m|0)}}}while(0);m=a0(b|0,h|0,f|0,c[10082]|0)|0;f=M;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>65535>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function KE(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;i=g;return(M=j,k)|0}l=b$()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}n=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=n;break}else{z=0;n=bT(-1,-1)|0;bg(n|0)}}}while(0);n=cd(b|0,h|0,f|0,c[10082]|0)|0;f=M;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;i=g;return(M=j,k)|0}if((b|0)!=34){j=f;k=n;i=g;return(M=j,k)|0}c[e>>2]=4;e=0;b=(f|0)>(e|0)|(f|0)==(e|0)&n>>>0>0>>>0;j=b?2147483647:-2147483648;k=b?-1:0;i=g;return(M=j,k)|0}function KF(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=b$()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[42320]|0)==0){if((bC(42320)|0)==0){break}m=(z=0,az(72,2147483647,10032,0)|0);if(!z){c[10082]=m;break}else{z=0;m=bT(-1,-1)|0;bg(m|0)}}}while(0);m=cd(b|0,h|0,f|0,c[10082]|0)|0;f=M;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=-1;h=0;if((b|0)==34|((f|0)<(d|0)|(f|0)==(d|0)&m>>>0<-2147483648>>>0)|((f|0)>(h|0)|(f|0)==(h|0)&m>>>0>2147483647>>>0)){c[e>>2]=4;e=0;j=(f|0)>(e|0)|(f|0)==(e|0)&m>>>0>0>>>0?2147483647:-2147483648;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function KG(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+4|0;d=(c[a>>2]|0)+(c[b+4>>2]|0)|0;a=d;e=c[b>>2]|0;if((e&1|0)==0){f=e;cA[f&1023](a);return}else{f=c[(c[d>>2]|0)+(e-1)>>2]|0;cA[f&1023](a);return}}function KH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=b+8|0;f=b+4|0;g=c[f>>2]|0;h=c[e>>2]|0;i=g;if(h-i>>2>>>0>=d>>>0){j=d;k=g;do{if((k|0)==0){l=0}else{c[k>>2]=0;l=c[f>>2]|0}k=l+4|0;c[f>>2]=k;j=j-1|0;}while((j|0)!=0);return}j=b+16|0;k=b|0;l=c[k>>2]|0;g=i-l>>2;i=g+d|0;if(i>>>0>1073741823>>>0){IU(0)}m=h-l|0;do{if(m>>2>>>0>536870910>>>0){n=1073741823;o=11}else{l=m>>1;h=l>>>0<i>>>0?i:l;if((h|0)==0){p=0;q=0;break}l=b+128|0;if(!((a[l]&1)==0&h>>>0<29>>>0)){n=h;o=11;break}a[l]=1;p=j;q=h}}while(0);if((o|0)==11){p=Lu(n<<2)|0;q=n}n=d;d=p+(g<<2)|0;do{if((d|0)==0){r=0}else{c[d>>2]=0;r=d}d=r+4|0;n=n-1|0;}while((n|0)!=0);n=c[k>>2]|0;r=(c[f>>2]|0)-n|0;o=p+(g-(r>>2)<<2)|0;g=n;LF(o|0,g|0,r)|0;c[k>>2]=o;c[f>>2]=d;c[e>>2]=p+(q<<2);if((n|0)==0){return}if((n|0)==(j|0)){a[b+128|0]=0;return}else{Lw(g);return}}function KI(a){a=a|0;Eo(39540);Eo(39528);Eo(39516);Eo(39504);Eo(39492);Eo(39480);Eo(39468);Eo(39456);Eo(39444);Eo(39432);Eo(39420);Eo(39408);Eo(39396);Eo(39384);Eo(39372);Eo(39360);Eo(39348);Eo(39336);Eo(39324);Eo(39312);Eo(39300);Eo(39288);Eo(39276);Eo(39264);return}function KJ(a){a=a|0;Eb(40284);Eb(40272);Eb(40260);Eb(40248);Eb(40236);Eb(40224);Eb(40212);Eb(40200);Eb(40188);Eb(40176);Eb(40164);Eb(40152);Eb(40140);Eb(40128);Eb(40116);Eb(40104);Eb(40092);Eb(40080);Eb(40068);Eb(40056);Eb(40044);Eb(40032);Eb(40020);Eb(40008);return}function KK(a){a=a|0;Eo(39084);Eo(39072);Eo(39060);Eo(39048);Eo(39036);Eo(39024);Eo(39012);Eo(39e3);Eo(38988);Eo(38976);Eo(38964);Eo(38952);Eo(38940);Eo(38928);Eo(38916);Eo(38904);Eo(38892);Eo(38880);Eo(38868);Eo(38856);Eo(38844);Eo(38832);Eo(38820);Eo(38808);return}function KL(a){a=a|0;Eb(39828);Eb(39816);Eb(39804);Eb(39792);Eb(39780);Eb(39768);Eb(39756);Eb(39744);Eb(39732);Eb(39720);Eb(39708);Eb(39696);Eb(39684);Eb(39672);Eb(39660);Eb(39648);Eb(39636);Eb(39624);Eb(39612);Eb(39600);Eb(39588);Eb(39576);Eb(39564);Eb(39552);return}function KM(a){a=a|0;Eo(39252);Eo(39240);Eo(39228);Eo(39216);Eo(39204);Eo(39192);Eo(39180);Eo(39168);Eo(39156);Eo(39144);Eo(39132);Eo(39120);Eo(39108);Eo(39096);return}function KN(a){a=a|0;Eb(39996);Eb(39984);Eb(39972);Eb(39960);Eb(39948);Eb(39936);Eb(39924);Eb(39912);Eb(39900);Eb(39888);Eb(39876);Eb(39864);Eb(39852);Eb(39840);return}function KO(a,b,c){a=a|0;b=b|0;c=c|0;return KP(0,a,b,(c|0)!=0?c:38288)|0}function KP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+8|0;h=g|0;c[h>>2]=b;j=((f|0)==0?38280:f)|0;f=c[j>>2]|0;L1:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n-194|0;if(l>>>0>50>>>0){break L1}o=d+1|0;q=c[p+(l<<2)>>2]|0;r=e-1|0;break}}else{o=d;q=f;r=e}}while(0);L19:do{if((r|0)==0){s=q}else{l=a[o]|0;n=(l&255)>>>3;if((n-16|n+(q>>26))>>>0>7>>>0){break L1}else{t=o;u=q;v=r;w=l}while(1){t=t+1|0;u=(w&255)-128|u<<6;v=v-1|0;if((u|0)>=0){break}if((v|0)==0){s=u;break L19}w=a[t]|0;if(((w&255)-128|0)>>>0>63>>>0){break L1}}c[j>>2]=0;c[m>>2]=u;k=e-v|0;i=g;return k|0}}while(0);c[j>>2]=s;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(b$()|0)>>2]=84;k=-1;i=g;return k|0}function KQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=i;i=i+1032|0;h=g|0;j=g+1024|0;k=c[b>>2]|0;c[j>>2]=k;l=(a|0)!=0;m=l?e:256;e=l?a:h|0;L1:do{if((k|0)==0|(m|0)==0){n=0;o=d;p=m;q=e;r=k}else{a=h|0;s=m;t=d;u=0;v=e;w=k;while(1){x=t>>>2;y=x>>>0>=s>>>0;if(!(y|t>>>0>131>>>0)){n=u;o=t;p=s;q=v;r=w;break L1}z=y?s:x;A=t-z|0;x=KR(v,j,z,f)|0;if((x|0)==-1){break}if((v|0)==(a|0)){B=a;C=s}else{B=v+(x<<2)|0;C=s-x|0}z=x+u|0;x=c[j>>2]|0;if((x|0)==0|(C|0)==0){n=z;o=A;p=C;q=B;r=x;break L1}else{s=C;t=A;u=z;v=B;w=x}}n=-1;o=A;p=0;q=v;r=c[j>>2]|0}}while(0);L12:do{if((r|0)==0){D=n}else{if((p|0)==0|(o|0)==0){D=n;break}else{E=p;F=o;G=n;H=q;I=r}while(1){J=KP(H,I,F,f)|0;if((J+2|0)>>>0<3>>>0){break}A=(c[j>>2]|0)+J|0;c[j>>2]=A;B=E-1|0;C=G+1|0;if((B|0)==0|(F|0)==(J|0)){D=C;break L12}else{E=B;F=F-J|0;G=C;H=H+4|0;I=A}}if((J|0)==0){c[j>>2]=0;D=G;break}else if((J|0)==(-1|0)){D=-1;break}else{c[f>>2]=0;D=G;break}}}while(0);if(!l){i=g;return D|0}c[b>>2]=c[j>>2];i=g;return D|0}function KR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0;h=c[e>>2]|0;do{if((g|0)==0){i=5}else{j=g|0;k=c[j>>2]|0;if((k|0)==0){i=5;break}if((b|0)==0){l=k;m=h;n=f;i=16;break}c[j>>2]=0;o=k;q=h;r=b;s=f;i=36}}while(0);if((i|0)==5){if((b|0)==0){t=h;u=f;i=7}else{v=h;w=b;x=f;i=6}}L7:while(1){if((i|0)==6){i=0;if((x|0)==0){y=f;i=54;break}else{z=x;A=w;B=v}while(1){h=a[B]|0;do{if(((h&255)-1|0)>>>0<127>>>0){if((B&3|0)==0&z>>>0>3>>>0){C=z;D=A;E=B}else{F=B;G=A;H=z;I=h;break}while(1){J=c[E>>2]|0;if(((J-16843009|J)&-2139062144|0)!=0){i=30;break}c[D>>2]=J&255;c[D+4>>2]=d[E+1|0]|0;c[D+8>>2]=d[E+2|0]|0;K=E+4|0;L=D+16|0;c[D+12>>2]=d[E+3|0]|0;M=C-4|0;if(M>>>0>3>>>0){C=M;D=L;E=K}else{i=31;break}}if((i|0)==31){i=0;F=K;G=L;H=M;I=a[K]|0;break}else if((i|0)==30){i=0;F=E;G=D;H=C;I=J&255;break}}else{F=B;G=A;H=z;I=h}}while(0);N=I&255;if((N-1|0)>>>0>=127>>>0){break}c[G>>2]=N;h=H-1|0;if((h|0)==0){y=f;i=55;break L7}else{z=h;A=G+4|0;B=F+1|0}}h=N-194|0;if(h>>>0>50>>>0){O=H;P=G;Q=F;i=47;break}o=c[p+(h<<2)>>2]|0;q=F+1|0;r=G;s=H;i=36;continue}else if((i|0)==7){i=0;h=a[t]|0;do{if(((h&255)-1|0)>>>0<127>>>0){if((t&3|0)!=0){R=t;S=u;T=h;break}g=c[t>>2]|0;if(((g-16843009|g)&-2139062144|0)==0){U=u;V=t}else{R=t;S=u;T=g&255;break}do{V=V+4|0;U=U-4|0;W=c[V>>2]|0;}while(((W-16843009|W)&-2139062144|0)==0);R=V;S=U;T=W&255}else{R=t;S=u;T=h}}while(0);h=T&255;if((h-1|0)>>>0<127>>>0){t=R+1|0;u=S-1|0;i=7;continue}g=h-194|0;if(g>>>0>50>>>0){O=S;P=b;Q=R;i=47;break}l=c[p+(g<<2)>>2]|0;m=R+1|0;n=S;i=16;continue}else if((i|0)==36){i=0;g=d[q]|0;h=g>>>3;if((h-16|h+(o>>26))>>>0>7>>>0){i=37;break}h=q+1|0;X=g-128|o<<6;do{if((X|0)<0){g=(d[h]|0)-128|0;if(g>>>0>63>>>0){i=40;break L7}k=q+2|0;Y=g|X<<6;if((Y|0)>=0){Z=Y;_=k;break}g=(d[k]|0)-128|0;if(g>>>0>63>>>0){i=43;break L7}Z=g|Y<<6;_=q+3|0}else{Z=X;_=h}}while(0);c[r>>2]=Z;v=_;w=r+4|0;x=s-1|0;i=6;continue}else if((i|0)==16){i=0;h=(d[m]|0)>>>3;if((h-16|h+(l>>26))>>>0>7>>>0){i=17;break}h=m+1|0;do{if((l&33554432|0)==0){$=h}else{if(((d[h]|0)-128|0)>>>0>63>>>0){i=20;break L7}g=m+2|0;if((l&524288|0)==0){$=g;break}if(((d[g]|0)-128|0)>>>0>63>>>0){i=23;break L7}$=m+3|0}}while(0);t=$;u=n-1|0;i=7;continue}}if((i|0)==54){return y|0}else if((i|0)==40){aa=X;ab=q-1|0;ac=r;ad=s;i=46}else if((i|0)==37){aa=o;ab=q-1|0;ac=r;ad=s;i=46}else if((i|0)==43){aa=Y;ab=q-1|0;ac=r;ad=s;i=46}else if((i|0)==23){aa=l;ab=m-1|0;ac=b;ad=n;i=46}else if((i|0)==17){aa=l;ab=m-1|0;ac=b;ad=n;i=46}else if((i|0)==55){return y|0}else if((i|0)==20){aa=l;ab=m-1|0;ac=b;ad=n;i=46}if((i|0)==46){if((aa|0)==0){O=ad;P=ac;Q=ab;i=47}else{ae=ac;af=ab}}do{if((i|0)==47){if((a[Q]|0)!=0){ae=P;af=Q;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}y=f-O|0;return y|0}}while(0);c[(b$()|0)>>2]=84;if((ae|0)==0){y=-1;return y|0}c[e>>2]=af;y=-1;return y|0}function KS(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g|0;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m-194|0;if(k>>>0>50>>>0){break}m=e+1|0;n=c[p+(k<<2)>>2]|0;if(f>>>0<4>>>0){if((n&-2147483648>>>(((f*6|0)-6|0)>>>0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m-16|m+(n>>26))>>>0>7>>>0){break}m=k-128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)-128|0;if(n>>>0>63>>>0){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)-128|0;if(m>>>0>63>>>0){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(b$()|0)>>2]=84;j=-1;i=g;return j|0}function KT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((b|0)==0){f=1;return f|0}if(d>>>0<128>>>0){a[b]=d;f=1;return f|0}if(d>>>0<2048>>>0){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;return f|0}if(d>>>0<55296>>>0|(d-57344|0)>>>0<8192>>>0){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;return f|0}if((d-65536|0)>>>0<1048576>>>0){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;return f|0}else{c[(b$()|0)>>2]=84;f=-1;return f|0}return 0}function KU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+264|0;g=f|0;h=f+256|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:g|0;L1:do{if((j|0)==0|(l|0)==0){m=0;n=d;o=l;p=e;q=j}else{a=g|0;r=l;s=d;t=0;u=e;v=j;while(1){w=s>>>0>=r>>>0;if(!(w|s>>>0>32>>>0)){m=t;n=s;o=r;p=u;q=v;break L1}x=w?r:s;y=s-x|0;w=KV(u,h,x,0)|0;if((w|0)==-1){break}if((u|0)==(a|0)){z=a;A=r}else{z=u+w|0;A=r-w|0}x=w+t|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){m=x;n=y;o=A;p=z;q=w;break L1}else{r=A;s=y;t=x;u=z;v=w}}m=-1;n=y;o=0;p=u;q=c[h>>2]|0}}while(0);L12:do{if((q|0)==0){B=m}else{if((o|0)==0|(n|0)==0){B=m;break}else{C=o;D=n;E=m;F=p;G=q}while(1){H=KT(F,c[G>>2]|0,0)|0;if((H+1|0)>>>0<2>>>0){break}y=(c[h>>2]|0)+4|0;c[h>>2]=y;z=D-1|0;A=E+1|0;if((C|0)==(H|0)|(z|0)==0){B=A;break L12}else{C=C-H|0;D=z;E=A;F=F+H|0;G=y}}if((H|0)!=0){B=-1;break}c[h>>2]=0;B=E}}while(0);if(!k){i=f;return B|0}c[b>>2]=c[h>>2];i=f;return B|0}function KV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f|0;if((b|0)==0){h=c[d>>2]|0;j=g|0;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=h;o=k}while(1){if(o>>>0>127>>>0){k=KT(j,o,0)|0;if((k|0)==-1){l=-1;p=27;break}else{q=k}}else{q=1}k=q+m|0;h=n+4|0;r=c[h>>2]|0;if((r|0)==0){l=k;p=31;break}else{m=k;n=h;o=r}}if((p|0)==31){i=f;return l|0}else if((p|0)==27){i=f;return l|0}}L14:do{if(e>>>0>3>>>0){o=e;n=b;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break L14}if(q>>>0>127>>>0){j=KT(n,q,0)|0;if((j|0)==-1){l=-1;break}u=n+j|0;v=o-j|0;w=m}else{a[n]=q;u=n+1|0;v=o-1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3>>>0){o=v;n=u;m=q}else{s=v;t=u;break L14}}i=f;return l|0}else{s=e;t=b}}while(0);L26:do{if((s|0)==0){x=0}else{b=g|0;u=s;v=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127>>>0){n=KT(b,m,0)|0;if((n|0)==-1){l=-1;p=29;break}if(n>>>0>u>>>0){p=20;break}KT(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u-1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break L26}else{u=z;v=y;w=m}}if((p|0)==29){i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==20){l=e-u|0;i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function KW(a){a=a|0;var b=0;b=a;while(1){if((c[b>>2]|0)==0){break}else{b=b+4|0}}return b-a>>2|0}function KX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)==0){return a|0}else{e=b;f=d;g=a}while(1){d=f-1|0;c[g>>2]=c[e>>2];if((d|0)==0){break}else{e=e+4|0;f=d;g=g+4|0}}return a|0}function KY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(e){return a|0}else{f=d}do{f=f-1|0;c[a+(f<<2)>>2]=c[b+(f<<2)>>2];}while((f|0)!=0);return a|0}else{if(e){return a|0}else{g=b;h=d;i=a}while(1){d=h-1|0;c[i>>2]=c[g>>2];if((d|0)==0){break}else{g=g+4|0;h=d;i=i+4|0}}return a|0}return 0}function KZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;if((d|0)==0){return a|0}else{e=d;f=a}while(1){d=e-1|0;c[f>>2]=b;if((d|0)==0){break}else{e=d;f=f+4|0}}return a|0}function K_(a){a=a|0;return}function K$(a){a=a|0;c[a>>2]=13800;return}function K0(a){a=a|0;Lw(a);return}function K1(a){a=a|0;return}function K2(a){a=a|0;return 10792}function K3(a){a=a|0;K_(a|0);return}function K4(a){a=a|0;return}function K5(a){a=a|0;return}function K6(a){a=a|0;K_(a|0);Lw(a);return}function K7(a){a=a|0;K_(a|0);Lw(a);return}function K8(a){a=a|0;K_(a|0);Lw(a);return}function K9(a){a=a|0;K_(a|0);Lw(a);return}function La(a){a=a|0;K_(a|0);Lw(a);return}function Lb(a,b,c){a=a|0;b=b|0;c=c|0;return(a|0)==(b|0)|0}function Lc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+56|0;f=e|0;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=Lh(b,32504,32488,-1)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}LI(f|0,0,56)|0;c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;c2[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function Ld(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if((c[d+8>>2]|0)!=(b|0)){return}b=d+16|0;g=c[b>>2]|0;if((g|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((g|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}e=d+24|0;if((c[e>>2]|0)!=2){return}c[e>>2]=f;return}function Le(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if((b|0)!=(c[d+8>>2]|0)){g=c[b+8>>2]|0;c2[c[(c[g>>2]|0)+28>>2]&63](g,d,e,f);return}g=d+16|0;b=c[g>>2]|0;if((b|0)==0){c[g>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}e=d+24|0;if((c[e>>2]|0)!=2){return}c[e>>2]=f;return}function Lf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((b|0)==(c[d+8>>2]|0)){g=d+16|0;h=c[g>>2]|0;if((h|0)==0){c[g>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((h|0)!=(e|0)){h=d+36|0;c[h>>2]=(c[h>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}h=d+24|0;if((c[h>>2]|0)!=2){return}c[h>>2]=f;return}h=c[b+12>>2]|0;g=b+16+(h<<3)|0;i=c[b+20>>2]|0;j=i>>8;if((i&1|0)==0){k=j}else{k=c[(c[e>>2]|0)+j>>2]|0}j=c[b+16>>2]|0;c2[c[(c[j>>2]|0)+28>>2]&63](j,d,e+k|0,(i&2|0)!=0?f:2);if((h|0)<=1){return}h=d+54|0;i=e;k=b+24|0;while(1){b=c[k+4>>2]|0;j=b>>8;if((b&1|0)==0){l=j}else{l=c[(c[i>>2]|0)+j>>2]|0}j=c[k>>2]|0;c2[c[(c[j>>2]|0)+28>>2]&63](j,d,e+l|0,(b&2|0)!=0?f:2);if((a[h]&1)!=0){m=21;break}b=k+8|0;if(b>>>0<g>>>0){k=b}else{m=20;break}}if((m|0)==20){return}else if((m|0)==21){return}}function Lg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+56|0;f=e|0;c[d>>2]=c[c[d>>2]>>2];g=b|0;do{if((a|0)==(g|0)|(g|0)==32520){h=1}else{if((b|0)==0){h=0;break}j=Lh(b,32504,32456,-1)|0;if((j|0)==0){h=0;break}if((c[j+8>>2]&~c[a+8>>2]|0)!=0){h=0;break}k=c[a+12>>2]|0;l=j+12|0;if((k|0)==(c[l>>2]|0)|(k|0)==29296){h=1;break}if((k|0)==0){h=0;break}j=Lh(k,32504,32488,-1)|0;if((j|0)==0){h=0;break}k=c[l>>2]|0;if((k|0)==0){h=0;break}l=Lh(k,32504,32488,-1)|0;k=l;if((l|0)==0){h=0;break}LI(f|0,0,56)|0;c[f>>2]=k;c[f+8>>2]=j;c[f+12>>2]=-1;c[f+48>>2]=1;c2[c[(c[l>>2]|0)+28>>2]&63](k,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){h=0;break}c[d>>2]=c[f+16>>2];h=1}}while(0);i=e;return h|0}function Lh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+56|0;g=f|0;h=c[a>>2]|0;j=a+(c[h-8>>2]|0)|0;k=c[h-4>>2]|0;h=k;c[g>>2]=d;c[g+4>>2]=a;c[g+8>>2]=b;c[g+12>>2]=e;e=g+16|0;b=g+20|0;a=g+24|0;l=g+28|0;m=g+32|0;n=g+40|0;LI(e|0,0,39)|0;if((k|0)==(d|0)){c[g+48>>2]=1;cM[c[(c[k>>2]|0)+20>>2]&127](h,g,j,j,1,0);i=f;return((c[a>>2]|0)==1?j:0)|0}cz[c[(c[k>>2]|0)+24>>2]&63](h,g,j,1,0);j=c[g+36>>2]|0;if((j|0)==0){if((c[n>>2]|0)!=1){o=0;i=f;return o|0}if((c[l>>2]|0)!=1){o=0;i=f;return o|0}o=(c[m>>2]|0)==1?c[b>>2]|0:0;i=f;return o|0}else if((j|0)==1){do{if((c[a>>2]|0)!=1){if((c[n>>2]|0)!=0){o=0;i=f;return o|0}if((c[l>>2]|0)!=1){o=0;i=f;return o|0}if((c[m>>2]|0)==1){break}else{o=0}i=f;return o|0}}while(0);o=c[e>>2]|0;i=f;return o|0}else{o=0;i=f;return o|0}return 0}function Li(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=b|0;if((h|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){return}i=d+28|0;if((c[i>>2]|0)==1){return}c[i>>2]=f;return}if((h|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){h=d+20|0;if((c[h>>2]|0)==(e|0)){break}c[d+32>>2]=f;i=d+44|0;if((c[i>>2]|0)==4){return}j=c[b+12>>2]|0;k=b+16+(j<<3)|0;L19:do{if((j|0)>0){l=d+52|0;m=d+53|0;n=d+54|0;o=b+8|0;p=d+24|0;q=e;r=0;s=b+16|0;t=0;L21:while(1){a[l]=0;a[m]=0;u=c[s+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[q>>2]|0)+v>>2]|0}v=c[s>>2]|0;cM[c[(c[v>>2]|0)+20>>2]&127](v,d,e,e+w|0,2-(u>>>1&1)|0,g);if((a[n]&1)!=0){x=t;y=r;break}do{if((a[m]&1)==0){z=t;A=r}else{if((a[l]&1)==0){if((c[o>>2]&1|0)==0){x=1;y=r;break L21}else{z=1;A=r;break}}if((c[p>>2]|0)==1){B=27;break L19}if((c[o>>2]&2|0)==0){B=27;break L19}else{z=1;A=1}}}while(0);u=s+8|0;if(u>>>0<k>>>0){r=A;s=u;t=z}else{x=z;y=A;break}}if(y){C=x;B=26}else{D=x;B=23}}else{D=0;B=23}}while(0);do{if((B|0)==23){c[h>>2]=e;k=d+40|0;c[k>>2]=(c[k>>2]|0)+1;if((c[d+36>>2]|0)!=1){C=D;B=26;break}if((c[d+24>>2]|0)!=2){C=D;B=26;break}a[d+54|0]=1;if(D){B=27}else{B=28}}}while(0);if((B|0)==26){if(C){B=27}else{B=28}}if((B|0)==27){c[i>>2]=3;return}else if((B|0)==28){c[i>>2]=4;return}}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}C=c[b+12>>2]|0;D=b+16+(C<<3)|0;x=c[b+20>>2]|0;y=x>>8;if((x&1|0)==0){E=y}else{E=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;cz[c[(c[y>>2]|0)+24>>2]&63](y,d,e+E|0,(x&2|0)!=0?f:2,g);x=b+24|0;if((C|0)<=1){return}C=c[b+8>>2]|0;do{if((C&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((C&1|0)==0){E=d+54|0;y=e;A=x;while(1){if((a[E]&1)!=0){B=70;break}if((c[b>>2]|0)==1){B=65;break}z=c[A+4>>2]|0;w=z>>8;if((z&1|0)==0){F=w}else{F=c[(c[y>>2]|0)+w>>2]|0}w=c[A>>2]|0;cz[c[(c[w>>2]|0)+24>>2]&63](w,d,e+F|0,(z&2|0)!=0?f:2,g);z=A+8|0;if(z>>>0<D>>>0){A=z}else{B=57;break}}if((B|0)==57){return}else if((B|0)==65){return}else if((B|0)==70){return}}A=d+24|0;y=d+54|0;E=e;i=x;while(1){if((a[y]&1)!=0){B=58;break}if((c[b>>2]|0)==1){if((c[A>>2]|0)==1){B=60;break}}z=c[i+4>>2]|0;w=z>>8;if((z&1|0)==0){G=w}else{G=c[(c[E>>2]|0)+w>>2]|0}w=c[i>>2]|0;cz[c[(c[w>>2]|0)+24>>2]&63](w,d,e+G|0,(z&2|0)!=0?f:2,g);z=i+8|0;if(z>>>0<D>>>0){i=z}else{B=69;break}}if((B|0)==58){return}else if((B|0)==60){return}else if((B|0)==69){return}}}while(0);G=d+54|0;F=e;C=x;while(1){if((a[G]&1)!=0){B=64;break}x=c[C+4>>2]|0;i=x>>8;if((x&1|0)==0){H=i}else{H=c[(c[F>>2]|0)+i>>2]|0}i=c[C>>2]|0;cz[c[(c[i>>2]|0)+24>>2]&63](i,d,e+H|0,(x&2|0)!=0?f:2,g);x=C+8|0;if(x>>>0<D>>>0){C=x}else{B=67;break}}if((B|0)==64){return}else if((B|0)==67){return}}function Lj(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=b|0;if((h|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){return}i=d+28|0;if((c[i>>2]|0)==1){return}c[i>>2]=f;return}if((h|0)!=(c[d>>2]|0)){h=c[b+8>>2]|0;cz[c[(c[h>>2]|0)+24>>2]&63](h,d,e,f,g);return}do{if((c[d+16>>2]|0)!=(e|0)){h=d+20|0;if((c[h>>2]|0)==(e|0)){break}c[d+32>>2]=f;i=d+44|0;if((c[i>>2]|0)==4){return}j=d+52|0;a[j]=0;k=d+53|0;a[k]=0;l=c[b+8>>2]|0;cM[c[(c[l>>2]|0)+20>>2]&127](l,d,e,e,1,g);if((a[k]&1)==0){m=0;n=13}else{if((a[j]&1)==0){m=1;n=13}}L23:do{if((n|0)==13){c[h>>2]=e;j=d+40|0;c[j>>2]=(c[j>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){n=16;break}a[d+54|0]=1;if(m){break L23}}else{n=16}}while(0);if((n|0)==16){if(m){break}}c[i>>2]=4;return}}while(0);c[i>>2]=3;return}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}function Lk(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){return}g=d+28|0;if((c[g>>2]|0)==1){return}c[g>>2]=f;return}if((c[d>>2]|0)!=(b|0)){return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;return}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}function Ll(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((b|0)!=(c[d+8>>2]|0)){i=d+52|0;j=a[i]&1;k=d+53|0;l=a[k]&1;m=c[b+12>>2]|0;n=b+16+(m<<3)|0;a[i]=0;a[k]=0;o=c[b+20>>2]|0;p=o>>8;if((o&1|0)==0){q=p}else{q=c[(c[f>>2]|0)+p>>2]|0}p=c[b+16>>2]|0;cM[c[(c[p>>2]|0)+20>>2]&127](p,d,e,f+q|0,(o&2|0)!=0?g:2,h);L6:do{if((m|0)>1){o=d+24|0;q=b+8|0;p=d+54|0;r=f;s=b+24|0;do{if((a[p]&1)!=0){break L6}do{if((a[i]&1)==0){if((a[k]&1)==0){break}if((c[q>>2]&1|0)==0){break L6}}else{if((c[o>>2]|0)==1){break L6}if((c[q>>2]&2|0)==0){break L6}}}while(0);a[i]=0;a[k]=0;t=c[s+4>>2]|0;u=t>>8;if((t&1|0)==0){v=u}else{v=c[(c[r>>2]|0)+u>>2]|0}u=c[s>>2]|0;cM[c[(c[u>>2]|0)+20>>2]&127](u,d,e,f+v|0,(t&2|0)!=0?g:2,h);s=s+8|0;}while(s>>>0<n>>>0)}}while(0);a[i]=j;a[k]=l;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;l=c[f>>2]|0;if((l|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((l|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;l=c[e>>2]|0;if((l|0)==2){c[e>>2]=g;w=g}else{w=l}if(!((c[d+48>>2]|0)==1&(w|0)==1)){return}a[d+54|0]=1;return}function Lm(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;if((b|0)!=(c[d+8>>2]|0)){i=c[b+8>>2]|0;cM[c[(c[i>>2]|0)+20>>2]&127](i,d,e,f,g,h);return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;j=g}else{j=h}if(!((c[d+48>>2]|0)==1&(j|0)==1)){return}a[d+54|0]=1;return}function Ln(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;if((c[d+8>>2]|0)!=(b|0)){return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;i=g}else{i=b}if(!((c[d+48>>2]|0)==1&(i|0)==1)){return}a[d+54|0]=1;return}function Lo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0;do{if(a>>>0<245>>>0){if(a>>>0<11>>>0){b=16}else{b=a+11&-8}d=b>>>3;e=c[9584]|0;f=e>>>(d>>>0);if((f&3|0)!=0){g=(f&1^1)+d|0;h=g<<1;i=38376+(h<<2)|0;j=38376+(h+2<<2)|0;h=c[j>>2]|0;k=h+8|0;l=c[k>>2]|0;do{if((i|0)==(l|0)){c[9584]=e&~(1<<g)}else{if(l>>>0<(c[9588]|0)>>>0){cb();return 0}m=l+12|0;if((c[m>>2]|0)==(h|0)){c[m>>2]=i;c[j>>2]=l;break}else{cb();return 0}}}while(0);l=g<<3;c[h+4>>2]=l|3;j=h+(l|4)|0;c[j>>2]=c[j>>2]|1;n=k;return n|0}if(b>>>0<=(c[9586]|0)>>>0){o=b;break}if((f|0)!=0){j=2<<d;l=f<<d&(j|-j);j=(l&-l)-1|0;l=j>>>12&16;i=j>>>(l>>>0);j=i>>>5&8;m=i>>>(j>>>0);i=m>>>2&4;p=m>>>(i>>>0);m=p>>>1&2;q=p>>>(m>>>0);p=q>>>1&1;r=(j|l|i|m|p)+(q>>>(p>>>0))|0;p=r<<1;q=38376+(p<<2)|0;m=38376+(p+2<<2)|0;p=c[m>>2]|0;i=p+8|0;l=c[i>>2]|0;do{if((q|0)==(l|0)){c[9584]=e&~(1<<r)}else{if(l>>>0<(c[9588]|0)>>>0){cb();return 0}j=l+12|0;if((c[j>>2]|0)==(p|0)){c[j>>2]=q;c[m>>2]=l;break}else{cb();return 0}}}while(0);l=r<<3;m=l-b|0;c[p+4>>2]=b|3;q=p;e=q+b|0;c[q+(b|4)>>2]=m|1;c[q+l>>2]=m;l=c[9586]|0;if((l|0)!=0){q=c[9589]|0;d=l>>>3;l=d<<1;f=38376+(l<<2)|0;k=c[9584]|0;h=1<<d;do{if((k&h|0)==0){c[9584]=k|h;s=f;t=38376+(l+2<<2)|0}else{d=38376+(l+2<<2)|0;g=c[d>>2]|0;if(g>>>0>=(c[9588]|0)>>>0){s=g;t=d;break}cb();return 0}}while(0);c[t>>2]=q;c[s+12>>2]=q;c[q+8>>2]=s;c[q+12>>2]=f}c[9586]=m;c[9589]=e;n=i;return n|0}l=c[9585]|0;if((l|0)==0){o=b;break}h=(l&-l)-1|0;l=h>>>12&16;k=h>>>(l>>>0);h=k>>>5&8;p=k>>>(h>>>0);k=p>>>2&4;r=p>>>(k>>>0);p=r>>>1&2;d=r>>>(p>>>0);r=d>>>1&1;g=c[38640+((h|l|k|p|r)+(d>>>(r>>>0))<<2)>>2]|0;r=g;d=g;p=(c[g+4>>2]&-8)-b|0;while(1){g=c[r+16>>2]|0;if((g|0)==0){k=c[r+20>>2]|0;if((k|0)==0){break}else{u=k}}else{u=g}g=(c[u+4>>2]&-8)-b|0;k=g>>>0<p>>>0;r=u;d=k?u:d;p=k?g:p}r=d;i=c[9588]|0;if(r>>>0<i>>>0){cb();return 0}e=r+b|0;m=e;if(r>>>0>=e>>>0){cb();return 0}e=c[d+24>>2]|0;f=c[d+12>>2]|0;do{if((f|0)==(d|0)){q=d+20|0;g=c[q>>2]|0;if((g|0)==0){k=d+16|0;l=c[k>>2]|0;if((l|0)==0){v=0;break}else{w=l;x=k}}else{w=g;x=q}while(1){q=w+20|0;g=c[q>>2]|0;if((g|0)!=0){w=g;x=q;continue}q=w+16|0;g=c[q>>2]|0;if((g|0)==0){break}else{w=g;x=q}}if(x>>>0<i>>>0){cb();return 0}else{c[x>>2]=0;v=w;break}}else{q=c[d+8>>2]|0;if(q>>>0<i>>>0){cb();return 0}g=q+12|0;if((c[g>>2]|0)!=(d|0)){cb();return 0}k=f+8|0;if((c[k>>2]|0)==(d|0)){c[g>>2]=f;c[k>>2]=q;v=f;break}else{cb();return 0}}}while(0);L78:do{if((e|0)!=0){f=d+28|0;i=38640+(c[f>>2]<<2)|0;do{if((d|0)==(c[i>>2]|0)){c[i>>2]=v;if((v|0)!=0){break}c[9585]=c[9585]&~(1<<c[f>>2]);break L78}else{if(e>>>0<(c[9588]|0)>>>0){cb();return 0}q=e+16|0;if((c[q>>2]|0)==(d|0)){c[q>>2]=v}else{c[e+20>>2]=v}if((v|0)==0){break L78}}}while(0);if(v>>>0<(c[9588]|0)>>>0){cb();return 0}c[v+24>>2]=e;f=c[d+16>>2]|0;do{if((f|0)!=0){if(f>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[v+16>>2]=f;c[f+24>>2]=v;break}}}while(0);f=c[d+20>>2]|0;if((f|0)==0){break}if(f>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[v+20>>2]=f;c[f+24>>2]=v;break}}}while(0);if(p>>>0<16>>>0){e=p+b|0;c[d+4>>2]=e|3;f=r+(e+4)|0;c[f>>2]=c[f>>2]|1}else{c[d+4>>2]=b|3;c[r+(b|4)>>2]=p|1;c[r+(p+b)>>2]=p;f=c[9586]|0;if((f|0)!=0){e=c[9589]|0;i=f>>>3;f=i<<1;q=38376+(f<<2)|0;k=c[9584]|0;g=1<<i;do{if((k&g|0)==0){c[9584]=k|g;y=q;z=38376+(f+2<<2)|0}else{i=38376+(f+2<<2)|0;l=c[i>>2]|0;if(l>>>0>=(c[9588]|0)>>>0){y=l;z=i;break}cb();return 0}}while(0);c[z>>2]=e;c[y+12>>2]=e;c[e+8>>2]=y;c[e+12>>2]=q}c[9586]=p;c[9589]=m}f=d+8|0;if((f|0)==0){o=b;break}else{n=f}return n|0}else{if(a>>>0>4294967231>>>0){o=-1;break}f=a+11|0;g=f&-8;k=c[9585]|0;if((k|0)==0){o=g;break}r=-g|0;i=f>>>8;do{if((i|0)==0){A=0}else{if(g>>>0>16777215>>>0){A=31;break}f=(i+1048320|0)>>>16&8;l=i<<f;h=(l+520192|0)>>>16&4;j=l<<h;l=(j+245760|0)>>>16&2;B=14-(h|f|l)+(j<<l>>>15)|0;A=g>>>((B+7|0)>>>0)&1|B<<1}}while(0);i=c[38640+(A<<2)>>2]|0;L126:do{if((i|0)==0){C=0;D=r;E=0}else{if((A|0)==31){F=0}else{F=25-(A>>>1)|0}d=0;m=r;p=i;q=g<<F;e=0;while(1){B=c[p+4>>2]&-8;l=B-g|0;if(l>>>0<m>>>0){if((B|0)==(g|0)){C=p;D=l;E=p;break L126}else{G=p;H=l}}else{G=d;H=m}l=c[p+20>>2]|0;B=c[p+16+(q>>>31<<2)>>2]|0;j=(l|0)==0|(l|0)==(B|0)?e:l;if((B|0)==0){C=G;D=H;E=j;break}else{d=G;m=H;p=B;q=q<<1;e=j}}}}while(0);if((E|0)==0&(C|0)==0){i=2<<A;r=k&(i|-i);if((r|0)==0){o=g;break}i=(r&-r)-1|0;r=i>>>12&16;e=i>>>(r>>>0);i=e>>>5&8;q=e>>>(i>>>0);e=q>>>2&4;p=q>>>(e>>>0);q=p>>>1&2;m=p>>>(q>>>0);p=m>>>1&1;I=c[38640+((i|r|e|q|p)+(m>>>(p>>>0))<<2)>>2]|0}else{I=E}if((I|0)==0){J=D;K=C}else{p=I;m=D;q=C;while(1){e=(c[p+4>>2]&-8)-g|0;r=e>>>0<m>>>0;i=r?e:m;e=r?p:q;r=c[p+16>>2]|0;if((r|0)!=0){p=r;m=i;q=e;continue}r=c[p+20>>2]|0;if((r|0)==0){J=i;K=e;break}else{p=r;m=i;q=e}}}if((K|0)==0){o=g;break}if(J>>>0>=((c[9586]|0)-g|0)>>>0){o=g;break}q=K;m=c[9588]|0;if(q>>>0<m>>>0){cb();return 0}p=q+g|0;k=p;if(q>>>0>=p>>>0){cb();return 0}e=c[K+24>>2]|0;i=c[K+12>>2]|0;do{if((i|0)==(K|0)){r=K+20|0;d=c[r>>2]|0;if((d|0)==0){j=K+16|0;B=c[j>>2]|0;if((B|0)==0){L=0;break}else{M=B;N=j}}else{M=d;N=r}while(1){r=M+20|0;d=c[r>>2]|0;if((d|0)!=0){M=d;N=r;continue}r=M+16|0;d=c[r>>2]|0;if((d|0)==0){break}else{M=d;N=r}}if(N>>>0<m>>>0){cb();return 0}else{c[N>>2]=0;L=M;break}}else{r=c[K+8>>2]|0;if(r>>>0<m>>>0){cb();return 0}d=r+12|0;if((c[d>>2]|0)!=(K|0)){cb();return 0}j=i+8|0;if((c[j>>2]|0)==(K|0)){c[d>>2]=i;c[j>>2]=r;L=i;break}else{cb();return 0}}}while(0);L176:do{if((e|0)!=0){i=K+28|0;m=38640+(c[i>>2]<<2)|0;do{if((K|0)==(c[m>>2]|0)){c[m>>2]=L;if((L|0)!=0){break}c[9585]=c[9585]&~(1<<c[i>>2]);break L176}else{if(e>>>0<(c[9588]|0)>>>0){cb();return 0}r=e+16|0;if((c[r>>2]|0)==(K|0)){c[r>>2]=L}else{c[e+20>>2]=L}if((L|0)==0){break L176}}}while(0);if(L>>>0<(c[9588]|0)>>>0){cb();return 0}c[L+24>>2]=e;i=c[K+16>>2]|0;do{if((i|0)!=0){if(i>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[L+16>>2]=i;c[i+24>>2]=L;break}}}while(0);i=c[K+20>>2]|0;if((i|0)==0){break}if(i>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[L+20>>2]=i;c[i+24>>2]=L;break}}}while(0);do{if(J>>>0<16>>>0){e=J+g|0;c[K+4>>2]=e|3;i=q+(e+4)|0;c[i>>2]=c[i>>2]|1}else{c[K+4>>2]=g|3;c[q+(g|4)>>2]=J|1;c[q+(J+g)>>2]=J;i=J>>>3;if(J>>>0<256>>>0){e=i<<1;m=38376+(e<<2)|0;r=c[9584]|0;j=1<<i;do{if((r&j|0)==0){c[9584]=r|j;O=m;P=38376+(e+2<<2)|0}else{i=38376+(e+2<<2)|0;d=c[i>>2]|0;if(d>>>0>=(c[9588]|0)>>>0){O=d;P=i;break}cb();return 0}}while(0);c[P>>2]=k;c[O+12>>2]=k;c[q+(g+8)>>2]=O;c[q+(g+12)>>2]=m;break}e=p;j=J>>>8;do{if((j|0)==0){Q=0}else{if(J>>>0>16777215>>>0){Q=31;break}r=(j+1048320|0)>>>16&8;i=j<<r;d=(i+520192|0)>>>16&4;B=i<<d;i=(B+245760|0)>>>16&2;l=14-(d|r|i)+(B<<i>>>15)|0;Q=J>>>((l+7|0)>>>0)&1|l<<1}}while(0);j=38640+(Q<<2)|0;c[q+(g+28)>>2]=Q;c[q+(g+20)>>2]=0;c[q+(g+16)>>2]=0;m=c[9585]|0;l=1<<Q;if((m&l|0)==0){c[9585]=m|l;c[j>>2]=e;c[q+(g+24)>>2]=j;c[q+(g+12)>>2]=e;c[q+(g+8)>>2]=e;break}if((Q|0)==31){R=0}else{R=25-(Q>>>1)|0}l=J<<R;m=c[j>>2]|0;while(1){if((c[m+4>>2]&-8|0)==(J|0)){break}S=m+16+(l>>>31<<2)|0;j=c[S>>2]|0;if((j|0)==0){T=151;break}else{l=l<<1;m=j}}if((T|0)==151){if(S>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[S>>2]=e;c[q+(g+24)>>2]=m;c[q+(g+12)>>2]=e;c[q+(g+8)>>2]=e;break}}l=m+8|0;j=c[l>>2]|0;i=c[9588]|0;if(m>>>0<i>>>0){cb();return 0}if(j>>>0<i>>>0){cb();return 0}else{c[j+12>>2]=e;c[l>>2]=e;c[q+(g+8)>>2]=j;c[q+(g+12)>>2]=m;c[q+(g+24)>>2]=0;break}}}while(0);q=K+8|0;if((q|0)==0){o=g;break}else{n=q}return n|0}}while(0);K=c[9586]|0;if(o>>>0<=K>>>0){S=K-o|0;J=c[9589]|0;if(S>>>0>15>>>0){R=J;c[9589]=R+o;c[9586]=S;c[R+(o+4)>>2]=S|1;c[R+K>>2]=S;c[J+4>>2]=o|3}else{c[9586]=0;c[9589]=0;c[J+4>>2]=K|3;S=J+(K+4)|0;c[S>>2]=c[S>>2]|1}n=J+8|0;return n|0}J=c[9587]|0;if(o>>>0<J>>>0){S=J-o|0;c[9587]=S;J=c[9590]|0;K=J;c[9590]=K+o;c[K+(o+4)>>2]=S|1;c[J+4>>2]=o|3;n=J+8|0;return n|0}do{if((c[9564]|0)==0){J=b9(30)|0;if((J-1&J|0)==0){c[9566]=J;c[9565]=J;c[9567]=-1;c[9568]=-1;c[9569]=0;c[9695]=0;c[9564]=(cv(0)|0)&-16^1431655768;break}else{cb();return 0}}}while(0);J=o+48|0;S=c[9566]|0;K=o+47|0;R=S+K|0;Q=-S|0;S=R&Q;if(S>>>0<=o>>>0){n=0;return n|0}O=c[9694]|0;do{if((O|0)!=0){P=c[9692]|0;L=P+S|0;if(L>>>0<=P>>>0|L>>>0>O>>>0){n=0}else{break}return n|0}}while(0);L268:do{if((c[9695]&4|0)==0){O=c[9590]|0;L270:do{if((O|0)==0){T=181}else{L=O;P=38784;while(1){U=P|0;M=c[U>>2]|0;if(M>>>0<=L>>>0){V=P+4|0;if((M+(c[V>>2]|0)|0)>>>0>L>>>0){break}}M=c[P+8>>2]|0;if((M|0)==0){T=181;break L270}else{P=M}}if((P|0)==0){T=181;break}L=R-(c[9587]|0)&Q;if(L>>>0>=2147483647>>>0){W=0;break}m=b_(L|0)|0;e=(m|0)==((c[U>>2]|0)+(c[V>>2]|0)|0);X=e?m:-1;Y=e?L:0;Z=m;_=L;T=190}}while(0);do{if((T|0)==181){O=b_(0)|0;if((O|0)==-1){W=0;break}g=O;L=c[9565]|0;m=L-1|0;if((m&g|0)==0){$=S}else{$=S-g+(m+g&-L)|0}L=c[9692]|0;g=L+$|0;if(!($>>>0>o>>>0&$>>>0<2147483647>>>0)){W=0;break}m=c[9694]|0;if((m|0)!=0){if(g>>>0<=L>>>0|g>>>0>m>>>0){W=0;break}}m=b_($|0)|0;g=(m|0)==(O|0);X=g?O:-1;Y=g?$:0;Z=m;_=$;T=190}}while(0);L290:do{if((T|0)==190){m=-_|0;if((X|0)!=-1){aa=Y;ab=X;T=201;break L268}do{if((Z|0)!=-1&_>>>0<2147483647>>>0&_>>>0<J>>>0){g=c[9566]|0;O=K-_+g&-g;if(O>>>0>=2147483647>>>0){ac=_;break}if((b_(O|0)|0)==-1){b_(m|0)|0;W=Y;break L290}else{ac=O+_|0;break}}else{ac=_}}while(0);if((Z|0)==-1){W=Y}else{aa=ac;ab=Z;T=201;break L268}}}while(0);c[9695]=c[9695]|4;ad=W;T=198}else{ad=0;T=198}}while(0);do{if((T|0)==198){if(S>>>0>=2147483647>>>0){break}W=b_(S|0)|0;Z=b_(0)|0;if(!((Z|0)!=-1&(W|0)!=-1&W>>>0<Z>>>0)){break}ac=Z-W|0;Z=ac>>>0>(o+40|0)>>>0;Y=Z?W:-1;if((Y|0)!=-1){aa=Z?ac:ad;ab=Y;T=201}}}while(0);do{if((T|0)==201){ad=(c[9692]|0)+aa|0;c[9692]=ad;if(ad>>>0>(c[9693]|0)>>>0){c[9693]=ad}ad=c[9590]|0;L310:do{if((ad|0)==0){S=c[9588]|0;if((S|0)==0|ab>>>0<S>>>0){c[9588]=ab}c[9696]=ab;c[9697]=aa;c[9699]=0;c[9593]=c[9564];c[9592]=-1;S=0;do{Y=S<<1;ac=38376+(Y<<2)|0;c[38376+(Y+3<<2)>>2]=ac;c[38376+(Y+2<<2)>>2]=ac;S=S+1|0;}while(S>>>0<32>>>0);S=ab+8|0;if((S&7|0)==0){ae=0}else{ae=-S&7}S=aa-40-ae|0;c[9590]=ab+ae;c[9587]=S;c[ab+(ae+4)>>2]=S|1;c[ab+(aa-36)>>2]=40;c[9591]=c[9568]}else{S=38784;while(1){af=c[S>>2]|0;ag=S+4|0;ah=c[ag>>2]|0;if((ab|0)==(af+ah|0)){T=213;break}ac=c[S+8>>2]|0;if((ac|0)==0){break}else{S=ac}}do{if((T|0)==213){if((c[S+12>>2]&8|0)!=0){break}ac=ad;if(!(ac>>>0>=af>>>0&ac>>>0<ab>>>0)){break}c[ag>>2]=ah+aa;ac=c[9590]|0;Y=(c[9587]|0)+aa|0;Z=ac;W=ac+8|0;if((W&7|0)==0){ai=0}else{ai=-W&7}W=Y-ai|0;c[9590]=Z+ai;c[9587]=W;c[Z+(ai+4)>>2]=W|1;c[Z+(Y+4)>>2]=40;c[9591]=c[9568];break L310}}while(0);if(ab>>>0<(c[9588]|0)>>>0){c[9588]=ab}S=ab+aa|0;Y=38784;while(1){aj=Y|0;if((c[aj>>2]|0)==(S|0)){T=223;break}Z=c[Y+8>>2]|0;if((Z|0)==0){break}else{Y=Z}}do{if((T|0)==223){if((c[Y+12>>2]&8|0)!=0){break}c[aj>>2]=ab;S=Y+4|0;c[S>>2]=(c[S>>2]|0)+aa;S=ab+8|0;if((S&7|0)==0){ak=0}else{ak=-S&7}S=ab+(aa+8)|0;if((S&7|0)==0){al=0}else{al=-S&7}S=ab+(al+aa)|0;Z=S;W=ak+o|0;ac=ab+W|0;_=ac;K=S-(ab+ak)-o|0;c[ab+(ak+4)>>2]=o|3;do{if((Z|0)==(c[9590]|0)){J=(c[9587]|0)+K|0;c[9587]=J;c[9590]=_;c[ab+(W+4)>>2]=J|1}else{if((Z|0)==(c[9589]|0)){J=(c[9586]|0)+K|0;c[9586]=J;c[9589]=_;c[ab+(W+4)>>2]=J|1;c[ab+(J+W)>>2]=J;break}J=aa+4|0;X=c[ab+(J+al)>>2]|0;if((X&3|0)==1){$=X&-8;V=X>>>3;L355:do{if(X>>>0<256>>>0){U=c[ab+((al|8)+aa)>>2]|0;Q=c[ab+(aa+12+al)>>2]|0;R=38376+(V<<1<<2)|0;do{if((U|0)!=(R|0)){if(U>>>0<(c[9588]|0)>>>0){cb();return 0}if((c[U+12>>2]|0)==(Z|0)){break}cb();return 0}}while(0);if((Q|0)==(U|0)){c[9584]=c[9584]&~(1<<V);break}do{if((Q|0)==(R|0)){am=Q+8|0}else{if(Q>>>0<(c[9588]|0)>>>0){cb();return 0}m=Q+8|0;if((c[m>>2]|0)==(Z|0)){am=m;break}cb();return 0}}while(0);c[U+12>>2]=Q;c[am>>2]=U}else{R=S;m=c[ab+((al|24)+aa)>>2]|0;P=c[ab+(aa+12+al)>>2]|0;do{if((P|0)==(R|0)){O=al|16;g=ab+(J+O)|0;L=c[g>>2]|0;if((L|0)==0){e=ab+(O+aa)|0;O=c[e>>2]|0;if((O|0)==0){an=0;break}else{ao=O;ap=e}}else{ao=L;ap=g}while(1){g=ao+20|0;L=c[g>>2]|0;if((L|0)!=0){ao=L;ap=g;continue}g=ao+16|0;L=c[g>>2]|0;if((L|0)==0){break}else{ao=L;ap=g}}if(ap>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[ap>>2]=0;an=ao;break}}else{g=c[ab+((al|8)+aa)>>2]|0;if(g>>>0<(c[9588]|0)>>>0){cb();return 0}L=g+12|0;if((c[L>>2]|0)!=(R|0)){cb();return 0}e=P+8|0;if((c[e>>2]|0)==(R|0)){c[L>>2]=P;c[e>>2]=g;an=P;break}else{cb();return 0}}}while(0);if((m|0)==0){break}P=ab+(aa+28+al)|0;U=38640+(c[P>>2]<<2)|0;do{if((R|0)==(c[U>>2]|0)){c[U>>2]=an;if((an|0)!=0){break}c[9585]=c[9585]&~(1<<c[P>>2]);break L355}else{if(m>>>0<(c[9588]|0)>>>0){cb();return 0}Q=m+16|0;if((c[Q>>2]|0)==(R|0)){c[Q>>2]=an}else{c[m+20>>2]=an}if((an|0)==0){break L355}}}while(0);if(an>>>0<(c[9588]|0)>>>0){cb();return 0}c[an+24>>2]=m;R=al|16;P=c[ab+(R+aa)>>2]|0;do{if((P|0)!=0){if(P>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[an+16>>2]=P;c[P+24>>2]=an;break}}}while(0);P=c[ab+(J+R)>>2]|0;if((P|0)==0){break}if(P>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[an+20>>2]=P;c[P+24>>2]=an;break}}}while(0);aq=ab+(($|al)+aa)|0;ar=$+K|0}else{aq=Z;ar=K}J=aq+4|0;c[J>>2]=c[J>>2]&-2;c[ab+(W+4)>>2]=ar|1;c[ab+(ar+W)>>2]=ar;J=ar>>>3;if(ar>>>0<256>>>0){V=J<<1;X=38376+(V<<2)|0;P=c[9584]|0;m=1<<J;do{if((P&m|0)==0){c[9584]=P|m;as=X;at=38376+(V+2<<2)|0}else{J=38376+(V+2<<2)|0;U=c[J>>2]|0;if(U>>>0>=(c[9588]|0)>>>0){as=U;at=J;break}cb();return 0}}while(0);c[at>>2]=_;c[as+12>>2]=_;c[ab+(W+8)>>2]=as;c[ab+(W+12)>>2]=X;break}V=ac;m=ar>>>8;do{if((m|0)==0){au=0}else{if(ar>>>0>16777215>>>0){au=31;break}P=(m+1048320|0)>>>16&8;$=m<<P;J=($+520192|0)>>>16&4;U=$<<J;$=(U+245760|0)>>>16&2;Q=14-(J|P|$)+(U<<$>>>15)|0;au=ar>>>((Q+7|0)>>>0)&1|Q<<1}}while(0);m=38640+(au<<2)|0;c[ab+(W+28)>>2]=au;c[ab+(W+20)>>2]=0;c[ab+(W+16)>>2]=0;X=c[9585]|0;Q=1<<au;if((X&Q|0)==0){c[9585]=X|Q;c[m>>2]=V;c[ab+(W+24)>>2]=m;c[ab+(W+12)>>2]=V;c[ab+(W+8)>>2]=V;break}if((au|0)==31){av=0}else{av=25-(au>>>1)|0}Q=ar<<av;X=c[m>>2]|0;while(1){if((c[X+4>>2]&-8|0)==(ar|0)){break}aw=X+16+(Q>>>31<<2)|0;m=c[aw>>2]|0;if((m|0)==0){T=296;break}else{Q=Q<<1;X=m}}if((T|0)==296){if(aw>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[aw>>2]=V;c[ab+(W+24)>>2]=X;c[ab+(W+12)>>2]=V;c[ab+(W+8)>>2]=V;break}}Q=X+8|0;m=c[Q>>2]|0;$=c[9588]|0;if(X>>>0<$>>>0){cb();return 0}if(m>>>0<$>>>0){cb();return 0}else{c[m+12>>2]=V;c[Q>>2]=V;c[ab+(W+8)>>2]=m;c[ab+(W+12)>>2]=X;c[ab+(W+24)>>2]=0;break}}}while(0);n=ab+(ak|8)|0;return n|0}}while(0);Y=ad;W=38784;while(1){ax=c[W>>2]|0;if(ax>>>0<=Y>>>0){ay=c[W+4>>2]|0;az=ax+ay|0;if(az>>>0>Y>>>0){break}}W=c[W+8>>2]|0}W=ax+(ay-39)|0;if((W&7|0)==0){aA=0}else{aA=-W&7}W=ax+(ay-47+aA)|0;ac=W>>>0<(ad+16|0)>>>0?Y:W;W=ac+8|0;_=ab+8|0;if((_&7|0)==0){aB=0}else{aB=-_&7}_=aa-40-aB|0;c[9590]=ab+aB;c[9587]=_;c[ab+(aB+4)>>2]=_|1;c[ab+(aa-36)>>2]=40;c[9591]=c[9568];c[ac+4>>2]=27;c[W>>2]=c[9696];c[W+4>>2]=c[9697];c[W+8>>2]=c[9698];c[W+12>>2]=c[9699];c[9696]=ab;c[9697]=aa;c[9699]=0;c[9698]=W;W=ac+28|0;c[W>>2]=7;if((ac+32|0)>>>0<az>>>0){_=W;while(1){W=_+4|0;c[W>>2]=7;if((_+8|0)>>>0<az>>>0){_=W}else{break}}}if((ac|0)==(Y|0)){break}_=ac-ad|0;W=Y+(_+4)|0;c[W>>2]=c[W>>2]&-2;c[ad+4>>2]=_|1;c[Y+_>>2]=_;W=_>>>3;if(_>>>0<256>>>0){K=W<<1;Z=38376+(K<<2)|0;S=c[9584]|0;m=1<<W;do{if((S&m|0)==0){c[9584]=S|m;aC=Z;aD=38376+(K+2<<2)|0}else{W=38376+(K+2<<2)|0;Q=c[W>>2]|0;if(Q>>>0>=(c[9588]|0)>>>0){aC=Q;aD=W;break}cb();return 0}}while(0);c[aD>>2]=ad;c[aC+12>>2]=ad;c[ad+8>>2]=aC;c[ad+12>>2]=Z;break}K=ad;m=_>>>8;do{if((m|0)==0){aE=0}else{if(_>>>0>16777215>>>0){aE=31;break}S=(m+1048320|0)>>>16&8;Y=m<<S;ac=(Y+520192|0)>>>16&4;W=Y<<ac;Y=(W+245760|0)>>>16&2;Q=14-(ac|S|Y)+(W<<Y>>>15)|0;aE=_>>>((Q+7|0)>>>0)&1|Q<<1}}while(0);m=38640+(aE<<2)|0;c[ad+28>>2]=aE;c[ad+20>>2]=0;c[ad+16>>2]=0;Z=c[9585]|0;Q=1<<aE;if((Z&Q|0)==0){c[9585]=Z|Q;c[m>>2]=K;c[ad+24>>2]=m;c[ad+12>>2]=ad;c[ad+8>>2]=ad;break}if((aE|0)==31){aF=0}else{aF=25-(aE>>>1)|0}Q=_<<aF;Z=c[m>>2]|0;while(1){if((c[Z+4>>2]&-8|0)==(_|0)){break}aG=Z+16+(Q>>>31<<2)|0;m=c[aG>>2]|0;if((m|0)==0){T=331;break}else{Q=Q<<1;Z=m}}if((T|0)==331){if(aG>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[aG>>2]=K;c[ad+24>>2]=Z;c[ad+12>>2]=ad;c[ad+8>>2]=ad;break}}Q=Z+8|0;_=c[Q>>2]|0;m=c[9588]|0;if(Z>>>0<m>>>0){cb();return 0}if(_>>>0<m>>>0){cb();return 0}else{c[_+12>>2]=K;c[Q>>2]=K;c[ad+8>>2]=_;c[ad+12>>2]=Z;c[ad+24>>2]=0;break}}}while(0);ad=c[9587]|0;if(ad>>>0<=o>>>0){break}_=ad-o|0;c[9587]=_;ad=c[9590]|0;Q=ad;c[9590]=Q+o;c[Q+(o+4)>>2]=_|1;c[ad+4>>2]=o|3;n=ad+8|0;return n|0}}while(0);c[(b$()|0)>>2]=12;n=0;return n|0}function Lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;if((a|0)==0){return}b=a-8|0;d=b;e=c[9588]|0;if(b>>>0<e>>>0){cb()}f=c[a-4>>2]|0;g=f&3;if((g|0)==1){cb()}h=f&-8;i=a+(h-8)|0;j=i;L10:do{if((f&1|0)==0){k=c[b>>2]|0;if((g|0)==0){return}l=-8-k|0;m=a+l|0;n=m;o=k+h|0;if(m>>>0<e>>>0){cb()}if((n|0)==(c[9589]|0)){p=a+(h-4)|0;if((c[p>>2]&3|0)!=3){q=n;r=o;break}c[9586]=o;c[p>>2]=c[p>>2]&-2;c[a+(l+4)>>2]=o|1;c[i>>2]=o;return}p=k>>>3;if(k>>>0<256>>>0){k=c[a+(l+8)>>2]|0;s=c[a+(l+12)>>2]|0;t=38376+(p<<1<<2)|0;do{if((k|0)!=(t|0)){if(k>>>0<e>>>0){cb()}if((c[k+12>>2]|0)==(n|0)){break}cb()}}while(0);if((s|0)==(k|0)){c[9584]=c[9584]&~(1<<p);q=n;r=o;break}do{if((s|0)==(t|0)){u=s+8|0}else{if(s>>>0<e>>>0){cb()}v=s+8|0;if((c[v>>2]|0)==(n|0)){u=v;break}cb()}}while(0);c[k+12>>2]=s;c[u>>2]=k;q=n;r=o;break}t=m;p=c[a+(l+24)>>2]|0;v=c[a+(l+12)>>2]|0;do{if((v|0)==(t|0)){w=a+(l+20)|0;x=c[w>>2]|0;if((x|0)==0){y=a+(l+16)|0;z=c[y>>2]|0;if((z|0)==0){A=0;break}else{B=z;C=y}}else{B=x;C=w}while(1){w=B+20|0;x=c[w>>2]|0;if((x|0)!=0){B=x;C=w;continue}w=B+16|0;x=c[w>>2]|0;if((x|0)==0){break}else{B=x;C=w}}if(C>>>0<e>>>0){cb()}else{c[C>>2]=0;A=B;break}}else{w=c[a+(l+8)>>2]|0;if(w>>>0<e>>>0){cb()}x=w+12|0;if((c[x>>2]|0)!=(t|0)){cb()}y=v+8|0;if((c[y>>2]|0)==(t|0)){c[x>>2]=v;c[y>>2]=w;A=v;break}else{cb()}}}while(0);if((p|0)==0){q=n;r=o;break}v=a+(l+28)|0;m=38640+(c[v>>2]<<2)|0;do{if((t|0)==(c[m>>2]|0)){c[m>>2]=A;if((A|0)!=0){break}c[9585]=c[9585]&~(1<<c[v>>2]);q=n;r=o;break L10}else{if(p>>>0<(c[9588]|0)>>>0){cb()}k=p+16|0;if((c[k>>2]|0)==(t|0)){c[k>>2]=A}else{c[p+20>>2]=A}if((A|0)==0){q=n;r=o;break L10}}}while(0);if(A>>>0<(c[9588]|0)>>>0){cb()}c[A+24>>2]=p;t=c[a+(l+16)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[9588]|0)>>>0){cb()}else{c[A+16>>2]=t;c[t+24>>2]=A;break}}}while(0);t=c[a+(l+20)>>2]|0;if((t|0)==0){q=n;r=o;break}if(t>>>0<(c[9588]|0)>>>0){cb()}else{c[A+20>>2]=t;c[t+24>>2]=A;q=n;r=o;break}}else{q=d;r=h}}while(0);d=q;if(d>>>0>=i>>>0){cb()}A=a+(h-4)|0;e=c[A>>2]|0;if((e&1|0)==0){cb()}do{if((e&2|0)==0){if((j|0)==(c[9590]|0)){B=(c[9587]|0)+r|0;c[9587]=B;c[9590]=q;c[q+4>>2]=B|1;if((q|0)!=(c[9589]|0)){return}c[9589]=0;c[9586]=0;return}if((j|0)==(c[9589]|0)){B=(c[9586]|0)+r|0;c[9586]=B;c[9589]=q;c[q+4>>2]=B|1;c[d+B>>2]=B;return}B=(e&-8)+r|0;C=e>>>3;L113:do{if(e>>>0<256>>>0){u=c[a+h>>2]|0;g=c[a+(h|4)>>2]|0;b=38376+(C<<1<<2)|0;do{if((u|0)!=(b|0)){if(u>>>0<(c[9588]|0)>>>0){cb()}if((c[u+12>>2]|0)==(j|0)){break}cb()}}while(0);if((g|0)==(u|0)){c[9584]=c[9584]&~(1<<C);break}do{if((g|0)==(b|0)){D=g+8|0}else{if(g>>>0<(c[9588]|0)>>>0){cb()}f=g+8|0;if((c[f>>2]|0)==(j|0)){D=f;break}cb()}}while(0);c[u+12>>2]=g;c[D>>2]=u}else{b=i;f=c[a+(h+16)>>2]|0;t=c[a+(h|4)>>2]|0;do{if((t|0)==(b|0)){p=a+(h+12)|0;v=c[p>>2]|0;if((v|0)==0){m=a+(h+8)|0;k=c[m>>2]|0;if((k|0)==0){E=0;break}else{F=k;G=m}}else{F=v;G=p}while(1){p=F+20|0;v=c[p>>2]|0;if((v|0)!=0){F=v;G=p;continue}p=F+16|0;v=c[p>>2]|0;if((v|0)==0){break}else{F=v;G=p}}if(G>>>0<(c[9588]|0)>>>0){cb()}else{c[G>>2]=0;E=F;break}}else{p=c[a+h>>2]|0;if(p>>>0<(c[9588]|0)>>>0){cb()}v=p+12|0;if((c[v>>2]|0)!=(b|0)){cb()}m=t+8|0;if((c[m>>2]|0)==(b|0)){c[v>>2]=t;c[m>>2]=p;E=t;break}else{cb()}}}while(0);if((f|0)==0){break}t=a+(h+20)|0;u=38640+(c[t>>2]<<2)|0;do{if((b|0)==(c[u>>2]|0)){c[u>>2]=E;if((E|0)!=0){break}c[9585]=c[9585]&~(1<<c[t>>2]);break L113}else{if(f>>>0<(c[9588]|0)>>>0){cb()}g=f+16|0;if((c[g>>2]|0)==(b|0)){c[g>>2]=E}else{c[f+20>>2]=E}if((E|0)==0){break L113}}}while(0);if(E>>>0<(c[9588]|0)>>>0){cb()}c[E+24>>2]=f;b=c[a+(h+8)>>2]|0;do{if((b|0)!=0){if(b>>>0<(c[9588]|0)>>>0){cb()}else{c[E+16>>2]=b;c[b+24>>2]=E;break}}}while(0);b=c[a+(h+12)>>2]|0;if((b|0)==0){break}if(b>>>0<(c[9588]|0)>>>0){cb()}else{c[E+20>>2]=b;c[b+24>>2]=E;break}}}while(0);c[q+4>>2]=B|1;c[d+B>>2]=B;if((q|0)!=(c[9589]|0)){H=B;break}c[9586]=B;return}else{c[A>>2]=e&-2;c[q+4>>2]=r|1;c[d+r>>2]=r;H=r}}while(0);r=H>>>3;if(H>>>0<256>>>0){d=r<<1;e=38376+(d<<2)|0;A=c[9584]|0;E=1<<r;do{if((A&E|0)==0){c[9584]=A|E;I=e;J=38376+(d+2<<2)|0}else{r=38376+(d+2<<2)|0;h=c[r>>2]|0;if(h>>>0>=(c[9588]|0)>>>0){I=h;J=r;break}cb()}}while(0);c[J>>2]=q;c[I+12>>2]=q;c[q+8>>2]=I;c[q+12>>2]=e;return}e=q;I=H>>>8;do{if((I|0)==0){K=0}else{if(H>>>0>16777215>>>0){K=31;break}J=(I+1048320|0)>>>16&8;d=I<<J;E=(d+520192|0)>>>16&4;A=d<<E;d=(A+245760|0)>>>16&2;r=14-(E|J|d)+(A<<d>>>15)|0;K=H>>>((r+7|0)>>>0)&1|r<<1}}while(0);I=38640+(K<<2)|0;c[q+28>>2]=K;c[q+20>>2]=0;c[q+16>>2]=0;r=c[9585]|0;d=1<<K;do{if((r&d|0)==0){c[9585]=r|d;c[I>>2]=e;c[q+24>>2]=I;c[q+12>>2]=q;c[q+8>>2]=q}else{if((K|0)==31){L=0}else{L=25-(K>>>1)|0}A=H<<L;J=c[I>>2]|0;while(1){if((c[J+4>>2]&-8|0)==(H|0)){break}M=J+16+(A>>>31<<2)|0;E=c[M>>2]|0;if((E|0)==0){N=129;break}else{A=A<<1;J=E}}if((N|0)==129){if(M>>>0<(c[9588]|0)>>>0){cb()}else{c[M>>2]=e;c[q+24>>2]=J;c[q+12>>2]=q;c[q+8>>2]=q;break}}A=J+8|0;B=c[A>>2]|0;E=c[9588]|0;if(J>>>0<E>>>0){cb()}if(B>>>0<E>>>0){cb()}else{c[B+12>>2]=e;c[A>>2]=e;c[q+8>>2]=B;c[q+12>>2]=J;c[q+24>>2]=0;break}}}while(0);q=(c[9592]|0)-1|0;c[9592]=q;if((q|0)==0){O=38792}else{return}while(1){q=c[O>>2]|0;if((q|0)==0){break}else{O=q+8|0}}c[9592]=-1;return}function Lq(a,b){a=a|0;b=b|0;var d=0,e=0;do{if((a|0)==0){d=0}else{e=ai(b,a)|0;if((b|a)>>>0<=65535>>>0){d=e;break}d=((e>>>0)/(a>>>0)|0|0)==(b|0)?e:-1}}while(0);b=Lo(d)|0;if((b|0)==0){return b|0}if((c[b-4>>2]&3|0)==0){return b|0}LI(b|0,0,d|0)|0;return b|0}function Lr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;if((a|0)==0){d=Lo(b)|0;return d|0}if(b>>>0>4294967231>>>0){c[(b$()|0)>>2]=12;d=0;return d|0}if(b>>>0<11>>>0){e=16}else{e=b+11&-8}f=Ls(a-8|0,e)|0;if((f|0)!=0){d=f+8|0;return d|0}f=Lo(b)|0;if((f|0)==0){d=0;return d|0}e=c[a-4>>2]|0;g=(e&-8)-((e&3|0)==0?8:4)|0;LF(f|0,a|0,g>>>0<b>>>0?g:b)|0;Lp(a);d=f;return d|0}function Ls(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+4|0;e=c[d>>2]|0;f=e&-8;g=a;h=g+f|0;i=h;j=c[9588]|0;if(g>>>0<j>>>0){cb();return 0}k=e&3;if(!((k|0)!=1&g>>>0<h>>>0)){cb();return 0}l=g+(f|4)|0;m=c[l>>2]|0;if((m&1|0)==0){cb();return 0}if((k|0)==0){if(b>>>0<256>>>0){n=0;return n|0}do{if(f>>>0>=(b+4|0)>>>0){if((f-b|0)>>>0>c[9566]<<1>>>0){break}else{n=a}return n|0}}while(0);n=0;return n|0}if(f>>>0>=b>>>0){k=f-b|0;if(k>>>0<=15>>>0){n=a;return n|0}c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=k|3;c[l>>2]=c[l>>2]|1;Lt(g+b|0,k);n=a;return n|0}if((i|0)==(c[9590]|0)){k=(c[9587]|0)+f|0;if(k>>>0<=b>>>0){n=0;return n|0}l=k-b|0;c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=l|1;c[9590]=g+b;c[9587]=l;n=a;return n|0}if((i|0)==(c[9589]|0)){l=(c[9586]|0)+f|0;if(l>>>0<b>>>0){n=0;return n|0}k=l-b|0;if(k>>>0>15>>>0){c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=k|1;c[g+l>>2]=k;o=g+(l+4)|0;c[o>>2]=c[o>>2]&-2;p=g+b|0;q=k}else{c[d>>2]=e&1|l|2;e=g+(l+4)|0;c[e>>2]=c[e>>2]|1;p=0;q=0}c[9586]=q;c[9589]=p;n=a;return n|0}if((m&2|0)!=0){n=0;return n|0}p=(m&-8)+f|0;if(p>>>0<b>>>0){n=0;return n|0}q=p-b|0;e=m>>>3;L52:do{if(m>>>0<256>>>0){l=c[g+(f+8)>>2]|0;k=c[g+(f+12)>>2]|0;o=38376+(e<<1<<2)|0;do{if((l|0)!=(o|0)){if(l>>>0<j>>>0){cb();return 0}if((c[l+12>>2]|0)==(i|0)){break}cb();return 0}}while(0);if((k|0)==(l|0)){c[9584]=c[9584]&~(1<<e);break}do{if((k|0)==(o|0)){r=k+8|0}else{if(k>>>0<j>>>0){cb();return 0}s=k+8|0;if((c[s>>2]|0)==(i|0)){r=s;break}cb();return 0}}while(0);c[l+12>>2]=k;c[r>>2]=l}else{o=h;s=c[g+(f+24)>>2]|0;t=c[g+(f+12)>>2]|0;do{if((t|0)==(o|0)){u=g+(f+20)|0;v=c[u>>2]|0;if((v|0)==0){w=g+(f+16)|0;x=c[w>>2]|0;if((x|0)==0){y=0;break}else{z=x;A=w}}else{z=v;A=u}while(1){u=z+20|0;v=c[u>>2]|0;if((v|0)!=0){z=v;A=u;continue}u=z+16|0;v=c[u>>2]|0;if((v|0)==0){break}else{z=v;A=u}}if(A>>>0<j>>>0){cb();return 0}else{c[A>>2]=0;y=z;break}}else{u=c[g+(f+8)>>2]|0;if(u>>>0<j>>>0){cb();return 0}v=u+12|0;if((c[v>>2]|0)!=(o|0)){cb();return 0}w=t+8|0;if((c[w>>2]|0)==(o|0)){c[v>>2]=t;c[w>>2]=u;y=t;break}else{cb();return 0}}}while(0);if((s|0)==0){break}t=g+(f+28)|0;l=38640+(c[t>>2]<<2)|0;do{if((o|0)==(c[l>>2]|0)){c[l>>2]=y;if((y|0)!=0){break}c[9585]=c[9585]&~(1<<c[t>>2]);break L52}else{if(s>>>0<(c[9588]|0)>>>0){cb();return 0}k=s+16|0;if((c[k>>2]|0)==(o|0)){c[k>>2]=y}else{c[s+20>>2]=y}if((y|0)==0){break L52}}}while(0);if(y>>>0<(c[9588]|0)>>>0){cb();return 0}c[y+24>>2]=s;o=c[g+(f+16)>>2]|0;do{if((o|0)!=0){if(o>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[y+16>>2]=o;c[o+24>>2]=y;break}}}while(0);o=c[g+(f+20)>>2]|0;if((o|0)==0){break}if(o>>>0<(c[9588]|0)>>>0){cb();return 0}else{c[y+20>>2]=o;c[o+24>>2]=y;break}}}while(0);if(q>>>0<16>>>0){c[d>>2]=p|c[d>>2]&1|2;y=g+(p|4)|0;c[y>>2]=c[y>>2]|1;n=a;return n|0}else{c[d>>2]=c[d>>2]&1|b|2;c[g+(b+4)>>2]=q|3;d=g+(p|4)|0;c[d>>2]=c[d>>2]|1;Lt(g+b|0,q);n=a;return n|0}return 0}function Lt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=a;e=d+b|0;f=e;g=c[a+4>>2]|0;L1:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){return}i=d+(-h|0)|0;j=i;k=h+b|0;l=c[9588]|0;if(i>>>0<l>>>0){cb()}if((j|0)==(c[9589]|0)){m=d+(b+4)|0;if((c[m>>2]&3|0)!=3){n=j;o=k;break}c[9586]=k;c[m>>2]=c[m>>2]&-2;c[d+(4-h)>>2]=k|1;c[e>>2]=k;return}m=h>>>3;if(h>>>0<256>>>0){p=c[d+(8-h)>>2]|0;q=c[d+(12-h)>>2]|0;r=38376+(m<<1<<2)|0;do{if((p|0)!=(r|0)){if(p>>>0<l>>>0){cb()}if((c[p+12>>2]|0)==(j|0)){break}cb()}}while(0);if((q|0)==(p|0)){c[9584]=c[9584]&~(1<<m);n=j;o=k;break}do{if((q|0)==(r|0)){s=q+8|0}else{if(q>>>0<l>>>0){cb()}t=q+8|0;if((c[t>>2]|0)==(j|0)){s=t;break}cb()}}while(0);c[p+12>>2]=q;c[s>>2]=p;n=j;o=k;break}r=i;m=c[d+(24-h)>>2]|0;t=c[d+(12-h)>>2]|0;do{if((t|0)==(r|0)){u=16-h|0;v=d+(u+4)|0;w=c[v>>2]|0;if((w|0)==0){x=d+u|0;u=c[x>>2]|0;if((u|0)==0){y=0;break}else{z=u;A=x}}else{z=w;A=v}while(1){v=z+20|0;w=c[v>>2]|0;if((w|0)!=0){z=w;A=v;continue}v=z+16|0;w=c[v>>2]|0;if((w|0)==0){break}else{z=w;A=v}}if(A>>>0<l>>>0){cb()}else{c[A>>2]=0;y=z;break}}else{v=c[d+(8-h)>>2]|0;if(v>>>0<l>>>0){cb()}w=v+12|0;if((c[w>>2]|0)!=(r|0)){cb()}x=t+8|0;if((c[x>>2]|0)==(r|0)){c[w>>2]=t;c[x>>2]=v;y=t;break}else{cb()}}}while(0);if((m|0)==0){n=j;o=k;break}t=d+(28-h)|0;l=38640+(c[t>>2]<<2)|0;do{if((r|0)==(c[l>>2]|0)){c[l>>2]=y;if((y|0)!=0){break}c[9585]=c[9585]&~(1<<c[t>>2]);n=j;o=k;break L1}else{if(m>>>0<(c[9588]|0)>>>0){cb()}i=m+16|0;if((c[i>>2]|0)==(r|0)){c[i>>2]=y}else{c[m+20>>2]=y}if((y|0)==0){n=j;o=k;break L1}}}while(0);if(y>>>0<(c[9588]|0)>>>0){cb()}c[y+24>>2]=m;r=16-h|0;t=c[d+r>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[9588]|0)>>>0){cb()}else{c[y+16>>2]=t;c[t+24>>2]=y;break}}}while(0);t=c[d+(r+4)>>2]|0;if((t|0)==0){n=j;o=k;break}if(t>>>0<(c[9588]|0)>>>0){cb()}else{c[y+20>>2]=t;c[t+24>>2]=y;n=j;o=k;break}}else{n=a;o=b}}while(0);a=c[9588]|0;if(e>>>0<a>>>0){cb()}y=d+(b+4)|0;z=c[y>>2]|0;do{if((z&2|0)==0){if((f|0)==(c[9590]|0)){A=(c[9587]|0)+o|0;c[9587]=A;c[9590]=n;c[n+4>>2]=A|1;if((n|0)!=(c[9589]|0)){return}c[9589]=0;c[9586]=0;return}if((f|0)==(c[9589]|0)){A=(c[9586]|0)+o|0;c[9586]=A;c[9589]=n;c[n+4>>2]=A|1;c[n+A>>2]=A;return}A=(z&-8)+o|0;s=z>>>3;L100:do{if(z>>>0<256>>>0){g=c[d+(b+8)>>2]|0;t=c[d+(b+12)>>2]|0;h=38376+(s<<1<<2)|0;do{if((g|0)!=(h|0)){if(g>>>0<a>>>0){cb()}if((c[g+12>>2]|0)==(f|0)){break}cb()}}while(0);if((t|0)==(g|0)){c[9584]=c[9584]&~(1<<s);break}do{if((t|0)==(h|0)){B=t+8|0}else{if(t>>>0<a>>>0){cb()}m=t+8|0;if((c[m>>2]|0)==(f|0)){B=m;break}cb()}}while(0);c[g+12>>2]=t;c[B>>2]=g}else{h=e;m=c[d+(b+24)>>2]|0;l=c[d+(b+12)>>2]|0;do{if((l|0)==(h|0)){i=d+(b+20)|0;p=c[i>>2]|0;if((p|0)==0){q=d+(b+16)|0;v=c[q>>2]|0;if((v|0)==0){C=0;break}else{D=v;E=q}}else{D=p;E=i}while(1){i=D+20|0;p=c[i>>2]|0;if((p|0)!=0){D=p;E=i;continue}i=D+16|0;p=c[i>>2]|0;if((p|0)==0){break}else{D=p;E=i}}if(E>>>0<a>>>0){cb()}else{c[E>>2]=0;C=D;break}}else{i=c[d+(b+8)>>2]|0;if(i>>>0<a>>>0){cb()}p=i+12|0;if((c[p>>2]|0)!=(h|0)){cb()}q=l+8|0;if((c[q>>2]|0)==(h|0)){c[p>>2]=l;c[q>>2]=i;C=l;break}else{cb()}}}while(0);if((m|0)==0){break}l=d+(b+28)|0;g=38640+(c[l>>2]<<2)|0;do{if((h|0)==(c[g>>2]|0)){c[g>>2]=C;if((C|0)!=0){break}c[9585]=c[9585]&~(1<<c[l>>2]);break L100}else{if(m>>>0<(c[9588]|0)>>>0){cb()}t=m+16|0;if((c[t>>2]|0)==(h|0)){c[t>>2]=C}else{c[m+20>>2]=C}if((C|0)==0){break L100}}}while(0);if(C>>>0<(c[9588]|0)>>>0){cb()}c[C+24>>2]=m;h=c[d+(b+16)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[9588]|0)>>>0){cb()}else{c[C+16>>2]=h;c[h+24>>2]=C;break}}}while(0);h=c[d+(b+20)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[9588]|0)>>>0){cb()}else{c[C+20>>2]=h;c[h+24>>2]=C;break}}}while(0);c[n+4>>2]=A|1;c[n+A>>2]=A;if((n|0)!=(c[9589]|0)){F=A;break}c[9586]=A;return}else{c[y>>2]=z&-2;c[n+4>>2]=o|1;c[n+o>>2]=o;F=o}}while(0);o=F>>>3;if(F>>>0<256>>>0){z=o<<1;y=38376+(z<<2)|0;C=c[9584]|0;b=1<<o;do{if((C&b|0)==0){c[9584]=C|b;G=y;H=38376+(z+2<<2)|0}else{o=38376+(z+2<<2)|0;d=c[o>>2]|0;if(d>>>0>=(c[9588]|0)>>>0){G=d;H=o;break}cb()}}while(0);c[H>>2]=n;c[G+12>>2]=n;c[n+8>>2]=G;c[n+12>>2]=y;return}y=n;G=F>>>8;do{if((G|0)==0){I=0}else{if(F>>>0>16777215>>>0){I=31;break}H=(G+1048320|0)>>>16&8;z=G<<H;b=(z+520192|0)>>>16&4;C=z<<b;z=(C+245760|0)>>>16&2;o=14-(b|H|z)+(C<<z>>>15)|0;I=F>>>((o+7|0)>>>0)&1|o<<1}}while(0);G=38640+(I<<2)|0;c[n+28>>2]=I;c[n+20>>2]=0;c[n+16>>2]=0;o=c[9585]|0;z=1<<I;if((o&z|0)==0){c[9585]=o|z;c[G>>2]=y;c[n+24>>2]=G;c[n+12>>2]=n;c[n+8>>2]=n;return}if((I|0)==31){J=0}else{J=25-(I>>>1)|0}I=F<<J;J=c[G>>2]|0;while(1){if((c[J+4>>2]&-8|0)==(F|0)){break}K=J+16+(I>>>31<<2)|0;G=c[K>>2]|0;if((G|0)==0){L=126;break}else{I=I<<1;J=G}}if((L|0)==126){if(K>>>0<(c[9588]|0)>>>0){cb()}c[K>>2]=y;c[n+24>>2]=J;c[n+12>>2]=n;c[n+8>>2]=n;return}K=J+8|0;L=c[K>>2]|0;I=c[9588]|0;if(J>>>0<I>>>0){cb()}if(L>>>0<I>>>0){cb()}c[L+12>>2]=y;c[K>>2]=y;c[n+8>>2]=L;c[n+12>>2]=J;c[n+24>>2]=0;return}function Lu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=(a|0)==0?1:a;while(1){d=Lo(b)|0;if((d|0)!=0){e=10;break}a=(K=c[10562]|0,c[10562]=K+0,K);if((a|0)==0){e=9;break}z=0;aS(a|0);if(z){z=0;e=5;break}}do{if((e|0)==9){b=cl(4)|0;c[b>>2]=13768;z=0;aR(156,b|0,29320,472);if(!z){return 0}else{z=0;b=bT(-1,-1)|0;f=M;g=b;break}}else if((e|0)==10){return d|0}else if((e|0)==5){b=bT(-1,-1)|0;f=M;g=b}}while(0);if((f|0)<0){bH(g|0);return 0}else{bg(g|0)}return 0}function Lv(a){a=a|0;var b=0;b=(z=0,au(248,a|0)|0);if(!z){return b|0}else{z=0}b=bT(-1,-1)|0;if((M|0)<0){bH(b|0);return 0}else{bg(b|0)}return 0}function Lw(a){a=a|0;if((a|0)==0){return}Lp(a);return}function Lx(a){a=a|0;Lw(a);return}function Ly(a){a=a|0;Lw(a);return}function Lz(a){a=a|0;return}function LA(a){a=a|0;return 7648}function LB(){var a=0;a=cl(4)|0;c[a>>2]=13768;bK(a|0,29320,472)}function LC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0;e=b;while(1){f=e+1|0;if((a6(a[e]|0)|0)==0){break}else{e=f}}g=a[e]|0;if((g<<24>>24|0)==43){i=f;j=0}else if((g<<24>>24|0)==45){i=f;j=1}else{i=e;j=0}e=-1;f=0;g=i;while(1){k=a[g]|0;if(((k<<24>>24)-48|0)>>>0<10>>>0){l=e}else{if(k<<24>>24!=46|(e|0)>-1){break}else{l=f}}e=l;f=f+1|0;g=g+1|0}l=g+(-f|0)|0;i=(e|0)<0;m=((i^1)<<31>>31)+f|0;n=(m|0)>18;o=(n?-18:-m|0)+(i?f:e)|0;e=n?18:m;do{if((e|0)==0){p=b;q=0.0}else{if((e|0)>9){m=l;n=e;f=0;while(1){i=a[m]|0;r=m+1|0;if(i<<24>>24==46){s=a[r]|0;t=m+2|0}else{s=i;t=r}u=(f*10|0)-48+(s<<24>>24)|0;r=n-1|0;if((r|0)>9){m=t;n=r;f=u}else{break}}v=+(u|0)*1.0e9;w=9;x=t;y=14}else{if((e|0)>0){v=0.0;w=e;x=l;y=14}else{z=0.0;A=0.0}}if((y|0)==14){f=x;n=w;m=0;while(1){r=a[f]|0;i=f+1|0;if(r<<24>>24==46){B=a[i]|0;C=f+2|0}else{B=r;C=i}D=(m*10|0)-48+(B<<24>>24)|0;i=n-1|0;if((i|0)>0){f=C;n=i;m=D}else{break}}z=+(D|0);A=v}E=A+z;do{if((k<<24>>24|0)==69|(k<<24>>24|0)==101){m=g+1|0;n=a[m]|0;if((n<<24>>24|0)==43){F=g+2|0;G=0}else if((n<<24>>24|0)==45){F=g+2|0;G=1}else{F=m;G=0}m=a[F]|0;if(((m<<24>>24)-48|0)>>>0<10>>>0){H=F;I=0;J=m}else{K=0;L=F;M=G;break}while(1){m=(I*10|0)-48+(J<<24>>24)|0;n=H+1|0;f=a[n]|0;if(((f<<24>>24)-48|0)>>>0<10>>>0){H=n;I=m;J=f}else{K=m;L=n;M=G;break}}}else{K=0;L=g;M=0}}while(0);n=o+((M|0)==0?K:-K|0)|0;m=(n|0)<0?-n|0:n;if((m|0)>511){c[(b$()|0)>>2]=34;N=1.0;O=8;P=511;y=31}else{if((m|0)==0){Q=1.0}else{N=1.0;O=8;P=m;y=31}}if((y|0)==31){while(1){y=0;if((P&1|0)==0){R=N}else{R=N*+h[O>>3]}m=P>>1;if((m|0)==0){Q=R;break}else{N=R;O=O+8|0;P=m;y=31}}}if((n|0)>-1){p=L;q=E*Q;break}else{p=L;q=E/Q;break}}}while(0);if((d|0)!=0){c[d>>2]=p}if((j|0)==0){S=q;return+S}S=-0.0-q;return+S}function LD(a,b,c){a=a|0;b=b|0;c=c|0;return+(+LC(a,b))}function LE(a){a=a|0;return+(+LC(a,0))}function LF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function LG(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{LF(b,c,d)|0}return b|0}function LH(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0;while((e|0)<(c|0)){f=d[a+e|0]|0;g=d[b+e|0]|0;if((f|0)!=(g|0))return((f|0)>(g|0)?1:-1)|0;e=e+1|0}return 0}function LI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function LJ(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function LK(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function LL(a){a=a|0;if((a|0)<65)return a|0;if((a|0)>90)return a|0;return a-65+97|0}function LM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(M=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function LN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(M=e,a-c>>>0|0)|0}function LO(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){M=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}M=a<<c-32;return 0}function LP(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){M=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}M=0;return b>>>c-32|0}function LQ(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){M=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}M=(b|0)<0?-1:0;return b>>c-32|0}function LR(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function LS(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function LT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=ai(d,c)|0;f=a>>>16;a=(e>>>16)+(ai(d,f)|0)|0;d=b>>>16;b=ai(d,c)|0;return(M=(a>>>16)+(ai(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function LU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=LN(e^a,f^b,e,f)|0;b=M;a=g^e;e=h^f;f=LN((LZ(i,b,LN(g^c,h^d,g,h)|0,M,0)|0)^a,M^e,a,e)|0;return(M=M,f)|0}function LV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=LN(h^a,j^b,h,j)|0;b=M;LZ(m,b,LN(k^d,l^e,k,l)|0,M,g)|0;l=LN(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=M;i=f;return(M=j,l)|0}function LW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=LT(e,a)|0;f=M;return(M=(ai(b,a)|0)+(ai(d,e)|0)+f|f&0,c|0|0)|0}function LX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=LZ(a,b,c,d,0)|0;return(M=M,e)|0}function LY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;LZ(a,b,d,e,g)|0;i=f;return(M=c[g+4>>2]|0,c[g>>2]|0)|0}function LZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(M=n,o)|0}else{if(!m){n=0;o=0;return(M=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(M=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(M=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(M=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((LS(l|0)|0)>>>0);return(M=n,o)|0}p=(LR(l|0)|0)-(LR(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(M=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(M=n,o)|0}else{if(!m){r=(LR(l|0)|0)-(LR(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(M=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(M=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(LR(j|0)|0)+33-(LR(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(M=n,o)|0}else{p=LS(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(M=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=LM(g,d,-1,-1)|0;k=M;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;LN(e,k,j,a)|0;b=M;h=b>>31|((b|0)<0?-1:0)<<1;J=h&1;K=LN(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;L=M;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=L;u=K;t=b;s=J}}B=H;C=I;D=L;E=K;F=0;G=J}J=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(J|0)>>>31|(B|C)<<1|(C<<1|J>>>31)&0|F;o=(J<<1|0>>>31)&-2|G;return(M=n,o)|0}function L_(a){a=a|0;bx(a|0)}function L$(a){a=a|0;return a_(a|0)|0}function L0(a){a=a|0;return b6(a|0)|0}function L1(a){a=a|0;return bW(a|0)|0}function L2(a){a=a|0;return bZ(a|0)|0}function L3(a){a=a|0;return bY(a|0)|0}function L4(a){a=a|0;return bM(a|0)|0}function L5(a,b,c){a=a|0;b=b|0;c=c|0;return co(a|0,b|0,c|0)|0}function L6(a,b,c){a=a|0;b=b|0;c=c|0;return bb(a|0,b|0,c|0)|0}function L7(a,b){a=+a;b=+b;return+bf(+a,+b)}function L8(a,b){a=a|0;b=b|0;return cc(a|0,b|0)|0}function L9(a,b){a=a|0;b=b|0;return br(a|0,b|0)|0}function Ma(){return cr()|0}function Mb(){return cq()|0}function Mc(){return bw()|0}function Md(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return by(a|0,b|0,c|0,d|0)|0}function Me(a,b,c){a=a|0;b=b|0;c=c|0;bK(a|0,b|0,c|0)}function Mf(){a$()}function Mg(){be()}function Mh(){cn()}function Mi(){cj()}function Mj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return cx[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Mk(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;return cy[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)|0}function Ml(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cz[a&63](b|0,c|0,d|0,e|0,f|0)}function Mm(a,b){a=a|0;b=b|0;cA[a&1023](b|0)}function Mn(a,b,c){a=a|0;b=b|0;c=c|0;cB[a&1023](b|0,c|0)}function Mo(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return cC[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function Mp(a,b){a=a|0;b=b|0;return cD[a&511](b|0)|0}function Mq(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;cE[a&3](b|0,c|0,d|0,+e,+f,+g,+h,i|0)}function Mr(a,b,c,d,e,f,g,h){a=a|0;b=+b;c=+c;d=+d;e=+e;f=f|0;g=g|0;h=h|0;return cF[a&3](+b,+c,+d,+e,f|0,g|0,h|0)|0}function Ms(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;return cG[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)|0}function Mt(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;cH[a&3](b|0,+c,d|0)}function Mu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cI[a&127](b|0,c|0,d|0)|0}function Mv(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;cJ[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0)}function Mw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;cK[a&15](b|0,c|0,d|0,e|0,f|0,+g)}function Mx(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cL[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function My(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cM[a&127](b|0,c|0,d|0,e|0,f|0,g|0)}function Mz(a,b,c){a=a|0;b=+b;c=+c;return+cN[a&15](+b,+c)}function MA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return+cO[a&3](b|0,c|0,d|0)}function MB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;cP[a&3](b|0,c|0,d|0,+e,f|0)}function MC(a,b,c){a=a|0;b=b|0;c=+c;return cQ[a&3](b|0,+c)|0}function MD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;cR[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function ME(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;cS[a&7](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function MF(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;cT[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function MG(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;cU[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function MH(a,b,c){a=a|0;b=b|0;c=c|0;return cV[a&1023](b|0,c|0)|0}function MI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return+cW[a&7](b|0,c|0,d|0)}function MJ(a,b,c){a=a|0;b=b|0;c=c|0;return+cX[a&3](b|0,c|0)}function MK(a){a=a|0;return cY[a&15]()|0}function ML(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cZ[a&31](b|0,c|0,d|0,e|0,f|0)|0}function MM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c_[a&511](b|0,c|0,d|0)}function MN(a){a=a|0;c$[a&15]()}function MO(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return c0[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function MP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return c1[a&63](b|0,c|0,d|0,e|0)|0}function MQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;c2[a&63](b|0,c|0,d|0,e|0)}function MR(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aj(0);return 0}function MS(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;aj(1);return 0}function MT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aj(2)}function MU(a){a=a|0;aj(3)}function MV(a,b){a=a|0;b=b|0;aj(4)}function MW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aj(5);return 0}function MX(a){a=a|0;aj(6);return 0}function MY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;aj(7)}function MZ(a,b,c,d,e,f,g){a=+a;b=+b;c=+c;d=+d;e=e|0;f=f|0;g=g|0;aj(8);return 0}function M_(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aj(9);return 0}function M$(a,b,c){a=a|0;b=+b;c=c|0;aj(10)}function M0(a,b,c){a=a|0;b=b|0;c=c|0;aj(11);return 0}function M1(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;aj(12)}function M2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aj(13)}function M3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aj(14)}function M4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aj(15)}function M5(a,b){a=+a;b=+b;aj(16);return 0.0}function M6(a,b,c){a=a|0;b=b|0;c=c|0;aj(17);return 0.0}function M7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;aj(18)}function M8(a,b){a=a|0;b=+b;aj(19);return 0}function M9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aj(20)}function Na(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;aj(21)}function Nb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aj(22)}function Nc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aj(23)}function Nd(a,b){a=a|0;b=b|0;aj(24);return 0}function Ne(a,b,c){a=a|0;b=b|0;c=c|0;aj(25);return 0.0}function Nf(a,b){a=a|0;b=b|0;aj(26);return 0.0}function Ng(){aj(27);return 0}function Nh(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aj(28);return 0}function Ni(a,b,c){a=a|0;b=b|0;c=c|0;aj(29)}function Nj(){aj(30)}function Nk(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aj(31);return 0}function Nl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aj(32);return 0}function Nm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aj(33)}
// EMSCRIPTEN_END_FUNCS
var cx=[MR,MR,Ga,MR,FN,MR,MR,MR];var cy=[MS,MS,qm,MS];var cz=[MT,MT,t0,MT,ou,MT,Lk,MT,k0,MT,lk,MT,uH,MT,yl,MT,t1,MT,x$,MT,fb,MT,Lj,MT,oK,MT,g1,MT,lu,MT,Ea,MT,Li,MT,wY,MT,iL,MT,lF,MT,vE,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT,MT];var cA=[MU,MU,IO,MU,e0,MU,qj,MU,FF,MU,DO,MU,DB,MU,JJ,MU,lc,MU,xp,MU,FA,MU,hm,MU,kY,MU,GC,MU,nk,MU,kP,MU,I4,MU,GQ,MU,HV,MU,te,MU,xI,MU,fy,MU,lw,MU,K4,MU,J5,MU,Ik,MU,nS,MU,DT,MU,FG,MU,oV,MU,J4,MU,iq,MU,wQ,MU,GB,MU,mM,MU,xh,MU,g4,MU,Hs,MU,oH,MU,w6,MU,kq,MU,KJ,MU,KK,MU,D5,MU,EP,MU,nT,MU,AQ,MU,kE,MU,wn,MU,K1,MU,m9,MU,Df,MU,Fq,MU,Bw,MU,eg,MU,wG,MU,Iq,MU,es,MU,IE,MU,Dv,MU,hl,MU,k2,MU,xq,MU,oa,MU,d6,MU,nv,MU,x3,MU,nK,MU,Fb,MU,Fi,MU,xR,MU,G2,MU,K7,MU,oU,MU,Jk,MU,g3,MU,IU,MU,he,MU,DW,MU,ga,MU,Fw,MU,ll,MU,eh,MU,wx,MU,E2,MU,iW,MU,iz,MU,AP,MU,e$,MU,La,MU,gP,MU,E5,MU,Fu,MU,kZ,MU,J8,MU,ID,MU,Fa,MU,DO,MU,J6,MU,yy,MU,wP,MU,fN,MU,HW,MU,Hf,MU,HK,MU,EA,MU,oI,MU,K8,MU,eE,MU,Jt,MU,p9,MU,Fv,MU,If,MU,kr,MU,ov,MU,IX,MU,nJ,MU,nA,MU,K0,MU,Ht,MU,D6,MU,kB,MU,Fz,MU,As,MU,er,MU,wH,MU,Ip,MU,sj,MU,Fg,MU,D3,MU,gb,MU,E0,MU,lm,MU,p6,MU,wy,MU,gg,MU,Ex,MU,Ff,MU,I_,MU,iA,MU,xH,MU,H5,MU,yn,MU,KI,MU,xy,MU,gF,MU,Dg,MU,n2,MU,K3,MU,Iy,MU,Eb,MU,DS,MU,w7,MU,DV,MU,AC,MU,F7,MU,fM,MU,wo,MU,Jj,MU,gi,MU,Hg,MU,Fo,MU,xQ,MU,IK,MU,mg,MU,ow,MU,nz,MU,eQ,MU,I6,MU,iV,MU,K6,MU,Fy,MU,Dn,MU,Hv,MU,p7,MU,hj,MU,dY,MU,yc,MU,iN,MU,Fh,MU,Ly,MU,id,MU,rq,MU,j1,MU,wd,MU,p8,MU,f_,MU,H4,MU,yx,MU,yH,MU,ok,MU,K5,MU,eD,MU,dP,MU,nj,MU,Du,MU,p4,MU,I0,MU,Hz,MU,GP,MU,Ai,MU,xz,MU,FB,MU,Dh,MU,eG,MU,Ix,MU,Eo,MU,K1,MU,K9,MU,rp,MU,s9,MU,fn,MU,fA,MU,Fn,MU,IJ,MU,wZ,MU,IT,MU,DC,MU,mf,MU,ta,MU,EO,MU,Fe,MU,Bx,MU,IP,MU,Hw,MU,yo,MU,KN,MU,FK,MU,n1,MU,EB,MU,I5,MU,Do,MU,DN,MU,DT,MU,dZ,MU,kO,MU,Lz,MU,DO,MU,I3,MU,F8,MU,K$,MU,jx,MU,ol,MU,fx,MU,fB,MU,lv,MU,lI,MU,ke,MU,IY,MU,kC,MU,ob,MU,qa,MU,yI,MU,ip,MU,mN,MU,HA,MU,Lp,MU,HL,MU,xg,MU,gO,MU,KG,MU,eF,MU,lb,MU,JU,MU,E1,MU,Fx,MU,nU,MU,yd,MU,Fp,MU,g$,MU,w_,MU,E3,MU,j2,MU,we,MU,KM,MU,f$,MU,k1,MU,si,MU,Ii,MU,KL,MU,Fc,MU,eP,MU,JB,MU,J7,MU,FL,MU,ic,MU,d7,MU,nu,MU,lH,MU,dQ,MU,fz,MU,kF,MU,x4,MU,kf,MU,na,MU,p5,MU,L_,MU,fC,MU,D2,MU,G1,MU,fw,MU,J3,MU,Ig,MU,E9,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU,MU];var cB=[MV,MV,tc,MV,Kh,MV,m6,MV,gQ,MV,Di,MV,Az,MV,gu,MV,nL,MV,tm,MV,rW,MV,Dp,MV,ti,MV,gC,MV,rN,MV,eR,MV,o5,MV,sF,MV,s5,MV,kQ,MV,o2,MV,sg,MV,rt,MV,s6,MV,ox,MV,rr,MV,sX,MV,f0,MV,tC,MV,ei,MV,tG,MV,sb,MV,e_,MV,th,MV,o$,MV,H0,MV,wc,MV,rU,MV,yJ,MV,ry,MV,sS,MV,tk,MV,I$,MV,kg,MV,sB,MV,tY,MV,kD,MV,Dw,MV,DQ,MV,ph,MV,rx,MV,pZ,MV,dD,MV,AB,MV,kb,MV,r5,MV,pl,MV,H8,MV,to,MV,sy,MV,tS,MV,sK,MV,o6,MV,HR,MV,ye,MV,ro,MV,o9,MV,ks,MV,fO,MV,wz,MV,pp,MV,EC,MV,r2,MV,sI,MV,yz,MV,tE,MV,tl,MV,IS,MV,jZ,MV,w$,MV,px,MV,pt,MV,rF,MV,sa,MV,e8,MV,sA,MV,d8,MV,o4,MV,sR,MV,HE,MV,rY,MV,KH,MV,pa,MV,tX,MV,eB,MV,rJ,MV,tO,MV,d_,MV,wp,MV,Ez,MV,tr,MV,sJ,MV,rR,MV,pC,MV,H9,MV,nV,MV,fI,MV,ru,MV,o1,MV,k3,MV,ps,MV,pi,MV,pm,MV,tb,MV,rK,MV,pu,MV,w8,MV,fh,MV,om,MV,sp,MV,s2,MV,IV,MV,po,MV,Ke,MV,jw,MV,sm,MV,s_,MV,Es,MV,Kd,MV,f9,MV,rO,MV,rP,MV,IN,MV,gf,MV,EQ,MV,DD,MV,ib,MV,sW,MV,gd,MV,Bv,MV,HF,MV,p_,MV,e6,MV,ie,MV,tz,MV,sh,MV,sr,MV,gM,MV,Ib,MV,sQ,MV,r7,MV,tu,MV,tZ,MV,Ar,MV,nt,MV,r6,MV,xr,MV,rD,MV,pq,MV,tf,MV,AD,MV,sD,MV,s3,MV,fe,MV,jv,MV,Ao,MV,tq,MV,sv,MV,ir,MV,tg,MV,r$,MV,sT,MV,Kf,MV,HT,MV,hc,MV,tQ,MV,Ey,MV,tV,MV,ns,MV,sP,MV,oX,MV,Aj,MV,rz,MV,sc,MV,Ew,MV,pB,MV,HZ,MV,sC,MV,fq,MV,e7,MV,HJ,MV,e4,MV,sn,MV,pg,MV,pJ,MV,oJ,MV,pz,MV,so,MV,sH,MV,H$,MV,rv,MV,dE,MV,xi,MV,tP,MV,m5,MV,pe,MV,sL,MV,tj,MV,xA,MV,wI,MV,Ia,MV,ts,MV,sz,MV,tv,MV,oZ,MV,kX,MV,rZ,MV,o7,MV,H3,MV,nB,MV,nb,MV,sV,MV,dG,MV,et,MV,tI,MV,oF,MV,sw,MV,oY,MV,pk,MV,tt,MV,iB,MV,tW,MV,m1,MV,DR,MV,sZ,MV,x5,MV,rV,MV,sU,MV,e5,MV,HD,MV,tJ,MV,pK,MV,lx,MV,oL,MV,m3,MV,lJ,MV,sN,MV,td,MV,mO,MV,o_,MV,rL,MV,wb,MV,Kg,MV,sl,MV,ge,MV,Er,MV,sk,MV,tK,MV,tx,MV,HP,MV,fW,MV,sd,MV,sx,MV,HO,MV,eZ,MV,su,MV,gB,MV,H2,MV,s0,MV,tM,MV,sM,MV,tw,MV,m_,MV,gc,MV,wf,MV,lE,MV,Af,MV,go,MV,oQ,MV,r1,MV,g5,MV,o8,MV,tB,MV,lG,MV,la,MV,tH,MV,eH,MV,rA,MV,fv,MV,rT,MV,py,MV,mY,MV,oG,MV,se,MV,f7,MV,Eh,MV,H_,MV,ty,MV,pD,MV,kG,MV,rB,MV,pc,MV,ss,MV,HQ,MV,oT,MV,ln,MV,pb,MV,rG,MV,ld,MV,k_,MV,Eg,MV,DM,MV,pA,MV,kA,MV,oc,MV,r8,MV,s1,MV,st,MV,s$,MV,rw,MV,kn,MV,rH,MV,ny,MV,r0,MV,sq,MV,HU,MV,tA,MV,HG,MV,lR,MV,Id,MV,sE,MV,wR,MV,t_,MV,tL,MV,dR,MV,r4,MV,pf,MV,pd,MV,sG,MV,xJ,MV,tn,MV,yp,MV,kz,MV,Ay,MV,rE,MV,Ie,MV,j3,MV,rQ,MV,pj,MV,rm,MV,n3,MV,nl,MV,oP,MV,qb,MV,tR,MV,rM,MV,r9,MV,sO,MV,Ki,MV,tD,MV,r_,MV,sY,MV,tp,MV,tU,MV,xS,MV,tT,MV,rI,MV,E7,MV,tN,MV,HI,MV,e3,MV,oW,MV,nw,MV,rC,MV,rS,MV,o0,MV,s4,MV,oM,MV,pn,MV,rX,MV,eC,MV,o3,MV,tF,MV,pr,MV,io,MV,r3,MV,pw,MV,ju,MV,pV,MV,pv,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV,MV];var cC=[MW,MW,qy,MW,q6,MW,qz,MW,qu,MW,qJ,MW,rl,MW,re,MW,qR,MW,qI,MW,q$,MW,qp,MW,qN,MW,qT,MW,qD,MW,qW,MW,ra,MW,qK,MW,rh,MW,qt,MW,qU,MW,qE,MW,qn,MW,qG,MW,q3,MW,rf,MW,qv,MW,q5,MW,qO,MW,q2,MW,qB,MW,rb,MW,ri,MW,qY,MW,qP,MW,qF,MW,qA,MW,qC,MW,q8,MW,qS,MW,rk,MW,qH,MW,qL,MW,qX,MW,rj,MW,rd,MW,q4,MW,qZ,MW,q0,MW,qq,MW,rg,MW,q1,MW,q_,MW,qQ,MW,qV,MW,qr,MW,hn,MW,qo,MW,q7,MW,q9,MW,qM,MW,qs,MW,rc,MW,MW,MW];var cD=[MX,MX,Kw,MX,Kb,MX,Km,MX,u$,MX,Ku,MX,Dx,MX,L$,MX,HM,MX,u2,MX,G3,MX,DF,MX,dO,MX,d5,MX,EX,MX,lS,MX,Kc,MX,dA,MX,L0,MX,uK,MX,u4,MX,Ka,MX,u1,MX,C7,MX,dv,MX,uJ,MX,u0,MX,dz,MX,H6,MX,Kj,MX,LL,MX,E4,MX,Fs,MX,y$,MX,vi,MX,EU,MX,HS,MX,Kv,MX,gX,MX,u7,MX,EV,MX,ds,MX,Hh,MX,Ks,MX,Lv,MX,vf,MX,uC,MX,fX,MX,dy,MX,Ko,MX,K2,MX,DU,MX,Ic,MX,Kr,MX,HN,MX,JQ,MX,lQ,MX,fY,MX,L1,MX,dN,MX,KW,MX,uv,MX,HH,MX,Dr,MX,u3,MX,JP,MX,JG,MX,ka,MX,dt,MX,uu,MX,im,MX,gt,MX,HY,MX,H7,MX,J2,MX,vt,MX,zv,MX,EK,MX,J$,MX,eY,MX,vg,MX,dB,MX,uD,MX,Fd,MX,vd,MX,ux,MX,J9,MX,vj,MX,EG,MX,JA,MX,Jx,MX,fV,MX,zy,MX,ef,MX,Dq,MX,yR,MX,gs,MX,vZ,MX,kd,MX,vX,MX,EH,MX,vk,MX,qg,MX,ot,MX,ul,MX,DE,MX,y0,MX,HB,MX,Kl,MX,HC,MX,HX,MX,JI,MX,eO,MX,DP,MX,Kk,MX,Kt,MX,uE,MX,Da,MX,EJ,MX,Jy,MX,f8,MX,eA,MX,EY,MX,uw,MX,Lu,MX,iJ,MX,J_,MX,Kq,MX,Kp,MX,qf,MX,gY,MX,vJ,MX,Dj,MX,uM,MX,vw,MX,v$,MX,L2,MX,L3,MX,kc,MX,uz,MX,yS,MX,oE,MX,t2,MX,uA,MX,vY,MX,zw,MX,p3,MX,ep,MX,dC,MX,LA,MX,eq,MX,H1,MX,Kn,MX,JF,MX,vs,MX,fF,MX,L4,MX,yX,MX,JT,MX,oj,MX,yU,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX,MX];var cE=[MY,MY,g2,MY];var cF=[MZ,MZ,qx,MZ];var cG=[M_,M_,Is,M_,Ij,M_,M_,M_];var cH=[M$,M$,Ad,M$];var cI=[M0,M0,oN,M0,KO,M0,Lc,M0,I7,M0,Jr,M0,dF,M0,Dk,M0,D_,M0,IL,M0,oO,M0,FE,M0,C9,M0,i8,M0,Jh,M0,ER,M0,L5,M0,oR,M0,i9,M0,Jc,M0,dp,M0,dq,M0,An,M0,iX,M0,Je,M0,dn,M0,Jm,M0,dm,M0,KS,M0,FJ,M0,EM,M0,IQ,M0,Im,M0,Lg,M0,Jo,M0,dr,M0,L6,M0,Iu,M0,E6,M0,KT,M0,qc,M0,Ef,M0,DZ,M0,EI,M0,Ei,M0,Lb,M0,EW,M0,ED,M0,Dy,M0,E_,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0,M0];var cJ=[M1,M1,IB,M1,IH,M1,M1,M1];var cK=[M2,M2,GN,M2,GK,M2,G_,M2,GY,M2,M2,M2,M2,M2,M2,M2];var cL=[M3,M3,Hx,M3,ww,M3,Hu,M3,Ej,M3,It,M3,Ih,M3,Il,M3,gN,M3,Ir,M3,M3,M3,M3,M3,M3,M3,M3,M3,M3,M3,M3,M3];var cM=[M4,M4,k$,M4,Lm,M4,fL,M4,xZ,M4,n0,M4,ES,M4,vr,M4,Ln,M4,ym,M4,fa,M4,EE,M4,fj,M4,yw,M4,fD,M4,fK,M4,Ll,M4,qd,M4,fZ,M4,v8,M4,m7,M4,GW,M4,GD,M4,GI,M4,GE,M4,lU,M4,GS,M4,GR,M4,G$,M4,wm,M4,GO,M4,IM,M4,IR,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4];var cN=[M5,M5,L7,M5,iQ,M5,iS,M5,iR,M5,iT,M5,M5,M5,M5,M5];var cO=[M6,M6,Kz,M6];var cP=[M7,M7,lT,M7];var cQ=[M8,M8,Fl,M8];var cR=[M9,M9,G8,M9,nx,M9,Hl,M9,Gl,M9,Gd,M9,Gf,M9,Gj,M9,Gb,M9,F9,M9,Gr,M9,Gp,M9,Gn,M9,Hm,M9,FY,M9,FQ,M9,FS,M9,FW,M9,F2,M9,F0,M9,F_,M9,Hk,M9,II,M9,Ek,M9,GT,M9,G6,M9,GU,M9,FO,M9,ft,M9,hk,M9,FU,M9,Hi,M9,IC,M9,G4,M9,G7,M9,GZ,M9,Gt,M9,GJ,M9,GH,M9,F4,M9,GG,M9,GX,M9,GV,M9,GM,M9,kN,M9,Gh,M9,Hj,M9,FM,M9,G5,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9,M9];var cS=[Na,Na,Iz,Na,IF,Na,Na,Na];var cT=[Nb,Nb,G9,Nb,Hn,Nb,Nb,Nb];var cU=[Nc,Nc,IG,Nc,In,Nc,rn,Nc,Iv,Nc,IA,Nc,Nc,Nc,Nc,Nc];var cV=[Nd,Nd,yt,Nd,xl,Nd,kJ,Nd,ew,Nd,dI,Nd,xV,Nd,l5,Nd,lX,Nd,d2,Nd,i5,Nd,wg,Nd,jQ,Nd,mK,Nd,hQ,Nd,hy,Nd,fQ,Nd,lr,Nd,nZ,Nd,yA,Nd,oo,Nd,iv,Nd,eu,Nd,lp,Nd,wK,Nd,f1,Nd,du,Nd,hD,Nd,lz,Nd,gT,Nd,jF,Nd,on,Nd,yL,Nd,mF,Nd,L8,Nd,oq,Nd,h5,Nd,kh,Nd,is,Nd,ht,Nd,dk,Nd,hX,Nd,jn,Nd,i4,Nd,mx,Nd,gw,Nd,jT,Nd,lY,Nd,jm,Nd,mS,Nd,jp,Nd,wV,Nd,hv,Nd,ko,Nd,lB,Nd,hV,Nd,hU,Nd,fl,Nd,mq,Nd,mv,Nd,mz,Nd,g6,Nd,k5,Nd,iY,Nd,wi,Nd,n5,Nd,mJ,Nd,mn,Nd,gS,Nd,yD,Nd,h9,Nd,yh,Nd,fk,Nd,ki,Nd,wJ,Nd,hJ,Nd,d0,Nd,mk,Nd,l9,Nd,yi,Nd,hz,Nd,yq,Nd,L9,Nd,xj,Nd,wD,Nd,dJ,Nd,I1,Nd,lV,Nd,md,Nd,fo,Nd,hI,Nd,hW,Nd,xU,Nd,dK,Nd,n4,Nd,lo,Nd,l2,Nd,xN,Nd,iZ,Nd,I2,Nd,nC,Nd,hs,Nd,mH,Nd,hp,Nd,og,Nd,jO,Nd,jK,Nd,h0,Nd,me,Nd,mh,Nd,xt,Nd,Ep,Nd,mI,Nd,nO,Nd,eS,Nd,wS,Nd,x9,Nd,mi,Nd,wC,Nd,xD,Nd,xu,Nd,Fm,Nd,ex,Nd,Jp,Nd,jo,Nd,EZ,Nd,xb,Nd,x8,Nd,ws,Nd,nF,Nd,jf,Nd,gj,Nd,h7,Nd,Dz,Nd,mr,Nd,mA,Nd,np,Nd,hR,Nd,mP,Nd,jI,Nd,hP,Nd,ev,Nd,hw,Nd,eV,Nd,fH,Nd,yf,Nd,hA,Nd,eU,Nd,mu,Nd,j5,Nd,jV,Nd,mB,Nd,ms,Nd,xs,Nd,n7,Nd,Fk,Nd,Fj,Nd,d9,Nd,h6,Nd,jg,Nd,mE,Nd,of,Nd,oz,Nd,jN,Nd,p2,Nd,dU,Nd,h_,Nd,od,Nd,hC,Nd,w3,Nd,jr,Nd,yg,Nd,Ec,Nd,wt,Nd,d1,Nd,x7,Nd,oA,Nd,nN,Nd,xK,Nd,i3,Nd,mp,Nd,l6,Nd,hq,Nd,jW,Nd,g8,Nd,Dd,Nd,em,Nd,xW,Nd,i0,Nd,xM,Nd,l8,Nd,wT,Nd,Dc,Nd,wB,Nd,ia,Nd,k7,Nd,l$,Nd,fG,Nd,xv,Nd,iC,Nd,t6,Nd,nc,Nd,ys,Nd,wh,Nd,h3,Nd,wM,Nd,nP,Nd,l7,Nd,dV,Nd,f3,Nd,ku,Nd,jE,Nd,jH,Nd,el,Nd,mQ,Nd,lh,Nd,hu,Nd,pY,Nd,hT,Nd,i$,Nd,mG,Nd,ne,Nd,nY,Nd,ji,Nd,hG,Nd,DG,Nd,eJ,Nd,jk,Nd,jz,Nd,h1,Nd,g7,Nd,it,Nd,wA,Nd,lK,Nd,xE,Nd,xa,Nd,hN,Nd,lf,Nd,hY,Nd,jt,Nd,k4,Nd,mC,Nd,jB,Nd,i2,Nd,ii,Nd,h4,Nd,gU,Nd,jC,Nd,mo,Nd,h$,Nd,vu,Nd,yN,Nd,Jb,Nd,w1,Nd,lW,Nd,gl,Nd,kU,Nd,jS,Nd,hE,Nd,nM,Nd,xC,Nd,no,Nd,lq,Nd,d$,Nd,jD,Nd,xL,Nd,jG,Nd,dH,Nd,hO,Nd,iu,Nd,nW,Nd,Ed,Nd,oe,Nd,mb,Nd,w9,Nd,nf,Nd,xc,Nd,ec,Nd,l3,Nd,kv,Nd,i_,Nd,jX,Nd,my,Nd,nn,Nd,nX,Nd,kt,Nd,wj,Nd,jy,Nd,hM,Nd,yC,Nd,E$,Nd,f2,Nd,j7,Nd,uI,Nd,Db,Nd,dS,Nd,ek,Nd,eK,Nd,n6,Nd,kI,Nd,yB,Nd,ml,Nd,mj,Nd,dT,Nd,mR,Nd,w0,Nd,x6,Nd,hF,Nd,op,Nd,kT,Nd,eb,Nd,hL,Nd,kj,Nd,mt,Nd,oy,Nd,lA,Nd,g9,Nd,xm,Nd,l0,Nd,jR,Nd,EL,Nd,dx,Nd,Dl,Nd,wq,Nd,f4,Nd,hr,Nd,j6,Nd,i6,Nd,mm,Nd,yr,Nd,l4,Nd,nm,Nd,hS,Nd,kR,Nd,jY,Nd,mw,Nd,kS,Nd,iF,Nd,iE,Nd,Jl,Nd,Am,Nd,xT,Nd,jj,Nd,kH,Nd,fR,Nd,mD,Nd,lN,Nd,yK,Nd,ea,Nd,gR,Nd,wr,Nd,mc,Nd,Jf,Nd,eT,Nd,jl,Nd,w2,Nd,xk,Nd,ho,Nd,fS,Nd,i1,Nd,Ds,Nd,gk,Nd,yM,Nd,ej,Nd,eL,Nd,nE,Nd,lL,Nd,hH,Nd,h8,Nd,iD,Nd,nd,Nd,lg,Nd,jJ,Nd,oB,Nd,ij,Nd,jP,Nd,jU,Nd,wU,Nd,hZ,Nd,lM,Nd,qh,Nd,hB,Nd,kK,Nd,jL,Nd,Jn,Nd,hK,Nd,lZ,Nd,ih,Nd,ig,Nd,hx,Nd,ly,Nd,le,Nd,jM,Nd,fP,Nd,js,Nd,Jd,Nd,j4,Nd,kw,Nd,jA,Nd,xB,Nd,kk,Nd,l1,Nd,k6,Nd,l_,Nd,EN,Nd,qi,Nd,wL,Nd,fm,Nd,jq,Nd,nD,Nd,eI,Nd,h2,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd,Nd];var cW=[Ne,Ne,Kx,Ne,Ky,Ne,Ne,Ne];var cX=[Nf,Nf,C8,Nf];var cY=[Ng,Ng,Ma,Ng,IZ,Ng,Mb,Ng,Mc,Ng,Ng,Ng,Ng,Ng,Ng,Ng];var cZ=[Nh,Nh,Ji,Nh,FC,Nh,KQ,Nh,Jz,Nh,JH,Nh,J0,Nh,JR,Nh,KU,Nh,JO,Nh,jh,Nh,JZ,Nh,FH,Nh,Js,Nh,Jw,Nh,JE,Nh];var c_=[Ni,Ni,D4,Ni,li,Ni,eN,Ni,ey,Ni,BS,Ni,B8,Ni,s8,Ni,n$,Ni,gW,Ni,xo,Ni,pE,Ni,p$,Ni,Ev,Ni,BC,Ni,lD,Ni,gq,Ni,AT,Ni,Ci,Ni,lC,Ni,wN,Ni,kW,Ni,fi,Ni,yj,Ni,B0,Ni,kp,Ni,km,Ni,nr,Ni,BA,Ni,xw,Ni,iP,Ni,Bj,Ni,BH,Ni,lt,Ni,Bk,Ni,AW,Ni,Em,Ni,yF,Ni,Ba,Ni,Al,Ni,wk,Ni,BF,Ni,wF,Ni,xF,Ni,Ee,Ni,A7,Ni,dM,Ni,BE,Ni,D8,Ni,Iw,Ni,Ak,Ni,A0,Ni,Bl,Ni,Bf,Ni,BG,Ni,ik,Ni,dW,Ni,gp,Ni,xG,Ni,yk,Ni,iH,Ni,AS,Ni,oi,Ni,BP,Ni,yP,Ni,k8,Ni,Cb,Ni,AJ,Ni,xP,Ni,BZ,Ni,By,Ni,B$,Ni,wE,Ni,BL,Ni,BQ,Ni,hb,Ni,j0,Ni,Bc,Ni,Me,Ni,Bn,Ni,B1,Ni,Bg,Ni,A5,Ni,lj,Ni,AM,Ni,A3,Ni,lP,Ni,oS,Ni,BO,Ni,AN,Ni,BN,Ni,nH,Ni,fg,Ni,nG,Ni,BD,Ni,AX,Ni,Bq,Ni,xn,Ni,ls,Ni,wW,Ni,or,Ni,lO,Ni,xd,Ni,Cd,Ni,ky,Ni,g0,Ni,BU,Ni,nI,Ni,A8,Ni,BY,Ni,xY,Ni,kM,Ni,kL,Ni,ma,Ni,AO,Ni,Br,Ni,xO,Ni,BB,Ni,A9,Ni,AI,Ni,BW,Ni,oC,Ni,ix,Ni,AZ,Ni,mX,Ni,nR,Ni,n8,Ni,B4,Ni,B2,Ni,A6,Ni,j8,Ni,D0,Ni,kV,Ni,iw,Ni,kx,Ni,IW,Ni,nh,Ni,BI,Ni,k9,Ni,il,Ni,oh,Ni,w5,Ni,Bo,Ni,sf,Ni,j9,Ni,Ce,Ni,xX,Ni,Be,Ni,Ck,Ni,xe,Ni,yu,Ni,x_,Ni,B_,Ni,nQ,Ni,mU,Ni,wX,Ni,BT,Ni,Cc,Ni,B3,Ni,wl,Ni,yO,Ni,iG,Ni,Bp,Ni,eX,Ni,fU,Ni,oD,Ni,Bs,Ni,AL,Ni,d4,Ni,BR,Ni,BV,Ni,f6,Ni,p0,Ni,Cf,Ni,BJ,Ni,A2,Ni,Bt,Ni,en,Ni,ng,Ni,DY,Ni,ez,Ni,A1,Ni,A_,Ni,B5,Ni,AR,Ni,wO,Ni,AH,Ni,ee,Ni,xx,Ni,eM,Ni,AU,Ni,iM,Ni,gh,Ni,Bz,Ni,yv,Ni,Cj,Ni,BK,Ni,B7,Ni,dX,Ni,m0,Ni,gy,Ni,ha,Ni,w4,Ni,eo,Ni,dL,Ni,gr,Ni,AK,Ni,Bi,Ni,gG,Ni,ed,Ni,Bu,Ni,m2,Ni,gZ,Ni,gV,Ni,AY,Ni,eW,Ni,mT,Ni,vb,Ni,Bm,Ni,B6,Ni,D1,Ni,Ca,Ni,AV,Ni,Cg,Ni,B9,Ni,Bb,Ni,A4,Ni,yE,Ni,Bd,Ni,BX,Ni,AG,Ni,A$,Ni,n9,Ni,yb,Ni,pN,Ni,Ch,Ni,BM,Ni,fT,Ni,ni,Ni,os,Ni,f5,Ni,dw,Ni,Ft,Ni,kl,Ni,wv,Ni,wu,Ni,t9,Ni,nq,Ni,Bh,Ni,ya,Ni,d3,Ni,n_,Ni,Ni,Ni,Ni,Ni,Ni,Ni,Ni,Ni];var c$=[Nj,Nj,Mf,Nj,LB,Nj,Mg,Nj,Mh,Nj,Mi,Nj,Nj,Nj,Nj,Nj];var c0=[Nk,Nk,JV,Nk,Jv,Nk,JX,Nk,Ju,Nk,JK,Nk,JC,Nk,JM,Nk,JD,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk,Nk];var c1=[Nl,Nl,El,Nl,KC,Nl,KE,Nl,KD,Nl,I9,Nl,jb,Nl,Ja,Nl,I8,Nl,KR,Nl,KA,Nl,F6,Nl,jc,Nl,E8,Nl,GL,Nl,KB,Nl,vh,Nl,Md,Nl,ff,Nl,Jg,Nl,KP,Nl,KF,Nl,Jq,Nl,jd,Nl,vv,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl,Nl];var c2=[Nm,Nm,xf,Nm,i7,Nm,m8,Nm,gm,Nm,x2,Nm,FI,Nm,ET,Nm,mV,Nm,FD,Nm,fE,Nm,Le,Nm,Lf,Nm,EF,Nm,yG,Nm,x1,Nm,t7,Nm,qe,Nm,pM,Nm,yQ,Nm,pG,Nm,fd,Nm,p1,Nm,iO,Nm,Ld,Nm,x0,Nm,iU,Nm,uL,Nm,iy,Nm,iI,Nm,Nm,Nm,Nm,Nm];return{_memcmp:LH,_strlen:LJ,__GLOBAL__I_a:DI,_free:Lp,_realloc:Lr,_sass_compile_emscripten:iK,_memmove:LG,_tolower:LL,_memset:LI,_malloc:Lo,_memcpy:LF,_strcpy:LK,_calloc:Lq,runPostSets:dj,stackAlloc:c3,stackSave:c4,stackRestore:c5,setThrew:c6,setTempRet0:c9,setTempRet1:da,setTempRet2:db,setTempRet3:dc,setTempRet4:dd,setTempRet5:de,setTempRet6:df,setTempRet7:dg,setTempRet8:dh,setTempRet9:di,dynCall_iiiiiiii:Mj,dynCall_iiiiiiddi:Mk,dynCall_viiiii:Ml,dynCall_vi:Mm,dynCall_vii:Mn,dynCall_iiiiiii:Mo,dynCall_ii:Mp,dynCall_viiiddddi:Mq,dynCall_iddddiii:Mr,dynCall_iiiiiiiiiiii:Ms,dynCall_vidi:Mt,dynCall_iiii:Mu,dynCall_viiiiiiiiiiiiiii:Mv,dynCall_viiiiid:Mw,dynCall_viiiiiiii:Mx,dynCall_viiiiii:My,dynCall_ddd:Mz,dynCall_fiii:MA,dynCall_viiidi:MB,dynCall_iid:MC,dynCall_viiiiiii:MD,dynCall_viiiiiid:ME,dynCall_viiiiiiiii:MF,dynCall_viiiiiiiiii:MG,dynCall_iii:MH,dynCall_diii:MI,dynCall_dii:MJ,dynCall_i:MK,dynCall_iiiiii:ML,dynCall_viii:MM,dynCall_v:MN,dynCall_iiiiiiiii:MO,dynCall_iiiii:MP,dynCall_viiii:MQ}})
// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_iiiiiiddi": invoke_iiiiiiddi, "invoke_viiiii": invoke_viiiii, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiii": invoke_iiiiiii, "invoke_ii": invoke_ii, "invoke_viiiddddi": invoke_viiiddddi, "invoke_iddddiii": invoke_iddddiii, "invoke_iiiiiiiiiiii": invoke_iiiiiiiiiiii, "invoke_vidi": invoke_vidi, "invoke_iiii": invoke_iiii, "invoke_viiiiiiiiiiiiiii": invoke_viiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_ddd": invoke_ddd, "invoke_fiii": invoke_fiii, "invoke_viiidi": invoke_viiidi, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_viiiiiiiiii": invoke_viiiiiiiiii, "invoke_iii": invoke_iii, "invoke_diii": invoke_diii, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiii": invoke_iiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_llvm_lifetime_end": _llvm_lifetime_end, "_lseek": _lseek, "__scanString": __scanString, "_fclose": _fclose, "_pthread_mutex_lock": _pthread_mutex_lock, "___cxa_end_catch": ___cxa_end_catch, "_strtoull": _strtoull, "_fflush": _fflush, "_strtol": _strtol, "__isLeapYear": __isLeapYear, "_fwrite": _fwrite, "_send": _send, "_isspace": _isspace, "_read": _read, "_ceil": _ceil, "_fsync": _fsync, "___cxa_guard_abort": ___cxa_guard_abort, "_newlocale": _newlocale, "___gxx_personality_v0": ___gxx_personality_v0, "_pthread_cond_wait": _pthread_cond_wait, "___cxa_rethrow": ___cxa_rethrow, "_fmod": _fmod, "___resumeException": ___resumeException, "_memchr": _memchr, "_llvm_va_end": _llvm_va_end, "_vsscanf": _vsscanf, "_snprintf": _snprintf, "_fgetc": _fgetc, "__getFloat": __getFloat, "_atexit": _atexit, "___cxa_free_exception": ___cxa_free_exception, "_close": _close, "___setErrNo": ___setErrNo, "_isxdigit": _isxdigit, "_ftell": _ftell, "_exit": _exit, "_sprintf": _sprintf, "_asprintf": _asprintf, "___ctype_b_loc": ___ctype_b_loc, "_freelocale": _freelocale, "_catgets": _catgets, "___cxa_is_number_type": ___cxa_is_number_type, "_getcwd": _getcwd, "___cxa_does_inherit": ___cxa_does_inherit, "___cxa_guard_acquire": ___cxa_guard_acquire, "___cxa_begin_catch": ___cxa_begin_catch, "_recv": _recv, "__parseInt64": __parseInt64, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "___cxa_call_unexpected": ___cxa_call_unexpected, "__exit": __exit, "_strftime": _strftime, "___cxa_throw": ___cxa_throw, "_llvm_eh_exception": _llvm_eh_exception, "_toupper": _toupper, "_pread": _pread, "_fopen": _fopen, "_open": _open, "__arraySum": __arraySum, "_isalnum": _isalnum, "_isalpha": _isalpha, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_strdup": _strdup, "__formatString": __formatString, "_pthread_cond_broadcast": _pthread_cond_broadcast, "__ZSt9terminatev": __ZSt9terminatev, "_isascii": _isascii, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_sbrk": _sbrk, "___errno_location": ___errno_location, "_strerror": _strerror, "_catclose": _catclose, "_llvm_lifetime_start": _llvm_lifetime_start, "__parseInt": __parseInt, "___cxa_guard_release": ___cxa_guard_release, "_ungetc": _ungetc, "_uselocale": _uselocale, "_vsnprintf": _vsnprintf, "_sscanf": _sscanf, "_sysconf": _sysconf, "_fread": _fread, "_abort": _abort, "_isdigit": _isdigit, "_strtoll": _strtoll, "__addDays": __addDays, "_fabs": _fabs, "_floor": _floor, "__reallyNegative": __reallyNegative, "_fseek": _fseek, "___cxa_bad_typeid": ___cxa_bad_typeid, "_write": _write, "___cxa_allocate_exception": ___cxa_allocate_exception, "_stat": _stat, "___cxa_pure_virtual": ___cxa_pure_virtual, "_vasprintf": _vasprintf, "_catopen": _catopen, "___ctype_toupper_loc": ___ctype_toupper_loc, "___ctype_tolower_loc": ___ctype_tolower_loc, "_llvm_eh_typeid_for": _llvm_eh_typeid_for, "_pwrite": _pwrite, "_strerror_r": _strerror_r, "_time": _time, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "NaN": NaN, "Infinity": Infinity, "__ZTVN10__cxxabiv117__class_type_infoE": __ZTVN10__cxxabiv117__class_type_infoE, "___fsmu8": ___fsmu8, "__ZTIc": __ZTIc, "_stdout": _stdout, "__ZTVN10__cxxabiv119__pointer_type_infoE": __ZTVN10__cxxabiv119__pointer_type_infoE, "___dso_handle": ___dso_handle, "_stdin": _stdin, "__ZTVN10__cxxabiv120__si_class_type_infoE": __ZTVN10__cxxabiv120__si_class_type_infoE, "_stderr": _stderr }, buffer);
var _memcmp = Module["_memcmp"] = asm["_memcmp"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var _free = Module["_free"] = asm["_free"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _sass_compile_emscripten = Module["_sass_compile_emscripten"] = asm["_sass_compile_emscripten"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _tolower = Module["_tolower"] = asm["_tolower"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_iiiiiiddi = Module["dynCall_iiiiiiddi"] = asm["dynCall_iiiiiiddi"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viiiddddi = Module["dynCall_viiiddddi"] = asm["dynCall_viiiddddi"];
var dynCall_iddddiii = Module["dynCall_iddddiii"] = asm["dynCall_iddddiii"];
var dynCall_iiiiiiiiiiii = Module["dynCall_iiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiii"];
var dynCall_vidi = Module["dynCall_vidi"] = asm["dynCall_vidi"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiiiiiiiiiiii = Module["dynCall_viiiiiiiiiiiiiii"] = asm["dynCall_viiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_ddd = Module["dynCall_ddd"] = asm["dynCall_ddd"];
var dynCall_fiii = Module["dynCall_fiii"] = asm["dynCall_fiii"];
var dynCall_viiidi = Module["dynCall_viiidi"] = asm["dynCall_viiidi"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_viiiiiiiiii = Module["dynCall_viiiiiiiiii"] = asm["dynCall_viiiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_diii = Module["dynCall_diii"] = asm["dynCall_diii"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };
// TODO: strip out parts of this we do not need
//======= begin closure i64 code =======
// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */
var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };
  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.
    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };
  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.
  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};
  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }
    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };
  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };
  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };
  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }
    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }
    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));
    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };
  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.
  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;
  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);
  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);
  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);
  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);
  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);
  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);
  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };
  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };
  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }
    if (this.isZero()) {
      return '0';
    }
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }
    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));
    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);
      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };
  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };
  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };
  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };
  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };
  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };
  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };
  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };
  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }
    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }
    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };
  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };
  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.
    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;
    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;
    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };
  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };
  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }
    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }
    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }
    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.
    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;
    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;
    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };
  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }
    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }
    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));
      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);
      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }
      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }
      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };
  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };
  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };
  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };
  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };
  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };
  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };
  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };
  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };
  //======= begin jsbn =======
  var navigator = { appName: 'Modern Browser' }; // polyfill a little
  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/
  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */
  // Basic JavaScript BN library - subset useful for RSA encryption.
  // Bits per digit
  var dbits;
  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);
  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }
  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }
  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.
  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }
  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);
  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;
  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }
  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }
  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }
  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }
  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }
  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }
  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }
  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }
  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }
  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }
  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }
  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }
  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }
  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }
  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }
  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }
  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }
  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }
  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }
  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }
  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }
  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }
  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;
  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }
  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }
  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }
  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }
  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }
  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }
  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;
  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }
  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }
  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }
  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;
  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;
  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);
  // jsbn2 stuff
  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }
  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }
  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }
  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }
  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }
  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }
  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }
  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }
  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;
  //======= end jsbn =======
  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();
//======= end closure i64 code =======
// === Auto-generated postamble setup entry stuff ===
if (memoryInitializer) {
  function applyData(data) {
    HEAPU8.set(data, STATIC_BASE);
  }
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    applyData(Module['readBinary'](memoryInitializer));
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      applyData(data);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}
function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;
var initialStackTop;
var preloadStartTime = null;
var calledMain = false;
dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}
Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');
  args = args || [];
  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }
  ensureInitRuntime();
  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);
  initialStackTop = STACKTOP;
  try {
    var ret = Module['_main'](argc, argv, 0);
    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}
function run(args) {
  args = args || Module['arguments'];
  if (preloadStartTime === null) preloadStartTime = Date.now();
  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }
  preRun();
  if (runDependencies > 0) {
    // a preRun added a dependency, run will be called later
    return;
  }
  function doRun() {
    ensureInitRuntime();
    preMain();
    Module['calledRun'] = true;
    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }
    postRun();
  }
  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;
function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;
  // exit the runtime
  exitRuntime();
  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371
  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;
function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }
  ABORT = true;
  EXITSTATUS = 1;
  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;
// {{PRE_RUN_ADDITIONS}}
if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}
// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}
run();
// {{POST_RUN_ADDITIONS}}
// {{MODULE_ADDITIONS}}

/*global Module, FS, ALLOC_STACK*/
/*jshint strict:false*/
var Sass = {
  style: {
    nested: 0,
    expanded: 1,
    compact: 2,
    compressed: 3
  },
  comments: {
    'none': 0,
    'default': 1
  },
  _options: {
    style: 0,
    comments: 0
  },
  _files: {},
  _path: '/sass/',

  options: function(options) {
    if (typeof options !== 'object') {
      return;
    }

    Object.keys(options).forEach(function(key) {
      switch (key) {
        case 'style':
          Sass._options[key] = Number(options[key]);
          break;
        case 'comments':
          Sass._options[key] = Number(!!options[key]);
          break;
      }
    });
  },

  _absolutePath: function(filename) {
    return Sass._path + (filename.slice(0, 1) === '/' ? filename.slice(1) : filename);
  },

  _createPath: function(parts) {
    var base = [];

    while (parts.length) {
      var directory = parts.shift();
      try {
        FS.createFolder(base.join('/'), directory, true, true);
      } catch(e) {
        // IGNORE file exists errors
      }

      base.push(directory);
    }
  },

  _ensurePath: function(filename) {
    var parts = filename.split('/');
    parts.pop();
    if (!parts.length) {
      return;
    }

    try {
      FS.stat(parts.join('/'));
      return;
    } catch(e) {
      Sass._createPath(parts);
    }
  },

  writeFile: function(filename, text) {
    var path = Sass._absolutePath(filename);
    try {
      Sass._ensurePath(path);
      FS.writeFile(path, text);
      Sass._files[path] = filename;
      return true;
    } catch(e) {
      return false;
    }
  },

  readFile: function(filename) {
    var path = Sass._absolutePath(filename);
    try {
      return FS.readFile(path, {encoding: 'utf8'});
    } catch(e) {
      return undefined;
    }
  },

  listFiles: function() {
    return Object.keys(Sass._files).map(function(path) {
      return Sass._files[path];
    });
  },

  removeFile: function(filename) {
    var path = Sass._absolutePath(filename);
    try {
      FS.unlink(path);
      delete Sass._files[path];
      return true;
    } catch(e) {
      return false;
    }
  },

  compile: function(text) {
    try {
      // in C we would use char *ptr; foo(&ptr) - in EMScripten this is not possible,
      // so we allocate a pointer to a pointer on the stack by hand
      var errorPointerPointer = Module.allocate([0], 'i8', ALLOC_STACK);
      var result = Module.ccall(
        // C/++ function to call
        'sass_compile_emscripten',
        // return type
        'string',
        // parameter types
        ['string', 'number', 'number', 'string', 'i8'],
        // arguments for invocation
        [text, Sass._options.style, Sass._options.comments, Sass._path, errorPointerPointer]
      );
      // this is equivalent to *ptr
      var errorPointer = Module.getValue(errorPointerPointer, '*');
      // error string set? if not, it would be NULL and therefore 0
      if (errorPointer) {
        // pull string from pointer

        /*jshint camelcase:false*/
        errorPointer = Module.Pointer_stringify(errorPointer);
        /*jshint camelcase:true*/

        var error = errorPointer.match(/^source string:(\d+):/);
        var message = errorPointer.slice(error[0].length).replace(/(^\s+)|(\s+$)/g, '');
        // throw new Error(message, 'string', error[1]);
        return {
          line: Number(error[1]),
          message: message
        };
      }

      return result;
    } catch(e) {
      // in case libsass.js was compiled without exception support
      return {
        line: null,
        message: 'Unknown Error: you need to compile libsass.js with exceptions to get proper error messages'
      };
    }
  }
};
return Sass;
}));